/*******************************************************************************

    uBlock Origin Lite - a comprehensive, MV3-compliant content blocker
    Copyright (C) 2014-present Raymond Hill

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see {http://www.gnu.org/licenses/}.

    Home: https://github.com/gorhill/uBlock
*/

/* jshint esversion:11 */

'use strict';

// ruleset: nor-0

/******************************************************************************/

// Important!
// Isolate from global scope
(function uBOL_cssDeclarativeImport() {

/******************************************************************************/

const argsList = [["{\"selector\":\"#whitetop\",\"action\":[\"style\",\"margin-top: 0px !important\"]}","{\"selector\":\".n_ListHeader\",\"action\":[\"style\",\"margin-top: 5px !important\"]}"],["{\"selector\":\"#ad-top-banner-placeholder\",\"action\":[\"style\",\"min-height: 0px !important\"]}"],["{\"selector\":\".modal-container.open\",\"action\":[\"style\",\"padding-top: unset !important\"]}","{\"selector\":\".site-wrapper[data-state=\\\"panorama\\\"]\",\"action\":[\"style\",\"padding-top: 70px !important\"]}"],["{\"selector\":\"#content\",\"action\":[\"style\",\"margin-left: 0 !important\"]}"],["{\"selector\":\"body\",\"action\":[\"style\",\"overflow: auto !important\"]}"],["{\"selector\":\".custom-background\",\"action\":[\"style\",\"background-image: none !important\"]}"],["{\"selector\":\".paywall-wrapper\",\"action\":[\"style\",\"top: unset !important\"]}"],["{\"selector\":\".paywall\",\"action\":[\"style\",\"top: 0 !important\"]}"],["{\"selector\":\".article-container > .row > .col-12.col-xl-8\",\"action\":[\"style\",\"width: 98.1% !important; max-width: none !important; flex: none !important\"]}"],["{\"selector\":\".product-list-row .description\",\"action\":[\"style\",\"position: static !important; word-break: break-word !important\"]}"],["{\"selector\":\".wrapper\",\"action\":[\"style\",\"margin-top: 0 !important\"]}"],["{\"selector\":\"iframe + div[style*=\\\"height: 80vh\\\"]\",\"action\":[\"style\",\"height: unset !important\"]}"],["{\"selector\":\"#paywall\",\"action\":[\"style\",\"margin-top:0!important\"]}","{\"selector\":\".paywall-box\",\"action\":[\"style\",\"margin-top: 0 !important\"]}"],["{\"selector\":\".article\",\"action\":[\"style\",\"padding-bottom: 10px !important\"]}"],["{\"selector\":\".background-ad\",\"action\":[\"style\",\"min-height: 0 !important\"]}"],["{\"selector\":\".promotion\",\"action\":[\"style\",\"top: 0 !important\"]}"],["{\"selector\":\"#wrapper > #leaderboard > div\",\"action\":[\"style\",\"display: block !important\"]}"],["{\"selector\":\".auto_expandable\",\"action\":[\"style\",\"margin-top: 21px !important\"]}"],["{\"selector\":\"#topbanner\",\"action\":[\"style\",\"height: 1px !important\"]}"],["{\"selector\":\".container\",\"action\":[\"style\",\"margin-top: 0 !important\"]}","{\"selector\":\".main-header\",\"action\":[\"style\",\"margin-top: 0 !important\"]}"],["{\"selector\":\".padded.limit--tight.limit\",\"action\":[\"style\",\"padding-top: 15px !important\"]}","{\"selector\":\"div.padded--no-bottom.padded--less.padded.limit\",\"action\":[\"style\",\"padding-top: 5px !important\"]}"],["{\"selector\":\".tag-page\",\"action\":[\"style\",\"margin:0!important;padding:0!important\"]}","{\"selector\":\"html.height-calculated.nyheter[lang^=\\\"n\\\"] .article-footer\",\"action\":[\"style\",\"margin:0!important\"]}","{\"selector\":\"html.height-calculated.nyheter[lang^=\\\"n\\\"] .time\",\"action\":[\"style\",\"margin-bottom:0!important;padding-bottom:0!important;margin-top:0!important\"]}"],["{\"selector\":\"#aid-overlay\",\"action\":[\"style\",\"background: none !important; height: 0px !important; min-height: unset !important\"]}","{\"selector\":\"amedia-incentive\",\"action\":[\"style\",\"top: 1600px !important\"]}","{\"selector\":\"amedia-include[src*=\\\"/incentive/\\\"]\",\"action\":[\"style\",\"border: 10px !important; border-color: #CD5C5C !important; border-style: solid !important\"]}"],["{\"selector\":\".aid-background-blur\",\"action\":[\"style\",\"filter: none !important\"]}"],["{\"selector\":\".container-newsfeed + section .c-teaser__image\",\"action\":[\"style\",\"max-height: none !important\"]}","{\"selector\":\".container-newsfeed + section .o-grid__col:not(.u-size-onethird-medium):not([data-ga-action=\\\"1\\\"])\",\"action\":[\"style\",\"height: 200px !important\"]}"],["{\"selector\":\".article-content\",\"action\":[\"style\",\"padding:0\"]}"],["{\"selector\":\"body[style^=\\\"padding\\\"]\",\"action\":[\"style\",\"padding-top: 80px !important\"]}"],["{\"selector\":\".article-text-preview\",\"action\":[\"style\",\"-webkit-text-fill-color: black !important\"]}"],["{\"selector\":\"footer\",\"action\":[\"style\",\"margin: 0 !important\"]}"],["{\"selector\":\"#googlead-toppbanner\",\"action\":[\"style\",\"min-height: 0 !important\"]}"],["{\"selector\":\".rightColumn\",\"action\":[\"style\",\"margin-top: 10px !important\"]}"],["{\"selector\":\".title > h1.tittel\",\"action\":[\"style\",\"padding-top:0!important\"]}"],["{\"selector\":\".teaser\",\"action\":[\"style\",\"mask-image: none !important\"]}"],["{\"selector\":\".faded-content\",\"action\":[\"style\",\"max-height: none !important\"]}"],["{\"selector\":\".paywall-fade-out\",\"action\":[\"style\",\"overflow-y: unset !important\"]}","{\"selector\":\".paywall-login\",\"action\":[\"style\",\"margin-top: 30px !important\"]}"],["{\"selector\":\"#content\",\"action\":[\"style\",\"margin-top: 0px !important\"]}"],["{\"selector\":\".t3-header\",\"action\":[\"style\",\"margin-top: 0px !important\"]}"],["{\"selector\":\".article-top header\",\"action\":[\"style\",\"padding-top:0!important;margin:0!important\"]}","{\"selector\":\".content-marketing-ribbon\",\"action\":[\"style\",\"margin-top: 20px !important\"]}"],["{\"selector\":\":is(.container--break, .content-extra__recommended-news)\",\"action\":[\"style\",\"padding:0!important;margin:0!important\"]}"],["{\"selector\":\"main\",\"action\":[\"style\",\"min-height: unset !important\"]}","{\"selector\":\"section > section:first-of-type + section:last-of-type:has([class*=\\\"  \\\"])\",\"action\":[\"style\",\"width: 100% !important; max-width: 675px !important\"]}","{\"selector\":\"section[class^=\\\"GreatCanvas__smallArticles-\\\"]\",\"action\":[\"style\",\"width: 100% !important\"]}","{\"selector\":\"section[hidden] + section\",\"action\":[\"style\",\"column-count: 3 !important; width: 100% !important\"]}"],["{\"selector\":\".td-main-content-wrap\",\"action\":[\"style\",\"padding-top:0!important\"]}"],["{\"selector\":\".page-container\",\"action\":[\"style\",\"margin-top: 0 !important\"]}"]];

const hostnamesMap = new Map([["no.afterdawn.com",1],["mytastednk.com",2],["mytastenor.com",2],["nakenprat.com",3],["playpilot.com",4],["www.aftenposten.no",4],["tvkampen.com",5],["tvsporten.dk",5],["berlingske.dk",6],["borsen.dk",7],["bt.dk",8],["edbpriser.dk",9],["esportsmagasinet.dk",10],["feltet.dk",11],["information.dk",12],["journalisten.dk",13],["lydogbillede.dk",14],["lydogbilde.no",14],["mm.dk",15],["mx.dk",16],["skagensavis.dk",17],["spanienidag.es",18],["mbl.is",19],["visir.is",20],["no",21],["aasavis.no",[22,23]],["amta.no",[22,23]],["an.no",[22,23]],["ao.no",[22,23]],["auraavis.no",[22,23]],["austagderblad.no",[22,23]],["avisenagder.no",[22,23]],["ba.no",[22,23]],["bygdebladet.no",[22,23]],["bygdeposten.no",[22,23]],["dalane-tidende.no",[22,23]],["dt.no",[22,23]],["eikerbladet.no",[22,23]],["enebakkavis.no",[22,23]],["f-b.no",[22,23]],["finnmarkdagblad.no",[22,23]],["finnmarken.no",[22,23]],["firda.no",[22,23]],["firdaposten.no",[22,23]],["fremover.no",[22,23]],["gbnett.no",[22,23]],["gjengangeren.no",[22,23]],["glomdalen.no",[22,23]],["h-avis.no",[22,23]],["ha-halden.no",[22,23]],["hadeland.no",[22,23]],["hardanger-folkeblad.no",[22,23]],["helg.no",[22,23]],["iharstad.no",[22,23]],["indre.no",[22,23]],["jarlsbergavis.no",[22,23]],["jbl.no",[22,23]],["kv.no",[22,23]],["kvinnheringen.no",[22,23]],["laagendalsposten.no",[22,23]],["lierposten.no",[22,23]],["lofotposten.no",[22,23]],["lyngdalsavis.no",[22,23]],["merakerposten.no",[22,23]],["moss-avis.no",[22,23]],["nettavisen.no",[22,23]],["nidaros.no",[22,23]],["noblad.no",[22,23]],["nordhordland.no",[22,23]],["nordlys.no",[22,23]],["nt24.no",[22,23]],["oa.no",[22,23]],["oblad.no",[22,23]],["op.no",[22,23]],["ostlendingen.no",[22,23]],["oyene.no",[22,23]],["r-a.no",[22,23]],["rablad.no",[22,23]],["ranablad.no",[22,23]],["rb.no",[22,23]],["retten.no",[22,23]],["rha.no",[22,23]],["ringblad.no",[22,23]],["ringsaker-blad.no",[22,23]],["sa.no",[22,23]],["sandeavis.no",[22,23]],["sandnesposten.no",[22,23]],["sb.no",[22,23]],["smaalenene.no",[22,23]],["sognavis.no",[22,23]],["solabladet.no",[22,23]],["solungavisa.no",[22,23]],["strandbuen.no",[22,23]],["svelviksposten.no",[22,23]],["ta.no",[22,23]],["tb.no",[22,23]],["telen.no",[22,23]],["tk.no",[22,23]],["tvedestrandsposten.no",[22,23]],["varingen.no",[22,23]],["vestbyavis.no",[22,23]],["alt.no",23],["abcnyheter.no",24],["aftenbladet.no",25],["byggebolig.no",26],["canariavisen.no",27],["digi.no",28],["tu.no",28],["dn.no",29],["e24.no",30],["fagbladet.no",31],["friflyt.no",32],["jeger.no",32],["landevei.no",32],["norsk-klatring.no",32],["terrengsykkel.no",32],["utemagasinet.no",32],["h-a.no",33],["lokal-avisa.no",33],["ringsakern.no",33],["stangeavisa.no",33],["kommunal-rapport.no",34],["kondis.no",35],["samler.no",36],["seher.no",37],["sykepleien.no",38],["tek.no",39],["utrop.no",40],["vgtv.no",41]]);

const entitiesMap = new Map([["qxl",0]]);

const exceptionsMap = new Map(undefined);

self.declarativeImports = self.declarativeImports || [];
self.declarativeImports.push({ argsList, hostnamesMap, entitiesMap, exceptionsMap });

/******************************************************************************/

})();

/******************************************************************************/
