/*******************************************************************************

    uBlock Origin Lite - a comprehensive, MV3-compliant content blocker
    Copyright (C) 2019-present Raymond Hill

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see {http://www.gnu.org/licenses/}.

    Home: https://github.com/gorhill/uBlock
*/

/* jshint esversion:11 */

'use strict';

// ruleset: cze-0

/******************************************************************************/

// Important!
// Isolate from global scope
(function uBOL_cssSpecificImports() {

/******************************************************************************/

const argsList = ["#modal-container,\ndiv[id^=\"branding\"]",".modal-backdrop","[class*=\"sda\"]:not(.post-content)","div.banner_position","#banner-left-pane,\n#banner-top-four,\n#sportObchodBanner,\ndiv.bannerHolderZapasRight","#branding_anchor_left,\n#branding_anchor_right,\n.adtea_inpage,\n.adtea_leaderboard",".amalker","#pagefoot","#tblHorniLista",".native-ads",".wpa.top","[class^=\"advert__\"]",".ai_widget",".banner-header","#biglink","#content-right > div[style]:first-of-type","#header-banner","#leva-reklama","#content-lead,\ndiv.sky-wrapper","#header-reklama,\n.side-bann-l,\n.side-bann-r",".rklh",".banner2,\n.wrap + div:not(#footer)",".ads",".square_banner","#skyscraper","#sideScrapperLayout,\ndiv[id*=\"Banner\"]","#js-branding,\ndiv[id^=\"czech-\"]","#pr-prace-blok-view,\ndiv.block-jobs-link,\ndiv[class*=\"openx-async\"]","[id^=\"hyperbox\"]",".box-offer",".cornerbox,\n.heurekaIframeHeader","div#td-outer-wrap > div.td-container",".ad-obal",".box-banner",".widget-group-2 li:has(div.ad-pmg)","div[id^=\"ad_\"]","div[class^=\"reklama\"]","div#highlitesAds",".layoutTop","#g-top-bannery","#topSite,\n.gallery-advertisement",".intent-exit-box.l-row,\n.js-popup-quest.intent-exit-popup--quest.intent-exit-popup,\ndiv[class*=\"adcontainer\"]",".adsense,\n.leaderboard,\n.seriesadvert,\n.skyscraper",".banner","#r-leaderboardhp","div[id^=\"cross\"]","div:has(> a[class^=\"glightbox\"])",".rf-branding,\ndiv[class^=\"cross\"]","#fancybox-overlay,\n#h_part_right","#t-content",".topbanner","div[id^=\"ad-leaderboard\"]",".advert","#invelt","div.klik--leaderboard","#blackfooter","div[id^=\"pos-\"]",".topbanners","#box.mb,\n.arr-red","#ahead","#stOverlay,\n.promobox","div._banner","div.ogm-branding > div > div","div.bottom-partners","div.container.partners",".filtr.category-partner,\ndiv[class$=\"advert\"],\ndiv[class*=\"__banner\"]","[class*=\"sda-\"]",".TopFullBanner","div[id^=\"hyper\"]","div.advert-leader-board-container",".mone_box",".reklama-background","#social",".bannLead","[class*=\"ad_\"]","div[class*=\"Commercial_container\"]",".rleft,\n.rright,\n.tree","div[id^=\"banner\"]",".ad",".v-card--link:has(.ad),\n.v-card.mb-6","[class*=\"partnеr\"],\na[rel=\"sponsored\"]",".top_background","#z990x200,\n#zr300x600,\n[id^=\"adv_\"],\na[href*=\"utm_campaign=kurzy_\"],\niframe[src^=\"https://img.kurzy.cz/og\"]",".square","#box-over-content-a",".design-advert-placeholder,\n.design-box--jobs,\ndiv.article--content:has(div.design-advert)","#box-3,\n#rbackground-link,\ndiv[id*=\"reklama\"]",".banns-group","#block-nodesinblock-0",".header_banner","div[id^=\"mp_banner_\"]",".scroll_banner",".banner, .left-side-banner, .right-side-banner,\na[trgurl], a[href*=\"relocate.php\"],\ndiv:has(> a[href*=\"?act=detail&f=8\"])",".komerce",".bcc:has(.banners)",".npab",".box-responsive","[class*=\"advertisement\"]","pp",".right","div[style^=\"float:left;width:468px;\"] + img[src^=\"data:image/gif;base64,\"]",".advtick","#ad-leaderboard-alt-sides,\n.ad-leaderboard-alt-wrapper","a[class^=\"levakolejroku\"],\na[class^=\"pravakolejroku\"]","#leaderBox,\n.sticky-wrapper","#fixedMenu,\n#rek3,\n#rodkaz",".body_message--ad",".roumingLista","#pvMid","a[href^=\"https://prehrajto.cz/?cc=prlbmso2\"]",".mid-lead-hp",".gadget--zbozi,\ndiv[data-dot*=\"gadgetCommercial\"]","div[data-e-b-n*=\"advert\"],\ndiv[data-e-b-n*=\"sklik\"]","div[class^=\"branding-ad\"]","div.ad-exclusive,\ndiv.dragging-enabled:has(div.gadget--reklama),\ndiv.ogm-sticky-repeater","a[href*=\"track.smartmania.cz\"]","#P_reklama_horni,\n.reklamni_sdeleni,\n.rs_reklama,\n[style=\"vertical-align:middle; text-align: left; width: 139px;\"]",".tdc-row:not(:has(> .tdc-element-style))",".mabo.faa,\n[style=\"width:960px;margin:0 auto;text-align:left\"]","a[data-dot=\"c_pozadi\"],\na[data-dot=\"hp_pozadi\"],\ndiv.ad","#ad",".bbtitle","#vyjizdeciBoxikDiv",".sidebar-banner,\n.skyscrapper-right",".branding-link",".banner-brand",".center,\nobject[id*=\"bfad\"]","#adLocation-21,\n#popwrapper,\n#t-overlay,\n.row0,\na[href=\"http://acu.cz\"],\nh3","[class^=\"ws-banner-\"]",".SkyLeft.Banner","div.main-top,\ndiv.site-reklama",".bannero2","#aa1","div[style*=\"position:absolute;\"]","div[id][style=\"position: absolute; top: 0; left: 0; width: 100%; height: 380px; text-align: center;\"]",".modal","a[id*=\"popup2\"],\ndiv[id*=\"banner\"],\ndiv[id*=\"casino\"]",".desktop-wrapper:has([id^=\"div-gpt-ad\"])",".c_banner300x300","div[class^=\"banner_box\"]","a[href=\"http://www.Onlinefilmy.eu\"],\na[href=\"http://www.movieportal.eu\"],\ndiv[style=\"font-size:20px; font-family:Arial Black, Arial; color:#FF0000; font-weight:bold\"]","div[id^=\"ad\"]","div[class*=\"pohodoWidget\"]","a.predpredaj-black",".h2.grad2.kupons_games",".header_info_text",".s-branding,\n[id^=\"banner-\"],\ndiv[style*=\"Roboto\"][style*=\"fixed\"],\nstripemark",".container--break-branding,\n.container--break:has(.ad--align),\n.container--ticketportal,\n.item--socials,\n.item__ad-center,\ndiv[class^=\"position_\"]:has(.ad--align)","[id^=\"back\"][onclick]",".newsletter,\nheader > div","#footer,\n#headerSlideContent1,\n#ocko","[id^=\"mk-branding-\"]","#brnd","a[href*=\"trackBannerAd\"]","#push_promt,\n.wrapper__list__article:has(.widget__form-subscribe)","iframe[data-src^=\"/default-ad\"]",".artemis-ad-position","#top-offers-slider,\n.addbox.avizo,\n.box_advertisment.addbox.recycle,\n.nastip,\n.takeoverKlik",".gate-advert-wrap",".dragobj > div:nth-of-type(2),\n.stn.stns > a[target=\"_blank\"],\n.stn.stnu > a[target=\"_blank\"]",".content-item:has(.header a[href^=\"/reklama/\"])",".connection-results-ad","div[class=\"advertisement-list-component\"],\ndiv[class^=\"item h2\"]",".widget:has(img[src*=\"/ads/\"]),\ndiv[id^=\"advert_\"]","a[href^=\"https://boxu.sk\"]",".post.bg5",".overlay,\na[class^=\"tv-\"]",".banner-under,\n.product-ad-wrapper,\n.sqaure-mobile-ad"];

const hostnamesMap = new Map([["autozurnal.com",[0,1]],["pppeter.shop",[1,135]],["presovak.sk",[1,154]],["grunex.com",2],["kamsdetmi.com",3],["onlajny.com",4],["programujte.com",5],["tipcars.com",6],["titulky.com",7],["war4all.com",8],["zmeskanyhovor.com",9],["365tipu.cz",10],["aktualne.cz",11],["anglictina-maturita.cz",12],["biologie-chemie.cz",12],["ekonomie-ucetnictvi.cz",12],["rozbor-dila.cz",12],["rozborknihy.cz",12],["studijni-svet.cz",12],["rozbor-dila.eu",12],["appliste.cz",13],["serialzone.cz",[13,110]],["autobazar.cz",14],["autoforum.cz",[15,16]],["wmmania.cz",16],["autohit.cz",17],["autorevue.cz",18],["e15.cz",[18,40]],["maminka.cz",18],["mobilmania.cz",18],["zive.cz",18],["autosport.cz",19],["autoweb.cz",20],["autozine.cz",21],["isport.blesk.cz",22],["evropa2.cz",22],["filmporno.cz",[22,57]],["businessworld.cz",[23,24]],["computerworld.cz",[23,24,32]],["pcworld.cz",24],["busportal.cz",25],["cc.cz",26],["cdr.cz",27],["diit.cz",27],["ceskenoviny.cz",[28,29]],["nasepenize.cz",29],["cesky-jazyk.cz",30],["cnews.cz",31],["csfd.cz",[33,34]],["csfd.sk",33],["databazeknih.cz",35],["denik.cz",36],["dotekomanie.cz",37],["drbna.cz",38],["e-mostecko.cz",39],["info.cz",40],["echo24.cz",41],["edna.cz",[42,43]],["in-pocasi.cz",43],["ireceptar.cz",43],["webtrh.cz",43],["centrum.sk",[43,144]],["cp.sk",[43,52]],["emimino.cz",44],["enigmaplus.cz",[45,46]],["epochaplus.cz",[46,47]],["esemes.cz",[48,49]],["warforum.cz",[49,127]],["estav.cz",50],["euro.cz",51],["eurogamer.cz",52],["pravopisne.cz",52],["pravda.sk",52],["pravopisne.sk",52],["ewrc.cz",53],["extra.cz",54],["fdb.cz",55],["fdrive.cz",56],["fzone.cz",56],["mobilenet.cz",56],["finance.cz",[58,59]],["motoforum.cz",59],["firstclass.cz",60],["fotoaparat.cz",61],["garaz.cz",62],["prozeny.cz",62],["seznamzpravy.cz",62],["hcdukla.cz",63],["hcmotor.cz",64],["heureka.cz",65],["heureka.sk",65],["hrej.cz",66],["pctuning.cz",66],["tryhard.cz",66],["zing.cz",66],["hybrid.cz",67],["idnes.cz",68],["lidovky.cz",68],["idos.idnes.cz",69],["cnn.iprima.cz",70],["itnetwork.cz",71],["jaknaletenky.cz",72],["kaloricketabulky.cz",73],["karaoketexty.cz",74],["kinobox.cz",75],["kladenskelisty.cz",76],["kniha.cz",77],["konzolista.cz",[78,79]],["topky.sk",[78,157]],["tvtv.sk",[78,160]],["krimi-plzen.cz",80],["kupi.cz",81],["kurzy.cz",82],["lamer.cz",83],["moda.cz",83],["livesport.cz",84],["lupa.cz",85],["root.cz",85],["matematika.cz",86],["mediar.cz",87],["medop.cz",88],["menicka.cz",89],["meteoprog.cz",90],["mladypodnikatel.cz",91],["motorkari.cz",92],["mrk.cz",93],["msmt.cz",94],["nasepraha.cz",95],["navratdoreality.cz",96],["netconcert.cz",97],["onlymen.cz",98],["osel.cz",99],["parabola.cz",100],["pravidla.cz",101],["prehrajto.cz",102],["primat.cz",103],["reflex.cz",104],["ronnie.cz",105],["forum.root.cz",106],["rouming.cz",107],["sauto.cz",108],["serialycz.cz",109],["seznam.cz",111],["clanky.seznam.cz",112],["search.seznam.cz",112],["tv.seznam.cz",113],["www.seznam.cz",114],["smartmania.cz",115],["sms.cz",116],["sports24.cz",117],["stesti.cz",118],["super.cz",119],["login.szn.cz",120],["tiscali.cz",121],["topzine.cz",122],["tvfreak.cz",123],["uschovna.cz",124],["vortex.cz",125],["warezforum.cz",126],["webshare.cz",128],["zakonyprolidi.cz",129],["zena-in.cz",130],["autobazar.eu",131],["libise.eu",132],["sktorrent.eu",133],["serialy.io",134],["bombuj.si",136],["serialy.bombuj.si",136],["slovnik.aktuality.sk",137],["pokec.azet.sk",138],["behame.sk",139],["best4you.sk",140],["bmwklub.sk",141],["cas.sk",[142,143]],["feminity.zoznam.sk",142],["dsl.sk",145],["hnonline.sk",146],["brainee.hnonline.sk",147],["kinema.sk",148],["sector.sk",[148,155]],["kosicednes.sk",149],["michalovskespravy.sk",150],["modrykonik.sk",151],["mojevideo.sk",152],["mtbiker.sk",153],["sme.sk",156],["touchit.sk",158],["tv-program.sk",159],["ubian.sk",161],["vranovske.sk",162],["vtn-vranov.sk",163],["zoznam.sk",164],["pretaktovanie.zoznam.sk",165],["najserialy.to",166],["mall.tv",167]]);

const entitiesMap = new Map(undefined);

const exceptionsMap = new Map(undefined);

self.specificImports = self.specificImports || [];
self.specificImports.push({ argsList, hostnamesMap, entitiesMap, exceptionsMap });

/******************************************************************************/

})();

/******************************************************************************/
