/*******************************************************************************

    uBlock Origin Lite - a comprehensive, MV3-compliant content blocker
    Copyright (C) 2014-present Raymond Hill

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see {http://www.gnu.org/licenses/}.

    Home: https://github.com/gorhill/uBlock
*/

/* jshint esversion:11 */

'use strict';

// ruleset: annoyances-overlays

/******************************************************************************/

// Important!
// Isolate from global scope
(function uBOL_cssDeclarativeImport() {

/******************************************************************************/

const argsList = [["{\"selector\":\"*\",\"action\":[\"style\",\"-webkit-touch-callout: default !important; -webkit-user-select: text !important; -moz-user-select: text !important; -ms-user-select: text !important; user-select: text !important;\"]}"],["{\"selector\":\"::selection\",\"action\":[\"style\",\"background-color:#338FFF!important\"]}"],["{\"selector\":\"*\",\"action\":[\"style\",\"user-select: text !important; -ms-user-select: text !important; -moz-user-select: text !important; -khtml-user-select: text !important; -webkit-user-select: text !important; -webkit-touch-callout: default !important;\"]}"],["{\"selector\":\"*\",\"action\":[\"style\",\"-webkit-touch-callout: default!important; -webkit-user-drag: element!important; -webkit-user-select: text!important; -moz-user-select: text!important; -ms-user-select: text!important; user-select: text!important;\"]}"],["{\"selector\":\"body\",\"action\":[\"style\",\"-webkit-touch-callout: default !important; -webkit-user-select: text !important; -moz-user-select: text !important; -ms-user-select: text !important; user-select: text !important;\"]}"],["{\"selector\":\"[data-lyricid]\",\"action\":[\"style\",\"user-select: text !important;\"]}"],["{\"selector\":\"#chapter-article .chapter-content\",\"action\":[\"style\",\"user-select: text !important; -ms-user-select: text !important; -moz-user-select: text !important; -khtml-user-select: text !important; -webkit-user-select: text !important; -webkit-touch-callout: default !important;\"]}"],["{\"selector\":\"#desktopWrapper\",\"action\":[\"style\",\"position: static !important;\"]}","{\"selector\":\".gridCentered\",\"action\":[\"style\",\"margin-top: auto !important;\"]}"],["{\"selector\":\"body, html\",\"action\":[\"style\",\"height: auto !important; overflow: auto !important\"]}"],["{\"selector\":\"html.u-overflowHidden\",\"action\":[\"style\",\"overflow-y: scroll !important;\"]}"],["{\"selector\":\"body\",\"action\":[\"style\",\"overflow: auto !important; position: initial !important;\"]}"],["{\"selector\":\".blur\",\"action\":[\"style\",\"filter: none !important\"]}"],["{\"selector\":\"body, html\",\"action\":[\"style\",\"overflow: auto !important; position: initial !important;\"]}"],["{\"selector\":\"html\",\"action\":[\"style\",\"overflow:auto !important\"]}"],["{\"selector\":\"body\",\"action\":[\"style\",\"overflow: auto !important;\"]}"],["{\"selector\":\".select-none\",\"action\":[\"style\",\"-webkit-touch-callout: default !important; -webkit-user-select: text !important; -moz-user-select: text !important; -ms-user-select: text !important; user-select: text !important;\"]}"],["{\"selector\":\"#page\",\"action\":[\"style\",\"-webkit-touch-callout: default !important; -webkit-user-select: text !important; -moz-user-select: text !important; -ms-user-select: text !important; user-select: text !important;\"]}"],["{\"selector\":\".definicao_verbete_homologado_interna\",\"action\":[\"style\",\"height:100% !important;\"]}"],["{\"selector\":\"body\",\"action\":[\"style\",\"-moz-user-select:text !important;-ms-user-select:text !important;user-select:text !important;\"]}"],["{\"selector\":\"body\",\"action\":[\"style\",\"cursor: revert !important; -webkit-touch-callout: default !important; -webkit-user-select: text !important; -khtml-user-select: text !important; -moz-user-select: text !important; -ms-user-select: text !important; user-select: text !important; -webkit-tap-highlight-color: revert !important;\"]}"],["{\"selector\":\"body * :not(input):not(textarea)\",\"action\":[\"style\",\"-webkit-touch-callout: default !important; -webkit-user-select: text !important; -moz-user-select: text !important; -ms-user-select: text !important; user-select: text !important;\"]}"],["{\"selector\":\"body\",\"action\":[\"style\",\"overflow: auto !important\"]}"],["{\"selector\":\"body, html\",\"action\":[\"style\",\"position: static !important; overflow: auto !important; width: auto !important;\"]}"],["{\"selector\":\"::selection\",\"action\":[\"style\",\"background: Highlight !important; color: HighlightText !important\"]}"],["{\"selector\":\".unselectable\",\"action\":[\"style\",\"-webkit-touch-callout: default !important; -webkit-user-select: text !important; -moz-user-select: text !important; -ms-user-select: text !important; user-select: text !important; cursor: auto !important;\"]}"],["{\"selector\":\"div#wrapper\",\"action\":[\"style\",\"filter: none !important\"]}"],["{\"selector\":\"body\",\"action\":[\"style\",\"-webkit-touch-callout: default !important; -webkit-user-select: text !important;-moz-user-select: text !important;-ms-user-select: text !important;user-select: text !important;\"]}"],["{\"selector\":\"*\",\"action\":[\"style\",\"filter: none !important\"]}"],["{\"selector\":\"*\",\"action\":[\"style\",\"-webkit-touch-callout: default !important; -webkit-user-select: text !important; -moz-user-select: text !important; -ms-user-select: text !important; user-select: text !important; cursor: auto !important;\"]}"],["{\"selector\":\":not(input):not(textarea)::selection\",\"action\":[\"style\",\"background-color:Highlight!important;color:HighlightText!important\"]}"],["{\"selector\":\"html, body\",\"action\":[\"style\",\"overflow: auto !important; position: initial !important;\"]}"],["{\"selector\":\":not(input):not(textarea), img\",\"action\":[\"style\",\"-webkit-touch-callout: default !important; -webkit-user-select: text !important; -moz-user-select: text !important; -ms-user-select: text !important; user-select: text !important;\"]}"],["{\"selector\":\"*::selection\",\"action\":[\"style\",\"background-color:#338FFF!important\"]}"],["{\"selector\":\"[id]\",\"action\":[\"style\",\"-webkit-touch-callout: default !important; -webkit-user-select: text !important; -moz-user-select: text !important; -ms-user-select: text !important; user-select: text !important;\"]}"],["{\"selector\":\"body\",\"action\":[\"style\",\"cursor:auto!important\"]}"],["{\"selector\":\"body *\",\"action\":[\"style\",\"user-select: auto!important;-webkit-touch-callout: default!important;-webkit-user-select: auto!important;-moz-user-select: auto!important;-ms-user-select: auto!important;\"]}"],["{\"selector\":\"body\",\"action\":[\"style\",\"overflow: scroll !important; position: unset !important\"]}"],["{\"selector\":\".modal-open\",\"action\":[\"style\",\"overflow:initial!important\"]}"],["{\"selector\":\"body.modal-open\",\"action\":[\"style\",\"overflow:auto !important\"]}"],["{\"selector\":\"html, .unselectable\",\"action\":[\"style\",\"-webkit-touch-callout: default !important; -webkit-user-select: text !important; -moz-user-select: text !important; -ms-user-select: text !important; user-select: text !important;\"]}"],["{\"selector\":\"body\",\"action\":[\"style\",\"overflow: auto !important; max-height: unset !important;\"]}"],["{\"selector\":\"body\",\"action\":[\"style\",\"overflow-x: hidden !important; overflow-y: scroll !important; padding-right: 0 !important;\"]}"],["{\"selector\":\".content-body-wrapper\",\"action\":[\"style\",\"opacity:1!important\"]}"],["{\"selector\":\"*::selection\",\"action\":[\"style\",\"background-color:#338FFF !important;\"]}"],["{\"selector\":\"body\",\"action\":[\"style\",\"overflow:auto !important\"]}"],["{\"selector\":\"html\",\"action\":[\"style\",\"overflow: auto !important\"]}"],["{\"selector\":\"html.om-position-popup body\",\"action\":[\"style\",\"overflow:auto !important\"]}"],["{\"selector\":\".novel-box :not(a)\",\"action\":[\"style\",\"user-select: text !important; -ms-user-select: text !important; -moz-user-select: text !important; -khtml-user-select: text !important; -webkit-user-select: text !important; -webkit-touch-callout: default !important;\"]}","{\"selector\":\".superpowerlol::before\",\"action\":[\"style\",\"content: unset !important;\"]}"],["{\"selector\":\".post-section\",\"action\":[\"style\",\"filter: none !important; -webkit-filter: none !important; pointer-events: all !important\"]}"],["{\"selector\":\"body\",\"action\":[\"style\",\"overflow-x: hidden !important; overflow-y: scroll !important;\"]}"],["{\"selector\":\"body *:not(input):not(textarea)\",\"action\":[\"style\",\"user-select: text !important; -ms-user-select: text !important; -moz-user-select: text !important; -khtml-user-select: text !important; -webkit-user-select: text !important; -webkit-touch-callout: default !important;\"]}"],["{\"selector\":\"body.tingle-enabled\",\"action\":[\"style\",\"position: static!important;overflow: auto!important;\"]}"],["{\"selector\":\".unselectable\",\"action\":[\"style\",\"-webkit-touch-callout: default !important; -webkit-user-select: text !important; -moz-user-select: text !important; -ms-user-select: text !important; user-select: text !important;\"]}"],["{\"selector\":\".fb_lightbox-lock\",\"action\":[\"style\",\"overflow-x: hidden !important; overflow-y: scroll !important;\"]}"],["{\"selector\":\"html\",\"action\":[\"style\",\"overflow: auto !important; position: initial !important;\"]}"],["{\"selector\":\"body.disable-scroll\",\"action\":[\"style\",\"overflow: auto !important;\"]}"],["{\"selector\":\".erc-existing-profile-onboarding-modal > div[class^=\\\"modal-portal__overlay\\\"]\",\"action\":[\"style\",\"visibility: hidden !important;\"]}"],["{\"selector\":\"*\",\"action\":[\"style\",\"-ms-user-select:auto !important; -moz-user-select:auto !important; -webkit-user-select:auto !important; -webkit-touch-callout:default !important; user-select:auto !important\"]}"],["{\"selector\":\"#courier-body-wrapper\",\"action\":[\"style\",\"overflow: auto !important; position: initial !important;\"]}"],["{\"selector\":\".post-body\",\"action\":[\"style\",\"-webkit-touch-callout: default !important; -webkit-user-select: text !important; -moz-user-select: text !important; -ms-user-select: text !important; user-select: text !important;\"]}"],["{\"selector\":\"html\",\"action\":[\"style\",\"overflow: hidden !important;\"]}"],["{\"selector\":\"*\",\"action\":[\"style\",\"-webkit-touch-callout: default !important; -webkit-user-select: text !important;-moz-user-select: text !important;-ms-user-select: text !important;user-select: text !important;\"]}"],["{\"selector\":\"html.documentLocked body\",\"action\":[\"style\",\"overflow: visible !important;\"]}","{\"selector\":\"html.documentLocked header\",\"action\":[\"style\",\"padding-right: 0 !important;\"]}","{\"selector\":\"html.documentLocked\",\"action\":[\"style\",\"margin-right: 0 !important;\"]}"],["{\"selector\":\".unselectable\",\"action\":[\"style\",\"-webkit-touch-callout: default !important; -webkit-user-select: text !important;-moz-user-select: text !important;-ms-user-select: text !important;user-select: text !important;\"]}"],["{\"selector\":\".no-js\",\"action\":[\"style\",\"overflow: auto !important\"]}"],["{\"selector\":\".aui-modal-open, .modal-open\",\"action\":[\"style\",\"overflow:unset!important\"]}"],["{\"selector\":\".obscured\",\"action\":[\"style\",\"color: black !important;text-shadow: none !important; filter: none !important\"]}"],["{\"selector\":\"body\",\"action\":[\"style\",\"-webkit-touch-callout: default !important; -khtml-user-select: text !important; -webkit-user-select: text !important; -moz-user-select: text !important; -ms-user-select: text !important; user-select: text !important;\"]}"],["{\"selector\":\".pg_main2, .panel_main, .panel_border2\",\"action\":[\"style\",\"background: unset !important; user-select: text !important; -ms-user-select: text !important; -moz-user-select: text !important; -khtml-user-select: text !important; -webkit-user-select: text !important; -webkit-touch-callout: default !important;\"]}","{\"selector\":\".track_back\",\"action\":[\"style\",\"background: unset !important;\"]}"],["{\"selector\":\"html, .unselectable\",\"action\":[\"style\",\"cursor: revert !important; -webkit-touch-callout: default !important; -webkit-user-select: text !important; -khtml-user-select: text !important; -moz-user-select: text !important; -ms-user-select: text !important; user-select: text !important; -webkit-tap-highlight-color: revert !important;\"]}"],["{\"selector\":\".navigationWrapper\",\"action\":[\"style\",\"top: 0px !important;\"]}"],["{\"selector\":\"body\",\"action\":[\"style\",\"-webkit-touch-callout: default !important;-webkit-user-select: text !important;-moz-user-select: text !important;-ms-user-select: text !important;user-select: text !important;\"]}"],["{\"selector\":\".storytextp\",\"action\":[\"style\",\"user-select: text !important; -webkit-user-select: text !important;\"]}"],["{\"selector\":\"#fwrapper, body\",\"action\":[\"style\",\"-webkit-touch-callout: default !important; -webkit-user-select: text !important; -moz-user-select: text !important; -ms-user-select: text !important; user-select: text !important;\"]}"],["{\"selector\":\"html\",\"action\":[\"style\",\"position: static !important; overflow: auto !important; width: auto !important;\"]}"],["{\"selector\":\"body.no-scroll\",\"action\":[\"style\",\"overflow:auto !important\"]}"],["{\"selector\":\"body\",\"action\":[\"style\",\"height: auto !important; overflow: auto !important\"]}"],["{\"selector\":\"body\",\"action\":[\"style\",\"-moz-user-select: auto !important;-ms-user-select: auto !important;-webkit-user-select: auto !important;-webkit-touch-callout: default !important;\"]}"],["{\"selector\":\"html\",\"action\":[\"style\",\"-webkit-touch-callout: default !important; -webkit-user-select: text !important; -moz-user-select: text !important; -ms-user-select: text !important; user-select: text !important;\"]}"],["{\"selector\":\"[style^=\\\"filter: blur\\\"]\",\"action\":[\"style\",\"filter: none !important\"]}"],["{\"selector\":\".modal-open\",\"action\":[\"style\",\"overflow:unset!important\"]}"],["{\"selector\":\"*\",\"action\":[\"style\",\"-webkit-touch-callout: default !important; -webkit-user-select: text !important; -khtml-user-select: text !important; -moz-user-select: text !important; -ms-user-select: text !important; user-select: text !important; -webkit-tap-highlight-color: revert !important; cursor: revert !important;\"]}"],["{\"selector\":\"*\",\"action\":[\"style\",\"cursor: revert !important; -webkit-touch-callout: default !important; -webkit-user-select: text !important; -khtml-user-select: text !important; -moz-user-select: text !important; -ms-user-select: text !important; user-select: text !important; -webkit-tap-highlight-color: revert !important;\"]}"],["{\"selector\":\".CoverPop-open\",\"action\":[\"style\",\"overflow: auto !important\"]}"],["{\"selector\":\"p\",\"action\":[\"style\",\"-webkit-touch-callout: default !important; -webkit-user-select: text !important; -moz-user-select: text !important; -ms-user-select: text !important; user-select: text !important;\"]}"],["{\"selector\":\":root\",\"action\":[\"style\",\"user-select: unset !important;\"]}"],["{\"selector\":\"body > div\",\"action\":[\"style\",\"-webkit-touch-callout: default !important; -webkit-user-select: text !important;-moz-user-select: text !important;-ms-user-select: text !important;user-select: text !important;\"]}"],["{\"selector\":\"body[style*=\\\"overflow\\\"] > div[class]:has(> #passport-modal-overlay)\",\"action\":[\"style\",\"opacity: 0 !important; visibility: collapse !important;\"]}","{\"selector\":\"body[style*=\\\"overflow\\\"]:has(> div[class] > #passport-modal-overlay)\",\"action\":[\"style\",\"overflow: auto !important; position: relative !important; padding-right: 0px !important; inset: unset !important;\"]}"],["{\"selector\":\"html.gnt__mo\",\"action\":[\"style\",\"overflow-y:scroll !important;pointer-events: unset !important;user-select: unset !important;margin-right: unset !important;\"]}"],["{\"selector\":\"html\",\"action\":[\"style\",\"overflow-x: hidden !important; overflow-y: scroll !important;\"]}"],["{\"selector\":\"[class]\",\"action\":[\"style\",\"-webkit-touch-callout: default !important; -webkit-user-select: text !important; -moz-user-select: text !important; -ms-user-select: text !important; user-select: text !important;\"]}"],["{\"selector\":\"body\",\"action\":[\"style\",\"user-select: text !important; -ms-user-select: text !important; -moz-user-select: text !important; -khtml-user-select: text !important; -webkit-user-select: text !important; -webkit-touch-callout: default !important;\"]}"],["{\"selector\":\"body\",\"action\":[\"style\",\"-webkit-touch-callout: default !important; -webkit-user-select: text !important; -moz-user-select: text !important; -ms-user-select: text !important; user-select: text !important\"]}"],["{\"selector\":\"*\",\"action\":[\"style\",\"-webkit-user-select: text !important; -moz-user-select: text !important; -ms-user-select: text !important; user-select: text !important;\"]}"],["{\"selector\":\"html\",\"action\":[\"style\",\"overflow: auto !important;\"]}"],["{\"selector\":\"body\",\"action\":[\"style\",\"user-select:auto !important;-webkit-user-select:auto !important;-ms-user-select:auto !important;-moz-user-select:auto !important;-webkit-user-drag:auto !important\"]}"],["{\"selector\":\".modal-open\",\"action\":[\"style\",\"overflow: auto !important;\"]}"],["{\"selector\":\"body *\",\"action\":[\"style\",\"-webkit-touch-callout: default !important; -webkit-user-select: text !important; -moz-user-select: text !important; -ms-user-select: text !important; user-select: text !important;\"]}"],["{\"selector\":\".subscription .paywall\",\"action\":[\"style\",\"height: unset !important; overflow: unset !important;\"]}"],["{\"selector\":\"body\",\"action\":[\"style\",\"-webkit-touch-callout:text !important;-webkit-user-select:text !important;-khtml-user-select:text !important;-moz-user-select:text !important;-ms-user-select:text !important;user-select:text !important\"]}"],["{\"selector\":\".index-wrap\",\"action\":[\"style\",\"overflow: auto !important;\"]}"],["{\"selector\":\"body.modal-open\",\"action\":[\"style\",\"overflow-x: hidden !important; overflow-y: scroll !important;\"]}"],["{\"selector\":\".nosel\",\"action\":[\"style\",\"-webkit-touch-callout: default !important; -webkit-user-select: text !important; -moz-user-select: text !important; -ms-user-select: text !important; user-select: text !important;\"]}"],["{\"selector\":\"body\",\"action\":[\"style\",\"overflow: initial !important\"]}"],["{\"selector\":\"body.ReactModal__Body--open\",\"action\":[\"style\",\"position: unset !important; overflow: auto !important;\"]}"],["{\"selector\":\".ad_block_detected\",\"action\":[\"style\",\"overflow: auto !important;\"]}"],["{\"selector\":\"body\",\"action\":[\"style\",\"position: static !important; overflow: auto !important; width: auto !important;\"]}"],["{\"selector\":\"body\",\"action\":[\"style\",\"overflow:initial!important\"]}"],["{\"selector\":\"#pftop\",\"action\":[\"style\",\"height: auto !important;padding-bottom:5px !important\"]}"],["{\"selector\":\".SetPageTerm\",\"action\":[\"style\",\"display: block !important\"]}"],["{\"selector\":\".qu-overflow--hidden[style*=\\\"filter: blur\\\"]\",\"action\":[\"style\",\"filter:none !important;overflow:auto !important\"]}","{\"selector\":\".signup_wall_prevent_scroll #root\",\"action\":[\"style\",\"filter: none !important;\"]}","{\"selector\":\".signup_wall_prevent_scroll\",\"action\":[\"style\",\"position: unset !important; padding-right: 0 !important;\"]}"],["{\"selector\":\"*\",\"action\":[\"style\",\"-webkit-touch-callout: default !important; -webkit-user-select: text !important; -moz-user-select: text !important; -ms-user-select: text !important; user-select: text !important; cursor: auto !important\"]}"],["{\"selector\":\".unselectable, html\",\"action\":[\"style\",\"-webkit-touch-callout: default !important; -webkit-user-select: text !important; -moz-user-select: text !important; -ms-user-select: text !important; user-select: text !important; cursor: auto !important\"]}"],["{\"selector\":\"body.modal-open\",\"action\":[\"style\",\"overflow: auto !important; padding-right: 0 !important;\"]}"],["{\"selector\":\":root\",\"action\":[\"style\",\"-webkit-touch-callout: default !important; -webkit-user-select: text !important; -moz-user-select: text !important; -ms-user-select: text !important; user-select: text !important;\"]}"],["{\"selector\":\"form[id=\\\"tfnewsearch\\\"] > input[id=\\\"val\\\"]\",\"action\":[\"style\",\"clip-path: circle(0) !important;\"]}","{\"selector\":\"form[id=\\\"tfnewsearch\\\"]\",\"action\":[\"style\",\"font-size: 0px !important;\"]}"],["{\"selector\":\"body.no-scroll\",\"action\":[\"style\",\"overflow: visible !important;position: static !important\"]}"],["{\"selector\":\"body\",\"action\":[\"style\",\"user-select: text !important; -webkit-user-select: text !important; -moz-user-select: text !important; -ms-user-select: text !important; -o-user-select: text !important;\"]}"],["{\"selector\":\".unselectable, html\",\"action\":[\"style\",\"-webkit-touch-callout: default !important; -webkit-user-select: text !important; -moz-user-select: text !important; -ms-user-select: text !important; user-select: text !important; cursor: text !important\"]}"],["{\"selector\":\"*\",\"action\":[\"style\",\"cursor: revert !important; -webkit-touch-callout: default !important; -webkit-user-select: text !important; -khtml-user-select: text !important; -moz-user-select: text !important; -ms-user-select: text !important; user-select: text !important;\"]}"],["{\"selector\":\"form#link a.submit\",\"action\":[\"style\",\"opacity: 1 !important; pointer-events: auto !important;\"]}"],["{\"selector\":\"#bottomAd\",\"action\":[\"style\",\"position: absolute !important; left: -4000px !important;\"]}"],["{\"selector\":\".sui-u-no-scroll\",\"action\":[\"style\",\"overflow:auto !important;\"]}"],["{\"selector\":\"body\",\"action\":[\"style\",\"cursor: initial !important;\"]}"],["{\"selector\":\"body, code\",\"action\":[\"style\",\"-webkit-touch-callout: default !important; -webkit-user-select: text !important; -moz-user-select: text !important; -ms-user-select: text !important; user-select: text !important;\"]}"],["{\"selector\":\"body\",\"action\":[\"style\",\"overflow: auto!important\"]}"],["{\"selector\":\"body * :not(input):not(textarea)\",\"action\":[\"style\",\"user-select: text !important; -ms-user-select: text !important; -moz-user-select: text !important; -khtml-user-select: text !important; -webkit-user-select: text !important; -webkit-touch-callout: default !important;\"]}"],["{\"selector\":\".modal-open\",\"action\":[\"style\",\"overflow: auto !important; padding-top: 0 !important;\"]}"],["{\"selector\":\"*::selection\",\"action\":[\"style\",\"background-color: #338FFF !important\"]}"],["{\"selector\":\"html, body\",\"action\":[\"style\",\"overflow: auto !important;\"]}"],["{\"selector\":\"body\",\"action\":[\"style\",\"overflow: scroll !important\"]}"],["{\"selector\":\".Post-body--truncated\",\"action\":[\"style\",\"max-height: unset !important;\"]}"],["{\"selector\":\".async-hide\",\"action\":[\"style\",\"opacity:1!important\"]}"],["{\"selector\":\"*\",\"action\":[\"style\",\"-webkit-touch-callout: default!important; -webkit-user-select: auto!important; -moz-user-select: auto!important; -ms-user-select: auto!important;\"]}"],["{\"selector\":\"body > div > section.default\",\"action\":[\"style\",\"cursor: revert !important;\"]}"],["{\"selector\":\"html\",\"action\":[\"style\",\"overflow:auto!important\"]}"],["{\"selector\":\".lyricBody\",\"action\":[\"style\",\"-webkit-touch-callout: default !important; -webkit-user-select: text !important; -moz-user-select: text !important; -ms-user-select: text !important; user-select: text !important;\"]}"],["{\"selector\":\"div.body-container\",\"action\":[\"style\",\"cursor: revert !important;\"]}"],["{\"selector\":\"html\",\"action\":[\"style\",\"user-select: text !important; -ms-user-select: text !important; -moz-user-select: text !important; -khtml-user-select: text !important; -webkit-user-select: text !important; -webkit-touch-callout: default !important;\"]}"],["{\"selector\":\".unselectable, html\",\"action\":[\"style\",\"-webkit-touch-callout: default !important; -webkit-user-select: text !important; -moz-user-select: text !important; -ms-user-select: text !important; user-select: text !important;\"]}"],["{\"selector\":\"html\",\"action\":[\"style\",\"height: auto !important; overflow: auto !important\"]}"],["{\"selector\":\"body, html\",\"action\":[\"style\",\"overflow: auto !important;\"]}"],["{\"selector\":\".td-post-content, .td-post-title\",\"action\":[\"style\",\"user-select: text !important; -ms-user-select: text !important; -moz-user-select: text !important; -khtml-user-select: text !important; -webkit-user-select: text !important; -webkit-touch-callout: default !important;\"]}"],["{\"selector\":\"#maincontent\",\"action\":[\"style\",\"user-select: text !important; -webkit-user-select: text !important; -moz-user-select: text !important; -ms-user-select: text !important; -o-user-select: text !important;\"]}"],["{\"selector\":\"html.open-modal .overlay\",\"action\":[\"style\",\"display: none !important\"]}","{\"selector\":\"html.open-modal body\",\"action\":[\"style\",\"overflow: auto !important\"]}","{\"selector\":\"html.open-modal body::after\",\"action\":[\"style\",\"display: none !important;\"]}"],["{\"selector\":\"*::-webkit-scrollbar\",\"action\":[\"style\",\"width:17px !important\"]}","{\"selector\":\"*::-webkit-scrollbar-thumb\",\"action\":[\"style\",\"background:#5e5e5e !important\"]}"],["{\"selector\":\"article.post\",\"action\":[\"style\",\"-webkit-touch-callout: default !important; -webkit-user-select: text !important; -moz-user-select: text !important; -ms-user-select: text !important; user-select: text !important;\"]}"],["{\"selector\":\"body\",\"action\":[\"style\",\"cursor: revert !important;\"]}"],["{\"selector\":\"body\",\"action\":[\"style\",\"cursor: auto !important\"]}"],["{\"selector\":\"#game-wrap\",\"action\":[\"style\",\"-webkit-user-select: text !important; -moz-user-select: text !important; -ms-user-select: text !important; user-select: text !important;\"]}"],["{\"selector\":\"*\",\"action\":[\"style\",\"-webkit-touch-callout: default !important; -webkit-user-select: text !important; -moz-user-select: text !important; -ms-user-select: text !important; user-select: text !important; -webkit-tap-highlight-color: revert !important;\"]}"],["{\"selector\":\"body\",\"action\":[\"style\",\"user-select: auto !important; -webkit-user-select: auto !important; -moz-user-select: auto !important; -webkit-user-drag: auto !important\"]}"],["{\"selector\":\"body[style=\\\"overflow: hidden;\\\"]\",\"action\":[\"style\",\"overflow: auto !important;\"]}"],["{\"selector\":\".all-lyrics\",\"action\":[\"style\",\"-webkit-user-select: text !important; -moz-user-select: text !important; -ms-user-select: text !important; user-select: text !important;\"]}"],["{\"selector\":\"*\",\"action\":[\"style\",\"opacity: 1 !important;\"]}"],["{\"selector\":\"body\",\"action\":[\"style\",\"-webkit-user-select:auto !important; -webkit-touch-callout: default !important;\"]}"],["{\"selector\":\"body\",\"action\":[\"style\",\"-webkit-user-select:text!important;-moz-user-select:text!important;-ms-user-select:text!important;user-select:text!important\"]}"],["{\"selector\":\"p, ul, ol\",\"action\":[\"style\",\"-webkit-touch-callout: default !important; -webkit-user-select: text !important; -moz-user-select: text !important; -ms-user-select: text !important; user-select: text !important;\"]}"],["{\"selector\":\"div\",\"action\":[\"style\",\"-webkit-touch-callout: default !important; -webkit-user-select: text !important; -moz-user-select: text !important; -ms-user-select: text !important; user-select: text !important;\"]}"],["{\"selector\":\".post-body\",\"action\":[\"style\",\"-webkit-user-select: text !important; -moz-user-select: text !important; -ms-user-select: text !important; user-select: text !important;\"]}"],["{\"selector\":\".hiddenRanking\",\"action\":[\"style\",\"text-shadow: none !important; color: #6c757d !important;\"]}","{\"selector\":\"[_ngcontent-serverapp-c134]\",\"action\":[\"style\",\"text-shadow: none !important; color: #000 !important;\"]}","{\"selector\":\"[_ngcontent-serverapp-c135]\",\"action\":[\"style\",\"text-shadow: none !important; color: #000 !important;\"]}","{\"selector\":\"[href*=\\\"/meet\\\"]\",\"action\":[\"style\",\"text-shadow: none !important; color: #8b0000 !important;\"]}","{\"selector\":\"[href*=\\\"/result\\\"]\",\"action\":[\"style\",\"text-shadow: none !important; color: #8b0000 !important;\"]}","{\"selector\":\"[ngbtooltip]\",\"action\":[\"style\",\"text-shadow: none !important; color: #6c757d !important;\"]}"],["{\"selector\":\"#lightbox-wrap img\",\"action\":[\"style\",\"pointer-events: auto !important\"]}","{\"selector\":\"[class*=\\\"ImageElement-blockPointerEvents-\\\"]\",\"action\":[\"style\",\"pointer-events: auto !important\"]}","{\"selector\":\"[class*=\\\"Module-blockGridPointerEvents-\\\"] .grid__item-image\",\"action\":[\"style\",\"pointer-events: auto !important\"]}"],["{\"selector\":\"a:hover\",\"action\":[\"style\",\"cursor: auto!important;\"]}","{\"selector\":\"body\",\"action\":[\"style\",\"cursor: auto!important;\"]}"],["{\"selector\":\"*\",\"action\":[\"style\",\"cursor:unset!important;user-select:unset!important\"]}"],["{\"selector\":\"body\",\"action\":[\"style\",\"overflow: auto !important; padding-right: 0 !important;\"]}"],["{\"selector\":\"ins.adsbygoogle\",\"action\":[\"style\",\"visibility: hidden !important;\"]}"],["{\"selector\":\"*\",\"action\":[\"style\",\"-webkit-touch-callout: default!important;-webkit-user-select: auto!important;-moz-user-select: auto!important;user-select: auto!important;\"]}"],["{\"selector\":\".post-body\",\"action\":[\"style\",\"-webkit-touch-callout: default !important; -webkit-user-select: text !important;-moz-user-select: text !important;-ms-user-select: text !important;user-select: text !important;\"]}"],["{\"selector\":\".blocked .text\",\"action\":[\"style\",\"filter: none!important;-webkit-filter: none!important;\"]}","{\"selector\":\".blocked\",\"action\":[\"style\",\"filter: none !important;\"]}"],["{\"selector\":\"body *\",\"action\":[\"style\",\"user-select: unset !important\"]}"],["{\"selector\":\"*::-webkit-scrollbar\",\"action\":[\"style\",\"height: 14px !important; width: 14px !important;\"]}","{\"selector\":\"*::-webkit-scrollbar-button\",\"action\":[\"style\",\"border-color: #A6A6A6 !important; border-style: solid !important; height:16px !important; width: 16px !important;\"]}","{\"selector\":\"*::-webkit-scrollbar-thumb\",\"action\":[\"style\",\"background: #A6A6A6 !important;\"]}","{\"selector\":\":root\",\"action\":[\"style\",\"scrollbar-color: revert !important; scrollbar-width: auto !important;\"]}"],["{\"selector\":\"#main-content > .container\",\"action\":[\"style\",\"padding-top: 20px !important;\"]}","{\"selector\":\".o-header, .project-header-actions\",\"action\":[\"style\",\"position: initial !important;\"]}","{\"selector\":\"main[class^=\\\"o-content\\\"]\",\"action\":[\"style\",\"top: 0px !important;\"]}"],["{\"selector\":\".result-snippet\",\"action\":[\"style\",\"-webkit-touch-callout: default !important; -webkit-user-select: text !important;-moz-user-select: text !important;-ms-user-select: text !important;user-select: text !important;\"]}"],["{\"selector\":\"body, div, p, span, a, h1, h2, h3, h4, h5, h6\",\"action\":[\"style\",\"-webkit-touch-callout: default !important; -webkit-user-select: text !important; -moz-user-select: text !important; -ms-user-select: text !important; user-select: text !important\"]}"],["{\"selector\":\"body[style^=\\\"cursor:pointer\\\"]\",\"action\":[\"style\",\"cursor: auto!important\"]}"],["{\"selector\":\".chapter-content3\",\"action\":[\"style\",\"-webkit-touch-callout: default !important; -webkit-user-select: text !important; -moz-user-select: text !important; -ms-user-select: text !important; user-select: text !important;\"]}"],["{\"selector\":\"div.Message.is-protected\",\"action\":[\"style\",\"-webkit-touch-callout: default !important; -webkit-user-select: text !important; -moz-user-select: text !important; -ms-user-select: text !important; user-select: text !important;\"]}"],["{\"selector\":\"#description\",\"action\":[\"style\",\"user-select: initial !important;\"]}"],["{\"selector\":\".atomsPartialLinkLink\",\"action\":[\"style\",\"user-select: text !important;\"]}"],["{\"selector\":\"body *\",\"action\":[\"style\",\"-webkit-user-select: auto !important; -moz-user-select: auto !important; -ms-user-select: auto !important; user-select: auto !important;\"]}"],["{\"selector\":\"*\",\"action\":[\"style\",\"-webkit-touch-callout:default!important; -webkit-user-select:text!important; -moz-user-select:text!important; -ms-user-select:text!important; user-select:text!important;\"]}"],["{\"selector\":\"section.lyric_lyric\",\"action\":[\"style\",\"user-select: text !important; -webkit-user-select: text !important; -moz-user-select: text !important; -khtml-user-select: text !important; -webkit-user-drag: auto !important; -khtml-user-drag: auto !important; -webkit-touch-callout: auto !important; -moz-touch-callout: auto !important;\"]}"],["{\"selector\":\".adsbygoogle\",\"action\":[\"style\",\"max-height: 1px !important;left:-9999px !important;position:absolute !important\"]}"],["{\"selector\":\"body\",\"action\":[\"style\",\"-moz-user-select: text !important; -ms-user-select: text !important; user-select: text !important;\"]}"],["{\"selector\":\"#ad_box\",\"action\":[\"style\",\"height: 50px !important;\"]}"],["{\"selector\":\".body--prevent-scroll\",\"action\":[\"style\",\"overflow: auto !important;\"]}"]];

const hostnamesMap = new Map([["g37.com.br",0],["ne10.uol.com.br",0],["peekme.cc",0],["labs.j-novel.club",[0,23]],["uemeds.cn",0],["wjx.cn",0],["turbo1.co",0],["adnan-tech.com",0],["read.amazon.com",0],["music.apple.com",[0,34]],["arlinadzgn.com",0],["bike-parts-sym.com",0],["bingotingo.com",0],["bisablog.com",0],["bloggerspice.com",0],["flash-firmware.blogspot.com",0],["insurance-corporate.blogspot.com",0],["librospreuniversitariospdf.blogspot.com",0],["marfilius.blogspot.com",0],["tahmial.blogspot.com",0],["walkthrough-indo.blogspot.com",0],["whowantstuffs.blogspot.com",0],["www-daftarharga.blogspot.com",0],["zeeebatch.blogspot.com",0],["bumigemilang.com",[0,23]],["cafago.com",0],["celtadigital.com",0],["cintateknologi.com",0],["ciweimao.com",0],["convenienza.com",0],["deseneledublate.com",0],["edailybuzz.com",[0,32]],["elahmad.com",0],["erexams.com",0],["everydaynewinfo.com",0],["exclusifvoyages.com",0],["flinsetyadi.com",0],["flipmsg.com",0],["gamezop.com",0],["gaypornmasters.com",0],["gaypornwave.com",0],["geeksoncoffee.com",0],["ggulpass.com",0],["gooyaabitemplates.com",0],["habuteru.com",0],["hienzo.com",0],["hollywoodmask.com",0],["hongxiu.com",0],["ideaberita.com",0],["igniel.com",0],["download.ipeenk.com",0],["jootc.com",0],["kooora4livs.com",0],["langitmovie.com",0],["digital.lasegunda.com",0],["lightnovelpub.com",0],["loveplay123.com",0],["magelang1337.com",0],["mainframestechhelp.com",0],["bbs.mihoyo.com",0],["minecraftquiz.com",0],["movieston.com",0],["musicindustryhowto.com",0],["myhtebooks.com",0],["nana-music.com",0],["nandedbazaar.com",0],["blog.naver.com",0],["cafe.naver.com",0],["novelpia.com",0],["novelpub.com",0],["nullphpscript.com",0],["objectivequiz.com",0],["oceanof-games.com",0],["outidesigoto.com",0],["panda-novel.com",0],["picallow.com",0],["polskacanada.com",0],["psychologiazycia.com",0],["pvstreams.com",0],["qiangwaikan.com",0],["qidian.com",0],["readnovel.com",0],["repack-games.com",0],["rodude.com",0],["sachonthi.com",0],["satcesc.com",0],["scarysymptoms.com",[0,43]],["selfstudyhistory.com",0],["seotechman.com",[0,32]],["snbc13.com",0],["software-on.com",[0,32]],["sogou.com",0],["sqlserveregitimleri.com",0],["sysnettechsolutions.com",0],["techdracula.com",0],["th-world.com",0],["thegearhunt.com",0],["themes-dl.com",0],["thenekodark.com",0],["tiktok.com",0],["tritinia.com",0],["ukrainashop.com",0],["uslsoftware.com",0],["utamap.com",0],["vedantu.com",0],["webnovelpub.com",0],["wouterplanet.com",0],["yamibo.com",0],["yhocdata.com",0],["book.zongheng.com",0],["autophorie.de",0],["klartext-ne.de",[0,1]],["suedkurier.de",0],["androidtvbox.eu",0],["cambiarevita.eu",0],["cespun.eu",0],["jpopsingles.eu",0],["world4.eu",[0,32]],["zdravenportal.eu",0],["doranobi-fansub.id",0],["blisseyhusband.in",0],["rawneix.in",[0,148]],["timeforbitco.in",0],["bagaglioamano.io",0],["significatocanzoni.it",0],["starbene.it",0],["youmath.it",0],["news24.jp",0],["riie.jp",0],["ufret.jp",0],["sekaikomik.live",0],["bianity.net",0],["blog.csdn.net",0],["gsmfirmware.net",0],["kooora4lives.net",0],["ntvspor.net",0],["pixnet.net",0],["unikampus.net",0],["wpchen.net",0],["aileen-novel.online",0],["audiologyresearch.org",0],["funivie.org",0],["readm.org",0],["thezealots.org",0],["dddance.party",0],["boop.pl",0],["invado.pl",0],["koszalincity.pl",0],["adpres.ro",0],["clubulbebelusilor.ro",0],["cristelageorgescu.ro",0],["csid.ro",0],["delicateseliterare.ro",0],["epitesti.ro",0],["lataifas.ro",0],["psihologiadeazi.ro",0],["stiridinromania.ro",0],["terramirabilis.ro",[0,1]],["poli-vsp.ru",0],["polyvsp.ru",0],["mio.to",0],["wjx.top",0],["iptvromania.ro",[1,81]],["tv.bdix.app",2],["karsaz-law.com",2],["teachoo.com",2],["topperlearning.com",2],["videocardz.com",2],["classnotes.org.in",2],["rds.live",2],["partsnl.nl",2],["androidmakale.com",4],["bolugundem.com",4],["citpekalongan.com",4],["displayspecifications.com",4],["gdrivedescarga.com",4],["informagiovani-italia.com",4],["joysound.com",4],["raccontivietati.com",4],["raqmedia.com",4],["runmods.com",4],["smartkhabrinews.com",4],["tanya-tanya.com",4],["tohkaishimpo.com",4],["visaonoticias.com",4],["tfp.is",4],["daily-tohoku.news",4],["fizyka.org",4],["hitcena.pl",4],["workhouses.org.uk",4],["hockeylion.ca",8],["justcloseoutscanada.ca",8],["bwpsales.com",8],["detroitmodular.com",8],["fitnessav.com",8],["fwrd.com",8],["glasses.com",8],["gronkfitnessproducts.com",8],["kitchentime.com",8],["lakshmistores.com",8],["magnumboots.com",8],["metrocheese.com",8],["pitviper.com",8],["pv-magazine-australia.com",8],["pv-magazine-brasil.com",8],["pv-magazine-latam.com",8],["pv-magazine-mexico.com",8],["pv-magazine-usa.com",8],["revolve.com",8],["revolvermag.com",[8,49]],["treblezine.com",8],["vat19.com",8],["wilcooffroad.com",8],["worldcrunch.com",[8,27]],["kitchentime.de",8],["kitchentime.dk",8],["kitchentime.fi",8],["kitchentime.no",8],["olaproducts.co.nz",8],["kitchentime.se",8],["fritz.ai",9],["blog.inkdrop.app",9],["blog.dp6.com.br",9],["uxdesign.cc",9],["atrium.co",9],["newco.co",9],["thecontrol.co",9],["unpatent.co",9],["backstage.1blocker.com",9],["500ish.com",9],["tech.ahrefs.com",9],["artplusmarketing.com",9],["backchannel.com",9],["badootech.badoo.com",9],["baharudinyusuf.com",9],["bitcointechtalk.com",9],["bitwarden.com",9],["bluerockpublicradio.com",9],["boomsupersonic.com",9],["bradfieldcs.com",9],["brightthemag.com",9],["tech.buzzfeed.com",9],["blog.canopas.com",9],["blog.coinbase.com",9],["blog.confiant.com",9],["dave-bailey.com",9],["discordapp.com",9],["doist.com",9],["doit-intl.com",9],["doublepulsar.com",9],["economist.com",9],["electricliterature.com",9],["elidourado.com",9],["getadblock.com",9],["levelup.gitconnected.com",9],["greylock.com",9],["blog.growthhackers.com",9],["headmelted.com",9],["helium.com",9],["blog.hiri.com",9],["howwegettonext.com",9],["iheart.com",9],["injusticetoday.com",9],["insightdatascience.com",9],["itsyourturnblog.com",9],["kiwi.com",9],["learngoprogramming.com",9],["learningbyshipping.com",9],["ledwards.com",9],["legalist.com",9],["broadcast.listennotes.com",9],["logrocket.com",9],["blog.ltse.com",9],["mapbox.com",9],["medium.com",9],["melmagazine.com",9],["mondaynote.com",9],["open.nytimes.com",9],["nyulocal.com",9],["ofdollarsanddata.com",9],["postlight.com",9],["proandroiddev.com",9],["signalvnoise.com",9],["slackhq.com",9],["news.smugmug.com",9],["springboard.com",9],["startupsventurecapital.com",9],["theawl.com",9],["thebigroundtable.com",9],["thebillfold.com",9],["thebolditalic.com",9],["theringer.com",9],["thriveglobal.com",9],["timeline.com",9],["towardsdatascience.com",9],["udacity.com",9],["usejournal.com",9],["warisboring.com",9],["wearemel.com",9],["whatahowler.com",9],["writingcooperative.com",9],["x.company",9],["slack.engineering",9],["blog.angular.io",9],["blog.bitsrc.io",9],["bolt.io",9],["codeburst.io",9],["fossa.io",9],["itnext.io",9],["okmeter.io",9],["javascript.plainenglish.io",9],["prototypr.io",9],["rainway.io",9],["stoplight.io",9],["theabacus.io",9],["blog.waffle.io",9],["coach.me",9],["citizen428.net",9],["dotandline.net",9],["keepingstock.net",9],["esciencecenter.nl",9],["thetaoist.online",9],["checkio.org",9],["blog.devcolor.org",9],["freecodecamp.org",9],["iota.org",9],["jupyter.org",9],["sagefy.org",9],["standardnotes.org",9],["blog.statebox.org",9],["thinkprogress.org",9],["uxplanet.org",9],["faun.pub",9],["blog.twitch.tv",9],["calvinklein.at",10],["italianluxurygroup.com.au",10],["calvinklein.be",10],["calvinklein.bg",10],["clubhouseforchefs.ca",10],["deskhero.ca",10],["frontrunners.ca",10],["journeys.ca",10],["massivetoyblowout.ca",10],["trutone.ca",10],["tsc.ca",10],["tweeters.ca",10],["calvinklein.ch",10],["animalchannel.co",10],["decrypt.co",10],["homehacks.co",10],["parentingisnteasy.co",10],["relieved.co",10],["seeitlive.co",10],["spotlightstories.co",10],["sweetandsavory.co",10],["6sqft.com",10],["atlasobscura.com",[10,38]],["authenticoilco.com",10],["bankbazaar.com",10],["build.com",10],["businesstraveller.com",10],["calvinklein.com",10],["cars.com",10],["coinbase.com",10],["dailyvoice.com",10],["delish.com",10],["dell.com",10],["dgmlive.com",10],["esquire.com",10],["flovitamins.com",10],["foliosociety.com",10],["fredmeyer.com",10],["generalpants.com",10],["globoshoes.com",10],["goodhousekeeping.com",10],["harborfreight.com",10],["headphonebar.com",10],["investors.com",10],["jessicabryson.com",10],["jolinne.com",10],["kftv.com",10],["lazycatkitchen.com",10],["leevalley.com",10],["levi.com",10],["shop.libbey.com",10],["lilysilk.com",10],["littleburgundyshoes.com",10],["lull.com",10],["mashable.com",10],["monarchmoney.com",10],["nationalgeographic.com",10],["otterbox.com",10],["overstock.com",10],["pbteen.com",10],["publiclands.com",10],["pulseuniform.com",10],["www.razer.com",10],["ringkestore.com",10],["saksfifthavenue.com",10],["snopes.com",10],["sportskeeda.com",10],["stylewe.com",10],["szucstermekek.com",10],["temu.com",10],["upworthy.com",10],["vitaminworld.com",10],["wafuu.com",10],["williams-sonoma.com",10],["zumub.com",10],["calvinklein.cz",10],["calvinklein.de",10],["geizdental.de",10],["calvinklein.dk",10],["health.harvard.edu",10],["calvinklein.ee",10],["calvinklein.es",10],["calvinklein.fi",10],["calvinklein.fr",10],["calvinklein.hr",10],["calvinklein.hu",10],["calvinklein.ie",10],["calvinklein.it",10],["calvinklein.lt",10],["calvinklein.lu",10],["calvinklein.lv",10],["calvinklein.nl",10],["apotekfordeg.no",10],["drinkspy.co.nz",10],["thebfd.co.nz",10],["tradedepot.co.nz",10],["berkeleyearth.org",10],["shop.pbs.org",10],["scetv.org",10],["yesmagazine.org",10],["calvinklein.pl",10],["calvinklein.pt",10],["calvinklein.ru",10],["calvinklein.se",10],["calvinklein.si",10],["calvinklein.sk",10],["calvinklein.co.uk",10],["fruugo.co.uk",10],["sainsburysmagazine.co.uk",10],["tiedex.co.uk",10],["vol.at",11],["allbirds.com.au",12],["digital4.biz",12],["bucketlistly.blog",12],["networldsports.ca",12],["niagarafallsreview.ca",12],["racketsandrunners.ca",12],["stcatharinesstandard.ca",12],["toysrus.ca",12],["wellandtribune.ca",12],["swissinfo.ch",12],["404media.co",12],["ello.co",12],["abeka.com",12],["allbirds.com",12],["americastestkitchen.com",12],["apnews.com",12],["ardene.com",12],["atelierskn.com",12],["bedbathandbeyond.com",12],["biglots.com",12],["brandingmag.com",12],["breakingenergy.com",12],["brighteon.com",[12,44]],["broadbandbreakfast.com",12],["bygonely.com",12],["carsalesbase.com",12],["contiki.com",12],["cryptobriefing.com",12],["dailytarheel.com",12],["dollartree.com",12],["dsw.com",12],["elimento.com",12],["everyday-reading.com",12],["foreignaffairs.com",[12,75]],["freshbooks.com",12],["fxstreet.com",12],["gwr.com",12],["heraldnet.com",12],["hiddenvalley.com",12],["historiccity.com",12],["history.com",12],["hollywoodunlocked.com",12],["humankinetics.com",12],["idsnews.com",12],["impulkits.com",12],["inquirer.com",12],["ipowerqueen.com",12],["jewishinsider.com",12],["justthenews.com",12],["latina.com",12],["liamodell.com",12],["linenbee.com",12],["logitech.com",12],["mediadump.com",12],["www.microsoft.com",12],["milwaukeetool.com",12],["modesens.com",12],["mountainwarehouse.com",12],["musclecarsandtrucks.com",12],["nimsdai.com",12],["njbiz.com",12],["numero.com",12],["ohsweetbasil.com",12],["palestinechronicle.com",12],["parent.com",12],["petri.com",12],["psychcentral.com",12],["pushmycart.com",12],["readtangle.com",12],["recyclingproductnews.com",12],["scientificamerican.com",12],["scottishlegal.com",12],["securityweek.com",12],["shutterfly.com",12],["soundproofcow.com",12],["staradvertiser.com",12],["statista.com",12],["statnews.com",12],["staygenerator.com",12],["summitracing.com",12],["sweetteacaviar.com",12],["syfy.com",12],["theepochtimes.com",[12,14]],["thehill.com",12],["thepeterboroughexaminer.com",12],["therecord.com",12],["thespec.com",12],["travelcaffeine.com",12],["vallejosun.com",12],["vargooutdoors.com",12],["vernyx.com",12],["cube-magazin.de",12],["rktbns.de",12],["bitcoinke.io",12],["pagamentidigitali.it",12],["aihome.com.my",12],["snackstack.net",12],["tapinto.net",12],["newsnationnow",12],["allbirds.co.nz",12],["ballantynes.co.nz",12],["torpedo7.co.nz",12],["thepetslife.online",12],["envol-vert.org",12],["hcn.org",12],["knowablemagazine.org",[12,49]],["skepchick.org",12],["spotlightpa.org",12],["partsinmotion.co.uk",12],["simmiwoman.co.uk",12],["spring.org.uk",12],["dispatchlive.co.za",12],["heraldlive.co.za",12],["australiangolfdigest.com.au",13],["thecanary.co",13],["alexandracooks.com",13],["artificialintelligence-news.com",13],["chillamo.com",13],["christianstandard.com",13],["coloradotimesrecorder.com",13],["dailynewsegypt.com",13],["daphneoz.com",13],["eletric-vehicles.com",13],["fandomwire.com",13],["hdwalle.com",13],["hypebot.com",13],["megacatstudios.com",13],["moneymagpie.com",13],["prepinsta.com",13],["socialitelife.com",13],["thefreethoughtproject.com",13],["thurrott.com",13],["ubitennis.com",13],["zerobreeze.com",13],["fatgirlskinny.net",13],["otisoatmilk.co.nz",13],["childrenshealthdefense.org",13],["matomo.org",13],["scholarlykitchen.sspnet.org",13],["verdadeiroolhar.pt",13],["bandt.com.au",14],["nieuwsblad.be",14],["theblock.co",14],["thecradle.co",14],["artnet.com",14],["audioholics.com",14],["auepaisagismo.com",14],["auepaisajismo.com",14],["ba-bamail.com",14],["babylonbee.com",14],["bellhelmets.com",14],["bibleportal.com",14],["bongino.com",14],["boredpanda.com",14],["braziljournal.com",14],["cityandstateny.com",14],["curiocity.com",14],["dispatch.com",14],["fermatslibrary.com",14],["greatist.com",14],["humanevents.com",14],["insauga.com",14],["law.com",14],["lensculture.com",14],["media4growth.com",14],["moneycontrol.com",14],["moroccoworldnews.com",14],["nycgo.com",14],["omr.com",14],["patch.com",14],["personality-database.com",14],["playpilot.com",14],["prowritingaid.com",14],["softwaretestinghelp.com",14],["theconversation.com",14],["thepostmillennial.com",14],["uinterview.com",14],["vedbex.com",14],["vegnews.com",14],["wateronline.com",14],["worlddogfinder.com",14],["zorbabooks.com",14],["kauppalehti.fi",14],["talouselama.fi",14],["tekniikkatalous.fi",14],["tivi.fi",14],["uusisuomi.fi",14],["magiclen.org",14],["projectcbd.org",14],["informatykzakladowy.pl",14],["pbsamerica.co.uk",14],["sportando.basketball",15],["novelism.jp",15],["nsfw247.biz",16],["aulete.com.br",17],["diariodaregiao.com.br",18],["jornaljoca.com.br",19],["visse.com.br",19],["plural.jor.br",19],["javsubtitle.co",19],["afrikmag.com",19],["alphagirlreviews.com",19],["aprendeinglessila.com",19],["arcanescans.com",19],["bigdatauni.com",19],["clockks.com",19],["codedosa.com",19],["cracksone.com",19],["cyberkrafttraining.com",19],["drkrok.com",19],["filmzone.com",19],["flashdumpfiles.com",19],["formatatmak.com",19],["getective.com",19],["globaldefensecorp.com",19],["gossipnextdoor.com",19],["hayatbilgileri.com",[19,82]],["hellokpop.com",19],["hiraethtranslation.com",19],["ieltsliz.com",19],["immobiliaremia.com",19],["iptv4best.com",19],["jbjbgame.com",19],["kapitalis.com",19],["kitchennovel.com",19],["koalasplayground.com",19],["learninsta.com",19],["liveyourmaths.com",19],["moneyexcel.com",19],["ncert-solutions.com",19],["home.novel-gate.com",19],["placementstore.com",19],["poolpiscina.com",19],["riwyat.com",19],["samsungtechwin.com",19],["sinhasannews.com",19],["tech-recipes.com",19],["tempatwisataseru.com",19],["theaircurrent.com",19],["tipssehatcantik.com",19],["viatasisanatate.com",19],["wikiofcelebs.com",19],["winmeen.com",19],["rozbor-dila.cz",19],["neuroteam-metz.de",19],["newspao.gr",19],["viewsofgreece.gr",19],["ncertsolutions.guru",19],["tiempo.hn",19],["rukim.id",19],["ibps.in",19],["colegiosconcertados.info",19],["coffeeapps.ir",19],["infodifesa.it",19],["anime-drama.jp",19],["mediahiburan.my",19],["cours-de-droit.net",19],["nocturnetls.net",19],["programasvirtualespc.net",19],["onlineonderdelenshop.nl",19],["day-hoc.org",19],["licensekeys.org",19],["postcourier.com.pg",[19,43]],["blogvisaodemercado.pt",19],["ananda-yoga.ro",19],["pitesti24.ro",19],["visefierbinti.ro",19],["voxvalachorum.ro",19],["ziarulargesul.ro",19],["kaystls.site",19],["kicknews.today",19],["primicia.com.ve",19],["maduras.vip",19],["media.framu.world",19],["hardcoregames.ca",20],["teamkong.tk",20],["lapresse.ca",21],["beckershospitalreview.com",21],["tietoevry.com",21],["trip.com",21],["ionos.de",21],["rakentaja.fi",21],["jumia.ci",22],["mofi.com",22],["jumia.dz",22],["jumia.com.eg",22],["jumia.com.gh",22],["jumia.co.ke",22],["jumia.ma",22],["jumia.com.ng",22],["jumia.sn",22],["jumia.com.tn",22],["jumia.ug",22],["activationkeys.co",24],["dialectsarchive.com",24],["capx.co",25],["nfltraderumors.co",26],["answersafrica.com",26],["musixmatch.com",26],["practicetestgeeks.com",26],["sigma4pc.com",26],["ilturista.info",26],["jobsbotswana.info",26],["yeane.org",26],["mbahhanif.site",26],["thedisconnect.co",27],["7misr4day.com",28],["raindropteamfan.com",28],["senpaiediciones.com",28],["audiotools.in",28],["acupoffrench.com",29],["novelza.com",29],["allrecipes.com",30],["expatexplore.com",30],["fcw.com",30],["fine-day.com",30],["foodandwine.com",30],["forbestravelguide.com",30],["frontofficesports.com",30],["gcn.com",30],["investopedia.com",30],["lonelyplanet.com",30],["seriouseats.com",30],["shape.com",30],["simplyrecipes.com",30],["southernliving.com",30],["thebaffler.com",[30,129]],["thespruceeats.com",30],["travelandleisure.com",30],["tripsavvy.com",30],["tsunagujapan.com",30],["vadimkravcenko.com",30],["verybestbaking.com",30],["verywellhealth.com",30],["verywellmind.com",30],["washingtontechnology.com",30],["posylka.de",30],["oneesports.gg",30],["android1pro.com",31],["novelasligera.com",31],["geotips.net",31],["hulnews.top",[31,32]],["androidacy.com",32],["boke112.com",32],["darktranslation.com",32],["festival-cannes.com",32],["indiatimes.com",32],["la8osapofash.com",32],["tepat.id",32],["bigulnews.tv",32],["androidmtk.com",33],["appofmirror.com",35],["arcade1up.com",36],["artstation.com",37],["audiobookcup.com",39],["aulart.com",40],["autoblog.com",41],["aviationweek.com",42],["awebstories.com",43],["kpopjjang.com",43],["wenku.baidu.com",44],["protocol.com",44],["liga.net",44],["bemoneyaware.com",45],["launer.com",45],["newrepublic.com",45],["rebelnews.com",45],["ftm.eu",45],["blogpascher.com",46],["mskmangaz.blogspot.com",47],["bookbub.com",48],["breakingdefense.com",49],["brooklyneagle.com",50],["buondua.com",51],["businessemailetiquette.com",52],["programegratuitepc.com",52],["qualityfilehosting.com",52],["sabishiidesu.com",52],["techtrickseo.com",52],["audioreview.m1001.coreserver.jp",52],["republicadecuritiba.net",52],["newsbook.pl",52],["gay69.stream",52],["chowhound.com",53],["foreignpolicy.com",53],["cnn.com",54],["milenio.com",54],["cjr.org",54],["coub.com",55],["crunchyroll.com",56],["daimangajiten.com",57],["dallasnews.com",58],["datadikdasmen.com",59],["malasngeblog.com",59],["digicular.com",60],["dollarvr.com",61],["gagetmatome.com",61],["husseinezzat.com",61],["kimkazandi.com",61],["lofter.com",61],["poipiku.com",61],["readawrite.com",61],["savoriurbane.com",61],["tinyppt.com",61],["two9success.com",61],["velicu.eu",61],["newsme.gr",61],["verselemzes.hu",61],["panorama.it",61],["pehawe.me",61],["sdewery.me",61],["revistasufletului.net",61],["canondrivers.org",61],["arenavalceana.ro",61],["descopera.ro",61],["dreamstime.com",62],["droidtekno.com",63],["ef.com",64],["elsalvadorsurfrealestate.com",65],["enotes.com",66],["enttechub.com",67],["esscctv.com",68],["evreporter.com",69],["experts-exchange.com",70],["fantricks.com",71],["fictionpress.com",72],["fanfiction.net",72],["firmwarefile.com",73],["forbes.com",74],["forward.com",76],["geopoliticalmonitor.com",76],["glassblocktint.com",76],["matadornetwork.com",76],["monroenews.com",76],["nationalobserver.com",76],["poconorecord.com",76],["shoppingsouthparkmall.com",76],["vice.com",76],["washingtontimes.com",76],["forsvaretsforum.no",76],["npr.org",76],["thebulletin.org",76],["fraudnavi.com",77],["genesistls.com",78],["getlatka.com",79],["groundies.com",80],["guidingliterature.com",81],["pap.pl",81],["anascrie.ro",81],["healthitsecurity.com",83],["hindi-gk.com",84],["livetennis.it",84],["ilife97.com",85],["imaginetricks.com",86],["indeed.com",87],["independentmail.com",88],["northjersey.com",88],["usatoday.com",88],["insidesources.com",89],["instagram.com",90],["ipphone-warehouse.com",91],["playingfire.com",91],["zigya.com",91],["unic.com.vn",91],["kamerabudaya.com",92],["kangkimin.com",93],["myschool-eng.com",93],["orangespotlight.com",93],["sinau-thewe.com",93],["katzen-fieber.de",93],["isikuota.co.id",93],["athletic.net",[93,160]],["clujust.ro",93],["kbdfans.com",94],["mountaintopwebdesign.com",94],["thethaiger.com",94],["studyflix.de",94],["kijyomatome-ch.com",95],["lamusica.com",96],["lectortmo.com",97],["warungkomik.com",97],["livemint.com",98],["liveroger.com",99],["mbt-store.com",100],["mercurynews.com",101],["neobux.com",102],["nytimes.com",[103,104]],["trucksbook.eu",103],["otomobilgunluklerim.com",105],["pcipolicyportal.com",106],["publish0x.com",106],["thetruthaboutcars.com",106],["reclaimthenet.org",106],["prompthero.com",107],["proxfree.com",108],["quizlet.com",109],["quora.com",110],["quotev.com",111],["the-masters-voice.com",[111,128]],["relet365.com",112],["revouninstaller.com",113],["romprovider.com",114],["safirsoft.com",115],["chan.sankakucomplex.com",116],["sanspo.com",117],["selfstudyanthro.com",118],["shaalaa.com",119],["social-unlock.com",120],["socialblade.com",121],["community.spiceworks.com",122],["substack.com",123],["taufiqhdyt.com",124],["teamaretuza.com",125],["techgyd.com",126],["techopedia.com",127],["opportunitydesk.org",[128,173]],["thefp.com",130],["theintercept.com",131],["therealdeal.com",132],["truyenbanquyen.com",133],["tuta.com",134],["twitter.com",135],["x.com",135],["utaten.com",136],["venturebeat.com",137],["volokit2.com",138],["wikibious.com",139],["zenith-watches.com",140],["airbnb.de",141],["hansa-online.de",142],["justspices.de",143],["allocine.fr",144],["cheatsquad.gg",145],["trakteer.id",146],["edurev.in",147],["ncrtsolutions.in",147],["wormate.io",149],["with.is",150],["iwanichi.co.jp",151],["logicool.co.jp",152],["oricon.co.jp",153],["video.tv-tokyo.co.jp",154],["hibiki-radio.jp",155],["katosatoshi.jp",156],["livedays.jp",157],["gamegame.kr",158],["ahzaa.net",159],["behance.net",161],["bimiacg.net",162],["brokensilenze.net",163],["cataz.net",164],["cyanlabs.net",165],["gnt24365.net",166],["kurazone.net",167],["context.reverso.net",168],["streambuddy.net",169],["tv2.no",170],["01.org",171],["ecosia.org",172],["payskip.org",174],["readlightnovel.org",175],["web.telegram.org",176],["zelka.org",177],["pl",178],["odoserwis.pl",179],["projektowanie-wnetrz-online.pl",180],["linkco.re",181],["curs-valutar-bnr.ro",182],["evz.ro",183],["zunda.site",184],["abema.tv",185]]);

const entitiesMap = new Map([["123movies",0],["depedlps",0],["fmovies",0],["gomovies",0],["irisbuddies",0],["magesypro",0],["mangatoon",0],["otakudesu",0],["tabonitobrasil",0],["daotranslate",[1,2]],["dostfilms",3],["kimovil",3],["dramacute",4],["google",5],["lightnovelworld",6],["pinterest",7],["pv-magazine",8]]);

const exceptionsMap = new Map(undefined);

self.declarativeImports = self.declarativeImports || [];
self.declarativeImports.push({ argsList, hostnamesMap, entitiesMap, exceptionsMap });

/******************************************************************************/

})();

/******************************************************************************/
