/*******************************************************************************

    uBlock Origin Lite - a comprehensive, MV3-compliant content blocker
    Copyright (C) 2014-present Raymond Hill

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see {http://www.gnu.org/licenses/}.

    Home: https://github.com/gorhill/uBlock
*/

/* jshint esversion:11 */

'use strict';

// ruleset: default

/******************************************************************************/

// Important!
// Isolate from global scope
(function uBOL_cssDeclarativeImport() {

/******************************************************************************/

const argsList = [["{\"selector\":\"span[id^=\\\"img_\\\"][class^=\\\"img_\\\"] > div[style=\\\"display: flex; justify-content: center; align-items: center; position: relative;\\\"] > iframe[src][marginwidth][width][style]\",\"action\":[\"style\",\"height: 0 !important; overflow: hidden !important;\"]}"],["{\"selector\":\"body\",\"action\":[\"style\",\"overflow: auto !important\"]}"],["{\"selector\":\"#content-embed\",\"action\":[\"style\",\"display: block!important\"]}"],["{\"selector\":\"[id=\\\"colunas\\\"]\",\"action\":[\"style\",\"display: block !important;\"]}"],["{\"selector\":\"#wpsafe-generate, #wpsafe-link\",\"action\":[\"style\",\"display: block !important;\"]}"],["{\"selector\":\"#download_link\",\"action\":[\"style\",\"display: block !important;\"]}"],["{\"selector\":\"iframe[id^=\\\"google_ads_iframe_/\\\"], div[id^=\\\"adm-container-\\\"]\",\"action\":[\"style\",\"clip-path: circle(0) !important;\"]}"],["{\"selector\":\"body.pageskin\",\"action\":[\"style\",\"margin-top: 0px !important;\"]}"],["{\"selector\":\".footerLink.hidden\",\"action\":[\"style\",\"display: block !important;\"]}"],["{\"selector\":\"[id^=\\\"sas_\\\"]\",\"action\":[\"style\",\"height: 1px !important\"]}"],["{\"selector\":\"body.modal-open\",\"action\":[\"style\",\"overflow: auto!important\"]}"],["{\"selector\":\"#container\",\"action\":[\"style\",\"width:100%!important\"]}","{\"selector\":\"html.can-have-sky .page-body > .section-content\",\"action\":[\"style\",\"margin-right: 0 !important;\"]}"],["{\"selector\":\".onp-sl-content\",\"action\":[\"style\",\"display: block !important;\"]}"],["{\"selector\":\".thumb-list > .video-thumb\",\"action\":[\"style\",\"margin-right: 0px !important;\"]}"],["{\"selector\":\"[style=\\\"display:none\\\"]\",\"action\":[\"style\",\"display: block !important;\"]}"],["{\"selector\":\"#adBanner\",\"action\":[\"style\",\"height:25px !important;left:-3000px !important;position:absolute !important\"]}"],["{\"selector\":\"input[value^=\\\"http\\\"]\",\"action\":[\"style\",\"width: 70% !important\"]}"],["{\"selector\":\"#list-eps\",\"action\":[\"style\",\"display:block!important\"]}"],["{\"selector\":\"body\",\"action\":[\"style\",\"overflow: auto !important;\"]}"],["{\"selector\":\"div#responseads\",\"action\":[\"style\",\"display:block !important\"]}"],["{\"selector\":\"#izobrazhenie-1\",\"action\":[\"style\",\"padding-bottom: 0px !important;\"]}","{\"selector\":\".group_viewport, .page__viewport\",\"action\":[\"style\",\"display: initial !important;\"]}"],["{\"selector\":\"#web\",\"action\":[\"style\",\"display: block !important;\"]}"],["{\"selector\":\"div.container\",\"action\":[\"style\",\"margin-top: 0px !important\"]}"],["{\"selector\":\"*\",\"action\":[\"style\",\"filter: none !important\"]}"],["{\"selector\":\"#playVideo\",\"action\":[\"style\",\"display: block !important; visibility: visible !important;\"]}","{\"selector\":\"#player_embed\",\"action\":[\"style\",\"display: block !important; visibility: visible !important;\"]}"],["{\"selector\":\".vjs-poster-onscreen\",\"action\":[\"style\",\"visibility: hidden !important;\"]}"],["{\"selector\":\".position-absolute\",\"action\":[\"style\",\"opacity: 0 !important;\"]}"],["{\"selector\":\"body\",\"action\":[\"style\",\"visibility:visible !important\"]}"],["{\"selector\":\".content.page.page-video .video-content > div[class] > div > div[class] > div[class][style^=\\\"background-image:\\\"]\",\"action\":[\"style\",\"background-image: none !important;\"]}"],["{\"selector\":\".jw-reset.jw-wrapper\",\"action\":[\"style\",\"z-index:2147483647 !important\"]}"],["{\"selector\":\"#timerContainer > div:not(:has(#timerPercentage))\",\"action\":[\"style\",\"display: flex !important;\"]}"],["{\"selector\":\"html\",\"action\":[\"style\",\"overflow: auto !important;\"]}"],["{\"selector\":\"#fafsf2\",\"action\":[\"style\",\"display:block !important\"]}"],["{\"selector\":\".sidebar-tabs-panels\",\"action\":[\"style\",\"max-height: 700px !important;\"]}"],["{\"selector\":\".subscribe-article .subscribe-truncate\",\"action\":[\"style\",\"max-height:unset!important;order:unset!important;\"]}","{\"selector\":\".subscribe-article .subscribe-truncate::before\",\"action\":[\"style\",\"background:none!important;\"]}","{\"selector\":\".subscribe-article .subscriber-hider\",\"action\":[\"style\",\"display:block!important\"]}"],["{\"selector\":\"._2gSkZ\",\"action\":[\"style\",\"height: 150px !important;\"]}","{\"selector\":\"header\",\"action\":[\"style\",\"top: 0 !important\"]}"],["{\"selector\":\".subscribe-truncate\",\"action\":[\"style\",\"order:0!important;max-height:inherit!important\"]}","{\"selector\":\".subscribe-truncate::before\",\"action\":[\"style\",\"background:none!important\"]}","{\"selector\":\".subscriber-hider\",\"action\":[\"style\",\"display:inherit!important\"]}"],["{\"selector\":\"#header-new\",\"action\":[\"style\",\"margin-top: 0px !important;\"]}"],["{\"selector\":\".page__content-header\",\"action\":[\"style\",\"height: 50px !important\"]}"],["{\"selector\":\"header#masthead\",\"action\":[\"style\",\"top: -110px !important;\"]}"],["{\"selector\":\".main-header\",\"action\":[\"style\",\"top: 0 !important\"]}"],["{\"selector\":\"#leading_video_player_autoplay_main_wrapper\",\"action\":[\"style\",\"display: block !important;\"]}"],["{\"selector\":\"#player\",\"action\":[\"style\",\"display:block !important\"]}"],["{\"selector\":\".adsbygoogle\",\"action\":[\"style\",\"max-height: 1px !important;\"]}"],["{\"selector\":\"#page-header > header\",\"action\":[\"style\",\"position: absolute !important;\"]}","{\"selector\":\"section#home > #hero.pinned\",\"action\":[\"style\",\"position: absolute !important;\"]}"],["{\"selector\":\"body\",\"action\":[\"style\",\"padding-top:0px !important\"]}"],["{\"selector\":\".css-1352p5e\",\"action\":[\"style\",\"height: 2400px !important;\"]}","{\"selector\":\".css-1s6rfoz\",\"action\":[\"style\",\"height: 2400px !important;\"]}","{\"selector\":\".css-1wm768n\",\"action\":[\"style\",\"height: 1560px !important;\"]}","{\"selector\":\".css-uc3mu7\",\"action\":[\"style\",\"margin-top: 0 !important; height: 2400px !important;\"]}","{\"selector\":\".gridRowPad\",\"action\":[\"style\",\"margin-top: 0 !important;\"]}"],["{\"selector\":\".fKZLNI\",\"action\":[\"style\",\"width:120% !important\"]}"],["{\"selector\":\"#wpsafe-generate, #wpsafe-link\",\"action\":[\"style\",\"display: block !important\"]}"],["{\"selector\":\"#tp-generate, [id^=\\\"tp-snp\\\"]\",\"action\":[\"style\",\"display: block !important\"]}"],["{\"selector\":\"#wpsafe-generate\",\"action\":[\"style\",\"display: block !important\"]}"],["{\"selector\":\"div[style=\\\"display: none;\\\"]\",\"action\":[\"style\",\"display: block !important;\"]}"],["{\"selector\":\"#wpsafe-link\",\"action\":[\"style\",\"display:block !important;\"]}"],["{\"selector\":\"form [id][style=\\\"display: none;\\\"]\",\"action\":[\"style\",\"display: block !important;\"]}","{\"selector\":\"form[id]\",\"action\":[\"style\",\"display: block !important;\"]}"],["{\"selector\":\".icon_animation samp\",\"action\":[\"style\",\"animation: none !important;\"]}"],["{\"selector\":\"#wpsafe-link\",\"action\":[\"style\",\"display: block !important;\"]}"],["{\"selector\":\"#btn6, #tp98\",\"action\":[\"style\",\"display: block !important;\"]}"],["{\"selector\":\"#toshowtrlink, #gtbtn2\",\"action\":[\"style\",\"display: block !important;\"]}"],["{\"selector\":\"#submitBtn, #go_d, #devozon-snp, #submitBtn, #tp-snp1, #go_d2\",\"action\":[\"style\",\"display: block !important;\"]}"],["{\"selector\":\".overflow-hidden\",\"action\":[\"style\",\"overflow: auto !important;\"]}"],["{\"selector\":\"#wpsafe-link, #section2\",\"action\":[\"style\",\"display: block !important;\"]}"],["{\"selector\":\"[id^=\\\"rewarded_ad_\\\"]:not(#rewarded_ad_blocker)\",\"action\":[\"style\",\"display: block !important; visibility: visible !important;\"]}"],["{\"selector\":\".advert-wrapper\",\"action\":[\"style\",\"clip-path: circle(0) !important;\"]}"],["{\"selector\":\".nav-bar\",\"action\":[\"style\",\"top:0px !important\"]}","{\"selector\":\"body:not(.skybox-loaded) .topnav\",\"action\":[\"style\",\"margin-top:0px !important\"]}"],["{\"selector\":\"#pageWrapper\",\"action\":[\"style\",\"display: initial !important;\"]}"],["{\"selector\":\"button\",\"action\":[\"style\",\"display: inline-block !important\"]}"],["{\"selector\":\".nav.sticky\",\"action\":[\"style\",\"top: 0px !important;\"]}"],["{\"selector\":\"body.modal-open *\",\"action\":[\"style\",\"filter: none!important;\"]}"],["{\"selector\":\"#wpsafe-generate, #wpsafelink-landing, #wpsafe-link\",\"action\":[\"style\",\"display: block !important;\"]}"],["{\"selector\":\".add-bx\",\"action\":[\"style\",\"height: 0px !important; min-height: 0px !important;\"]}"],["{\"selector\":\"body:not(.home) #content\",\"action\":[\"style\",\"margin-top: 13px !important;\"]}"],["{\"selector\":\"#link1s-snp\",\"action\":[\"style\",\"display:block!important\"]}"],["{\"selector\":\"#smspage\",\"action\":[\"style\",\"display: block !important;\"]}"],["{\"selector\":\".container\",\"action\":[\"style\",\"font-size: 0px !important;\"]}"],["{\"selector\":\".gooWidget\",\"action\":[\"style\",\"opacity: 0 !important; visibility: collapse !important;\"]}","{\"selector\":\".google-ad-leaderboard\",\"action\":[\"style\",\"opacity: 0 !important;\"]}","{\"selector\":\"[id^=\\\"adtester-container\\\"]\",\"action\":[\"style\",\"position: absolute !important;\"]}"],["{\"selector\":\"#tp98, #btn6\",\"action\":[\"style\",\"display: block !important;\"]}"],["{\"selector\":\".adsbygoogle\",\"action\":[\"style\",\"width:1px!important;height:1px!important;min-width:1px!important;min-height:1px\"]}"],["{\"selector\":\"#tristana, #_append, #myDiv\",\"action\":[\"style\",\"display: block !important;\"]}"],["{\"selector\":\"#info\",\"action\":[\"style\",\"display: block !important\"]}"],["{\"selector\":\"div[class^=\\\"Ad-adContainer\\\"]\",\"action\":[\"style\",\"min-height:1px!important;min-width:1px!important;\"]}"],["{\"selector\":\".adsense\",\"action\":[\"style\",\"padding: 0 !important;\"]}"],["{\"selector\":\"#site-wrapper\",\"action\":[\"style\",\"padding-top: 0 !important;\"]}"],["{\"selector\":\".adsbyvli\",\"action\":[\"style\",\"opacity: 0 !important; pointer-events: none !important;\"]}"],["{\"selector\":\"#wpsafe-snp\",\"action\":[\"style\",\"display: block !important\"]}"],["{\"selector\":\"#ymm-sub-nav\",\"action\":[\"style\",\"top:0px !important\"]}"],["{\"selector\":\".text-center\",\"action\":[\"style\",\"display: block !important;\"]}"],["{\"selector\":\"#wpsafe-generate\",\"action\":[\"style\",\"display: block !important;\"]}"],["{\"selector\":\".g-recaptcha\",\"action\":[\"style\",\"margin-top:60px !important\"]}"],["{\"selector\":\"#footer #wpsafe-link\",\"action\":[\"style\",\"display: block !important;\"]}"],["{\"selector\":\"#my-content\",\"action\":[\"style\",\"display: block !important;\"]}"],["{\"selector\":\".modal-open\",\"action\":[\"style\",\"overflow: auto !important; padding-right: 0 !important;\"]}"],["{\"selector\":\"#yuidea-snp\",\"action\":[\"style\",\"display: block !important;\"]}"],["{\"selector\":\"body\",\"action\":[\"style\",\"display: block !important\"]}"],["{\"selector\":\"html, body\",\"action\":[\"style\",\"overflow: auto !important\"]}"],["{\"selector\":\".samBackground\",\"action\":[\"style\",\"background-image:none !important\"]}"],["{\"selector\":\"#tp-snp2, #cross-snp2\",\"action\":[\"style\",\"display: block !important;\"]}"],["{\"selector\":\".adhesiveHeaderAdFixed header\",\"action\":[\"style\",\"top: 0 !important;\"],\"tasks\":[[\"matches-media\",\"(min-width: 1000px)\"]]}"],["{\"selector\":\".b_ad\",\"action\":[\"style\",\"position: absolute !important; top: -9999px !important;\"]}","{\"selector\":\".b_adLastChild\",\"action\":[\"style\",\"position: absolute !important; top: -9999px !important;\"]}","{\"selector\":\".pa_sb\",\"action\":[\"style\",\"position: absolute !important; top: -9999px !important;\"]}"],["{\"selector\":\".item > .post\",\"action\":[\"style\",\"height: auto !important;\"]}","{\"selector\":\".item\",\"action\":[\"style\",\"height: auto !important;\"]}"],["{\"selector\":\".buttondownload\",\"action\":[\"style\",\"display: block !important;\"]}","{\"selector\":\".buttonnya\",\"action\":[\"style\",\"display: block !important;\"]}"],["{\"selector\":\".asdf\",\"action\":[\"style\",\"display: block !important;\"]}"],["{\"selector\":\"#waiting, #pop-button\",\"action\":[\"style\",\"display: block !important;\"]}"],["{\"selector\":\"#wpsafe-snp1\",\"action\":[\"style\",\"display: block !important\"]}"],["{\"selector\":\"#btn-gotolink\",\"action\":[\"style\",\"display:block !important; margin-top: 410px !important; margin-left: 200px !important; height: 100px !important; width: 100px !important\"]}"],["{\"selector\":\"#top_fold[style=\\\"display:flex !important;\\\"]\",\"action\":[\"style\",\"min-height: 0px !important; transition: all 0s ease 0s !important;\"]}"],["{\"selector\":\".header\",\"action\":[\"style\",\"top: 0px !important;\"]}","{\"selector\":\"h1\",\"action\":[\"style\",\"margin-top:20px !important;\"]}","{\"selector\":\"main[role=\\\"main\\\"]\",\"action\":[\"style\",\"margin-top:30px !important;\"]}"],["{\"selector\":\"#show_ag\",\"action\":[\"style\",\"display:block !important\"]}"],["{\"selector\":\".cb-comments__create-form\",\"action\":[\"style\",\"margin-top: 30px !important;\"]}","{\"selector\":\".cb-post-block-images-swiper .cb-post-block__comments .collapseable-comments__collapse\",\"action\":[\"style\",\"margin-bottom: 0px !important;\"]}","{\"selector\":\".cb-post-block-images-swiper .cb-post-block__comments\",\"action\":[\"style\",\"margin-bottom: 0 !important; top: -97px !important;\"]}","{\"selector\":\".cb-post-block-images-swiper .collapseable-comments__collapseable\",\"action\":[\"style\",\"margin-bottom: -80px !important;\"]}","{\"selector\":\".cb-post-block__comments\",\"action\":[\"style\",\"padding-bottom: 0 !important;\"]}"],["{\"selector\":\".Skybox--minHeight, .Skybox--minHeightBoth\",\"action\":[\"style\",\"--global-nav-v2-offset: 0px !important;\"]}"],["{\"selector\":\".game-over-ad-legacy-component\",\"action\":[\"style\",\"height: 0 !important\"]}","{\"selector\":\"body.board-layout.with-und\",\"action\":[\"style\",\"margin-right:0px!important\"]}"],["{\"selector\":\"[id^=\\\"wpsafe-generate\\\"], #continue\",\"action\":[\"style\",\"display: block !important;\"]}"],["{\"selector\":\"#tp-generate, #getlinkbtn\",\"action\":[\"style\",\"display: block !important;\"]}"],["{\"selector\":\"body\",\"action\":[\"style\",\"background-image: unset !important; cursor: auto !important;\"]}"],["{\"selector\":\"#tp-snp2, #timeout\",\"action\":[\"style\",\"display:block !important; margin-top: 520px !important; height: 100px !important; width: 100px !important\"]}"],["{\"selector\":\".ad-slot-header__wrapper\",\"action\":[\"style\",\"display: none !important; top: 0 !important\"]}"],["{\"selector\":\"#claimCoins\",\"action\":[\"style\",\"display: block !important;\"]}"],["{\"selector\":\"#wpsafelinkhuman, #wpsafe-link\",\"action\":[\"style\",\"display: block !important;\"]}"],["{\"selector\":\"body > header\",\"action\":[\"style\",\"top:0 !important\"]}","{\"selector\":\"body.pcm-public\",\"action\":[\"style\",\"margin-top: 84px !important;\"]}"],["{\"selector\":\"html, body\",\"action\":[\"style\",\"height: 0 !important; overflow: hidden !important;\"]}"],["{\"selector\":\"body\",\"action\":[\"style\",\"overflow:auto !important\"]}"],["{\"selector\":\"div.text-center[id]\",\"action\":[\"style\",\"height: 100px !important;\"]}"],["{\"selector\":\"#hometimerstartbtn, #hometimer, #yuidea-btmbtn, #btn6\",\"action\":[\"style\",\"display: block !important;\"]}"],["{\"selector\":\".pum-open-overlay\",\"action\":[\"style\",\"overflow: auto !important;\"]}"],["{\"selector\":\"#locked_action_link.disabled\",\"action\":[\"style\",\"cursor:pointer !important; opacity:1 !important; pointer-events:auto !important\"]}"],["{\"selector\":\".td-animation-stack-type0-1\",\"action\":[\"style\",\"opacity:1 !important\"]}"],["{\"selector\":\"#top_nav, .rd_btn, .soractrl\",\"action\":[\"style\",\"display: block !important;\"]}"],["{\"selector\":\"#dclm-blur\",\"action\":[\"style\",\"filter: none !important\"]}"],["{\"selector\":\"#btngetlink\",\"action\":[\"style\",\"display: inline-block !important\"]}"],["{\"selector\":\".dd-nav-global\",\"action\":[\"style\",\"top: 0 !important; transform: none !important;\"]}"],["{\"selector\":\"[style*=\\\"pointer-events\\\"]\",\"action\":[\"style\",\"pointer-events:auto !important\"]}"],["{\"selector\":\".desktop-wrapper.has-header-banner.mt-32\",\"action\":[\"style\",\"margin-top: 8rem !important;\"]}","{\"selector\":\".single-story > header\",\"action\":[\"style\",\"margin-top: 40px !important\"]}"],["{\"selector\":\".adsbygoogle\",\"action\":[\"style\",\"height: 0px !important; visibility: collapse;\"]}"],["{\"selector\":\"#gourl\",\"action\":[\"style\",\"display: block !important;\"]}"],["{\"selector\":\".TablesTitle > div:not([style=\\\"padding\\\"])\",\"action\":[\"style\",\"width: 100% !important;\"]}"],["{\"selector\":\"img[id^=\\\"ads-\\\"]\",\"action\":[\"style\",\"visibility: hidden !important;\"]}"],["{\"selector\":\".adBanner\",\"action\":[\"style\",\"height:1px !important\"]}"],["{\"selector\":\".aoa_overlay\",\"action\":[\"style\",\"height: 0px !important\"]}"],["{\"selector\":\".site-wrapper\",\"action\":[\"style\",\"opacity:1!important;visibility:visible!important\"]}","{\"selector\":\"body\",\"action\":[\"style\",\"overflow:auto!important\"]}"],["{\"selector\":\"#tie-wrapper\",\"action\":[\"style\",\"min-height:initial! important;\"]}"],["{\"selector\":\".efi_enabled\",\"action\":[\"style\",\"overflow: auto !important; height: auto !important; width: auto !important; position: static !important;\"]}"],["{\"selector\":\".adsbygoogle\",\"action\":[\"style\",\"height: 1px !important;\"]}"],["{\"selector\":\"header.elevation-3\",\"action\":[\"style\",\"top: 0px !important;\"]}","{\"selector\":\"main\",\"action\":[\"style\",\"--v-layout-top: 64px !important;\"]}"],["{\"selector\":\"*::selection\",\"action\":[\"style\",\"background-color:#338FFF!important\"]}"],["{\"selector\":\".adsbyvli\",\"action\":[\"style\",\"height: 0px !important;\"]}"],["{\"selector\":\"ins.adsbygoogle\",\"action\":[\"style\",\"height: 1px !important;\"]}"],["{\"selector\":\"div[aria-posinset]:has(a[aria-label=\\\"広告\\\"])\",\"action\":[\"style\",\"height: 0 !important; overflow: hidden !important;\"]}"],["{\"selector\":\"#bodyContent\",\"action\":[\"style\",\"width:100% !important\"]}"],["{\"selector\":\".azz_div\",\"action\":[\"style\",\"height: unset !important;\"]}"],["{\"selector\":\"div.labeled-dw-ads\",\"action\":[\"style\",\"position: absolute !important; top: -10000px !important;\"]}","{\"selector\":\"div.single-text-ads\",\"action\":[\"style\",\"position: absolute !important; top: -10000px !important;\"]}","{\"selector\":\"div.site-middle-banners\",\"action\":[\"style\",\"position: absolute !important; top: -10000px !important;\"]}"],["{\"selector\":\"#main > ins.adsbygoogle\",\"action\":[\"style\",\"position: absolute !important; left: -4000px !important;\"]}","{\"selector\":\".side_banner\",\"action\":[\"style\",\"position: absolute !important; left: -4000px !important;\"]}"],["{\"selector\":\"body\",\"action\":[\"style\",\"overflow: auto !important; position: initial !important;\"]}"],["{\"selector\":\"#b3c\",\"action\":[\"style\",\"height: 0 !important;\"]}"],["{\"selector\":\"#btnshow\",\"action\":[\"style\",\"display: block !important;\"]}","{\"selector\":\"#verify_button\",\"action\":[\"style\",\"display: block !important;\"]}"],["{\"selector\":\"#donead\",\"action\":[\"style\",\"display: block !important;\"]}"],["{\"selector\":\".btn-success, .btn-primary\",\"action\":[\"style\",\"display: block !important;\"]}"],["{\"selector\":\".site-header\",\"action\":[\"style\",\"min-height: 90px !important\"]}"],["{\"selector\":\".reward-btn\",\"action\":[\"style\",\"display: block !important;\"]}","{\"selector\":\".reward-message\",\"action\":[\"style\",\"display: none !important;\"]}"],["{\"selector\":\"a.download\",\"action\":[\"style\",\"visibility: hidden;\"]}"],["{\"selector\":\".spot-thumbs > .right\",\"action\":[\"style\",\"height:1px !important\"]}"],["{\"selector\":\"#bodyContent\",\"action\":[\"style\",\"width:100%!important\"]}"],["{\"selector\":\"embed\",\"action\":[\"style\",\"display:inherit!important\"]}"],["{\"selector\":\"#ava-game_container\",\"action\":[\"style\",\"display:inherit!important\"]}","{\"selector\":\"#wrapped-content\",\"action\":[\"style\",\"display:inherit!important\"]}"],["{\"selector\":\".downloadLink\",\"action\":[\"style\",\"max-height: initial !important; overflow: revert !important\"]}"],["{\"selector\":\"#logoContainer\",\"action\":[\"style\",\"top: 0px !important;\"]}"],["{\"selector\":\".cNDPHQ, .fKCJyZ\",\"action\":[\"style\",\"top: 0px !important; transform: unset !important;\"]}"],["{\"selector\":\".dictionary-grid\",\"action\":[\"style\",\"grid-template-columns: minmax(180px,200px) minmax(400px,736px) 0 !important; grid-template-rows: 0 auto !important;\"],\"tasks\":[[\"matches-media\",\"(min-width: 1024px)\"]]}","{\"selector\":\".dictionary-grid\",\"action\":[\"style\",\"grid-template-columns: minmax(180px,250px) minmax(400px,736px) 0 !important; grid-template-rows: 0 auto !important;\"],\"tasks\":[[\"matches-media\",\"(min-width: 1280px)\"]]}","{\"selector\":\".dictionary-grid\",\"action\":[\"style\",\"grid-template-rows: 0 auto !important;\"],\"tasks\":[[\"matches-media\",\"(min-width: 768px)\"]]}"],["{\"selector\":\".Page-body[data-header-hat=\\\"true\\\"] .Page-header\",\"action\":[\"style\",\"top: 0px !important;\"]}","{\"selector\":\".Page-body[data-header-hat=\\\"true\\\"]\",\"action\":[\"style\",\"padding-top: var(--headerHeight) !important;\"]}"],["{\"selector\":\"#btn6\",\"action\":[\"style\",\"display: block !important;\"]}"],["{\"selector\":\"html\",\"action\":[\"style\",\"overflow: auto !important\"]}"],["{\"selector\":\".css-1uhcmhp\",\"action\":[\"style\",\"grid-template-rows: 0 auto !important;\"],\"tasks\":[[\"matches-media\",\"(min-width: 80em)\"]]}"],["{\"selector\":\".pagebody\",\"action\":[\"style\",\"height: auto !important;\"]}"],["{\"selector\":\"#my-btn, #pro-continue, #pro-link\",\"action\":[\"style\",\"display: block !important;\"]}"],["{\"selector\":\"#submitBtn, #go_d, #wolfexe-snp\",\"action\":[\"style\",\"display: block !important;\"]}"],["{\"selector\":\".min-h-\\\\[250px\\\\]\",\"action\":[\"style\",\"min-height: 0 !important;\"]}"],["{\"selector\":\"#header\",\"action\":[\"style\",\"position: inherit !important;\"]}"],["{\"selector\":\"#notarobot, #gotolink\",\"action\":[\"style\",\"display: block !important;\"]}"],["{\"selector\":\".onp-sl-content\",\"action\":[\"style\",\"display:block !important\"]}"],["{\"selector\":\".webgl-content\",\"action\":[\"style\",\"width: 100% !important;\"]}"],["{\"selector\":\"body\",\"action\":[\"style\",\"background-color: #2D2D2D;\"]}"],["{\"selector\":\".uk-panel.widget-text\",\"action\":[\"style\",\"height: 0px !important; visibility: collapse;\"]}"],["{\"selector\":\".preShell\",\"action\":[\"style\",\"height: 0 !important;\"]}","{\"selector\":\".zad.billboard\",\"action\":[\"style\",\"min-height: 1px !important;\"]}"],["{\"selector\":\".no-scroll\",\"action\":[\"style\",\"overflow:auto!important\"]}"],["{\"selector\":\"#image_details\",\"action\":[\"style\",\"margin-top: 30px !important\"]}"],["{\"selector\":\"a[href].Post-item:has(.Post-item-external-ad)\",\"action\":[\"style\",\"opacity: 0 !important; cursor: unset !important; pointer-events: none !important;\"]}"],["{\"selector\":\"body\",\"action\":[\"style\",\"color: #000 !important;\"]}"],["{\"selector\":\"img\",\"action\":[\"style\",\"visibility: visible !important;\"]}"],["{\"selector\":\"ins.adsbygoogle\",\"action\":[\"style\",\"height: 1px !important; visibility: hidden !important;\"]}"],["{\"selector\":\"article:has(a[href^=\\\"https://www.facebook.com/ads/\\\"])\",\"action\":[\"style\",\"height: 0 !important; overflow: hidden !important;\"]}"],["{\"selector\":\".flowplayer.is-cva .fp-controls\",\"action\":[\"style\",\"display: flex !important\"]}","{\"selector\":\".flowplayer.is-cva .fp-fullscreen\",\"action\":[\"style\",\"display: flex !important\"]}"],["{\"selector\":\"body.td-background-link\",\"action\":[\"style\",\"cursor:default !important;\"]}"],["{\"selector\":\"#combtn, .download.medium.button\",\"action\":[\"style\",\"display: inline-block !important;\"]}"],["{\"selector\":\".logo, .blinker\",\"action\":[\"style\",\"animation: none !important;\"]}"],["{\"selector\":\".adstrick > .video-item\",\"action\":[\"style\",\"clear: none !important;\"]}"],["{\"selector\":\".thumb\",\"action\":[\"style\",\"cursor:pointer !important\"]}"],["{\"selector\":\"#wrapfabtest\",\"action\":[\"style\",\"height:1px !important;width:1px !important\"]}"],["{\"selector\":\".videos-ad__wrap\",\"action\":[\"style\",\"background-color: transparent !important\"]}"],["{\"selector\":\".widget-topad\",\"action\":[\"style\",\"padding-bottom: 20px !important;\"]}"],["{\"selector\":\"#embed\",\"action\":[\"style\",\"position: static!important; margin-top: 0!important;\"]}"],["{\"selector\":\"p.chapter_content\",\"action\":[\"style\",\"display: block !important; visibility: visible !important; opacity: 1 !important; transform: none !important;\"]}"],["{\"selector\":\"ins.adsbygoogle\",\"action\":[\"style\",\"height: 1px!important;\"]}"],["{\"selector\":\"#btx1, #btx2, #wg-genx > .mediafire\",\"action\":[\"style\",\"visibility: hidden !important;\"]}","{\"selector\":\"body\",\"action\":[\"style\",\"overflow: visible !important;\"]}"],["{\"selector\":\"[id^=\\\"div-gpt-ad\\\"]:not([style^=\\\"width: 1px; height: 1px; position: absolute; left: -10000px; top: -\\\"])\",\"action\":[\"style\",\"height: 0px !important; min-height: 0px !important;\"]}"],["{\"selector\":\".publi_luto_horizontal\",\"action\":[\"style\",\"max-height: 1px !important;\"]}","{\"selector\":\"div[id^=\\\"google_ads_iframe_\\\"]\",\"action\":[\"style\",\"max-height: 1px !important;\"]}","{\"selector\":\"iframe[id^=\\\"google_ads_iframe\\\"]\",\"action\":[\"style\",\"max-height: 1px !important;\"]}"],["{\"selector\":\".below-ad-wrapper\",\"action\":[\"style\",\"margin-top: 51px !important;\"]}"],["{\"selector\":\"#scroll.hidden, .footerLink.hidden\",\"action\":[\"style\",\"display: block!important\"]}"],["{\"selector\":\"#chapter-images div\",\"action\":[\"style\",\"padding: unset !important\"]}"],["{\"selector\":\"#container\",\"action\":[\"style\",\"height: 100% !important;\"]}"],["{\"selector\":\"html, body\",\"action\":[\"style\",\"overflow: auto !important;\"]}"],["{\"selector\":\"[id*=\\\"iframe\\\"], [id*=\\\"gpt_unit\\\"], [id*=\\\"div-gpt-\\\"]\",\"action\":[\"style\",\"height:0.0001px !important;\"]}"],["{\"selector\":\".container\",\"action\":[\"style\",\"width: 100% !important;\"]}"],["{\"selector\":\"div#wpsafe-link\",\"action\":[\"style\",\"display: block !important;\"]}"],["{\"selector\":\".center\",\"action\":[\"style\",\"margin-top:50px !important\"]}"],["{\"selector\":\".adthrive-video-player\",\"action\":[\"style\",\"padding-bottom: 0 !important;\"]}"],["{\"selector\":\"html\",\"action\":[\"style\",\"background-image: none !important;\"]}"],["{\"selector\":\"#content.sidebar2\",\"action\":[\"style\",\"margin-right: 0 !important;\"]}"],["{\"selector\":\"aside\",\"action\":[\"style\",\"background: transparent !important;\"]}"],["{\"selector\":\"#wpsafe-link\",\"action\":[\"style\",\"display: block !important\"]}"],["{\"selector\":\".adsbygoogle\",\"action\":[\"style\",\"width:11px;height:11px\"]}"],["{\"selector\":\"#btn2, .tp-blue\",\"action\":[\"style\",\"display: block !important;\"]}"],["{\"selector\":\"body.noImages .content img\",\"action\":[\"style\",\"display: inline-block !important\"]}"],["{\"selector\":\"#ins_videodetail\",\"action\":[\"style\",\"display: block !important;\"]}"],["{\"selector\":\".adblockerContent\",\"action\":[\"style\",\"display: initial !important;\"]}"],["{\"selector\":\"#wrapper\",\"action\":[\"style\",\"padding-top: 0 !important;\"]}","{\"selector\":\".advert\",\"action\":[\"style\",\"z-index: -999999 !important;\"]}"],["{\"selector\":\"#gameEtTopRight.commonEt\",\"action\":[\"style\",\"height: 0 !important;\"]}","{\"selector\":\"#gamelistCategories\",\"action\":[\"style\",\"margin-bottom: auto !important;\"]}"],["{\"selector\":\"article.story\",\"action\":[\"style\",\"opacity: 1.0 !important;\"]}"],["{\"selector\":\"[data-testid=\\\"connection-toast\\\"]\",\"action\":[\"style\",\"margin-top: 330px !important;\"]}"],["{\"selector\":\"body\",\"action\":[\"style\",\"height: auto !important; overflow: auto !important\"]}","{\"selector\":\"html\",\"action\":[\"style\",\"height: auto !important; overflow: auto !important\"]}"],["{\"selector\":\".adsbyvli\",\"action\":[\"style\",\"max-height: 1px !important;\"]}"],["{\"selector\":\"header\",\"action\":[\"style\",\"top:0 !important\"]}"],["{\"selector\":\"#adkit_billboard\",\"action\":[\"style\",\"padding-top: 0px!important;\"]}"],["{\"selector\":\".list_ads\",\"action\":[\"style\",\"height: 0px !important;\"]}"],["{\"selector\":\"#content > form[id]:has(> center > button)\",\"action\":[\"style\",\"display: block !important;\"]}"],["{\"selector\":\"body.swal2-shown > [aria-hidden=\\\"true\\\"]\",\"action\":[\"style\",\"filter: none !important\"]}"],["{\"selector\":\".lst_ads\",\"action\":[\"style\",\"height: 0px !important;\"]}"],["{\"selector\":\"#workspace\",\"action\":[\"style\",\"right: 0px !important;\"]}"],["{\"selector\":\"body.has-interstitial-ads .has-interstitial-ads-page, body.has-interstitial-ads .has-interstitial-ads-page *\",\"action\":[\"style\",\"visibility: visible !important;\"]}"],["{\"selector\":\"a[download-button]\",\"action\":[\"style\",\"display: block !important;\"]}"],["{\"selector\":\".adsbygoogle\",\"action\":[\"style\",\"height: 1px !important; width: 1px !important;\"]}"],["{\"selector\":\"#Page\",\"action\":[\"style\",\"right: 0px !important;\"]}"],["{\"selector\":\"div[class*=\\\"styles_withAd\\\"]\",\"action\":[\"style\",\"padding-top: 0 !important;\"]}"],["{\"selector\":\"body.pcm-public:not(.skybox-loaded)\",\"action\":[\"style\",\"margin-top: 90px !important;\"]}","{\"selector\":\"body:not(.skybox-loaded) > header\",\"action\":[\"style\",\"top: 0 !important;\"]}"],["{\"selector\":\".bunny-button-resume\",\"action\":[\"style\",\"display: grid !important;\"]}","{\"selector\":\".bunny-container\",\"action\":[\"style\",\"display: flex !important;\"]}"],["{\"selector\":\"#blockblockB\",\"action\":[\"style\",\"display: block!important;\"]}"],["{\"selector\":\"#btn11, #tp-snp2, #rtg, #btn6, #wpsafe-snp\",\"action\":[\"style\",\"display: block !important;\"]}"],["{\"selector\":\"#gotolink\",\"action\":[\"style\",\"display: block !important;\"]}"],["{\"selector\":\"center, [src*=\\\"google.com/recaptcha/\\\"], #yuidea-snp\",\"action\":[\"style\",\"display:block !important\"]}"],["{\"selector\":\"body\",\"action\":[\"style\",\"background-color: white !important\"]}"],["{\"selector\":\".result__ext:has([data-testid=\\\"adResult\\\"])\",\"action\":[\"style\",\"max-height: 1px !important; opacity: 0 !important; pointer-events: none !important;\"]}","{\"selector\":\"div[data-testid=\\\"pam.container\\\"]\",\"action\":[\"style\",\"max-height: 1px !important; opacity: 0 !important; pointer-events: none !important;\"]}"],["{\"selector\":\".e76xF.bJlt-\",\"action\":[\"style\",\"padding-top:0px !important\"]}"],["{\"selector\":\"#main_canvas > div:not(div[id^=\\\"google\\\"])\",\"action\":[\"style\",\"width: 100% !important;\"]}"],["{\"selector\":\".subredditvars-r-ublockorigin [role=\\\"dialog\\\"] > div\",\"action\":[\"style\",\"width: auto !important\"]}"],["{\"selector\":\".result_content_ff\",\"action\":[\"style\",\"display: block !important;\"]}"],["{\"selector\":\".phpbb-ads-center\",\"action\":[\"style\",\"pointer-events: none !important\"]}","{\"selector\":\"ins\",\"action\":[\"style\",\"opacity: 0 !important; pointer-events: none !important\"]}"],["{\"selector\":\"ul[class^=\\\"cluster__stories\\\"] > li[class^=\\\"cluster__cluster-basic\\\"][class*=\\\"cluster__column-left\\\"]\",\"action\":[\"style\",\"margin-left: 17.0418006431vw !important;\"]}","{\"selector\":\"ul[class^=\\\"cluster__stories\\\"] > li[class^=\\\"cluster__cluster-hub\\\"][class*=\\\"cluster__column-middle\\\"][class*=\\\"cluster__break-after\\\"]\",\"action\":[\"style\",\"margin-bottom: 100px !important;\"]}"],["{\"selector\":\"#colunas\",\"action\":[\"style\",\"display: block !important;\"]}"],["{\"selector\":\"div[id$=\\\"content\\\"] img.lazy\",\"action\":[\"style\",\"opacity: 1 !important;\"]}"],["{\"selector\":\"#player\",\"action\":[\"style\",\"display: block !important;\"]}"],["{\"selector\":\"body.no-scroll\",\"action\":[\"style\",\"overflow: auto !important; position: static !important; width: unset !important;\"]}"],["{\"selector\":\"body::after\",\"action\":[\"style\",\"background: unset !important;\"]}"],["{\"selector\":\"#yuidea-snp, #btn6\",\"action\":[\"style\",\"display: block !important;\"]}"],["{\"selector\":\".background-cloud\",\"action\":[\"style\",\"display: none !important;\"]}"],["{\"selector\":\".cover\",\"action\":[\"style\",\"background-image: none!important;\"]}"],["{\"selector\":\"#nextBTNH\",\"action\":[\"style\",\"display: block !important;\"]}"],["{\"selector\":\".btn-primary\",\"action\":[\"style\",\"visibility: visible !important;\"]}"],["{\"selector\":\"#myBtn\",\"action\":[\"style\",\"display: block !important;\"]}"],["{\"selector\":\"div[class$=\\\"-margin-Advert\\\"]\",\"action\":[\"style\",\"height:1px !important;width:1px !important;position:absolute !important;left:-3000px !important\"]}"],["{\"selector\":\"body\",\"action\":[\"style\",\"background-image:none !important\"]}"],["{\"selector\":\"#nn_bfa_wrapper + .container\",\"action\":[\"style\",\"margin-top: 50px !important;\"]}"],["{\"selector\":\"#cc\",\"action\":[\"style\",\"display: block !important;\"]}"],["{\"selector\":\"#botaoLink\",\"action\":[\"style\",\"display: block !important;\"]}"],["{\"selector\":\"#my-btn, #my-btn2\",\"action\":[\"style\",\"display: block !important;\"]}"],["{\"selector\":\".td-pb-span8\",\"action\":[\"style\",\"width: 100% !important;\"]}"],["{\"selector\":\"#link\",\"action\":[\"style\",\"display: block !important;\"]}"],["{\"selector\":\"#makingdifferenttimer\",\"action\":[\"style\",\"display: block!important\"]}"],["{\"selector\":\"#timed\",\"action\":[\"style\",\"display: block !important;\"]}"],["{\"selector\":\".glass-panel > ins.adsbygoogle\",\"action\":[\"style\",\"height: 10px !important;\"]}"],["{\"selector\":\"body.body-load\",\"action\":[\"style\",\"overflow: auto !important;\"]}"],["{\"selector\":\".home-page.main-section, html > body\",\"action\":[\"style\",\"margin-top: 0px !important;\"]}","{\"selector\":\".slideMenu\",\"action\":[\"style\",\"top: -7px !important;\"]}","{\"selector\":\"body\",\"action\":[\"style\",\"padding-top: 0px !important;\"]}","{\"selector\":\"header\",\"action\":[\"style\",\"top: 0px !important;\"]}"],["{\"selector\":\"#tp-snp2\",\"action\":[\"style\",\"display: block !important;\"]}"],["{\"selector\":\"body:not([data-template]) a[rel=\\\"nofollow\\\"][href^=\\\"/reviyuu/b784/\\\"]\",\"action\":[\"style\",\"pointer-events: none !important;\"]}"],["{\"selector\":\"#td-outer-wrap\",\"action\":[\"style\",\"cursor: default !important\"]}"],["{\"selector\":\"#tp-generate, #tp-snp2\",\"action\":[\"style\",\"display: block !important;\"]}"],["{\"selector\":\"#wpsafe-generate, #wpsafe-link, .bt-success\",\"action\":[\"style\",\"display: block !important;\"]}"],["{\"selector\":\"#wpsafe-snp\",\"action\":[\"style\",\"display: block !important;\"]}"],["{\"selector\":\".widget-height\",\"action\":[\"style\",\"height: unset !important\"]}"],["{\"selector\":\"body, html\",\"action\":[\"style\",\"height: auto !important; overflow: auto !important\"]}"],["{\"selector\":\"[class^=\\\"HomepageSection\\\"]\",\"action\":[\"style\",\"grid-template-rows: unset !important;\"]}"],["{\"selector\":\"body[style=\\\"margin-top: 90px; margin-bottom: 90px;\\\"]\",\"action\":[\"style\",\"margin-top: 0 !important; margin-bottom: 0 !important;\"]}"],["{\"selector\":\".row > [id^=\\\"sPost\\\"]\",\"action\":[\"style\",\"margin-top: 60px !important;\"]}"],["{\"selector\":\"._4xQrn\",\"action\":[\"style\",\"max-height:0px\"]}"],["{\"selector\":\"#trd-header\",\"action\":[\"style\",\"top: 0 !important;\"]}","{\"selector\":\"body[data-pushdown-enabled=\\\"true\\\"]\",\"action\":[\"style\",\"margin-top: 0px !important;\"]}"],["{\"selector\":\".mntl-leaderboard-spacer\",\"action\":[\"style\",\"min-height: 0px !important;\"]}"],["{\"selector\":\"#site-navbar-container, #site-top-nav-container\",\"action\":[\"style\",\"padding-top: 10px !important;\"]}"],["{\"selector\":\".ipsType_richText a\",\"action\":[\"style\",\"color:currentcolor !important\"]}","{\"selector\":\"a[data-autolink]\",\"action\":[\"style\",\"text-decoration: none !important; color: inherit !important; pointer-events: none;\"]}"],["{\"selector\":\".body-container\",\"action\":[\"style\",\"background-image: unset !important; cursor: auto !important;\"]}"],["{\"selector\":\"#download_link\",\"action\":[\"style\",\"display: inline-block !important\"]}"],["{\"selector\":\".Yc2Sp h1, .Yc2Sp a\",\"action\":[\"style\",\"font-size: 0 !important;\"]}"],["{\"selector\":\"body[style=\\\"pointer-events: none;\\\"]\",\"action\":[\"style\",\"pointer-events: auto !important;\"]}"],["{\"selector\":\"#ad-container\",\"action\":[\"style\",\"display: block !important;\"]}"],["{\"selector\":\".underplayer\",\"action\":[\"style\",\"min-height: initial !important;\"]}"],["{\"selector\":\".gnt_n\",\"action\":[\"style\",\"top: 0 !important; margin-top: 0 !important;\"]}"],["{\"selector\":\".ads\",\"action\":[\"style\",\"height:1px !important\"]}"],["{\"selector\":\"#video-player-track[style*=\\\"display: block\\\"]\",\"action\":[\"style\",\"visibility: visible !important;\"]}"],["{\"selector\":\"#app\",\"action\":[\"style\",\"display: none !important;\"]}","{\"selector\":\"#app_msg\",\"action\":[\"style\",\"display: none !important;\"]}","{\"selector\":\"#download-form\",\"action\":[\"style\",\"display: initial !important;\"]}"],["{\"selector\":\"#breadcrumb + .trytopnav\",\"action\":[\"style\",\"top: 36px!important;\"]}","{\"selector\":\"#tryitLeaderboard + #breadcrumb ~ #container\",\"action\":[\"style\",\"top: 84px!important;\"]}","{\"selector\":\"#tryitLeaderboard + .trytopnav ~ #dragbar + #container\",\"action\":[\"style\",\"top: 48px!important;\"]}","{\"selector\":\"#tryitLeaderboard + .trytopnav\",\"action\":[\"style\",\"top: 0!important;\"]}"],["{\"selector\":\"html[style=\\\"overflow: hidden;\\\"]\",\"action\":[\"style\",\"overflow: auto !important;\"]}"],["{\"selector\":\".wh_ad_active\",\"action\":[\"style\",\"margin: 0 !important; visibility: collapse !important;\"]}"],["{\"selector\":\"#gameplay > iframe\",\"action\":[\"style\",\"display: block !important;\"]}"],["{\"selector\":\".content-wrap #inner-wrap\",\"action\":[\"style\",\"height: 100vh !important;\"]}","{\"selector\":\"body wu-header\",\"action\":[\"style\",\"margin-top: 0px !important;\"]}"],["{\"selector\":\".ad_block\",\"action\":[\"style\",\"visibility: hidden !important;\"]}"],["{\"selector\":\"body.desktopView.hasFooterAd .mainSection\",\"action\":[\"style\",\"margin-bottom: 0!important;padding-bottom: 0!important;\"]}"],["{\"selector\":\".post-content img.lazy\",\"action\":[\"style\",\"opacity: 1 !important;\"]}"],["{\"selector\":\".header\",\"action\":[\"style\",\"top: 0 !important\"]}"],["{\"selector\":\"#header-collapse-trigger\",\"action\":[\"style\",\"top: 0 !important; margin-top: 0 !important;\"]}"],["{\"selector\":\".vjs-control-bar\",\"action\":[\"style\",\"display: flex !important;\"]}"],["{\"selector\":\"#link1s-snp\",\"action\":[\"style\",\"display: block !important;\"]}"],["{\"selector\":\"body::before\",\"action\":[\"style\",\"background: none !important;\"]}","{\"selector\":\"html\",\"action\":[\"style\",\"cursor: auto !important;\"]}"],["{\"selector\":\"#cnc_branding_creative_wrapper\",\"action\":[\"style\",\"min-height: 0px !important; height: 0px !important; visibility: hidden !important;\"]}","{\"selector\":\".cnc-ads\",\"action\":[\"style\",\"min-height: 0px !important; height: 0px !important; visibility: hidden !important;\"]}"],["{\"selector\":\"[id=\\\"aswift_0_host\\\"], [id=\\\"aswift_1_host\\\"], [id=\\\"aswift_2_host\\\"], [id=\\\"aswift_3_host\\\"], [id=\\\"aswift_4_host\\\"], [id=\\\"aswift_5_host\\\"]\",\"action\":[\"style\",\"opacity: 0 !important; pointer-events: none !important;\"]}"],["{\"selector\":\".main-nav .utilities > li\",\"action\":[\"style\",\"margin-left:-0.5px !important\"]}"],["{\"selector\":\".slideshow__desktop-ad\",\"action\":[\"style\",\"max-height:20px\"]}"],["{\"selector\":\".FC__Container.min-height-250px-mu\",\"action\":[\"style\",\"max-height: 0.1px !important; height: 0.1px !important; min-height: 0px !important;\"]}","{\"selector\":\":root\",\"action\":[\"style\",\"--topbanner-height-min:unset!important;--topbanner-height-max:unset!important;\"]}"],["{\"selector\":\"#G32\",\"action\":[\"style\",\"grid-template-rows: unset!important;\"]}"],["{\"selector\":\"body\",\"action\":[\"style\",\"margin-top: 0px !important;\"]}"],["{\"selector\":\"#G32\",\"action\":[\"style\",\"grid-template-rows: unset !important;\"]}"],["{\"selector\":\".adsbygoogle\",\"action\":[\"style\",\"height: 1px !important\"]}"],["{\"selector\":\".id-Page-layoutWrap, .id-SiteWrap, .id-SiteHeader-wrap\",\"action\":[\"style\",\"width: 100% !important; max-width: 100% !important;\"]}"],["{\"selector\":\".ad\",\"action\":[\"style\",\"position:absolute !important; left:-10000px !important; display:block !important; pointer-events: none !important;\"]}"],["{\"selector\":\".disabled-vscroll\",\"action\":[\"style\",\"overflow: auto !important; position: initial !important;\"]}"],["{\"selector\":\".mat-drawer-container\",\"action\":[\"style\",\"overflow-x: auto !important\"]}"],["{\"selector\":\".adsbygoogle\",\"action\":[\"style\",\"visibility: collapse !important\"]}"],["{\"selector\":\"body::before\",\"action\":[\"style\",\"background-image: unset !important;\"]}"],["{\"selector\":\"#o_carrepub\",\"action\":[\"style\",\"height: 1px; margin: 0; min-height: auto; visibility: hidden; width: 1px;\"]}"],["{\"selector\":\"form > div[id][style=\\\"display: none;\\\"]\",\"action\":[\"style\",\"display: block !important;\"]}"],["{\"selector\":\"input[type=\\\"submit\\\"]\",\"action\":[\"style\",\"display: block !important;\"]}"],["{\"selector\":\"body\",\"action\":[\"style\",\"padding-bottom: 0 !important;\"]}"],["{\"selector\":\"a[href^=\\\"https://skinrave.gg/rewards?\\\"]\",\"action\":[\"style\",\"height: 0px !important; margin-bottom: 0px !important;\"]}"],["{\"selector\":\".bg-gray-200\",\"action\":[\"style\",\"background: none !important; height: 1px !important; min-height: 1px !important;\"]}"],["{\"selector\":\"#vote-root\",\"action\":[\"style\",\"display:block !important\"]}","{\"selector\":\"div[class^=\\\"chakra-modal__overlay\\\"][style=\\\"opacity: 1;\\\"] ~ div[data-focus-lock-disabled]\",\"action\":[\"style\",\"display: none !important;\"]}","{\"selector\":\"div[class^=\\\"chakra-modal__overlay\\\"][style=\\\"opacity: 1;\\\"]\",\"action\":[\"style\",\"display: none !important;\"]}"],["{\"selector\":\"#af-all\",\"action\":[\"style\",\"margin-top: 4em;\"]}"],["{\"selector\":\"main\",\"action\":[\"style\",\"padding-top: 5em !important;\"]}"],["{\"selector\":\"#comment-section\",\"action\":[\"style\",\"display: block !important;\"]}"],["{\"selector\":\"#disqus_thread\",\"action\":[\"style\",\"display: block !important;\"]}"],["{\"selector\":\"div.secret\",\"action\":[\"style\",\"display:block !important\"]}"],["{\"selector\":\"html\",\"action\":[\"style\",\"background-image:none !important\"]}"],["{\"selector\":\"#url\",\"action\":[\"style\",\"display: block !important;\"]}"],["{\"selector\":\"body > .pubTime\",\"action\":[\"style\",\"display: block !important\"]}","{\"selector\":\"body > .secArticleImage\",\"action\":[\"style\",\"display: block !important\"]}","{\"selector\":\"body > .secArticleTitle\",\"action\":[\"style\",\"display: block !important\"]}","{\"selector\":\"body > .storyBody\",\"action\":[\"style\",\"display: block !important\"]}"],["{\"selector\":\"button#getlink, button#gotolink\",\"action\":[\"style\",\"display: block !important;\"]}"],["{\"selector\":\"#tp982, #btn6\",\"action\":[\"style\",\"display: block !important;\"]}"],["{\"selector\":\".show_download_links\",\"action\":[\"style\",\"display: block !important\"]}"],["{\"selector\":\"#tp98, #jatinbtn-continue\",\"action\":[\"style\",\"display: block !important;\"]}"],["{\"selector\":\"#zedoads1\",\"action\":[\"style\",\"height: 1px !important\"]}","{\"selector\":\"#zedoads2\",\"action\":[\"style\",\"height: 1px !important\"]}"],["{\"selector\":\"#story-maincontent\",\"action\":[\"style\",\"display: block !important\"]}","{\"selector\":\"#zedotopnavads\",\"action\":[\"style\",\"height: 1px !important\"]}","{\"selector\":\"#zedotopnavads1\",\"action\":[\"style\",\"height: 1px !important\"]}"],["{\"selector\":\"#tp98, #countdown\",\"action\":[\"style\",\"display: block !important;\"]}"],["{\"selector\":\"body\",\"action\":[\"style\",\"opacity: 1 !important;\"]}"],["{\"selector\":\"#btn11\",\"action\":[\"style\",\"display: block !important;\"]}"],["{\"selector\":\"#btn2, #btn5, #tp-snp2\",\"action\":[\"style\",\"display: block !important;\"]}"],["{\"selector\":\".adblockcontainer\",\"action\":[\"style\",\"display: block !important\"]}"],["{\"selector\":\".wpsafe-top\",\"action\":[\"style\",\"margin-top: 50px !important\"]}"],["{\"selector\":\"#tp98, #tp-snp2\",\"action\":[\"style\",\"display: block !important;\"]}"],["{\"selector\":\"#rtg-snp2\",\"action\":[\"style\",\"display: block !important;\"]}"],["{\"selector\":\"#notarobot, #btn7\",\"action\":[\"style\",\"display: block !important;\"]}"],["{\"selector\":\".box-main\",\"action\":[\"style\",\"font-size: 0px !important;\"]}"],["{\"selector\":\"button.tp-btn\",\"action\":[\"style\",\"display: block !important;\"]}"],["{\"selector\":\"[id^=\\\"AT-Download\\\"]\",\"action\":[\"style\",\"display: block !important;\"]}"],["{\"selector\":\"#wrapper-content\",\"action\":[\"style\",\"margin-top:0px !important\"]}"],["{\"selector\":\"#wtf\",\"action\":[\"style\",\"visibility:visible!important;display:block!important;\"]}"],["{\"selector\":\"#tie-body\",\"action\":[\"style\",\"background-image: none !important;\"]}"],["{\"selector\":\"body > div[style]:not([id])\",\"action\":[\"style\",\"position: static !important; background-color: rgba(0, 0, 0, 0) !important\"]}","{\"selector\":\"html, body\",\"action\":[\"style\",\"overflow: visible !important;\"]}"],["{\"selector\":\".opera-container\",\"action\":[\"style\",\"visibility: collapse !important;\"]}","{\"selector\":\"img[alt=\\\"Buff Banner\\\"]\",\"action\":[\"style\",\"visibility: collapse !important;\"]}"],["{\"selector\":\".adsbyvli\",\"action\":[\"style\",\"height: 1px !important; opacity: 0 !important; pointer-events: none !important;\"]}"],["{\"selector\":\".login-page\",\"action\":[\"style\",\"-webkit-animation: none !important\"]}"],["{\"selector\":\"#glink\",\"action\":[\"style\",\"display: block !important;\"]}"],["{\"selector\":\"body\",\"action\":[\"style\",\"background: none !important; overflow: auto !important;\"]}"],["{\"selector\":\"#banner-mnz-topleft\",\"action\":[\"style\",\"height: 80px !important\"]}"],["{\"selector\":\"body\",\"action\":[\"style\",\"background-image: none !important;\"]}"],["{\"selector\":\"gdwc-recommendations.is-hidden\",\"action\":[\"style\",\"display: block !important;\"]}"],["{\"selector\":\"html[class^=\\\"loading\\\"]\",\"action\":[\"style\",\"visibility: visible !important;\"]}"],["{\"selector\":\".co-Widget[style=\\\"min-height: 6000px;\\\"]\",\"action\":[\"style\",\"min-height: auto !important;\"]}"],["{\"selector\":\"#ulCommentWidget[style*=\\\"display\\\"]\",\"action\":[\"style\",\"display: block !important;\"]}"],["{\"selector\":\"body[style=\\\"opacity: 0;\\\"]\",\"action\":[\"style\",\"opacity: 1 !important;\"]}"],["{\"selector\":\".inviewSection:not(.is-show)\",\"action\":[\"style\",\"transform: translateY(0) !important; opacity: 1 !important;\"]}"],["{\"selector\":\"[id]:has(> ins.adsbygoogle)\",\"action\":[\"style\",\"height: 100px !important; position: absolute !important; left: -4000px !important;\"]}"],["{\"selector\":\"table\",\"action\":[\"style\",\"visibility: visible !important;\"]}"],["{\"selector\":\"body\",\"action\":[\"style\",\"background: none !important;\"]}"],["{\"selector\":\".navbar-nav > li#navpromo2.nav-item > a[href^=\\\"http://www.toueapo.shop/\\\"]:not(:empty)\",\"action\":[\"style\",\"clip-path: circle(0) !important;\"]}"],["{\"selector\":\"button.flleft.btn-lg.btn-warning.btn.skip\",\"action\":[\"style\",\"display:block !important\"]}"],["{\"selector\":\"form > [id]\",\"action\":[\"style\",\"display: block !important;\"]}"],["{\"selector\":\".MediaStep\",\"action\":[\"style\",\"cursor: pointer !important;\"]}"],["{\"selector\":\".play-Imagemaker\",\"action\":[\"style\",\"height: 100% !important;\"]}"],["{\"selector\":\"#alf_continue_captcha\",\"action\":[\"style\",\"cursor: pointer !important; opacity: 1 !important;\"]}"],["{\"selector\":\".adsbygoogle\",\"action\":[\"style\",\"position:absolute !important;left:-3000px !important\"]}"],["{\"selector\":\".lm-hide\",\"action\":[\"style\",\"display: block !important;\"]}"],["{\"selector\":\".related_box:has(.adds)\",\"action\":[\"style\",\"height: 1px !important;\"]}"],["{\"selector\":\"#obalovydiv\",\"action\":[\"style\",\"display: block !important;\"]}"],["{\"selector\":\"a:has(img[src*=\\\"/download\\\"])\",\"action\":[\"style\",\"width: 300px !important; height: 300px !important; display: block !important;\"]}"],["{\"selector\":\".col-md-6\",\"action\":[\"style\",\"height: 150px !important;\"]}"],["{\"selector\":\"#devozon-snp, #submitBtn, #go_d\",\"action\":[\"style\",\"display: block !important;\"]}"],["{\"selector\":\"#js-mount-point-header.with-ad\",\"action\":[\"style\",\"min-height: auto !important\"]}"],["{\"selector\":\".lite-page__header-navigation--with-ad\",\"action\":[\"style\",\"top: 0 !important;\"]}","{\"selector\":\".research-resources-summary__inner.is-sticky\",\"action\":[\"style\",\"top: 0 !important;\"]}"],["{\"selector\":\"#link, center, #yuidea-snp, #btn6\",\"action\":[\"style\",\"display: block !important;\"]}"],["{\"selector\":\".blur-sm\",\"action\":[\"style\",\"filter: none !important;\"]}"],["{\"selector\":\"a.dl-stub:not([href])\",\"action\":[\"style\",\"cursor: pointer !important;\"]}"],["{\"selector\":\".su-note\",\"action\":[\"style\",\"display: block !important;\"]}"],["{\"selector\":\"*[style=\\\"display:none;\\\"]\",\"action\":[\"style\",\"display:block !important\"]}"],["{\"selector\":\"#tp-snp1, #go_d, #go_d2\",\"action\":[\"style\",\"display: block !important;\"]}"],["{\"selector\":\"#mw-content-text div[style] a:is([href*=\\\"contents.fc2.com\\\"], [href*=\\\"dmm.co.jp\\\"]) img\",\"action\":[\"style\",\"height: 0 !important;\"]}","{\"selector\":\"#mw-content-text div[style] a:is([href*=\\\"contents.fc2.com\\\"], [href*=\\\"dmm.co.jp\\\"])\",\"action\":[\"style\",\"font-size: 0 !important;\"]}"],["{\"selector\":\"form > div\",\"action\":[\"style\",\"display: flex !important;\"]}"],["{\"selector\":\"#adsads\",\"action\":[\"style\",\"height: 9px !important;\"]}"],["{\"selector\":\"#content\",\"action\":[\"style\",\"font-size: 0px !important;\"]}","{\"selector\":\"#yuidea-btn-after, #yuidea-btmbtn\",\"action\":[\"style\",\"display: block !important;\"]}"],["{\"selector\":\"#devozon-snp\",\"action\":[\"style\",\"display: block !important;\"]}"],["{\"selector\":\"div[class=\\\"\\\"][data-locker-id]\",\"action\":[\"style\",\"display:block !important\"]}"],["{\"selector\":\".ad-dfp\",\"action\":[\"style\",\"min-height: 0.1485mm !important; height: 0.1485mm !important;\"]}","{\"selector\":\".header-center\",\"action\":[\"style\",\"margin-top:-5000px !important;\"]}","{\"selector\":\".sidebar\",\"action\":[\"style\",\"width: 1.745px !important; padding: 1px !important\"]}"],["{\"selector\":\".link1\",\"action\":[\"style\",\"display: block !important;\"]}"],["{\"selector\":\"body[style=\\\"overflow: hidden;\\\"]\",\"action\":[\"style\",\"overflow: auto!important;\"]}"],["{\"selector\":\"body, body::before\",\"action\":[\"style\",\"background-image: unset !important;\"]}"],["{\"selector\":\".adtester-container\",\"action\":[\"style\",\"min-height: 0px !important; max-height: 1px !important; opacity: 0 !important;\"]}"],["{\"selector\":\"div[data-width][style*=\\\"background-image: url\\\"]\",\"action\":[\"style\",\"background: none !important\"]}"],["{\"selector\":\"#play_button\",\"action\":[\"style\",\"display:block!important;\"]}"],["{\"selector\":\"main::before\",\"action\":[\"style\",\"content: 'uBlock is unrelated to the well-known uBlock Origin.' !important; font-size: 32px !important; color: red !important; font-weight: bold !important;\"]}"],["{\"selector\":\"div.hero-unit > div.search-box--hero-unit::before\",\"action\":[\"style\",\"content: 'uBlock is unrelated to the well-known uBlock Origin.' !important; font-size: var(--font-size-h2) !important; color: red !important; font-weight: bold !important;\"]}"],["{\"selector\":\"#btnfianl\",\"action\":[\"style\",\"display: block !important;\"]}"],["{\"selector\":\"body > [class]\",\"action\":[\"style\",\"filter: none !important;\"]}","{\"selector\":\"body > [id]\",\"action\":[\"style\",\"filter: none !important;\"]}"],["{\"selector\":\"header.intro\",\"action\":[\"style\",\"margin-bottom: 0px !important;\"]}"],["{\"selector\":\"div.adsbygoogle.prebid.adocean.ado.ad.ads.advert.banner.reklama.linkSponsorowany.adsense.advertisments.reklama-top.adv_container\",\"action\":[\"style\",\"display: block !important\"]}"],["{\"selector\":\".adsbygoogle\",\"action\":[\"style\",\"height: 3px !important; display: block !important;\"]}"],["{\"selector\":\"#site-header\",\"action\":[\"style\",\"min-height: 0px !important;\"]}"],["{\"selector\":\"#targetdiv, #containerr\",\"action\":[\"style\",\"display: block !important;\"]}","{\"selector\":\"div[id][style=\\\"display: none;\\\"]\",\"action\":[\"style\",\"display: block !important;\"]}"],["{\"selector\":\"#targetdiv\",\"action\":[\"style\",\"display: inline !important;\"]}"],["{\"selector\":\".zc_top_mobil\",\"action\":[\"style\",\"display: block !important;\"]}"],["{\"selector\":\"html\",\"action\":[\"style\",\"overflow-y: auto !important;\"]}"],["{\"selector\":\".banner-inner\",\"action\":[\"style\",\"width: 0 !important;\"]}"],["{\"selector\":\"#primary\",\"action\":[\"style\",\"display: block !important;\"]}"],["{\"selector\":\"#video-container\",\"action\":[\"style\",\"display: block !important;\"]}"],["{\"selector\":\"#main, #ielement\",\"action\":[\"style\",\"display: block !important;\"]}"],["{\"selector\":\".st-btn > img\",\"action\":[\"style\",\"margin: auto !important; display: block !important;\"]}","{\"selector\":\".st-btn:not(.st-first)\",\"action\":[\"style\",\"display: inline-block !important; min-width: 50px !important; width: 50px !important;\"]}"],["{\"selector\":\"[id^=\\\"tp-snp\\\"]\",\"action\":[\"style\",\"display: block !important\"]}"],["{\"selector\":\"[class*=\\\"MPU\\\"]\",\"action\":[\"style\",\"height: 1px !important\"]}","{\"selector\":\"[id*=\\\"mpu\\\"]\",\"action\":[\"style\",\"height: 1px !important\"]}"],["{\"selector\":\"display-ad-component, [class^=\\\"DisplayAd\\\"], .ark-ad-message\",\"action\":[\"style\",\"visibility: collapse !important\"]}"],["{\"selector\":\".header\",\"action\":[\"style\",\"margin-top: 0px !important;\"]}"],["{\"selector\":\"ins.adsbygoogle\",\"action\":[\"style\",\"clip-path: circle(0) !important;\"]}"],["{\"selector\":\"body > div#wrapper\",\"action\":[\"style\",\"padding-top: 0px !important;\"]}"],["{\"selector\":\"#wpsafe-link, #wpsafe-generate\",\"action\":[\"style\",\"display: block !important;\"]}"],["{\"selector\":\".header, .leaflet-top.leaflet-left\",\"action\":[\"style\",\"top: 0 !important;\"]}","{\"selector\":\".map\",\"action\":[\"style\",\"top: 52px !important;\"]}"],["{\"selector\":\"#form > [id], [id^=\\\"wpsafe-link\\\"], [id^=\\\"plan\\\"], .wpsafelink-button, #wpsafelinkhuman, [id][style=\\\"display: none;\\\"]\",\"action\":[\"style\",\"display: block !important;\"]}"],["{\"selector\":\"div.pub_300x250.pub_300x250m.pub_728x90.text-ad.textAd.text_ad.text_ads.text-ads\",\"action\":[\"style\",\"display:block !important\"]}"],["{\"selector\":\".p-pageWrapper\",\"action\":[\"style\",\"margin-bottom: 0px !important;\"]}"],["{\"selector\":\"body > a > div[id]\",\"action\":[\"style\",\"background: var(--c-bg, #aae5a3) !important\"]}"],["{\"selector\":\"#getlink, #pop-button\",\"action\":[\"style\",\"display: block !important;\"]}"],["{\"selector\":\"#yuidea-snp\",\"action\":[\"style\",\"display: block !important\"]}"],["{\"selector\":\"form > [id][style=\\\"display: none;\\\"]\",\"action\":[\"style\",\"display:block !important;\"]}"],["{\"selector\":\"#makingdifferenttimer\",\"action\":[\"style\",\"display: block !important;\"]}"],["{\"selector\":\"#pro-continue, #pro-btn, #my-btn\",\"action\":[\"style\",\"display: block !important;\"]}"],["{\"selector\":\"#gtelinkbtn, #wpsafe-generate, #wpsafe-link\",\"action\":[\"style\",\"display: block !important;\"]}"]];

const hostnamesMap = new Map([["*",0],["alliptvlinks.com",1],["beermoneyforum.com",[1,94]],["yusepjaelani.blogspot.com",1],["greensboro.com",1],["investing.com",1],["ndtv.com",[1,220]],["photobucket.com",[1,232]],["techysnap.com",[1,50,83]],["web2.0rechner.de",1],["lojadebicicleta.com.br",3],["mcrypto.club",[4,50,51]],["bantenexis.com",4],["cdrab.com",[4,55]],["garoetpos.com",4],["gifans.com",4],["inbbotlist.com",4],["informaxonline.com",4],["iptvjournal.com",4],["techedubyte.com",4],["theusaposts.com",4],["tudaydeals.com",4],["ufacw.com",4],["winlator.com",4],["shorttrick.in",4],["7apple.net",4],["luckydice.net",4],["offerinfo.net",4],["toolss.net",4],["adarima.org",4],["segurosdevida.site",4],["1apple.xyz",4],["choiceappstore.xyz",4],["welovecrypto.xyz",4],["dktechnicalmate.com",5],["indiakablog.com",5],["financemonk.net",6],["fullfilmizle.cc",7],["filmizlehdfilm.com",7],["enit.in",8],["f2movies.to",10],["compucalitv.com",12],["crackllc.com",12],["designmodo.com",12],["megawarez.org",12],["procrackerz.org",12],["buktube.com",13],["fullxh.com",13],["megaxh.com",13],["seexh.com",13],["unlockxh4.com",13],["xhaccess.com",13],["xhadult2.com",13],["xhadult3.com",13],["xhadult4.com",13],["xhadult5.com",13],["xhamster46.com",13],["xhbig.com",13],["xhbranch5.com",13],["xhchannel.com",13],["xhchannel2.com",13],["xhday.com",13],["xhday1.com",13],["xhmoon5.com",13],["xhofficial.com",13],["xhopen.com",13],["xhplanet1.com",13],["xhplanet2.com",13],["xhreal2.com",13],["xhreal3.com",13],["xhspot.com",13],["xhtab2.com",13],["xhtab4.com",13],["xhtotal.com",13],["xhtree.com",13],["xhvictory.com",13],["xhwebsite.com",13],["xhwebsite2.com",13],["xhwebsite5.com",13],["xhwide1.com",13],["xhwide2.com",13],["xhwide5.com",13],["valuexh.life",13],["xhamsterporno.mx",13],["galleryxh.site",13],["movingxh.world",13],["xhdate.world",13],["xhlease.world",13],["xhxh3.xyz",13],["schools.snap.app",18],["snapinsta.app",18],["4j.com",18],["beaumontenterprise.com",18],["beautypackaging.com",18],["bigrapidsnews.com",18],["cmphost.com",[18,113]],["coatingsworld.com",18],["contractpharma.com",18],["ctinsider.com",18],["ctpost.com",18],["cybernews.com",18],["darientimes.com",18],["dmzj.com",18],["drinkspartner.com",[18,113]],["expressnews.com",18],["fansonlinehub.com",18],["review.firstround.com",18],["greenwichtime.com",18],["happi.com",18],["headlinerpost.com",[18,113]],["hindustantimes.com",18],["hotmediahub.com",18],["houstonchronicle.com",18],["ifenpaidy.com",18],["inkworldmagazine.com",18],["labelandnarrowweb.com",18],["lmtonline.com",18],["cinema.maalaimalar.com",18],["manisteenews.com",18],["michigansthumb.com",18],["middletownpress.com",18],["milfordmirror.com",18],["mpo-mag.com",18],["mrt.com",18],["myjournalcourier.com",18],["ncadvertiser.com",18],["newstimes.com",18],["nhregister.com",18],["nutraceuticalsworld.com",18],["odtmag.com",18],["ourmidland.com",18],["petri.com",18],["printedelectronicsnow.com",18],["publish0x.com",18],["registercitizen.com",18],["sfchronicle.com",18],["sheltonherald.com",18],["sna3talaflam.com",18],["soft3arbi.com",18],["sportstiger.com",18],["stamfordadvocate.com",18],["teraearn.com",18],["theheraldreview.com",18],["thehour.com",18],["theintelligencer.com",18],["theridgefieldpress.com",18],["thetelegraph.com",18],["timesunion.com",18],["tribuna.com",18],["trumbulltimes.com",18],["uploadsoon.com",[18,113]],["viralxns.com",[18,113]],["vuinsider.com",18],["walletinvestor.com",18],["wiltonbulletin.com",18],["yourconroenews.com",18],["eltiempo.es",18],["terabox.fun",18],["top.gg",[18,338]],["primeos.in",18],["techishant.in",18],["wp.uploadfiles.in",[18,113]],["palatifini.it",18],["leechpremium.link",18],["teralink.me",18],["terashare.me",18],["bccondos.net",18],["linkneverdie.net",18],["posterify.net",[18,113]],["abczdrowie.pl",[18,422]],["autocentrum.pl",[18,422]],["autokult.pl",[18,422]],["benchmark.pl",[18,422]],["deliciousmagazine.pl",[18,422]],["dobreprogramy.pl",[18,422]],["fotoblogia.pl",[18,422]],["gadzetomania.pl",[18,422]],["genialne.pl",[18,422]],["jastrzabpost.pl",[18,422]],["kafeteria.pl",[18,422]],["komorkomania.pl",[18,422]],["money.pl",[18,422]],["o2.pl",[18,422]],["parenting.pl",[18,422]],["polygamia.pl",[18,422]],["pudelek.pl",[18,422]],["pysznosci.pl",[18,422]],["wp.pl",[18,422]],["advertiserandtimes.co.uk",18],["carbonite.co.za",18],["amateurs-fuck.com",23],["falatron.com",23],["sex-amateur-clips.com",23],["sexmadeathome.com",23],["comicxxx.eu",23],["arrowos.net",27],["drstevenlin.com",31],["romaniataramea.com",31],["straatosphere.com",31],["discussingfilm.net",31],["rmweb.co.uk",31],["interactivemap.app",33],["begadistrictnews.com.au",34],["bendigoadvertiser.com.au",34],["goulburnpost.com.au",34],["maitlandmercury.com.au",34],["newcastleherald.com.au",34],["brisbanetimes.com.au",35],["smh.com.au",35],["theage.com.au",35],["watoday.com.au",35],["examiner.com.au",36],["theadvocate.com.au",36],["thecourier.com.au",36],["gumtree.com.au",37],["nowtolove.com.au",38],["screenhub.com.au",39],["taste.com.au",40],["btv.bg",41],["btvnovinite.bg",41],["btvsport.bg",41],["cryptobr.biz",42],["loskatchorros.com.br",43],["dausel.co",43],["onle.co",43],["dexterclearance.com",43],["how2electronics.com",43],["onlinestudentseva.com",43],["univers-simu.com",43],["stokerpiller.dk",43],["reclameaqui.com.br",44],["citynews.ca",45],["trueachievements.com",45],["truesteamachievements.com",45],["truetrophies.com",45],["tvtv.ca",46],["tvtv.us",46],["blick.ch",47],["tinys.click",48],["askpaccosi.com",48],["coin-free.com",48],["ezeviral.com",48],["kienthucrangmieng.com",48],["pngreal.com",48],["apkupload.in",48],["ytpng.net",48],["dailynew.online",48],["earnme.club",49],["usanewstoday.club",49],["jrlinks.in",49],["audiencepool.com",[50,83]],["model-tas-terbaru.com",[50,216]],["therootdroid.com",[50,216]],["moddingzone.in",[50,216,358]],["worldappsstore.xyz",[50,216]],["geniussolutions.co",52],["fartechy.com",52],["foodxor.com",52],["mealcold.com",52],["mixrootmods.com",52],["djpunjab2.in",52],["djqunjab.in",52],["lawyex.co",53],["homeculina.com",53],["ineedskin.com",53],["kenzo-flowertag.com",53],["mdn.lol",53],["plagiarismchecker.co",54],["duplichecker.com",54],["smallseotools.com",54],["plagiarismdetector.net",54],["searchenginereports.net",54],["reminimod.co",55],["admediaflex.com",55],["aduzz.com",55],["amanguides.com",55],["deezloaded.com",[55,86]],["mb.feedale.com",55],["forexsalary.com",55],["getintoway.com",55],["highkeyfinance.com",55],["iconicblogger.com",55],["investcrust.com",55],["itechmafiia.com",55],["jardima.com",[55,86]],["kreatifparenting.com",55],["krishiloksewa.com",55],["litonmods.com",55],["mamatamusicbanaras.com",55],["missionupsc.com",55],["blog.nationapk.com",55],["odisha-remix.com",55],["owsafe.com",55],["placementsmela.com",55],["ryuugames.com",55],["sportsonfr.com",55],["technoinformations.com",55],["visflakes.com",[55,86]],["worldmak.com",55],["apkandroidhub.in",[55,86,87]],["dailywebsite.in",55],["filesupload.in",55],["panda.freemodsapp.in",55],["gamepure.in",[55,86]],["modzilla.in",55],["rsrlink.in",55],["themoviesradar.in",55],["warrenrahul.in",[55,86]],["bitcrypto.info",55],["sportweb.info",55],["datacheap.io",55],["adcrypto.net",55],["dulichkhanhhoa.net",[55,86]],["gurumu.net",55],["mad.gplpalace.one",[55,86]],["savego.org",55],["hbz.us",55],["noithatmyphu.vn",[55,86]],["freemodsapp.xyz",55],["modmakers.xyz",[55,86]],["studyis.xyz",[55,86]],["shortix.co",56],["takez.co",57],["tech5s.co",58],["trip.businessnews-nigeria.com",58],["ez4mods.com",58],["mobi2c.com",58],["te-it.com",58],["world2our.com",58],["bluetechno.net",58],["forexit.online",58],["theblock.co",59],["veganab.co",60],["camdigest.com",60],["101soundboards.com",61],["1cloudfile.com",62],["247sports.com",63],["360haven.com",64],["5ggyan.com",65],["apps2app.com",[65,76]],["6abc.com",66],["abc11.com",66],["abc13.com",66],["abc30.com",66],["abc7.com",66],["abc7chicago.com",66],["abc7news.com",66],["abc7ny.com",66],["abcotvs.net",66],["ac-illust.com",67],["photo-ac.com",67],["acetack.com",68],["androidquest.com",68],["apklox.com",68],["gujarativyakaran.com",68],["kisantime.com",68],["pastescript.com",68],["trimorspacks.com",68],["chhaprawap.in",68],["kashmirstudentsinformation.in",68],["shetkaritoday.in",68],["updrop.link",68],["addictinggames.com",69],["additudemag.com",70],["aemenstore.com",71],["byboe.com",71],["cazzette.com",71],["dreamcheeky.com",71],["fidlarmusic.com",71],["hookeaudio.com",71],["jncojeans.com",71],["kiemlua.com",71],["kingsleynyc.com",71],["lucidcam.com",71],["nguyenvanbao.com",71],["nousdecor.com",71],["pennbookcenter.com",71],["publicananker.com",71],["restorbio.com",71],["rezence.com",71],["staaker.com",71],["thegoneapp.com",71],["uebnews.online",71],["afreesms.com",72],["apekite.com",73],["cureclues.com",73],["en.financerites.com",73],["healthfirstweb.com",73],["howifx.com",73],["junkyponk.com",73],["livenewsflix.com",73],["mythvista.com",73],["vocalley.com",73],["yogablogfit.com",73],["apkmirror.com",74],["appkamods.com",75],["careersides.com",75],["edukaroo.com",75],["funkeypagali.com",75],["indiamaja.com",75],["infinityskull.com",75],["jkssbalerts.com",75],["nayisahara.com",75],["newedutopics.com",75],["spatsify.com",75],["starxinvestor.com",75],["viewmyknowledge.com",75],["wikifilmia.com",75],["getviralreach.in",75],["iisfvirtual.in",75],["newshuta.in",75],["tea-coffee.net",75],["appsbull.com",77],["diudemy.com",77],["maqal360.com",77],["appvn.com",78],["arkadium.com",79],["time.artjoey.com",80],["ashemaletube.com",81],["atozmath.com",82],["autoblog.com",84],["awgrow.com",85],["babymodz.com",[86,87,88]],["teknomuda.com",[86,283]],["theconomy.me",86],["isi7.net",86],["motorantik.store",[86,283]],["bangpremier.com",89],["bankbazaar.com",90],["bartendingexpert.com",91],["easyworldbusiness.com",[91,138]],["nichapk.com",[91,138]],["riveh.com",[91,138]],["bazadecrypto.com",92],["beckershospitalreview.com",93],["best-mobilegames.com",95],["bharatsarkarijobalert.com",95],["creditsgoal.com",95],["freshbhojpuri.com",95],["moderngyan.com",95],["learn.moderngyan.com",95],["earn.mpscstudyhub.com",95],["quotesopia.com",95],["earn.quotesopia.com",95],["money.quotesopia.com",95],["bankshiksha.in",95],["bgmi32bitapk.in",95],["sattakingcharts.in",95],["bettycrocker.com",96],["bing.com",97],["bitchesgirls.com",98],["bitzite.com",99],["blindhypnosis.com",100],["bloggingaro.com",101],["gyanitheme.com",101],["hipsonyc.com",[101,175]],["theforyou.in",101],["hostadviser.net",101],["bloggingguidance.com",102],["onroid.com",102],["viralsbaba1.blogspot.com",103],["bookriot.com",104],["boundingintocomics.com",105],["themix.net",105],["br0wsers.com",106],["carbuzz.com",107],["cbssports.com",108],["chess.com",109],["chinhnhacoban.com",110],["tremamnon.com",110],["vnpttelle.com",110],["claimfey.com",111],["club386.com",112],["cnn.com",114],["coins-town.com",115],["coinseidon.com",116],["paidinsurance.in",116],["conghuongtu.net",116],["comicbook.com",117],["content-loader.com",118],["css-load.com",118],["html-load.com",118],["img-load.com",118],["cookpad.com",119],["urbanmilwaukee.com",119],["phica.net",119],["crypto4yu.com",120],["wiour.com",120],["btcbitco.in",120],["btcsatoshi.net",120],["readbitcoin.org",120],["currentrecruitment.com",121],["investorveda.com",121],["curs-germana.com",122],["freewebcart.com",122],["pervertgirlsvideos.com",122],["securityweek.com",122],["customercareal.com",123],["cyberstumble.com",124],["cybertyrant.com",125],["gdspike.com",125],["maxxfour.com",125],["profitshort.com",125],["technorozen.com",125],["uses-in-hindi.com",125],["blog.workedbd.com",125],["advisecreate.fun",125],["hubdrive.me",125],["courselinkfree.us",125],["dads-banging-teens.com",126],["home-xxx-videos.com",126],["mature-chicks.com",126],["teens-fucking-matures.com",126],["redirect.dafontvn.com",127],["dailydot.com",128],["eschenker.dbschenker.com",129],["digg.com",130],["digilibraries.com",131],["blog.disheye.com",132],["distrowatch.com",133],["dogemate.com",134],["drphil.com",135],["dubznetwork.com",136],["dvm360.com",137],["efukt.com",139],["safe.elektroupdate.com",140],["gameguardian.net",140],["eloshapes.com",141],["enterinit.com",142],["esopress.com",143],["estudyme.com",144],["facebook.com",145],["facebookwkhpilnemxj7asaniu7vnjjbiltxjqhye3mhbshg7kx5tfyd.onion",145],["fandom.com",146],["fapeza.com",147],["farsroid.com",148],["ff14angler.com",149],["filerox.com",150],["filext.com",151],["finchtechie.com",152],["foodupe.com",153],["forexrw7.com",154],["fx-22.com",154],["mooonten.com",154],["gold-24.net",154],["msic.site",154],["foxnews.com",155],["francoischarron.com",156],["freeroms.com",157],["fuqer.com",158],["gamepedia.com",159],["games2rule.com",160],["games4king.com",161],["getmodsapk.com",162],["gifmagic.com",163],["giphy.com",164],["glosbe.com",165],["governing.com",166],["graphicuv.com",167],["hit-films.com",167],["learnmany.in",167],["greentumble.com",168],["techhelpbd.com",168],["her.ie",168],["gumtree.com",169],["h-flash.com",170],["hamrojaagir.com",171],["kbconlinegame.com",171],["odijob.com",171],["healthy4pepole.com",172],["fx-gd.net",172],["hightrip.net",172],["to-travel.net",172],["hentaipaw.com",173],["hero-magazine.com",174],["meclipstudy.in",175],["hitproversion.com",176],["hole-io.com",177],["honkailab.com",178],["igg-games.com",179],["ign.com",180],["ilbianconero.com",181],["imgtaxi.com",182],["imgur.com",183],["in-jpn.com",[184,185]],["oninet.ne.jp",[184,185,382,383]],["xth.jp",[184,382,384]],["infinityfree.com",186],["dogdrip.net",186],["instagram.com",187],["iseekgirls.com",188],["italpress.com",189],["root-nation.com",189],["itscybertech.com",190],["itstillworks.com",191],["javbake.com",192],["javdoge.com",192],["javsexfree.com",192],["javcensored.net",192],["javuncensored.watch",192],["javchill.com",193],["javcl.com",194],["javfull.net",194],["javynow.com",195],["jayisgames.com",196],["jzzo.com",197],["karistudio.com",198],["karvitt.com",199],["kiktu.com",200],["techcyan.com",200],["upshrink.com",200],["banaraswap.in",200],["trangchu.news",200],["hints.littlealchemy2.com",201],["los40.com",202],["lovetoknow.com",203],["makemoneywithurl.com",204],["mangabuddy.com",205],["mapcrunch.com",206],["masterduelmeta.com",207],["mastharyana.com",208],["quickimageconverter.com",208],["remixbass.com",208],["techipop.com",208],["techyember.com",208],["mathway.com",209],["mbjremix.com",210],["neverdims.com",210],["ottlatest.com",210],["unfoldedstars.com",210],["mayaremix.in",210],["bit4me.info",210],["deltabtc.xyz",210],["mediafire.com",211],["mediaite.com",212],["mercatinomusicale.com",213],["mind42.com",214],["www.mindbodygreen.com",215],["model-viewer.com",217],["mrproblogger.com",218],["themezon.net",218],["muropaketti.com",219],["gadgets.ndtv.com",221],["nme.com",222],["novelgames.com",223],["nytimes.com",[224,225]],["nytimes3xbfgragh.onion",224],["cooking.nytimes.com",226],["orbispatches.com",227],["pcgamesn.com",228],["theloadout.com",228],["pcmag.com",229],["peakpx.com",230],["pxfuel.com",230],["phineypet.com",231],["crewbase.net",231],["pikist.com",233],["pixlr.com",234],["plasticsnews.com",235],["playmod24.com",236],["playok.com",237],["plotaroute.com",238],["politico.com",239],["popculture.com",240],["porndoe.com",241],["pornve.com",242],["pranarevitalize.com",243],["redfea.com",243],["techyinfo.in",243],["fitnessholic.net",243],["proappapk.com",244],["adzz.in",[244,347]],["progfu.com",245],["freethailottery.live",245],["psprices.com",246],["qwant.com",247],["qz.com",248],["rain-alarm.com",249],["new.reddit.com",250],["www.reddit.com",250],["reidoplacar.com",251],["forum.release-apk.com",252],["reuters.com",253],["ricettafitness.com",254],["comidacaseira.me",254],["rocketnews24.com",255],["soranews24.com",255],["youpouch.com",[255,311]],["sabornutritivo.com",256],["tecnologiati.online",256],["chan.sankakucomplex.com",257],["schnittberichte.com",258],["sevenjournals.com",259],["uptechnologys.com",259],["sexodi.com",260],["shemalestube.com",261],["shortenbuddy.com",262],["shorterall.com",263],["promo-visits.site",263],["link.smallseostat.com",264],["sportbible.com",265],["tyla.com",265],["gamingbible.co.uk",265],["stardewids.com",266],["uschovna.cz",266],["vladan.fr",266],["commands.gg",266],["kitguru.net",266],["steamidfinder.com",267],["sturls.com",268],["subsvip.com",269],["sugarona.com",270],["sumikai.com",271],["supergoku.com",272],["ta2deem7arbya.com",273],["taisachonthi.com",274],["tamrieltradecentre.com",275],["tcsjerky.com",276],["techjunkie.com",277],["techkeshri.com",278],["trickms.com",278],["gorating.in",278],["loanteacher.in",278],["techpowerup.com",279],["techsignin.com",280],["techusnews.com",281],["universitiesonline.xyz",281],["techymedies.com",282],["the-sun.com",284],["theblockcrypto.com",285],["thedailybeast.com",286],["thefastcode.com",287],["theodysseyonline.com",288],["thequint.com",289],["therealdeal.com",290],["thespruce.com",291],["thestar.com",292],["thumpertalk.com",293],["totalcsgo.com",294],["trendyoum.com",295],["tumblr.com",296],["twi-fans.com",297],["typingtest.com",298],["upornia.com",299],["usatoday.com",300],["viefaucet.com",301],["vix.com",302],["vrcmods.com",303],["w3schools.com",304],["washingtonpost.com",305],["wikihow.com",306],["wowescape.com",307],["wunderground.com",308],["xenvn.com",309],["xtube.com",310],["yourdictionary.com",312],["yourstory.com",313],["zee5.com",314],["zubatecno.com",315],["battleroyal.online",315],["blog.panytourism.online",315],["idnes.cz",316],["zive.cz",317],["decrypt.day",318],["bild.de",319],["businessinsider.de",320],["chip.de",321],["praxistipps.chip.de",322],["praxistipps.focus.de",[322,324]],["netmoms.de",322],["duden.de",323],["rechtschreibpruefung24.de",325],["wa.de",326],["web.de",327],["elmundo.es",328],["gigantti.fi",329],["fiches-auto.fr",330],["handirect.fr",331],["orange.fr",332],["aiimgvlog.fun",333],["claim.fun",334],["romsmania.games",335],["app.scope.gg",336],["teemo.gg",337],["u.gg",339],["win.gg",340],["gazzetta.gr",341],["sdna.gr",342],["kelasexcel.id",343],["thejournal.ie",344],["00m.in",345],["m.aajtak.in",346],["akcartoons.in",348],["cybercityhelp.in",348],["apkmodhub.in",349],["bookszone.in",350],["businesstoday.in",[351,352]],["indiatoday.in",[351,357]],["intoday.in",[351,357]],["computerpedia.in",353],["decathlon.in",354],["filmypoints.in",355],["finclub.in",356],["financeyogi.net",356],["naukrilelo.in",359],["petrainer.in",360],["rphost.in",361],["techurlshort.in",361],["shrinkforearn.in",362],["techincubator.in",363],["ffworld.xyz",363],["thizissam.in",364],["l2db.info",365],["nifteam.info",366],["mag.shock2.info",367],["dragontea.ink",368],["work.ink",369],["colonist.io",370],["app.koinly.io",371],["tmail.io",372],["hdmotori.it",373],["ilmeteo.it",374],["ilprimatonazionale.it",375],["lastampa.it",376],["anikore.jp",377],["infoseek.co.jp",378],["itmedia.co.jp",379],["mustar.meitetsu.co.jp",380],["e-begin.jp",381],["japscan.lol",385],["adyou.me",386],["blog24.me",387],["mboost.me",388],["picrew.me",389],["skiplink.me",390],["alrakoba.net",391],["azrom.net",392],["calculator-online.net",393],["chrysler-club.net",394],["download.megaup.net",395],["metastats.net",396],["otechno.net",397],["pixiv.net",398],["researchgate.net",399],["sahlmarketing.net",400],["schoolcheats.net",401],["sex-torrent.net",402],["xxxrip.net",402],["sextor.org",402],["domaha.tv",402],["sonixgvn.net",403],["uprot.net",404],["yoshare.net",405],["wiki.yjsnpi.nu",406],["exactpay.online",407],["maxlinks.online",408],["maxstreams.site",408],["maxstream.video",408],["mphealth.online",409],["shopforex.online",410],["3dmodelshare.org",411],["aternos.org",412],["link.idblog.eu.org",413],["garrysmods.org",414],["hltv.org",415],["homeairquality.org",416],["sensualgirls.org",417],["telepisodes.org",418],["ublock.org",419],["support.ublock.org",420],["hosty.uprwssp.org",421],["lowcygier.pl",423],["player.pl",424],["skmedix.pl",425],["www.wp.pl",426],["adsy.pw",427],["playstore.pw",428],["profit.ro",429],["businesstimes.com.sg",430],["oko.sh",431],["adseek.site",432],["ptube.pipio.site",433],["cryptofun.space",434],["bigbtc.win",434],["goku.sx",435],["haonguyen.top",436],["bishopsstortfordindependent.co.uk",437],["cambridgeindependent.co.uk",437],["dissexpress.co.uk",437],["fenlandcitizen.co.uk",437],["granthamjournal.co.uk",437],["kentonline.co.uk",437],["lynnnews.co.uk",437],["newarkadvertiser.co.uk",437],["rutland-times.co.uk",437],["spaldingtoday.co.uk",437],["stamfordmercury.co.uk",437],["suffolknews.co.uk",437],["velvetmag.co.uk",437],["games.dailymail.co.uk",438],["faroutmagazine.co.uk",439],["fplstatistics.co.uk",440],["idealhome.co.uk",441],["look.co.uk",441],["gktech.uk",442],["metoffice.gov.uk",443],["coingraph.us",444],["impact24.us",444],["vieon.vn",445],["voz.vn",446],["rule34.xxx",447],["bloggertheme.xyz",448],["insurglobal.xyz",449],["jeuxenligne.xyz",450],["lrncook.xyz",451],["yalifin.xyz",451],["nishankhatri.xyz",452],["sitecuatui.xyz",453]]);

const entitiesMap = new Map([["web2.0calc",1],["streamingcommunity",1],["5movies",2],["allgamesejogos",3],["bemestarglobal",3],["gamesgo",3],["redecanais",3],["apkmaven",[4,5]],["dropgalaxy",6],["filmizletv",7],["financerites",8],["finanzen",9],["fmovies",10],["gmx",11],["hackstore",12],["hamsterix",13],["xhamster",13],["xhamster1",13],["xhamster10",13],["xhamster11",13],["xhamster12",13],["xhamster13",13],["xhamster14",13],["xhamster15",13],["xhamster16",13],["xhamster17",13],["xhamster18",13],["xhamster19",13],["xhamster2",13],["xhamster20",13],["xhamster3",13],["xhamster4",13],["xhamster42",13],["xhamster5",13],["xhamster7",13],["xhamster8",13],["ibomma",14],["leechall",15],["mlwbd",16],["movies123",17],["moviesjoy",18],["netpornix",19],["oxy",20],["pixhost",21],["pornhub",22],["pornocomics",23],["samehadaku",24],["stream4free",25],["strikeout",26],["tvshows4mobile",27],["txxx",28],["videovard",29],["writedroid",30],["yts",31],["zshort",32]]);

const exceptionsMap = new Map([["support.ublock.org",[419]]]);

self.declarativeImports = self.declarativeImports || [];
self.declarativeImports.push({ argsList, hostnamesMap, entitiesMap, exceptionsMap });

/******************************************************************************/

})();

/******************************************************************************/
