/*******************************************************************************

    uBlock Origin Lite - a comprehensive, MV3-compliant content blocker
    Copyright (C) 2014-present Raymond Hill

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see {http://www.gnu.org/licenses/}.

    Home: https://github.com/gorhill/uBlock
*/

/* jshint esversion:11 */

'use strict';

// ruleset: rus-0

/******************************************************************************/

// Important!
// Isolate from global scope
(function uBOL_cssDeclarativeImport() {

/******************************************************************************/

const argsList = [["{\"selector\":\"#wrapper:not(#id)\",\"action\":[\"style\",\"margin-top: 67px !important\"]}"],["{\"selector\":\"html:not(#id)\",\"action\":[\"style\",\"background-image: none !important\"]}"],["{\"selector\":\"body[class^=\\\"has-brand\\\"][class*=\\\" active-brand\\\"][class*=\\\"fixed-header\\\"] > [id$=\\\"er\\\"]:nth-child(-1n+3)\",\"action\":[\"style\",\"width: unset !important\"]}","{\"selector\":\"body[class^=\\\"has-brand\\\"][class*=\\\" active-brand\\\"][class*=\\\"fixed-header\\\"]\",\"action\":[\"style\",\"padding-top: 0 !important; background-color: inherit !important\"]}"],["{\"selector\":\"#FheaderContent > div[id]:not([class])\",\"action\":[\"style\",\"min-height: 0 !important\"]}"],["{\"selector\":\"#wr-bg\",\"action\":[\"style\",\"padding-top: 60px !important; margin-top: unset !important; top: unset !important\"]}"],["{\"selector\":\".wrap\",\"action\":[\"style\",\"padding-top: 0 !important\"]}"],["{\"selector\":\"#site\",\"action\":[\"style\",\"top: 0 !important\"]}"],["{\"selector\":\"body\",\"action\":[\"style\",\"padding-top: 0 !important; background-color: transparent !important\"]}"],["{\"selector\":\"#id_box_r_y1\",\"action\":[\"style\",\"position: absolute !important; top: -10000px !important; left: -10000px !important; height: 50px !important\"]}","{\"selector\":\"#idbbbad\",\"action\":[\"style\",\"position: absolute !important; top: -10000px !important; left: -10000px !important; height: 50px !important\"]}"],["{\"selector\":\".site-logo\",\"action\":[\"style\",\"max-height: 90px !important; width: auto !important\"]}"],["{\"selector\":\"div[class=\\\"article vid\\\"]\",\"action\":[\"style\",\"margin-top: auto !important\"]}"],["{\"selector\":\".mdspost > div[class]\",\"action\":[\"style\",\"min-height: 0 !important\"]}","{\"selector\":\"header > div[class]\",\"action\":[\"style\",\"min-height: 0 !important\"]}"],["{\"selector\":\".av-branding .page\",\"action\":[\"style\",\"padding-top: 0 !important; padding-bottom: 0 !important\"]}","{\"selector\":\".av-branding\",\"action\":[\"style\",\"background: none !important\"]}"],["{\"selector\":\"[data-test-id=\\\"avia_form\\\"] > div[class*=\\\"footer\\\"] label\",\"action\":[\"style\",\"zoom: 2 !important; color: #f57c00 !important; font-weight: bold !important\"]}"],["{\"selector\":\"#page\",\"action\":[\"style\",\"padding-top: 0 !important\"]}"],["{\"selector\":\"body.blocked\",\"action\":[\"style\",\"overflow: auto !important\"]}"],["{\"selector\":\"body\",\"action\":[\"style\",\"overflow: auto !important\"]}"],["{\"selector\":\"body[class*=\\\"modal-\\\"]\",\"action\":[\"style\",\"overflow: auto !important\"]}"],["{\"selector\":\"body:not(#id)\",\"action\":[\"style\",\"background-image: none !important\"]}"],["{\"selector\":\"#page\",\"action\":[\"style\",\"top: 0 !important\"]}"],["{\"selector\":\"#mainWrapper\",\"action\":[\"style\",\"background: none !important; padding-top: 0 !important\"]}"],["{\"selector\":\".adfox-banner-background ~ .layout-container\",\"action\":[\"style\",\"max-width: unset !important; top: unset !important\"]}"],["{\"selector\":\".g-container-outer > div\",\"action\":[\"style\",\"height: auto !important\"]}"],["{\"selector\":\".b-global-branding[branding_url*=\\\"http\\\"] .b-global-wrap\",\"action\":[\"style\",\"cursor: auto !important\"]}","{\"selector\":\".b-global-wrap > .b-global-offset\",\"action\":[\"style\",\"padding: unset !important\"]}"],["{\"selector\":\".SubjectMenu_desktop.PageLayout-Nav\",\"action\":[\"style\",\"position: sticky !important\"]}","{\"selector\":\"main > div:first-child:empty + div:not([class]) > div\",\"action\":[\"style\",\"min-height: 86px !important; height: 86px !important; margin-bottom: -80px !important\"]}"],["{\"selector\":\".googlead.pub_300x250.pub_300x250m.pub_728x90.text-ad.textAd.text_ad.text_ads.text-ads.text-ad-links\",\"action\":[\"style\",\"display: block !important\"]}"],["{\"selector\":\".main\",\"action\":[\"style\",\"padding-top: 0 !important\"]}"],["{\"selector\":\"html[class] > body\",\"action\":[\"style\",\"background-color: #e6e6e6 !important\"]}"],["{\"selector\":\".full-banner-page\",\"action\":[\"style\",\"padding-top: 0 !important\"]}"],["{\"selector\":\".app__wrapper div[style^=\\\"width: calc(100% \\\"]\",\"action\":[\"style\",\"width: unset !important\"]}","{\"selector\":\".b-page\",\"action\":[\"style\",\"padding-top: 0 !important\"]}","{\"selector\":\".head-stripe\",\"action\":[\"style\",\"position: fixed !important; transform: scale(0) !important\"]}","{\"selector\":\".monetization-group > .monetization-group__item\",\"action\":[\"style\",\"height: auto !important\"]}","{\"selector\":\".serp-header\",\"action\":[\"style\",\"margin-top: 0 !important\"]}","{\"selector\":\".suggest2_align_center[data-bem*=\\\"weather_\\\"]\",\"action\":[\"style\",\"max-width: 100% !important\"]}","{\"selector\":\"body.b-page > .b-page__container .card.content__adv.card\",\"action\":[\"style\",\"margin-bottom: unset !important; padding: unset !important\"]}","{\"selector\":\"body[class*=\\\"exp_ym-referrer-original-url\\\"] div[class*=\\\"_type_\\\"]\",\"action\":[\"style\",\"min-height: 0 !important; height: unset !important\"]}","{\"selector\":\"body[class*=\\\"exp_ym-referrer-original-url\\\"] div[class*=\\\"rect\\\"][id][data-name]\",\"action\":[\"style\",\"min-height: 0 !important; height: unset !important\"]}","{\"selector\":\"body[class*=\\\"exp_ym-referrer-original-url\\\"] div[class*=\\\"turbo-\\\"][class*=\\\"load-error\\\"]\",\"action\":[\"style\",\"min-height: 0 !important; margin-top: unset !important; margin-bottom: unset !important\"]}"],["{\"selector\":\".b-page_type_maps div[class$=\\\"__content\\\"] > [class$=\\\"__ad\\\"] > div\",\"action\":[\"style\",\"width: unset !important\"]}","{\"selector\":\".climate-calendar__cell\",\"action\":[\"style\",\"width: 13.8% !important; -webkit-flex-basis: 13.8% !important; flex-basis: 13.8% !important\"]}"],["{\"selector\":\".b-page.overlay\",\"action\":[\"style\",\"overflow-y: auto !important\"]}","{\"selector\":\".b-page[style*=\\\"padding-right:\\\"]\",\"action\":[\"style\",\"overflow-y: auto !important; padding-right: 0 !important\"]}"],["{\"selector\":\"[class*=\\\"ComposeDoneScreen\\\"] *\",\"action\":[\"style\",\"height: auto !important; min-height: 0 !important\"]}"],["{\"selector\":\"body.no-scroll\",\"action\":[\"style\",\"overflow: visible !important\"]}"],["{\"selector\":\".StationPage__centralArea\",\"action\":[\"style\",\"margin-top: 20px !important\"]}"],["{\"selector\":\".drowmenu\",\"action\":[\"style\",\"z-index: 1999999999 !important\"]}","{\"selector\":\".list-nav\",\"action\":[\"style\",\"z-index: 1 !important\"]}","{\"selector\":\"body > .main.wrapper\",\"action\":[\"style\",\"margin-top: 0 !important\"]}","{\"selector\":\"body > header\",\"action\":[\"style\",\"top: 0 !important\"]}","{\"selector\":\"html > body:not(#id)\",\"action\":[\"style\",\"background-image: none !important\"]}"],["{\"selector\":\"#cams_top_block\",\"action\":[\"style\",\"height: 0 !important\"]}","{\"selector\":\".banner\",\"action\":[\"style\",\"height: 0 !important\"]}"],["{\"selector\":\"#page\",\"action\":[\"style\",\"max-width: 1600px !important; margin-top: 0 !important\"]}"],["{\"selector\":\"#wrapper > .menu\",\"action\":[\"style\",\"margin-top: auto !important\"]}"],["{\"selector\":\"html > body\",\"action\":[\"style\",\"padding-top: unset !important\"]}"],["{\"selector\":\"body:not(#id)\",\"action\":[\"style\",\"padding-top: 0 !important\"]}"],["{\"selector\":\"body > #container\",\"action\":[\"style\",\"margin-top: 0 !important\"]}"],["{\"selector\":\".has-top-liner .ln__topliner\",\"action\":[\"style\",\"top: unset !important\"]}","{\"selector\":\".has-top-liner\",\"action\":[\"style\",\"padding-top: unset !important\"]}"],["{\"selector\":\".body-wrap > #content\",\"action\":[\"style\",\"margin-top:42px !important\"]}"],["{\"selector\":\".wrapper main\",\"action\":[\"style\",\"margin-top: 0 !important\"]}"],["{\"selector\":\".center-box2\",\"action\":[\"style\",\"margin-top: 0 !important\"]}"],["{\"selector\":\".wrapper > .main-content\",\"action\":[\"style\",\"margin-top: 0 !important\"]}"],["{\"selector\":\"#oframeflashcontent > pjsdiv[style*=\\\"transition: transform\\\"]\",\"action\":[\"style\",\"transform: none !important\"]}","{\"selector\":\"video\",\"action\":[\"style\",\"filter: none !important\"]}"],["{\"selector\":\"html > body\",\"action\":[\"style\",\"cursor: default !important\"]}"],["{\"selector\":\".main\",\"action\":[\"style\",\"cursor: auto !important\"]}"],["{\"selector\":\"body > .wrapper\",\"action\":[\"style\",\"margin-top: 0 !important; max-width: unset !important\"]}"],["{\"selector\":\"body\",\"action\":[\"style\",\"background-image: none !important\"]}"],["{\"selector\":\"body\",\"action\":[\"style\",\"background: none !important\"]}"],["{\"selector\":\".content > .sect-header\",\"action\":[\"style\",\"margin-bottom: 0 !important\"]}","{\"selector\":\".content\",\"action\":[\"style\",\"padding-top: 0 !important\"]}","{\"selector\":\".full\",\"action\":[\"style\",\"padding-top: 0 !important\"]}","{\"selector\":\".popular-in\",\"action\":[\"style\",\"padding-top: 80px !important\"]}","{\"selector\":\".sticky-wrap\",\"action\":[\"style\",\"position: relative !important\"]}","{\"selector\":\".wrap > .popular\",\"action\":[\"style\",\"visibility: visible !important\"]}","{\"selector\":\"main > .wrap-center\",\"action\":[\"style\",\"margin-left: auto !important; margin-right: auto !important\"]}"],["{\"selector\":\".commercial-branding > div script ~ div > div\",\"action\":[\"style\",\"min-height: 0 !important\"]}","{\"selector\":\".commercial-branding > div script ~ div > div:last-child div\",\"action\":[\"style\",\"min-height: 0 !important\"]}","{\"selector\":\".commercial-branding article > div:only-child > div:first-child + div > div > div:first-child + div\",\"action\":[\"style\",\"box-shadow: none !important\"]}"],["{\"selector\":\"#content-padding > *\",\"action\":[\"style\",\"color: black !important\"]}","{\"selector\":\"#content-padding\",\"action\":[\"style\",\"color: white !important\"]}"],["{\"selector\":\".b-chat\",\"action\":[\"style\",\"margin-bottom: 0 !important\"]}"],["{\"selector\":\"body.access *\",\"action\":[\"style\",\"filter: none !important\"]}","{\"selector\":\"body.access\",\"action\":[\"style\",\"overflow: auto !important; position: relative !important\"]}"],["{\"selector\":\"body\",\"action\":[\"style\",\"background-color: white !important\"]}"],["{\"selector\":\".header-logo__link > img\",\"action\":[\"style\",\"display: block !important\"]}","{\"selector\":\".page-sidebar > .sticky-vertical\",\"action\":[\"style\",\"position: relative !important; top: 0 !important\"]}","{\"selector\":\"html:not(#id)\",\"action\":[\"style\",\"padding-top: 0 !important\"]}"],["{\"selector\":\"#body\",\"action\":[\"style\",\"margin-top: 0 !important\"]}"],["{\"selector\":\"header[class=\\\"header -transparent\\\"]\",\"action\":[\"style\",\"background: #e0e0e0 !important\"]}"],["{\"selector\":\".fon_site_pic\",\"action\":[\"style\",\"background-image: none !important; padding-top: 0 !important\"]}"],["{\"selector\":\".u-extend-fix\",\"action\":[\"style\",\"background: center / 100% 100% no-repeat #515151 var(--res-logo) !important; border-radius: 6px !important\"]}","{\"selector\":\"[data-track]\",\"action\":[\"style\",\"min-height: 0 !important; padding-top: unset !important; padding-bottom: unset !important; box-shadow: inherit !important\"]}","{\"selector\":\"div[class*=\\\"--content article \\\"] + div ~ div:last-child > div:first-child:not(:only-child)\",\"action\":[\"style\",\"max-width: unset !important\"]}","{\"selector\":\"div[itemtype*=\\\"://schema.org/BlogPosting\\\"] > div:last-child > div:first-child + div[class]\",\"action\":[\"style\",\"width: unset !important; margin-left: unset !important\"]}","{\"selector\":\"div[itemtype*=\\\"://schema.org/BlogPosting\\\"] > div:last-child > div:first-child:not(:only-child)\",\"action\":[\"style\",\"max-width: unset !important\"]}","{\"selector\":\"div[itemtype*=\\\"://schema.org/BlogPosting\\\"] > div:not(:last-child)\",\"action\":[\"style\",\"min-height: 0 !important; padding-top: unset !important; padding-bottom: unset !important; box-shadow: inherit !important\"]}","{\"selector\":\"div[itemtype*=\\\"://schema.org/Photograph\\\"] > div:last-child > div:first-child + div[class]\",\"action\":[\"style\",\"width: unset !important; margin-left: unset !important\"]}","{\"selector\":\"div[itemtype*=\\\"://schema.org/Photograph\\\"] > div:last-child > div:first-child:not(:only-child)\",\"action\":[\"style\",\"max-width: unset !important\"]}","{\"selector\":\"div[itemtype*=\\\"://schema.org/Photograph\\\"] > div:not(:last-child)\",\"action\":[\"style\",\"min-height: 0 !important; padding-top: unset !important; padding-bottom: unset !important; box-shadow: inherit !important\"]}","{\"selector\":\"div[itemtype*=\\\"://schema.org/Product\\\"] ~ div:not(:last-child)\",\"action\":[\"style\",\"min-height: 0 !important; padding-top: unset !important; padding-bottom: unset !important; box-shadow: inherit !important\"]}","{\"selector\":\"div[itemtype*=\\\"://schema.org/Review\\\"] ~ div:last-child > div:first-child + div[class]\",\"action\":[\"style\",\"width: unset !important; margin-left: unset !important\"]}","{\"selector\":\"div[itemtype*=\\\"://schema.org/Review\\\"] ~ div:last-child > div:first-child:not(:only-child)\",\"action\":[\"style\",\"max-width: unset !important\"]}","{\"selector\":\"div[itemtype*=\\\"://schema.org/Review\\\"] ~ div:not(:last-child)\",\"action\":[\"style\",\"min-height: 0 !important; padding-top: unset !important; padding-bottom: unset !important; box-shadow: inherit !important\"]}"],["{\"selector\":\"body > *\",\"action\":[\"style\",\"pointer-events: auto\"]}"],["{\"selector\":\"body\",\"action\":[\"style\",\"padding-top: 0 !important; background: whitesmoke !important; overflow: auto !important; pointer-events: none\"]}","{\"selector\":\"html\",\"action\":[\"style\",\"padding-top: 0 !important; background: whitesmoke !important; overflow: auto !important; pointer-events: none\"]}"],["{\"selector\":\".maincontent\",\"action\":[\"style\",\"margin-top: 0 !important\"]}"],["{\"selector\":\"[data-bookmaker-id]\",\"action\":[\"style\",\"pointer-events: none !important\"]}"],["{\"selector\":\"body:not(#id)\",\"action\":[\"style\",\"overflow-y: auto !important\"]}"],["{\"selector\":\"a[href*=\\\"://artline.ua/\\\"]\",\"action\":[\"style\",\"pointer-events: none !important\"]}","{\"selector\":\"a[href*=\\\"://bit.ly/\\\"]\",\"action\":[\"style\",\"pointer-events: none !important\"]}"],["{\"selector\":\".roarticlecol\",\"action\":[\"style\",\"top: 2px !important\"]}","{\"selector\":\"body > div:not([id]):not([class]) > div[class] > div[class]\",\"action\":[\"style\",\"background-image: none !important\"]}","{\"selector\":\"body > div:not([id]):not([class]) > div[class]\",\"action\":[\"style\",\"padding-top: unset !important; background-color: inherit !important\"]}"],["{\"selector\":\"body.modal-open\",\"action\":[\"style\",\"overflow: auto !important\"]}"],["{\"selector\":\".main.with-top-menu\",\"action\":[\"style\",\"padding-top: 100px !important\"]}"],["{\"selector\":\"body > *\",\"action\":[\"style\",\"pointer-events: auto !important\"]}"],["{\"selector\":\"body\",\"action\":[\"style\",\"cursor: default !important; pointer-events: none !important; background-color: transparent !important\"]}"],["{\"selector\":\"#page-content\",\"action\":[\"style\",\"margin-top: 0 !important\"]}"],["{\"selector\":\".footer\",\"action\":[\"style\",\"position: relative !important\"]}"],["{\"selector\":\"#reader_pane\",\"action\":[\"style\",\"padding-right: unset !important\"]}","{\"selector\":\"#sinner_container\",\"action\":[\"style\",\"display: block !important; z-index: 0 !important\"]}","{\"selector\":\".ad_title\",\"action\":[\"style\",\"display: block !important; position: fixed !important; top: -10000px !important; left: -10000px !important\"]}","{\"selector\":\".adsbygoogle\",\"action\":[\"style\",\"display: block !important\"]}","{\"selector\":\".leaderboard_ad\",\"action\":[\"style\",\"display: block !important; position: fixed !important; top: -10000px !important; left: -10000px !important\"]}"],["{\"selector\":\"body[style*=\\\"overflow: hidden;\\\"]\",\"action\":[\"style\",\"overflow: auto !important\"]}"],["{\"selector\":\".b-content__pagecontent > .b-content--wrapper > .g-grid\",\"action\":[\"style\",\"margin-top: unset !important\"]}","{\"selector\":\"body:not(#id) > .b-content.b-content__breadcrumbs\",\"action\":[\"style\",\"margin-top: unset !important\"]}","{\"selector\":\"body:not(#id) > .b-content__pagecontent\",\"action\":[\"style\",\"margin-top: unset !important\"]}"],["{\"selector\":\".body_content_table > .left.column\",\"action\":[\"style\",\"margin-right: 0 !important; width: 100% !important\"]}","{\"selector\":\".body_wrapper\",\"action\":[\"style\",\"max-width: 100% !important\"]}","{\"selector\":\".fullscreen_branding ~ .body_content_table\",\"action\":[\"style\",\"margin-top: 0 !important; z-index: 0 !important\"]}","{\"selector\":\".left.column > #question.dialog_thanks\",\"action\":[\"style\",\"left: 67% !important\"]}"],["{\"selector\":\"body:not(#id)\",\"action\":[\"style\",\"margin-top: 0 !important\"]}"],["{\"selector\":\".smb-bg\",\"action\":[\"style\",\"background: none !important\"]}","{\"selector\":\".wrapper > #tm\",\"action\":[\"style\",\"margin-bottom: auto !important\"]}"],["{\"selector\":\".tm-wrapper > .tm\",\"action\":[\"style\",\"margin-bottom: auto !important\"]}","{\"selector\":\"body\",\"action\":[\"style\",\"background: #eee !important\"]}"],["{\"selector\":\"#page-wrapper > #header\",\"action\":[\"style\",\"margin-bottom: auto !important\"]}","{\"selector\":\"#page-wrapper > .tm-wrapper > .tm\",\"action\":[\"style\",\"margin-bottom: auto !important\"]}","{\"selector\":\"#page-wrapper\",\"action\":[\"style\",\"background-color: white !important\"]}"],["{\"selector\":\"#page-wrapper .container\",\"action\":[\"style\",\"max-width: 100% !important\"]}","{\"selector\":\"#page-wrapper > #wrapper\",\"action\":[\"style\",\"padding-top: 0 !important\"]}"],["{\"selector\":\".b-background\",\"action\":[\"style\",\"background: none !important; padding-top: 0 !important\"]}"],["{\"selector\":\"body\",\"action\":[\"style\",\"margin-top: auto !important\"]}"],["{\"selector\":\"body > .wrapper > *\",\"action\":[\"style\",\"pointer-events: auto !important\"]}","{\"selector\":\"body > .wrapper\",\"action\":[\"style\",\"pointer-events: none !important\"]}"],["{\"selector\":\".s-layout > div[class]\",\"action\":[\"style\",\"min-height: 0 !important\"]}"],["{\"selector\":\".mainpage > div[class]\",\"action\":[\"style\",\"min-height: 0 !important\"]}"],["{\"selector\":\"body > .navbar\",\"action\":[\"style\",\"margin-top: 0 !important\"]}","{\"selector\":\"html > body\",\"action\":[\"style\",\"background-color: white !important\"]}"],["{\"selector\":\".main__branding\",\"action\":[\"style\",\"margin-top: 0 !important\"]}","{\"selector\":\".news-line > .news-line__block\",\"action\":[\"style\",\"-webkit-animation: none !important; animation: none !important\"]}","{\"selector\":\".news-line > .news-line__block:hover\",\"action\":[\"style\",\"-webkit-animation: scroll 30s linear 0s infinite !important; animation: scroll 30s linear 0s infinite !important\"]}"],["{\"selector\":\"body > .header\",\"action\":[\"style\",\"margin-top: 0 !important\"]}"],["{\"selector\":\".downloadlink a\",\"action\":[\"style\",\"color: #09c !important; text-decoration: underline !important\"]}","{\"selector\":\".post-info > div[style^=\\\"width: 730px;\\\"][style*=\\\"#f9f9f9\\\"]\",\"action\":[\"style\",\"background-color: #333 !important\"]}","{\"selector\":\"body > div\",\"action\":[\"style\",\"filter: none !important; -webkit-filter: none !important\"]}"],["{\"selector\":\"[class*=\\\"_no_abs\\\"] > *\",\"action\":[\"style\",\"height: auto !important\"]}","{\"selector\":\"[class*=\\\"_no_abs\\\"]\",\"action\":[\"style\",\"height: auto !important\"]}"],["{\"selector\":\".header-clear\",\"action\":[\"style\",\"margin-bottom: 0 !important\"]}"],["{\"selector\":\"#topbrandingspot\",\"action\":[\"style\",\"padding-top: 0 !important; background: none !important\"]}","{\"selector\":\"html:not(#id) > body\",\"action\":[\"style\",\"background: none !important\"]}"],["{\"selector\":\"#ad_global_below_navbar\",\"action\":[\"style\",\"position: fixed !important; transform: scale(0) !important; top: -10000px !important\"]}","{\"selector\":\"#header ~ *\",\"action\":[\"style\",\"position: fixed !important; transform: scale(0) !important; top: -10000px !important\"]}","{\"selector\":\".above_body > div[style]\",\"action\":[\"style\",\"height: auto !important\"]}"],["{\"selector\":\".branding .main-content\",\"action\":[\"style\",\"margin-top: 90px !important\"]}","{\"selector\":\".poster-grid-item > a[target=\\\"_blank\\\"]:first-child\",\"action\":[\"style\",\"pointer-events: none !important\"]}","{\"selector\":\"html[xmlns]\",\"action\":[\"style\",\"background-image: none !important\"]}"],["{\"selector\":\"div[id*=\\\"-error-page\\\"] > p\",\"action\":[\"style\",\"height: 0 !important; opacity: 0 !important\"]}"],["{\"selector\":\".fader-social\",\"action\":[\"style\",\"position: fixed !important; top: -10000px !important; opacity: 0 !important; z-index: -9999 !important\"]}"],["{\"selector\":\".social-open\",\"action\":[\"style\",\"overflow: auto !important\"]}"],["{\"selector\":\"body:not(#id) .all-wrapper\",\"action\":[\"style\",\"top: 0 !important\"]}","{\"selector\":\"body:not(#id) .bottom-bar\",\"action\":[\"style\",\"top: 0 !important\"]}"],["{\"selector\":\"html:not(#id) > body:not(#id)\",\"action\":[\"style\",\"background: none !important\"]}"],["{\"selector\":\".tpc > .post > a[href]\",\"action\":[\"style\",\"word-break: break-all\"]}","{\"selector\":\".tpc > .post > table[width] > tbody > tr > .lgf\",\"action\":[\"style\",\"word-break: break-word\"]}"],["{\"selector\":\"div#body_container\",\"action\":[\"style\",\"margin-top: 0 !important; margin-bottom: 0 !important\"]}"],["{\"selector\":\"html\",\"action\":[\"style\",\"overflow: auto !important\"]}"],["{\"selector\":\"html > body\",\"action\":[\"style\",\"overflow: auto !important\"]}"],["{\"selector\":\".btn-download\",\"action\":[\"style\",\"opacity: 1 !important; pointer-events: auto !important\"]}"],["{\"selector\":\".mainContainer\",\"action\":[\"style\",\"padding-top: 0 !important\"]}"],["{\"selector\":\".admineditor-menu\",\"action\":[\"style\",\"margin-top: 0 !important\"]}"],["{\"selector\":\"body > #td-outer-wrap > *\",\"action\":[\"style\",\"pointer-events: auto !important\"]}","{\"selector\":\"body > #td-outer-wrap\",\"action\":[\"style\",\"pointer-events: none !important; cursor: auto !important\"]}","{\"selector\":\"html > body\",\"action\":[\"style\",\"background-image: none !important; background-color: #e8e8e8 !important; cursor: auto !important\"]}"],["{\"selector\":\".page-content\",\"action\":[\"style\",\"background-color: inherit !important\"]}","{\"selector\":\".page-content\",\"action\":[\"style\",\"padding-top: 0 !important\"]}"],["{\"selector\":\"body > .header-menu-bg\",\"action\":[\"style\",\"margin-bottom: 0 !important\"]}"],["{\"selector\":\"body\",\"action\":[\"style\",\"cursor: auto !important\"]}"],["{\"selector\":\"body\",\"action\":[\"style\",\"pointer-events: none !important\"]}"],["{\"selector\":\".head-top\",\"action\":[\"style\",\"position: absolute !important\"]}","{\"selector\":\"body\",\"action\":[\"style\",\"background: #091016 !important\"]}"],["{\"selector\":\"header .container\",\"action\":[\"style\",\"padding-top: 30px !important\"]}"],["{\"selector\":\".navbar\",\"action\":[\"style\",\"position: relative !important\"]}","{\"selector\":\".right-column > .sticky-box\",\"action\":[\"style\",\"position: relative !important\"]}","{\"selector\":\"body\",\"action\":[\"style\",\"padding-top: unset !important\"]}"],["{\"selector\":\".JoinForm__notNow\",\"action\":[\"style\",\"font-weight: bold !important; color: red !important; border: 3px solid red !important; padding: 6px !important\"]}","{\"selector\":\"body.video_showcase #page_body\",\"action\":[\"style\",\"max-width: 100% !important\"]}","{\"selector\":\"body.video_showcase .VideoGrid.video_items_list\",\"action\":[\"style\",\"max-width: 97% !important\"]}","{\"selector\":\"body.video_showcase .VideoLayout\",\"action\":[\"style\",\"max-width: 100% !important\"]}","{\"selector\":\"body.video_showcase .VideoSearchInput\",\"action\":[\"style\",\"max-width: 100% !important\"]}"],["{\"selector\":\".PhotoPrimaryAttachment__background[src*=\\\"userapi.com/impf/\\\"][src*=\\\"blur=\\\"]\",\"action\":[\"style\",\"filter: blur(20px) !important\"]}"],["{\"selector\":\"body > #layout-center > *\",\"action\":[\"style\",\"pointer-events: auto !important\"]}","{\"selector\":\"body > #layout-center\",\"action\":[\"style\",\"pointer-events: none !important\"]}"],["{\"selector\":\"#header_box\",\"action\":[\"style\",\"height: auto !important; min-height: auto !important\"]}"],["{\"selector\":\"body.home\",\"action\":[\"style\",\"overflow: auto !important\"]}"],["{\"selector\":\"#footer\",\"action\":[\"style\",\"background: none !important; padding: 0 !important\"]}","{\"selector\":\"#top-line\",\"action\":[\"style\",\"background: none !important; padding: 0 !important; height: auto !important\"]}","{\"selector\":\"body:not(#id)\",\"action\":[\"style\",\"background-color: #9ab9a7 !important\"]}"],["{\"selector\":\".branding_wrapper > *\",\"action\":[\"style\",\"pointer-events: auto !important\"]}","{\"selector\":\".branding_wrapper\",\"action\":[\"style\",\"pointer-events: none !important\"]}"],["{\"selector\":\".wrapper > header\",\"action\":[\"style\",\"margin-top: 15px !important\"]}"],["{\"selector\":\".main-wrapper\",\"action\":[\"style\",\"margin-top: 0 !important\"]}"],["{\"selector\":\".page-wrapper\",\"action\":[\"style\",\"margin-top: 0 !important\"]}"],["{\"selector\":\".footer\",\"action\":[\"style\",\"background: #1c1e1f !important; color: #fff !important\"]}","{\"selector\":\".gallery_img_preload\",\"action\":[\"style\",\"position: absolute !important; display: block !important; opacity: 0 !important; margin-top: 155px !important; margin-left: 20px !important; width: calc(100% - 40%);\"]}","{\"selector\":\".lstfml .footer .links a\",\"action\":[\"style\",\"color: #fff !important\"]}","{\"selector\":\"body\",\"action\":[\"style\",\"background-image: none !important; background-color: #1c1e1f !important\"]}"],["{\"selector\":\".body > .body\",\"action\":[\"style\",\"user-select: text !important; -moz-user-select: text !important; -webkit-user-select: text !important\"]}"],["{\"selector\":\".cookie-paywall-visible div > .article-body-content ~ .article-body-content\",\"action\":[\"style\",\"display: flex !important\"]}"],["{\"selector\":\".i-layout__branding-content-wrapper\",\"action\":[\"style\",\"margin-top: 0 !important\"]}","{\"selector\":\".i-layout_branding\",\"action\":[\"style\",\"background-image: none !important\"]}"],["{\"selector\":\"#topper_up\",\"action\":[\"style\",\"height: 88px !important\"]}"],["{\"selector\":\".main\",\"action\":[\"style\",\"margin-top: 2px !important\"]}"],["{\"selector\":\"#alert > *\",\"action\":[\"style\",\"pointer-events: auto\"]}","{\"selector\":\"#alert\",\"action\":[\"style\",\"pointer-events: none\"]}","{\"selector\":\"body\",\"action\":[\"style\",\"background: black !important; cursor: default\"]}"],["{\"selector\":\"#mainContainer\",\"action\":[\"style\",\"cursor: auto !important; padding-top: unset !important; background-color: inherit !important\"]}"],["{\"selector\":\".b-cell > div[id]\",\"action\":[\"style\",\"padding-top: 0 !important\"]}"],["{\"selector\":\"body:not(#id) .header\",\"action\":[\"style\",\"margin-top: 0 !important\"]}"],["{\"selector\":\".td-header-sp-logo\",\"action\":[\"style\",\"max-height: 90px !important\"]}"],["{\"selector\":\".newsfeed\",\"action\":[\"style\",\"height: auto !important\"]}"],["{\"selector\":\".footer-logo\",\"action\":[\"style\",\"filter: invert(0.8) !important\"]}","{\"selector\":\"img[src=\\\"/vision/footer-logo.png\\\"]\",\"action\":[\"style\",\"filter: invert(0.8) !important\"]}"],["{\"selector\":\".td-ad-background-link #td-outer-wrap\",\"action\":[\"style\",\"cursor: default !important\"]}"],["{\"selector\":\"#SITE_PAGES > div > div[id]\",\"action\":[\"style\",\"min-height: auto !important\"]}","{\"selector\":\"[data-mesh-id]\",\"action\":[\"style\",\"min-height: auto !important; height: auto !important\"]}"],["{\"selector\":\"body > #page\",\"action\":[\"style\",\"margin-top: 0 !important\"]}"],["{\"selector\":\".home\",\"action\":[\"style\",\"background-image: none !important; padding-top: 0 !important\"]}"],["{\"selector\":\".header\",\"action\":[\"style\",\"top: 0 !important\"]}"],["{\"selector\":\".overlayed .bottom-page.scroll-block\",\"action\":[\"style\",\"filter: none !important; -webkit-filter: none !important\"]}"],["{\"selector\":\".post_content.newsletter\",\"action\":[\"style\",\"max-height: unset !important\"]}"],["{\"selector\":\"body\",\"action\":[\"style\",\"position: unset !important\"]}"],["{\"selector\":\"[data-test-id=\\\"News_SpecialArticle\\\"] + div[class]:not(:empty) + div[class]:not(:empty)\",\"action\":[\"style\",\"min-height: auto !important\"]}","{\"selector\":\"[data-test-id=\\\"News_SpecialArticle\\\"] + div[class]:not(:empty)\",\"action\":[\"style\",\"min-height: auto !important\"]}","{\"selector\":\"[data-test-id=\\\"News_SpecialArticle\\\"] ~ div[class]:empty + div[class]:not(:empty) + div[class]:not(:empty)\",\"action\":[\"style\",\"min-height: auto !important\"]}","{\"selector\":\"[data-test-id=\\\"News_SpecialArticle\\\"] ~ div[class]:empty + div[class]:not(:empty)\",\"action\":[\"style\",\"min-height: auto !important\"]}","{\"selector\":\"[data-test-id=\\\"News_SpecialArticle\\\"]:empty\",\"action\":[\"style\",\"min-height: auto !important\"]}","{\"selector\":\"body > #app [data-branding-wrapper]\",\"action\":[\"style\",\"padding-top: 0 !important\"]}","{\"selector\":\"body > #app div[style=\\\"display:block !important\\\"] > div:first-child > div:first-child + div > div:first-child + div > div[data-name]:first-child + div\",\"action\":[\"style\",\"margin-top: auto !important\"]}"],["{\"selector\":\".buttonContainer[data-name=\\\"play\\\"][style*=\\\"left: 10px;\\\"]\",\"action\":[\"style\",\"opacity: unset !important\"]}"],["{\"selector\":\"html > body:not(#id)\",\"action\":[\"style\",\"overflow: auto !important\"]}"],["{\"selector\":\"body\",\"action\":[\"style\",\"background-color: inherit !important\"]}"],["{\"selector\":\".main-container\",\"action\":[\"style\",\"margin-top: 0 !important\"]}"],["{\"selector\":\".article > .onadlable ~ .js-mediator-article a[href]:not([href^=\\\"/\\\"]):not([href^=\\\"#\\\"]):not([href*=\\\"3dnews.\\\"])\",\"action\":[\"style\",\"pointer-events: none !important; text-decoration: none !important; color: inherit !important\"]}"],["{\"selector\":\"body\",\"action\":[\"style\",\"background: #e8ecff !important\"]}"],["{\"selector\":\".page-layout-without-banner\",\"action\":[\"style\",\"margin-top: 0 !important\"]}"],["{\"selector\":\".top-line + header.main\",\"action\":[\"style\",\"top: auto !important\"]}"],["{\"selector\":\".redirect-button\",\"action\":[\"style\",\"pointer-events: auto !important; opacity: 1 !important\"]}"],["{\"selector\":\".have-brand .wrap\",\"action\":[\"style\",\"margin-top: 0 !important\"]}"],["{\"selector\":\".hide-dn img\",\"action\":[\"style\",\"filter: none !important\"]}"],["{\"selector\":\".have-brand .obertka-in\",\"action\":[\"style\",\"margin-top: 70px !important\"]}"],["{\"selector\":\".DefaultLayout-main\",\"action\":[\"style\",\"margin-top: 0 !important\"]}","{\"selector\":\"body\",\"action\":[\"style\",\"padding-right: unset !important; overflow: auto !important\"]}"],["{\"selector\":\".quote a.btn\",\"action\":[\"style\",\"pointer-events: auto !important\"]}"],["{\"selector\":\"html.dark-mode > body\",\"action\":[\"style\",\"filter: invert(90%) !important\"]}","{\"selector\":\"html.dark-mode > iframe\",\"action\":[\"style\",\"filter: none !important\"]}","{\"selector\":\"html.dark-mode\",\"action\":[\"style\",\"filter: none !important\"]}"],["{\"selector\":\"main > .container\",\"action\":[\"style\",\"padding-top: 0 !important; margin-top: 0 !important\"]}"],["{\"selector\":\"#embed-video > [id^=\\\"blink\\\"]\",\"action\":[\"style\",\"-webkit-animation: none !important; animation: none !important; color: var(--color--normal) !important; font-weight: normal !important\"]}","{\"selector\":\".navbart > a[href] > .spin\",\"action\":[\"style\",\"animation-name: none !important\"]}","{\"selector\":\".publisher-name > [id^=\\\"blink\\\"]\",\"action\":[\"style\",\"-webkit-animation: none !important; animation: none !important; color: var(--color--normal) !important; font-weight: normal !important\"]}"],["{\"selector\":\".dwrp\",\"action\":[\"style\",\"margin-top: 0 !important\"]}"],["{\"selector\":\"body > .all-wrap\",\"action\":[\"style\",\"margin-top: 0 !important\"]}"],["{\"selector\":\"body.ReactModal__Body--open\",\"action\":[\"style\",\"overflow: auto !important\"]}"],["{\"selector\":\".article__bg\",\"action\":[\"style\",\"left: 49% !important\"]}"],["{\"selector\":\".wrap\",\"action\":[\"style\",\"padding-top: 0 !important; top: 0 !important\"]}"],["{\"selector\":\"body > #header\",\"action\":[\"style\",\"top: 0 !important\"]}","{\"selector\":\"body > .page\",\"action\":[\"style\",\"padding-top: 144px !important\"]}"],["{\"selector\":\"body > .widget_header .header_icons\",\"action\":[\"style\",\"top: 0 !important\"]}","{\"selector\":\"body > .widget_header .lang_switcher\",\"action\":[\"style\",\"top: 0 !important\"]}","{\"selector\":\"body > .widget_header .menu\",\"action\":[\"style\",\"top: 0 !important\"]}","{\"selector\":\"body > .widget_header\",\"action\":[\"style\",\"padding-top: 60px !important\"]}"],["{\"selector\":\"body > #right ~ .middle\",\"action\":[\"style\",\"margin-right: 4px !important\"]}"],["{\"selector\":\".ReactVirtualized__Grid__innerScrollContainer\",\"action\":[\"style\",\"height: auto !important\"]}","{\"selector\":\".fs-table__row\",\"action\":[\"style\",\"position: initial !important\"]}","{\"selector\":\".fs-table__row[style^=\\\"height: 162px;\\\"]\",\"action\":[\"style\",\"height: auto !important\"]}"],["{\"selector\":\".wrap > .block\",\"action\":[\"style\",\"margin-top: 0 !important\"]}"],["{\"selector\":\"body > .wrapper\",\"action\":[\"style\",\"margin-top: 0 !important\"]}"],["{\"selector\":\"#container\",\"action\":[\"style\",\"cursor: auto !important\"]}"],["{\"selector\":\"#sitebox:not(#id)\",\"action\":[\"style\",\"margin-top: 0 !important\"]}"],["{\"selector\":\".page\",\"action\":[\"style\",\"margin-top: 0 !important\"]}"],["{\"selector\":\".right-column > .b-newsfeed > span\",\"action\":[\"style\",\"margin-top: 0 !important\"]}"],["{\"selector\":\"#wrapper\",\"action\":[\"style\",\"margin-top: 0 !important\"]}"],["{\"selector\":\"body:not(#id)\",\"action\":[\"style\",\"padding-top: 0 !important; padding-bottom: 0 !important\"]}"],["{\"selector\":\"body > div[class^=\\\"wrapper\\\"]\",\"action\":[\"style\",\"margin-top: 0 !important\"]}"],["{\"selector\":\".downloada > .btn\",\"action\":[\"style\",\"font-size: large !important; color: #b4ff00 !important\"]}","{\"selector\":\".downloada\",\"action\":[\"style\",\"display: block !important\"]}","{\"selector\":\".main_shift\",\"action\":[\"style\",\"height: 100px !important\"]}"],["{\"selector\":\"[href*=\\\"poluchenie-premium-dostupa.html\\\"] > b > .fa-spin\",\"action\":[\"style\",\"animation: none !important\"]}"],["{\"selector\":\"#videoViewPlayer\",\"action\":[\"style\",\"padding-top: unset !important\"]}"],["{\"selector\":\"*\",\"action\":[\"style\",\"-webkit-touch-callout: default !important; -webkit-user-select: text !important; -moz-user-select: text !important; -ms-user-select: text !important; user-select: text !important\"]}"],["{\"selector\":\"header > .body\",\"action\":[\"style\",\"margin-top: 54px !important\"]}"],["{\"selector\":\"body > #page\",\"action\":[\"style\",\"margin-top: 65px !important\"]}","{\"selector\":\"html > body\",\"action\":[\"style\",\"background-image: none !important; background-color: transparent !important\"]}"],["{\"selector\":\".banner\",\"action\":[\"style\",\"height: 90px !important\"]}"],["{\"selector\":\".blocked .text\",\"action\":[\"style\",\"filter: none !important; -webkit-filter: none !important\"]}","{\"selector\":\".blocked\",\"action\":[\"style\",\"filter: none !important; -webkit-filter: none !important\"]}","{\"selector\":\".locked .example\",\"action\":[\"style\",\"filter: none !important; -webkit-filter: none !important\"]}"],["{\"selector\":\"#subheader\",\"action\":[\"style\",\"padding-top: 0 !important\"]}"],["{\"selector\":\"#main-wrapper\",\"action\":[\"style\",\"top: 0 !important\"]}"],["{\"selector\":\".right-sidebar\",\"action\":[\"style\",\"margin-top: 0 !important; overflow: hidden !important\"]}"],["{\"selector\":\".scrollable > #thumbs\",\"action\":[\"style\",\"width: max-content !important\"]}","{\"selector\":\".scrollable\",\"action\":[\"style\",\"overflow-x: auto !important; padding-bottom: 16px !important\"]}"],["{\"selector\":\"#comments_block\",\"action\":[\"style\",\"margin-top: unset !important\"]}","{\"selector\":\".embed-instagram > iframe\",\"action\":[\"style\",\"max-width: unset !important\"]}"],["{\"selector\":\"#top_banner:not(#id)\",\"action\":[\"style\",\"display: block !important; pointer-events: none !important; opacity: 0 !important; height: 0 !important\"]}","{\"selector\":\".advt:not(#id)\",\"action\":[\"style\",\"display: block !important; pointer-events: none !important; opacity: 0 !important; height: 0 !important\"]}","{\"selector\":\".sidebar\",\"action\":[\"style\",\"top: 0 !important\"]}","{\"selector\":\"div[class]:not([id]):first-child:only-child > div[class]:not([id]):first-child:only-child > div[class]:not([id]):first-child:only-child\",\"action\":[\"style\",\"height: unset !important\"]}"],["{\"selector\":\".right-banner > div\",\"action\":[\"style\",\"height: auto !important\"]}","{\"selector\":\"a[href*=\\\"adpool.bet/\\\"]\",\"action\":[\"style\",\"pointer-events: none !important; opacity: 0 !important; height: 0 !important\"]}","{\"selector\":\"body > .wrapper > #main\",\"action\":[\"style\",\"overflow: hidden !important\"]}"],["{\"selector\":\".dpbAll\",\"action\":[\"style\",\"display: block !important\"]}"],["{\"selector\":\".block-content > .ageLimit ~ [class$=\\\"-player\\\"]\",\"action\":[\"style\",\"display: block !important\"]}","{\"selector\":\".block-content\",\"action\":[\"style\",\"min-height: unset !important\"]}"],["{\"selector\":\".page-column > .right-adv-container\",\"action\":[\"style\",\"top: 100px !important\"]}"],["{\"selector\":\"body\",\"action\":[\"style\",\"background-image: none !important; background-color: #ffffff !important; padding-top: 0 !important\"]}"],["{\"selector\":\"div[class^=\\\"right-block\\\"][style^=\\\"min-height:\\\"]\",\"action\":[\"style\",\"min-height: 0 !important\"]}"],["{\"selector\":\"img[src]\",\"action\":[\"style\",\"filter: none !important\"]}"],["{\"selector\":\".main .header\",\"action\":[\"style\",\"padding-top: 94px !important\"]}","{\"selector\":\".showfull .header\",\"action\":[\"style\",\"padding-top: 60px !important\"]}"],["{\"selector\":\".wrapper\",\"action\":[\"style\",\"margin-top: 0 !important\"]}"],["{\"selector\":\".header\",\"action\":[\"style\",\"padding-block-start: 0 !important\"]}"],["{\"selector\":\"body > .wrapper\",\"action\":[\"style\",\"padding-top: 0 !important; padding-bottom: 0 !important\"]}","{\"selector\":\"body\",\"action\":[\"style\",\"padding-top: 0 !important; padding-bottom: 0 !important; background-image: none !important\"]}"],["{\"selector\":\".bg_container > .wrapper-content\",\"action\":[\"style\",\"padding-top: 0 !important\"]}"],["{\"selector\":\"body > section[class*=\\\"section details\\\"]\",\"action\":[\"style\",\"padding-top: 70px !important\"]}"],["{\"selector\":\"iframe.youtube-video:not([src*=\\\"//utraff.com/\\\"])\",\"action\":[\"style\",\"display: block !important\"]}"],["{\"selector\":\".content:not(#id)\",\"action\":[\"style\",\"margin-top: 80px !important\"]}"],["{\"selector\":\".footer\",\"action\":[\"style\",\"margin-top: 20px !important\"]}","{\"selector\":\".out__inner > header\",\"action\":[\"style\",\"visibility: inherit !important\"]}"],["{\"selector\":\"main > .container\",\"action\":[\"style\",\"margin-top: 50px !important\"]}"],["{\"selector\":\".page-content\",\"action\":[\"style\",\"margin-top: 0 !important\"]}"],["{\"selector\":\"aside > div.overflow-hidden + .block-sidebar-wrapper\",\"action\":[\"style\",\"margin-top: 0 !important\"]}"],["{\"selector\":\"div[class^=\\\"headbg\\\"] > .menu .sar\",\"action\":[\"style\",\"bottom: auto !important; top: 50px !important; z-index: 100 !important\"]}","{\"selector\":\"div[class^=\\\"headbg\\\"] > .menu\",\"action\":[\"style\",\"top: 0 !important\"]}","{\"selector\":\"div[class^=\\\"headbg\\\"]\",\"action\":[\"style\",\"background-image: none !important; height: auto !important\"]}"],["{\"selector\":\".container > header\",\"action\":[\"style\",\"margin-top: 10px !important\"]}","{\"selector\":\".topside\",\"action\":[\"style\",\"max-width: 99.8% !important\"]}"],["{\"selector\":\"#content\",\"action\":[\"style\",\"top: 0 !important; left: 0 !important; width: 100% !important; margin-left: 0 !important\"]}"],["{\"selector\":\".wrapper.full\",\"action\":[\"style\",\"margin-top: 70px !important\"]}"],["{\"selector\":\".justify-content-center > .col[id]\",\"action\":[\"style\",\"max-width: max-content !important\"]}","{\"selector\":\"body > footer\",\"action\":[\"style\",\"background: none !important\"]}","{\"selector\":\"main#mainContainer\",\"action\":[\"style\",\"max-width: unset !important\"]}"],["{\"selector\":\"#advert\",\"action\":[\"style\",\"height: 1px !important\"]}","{\"selector\":\".adsbygoogle\",\"action\":[\"style\",\"max-height: 6px !important\"]}"],["{\"selector\":\".fix_block > nav\",\"action\":[\"style\",\"position: relative !important\"]}","{\"selector\":\".fix_block\",\"action\":[\"style\",\"position: relative !important\"]}","{\"selector\":\"body.pagefullbg\",\"action\":[\"style\",\"padding-top: 50px !important\"]}"],["{\"selector\":\".short-poster > img\",\"action\":[\"style\",\"filter: none !important; -webkit-filter: none !important\"]}"],["{\"selector\":\"body > .container\",\"action\":[\"style\",\"margin-top: 0 !important\"]}"],["{\"selector\":\"body\",\"action\":[\"style\",\"padding-top: 0 !important\"]}"],["{\"selector\":\"#main\",\"action\":[\"style\",\"max-width: 100% !important\"]}"],["{\"selector\":\".navbar-default\",\"action\":[\"style\",\"margin-bottom: 0 !important\"]}"],["{\"selector\":\"#vO5STmSLgNAkebzSluI8coxpDgsG97g\",\"action\":[\"style\",\"height: 1px !important; min-height: 1px !important\"]}"],["{\"selector\":\"#main-wrapper > #wrap\",\"action\":[\"style\",\"padding: 0 10px !important\"]}"],["{\"selector\":\".top_bg\",\"action\":[\"style\",\"height: 0 !important\"]}"],["{\"selector\":\"body:not(#id)\",\"action\":[\"style\",\"padding: 0 !important\"]}","{\"selector\":\"html:not(#id)\",\"action\":[\"style\",\"padding: 0 !important\"]}"],["{\"selector\":\".colorAdmin\",\"action\":[\"style\",\"color: black !important; font-weight: 100 !important; font-size: 8px !important\"]}"],["{\"selector\":\".content > .media\",\"action\":[\"style\",\"padding-bottom: unset !important\"]}","{\"selector\":\".right-sidebar\",\"action\":[\"style\",\"height: auto !important\"]}"],["{\"selector\":\".main-container\",\"action\":[\"style\",\"margin-top: 80px !important\"]}"],["{\"selector\":\".page-header\",\"action\":[\"style\",\"height: auto !important\"]}"],["{\"selector\":\"#page-wrapper > header\",\"action\":[\"style\",\"margin-bottom: auto !important\"]}"],["{\"selector\":\".postquotehref\",\"action\":[\"style\",\"position: inherit !important\"]}","{\"selector\":\"body > .wrap\",\"action\":[\"style\",\"top: 0 !important\"]}"],["{\"selector\":\"body[style*=\\\"://image.krasview.ru/channel\\\"]\",\"action\":[\"style\",\"background-color: #596c84 !important\"]}"],["{\"selector\":\"[data-ns-portal] .page-type-article.branding div[class^=\\\"content_\\\"] > div[class^=\\\"bottom\\\"]\",\"action\":[\"style\",\"max-width: 100% !important\"]}","{\"selector\":\"[data-ns-portal] .page-type-article.branding\",\"action\":[\"style\",\"--grid-breakpoint-lg: unset !important; margin-top: unset !important; width: 100% !important\"]}"],["{\"selector\":\".wrapper\",\"action\":[\"style\",\"padding-top: 0 !important\"]}"],["{\"selector\":\"div[class^=\\\"articleBlockViqeo_\\\"][class*=\\\"notReady_\\\"]\",\"action\":[\"style\",\"padding-bottom: unset !important\"]}"],["{\"selector\":\"div[class^=\\\"Branding_container_\\\"]\",\"action\":[\"style\",\"margin-top: unset !important; height: auto !important\"]}"],["{\"selector\":\".body *\",\"action\":[\"style\",\"opacity: 1 !important; filter: none !important; pointer-events: auto !important\"]}","{\"selector\":\".topAdvertize__wrapper\",\"action\":[\"style\",\"height: auto !important\"]}"],["{\"selector\":\".wrap\",\"action\":[\"style\",\"cursor: default !important\"]}","{\"selector\":\".wraps\",\"action\":[\"style\",\"margin-top: 0 !important\"]}"],["{\"selector\":\"body\",\"action\":[\"style\",\"margin-top: 0 !important\"]}"],["{\"selector\":\"#new_logo_helper01\",\"action\":[\"style\",\"top: 0 !important\"]}"],["{\"selector\":\".sidebarfix\",\"action\":[\"style\",\"margin-top: 0 !important\"]}"],["{\"selector\":\"#container:not(#id)\",\"action\":[\"style\",\"margin-top: 0 !important\"]}"],["{\"selector\":\".content-wrapper\",\"action\":[\"style\",\"margin-top: 0 !important\"]}","{\"selector\":\"body *\",\"action\":[\"style\",\"transition: none !important\"]}"],["{\"selector\":\".fancybox-enabled\",\"action\":[\"style\",\"overflow: auto !important\"]}"],["{\"selector\":\"#trend\",\"action\":[\"style\",\"margin-bottom: 0 !important\"]}","{\"selector\":\"#wrapper\",\"action\":[\"style\",\"background: none !important\"]}"],["{\"selector\":\".nav-line\",\"action\":[\"style\",\"margin-top: 0 !important\"]}","{\"selector\":\"body\",\"action\":[\"style\",\"background-color: rgb(255, 255, 238) !important\"]}"],["{\"selector\":\".home\",\"action\":[\"style\",\"padding-top: 0 !important\"]}","{\"selector\":\".single\",\"action\":[\"style\",\"padding-top: 0 !important\"]}"],["{\"selector\":\".need-friends\",\"action\":[\"style\",\"margin-top: 125px !important\"]}"],["{\"selector\":\".headb\",\"action\":[\"style\",\"height: auto !important\"]}","{\"selector\":\".wrap\",\"action\":[\"style\",\"margin-top: unset !important\"]}"],["{\"selector\":\"article.full > div .skrin ~ div\",\"action\":[\"style\",\"border: unset !important; background-color: unset !important\"]}"],["{\"selector\":\".htitle\",\"action\":[\"style\",\"margin-left: 0 !important; left: 150px !important\"]}","{\"selector\":\".logo\",\"action\":[\"style\",\"margin-left: 0 !important; left: 0 !important\"]}","{\"selector\":\"body > .standard\",\"action\":[\"style\",\"height: 100px !important; background: transparent !important\"]}","{\"selector\":\"header[role=\\\"banner\\\"]\",\"action\":[\"style\",\"height: 100px !important; background: transparent !important\"]}","{\"selector\":\"nav[role=\\\"navigation\\\"] > ul\",\"action\":[\"style\",\"top: 0 !important\"]}"],["{\"selector\":\"body > header\",\"action\":[\"style\",\"margin-top: 0 !important\"]}"],["{\"selector\":\".native-brand ~ section.main\",\"action\":[\"style\",\"margin-top: 0 !important\"]}","{\"selector\":\".native-brand\",\"action\":[\"style\",\"height: 0 !important\"]}","{\"selector\":\"header\",\"action\":[\"style\",\"position: relative !important\"]}"],["{\"selector\":\".page-wrapper\",\"action\":[\"style\",\"padding-top: 0 !important\"]}"],["{\"selector\":\"body > a.bsec[href=\\\"#\\\"]\",\"action\":[\"style\",\"top: 31px !important\"]}"],["{\"selector\":\"#pagewrapper\",\"action\":[\"style\",\"margin-top: 0 !important\"]}"],["{\"selector\":\".avito-ads-container\",\"action\":[\"style\",\"margin: 0 !important; min-height: 0 !important; padding-top: 0 !important\"]}"],["{\"selector\":\".promo-background\",\"action\":[\"style\",\"padding-top: 0 !important\"]}"],["{\"selector\":\".header--short.header\",\"action\":[\"style\",\"margin-top: 0 !important\"]}"],["{\"selector\":\"#userTabs\",\"action\":[\"style\",\"float: none !important\"]}"],["{\"selector\":\".branding\",\"action\":[\"style\",\"margin-top: 0 !important\"]}"],["{\"selector\":\"body.cookielaw-blur-background > *\",\"action\":[\"style\",\"filter: none !important\"]}","{\"selector\":\"html > head ~ body\",\"action\":[\"style\",\"overflow-y: auto !important\"]}"],["{\"selector\":\"html > body > *\",\"action\":[\"style\",\"pointer-events: auto !important\"]}"],["{\"selector\":\"html > body\",\"action\":[\"style\",\"background-image: none !important; pointer-events: none !important\"]}"],["{\"selector\":\"[data-alias=\\\"Copyright\\\"] .widget-area > .widget_text:last-child\",\"action\":[\"style\",\"border-style: none !important\"]}"],["{\"selector\":\".body-branding\",\"action\":[\"style\",\"background: none !important; padding-top: 0 !important\"]}"],["{\"selector\":\"html\",\"action\":[\"style\",\"width: auto !important; position: unset !important; overflow: auto !important\"]}"],["{\"selector\":\".layout-default__content--brand\",\"action\":[\"style\",\"margin-top: 0 !important\"]}"],["{\"selector\":\"html\",\"action\":[\"style\",\"background: none !important\"]}"],["{\"selector\":\"#art-main\",\"action\":[\"style\",\"background-image: none !important\"]}","{\"selector\":\".bg-top-menu\",\"action\":[\"style\",\"top: 0 !important\"]}"],["{\"selector\":\".header.header-wrapper\",\"action\":[\"style\",\"padding-top: 15px !important\"]}"],["{\"selector\":\".content\",\"action\":[\"style\",\"background: none !important; padding: 0 !important\"]}"],["{\"selector\":\"#main\",\"action\":[\"style\",\"margin-top: 0 !important\"]}"],["{\"selector\":\"body\",\"action\":[\"style\",\"background: none !important; margin-top: 0 !important; padding-top: 0 !important\"]}"],["{\"selector\":\".mt-auto\",\"action\":[\"style\",\"margin-top: unset !important\"]}"],["{\"selector\":\".article_inner.news_content_inner + .sidebar\",\"action\":[\"style\",\"top: 0 !important\"]}","{\"selector\":\".main_content\",\"action\":[\"style\",\"margin-top: 12px !important\"]}"],["{\"selector\":\"#snow\",\"action\":[\"style\",\"animation: none !important\"]}","{\"selector\":\"body:not(#id) > .header\",\"action\":[\"style\",\"margin-bottom: auto !important\"]}"],["{\"selector\":\".box[class*=\\\"content\\\"]\",\"action\":[\"style\",\"margin-top: auto !important\"]}"],["{\"selector\":\".pocaz\",\"action\":[\"style\",\"width: 10px !important; height: 10px !important; position: fixed !important; top:-100px !important\"]}"],["{\"selector\":\"body > .site\",\"action\":[\"style\",\"margin-top: 0 !important\"]}"],["{\"selector\":\"body > div[style*=\\\"width\\\"][style*=\\\"margin\\\"]\",\"action\":[\"style\",\"margin-top: 0 !important\"]}"],["{\"selector\":\".page-layout > main\",\"action\":[\"style\",\"padding-top: 0 !important\"]}"],["{\"selector\":\"body > #container\",\"action\":[\"style\",\"top: 0 !important\"]}"],["{\"selector\":\".header-space\",\"action\":[\"style\",\"max-width: 100% !important\"]}"],["{\"selector\":\".p-sidebar\",\"action\":[\"style\",\"margin: auto !important\"]}","{\"selector\":\"div[class^=\\\"banner\\\"] + section > div\",\"action\":[\"style\",\"width: auto !important; height: auto !important\"]}","{\"selector\":\"div[class^=\\\"banner\\\"] + section\",\"action\":[\"style\",\"padding: unset !important; margin: unset !important\"]}","{\"selector\":\"html:not(#id) > body > [id]:not([style])\",\"action\":[\"style\",\"background-image: none !important; padding-top: 0 !important\"]}"],["{\"selector\":\".adb\",\"action\":[\"style\",\"position: fixed !important; transform: scale(0) !important\"]}","{\"selector\":\".forumAd\",\"action\":[\"style\",\"height: 1px !important\"]}","{\"selector\":\".navbar_notice\",\"action\":[\"style\",\"position: fixed !important; transform: scale(0) !important\"]}"],["{\"selector\":\"#timer_2\",\"action\":[\"style\",\"display: block !important\"]}"],["{\"selector\":\".contentWrap .lcWrap\",\"action\":[\"style\",\"padding-right: unset !important\"]}"],["{\"selector\":\"html\",\"action\":[\"style\",\"--layout-header-height-large: 60px !important\"]}"],["{\"selector\":\"#left-block\",\"action\":[\"style\",\"min-height: 100% !important\"]}","{\"selector\":\"#right-block\",\"action\":[\"style\",\"min-height: 100% !important\"]}"],["{\"selector\":\"#LayoutTopMicroRoot div[style*=\\\"%\\\"]\",\"action\":[\"style\",\"padding-top: unset !important\"]}","{\"selector\":\".mg-advert__content:not(:first-child)\",\"action\":[\"style\",\"margin-top: unset !important\"]}","{\"selector\":\".mg-grid__col > div[style^=\\\"margin-top:\\\"]\",\"action\":[\"style\",\"margin-top: unset !important\"]}","{\"selector\":\"body\",\"action\":[\"style\",\"overflow-y: unset !important\"]}","{\"selector\":\"div[class*=\\\"dzen-wrapper-with-top-content-desktop__topContent-\\\"]\",\"action\":[\"style\",\"grid-template-columns: inherit !important\"]}"],["{\"selector\":\"[data-test=\\\"sticky-header\\\"] > div\",\"action\":[\"style\",\"max-width: 1280px !important\"]}","{\"selector\":\"[data-test=\\\"sticky-header\\\"] > div:first-child > div:first-child + div > div:not(:last-child)\",\"action\":[\"style\",\"margin-right: 60px !important\"]}"],["{\"selector\":\"body > .eva\",\"action\":[\"style\",\"margin-top: 50px !important\"]}"],["{\"selector\":\"header .light-line\",\"action\":[\"style\",\"height: unset !important\"]}"],["{\"selector\":\"#search_panel > .panel-body\",\"action\":[\"style\",\"display: block !important\"]}"],["{\"selector\":\".site\",\"action\":[\"style\",\"margin-top: 0 !important\"]}"],["{\"selector\":\".sitemaker > .grid > .sm-responsive-full-width\",\"action\":[\"style\",\"width: auto !important\"]}"],["{\"selector\":\"body > #header\",\"action\":[\"style\",\"margin-top: 0 !important\"]}"],["{\"selector\":\".jnrGz\",\"action\":[\"style\",\"height: calc(var(--vh, 1vh)*100 - 1px) !important\"]}"],["{\"selector\":\".ftips-branding .td-main-page-wrap\",\"action\":[\"style\",\"padding-top: 5px !important\"]}","{\"selector\":\".ftips-branding-ad + div\",\"action\":[\"style\",\"padding-top: 5px !important\"]}","{\"selector\":\".ftips-branding.td_category_template_1 .td-category-header\",\"action\":[\"style\",\"padding-top: 5px !important\"]}"],["{\"selector\":\"div[id^=\\\"pai_thumbz_\\\"][id$=\\\"_side\\\"]\",\"action\":[\"style\",\"background: #363636 !important\"]}"],["{\"selector\":\"html > body\",\"action\":[\"style\",\"overflow-y: auto !important; position: static !important\"]}"],["{\"selector\":\"div[class^=\\\"container-content\\\"] > div[class^=\\\"obolox\\\"]\",\"action\":[\"style\",\"margin-top: 52px !important\"]}"],["{\"selector\":\"body > .container\",\"action\":[\"style\",\"margin-top: 120px !important\"]}"],["{\"selector\":\"#content.site-max-width\",\"action\":[\"style\",\"margin-top: 0 !important; padding-top: 0 !important\"]}","{\"selector\":\"body > div[id] > div[id]\",\"action\":[\"style\",\"background-image: none !important\"]}","{\"selector\":\"body\",\"action\":[\"style\",\"background-color: #303030 !important; background-image: none !important\"]}"],["{\"selector\":\"#mainContent > section:first-of-type\",\"action\":[\"style\",\"margin-top: unset !important\"]}"],["{\"selector\":\".comment-background\",\"action\":[\"style\",\"background: none !important\"]}","{\"selector\":\".main-content\",\"action\":[\"style\",\"background: none !important\"]}","{\"selector\":\".user-profile-section\",\"action\":[\"style\",\"margin-top: unset !important\"]}"],["{\"selector\":\"body > div[class^=\\\"js-nh\\\"]\",\"action\":[\"style\",\"margin-top: 115px !important\"]}"],["{\"selector\":\"#_id_main_content\",\"action\":[\"style\",\"max-width: 100% !important\"]}","{\"selector\":\".b_header\",\"action\":[\"style\",\"max-width: 100% !important\"]}"],["{\"selector\":\".maps .maps-block\",\"action\":[\"style\",\"height: auto !important\"]}","{\"selector\":\".project-maps .wrap\",\"action\":[\"style\",\"max-width: 1010px !important\"]}","{\"selector\":\".project-weather .wrap\",\"action\":[\"style\",\"max-width: 1010px !important\"]}","{\"selector\":\".section-map-grid\",\"action\":[\"style\",\"display: unset !important\"]}","{\"selector\":\".section-map-grid\",\"action\":[\"style\",\"margin-bottom: 20px !important\"]}"],["{\"selector\":\"a[href^=\\\"https://www.goha.ru/~\\\"]\",\"action\":[\"style\",\"pointer-events: none !important\"]}"],["{\"selector\":\".wrapper__content-inner:not(#id)\",\"action\":[\"style\",\"padding-top: 0 !important\"]}"],["{\"selector\":\".wallpapers > [class^=\\\"wallpapers__item\\\"]\",\"action\":[\"style\",\"margin-right: unset !important; width: 320px !important\"]}"],["{\"selector\":\".main-block .main-inner-wrap\",\"action\":[\"style\",\"margin-top: 0 !important\"]}"],["{\"selector\":\".page\",\"action\":[\"style\",\"padding-top: 0 !important\"]}"],["{\"selector\":\"#Page\",\"action\":[\"style\",\"margin-top: 0 !important\"]}"],["{\"selector\":\".rightColumn > .darkPart\",\"action\":[\"style\",\"height: auto !important\"]}","{\"selector\":\"footer.pageContainer\",\"action\":[\"style\",\"height: auto !important\"]}"],["{\"selector\":\"#link-b\",\"action\":[\"style\",\"display: block !important\"]}"],["{\"selector\":\".wrapper-body\",\"action\":[\"style\",\"margin-top: 0 !important\"]}"],["{\"selector\":\".jirrua\",\"action\":[\"style\",\"margin-top: 0 !important\"]}"],["{\"selector\":\".page-branded\",\"action\":[\"style\",\"margin-top: 0 !important\"]}"],["{\"selector\":\"body > .all\",\"action\":[\"style\",\"margin-top: 0 !important\"]}"],["{\"selector\":\"#td-outer-wrap > *\",\"action\":[\"style\",\"pointer-events: auto\"]}","{\"selector\":\"#td-outer-wrap\",\"action\":[\"style\",\"pointer-events: none\"]}","{\"selector\":\"body\",\"action\":[\"style\",\"background-image: none !important; background-color: whitesmoke !important\"]}","{\"selector\":\"body\",\"action\":[\"style\",\"pointer-events: none\"]}"],["{\"selector\":\".knb-grid-container > [data-io-article-url]:has(> [class^=\\\"MaterialItemHead_head\\\"] [href=\\\"/tags/partnyorskij-material/\\\"]) > .knb-grid-container [class^=\\\"material-content_\\\"] a[href][target=\\\"_blank\\\"]:not([href^=\\\"https://www.igromania.ru/\\\"])\",\"action\":[\"style\",\"color: inherit !important; pointer-events: none !important\"]}"],["{\"selector\":\".footer-slow-download__btn\",\"action\":[\"style\",\"color: #57a216 !important; font-size: 19px !important; font-weight: bold !important\"]}"],["{\"selector\":\"body > .page__wrapper\",\"action\":[\"style\",\"padding-top: 60px !important\"]}"],["{\"selector\":\"#contentShifter\",\"action\":[\"style\",\"height: 127px !important\"]}"],["{\"selector\":\".fltext\",\"action\":[\"style\",\"background: none !important; position: unset !important\"]}"],["{\"selector\":\"body > .layout\",\"action\":[\"style\",\"padding-top: 50px !important\"]}"],["{\"selector\":\".headerNotify_hasUnread .nbl-simpleControlButton\",\"action\":[\"style\",\"animation: none !important\"]}","{\"selector\":\".page-wrapper > .content-main\",\"action\":[\"style\",\"padding-top: 0 !important\"]}","{\"selector\":\"body.watch > div[class]:not([id]):not([style]):nth-child(-1n+2)\",\"action\":[\"style\",\"background: none !important\"]}","{\"selector\":\"body.watch > header.ivi-top\",\"action\":[\"style\",\"top: 0 !important\"]}"],["{\"selector\":\"body:not(#id)\",\"action\":[\"style\",\"background: whitesmoke !important\"]}"],["{\"selector\":\".comments_form\",\"action\":[\"style\",\"min-height: 0 !important\"]}","{\"selector\":\".ten_ears_wrap\",\"action\":[\"style\",\"margin: 35px auto 0 auto !important\"]}","{\"selector\":\".ten_topbar\",\"action\":[\"style\",\"height: 0 !important\"]}","{\"selector\":\"body > .menu_wrap\",\"action\":[\"style\",\"position: relative !important\"]}","{\"selector\":\"body\",\"action\":[\"style\",\"background-image: none !important; background-color: #bdbdbd !important\"]}"],["{\"selector\":\".outer\",\"action\":[\"style\",\"padding-top: 0 !important\"]}"],["{\"selector\":\"body > .wrapper\",\"action\":[\"style\",\"background: none !important; padding-top: 0 !important; padding-bottom: 0 !important\"]}"],["{\"selector\":\"#actorListBlock\",\"action\":[\"style\",\"padding-right: 19px !important\"]}","{\"selector\":\"#header-info-bg\",\"action\":[\"style\",\"background-color: transparent !important; background-image: none !important\"]}","{\"selector\":\".app div[class^=\\\"device\\\"][class*=\\\" page-main__content\\\"]\",\"action\":[\"style\",\"background-color: black !important\"]}","{\"selector\":\".content-container_app-width_wide\",\"action\":[\"style\",\"max-width: 100% !important\"]}","{\"selector\":\".desktop-layout-with-sidebar__content > div[class][data-tid]\",\"action\":[\"style\",\"width: auto !important\"]}","{\"selector\":\".film-seances-page\",\"action\":[\"style\",\"box-shadow: 0 -8px 15px #333333 !important\"]}","{\"selector\":\".filmsListNew .info\",\"action\":[\"style\",\"padding-right: 116px !important\"]}","{\"selector\":\".header-navigation\",\"action\":[\"style\",\"max-width: 100% !important\"]}","{\"selector\":\".modal-root div[class^=\\\"fullscreen-selector\\\"]\",\"action\":[\"style\",\"opacity: inherit !important\"]}","{\"selector\":\".page-content > #header-info-bg + div[id]:not([class])\",\"action\":[\"style\",\"margin-bottom: 40px !important\"]}","{\"selector\":\".page-content > div[id]:not(#header-info-bg):empty + div[id]:not(#top)\",\"action\":[\"style\",\"margin-bottom: 40px !important\"]}","{\"selector\":\".shadow.shadow-restyle\",\"action\":[\"style\",\"box-shadow: 0 -8px 15px #333333 !important\"]}","{\"selector\":\".user-subscription-partial-component__subscription-item-text\",\"action\":[\"style\",\"white-space: pre-wrap !important\"]}","{\"selector\":\"body[class*=\\\"styles_body\\\"]\",\"action\":[\"style\",\"overflow: auto !important\"]}","{\"selector\":\"div > a[aria-label=\\\"КиноПоиск\\\"] ~ div > button ~ div\",\"action\":[\"style\",\"opacity: inherit !important\"]}","{\"selector\":\"div[class*=\\\" styles_basicInfoSection\\\"]\",\"action\":[\"style\",\"padding-top: 40px !important\"]}","{\"selector\":\"div[class*=\\\" styles_basicMediaSection\\\"]\",\"action\":[\"style\",\"padding-top: 40px !important\"]}","{\"selector\":\"div[class*=\\\" styles_videoContainer\\\"]\",\"action\":[\"style\",\"margin-top: 0 !important\"]}","{\"selector\":\"div[class*=\\\"kinopoisk-media-container_pending\\\"]\",\"action\":[\"style\",\"min-height: 0 !important\"]}","{\"selector\":\"div[class*=\\\"styles_baseContainer\\\"] > div[class]:first-child > div[class]:first-child\",\"action\":[\"style\",\"min-height: 0 !important\"]}","{\"selector\":\"div[class*=\\\"styles_baseContainer\\\"] > div[class]:first-child\",\"action\":[\"style\",\"min-height: 0 !important\"]}","{\"selector\":\"div[class*=\\\"styles_headerContainer\\\"] + div[class^=\\\"styles_\\\"]\",\"action\":[\"style\",\"max-width: 100% !important\"]}","{\"selector\":\"div[class*=\\\"user-bar\\\"] > div > button ~ div\",\"action\":[\"style\",\"opacity: inherit !important\"]}","{\"selector\":\"div[class^=\\\"styles_emptyItems__\\\"] div\",\"action\":[\"style\",\"background-color: transparent !important\"]}","{\"selector\":\"div[class^=\\\"styles_footerContainer__\\\"]\",\"action\":[\"style\",\"max-width: 100% !important\"]}","{\"selector\":\"div[class^=\\\"styles_wideContentContainer\\\"] > div[class]:first-child\",\"action\":[\"style\",\"min-height: 0 !important\"]}","{\"selector\":\"div[style=\\\"min-width: 1px;\\\"]\",\"action\":[\"style\",\"min-height: 0 !important\"]}","{\"selector\":\"div[style=\\\"min-width:1px\\\"]\",\"action\":[\"style\",\"min-height: 0 !important\"]}"],["{\"selector\":\".header_container\",\"action\":[\"style\",\"margin-top: 0 !important\"]}","{\"selector\":\"html > body\",\"action\":[\"style\",\"background-image: none !important; background-color: black !important\"]}"],["{\"selector\":\".bg_container\",\"action\":[\"style\",\"padding-top: 0 !important\"]}","{\"selector\":\".subbody2\",\"action\":[\"style\",\"margin-top: 0 !important\"]}"],["{\"selector\":\".page-detail .section-detail-news\",\"action\":[\"style\",\"margin-left: 0 !important\"]}"],["{\"selector\":\"div[id^=\\\"newsid_\\\"] > .row0[style=\\\"margin-bottom:8px;\\\"]\",\"action\":[\"style\",\"pointer-events: none !important\"]}"],["{\"selector\":\"#allrecords > #t-header + div + div[id^=\\\"rec\\\"][style*=\\\"padding-top:\\\"]\",\"action\":[\"style\",\"padding-top: 0 !important\"]}","{\"selector\":\"#allrecords > #t-header + div[id^=\\\"rec\\\"][style*=\\\"padding-top:\\\"]\",\"action\":[\"style\",\"padding-top: 0 !important\"]}","{\"selector\":\".page-wrapper > .page-inner\",\"action\":[\"style\",\"margin-top: auto !important\"]}"],["{\"selector\":\".container[style=\\\"max-width: unset;\\\"] > .container\",\"action\":[\"style\",\"margin-top: auto !important\"]}"],["{\"selector\":\".longgrid-list__box\",\"action\":[\"style\",\"justify-content: unset !important\"]}"],["{\"selector\":\".recipes-layout__content\",\"action\":[\"style\",\"margin-top: 0 !important\"]}"],["{\"selector\":\".theme-wrapper > .container > div\",\"action\":[\"style\",\"padding-bottom: unset !important\"]}"],["{\"selector\":\".content\",\"action\":[\"style\",\"margin-top: 0 !important\"]}"],["{\"selector\":\".allpage .currency a\",\"action\":[\"style\",\"pointer-events: none !important\"]}"],["{\"selector\":\":not(.allpageinner) > :not(.header) > .logo > a[href=\\\"/\\\"] > span\",\"action\":[\"style\",\"top: inherit !important; left: inherit !important; font-size: x-large !important; font-weight: bold !important; color: #0183cb !important\"]}"],["{\"selector\":\".main\",\"action\":[\"style\",\"margin-top: 0 !important\"]}"],["{\"selector\":\".vjs-big-play-button\",\"action\":[\"style\",\"background: #0fc3c3 !important\"]}"],["{\"selector\":\"#mailbox:not(#id)\",\"action\":[\"style\",\"visibility: unset !important; pointer-events: unset !important\"]}","{\"selector\":\".article__item_source_viqeo .article__container::before\",\"action\":[\"style\",\"content: initial !important\"]}","{\"selector\":\".grid__ccol > .tabs-content\",\"action\":[\"style\",\"margin-top: 5px !important\"]}","{\"selector\":\".grid__header .ph-auth\",\"action\":[\"style\",\"height: 37px !important\"],\"tasks\":[[\"matches-media\",\"(max-width: 1280px)\"]]}","{\"selector\":\".grid__header .ph-container\",\"action\":[\"style\",\"height: 40px !important\"],\"tasks\":[[\"matches-media\",\"(max-width: 1280px)\"]]}","{\"selector\":\".grid__header .ph-modal-projects-overlay\",\"action\":[\"style\",\"top: inherit !important\"]}","{\"selector\":\".grid__header > .headline\",\"action\":[\"style\",\"height: 40px !important; min-height: 40px !important\"],\"tasks\":[[\"matches-media\",\"(max-width: 1280px)\"]]}","{\"selector\":\".grid__main-col .eventbar-wrapper\",\"action\":[\"style\",\"margin-top: 0 !important\"]}","{\"selector\":\".grid__main-col > div[slot=\\\"main-column\\\"] .search-container\",\"action\":[\"style\",\"margin-top: 4px !important; margin-bottom: 4px !important\"]}","{\"selector\":\".ph-project__user-icon-mask\",\"action\":[\"style\",\"mask-image: inherit !important\"]}","{\"selector\":\".tabs-content > :first-child > a > .news-main__img\",\"action\":[\"style\",\"max-width: unset !important; min-width: unset !important; height: 5em !important; width: 6.66em !important\"]}","{\"selector\":\".tabs-content > :first-child > a > .news-main__text-wrapper\",\"action\":[\"style\",\"max-height: 5em !important; white-space: pre-line !important\"]}","{\"selector\":\".tabs-content > :first-child > a\",\"action\":[\"style\",\"max-height: 5em !important; position: static !important\"]}","{\"selector\":\".tabs-content > :first-child > a::after\",\"action\":[\"style\",\"position: unset !important\"]}","{\"selector\":\".tabs-content > :first-child ~ li\",\"action\":[\"style\",\"max-width: 660px !important\"]}","{\"selector\":\".tabs-content > :first-child\",\"action\":[\"style\",\"max-width: 750px !important\"]}","{\"selector\":\".weather_right-column .weather__block\",\"action\":[\"style\",\"height: auto !important\"]}","{\"selector\":\"[data-testid=\\\"grid-left-col\\\"] > .logo\",\"action\":[\"style\",\"margin-top: 4px !important; margin-bottom: 4px !important\"]}","{\"selector\":\"[slot=\\\"main-column\\\"] .news-item\",\"action\":[\"style\",\"line-height: 19px !important\"],\"tasks\":[[\"matches-media\",\"(max-width: 1280px)\"]]}","{\"selector\":\"[slot=\\\"main-column\\\"] > .tabs\",\"action\":[\"style\",\"height: 20px !important\"],\"tasks\":[[\"matches-media\",\"(max-width: 1280px)\"]]}","{\"selector\":\"body > .grid .grid__lcol > .footer\",\"action\":[\"style\",\"margin-top: 10px !important\"]}","{\"selector\":\"body > .grid .grid__rcol\",\"action\":[\"style\",\"margin-left: 0 !important\"]}","{\"selector\":\"body > .zeropixel ~ div > style ~ div\",\"action\":[\"style\",\"pointer-events: none !important; opacity: 0 !important\"]}","{\"selector\":\"body:not(.js-module) .tabs + div[class] > :first-child\",\"action\":[\"style\",\"width: 100% !important\"]}","{\"selector\":\"body:not(.js-module) .tabs + div[class]\",\"action\":[\"style\",\"min-width: fit-content !important\"]}","{\"selector\":\"body:not(.js-module) .tabs > .tabs__item\",\"action\":[\"style\",\"padding: 0 4px !important; font-size: 14px !important\"]}","{\"selector\":\"div:not(.grid__main-col) > div[slot=\\\"main-column\\\"] .search-container\",\"action\":[\"style\",\"margin-top: 4px !important; margin-bottom: 20px !important\"]}","{\"selector\":\"div[slot=\\\"main-column\\\"] .tabs\",\"action\":[\"style\",\"margin-top: 5px !important\"]}","{\"selector\":\"div[slot=\\\"main-column\\\"] > .micro-widgets\",\"action\":[\"style\",\"height: auto !important; margin: auto !important\"]}","{\"selector\":\"div[slot=\\\"main-column\\\"] > .tabs__container\",\"action\":[\"style\",\"margin-top: 5px !important\"]}","{\"selector\":\"div[slot=\\\"main-column\\\"] > :nth-child(-1n+2) ~ [class] > [class]\",\"action\":[\"style\",\"visibility: unset !important; pointer-events: unset !important\"]}"],["{\"selector\":\"div[class^=\\\"Public__folderContent\\\"]\",\"action\":[\"style\",\"padding-right: 0 !important\"]}","{\"selector\":\"div[class^=\\\"ReactViewer__root-\\\"]\",\"action\":[\"style\",\"--bottom-banner-height: 1px !important\"]}"],["{\"selector\":\"#app-canvas .application-mail__layout .layout__column_right\",\"action\":[\"style\",\"width: auto !important\"]}","{\"selector\":\"#app-canvas .paginator-container\",\"action\":[\"style\",\"right: 8px !important\"]}","{\"selector\":\".advert-column\",\"action\":[\"style\",\"width: 0 !important\"]}","{\"selector\":\".application-mail__wrap > .application-mail__layout > .layout[style*=\\\"grid-template-columns:\\\"]\",\"action\":[\"style\",\"grid-template-columns: 232px 1fr 0 0 !important\"]}","{\"selector\":\".application_new-toolbar .application-mail:not(.application-mail_webview-mobile) .letter-list[class*=\\\"adv\\\"]\",\"action\":[\"style\",\"--letter-list-top-toolbar-height: inherit !important\"]}","{\"selector\":\".layer-sent-page > .layer\",\"action\":[\"style\",\"min-height: 0 !important\"]}","{\"selector\":\".letter-list-item-adv__container\",\"action\":[\"style\",\"height: 0 !important; opacity: 0 !important; pointer-events: none !important\"]}","{\"selector\":\"body > div > .letter-list-item-adv\",\"action\":[\"style\",\"display: block !important\"]}","{\"selector\":\"body > div[style*=\\\"top:\\\"][style*=\\\"position:\\\"][style*=\\\"visibility:\\\"] #app-canvas div\",\"action\":[\"style\",\"display: block !important\"]}"],["{\"selector\":\".ph-projects > a[href^=\\\"https://e.mail.ru/messages/inbox?utm_\\\"]\",\"action\":[\"style\",\"pointer-events: none !important\"]}","{\"selector\":\"body:not(#id) > div[style=\\\"position: absolute; visibility: hidden; top: -10000px; left: -10000px;\\\"] > div\",\"action\":[\"style\",\"display: block !important\"]}"],["{\"selector\":\"aside > div > div\",\"action\":[\"style\",\"min-height: 0 !important\"]}"],["{\"selector\":\"#portal-menu\",\"action\":[\"style\",\"margin: 0 !important\"]}","{\"selector\":\".header-banner\",\"action\":[\"style\",\"margin: 0 !important\"]}"],["{\"selector\":\".portal-menu__logo__link\",\"action\":[\"style\",\"width: 90px !important; !important; overflow: hidden !important\"]}"],["{\"selector\":\"#portal-headline\",\"action\":[\"style\",\"margin-top: auto !important\"]}"],["{\"selector\":\"html.window-loaded .b-video-controls__inside-play-button\",\"action\":[\"style\",\"visibility: visible !important; opacity: 0 !important; width: 100% !important; height: 100% !important; top: 0 !important; left: 0 !important\"]}"],["{\"selector\":\"body > .block > .tag\",\"action\":[\"style\",\"z-index: 1400 !important; cursor: pointer !important\"]}"],["{\"selector\":\".preview-section .vertical-video__play-icon-wrapper\",\"action\":[\"style\",\"display: unset !important\"]}"],["{\"selector\":\"main[style^=\\\"background-color:\\\"]\",\"action\":[\"style\",\"background-color: inherit !important\"]}"],["{\"selector\":\".aggregator-page\",\"action\":[\"style\",\"pointer-events: none !important; opacity: 0 !important\"]}"],["{\"selector\":\"#page > .content\",\"action\":[\"style\",\"margin-top: 74px !important\"]}","{\"selector\":\".header-wrapper\",\"action\":[\"style\",\"min-height: 0 !important\"]}"],["{\"selector\":\"#gl_pos1\",\"action\":[\"style\",\"min-width: auto !important; width: unset !important\"]}","{\"selector\":\"#main_tb\",\"action\":[\"style\",\"top: 0 !important\"]}","{\"selector\":\"#move_up[style*=\\\"left: -40px;\\\"]\",\"action\":[\"style\",\"left: 0 !important\"]}","{\"selector\":\"html > body\",\"action\":[\"style\",\"background-color: #f7f8f9 !important\"]}"],["{\"selector\":\"body.noscroll\",\"action\":[\"style\",\"overflow: auto !important\"]}","{\"selector\":\"body.noscroll::before\",\"action\":[\"style\",\"content: none !important\"]}"],["{\"selector\":\".wrapp_content\",\"action\":[\"style\",\"margin-top: 0 !important\"]}"],["{\"selector\":\"body\",\"action\":[\"style\",\"-webkit-touch-callout: default !important; -webkit-user-select: text !important; -khtml-user-select: text !important; -moz-user-select: text !important; -ms-user-select: text !important; user-select: text !important\"]}"],["{\"selector\":\"#page-wrapper\",\"action\":[\"style\",\"margin-top: 0 !important\"]}","{\"selector\":\".col-side > .opinion-teaser\",\"action\":[\"style\",\"border-top: none !important\"]}"],["{\"selector\":\"#header-b\",\"action\":[\"style\",\"margin-bottom: 11px !important\"]}"],["{\"selector\":\"div[class=\\\"global-top-menus article_menu_type\\\"]\",\"action\":[\"style\",\"margin-top: auto !important\"]}"],["{\"selector\":\".adv-banner__right\",\"action\":[\"style\",\"min-height: 0 !important\"]}"],["{\"selector\":\"body > div:not([id]):not([class]) > .exit-popup\",\"action\":[\"style\",\"display: block !important\"]}"],["{\"selector\":\".video-box[style=\\\"display: none;\\\"]\",\"action\":[\"style\",\"display: block !important\"]}"],["{\"selector\":\"#wrapper\",\"action\":[\"style\",\"background-image: none !important; padding-bottom: 0 !important\"]}"],["{\"selector\":\"a.over-hiddenlink-html[target=\\\"_blank\\\"]\",\"action\":[\"style\",\"pointer-events: none !important; color: inherit !important\"]}"],["{\"selector\":\"tr > td[nowrap=\\\"nowrap\\\"][style=\\\"color: red;  font-weight: bold\\\"]\",\"action\":[\"style\",\"color: #004488 !important; font-weight: 200 !important\"]}"],["{\"selector\":\"body\",\"action\":[\"style\",\"cursor: auto !important; background: whitesmoke !important\"]}"],["{\"selector\":\"body > .a\",\"action\":[\"style\",\"background-image: none !important\"]}"],["{\"selector\":\".app > .app__inner[style*=\\\"padding-top\\\"]\",\"action\":[\"style\",\"padding-top: 64px !important\"]}","{\"selector\":\".footer__inner\",\"action\":[\"style\",\"background-color: var(--color--app__bg) !important; color: var(--color--app__text) !important\"]}","{\"selector\":\".pub300x250.pub300x250m.pub728x90.text-ad.textAd.textad.textads.text-ads.text-ad-links\",\"action\":[\"style\",\"display: block !important; position: absolute !important; top: -10000px !important; left: -10000px !important\"]}","{\"selector\":\"aside > .sidebar-block > div > div > div > div\",\"action\":[\"style\",\"min-height: unset !important\"]}","{\"selector\":\"aside > .sidebar-block > div > div > div\",\"action\":[\"style\",\"min-height: unset !important\"]}","{\"selector\":\"aside > .sidebar-block > div > div\",\"action\":[\"style\",\"min-height: unset !important\"]}","{\"selector\":\"aside > .sidebar-block > div\",\"action\":[\"style\",\"min-height: unset !important\"]}","{\"selector\":\"aside > .sidebar-block\",\"action\":[\"style\",\"min-height: unset !important\"]}","{\"selector\":\"div[class*=\\\"page-story\\\"][class*=\\\"ments\\\"] div\",\"action\":[\"style\",\"min-height: 0 !important\"]}","{\"selector\":\"header > .header__main\",\"action\":[\"style\",\"background-color: var(--color--header__bg) !important\"]}"],["{\"selector\":\"body > #branding\",\"action\":[\"style\",\"padding-top: 0 !important\"]}"],["{\"selector\":\".content_aside-container > .content-column\",\"action\":[\"style\",\"padding-left: 0 !important; padding-right: 40px !important\"]}","{\"selector\":\".content_aside-container\",\"action\":[\"style\",\"flex-direction: unset !important\"]}","{\"selector\":\".gp-game-card .user-profile-sidebar\",\"action\":[\"style\",\"max-width: unset !important\"]}","{\"selector\":\"body\",\"action\":[\"style\",\"background: #242424 !important\"]}","{\"selector\":\"body#userNotAuthorized .bonus-landing-page .panel-collapse > .panel-body\",\"action\":[\"style\",\"background-color: white !important\"]}","{\"selector\":\"body#userNotAuthorized .bonus-landing-page .panel-default > .panel-heading\",\"action\":[\"style\",\"background-color: white !important\"]}","{\"selector\":\"body#userNotAuthorized .bonus-landing-page-faq > .title\",\"action\":[\"style\",\"color: white !important\"]}"],["{\"selector\":\".banner-advertise\",\"action\":[\"style\",\"margin-top: 0 !important\"]}","{\"selector\":\".open-main-container\",\"action\":[\"style\",\"margin-top: 60px !important\"]}"],["{\"selector\":\"div[id][class*=\\\" BannerPlace-\\\"]\",\"action\":[\"style\",\"filter: grayscale(1) !important\"]}"],["{\"selector\":\".foundation-wrapper\",\"action\":[\"style\",\"padding-top: 0 !important\"]}"],["{\"selector\":\".page-width\",\"action\":[\"style\",\"margin-top: 0 !important\"]}","{\"selector\":\".sp-header-block\",\"action\":[\"style\",\"height: 50px !important\"]}"],["{\"selector\":\"#container\",\"action\":[\"style\",\"top: auto !important\"]}","{\"selector\":\"html > body\",\"action\":[\"style\",\"background-image:none !important; pointer-events: none !important\"]}"],["{\"selector\":\"body:not(#id)\",\"action\":[\"style\",\"padding-top: 130px !important\"]}"],["{\"selector\":\".main-wrapp__content\",\"action\":[\"style\",\"margin-top: 0 !important\"]}"],["{\"selector\":\"div[class]\",\"action\":[\"style\",\"min-height: 0 !important\"]}"],["{\"selector\":\".ad_branding_main > div[class]\",\"action\":[\"style\",\"max-width: 100% !important\"]}","{\"selector\":\".ad_branding_main > div[class]:first-child > div\",\"action\":[\"style\",\"max-width: 100% !important\"]}","{\"selector\":\".ad_branding_main > div[class]:first-child\",\"action\":[\"style\",\"margin-left: 0 !important\"]}","{\"selector\":\".ad_branding_main\",\"action\":[\"style\",\"max-width: 100% !important\"]}"],["{\"selector\":\"div[class*=\\\"WithRightBarWrapper\\\"] > div[class*=\\\"AutoAppContainer\\\"]\",\"action\":[\"style\",\"max-width: 100% !important\"]}"],["{\"selector\":\"html > body:not(#id)\",\"action\":[\"style\",\"overflow: unset !important\"]}"],["{\"selector\":\"#app > div\",\"action\":[\"style\",\"min-height: 0 !important\"]}","{\"selector\":\"footer\",\"action\":[\"style\",\"max-width: 100% !important\"]}"],["{\"selector\":\"#js_col_left > .l-sticky\",\"action\":[\"style\",\"position: relative !important; top: unset !important\"]}","{\"selector\":\".g-banner__news-footer\",\"action\":[\"style\",\"min-height: 0 !important\"]}","{\"selector\":\".g-relative > .forecast\",\"action\":[\"style\",\"height: auto !important\"]}","{\"selector\":\".l-col-100h\",\"action\":[\"style\",\"min-height: 0 !important; height: auto !important\"]}","{\"selector\":\".l-sticky:has(.forecast:empty) ~ .js-news-feed > .news-feed\",\"action\":[\"style\",\"top: 166px !important; position: unset !important\"]}"],["{\"selector\":\".g-icon-big.g-play::after\",\"action\":[\"style\",\"bottom: calc(50% - 55px) !important; left: calc(50% - 55px) !important; cursor: pointer !important\"]}","{\"selector\":\".l-small-width-top-padding\",\"action\":[\"style\",\"padding-top: unset !important\"]}","{\"selector\":\".video-gallery-popup.single .video-gallery-popup__body\",\"action\":[\"style\",\"left: 200px !important; right: 200px !important\"]}","{\"selector\":\".video-gallery-popup.single .video-gallery-popup__wrap\",\"action\":[\"style\",\"max-width: 100% !important\"]}"],["{\"selector\":\"#topcontainer\",\"action\":[\"style\",\"margin-top: 40px !important\"]}"],["{\"selector\":\"div[class*=\\\"_spiegelWrapper\\\"]\",\"action\":[\"style\",\"padding-top: 0 !important\"]}","{\"selector\":\"div[class^=\\\"PageMediaContentVideo_mainContent\\\"]\",\"action\":[\"style\",\"min-height: 0 !important\"]}","{\"selector\":\"div[class^=\\\"Page_main\\\"][style*=\\\"min-height:\\\"]\",\"action\":[\"style\",\"min-height: 0 !important\"]}"],["{\"selector\":\".m-blur\",\"action\":[\"style\",\"filter: none !important; position: relative !important\"]}"],["{\"selector\":\".header20-00\",\"action\":[\"style\",\"height: auto !important\"]}"],["{\"selector\":\"#wrapper > #header\",\"action\":[\"style\",\"margin-top: 0 !important\"]}"],["{\"selector\":\"body > .wrapper\",\"action\":[\"style\",\"top: 0 !important\"]}"],["{\"selector\":\".body--brranding > .content\",\"action\":[\"style\",\"margin-top: unset !important\"]}","{\"selector\":\"html:not(#id) > body:not(#id) .body--brranding > *\",\"action\":[\"style\",\"pointer-events: auto !important\"]}","{\"selector\":\"html:not(#id) > body:not(#id) .body--brranding\",\"action\":[\"style\",\"pointer-events: none !important\"]}"],["{\"selector\":\".menu[role=\\\"navigation\\\"] div[style]\",\"action\":[\"style\",\"height: auto !important\"]}","{\"selector\":\"aside > div[class]:first-child div\",\"action\":[\"style\",\"height: auto !important\"]}"],["{\"selector\":\"body > div[style^=\\\"background-color:\\\"]\",\"action\":[\"style\",\"height: unset !important\"]}"],["{\"selector\":\"html.dark > body\",\"action\":[\"style\",\"background-color: #171717 !important\"]}","{\"selector\":\"html:not(.dark) > body\",\"action\":[\"style\",\"background: initial !important\"]}"],["{\"selector\":\".abp\",\"action\":[\"style\",\"transform: none !important; direction: ltr !important\"]}"],["{\"selector\":\".promotion .h-layoutWide\",\"action\":[\"style\",\"cursor: auto !important\"]}"],["{\"selector\":\".b-site-body\",\"action\":[\"style\",\"padding-top: 0 !important\"]}"],["{\"selector\":\"#main_body > .block\",\"action\":[\"style\",\"height: auto !important\"]}","{\"selector\":\"#site\",\"action\":[\"style\",\"margin-top: 0 !important\"]}"],["{\"selector\":\".header_top\",\"action\":[\"style\",\"margin-top: 0 !important\"]}"],["{\"selector\":\".se-onair-popup:not([class*=\\\"active\\\"]) > .se-onair\",\"action\":[\"style\",\"background: #292e35 !important\"]}","{\"selector\":\".se-onair-popup:not([class*=\\\"active\\\"])\",\"action\":[\"style\",\"bottom: 10px !important; right: 0 !important; width: 155px !important; top: 22px !important\"]}","{\"selector\":\"body.popup\",\"action\":[\"style\",\"overflow:auto !important\"]}"],["{\"selector\":\".tab__sport a[href^=\\\"https://www.championat.com/\\\"]\",\"action\":[\"style\",\"pointer-events: none !important\"]}"],["{\"selector\":\".header-middle-wrapper\",\"action\":[\"style\",\"height: auto !important\"]}"],["{\"selector\":\".layout_footer\",\"action\":[\"style\",\"margin-top: 20px !important\"]}","{\"selector\":\".p-article-bookmakers ~ div a[href^=\\\"https://r.mail.ru/\\\"]\",\"action\":[\"style\",\"pointer-events: none !important; text-decoration: none !important; color: inherit !important\"]}"],["{\"selector\":\"#branding-layout > * > *\",\"action\":[\"style\",\"pointer-events: auto !important\"]}","{\"selector\":\"#branding-layout > a\",\"action\":[\"style\",\"width: 0 !important; height: 0 !important; left:-10000px !important\"]}","{\"selector\":\"#branding-layout\",\"action\":[\"style\",\"pointer-events: none !important\"]}","{\"selector\":\"#branding-layout:not(#id)\",\"action\":[\"style\",\"padding-top: 0 !important\"]}","{\"selector\":\".columns-layout__right > div > div[id][class]\",\"action\":[\"style\",\"min-height: 0 !important\"]}","{\"selector\":\":not(.nba-global-nav-wrapper) + #branding-layout:not(#id)\",\"action\":[\"style\",\"margin-top: 96px !important\"]}","{\"selector\":\"[data-content-name=\\\"banner-static\\\"]\",\"action\":[\"style\",\"position: fixed !important; left: -10000px !important; transform: scale(0) !important; display: none !important\"]}","{\"selector\":\"body.img-bg\",\"action\":[\"style\",\"padding-top: 0 !important\"]}","{\"selector\":\"body.is-fixed\",\"action\":[\"style\",\"overflow: auto !important\"]}","{\"selector\":\"html > body\",\"action\":[\"style\",\"background-image: none !important; background-color: #a7a7a7 !important\"]}"],["{\"selector\":\"#branding-wrapper\",\"action\":[\"style\",\"padding-top: 0 !important\"]}"],["{\"selector\":\"div[id^=\\\"videoplayer_\\\"][class^=\\\"iframe_wrapper\\\"]\",\"action\":[\"style\",\"display: block !important\"]}"],["{\"selector\":\".n-main-branding-container\",\"action\":[\"style\",\"margin-top: 0 !important\"]}"],["{\"selector\":\"#footer\",\"action\":[\"style\",\"margin-top: 0 !important\"]}","{\"selector\":\"#vbulletin_html #globalcontent\",\"action\":[\"style\",\"margin-top: unset !important\"]}","{\"selector\":\"#vbulletin_html .above_body\",\"action\":[\"style\",\"margin-bottom: auto !important\"]}","{\"selector\":\"#vbulletin_html body > div[id][class]\",\"action\":[\"style\",\"background: none !important\"]}","{\"selector\":\"html\",\"action\":[\"style\",\"background-color: #dbdbdb !important\"]}","{\"selector\":\"html.home > body idiv[class][id]\",\"action\":[\"style\",\"background: none !important\"]}"],["{\"selector\":\"#header\",\"action\":[\"style\",\"height: 94px !important\"]}","{\"selector\":\".header-inner\",\"action\":[\"style\",\"height: 94px !important\"]}"],["{\"selector\":\"aside > div[class^=\\\"NavPanel_nav\\\"]\",\"action\":[\"style\",\"width: unset !important\"]}","{\"selector\":\"div[class^=\\\"LoopChannelLayout_widget\\\"] > div[class^=\\\"SimpleCaption_wrapper\\\"]\",\"action\":[\"style\",\"background: none !important\"]}"],["{\"selector\":\"body:not(.path-frontpage) .page-main\",\"action\":[\"style\",\" min-height: unset !important\"]}"],["{\"selector\":\"body\",\"action\":[\"style\",\"background: whitesmoke !important\"]}"],["{\"selector\":\"#all:not(#id) > #content\",\"action\":[\"style\",\"margin-top: 20px !important\"]}","{\"selector\":\"body\",\"action\":[\"style\",\"background-color: #fff !important\"]}"],["{\"selector\":\".modal-open\",\"action\":[\"style\",\"overflow: auto !important\"]}"],["{\"selector\":\".tp-widget-pinned-post-item__title > a\",\"action\":[\"style\",\"pointer-events: auto !important\"]}"],["{\"selector\":\".tBlurred\",\"action\":[\"style\",\"-webkit-filter: none !important\"]}"],["{\"selector\":\"html[prefix] > body\",\"action\":[\"style\",\"background-color: #202030 !important; background-image: none !important\"]}"],["{\"selector\":\".page-wrap\",\"action\":[\"style\",\"margin-right: unset !important\"]}"],["{\"selector\":\"#cmain\",\"action\":[\"style\",\"margin-left: unset !important\"]}"],["{\"selector\":\"body[style] > .vgt_orig_bg\",\"action\":[\"style\",\"display: block !important\"]}","{\"selector\":\"html > body[style] > :not(.vgt_orig_bg)\",\"action\":[\"style\",\"pointer-events: auto !important\"]}","{\"selector\":\"html > body[style]\",\"action\":[\"style\",\"pointer-events: none !important; padding-top: 0 !important; background-image: none !important\"]}"],["{\"selector\":\".with-cookies-agreements .channels-line\",\"action\":[\"style\",\"top: calc(70px + 0px) !important\"]}","{\"selector\":\".with-cookies-agreements .header\",\"action\":[\"style\",\"top: 0 !important\"]}","{\"selector\":\".with-cookies-agreements .wrapper\",\"action\":[\"style\",\"margin-top: 120px !important\"]}","{\"selector\":\".wrapper.adfoxClickable > div\",\"action\":[\"style\",\"pointer-events: auto !important\"]}","{\"selector\":\".wrapper.adfoxClickable\",\"action\":[\"style\",\"padding-top: 0 !important; background-image: none !important; pointer-events: none !important; background-color: #ECEFF2 !important\"]}","{\"selector\":\"body > .wrapper\",\"action\":[\"style\",\"padding-top: 0 !important; background-color: #ECEFF2 !important\"]}"],["{\"selector\":\"div[style^=\\\"min-height: 100vh;\\\"]\",\"action\":[\"style\",\"min-height: 0 !important\"]}"],["{\"selector\":\"ul.tabsmenuverch li\",\"action\":[\"style\",\"padding-right: 2px !important; padding-left: 2px !important\"]}"],["{\"selector\":\".ly.header\",\"action\":[\"style\",\"top: -1px !important\"]}","{\"selector\":\".onair[style^=\\\"height:\\\"] > .onair_wrapper > [name=\\\"btn_air_close\\\"]\",\"action\":[\"style\",\"opacity: unset !important\"]}","{\"selector\":\".onair_wrapper\",\"action\":[\"style\",\"position: relative !important; bottom: unset !important; right: unset !important; -webkit-animation: none !important; animation: none !important\"]}","{\"selector\":\".vjs-poster\",\"action\":[\"style\",\"position: inherit !important\"]}"],["{\"selector\":\"td[width=\\\"100%\\\"][valign=\\\"top\\\"][class^=\\\"post\\\"] > .postcolor > img\",\"action\":[\"style\",\"max-width: 100% !important\"]}"],["{\"selector\":\"#header + .banner\",\"action\":[\"style\",\"height: 100px !important\"]}"],["{\"selector\":\".p_wrap\",\"action\":[\"style\",\"margin-top: 0 !important\"]}"],["{\"selector\":\".wrap\",\"action\":[\"style\",\"transform: none !important; margin-top: 0 !important\"]}"],["{\"selector\":\"body\",\"action\":[\"style\",\"background-color: #f1f3f6 !important\"]}"],["{\"selector\":\"body\",\"action\":[\"style\",\"overflow-y: hidden !important\"]}","{\"selector\":\"html\",\"action\":[\"style\",\"overflow-y: auto !important\"]}"],["{\"selector\":\"div > .banner-root ~ .page-root > #page > div[class]:first-child > div[class]:first-child + div + div > div[style] > div[style] > div > div:last-child div\",\"action\":[\"style\",\"min-height: 0 !important\"]}","{\"selector\":\"div > .banner-root ~ .page-root > #page > div[class]:first-child > div[class]:first-child + div > section > div[class]:first-child ~ div > div > div\",\"action\":[\"style\",\"min-height: 0 !important\"]}","{\"selector\":\"div > .banner-root ~ .page-root > #page > div[class]:first-child > div[class]:first-child + div > section > div[class]:first-child ~ div > div > span ~ div > div[class]\",\"action\":[\"style\",\"min-height: 0 !important\"]}"],["{\"selector\":\"#columns > .transparent\",\"action\":[\"style\",\"background-color: transparent !important\"]}","{\"selector\":\".branding\",\"action\":[\"style\",\"background: none !important; height: auto !important\"]}","{\"selector\":\".logo\",\"action\":[\"style\",\"background: none !important; height: auto !important\"]}","{\"selector\":\"body[style^=\\\"padding-top:\\\"][style*=\\\"250px\\\"][style*=\\\"!important\\\"]\",\"action\":[\"style\",\"margin-top: -250px !important\"]}","{\"selector\":\"html > body:not(#id)\",\"action\":[\"style\",\"background-color: #3a3a3a !important\"]}"],["{\"selector\":\".rotate-block\",\"action\":[\"style\",\"display: table !important\"]}","{\"selector\":\"aside > div[class^=\\\"styled__SidebarWrap-\\\"]\",\"action\":[\"style\",\"height: auto !important\"]}"],["{\"selector\":\".wrapper-header\",\"action\":[\"style\",\"margin-top: 0 !important\"]}"],["{\"selector\":\".wrapper\",\"action\":[\"style\",\"top: 0 !important\"]}"],["{\"selector\":\"div[class*=\\\"user-data-grid\\\"]\",\"action\":[\"style\",\"background: none !important; height: auto !important\"]}"],["{\"selector\":\"#root\",\"action\":[\"style\",\"min-height: 0 !important\"]}"],["{\"selector\":\"#blink2[color=\\\"red\\\"]\",\"action\":[\"style\",\"-webkit-animation: none !important; color: #837e6e !important\"]}","{\"selector\":\"div[id^=\\\"pos\\\"] > a > img[src*=\\\"audioportal.su/!!!ads/!rotator/\\\"]\",\"action\":[\"style\",\"zoom: 0.1 !important; filter: grayscale(1) !important\"]}"],["{\"selector\":\"body [data-revive-id] ~ script ~ [id][class]\",\"action\":[\"style\",\"background-image: none !important\"]}","{\"selector\":\"html:not([class]):not([style]) > body:not([itemscope]) > div[id] > div[id][href]\",\"action\":[\"style\",\"cursor: auto !important\"]}","{\"selector\":\"html[style]:not([style=\\\"\\\"]) > body [class]:not([id]):not(div):not([style]) :not(div)[class][id]\",\"action\":[\"style\",\"min-height: 0 !important; height: unset !important\"]}"],["{\"selector\":\".category-all #content\",\"action\":[\"style\",\"background-image: none !important; cursor: auto !important\"]}"],["{\"selector\":\"div#main\",\"action\":[\"style\",\"margin-top: 0 !important; margin-bottom: 0 !important\"]}","{\"selector\":\"table.lista[width=\\\"100%\\\"][style] > tbody > tr > td.header[width=\\\"110px\\\"]\",\"action\":[\"style\",\"color: transparent !important\"]}"],["{\"selector\":\".static_content\",\"action\":[\"style\",\"min-height: 0 !important\"]}"],["{\"selector\":\".topserial\",\"action\":[\"style\",\"height: auto !important\"]}"],["{\"selector\":\".footer\",\"action\":[\"style\",\"margin-bottom: 0 !important\"]}"],["{\"selector\":\"#disqus_thread\",\"action\":[\"style\",\"min-width: 700px !important\"]}"],["{\"selector\":\".video_content\",\"action\":[\"style\",\"height: auto !important\"]}"],["{\"selector\":\".is--forum\",\"action\":[\"style\",\"margin-top: 0 !important\"]}","{\"selector\":\"body > div[id]:not([class])\",\"action\":[\"style\",\"margin-top: auto !important\"]}"],["{\"selector\":\"html:not(#id) *\",\"action\":[\"style\",\"-webkit-filter: none !important; filter: none !important\"]}"],["{\"selector\":\"#cn-content.playlists-iframe\",\"action\":[\"style\",\"display: block !important\"]}"],["{\"selector\":\"html.bx-no-touch button[data-analytics$=\\\"-watch-with-ads-btn\\\"]\",\"action\":[\"style\",\"min-width: 0 !important; max-width: unset !important; width: 115px !important; overflow: hidden !important; padding-left: 15px !important\"]}"],["{\"selector\":\"[data-video_status=\\\"paused\\\"] .buttonContainer[data-name=\\\"play\\\"][style*=\\\"left: 10px;\\\"]\",\"action\":[\"style\",\"opacity: unset !important\"]}"],["{\"selector\":\".eael-sticky-video-wrapper > #videobox\",\"action\":[\"style\",\"all: inherit !important\"]}"],["{\"selector\":\"#subbody\",\"action\":[\"style\",\"top: auto !important\"]}","{\"selector\":\".big-ad-wrapper\",\"action\":[\"style\",\"height: auto !important\"]}","{\"selector\":\"html > body:not(#id) > *\",\"action\":[\"style\",\"pointer-events: auto !important\"]}","{\"selector\":\"html > body:not(#id)\",\"action\":[\"style\",\"pointer-events: none !important; background-color: #eff1f2 !important; margin-top: auto !important\"]}"],["{\"selector\":\"div[style=\\\"position:absolute;left:0px;top:0px;width:240px;margin-top:660px\\\"]\",\"action\":[\"style\",\"position: relative !important; margin-top: auto !important\"]}"],["{\"selector\":\".scroll-content.disable-scrolling\",\"action\":[\"style\",\"overflow:auto !important\"]}","{\"selector\":\"body.overflow--hidden\",\"action\":[\"style\",\"overflow:auto !important\"]}"],["{\"selector\":\"#wrapper > #header\",\"action\":[\"style\",\"position: relative !important\"]}","{\"selector\":\"#wrapper\",\"action\":[\"style\",\"padding-top: 0 !important\"]}"],["{\"selector\":\"html\",\"action\":[\"style\",\"position: relative !important; top: 0 !important\"]}"],["{\"selector\":\".wrap_nd .page-head\",\"action\":[\"style\",\"height: auto !important\"]}"],["{\"selector\":\".l-wrapper\",\"action\":[\"style\",\"margin-top: 0 !important\"]}"],["{\"selector\":\".header.fixed .layout\",\"action\":[\"style\",\"margin-top: 0 !important\"]}","{\"selector\":\".right_column_content > .block_news\",\"action\":[\"style\",\"margin-top: 0 !important\"]}","{\"selector\":\"header.header\",\"action\":[\"style\",\"margin-top: 0 !important\"]}"],["{\"selector\":\".page-container\",\"action\":[\"style\",\"top: 0 !important\"]}"],["{\"selector\":\"body\",\"action\":[\"style\",\"background-image: none !important; background-color: #f5f5f5 !important\"]}"],["{\"selector\":\"#content > #header > div[style^=\\\"height: 94px;\\\"]\",\"action\":[\"style\",\"height: 6px !important\"]}","{\"selector\":\"#content > #header\",\"action\":[\"style\",\"height: 220px !important; background-position-y: -100px !important\"]}","{\"selector\":\"#right > div[style^=\\\"height:\\\"]\",\"action\":[\"style\",\"height: 0 !important\"]}","{\"selector\":\"td.left[width=\\\"200\\\"][valign=\\\"top\\\"]\",\"action\":[\"style\",\"height: auto !important\"]}"],["{\"selector\":\"body\",\"action\":[\"style\",\"padding-top: 40px !important; background-image: none !important\"]}"],["{\"selector\":\".gbg\",\"action\":[\"style\",\"top: auto !important\"]}"],["{\"selector\":\"#header\",\"action\":[\"style\",\"height: auto !important\"]}"],["{\"selector\":\".header-main .container .row\",\"action\":[\"style\",\"min-height: unset !important\"]}"],["{\"selector\":\"body > .block0\",\"action\":[\"style\",\"margin-top: 0 !important\"]}"],["{\"selector\":\".ban_head\",\"action\":[\"style\",\"display: block !important; background: none !important; pointer-events: none !important\"]}","{\"selector\":\"header > a[href=\\\"/\\\"]\",\"action\":[\"style\",\"display: block !important\"]}","{\"selector\":\"main\",\"action\":[\"style\",\"margin-top: 0 !important\"]}"],["{\"selector\":\"#page\",\"action\":[\"style\",\"margin-top: 0 !important\"]}"],["{\"selector\":\".block-type-widget-area\",\"action\":[\"style\",\"min-height: 0 !important; box-shadow: none !important\"]}"],["{\"selector\":\"body.td-animation-stack-type0 .post img\",\"action\":[\"style\",\"opacity: unset !important\"]}","{\"selector\":\"body.td-animation-stack-type0 .td-animation-stack .entry-thumb\",\"action\":[\"style\",\"opacity: unset !important\"]}"],["{\"selector\":\".back_bottom > *\",\"action\":[\"style\",\"pointer-events: auto !important\"]}","{\"selector\":\".back_bottom\",\"action\":[\"style\",\"cursor: auto !important\"]}","{\"selector\":\".back_bottom\",\"action\":[\"style\",\"pointer-events: none !important\"]}"],["{\"selector\":\".island_overflow-initial > .feature_wide\",\"action\":[\"style\",\"margin: auto !important\"]}"],["{\"selector\":\"#popup-manager.popup-show + #layout\",\"action\":[\"style\",\"-webkit-filter: none !important; filter: none !important\"]}"],["{\"selector\":\"#ad-300 + .w\",\"action\":[\"style\",\"margin-top: unset !important\"]}"],["{\"selector\":\"#main-block > .content-block\",\"action\":[\"style\",\"margin: auto !important\"]}"],["{\"selector\":\"#navbar\",\"action\":[\"style\",\"position: relative !important\"]}"],["{\"selector\":\"body\",\"action\":[\"style\",\"background-image: none !important; padding-top: 0 !important\"]}"],["{\"selector\":\".body_container\",\"action\":[\"style\",\"padding-bottom: unset !important\"]}","{\"selector\":\".footer_container\",\"action\":[\"style\",\"height: auto !important; margin-top: auto !important\"]}"],["{\"selector\":\".video-stream > *\",\"action\":[\"style\",\"pointer-events: auto !important\"]}","{\"selector\":\".video-stream\",\"action\":[\"style\",\"background-image:none !important; pointer-events: none !important\"]}"],["{\"selector\":\"aside#sidebar\",\"action\":[\"style\",\"min-height: auto !important\"]}"],["{\"selector\":\".fb-sidebar__main > a[href]\",\"action\":[\"style\",\"pointer-events: none !important\"]}"],["{\"selector\":\".lenta-wrap > .lenta\",\"action\":[\"style\",\"position: relative !important\"]}","{\"selector\":\".lenta-wrap\",\"action\":[\"style\",\"height: auto !important\"]}"],["{\"selector\":\"body.lock\",\"action\":[\"style\",\"overflow: auto !important; padding-right: 0 !important\"]}"],["{\"selector\":\"#totalbg\",\"action\":[\"style\",\"background-image: none !important\"]}"],["{\"selector\":\"body > .layout\",\"action\":[\"style\",\"margin-top: 0 !important\"]}"],["{\"selector\":\"a[href*=\\\"://rdr.fmcgsd.net/in/offer/\\\"]\",\"action\":[\"style\",\"pointer-events: none !important; color: unset !important; border-bottom: none !important\"]}","{\"selector\":\"a[href*=\\\"://telemart.ua/\\\"]\",\"action\":[\"style\",\"pointer-events: none !important; color: unset !important; border-bottom: none !important\"]}","{\"selector\":\"a[href*=\\\"utm_\\\"][target=\\\"_blank\\\"]\",\"action\":[\"style\",\"pointer-events: none !important; color: unset !important; border-bottom: none !important\"]}","{\"selector\":\"a[href^=\\\"https://ek.ua/ua/\\\"]\",\"action\":[\"style\",\"pointer-events: none !important; color: unset !important; border-bottom: none !important\"]}"],["{\"selector\":\"html:not(#id)\",\"action\":[\"style\",\"background: none !important\"]}"],["{\"selector\":\".infobar > .info-block:not(.mail):not(.weather)\",\"action\":[\"style\",\"border: none !important\"]}"],["{\"selector\":\".wrapper > .header\",\"action\":[\"style\",\"height: 150px !important\"]}"],["{\"selector\":\"#home_page\",\"action\":[\"style\",\"max-width: 100% !important\"]}"],["{\"selector\":\".alltop1\",\"action\":[\"style\",\"margin-bottom: 30px !important\"]}"],["{\"selector\":\"footer\",\"action\":[\"style\",\"margin: 0 !important\"]}"],["{\"selector\":\"#js-content\",\"action\":[\"style\",\"padding-top: 40px !important\"]}"],["{\"selector\":\".mfp-content\",\"action\":[\"style\",\"background-color: #ddd !important\"]}","{\"selector\":\".mfp-wrap\",\"action\":[\"style\",\"position: unset !important\"]}"],["{\"selector\":\"head > style:empty\",\"action\":[\"style\",\"all: inherit !important\"]}"],["{\"selector\":\"#outer-top\",\"action\":[\"style\",\"padding-top: initial !important\"]}"],["{\"selector\":\"body.locked\",\"action\":[\"style\",\"overflow:auto !important\"]}","{\"selector\":\"html.locked\",\"action\":[\"style\",\"overflow:auto !important\"]}"],["{\"selector\":\"#page\",\"action\":[\"style\",\"-webkit-filter:none !important; filter: none !important\"]}","{\"selector\":\".fancybox-lock body\",\"action\":[\"style\",\"overflow: auto !important\"]}"],["{\"selector\":\"#header-dummy:not(#id)\",\"action\":[\"style\",\"min-height: 70px !important\"]}"],["{\"selector\":\"#site_container\",\"action\":[\"style\",\"margin-top: auto !important\"]}"],["{\"selector\":\"div[class^=\\\"playlist-player-branding-\\\"] ~ .playlist-player\",\"action\":[\"style\",\"max-width: 1155px !important\"]}"],["{\"selector\":\"body .header .header-fixed\",\"action\":[\"style\",\"top: 0 !important\"]}","{\"selector\":\"body .header\",\"action\":[\"style\",\"padding-top: 0 !important\"]}"],["{\"selector\":\"body > .root\",\"action\":[\"style\",\"top: 0 !important\"]}"],["{\"selector\":\"#localNotice .floatleft img\",\"action\":[\"style\",\"height: 70px !important; width: auto !important\"]}"]];

const hostnamesMap = new Map([["kinokrad.ac",0],["kinokong.bz",0],["4video.adult",1],["kv.by",[1,18,19]],["ixbt.com",[1,18,58,79]],["livejournal.com",[1,11,18,89]],["zakarpatpost.net",[1,18]],["userstyles.org",[1,18]],["2pay-day.ru",1],["aif.ru",[1,18,252]],["oper.ru",[1,18,384]],["sc2tv.ru",[1,18,412]],["stopgame.ru",[1,18,427]],["mc.today",[1,18,461]],["newstudio.tv",[1,18,40]],["ain.ua",[1,18,474]],["bit.ua",[1,18,81]],["budport.com.ua",[1,18,479]],["ko.com.ua",[1,18,486]],["ag",2],["biz",2],["buzz",2],["by",2],["city",2],["club",2],["co",2],["com",2],["fi",2],["in",2],["ink",2],["kim",2],["loan",2],["me",2],["name",2],["net",2],["org",2],["rest",2],["run",2],["sh",2],["so",2],["space",2],["today",2],["tv",2],["vip",2],["website",2],["win",2],["rp5.am",3],["rp5.by",3],["rp5.kz",3],["rp5.md",3],["rp5.co.nz",3],["rp5.ru",3],["rp5.co.uk",3],["anidub.best",4],["anilibria.best",4],["animevost.best",4],["senpai.cc",4],["kinogo-net.la",4],["anilibria.life",4],["animedia.life",4],["animego.life",4],["yummyanime.life",4],["anistars.ru",4],["animebest.tv",4],["yummyanime.best",5],["kinoxa.cc",5],["lordserial.fun",5],["hdrezka.it",5],["lordfilm.lu",5],["newseries.me",5],["cinema-hd.ru",5],["lordserial.run",5],["doramatv.su",5],["goodfilms.su",5],["lordserial.top",5],["filmshd.vip",5],["ukr.bio",6],["delovoymir.biz",7],["infoua.biz",8],["pornolab.biz",9],["pornolab.cc",9],["pornolab.lib",9],["pornolab.net",9],["ruporus.biz",10],["ruporus.cc",10],["ruporus.com",10],["ruporus.net",10],["porus.ru",10],["ruporus.top",10],["ruporus.tv",10],["ruporus.xyz",10],["levik.blog",11],["lena-miro.ru",11],["olegmakarenko.ru",11],["shakko.ru",11],["shiro-kino.ru",11],["vadimrazumov.ru",11],["periskop.su",11],["av.by",12],["www.aviasales.by",13],["www.aviasales.kg",13],["www.aviasales.md",13],["www.aviasales.ru",13],["www.aviasales.ua",13],["www.aviasales.uz",13],["blisch.by",14],["old.sport-tv.by",14],["mail.ukr.net",[14,200]],["domovita.by",15],["eplus.by",16],["investing.com",16],["ogorodniki.com",16],["delfi.ee",16],["moscowtimes.eu",16],["cursorinfo.co.il",16],["newsyou.info",[16,146]],["2ip.io",16],["fex.net",[16,177]],["26-2.ru",[16,247]],["2ip.ru",16],["arbitr-praktika.ru",[16,247]],["batenka.ru",16],["budgetnik.ru",[16,247]],["buhsoft.ru",[16,247]],["business.ru",[16,247]],["cxychet.ru",[16,247]],["dirsalona.ru",[16,247]],["draug.ru",[16,297]],["fd.ru",[16,247]],["gazeta-unp.ru",[16,247]],["gd.ru",[16,247]],["gkh.ru",[16,247]],["glavbukh.ru",[16,247]],["hr-director.ru",[16,247]],["kdelo.ru",[16,247]],["kom-dir.ru",[16,247]],["law.ru",[16,247]],["lawyercom.ru",[16,247]],["menobr.ru",[16,247]],["modsforwot.ru",[16,297]],["moscowtimes.ru",16],["nalogplan.ru",[16,247]],["pro-goszakaz.ru",[16,247]],["pro-personal.ru",[16,247]],["resobr.ru",[16,247]],["rnk.ru",[16,247]],["rusprofile.ru",16],["sekretariat.ru",[16,247]],["stroychet.ru",[16,247]],["trudohrana.ru",[16,247]],["ugpr.ru",[16,247]],["zarplata-online.ru",[16,247]],["zdrav.ru",[16,247]],["w98008mo.beget.tech",16],["budgetnyk.com.ua",[16,247]],["dzakupivli.com.ua",[16,247]],["edenland.com.ua",16],["kadrovik01.com.ua",[16,247]],["medsprava.com.ua",[16,247]],["sop.com.ua",[16,247]],["factor.ua",16],["golovbukh.ua",[16,247]],["podrobno.uz",[16,358]],["kraj.by",17],["allapteki.ru",17],["profile.ru",17],["kurs.com.ua",17],["cont.ws",17],["game-pool.ru",[18,313]],["pay-day.ru",[18,40]],["nn.by",20],["onliner.by",21],["pogoda.onliner.by",22],["tech.onliner.by",22],["mag.relax.by",23],["reshu.by",[24,25]],["sdamgia.ru",[24,25,413]],["reshuent.kz",25],["reshuolymp.ru",25],["sport-tv.by",26],["tut.by",27],["vseprosport.by",28],["vseprosport.kz",28],["vseprosport.ru",28],["vse-pro-sport.com.ua",28],["yandex.by",[29,30,31]],["yandex.kz",[29,30,31]],["yandex.ru",[29,30,31,452]],["yandex.uz",[29,30,31]],["dzen.ru",[30,301]],["ya.ru",31],["mail.yandex.by",32],["mail.yandex.com",32],["mail.yandex.kz",32],["mail.yandex.ru",32],["mail.yandex.uz",32],["music.yandex.by",33],["music.yandex.kz",33],["music.yandex.ru",33],["music.yandex.uz",33],["rasp.yandex.by",34],["rasp.yandex.kz",34],["rasp.yandex.ru",34],["rasp.yandex.uz",34],["astar.bz",35],["anistar.org",35],["online-star.org",35],["online-stars.org",35],["sochi.camera",36],["freehat.cc",37],["hdkinomir.cc",38],["sefon.cc",39],["intermedia.ru",39],["gorod.dp.ua",39],["utorr.cc",[40,41]],["kinoukr.com",40],["baskino.film",40],["moskva.fm",40],["dnepr.info",40],["rusfootball.info",40],["virusinfo.info",[40,81]],["zombie-film.live",40],["ladys.media",40],["filmitorrent.net",[40,41]],["konohatv.org",40],["trupornolabs.org",40],["xxxadulttorrent.org",40],["nnmclub.ro",[40,52,241]],["dugtor.ru",[40,300]],["hdkinozzoro.ru",[40,330]],["roem.ru",40],["vc.ru",[40,299]],["you-anime.ru",40],["filmitorrent.site",[40,41]],["nnmclub.to",[40,52,241]],["wikianime.tv",40],["yummyanime.tv",40],["jetsetter.ua",40],["kinoafisha.ua",40],["kinobar.vip",40],["timeweb.cloud",42],["films-online.club",43],["myseason.club",44],["kinovibe.co",45],["ofxme.co",46],["1bigboss.com",47],["bigboss.video",47],["1informer.com",48],["fainaidea.com",48],["root-nation.com",[48,104]],["itech.co.ua",48],["agroreview.com",49],["all-episodesfun.com",[50,51]],["riotpixels.com",[51,103]],["animego.space",[51,456]],["smartmama.com.ua",[51,491]],["ampercar.com",52],["itechua.com",52],["hi-fi.ru",[52,331]],["hi-news.ru",52],["modernrock.ru",52],["uamotors.com.ua",52],["kino-teatr.ua",[52,510]],["mmr.net.ua",52],["anidubonline.com",53],["anidub.vip",53],["avtorambler.com",54],["rambler.ru",[54,68]],["brestcity.com",55],["buhgalter911.com",[56,57]],["buhgalter.com.ua",57],["businessua.com",58],["championat.com",59],["cherkassy-sport.com",60],["coub.com",61],["crazyatomicgames.com",62],["xxx-igra.com",62],["yaldagames.com",62],["animejapan.tv",62],["drive2.com",63],["drive2.ru",63],["economistua.com",[64,65]],["hs-manacost.ru",[64,333]],["filmozavr.com",66],["filmozavr.net",66],["flashscorekz.com",67],["flashscore.ru.com",67],["soccerstand.com",67],["livescore.in",67],["flashscore.com.ua",67],["flashscore.ua",67],["gagadget.com",68],["gazeta.ru",[68,319]],["lenta.ru",[68,352]],["gamegpu.com",69],["gamer-info.com",70],["gasolina-online.com",71],["houzz.ru",[71,107]],["galka.if.ua",71],["proxima.net.ua",71],["gdetraffic.com",72],["gecid.com",[73,74]],["tt-cup.com",[73,115,116]],["dyvys.info",[73,116,140]],["valetudo.ru",[73,116]],["agronom.com.ua",[73,115,116]],["gubkinskiy.com",75],["hellomagazine.com",76],["inoreader.com",77],["instagram.com",78],["forum.ixbt.com",80],["smb.ixbt.com",[81,82,83]],["gidonline.fun",81],["ixbt.games",[81,83,135]],["sportboom.info",81],["kinogo-720.net",81],["repackov.net",81],["urologypro.ru",81],["kinoboom.su",81],["greenpost.ua",81],["www.ixbt.com",[84,85]],["ixbt.market",85],["kinokladovka.com",86],["kinorium.com",87],["latifundimag.com",88],["www.livejournal.com",90],["mobile-review.com",91],["newsland.com",92],["obozrevatel.com",93],["darkermagazine.ru",93],["open3dmodel.com",94],["otzovik.com",95],["partnerkin.com",96],["promodj.com",97],["pvpru.com",98],["rbkgames.com",99],["reshebnik.com",100],["ringside24.com",[101,102]],["dynamo.kiev.ua",[101,102]],["autoua.net",102],["www.okino.ua",102],["forum.ru-board.com",105],["rustorka.com",106],["rustorkacom.lib",106],["rustorka.net",106],["apad2.top",106],["game4you.top",106],["games-pc.top",106],["innal.top",[106,249,462]],["naylo.top",106],["rustorka.top",106],["sherdog.com",[107,108]],["softportal.com",[107,109]],["dentalmagazine.ru",107],["noddb.ru",107],["ppt.ru",107],["texterra.ru",107],["buh24.com.ua",107],["senior.ua",[107,517]],["sovetromantica.com",110],["sportarena.com",111],["tehnot.com",112],["the-village-kz.com",113],["the-village.me",113],["the-village.ru",113],["village.com.ua",113],["torent-igruha.com",114],["ua-cinema.com",117],["uakino.com",118],["ukrainianwall.com",119],["vk.com",[120,121]],["vk.ru",121],["volynpost.com",122],["vserialy.com",123],["vserialy.fun",123],["great-tv.ru",123],["vtb-league.com",124],["yaplakal.com",125],["yap.ru",125],["zerno-ua.com",126],["znak.com",127],["filmix.date",[128,129]],["filmix.fm",[128,129]],["filmix.life",[128,129]],["ru-drivemusic.net",128],["filmix.pub",[128,129]],["nevasport.ru",128],["filmix.tech",[128,129]],["filmix.zone",[128,129]],["lostfilm.download",[130,131]],["lostfilm.life",[130,131]],["lostfilm.one",[130,131]],["lostfilm.pro",[130,131]],["lostfilmtv.site",[130,131]],["lostfilmtv2.site",[130,131]],["lostfilmtv3.site",[130,131]],["lostfilmtv5.site",[130,131]],["lostfilm.space",130],["lostfilm.today",[130,131]],["lostfilm.tv",[130,131]],["lostfilm.tw",[130,131]],["lostfilm.uno",[130,131]],["lostfilmtv.uno",[130,131]],["lostfilm.win",[130,131]],["lostfilmtv1.site",131],["lostfilmtv4.site",131],["postimees.ee",132],["mel.fm",133],["tort.fm",134],["aces.gg",136],["conversion.im",137],["doefiratv.info",138],["dostfilms.info",139],["wowskill.ru",139],["dostfilms.site",139],["glavred.info",141],["glavred.net",141],["lostfilm.info",142],["mediasat.info",143],["mivmeste.info",144],["news-sport.info",145],["1plus1.international",147],["bigudi.tv",[147,229]],["plus-plus.tv",[147,229]],["2plus2.ua",[147,229]],["mega.io",148],["mega.nz",148],["thebell.io",149],["vtimes.io",150],["kp.kg",[151,152]],["kp.kz",[151,152]],["kp.md",[151,152]],["kp.ru",[151,350]],["media",152],["ru",[152,242,243]],["namba.kg",153],["ts.kg",[154,155]],["asienda.ru",[154,266]],["diets.ru",[154,293]],["gameguru.ru",[154,316]],["mycharm.ru",[154,266]],["myjane.ru",[154,266]],["peterburg2.ru",[154,388]],["povarenok.ru",[154,395]],["relook.ru",[154,406]],["stranamam.ru",[154,428]],["growhow.in.ua",154],["sport-express.ua",155],["ukrfootball.ua",155],["3dnews.kz",156],["3dnews.ru",156],["namba.kz",157],["shaiba.kz",158],["yk.kz",159],["surl.li",160],["rezkahd.life",161],["mintmanga.live",162],["selfmanga.live",162],["filmhd1080.me",163],["myshows.me",164],["online-fix.me",165],["opennet.me",166],["opennet.ru",166],["repack.me",167],["tasix.me",168],["kino.video",168],["torrentinka.me",169],["uakino.me",170],["adme.media",171],["holod.media",172],["1080kino.net",173],["www.bigmir.net",174],["censor.net",175],["driveroff.net",176],["filmishki.net",178],["filmive-hd.net",179],["kinoshack.net",179],["tree.tv",179],["fishki.net",180],["zagonkop.gb.net",181],["zagonkov.gb.net",181],["zagonka.net",181],["zagonko.org",181],["zogonka.org",181],["zagonka.tv",181],["hdru.net",182],["hvylya.net",183],["igry-online.net",184],["fullfilmhd.space",184],["animespirit.tv",184],["jut-su.net",185],["kinoakter.net",186],["libertycity.net",187],["libertycity.ru",187],["lrepacks.net",188],["megogo.net",189],["miyzvuk.net",190],["kolizhanka.com.ua",190],["nashaplaneta.net",191],["playua.net",192],["politobzor.net",193],["context.reverso.net",194],["rserials.net",195],["season-var.net",196],["stravy.net",197],["tapochek.net",198],["tochka.net",199],["www.ukr.net",201],["winzoro.net",202],["doramalive.news",203],["regnum.news",204],["regnum.ru",204],["ua.news",205],["ura.news",206],["hentai-share.one",[207,208]],["mintmanga.one",207],["allhen.online",207],["seasonvar.one",209],["animemobi.ru",209],["euro-football.ru",209],["onlinestreams.ru",209],["animegid.online",210],["animego.online",211],["kirov.online",212],["rudub.online",213],["tv-kanali.online",214],["zaycev.online",215],["24smi.org",216],["alexfilm.org",217],["allbasketball.org",[218,219]],["gstv.ru",218],["animevost.org",220],["vost.pw",220],["animevost.top",220],["anitokyo.org",221],["anitokyo.tv",221],["binmovie.org",222],["doramax.org",223],["fastpic.org",224],["freeopenvpn.org",225],["freetp.org",226],["freetp.ru",226],["hentaiz.org",227],["igrovaya.org",228],["vsetors.org",228],["kaztorka.org",[229,230]],["allboxing.ru",[229,253]],["star-wars-film.ru",229],["nv.ua",[229,513]],["livesport.ws",229],["my-hit.org",231],["pronpic.org",232],["riperam.org",233],["simhost.org",234],["uniondht.org",[235,236]],["seasonvar.ru",235],["animedia.pro",[237,238]],["tt.animedia.tv",238],["teleprogramma.pro",239],["cpa.rip",240],["hlamer.ru",242],["101.ru",244],["116.ru",245],["14.ru",245],["161.ru",245],["164.ru",245],["173.ru",245],["178.ru",245],["26.ru",245],["29.ru",245],["35.ru",245],["43.ru",245],["45.ru",245],["48.ru",245],["51.ru",245],["53.ru",245],["56.ru",245],["59.ru",245],["60.ru",245],["62.ru",245],["63.ru",245],["68.ru",245],["71.ru",245],["72.ru",245],["74.ru",245],["76.ru",245],["86.ru",245],["89.ru",245],["93.ru",245],["chita.ru",[245,284]],["e1.ru",245],["ircity.ru",245],["izh1.ru",245],["mgorsk.ru",245],["msk1.ru",245],["ngs.ru",245],["ngs22.ru",245],["ngs24.ru",245],["ngs42.ru",245],["ngs55.ru",245],["ngs70.ru",245],["nn.ru",245],["sochi1.ru",245],["sterlitamak1.ru",245],["tolyatty.ru",245],["ufa1.ru",245],["v1.ru",245],["vladivostok1.ru",245],["voronezh1.ru",245],["www.1tv.ru",246],["tornado.3dn.ru",248],["7days.ru",249],["zannn.top",[249,462]],["ag.ru",250],["agroxxi.ru",251],["alllyr.ru",254],["androidinsider.ru",255],["anekdot.ru",256],["anime-naruto.ru",257],["blich.ru",257],["borutoplanet.ru",257],["bungou-stray-dogs.ru",257],["doktor-stoun.ru",257],["haikyu.ru",257],["hunter-x-hunter.ru",257],["klinok-rassekayuschiy-demonov.ru",257],["magicheskaya-bitva.ru",257],["my-hero-academia.ru",257],["one-pieces.ru",257],["reinkarnatsiya-bezrabotnogo.ru",257],["tokiyskie-mstiteli.ru",257],["anime777.ru",258],["animecos.ru",259],["animedub.ru",260],["animemovie.ru",261],["anti-malware.ru",262],["app-time.ru",263],["app2top.ru",264],["artfile.ru",265],["avito.ru",267],["baby.ru",268],["banki.ru",269],["bestpersons.ru",270],["bombardir.ru",271],["bosch-home.ru",272],["botanichka.ru",[273,274]],["prikol.ru",[273,396]],["bryansknovosti.ru",275],["novozybkov.su",275],["bugaga.ru",276],["buhonline.ru",277],["burninghut.ru",278],["buzulukday.ru",279],["nsday.ru",279],["orenday.ru",279],["perevolockday.ru",279],["saltday.ru",279],["sorochinskday.ru",279],["bvedomosti.ru",280],["car.ru",281],["carambatv.ru",282],["cars.ru",283],["www.cnews.ru",285],["zoom.cnews.ru",286],["coop-land.ru",287],["cq.ru",288],["creativportal.ru",289],["ctv7.ru",290],["cyberforum.ru",291],["cybersport.ru",292],["club.dns-shop.ru",294],["dota2.ru",295],["drahelas.ru",296],["stalkerportaal.ru",297],["top-mods.ru",297],["stalker-mods.clan.su",297],["stalker-mods.su",297],["forums.drom.ru",298],["dtf.ru",299],["www.e1.ru",302],["eva.ru",303],["expertcen.ru",304],["fbsearch.ru",305],["fclmnews.ru",306],["doramy.su",306],["xsport.ua",306],["forum.flprog.ru",307],["footballhd.ru",308],["forbes.ru",309],["fototips.ru",310],["freescreens.ru",311],["imgbase.ru",311],["imgcach.ru",311],["imgclick.ru",311],["payforpic.ru",311],["picclick.ru",311],["picclock.ru",311],["picforall.ru",311],["fssprus.ru",312],["game2day.ru",314],["gamebomb.ru",315],["gamemag.ru",317],["gastronom.ru",318],["gismeteo.ru",320],["www.goha.ru",321],["gol.ru",322],["goodfon.ru",323],["goodgame.ru",324],["gotennis.ru",325],["gotps3.ru",326],["govoritmoskva.ru",327],["gta-gaming.ru",328],["gtavicecity.ru",329],["horrorzone.ru",332],["igromania.ru",334],["infourok.ru",335],["inoprosport.ru",336],["iphones.ru",337],["it-actual.ru",338],["ivanovonews.ru",339],["www.ivi.ru",340],["kaluga-poisk.ru",341],["yasniy-city.ru",341],["yola-poisk.ru",341],["kg-portal.ru",342],["kinomania.ru",343],["kinometro.ru",344],["www.kinopoisk.ru",345],["kinoteatr.ru",346],["kirovnet.ru",347],["klops.ru",348],["korabel.ru",349],["l2top.ru",351],["lifehacker.ru",353],["lifetambov.ru",354],["livecars.ru",355],["livesport.ru",355],["liveinternet.ru",356],["www.liveinternet.ru",357],["liveresult.ru",358],["m24.ru",359],["mail.ru",360],["cloud.mail.ru",361],["e.mail.ru",[362,363]],["octavius.mail.ru",362],["finance.mail.ru",364],["vfokuse.mail.ru",364],["hi-tech.mail.ru",365],["light.mail.ru",366],["minigames.mail.ru",367],["my.mail.ru",368],["news.mail.ru",369],["mentoday.ru",370],["techinsider.ru",370],["thevoicemag.ru",370],["www.mirf.ru",371],["gamma.mirtesen.ru",372],["mmo13.ru",373],["mobiltelefon.ru",374],["motorpage.ru",375],["movieshok.ru",376],["my-expert.ru",377],["newkaliningrad.ru",378],["noob-club.ru",379],["ogorod.ru",380],["ohotniki.ru",381],["ok.ru",382],["onlinemultfilmy.ru",383],["overclockers.ru",385],["forums.overclockers.ru",386],["penzainform.ru",387],["pikabu.ru",389],["pimpletv.ru",390],["playground.ru",391],["pluggedin.ru",392],["pochta.ru",393],["portalvirtualreality.ru",394],["prophotos.ru",397],["radioromantika.ru",398],["horoscopes.rambler.ru",[399,400]],["tv.rambler.ru",399],["weather.rambler.ru",399],["mail.rambler.ru",401],["nova.rambler.ru",402],["www.rambler.ru",403],["rbc.ru",[404,405]],["sportrbc.ru",404],["rg.ru",407],["ria.ru",408],["rusnext.ru",409],["russorosso.ru",410],["s13.ru",411],["seolik.ru",414],["shazoo.ru",415],["slushat-tekst-pesni.ru",416],["snob.ru",417],["sobaka.ru",418],["soccer.ru",419],["soccer365.ru",420],["soccer365.com.ua",420],["sport-express.ru",421],["sport-interfax.ru",422],["sportkp.ru",423],["sportmail.ru",424],["sports.ru",425],["sportsdaily.ru",426],["stratege.ru",429],["study.ru",430],["tass.ru",431],["teleport2001.ru",432],["thg.ru",433],["tnt-online.ru",434],["tourpom.ru",435],["tproger.ru",436],["translit.ru",437],["trashbox.ru",438],["www.vesti.ru",439],["vgae.ru",440],["vgtimes.ru",441],["videomore.ru",442],["videoredaktor.ru",443],["virtualbrest.ru",444],["vm.ru",445],["vrtp.ru",446],["warfiles.ru",447],["webfile.ru",448],["wotspeak.ru",449],["wtftime.ru",450],["www.xcom-shop.ru",451],["www.zoneofgames.ru",453],["zr.ru",454],["lafa.site",455],["loads.ati.su",457],["tm.ati.su",457],["trucks.ati.su",[457,458]],["audioportal.su",459],["4pda.to",460],["alexua.tv",463],["baibako.tv",464],["casstudio.tv",465],["espreso.tv",466],["goclips.tv",467],["naruto-base.tv",468],["nezavisim.tv",469],["softbox.tv",470],["kino.tricolor.tv",471],["cdn.viqeo.tv",472],["weukraine.tv",473],["bin.ua",475],["cf.ua",476],["4studio.com.ua",477],["apnews.com.ua",478],["champion.com.ua",480],["eurointegration.com.ua",481],["footballhub.com.ua",482],["gta.com.ua",483],["itnews.com.ua",484],["sovet.kidstaff.com.ua",485],["kredos.com.ua",487],["smartphone.ua",487],["portaltele.com.ua",488],["blogs.pravda.com.ua",489],["proagro.com.ua",490],["volnorez.com.ua",492],["vsviti.com.ua",493],["comments.ua",494],["dev.ua",495],["news.dn.ua",496],["kriminal.net.ua",496],["gazeta.ua",497],["glavnoe.ua",498],["glavpost.ua",499],["hi-tech.ua",500],["i.ua",501],["ictv.ua",502],["blitz.if.ua",503],["versii.if.ua",504],["asn.in.ua",505],["rayon.in.ua",506],["infocar.ua",507],["isport.ua",508],["itc.ua",509],["meta.ua",511],["nrj.ua",512],["btu.org.ua",514],["patrioty.org.ua",515],["radioclub.ua",516],["sinoptik.ua",518],["sport.ua",519],["doba.te.ua",520],["uteka.ua",521],["spot.uz",522],["stadion.uz",523],["1plus1.video",524],["kinoprofi.vip",525],["filebase.ws",526],["lurkmore.wtf",527]]);

const entitiesMap = new Map(undefined);

const exceptionsMap = new Map(undefined);

self.declarativeImports = self.declarativeImports || [];
self.declarativeImports.push({ argsList, hostnamesMap, entitiesMap, exceptionsMap });

/******************************************************************************/

})();

/******************************************************************************/
