/*******************************************************************************

    uBlock Origin Lite - a comprehensive, MV3-compliant content blocker
    Copyright (C) 2014-present Raymond Hill

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see {http://www.gnu.org/licenses/}.

    Home: https://github.com/gorhill/uBlock
*/

/* jshint esversion:11 */

'use strict';

// ruleset: spa-1

/******************************************************************************/

// Important!
// Isolate from global scope
(function uBOL_cssDeclarativeImport() {

/******************************************************************************/

const argsList = [["{\"selector\":\".ad_block_non_shadowed\",\"action\":[\"style\",\"position: absolute!important; left: -3000px!important;\"]}","{\"selector\":\".ad_block_shadowed\",\"action\":[\"style\",\"position: absolute!important; left: -3000px!important;\"]}"],["{\"selector\":\"div[class^=\\\"block-ads-\\\"]\",\"action\":[\"style\",\"visibility: hidden !important;\"]}"],["{\"selector\":\".hided\",\"action\":[\"style\",\"display: block !important;\"]}"],["{\"selector\":\".body\",\"action\":[\"style\",\"background-image: none!important;\"]}"],["{\"selector\":\"#colunas\",\"action\":[\"style\",\"display: block !important;\"]}"],["{\"selector\":\"#player\",\"action\":[\"style\",\"display: block !important;\"]}"],["{\"selector\":\".ads.ads-block.prebid\",\"action\":[\"style\",\"display: block !important;\"]}"],["{\"selector\":\".containerMapAndBanner > .contentMap\",\"action\":[\"style\",\"height: 100% !important;\"]}"],["{\"selector\":\".play\",\"action\":[\"style\",\"display: block !important;\"]}"],["{\"selector\":\".main__corpo\",\"action\":[\"style\",\"margin-top: 160px!important;\"]}"],["{\"selector\":\"div[class=\\\"vc_row wpb_row td-pb-row\\\"][style^=\\\"padding-top: 1\\\"]\",\"action\":[\"style\",\"padding-top: 0 !important;\"]}"],["{\"selector\":\"#fusion-app\",\"action\":[\"style\",\"margin-top: 0!important;\"]}","{\"selector\":\".navbar-container\",\"action\":[\"style\",\"margin-top: 0!important;\"]}"],["{\"selector\":\".row-container-game > .ad-game + .container-game\",\"action\":[\"style\",\"width: 100% !important;\"]}"],["{\"selector\":\"main#site-main\",\"action\":[\"style\",\"margin-top: 0px !important;\"]}"],["{\"selector\":\".is_advertising .site-advertising\",\"action\":[\"style\",\"margin: 5px auto 0 !important;\"]}"],["{\"selector\":\"body\",\"action\":[\"style\",\"overflow: auto !important; padding-right: 0 !important;\"]}"],["{\"selector\":\".block-wrapper[style*=\\\"url\\\"] > .container > .row\",\"action\":[\"style\",\"margin-top: 0 !important;\"]}","{\"selector\":\".block-wrapper[style*=\\\"url\\\"]\",\"action\":[\"style\",\"background: none !important;\"]}","{\"selector\":\"body[style*=\\\"url\\\"] .trending-light[style^=\\\"margin-top:\\\"]\",\"action\":[\"style\",\"margin-top: 20px !important;\"]}","{\"selector\":\"body[style*=\\\"url\\\"]\",\"action\":[\"style\",\"background-image: none !important;\"]}"],["{\"selector\":\"body div[id].ads.adsbox.doubleclick\",\"action\":[\"style\",\"display: block !important;\"]}"],["{\"selector\":\".area-publi\",\"action\":[\"style\",\"height: 0 !important;\"]}"],["{\"selector\":\"body\",\"action\":[\"style\",\"padding-top: 0 !important;\"]}"],["{\"selector\":\"body > header\",\"action\":[\"style\",\"top: 0 !important;\"]}"],["{\"selector\":\"#banner_b\",\"action\":[\"style\",\"display: block !important;\"]}","{\"selector\":\"iframe#google_ads_iframe_123_bait\",\"action\":[\"style\",\"display: block !important;\"]}","{\"selector\":\"iframe#google_ads_iframe_b\",\"action\":[\"style\",\"display: block !important;\"]}"],["{\"selector\":\"#header-bar.header-bar\",\"action\":[\"style\",\"padding-top: 0 !important;\"]}"],["{\"selector\":\"#div-gpt-leaderboard ~ #page\",\"action\":[\"style\",\"margin-top: 30px !important;\"]}"],["{\"selector\":\"body\",\"action\":[\"style\",\"overflow: auto !important;\"]}"],["{\"selector\":\".alert-message > #informacion\",\"action\":[\"style\",\"display: block!important;\"]}"],["{\"selector\":\".ad-lat2\",\"action\":[\"style\",\"height: 0 !important; min-height: 0 !important; margin: 0 !important; padding: 0 !important; visibility: collapse !important;\"]}"],["{\"selector\":\"#NEWS_RELATED\",\"action\":[\"style\",\"position: absolute !important; left: -3000px !important;\"]}"],["{\"selector\":\"#ROBAPAGINAS_INLINE_LEFT\",\"action\":[\"style\",\"position: absolute !important; left: -3000px !important;\"]}"],["{\"selector\":\"[id].adsbox.doubleclick.ad-placement\",\"action\":[\"style\",\"display: block !important;\"]}"],["{\"selector\":\"body .adsbygoogle\",\"action\":[\"style\",\"display: block!important; position: absolute!important; left: -3000px!important;\"]}"],["{\"selector\":\"#btn-download\",\"action\":[\"style\",\"display: block !important;\"]}"],["{\"selector\":\".navBar\",\"action\":[\"style\",\"height: auto !important;\"]}"],["{\"selector\":\".banner\",\"action\":[\"style\",\"visibility: hidden !important;\"]}"],["{\"selector\":\".ads-300x300\",\"action\":[\"style\",\"position: absolute!important; left: -3000px!important;\"]}","{\"selector\":\"div#detect.adsbox.doubleclick\",\"action\":[\"style\",\"display: block !important;\"]}"],["{\"selector\":\".content-box\",\"action\":[\"style\",\"display: block !important;\"]}"],["{\"selector\":\"body\",\"action\":[\"style\",\"background-image: none !important;\"]}"],["{\"selector\":\"header\",\"action\":[\"style\",\"top: 0 !important;\"]}"],["{\"selector\":\"body\",\"action\":[\"style\",\"overflow: visible!important;\"]}"],["{\"selector\":\"#framed > #player\",\"action\":[\"style\",\"display: block !important;\"]}"],["{\"selector\":\"#framed\",\"action\":[\"style\",\"display: block !important;\"]}"],["{\"selector\":\"body > #box\",\"action\":[\"style\",\"display: block !important;\"]}"],["{\"selector\":\"#detect.ad-placement\",\"action\":[\"style\",\"display: block !important;\"]}"],["{\"selector\":\"html.fancybox-lock > body\",\"action\":[\"style\",\"overflow: auto !important;\"]}","{\"selector\":\"html.fancybox-margin\",\"action\":[\"style\",\"margin-right: 0 !important;\"]}"],["{\"selector\":\".col-anu + div.col-cnt > div.columna\",\"action\":[\"style\",\"width: 34% !important;\"]}"],["{\"selector\":\".hasBgApb\",\"action\":[\"style\",\"margin-top: 0 !important;\"]}"],["{\"selector\":\"#ablockercheck\",\"action\":[\"style\",\"display: block!important;\"]}"],["{\"selector\":\".content_section > .top\",\"action\":[\"style\",\"margin-top: 100px !important;\"]}","{\"selector\":\".page-container.top\",\"action\":[\"style\",\"margin-top: 60px!important;\"]}","{\"selector\":\".top-home\",\"action\":[\"style\",\"margin-top: 60px!important;\"]}"],["{\"selector\":\"#article-header\",\"action\":[\"style\",\"min-height: 0 !important;\"]}"],["{\"selector\":\"body\",\"action\":[\"style\",\"overflow: visible !important;\"]}"],["{\"selector\":\"#manga-title\",\"action\":[\"style\",\"height: unset !important;\"]}"],["{\"selector\":\".lv-publi-box\",\"action\":[\"style\",\"position: absolute!important; left: -3000px!important;\"]}","{\"selector\":\".megabanner-adv\",\"action\":[\"style\",\"position: absolute!important; left: -3000px!important;\"]}"],["{\"selector\":\".add990x90 div\",\"action\":[\"style\",\"height: 0 !important;\"]}","{\"selector\":\".add990x90\",\"action\":[\"style\",\"min-height: 0 !important;\"]}"],["{\"selector\":\"iframe.video\",\"action\":[\"style\",\"display: block!important;\"]}"],["{\"selector\":\"body > .textads.banner-ads\",\"action\":[\"style\",\"display: block !important;\"]}","{\"selector\":\"body > div[id^=\\\"div-gpt-ad-\\\"]\",\"action\":[\"style\",\"display: block !important;\"]}","{\"selector\":\"body > ins.adsbygoogle\",\"action\":[\"style\",\"display: block !important;\"]}"],["{\"selector\":\"#Publi300600xaa\",\"action\":[\"style\",\"height: 1px!important;\"]}"],["{\"selector\":\"body\",\"action\":[\"style\",\"background-image:none!important;\"]}"],["{\"selector\":\"#pulzo-header\",\"action\":[\"style\",\"position: static !important;\"]}"],["{\"selector\":\"#ad\",\"action\":[\"style\",\"position: absolute!important; left: -3000px!important;\"]}"],["{\"selector\":\"#adsdiv\",\"action\":[\"style\",\"position: absolute!important; left: -3000px!important;\"]}"],["{\"selector\":\".ads.ad.adsbox.ad-placement.carbon-ads\",\"action\":[\"style\",\"display: block !important;\"]}"],["{\"selector\":\".container.have-brand\",\"action\":[\"style\",\"margin-top: 0!important;\"]}"],["{\"selector\":\"#plays\",\"action\":[\"style\",\"display: block !important;\"]}"],["{\"selector\":\".publicite.text-ad.adsbox\",\"action\":[\"style\",\"display: block !important;\"]}"],["{\"selector\":\"#neoni_mutiny\",\"action\":[\"style\",\"display: block !important;\"]}"],["{\"selector\":\".sidebar > div.tile-top.tile\",\"action\":[\"style\",\"height: auto!important;\"]}"],["{\"selector\":\"body div.adsbox.doubleclick.ad-placement[id]:not(#style_important)\",\"action\":[\"style\",\"display: block !important;\"]}"],["{\"selector\":\".iframeDiv > center > a[target=\\\"_blank\\\"]\",\"action\":[\"style\",\"position: absolute !important; left: -3000px !important;\"]}"],["{\"selector\":\"body\",\"action\":[\"style\",\"background-image: none!important;\"]}"],["{\"selector\":\".banner_large\",\"action\":[\"style\",\"position: absolute !important; left: -3000px !important;\"]}"],["{\"selector\":\"#axds-Top\",\"action\":[\"style\",\"min-height: 0 !important;\"]}"],["{\"selector\":\".pub_728x90.text-ad.textAd.text_ad.text_ads.text-ads.text-ad-links\",\"action\":[\"style\",\"display: block !important;\"]}"],["{\"selector\":\".dat-menu-container\",\"action\":[\"style\",\"cursor: auto !important;\"]}","{\"selector\":\"body[style^=\\\"background\\\"]\",\"action\":[\"style\",\"background: none !important;\"]}"],["{\"selector\":\".footer\",\"action\":[\"style\",\"padding-bottom: 0 !important;\"]}"],["{\"selector\":\".op-body\",\"action\":[\"style\",\"overflow: auto !important;\"]}"],["{\"selector\":\"aside > div > .goqpfsl\",\"action\":[\"style\",\"visibility: hidden !important; height: 1px !important;\"]}"],["{\"selector\":\"body .ads-box\",\"action\":[\"style\",\"display: block !importnat;\"]}"],["{\"selector\":\"#hide\",\"action\":[\"style\",\"display: block!important;\"]}"],["{\"selector\":\".content #src_iframe\",\"action\":[\"style\",\"display: block !important;\"]}","{\"selector\":\".content > div[id]:has(> center > #src_iframe)\",\"action\":[\"style\",\"display: block !important;\"]}"],["{\"selector\":\"body #fullbanner-container\",\"action\":[\"style\",\"height: 1px !important;\"]}"],["{\"selector\":\"[style=\\\"text-align: center; display: none;\\\"]\",\"action\":[\"style\",\"display: block !important;\"]}"],["{\"selector\":\".player\",\"action\":[\"style\",\"display: block !important;\"]}"],["{\"selector\":\"body\",\"action\":[\"style\",\"overflow: auto!important;\"]}","{\"selector\":\"html\",\"action\":[\"style\",\"overflow: auto!important;\"]}"],["{\"selector\":\"body .adblock_warning:not(#style_important)\",\"action\":[\"style\",\"position: absolute !important; left: -3000px !important;\"]}"],["{\"selector\":\".modal-open\",\"action\":[\"style\",\"overflow: auto !important;\"]}"],["{\"selector\":\"#bannerGames\",\"action\":[\"style\",\"height: 2px!important;\"]}","{\"selector\":\".adstopo\",\"action\":[\"style\",\"position: absolute!important; left: -3000px!important;\"]}"],["{\"selector\":\".pum-open-overlay\",\"action\":[\"style\",\"overflow: auto !important;\"]}"],["{\"selector\":\"div[id^=\\\"src_iframe_\\\"]\",\"action\":[\"style\",\"display: block !important;\"]}"],["{\"selector\":\"body > #content\",\"action\":[\"style\",\"padding-bottom: 0 !important;\"]}"]];

const hostnamesMap = new Map([["foros.3dgames.com.ar",0],["lavoz.com.ar",1],["vidasaudavel.bio",2],["cryptobr.biz",2],["receitastop.click",2],["financasdeouro.com",2],["receitasnatural.com",2],["receitasdodia.fun",2],["financastop.online",2],["fomedereceitas.online",2],["investimentosfacil.online",2],["infoinvest.org",2],["investfacil.org",2],["criptoreal.site",2],["blog.whatsappgb.top",2],["adrenaline.com.br",3],["adrianeboneck.com.br",4],["ldicas.com.br",4],["bolsadevalores.club",4],["androidapktop.com",4],["cheirinhobao.com",4],["dicasfinanceirasbr.com",[4,5]],["fonte1.com",4],["loucosporti.com",4],["guiasaude.info",4],["receitasdochico.life",[4,5]],["futlances.net",4],["gastronomiabrasileira.net",4],["receitasdalu.net",4],["dicadesaude.online",4],["receitasdahora.online",4],["legacyfun.site",4],["caroloportunidades.com.br",5],["dicasgostosas.com",5],["foodiesgallery.com",5],["gastroponto.com",5],["receitasvegana.com",5],["dicasdefinancas.net",5],["dicasdevalor.net",5],["guianoticiario.net",[5,60,76]],["megacurioso.net",5],["megacurioso.online",5],["nossoprato.online",5],["receitasdaora.online",5],["receitasdocheff.online",5],["ricasdelicias.online",5],["oplanetatv.clickgratis.com.br",6],["ouniversodatv.com",6],["climaaovivo.com.br",7],["decorardicas.com.br",8],["loucasporcabelos.com.br",8],["diariodepernambuco.com.br",9],["diariodoiguacu.com.br",10],["estadao.com.br",11],["geniol.com.br",12],["guiadasemana.com.br",13],["hardware.com.br",14],["inforchannel.com.br",15],["anroll.net",15],["mundoconectado.com.br",16],["oceans14.com.br",17],["tudosobrefinancas.com",17],["portugues.com.br",18],["tudogostoso.com.br",[19,20]],["lavozdegalicia.es",19],["uol.com.br",21],["jc.ne10.uol.com.br",22],["oantagonista.uol.com.br",23],["radioagricultura.cl",24],["gamesperu2021.blogspot.com",24],["mantrazscan.com",24],["dicasdereceitas.net",24],["dicasgeeks.net",24],["gamesviatorrent.top",24],["buscalinks.xyz",24],["goovie.co",25],["3djuegos.com",26],["androidayuda.com",[27,28]],["hardzone.es",27],["softzone.es",27],["antoniomote.com",29],["asialiveaction.com",30],["boafinancas.com",31],["cienradios.com",32],["clavejuegos.com",33],["depor.com",34],["dicasvalores.com",35],["elchapuzasinformatico.com",36],["elmueble.com",37],["elperiodico.com",38],["empregovaga.com",[39,40]],["resenhasglobais.com",[39,40,60]],["turismoeviagem.com",[39,40]],["vidadeatletas.com",[39,40]],["tecword.info",[39,40,60]],["blotz.me",[39,40]],["belezaedieta.net",[39,40]],["manualdamulher.net",[39,40]],["cardapiodavovo.online",[39,40]],["financashoje.online",[39,40]],["financasnow.online",[39,40]],["noticiastecnologica.online",[39,40]],["tudoemprego.online",[39,40]],["vivercomsaude.online",[39,40,60]],["smartdoing.tech",[39,40,60]],["manchetehoje.xyz",[39,40,60]],["grandnoticias.com",40],["muitasreceitas.site",40],["tecnologiaonline.site",40],["fazendorendaextra.xyz",40],["felizemforma.com",41],["filmesxp.com",42],["folhadoslagos.com",43],["formulatv.com",44],["gamevicio.com",45],["hartico.com",46],["infobae.com",47],["infoescola.com",48],["journaldemontreal.com",49],["knightnoscanlation.com",50],["lavanguardia.com",51],["lecturas.com",52],["mastercuriosidadesbr.com",53],["novatecnology.com",54],["tipsdesalud.tips",54],["pcbolsa.com",55],["profesionalreview.com",56],["pulzo.com",57],["radiotormentamx.com",[58,59]],["televall.website",58],["seodiv.com",61],["seriesbanana.com",62],["metroseries.net",62],["flixseries.org",62],["homecine.to",62],["homecine.tv",62],["smartpelis.tv",62],["seriesretro.com",63],["tudonoticiasbr.com",64],["windowsblogitalia.com",65],["xerifetech.com",66],["zona-leros.com",67],["zonammorpg.com",68],["primicias.ec",69],["20minutos.es",70],["canarias7.es",71],["hoy.es",71],["lasprovincias.es",71],["geeknetic.es",72],["informacion.es",73],["netmentor.es",74],["todalamusica.es",75],["kshowes.net",77],["sejasaudavel.net",78],["tecnoblog.net",79],["comandotorrents.org",80],["mundotec.pro",81],["jornaleconomico.pt",82],["meocloud.pt",83],["visao.sapo.pt",84],["superanimes.site",85],["lapagina.com.sv",86],["clubinvest.top",87],["donghuas.top",88]]);

const entitiesMap = new Map(undefined);

const exceptionsMap = new Map(undefined);

self.declarativeImports = self.declarativeImports || [];
self.declarativeImports.push({ argsList, hostnamesMap, entitiesMap, exceptionsMap });

/******************************************************************************/

})();

/******************************************************************************/
