/*******************************************************************************

    uBlock Origin Lite - a comprehensive, MV3-compliant content blocker
    Copyright (C) 2014-present Raymond Hill

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see {http://www.gnu.org/licenses/}.

    Home: https://github.com/gorhill/uBlock
*/

/* jshint esversion:11 */

'use strict';

// ruleset: tur-0

/******************************************************************************/

// Important!
// Isolate from global scope
(function uBOL_cssDeclarativeImport() {

/******************************************************************************/

const argsList = [["{\"selector\":\".container\",\"action\":[\"style\",\"margin-top: 0 !important;\"]}"],["{\"selector\":\"#player\",\"action\":[\"style\",\"display: block !important;\"]}"],["{\"selector\":\"#reki[style*=\\\"display\\\"]\",\"action\":[\"style\",\"display: block !important;\"]}","{\"selector\":\"header.container\",\"action\":[\"style\",\"margin-top: 20px !important;\"]}"],["{\"selector\":\".wrapper\",\"action\":[\"style\",\"margin-top: 0 !important;\"]}"],["{\"selector\":\"html > body\",\"action\":[\"style\",\"background-image: none !important;\"]}"],["{\"selector\":\"body > #wrap\",\"action\":[\"style\",\"margin-top: 0 !important;\"]}"],["{\"selector\":\"#iframe-video\",\"action\":[\"style\",\"display: block !important;\"]}"],["{\"selector\":\"#dt_contenedor\",\"action\":[\"style\",\"margin-top: 0 !important;\"]}"],["{\"selector\":\"#episode\",\"action\":[\"style\",\"height: unset !important; width: unset !important; position: unset !important; overflow: unset !important;\"]}"],["{\"selector\":\"body\",\"action\":[\"style\",\"background-image: none !important;\"]}"],["{\"selector\":\"#header\",\"action\":[\"style\",\"margin-top: 0 !important;\"]}"],["{\"selector\":\"#cn-content\",\"action\":[\"style\",\"display: block !important;\"]}"],["{\"selector\":\".container.main\",\"action\":[\"style\",\"margin-top: 0 !important;\"]}"],["{\"selector\":\"body > .orta:not([style*=\\\"margin-top:\\\"])\",\"action\":[\"style\",\"margin-top: 0 !important;\"]}","{\"selector\":\"div.duyuru-izle.duyuru-izle\",\"action\":[\"style\",\"margin-top: 20px !important;\"]}","{\"selector\":\"div.orta.izle[style^=\\\"margin-top:\\\"]:not(#style_important)\",\"action\":[\"style\",\"margin-top: 180px !important;\"]}","{\"selector\":\"div.orta[style^=\\\"margin-top:\\\"]:not(.izle)\",\"action\":[\"style\",\"margin-top: 131px !important;\"]}"],["{\"selector\":\"#kendisi\",\"action\":[\"style\",\"display: block !important;\"]}"],["{\"selector\":\"#reki\",\"action\":[\"style\",\"display: block !important;\"]}"],["{\"selector\":\".pageskin .oblong\",\"action\":[\"style\",\"margin-top: 0 !important;\"]}"],["{\"selector\":\"body\",\"action\":[\"style\",\"margin-top: 0 !important;\"]}"],["{\"selector\":\".main-content\",\"action\":[\"style\",\"margin-top: 0 !important;\"]}"],["{\"selector\":\".previd-link\",\"action\":[\"style\",\"visibility: hidden!important;\"]}"],["{\"selector\":\"#preroll_skip_btn\",\"action\":[\"style\",\"display: block !important;\"]}","{\"selector\":\".player\",\"action\":[\"style\",\"display: block !important;\"]}","{\"selector\":\"body > main#wrapper\",\"action\":[\"style\",\"margin-top: 0 !important;\"]}"],["{\"selector\":\"center > div > a[href][target=\\\"_blank\\\"]\",\"action\":[\"style\",\"position: absolute !important; left: -3000px !important;\"]}"],["{\"selector\":\"body\",\"action\":[\"style\",\"margin-top: 0 !important; background-image: none !important;\"]}"],["{\"selector\":\".video-banner\",\"action\":[\"style\",\"display: block !important;\"]}"],["{\"selector\":\".card-video\",\"action\":[\"style\",\"display: block !important;\"]}"],["{\"selector\":\".plyr\",\"action\":[\"style\",\"display: block !important;\"]}"],["{\"selector\":\"body\",\"action\":[\"style\",\"overflow: visible !important; padding-right: 0 !important;\"]}"],["{\"selector\":\"#header\",\"action\":[\"style\",\"height: 0px !important;\"]}"],["{\"selector\":\".topBanner + header\",\"action\":[\"style\",\"top: 0 !important;\"]}","{\"selector\":\".topBanner\",\"action\":[\"style\",\"top: -50px !important;\"]}","{\"selector\":\"body > div[class^=\\\"sfv_\\\"] > div[id]\",\"action\":[\"style\",\"top: 0 !important;\"]}"],["{\"selector\":\"body #oden.adsbygoogle-noablate\",\"action\":[\"style\",\"display: block !important;\"]}"],["{\"selector\":\"#header2\",\"action\":[\"style\",\"height: 100px !important;\"]}"],["{\"selector\":\".min-height-at-index\",\"action\":[\"style\",\"height: 144px!important;\"]}"],["{\"selector\":\"#wrap\",\"action\":[\"style\",\"margin-top: 0 !important;\"]}"],["{\"selector\":\"body.modal-open\",\"action\":[\"style\",\"overflow: visible!important; padding-right: 0!important;\"]}"],["{\"selector\":\"body.has-mtsnb[style^=\\\"padding-top:\\\"]\",\"action\":[\"style\",\"padding-top: 0!important;\"]}"],["{\"selector\":\".content-wrapper\",\"action\":[\"style\",\"filter: none!important;\"]}","{\"selector\":\"body\",\"action\":[\"style\",\"overflow: auto!important;\"]}"],["{\"selector\":\".icerik_reklam\",\"action\":[\"style\",\"position: absolute!important; left: -3000px!important;\"]}","{\"selector\":\".rek1\",\"action\":[\"style\",\"height: 1px!important;\"]}","{\"selector\":\".reklam_kontrol\",\"action\":[\"style\",\"height: 1px!important;\"]}"],["{\"selector\":\"#solust\",\"action\":[\"style\",\"position: static!important;\"]}"],["{\"selector\":\".page_container > .single\",\"action\":[\"style\",\"margin-top: 0 !important;\"]}","{\"selector\":\"body .fixed_header\",\"action\":[\"style\",\"top: 0 !important;\"]}","{\"selector\":\"body .page_container\",\"action\":[\"style\",\"margin-top: 80px !important;\"]}","{\"selector\":\"body > div.site-outer\",\"action\":[\"style\",\"margin-top: 0 !important;\"]}"],["{\"selector\":\"body\",\"action\":[\"style\",\"overflow: auto !important;\"]}"],["{\"selector\":\"body\",\"action\":[\"style\",\"overflow: auto !important; padding-right: 0 !important;\"]}"],["{\"selector\":\"#ikinci\",\"action\":[\"style\",\"display: block !important;\"]}"],["{\"selector\":\".sayfafull.uzat > .ie-navigasyon + .soltaraf\",\"action\":[\"style\",\"width:calc(100% - 290px)!important;\"]}","{\"selector\":\".sayfafull.uzat > .soltaraf\",\"action\":[\"style\",\"width:calc(100% - 253px)!important;\"]}","{\"selector\":\".soltaraf\",\"action\":[\"style\",\"width: calc(100%)!important;\"]}"],["{\"selector\":\"#videos\",\"action\":[\"style\",\"display: block!important;\"]}"],["{\"selector\":\"body div#player\",\"action\":[\"style\",\"display: block !important;\"]}"],["{\"selector\":\"body.modal-open\",\"action\":[\"style\",\"overflow: visible !important; padding-right: 0 !important;\"]}"],["{\"selector\":\".video-content > div.ads\",\"action\":[\"style\",\"height: 0 !important; visibility: hidden !important;\"]}"],["{\"selector\":\"body.pageskin\",\"action\":[\"style\",\"margin-top: 0 !important;\"]}"],["{\"selector\":\".tab-embed\",\"action\":[\"style\",\"display: block !important;\"]}"],["{\"selector\":\".embed-responsive\",\"action\":[\"style\",\"display: block !important;\"]}","{\"selector\":\"body\",\"action\":[\"style\",\"background-color: #0E0E0E !important;\"]}"],["{\"selector\":\"#episode\",\"action\":[\"style\",\"height: auto !important; width: auto !important; overflow: auto !important; position: unset !important;\"]}"],["{\"selector\":\"#konu\",\"action\":[\"style\",\"display: block !important;\"]}"],["{\"selector\":\"#head > .menu-bar.cloned\",\"action\":[\"style\",\"top: 0!important;\"]}"],["{\"selector\":\"#film\",\"action\":[\"style\",\"display: block !important;\"]}"],["{\"selector\":\".global-header\",\"action\":[\"style\",\"margin-bottom: 24px !important;\"]}"],["{\"selector\":\"#episode\",\"action\":[\"style\",\"height: unset !important; width: unset !important; position: unset !important;\"]}"],["{\"selector\":\"html.async-hide\",\"action\":[\"style\",\"opacity: 1 !important;\"]}"],["{\"selector\":\"body\",\"action\":[\"style\",\"overflow: visible!important;\"]}"],["{\"selector\":\"body\",\"action\":[\"style\",\"background-image: none!important;\"]}"],["{\"selector\":\".site-container\",\"action\":[\"style\",\"margin-top: 10px!important;\"]}"],["{\"selector\":\".video-content\",\"action\":[\"style\",\"display: block !important;\"]}"],["{\"selector\":\"#videos\",\"action\":[\"style\",\"display: block !important;\"]}"],["{\"selector\":\".reklam-alan-tam\",\"action\":[\"style\",\"position: absolute!important; left: -3000px!important;\"]}"],["{\"selector\":\"body\",\"action\":[\"style\",\"overflow: auto !important; position: static !important;\"]}","{\"selector\":\"html.fancybox-lock:has(> body) > body\",\"action\":[\"style\",\"overflow: visible!important;\"]}","{\"selector\":\"html.fancybox-lock:has(> body)\",\"action\":[\"style\",\"overflow: visible!important;\"]}"],["{\"selector\":\"body\",\"action\":[\"style\",\"background: none !important;\"]}"],["{\"selector\":\".adsbygoogle\",\"action\":[\"style\",\"position: absolute !important; left: -3000px !important;\"]}"],["{\"selector\":\".tab-embed\",\"action\":[\"style\",\"display: block!important;\"]}"],["{\"selector\":\"#main\",\"action\":[\"style\",\"margin-top: 0px !important;\"]}"],["{\"selector\":\".banner\",\"action\":[\"style\",\"visibility: hidden !important; height: 150px !important;\"]}"],["{\"selector\":\"#cn-content\",\"action\":[\"style\",\"display: block!important;\"]}"],["{\"selector\":\"#live-top-menu\",\"action\":[\"style\",\"height: auto !important;\"]}"],["{\"selector\":\"div[id=\\\"episode\\\"][style]\",\"action\":[\"style\",\"height: unset !important; width: unset !important; overflow: unset !important; position: unset !important;\"]}"],["{\"selector\":\"div > a[href][target=\\\"_blank\\\"][style*=\\\"display: flex !important;\\\"]\",\"action\":[\"style\",\"position: absolute !important; left: -3000px !important;\"]}"],["{\"selector\":\".modal-open\",\"action\":[\"style\",\"overflow: auto !important;\"]}"],["{\"selector\":\".adsbygoogle\",\"action\":[\"style\",\"position: absolute!important; left: -3000px!important;\"]}"],["{\"selector\":\".modal-open\",\"action\":[\"style\",\"overflow: visible !important;\"]}"],["{\"selector\":\"#site\",\"action\":[\"style\",\"margin-top: 0 !important;\"]}"],["{\"selector\":\".yildiz-pageskin #header\",\"action\":[\"style\",\"margin: 0 auto 0px auto !important;\"]}"],["{\"selector\":\"#roadblock\",\"action\":[\"style\",\"position: absolute !important; left: -3000px !important;\"]}"],["{\"selector\":\"ul.app-features\",\"action\":[\"style\",\"margin-top: 0!important;\"]}"],["{\"selector\":\".header[style^=\\\"margin-top:\\\"]\",\"action\":[\"style\",\"margin-top: 0 !important;\"]}"],["{\"selector\":\"body\",\"action\":[\"style\",\"background: #232930 !important;\"]}"],["{\"selector\":\"body\",\"action\":[\"style\",\"overflow: visible !important;\"]}"],["{\"selector\":\"body.no-scroll\",\"action\":[\"style\",\"overflow: auto !important;\"]}"],["{\"selector\":\"body > header\",\"action\":[\"style\",\"margin-bottom: 0 !important;\"]}"],["{\"selector\":\".embed-col.ikinci\",\"action\":[\"style\",\"display: block !important;\"]}","{\"selector\":\"body > .container\",\"action\":[\"style\",\"margin-top: 0 !important;\"]}"],["{\"selector\":\"#wt-masthead\",\"action\":[\"style\",\"height: 0px !important; min-height: 0px !important;\"]}","{\"selector\":\".wt-container[style*=\\\"padding-top: 0px;\\\"]\",\"action\":[\"style\",\"padding-top: 60px!important;\"]}","{\"selector\":\".wt-masthead\",\"action\":[\"style\",\"padding: 0 !important;\"]}"],["{\"selector\":\".layout\",\"action\":[\"style\",\"padding-top: 0 !important;\"]}"],["{\"selector\":\"body > #page\",\"action\":[\"style\",\"margin-top: 0 !important;\"]}"],["{\"selector\":\".adsbygoogle\",\"action\":[\"style\",\"height:1px!important;\"]}"],["{\"selector\":\"body #site\",\"action\":[\"style\",\"margin-top: 0px !important;\"]}"],["{\"selector\":\"#dinami\",\"action\":[\"style\",\"display: block !important;\"]}"],["{\"selector\":\".video\",\"action\":[\"style\",\"display: block !important;\"]}"],["{\"selector\":\"#kendisi\",\"action\":[\"style\",\"display: block!important;\"]}"],["{\"selector\":\"#menuBG.sabitle\",\"action\":[\"style\",\"top: 0!important;\"]}"],["{\"selector\":\".adsbygoogle\",\"action\":[\"style\",\"position: absolute!important; left: -10000px!important;\"]}"],["{\"selector\":\"#blogkafemnet-reklam\",\"action\":[\"style\",\"height: 1px!important;\"]}"],["{\"selector\":\".tepe-banner\",\"action\":[\"style\",\"margin-top: 0 !important;\"]}"],["{\"selector\":\".reklam\",\"action\":[\"style\",\"display: block!important; height: 1px!important;\"]}"],["{\"selector\":\"body > div[class=\\\"orta\\\"]\",\"action\":[\"style\",\"margin-top: -150px !important;\"]}"],["{\"selector\":\"#player-has-ads\",\"action\":[\"style\",\"display: block !important;\"]}"],["{\"selector\":\"body.modal-open\",\"action\":[\"style\",\"overflow: visible!important;\"]}"],["{\"selector\":\"body\",\"action\":[\"style\",\"background-image: none !important; background-color: #171717 !important;\"]}"],["{\"selector\":\"#detect.ad-placement\",\"action\":[\"style\",\"display: block !important;\"]}"],["{\"selector\":\".videoAdBlock > div.content\",\"action\":[\"style\",\"display: block !important;\"]}"],["{\"selector\":\".tbanner\",\"action\":[\"style\",\"visibility: hidden !important;\"]}"],["{\"selector\":\".pub_300x250.pub_300x250m.pub_728x90.text-ad.textAd.text_ad.text_ads.text-ads.text-ad-links\",\"action\":[\"style\",\"display:block!important;\"]}"],["{\"selector\":\"body > main\",\"action\":[\"style\",\"padding-left: unset !important;\"]}","{\"selector\":\"body\",\"action\":[\"style\",\"overflow: visible!important; padding-right: 0!important;\"]}"],["{\"selector\":\".samBackground[style]\",\"action\":[\"style\",\"background-image: none!important;\"]}","{\"selector\":\".td-background-link #td-outer-wrap\",\"action\":[\"style\",\"cursor: auto !important;\"]}","{\"selector\":\".x-root\",\"action\":[\"style\",\"background-image: none !important;\"]}","{\"selector\":\"body > #x-root\",\"action\":[\"style\",\"background-image: none!important;\"]}","{\"selector\":\"body.td-ad-background-link #td-outer-wrap\",\"action\":[\"style\",\"cursor: auto!important;\"]}","{\"selector\":\"body.td-ad-background-link\",\"action\":[\"style\",\"background-image: none!important;\"]}"],["{\"selector\":\"#video > div#videos\",\"action\":[\"style\",\"display: block !important;\"]}"],["{\"selector\":\".pageskin .rectangle\",\"action\":[\"style\",\"margin-top: 0 !important;\"]}"],["{\"selector\":\"#wrap\",\"action\":[\"style\",\"margin-top: 0px !important;\"]}","{\"selector\":\".pageskin header\",\"action\":[\"style\",\"margin-top: 0 !important;\"]}"],["{\"selector\":\".billBoardFrame\",\"action\":[\"style\",\"position: absolute !important; left: -3000px !important;\"]}"],["{\"selector\":\".adsmd\",\"action\":[\"style\",\"height: 1px!important;\"]}"],["{\"selector\":\".fancybox-lock body\",\"action\":[\"style\",\"overflow: auto !important;\"]}","{\"selector\":\".fancybox-lock\",\"action\":[\"style\",\"overflow: auto !important; margin-right: unset !important;\"]}"],["{\"selector\":\".with-popup\",\"action\":[\"style\",\"overflow: visible!important;\"]}","{\"selector\":\"body.with-bg\",\"action\":[\"style\",\"padding-top: 0!important;\"]}"],["{\"selector\":\"main.content-index\",\"action\":[\"style\",\"margin-top: 0px !important;\"]}"],["{\"selector\":\".in-view-ads\",\"action\":[\"style\",\"position: absolute!important; left: -3000px!important;\"]}"],["{\"selector\":\"div[class^=\\\"adv-\\\"]\",\"action\":[\"style\",\"height: 0 !important;\"]}"],["{\"selector\":\"#iki.oynama\",\"action\":[\"style\",\"display: block !important;\"]}"],["{\"selector\":\".td-pb-row > .tdc-column > .wpb_wrapper\",\"action\":[\"style\",\"min-height: 0 !important;\"]}"],["{\"selector\":\"header.advertControlArea\",\"action\":[\"style\",\"top: 0!important;\"]}"],["{\"selector\":\"#mvp-site-main\",\"action\":[\"style\",\"margin-top: 0 !important;\"]}"],["{\"selector\":\"#galleryContent\",\"action\":[\"style\",\"visibility: visible!important;\"]}"],["{\"selector\":\".top-banner-wrapper\",\"action\":[\"style\",\"padding: 1px!important; background-color: #007fc5!important;\"]}"],["{\"selector\":\".Banner\",\"action\":[\"style\",\"border: none !important;\"]}","{\"selector\":\"a[href$=\\\"#ReklamRezervasyon\\\"]\",\"action\":[\"style\",\"visibility:hidden !important;\"]}"],["{\"selector\":\"div[style*=\\\"min-width: 300px;\\\"][style*=\\\"min-height: 250px;\\\"][style*=\\\"display: flex!important;\\\"]\",\"action\":[\"style\",\"position: absolute !important; left: -3000px !important;\"]}"],["{\"selector\":\".jw-preview[style*=\\\"background-image: url\\\"]\",\"action\":[\"style\",\"background: none !important;\"]}"],["{\"selector\":\"html.uk-modal-page > body\",\"action\":[\"style\",\"overflow: auto !important;\"]}","{\"selector\":\"html.uk-modal-page\",\"action\":[\"style\",\"overflow: auto !important;\"]}"],["{\"selector\":\".player-poster\",\"action\":[\"style\",\"background-image: none !important;\"]}"],["{\"selector\":\".table-area\",\"action\":[\"style\",\"visibility: hidden !important;\"]}"]];

const hostnamesMap = new Map([["sexfilmleriizle.com",1],["elzemfilm.org",1],["filmizlehdfilm.com",[4,47]],["contentx.me",4],["fullhdfilmizlesenebox.org",4],["hdfilmizlesene.org",[4,110]],["turkcealtyazi.org",4],["pchocasi.com.tr",4],["diziwatch.net",5],["setfilmizleyin.com",7],["hdfilmizle.site",7],["selcuksportshd78.biz",9],["filmmodu10.com",[9,49]],["filmmodu11.com",[9,49]],["filmmodu12.com",[9,49]],["filmmodu13.com",[9,49]],["filmmodu14.com",[9,49]],["filmmodu15.com",[9,49]],["filmmodu16.com",[9,49]],["filmmodu17.com",[9,49]],["filmmodu18.com",[9,49]],["filmmodu19.com",[9,49]],["filmmodu20.com",[9,49]],["filmmodu9.com",[9,49]],["webteizle.info",[9,90]],["webteizle1.info",[9,90]],["webteizle10.info",[9,90]],["webteizle2.info",[9,90]],["webteizle3.info",[9,90]],["webteizle4.info",[9,90]],["webteizle5.info",[9,90]],["webteizle6.info",[9,90]],["webteizle7.info",[9,90]],["webteizle8.info",[9,90]],["webteizle9.info",[9,90]],["selcuksportshdamp5.xyz",9],["sinefy3.com",10],["burcufilm.com",11],["dizirella.com",11],["filmizlersin.com",11],["tekparthdfilmizle.com",11],["1080pizle.net",[11,64]],["izlehdfilm.net",[11,102]],["filmizle10.org",14],["filmizle11.org",14],["filmizle12.org",14],["filmizle13.org",14],["filmizle14.org",14],["filmizle15.org",14],["filmizle16.org",14],["filmizle17.org",14],["filmizle18.org",14],["filmizle19.org",14],["filmizle20.org",14],["filmizle21.org",14],["filmizle22.org",14],["filmizle23.org",14],["filmizle24.org",14],["filmizle25.org",14],["filmizle5.org",14],["filmizle6.org",14],["filmizle7.org",14],["filmizle8.org",14],["filmizle9.org",14],["hdfilmseyircisi.org",14],["fullhdfilmizle.vip",14],["filmindir.be",21],["fullfilmizle.cc",22],["dizipal1.cloud",[23,24]],["dizipal10.cloud",[23,24]],["dizipal11.cloud",[23,24]],["dizipal12.cloud",[23,24]],["dizipal132.cloud",[23,24]],["dizipal133.cloud",[23,24]],["dizipal134.cloud",[23,24]],["dizipal135.cloud",[23,24]],["dizipal14.cloud",[23,24]],["dizipal140.cloud",[23,24]],["dizipal2.cloud",[23,24]],["dizipal37.cloud",[23,24]],["dizipal39.cloud",[23,24]],["dizipal4.cloud",[23,24]],["dizipal43.cloud",[23,24]],["dizipal45.cloud",[23,24]],["dizipal47.cloud",[23,24]],["dizipal48.cloud",[23,24]],["dizipal5.cloud",[23,24]],["dizipal54.cloud",[23,24]],["dizipal58.cloud",[23,24]],["dizipal59.cloud",[23,24]],["dizipal60.cloud",[23,24]],["dizipal61.cloud",[23,24]],["dizipal67.cloud",[23,24]],["dizipal73.cloud",[23,24]],["dizipal74.cloud",[23,24]],["dizipal9.cloud",[23,24]],["dizipal739.com",23],["dizipal740.com",23],["dizipal840.com",23],["filmmodu.co",25],["sinemia.org",25],["61saat.com",26],["esgundem26.com",26],["ademyurt.com",27],["akakce.com",28],["akillikafa.com",29],["kazanimtestleri.com.tr",29],["altinpiyasa.com",30],["arabam.com",31],["asyadiziizle.com",32],["canlidizi6.org",32],["dizimom.tv",32],["aydinpost.com",33],["mygaziantep.com",33],["bilgenc.com",34],["boxofficeturkiye.com",35],["cadcamsektoru.com",36],["cazkolik.com",37],["coin-turk.com",38],["degisimmedya.com",39],["turkishairforce.org",39],["karadenizgazete.com.tr",39],["dizimax2.com",40],["besiktas.com.tr",40],["dizimodu.com",41],["neskici.com",41],["forum.donanimhaber.com",42],["eroticpub.com",43],["filmdizievi1.com",43],["erotikfilmtube.com",44],["eskisehirhaber.com",45],["haberlisin.com",45],["halk54.com",45],["karaman24.com",45],["eskisehirekspres.net",45],["filmerotikizle.com",46],["filmkuzusu1.com",48],["safirfilmizle1.com",48],["sinefilmizlesen.com",[48,77]],["filmmoduu.com",50],["hdfilmizle.org",50],["filmsezonu.com",51],["finansgundem.com",52],["fullhdfilmizleabi.com",53],["hdfilmcanavari.org",53],["gazetevatan.com",54],["goodfilmizle.com",55],["gratis.com",56],["haberintakasi.com",57],["hdfilmifullizle.com",[58,59]],["technopat.net",[58,108]],["hdfreeizle.com",60],["hdmixfilim.com",60],["superfilmgeldi.net",60],["hdizlefilmleri.com",61],["sinekolik.com",61],["iddaaorantahmin.com",62],["itemci.com",[63,64]],["kizlarsoruyor.com",64],["jurnalci.com",65],["kelebekfilmizlee.com",66],["koinfinans.com",67],["kriptoarena.com",68],["kultfilmler.com",69],["mackolik.com",70],["moonfilmizle.com",71],["mp3indirhane.com",72],["ceptenmuzikindir.me",72],["nesine.com",73],["piyasaanketi.com",74],["teknoblog.com",74],["ucuzaucak.net",74],["radyofenomen.com",75],["sezonlukdizi6.com",76],["sinemalar.com",78],["tamindir.com",79],["tarsusakdeniz.com",80],["tipobettv204.com",81],["tipobettv205.com",81],["tipobettv206.com",81],["tipobettv207.com",81],["tipobettv208.com",81],["tipobettv209.com",81],["tipobettv210.com",81],["trabzonhaber24.com",82],["forum.turkmmo.com",82],["kayseristarhaber.com.tr",82],["turkce-brosurler.com",83],["ugurfilm10.com",84],["ugurfilm11.com",84],["ugurfilm12.com",84],["ugurfilm13.com",84],["ugurfilm14.com",84],["ugurfilm15.com",84],["ugurfilm16.com",84],["ugurfilm7.com",84],["ugurfilm8.com",84],["ugurfilm9.com",84],["webdramaturkey.com",85],["webtekno.com",86],["yenisafak.com",87],["sinema.cx",88],["altin.in",89],["tr.link",91],["fullhd720pizle.live",92],["hdfilmcehennem.live",93],["61medya.net",94],["birgun.net",95],["blogkafem.net",96],["evrensel.net",97],["fontyukle.net",98],["fullfilmizlesene.net",99],["fullhddizifilmizle2.net",100],["fullhddizifilmizle3.net",100],["fullhddizifilmizle4.net",100],["fullhddizifilmizle5.net",100],["haber61.net",101],["hdfilmcehennemi.so",102],["mangaship.net",103],["mobeseizle.net",104],["motosiklet.net",105],["osxinfo.net",106],["r10.net",107],["filmgo.org",109],["fullhdfilm.pro",111],["apara.com.tr",112],["baho.com.tr",113],["cepteteb.com.tr",114],["cumhuriyet.com.tr",115],["elle.com.tr",116],["fanatik.com.tr",117],["muud.com.tr",118],["oyunu.com.tr",119],["popsci.com.tr",120],["sabah.com.tr",121],["sanayigazetesi.com.tr",122],["sonsaat.com.tr",123],["t24.com.tr",124],["tercihrobotu.com.tr",125],["tgrthaber.com.tr",126],["dizigom1.tv",127],["ssport.tv",128],["trgoals1000.xyz",129],["trgoals1001.xyz",129],["trgoals1002.xyz",129],["trgoals1003.xyz",129],["trgoals1004.xyz",129],["trgoals1005.xyz",129],["trgoals1006.xyz",129],["trgoals1007.xyz",129],["trgoals1008.xyz",129],["trgoals1009.xyz",129],["trgoals1010.xyz",129],["trgoals967.xyz",129],["trgoals968.xyz",129],["trgoals969.xyz",129],["trgoals970.xyz",129],["trgoals971.xyz",129],["trgoals972.xyz",129],["trgoals973.xyz",129],["trgoals974.xyz",129],["trgoals975.xyz",129],["trgoals976.xyz",129],["trgoals977.xyz",129],["trgoals978.xyz",129],["trgoals979.xyz",129],["trgoals980.xyz",129],["trgoals981.xyz",129],["trgoals982.xyz",129],["trgoals983.xyz",129],["trgoals984.xyz",129],["trgoals985.xyz",129],["trgoals986.xyz",129],["trgoals987.xyz",129],["trgoals988.xyz",129],["trgoals989.xyz",129],["trgoals990.xyz",129],["trgoals991.xyz",129],["trgoals992.xyz",129],["trgoals993.xyz",129],["trgoals994.xyz",129],["trgoals995.xyz",129],["trgoals996.xyz",129],["trgoals997.xyz",129],["trgoals998.xyz",129],["trgoals999.xyz",129],["xyzsports173.xyz",130],["xyzsports174.xyz",130],["xyzsports175.xyz",130],["xyzsports176.xyz",130],["xyzsports177.xyz",130],["xyzsports178.xyz",130],["xyzsports179.xyz",130],["xyzsports180.xyz",130],["xyzsports181.xyz",130],["xyzsports182.xyz",130],["xyzsports183.xyz",130],["xyzsports184.xyz",130],["xyzsports185.xyz",130],["xyzsports186.xyz",130],["xyzsports187.xyz",130],["xyzsports188.xyz",130],["xyzsports189.xyz",130],["xyzsports190.xyz",130],["xyzsports191.xyz",130],["xyzsports192.xyz",130],["xyzsports193.xyz",130],["xyzsports194.xyz",130],["xyzsports195.xyz",130],["xyzsports196.xyz",130],["xyzsports197.xyz",130],["xyzsports198.xyz",130],["xyzsports199.xyz",130],["xyzsports200.xyz",130]]);

const entitiesMap = new Map([["4kfilmizlesene",0],["dizicaps",1],["dizifilmbox",2],["dizikorea",3],["dizitime",[3,6]],["filmmakinesi",[3,9]],["dizilab8",4],["dizilab9",4],["filmizletv",4],["fullhdfilmizle",[4,12]],["fullhdfilmizletv",4],["hdfilmcehennemi",[4,10,16]],["jetfilmizle",[4,18]],["siyahfilmizle",4],["dizimom",5],["filmizlesene",[5,8]],["diziyo",7],["filmzal",10],["fullfilmizle",11],["fulltimehdfilmizle",11],["fullhdfilmizlesene",13],["fullhdfilmmodu2",14],["fullhdizle",15],["hdfilmizleamk",17],["tranimeizle",19],["yabancidizi",20]]);

const exceptionsMap = new Map(undefined);

self.declarativeImports = self.declarativeImports || [];
self.declarativeImports.push({ argsList, hostnamesMap, entitiesMap, exceptionsMap });

/******************************************************************************/

})();

/******************************************************************************/
