/*******************************************************************************

    uBlock Origin Lite - a comprehensive, MV3-compliant content blocker
    Copyright (C) 2014-present Raymond Hill

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see {http://www.gnu.org/licenses/}.

    Home: https://github.com/gorhill/uBlock
*/

/* jshint esversion:11 */

'use strict';

// ruleset: annoyances-overlays

/******************************************************************************/

// Important!
// Isolate from global scope
(function uBOL_cssProceduralImport() {

/******************************************************************************/

const argsList = [["{\"selector\":\"p > b\",\"tasks\":[[\"xpath\",\"//*[contains(text(),\\\"AdBlock\\\")]\"]]}"],["{\"selector\":\"style\",\"action\":[\"remove\",\"\"],\"tasks\":[[\"has-text\",\"@media print\"]]}"],["{\"selector\":\"script\",\"tasks\":[[\"has-text\",\"devtoolsDetector\"]]}"],["{\"selector\":\"#root > div > div\",\"tasks\":[[\"has-text\",\"Get one more story in your member\"]]}","{\"selector\":\".overlay\",\"tasks\":[[\"not\",{\"selector\":\"\",\"tasks\":[[\"has-text\",\"Welcome back\"]]}],[\"not\",{\"selector\":\"\",\"tasks\":[[\"has-text\",\"write a response\"]]}],[\"not\",{\"selector\":\"\",\"tasks\":[[\"has-text\",\"Publish now\"]]}]]}"],["{\"selector\":\"style\",\"action\":[\"remove\",\"\"],\"tasks\":[[\"has-text\",\"user-select:\"]]}"],["{\"selector\":\"[id=\\\"toggle_notification_notification-ad-blocker\\\"]\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\"div.wp-block-cover\",\"tasks\":[[\"has-text\",\"Be the first to know\"]]}"],["{\"selector\":\".pull-right.inline-gallery-container\",\"tasks\":[[\"has-text\",\"Post this\"]]}"],["{\"selector\":\"script\",\"tasks\":[[\"has-text\",\"document.oncontextmenu\"]]}"],["{\"selector\":\".adsbygoogle\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\".ct_warn\",\"tasks\":[[\"has-text\",\"adblock\"]]}"],["{\"selector\":\"div[style] > div > .userBanner--red\",\"tasks\":[[\"upward\",2]]}"],["{\"selector\":\".et_pb_row_1_tb_body\",\"tasks\":[[\"has-text\",\"Sign up for our weekly newsletter\"]]}","{\"selector\":\".et_pb_section\",\"tasks\":[[\"has-text\",\"Sign up for our weekly newsletter\"]]}"],["{\"selector\":\".border-gray-200\",\"tasks\":[[\"has-text\",\"Get the news\"]]}","{\"selector\":\".border-secondary-900\",\"tasks\":[[\"has-text\",\"Get the news\"]]}"],["{\"selector\":\"div[class^=\\\"-_\\\"] > form\",\"tasks\":[[\"has-text\",\"newsletters\"]]}"],["{\"selector\":\"style\",\"action\":[\"remove\",\"\"],\"tasks\":[[\"has-text\",\"user-select\"]]}"],["{\"selector\":\"button[type=\\\"submit\\\"]\",\"action\":[\"remove-attr\",\"disabled\"]}"],["{\"selector\":\".js-dismissable-hero\",\"tasks\":[[\"has-text\",\"Sign up\"]]}"],["{\"selector\":\".bg-gray-50\",\"tasks\":[[\"has-text\",\"Fake news\"]]}","{\"selector\":\".hidden\",\"tasks\":[[\"has-text\",\"Fake news\"]]}"],["{\"selector\":\".optin\",\"tasks\":[[\"has-text\",\"Sign Up\"]]}"],["{\"selector\":\".bg-gray-100\",\"tasks\":[[\"has-text\",\"newsletter\"]]}"],["{\"selector\":\"script\",\"tasks\":[[\"has-text\",\"document.onmousedown\"]]}"],["{\"selector\":\"script\",\"tasks\":[[\"has-text\",\"debugger\"]]}"],["{\"selector\":\"div[oncopy]\",\"action\":[\"remove-attr\",\"/oncopy|oncut|onpaste/\"]}"],["{\"selector\":\"script\",\"tasks\":[[\"has-text\",\"/addLinkToCopy/i\"]]}"],["{\"selector\":\".sidebar-form\",\"tasks\":[[\"has-text\",\"Sign Up For Our Newsletter\"]]}"],["{\"selector\":\".callout\",\"tasks\":[[\"has-text\",\"inbox\"]]}"],["{\"selector\":\".col1span3\",\"tasks\":[[\"has-text\",\"Newsletters\"]]}"],["{\"selector\":\".p-4.bg-\\\\[\\\\#F5F5F5\\\\]\",\"tasks\":[[\"has-text\",\"Subscribe to our newsletter\"]]}"],["{\"selector\":\".MuiBox-root\",\"tasks\":[[\"has-text\",\"Subscribe to our Newsletter\"]]}"],["{\"selector\":\".has-primary-dark-background-color\",\"tasks\":[[\"has-text\",\"Sign up\"]]}"],["{\"selector\":\".bg-purple-50\",\"tasks\":[[\"has-text\",\"Fan of great business\"]]}","{\"selector\":\".md\\\\:px-2.py-10\",\"tasks\":[[\"has-text\",\"Subscribe to the newsletter\"]]}"],["{\"selector\":\"strong > .link--button\",\"tasks\":[[\"has-text\",\"newsletter\"]]}"],["{\"selector\":\".bg-primary-dark\",\"tasks\":[[\"has-text\",\"newsletter\"]]}"],["{\"selector\":\"body[class^=\\\"scroll-block--is-blocked\\\"]\",\"action\":[\"remove-class\",\"/scroll-block--is-blocked/\"]}"],["{\"selector\":\".px20.pb32\",\"tasks\":[[\"has-text\",\"Sign up for\"]]}"],["{\"selector\":\".section > .wrapper\",\"tasks\":[[\"has-text\",\"Newsletters\"]]}"],["{\"selector\":\".article-content-wrapper > p\",\"tasks\":[[\"has-text\",\"into your inbox\"]]}","{\"selector\":\"strong > em\",\"tasks\":[[\"has-text\",\"Sign up\"]]}"],["{\"selector\":\"#home-section3\",\"tasks\":[[\"has-text\",\"Newsletter\"]]}"],["{\"selector\":\"#modal_login\",\"tasks\":[[\"upward\",2]]}"],["{\"selector\":\"\",\"tasks\":[[\"xpath\",\"//div[contains(text(),\\\"Adblock\\\")]/..\"]]}"],["{\"selector\":\".bottom-0.fixed\",\"tasks\":[[\"has-text\",\"weekly newsletters\"]]}","{\"selector\":\".lg\\\\:p-\\\\[16px\\\\]\",\"tasks\":[[\"has-text\",\"newsletters\"]]}"],["{\"selector\":\"h2\",\"tasks\":[[\"has-text\",\"Using an ad blocker?\"],[\"upward\",3]]}"],["{\"selector\":\"style\",\"action\":[\"remove\",\"\"],\"tasks\":[[\"has-text\",\"/-moz-user-select:none|@media print/\"]]}"],["{\"selector\":\".ReactModalPortal\",\"tasks\":[[\"has-text\",\"mobile\"]]}"],["{\"selector\":\".p-6.justify-center\",\"tasks\":[[\"has-text\",\"Daily newsletter\"]]}"],["{\"selector\":\".order-lg-2\",\"tasks\":[[\"has-text\",\"Sign up to our newsletter\"]]}","{\"selector\":\".sidebar-sticky\",\"tasks\":[[\"has-text\",\"newsletter\"]]}"],["{\"selector\":\".forbidden_select\",\"action\":[\"remove-class\",\"forbidden_select\"]}"],["{\"selector\":\".comp > strong\",\"tasks\":[[\"has-text\",\"newsletter\"]]}"],["{\"selector\":\".swal2-shown\",\"action\":[\"remove-class\",\"swal2-shown\"]}"],["{\"selector\":\".fbUserStory\",\"tasks\":[[\"has-text\",\"Popular Across Facebook\"]]}","{\"selector\":\".userContentWrapper\",\"tasks\":[[\"has-text\",\"Popular Across Facebook\"]]}"],["{\"selector\":\"style\",\"action\":[\"remove\",\"\"],\"tasks\":[[\"has-text\",\"-moz-none\"]]}"],["{\"selector\":\".pb-1.gap-4\",\"tasks\":[[\"has-text\",\"Sign up for\"]]}","{\"selector\":\".pb-6\",\"tasks\":[[\"has-text\",\"Newsletter\"]]}"],["{\"selector\":\"[oncontextmenu=\\\"return false;\\\"]\",\"action\":[\"remove-attr\",\"oncontextmenu\"]}"],["{\"selector\":\".td-block-title.block-title\",\"tasks\":[[\"has-text\",\"NEWSLETTER\"]]}"],["{\"selector\":\".moola-search-view\",\"tasks\":[[\"has-text\",\"hide these ads\"]]}"],["{\"selector\":\".bg-fok-gray-500\",\"tasks\":[[\"has-text\",\"Join our mailing list\"]]}"],["{\"selector\":\".has-senary-background-color\",\"tasks\":[[\"has-text\",\"Email\"]]}","{\"selector\":\".has-tertiary-background-color\",\"tasks\":[[\"has-text\",\"Week\"]]}"],["{\"selector\":\"\",\"tasks\":[[\"xpath\",\"//*[contains(text(),\\\"blocking software\\\")]/../../..\"]]}","{\"selector\":\".advanced.embed-media\",\"tasks\":[[\"has-text\",\"Get a daily look\"]]}"],["{\"selector\":\".bg-gray-100\",\"tasks\":[[\"has-text\",\"Sign up\"]]}"],["{\"selector\":\"script[id=\\\"jquery-core-js-after\\\"]\",\"tasks\":[[\"has-text\",\"e.preventDefault();\"]]}"],["{\"selector\":\".w-full\",\"tasks\":[[\"has-text\",\"Mailing\"]]}"],["{\"selector\":\".content-panel-container\",\"tasks\":[[\"has-text\",\"Get recipes\"]]}"],["{\"selector\":\"h3.section_name\",\"tasks\":[[\"has-text\",\"Newsletter\"]]}"],["{\"selector\":\".wp-block-group-is-layout-flow\",\"tasks\":[[\"has-text\",\"Subscribe\"]]}"],["{\"selector\":\"html.no-scroll\",\"action\":[\"remove-class\",\"no-scroll\"]}"],["{\"selector\":\".d-lg-block.sp-module\",\"tasks\":[[\"has-text\",\"newsletter\"]]}"],["{\"selector\":\".adsbygoogle\",\"action\":[\"remove\",\"\"],\"tasks\":[[\"upward\",1]]}","{\"selector\":\"body > div[id]\",\"action\":[\"style\",\"visibility: hidden !important\"],\"tasks\":[[\"matches-css\",{\"name\":\"position\",\"value\":\"^fixed$\"}]]}"],["{\"selector\":\".wp-block-genesis-blocks-gb-columns\",\"tasks\":[[\"has-text\",\"Subscribe by Email\"]]}","{\"selector\":\".wp-block-genesis-blocks-gb-container\",\"tasks\":[[\"has-text\",\"Free Email Guide\"]]}"],["{\"selector\":\".t-bg-surface-zero.t-p-6\",\"tasks\":[[\"has-text\",\"Newsletter\"]]}"],["{\"selector\":\"body\",\"action\":[\"remove-attr\",\"contextmenu\"]}"],["{\"selector\":\".pb-6.border-b\",\"tasks\":[[\"has-text\",\"Signup\"]]}"],["{\"selector\":\"script\",\"tasks\":[[\"has-text\",\"stopRefreshSite\"]]}"],["{\"selector\":\"p > em\",\"tasks\":[[\"has-text\",\"Sign up for\"]]}"],["{\"selector\":\"div.confuse\",\"action\":[\"remove\",\"\"]}"],["{\"selector\":\".p-8.bg-dynamic-primary\",\"tasks\":[[\"has-text\",\"straight to your inbox\"]]}"],["{\"selector\":\"style\",\"tasks\":[[\"has-text\",\"user-select: none;\"]]}"],["{\"selector\":\".wp-block-group__inner-container\",\"tasks\":[[\"has-text\",\"Discover more\"]]}"],["{\"selector\":\".shadow-card.p-8\",\"tasks\":[[\"has-text\",\"Laravel Newsletter\"]]}"],["{\"selector\":\"style\",\"action\":[\"remove\",\"\"],\"tasks\":[[\"has-text\",\"unselectable\"]]}"],["{\"selector\":\".wp-block-group-is-layout-flow.has-background.has-base-background-color\",\"tasks\":[[\"has-text\",\"Email Me This For Later\"]]}"],["{\"selector\":\".pt-\\\\[60px\\\\]\",\"tasks\":[[\"has-text\",\"newsletter\"]]}"],["{\"selector\":\"[data-pw-desk]\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\".has-border-color.wp-block-columns\",\"tasks\":[[\"has-text\",\"NEWSLETTER\"]]}"],["{\"selector\":\"#MainModule + div[class] > div[style^=\\\"width\\\"] > div > i[data-icon-name=\\\"OutlookLogo\\\"]\",\"tasks\":[[\"upward\",3]]}"],["{\"selector\":\"style\",\"action\":[\"remove\",\"\"],\"tasks\":[[\"has-text\",\"::selection\"]]}"],["{\"selector\":\".fxsEzN\",\"tasks\":[[\"has-text\",\"Sign up to our newsletter\"]]}"],["{\"selector\":\"section.sidebar-section\",\"tasks\":[[\"has-text\",\"email\"]]}"],["{\"selector\":\".under-map-wrapper\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\".align-items-center.py-2\",\"tasks\":[[\"has-text\",\"Sign Up\"]]}"],["{\"selector\":\".m-detail--body > p\",\"tasks\":[[\"has-text\",\"Sign up for the\"]]}"],["{\"selector\":\"body[oncontextmenu=\\\"return!1\\\"]\",\"action\":[\"remove-attr\",\"oncontextmenu\"]}"],["{\"selector\":\"style\",\"action\":[\"remove\",\"\"],\"tasks\":[[\"has-text\",\"/media print|user-select:/\"]]}"],["{\"selector\":\".sidebar-item-container\",\"tasks\":[[\"has-text\",\"Email me\"]]}"],["{\"selector\":\".mobile-only-on-col-ab\",\"tasks\":[[\"has-text\",\"Subscribe\"]]}"],["{\"selector\":\".bg-gray-50\",\"tasks\":[[\"has-text\",\"Want to stay informed\"]]}"],["{\"selector\":\".border-brand-pink\",\"tasks\":[[\"has-text\",\"inbox\"]]}"],["{\"selector\":\"div[class=\\\"container_box content_box\\\"] > div:only-child > div:last-child > div:last-child > ins.adsbygoogle\",\"tasks\":[[\"upward\",4]]}","{\"selector\":\"div[class=\\\"container_box content_box\\\"] > div[id][class] > div:last-child > div:last-child > ins.adsbygoogle\",\"tasks\":[[\"upward\",3]]}","{\"selector\":\"div[id][class][style^=\\\"position:\\\"] > div:last-child > div:last-child > ins.adsbygoogle\",\"tasks\":[[\"upward\",3]]}"],["{\"selector\":\".md\\\\:decorative-horizontal-lines\",\"tasks\":[[\"has-text\",\"subscribe\"]]}"],["{\"selector\":\"body\",\"action\":[\"remove-attr\",\"/oncopy|oncut|onpaste/\"]}"],["{\"selector\":\"strong\",\"tasks\":[[\"has-text\",\"daily newsletter\"]]}"],["{\"selector\":\".confirm\",\"tasks\":[[\"has-text\",\"AdBlocker\"]]}"],["{\"selector\":\"#custom_html-12\",\"tasks\":[[\"has-text\",\"newsletters\"]]}"],["{\"selector\":\".has-border-color\",\"tasks\":[[\"has-text\",\"Discover more\"]]}"],["{\"selector\":\".p1\",\"tasks\":[[\"has-text\",\"newsletter\"]]}"],["{\"selector\":\".widget_text\",\"tasks\":[[\"has-text\",\"newsletter\"]]}"],["{\"selector\":\"a:has(shreddit-player)\",\"action\":[\"remove-attr\",\"href\"]}","{\"selector\":\"shreddit-player\",\"action\":[\"remove-attr\",\"autoplay\"]}"],["{\"selector\":\".has-profile.post:first-child\",\"tasks\":[[\"has-text\",\"/adblock/i\"]]}"],["{\"selector\":\".border.rounded.p-2\",\"tasks\":[[\"has-text\",\"news letter\"]]}"],["{\"selector\":\"form[id=\\\"tfnewsearch\\\"]\",\"action\":[\"remove-attr\",\"onsubmit\"]}"],["{\"selector\":\"[style=\\\"text-align:center\\\"]\",\"tasks\":[[\"has-text\",\"newsletter\"]]}"],["{\"selector\":\".bg-light\",\"tasks\":[[\"has-text\",\"newsletter\"]]}"],["{\"selector\":\"script\",\"tasks\":[[\"has-text\",\"contextmenu\"]]}"],["{\"selector\":\"[oncopy=\\\"return false\\\"]\",\"action\":[\"remove-attr\",\"oncopy\"]}"],["{\"selector\":\".wp-block-group__inner-container\",\"tasks\":[[\"has-text\",\"Discover\"]]}"],["{\"selector\":\"script\",\"tasks\":[[\"has-text\",\"copyprotect\"]]}"],["{\"selector\":\"[data-text-as-pseudo-element*=\\\" push \\\"]\",\"tasks\":[[\"upward\",\"[role]\"],[\"upward\",\"[role]\"]]}"],["{\"selector\":\"style\",\"action\":[\"remove\",\"\"],\"tasks\":[[\"has-text\",\":not(input):not(textarea)\"]]}"],["{\"selector\":\".ReactModal__Overlay--after-open\",\"tasks\":[[\"has-text\",\"/Premium|Try 7 days/\"]]}","{\"selector\":\".ReactModal__Overlay--after-open:has(iframe[srcdoc], img)\",\"tasks\":[[\"has-text\",\"signing up\"]]}","{\"selector\":\"main > div[class*=\\\"-\\\"] > div[class^=\\\"_\\\"] > div[class^=\\\"_\\\"] > div[class]\",\"tasks\":[[\"has\",{\"selector\":\"> div[class^=\\\"_\\\"]\",\"tasks\":[[\"has-text\",\"Do your part to support us\"]]}]]}"],["{\"selector\":\"body\",\"action\":[\"remove-attr\",\"/onselectstart|oncopy|oncontextmenu/\"]}"],["{\"selector\":\".wp-block-quote\",\"tasks\":[[\"has-text\",\"inbox daily\"]]}"],["{\"selector\":\"*\",\"action\":[\"remove-attr\",\"oncontextmenu\"]}"],["{\"selector\":\"script\",\"tasks\":[[\"has-text\",\"innerText\"]]}"],["{\"selector\":\".LostInventoryMessage_root__YllYq\",\"tasks\":[[\"has-text\",\"newsletter\"]]}"],["{\"selector\":\".has-secondary-background-color\",\"tasks\":[[\"has-text\",\"Subscribe\"]]}","{\"selector\":\".wp-block-group\",\"tasks\":[[\"has-text\",\"Subscribe to our Newsletter\"]]}"],["{\"selector\":\"[data-testid=\\\"contributions-liveblog-epic\\\"]\",\"tasks\":[[\"has-text\",\"daily newsletter\"]]}"],["{\"selector\":\"script\",\"tasks\":[[\"has-text\",\"preventDefault\"]]}"],["{\"selector\":\".bg-soft-teal\",\"tasks\":[[\"has-text\",\"Subscribe\"]]}"],["{\"selector\":\".rounded-3.px-5\",\"tasks\":[[\"has-text\",\"Newsletter\"]]}"],["{\"selector\":\".dark-theme-dialog__dialogBody___106Di\",\"tasks\":[[\"upward\",4]]}"],["{\"selector\":\"div[tabindex=\\\"0\\\"]\",\"tasks\":[[\"matches-css\",{\"name\":\"position\",\"value\":\"^fixed$\"}],[\"spath\",\":has([href=\\\"/signup\\\"])\"]]}"],["{\"selector\":\".rounded-md.md\\\\:p-8.p-5.shadow-light\",\"tasks\":[[\"has-text\",\"Sign up\"]]}"],["{\"selector\":\".bg-gray-600\",\"tasks\":[[\"has-text\",\"Read the latest business news\"]]}"],["{\"selector\":\".duet--article--highlight\",\"tasks\":[[\"has-text\",\"Sign up here\"]]}"],["{\"selector\":\".no-select\",\"action\":[\"remove-class\",\"no-select\"]}"],["{\"selector\":\".has-medium-font-size\",\"tasks\":[[\"has-text\",\"newsletter\"]]}"],["{\"selector\":\".has-background\",\"tasks\":[[\"has-text\",\"Never miss a post\"]]}"],["{\"selector\":\".mt-\\\\[2rem\\\\]\",\"tasks\":[[\"has-text\",\"newsletter\"]]}"],["{\"selector\":\"section\",\"tasks\":[[\"has-text\",\"Winter-Update\"],[\"upward\",1]]}"],["{\"selector\":\".promo-card-primary\",\"tasks\":[[\"has-text\",\"Check your inbox\"]]}"],["{\"selector\":\".textwidget > .textwidget\",\"tasks\":[[\"has-text\",\"Subscribe\"]]}"],["{\"selector\":\"script\",\"tasks\":[[\"has-text\",\"oncontextmenu\"]]}"],["{\"selector\":\"[href=\\\"/about#support\\\"]\",\"tasks\":[[\"upward\",2]]}"],["{\"selector\":\"script\",\"tasks\":[[\"has-text\",\"DisableDevtool\"]]}"],["{\"selector\":\".loading-text\",\"action\":[\"remove-class\",\"loading-text\"]}"],["{\"selector\":\".bg-left.bg-cover\",\"tasks\":[[\"has-text\",\"Subscribe\"]]}"],["{\"selector\":\".v-card.v-card--flat\",\"tasks\":[[\"has-text\",\"Sign up to receive\"]]}"],["{\"selector\":\".mx-auto.container\",\"tasks\":[[\"has-text\",\"NEWSLETTER\"]]}"],["{\"selector\":\"body\",\"action\":[\"remove-attr\",\"oncontextmenu\"]}"],["{\"selector\":\"body > div:nth-of-type(1) > div\",\"tasks\":[[\"has-text\",\"adblocker\"]]}"],["{\"selector\":\".around-desktop-ad\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\"script\",\"tasks\":[[\"has-text\",\"window.carbonLoaded\"]]}"],["{\"selector\":\".adbanner\",\"action\":[\"remove\",\"\"]}"],["{\"selector\":\"#side > ins.adsbygoogle\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\"script\",\"tasks\":[[\"has-text\",\"document.onkeydown\"]]}"],["{\"selector\":\".modal-content\",\"tasks\":[[\"has\",{\"selector\":\".text > b\",\"tasks\":[[\"has-text\",\"Privacy Policy\"]]}]]}"],["{\"selector\":\"script\",\"tasks\":[[\"has-text\",\"/oncontextmenu|devtools|stateObject|debugger/\"]]}"],["{\"selector\":\"script\",\"tasks\":[[\"has-text\",\"/contextmenu|devtool/\"]]}"],["{\"selector\":\".elementor-top-column h6\",\"tasks\":[[\"has-text\",\"advertisement\"],[\"upward\",\".elementor-top-column\"]]}"],["{\"selector\":\".notificationsContainer\",\"tasks\":[[\"has-text\",\"whitelisten of beleef Tweakers\"]]}"],["{\"selector\":\"\",\"tasks\":[[\"xpath\",\"//*[contains(text(),\\\"AdB\\\")]\"]]}"],["{\"selector\":\"form\",\"tasks\":[[\"has-text\",\"Subscribe and thrive\"]]}","{\"selector\":\"form\",\"tasks\":[[\"has-text\",\"Your inbox is ready\"]]}"],["{\"selector\":\"style\",\"action\":[\"remove\",\"\"],\"tasks\":[[\"has-text\",\"/user-select|::selection/\"]]}"],["{\"selector\":\".text_multiline\",\"tasks\":[[\"has-text\",\"newsletter\"]]}"],["{\"selector\":\".w-embed\",\"tasks\":[[\"has-text\",\"Sign up now\"]]}"],["{\"selector\":\".has-background\",\"tasks\":[[\"has-text\",\"/newsletter|inbox/\"]]}"],["{\"selector\":\".restricted-body.html-content\",\"tasks\":[[\"has-text\",\"Email us\"]]}","{\"selector\":\".restricted-body.html-content\",\"tasks\":[[\"has-text\",\"your inbox\"]]}"],["{\"selector\":\".recommendationSection\",\"tasks\":[[\"has-text\",\"Newsletter\"]]}"],["{\"selector\":\".row > .entry-content > p\",\"tasks\":[[\"has-text\",\"daily newsletter\"]]}"],["{\"selector\":\".elementor-button-link\",\"tasks\":[[\"has-text\",\"Sign Up\"]]}"],["{\"selector\":\".has-background.has-dark-gray-background-color\",\"tasks\":[[\"has-text\",\"Sign up\"]]}"],["{\"selector\":\"p\",\"tasks\":[[\"has-text\",\"Adblock\"]]}"],["{\"selector\":\".hide.post__sidebar\",\"tasks\":[[\"has-text\",\"Share this article\"]]}"],["{\"selector\":\".elementor-section\",\"tasks\":[[\"has-text\",\"Subscribe for\"]]}","{\"selector\":\".elementor-widget-container\",\"tasks\":[[\"has-text\",\"tired of censorship\"]]}"],["{\"selector\":\".wp-block-pullquote\",\"tasks\":[[\"has-text\",\"Sign up for\"]]}"],["{\"selector\":\".wp-block-column > .is-layout-flow.wp-block-group\",\"tasks\":[[\"has-text\",\"Subscribe\"]]}"],["{\"selector\":\"\",\"tasks\":[[\"xpath\",\"//*[contains(text(),\\\"Adblock\\\")]\"]]}"],["{\"selector\":\"p.t-links-underlinedy\",\"tasks\":[[\"has-text\",\"Sign up for The Brief\"]]}"],["{\"selector\":\".bg-cover\",\"tasks\":[[\"has-text\",\"Sign up\"]]}","{\"selector\":\".bg-dark-brown\",\"tasks\":[[\"has-text\",\"Sign up\"]]}"],["{\"selector\":\"script\",\"tasks\":[[\"has-text\",\"checkAdblockBait\"]]}"],["{\"selector\":\".border-gray-175\",\"tasks\":[[\"has-text\",\"BT in your inbox\"]]}"],["{\"selector\":\"html\",\"action\":[\"remove-class\",\"modal-open\"],\"tasks\":[[\"watch-attr\",[\"class\"]]]}"],["{\"selector\":\"script\",\"tasks\":[[\"has-text\",\"nocontextmenu\"]]}"],["{\"selector\":\"\",\"tasks\":[[\"xpath\",\"//*[contains(text(),\\\"blocker\\\")]\"]]}"],["{\"selector\":\"script\",\"tasks\":[[\"has-text\",\"We think our Android\"]]}"],["{\"selector\":\".article-body > p\",\"tasks\":[[\"has-text\",\"sign up for our newsletters\"]]}"],["{\"selector\":\"body[oncontextmenu=\\\"return false\\\"]\",\"action\":[\"remove-attr\",\"oncontextmenu\"]}","{\"selector\":\"script\",\"tasks\":[[\"has-text\",\"_0x\"]]}"]];

const hostnamesMap = new Map([["ferroviando.com.br",1],["jornaljoca.com.br",1],["visse.com.br",1],["plural.jor.br",1],["javsubtitle.co",1],["afrikmag.com",1],["alphagirlreviews.com",1],["android1pro.com",1],["aprendeinglessila.com",1],["arcanescans.com",1],["bigdatauni.com",1],["bingotingo.com",1],["clockks.com",1],["codedosa.com",1],["counciloflove.com",1],["cracksone.com",1],["drkrok.com",1],["evreporter.com",1],["filmzone.com",1],["flashdumpfiles.com",1],["formatatmak.com",1],["getective.com",1],["globaldefensecorp.com",1],["gossipnextdoor.com",1],["guidingliterature.com",1],["hayatbilgileri.com",1],["hellokpop.com",1],["hiraethtranslation.com",1],["ieltsliz.com",1],["immobiliaremia.com",1],["infokik.com",1],["iptv4best.com",1],["jafekri.com",1],["jbjbgame.com",1],["joysound.com",1],["kapitalis.com",1],["kitchennovel.com",1],["koalasplayground.com",1],["learninsta.com",1],["liveyourmaths.com",1],["moneyexcel.com",1],["ncert-solutions.com",1],["home.novel-gate.com",1],["placementstore.com",1],["poolpiscina.com",1],["riwyat.com",1],["samsungtechwin.com",1],["secondlifetranslations.com",1],["selfstudyanthro.com",1],["selfstudyhistory.com",1],["sinhasannews.com",1],["tech-recipes.com",1],["tempatwisataseru.com",1],["theaircurrent.com",1],["tipssehatcantik.com",1],["truyenbanquyen.com",1],["viatasisanatate.com",1],["wikiofcelebs.com",1],["winmeen.com",1],["rozbor-dila.cz",1],["neuroteam-metz.de",1],["velicu.eu",1],["newspao.gr",1],["viewsofgreece.gr",1],["ncertsolutions.guru",1],["tiempo.hn",1],["rukim.id",1],["ibps.in",1],["colegiosconcertados.info",1],["coffeeapps.ir",1],["infodifesa.it",1],["gakki.me",1],["tunegate.me",1],["mediahiburan.my",1],["cours-de-droit.net",1],["ezmanga.net",1],["nocturnetls.net",1],["programasvirtualespc.net",1],["onlineonderdelenshop.nl",1],["day-hoc.org",1],["licensekeys.org",1],["sertracen.com.pa",1],["kulinarnastronamocy.pl",1],["blogvisaodemercado.pt",1],["ananda-yoga.ro",1],["anascrie.ro",1],["cabinetexpert.ro",1],["pitesti24.ro",1],["visefierbinti.ro",1],["voxvalachorum.ro",1],["ziarulargesul.ro",1],["kaystls.site",1],["kicknews.today",1],["primicia.com.ve",1],["maduras.vip",1],["media.framu.world",1],["animesaga.in",2],["fritz.ai",3],["blog.inkdrop.app",3],["blog.dp6.com.br",3],["uxdesign.cc",3],["atrium.co",3],["newco.co",3],["thecontrol.co",3],["unpatent.co",3],["backstage.1blocker.com",3],["500ish.com",3],["tech.ahrefs.com",3],["artplusmarketing.com",3],["backchannel.com",3],["badootech.badoo.com",3],["baharudinyusuf.com",3],["bitcointechtalk.com",3],["bitwarden.com",3],["bluerockpublicradio.com",3],["boomsupersonic.com",3],["bradfieldcs.com",3],["brightthemag.com",3],["tech.buzzfeed.com",3],["blog.canopas.com",3],["blog.coinbase.com",3],["blog.confiant.com",3],["dave-bailey.com",3],["discordapp.com",3],["doist.com",3],["doit-intl.com",3],["doublepulsar.com",3],["economist.com",3],["electricliterature.com",3],["elidourado.com",3],["getadblock.com",3],["levelup.gitconnected.com",3],["greylock.com",3],["blog.growthhackers.com",3],["headmelted.com",3],["helium.com",3],["blog.hiri.com",3],["howwegettonext.com",3],["iheart.com",3],["injusticetoday.com",3],["insightdatascience.com",3],["itsyourturnblog.com",3],["kiwi.com",3],["learngoprogramming.com",3],["learningbyshipping.com",3],["ledwards.com",3],["legalist.com",3],["broadcast.listennotes.com",3],["logrocket.com",3],["blog.ltse.com",3],["mapbox.com",3],["medium.com",3],["melmagazine.com",3],["mondaynote.com",3],["open.nytimes.com",3],["nyulocal.com",3],["ofdollarsanddata.com",3],["postlight.com",3],["proandroiddev.com",3],["signalvnoise.com",3],["slackhq.com",3],["news.smugmug.com",3],["springboard.com",3],["startupsventurecapital.com",3],["theawl.com",3],["thebigroundtable.com",3],["thebillfold.com",3],["thebolditalic.com",3],["theringer.com",3],["thriveglobal.com",3],["timeline.com",3],["towardsdatascience.com",3],["udacity.com",3],["usejournal.com",3],["warisboring.com",3],["wearemel.com",3],["whatahowler.com",3],["writingcooperative.com",3],["x.company",3],["slack.engineering",3],["blog.angular.io",3],["blog.bitsrc.io",3],["bolt.io",3],["codeburst.io",3],["fossa.io",3],["itnext.io",3],["okmeter.io",3],["javascript.plainenglish.io",3],["prototypr.io",3],["rainway.io",3],["stoplight.io",3],["theabacus.io",3],["blog.waffle.io",3],["coach.me",3],["citizen428.net",3],["dotandline.net",3],["keepingstock.net",3],["esciencecenter.nl",3],["thetaoist.online",3],["checkio.org",3],["blog.devcolor.org",3],["freecodecamp.org",3],["iota.org",3],["jupyter.org",3],["sagefy.org",3],["standardnotes.org",3],["blog.statebox.org",3],["thinkprogress.org",3],["uxplanet.org",3],["faun.pub",3],["blog.twitch.tv",3],["appd.at",4],["themosvagas.com.br",4],["hitproversion.com",4],["operatorsekolahdbn.com",4],["techsini.com",4],["9now.com.au",5],["cheknews.ca",6],["newswire.ca",7],["eplayer.click",8],["streamservicehd.click",8],["kooora4livs.com",[8,76]],["olacast.live",8],["kooora4lives.net",[8,76]],["apps.jeurissen.co",9],["1fichier.com",10],["8muses.com",11],["advancedsciencenews.com",12],["amgreatness.com",13],["androidauthority.com",14],["apk1s.com",15],["dreamsfriend.com",15],["mercenaryenrollment.com",15],["xossipy.com",15],["appimagehub.com",16],["linux-apps.com",16],["pling.com",16],["gnome-look.org",16],["store.kde.org",16],["opendesktop.org",16],["xfce-look.org",16],["askubuntu.com",17],["serverfault.com",17],["stackapps.com",17],["stackexchange.com",17],["superuser.com",17],["mathoverflow.net",17],["babylonbee.com",18],["bakerbynature.com",19],["bigthink.com",20],["canalnatelinhaonline.blogspot.com",21],["librospreuniversitariospdf.blogspot.com",22],["lvturbo.com",22],["sbbrisk.com",22],["sbface.com",22],["sbspeed.com",22],["camcaps.io",22],["streamsb.net",22],["vtplayer.net",22],["weakstream.org",22],["camcaps.to",22],["mskmangaz.blogspot.com",23],["bloombergquint.com",24],["brooklynvegan.com",25],["calgaryherald.com",26],["edmontonjournal.com",26],["montrealgazette.com",26],["ottawacitizen.com",26],["thestarphoenix.com",26],["chron.com",27],["sfgate.com",27],["cockroachlabs.com",28],["coder.com",29],["comicbook.com",30],["commoncog.com",31],["countryandtownhouse.com",32],["crunchydata.com",33],["crunchyroll.com",34],["ctpost.com",35],["cultofmac.com",36],["dailydot.com",37],["dailygalaxy.com",38],["deezer.com",39],["diffnow.com",40],["dlnews.com",41],["duolingo.com",42],["elektrikmen.com",43],["embibe.com",44],["entrepreneur.com",45],["erlang-solutions.com",46],["esscctv.com",47],["ew.com",48],["expquebec.com",49],["facebook.com",50],["facebookcorewwwi.onion",50],["facebookwkhpilnemxj7asaniu7vnjjbiltxjqhye3mhbshg7kx5tfyd.onion",50],["faloo.com",51],["fastcompany.com",52],["financasdeouro.com",53],["verfutebol.net",53],["finsmes.com",54],["flickr.com",55],["forksoverknives.com",56],["foxandbriar.com",57],["foxnews.com",58],["freethink.com",59],["gdrivedescarga.com",60],["guitar.com",61],["hellmanns.com",62],["heraldextra.com",63],["historiccity.com",64],["stitchsnitches.com",64],["hket.com",65],["hot-dinners.com",66],["hotcleaner.com",67],["iheartrecipes.com",68],["interestingengineering.com",69],["ipphone-warehouse.com",70],["jointhefollowup.com",71],["jpost.com",72],["jweekly.com",73],["karistudio.com",74],["kerrang.com",75],["labrujulaverde.com",77],["laravel-news.com",78],["lazytranslations.com",79],["lemonblossoms.com",80],["levernews.com",81],["lightnovelpub.com",82],["linuxiac.com",83],["outlook.live.com",84],["lokercirebon.com",85],["loginhit.com.ng",85],["londonpass.com",86],["marginalrevolution.com",87],["marinetraffic.com",88],["marketbeat.com",89],["mensjournal.com",90],["myntra.com",91],["naaree.com",92],["neo4j.com",93],["notateslaapp.com",94],["notthebee.com",95],["officialcharts.com",96],["online2pdf.com",97],["pcmag.com",98],["pendulumedu.com",99],["people.com",100],["photopea.com",101],["politicalwire.com",102],["potatonewstoday.com",103],["rd.com",104],["recordcollectormag.com",105],["embed.reddit.com",106],["forum.release-apk.com",107],["rprealtyplus.com",108],["safirsoft.com",109],["salon.com",110],["market.samm.com",111],["seriesperu.com",112],["shortform.com",113],["skepticalraptor.com",114],["skidrowreloaded.com",115],["web.skype.com",116],["snbc13.com",117],["spanishdict.com",118],["studiestoday.com",119],["taskandpurpose.com",120],["teachoo.com",121],["th-world.com",122],["theatlantic.com",123],["thebarbedwire.com",124],["theguardian.com",125],["themeslide.com",126],["warungkomik.com",126],["theskimm.com",127],["thestreamable.com",128],["tunein.com",129],["twitter.com",130],["x.com",130],["urbandictionary.com",131],["us500.com",132],["vox.com",133],["webnovel.com",134],["worldsensorium.com",135],["wyseguide.com",136],["yourstory.com",137],["airbnb.de",138],["newsroom.ucla.edu",139],["washington.edu",140],["yoututosjeff.es",141],["gridcoinstats.eu",142],["jpopsingles.eu",143],["adslink.pw",143],["techcrunch-com.translate.goog",144],["balls.ie",145],["gript.ie",146],["businessinsider.in",147],["ncrtsolutions.in",148],["hardware.info",149],["tarnkappe.info",150],["cssreference.io",151],["tileman.io",152],["bwitter.me",153],["allcryptoz.net",154],["crewbase.net",154],["crewus.net",154],["shinbhu.net",154],["shinchu.net",154],["thumb8.net",154],["thumb9.net",154],["topcryptoz.net",154],["ultraten.net",154],["uniqueten.net",154],["myanimelist.net",155],["phimlongtieng.net",156],["playertv.net",157],["streambuddy.net",158],["tweakers.net",159],["wotlabs.net",160],["sherwood.news",161],["janvissersweer.nl",162],["sciencenorway.no",163],["ensemblemagazine.co.nz",164],["newsroom.co.nz",165],["stuff.co.nz",166],["aarp.org",167],["cjr.org",168],["ffrfaction.org",169],["montanafreepress.org",170],["nusantararom.org",171],["quantamagazine.org",172],["reclaimthenet.org",173],["sfpublicpress.org",174],["systemsapproach.org",175],["sythe.org",176],["texastribune.org",177],["thetransmitter.org",178],["mgsm.pl",179],["businesstimes.com.sg",180],["surreyhillsgrocer.sg",181],["teamkong.tk",182],["mail.tm",183],["dailymail.co.uk",184],["dailystar.co.uk",185],["ntuplay.xyz",186]]);

const entitiesMap = new Map([["extreme-down",0],["fmovies",1],["vidmoly",2]]);

const exceptionsMap = new Map(undefined);

self.proceduralImports = self.proceduralImports || [];
self.proceduralImports.push({ argsList, hostnamesMap, entitiesMap, exceptionsMap });

/******************************************************************************/

})();

/******************************************************************************/
