/*******************************************************************************

    uBlock Origin Lite - a comprehensive, MV3-compliant content blocker
    Copyright (C) 2014-present Raymond Hill

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see {http://www.gnu.org/licenses/}.

    Home: https://github.com/gorhill/uBlock
*/

/* jshint esversion:11 */

'use strict';

// ruleset: default

/******************************************************************************/

// Important!
// Isolate from global scope
(function uBOL_cssProceduralImport() {

/******************************************************************************/

const argsList = [["{\"selector\":\".les-title\",\"tasks\":[[\"has-text\",\"HD\"]]}"],["{\"selector\":\"script\",\"tasks\":[[\"has-text\",\"break;case\"]]}"],["{\"selector\":\"\",\"tasks\":[[\"xpath\",\"//*[contains(text(),\\\"Hide your IP\\\")]/..\"]]}","{\"selector\":\"ul > li\",\"tasks\":[[\"has-text\",\"/‌/i\"]]}"],["{\"selector\":\".download-links-dontblock > LI\",\"tasks\":[[\"has-text\",\"Anon\"]]}","{\"selector\":\".download-links-dontblock > LI\",\"tasks\":[[\"has-text\",\"Stream\"]]}"],["{\"selector\":\".no-top-radius div > a[href]\",\"tasks\":[[\"has-text\",\"VPN\"]]}"],["{\"selector\":\"a[href]#clickfakeplayer\",\"action\":[\"remove-attr\",\"href\"]}"],["{\"selector\":\"script\",\"tasks\":[[\"has-text\",\"3f87b0eaddd\"]]}"],["{\"selector\":\"script[type]\",\"tasks\":[[\"has-text\",\"c=document.createElement\"]]}"],["{\"selector\":\"script[data-cfasync]\",\"tasks\":[[\"has-text\",\"popundersPerIP\"]]}"],["{\"selector\":\".block_area iframe\",\"tasks\":[[\"upward\",\".block_area\"]]}"],["{\"selector\":\"script\",\"tasks\":[[\"has-text\",\"\\\\'shift\\\\'\"]]}","{\"selector\":\"script\",\"tasks\":[[\"has-text\",\"shift\"]]}"],["{\"selector\":\".table-hover.table > tbody > tr\",\"tasks\":[[\"has-text\",\"Descargar Premium\"]]}"],["{\"selector\":\".a-carousel-card:has(> div > div[cel_widget_id^=\\\"adplacements:\\\"])\",\"action\":[\"remove\",\"\"]}"],["{\"selector\":\"a[href*=\\\".yabo816.\\\"]\",\"action\":[\"remove\",\"\"]}"],["{\"selector\":\"#players a[href][target=\\\"_blank\\\"]\",\"action\":[\"remove-attr\",\"/href|target/\"]}","{\"selector\":\"style\",\"tasks\":[[\"has-text\",\"blink_me_ad\"],[\"upward\",2]]}"],["{\"selector\":\"script\",\"tasks\":[[\"has-text\",\"WebAssembly\"]]}"],["{\"selector\":\".links_table > .fix-table > table > tbody > tr\",\"tasks\":[[\"has-text\",\"Patrocinador\"]]}"],["{\"selector\":\"button\",\"tasks\":[[\"has-text\",\"/Watch|🎟|👉/\"]]}"],["{\"selector\":\"a.download[target=\\\"_blank\\\"]:not(a[href*=\\\"ctrlv.\\\"])\",\"action\":[\"remove\",\"\"]}"],["{\"selector\":\"script\",\"tasks\":[[\"has-text\",\"decodeURIComponent\"]]}"],["{\"selector\":\"h2.widget-title\",\"tasks\":[[\"has-text\",\"Advertisement\"]]}"],["{\"selector\":\"script[data-cfasync]\",\"tasks\":[[\"has-text\",\"decodeURIComponent\"]]}"],["{\"selector\":\"script\",\"tasks\":[[\"has-text\",\"0x3\"]]}"],["{\"selector\":\"\",\"tasks\":[[\"xpath\",\"//*[contains(text(),\\\"VPN\\\")]\"],[\"upward\",2]]}"],["{\"selector\":\"\",\"tasks\":[[\"xpath\",\"//a[contains(text(),\\\"VPN\\\")]/../../..\"]]}"],["{\"selector\":\"table\",\"tasks\":[[\"has-text\",\"VPN\"]]}"],["{\"selector\":\".adunitContainer\",\"tasks\":[[\"upward\",3]]}"],["{\"selector\":\".getlink\",\"tasks\":[[\"others\",\"\"]]}"],["{\"selector\":\"script\",\"tasks\":[[\"has-text\",\"AaDetector\"]]}"],["{\"selector\":\"script\",\"tasks\":[[\"has-text\",\"/\\\\{delete window\\\\[/\"]]}"],["{\"selector\":\"script\",\"tasks\":[[\"has-text\",\"/history\\\\.pushState/\"]]}"],["{\"selector\":\"script\",\"tasks\":[[\"has-text\",\"adslotFilledByCriteo\"]]}"],["{\"selector\":\"#main a[href][data-sb^=\\\"/url?\\\"]\",\"action\":[\"remove-attr\",\"data-sb\"]}"],["{\"selector\":\"#clickfakeplayer[href]\",\"action\":[\"remove-attr\",\"href\"]}"],["{\"selector\":\"script\",\"tasks\":[[\"has-text\",\"self == top\"]]}"],["{\"selector\":\"script\",\"tasks\":[[\"has-text\",\"detect\"]]}"],["{\"selector\":\"[id]\",\"tasks\":[[\"matches-attr\",{\"attr\":\"id\",\"value\":\"/[a-zA-Z]{40,}/\"}]]}"],["{\"selector\":\"div[class] > ins.adsbygoogle\",\"tasks\":[[\"upward\",\"div[class]\"]]}","{\"selector\":\"li[class] > ins.adsbygoogle\",\"tasks\":[[\"upward\",\"li[class]\"]]}"],["{\"selector\":\"*\",\"tasks\":[[\"matches-css-before\",{\"name\":\"content\",\"pseudo\":\"before\",\"value\":\"Adv\"}]]}"],["{\"selector\":\".head\",\"tasks\":[[\"has-text\",\"Adv\"]]}","{\"selector\":\"tr\",\"tasks\":[[\"has-text\",\"VPN\"]]}"],["{\"selector\":\".uk-card-secondary\",\"tasks\":[[\"has-text\",\"VPN\"]]}"],["{\"selector\":\"script\",\"tasks\":[[\"has-text\",\"htmlAds\"]]}"],["{\"selector\":\"script\",\"tasks\":[[\"has-text\",\"antiAdBlockerHandler\"]]}"],["{\"selector\":\"[id^=\\\"cookieConsent\\\"]\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\"#clickfakeplayer\",\"action\":[\"remove-attr\",\"href\"]}"],["{\"selector\":\"div[id][style=\\\"width: 728px; height: 90px;\\\"]\",\"tasks\":[[\"upward\",\"#pub1\"]]}"],["{\"selector\":\".happy-player-beside, .happy-section, .widget_execphp\",\"tasks\":[[\"has-text\",\"/Advertisement|ExoLoader/\"]]}"],["{\"selector\":\".video-block-happy-absolute\",\"tasks\":[[\"upward\",\".order-1\"]]}"],["{\"selector\":\"a[href*=\\\"&epik=\\\"]\",\"tasks\":[[\"upward\",\"[data-grid-item]\"]]}"],["{\"selector\":\"[href]\",\"tasks\":[[\"has-text\",\"PLAY\"]]}"],["{\"selector\":\"script\",\"tasks\":[[\"has-text\",\"exdynsrv\"]]}"],["{\"selector\":\"div[width=\\\"300\\\"][height=\\\"250\\\"]\",\"tasks\":[[\"upward\",1]]}","{\"selector\":\"div[width=\\\"728\\\"][height=\\\"90\\\"]\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\"script\",\"tasks\":[[\"has-text\",\"admc\"]]}"],["{\"selector\":\"\",\"tasks\":[[\"xpath\",\"//*[contains(text(),\\\"Sponsored\\\")]\"],[\"upward\",2]]}"],["{\"selector\":\".adsbyvli\",\"tasks\":[[\"upward\",\"div[style^=\\\"width: 300px; height: 250px\\\"]\"]]}"],["{\"selector\":\".adsbygoogle\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\"script\",\"tasks\":[[\"has-text\",\"debugger\"]]}"],["{\"selector\":\".g-recaptcha\",\"action\":[\"style\",\"display: block !important;\"],\"tasks\":[[\"upward\",\"form > div\"]]}"],["{\"selector\":\".placeholder\",\"action\":[\"remove-class\",\"placeholder\"]}"],["{\"selector\":\"div.row\",\"tasks\":[[\"has-text\",\"in HD\"]]}","{\"selector\":\"table.movie_version\",\"tasks\":[[\"has-text\",\"Promo\"]]}"],["{\"selector\":\"script\",\"tasks\":[[\"has-text\",\"u_cfg\"]]}"],["{\"selector\":\"script\",\"tasks\":[[\"has-text\",\"\\\\\\\"admc\\\\\\\"\"]]}"],["{\"selector\":\"#f13 > b\",\"tasks\":[[\"has-text\",\"Sponsor\"],[\"upward\",4]]}"],["{\"selector\":\"script\",\"tasks\":[[\"has-text\",\"/aclib|runPop/\"]]}"],["{\"selector\":\"script\",\"tasks\":[[\"has-text\",\"/adblock/i\"]]}"],["{\"selector\":\"[style]\",\"tasks\":[[\"has-text\",\"PREMIUM\"]]}"],["{\"selector\":\"\",\"tasks\":[[\"xpath\",\"//strong[contains(text(),\\\"VPN\\\")]/../../..\"]]}"],["{\"selector\":\".table2\",\"tasks\":[[\"has-text\",\"Sponsored\"]]}","{\"selector\":\"TR\",\"tasks\":[[\"has-text\",\"Stream:\"]]}"],["{\"selector\":\"[class]:not(body):not(html)\",\"tasks\":[[\"has-text\",\"/Protect your privacy/i\"]]}","{\"selector\":\"[class]:not(body):not(html)\",\"tasks\":[[\"has-text\",\"Sponsored\"]]}"],["{\"selector\":\".panel-title\",\"tasks\":[[\"has-text\",\"REKLAM\"]]}","{\"selector\":\"div.col-xs-12\",\"tasks\":[[\"has-text\",\"MMPORG OYUNLAR\"]]}"],["{\"selector\":\".page-video > div.video-videos-slider ~ div[class]\",\"tasks\":[[\"matches-css\",{\"name\":\"justify-content\",\"value\":\"^center$\"}]]}"],["{\"selector\":\"span:only-child\",\"tasks\":[[\"has-text\",\"/^AD$/\"],[\"upward\",2]]}"],["{\"selector\":\".btn-danger\",\"tasks\":[[\"has-text\",\"/download/i\"]]}"],["{\"selector\":\"script\",\"tasks\":[[\"has-text\",\"btoa\"]]}"],["{\"selector\":\"[src^=\\\"assets/bn\\\"]\",\"tasks\":[[\"upward\",\"[style]\"]]}"],["{\"selector\":\"div > div[io-id]\",\"tasks\":[[\"has-text\",\"Sponsored\"]]}"],["{\"selector\":\"script\",\"tasks\":[[\"has-text\",\"runCount\"]]}"],["{\"selector\":\"#shortGoToCont.hidden\",\"action\":[\"remove-class\",\"hidden\"]}"],["{\"selector\":\"[style^=\\\"font-weight\\\"]\",\"tasks\":[[\"has-text\",\"PREMIUM\"]]}"],["{\"selector\":\".adsbygoogle\",\"action\":[\"remove\",\"\"]}"],["{\"selector\":\"[onclick^=\\\"showAd\\\"]\",\"action\":[\"remove-attr\",\"onclick\"]}"],["{\"selector\":\"main[class^=\\\"searchResultsContainer\\\"] li h2\",\"tasks\":[[\"has-text\",\"Sponsored\"]]}"],["{\"selector\":\"html > head > :is([name=\\\"canonical\\\"], [rel=\\\"canonical\\\"]):not([content*=\\\"/details/\\\"])\",\"tasks\":[[\"upward\",1],[\"spath\",\" > script[src*=\\\"optimizely\\\"]\"]]}"],["{\"selector\":\"script\",\"tasks\":[[\"has-text\",\"NREUM\"]]}"],["{\"selector\":\"tbody\",\"tasks\":[[\"has-text\",\"WARNING! Use a\"]]}"],["{\"selector\":\"#leading_video_player_autoplay_wrapper\",\"action\":[\"remove\",\"\"]}"],["{\"selector\":\".banner\",\"tasks\":[[\"has-text\",\"/Sponsorizzato|Sponsorowane|Sponsorizat|Sponzorováno|Szponzorált|Спонсорирани|Sponsored|Gesponsert/\"]]}","{\"selector\":\".product\",\"tasks\":[[\"has-text\",\"/Sponsorizzato|Sponsorowane|Sponsorizat|Sponzorováno|Szponzorált|Спонсорирани|Sponsored|Gesponsert/\"]]}"],["{\"selector\":\".attention-button-wrap\",\"tasks\":[[\"has-text\",\"Reimage\"]]}","{\"selector\":\".nfc-bottom-right\",\"tasks\":[[\"has-text\",\"Reimage\"]]}","{\"selector\":\"a\",\"tasks\":[[\"has-text\",\"Reimage\"]]}","{\"selector\":\"a\",\"tasks\":[[\"has-text\",\"SpyHunter\"]]}","{\"selector\":\"th\",\"tasks\":[[\"has-text\",\"/^Detection$/\"],[\"spath\",\" + td\"]]}","{\"selector\":\"th\",\"tasks\":[[\"has-text\",\"/^Detection$/\"]]}"],["{\"selector\":\"script\",\"tasks\":[[\"has-text\",\"htmls\"]]}"],["{\"selector\":\".postcontainer\",\"tasks\":[[\"has\",{\"selector\":\".usertitle\",\"tasks\":[[\"has-text\",\"Publicidade\"]]}]]}"],["{\"selector\":\"[id^=\\\"banner-300x250\\\"]\",\"action\":[\"remove\",\"\"]}"],["{\"selector\":\".chakra-linkbox\",\"tasks\":[[\"has-text\",\"Sponsored\"]]}","{\"selector\":\"[data-testid=\\\"card\\\"]\",\"tasks\":[[\"has-text\",\"sponsored\"]]}"],["{\"selector\":\".product-tile-group__list__item\",\"tasks\":[[\"has-text\",\"Sponsored\"]]}"],["{\"selector\":\"[data-testid^=\\\"listing-card-list-item-\\\"]\",\"tasks\":[[\"has-text\",\"TOP AD\"]]}"],["{\"selector\":\"[data-testid=\\\"product-grid\\\"] > div\",\"tasks\":[[\"has-text\",\"Sponsored\"]]}"],["{\"selector\":\".chakra-container\",\"tasks\":[[\"has-text\",\"Featured Items\"]]}"],["{\"selector\":\"style\",\"action\":[\"remove\",\"\"],\"tasks\":[[\"has-text\",\"#blockblock\"]]}"],["{\"selector\":\"script\",\"tasks\":[[\"has-text\",\"popunder\"]]}"],["{\"selector\":\".definetelynotanad\",\"tasks\":[[\"upward\",\"[class^=\\\"col-md-\\\"]\"]]}"],["{\"selector\":\".safelink-recatpcha\",\"action\":[\"style\",\"display: block !important;\"],\"tasks\":[[\"upward\",\"div\"]]}"],["{\"selector\":\"img[onclick]\",\"action\":[\"style\",\"display: block !important\"],\"tasks\":[[\"upward\",\".wait\"]]}"],["{\"selector\":\".post__content > p\",\"tasks\":[[\"has-text\",\"This segment is a paid ad\"]]}"],["{\"selector\":\"[href*=\\\"preroll\\\"]\",\"tasks\":[[\"upward\",2]]}"],["{\"selector\":\"a\",\"tasks\":[[\"has\",{\"selector\":\"div:last-child\",\"tasks\":[[\"has-text\",\"Hide\"]]}]]}"],["{\"selector\":\"span\",\"tasks\":[[\"has-text\",\"AD\"]]}"],["{\"selector\":\".js-side-ads-movie-container\",\"action\":[\"remove\",\"\"]}"],["{\"selector\":\"#wpsafe-link\",\"tasks\":[[\"others\",\"\"]]}"],["{\"selector\":\".main-content > h4 > strong\",\"tasks\":[[\"has-text\",\"Brave\"]]}"],["{\"selector\":\"#tp-snp2\",\"tasks\":[[\"others\",\"\"]]}"],["{\"selector\":\"body *\",\"action\":[\"remove\",\"\"],\"tasks\":[[\"matches-css\",{\"name\":\"margin\",\"value\":\"auto\"}],[\"matches-css\",{\"name\":\"width\",\"value\":\"^[2-3]{1}[0-9]{2}(\\\\.[0-9]+)?px$\"}],[\"matches-css\",{\"name\":\"height\",\"value\":\"^[2-3]{1}[0-9]{2}(\\\\.[0-9]+)?px$\"}],[\"matches-css\",{\"name\":\"display\",\"value\":\"block|table\"}]]}"],["{\"selector\":\"div[style*=\\\"z-index: 300000\\\"]\",\"action\":[\"remove\",\"\"]}"],["{\"selector\":\".ad-zone\",\"action\":[\"remove\",\"\"]}"],["{\"selector\":\"#btn6, #tp98\",\"tasks\":[[\"others\",\"\"]]}"],["{\"selector\":\"script\",\"tasks\":[[\"has-text\",\"onerror\"]]}"],["{\"selector\":\"#toshowtrlink, #gtbtn2, .divTableCell, #postfooterOk\",\"tasks\":[[\"others\",\"\"]]}"],["{\"selector\":\"#go_d\",\"action\":[\"remove-attr\",\"disabled\"]}"],["{\"selector\":\".btn-primary, #go_d, #tp-snp1, #go_d2\",\"tasks\":[[\"others\",\"\"]]}"],["{\"selector\":\"#wpsafe-link, #section2\",\"tasks\":[[\"others\",\"\"]]}"],["{\"selector\":\".page-wrap > section\",\"tasks\":[[\"has-text\",\"Download the free\"]]}"],["{\"selector\":\"li.uk-active\",\"action\":[\"remove\",\"\"]}"],["{\"selector\":\".video-holder > center > *\",\"tasks\":[[\"has-text\",\"/^Advertisement$/\"]]}"],["{\"selector\":\"script\",\"tasks\":[[\"has-text\",\"google_ad_client\"]]}"],["{\"selector\":\"[id^=\\\"sidebar-stream-\\\"] > h4\",\"tasks\":[[\"has-text\",\"Advertisement\"]]}"],["{\"selector\":\"link[rel=\\\"canonical\\\"]:not([href*=\\\"pageconfig=contactus\\\"])\",\"tasks\":[[\"upward\",\"html\"],[\"spath\",\" script.optanon-category-C0001\"]]}"],["{\"selector\":\"body\",\"action\":[\"remove-class\",\"ads-not-loaded\"]}"],["{\"selector\":\".product-card-col\",\"tasks\":[[\"has-text\",\"Sponsored\"]]}"],["{\"selector\":\"script\",\"tasks\":[[\"has-text\",\"axtd\"]]}"],["{\"selector\":\".PropertyCardItem\",\"tasks\":[[\"has\",{\"selector\":\"div\",\"tasks\":[[\"has-text\",\"Promoted\"]]}]]}"],["{\"selector\":\"html:has(> head > :is(meta[name=\\\"subscriber_only\\\"][content=\\\"false\\\"], meta[property=\\\"og:url\\\"]:not([content*=\\\".html\\\"]))) script\",\"tasks\":[[\"has-text\",\"/googletagmanager|window\\\\.sophi/\"]]}"],["{\"selector\":\".J-offer-wrapper\",\"tasks\":[[\"has-text\",\"Top sponsor listing\"]]}","{\"selector\":\".m-product-item\",\"tasks\":[[\"has-text\",\"Sponsored Listing\"]]}"],["{\"selector\":\"#card-list > .search-item-card-wrapper-gallery\",\"tasks\":[[\"has\",{\"selector\":\"a.search-card-item[href*=\\\"&aem_p4p_detail=\\\"] div[class*=\\\"cards--image--\\\"] > div[class*=\\\"multi--ax--\\\"]\",\"tasks\":[[\"has-text\",\"/^(?:AD|An[uú]ncio|광고|広告)$/\"]]}],[\"spath\",\":has(+ .search-item-card-wrapper-gallery a.search-card-item:not([href*=\\\"&aem_p4p_detail=\\\"]))\"]]}"],["{\"selector\":\".code-block\",\"tasks\":[[\"has-text\",\"ADV\"]]}"],["{\"selector\":\"center\",\"tasks\":[[\"has-text\",\"deal\"]]}"],["{\"selector\":\".g-recaptcha, #tp-snp2, .captcha-check, [src*=\\\"google.com/recaptcha/\\\"]\",\"tasks\":[[\"others\",\"\"]]}"],["{\"selector\":\".blockTitle\",\"tasks\":[[\"has-text\",\"Advertisement\"]]}"],["{\"selector\":\"div.d_mh\",\"tasks\":[[\"has-text\",\"Latest deals\"]]}","{\"selector\":\"main > div > div:empty\",\"tasks\":[[\"matches-css\",{\"name\":\"min-height\",\"value\":\"^250px$\"}],[\"matches-css\",{\"name\":\"min-width\",\"value\":\"^80%$\"}]]}"],["{\"selector\":\"[href^=\\\"/advertorial/\\\"]\",\"tasks\":[[\"upward\",2]]}"],["{\"selector\":\".post.has-post-thumbnail video#gump\",\"action\":[\"remove\",\"\"],\"tasks\":[[\"upward\",\".post\"]]}"],["{\"selector\":\".maas-item\",\"tasks\":[[\"has-text\",\"our Partners\"]]}"],["{\"selector\":\".ads_horizontal_reader\",\"action\":[\"remove\",\"\"]}"],["{\"selector\":\".container > center\",\"tasks\":[[\"others\",\"\"]]}","{\"selector\":\".getlink, #getlink\",\"action\":[\"remove-attr\",\"disabled\"]}"],["{\"selector\":\"p\",\"tasks\":[[\"has-text\",\"Advertisement\"]]}"],["{\"selector\":\".btnDownload\",\"tasks\":[[\"has-text\",\"SHARE\"]]}"],["{\"selector\":\"script\",\"tasks\":[[\"has-text\",\"document.createTextNode\"]]}"],["{\"selector\":\".Page-header-leaderboardAd\",\"action\":[\"remove\",\"\"]}","{\"selector\":\"html[data-header-hasleaderboard]\",\"action\":[\"remove-attr\",\"data-header-hasleaderboard\"]}"],["{\"selector\":\"#tp98, #btn6\",\"tasks\":[[\"others\",\"\"]]}"],["{\"selector\":\"script\",\"tasks\":[[\"has-text\",\"window.adsbygoogle\"]]}"],["{\"selector\":\".js-toggle-content-wrapper a[href^=\\\"https://shemale.show/\\\"]\",\"tasks\":[[\"upward\",\".js-toggle-content-wrapper\"]]}"],["{\"selector\":\".serieslist > ul > li\",\"tasks\":[[\"has-text\",\"(AD)\"]]}","{\"selector\":\"a[href][title^=\\\"(AD)\\\"]\",\"tasks\":[[\"upward\",\".bs\"]]}"],["{\"selector\":\"[class^=\\\"style\\\"]\",\"tasks\":[[\"has-text\",\"Advertisement\"]]}"],["{\"selector\":\".panel\",\"tasks\":[[\"has-text\",\"createAd\"]]}"],["{\"selector\":\"#content-main a[title][href*=\\\"?staticParams=\\\"]\",\"tasks\":[[\"upward\",\"span\"]]}"],["{\"selector\":\"#yuidea-snp\",\"tasks\":[[\"others\",\"\"]]}"],["{\"selector\":\".elementor-section\",\"tasks\":[[\"has-text\",\"Advertisement\"]]}"],["{\"selector\":\"script\",\"tasks\":[[\"has-text\",\"push\"]]}"],["{\"selector\":\"script\",\"tasks\":[[\"has-text\",\"googlesyndication\"]]}"],["{\"selector\":\".mb32\",\"tasks\":[[\"has-text\",\"Advertisement\"]]}"],["{\"selector\":\".b-gray300\",\"tasks\":[[\"has-text\",\"Advertisement\"]]}"],["{\"selector\":\"html:not(:has(video)) > head > script\",\"tasks\":[[\"has-text\",\"connatix.com\"]]}"],["{\"selector\":\"button[onclick^=\\\"window.open\\\"]\",\"action\":[\"remove-attr\",\"onclick\"]}"],["{\"selector\":\"#tp-snp2, #cross-snp2, .tp-top\",\"tasks\":[[\"others\",\"\"]]}"],["{\"selector\":\"#player-container\",\"tasks\":[[\"has-text\",\"Close ad\"]]}"],["{\"selector\":\"[id^=\\\"Ad\\\"]\",\"tasks\":[[\"upward\",\"[style]\"]]}"],["{\"selector\":\"script\",\"tasks\":[[\"has-text\",\"AdBlockEnabled\"]]}"],["{\"selector\":\"div.border_radius\",\"tasks\":[[\"has-text\",\"Advertisement\"]]}"],["{\"selector\":\"img[width=\\\"558\\\"][height=\\\"149\\\"]\",\"tasks\":[[\"upward\",\"td[style]\"]]}"],["{\"selector\":\"\",\"tasks\":[[\"matches-path\",\"~/shop\"],[\"spath\",\" a[href*=\\\"/aclick?\\\"]:not(.vsp_ads)\"]]}","{\"selector\":\".b_restorableLink\",\"action\":[\"remove\",\"\"]}"],["{\"selector\":\".row.justify-center\",\"tasks\":[[\"has-text\",\"Advertisement\"]]}"],["{\"selector\":\"script\",\"tasks\":[[\"has-text\",\"/eval[\\\\s\\\\S]*?decodeURIComponent/\"]]}"],["{\"selector\":\".post_wrap\",\"tasks\":[[\"has-text\",\"AdBot\"]]}","{\"selector\":\"ul#bc-home-news-main-wrap > li\",\"tasks\":[[\"has-text\",\"Sponsored\"]]}"],["{\"selector\":\"#waiting, #pop-button, .modal-content\",\"tasks\":[[\"others\",\"\"]]}"],["{\"selector\":\"a.get-link.disabled\",\"action\":[\"remove-class\",\"disabled\"]}"],["{\"selector\":\"#wpsafe-snp1\",\"tasks\":[[\"others\",\"\"]]}"],["{\"selector\":\".text-center\",\"tasks\":[[\"has-text\",\"Adv\"]]}"],["{\"selector\":\"#btn-gotolink\",\"action\":[\"remove-attr\",\"disabled\"]}","{\"selector\":\"#btn-gotolink\",\"tasks\":[[\"others\",\"\"]]}"],["{\"selector\":\"div.fixed[style^=\\\"z-index:\\\"]\",\"tasks\":[[\"has-text\",\"گوشی خود را بچرخانید\"]]}"],["{\"selector\":\"main div.MuiBox-root > span.MuiTypography-subtitle2\",\"tasks\":[[\"has-text\",\"Advertisement\"],[\"upward\",1]]}"],["{\"selector\":\"[style*=\\\"center\\\"]\",\"tasks\":[[\"has-text\",\"Ad\"]]}"],["{\"selector\":\"div[data-testid=\\\"property-card\\\"]\",\"tasks\":[[\"has\",{\"selector\":\"span\",\"tasks\":[[\"has-text\",\"Promoted\"]]}]]}"],["{\"selector\":\".oct-listers-hits__item\",\"tasks\":[[\"has-text\",\"Sponsored\"]]}"],["{\"selector\":\"script\",\"tasks\":[[\"has-text\",\"FingerprintJS\"]]}"],["{\"selector\":\".js-toggle-content-wrapper a[href^=\\\"https://boyfriend.show/\\\"][rel=\\\"sponsored\\\"]\",\"tasks\":[[\"upward\",\".js-toggle-content-wrapper\"]]}"],["{\"selector\":\"html > head > meta[property=\\\"og:url\\\"]:not([content*=\\\"/games/\\\"], [content*=\\\"/play/\\\"])\",\"tasks\":[[\"upward\",1],[\"spath\",\" > script\"],[\"has-text\",\"wgplayer\"]]}"],["{\"selector\":\".main-body > div > div[class]:not([class^=\\\"item\\\"]):not([class^=\\\"article\\\"])\",\"tasks\":[[\"has-text\",\"/^Sponsored ads$/\"]]}","{\"selector\":\"div[class*=\\\"article\\\"] > div:not([class]) > div[class]\",\"tasks\":[[\"has-text\",\"/^Sponsored ads$/\"]]}"],["{\"selector\":\"#submitBtn, #go_d, #devozon-snp, #submitBtn, #tp-snp1, #go_d2\",\"tasks\":[[\"others\",\"\"]]}"],["{\"selector\":\"body[style*=\\\"display: none\\\"]\",\"action\":[\"remove-attr\",\"style\"]}"],["{\"selector\":\".dl.disabled\",\"action\":[\"remove-class\",\"disabled\"]}"],["{\"selector\":\"[data-cg-ft=\\\"sponsored-listing-badge\\\"]\",\"tasks\":[[\"upward\",3]]}"],["{\"selector\":\".row.divider\",\"tasks\":[[\"has-text\",\"/sponsor|press releases/i\"]]}","{\"selector\":\".widget\",\"tasks\":[[\"has-text\",\"/advert|sponsor/i\"]]}"],["{\"selector\":\".widget_custom_html #myVideo\",\"tasks\":[[\"upward\",\".widget_custom_html\"]]}"],["{\"selector\":\"div:is(.shadow, .flex.w-full.justify-center[style=\\\"\\\"]):has(a[href=\\\"/pricing\\\"] img[alt=\\\"Please support civitai and creators by disabling adblock\\\"])\",\"action\":[\"remove\",\"\"]}"],["{\"selector\":\".ad-wrapper\",\"tasks\":[[\"upward\",\"div.region-sidebar-first-wrapper\"]]}"],["{\"selector\":\".zox-side-widget\",\"tasks\":[[\"has-text\",\"/^Advertis/\"]]}"],["{\"selector\":\"#timeout\",\"action\":[\"remove-attr\",\"disabled\"]}","{\"selector\":\"#timeout, #btn1, #tp-snp2\",\"tasks\":[[\"others\",\"\"]]}"],["{\"selector\":\"script\",\"tasks\":[[\"has-text\",\"clientHeight\"]]}"],["{\"selector\":\"#wpsafelinkhuman, #wpsafe-link\",\"tasks\":[[\"others\",\"\"]]}"],["{\"selector\":\"#captchaShortlink\",\"action\":[\"style\",\"display: block !important;\"],\"tasks\":[[\"upward\",\"form#coinsparty > div\"]]}","{\"selector\":\"form[action$=\\\"/links/popad\\\"]\",\"action\":[\"remove\",\"\"]}"],["{\"selector\":\"li.group-\\\\[\\\\.inline\\\\]\\\\:mb-8\",\"tasks\":[[\"has-text\",\"Ad\"]]}"],["{\"selector\":\"section h6\",\"tasks\":[[\"has-text\",\"Advertising\"],[\"upward\",\"section\"]]}"],["{\"selector\":\".widget_custom_html ins\",\"tasks\":[[\"upward\",\".widget_custom_html\"]]}"],["{\"selector\":\"aside.td_block_template_1.widget.widget_text\",\"tasks\":[[\"has\",{\"selector\":\"> h4.block-title > span\",\"tasks\":[[\"has-text\",\"Visit Our Sponsors\"]]}]]}"],["{\"selector\":\".ad-unit\",\"action\":[\"remove\",\"\"]}"],["{\"selector\":\"[data-pid^=\\\"ad-\\\"]\",\"action\":[\"remove\",\"\"]}"],["{\"selector\":\".ct-related-videos-title\",\"tasks\":[[\"has-text\",\"Advertisement\"]]}","{\"selector\":\".ct-related-videos-title\",\"tasks\":[[\"has-text\",\"You may also like\"]]}"],["{\"selector\":\"div[role=\\\"group\\\"]\",\"tasks\":[[\"has-text\",\"Sponsored\"]]}"],["{\"selector\":\"center\",\"tasks\":[[\"others\",\"\"]]}"],["{\"selector\":\"#hometimerstartbtn, #hometimer, #yuidea-btmbtn, #btn6\",\"tasks\":[[\"others\",\"\"]]}"],["{\"selector\":\"form#go-popup\",\"action\":[\"remove\",\"\"]}"],["{\"selector\":\"\",\"action\":[\"remove\",\"\"],\"tasks\":[[\"matches-path\",\"/utm_medium=adv/i\"],[\"spath\",\" html\"]]}"],["{\"selector\":\"#top_nav, .rd_btn, .soractrl, .large\",\"tasks\":[[\"others\",\"\"]]}"],["{\"selector\":\"div#container-text\",\"tasks\":[[\"has-text\",\"ADVERTISEMENT\"]]}","{\"selector\":\"span.container-text\",\"tasks\":[[\"has-text\",\"ADVERTISEMENT\"]]}"],["{\"selector\":\"div[pb-serve-label*=\\\"advert\\\"]\",\"tasks\":[[\"upward\",2]]}"],["{\"selector\":\"#rightcolumn > .rbox > .rboxInner img[alt=\\\"Advertisement\\\"]\",\"tasks\":[[\"upward\",\".rbox\"]]}","{\"selector\":\".wallpaperSidebarAds\",\"tasks\":[[\"upward\",\"div\"]]}"],["{\"selector\":\"#deviantartcom_desktop-devpage-sidebar-300x250-atf\",\"tasks\":[[\"upward\",\"div[role=\\\"complementary\\\"] > div\"]]}"],["{\"selector\":\".chakra-link\",\"tasks\":[[\"has-text\",\"Advertise\"]]}"],["{\"selector\":\"[class] > p\",\"tasks\":[[\"has-text\",\"Advertisement\"]]}"],["{\"selector\":\"article.relative\",\"tasks\":[[\"has\",{\"selector\":\"div\",\"tasks\":[[\"has-text\",\"SPONSORED\"]]}]]}"],["{\"selector\":\"div > [id$=\\\"_slot\\\"]\",\"tasks\":[[\"upward\",\"div\"]]}"],["{\"selector\":\".left_shadow\",\"tasks\":[[\"has-text\",\"Fast\"]]}"],["{\"selector\":\"a > img + div[class]:last-of-type\",\"tasks\":[[\"has-text\",\"Sponsored\"],[\"upward\",\"div[sizes]\"]]}","{\"selector\":\"div[sizes] > span[class]\",\"tasks\":[[\"has-text\",\"Sponsored\"],[\"upward\",\"div[sizes]\"]]}"],["{\"selector\":\"#gourl\",\"tasks\":[[\"others\",\"\"]]}"],["{\"selector\":\"a[href][data-link-out]\",\"action\":[\"remove-attr\",\"data-link-out\"]}"],["{\"selector\":\"center[style]\",\"tasks\":[[\"has-text\",\"advertisement\"]]}"],["{\"selector\":\"#banner_overlay-postitial-video\",\"action\":[\"remove\",\"\"]}"],["{\"selector\":\"script\",\"tasks\":[[\"has-text\",\"/innerHTML.*appendChild/\"]]}"],["{\"selector\":\"center, [src*=\\\"google.com/recaptcha/\\\"]\",\"tasks\":[[\"others\",\"\"]]}"],["{\"selector\":\"H2\",\"tasks\":[[\"has-text\",\"/Promoted/\"],[\"spath\",\" + DIV\"]]}"],["{\"selector\":\"h2\",\"tasks\":[[\"has-text\",\"/Promoted/\"]]}"],["{\"selector\":\".ad-banner\",\"action\":[\"remove\",\"\"]}"],["{\"selector\":\"h3.my-4\",\"tasks\":[[\"has-text\",\"/^Advertising/\"]]}"],["{\"selector\":\"div > .page > div > div[style]\",\"tasks\":[[\"has-text\",\"/^Advertise/i\"],[\"spath\",\" + a\"]]}"],["{\"selector\":\"script\",\"tasks\":[[\"has-text\",\"d.createElement('script')\"]]}","{\"selector\":\"script\",\"tasks\":[[\"has-text\",\"d.createElement(\\\\'script\\\\')\"]]}"],["{\"selector\":\"body.no-touch li.wt-list-unstyled div.v2-listing-card__info > div.wt-text-caption.wt-text-grey > span:not(.wt-icon):not([aria-role])\",\"action\":[\"remove\",\"\"],\"tasks\":[[\"matches-css\",{\"name\":\"display\",\"value\":\"^inline-block$\"}],[\"has-text\",\"/^Ad/i\"],[\"upward\",\"li\"]]}","{\"selector\":\"li:not(#ad-ubo) .listing-link[href*=\\\"ref=sc_gallery\\\"]\",\"tasks\":[[\"upward\",\"li\"]]}"],["{\"selector\":\"div[class*=\\\"ads\\\"]\",\"tasks\":[[\"has-text\",\"/Advertisement/i\"]]}"],["{\"selector\":\"#o-site-hr__leaderboard-wallpaper.u-show-for-xlarge\",\"action\":[\"remove\",\"\"]}"],["{\"selector\":\".m-object\",\"tasks\":[[\"has\",{\"selector\":\".m-object__quote\",\"tasks\":[[\"has-text\",\"/In partnership with|En partenariat avec|Mit Unterstützung von|In collaborazione con|En colaboración con|Em parceria com|Совместно с|ile birlikte|Σε συνεργασία με|Együttműködésben a|با همکاری|بالمشاركة مع/\"]]}]]}"],["{\"selector\":\"\",\"action\":[\"style\",\"height: 0 !important; overflow: hidden !important;\"],\"tasks\":[[\"matches-path\",\"/^\\\\/(\\\\?[a-z]+=\\\\w+)?$/\"],[\"spath\",\" div[aria-posinset] :is(h3, h4) span > a[href]:not([href^=\\\"/groups/\\\"]):not([href*=\\\"section_header_type\\\"])\"],[\"matches-attr\",{\"attr\":\"href\",\"value\":\"/__cft__\\\\[0\\\\]=[-\\\\w]{290,}/\"}],[\"upward\",\"div[aria-posinset]\"]]}","{\"selector\":\"\",\"action\":[\"style\",\"height: 0 !important; overflow: hidden !important;\"],\"tasks\":[[\"matches-path\",\"/search/\"],[\"spath\",\" div[role=\\\"article\\\"] span > a[href]:not([href^=\\\"/groups/\\\"]):not([href*=\\\"section_header_type\\\"])\"],[\"matches-attr\",{\"attr\":\"href\",\"value\":\"/__cft__\\\\[0\\\\]=[-\\\\w]{265,}/\"}],[\"upward\",\"[role=\\\"article\\\"]\"]]}","{\"selector\":\"#stream_pagelet div[id^=\\\"hyperfeed_story_id_\\\"]\",\"tasks\":[[\"if\",{\"selector\":\"h6\",\"tasks\":[[\"has-text\",\"People You May Know\"]]}]]}","{\"selector\":\"#watch_feed div:not([class]) > div:not([class]) div[class] [class] > a[href*=\\\"utm_source=facebook\\\"] span[class] > span[class][style*=\\\"-webkit-line-clamp\\\"]\",\"action\":[\"style\",\"height: 0 !important; overflow: hidden !important;\"],\"tasks\":[[\"has-text\",\"広告\"],[\"upward\",\"div:not([class]) > div:not([class])\"]]}","{\"selector\":\"#watch_feed div:not([class]) > div:not([class]) div[class] span[class] > a span[aria-labelledby]\",\"action\":[\"style\",\"height: 0 !important; overflow: hidden !important;\"],\"tasks\":[[\"has\",{\"selector\":\"> span[style=\\\"display: flex;\\\"] > span[class]\",\"tasks\":[[\"has-text\",\"/^S$/\"]]}],[\"has\",{\"selector\":\"> span[style=\\\"display: flex;\\\"] > span[class]\",\"tasks\":[[\"has-text\",\"/^p$/\"]]}],[\"has\",{\"selector\":\"> span[style=\\\"display: flex;\\\"] > span[class]\",\"tasks\":[[\"has-text\",\"/^d$/\"]]}],[\"upward\",\"div:not([class]) > div:not([class])\"]]}","{\"selector\":\"#watch_feed div:not([class]) > div:not([class]) div[class] span[class] > a[aria-label=\\\"広告\\\"]\",\"action\":[\"style\",\"height: 0 !important; overflow: hidden !important;\"],\"tasks\":[[\"upward\",\"div:not([class]) > div:not([class])\"]]}","{\"selector\":\".ego_column\",\"tasks\":[[\"if\",\"a[href^=\\\"/campaign/landing\\\"]\"]]}","{\"selector\":\".ego_section\",\"tasks\":[[\"if\",\"a[href^=\\\"/ad_campaign\\\"]\"]]}","{\"selector\":\".pagelet-group .pagelet\",\"tasks\":[[\"has\",{\"selector\":\"a\",\"tasks\":[[\"has-text\",\"/Sponsored|Create ad|Crear un anuncio|Publicidad/\"]]}]]}","{\"selector\":\".userContentWrapper > div div > span > span\",\"tasks\":[[\"has-text\",\"/^Suggested Post$/\"]]}","{\"selector\":\"div[aria-describedby]:not([aria-posinset]) :is(h3, h4) span > a[href]:not([href^=\\\"/groups/\\\"]):not([href*=\\\"section_header_type\\\"])\",\"action\":[\"style\",\"height: 0 !important; overflow: hidden !important;\"],\"tasks\":[[\"matches-attr\",{\"attr\":\"href\",\"value\":\"/__cft__\\\\[0\\\\]=[-\\\\w]{290,}/\"}],[\"upward\",\"div[aria-describedby]\"]]}","{\"selector\":\"div[id^=\\\"hyperfeed_story_id_\\\"]\",\"tasks\":[[\"has\",{\"selector\":\"div > span:has(abbr .timestampContent)\",\"tasks\":[[\"matches-css\",{\"name\":\"display\",\"value\":\"^none$\"}]]}]]}"],["{\"selector\":\".inside-list-boxes\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\"li.top-results__item span\",\"tasks\":[[\"has-text\",\"Sponsored\"],[\"upward\",\"li\"]]}"],["{\"selector\":\".video\",\"tasks\":[[\"has\",{\"selector\":\"span\",\"tasks\":[[\"has-text\",\"Live\"]]}]]}","{\"selector\":\"[data-vid^=\\\"live-\\\"]\",\"action\":[\"remove\",\"\"]}","{\"selector\":\"[href^=\\\"https://go.cam.feet9.com/\\\"]\",\"tasks\":[[\"upward\",3]]}","{\"selector\":\"[onclick*=\\\"banner\\\"]\",\"tasks\":[[\"upward\",\".video\"]]}"],["{\"selector\":\"article.card-article\",\"tasks\":[[\"has\",{\"selector\":\"span.card-article__author\",\"tasks\":[[\"has-text\",\"Sponsored Content\"]]}]]}"],["{\"selector\":\".title-section\",\"tasks\":[[\"has-text\",\"/adv/i\"]]}"],["{\"selector\":\"form\",\"tasks\":[[\"others\",\"\"]]}"],["{\"selector\":\".advertising\",\"tasks\":[[\"upward\",2]]}"],["{\"selector\":\".video-block-happy\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\"div[data-id] > div[data-tkid] > div[class]\",\"tasks\":[[\"has-text\",\"Sponsored\"],[\"upward\",\"div[data-id]\"]]}","{\"selector\":\"span\",\"tasks\":[[\"has-text\",\"/^Ad$/\"],[\"upward\",\"div[style]\"]]}"],["{\"selector\":\".adsbygoogle\",\"tasks\":[[\"upward\",\".widget\"]]}"],["{\"selector\":\"a[onclick*=\\\"adlink()\\\"]\",\"action\":[\"remove-attr\",\"onclick\"]}"],["{\"selector\":\"main > div > div > div[class]\",\"tasks\":[[\"matches-css\",{\"name\":\"width\",\"value\":\"^350px$\"}]]}"],["{\"selector\":\".btn-success, .btn-primary\",\"tasks\":[[\"others\",\"\"]]}"],["{\"selector\":\"#wpsafe-link, .wpsafelink-multiple-pages\",\"tasks\":[[\"others\",\"\"]]}"],["{\"selector\":\".post_simple\",\"tasks\":[[\"has\",{\"selector\":\".postsimple_pseudo\",\"tasks\":[[\"has-text\",\"/promo/i\"]]}]]}"],["{\"selector\":\".uppercase\",\"tasks\":[[\"has-text\",\"/advertisement/i\"]]}"],["{\"selector\":\".spr > .container-fluid:not([data-autopromo-name=\\\"freepik\\\"])\",\"tasks\":[[\"upward\",\".spr\"]]}"],["{\"selector\":\"div[class][id]:not(.logo)\",\"tasks\":[[\"if-not\",\"*\"],[\"has-text\",\"/^$/\"]]}"],["{\"selector\":\".swiper-slide\",\"tasks\":[[\"has-text\",\"Sponsored\"]]}"],["{\"selector\":\".partner-banner\",\"tasks\":[[\"upward\",\"div[style]\"]]}"],["{\"selector\":\"\",\"tasks\":[[\"matches-path\",\"/\\\\/posts/\"],[\"spath\",\" div[data-comment*=\\\"gab-ad\\\"]\"],[\"has\",{\"selector\":\"span[class]\",\"tasks\":[[\"has-text\",\"Sponsored\"]]}]]}","{\"selector\":\"div[class] > span[class]\",\"tasks\":[[\"has-text\",\"Sponsored\"],[\"upward\",5]]}"],["{\"selector\":\"li.list-group-item\",\"tasks\":[[\"has-text\",\"Sponsored content\"]]}"],["{\"selector\":\".col-sm-4\",\"tasks\":[[\"has-text\",\"Advertisement\"]]}","{\"selector\":\"div\",\"tasks\":[[\"has\",{\"selector\":\"> div:has(> .adsbygoogle)\"}]]}"],["{\"selector\":\".mobile-leaderboard-320-50\",\"tasks\":[[\"upward\",\"[style]\"]]}"],["{\"selector\":\"div[id] > .dfp-ad-unit\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\"#int-over\",\"action\":[\"remove\",\"\"]}","{\"selector\":\"#intt-layer\",\"action\":[\"remove\",\"\"]}"],["{\"selector\":\".leftMenu .menuHeadline\",\"tasks\":[[\"has-text\",\"3D\"]]}"],["{\"selector\":\"[src^=\\\"https://spotlights-feed.github.com/spotlights/octoprint/\\\"]\",\"tasks\":[[\"upward\",\"article[class]\"]]}"],["{\"selector\":\"p.content-center\",\"tasks\":[[\"has-text\",\"ADVERTISEMENT\"]]}"],["{\"selector\":\"body > div iframe\",\"tasks\":[[\"upward\",\"body > div\"]]}"],["{\"selector\":\".golin-adlabel\",\"tasks\":[[\"upward\",\"[class^=\\\"golin-content\\\"]\"]]}"],["{\"selector\":\"[data-profile-url-path^=\\\"/localservices\\\"]\",\"tasks\":[[\"has-text\",\"/google screened/i\"]]}"],["{\"selector\":\"div[aria-label=\\\"Why this ad?\\\"]\",\"tasks\":[[\"upward\",\"[data-pla=\\\"1\\\"]\"]]}"],["{\"selector\":\".im_outer_x\",\"tasks\":[[\"upward\",2]]}","{\"selector\":\"script\",\"tasks\":[[\"has-text\",\"myreadCookie/\"]]}"],["{\"selector\":\"body[data-billboard=\\\"true\\\"]\",\"action\":[\"remove-attr\",\"data-billboard\"]}"],["{\"selector\":\"#btn6\",\"tasks\":[[\"others\",\"\"]]}"],["{\"selector\":\".HTML.widget .adsbygoogle\",\"tasks\":[[\"upward\",\".widget\"]]}"],["{\"selector\":\"div.bar_container\",\"tasks\":[[\"has\",{\"selector\":\"> div.bar_headline\",\"tasks\":[[\"has-text\",\"Advertising\"]]}]]}"],["{\"selector\":\"div > article[data-q=\\\"search-result\\\"] > a[data-q=\\\"search-result-anchor\\\"] > div > figure.listing-tile-thumbnail-image + div\",\"tasks\":[[\"has-text\",\"Featured\"],[\"upward\",\"article[data-q=\\\"search-result\\\"]\"]]}"],["{\"selector\":\".content3 > div[style]\",\"tasks\":[[\"has-text\",\"Advertisement\"]]}"],["{\"selector\":\"script\",\"tasks\":[[\"has-text\",\"await fetch\"]]}"],["{\"selector\":\"#my-btn, #pro-continue, #pro-link\",\"tasks\":[[\"others\",\"\"]]}"],["{\"selector\":\".header-2\",\"tasks\":[[\"has-text\",\"Sponsored Suggestions\"]]}"],["{\"selector\":\"[class*=\\\"css\\\"]\",\"tasks\":[[\"matches-css-before\",{\"name\":\"content\",\"pseudo\":\"before\",\"value\":\"ADVERTISEMENT\"}]]}","{\"selector\":\"[href*=\\\"redirect\\\"]\",\"tasks\":[[\"upward\",\"section\"]]}","{\"selector\":\"aside\",\"tasks\":[[\"has\",{\"selector\":\"div\",\"tasks\":[[\"matches-css-before\",{\"name\":\"content\",\"pseudo\":\"before\",\"value\":\"ADVERTISEMENT\"}]]}]]}","{\"selector\":\"div[data-empty^=\\\"true\\\"]\",\"tasks\":[[\"matches-css-before\",{\"name\":\"content\",\"pseudo\":\"before\",\"value\":\"ADVERTISEMENT\"}]]}"],["{\"selector\":\"#submitBtn, #go_d, #wolfexe-snp\",\"tasks\":[[\"others\",\"\"]]}"],["{\"selector\":\"div[class^=\\\"sc-\\\"]\",\"tasks\":[[\"has\",{\"selector\":\"> div[data-qe-id=\\\"productCard\\\"]\",\"tasks\":[[\"has-text\",\"Promoted\"]]}]]}"],["{\"selector\":\"script\",\"tasks\":[[\"has-text\",\"/eval\\\\(.+?decodeURIComponent/\"]]}"],["{\"selector\":\".ad\",\"tasks\":[[\"upward\",\".horizontal-ads-content\"]]}"],["{\"selector\":\"#notarobot, #gotolink\",\"tasks\":[[\"others\",\"\"]]}"],["{\"selector\":\"#gotolink[disabled]\",\"action\":[\"remove-attr\",\"disabled\"]}"],["{\"selector\":\".article-sidebar\",\"tasks\":[[\"has-text\",\"Advertisement\"]]}"],["{\"selector\":\"\",\"action\":[\"remove\",\"\"],\"tasks\":[[\"matches-path\",\"soft98\"],[\"spath\",\" html\"]]}"],["{\"selector\":\"div[class]\",\"tasks\":[[\"matches-css-before\",{\"name\":\"content\",\"pseudo\":\"before\",\"value\":\"Advertisements\"}]]}"],["{\"selector\":\".block_label--last\",\"tasks\":[[\"has-text\",\"Advertisement\"]]}"],["{\"selector\":\"script\",\"tasks\":[[\"has-text\",\"iframeTestTimeMS\"]]}"],["{\"selector\":\"script\",\"tasks\":[[\"has-text\",\"g02.\"]]}"],["{\"selector\":\"script\",\"tasks\":[[\"has-text\",\"shouldPop\"]]}"],["{\"selector\":\"body div\",\"tasks\":[[\"matches-css\",{\"name\":\"position\",\"value\":\"^fixed$\"}],[\"matches-css\",{\"name\":\"background-color\",\"value\":\"rgb\"}],[\"matches-css\",{\"name\":\"z-index\",\"value\":\"\\\\d+\"}]]}"],["{\"selector\":\".nonAppView > div div[class]:not([id]) > div[id^=\\\"div-gpt-ad\\\"]\",\"tasks\":[[\"upward\",1]]}","{\"selector\":\"[onclick] .btxt\",\"tasks\":[[\"has-text\",\"/Ad/\"],[\"xpath\",\"../../..\"]]}","{\"selector\":\"[onclick] h5\",\"tasks\":[[\"has-text\",\"/Ad/\"],[\"xpath\",\"../../..\"]]}","{\"selector\":\"[onclick] p\",\"tasks\":[[\"has-text\",\"/Ad/\"],[\"xpath\",\"../../..\"]]}","{\"selector\":\"div\",\"tasks\":[[\"matches-css\",{\"name\":\"background-image\",\"value\":\"colombia_\"}],[\"xpath\",\"../..\"]]}","{\"selector\":\"h2\",\"tasks\":[[\"has-text\",\"/Promoted/\"],[\"spath\",\" + div\"]]}","{\"selector\":\"p\",\"tasks\":[[\"matches-css\",{\"name\":\"background-image\",\"value\":\"colombia-icon\"}],[\"xpath\",\"../..\"]]}"],["{\"selector\":\"[onclick] p\",\"tasks\":[[\"matches-css-before\",{\"name\":\"content\",\"pseudo\":\"before\",\"value\":\"Ad \"}],[\"xpath\",\"../..\"],[\"not\",{\"selector\":\"p\",\"tasks\":[[\"has-text\",\"/MAHA/i\"]]}],[\"not\",{\"selector\":\"p\",\"tasks\":[[\"has-text\",\"/Times/i\"]]}]]}"],["{\"selector\":\".active > ul > li\",\"tasks\":[[\"has-text\",\"Ad:\"]]}","{\"selector\":\"div h2\",\"tasks\":[[\"has\",{\"selector\":\"span\",\"tasks\":[[\"matches-css-before\",{\"name\":\"content\",\"pseudo\":\"before\",\"value\":\"Sponsored\"}]]}],[\"spath\",\" + div\"]]}","{\"selector\":\"div h2\",\"tasks\":[[\"has\",{\"selector\":\"span\",\"tasks\":[[\"matches-css-before\",{\"name\":\"content\",\"pseudo\":\"before\",\"value\":\"Sponsored\"}]]}]]}"],["{\"selector\":\".g1-advertisement-inside-grid\",\"tasks\":[[\"upward\",\"li\"]]}"],["{\"selector\":\".et_pb_module\",\"tasks\":[[\"has-text\",\"Partners\"],[\"spath\",\" + .et_pb_module\"]]}","{\"selector\":\".et_pb_module\",\"tasks\":[[\"has-text\",\"Partners\"]]}","{\"selector\":\".et_pb_widget\",\"tasks\":[[\"has-text\",\"Partners\"]]}"],["{\"selector\":\"script\",\"tasks\":[[\"has-text\",\"two_worker_data_js\"]]}"],["{\"selector\":\"#wpsafe-generate, #wpsafe-link\",\"tasks\":[[\"others\",\"\"]]}"],["{\"selector\":\"amp-iframe:has([src^=\\\"https://widget.sellwild.com\\\"])\",\"action\":[\"remove\",\"\"]}"],["{\"selector\":\"div[style=\\\"max-height: inherit; max-width: inherit; display: none !important;\\\"]\",\"tasks\":[[\"has\",{\"selector\":\"span\",\"tasks\":[[\"has-text\",\"Paid partnership with \"]]}]]}","{\"selector\":\"div[style=\\\"max-height: inherit; max-width: inherit; display: none !important;\\\"]\",\"tasks\":[[\"has\",{\"selector\":\"span\",\"tasks\":[[\"has-text\",\"Paid partnership\"]]}]]}","{\"selector\":\"div[style=\\\"max-height: inherit; max-width: inherit;\\\"]\",\"tasks\":[[\"has\",{\"selector\":\"span\",\"tasks\":[[\"has-text\",\"Paid partnership with \"]]}]]}","{\"selector\":\"main > div div[style*=\\\"flex-direction: column;\\\"] > article > div\",\"tasks\":[[\"has\",{\"selector\":\"> div:first-child span\",\"tasks\":[[\"has-text\",\"/Anzeige|Gesponsert|Sponsored|Geborg|Maksettu kumppanuus|Sponzorováno|Sponsoreret|Χορηγούμενη|Publicidad|Sponsoroitu|Sponsorisé|Bersponsor|Sponsorizzato|広告|광고|Ditaja|Sponset|Gesponsord|Sponsorowane|Patrocinado|Реклама|Sponsrad|ได้รับการสนับสนุน|May Sponsor|Sponsorlu|赞助内容|贊助|প্রযোজিত|પ્રાયોજિત|स्पॉन्सर्ड|Sponzorirano|ಪ್ರಾಯೋಜಿತ|സ്‌പോൺസർ ചെയ്‌തത്|पुरस्‍कृत|प्रायोजित|ਪ੍ਰਾਯੋਜਿਤ|මුදල් ගෙවා ප්‍රචාරය කරන ලදි|Sponzorované|விளம்பரதாரர்கள்|స్పాన్సర్ చేసింది|Được tài trợ|Спонсорирано|Commandité|Sponsorizat|Спонзорисано/\"]]}]]}"],["{\"selector\":\"[class]\",\"tasks\":[[\"matches-css-before\",{\"name\":\"content\",\"pseudo\":\"before\",\"value\":\"Advertisement\"}],[\"upward\",1]]}"],["{\"selector\":\"#landing, .soractrl\",\"tasks\":[[\"others\",\"\"]]}"],["{\"selector\":\"button\",\"action\":[\"remove-attr\",\"disabled\"]}","{\"selector\":\"button\",\"action\":[\"remove-class\",\"hidden\"]}"],["{\"selector\":\"script\",\"tasks\":[[\"has-text\",\"wadsBlocking\"]]}"],["{\"selector\":\".MuiGrid-item div[style^=\\\"position\\\"] > div\",\"tasks\":[[\"has-text\",\"Skip Ad\"]]}"],["{\"selector\":\".video-image > .track_outbound_post\",\"tasks\":[[\"upward\",2]]}"],["{\"selector\":\"script\",\"tasks\":[[\"has-text\",\"end_click\"]]}"],["{\"selector\":\"script\",\"tasks\":[[\"has-text\",\"Adblock\"]]}"],["{\"selector\":\"script\",\"tasks\":[[\"has-text\",\"/htmls|google_ad_client/\"]]}"],["{\"selector\":\"#p7a1\",\"action\":[\"remove\",\"\"]}"],["{\"selector\":\"html > head > link[rel=\\\"canonical\\\"]:not([href*=\\\"/recipes/\\\"])\",\"tasks\":[[\"upward\",2],[\"spath\",\" script\"],[\"has-text\",\"googletagmanager\"]]}"],["{\"selector\":\"._2EeeR\",\"tasks\":[[\"has-text\",\"Sponsored\"]]}","{\"selector\":\".rs-infinite-scroll > div\",\"tasks\":[[\"has-text\",\"Sponsored\"]]}","{\"selector\":\".slider-slide\",\"tasks\":[[\"has-text\",\"Sponsored\"]]}"],["{\"selector\":\".wrapper\",\"tasks\":[[\"has-text\",\"Sponsored Articles\"]]}"],["{\"selector\":\".adunitContainer\",\"tasks\":[[\"upward\",\"[data-qa-id]\"]]}"],["{\"selector\":\"span\",\"tasks\":[[\"has-text\",\"Advert\"]]}"],["{\"selector\":\"script\",\"tasks\":[[\"has-text\",\"Math.imul\"]]}"],["{\"selector\":\"script\",\"tasks\":[[\"has-text\",\"afScript\"]]}"],["{\"selector\":\"[data-ref=\\\"saashub\\\"]\",\"tasks\":[[\"upward\",\"div.feed-item\"]]}"],["{\"selector\":\"div[class] > div[id^=\\\"gpt_\\\"] > script\",\"tasks\":[[\"has-text\",\"initGpt\"],[\"upward\",\"div[class]\"]]}","{\"selector\":\"div[class] > div[id^=\\\"stpd_\\\"] > script\",\"tasks\":[[\"has-text\",\"/initAd|initGpt/\"],[\"upward\",\"div[class]\"]]}","{\"selector\":\"li[class] > div[id^=\\\"stpd_\\\"] > script\",\"tasks\":[[\"has-text\",\"stpd\"],[\"upward\",\"li[class]\"]]}"],["{\"selector\":\"div[class][data-mobid] > div[class=\\\"vm-placement\\\"][data-id]\",\"tasks\":[[\"upward\",\"div[class]\"]]}"],["{\"selector\":\".msg-overlay-list-bubble__conversations-list\",\"tasks\":[[\"has-text\",\"Sponsored\"]]}","{\"selector\":\"div.feed-shared-update-v2\",\"tasks\":[[\"has\",{\"selector\":\"span.update-components-actor__description\",\"tasks\":[[\"has-text\",\"/Anzeige|Sponsored|Promoted|Dipromosikan|Propagováno|Promoveret|Gesponsert|Promocionado|促銷內容|Post sponsorisé|프로모션|Post sponsorizzato|广告|プロモーション|Treść promowana|Patrocinado|Promovat|Продвигается|Marknadsfört|Nai-promote|ได้รับการโปรโมท|Öne çıkarılan içerik|Gepromoot|الترويج/\"]]}]]}","{\"selector\":\"div.feed-shared-update-v2\",\"tasks\":[[\"has\",{\"selector\":\"span.update-components-actor__sub-description\",\"tasks\":[[\"has-text\",\"/Anzeige|Sponsored|Promoted|Dipromosikan|Propagováno|Promoveret|Gesponsert|Promocionado|促銷內容|Post sponsorisé|프로모션|Post sponsorizzato|广告|プロモーション|Treść promowana|Patrocinado|Promovat|Продвигается|Marknadsfört|Nai-promote|ได้รับการโปรโมท|Öne çıkarılan içerik|Gepromoot|الترويج/\"]]}]]}","{\"selector\":\"div.feed-shared-update-v2\",\"tasks\":[[\"has\",{\"selector\":\"span.update-components-actor__sub-description--tla\",\"tasks\":[[\"has-text\",\"/Anzeige|Sponsored|Promoted|Dipromosikan|Propagováno|Promoveret|Gesponsert|Promocionado|促銷內容|Post sponsorisé|프로모션|Post sponsorizzato|广告|プロモーション|Treść promowana|Patrocinado|Promovat|Продвигается|Marknadsfört|Nai-promote|ได้รับการโปรโมท|Öne çıkarılan içerik|Gepromoot|الترويج/\"]]}]]}"],["{\"selector\":\"p[style=\\\"font-size:12px; text-align:center;\\\"] > span\",\"tasks\":[[\"has-text\",\"Advertisement\"]]}","{\"selector\":\"section.wix-blog-hide-in-print p[style=\\\"font-size:12px; text-align:center;\\\"] > span\",\"tasks\":[[\"has-text\",\"Advertisement\"],[\"upward\",\"section\"]]}"],["{\"selector\":\".amp-animate\",\"action\":[\"remove\",\"\"]}"],["{\"selector\":\".mod-container\",\"tasks\":[[\"has-text\",\"/sponsor/i\"]]}"],["{\"selector\":\"\",\"tasks\":[[\"xpath\",\"//*[contains(text(),\\\"allow ads\\\")]\"],[\"upward\",3]]}"],["{\"selector\":\"#SmileyBanner\",\"action\":[\"remove\",\"\"]}"],["{\"selector\":\"iframe\",\"tasks\":[[\"upward\",2]]}"],["{\"selector\":\"div#wpsafe-link\",\"tasks\":[[\"others\",\"\"]]}"],["{\"selector\":\"script\",\"tasks\":[[\"has-text\",\"adp\"],[\"upward\",\"._ap_apex_ad\"],[\"upward\",\"[style]\"]]}"],["{\"selector\":\"div[class^=\\\"css-\\\"]\",\"tasks\":[[\"matches-css-before\",{\"name\":\"content\",\"pseudo\":\"before\",\"value\":\"ADVERTISEMENT\"}]]}","{\"selector\":\"div[id=\\\"__next\\\"] > div[class^=\\\"css-\\\"] > aside\",\"tasks\":[[\"has\",{\"selector\":\"> div\",\"tasks\":[[\"matches-css-before\",{\"name\":\"content\",\"pseudo\":\"before\",\"value\":\"ADVERTISEMENT\"}]]}]]}","{\"selector\":\"div[id=\\\"__next\\\"] > div[class^=\\\"css-\\\"] > div > section > div\",\"tasks\":[[\"matches-css-before\",{\"name\":\"content\",\"pseudo\":\"before\",\"value\":\"ADVERTISEMENT\"}]]}"],["{\"selector\":\"h4\",\"tasks\":[[\"has-text\",\"VPN\"]]}"],["{\"selector\":\"script\",\"tasks\":[[\"has-text\",\"adblock\"]]}"],["{\"selector\":\"[href*=\\\"?key\\\"][target=\\\"_blank\\\"]\",\"action\":[\"remove-attr\",\"href\"]}"],["{\"selector\":\"a[href=\\\"javascript:;\\\"]\",\"tasks\":[[\"has\",{\"selector\":\"> span\",\"tasks\":[[\"has-text\",\"Advertisement\"]]}]]}"],["{\"selector\":\".adsbygoogle\",\"action\":[\"style\",\"min-height:11px!important;height:11px!important;opacity:0\"],\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\"a[rel*=\\\"sponsored\\\"]\",\"tasks\":[[\"upward\",\".normal-page__content > div\"]]}"],["{\"selector\":\"iframe\",\"tasks\":[[\"upward\",\"[style*=\\\"visibility\\\"]\"]]}"],["{\"selector\":\".headline.wrapper\",\"tasks\":[[\"has-text\",\"Advertisement\"],[\"spath\",\" + div\"]]}","{\"selector\":\".headline.wrapper\",\"tasks\":[[\"has-text\",\"Advertisement\"]]}","{\"selector\":\".video-info > section\",\"tasks\":[[\"has-text\",\"Adv\"]]}","{\"selector\":\"article > .headline\",\"tasks\":[[\"has-text\",\"Suggested\"],[\"spath\",\" + section\"]]}","{\"selector\":\"article > .headline\",\"tasks\":[[\"has-text\",\"Suggested\"]]}"],["{\"selector\":\"#btn2, .tp-blue\",\"tasks\":[[\"others\",\"\"]]}"],["{\"selector\":\"[data-aop=\\\"stripe.sponsored.navigation_stripenavigation\\\"]\",\"tasks\":[[\"upward\",2]]}","{\"selector\":\"[data-aop=\\\"stripe.store.navigation_stripenavigation\\\"]\",\"tasks\":[[\"upward\",2]]}"],["{\"selector\":\"a[href^=\\\"/visual/\\\"]\",\"tasks\":[[\"upward\",\".menu > div[id]\"]]}","{\"selector\":\"div\",\"tasks\":[[\"matches-css-after\",{\"name\":\"content\",\"pseudo\":\"after\",\"value\":\"Ads\"}]]}","{\"selector\":\"div[id*=\\\"myabandonware_leaderboard_btf_\\\"]\",\"tasks\":[[\"upward\",\"div[id]\"]]}","{\"selector\":\"div[id*=\\\"myabandonware_medrec_right_\\\"]\",\"tasks\":[[\"upward\",\"div[id]\"]]}","{\"selector\":\"style\",\"action\":[\"remove\",\"\"],\"tasks\":[[\"has-text\",\"justify-content\"]]}"],["{\"selector\":\".ad-removal-info\",\"tasks\":[[\"has-text\",\"ads\"],[\"upward\",\"[class]\"]]}"],["{\"selector\":\"div[class^=\\\"span\\\"] > div.box\",\"tasks\":[[\"has\",{\"selector\":\"> .title > div\",\"tasks\":[[\"has-text\",\"Advertisement\"]]}]]}"],["{\"selector\":\".banner\",\"tasks\":[[\"upward\",\".block\"]]}"],["{\"selector\":\"\",\"tasks\":[[\"xpath\",\"//div[contains(text(),\\\"Advert\\\")]\"]]}","{\"selector\":\".composite-branding.branding\",\"tasks\":[[\"has-text\",\"/sponsored/i\"],[\"xpath\",\"..\"]]}"],["{\"selector\":\"#jeocontainer > span\",\"tasks\":[[\"has-text\",\"Promoted\"]]}"],["{\"selector\":\"script\",\"tasks\":[[\"has-text\",\"popWin\"]]}"],["{\"selector\":\"script\",\"tasks\":[[\"has-text\",\"script\"]]}"],["{\"selector\":\"a[onclick][target]\",\"tasks\":[[\"upward\",2]]}"],["{\"selector\":\".viewtable\",\"tasks\":[[\"has\",{\"selector\":\"> center\",\"tasks\":[[\"has-text\",\"▼ Scroll down to Continue ▼\"]]}],[\"spath\",\" > a[href][target=\\\"_blank\\\"]\"]]}"],["{\"selector\":\"span[class*=\\\"productContaine\\\"]\",\"tasks\":[[\"has\",{\"selector\":\"div\",\"tasks\":[[\"has-text\",\"Sponsored\"]]}]]}"],["{\"selector\":\"article\",\"tasks\":[[\"has\",{\"selector\":\".Yw5es\",\"tasks\":[[\"has-text\",\"Sponsored\"]]}]]}","{\"selector\":\"ul[style^=\\\"padding: 0px; position: relative;\\\"] > li[class]\",\"tasks\":[[\"has-text\",\"Sponsored\"]]}"],["{\"selector\":\"script\",\"tasks\":[[\"has-text\",\"antiblock\"]]}"],["{\"selector\":\"img[src$=\\\"/knewz_300x250.png\\\"]\",\"tasks\":[[\"upward\",\".widget_text\"]]}"],["{\"selector\":\"\",\"tasks\":[[\"xpath\",\"//div[starts-with(@id, \\\"dfp-ad\\\")]/../..\"]]}"],["{\"selector\":\".bn-title\",\"tasks\":[[\"has-text\",\"Advertising\"]]}"],["{\"selector\":\"#header-adv-banner\",\"action\":[\"remove\",\"\"]}"],["{\"selector\":\"iframe\",\"tasks\":[[\"upward\",\".thumb\"]]}"],["{\"selector\":\".countdown, .get-link\",\"tasks\":[[\"others\",\"\"]]}"],["{\"selector\":\".circular-progress, button, b > p > span\",\"tasks\":[[\"others\",\"\"]]}"],["{\"selector\":\".banotset\",\"tasks\":[[\"upward\",3]]}"],["{\"selector\":\"#adter\",\"tasks\":[[\"upward\",3]]}","{\"selector\":\".single-entry-titles\",\"tasks\":[[\"has-text\",\"Sponsor\"]]}"],["{\"selector\":\"center > font[size=\\\"3\\\"][face=\\\"ARIAL\\\"]\",\"tasks\":[[\"has-text\",\"ADVERTISING\"],[\"upward\",\"td\"]]}"],["{\"selector\":\"a[href^=\\\"https://www.panda-novel.com/advertising\\\"]\",\"tasks\":[[\"upward\",\".index-swiper\"]]}"],["{\"selector\":\"body\",\"action\":[\"remove-class\",\"top_ads_add\"]}"],["{\"selector\":\".InfoPcBolsaAdBlock\",\"tasks\":[[\"xpath\",\"..\"]]}"],["{\"selector\":\"div[data-controller=\\\"downloads.front.view.download\\\"] a[data-action=\\\"download\\\"][data-wait=\\\"true\\\"]\",\"action\":[\"remove-attr\",\"data-wait\"]}"],["{\"selector\":\".adsbox\",\"action\":[\"remove\",\"\"]}"],["{\"selector\":\"[class^=\\\"CitrusCatapult-styled__LeftContent\\\"]\",\"tasks\":[[\"has\",{\"selector\":\"div\",\"tasks\":[[\"has-text\",\"Sponsored\"]]}]]}","{\"selector\":\"[class^=\\\"HorizontalWidget\\\"]\",\"tasks\":[[\"has\",{\"selector\":\"div\",\"tasks\":[[\"has-text\",\"Sponsored\"]]}]]}","{\"selector\":\"li\",\"tasks\":[[\"has-text\",\"Sponsored\"]]}"],["{\"selector\":\".wcfAdLocation\",\"tasks\":[[\"upward\",\"li\"]]}"],["{\"selector\":\"#googletop\",\"action\":[\"remove\",\"\"]}"],["{\"selector\":\"[class*=\\\"has-interstitial-ads\\\"]\",\"action\":[\"remove-class\",\"/^has-interstitial-ads/\"]}"],["{\"selector\":\"h1\",\"tasks\":[[\"has-text\",\"Ads\"]]}"],["{\"selector\":\".bunny-icon[disabled]\",\"action\":[\"remove-attr\",\"disabled\"]}"],["{\"selector\":\"[data-popunder-enabled]\",\"action\":[\"remove-attr\",\"data-popunder-enabled\"]}"],["{\"selector\":\".adsbyexoclick\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\"script[data-cfasync]\",\"tasks\":[[\"has-text\",\"0x\"]]}"],["{\"selector\":\"#btn11, #tp-snp2, #rtg, #btn6, #wpsafe-snp\",\"tasks\":[[\"others\",\"\"]]}"],["{\"selector\":\"span\",\"tasks\":[[\"has-text\",\"ADVERTISEMENT\"]]}"],["{\"selector\":\"script\",\"tasks\":[[\"has-text\",\"vglnk\"]]}"],["{\"selector\":\".text-12\",\"tasks\":[[\"has-text\",\"Promoted\"]]}"],["{\"selector\":\"center, [src*=\\\"google.com/recaptcha/\\\"], #yuidea-snp\",\"tasks\":[[\"others\",\"\"]]}"],["{\"selector\":\"div[class^=\\\"mikex\\\"]\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\"#alphabet, #channels, #divx-container, #hmenu, #inform, #nowlooking, #playerCamBox, #playerMenu, #qcat, #showPlayer, #tabel_tagslist, #video_content, #web_cam, .BaseRoomContents, .buttons, .carouselTopScroll, .carusel-keys-box-ps, .footerdesc, .in_top, .load_more_rel, .mainBoxTitle, .pagIno, .playerContent100pr, .relatedVideo, .right-160px, .videos-related, footer, header, [href^=\\\"/webcams.php\\\"]\",\"tasks\":[[\"others\",\"\"]]}","{\"selector\":\"a\",\"tasks\":[[\"matches-attr\",{\"attr\":\"/-h?ref/\",\"value\":\"\"}]]}","{\"selector\":\"a\",\"tasks\":[[\"matches-attr\",{\"attr\":\"/^on/\",\"value\":\"/event/\"}]]}"],["{\"selector\":\"div.has-adz:not(.SetPage)\",\"action\":[\"remove-class\",\"has-adz\"]}"],["{\"selector\":\"\",\"tasks\":[[\"xpath\",\"//div[not(@class=\\\"ui_qtext_para\\\") and contains(text(), 'Quora') and contains(text(), 'by') and contains(text(), 'Business')]/parent::a/parent::div/parent::div/parent::div[@id]\"]]}","{\"selector\":\"\",\"tasks\":[[\"xpath\",\"//div[not(@class=\\\"ui_qtext_para\\\") and contains(text(), 'ad by')]/parent::div/parent::div/parent::div[@id]\"]]}","{\"selector\":\"\",\"tasks\":[[\"xpath\",\"//div[not(@class=\\\"ui_qtext_para\\\") and contains(text(), 'promoted') and contains(text(), 'by')]/parent::a/parent::div/parent::div/parent::div[@id]\"]]}","{\"selector\":\"\",\"tasks\":[[\"xpath\",\"//p[(text()='d')]/../../../../..\"]]}","{\"selector\":\"\",\"tasks\":[[\"xpath\",\"//span[contains(text(), 'by')]/ancestor::*[contains(concat(' ', @class, ' '), ' external_link ')]/../../..\"]]}","{\"selector\":\".FeedStory.feed_item > div > div\",\"tasks\":[[\"has-text\",\"/by Quora for Business/i\"]]}","{\"selector\":\".Toggle.SimpleToggle.ToggleAnswerFooterWrapper > div\",\"tasks\":[[\"has-text\",\"/Promoted/i\"]]}","{\"selector\":\".q-sticky\",\"tasks\":[[\"has-text\",\"Advertisement\"]]}"],["{\"selector\":\".main > div.container > h2\",\"tasks\":[[\"has-text\",\"Advertisement\"]]}"],["{\"selector\":\".adLinkBar\",\"tasks\":[[\"upward\",\"article[style=\\\"z-index: 1;\\\"]\"]]}","{\"selector\":\"[id^=\\\"t3\\\"].promotedlink\",\"tasks\":[[\"upward\",\".rpBJOHq2PR60pnwJlUyP0 > div\"]]}","{\"selector\":\"div[id*=\\\"sidebar\\\"][data-before-content=\\\"advertisement\\\"]\",\"tasks\":[[\"upward\",3]]}"],["{\"selector\":\"a.outbound[data-outbound-url]\",\"action\":[\"remove-attr\",\"data-outbound-url\"]}"],["{\"selector\":\"community-highlight-card[subreddit-prefixed-name=\\\"r/uBlockOrigin\\\"][src]\",\"action\":[\"remove-attr\",\"src\"]}"],["{\"selector\":\".items-center\",\"tasks\":[[\"has-text\",\"/^ad$/\"]]}","{\"selector\":\"[role=\\\"gridcell\\\"]\",\"tasks\":[[\"has-text\",\"/^AD$/\"]]}"],["{\"selector\":\"a[onclick^=\\\"trackURL\\\"]\",\"action\":[\"remove-attr\",\"onclick\"]}","{\"selector\":\"a[onmousedown^=\\\"return enc(this,'https://track.rediff.com\\\"]\",\"action\":[\"remove-attr\",\"onmousedown\"]}"],["{\"selector\":\"div > header + div > div + div\",\"tasks\":[[\"has-text\",\"Sponsors\"]]}"],["{\"selector\":\"#page-header\",\"action\":[\"style\",\"margin-bottom: -265px !important\"],\"tasks\":[[\"has\",{\"selector\":\"+ .phpbb-ads-center\",\"tasks\":[[\"matches-css\",{\"name\":\"height\",\"value\":\"^280px$\"}]]}]]}"],["{\"selector\":\"body > p > span\",\"tasks\":[[\"has-text\",\"adblock\"]]}"],["{\"selector\":\"html > body:not(.catalogsearch-result-index)\",\"tasks\":[[\"upward\",1],[\"spath\",\" > head > script\"],[\"has-text\",\"googletagmanager\"]]}"],["{\"selector\":\"div[id^=\\\"post-\\\"]\",\"action\":[\"remove-class\",\"hidden_share\"]}"],["{\"selector\":\"div[aria-labelledby=\\\"schedules-header\\\"] > div > div\",\"tasks\":[[\"has-text\",\"Ad\"]]}"],["{\"selector\":\"#main > div[class] > div div[class]\",\"tasks\":[[\"matches-css-before\",{\"name\":\"content\",\"pseudo\":\"before\",\"value\":\"^\\\"advertisement\\\"$\"}],[\"upward\",\"#main > div[class] > div\"]]}"],["{\"selector\":\"#wpsafe-wait1, #wpsafe-link\",\"tasks\":[[\"others\",\"\"]]}"],["{\"selector\":\"\",\"tasks\":[[\"xpath\",\"//span[(text()='Ad')]/../../..\"]]}"],["{\"selector\":\"center\",\"tasks\":[[\"has-text\",\"Advertisement\"]]}"],["{\"selector\":\"html:not(:has([class^=\\\"Dailymotion__Wrapper\\\"])) > head > script\",\"tasks\":[[\"has-text\",\"gptScript\"]]}"],["{\"selector\":\".ad-block-popup\",\"tasks\":[[\"upward\",2]]}","{\"selector\":\".native-ad-item-panel\",\"tasks\":[[\"upward\",\".vertical-view__item\"]]}"],["{\"selector\":\".marketplace-row\",\"tasks\":[[\"has-text\",\"Sponsored\"]]}"],["{\"selector\":\".suppress-rss\",\"tasks\":[[\"has\",{\"selector\":\"\",\"tasks\":[[\"has-text\",\"Supported by\"]]}]]}"],["{\"selector\":\"div[class^=\\\"css-\\\"]\",\"tasks\":[[\"has\",{\"selector\":\"> a\",\"tasks\":[[\"has\",{\"selector\":\"span\",\"tasks\":[[\"has-text\",\"Sponsored\"]]}]]}]]}"],["{\"selector\":\"#yuidea-snp, #btn6, #yuidea, #countdown\",\"tasks\":[[\"others\",\"\"]]}","{\"selector\":\"#yuidea-snp, #btn6, center, [src*=\\\"google.com/recaptcha\\\"]\",\"tasks\":[[\"others\",\"\"]]}"],["{\"selector\":\"script[language=\\\"javascript\\\"]\",\"tasks\":[[\"has-text\",\"open\"]]}"],["{\"selector\":\"div.swiper-slide\",\"tasks\":[[\"has-text\",\"Sponsored\"]]}","{\"selector\":\"li[class$=\\\"eBAnBw\\\"]\",\"tasks\":[[\"has-text\",\"Sponsored\"]]}","{\"selector\":\"li[class]\",\"tasks\":[[\"has-text\",\"Sponsored\"]]}"],["{\"selector\":\"#index-games\",\"tasks\":[[\"upward\",\"html\"],[\"spath\",\" > head > script\"],[\"has-text\",\"wgplayer\"]]}"],["{\"selector\":\".ssm_adunit_container\",\"tasks\":[[\"upward\",\"[id^=\\\"list_ads\\\"]\"]]}"],["{\"selector\":\".widget .adsSidebarContainer\",\"tasks\":[[\"upward\",\".widget\"]]}"],["{\"selector\":\".tweet-card .v-responsive.media-carousel-image .v-responsive__content img[alt]\",\"tasks\":[[\"not\",{\"selector\":\"\",\"tasks\":[[\"matches-attr\",{\"attr\":\"alt\",\"value\":\"/.*\\\\shttps:\\\\/\\\\/t\\\\.co\\\\/[\\\\w]{10}$/\"}]]}],[\"upward\",\".tweet-card\"]]}"],["{\"selector\":\".adsbygoogle\",\"tasks\":[[\"upward\",\".row-container\"]]}"],["{\"selector\":\".dfp-ad-unit\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\"li.product-wrapper\",\"tasks\":[[\"has\",{\"selector\":\"span\",\"tasks\":[[\"has-text\",\"Sponsored\"]]}]]}"],["{\"selector\":\".section-advert-banner--top\",\"action\":[\"remove\",\"\"]}"],["{\"selector\":\".is-visible\",\"tasks\":[[\"has-text\",\"Remove ads\"]]}"],["{\"selector\":\".content\",\"tasks\":[[\"has\",{\"selector\":\"> div\",\"tasks\":[[\"has-text\",\"Branded Content\"]]}]]}"],["{\"selector\":\".OUTBRAIN\",\"tasks\":[[\"upward\",2]]}"],["{\"selector\":\"#file\",\"action\":[\"remove-attr\",\"disabled\"]}","{\"selector\":\"#file\",\"tasks\":[[\"others\",\"\"]]}"],["{\"selector\":\"#my-btn, #my-btn2\",\"tasks\":[[\"others\",\"\"]]}"],["{\"selector\":\".a11t--product\",\"action\":[\"remove\",\"\"]}"],["{\"selector\":\"div > ins\",\"tasks\":[[\"upward\",\"div\"]]}"],["{\"selector\":\"[href*=\\\"sjv.io\\\"]\",\"action\":[\"remove\",\"\"]}"],["{\"selector\":\".ProductRecsLink-sc-4mw94v-0\",\"tasks\":[[\"has\",{\"selector\":\"p\",\"tasks\":[[\"has-text\",\"sponsored\"]]}]]}","{\"selector\":\"div[data-test=\\\"@web/ProductCard/ProductCardVariantAisle\\\"]\",\"tasks\":[[\"has-text\",\"Sponsored\"]]}","{\"selector\":\"div[data-test=\\\"@web/site-top-of-funnel/ProductCardWrapper\\\"]\",\"tasks\":[[\"has-text\",\"sponsored\"]]}"],["{\"selector\":\"[href=\\\"/category/taxi-fares/\\\"]\",\"tasks\":[[\"upward\",\".thumb\"]]}"],["{\"selector\":\"script\",\"tasks\":[[\"has-text\",\"numberPages\"]]}"],["{\"selector\":\"#link, #btn6, #yuidea-snp\",\"action\":[\"remove-attr\",\"disabled\"]}"],["{\"selector\":\"div[class] > p\",\"tasks\":[[\"has-text\",\"Advertisements\"]]}"],["{\"selector\":\"#customad\",\"tasks\":[[\"upward\",\".code-block\"]]}","{\"selector\":\".brxe-div > div[class=\\\"brxe-container\\\"] .adsbygoogle\",\"tasks\":[[\"upward\",\".brxe-container\"]]}","{\"selector\":\"section.brxe-section > div[class=\\\"brxe-container\\\"] .adsbygoogle\",\"tasks\":[[\"upward\",\"section\"]]}"],["{\"selector\":\"#wpsafe-time\",\"tasks\":[[\"upward\",\"[id^=\\\"wpsafe-wait\\\"]\"]]}"],["{\"selector\":\".get-link\",\"action\":[\"remove-attr\",\"disabled\"]}","{\"selector\":\".get-link\",\"action\":[\"remove-class\",\"disabled\"]}"],["{\"selector\":\".quads-location, .pro_btn\",\"tasks\":[[\"others\",\"\"]]}","{\"selector\":\"script\",\"tasks\":[[\"has-text\",\"/AdbModel|showPopup/\"]]}"],["{\"selector\":\"table\",\"tasks\":[[\"has\",{\"selector\":\"> tbody > tr > td > a\",\"tasks\":[[\"has-text\",\"Advertisements\"]]}]]}"],["{\"selector\":\".article-body > div\",\"tasks\":[[\"has-text\",\"[Advertisement]\"]]}"],["{\"selector\":\"#nn_bfa_wrapper\",\"action\":[\"remove\",\"\"]}","{\"selector\":\".sticky_rail600\",\"action\":[\"remove\",\"\"]}"],["{\"selector\":\"a[href^=\\\"https://thehackernews.uk/\\\"]\",\"tasks\":[[\"matches-attr\",{\"attr\":\"href\",\"value\":\"/https:\\\\/\\\\/thehackernews\\\\.uk\\\\/[a-zA-Z0-9]{4,}/\"}],[\"spath\",\":not([href*=\\\"-\\\"]):not([class*=\\\"button\\\"]):not([class*=\\\"latest\\\"])\"]]}"],["{\"selector\":\".tjp-single__content-ads\",\"action\":[\"remove\",\"\"]}"],["{\"selector\":\".loadingLI\",\"tasks\":[[\"upward\",\".tncms-block\"]]}"],["{\"selector\":\"html > head > script\",\"tasks\":[[\"has-text\",\"connatix.id\"],[\"upward\",1],[\"spath\",\" > script\"],[\"has-text\",\"window.cnx\"]]}"],["{\"selector\":\"#btm-widget img[onload]\",\"tasks\":[[\"upward\",\"#btm-widget > .colombiaonesuccess > div\"]]}"],["{\"selector\":\".entry-content > div > strong\",\"tasks\":[[\"has-text\",\"find & fix Windows error\"]]}"],["{\"selector\":\".brand_ctn\",\"tasks\":[[\"has-text\",\"/Ad:/\"],[\"xpath\",\"../..\"]]}","{\"selector\":\"p\",\"tasks\":[[\"has-text\",\"/Ad:/\"],[\"xpath\",\"../../..\"]]}","{\"selector\":\"span\",\"tasks\":[[\"has-text\",\"/Ad:/\"],[\"xpath\",\"../..\"]]}"],["{\"selector\":\"#vidPlayer span\",\"tasks\":[[\"has-text\",\"Advertisement\"]]}"],["{\"selector\":\"tbody\",\"tasks\":[[\"has-text\",\"Please visit our below advertisers\"]]}"],["{\"selector\":\"[style*=\\\"desktop-url\\\"]\",\"action\":[\"remove\",\"\"]}"],["{\"selector\":\"#tp98, #btn6, #tp-snp2\",\"tasks\":[[\"others\",\"\"]]}","{\"selector\":\"#tp98[disabled]\",\"action\":[\"remove-attr\",\"disabled\"]}"],["{\"selector\":\".AaFRW\",\"tasks\":[[\"has-text\",\"Sponsored\"]]}","{\"selector\":\".cAWGu\",\"tasks\":[[\"has\",{\"selector\":\"a\",\"tasks\":[[\"has-text\",\"Similar Sponsored Properties\"]]}]]}","{\"selector\":\".tkvEM\",\"tasks\":[[\"has-text\",\"Sponsored\"]]}","{\"selector\":\"[data-automation=\\\"crossSellShelf\\\"] div\",\"tasks\":[[\"has\",{\"selector\":\"> span\",\"tasks\":[[\"has-text\",\"Sponsored\"]]}]]}","{\"selector\":\"[data-automation=\\\"relatedStories\\\"] div > div\",\"tasks\":[[\"has\",{\"selector\":\"a\",\"tasks\":[[\"has-text\",\"SPONSORED\"]]}]]}"],["{\"selector\":\"script\",\"tasks\":[[\"has-text\",\"isIframeNetworking\"]]}"],["{\"selector\":\"header[role=\\\"banner\\\"] > div > a[href=\\\"/docs/en/relevantads\\\"]\",\"tasks\":[[\"upward\",3]]}"],["{\"selector\":\"body[data-scroll-locked]\",\"action\":[\"remove-attr\",\"data-scroll-locked\"]}"],["{\"selector\":\"[data-testid=\\\"trend\\\"]\",\"tasks\":[[\"has-text\",\"/Promoted|Gesponsert|Promocionado|Patrocinat|Sponsorisé|Sponsorizzato|Promowane|Promovido|Реклама|Uitgelicht|Sponsorlu|Promotert|Promoveret|Sponsrad|Mainostettu|Sponzorováno|Promovat|Ajánlott|Προωθημένο|Dipromosikan|Được quảng bá|推廣|推广|推薦|推荐|プロモーション|프로모션|ประชาสัมพันธ์|प्रचारित|বিজ্ঞাপিত|تشہیر شدہ|مُروَّج|تبلیغی|מקודם/\"],[\"upward\",1]]}","{\"selector\":\"div[style^=\\\"transform\\\"] h2 > div[style^=\\\"-webkit-line-clamp\\\"] > span\",\"tasks\":[[\"has-text\",\"/^(?:Promoted Post|Promowany Post|Post promovat|プロモポスト)$/\"],[\"upward\",3]]}"],["{\"selector\":\"[data-testid=\\\"primaryColumn\\\"] [data-testid=\\\"cellInnerDiv\\\"] > div:has([data-testid$=\\\"-impression-pixel\\\"])\",\"action\":[\"remove\",\"\"]}","{\"selector\":\"h2[role=\\\"heading\\\"]\",\"tasks\":[[\"has-text\",\"/Promoted|Gesponsert|Promocionado|Sponsorisé|Sponsorizzato|Promowane|Promovido|Реклама|Uitgelicht|Sponsorlu|Promotert|Promoveret|Sponsrad|Mainostettu|Sponzorováno|Promovat|Ajánlott|Προωθημένο|Dipromosikan|Được quảng bá|推廣|推广|推薦|推荐|プロモーション|프로모션|ประชาสมพนธ|परचरत|বজঞপত|تشہیر شدہ|مروج|تبلیغی|מקודם/\"]]}"],["{\"selector\":\"li.ProductListingResults__productCard\",\"tasks\":[[\"has\",{\"selector\":\".ProductCard__badge\",\"tasks\":[[\"has-text\",\"Sponsored\"]]}]]}"],["{\"selector\":\"div[style^=\\\"--row-gutter\\\"] > div a[href=\\\"/brands\\\"]\",\"tasks\":[[\"upward\",\"div[style^=\\\"--row-gutter\\\"] > div\"]]}"],["{\"selector\":\"h5\",\"tasks\":[[\"has-text\",\"Advertisement\"]]}"],["{\"selector\":\"script\",\"tasks\":[[\"has-text\",\"/iframe|setTimeout|0x/\"]]}"],["{\"selector\":\"html > head > link[rel=\\\"canonical\\\"]:not([href*=\\\"/video/\\\"])\",\"tasks\":[[\"upward\",1],[\"spath\",\" > script[src*=\\\"connatix\\\"]\"]]}"],["{\"selector\":\".text-primary.inline-block, button.text-primary\",\"tasks\":[[\"others\",\"\"]]}"],["{\"selector\":\"script\",\"tasks\":[[\"has-text\",\"popMagic\"]]}"],["{\"selector\":\".base-asset-video\",\"action\":[\"remove-class\",\"base-asset-video\"]}"],["{\"selector\":\"div[id] *\",\"tasks\":[[\"has\",{\"selector\":\"> a[href]\",\"tasks\":[[\"has-text\",\"/^Try (?:D.?V.?D.?F.?a.?b|StreamFab)/\"],[\"spath\",\" + a[href]\"]]}]]}"],["{\"selector\":\".ads-between-post\",\"tasks\":[[\"upward\",\".post-item\"]]}"],["{\"selector\":\"[data-stack-index] > section > div > div [data-item-id] > a[link-identifier][href^=\\\"https://wrd.walmart.com\\\"]\",\"tasks\":[[\"upward\",\"section > div > div\"]]}"],["{\"selector\":\".widget a.gofollow\",\"tasks\":[[\"upward\",\".widget\"]]}"],["{\"selector\":\"\",\"tasks\":[[\"xpath\",\"//*[(text()=\\\"AD\\\")]/..\"]]}","{\"selector\":\".w-100\",\"tasks\":[[\"has-text\",\"Advertisement\"]]}","{\"selector\":\"section > div\",\"tasks\":[[\"has-text\",\"/^AD$/\"]]}"],["{\"selector\":\".entry.card div:is(#sidead, .topad)\",\"tasks\":[[\"upward\",\".entry.card\"]]}"],["{\"selector\":\"button\",\"tasks\":[[\"has\",{\"selector\":\"> div > div > div > span\",\"tasks\":[[\"has-text\",\"Sponsored\"]]}]]}","{\"selector\":\"div\",\"tasks\":[[\"has\",{\"selector\":\"> div > div > div > div > div > p\",\"tasks\":[[\"has-text\",\"Sponsored\"]]}]]}"],["{\"selector\":\"body > div[style]\",\"tasks\":[[\"has-text\",\"Ads\"]]}"],["{\"selector\":\".ad-body\",\"action\":[\"remove\",\"\"]}","{\"selector\":\".nvheader > span\",\"tasks\":[[\"has-text\",\"Advertisement\"]]}"],["{\"selector\":\"script\",\"tasks\":[[\"has-text\",\"l.parentNode.insertBefore(s, l);\"]]}"],["{\"selector\":\".img_box\",\"tasks\":[[\"has-text\",\"Anzeige\"]]}","{\"selector\":\"aside ins\",\"tasks\":[[\"upward\",\"aside\"]]}"],["{\"selector\":\"#asg-inplayer-block\",\"tasks\":[[\"upward\",4]]}"],["{\"selector\":\"[href^=\\\"/plugout.php\\\"]\",\"tasks\":[[\"upward\",\"[class^=\\\"col-sm\\\"]\"]]}"],["{\"selector\":\"*\",\"tasks\":[[\"matches-css-after\",{\"name\":\"content\",\"pseudo\":\"after\",\"value\":[\"Advertisement\",\"i\"]}]]}"],["{\"selector\":\".leading-3\",\"tasks\":[[\"has-text\",\"Advertisement\"]]}"],["{\"selector\":\"div.mb-28\",\"tasks\":[[\"has\",{\"selector\":\"span\",\"tasks\":[[\"has-text\",\"Ads\"]]}]]}"],["{\"selector\":\"[width]\",\"tasks\":[[\"has-text\",\"ADVERTISEMENT\"]]}"],["{\"selector\":\".ytlr-horizontal-list-renderer__items > .yt-virtual-list__container > .yt-virtual-list__item--visible.yt-virtual-list__item--selected.yt-virtual-list__item\",\"tasks\":[[\"has-text\",\"Ad\"]]}"],["{\"selector\":\"script\",\"tasks\":[[\"has-text\",\"/'.adsbygoogle'|text-danger|warning|Adblock|_0x/\"]]}"],["{\"selector\":\"script\",\"tasks\":[[\"has-text\",\"Math\"]]}"],["{\"selector\":\".banner-wrapper\",\"action\":[\"remove\",\"\"],\"tasks\":[[\"upward\",2]]}","{\"selector\":\".sticky-content\",\"tasks\":[[\"has-text\",\"Rek\"]]}","{\"selector\":\".sticky-content\",\"tasks\":[[\"has-text\",\"Reklama\"]]}","{\"selector\":\".sticky-content\",\"tasks\":[[\"has-text\",\"klama\"]]}","{\"selector\":\"[data-draggable-target]\",\"tasks\":[[\"has-text\",\"Rekl\"],[\"spath\",\":not(*:has([href*=\\\"radio\\\"]))\"]]}"],["{\"selector\":\".branding\",\"tasks\":[[\"upward\",\"[target=\\\"_blank\\\"]\"]]}"],["{\"selector\":\".b-main__section\",\"tasks\":[[\"has\",{\"selector\":\"h2.homepage-headline\",\"tasks\":[[\"has-text\",\"Advertisement\"]]}]]}"],["{\"selector\":\"div\",\"tasks\":[[\"matches-css-before\",{\"name\":\"content\",\"pseudo\":\"before\",\"value\":[\"Anzeige\",\"i\"]}]]}"],["{\"selector\":\".elementor-row\",\"tasks\":[[\"has-text\",\"[Anzeige]\"]]}"],["{\"selector\":\"script\",\"tasks\":[[\"has-text\",\"/pushAdTag|link_click|getAds/\"]]}"],["{\"selector\":\"#dlcharts-list + div[class]\",\"tasks\":[[\"has\",{\"selector\":\"> h2\",\"tasks\":[[\"has-text\",\"/Gesponsert|Bezahlte Empfehlung/\"],[\"spath\",\" + a[href^=\\\"https://www.chip.de/downloads/\\\"]\"]]}]]}","{\"selector\":\".fb > .Listing > div\",\"tasks\":[[\"has\",{\"selector\":\"> h2\",\"tasks\":[[\"has-text\",\"/Gesponsert|Bezahlte Empfehlung/\"],[\"spath\",\" + a[href^=\\\"https://www.chip.de/downloads/\\\"]\"]]}]]}"],["{\"selector\":\"noscript\",\"action\":[\"remove\",\"\"],\"tasks\":[[\"has-text\",\"Adblocker\"]]}"],["{\"selector\":\"[id^=\\\"desig-\\\"]\",\"tasks\":[[\"has-text\",\"ANZEIGE\"]]}"],["{\"selector\":\".swiper-slide [data-testid=\\\"topStories-cardSlider-ad\\\"]\",\"tasks\":[[\"upward\",\".swiper-slide\"]]}"],["{\"selector\":\".clearfix.branding > .surftipp\",\"tasks\":[[\"has-text\",\"Anzeige\"]]}"],["{\"selector\":\".ad-loading\",\"action\":[\"remove\",\"\"]}"],["{\"selector\":\".list-articles > li\",\"tasks\":[[\"has\",{\"selector\":\".icon-addy\",\"tasks\":[[\"matches-css-before\",{\"name\":\"content\",\"pseudo\":\"before\",\"value\":\"^\\\"Anzeige\\\"$\"}]]}]]}","{\"selector\":\".sp-article\",\"tasks\":[[\"has\",{\"selector\":\"span\",\"tasks\":[[\"matches-css-before\",{\"name\":\"content\",\"pseudo\":\"before\",\"value\":[\"Anzeige\",\"i\"]}]]}]]}","{\"selector\":\"[data-article-id]\",\"tasks\":[[\"has\",{\"selector\":\"[class]\",\"tasks\":[[\"matches-css-before\",{\"name\":\"content\",\"pseudo\":\"before\",\"value\":\"ANZEIGE\"}]]}]]}"],["{\"selector\":\"script\",\"tasks\":[[\"has-text\",\"===\"],[\"has-text\",\"/[\\\\w\\\\W]{14000}/\"]]}"],["{\"selector\":\"#ad-Billboard\",\"tasks\":[[\"upward\",\"[style]\"]]}"],["{\"selector\":\"[class*=\\\"superbanner\\\"]\",\"tasks\":[[\"upward\",\"article > div:not(#main)\"]]}"],["{\"selector\":\"script\",\"tasks\":[[\"has-text\",\"homad\"]]}"],["{\"selector\":\"strong\",\"tasks\":[[\"has-text\",\"/anzeige/i\"]]}"],["{\"selector\":\"script\",\"tasks\":[[\"has-text\",\",window\\\\);\"]]}","{\"selector\":\"script\",\"tasks\":[[\"has-text\",\"toscr\\\\'\"]]}","{\"selector\":\"script\",\"tasks\":[[\"has-text\",\"}(window);\"]]}"],["{\"selector\":\".iba-acceptable\",\"tasks\":[[\"has-text\",\"/Anzeige|Info/\"]]}"],["{\"selector\":\"div[id][style^=\\\"z-index: 2\\\"][style*=\\\"margin\\\"][style*=\\\"auto\\\"][style*=\\\"top\\\"][style$=\\\"px; position: absolute;\\\"]\",\"action\":[\"remove\",\"\"]}"],["{\"selector\":\"[id^=\\\"outbrain_widget_\\\"].OUTBRAIN[data-src]\",\"tasks\":[[\"has\",{\"selector\":\"> .ob-widget > .ob-widget-header > span.ob-grid-header-text\",\"tasks\":[[\"has-text\",\"/^MEHR AUS DEM WEB|MEHR AUS DEM NETZ|AUCH INTERESSANT$/\"]]}]]}"],["{\"selector\":\"article\",\"tasks\":[[\"has-text\",\"Promoted\"]]}"],["{\"selector\":\"style[id$=\\\"-css\\\"]\",\"action\":[\"remove\",\"\"]}"],["{\"selector\":\"script\",\"tasks\":[[\"has-text\",\"detectAdblockWithInvalidURL\"]]}"],["{\"selector\":\".channel-feed__brick .cfeed-card-contents--banner-adsense\",\"tasks\":[[\"upward\",\".channel-feed__brick\"]]}"],["{\"selector\":\".body--onPlayer--ads\",\"action\":[\"remove-class\",\"body--onPlayer--ads\"]}"],["{\"selector\":\"\",\"tasks\":[[\"xpath\",\"//*[string-length(@href) > 1600]\"]]}"],["{\"selector\":\"style\",\"action\":[\"remove\",\"\"],\"tasks\":[[\"has-text\",\"/background\\\\: url\\\\(https/\"]]}","{\"selector\":\"style\",\"action\":[\"remove\",\"\"],\"tasks\":[[\"has-text\",\"background-image:\"]]}"],["{\"selector\":\"style\",\"action\":[\"remove\",\"\"],\"tasks\":[[\"has-text\",\"::before\"]]}"],["{\"selector\":\".relacionados .aawp\",\"tasks\":[[\"upward\",\".relacionados\"]]}"],["{\"selector\":\"[class]\",\"tasks\":[[\"matches-css-before\",{\"name\":\"content\",\"pseudo\":\"before\",\"value\":\"ads\"}]]}"],["{\"selector\":\"[id^=\\\"div-gpt-ad\\\"]:not([class])\",\"tasks\":[[\"upward\",\"div[class]\"]]}"],["{\"selector\":\"a[href^=\\\"/out/\\\"]\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\"#taboola-alternating-below-article\",\"action\":[\"remove\",\"\"]}","{\"selector\":\".banner-min-height\",\"action\":[\"remove\",\"\"]}","{\"selector\":\".fixed.social-bar\",\"action\":[\"remove\",\"\"]}","{\"selector\":\".mobile-banner-sticky-container\",\"action\":[\"remove\",\"\"]}"],["{\"selector\":\"#alt_content_main_div > p\",\"tasks\":[[\"has-text\",\"SpyHunter\"]]}","{\"selector\":\".entry-content > div\",\"tasks\":[[\"has-text\",\"Special Offer\"]]}"],["{\"selector\":\".fluid-close[target=\\\"_blank\\\"]\",\"action\":[\"remove-attr\",\"target\"]}","{\"selector\":\"script\",\"tasks\":[[\"has-text\",\"/popstate|popMagic/\"]]}"],["{\"selector\":\"#tp982, #btn6\",\"tasks\":[[\"others\",\"\"]]}"],["{\"selector\":\"#tp98, #jatinbtn-continue\",\"tasks\":[[\"others\",\"\"]]}"],["{\"selector\":\".article_content > [class] > [class]:has(.iframe_embed_container)\",\"action\":[\"remove\",\"\"]}"],["{\"selector\":\"#username[required]\",\"action\":[\"remove-attr\",\"required\"]}"],["{\"selector\":\"div[style] > ins\",\"tasks\":[[\"upward\",\"div\"]]}"],["{\"selector\":\"#player_img\",\"tasks\":[[\"upward\",2]]}"],["{\"selector\":\"#btn2, #btn5, #tp-snp2\",\"tasks\":[[\"others\",\"\"]]}"],["{\"selector\":\"#tp98, #tp-generate, #tp-snp2, [src*=\\\"https://www.google.com/recaptcha\\\"]\",\"tasks\":[[\"others\",\"\"]]}"],["{\"selector\":\"#rtg-snp2\",\"tasks\":[[\"others\",\"\"]]}"],["{\"selector\":\"#bottomNewButton, #bottomButton\",\"action\":[\"remove-attr\",\"disabled\"]}","{\"selector\":\".timer, .shrs_btn, .tag, .link-open-modal\",\"tasks\":[[\"others\",\"\"]]}"],["{\"selector\":\"#notarobot, #btn7\",\"tasks\":[[\"others\",\"\"]]}"],["{\"selector\":\".panel\",\"tasks\":[[\"has\",{\"selector\":\"h3\",\"tasks\":[[\"has-text\",\"Sponsored Ad\"]]}]]}"],["{\"selector\":\"script\",\"tasks\":[[\"has-text\",\"decodeURIComponent(escape(r))\"]]}"],["{\"selector\":\".text-center:not([id]) [id^=\\\"adngin-\\\"]\",\"tasks\":[[\"upward\",\".text-center:not([id])\"]]}"],["{\"selector\":\".thleft\",\"tasks\":[[\"has-text\",\"Fast\"],[\"upward\",2]]}"],["{\"selector\":\"a13\",\"tasks\":[[\"has-text\",\" Ad\"]]}"],["{\"selector\":\"style\",\"action\":[\"remove\",\"\"],\"tasks\":[[\"has-text\",\".reading-content img\"]]}"],["{\"selector\":\"div[tabindex] > button\",\"tasks\":[[\"has-text\",\"Buy $\"]]}"],["{\"selector\":\".form-group center\",\"tasks\":[[\"has-text\",\"Advertisement\"]]}"],["{\"selector\":\"\",\"action\":[\"remove\",\"\"],\"tasks\":[[\"matches-path\",\"/utm_medium=Banner/i\"],[\"spath\",\" html\"]]}"],["{\"selector\":\"\",\"action\":[\"remove\",\"\"],\"tasks\":[[\"matches-path\",\"/utm_source=footer/i\"],[\"spath\",\" html\"]]}"],["{\"selector\":\"html\",\"action\":[\"remove\",\"\"]}"],["{\"selector\":\".active.dimmer.ui\",\"tasks\":[[\"has-text\",\"/Wait|Skip/i\"]]}"],["{\"selector\":\".banner\",\"action\":[\"remove\",\"\"]}","{\"selector\":\"[id^=\\\"ad\\\"]\",\"action\":[\"remove\",\"\"]}"],["{\"selector\":\"#gads[disabled]\",\"action\":[\"remove-attr\",\"disabled\"]}"],["{\"selector\":\"[id^=\\\"google_ads_iframe\\\"]\",\"action\":[\"remove\",\"\"]}"],["{\"selector\":\"script\",\"tasks\":[[\"has-text\",\"KeenTracking\"]]}"],["{\"selector\":\".nav ~ div[id] + div[id][class][style]\",\"action\":[\"remove\",\"\"]}","{\"selector\":\".nav ~ div[id][class]:has(+ div[id]:not(#chapters))\",\"action\":[\"remove-attr\",\"class\"]}","{\"selector\":\".w-100 > [class]:has(+ div[id])\",\"action\":[\"remove\",\"\"]}"],["{\"selector\":\"\",\"tasks\":[[\"matches-path\",\"/^\\\\/($|abss\\\\/)/\"],[\"spath\",\" .postContent a[href^=\\\"/\\\"]:not([href*=\\\"/forum/\\\"])\"],[\"matches-attr\",{\"attr\":\"href\",\"value\":\"/^\\\\/[-a-z]+\\\\?[a-z]{2,}=/\"}]]}","{\"selector\":\"\",\"tasks\":[[\"matches-path\",\"/^\\\\/($|abss\\\\/)/\"],[\"spath\",\" a:is([href^=\\\"/\\\"], [href*=\\\"audiobookbay.lu/\\\"])\"],[\"matches-attr\",{\"attr\":\"href\",\"value\":\"/(^|audiobookbay\\\\.lu)\\\\/[-a-z0-9]+$/\"}],[\"spath\",\" img\"]]}"],["{\"selector\":\"[id]\",\"tasks\":[[\"has-text\",\"Provider\"]]}"],["{\"selector\":\"#alf_continue_captcha\",\"action\":[\"remove-attr\",\"disabled\"]}"],["{\"selector\":\".is-full .climad-badge\",\"tasks\":[[\"upward\",\".is-full\"]]}"],["{\"selector\":\"center\",\"tasks\":[[\"has-text\",\"sponsored\"]]}"],["{\"selector\":\"main > h2:nth-of-type(1)\",\"tasks\":[[\"has-text\",\"Sponsored\"]]}"],["{\"selector\":\".container > [class]\",\"tasks\":[[\"has-text\",\"VPN\"]]}","{\"selector\":\".title ~ a[href] .button\",\"tasks\":[[\"upward\",\".container > div\"]]}","{\"selector\":\"script\",\"tasks\":[[\"has-text\",\"document.write\"]]}"],["{\"selector\":\"a.extern[href^=\\\"//www.amazon.de/\\\"]\",\"tasks\":[[\"upward\",2]]}"],["{\"selector\":\"span.text-secondary\",\"tasks\":[[\"has-text\",\"Advertisement\"]]}"],["{\"selector\":\".modal_dialog_base\",\"tasks\":[[\"has\",{\"selector\":\"> .modal_top_header\",\"tasks\":[[\"has-text\",\"Marketing\"]]}]]}","{\"selector\":\"table\",\"tasks\":[[\"has\",{\"selector\":\"> thead > .collapsableSection > td\",\"tasks\":[[\"has-text\",\"Ads\"]]}]]}"],["{\"selector\":\"\",\"tasks\":[[\"xpath\",\"//*[contains(text(),\\\"Werbung\\\")]\"],[\"spath\",\" + [class]\"]]}"],["{\"selector\":\".moduleContent\",\"tasks\":[[\"has-text\",\"Advertisement\"]]}"],["{\"selector\":\".money\",\"tasks\":[[\"has\",{\"selector\":\".century\",\"tasks\":[[\"has-text\",\"ADS\"]]}]]}"],["{\"selector\":\"div[class=\\\"alert alert-danger alert-dismissible fade show m-0 p-0\\\"]\",\"tasks\":[[\"has-text\",\"uBlock Origin\"]]}"],["{\"selector\":\"script\",\"tasks\":[[\"has-text\",\"liedetector\"]]}"],["{\"selector\":\"script\",\"tasks\":[[\"has-text\",\"doOpen\"]]}"],["{\"selector\":\"html[data-orlock-url]\",\"action\":[\"remove-attr\",\"data-orlock-url\"]}"],["{\"selector\":\".kecil\",\"tasks\":[[\"others\",\"\"]]}"],["{\"selector\":\".row\",\"tasks\":[[\"has-text\",\"Advertisement\"]]}"],["{\"selector\":\".widget-title\",\"tasks\":[[\"has-text\",\"Adv\"]]}"],["{\"selector\":\"a img:not([src=\\\"images/main_logo_inverted.png\\\"])\",\"action\":[\"style\",\"visibility: hidden !important;\"],\"tasks\":[[\"matches-css\",{\"name\":\"height\",\"value\":\"^([2-4]{1}[0-9]{2}(\\\\.[0-9]+)?px|0px)$\"}]]}"],["{\"selector\":\"[data-koukoku-width]\",\"action\":[\"remove\",\"\"]}"],["{\"selector\":\"table > tbody > tr\",\"tasks\":[[\"has-text\",\"Advertisement\"]]}"],["{\"selector\":\".ipsColumns_collapsePhone.classes\",\"tasks\":[[\"has-text\",\"Our Sponsors\"]]}"],["{\"selector\":\"script[src$=\\\"ads.js\\\"]\",\"tasks\":[[\"upward\",\"section[id]\"]]}"],["{\"selector\":\".selected\",\"tasks\":[[\"has-text\",\"Ads\"]]}"],["{\"selector\":\"div[class^=\\\"sc-\\\"] > div[class^=\\\"sc-\\\"]:has(> div[style*=\\\"width: 728px;\\\"]:only-child > iframe[name=\\\"footer\\\"][width=\\\"728\\\"][height=\\\"90\\\"])\",\"tasks\":[[\"matches-css\",{\"name\":\"padding-bottom\",\"value\":\"^56px$\"}]]}","{\"selector\":\"iframe[name=\\\"dashboard_home\\\"]\",\"tasks\":[[\"upward\",\"div[class^=\\\"sc-\\\"][span=\\\"1\\\"]\"]]}","{\"selector\":\"section > div[class^=\\\"sc-\\\"]:last-child:has(> div[style*=\\\"width: 728px;\\\"]:only-child > iframe[name=\\\"footer\\\"][width=\\\"728\\\"][height=\\\"90\\\"])\",\"tasks\":[[\"matches-css\",{\"name\":\"margin-bottom\",\"value\":\"^-16px$\"}]]}"],["{\"selector\":\"a.box-title\",\"tasks\":[[\"has-text\",\"Ads\"]]}"],["{\"selector\":\"#link\",\"action\":[\"remove-attr\",\"disabled\"]}"],["{\"selector\":\".widget_text\",\"tasks\":[[\"has-text\",\"Advertisement\"]]}"],["{\"selector\":\"script\",\"tasks\":[[\"has-text\",\"BetterJsPop.add\"]]}"],["{\"selector\":\".downloadbtn\",\"action\":[\"remove-attr\",\"disabled\"]}"],["{\"selector\":\"script\",\"tasks\":[[\"has-text\",\"/ConsoleBan|alert|AdBlocker/\"]]}"],["{\"selector\":\"script\",\"tasks\":[[\"has-text\",\"ai_adb\"]]}"],["{\"selector\":\"article\",\"tasks\":[[\"has\",{\"selector\":\"header:has(.ct-sponsored)\"}]]}"],["{\"selector\":\"script\",\"tasks\":[[\"has-text\",\"popUnder\"]]}"],["{\"selector\":\"\",\"action\":[\"style\",\"background: none !important;\"],\"tasks\":[[\"not\",{\"selector\":\"\",\"tasks\":[[\"matches-path\",\"/amafav/\"]]}],[\"spath\",\" .image_box[style*=\\\"amazon.co\\\"]\"]]}","{\"selector\":\"\",\"tasks\":[[\"not\",{\"selector\":\"\",\"tasks\":[[\"matches-path\",\"/amafav/\"]]}],[\"spath\",\" a[href^=\\\"https://www.amazon.co.jp\\\"][target=\\\"_blank\\\"]\"]]}"],["{\"selector\":\".jeg_postblock\",\"tasks\":[[\"has-text\",\"SPONSORED\"]]}"],["{\"selector\":\".wpsafe-top > div > center\",\"tasks\":[[\"has-text\",\"Advertisements\"]]}"],["{\"selector\":\"div.product-tile\",\"tasks\":[[\"has\",{\"selector\":\"span\",\"tasks\":[[\"has-text\",\"Sponsored\"]]}]]}"],["{\"selector\":\"div[id^=\\\"imCell_\\\"][class=\\\"\\\"]\",\"tasks\":[[\"has-text\",\"/Advertisement/i\"]]}"],["{\"selector\":\".les-title\",\"tasks\":[[\"has-text\",\"Sponsor\"]]}","{\"selector\":\".selected\",\"tasks\":[[\"has-text\",\"Sponsor\"]]}"],["{\"selector\":\"#tp-snp2, #cross-snp2\",\"tasks\":[[\"others\",\"\"]]}"],["{\"selector\":\"h1\",\"tasks\":[[\"has-text\",\"/adblock|supporter/\"]]}"],["{\"selector\":\"#yuidea-btn-after, #yuidea-btmbtn\",\"action\":[\"remove-attr\",\"disabled\"]}","{\"selector\":\"#yuidea-btn-after, #yuidea-btmbtn\",\"tasks\":[[\"others\",\"\"]]}"],["{\"selector\":\"[target=\\\"_blank\\\"][style]\",\"tasks\":[[\"upward\",\"[style]\"]]}"],["{\"selector\":\"\",\"tasks\":[[\"xpath\",\"//span[contains(text(),\\\"Advert\\\")]/../..\"]]}","{\"selector\":\"td\",\"tasks\":[[\"has\",{\"selector\":\"> span[class]\",\"tasks\":[[\"has-text\",\"Advert\"]]}]]}"],["{\"selector\":\"center > ins\",\"tasks\":[[\"upward\",\"center\"]]}"],["{\"selector\":\"div[class*=\\\"better-ads-listitemad\\\"]\",\"action\":[\"remove\",\"\"]}"],["{\"selector\":\".widget\",\"tasks\":[[\"has-text\",\"Adv\"]]}"],["{\"selector\":\"[href*=\\\"3cx\\\"]\",\"tasks\":[[\"upward\",\"tbody\"]]}"],["{\"selector\":\".widget-title\",\"tasks\":[[\"has-text\",\"AD\"]]}"],["{\"selector\":\"\",\"action\":[\"remove\",\"\"],\"tasks\":[[\"matches-path\",\"/utm_medium=banner-kaprila/i\"],[\"spath\",\" html\"]]}"],["{\"selector\":\"[href^=\\\"/click\\\"]\",\"action\":[\"remove-attr\",\"href\"]}","{\"selector\":\"div[id$=\\\"_frame_content\\\"][class=\\\"wide_boxcontent\\\"]\",\"tasks\":[[\"has-text\",\"Adblock\"]]}"],["{\"selector\":\".leftCol > div [data-link-tracking-page=\\\"Widget\\\"]\",\"tasks\":[[\"upward\",\".leftCol > div\"]]}","{\"selector\":\"a\",\"tasks\":[[\"matches-attr\",{\"attr\":\"href\",\"value\":\"/[a-zA-Z0-9]{100,}/\"}]]}"],["{\"selector\":\"script[data-cfasync]\",\"tasks\":[[\"has-text\",\"D4zz.\"]]}"],["{\"selector\":\".result:has(.result-open-metagerkey)\",\"action\":[\"remove\",\"\"]}"],["{\"selector\":\"*\",\"action\":[\"remove-class\",\"/[a-z]{30,}/\"]}","{\"selector\":\"style\",\"tasks\":[[\"has-text\",\"adbl\"]]}"],["{\"selector\":\".row\",\"tasks\":[[\"has-text\",\"Promotion Bot\"]]}"],["{\"selector\":\".cp-modal-popup-container\",\"action\":[\"remove\",\"\"]}"],["{\"selector\":\".wide_boxcontent\",\"tasks\":[[\"has-text\",\"/adb/i\"]]}"],["{\"selector\":\".container > .adsbygoogle\",\"tasks\":[[\"upward\",\".container\"]]}","{\"selector\":\".container > div > .adsbygoogle\",\"tasks\":[[\"upward\",\"div\"]]}"],["{\"selector\":\".cmplz-blocked-content-container\",\"action\":[\"remove-class\",\"cmplz-blocked-content-container\"]}"],["{\"selector\":\"a.button-link.mybutton\",\"tasks\":[[\"has-text\",\"Play\"]]}"],["{\"selector\":\"li\",\"tasks\":[[\"has\",{\"selector\":\".viewLink\",\"tasks\":[[\"has-text\",\"AD |\"]]}]]}"],["{\"selector\":\".ipsSideBlock.clearfix\",\"tasks\":[[\"has-text\",\"Affiliates\"]]}"],["{\"selector\":\"body > [id][class] > [class]\",\"tasks\":[[\"matches-css\",{\"name\":\"z-index\",\"value\":\"^2147483[0-9]{3}$\"}]]}"],["{\"selector\":\"div[class]\",\"tasks\":[[\"has\",{\"selector\":\"> img[src] + div > style\",\"tasks\":[[\"has-text\",\"flex: 0 0 100%\"]]}]]}"],["{\"selector\":\"div[class*=\\\" \\\"]:has(> div:first-child > div:first-child:empty)\",\"tasks\":[[\"matches-css\",{\"name\":\"z-index\",\"value\":\"^0$\"}],[\"matches-css\",{\"name\":\"position\",\"value\":\"^relative$\"}]]}"],["{\"selector\":\"div[class]:has(> img[src] ~ div:empty)\",\"tasks\":[[\"matches-css\",{\"name\":\"z-index\",\"value\":\"^0$\"}],[\"matches-css\",{\"name\":\"position\",\"value\":\"^relative$\"}]]}"],["{\"selector\":\"*\",\"tasks\":[[\"has\",{\"selector\":\"> div:first-child:has(> div:first-child > a > img[src^=\\\"https://v.wpimg.pl/\\\"]):not([alt], [id], [width], [data-src]) + div:empty\"}]]}"],["{\"selector\":\"div\",\"tasks\":[[\"has\",{\"selector\":\"> div:first-child:has(> a:first-child > img[src^=\\\"https://v.wpimg.pl/\\\"]) + div:empty:last-child\"}]]}"],["{\"selector\":\"div[class]\",\"tasks\":[[\"has\",{\"selector\":\"> style:first-child\",\"tasks\":[[\"has-text\",\"flex: 0 0 100%\"],[\"spath\",\" + div > div > style:first-child\"],[\"has-text\",\"flex: 0 0 100%\"],[\"spath\",\" + div\"]]}],[\"spath\",\":not(:has([data-st-area^=\\\"czyt_dalej\\\"]))\"]]}"],["{\"selector\":\"style\",\"tasks\":[[\"has-text\",\"right:0;top:0;bottom:0;left:0;margin:auto;position:absolute;\"],[\"upward\",1]]}"],["{\"selector\":\"*\",\"tasks\":[[\"has\",{\"selector\":\"> .top-box-caption\",\"tasks\":[[\"has-text\",\"/REKLAMA|WERBUNG/\"],[\"spath\",\" + a\"]]}]]}"],["{\"selector\":\"div[class*=\\\" \\\"]:has(> div:empty)\",\"tasks\":[[\"matches-css\",{\"name\":\"z-index\",\"value\":\"^0$\"}],[\"matches-css\",{\"name\":\"position\",\"value\":\"^relative$\"}]]}"],["{\"selector\":\"div\",\"action\":[\"remove\",\"\"],\"tasks\":[[\"has\",{\"selector\":\"> a:first-child:has(> div:empty:only-child) + div:empty:last-child\"}]]}"],["{\"selector\":\"div > h6\",\"tasks\":[[\"has-text\",\"Oferty dla Ciebie\"]]}","{\"selector\":\"section > h2\",\"tasks\":[[\"has-text\",\"Oferty dla Ciebie:\"]]}"],["{\"selector\":\"#bottom-sticky-container > div\",\"tasks\":[[\"matches-attr\",{\"attr\":\"class\",\"value\":\"/^[a-zA-Z]{2}$/\"}],[\"spath\",\":not([id])\"]]}"],["{\"selector\":\"[onclick$=\\\"return !ga.loaded;\\\"]\",\"action\":[\"remove-attr\",\"onclick\"]}"],["{\"selector\":\"a[href=\\\"https://www.wp.pl\\\"][data-st-area=\\\"goToSG\\\"] + div\",\"tasks\":[[\"has\",{\"selector\":\"> div > div > div\",\"tasks\":[[\"has-text\",\"REKLAMA\"]]}]]}","{\"selector\":\"div\",\"tasks\":[[\"has\",{\"selector\":\"> div:first-child:has(> div:only-child > a > div:empty:only-child) + div:last-child:empty\"}]]}","{\"selector\":\"div\",\"tasks\":[[\"has\",{\"selector\":\"> div:first-child:has(> iframe:only-child) + div:last-child:empty\"}]]}"],["{\"selector\":\"div[class]\",\"tasks\":[[\"has\",{\"selector\":\"> img[src] + div + style\",\"tasks\":[[\"has-text\",\"flex: 0 0 100%\"]]}]]}"],["{\"selector\":\"div\",\"tasks\":[[\"has\",{\"selector\":\"> div:only-child > * > div > .border > .container > .labelCopy\",\"tasks\":[[\"has-text\",\"REKLAMA\"]]}]]}"],["{\"selector\":\"div[style=\\\"width: 100%;\\\"]\",\"tasks\":[[\"has\",{\"selector\":\"> div > div > div\",\"tasks\":[[\"has-text\",\"OFERTY DLA CIEBIE\"]]}]]}","{\"selector\":\"iframe[scrolling=\\\"no\\\"][src^=\\\"https://v.wpimg.pl/\\\"][frameborder=\\\"0\\\"]\",\"action\":[\"remove\",\"\"],\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\".g-recaptcha, iframe[src*=\\\"google.com/recaptcha\\\"], .btn-captcha, .btn-black-outline\",\"tasks\":[[\"others\",\"\"]]}"],["{\"selector\":\"#openLinks\",\"action\":[\"remove\",\"\"]}"],["{\"selector\":\"script\",\"tasks\":[[\"has-text\",\"adsBlocked\"]]}"],["{\"selector\":\"script\",\"tasks\":[[\"has-text\",\"chp_ads_blocker_detector\"]]}"],["{\"selector\":\"html:not(:has(#thegame)) > head > script\",\"tasks\":[[\"has-text\",\"wgplayer\"]]}"],["{\"selector\":\".sponsorship\",\"action\":[\"remove-class\",\"sponsorship\"]}"],["{\"selector\":\".shopee-header-section__content\",\"tasks\":[[\"has-text\",\"Ad\"]]}","{\"selector\":\".shopee-search-item-result__item\",\"tasks\":[[\"has-text\",\"Ad\"]]}"],["{\"selector\":\"script\",\"tasks\":[[\"has-text\",\"adb_detected\"]]}"],["{\"selector\":\"script\",\"tasks\":[[\"has-text\",\"/block-adb|-0x|ad block|alert/\"]]}"],["{\"selector\":\"[src^=\\\"blob:https://autofaucet.dutchycorp.space/\\\"]\",\"action\":[\"remove\",\"\"]}"],["{\"selector\":\"[style][href]\",\"tasks\":[[\"upward\",\"[style]\"]]}"],["{\"selector\":\"#submitbutton[disabled]\",\"action\":[\"remove-attr\",\"disabled\"]}","{\"selector\":\"a#gobutton[onclick]\",\"action\":[\"remove-attr\",\"onclick\"]}"],["{\"selector\":\".st-hidden\",\"action\":[\"remove-class\",\"st-hidden\"]}"],["{\"selector\":\"#cross-snp2\",\"tasks\":[[\"others\",\"\"]]}"],["{\"selector\":\".g-recaptcha, #cross-verify-go, .captcha-check, [src*=\\\"google.com/recaptcha/\\\"]\",\"tasks\":[[\"others\",\"\"]]}"],["{\"selector\":\"\",\"tasks\":[[\"xpath\",\"//*[(text()='Advertisement')]\"],[\"upward\",1]]}"],["{\"selector\":\"iframe.hide-ads\",\"tasks\":[[\"upward\",\"div[style]\"]]}"],["{\"selector\":\"[data-test^=\\\"component-slider-slide-\\\"]\",\"tasks\":[[\"has-text\",\"SPONSORED\"]]}"],["{\"selector\":\".search-page__result .listings-standout\",\"tasks\":[[\"upward\",\".search-page__result\"]]}","{\"selector\":\".searchResults .product-card__ad-copy\",\"tasks\":[[\"upward\",\"li\"]]}"],["{\"selector\":\".pufftext > .sponsored\",\"tasks\":[[\"upward\",3]]}","{\"selector\":\".pufftext\",\"tasks\":[[\"has-text\",\"/SPONSORED/\"],[\"upward\",2]]}"],["{\"selector\":\"main > div > [id].scroll-mt-20\",\"tasks\":[[\"has\",{\"selector\":\".items-center + div\",\"tasks\":[[\"has-text\",\"/^Sponsored$/\"]]}]]}"],["{\"selector\":\"body:not(:has(#remixd-audio-player)) > script\",\"tasks\":[[\"has-text\",\"googletagmanager\"]]}"],["{\"selector\":\"article > [class^=\\\"tc-view\\\"] #ad-header\",\"tasks\":[[\"upward\",\"article > [class^=\\\"tc-view\\\"]\"]]}"],["{\"selector\":\".thumb div.ad\",\"tasks\":[[\"upward\",\".thumb\"]]}"],["{\"selector\":\"#pro-continue, #pro-btn, #my-btn\",\"tasks\":[[\"others\",\"\"]]}"]];

const hostnamesMap = new Map([["1337x.unblock2.xyz",2],["g-porno.com",8],["g-streaming.com",8],["giga-streaming.com",8],["girlmms.com",8],["ottxmaza.com",8],["sexmazahd.com",8],["webxmaza.com",8],["ustream.click",10],["ebookbb.com",10],["kropic.com",10],["newtorrentgame.com",10],["thisav.com",10],["legendaoficial.net",10],["urlpay.net",10],["xxxmax.net",10],["22pixx.xyz",10],["uhdgames.xyz",10],["projectlive.info",19],["enit.in",27],["hdmovie20.com",33],["hdmovie22.com",33],["funnywifiname.net",33],["webnovelpub.com",37],["lightnovelspot.com",38],["novelpub.com",[38,323]],["missav123.com",41],["missav789.com",41],["myav.com",41],["gamerxyt.com",42],["94.103.83.138",44],["pornkino.cc",[46,47]],["youwatchporn.com",[46,47]],["pandamovies.me",[46,47]],["watchfreexxx.net",46],["xxxscenes.net",[46,47]],["bdnewszh.com",[52,61,154]],["olacast.live",[52,61]],["embedstream.me",[52,61,180]],["footyhunter3.xyz",[52,61]],["networkhint.com",57],["ytanime.tv",60],["idol69.net",64],["torrentfunk.com",66],["txxxporn.tube",71],["walmart.ca",75],["walmart.com",75],["cutty.app",79],["simply-debrid.com",79],["snaptik.app",80],["yelp.com.ar",81],["yelp.at",81],["yelp.com.au",81],["yelp.be",81],["yelp.com.br",81],["yelp.ca",81],["yelp.ch",81],["yelp.cl",81],["yelp.com",81],["yelp.cz",81],["yelp.de",81],["yelp.dk",81],["yelp.es",81],["yelp.fi",81],["yelp.fr",81],["yelp.com.hk",81],["yelp.ie",81],["yelp.it",81],["yelp.co.jp",81],["yelp.com.mx",81],["yelp.my",81],["yelp.nl",81],["yelp.no",81],["yelp.co.nz",81],["yelp.com.ph",81],["yelp.pl",81],["yelp.pt",81],["yelp.se",81],["yelp.com.sg",81],["yelp.com.tr",81],["yelp.co.uk",81],["bikesales.com.au",82],["sbs.com.au",83],["123unblock.bar",84],["eztv.tf",84],["eztv.yt",84],["btv.bg",85],["btvnovinite.bg",85],["btvsport.bg",85],["modivo.bg",86],["modivo.cz",86],["modivo.de",86],["modivo.gr",86],["modivo.hu",86],["modivo.it",86],["modivo.pl",86],["modivo.ro",86],["virusi.bg",87],["wubingdu.cn",87],["2-spyware.com",87],["odstranitvirus.cz",87],["dieviren.de",87],["udenvirus.dk",87],["viirused.ee",87],["losvirus.es",87],["virukset.fi",87],["lesvirus.fr",87],["ioys.gr",87],["virusi.hr",87],["avirus.hu",87],["tanpavirus.web.id",87],["senzavirus.it",87],["uirusu.jp",87],["virusai.lt",87],["zondervirus.nl",87],["viruset.no",87],["usunwirusa.pl",87],["semvirus.pt",87],["faravirus.ro",87],["bedynet.ru",87],["utanvirus.se",87],["virusler.info.tr",87],["novirus.uk",87],["hynews.biz",88],["bitcotasks.com",88],["cempakajaya.com",88],["coin-free.com",88],["coinsrev.com",88],["crypto4yu.com",88],["kienthucrangmieng.com",88],["manofadan.com",88],["tagecoin.com",[88,428]],["tremamnon.com",88],["tron-free.com",88],["wiour.com",88],["bitsmagic.fun",88],["btcbitco.in",88],["doge25.in",[88,528]],["videolyrics.in",88],["gainl.ink",88],["blog24.me",88],["btcsatoshi.net",88],["readbitcoin.org",88],["cryptosh.pro",88],["claimcoins.site",88],["allfaucet.xyz",88],["ourcoincash.xyz",[88,312]],["hardmob.com.br",89],["uol.com.br",90],["atlanticsuperstore.ca",[91,92]],["fortinos.ca",[91,92]],["maxi.ca",[91,92]],["newfoundlandgrocerystores.ca",[91,92]],["nofrills.ca",[91,92]],["provigo.ca",[91,92,95]],["realcanadiansuperstore.ca",[91,92]],["valumart.ca",[91,92,95]],["yourindependentgrocer.ca",[91,92,95]],["zehrs.ca",[91,92,95]],["loblaws.ca",[92,94,95]],["kijiji.ca",93],["filezip.cc",96],["pahaplayers.click",97],["givee.club",98],["mcrypto.club",99],["pkpics.club",100],["404media.co",101],["bellesa.co",102],["coolors.co",103],["decrypt.co",104],["game8.co",105],["geniussolutions.co",106],["reminimod.co",106],["amanguides.com",106],["fartechy.com",106],["mb.feedale.com",106],["foodxor.com",106],["highkeyfinance.com",106],["iconicblogger.com",106],["investcrust.com",106],["itechmafiia.com",106],["kreatifparenting.com",106],["krishiloksewa.com",106],["litonmods.com",106],["mealcold.com",106],["mixrootmods.com",106],["blog.nationapk.com",106],["placementsmela.com",106],["sportsonfr.com",106],["djpunjab2.in",106],["djqunjab.in",106],["panda.freemodsapp.in",106],["modzilla.in",106],["rsrlink.in",106],["gurumu.net",106],["freemodsapp.xyz",106],["javopen.co",107],["letest25.co",108],["financebolo.com",108],["techkeshri.com",108],["truevpnlover.com",108],["gorating.in",108],["loanteacher.in",108],["rphost.in",[108,534]],["plagiarismchecker.co",109],["redload.co",110],["roblox-scripts.co",111],["shortix.co",[112,113]],["androjungle.com",113],["bokugents.com",113],["drakescans.com",113],["bookszone.in",[113,525]],["takez.co",114],["tech5s.co",[115,116]],["trip.businessnews-nigeria.com",[115,184]],["ez4mods.com",[115,116]],["mobi2c.com",[115,184]],["te-it.com",[115,184]],["world2our.com",[115,184]],["bluetechno.net",[115,184]],["forexit.online",[115,184]],["veganab.co",117],["camdigest.com",117],["vsco.co",118],["1movietv.com",119],["4wank.com",120],["5ggyan.com",121],["newssokuhou666.blog.fc2.com",121],["youkaiwatch2345.blog.fc2.com",121],["marketmovers.it",121],["health-and.me",121],["9gag.com",122],["abcam.com",123],["accuweather.com",124],["acmemarkets.com",125],["albertsons.com",125],["andronicos.com",125],["carrsqc.com",125],["haggen.com",125],["jewelosco.com",125],["kingsfoodmarkets.com",125],["pavilions.com",125],["randalls.com",125],["safeway.com",125],["shaws.com",125],["starmarket.com",125],["tomthumb.com",125],["vons.com",125],["adivineencounter.com",126],["alcasthq.com",126],["au-di-tions.com",126],["badgehungry.com",126],["bloggingawaydebt.com",126],["chipandco.com",126],["cornerstoneconfessions.com",126],["dearcreatives.com",126],["divinelifestyle.com",126],["eslauthority.com",126],["heresyoursavings.com",126],["investingchannel.com",126],["justjared.com",126],["kompas.com",126],["lovegrowswild.com",126],["mjsbigblog.com",126],["mommybunch.com",126],["mustardseedmoney.com",126],["myfunkytravel.com",126],["mywomenstuff.com",126],["onetimethrough.com",126],["panlasangpinoymeatrecipes.com",126],["savespendsplurge.com",126],["savvyhoney.com",126],["silverpetticoatreview.com",126],["tamaratattles.com",126],["the-military-guide.com",126],["the2seasons.com",126],["therelaxedhomeschool.com",126],["thetechieguy.com",126],["truesteamachievements.com",126],["truetrophies.com",[126,454]],["waterheaterleakinginfo.com",126],["zeroto60times.com",126],["irresistiblepets.net",126],["peru21.pe",126],["agoda.com",127],["www.al.com",128],["www.cleveland.com",128],["www.lehighvalleylive.com",128],["www.masslive.com",128],["www.mlive.com",128],["www.nj.com",128],["www.oregonlive.com",128],["www.pennlive.com",128],["www.silive.com",128],["www.syracuse.com",128],["alibaba.com",129],["aliexpress.com",130],["alltechnerd.com",131],["alrincon.com",132],["amritadrino.com",133],["myprivatejobs.com",133],["wikitraveltips.com",133],["amusingplanet.com",134],["androidauthority.com",135],["animenewsnetwork.com",136],["animenhentai.com",137],["aol.com",138],["aov-news.com",139],["summonersky.com",139],["apekite.com",140],["cureclues.com",140],["en.financerites.com",[140,242]],["healthfirstweb.com",140],["howifx.com",140],["junkyponk.com",140],["livenewsflix.com",140],["mythvista.com",140],["vocalley.com",140],["yogablogfit.com",140],["apkcombo.com",141],["tricksplit.io",141],["dl.apkmb.com",142],["apkmirror.com",143],["apnews.com",144],["appkamods.com",145],["artribune.com",146],["ashemaletube.com",147],["asurascans.com",148],["asura.gg",148],["azaleasdolls.com",149],["backpacktf.com",150],["backpack.tf",150],["m.baomoi.com",151],["bartendingexpert.com",152],["bayequest.com",153],["jewelavid.com",154],["nizarstream.com",154],["backfirstwo.site",154],["beatsnoop.com",155],["fetchpik.com",155],["beaumontenterprise.com",[156,157]],["bigrapidsnews.com",156],["ctinsider.com",156],["ctpost.com",[156,157]],["darientimes.com",156],["expressnews.com",[156,157]],["greenwichtime.com",[156,157]],["houstonchronicle.com",[156,157]],["lmtonline.com",[156,157]],["manisteenews.com",[156,157]],["michigansthumb.com",[156,157]],["middletownpress.com",[156,157]],["milfordmirror.com",156],["mrt.com",[156,157]],["myjournalcourier.com",[156,157]],["ncadvertiser.com",156],["newstimes.com",156],["nhregister.com",[156,157]],["ourmidland.com",[156,157]],["registercitizen.com",[156,157]],["sfchronicle.com",[156,157]],["sheltonherald.com",156],["stamfordadvocate.com",[156,157]],["theheraldreview.com",156],["thehour.com",156],["theintelligencer.com",[156,157]],["theridgefieldpress.com",156],["thetelegraph.com",156],["timesunion.com",156],["trumbulltimes.com",156],["wiltonbulletin.com",156],["yourconroenews.com",156],["myplainview.com",157],["bellinghamherald.com",158],["bnd.com",158],["bradenton.com",158],["centredaily.com",158],["charlotteobserver.com",158],["flkeysnews.com",158],["fresnobee.com",158],["heraldonline.com",158],["heraldsun.com",158],["idahostatesman.com",158],["islandpacket.com",158],["kansas.com",158],["kansascity.com",158],["kentucky.com",158],["ledger-enquirer.com",158],["macon.com",158],["mahoningmatters.com",158],["mcclatchydc.com",158],["mercedsunstar.com",158],["miamiherald.com",158],["modbee.com",158],["myrtlebeachonline.com",158],["newsobserver.com",158],["sacbee.com",158],["sanluisobispo.com",158],["star-telegram.com",158],["sunherald.com",158],["besargaji.com",159],["best-mobilegames.com",160],["bharatsarkarijobalert.com",160],["creditsgoal.com",160],["freshbhojpuri.com",160],["moderngyan.com",160],["learn.moderngyan.com",160],["earn.mpscstudyhub.com",160],["quotesopia.com",160],["earn.quotesopia.com",160],["money.quotesopia.com",160],["bankshiksha.in",160],["bgmi32bitapk.in",160],["sattakingcharts.in",160],["bestjavporn.com",161],["bhaskar.com",162],["divyabhaskar.co.in",162],["biblestudytools.com",163],["christianheadlines.com",163],["ibelieve.com",163],["bigescapegames.com",164],["games2rule.com",[164,259]],["wowescape.com",164],["adultgamestop.bigtopsites.com",165],["bing.com",166],["bitchute.com",167],["bitcosite.com",168],["readytechflip.com",168],["bleepingcomputer.com",169],["bloggingaro.com",170],["gyanitheme.com",170],["hipsonyc.com",[170,285,286]],["theforyou.in",170],["hostadviser.net",170],["bloggingdaze.com",171],["bloggingguidance.com",172],["onroid.com",172],["akuu-sflin.blogspot.com",173],["viralsbaba1.blogspot.com",174],["app.blubank.com",175],["boardgameoracle.com",176],["bolnews.com",177],["booking.com",178],["boots.com",179],["bowfile.com",180],["buffsports.me",180],["cricstream.me",180],["boyfriendtv.com",181],["brightygames.com",182],["yoho.games",182],["buondua.com",183],["buytesmart.com",185],["buzzheavier.com",186],["cargurus.com",187],["ccn.com",188],["cdromance.com",189],["civitai.com",190],["classicreload.com",191],["cleantechnica.com",192],["cmphost.com",193],["drinkspartner.com",193],["headlinerpost.com",193],["uploadsoon.com",193],["viralxns.com",193],["wp.uploadfiles.in",193],["posterify.net",193],["codelivly.com",194],["coinseidon.com",195],["paidinsurance.in",195],["conghuongtu.net",195],["coinsparty.com",196],["cointelegraph.com",197],["comohoy.com",198],["convallariaslibrary.com",199],["gourmetscans.net",199],["corvetteblogger.com",200],["creativebloq.com",201],["creepypasta.com",202],["crocotube.com",203],["cruisecritic.com",204],["cruisecritic.co.uk",204],["cryptokinews.com",205],["gadgetsreview27.com",205],["mastharyana.com",[205,329]],["newsbawa.com",205],["quickimageconverter.com",[205,329]],["remixbass.com",[205,329]],["techipop.com",[205,329]],["techyember.com",[205,329]],["lifesurance.info",205],["lrncook.xyz",205],["yalifin.xyz",205],["currentrecruitment.com",206],["investorveda.com",206],["cut-fly.com",207],["foxseotools.com",207],["cxchief.com",208],["cybertyrant.com",209],["gdspike.com",209],["maxxfour.com",209],["profitshort.com",209],["technorozen.com",209],["uses-in-hindi.com",209],["blog.workedbd.com",209],["advisecreate.fun",209],["hubdrive.me",209],["courselinkfree.us",209],["deccanherald.com",210],["dekki.com",211],["desktopnexus.com",212],["deviantart.com",213],["dexscreener.com",214],["dictionary.com",215],["thesaurus.com",215],["digg.com",216],["digminecraft.com",217],["torrentdownloads.dirproxy.com",218],["discovermagazine.com",219],["blog.disheye.com",220],["disqus.com",221],["dll-files.com",222],["m.drtuber.com",223],["dzapk.com",224],["easyworldbusiness.com",225],["nichapk.com",225],["riveh.com",225],["m.economictimes.com",[226,227]],["indiatimes.com",[227,295,296]],["eksisozluk.com",228],["elamigos-games.com",229],["elamigos-games.net",229],["elitepvpers.com",230],["elmalajeno.com",231],["etsy.com",232],["ettvi.com",233],["euronews.com",[234,235]],["facebook.com",236],["facebookwkhpilnemxj7asaniu7vnjjbiltxjqhye3mhbshg7kx5tfyd.onion",236],["familyporner.com",237],["fandom.com",238],["feet9.com",239],["filehippo.com",240],["filmytoday.com",241],["flashingjungle.com",243],["flicksnchill.com",244],["flipkart.com",245],["flsaudio.com",246],["foodupe.com",247],["foreca.com",248],["forexrw7.com",249],["fx-22.com",249],["mooonten.com",249],["gold-24.net",249],["msic.site",249],["forexsalary.com",250],["mamatamusicbanaras.com",250],["missionupsc.com",250],["odisha-remix.com",250],["dailywebsite.in",250],["themoviesradar.in",250],["forumconstruire.com",251],["freebeacon.com",252],["freepik.com",253],["freethesaurus.com",254],["thefreedictionary.com",254],["freshdirect.com",255],["fucktube4k.com",256],["gab.com",257],["trends.gab.com",258],["gamesradar.com",260],["techradar.com",260],["tomsguide.com",260],["tomshardware.com",260],["whathifi.com",260],["gamingbible.com",261],["gay4porn.com",262],["getsexgames.com",263],["github.com",264],["globalchinaev.com",265],["gloryshole.com",266],["golinuxcloud.com",267],["google.com",268],["www.google.com",269],["gosexpod.com",270],["govtech.com",271],["graphicuv.com",272],["hit-films.com",272],["learnmany.in",272],["gsmware.com",273],["gtainside.com",274],["gumtree.com",275],["guru3d.com",276],["hacoos.com",277],["hamrojaagir.com",278],["kbconlinegame.com",278],["odijob.com",278],["hannaford.com",279],["healthline.com",280],["healthy4pepole.com",281],["fx-gd.net",281],["hightrip.net",281],["to-travel.net",281],["heb.com",282],["helicomicro.com",283],["freemodsapp.in",283],["hentaicloud.com",284],["meclipstudy.in",[285,286]],["historic-uk.com",287],["cdn.hostdl.com",288],["hotcleaner.com",289],["hotmovs.com",290],["ign.com",[291,292]],["ignboards.com",292],["imgbox.com",293],["in-jpn.com",294],["oninet.ne.jp",294],["xth.jp",294],["samayam.com",[296,404]],["economictimes.indiatimes.com",297],["influencersgonewild.com",298],["infographicjournal.com",299],["infokik.com",300],["informaxonline.com",301],["ufacw.com",301],["insideevs.com",302],["instagram.com",303],["integral-calculator.com",304],["derivative-calculator.net",304],["intercelestial.com",305],["isekaipalace.com",306],["yurasu.xyz",306],["jeuxvideo.com",307],["jpvhub.com",308],["kaotic.com",309],["khoaiphim.com",310],["kiemlua.com",311],["king-ptcs.com",[312,313]],["sh.techsamir.com",312],["naijafav.top",312],["kingarthurbaking.com",314],["kogan.com",315],["kslnewsradio.com",316],["ksltv.com",316],["ktar.com",316],["kumparan.com",317],["ladbible.com",318],["lbprate.com",319],["leaknud.com",320],["nodejs.libhunt.com",321],["lightnovelpub.com",322],["lightnovelworld.com",323],["linkedin.com",324],["logikfx.com",325],["los40.com",326],["mail.com",327],["masterduelmeta.com",328],["maturell.com",330],["nakedolders.com",330],["nudemilfwomen.com",330],["oldgirlsporn.com",330],["pornoplum.com",330],["vulgarmilf.com",330],["widewifes.com",330],["mbjremix.com",331],["neverdims.com",331],["ottlatest.com",331],["unfoldedstars.com",331],["mayaremix.in",331],["bit4me.info",331],["deltabtc.xyz",331],["meaww.com",332],["medicalnewstoday.com",333],["mgnetu.com",334],["miniwebtool.com",335],["streamvid.net",335],["mobilecric.com",336],["freehit.eu",336],["crictime.is",336],["live-sport.duktek.pro",336],["mod1s.com",337],["model-viewer.com",338],["modrinth.com",339],["movie.momo-net.com",340],["mrgay.com",341],["mrproblogger.com",342],["themezon.net",342],["msn.com",343],["myabandonware.com",344],["mydramalist.com",345],["mylust.com",346],["nakedneighbour.com",347],["ndtv.com",348],["food.ndtv.com",349],["nectareousoverelate.com",350],["needgayporn.com",351],["neogeo-system.com",352],["ddaynormandy.forumgaming.fr",352],["newsonthegotoday.com",353],["noon.com",354],["nordstrom.com",355],["nu6i-bg-net.com",356],["nypost.com",357],["nytimes.com",358],["nytimes3xbfgragh.onion",358],["okxxx1.com",359],["olympics.com",360],["onlylesbiantube.com",361],["blog.onroid.com",362],["ontechhindi.com",363],["bkgnews.in",363],["oscobo.com",364],["ovagames.com",365],["palcomix.com",366],["pandasnovel.com",367],["parentcircle.com",368],["pcbolsa.com",369],["community.pcgamingwiki.com",370],["peacocktv.com",371],["petco.com",372],["photovoltaikforum.com",373],["pikkado.com",374],["plasticsnews.com",375],["playonlinux.com",376],["porndoe.com",377],["porno-baguette.com",378],["pornolisa.com",379],["pornojenny.net",379],["porntn.com",380],["pranarevitalize.com",381],["redfea.com",381],["techyinfo.in",381],["fitnessholic.net",381],["prepostseo.com",382],["thequint.com",382],["proboards.com",383],["winclassic.net",383],["producthunt.com",384],["progfu.com",385],["freethailottery.live",385],["pussymaturephoto.com",386],["pussyspace.com",387],["pussyspace.net",387],["quizlet.com",388],["quora.com",389],["realpornclips.com",390],["reddit.com",391],["reddittorjg6rue252oqsxryoxengawnmo46qy4kyii5wtqnwfj4ooad.onion",391],["old.reddit.com",392],["sh.reddit.com",393],["www.reddit.com",393],["reddxxx.com",394],["rediff.com",395],["regex101.com",396],["forum.release-apk.com",397],["ricettafitness.com",398],["riteaid.com",399],["rocketnews24.com",400],["soranews24.com",400],["youpouch.com",400],["rome2rio.com",401],["rookieroad.com",402],["ryuugames.com",403],["scamwarners.com",405],["lovenovels.net",405],["scotsman.com",406],["scrolller.com",407],["seattleweekly.com",408],["semafor.com",409],["sephora.com",410],["sevenjournals.com",411],["uptechnologys.com",411],["xxxtime.sextgem.com",412],["shipt.com",413],["sisigames.com",414],["slidesgo.com",415],["sofmag.com",416],["sotwe.com",417],["splitshire.com",418],["sportbible.com",419],["sprouts.com",420],["steamidfinder.com",421],["stocktwits.com",422],["stomp.straitstimes.com",423],["streamingsites.com",424],["sub4unlock.com",425],["sugarona.com",426],["swisscows.com",427],["tamrieltradecentre.com",429],["target.com",430],["taxidrivermovie.com",431],["teachoo.com",432],["techacode.com",433],["sahlmarketing.net",[433,580]],["techonthenet.com",434],["techpp.com",435],["techymedies.com",436],["techyreviewx.com",437],["tejtime24.com",438],["cinedesi.in",438],["techishant.in",438],["thevouz.in",438],["telugupeople.com",439],["thedailywtf.com",440],["thedigitalfix.com",441],["thehackernews.com",442],["thejakartapost.com",443],["thestar.com",444],["thestate.com",445],["theswagsports.com",446],["thewindowsclub.com",447],["m.timesofindia.com",448],["tnaflix.com",449],["tossinggames.com",450],["totalcsgo.com",451],["trickms.com",452],["tripadvisor.com",453],["tumblr.com",455],["twi-fans.com",456],["twitter.com",[457,458]],["x.com",[457,458]],["twitter3e4tixl4xyajtrzo62zg5vztmjuricljdp2c5kshju4avyoid.onion",457],["ulta.com",459],["unsplash.com",460],["upornia.com",461],["upshrink.com",462],["variety.com",463],["travel.vebma.com",464],["veryfreeporn.com",465],["vidaextra.com",466],["videohelp.com",467],["wallpaperwaifu.com",468],["www.walmart.com",469],["washingtoninformer.com",470],["washingtonpost.com",471],["weatherwx.com",472],["wolt.com",473],["woowebtools.com",474],["xfreehd.com",475],["xmegadrive.com",476],["xnxx-sexfilme.com",477],["xnxxjapon.com",478],["xrares.com",479],["xxxdan.com",480],["yahoo.com",481],["search.yahoo.com",482],["yourstory.com",483],["youtube.com",484],["zefoy.com",485],["novinky.cz",486],["seznam.cz",487],["seznamzpravy.cz",487],["uschovna.cz",488],["china.ahk.de",489],["bild.de",490],["btc-echo.de",491],["chip.de",492],["www.chip.de",493],["cinemaxxl.de",494],["designtagebuch.de",495],["echo-online.de",496],["focus.de",497],["frag-mutti.de",498],["golem.de",499],["newsbreak24.de",500],["nn.de",501],["rtl.de",502],["spiegel.de",503],["sport1.de",504],["t-online.de",505],["web.de",506],["welt.de",[507,508]],["app.daily.dev",509],["jpopsingles.eu",510],["beta.shortearn.eu",511],["tlgrm.eu",512],["eitb.eus",513],["open.fm",514],["abczdrowie.pl",[514,618,619,620,621,622,623]],["autocentrum.pl",[514,618,621]],["autokult.pl",[514,618,619,624]],["benchmark.pl",[514,618,625]],["dobreprogramy.pl",[514,618,619,624]],["fotoblogia.pl",[514,618,619,624]],["gadzetomania.pl",[514,618,619,624]],["genialne.pl",[514,618,619,621,624]],["jastrzabpost.pl",[514,618,619,621,624]],["kafeteria.pl",[514,618,620,627]],["komorkomania.pl",[514,618,619,624]],["money.pl",[514,618,619,628]],["o2.pl",[514,618,619,620,621,623,627,629]],["parenting.pl",[514,618,623]],["polygamia.pl",[514,618,619,624]],["pudelek.pl",[514,618,619]],["pysznosci.pl",[514,618,619,621,624,630]],["wp.pl",[514,618,619,623,628,632]],["paste.fo",[515,516]],["romsmania.games",517],["genshin.gg",518],["op.gg",519],["vlr.gg",520],["skai.gr",521],["howtoremove.guide",522],["sexvideos.host",523],["akcartoons.in",524],["cybercityhelp.in",[524,527]],["caravanmagazine.in",526],["filerio.in",529],["finclub.in",530],["financeyogi.net",530],["naukrilelo.in",531],["petrainer.in",532],["pmkisanlists.in",533],["shramikcard.in",533],["cookad.net",533],["techurlshort.in",534],["coinlisting.info",535],["pepperlive.info",536],["rephrase.info",537],["torrentdownload.info",538],["vofomovies.info",539],["dragontea.ink",540],["cryptorank.io",541],["wings.io",542],["iranicard.ir",543],["smostafa.ir",544],["linkdoni.soft98.ir",545],["adshrink.it",546],["aranzulla.it",547],["enit.it",548],["nasonga.co.ke",549],["unito.life",550],["japscan.lol",551],["audiobookbay.lu",552],["dirp.me",553],["skiplink.me",554],["telegramchannels.me",555],["unknowncheats.me",556],["piracy.moe",557],["yts.mx",558],["ableitungsrechner.net",559],["belloflostsouls.net",560],["cellmapper.net",561],["finanzen.net",562],["gamersnexus.net",563],["hdpornpics.net",564],["infinityscans.net",565],["infinityscans.xyz",565],["iwatchfriendsonline.net",566],["izlekolik.net",567],["jacquieetmicheltv.net",568],["jacquieetmicheltv2.net",568],["linegee.net",569],["mapchart.net",570],["medievalists.net",571],["download.megaup.net",572],["myanimelist.net",573],["mypornstarbook.net",574],["neowin.net",575],["rule34.paheal.net",576],["peliculasmx.net",577],["pixiv.net",578],["client.pylexnodes.net",579],["skidrowcodex.net",581],["streaming-french.net",582],["wilifilm.net",582],["thefileslocker.net",583],["topsporter.net",584],["sportshub.to",584],["truyentranhfull.net",585],["tympanus.net",586],["vidello.net",587],["service.webgoto.net",588],["leadership.ng",589],["link.goto.com.np",590],["noelleeming.co.nz",591],["webserver.one",592],["allstreaming.online",593],["cancelguider.online",594],["maxlinks.online",595],["maxstreams.site",595],["maxstream.video",595],["mphealth.online",596],["vidstreamz.online",597],["bitcointalk.org",598],["btc25.org",599],["cgtips.org",600],["chimicamo.org",601],["distrowatch.org",602],["elizabeth-mitchell.org",603],["faradars.org",604],["girlsofdesire.org",605],["hltv.org",606],["mangaraw.org",607],["metager.org",608],["minioppai.org",609],["porn-w.org",610],["responsivevoice.org",611],["sensualgirls.org",612],["socialcounts.org",613],["statisticsanddata.org",614],["telepisodes.org",615],["temp-mail.org",616],["vpforums.org",617],["deliciousmagazine.pl",[618,619]],["vibez.pl",619],["fitness.wp.pl",[620,627]],["sportowefakty.wp.pl",[620,627]],["horoskop.wp.pl",621],["www.wp.pl",[621,635]],["domodi.pl",622],["forum.kardiolo.pl",[622,627]],["elektroda.pl",626],["smaczneblogi.pl",627],["pogoda.wp.pl",627],["sklep.trzynastkaplus.pl",631],["pilot.wp.pl",633],["turystyka.wp.pl",634],["afly.pro",636],["aliezstream.pro",637],["mylivestream.pro",637],["tokenmix.pro",638],["carbonite.co.za",638],["adslink.pw",639],["eminiclip.ro",640],["cenoteka.rs",641],["shopee.sg",642],["oko.sh",643],["cryptofun.space",644],["bigbtc.win",644],["autofaucet.dutchycorp.space",645],["playerx.stream",646],["n.fcd.su",647],["goku.sx",648],["easywithcode.tech",649],["vedamdigi.tech",[649,650]],["trakt.tv",651],["wco.tv",652],["argos.co.uk",653],["autotrader.co.uk",654],["dailymail.co.uk",655],["mylocal.co.uk",656],["radiox.co.uk",657],["thetimes.co.uk",658],["cambb.xxx",659],["nishankhatri.xyz",660]]);

const entitiesMap = new Map([["0123movies",0],["5movies",0],["megadede",0],["movies123",0],["10starhd",1],["2embed",1],["hdss",1],["moviesflix",1],["projectfreetv",1],["1337x",[2,3,4]],["1337x.unblocked",2],["1337x.unblockit",2],["x1337x",[2,4]],["1jour1film",5],["1movies",6],["1stream",7],["9xlinks",8],["9xmovie",8],["desiflix",8],["actvid",9],["alexsports",10],["animepahe",10],["hpaudiobooks",10],["kwik",10],["ouo",10],["allcalidad",11],["amazon",12],["bde4",13],["bombuj",14],["bunkr",15],["cinetux",16],["watch.cricstream",17],["ctrlv",18],["daddylive",19],["dramacool",20],["dvdplay",21],["elixx",22],["ettv",23],["extratorrent",24],["eztv",25],["fashionunited",26],["financerites",27],["gamestorrents",28],["gogoanimes",28],["limetorrents",[28,39]],["piratebayz",28],["gdflix",[29,30]],["vidsrc",29],["gmx",31],["www.google",32],["hdmovie2",33],["jattfilms",33],["hqq",34],["waaw",34],["indianwebseries",35],["kickass",36],["lightnovelpub",[37,38]],["mirrorace",40],["missav",41],["movies4u",42],["movies4u3",42],["mrunblock",43],["multimovies",44],["my1ink",45],["myl1nk",45],["myli3k",45],["mylink",45],["pandamovie",[46,47]],["speedporn",[46,47]],["pinterest",48],["piratebay",49],["pirateproxy",49],["pixhost",50],["poki",51],["poscitech",52],["sportsonline",[52,61]],["vipbox",[52,61]],["viprow",[52,61]],["primewire",53],["readcomiconline",54],["rp5",55],["sbplay",56],["shinchu",57],["sms24",58],["solarmovie",59],["sportskart",60],["stooq",62],["streameast",63],["streamingcommunity",64],["tirexo",65],["torlock",66],["torlock2",66],["torrentdownload",67],["torrentz2",68],["turkanime",69],["txxx",[70,71]],["userupload",72],["ustream",73],["vid2faf",74],["vidplay",74],["walmart",75],["wetteronline",76],["writedroid",77],["zone-annuaire",78]]);

const exceptionsMap = new Map([["tech.hipsonyc.com",[285]],["dutyfarm.welt.de",[507]]]);

self.proceduralImports = self.proceduralImports || [];
self.proceduralImports.push({ argsList, hostnamesMap, entitiesMap, exceptionsMap });

/******************************************************************************/

})();

/******************************************************************************/
