/*******************************************************************************

    uBlock Origin Lite - a comprehensive, MV3-compliant content blocker
    Copyright (C) 2014-present Raymond Hill

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see {http://www.gnu.org/licenses/}.

    Home: https://github.com/gorhill/uBlock
*/

/* jshint esversion:11 */

'use strict';

// ruleset: fra-0

/******************************************************************************/

// Important!
// Isolate from global scope
(function uBOL_cssProceduralImport() {

/******************************************************************************/

const argsList = [["{\"selector\":\".hz-Listing--list-item\",\"tasks\":[[\"has\",{\"selector\":\".hz-Listing-priority\",\"tasks\":[[\"has-text\",\"Pub au top\"]]}]]}"],["{\"selector\":\"div[class^=\\\"Flex-styled__StyledFlex-\\\"]\",\"tasks\":[[\"has\",{\"selector\":\"h3\",\"tasks\":[[\"has-text\",\"Produits sponsorisés\"]]}]]}"],["{\"selector\":\"[data-index-number]\",\"tasks\":[[\"has-text\",\"Sponsorisé\"]]}"],["{\"selector\":\"div[style=\\\"min-height: 0px;\\\"] > div[class^=\\\"css-\\\"] > div[class^=\\\"css-\\\"] > div[data-m32-ad]\",\"tasks\":[[\"upward\",2]]}"],["{\"selector\":\".clusterTop\",\"tasks\":[[\"has\",{\"selector\":\".teaser\",\"tasks\":[[\"has\",{\"selector\":\"h3\",\"tasks\":[[\"has-text\",\"Paid Post\"]]}]]}]]}"],["{\"selector\":\"article\",\"tasks\":[[\"has\",{\"selector\":\".sidebar-artitle\",\"tasks\":[[\"has-text\",\"/📣|📌/\"]]}]]}","{\"selector\":\"article\",\"tasks\":[[\"has\",{\"selector\":\"h2\",\"tasks\":[[\"has-text\",\"/📣|📌/\"]]}]]}"],["{\"selector\":\"div[class^=\\\"pub\\\"]\",\"tasks\":[[\"has-text\",\"adsbygoogle\"]]}"],["{\"selector\":\".td_block_wrap\",\"tasks\":[[\"has\",{\"selector\":\".block-title\",\"tasks\":[[\"has-text\",\"sponsorisés\"]]}]]}"],["{\"selector\":\"._2FypS\",\"tasks\":[[\"has\",{\"selector\":\"._1rKqn\",\"tasks\":[[\"has-text\",\"/AD|Annonce|إعلان/\"]]}]]}","{\"selector\":\".search-item-card-wrapper-gallery\",\"tasks\":[[\"has\",{\"selector\":\"[class^=\\\"multi--ax\\\"]\",\"tasks\":[[\"has-text\",\"/AD|Annonce|إعلان/\"]]}]]}"],["{\"selector\":\".boutonlink\",\"tasks\":[[\"has\",{\"selector\":\"a\",\"tasks\":[[\"has-text\",\"/VPN|rencontre/\"]]}]]}","{\"selector\":\".bp-fin\",\"tasks\":[[\"has\",{\"selector\":\"a\",\"tasks\":[[\"has-text\",\"/VPN|rencontre/\"]]}]]}"],["{\"selector\":\".af-album-ctn > div.cols-right-album > div.ad-container\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\".g-bg-gray-light-v4 > .text-center\",\"tasks\":[[\"has-text\",\"/^Publicité$/\"]]}"],["{\"selector\":\".breve\",\"tasks\":[[\"has\",{\"selector\":\".breve-info\",\"tasks\":[[\"has-text\",\"Sponsorisé\"]]}]]}"],["{\"selector\":\".o-block\",\"tasks\":[[\"has\",{\"selector\":\".o-block__content:has(.c-sponsoredMentions)\"}]]}","{\"selector\":\"li\",\"tasks\":[[\"has\",{\"selector\":\".prdtBlocInline:has(.c-sponsoredMentions)\"}]]}"],["{\"selector\":\".ccm_list_catch__item\",\"tasks\":[[\"has-text\",\"Annonces\"]]}"],["{\"selector\":\".News1\",\"tasks\":[[\"has\",{\"selector\":\"td\",\"tasks\":[[\"has-text\",\"Sponsored\"]]}]]}"],["{\"selector\":\".discussion_box > .post_simple_contener\",\"tasks\":[[\"has\",{\"selector\":\"> .post_simple > .postsimple_post_cell > .postsimple_head_cell > .postsimple_poster_info > div > .postsimple_pseudo > a > span\",\"tasks\":[[\"has-text\",\"/^Auto-promo$/\"]]}]]}"],["{\"selector\":\".postcontainer\",\"tasks\":[[\"has\",{\"selector\":\".username\",\"tasks\":[[\"has-text\",\"Publicité\"]]}]]}"],["{\"selector\":\".articles_list_item\",\"tasks\":[[\"has\",{\"selector\":\".category\",\"tasks\":[[\"has-text\",\"Sponsorisé\"]]}]]}"],["{\"selector\":\"#node-story > h2.story_subtitle_title\",\"tasks\":[[\"has-text\",\"/^Ailleurs sur le web$/\"]]}"],["{\"selector\":\".anchorMiddleOne\",\"tasks\":[[\"has\",{\"selector\":\".badge\",\"tasks\":[[\"has-text\",\"Sponsorisé\"]]}]]}","{\"selector\":\".anchorWrapper\",\"tasks\":[[\"has\",{\"selector\":\".cardHorizontalList__footer\",\"tasks\":[[\"has-text\",\"Sponsorisé\"]]}]]}","{\"selector\":\".card\",\"tasks\":[[\"has\",{\"selector\":\".badge\",\"tasks\":[[\"has-text\",\"Sponsorisé\"]]}]]}","{\"selector\":\".item-small-pres\",\"tasks\":[[\"has\",{\"selector\":\"a:has(.sponsored-prefix)\"}]]}","{\"selector\":\"li\",\"tasks\":[[\"has\",{\"selector\":\"a:has(.sponsored-prefix)\"}]]}"],["{\"selector\":\".posts-list-row > .posts-list-row-item > .card-item > .ad-wrapper\",\"tasks\":[[\"upward\",2]]}","{\"selector\":\".posts-list-row > .posts-list-row-item > .card-item > div[data-ad-unit-path]\",\"tasks\":[[\"upward\",2]]}"],["{\"selector\":\".article-list > .article-list__item\",\"tasks\":[[\"has\",{\"selector\":\"> .article-list__text-wrapper > a > .article-list__label\",\"tasks\":[[\"has-text\",\"/^Contenu sponsorisé$/\"]]}]]}"],["{\"selector\":\".boxed\",\"tasks\":[[\"has\",{\"selector\":\".tag\",\"tasks\":[[\"has-text\",\"Sponsored\"]]}]]}","{\"selector\":\".repo-component\",\"tasks\":[[\"has\",{\"selector\":\"label\",\"tasks\":[[\"has-text\",\"sponsored\"]]}]]}"],["{\"selector\":\".isnotmobi\",\"tasks\":[[\"has\",{\"selector\":\"a\",\"tasks\":[[\"has-text\",\"sponsorisé\"]]}]]}","{\"selector\":\"tbody\",\"tasks\":[[\"has\",{\"selector\":\"i\",\"tasks\":[[\"has-text\",\"sponsorisé\"]]}]]}"],["{\"selector\":\"aside\",\"tasks\":[[\"has\",{\"selector\":\".widget-title\",\"tasks\":[[\"has-text\",\"Publicité\"]]}]]}"],["{\"selector\":\".article-thumbnail\",\"tasks\":[[\"has\",{\"selector\":\"a\",\"tasks\":[[\"has-text\",\"/Sponsored|sponsorisé/\"]]}]]}"],["{\"selector\":\"app-home-item\",\"tasks\":[[\"has\",{\"selector\":\".article:has(.sponsored)\"}]]}"],["{\"selector\":\"section\",\"tasks\":[[\"has\",{\"selector\":\".brand\",\"tasks\":[[\"has-text\",\"sponsorisé\"]]}]]}"],["{\"selector\":\".post-card\",\"tasks\":[[\"has\",{\"selector\":\"span\",\"tasks\":[[\"has-text\",\"sponso\"]]}]]}"],["{\"selector\":\".container\",\"tasks\":[[\"has\",{\"selector\":\".o-section-heading\",\"tasks\":[[\"has-text\",\"/Sponsored|Sponsorisées|Stores à la une/\"]]}]]}"],["{\"selector\":\"li\",\"tasks\":[[\"has\",{\"selector\":\"a\",\"tasks\":[[\"has-text\",\"sponso\"]]}]]}"],["{\"selector\":\".results-container > div.result\",\"tasks\":[[\"has\",{\"selector\":\"> div.url > span.info\",\"tasks\":[[\"has-text\",\"Annonce\"]]}]]}"],["{\"selector\":\".post\",\"tasks\":[[\"has\",{\"selector\":\".postprofile\",\"tasks\":[[\"has\",{\"selector\":\"strong\",\"tasks\":[[\"has-text\",\"Ad Machine\"]]}]]}]]}"],["{\"selector\":\".owl-item\",\"tasks\":[[\"has\",{\"selector\":\"figure:has(img[src^=\\\"publicites/\\\"])\"}]]}"],["{\"selector\":\".post.has-profile\",\"tasks\":[[\"has\",{\"selector\":\".postbody:has(.adsbygoogle)\"}]]}"],["{\"selector\":\".wm-module\",\"tasks\":[[\"has-text\",\"Contenu sponsorisé\"]]}"],["{\"selector\":\".jwpv-desktop\",\"tasks\":[[\"has-text\",\"Publicité\"]]}"],["{\"selector\":\"[data-testid=\\\"tweet\\\"]\",\"tasks\":[[\"has-text\",\"Sponsorisé\"]]}"],["{\"selector\":\"div[style*=\\\"width: 300px\\\"]\",\"tasks\":[[\"has-text\",\"/Publicité|Publicités/\"]]}","{\"selector\":\"table[class=\\\"post\\\"]\",\"tasks\":[[\"has\",{\"selector\":\"tbody\",\"tasks\":[[\"has-text\",\"/annonces|annonceurs/\"]]}]]}"],["{\"selector\":\".custom-sidebar\",\"tasks\":[[\"has\",{\"selector\":\"h3\",\"tasks\":[[\"has-text\",\"/Partenaires|Publicité/\"]]}]]}"],["{\"selector\":\"a\",\"tasks\":[[\"has-text\",\"/ANONYME|Anonyme|anonyme|PREMIUM|Premium|RAPIDE|Rapide|Usenet|VPN|Vpn/\"]]}"],["{\"selector\":\".news-card\",\"tasks\":[[\"has-text\",\"Sponsorisé\"]]}"],["{\"selector\":\".post-nonfeatured\",\"tasks\":[[\"has\",{\"selector\":\".title-studio\",\"tasks\":[[\"has-text\",\"Contenu Sponsorisé\"]]}]]}"],["{\"selector\":\".riverPost\",\"tasks\":[[\"has\",{\"selector\":\".tag-desktop\",\"tasks\":[[\"has-text\",\"Publicité\"]]}]]}"],["{\"selector\":\"[class$=\\\"Container-right\\\"] > div.m-top-md\",\"tasks\":[[\"has\",{\"selector\":\"> div > span\",\"tasks\":[[\"has-text\",\"Publicité\"]]}]]}"],["{\"selector\":\"[id^=\\\"nume_html_\\\"]\",\"tasks\":[[\"has\",{\"selector\":\".mfe-card-group\",\"tasks\":[[\"has\",{\"selector\":\".mfe-card-group-title\",\"tasks\":[[\"has-text\",\"sponsorisées\"]]}]]}]]}","{\"selector\":\"[id^=\\\"nume_html_\\\"]\",\"tasks\":[[\"has\",{\"selector\":\".mfe-header\",\"tasks\":[[\"has\",{\"selector\":\".mfe-pull-left\",\"tasks\":[[\"has-text\",\"sponsorisés\"]]}]]}]]}"],["{\"selector\":\".highlight-item\",\"tasks\":[[\"has\",{\"selector\":\".word-wrapper\",\"tasks\":[[\"has-text\",\"sponso\"]]}]]}","{\"selector\":\".item.full.gameblog\",\"tasks\":[[\"has\",{\"selector\":\".post-details\",\"tasks\":[[\"has-text\",\"sponsorisé\"]]}]]}"],["{\"selector\":\"#main-container .blog__content\",\"tasks\":[[\"has\",{\"selector\":\"> .title-wrap--pr > h3\",\"tasks\":[[\"has-text\",\"Annonces\"]]}]]}"],["{\"selector\":\".main ~ table.messagetable > tbody > tr.message div[id^=\\\"div-gpt-ad-\\\"]\",\"tasks\":[[\"upward\",\"table.messagetable\"]]}"],["{\"selector\":\".news-bloc\",\"tasks\":[[\"has\",{\"selector\":\".article-type\",\"tasks\":[[\"has-text\",\"Sponsorisé\"]]}]]}"],["{\"selector\":\"article\",\"tasks\":[[\"has\",{\"selector\":\".date\",\"tasks\":[[\"has-text\",\"Sponso\"]]}]]}"],["{\"selector\":\"#blockPubGalleryWrapper\",\"action\":[\"remove\",\"\"]}"],["{\"selector\":\".article-wrapper\",\"tasks\":[[\"has\",{\"selector\":\".subheading\",\"tasks\":[[\"has-text\",\"Partenaire\"]]}]]}","{\"selector\":\".homepage-section.supplement-section\",\"tasks\":[[\"has\",{\"selector\":\"span\",\"tasks\":[[\"has-text\",\"Partenaires\"]]}]]}","{\"selector\":\".sticky-sidebar-block > div.bloc\",\"tasks\":[[\"has-text\",\"Annonces légales\"]]}"],["{\"selector\":\"#mainContent > div > div#lht-space-ad\",\"tasks\":[[\"upward\",1]]}","{\"selector\":\".undefined\",\"tasks\":[[\"has-text\",\"Sponsorisé\"]]}","{\"selector\":\"a[data-test-id]\",\"tasks\":[[\"has\",{\"selector\":\"[class]\",\"tasks\":[[\"has-text\",\"/À la une|Sponsorisé|Urgent/\"]]}]]}","{\"selector\":\"a[data-test-id]\",\"tasks\":[[\"has\",{\"selector\":\"[class]\",\"tasks\":[[\"has-text\",\"Sponsorisé\"]]}]]}"],["{\"selector\":\".fig-footer-ranking > div.fig-grid4\",\"tasks\":[[\"has\",{\"selector\":\"> span.fig-grid4__main-title\",\"tasks\":[[\"has-text\",\"Partenaires\"]]}]]}"],["{\"selector\":\".zone > div.area\",\"tasks\":[[\"has\",{\"selector\":\"> div.area__title > p\",\"tasks\":[[\"has-text\",\"Contenus partenaires\"]]}]]}"],["{\"selector\":\"div[id^=\\\"custom-gpt-\\\"]\",\"tasks\":[[\"upward\",\"div\"]]}","{\"selector\":\"span[shape=\\\"circle\\\"] + span\",\"tasks\":[[\"has-text\",\"Publicité\"],[\"upward\",2]]}"],["{\"selector\":\".post > aside.sidebar-before-comments\",\"tasks\":[[\"has\",{\"selector\":\"> [class=\\\"default-title\\\"] > span\",\"tasks\":[[\"has-text\",\"/Ailleurs sur le web|A lire sur le même sujet/\"]]}]]}"],["{\"selector\":\"div[align=\\\"center\\\"]\",\"tasks\":[[\"has-text\",\"PUBLICITÉ\"]]}"],["{\"selector\":\".habpage\",\"action\":[\"remove\",\"\"]}"],["{\"selector\":\".uk-margin-remove-last-child\",\"tasks\":[[\"has\",{\"selector\":\"div\",\"tasks\":[[\"has\",{\"selector\":\"span\",\"tasks\":[[\"has-text\",\"PUBLICITÉ\"]]}]]}]]}"],["{\"selector\":\".container-fluid > .mt-1 > h3\",\"tasks\":[[\"has-text\",\"/^Liens commerciaux$/\"]]}"],["{\"selector\":\".col-xl-4 > .align-items-center > .text-right > span\",\"tasks\":[[\"has-text\",\"/^PUBLICITÉ$/\"]]}"],["{\"selector\":\"div[class^=\\\"sc-\\\"] > div[class^=\\\"sc-\\\"] > div[id^=\\\"RAD_\\\"]\",\"tasks\":[[\"upward\",2]]}"],["{\"selector\":\"[data-identifier]\",\"tasks\":[[\"has\",{\"selector\":\"div:has(.sponsor-color)\"}]]}"],["{\"selector\":\".bot-card\",\"tasks\":[[\"has\",{\"selector\":\".lib\",\"tasks\":[[\"has-text\",\"Promoted\"]]}]]}","{\"selector\":\".bot-card\",\"tasks\":[[\"has\",{\"selector\":\".lib:has(img)\"}]]}"],["{\"selector\":\".alderaan-sous-article\",\"tasks\":[[\"has\",{\"selector\":\"span\",\"tasks\":[[\"has-text\",\"publicité\"]]}]]}","{\"selector\":\".app-main > article.post > div:not([class^=\\\"entry-\\\"]):not([class^=\\\"comments-\\\"])\",\"tasks\":[[\"has-text\",\"Article sponsorisé\"]]}","{\"selector\":\"[class*=\\\"sous-categories\\\"]\",\"tasks\":[[\"has-text\",\"Lien partenaire\"]]}","{\"selector\":\"div > hr + article.type-post\",\"tasks\":[[\"has\",{\"selector\":\"header:has(a[href^=\\\"http://bit.ly/\\\"])\"}]]}","{\"selector\":\"div > hr + article.type-post\",\"tasks\":[[\"has\",{\"selector\":\"header:has(a[href^=\\\"http://bitly.com/\\\"])\"}]]}"],["{\"selector\":\".widget_article\",\"tasks\":[[\"has\",{\"selector\":\".title_widget\",\"tasks\":[[\"has-text\",\"/PUBLI INFO|Publi-info/\"]]}]]}"],["{\"selector\":\"#fullad-active\",\"action\":[\"remove\",\"\"]}"],["{\"selector\":\"aside\",\"tasks\":[[\"has\",{\"selector\":\"div + span\",\"tasks\":[[\"has-text\",\"Publicité\"]]}]]}"],["{\"selector\":\".place-items-center\",\"tasks\":[[\"has\",{\"selector\":\"> div:only-child:not([class], [id]) > p.text-right\",\"tasks\":[[\"has-text\",\"/^Publicité$/\"]]}]]}","{\"selector\":\"p.text-right\",\"tasks\":[[\"has-text\",\"/^Publicité$/\"]]}"],["{\"selector\":\".ccm_list_catch__item\",\"tasks\":[[\"has-text\",\"Sponsored\"]]}"],["{\"selector\":\"#side > div[style^=\\\"float\\\"]\",\"tasks\":[[\"has\",{\"selector\":\"> div\",\"tasks\":[[\"has-text\",\"/^Publicité$/\"]]}]]}","{\"selector\":\"#side > div[style^=\\\"float\\\"]\",\"tasks\":[[\"has\",{\"selector\":\"> h2\",\"tasks\":[[\"has-text\",\"/^Partenaires$/\"]]}]]}"],["{\"selector\":\".l-section\",\"tasks\":[[\"has\",{\"selector\":\"> div.l-section-h > div.g-cols > div > div.vc_column-inner > div.wpb_wrapper > div.w-separator > div.w-separator-h > h6 > span\",\"tasks\":[[\"has-text\",\"Publicité\"]]}]]}"],["{\"selector\":\".main-right > h2\",\"tasks\":[[\"has-text\",\"Partenaires\"]]}"],["{\"selector\":\".panel\",\"tasks\":[[\"has\",{\"selector\":\".panel-heading\",\"tasks\":[[\"has\",{\"selector\":\".panel-title\",\"tasks\":[[\"has-text\",\"Publicité\"]]}]]}]]}"],["{\"selector\":\"#sidebar-right > div.blockbox\",\"tasks\":[[\"has\",{\"selector\":\"> div.sidetitle > i\",\"tasks\":[[\"has-text\",\"Annonces\"]]}]]}"],["{\"selector\":\"li\",\"tasks\":[[\"has\",{\"selector\":\".inboxSenderEmail\",\"tasks\":[[\"has-text\",\"AD | Temp Number\"]]}]]}"],["{\"selector\":\"div[style]\",\"tasks\":[[\"has-text\",\"/ANONYME|Anonyme|anonyme|Usenet|VPN|Vpn/\"]]}","{\"selector\":\"table[style]\",\"tasks\":[[\"has-text\",\"/ANONYME|Anonyme|anonyme|Usenet|VPN|Vpn/\"]]}"],["{\"selector\":\"a[href=\\\"/streaming-video.html\\\"]\",\"action\":[\"remove\",\"\"]}"],["{\"selector\":\"section > div[class]\",\"tasks\":[[\"has\",{\"selector\":\"> p\",\"tasks\":[[\"has-text\",\"/^Publicité$/\"]]}]]}"]];

const hostnamesMap = new Map([["2ememain.be",0],["krefel.be",1],["mediamarkt.be",2],["tv5unis.ca",3],["20min.ch",4],["macg.co",5],["igen.fr",5],["watchgeneration.fr",5],["11anim.com",6],["algerie-eco.com",7],["aliexpress.com",8],["aliexpress.us",8],["android-mt.com",9],["aufeminin.com",10],["automobile-propre.com",11],["blogdumoderateur.com",12],["cdiscount.com",13],["commentcamarche.com",14],["commentcamarche.net",14],["distrowatch.com",15],["forumconstruire.com",16],["futura-sciences.com",17],["ici-londres.com",18],["jeanmarcmorandini.com",19],["jeuxvideo.com",20],["konbini.com",21],["laprovence.com",22],["libhunt.com",23],["linfoweb.com",24],["maison-islam.com",25],["narcity.com",26],["nextinpact.com",27],["nicematin.com",28],["numerama.com",29],["ouedkniss.com",30],["phonandroid.com",31],["qwant.com",32],["sketchucation.com",33],["sookbtp.com",34],["starbike.com",35],["tourmag.com",36],["tsa-algerie.com",37],["twitter.com",38],["voyageforum.com",39],["zataz.com",40],["extreme-down.cyou",41],["t911.pw",[41,79]],["torrent9.se",[41,79]],["torrent.ws",[41,79]],["gktorrent.xyz",[41,79]],["allocine.fr",42],["businessinsider.fr",43],["cnetfrance.fr",44],["cuisineactuelle.fr",45],["ebay.fr",46],["gameblog.fr",47],["h2-mobile.fr",48],["forum.hardware.fr",49],["hitek.fr",50],["iphonesoft.fr",51],["lalsace.fr",52],["latribune.fr",53],["leboncoin.fr",54],["lefigaro.fr",55],["lemonde.fr",56],["lesechos.fr",57],["mariefrance.fr",58],["minutesports.fr",59],["moneyvox.fr",60],["on-mag.fr",61],["orange.fr",62],["actu.orange.fr",63],["radio.fr",64],["santemagazine.fr",65],["top.gg",66],["discordbots.org",66],["korben.info",67],["macommune.info",68],["lesfrontaliers.lu",69],["lessentiel.lu",70],["lexpress.mu",71],["ccm.net",72],["cyclismactu.net",73],["emugen.net",74],["tennisactu.net",75],["thesiteoueb.net",76],["extreme-down.ninja",77],["temp-mail.org",78],["zoneseries.stream",80],["ici.tou.tv",81]]);

const entitiesMap = new Map(undefined);

const exceptionsMap = new Map(undefined);

self.proceduralImports = self.proceduralImports || [];
self.proceduralImports.push({ argsList, hostnamesMap, entitiesMap, exceptionsMap });

/******************************************************************************/

})();

/******************************************************************************/
