/*******************************************************************************

    uBlock Origin Lite - a comprehensive, MV3-compliant content blocker
    Copyright (C) 2014-present Raymond Hill

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see {http://www.gnu.org/licenses/}.

    Home: https://github.com/gorhill/uBlock
*/

/* jshint esversion:11 */

'use strict';

// ruleset: jpn-1

/******************************************************************************/

// Important!
// Isolate from global scope
(function uBOL_cssProceduralImport() {

/******************************************************************************/

const argsList = [["{\"selector\":\"font[color=\\\"red\\\"]\",\"tasks\":[[\"has-text\",\"[PR]\"]]}"],["{\"selector\":\"#list\",\"tasks\":[[\"has\",{\"selector\":\"> div.entry-card > div > p > span.category\",\"tasks\":[[\"has-text\",\"PR\"]]}]]}"],["{\"selector\":\"p span#RealtimeClockArea2\",\"tasks\":[[\"upward\",\"p\"]]}"],["{\"selector\":\".plugin-memo > div.side > script[src*=\\\"i-mobile.co.jp/\\\"]\",\"tasks\":[[\"upward\",2]]}"],["{\"selector\":\".plugin-memo > div.side > div[id^=\\\"i2i\\\"]\",\"tasks\":[[\"upward\",2]]}"],["{\"selector\":\".plugin-memo > div.side > div[id^=\\\"gad-fixed\\\"]\",\"tasks\":[[\"upward\",2]]}"],["{\"selector\":\".plugin-memo > div.side > div.AMvertical\",\"tasks\":[[\"upward\",2]]}"],["{\"selector\":\"#extra div.plugin-memo > div.side > div[id]\",\"tasks\":[[\"upward\",\".plugin-memo\"]]}","{\"selector\":\"#extra div.plugin-memo script[src^=\\\"https://js.gsspcln.jp/\\\"]\",\"tasks\":[[\"upward\",\".plugin-memo\"]]}"],["{\"selector\":\".plugin-memo > div.side > div[class^=\\\"alistcloud-\\\"]\",\"tasks\":[[\"upward\",2]]}"],["{\"selector\":\"div[style=\\\"margin:10px 0;\\\"] > div[style=\\\"height:280px;\\\"] > ins.adsbygoogle\",\"tasks\":[[\"upward\",2]]}"],["{\"selector\":\".ark-block-columns\",\"tasks\":[[\"has-text\",\"スポンサードリンク\"]]}"],["{\"selector\":\"#mainEntity > div.clearfix > p > ins.adsbygoogle\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\".post-list-item > div.post-list-inner-infeed\",\"action\":[\"remove\",\"\"],\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\".entry-content > p + h2\",\"tasks\":[[\"has-text\",\"【PR】\"]]}"],["{\"selector\":\".plugin-memo > div.side > script[src*=\\\"//adm.shinobi.jp/\\\"]\",\"tasks\":[[\"upward\",2]]}"],["{\"selector\":\".plugin-memo > div.side > a[href^=\\\"https://daimaoh.co.jp\\\"]\",\"tasks\":[[\"upward\",2]]}"],["{\"selector\":\".plugin-memo > div.side > ins.dmm-widget-placement\",\"tasks\":[[\"upward\",2]]}"],["{\"selector\":\".plugin-memo > div.side > iframe[src*=\\\"//rcm-fe.amazon-adsystem.com\\\"]\",\"tasks\":[[\"upward\",2]]}"],["{\"selector\":\"div[class*=\\\"column-inner\\\"] > div.plugin-memo\",\"tasks\":[[\"has\",{\"selector\":\"> div.sidetitlebody > div.sidetitle\",\"tasks\":[[\"has-text\",\"スポンサードリンク\"]]}]]}"],["{\"selector\":\".post > h2[data-amp-original-style=\\\"padding-left:3%;margin-top:5%;margin-bottom:5%\\\"]\",\"tasks\":[[\"has-text\",\"関連広告\"]]}"],["{\"selector\":\".blogbody > a[name=\\\"\\\"]\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\".module--free ins.adsbygoogle\",\"tasks\":[[\"upward\",\".module--free\"]]}"],["{\"selector\":\".entryList > li #ninja-blog-inactive\",\"tasks\":[[\"upward\",\"li\"]]}"],["{\"selector\":\".article > h3.frontTitle\",\"tasks\":[[\"has-text\",\"お勧めサイト[PR]\"]]}"],["{\"selector\":\".module--free > ins.adsbygoogle\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\".entry[data-type=\\\"space\\\"] script[src^=\\\"https://img.ad-nex\\\"]\",\"tasks\":[[\"upward\",\".entry\"]]}"],["{\"selector\":\".plugin-memo > .side > div[id^=\\\"div-gpt-\\\"]:last-child\",\"tasks\":[[\"upward\",2]]}"],["{\"selector\":\"div[class$=\\\"_outline\\\"] > div > div.plugin-freearea > iframe[src*=\\\"mmaaxx.com/\\\"]\",\"tasks\":[[\"upward\",3]]}"],["{\"selector\":\".entry_box > div.entry_side + div.entry_main > div.entry_main_in > div.entry_body > div[style=\\\"text-align:center;margin-bottom:10px;\\\"] + div[style=\\\"font-size:8px;\\\"]\",\"tasks\":[[\"upward\",4]]}","{\"selector\":\".side_plugin > div.plugin_content > div.plugin_body > div.plugin-freearea > script#mgs_Widget\",\"tasks\":[[\"upward\",4]]}","{\"selector\":\".sidemenu_body > dd.plg_body > div.plugin-freearea > a[href^=\\\"http://www.amazon.co.jp/gp/\\\"][target=\\\"_blank\\\"]\",\"tasks\":[[\"upward\",3]]}","{\"selector\":\"aside[class^=\\\"plugin_\\\"] > div.plg_body > center > div > a[href^=\\\"https://dlsoft.dmm.co.jp\\\"][target=\\\"_blank\\\"]\",\"tasks\":[[\"upward\",3]]}","{\"selector\":\"div[class$=\\\"_outline\\\"] > div > div > ins.dmm-widget-placement\",\"tasks\":[[\"upward\",3]]}","{\"selector\":\"div[class$=\\\"_outline\\\"] > div > div.plugin-freearea > a[href*=\\\"dmm.co\\\"][target=\\\"_blank\\\"] > img\",\"tasks\":[[\"upward\",4]]}","{\"selector\":\"div[class$=\\\"_outline\\\"] > div > div.plugin-freearea > a[href^=\\\"http://order.getchu.com/r.php?aff=\\\"]\",\"tasks\":[[\"upward\",3]]}","{\"selector\":\"div[class$=\\\"_outline\\\"] > div > div.plugin-freearea > a[href^=\\\"https://click.dtiserv2.com\\\"]\",\"tasks\":[[\"upward\",3]]}","{\"selector\":\"div[class$=\\\"_outline\\\"] > div > div.plugin-freearea > a[href^=\\\"https://www.dlsite.com/maniax/dlaf\\\"][rel$=\\\"sponsored\\\"]\",\"tasks\":[[\"upward\",3]]}"],["{\"selector\":\"div[class$=\\\"_outline\\\"] > div > div.plugin-freearea > a[href*=\\\"amazon.co.jp/\\\"][target=\\\"_blank\\\"]:not([name])\",\"tasks\":[[\"upward\",3]]}"],["{\"selector\":\"center > table > tbody > tr > td > center > a.overwhite[target=\\\"_blank\\\"]\",\"tasks\":[[\"upward\",3]]}"],["{\"selector\":\".ac-mb-3.text-center > div[id^=\\\"div-gpt-ad-side\\\"]\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\".plugin-memo > div.side > a > img[src*=\\\"dmm.com/af/\\\"]\",\"tasks\":[[\"upward\",3]]}","{\"selector\":\".plugin-memo > div.side > script[src*=\\\"amazon-adsystem.com/\\\"]\",\"tasks\":[[\"upward\",2]]}"],["{\"selector\":\".plugin-memo > div.side:nth-last-child(2) > ins.adsbygoogle\",\"tasks\":[[\"upward\",2]]}"],["{\"selector\":\"table[width=\\\"95%\\\"][bgcolor=\\\"#CCFFCC\\\"] div[align=\\\"center\\\"] > iframe[src*=\\\"mmaaxx.com\\\"]\",\"tasks\":[[\"upward\",\"table[width=\\\"95%\\\"]\"]]}","{\"selector\":\"table[width=\\\"95%\\\"][bgcolor=\\\"#EFEFEF\\\"] div[align=\\\"center\\\"] > iframe[src*=\\\"/koukoku_\\\"]\",\"tasks\":[[\"upward\",\"table[width=\\\"95%\\\"]\"]]}","{\"selector\":\"table[width=\\\"95%\\\"][bgcolor=\\\"#EFEFEF\\\"] td[colspan=\\\"3\\\"] > iframe[src*=\\\"/koukoku_\\\"]\",\"tasks\":[[\"upward\",\"table[width=\\\"95%\\\"]\"]]}"],["{\"selector\":\".plugin-memo > div.side > div > div.google-user-ad-side\",\"tasks\":[[\"upward\",3]]}"],["{\"selector\":\".sidewrapper.widget_text > .sidebody > .textwidget > div[id] > script\",\"tasks\":[[\"upward\",4]]}"],["{\"selector\":\".EntryInnerBlock:not(.EntryInnerBlock:last-child) #ninja-blog-inactive\",\"tasks\":[[\"upward\",\".EntryInnerBlock\"]]}"],["{\"selector\":\".entry_table #ninja-blog-inactive\",\"tasks\":[[\"upward\",\".entry_table\"]]}"],["{\"selector\":\"#EntryTextBox #ninja-blog-inactive\",\"tasks\":[[\"upward\",\"#EntryTextBox\"]]}"],["{\"selector\":\".article1 #ninja-blog-inactive\",\"tasks\":[[\"upward\",\".article1\"]]}"],["{\"selector\":\"#EntryListBlock > .EntryTextBox #ninja-blog-inactive\",\"tasks\":[[\"upward\",\".EntryTextBox\"]]}"],["{\"selector\":\".EntryContainerExt #ninja-blog-inactive\",\"tasks\":[[\"upward\",\".EntryContainerExt\"]]}"],["{\"selector\":\".main_body > .text_body #ninja-blog-inactive\",\"tasks\":[[\"upward\",\".text_body\"]]}","{\"selector\":\".main_title_box h3 > a[href=\\\"\\\"]\",\"tasks\":[[\"upward\",\".main_title_box\"]]}"],["{\"selector\":\"#main-inner > .text #ninja-blog-inactive\",\"tasks\":[[\"upward\",\".text\"]]}","{\"selector\":\".posted > a[href=\\\"\\\"]\",\"tasks\":[[\"upward\",1]]}","{\"selector\":\".title > a[href=\\\"\\\"]\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\".article2 #ninja-blog-inactive\",\"tasks\":[[\"upward\",\".article2\"]]}"],["{\"selector\":\".FeatureBox_Magazine > div[id^=\\\"div-gpt-\\\"]\",\"tasks\":[[\"upward\",1]]}","{\"selector\":\".Section > div.Ad\",\"tasks\":[[\"upward\",1]]}","{\"selector\":\".content > h2.widget-header\",\"tasks\":[[\"has-text\",\"あなたにおススメの記事\"]]}","{\"selector\":\".l-main > div[class^=\\\"_\\\"] > div > ul > li > div[id^=\\\"div-gpt-\\\"]\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\"ul[class^=\\\"panel-article__list\\\"] > li > div[id^=\\\"div-gpt-\\\"]\",\"action\":[\"remove\",\"\"],\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\".list > li > div[id^=\\\"div-gpt-\\\"]\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\".c-article-block:has(> div[id^=\\\"div-gpt-\\\"])\",\"action\":[\"remove\",\"\"]}"],["{\"selector\":\".td-post-content > div > ins.adsbygoogle\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\".entry > p > ins.adsbygoogle\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\".newsList05__bnr\",\"action\":[\"remove\",\"\"]}"],["{\"selector\":\".not-athleterecipe > aside.ad\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\".results_bid > td[colspan=\\\"5\\\"] > ins.adsbygoogle\",\"tasks\":[[\"upward\",2]]}"],["{\"selector\":\".box_round > p > small\",\"tasks\":[[\"not\",{\"selector\":\"\",\"tasks\":[[\"has-text\",\"配信\"]]}]]}"],["{\"selector\":\"#EntryBlockNa #ninja-blog-inactive\",\"tasks\":[[\"upward\",\"#EntryBlockNa\"]]}"],["{\"selector\":\".entry_body #ninja-blog-inactive\",\"tasks\":[[\"upward\",\".entry_body\"]]}","{\"selector\":\".entry_state > .entry_comments > a[href=\\\"\\\"]\",\"tasks\":[[\"upward\",2]]}"],["{\"selector\":\"h2 > a[href=\\\"\\\"]\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\".EntryFooter > a[href=\\\"\\\"]\",\"tasks\":[[\"upward\",1]]}","{\"selector\":\".EntryHeader a[href=\\\"\\\"]\",\"tasks\":[[\"upward\",\".EntryHeader\"]]}","{\"selector\":\".EntryText #ninja-blog-inactive\",\"tasks\":[[\"upward\",\".EntryText\"]]}","{\"selector\":\".EntryTitle > .Title > a[href=\\\"\\\"]\",\"tasks\":[[\"upward\",2]]}"],["{\"selector\":\".grid_post-box > div.post-box-contents > div > div.dfad\",\"tasks\":[[\"upward\",3]]}"],["{\"selector\":\"li.p-topics-list__item div[id^=\\\"yads\\\"]\",\"tasks\":[[\"upward\",\"li\"]]}"],["{\"selector\":\".eall #ninja-blog-inactive\",\"tasks\":[[\"upward\",\".eall\"]]}"],["{\"selector\":\".main_left_block > div#BottomAmazon\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\".items > div.item > div[id^=\\\"logly-\\\"]\",\"tasks\":[[\"upward\",1]]}","{\"selector\":\".slick-slide > div[id] + script\",\"action\":[\"remove\",\"\"],\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\".article #ninja-blog-inactive\",\"tasks\":[[\"upward\",\".article\"]]}"],["{\"selector\":\".entry_table2 #ninja-blog-inactive\",\"tasks\":[[\"upward\",\".entry_table2\"]]}"],["{\"selector\":\".pad #ninja-blog-inactive\",\"tasks\":[[\"upward\",\".pad\"]]}"],["{\"selector\":\".entryHeader > a.entryListTime[href=\\\"\\\"]\",\"tasks\":[[\"upward\",1]]}","{\"selector\":\".entryMain #ninja-blog-inactive\",\"tasks\":[[\"upward\",\".entryMain\"]]}"],["{\"selector\":\"div[style^=\\\"float:\\\"] > p\",\"tasks\":[[\"has-text\",\"スポンサードリンク\"]]}"],["{\"selector\":\".HTML > div.widget-content > ins.adsbygoogle\",\"tasks\":[[\"upward\",2]]}"],["{\"selector\":\".readmoreWrap > p > ins.adsbygoogle\",\"tasks\":[[\"upward\",1]]}","{\"selector\":\".widget_text ins.adsbygoogle\",\"tasks\":[[\"upward\",\".widget_text\"]]}","{\"selector\":\".widget_text script[src*=\\\"zucks.net\\\"]\",\"tasks\":[[\"upward\",\".widget_text\"]]}"],["{\"selector\":\".widget_custom_html > div > ins.adsbygoogle\",\"tasks\":[[\"upward\",2]]}"],["{\"selector\":\".cardtype__article > ins.adsbygoogle\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\".swiper-slide > div.adunitContainer\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\"#sidebar-inner > span\",\"tasks\":[[\"has-text\",\"スポンサードリンク\"]]}"],["{\"selector\":\".image-posts-detail > div.l-section-container > section\",\"tasks\":[[\"has\",{\"selector\":\"> h2.c-section-title\",\"tasks\":[[\"has-text\",\"Amazon\"]]}]]}"],["{\"selector\":\".grid_post-box > div.post-box-contents > ins.adsbygoogle\",\"tasks\":[[\"upward\",2]]}"],["{\"selector\":\".widget_block script[src^=\\\"https://img.ad-nex.com\\\"]\",\"tasks\":[[\"upward\",\".widget_block\"]]}"],["{\"selector\":\"h5 > div.dfad\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\"div[id^=\\\"_popIn_recommend_\\\"] ul._popIn_infinite_page > li > a[class*=\\\"_popIn_recommend_article_ad\\\"]\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\".plugin-memo > div.side > center > iframe[src*=\\\"//rcm-fe.amazon-adsystem.com\\\"]\",\"tasks\":[[\"upward\",3]]}"],["{\"selector\":\"#entry > #entryText #ninja-blog-inactive\",\"tasks\":[[\"upward\",\"#entryText\"]]}","{\"selector\":\"#entryStatus > li > a[href=\\\"\\\"]\",\"tasks\":[[\"upward\",2]]}","{\"selector\":\"h2.entryTitle > a[href=\\\"\\\"]\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\".topstoriestxt > p > ins.adsbygoogle\",\"tasks\":[[\"upward\",2]]}"],["{\"selector\":\".logout_text + div.timesale > ul > li > div > div[id^=\\\"div-gpt-\\\"]\",\"tasks\":[[\"upward\",3]]}"],["{\"selector\":\".entry-block #ninja-blog-inactive\",\"tasks\":[[\"upward\",\".entry-block\"]]}"],["{\"selector\":\".section > div > ins.adsbygoogle\",\"tasks\":[[\"upward\",2]]}","{\"selector\":\".section > div.container > div.row > div > ins.adsbygoogle\",\"tasks\":[[\"upward\",4]]}"],["{\"selector\":\"h3.gap\",\"tasks\":[[\"has-text\",\"スポンサードリンク\"]]}"],["{\"selector\":\".card.example-1\",\"tasks\":[[\"upward\",1]]}","{\"selector\":\".hatena-module-html > div > script:only-child:not([src])\",\"tasks\":[[\"upward\",2]]}"],["{\"selector\":\".articleContainer > div.articleInner > ul.relatedItemList\",\"tasks\":[[\"upward\",2]]}"],["{\"selector\":\"#content > h2\",\"tasks\":[[\"has-text\",\"[PR]\"]]}","{\"selector\":\".d_line > img[src$=\\\"/cat20.gif\\\"]\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\".widget_custom_html a[href^=\\\"https://app.seedapp.jp\\\"]\",\"tasks\":[[\"upward\",\".widget_custom_html\"]]}"],["{\"selector\":\".widget_text > div > p > ins.adsbygoogle\",\"tasks\":[[\"upward\",3]]}"],["{\"selector\":\".widget_text > div > div[id^=\\\"logly\\\"]\",\"tasks\":[[\"upward\",2]]}"],["{\"selector\":\".text-111\",\"tasks\":[[\"has-text\",\"/^PR$/\"]]}"],["{\"selector\":\".rmenubox + div.p1_title\",\"tasks\":[[\"has-text\",\"【PR】\"]]}","{\"selector\":\".rmenubox > div.plugin-freearea > div[style^=\\\"width:230px\\\"]\",\"tasks\":[[\"upward\",2]]}"],["{\"selector\":\"div[class^=\\\"ArticleDetailBody_articleBody_\\\"] a.article_detail_button_ec_amazon\",\"tasks\":[[\"has-text\",\"関連商品を\"]]}","{\"selector\":\"div[class^=\\\"ArticleDetailBody_articleBody_\\\"] a.article_detail_button_ec_rakuten\",\"tasks\":[[\"has-text\",\"関連商品を\"]]}"],["{\"selector\":\"#__next > div[class^=\\\"_\\\"] > div[class]\",\"tasks\":[[\"has\",{\"selector\":\"> div > p\",\"tasks\":[[\"has-text\",\"ADVERTISING\"]]}]]}","{\"selector\":\"#mainArticleBottom_leftUnit\",\"tasks\":[[\"upward\",1]]}","{\"selector\":\"div[class] > div:not([class]) > div > div.OB-REACT-WRAPPER\",\"tasks\":[[\"upward\",2]]}"],["{\"selector\":\".tag_list + div.block-title\",\"tasks\":[[\"has-text\",\"今日から配信のHey動画\"]]}"],["{\"selector\":\"#main_contents > div.entry > div.entry_body > div[style=\\\"text-align:center;margin-bottom:10px;\\\"] + div[style=\\\"font-size:8px;\\\"]\",\"tasks\":[[\"upward\",2]]}","{\"selector\":\"#reserve > section.side-menu > div.sidebar-style ins.adsbygoogle\",\"tasks\":[[\"upward\",\"section.side-menu\"]]}","{\"selector\":\".plg_body > div[style] > a[href^=\\\"https://www.dlsite.com/pro/dlaf\\\"][target=\\\"_blank\\\"] > img\",\"tasks\":[[\"upward\",3]]}","{\"selector\":\".plugin-freearea > div[style^=\\\"width:300px\\\"] > ins.adsbygoogle\",\"tasks\":[[\"upward\",2]]}","{\"selector\":\".plugin2_outline > div.plugin2_body > div.plugin-freearea > iframe[src^=\\\"http://customize.dtiserv\\\"]\",\"tasks\":[[\"upward\",3]]}","{\"selector\":\".plugin_content > div.plugin_body > div.plugin-freearea > div[id^=\\\"i2i\\\"]\",\"tasks\":[[\"upward\",3]]}","{\"selector\":\".plugin_third > div.plg_body > div.plugin-freearea > a[href^=\\\"https://cnt.affiliate.fc2.com\\\"]\",\"tasks\":[[\"upward\",3]]}","{\"selector\":\".side-menu > div.side-menu-title > div.plugin-freearea > div[style=\\\"margin:0;padding:5px;font-size:12px;word-break: break-all;\\\"] > a[href^=\\\"https://al.dmm.co.jp\\\"][rel=\\\"nofollow\\\"]\",\"tasks\":[[\"upward\",4]]}","{\"selector\":\".side-menu > div.side-menu-title > div.plugin-freearea[style=\\\"text-align:center\\\"] > ins.dmm-widget-placement\",\"tasks\":[[\"upward\",3]]}","{\"selector\":\".side-menu > div.sidebar-style > div.plugin-freearea > img[src^=\\\"//v2st.shinobi.jp/\\\"]\",\"tasks\":[[\"upward\",3]]}","{\"selector\":\".side-menu > div.sidebar-style > div.plugin-freearea > script[src^=\\\"//adm.shinobi.jp/\\\"]\",\"tasks\":[[\"upward\",3]]}","{\"selector\":\".sidemenu_content > div.plg_body > div.plugin-freearea > div#scroll script[src^=\\\"https://adm.shinobi.jp/\\\"]\",\"tasks\":[[\"upward\",4]]}","{\"selector\":\".sidemenu_content > div.plg_body > div.plugin-freearea > script[src*=\\\"//adm.shinobi.jp/\\\"]\",\"tasks\":[[\"upward\",3]]}","{\"selector\":\"div[class$=\\\"BlockBase\\\"] > div > div > div.plugin-freearea > ins.adsbygoogle\",\"tasks\":[[\"upward\",4]]}","{\"selector\":\"div[class$=\\\"_outline\\\"] > div > div.plugin-freearea > a[name=\\\"amazletlink\\\"]\",\"tasks\":[[\"upward\",3]]}","{\"selector\":\"div[class$=\\\"_outline\\\"] > div > div.plugin-freearea > div[id^=\\\"i2i\\\"]\",\"tasks\":[[\"upward\",3]]}","{\"selector\":\"div[class$=\\\"_outline\\\"] > div > div.plugin-freearea > iframe[src^=\\\"https://rcm-fe.amazon-adsystem.com\\\"]\",\"tasks\":[[\"upward\",3]]}","{\"selector\":\"div[class$=\\\"_outline\\\"] > div > div.plugin-freearea > script[src$=\\\"/show_ads.js\\\"]\",\"tasks\":[[\"upward\",3]]}","{\"selector\":\"div[class$=\\\"_outline\\\"] > div > div.plugin-freearea > script[src*=\\\"//adm.shinobi.jp/\\\"]\",\"tasks\":[[\"upward\",3]]}","{\"selector\":\"div[class$=\\\"_outline\\\"] > div > div.plugin-freearea > script[src*=\\\"i-mobile.co.jp\\\"]\",\"tasks\":[[\"upward\",3]]}","{\"selector\":\"div[id$=\\\"-column\\\"] > div.sidebar > div[style=\\\"text-align:left\\\"] > div.plugin-freearea > a[href^=\\\"http://www.amazon.co.jp/gp/\\\"] > img[src^=\\\"https://ws-fe.amazon-adsystem.com\\\"]\",\"tasks\":[[\"upward\",4]]}","{\"selector\":\"div[id$=\\\"-column\\\"] > div.sidebar > div[style=\\\"text-align:left\\\"] > div.plugin-freearea > script[src^=\\\"//z-fe.amazon-adsystem.com\\\"]\",\"tasks\":[[\"upward\",3]]}"],["{\"selector\":\"div[class$=\\\"_outline\\\"] > div > div > a[name=\\\"amazletlink\\\"]\",\"tasks\":[[\"upward\",3]]}"],["{\"selector\":\"div[class$=\\\"_outline\\\"] > div > div.plugin-freearea > center > ins.adsbygoogle\",\"tasks\":[[\"upward\",4]]}"],["{\"selector\":\"div[class$=\\\"_outline\\\"] > div > div.plugin-freearea > ins.adsbygoogle\",\"tasks\":[[\"upward\",3]]}"],["{\"selector\":\".plugin1\",\"tasks\":[[\"has-text\",\"スポンサードリンク\"]]}"],["{\"selector\":\"#secondary-column > div.sidebar > div[style^=\\\"text-align:\\\"] > div.plugin-freearea > div.kaerebalink-box\",\"tasks\":[[\"upward\",3]]}"],["{\"selector\":\"div[class$=\\\"BlockBase\\\"] > div > div > div.plugin-freearea > div > a[href^=\\\"https://hb.afl.rakuten.co.jp/hsc/\\\"][target=\\\"_blank\\\"]\",\"tasks\":[[\"upward\",5]]}"],["{\"selector\":\"div[class$=\\\"BlockBase\\\"] > div > div > div.plugin-freearea > a[href^=\\\"https://www.amazon.co.jp/dp/\\\"][target=\\\"_blank\\\"] > img\",\"tasks\":[[\"upward\",5]]}"],["{\"selector\":\"div[class$=\\\"_outline\\\"] > div > div.plugin-freearea > div > a[name=\\\"amazletlink\\\"]\",\"tasks\":[[\"upward\",4]]}"],["{\"selector\":\"div[class$=\\\"_outline\\\"] > div > div.plugin-freearea > iframe[src^=\\\"http://blogparts.dmm.com\\\"]\",\"tasks\":[[\"upward\",3]]}","{\"selector\":\"div[class$=\\\"_outline\\\"] > div > div.plugin-freearea > ins.widget-banner\",\"tasks\":[[\"upward\",3]]}","{\"selector\":\"div[class$=\\\"_outline\\\"] > div > div.plugin-freearea > script[src$=\\\"/blogparts.js\\\"]\",\"tasks\":[[\"upward\",3]]}"],["{\"selector\":\".menuProfBlock > div.menuText > div.plugin-freearea > ins.dmm-widget-placement\",\"tasks\":[[\"upward\",3]]}"],["{\"selector\":\".search_listBox > .search_listBox\",\"tasks\":[[\"has\",{\"selector\":\"> div[class^=\\\"search_list\\\"] > h3 > a[href^=\\\"https://media.fc2.com/clicks.php?id=\\\"] > span\",\"tasks\":[[\"has-text\",\"/^\\\\[PR\\\\]$/\"]]}]]}","{\"selector\":\"section[class^=\\\"search_\\\"] > div[class^=\\\"c-cntCard-\\\"]\",\"tasks\":[[\"has\",{\"selector\":\"> div[class*=\\\"_indetail\\\"] > a[href^=\\\"https://media.fc2.com/clicks.php?id=\\\"] > span\",\"tasks\":[[\"has-text\",\"/^\\\\[PR\\\\]$/\"]]}]]}"],["{\"selector\":\".-freeArea > div.adAmazon\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\"div.plugin_item\",\"tasks\":[[\"has\",{\"selector\":\"> div.plugin_content > h2 > span\",\"tasks\":[[\"has-text\",\"/スポンサーリンク|オススメ記事/\"]]}]]}"],["{\"selector\":\".entry .aposted[href=\\\"\\\"]\",\"tasks\":[[\"upward\",\".entry\"]]}"],["{\"selector\":\".NormalList > li\",\"tasks\":[[\"has\",{\"selector\":\"h3 > a[href] > p\",\"tasks\":[[\"has-text\",\"PR\"]]}]]}"],["{\"selector\":\".entry_main_body > p.contentText\",\"tasks\":[[\"has-text\",\"【PR】\"]]}"],["{\"selector\":\".post-box > div.post-box-contents > ins.adsbygoogle\",\"tasks\":[[\"upward\",2]]}"],["{\"selector\":\"#article-options > div[style=\\\"width: 100%;\\\"] + h3\",\"tasks\":[[\"has-text\",\"楽天\"]]}","{\"selector\":\".plugin-memo > div.side > script[src*=\\\"i2i.jp/\\\"]\",\"tasks\":[[\"upward\",2]]}"],["{\"selector\":\".side-sp\",\"tasks\":[[\"has-text\",\"注目の巨乳アイドル\"]]}"],["{\"selector\":\"article[class^=\\\"mdlGrid_\\\"] > a[href^=\\\"https://www.amazon.co.jp/\\\"]\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\".under_content > .box > .textwidget > p > .adsbygoogle\",\"tasks\":[[\"upward\",3]]}"],["{\"selector\":\".cage #ninja-blog-inactive\",\"tasks\":[[\"upward\",\".cage\"]]}"],["{\"selector\":\".posts-inner\",\"tasks\":[[\"has-text\",\"/スポンサードリンク|関連コンテンツ|他サイト様人気記事|最新記事|こちらもオススメ/\"]]}"],["{\"selector\":\".Entry #ninja-blog-inactive\",\"tasks\":[[\"upward\",\".Entry\"]]}"],["{\"selector\":\"h2[id^=\\\"outline\\\"]\",\"tasks\":[[\"has\",{\"selector\":\"> span[style] > em > strong\",\"tasks\":[[\"has-text\",\"/^PR\\\\)/\"]]}]]}"],["{\"selector\":\".mt-6 > div.ads-double\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\".article-body-inner h4\",\"tasks\":[[\"has-text\",\"/FANZA|Gcolle|ランダム/\"]]}"],["{\"selector\":\".menu_title\",\"tasks\":[[\"has-text\",\"/スポンサードリンク|記事|【PR】/\"]]}"],["{\"selector\":\"._popIn_infinite_page > li:has(> a[class*=\\\"_popIn_recommend_article_ad\\\"])\",\"action\":[\"remove\",\"\"]}"],["{\"selector\":\"#related-entries ~ .singleh4\",\"tasks\":[[\"has-text\",\"amazon\"]]}"],["{\"selector\":\".article_box_item > div.pcBanner_category\",\"tasks\":[[\"upward\",1]]}","{\"selector\":\".list_item > div.pcBanner_index\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\".article > h3\",\"tasks\":[[\"has-text\",\"他にこんな記事も\"]]}"],["{\"selector\":\".entry-content > h3\",\"tasks\":[[\"has-text\",\"/売れ筋|おすすめ|商品/\"]]}"],["{\"selector\":\".p_top_top_article > span > div.p_top_top_article_banner\",\"action\":[\"remove\",\"\"],\"tasks\":[[\"upward\",2]]}"],["{\"selector\":\"\",\"action\":[\"style\",\"grid-template-rows: 1fr auto 1fr !important;\"],\"tasks\":[[\"matches-path\",\"/jp/\"],[\"spath\",\".aside_has-children__Ub7k8\"]]}","{\"selector\":\"\",\"tasks\":[[\"matches-path\",\"/jp/\"],[\"spath\",\"div[class^=\\\"fc-player_fc\\\"]\"]]}"],["{\"selector\":\".box > div[id^=\\\"pc_top_infeed\\\"]\",\"action\":[\"remove\",\"\"],\"tasks\":[[\"upward\",1]]}","{\"selector\":\".typeB_ttl\",\"tasks\":[[\"has-text\",\"記事\"]]}"],["{\"selector\":\".widget_text > div > ins.adsbygoogle\",\"tasks\":[[\"upward\",2]]}"],["{\"selector\":\".loop-entry > span.memo:first-child ~ ins.adsbygoogle\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\".entry #ninja-blog-inactive\",\"tasks\":[[\"upward\",\".entry\"]]}"],["{\"selector\":\".entry-inner > p\",\"tasks\":[[\"has-text\",\"/^PR$/\"]]}"],["{\"selector\":\".hatena-module-html > div.hatena-module-body > ins.adsbygoogle\",\"tasks\":[[\"upward\",2]]}"],["{\"selector\":\".hatena-module-html > div.hatena-module-body > iframe[src^=\\\"https://rcm-fe.amazon-adsystem.com/\\\"]\",\"tasks\":[[\"upward\",2]]}"],["{\"selector\":\".hatena-module-html > div.hatena-module-body > a[href*=\\\"//hb.afl.rakuten.co.jp/hsc/\\\"]\",\"tasks\":[[\"upward\",2]]}","{\"selector\":\".hatena-module-html > div.hatena-module-body > a[href^=\\\"https://adf.shinobi.jp/\\\"]\",\"tasks\":[[\"upward\",2]]}","{\"selector\":\".hatena-module-html > div.hatena-module-body > a[href^=\\\"https://click.linksynergy.com\\\"]\",\"tasks\":[[\"upward\",2]]}","{\"selector\":\".hatena-module-html > div.hatena-module-body > script[src^=\\\"//z-fe.amazon-adsystem.com/\\\"]\",\"tasks\":[[\"upward\",2]]}"],["{\"selector\":\".hatena-module-html > div.hatena-module-body > script[src*=\\\"//adm.shinobi.jp/\\\"]\",\"tasks\":[[\"upward\",2]]}"],["{\"selector\":\"#p5tittle\",\"tasks\":[[\"has-text\",\"/人気ランキング|商品|予約開始|発売/\"]]}"],["{\"selector\":\".box-article > div.border-ao.text-center\",\"tasks\":[[\"has-text\",\"関連商品\"]]}","{\"selector\":\".page-desktop > div.text-dark\",\"tasks\":[[\"has-text\",\"/プレバン|楽天/\"]]}"],["{\"selector\":\".adsbygoogle\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\"div[style^=\\\"width:100%;box-sizing:border-box;padding:1em\\\"] > a[href^=\\\"https://click.dtiserv2.com/\\\"]:only-child\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\"#first > .p1_outline\",\"tasks\":[[\"has\",{\"selector\":\"> .p1_title\",\"tasks\":[[\"has-text\",\"人気ゲームランキング\"]]}]]}","{\"selector\":\".p1_outline > .p1_title\",\"tasks\":[[\"has-text\",\"スポンサードリンク\"]]}"],["{\"selector\":\"section > center > span[style=\\\"opacity:0.7;font-size:xx-small\\\"]\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\".plugin2_outline > div.plugin2_title\",\"tasks\":[[\"has-text\",\"/amazon|スポンサーリンク/\"]]}"],["{\"selector\":\".entry-list-item #ninja-blog-inactive\",\"tasks\":[[\"upward\",\".entry-list-item\"]]}"],["{\"selector\":\".nb-entry #ninja-blog-inactive\",\"tasks\":[[\"upward\",\".nb-entry\"]]}"],["{\"selector\":\".plugin-memo:has(> div.side > div[id^=\\\"gad-fixed\\\"])\",\"action\":[\"remove\",\"\"]}"],["{\"selector\":\".HTML > div > div.entryadwrapper2\",\"tasks\":[[\"upward\",2]]}"],["{\"selector\":\".side-amazon\",\"tasks\":[[\"upward\",\".ad\"]]}"],["{\"selector\":\".plugin-memo > div.side > div > script[src*=\\\"i-mobile.co.jp\\\"]\",\"tasks\":[[\"upward\",3]]}"],["{\"selector\":\".panel:last-child > p.panel-heading\",\"tasks\":[[\"has-text\",\"PR情報\"],[\"upward\",1]]}"],["{\"selector\":\".widget-sidebar script[src$=\\\"/show_ads.js\\\"]\",\"tasks\":[[\"upward\",\".widget-sidebar\"]]}"],["{\"selector\":\"div.title-sec\",\"tasks\":[[\"has-text\",\"姉妹サイト\"]]}"],["{\"selector\":\".right-column-inner > div.plugin-memo\",\"tasks\":[[\"has\",{\"selector\":\"> div.sidetitlebody > div.sidetitle\",\"tasks\":[[\"has-text\",\"スポンサードリンク\"]]}]]}"],["{\"selector\":\".plugin1_outline > div > div[id] > script\",\"tasks\":[[\"upward\",3]]}"],["{\"selector\":\".cardtype > .cardtype__article > .adsbygoogle\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\".plugin_right > div > div > script[src$=\\\"/rakuten_widget.js\\\"]\",\"tasks\":[[\"upward\",3]]}"],["{\"selector\":\"#ct004 > div.contMain > table.tblPRbn\",\"tasks\":[[\"upward\",2]]}","{\"selector\":\".alignC > div.mTop10 > div[style]\",\"tasks\":[[\"has-text\",\"-PR-\"]]}","{\"selector\":\".c-feed_cell > a.c-feed_item-pr\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\"#entry_li_body #ninja-blog-inactive\",\"tasks\":[[\"upward\",\"#entry_li_body\"]]}"],["{\"selector\":\"#Left #ninja-blog-inactive\",\"tasks\":[[\"upward\",\"#Left\"]]}"],["{\"selector\":\".side-menu > div > div.plugin-freearea > div > a[name=\\\"amachazllink\\\"]\",\"tasks\":[[\"upward\",4]]}","{\"selector\":\".side-menu > h4\",\"tasks\":[[\"has-text\",\"ｽﾎﾟﾝｻｰﾘﾝｸ\"]]}"],["{\"selector\":\"#main > p > ins.adsbygoogle\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\"\",\"tasks\":[[\"matches-path\",\"/media\"],[\"spath\",\"body .code-block\"]]}"],["{\"selector\":\".singleAdjust01 > div.adAdjust02\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\".sub_right > .sidewrapper\",\"tasks\":[[\"has\",{\"selector\":\"> .sidetitlebody > .sidetitle\",\"tasks\":[[\"has-text\",\"スポンサードリンク\"]]}]]}"],["{\"selector\":\".plugin-memo > div.side > script[src*=\\\"//p.permalink-system.com\\\"]\",\"tasks\":[[\"upward\",2]]}"],["{\"selector\":\".plugin-memo > div.side > center > script[src^=\\\"https://cdn-fluct.sh.adingo.jp\\\"]\",\"tasks\":[[\"upward\",3]]}"],["{\"selector\":\"#sidebar1 h4.widgettitle\",\"tasks\":[[\"has-text\",\"スポンサードリンク\"]]}"],["{\"selector\":\"div[class$=\\\"_outline\\\"] > div > div.plugin-freearea > a[href^=\\\"https://www.e-nls.com/access.php\\\"]\",\"tasks\":[[\"upward\",3]]}"],["{\"selector\":\"#side > h2.h2s\",\"tasks\":[[\"has-text\",\"スポンサーリンク\"]]}"],["{\"selector\":\".h2s:last-of-type\",\"tasks\":[[\"has-text\",\"ポケモン関連\"]]}"],["{\"selector\":\".plugin-freearea > div > div > div[id^=\\\"gad-fixed\\\"]\",\"tasks\":[[\"upward\",3]]}"],["{\"selector\":\"#EB a[href=\\\"\\\"]\",\"tasks\":[[\"upward\",\"#EB\"]]}","{\"selector\":\"#EiB2 #ninja-blog-inactive\",\"tasks\":[[\"upward\",\"#EiB2\"]]}"],["{\"selector\":\".nav_div\",\"tasks\":[[\"has-text\",\"PR\"]]}"],["{\"selector\":\".entry-content > p > a[href^=\\\"https://px.a8.net\\\"]\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\"table[cellpadding=\\\"3\\\"]\",\"tasks\":[[\"has-text\",\"[PR]\"]]}","{\"selector\":\"table[width=\\\"100%\\\"][cellpadding=\\\"0\\\"][cellspacing=\\\"8\\\"]\",\"tasks\":[[\"has-text\",\"出会い特集\"]]}"],["{\"selector\":\"body > font[color=\\\"green\\\"]\",\"tasks\":[[\"has-text\",\"/初心者|セフレ|出会い|女装子|ニューハーフと遊/\"],[\"spath\",\" + br + br + a[target=\\\"_blank\\\"]\"]]}","{\"selector\":\"body > font[color=\\\"green\\\"]\",\"tasks\":[[\"has-text\",\"/初心者|セフレ|出会い|女装子|ニューハーフと遊/\"]]}","{\"selector\":\"table[cellpadding=\\\"4\\\"]\",\"tasks\":[[\"has-text\",\"[PR]\"],[\"spath\",\" + br + img\"]]}","{\"selector\":\"table[cellpadding=\\\"4\\\"]\",\"tasks\":[[\"has-text\",\"[PR]\"]]}"],["{\"selector\":\".subSec:first-child > div[id^=\\\"div-gpt-ad\\\"]\",\"tasks\":[[\"upward\",1]]}","{\"selector\":\".topicsList > li > i.pr\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\".lyricside > span.ezoic-ad\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\"b > div > a[href^=\\\"https://al.dmm.co.jp\\\"]\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\"#extra div.plugin-memo > div.side > script[language=\\\"JavaScript\\\"]\",\"tasks\":[[\"upward\",2]]}","{\"selector\":\".plugin-memo > div.side > script[src^=\\\"https://js.ad-stir.com/\\\"]\",\"tasks\":[[\"upward\",2]]}"],["{\"selector\":\".EntryInnerBlock #ninja-blog-inactive\",\"tasks\":[[\"upward\",\".EntryInnerBlock\"]]}","{\"selector\":\".entry_header:first-child > span.entry_title > a[href=\\\"\\\"]\",\"tasks\":[[\"has-text\",\"[PR]\"],[\"upward\",2]]}","{\"selector\":\".entry_text > #ninja-blog-inactive\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\".main-box > ul.list > li > script[src^=\\\"https://img.ad-nex.com\\\"]\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\"#left > div.plugin1_outline\",\"tasks\":[[\"has\",{\"selector\":\"> div.plugin1_title\",\"tasks\":[[\"has-text\",\"ＰＲ\"]]}]]}","{\"selector\":\".menuTabLight\",\"tasks\":[[\"has-text\",\"PR\"]]}","{\"selector\":\".plugin1_outline > div.plugin1_title\",\"tasks\":[[\"has-text\",\"PR\"],[\"upward\",1]]}","{\"selector\":\".plugin3_body > div.ta_center > div.plugin-freearea\",\"tasks\":[[\"upward\",3]]}"],["{\"selector\":\".mdModal div.mdbnViewer__ad\",\"tasks\":[[\"upward\",\".mdModal\"]]}"],["{\"selector\":\"#EntryInnerBlock #ninja-blog-inactive\",\"tasks\":[[\"upward\",\"#EntryInnerBlock\"]]}"],["{\"selector\":\".plugin-memo > div.side > a[href^=\\\"https://book.dmm.co.jp\\\"]\",\"tasks\":[[\"upward\",2]]}"],["{\"selector\":\".side_title\",\"tasks\":[[\"has-text\",\"FANZA\"]]}"],["{\"selector\":\".moyugenn-c\",\"tasks\":[[\"has-text\",\"Amazonランキング\"]]}"],["{\"selector\":\".module--free > div[style=\\\"text-align:center;\\\"] > ins.adsbygoogle\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\".ad-area > div.ad-label\",\"tasks\":[[\"has-text\",\"/^スポンサーリンク$/\"]]}","{\"selector\":\".section-title > p\",\"tasks\":[[\"has-text\",\"/^スポンサーリンク$/\"]]}","{\"selector\":\".text-center > p\",\"tasks\":[[\"has-text\",\"スポンサー\"]]}"],["{\"selector\":\".module--free > div > ins.adsbygoogle\",\"tasks\":[[\"upward\",2]]}"],["{\"selector\":\".widget_text > h3.sidebar-widget-title\",\"tasks\":[[\"has-text\",\"人気作\"]]}"],["{\"selector\":\".EntryInner #ninja-blog-inactive\",\"tasks\":[[\"upward\",\".EntryInner\"]]}"],["{\"selector\":\".side-menu\",\"tasks\":[[\"has\",{\"selector\":\"> h4\",\"tasks\":[[\"has-text\",\"/^PR/\"]]}]]}"],["{\"selector\":\".article__content > div:not([class]) > ins.adsbygoogle\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\"div[class$=\\\"_outline\\\"] > div > div.plugin-freearea > div > a[href^=\\\"https://book.dmm.co.jp\\\"]\",\"tasks\":[[\"upward\",4]]}"],["{\"selector\":\".divh1\",\"tasks\":[[\"has-text\",\"PR\"]]}"],["{\"selector\":\".vab > div#pr\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\".mb0 > div.s-side-title-header > [class^=\\\"s-side-\\\"]\",\"tasks\":[[\"has-text\",\"スポンサードリンク\"]]}"],["{\"selector\":\".entrybox #ninja-blog-inactive\",\"tasks\":[[\"upward\",\".entrybox\"]]}"],["{\"selector\":\".widget > div[id^=\\\"div-gpt-\\\"]\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\".wppwrap > div.ts10box\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\".plugin-memo > div.side > center > div[id^=\\\"im-\\\"]\",\"tasks\":[[\"upward\",3]]}","{\"selector\":\".plugin-memo > div.side > script[src^=\\\"//150601.fc2rs.com\\\"]\",\"tasks\":[[\"upward\",2]]}"],["{\"selector\":\".l-section > .c-iconAd + ul.p-articleList > .p-articleList_item > div[id^=\\\"div-gpt-ad\\\"]\",\"tasks\":[[\"upward\",3]]}"],["{\"selector\":\"#contents > .label\",\"tasks\":[[\"has-text\",\"/ランキング$/\"]]}"],["{\"selector\":\".grid_post-box > div.post-box-contents > div[id^=\\\"imobile_ad\\\"]\",\"tasks\":[[\"upward\",2]]}"],["{\"selector\":\".entry_body > center\",\"tasks\":[[\"has-text\",\"[スポンサーリンク]\"]]}"],["{\"selector\":\"#sub .sidewrapper\",\"tasks\":[[\"has\",{\"selector\":\"> .sidetitlebody > .sidetitle\",\"tasks\":[[\"has-text\",\"スポンサードリンク\"]]}]]}"],["{\"selector\":\"div[class=\\\"add\\\"] > div[id^=\\\"text-6\\\"]\",\"tasks\":[[\"has\",{\"selector\":\"> h4 > span\",\"tasks\":[[\"has-text\",\"おすすめ関連記事\"]]}]]}"],["{\"selector\":\".v-list-item.thd-enter-to[tabindex=\\\"-1\\\"]:first-child\",\"tasks\":[[\"has-text\",\"/^ad\\\\s+$/\"]]}"],["{\"selector\":\".plugin-memo > div.side > center > ins.adsbygoogle\",\"tasks\":[[\"upward\",3]]}"],["{\"selector\":\"td[valign=\\\"top\\\"] > table[border=\\\"0\\\"][cellspacing=\\\"0\\\"] > tbody > tr > td > ins.adsbygoogle\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\".entrytextbox #ninja-blog-inactive\",\"tasks\":[[\"upward\",\".entrytextbox\"]]}"],["{\"selector\":\".links > div.side_headline20\",\"tasks\":[[\"has-text\",\"スポンサード リンク\"]]}","{\"selector\":\".links-left > div.side_headline60\",\"tasks\":[[\"has-text\",\"スポンサード リンク\"]]}"],["{\"selector\":\".noads-link\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\".forum-information > font\",\"tasks\":[[\"has-text\",\"楽天\"]]}"],["{\"selector\":\"#extra div.free-box iframe[src*=\\\"amazon-adsystem\\\"]\",\"tasks\":[[\"upward\",\"div.free-box\"]]}"],["{\"selector\":\"#side > .content_area\",\"tasks\":[[\"has-text\",\"広告\"]]}"],["{\"selector\":\".k_leftColumnCommon > .k_mt-6\",\"tasks\":[[\"has\",{\"selector\":\".k_text\",\"tasks\":[[\"has-text\",\"AD\"]]}]]}"],["{\"selector\":\".box_sidebar > .line\",\"tasks\":[[\"has-text\",\"/^★(?:スポンサードリンク|おすすめ)$/\"]]}"],["{\"selector\":\"#home-side-ad\",\"tasks\":[[\"upward\",1]]}","{\"selector\":\"#personalized-feed-side-ad\",\"tasks\":[[\"upward\",1]]}","{\"selector\":\".p-items_main > div > div[class^=\\\"style-\\\"] > div[class^=\\\"style-\\\"] > div[id^=\\\"logly-\\\"]\",\"tasks\":[[\"upward\",2]]}","{\"selector\":\"div[class^=\\\"style\\\"] > div[class^=\\\"style\\\"] > div[class^=\\\"style\\\"] > div[data-testid$=\\\"AdUnit\\\"]\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\".plugin1_outline\",\"tasks\":[[\"has\",{\"selector\":\"> div.plugin1_title\",\"tasks\":[[\"has-text\",\"PR\"]]}]]}"],["{\"selector\":\"#link-will-go\",\"action\":[\"remove\",\"\"]}"],["{\"selector\":\".module > center > script[src^=\\\"https://js.ad-spire.net\\\"]\",\"tasks\":[[\"upward\",2]]}","{\"selector\":\".module--free > center > ins.adsbygoogle\",\"tasks\":[[\"upward\",2]]}"],["{\"selector\":\"#main-column > div.EntryBlock #ninja-blog-inactive\",\"tasks\":[[\"upward\",\".EntryBlock\"]]}"],["{\"selector\":\"#main-inner > .content #ninja-blog-inactive\",\"tasks\":[[\"upward\",\".content\"]]}","{\"selector\":\".page_navi > a[href=\\\"\\\"]\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\"#content1 > .articles #ninja-blog-inactive\",\"tasks\":[[\"upward\",\".articles\"]]}"],["{\"selector\":\".sidetitlebody\",\"tasks\":[[\"has-text\",\"スポンサーリンク\"]]}"],["{\"selector\":\"#main center\",\"tasks\":[[\"has-text\",\"スポンサーリンク\"]]}"],["{\"selector\":\".entry-content > div[style^=\\\"box-shadow: 0px 0px 20px rgba(0, 0, 0, 0.25);\\\"] > ins.adsbygoogle\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\".plugin-memo > div.side > script[src$=\\\"/rakuten_widget.js\\\"]\",\"tasks\":[[\"upward\",2]]}"],["{\"selector\":\".post_ad\",\"action\":[\"remove\",\"\"]}"],["{\"selector\":\"p > ins.adsbygoogle\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\".side-section > div[data-as-slot-id]\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\".title_right_top\",\"tasks\":[[\"has-text\",\"SPONSORED\"]]}"],["{\"selector\":\".sidebar-t\",\"tasks\":[[\"has-text\",\"/ランキング|エロ情報/\"]]}"],["{\"selector\":\"#side > div > .widget-wrap > h3\",\"tasks\":[[\"has-text\",\"/^Ads$/\"],[\"upward\",1]]}","{\"selector\":\".entry-footer > p[style]\",\"tasks\":[[\"has-text\",\"[Ads & Featured Articles]\"]]}"],["{\"selector\":\"#posts > div.post-wrap > a[href*=\\\"_ad_\\\"][target=\\\"_blank\\\"]\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\".article-single-content > div > div\",\"tasks\":[[\"has\",{\"selector\":\"> div[style] > div > span\",\"tasks\":[[\"has-text\",\"【PR】\"]]}]]}"],["{\"selector\":\".c-list__item > div[id^=\\\"_popIn_infeed\\\"]\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\".tweet_box > div[class=\\\"list_box\\\"]:not([data-index]) > div > a[href^=\\\"https://www.amazon.co.jp/\\\"]\",\"tasks\":[[\"upward\",2]]}"],["{\"selector\":\".contents_right > div.box > div#ad_rectangle_1\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\"#ar_w300px > div.cont > ul.tab\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\"._popIn_infinite_page > a._popIn_recommend_article_ad\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\"center > table[width=\\\"85%\\\"]:first-child > tbody > tr > td[align=\\\"center\\\"] > script[src^=\\\"//pagead2\\\"]\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\"#irelated > div > ul > div.bds > div.bd_left1[name]\",\"tasks\":[[\"has-text\",\"PR\"],[\"upward\",4]]}","{\"selector\":\".banner_left1 > script\",\"tasks\":[[\"upward\",1]]}","{\"selector\":\"tr > td > div[class^=\\\"text-top-tab1-\\\"] > div.bd > div.bd_left[name]\",\"tasks\":[[\"has-text\",\"PR\"],[\"upward\",4]]}"],["{\"selector\":\"#right_col > div:not([class])\",\"tasks\":[[\"has-text\",\"スポンサーリンク\"]]}"],["{\"selector\":\".entry_header > a[href=\\\"\\\"]\",\"tasks\":[[\"upward\",1]]}","{\"selector\":\".entry_text #ninja-blog-inactive\",\"tasks\":[[\"upward\",\".entry_text\"]]}"],["{\"selector\":\".widget_diver_widget_pcsp > div > center > script[src$=\\\"/adstir.js\\\"]\",\"tasks\":[[\"upward\",3]]}","{\"selector\":\".widget_diver_widget_pcsp > div > div.adp\",\"tasks\":[[\"upward\",2]]}"],["{\"selector\":\"#page-content > h2#toc3\",\"tasks\":[[\"has\",{\"selector\":\"> span\",\"tasks\":[[\"has-text\",\"/^広告$/\"]]}],[\"spath\",\" ~ div.scp-image-block[style=\\\"width:300px;\\\"]\"]]}","{\"selector\":\"#page-content > h2#toc3\",\"tasks\":[[\"has\",{\"selector\":\"> span\",\"tasks\":[[\"has-text\",\"/^広告$/\"]]}]]}"],["{\"selector\":\"div[class^=\\\"mainCommentBold\\\"]\",\"tasks\":[[\"has-text\",\"/^(関連記事|PR|週間人気ページランキング)$/\"]]}"],["{\"selector\":\".side_banner > #_popIn_recommend_image_right\",\"tasks\":[[\"upward\",1]]}","{\"selector\":\".single_container > div[class=\\\"\\\"]\",\"tasks\":[[\"has-text\",\"【あなたにオススメ記事】\"]]}"],["{\"selector\":\".widget-post ul.horizontal-list\",\"tasks\":[[\"upward\",\".widget-post\"]]}"],["{\"selector\":\"div:not([style]) > div[style=\\\"text-align:center;\\\"] > ins.adsbygoogle\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\".clearfix > p > span[style=\\\"color: #ff0000;\\\"]\",\"tasks\":[[\"has-text\",\"3千円プレゼント！\"],[\"upward\",1]]}","{\"selector\":\".clearfix > p > strong\",\"tasks\":[[\"has-text\",\"↓\"]]}"],["{\"selector\":\".post > strong > p > ins.adsbygoogle\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\"#sidebar_right > div.box > div.bg_white > div > div.fw-b > a[href^=\\\"http://yamare.co/amz\\\"]\",\"tasks\":[[\"upward\",4]]}"],["{\"selector\":\".menu_title3\",\"tasks\":[[\"has-text\",\"スポンサーリンク\"]]}"],["{\"selector\":\".custom-html-widget > p > ins.adsbygoogle\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\"#e-zone > h2 a[href=\\\"\\\"]\",\"tasks\":[[\"upward\",\"h2\"]]}","{\"selector\":\".ebody #ninja-blog-inactive\",\"tasks\":[[\"upward\",\".ebody\"]]}"],["{\"selector\":\"#entry #ninja-blog-inactive\",\"tasks\":[[\"upward\",\"#entry\"]]}"],["{\"selector\":\"\",\"tasks\":[[\"matches-path\",\"/mailfriend/livechat/\"],[\"spath\",\"#info3\"]]}","{\"selector\":\"table[cellpadding=\\\"4\\\"]\",\"tasks\":[[\"has-text\",\"[PR]\"],[\"spath\",\" + br + a[target=\\\"_blank\\\"] + b + font\"]]}","{\"selector\":\"table[cellpadding=\\\"4\\\"]\",\"tasks\":[[\"has-text\",\"[PR]\"],[\"spath\",\" + br + a[target=\\\"_blank\\\"] + b\"]]}","{\"selector\":\"table[cellpadding=\\\"4\\\"]\",\"tasks\":[[\"has-text\",\"[PR]\"],[\"spath\",\" + br + a[target=\\\"_blank\\\"]\"]]}","{\"selector\":\"table[cellpadding=\\\"4\\\"]\",\"tasks\":[[\"has-text\",\"[PR]\"],[\"spath\",\" + br + img + b + font + br + font[size=\\\"2\\\"]\"]]}","{\"selector\":\"table[cellpadding=\\\"4\\\"]\",\"tasks\":[[\"has-text\",\"[PR]\"],[\"spath\",\" + br + img + b + font\"]]}","{\"selector\":\"table[cellpadding=\\\"4\\\"]\",\"tasks\":[[\"has-text\",\"[PR]\"],[\"spath\",\" + br + img + b\"]]}","{\"selector\":\"table[width=\\\"100%\\\"][cellpadding=\\\"0\\\"][cellspacing=\\\"8\\\"]\",\"tasks\":[[\"has-text\",\"/と出会えそうな予感|顔出しオナニー素人のライブチャット|出会い特集|テレクラ特集|マゾ男向けのSM特集|男と男が出会いを探せる場所|が夢中に男を探し始めた！|素人女子のオナ声に癒されたい/\"]]}"],["{\"selector\":\".acr_ranking_sys > tbody > tr > td > div[id^=\\\"imobile_ad\\\"]\",\"tasks\":[[\"upward\",2]]}","{\"selector\":\".plugin-memo > div.side > div > script[src^=\\\"http://spdeliver.i-mobile.co.jp/script/ads.js\\\"]\",\"tasks\":[[\"upward\",3]]}"],["{\"selector\":\".pg-container-main-primary > section > div.pg-mod > h3.ttl-line-center\",\"tasks\":[[\"has-text\",\"PR\"]]}"],["{\"selector\":\".entryinner #ninja-blog-inactive\",\"tasks\":[[\"upward\",\".entryinner\"]]}"],["{\"selector\":\".aside-banner > div[id^=\\\"div-gpt-\\\"]\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\".innerframe > div.whiteboard > div > div.indent > center > div#ad_index_middle\",\"tasks\":[[\"upward\",5]]}","{\"selector\":\".innerframe > div.whiteboard > div > div.indent > div#ad_index_top\",\"tasks\":[[\"upward\",4]]}","{\"selector\":\".innerframe > div.whiteboard > div > div.indent > div#ad_kiji_middle\",\"tasks\":[[\"upward\",4]]}"],["{\"selector\":\".ad > div > a[href^=\\\"https://al.dmm.co.jp/\\\"]\",\"tasks\":[[\"upward\",2]]}"],["{\"selector\":\".side_main > img[src=\\\"img/index_book.gif\\\"]\",\"tasks\":[[\"upward\",1]]}","{\"selector\":\".side_main > img[src=\\\"img/index_series.gif\\\"]\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\"body > font[size=\\\"2\\\"]\",\"tasks\":[[\"has-text\",\"/^広告$/\"]]}"],["{\"selector\":\".plugin-memo > div.side > ins.adsbygoogle\",\"tasks\":[[\"upward\",2]]}"],["{\"selector\":\"[class]:is([class^=\\\"word_label\\\"], section[class^=\\\"word\\\"][class*=\\\"_detail\\\"])\",\"tasks\":[[\"has-text\",\"スポンサーリンク\"]]}"],["{\"selector\":\".left_column > h2\",\"tasks\":[[\"has-text\",\"おすすめのDL\"],[\"spath\",\" ~ div.tieup_rand_block\"]]}","{\"selector\":\".left_column > h2\",\"tasks\":[[\"has-text\",\"おすすめのDL\"]]}"],["{\"selector\":\".text-center > small\",\"tasks\":[[\"has-text\",\"PR\"]]}"],["{\"selector\":\".news_b table[border=\\\"0\\\"][cellpadding=\\\"5\\\"][style=\\\"background:#fff\\\"] > tbody > tr[bgcolor=\\\"#fff\\\"] > td.newsarea[style] > a.wl[href^=\\\"https://a\\\"][href*=\\\".to/\\\"]\",\"tasks\":[[\"upward\",2]]}","{\"selector\":\"td[style^=\\\"vertical-align: top\\\"] [onclick*=\\\"()\\\"][target=\\\"_blank\\\"]\",\"action\":[\"style\",\"pointer-events: none !important;\"],\"tasks\":[[\"has\",{\"selector\":\"[style*=\\\"background-image: url(\\\\\\\"data:image/jpg;\\\"]\",\"tasks\":[[\"matches-attr\",{\"attr\":\"style\",\"value\":\"/height\\\\s*:\\\\s*[12]\\\\d{2}\\\\.?\\\\d*px/\"}]]}]]}","{\"selector\":\"td[style^=\\\"vertical-align\\\"] [id] [class]\",\"action\":[\"style\",\"pointer-events: none !important;\"],\"tasks\":[[\"matches-css\",{\"name\":\"top\",\"value\":\"^[4-8]\\\\d{2}\\\\.?\\\\d*px$\"}],[\"spath\",\" [onclick*=\\\")\\\"]:has(b):not(:has(td > a))\"]]}","{\"selector\":\"td[style^=\\\"vertical-align\\\"] [id] [class]\",\"action\":[\"style\",\"pointer-events: none !important;\"],\"tasks\":[[\"matches-css\",{\"name\":\"top\",\"value\":\"^[4-8]\\\\d{2}\\\\.?\\\\d*px$\"}],[\"spath\",\" [onmousedown*=\\\")\\\"]:has(b):not(:has(td > a))\"]]}"],["{\"selector\":\"#sidebar-inner > div.plugin-memo\",\"tasks\":[[\"has-text\",\"スポンサードリンク\"]]}","{\"selector\":\".plugin-memo > div.side > div > div[id^=\\\"gad-fixed\\\"]\",\"tasks\":[[\"upward\",3]]}"],["{\"selector\":\".plugin-memo > div.side > center > div#verticalrank\",\"tasks\":[[\"upward\",3]]}"],["{\"selector\":\".plugin-memo > div.side > div#nav > div.adblock\",\"tasks\":[[\"upward\",3]]}","{\"selector\":\".plugin-memo > div.side > div.adblock\",\"tasks\":[[\"upward\",2]]}","{\"selector\":\".plugin-memo > div.side > div.gdblock\",\"tasks\":[[\"upward\",2]]}"],["{\"selector\":\".linklist > li > a[target=\\\"_blank\\\"]\",\"tasks\":[[\"has-text\",\"[PR]\"]]}"],["{\"selector\":\".footer_content > div.recommend_ads\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\".frame > div[style=\\\"background-color:transparent;\\\"] > ins.adsbygoogle\",\"tasks\":[[\"upward\",2]]}"],["{\"selector\":\"article.HomeBlogFeed_Article_Card > div.HomeBlogFeed_Article_Ad_Loading\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\"\",\"tasks\":[[\"matches-path\",\"/nao-angel-smile\"],[\"spath\",\"#entryBody > div[style]:has(> div.pickCreative_root)\"]]}","{\"selector\":\"#bigfooterpanel_general\",\"tasks\":[[\"upward\",1]]}","{\"selector\":\"h3[class^=\\\"_\\\"] + div > ul[class^=\\\"_\\\"] + div\",\"tasks\":[[\"has\",{\"selector\":\"> p[class^=\\\"_\\\"]\",\"tasks\":[[\"has-text\",\"PR\"]]}]]}"],["{\"selector\":\".block-mobile > div[class^=\\\"list\\\"] > script[src^=\\\"https://cdn-fluct.sh.adingo.jp/\\\"]\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\"\",\"tasks\":[[\"matches-path\",\"/gtav/\"],[\"spath\",\"a[href^=\\\"https://al.dmm.com\\\"]\"]]}","{\"selector\":\"\",\"tasks\":[[\"matches-path\",\"/gtav/\"],[\"spath\",\"a[href^=\\\"https://amzn.to\\\"]\"]]}","{\"selector\":\"\",\"tasks\":[[\"matches-path\",\"/gtav/\"],[\"spath\",\"a[href^=\\\"https://hb.afl.rakuten.co.jp\\\"]\"]]}","{\"selector\":\"\",\"tasks\":[[\"matches-path\",\"/gtav/\"],[\"spath\",\"a[href^=\\\"https://px.a8.net\\\"]\"]]}","{\"selector\":\"\",\"tasks\":[[\"matches-path\",\"/gtav/\"],[\"spath\",\"a[href^=\\\"https://www.dlsite.com/comic/dlaf/\\\"]\"]]}","{\"selector\":\"\",\"tasks\":[[\"matches-path\",\"/hachinai_nanj\"],[\"spath\",\".plugin_include:has(> table a[href=\\\"https://supponponclub.blog.jp/\\\"])\"]]}","{\"selector\":\"#atwiki-ads-overlay\",\"action\":[\"remove\",\"\"]}","{\"selector\":\"#menubar2 > div.atwiki-contents > div > object[id^=\\\"Player_\\\"]\",\"tasks\":[[\"upward\",3]]}","{\"selector\":\"#wikibody > div:not([id], [class]):nth-last-of-type(2):has(> a)\",\"tasks\":[[\"has-text\",\"<PR>\"]]}","{\"selector\":\"#wikibody > h3[id^=\\\"id_\\\"] > span[style=\\\"font-weight: bold;\\\"] > center\",\"tasks\":[[\"has-text\",\"広告\"],[\"upward\",2]]}"],["{\"selector\":\".news__item > div.news__item--ad\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\".l-sub__block > div.l-sub__bnr > div[id$=\\\"_Rectangle\\\"]\",\"tasks\":[[\"upward\",2]]}"],["{\"selector\":\".swiper-slide[data-history^=\\\"photo_extra\\\"]\",\"action\":[\"remove\",\"\"]}"],["{\"selector\":\".plugin-memo > div.side > ins.widget-banner\",\"tasks\":[[\"upward\",2]]}"],["{\"selector\":\".plugin-memo > div.side > a[href^=\\\"https://mintj.com/?\\\"][target=\\\"_blank\\\"]\",\"tasks\":[[\"upward\",2]]}","{\"selector\":\".plugin-memo > div.side > a[href^=\\\"https://www.cityheaven.net\\\"] > img\",\"tasks\":[[\"upward\",3]]}","{\"selector\":\".plugin-memo > div.side > div > a[name=\\\"amazletlink\\\"]\",\"tasks\":[[\"upward\",3]]}","{\"selector\":\".plugin-memo > div.side > div > div#verticalrank\",\"tasks\":[[\"upward\",3]]}","{\"selector\":\".plugin-memo > div.side > div.eroterest_partsv2\",\"tasks\":[[\"upward\",2]]}","{\"selector\":\".plugin-memo > div.side > div[align=\\\"center\\\"] > ins.adsbygoogle\",\"tasks\":[[\"upward\",3]]}","{\"selector\":\".plugin-memo > div.side > iframe.elogch_blogparts_iframe\",\"tasks\":[[\"upward\",2]]}","{\"selector\":\".plugin-memo > div.side > img[src*=\\\"a8.net/\\\"]\",\"tasks\":[[\"upward\",2]]}","{\"selector\":\".plugin-memo > div.side > script[src*=\\\".jp/ufo/\\\"]\",\"tasks\":[[\"upward\",2]]}","{\"selector\":\".plugin-memo > div.side > script[src*=\\\"dmm-rank.com\\\"]\",\"tasks\":[[\"upward\",2]]}","{\"selector\":\".plugin-memo > div.side > script[src^=\\\"//aztool.org\\\"]\",\"tasks\":[[\"upward\",2]]}","{\"selector\":\".plugin-memo > div.side > script[src^=\\\"//js.octopuspop.com\\\"]\",\"tasks\":[[\"upward\",2]]}","{\"selector\":\".plugin-memo > div.side > script[src^=\\\"https://ad999.biz\\\"]\",\"tasks\":[[\"upward\",2]]}","{\"selector\":\".plugin-memo > div.side > script[src^=\\\"https://adt.ad-spire.net\\\"]\",\"tasks\":[[\"upward\",2]]}"],["{\"selector\":\".plugin-memo > div.side > div > a[href^=\\\"https://al.dmm.co.jp/\\\"]\",\"tasks\":[[\"upward\",3]]}"],["{\"selector\":\".plugin-memo > div.side > div > script[src*=\\\"//adm.shinobi.jp\\\"]\",\"tasks\":[[\"upward\",3]]}"],["{\"selector\":\".plugin-memo > div.side > script[src^=\\\"//z-fe.amazon-adsystem.com\\\"]\",\"tasks\":[[\"upward\",2]]}"],["{\"selector\":\"font\",\"tasks\":[[\"has-text\",\"Sponsored Links\"]]}"],["{\"selector\":\"div[class$=\\\"t-column-inner\\\"] > center\",\"tasks\":[[\"has-text\",\"スポンサーリンク\"]]}"],["{\"selector\":\".plugin-memo > div.side > div.banner\",\"tasks\":[[\"upward\",2]]}"],["{\"selector\":\".main-container > div\",\"tasks\":[[\"has-text\",\"/^【スポンサードリンク】$/\"]]}"],["{\"selector\":\".plugin-memo > div.side > div[id^=\\\"blz_lock\\\"]\",\"tasks\":[[\"upward\",2]]}"],["{\"selector\":\".sidetitlebody > .sidetitle\",\"tasks\":[[\"has-text\",\"AD\"]]}"],["{\"selector\":\"table > tbody > tr\",\"tasks\":[[\"has\",{\"selector\":\"> td.txt-top > div.el-list em\",\"tasks\":[[\"has-text\",\"PR\"]]}]]}"],["{\"selector\":\".entry-content > div#a8rakutenadrank_pc\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\".csw-content-container > .ise-ad\",\"action\":[\"remove\",\"\"]}"],["{\"selector\":\".ccn-article-info li\",\"tasks\":[[\"has-text\",\"【PR】\"]]}"],["{\"selector\":\"#Center > div.partsHeading\",\"tasks\":[[\"has-text\",\"インタレスト\"]]}","{\"selector\":\".dparts.homeMainTable\",\"tasks\":[[\"has-text\",\"インタレストマッチ\"]]}","{\"selector\":\".homeRightTable > div.parts > div.partsBanner\",\"tasks\":[[\"upward\",2]]}"],["{\"selector\":\".feed-item > div[id^=\\\"div-gpt-\\\"]\",\"action\":[\"remove\",\"\"],\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\".pg-container-side div.cb-l1-m2 > div.cb > .OUTBRAIN\",\"tasks\":[[\"upward\",2]]}"],["{\"selector\":\"._popIn_recommend_container a._popIn_recommend_article_ad\",\"tasks\":[[\"upward\",\"._popIn_recommend_container\"]]}"],["{\"selector\":\".article > div[style=\\\"padding: 8px 0; font-weight: bold;\\\"]\",\"tasks\":[[\"has-text\",\"編集部おすすめ\"]]}","{\"selector\":\"headline > ul > li > a.pr\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\"#gpt_pc_blog_header\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\"#wrapper > div[style^=\\\"text-align:center;\\\"] > div[id^=\\\"div-gpt-ad\\\"]\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\".hatena-module-html > .hatena-module-body > div > div[id^=\\\"div-gpt-ad-\\\"]\",\"tasks\":[[\"upward\",3]]}"],["{\"selector\":\".main_1col > div.post_list > div.OUTBRAIN\",\"tasks\":[[\"upward\",2]]}","{\"selector\":\".main_1col > div.post_list > div.post_item > div[id^=\\\"div-gpt-\\\"]\",\"tasks\":[[\"upward\",3]]}","{\"selector\":\".main_1col > div.post_list > div[id^=\\\"logly-\\\"]\",\"tasks\":[[\"upward\",2]]}"],["{\"selector\":\"#cmsBody > div.inner > h2.format--crosshead\",\"tasks\":[[\"has-text\",\"/売れ筋ランキング|聴き放題！|楽天ポイント/\"]]}"],["{\"selector\":\"#cmsBody > div.inner > p:last-of-type:has(> * > a[href^=\\\"https://twitter.com/\\\"][target=\\\"_blank\\\"])\",\"tasks\":[[\"has-text\",\"作品提供\"],[\"spath\",\" ~ div.cmsAmazonWrap\"]]}"],["{\"selector\":\".article-list > li > script[src^=\\\"//yads.\\\"]\",\"tasks\":[[\"upward\",1]]}","{\"selector\":\"li[id^=\\\"top-news-article-\\\"] > a.article-ad\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\".block_ad > div.img_ad > div#adbnr-s > ins.adsbygoogle\",\"tasks\":[[\"upward\",3]]}"],["{\"selector\":\".top-articles > div[id^=\\\"div-gpt-\\\"]\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\"body #sb3\",\"tasks\":[[\"has-text\",\"[PR]\"]]}"],["{\"selector\":\".is-style-icon_announce\",\"tasks\":[[\"has\",{\"selector\":\"> a\",\"tasks\":[[\"has-text\",\"【PR】\"]]}]]}"],["{\"selector\":\"#Main > div > div.OUTBRAIN\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\"li > dl.pr\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\".l-section-side h2.c-heading-side-h2--otherStyle__text\",\"tasks\":[[\"upward\",\".l-section-side\"]]}","{\"selector\":\".p-content > #external-feed > .p-grid__item\",\"tasks\":[[\"has\",{\"selector\":\"> .p-content-header > .c-heading-h2--pr > .c-heading-h2--pr__inner > .c-heading-h2__text > span\",\"tasks\":[[\"has-text\",\"[PR]\"]]}]]}"],["{\"selector\":\"ul[class^=\\\"_taxel_row\\\"] > li > div[class^=\\\"_taxel_ad_article\\\"]\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\"\",\"tasks\":[[\"matches-path\",\"/negishinouen\"],[\"spath\",\"#content-sticky div.side_lo a[href$=\\\"/ranking.html\\\"] ~ a[target=\\\"_blank\\\"]:not([href$=\\\"/ranking.html\\\"])\"]]}","{\"selector\":\"\",\"tasks\":[[\"matches-path\",\"/negishinouen\"],[\"spath\",\"#content-sticky div.side_lo img[alt^=\\\"初めてさん歓迎！\\\"]\"]]}","{\"selector\":\"\",\"tasks\":[[\"matches-path\",\"/negishinouen\"],[\"spath\",\"#content-sticky div.sidefree > center > center:last-child > br\"]]}","{\"selector\":\"#content-side > table div[id*=\\\"Rak_Blog_User_SideBanner\\\"]\",\"tasks\":[[\"upward\",\"table\"]]}"],["{\"selector\":\".side-box > div[id^=\\\"rdn-adspot\\\"]\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\".c-content-main > h2:not([data-bg-pattern])\",\"tasks\":[[\"has-text\",\"こちらもおすすめ\"]]}"],["{\"selector\":\"#related-small-list > li > ins.adsbygoogle\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\".items-center > .flex-col.pb-8\",\"tasks\":[[\"has\",{\"selector\":\"> h3\",\"tasks\":[[\"has-text\",\"あわせて読みたい\"]]}]]}"],["{\"selector\":\".mb30 > h2\",\"tasks\":[[\"has-text\",\"スペシャルコンテンツ\"]]}"],["{\"selector\":\".hsNormal > div.bJava\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\"div[data-test-id=\\\"TeaserFourUpCol\\\"] > div > div[id^=\\\"ad-\\\"]\",\"tasks\":[[\"upward\",2]]}"],["{\"selector\":\"#yjSub > div.cmnBnr > div#ydn-mr\",\"tasks\":[[\"upward\",1]]}","{\"selector\":\"#yjSub > div.nav > div[id^=\\\"ydn-right-\\\"]\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\"#lsc div[class^=\\\"ClapLv3SearchList_Chie-SearchList__Item__\\\"]\",\"tasks\":[[\"has\",{\"selector\":\"> div > div[class*=\\\"__Information__\\\"] > div[class*=\\\"__InformationIcon__\\\"] > div[class*=\\\"__InformationText__\\\"]\",\"tasks\":[[\"has-text\",\"広告\"]]}]]}"],["{\"selector\":\"aside[class^=\\\"ClapLv3SubList_Chie-SubList__ListItem__\\\"] > div.infdAd\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\"#contents + div > div > div > div[class]:has(> div > div[id^=\\\"ad_\\\"])\",\"tasks\":[[\"matches-css\",{\"name\":\"padding-right\",\"value\":\"^12px$\"}]]}","{\"selector\":\"#contents + div > div[class^=\\\"wP-\\\"]:has(> div[class]:only-child > div[id^=\\\"ad_\\\"])\",\"tasks\":[[\"matches-css\",{\"name\":\"width\",\"value\":\"^300px$\"}]]}","{\"selector\":\"#contents > div > div > div\",\"tasks\":[[\"matches-css\",{\"name\":\"min-height\",\"value\":\"^150px$\"}],[\"spath\",\":has(div[id^=\\\"ad_\\\"])\"]]}","{\"selector\":\"#contents > div[class^=\\\"_\\\"] > div[class^=\\\"_\\\"] > div[class*=\\\"_\\\"]\",\"tasks\":[[\"matches-css\",{\"name\":\"min-height\",\"value\":\"^250px$\"}]]}","{\"selector\":\"#contents-body ~ div > div > div > div\",\"tasks\":[[\"has\",{\"selector\":\"> div[class]\",\"tasks\":[[\"matches-css\",{\"name\":\"min-height\",\"value\":\"^111px$\"}],[\"spath\",\" > div[id^=\\\"ad_\\\"]\"]]}]]}","{\"selector\":\"#contents-body ~ div > div > div\",\"tasks\":[[\"matches-css\",{\"name\":\"min-height\",\"value\":\"^150px$\"}],[\"spath\",\":has(div[id^=\\\"ad_\\\"])\"]]}","{\"selector\":\"div > #mainAdTop\",\"tasks\":[[\"upward\",1]]}","{\"selector\":\"div > div > div[class^=\\\"_\\\"] > div[class] > div[class*=\\\"_\\\"] > div[class]:has(> div[id^=\\\"ad_\\\"])\",\"tasks\":[[\"matches-css\",{\"name\":\"min-height\",\"value\":\"217px|42px\"}]]}","{\"selector\":\"div > div[class] > div[class*=\\\"_\\\"] > div[class]:has(> div[id^=\\\"ad_\\\"])\",\"tasks\":[[\"matches-css\",{\"name\":\"min-height\",\"value\":\"^200px$\"}]]}","{\"selector\":\"div > div[class^=\\\"wP-\\\"] div[class]\",\"tasks\":[[\"matches-css\",{\"name\":\"min-height\",\"value\":\"^250px$\"}]]}"],["{\"selector\":\"div[class*=\\\"__\\\"] > div[id$=\\\"ad1\\\"]\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\"#tagYadsDetail\",\"tasks\":[[\"upward\",1]]}","{\"selector\":\"#tagYadsListTop\",\"tasks\":[[\"upward\",1]]}","{\"selector\":\"#tagYadsSideColumn\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\"#contentsInner > div[class^=\\\"ContentWrapper_wrapper_\\\"]\",\"tasks\":[[\"has\",{\"selector\":\"> div[class^=\\\"SS_SS__\\\"] > ul > li > article > a > span\",\"tasks\":[[\"matches-css\",{\"name\":\"content\",\"pseudo\":\"before\",\"value\":\"^広告$\"}]]}]]}"],["{\"selector\":\".aside > div.category-list > span.ad-text03\",\"tasks\":[[\"upward\",2]]}"],["{\"selector\":\".p-article-reading-recommend-list-item > article > div[id^=\\\"ad_dfp\\\"]\",\"tasks\":[[\"upward\",2]]}"],["{\"selector\":\".wp-caption-text\",\"tasks\":[[\"has-text\",\"※楽天ブックスにリンクします\"]]}"],["{\"selector\":\".relation-block > div.OUTBRAIN\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\".p-10px > div.OUTBRAIN\",\"tasks\":[[\"upward\",1]]}","{\"selector\":\".sidebar-items > header.story-card-header.large\",\"tasks\":[[\"has-text\",\"zakスペシャル\"]]}"],["{\"selector\":\".homelist-in[style^=\\\"text-align:center;height:\\\"]\",\"action\":[\"remove\",\"\"]}"],["{\"selector\":\"div[align=\\\"center\\\"] > .badge-success\",\"tasks\":[[\"has-text\",\"スポンサード リンク\"]]}"],["{\"selector\":\".p-widget-list__item > div[id^=\\\"div-gpt-\\\"]\",\"action\":[\"remove\",\"\"],\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\".article center > div#SPREAD_VIDEO_PLAYER\",\"tasks\":[[\"upward\",\".article\"]]}","{\"selector\":\".blogbody center > div#SPREAD_VIDEO_PLAYER\",\"tasks\":[[\"upward\",\".blogbody\"]]}"],["{\"selector\":\".style_table > tbody > tr > td.style_td > div[class*=\\\"Rect\\\"][style^=\\\"margin:\\\"]\",\"tasks\":[[\"upward\",\"tr\"]]}"],["{\"selector\":\".plugin1_outline\",\"tasks\":[[\"has-text\",\"スポンサーバナー\"]]}"],["{\"selector\":\".owl-item > div.ad-wrapper\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\"div[class^=\\\"side_1cbox_\\\"] > div[class^=\\\"amazon_sbox\\\"]\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\".plugin-memo > div.side > script[src$=\\\"dlsite.com/js/blogparts.js\\\"]\",\"tasks\":[[\"upward\",2]]}","{\"selector\":\".plugin-memo > div.side > script[src^=\\\"//j.microad.net/\\\"]\",\"tasks\":[[\"upward\",2]]}"],["{\"selector\":\".plugin-memo > div.side > a[href*=\\\"px.a8.net/svt/ejp?\\\"]\",\"tasks\":[[\"upward\",2]]}","{\"selector\":\".plugin-memo > div.side > a[href^=\\\"http://atq.ck.valuecommerce.com/servlet/atq/referral?\\\"][target=\\\"_blank\\\"]\",\"tasks\":[[\"upward\",2]]}","{\"selector\":\".plugin-memo > div.side > center > script[src^=\\\"//z-fe.amazon-adsystem.com\\\"]\",\"tasks\":[[\"upward\",3]]}","{\"selector\":\".plugin-memo > div.side > div > ins.adsbygoogle\",\"tasks\":[[\"upward\",3]]}","{\"selector\":\".plugin-memo > div.side > div.amazon_adv\",\"tasks\":[[\"upward\",2]]}","{\"selector\":\".plugin-memo > div.side > div[align=\\\"center\\\"] > script[src$=\\\"/show_ads.js\\\"]\",\"tasks\":[[\"upward\",3]]}"],["{\"selector\":\".plugin-memo > div.side > div > a[href^=\\\"https://www.amazon.co.jp\\\"][target=\\\"_blank\\\"]\",\"tasks\":[[\"upward\",3]]}"],["{\"selector\":\".plugin-memo > div.side > div[id]\",\"tasks\":[[\"upward\",2]]}"],["{\"selector\":\".plugin-memo script[src]\",\"tasks\":[[\"upward\",\".plugin-memo\"]]}"],["{\"selector\":\"#sidebar-inner > div.plugin3_title\",\"tasks\":[[\"has-text\",\"スポンサードリンク\"]]}"],["{\"selector\":\"#sidebar > div.plugin-memo\",\"tasks\":[[\"has\",{\"selector\":\"> div.sidetitlebody > div.sidetitle\",\"tasks\":[[\"has-text\",\"/ad/\"]]}]]}"],["{\"selector\":\".plugin-memo > div.google-user-ad-side\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\".contents_ad01\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\".plugin_right > div > div.plugin-freearea > a[rel$=\\\"sponsored\\\"]\",\"tasks\":[[\"upward\",3]]}"],["{\"selector\":\"li > div.related-ad > ins.adsbygoogle\",\"tasks\":[[\"upward\",2]]}"],["{\"selector\":\".cMovieboxC > div.cPabox.babg\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\".bg--deep a[class*=\\\"gtm-ad\\\"]\",\"tasks\":[[\"upward\",\".bg--deep\"]]}"],["{\"selector\":\".content-rank > div > div.content-rank-img > a[href*=\\\"www.dlsite.com\\\"]\",\"tasks\":[[\"upward\",2]]}"],["{\"selector\":\".post-item > ins.adsbygoogle\",\"tasks\":[[\"upward\",1]]}","{\"selector\":\".related-post-item > ins.adsbygoogle\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\"#amzn-ranking-zone-title\",\"tasks\":[[\"has-text\",\"Amazon売り上げランキング\"]]}","{\"selector\":\".widget_catbox_widget.post-widgets-bottom > div > div.amzn-tabs-container\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\"div > div[style=\\\"text-align:center;\\\"] > ins.adsbygoogle\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\"#taboola-below-article-thumbnails-pcxrr\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\".s-Ranking_ListContainerWrapper:has(> .-amazon)\",\"action\":[\"remove\",\"\"]}","{\"selector\":\".s-Ranking_TabItem:last-child\",\"action\":[\"remove\",\"\"],\"tasks\":[[\"has-text\",\"Amazon\"]]}"],["{\"selector\":\".mainbody > h2\",\"tasks\":[[\"has-text\",\"おすすめ関連記事\"]]}"],["{\"selector\":\"#box2-inner > div.hatena-module\",\"tasks\":[[\"has\",{\"selector\":\"> div.hatena-module-title\",\"tasks\":[[\"has-text\",\"[AD]\"]]}]]}"],["{\"selector\":\".l-section > div.u-alignCenter > ins.adsbygoogle\",\"tasks\":[[\"upward\",2]]}"],["{\"selector\":\".ng-isolate-scope > li.ng-scope ins.adsbygoogle\",\"tasks\":[[\"upward\",\"li\"]]}"],["{\"selector\":\"#side > div.sidewrapper\",\"tasks\":[[\"has\",{\"selector\":\"> div.sidetitle\",\"tasks\":[[\"has-text\",\"★スポンサー\"]]}]]}","{\"selector\":\".entrybody > p > a[target=\\\"_blank\\\"][rel]\",\"tasks\":[[\"has-text\",\"【PR】\"]]}"],["{\"selector\":\".full_screen_ad\",\"action\":[\"remove\",\"\"]}"],["{\"selector\":\"#_popIn_recommend_carousel2_div > div._popIn_recommend_articles > ul._popIn_infinite_page > li > a._popIn_recommend_article_ad\",\"tasks\":[[\"upward\",2]]}","{\"selector\":\".l-ad32 > div[id^=\\\"div-gpt-\\\"]\",\"tasks\":[[\"upward\",1]]}","{\"selector\":\".post-image\",\"tasks\":[[\"has\",{\"selector\":\"> section.clear + figcaption\",\"tasks\":[[\"has-text\",\"【AD】\"]]}]]}","{\"selector\":\"div[class^=\\\"pr_list_contentsbox\\\"] > a > div > img[src^=\\\"https://ibarakinews.jp/images/common/PR_\\\"]\",\"tasks\":[[\"upward\",3]]}"],["{\"selector\":\".m-article-colm-list > div#recommend_pc\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\".column-inner-2 > div.plugin-memo\",\"tasks\":[[\"has\",{\"selector\":\"> div.sidetitlebody > div.sidetitle\",\"tasks\":[[\"has-text\",\"Amazon\"]]}]]}"],["{\"selector\":\".js-reward-gallery-modal\",\"action\":[\"remove\",\"\"]}","{\"selector\":\".js-reward-modal\",\"action\":[\"remove\",\"\"]}"],["{\"selector\":\"#entry .entry_title\",\"tasks\":[[\"has-text\",\"スポンサーサイト\"],[\"upward\",\"#entry\"]]}","{\"selector\":\".entry .entry_title\",\"tasks\":[[\"has-text\",\"スポンサーサイト\"],[\"upward\",\".entry\"]]}","{\"selector\":\".entry > h2\",\"tasks\":[[\"has-text\",\"スポンサーサイト\"],[\"upward\",1]]}","{\"selector\":\".entry_area > h2\",\"tasks\":[[\"has-text\",\"スポンサーサイト\"],[\"upward\",1]]}","{\"selector\":\".side_content > dl div#jgSideAdContainer\",\"tasks\":[[\"upward\",\"dl\"]]}"],["{\"selector\":\"ul[class^=\\\"top-news--items-\\\"] > li[class^=\\\"cmn-summary-\\\"] > div[id^=\\\"div-gpt-ad\\\"]\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\"#acrank_top td[id^=\\\"div-gpt-\\\"]\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\".right-col > .side-multiline-html-area ul ~ p\",\"tasks\":[[\"has-text\",\"広告\"]]}"],["{\"selector\":\"#recommendations > li > div[class^=\\\"ad\\\"]\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\".widget_text > div.widget_inner > div.textwidget > p > ins.adsbygoogle\",\"tasks\":[[\"upward\",4]]}"],["{\"selector\":\".plugin-memo > div.side > script[src$=\\\"/show_ads.js\\\"]\",\"tasks\":[[\"upward\",2]]}"],["{\"selector\":\".plugin-memo > div.side > div[class^=\\\"alistcloud-container\\\"]\",\"tasks\":[[\"upward\",2]]}"],["{\"selector\":\".plugin-memo > div.side > center > ins.dmm-widget-placement\",\"tasks\":[[\"upward\",3]]}"],["{\"selector\":\".related-wadai\",\"tasks\":[[\"has-text\",\"ベストセラー\"]]}"],["{\"selector\":\".plugin-memo > div.side > div.osusume-side\",\"tasks\":[[\"upward\",2]]}"],["{\"selector\":\".kanren > dl.clearfix\",\"tasks\":[[\"has-text\",\"【PR】\"]]}"],["{\"selector\":\"#RightPane > div.rs_preserve\",\"tasks\":[[\"has\",{\"selector\":\"> div.standardInfo > div.standardInfo_head_body > h2\",\"tasks\":[[\"has-text\",\"企業広告欄\"]]}]]}"],["{\"selector\":\".container05 > div.t_kokoku_title\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\".top_banner5_wrap\",\"tasks\":[[\"has-text\",\"広告欄\"]]}"],["{\"selector\":\"#wrapper > .box-content > .inner > .box-other.t1\",\"tasks\":[[\"has\",{\"selector\":\"> .title\",\"tasks\":[[\"has-text\",\"企業広告\"]]}]]}"],["{\"selector\":\"div[class^=\\\"ranking_sRanking_List_Wrapper\\\"] > div[class^=\\\"ranking_sRanking_List_Label\\\"]\",\"tasks\":[[\"has-text\",\"PR\"]]}","{\"selector\":\"div[class^=\\\"recommendArticles_pRecommend_\\\"] > div#cxMorePc\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\"\",\"action\":[\"style\",\"position: static !important;\"],\"tasks\":[[\"matches-path\",\"/kinisoku\"],[\"spath\",\"#aside[style]\"]]}","{\"selector\":\"\",\"action\":[\"style\",\"position: static!important;\"],\"tasks\":[[\"matches-path\",\"/goldennews\"],[\"spath\",\"#side-column[style^=\\\"position: fixed\\\"]\"]]}","{\"selector\":\"\",\"tasks\":[[\"matches-path\",\"/footcalcio\"],[\"spath\",\"#sub_left\"]]}","{\"selector\":\"\",\"tasks\":[[\"matches-path\",\"/goldennews/\"],[\"spath\",\"a[href^=\\\"https://www.amazon.co.jp\\\"], a[href^=\\\"https://amzn.to\\\"]\"]]}","{\"selector\":\"\",\"tasks\":[[\"matches-path\",\"/kinisoku\"],[\"spath\",\"#fix_sidewrapper\"]]}","{\"selector\":\"\",\"tasks\":[[\"matches-path\",\"/rbkyn844\"],[\"spath\",\".sidetitle\"],[\"has-text\",\"スポンサー\"]]}","{\"selector\":\"\",\"tasks\":[[\"matches-path\",\"/umadori0726\"],[\"spath\",\".entry-body > div[align=\\\"center\\\"]:has(+ div[class^=\\\"google-2ad\\\"])\"]]}","{\"selector\":\"#left_wrapper > div.area01 > p[style=\\\"”font-size:5pt;\\\"] + center\",\"tasks\":[[\"has-text\",\"スポンサードリンク\"]]}","{\"selector\":\"#sidebar > div.scroll > div.side-ad\",\"tasks\":[[\"upward\",1]]}","{\"selector\":\".article-body-inner > center > table > tbody > tr > td > div.ninja_onebutton\",\"tasks\":[[\"upward\",4]]}","{\"selector\":\".article-body-inner > center > table > tbody > tr > td > script[src$=\\\"/rakuten_widget.js\\\"]\",\"tasks\":[[\"upward\",4]]}","{\"selector\":\".article-body-inner > div.t_b ~ b > a[href^=\\\"https://www.amazon.co.jp/dp/\\\"]\",\"tasks\":[[\"upward\",1]]}","{\"selector\":\".article-body-inner > div[style=\\\"margin:0;padding:5px;font-size:12px;word-break: break-all;\\\"] > a[href^=\\\"https://al.dmm.co.jp\\\"]\",\"tasks\":[[\"upward\",1]]}","{\"selector\":\".article-body-more > div[align=\\\"center\\\"] > a[href^=\\\"https://www.sokmil.com/av/_item/\\\"]\",\"tasks\":[[\"upward\",1]]}","{\"selector\":\".article-outer-3 > div.article-option > h3 + div[style=\\\"text-align:center; margin-top:10px;\\\"] > script[type]\",\"tasks\":[[\"upward\",2]]}","{\"selector\":\".entry-content > link[href$=\\\"/default.css\\\"] + span[style=\\\"font-size:12px;\\\"]\",\"tasks\":[[\"has-text\",\"スポンサード\"]]}","{\"selector\":\".first-article > div[align=\\\"center\\\"] > p\",\"tasks\":[[\"has-text\",\"/^スポンサードリンク$/\"]]}","{\"selector\":\".plugin-memo > .side > a[href^=\\\"https://adf.shinobi.jp/\\\"]\",\"tasks\":[[\"upward\",2]]}","{\"selector\":\".plugin-memo > .side > a[href^=\\\"https://www.infocart.jp/\\\"]\",\"tasks\":[[\"upward\",2]]}","{\"selector\":\".plugin-memo > .side > a[href^=\\\"https://www.infotop.jp/click\\\"]\",\"tasks\":[[\"upward\",2]]}","{\"selector\":\".plugin-memo > div#gad-fixed-r2\",\"tasks\":[[\"upward\",1]]}","{\"selector\":\".plugin-memo > div.side > #mgs_Widget\",\"tasks\":[[\"upward\",2]]}","{\"selector\":\".plugin-memo > div.side > a[href^=\\\"http://550909.com/\\\"]\",\"tasks\":[[\"upward\",2]]}","{\"selector\":\".plugin-memo > div.side > a[href^=\\\"https://affiliate.suruga-ya.jp\\\"]\",\"tasks\":[[\"upward\",2]]}","{\"selector\":\".plugin-memo > div.side > a[href^=\\\"https://pcmax.jp/lp/\\\"]\",\"tasks\":[[\"upward\",2]]}","{\"selector\":\".plugin-memo > div.side > center > b > a[href^=\\\"https://amzn.to\\\"][target=\\\"_blank\\\"]\",\"tasks\":[[\"upward\",4]]}","{\"selector\":\".plugin-memo > div.side > center > iframe[src^=\\\"//rcm-fe.amazon-adsystem.com\\\"]\",\"tasks\":[[\"upward\",3]]}","{\"selector\":\".plugin-memo > div.side > center > script[src$=\\\"ziyu.net/js/dqnplus.js\\\"]\",\"tasks\":[[\"upward\",3]]}","{\"selector\":\".plugin-memo > div.side > div > a[href^=\\\"http://www.dmm.co.jp\\\"][style]\",\"tasks\":[[\"upward\",3]]}","{\"selector\":\".plugin-memo > div.side > div > b > a[href^=\\\"https://www.amazon.co.jp\\\"][target=\\\"_blank\\\"]\",\"tasks\":[[\"upward\",4]]}","{\"selector\":\".plugin-memo > div.side > div > div > iframe#gazoupickup_3\",\"tasks\":[[\"upward\",4]]}","{\"selector\":\".plugin-memo > div.side > div > ins.dmm-widget-placement\",\"tasks\":[[\"upward\",3]]}","{\"selector\":\".plugin-memo > div.side > div#ldb-user-ad-fixed\",\"tasks\":[[\"upward\",2]]}","{\"selector\":\".plugin-memo > div.side > div#verticalrank\",\"tasks\":[[\"upward\",2]]}","{\"selector\":\".plugin-memo > div.side > div.ad-center\",\"action\":[\"style\",\"visibility: hidden!important;height: 0 !important;\"],\"tasks\":[[\"upward\",2]]}","{\"selector\":\".plugin-memo > div.side > div.amazon_tool\",\"tasks\":[[\"upward\",2]]}","{\"selector\":\".plugin-memo > div.side > div.gad-fixed\",\"tasks\":[[\"upward\",2]]}","{\"selector\":\".plugin-memo > div.side > div.rakuad\",\"tasks\":[[\"upward\",2]]}","{\"selector\":\".plugin-memo > div.side > div.yms-user-ad-side\",\"tasks\":[[\"upward\",2]]}","{\"selector\":\".plugin-memo > div.side > div[id^=\\\"blz_dmm\\\"]\",\"tasks\":[[\"upward\",2]]}","{\"selector\":\".plugin-memo > div.side > iframe[src*=\\\"blogparts.dmm.com\\\"]\",\"tasks\":[[\"upward\",2]]}","{\"selector\":\".plugin-memo > div.side > iframe[src^=\\\"https://image.getchu.com/api/item_af\\\"]\",\"tasks\":[[\"upward\",2]]}","{\"selector\":\".plugin-memo > div.side > link[href^=\\\"https://pdn.adingo.jp/\\\"]\",\"tasks\":[[\"upward\",2]]}","{\"selector\":\".plugin-memo > div.side > p.gad\",\"tasks\":[[\"upward\",2]]}","{\"selector\":\".plugin-memo > div.side > script[src^=\\\"http://ws.amazon.co.jp\\\"]\",\"tasks\":[[\"upward\",2]]}","{\"selector\":\".plugin-memo > div.side > script[src^=\\\"https://cdn-fluct.sh.adingo.jp\\\"]\",\"tasks\":[[\"upward\",2]]}","{\"selector\":\".plugin-memo > div.side > script[src^=\\\"https://i-section\\\"]\",\"tasks\":[[\"upward\",2]]}","{\"selector\":\".plugin-memo > div.side > table a[href*=\\\"amazon.co.jp/exec\\\"][target=\\\"_blank\\\"] > img[src^=\\\"https://images-na.ssl-images-amazon.com\\\"]\",\"tasks\":[[\"upward\",\".plugin-memo\"]]}","{\"selector\":\".plugin-memo > div.side > table[style=\\\"color:darkblue; background-color: #FFFFFF\\\"][width$=\\\"305\\\"][border=\\\"1\\\"]\",\"tasks\":[[\"upward\",2]]}","{\"selector\":\".right > div.plugin-memo > div.side > p:last-of-type > a[href*=\\\"amazon.\\\"]:first-of-type\",\"tasks\":[[\"upward\",\".plugin-memo\"]]}"],["{\"selector\":\".plugin-memo > div.side > script[src^=\\\"//dameparts.com/pbanner/\\\"]\",\"tasks\":[[\"upward\",2]]}"],["{\"selector\":\".post-block > div#taboola-below-article-thumbnails\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\".swiper-slide-extra\",\"action\":[\"remove\",\"\"]}"],["{\"selector\":\".module-list-articles__item[style=\\\"padding:0px\\\"]\",\"action\":[\"remove\",\"\"]}"],["{\"selector\":\".featurelist > li > div[id^=\\\"ad-\\\"]\",\"tasks\":[[\"upward\",1]]}","{\"selector\":\".is-2col.articlelist > li > div[id^=\\\"ad-pc-article\\\"]\",\"action\":[\"remove\",\"\"],\"tasks\":[[\"upward\",1]]}","{\"selector\":\"section[id^=\\\"oblist\\\"] > div.OUTBRAIN\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\".l-sidebar_inner > div.c-secondarysection\",\"tasks\":[[\"has\",{\"selector\":\"> div.c-secondarysection_header > p.c-secondarysection_heading\",\"tasks\":[[\"has-text\",\"スポンサーサイト\"]]}]]}"],["{\"selector\":\".common-wrap > div.OUTBRAIN\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\".c-glo-section > aside.l-post-aside > div[id^=\\\"logly-\\\"]\",\"tasks\":[[\"upward\",2]]}","{\"selector\":\".c-glo-section > div[id^=\\\"logly\\\"]\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\"div[id^=\\\"cc_\\\"] > div[id^=\\\"div-gpt-\\\"]\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\"div[class$=\\\"BlockBase\\\"] > div > div > div.plugin-freearea > ins.dmm-widget-placement\",\"tasks\":[[\"upward\",4]]}","{\"selector\":\"div[class$=\\\"BlockBase\\\"] > div > div > div.plugin-freearea > script[src*=\\\"://js.\\\"][src*=\\\"/t/\\\"]\",\"tasks\":[[\"upward\",4]]}"],["{\"selector\":\".p-articlePageRelatedArticles__post > ins.adsbygoogle\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\"#sranking > div > dl a[onclick^=\\\"ga\\\"]\",\"tasks\":[[\"upward\",\"dl\"]]}"],["{\"selector\":\".feed01 > div.adMain\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\"dl.sidemenu_body\",\"tasks\":[[\"has\",{\"selector\":\"dt.plg_title\",\"tasks\":[[\"has-text\",\"スポンサー\"]]}]]}"],["{\"selector\":\".list-object__item > ins.adsbygoogle\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\".p-aside-section > div[id^=\\\"div-gpt-ad-\\\"]\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\"li[class$=\\\"_item\\\"] > div[id^=\\\"div-M_MD_gtx_\\\"]\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\"#new_article_alltop > li > div[id^=\\\"logly\\\"]\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\"section > a[href^=\\\"https://hb.afl.\\\"][onclick]\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\".sticky-height > section.article-list\",\"tasks\":[[\"has-text\",\"SPONSORD\"]]}"],["{\"selector\":\"body > p > ins.adsbygoogle\",\"tasks\":[[\"upward\",1]]}","{\"selector\":\"td[colspan=\\\"2\\\"]\",\"tasks\":[[\"has-text\",\"/^スポンサードリンク$/\"]]}"],["{\"selector\":\".list_base_nom > li > ins.adsbygoogle\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\"#NR-sub-in > aside > div.module-frame > div.areamatch\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\".articlePhotoList_articleNormal > a[data-osccid^=\\\"recommend_qa_ad\\\"] > div.img_crown\",\"tasks\":[[\"upward\",2]]}"],["{\"selector\":\"div[class^=\\\"sc-\\\"]:only-child > div:first-child > div[id^=\\\"rectangle_main_\\\"]\",\"tasks\":[[\"upward\",2]]}"],["{\"selector\":\".simple-header\",\"tasks\":[[\"has-text\",\"/izaスペシャル|あなたにオススメ/\"]]}"],["{\"selector\":\".c-box.ad\",\"action\":[\"remove\",\"\"]}"],["{\"selector\":\"#amazonSelector\",\"tasks\":[[\"upward\",1]]}","{\"selector\":\"#wrapAmazon\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\".MuiCard-root > ins.adsbygoogle\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\".l-aside-item-inner > ul.l-aside-prlist\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\"div[style=\\\"margin-left: -4px;\\\"] > a.auto[href*=\\\"/Ads\\\"]\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\"#side > div.mb-4.p-3 div.global-ad-info\",\"tasks\":[[\"upward\",\".p-3\"]]}"],["{\"selector\":\"#main_contents > .content\",\"tasks\":[[\"has\",{\"selector\":\"> h3.plg_header\",\"tasks\":[[\"has-text\",\"スポンサーリンク\"]]}]]}","{\"selector\":\"#sidemenu > .sidemenu_content\",\"tasks\":[[\"has\",{\"selector\":\"> h3.plg_header\",\"tasks\":[[\"has-text\",\"スポンサーリンク\"]]}]]}"],["{\"selector\":\"div[class^=\\\"banner\\\"] > a:not([href*=\\\"://www.ja\\\"])\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\".prBanner > ul > li > ins.adsbygoogle\",\"tasks\":[[\"upward\",3]]}"],["{\"selector\":\"#_popIn_recommend ul._popIn_infinite_page > li > a._popIn_recommend_article_ad\",\"tasks\":[[\"upward\",2]]}"],["{\"selector\":\".sidetitlebody > div.sidetitle\",\"tasks\":[[\"has-text\",\"スポンサードリンク\"]]}"],["{\"selector\":\"._popIn_infinite_page > a._popIn_recommend_article_ad_reserved\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\".col-xs-3[class$=\\\"tColumn\\\"] > ul > li > div.panel-default > div.panel-heading\",\"tasks\":[[\"has-text\",\"スポンサードリンク\"]]}"],["{\"selector\":\"#mainvisual-column div.slick-slide:has(> script)\",\"action\":[\"remove\",\"\"]}"],["{\"selector\":\".article-triple > div[id^=\\\"pc_pol_woman_recommend\\\"]\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\"main > .homepage\",\"action\":[\"style\",\"margin-top: 0px !important;\"],\"tasks\":[[\"not\",{\"selector\":\"\",\"tasks\":[[\"matches-css\",{\"name\":\"max-width\",\"value\":\"^1150px$\"}]]}]]}"],["{\"selector\":\"article > div > ins.adsbygoogle\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\"a[name=\\\"\\\"] + h2.title\",\"tasks\":[[\"has-text\",\"スポンサーサイト\"]]}"],["{\"selector\":\".p-newslist__item > div[id^=\\\"div-gpt-\\\"]\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\".contents > div.OUTBRAIN\",\"tasks\":[[\"upward\",1]]}","{\"selector\":\".contents > div.section_relation > div.uz-ny\",\"tasks\":[[\"upward\",2]]}"],["{\"selector\":\".plg > div > div.plugin-freearea > div.eroterest_partsv2\",\"tasks\":[[\"upward\",3]]}"],["{\"selector\":\"#main > table:first-child #ninja-blog-inactive\",\"tasks\":[[\"upward\",\"table\"]]}","{\"selector\":\".entryBlock #ninja-blog-inactive\",\"tasks\":[[\"upward\",\".entryBlock\"]]}","{\"selector\":\"div.EntryTitle\",\"tasks\":[[\"has\",{\"selector\":\"a[href=\\\"\\\"]\",\"tasks\":[[\"has-text\",\"[PR]\"]]}]]}"],["{\"selector\":\".EntryTitle > a[href=\\\"\\\"]\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\".sub_box > h4\",\"tasks\":[[\"has-text\",\"/^広告$/\"]]}"],["{\"selector\":\".pt-10 > ins.adsbygoogle\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\".section > h3\",\"tasks\":[[\"has-text\",\"今、あなたにおすすめの記事\"]]}"],["{\"selector\":\"#srdk-in-article-related-pc\",\"action\":[\"remove\",\"\"]}"],["{\"selector\":\"li > .p0[href^=\\\"https://amzn.to\\\"][title=\\\"Amazonを新しいタブで開く\\\"]\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\".list-recommend > h2\",\"tasks\":[[\"has\",{\"selector\":\"> span.line\",\"tasks\":[[\"has-text\",\"おすすめ情報\"]]}]]}"],["{\"selector\":\".section > div > div[class^=\\\"col-\\\"] > div[id^=\\\"div-gpt-ad\\\"]\",\"tasks\":[[\"upward\",3]]}","{\"selector\":\".section > div[id^=\\\"div-gpt-ad\\\"]\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\"div[class^=\\\"css-\\\"] > div:not([class]) > ins.adsbygoogle\",\"tasks\":[[\"upward\",2]]}"],["{\"selector\":\".sidebarcontents > div.pr\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\"#slider_list span.title-text\",\"tasks\":[[\"has-text\",\"おすすめPR\"],[\"upward\",\"#slider_list\"]]}"],["{\"selector\":\".news_list > li > ins.adsbygoogle\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\".heightLine-4 > div#pc-tmall-gamelist-gamelist\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\"#pickup-box > article div.ad-ranking\",\"tasks\":[[\"upward\",\"article\"]]}"],["{\"selector\":\".ta-c font[size=\\\"+1\\\"][color=\\\"#1a0dab\\\"]\",\"tasks\":[[\"has-text\",\"セフレ\"]]}"],["{\"selector\":\"table[width=\\\"446\\\"] > tbody > tr\",\"tasks\":[[\"has-text\",\"セックスライフ必需品\"]]}"],["{\"selector\":\".vjs-text-track-display > div\",\"action\":[\"style\",\"background: none !important;\"],\"tasks\":[[\"matches-css\",{\"name\":\"background-color\",\"value\":\"^rgb\\\\(0, 0, 0\\\\)$\"}]]}"],["{\"selector\":\".entry-content > p > a[href^=\\\"//af.moshimo.com\\\"]\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\".together-posts > li > div[id^=\\\"logly-\\\"]\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\"#right_menu > h1:first-child\",\"tasks\":[[\"has-text\",\"/^Information$/\"]]}","{\"selector\":\"#wiki_menu.left_side > h2:only-of-type\",\"tasks\":[[\"has-text\",\"/^管理者のススメ$/\"]]}","{\"selector\":\"#wiki_menu.left_side > p > a[href^=\\\"http://www.sekaimon.com/\\\"]\",\"tasks\":[[\"upward\",1]]}","{\"selector\":\"#wiki_menu.left_side > p > a[href^=\\\"https://www.amazon.co.jp/gp/\\\"]\",\"tasks\":[[\"upward\",1]]}","{\"selector\":\"#wiki_menu.left_side > p > a[href^=\\\"https://www.powera.com/\\\"]\",\"tasks\":[[\"upward\",1]]}","{\"selector\":\".sidebar > p > a[href^=\\\"https://www.amazon.co.jp/ref=assoc_\\\"]\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\"#text2 > p + p + p\",\"tasks\":[[\"has-text\",\"スポンサーリンク\"]]}"],["{\"selector\":\"#mybox > ul > li > div.textwidget > ins.adsbygoogle\",\"tasks\":[[\"upward\",3]]}","{\"selector\":\".hentry > aside > script + div\",\"tasks\":[[\"has-text\",\"スポンサーリンク\"]]}","{\"selector\":\".kizi-under-box > div.textwidget > p\",\"tasks\":[[\"has-text\",\"スポンサーリンク\"]]}"],["{\"selector\":\".plugin-memo > div.side > div > a[href^=\\\"https://www.e-nls.com/access.php\\\"]\",\"tasks\":[[\"upward\",3]]}"],["{\"selector\":\".plugin-memo > div.side > div > script[src^=\\\"//p.permalink-system.com\\\"]\",\"tasks\":[[\"upward\",3]]}"],["{\"selector\":\".clickable-sentence iframe[src^=\\\"https://rcm-fe.\\\"]\",\"tasks\":[[\"upward\",\".clickable-sentence\"]]}","{\"selector\":\".side-component a[href^=\\\"https://www.amazon.co.jp/\\\"]\",\"tasks\":[[\"upward\",\".side-component\"]]}"],["{\"selector\":\".c-search-item > ins.adsbygoogle\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\".widget_custom_html > div > div[id^=\\\"jp_crv_\\\"]\",\"tasks\":[[\"upward\",2]]}"],["{\"selector\":\"ul[class^=\\\"list-comic-\\\"] > li > div.native-ad-wrap\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\"#left > h3:first-child\",\"tasks\":[[\"has-text\",\"[PR 広告]\"]]}"],["{\"selector\":\".st-Related_Title\",\"tasks\":[[\"has-text\",\"おすすめ画像メーカー\"]]}"],["{\"selector\":\".blockContainer > div[id^=\\\"logly-\\\"]\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\"div[class$=\\\"-block\\\"] > div.m-ad-rectangle\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\".plugin-memo > div.side > script[src^=\\\"//static.criteo.net\\\"]\",\"tasks\":[[\"upward\",2]]}"],["{\"selector\":\".nend_text_ad\",\"tasks\":[[\"upward\",\"li\"]]}"],["{\"selector\":\".archive__item > ins.adsbygoogle\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\"#more > b\",\"tasks\":[[\"not\",{\"selector\":\"\",\"tasks\":[[\"has-text\",\"まとめもり～\"]]}]]}"],["{\"selector\":\"#EntryBlock > .EntryTextBox #ninja-blog-inactive\",\"tasks\":[[\"upward\",\".EntryTextBox\"]]}","{\"selector\":\"#EntryListBlock > article #ninja-blog-inactive\",\"tasks\":[[\"upward\",\"article\"]]}"],["{\"selector\":\"#site-box #d-box + div > font\",\"tasks\":[[\"has-text\",\"/^スポンサーリンク$/\"]]}","{\"selector\":\"#site-box > #b-box > div > font\",\"tasks\":[[\"has-text\",\"/^スポンサーリンク$/\"]]}","{\"selector\":\"table[summary] > tbody > tr[align=\\\"left\\\"][bgcolor]\",\"tasks\":[[\"has\",{\"selector\":\"> td > font\",\"tasks\":[[\"has-text\",\"/^スポンサーリンク$/\"]]}]]}"],["{\"selector\":\".posts-under-1 > div.execphpwidget > div.idname\",\"tasks\":[[\"has-text\",\"【PR】\"]]}"],["{\"selector\":\".ranklist table:not([class]) > tbody > tr > td[colspan=\\\"3\\\"]\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\".col-lg-4 > .p-t-1\",\"tasks\":[[\"has\",{\"selector\":\"> h5\",\"tasks\":[[\"has-text\",\"広告\"]]}]]}"],["{\"selector\":\"#MainBlock > div > div > #ninja-blog-inactive\",\"tasks\":[[\"upward\",2]]}"],["{\"selector\":\".column > div.card > div.adv\",\"tasks\":[[\"upward\",2]]}"],["{\"selector\":\".footer_ranking_wrap > div.osusume_av_wrapper\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\".blockAreaMainFooter > div.blockWrapper > div.blockBody > div.eroterest_partsv2\",\"tasks\":[[\"upward\",2]]}","{\"selector\":\".blockAreaMainMiddle > div.blockWrapper > .blockBody > h2 + div[style=\\\"padding:10px;\\\"] > a[href^=\\\"https://al.dmm.co.jp\\\"][target=\\\"_blank\\\"] > img[style=\\\"border-radius:15px;border:5px solid #dedede;\\\"]\",\"tasks\":[[\"upward\",3]]}","{\"selector\":\".blockSide > div.blockWrapper > div > div[class$=\\\"eroterest_partsv2\\\"]\",\"tasks\":[[\"upward\",2]]}","{\"selector\":\".blockSide > div.blockWrapper > div.blockBody > center > ins.dmm-widget-placement\",\"tasks\":[[\"upward\",3]]}","{\"selector\":\".blockSide > div.blockWrapper > div.blockBody > div > a[href^=\\\"https://click.duga.jp\\\"]\",\"tasks\":[[\"upward\",2]]}"],["{\"selector\":\".widget_text > div.textwidget > div.eroterest_partsv2\",\"tasks\":[[\"upward\",2]]}","{\"selector\":\".widget_text > div.textwidget > p > ins.dmm-widget-placement\",\"tasks\":[[\"upward\",3]]}"],["{\"selector\":\".blockWrapper div[id^=\\\"mhub-\\\"]\",\"tasks\":[[\"upward\",\".blockWrapper\"]]}"],["{\"selector\":\".epad #ninja-blog-inactive\",\"tasks\":[[\"upward\",\".epad\"]]}"],["{\"selector\":\".entry-body > center\",\"tasks\":[[\"has-text\",\"スポンサーリンク\"]]}"],["{\"selector\":\"aside > h4.card-panel\",\"tasks\":[[\"has-text\",\"ライブ配信\"]]}"],["{\"selector\":\"div[id^=\\\"plist\\\"] > div:not([class])\",\"action\":[\"remove\",\"\"]}"],["{\"selector\":\"#extra div.sidetitle\",\"tasks\":[[\"has-text\",\"DMM\"]]}"],["{\"selector\":\".caption1\",\"tasks\":[[\"has-text\",\"関連DUGA動画\"]]}","{\"selector\":\"[class^=\\\"caption\\\"]\",\"tasks\":[[\"has-text\",\"PR\"]]}"],["{\"selector\":\".pc_only.fp_list_each > div.pc_only_ad\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\".pluginWrap > div > div > a[target=\\\"_blank\\\"][rel=\\\"noopener\\\"] > img\",\"tasks\":[[\"upward\",4]]}"],["{\"selector\":\"#recommended > div > div.floatL > a > img[title^=\\\"[PR]\\\"]\",\"tasks\":[[\"upward\",3]]}"],["{\"selector\":\".entryContents > h3\",\"tasks\":[[\"has-text\",\"おすすめ記事\"]]}"],["{\"selector\":\".classic-text-widget > ins.adsbygoogle\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\".bottombox > div > span[class=\\\"accent\\\"]\",\"tasks\":[[\"upward\",2]]}","{\"selector\":\".sentence > p + div.width75\",\"tasks\":[[\"has\",{\"selector\":\"> div[align=\\\"center\\\"]\",\"tasks\":[[\"has-text\",\"/^スポンサード リンク$/\"]]}]]}"],["{\"selector\":\"\",\"tasks\":[[\"matches-path\",\"/^\\\\/$/\"],[\"spath\",\"section > div.card > div.date span.catab\"],[\"has-text\",\"広告\"],[\"upward\",\"section\"]]}"],["{\"selector\":\".cst > div.inNews > div.flex > div[id^=\\\"div-gpt-\\\"]\",\"tasks\":[[\"upward\",3]]}"],["{\"selector\":\".plugin-memo > div.side div.ad-center\",\"tasks\":[[\"upward\",\".plugin-memo\"]]}"],["{\"selector\":\"div > center\",\"tasks\":[[\"has-text\",\"Sponsored Link\"]]}"],["{\"selector\":\".plugin_item ins.adsbygoogle\",\"tasks\":[[\"upward\",\".plugin_item\"]]}"],["{\"selector\":\".plugin-memo > div.side > div > script[src$=\\\"/rakuten_widget.js\\\"]\",\"tasks\":[[\"upward\",3]]}"],["{\"selector\":\".plg_area > h2.plg_title\",\"tasks\":[[\"has-text\",\"スポンサー\"],[\"upward\",1]]}"],["{\"selector\":\".ta-c > b > font[size=\\\"+1\\\"]\",\"tasks\":[[\"has-text\",\"PCMAX\"]]}","{\"selector\":\".ta-c > font[size=\\\"+1\\\"] > b\",\"tasks\":[[\"has-text\",\"/バイアグラ|日本最大級の会員/\"]]}","{\"selector\":\".ta-c > form > font[size=\\\"+1\\\"] > b\",\"tasks\":[[\"has-text\",\"/会員数|ハッピーメール/\"]]}"],["{\"selector\":\".l-contents > div > div.p-ad\",\"tasks\":[[\"upward\",2]]}","{\"selector\":\".type_button > a[target=\\\"_blank\\\"]\",\"tasks\":[[\"not\",{\"selector\":\"\",\"tasks\":[[\"has-text\",\"読む\"]]}]]}"],["{\"selector\":\".entry[data-type=\\\"space\\\"] script[src^=\\\"https://img.ad-nex.com/\\\"]\",\"tasks\":[[\"upward\",\".entry\"]]}"],["{\"selector\":\".menu_div > center > ins.contents_ad_main\",\"tasks\":[[\"upward\",2]]}"],["{\"selector\":\"#content > p\",\"tasks\":[[\"has-text\",\"スポンサーリンク\"]]}"],["{\"selector\":\"#text-2 > div.textwidget > p > ins.adsbygoogle\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\"aside > div.plugin-memo\",\"tasks\":[[\"has\",{\"selector\":\"> div.sidetitlebody > div.sidetitle\",\"tasks\":[[\"has-text\",\"スポンサードリンク\"]]}]]}"],["{\"selector\":\".entry #SPREAD_VIDEO_PLAYER\",\"tasks\":[[\"upward\",\".entry\"]]}"],["{\"selector\":\"#dmm_ranking_pc_more ~ h2\",\"tasks\":[[\"has-text\",\"ランキ��グ\"]]}"],["{\"selector\":\".-freeArea ins.adsbygoogle\",\"tasks\":[[\"upward\",\".-freeArea\"]]}"],["{\"selector\":\".hidden-sm > p > a[data-target=\\\"#adModal\\\"]\",\"tasks\":[[\"upward\",2]]}"],["{\"selector\":\".side--right > section.module--free\",\"tasks\":[[\"has-text\",\"スポンサーリンク\"]]}"],["{\"selector\":\".article__bottom__container > div.article__bottom__ad__container\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\".module--free > center > a[href^=\\\"https://prf.hn\\\"]\",\"tasks\":[[\"upward\",2]]}","{\"selector\":\".module--free > center > script[src*=\\\"//adm.shinobi.jp\\\"]\",\"tasks\":[[\"upward\",2]]}","{\"selector\":\".module--free > center > script[src*=\\\"i-mobile.co.jp\\\"]\",\"tasks\":[[\"upward\",2]]}"],["{\"selector\":\"#links > div.sidetitle\",\"tasks\":[[\"has-text\",\"注目\"]]}"],["{\"selector\":\".module--free h3.module__heading\",\"tasks\":[[\"has-text\",\"スポンサーリンク\"]]}"],["{\"selector\":\".jbbsCustomHeader > table[width=\\\"95%\\\"] #tokuwari\",\"tasks\":[[\"upward\",\"table[width=\\\"95%\\\"]\"]]}","{\"selector\":\".jbbsCustomHeader > table[width=\\\"95%\\\"] a[href=\\\"http://wiki.livedoor.jp/fuzokuwiki/\\\"]\",\"tasks\":[[\"upward\",\"table[width=\\\"95%\\\"]\"]]}","{\"selector\":\".jbbsCustomHeader > table[width=\\\"95%\\\"] td > a[href^=\\\"http://seesaawiki.\\\"]\",\"tasks\":[[\"upward\",\"table[width=\\\"95%\\\"]\"]]}"],["{\"selector\":\".entrys #ninja-blog-inactive\",\"tasks\":[[\"upward\",\".entrys\"]]}"],["{\"selector\":\"#sitemap_right > div.ul_main > h3\",\"tasks\":[[\"has-text\",\"ADリンク\"],[\"upward\",1]]}"],["{\"selector\":\".entry-content > center > ins.adsbygoogle\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\".genre > ul > li.pr\",\"action\":[\"remove\",\"\"]}"],["{\"selector\":\"p.text-center.caption\",\"tasks\":[[\"has-text\",\"/^スポンサーリンク/\"]]}"],["{\"selector\":\".art_li[style^=\\\"width\\\"]\",\"action\":[\"remove\",\"\"]}"],["{\"selector\":\".contents_title > a[href=\\\"\\\"]\",\"tasks\":[[\"upward\",1]]}","{\"selector\":\".entry_foot > a[title=\\\"[PR]の記事トップへ\\\"]\",\"tasks\":[[\"upward\",1]]}","{\"selector\":\".entry_main #ninja-blog-inactive\",\"tasks\":[[\"upward\",\".entry_main\"]]}","{\"selector\":\".entry_state > a[href=\\\"\\\"]\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\"#EntryBlock > .w1 #ninja-blog-inactive\",\"tasks\":[[\"upward\",\".w1\"]]}"],["{\"selector\":\".archive-entry > ins.adsbygoogle\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\".entry-content > p[style=\\\"text-align: center;\\\"]\",\"tasks\":[[\"has-text\",\"スポンサーリンク\"]]}"],["{\"selector\":\"#rank li > iframe[src^=\\\"/ad_frame.\\\"]\",\"tasks\":[[\"upward\",\"li\"]]}"],["{\"selector\":\".box-onetag-rec\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\"#secondary > div.widget_text a[href^=\\\"https://al.dmm.com/\\\"]\",\"tasks\":[[\"upward\",1]]}","{\"selector\":\"#secondary > div.widget_text a[href^=\\\"https://amzn\\\"]\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\".SimpleBox > p[style^=\\\"padding-left:\\\"] > a[href]\",\"tasks\":[[\"has-text\",\"[PR]\"]]}"],["{\"selector\":\".newslist__item > div[id^=\\\"div-gpt-\\\"]\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\"article > a[href^=\\\"https://al.dmm.co.jp\\\"]\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\"aside > h3\",\"tasks\":[[\"has-text\",\"Rapidgator\"],[\"spath\",\" + div.custom-html-widget\"]]}","{\"selector\":\"aside > h3\",\"tasks\":[[\"has-text\",\"Rapidgator\"]]}"],["{\"selector\":\"#log-1[colspan=\\\"2\\\"]\",\"tasks\":[[\"has-text\",\"スポンサードリンク\"]]}","{\"selector\":\"body > div:not([style]) > ins.adsbygoogle\",\"tasks\":[[\"upward\",1]]}","{\"selector\":\"div[style=\\\"margin-left:175px;zoom:1;\\\"] > div[style=\\\"margin-top:10px;\\\"]\",\"tasks\":[[\"has-text\",\"/^スポンサードリンク$/\"]]}"],["{\"selector\":\".bigpickupin > a[href^=\\\"https://www.dmm.co.jp\\\"]\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\".elementor-heading-title\",\"tasks\":[[\"has-text\",\"Sponsored Links\"]]}"],["{\"selector\":\"#box2-inner > .hatena-module-html\",\"tasks\":[[\"has-text\",\"スポンサーリンク\"]]}"],["{\"selector\":\"div.center[style=\\\"margin-top:20px;min-height:167px;\\\"] > ins.adsbygoogle\",\"tasks\":[[\"upward\",1]]}"],["{\"selector\":\"p a[href^=\\\"//ck.jp.ap.\\\"]\",\"tasks\":[[\"upward\",\"p\"]]}","{\"selector\":\"p a[href^=\\\"https://px.\\\"]\",\"tasks\":[[\"upward\",\"p\"]]}"],["{\"selector\":\".entry-content > p:nth-of-type(2) > a:first-of-type > img\",\"tasks\":[[\"xpath\",\"//div[contains(@class, \\\"entry-content \\\")]//a[@target=\\\"_blank\\\" and contains(@rel, \\\"noopener\\\") and not(@href=ancestor::div[contains(@class, \\\"entry-content \\\")]/p[2]/a[1]/@href)]/img\"]]}"],["{\"selector\":\".c-article-footer-title\",\"tasks\":[[\"has-text\",\"/^関連(記事|動画)/\"]]}"],["{\"selector\":\".grid > div[id^=\\\"div_fam_async_\\\"]\",\"action\":[\"remove\",\"\"],\"tasks\":[[\"upward\",1]]}","{\"selector\":\"li.large.grid\",\"action\":[\"remove\",\"\"]}"],["{\"selector\":\"div[align=\\\"center\\\"][style=\\\"margin: 20px 0px;\\\"]\",\"tasks\":[[\"has-text\",\"/^- PR -$/\"]]}"],["{\"selector\":\".container > div.sub-content > div[align=\\\"center\\\"]\",\"tasks\":[[\"has-text\",\"/^- PR -$/\"]]}"],["{\"selector\":\".menu_underh2\",\"tasks\":[[\"has-text\",\"PCMAX\"]]}"],["{\"selector\":\".entry > h3\",\"tasks\":[[\"has-text\",\"こちらの記事も\"]]}"]];

const hostnamesMap = new Map([["gokkun.biz",[0,1]],["otokonoko.biz",[0,1]],["petanko.biz",[0,1]],["anarumama.com",[0,1]],["aokanmama.com",[0,1]],["ashikosu.com",[0,1]],["bata-wagina.com",[0,1]],["carsexspot.com",0],["chikubi-mu.com",[0,1]],["girikoki.com",[0,1]],["mazomenzu.com",[0,1]],["miwakunotango.com",[0,1]],["nanpamama.com",[0,1]],["ninshinmama.com",[0,1]],["nosemania.com",[0,1]],["pakomanmama.com",[0,1]],["panchirarizumu.com",[0,1]],["passion-passion.com",0],["peepspider.com",[0,1]],["pisuton.com",[0,1]],["sadomazomama.com",[0,1]],["sukatoromama.com",[0,1]],["taitsukingu.com",[0,1]],["tsubahaki.com",[0,1]],["worldporuno.com",[0,1]],["blackgal.net",[0,1]],["boindoru.net",[0,1]],["dadamore.net",[0,1]],["erocampus.net",[0,1]],["gerorian.net",[0,1]],["hamemama.net",0],["hipup.net",[0,1]],["kochokocho.net",[0,1]],["muchimuchimama.net",[0,1]],["meisaku.org",[0,1]],["kagua.biz",2],["livedoor.biz",[3,4,5,6]],["2chcopipe.com",[3,26]],["eroduma.com",3],["itaishinja.com",[3,156]],["news109.com",3],["blog.jp",[3,4,5,14,17,26,33,218,238,296,297,298,299,300]],["blog.livedoor.jp",[3,4,5,6,14,16,17,33,218,238,296,298,299,300,359,361,395,396,405,406]],["2chblog.jp",[4,5,172,283]],["doorblog.jp",[4,5,14,17,33,238,300,359,360,361]],["youblog.jp",[4,16,296,361,477]],["livedoor.blog",[5,14,15,16,17]],["akb48matomemory.com",5],["kitizawa.com",5],["news-buzz1.com",5],["oumaga-times.com",5],["paranormal-ch.com",[5,172]],["shuraba-matome.com",5],["blogo.jp",5],["ldblog.jp",[5,17,33,238,300,394,395,396]],["vipnews.jp",5],["kyousoku.net",5],["akb48taimuzu.livedoor.biz",7],["michaelsan.livedoor.biz",8],["namaeuranai.biz",9],["asobu.blog",10],["betweenjpandkr.blog",11],["lifematome.blog",12],["happy-news-style.com",12],["japan-hentai.com",12],["31012.jp",12],["lionmaru.blog",13],["moetataiken.com",[16,193]],["nadarenews.com",[16,172]],["syurabahazard.com",17],["valorantchannel.livedoor.blog",18],["jetstream.bz",19],["miyachan.cc",20],["niiblo.jp",20],["tamaliver.jp",[20,113]],["osakazine.net",[20,527]],["ti-da.net",20],["sekisei.click",21],["yaamjw.click",22],["anime-festa.com",[22,37,38]],["anime-report.com",[22,37,42,43]],["anime-voice.com",[22,37,38,44]],["animegoe.com",[22,37,38,39,45]],["bangofan.com",[22,37,57,58,59]],["bijual.com",[22,37,40,41,62]],["blog-fps.com",[22,37,39]],["cosplay-festa.com",[22,37,45]],["cosplay-navi.com",[22,37,39,67]],["cosplay-report.com",[22,45]],["game-ss.com",[22,37,123]],["iku4.com",[22,37]],["kakuren-bo.com",[22,37,41,165]],["ko-me.com",[22,37,39,41]],["koushijima.com",[22,37,39,41,45,85,138]],["living-myself.com",22],["mamagoto.com",[22,37,41,57,58]],["mangalog.com",[22,37,38,41,67,138,188]],["mmo-fps.com",[22,37,39,41,44,45,58,59,192]],["ms-inst.com",22],["pazru.com",[22,37,41,220]],["sankuzushi.com",[22,37,39,45,85,233]],["satsumablog.com",[22,37,39,40,41,44,85,138,151,200,207,234]],["sugo-roku.com",[22,37,41,67]],["tyoshublog.com",[22,37,39,45]],["ya-gasuri.com",[22,37,58,59,207]],["blog.shinobi.jp",[22,37,38,41,57,58,123,166,192,200,232,268,453,454]],["99ing.net",[22,37,38,41,490]],["anime-japan.net",[22,37,65]],["anime-movie.net",[22,37,38,39,65]],["anime-navi.net",[22,37,39]],["anime-ranking.net",[22,138]],["animech.net",[22,39,207]],["cos-mania.net",[22,37]],["cosplay-japan.net",[22,39,43]],["fukuwarai.net",[22,37,44,232,454]],["gjgd.net",[22,37,41,67,85,123,138,151,234]],["gjpw.net",[22,37,44,65,138]],["go-th.net",[22,41,138]],["kai-seki.net",[22,37,39,41,45,57,58]],["ky-3.net",[22,37,41,85]],["mangadou.net",[22,37,39]],["ni-3.net",[22,37,41]],["o-oi.net",[22,37,41]],["p-kin.net",[22,37,38,39,45,62,65]],["yamatoblog.net",[22,37,65,85]],["eroangle.club",23],["amaebi.co",24],["2ch-mma.com",25],["afo-news.com",25],["newsnow-2ch.com",25],["besttrendnews.net",25],["konowaro.net",25],["matometatta-news.net",[25,522]],["news-choice.net",25],["news-three-stars.net",25],["blog.2nt.com",[27,28,29]],["blog.fc2.com",[27,29,99,100,101,102]],["sennenaigis.jp",[29,102]],["nikonikona.blog.2nt.com",30],["ac-illust.com",31],["akb48rompen.com",[32,33]],["burusoku-vip.com",33],["crx7601.com",[33,81]],["squallchannel.com",33],["taikankyohou.com",33],["tsuisoku.com",33],["baseballstats2011.jp",33],["dreamlog.jp",[33,299]],["gootore.xyz",33],["angel-bbs.com",34],["anihatsu.com",35],["animanch.com",36],["anime-cosplay.com",[37,38,39,40]],["anime-life.com",[37,39,41]],["bangalog.com",[37,39,40,41,44,56]],["blog-mmo.com",[37,41,65,66]],["blog-rpg.com",[37,41,67]],["blog-sim.com",[37,43,45,68]],["coelacanth108.com",37],["cos-live.com",[37,39,45,62]],["dankanoko.com",[37,39,41,45,57,58]],["darumasangakoronda.com",[37,44,82]],["dou-jin.com",[37,85]],["en-grey.com",[37,41]],["escapepower.com",37],["futatsutomoe.com",[37,40,41,44,121]],["gg-blog.com",[37,41]],["guhaw.com",[37,41,67,138]],["iga-log.com",[37,151,152]],["indiesj.com",[37,38,40,41,62]],["kagome-kagome.com",[37,39,138]],["kamakurablog.com",[37,41,43,62,166]],["kazamidori-o.com",37],["komochijima.com",[37,39,44]],["kurofuku.com",[37,39,41,179]],["manga-cosplay.com",[37,38,82]],["misujitate.com",[37,39]],["moe-cosplay.com",[37,39,44]],["nari-kiri.com",[37,39,41,44,45,65,200]],["ni-moe.com",[37,45,85,207]],["no-mania.com",[37,38,39]],["or-hell.com",[37,40,41,67,138]],["outisigoto.com",37],["ria10.com",[37,41,58,59,67]],["sekigaharablog.com",[37,38,44]],["tosalog.com",[37,207]],["tou3.com",[37,39,44,67]],["tsuyushiba.com",[37,38,41,56,207]],["visualfan.com",[37,38,39,41]],["wa-syo-ku.com",[37,39,41,44,45,207,255]],["yotsumeyui.com",[37,38,41,45,267,268]],["zoku-sei.com",[37,41,44,67,151,272]],["11songs.info",37],["ginoushi.jp",37],["3rin.net",[37,41,85,151]],["7narabe.net",[37,67,267]],["asukablog.net",[37,41,44,495]],["atgj.net",[37,45,57,58,82,138]],["cooklog.net",[37,44,58,59,67,501]],["coslife.net",[37,39,207,234]],["edoblog.net",[37,38,41,57,58,85]],["game-waza.net",[37,39,41,138]],["hyakunin-isshu.net",[37,39,41]],["ichi-matsu.net",[37,41]],["janken-pon.net",[37,39,44,65,85,207]],["kuizu.net",[37,39,41,57,58,67]],["kyotolog.net",[37,38,207]],["omaww.net",[37,38,41,85]],["sakeblog.net",[37,38,39,41,138,232,267,454]],["side-story.net",[37,138]],["syoyu.net",[37,138]],["take-uma.net",[37,38,39,537]],["blog.tkooler.net",37],["v-kei.net",[37,41,65,138,543]],["visualshoxx.net",[37,39,57,58,138,544]],["kimamana-theater.info",41],["b0ne.me",41],["totheworld.net",41],["akashicdesign.org",41],["asahi.com",46],["4years.asahi.com",47],["nakamaaru.asahi.com",48],["sippo.asahi.com",49],["asiatravelnote.com",50],["astage-ent.com",51],["at-s.com",52],["athleterecipe.com",53],["aucfree.com",54],["backsi.com",55],["baraero.com",60],["bengo4.com",61],["bipblog.com",63],["biteki.com",64],["minaminumaebi.blogmimi.com",69],["blogspot.com",70],["bokuslog.com",71],["bukidobi.com",72],["tennimuhou.com",72],["texal.jp",72],["butti15.com",73],["fragrantica-japan.com",73],["gadgerba.com",73],["taisy0.com",73],["complesso.jp",73],["nilcollection.net",73],["xn--zcka7aza6gyb9jd.net",73],["disney-fun.xyz",73],["casabrutus.com",74],["chansoku.com",75],["chichi-pui.com",76],["chiebiyori.com",77],["cidresweet.com",77],["coco2i.com",77],["favoriteslibrary-books.com",77],["753ya.net",77],["gowomengo.press",77],["cnmi-dfw.com",78],["paipan-holic.com",78],["connecnect.com",79],["cosmopolitan.com",80],["elle.com",80],["esquire.com",80],["harpersbazaar.com",80],["womenshealthmag.com",80],["25ans.jp",80],["ellegirl.jp",80],["fujingaho.jp",80],["designstoriesinc.com",83],["dietnavi.com",84],["douga-getter.com",86],["e-kodate.com",87],["ear-phone-review.com",88],["anime.eiga.com",89],["elog-ch.com",90],["enrichoneslife.com",91],["entameclip.com",[92,93]],["shareblog.info",92],["4k8ktv.jp",92],["erologz.com",94],["f1jouhou2.com",95],["famitsu.com",96],["fashionsnap.com",97],["fc1adult.com",98],["blog19.fc2.com",[100,107]],["blog31.fc2.com",100],["blog55.fc2.com",[101,102]],["pandora11.com",102],["channelz.blog.fc2.com",103],["nmbschedule.blog.fc2.com",104],["blog103.fc2.com",105],["blog120.fc2.com",106],["blog47.fc2.com",108],["blog94.fc2.com",109],["contents.fc2.com",110],["femimatsu.com",111],["ff14hikasensokuhou.com",112],["ffsagami.com",113],["fightingirl.com",114],["financial-field.com",115],["fnjpnews.com",116],["xn--mck5e585m.com",116],["football-2ch.com",117],["forestofbreast.com",118],["formula1-data.com",119],["futabagumi.com",120],["gadget2ch.com",122],["gazyekichi96.com",124],["geartics.com",125],["geinoujam.com",126],["geinoukame.com",127],["gentosha-go.com",128],["gfoodd.com",129],["gemmed.ghc-j.com",130],["ghibli-tosidensetu.com",131],["gmo-animation.com",132],["go2senkyo.com",133],["goal.com",134],["golfsapuri.com",135],["gosyuinsanpo.com",136],["gotrip.jp",136],["gpc-check.com",137],["mogtas.net",138],["hadakanonude.com",139],["hatenablog.com",[140,141,142,143]],["hatenadiary.com",[140,142,143]],["kobonemi.com",[140,141]],["longamerikastock.com",140],["hateblo.jp",[140,142,143]],["hatenablog.jp",[140,142,143]],["hatenadiary.jp",[140,142,143]],["kansou-blog.jp",140],["blog.wanichan.net",140],["yoima2.hatenablog.com",143],["hayamimi-gunpla.com",[144,145]],["hayamimi-hobby.com",145],["hikak.com",146],["shindans.com",146],["zengin.ajtw.net",146],["zyuken.net",[146,550]],["hikaritube.com",147],["poyopara.com",147],["sugirl.info",147],["iqoo.me",147],["erry.one",147],["hitoikigame.com",148],["hlsloader.com",149],["i2chmeijin.com",150],["inutomo11.com",153],["kidan-m.com",153],["irasutoya.com",154],["irodorich.com",155],["its-mo.com",157],["iyuto.com",158],["j-cast.com",159],["jisaka.com",160],["jishin-yogen.com",161],["jpstreamer.com",162],["tanweb.net",162],["originalnew.org",162],["kaigainoomaera.com",163],["kakaku.com",164],["kandatasokuho.com",167],["kanjitisiki.com",168],["kashi-mo.com",169],["kichikuou.com",170],["kijomatomelog.com",171],["kijyokatu.com",172],["kijyomatome-ch.com",172],["kijyomita.com",173],["kodate-ru.com",174],["sumu-log.com",174],["kokuhakutaiken.com",175],["netoraretaiken.com",[175,203]],["koro-pokemon.com",176],["pente.koro-pokemon.com",177],["kosoch.com",178],["kuroyonhon.com",180],["laboradian.com",181],["life-gogo.com",[182,183]],["zatsubitown.com",[183,269]],["news.livedoor.com",184],["lyrical-nonsense.com",185],["m4ex.com",186],["majikichi.com",187],["matomeantena.com",189],["matomecup.com",190],["medibang.com",191],["moeyo.com",194],["moyugenn.com",195],["mukakin-blog.com",196],["musenboya.com",197],["namaxchang.com",198],["gossip1.net",198],["comic.nan-net.com",199],["natuero-dougakan.com",201],["netamesi.com",202],["newmatoan.com",204],["news-boaters.com",205],["newsee-media.com",206],["news.nifty.com",208],["nijifeti.com",209],["nijimoemoe.com",210],["xtech.nikkei.com",211],["nukeruerodouga.com",212],["shiroino.com",212],["nuki-dokoro.com",213],["onepiece-log.com",214],["onihimechan.com",215],["oreteki-design.com",216],["app.oshioki24.com",217],["pachinkolist.com",218],["patanouchi.com",219],["peko-step.com",221],["photo-ac.com",222],["picb2.com",223],["pokemasujikaku.com",224],["ppvdatabank.com",225],["purelovers.com",226],["puzzle-ch.com",227],["qiita.com",228],["rastaneko-blog.com",229],["raw19.com",230],["ronsoku.com",231],["ryorika.com",232],["scienceplus2ch.com",235],["setusoku.com",236],["simtaro.com",237],["ske48matoeme.com",238],["soco-st.com",239],["solodc2017.com",240],["splatoon-torikara.com",241],["stats-japan.com",242],["sumomo-ch.com",243],["suzukikenichi.com",244],["taittsuu.com",245],["tekoki-fuzoku-joho.com",246],["thedigestweb.com",247],["togetter.com",248],["tokai-tv.com",249],["toremaga.com",250],["sp.uta-net.com",251],["otonasalone.jp",[251,443]],["utamap.com",252],["viet-jo.com",253],["w-higa.com",254],["warotanikki.com",256],["scp-jp.wikidot.com",257],["workingnews117.com",258],["wws-channel.com",259],["xn--icktho51ho02a0dc.com",260],["xn--l8j1bc5qvlge4c1402b4ha377l2f3cvvyd.com",261],["xn--u9j3iub5080abs7bxbc.com",262],["xn--w8jtkjf8c570x.com",263],["yamareco.com",264],["yaruo18book.com",265],["yosakoimatsuri.com",266],["zch-vip.com",270],["japan.zdnet.com",271],["zuuonline.com",273],["eegg.fun",274],["opantsu.fun",275],["dqmj.info",276],["dev.ftbucket.info",277],["hoge5ch.info",278],["wa3.i-3-i.info",279],["nijie.info",280],["npodb.info",281],["realtime-chart.info",282],["gahalog.2chblog.jp",284],["rabitsokuhou.2chblog.jp",285],["5chan.jp",286],["8mato.jp",287],["9db.jp",288],["ameba.jp",289],["ameblo.jp",290],["asajikan.jp",291],["w.atwiki.jp",292],["portal.auone.jp",293],["bestcarweb.jp",294],["bike-news.jp",295],["kuruma-news.jp",295],["merkmal-biz.jp",295],["trafficnews.jp",[295,330,464]],["asianoneta.blog.jp",301],["baynews.blog.jp",302],["eroitaiken.blog.jp",303],["kininaru-geinou-m.blog.jp",304],["seikeidouga.blog.jp",305],["sow.blog.jp",306],["buffalo.jp",307],["buzzap.jp",308],["car-me.jp",309],["news.careerconnection.jp",310],["chixi.jp",311],["cinematoday.jp",312],["cnn.co.jp",313],["daily.co.jp",314],["excite.co.jp",315],["blog.excite.co.jp",316],["exblog.jp",316],["fukuishimbun.co.jp",317],["r.gnavi.co.jp",318],["hokkaido-np.co.jp",319],["itmedia.co.jp",320],["nlab.itmedia.co.jp",321],["iwate-np.co.jp",322],["j-wave.co.jp",323],["jomo-news.co.jp",324],["kochinews.co.jp",325],["lps-web.co.jp",326],["mapion.co.jp",327],["netmile.co.jp",328],["nishinippon.co.jp",329],["oricon.co.jp",330],["plaza.rakuten.co.jp",331],["pointmall.rakuten.co.jp",332],["sagatv.co.jp",333],["shimotsuke.co.jp",334],["shinmai.co.jp",335],["sponichi.co.jp",336],["mangalifewin.takeshobo.co.jp",337],["vogue.co.jp",338],["carview.yahoo.co.jp",339],["chiebukuro.yahoo.co.jp",340],["detail.chiebukuro.yahoo.co.jp",341],["finance.yahoo.co.jp",342],["jobcatalog.yahoo.co.jp",343],["mail.yahoo.co.jp",344],["search.yahoo.co.jp",345],["yakuji.co.jp",346],["yomiuri.co.jp",347],["otekomachi.yomiuri.co.jp",348],["ytv.co.jp",349],["zakzak.co.jp",350],["coinpost.jp",351],["crefan.jp",352],["curet.jp",353],["da-te.jp",354],["game-i.daa.jp",355],["deneblog.jp",356],["dokuha.jp",357],["doope.jp",358],["akankore.doorblog.jp",362],["anacap.doorblog.jp",363],["kimamamatome.doorblog.jp",364],["otakumix.doorblog.jp",365],["pokemon-goh.doorblog.jp",366],["douga100ka.jp",367],["doujinonsei.jp",368],["enuchi.jp",369],["erozon.jp",370],["esportsnewsjapan.jp",371],["favsite.jp",372],["frequ.jp",373],["fukafuka295.jp",374],["gamedbs.jp",375],["gameranbu.jp",376],["gizmodo.jp",377],["h1g.jp",378],["taxtax.hatenablog.jp",379],["heim.jp",380],["hibiki-radio.jp",381],["hosyusokuhou.jp",382],["hotokami.jp",383],["ibarakinews.jp",384],["jbpress.ismedia.jp",385],["jisakuhibi.jp",386],["jprime.jp",387],["jugem.jp",388],["kabushiki.jp",389],["kabutan.jp",390],["city.atsugi.kanagawa.jp",391],["kanaloco.jp",392],["kk1up.jp",393],["anicobin.ldblog.jp",397],["hattatu-matome.ldblog.jp",398],["leaked.jp",399],["city.chichibu.lg.jp",400],["city.niigata.lg.jp",401],["city.owariasahi.lg.jp",402],["pref.shimane.lg.jp",403],["lifehacker.jp",404],["2-carat.net",[406,486]],["lnews.jp",407],["magmix.jp",408],["maidonanews.jp",409],["yorozoonews.jp",409],["mainichi.jp",410],["markezine.jp",411],["mbs.jp",412],["medicalnote.jp",413],["cc.minkabu.jp",414],["minnyuu.jp",415],["minute.jp",416],["mirrorz.jp",417],["mixi.jp",418],["motimoti3d.jp",419],["moviecollection.jp",420],["woman.mynavi.jp",421],["39.benesse.ne.jp",422],["39mag.benesse.ne.jp",422],["st.benesse.ne.jp",423],["biglobe.ne.jp",424],["cinema.ne.jp",425],["eurus.dti.ne.jp",426],["free.foto.ne.jp",427],["goo.ne.jp",428],["oshiete.goo.ne.jp",429],["d.hatena.ne.jp",430],["iza.ne.jp",431],["japandesign.ne.jp",432],["yukkuri-futaba.sakura.ne.jp",433],["news.so-net.ne.jp",434],["blog.nicovideo.jp",435],["dic.nicovideo.jp",436],["nurse-senka.jp",437],["ongakumichi523.jp",438],["jacom.or.jp",439],["kankomie.or.jp",440],["topics.or.jp",441],["otakomu.jp",442],["peta2.jp",444],["precious.jp",445],["president.jp",446],["ryukyushimpo.jp",447],["s8a.jp",448],["sagafan.jp",449],["sakigake.jp",450],["sanyonews.jp",451],["seinaruyakata.jp",452],["shipping.jp",455],["blog.skeg.jp",456],["smart-flash.jp",457],["soredoko.jp",458],["main-hrs-game.ssl-lolipop.jp",459],["tanoshiiosake.jp",460],["tap-biz.jp",461],["teller.jp",462],["thetv.jp",463],["trailrunner.jp",465],["t-mall.tsite.jp",466],["tsuiran.jp",467],["tuma.jp",[468,469]],["toukou.tv",469],["tver.jp",470],["volx.jp",471],["weekly-jitsuwa.jp",472],["wiki3.jp",473],["xn--68jza6c6j4c9e9094b.jp",474],["hoimiso.xsrv.jp",475],["xxxblog.jp",476],["yourei.jp",478],["medley.life",479],["creive.me",480],["mangalove.me",481],["blog2.mmm.me",482],["picrew.me",483],["gendai.media",484],["limo.media",485],["2ch-c.net",487],["417ena.net",488],["46matome.net",489],["keyakizaka46matomemory.net",489],["all-freesoft.net",491],["ani-chat.net",492],["app-ranking.net",493],["ascii2d.net",494],["avgle.net",496],["bi-girl.net",497],["blogterest.net",498],["boshisoukan.net",499],["clublucifer.net",500],["counter-attaaack.net",502],["ddd-smart.net",503],["diamond-rm.net",504],["doucolle.net",505],["elog-ch.net",506],["fashion-press.net",507],["figsoku.net",508],["azby.fmworld.net",509],["fumumu.net",510],["pokemon.gamerstand.net",511],["gigafree.net",512],["gigazine.net",513],["news.gree.net",514],["imas-cg.net",515],["japohan.net",516],["keokeoblog.net",517],["kitimama-matome.net",518],["kokopyon.net",519],["konyoku.net",520],["lettuceclub.net",521],["morekorea.net",523],["namae-yurai.net",524],["nihongonosensei.net",525],["openworldnews.net",526],["sp.oshaburi.net",528],["pokemongo-kouryakumatome.net",529],["privatter.net",530],["rakukan.net",531],["renote.net",532],["seesaa.net",533],["hdata.seesaa.net",534],["jj-labo.seesaa.net",535],["jbbs.shitaraba.net",536],["amigo.tennis365.net",538],["topitane.net",539],["toyokeizai.net",540],["twiman.net",541],["twivideo.net",542],["wackwack.net",545],["wifi-kiwami.net",546],["with2.net",547],["yoheim.net",548],["zekamashi.net",549],["hochi.news",551],["fevian.org",552],["jav-free.org",553],["kabegami.jpn.org",554],["loveh.org",555],["news-us.org",556],["hellokpop.site",557],["connect.coron.tech",558],["ribbon.to",559],["adult-video.tokyo",560],["times.abema.tv",561],["nukiez.tv",562],["contents-group.work",563],["mineralfoundation.work",564],["jukujo-neet.xyz",565],["socom.yokohama",566]]);

const entitiesMap = new Map(undefined);

const exceptionsMap = new Map(undefined);

self.proceduralImports = self.proceduralImports || [];
self.proceduralImports.push({ argsList, hostnamesMap, entitiesMap, exceptionsMap });

/******************************************************************************/

})();

/******************************************************************************/
