/*******************************************************************************

    uBlock Origin Lite - a comprehensive, MV3-compliant content blocker
    Copyright (C) 2019-present Raymond Hill

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see {http://www.gnu.org/licenses/}.

    Home: https://github.com/gorhill/uBlock
*/

/* jshint esversion:11 */

'use strict';

// ruleset: annoyances-others

/******************************************************************************/

// Important!
// Isolate from global scope
(function uBOL_cssSpecificImports() {

/******************************************************************************/

const argsList = ["#google-hats-survey",".fav-info",".top-btn","#div[jscontroller=\"MaoVMd\"][jsdata*=\"nTLyye;\"],\ndiv.nD2EKb.VEELad","#scrollup","a[href=\"#top\"]",".maple-banner",".moduleBookmarkLinks",".widget-advertisement-card",".scroll-to-top",".promotion-banner,\n.related-in-content",".show-check-also","#notificacion-modal","#TopBtn",".s-answer-region-center-top > div[id^=\"placement\"][style=\"min-height:144px;\"]",".s-feedback","#topButton",".onboarding-modal","#storage-notice",".pageup","#nav-upnav[style]",".node-navigation",".more-articles-placeholder",".css-pt0h6u","#backtop","#back_to_top",".footer__scroll-top",".et-l--footer,\n.et_pb_row_1_tb_body,\n.et_pb_row_5_tb_body,\n.et_pb_scroll_top","#sectionMoshtixSubscribeForm","#floatingScrollBtn",".ninemsn-footer-top",".BqJep",".w-nt.h-ni",".desktop-buttons-row",".css-1cjzv6h-StyledContainer,\n.css-t03kxs-StickyBreachContainer",".article-footer-container,\n.promo-footer-strap-wrapper,\n.subscriber-push-end",".MagDriver",".mrec-conrainer-article",".g1-teaser","#btn-up",".flash-container","#scrollTop","#top-story-alert",".sign-up",".community",".jobs",".single-content-apoie-lg","#scroll-btn",".scrollToTop",".fixed-btn-uai",".scroll-top",".c-subscribe-ads,\n.c-top-signup",".backtop",".support","#scroller",".on-top","#scrollUp",".contribute-box,\n.contribute-section,\n.your-story","#scroll-up",".mailchimp-form",".replacement-image",".js-badger-accordion","#gallery-1",".redirect-background",".PopupBackground","#mikes_reading",".asset-paging",".donate-bar",".donate-box",".container-adbox-autopromo","#back-to-top",".top",".Feedback__cont",".button--back-to-top",".asset-paging-container",".article-footer--builder-ask","#inarticle,\n.area-arbitrary.widget_custom_html,\n.gala_banner",".wppopups-whole","#scroll-top","#backToTop",".cta-element","#retour-haut",".go-top",".block-to-top",".info-subscription-box,\n.support-subscribe","#slide_top",".cd-top",".scrollup","div[class^=\"BackToTop_\"]",".temp-sticky-banner",".unige-topnav",".auth-modal-signup,\n.view-cam-watching-limit",".banner-pop",".gotop",".hui-dingbu",".topb",".scrolltopa",".btn-primary,\n.promo-unit","#bottom-portal",".gjJPGq,\n[data-ga-view-prompt=\"aeon_cta_article_side_donate\"]","#coco-plus-membership-section",".chrome-app","[data-ga-view-prompt=\"psyche_cta_article_end_donate\"]",".button-scroll-top",".md-adbox",".theblockpro,\n.theblockresearch",".join-panel,\n.support-img",".support-popup","#announcement-bar-root",".video__docker_state_docked","#allapps-extension-popup","#g_backtop","#sidebar-video-fixed",".kHolder",".recommend,\n.sale-line",".pagination-sticky","#to-top","#landlord,\n.qiye-pop,\n.recharge,\n.springtime-floatLink,\n.viewLimit,\n.winpopbg",".dock",".feed","#nav-above",".td-more-articles-box",".module-recommended",".donate",".donation-module",".cp-modal-popup-container",".recent-jobs-widget","#RSS","#retourHaut",".ReactModal__Overlay--after-open.ReactModal__Overlay",".feedback-banner",".next-article",".adx-membership",".theme-back-to-top-button",".art-cta",".ui-dialog",".reader-revenue","#swnexttrigger,\n#swprevtrigger","#scroll-to-top","#story_tools",".js-scroll-down",".footer-wrapper",".back-to-top",".sendtip",".drogue-poplayer-modal,\n.image-poplayer-modal,\n.top-banner-container",".coil-banner-message-container",".atbs-ceris-go-top",".pagination",".footer_pagetop",".fundraising-block-flex","#scrollingDiv","#up","#divStayTopLeft","#mobile-immersive-player,\n#nav-upnav,\n#percolate-ui-ilm_div,\n#watchNow_feature_div,\n.mini-atf,\ndiv[class^=\"DesktopFlexBannerLayout-module__playerContainer_\"]","#marketingimagelink","#post-nav",".coffer-box","#toolbar",".agr-callout",".arrow-up",".follow","#gotop",".go-top-div",".browser-extension",".apkm-timed-slider,\n.promotedApp",".ap_banner-container,\n.fancybox-overlay-fixed","#send-email",".accsoffer-wrapper",".top-button","#radio_content","#check-also-box","#article-navigation",".get-the-magazine__outer",".support-artstation","#ToTop",".hero-box,\n.js-dismissable-hero,\n.js-freemium-cta","#scrolling-top",".overlay-wrapper",".check-survey-info",".af-form,\n.pane-aweber-webform","#top_up",".article-gastro-interruptor,\n.footer-banner",".backToTop33",".up",".extension-popup",".modal",".modal-backdrop","#support-bar","#crm_article_box",".blog-sidebar-ad-img",".connect",".flyout",".o-content-cta,\n.o-promo-module","#message-panel",".menuTopAds",".exclick.top-item,\n.modal-newbie,\n.suspended-banner-wrap,\n.top-item","#linkTop",".page-top","#scroll-back",".lx-commentary__top-link",".promotion-cards","#top","#acquisition-bar-wrapper","#scStb",".bic-custom-banner",".black-banner",".hustle-slidein-content",".box-iscrizione",".fab__scrollTop",".dont-miss",".bgTB","#newmode-embed-50964-65957,\n.polaris__flexible-cta,\n.polaris__sticky-subscription",".bt-block__inner",".footer-promotional,\n.promotional-content",".footer-back-button",".feed-card:has(a[href*=\"cm.bilibili.com\"][data-target-url*=\"gaoneng.bilibili.com\"]),\n.is-rcmd:has(a[href*=\"cm.bilibili.com\"][data-target-url]:not([data-target-url*=\".bilibili.com/\"]))",".bb-pro-promotional-banner",".progress-wrap","#pagination_Arrow",".sb_spotlight",".membership-promotion-header-banner",".banners-banner",".next-navigation-container",".membership-appeal-bottom,\n.membership-appeal-top",".onTop",".stackcommerce-widget",".patreon-sidebar",".banner",".TheArticleClothesline_wrapper_2LSY-",".scroll-top-section",".next,\n.prev",".journey-unit","#toHide",".emk_footer_update",".rightbox1","#infos-boursier_panel",".has-promo",".apg-support-local-wrapper",".scroll",".TopBar","#cta-make-default","#cin_poll",".index_top_banner","#auto-top-link",".comp-content-keepfreebannercontent",".fdn-support-us-block",".swipe-prompt",".elementor-element-afcad4d",".single_page_navigator",".targeted-recommended",".topButton",".shoppingWrapper_packageWrapper__UR6JD",".newsblock-tips",".fixed-up-arrow",".story-actions","#torna",".navigation",".riskWarning","#scrollToTop","#pp-banner",".header-support-image,\n.main-sidebar-wrap",".gsst_scroll-btn",".ant-modal-root",".promo-bar",".cta46_card","#go-top",".next_stories_div",".donation-box",".floating",".ui-widget-overlay","#backToTopWrapper","footer","#spot_popup","#scrolltop",".upnext-container",".prod-animation","#eme-fixed-banner",".widget-support-tcr","#scrolltab",".go_top",".jobsPosterAside",".body-copy > div > [href=\"/user/subscribe\"]",".go-up","#dialogueBox",".fdn-support-us-button-block",".paging-link",".footerCtaBanner",".fdn-keep-free-block",".section-sticky-footer",".to-top",".c-avStickyVideo",".toast-popup",".scroll-button",".blog-back-header",".entry-bar",".guest-banner","#top-announcement-header","#topbutton",".api-promo-banner",".arrow-icon","#infobar",".email,\n.feeds",".ir-arriba","#text-html-widget-8,\n[style=\"background-color: #FBD603; padding: 8px; border: 5px solid;\"]","#text-5",".hb-single-next-prev",".nextArticle","#backtotop",".jan-to-top","#radio-player-container","promo-up-next",".feedback",".widget-advert-300-sticky,\n.widget-advert-336",".article-recommended",".header-top-banner","#js-promo-banner,\n.single-banner-tier","#top-btn",".bottom-20","#post_more_wrapper,\n.subscriber-drive-container",".donation-drive","#slidepanel",".blog-sidebar-ad",".top-banner__item",".js-go-to",".stickyMessenger-cta",".c-highlight",".bottomcontainerBox",".page-slideshow_cards_controls",".top-banner","#user_optin_banner","#default-next-button-wrapper",".stickybar",".dfx-inHouseGuideBannerComponent","[href=\"https://dailyhodl.com/alerts/\"]",".top_news_donation",".dtafter",".aos-animate",".dear_reader",".b-scroll-to-next-article","#lts-banner",".comp-shell-supportus",".an_independent,\n.article-support-bump,\n.article-top-donate-bump,\n.row_background_red_padding",".about-us,\n.plea",".announcement",".more-insights",".dc-ps-banner-wrapper","#sg-popup",".top-scroll",".story-appeal",".swipe_arrows",".pmc-u-background-white.pmc-u-margin-b-0","#softMessages-list",".nav-banner",".back-to-top-outer,\n.engagement",".comments-inline-cta",".ant-alert","#iosAppAdPortal",".js-stickybar","#nekoToTop",".el-backtop",".ArticleList_listBanner__9Vy9d",".publish-your-work","#relatedposts",".wp-image-2011","#feedbackBtn",".drainagebanner,\n.new-pack-mask,\n.new-pack-pop,\n.promo-coupon-pack,\n.promo-pack-mask,\n.promoGiftPack_promoGiftPack__FRb2W",".feedback-container-bottom",".feedback-link","#callout","#uvTab",".login-overlay__wrapper","#pop-up-show",".overlay","dole-back-to-top","#top-button-block",".alert-warning",".footer-feature",".button_size-md__dS3Yr.button_secondary__DAail,\n.header--aside.js-header-aside > .header--aside__item > [class]",".go-to-top-btn","#TB_overlay,\n#TB_window","#topScroll",".float_totop","#toTop",".promoAd","#gh-bt,\n.vi-feedback","#totop","#inscription-hebdo","#adPopup",".article-right",".code-block",".five-sixths,\n.topbar",".bg-overlay",".footer",".bar-thin",".article__arrow,\n.article__footer-nav",".relatednext","#text-9","#slidebox",".sticky","#footer",".up-button","#goTop",".escapist-plus",".jqmOverlay,\n.jqmWindow",".sns_btn",".membership-upsell","#bsf_rt_progress_bar_container,\n#contribs_banner","#pa_banner_code,\n.kompreno",".correction",".js-swip-btn","#article-portal-container","#featuredBottomContentContainer,\n#modalAfterInactivityFormContainer,\n.erf-goTop",".post_navigation",".banda_suscripcion",".marketing-notifications,\n.mobileDrawer","#go_to_top",".custombox-content,\n.custombox-overlay",".fancybox-overlay",".v-ReferralsSource","#related","#upper",".noLoginSticker",".StarFeatureDockedPopup","#bottom-banner-fallback,\n#right-ad-box,\n#top-banner-fallback","#right-vertical-banner",".networking","#sub-intent",".-donate",".next-arrow",".prev-arrow",".banner-campaign,\n.bn-space,\n.premium-autop",".join-flc",".upgrade-button",".skybanner",".get-magazine",".sweeps-promo","fbs-ad",".artical-controls",".mfp_academy-enjoy-private-lesson-popup","#after-post-content-widget-wrapper,\n.top-banner-desktop",".commenting-nation-promo",".promo",".o-self-promo--nl","#tie-block_521",".cs-entry__prev-next-item","#inhouse-pushdown",".n-feedback__container","#relatedarticleflyoutbx2","#upPageToolbar",".floating-post-navigation",".scroll-up",".ProgramHeader","#in-page-nav",".stream-item-top",".callToRegister2,\n.callToRegisterPopupWrapper","#action-up",".support-banner","#geekwire-events-sidebar,\n#geekwork-sidebar,\n#tips-sidebar","#dummyid20",".jss82 > svg > circle,\nimg[alt=\"GETTR coin\"]",".skySportsRow","#related-posts > div",".js-notice-dismiss[data-analytics-visible],\n.signup-prompt,\nbutton[data-testid=\"copilot-popover-button\"]","[aria-label=\"Scroll to top\"]",".nxt-content-wrapper,\n.ribbon-container",".tapBoxCls",".mainBorromSliderSec",".StickyVideoPlayer.VideoPlayer[style=\"\"]",".arrow-up-container",".books",".relatedRiser",".floatingchat-container-wrap",".article-tools,\n.sticky-footer",".gdn-component-gdn-back-to-top",".ss-pu-container",".b-back_to_top","[role=\"dialog\"][aria-labelledby=\"promo-header\"]","[jscontroller][data-limp] > .zQSHZb.cH2VZe[style^=\"right:\"] > .gLpFG",".article-donation-CTA",".taboonews",".consumer-marketing-unit--cm-footer","#un-button",".actions",".site-footer__up",".subscribe","[href^=\"https://bit.ly/\"]","#js-top",".pk-scroll-to-top",".sitewide-tout,\n.sitewide-tout_l",".sign",".top-bar-promo","#_im_feedbackTab__109","#veilon_gotop",".promo-designer-modal",".fot-float-box","#GOZERO",".advWrapper",".entryPointBanner",".btn-backtotop",".totop",".scrolltop",".menu",".gb-container-eda5dcfe","#hzScrollTop",".notificationbar",".fade,\n.modal-content","#support-huffpost-entry","#site-xpromo-banner",".article_footer","#qrCode","#notifications",".toplink",".c-syndication",".navbar-alt",".scta","#geist-ui-modal","#popupOverlay",".gototopdesk",".Ad",".sprtadv",".fancybox-wrap",".im-go-top-btn","#append_breaking_box,\n#engagement-top,\n.breaking-scroll,\n.subscriber_hide","#yolooverlay",".reg-block",".header__bottom__events,\n.notice,\n.related__group,\n.section__newsletter","#float_top,\n#wi-plugin-corner",".block-tip-block,\n.got-tip",".HoverCard",".promo-link",".bg-blackest,\n.border-red",".promo-strip-wrapper",".signup,\n.sim-promo","#action_insert_15511419671934590,\n#login-banner,\n#researchTools,\n.broadcast-text,\n.market-banner",".btt",".iw-ad-slider","#limits > a",".td-header-top-menu-full",".s-up",".bn-at,\n.po-sr-sb__container",".postslide",".td-scroll-up",".sidebar-banner,\n.top-fixed-stripe","#_popIn_recommend_2","#notification-banner-content",".rotating-leads",".grabtherssfeed,\n.sidebarbutton",".Unlock_unlimited_access","#custom_html-2",".c-feed_cell:has(> a > div.c-global_pr)","#_popIn_recommend",".link_top",".desktop-floating-player",".desktop-video-title-bar",".scrollTop",".powa-sticky",".code-block-22",".block-row.block-body",".gb-donate_wrapper",".button-gotop",".klook-icon-Top","#cboxOverlay",".combo-wrapper,\n.shopify-container",".story_tools","#oo_tab","#scroll_top",".btn_top","#popup-banner,\n.eStoreTopBanner,\n.supportUs-article__banner,\n.ukraine-daily-side-banner",".scroll_to",".ReportFloatingBanner",".TogglerWrapper",".blog__cta__signup,\n.demo__cta","#floatArrowUp",".footer_rrss","#preload",".nw_cont,\n.nwletter,\n.soc_box",".c-article-nav-arrows","#tips","#btn-top",".kg-product-card,\n.lp-popup__iframe-wrapper",".contribute-stripe","#memberZoneFullSub,\n.embedshortcode",".donate-callout","#custom_html-9",".pum-active",".widget_media_image",".b-fader",".backtoTop","#tncms-region-page_sticky_anchor,\n.promo-button",".email_signup",".signup-overlay_isCentered_2Al",".cleanslate,\n.imageBanner",".m-scroll","[href^=\"https://apple.news/subscription\"]","#pageTop",".nextarticle--3Zv4q93A","#accept-top",".latest-news",".back-to-top-bot","#skyscraper_container_front,\n#topBanner","#piano_catfish_wrapper_bottomfull",".teasing_widget_surtop_light","#move-down","#rss",".direction",".freshwp-scroll-top",".promo-sidebar",".sub-form","#colorbox","#js-popup-donate","#backTop","#top-link","#phx-1",".woahbar",".img-responsive-container",".ia-support",".scrolltotop",".vscom-usabilla-button","#banner-holder",".supStickyFeedback",".ui-widget",".midhu-target",".eo-free","#return_top_2023","#GoTop","#js_globalFooterButtonTop",".nav-arrow",".blogsidebarimg,\n[href=\"https://github.com/mljar/mercury\"]","#text-34",".leaderboard",".home-ranking,\n.mp-popin-analytics,\n.mp-recommends","#hs-web-interactives-top-anchor",".widget",".mj-adblock-widget",".media-action-networks,\n.page-to-top-link-wrapper","#main_footer",".sp-back-to-top","[data-id=\"documentScrollToTop\"]","a[data-target=\"top\"]","#js-pagetop",".button-scroll",".crm-card-next","#over","#viewportGreyout",".so-parallax",".feedback-container,\n.feedback_link_default-DS-EntryPoint1-1,\n.paddle,\nfooter[role=\"contentinfo\"][part=\"footer\"],\nsocial-star-rating",".styles_stuck__gtILi",".bio-lead-form",".up_btn","#myBtnScroll",".gpoll_enabled_wrapper","#a_showhotnews_list_dia",".sidebar-shop-patreon-cta-container","#tncms-region-article_bottom",".td-read-down",".carousel-widget,\n.widget--local-ads",".c-holidayPlug",".app-featured-row__item","#tbl-next-up,\n.new_nextarrow,\n.new_prevarrow",".mfp-ready","#bottomBar","._1y2JXo,\n.nw-auth-stepper,\ndiv._3VJt4n > div > ._3eCw6n._2247K8",".floating-right-tools",".ad-container-house,\n.beg-to-differ,\n.blink-sdk-widget-container,\n.footer__middleRow,\n.upArrow","#nextbtnwrap,\n.NPrltd_story_Wrp","#cube_spinner",".prev-article-button",".btn-warning",".subscribe-block-wrapper,\n.videocontent-wrapper.stickyPlayer[style*=\"top: 0px;\"]",".f7ff6e98380,\n[title=\"Back to top\"]",".trx_addons_scroll_to_top","#pianoj_ribbon",".u-pagetop",".mysticky-welcomebar-fixed-wrap",".af-form-wrapper","#kt-scroll-up",".topbutton",".js-PageTop","[href=\"#back-to-top\"]",".latacz",".support-bar,\n.support-section","#popup",".su-advertisement-wrapper",".caption-container","#melmaga-popup","#pagetop",".prev-next",".banner-article-1",".nag--helpful","#scroll-buttons","#supFeedbackWrapper","#cta-sticky-banner",".JoinCommunityBtnContainer","#text-3,\n.popupad-base",".promo-padding",".oi-footer-bottom-ad-btns","#big-bottom-ad-single-posts","#overlay",".floating-section",".get-opera","#sitetop","#scroll-box",".KeepFreeBanner","#footerbar",".l-footer-back-btn",".promotional_subscribeNow","#pagesix-app-flyout__wrapper",".blog-item-pagination","#inner_pages_fundraiser",".eut-back-top",".popup-container","#feedback-side,\n.js-track-ad",".showUp",".generate-back-to-top",".scrollmeup","#recommendo",".NameChangeBanner_container__GyQTG","[href^=\"https://phemex.com/bonus\"]",".recom-upnext-section","#socpage","#main > script + [style]","#zenbox_tab",".BOX_MarginOut","[class^=\"hintWrapper\"],\n[class^=\"pa-monetization\"]","#promo","#block-2","#credential_picker_container,\n#credential_picker_iframe",".container--GV-ux",".bookmarks",".thm-piano-bottom",".thm-piano-eop","#modal-confirmTerms",".pb-page-overlay",".article-paywall","#site-background",".article__suggest",".o-disruptor",".arrow_carrot-2up","#welcome","[alt=\"RSS\"]","#PoPAI",".prpromo",".bottom-signup-banner","#exit_popup_custom,\n#over-overlay",".affiliate-disclaimer","#bbstar-popin","#wr-back-top","#btn-back-to-top",".focus-img",".qm_toolbarSubTitle,\n.top_announce",".app_qrcode",".extension-item,\n.home__snippet__extension",".promotion__asset,\n.promotion__overlay",".navigation_between_posts",".toTop",".bg-orange-600",".nav_top",".post-nav",".below-content-appeal","#expandableDonateButton","#spink_appeal_box_0_0_14_0_0_0,\n.go-top-btn","#sideheadlinescontainer2",".webathon-leaderboard,\n.webathon-meter,\n.webathon-meter-widget",".abnormal-icon",".premium-banner,\n.premium-banner-outer",".UpsellModal","#span_subscibe",".tp-container-inner",".nav-links",".refinitiv-promo-bar__container__3YPMt",".memberEngagementOverlay",".kadence-scroll-to-top",".merch_component",".mailing-list","back-to-top","#topscroll",".interstitial-show",".top-page","#offers","#divMVPopup",".navToTop","#floating-nextprev",".PromoTopBar",".wp-block-san-news-popup",".ad-sponsored-inline",".spw__banner","#infinite-footer",".stickyLinks",".between_page_portal_root,\n.exit_modal,\ndiv[data-testid=\"bottom-right-mrec\"],\ndiv[data-testid=\"desktop-leaderboard\"],\ndiv[data-testid=\"sticky-wrapper\"]",".ads-container,\n.promo-image",".tap-top","div[class^=\"styles_floatingBanner_\"]","#pagelinks",".scrolled","#related-module",".promo_PromotionalEventContent___XAR_","#b2t",".shz-frame-apps-banner,\n.shz-frame-promotionbanner",".c-vue-coupon,\n.sui-modal",".ribbon",".sm-up-container",".ceiizM,\n.kapuda",".noprint > td,\n.right-sidebar","[data-xf-click=\"scroll-to\"]",".pagetop",".p-download_modal.c-fullscreen_modal.ReactModal__Overlay--after-open,\n.p-ia__workspace_banner.p-client__banners,\n.p-upgrades_button",".slate-plus-promo",".give-embed-form-wrapper","#suggestion",".feature-panel",".f-page","#block-patchonboardinginvictus",".become_member_section,\n.in-house-placement","#remote_cs,\n#voc_ec_button,\n.side_bnr","#in_touch","#spsbtns","img[alt=\"Banner\"]",".img-banner",".l-sec--scroll-menu__btn","#previous","#showroom",".l-product-banners",".pagenav",".single-navigation","#sliding-nudge-sell,\n#support-banner,\n.sell-wrap",".totop-br",".sporcle-promo",".modal-freeplay",".paywall-footer-container",".cb-customize-desktop",".page-up","#widgetBottom",".arrowup",".ui-dialog-overlay",".actions-scroll-to-top","#hireme","#top-anchor",".overlay-arrows-anchor","#block-display,\n#feedback-button-container,\n#home-top-banner,\n.block-display,\n.widget-install-legacy",".Layout_tabContainer__ZNCCp",".recirculation-bar",".awdSnsIcons","#backTo","#ei_subscribe",".desktop-banner","#floating_footer,\n.premium_signup",".single-next,\n.single-prev","#divWelcome",".homepage-banner",".dialog-invitation",".sign-in-button",".toggle_lb_scrolling_mobile","#page-up",".DonationPopup",".boxzilla-container","#make-a-donation",".Footer__ModalAds,\n.MeteredBumperWinter24Widget",".dpa-variant-sidebar","#ssttbutton",".install-modal","[style=\"width: 300px; height: 360px;\"]",".float_article",".IRPP_button",".share-sec-tags,\n.trust_desktop",".ct-back-to-top",".trust-feat",".gofollow",".top-bar",".btnpg,\n.encadre.bleu:has(a[href^=\"https://eepurl.com/\"])",".wrap-6ZxH0",".com-back2top",".float-player",".sf-header-cta-gift","#block-33",".vspl__gtap-notification-content,\n.vspl__gtap-notification-overlay",".floating-copy",".ao-cpa","#nextStoryTitle,\n#previousStoryTitle",".gizmo-jtop",".bottom-bar","#theDrumPlusRegistrationBlock,\n.header-banner__fest,\n.td-miso","#uacta-target","#block-23","#to-top-wrap","#subscription-pencil-area,\n.premium-chain-rail","#contact-the-guardian,\n.dcr-nv35qx,\n.site-message,\n.site-message--banner,\n[name=\"SlotBodyEnd\"],\n[name=\"StickyBottomBanner\"]",".m-site-sticky-footer__btt-link",".cross-sign",".spl-article-bottom",".inertia-contribute-home",".sticky-sidebar__donate",".ad-v-box,\n.ads-large-leaderboard,\n.loginAds,\n.tjp-feedback",".PromotionalRibbon",".wpnp_anchor_js",".navbar-wrap",".contribute-article,\n.contribute-bar,\n.contribute-modal,\n.contribute-popup,\n.contribute-stickybottom,\n.contribute-teaser-mobile",".tn-editor-none-module","#feedback-btn",".pulse__ad-wrapper,\n.pulse_poster",".right-rail-promo","#paywall_overlay",".top-bottom",".notification",".contributions-container,\n.contributions-epic",".post-preview-next,\n.post-preview-prev",".sub-links",".bannerExternalContainer",".top-hat",".rss",".polaris__subscription","#greeting","#announcment-banner,\n.widget > [href=\"https://www.thurrott.com/thurrott-premium\"]",".app-promotion,\n.show-top,\n.tiktok-zeo9hm-DivPromotionContainer,\n[aria-label=\"Scroll to the top\"]",".mobile-anchor-container",".homepage-hero",".crm-post-module",".scroll-notification-container","#top_ribbon,\n.hideOnpremium","#third-party--viewport-bottom,\n.pages-Article-pianoContainer",".back_top",".ta_patreonWidget",".resocs",".widgets-top-banner",".irTop",".toup","#go-bottom","#promo-ad-free-story-bottom,\n.top_button",".ZkqhQ",".js-track-link",".before-you-go","#sidebarUpsell",".posts-pagination",".announcement-bar",".tt-shortcode-1",".ad-parent","aside[role=\"complementary\"]:has(> a[href=\"/i/premium_sign_up\"])","#scTop","#bluenext,\n#blueprevious,\n#fixed_bottom_bar_back,\n#fixed_bottom_bar_text","#t4s-backToTop",".scroll_top",".mascotte_mascotteWrapper__8RnmL",".adv-link","#beginn-arrow",".cursore-uq",".mug-ad",".c-pwa-back-to-top__icon",".be-caption,\n.be-lb,\n.be-ls,\n.be-mr",".right-rail",".vb_widget",".supporters_promo",".scrollUp",".vigil-after-article","#blogup",".slide-in-wg","._1agbrixs,\n._1agbrixx","#dyTopButton","#bio_ep,\n#bio_ep_bg,\n[href^=\"https://premium.walletinvestor.com/\"]","[title=\"back to top\"]",".member-button-container","#text-11","#ModalWindow,\n#btnStopAds",".top-link",".PromoDriver--card--15FjK",".jump",".jump-bottom","#wo_ext",".footer-totop",".powered-by",".sidebar-card-banner",".cross-promo",".widget-area.sidebar","#firefly-poll-container","#rp_list",".crates-banner","#back","#menu-back","#article_courses_banner","#site-scroll",".writeforwionbanner",".consumer-marketing-unit--article-mid-content",".follow-block",".bb-fixed-pagination,\n.dotted-widget",".paypal-donate",".feedback-button",".wsc-gotop","#MsgContainer",".guestwarn","#footer_fixed",".a-42",".btn-top",".arrow",".bottom-bar-articles",".premium-promo-row",".theiaStickySidebar",".blockOverlay",".b17-scroll-top-button",".extension",".creator-promo-bg,\n.heading-promo,\n.up-arrow,\na[class*=\"promoMessageBanner-\"]","#nagbox",".PSHeader-Center",".app-promo-banner,\n.mobile-badges",".cta-bajo-pregunta + div[class^=\"div-block\"]",".topTop","#article_ribbon_bar,\n.unique-progress","#yt-feedback,\n#yt-hitchhiker-feedback,\n#yt-lang-alert-container,\n.YtmPaidContentOverlayHost,\n.ytd-primetime-promo-renderer,\n.ytd-statement-banner-renderer,\nytd-brand-video-singleton-renderer",".ytp-ce-playlist,\n.ytp-pause-overlay","#fixed-addon-banner","#featured_zacks_rank_stocks",".TheMarketEarHomePageSidebar_container__ZI0HO",".jsBookmarkExtn",".block-3","#vw-back-to-top,\n.proven-media-link",".scroll-to-top-outer","#footerFlyout",".js-go-top-el",".li-reset,\n.sdgSlotContainer,\n.supplementary","#spotlight",".ho-bg.z-0.relative","#scrolltopbutton","#UpToTopButton",".kick__scroll-top-ic",".kontextpermail",".simplemodal-container,\n.simplemodal-overlay",".to-top-container","#topAnchor",".cc-FloatingButtonBarContainer-button-scroll",".c-toplink",".fab__scroll",".custom-topbutton","#editorial-popin",".footer__nl",".spu-bg","#arrow-up","a[href=\"#goToHead\"]","#topcontrol",".secondary-footer",".custom-gated-topic-container",".ua-zen-back-to-top",".popup-overlay,\n.sitewide-quiz-banner",".a-scroll-top-btn","[x-data^=\"alpine_scroll_to_top\"]",".ma-don-cont",".swal2-container",".eWFZXO",".pujar_adalt",".tvbottom-to-top",".sidedock56-placement",".bottom-bar__up","#videoContainer.playersmall[style^=\"position: relative; aspect-ratio: initial; background: black; margin-bottom:\"]","#mb-scrollup",".terms-of-service-popup","#next-teaser",".top-clone",".homepage-upsell",".mpu-subscription-upsell",".bloc-nl",".nl","#goup,\n#simplemodal-container,\n#simplemodal-overlay",".box-one-click",".js-scrollTo","#toTopBtn","push-more-content","#sticky_footer_article",".figaro-player.is-sticky",".bloc-promo-nl,\n.bloc.advice",".l-search-evaluation",".sf-extensionfactory-link",".return-top","#toast",".link-top",".cloux-mailchimp",".UpButton","#ad-scroll-banner,\n.adv-desktop-left","#sleek-button-btn","#thumbs_div","#block-follow-site",".castle-nextprev",".scroll-btn",".nygov-back-to-top",".page-nav","#infiload-return-top","#site_nt",".scroll-top-arrow",".atop",".fixedbox","#ib-scrolltop","#back_top",".js-react-registration-toplayer",".bottom-0","#contribution-prompt-overlay,\n.contribution-prompt",".carousel__nav",".walla-icon-arrow-up",".xbFootNewsForm","#news_on_exit","#button","#myBtn",".bottom-0.fixed.lg\\:max-w-\\[1008px\\]",".story__arrow",".pre_next","#advisoryModadId1",".recommended__widget","#supportStrap,\n.carousel-is-sticky.trending-carousel,\n.contribute-block,\n.not-paywall-floating-contribute-block","a[data-gtm-tcb=\"TCB_CLICK_scrollbanner_default_exp_income\"],\na[data-gtm-tcb^=\"TCB_CLICK_buntyubanner_\"]",".bottom_sticky_menu_unify",".postNavigation","#text-92,\n#zox-lead-bot",".osn_base",".ancr-group","#body-fixed-footer",".styled__Wrapper-sc-1xbee9a-0","#surveyJS,\n.project_count_banner__container__TLBbH","#earn-sidebar",".icon-banner",".js-userLogin-popup.popup-register","#scroll","#wrapper-header-small-up","#smart-app-banner",".to_top",".scrollbutton",".in,\n.popup",".ArrowGoTop","#arrow-back-top",".moveToTop",".section-footer-nl","#IAS_container","#srollTop","#loader","#box-banner-messaggero","#tal",".hc_scrollup","#intestazione","#G_info","#slimheader","#dyscrollup-btn",".box-engage-mag",".popmake","#moveUp","#ea-alert-menu",".nav_articoli","#FJToTop","#pre-header",".c-header__top-bar","#top-of-the-page",".modezuparrow",".gotopbr","#topBtn",".ScrollTop",".containerBannerBox","#sostegno",".articoli_correlati",".acy-email-footer",".box_dem",".top_arrow_footer","#POPUPS_ROOT",".top_sali",".footer-top-feild","#centralNotice","#BoxGri",".call-iscrizione,\n.conferma_reg_nl",".newsButton","#cg-top-button",".lkPopover","#scrollblock","#scroll-top-container",".article_nav",".frecciabg","#slidingblock","#vl-back-top",".alert","#slideUpForm",".hm_go_top",".tasto-dona",".page-link-top",".j-navTop",".nav-reveal","#go-up-banner","div[class^=\"UpScroll_\"]",".recibe","#TGCom24HeaderBanner",".article_newls_box","#templatemo_container_barra","#InAlto",".wpdiscuz-front-actions",".btn-scroll-top",".link-to-top",".backto",".article-navigation",".code-mc-container-panel:has(a[href$=\"/ranking.html\"])","#entryprompt_area,\n.post_content > a[href*=\"?utm_source\"] > img",".dc__pagetop",".bfb_textBtn","#page-top",".ntv-pageTop","#btn-pagetop","#pg_top,\n.ai_floating_bnr",".riff-BackTop__root","#_popIn_right","#hs-web-interactives-bottom-anchor","#dfng-popup","#right-feedback-btn,\n#sticky-register-to-j-stage,\n.take-on-top",".autoScrollBtn",".page_top","#myPaymentModal",".l-fixed,\n.p-article__banners,\n.qualvaBtn",".common-wrap--ranking,\n.common-wrap--recommend",".pageTop",".hls-player_message","div[class*=\"anim-n_slideFadeInFromBottom\"]",".searchResult-nicoadNicodicItem","#js-pageTop","#floatingBnr","#full-screen-ad","#btnSkipTop","[href=\"#\"]",".goUp","#marketing-banner",".icon-top",".gain","#returnTop","#suscription-block",".freeModal,\n.slider-story",".bottom-nav",".nextart",".btn-up",".support-cepr-sec","#js-customer-satisfaction-popup",".move_up","#asideWriteGuide","#rt\\.popup-overlay_rt_popup_sws,\n#rt_popup_sws",".eg-ics-rss-64px",".custom-social-proof",".Bigfoot-navigationUp","#the-day-in-history",".panelSubscription",".iib-banner-link,\n.iib-page-promo","#read-next-2018","#topScroller,\n.donation-popup-box","[title=\"Scroll To Top\"]","#custom_html-8","#wrapperdiv","#navigation,\n.breaking-news-container,\n.side-banner",".couplet_app,\n.tools_top",".header-mini-banner",".hey-nc-bottom-link-banner,\n.hey-nc-top-banner",".btm-left-popupbox","#ajax-spinner,\n.deals",".navigation__donate",".fixed-bottom",".codeBlock","#exit-modal",".scribd-ad-exit-modal",".ly_pagetop-main",".useVisitedState.nonspot.headlineItem","[title=\"Go to top\"]",".single-cube_clusters_promo-cluster_hrefWrapper",".article__donate","#block-block-92",".footer__totop",".top-slide","#sticky_container",".articleSuggestStories","#presspatron-footer",".site__footer__back-to-top",".dynotifyjs-corner",".down.premium-toaster,\n.recommended-articles__heading",".js-show-up-arrow","#neighbourly,\n.feedback-link-wrapper,\n.supporter-wrapper",".article-navbar",".article-navigation-buttons",".article-peep,\n.infinite-scroll-divider,\n.staffInlineBannerOuter",".ad-container",".block-general-copy",".promotion",".tdm_block_call_to_action",".hills-inline-full-width","#post-navigation",".aarpe-site-banner,\n.backgroundParsys,\n.caregivingPromotion,\n.section.membership,\n.sharp-c-configurable-carousel__slide--multi",".motw-controls",".support-us__wrapper___28JTY",".paywall-notification-bar-wrapper","#article-back-to-top",".js-donate-banner","#home-donate-button",".suggestion-box",".bps-banner",".donation,\n.engagement-card-sidebar-section",".companion,\n.countdown-container,\n.sticky-bubble-wrp",".spread",".cspan-ad-still-prebid-placeholder","#cm-event-ad-2024-d",".chd-defender-widget--donate,\n.chd-shortcode-donation-ask,\n.chd-shortcode__link",".donation__container",".m_article-donate","#slp-news-tip-widget,\n.page-donate-footnote",".breaking-news-top-wrapper,\n.post-section--message\\/desktop,\n.rm-sticky-parent",".labnolFB","#block-3","#appeal,\n#top_anchor,\n.donate_banner",".pane-site-banner",".ScrollToTop_scroll-to-top__mLPhy",".widget_factcheck_donate_widget",".simple-banner",".appeal-bar-donation-list,\n.appeal-bar-text,\n.footer__cta-wrapper,\n.grist-modal-ad-blocker,\n.js-membership-ad.membership-ad,\n.wp-block-article-donation","#block-signupbarblock",".banner-donation-default-inline,\n.banner-donation-default-sidebar",".vue-back-to-top",".JustWatch",".donate-cta,\n.icn-donate-block","#backtoTop","#donation-button-footer","#XZSCFLEW,\n._hide_if_premium_user,\n.header-banner,\n.registration-popup",".footer-widget,\n.membership-incontent-banner",".donate-banner,\n[href=\"/apply/\"]",".PromoD","#donate-banner","#alerts,\n.promo-article-dark","#header-cts",".sticky-issue",".styles_cta__rFpfQ,\n.styles_membershipContainer__10uhb","#banner-top-prom,\n#single_top,\n#widget-tracking","#global-giving-item,\n.c-callout-banner,\n.c-donate-cta",".quicktip[type=\"spendenaufruf\"]",".mh-notice,\n.mw-dismissable-notice",".mzp-c-sticky-promo",".donate-ask,\n.donateAsk",".jetpack-lazy-image--handled","#banner-small,\n.netzpolitik-cta","#promo_insert_container","#banner",".cookbook-button-section",".internal_promotion,\n.overlay-cta,\n.sustainer",".dontprintme,\n.is-visible.js-init.Modal",".donate-footer",".ad,\n.footer__donate",".donate_strip,\n.topscroll","#welcome_box","#donateMsgPopup,\n.popup-cookies",".flyout1",".support-message",".md-banner","div[style=\"top:0;right:0;position:absolute\"]","#XHMSPXWS",".fundraising-letter-inline,\n.module-donate,\n.site-header__banner",".bright-blue-big,\n.mp-html",".fundraiser-banner","#dropBG",".dropdown-banner",".returntotop",".alert-donation,\n.show-recommended",".hide-on-landing","#stackcommerce-adwrap,\n.deals-footer",".data-mon-block","#block-block-10",".elementor-popup-modal",".ga\\:component\\:main\\:inline\\:support","#button-scrolltop",".has-vert-bar--padded-xxl","#donate_rocket,\n#support_box,\n.republish",".uabb-infobox",".alert-banner","#bottom_donation",".header-stripe,\n.js-promotion",".welcome-mat","#tmlPopupDonate,\n.mdl-section-donate-banner,\n.tml-popup-donate-holder",".addendum",".truth-hellobar-placement,\n.truth-post-content-after,\n.wp-block-truthout-related-article-block","#special-message",".PagePromoModuleC",".header-donate","#support-us",".PromoS",".ads,\n[href=\"https://whowhatwhy.org/donate/\"]",".hearken-embed","#siteNotice",".ahe-ad",".yui-popup-container-node","#story-chunk","#support-pop-up",".prev-next-sec",".shotimoo","#l-overlay,\ndiv[style*=\"position: fixed\"]",".infoBox",".podcasts-home","#goUp","#redesSociais","#myBtnGoToTop",".wp-image-241027",".fa-feed",".gttt",".links","div[id^=\"unit_\"]",".cb-goup","#page-error-modal",".up-button-page",".up_button",".seti",".b-scroller-up",".b-button-up",".black-friday-banner",".block-article-shoutout",".chrome-extension-banner",".popnav",".popover-billboard--menuopenupwards","#totopbutton",".gmr-ontop",".kanews-banner",".kapee-back-to-top",".scrollUP","#tasto_top",".diretta-tv",".sticky-bottom-banner,\n.sticky-bottom-banner-wrapper",".dialog-widget-content,\n.support-popup-section",".nag","#flyout-recommended-content",".mod-to-top","#twilight-sticky-footer-root","#scroll_up","#w2g-center-doit,\n.w2g-doit,\n.w2g-top-message-small","#topx",".Subscription",".m_banner",".b-top",".btt__inner","#chromelessPlayer,\n#next-story,\n#swipeIndicator,\n.rss_feeds_buttons,\n.swipe-bar,\n.swipe-tutorial",".avia-post-nav","#link-banner","#article-im-prompt",".inews__back-to-top",".g_bar,\ndiv[style=\"width:100%;clear:both;\"]",".issuu,\n.jn-donate-popup","#alert-footer-box",".londo-target","#we-need-monies",".metro-swipe-prompt",".blocker,\n.site-ribbon,\n.ticker",".omg-hero-button","#si-scroll-top",".foobar-wrapper",".promo--small",".ccc-widget",".send-us-your-news-cta",".animate-fly",".subscription-banner",".sf-header-subscription__content,\n.sf-subscribe",".next-article-btn,\n.prev-article-btn",".leaf",".pcf-backtotop",".wp-block-humanists-uk-bootstrap-campaigns-block,\n.wp-block-humanists-uk-bootstrap-notes-block",".super-button",".widget_hustle_module_widget",".formFooter-wrapper",".subscribe-cta",".bottom-button-top","#upprev_box",".scrolltop-button","#btTop",".article-subscribe",".subscribe_ad_free",".next-previous-article","#in-article-action-1,\n#post-article-footer,\n#ribbon-container,\n.top_stories",".mny-promo-popup","#register-popup-backdrop,\n.register-modal-popup-wrapper","#eltd-back-to-top",".up-scroll"];

const hostnamesMap = new Map([["grow.google",0],["filmix.ac",2],["motordoctor.at",2],["motordoctor.ch",2],["m.mouthshut.com",2],["motordoctor.de",2],["motordoctor.dk",2],["motordoctor.es",2],["motordoctor.fi",2],["motordoctor.fr",2],["motordoctor.gr",2],["motordoctor.hu",2],["motordoctor.it",2],["motor-doctor.nl",2],["motordoctor.co.no",2],["motordoctor.pl",2],["motordoctor.pt",2],["motordoctor.ro",2],["motordoctor.se",2],["motor-doctor.co.uk",2],["www.google.ac",3],["www.google.ae",3],["www.google.com.ar",3],["www.google.at",3],["www.google.com.au",3],["www.google.be",3],["www.google.bg",3],["www.google.com.br",3],["www.google.by",3],["www.google.ca",3],["www.google.ch",3],["www.google.cl",3],["www.google.com.co",3],["www.google.com",[3,477]],["www.google.cz",3],["www.google.de",3],["www.google.dk",3],["www.google.dz",3],["www.google.com.ec",3],["www.google.ee",3],["www.google.com.eg",3],["www.google.es",3],["www.google.fi",3],["www.google.fr",3],["www.google.gr",3],["www.google.com.hk",3],["www.google.hr",3],["www.google.hu",3],["www.google.co.id",3],["www.google.ie",3],["www.google.co.il",3],["www.google.co.in",3],["www.google.it",3],["www.google.co.jp",3],["www.google.co.ke",3],["www.google.co.kr",3],["www.google.lt",3],["www.google.lv",3],["www.google.com.mx",3],["www.google.com.my",3],["www.google.nl",3],["www.google.no",3],["www.google.co.nz",3],["www.google.com.pe",3],["www.google.com.ph",3],["www.google.com.pk",3],["www.google.pl",3],["www.google.pt",3],["www.google.com.py",3],["www.google.ro",3],["www.google.rs",3],["www.google.ru",3],["www.google.com.sa",3],["www.google.se",3],["www.google.com.sg",3],["www.google.sk",3],["www.google.co.th",3],["www.google.com.tr",3],["www.google.com.tw",3],["www.google.com.ua",3],["www.google.co.uk",3],["www.google.com.uy",3],["www.google.co.ve",3],["www.google.com.vn",3],["www.google.co.za",3],["generalist.academy",4],["news.northwestern.edu",4],["budapester.hu",4],["albayan.ae",5],["nca.aero",5],["dagospia.com",5],["repsol.com",5],["tradetracker.com",5],["antennebrandenburg.de",5],["vodafone.de",5],["israeltoday.co.il",5],["dz-algerie.info",5],["autoscout24.it",5],["billboard.it",5],["calendario-365.it",[5,86]],["lvh.it",5],["regione.marche.it",5],["chinadialogue.net",5],["amazon.ae",[6,7]],["amazon.com.au",[6,7,20]],["amazon.ca",[6,7,20]],["amazon.cn",[6,7]],["amazon.com",[6,7,20,153]],["amazon.de",[6,7]],["amazon.es",[6,7]],["amazon.fr",6],["amazon.in",6],["amazon.co.jp",[6,7]],["amazon.nl",6],["amazon.sg",6],["amazon.co.uk",[6,7,20]],["guardianbookshop.co.uk",7],["gulftoday.ae",[8,9]],["nostalgica.cl",9],["50languages.com",9],["boredpanda.com",9],["business-standard.com",9],["cnevpost.com",9],["hsn.com",9],["lessknownfacts.com",9],["malighting.com",9],["pandasecurity.com",9],["pbteen.com",9],["ingolstadt-today.de",9],["multiup.eu",9],["origo.hu",9],["peoplematters.in",9],["labouroutlook.org",9],["multiup.org",9],["advgazeta.ru",9],["leadingrestaurants.co.uk",9],["iol.co.za",9],["nation.africa",10],["armradio.am",11],["lanacion.com.ar",12],["baguette.at",13],["ebay.at",[14,15]],["ebay.com",[14,15,384]],["ebay.de",[14,15]],["ebay.es",[14,15]],["ebay.fr",[14,15]],["ebay.it",[14,15]],["ebay.nl",[14,15]],["ebay.pl",[14,15]],["ebay.co.uk",[14,15]],["ebay.com.au",15],["noen.at",16],["clxgaming.com",16],["gedidigital.it",16],["on.orf.at",17],["soeren-hentzschel.at",18],["therese-moelk.at",19],["bellasugar.com.au",21],["carsales.com.au",22],["catch.com.au",23],["crazysales.com.au",24],["zona.eu",24],["holidayswithkids.com.au",25],["panoramapolitico.co",25],["circuitbasics.com",25],["milwaukeeindependent.com",25],["thegrio.com",25],["vgleaks.com",25],["marsalace.it",25],["hiswatewater.nl",25],["hardwarezone.com.sg",25],["foodstuffsa.co.za",25],["jw.com.au",26],["michaelwest.com.au",27],["moshtix.com.au",28],["mydeal.com.au",29],["nine.com.au",30],["ozsale.com.au",31],["techguide.com.au",32],["themonthly.com.au",33],["thenightly.com.au",34],["thesaturdaypaper.com.au",35],["who.com.au",36],["ia.acs.org.au",37],["darko.audio",38],["americansongwriter.com",38],["ogbongeblog.com",38],["azernews.az",39],["mmegi.bw",39],["airbnb.be",40],["moniteurautomobile.be",41],["ebookrenta.com",41],["indiatimes.com",41],["marketbusinessnews.com",41],["philstar.com",[41,307]],["timesnownews.com",41],["xiachufang.com",41],["knowledge.wharton.upenn.edu",41],["insidethegames.biz",42],["licensing.biz",43],["mobile-ent.biz",43],["next-gen.biz",44],["freemake.com",44],["pocketgamer.biz",45],["intercept.com.br",46],["linkrosa.com.br",47],["splove.com.br",47],["pinkluna.com.br",48],["revistaencontro.com.br",49],["trabalhabrasil.com.br",50],["carscoops.com",50],["piunikaweb.com",50],["dioezesanmuseum-rottenburg.de",50],["vonovia.de",50],["deghi.it",50],["bl.uk",50],["folha.uol.com.br",51],["valor.com.br",52],["wanda.cn",52],["humanresourcesonline.net",52],["viomundo.com.br",53],["codastory.com",53],["imperiya.by",54],["systems.bz",55],["123ink.ca",56],["itdevices.ca",56],["primecables.ca",56],["americanmusical.com",56],["kingofcocaine.com",56],["cinemo.hu",56],["labusa.info",56],["joemonster.org",56],["aptnnews.ca",[57,58]],["uska.ch",58],["gatewayhispanic.com",58],["morbidology.com",58],["rivanimation.com",58],["theoverclocker.com",58],["spuf.org",58],["wdet.org",[58,1368]],["cheknews.ca",59],["citynews.ca",60],["fool.ca",61],["halifaxexaminer.ca",62],["inquinte.ca",63],["kbb.ca",64],["mikesmoneytalks.ca",65],["niagarafallsreview.ca",66],["bozemandailychronicle.com",[66,237]],["dinamalar.com",66],["thepeterboroughexaminer.com",66],["thespec.com",66],["rabble.ca",[67,68]],["thedp.com",68],["sciencenews.org",68],["ici.radio-canada.ca",69],["sfu.ca",70],["al-watan.com",70],["coinedcuisine.com",70],["duhuliye.com",70],["krdb.com",70],["leakedzone.com",70],["qatar-tribune.com",70],["sandordargo.com",70],["volexity.com",70],["neue-impulse-verlag.de",70],["slocounty.ca.gov",70],["brevzin.github.io",70],["appdate.lk",70],["accessnow.org",70],["tfn.scot",70],["shopperplus.ca",71],["bostonherald.com",71],["cosmosup.com",71],["dailysignal.com",[71,337]],["haier.com",71],["sivtimes.com",71],["visitnsw.com",71],["wikiway.com",71],["svp.eu",71],["abitare-in-altoadige.it",71],["automobilismo.it",71],["ciclismo.it",71],["cyclistmagazine.it",71],["motociclismo.it",71],["velaemotore.it",71],["wohnen-in-suedtirol.it",71],["nrc.nl",71],["germany.travel",71],["freeviewnz.tv",71],["thefappening.wiki",71],["sportsnet.ca",72],["staples.ca",73],["thecanadianpressnews.ca",74],["wellandtribune.ca",74],["berkshireeagle.com",74],["bgdailynews.com",74],["bramptonguardian.com",74],["captimes.com",[74,260]],["chronicle-tribune.com",74],["citizentribune.com",74],["clintonherald.com",74],["coloradopolitics.com",74],["crossroadstoday.com",[74,320]],["csindy.com",74],["dailygazette.com",74],["dailyitem.com",74],["dentonrc.com",74],["denvergazette.com",74],["gazette.com",74],["guelphmercury.com",74],["herald-dispatch.com",[74,493]],["hjnews.com",[74,237]],["homenewshere.com",74],["insidenova.com",74],["insideottawavalley.com",74],["insightnews.com",74],["jhnewsandguide.com",74],["kentuckytoday.com",74],["keysnews.com",74],["khq.com",74],["kilgorenewsherald.com",74],["kmaland.com",74],["kmzu.com",74],["komu.com",74],["ktbs.com",74],["kulr8.com",74],["lufkindailynews.com",74],["mdjonline.com",74],["mtdemocrat.com",74],["nashvillescene.com",[74,653]],["nbcrightnow.com",74],["news-gazette.com",74],["niagarathisweek.com",74],["northcentralpa.com",74],["ottumwacourier.com",74],["phillytrib.com",74],["postandcourier.com",74],["pulaskicountyweekly.com",74],["reformer.com",74],["sfexaminer.com",74],["sfweekly.com",74],["sharonherald.com",74],["starlocalmedia.com",74],["swiowanewssource.com",74],["thecentersquare.com",74],["themountaineer.com",74],["thenewsenterprise.com",74],["therecord.com",74],["thesuburban.com",74],["thetimestribune.com",74],["unionleader.com",74],["wdel.com",74],["wdrb.com",74],["wfmz.com",74],["wvgazettemail.com",74],["wvnews.com",74],["youralaskalink.com",74],["newsmirror.net",74],["wyomingnewsnow.tv",74],["thetyee.ca",75],["thewalrus.ca",[76,77]],["dailyevergreen.com",77],["dailyexpose.uk",[77,673]],["trutone.ca",78],["dihi.org",78],["tsc.ca",79],["bigislandnow.com",79],["mmoga.com",79],["mmoga.de",79],["med.stanford.edu",79],["mmoga.es",79],["mmoga.fr",79],["toplegal.it",79],["mmoga.se",79],["mmoga.co.uk",79],["vov.vn",79],["tsn.ca",80],["nouvelles.umontreal.ca",81],["rac1.cat",82],["paradisehill.cc",83],["road.cc",84],["romaest.cc",85],["zipnews.it",85],["irusa.org",85],["cdt.ch",86],["shine.cn",86],["aurecongroup.com",86],["filmatipornohd.com",86],["gasoline-station.com",86],["pastebin.com",[86,710]],["secondnexus.com",86],["suninternational.com",86],["unifiedlayers.com",86],["visitnordic.com",86],["rktbns.de",86],["wifi.id",86],["gov.il",86],["boomlive.in",[86,1093,1094]],["millenniumpost.in",86],["thebridge.in",86],["consumer.bz.it",86],["dmail.it",86],["kellergrigliati.it",86],["paginesi.it",86],["saras.it",86],["vog.it",86],["valdelsa.net",86],["premierchristian.news",[86,1255]],["drivesouth.co.nz",86],["revistablogurilor.ro",86],["rti.org.tw",[86,93]],["caltex.co.za",86],["cryptonomist.ch",87],["globalguideline.com",87],["isanek.com",87],["iogames.onl",87],["derbund.ch",88],["swissinfo.ch",89],["unige.ch",90],["strip.chat",91],["imagetwistcams.com",91],["stripchat.com",91],["xhamsterlive.com",91],["jumia.ci",92],["jumia.com.dz",92],["jumia.com.eg",92],["jumia.com.gh",92],["jumia.co.ke",92],["jumia.ma",92],["jumia.com.ng",92],["jumia.sn",92],["jumia.com.tn",92],["jumia.ug",92],["4399.cn",93],["weather.com.cn",93],["dailypioneer.com",93],["digitimes.com",93],["mmm100.com",93],["moneycontrol.com",93],["sport-express.ru",93],["cna.com.tw",[93,1419]],["cts.com.tw",93],["digitimes.com.tw",93],["chinadaily.com.cn",94],["people.com.cn",95],["kafan.cn",96],["404media.co",97],["aeon.co",[98,99]],["psyche.co",[98,102]],["coconuts.co",100],["convertio.co",101],["tech.co",103],["tedium.co",104],["theblock.co",105],["thecanary.co",106],["thecradle.co",107],["therage.co",108],["11alive.com",109],["9news.com",109],["wkyc.com",109],["wusa9.com",109],["123apps.com",110],["online-video-cutter.com",110],["mp3cut.net",110],["music.163.com",111],["3bmeteo.com",112],["4clik.com",113],["4kdownload.com",114],["4sysops.com",115],["699pic.com",[116,117]],["al-akhbar.com",116],["mariahcarey.com",116],["osgamers.com",116],["classicbid.de",116],["tageblatt.de",116],["powvideo.net",116],["omannews.gov.om",116],["finallyfocused.org",[116,1301]],["6abc.com",118],["abc11.com",118],["abc13.com",118],["abc30.com",118],["abc7.com",118],["abc7chicago.com",118],["abc7news.com",118],["abc7ny.com",118],["7is7.com",119],["criosweb.ro",119],["90percentofeverything.com",120],["91mobiles.com",121],["bohemian.com",121],["cinelinx.com",121],["genengnews.com",121],["geopoliticalfutures.com",121],["itmunch.com",[121,537]],["politik.co.nz",121],["92q.com",122],["cassiuslife.com",122],["espnrichmond.com",122],["foxync.com",122],["hellobeautiful.com",122],["hiphopnc.com",122],["hotspotatl.com",122],["ipowerrichmond.com",122],["joycolumbus.com",122],["kissdetroit.com",122],["kissrichmond.com",122],["kysdc.com",122],["magicbaltimore.com",122],["majic945.com",122],["majicatl.com",122],["mybaltimorespirit.com",122],["myboomatl.com",122],["mycolumbusmagic.com",122],["mycolumbuspower.com",122],["myhoustonmajic.com",122],["mymajicdc.com",122],["mypraiseatl.com",122],["myspiritdc.com",122],["newsone.com",122],["newstalkcleveland.com",122],["oldschool1053.com",122],["praise1027detroit.com",122],["praisebaltimore.com",122],["praisecharlotte.com",122],["praisecleveland.com",122],["praisedc.com",122],["praisehouston.com",122],["praiseindy.com",122],["praisephilly.com",122],["radionowhouston.com",122],["radionowindy.com",122],["rnbcincy.com",122],["rnbphilly.com",122],["thebeatdfw.com",122],["theboxhouston.com",122],["thelightnc.com",122],["tlcnaptown.com",122],["wiznation.com",122],["wolbbaltimore.com",122],["woldcnews.com",122],["wzakcleveland.com",122],["zhiphopcleveland.com",122],["972mag.com",[123,124]],["electronicintifada.net",123],["opendemocracy.net",[123,1246]],["fullfact.org",123],["abhiandroid.com",125],["abovethelaw.com",126],["abovetopsecret.com",127],["accessoires-asus.com",128],["accuradio.com",129],["accuweather.com",130],["adexchanger.com",[131,132]],["ethnews.com",[131,227]],["news24.com",131],["pokerupdate.com",131],["wn.com",131],["live-adexchanger.pantheonsite.io",131],["manilatimes.net",[131,450]],["adguard.com",133],["adnkronos.com",134],["adotas.com",135],["cdispatch.com",[135,269]],["drsinatra.com",[135,269]],["hotscripts.com",[135,269]],["mac-forums.com",[135,269]],["mercola.com",[135,269]],["pier1.com",[135,269]],["squawkfox.com",[135,833]],["thebolditalic.com",[135,269]],["underarmour.com",[135,269]],["warrior.com",[135,269]],["boldprogressives.org",[135,269]],["advocate.com",136],["adweek.com",137],["aeromalls.com",138],["coinmarketcap.com",138],["ecrater.com",138],["gadgetstouse.com",138],["hotels.com",138],["iphoneitalia.com",138],["safetydetectives.com",138],["theblondeabroad.com",138],["thefintechtimes.com",138],["tvrus.eu",138],["gipa.ge",138],["advister.it",138],["roadhousestory.it",138],["hard-drive.net",138],["yoshuabengio.org",138],["afr.com",139],["airliquide.com",140],["ajc.com",141],["albertsons.com",142],["celebritycruises.com",142],["giantfreakinrobot.com",142],["mygenefood.com",142],["onthegotours.com",142],["savoredjourneys.com",142],["wanderlustcrew.com",142],["err.ee",142],["nzherald.co.nz",[142,1264]],["dl.acm.org",142],["stanfordreview.org",142],["algemeiner.com",143],["aliexpress.com",144],["aliexpress.us",144],["alistapart.com",145],["allaboutcd.com",146],["alligator-sunglasses.com",147],["bucketlistseekers.com",147],["want.nl",147],["allnightnippon.com",148],["global.toyota",148],["allsides.com",149],["allvoices.com",150],["statetechmagazine.com",150],["thesixthaxis.com",150],["altoadigelatte.com",151],["cine974.com",151],["europeanjournalists.org",151],["amazines.com",152],["signin.aws.amazon.com",154],["ambotv.com",155],["americanwirenews.com",156],["bizpacreview.com",[156,223]],["amtrak.com",[157,158]],["collegiatetimes.com",157],["titantv.com",157],["analdin.com",159],["reverbpress.com",159],["uinterview.com",159],["anandtech.com",160],["citytv.com",160],["slantmagazine.com",160],["superbooyah.com",160],["twitchy.com",160],["aorus.com",[161,162]],["insidebitcoins.com",161],["apkcombo.com",163],["apkmirror.com",164],["apnews.com",165],["appbrain.com",166],["support.apple.com",167],["applesencia.com",168],["capitalibre.com",168],["cheatcc.com",168],["frenomotor.com",168],["placeralplato.com",168],["rootear.com",168],["sportadictos.com",168],["thrillophilia.com",168],["winphonemetro.com",168],["xombit.com",168],["xombitgames.com",168],["xombitmusic.com",168],["aquamanga.com",169],["reaperscans.com",169],["arabtimesonline.com",170],["conservativedailynews.com",[170,303]],["elpasoheraldpost.com",170],["laprensalatina.com",170],["loadthegame.com",170],["sigma-4pc.com",170],["voxelmatters.com",170],["xboxera.com",170],["archdaily.com",171],["artnews.com",172],["artstation.com",173],["asahi.com",174],["askubuntu.com",175],["serverfault.com",175],["stackexchange.com",175],["stackoverflow.com",[175,835]],["superuser.com",175],["mathoverflow.net",175],["astrofame.com",176],["astronomy.com",177],["feedspot.com",[177,186]],["asus.com",178],["atheistrepublic.com",179],["atlantaradiokorea.com",180],["atlasobscura.com",181],["atozmath.com",182],["atramentowka.com",183],["link11.com",183],["oil-land.pl",183],["sklep-art-meb.pl",183],["latuaitalia.ru",183],["subscribe.ru",183],["tv-soyuz.ru",183],["vz.ru",183],["picardirebel.co.za",183],["audio-joiner.com",184],["online-voice-recorder.com",184],["video-converter.com",184],["convert.io",184],["pdf.io",184],["webcamera.io",184],["extract.me",184],["audioholics.com",[185,186]],["jobomas.com",[185,186]],["ffr.fr",185],["patient.info",185],["bournemouthecho.co.uk",[185,186]],["decalgirl.com",186],["straitstimes.com",[186,843]],["watchsomuchproxy.com",[186,960]],["younow.com",186],["ociservices.gov.in",[186,1099]],["police.uk",186],["austinchronicle.com",187],["auto-moto.com",188],["blog.avast.com",189],["avg.com",190],["copykat.com",190],["snagfilms.com",190],["azuremagazine.com",191],["backpacker.com",192],["map.baidu.com",193],["bakusai.com",194],["banggood.com",195],["basket4ballers.com",196],["bayer.com",197],["jpx.co.jp",197],["gamespark.jp",197],["response.jp",197],["baystatebanner.com",198],["bbc.com",199],["bbcgoodfood.com",200],["bd.com",201],["vpnranks.com",201],["livelaw.in",201],["isocellitalia.it",201],["beautyhigh.com",[202,203]],["thevivant.com",202],["beincrypto.com",204],["benzinga.com",205],["betootaadvocate.com",206],["beverfood.com",207],["about.bgov.com",208],["bgr.com",209],["bhaskar.com",210],["bigissue.com",211],["bigthink.com",212],["bikeradar.com",213],["bikerumor.com",214],["bilibili.com",215],["billboard.com",216],["bingehulu.com",217],["bingplaces.com",218],["biometricupdate.com",219],["birdwatchingdaily.com",220],["bitfinex.com",221],["bizcommunity.com",222],["blauerusa.com",224],["bleepingcomputer.com",225],["techdirt.com",[225,860]],["blizzardwatch.com",226],["bloomberg.com",227],["curseforge.com",[227,328]],["gwaramedia.com",[227,485]],["letterboxd.com",227],["monkeytype.com",227],["singsnap.com",227],["springer.com",227],["newstalkzb.co.nz",227],["freecodecamp.org",227],["goodnet.org",227],["wikipedia.org",[227,1156,1373]],["news.bloomberglaw.com",228],["news.bloombergtax.com",228],["bluestacks.com",229],["bmwblog.com",230],["gwinnettdailypost.com",230],["la-croix.com",230],["porn5.com",230],["bonappetit.com",231],["wired.com",[231,979]],["bonjourlife.com",232],["visualnews.com",232],["booking.com",233],["booksnreview.com",234],["boursier.com",235],["bowhuntingmag.com",236],["firearmsnews.com",236],["flyfisherman.com",236],["gameandfishmag.com",236],["gundogmag.com",236],["gunsandammo.com",[236,289]],["handgunsmag.com",236],["in-fisherman.com",236],["northamericanwhitetail.com",236],["outdoorchannelplus.com",236],["petersenshunting.com",236],["shootingtimes.com",236],["wildfowlmag.com",236],["bplaytipremia.com",238],["tempoitalia.it",238],["bradblog.com",239],["search.brave.com",240],["breitbart.com",241],["brighteon.com",242],["britishland.com",243],["browardpalmbeach.com",[244,245]],["dallasobserver.com",[244,245,340]],["miaminewtimes.com",[244,245,615]],["westword.com",[244,245]],["phoenixnewtimes.com",245],["buckinghamshirelive.com",246],["cornwalllive.com",246],["devonlive.com",246],["nottinghampost.com",246],["buzz.ie",246],["dublinlive.ie",246],["irishmirror.ie",246],["dorset.live",246],["lancs.live",246],["coventrytelegraph.net",246],["aberdeenlive.news",246],["essexlive.news",246],["kentlive.news",246],["mylondon.news",246],["belfastlive.co.uk",246],["birminghammail.co.uk",246],["bristolpost.co.uk",246],["business-live.co.uk",246],["cambridge-news.co.uk",246],["cheshire-live.co.uk",246],["chroniclelive.co.uk",246],["dailypost.co.uk",246],["dailyrecord.co.uk",246],["dailystar.co.uk",246],["derbytelegraph.co.uk",246],["edinburghlive.co.uk",246],["examinerlive.co.uk",246],["gazettelive.co.uk",246],["getsurrey.co.uk",246],["glasgowlive.co.uk",246],["gloucestershirelive.co.uk",246],["grimsbytelegraph.co.uk",246],["hertfordshiremercury.co.uk",246],["hulldailymail.co.uk",246],["insider.co.uk",246],["leeds-live.co.uk",246],["leicestermercury.co.uk",246],["lincolnshirelive.co.uk",246],["liverpoolecho.co.uk",246],["manchestereveningnews.co.uk",246],["mirror.co.uk",246],["norfolklive.co.uk",246],["ok.co.uk",246],["oxfordshirelive.co.uk",246],["plymouthherald.co.uk",246],["somersetlive.co.uk",246],["staffordshire-live.co.uk",246],["stokesentinel.co.uk",246],["walesonline.co.uk",246],["wiltshirelive.co.uk",246],["buffalorising.com",247],["buggedspace.com",248],["curioustic.com",248],["businessinsider.com",249],["insider.com",249],["butterwithasideofbread.com",250],["dirtyship.com",250],["momontimeout.com",250],["buzzfeed.com",251],["buzzfeednews.com",252],["byjus.com",253],["californiasunday.com",254],["cambiodns.com",255],["canonclast.com",256],["futurecapetown.com",256],["kqed.org",[256,1316]],["worldarchitecture.org",256],["capital.com",[257,258]],["permanentstyle.com",258],["vodacomsoccer.com",258],["alldomains.hosting",258],["capsulenz.com",259],["interest.co.nz",[259,1261]],["cardekho.com",261],["careerkarma.com",262],["carsandbids.com",263],["carsauce.com",264],["casinodelavallee.com",265],["cryptobizmagazine.com",265],["ijn.com",265],["nationwideradiojm.com",265],["tv360nigeria.com",265],["weeklyrecess.com",265],["stanfordmag.org",265],["catchnews.com",266],["catholicnewsagency.com",267],["cbsnews.com",268],["techcommunity.microsoft.com",[269,620]],["cdw.com",270],["celebified.com",271],["centrometeolombardo.com",272],["centrosuono.com",273],["gigaset.com",273],["hiclipart.com",273],["miui.com",273],["mytheresa.com",273],["pcbeta.com",273],["pngwing.com",273],["luchtvaartnieuws.nl",[273,1256]],["cheddar.com",274],["chektools.com",275],["chemistryworld.com",276],["chicagoreporter.com",277],["chiesi.com",278],["china.com",279],["hackingloops.com",279],["medibang.com",279],["chronicle.com",280],["churchmilitant.com",281],["ciiradio.com",282],["smutr.com",282],["reverso.net",282],["elcomercio.pe",282],["cio-online.com",283],["citybeat.com",284],["clevescene.com",284],["leoweekly.com",284],["metrotimes.com",284],["orlandoweekly.com",[284,702]],["sacurrent.com",[284,702,782]],["clevelandjewishnews.com",285],["kmov.com",285],["kptv.com",[285,555]],["climeworks.com",286],["cltampa.com",287],["clubcall.com",288],["cnbctv18.com",289],["consolecreatures.com",289],["ekathimerini.com",289],["gbnews.com",[289,456]],["justapack.com",289],["linuxlookup.com",289],["porngem.com",289],["ansa.it",289],["cacm.acm.org",289],["californiacitynews.org",289],["thedebrief.org",289],["cnet.com",290],["cnn.com",291],["cnnchile.com",292],["eatsmarter.com",292],["cockroachlabs.com",293],["codecalamity.com",294],["codeur.com",295],["coingecko.com",296],["coinlore.com",297],["coinpaprika.com",298],["collectorsweekly.com",299],["computerhope.com",300],["computingunleashed.com",301],["condominio.com",302],["libero.it",302],["consortiumnews.com",304],["consummateathlete.com",305],["contactmusic.com",306],["coreight.com",307],["cosedicasa.com",307],["lleida.com",307],["oantagonista.com",307],["soundonsound.com",307],["gamepro.de",307],["gamestar.de",307],["castanet.net",307],["adl.org",307],["news.ki.se",307],["corrosionpedia.com",308],["cosmicscans.com",309],["courier-journal.com",[310,311]],["courierpress.com",[310,311]],["detroitnews.com",[310,311]],["freep.com",[310,311]],["greenbaypressgazette.com",[310,311]],["jsonline.com",[310,311]],["lohud.com",[310,311]],["northjersey.com",[310,311]],["sheboyganpress.com",[310,311]],["tallahassee.com",[310,311]],["theadvertiser.com",[310,311]],["tiktok.com",[311,912]],["usatoday.com",311],["calculat.io",311],["cpuid.com",312],["crainscleveland.com",313],["crainsnewyork.com",313],["crealitycloud.com",314],["creativefabrica.com",315],["cricbuzz.com",316],["m.cricbuzz.com",317],["crimereads.com",318],["lithub.com",[318,585]],["crooksandliars.com",319],["news.crunchbase.com",321],["crypto.com",322],["cryptoglobe.com",323],["csmonitor.com",324],["csswizardry.com",325],["ctovision.com",326],["phonerpt.com",326],["umpcportal.com",326],["fullepisode.info",326],["cuisineaz.com",327],["cwtv.com",329],["cyberark.com",330],["cyberscoop.com",331],["dailyfx.com",332],["dailyhodl.com",333],["dailykos.com",334],["dailynewshungary.com",335],["dailysabah.com",336],["dailyvoice.com",338],["dailywire.com",339],["damemagazine.com",341],["damninteresting.com",342],["darkreading.com",[343,344]],["soundcloud.com",[343,821]],["datacamp.com",345],["datamation.com",346],["support.mozilla.org",346],["davinotti.com",347],["dcist.com",348],["ddtonline.com",349],["northsidesun.com",349],["deadline.com",350],["dealabs.com",[351,352]],["mydealz.de",351],["dealnews.com",353],["decider.com",354],["nypost.com",354],["pagesix.com",[354,706]],["deeditor.com",355],["deepl.com",356],["defensescoop.com",357],["fedscoop.com",357],["delanceyplace.com",358],["deltareading.com",359],["dengekionline.com",360],["designboom.com",361],["designobserver.com",362],["desmog.com",363],["devdiscourse.com",364],["dhgate.com",365],["dickssportinggoods.com",366],["dictionary.com",367],["didyouknowfacts.com",368],["digitalrev.com",369],["makeagif.com",369],["post-gazette.com",369],["tldrlegal.com",369],["yourtvseri.es",369],["disqus.com",370],["dmv-practice-test.com",371],["dnainfo.com",372],["minus.com",372],["virginislandsdailynews.com",372],["dole.com",373],["dollartree.com",374],["downloaddevtools.com",375],["drugs.com",376],["duckduckgo.com",377],["duo.com",378],["e-reader-info.com",379],["foreignpolicy.com",379],["seatguru.com",379],["earthcam.com",380],["easeus.com",381],["easeus.fr",381],["ebar.com",382],["farooqkperogi.com",382],["popmythology.com",382],["theapplepost.com",382],["blog.westerndigital.com",382],["osthessen-news.de",382],["stuttgarter-zeitung.de",382],["mieuxvivresante.fr",382],["pourquoidocteur.fr",382],["arigatojapan.co.jp",382],["amiventures.net",382],["jqueryscript.net",382],["ebaumsworld.com",383],["eboblack.com",385],["ixosofficial.com",385],["kapook.com",385],["maxcasa.com",385],["nilox.com",385],["publish0x.com",385],["scarpescarpestore.com",385],["teenxy.com",385],["alalam.ir",385],["consorzioautolinee.it",385],["murripatrizia.it",385],["nomisma.it",385],["rstore.it",385],["aniwatch.to",385],["aniwatchtv.to",385],["ecoaustral.com",386],["econotimes.com",387],["edilportale.com",388],["educba.com",[389,390]],["phoenixnap.com",389],["thecoastnews.com",389],["eepower.com",391],["egoallstars.com",392],["egotastic.com",392],["washingtonian.com",392],["wwtdd.com",392],["electromenager-compare.com",393],["homecine-compare.com",393],["lcd-compare.com",393],["elespanol.com",394],["elgrupoinformatico.com",395],["emmepress.com",396],["emol.com",397],["orizzontescuola.it",[397,1166]],["di.com.pl",397],["engadget.com",398],["thehollywoodgossip.com",398],["milliyet.com.tr",398],["entireweb.com",399],["softroboticstoolkit.com",399],["epicgames.com",400],["wapbold.net",400],["erome.com",401],["escapistmagazine.com",402],["esetindia.com",403],["etnews.com",404],["euobserver.com",405],["euractiv.com",406],["euromaidanpress.com",[407,408]],["kyivpost.com",[408,568]],["euronews.com",409],["eurosport.com",410],["everythingrf.com",411],["ew-nutrition.com",412],["expansion.com",413],["fandom.com",414],["fanfreegames.com",415],["fark.com",416],["fastcompany.com",417],["indexwp.com",[417,520]],["app.fastmail.com",418],["favbrowser.com",419],["fboomporn.com",420],["xcafe.com",420],["video.fc2.com",421],["video.laxd.com",421],["feedly.com",422],["fflogs.com",[423,424]],["warcraftlogs.com",423],["filehorse.com",425],["finbold.com",426],["fivebooks.com",427],["fixya.com",[428,429]],["thetruthaboutcars.com",[428,484,908]],["flaticon.com",430],["flightconnections.com",431],["flightradar24.com",432],["flightrising.com",433],["flyingmag.com",434],["food.com",435],["forbes.com",436],["forbesindia.com",437],["forvo.com",438],["forward.com",439],["foxbusiness.com",440],["foxnews.com",[440,441]],["infoq.com",[441,525]],["threadreaderapp.com",441],["stylist.co.uk",441],["france24.com",442],["rfi.fr",442],["freightwaves.com",443],["frontpagetech.com",444],["fstoppers.com",445],["ft.com",446],["fudzilla.com",447],["g2a.com",448],["game-news24.com",[449,450]],["gamedeveloper.com",451],["gamespot.com",452],["gamingonphone.com",453],["gardrops.com",454],["gayboystube.com",455],["geekwire.com",457],["gemoo.com",458],["gettr.com",459],["gianlucadimarzio.com",460],["girlonthenet.com",461],["github.com",462],["docs.github.com",463],["gmanetwork.com",464],["gnttv.com",[465,466]],["aajtak.in",[465,466]],["indiatodayne.in",465],["businesstoday.in",466],["abcnews.go.com",467],["goafricaonline.com",468],["gofugyourself.com",469],["golfdigest.com",470],["goodmenproject.com",471],["goodmorningamerica.com",472],["goodnes.com",473],["goodthingsguy.com",474],["goodwillfinds.com",475],["chromewebstore.google.com",476],["gothamist.com",478],["gpfans.com",479],["gq.com",480],["greenweddingshoes.com",481],["techday.com",481],["groupon.com",482],["wivb.com",482],["grundig.com",483],["gulfnews.com",484],["telekom.com",[484,511]],["aquab0n.fr",484],["independent.com.mt",484],["africacheck.org",484],["monthlyreview.org",484],["gzeromedia.com",486],["hackread.com",487],["hannity.com",488],["healthboards.com",489],["healthday.com",490],["heathrow.com",491],["hellsgamers.com",492],["oleantimesherald.com",[493,694]],["hiapkdownload.com",494],["modapkdown.com",494],["himilangaribaldi.com",495],["hotelcontinentalvenice.com",495],["chcflorence.it",495],["hiexpressbolognafiera.it",495],["higenova.it",495],["hiturin.it",495],["hizara.it",495],["hindawi.com",496],["tech.hindustantimes.com",497],["global.hisense.com",498],["hispantv.com",499],["minitool.com",499],["roadsurfer.com",499],["roccosiffredixxx.it",499],["host-tools.com",500],["hostelworld.com",500],["news9live.com",[500,665]],["paramorefans.com",500],["spacetourismguide.com",[500,823]],["tribuneindia.com",500],["hotklix.com",501],["housefresh.com",502],["houzz.com",503],["hth-kitchen.com",504],["huckberry.com",505],["huffpost.com",506],["humblebundle.com",507],["iclarified.com",508],["ifeng.com",509],["ifixit.com",510],["iinspirationalquotess.com",511],["orthochristian.com",511],["hessenschau.de",511],["hr.de",511],["hr-bigband.de",511],["hr-fernsehen.de",511],["hr-inforadio.de",511],["hr-rundfunkrat.de",511],["hr-sinfonieorchester.de",511],["hr-werbung.de",511],["hr1.de",511],["hr2.de",511],["hr3.de",511],["hr4.de",511],["you-fm.de",511],["pravoslavie.ru",511],["ilbianconero.com",512],["ilsitodellozoo.com",513],["ilsole24ore.com",514],["imagecolorpicker.com",515],["imagenimage.com",516],["imagenpic.com",516],["imageshimage.com",516],["imagetwist.com",516],["imbruttito.com",517],["imgur.com",518],["imobie.com",519],["indiamike.com",521],["indianexpress.com",522],["auto.economictimes.indiatimes.com",523],["indy100.com",524],["informer.com",526],["insideedition.com",527],["instagram.com",528],["instructables.com",529],["inthesetimes.com",530],["investing.com",531],["investopedia.com",532],["investors.com",533],["ipaddress.com",534],["iranwire.com",535],["irccloud.com",536],["iwaatch.com",538],["jacobin.com",539],["jagonews24.com",540],["jewishpress.com",541],["nme.com",541],["jfrog.com",542],["jiji.com",543],["connect.justia.com",544],["patents.justia.com",545],["justjaredjr.com",546],["justthenews.com",547],["jweekly.com",548],["reifenpresse.de",548],["kakaku.com",549],["kakakumag.com",550],["kakaocorp.com",551],["kark.com",[552,553]],["ktla.com",[552,553]],["ktsm.com",[552,553]],["myarklamiss.com",[552,553]],["mytwintiers.com",[552,553]],["nbc4i.com",[552,553]],["news10.com",[552,553]],["nwahomepage.com",[552,553]],["thehill.com",[552,887]],["wavy.com",[552,553]],["kathmandupost.com",554],["kbtx.com",555],["kesq.com",556],["kitchenknifeforums.com",[557,558]],["quadraphonicquad.com",558],["kiz10.com",559],["klook.com",560],["knowyourmeme.com",[561,562]],["ndtv.com",[561,608,658]],["knoxnews.com",563],["ibtimes.co.uk",563],["kohls.com",564],["samsclub.com",564],["koreaboo.com",565],["vipcars.com",565],["hasznaltauto.hu",565],["szalonauto.hu",565],["myfaith.tv",565],["koreaherald.com",566],["kyivindependent.com",567],["khronos.org",568],["l2beat.com",569],["laist.com",570],["lambdatest.com",571],["lamborghini-tractors.com",572],["lasexta.com",573],["lastmomenttuitions.com",574],["latinospost.com",575],["lawandcrime.com",[576,577]],["mediaite.com",[576,606]],["whiskeyraiders.com",576],["lepratiquedugabon.com",578],["fda.gov",578],["olx.ua",578],["levernews.com",579],["lgbtqnation.com",580],["libertynation.com",581],["lifesitenews.com",582],["liliputing.com",583],["linuxbabe.com",584],["splashlearn.com",584],["livejournal.com",586],["livemint.com",587],["lmtribune.com",588],["logicbuy.com",589],["loom.com",590],["lwlies.com",591],["ma-reduc.com",592],["macdailynews.com",593],["macromill.com",594],["mhi.com",594],["it.hisamitsu",594],["smth.jp",594],["macrumors.com",595],["maisonapart.com",596],["malaymail.com",597],["mangatoto.com",598],["marinetraffic.com",599],["marketingweek.com",600],["marketscreener.com",601],["mawdoo3.com",602],["mayoclinic.com",603],["nintendogal.com",603],["thetech.com",603],["geeksaresexy.net",603],["mdpi.com",604],["mediachomp.com",605],["medianama.com",607],["medicaldaily.com",608],["medicalxpress.com",609],["medicinenet.com",610],["mega4upload.com",610],["meganstarr.com",611],["motorscribes.com",611],["secretatlas.com",611],["avantishop.it",611],["lacomunicazione.it",611],["angelshack.co.za",611],["mensjournal.com",612],["meteomedia.com",613],["metservice.com",614],["microchip.com",616],["devblogs.microsoft.com",617],["learn.microsoft.com",618],["support.microsoft.com",619],["midhudsonnews.com",621],["milenio.com",622],["news.mingpao.com",623],["mitsubishicorp.com",624],["mitsui.com",625],["mlbtraderumors.com",626],["mljar.com",627],["modamee.com",628],["modernluxury.com",629],["media.moneyforward.com",630],["news.mongabay.com",631],["motherjones.com",[632,633]],["grist.org",[632,1302]],["motherless.com",634],["motogp.com",635],["motoringnz.com",636],["motorsport.com",637],["motorsport-total.com",638],["motto-jp.com",639],["movehub.com",640],["mowmag.com",641],["mp4upload.com",642],["mrfood.com",643],["mrskin.com",644],["msn.com",645],["msnbc.com",646],["nbcnews.com",646],["today.com",646],["multiplesclerosisnewstoday.com",647],["mundodastribos.com",648],["restaurantguru.com",648],["musicredone.com",649],["mydailyfreedom.com",650],["patriotfetch.com",650],["news.mydrivers.com",651],["mymodernmet.com",652],["nasilemaktech.com",654],["nationalpost.com",655],["nationaltoday.com",656],["nature.com",657],["neilpatel.com",659],["valuewalk.com",659],["neonnettle.com",660],["nerdwallet.com",661],["newegg.com",662],["newrepublic.com",663],["news18.com",664],["newsbytesapp.com",666],["newswars.com",667],["newsweek.com",668],["nexusmods.com",669],["nftplazas.com",670],["asia.nikkei.com",671],["nippon.com",672],["nironmagnetics.com",673],["nofilmschool.com",674],["nomadicmatt.com",[675,676]],["vdigitalservices.com",676],["newsreleases.sandia.gov",676],["nomuraholdings.com",677],["nordstrom.com",678],["notesfrompoland.com",679],["novaramedia.com",680],["novinite.com",681],["nowpatient.com",682],["ny1.com",683],["nyanpedia.com",684],["nyk.com",685],["webtsc.com",[685,966]],["census.gov",[685,1074]],["chugai-pharm.co.jp",685],["daiichi-kamotsu.co.jp",685],["nymag.com",686],["vulture.com",686],["odessa-journal.com",687],["odysee.com",688],["ofbez.com",689],["office.com",690],["oh-my-teeth.com",691],["oilprice.com",692],["okmagazine.com",693],["oneindia.com",695],["openculture.com",696],["addons.opera.com",697],["blogs.opera.com",698],["forums.opera.com",699],["orbispatches.com",700],["organicauthority.com",701],["oszkar.com",703],["otsukai.com",704],["outlookindia.com",705],["paleofuture.com",707],["palestinechronicle.com",708],["parsintl.com",709],["pbtech.com",[711,712]],["pbtech.co.nz",[712,1265]],["pcguide.com",713],["peekyou.com",714],["petside.com",715],["pexels.com",716],["phemex.com",717],["phonearena.com",718],["phonescoop.com",719],["phoronix.com",720],["photobucket.com",721],["photonics.com",722],["picsart.com",723],["picturecorrect.com",724],["salemnews.net",724],["newhumanist.org.uk",[724,1448]],["pimylifeup.com",725],["pinterest.com",726],["reddit.com",[726,764]],["pixabay.com",727],["pixsor.com",728],["vippix.com",728],["pjmedia.com",[729,730]],["townhall.com",730],["planner5d.com",731],["playbuzz.com",732],["plough.com",733],["pocketgamer.com",734],["pokernews.com",735],["politifact.com",736],["polska-ie.com",737],["thenassauguardian.com",737],["pornhub.com",738],["portableapps.com",739],["pramgnet.com",740],["pressreader.com",741],["prompthero.com",742],["proprofs.com",743],["protrumpnews.com",744],["publishersweekly.com",745],["pyrexoriginal.com",746],["qatarairways.com",747],["symbolica.io",747],["qidian.com",748],["qq.com",749],["mail.qq.com",750],["qwant.com",751],["racingtv.com",752],["racquetmag.com",753],["radaris.com",754],["radarplane.com",755],["radioseoul1650.com",756],["rap-up.com",757],["wellnessmama.com",757],["rawstory.com",[758,759,760]],["alternet.org",[758,759]],["realitytvworld.com",761],["reason.com",762],["rebelnews.com",763],["amp.reddit.com",765],["rediff.com",766],["redstate.com",767],["retroist.com",768],["reuters.com",769],["rigzone.com",770],["roadiscalling.com",771],["slothytech.com",771],["theinvisibletourist.com",771],["rockpapershotgun.com",772],["vg247.com",[772,949]],["eurogamer.net",772],["rogerebert.com",773],["rottentomatoes.com",774],["routard.com",775],["route-fifty.com",776],["rpdrlatino.com",777],["informazionefiscale.it",777],["rt.com",778],["rttnews.com",779],["rwe.com",780],["sabcnews.com",781],["san.com",783],["saturdayeveningpost.com",784],["scientificamerican.com",785],["scifiinterfaces.com",786],["pcpj.org",786],["scmp.com",787],["scribd.com",788],["scrippsnews.com",789],["sears.com",790],["semafor.com",791],["seroundtable.com",792],["sfbayca.com",793],["sfist.com",794],["sfstandard.com",795],["shameless.com",796],["shazam.com",797],["shein.com",798],["shopstyle.com",799],["siciliaoggi.com",800],["tennesseestar.com",800],["themichiganstar.com",800],["theminnesotasun.com",800],["theohiostar.com",800],["siciliapress.it",800],["tavoloeditoriradio.it",800],["motori.net",800],["similarsites.com",801],["skeptoid.com",802],["skial.com",803],["skyticket.com",804],["emb-japan.go.jp",804],["mobilenews.jp",804],["app.slack.com",805],["slate.com",806],["slaynews.com",807],["slideserve.com",808],["smashingmagazine.com",809],["smhlmao.com",810],["sncf-connect.com",811],["snopes.com",812],["sofmap.com",813],["soft32.com",814],["softpedia.com",815],["softwarekeep.com",816],["fanyi.sogou.com",817],["solarisbus.com",818],["solutions-numeriques.com",819],["songsterr.com",820],["southfloridagaynews.com",822],["thefitcareerist.com",823],["spiked-online.com",824],["spjeff.com",825],["sporcle.com",826],["sportsadda.com",827],["sportsbusinessjournal.com",828],["sportsocratic.com",829],["sportstarlive.com",830],["sputnikglobe.com",831],["sputniknewslv.com",832],["sputnik-abkhazia.ru",832],["sputnik-georgia.ru",832],["sputnik-ossetia.ru",832],["stacker.com",834],["staradvertiser.com",836],["stargazette.com",837],["startpage.com",838],["startrek.com",839],["statnews.com",840],["stickam.com",841],["stoneberry.com",842],["streamable.com",844],["streetinsider.com",845],["strevel.com",846],["sunsky-online.com",847],["surveymonkey.com",848],["swordscomic.com",849],["symbolab.com",850],["t-nation.com",851],["tabelog.com",852],["tabletmag.com",853],["tactxflashlights.com",854],["tainews.com",855],["talkingpointsmemo.com",856],["talksport.com",857],["taosect.com",858],["techbigs.com",859],["techfirstnow.com",861],["techlila.com",862],["techopedia.com",863],["techovedas.com",864],["techspot.com",865],["techweez.com",866],["tecmint.com",867],["telesatellite.com",868],["temu.com",869],["cloud.tencent.com",870],["texasmonthly.com",871],["the-fence.com",872],["thebarbedwire.com",873],["thebetterindia.com",874],["theblaze.com",875],["thebookseller.com",876],["thecourier.com",877],["thecydia.com",878],["thedarewall.com",879],["thedrum.com",880],["theepochtimes.com",881],["thefrisc.com",882],["thegamecrater.com",883],["theglobeandmail.com",884],["theguardian.com",885],["thehandbook.com",886],["thehindu.com",888],["theinertia.com",889],["theintercept.com",890],["thejakartapost.com",891],["thekitchn.com",892],["thelondoneconomic.com",893],["thelostavocado.com",894],["themoscowtimes.com",895],["thenation.com",896],["thenationalnews.com",897],["thenationalpulse.com",898],["thenest.com",899],["thenewamerican.com",900],["ny.thepaperfair.com",901],["thephuketnews.com",902],["reed.co.uk",902],["thecourier.co.uk",902],["thepostmillennial.com",903],["theprp.com",904],["thesmokinggun.com",905],["thespectator.com",906],["thestayathomechef.com",907],["metrodaily.hk",908],["eurocash.pl",908],["avtoradio.ru",[908,1390]],["chronicle.co.zw",908],["theweek.com",909],["thumbzilla.com",910],["thurrott.com",911],["time.com",913],["timeshighereducation.com",914],["timesofisrael.com",915],["timesofmalta.com",916],["tipranks.com",917],["topic.com",918],["topuniversities.com",919],["toucharcade.com",920],["tourhebdo.com",921],["tp-link.com",922],["tradeinn.com",923],["travelnostop.com",924],["trenitalia.com",925],["triblive.com",926],["tripadvisor.com",927],["truecrimedaily.com",928],["truthdig.com",929],["tunein.com",930],["turningleftforless.com",931],["businessmirror.com.ph",931],["tutsplus.com",932],["twistedvoxel.com",933],["twitchquotes.com",934],["twitter.com",935],["x.com",935],["tyrantscans.com",936],["uberhumor.com",937],["ugreen.com",938],["ukranews.com",939],["assly.dz",939],["rogor.ge",939],["koreatimes.co.kr",939],["ultimouomo.com",940],["universetoday.com",941],["unsertirol24.com",942],["upqode.com",943],["urbandictionary.com",944],["urbanoutfitters.com",945],["userbenchmark.com",946],["usmagazine.com",947],["venturebeat.com",948],["blog.vidizmo.com",950],["allnews.ge",950],["vigilantcitizen.com",951],["vistosulweb.com",952],["ilfattonisseno.it",952],["itacanotizie.it",952],["qds.it",952],["tempostretto.it",952],["voanews.com",953],["rferlo2zxgv23tct66v45s5mecftol5vod3hf4rqbipfp46fqu2q56ad.onion",953],["rferl.org",953],["vox.com",954],["wahoofitness.com",955],["walletinvestor.com",956],["wallpaperflare.com",957],["warontherocks.com",958],["washingtonmonthly.com",959],["wbal.com",961],["hofbraeu-muenchen.de",961],["visitberlin.de",961],["middleeasteye.net",961],["weather.com",962],["webmasterworld.com",[963,964]],["buyee.jp",963],["websiteoutlook.com",965],["weebly.com",967],["welivesecurity.com",968],["wellgames.com",969],["welovetrump.com",970],["westernjournal.com",971],["wnd.com",[971,982]],["whatsoniphone.com",972],["whosampled.com",973],["whtop.com",[974,975]],["news.tvbs.com.tw",974],["wikihow.com",976],["winzzguitars.com",977],["homemark.co.za",977],["wionews.com",978],["wisebread.com",980],["wltreport.com",981],["wolverine.com",983],["wondershare.com",984],["ilninth.wordpress.com",985],["world-of-satellite.com",986],["worldfinance.com",987],["worldisraelnews.com",988],["worldjournal.com",989],["worldsoccertalk.com",[990,991]],["rtve.es",990],["wowhead.com",992],["wpneon.com",993],["wsadirectory.com",994],["help.x.com",995],["x2download.com",996],["xranks.com",996],["y2meta.com",996],["yt5s.com",996],["slickdeals.net",996],["xhaccess.com",997],["xhamster.com",997],["xhamster.desi",997],["xkcdb.com",998],["disk.yandex.com",[999,1000]],["disk.yandex.ru",999],["yoreparo.com",1001],["youm7.com",1002],["yourstory.com",1003],["youtube.com",[1004,1005]],["youtube-nocookie.com",1005],["youtube4kdownloader.com",1006],["zacks.com",1007],["zerohedge.com",1008],["mail.zoho.com",1009],["zycrypto.com",1010],["boerse-global.de",1011],["donaukurier.de",1012],["foerderland.de",1013],["gebrauchtwagenberater.de",1014],["golem.de",1015],["groupon.de",1016],["groupon.fr",1016],["heise.de",1017],["icx-shop.de",1018],["jobsuche-bw.de",1019],["kicker.de",1020],["kontextwochenzeitung.de",1021],["kostenlose-urteile.de",1022],["linux-magazin.de",1023],["logistik-watchblog.de",1024],["motorsportpics.de",1025],["vansoestklassiekers.nl",1025],["phoenix.de",1026],["radiokoeln.de",1027],["seniorenportal.de",1028],["silicon.de",1029],["silicon.es",1029],["itespresso.fr",1029],["silicon.fr",1029],["channelbiz.it",1029],["itespresso.it",1029],["bit.pt",1029],["channelbiz.co.uk",1029],["spektrum.de",1030],["supermarkt-inside.de",1031],["laluce.news",1031],["valentins.de",1032],["wdr.de",1033],["weltbild.de",1034],["pestor.nl",1034],["woxikon.de",1035],["linux.do",1036],["news.arizona.edu",1037],["escoffier.edu",1038],["getty.edu",1039],["harvard.edu",1040],["thereader.mitpress.mit.edu",1041],["e360.yale.edu",1042],["linktr.ee",1043],["agenciasinc.es",1044],["repuestosportatiles.es",1045],["theolivepress.es",1046],["agendadigitale.eu",1047],["corrierecomunicazioni.it",1047],["economyup.it",1047],["gamereactor.eu",1048],["lavocedelnordest.eu",1049],["iltalehti.fi",1050],["nyt.fi",1051],["baden.fm",1052],["di.fm",1053],["last.fm",1054],["automobile-magazine.fr",1055],["challenges.fr",1056],["comment-economiser.fr",1057],["e-sante.fr",1058],["ecommercemag.fr",1059],["francearchives.gouv.fr",1060],["kartable.fr",1061],["lamanchelibre.fr",1062],["lefigaro.fr",1063],["lemondeinformatique.fr",1064],["leroymerlin.fr",1065],["loractu.fr",1066],["muslimshop.fr",1067],["ca.gov",1067],["medlineplus.gov",1067],["nwglobalvending.fr",1068],["pole-emploi.fr",1069],["giocodigitale.game",1070],["lelo.ge",1071],["stash.clash.gg",1072],["esports.gg",1073],["energy.gov",1075],["fbi.gov",1076],["magazine.medlineplus.gov",1077],["pronouns.page",1077],["ny.gov",1078],["history.state.gov",1079],["capital.gr",1080],["apartmanija.hr",1081],["sptv.hr",1082],["atlatszo.hu",1083],["hrportal.hu",1084],["ingatlanbazar.hu",1085],["pcworld.hu",1086],["brainly.co.id",1087],["kompas.id",1088],["thejournal.ie",1089],["thesun.ie",1090],["walla.co.il",1091],["wheel.co.il",1092],["money.it",1094],["bridestoday.in",1095],["businessinsider.in",1096],["fiftytwo.in",1097],["ddnews.gov.in",1098],["indiatoday.in",1100],["scroll.in",1101],["tech-camp.in",1102],["m.thewire.in",1103],["matratzen.info",1104],["nordicmag.info",1105],["realtime-chart.info",1106],["sdvoice.info",1107],["apkmody.io",1108],["cryptorank.io",1109],["hackster.io",1110],["kriptomat.io",1111],["tabler.io",1112],["virgool.io",1113],["alkawthartv.ir",1114],["betway.co.za",1114],["alvolante.it",1115],["amazon.it",1116],["anothersound.it",1117],["maghrebemergent.net",1117],["assologico.it",1118],["astrooroscopo.it",1119],["automobile.it",1120],["automoto.it",1121],["moto.it",1121],["avvenire.it",1122],["biografieonline.it",1123],["meglio.it",1123],["blitzquotidiano.it",1124],["ladyblitz.it",1124],["arch.bz.it",1125],["canavesenews.it",1126],["torinonews24.it",1126],["centrometeoitaliano.it",1127],["comingsoon.it",1128],["comuniciclabili.it",1129],["wikibit.it",1129],["cronacheancona.it",1130],["dailybest.it",1131],["dirittierisposte.it",1132],["donewifi.it",1133],["engage.it",1134],["enzopennetta.it",1135],["eprice.it",1136],["euractiv.it",1137],["everyeye.it",1138],["focusjunior.it",1139],["formulapassion.it",1140],["funweek.it",1141],["wtc.genova.it",1142],["gigapc.it",1143],["grandangoloagrigento.it",1144],["greenstyle.it",1145],["japanpost.jp",1145],["ice.it",1146],["ilfarmacistaonline.it",1147],["ilfattoalimentare.it",1148],["iltempo.it",1149],["ilvibonese.it",1150],["infobuildenergia.it",1151],["internazionale.it",1152],["katorishintoryu.it",1153],["lagazzettadelmezzogiorno.it",1154],["laleggepertutti.it",1155],["lantidiplomatico.it",[1156,1157]],["lastampa.it",1158],["leggioggi.it",1159],["liberogioco.it",1160],["linkiesta.it",1161],["mobimart.it",1162],["monclick.it",1163],["multiplayer.it",1164],["my-personaltrainer.it",1165],["orvieto24.it",1167],["puntosicuro.it",1168],["qualescegliere.it",1169],["radioitaliaannisessanta.it",1170],["radioradio.it",1171],["ricoh.it",1172],["sky.it",1173],["spaziogames.it",1174],["stabiachannel.it",1175],["stol.it",1176],["storicang.it",1177],["superguidatv.it",1178],["tempi.it",1179],["tp24.it",1180],["unimore.it",1181],["vitatrentina.it",1182],["wuerth.it",1183],["ytong.it",1184],["zerosette.it",1185],["zoomsud.it",1186],["bedstyle.jp",1187],["dandy-house.co.jp",1188],["diners.co.jp",1189],["sumitclub.jp",1189],["jingukan.co.jp",1190],["kyodo.co.jp",1191],["biglobe.ne.jp",1191],["280blocker.net",1191],["ntv.co.jp",1192],["tv-asahi.co.jp",1193],["carview.yahoo.co.jp",1194],["news.yahoo.co.jp",1195],["otekomachi.yomiuri.co.jp",1196],["comnico.jp",1197],["news.denfaminicogamer.jp",1198],["jstage.jst.go.jp",1199],["hotpepper.jp",1200],["iphone-mania.jp",1201],["kotobank.jp",1202],["mastory.jp",1203],["mbs.jp",1204],["narita-transit-program.jp",1205],["plus.nhk.jp",1206],["nicovideo.jp",1207],["sp.nicovideo.jp",1208],["suumo.jp",1209],["toptoon.jp",1210],["ufret.jp",1211],["auction.co.kr",1212],["kimcartoon.li",1213],["34travel.me",1214],["gayflix.me",1215],["russian-sex.me",1216],["landian.vip",1216],["xpics.me",1217],["thscore.mobi",1218],["excelsior.com.mx",1219],["thestar.com.my",1220],["alarabiya.net",1221],["ancient-origins.net",1222],["bravotube.net",1223],["telesurtv.net",1223],["cepr.net",1224],["codecanyon.net",1225],["copytrans.net",1226],["blog.csdn.net",1227],["ec-store.net",1228],["edugeek.net",1229],["emails-checker.net",1230],["finanzfrage.net",1231],["gutefrage.net",1231],["ghacks.net",1232],["independentaustralia.net",1233],["informationisbeautiful.net",1234],["inquirer.net",1235],["jam-news.net",1236],["kitguru.net",1237],["marijuanamoment.net",1238],["mathe24.net",1239],["mcsweeneys.net",1240],["meijumi.net",1241],["myanimelist.net",1242],["nativecamp.net",1243],["ncrypted.net",1244],["neowin.net",1245],["organicfacts.net",1247],["oschina.net",1248],["researchgate.net",1249],["slideshare.net",1250],["sony.net",1251],["tweakers.net",1252],["urlgalleries.net",1253],["wowway.net",1254],["metronieuws.nl",1257],["welingelichtekringen.nl",1258],["lookbook.nu",1259],["1news.co.nz",1260],["niwa.co.nz",1262],["noelleeming.co.nz",1263],["stuff.co.nz",1266],["thepost.co.nz",1267],["thepress.co.nz",[1267,1268]],["waikatotimes.co.nz",1267],["thespinoff.co.nz",1269],["turners.co.nz",1270],["consumer.org.nz",[1271,1272]],["themarkup.org",[1272,1361]],["lindipendente.online",1273],["48hills.org",1274],["99percentinvisible.org",1275],["aarp.org",1276],["acs.org",1277],["agsiw.org",1278],["americanaffairsjournal.org",1279],["annualreviews.org",1280],["archive.org",1281],["archlinux.org",1282],["artscanvas.org",1283],["arxiv.org",1284],["audubon.org",1285],["bitdegree.org",1286],["blogcritics.org",1287],["c-span.org",1288],["calmatters.org",1289],["childrenshealthdefense.org",1290],["citizensforethics.org",1291],["city-journal.org",1292],["civilbeat.org",1293],["commondreams.org",1294],["ctrlq.org",1295],["dcreport.org",1296],["democracynow.org",1297],["eff.org",1298],["emojipedia.org",1299],["factcheck.org",1300],["hrw.org",1303],["icij.org",1304],["iihs.org",1305],["imcdb.org",1306],["insideclimatenews.org",1307],["investigativepost.org",1308],["isglobal.org",1309],["jns.org",1310],["daily.jstor.org",1311],["jurist.org",1312],["kcur.org",1313],["khanacademy.org",1314],["knowablemagazine.org",1315],["laphamsquarterly.org",1317],["lareviewofbooks.org",1318],["leawo.org",1319],["marketplace.org",1320],["metager.org",1321],["miraheze.org",1322],["mozilla.org",1323],["mprnews.org",1324],["nationofchange.org",1325],["netzpolitik.org",1326],["northcountrypublicradio.org",1327],["octoprint.org",1328],["onegreenplanet.org",1329],["opb.org",1330],["opensecrets.org",1331],["ourworldindata.org",1332],["pbs.org",1333],["peoplesworld.org",1334],["philosophynow.org",1335],["phys.org",1336],["pirg.org",1337],["poynter.org",1338],["privacyguides.org",1339],["privacywall.org",1340],["progressive.org",1341],["propublica.org",1342],["prospect.org",1343],["publicdomainreview.org",1344],["railstutorial.org",1345],["rightwingwatch.org",1346],["rsc.org",1347],["science.org",1348],["sfpublicpress.org",1349],["slashdot.org",1350],["sleepfoundation.org",1351],["slideme.org",1352],["spectator.org",1353],["spotlightpa.org",1354],["tasvideos.org",1355],["texastribune.org",1356],["the74million.org",1357],["thebulletin.org",1358],["thefire.org",1359],["themarginalian.org",1360],["themarshallproject.org",1362],["themedialine.org",1363],["thenewhumanitarian.org",1364],["truthout.org",1365],["undark.org",1366],["wbez.org",1367],["wedistribute.org",1369],["wgbh.org",1370],["whowhatwhy.org",1371],["whyy.org",1372],["worldhistory.org",1374],["worthrises.org",1375],["wqxr.org",1376],["yalereview.org",1377],["tribune.com.pk",1378],["gda.pl",1379],["gosc.pl",1380],["mpolska24.pl",1381],["dnoticias.pt",1382],["maisfutebol.iol.pt",1383],["sapo.pt",1384],["ebin.pub",1385],["realitycheck.radio",1386],["glas-javnosti.rs",1387],["5-tv.ru",1388],["autowp.ru",1389],["bancaintesa.ru",1391],["culture.ru",1392],["forbes.ru",1393],["kommersant.ru",1394],["kp.ru",1395],["ria.ru",1396],["vestifinance.ru",1397],["any.run",1398],["thenational.scot",1399],["meet.jit.si",1400],["latestgadgets.tech",1401],["dev.to",1402],["torrentgalaxy.to",1403],["kimcilonly.top",1404],["haberiniz.com.tr",1405],["scandi.travel",1406],["4gtv.tv",1407],["adessoin.tv",1408],["atletica.tv",1409],["i24news.tv",1410],["islamchannel.tv",1411],["lbry.tv",1412],["mywheels.tv",1413],["teamfortress.tv",1414],["twitch.tv",1415],["vloungebeach.tv",1416],["w2g.tv",1417],["bcc.com.tw",1418],["pravda.com.ua",1420],["itc.ua",1421],["qmul.ac.uk",1422],["dailymail.co.uk",1423],["emergingrisks.co.uk",1424],["gq-magazine.co.uk",1425],["independent.co.uk",1426],["inews.co.uk",1427],["ispreview.co.uk",1428],["jewishnews.co.uk",1429],["jobisjob.co.uk",1430],["londonnewsonline.co.uk",1431],["metro.co.uk",[1432,1433]],["newsnow.co.uk",1434],["omgubuntu.co.uk",1435],["papermtn.co.uk",1436],["pcpro.co.uk",1437],["processengineering.co.uk",1438],["revisionworld.co.uk",1439],["salisburyjournal.co.uk",1440],["screamingfrog.co.uk",1441],["spectator.co.uk",1442],["thecritic.co.uk",1443],["thetablet.co.uk",1444],["theweek.co.uk",1445],["ncsc.gov.uk",1446],["humanists.uk",1447],["spring.org.uk",1449],["jotform.us",1450],["nautil.us",1451],["guardaserie.watch",1452],["reinsurancene.ws",1453],["nsfw.xxx",1454],["blaauwbergbeachhotel.co.za",1455],["businesslive.co.za",[1456,1457]],["timeslive.co.za",[1456,1461]],["businesstech.co.za",1458],["mybroadband.co.za",1458],["dailymaverick.co.za",1459],["moneyweb.co.za",1460],["topauto.co.za",1462],["webuycars.co.za",1463]]);

const entitiesMap = new Map([["google",0],["sadisflix",1]]);

const exceptionsMap = new Map(undefined);

self.specificImports = self.specificImports || [];
self.specificImports.push({ argsList, hostnamesMap, entitiesMap, exceptionsMap });

/******************************************************************************/

})();

/******************************************************************************/
