/*******************************************************************************

    uBlock Origin Lite - a comprehensive, MV3-compliant content blocker
    Copyright (C) 2019-present Raymond Hill

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see {http://www.gnu.org/licenses/}.

    Home: https://github.com/gorhill/uBlock
*/

/* jshint esversion:11 */

'use strict';

// ruleset: annoyances-overlays

/******************************************************************************/

// Important!
// Isolate from global scope
(function uBOL_cssSpecificImports() {

/******************************************************************************/

const argsList = [".is-blocked",".ico.close,\n[href=\"/user/profile/premium-membership\"]",".GrowthUnauthPinImage > a > div[class^=\"Jea\"]:has(button[class^=\"noButtonStyles \"]),\n.Hsu.iyn.zI7:nth-of-type(2) > div > .FullPageModal__scroller,\n[data-test-giftwrap],\ndiv[class=\"Closeup__wrapper\"] > div > div[style^=\"cursor: default\"],\ndiv[class=\"GrowthUnauthPinImage__imageDim\"],\ndiv[data-test-id=\"giftWrap\"]","#js-abContainterMain",".TopSection-sc-z3c0qx-11","#newsletter-modal",".modal-backdrop",".hubspot-widget-newsletter",".alert-danger.alert","main.py-4 > p",".cs-entry__subscribe",".cs-site-subscribe",".GetRewardsBlock_GetRewardsBlock__3tHaD",".yui-popup-container-node",".esub-section-wrap","#tie-newsletter-3",".t-nl-box-1",".adblock-box",".gh-portal-triggerbtn-iframe",".notanewsletter,\n.p-optin","#mc_embed_signup",".newsletterbox",".newsletter-subscription",".widget-newsletter",".sticky_top",".newsletter",".ck-modal--newsletter-modal-wrapper,\ndiv[class^=\"NewsletterBanner_\"]",".newsletter-section-wrapper",".subscription-note-wide",".nl-footer,\n.nl-sidebar",".reveal-modal",".reveal-modal-bg","#newsletter",".bg-refurbed-blue",".box-emarsys",".footer__subscription","#thegapnewsletter",".ml-manual-widget-container",".vodl-widget-newsletter",".outpost-pub-container","[data-component=\"Newsletter\"]","#backdrop-container,\n.EmailSignupModal__portal",".email-overlay",".focus-guest-alert",".pum",".ba-widget-namespace",".mail_signup",".modal","#NewsletterSignUpSideHero",".subscription-modal",".bg-indigo-700",".sign-up-widget-placeholder","#adBlockMessage",".ml-form-embedContainer",".c-notification-bar",".subscribe-box",".signup_form_container","#middleSubscribe,\n.home_fixed-subscribe__JNPlW",".pm-todays-newsletter-block","._1iiWS",".subscribe_drive-subscribe-content__wrapper__H5Hu0,\n.subscribe_drive-subscribe-content__wrapper__eL0k9",".max-w-7xl","#omnisend-dynamic-container",".footerSubscribeMe",".curated-content-block__newsletter","#pop-convert-app",".otp-overlay",".promo-banner",".subscribe-footer","#cboxOverlay",".subscribe",".bottom-0.fixed","a[href*=\"/newsletter\"]","#subscribe-main","#mc-embedded-subscribe-form",".shopify-section-group-popup-group","._13cnlxs2af","#hs-web-interactives-top-anchor",".email-popup-container",".newsletterForm-1Gx",".footer-block__newsletter",".subscribe-border-bottom",".ml-subscribe-form",".gform_widget",".signup","#newsletterForm",".newsletter_container",".ow-signup",".widget_infusionsoft",".ff-63da3514de520bd60dc34604","#visitor-notice",".epkJK",".newsletter-form-wrapper",".block-wrap-mailing,\n.subscribe-wrap","#block-17",".qe-news--inline",".emthemesModez-footer-topColumns-wrapper",".offYourDial",".l-footer-join","#newsletter-form","#subForm,\n.cm-form-container","#_lpSurveyPopover",".newsletter-container",".footer-top",".popup_overlay",".newsletter-style-4,\n.spy-newsletter",".enews-quick","#custom_html-3",".vc_single_image-wrapper,\n.vc_wp_text",".js-footer-email-capture","#catalogueDrawer,\n.drawerTitleTextWrapper","#interstitial",".border-years,\n.sign-up-form-latest,\n.signup-box-container",".slide-in-from-bottom","div[class*=\"StyledFormContainer\"]",".sidebar-sticky--briefing",".panel--subscribe","#emailPopUpModal",".newsletter-light-registration",".Newsletter",".emailReengagement",".b-sideSub",".subscribe-callout",".InlineSubscribe_inlineSubscribe__Yc5sT",".subscribe-modal",".SiteFooter_signup",".stay-up-to-date-container",".warning",".js-blocknwlsub","#NEWSLETTER_OCHTEND",".optinboxWrapper","#block-nieuwsbrief",".footer-newsletter",".block-newsletter",".cj-root","box-newsletters",".article-detail-nieuwsbrief",".floorad,\n.pane-bulweb-general-bulletinguide-block,\n.pane-bulweb-general-registration-block",".newsletter-form",".newspopup_up_bg",".subscription","#hs-web-interactives-bottom-anchor",".premium-popup,\n.widget-dynamic","div.aslot","#sidebar-mailer",".top-banner",".footer-newsletter-wrapper",".modal-overlay",".gh-footer-signup",".kg-signup-card-content","._subscribeDialog_1h9fv_1,\n.intro-popup,\ndiv[class^=\"_background_1h9fv_\"]",".followit--follow-form-container",".c-newslatter-box",".revue-embed",".catchment-box",".form-email-container",".newsletter-button",".tdi_143",".ad-aside,\n.im-cta",".sgpb-popup-overlay",".single-content-newsletter",".wpforms-widget",".mc-optin",".newsletter_form_amp_inner",".newsV2-assinar",".form-subscribe,\n.navigation-menu__form-create",".mod-newsletter",".tec--thebrief,\n.tec--thebrief__bg,\n.tec--widget-thebrief",".jupiter-news-notice",".c-newsletter",".btn-newsletter,\n.sup-newsletter",".elementor-element-c70499c","#exit-modal-signup, #overlay-modal",".subscribeBox",".subscribeNews",".customer-gift",".footer-customer-gift,\n.gift-bag,\n.git-bag-pop",".nua-newsletter",".gfm-subscriptions-in-content",".fancybox-container",".product-details-page__ad-unit","[class^=\"newsLetterCont\"]",".block__newsletter-cta",".footer-social-share-icon__container-1","#emailCheckFooter",".accountCTA-XwarX",".footer-cta",".pre-header-newsletter",".newsletter-signup",".current.blocker,\n.newsletter-cta-large-wrapper",".share-mailing",".bm-footer__wrapper__subscribeButton","[id^=\"smsbump-form-\"]",".react-responsive-modal-root","[data-aqa=\"widget-breaking-banner\"]",".vip-enrollment-banner",".foo-newsletter",".pp-btn-container","#insiderEmailAlert","#footerSubcribeForm",".home-subscribe",".main-footer-newsletter","#website_ticker","#newsletterSignUp","#headerAd,\n.c-inlineSignup,\n.c-textSignup",".c-newsletterSignup",".ad-container","#notification,\n.news-letter-form","#shopify-section-newsletter-popup","#hh-newsletter",".browsepopup",".adthrive-ad,\n.send-footer,\n.slbElement","#modalSignup",".sharing","#newsletter-hub-promo-box,\n#newsletters-subscription-box-root,\n.brz_msg_wall_body,\nbody > div[style]:has(.brz_msg_wall_body)",".simpleltkmodal-container",".simpleltkmodal-overlay",".__wrap__2golE.nl-signup > div > .inner,\n.single-article-text > blockquote > p",".hero-sidebar,\n.under-article-widget-nl",".wcb-md-modal,\n.wcb-md-overlay",".paragraphs-item-call-to-action","#ndms-newsletter_widget",".dialog-type-lightbox",".reveal-overlay",".promo-designer-modal",".c-newsletterBlock,\n.c-newslettersticky",".subscribe-bar",".popUp-overlay",".StyledNewsletterSection-sc-67bd630a-0,\n.most-popular-newsletter-container,\n.sc-pahfbg-0.beUHeC.print\\:hidden",".newsletter-popup",".et_newsletter_area",".enewsSubscribeModal",".ReactModal__Overlay","#savingSignupWidget",".connect-us",".plp__newsLetterSignUp__3GXDU","#shopify-section-popups",".footer-section__newsletter_signup",".needsclick[aria-label][style]",".elementor-popup-modal",".brave_popup",".ays-pb-modals,\n.lead-magnet,\n.side-newsletter",".messaging-zone","._form",".sidebar-above-footer",".spu-bg",".spu-box",".b-footer_email",".email-popup__overlay",".stay-connected",".ju_Con,\n.ju_overlay",".ara-newsletter","#nlt_signup_botton","#popup","#dh-donation-prompts-5",".in-article-sub-form",".widget_sib_subscribe_form",".NewsletterPopup",".snm-newsletter-subscription","#adnz_maxiboard_1","[class^=\"style__NewsletterPopupComponent\"]","#newsletter-validate-detail","#newsletter-flyin,\n.--is-open,\n.infobox,\n.newsletter-modal__container,\n.si-teaser--newsletter-subscription",".sib-form-container",".newsletter-modal","section[class^=\"NewsletterBox_\"]",".watson-snippet__newsletter",".popup",".mt-3","#mc_register_iframe,\n.rotulo-newsletter","#suscripcion,\n.mail_box",".nav-tools",".outpost-cta",".NLFormInsertFromCMS",".dZRtZo,\n.drEkmg","[class=\"md:mt-10\"]","#email-modal-container,\n#email-modal-overlay",".flex-col.flex.border-t.p-10.gap-4,\ndiv > .p-10.gap-4","#wf-form-Newsletter-Signup","#coco-newsletter-sidebar,\n#coco-subscriber-newsletter",".suscribe",".sib-form",".subscribe-form",".GridItem.hEYXVm.sc-39129d7e-1,\n.left-0.top-0.fixed,\n.max-w-prose",".asDecapitated",".blog-subscribe-banner",".fitt-subscribe-pop-up-window,\n.subscribe-pop-up-bar",".kg-signup-card",".TheFooterSignUp",".widget-ad-container",".seva-form",".section-sign-up","#lead_newsletter","[data-ga-view-prompt=\"psyche_cta_pop_up_subscribe\"]","#ethad","#savetherecipe",".sidebar-newsletter",".form-simple",".md-colorbox,\n.subscribebox",".modal-container",".newsletterBox",".newsletterModal",".subscribe-panel",".footer-Newsletter-input,\n.newsletter-subscription_newsletterform__ulg8Q","#notice-root","#hs_cos_wrapper_blog_post_simple_sticky_cta,\n.blog-hustle-form-config-wrapper,\n.hs-cta-wrapper",".app-subscribe",".gh-cta",".mailchimp-subscribe",".newsletter_sidebar_block",".browsemore",".blocked-notice-small","#sg_email",".newsletter-main-old,\n.newsletter-mini",".ui-widget-overlay",".ui-dialog[aria-describedby=\"modal-msg\"]:has(a[href$=\"/console/abo.pl\"][style^=\"text-decoration:underline\"])",".EsolEmailSubscribeWidget",".section-email-sub","#text-8",".adace-popup",".banner",".article__subscribe,\n.subscribe--sidebar",".cb-box","#BannerNewsletter_Container","#smile-ui-container",".wpcf7",".Form-wrapper",".TwoColumnContainer3070",".article-subscription-form,\n.exit-intent-popup",".custom-html-widget","#newsletter_subscribe",".article-newsletter",".subscribe-button",".email-box",".hello-bar-container",".bio-lp-newsletter,\n.widget--subscribe",".modal--content",".aside-newsletter-signup",".Shfq",".block-subscribe","#newsLetterSignup",".skl-widget",".privacy-policy-banner",".subscribe-post",".block-email",".block-inline-email",".block-save-recipe",".tasty-recipes-entry-footer",".adBlocked, .banner","#text-46",".recirculationCTA",".wpforms-container",".signup-global",".in-content-house,\n.in-house","._footer_newsletter_1ecdc_1","#adm-signupbar,\n#ftr_subscribe-join,\n#hdr_sign-up",".signup-block","#global-footer-main_contact","#featured-news",".ap-signup-inline,\n.newsletter__signup-form",".magazine__banner,\n.newsletter-overlay","#widget-newsletter",".widget--newsletter","#signup-popup",".show-newsletter-container",".newsletterwrapper",".single-newsletter",".savicom-subscribe-widget",".tasty-recipes-footer-content",".SubscribeBanner",".SubscribeBannerTopicPage","#FooterSignUp",".hbspt-form","#block-2","#newsletter-popup-container, #newsletter-popup-overlay",".bannerleads",".site-header__subscribe","#newuser_promotion_ad",".boxemail",".uabb-modal-parent-wrapper",".black-box",".subscribe-btn",".email-signup",".alg_subscribe_cont,\n.formnews",".bg-newsletter",".light-box-shadow",".seva-overlay","#GeneralSaleBanner","#mailing-list","._9u2nava_713",".new-release-newsletter-promo-tile",".promo",".mntl-dialog--campaign",".r-klde5a.r-1awozwy.css-175oi2r",".block-listraksubscribe-block,\n.newsletter-incontent,\n.newsletters-signup-wrapper",".featureNewsletter","#exitpopup-modal",".sidebar-form",".subscribe-s","form",".wpsta-ar-newsletter-1st-page-view",".fs-daily","#cm-embed_signup","#d-popups",".wd1_nlpopup,\n.wd1_nlpopup_overlay","#slidebox","#homeSignUp",".anw-subscribe","#piano-modal-backdrop,\n.sc-8051a6e6-3",".tp-container-inner",".inset-0.fixed",".js-section__promo-pop",".terrabanner",".elementor-element-36dbceb","[class] > [class] > form[class]",".swal-overlay",".widget-ahsubscribe",".ck_form_container",".subcription-block","#popupbackground",".article-subscribe-box","#form_newsletter",".c-pwa-email-signup--footer",".subscribe-div",".fancybox-overlay",".notify",".mc_embed_signup","#gb-newsletter-modal-reg","#cb-announement-bar",".footer-block--newsletter",".tingle-modal",".channel-subscribe",".simplemodal-container,\n.simplemodal-overlay",".hd-promo","#jsNewsletterContainer",".ar-newsletter-tc__sheet","#nlForm,\n.dml-wrapper",".c-toaster","[class^=\"_newsletter_\"]",".techforge-subscribe-widget","#ouibounce-modal",".theme-newsletter-signup",".aom-subscribe",".c-newsletter_wrap","signup-modal-prompt-fullscreen",".newsl-suscribe__content,\n.nwl,\n.publi",".cl-dialog","#sign-up",".ao-newsletter","#block-panels-mini-clone-of-sharer,\n.pane-mailchimp-signup-signup-to-our-emails",".hero-signup-wrap","#block-13,\n#block-14,\n#block-16","#block-15",".SubtoNew_box",".cls-inserted",".wprm-call-to-action",".footersubscribe","#signup-article-button",".wp-block-cover[style=\"padding-top:0;padding-bottom:0\"]",".atavist-mailchimp","#homepage-newsletter-component,\n.js-email-ask-form,\n.js-subscription-ask-modal,\n.modal-sm-fullscreen",".footer-subscribe",".newsletter-sign-up--station",".foot-newsletter",".white-bkg","#NewsletterModal,\n.cta-small","#omnisend-forms-container","#mail-list-button","#footer-aulart-newsletter,\n.elementor-widget-wrap .elementor-inner-section.elementor-section-boxed,\n.sticky_banner_blog","#newsletter-box",".modals-wrapper",".bloc-netitmail",".modal, .modal-backdrop",".news-letter","#uf-cta-beside",".footer-top-follow-us",".ms-footer_top",".alertbar","#newsletter-signup",".newsletter-section",".StoryPageCTA_story-page-cta__mfCH7,\n.right-rail-cta",".block-area-before-wprm-recipe,\n.fca_eoi_featherlight","#newsletter-content-wrap",".tm-desk-reg-box-wrapper,\n.tm-join-box",".infopub,\n[id^=\"adReplacement\"]",".overflow-hidden.bg-primary-orange",".overscroll-contain","#webform-submission-e-mail-popup-node-2111-form-ajax,\n.block-sign-up-for-our-email-newsletter","#shopify-section-popup",".section--newsletter",".experience-card-dialog-wrap",".banner-text","#sub-footer",".box-informed,\n.ft--stay-informed",".dimmer,\n.oneTapLoginModal","#section-newsletter-blk",".fd-modal",".for-email",".style--newsletter-signup-bottom--1Spc175x",".subscribeToOurNewsletter","[id*=\"cdm-zone\"]",".ui-dialog","#reg5-form-fon","#zephr-message,\n.zephr-overlay",".subscription-widget,\nps-subscription-module",".mw1200px.rel","#emailSignupRoot",".becker_doubleclick","#page_triggers",".dark-gradient-bg","#fancybox-overlay","#fancybox-wrap,\n#top-alert","#subscribe",".bic-newsletter",".newsletter-header",".simple-row-signup",".email-alert-signup",".footer__mailing__right",".OPF__embedded-form",".call-to-action-container",".widget-postup-standalone-form",".beautify__newsletter",".css-mha66v-Box-Flex-StyledNewsletterLayout",".adblock",".widget-popup",".newsletter_PK8HvolxQy,\n[class^=\"newsletter_\"]",".votd-subscribe-form",".email-capture-container",".post-article-signup",".cta-container",".newsletterSignupGrid",".cta--subscription,\n.ctas-container",".blackOverlay",".bt-block__inner",".subscribe-win",".flyout_newsletter_center",".wp-block-ldm-blocks-call-to-action",".adace-slideup-slot-wrap",".adblock-tips",".bodysection-subscribebar",".section-subscribe",".elementor-element-2db20597",".dXWTEu,\n.gyHIup",".pp-modal-wrap","#facebox,\n#facebox_overlay,\n.bottom-slideIn","#custom_html-7",".cta","#enhancedtextwidget-2","#block-cdwregistertimedmodal,\n.hdr-top,\n.insider-register-one-form-wrapper,\n.paragraph--type--linked-image,\n.views-field-field-cta-slide-image",".cp-popup-container",".persistentcomponent",".CampaignFullscreen__bravoLayer",".acumba-form",".c-signup",".inline-newsletter-top",".newsletter-module","#tnp-modal",".newsletterwidgetminimal-6",".w21_middle-bar__newsletter",".subs-block",".journey-template--cm_footer,\n.persistent-bottom",".journey-unit__container",".subscribe-form-home",".b-newsletters",".blur.signup-gate",".overlay",".subscribe-ad__corner",".gta-link-track",".border-neutral-200.border-b.bg-white,\n.exit-modal",".subscription-block",".m-generic-cta--email-signup",".bl-f-wrap",".subscription-section","#app-overlay","div[class^=\"newsletter\"]",".newsletter-box",".join-email-list-wrapper",".in.fade",".tve-leads-slide-i,\n.widget_mailchimpsf_widget","#simplemodal-container, #simplemodal-overlay",".form-interruptor","#simplemodal-overlay",".subscribe_div","#block-4,\n#fluentform_6,\n.five.row",".CoverDark,\n.PopUpNewsletter,\ndiv.overlay, .bottom-banner",".bottom-banner",".bat-theme-widget-constant-contact",".article-newsletter-signup-cta",".newsletter-row",".subscribtion-form",".subscribe_widget","#fdn-sm-NewsletterSignupWidgetSlideIn","#web-subscribe2",".guide-newsletter","#piano-single-before-ads-jobs",".our-newsletters",".footer-info-col--newsletter",".block-email-subscribe","#modal-root",".noblock-modal",".signup-wrapper",".popup-modal",".homepage-newsletter-module",".inline-newsletter-form",".popup-wrapper",".inline-newsletter-signup","#newsletter-signup-popup,\n.nw-ns-main",".VrW.j1J,\n.card-180737953,\n.lqj,\ndiv.lqj:last-child","#newsletter-optin3,\n.end-wrap,\n.footer-optin",".in-post-recipe-save,\n.newsletter2",".bfp-newsletter-signup",".g1-popup-newsletter",".et_bloom_popup",".subscribe-enter-done","#pn-newsletter-signup",".woocommerce-store-notice",".lg\\:top-\\[125px\\]",".candela-block--subscribe",".newsletter-sign-up-wrapper",".bee-page-container,\n.exit-intent-acm","#black_mask",".newsletter-for-scroll,\n.td-pb-span4.tdi_127,\n.tdi_117,\n.tdi_134.vc_column",".email-capture",".dialog,\ncars-newsletter-signup",".modal-wrap",".cta46_component",".footer-head","#rsidebar-subscribe","#block-newsletterfooterblock,\n.block-newsletter-block",".EventPromoInline,\n.Newsletter-container",".site-newsletter-menu","#mc_embed_shell",".pum-overlay[data-popmake*=\"newsletter-signup-popup\"]",".pum-overlay",".single-footer-subscribe",".subscription__content","#text-4","#text-59","#newsletter_widget",".signUpWrapper","[data-cy*=\"Newsletter\"]","#modalAnchor","#eme-global-head",".newsletterSignup",".footer-email-signup",".elementor-element-648759a3",".connext-modal-backdrop,\n.wripper_block",".modal-scrollable",".mailpoet_form","#block-41",".preloaded_lightbox",".fb_lightbox-overlay",".article-body-newsletter","section[class^=\"inline-newsletter\"]",".mfp-bg",".mfp-wrap","#newsletter-popup",".ebookbox","#text-2",".kadence-conversion-wrap",".SignupModule,\n.media-width-half",".signup-module","#restrict-access-model","#right-widget-d-newsletter_form_widget-17,\n#right-widget-top-newsletter_form_widget-14",".td-all-devices",".article-subscription",".newsletter-subscription-promo,\n.newsletter-subscription-small",".newsletterSignUpBox","#custom_html-2","#nlsubscribe",".footer-sub",".conversion-module",".newsletter-block",".adblock_detector",".case_newsletter",".signup1",".pane-block-96","#sliding-popup.sliding-popup-bottom",".cdj-vip","#subscriptionform","#shopify-section-promo-pop",".loyalty-offer-overlay",".black.bg-orange-1-500.bottom-0.fixed,\n.mt6.ph2.bg-blue4",".NewsletterSignup",".gklQZJ","#sib-form",".CNBCFooter-info,\n.WildcardEmbed-wrapper",".c-newsletterInlineUnit,\n.c-newsletterSubscribeHighlight",".formkit-form",".subscription-container",".newsletter_deals",".bx-impress",".factbox_inline-small",".subscribe__fixed",".NewsletterWrapper-JRxKg",".ticker-view",".et_pb_widget",".adsbygoogle",".signup-box",".ct-newsletter-subscribe-container",".dialog-lightbox-widget",".sidebar-subscribe","[class^=\"article-sign-up-\"]",".Mainads,\n.Newslettershare",".aside-little_newsletter",".newsletter-subscription-form_k9oQq","#block-9",".inpost-save","#tncms-block-1390809",".has-light-gray-background-color","#sticky-footer-cta","#ps__widget_container",".newsletter-aside",".wixui-column-strip__column",".Newsletter__NewsletterContainer-sc-1ysnx0y-0,\n.sc-2ff98d60-0",".nw-subs",".mailpoet_form_popup_overlay",".newsletter-form-on-post-page",".box--teal-accent",".lcw-modal__parent",".subscribePromo",".fd-form-popup",".site-top-footer-wrap",".slick-on-page",".subscribebar",".wp-block-group__inner-container","#newsletter_signup",".jan-box-inner",".e1iisoe612","[height=\"154\"],\n[href=\"https://link.cosmosmagazine.com/JP4n\"]","#email-popup-title","#newsletter-entry-footer,\n.subscribe-tab","body > .force-to-login-popup",".wrap__newsletter",".subscribe-area","#email-subscribers",".module-newsletter",".upper",".crain-newsletter-v2-wrapper",".block-about__right,\n.block-newsletter-cta-sidebar",".block-newsletter-cta",".cb-box__wrapper-center_modal",".sgpb-popup-dialog-main-div-wrapper",".js-signup-visibility",".wp-block-cata-newsletter","#email,\n.gb-container-6d731b3a",".ad-imu-sticky","#popinCK,\n.ck-newsletter",".subscribe_cta",".section-email-signup","#emailFooter",".herald-ad,\n.herald-txt-module",".footer-card-email",".tve-leads-shortcode","#cp-newsletter-block","#mo_optin_widgets-2","#cs-newsletter","#expanded-message,\n#ezve-inbody-newsletter-widget,\n.newsletter-email-signup",".marketo-newsletter-form",".band--highlight","#divSideNews,\n.c-box-news",".z-newsletter","#subscribe_black_box",".fancybox-is-open,\n.sidebar-section--subscribe","#curiosmosnewsletter_widget-2",".boxzilla-container",".boxzilla-overlay",".blog-newsletter__title",".news-control",".mpc-callout","#newsletters","#popup_box","#dc-home-tab-bar","#lander-exclude-ads,\nfooter",".dfx-inHouseGuideBannerComponent,\n.dfx-inHouseNewsletterBanner","[class^=\"IframeNewsletter_iframe-\"],\n[class^=\"NewsletterModule_newsletter_\"]",".dk-action-embed",".EmailSignup","#dth-borderless-modal","#nativo_rightrail1,\n.b-modal.b-dialog",".dmn-newsletter-overlay,\n.dmnc_features-cta-newsletter-cta-newsletter-module__eQOmx,\n.dmnc_features-cta-social-cta-social-module__YgCAW",".newsletter-sign-up",".block-channel_subscription,\n.block-registration_prompt,\n.js-mktoFormBlock",".fit-omv2-modal","#ctabar",".ju_iframe",".magazine-cta",".widget__newsletter,\n.widget_nypost_decider_social_connect_widget",".page_footer-container_newsletter_sticky","astro-island[component-url*=\"/_astro/Newsletter.\"]","#block-8",".abp-banner",".ContentGate_wrapper__tNtjt","div[class*=\"NewsletterSign\"]",".defia-right-rail-newsletter",".color2.boxFocus,\n.ctct-embed-signup","journey-modal-newsletter",".recieve-recipe","#mh-ext-signupemail-modal","#footer-email-sign-up-form","#promo-designer-modal-custom-pop","#tncms-region-global-container-top",".navbar-nm__n",".newsletter__container","#below-article,\n#newsletter-subscribe-div,\n#subscribe-box",".jet-popup",".form-inline",".acymailing_module","[data-cy=\"SignupWidget\"]","#dga-newsletter-cta",".footer-sub-form",".foot-login,\n.j-foot-login",".dsg-react-footer-cwu-sign-up",".gform_wrapper",".widget",".newsletter-form--article","#digg-subscribe,\n#subscribePromotion,\n.md\\:p-4.p-2.rounded-md,\n[data-cy=\"namespace-home-newsletter\"]",".khfYvn",".b-in-content-shortcode",".cta-link,\n.tp-banner",".block-recipes-signup,\n.recipe-footer","[class^=\"buttonWrapper\"][tabindex=\"2\"]",".email-banner",".tp-modal",".tp-active.tp-backdrop","#email-signup",".container-box-email",".o-AdhesionNotifier",".mc4wp-form",".popup-subscribe","#tncms-block-529772",".widget_convertkit_form",".dib-footer-signupemail","#email-signup-template","#simple-banner,\n.widget-wrap.widget_text","#shopify-section-newsletter-banner",".top-hat",".newsletter-signup-inline","#cbox",".large-footer-shot","#freetrial_popup","#totalpoll",".signup-modal",".reveal-newsletter","#shopify-section-entry-popup","#shopify-section-newsletter",".advads-background,\n.drugt-before-you-go",".subscribe__form",".badge-link--newsletter,\n.js-footer-card",".meta-info-block",".nlbox",".signin-prompt",".landing-subscribe",".copyRight-div",".NewsSubscribeLg_main__QWMpm","#news-letter-pop","#ep-footer-subscribe","script[id^=\"wccp_\"]",".newsletter_signup",".block-ebook",".block-area-beforefirstimage",".c-postup-widget,\n.newsletter-window","#flyinbutton","#custom_html-56",".fd-focus-visible-applied",".mailinglist","#eb-bottom-banner,\n.eb-promotions--subscribe",".cta-suscripcion,\n.mf-modal-iframe,\n.mf-modal-overlay",".article__suscribe-bottom,\n.article__suscribe-sidebar,\n.site-footer__newsletter-widget","#nlSubscriptionForm","#SMSBump-Modal",".newsletter-widget","#newsletter-register",".mfp-bg, .mfp-wrap",".site-footer",".top-news-letter-cta","#pt_dark_over",".md-subscription,\n.md-suscription",".wp-block-jetpack-subscriptions",".NewsletterPopup_newsletter-popup__1pFRF",".has-newsletter,\n.popup-modal-mask",".boletin-wrapper",".w-cta.w,\n.w_tx",".btn-subscribe",".show.middle.modal,\n.show.modal-backdrop",".flujo-suscripciones",".inline-subscribe,\n.style__NewsletterCTAWrapper-sc-e26ea068-2,\n.styles__NewsletterButtonWrapper-sc-1d1d7156-13",".subscription-widget-wrap","#newsletter-asset",".promo-inline",".BFm46L","#notification-bars","#mambasms-forms-container",".paywall-mount","#hsNewletterFooterSub-container",".sf__newsletter-section",".side-rail-ads",".current","#block-12","#newsletter-subscribe-modal,\n.newsletter-subscribe-inline",".wixui-form",".block-et-newsletter,\n.full-bleed-newsletter",".wp-block-eugene-weekly-newsletter-signup",".cs-row-top",".subscribe-for-news",".cTopicPostArea:has(.cGuestTeaser)",".footer-top-block",".tve-leads-lightbox","#text-26",".newslattre-modal",".sidebar__subscribe",".code-block-6",".optshorts",".hustle-inline",".ta-campaign-widget",".banner-mh",".swal2-container","#entWinSlideBox","#topHeaderBannerWrap,\n.solutionLeadCapture",".mail-popup,\n.wrap-subscribe",".bg-gray-100","section > .mt-8",".brx-popup","._5hn6","div[style^=\"background: none;\"]:has(#mobile_login_bar)",".f-ssw,\n.f-ssw-subscribe-hook",".widget_bloomwidget",".catfish",".site-ftr__subscribe",".sign-up",".g1-popup",".terror-teletype",".sub-footer-container",".js-sjmnmm-root",".nl-popin",".featherlight",".bcToaster",".newsletter__widget","div[class^=\"signUpForm_\"]",".BMP",".jNY",".newsletter-wrapper","#articlePageNLSignupDiv",".has-quinary-background-color",".block-newsletter-share",".breaking-news-signup",".blackout",".regoverlay",".fadeIn.animated,\n.fixedBar,\n.mfp-container",".FooterSignup__SignupContainer-sc-bzm7ki-0,\n.fender-EmailSignup","#bottom-banner, #top-banner,\n.ad-placement",".omeda-newsletter-block","div.black.banner","#top-anch",".card-subscribe",".section-newsletter",".chakra-portal","#subscribe-app",".cmp-newsletter-popup","#subscribeButton,\n.-newsletter","#block-6",".dpsp-email-save-this-tool","#boxzilla-overlay, .boxzilla-container",".newslettercontainer",".is-newsletter",".diverse-subscribe,\n.if-signup-sidebar","#shopify-section-signup-modal",".act-btns-wrapper__newsletter",".ft-email-box",".Subscribe",".modals-overlay,\n.popup-newsletter",".mailing-list-banner,\n.mailingListRoot",".l-newsletter","#subscribeToNewsLetters,\n.newsletter-inline-flex,\n.zephr-editorial-newsletter-backdrop,\n.zephr-editorial-newsletter-modal","#colorbox",".p-0.container-fluid > .mt-5",".sign-up-container",".newsletter-backdrop",".pk-subscribe-form-wrap",".fb_lightbox-overlay-fixed.fb_lightbox-overlay,\n.newsletter-signup-and-ads,\n[data-shortcode-newsletter]",".download-block,\n.hello-overlay,\n.join-section",".hello-bar",".sidebarPlea",".tp-backdrop","._1Pece,\n.guanggao_close_group",".promo-image",".item-newsletter","#text-3","#ppsPopupBgOverlay",".container-fullwidth-subscription",".kds-Modal-overlay",".lb_overlay,\n.quitifyBannerContainer",".f-block--form-text",".app-footer",".super-form","#custom_html-8",".trackingSection-modal",".wp-block-kadence-rowlayout",".grey_background","#subscribe-home","._background_1mspu_85,\n._subscribeDialog_1mspu_1",".block-cookbook",".is-style-default",".newsletter_modal",".body-overlay,\n.newsletter-sticky-bar",".spinPromo",".article__content-sign-up,\n.n-sliding-popup","app-mailing",".max-w-screen-lg.w-full","[id^=\"subscribetonewsletterv2_\"]",".c-quick-subscribe",".cta--inner",".NewsletterSignupButton","#gd__adblocker__overlay",".js-nlsub",".mc-signup",".TGN_site_FullOverlay",".mailchimp-block","#POPUPS_ROOT","#footer-newsletter-subscribe-form","#nsltr",".floating-banner",".article-card,\n.email,\n.gcaptain-subscribe-modal,\n.sidebar-card",".ldm-cta",".wp-block-gearpatrol-newsletter-signup",".sub_bg","#itemz[style^=\"position:fixed; top:10px\"]",".announcement-box",".slide-up-banner",".boxzilla-slide-in-free-newsletter-2","#maillist-modal","body > div[attr=\"[object Object]\"]",".MuiModal-root",".top-footer-wrapper","#newsletterBannerBlock,\n.activity__newsletter-signup",".sidebar.col-md-3",".tdm-popup-modal-wrap",".w-newsletter-in_article",".cp-modal-popup-container",".form-container",".ps-curtain","#exit-intent-registration-modal,\n#sitewide-overlay",".main-overlay-container",".newsletter-module-optin--container,\n.newsletter-right-rail-optin",".expert-newslater",".gs-subscribe",".paragraph--type--gdn-newsletter-ii",".LbnIX",".b-footer-newsletters",".newsletter-home","#divInterstitialContainer,\n.divInterstitialBGCover","#newsletter-bottom-box",".conversion-module-nl-signup","#automizely_marketing_popup_bars",".subNewsletter",".newsletter__title-image-overlay","#modal-host",".c-email-sign-up","#js-subscribe-takeover,\n.marketing-footer__subscribe-content",".subscribe-block-container",".subscribe-block",".module--email-cta",".sign-up-banner-inner",".cms-popup","#spotlight",".footer_subscribe_subscribe-wrap",".mailing-list","#curtain,\n#modal-overlay",".home-form,\n.join-newsletter",".bg-borderMoreLightColor",".email-subscriber",".popupSubscribe","#article-nl-wrap",".sticky-footer-overlay",".lity",".af-form-wrapper",".el-dialog__wrapper,\n.v-modal",".elementor-element-be4633f",".poster-wrap--subscribe-news,\n.subscribe-form-holder",".chakra-modal__content-container,\n.chakra-modal__overlay,\n.css-pfotuc",".newsletter__bottom-wrapper,\ndiv[id^=\"sNewsletter_\"]","div[id^=\"newsletter\"]",".widget-had-subscribe","#newsletter-custom-container,\n#newsletter-custom-form-toast",".newssignup",".emailBox",".sidebar-form-wrap",".alo-newletter",".to-sky-100",".dy-modal-container",".newsletterBoxSidebar",".subscribe-widget",".subscribe-now",".newsletter-dialog-header-link","#boxes-box-subsctiption_middle,\n#home-subscription-row","#CoverPop-cover","#hcpro-misc-form",".footerNewletSub",".news-form",".has-quaternary-background-color",".is-style-group-envelope","#text-40","#_ghostery-background",".newsletterClass_n1f72qdk",".adblock-detected","body > .text-center[style=\"color:white; font-size:16px;\"]",".opportunity-container",".bc-newsletter-signup-container,\n.header-newsletter-btn",".sp-form-outer",".pulse-subscribe",".yellow-nl","#he1",".gradient_subscription","#sms-opt-in-modal,\n.callout-newsletter,\n.toast-wrapper","#shopify-section-static_site_popup",".forUnit___ixF4Y,\n.mpu___jBf9d,\n.unitContainer___ykMrM",".js-swimingBlock-stoper",".nl-signup-container","#credential_picker_iframe","#credential_picker_container",".newsletter-signup-tab",".io-header__cta-button",".proof-factor-app","#elementor-popup-modal-40,\n.elementor-element-3b03fc7c",".jetpack-subscribe-modal","#sticky-email-updates",".m-brand-engagement",".app-redirect-panel",".vtex-flex-layout-0-x-flexRow--newsletter",".form-article",".email-sign-up-form",".HolaNewsletter_h1mkhy1o",".single-page-subscription","#hlifenewsletter",".rc-subs,\n.subs-popup",".RegisterAndGetOFF",".popup-signup","#block-60",".Subscribe_subscribe__fsS5P",".active-campaign-form",".eb-inst",".gb-container-20db77c8,\n.gb-container-bc87a424",".home-owner-carousel-section",".widget-2",".avb-magento-form",".footer-newsletter-block",".nl-box",".widget_custom_html","#newsletter-popup-fullscreen",".article-email-signup-wrapper,\n.newsletter-popup-modal","#pico_prompt",".newsletter-in-article","#blox-message-incompatible,\n.tnc-overlay.tncms-block",".sb3",".signup-container","#ids-newsletter-modal,\n.bg-ids-light-blue,\n.bg-ids-primary-container",".header-secondary","#pit-below-all-content",".email-subscription-container",".ck_vertical_subscription_form",".Footer-whitelist","#text-15",".gnt_mol_oy",".modal-wraper",".join-community",".top-newsletter-subs",".layoutFooter-newsletterSignUp-form",".is-layout-constrained",".w-form","#smallmeternote",".elementor-element-8da89b7",".footer__banner",".block-pinterest-cta,\n.block-save-recipe-email",".grid-article-subscribe-container",".msnt-mail-dialog",".msnt-mail-footer",".signup-text","[data-lpos=\"headlines-newsletter\"]","#ig-newsletter-holder","#ArticleNewsletterBottom",".alert",".fancybox, .fancybox-overlay, .fancybox-wrap","#react-root ~ div[class*=\" \"][class$=\" \"][role=\"presentation\"]:has(a[href^=\"/accounts/\"][href*=\"signup/\"]):not(:has(button[type=\"button\"] > div > svg[aria-label][width=\"18\"][height=\"18\"][viewBox*=\"48\"])),\nnav > div[class^=\"_\"] > div[class^=\"_\"] > div[class^=\"_\"] > div[class^=\"_\"] > div[class^=\"_\"] > div[class] > div[class^=\" _\"][style=\"width: 100%;\"]:only-child",".wrapper-fluid--subscribe",".Subscription_sub_wrapper__eQ6n1",".stripe--newsletter",".SubscriptionInlineForm_articleInlineVariant__dcdCo,\n.home-news-letter-banner",".subsoverlay",".ic-alert-email-newsletter-signup",".newsletterForm","#subscribe-wide-side",".dsa",".component-quick-subscribe-newsletters","#blocker,\n.top-down-list--newsletter",".exit-intent-modal",".bg-grey-700.inv-sidebar-widget,\n.email-capture__zigzag",".ArticleBase-Newsletter",".pre-footer-subscribe-box",".wpdev-email-signup",".woo-login-popup-sc-modal,\n.woo-login-popup-sc-modal-overlay",".mfp-ready",".footer__bar",".custom-functionality-newsletter,\n.d-flex.row","#overlay-form-container",".jeg_button_1",".mail-chimp",".article-join-button",".modulonewsletter",".nw_cont",".cta__inner",".hero",".NewsLetterInlineHome",".js_qz_newsletter_signup_placeholder",".jg-newsletter-sign-up",".join-list",".site-footer__item-inner--newsletter",".module-footer__signup","#Newsletters",".dlvraPublished",".subscribeModalOuter","#ema_signup_form","[href=\"/subs.php\"]","#jms-tray",".c-hgrWQv",".jr-modal-wrapper,\n.proposal-box",".block-media-feature-image","#lb-wrapper-autonewsletter",".mb-4.card","#article-subscriber-form,\n#premium-link",".elementor-element-9d638ba",".widget_black_studio_tinymce","#rcp-email-signup",".block-sidebar-subscribe","#newsletter-subscription-aside-widget,\n.notification-banner",".top-bar","#bio_ep,\n#bio_ep_bg",".jcom-c-promo-newsletter","#block-36",".css-81stxx","[aria-label=\"Receive our newsletter.\"]",".get-subscribe-form-wrap,\n.td_block_kbb_bestcardeals_subscription_form",".Placeholder",".footer-col--newsletter","#modalnewsletter___BV_modal_outer_",".newletter-widget-wrapper","._inline-form",".autoplay","#block-recipenewslettersignup,\n.dynotifyjs-corner",".blueconic-article__wrapper",".member-register",".footer-productsignup","#HTML1",".popup-overlay",".post-subscribe",".newsletter-opt",".dQrqPv",".promo-design","#forms-block_ee1e843a9348070a466c6e3f908c9703",".beehiiv-newsletter-signup-container","div[id^=\"div-gpt-ad-\"]",".newsSignup","#newsletters-subscribe-box,\n#popup-banner-subscription-ecom,\n#popup-banner-subscription-store,\n.c-header__newsletter,\n.popupBannerSubscribeUd,\n.ukraine-daily-side-banner,\n.war-notes-banner,\n.wtfr-snippet",".formulariosuscripcion",".gf_form_mail_wrapper",".subscribe__style-5",".ArticlePage-aside-content,\n.Page-footer-content-above",".elementor-element-5f8f7d3,\n.elementor-element-dc75b6d",".css-jh5v8h","#bottom_navbar,\n.track-reminder","div[id$=\"___BV_modal_outer_\"]",".marketo",".site-footer__form-wrap",".avada-footer-scripts",".hosting-below-post",".modal:has([style^=\"background-image: url(\\\"/assets/newsletter-\"])",".newsletter__col","#custom_html-21",".suscribehorizontal","#reg-modal",".show.fade.modal-backdrop",".c-promo-slice__link",".o-callout__newsletter",".wppopups-whole","c-tag-home-page-sign-up-pop-up","#newsletter-signup-modal,\n.lv-modal-blocker",".popupally-overlay-gfcr-1","#block-edu-prospect-edu-prospect-email-catcher",".c-homepage__newsletter-block",".p-7.border-eerie-black,\n.py-\\[60px\\]",".email-subscription-form,\n.full-vp-welcome-modal-wrapper","div.loading-links",".bottom-wrapper",".text-strong-invite",".close-popup-overlay,\n.popup-acm","#newsbox","#blockModalPopupDiv,\n.outerModalPopupDiv",".latest-issue-spotlight",".subscribe-popup",".subscribe-maskLayer",".newsletter__lightbox",".newsletter_section",".global-alert--yield.global-alert, #global-alert-queue","[href^=\"https://subscribe.linuxiac.com/\"]",".modal-email-signup","#MainModule div[data-max-width=\"2400\"] + div[class],\ndiv[class][tabindex=\"-1\"][role=\"region\"][aria-label][data-min-width][data-max-width] ~ div[class][data-max-width=\"2400\"] + div[class]",".message",".newsletterRHS,\n.subscription .paywall .subscriptionBox",".mlform",".Footer_email-form",".emphasis-h2","#slidingbar",".email-subscription-modal",".email-subscription",".newsletter-signup-butt",".jsx-3f4fe83626c3275",".subscribe-now-box",".newsletter-box-container",".lnl-recipe-emailme,\n.lnl-theme-widget-subscribe-popup",".elementor-element-515d4e87",".uix_sidebarInner",".campaign-pop-container,\n.campaign-pop-mask",".wixui-lightbox",".blnotice",".loyalty",".subcribe-banner",".newsub-box",".footer__signup","#newsletterSubscriptionModalLoad",".Newsletter_component__sowM_,\n.comp-newsletter-box","#newsletterform",".magazine-subscription",".markamayNewsletter",".gradient-purple,\n.p-3.h-100",".td-a-rec-id-content_inline",".footer-newsletter__container",".border-secondary-300,\n.border-warmgray-100,\n.max-w-9xl",".pk-subscribe-container","#email-capture",".brazen-modal",".piano-newsletter-article","aside.widget_custom_html",".subscribe-cta","#newsletterModal",".footer-sign-comp,\n.signup-profile-comp",".email_SignUp",".StickySubscriptionFooter_mck-c-subscription-footer__au9pl",".newsletter-html-asset","#support_banner",".wdn_responsive_table","#home-sidebar-1-container,\n.site-top-bar",".subscribe-ltr",".g1-newsletter","#subscribe_form",".subscribe-callout-bar",".grwf2-wrapper",".grwf2_backdrop",".sticky_ad_container,\nhl-newsletter-cta",".footer-form","#nlModule","[class][style=\"bottom: 0px;\"]",".cme-join","#block-3",".content_mailchimp",".MPHomepageModalWidget",".footerSub","#bottom3","#mcomEmailBanner","#message-purchased",".fixed-footer",".Mg2-connext, .connext-modal-backdrop, .modal-scrollable",".active-subscribe,\n.footer-subscribe-block,\n.wotd-side__subscribe","#m-newsletter",".side-newsletter-wrap",".tap-email","#modalsRenderedAfterPageLoad",".memo-newsletter-wrap",".amped-wrapper","#modal-darkener,\n.lead-gen-pop-up",".jpKUNM",".m-modal-bg,\nM-MODAL","[href^=\"http://www.pingperfect.com/aff.php\"]",".vertical-subscribe",".sign-up-newsletter",".footer-join-wrapper","#block-33,\n.wp-elements-6af074a2b773903132682d24a9a289ae","#newsletter_article",".css-1dwh0gf","#block_footer_custom",".footNewsletter","#mc_newsletter_signup_article,\n.newsletter-article-container,\n.newsletter-form-container","#signmd___BV_modal_outer_",".content-wrapper[ethical-ads-big],\n.info-wrapper[data-v-7cd21295],\n.info-wrapper[ethical-ads-big=\"\"]","div.center-align","#custom_html-14,\n.footer-widgets",".top-sub",".sticky-signup",".modal__overlay",".hpv2-newsletter,\n.m00646-mc-newsletter",".newsletter-signup-rhs,\n.tech_newsletter",".email-subscribe-box",".analytics-tiplistbox,\n.reference-email-tip-box,\n.tip-email-popup",".before-content",".boxzilla-bottom-right-container",".footer-newsletter__form",".init.open",".news__subscribe",".widget__form-subscribe","#homepage-newsletter-promo,\n#homepage-subscription-promo,\n.mj-adblock-widget,\n.mj-text-cta",".sII9F","#wmpci-popup-wrp","#sledgehammer",".ad-blocker-notice","#newsletterSignUpDivAnime,\n#viewportGreyout,\n.in-content-container-coverage",".SubscribePopup2,\n.SubscribePopup2__pop-up-overLay",".ms-actions",".msnbcDaily__footer",".site-header-top-section-center","#buy-tickets,\n.amazon-tickets",".mb-interstitial,\n.mbw-stickybar",".responsive-footer_email-signup","#subscription","#express-signup,\n#side-block-02,\n#side-block-04,\n.comment-hunter-block","#side-block-01,\n.meter-warning-box",".form-version-cid-1",".bottom-bar-optin,\n.section--optin",".cb-ready",".like-newsletter,\n.side-subscribe",".login-callout","#overlay, .social-media-popup",".ebook","#tncms-region-article_bottom",".subscribenew","#natgeo-marketing-inline-email-footer-frame1-module2,\n.EmailStickyFooter__Modal,\n.InlineEmail__Container","#modalBackdrop,\n#site-broadcast,\n.modal-default",".aside-module--promo-module,\n.aside-newsletter",".home-section-register,\n.subscriber-box",".Subscription-Article-Box","div.c-site-messages,\ndiv.nature-briefing",".site-footer-newsletter__one-half","#company_profile_form",".tile-newsletter","#\\5f _cricketsubscribe,\n#___ndtvpushdiv",".mailmodo-news-letter-m__card-wrapper__o-Dst",".dy-act-overlay",".newsletterCol","#pr-sidebar-subscribe","#contextual-reg-modal-container",".fr-dialogmodal",".optinforms-form-container",".sticky-footer",".sqs-popup-overlay",".article-sidebar--newsletter",".newsletter-subscription-section",".blink-sdk-widget-container",".double-padding-top",".newsletter-signup--group",".bg-blue-link","#custom_html-30",".NewsletterPromotion,\n.NewslettersPanel,\n.SidebarNewsletterWrapper","div[class^=\"Newsletter_\"]",".dialog-widget-content","#EmailSignupContainer,\n#nmsbma__container","#Widget15",".july22-newsletter",".newsletter-signup-horizontal,\n.promo-link",".newsletter-subscribe-form",".subscription-form",".nl-modal","#adtoniq-msgr-bar,\n#text-36,\n.widget-no-mobile",".email-sidebar-signup",".connected","#att_lightbox_email",".emthemesModez-footer-topColumns","div[data-newsletter-popup-container]","#in-article-newsletter-signup","#easybanner-overlay-el,\n.easybanner-lightbox-content","#popup_newsletter",".impact-subscribe-cta",".site-footer-mailing-list","#custom_html-23","#footer-email,\n.home-signup",".tfCi0",".SubscribeSection",".site-announcement",".newsletter-mod",".newsletter-form-block,\n.nl-space",".formkit-sticky-bar",".overflow-hidden.bg-blue-700,\n.rounded-lg.px-6",".nn-newsletter",".nt-sidebar-newsletter",".module-subscribe",".uui-blogpost05_newsletter","#header-banner",".border-\\[\\#000777\\]",".type-newsletter_subscription",".freebie-opt-in-form",".footer_form_section","#formWidget",".playerBlocker","a[href=\"https://info.ipet-ins.com/emagazine_subscribe_nyanpedia.html\"] > img",".text-form-wrapper",".inline-module--newsletter",".backdrop-blur-sm,\n.border-sunGolden","#modal-portal-regiwall,\n.ReactModalPortal:has(.welcomeAd),\n.a8f50c72,\n[data-gtm-element=\"newsletter_loaf_form\"],\n[data-scp=\"newsletter\"]",".footer_newsletterSectionBlock__c0Qgo,\n.modal_modal-window-container__26ycp,\n.newslettersignupmodule_newsletterSignupModule__pT3BJ",".enews-container",".l2VEg",".PD_modal,\n[href=\"/alerts\"]",".lightbox-push",".wp-block-observer-newsletters","#extras-container,\n.email-updates",".tl-states-root",".background_lozad",".dNsyER,\n.lnolAx",".af-form",".piano-inline-template__content",".lh-subscribe","#dsgvoModal",".subscribeform-footer",".nt_se_newsletter2",".sidebar-signup-form",".ribbon",".emailSignup-borderRadius",".ooni-footer-newsletter",".mailster-form","#footBox3",".tdi_174",".modal_overlay",".rawhtml","#newsletter2","#details-widgets",".met-footer-toast",".ad-container-responsive,\ndiv[id^=\"div-gpt-ad\"]",".guest-mail,\n.mailMagazine","#text-12",".Subscribe__Subscribe___2hrcO",".adblockalert",".email-input",".newsletter-content",".ArticleSignupForm,\n.Modal",".output-mag-newsletter-form",".o-content-cta","#dynamic_banners,\n#omailContainer,\n.fusion-emailSignup",".insider-exclusive__container,\n.site-footer__insider-promo",".IndexStyled__NewsletterSection-x8xg4h-5",".lg-backdrop,\n.lg-outer","#newsletter_subscribition_box,\n.jquery-modal,\n.newsletter_box",".meter-warning-text",".essb_mailform",".mailchimp-form",".m-flex-nav--right-engagement",".SubscribeCTABlurb_SubscribeCTABlurb__M_Azu,\n.btn--follow,\n.css-1at62qq,\ndiv[class^=\"ContentBlocks_CardDetail__SubscribeBlock\"]",".simple-signup",".pdtgfooternewsletter",".join_email_capture_component","#newsletter_descri,\n#newsletter_titre,\n.inscriptionmail","#g-bottom1",".pclHotDeals","div[x-init*=\"initNewsletter\"]",".playback-ad-blocker-notice","#signup-container,\n.b-modal,\n.pps-popup",".module__promo",".custom-a-banner","#signUpWrapperOuter",".form-nl",".newsletter_flyout_newsletterFlyout__ms6QT","#bww-advertising-popup-overlay,\n.newsletterWide",".ui-dialog[tabindex=\"-1\"]",".subscribe-section","#newsletter-signup-form",".bnotify",".fullwidth-newsletter-sign-up__email",".article_sub","[action=\"/api/subscribe\"]",".new--lttr--sec",".yotpo-smsbump-modal__backdrop","#nonono",".wp-block-aweber-signupform-block-aweber-shortcode",".pb-site-subscription",".takeover.modals",".hayes-subscription-widget,\n.pasta-school-email",".daily-callout-list",".sponsor, div.wrapper",".contact-wrapper","#below-story-text > .story-enhancement,\n.sign-up-21",".ftr-subsWrap",".m-supporter",".duet--cta--newsletter","[class]:has(> .duet--cta--newsletter)",".pc-newsletter-sidebar",".EmailAcquisitonstyles__EmailAcquisitionOuterContainer-sc-1b9duud-0",".page-error","#tncms-region-article_instory_bottom",".tp-backdrop, .tp-modal","#text-6",".ragansdaily",".mfp-ready, .mfp-wrap","#sml_subscribe_widget",".article-inline-promo",".PHNewsletter",".widget-area",".site-newsletter-bar",".sign-up-modal","#form_out",".animate-floating-banner,\n.exit-popup",".pflrgAds",".newslatter_box",".Notice",".footerEmailSignUp-container,\n.modal-wrapper","#registerPopup",".home-promo-center-right-bottom",".email-bar20",".lead-capture-campaign",".ml-subscribe-form-5774674,\n.mt-3.sticky-top,\n.sailthru-nl-signup",".invader-overlay","#block-elettersubform","#gb-reg-modal-block,\n#gb-reg-modal-reg,\n.gb-reg-modal-overlay",".border.bg-white.mb-4",".widget_oih_opt_in_widget",".SignupWallInline-overlay",".new_signup_dialog.modal_bg,\n.qu-overflow--hidden[class*=\"qu-zIndex--modal_\"],\nbody > div[id]:has(.modal_signup_dialog)",".kHmXgL","#inner-ad-container,\n.floating.share-btn",".Footer__topsection",".c-action-box","#rb-newsletter",".sc-bUQzRK,\n.sc-xGAYn",".w-md-100",".widget_ymlp",".gdm-company-profile-unit__profile-container",".whine",".NewsletterSubscription_mainWrapper__GxgFi","[class^=\"AdBlockDetector\"]","#piano-infobar-container",".modal-newsletter",".rcrwi-hubspot-article-form",".js-intro,\n.post-subscribe-cta-wrapper",".rw-subscribe-sec",".product_specific_widget_link,\n.textbanner_link",".single-post-signup-box","#module_form,\n.form-wrap,\n.remodal-overlay,\n.remodal-wrapper",".wprm-entry-footer",".newsshort,\n.rtJqibox",".card-newsletter-modal,\n[style*=\"opacity:\"]",".email-collection-banner,\ndiv.prompt:has(> .viewInApp)","#span_subscibe_top",".dfm-sidebar-top-flex-container","aside",".yOGxa","div.hello",".email-signup__container","#ltkpopup-overlay","#ltkpopup-container",".rns-newsletter-embed-content,\n.rns-pop-up-wrapper",".fluentform","#ad-plea",".footer-fixed",".newslettreastuce",".slot1",".Campaign",".widget_text.zox-side-widget",".article-prompt__container__3uXJV,\n.regular-article-layout__newsletter__3wzPk",".nlsm-small,\n.rj-newsletter-signup",".w-newsletter-form,\n.w-newsletter-right-rail",".emma-show","#popupModal, .modal-backdrop",".footer__email-signup","#lightboxWrapper,\n#promotion_banner,\n.lightboxOverlay",".form-preview","#newsletter_subscription",".section-footer__newsletter-block,\npop-up","#form_newsletter-blog,\n#form_newsletter-sub-single",".SubscribeBox",".signup-popup",".newsletter-link",".cta-modal",".smart-slot","#block-nodepagebelownewsletter,\n#block-romaniainsiderfreenewsletter-2,\n#block-romaniainsiderfreenewsletter-3","div[id^=\"PopupOverLay_SF_\"],\ndiv[id^=\"pframe_SF_\"]",".email-wrap,\n.mask",".footer__newsletter-block",".Subscription-isReact",".subscribe-layout",".silo_page-newsletter",".comp-landing-newslettersignup",".home-email-signup","#sgpb-popup-dialog-main-div-wrapper, .sgpb-theme-1-overlay",".savetherecipe",".sub_promo",".mailchimp-links",".sc-footer-desktop-sect01",".wp-block-san-san-inarticle-newsletter-signup,\n.wp-block-san-san-sidebar-newsletter-signup,\n.wp-block-san-sidebar-cta__content",".newsletter-m","#sank-prestitial",".interstitial",".cta-newsletter","#cm-popup-overlay",".message-inner:has(.ads)",".NEWSLETTER_ONENTRY","#newsletterContainer","#emailCollectorModalOverlay,\n.columnSignup-ztftf,\n[class*=\"newsletterSign\"]",".css-e2xo3p","div[data-qa=\"NewsletterWidgetContainer-NewsletterWidget\"]","#subscribeModal",".ftr-subscribe","#subs-ribbon","#new-home-row-3,\n#new-home-row-7",".notification[style^=\"height: 189px;\"]",".daily-scan-form",".featured-subscribe",".sej-subscribe-form,\n.sej-widget,\n.web-dwn",".bg-ftr-subscribe,\n.nl-inline-form,\n.nl-stacked-form","#signup_large",".footer_newsletter_wrap",".smn-banner-newsletter,\n.smn-header-subscribe,\n.smn-home-section__sticky-container",".c-form--newsletter,\n.c-widget-subscribe","#custom_html-29",".security-newsletter-container,\n.sw-newsletter","#inline-africa-form,\n#inline-business-form,\n#inline-flagship-form,\n#inline-media-form,\n#inline-principals-form,\n#inline-technology-form,\n#newsletter-sign-up,\n#vertical-signup-form,\n.liveramp-inline-signup-form,\n.styles_newsletterSection__6CWXE",".widget_s1_signup",".max-h-\\[250px\\],\n.tablet\\:max-xl\\:max-h-\\[250px\\]","#realpop_optincontent","#newsletterBox","[href=\"https://link.sfgate.com/join/signup-sfgate\"]",".Header_newslettersButton__8p0gX",".ft-right-email,\n.j-quick-register-container",".form__container","#sidebar-newsletter-signup","flashy-popup",".blp-container",".gooble-omodal","#post-article-subscribe",".drawer--newsletter",".signup-background",".bottom-20,\n.left-0",".simpl-adlabel",".ipsDialog,\n.ipsModal",".article__newsletter",".noFocusOutline > div > div > div > div > div[style^=\"position: relative; display: flex; flex-direction: column; flex-grow: 0; flex-shrink: 0; overflow: hidden; align-items: stretch; align-self: stretch; background-color\"][style$=\"border-style: solid;\"]",".totalpoll-container",".top-start","#newsletter-embed",".content-newsletter",".c-garfield__nl",".in-article-newsletter",".footer-email-subscribe",".action","#modal-box",".ldm-newsletter-promo-inner",".cas-container,\n.cas-wide-container,\ndiv[style^=\"width: 300px; height: 250px;\"][style*=\"background: #fff;\"],\ndiv[style^=\"width: 860px; min-height: 90px\"]",".c-home-right",".c-subscribe",".springbot-overlay","#overlay","#nlFrameId7020","#sub_pop",".CustomHubspotForm_blogForm__6LtFv",".is-style-call-out-subscribe",".pattern-newsletter-subscribe",".subscribe-line-link","#removeAdsSidebar,\n.ad-wrapper, #adTopLarge, [id^=\"adSide\"], [id^=\"adMiddle\"]",".email-signup-offer-wrap",".join-login-wrapper.join-login-alt--six-second[data-alt-modal],\n.zd-privacy-content",".mb4.pa4.pb5.overflow-auto.tc.flex.flex-column.bg-center.cover.bg-dark-red.white",".newsletter-podcast","#leaveSiteContainer",".newsletter-ui,\n.signup-msg-cta-wrapper",".cWZgjA",".tw-email-signup-section",".content-block-sidebar-form",".article__news-services-subscribe,\n.cell-subscribe",".top_block","#smartcta_1",".footer-subscribe-form__formWrapper",".breakingPopUp,\n.emailbox",".Article_newsletterPromo__YXJkV",".hp-newsletter,\n.sidebar-newsletter-signup-wrap","#email-subscribe","#infographicNewsletter,\n#newsletterPopupOverlay","#stat-modal-base,\n.stat-hubspot-signup","#text-11",".abg-card","#mailerlite-form_1",".footer-right__box",".subscribe-article","#sidearm-adblock-modal",".email_popup",".cordial-email-signup",".moOptinForm",".st-newsletter",".mc-modal,\n.mc-modal-bg","#cartx-wrap",".show-subscribe","article.post > div[class*=\"frontend-components-SubscribePrompt-module\"]",".t-newsletter-form--container","[data-mht-widget=\"signu-up-black-background\"]",".footer-info-newsletter-inn",".subscribe-header",".custom_signup","#swell-overlay,\n#swell-popup",".site-footer-col--subscribe","a[class^=\"_\"][href^=\"/restaurants\"]:has(div[style=\"background: rgb(58, 60, 65) none repeat scroll 0% 0%; color: rgb(255, 255, 255); border-color: rgb(30, 32, 35) transparent;\"])",".blog-post__gated__wrapper",".c-banner-form",".afill",".Toastify",".regcta,\n[style^=\"width: 100vw; height: 100vh; background-image: linear-gradient\"]",".SubstackWidget",".my-32",".jumbotron",".lgfwSu",".sidebar-newsletter-container",".post-nl-promo",".block-meal-plan,\n.wprm-custom-cta",".eb-init",".custom-mailing-list",".global-newsletterBanner","#consentModal, .modal-backdrop","[href=\"https://techcabal.com/newsletter\"]",".wp-block-tc23-newsletter-signup-compact,\n.wp-block-techcrunch-newsletter-signup-compact",".sidebar-signup-form-container",".my-float,\n.newsletter-body",".popup-overlayx","#lightbox_container,\n.backdrop",".elementor-element-8e82188,\n.sidebar-optin",".mb4wp-form-wrapper","#ti-subscribe-form",".ubub",".base_subscribe_footer,\n.featuredVendors,\n.inner_content_lazy_load_content_divider","[class^=\"stayConnected__wrapper-\"]",".header-newsletter-cta","#subscriptionModal, .modal-backdrop",".subscribe-medium",".ta-campaign-widget__popup-wrapper","#kt-popup-newsletter",".js-notices",".newletter-signup-wrapper","#talk-marketing-banner",".spin-modal",".ts-banner-overlay-first",".ue-c-nl-banner","#bg-simple-portal-container,\n#bg_pc_benefit_download_modal_container_id","#blog-subscribe","#join-mailing-footer",".et_bloom_below_post",".eoa__newsletter-signup",".newsletter-box-2",".newsletter-component",".newsLettetPb",".newsletter-container-placeholder",".sim-module-wrapper",".above-email",".nl-right-rail-module",".widget-signup",".c-article-comments-banner__content,\n.c-subscribe-email__wrap","#the_analyst_subscribe_widget-2,\n.subscribe-form-footer",".newsletter-subscribe-card-warp","div[class^=\"BottomLeaflets_newsletter_\"]",".bg-graphite",".push-notification-inline-cta","#article-newsletter,\n.pane-simplenews",".ml-vertical-align-center","#inarticle-sponsored-headline","#block-10","[href=\"http://tbi.fyi/website_referral\"]",".full-width-cta,\n.post-form-cta",".bg-turquoise-500,\n.savvy-target","#newsletter-su",".subscription-box",".form__wrapper","#overlay_search","#robly_embed_signup",".MuiDialog-root",".cool_gallery__main,\n.cool_newsletter,\n.tcd-gradient-cerulean-alt",".popup-box",".nlSignup",".sign-up-banner-container,\n.sign-up-bannerstyled__SignUpBannerWrapper-sc-13sjkk5-0,\n.toaststyled__ToastArticleWrapper-sc-1i4l75i-0",".space-y-8 > .subscribe-form",".ProductCalloutNewsletterModule",".interact",".right-footer",".py-lg-8",".recurrent-newsletter-block",".articleNewsletter,\n.homepage-newsletter-cta",".weekender-blue,\n.weekender-green,\n.weekender-white","#modal-OVERLAPABLE,\n.showTopNav",".has-over-sun-gradient-background","#subscribe-pop-wrapper",".footer_content",".subscribe_widget_item",".Hd__banner,\n.NewslBanner,\n.SplitCTA",".mailchimp_form",".tft-subs-block","#myEmailModal,\n.c-side-header__extra,\n.substack-frame-root","#block-19,\n.newspack-pattern",".gfl-blogpost-daily-digest,\n.signup.blog-sidebar-section",".email-list-subscribe,\n.get-our-newsletter",".capdigest_sign_up_page_breaker,\n.newsletter_sign_up_page_breaker",".marketing-container-wrapper,\ndiv[class^=\"NewsletterOnArticleSubscribe_\"]",".ns-buttons","[data-spacefinder-type=\"model.dotcomrendering.pageElements.NewsletterSignupBlockElement\"]","#email-outer",".sub-button",".newsletter-cta-banner",".newsletter__popup-container",".network-footer__ca-newsletter,\n.network-footer__newsletter","#htp",".enews-backdrop,\n.inertia-newsletter-home","[data-testid=\"newsletter\"]",".subscribe-form-wrap","#offer-0-lwmcg,\n#third-party--viewport-takeover,\n.newsletter-block__content",".tjp-newsletter-box","#newsletter-reminder,\n.subscribe__footer",".Post__emailSignup",".widget_mc4wp_form_widget",".section-subscription",".meta-join",".newsletter-dialog",".wp-block-group-is-layout-flow",".newsletterbanner","#news-letters,\n.email-signup-module",".defaultstyled__StyledNewsletterForm-sc-1n48v8y-8,\n.newsletter_subscribe_container",".footer__subscriber,\n.post_home__newsletter,\n.subscribe__popover",".join","#newslettersignup,\n.c-channel__cta,\n.channel-cta",".comic-newsletter-signup",".gh-post-page-cta",".sign-up-form",".newsletter-promo-box","div[class*=\"EmailSignUp_\"]",".bg-warning,\n.card-body",".header-breaking__secondary",".elementor-element-16c138b","[class*=\"Newsletter\"]",".newspack-lightbox,\n.subscribe__style-1","div[class^=\"NewsletterCard_\"]","#daily-skimm","#modal-dialog-dismiss",".m-custom-component,\n.mm-navigation--multiple-menus","#tncms-region-global-side-secondary",".navbar-feedback",".wds-block-newsletter","#cms-popup",".InlineForm","#blueconic-article-theweek",".aspect-ratio-newsletterbox",".bJ_pf,\n.dr_wr",".wp-block-newsletter-builder-signup-form","#snack_dex6,\n.ad-billboard,\n.c-header__advert",".c-newsletter-signup-box","appcues-container",".email-sign-up_emailSignUpContainer__OJefo",".substack-popup-container",".modal-div",".email-sign-up",".modal-underlay,\n.redux-modal","[class^=\"EmailAcquisitonstyles\"]","[data-thurrott-layout-section-footer-section=\"newsletter\"],\n[data-thurrott-section=\"inline-form\"]",".c-banner","a[href^=\"https://cloud.newsletters.time.com/signup?\"]","#ad300",".newsletter_inline,\n.newsletter_inline_banner,\ndiv[class^=\"_inlineNewsletter_\"]","#body-subscribe","._37K4.RUE6","a[href^=\"https://timesofindia.onelink.me\"]",".daily-edition-signup,\n.nlsignup","#footerNewEmail",".adblock-on","#tjx-newsletter","#browser-notifications-prompt,\n#newsletter-subscription__sidebar,\n.canvas-video-block--aside",".newsletterpopup,\n.nwl-teaser__wrap",".suscripcion",".subscription_banner","#sign-up-form",".freePointWrap","#sbnewsletter-signup-wrap",".hrWTog,\n[data-testid=\"NewsletterFooter\"]",".adsninja-ad-zone,\n.daily-vid-ad,\n.top-horizontal-ad-content,\n.txt-ad",".FGceuF2n",".subscribe_news_letter",".top-optin","#custom_html-24,\n#custom_html-4",".promo-popup",".news_letter_box",".widget_mo_optin_widgets",".sib_signup_form",".musthave-right",".tp-follow-container",".content31_newsletter",".newsFooter","#prefooter",".nlform",".mntl-footer__newsletter",".push-subscribe-newsletter-wrapper",".lp__formPopCont",".related,\n[href=\"/notifications/\"]",".J_PopupMask,\n.h5-subscribe-card-con,\n.o-pop-box-retention","#newsletterCheckbox",".subscription-island--home","#grow-consent-modal",".join-our-newsletter",".signup_section",".js-modal_wrap",".block-webform-block",".signupAfter,\n.signupInline",".tmblr-iframe--follow-teaser",".dark-theme-dialog__dialogBody___106Di",".text-2",".n-subscribe-footer","._newsletter_1cw2x_1",".p2-subscribe",".right_subscribe",".financetldr-top-bar,\n.financetldr-top-bar-card","#layers > div[class] > div[class] > div[class] > div[class]:has(> div[class] > div[class] > div[class] > div[class] > div[class] > a[href=\"/login\"]),\n#layers div[class=\"css-1dbjc4n r-l5o3uw r-97e31f\"]",".js-signup-call-out",".recurrent-sidebar-newsletter-block",".subs-box",".ug-footer-subscribe",".alert-discreet","#js-stickyEmailSignUpFooter","#ug-article-email-subscribe",".newsletter-pop-up-container",".blog-subscribe-inline,\n.dt-tip-subscribe",".single-ad","#block-10 > .container > .background-gradient","#login-form,\n.code-block-4,\n.subs-modal",".modal--newsletter",".force-load-ad",".mailchimp-popup-overlay-upworthy,\n.mailchimp-popup-upworthy",".o-pwa-modal-overlay",".gnt_m_th_em,\n[aria-label=\"Newsletter signup form\"]",".js-inline-email-cta,\n.persistent-email-cta","#post-newsletter,\n#tie-newsletter-2","div.mb5 > react-trigger,\ndiv[class^=\"KioskFirstClass__Container-\"]",".investedpromo",".inline-signup",".t-signup-navigation",".article-newsletterFooterModule-container,\n.homepage-newsletters-container","#footer-primary","div[id^=\"popup-smart-root-\"]",".widget-wysiwyg",".callout","#shopify-section-custom-popup",".never-miss",".wpforms-location-newsletter",".btn_footer_get_listed,\n.newsletter_row",".post-boilerplate",".fnews","#gigya-subscribe-with-email-screen,\n.gdn-popup-modal,\n.paragraph--type--gdn-contact-us",".user-newsletter-signup,\n.wp-block-savage-platform-beehiiv-form","#blog-sidebar-cms-block",".signup-newsletter-style-two",".home-email-cta",".alert-info",".enewsBanner",".footer-mid",".mvp-widget-home-head,\n.wp-image-1216,\n.wpforms-ajax-form",".silk-modal-root",".sidebaritem2018",".component-cnid-modal-backdrop","div[style=\"width: 100%; height: 100%; top: 0;left: 0; position:fixed; z-index: 255;\"]",".duet--layout--rail",".form-newsletter",".showfreemethod",".contact-form","#kajabi-form",".footer__email-sign-up",".ad-align-center,\n[data-section=\"header_top\"],\n[data-section=\"news_header_top\"]",".hub-newsletter","#cred-bnr-top","#gform_wrapper_1",".bg-light.card,\n.home-subscribe-header",".newspack-lightbox-overlay,\n.newspack-popup-container","#ctct_form-2,\n#signup,\n.ctct-form-block",".mb-lg-mod.bh.b",".email-alerts,\n.piano-fixed-footer-two",".vm-hello-bar,\n.vm-newsletter-signup-bait,\n.vm-newsletterbribe","._4zodakb._4zodaka,\n.fINiis",".search-container2",".frontpage-quiz",".AnonymousNewsletter--AnonymousNewsletter--1Btxs",".lepopup-popup-container",".lepopup-popup-overlay",".hp-nl-main,\n.sf-nls-wrapper","#home-nl-bar",".article-subscribe-form",".block-join,\n.cpro-overlay,\n.mz-signup-block",".sec-subscribe",".elementor-element-ba0e7fd",".newsextras",".footer--subscribe",".free-food-bar,\n.homeMealCTA-wrapper","#js-blog-subscription",".oxy-alert-box","#hp_newsletter","#join-email-campaign",".swal-modal, .swal-overlay",".atf-signup,\n.newsletter-prompt",".article-registration-form",".ad,\n.consumer-marketing-unit--cm-footer,\n.consumer-marketing-unit--display-rail,\ndiv[class^=\"ConsumerMarketingUnitThemedWrapper-\"]",".M0a",".newsletterContainer",".social-box-sign-up",".nl-container,\n.side-bar-nl-wrap,\ndiv[id*=\"snewsletter-popup-MailChimp_\"]",".widget_loginwithajaxwidget",".widget_execphp.widget",".worth-newsletter-section","#text-19","[data-inset_type=\"newsletterinset\"]",".nl-footer__inner","#newsletter-signup-bar-01",".u-width-300.lrv-u-background-color-black,\n.wwd-subscribe-now-banner-ad-container,\n.wwd-subscribe-now-banner-background",".signup-form","#baseModalContainer",".independent_mailchimp_widget",".caas-figure-with-pb[style=\"max-height: 192px\"],\n[href^=\"https://subscription.yahoo.net/Newsletter/\"]",".react-wafer-Featurebar",".newsLetter",".subscribe_form_box","#YncLightBox",".newsletter-subscription-block,\n.sidebar-item-subscribe-form","ytd-popup-container > .ytd-popup-container > #contentWrapper > .ytd-popup-container[position-type=\"OPEN_POPUP_POSITION_BOTTOMLEFT\"]","#mealbar\\:3 > ytm-mealbar.mealbar-promo-renderer",".qi-z,\n.xh-z",".EmailSignupForm",".css-1l59vvo",".footer-widgets-wrapper","#modal-generic-modal","#abd-banner,\n[class^=\"ExitModalNewsletter_\"],\n[class^=\"MidArticleNewsletter_\"]",".idx-bg,\n.tap-hdl","div[class^=\"article-page-module--article__newsletter\"]","[class^=\"advt-\"]",".fb-inst",".email-capture-component","#emailInfobar","#cro-common-newsletter-ecomail-entityform-edit-form",".s1-newsletter-outer","#c5531,\n#nlNag",".footer-newsletter--container","[href^=\"https://airvpn.org/\"]",".daily-newsletter-anmeldung_r",".newsletter-sign-in-wrap","#newsletter-subscription-popup","#newsletter-container",".exp-newsletter",".cs-newsletter-registration-overlay,\n.js--overlay","#footer-newsletter","#boersen-briefing",".js-newsletter-popup,\n.js-newsletter-popup-inner","app-newsletter-popup",".aff-cta-sidebar-wrap,\n.after-post-sharing",".widget_ee_formbuilder_widget",".nl_subscription_form","#popup-background","#footer-bold",".post_newsletter",".subscribe-newsletter",".paragraph-wrapper--ParagraphNewsletter","#block-newsletterctablock",".promo__newsletter","#kress-express,\n#nl-kressExpress",".newsletter-layer",".newsletteranmeldung",".teaser--newsletter",".subscribeboard",".np-nl-widget","#article-subscribe",".modal-custom--overlay",".arcticmodal-container,\n.arcticmodal-overlay","#nl-overlay,\n.register-newsletter-form","#persoblock,\n.underlay",".asf-newsletter","#adsGross1,\n#adsKlein",".reminder-modal",".ab-feature-popup",".pn-header",".newslettereinblendung","#nl_block",".c-oembed","#newsletter-flyout",".form-newsletter-subscription",".info",".margin-subscribe","#subscribe-form",".block-sam-newsletter-popup",".vert-subscribe-aside",".article-newsletter-bottom-toolbar",".d-flex.news-info-block__sharing",".subscribe-wrapper",".blog-subscribe",".c-post__blog-sign-up",".sticky-popup,\n.welcome-popup",".misinfo-banner",".webform-submission-form",".ma-subscribe-form",".newsletter_form","#sticky",".mailinglist-form",".email-newsletter_outer__7vgF9",".block-cidrap-persistent-newsletter",".hnf-container-fluid",".article-subscribe",".modalbg",".ue-l-article__newsletter-widget","#nlt_signup_botton_desktop",".subs_box",".subscribe-container",".register-newsletter",".suscribete",".block-views-blocknewsletter-block-3","[class^=\"san_howtowhitelist_\"]",".blockingOverlay",".gDiv",".pb-8","#fm-pu-container",".subscribe-cta-block","center[style=\"margin-bottom: 2px;\"]","[data-testid=\"in-house-ad-climatetech\"]","#mailsignup",".optin-form",".s-footer__newsletter","div[style*=\"position: fixed; width: 100%;\"]",".newsletter-popup-elements","[class^=\"Dialogue__Overlay-tmcl\"]",".subscribe-newsletter_wrapper","#text-61",".item.sidebar.reader-comp.main-gray-bg:has(a[href=\"/tilaa-moottorin-uutiskirje/\"])","#ctl00_verkkolehdenmainos,\n.in.fade.modal-backdrop",".smm-newsletter","#wpfront-notification-bar-spacer",".hustle-popup","a[href=\"https://uutiskirje.valitutpalat.fi\"]",".hs-form-private","#liner-notes","#overlay:not(.overlay)","#spb-block-popinnewsletter",".isg-shared-banner-popin,\n.mrk-footer-newsletter",".pmcInsert",".casting-card-subscribe-newsletter","#bloc_newsletter_bas,\n#newsletter_box",".r-1ups-description","app-newsletter",".doc-newsletter-banner-wrapper",".bandeau-abo-nl","#newsletter-container + #legal-terms",".NewsletterForm",".nl-block",".content-banner-nl,\n.o-optin-newsletter",".nlregister",".registration-banner__bg",".popup--newsletter","#articleFormNL",".nl-article-card",".nl-form-inscription",".PromoFooter,\n.User-subscription-form",".subscribe-nl",".widget-first",".NewsletterBox",".nl-social",".o-modal",".bp14_recevoirannonces","#popup_actu",".nwsBlock",".relance-newsletter",".vi-newsletter-subscribe__content",".fullwidth,\n.widget-advert","#block-block-newsletter3-block-newsletter3","[class^=\"ArchonLayout_containerSidebar\"]:has(> [class^=\"Advertisements\"]),\n[class^=\"ArchonLayout_stickyFooterAd\"]","#ad-blocker-nudge,\n.items-right-square,\n.remove-turtles","#onePassportModal,\n#onePassportOverlay",".adfree-banner,\n.adfree-td","[class*=\"AdContainer\"],\ndiv[class^=\"css-feed\"] > div.chakra-stack",".premium-top-banner-container",".uni-newsletter-toast","#ag-newsletter",".uscb-container-foreground,\n.uscb-email-subscription","#GD-snippet-form","div#unsupportedBrowser",".text-center.bg-gray-light",".newsletter-subscribe-block-container",".usa-sign-up",".bottomcta-wrapper",".newsletter-popup-overlay","#theMarketer-popup-backdrop",".wrap-banner",".widget_et_ads",".subscribox",".oes-hbs-dedicated-article,\n.oes-hbs-sticky-bar",".flex.bg-gray-900.pt-12",".c-margin-top-m.ct-div-block,\n.ct-link-text","#bp_piano_homepage_newsletter_container",".separator-newsletter-redesign",".subscriptions",".quick_subscribe",".email-marketing-embed",".aside_subscribe",".newsletter-subscribe",".newsletter_head,\n.page_lb_mask",".bottom-right-subscribe","#ad_blocker_detect_dialog,\n.advert-panel,\n.exit-window-modal,\n.info-container2",".gd-newsletter-subscribe-box-outer,\n.gd-newsletter-subscribe-container",".n13_foot_subscribe",".simple-popup-blocks-global",".newsletter-sub-fixed",".py-8.bg-gradient",".sidebar_right_bottom,\n.sidebar_right_top","#custom_html-1203,\n.interscroller-wrapper[style^=\"height: 700px; \"],\ndiv[style=\"min-height: 300px;\"]",".tni-newsletterModal",".email-optin-widget",".menu_ad1Box",".placeholder",".disable-prompt-header","[href=\"https://www.hackster.io/newsletter/sign_up\"]","#gwvideo",".header-carbon","#ad_block_reminder_dialog","._subscribe_pm84d_312",".mt-1.mb-1.text-center",".Section-module-isBrief_subscription",".mainMenuAdBox",".subsciption",".framer-2ydke7-container","#subscribe-embed","#moneySquare",".basic_mailchimp_widget","#tns-frontpage-newsletter,\n#tns-post-newsletter","#moneyMakerHolder","#mm-skin-over",".news-signup-container","div.rounded-0.alert-info.alert:nth-of-type(1)","a[href=\"/iscriviti-alla-newsletter\"]","abbo-newsletter",".nl-bottom-content","div[class^=\"BoxNewsletter_\"],\ndiv[class^=\"ModalNewsletter_\"]",".custom-newsletter-container","#subscription-form",".box-hebdo",".MuiDialog-container",".mailpoet_form_popup",".form-newsletter-wrapper","#box_newsletter",".newslettercta",".article-footer",".tuplus-newsletter","#footernews,\n.dialog-lightbox-message",".xnc-form-general__container","a[title=\"Newsletter\"]",".nl",".boxNewsletterArticle-BUON",".ma_div",".elementor-element-7c001dd6","#frm-mltchnl","#footer-nl-form","#weekly_newsletter,\n.cta_nl_ext_container",".bottom-article",".exitpopup-modal-window","#newsletter-footer-form",".box-nl",".RegNewsletterBox",".nl-signup-frm","#hs-interactives-modal-overlay",".email-container-footer",".essb-subscribe-form","#splioNewsFooter","#iqitpopup,\n#iqitpopup-overlay",".box_newsletter",".vb-magazine-newsletter","#dynamic-react-root + div:has(> div.needsclick input[id^=\"email_\"])","#jsiModalOverLayerShare,\n.md-question.js-modal-window",".blockOverlay",".p-article-mail",".mailbtn",".popup-mailmaga",".meter","#js-sticky-footer,\n.gap-12 > .bg-surface-secondary.p-4.lg\\:flex-col",".l-header__subscribe","#mc_embed_signup_bar,\n.pop-up-content",".suscribevertical",".newsletterPopupBtn",".flex-block-11",".widget-page__banner",".mc-embed",".header__cta,\n.sidebar__widget--newsletter","#lock_pre_desc","#newsletterAlDespertar","#suscribe",".widgetMC",".block-ao-activecampaign",".ng-star-inserted.sign-up-box",".bilten-signup","#bottombanner,\n#header > .wrapper > [class],\n.cc-banner,\n.hostBtn",".Popup-popup-T3F,\n[class*=\"Search-contentBlocker-\"]",".premodal-share","#article-signup-wrap",".echobox-subscribe-1",".hljs-button.signin","#submitForm",".get-updates,\n.pane-mailchimp-signup-ei-readers",".elementor-element-b0ed665",".newslatter-s",".wrapallwowpopup","[id^=\"reklamy\"]","div[id^=\"donate\"]","#SUBSCRIBE",".experience-commerce_assets-AdvanceTextEditor,\n.top-header-banner",".iib-signup",".afterpost.text_box",".sidebar-signup",".wp-block-id-newsletter",".metanewsletter",".itd-nl-box",".ulp-window-container",".wp-image-9836","#addBlockModal",".article-embedded-newsletter-form,\n.hp-newsletter-form",".red.b.center.mute",".sharepost","#ms-newsletter-2","[style^=\"display: flex; align-items: center; justify-content: center;\"]",".promo-container",".in-article-signupbox",".category-bar,\n[class^=\"sp_veil\"],\n[id^=\"sp_message_panel_id\"]","#topic-notification-signup-box","#top-donation-banner,\n.donation-cta-contentbottom,\n.donation-cta-contenttop,\n.sidebar--banner",".notices","#blog-subscription-form",".previewPageSubscribe,\n.subscribeForEmail","#noty_bottom_layout_container",".textwidget","#blocked-results-banner",".signup-area",".tdm-popup-modal-over-screen",".home-sidebar-signup",".footer__heading","#unit_a_cont",".exit_intent_pop_up-0-2-2,\n[class^=\"mobile_newsletter_\"],\n[id^=\"SubscriptionBox-react-component-\"]",".after-post",".tb-newsletter",".floating-newsletter","#text-10,\n#text-9",".outer-grid-container","#warning-content",".adaptive","#SubscribeForm",".elementor-element-20eaf3b",".has-blue-grey-very-light-background-color",".footer-daily-drop","small","#header-subscribe-button,\n#homepage-fixed-signup",".gh-header",".js-esend-user",".ctct_form-2","#ays_tooltip",".c-footer-subscribe",".newsletter-forms",".component__newsletter",".mnl-signup",".bg-lichtgrijs.p-6.md\\:py-8.lg\\:py-12.rounded-br-2xl.lg\\:rounded-br-3xl.sm\\:mx-auto.sm\\:max-w-lg.md\\:max-w-xl.lg\\:max-w-3xl.xl\\:max-w-4xl",".footer__blocks__newsletter","#ctl00_ctl00_NewsletterFooter_UpdateForm",".aanmelden",".modal-exit-intent","#adholderContainerHeader","#overlay-container",".sidebar-basedriver,\n.wpbd-form","[id^=\"newsletter_\"]",".news-banner",".email-grid-item",".email_newsletter","#mp-popupwrapper1",".signup-promo","#wa_web_headertofloor,\ndiv.commercial_space",".nieuwsbrief",".e1w9k0qi0",".block-cta__subscribe","div[class*=\"newsletter_content-side_\"]","#ctl00_ctl00_footer_newsletter_UpdateForm",".blocksub","#ctl00_Newsletter_UpdateForm",".ct_footer_nieuwsbrief",".single_post_sub_form",".newsletter-subscription-widget",".call-to-action__container",".widget-news-letter-subscribe",".rh-footer-newsletter",".newsletter-fullwidth",".PopupNewsletter_popup__y9HPO",".widget_budgetmailer_widget_subscribe",".newsletterform","#ctl00_ctl00_newsletter_UpdateForm,\n#ctl00_newsletter_UpdateForm","#reusableblockswidget-16","#reusableblockswidget-9",".UI_Newsletter_container",".mm-popup-wrapper","#formNewsletterFooter",".news",".gkDSfm",".signup-bar",".newsLetterSignupWrapper",".s-popup",".tw-text-white.tw-bg-gray-900","._w-classic-ad-div,\n.modal-subscribe",".frm_form_fields",".container-news-sub",".main-footer__subscribe",".wufoo-form-container","#signup-component",".newsletter-nag-modal",".ArticleAttribution","#block-24",".c-promo",".email-boost",".curtain",".wkwp-login-block",".ply-backdrop","#modal-adblocker, .in.fade.modal-backdrop",".open-js-modal-full",".modal-background",".modal-newsletterModal",".ccc__newsline__models__newslinenewslettersignupcontentblock",".infgraphicsAttach",".td_block_template_18",".sidebar-promo--newsletter",".uxdia-c-widget--newsletter",".wp-popup",".floating-action-wrapper,\n.has-background-yellow",".Button_button__dSklw,\n.NewsletterCTA_inner__8UZPJ",".marketo-form-block","#block-webform,\n.block-cta-block,\n.region-footer-third",".newsletter__wrapper___14iH8",".supplement",".NewsletterForm_container__CWjyJ",".signUp",".signup2","#corner-slider",".banner-fixed",".actionbox",".email-callout",".ac-mkto-form",".footer-social-column",".wp-block-lede-common-newsletter",".astra-advanced-hook-7207",".signup_card",".slide-in",".emailrightcol","#subscribe_container",".signup-embed","[data-block=\"newsletter\"]",".newsletter-form-article",".chd-defender__sign-up",".hp_signup__container,\n.site-header__secondary-nav",".m_newsletter-container","#interContainer,\n#interVeil",".ml-embedded",".black_newsletter,\n.popup--backdrop",".signupprint",".freestar-placement","#mtExitModalPopup,\n#yeGivingTuesAlertContainer,\n.cda-newsletter","#coWondersWrapper,\n.block-pym,\n.legacy-newsletter",".main-footer",".dm-sign-form-wapper",".elementor-element-85562d2",".module-fixed-sign-up","#daily_digest_modal,\n.daily_digest,\n.home_daily_digest",".earth-widget",".wrapper-anchor-subscribe,\n.wrapper-subscribe-form",".notice",".box","a[href*=\"/subscribe/\"]",".newsletter_popup","#subcribe-nl","#text-39",".lepopup-form",".form-view","#newsletter-block-bottom","#subscribeblock",".article-signup,\n.signup-section","#cboxWrapper",".elementor-element-1922719,\n.elementor-element-241f781c",".gv-mailchimp-form-container",".hp-topper-newsletter,\n.popup-overlay-newsletter-signup",".persistent-banner","#pelcro-app",".block-email-subscription-block","[id*=\"_modal_outer_\"]",".lightbox-popup","#popup-home",".icn-newsletter-block",".page-general__newsletter-btn",".nl-small-cta",".component-daily-update-sticky",".block--newsletter","#newsModel,\n#newsletter-promo-item",".PromoD",".PromoNewsletter",".routes-Site-routes-Post-EmailSignup-__EmailSignup__postEmailSignup,\n[class*=\"modal\"]",".cta_newsletters_explore",".listmonk-form","._slug__donationCard__glcwg,\n.styles_newsletterContainer__8v_OS","#Main_C010_Col00",".gf__widget--subscribe","#media_image-7",".in_frame_sub",".email-footer",".footer-newsletter-col",".modaal-overlay",".show.fade.modal",".c-simple-newsletter-subscribe,\n.c-subscribe-cta","#wbounce-modal",".myc-subscription-form",".footer--upper",".GLSideBarSlider",".subscribe-for-updates","labcoat-promo",".alert-dismissible",".newspack-newsletters-subscribe","#connect","#newsletter-subscribe","#pardotForm","#mc-signup-iframe",".bg-navylightblue.padding-v20",".nav__mag",".c-article-cta__inner-narrow",".container-newsletter-home",".block-ncr-api-emailmarketing",".pb-house-message",".enews,\n.magazine-subscription-popup",".s2-bottom-emailpromo,\n.simple-endofarticleemail,\n.simple-sidebar-emailsignupbox,\ndiv[style^=\"border: 1px dashed #a51c30; color: #333;\"]",".callout-end-of-story-mount-piano-wrap",".homepage-email-icon",".StayConnected",".subscribe__box,\n.subscribe__form-wrapper","#popupModal,\n.attachment-full",".wp-block-prc-block-promo","#action,\n.-gg\\:1.-mb\\:3,\n.footer1-signup","[data-class=\"support-us__wrapper\"]",".signup-ad",".newsletter-nav","#block-newsletterlink-2",".exit-modal__shade,\n.homepage__top-grid__newsletter",".subscribe__style-6",".elementor-element-578e5f5","a[href=\"#newsletter\"]",".block--homepage-newsletter,\n.inline-newsletter",".comp-subscribe",".header__top",".banner-wrapper",".paragraph--type--newsletter","#block-nieuwsbriefblok",".news-article-content-aside__webinar-alerts",".shi-subscribe","#zephr-user-form-root,\n.zephr-form-container",".shvertise-banner",".subscribe-tile","[class^=\"widget-resources_\"]",".email-signup-widget",".ga\\:component\\:main\\:homepage\\:midpage\\:tout,\n.ga\\:component\\:main\\:sidebar\\:rail-newsletter,\n.ga\\:component\\:main\\:sidebar\\:top\\:promo-image","#homepage-email-2024",".txo-newsletter__outer",".c-featured-series__newsletter,\n.c-plugin--flush > .c-plugin__inner,\n.c-sign-up","#toaster_banner,\n.cta_snippet","#newsletter-homepage-right",".infobox-icon-above-title","#firefly-poll-container,\n.tgp-ic-subscribe-box",".subscribe-sticky",".widget_brainpickings_newsletter_midweek_vertical_widget,\n.widget_brainpickings_newsletter_vertical_widget",".cta--subscribe,\n.promotion--newsletter",".email-signup-v2-js,\n.post-footer-subscribe-promo,\n.toast-notifications-container",".mdl-fixed-informer,\n.mdl-section-subscribe,\n.tml-in-content-block--subscribe",".signup-cta,\n.support-cta",".rail-enews",".mui-style-19k9qdy",".widget_text","#newsletter__sticky,\n.js-newsletter--expand,\n.newsletter__bg,\n.newsletter__block,\n.newsletter__header","#subscribe-modal,\n.section-callout-newsletter",".has-background.homepage-posts__style-7","#req_login_reg_interrupt,\n#window_overlay",".shop-promo",".Campaign__innerWrapper,\n.WallOfLinks_actions__cAUTE","#toplink",".NewsletterSubscribe,\n.PromoCard",".button-floating",".promo-block",".fajardo-campaign",".node-banner","#ad-top-dsk,\n.adx1",".newsletter-post","#newsletterOnline-68",".box-adv",".box-newsletter-lp","#adblocker",".popupNewsletter",".t-s18-i",".newsletter-subscription-form",".t-footer-nl",".obs-cta",".t-d6-nl-1",".fusion-builder-row-5","#block-23",".nl-content,\n.sidebar-nl",".subscribers-area",".text-warning",".klima-subscribe",".subscribe_popup,\n.subscribe_wid",".journal-subscribe","[href=\"/bulletin\"]",".subscribe-sec","#signup-wrapper","#NewsletterPopup-newsletter-popup",".NewsletterSignup_wrapper__rmf2c",".e_newsletters","[href=\"https://github.com/easylist/easylist/issues\"]",".box-mail-chimp",".popup_bg",".alert-errors.in.fade.alert",".totally-not-an-ad",".jw-reset.jw-error",".kanews-banner",".com-onboarding-OnboardingModalContainerView--enter-done",".newsletter-page","#text-43",".aviso",".footer--signup","ticker-subscription",".np_signup_container",".mail-subscribe-user",".bn-subscribe,\n.coronavirus_subscribe",".social-signup--container",".block-custom-mailchimp-subscription",".modular-footer-socials",".main-sign-up",".main-footer-sub","#abandonednewsletter",".subscribe1",".mail-best-v2-wrapper_1jvCah-U,\n.newsletter-modal-shopping,\n.newsletter-sign-up_2K2O1Qev",".digital-download-wrapper",".footer-newsletterTop",".dfp-ad,\n.mar-block-ad",".c-infobar-wrapper",".contact-box--article",".jsFixedMessage","#news",".promotional-modal-container",".sendysubscribe","#article-im-prompt,\n#footerPrompt,\n.tp-active",".inews__email-signup,\n.inews__masthead",".styles_DesktopBottomBarSubscriptionForm_21C_s",".modal-window,\n.new-nl-popup","#alert-box-multiple,\n#alert-footer-div",".button-wrap-large",".lr-newsletter-sidebar",".c-modal--newsletter","#info-popup-overlay,\n#voucher-request-popup",".sidebar_nl",".metro-email-signup,\n.metro-email-signup-mpu,\n.newsletter-end-card,\n.spot-im-spotlight",".email__toaster-component",".wrapNewsletterFooter","#po-inline-article-above","#lootly-widget",".NewsletterSignup_wrapper__mTmqu",".subscribe-popup-container","#before-the-content-hook-1",".newsletter-inner-container",".background--dark,\n.ub-emb-container","#ajaxNewsletter",".section--blue.section,\n.subscription-popup",".popupwrapper",".gform_fields",".js-rewards-promo-float",".sc-hLwbiq.htYiK,\n.tnqeQ",".css-17zlb8c",".martech-newsletter-unit",".tls-newsletter__block",".add_slot_header","._lpSurveyEmbed","[data-newsletter]","#onExit",".oxy-modal-backdrop",".ToolSignpost__container--1h2Ap",".front-newsletter",".footer__mailing","#newsletter-blob",".promotion-messages",".listings_sign_up",".h-newslatter--newsletter",".subscribe-section-container",".stay_connected",".speedbump-in-article",".move-social__inner","section[data-testid=\"newsletter-section\"]","#widgetNewsHolder,\n.nsl-form-container",".teaser__shoulder-banner--newsletter","#danger_adblock",".top-subscribe",".newsletter-subscription-cta-wrapper","#register-popup-backdrop,\n.register-modal-popup-wrapper",".mailer-signup-sidebar",".mk-subscribe-link","#omnisend-form-6374e71bfb02cc636d393258",".sc-kkGfuU.ufUAH",".subscribe-input-box,\n.v-alert","#mc_embed_signup1,\n#overlayPromo,\n.markets-widget,\n.markets-widget-content",".feed-newsletter",".css-16esypq","#steadyAdblockContainer","#text-37","#itro_opaco,\n#itro_popup","#omnisend-form-63c2e367547ff69603390250-submit-form,\n.emthemesModez-footer-newsletter",".top-newsletter",".subswrapper","#subscribeWrapper","#fde_bar"];

const hostnamesMap = new Map([["spielspiele.de",0],["infotel.ca",5],["cryptonews.com",5],["glasses.com",[5,1039]],["pv-magazine-australia.com",[5,6]],["pv-magazine-brasil.com",[5,6]],["pv-magazine-latam.com",[5,6]],["pv-magazine-mexico.com",[5,6]],["pv-magazine-usa.com",[5,6,83]],["saluhallmarket.com",[5,6,1189]],["thejc.com",[5,1912]],["bandt.com.au",[6,47]],["underarmour.com.au",[6,117]],["underarmour.com.br",[6,117]],["factorydirect.ca",[6,198]],["frontrunners.ca",[6,47]],["journeys.ca",[6,212]],["niagarafallsreview.ca",[6,224]],["stcatharinesstandard.ca",[6,224]],["trutone.ca",[6,47]],["underarmour.ca",[6,117]],["wellandtribune.ca",[6,224]],["underarmour.cl",[6,117]],["thecradle.co",[6,47,303]],["tinysociety.co",[6,47]],["abeka.com",[6,340]],["artnet.com",[6,47]],["artstation.com",[6,444]],["atlasobscura.com",[6,460,461]],["ba-bamail.com",[6,47,483]],["babylonbee.com",[6,485,486]],["bankbazaar.com",[6,494]],["baybloorradio.com",[6,47]],["bellhelmets.com",[6,47]],["bibleportal.com",[6,47]],["bongino.com",[6,47,562]],["boredpanda.com",[6,47,569]],["breakingdefense.com",[6,23,579]],["dailytarheel.com",[6,778]],["dgmlive.com",[6,47]],["dollartree.com",[6,833]],["drinkfreshjuice.com",[6,844]],["fermatslibrary.com",[6,47]],["freshbooks.com",[6,996]],["geopoliticalmonitor.com",[6,1030]],["groundies.com",[6,1063]],["humanevents.com",[6,47]],["idsnews.com",[6,1155]],["insauga.com",[6,47,1173]],["lensculture.com",[6,47]],["littleburgundyshoes.com",[6,1303]],["lull.com",[6,47]],["mbt-store.com",[6,1342]],["media4growth.com",[6,47,1350]],["www.microsoft.com",[6,1374]],["moneycontrol.com",[6,47,1398]],["moroccoworldnews.com",[6,47,1406]],["nordvpn.com",[6,1482]],["nycgo.com",[6,47]],["omr.com",[6,1517]],["otterbox.com",[6,47,1537]],["patch.com",[6,47,1551]],["poolsupplies.com",6],["prompthero.com",[6,1602]],["publish0x.com",[6,1609]],["pulseuniform.com",[6,47,1611]],["pv-magazine.com",[6,813]],["www.razer.com",[6,1634]],["saksfifthavenue.com",[6,47,1685]],["scottishlegal.com",[6,1703]],["staradvertiser.com",[6,945,1774]],["szucstermekek.com",[6,47]],["thepeterboroughexaminer.com",[6,224]],["thepostmillennial.com",[6,47,1930]],["therecord.com",[6,224,424]],["thespec.com",[6,224]],["thestar.com",[6,1937]],["uinterview.com",[6,47,2018]],["underarmour.com",[6,117]],["vegnews.com",[6,47]],["wafuu.com",[6,2064]],["wateronline.com",[6,47,2076]],["worlddogfinder.com",[6,47]],["zorbabooks.com",[6,47]],["zumub.com",[6,47]],["underarmour.de",[6,117]],["underarmour.es",[6,117]],["trucksbook.eu",6],["underarmour.eu",[6,117]],["underarmour.fr",[6,117]],["de-santis.it",[6,47]],["underarmour.it",[6,117]],["underarmour.com.mx",[6,117]],["underarmour.com.my",[6,117]],["cataz.net",[6,2392]],["liga.net",[6,2413]],["bolddata.nl",[6,2461]],["underarmour.nl",[6,117]],["apotekfordeg.no",[6,264]],["ballantynes.co.nz",[6,647]],["bizpromo.co.nz",[6,47]],["drinkspy.co.nz",6],["mightyape.co.nz",[6,2507]],["protel.co.nz",6],["underarmour.co.nz",[6,117]],["knowablemagazine.org",[6,47,2592]],["shop.pbs.org",[6,47]],["projectcbd.org",[6,47]],["fruugo.co.uk",[6,47]],["pbsamerica.co.uk",[6,47]],["md5hashing.net",[8,2415]],["aerotime.aero",[10,11]],["mysteriesrunsolved.com",[10,11]],["justgeek.fr",10],["macmagazine.com.br",11],["foreigndesknews.com",[11,978]],["hackread.com",[11,978]],["autonomous.ai",12],["stability.ai",13],["recoveryguru.com.au",13],["brucelee.com",13],["clereviewofbooks.com",13],["fridaythings.com",[13,999]],["genelmag.com",13],["myvetcandy.com",13],["ooshtush.com",13],["paleofuture.com",13],["rgmwatches.com",13],["unifiedpatents.com",13],["worldofreel.com",13],["eli.org.nz",13],["jphs.org",13],["rai.ac.uk",13],["bancone.co.uk",13],["bodyweightwarrior.co.uk",13],["unremarkable.ai",14],["armradio.am",15],["expansao.co.ao",16],["randaris.app",17],["thecompanion.app",18],["evinfocus.com",[18,287,910]],["kyivindependent.com",[18,1261]],["readtangle.com",[18,910,1636]],["eleconomista.com.ar",19],["lacapital.com.ar",20],["metrotime.be",20],["aheadofthyme.com",[20,368]],["alreporter.com",20],["americanmilitarynews.com",[20,406]],["appleinsider.com",20],["austindailyherald.com",20],["benwajdi.com",20],["biznews.com",[20,545,546]],["bowenislandundercurrent.com",20],["burelfactory.com",20],["burnabynow.com",20],["californiasunday.com",20],["capitolhillseattle.com",20],["caribjournal.com",[20,397,620]],["chinafile.com",20],["churchmilitant.com",[20,662]],["cinainitalia.com",20],["circuitdigest.com",20],["convertingcolors.com",20],["cppstories.com",20],["culturemap.com",[20,761]],["dailyfreepress.com",20],["delta-optimist.com",20],["ebar.com",[20,865]],["exstreamist.com",20],["firstpost.com",20],["funcheap.com",20],["ghafla.com",[20,1035]],["howlermagazine.com",20],["idropnews.com",[20,1153,1154]],["informagiovani-italia.com",20],["itm.com",20],["jweekly.com",20],["kyivpost.com",20],["lapatilla.com",20],["lascimmiapensa.com",20],["leoweekly.com",20],["magnoliastatelive.com",20],["majorgeeks.com",20],["midhudsonnews.com",20],["newsshooter.com",20],["newzimbabwe.com",20],["nextbigfuture.com",20],["nsnews.com",20],["ny1.com",[20,565,1498]],["onorient.com",20],["pcgamesn.com",20],["planetware.com",20],["playstationbit.com",20],["politifact.com",[20,1586]],["portlandmercury.com",20],["prescouter.com",[20,159]],["punchng.com",20],["redandblack.com",20],["richmond-news.com",20],["russia-insider.com",20],["sciencealert.com",20],["sociologicalscience.com",20],["thedrinknation.com",[20,25]],["thegrayzone.com",20],["theloadout.com",20],["thespacereview.com",20],["thestandnews.com",20],["thestranger.com",20],["thethaiger.com",20],["tricitynews.com",20],["union-bulletin.com",20],["wayfm.com",20],["winedharma.com",20],["gamereactor.dk",20],["engineering.columbia.edu",20],["gamereactor.es",20],["gamereactor.eu",20],["demokraatti.fi",20],["gamereactor.fi",20],["gamereactor.fr",20],["publinews.gt",20],["dv.is",20],["grapevine.is",20],["agenziaimpress.it",20],["davidemaggio.it",20],["ilfarosulmondo.it",20],["ilprimatonazionale.it",20],["meteonetwork.it",20],["moked.it",20],["money.it",20],["pallacanestrotrieste.it",20],["pharmacyscanner.it",20],["techzilla.it",20],["tvsvizzera.it",20],["vvox.it",20],["businessinsider.mx",20],["thestar.com.my",20],["francescocosta.net",20],["indiaclimatedialogue.net",20],["ticotimes.net",20],["volkskrant.nl",[20,129]],["gamereactor.no",20],["resett.no",20],["scoop.co.nz",20],["cjr.org",[20,32,2552]],["current.org",20],["iihs.org",20],["iowapublicradio.org",20],["sfpublicpress.org",20],["worldhistory.org",20],["wpr.org",20],["dailytimes.com.pk",20],["kliknijwzdrowie.pl",20],["gamereactor.se",20],["trancentral.tv",20],["news.virginmediao2.co.uk",20],["mg.co.za",20],["lanacion.com.ar",21],["christiantoday.com",[21,299,656,657]],["letrap.com.ar",22],["ambito.com",22],["intego.com",[22,1184]],["news24.com",[22,1455]],["phonearena.com",22],["sundayworld.com",[22,1795]],["recepty.cz",22],["deutschland.de",22],["discover.lanl.gov",22],["elfinanciero.com.mx",22],["alarabiya.net",22],["noticiargentina.com.ar",23],["notibolivia.bo",23],["notichile.cl",23],["colombiapress.co",23],["deadline.com",23],["insideevs.com",[23,1174,1175]],["mlbtraderumors.com",23],["motor1.com",[23,238,1174]],["notiecuador.com.ec",23],["deghi.it",23],["notimexico.com.mx",23],["poresto.net",23],["notipanama.com.pa",23],["notiperu.com.pe",23],["notiparaguay.com.py",23],["notiuruguay.uy",23],["tn.com.ar",24],["voydeviaje.com.ar",25],["kleinezeitung.at",25],["profil.at",25],["crazysales.com.au",[25,57]],["essentialbaby.com.au",25],["essentialkids.com.au",25],["goodfood.com.au",25],["ozbargain.com.au",[25,90]],["taste.com.au",25],["goodbye.be",25],["voetbalnieuws.be",25],["administradores.com.br",25],["bitmag.com.br",25],["estadao.com.br",25],["estrelando.com.br",25],["fdr.com.br",25],["imasters.com.br",25],["jornaldebrasilia.com.br",25],["omelete.com.br",25],["pinkluna.com.br",25],["portalinsights.com.br",25],["verdesmares.com.br",25],["cdt.ch",25],["elmostrador.cl",25],["capx.co",[25,44]],["tasty.co",25],["2gb.com",25],["a2zphoneselectronics.com",25],["aawsat.com",[25,32]],["addictivetips.com",[25,84]],["adventures.com",25],["airqualitynews.com",25],["aiscoop.com",[25,376]],["alattefood.com",25],["aldianews.com",25],["algemeiner.com",[25,383]],["antlionaudio.com",25],["apracticalwedding.com",25],["arab24.com",25],["arcade1up.com",[25,430]],["arsenalinsider.com",25],["artnews.com",25],["asteriskmag.com",[25,457]],["atimes.com",25],["atlantadailyworld.com",25],["autoguide.com",25],["automotive-fleet.com",25],["basketinside.com",25],["bestlifeonline.com",[25,520]],["bigmammagroup.com",25],["billboard.com",25],["biometricupdate.com",25],["boerse-express.com",25],["bostonglobe.com",25],["bostonmagazine.com",25],["brooklynbased.com",25],["businessfleet.com",25],["carolinajournal.com",25],["chicagodefender.com",25],["clubic.com",[25,684]],["cnn.com",[25,690,691]],["comicsands.com",[25,712]],["completesportsnigeria.com",25],["condominioweb.com",25],["corsedimoto.com",25],["crn.com",[25,746]],["cronista.com",25],["cuisineetvinsdefrance.com",25],["cyberscoop.com",[25,376]],["dazeddigital.com",25],["defensescoop.com",[25,376]],["deichmann.com",25],["denofgeek.com",25],["diepresse.com",[25,815]],["digiday.com",25],["dirt.com",25],["discoverymedia.com",25],["ditano.com",[25,826]],["dojacat.com",25],["dreambigtravelfarblog.com",[25,838,839]],["edscoop.com",[25,376]],["electroeshop.com",25],["electronicsweekly.com",[25,70]],["enstarz.com",25],["epicurious.com",25],["etonline.com",[25,901]],["euractiv.com",25],["everymarket.com",25],["familyhandyman.com",25],["fandom.com",25],["fantamagazine.com",25],["fashionotes.com",25],["fedscoop.com",[25,376]],["fleetfinancials.com",25],["focusardegna.com",25],["forbesafrica.com",25],["futura-sciences.com",25],["gizchina.com",25],["goodrx.com",[25,1047]],["government-fleet.com",25],["grandandtoy.com",25],["greatbritishchefs.com",[25,1055]],["greenbot.com",[25,70]],["hannity.com",25],["healthday.com",25],["historic-uk.com",25],["hits973.com",25],["hngn.com",25],["hodinkee.com",25],["hollywoodreporter.com",25],["horse-canada.com",[25,1139]],["huffpost.com",25],["iltascabile.com",25],["infoq.com",[25,55]],["inthesetimes.com",[25,1189]],["investopedia.com",[25,392]],["itechpost.com",[25,1208]],["jdpower.com",25],["jewishjournal.com",[25,700]],["jfrog.com",25],["jornaldocomercio.com",25],["laopinion.com",25],["laprensafl.com",25],["laraza.com",25],["lctmag.com",25],["leitgamhof.com",25],["life.com",25],["livability.com",25],["longislandpress.com",[25,1315]],["madeincucina.com",25],["maritimejobs.com",25],["massivesci.com",25],["metro-magazine.com",25],["michiganchronicle.com",25],["mlb.com",25],["moodiedavittreport.com",25],["motorionline.com",25],["multichannel.com",25],["muscleandfitness.com",25],["mymodernmet.com",[25,1426]],["newbeauty.com",25],["newpittsburghcourier.com",25],["newrepublic.com",[25,1453]],["newsdeeply.com",25],["nofilmschool.com",25],["noticiasrcn.com",25],["out-law.com",25],["passioneinter.com",25],["phillymag.com",[25,77]],["phonandroid.com",[25,648]],["piriform.com",25],["pitchfork.com",25],["pomade.com",25],["psfk.com",25],["qualitymobilevideo.com",25],["quickanddirtytips.com",25],["rainbowplantlife.com",25],["recombu.com",25],["redsharknews.com",25],["reynardsec.com",25],["roguefitness.com",25],["rollingstone.com",25],["salon.com",[25,1688]],["sapstjean.com",25],["saucemagazine.com",25],["scarpescarpestore.com",25],["schoolbusfleet.com",25],["screencrush.com",25],["servers4less.com",25],["servus.com",25],["sheknows.com",25],["skyairline.com",25],["slashfilm.com",25],["sourcingjournal.com",25],["speedcafe.com",25],["sportico.com",[25,1764]],["spy.com",25],["startpage.com",25],["statescoop.com",[25,376]],["surfer.com",25],["surveillance-video.com",25],["tasteofhome.com",[25,1812]],["techbeat.com",25],["technologygalaxy.com",25],["teksavvy.com",25],["tenniscircus.com",25],["thawrah2day.com",25],["the-decoder.com",25],["theblaze.com",[25,803,1862]],["thedp.com",25],["themeshreport.com",25],["thenevadaindependent.com",25],["theodysseyonline.com",25],["thepointsguy.com",[25,1929]],["thetruthaboutcars.com",[25,32,1942]],["thewolseley.com",25],["time.com",[25,1959]],["timesofisrael.com",[25,1965]],["topdocumentaryfilms.com",25],["toutelanutrition.com",[25,1986]],["travelweekly.com",25],["tech.trivago.com",25],["truckinginfo.com",25],["truthdig.com",[25,2000]],["tuasaude.com",25],["tvquran.com",25],["twitchy.com",25],["undercurrentnews.com",25],["unsolved.com",25],["usatoday.com",[25,1162,2030]],["mmajunkie.usatoday.com",25],["variety.com",25],["vibe.com",25],["videogamer.com",25],["violanews.com",25],["vtvgujarati.com",25],["welivesecurity.com",[25,2085]],["wgnamerica.com",25],["wikihow.com",[25,2094]],["wikitribune.com",25],["wizworkwear.com",25],["workscoop.com",25],["worktruckonline.com",25],["wwd.com",[25,2111]],["4investors.de",25],["airliners.de",25],["alexander-wallasch.de",25],["delamar.de",25],["euractiv.de",25],["fliegermagazin.de",25],["silicon.de",[25,2169]],["the-decoder.de",25],["ukraine-nachrichten.de",[25,2176]],["ccmagazine.es",25],["silicon.es",[25,2169,2207]],["juvenews.eu",25],["voxeurop.eu",[25,2219]],["kipparilehti.fi",25],["superfly.fm",25],["francetvinfo.fr",[25,2246,2247]],["lanutrition.fr",25],["trendy.letudiant.fr",25],["offresasaisir.fr",25],["hottopics.ht",25],["atlatszo.hu",25],["ezalenyeg.hu",25],["fmc.hu",25],["israeltoday.co.il",25],["hdwallpapers.in",25],["sangbadpratidin.in",25],["forzaroma.info",25],["madeinbz.info",25],["buoyant.io",25],["01net.it",[25,2330]],["advisoronline.it",25],["astrooroscopo.it",25],["bintmusic.it",25],["bolzano-bozen.it",25],["brindisisera.it",25],["carpicalcionews.it",25],["chiesadimilano.it",25],["cittaceleste.it",25],["digitaleterrestrefacile.it",25],["dissipatio.it",25],["fcinter1908.it",25],["gazzamercato.it",25],["giornaledibrescia.it",[25,2348]],["gogedizioni.it",25],["golssip.it",25],["ilgiorno.it",[25,1459]],["ilmilanista.it",25],["ilposticipo.it",25],["ilrestodelcarlino.it",[25,1459]],["ilsecoloxix.it",25],["itasportpress.it",25],["key4biz.it",25],["lanazione.it",[25,1459]],["legab.it",25],["lescienze.it",25],["libreriascolastica.it",25],["libreriauniversitaria.it",25],["linkiesta.it",25],["lintellettualedissidente.it",[25,32]],["lvh.it",25],["mediagol.it",25],["meteolive.it",25],["mondoudinese.it",25],["numericalcio.it",25],["pianetamilan.it",25],["primainfanzia.it",25],["rivistacontrasti.it",25],["sassuolocalcionews.it",25],["sportavellino.it",25],["swz.it",25],["theitaliantimes.it",25],["thrillercafe.it",25],["tuttobolognaweb.it",25],["valori.it",25],["the-star.co.ke",25],["aeroporto.net",25],["hcb.net",25],["ilsussidiario.net",25],["mcsweeneys.net",25],["nooun.net",25],["pianetagenoa1893.net",25],["quotidiano.net",[25,1459]],["sayrodigital.net",25],["toronews.net",25],["transworld.net",25],["verportugal.net",25],["crypto.news",[25,229]],["oilcity.news",25],["torresette.news",25],["web3wire.news",25],["gooieneemlander.nl",25],["haarlemsdagblad.nl",25],["handdoekentoiletpapier.nl",25],["kippersrijssen.nl",25],["leidschdagblad.nl",25],["nieuwrechts.nl",25],["noordhollandsdagblad.nl",25],["participaties.nl",25],["cheapies.nz",25],["eventfinda.co.nz",25],["clevelandclinic.org",25],["doktersvandewereld.org",25],["goodnet.org",25],["icij.org",[25,2584]],["indypendent.org",25],["kpfa.org",25],["hacks.mozilla.org",25],["nationalinterest.org",[25,2621]],["paidcontent.org",25],["pbs.org",[25,267,2631]],["revealnews.org",25],["sciencemag.org",25],["sfitalianheritage.org",25],["usopen.org",25],["culture.pl",[25,2684]],["bit.pt",25],["cmjornal.pt",25],["dn.pt",25],["jornaldenegocios.pt",25],["record.pt",25],["sabado.pt",25],["sapo.pt",25],["voltaaomundo.pt",25],["evz.ro",25],["ziarulevenimentul.ro",25],["deraktionaer.tv",25],["i24news.tv",25],["padovasport.tv",25],["syria.tv",25],["1stplace4trophies.co.uk",25],["boardgameprices.co.uk",25],["bodybuildingwarehouse.co.uk",25],["coachmag.co.uk",25],["electricfencing.co.uk",25],["maplin.co.uk",25],["muslimnews.co.uk",25],["prospectmagazine.co.uk",25],["silicon.co.uk",[25,2169]],["tuffshop.co.uk",25],["paratimujer.us",25],["thefulcrum.us",[25,712]],["timeslive.co.za",25],["calvinklein.at",26],["calvinklein.be",26],["calvinklein.bg",26],["calvinklein.ch",26],["calvinklein.com",26],["calvinklein.cz",26],["calvinklein.de",26],["calvinklein.dk",26],["calvinklein.ee",26],["calvinklein.es",26],["calvinklein.fi",26],["calvinklein.fr",26],["calvinklein.hr",26],["calvinklein.hu",26],["calvinklein.ie",26],["calvinklein.it",26],["calvinklein.lt",26],["calvinklein.lu",26],["calvinklein.lv",26],["calvinklein.nl",26],["calvinklein.pl",26],["calvinklein.pt",26],["calvinklein.ru",26],["calvinklein.se",26],["calvinklein.si",26],["calvinklein.sk",26],["calvinklein.co.uk",26],["eschuhe.at",27],["obuvki.bg",27],["eschuhe.ch",27],["eobuv.cz",27],["eschuhe.de",27],["zapatos.es",27],["chaussures.fr",27],["epapoutsia.gr",27],["ecipele.hr",27],["ecipo.hu",27],["escarpe.it",27],["eapavi.lv",27],["eobuwie.com.pl",27],["epantofi.ro",27],["eskor.se",27],["eobuv.sk",27],["evzuttya.com.ua",27],["falter.at",28],["krone.at",29],["laendlejob.at",[30,31]],["generalpants.com",[30,31]],["visittopeka.com",30],["audiofilemagazine.com",[31,465]],["modern-banking.at",32],["gardeningaustralia.com.au",32],["getprice.com.au",32],["intersport.com.au",32],["harem69.com.br",32],["mattinonline.ch",32],["7digital.com",32],["alligator-sunglasses.com",32],["bloomberg.com",[32,554,555]],["boldsky.com",32],["download3k.com",32],["drivespark.com",32],["deploy.equinix.com",32],["filmibeat.com",32],["food.com",32],["gainkit.com",32],["gamblingitalia.com",32],["gizbot.com",32],["heraldextra.com",32],["hispantv.com",32],["keshaofficial.com",32],["langenscheidt.com",32],["leseclaireuses.com",32],["mayoclinic.com",32],["movies.com",32],["nativeplanet.com",32],["ohmyrockness.com",32],["oneindia.com",32],["pdfcoffee.com",32],["penny-arcade.com",32],["petroleumservicecompany.com",32],["producebluebook.com",32],["raileurope.com",32],["rivistastudio.com",32],["styleite.com",32],["tennismajors.com",32],["termometropolitico.com",32],["vidaextra.com",32],["modern-banking.de",32],["acento.com.do",32],["acpm.fr",32],["largus.fr",32],["lepoint.fr",32],["misya.info",32],["codefresh.io",32],["agriaffaires.it",32],["atalanta.it",32],["ilfattoalimentare.it",[32,2351]],["lacnews24.it",32],["monitorimmobiliare.it",32],["radiospeaker.it",32],["silhouettedonna.it",32],["soldioggi.it",32],["sscnapoli.it",32],["termometropolitico.it",32],["terranuova.it",32],["valgardena.it",32],["messengernews.net",[32,1385]],["opendemocracy.net",[32,2423]],["salemnews.net",[32,1385]],["telesurtv.net",[32,2438]],["envol-vert.org",[32,1038,1272]],["malwarebytes.org",32],["pewforum.org",32],["publicradio.org",32],["quantamagazine.org",[32,2642]],["scottishrugby.org",32],["wdcb.org",32],["iol.pt",32],["fundatiacaleavictoriei.ro",32],["dailymaverick.co.za",32],["refurbed.at",33],["refurbed.de",33],["refurbed.dk",33],["refurbed.fr",33],["refurbed.ie",33],["refurbed.it",33],["refurbed.nl",33],["refurbed.se",33],["sn.at",34],["teufelaudio.at",35],["teufelaudio.be",35],["teufel.ch",35],["spigen.com",35],["teufelaudio.com",35],["teufel.de",35],["teufelaudio.es",35],["teufelaudio.fr",35],["teufelaudio.it",35],["teufelaudio.nl",35],["tvgids.nl",35],["teufelaudio.pl",35],["thegap.at",36],["thelocal.at",37],["thelocal.ch",37],["thelocal.de",[37,2175]],["thelocal.dk",37],["thelocal.es",[37,2175]],["thelocal.fr",37],["thelocal.it",[37,2175]],["thelocal.no",37],["thelocal.se",37],["vol.at",38],["wheresyoured.at",39],["abc.com.au",40],["allbirds.com.au",41],["allbirds.com",41],["allbirds.co.nz",41],["arb.com.au",42],["australianfrequentflyer.com.au",43],["australiangolfdigest.com.au",44],["thecanary.co",[44,302]],["alexandracooks.com",[44,70]],["artificialintelligence-news.com",[44,439]],["coloradotimesrecorder.com",44],["hypebot.com",44],["moneymagpie.com",[44,246,1399]],["thefreethoughtproject.com",44],["theroyaloakmarylebone.com",44],["thurrott.com",[44,1957]],["fatgirlskinny.net",44],["childrenshealthdefense.org",[44,83,2549]],["matomo.org",[44,2608]],["verdadeiroolhar.pt",44],["australianorganicproducts.com.au",45],["deal4.ca",[45,192]],["unwiredshop.ca",45],["runninwildkids.co",45],["jdstorefashion.com",45],["phyllisdunn93.myshopify.com",45],["pixibow.com",45],["winnerscircle.com",45],["ish.guitars",45],["bodynutritionuk.co.uk",45],["autoaction.com.au",46],["toysrus.ca",[47,247]],["ardene.com",47],["bbcearth.com",47],["biglots.com",47],["fanatics.com",47],["fwrd.com",[47,147]],["history.com",[47,1125,1126]],["kenyabuzz.com",47],["opositiv.com",[47,1527]],["revolve.com",[47,147]],["thebrick.com",[47,941]],["vogue.com",[47,2059]],["tradedepot.co.nz",[47,2517]],["adpri.org",[47,512]],["answear.ua",47],["beautycrew.com.au",48],["broadsheet.com.au",49],["cityam.com",[49,140]],["canberratimes.com.au",50],["theland.com.au",50],["carsales.com.au",51],["carsguide.com.au",52],["chaser.com.au",53],["findingtheuniverse.com",53],["levittownnow.com",53],["serenabakessimplyfromscratch.com",53],["thegazette.com",[53,1897]],["techpolicy.press",53],["chasingcars.com.au",54],["christiantoday.com.au",55],["mamamia.com.au",[55,81]],["newegg.ca",55],["save.ca",[55,233]],["faithpot.com",55],["newegg.com",55],["onmilwaukee.com",55],["blog.oup.com",55],["paloaltonetworks.com",[55,1357]],["theenergymix.com",[55,1884]],["heatmap.news",55],["christiantoday.co.nz",55],["oversixty.co.nz",55],["countryroad.com.au",56],["crikey.com.au",58],["dicksmith.com.au",59],["mattblatt.com.au",59],["kogan.com",59],["dicksmith.co.nz",59],["drive.com.au",60],["examiner.com.au",61],["factoryfast.com.au",62],["orka.ca",62],["pastimesports.ca",62],["a1supplements.com",62],["allyouplay.com",62],["globaleparts.com",62],["jj-motorsports.com",62],["mavigadget.com",62],["myvillagegreen.com",[62,324]],["nevstudio.com",62],["noticethereckless.com",62],["recstuff.com",62],["santiemidwest.com",62],["skinhelpzone.com",62],["thetruthbeautycompany.com",62],["toolsplus.com",62],["orbitgear.net",62],["huskymoto.co.uk",62],["supplementschester.co.uk",62],["snatcher.co.za",[62,2807]],["startmycar.co.za",62],["fantasticfurniture.com.au",63],["forbes.com.au",64],["forkneasy.com.au",65],["hardtofind.com.au",66],["harrisscarfe.com.au",67],["anacondastores.com",67],["spotlightstores.com",67],["i-tech.com.au",68],["ibtimes.com.au",69],["forbestravelguide.com",[69,974]],["westhawaiitoday.com",[69,974,1092]],["gatestoneinstitute.org",[69,2577]],["globalvoices.org",[69,974,2579]],["sinya.com.tw",[69,974]],["ilglobo.com.au",70],["indaily.com.au",[70,71]],["lafiamma.com.au",70],["mumbrella.com.au",[70,84]],["noticiabrasil.net.br",70],["seasonsandsuppers.ca",70],["404media.co",[70,272]],["972mag.com",[70,331,332]],["a-z-animals.com",[70,333,334]],["alhurra.com",70],["attn.com",70],["bamargera.com",70],["bcg.com",[70,504]],["blackagendareport.com",70],["boardingarea.com",70],["broadwayworld.com",[70,588,589]],["cheeserank.com",70],["chicagomag.com",70],["cityandstateny.com",[70,671]],["coincodex.com",[70,701]],["coinspeaker.com",[70,704]],["cointelegraph.com",[70,665,705]],["cybernews.com",70],["defenseone.com",[70,671]],["delishknowledge.com",[70,549,797]],["divascancook.com",70],["downshiftology.com",[70,454,723,836]],["ebayinkblog.com",70],["fcw.com",[70,671]],["foxnews.com",[70,138,986]],["freshersworld.com",70],["fromthegrapevine.com",[70,1003]],["gadgets360.com",70],["gcn.com",[70,671]],["gellerreport.com",70],["gimmesomeoven.com",[70,74]],["govexec.com",[70,1052]],["greece-is.com",70],["healthyseasonalrecipes.com",70],["howsweeteats.com",[70,461]],["hpcwire.com",[70,1143]],["inc-aus.com",70],["irishpost.com",[70,1203]],["jessicainthekitchen.com",70],["jewishinsider.com",[70,1219]],["kitchentreaty.com",[70,1253]],["kristineskitchenblog.com",[70,351]],["littlespicejar.com",[70,549]],["livewellbakeoften.com",70],["melskitchencafe.com",70],["messynessychic.com",70],["miaminewtimes.com",[70,591]],["mouser.com",70],["naij.com",70],["nationalpost.com",[70,409]],["ndtv.com",[70,1441]],["newsmaxtv.com",70],["newsthump.com",70],["nextgov.com",70],["notquitenigella.com",70],["rbth.com",70],["recipetineats.com",[70,1641]],["restaurantguru.com",70],["roadbook.com",[70,1673]],["route-fifty.com",70],["selenagomez.com",70],["stereogum.com",[70,1783,1784]],["tasteandtellblog.com",[70,546]],["ted.com",[70,1837]],["thechunkychef.com",[70,200,670]],["thehighwire.com",70],["thesuburbansoapbox.com",[70,295]],["topflightautomotive.com",70],["tv.com",70],["up.com",70],["venezuelastar.com",70],["viewfromthewing.com",70],["wackymania.com",70],["washingtontechnology.com",[70,671]],["today.ucsd.edu",70],["doordash.engineering",[70,2202]],["defense.gov",70],["android.gs",70],["professionearchitetto.it",70],["damndelicious.net",[70,455,1709]],["naija.ng",70],["jbhifi.co.nz",70],["player.one",70],["al-shabaka.org",70],["artscanvas.org",70],["gotquestions.org",70],["mpr.org",70],["stream.org",70],["dailyfeed.co.uk",70],["briefly.co.za",70],["mygaming.co.za",[70,1600]],["politicsweb.co.za",[70,2804]],["notthebee.com",[71,486,1487]],["nysun.com",[71,1502]],["sfstandard.com",[71,1724]],["spotlightpa.org",[71,410,2656]],["usafacts.org",[71,2673]],["refurbly.se",71],["innovations.com.au",72],["adweek.com",72],["avclub.com",[72,102]],["bloomberglinea.com",72],["chicoer.com",72],["coloradodaily.com",72],["coloradohometownweekly.com",72],["dailybreeze.com",72],["dailybulletin.com",72],["dailycamera.com",72],["dailydemocrat.com",72],["dailynews.com",72],["deadspin.com",72],["denverpost.com",72],["detroitnews.com",72],["dw.com",72],["eastbaytimes.com",72],["eco-business.com",[72,866]],["euobserver.com",[72,188]],["eurweb.com",72],["gizmodo.com",[72,828]],["helpnetsecurity.com",72],["infowars.com",72],["jalopnik.com",[72,1212]],["japantoday.com",72],["jezebel.com",[72,102]],["kake.com",72],["kotaku.com",[72,1212]],["lifehacker.com",72],["lowellsun.com",72],["marinij.com",72],["mendocinobeacon.com",72],["mercurynews.com",[72,1369]],["montereyherald.com",72],["ocregister.com",72],["orovillemr.com",72],["paradisepost.com",72],["pasadenastarnews.com",72],["pe.com",72],["post-gazette.com",72],["presstelegram.com",72],["readingeagle.com",72],["record-bee.com",72],["redbluffdailynews.com",72],["redlandsdailyfacts.com",[72,1646]],["santacruzsentinel.com",72],["scotsman.com",[72,409]],["spokesman.com",[72,1763]],["thereporter.com",72],["theroot.com",72],["thetakeout.com",72],["times-standard.com",72],["timesheraldonline.com",72],["ukiahdailyjournal.com",72],["whittierdailynews.com",72],["willitsnews.com",72],["wsj.com",[72,2108]],["web.dev",72],["corriere.it",72],["stuff.co.nz",72],["pap.pl",72],["telegraph.co.uk",[72,2771]],["investordaily.com.au",[73,74]],["egyptianstreets.com",74],["evonomics.com",[74,912]],["macrumors.com",74],["reductress.com",74],["theawesomer.com",74],["themichiganstar.com",74],["theminnesotasun.com",74],["theohiostar.com",74],["wweek.com",74],["reliefweb.int",74],["dagelijksestandaard.nl",74],["italianluxurygroup.com.au",75],["tweeters.ca",75],["shop.libbey.com",75],["tiedex.co.uk",75],["jbhifi.com.au",76],["karryon.com.au",[77,78]],["digital4.biz",[77,141]],["collato.com",77],["pagamentidigitali.it",[77,141,2360]],["kathmandu.com.au",79],["kathmandu.co.nz",79],["localthreads.com.au",80],["halseymusicstore.com",80],["store.lizzomusic.com",80],["michaelwest.com.au",82],["designersbrasileiros.com.br",82],["dailynewshungary.com",82],["justrunlah.com",82],["nanowerk.com",82],["osxdaily.com",82],["roadiscalling.com",82],["upinthesky.nl",82],["fosspost.org",82],["motoring.com.au",83],["womensagenda.com.au",83],["navyhistory.au",83],["centralmaine.com",83],["sunjournal.com",83],["thecollegefix.com",83],["threatpost.com",83],["trendingpolitics.com",[83,813]],["tylerwoodgroup.com",83],["wvexplorer.com",83],["yellowhammernews.com",83],["euractiv.it",83],["mondoweiss.net",83],["sumptuousliving.net",83],["businessinsider.nl",83],["kusc.org",83],["whoprofits.org",83],["catholicherald.co.uk",83],["additudemag.com",[84,352]],["armytimes.com",84],["biblegateway.com",[84,526]],["biopharmadive.com",84],["gustorestaurants.com",84],["insidehook.com",[84,1176]],["moon.com",84],["motorsportweek.com",84],["tatemcrae.com",84],["theafricareport.com",[84,1853]],["tripstodiscover.com",84],["tubefilter.com",[84,565,2004]],["elie.net",84],["fullfact.org",84],["thecourier.co.uk",84],["reinsurancene.ws",84],["mwave.com.au",85],["applefirmwares.com",85],["mycause.com.au",86],["newsrimini.it",86],["mince.nl",86],["officeworks.com.au",87],["onelifeadventures.com.au",88],["outandaboutwithkids.com.au",89],["ozsale.com.au",91],["popsugar.com.au",92],["matthewball.co",92],["press-start.com.au",93],["primemovermag.com.au",94],["quarterlyessay.com.au",95],["australianforeignaffairs.com",95],["rosmancomputers.com.au",96],["t-shirt.ca",96],["edmfast.com",96],["priceblaze.com",96],["theonlinedrugstore.com",96],["youritdelivered.com",96],["rtrfm.com.au",97],["runningwarehouse.com.au",98],["sbs.com.au",99],["coxautoinc.com",99],["dezeen.com",99],["discogs.com",99],["soft112.com",99],["altreconomia.it",99],["spectator.com.au",100],["spendless.com.au",[101,102]],["advocate.com",[102,360]],["out.com",102],["pastemagazine.com",102],["popsci.com",102],["san.com",[102,188,264,1691]],["splinter.com",102],["weeklyrecess.com",102],["nextplz.fr",102],["sportsgirl.com.au",103],["canadianbestseller.com",[103,615]],["moon-audio.com",103],["mrphone.gr",[103,2283]],["styletread.com.au",104],["styletread.co.nz",104],["supplementwarehouse.com.au",105],["target.com.au",106],["techguide.com.au",[107,108]],["codeur.com",107],["palestinechronicle.com",[107,1546]],["digitalfernsehen.de",107],["templeandwebster.com.au",109],["thegoodguys.com.au",110],["theiconic.com.au",111],["govtech.com",[111,119,372]],["themonthly.com.au",112],["thenewdaily.com.au",113],["thenightly.com.au",114],["thesaturdaypaper.com.au",115],["traveller.com.au",116],["vogue.com.au",118],["who.com.au",119],["clarin.com",119],["governing.com",[119,1051]],["littlewordsproject.com",119],["i-d.vice.com",119],["zavvi.com.au",120],["zavvi.ca",120],["zavvi.cn",120],["cultbeauty.com",120],["lookfantastic.com",120],["myprotein.com",120],["myvitamins.com",120],["thehut.com",120],["zavvi.com",120],["zavvi.de",120],["zavvi.es",120],["zavvi.ie",120],["myprotein.it",120],["zavvi.it",120],["zavvi.nl",120],["cultbeauty.co.uk",120],["cyberdaily.au",121],["unsw.edu.au",122],["sunset.com",122],["abc.net.au",123],["ia.acs.org.au",124],["meetup.com",124],["futurework.org.au",125],["acea.auto",126],["baby.be",127],["beursduivel.be",128],["eurobench.com",128],["belegger.nl",[128,2459]],["debeurs.nl",128],["iexprofs.nl",128],["demorgen.be",129],["parool.nl",129],["trouw.nl",129],["gva.be",130],["nieuwsblad.be",[130,134]],["hagelandactueel.be",131],["leuvenactueel.be",131],["kunstenfestivalwatou.be",132],["funko.com",132],["loungefly.com",132],["truecrimedaily.com",132],["shop.mchobby.be",133],["averiecooks.com",133],["bingehq.com",133],["chocolatecoveredkatie.com",133],["crackberry.com",133],["ifoodreal.com",133],["lexiscleankitchen.com",[133,295,549]],["streamsgeek.com",133],["open.online",133],["carbonbrief.org",133],["dcreport.org",133],["whyy.org",[133,2682]],["rtl.be",135],["sport247.be",136],["thebulletin.be",137],["dnevnik.bg",138],["thecanadianpressnews.ca",138],["appfigures.com",138],["captimes.com",138],["cined.com",[138,663]],["cnnturk.com",138],["frandroid.com",138],["about.gitlab.com",138],["pitcherlist.com",138],["securityaffairs.com",138],["superdeluxeedition.com",[138,229]],["usmagazine.com",138],["visualstudiomagazine.com",138],["wayfairertravel.com",[138,2078]],["wsbtv.com",[138,514]],["challenges.fr",138],["blog.google",[138,2273]],["news247.gr",138],["elsoldemexico.com.mx",138],["carwashpro.nl",[138,1628,2463]],["infrasite.nl",[138,1628,2463]],["omroepmax.nl",138],["rijschoolpro.nl",[138,1628,2463]],["spoorpro.nl",[138,1628,2463]],["tankpro.nl",[138,1628,2463]],["taxipro.nl",[138,1628,2463]],["zelfrijdendvervoer.nl",[138,1628,2463]],["eff.org",138],["aeiou.pt",138],["douglas.bg",139],["news.bg",140],["6sqft.com",[140,328]],["augustman.com",140],["brighteon.com",[140,565,584,585]],["healthboards.com",140],["infosecurity-magazine.com",140],["lifestyleasia.com",140],["livejournal.com",140],["cgsociety.org",140],["noticiasmagazine.pt",140],["alhayat.tv",140],["alquds.co.uk",140],["hagerty.co.uk",[140,2739]],["blog.plerion.com",141],["zaui.com",141],["offshore-energy.biz",142],["photoshop-online.biz",143],["pocketgamer.biz",144],["bucketlistly.blog",[145,146,147]],["moovitapp.com",[145,1404]],["disconnect.blog",[148,149]],["therage.co",[148,307]],["broadbandbreakfast.com",[148,272]],["platformer.news",[148,150,307,849,1792,2449]],["dkb.blog",150],["moreisdifferent.blog",150],["noahpinion.blog",150],["forkingpaths.co",150],["publicnotice.co",150],["sambowman.co",150],["afterbabel.com",150],["aisnakeoil.com",150],["antiracismnewsletter.com",150],["aporiamagazine.com",150],["asiasentinel.com",150],["newsletter.banklesshq.com",150],["blog.codingconfessions.com",150],["computerenhance.com",150],["construction-physics.com",150],["duffelblog.com",[150,849]],["newsletter.eng-leadership.com",150],["eugyppius.com",150],["experimental-history.com",150],["friendlyatheist.com",[150,1000]],["fullstackeconomics.com",150],["goto10retro.com",150],["hamiltonnolan.com",[150,887]],["honest-broker.com",150],["newsletter.maartengrootendorst.com",150],["michaelmoore.com",150],["read.perspectiveship.com",150],["piratewires.com",150],["secretsofprivacy.com",150],["semianalysis.com",150],["slowboring.com",150],["statsignificant.com",150],["strangeloopcanon.com",150],["substack.com",[150,849,1792,1793]],["techemails.com",150],["theankler.com",[150,849]],["thebignewsletter.com",150],["thebulwark.com",150],["theclimatebrink.com",150],["theintrinsicperspective.com",150],["unchartedterritories.tomaspueyo.com",150],["persuasion.community",150],["garbageday.email",150],["flowstate.fm",150],["popular.info",150],["gamefile.news",150],["racket.news",150],["understandingai.org",150],["elysian.press",150],["jacobwolf.report",150],["latent.space",150],["dossier.today",150],["engineeringleadership.xyz",150],["henrikkarlsson.xyz",150],["areavip.com.br",151],["cryptopolitan.com",[151,754]],["izismile.com",151],["techsupportalert.com",151],["b9.com.br",152],["correiobraziliense.com.br",153],["crusoe.com.br",154],["folhadelondrina.com.br",155],["folhape.com.br",156],["dailydot.com",[156,773]],["gkpb.com.br",157],["infomoney.com.br",158],["intercept.com.br",[159,160]],["asianjournal.com",159],["creativedestructionmedia.com",[159,742]],["floridianpress.com",[159,742,965]],["marktechpost.com",[159,742,1333]],["mediaplaynews.com",[159,742]],["soundproofcow.com",[159,742]],["thefullpint.com",[159,742]],["delacortereview.org",[159,742]],["reasonstobecheerful.world",[159,282,742,1568]],["maquinadoesporte.com.br",161],["autocar.co.nz",161],["health-e.org.za",161],["moneytimes.com.br",162],["oantagonista.com.br",163],["olhardigital.com.br",164],["poder360.com.br",165],["revistaforum.com.br",166],["tecmundo.com.br",167],["uol.com.br",168],["folha.uol.com.br",169],["huffingtonpost.es",169],["skyandtelescope.org",169],["luxurylondon.co.uk",[169,2751]],["gizmodo.uol.com.br",170],["operamundi.uol.com.br",171],["zoom.com.br",172],["letras.mus.br",[173,174]],["iflscience.com",[173,1156]],["123ink.ca",[175,176]],["primecables.ca",[175,176]],["shopperplus.ca",[176,234]],["advisor.ca",177],["albertafarmexpress.ca",178],["canadiancattlemen.ca",178],["country-guide.ca",178],["grainews.ca",178],["manitobacooperator.ca",178],["producer.com",178],["shop.artnoise.ca",179],["headphonebar.com",179],["jolinne.com",179],["berkeleyearth.org",179],["scetv.org",179],["hifiheadphones.co.uk",[179,601]],["atlanticsuperstore.ca",180],["bestbuy.ca",181],["bluetrain.ca",182],["canadiantire.ca",183],["cb2.ca",184],["cbc.ca",185],["cheknews.ca",[186,187]],["brisktest.com",186],["blog.duncangeere.com",186],["blog.elevatedataviz.com",186],["fleshlight.eu",186],["updates.techforpalestine.org",186],["citynews.ca",188],["aeon.co",[188,273,274]],["readcars.co",188],["readfashion.co",188],["readfilm.co",188],["readfood.co",188],["readgaming.co",188],["readmusic.co",188],["readshowbiz.co",188],["readtv.co",188],["247sports.com",188],["4029tv.com",188],["abovethelaw.com",188],["asmartbear.com",188],["blackburnnews.com",188],["bookriot.com",188],["christianitytoday.com",[188,652]],["citusdata.com",[188,670]],["clickorlando.com",188],["cockroachlabs.com",188],["creation.com",188],["dailybee.com",188],["dailysignal.com",188],["dallasinnovates.com",188],["fox10phoenix.com",188],["fox13news.com",188],["fox13seattle.com",188],["fox26houston.com",188],["fox29.com",188],["fox2detroit.com",188],["fox32chicago.com",188],["fox35orlando.com",188],["fox4news.com",[188,985]],["fox5atlanta.com",188],["fox5dc.com",188],["fox6now.com",188],["fox7austin.com",[188,985]],["fox9.com",188],["foxla.com",188],["frommers.com",188],["greencarreports.com",188],["hedgehogreview.com",188],["hiphopdx.com",[188,1120]],["kcci.com",188],["kcra.com",188],["ketv.com",188],["kmbc.com",188],["koat.com",188],["koco.com",188],["komando.com",188],["ksbw.com",188],["ktvu.com",188],["livescience.com",188],["local10.com",188],["londondrugs.com",188],["motherjones.com",[188,1407]],["mynbc5.com",188],["nbc-2.com",188],["newsweek.com",[188,1464]],["q13fox.com",188],["readbetting.com",188],["readceltic.com",188],["readmanutd.com",188],["readmotorsport.com",188],["reverb.com",188],["slate.com",188],["sportsworldnews.com",188],["tastecooking.com",[188,1612]],["techfinitive.com",188],["thekitchenmagpie.com",188],["tomsguide.com",188],["toofab.com",[188,1975]],["venturebeat.com",[188,2046]],["wapt.com",188],["wbaltv.com",188],["wcvb.com",188],["wdsu.com",188],["wesh.com",188],["wgal.com",188],["wisn.com",188],["wjcl.com",188],["wlky.com",188],["wlwt.com",188],["wmtw.com",188],["wmur.com",188],["womanandhome.com",188],["wpbf.com",188],["wtae.com",188],["wvtm13.com",188],["wxii12.com",188],["wyff4.com",188],["samvirke.dk",[188,2184]],["japantimes.co.jp",188],["thebeliever.net",188],["feadship.nl",188],["kantinepraat.nl",188],["voetbalverslaafd.nl",188],["jta.org",188],["progressive.org",188],["propublica.org",[188,546]],["publicdomainreview.org",[188,2639]],["restofworld.org",[188,2643]],["tvtropes.org",188],["undark.org",[188,813,962]],["wqxr.org",188],["citiblog.co.uk",188],["clubhouseforchefs.ca",189],["cochraneeagle.ca",190],["fitzhugh.ca",190],["lakelandtoday.ca",190],["westernwheel.ca",190],["airdriecityview.com",190],["rmoutlook.com",190],["stalbertgazette.com",190],["thealbertan.com",190],["timescolonist.com",[190,1962]],["ctvnews.ca",191],["bergautodesign.com",192],["braveandkindbooks.com",192],["bwpsales.com",[192,208]],["fwdformnutrition.com",192],["gizmogoober.com",[192,429]],["pitviper.com",[192,1575]],["sweetteacaviar.com",[192,1799]],["deskhero.ca",193],["driving.ca",194],["dsw.ca",195],["theshoecompany.ca",195],["esourceparts.ca",196],["everythinglifestyle.ca",197],["fraservalleytoday.ca",[197,202]],["fleetnetwork.ca",199],["flexispot.ca",200],["flexispot.com",200],["inc42.com",200],["flexispot.de",200],["flexispot.es",200],["flexispot.it",200],["flexispot.nl",200],["yesmagazine.org",[200,2683]],["flexispot.pl",200],["flexispot.co.uk",200],["fortnine.ca",201],["battlefordsnow.com",202],["everythinggp.com",202],["farmnewsnow.com",202],["larongenow.com",202],["lethbridgenewsnow.com",202],["meadowlakenow.com",202],["nanaimonewsnow.com",202],["panow.com",202],["rdnewsnow.com",202],["ginospizza.ca",203],["globalnews.ca",[204,205,206]],["zdnet.com",205],["stoneyroads.com",206],["healthing.ca",207],["hockeylion.ca",208],["justcloseoutscanada.ca",208],["chillamo.com",208],["detroitmodular.com",208],["fitnessav.com",208],["gronkfitnessproducts.com",208],["kyliejennershop.com",208],["lakshmistores.com",208],["magnumboots.com",208],["metrocheese.com",208],["wilcooffroad.com",208],["zerobreeze.com",208],["otisoatmilk.co.nz",208],["homehardware.ca",209],["chapters.indigo.ca",210],["iphoneincanada.ca",211],["jvns.ca",213],["lapresse.ca",214],["leons.ca",[215,216]],["12tomatoes.com",[215,216,312]],["almanac.com",[215,216,394]],["princessauto.com",[215,216]],["victorpest.com",[215,1651,2050]],["macleans.ca",[217,218]],["chatelaine.com",[218,641]],["massivetoyblowout.ca",219],["mcgill.ca",220],["nascar.ca",221],["naturalsound.ca",222],["shellsoul.com",222],["sigav.com",222],["fruitarian.store",222],["networldsports.ca",223],["brandingmag.com",[223,575]],["drinkcirkul.com",[223,843]],["staygenerator.com",223],["summitracing.com",223],["kmzu.com",[224,1256]],["noovomoi.ca",225],["rabble.ca",226],["lovefoodnotcooking.com",226],["spectator.org",[226,1091,2655]],["racketsandrunners.ca",227],["ici.radio-canada.ca",[228,229]],["frontofficesports.com",[229,1004]],["mikebloomberg.com",229],["nimsdai.com",229],["patijinich.com",229],["smnovella.com",229],["treblezine.com",[229,656]],["trustedreviews.com",229],["solidaarisuus.fi",229],["mekomit.co.il",[229,2296,2297]],["cremaoggi.it",[229,2339]],["cremonaoggi.it",[229,2339]],["cremonasport.it",[229,2339]],["oglioponews.it",[229,2339]],["heelhollandbakt.nl",229],["realestatemagazine.ca",230],["rona.ca",231],["rugs.ca",232],["bigissue.com",[232,531]],["coinbase.com",232],["shoppersdrugmart.ca",235],["simcoeav.ca",236],["atelierskn.com",236],["awables.com",236],["camerawholesalers.com",236],["flight-model.com",236],["loudshop.com",236],["p2nstore.co.uk",236],["sportchek.ca",237],["staples.ca",238],["highcarbhannah.co",238],["asweetpeachef.com",238],["biggerbolderbaking.com",238],["craftboxdirect.com",238],["dailycaller.com",[238,772]],["gamebyte.com",238],["glerups.com",238],["kurufootwear.com",238],["mychicagosteak.com",[238,1423]],["mylivelobster.com",238],["readwrite.com",[238,1637]],["redrightvideos.com",[238,675]],["rocketeyewear.com",238],["thesatanictemple.com",238],["tibi.com",238],["unknowncomicbooks.com",[238,2026]],["warpedsense.com",238],["geoffanderson.dk",238],["mobellageret.dk",238],["bookshop.org",238],["techbomb.ca",239],["analyticsindiamag.com",[239,413]],["aulart.com",[239,468]],["lalaskinessentials.com",239],["parametric-architecture.com",239],["pcipolicyportal.com",[239,1556]],["redhuntlabs.com",239],["swidget.com",239],["whereyourebetween.com",[239,2088]],["gastgewerbe-magazin.de",239],["tlv1.fm",239],["syntagmawatch.gr",239],["nusantararom.org",239],["reclaimthenet.org",239],["houseandleisure.co.za",239],["thenarwhal.ca",240],["thetechfactor.ca",241],["thetyee.ca",242],["thewalrus.ca",[243,244,245,246]],["thefiscaltimes.com",[243,1892]],["mayottehebdo.com",[245,246,1340]],["eatpink.it",[245,246]],["tsc.ca",248],["ualberta.ca",249],["well.ca",250],["birdbgone.com",250],["draxe.com",[250,837]],["hugesupplements.com",[250,1145]],["loveyourmelon.com",250],["ritual.com",250],["ara.cat",251],["diaridegirona.cat",252],["regio7.cat",252],["diariocordoba.com",252],["elperiodicodearagon.com",252],["elperiodicoextremadura.com",252],["elperiodicomediterraneo.com",252],["levante-emv.com",252],["noticiasdenavarra.com",252],["diariodeibiza.es",252],["diariodemallorca.es",252],["elcorreogallego.es",252],["eldia.es",252],["farodevigo.es",252],["informacion.es",252],["laopinioncoruna.es",252],["laopiniondemalaga.es",252],["laopiniondezamora.es",252],["laprovincia.es",252],["lne.es",252],["mallorcazeitung.es",252],["superdeporte.es",252],["deia.eus",252],["noticiasdealava.eus",252],["noticiasdegipuzkoa.eus",252],["emporda.info",252],["artdaily.cc",253],["researchnews.cc",253],["angioproteomie.com",[253,419]],["radioandmusic.com",253],["shopcytee.com",253],["jamesgmartin.center",254],["iamexpat.ch",255],["iamexpat.de",255],["iamexpat.nl",255],["blog.jobeo.ch",256],["ortodacoltivare.it",256],["pressgiochi.it",256],["laurentferrier.ch",257],["dauletapparel.com",257],["blog.nationalmuseum.ch",258],["nzz.ch",259],["pfister.ch",260],["pi-shop.ch",261],["swissinfo.ch",[262,263,264]],["altonbrown.com",[263,396]],["exceptional.com",264],["louderwithcrowder.com",264],["the-line-up.com",[264,853,1848]],["theportalist.com",[264,853]],["tokmanni.fi",264],["zeta.nu",264],["lung.org",[264,2605]],["monitor.co.ug",264],["tdg.ch",265],["watson.ch",266],["jumia.ci",267],["intergameonline.com",[267,1187]],["morningconsult.com",[267,1405]],["pushmycart.com",267],["shutterfly.com",267],["jumia.dz",267],["jumia.com.eg",267],["jumia.com.gh",267],["jumia.co.ke",267],["jumia.ma",267],["jumia.com.ng",267],["pagani.co.nz",[267,2512]],["jumia.sn",267],["jumia.com.tn",267],["jumia.ug",267],["seastarsuperbikes.co.uk",267],["ciperchile.cl",268],["cooperativa.cl",269],["pauta.cl",270],["shine.cn",271],["psyche.co",[273,293]],["animalchannel.co",[275,276]],["homehacks.co",[275,276]],["parentingisnteasy.co",[275,276]],["relieved.co",[275,276]],["seeitlive.co",[275,276]],["spotlightstories.co",[275,276]],["sweetandsavory.co",[275,276]],["blockworks.co",277],["cinder.co",278],["coconuts.co",279],["motor.com.co",280],["elgrafico.com",280],["laprensagrafica.com",280],["thejakartapost.com",[280,1911]],["ultimominuto.news",280],["dashbit.co",[281,282]],["offthebeatenpoints.com",281],["inquirer.net",281],["armageddonexpo.com",282],["etsy.com",282],["itsfoss.com",[282,1209,1210]],["global.microless.com",282],["pandotrip.com",282],["pissdaily.com",282],["rigzone.com",[282,1669]],["sfist.com",[282,332]],["allthings.how",282],["jurist.org",282],["neon.tech",282],["businesstech.co.za",[282,2793]],["decrypt.co",283],["ello.co",284],["finom.co",285],["insider.fitt.co",286],["gkogan.co",287],["beautifulpublicdata.com",287],["scarletink.com",287],["codereliant.io",287],["blog.privacyguides.org",287],["overkill.wtf",287],["grove.co",288],["instaread.co",289],["jxnl.co",290],["ambitiouskitchen.com",[290,403]],["cookincanuck.com",[290,549]],["leadingsapiens.com",290],["notthathardtohomeschool.com",[290,1486]],["sallysbakingaddiction.com",[290,1687]],["sundaysuppermovement.com",[290,454]],["wholefully.com",[290,961]],["wyseguide.com",[290,454]],["1000logos.net",290],["magiclasso.co",291],["modernretail.co",292],["routinehub.co",294],["sugarandsoul.co",[295,296]],["culinaryhill.com",295],["diethood.com",[295,351]],["houseofnasheats.com",295],["iheartrecipes.com",295],["justataste.com",[295,1232]],["lilluna.com",[295,344,346]],["littlespoonfarm.com",295],["whatsgabycooking.com",295],["happymoneysaver.com",296],["togetherasfamily.com",296],["tech.co",297],["tedium.co",298],["theblock.co",[299,300,301]],["all3dp.com",299],["theblockcrypto.com",301],["thedisconnect.co",304],["thehustle.co",305],["thenetnaija.co",306],["thetrek.co",308],["weareexplorers.co",309],["101cookbooks.com",310],["101soundboards.com",311],["177milkstreet.com",313],["1fichier.com",[314,315]],["aritzia.com",[314,435]],["bathandbodyworks.com",[314,501]],["bestreviews.com",314],["biztechmagazine.com",[314,501,548]],["fye.com",[314,501]],["madewell.com",[314,1323]],["ptitchef.com",[314,501,1564]],["2-spyware.com",316],["247wallst.com",317],["29secrets.com",318],["itmunch.com",[318,396]],["pqube.co.uk",318],["2hbn.com",319],["bilgisentezi.com",[319,537]],["farklifarkli.com",319],["readingclock.com",319],["2pdfconverter.com",320],["annotation.com",320],["changefaces.com",320],["chartle.com",320],["coloringonline.com",320],["fakechatapp.com",320],["files2zip.com",[320,952]],["htmlgames.com",320],["mapimage.com",320],["maproute.com",320],["mindclouds.com",320],["news.mongabay.com",320],["phideo.com",320],["photocollage.com",320],["photoeditor.com",320],["photoenlarger.com",320],["photofilters.com",320],["photoresizer.com",320],["postermaker.com",320],["qrapp.com",320],["stripbackground.com",320],["toonytool.com",320],["wordclouds.com",320],["youtubetrimmer.com",320],["fotofilter.de",320],["3dprint.com",321],["3dprintingspot.com",322],["3f-filippi.com",323],["5percentnutrition.com",324],["legacytoys.com",324],["myotcstore.com",324],["newvaping.com",324],["nisupplements.com",324],["5pillarsuk.com",325],["raya.com",325],["sentieriselvaggi.it",325],["6amcity.com",[326,327]],["pitchbook.com",326],["straightdope.com",326],["8newsnow.com",329],["news.uthscsa.edu",329],["91mobiles.com",330],["indiatimes.com",[331,1164]],["flightconnections.com",333],["a16z.com",335],["abc15.com",336],["abc57.com",337],["abc7.com",338],["abc7ny.com",338],["abeautifulmess.com",339],["afamilyfeast.com",339],["airandspaceforces.com",339],["hightechplace.com",339],["spendwithpennies.com",[339,723,859]],["thebestcakerecipes.com",[339,1861]],["metronieuws.nl",339],["want.nl",339],["abplive.com",341],["accuweather.com",342],["acimena.com",343],["catholicnewsagency.com",343],["aciafrica.org",343],["aciafrique.org",343],["acouplecooks.com",[344,345,346,347]],["dinneratthezoo.com",344],["eatyourselfskinny.com",[344,346,351]],["gimmedelicious.com",344],["inquiringchef.com",[344,1172]],["noracooks.com",344],["simplifylivelove.com",344],["tastesbetterfromscratch.com",[344,1813]],["therecipecritic.com",344],["tutti-dolci.com",344],["veggiekinsblog.com",344],["vindulge.com",344],["studyfinds.org",344],["eatingbirdfood.com",[346,859]],["healthyfitnessmeals.com",[346,1099]],["meaningfuleats.com",[346,351]],["selfproclaimedfoodie.com",[346,351]],["thecookierookie.com",[346,351]],["thefoodcharlatan.com",346],["tonisrecipes.com",[346,351]],["feelgoodfoodie.net",[346,351]],["iambaker.net",[346,549]],["couplecooks.com",347],["actiongame.com",348],["classicgame.com",348],["hiddenobjectgames.com",348],["mahjong.com",348],["match3games.com",348],["mindgames.com",348],["neongames.com",348],["solitaireonline.com",348],["timemanagementgame.com",348],["brain-games.co.uk",348],["games-site.co.uk",348],["mahjong.co.uk",348],["match3.co.uk",348],["neongames.co.uk",348],["activistpost.com",349],["adage.com",350],["addapinch.com",351],["budgetbytes.com",[351,549,597]],["dinnerthendessert.com",[351,820]],["eatingonadime.com",[351,860]],["playswellwithbutter.com",[351,1580]],["themom100.com",[351,1918]],["thestayathomechef.com",351],["vacationstravel.com",351],["wellplated.com",[351,2086]],["yellowblissroad.com",[351,549]],["adexchanger.com",353],["adidas.com",354],["admonsters.com",[355,356]],["bookmundi.com",[356,410,568]],["autocar.co.uk",356],["adorama.com",357],["advfn.com",358],["advisorperspectives.com",359],["aeromalls.com",361],["aerotelegraph.com",362],["aetv.com",[363,364]],["historytoday.com",363],["affectionink.com",365],["baskdallas.com",365],["bigphilspeaks.com",365],["brit-pet.com",365],["brookeandarrow.com",365],["crownnstyle.com",365],["dollmeupmakeup.com",365],["www.drinktco.com",365],["grainbrainusa.com",365],["invitationhouseph.com",365],["labellerobe.com",365],["learnintt.com",365],["leighcountry.com",365],["lucieandpompette.com",365],["modelsindustry.com",365],["modernmotifsocks.com",365],["mortonjamesboutique.com",365],["brilliant-30.myshopify.com",365],["brilliant-demo.myshopify.com",365],["ella-demo-4.myshopify.com",365],["single-citrus.myshopify.com",365],["sportwear-2.myshopify.com",365],["rhianjohn.com",365],["shopmeko.com",365],["smsaree.com",365],["straightarrowtherapeutic.com",365],["telabeautyorganics.com",365],["toptiertac.com",365],["vernyx.com",365],["compagniadeltabacco.it",365],["sofii.org",365],["simmiwoman.co.uk",365],["topgear.co.za",[365,2809]],["agrarheute.com",366],["ahchealthenews.com",367],["aibusiness.com",[369,370]],["channelfutures.com",369],["darkreading.com",[369,781]],["gamedeveloper.com",[369,370,781,1012]],["iotworldtoday.com",[369,1012,1196]],["itprotoday.com",[369,370]],["air1.com",371],["klove.com",371],["aircargonext.com",372],["baltimoremagazine.com",372],["cargofacts.com",372],["deseret.com",372],["gvwire.com",[372,1077]],["medcitynews.com",[372,987,1349]],["interrupt.memfault.com",372],["interlochenpublicradio.org",372],["airfactsjournal.com",[373,374]],["howtocookthat.net",373],["newmatilda.com",374],["airtahitinui.com",375],["akkogear.com",377],["al-sharq.com",378],["alamocitygolftrail.com",379],["albawaba.com",[380,381]],["sport360.com",381],["alexcityoutlook.com",382],["crooksandliars.com",382],["crucial.com",382],["drewberquist.com",[382,841,842]],["kentuckytoday.com",382],["keysnews.com",382],["ktbs.com",382],["kulr8.com",382],["lifezette.com",[382,841,842]],["magazines.com",382],["msmagazine.com",[382,1414]],["napacanada.com",382],["northcentralpa.com",382],["novaramedia.com",382],["redvoicemedia.com",[382,842]],["technicianonline.com",382],["trueachievements.com",382],["truetrophies.com",382],["urbanmilwaukee.com",382],["zarar.dev",382],["newsmirror.net",382],["heartlandalliance.org",382],["newsnow.co.uk",382],["allaboutcircuits.com",384],["alldayidreamaboutfood.com",[385,386]],["fearlesssalarynegotiation.com",386],["laurenslatest.com",[386,496,1276]],["inspiredtaste.net",[386,2406,2407]],["alldayshirts.com",387],["allkpop.com",388],["snowbrains.com",388],["tokyohive.com",388],["volquartsen.com",388],["happens.vip",388],["allmodern.com",389],["birchlane.com",389],["jossandmain.com",389],["allmusic.com",[390,391]],["theconversation.com",[391,1872]],["texasattorneygeneral.gov",391],["usrtk.org",[391,2674]],["allrecipes.com",392],["foodandwine.com",392],["seriouseats.com",392],["shape.com",392],["simplyrecipes.com",392],["southernliving.com",392],["thespruceeats.com",392],["travelandleisure.com",[392,1992]],["tripsavvy.com",[392,1998]],["verywellhealth.com",392],["verywellmind.com",392],["allthatsinteresting.com",393],["altalex.com",395],["diritto.it",396],["leggioggi.it",[396,2355]],["rollingstone.it",396],["altpress.com",397],["invisibleoranges.com",397],["alvarotrigo.com",398],["amazingcto.com",399],["amazingribs.com",400],["amazonadviser.com",401],["apptrigger.com",401],["arrowheadaddict.com",401],["bamsmackpow.com",[401,492]],["fansided.com",[401,932]],["gamesided.com",[401,492]],["gojoebruin.com",[401,492]],["hiddenremote.com",401],["lastnighton.com",[401,932]],["lawlessrepublic.com",401],["mlsmultiplex.com",401],["netflixlife.com",[401,932]],["playingfor90.com",401],["stormininnorman.com",[401,932]],["winteriscoming.net",[401,932]],["ambcrypto.com",402],["amcrest.com",404],["amd.com",405],["americanwirenews.com",407],["americastestkitchen.com",[408,409]],["heraldscotland.com",409],["suntimes.com",409],["vancouversun.com",[409,2041]],["hbr.org",[409,2581]],["amgreatness.com",410],["anker.com",410],["shop.amoreterra.com",411],["amtraker.com",412],["androidauthority.com",414],["androidcentral.com",415],["androidheadlines.com",416],["androidpcreview.com",417],["raptitude.com",417],["thelittlekitchen.net",417],["angara.com",418],["anothermag.com",420],["antena3.com",421],["anthropologie.com",422],["freepeople.com",422],["urbanoutfitters.com",[422,2029]],["aorus.com",423],["nutritioninsight.com",[423,1496]],["packaginginsights.com",423],["apnews.com",424],["heraldnet.com",[424,1107]],["humankinetics.com",424],["inquirer.com",424],["njbiz.com",424],["parent.com",424],["thehill.com",[424,1905]],["proiezionidiborsa.it",424],["newsnationnow",424],["ar15.com",425],["arabnews.com",426],["tribalfootball.com",426],["onmeda.de",426],["castanet.net",426],["arboristsite.com",427],["kitchenknifeforums.com",427],["arcade-sound.com",[428,429]],["justripenutrition.com",429],["vargooutdoors.com",[429,2042]],["arcamax.com",431],["archaeologymag.com",432],["blendernation.com",432],["architectmagazine.com",433],["jlconline.com",433],["argusdelassurance.com",434],["arkansasonline.com",436],["arrowheadpride.com",437],["badlefthook.com",437],["barcablaugranes.com",437],["bavarianfootballworks.com",437],["bleedinggreennation.com",437],["bloggingtheboys.com",437],["bloodyelbow.com",437],["brightsideofthesun.com",437],["cagesideseats.com",437],["celticsblog.com",437],["eater.com",[437,858]],["goldenstateofmind.com",437],["libertyballers.com",437],["managingmadrid.com",437],["mmafighting.com",437],["mmamania.com",437],["polygon.com",[437,1587,1588]],["silverscreenandroll.com",437],["sounderatheart.com",437],["artforum.com",438],["footwearnews.com",[438,972]],["indiewire.com",438],["stylecaster.com",438],["news.artnet.com",[440,441]],["skylineatlas.de",[440,2170]],["arti-definisi-pengertian.info",440],["artofmanliness.com",442],["artribune.com",443],["as.com",445],["aseannow.com",446],["aserto.com",447],["music-news.com",[447,1417]],["theatre-news.com",[447,1417]],["film-news.co.uk",[447,1417]],["game-news.co.uk",[447,1417]],["asiaone.com",448],["asiaresearchnews.com",449],["press.asimov.com",450],["askleo.com",[451,452]],["musically.com",452],["asmag.com",453],["aspicyperspective.com",[454,455]],["feastingathome.com",[454,944]],["foodiecrush.com",454],["healthyrecipesblogs.com",[454,723,1100]],["neighborfoodblog.com",[454,864]],["ohsheglows.com",454],["ohsweetbasil.com",[454,1511]],["onceuponachef.com",[454,540,1518]],["prowrestlingstories.com",454],["thecountrycook.net",454],["www.thecountrycook.net",454],["aspose.com",456],["astronomy.com",458],["atavist.com",459],["audacy.com",462],["audfree.com",463],["audioadvice.com",464],["audiogeeks.com",466],["keepgo.com",466],["audioholics.com",467],["austinchronicle.com",469],["authenticoilco.com",470],["geizdental.de",470],["powgen.fr",470],["sensilab.se",470],["auto-moto.com",471],["autoblog.com",472],["steelersdepot.com",472],["autocarindia.com",473],["india.com",473],["sassymamahk.com",473],["laleggepertutti.it",473],["isglobal.org",473],["autodesk.com",474],["autoplicity.com",475],["autosport.com",476],["motorsport.com",476],["averagelinuxuser.com",477],["awapress.com",478],["gbnews.com",478],["ridefox.com",478],["nakedsecurity.sophos.com",478],["jamesbeard.org",478],["awesomebooks.com",479],["news12.com",479],["percona.com",479],["essemagazine.it",479],["poynter.org",[479,2637]],["axios.com",480],["azestforlife.com",481],["azoai.com",482],["azobuild.com",482],["azocleantech.com",482],["azolifesciences.com",482],["azom.com",482],["azomining.com",482],["azonano.com",482],["azooptics.com",482],["azoquantum.com",482],["azorobotics.com",482],["azosensors.com",482],["babel.com",484],["backroads.com",487],["backroadslondon.com",488],["fsaproshop.com",488],["mofi.com",488],["vulkit.com",488],["crates.whosampled.com",488],["vibergboot.eu",488],["ownsilent.international",488],["bazaar-foods.co.uk",488],["modify71.co.uk",488],["roughandreadywholefoods.co.uk",488],["backstage.com",489],["wenku.baidu.com",490],["balkangreenenergynews.com",491],["bangkokpost.com",493],["bankinfosecurity.com",495],["barefootuniverse.com",496],["bestbeefrecipes.com",496],["herwholesomekitchen.com",[496,864]],["yinibinibaby.com",496],["barnesandnoble.com",497],["barrons.com",498],["bartendersbusiness.com",499],["basilmarket.com",500],["iclg.co.uk",501],["baystatebanner.com",502],["bbc.com",503],["beaumontenterprise.com",505],["ctpost.com",505],["expressnews.com",505],["greenwichtime.com",505],["houstonchronicle.com",505],["lmtonline.com",505],["manisteenews.com",505],["michigansthumb.com",505],["middletownpress.com",505],["mrt.com",505],["myjournalcourier.com",505],["myplainview.com",505],["nhregister.com",505],["ourmidland.com",505],["registercitizen.com",505],["sfchronicle.com",505],["stamfordadvocate.com",505],["theintelligencer.com",505],["beautycounter.com",506],["beckershospitalreview.com",507],["bedbathandbeyond.com",508],["overstock.com",[508,1542]],["beermenus.com",509],["beforeitsnews.com",[510,511,512]],["partsinmotion.co.uk",510],["biblio.com",512],["codastory.com",512],["fjolt.com",512],["homeofdirectcommerce.com",512],["marineelectronics.com",512],["swimswam.com",512],["technostall.com",512],["knowledge.wharton.upenn.edu",512],["appstorm.net",512],["dailygood.org",512],["worldwatchmonitor.org",512],["celebrity.red",512],["u.today",512],["biblio.co.uk",512],["beincrypto.com",513],["beinsports.com",514],["wftv.com",514],["wpxi.com",514],["beliefnet.com",515],["belk.com",516],["bellingcat.com",517],["benjamingroff.com",518],["benzinga.com",519],["bestpricenutrition.com",521],["fallindesign.com",521],["bet.com",522],["betaprofiles.com",523],["beverageforyou.com",524],["bhphotovideo.com",525],["biblia.com",527],["bicycleretailer.com",528],["bigbearrealestateagent.com",529],["bigislandnow.com",530],["bigkitchen.com",532],["bigthink.com",533],["bikeexif.com",534],["bikerumor.com",[535,536]],["gearjunkie.com",[535,536,1023]],["soaphub.com",[535,1748]],["bilibili.com",538],["billyparisi.com",[539,540]],["davidlebovitz.com",[540,549,784]],["kimpetras.com",540],["bingehulu.com",541],["news.bitcoin.com",542],["bittmanproject.com",543],["bizcommunity.com",544],["opindia.com",[545,1526]],["bridgemi.com",546],["thenation.com",[546,1920]],["positive.news",546],["bizpacreview.com",547],["biztimes.com",549],["browneyedbaker.com",549],["peanutbutterandjilly.com",549],["traditionalcookingschool.com",549],["wholesomeyum.com",[549,2091]],["bkstr.com",550],["blogpascher.com",551],["blogthinkbig.com",552],["blooloop.com",553],["forward.com",[555,823,941,983]],["latimes.com",555],["northernvirginiamag.com",555],["sandiegouniontribune.com",555],["tvinsider.com",555],["jns.org",555],["wamu.org",555],["bocanewsnow.com",[556,557]],["piacenza24.eu",556],["podwatch.io",556],["transport-online.nl",556],["bodybuilding.com",558],["bolavip.com",559],["bonappetit.com",[560,561]],["gq.com",561],["boohoo.com",563],["bookbub.com",564],["bookforum.com",[565,566]],["dsw.com",565],["gunsamerica.com",[565,1073]],["realclearpolitics.com",565],["realclearscience.com",565],["ultra1plus.com",[565,2021]],["fairplanet.org",[565,2569]],["aif.ru",[565,2703]],["booking.com",567],["todayonline.com",569],["standout.co.uk",569],["boston.com",570],["bostonagentmagazine.com",571],["boutirmall.com",572],["takimag.com",[572,1806]],["bramptonguardian.com",[573,574]],["simcoe.com",573],["buzzfeed.com",574],["buzzfeednews.com",[574,610]],["coindesk.com",[574,702]],["petmd.com",[574,1565]],["zicasso.com",[574,2130]],["sciencenews.org",[574,2651]],["snexplores.org",[574,2654]],["business-punk.com",575],["cosmosmagazine.com",[575,729]],["dealnews.com",575],["libhunt.com",[575,1291]],["pharmaceutical-business-review.com",575],["thepitchfootball.com",575],["it-times.de",575],["borsonline.hu",[575,1868]],["metropol.hu",[575,1868]],["ripost.hu",[575,1868]],["businessworld.in",575],["ricethresher.org",575],["brandsmartusa.com",576],["braziljournal.com",577],["vedbex.com",577],["breakingbelizenews.com",578],["breakingenergy.com",[580,581]],["breakinggov.com",580],["breathecast.com",582],["breathedreamgo.com",583],["cruxnow.com",585],["bringatrailer.com",586],["britishheritage.com",587],["networkdevicesinc.com",588],["brooklynfarmgirl.com",590],["thewoksoflife.com",590],["browardpalmbeach.com",591],["dallasobserver.com",591],["phoenixnewtimes.com",591],["westword.com",591],["browserling.com",592],["browserstack.com",593],["brusselstimes.com",594],["btimesonline.com",595],["btr.com",596],["latenighter.com",[597,1271]],["build.com",598],["buondua.com",599],["burkesoutlet.com",600],["busbeestyle.com",601],["towerhousewares.co.uk",601],["businessinsider.com",[602,603,604,605]],["insider.com",[602,603,605]],["ekathimerini.com",603],["wearesync.co.uk",604],["inc.com",[605,936]],["businesstraveller.com",606],["bustle.com",607],["butternutbakeryblog.com",608],["butterwithasideofbread.com",609],["bygonely.com",611],["impulkits.com",611],["musclecarsandtrucks.com",611],["thepetslife.online",611],["cabothousefurniture.com",612],["factkeepers.com",[612,926]],["online-tech-tips.com",[612,1520]],["onthegotours.com",612],["everybithelps.io",612],["nutritioncare.net",612],["diycarserviceparts.co.uk",612],["cafemom.com",613],["calgaryherald.com",614],["edmontonjournal.com",[614,871]],["montrealgazette.com",614],["ottawacitizen.com",614],["thestarphoenix.com",614],["canarymedia.com",616],["candela.com",617],["capitaltransport.com",618],["captainaltcoin.com",619],["carnewschina.com",621],["cars.com",[622,623]],["invezz.com",[622,1195]],["carsalesbase.com",624],["bitcoinke.io",624],["carsauce.com",625],["carshopinc.com",626],["catchnews.com",627],["cbn.com",628],["cbssports.com",629],["ccjdigital.com",630],["equipmentworld.com",630],["cdispatch.com",631],["ceenergynews.com",632],["celebrityaccess.com",[633,634]],["securityweek.com",[633,1717]],["eastasiaforum.org",[633,2565]],["mag.toyota.co.uk",633],["channelnewsasia.com",635],["chargedevs.com",[636,637]],["gomag.com",636],["mauritiustimes.com",636],["charismamag.com",638],["roughstock.com",638],["charlestonbusiness.com",639],["columbiabusinessreport.com",639],["gsabusiness.com",639],["scbiznews.com",639],["charlieintel.com",640],["dexerto.com",[640,808]],["chemistryworld.com",[642,643]],["flightglobal.com",643],["fruitnet.com",[643,1005]],["screendaily.com",[643,1705]],["lawgazette.co.uk",643],["thegrocer.co.uk",643],["cheshirehorse.com",644],["farmandfleet.com",644],["chicagocrusader.com",645],["chicagotribune.com",[646,647]],["chipsandcheese.com",648],["chipwits.com",[648,649]],["consummateathlete.com",[648,716]],["exputer.com",648],["logitheque.com",648],["mixed-news.com",648],["notionthings.com",648],["plusrew.com",[648,716]],["pstribune.com",[648,716]],["slaynews.com",[648,1739]],["tech4gamers.com",648],["yogaworld.de",[648,716]],["tomshardware.fr",648],["sardiniapost.it",648],["thedesk.net",648],["chowhound.com",[650,651]],["kob.com",650],["christianpost.com",653],["christianstandard.com",[654,655]],["dailynewsegypt.com",[654,655]],["daphneoz.com",[654,655]],["eletric-vehicles.com",[654,655,878]],["hdwalle.com",[654,655]],["megacatstudios.com",[654,655]],["ubitennis.com",[654,655]],["scholarlykitchen.sspnet.org",[654,655]],["quzo.net",655],["fodors.com",656],["nocamels.com",[656,1479]],["theface.com",656],["talotekniikka-lehti.fi",656],["christiesrealestate.com",658],["slightnorth.com",658],["guides.wp-bullet.com",[658,987]],["publicbooks.org",658],["glutenfreecuppatea.co.uk",[658,2436]],["christinacooks.com",659],["chronicle.com",[660,661]],["realtor.com",[661,1638]],["cinelinx.com",664],["cinesprint.com",665],["cio.com",666],["computerworld.com",666],["csoonline.com",666],["networkworld.com",666],["circleid.com",667],["circuitbasics.com",668],["loyaltylobby.com",[668,1318]],["makingthymeforhealth.com",668],["citoyens.com",669],["citybeach.com",672],["everything5pounds.com",672],["momentarecovery.com",672],["starlocalmedia.com",[672,1592]],["worldwidevoltage.com",672],["elcaribe.com.do",672],["slate.fr",[672,2263]],["soccity.net",672],["gaytimes.co.uk",672],["thedial.world",[672,1450]],["civicx.com",673],["claimdepot.com",674],["clashdaily.com",675],["thinkamericana.com",675],["americanprogress.org",[675,2533]],["clashmusic.com",676],["classicreload.com",677],["classicsdujour.com",678],["classpop.com",679],["clementoni.com",680],["clinique.com",681],["cloudflare.com",682],["cltampa.com",683],["clutchpoints.com",685],["cnbc.com",686],["cnet.com",687],["cnevpost.com",[688,689]],["prettysimplesweet.com",688],["saabplanet.com",688],["valuewalk.com",688],["mashable.com",[691,1335]],["edition.cnn.com",692],["cnnindonesia.com",693],["cntraveler.com",694],["cntraveller.com",695],["them.us",695],["cocktailsaway.com",696],["codehelppro.com",697],["freshersnow.com",697],["knshow.com",[697,1259]],["minecraft-schematics.com",[697,1380]],["samfw.com",697],["bdcraft.net",[697,2390]],["codeproject.com",698],["reviewjournal.com",[698,1662]],["coincodecap.com",[699,700]],["targettrend.com",699],["diarioelregionaldelzulia.com",700],["elxis.com",700],["homesteading.com",700],["innotechtoday.com",[700,1170]],["jessicabryson.com",700],["shapeways.com",700],["theglossarymagazine.com",[700,1382,1899]],["underground-england.com",700],["news.stonybrook.edu",[700,1534]],["epoliteia.gr",700],["financecommunity.it",[700,2344]],["brownstone.org",[700,2541]],["restaurantkod.co.uk",700],["halfbakedharvest.com",[701,723]],["coingape.com",703],["coleycooks.com",[706,707]],["unofficialnetworks.com",706],["coloradopolitics.com",708],["coloradosun.com",709],["columbian.com",710],["comfortoneshoes.com",711],["getrawnutrition.com",711],["groovelife.com",711],["mypatriotsupply.com",711],["myvidaorigins.com",711],["revivesups.com",711],["commandlinewizardry.com",713],["complex.com",714],["consumeraffairs.com",715],["bsnews.it",[716,2338]],["contemporist.com",717],["contexttravel.com",718],["contiki.com",719],["controleng.com",720],["cookienameddesire.com",721],["cookiesfordays.com",[722,723]],["cookthestory.com",723],["girlgonegourmet.com",723],["itdoesnttastelikechicken.com",723],["momontimeout.com",[723,1294]],["momsdish.com",[723,1394]],["mygorgeousrecipes.com",723],["myquietkitchen.com",[723,961]],["preppykitchen.com",[723,1597]],["theflavorbender.com",723],["toriavey.com",[723,1980]],["cookingclassy.com",724],["tatyanaseverydayfood.com",724],["cookingwithjanica.com",725],["core77.com",726],["corrosionpedia.com",727],["cosmopolitan.com",728],["costco.com",730],["cottonon.com",731],["coub.com",732],["countryviewah.com",733],["countynewscenter.com",734],["vallejosun.com",[734,2039]],["courthousenews.com",735],["cracked.com",736],["craftybaking.com",737],["crainsnewyork.com",738],["crazyforcrust.com",[739,740,741]],["frommybowl.com",[740,1001,1002]],["vegrecipesofindia.com",[740,2044]],["cpr.org",[740,2558]],["easypeasyfoodie.com",741],["thetinylife.com",741],["creditcards.com",743],["creepycatalog.com",744],["crisismagazine.com",745],["croq-kilos.com",747],["crowdstrike.com",748],["crowdsupply.com",749],["cruise.com",750],["news.crunchbase.com",751],["crutchfield.com",752],["crypto-news-flash.com",753],["cryptopotato.com",755],["cryptoslate.com",756],["csmonitor.com",757],["cspdailynews.com",758],["restaurantbusinessonline.com",758],["csswizardry.com",759],["cuisineaz.com",760],["culturewhisper.com",762],["curiocity.com",763],["curiosmos.com",[764,765,766]],["geopoliticalfutures.com",[765,766,1029]],["iafrica.com",[765,766]],["kdnuggets.com",[765,766]],["naturalblaze.com",[765,766,962]],["thebaffler.com",[765,766,962,1858]],["wakingtimes.com",[765,766,2065]],["marijuanamoment.net",[765,766,962]],["labourlist.org",[765,766]],["curiosum.com",767],["cyberctm.com",768],["cybersecurityventures.com",769],["cyclinguptodate.com",770],["dartsnieuws.com",770],["d2-store.com",771],["dailyfx.com",774],["dailyhive.com",775],["dailykos.com",776],["dailymemphian.com",777],["thekitchn.com",[777,1913]],["dailyvoice.com",779],["dallasnews.com",780],["everydayhealth.com",781],["historyextra.com",781],["radiotimes.com",781],["datacenterdynamics.com",782],["datamation.com",783],["esecurityplanet.com",783],["www.serverwatch.com",783],["webopedia.com",783],["dbrand.com",785],["dcvelocity.com",786],["decider.com",787],["deciem.com",788],["theordinary.com",788],["decisiondeskhq.com",789],["decode39.com",790],["deezer.com",791],["defector.com",[792,793]],["aftermath.site",[792,2709]],["goop.com",793],["hellgatenyc.com",793],["nationalworld.com",793],["dirt.fyi",793],["context.news",793],["streetsblog.org",793],["which.co.uk",[793,2778]],["defiantamerica.com",794],["delanceyplace.com",795],["delish.com",796],["esquire.com",796],["goodhousekeeping.com",796],["dell.com",798],["denon.com",799],["dentonrc.com",800],["sfexaminer.com",800],["wfmz.com",800],["denvergazette.com",801],["depor.com",802],["designmynight.com",803],["soaps.sheknows.com",803],["designtaxi.com",804],["desmog.com",805],["devdiscourse.com",806],["upi.com",806],["developingtelecoms.com",807],["dgardiner.com",809],["dharmann.com",810],["dhgate.com",811],["dickssportinggoods.com",812],["dictionary.com",[813,814]],["pressherald.com",813],["reason.com",[813,946,1639]],["revolvermag.com",[813,1663,1664]],["thefinancialbrand.com",[813,920]],["eiwittrends.nl",813],["atlanticcouncil.org",[813,2538]],["vtdigger.org",[813,2677]],["digg.com",816],["digitalocean.com",817],["digitaltrends.com",818],["digitimes.com",819],["discordapp.com",821],["disneydose.com",822],["dispatch.com",[823,824]],["monroenews.com",[823,983]],["nationalobserver.com",[823,983,1433]],["poconorecord.com",[823,983]],["vice.com",[823,983,2049]],["washingtontimes.com",[823,983,2075]],["npr.org",[823,983,2628]],["thebulletin.org",[823,983,2662]],["independent.co.uk",[823,983,1847,2744]],["disqus.com",825],["diynetwork.com",827],["foodnetwork.com",827],["dlife.com",828],["dmarge.com",829],["dnronline.com",830],["doctornerdlove.com",831],["doitbest.com",832],["domainnamewire.com",834],["doverstreetmarket.com",835],["englandexplore.com",838],["founderreports.com",838],["interacnetwork.com",[838,1185]],["unexpectedlydomestic.com",838],["dreamstime.com",840],["store.drlivingood.com",845],["gizmodern.com",845],["drugtargetreview.com",846],["dualipa.com",847],["duckduckgo.com",848],["duckduckgogg42xjoc72x3sjasowoarfbgcmvfimaftt6twagswzczad.onion",848],["dx.com",850],["dzone.com",851],["e-flux.com",852],["earlybirdbooks.com",853],["openroadmedia.com",853],["earth.com",854],["easternstandardtimes.com",855],["nabd.com",855],["eastporters.com",856],["easyayurveda.com",857],["sharktankblog.com",857],["shakira.com",858],["joyfoodsunshine.com",859],["eatthis.com",861],["eatwell101.com",862],["eazypeazymealz.com",[863,864]],["familystylefood.com",864],["helloadamsfamily.com",864],["lanternlanedesigns.com",864],["mallorynikolaus.com",864],["mommyshomecooking.com",[864,1393]],["splashoftaste.com",[864,1654]],["sweetteaandthyme.com",864],["thelittlehollythatcould.com",864],["thesuburbanmom.com",864],["tosimplyinspire.com",864],["withspice.com",864],["economipedia.com",867],["ecowatch.com",868],["edenfantasys.com",869],["edikted.com",870],["eenewseurope.com",872],["ef.com",873],["efe.com",874],["efinancialcareers-gulf.com",875],["egmnow.com",876],["elespanol.com",877],["snackstack.net",[878,1124]],["elgato.com",879],["elimento.com",880],["elordenmundial.com",881],["elpais.com",882],["elplural.com",883],["elsalvadorsurfrealestate.com",884],["eluniverso.com",885],["emergingtechbrew.com",886],["emianalysis.com",887],["empr.com",888],["endocrinologyadvisor.com",888],["hematologyadvisor.com",888],["mcknights.com",[888,1346]],["mcknightshomecare.com",[888,1346]],["medicalbag.com",888],["neurologyadvisor.com",[888,1447]],["ophthalmologyadvisor.com",[888,1447]],["optometryadvisor.com",[888,1447]],["thecardiologyadvisor.com",888],["endocrineweb.com",889],["eneba.com",890],["energylivenews.com",891],["enjoybot.com",892],["enotes.com",893],["entrepreneur.com",894],["epomaker.com",895],["esologs.com",896],["fflogs.com",[896,950]],["swtorlogs.com",896],["warcraftlogs.com",896],["esportsawards.com",897],["esquireme.com",898],["fedsmith.com",898],["catfox.life",898],["essence.com",899],["ethostimes.com",900],["madelinekopp.com",[900,1321]],["eugeneweekly.com",902],["euromaidanpress.com",903],["euroweeklynews.com",904],["discussion.evernote.com",905],["prestashop.com",905],["everout.com",906],["everyday-reading.com",907],["everydaycheapskate.com",908],["nextplatform.com",[908,1468]],["everythingrf.com",909],["evolvepolitics.com",911],["evreporter.com",913],["mustsharenews.com",913],["eweek.com",914],["techrepublic.com",[914,1833]],["executivegov.com",915],["expatexplore.com",916],["expquebec.com",916],["vadimkravcenko.com",916],["vat19.com",916],["expediacruises.com",917],["experts-exchange.com",918],["expressvpn.com",919],["extremetech.com",[920,921]],["fabriziovanmarciano.com",922],["facebook.com",923],["facebookcorewwwi.onion",923],["facebookwkhpilnemxj7asaniu7vnjjbiltxjqhye3mhbshg7kx5tfyd.onion",923],["b-m.facebook.com",924],["iphone.beta.facebook.com",924],["m.beta.facebook.com",924],["mtouch.beta.facebook.com",924],["touch.beta.facebook.com",924],["x.beta.facebook.com",924],["iphone.facebook.com",924],["m.facebook.com",924],["mobile.facebook.com",924],["mtouch.facebook.com",924],["touch.facebook.com",924],["x.facebook.com",924],["b-m.facebookcorewwwi.onion",924],["touch.beta.facebookcorewwwi.onion",924],["iphone.facebookcorewwwi.onion",924],["m.facebookcorewwwi.onion",924],["mobile.facebookcorewwwi.onion",924],["mtouch.facebookcorewwwi.onion",924],["touch.facebookcorewwwi.onion",924],["x.facebookcorewwwi.onion",924],["b-m.facebookwkhpilnemxj7asaniu7vnjjbiltxjqhye3mhbshg7kx5tfyd.onion",924],["touch.beta.facebookwkhpilnemxj7asaniu7vnjjbiltxjqhye3mhbshg7kx5tfyd.onion",924],["iphone.facebookwkhpilnemxj7asaniu7vnjjbiltxjqhye3mhbshg7kx5tfyd.onion",924],["m.facebookwkhpilnemxj7asaniu7vnjjbiltxjqhye3mhbshg7kx5tfyd.onion",924],["mobile.facebookwkhpilnemxj7asaniu7vnjjbiltxjqhye3mhbshg7kx5tfyd.onion",924],["mtouch.facebookwkhpilnemxj7asaniu7vnjjbiltxjqhye3mhbshg7kx5tfyd.onion",924],["touch.facebookwkhpilnemxj7asaniu7vnjjbiltxjqhye3mhbshg7kx5tfyd.onion",924],["x.facebookwkhpilnemxj7asaniu7vnjjbiltxjqhye3mhbshg7kx5tfyd.onion",924],["factinate.com",925],["tennesseestar.com",[926,1844]],["faithwire.com",[927,928]],["just-food.com",927],["naval-technology.com",[927,1439]],["railway-technology.com",[927,1629]],["retail-insight-network.com",[927,1629]],["verdict.co.uk",[927,1629]],["fakartany.com",929],["loopchicago.com",929],["loopnet.com",929],["nintendonews.com",929],["piccalil.li",929],["ensemblemagazine.co.nz",[929,2501]],["tbn.org",929],["iai.tv",[929,2722]],["fandomwire.com",930],["fangoria.com",931],["fashionmagazine.com",933],["fashionnetwork.com",934],["fashionrepublicmagazine.com",935],["hollywoodunlocked.com",935],["travelcaffeine.com",935],["fastcompany.com",[936,937]],["fastxmovie.com",938],["missionimpossible.com",938],["teenagemutantninjaturtlesmovie.com",938],["transformersmovie.com",938],["thesupermariobros.movie",938],["fatherly.com",[939,940]],["mic.com",939],["romper.com",939],["fatquartershop.com",941],["gadgets-africa.com",941],["webmd.com",[941,2083]],["jam-news.net",941],["ijnet.org",941],["favesouthernrecipes.com",942],["favfamilyrecipes.com",943],["federalnewsnetwork.com",945],["feedspot.com",[946,947,948]],["fender.com",949],["fierce-network.com",951],["filmaffinity.com",953],["finbold.com",954],["findlaw.com",955],["topgear.nl",955],["fine-day.com",956],["fingerhut.com",957],["firmdalehotels.com",958],["fivebooks.com",959],["fivehearthome.com",[960,961]],["wyofile.com",960],["thenovicechefblog.com",961],["flashbak.com",962],["saludmovil.com",962],["geneticliteracyproject.org",[962,2578]],["wealthydoc.org",962],["flatpanelshd.com",963],["floridasportsman.com",964],["flovitamins.com",966],["flypgs.com",967],["flytrippers.com",968],["focusrisparmio.com",969],["outsystems.com",969],["foliosociety.com",970],["food52.com",971],["forbes.com",973],["foreignaffairs.com",[975,976,977]],["monocle.com",976],["billboard.it",978],["foreignpolicy.com",979],["forksoverknives.com",[980,981]],["history-computer.com",981],["fortune.com",982],["fotor.com",984],["outkick.com",986],["franklincounty-news.com",987],["cineguru.screenweek.it",987],["frankmerenda.com",988],["frankwatching.com",989],["fredmeyer.com",990],["freemans.com",991],["freethink.com",992],["freevector.com",993],["freightwaves.com",994],["frequentmiler.com",995],["sonomamag.com",[995,1754]],["freshoffthegrid.com",997],["freshplaza.com",998],["lgbtqnation.com",1002],["forecourttrader.co.uk",1005],["ft.com",1006],["ftaonline.com",1007],["trend-online.com",1007],["futurism.com",1008],["fxstreet.com",1009],["gallup.com",1010],["gamechangersmovie.com",1011],["html5.gamedistribution.com",1013],["gamespot.com",1014],["ganjapreneur.com",1015],["gatesnotes.com",1016],["gatewayhispanic.com",1017],["gayemagazine.com",1018],["gazelle.com",1019],["gazette.com",1020],["gazoo.com",1021],["gcaptain.com",1022],["gearpatrol.com",1024],["geekbuying.com",1025],["geektyper.com",1026],["geekwire.com",1027],["genuine-people.com",1028],["getintopc.com",1031],["getlatka.com",1032],["getrxd.com",1033],["getyourguide.com",1034],["ghpage.com",1036],["givemesport.com",1037],["pocket-lint.com",1037],["thethings.com",1037],["backyardboss.net",1037],["glassblocktint.com",1038],["glassons.com",1040],["hallensteins.com",1040],["insights.globalspec.com",1041],["globoshoes.com",1042],["gobankingrates.com",1043],["goldderby.com",1044],["goldmansachs.com",1045],["goodnes.com",1046],["goodwillfinds.com",1048],["gothamist.com",1049],["gourmetfoodstore.com",1050],["gpulive.com",1053],["grandhotelcalciomercato.com",1054],["greatist.com",1056],["psychcentral.com",1056],["greatnorthernrail.com",1057],["southernrailway.com",1057],["greatvaluevacations.com",1058],["greenbiz.com",[1059,1060]],["iranwire.com",1060],["lifesitenews.com",1060],["payloadspace.com",1060],["proofpoint.com",1060],["techtimes.com",1060],["greenbuildingadvisor.com",1061],["groceryoutlet.com",1062],["groupon.com",1064],["livingsocial.com",1064],["groupon.ie",1064],["groupon.co.uk",1064],["gsmserver.com",1065],["guernicamag.com",1066],["newreleasesnow.com",1066],["outinsa.com",1066],["audubon.org",[1066,1089,2539]],["guidedoc.com",1067],["guidingtech.com",1068],["guitarcenter.com",1069],["gujaratsamachar.com",1070],["gulf-times.com",1071],["gulfnews.com",1072],["gunsandammo.com",1074],["guru99.com",1075],["melaniecooks.com",[1075,1361]],["bucketlistjourney.net",1075],["goodnewsnetwork.org",1075],["gurufocus.com",1076],["gwaramedia.com",1078],["gwr.com",1079],["gzeromedia.com",1080],["haaretz.com",1081],["hackaday.com",1082],["hagerty.com",1083],["hakaimagazine.com",1084],["hammacher.com",1085],["hamodia.com",1086],["happy-trail.com",1087],["haproxy.com",1088],["harborfreight.com",1089],["hartfordbusiness.com",1090],["hartmannreport.com",1091],["splash247.com",1091],["thedefensepost.com",1091],["wonkette.com",[1091,1354]],["corrieredellumbria.it",1091],["corrierediarezzo.it",1091],["corrieredisiena.it",1091],["kingattitude.it",1091],["hawaiitribune-herald.com",1092],["wccftech.com",1092],["health.com",1093],["lifewire.com",[1093,1296]],["healthcareitnews.com",1094],["mobihealthnews.com",1094],["healthitsecurity.com",1095],["healthleadersmedia.com",1096],["healthshots.com",1097],["healthyceleb.com",1098],["hellenicshippingnews.com",1101],["hellmanns.com",1102],["hellomagazine.com",1103],["hendersonville.com",1104],["hentainhaven.com",1105],["hepper.com",1106],["herbiesheadshop.com",[1108,1109]],["ukragroconsult.com",1108],["hereisoregon.com",1110],["heroescommunity.com",1111],["heysocal.com",1112],["hiddenvalley.com",1113],["hificentre.com",1114],["highsnobiety.com",1115],["highya.com",1116],["hilltimes.com",1117],["hindustantimes.com",1118],["tech.hindustantimes.com",1119],["timesnownews.com",[1119,1963]],["hiphopwired.com",1121],["newsone.com",1121],["hippieshine.com",1122],["simpurelife.com",1122],["workprotools.store",1122],["totallypersonal.co.uk",1122],["hiresaudiocentral.com",1123],["historiccity.com",1124],["ianbetteridge.com",1124],["liamodell.com",1124],["vvng.com",1124],["skepchick.org",1124],["parade.com",[1126,1550]],["hket.com",1127],["hmart.com",1128],["hntrbrk.com",1129],["hobbylobby.com",1130],["hola.com",1131],["hollywoodinsider.com",1132],["hollywoodlife.com",1133],["holyrood.com",1134],["homary.com",1135],["homecookingadventure.com",1136],["hongkongfp.com",1137],["newsroom.co.nz",[1137,2509]],["hoorayteams.com",1138],["hot-dinners.com",1140],["housefresh.com",1141],["houzz.com",1142],["hudsonappliance.com",1144],["laredoute.fr",1145],["hugolescargot.com",1146],["journaldunet.com",1146],["linternaute.com",1146],["journaldesfemmes.fr",1146],["ccm.net",1146],["commentcamarche.net",1146],["humansbefree.com",1147],["momfabulous.com",1147],["pymnts.com",[1147,1613]],["wersm.com",1147],["mpost.io",1147],["insidethemagic.net",1147],["hypebae.com",1148],["hypebeast.com",1149],["hyperallergic.com",1150],["ibtimes.com",1151],["ibtimes.co.uk",1151],["idahopress.com",1152],["screenshot-media.com",[1154,1706]],["justdetention.org",1154],["ign.com",1157],["iherb.com",1158],["iliketomakestuff.com",1159],["imgur.com",1160],["independent.com",1161],["sportsspectrum.com",1161],["christiannews.net",1161],["independentmail.com",1162],["northjersey.com",1162],["indiainfoline.com",1163],["auto.economictimes.indiatimes.com",1165],["indiegogo.com",1166],["indyweek.com",1167],["thefrisc.com",[1167,1894]],["wisconsinwatch.org",1167],["inferless.com",1168],["infodocket.com",1169],["inov-8.com",1171],["insideottawavalley.com",1177],["insider-gaming.com",1178],["insiderintelligence.com",1179],["insidermedia.com",1180],["folklife.si.edu",1180],["insidesources.com",1181],["instagram.com",1182],["insurancebusinessmag.com",1183],["interestingengineering.com",1186],["interviewcake.com",1188],["intomore.com",1190],["inverse.com",1191],["investmentexecutive.com",1192],["investmentnews.com",1193],["investors.com",1194],["lightreading.com",1196],["ip2location.com",1197],["ipatriot.com",1198],["ipmark.com",1199],["ipowerqueen.com",1200],["socialitelife.com",1200],["aihome.com.my",1200],["ipwatchdog.com",1201],["irishexaminer.com",1202],["israelhayom.com",1204],["israellycool.com",1205],["israelnationalnews.com",1206],["italia-informa.com",1207],["therighthairstyles.com",1210],["historynewsnetwork.org",1210],["hnn.us",1210],["jagranjosh.com",1211],["qz.com",[1212,1621]],["jamaica-gleaner.com",1213],["jared.com",1214],["zales.com",1214],["jaysresales.com",1215],["jcrew.com",1216],["jeuxvideo-live.com",1217],["jewishexponent.com",1218],["jewishpress.com",1220],["jewishworldreview.com",1221],["jif.com",1222],["jingdaily.com",1223],["jobrapido.com",1224],["jocooks.com",1225],["johnsonfitness.com",1226],["joydeepdeb.com",1227],["jpost.com",1228],["julieroys.com",1229],["justapack.com",1230],["justapinch.com",1231],["law.justia.com",1233],["justthenews.com",[1234,1235]],["happinez.de",1234],["ionos.de",1235],["juventus.com",1236],["katesbestrecipes.com",1237],["katespade.com",1238],["kayak.com",1239],["kbb.com",1240],["keybr.com",1241],["keychron.com",1242],["kftv.com",1243],["khaleejtimes.com",1244],["kilgorenewsherald.com",1245],["kimkazandi.com",1246],["kingarthurbaking.com",1247],["kiplinger.com",1248],["kissanadu.com",1249],["kitchenaid.com",1250],["kitchenparade.com",1251],["kitchentime.com",1252],["kitchentime.de",1252],["kitchentime.dk",1252],["kitchentime.fi",1252],["kitchentime.no",1252],["kitchentime.se",1252],["earthsky.org",[1253,2564]],["kivitv.com",1254],["kiwi.com",1255],["mdjonline.com",1256],["knewz.com",1257],["knowyourmeme.com",1258],["ksl.com",1260],["labrujulaverde.com",1262],["lacolon.com",1263],["lafocusnews.com",1264],["laist.com",1265],["lakegenevacountrymeats.com",1266],["lakeside.com",1267],["ltdcommodities.com",1267],["lalanguefrancaise.com",1268],["lamusica.com",1269],["blog.lastpass.com",1270],["latina.com",1272],["laughingsquid.com",1273],["launer.com",1274],["lauramercier.com",1275],["laverdadnoticias.com",1277],["law.com",[1278,1279]],["magiclen.org",[1279,2606]],["lawandcrime.com",[1280,1281]],["mediaite.com",1280],["lazycatkitchen.com",1282],["nintendosoup.com",1282],["politik.co.nz",[1282,2513]],["thehappyfoodie.co.uk",1282],["leer.com",1283],["leevalley.com",1284],["lemonstripes.com",1285],["rairfoundation.com",1285],["lerobert.com",1286],["lesmobiles.com",1287],["levernews.com",1288],["levi.com",1289],["lewdzone.com",1290],["nodejs.libhunt.com",1292],["librotea.com",1293],["lifemadesweeter.com",1294],["lifenews.com",1295],["lilysilk.com",[1297,1298]],["tpain.com",1297],["blog.rootsofprogress.org",1297],["linenbee.com",[1299,1300]],["olaproducts.co.nz",1299],["thegame.cool",1300],["linkedin.com",1301],["linuxiac.com",1302],["outlook.live.com",1304],["livecoinwatch.com",1305],["livemint.com",1306],["lizzomusic.com",1307],["llbean.com",1308],["lmtribune.com",1309],["logisticsit.com",1310],["logitech.com",1311],["logicool.co.jp",1311],["logitechg.com",1312],["londonrestaurantfestival.com",1313],["lonelyplanet.com",1314],["metro.us",[1315,2785]],["lorientlejour.com",1316],["loveandlemons.com",1317],["forums.macrumors.com",1319],["made-in-china.com",1320],["tv.mademyday.com",1322],["magnetomagazine.com",1324],["maketecheasier.com",1325],["mandmdirect.com",1326],["sparknotes.com",1326],["shop.mango.com",1327],["manofmany.com",1328],["mapyourshow.com",1329],["marinelink.com",1330],["marinetechnologynews.com",1330],["worldenergynews.com",1330],["markammay.com",1331],["marketbeat.com",1332],["marshallheadphones.com",1334],["massispost.com",1336],["masterclass.com",1337],["matadornetwork.com",1338],["mathrubhumi.com",1339],["mbconfidential.com",1341],["tweaktown.com",[1342,2011]],["mccormick.com",1343],["mcguckin.com",1344],["mckinsey.com",1345],["me3tweaks.com",1347],["meatpoultry.com",1348],["supermarketperimeter.com",1348],["world-grain.com",1348],["petfoodprocessing.net",1348],["mediadump.com",1351],["ogbongeblog.com",1351],["mediapost.com",1352],["mediatrust.com",1353],["medicaldaily.com",[1354,1355]],["medicalnewstoday.com",1356],["medicalxpress.com",1357],["techxplore.com",1357],["phys.org",1357],["medicinenet.com",1358],["medium.com",1359],["codeburst.io",1359],["medpagetoday.com",1360],["melodijolola.com",1362],["meltingpot.com",1363],["memeburn.com",1364],["ventureburn.com",1364],["menafn.com",1365],["menards.com",1366],["merchoid.com",1367],["en.mercopress.com",1368],["merriam-webster.com",1370],["metropoles.com",1371],["metv.com",1372],["microperfumes.com",1373],["middleeastmonitor.com",1375],["mightyskins.com",1376],["pinkstork.com",1376],["milwaukeetool.com",1377],["mindbodygreen.com",1378],["minds.com",1379],["minimalistbaker.com",1381],["mining.com",1382],["minitool.com",1383],["minnpost.com",1384],["minotdailynews.com",1385],["miningjournal.net",1385],["minted.com",1386],["misterworker.com",1387],["mmoga.com",1388],["mmoga.de",1388],["mmoga.es",1388],["mmoga.fr",1388],["mmoga.se",1388],["mmoga.co.uk",1388],["mobilesyrup.com",1389],["modesens.com",1390],["modrinth.com",1391],["download.mokeedev.com",1392],["monarchmoney.com",[1395,1396]],["zerohedge.com",[1396,2128]],["money.com",1397],["moneysavingexpert.com",1400],["moneysavingmom.com",1401],["monochrome-watches.com",1402],["moonpalacecancun.com",1403],["motortrend.com",1408],["mountaintopwebdesign.com",1409],["mountainwarehouse.com",1410],["moving2canada.com",1411],["mrfood.com",1412],["mrporter.com",1413],["msnbc.com",1415],["mummytravels.com",1416],["musicbusinessworldwide.com",1418],["musiciansfriend.com",1419],["musictimes.com",1420],["mv-voice.com",[1421,1422]],["paloaltoonline.com",[1421,1547]],["mygenefood.com",1424],["mygermanyvacation.com",1425],["dev.mysql.com",1427],["nadidetarifler.com",1428],["namelymarly.com",1429],["nashvillescene.com",1430],["natashaskitchen.com",1431],["nationalgeographic.com",1432],["nationalreview.com",1434],["nationaltoday.com",1435],["naturalnews.com",1436],["nature.com",1437],["navafresh.com",1438],["ncaa.com",1440],["ndtvprofit.com",1442],["nectarsleep.com",1443],["neonyxcruises.com",1444],["nerdist.com",1445],["nerdwallet.com",1446],["neurosciencenews.com",1448],["newarab.com",1449],["fbi.gov",1449],["puck.news",1449],["alaraby.co.uk",[1449,2728]],["newblueontario.com",1450],["newmobility.com",1451],["newportjerkycompany.com",1452],["news-daily.com",1454],["newsbreak.com",1456],["newsbtc.com",1457],["newscientist.com",1458],["newsday.com",1459],["iltelegrafolivorno.it",1459],["sslazio.it",1459],["newslinet.com",1460],["newsmax.com",1461],["newstarget.com",1462],["cnnsofake.news",[1462,2443]],["collapse.news",1462],["health.news",[1462,2443]],["trump.news",[1462,2443]],["veteranstoday.news",1462],["newstatesman.com",1463],["newyorker.com",[1465,1466]],["blog.phylum.io",1466],["kommersant.uk",[1466,2201]],["newyorkhauntedhouses.com",1467],["nfcw.com",1469],["nfib.com",1470],["nfm.com",1471],["ngpstoreusa.com",1472],["nikkei.com",1473],["asia.nikkei.com",1474],["niteize.com",1475],["nitrokey.com",1476],["nj.com",1477],["nme.com",1478],["nomadicmatt.com",1480],["nordstrom.com",1481],["nostalgiaproducts.com",1483],["notateslaapp.com",1484],["noticiasaominuto.com",1485],["nowness.com",1488],["nowtoronto.com",1489],["nplusonemag.com",1490],["nscale.com",1491],["nsmb.com",1492],["ntd.com",1493],["numero.com",1494],["nutriciously.com",1495],["blogs.nvidia.com",1497],["nyanpedia.com",1499],["nymag.com",1500],["thecut.com",1500],["vulture.com",1500],["nypost.com",1501],["pagesix.com",1501],["nytimes.com",1503],["cooking.nytimes.com",1504],["nzgeo.com",1505],["oakandluna.com",1506],["oann.com",1507],["oantagonista.com",1508],["observer.com",1509],["offers.com",1510],["oilprice.com",1512],["okmagazine.com",1513],["oled-info.com",1514],["olivemagazine.com",1515],["omnivorescookbook.com",1516],["onebioshop.com",1519],["onlinepokerreport.com",1521],["onlyinyourstate.com",1522],["ooni.com",1523],["openculture.com",1524],["leadership.ng",1524],["openspeedtest.com",1525],["oregonlive.com",1528],["oreilly.com",1529],["orilliamatters.com",1530],["orlandosentinel.com",1531],["orlygift.com",1532],["otakumode.com",1533],["otakuusamagazine.com",1534],["powerlineblog.com",[1534,1594]],["otcmarkets.com",1535],["otomobilgunluklerim.com",1536],["outdoorlife.com",1538],["outdoorstatus.com",1539],["output.com",1540],["outsideonline.com",1541],["triathlete.com",1541],["oxygen.com",1543],["ozy.com",1544],["paceathletic.com",1545],["frontrunnercolombo.co.nz",1545],["pambianconews.com",1548],["thescoop.us",1548],["papermag.com",1549],["patheos.com",1552],["paydaythegame.com",1553],["pbteen.com",1554],["potterybarnkids.com",1554],["pcastuces.com",1555],["pcliquidations.com",1557],["pcmag.com",1558],["peacocktv.com",1559],["peanutbutterrunner.com",1560],["pennlive.com",1561],["perfectdailygrind.com",1562],["permanentstyle.com",1563],["petitchef.com",1564],["petitchef.es",1564],["kongnews.it",1564],["petitchef.it",1564],["petri.com",1566],["petrimazepa.com",1567],["philadelphiaherald.com",1568],["thechainsaw.com",1568],["bitdegree.org",1568],["philstar.com",1569],["theamericanscholar.org",[1569,2661]],["photopea.com",1570],["physicsworld.com",1571],["pianu.com",1572],["pillser.com",1573],["pinkvilla.com",1574],["planete-205.com",1576],["plantpowercouple.com",1577],["playbuzz.com",1578],["playpilot.com",1579],["plough.com",1581],["poeapp.com",1582],["pokcas.com",1583],["politico.com",1584],["politicshome.com",1585],["theverge.com",1587],["popculture.com",1589],["popsugar.com",1590],["thedodo.com",1590],["pornfd.com",1591],["postandcourier.com",[1592,1593]],["propertywheel.co.za",[1594,2805]],["prdaily.com",1595],["prepinsta.com",1596],["pressdemocrat.com",1598],["primerahora.com",1599],["printmag.com",1600],["prohockeylife.com",1601],["protocol.com",1603],["prowritingaid.com",1604],["proxfree.com",1605],["psychologies.com",1606],["ptable.com",1607],["publiclands.com",1608],["publishersweekly.com",1610],["punchdrink.com",1612],["qd-europe.com",1614],["qsrmagazine.com",1615],["quadraphonicquad.com",1616],["quillette.com",1617],["quipmag.com",1618],["quizlet.com",1619],["quora.com",1620],["r7.com",1622],["racingamerica.com",1623],["racked.com",1624],["racketboy.com",1625],["radaronline.com",1626],["railmarket.com",1627],["railtech.com",1628],["automobielmanagement.nl",1628],["fleet-mobility.nl",[1628,2456]],["mobiliteit.nl",1628],["schuttevaer.nl",1628],["randomlists.com",1630],["ranker.com",1631],["ratebeer.com",1632],["rawstory.com",1633],["rcrwireless.com",1635],["rebelnews.com",1640],["recipetips.com",1642],["recyclingproductnews.com",1643],["reddit.com",1644],["rediff.com",1645],["refinery29.com",1647],["regex101.com",1648],["regexr.com",1649],["rei.com",1650],["reigningchamp.com",[1651,1652]],["shop.reigningchamp.com",[1651,1652]],["ruralking.com",1652],["religionnews.com",1653],["reluctantentertainer.com",1654],["lmld.org",1654],["remotelyawesomejobs.com",1655],["renodepot.com",1656],["repasdelice.com",1657],["blog.resy.com",1658],["retailwire.com",1659],["softwaretestinghelp.com",1659],["retbit.com",1660],["reuters.com",1661],["revouninstaller.com",1665],["revzilla.com",1666],["rhino.com",1667],["righto.com",1668],["ringkestore.com",1670],["ripleys.com",1671],["riverbender.com",1672],["robbreport.com",1674],["robinsonsshoes.com",1675],["www.rockpapershotgun.com",1676],["thepopverse.com",1676],["vg247.com",1676],["eurogamer.net",1676],["romania-insider.com",1677],["rootforamerica.com",1678],["rosegal.com",1679],["rottentomatoes.com",1680],["rt.com",[1681,1682]],["freedert.online",1681],["esrt.space",1681],["rtde.tech",1681],["rtings.com",1683],["sacurrent.com",1684],["salary.com",1686],["salud180.com",1689],["samsclub.com",1690],["sandiegoreader.com",1692],["chan.sankakucomplex.com",1693],["sap-press.com",1694],["saturdayeveningpost.com",1695],["saveur.com",1696],["forum.sbenny.com",1697],["schottnyc.com",1698],["sciencefocus.com",1699],["trains.com",[1699,1991]],["scientificamerican.com",1700],["scientificcoder.com",1701],["scmp.com",1702],["screenbinge.com",1704],["scrolller.com",1707],["scworld.com",1708],["sdxcentral.com",1709],["searchenginejournal.com",1710],["searchengineland.com",1711],["seatguru.com",1712],["sebgorka.com",1713],["secretchicago.com",1714],["securelist.com",1715],["securityboulevard.com",1716],["torontoguardian.com",[1716,1981]],["semafor.com",1718],["sentinelone.com",1719],["seroundtable.com",1720],["servedez.com",1721],["sevendaysvt.com",1722],["pinlight.eu",1722],["sfgate.com",1723],["shein.com",1725],["shenandoahah.com",1726],["shieldsgazette.com",1727],["shopcjglobal.com",1728],["shopkitchenclique.com",1729],["shoppingsouthparkmall.com",1730],["shtfplan.com",1731],["signalfestival.com",1732],["simonandschuster.com",1733],["simpleanalytics.com",1734],["simpleflying.com",1735],["community.simtropolis.com",1736],["skydio.com",1737],["web.skype.com",1738],["sleepworld.com",1740],["sltrib.com",1741],["smartertravel.com",1742],["smashingmagazine.com",1743],["smithsonianmag.com",1744],["sneakernews.com",1745],["snocountry.com",1746],["snopes.com",1747],["socialblade.com",1749],["softlaunchlondon.com",[1750,1751]],["takebackourtech.org",1751],["northdevongazette.co.uk",1751],["solestop.com",1752],["lambland.co.uk",1752],["soleyama.com",1753],["safetyfirstaid.co.uk",[1753,2764]],["soundandvision.com",1755],["sourcegraph.com",1756],["southerndiscourse.com",1757],["spacenews.com",1758],["spaceref.com",1759],["spanishdict.com",1760],["sperry.com",1761],["community.spiceworks.com",1762],["sportsbusinessjournal.com",1765],["sportskeeda.com",1766],["sportsline.com",1767],["sportsmans.com",1768],["sportspromedia.com",1769],["sputnikglobe.com",1770],["squidboards.com",1771],["stamen.com",1772],["staples.com",1773],["startrek.com",1775],["starttv.com",1776],["statcounter.com",1777],["statista.com",1778],["statnews.com",1779],["steakschool.com",1780],["steamcollector.com",1781],["steamdeckhq.com",1782],["2night.it",1784],["stevensducks.com",1785],["stgeorgeutah.com",1786],["stoneberry.com",1787],["stopmandatoryvaccination.com",1788],["straitstimes.com",1789],["stripes.com",1790],["stylewe.com",1791],["suncoastparts.com",1794],["sunsetmicro.com",1796],["superwatchman.com",1797],["sweepstakesfanatics.com",1798],["sweetwater.com",1800],["swiggy.com",1801],["syfy.com",1802],["sysdig.com",1803],["tabstats.com",1804],["takealot.com",1805],["talkingpointsmemo.com",1807],["tampabay.com",1808],["tanga.com",1809],["target.com",1810],["taskandpurpose.com",1811],["thedrive.com",[1811,1882]],["taurususa.com",1814],["taylorswift.com",1815],["team17.com",1816],["teamaretuza.com",1817],["techcabal.com",1818],["techcrunch.com",1819],["techerati.com",1820],["techfirstnow.com",1821],["techforbrains.com",1822],["techforless.com",1823],["techgenix.com",1824],["techgenyz.com",1825],["techinformed.com",1826],["techmeme.com",1827],["technologynetworks.com",1828],["technologyreview.com",1829],["techonomy.com",1830],["techopedia.com",1831],["techpout.com",1832],["techstudiomumbai.com",1834],["techtobo.com",1835],["techwalla.com",1836],["teepop.com",1838],["teleticketservice.com",1839],["telva.com",1840],["temu.com",1841],["tenable.com",1842],["tenaquip.com",1843],["texasmonthly.com",1845],["thartribune.com",1846],["the-independent.com",1847],["the-sun.com",[1849,1850]],["thesun.ie",1849],["thesun.co.uk",1849],["the18.com",1851],["theadvocate.com",1852],["theamericanconservative.com",1854],["theanalyst.com",1855],["theasianparent.com",1856],["theatlantic.com",1857],["thebaltimorebanner.com",1859],["thebarentsobserver.com",1860],["thebluebonnetfarmhouse.com",1863],["thebolditalic.com",1864],["thebrokebackpacker.com",1865],["thebudgetsavvybride.com",1866],["thecaterer.com",[1867,1868]],["magyarnemzet.hu",1868],["veol.hu",1868],["vg.hu",1868],["faroutmagazine.co.uk",1868],["thechurchnews.com",1869],["theclever.com",1870],["thecoastnews.com",1871],["brics.it",[1872,2337]],["thecooldown.com",[1873,1874]],["wanderlust.co.uk",1874],["thecourier.com",1875],["theculturetrip.com",1876],["thecurrent.com",1877],["thedailybeast.com",1878],["thedevicedepot.com",1879],["thediscoveriesof.com",1880],["thedrinksbusiness.com",1881],["thedrum.com",1883],["theepochtimes.com",1885],["theevreport.com",1886],["thefabricator.com",1887],["thefader.com",1888],["thefastmode.com",1889],["thefinancialdiet.com",1890],["thefinancialist.com",1891],["thefp.com",1893],["thegadgetflow.com",1895],["thegatewaypundit.com",1896],["theglobeandmail.com",1898],["theguardian.com",1900],["thehackernews.com",[1901,1902]],["yardbarker.com",1902],["thehandbook.com",1903],["thehaul.com",1904],["thehouseofportable.com",1906],["theinertia.com",1907],["theinfatuation.com",1908],["theinspiredhome.com",1909],["theintercept.com",1910],["thelondoneconomic.com",1914],["washingtoncitypaper.com",1914],["thelostavocado.com",1915],["themighty.com",1916],["themodernproper.com",1917],["themoscowtimes.com",1919],["thenationalnews.com",1921],["thenationalpulse.com",1922],["thenewcivilrightsmovement.com",1923],["judicialwatch.org",[1923,2590]],["thenextweb.com",1924],["thenib.com",1925],["thepickool.com",1926],["thepinknews.com",1927],["thepitchkc.com",1928],["theprovince.com",1931],["thequantuminsider.com",1932],["therealdeal.com",1933],["therealnews.com",1934],["thescore.com",1935],["theskimm.com",1936],["thestreet.com",1938],["thesuburban.com",1939],["thetech.com",1940],["thetoyinsider.com",1941],["theurbanlist.com",1943],["theweek.com",1944],["thewellnesscorner.com",1945],["thewildest.com",1946],["thewrap.com",1947],["thisisfutbol.com",1948],["thisoldhouse.com",1949],["thomasnet.com",1950],["thomaspink.com",1951],["thomhartmann.com",1952],["thorne.com",1953],["thoughtbot.com",1954],["thredup.com",1955],["thrillist.com",1956],["tidbits.com",1958],["timeanddate.com",1960],["timeout.com",1961],["m.timesofindia.com",1964],["tirerack.com",1966],["jimnong.tistory.com",1967],["tkmaxx.com",1968],["tmz.com",1969],["tnmt.com",1970],["todomecanica.com",1971],["twilog.togetter.com",1972],["tomklingenstein.com",1973],["tomtop.com",1974],["topgear.com",1976],["topspeed.com",1977],["toptal.com",1978],["topuniversities.com",1979],["touchy-style.com",1982],["touristengland.com",1983],["touristspy.com",1984],["labhorizons.co.uk",1984],["tourscanner.com",1985],["weinkenner.de",1985],["mole24.it",1985],["technology.org",1985],["tp-link.com",1987],["tracebit.com",1988],["tradeinn.com",1989],["trailspace.com",1990],["traxmag.com",1993],["trendhunter.com",1994],["triblive.com",1995],["trip.com",1996],["trip101.com",1997],["trlnutrition.com",1999],["trutravels.com",2001],["tsunagujapan.com",2002],["ttnews.com",2003],["tumblr.com",2005],["tunein.com",2006],["turningleftforless.com",2007],["tutorialslink.com",2008],["tvline.com",2009],["tvseriesfinale.com",2010],["twitchquotes.com",2012],["twitter.com",[2013,2014]],["x.com",[2013,2014]],["twitter3e4tixl4xyajtrzo62zg5vztmjuricljdp2c5kshju4avyoid.onion",2013],["twz.com",2015],["tycsports.com",2016],["ugreen.com",2017],["ulta.com",2019],["ultimate-guitar.com",2020],["umaar.com",2022],["umterps.com",2023],["unchainedcrypto.com",2024],["unherd.com",2025],["uploadvr.com",2027],["upworthy.com",2028],["reviewed.usatoday.com",2031],["usatrendnow.com",2032],["usnews.com",2033],["money.usnews.com",2034],["utilitydive.com",[2035,2036]],["themarshallproject.org",[2035,2667]],["valetmag.com",2037],["valgourmand.com",2038],["vancouverisawesome.com",2040],["eurasianet.org",2041],["vegancooking.com",2043],["venturebanc.com",2045],["vercapas.com",2047],["verybestbaking.com",2048],["blog.vidizmo.com",2051],["vinepair.com",2052],["virustotal.com",2053],["visitcalifornia.com",2054],["vistashops.com",2055],["visualcapitalist.com",2056],["vitaminworld.com",2057],["vnews.com",2058],["votetw.com",2060],["vox.com",2061],["vozpopuli.com",2062],["uominietrasporti.it",2062],["exchangerates.org.uk",2062],["vrcmods.com",2063],["walgreens.com",2066],["walletinvestor.com",2067],["wallhere.com",2068],["wards.com",2069],["warontherocks.com",2070],["washingtonengager.com",2071],["washingtoninformer.com",2072],["washingtonmonthly.com",2073],["washingtonpost.com",2074],["wayfair.com",2077],["wearemitu.com",2079],["weather.com",2080],["webcodegeeks.com",[2081,2082]],["pcguia.pt",[2081,2082]],["financialissues.org",[2082,2572]],["webpronews.com",2084],["wethegeek.com",2087],["whmi.com",2089],["wholesomeculture.com",2090],["whosampled.com",2092],["whysobeerious.com",2093],["williams-sonoma.com",2095],["windowscentral.com",2096],["winnipegfreepress.com",2097],["wionews.com",2098],["wired.com",2099],["wmagazine.com",2100],["wob.com",2101],["wolverine.com",2102],["worldcrunch.com",2103],["worldisraelnews.com",2104],["worldscreen.com",2105],["worth.com",2106],["worthynews.com",2107],["wtatennis.com",2109],["news.wttw.com",2110],["xbiz.com",2112],["theiconic.co.nz",2112],["thesoapery.co.uk",2112],["xconfessions.com",2113],["xrprightnow.com",2114],["yahoo.com",2115],["news.yahoo.com",2116],["yaoota.com",2117],["desh.co.in",2117],["1news.co.nz",2117],["pgpf.org",2117],["yeprecipes.com",2118],["yoncu.com",2119],["youcouldtravel.com",2120],["m.youtube.com",[2121,2122]],["music.youtube.com",2121],["tv.youtube.com",2121],["www.youtube.com",2121],["youtubekids.com",2121],["zappos.com",2123],["zazzle.com",2124],["zecar.com",2125],["zeldman.com",2126],["zenith-watches.com",2127],["zhulang.com",2129],["zippyupload.com",2131],["zmescience.com",2132],["homestore.zola.com",2133],["zumiez.com",2134],["portal.rozhlas.cz",2135],["tvsatshop.cz",2136],["50plus.de",2137],["berrybase.de",2138],["bitblokes.de",2139],["bluray-disc.de",2140],["buecher.de",2141],["efahrer.chip.de",2142],["clever-tanken.de",2143],["crypto-insiders.de",2144],["crypto-insiders.es",2144],["crypto-insiders.nl",2144],["cube-magazin.de",2145],["deine-tierwelt.de",2146],["deraktionaer.de",2147],["dgb.de",2148],["distrelec.de",2149],["ecomento.de",2150],["filmundtvkamera.de",2151],["focus.de",2152],["focus-gesundheit.de",2153],["gamepro.de",2154],["gamestar.de",2154],["goldinvest.de",2155],["golem.de",2156],["haus.de",2157],["haustec.de",2158],["herz-fuer-tiere.de",2159],["kress.de",2160],["lto.de",2161],["mt.de",2162],["n-tv.de",2163],["netzwelt.de",2164],["nextpit.de",2165],["onlinehaendler-news.de",2166],["posylka.de",2167],["rktbns.de",2168],["silicon.fr",2169],["silicon.pt",2169],["soliver.de",2171],["sonnenverlauf.de",2172],["suncalc.org",2172],["studyflix.de",2173],["studysmarter.de",2174],["kfz-betrieb.vogel.de",2177],["welt.de",2178],["witt-weiden.de",2179],["woolworth.de",2180],["woolworth.pl",2180],["endler.dev",2181],["hamel.dev",2182],["orca-app.dev",2183],["buttondown.email",2183],["vert.eco",2185],["brookings.edu",2186],["caltech.edu",2187],["news.cornell.edu",2188],["escoffier.edu",2189],["folger.edu",2190],["health.harvard.edu",2191],["misinforeview.hks.harvard.edu",2192],["hms.harvard.edu",2193],["thereader.mitpress.mit.edu",2194],["mitsloan.mit.edu",2195],["news.northwestern.edu",2196],["psu.edu",2197],["www.psu.edu",2198],["cidrap.umn.edu",2199],["wusfnews.wusf.usf.edu",2200],["today.wayne.edu",2201],["elmundo.es",2203],["epe.es",2204],["lavozdegalicia.es",2205],["mcdiscount.es",2206],["welife.es",2208],["bandainamcoent.eu",2209],["centrumher.eu",2210],["ftm.eu",2211],["guildstats.eu",2212],["labiotech.eu",2213],["nawozy.eu",2214],["noyb.eu",2215],["ping.eu",2216],["sifted.eu",2217],["techzine.eu",2218],["techzine.nl",2218],["naiz.eus",2220],["olimpstore.f",2221],["iltalehti.fi",2222],["kauppalehti.fi",2223],["talouselama.fi",2223],["tekniikkatalous.fi",2223],["tivi.fi",2223],["uusisuomi.fi",2223],["metsalehti.fi",2224],["mobiili.fi",2225],["moottori.fi",2226],["rakentaja.fi",2227],["suomenmaa.fi",2228],["tempodent.fi",2229],["tyyliniekka.fi",2230],["spring.org.uk",2230],["valitutpalat.fi",2231],["blog.payara.fish",2232],["chorus.fm",2233],["allocine.fr",2234],["brgm.fr",2235],["bruneau.fr",2236],["capital.fr",2237],["casting.fr",2238],["comment-economiser.fr",2239],["dcshoes.fr",2240],["distrelec.fr",2241],["doctissimo.fr",2242],["ecommercemag.fr",2243],["fourchette-et-bikini.fr",2244],["francebleu.fr",2245],["telegraaf.nl",2245],["edweek.org",2245],["orizzontescuola.it",2246],["homap.fr",2248],["hostinger.fr",2249],["italiangourmet.fr",2250],["lamanchelibre.fr",2251],["leparisien.fr",2252],["letelegramme.fr",2253],["lopinion.fr",2254],["loractu.fr",2255],["maison-travaux.fr",2256],["marieclaire.fr",2257],["mariefrance.fr",2258],["optigura.fr",2259],["paruvendu.fr",2260],["sanctuary.fr",2261],["senetic.fr",2262],["viata.fr",2264],["valid.x86.fr",2265],["yonder.fr",2266],["archon.gg",2267],["light.gg",2268],["oneesports.gg",2269],["op.gg",2270],["top.gg",2271],["u.gg",2272],["oag.ca.gov",2274],["census.gov",2275],["commerce.gov",2276],["nppes.cms.hhs.gov",2277],["jpl.nasa.gov",2278],["neh.gov",2279],["usa.gov",2280],["whitehouse.gov",2281],["cosmotetv.gr",2282],["pronews.gr",2284],["taperaki.gr",2285],["am730.com.hk",2286],["oneesports.id",2287],["breakingnews.ie",2288],["businessplus.ie",2289],["businesspost.ie",2290],["dailyedge.ie",2291],["thejournal.ie",2291],["fora.ie",2292],["independent.ie",2293],["rte.ie",2294],["10dakot.co.il",2295],["eurocampings.nl",2296],["weerplaza.nl",2296],["allevents.in",2298],["boomlive.in",2299],["goodreturns.in",2300],["news13.in",2301],["newsclick.in",2302],["peoplematters.in",2303],["sprintmedical.in",2304],["hardware.info",2305],["tarnkappe.info",2306],["thenew.institute",2307],["autodidacts.io",2308],["chemz.io",2309],["cssreference.io",2310],["evades.io",2311],["hackster.io",2312],["helldivers.io",2313],["htmlreference.io",2314],["jojoy.io",2315],["blog.logto.io",2316],["mapgenie.io",2317],["meduza.io",2318],["nuggetroyale.io",2319],["live-adexchanger.pantheonsite.io",2320],["prodvana.io",2321],["readysetcloud.io",2322],["sketchful.io",2323],["thedriven.io",2324],["thenewstack.io",2325],["witz.io",2326],["wormate.io",2327],["presstv.ir",2328],["png.is",2329],["abbonamenti.it",2331],["affaritaliani.it",2332],["auto.it",2333],["bergamonews.it",2334],["bitcity.it",2335],["boatindustry.it",2336],["boatsnews.it",2336],["pescare.news",2336],["dilei.it",2340],["quifinanza.it",2340],["dueruote.it",2341],["editorialedomani.it",2342],["fastweb.it",2343],["funweek.it",2345],["gds.it",2346],["qualenergia.it",2346],["gioconews.it",2347],["ilcittadinomb.it",2349],["ilcorrieredelgiorno.it",2350],["ilgiardinodeilibri.it",2352],["internazionale.it",2353],["leccenews24.it",2354],["mag1861.it",2356],["aforismi.meglio.it",2357],["mentelocale.it",2358],["mrw.it",2359],["visitami.paginemediche.it",2361],["policymakermag.it",2362],["startmag.it",2362],["qvc.it",2363],["td-toys.it",2364],["virgilio.it",2365],["volksbank.it",2366],["bluetti.jp",2367],["video.tv-tokyo.co.jp",2368],["audioreview.m1001.coreserver.jp",2369],["mastory.jp",2370],["go.orixrentec.jp",2371],["somu-lier.jp",2372],["technologyreview.jp",2373],["theletter.jp",2374],["tuko.co.ke",2375],["legit.ng",[2375,2453]],["dot.la",2376],["tonica.la",2377],["lematin.ma",2378],["jorgegalindo.me",2379],["start.me",2380],["landline.media",2381],["therecord.media",2382],["storm.mg",2383],["eluniversal.com.mx",2384],["elinformador.mx",2385],["informador.mx",2385],["expansion.mx",2386],["ancient-origins.net",2387],["athletic.net",2388],["b92.net",2389],["b92s.net",2389],["behance.net",2391],["cepr.net",2393],["crash.net",2394],["blog.csdn.net",2395],["dynomight.net",2396],["electronicintifada.net",2397],["elektroauto-news.net",2398],["financialit.net",2399],["formiche.net",2400],["free-barcode-generator.net",2401],["gigazine.net",2402],["globalchinapulse.net",2403],["hummel.net",2404],["informationisbeautiful.net",2405],["tuc.org.uk",[2407,2783]],["interiordesign.net",2408],["ipsnews.net",2409],["it-daily.net",2410],["lcpshop.net",2411],["lifeinnorway.net",2412],["manilatimes.net",2414],["messitv.net",2416],["metalsucks.net",2417],["middleeasteye.net",2418],["files.minecraftforge.net",2419],["nativenewsonline.net",2420],["neowin.net",2421],["news-medical.net",2422],["osxinfo.net",2424],["particular.net",2425],["zookeys.pensoft.net",2426],["plagiarisma.net",2427],["racefans.net",2428],["context.reverso.net",2429],["shareable.net",2430],["shokuhin.net",2431],["sojo.net",2432],["streetartnews.net",2433],["striketactics.net",2434],["tapinto.net",2435],["techspree.net",2436],["tecnoblog.net",2437],["theplaylist.net",2439],["timesnews.net",2440],["windguru.net",2441],["xeiaso.net",2442],["energy-storage.news",2444],["forkast.news",2445],["grid.news",2446],["handball-world.news",2447],["headlight.news",2448],["premierchristian.news",2450],["tnc.news",2451],["loginhit.com.ng",2452],["aiwereld.nl",2454],["amstelveensnieuwsblad.nl",2455],["baarnschecourant.nl",2455],["barneveldsekrant.nl",2455],["bennekomsnieuwsblad.nl",2455],["biltschecourant.nl",2455],["bunniksnieuws.nl",2455],["denieuwsbode.nl",2455],["deputtenaer.nl",2455],["derijnpost.nl",2455],["destadamersfoort.nl",2455],["destadgorinchem.nl",2455],["dewoudenberger.nl",2455],["edestad.nl",2455],["ermelosweekblad.nl",2455],["harderwijkercourant.nl",2455],["hcnieuws.nl",2455],["hetkompashardinxveld-giessendam.nl",2455],["hetkompassliedrecht.nl",2455],["houtensnieuws.nl",2455],["huisaanhuiselburg.nl",2455],["huisaanhuisoldebroek.nl",2455],["leusderkrant.nl",2455],["nieuwsbladdekaap.nl",2455],["nunspeethuisaanhuis.nl",2455],["recreatiekrantveluwe.nl",2455],["regiosportveenendaal.nl",2455],["rijnenveluwe.nl",2455],["scherpenzeelsekrant.nl",2455],["soestercourant.nl",2455],["stadnijkerk.nl",2455],["stadwageningen.nl",2455],["weekbladvoorouderamstel.nl",2455],["wijksnieuws.nl",2455],["automotive-online.nl",2456],["autoreview.nl",2457],["avantisport.nl",2458],["boerenbusiness.nl",2460],["buienradar.nl",2462],["ct.nl",2464],["deondernemer.nl",2465],["dnb.nl",2466],["drimble.nl",2467],["duic.nl",2468],["dutchcowboys.nl",2469],["eurogamer.nl",2470],["frontpage.fok.nl",2471],["gezondheidsnet.nl",2472],["hartvannederland.nl",2473],["hpdetijd.nl",2474],["id.nl",2475],["iex.nl",[2476,2477]],["tostrams.nl",[2477,2489]],["iexgeld.nl",2478],["independer.nl",2479],["israeltoday.nl",2480],["koffievoordeel.nl",2481],["wijnvoordeel.nl",2481],["kro-ncrv.nl",2482],["mejudice.nl",2483],["micazu.nl",2484],["newsbit.nl",2485],["npokennis.nl",2486],["shespot.nl",2487],["smulderstextiel.nl",2488],["weekbladparty.nl",2490],["weekend-online.nl",2491],["wehkamp.nl",2492],["forsvaretsforum.no",2493],["tuinartikelen.nu",2494],["becextech.co.nz",2495],["bunnings.co.nz",2496],["chemistwarehouse.co.nz",2497],["computerlounge.co.nz",2498],["cosmicnz.co.nz",2499],["drivencarguide.co.nz",2500],["farmersweekly.co.nz",2502],["adventistworld.org",2502],["flashtrend.co.nz",2503],["grabone.co.nz",2504],["harveynorman.co.nz",2505],["livenation.co.nz",2506],["newshub.co.nz",2508],["newstalkzb.co.nz",2510],["nzherald.co.nz",2511],["rouleurcycles.co.nz",2514],["topomap.co.nz",2515],["torpedo7.co.nz",2516],["tradetested.co.nz",2518],["newsline.ccc.govt.nz",2519],["rferlo2zxgv23tct66v45s5mecftol5vod3hf4rqbipfp46fqu2q56ad.onion",2520],["rferl.org",2520],["lindipendente.online",2521],["19thnews.org",2522],["aarp.org",2523],["accessnow.org",2524],["aclu.org",2525],["axial.acs.org",2526],["aei.org",2527],["africacheck.org",2528],["agsiw.org",2529],["aerospaceamerica.aiaa.org",2530],["aleteia.org",2531],["americamagazine.org",2532],["americasquarterly.org",2534],["amnesty.org",2535],["answersingenesis.org",2536],["physics.aps.org",2537],["blockclubchicago.org",2540],["campusreform.org",2542],["carnegieendowment.org",2543],["cartercenter.org",2544],["catholicculture.org",2545],["cathstan.org",2546],["cepa.org",2547],["cfr.org",2548],["citizensforethics.org",2550],["city-journal.org",2551],["clevercreations.org",2553],["commondreams.org",2554],["compellingtruth.org",2555],["concertarchives.org",2556],["consumerreports.org",2557],["ctsbooks.org",2559],["culture.org",2560],["dailysceptic.org",2561],["deansforimpact.org",2562],["democracynow.org",2563],["ecosia.org",2566],["educatedguesswork.org",2567],["factcheck.org",2568],["fides.org",2570],["fightthenewdrug.org",2571],["flotrack.org",2573],["foodandwaterwatch.org",2574],["fsf.org",2575],["futurity.org",2576],["grist.org",2580],["hcn.org",2582],["humanesociety.org",2583],["spectrum.ieee.org",2585],["inhope.org",2586],["insideclimatenews.org",2587],["insightcrime.org",2588],["investigativepost.org",2589],["kffhealthnews.org",2591],["kpbs.org",[2593,2594]],["publicradiotulsa.org",2593],["kqed.org",2595],["kuow.org",2596],["lackofimagination.org",2597],["lareviewofbooks.org",2598],["lawfaremedia.org",2599],["lawliberty.org",2600],["lawyerscommittee.org",2601],["leftfootforward.org",2602],["lenfestinstitute.org",2603],["letsencrypt.org",2604],["marketplace.org",2607],["mayoclinic.org",2609],["mediamatters.org",2610],["meforum.org",2611],["memri.org",2612],["michiganmedicine.org",2613],["minimum-wage.org",2614],["missionlocal.org",2615],["monthlyreview.org",2616],["blog.nightly.mozilla.org",2617],["mrctv.org",2618],["museumcrush.org",2619],["mypenndentist.org",2620],["nature.org",2622],["nawaat.org",2623],["ncronline.org",2624],["nejm.org",2625],["newmexicomagazine.org",2626],["niemanlab.org",2627],["opencv.org",2629],["opensecrets.org",2630],["peoplesworld.org",2632],["pewresearch.org",2633],["pirg.org",2634],["plantbasednews.org",2635],["pnas.org",2636],["privacyinternational.org",2638],["publicintegrity.org",2640],["pv-tech.org",2641],["richmondfed.org",2644],["rightwingwatch.org",2645],["royalsocietypublishing.org",2646],["rsf.org",2647],["schrijvenonline.org",2648],["science.org",2649],["sciencehistory.org",2650],["scriptinghelpers.org",2652],["semanticscholar.org",2653],["strongtowns.org",2657],["texasobserver.org",2658],["texastribune.org",2659],["the74million.org",2660],["thefederalistpapers.org",2663],["thefire.org",2664],["themarginalian.org",2665],["themarkup.org",2666],["themedialine.org",2668],["thenewhumanitarian.org",2669],["theparisreview.org",2670],["theworld.org",2671],["truthout.org",2672],["voiceofsandiego.org",2675],["volunteermatch.org",2676],["wbur.org",2678],["webqc.org",2679],["wgbh.org",2680],["whowhatwhy.org",2681],["ikorektor.pl",2685],["komerso.pl",2686],["portalprzedszkolny.pl",2687],["queer.pl",2688],["zadowolenie.pl",2689],["masternodes.pro",2690],["consul.pt",2691],["dinheirovivo.pt",2692],["idealista.pt",2693],["jn.pt",2694],["observador.pt",2695],["ojogo.pt",2696],["realitycheck.radio",2697],["tmo.report",2698],["bucataras.ro",2699],["kudika.ro",2700],["pbinfo.ro",2701],["klima101.rs",2702],["tonkosti.ru",2704],["tfn.scot",2705],["soldfy.se",2706],["businesstimes.com.sg",2707],["surreyhillsgrocer.sg",2708],["dennikn.sk",2710],["coomer.su",2711],["kemono.su",2711],["mistergadget.tech",2712],["longevity.technology",2713],["nmac.to",2714],["doubledouble.top",2715],["hulnews.top",2716],["haberiniz.com.tr",2717],["abema.tv",2718],["amu.tv",2719],["arynews.tv",2720],["eshentai.tv",2721],["pedestrian.tv",2723],["thepeoplesvoice.tv",2724],["minfin.com.ua",2725],["english.nv.ua",2726],["nhm.ac.uk",2727],["balfesbikes.co.uk",2729],["blackwells.co.uk",2730],["britainsfinest.co.uk",2731],["celticwebmerchant.co.uk",2732],["chargedretail.co.uk",2733],["dailymail.co.uk",2734],["deliciousmagazine.co.uk",2735],["eastendprints.co.uk",2736],["eppingforestguardian.co.uk",2737],["gq-magazine.co.uk",2738],["harbourbookshop.co.uk",2740],["hive.co.uk",2741],["hudsonmarine.co.uk",2742],["ianvisits.co.uk",2743],["inews.co.uk",2745],["inyourarea.co.uk",2746],["jewishnews.co.uk",2747],["jobisjob.co.uk",2748],["legalfutures.co.uk",2749],["literaryreview.co.uk",2750],["markselectrical.co.uk",2752],["masterinvestor.co.uk",2753],["metro.co.uk",2754],["mirror.co.uk",2755],["monkeyoffice.co.uk",2756],["newsshopper.co.uk",2757],["okvape.co.uk",2758],["penguin.co.uk",2759],["politics.co.uk",2760],["pressandjournal.co.uk",2761],["pressgazette.co.uk",2762],["processengineering.co.uk",2763],["sainsburysmagazine.co.uk",2765],["shakeshack.co.uk",2766],["socialistworker.co.uk",2767],["squaremeal.co.uk",2768],["standard.co.uk",2769],["stylist.co.uk",2770],["the-tls.co.uk",2772],["thedarkblues.co.uk",2773],["therailwayhub.co.uk",2774],["thisismoney.co.uk",2775],["virginexperiencedays.co.uk",2776],["wahaca.co.uk",2777],["amnesty.org.uk",2779],["christian.org.uk",2780],["newhumanist.org.uk",2781],["onlineshop.oxfam.org.uk",2782],["healthyone.us",2784],["oceana.mi.us",2786],["nautil.us",2787],["rare.us",2788],["regain.us",2789],["elpais.com.uy",2790],["vaticannews.va",2791],["duhoctrungquoc.vn",2792],["mybroadband.co.za",[2793,2802]],["citizen.co.za",2794],["dispatchlive.co.za",2795],["heraldlive.co.za",2795],["ewn.co.za",2796],["heartfm.co.za",2797],["homemark.co.za",2798],["iol.co.za",2799],["itweb.co.za",2800],["moneyweb.co.za",2801],["onedayonly.co.za",2803],["sahomeowner.co.za",2806],["topauto.co.za",2808],["wined.co.za",2810],["polity.org.za",2811]]);

const entitiesMap = new Map([["funnygames",0],["gomovies-online",1],["pinterest",2],["pornhub",3],["pricespy",4],["pv-magazine",[5,6]],["royalqueenseeds",7],["ymovies",8],["zt-protect",9]]);

const exceptionsMap = new Map(undefined);

self.specificImports = self.specificImports || [];
self.specificImports.push({ argsList, hostnamesMap, entitiesMap, exceptionsMap });

/******************************************************************************/

})();

/******************************************************************************/
