/*******************************************************************************

    uBlock Origin Lite - a comprehensive, MV3-compliant content blocker
    Copyright (C) 2019-present Raymond Hill

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see {http://www.gnu.org/licenses/}.

    Home: https://github.com/gorhill/uBlock
*/

/* jshint esversion:11 */

'use strict';

// ruleset: annoyances-social

/******************************************************************************/

// Important!
// Isolate from global scope
(function uBOL_cssSpecificImports() {

/******************************************************************************/

const argsList = [".social-media-icons-footer",".follow-google","#Share",".article__news-services-subscribe",".social-icons",".youtube-subscriber",".social-share",".social-links",".notapage_sticky",".social",".social-topsharing",".group-redes,\n.redes-left",".share-buttons",".redes",".redes-share",".noticia-social-share",".compartir",".liCompartir",".list-icons",".BarraRedesNot",".share",".share-amp,\n.social-networs",".socialIcons",".socialbar",".tik4-sharing",".al__socials",".mainFooter__socialItem","#socialmedia",".share-dialog",".socials",".social-buttons","#services-sidebar-icons,\n.circle-icons","#sharing",".header-social",".article-toolbar","#zeen_retina_image-3",".social-share-sticky-menu__wrapper",".chaser-share-buttons",".c-strap--youtube",".pm-socials-block","#social",".react-share__ShareButton",".et_social_icons_container",".gb-share-list",".wp-block-jetpack-sharing-buttons",".sharing",".pm-share-horizontal",".footer-icons",".social-media-container",".uds-social-follow",".service-links",".FixedHeader_shareBtn__yNush,\n.ShareBanner_container__OX63I,\ndiv[data-component=\"ShareUtility\"]",".SiteFooter_socials",".flex.flex-wrap.justify-end.space-x-\\[1\\.5rem\\]",".grid.grid-cols-4.gap-0.border.mx-auto.dark\\:border-gray-600",".uc-social-bar-wrapper",".item__share-wrap",".flex.flex-row.lg\\:flex-col,\n.flex.flex-row.tems-center.justify-center",".youtube-subscribe","#social-icons",".js-sticky-content",".article-full__footer-share",".twitter",".facebook","[class*=\"shareitemlist\"]","[class*=\"_share_\"]",".share-post-container",".footer-social-icons",".twitter-icon","#custom_html-7,\n.single-post-share-header",".social_share",".btn-block.btn",".page__share",".follow-container",".webshare","#follow",".er-social-share-tag",".shared",".social-networks",".social-items",".ag-mobile-social-widget,\n.flex.flex-row.list-none.m-0.p-0.bg-transparent",".td-post-sharing",".mw-botaoGoogle",".footer-redes-sociais,\n.header-redes-sociais,\n.link-compartilhar",".compartilhamento",".c-social-midias",".follow",".buzzfeed-socials",".mb-8.flex.flex-col.flex-wrap.justify-between.gap-3.tablet\\:flex-row",".google-news",".a-author__socials",".single-sharer,\n.social__footer,\n.top__share",".hover-compartilhar",".icons",".row_gn",".compartilhar-button","#redes-sociais-footer",".tools",".btn-share",".social-icons-colunist,\n.social-icons-post",".social-icon",".share-container",".button-share-icon",".compartilhar-interna,\n.compartilhar-noticia",".compartilhe",".compartilhar",".midias,\n.midiasApp",".sigaInstagram",".share-float",".share-page","[data-ds-element^=\"social-Links-\"],\n[data-ds-element^=\"social-share-\"]",".pl-1",".cta-model",".share-bt",".fb-page",".botoes-compartilhar",".ast-footer-social-wrap,\n.ast-post-social-sharing","div[class^=\"styles_shareLinks_\"]",".content-shares",".nav-tools-footer__social-media",".post-sharing-menu",".b-footer__social-links-container",".follow-us-wrap",".redes_rodape,\n.redes_sociais",".box--share-single-page,\n.box-networks,\n.header-netwoorks,\n.widget_nr-socials-widget",".social-media","div[class^=\"ShareButtons_\"]",".noticia-share",".share-icons",".nm-fb-share","#socials",".sociallink",".footer-content__social,\n.share-posts",".zz-header-social,\n.zz-header-social-bar",".share-card,\n.social-media-share-wrapper",".share-header",".links--social",".btn-whatsapp",".botao-google-news,\n.icons-group",".lista-redes",".fixed-list",".redes-socias-noticia","#footer-social-links",".social-wrapper",".btn-social",".share-group",".btn-seguinos-gnews","#sociaisnk",".newsContent__article__meta__socials","#google-news","#shareitens","#single-compartilhe",".tec--didyouknow,\n.tec--share__container",".icon-partner-social,\n.t360-sharebar__wrapper",".flex.gap-2.ml-auto.mobile\\:hidden,\n.flex.mobile\\:mt-4.desktop\\:mt-2",".noticias-single-header__share__list,\n.tnh1-botao,\n.tnh1-videos-single__share",".jobview__btn-sharedVacancy,\n.sharedVacancy","#communit-box,\n.bar-redes-sociais",".blogger-social,\n.jupiter-share,\n.solar-header-columnist-socialmedia-content",".col.text-center.py-3,\n.d-flex.col-12.col-sm-4.align-items-end.justify-content-end,\n.header-block-right.d-block.my-auto.ml-auto.ml-md-0","#share",".fab",".c-follow-social-media,\n.gallery-widget-carousel__info-share",".sup-share-block__position,\n.sup-social",".s-whatsapp",".share-link",".social-media-v2",".footer-social-menu,\n.menu-social-networks,\n.page--share-wrapper","#block-block-11","#block-block-6",".socialshare",".ft-social",".sc",".b-share-bar",".share-toggle",".engagement-widgets",".footer1",".share-icon",".c-teaser",".item_share_area","#social-share-icons",".item--share","#article-social-icons",".c-actionsTools",".sc-sa6od2-0",".flex.flex-wrap.items-center.gap-3.pt-4.xsToSm\\:pt-2.print\\:hidden,\ndiv[class^=\"StyledSharingBar-\"]",".sc-expanded",".news_content_tools",".micro_mail__dd_RW,\n.micro_xshare__KIfyn",".sport-hero__share-action-container",".btn-social-icon",".dpsp-network-list-item",".social_diviser,\n.twitter_bas",".footer-rrss",".post-share-sms",".M-compartir,\n.R-rightShare",".club-producte-social",".rrss",".socialsharesnoticia",".content_share,\n.follow_panel","button[aria-label^=\"Partager\"]",".socials-custom",".social-bar-wof-wrapper",".footer-social-media",".social-media-blocks","button[class^=\"ActivityButton_\"]",".share-button",".ccm-element-social-share",".a2a_kit","#buttons-social",".node_share_news",".shariff-article",".watson-sharebuttons",".social-bar",".banner-google-news,\n.cuerpo-share",".c-sn",".cnt-interaccion",".botones-llevatelo",".botones-google-news-wsp,\n.post-social-container,\n.redes-container",".botones-rrss-final-noticia,\n.cs-entry__after-share-buttons",".ssd",".botones-redes-sociales,\n.contenedor-compartir,\n.contenedor-sociales,\n.modulo-channels,\n.modulo-google-news",".col-xs-12.col-sm-12.col-md-12.text-right.pull-left.pad-none",".share-content",".compartir-noticia,\n.gnews-container",".social-grid",".sn-single",".entry__social",".shares",".three-right",".section-common-share-wrap",".pageShare",".jiathis_style_shine",".container__btngoogle",".floatin-button-container-social",".Social",".SocialMedia",".Button_google",".text-neutral-700","#after_disclaimer_placement",".google-news-link",".container__boton-whatsapp,\n.share-redes",".footer__redes",".social-follows",".lb_overlay",".pin-block",".social-rocket-floating-buttons",".entry-share-link",".blog-hustle-social-links",".ActionBar","#sidebar > h4,\n.sharetocare-popup",".networks",".social-media-list",".byline-social",".flex.flex-row.items-center.justify-center.md\\:justify-start.p-16.md\\:p-0,\n.w-full.md\\:w-auto.h-full.flex.flex-row.items-center.justify-center.md\\:justify-start.pt-16.md\\:pt-0.border-t.md\\:border-none.border-black\\/10.dark\\:border-white\\/10",".tip-share",".form-success.text-center",".widget_sm411_widget",".kleo-quick-contact-wrapper",".Page-actions",".social-container",".wrapperBase_1ietptp-o_O-wrapperDefault_dlcy9n",".bm-social-top",".footer-redes",".fb_iframe_widget","#footer-social-list",".join-channels-wrap",".header__social-search__icons",".post-share-area,\n.stay-connected",".nav-sharebox","#ftr_social-icons","#share_buttons_top_of_petition_menu",".share-panel",".tw",".fb",".aw-social-share-container",".story-share",".ArticlePage-actions-wrapper",".social-links-menu","#share-list",".sharingColumn",".social-network",".alchetronShareCard",".fb-banner,\n.ig-banner,\n.tw-banner",".modal-backdrop","#share-modali",".connect",".sticky-panel-container",".social-btns",".SingleSocial",".FollowUsOn",".article-tools",".footer__altx-top-social",".share-tools__list",".auw_event_share,\n.followGoogleNews",".sticky_1ds30c3",".ag-social,\n.w-full.mb-10",".follow-please",".social-media-links > .sidebox-content,\n.social-media-links > h3[class=\"sidebox-header\"]",".SocialButtons",".mercatino-toggle,\n.social-bookmarks",".widget-ahcount",".cb__share-box","#sharingButtonPopup,\n.btn-linkedIn,\n.btn-reddit,\n.btn-x,\n.w-social-follow-button",".btn-facebook",".btn-flipboard",".btn-mail",".copy-link-button","#social-bookmarks",".social-button",".article-author__social",".masthead-nav-social",".zd-social",".share-capture",".tweet",".entry-views,\n.meta-area","#custom_html-4",".editoSocialBar",".blog-article__share-sticky,\ndiv[data-component=\"social-media\"]",".author-links",".header-super-nav",".s-bar",".sh-bar",".ao-share-buttons,\n.telegram-share-wrapper",".PartialSocialLinks","div[style=\"clear:both;position:absolute;top:20px;left:0px\"]",".wprm-call-to-action",".social-media-link","#more-less-btn,\n.rating-count,\n.singlemeta",".stay-social",".widget_connect",".icon-email","#reaction-wrap",".component--share",".af-socialIcons",".follow-us",".bloc-partage",".follow-google-news-p",".footer-svg-icons","#btnCompartir",".leading-0",".share-box",".follow-us-container-footer",".article-shareables",".twitter-embed",".boxnav--social",".sharedaddy","div[class^=\"social-share-\"]",".sticky-header__sharetoolsContainer,\n.style--save-and-share-container--KMiFF4od",".astra-widget-social-profiles","#bot-soc-icon-wrap,\n#top-soc-icon-wrap",".HeaderTopSocialIcon,\n.share-option",".fb-social,\n.tw-social","#icons",".beebom-social-share",".bg-primary-blue,\n.share-block",".div-rating",".sb-footer__notes__socials",".footer_social_media",".news-info",".pinterest",".ldm-social-menu",".widget-social-b",".spc-social-follow",".social-menu-desktop","#share_line",".obfx-sharing",".social-menu",".rs-icon","#bc_sharing_is_caring,\n#google_follow","#share-box",".facebook-round-control,\n.twitter-round-control",".css--social-wrapper-outer",".ts-share-bar-custom",".ArticlePage-google-news",".post__share-block",".td-social-share-text,\n.td-social-whatsapp",".footer__footer-top__social-links,\n.whatsapp-link",".one-head-share1-links",".social-icons--share",".social-box",".dd-share",".mojo-fb-logo,\n.mojo-tw-logo",".story-base-template-m__share-floating-expanded__1E6W0","#share-container",".links",".article__notif",".top-nav",".heateor_sss_sharing_container",".ea-share-count-wrap","#social-follow-sidebar-widget,\n.bnn-social-share",".m-social",".follow-buttons-block",".single-share-wrap",".MainStory_whtsppchannle___HEk3,\n.MetaPost_flwggle__kFKIT,\n.whtsclick",".join-tg",".social-heading",".brands-social,\n.mi-logo-social-container",".article-share-outer",".right","#aboutsocial",".js-inline-share-bar,\n.post_shareBottom__9whII,\n.share-bar_buzzfeed___uZ4R",".social-sharing",".share-buttons-icons",".cotent-share-icon",".youtube",".instagram",".caf-c-followbar,\n.caf-o-footer__socials",".art-action-wrp",".relative-social",".cm-share",".icon-share",".detail__soc",".post_share",".social_link",".btn-link",".GoogleNewsProvider,\n.WhatsappChannel",".td-post-sharing-style2,\n.telegram-scrolling",".tds-button",".global-footer-social-buttons,\n.sds-social-share",".analytics-cta,\n.py-4.flex-wrap.flex",".sharebar",".SocialIconsBar",".cgd-social-wrapper",".header-v3-shareicon,\n.news-share-wrapper",".header-v3-follow-common",".apss-social-share",".w-full.border-gray-900.p-5",".css-1lq2xsx-ShareButtons",".navigation-footer-platforms-component",".ck-share-buttons",".seguicisu",".footer-links",".widget_block",".article-control-bar",".follow-links",".social-share-sticky-menu",".comp-content-sharetools","#eapps-social-share-buttons-1,\n[href=\"https://vero.co/clashmagazine\"]",".meta__share",".fdn-content-multi-row-share-tools-small",".list-footer-rs",".CNBCFooter-social,\ndiv[class^=\"SocialShare-\"]",".google-btn-div",".gb-container-63330cf4,\n.wpjankari-social-wrapper","[data-meta=\"footer-section-social\"],\n[data-meta=\"footer-section-social\"] + ul","#btn-teleg",".headerradio__social,\n.section__social,\n.share-buttons-style-two,\n.share__radios,\n.storyfull__social",".sharepost",".ct-block-wrapper","#social-icons-box",".ce-post-sharing-visible,\n.google-news-block","#social-ad-new,\n.GoogleFollws,\n.Socilsm",".wrapp_aside-share",".post__socials-block,\n.shares-list__list","#sfsi-widget-2","a.mr-10.left > [src]",".cta",".l-shared-sec-outer",".socials-counter",".xs_social_counter_widget",".sosmed",".SocialLinks__SocialButtonsContainer-sc-vif6xs-0","div[class^=\"share-bar_\"],\ndiv[class^=\"social-list_\"]",".social-share-sticky-men",".icon-font",".socialoverlay",".bloc_reseau",".list-inline",".gl-btn,\n.gl-likes",".article-sharing",".x-follow-button",".breathe,\n.lc-article_share",".right-share-box",".cb-social-td",".border-all-mid-gray-rounded",".share-inner",".social-connect-links",".shareAndPrintBar",".blog_main_navigation_top","#ss-sticky-bar,\n.ss-inline-share-content",".nso_single_social",".ssk",".share-col",".share-links",".call-now-button,\n.mvp-alp-soc-wrap",".share-item",".links-bar",".buttons-social","#social-media",".sharing-element",".social-link",".details_list_group_footer_social__JSbQA",".e-shared-sec",".footer-social-list,\n.social-follower",".highlight-shares,\n.t-shared-sec",".shB",".social_media","#twitter",".sns-sharing",".a2a_default_style",".swp_share_button",".social__variant","#js-Social-Share-0",".swp_floating_horizontal_wrapper",".single_inner__pWuJ8",".group-xs,\n.list-inline-xs",".social-media-icons-container",".twitter-share-button",".nav-social__items,\n.social-links__anchor--sharing",".nav__story-social-network","#top-buttons",".top-sidebar-wrapper",".btn-connect","#newsletter-form,\n.badges",".single-artical-page-shear-section-shear-section",".box-social-com",".m-social-profile",".m-social-share",".atw-socials,\n.otd-socials",".post-share","#menu-2021-social",".share-frame,\n.social-frame","#print_article",".cwp-food-footer",".head-nav-social","._social-share",".social_icons_colored",".dm20-footer-social-link,\n.dm20-lory-share-panel",".post-share-bot",".post-share-float",".social-proof-wrapper","[data-tracking-name=\"footer-section-social-media\"],\n[data-tracking-name^=\"sharing-icons-\"]",".banner",".footer__top","ea-social-links",".feed",".Footer_social_bar__E9yGn",".socialsaveur",".galleryImageShare",".snsList-btn_wrap",".l-shared-sec",".open-compartir",".sharebutton",".article__share-buttons,\n.site-header__social",".boton_ws,\n.btn-compartir","div[class^=\"share-widget_\"]",".socialNav",".h-fixed-footer",".contenedor-google-noticias",".article__footer-nav",".Button_googleAlert,\n.Button_whatsapp",".SocialNetworks",".comparte_noticia",".w_rs",".countsocialhor",".ft-mol-rrss-column",".swBar",".btn_googlelink,\n.c-detail__info-share,\n.c-subheader__social,\n.sharrre",".share-options","#cuDetalle_cuBarraSocial_redesSociales,\n#redesSociales","#footsocbuttons",".btn-group",".boton-share",".article-button-simple","[href=\"https://bit.ly/39WhWFF\"],\n[href=\"https://bit.ly/3pozgtL\"],\n[href=\"https://bit.ly/3qLFns9\"],\n[href^=\"http://bit.ly/\"]",".mpGTIt",".some > *",".ea-social",".js-c-article-partage-commentaire-share",".social_a",".c-post__social",".kg-bookmark-card",".gGWTmb,\n.kifGPa",".list-group","#fixed-facebook,\n#fixed-wechat,\n#footer-wechat-container",".siguenos",".footer-right",".fa-share-alt",".widget_monarchwidget",".social__buttons",".wikia-bar-anon",".widget_bimber_widget_facebook_page","#social-promotion","#facebook",".fcbr_social_share",".thumbnail_pinit",".Entry-infoSocial",".mh_share_footer","#page-pre-footer","div[class*=\"article-section_shareButton_\"]",".article-icons,\n.article-icons-color,\n.contact-widget__sticky",".follow-us-on,\n.ie-google-news",".soc",".partial-heading-social,\n.partial-share",".FTU-social-floating",".social-sharers",".art-soc-icons,\n.bg-mail,\n.home,\n.rhs-yt-ch-wrap,\n.shr-ic,\n.so-ics,\n.subcrbe_btn,\n.whats-app-desc,\n.yt-ch",".recipe__social",".email",".single-social-share",".fdbst-share-button",".o-SocialShare",".single-social-icon,\n.social_top_bar","[class^=\"_socialMedia_\"]",".google-news-card",".action-icon-list__wrapper,\n.article-slot__socials",".post_bottom_socials_buttons_wrapper",".share-post",".article-meta-lower:has(.article-social)",".article-share-icons","#custom_html-3",".wprm-template-fmb-footer",".mvp-story-share-wrap","#block-fs_helpers-fstop_socials",".social-content",".redes__articulo",".fxs_bg_light_5_clr","._nvshrw,\n.gsocialbar,\n.story_social_share",".js-toplink-container",".gk__footer__social-bar,\n.gk__share__label",".Footer_follow__eMVb8,\n.Share_pc_share__RxDpq",".social-16-soc,\n.social-19-out-GP",".gametyrantSocial",".tag-social-media",".social-new",".chromenews_social_contacts_widget",".content-share","#gd-social-widget",".x-social-menu",".menu-follow",".social-actions",".article-float-buttons,\n.social-follow-unit","#d-block",".hdr-social-links",".share-social-icons",".social-widget,\n.social_tracking_home",".component-share,\n.component-social-twitter",".between-share-and-author",".footer-widgets","#share-buttons",".navbar-social",".share_count_holder","[href^=\"https://t.me/\"]",".v-share-tools",".social-options","div[class^=\"ShareBlock_\"]","._3fq8S-container",".share-box-container",".c-footer--social",".social_panel",".article__social",".section-footer-social",".follow-list",".facebook-page","#awt_popup_landing",".addtoany_shortcode","div[data-test=\"shareBar\"]",".googleNews",".pk-share-buttons-wrap,\n.pk-social-links-wrap",".headericons,\n.icon-icons_twitter-top-share,\n.post-story-social-sharing,\n.shareicons","#SideSocial","app-icon-link",".creator-recipe-footer",".follow-buttons",".sns",".follow-us-post-section","#block-social-2",".social-side",".button-wrapper",".stickySocial",".fp-hero-block",".article-sticky-social",".content__compartir",".ln,\n.new__socialIcons,\n.subscribe-social",".googlenewfollowidget",".shareLinks,\n.socialWidgets","#sharings-footer",".news__social",".contact",".share_img",".share-bar",".cookbook-instagram",".qa-gallery-socials",".Share_share__FQTKw",".custom-html-widget","#ampz_inline_top",".ul_media_links",".linkedin",".jSharer",".ds-share-blurb",".share_item","div[class^=\"index_share_box_\"]","#FollowOnGoogleNewsBtn,\n.social-share-elements",".social-icons-button",".header-banner-menu",".list-inline--tools,\n.share-in,\n.share-tw",".icon-send",".footerLinks_03","#findUs",".social-media-layout,\n.social-media-recommendations","#cus-news-detail-sharing-icons,\n.cus-sidebar-social-media-connect",".ie-ie-share",".second-saved-buttons,\n.sharebar-buttons-container",".noprint",".footer__social-wrap",".social-icons-item","#sfsi_floater",".mb10",".telegrame_cta_content",".isBottomShare,\n.m1-article-meta_share",".shariff-buttons",".menu-icon-discord,\n.menu-icon-fb,\n.menu-icon-tw,\n.menu-icon-yt",".sns-list",".article-footer",".footer-top,\n.single-share-socials",".w-shared-socials",".confess,\n.menu-menu4_home-container",".header-top,\n.opinion-advertising","[href^=\"https://whatsapp.com/channel/\"]",".b-it-social-share-block",".header-nav-addons-link",".kadence-column_09a01f-df",".SocialShare",".c-share","ul[class^=\"Details_Social_\"]",".subscribe-buttons",".social__link--share",".twitter-follow-button",".barra-acoes-container",".bn-block-brand",".article-subline-inner-share-buttons,\n.header-a",".gdm-article-actions",".article-sns-btm,\n.hd-sns",".ns-buttons","#footer_social_channels",".social-scroll",".art-top-share-pan-nf",".pinit",".cisc-box",".sqr-social-icons",".group.flex.w-40.items-center.space-x-2.text-xs.font-bold.text-gray-400.hover\\:text-primary",".MailToLink",".fb-page-like-box",".addtoany_share_save_container",".btn-whatsup",".kbos-share",".twit",".fa-instagram",".c-share__wrapper",".section-soc-icons",".actions-under-image,\n.actions-under-image__item,\n.send-article-icon",".action-buttons",".socialsvgul",".action-bar",".c-article-foot__site,\n.c-header-social-item",".sm-btns",".btns-partage",".LNPocket,\n._share_wrapper",".ln__m-shr",".kg-callout-card-blue",".social-tile","[data-ga-element=\"social-link\"]",".art-share-nav,\n.home-social-icons",".pre-footer_instagram","#menu-social-buttons-header",".parler",".lms-socialbar",".CompanyPage2CompanyPageAbout__share",".lmm_external_footer",".c-detail__share",".c-footer__share",".social_links",".widget_twitter_timeline",".social-feed-container",".support-now",".ebm-share-wrapper",".google","button[data-taggyid]",".c-sha","#pinthispage",".addthis_toolbox",".social--159R8SRB,\n.socialMedia--3i9tSnAb",".rezo_sociaux",".block_grid_share_icons_container,\n.footer_icons_container",".widget_a2a_share_save_widget",".btn-twitter",".header-social-menu",".wrap_social_account",".ShareBar_listItem__6t0E_,\n.mom-entry-meta-buttons",".home-content-panel__details-social__main-holder,\n.icon-share-card-lite","[href=\"https://t.me/maps4heroes\"]",".swp_social_panel",".ssbc-button__link",".mp-share-widget",".interacciones",".post-social-share",".slide-on-scroll","#post-social,\n.c-youtube-subscribe",".widget_group","#js-soc-panel",".fa-circle",".socialfloating","#fixed-share",".social_icons",".footer-options","#block-publicmenusocial",".style-mai-share,\n.tm-click-to-tweet","div[class^=\"HeaderSocialWrapper-\"]",".side_col_follow_box",".js-share-sticky",".ocArticleFooterShareContainer,\n.ocArticleFooterShareLinksWrapper",".sharelink_act,\n.social-icons-inline",".set-bottom-footer",".memo-footer-social,\n.memo-top-social,\n.share-link-btn",".ma-AdDetailShare","#share-icons-container,\n.google-news-follow,\n.info-networks",".block--addtoanyadv",".ssm","#sidebar_items_container",".social-signup",".fv_sharing_round",".likeBtn",".social-web",".widget_media_image","#partage",".partage",".fsoci,\n.join_follow,\n.social_icons_wrapper",".mdc-social-share",".socail-share1,\n.social__media","#socialshare_title,\n[data-c=\"social-share\"]",".top-prod-share",".mvhub-social-button",".footer-bg",".followbuttons",".aji-social-items-wrapper",".stb-bsb",".sharedaddy__wrapper","#follow-us-social",".sharecell",".article-share-container,\n.lets-connect,\n.like-it-share-it,\n.share-it-side","#follow-us","#shrarea",".blocco_condividi_dettaglio",".social-share-links",".styles-m__sticky-social-share__fJQ4J",".article-utility-nav",".nt-share","#ShareRow",".c-article-extras-additional-links",".gdm-article-share",".article-social-share-top",".ncaa-share-hanger,\n.tile-follow",".pst_scl",".col-4",".nerdist-social-share",".ns-share-count",".ActionLink","#header-social-follow",".social-sharing-links",".elementor-element-c6f7bc9",".article-social",".footer__middleRow",".article_bnow,\n.article_follow_1,\n.article_socials,\n.nhsocial,\n.pht-artcl-shr2",".article_socialShare,\n.followBtn,\n.followUs_Links",".subscribeBar",".ArticleHeader__SocialWrapper","div[class^=\"share-tools\"]","#lightbox",".elementor-element-9f47a8f",".social-media-links","[href^=\"https://news.google.com/publications/\"]",".detailed-social-media-icons",".simple-social-icons",".btn-primary",".nfl-c-article__share-bar",".-social",".nhl-o-sharebar","#bonus,\n.c2share",".sharebar-impact","#tele",".site-footer-social",".BlogPost__social-block",".social-media-vertical","#meta_share",".button-follow",".footer-info-social,\n.news-social-bottom",".btn-google-news,\n.google-button,\n.whatsapp-button","#floatingfacebook",".take-shareables","#redesSocialesNota",".nn-follow-us,\n.nn-join-us__col",".nt-sidebar-social,\n.nt-social",".eshare",".uui-blogpost05_share-wrapper",".Detail-share,\n.Follow",".share-bar-container",".floating-share,\n.floating-share-wrap","[data-testid=\"social-group\"]",".mashsb-container",".article__hictory-descr_share","#custom_html-2,\n.box-fixed-subscription",".social-sharing-bar",".wp-block-jetpack-send-a-message",".breakingNews__socialMedia",".tabrow",".indexstyles__SocialMedia-sc-1np4juy-1","#youtube_promo,\n.goog-one-news",".blog-post-single-share","#footBox2",".page-social-share,\n.site-header-actions-social",".tdi_134",".ocial,\n.ocialWhite",".scl-icons","#subscribe_box",".p-product-detail__social-buttons",".geekmag-share-buttons",".recurrent-share",".nav-socials,\n.rm-social-share,\n.social_sharing_article",".social-media-icons",".m-social-networks",".creator-social","#socialmenu",".share-copy-mail",".footer__right,\n.top-footer",".styles_SocialShare__lQpUq",".socials-block",".fixed-action-btn","#side-follow",".navbar__social-top","#follow_social",".fdn-site-header-social-icons","div[align=\"RIGHT\"]",".image-with-overlay-pinterest-0-2-76,\n.share-icons-single-icons-0-2-82",".social_network",".addtoany_list",".pb-share-bar,\n.pb-site-social",".scriptlesssocialsharing",".social-tools__list",".footer-socials-wrapper",".canais-s",".flex.gap-2.justify-center.border-b.border-\\[\\#ebebeb\\].mb-3\\.5.pb-3\\.5",".condividi",".sbnr",".ragan-social-share,\n.sidebarShareHeading",".sharethis_toolbox",".author-social-icons",".b-sharers",".nav-main__share,\n.ups-footer__social",".btn--email,\n.btn-classic",".ql-facebook,\n.ql-instagram,\n.ql-snapchat,\n.ql-twitter","#hit",".share-site",".nlg-social-icons","[class*=\"article-fill-social-\"]",".ss-inline-share-wrapper",".widget_twitter_followers",".social-share__actions",".body-share-wrap",".before_footer,\n.social_single_post,\n.social_single_post_bottom",".Popup-telegram,\n.follows-channel","#gch-social-share-container",".realtor-social-icons",".rcom-social-tools","#secondary-nav-bar-social,\n.rn_widgets","#rhs-pinbar,\n#shr-actn-bar","#CompartirRS",".ess-buttons",".footer-media",".acm-article-share",".socials2",".zox-post-soc-scroll-out,\n.zox-post-soc-stat","#toolbar-item-parent-share-12,\ndiv[class^=\"image-caption__social__\"],\ndiv[class^=\"social__container_\"]",".rj-story-social",".social_holder,\n.social_label",".footer-social-wrapper","#text-3","#text-9",".page-content--byline-share--share",".qyh","#widget,\n.ft-soc-block",".trending-bar__social-link",".dt_social_single",".topper-social",".article__google-news","#socialLinx,\n.socialShareLinks",".sabc_footer_btm_social,\n.sabc_social_box",".fdn-icon-button-smaller","#social_total",".social_comments_app_wrapper",".google-news-cta","span[class^=\"SnsPlugin_items_\"]",".dQkCRJ",".-newsletter_social",".footer__followus-text",".new-home-banner",".qa-placement-share-bar",".subheader",".sharebtn",".article-share",".author-share-buttons",".top-bar-social-media",".wp-social-link,\n.zox-post-soc-list,\n.zox-post-soc-top-wrap,\n.zox-top-soc-wrap","#social-networking","div[class^=\"styles_shareWrapper_\"]",".footer-google-news,\n.gtmGoogleNewsDetalleSm","#panel-3",".notizia-end-share-panel,\n.notizia-single-sharing-panel,\n.notizia-tweet-this",".ListingTile_social_nav-wrapper,\n[aria-label=\"Share from Email\"],\n[aria-label=\"Share to Twitter\"]",".floating-header-share,\n.twitter-svg",".PopupSharer_container__Nhcrt,\n.StickySharer_list__Lirqs",".footer_network",".o-social-list__item",".sc_socialconnection",".social-horizontal-container",".sharebarBetaWrapper",".follow-me-foot,\n.sj-recipe-callout",".block-pinterest-cta","td > .nomobile","#communication",".share-article",".site-share-wrapper",".ui-news-footer-social-link,\n[data-component-name=\"sdc-article-strapline\"]",".meta-box--share","#sb-footer-menu",".cph-gallery-share-button",".tvsc-footer-social,\n.tvsc-social-share",".listenDetails__login","#sticky-sharing,\n.post-sharing",".ba",".social_table",".follow-action","#cta",".header-social-media-links",".Article_shareToggle__D2fGG",".social-network-icons",".field-name-telegram",".comp-social-channels",".plugin-ss-sticky",".social-flex",".swp_social_panelSide","._socialMedia_1o0tg_1",".pin-recipe-container","[data-testid=\"article-share\"]",".SocialLink","#gp-social-share",".detail_text_socials","._share-wrapper",".networking",".Footer__Follow",".footer-segment-bottom__social-list",".a2a_share_target",".sws_supernormalaction","#gch-social-icons,\n.recipe-social-share",".block-follow-me,\n.block-follow-updates",".reddit",".google_news_button",".wp-block-techcrunch-social-share","#subscribe",".desktop-shareables",".share-it",".s_so",".tl-social,\n.tl-social-share","div[class^=\"socialList_\"]",".article_footer",".facebook-icon,\n.flipboard-icon",".mvp-top-soc-wrap,\n.supersharer",".article-interaction__social",".tecmint-float-social-wrapper",".astkysharebox,\n.followusbox","a[title=\"Share\"]",".sticky-social-widget",".-sharebar",".fl-social",".footer__bottom--social-links",".post-links","div[class^=\"ArticleShare_\"]",".field-name-sharing-buttons-1,\n.field-name-sharing-buttons-2","#text-2",".cinemaholic-share",".styled-social-box",".Footer__socials",".td-follow",".follow-bar,\n.share-bar-2",".jeg_custom_share_wrapper,\n.pf-button","#article_top_right_share_btn","#new_socials_bottom",".facebook_plugin,\n.twitter_plugin",".social-navigation",".essb_links",".c-site-header__buttons","div > gu-island[name=\"ShareButton\"]",".float-share,\n.follow-box,\n.mobile-share,\n.share-open-modal,\n.top-follow",".inertia-social-ad","#share-menu-button","#share-menu-top-button",".foot__socials",".toplinks",".sharing-cta",".jeg_share_top_container",".sharethis-menu",".social-share-rail__sticky",".code-block-3,\n.code-block-8,\n.share-layout-stack,\n.share-post-button",".c-engage",".tno-share",".wp-block-outermost-social-sharing",".socials_promo",".custom-pinterest-wrap",".c-social-buttons",".ShareLinks__container--3C8C4",".wa__btn_popup",".article_set_wrap",".desktopSocialShare","#header2",".project-actions-header",".side-box",".duet--article--lede-share-tools-separator",".duet--article--share-buttons",".like",".dJ_xt",".penci_social_counter,\n.widget_ame_tiktok_widget",".post-google-news-link",".header_google_button,\n.header_twitter_button",".share-this","#native-share",".mobile-sprite",".social-item",".sti-share-box",".subcription-two",".sns-icon-list",".socialite-widget-ul",".social-nav",".elements-Tombstone-social,\n.modules-SocialWidget-socialWidget","._1oxEOBHC","#addthisimage",".ta_followWidget,\n.wpusb-buttons",".heateor_sss_follow_icons_container",".code-block",".blog-post-header3_share-wrapper",".mntl-footer__social",".socialshare_box",".navbar-right",".social-sharing-sidebar",".google-news-button-wrapper",".social-links-container",".fa-comments,\n.fa-reddit,\n.vc",".fa-twitter",".masthead__social-list",".social-media-top",".footer-menu--icons","#menu-social-navigation-1",".follow_us_icons",".post-article_sns",".ao-sbcontent",".block-better-social-sharing-buttons",".social_buttons",".telegram",".tv5monde-footer-menu--social","._socialMedia_1y23u_1",".sharedesktop",".thm-sc",".fancybox-overlay","#footer-middle,\n#social-icon-col",".widget_custom_html",".c-post__props","#banniere-2951-particle,\n#banniere-6584-particle",".button-holder","div[class^=\"ShareButton_\"]","#ShareModal",".component--shareline","div[class*=\"SocialShar\"]","#social-bar-valora",".Shares",".block-social-links",".social_share_buttons",".widget_et_social_followers",".tdi_141",".post-comments-shortcut",".shareon,\n.social-item-mail,\n.social-item-media,\n.socialbar-sidebar",".vgc-socialshare",".share_body","a[onclick*=\"facebookShare\"],\na[onclick*=\"twitterShare\"]","#NNEsharearea",".post-single-social",".social-share-list",".vr-sharing",".channel_card",".min-height-800",".spc-social-block",".tools-container",".ebm-share-list",".story-share-bottom",".zocial",".Footer--socialContainer--3z8CW","[href^=\"http://twitter.com/intent/tweet\"]","#block-37,\n.elementor-widget-share-buttons",".sidebar-card-media",".fdn-site-header-social-icons-block",".ReviewSocialSection_reviewSocialSection__qzV0o",".pinterest-with-id",".share-access__ctrl",".follow-more-news,\n.shareMobile",".interactive",".article-share-data","div[class^=\"StickyBoxWrapper\"]",".article__sharing","#text-4",".article-body__social-links",".share-wrap-icons",".article-action",".share-your-results",".tool-list","#whatsapp",".YDC-Overlay","#top-nav-soc,\n.expanded.button,\n.msnfc",".ArticleBottomShareComponent,\n.ArticleHeaderShareComponent,\n.ArticleSideShareComponent",".AccordionShareWrapper,\n.SiteArticleSocialShareNew1280",".naf-article-share,\n.naf-article-social-block",".followdesktop",".c-connect","[href=\"https://zycryp.to/GoogleNews\"]",".buttons",".share__block__wrapper",".c-ticket-fan__social-icons",".shr",".nfy-social-line",".nfy-sharing-bar",".nfy-footer-social",".ston-shareicn","section[class^=\"article-top-panel_socials_\"]",".articlepreviewfooter_share-section__Pt8mf,\n.share-panel_wrapper__3tHN9","#share-Buttons",".article-addons",".exp-sharing",".smIconsWrap",".connectButtons",".social-line",".sticky-bar",".uncode-vc-social","#footerlinks",".page-tools","#bookmarkblock",".mtbnews-post-share__container",".field-share",".sideSocialMedia",".dm-articleUserActions",".article--footer",".bookmarks",".socFbLikeShare",".social-buttons_container",".article_socialMedia",".share__bottom,\n.share__top",".alice-push-channel",".social-block,\n.uael-marketing-button",".social-tools",".printfriendly",".paragraph--type--social-links",".footer__sharing",".iz-socmed",".social-channels",".kick__article__social",".susc-social-media",".sharewrapper",".module-share","#shareButton",".sliderbar",".article__share-wrapper",".meta",".StoryActions",".icon__social",".ov-article__sharebar",".btn-group.d-flex.mb-4",".artSocialLinks",".shariff",".story-sharing","[href=\"https://www.pinterest.de/redensartenindex/\"]",".sharing_is_caring",".c-social,\n.tg-pockethinweis,\n.tg-social-bottom",".sbm",".a-socialbar",".smeShare",".c-social-bar",".socilamedia-share-btns",".pagetools","#verticalShare",".googlenews-btn",".cu-share-sidebar",".share__body",".g-footer__social,\n.o-hero__social",".social-cont",".news-article--share",".social-media-sharing",".article-top-social-share_content__OYcDe","#js-pub-share","#shareButtonElement,\n.social-list-links",".cc--social-share",".connect-links",".follow-virginia-tech-icons",".toolbar",".noticia-compartir,\n.top-bar-rrss","#buttons",".ue-c-article__share-tools",".detail_rrss,\n.icons_rrss","#subnavegacionFixed",".fl-socials",".site-footer__rrss",".srvm-nw__share-wrapper",".entry-social-v3",".ft-mol-rrss","a[href=\"#condivisioni\"]","#scBx,\n#shBt",".header_facebook","#grnation",".inline-block.space-y-8","#block-chives-shariff-share",".sB",".subscribe",".sociable",".menu-icons,\n.telegram-banner",".insta-frame",".compartir_sociales,\n.flex.my-4.space-x-4.lg\\:justify-center.lg\\:my-0,\n.flex.space-x-4.justify-left.w-full.mt-5",".post-footer:has(> .share)",".anchored","div[class^=\"Styles__InnerContainer-\"] > .animated",".herald-single-sticky:has(.herald-share)",".somejaot",".clLoPp.sc-7urq97-0",".cyhxvA.sc-tq30ek-31","#text-15,\n.mobsome_icons","#elevator","#scrak_CONT_keski",".entry-socialmedia-title",".fmUFKd.sc-zxh5v-0",".cArfwR.sc-1fbt3do-0",".social-navigation > .nav-item",".principio_plugin",".proradio-shareball,\n.reakticons-share,\n.ttg-btn-share",".attentionUs","#email,\n#fb",".nl-social",".content-social,\n.slide-share",".ShareNetwork,\n.gfAGVu",".m-share-row,\n.social-zone__wrapper",".footer_col_social,\n.header_content_networks,\n.share_content_button",".cs-meta-shares",".fig-share-mobile-layer,\n.fig-sharebar",".sc-eVBRet.htUQLJ",".reseau-soc-page",".ShareManager,\n.StationFooter-social",".communities",".gg,\n.ld,\n.shared-logo",".widget-toms-widget-google-news",".cloux-social-links",".soc-media-sharing",".article_social_button",".articlesocial",".d-flex.mt-3,\n.research__details--share",".article_social_bottom",".fa-lg.text-center.my-5",".soc-icon-wrapper",".headerSocials,\n.ring-detail-social-share",".usa-footer__social-links",".m-social-media",".social-section","lbl-icon-list",".block--footer-media,\n.block--page-head__row__share",".ncbi-footer__icon-section",".nist-social__wrapper,\n.social-twitter",".wp-block-snl-blocks-snl-social-share-btns",".controls","#enternity_social_dialog",".tkp_con_share",".article__top,\n.social__wrap",".item__social-jl",".single-page__social-share-container",".h-screen",".item_social_share",".item__share",".instagram_feed,\n.social_networks",".megoszt",".facebook-layer-box",".mw_social",".ms-link-list",".header-right-socials",".fbpage-like-szmo",".framed-content,\n.options",".fb-box",".fejlec_osztas","app-share-buttons",".mb-1.pt-4,\n[aria-label=\"Facebook\"],\n[aria-label=\"Instagram\"],\n[aria-label=\"Twitter\"]",".c-padding-xs.ct-div-block",".social-links-wrapper",".social-btn-container","#sticky-share-button-redesign,\n.social-container-redesign",".Share","#shareIcon",".foo_t_n_r_icon,\n.single_bottom_discovers_p1_share",".whatsapp_channel",".socialicon-list",".social-common-blck,\n.social-panel-rgt",".cmp_shr_btn,\n.rhs-fixwhtsapp,\n.social_tracking,\n.whatsAppChannel",".share-btn-wrp",".ftr_scl_lst,\n.hdr_scl_icn",".stay_connected",".gd-newsletter-subscribe-sharelinks",".Story_whatsapp_channel__6xdtB,\n.fixedshared,\n.footer__socialshare,\n.whtspp_share",".like-text",".footerContainer,\n.social-icons--fixed,\n.subscribeTelegram",".art-social-block",".social_media_link",".socials-section",".jota-actions,\n.jota-article__share",".boldShare",".fa-facebook",".meks_ess",".spu-bg,\n.spu-box",".share-icons-column","._share_pm84d_360",".sfsi_centered_icon,\n.space-footer-top-soc","#tns-footer-bar,\n#tns-post-body-sidebar-share,\n.share-media",".social_icon_head",".social-icons__list",".social-fb,\n.social-tw,\n.social-yt,\n.temporary-skin-adv",".hidden.xlarge\\:flex.border-t.border-base-300.pt-2.core.items-center.justify-between",".td-post-sharing-bottom","#header-fanpage",".default--toolbar,\n.default--toolbar-listitem[data-type=\"icon\"]",".media-share","#vimeo",".socials_det","#ss-floating-bar",".ld-t-footer-sharing,\n.share-control",".ft-social-list","#gnews_label",".box-gnews","#box-social",".lista-social",".cirioYou",".box-canale-telegram,\n.company-social",".link_social,\n.link_social_footer",".sharing_icons_wrapper",".social-launch",".post-meta-actions","#segui",".p-gnewsBanner,\n.p-telBut",".ft-icon",".tutplus-socials",".foc-footer-social",".SATover",".bottoniera-social",".btn-toolbar",".art-item-footer",".partial-button-telegram,\n.section-cards-social,\n.single-post__social","#custom_html-8,\n#custom_html-9","#glfb","div[class^=\"SocialShare_\"],\ndiv[class^=\"WhatsApp_\"]","#condividi_news,\n.giornale-contatti,\n.social_condividi",".magazine-article-share-tools",".eltdf-woo-social-share-holder",".instagram-widget",".footerIconsUl",".socialBtn",".tgla7-condividi","div[id^=\"post-social-actions_\"]",".sswfb-buttons",".lp-sharing-box,\n.lp-social-networks",".lp-social-post",".s-cont-over-picture",".code-block-10",".seguici",".flex.justify-between.gap-x-2,\n.mb-2.justify-between.grid.grid-cols-6",".iol-share-menu",".iol-social",".footer-social-container",".post__trends",".post-actions",".google_news","div[class^=\"SocialBar_\"]",".social-column",".ts-social-list-item",".ss-box",".dsoc",".social-b",".fb-menu",".info-links",".btnYou",".lista-is",".vota-pul-consiglio",".colonna_social",".spc-social",".sfm-floating-menu",".td-social-sharing-button",".box-condivisione,\n.condivisioni",".extra_info_social",".jw-video-details-share",".mvp-post-soc-wrap",".top_nav_social","share-view","#social-container",".share-toggler",".prefooter__social__list",".banner-buttons",".alert",".p-box-discussion_block__gnews,\n.p-box-social_tools",".totwitter","#site-menu-social-footer","#banner_social",".hashtags",".link_invia_amico",".flex.gap-x-2.mx-auto.my-4",".follow-title","#follow-us-on,\n.condividi-button",".footer","div[class^=\"ModifyAndShareDetailArticle_\"]",".sgtv_divRowContent_messenger_subscribe",".fco2b,\n.finfo3",".wo-opening-share-panel",".cond",".condisione-social",".foobar-social",".socials-link",".condivisione",".condividipagcatd,\n.condividisottod",".vea_share",".foglia__social,\n.vv-shr","#sf","nav-social",".media-icons","#vertical_sns",".sns_list",".swp-hover-pin-button",".dc__footer_sns","#snsLink",".post_detail__sns","#sns",".block-sub-sns",".cmp-misc003",".ninja_onebutton,\n.social-media-inner",".sns_icons","fw-storyblock",".article-fix-sns,\n.gov_sns","#sticky-sidebar-shareicons",".button_ss,\n.single_s_bt,\n.socal","#Jfacebook,\n#Jtwitter,\n.sharetxt",".inline-list",".g-sticky","#article-bottom,\n.synd",".headlinks",".u-side-col--mailmagazine-share,\n.u-side-col--share--body",".article-sns",".socials_bar",".sare-sns",".sns_area",".PatternCurrentNewsContent__share,\n.PatternCurrentNewsHead__share",".foot_bar,\n.foot_social",".boxinstagram,\n.followvertical__home,\n.newsvideo__share",".mod--googlenews","#myModal","li.menu-link.d-xl-inline-block",".ff-social-icon","event-popup","#article_sns_inner",".edent-share",".ListSiguenos-SocialStrip",".net-social",".botonGoogleNews,\n.socialMediaBottom-Section",".pane-rate-widgetk","#affix-share,\n.container-share","#social-bottom-node,\n#social-top-node",".ic-rs",".share_alt","#scan",".social_f",".comments-social-share",".header-alert",".google-news-callout",".icon-bar",".loftocean-social-share-icon,\n.sticky-share",".shareButtons",".sh",".bam-topbar-social,\n.bm-social-sharing","#art-social-wrap",".cms_widget_content.widget_content > [align=\"center\"]","ul.inline.links","#et_sticky_pc,\n.et_social_2","#bookmarks",".Bigfoot-socialLinks",".topsoc",".media-links-area",".ghacks_share_widget","ui-social",".follow-section,\n.link-icon",".hd-discord",".socialmedia","#cht-shr","#topicons",".SiteHeaderSticky_share",".siguenos-reducido",".iib-share-buttons,\n.iib-viz-section--share",".profile-icons",".has-medium-font-size.has-background",".ftr_social_box",".tc-widget-social-style5",".socialComponent",".socialsider",".article_details_icons",".footer_soc_icon",".st-inline-share-buttons",".js-sns-icon-container","#like,\n#social3",".hw-el-share,\n.hw-toolbar-navplus",".noticia-ampliada-compartir",".header-info-text",".follow-od","#LinkList76",".mobile_social_block",".actions",".focus-social","#tb-banner-whatsapp",".content-area__contenedor__redes__lista",".social-sharing-wrapper",".shareImage",".google-news-banner,\n.google-news-button",".et_social_rectangle",".tdm-social-wrapper",".header__follow","#guardian-follow-links",".follow-google-news-container,\n.single-share-post-container",".s__pb\\+6.s__mb\\+6",".menu-social-media-container",".social-media-sharers-wrap",".mt-8.flex.gap-x-4",".badge-social",".m-article-info__data-share","#mediaLinks",".h-11.p-3.border-l.border-slate-300.transition-colors.fill-slate-300.hover\\:fill-brand.dark\\:fill-black.dark\\:hover\\:fill-brand.dark\\:border-black","div[class*=\"sharesticky\"]",".e1qelbru0",".socials-share-button",".slogan-bar-social",".socialmediabuttons",".entry-social",".c-content-footer__socials","#indexNavigatorbox,\n#indexNavigatorboxf,\n#indexNavigatorboxl",".rh-social-media",".article-single__meta__socials","div[class^=\"article_share_\"]","#block-socialicons",".app-follow-us","[class^=\"shares_shares_\"]","whatsapp",".whatsapp",".linkbar","div[class^=\"share_\"]",".share-like",".favshare-holder",".js-share",".social_icon",".c-article__header__social-sharing--vertical","#shareThisAd",".zld-ftr__social",".social-short",".self-center",".fm-share-bar",".nrkno-share",".color_mobile_bg-forskersonen-primary",".bg-twitter-default","div[data-type=\"social_feed\"]",".Navigation-items-social","#socialListParent","#social-component",".c-ArticleHeading-actions",".sharing-anchor",".o-share-list,\n[data-test-ui=\"social-connect\"]",".menu-link-contentsocial-menu",".pane-odt-social-odt-social-rsb","#article-tools",".comment-and-share,\n.stuff-article-sharebar",".ffsAxx",".shareButton",".newsline-social-media-share",".media--mobile-hide",".Fiction-FeedBack",".share-tools","#social-list",".share-icons__social-shares___2eB-m",".ShareBar_link__3gR4V,\n.Socials_social_links__T3MJv",".article__socialmedia",".horizontal-icon-bar,\n.vertical-icon-bar",".social-ico","#aps-share-widget",".header-share,\n.site-socials",".gta-hover-share-container",".global-footer-connect",".post-social-sharing__list",".page-info-header__social",".i-facebook,\n.i-twitter",".stayconnectedwrap","#SM_area","#a11y-dialog,\n.shares-simple",".addthis-trigger",".flex.gap-rem24px",".google_news-space",".btn__social",".legacy-social-list","#story_social",".ft-soc",".connect-2",".end-social-links-header",".social-profiles",".single-post__sidebar-share-desktop",".ampz_container",".footer-social-big",".sticy-share-block",".post-footer-shr",".article_like",".ftr-follow",".c-hero-card__social","#article-share","iti-share-icons","#push_notificationBlock",".icn-share-holder",".call-to-action",".twitter-featured",".top-bar-right",".share-icons-box",".ActionBar-items",".components-SocialShareTray-__SocialShareTray__SocialShareUL",".post-detail__share",".c-story-meta__share,\n.o-social-share",".share-hdg",".social-list-single",".nb-twitter-block",".social-story-bottom",".fixed-ad,\n.reveal-modal-bg",".data-insight-copy-link-button",".more-from-pbs__social","#header_right_top_right",".social-share-partial",".wdm-share-container","#smx,\n#smx2",".chicklets",".rss",".gtm_share",".qc-footer_social-media-links",".share-article-link","#storytoptools",".comp-share-bar",".rrssb",".news-article__share",".follow-us__background___WNsfy",".sh_space.share",".sbar_social_div",".block-social-share,\n.top-hat--has-socials","#technology-org-application",".icon-wrap",".teaser-utility-links",".mdl-share-tool-vertical",".article__aside-share,\n.article__post-share",".mui-style-dfyfg6-socialShareMenu",".post-article-share,\n.sidebar-action-share",".component56--share",".blog-article-share-options",".shared-counts-wrap",".st-sticky-share-buttons",".SocialShare_root__3h83X",".s-buttons",".article__follow",".container_shared--internal",".sidebar-social-icons,\n.story-social-icons,\n.topsocial-icons",".sidebar-inner",".articleSocials",".atomsArticleFoot__socialMedia,\n.atomsArticleMediaTools__socialShare","#widget_shop7","#before-leave-window",".social-style-2",".stay-connected-color",".footermenu",".social-btn",".partilhas,\n.subscrever_whatsapp",".sociais_div",".t-f-bar-apps",".article--aside_share",".articleShareToolsContainer",".social-top",".barrawhatsappDesktop",".social_media_links",".t-article-footer-bar-1",".col_partilhas,\n.shareModal",".social_stick",".nc-social,\n.wp-block-newsplex-social-share,\n.wp-block-social-icons",".social-bar-footer",".ink-button-share",".socials-networks",".article-tools-container,\n.share-toggle-wrapper",".whatsapp-button-container",".icon-social",".aft-social-share",".single-news-share",".row.pt-4.pb-4",".share-action-posts",".socialhover",".custom-share",".newsTitleShare",".article__messengers","._links",".smm",".sharing_item","#footer_counter,\n.news_story > div",".in,\n.ok,\n.vk,\n.yt",".header__soc",".sn",".StoryContentMainShare_root__LRFwu",".article__aggr","#telegram_push",".socials-group",".campaign-metrics-card__share","[height=\"73\"],\n[href=\"https://bit.ly/3KjTj94\"],\n[href=\"https://bit.ly/3qgqzHg\"]",".popup",".leftColumn-socialLinks",".flex.justify-center.items-center.fill-current.mt-18.md\\:mt-0,\n.flex.justify-center.md\\:justify-end.items-center.fill-current.mt-6.md\\:mt-0.xl\\:mt-0.w-auto",".social--bar",".social-dialog-wrapper",".articleActions",".sharedButtons",".dr-article-content__social-links",".ArticleView-googleNewsBanner,\n.ArticleView-rotatorBanners",".rs_bas","#block-block-5",".c-link--icon-alone",".soci",".article__gnews,\n.card__subscribe",".ustBar-sosyal",".pageTools",".sosyal-medya",".share-list",".social-aw",".share-tool","._main-footer-socials,\n._main-header-socials__permalink,\n.main-video-single__socials,\n.the-single-body__share",".lobibox-notify-wrapper,\n.navbar-sosyal,\n.sosyal-alt-ust",".news-social-share_wrapper",".share-news",".elfsight-widget-social-share-buttons",".soc_list",".footer-social-wrap,\n.soc-links-hor",".Footer_social-network-links-wrapper__xN9Go",".footerIcons",".post-footer-on-bottom",".vjs-icons-bar","#s1,\n#s2",".sb",".facebook-share",".ns-buttons-wrapper",".article_community_box",".post__social",".post_bottom_socials",".post_social_item,\n.post_text > blockquote",".article__footer__additional_share",".social_root__H2cRW",".box-services",".ssrcss-11faxz6-TagShareWrapper",".s-video-h","#articleIconLinksContainer,\n.container-3zJLP,\n.dms-puff,\n.fbmessenger,\n.flipboard,\n.image_strapline_slant_wocc,\n.prevNextWrapper-1Vg7e,\n.socialContainer-1Yly1,\n.vjs-social-controls","ul[class^=\"linksHolder-\"]",".tw-link",".inews__footer__menus__icons,\n.inews__post-share",".followbox","#share-buttons-bottom,\n#share-buttons-top,\n.follow-promo,\n.footer-follow,\n.item-share-buttons,\n.share-buttons-floaty",".header__nav__share--active,\n.social-sites",".share-highlight",".omg-socials",".block-article-content__socialbar",".entry-meta__item--social",".tls-sharing__items",".ne-social-list",".follow-the-tablet","div[class^=\"socialContainer-\"]","#whatsapp-community",".content__sharing",".bg-twitter",".fun-social-proof-iframe",".yasip.widget",".c-social-links","#DonTelegram",".nav__socialz",".sticky-media",".essbasc-popup",".sociales",".Page-actions-wrapper,\n.section-rrss-wrapper",".container-bar",".bqt-share-social",".box_fixRight",".fixed-social",".article-top-bar-share","#whatsapp-widget",".btn-sm",".footer-column-3",".social-meks",".css-p1ns9f",".sticky-buttons",".eltd-blog-single-share,\n.widget_eltd_social_icon_widget"];

const hostnamesMap = new Map([["albayan.ae",1],["indiatvnews.com",[1,9]],["amazon.ae",2],["amazon.com.au",2],["amazon.com.be",2],["amazon.com.br",2],["amazon.ca",2],["amazon.cn",2],["amazon.com",2],["pramgnet.com",[2,943]],["amazon.de",2],["amazon.eg",2],["amazon.es",2],["amazon.fr",2],["amazon.in",2],["amazon.it",2],["amazon.co.jp",2],["amazon.com.mx",2],["amazon.nl",2],["amazon.pl",2],["amazon.sa",2],["amazon.se",2],["amazon.sg",2],["amazon.com.tr",2],["amazon.co.uk",2],["sputnikarabic.ae",3],["sputnik.af",3],["sputniknews.africa",3],["armeniasputnik.am",3],["sputnik.az",3],["sputniknewsbr.com.br",3],["noticiabrasil.net.br",3],["sputnik.by",3],["sputniknews.cn",3],["sputnik-georgia.com",3],["sputnik-ossetia.com",3],["sputnikglobe.com",[3,1032]],["sputniknews.com",3],["sputniknews.in",3],["sputnik-abkhazia.info",3],["spnfa.ir",3],["sputniknews.jp",3],["sputnik.kg",3],["sputnik.kz",3],["sputniknews.lat",3],["sputnikportal.rs",[3,20,1032,1804]],["sputniknews.ru",3],["sputnik.tj",3],["sputniknews.com.tr",3],["sputniknews.uz",3],["sputniknews.vn",3],["pelisplus2.ai",4],["orf.at",[4,27,28]],["wielerkrant.be",[4,59,67]],["diskacompanhantes.com.br",4],["esquerdaonline.com.br",[4,99]],["noataque.com.br",[4,127]],["letras.mus.br",4],["abc13.com",[4,9]],["andreagaleazzi.com",[4,300]],["asmartbear.com",[4,20]],["awfulannouncing.com",4],["blackamericaweb.com",[4,367]],["blogdoiphone.com",4],["cbsnews.com",[4,421]],["changer4u.com",4],["dcrainmaker.com",[4,504]],["digitalinformationworld.com",[4,520]],["disneydose.com",4],["dreambigtravelfarblog.com",4],["foxnews.com",[4,609]],["frommers.com",4],["ijr.com",4],["investmentexecutive.com",[4,714,715]],["iranintl.com",4],["justthenews.com",4],["liliputing.com",4],["metsul.com",4],["neonyxcruises.com",4],["netgear.com",4],["nypost.com",[4,897]],["observer.com",4],["outkick.com",4],["ptinews.com",4],["saucemagazine.com",4],["screenshot-media.com",[4,995]],["superporn.com",4],["tedi.com",4],["the-decoder.com",[4,20]],["thechunkychef.com",4],["thegrayzone.com",4],["thetoyinsider.com",4],["thewindowsclub.com",4],["trtafrika.com",4],["trtarabi.com",[4,1143]],["trtbalkan.com",4],["trtdeutsch.com",[4,1143]],["trtfrancais.com",4],["trtrussian.com",4],["voetbalkrant.com",[4,59,67]],["whiskeyriff.com",4],["deraktionaer.de",[4,206]],["knowledge.wharton.upenn.edu",[4,7]],["sportintv.eu",4],["nasa.gov",4],["newsreleases.sandia.gov",[4,1368]],["casaegiardino.it",4],["davidwalsh.name",4],["allears.net",[4,30]],["cuevanahd.net",4],["alternet.org",4],["bukvy.org",[4,520]],["futurity.org",[4,1713]],["publicdomainreview.org",4],["glas-javnosti.rs",[4,1799]],["pink.rs",4],["unitednews.sr",4],["akkogear.com.vn",[4,1891]],["news.am",5],["newstalk870.am",[6,7]],["wdea.am",[6,7]],["lavoz.com.ar",6],["1019therock.com",[6,7]],["101theeagle.com",[6,7]],["1023thebullfm.com",[6,7]],["1025kiss.com",[6,7]],["1027kord.com",[6,7]],["1033thegoat.com",[6,7]],["1035kissfmboise.com",[6,7]],["1037theloon.com",[6,7]],["1037theriver.com",[6,7]],["103gbfrocks.com",[6,7]],["103kkcn.com",[6,7]],["103wjod.com",[6,7]],["1043wowcountry.com",[6,7]],["1045theteam.com",[6,7]],["1051theblock.com",[6,7]],["1057thehawk.com",[6,7]],["1061evansville.com",[6,7]],["1063nowfm.com",[6,7]],["1063thebuzz.com",[6,7]],["1073kissfmtexas.com",[6,7]],["1073popcrush.com",[6,7]],["1075thepeak.com",[6,7]],["1079ishot.com",[6,7]],["107jamz.com",[6,7]],["1130thetiger.com",[6,7]],["1340thehawk.com",[6,7]],["1390granitecitysports.com",[6,7]],["1420wbec.com",[6,7]],["1440wrok.com",[6,7]],["1470kyyw.com",[6,7]],["1520theticket.com",[6,7]],["560kmon.com",[6,7]],["610kona.com",[6,7]],["710keel.com",[6,7]],["890kdxu.com",[6,7]],["925kaar.com",[6,7]],["925theranch.com",[6,7]],["929nin.com",[6,7]],["929thebull.com",[6,7]],["929thelake.com",[6,7]],["929theticket.com",[6,7]],["943litefm.com",[6,7]],["943thepoint.com",[6,7]],["943thex.com",[6,7]],["945maxcountry.com",[6,7]],["949whom.com",[6,7]],["94kix.com",[6,7]],["953thebear.com",[6,7]],["955kmbr.com",[6,7]],["95rockfm.com",[6,7]],["961theeagle.com",[6,7]],["963theblaze.com",[6,7]],["965kvki.com",[6,7]],["965therock.com",[6,7]],["965thewalleye.com",[6,7]],["969zoofm.com",[6,7]],["973espn.com",[6,7]],["973kkrc.com",[6,7]],["973thedawg.com",[6,7]],["975kgkl.com",[6,7]],["975now.com",[6,7]],["979kickfm.com",[6,7]],["97rockonline.com",[6,7]],["97x.com",[6,7]],["97zokonline.com",[6,7]],["981thehawk.com",[6,7]],["983thesnake.com",[6,7]],["987jack.com",[6,7]],["987kissfmsanangelo.com",[6,7]],["987thebomb.com",[6,7]],["987thegrand.com",[6,7]],["995theapple.com",[6,7]],["999bigskysports.com",[6,7]],["999ktdy.com",[6,7]],["999thepoint.com",[6,7]],["99wfmk.com",[6,7]],["allhitskzmk.com",[6,7]],["alt1017.com",[6,7]],["alternativemissoula.com",[6,7]],["antennamag.com",[6,7]],["artnews.com",[6,320]],["awesome98.com",[6,7]],["b100quadcities.com",[6,7]],["b1027.com",[6,7]],["b105country.com",[6,7]],["b921hits.com",[6,7]],["banana1015.com",[6,7]],["bigcat921.com",[6,7]],["bigcat953.com",[6,7]],["bigcountry969.com",[6,7]],["bigfrog104.com",[6,7]],["bigstack1039.com",[6,7]],["billingsmix.com",[6,7]],["bozemanskissfm.com",[6,7]],["caspercowboy.com",[6,7]],["catcountry1029.com",[6,7]],["catcountry1073.com",[6,7]],["catcountryutah.com",[6,7]],["catfishtuscaloosa.com",[6,7]],["classicrock1051.com",[6,7]],["classicrock961.com",[6,7]],["club937.com",[6,7]],["cnynews.com",[6,7]],["coindesk.com",[6,450]],["cool987fm.com",[6,7]],["crn.com",[6,475]],["dakotacountry961.com",[6,7]],["danburycountry.com",[6,7]],["dave1077.com",[6,7]],["eagle1023fm.com",[6,7]],["eagle933.com",[6,7]],["espn960sanangelo.com",[6,7]],["espnquadcities.com",[6,7]],["espnsiouxfalls.com",[6,7]],["espnwesterncolorado.com",[6,7]],["euromaidanpress.com",6],["foxsports1510.com",[6,7]],["foxsportsutahradio.com",[6,7]],["fun1043.com",[6,7]],["fun107.com",[6,7]],["fun947.com",[6,7]],["gadgets360.com",[6,618]],["gator995.com",[6,7]],["highway989.com",[6,7]],["hot1047.com",[6,7]],["hot975fm.com",[6,7]],["hot991.com",[6,7]],["hudsonvalleycountry.com",[6,7]],["i95rock.com",[6,7]],["i95rocks.com",[6,7]],["jackfmcasper.com",[6,7]],["juan925fm.com",[6,7]],["juanhudsonvalley.com",[6,7]],["k2radio.com",[6,7]],["k945.com",[6,7]],["k96fm.com",[6,7]],["k99.com",[6,7]],["k99hits.com",[6,7]],["katsfm.com",[6,7]],["kbat.com",[6,7]],["kbulnewstalk.com",[6,7]],["kcrr.com",[6,7]],["kdat.com",[6,7]],["kdhlradio.com",[6,7]],["keanradio.com",[6,7]],["kekbfm.com",[6,7]],["keyj.com",[6,7]],["keyw.com",[6,7]],["keyzradio.com",[6,7]],["kezj.com",[6,7]],["kffm.com",[6,7]],["kfilradio.com",[6,7]],["kfmx.com",[6,7]],["kfox95.com",[6,7]],["kfyo.com",[6,7]],["kgab.com",[6,7]],["kgrzmissoula.com",[6,7]],["khak.com",[6,7]],["khmoradio.com",[6,7]],["kickam1530.com",[6,7]],["kicks105.com",[6,7]],["kidotalkradio.com",[6,7]],["kikn.com",[6,7]],["king-mag.com",[6,7]],["kingfm.com",[6,7]],["kisscasper.com",[6,7]],["kisselpaso.com",[6,7]],["kissfm1053.com",[6,7]],["kissfm969.com",[6,7]],["kissin977.com",[6,7]],["kixs.com",[6,7]],["kkam.com",[6,7]],["kkyr.com",[6,7]],["klaq.com",[6,7]],["klaw.com",[6,7]],["klubtejano.com",[6,7]],["kmhk.com",[6,7]],["kmmsam.com",[6,7]],["knue.com",[6,7]],["koel.com",[6,7]],["kool1017.com",[6,7]],["kool1079.com",[6,7]],["kool929fm.com",[6,7]],["kool965.com",[6,7]],["koolfmabilene.com",[6,7]],["kowb1290.com",[6,7]],["kpel965.com",[6,7]],["kpq.com",[6,7]],["kqvt.com",[6,7]],["krfofm.com",[6,7]],["krforadio.com",[6,7]],["krna.com",[6,7]],["kroc.com",[6,7]],["krocnews.com",[6,7]],["krod.com",[6,7]],["ksenam.com",[6,7]],["ksfa860.com",[6,7]],["ksisradio.com",[6,7]],["ksub590.com",[6,7]],["ktemnews.com",[6,7]],["kubcthecanyon.com",[6,7]],["kw3.com",[6,7]],["kwcdcountry.com",[6,7]],["kxkx.com",[6,7]],["kxrb.com",[6,7]],["kxtl.com",[6,7]],["kygl.com",[6,7]],["kyssfm.com",[6,7]],["lite987.com",[6,7]],["litefm955.com",[6,7]],["liteonline.com",[6,7]],["live959.com",[6,7]],["lonestar923.com",[6,7]],["lonestar995fm.com",[6,7]],["loudwire.com",[6,7]],["mega993online.com",[6,7]],["minnesotasnewcountry.com",[6,7]],["mix1043fm.com",[6,7]],["mix106radio.com",[6,7]],["mix108.com",[6,7]],["mix931fm.com",[6,7]],["mix941kmxj.com",[6,7]],["mix949.com",[6,7]],["mix951.com",[6,7]],["mix957gr.com",[6,7]],["mix979fm.com",[6,7]],["montanastatenews.com",[6,7]],["mooseradio.com",[6,7]],["my1053wjlt.com",[6,7]],["myb106.com",[6,7]],["mybeachradio.com",[6,7]],["mycountry955.com",[6,7]],["myjuan1017.com",[6,7]],["mykiss1031.com",[6,7]],["mykisscountry937.com",[6,7]],["mymagicgr.com",[6,7]],["mymagiclc.com",[6,7]],["mymajic933.com",[6,7]],["mymix923.com",[6,7]],["myq1075.com",[6,7]],["newsradio1310.com",[6,7]],["newstalk1280.com",[6,7]],["newstalk1290.com",[6,7]],["newstalk940.com",[6,7]],["newstalkkgvo.com",[6,7]],["newstalkkit.com",[6,7]],["nick975.com",[6,7]],["nj1015.com",[6,7]],["noisecreep.com",[6,7]],["northlandfan.com",[6,7]],["popcrush.com",[6,7]],["power1029noco.com",[6,7]],["power959.com",[6,7]],["power96radio.com",[6,7]],["powerboise.com",[6,7]],["praise933.com",[6,7]],["q1057.com",[6,7]],["q1077.com",[6,7]],["q961.com",[6,7]],["q985online.com",[6,7]],["quickcountry.com",[6,7]],["retro1025.com",[6,7]],["river967.com",[6,7]],["rivergrandrapids.com",[6,7]],["rock1041.com",[6,7]],["rock967online.com",[6,7]],["screencrush.com",[6,7]],["shark1053.com",[6,7]],["sojo1049.com",[6,7]],["sportsradio977.com",[6,7]],["squatchrocks.com",[6,7]],["star939.com",[6,7]],["star981.com",[6,7]],["supertalk1270.com",[6,7]],["talk1067.com",[6,7]],["talk1470.com",[6,7]],["talkradio960.com",[6,7]],["tasteofcountry.com",[6,7]],["theboot.com",[6,7]],["thebullamarillo.com",[6,7]],["thegame730am.com",[6,7]],["theinertia.com",[6,641,1093]],["thequake1021.com",[6,7]],["theriver979.com",[6,7]],["therockofrochester.com",[6,7]],["thunder981.com",[6,7]],["tide1009.com",[6,7]],["ultimateclassicrock.com",[6,7]],["us103.com",[6,7]],["us1033.com",[6,7]],["us1049quadcities.com",[6,7]],["us105fm.com",[6,7]],["vancouversun.com",6],["wbckfm.com",[6,7]],["wbkr.com",[6,7]],["wblk.com",[6,7]],["wblm.com",[6,7]],["wbsm.com",[6,7]],["wbxxfm.com",[6,7]],["wchram.com",[6,7]],["wcrz.com",[6,7]],["wcyy.com",[6,7]],["wdbqam.com",[6,7]],["wfnt.com",[6,7]],["wfpg.com",[6,7]],["wgna.com",[6,7]],["wgrd.com",[6,7]],["wibx950.com",[6,7]],["winnipegsun.com",6],["witl.com",[6,7]],["wjbq.com",[6,7]],["wjimam.com",[6,7]],["wjon.com",[6,7]],["wkdq.com",[6,7]],["wkfr.com",[6,7]],["wkmi.com",[6,7]],["wmmq.com",[6,7]],["wnaw.com",[6,7]],["wnbf.com",[6,7]],["wokq.com",[6,7]],["womiowensboro.com",[6,7]],["wour.com",[6,7]],["wpdh.com",[6,7]],["wpst.com",[6,7]],["wrkr.com",[6,7]],["wrrv.com",[6,7]],["wsbs.com",[6,7]],["wsrkfm.com",[6,7]],["wtug.com",[6,7]],["wupe.com",[6,7]],["wyrk.com",[6,7]],["wzozfm.com",[6,7]],["xlcountry.com",[6,7]],["xxlmag.com",[6,7]],["y105fm.com",[6,7]],["y105music.com",[6,7]],["y95country.com",[6,7]],["z100missoula.com",[6,7]],["z1073.com",[6,7]],["z94.com",[6,7]],["zoey1039.com",[6,7]],["wobm.comm",[6,7]],["businessinsider.de",[6,9]],["92moose.fm",[6,7]],["b985.fm",[6,7]],["k923.fm",[6,7]],["q1065.fm",[6,7]],["q985.fm",[6,7]],["967theeagle.net",[6,7]],["b93.net",[6,7]],["lifestyle.bg",7],["money.bg",7],["news.bg",[7,68]],["topsport.bg",7],["pocketgamer.biz",7],["nau.ch",7],["addapinch.com",7],["anothermag.com",7],["antena3.com",[7,310]],["armageddonexpo.com",[7,9]],["averiecooks.com",7],["cgchannel.com",7],["classic105.com",7],["diariolasamericas.com",[7,12]],["fortune.com",7],["gimmedelicious.com",7],["hannity.com",[7,484]],["idsnews.com",7],["insurancejournal.com",7],["jobrapido.com",7],["meteosafe.com",7],["mobilesyrup.com",[7,484]],["moviemaker.com",[7,45,833]],["mymodernmet.com",[7,840]],["oann.com",7],["overwolf.com",[7,206,921]],["realnewsmontana.com",7],["san.com",[7,520]],["saturdayeveningpost.com",[7,993]],["searchnowweb.com",7],["sfist.com",[7,9,1009]],["soaps.sheknows.com",7],["skinnyms.com",[7,1020]],["stoneyroads.com",7],["tuasaude.com",7],["upworthy.com",[7,272]],["wakingtimes.com",7],["alpin.de",[7,9]],["bnn.de",7],["med.stanford.edu",[7,109]],["serieturche.eu",7],["ebu.io",7],["bolina.it",[7,934]],["deghi.it",7],["orizzontescuola.it",7],["passioneturchia.it",7],["maghrebemergent.net",[7,1602]],["nationalactionnetwork.net",7],["thedailystar.net",7],["wijwedden.net",7],["trustradio.com.ng",7],["bitcoinmagazine.nl",[7,1627]],["nextplay.nl",[7,691]],["fullfact.org",7],["jstor.org",7],["quantamagazine.org",7],["culture.pl",[7,1770]],["global.espreso.tv",[7,1840]],["i24news.tv",[7,1845]],["rocketbeans.tv",7],["metro.us",[7,1885]],["sowetanlive.co.za",[7,260]],["wantedonline.co.za",[7,9]],["0221.com.ar",8],["agrositio.com.ar",9],["noticiargentina.com.ar",9],["radionacional.com.ar",9],["therese-moelk.at",9],["christiantoday.com.au",9],["mumbrella.com.au",9],["skynews.com.au",9],["slurpee.com.au",9],["dhakacourier.com.bd",9],["knack.be",9],["voetbal24.be",9],["voetbalnieuws.be",9],["notibolivia.bo",9],["paginasiete.bo",9],["geraligado.blog.br",[9,75]],["climatempo.com.br",9],["conjur.com.br",9],["correiobraziliense.com.br",[9,93]],["estadao.com.br",[9,20,100,101,102]],["estrelando.com.br",[9,103]],["odia.ig.com.br",9],["jornaldebrasilia.com.br",9],["motonline.com.br",9],["olhardigital.com.br",[9,12,33,135]],["portaldotransito.com.br",[9,20]],["portalinsights.com.br",[9,20]],["tuacasa.com.br",9],["uai.com.br",[9,157]],["sportnews.bz",[9,170]],["cropmarketchronicles.cc",9],["derleitstern.cc",9],["interventionist.cc",9],["kaputteampel.cc",9],["lesifflet.cc",9],["monovolume.cc",9],["cdt.ch",[9,20,201]],["notichile.cl",9],["pauta.cl",9],["europages.cn",9],["caustica.co",[9,233,234]],["colombiapress.co",9],["12tomatoes.com",[9,250]],["6abc.com",9],["972mag.com",9],["abc11.com",9],["abc30.com",9],["abc7.com",9],["abc7chicago.com",9],["abc7news.com",9],["abc7ny.com",9],["adsoftheworld.com",9],["africa1.com",9],["al-ain.com",[9,89]],["al-akhbar.com",9],["al-sharq.com",[9,20,89]],["albawabhnews.com",9],["algemeiner.com",[9,20]],["alligator-sunglasses.com",9],["allkpop.com",9],["almanaquesos.com",9],["androidiani.com",9],["apkmb.com",9],["assopoker.com",[9,328]],["avira.com",9],["banca5.com",9],["beatsbydre.com",9],["bestlifeonline.com",[9,272]],["bet.com",9],["bleacherreport.com",9],["bobvila.com",9],["boursier.com",9],["businessinsider.com",[9,397]],["christianpost.com",[9,341]],["cityam.com",9],["clarin.com",[9,20]],["classicalite.com",9],["clearancejobs.com",9],["cmt.com",9],["collectorsweekly.com",9],["comicbook.com",[9,44]],["comicbookmovie.com",9],["cookingwithjanica.com",9],["courrierinternational.com",9],["crossmap.com",9],["crowdstrike.com",[9,479]],["dagospia.com",9],["dailysignal.com",[9,286]],["deepsilver.com",9],["diarioti.com",9],["dpreview.com",9],["ebar.com",9],["ecologiaverde.com",[9,16,542]],["ecranlarge.com",9],["eetimes.com",[9,547]],["elconsolto.com",9],["elmundofinanciero.com",[9,553]],["elplural.com",[9,137]],["elvenar.com",9],["entywbas.com",9],["epicgames.com",9],["estrellatv.com",9],["etcanada.com",9],["eurovisionworld.com",[9,570]],["extratv.com",9],["fantamagazine.com",[9,20]],["fastcompany.com",9],["finanzaonline.com",[9,593,594]],["fivebooks.com",[9,30]],["fmglobal.com",9],["formulatv.com",9],["foxcharleston.com",9],["gamergen.com",9],["gidhaur.com",[9,520]],["glistatigenerali.com",9],["gmx.com",9],["grandhotel-et-des-palmes.com",9],["greencarreports.com",9],["grostracteurspassion.com",9],["guildwars2.com",9],["gulfstream.com",9],["haber7.com",9],["hawaii.com",9],["hellogiggles.com",9],["heraldnet.com",9],["hispanidad.com",9],["idiva.com",9],["iliketomakestuff.com",9],["imadrassa.com",9],["infomotori.com",9],["insideedition.com",9],["insider.com",9],["interior-news.com",9],["inthesetimes.com",9],["irannewsdaily.com",9],["isprime.com",9],["journaldugeek.com",9],["kwai.com",9],["lacivertdergi.com",9],["lavozdeltajo.com",9],["ledevoir.com",9],["leseclaireuses.com",9],["lethbridgeherald.com",9],["libertaddigital.com",9],["libremercado.com",9],["lorientlejour.com",9],["madeincucina.com",9],["marvel.com",9],["maxpreps.com",[9,794]],["medicinehatnews.com",9],["miastagebuch.com",9],["mondaymag.com",9],["motorionline.com",9],["muckraker.com",9],["muckrock.com",9],["myevreview.com",9],["nabd.com",[9,29]],["nbcolympics.com",9],["nintendolife.com",9],["nogomania.com",9],["noticiasbravas.com",9],["nplusonemag.com",9],["ntdtv.com",9],["nzgeo.com",9],["nzx.com",9],["olivetti.com",9],["oo-software.com",9],["opendns.com",9],["petitfute.com",9],["petrolicious.com",9],["phanteks.com",9],["phonearena.com",9],["pokernews.com",9],["protonvpn.com",9],["publish0x.com",9],["purexbox.com",9],["pushsquare.com",9],["qualcomm.com",9],["radioorient.com",9],["recipetineats.com",[9,100]],["red-buzz.com",9],["register724.com",9],["renaultsport.com",9],["retailmenot.com",9],["ropeofsilicon.com",9],["rottentomatoes.com",[9,981]],["russia-insider.com",9],["samfw.com",9],["sanook.com",9],["scalescale.com",9],["schiit-europe.com",9],["scorpionbay.com",9],["scottishconservatives.com",9],["searchmarketingexpo.com",9],["seattleweekly.com",9],["sectionstudios.com",9],["sex.com",9],["shacknews.com",9],["shanghaiist.com",9],["shefinds.com",9],["singaporeair.com",9],["smithsonianmag.com",9],["soccerway.com",9],["softexia.com",9],["solidfiles.com",9],["sparknotes.com",9],["spgpromos.com",9],["spin.com",9],["spratings.com",9],["stackpath.com",9],["stardock.com",9],["startpage.com",9],["sygic.com",9],["t3.com",9],["tacticalshit.com",9],["techonthenet.com",[9,1064]],["techpowerup.com",9],["telegiz.com",9],["testimania.com",9],["thebeaverton.com",9],["thedissolve.com",9],["themoscowtimes.com",9],["thepeninsulaqatar.com",9],["theringreport.com",[9,20]],["ti.com",9],["tickld.com",9],["timeextension.com",[9,1123]],["timesofisrael.com",9],["tmonews.com",9],["tmz.com",[9,1126]],["todomecanica.com",9],["toofab.com",[9,1131]],["tourhebdo.com",9],["truecrimedaily.com",[9,1147]],["tt.com",9],["tubestart.com",9],["tudocelular.com",[9,1155]],["tuttomercatoweb.com",[9,62,63,1156]],["utorrent.com",9],["vg247.com",9],["victoriassecret.com",9],["violanews.com",[9,20]],["viralnova.com",9],["vkmag.com",[9,1181]],["voxafrica.com",9],["wallpaper.com",9],["webs.com",9],["wegotthiscovered.com",9],["willyweather.com",9],["woot.com",9],["yachtingjournal.com",9],["legacoop.coop",9],["radio.cz",9],["alpen-guide.de",9],["dastelefonbuch.de",9],["ef-magazin.de",[9,1241]],["infosat.de",9],["kabeleins.de",[9,114]],["klassikradio.de",9],["krautundrueben.de",9],["osthessen-news.de",9],["peugeot.de",9],["prosieben.de",[9,114]],["ran.de",[9,114]],["ranactive.de",9],["sat1.de",[9,114]],["seen.de",9],["sixx.de",[9,114]],["the-voice-of-germany.de",9],["thomann.de",9],["tichyseinblick.de",9],["top.de",9],["ukraine-nachrichten.de",9],["winfuture.de",9],["europages.dk",9],["algerietelecom.dz",9],["notiecuador.com.ec",9],["extra.ec",[9,559]],["cmu.edu",9],["hub.jhu.edu",9],["err.ee",9],["europages.ee",9],["20minutos.es",9],["albaceteabierto.es",9],["clm21.es",9],["europages.es",9],["europapress.es",[9,1303]],["madridiario.es",9],["paginasamarillas.es",9],["publico.es",9],["sport.es",[9,197,556,1308]],["todomercadoweb.es",[9,62,63]],["europages.eu",9],["juvenews.eu",[9,20]],["notiziecalciomercato.eu",9],["europages.fi",9],["20minutes.fr",[9,23]],["doctissimo.fr",9],["europages.fr",9],["europe1.fr",[9,826]],["gmx.fr",9],["ladepeche.fr",[9,63]],["leboncoin.fr",9],["lemondeinformatique.fr",9],["medisite.fr",9],["rustica.fr",9],["sofarsogood.fr",9],["sudouest.fr",[9,33]],["europages.gr",9],["pentapostagma.gr",9],["europages.hk",9],["mikronis.hr",9],["atv.hu",9],["budapester.hu",9],["europages.co.hu",9],["hvg.hu",[9,20]],["metropol.hu",[9,1383]],["veol.hu",9],["lionair.co.id",9],["supermacs.ie",9],["thesun.ie",9],["dunsguide.co.il",9],["businesstoday.in",[9,70,1397,1400]],["ibtimes.co.in",[9,1401]],["indiatodayne.in",[9,635]],["derbayerischelowe.info",9],["forzaroma.info",[9,20]],["korben.info",9],["mobileapk.info",9],["ukrlm.info",9],["deintelligenz.io",9],["derrattenfanger.io",9],["electionwatch.io",9],["il-corrispondente.io",9],["laterrasse.io",9],["lebelligerant.io",9],["liesofwallstreet.io",9],["spicyconspiracy.io",9],["affaritaliani.it",9],["altoadige.it",[9,1426]],["amicidicasa.it",9],["angeloparodi.it",9],["angolotesti.it",9],["aruba.it",9],["auto.it",9],["avivaitalia.it",9],["aztesti.it",9],["badtaste.it",9],["bancaprivataleasing.it",9],["bioisotherm.it",9],["borsadelcredito.it",9],["brindisisera.it",9],["mader.bz.it",9],["calcionapoli1926.it",9],["cielotv.it",9],["cipiacecucinare.it",9],["cittaceleste.it",[9,20]],["consigli.it",[9,45,208,1438]],["coopcasarsa.it",[9,20]],["corriere.it",9],["corrierecomunicazioni.it",[9,1309]],["creditosportivo.it",9],["dequo.it",9],["derbyderbyderby.it",9],["dererker.it",9],["diariodelweb.it",9],["eurogamer.it",9],["euronics.it",9],["europages.it",9],["eurospin.it",9],["fcinter1908.it",[9,20]],["fm-world.it",9],["gay.it",9],["gazzetta.it",[9,20]],["gazzettadimantova.it",9],["gazzettaregionale.it",9],["gedidigital.it",9],["gediwatch.it",9],["giornaledibrescia.it",[9,1450]],["giornaletrentino.it",[9,1426]],["golssip.it",[9,20]],["gse.it",9],["hdmotori.it",[9,772,1155]],["hellas1903.it",9],["html.it",9],["ildolomiti.it",[9,20]],["ilgiornale.it",[9,402]],["ilmilanista.it",[9,20]],["ilpost.it",9],["ilposticipo.it",9],["inmoto.it",9],["istat.it",9],["italiaoggi.it",9],["itasportpress.it",[9,20]],["ivid.it",9],["kataweb.it",9],["lapressa.it",9],["laprovinciadivarese.it",9],["lasicilia.it",9],["liberoquotidiano.it",9],["lifegate.it",[9,20,1474]],["linkiesta.it",9],["luinonotizie.it",9],["magnoliatv.it",9],["mdspa.it",9],["mediagol.it",[9,20]],["mediocredito.it",9],["milanofinanza.it",9],["mondoudinese.it",[9,20]],["moto.it",9],["mtv.it",9],["nationalgeographic.it",9],["naturalborngamers.it",9],["numericalcio.it",[9,20]],["omnialyrics.it",9],["opinione.it",9],["ornews.it",[9,45]],["pianetamilan.it",[9,20]],["regione.piemonte.it",9],["pneusnews.it",9],["primainfanzia.it",9],["professionearchitetto.it",9],["proiezionidiborsa.it",9],["qualenergia.it",9],["quice.it",9],["radiocitymilano.it",9],["rollingstone.it",9],["roncadin.it",9],["rossopomodoro.it",9],["sardiniapost.it",9],["sorgenia.it",9],["spunteblu.it",9],["suzuki.it",9],["tari.it",9],["tuttobolognaweb.it",[9,20]],["unica.it",[9,1469]],["unita.it",[9,1521]],["units.it",9],["vg247.it",9],["vitatrentina.it",9],["viveregiovani.it",9],["vortice.it",9],["mobilenews.jp",9],["europages.lt",9],["europages.lv",9],["latvija.lv",9],["lematin.ma",9],["monacomatin.mc",[9,20]],["radbox.me",9],["vijesti.me",9],["lesfrontieres.media",9],["debate.com.mx",9],["notimexico.com.mx",9],["razon.com.mx",9],["informador.mx",9],["az.com.na",9],["republikein.com.na",9],["we.com.na",9],["centerblog.net",9],["damndelicious.net",9],["humordido.net",9],["ilsussidiario.net",[9,20]],["islamweb.net",9],["jamescoyle.net",9],["neowin.net",9],["rmcsport.net",9],["sucuri.net",9],["toronews.net",[9,20]],["tweakers.net",[9,1621]],["typomaps.net",9],["uk-mkivs.net",9],["urbanomnibus.net",9],["wanderfalke.net",9],["ultimominuto.news",[9,1625]],["guardian.ng",[9,1626]],["112brabant.nl",9],["112nederland.nl",9],["bnr.nl",[9,1628]],["dvhn.nl",9],["europages.nl",9],["marketingtribune.nl",9],["noordernieuws.nl",9],["rd.nl",9],["rtlnieuws.nl",9],["schuttevaer.nl",9],["sciencenorway.no",[9,1665]],["christiantoday.co.nz",9],["jeep.co.nz",9],["derglaube.online",9],["uschina.online",9],["aica.org",9],["al-shabaka.org",[9,20]],["arbeitspause.org",9],["c-span.org",[9,20]],["chimeraos.org",9],["democracynow.org",[9,20,1705]],["filmitalia.org",9],["gunviolencearchive.org",9],["healthychild.org",9],["impresspages.org",9],["indypendent.org",9],["jns.org",9],["meetingrimini.org",9],["monthlyreview.org",9],["moviechat.org",9],["omdb.org",9],["responsibility.org",9],["rickey.org",9],["rtcc.org",9],["truthout.org",9],["twr.org",9],["washwasha.org",9],["wdet.org",9],["workersliberty.org",9],["notipanama.com.pa",9],["notiperu.com.pe",9],["europages.pl",9],["goldenline.pl",9],["pap.pl",9],["acrosstheline.press",9],["hauynescherben.press",9],["mypride.press",9],["raya.ps",9],["abola.pt",[9,1778]],["autofoco.pt",9],["dn.pt",9],["iol.pt",[9,228,1784]],["notiparaguay.com.py",9],["rts.rs",9],["forbes.ru",[9,228]],["mk.ru",9],["moscowtimes.ru",9],["retrofm.ru",9],["vz.ru",[9,20]],["europages.se",9],["swedroid.se",9],["europages.si",9],["allons-y.social",9],["thomson",9],["hannibaltv.com.tn",[9,1827]],["misk.tn",9],["franceeteu.today",9],["notrepays.today",9],["a2tv.com.tr",9],["atv.com.tr",9],["dr.com.tr",9],["deabyday.tv",9],["madanichannel.tv",9],["noursat.tv",9],["padovasport.tv",[9,20]],["sat.tv",9],["streamkiste.tv",[9,1850]],["u.tv",9],["lancaster.ac.uk",9],["ox.ac.uk",9],["ucl.ac.uk",[9,40,870]],["carmagazine.co.uk",9],["masterinvestor.co.uk",9],["sportsmole.co.uk",9],["thescottishsun.co.uk",9],["thesun.co.uk",9],["scottishlabour.org.uk",9],["notiuruguay.uy",9],["jeu.video",9],["businesslive.co.za",9],["dailymaverick.co.za",9],["dispatchlive.co.za",[9,260]],["heraldlive.co.za",[9,260]],["timeslive.co.za",[9,260,335]],["trust.zone",9],["classifieds.co.zw",9],["batimes.com.ar",10],["perfil.com",[10,263,929]],["diariodecuyo.com.ar",11],["diariouno.com.ar",12],["letrap.com.ar",12],["radio-osterreich.at",[12,30]],["radio-belgie.be",[12,30]],["internetradio-schweiz.ch",[12,30]],["emisorascolombianas.co",[12,30]],["thecradle.co",12],["accessonline.com",[12,267]],["ambito.com",[12,29]],["animecenterbr.com",12],["arenaev.com",12],["assafirarabi.com",[12,327]],["auto-moto.com",[12,336]],["canadaradiostations.com",[12,30]],["canli-radyo-dinle.com",[12,30]],["criminaljusticedegreehub.com",12],["deseret.com",[12,249]],["design-milk.com",12],["emisoras-puertorico.com",[12,30]],["exputer.com",12],["ff-bz.com",12],["fmradiofree.com",[12,30]],["gamosaurus.com",12],["gizmodo.com",[12,165]],["globalconstructionreview.com",12],["hardwaretimes.com",[12,666]],["houstoniamag.com",12],["informe360.com",[12,706]],["mediaplaynews.com",12],["nbcbayarea.com",12],["nbcboston.com",12],["nbcchicago.com",12],["nbcconnecticut.com",12],["nbcdfw.com",12],["nbclosangeles.com",12],["nbcmiami.com",12],["nbcnewyork.com",12],["nbcphiladelphia.com",12],["nbcsandiego.com",12],["nbcwashington.com",12],["necn.com",12],["psychologies.com",12],["psychologytoday.com",12],["radio-ao-vivo.com",[12,30]],["radio-dominicana.com",[12,30]],["radio-hk.com",[12,30]],["radio-hrvatska.com",[12,30]],["radio-korea.com",[12,30]],["radio-philippines.com",[12,30]],["radio-singapore.com",[12,30]],["radio-suomi.com",[12,30]],["radio-thai.com",[12,30]],["radio-ua.com",[12,30]],["radios-bolivia.com",[12,30]],["radios-chilenas.com",[12,30]],["radios-guatemala.com",[12,30]],["radios-uruguay.com",[12,30]],["radios-venezuela.com",[12,30]],["robbreport.com",12],["spy.com",[12,1012]],["telemundo20.com",12],["telemundo31.com",12],["telemundo33.com",12],["telemundo40.com",12],["telemundo47.com",12],["telemundo48elpaso.com",12],["telemundo49.com",12],["telemundo51.com",12],["telemundo52.com",12],["telemundo62.com",12],["telemundoareadelabahia.com",12],["telemundoarizona.com",12],["telemundochicago.com",12],["telemundodallas.com",12],["telemundodenver.com",12],["telemundofresno.com",12],["telemundohouston.com",12],["telemundolasvegas.com",12],["telemundonuevainglaterra.com",12],["telemundonuevomexico.com",12],["telemundopr.com",12],["telemundosanantonio.com",12],["telemundoutah.com",12],["telemundowashingtondc.com",12],["tenor.com",12],["wn.com",12],["internetradio-horen.de",[12,30]],["radio-danmark.dk",[12,30]],["radio-espana.es",[12,30]],["radio-en-ligne.fr",[12,30]],["radioindia.in",[12,30]],["datingscammer.info",12],["radio-italiane.it",[12,30]],["radio-en-vivo.mx",[12,30]],["formule1.nl",12],["radio-nederland.nl",[12,30]],["techzine.nl",12],["vlaamskijken.nl",12],["adressa.no",12],["radio-stations.co.nz",[12,30]],["apk4free.org",12],["investigativepost.org",12],["radio-australia.org",[12,30]],["radio-ecuador.org",[12,30]],["radio-maroc.org",[12,30]],["radio-norge.org",[12,30]],["radioindonesia.org",[12,30]],["radiojapan.org",[12,30]],["radiomalaysia.org",[12,30]],["radios-argentinas.org",[12,30]],["radiosdelperu.pe",[12,30]],["pastebin.pl",[12,130]],["radio-polska.pl",[12,30]],["radios-online.pt",[12,30]],["radio-sveriges.se",[12,30]],["radiotaiwan.tw",[12,30]],["bank.gov.ua",12],["metro.co.uk",[12,1867]],["radio-uk.co.uk",[12,30]],["radio-south-africa.co.za",[12,30]],["eleconomista.com.ar",[13,14]],["acordacidade.com.br",[13,77]],["harem69.com.br",13],["lula.com.br",[13,113]],["tvcultura.com.br",13],["biobiochile.cl",[13,218]],["crea-mexico.com",13],["elonce.com",[13,242]],["expansion.com",[13,576]],["futbolred.com",[13,233,616]],["humordaterra.com",13],["jornaldocomercio.com",[13,729]],["laverdad.com",[13,16]],["mvsnoticias.com",[13,145,146]],["portalperifacon.com",[13,105,940]],["elobservador.com.uy",[13,1887]],["futbol.com.uy",13],["montevideo.com.uy",13],["pantallazo.com.uy",13],["elterritorio.com.ar",15],["diarioeldia.cl",15],["lanacion.com.ar",16],["el9nou.cat",16],["uab.cat",16],["elsaltodiario.com",16],["psicologia-online.com",16],["revistafamilia.ec",16],["qmusica.tv",16],["meteored.com.ar",17],["meteored.cl",17],["tameteo.com",17],["tempo.com",17],["tiempo.com",17],["meteored.mx",17],["ilmeteo.net",[17,77,1597]],["tempo.pt",17],["voydeviaje.com.ar",18],["deportv.gov.ar",19],["infofranquicias.ar",[20,21]],["laola1.at",20],["cricket.com.au",20],["karryon.com.au",20],["radiotoday.com.au",20],["infonegocios.barcelona",[20,21]],["sportando.basketball",20],["actiefwonen.be",20],["autoline.be",20],["autoline-nl.be",20],["businessam.be",20],["diningcity.be",20],["gettyimages.be",20],["landrover.be",20],["newsmonkey.be",20],["nieuwsblad.be",[20,64]],["infonegocios.biz",[20,21]],["autoline.bo",20],["administradores.com.br",20],["crusoe.com.br",20],["epochtimes.com.br",[20,97]],["exclusivo.com.br",20],["forbes.com.br",[20,84]],["landrover.com.br",20],["londrinasexy.com.br",20],["naomesmo.com.br",20],["obastidor.com.br",20],["otempo.com.br",[20,137,138]],["portugueselegal.com.br",20],["rftvoficial.com.br",20],["socialistamorena.com.br",20],["uol.com.br",[20,158]],["mmegi.bw",20],["autoline.by",20],["cbc.ca",[20,175]],["ara.cat",[20,193]],["elperiodico.cat",20],["kleinreport.ch",20],["landrover.ch",20],["nzz.ch",20],["cncnews.cn",20],["landrover.com.cn",20],["411mania.com",[20,257]],["9gag.com",20],["alfredopedulla.com",[20,283]],["alibaba.com",20],["aristeguinoticias.com",20],["arizonasports.com",20],["astanatimes.com",20],["autoline-az.com",20],["autoline-br.com",20],["autoline-ge.com",20],["autoline-tm.com",20],["averagelinuxuser.com",[20,338]],["basketinside.com",20],["blogtivvu.com",20],["cctv.com",20],["ch-aviation.com",20],["classicandsportscar.com",20],["cnbcindonesia.com",20],["cnnturk.com",20],["columbian.com",[20,457]],["corsedimoto.com",20],["courthousenews.com",[20,471]],["cryptopotato.com",[20,484]],["dailysabah.com",[20,496,497]],["dailytrust.com",20],["devisesquare.com",20],["dictionary.com",[20,519]],["downzen.com",20],["ecoaustral.com",20],["elgrafico.com",20],["elperiodico.com",[20,197,555,556]],["elquindiano.com",20],["euobserver.com",20],["flowingdata.com",20],["food.com",20],["football365.com",20],["frandroid.com",20],["gamespot.com",20],["gamingonlinux.com",[20,40]],["geekwire.com",20],["about.gitlab.com",20],["godtube.com",20],["hispantv.com",[20,677]],["idcquan.com",20],["indy100.com",20],["intesasanpaolo.com",20],["jewishinsider.com",[20,491]],["jweekly.com",20],["kingarthurbaking.com",20],["ktar.com",20],["lagranepoca.com",20],["landroverkz.com",20],["laprensagrafica.com",20],["lifezette.com",[20,765,766]],["megasesso.com",20],["milesplit.com",20],["money.com",20],["mynorthwest.com",20],["neoplan.com",20],["newhua.com",20],["newsmaxtv.com",20],["nicematin.com",20],["asia.nikkei.com",20],["notateslaapp.com",[20,335,885]],["ntn24.com",20],["oantagonista.com",20],["omglinux.com",20],["paper-io.com",20],["passioneinter.com",20],["planetrugby.com",20],["planetware.com",20],["new.qq.com",20],["qz.com",20],["recyclingproductnews.com",[20,29]],["reductress.com",20],["segmentnext.com",20],["slantmagazine.com",20],["sportsbusinessjournal.com",[20,78]],["steampowered.com",20],["tasteandtellblog.com",20],["tenniscircus.com",20],["tennismajors.com",20],["testfakta.com",20],["theroot.com",20],["toy-people.com",20],["trend-online.com",[20,100]],["tuttoeuropei.com",20],["valeursactuelles.com",20],["vastoweb.com",20],["vectorstock.com",20],["videogamer.com",20],["wdhafm.com",20],["webdunia.com",20],["wikiway.com",20],["windowslatest.com",20],["windowsreport.com",[20,1201]],["xxxymovies.com",[20,160]],["yougov.com",20],["ukrinform.de",[20,125]],["weltbild.de",20],["dr.dk",20],["gettyimages.dk",20],["landrover.dk",20],["news.unl.edu",20],["autoline.es",20],["gettyimages.es",20],["infonegociosgalicia.es",[20,21]],["infonegociosvalencia.es",[20,21]],["landrover.es",20],["lavozdegalicia.es",20],["ukrinform.es",[20,125]],["autoline-eu.fr",20],["buzzmoica.fr",20],["commentwiki.fr",[20,33]],["ecommercemag.fr",20],["epochtimes.fr",20],["franceinter.fr",20],["francetvinfo.fr",[20,86,1342]],["gettyimages.fr",20],["landrover.fr",20],["ukrinform.fr",[20,125]],["insomnia.gr",20],["knjizara-dominovic.hr",20],["diningcity.hu",20],["landrover.hu",20],["napi.hu",20],["nuus.hu",20],["speakingtree.in",20],["infoenergia.info",[20,21]],["infomendoza.info",[20,21]],["infonegocios.info",[20,21]],["infostyle.info",[20,21]],["infotecnologia.info",[20,21]],["injujuy.info",[20,21]],["inlitoral.info",[20,21]],["inneuquen.info",[20,21]],["inpatagonia.info",[20,21]],["inrosario.info",[20,21]],["insalta.info",[20,21]],["insanjuan.info",[20,21]],["insantiagodelestero.info",[20,21]],["intucuman.info",[20,21]],["laverita.info",20],["madeinbz.info",[20,1146,1413]],["autodidacts.io",20],["good.is",20],["amica.it",20],["areanapoli.it",20],["autoline-eu.it",20],["bianconeranews.it",20],["carpicalcionews.it",20],["chicercacasa.it",20],["firenzeviola.it",20],["foodnetwork.it",20],["funweek.it",20],["gazzamercato.it",20],["gettyimages.it",20],["miur.gov.it",20],["ilsecoloxix.it",20],["ilviaggiatorgoloso.it",20],["isaechia.it",[20,1459]],["laleggepertutti.it",20],["landrover.it",20],["lantidiplomatico.it",20],["lastampa.it",20],["metropolitano.it",20],["nachrichten.it",20],["paginegialle.it",20],["panorama.it",20],["perlaretorica.it",20],["radiotirol.it",20],["ravennanotizie.it",20],["reteimprese.it",20],["romadailynews.it",[20,1478]],["sassuolocalcionews.it",20],["sportavellino.it",20],["suedtirol1.it",20],["supereva.it",20],["tag43.it",20],["alu.jp",20],["ukrinform.jp",[20,125]],["autoline.kg",20],["autoline-eu.kz",20],["autoline-ru.lt",20],["autoline.lu",20],["autoline.lv",20],["landrover.lv",20],["infonegocios.madrid",[20,21]],["autoline.md",20],["autoline.me",20],["infonegocios.miami",[20,21]],["eleconomista.com.mx",[20,770,771]],["jornada.com.mx",20],["viveusa.mx",20],["brundisium.net",20],["entaotane.net",20],["huuto.net",20],["maannews.net",[20,172]],["pianetagenoa1893.net",20],["sayrodigital.net",20],["ukrinform.net",20],["xzorra.net",20],["crypto.news",[20,1622]],["aminiya.ng",20],["at5.nl",20],["autoline.nl",20],["automotive-online.nl",20],["bitcoindaily.nl",20],["diningcity.nl",20],["epochtimes.nl",20],["fleet-mobility.nl",20],["gettyimages.nl",20],["landrover.nl",20],["nos.nl",20],["ntr.nl",20],["hyundai.co.nz",20],["fairplanet.org",20],["freespeech.org",20],["kmfa.org",20],["mobilita.org",20],["pbs.org",[20,1736]],["responsiblestatecraft.org",20],["rxresource.org",20],["sleepfoundation.org",[20,1751]],["scholarlykitchen.sspnet.org",20],["stanfordchildrens.org",20],["autoline.pe",20],["autoline.com.pl",20],["gazeta.pl",20],["ukrinform.pl",[20,125]],["autoline.pt",20],["gettyimages.pt",20],["landrover.pt",20],["autoline.com.py",20],["infonegocios.com.py",[20,21]],["autoline.ro",20],["sasomange.rs",20],["autoline-eu.ru",20],["landrover.ru",20],["mail.ru",20],["ria.ru",[20,1813]],["autoline-eu.se",20],["gettyimages.se",20],["landrover.se",20],["va.se",20],["mediacorp.sg",20],["sanmarinortv.sm",20],["autoline.tj",20],["u.today",[20,1831]],["fotomac.com.tr",20],["vavradyo.com.tr",20],["gids.tv",20],["tivusat.tv",20],["cna.com.tw",20],["ltn.com.tw",20],["news.tvbs.com.tw",[20,1853]],["taiwanheute.tw",20],["taiwantoday.tw",20],["autoline.ua",20],["autoline.com.ua",20],["rbc.ua",20],["ukrinform.ua",20],["cardealermagazine.co.uk",20],["dailymail.co.uk",[20,62,63,599,1651,1862,1863]],["exchangerates.org.uk",[20,468]],["autoline.uz",20],["gumtree.co.za",20],["gamereactor.asia",22],["gamereactor.cn",22],["healthshots.com",[22,670]],["relationshiphero.com",22],["gamereactor.cz",22],["gamereactor.de",22],["gamereactor.dk",22],["gamereactor.es",22],["gamereactor.eu",[22,1312]],["gamereactor.fi",22],["gamereactor.fr",22],["gamereactor.it",22],["gamereactor.jp",22],["gamereactor.kr",22],["gamereactor.nl",22],["gamereactor.no",22],["gamereactor.pl",22],["gamereactor.pt",22],["gamereactor.se",22],["bigpara.hurriyet.com.tr",[22,1835]],["meduniwien.ac.at",23],["thueringer-allgemeine.de",23],["shipmag.it",23],["suedtirolnews.it",23],["today.rtl.lu",23],["kleinezeitung.at",24],["stuff.co.nz",[24,1677]],["krone.at",25],["nachrichten.at",26],["carwashpro.nl",[27,319,1629]],["infrasite.nl",[27,319,1629]],["mobiliteit.nl",[27,319,1629]],["rijschoolpro.nl",[27,319,1629]],["spoorpro.nl",[27,319,1629]],["tankpro.nl",[27,319,1629]],["taxipro.nl",[27,319,1629]],["zelfrijdendvervoer.nl",[27,319,1629]],["ots.at",29],["webcafe.bg",29],["addictivetips.com",29],["archivebate.com",29],["cracked.com",29],["dacast.com",29],["forward.com",[29,608]],["grunehummel.com",29],["holylandherald.com",[29,680]],["hot.com",29],["instant-gaming.com",29],["intellinews.com",29],["ipwatchdog.com",29],["iranpress.com",29],["jagranjosh.com",[29,725]],["kyivpost.com",[29,414,468,750]],["polskikompas.com",29],["rt.com",[29,984]],["salon.com",[29,988,989]],["thejc.com",[29,1096]],["thetruthaboutcars.com",[29,206,1114]],["einbecker-morgenpost.de",29],["ouest-france.fr",29],["ezalenyeg.hu",29],["hirtv.hu",29],["meisterurian.io",29],["bazar.it",[29,1429]],["ecodibergamo.it",29],["fastweb.it",[29,1446]],["laprovinciadicomo.it",29],["laprovinciaunicatv.it",29],["radiolina.it",29],["screenweek.it",[29,648,1507]],["secoloditalia.it",29],["sportwebsicilia.it",[29,309,1510]],["videolina.it",29],["50statesoflie.media",29],["levinaigre.net",29],["tuttotech.net",29],["candidat.news",29],["lavirgule.news",29],["az.nl",29],["hpdetijd.nl",29],["mechanisatiemarkt.nl",29],["newsbit.nl",29],["mob.org",29],["wng.org",[29,1764]],["mothership.sg",[29,1817]],["animeworld.so",[29,206]],["anews.com.tr",[29,1413]],["animeworld.tv",[29,1836]],["hot.co.uk",29],["shadowwatch.us",29],["truthgate.us",29],["warfareinsider.us",29],["crimeonline.com",30],["dezeen.com",[30,514]],["informer.com",30],["opencritic.com",30],["politicalflare.com",30],["redvoicemedia.com",30],["religionnews.com",30],["tarreo.com",30],["thecollegefix.com",[30,213,1080]],["upcomingvinyl.com",[30,484]],["rai.it",30],["elfinanciero.com.mx",[30,121]],["foxsports.com.mx",[30,1478]],["open.online",30],["eandt.theiet.org",[30,1756]],["soeren-hentzschel.at",[31,32]],["kirjastot.fi",32],["transfermarkt.at",33],["vijesti.ba",33],["transfermarkt.ch",33],["avn.com",33],["bostonmagazine.com",33],["cloth5.com",33],["dzfoot.com",33],["hothardware.com",33],["livingly.com",33],["lonny.com",33],["lovenature.com",33],["malwaretips.com",33],["northernvirginiamag.com",33],["precinctreporter.com",33],["sneakernews.com",33],["sourcefed.com",33],["soutalomma.com",33],["transfermarkt.com",33],["wowhead.com",33],["transfermarkt.de",33],["transfermarkt.es",33],["xn--tbnespaa-j3a.es",33],["lci.fr",33],["atlatszo.hu",[33,413,1378]],["ikhwanonline.info",33],["regione.abruzzo.it",33],["epochtimes.it",[33,97,497]],["kiss100.co.ke",33],["mpasho.co.ke",33],["radiojambo.co.ke",33],["the-star.co.ke",33],["liganews.net",33],["transfermarkt.nl",33],["niedziela.pl",33],["transfermarkt.pl",33],["pnn.ps",[33,497,1776]],["transfermarkt.pt",33],["cas.sk",33],["sabah.com.tr",33],["transfermarkt.com.tr",33],["atvavrupa.tv",33],["transfermarkt.co.uk",33],["wienerzeitung.at",34],["always-on.com.au",35],["arnnet.com.au",36],["csoonline.com",36],["infoworld.com",36],["networkworld.com",36],["chaser.com.au",37],["chasingcars.com.au",38],["crikey.com.au",39],["donnahay.com.au",40],["meteovista.be",40],["ledpros.ca",40],["atomic-robo.com",40],["bollywoodhungama.com",40],["classicreload.com",40],["phoronix.com",40],["telesatellite.com",40],["whtop.com",40],["archifacile.fr",40],["meteovista.fr",40],["sfr.fr",40],["autobelle.it",40],["canavesenews.it",[40,160]],["fotografidigitali.it",40],["lavoro.gov.it",40],["rasom.it",40],["navigaweb.net",[40,1609]],["zookeys.pensoft.net",40],["weeronline.nl",40],["chnetwork.org",40],["meteovista.pl",40],["nexto.pl",40],["joburg.org.za",40],["drive.com.au",41],["dermatologytimes.com",41],["michaelwest.com.au",42],["reneweconomy.com.au",[43,44]],["hyperallergic.com",44],["vice.com",44],["spectator.com.au",45],["goedgevoel.be",45],["amoledo.com",[45,297]],["astrologyzone.com",45],["damninteresting.com",45],["marketingweek.com",45],["metacritic.com",[45,804]],["numberempire.com",45],["onlineradiobox.com",45],["screenrant.com",45],["thegrio.com",45],["thepointsguy.com",45],["indiatoday.in",[45,635,1405]],["raiplay.it",[45,1500]],["goodnet.org",[45,1715]],["theroar.com.au",46],["westpac.com.au",47],["morbidology.com",47],["topuniversities.com",47],["lineageos.org",47],["cyberdaily.au",48],["gamingbolt.com",[48,624]],["unsw.edu.au",49],["newsroom.unsw.edu.au",50],["frieze.com",50],["abc.net.au",51],["futurework.org.au",52],["avaz.ba",53],["klix.ba",54],["n1info.ba",55],["n1info.hr",55],["n1info.rs",55],["nova.rs",55],["n1info.si",55],["oslobodjenje.ba",56],["radiosarajevo.ba",57],["unb.com.bd",58],["atletiekkrant.be",59],["autosportkrant.be",59],["basketbalkrant.be",59],["handbalkrant.be",59],["hockeykrant.be",59],["tenniskrant.be",59],["volleybalkrant.be",59],["vrouwenvoetbalkrant.be",59],["pinetools.com",59],["sport-planet.eu",59],["dvo.be",60],["hagelandactueel.be",61],["leuvenactueel.be",61],["lesoir.be",[62,63]],["teleticino.ch",[62,63]],["catapult.co",[62,63]],["anandtech.com",62],["buzzfil.com",[62,63]],["cadenaazul.com",[62,63,405,406]],["clubic.com",[62,63,441]],["flightglobal.com",[62,599]],["gameranx.com",62],["ludokado.com",[62,63]],["peoplesweather.com",[62,63,405,406,688]],["richersounds.com",[62,274]],["screendaily.com",[62,63,599,688]],["shortlist.com",62],["tripstodiscover.com",[62,63,360]],["trueachievements.com",[62,335,1145,1146]],["truesteamachievements.com",62],["yoink.com",[62,63]],["ifun.de",62],["iphone-ticker.de",62],["lounge.fm",62],["rfm.fr",[62,63,405,406,1349]],["lci.tf1.fr",[62,63,777]],["agenziacasaclima.it",[62,63,405]],["ilfoglio.it",[62,63,406]],["webnews.it",62],["miningjournal.net",62],["programme-tv.net",[62,63]],["iexprofs.nl",62],["filmgo.org",62],["mf24.pl",[62,63,405]],["habrahabr.ru",62],["trt.net.tr",[62,63]],["bdonline.co.uk",[62,599]],["iveybusinessreview.ca",63],["futbol24.com",63],["loi1901.com",[63,777]],["picclick.fr",63],["klimahaus.it",[63,405]],["startromagna.it",63],["suedtiroler-gaertner.it",63],["nyheteridag.se",63],["sporza.be",65],["wielerflits.be",66],["wielerflits.nl",66],["scarpescarpestore.com",67],["tribune.com.pk",[67,1769]],["ceoworld.biz",69],["gamesindustry.biz",70],["abplive.com",70],["24sata.hr",70],["ilmeteo.it",[70,1456]],["insidethegames.biz",71],["kinoland.biz",72],["ctrl.blog",[73,74]],["ein-herz-fuer-kinder.de",73],["empoweringparents.com",75],["tvmaze.com",75],["acheisudoeste.com.br",76],["adrenaline.com.br",78],["mundoconectado.com.br",78],["bossip.com",78],["insidehpc.com",[78,711]],["phonandroid.com",78],["agazeta.com.br",[79,80]],["knewz.com",79],["revolvermag.com",79],["areavip.com.br",81],["jewishpress.com",[81,728]],["techgenyz.com",[81,1061]],["thenewsglobe.net",[81,744]],["schengen.news",[81,1624]],["atarde.com.br",82],["folhadelondrina.com.br",82],["atoananet.com.br",83],["atribuna.com.br",84],["engeplus.com.br",[84,96]],["b9.com.br",85],["bitmag.com.br",86],["batman-news.com",[86,349]],["bbcamerica.com",86],["flashbak.com",86],["fox10phoenix.com",86],["fromthegrapevine.com",86],["fstoppers.com",[86,614]],["grindtv.com",86],["mmoga.com",[86,822]],["shazam.com",86],["techxplore.com",[86,800,1067]],["telanganatoday.com",86],["tribuneindia.com",86],["unz.com",[86,1166]],["verisigninc.com",86],["wonderwall.com",86],["mmoga.de",[86,822]],["s3nnet.de",86],["silicon.de",[86,101]],["mmoga.es",[86,822]],["silicon.es",[86,101,1307]],["mmoga.fr",[86,822]],["ansa.it",[86,484,1427]],["pulsenews.co.kr",86],["alarabiya.net",[86,335,1123,1575]],["geeksaresexy.net",86],["macstories.net",86],["cheapies.nz",86],["catholic.org",86],["phys.org",[86,800]],["symmetrymagazine.org",[86,1316]],["bit.pt",86],["mmoga.se",[86,822]],["mmoga.co.uk",[86,822]],["silicon.co.uk",[86,101]],["skatehut.co.uk",86],["buzzfeed.com.br",87],["canaltech.com.br",88],["cartacapital.com.br",[89,90]],["ecuavisa.com",[89,367,545]],["ocafezinho.com",89],["pcguide.com",89],["ringsidenews.com",[89,974]],["tv100.com",89],["cellulare-magazine.it",89],["cnnbrasil.com.br",91],["connectparts.com.br",92],["canalarte1.uol.com.br",[93,160,161]],["photofunia.com",93],["newsweek.ro",93],["defatoonline.com.br",94],["econodata.com.br",95],["cp24.com",[97,173]],["n-tv.de",[97,1266]],["toyokeizai.net",97],["progressive.org",[97,1741]],["esportesdp.com.br",98],["f1-news.eu",98],["mainichi.jp",[98,1544]],["india.com",100],["news18.com",[100,863]],["wionews.com",[100,1203]],["bricovideo.ovh",100],["cheknews.ca",101],["beebom.com",[101,354]],["captimes.com",[101,415]],["cockroachlabs.com",101],["fandomwire.com",[101,582]],["philstarlife.com",101],["stadiumtalk.com",101],["silicon.fr",101],["magyarnemzet.hu",[101,206,1381]],["silicon.pt",101],["mag.toyota.co.uk",101],["estudokids.com.br",104],["radiorock.com.br",104],["folhape.com.br",[105,106]],["ocioso.com.br",105],["gkpb.com.br",107],["gp1.com.br",108],["ig.com.br",109],["rebelnews.com",[109,964]],["infomoney.com.br",110],["jcconcursos.com.br",111],["jovempan.com.br",112],["maisregiao.com.br",[114,115]],["prosiebenmaxx.de",114],["suomi24.fi",114],["megacidade.com",115],["maquinadoesporte.com.br",116],["megacurioso.com.br",117],["meiahora.com.br",118],["mercadoshops.com.br",119],["mercadowebminas.com.br",120],["metroworldnews.com.br",[121,122]],["irishtimes.com",[121,720]],["mundodomanolo.com.br",123],["nerdrecomenda.com.br",124],["netshoes.com.br",125],["ojornalextra.com.br",[125,134]],["androidpolice.com",[125,137,303,304,305,306,307]],["jagonews24.com",125],["khamsat.com",125],["latenighter.com",125],["milenio.com",[125,816]],["securityaffairs.com",[125,870]],["techopedia.com",125],["thegamer.com",[125,306,307]],["trtworld.com",125],["watchesbysjx.com",125],["iltempo.it",125],["recipes.net",125],["heelhollandbakt.nl",125],["rtvstichtsevecht.nl",[125,1654]],["electricfencing.co.uk",125],["nexojornal.com.br",126],["noticiasaominuto.com.br",[128,129]],["alwatanvoice.com",128],["atlantablackstar.com",[128,329]],["binnews.com",128],["finurah.com",128],["gulf-times.com",128],["iheart.com",[128,694]],["jessekellyshow.com",[128,694]],["jfrog.com",128],["noticiasaominuto.com",[128,129,886]],["sciencefocus.com",128],["steveharveyfm.com",[128,694,1035]],["thehighwire.com",128],["theshadowleague.com",128],["thewildest.com",[128,1119]],["blog.phylum.io",128],["nsctotal.com.br",[130,131]],["oantagonista.com.br",132],["ogol.com.br",133],["omelete.com.br",136],["givemesport.com",[137,305,306]],["agrimag.co.za",[137,304,786]],["automart.co.za",[137,304,786]],["pinkluna.com.br",139],["poder360.com.br",140],["portaldozacarias.com.br",141],["reclameaqui.com.br",142],["redebrasilatual.com.br",143],["rbth.com",[143,260,960]],["larazon.es",[143,1305]],["dutchcowboys.nl",143],["menselijklichaam.nl",[143,484]],["revistaencontro.com.br",144],["thenewamerican.com",144],["glasistre.hr",144],["meemetoranje.nl",144],["femalefirst.co.uk",144],["revistaforum.com.br",[145,146]],["exafm.com",145],["goldderby.com",145],["lamejor.com.mx",145],["tribuna.com.mx",146],["spinoff.com.br",147],["suno.com.br",148],["superesportes.com.br",[149,150]],["elsoldemexico.com.mx",[149,1567]],["tatarada.com.br",151],["tecmundo.com.br",152],["terra.com.br",153],["timnews.com.br",154],["tnh1.com.br",155],["trabalhabrasil.com.br",156],["aventurasnahistoria.uol.com.br",159],["bulawayo24.com",[160,228]],["dbknews.com",160],["designtaxi.com",[160,511]],["hqbabes.com",160],["hqsluts.com",160],["libsyn.com",160],["memuplay.com",[160,803]],["meteoblue.com",[160,805]],["monstercockland.com",160],["seroundtable.com",160],["sohu.com",160],["sputniknewslv.com",160],["m.tribunnews.com",160],["xvideos-br.com",160],["foreca.fi",160],["keepone.net",160],["themoviedb.org",160],["voltairenet.org",160],["sputnik-abkhazia.ru",160],["sputnik-georgia.ru",160],["sputnik-ossetia.ru",160],["koreatimes.com",[161,747]],["folha.uol.com.br",162],["gizmodo.uol.com.br",163],["operamundi.uol.com.br",164],["zapimoveis.com.br",165],["nymag.com",[165,360]],["thisismoney.co.uk",[165,1863,1876]],["aasp.org.br",166],["vermelho.org.br",167],["salto.bz",[168,169]],["algerie-radio.com",168],["alaskahighwaynews.ca",[171,172]],["baytoday.ca",171],["bradfordtoday.ca",171],["cambridgetoday.ca",171],["cochraneeagle.ca",[171,172]],["collingwoodtoday.ca",171],["fitzhugh.ca",171],["haltonhillstoday.ca",171],["innisfiltoday.ca",171],["midlandtoday.ca",171],["miltontoday.ca",171],["mountainviewtoday.ca",[171,172]],["newmarkettoday.ca",171],["newwestrecord.ca",[171,172]],["ontarioflyers.ca",171],["pelhamtoday.ca",171],["stratfordtoday.ca",171],["theorca.ca",[171,172]],["thesarniajournal.ca",171],["thoroldtoday.ca",171],["westernwheel.ca",[171,172]],["airdriecityview.com",171],["barrietoday.com",171],["bowenislandundercurrent.com",[171,172]],["burlingtontoday.com",171],["burnabynow.com",[171,172]],["delta-optimist.com",[171,172]],["elorafergustoday.com",171],["flamboroughtoday.com",171],["guelphtoday.com",171],["moosejawtoday.com",[171,172]],["northernontariobusiness.com",171],["notllocal.com",171],["nsnews.com",[171,172]],["orilliamatters.com",171],["piquenewsmagazine.com",[171,172]],["princegeorgecitizen.com",[171,172]],["prpeak.com",[171,172]],["richmond-news.com",[171,172]],["rmoutlook.com",[171,172]],["sootoday.com",171],["stalbertgazette.com",[171,172]],["sudbury.com",171],["thealbertan.com",171],["timescolonist.com",[171,172]],["tricitynews.com",[171,172]],["vancouverisawesome.com",[171,172]],["coastreporter.net",[171,172]],["oakvillenews.org",171],["lakelandtoday.ca",172],["squamishchief.com",172],["bnnbloomberg.ca",173],["irishnews.com",[173,719]],["thedailybeast.com",[173,1081]],["breachmedia.ca",174],["cfl.ca",176],["citynews.ca",177],["cgtn.com",[177,335,424]],["ctvnews.ca",178],["flyercity.ca",179],["huskiefan.ca",180],["rocketfan.ca",180],["royalsfan.ca",180],["vernonmatters.ca",180],["battlefordsnow.com",180],["everythinggp.com",180],["larongenow.com",180],["lethbridgenewsnow.com",180],["meadowlakenow.com",180],["nanaimonewsnow.com",180],["northeastnow.com",180],["panow.com",180],["rdnewsnow.com",180],["sasknow.com",180],["iphoneincanada.ca",181],["teslanorth.com",181],["nascar.ca",182],["noovomoi.ca",183],["radio-canada.ca",184],["ici.radio-canada.ca",185],["sasktoday.ca",186],["sfu.ca",187],["sportsnet.ca",188],["watch.sportsnet.ca",189],["thetyee.ca",190],["blogmarcosfrahm.com",190],["thewalrus.ca",191],["thefitcareerist.com",191],["nouvelles.umontreal.ca",192],["beteve.cat",194],["ccma.cat",195],["clubdelsubscriptor.cat",196],["diaridegirona.cat",197],["regio7.cat",197],["acierto.com",197],["diariocordoba.com",197],["elperiodicodearagon.com",197],["elperiodicoextremadura.com",197],["elperiodicomediterraneo.com",197],["globovision.com",197],["levante-emv.com",197],["noticiasdenavarra.com",197],["cronicabalear.es",[197,1299]],["diariodeibiza.es",197],["diariodemallorca.es",197],["elcorreogallego.es",197],["eldia.es",197],["farodevigo.es",197],["informacion.es",197],["laopinioncoruna.es",197],["laopiniondemalaga.es",197],["laopiniondezamora.es",197],["laprovincia.es",197],["lne.es",197],["mallorcazeitung.es",197],["superdeporte.es",197],["welife.es",197],["deia.eus",197],["noticiasdealava.eus",197],["noticiasdegipuzkoa.eus",197],["emporda.info",197],["naciodigital.cat",198],["totmedia.cat",199],["totsantcugat.cat",199],["arcinfo.ch",200],["lacote.ch",200],["lenouvelliste.ch",200],["flashbackfm.ch",202],["gastrojournal.ch",[203,204]],["myanimelist.net",[203,1608]],["lematin.ch",205],["letemps.ch",206],["combinationsmag.com",206],["tastecooking.com",206],["tirto.id",206],["bergamonews.it",206],["fantasymagazine.it",206],["almanar.com.lb",206],["portswigger.net",206],["heidi.news",206],["nebelspalter.ch",207],["ocaholic.ch",208],["pctipp.ch",209],["suedostschweiz.ch",210],["unibas.ch",211],["watson.ch",212],["zueritoday.ch",213],["bearingarms.com",[213,352]],["heraldscotland.com",[213,672]],["hotair.com",[213,352]],["latimes.com",[213,754]],["motorsport-total.com",213],["pjmedia.com",213],["redstate.com",[213,352]],["townhall.com",213],["autozeitung.de",213],["formel1.de",[213,1249]],["tag24.de",213],["augustanews.it",213],["avolanews.it",213],["catanianews.it",213],["ibleinews.it",213],["leontinoinews.it",213],["notonews.it",213],["pachinonews.it",213],["sicilianews.it",213],["siracusanews.it",213],["almayadeen.net",213],["meridiano.net",213],["ilsettimanale.online",213],["thenational.scot",213],["takvim.com.tr",213],["glasgowtimes.co.uk",213],["salisburyjournal.co.uk",[213,1871]],["13.cl",214],["adnradio.cl",[215,216]],["cadenaser.com",[215,216]],["caracol.com.co",216],["wradio.com.co",216],["alairelibre.cl",217],["chocale.cl",219],["concierto.cl",220],["fmdos.cl",220],["cooperativa.cl",221],["df.cl",222],["elamaule.cl",223],["elboyaldia.cl",223],["elconcecuente.cl",223],["elmagallanews.cl",223],["elmartutino.cl",223],["elmorrocotudo.cl",223],["elnaveghable.cl",223],["elnortero.cl",223],["elobservatodo.cl",223],["elquehaydecierto.cl",223],["elrancahuaso.cl",223],["elrepuertero.cl",223],["elvacanudo.cl",223],["laopinon.cl",223],["elmostrador.cl",224],["nostalgica.cl",225],["radioimagina.cl",226],["universo.cl",227],["cnr.cn",228],["foodbeast.com",[228,601]],["levantenews.it",228],["twistedfood.co.uk",228],["chinadaily.com.cn",229],["people.com.cn",230],["news.cn",231],["shine.cn",232],["portafolio.co",[233,241,242]],["revistacromos.com.co",[235,236,237]],["trump.news",235],["veteranstoday.news",235],["kuorsauskauppa.fi",236],["decrypt.co",238],["electrek.co",[239,240]],["9to5google.com",[239,240]],["9to5mac.com",[239,240]],["dronedj.com",[239,240]],["9to5toys.com",240],["searchengineland.com",[240,264]],["spaceexplored.com",240],["readcars.co",243],["readfashion.co",243],["readfilm.co",243],["readfood.co",243],["readgaming.co",243],["readmusic.co",243],["readshowbiz.co",243],["readtv.co",243],["readbetting.com",243],["readceltic.com",243],["readmanutd.com",243],["readmotorsport.com",243],["sendatext.co",244],["sugarandsoul.co",[245,246]],["bessiebakes.com",246],["supertvaovivo.co",247],["thehustle.co",248],["10news.com",249],["abebooks.com",[249,265]],["aboutamazon.com",249],["chronicle.com",249],["ktvq.com",249],["laist.com",249],["nbcsports.com",249],["pitchbook.com",249],["scrippsnews.com",[249,997]],["suntimes.com",[249,1044]],["tvazteca.com",249],["vanidades.com",249],["washingtonexaminer.com",249],["aboutamazon.de",249],["aboutamazon.it",249],["adn40.mx",[249,1563]],["iowapublicradio.org",249],["kcur.org",249],["nepm.org",249],["wgbh.org",249],["aboutamazon.co.uk",249],["2001online.com",251],["thepostmillennial.com",[251,402]],["247sports.com",252],["247wallst.com",253],["24ur.com",254],["30seconds.com",255],["3bmeteo.com",256],["4sysops.com",258],["6amcity.com",259],["apnews.com",259],["lopinion.fr",259],["7iber.com",260],["africanews.com",260],["motherjones.com",[260,314]],["online-convert.com",260],["dibujos.net",260],["onet.pl",260],["iservices.pt",260],["novabh.tv",260],["90min.com",261],["9to5linux.com",262],["a24.com",263],["abajournal.com",264],["buddytv.com",264],["gospelway.com",264],["masslive.com",264],["mlive.com",264],["modamee.com",264],["shocktillyoudrop.com",264],["topsecretwriters.com",264],["elektronista.dk",264],["comingsoon.net",264],["gpforums.co.nz",264],["atlasobscura.com",265],["news.abplive.com",266],["aceshowbiz.com",268],["adexchanger.com",269],["admonsters.com",270],["adressit.com",271],["advocate.com",[272,273,274]],["comicsands.com",272],["gbnews.com",272],["rawstory.com",[272,958]],["theblaze.com",272],["commondreams.org",[272,1657]],["spectrum.ieee.org",272],["thefulcrum.us",[272,1316]],["hindustantimes.com",[273,274,674]],["franceantilles.fr",[273,274]],["rtl.fr",[273,274,1350]],["slashdot.org",273],["avtoradio.ru",[273,274,1809]],["leitgamhof.com",274],["gamer.hu",274],["crocebianca.bz.it",274],["eurocash.pl",274],["adweek.com",275],["aetv.com",276],["wccftech.com",[276,1191]],["afar.com",277],["afro.com",278],["hongkongfp.com",278],["lafocusnews.com",278],["ourweekly.com",278],["theatlantavoice.com",278],["washingtoncitypaper.com",[278,346]],["washingtonmonthly.com",278],["investigatemidwest.org",278],["aiseesoft.com",279],["al-watan.com",280],["qatar-tribune.com",280],["alahlionline.com",281],["elkhabar.com",281],["tilifony.com",[281,1122]],["citroenselect.it",281],["nieuweoogst.nl",281],["alchetron.com",282],["aliprice.com",[284,285]],["govtrack.us",284],["allafrica.com",[286,287]],["allkeyshop.com",288],["largus.fr",[288,491]],["almdrrj.com",289],["almesryoon.com",290],["altalex.com",[291,292]],["dailystar.com.lb",291],["eurekalert.org",291],["am800cklw.com",293],["amarujala.com",294],["amazonadviser.com",295],["apptrigger.com",[295,313,314]],["arrowheadaddict.com",295],["bamsmackpow.com",295],["fansided.com",295],["gamesided.com",295],["gojoebruin.com",295],["hiddenremote.com",295],["lastnighton.com",295],["mlsmultiplex.com",295],["netflixlife.com",295],["playingfor90.com",295],["stormininnorman.com",295],["winteriscoming.net",295],["amgreatness.com",296],["ampparit.com",298],["amusingplanet.com",299],["telegraaf.nl",299],["androidheadlines.com",301],["androidpcreview.com",302],["cbr.com",[306,307]],["collider.com",306],["dualshockers.com",[306,307]],["gamerant.com",[306,307]],["howtogeek.com",306],["makeuseof.com",[306,307]],["movieweb.com",[306,307]],["pocketnow.com",[306,307]],["thethings.com",306],["thetravel.com",[306,307]],["xda-developers.com",[306,307]],["backyardboss.net",306],["pocket-lint.com",307],["animenewsnetwork.com",308],["ansalatina.com",309],["disroot.org",309],["applesfera.com",311],["espinof.com",311],["genbeta.com",[311,630]],["vidaextra.com",[311,630,1177]],["vitonica.com",311],["xatakahome.com",311],["xatakamovil.com",311],["xatakandroid.com",311],["application-remuneratrice.com",312],["arabnews.com",315],["archaeologymag.com",316],["argusdelassurance.com",317],["artforum.com",318],["news.artnet.com",319],["magazine.artstation.com",321],["as.com",322],["asiaone.com",323],["ask.com",324],["smarter.com",324],["askmefast.com",325],["aspicyperspective.com",326],["budgetbytes.com",[326,393]],["butterwithasideofbread.com",[326,400]],["downshiftology.com",326],["handletheheat.com",[326,663,664]],["therecipecritic.com",[326,1017]],["twitch.tv",327],["atlantatribune.com",330],["atptour.com",331],["auburnpub.com",332],["azdailysun.com",332],["beatricedailysun.com",332],["billingsgazette.com",332],["bismarcktribune.com",332],["chippewa.com",332],["columbustelegram.com",332],["cumberlink.com",332],["dailyjournalonline.com",332],["democratherald.com",332],["elkodaily.com",332],["fremonttribune.com",332],["gazettetimes.com",332],["globegazette.com",332],["hanfordsentinel.com",332],["helenair.com",332],["herald-review.com",332],["jg-tc.com",332],["journalstar.com",332],["journaltimes.com",332],["lacrossetribune.com",332],["lebanon-express.com",332],["lompocrecord.com",332],["magicvalley.com",332],["missoulanews.com",332],["missoulian.com",332],["mtstandard.com",332],["muscatinejournal.com",332],["napavalleyregister.com",332],["nwitimes.com",332],["pantagraph.com",332],["poststar.com",332],["qconline.com",332],["qctimes.com",332],["rapidcityjournal.com",332],["ravallirepublic.com",332],["santamariatimes.com",332],["siouxcityjournal.com",332],["stltoday.com",[332,844]],["tdn.com",332],["thesouthern.com",332],["thetandd.com",332],["theworldlink.com",332],["trib.com",332],["tucson.com",332],["wcfcourier.com",332],["winonadailynews.com",332],["wiscnews.com",332],["audacy.com",333],["audiofilemagazine.com",334],["ausgamers.com",335],["republicworld.com",335],["truetrophies.com",335],["cloudwards.net",335],["autocarindia.com",337],["avisosdeocasion.com",339],["axios.com",340],["azoai.com",341],["azobuild.com",341],["azocleantech.com",341],["azolifesciences.com",341],["azom.com",341],["azomining.com",341],["azonano.com",341],["azooptics.com",341],["azoquantum.com",341],["azorobotics.com",341],["azosensors.com",341],["crealitycloud.com",[341,473]],["scientificamerican.com",[341,994]],["calcioefinanza.it",341],["libreriascolastica.it",[341,1473]],["libreriauniversitaria.it",[341,1473]],["tiscali.it",341],["news-medical.net",341],["azscore.com",342],["azscore.co.it",342],["babylonbee.com",343],["notthebee.com",[343,889]],["baesystems.com",344],["bangkokpost.com",345],["baptistnews.com",346],["cartoonbrew.com",346],["thefrisc.com",[346,1088]],["washingtoninformer.com",346],["calmatters.org",346],["jta.org",346],["barandbench.com",347],["barrons.com",348],["baystatebanner.com",350],["bdnews24.com",351],["beautifuldecay.com",353],["celebdirtylaundry.com",353],["beincrypto.com",355],["benditofutbol.com",356],["ultimasnoticias.ec",356],["betano.com",357],["bfmtv.com",358],["bhaskarhindi.com",359],["bicycling.com",360],["caranddriver.com",360],["cosmopolitan.com",360],["countryliving.com",360],["delish.com",360],["goodhousekeeping.com",360],["roadandtrack.com",360],["thepioneerwoman.com",360],["vulture.com",360],["bikerumor.com",361],["bingehq.com",362],["douglasnow.com",[362,520,529,530]],["watchinamerica.com",[362,520,530,1188]],["radar.news",362],["bingehulu.com",363],["birdsandblooms.com",364],["familyhandyman.com",364],["rd.com",[364,961]],["tasteofhome.com",[364,1053]],["thehealthy.com",364],["bitinfocharts.com",365],["biznews.com",366],["evreporter.com",366],["unicoebello.it",366],["cassiuslife.com",367],["gosunoob.com",367],["joblo.com",367],["ultiworld.com",367],["insideclimatenews.org",[367,1721]],["mycleo.tv",367],["tvone.tv",367],["bledina.com",368],["bleedingcool.com",369],["blogspot.com",370],["blogto.com",371],["bloomberg.com",372],["bloomberglinea.com",373],["bluradio.com",374],["caracoltv.com",[374,416]],["bnnbreaking.com",375],["bohemian.com",376],["bolavip.com",377],["boldsky.com",378],["bonappetit.com",379],["cntraveler.com",379],["boredpanda.com",380],["lasexta.com",380],["wolverine.com",380],["varesenews.it",380],["criticalthreats.org",380],["bostonagentmagazine.com",381],["boxofficemojo.com",382],["bqprime.com",383],["bracketfights.com",384],["tiermaker.com",384],["ecuadoradio.ec",384],["brasil247.com",[385,386]],["wheelsage.org",385],["bravewords.com",387],["breakingbelizenews.com",388],["worldsensorium.com",388],["spectator.org",388],["breakingdefense.com",389],["breitbart.com",390],["bringmethenews.com",391],["dealbreaker.com",391],["psmag.com",391],["si.com",391],["thestreet.com",391],["brobible.com",392],["business-standard.com",394],["business2community.com",395],["businessgreen.com",396],["computing.co.uk",396],["investmentweek.co.uk",396],["businesstraveller.com",398],["butternutbakeryblog.com",399],["buzzfeed.com",401],["byjus.com",402],["commentpicker.com",402],["hakaimagazine.com",[402,660]],["hollywoodlife.com",402],["iphoneitalia.com",402],["malaymail.com",[402,787]],["maxabout.com",402],["news24.com",402],["tennismagazin.de",402],["politico.eu",402],["ncbi.nlm.nih.gov",402],["nu.nl",[402,1648]],["novosti.rs",402],["homemark.co.za",402],["bylancer.com",403],["c-sharpcorner.com",404],["sassymamahk.com",406],["zoom.earth",406],["cafonline.com",407],["calcalistech.com",408],["calciatoribrutti.com",409],["calciomercato.com",410],["m.calciomercato.com",411],["fliegermagazin.de",411],["tviplayer.iol.pt",411],["joe.co.uk",411],["capital.com",412],["captainaltcoin.com",[413,414]],["celebritycruises.com",413],["elearn.interviewgig.com",413],["orologipertutti.it",413],["tomzorg.nl",413],["ndtv.com",414],["ndtv.in",414],["technicianonline.com",415],["psu.edu",415],["carnewschina.com",[417,418]],["macitynet.it",418],["cars.com",419],["cbn.com",420],["cbssports.com",422],["cgdirector.com",423],["news.cgtn.com",425],["newsus.cgtn.com",425],["chargedevs.com",426],["charlieintel.com",427],["dexerto.com",427],["chatelaine.com",428],["chess.com",429],["chesskid.com",430],["chiesi.com",431],["chinafile.com",432],["chipsandcheese.com",433],["chosun.com",434],["christianitytoday.com",435],["sfexaminer.com",435],["sfweekly.com",435],["cio.com",436],["citybeat.com",437],["clashmusic.com",438],["cleaner.com",439],["cltampa.com",440],["cnbc.com",442],["cnbctv18.com",443],["cnbdaily.com",444],["cnet.com",445],["cnevpost.com",446],["cnnespanol.cnn.com",447],["cnn59.com",448],["coincodecap.com",449],["coinedition.com",451],["coingape.com",452],["coinspeaker.com",453],["cointelegraph.com",454],["colibriwp.com",455],["colourlovers.com",456],["colunadofla.com",[458,459,460]],["dailyboulder.com",[458,493,494,495]],["spillsomebeans.com",459],["comicxy.com",461],["complex.com",462],["computerhoy.com",463],["hobbyconsolas.com",463],["autobild.es",463],["businessinsider.es",463],["topgear.es",463],["computerworld.com",464],["cookieandkate.com",465],["cookingclassy.com",466],["coreight.com",467],["corrosionpedia.com",468],["idownloadblog.com",468],["thedrinksbusiness.com",468],["cosmopolitanturkiye.com",469],["harpersbazaar.com.tr",469],["samdan.com.tr",469],["cosmosmagazine.com",470],["forbes.com",470],["phillyvoice.com",[470,930]],["heise.de",470],["coxautoinc.com",472],["cricbuzz.com",474],["crooksandliars.com",476],["crosscut.com",477],["crosswalk.com",478],["news.crunchbase.com",480],["crypto-news-flash.com",481],["cryptonews.com",482],["cryptopolitan.com",483],["miragenews.com",484],["thecookscook.com",484],["lagaceta.com.ec",484],["mole24.it",484],["sampdoria.it",[484,1505]],["eff.org",484],["jurist.org",484],["vivercomsaude.site",484],["newhumanist.org.uk",484],["ewn.co.za",484],["cryptotvplus.com",485],["cyberark.com",486],["ohga.it",486],["cybernews.com",487],["cyclingnews.com",488],["livescience.com",488],["cyclingstage.com",489],["dagens.com",[490,491]],["jenkemmag.com",491],["masterduelmeta.com",[491,793]],["merriam-webster.com",491],["presstv.ir",491],["english.nv.ua",[491,1857]],["daily-sun.com",492],["echonewshub.com",[493,495,541]],["jugomobile.com",[493,495,541]],["thartribune.com",[493,495,541]],["thegamepost.com",493],["townflex.com",[493,541,1137]],["gmanetwork.com",[497,634]],["dansingerman.com",498],["fark.com",[498,584]],["thetvaddict.com",498],["radioguide.fm",[498,1338]],["rare.us",498],["darkreading.com",499],["datacenterdynamics.com",500],["davidlebovitz.com",501],["davinotti.com",502],["dayton247now.com",503],["defector.com",505],["defensacentral.com",506],["defenseone.com",507],["govexec.com",[507,645]],["nextgov.com",507],["demilked.com",508],["denofgeek.com",509],["depor.com",510],["destructoid.com",512],["devdiscourse.com",513],["dhakatribune.com",515],["diarimes.com",516],["diario16plus.com",[517,518]],["planetarealmadrid.com",517],["earthsky.org",[520,1707]],["digitaltrends.com",521],["digitimes.com",522],["dinamani.com",523],["samakalikamalayalam.com",523],["dinneratthezoo.com",524],["directoalpaladar.com",525],["poprosa.com",525],["trendencias.com",525],["decoracion.trendencias.com",525],["dissapore.com",526],["dnaindia.com",527],["donnamoderna.com",528],["rockstarintel.com",530],["draxe.com",531],["dw.com",532],["dxomark.com",533],["dz-privatbank.com",534],["ea.com",535],["eadaily.com",536],["earth.com",537],["eatwell101.com",538],["ebaumsworld.com",539],["ebookrenta.com",540],["airlive.net",[541,1574]],["econotimes.com",543],["ecowatch.com",544],["editorji.com",546],["egotastic.com",548],["egotasticsports.com",548],["elcolombiano.com",549],["elespanol.com",550],["elespectador.com",551],["elmogaz.com",552],["elpais.com",554],["elsate.com",557],["eltiempo.com",[558,559]],["expreso.ec",559],["heraldo.es",559],["emol.com",560],["eporner.com",561],["equinix.com",562],["estadiodeportivo.com",563],["blog.esuteru.com",564],["eteknix.com",565],["ethostimes.com",566],["etusuora.com",567],["euractiv.com",568],["euronews.com",569],["euroweeklynews.com",571],["thisisfutbol.com",571],["videocelts.com",571],["evinfocus.com",572],["exame.com",573],["exchange4media.com",574],["exmoo.com",575],["f1i.com",577],["factinate.com",578],["factkeepers.com",579],["faithwire.com",580],["rtvs.sk",[580,1821]],["fandom.com",581],["fangoria.com",583],["tuttocampo.it",584],["fastcompanybrasil.com",585],["favpng.com",586],["federalnewsnetwork.com",587],["fellahe.com",588],["fia.com",589],["fifa.com",590],["financemagnates.com",591],["financialexpress.com",592],["porngals4.com",593],["mediaset.it",[593,1224,1481]],["teleborsa.it",593],["tempostretto.it",593],["borse.it",594],["findingtheuniverse.com",595],["fiorentinanews.com",596],["fiorentinauno.com",596],["tuttosporttaranto.com",596],["blunote.it",[596,1432]],["brindisimagazine.it",596],["monza-news.it",596],["pianetalecce.it",596],["salernogranata.it",596],["firstpost.com",597],["fleischmannsyeast.com",598],["frasicelebri.it",599],["flyingmag.com",600],["foodnetwork.com",602],["foodsforbetterhealth.com",603],["footwearnews.com",604],["indiewire.com",604],["foozine.com",605],["forexlive.com",606],["forklog.com",607],["freebeacon.com",610],["bygg.no",610],["freegameplanet.com",611],["frommybowl.com",612],["frostfairs.com",613],["fujitsu.com",615],["fxstreet.com",617],["gagadget.com",619],["gamekult.com",620],["gameloop.com",621],["guides.gamepressure.com",622],["gametyrant.com",623],["gasteizhoy.com",625],["gatewayhispanic.com",626],["gazetaweb.com",627],["geekdashboard.com",628],["geekflare.com",629],["getpocket.com",631],["midad.com",631],["gfinityesports.com",632],["stealthoptional.com",632],["glassrpske.com",633],["gnttv.com",[635,636]],["aajtak.in",[635,1397]],["goal.com",637],["gobankingrates.com",638],["goingawesomeplaces.com",639],["gomag.com",[640,641]],["goodmenproject.com",642],["goodyfeed.com",643],["gothamist.com",644],["gpblog.com",646],["bright.nl",646],["voetbalnieuws.nl",646],["voetbalprimeur.nl",646],["grammarly.com",647],["grandhotelcalciomercato.com",648],["greatnorthernrail.com",649],["southernrailway.com",649],["greenbot.com",650],["greenbuildingadvisor.com",651],["groceryoutlet.com",652],["grubstreet.com",653],["gujaratsamacharepaper.com",654],["epaperlokmat.in",654],["gulte.com",655],["gwaramedia.com",656],["marqueesportsnetwork.com",656],["accessnow.org",656],["haaretz.com",657],["haberler.com",658],["hackread.com",659],["hakone-japan.com",661],["handelsblatt.com",662],["businesstech.co.za",[664,1363,1893]],["mybroadband.co.za",664],["hankooktire.com",665],["jiji.com",665],["joins.com",665],["op.gg",665],["bestcarweb.jp",665],["videor.co.jp",665],["biglobe.ne.jp",665],["theinvestor.co.kr",665],["fhm.com.ph",665],["harvardmagazine.com",667],["hawaiitribune-herald.com",668],["healthline.com",669],["helpnetsecurity.com",671],["highxtar.com",673],["auto.hindustantimes.com",675],["tech.hindustantimes.com",676],["hola.com",[678,679]],["aces.illinois.edu",678],["holyrood.com",681],["rpgfan.com",[681,983]],["homecookingadventure.com",682],["honesttopaws.com",683],["hoorayteams.com",684],["hornoxe.com",685],["hot-dinners.com",686],["hp.com",687],["hsbc.com",688],["project-syndicate.org",688],["hugolescargot.com",689],["ibctamil.com",690],["idlprocycling.com",691],["indeleiderstrui.nl",691],["twenteinsite.nl",[691,1657]],["ifeng.com",692],["iflscience.com",693],["ilbianconero.com",695],["ilsole24ore.com",696],["24plus.ilsole24ore.com",697],["imagecollect.com",698],["imgflip.com",699],["inc42.com",700],["indiabusinessjournal.com",701],["indianexpress.com",702],["infobae.com",703],["infobyip.com",704],["infoq.com",705],["civil.ge",706],["inlandvalleynews.com",707],["inquisitr.com",708],["insidebitcoins.com",709],["insideevs.com",710],["insider-gaming.com",712],["invenglobal.com",713],["just-food.com",[714,732]],["invisibleoranges.com",716],["inyminy.com",717],["iranwire.com",718],["israelnationalnews.com",721],["itnwwe.com",722],["itprotoday.com",723],["news.itsfoss.com",724],["jasonwatmore.com",726],["jetphotos.com",727],["videocardz.com",[728,1178]],["jornalrazao.com",730],["jpost.com",731],["kakakumag.com",733],["karanpc.com",734],["it-daily.net",734],["cybermap.kaspersky.com",735],["kathmandupost.com",736],["khaleejtimes.com",737],["kharphonk.com",738],["khmertimeskh.com",739],["khutabaa.com",740],["kick.com",741],["kivitv.com",742],["knowyourmeme.com",743],["kob.com",744],["koimoi.com",745],["koreaboo.com",746],["kslnewsradio.com",748],["structurae.net",748],["kyivindependent.com",749],["la-croix.com",751],["la-razon.com",752],["labrujulaverde.com",753],["marriott.com",754],["sandiegouniontribune.com",754],["lawandcrime.com",755],["leagle.com",756],["ledojomanga.com",757],["leganerd.com",758],["lesnumeriques.com",759],["levernews.com",760],["overkill.wtf",760],["lgbtqnation.com",761],["lifehacker.com",762],["lifesitenews.com",763],["lifestyleasia.com",764],["revolver.news",765],["limesonline.com",767],["embed.listcorp.com",768],["listenmoneymatters.com",769],["listindiario.com",[770,771]],["segre.com",770],["huffingtonpost.es",770],["lithub.com",[772,773]],["hdblog.it",[772,1155]],["livecoinwatch.com",774],["locals.com",775],["locksmithledger.com",776],["lonelyplanet.com",778],["los40.com",779],["loveandlemons.com",780],["lwlies.com",781],["macrumors.com",782],["madagascar-tribune.com",783],["madamasr.com",784],["madinamerica.com",785],["maketecheasier.com",786],["manhwatop.com",788],["manofmany.com",789],["manutd.com",790],["maps4heroes.com",791],["marktechpost.com",792],["stuffparentsneed.com",[792,1040]],["elements.visualcapitalist.com",792],["podwatch.io",792],["mdzol.com",795],["medcitynews.com",796],["foodandwaterwatch.org",796],["publicbooks.org",[796,1742]],["medcraveonline.com",797],["mediaite.com",798],["mediapost.com",799],["medicalxpress.com",800],["megashare.com",801],["meiobit.com",802],["pix-geeks.com",804],["trustedreviews.com",[804,1149]],["woodworkforinventor.com",804],["audi-sport.net",[804,1578]],["eurogamer.net",804],["meteofrance.com",806],["methodshop.com",807],["metropoles.com",808],["michaelmedved.com",809],["guide.michelin.com",810],["support.microsoft.com",811],["mid-day.com",812],["midasbuy.com",813],["middleeastmonitor.com",814],["milanuncios.com",815],["military.com",817],["mingpao.com",818],["miningweekly.com",819],["engineeringnews.co.za",819],["polity.org.za",819],["mintpressnews.com",820],["online-tech-tips.com",820],["mlbtraderumors.com",821],["mmorpg.com",823],["mobilemarketingreads.com",824],["mondediplo.com",[825,826]],["orientxxi.info",826],["moneycontrol.com",827],["morningstar.com",828],["moroccoworldnews.com",829],["motortrend.com",830],["mouthshut.com",831],["movehub.com",832],["moviemistakes.com",834],["mp1st.com",835],["msn.com",836],["muscleandfitness.com",837],["music-news.com",838],["theatre-news.com",838],["film-news.co.uk",838],["game-news.co.uk",838],["mydorpie.com",839],["mymotherlode.com",841],["namnak.com",842],["napolimagazine.com",843],["nashvillescene.com",844],["nationalheraldindia.com",845],["nationalreview.com",846],["nationaltoday.com",847],["naturalnews.com",848],["nature.com",849],["naval-technology.com",850],["nbcnews.com",851],["ncaa.com",852],["sports.ndtv.com",853],["neatorama.com",854],["nerdist.com",855],["nerdnomads.com",856],["stationx.net",856],["newatlas.com",857],["newindianexpress.com",858],["newsgram.com",858],["newmobility.com",859],["newnoisemagazine.com",860],["newrepublic.com",[861,862]],["thetech.com",861],["news9live.com",864],["newsandguts.com",865],["newscientist.com",866],["newsday.com",867],["newser.com",868],["newskarnataka.com",[869,870,871]],["knowablemagazine.org",[870,1725]],["psypost.org",871],["newsonjapan.com",872],["newsshooter.com",873],["nezavisne.com",874],["nfl.com",875],["nhl.com",[876,877]],["petri.com",876],["nintendoworldreport.com",878],["nj.com",879],["nl7za.com",880],["nme.com",881],["operawire.com",[881,910]],["nordvpn.com",882],["northpennnow.com",883],["notalwaysright.com",884],["noticiasrcn.com",887],["notquitenigella.com",888],["novalaplata.com",890],["nowness.com",891],["nowtoronto.com",892],["nrttv.com",893],["nscale.com",894],["nutraingredients.com",895],["nutraingredients-asia.com",895],["nutraingredients-latam.com",895],["nutraingredients-usa.com",895],["ny1.com",896],["nytimes.com",898],["odditycentral.com",899],["odessa-journal.com",900],["ofbez.com",901],["officialcharts.com",902],["ogbongeblog.com",903],["oilprice.com",904],["okgoals.com",905],["olympics.com",906],["oneindia.com",907],["onextrapixel.com",908],["openspeedtest.com",909],["opindia.com",911],["optimagazine.com",912],["oracle.com",913],["osxdaily.com",914],["otakumode.com",915],["otakuusamagazine.com",916],["outdoorlife.com",917],["popsci.com",[917,939]],["taskandpurpose.com",917],["thedrive.com",917],["twz.com",917],["outlookindia.com",[918,919]],["pgpf.org",919],["over-blog.com",920],["palais-de-la-voiture.com",922],["paloaltonetworks.com",923],["pastebin.com",924],["patch.com",925],["payloadspace.com",926],["peepingmoon.com",927],["perezhilton.com",928],["phoenixnewtimes.com",931],["photorumors.com",932],["picsart.com",933],["planetebd.com",934],["planetizen.com",935],["playbuzz.com",936],["politicalwire.com",937],["politico.com",938],["portalrapmais.com",941],["portoravennanews.com",942],["lacronacadiravenna.it",942],["livesicilia.it",[942,1476]],["sportoutdoor.tv",942],["prdaily.com",944],["proofpoint.com",945],["proprivacy.com",946],["protos.com",947],["punchdrink.com",948],["purewow.com",949],["qatarliving.com",950],["qoshe.com",951],["quebeccoupongratuit.com",952],["quipmag.com",953],["r7.com",954],["radioink.com",955],["railtech.com",956],["rappler.com",957],["raya.com",959],["realtor.com",962],["reason.com",963],["recipeland.com",965],["reforma.com",966],["relevantradio.com",967],["repsol.com",968],["reserveamerica.com",969],["blog.resy.com",970],["retbit.com",971],["reuters.com",972],["reviewjournal.com",973],["rivanimation.com",975],["rocketnews24.com",[976,977]],["thebeet.com",[976,1078]],["themusicuniverse.com",977],["previously.tv",977],["rogerebert.com",978],["romper.com",979],["rosphoto.com",980],["rpdrlatino.com",982],["ruwix.com",985],["sabcsport.com",986],["sacurrent.com",987],["snopes.com",989],["sammobile.com",990],["galaxystore.samsung.com",991],["sanarmed.com",992],["scribol.com",996],["searchenginejournal.com",998],["seattletimes.com",999],["secretchicago.com",[1000,1001]],["secretldn.com",1000],["securityweek.com",1002],["seibertron.com",1003],["semafor.com",1004],["semana.com",1005],["seohorsesense.com",1006],["sfbayca.com",1007],["sfgate.com",1008],["sfstandard.com",1010],["shbarcelona.com",1011],["sheknows.com",1012],["shopclues.com",1013],["siliconrepublic.com",1014],["silive.com",1015],["simplejoy.com",1016],["simplifylivelove.com",1017],["skeptoid.com",1018],["skidrowreloaded.com",1019],["texasmonthly.com",1020],["news.sky.com",[1021,1022]],["skysports.com",1021],["smashingmagazine.com",1023],["snowbrains.com",1024],["sonomamag.com",1025],["sorrisi.com",1026],["soundcloud.com",1027],["spiked-online.com",1028],["spokesman.com",1029],["sportitalia.com",1030],["fcinternews.it",1030],["lalaziosiamonoi.it",1030],["torinogranata.it",1030],["sportskeeda.com",1031],["stamen.com",1033],["startrek.com",1034],["straitstimes.com",1036],["straumann.com",1037],["streamingrant.com",1038],["studyshoot.com",1039],["stylecaster.com",1041],["sundaysuppermovement.com",1042],["sundayworld.com",1043],["tageblatt.de",1044],["elpais.com.uy",[1044,1888]],["superluchas.com",1045],["ta3.com",1046],["tableconvert.com",1047],["taiwebs.com",1048],["talkingpointsmemo.com",1049],["tampabay.com",1050],["tandfonline.com",1051],["targettrend.com",1052],["tastesbetterfromscratch.com",1054],["teamcoco.com",1055],["tomshardware.com",[1055,1130]],["techadvisor.com",1056],["techcrunch.com",1057],["techdirt.com",1058],["techfirstnow.com",1059],["techforbrains.com",1060],["techlila.com",1062],["technologyreview.com",1063],["techradar.com",1065],["techweekmag.com",1066],["tecmint.com",1068],["telegraphindia.com",1069],["telekom.com",1070],["tenable.com",1071],["tennis.com",1072],["testbook.com",1073],["theanalyst.com",1074],["theashleysrealityroundup.com",1075],["theatlantic.com",1076],["thebarentsobserver.com",1077],["rightwingwatch.org",1078],["thecinemaholic.com",1079],["thediplomat.com",1082],["thedirect.com",1083],["theenergymix.com",1084],["theepochtimes.com",1085],["thefader.com",1086],["thefastmode.com",1087],["thegatewaypundit.com",1089],["wersm.com",1089],["theglobeandmail.com",1090],["theguardian.com",1091],["thehackernews.com",1092],["theintercept.com",[1094,1095]],["journals.aps.org",1094],["thejewishstar.com",1097],["thekitchenmagpie.com",1098],["thelondoneconomic.com",1099],["thenation.com",1100],["thenationalnews.com",1101],["thenationalpulse.com",1102],["thenextweb.com",1103],["theobjective.com",1104],["theonion.com",1105],["thepopverse.com",1106],["therighthairstyles.com",1107],["theringer.com",1108],["thescore.com",1109],["thesfnews.com",1110],["thespectator.com",1111],["thesportingtribune.com",1112],["thetrekcollective.com",1113],["theurbanlist.com",1115],["theverge.com",[1116,1117]],["vox.com",1117],["thevision.com",1118],["theyucatantimes.com",1120],["tilestwra.com",1121],["timesnownews.com",1124],["recipes.timesofindia.com",1125],["tnmt.com",1127],["todayonline.com",1128],["tokyoweekender.com",1129],["revistalideres.ec",1131],["automobielmanagement.nl",1131],["topic.com",1132],["toptal.com",1133],["torrentsafe.com",1134],["toucharcade.com",1135],["touristspy.com",1136],["tracebit.com",1138],["travelandleisure.com",1139],["traveltriangle.com",1140],["triblive.com",1141],["trip101.com",1142],["trthaber.com",1144],["radiolodz.pl",[1146,1413]],["trumparea.com",1148],["truthdig.com",1150],["trutravels.com",1151],["tsunagujapan.com",1152],["ttgmedia.com",1153],["ttnews.com",1154],["crash.net",1154],["time.is",1155],["tv5monde.com",1157],["tvline.com",1158],["tweaktown.com",1159],["twitchy.com",1160],["ultraslan.com",1161],["umweltwirtschaft.com",1162],["coating-converting.de",1162],["unanimodeportes.com",1163],["united24media.com",1164],["universfreebox.com",1165],["upday.com",1167],["url-encode-decode.com",1168],["usatoday.com",1169],["usnews.com",1170],["zerohedge.com",1170],["valoraanalitik.com",1171],["veganblatt.com",1172],["vegrecipesofindia.com",1173],["venturebanc.com",1174],["vgleaks.com",1175],["fashionhistory.fitnyc.edu",1175],["victoriabuzz.com",1176],["videogameschronicle.com",1179],["vimeo.com",1180],["vnews.com",1182],["volexity.com",1183],["vozpopuli.com",1184],["vreme.com",1185],["wabetainfo.com",1186],["washingtonian.com",1187],["upinthesky.nl",1188],["waterstechnology.com",1189],["risk.net",1189],["waterworld.com",1190],["wdwmagic.com",1192],["weather.com",1193],["webfail.com",1194],["weisradio.com",1195],["welivesecurity.com",1196],["westword.com",1197],["whatcar.com",1198],["wholesomeyum.com",1199],["onlinelibrary.wiley.com",1200],["winnipegfreepress.com",1202],["wired.com",1204],["wnep.com",1205],["worldisraelnews.com",1206],["worldsoccertalk.com",1207],["wrif.com",1208],["wxyz.com",1209],["wyseguide.com",1210],["xbiz.com",1211],["xvideossexo.com",1212],["iolecal.it",1212],["finance.yahoo.com",1213],["yardbarker.com",1214],["ynetespanol.com",1215],["ynetnews.com",1216],["ynet.co.il",1216],["zerolives.com",1217],["zimbabwesituation.com",1218],["zmonline.com",1219],["flava.co.nz",1219],["hauraki.co.nz",1219],["mixonline.co.nz",1219],["thehits.co.nz",1219],["zycrypto.com",1220],["360.cymru",1221],["89.0rtl.de",1222],["adticket.de",1223],["adventskalender-gewinnspiele.de",1224],["weihnachtsmarkt-finder.de",1224],["all-in.de",1225],["allgaeuer-zeitung.de",1226],["b4bschwaben.de",1227],["bafoeg-rechner.de",1228],["studis-online.de",1228],["berliner-kurier.de",1229],["berliner-zeitung.de",1230],["blick.de",1231],["butenunbinnen.de",1232],["crypto-insiders.de",1233],["crypto-insiders.es",1233],["crypto-insiders.nl",1233],["derfinanzinvestor.de",1234],["esg-aktien.de",1234],["inv3st.de",1234],["kapitalerhoehungen.de",1234],["deutsche-startups.de",1235],["deutsche-wirtschafts-nachrichten.de",1236],["deutschland.de",1237],["dioezesanmuseum-rottenburg.de",1238],["dls-logistics.de",1239],["domradio.de",1240],["emtb-news.de",1242],["mtb-news.de",1242],["rennrad-news.de",1242],["evangelisch.de",1243],["evrejskaja-panorama.de",1244],["juedischerundschau.de",1244],["express.de",1245],["finanznachrichten.de",1246],["fnp.de",1247],["sport1.de",1247],["focus.de",1248],["freenet.de",1250],["gameswelt.de",1251],["giga.de",1252],["goldinvest.de",1253],["golem.de",1254],["publico.pt",1254],["hansa-online.de",1255],["haustec.de",1256],["herz-fuer-tiere.de",1257],["islamische-zeitung.de",1258],["jetzt.de",1259],["kicker.de",1260],["kress.de",1261],["kurier.de",1262],["laut.de",1263],["mein-schoener-garten.de",1264],["mindfactory.de",1265],["ndr.de",1267],["niederrhein-nachrichten.de",1268],["nn.de",1269],["nordbayern.de",1269],["onvista.de",1270],["paz.de",1271],["pcgameshardware.de",1272],["pferdekult.de",1273],["bdkj.info",[1273,1410]],["presseportal.de",1274],["redensarten-index.de",1275],["st-georg.de",1276],["t3n.de",1277],["teltarif.de",1278],["urbia.de",1279],["urlaubsguru.de",1280],["welt.de",1281],["citizen.digital",1282],["politikenhistorie.dk",1283],["acento.com.do",1284],["metroecuador.com.ec",1285],["colorado.edu",1286],["drexel.edu",1287],["getty.edu",1288],["thereader.mitpress.mit.edu",1289],["news.mit.edu",1290],["science.psu.edu",1291],["www.psu.edu",1292],["businesslawreview.uchicago.edu",1293],["newsroom.ucla.edu",1294],["today.usc.edu",1295],["utexas.edu",1296],["vt.edu",1297],["cope.es",1298],["nurse24.it",1298],["cuencanews.es",1300],["elmundo.es",1301],["neomotor.epe.es",1302],["iblogmovil.es",1304],["servimedia.es",1306],["agendadigitale.eu",1309],["economyup.it",1309],["bandaancha.eu",1310],["fidelityhouse.eu",1311],["labiotech.eu",1313],["noyb.eu",1314],["testvelocidad.eu",1315],["topbet.eu",1316],["npr.org",1316],["thefinance.sg",[1316,1818]],["tusciaweb.eu",1317],["tvrus.eu",1318],["zona.eu",1319],["eitb.eus",1320],["apotti.fi",1321],["dawn.fi",1322],["demokraatti.fi",1323],["forssanlehti.fi",1324],["ku.fi",1325],["mediuutiset.fi",1326],["mikrobitti.fi",1327],["mobiili.fi",1328],["rakennusmaailma.fi",1329],["rakentaja.fi",1330],["seura.fi",1331],["tekniikkatalous.fi",1332],["tivi.fi",1333],["voice.fi",1334],["gamestorrents.fm",1335],["giornaleradio.fm",1336],["lizhi.fm",1337],["autoplus.fr",1339],["trendy.letudiant.fr",1339],["boursedirect.fr",1340],["francebleu.fr",1341],["homap.fr",1343],["justgeek.fr",1344],["lefigaro.fr",1345],["liberation.fr",1346],["moneyvox.fr",1347],["radiofrance.fr",1348],["tomshardware.fr",1351],["giocodigitale.game",1352],["1337.games",1353],["tuttotek.it",1353],["intermedia.ge",1354],["interpressnews.ge",1355],["kvirispalitra.ge",1356],["lelo.ge",1357],["netgazeti.ge",1358],["lootlabs.gg",1359],["pulse.com.gh",1360],["pulse.ng",1360],["commerce.gov",1361],["consumerfinance.gov",1362],["discover.lanl.gov",1363],["newscenter.lbl.gov",1364],["niaid.nih.gov",1365],["pmc.ncbi.nlm.nih.gov",1366],["nist.gov",1367],["capital.gr",1369],["enternity.gr",1370],["takungpao.com.hk",1371],["express.24sata.hr",1372],["gloria.hr",1373],["hkm.hr",1374],["hrt.hr",1375],["jutarnji.hr",1376],["slobodnadalmacija.hr",1377],["index.hu",1379],["totalcar.hu",1379],["velvet.hu",1379],["life.hu",1380],["origo.hu",1380],["travelo.hu",[1380,1381]],["mediamarkt.hu",1382],["szeretlekmagyarorszag.hu",1384],["telex.hu",[1385,1386]],["transtelex.ro",1386],["tv2.hu",1387],["vg.hu",1388],["breakingnews.ie",1389],["businessplus.ie",1390],["businesspost.ie",1391],["rte.ie",1392],["thejournal.ie",1393],["7kanal.co.il",1394],["inn.co.il",1394],["focusjunior.it",[1394,1448]],["glz.co.il",1395],["mekomit.co.il",1396],["bridestoday.in",1398],["businessinsider.in",1399],["cosmopolitan.in",1402],["digit.in",1403],["goodreturns.in",1404],["lionexpress.in",1406],["newsclick.in",1407],["overdrive.in",1408],["web3cafe.in",1409],["jota.info",1411],["labusa.info",1412],["urbantv.info",1414],["visionguinee.info",1415],["builder.io",1416],["blog.logto.io",1417],["mpost.io",1418],["thenewstack.io",1419],["alalam.ir",1420],["ad-italia.it",1421],["gqitalia.it",1421],["lacucinaitaliana.it",1421],["vanityfair.it",1421],["vogue.it",1421],["www.wired.it",1421],["agensir.it",1422],["agi.it",1423],["agimeg.it",1424],["altamuralife.it",1425],["andriaviva.it",1425],["bariviva.it",1425],["barlettaviva.it",1425],["bisceglieviva.it",1425],["bitontoviva.it",1425],["canosaviva.it",1425],["cerignolaviva.it",1425],["coratoviva.it",1425],["giovinazzoviva.it",1425],["gravinalife.it",1425],["margheritaviva.it",1425],["materalife.it",1425],["minervinoviva.it",1425],["modugnoviva.it",1425],["molfettaviva.it",1425],["ruvoviva.it",1425],["sanferdinandoviva.it",1425],["spinazzolaviva.it",1425],["terlizziviva.it",1425],["traniviva.it",1425],["trinitapoliviva.it",1425],["bancadipiacenza.it",1428],["biografieonline.it",1430],["blitztv.it",1431],["calcionapoli24.it",1433],["ccsnews.it",1434],["clubalfa.it",1434],["centrometeoitaliano.it",[1435,1436]],["leggo.it",1435],["cirio.it",1437],["corrieredellumbria.it",1439],["corrierediarezzo.it",1439],["corrieredimaremma.it",1439],["corrieredisiena.it",1439],["cronacheancona.it",1440],["deejay.it",1441],["dissipatio.it",1442],["dueruote.it",1443],["everyeye.it",1444],["fanpage.it",1445],["focus.it",1447],["gamershqitalia.it",1449],["teletutto.it",1450],["giornali.it",1451],["greenstyle.it",1452],["ilfattoalimentare.it",1453],["ilfattoquotidiano.it",1454],["ilgiorno.it",1455],["ilrestodelcarlino.it",1455],["iltelegrafolivorno.it",1455],["lanazione.it",1455],["quotidiano.net",1455],["internazionale.it",1457],["iodonna.it",1458],["jeanlouisdavid.it",1460],["la7.it",1461],["tg.la7.it",1462],["lacapitale.it",1463],["lapancalera.it",1464],["lapresse.it",[1465,1466]],["lapresse.us",1466],["laroma24.it",1467],["lemillericette.it",1468],["lescienze.it",1469],["lespresso.it",1470],["libero.it",[1471,1472]],["virgilio.it",[1471,1524]],["lintellettualedissidente.it",1475],["rtsplaneta.rs",1475],["perizona.it",1476],["mag1861.it",1477],["malpensanews.it",1478],["maremmanews.it",[1479,1480]],["fintech.tv",[1479,1841]],["meteogiuliacci.it",1482],["mezzicommerciali.it",1483],["milanodabere.it",1484],["money.it",1485],["mrw.it",1486],["mymovies.it",1487],["newsrimini.it",1488],["nordest24.it",1489],["orvieto24.it",1490],["ostuninews.it",1491],["primapaginanews.it",1492],["quattroruote.it",1493],["tv.quattroruote.it",1494],["quotidianopiemontese.it",1495],["radioinblu.it",1496],["play.radionorba.it",1497],["radiosubasio.it",1498],["rainews.it",1499],["raiplaysound.it",1501],["ricetta.it",1502],["robadadonne.it",1503],["roccosiffredixxx.it",1504],["scacchierando.it",1506],["showprice.it",1508],["spaziogames.it",1509],["stabiachannel.it",1511],["staseraincucina.it",1512],["stol.it",1513],["superguidatv.it",1514],["theitaliantimes.it",1515],["thewom.it",1516],["toplegal.it",1517],["torinomagazine.it",1518],["udinese.it",1519],["unionesarda.it",1520],["valsusaoggi.it",1522],["veritaeaffari.it",1523],["wikihow.it",1525],["zett.it",1526],["amazon.jobs",1527],["biz-journal.jp",1528],["buyee.jp",1529],["arigatojapan.co.jp",1530],["diners.co.jp",1531],["news.j-wave.co.jp",1532],["kyodo.co.jp",1533],["ntv.co.jp",1534],["oricon.co.jp",1535],["tokyo-np.co.jp",1536],["zaikei.co.jp",1537],["join.commufa.jp",1538],["gizmodo.jp",1539],["roomie.jp",1539],["japan.go.jp",1540],["jstage.jst.go.jp",1541],["iphone-mania.jp",1542],["knivesout.jp",1543],["lab.re-katsu.jp",1545],["srad.jp",1546],["suumo.jp",1547],["tjapan.jp",1548],["vippers.jp",1549],["ntvkenya.co.ke",1550],["auction.co.kr",1551],["koreatimes.co.kr",1552],["caravan.kz",1553],["dot.la",1554],["tonica.la",[1555,1556]],["show.news",1556],["playforukraine.life",1557],["playforukraine.live",1557],["discord.me",1558],["lubuntu.me",1559],["rgshows.me",1560],["storm.mg",1561],["shkspr.mobi",1562],["businessinsider.mx",1564],["de10.com.mx",[1565,1566]],["elgrafico.mx",1565],["excelsior.com.mx",1568],["economiahoy.mx",1569],["nupcias.mx",1570],["lelong.com.my",1571],["1000logos.net",1572],["adslzone.net",1573],["alekhbariya.net",1576],["sadisflix.vip",1576],["analyticsinsight.net",1577],["bravotube.net",1579],["butwhytho.net",1580],["cepr.net",1581],["edugeek.net",1582],["electronicintifada.net",1583],["ettoday.net",1584],["f1network.net",1585],["rugbynetwork.net",1585],["thefootballnetwork.net",1585],["cricketnetwork.co.uk",1585],["finanzfrage.net",1586],["gutefrage.net",1586],["firstshowing.net",1587],["geotastic.net",1588],["ghacks.net",1589],["gmx.net",1590],["gptoday.net",1591],["hard-drive.net",1592],["hcb.net",1593],["henaojara.net",1594],["hexus.net",1595],["horizont.net",1596],["informationisbeautiful.net",1598],["inspiredtaste.net",1599],["jam-news.net",1600],["kingmodapk.net",1601],["mangaforever.net",1603],["megaup.net",1604],["messengernews.net",[1605,1606]],["salemnews.net",1605],["middleeasteye.net",1607],["noisypixel.net",1610],["noticierovenevision.net",1611],["nova-magazine.net",1612],["opendemocracy.net",1613],["rockmods.net",1614],["ronorp.net",1615],["skuola.net",1616],["steamverde.net",1617],["tecnoblog.net",1618],["telesurtv.net",1619],["thehardtimes.net",1620],["headlight.news",1623],["computable.nl",1630],["ditjesendatjes.nl",1631],["dutchnews.nl",1632],["emerce.nl",1633],["fanclubbarcelona.nl",1634],["geenstijl.nl",1635],["gooieneemlander.nl",1636],["haarlemsdagblad.nl",1636],["leidschdagblad.nl",1636],["noordhollandsdagblad.nl",1636],["hartvannederland.nl",1637],["headliner.nl",1638],["heracles.nl",1639],["hrpraktijk.nl",1640],["israeltoday.nl",1641],["kn.nl",1642],["looopings.nl",1643],["micazu.nl",1644],["nd.nl",1645],["nhnieuws.nl",1646],["nltimes.nl",1647],["omroepbrabant.nl",1649],["omroepflevoland.nl",1650],["oogtv.nl",1651],["participaties.nl",1652],["pu.nl",1653],["smulderstextiel.nl",1655],["twentefans.nl",1656],["vi.nl",1658],["yachtonline.nl",1659],["zeelandnet.nl",1660],["zorgkrant.nl",1661],["altinget.no",1662],["klartale.no",1663],["nrk.no",1664],["tu.no",1666],["land.nrw",1667],["thecity.nyc",1668],["1news.co.nz",1669],["livenation.co.nz",1670],["newshub.co.nz",1671],["newsroom.co.nz",1672],["newstalkzb.co.nz",1673],["niwa.co.nz",1674],["odt.co.nz",1675],["scoop.co.nz",1676],["teaonews.co.nz",1678],["thespinoff.co.nz",1679],["newsline.ccc.govt.nz",1680],["wellington.govt.nz",1681],["omannews.gov.om",1682],["19thnews.org",1683],["adblockplus.org",1684],["agsiw.org",1685],["aleteia.org",1686],["americanscientist.org",1687],["apa.org",1688],["aporrea.org",1689],["physics.aps.org",1690],["archaeology.org",1691],["atlanticcouncil.org",1692],["avaaz.org",1693],["blockclubchicago.org",1694],["brennancenter.org",1695],["dictionary.cambridge.org",1696],["cartercenter.org",1697],["catholicculture.org",1698],["citizensforethics.org",1699],["city-journal.org",1700],["health.clevelandclinic.org",1701],["coinpedia.org",1702],["consumerreports.org",1703],["cpr.org",1704],["digitalcontentnext.org",1706],["endocrine.org",1708],["facethefactsusa.org",1709],["fas.org",1710],["federprivacy.org",1711],["freesvg.org",1712],["getcomics.org",1714],["haymarketbooks.org",1716],["heart.org",1717],["houstonpublicmedia.org",1718],["icann.org",1719],["inforesist.org",1720],["iotsrg.org",1722],["isglobal.org",1723],["daily.jstor.org",1724],["kpbs.org",1726],["kqed.org",1727],["lawfaremedia.org",1728],["marketplace.org",1729],["mprnews.org",1730],["nawaat.org",1731],["newsbusters.org",1732],["nhm.org",1733],["onegreenplanet.org",1734],["ourworldindata.org",1735],["philosophynow.org",1737],["plantbasednews.org",1738],["poynter.org",1739],["prlog.org",1740],["publicradiotulsa.org",1743],["quechoisir.org",1744],["radiopaedia.org",1745],["rfa.org",1746],["richmondfed.org",1747],["schrijvenonline.org",1748],["science.org",1749],["sciencenews.org",1750],["sordum.org",1752],["studyfinds.org",1753],["technology.org",1754],["thedebrief.org",1755],["themedialine.org",1757],["thenewhumanitarian.org",1758],["theworld.org",1759],["undark.org",1760],["news.usni.org",1761],["usrtk.org",1762],["whowhatwhy.org",1763],["worldathletics.org",1765],["elcomercio.pe",1766],["rpp.pe",1767],["wapa.pe",1768],["forbes.pl",1771],["gazetawroclawska.pl",1772],["motocombo.pl",1773],["mpolska24.pl",1774],["alaqsavoice.ps",1775],["wafa.ps",1777],["vaticannews.va",1778],["cmjornal.pt",1779],["diarioaveiro.pt",1780],["diariocoimbra.pt",1780],["diarioleiria.pt",1780],["diarioviseu.pt",1780],["dinheirovivo.pt",1781],["tsf.pt",1781],["dnoticias.pt",1782],["expresso.pt",1783],["maisfutebol.iol.pt",1785],["tvi.iol.pt",1786],["jn.pt",1787],["jornaldenegocios.pt",1788],["record.pt",1789],["sapo.pt",1790],["megahits.sapo.pt",1791],["rr.sapo.pt",1792],["opto.sic.pt",1793],["sicnoticias.pt",1794],["abc.com.py",1795],["qatarradio.qa",1796],["tmo.report",1797],["alo.rs",1798],["blic.rs",1798],["republika.rs",[1798,1802]],["tanjug.rs",1798],["happytv.rs",1800],["realestate-magazine.rs",1801],["rtv.rs",1803],["5-tv.ru",1805],["academic.ru",1806],["aif.ru",1807],["aimp.ru",1808],["interfax.ru",1810],["latuaitalia.ru",1811],["rg.ru",1812],["sibnet.ru",1814],["9anime.se",1815],["apoia.se",1816],["nms.si",1819],["vizita.si",1820],["sme.sk",1822],["teraz.sk",1823],["vidasana.sv",1824],["dropbox.tech",1825],["rtde.tech",1826],["tunisiatv.tn",1828],["watania1.tn",1828],["dev.to",1829],["netcine.to",1830],["yourdailypornmovies.ws",1830],["aa.com.tr",1832],["ahaber.com.tr",1833],["aspor.com.tr",1833],["cumhuriyet.com.tr",1834],["atletica.tv",1837],["canalnet.tv",1838],["diyanet.tv",1839],["war.ukraine.ua",1841],["fism.tv",1842],["grozny.tv",1843],["gtrk.tv",1844],["loewe.tv",1846],["montagna.tv",1847],["motorsport.tv",1848],["redice.tv",1849],["news.stv.tv",1851],["thepeoplesvoice.tv",1852],["eurointegration.com.ua",1854],["forklog.com.ua",1855],["pravda.com.ua",1856],["unn.ua",1858],["cardiff.ac.uk",1859],["bbc.co.uk",1860],["cryptodaily.co.uk",1861],["independent.co.uk",1864],["inews.co.uk",1865],["kentonline.co.uk",1866],["mirror.co.uk",1868],["newsnow.co.uk",1869],["omgubuntu.co.uk",1870],["spectator.co.uk",1872],["the-tls.co.uk",1873],["theneweuropean.co.uk",1874],["thetablet.co.uk",1875],["walesonline.co.uk",1877],["christian.org.uk",1878],["libdems.org.uk",1879],["map.org.uk",1880],["spring.org.uk",1881],["cityoflondon.police.uk",1882],["dontorrent.uno",1883],["hnn.us",1884],["thescoop.us",1886],["laprensalara.com.ve",1889],["baoquocte.vn",1890],["reasonstobecheerful.world",1892],["citizen.co.za",1894],["junkmail.co.za",1895],["leisurewheels.co.za",1896],["mg.co.za",1897],["onedayonly.co.za",1898],["sundayworld.co.za",1899],["topauto.co.za",1900]]);

const entitiesMap = new Map([["royalqueenseeds",0]]);

const exceptionsMap = new Map(undefined);

self.specificImports = self.specificImports || [];
self.specificImports.push({ argsList, hostnamesMap, entitiesMap, exceptionsMap });

/******************************************************************************/

})();

/******************************************************************************/
