/*******************************************************************************

    uBlock Origin Lite - a comprehensive, MV3-compliant content blocker
    Copyright (C) 2019-present Raymond Hill

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see {http://www.gnu.org/licenses/}.

    Home: https://github.com/gorhill/uBlock
*/

/* jshint esversion:11 */

'use strict';

// ruleset: deu-0

/******************************************************************************/

// Important!
// Isolate from global scope
(function uBOL_cssSpecificImports() {

/******************************************************************************/

const argsList = ["iframe[style*=\"z-index: 2147483647\"]","#superbanner",".cadbox,\n.reifen-winter",".container-billboard",".partner",".fusion-builder-row-14",".Ad","#banner5",".frame-type-mask_toolboxcontentad1",".ipsWidget:has(.sidebar-partner),\n.ipsWidget:has(.sidebar-partner-links)",".atla-place,\n.index-bns",".aawp",".cl-billboad-wrapper,\n.osa-as24-placeholder","#topleft",".td-header-rec-wrap",".tdi_59",".slick-track","div[class^=\"id-TBeepSlot\"]",".ad","#dabplusshop","#banner-container",".banner-place,\n.banner-top","#custom_html-27,\n#nerdic_header",".ressort_ad",".stream-item-top-wrapper","#djslider-loader227,\n#djslider-loader229",".bannerWrapper","#anzeigenkenzz","div[id^=\"sas_\"]",".banner","img[width=\"300\"]",".default-teaser--ads-teaser",".adContainer","#carousel","#gkf-adslot-header","div[data-ad-position]",".asyncBanner",".news_sponsoren_banner",".flex.justify-center.mx-auto.hidden.lg\\:flex.lg\\:mb-4.lg\\:pb-4","#billboard-location,\n#slot_middle,\n#slot_middle_2,\n.advertisement_widget","#footer-widgets","#media_image-4","#media_image-5,\n#media_image-6,\n#media_image-7,\n#media_image-8,\n#media_image-9",".bx-viewport",".dfmhtmlbanner,\n.widget-5,\n.widget-7",".block.medium:has(a[href^=\"https://dt.sportradar.com/\"]),\n.tag-presented",".alert,\n.media,\n.medrec,\na[href^=\"https://de.johnnybet.com/\"]",".billboard",".skyscraper",".ofni","div[data-test=\"mms-product-card\"]:has(div[data-test=\"mms-plp-sponsored\"])",".article-list-item.article-card.article-card-default:has(.commercial-tag)","#outbrain_container",".bannergroup","#TopRectangle","#leader_top_desk",".elementor-element-dc42ab9",".marketingTeaserBanner",".advertising",".app-foesvAdSpace,\n.footer_partner",".g",".bannerfullbanner,\ndiv[id^=\"prost-\"]",".fullbanner-wrapper",".topASp",".c-image--center",".leaderboard-wrapper",".partner_section",".adv-link","div[id^=\"sempr-\"]",".tnemesitrevda",".end-to-end-banner",".tdi_50","#Leaderboard_1_Superbanner_1_Billboard_1_Top_,\n#upsellerSidebar",".sponsored",".csc-partner",".norm-rsp-wbox1",".ads","#div-bigsizebanner_1",".main-sponsorlogo",".laendleimmo","div[data-div-ratios=\"default:300_250\"],\ndiv[data-div-ratios=\"default:696_280|500:300_250\"],\ndiv[style=\"width:100%; height:600px;\"]","#c17,\n.ad1,\n.ad2,\n.ad3",".banner-aspect-ratio","table[width=\"306\"]",".adbox",".box.contentBoard.default.highlights","#sponsor-info","#topcontainer","#custom_html-2","#hab-right,\n#hab-top","#newupcoming","a[href^=\"https://www.amazon.\"][href*=\"tag=\"]","#apn-large-content-ad,\n#apn-large-leaderboard,\n#apn-large-skyscraper,\n#apn-leaderboard,\n.apn-leaderboard-wrapper","div[id^=\"woche-\"]","div[id^=\"yeniv-\"]","#media_image-3",".c-image--left",".pr-area",".footer-dingens","#ad_global_below_navbar","a[href=\"https://tinyurl.com/\"]",".stj-sidebar-widget,\n.theme-carousel-partners",".bodShopWidget","#tab-1 p:nth-of-type(1), #tab-1 p:nth-of-type(2), #tab-1 p:nth-of-type(3), #tab-1 p:nth-of-type(4),\n.vpn_btn,\n[onclick^=\"window.location.href='/azn/\"],\na[href*=\"/azn/\"] > img,\nbutton[onclick*=\"/af.php\"]","#text-3","a[href*=\"/out/\"]","img[width=\"468\"]",".banner-header-left,\n.banner-header-right,\n.normal-banner",".links,\n.wideboard-cad","div[class^=\"ContentPage_insideFullTopPlaceholder_\"]","div[id^=\"ad_prime_\"],\ndiv[id^=\"ausland__inside-\"],\ndiv[id^=\"basel__inside-\"],\ndiv[id^=\"bern__inside-\"],\ndiv[id^=\"community__inside-\"],\ndiv[id^=\"coronavirus__inside-\"],\ndiv[id^=\"digital__inside-\"],\ndiv[id^=\"influencer-radar__inside-\"],\ndiv[id^=\"kinostreaming__inside-\"],\ndiv[id^=\"kochen__inside-\"],\ndiv[id^=\"lifestyle_autoundmobilitaet__inside-\"],\ndiv[id^=\"lifestyle_beauty__inside-\"],\ndiv[id^=\"lifestyle_bodyandsoul__inside-\"],\ndiv[id^=\"lifestyle_eatanddrink__inside-\"],\ndiv[id^=\"lifestyle_fashion__inside-\"],\ndiv[id^=\"lifestyle_living__inside-\"],\ndiv[id^=\"lifestyle_reduceandreuse__inside-\"],\ndiv[id^=\"lifestyle_reisen__inside-\"],\ndiv[id^=\"lifestyle_wein__inside-\"],\ndiv[id^=\"my-news-plus__inside-\"],\ndiv[id^=\"onelove__inside-\"],\ndiv[id^=\"ostschweiz__inside-\"],\ndiv[id^=\"people__inside-\"],\ndiv[id^=\"people_radio__inside-\"],\ndiv[id^=\"prime__inside-\"],\ndiv[id^=\"schweiz__inside-\"],\ndiv[id^=\"sport__inside-\"],\ndiv[id^=\"wettbewerbe__inside-\"],\ndiv[id^=\"wirtschaft__inside-\"],\ndiv[id^=\"wissen__inside-\"],\ndiv[id^=\"zentralschweiz__inside-\"],\ndiv[id^=\"zuerich__inside-\"]","a[href^=\"https://3fach.ch/track/\"]","#WelcomeBannerDiv,\n.p-banners-withborder",".mod_printanzeigen",".carousel",".sponsor","div[id^=\"adnz_\"]",".contest-frame",".anriss-item-advert,\ndiv:has(> .advert)",".werbepartner","#text-24","#text-28","#text-29","#text-31","#text-32",".appnexus-container,\n.brandstudio,\n.placement-leaderboard,\n.placement-rectangle,\na[href^=\"https://jackpot.onelink.me/\"]",".ads-group,\n.daydeal-container",".widget_metaslider_widget","#partner-teaser-links,\n.adm-container",".bannerListPremium",".bannerListPremiumTop","#partner",".mega-banner-outer","#text-4","a[href^=\"https://goo.gl/\"]","div[class^=\"PageLayout_topaddesktop_\"]","#aditems,\n.aditem",".inner",".banner-leadboard,\n.partner-logos",".partners",".sidebar-sponsor-outlay",".sponsor--margin",".advertisement",".big_size,\n.page-layout__ad-header-bottom,\na[href^=\"https://fra1-ib.adnxs.com/\"],\nimg[alt=\"vontobel-banner\"]","div[class^=\"page-layout__ad-\"]",".fn-edp-section__slider","div[style^=\"width:300px;\"]","#section-sponsored-blogs","#rv_sponsors_slider","a[href^=\"http://tidd.ly/\"]","#sponsor","#wallpaper,\n.rect",".addslider,\n.leaderbord",".anzeige",".ads-container","#service-linklist,\n.list-inbox-ad-item--multi-line,\n.list-programmatic-inbox-ad-item__iframe,\nlist-inbox-ad-item,\nlist-inbox-pga-ad-item,\nlist-programmatic-inbox-ad-item,\ntr[data-component-pixelurls*=\"adfarm1.adition.com\"],\ntr[data-component=\"MessageListSpecialRow\"]",".bannerTop,\n.clubBox",".partnerlinks",".adwrapper","table[width=\"195\"],\ntable[width=\"468\"]","#custom_html-3",".content-teaser-tabs,\n.indexwerbung","div[class^=\"AdSlotContainer_\"]",".asideBoxB,\n.footer-grey","div[style=\"width: auto; height: auto; min-height: 250px; display: flex; justify-content: center; align-items: center;\"],\ndiv[style=\"width: auto; height: auto; min-height: 250px; justify-content: center; align-items: center;\"]","#sky","#sponsorbutton_div,\n.article_rectangle",".qt-sponsor",".recommendations",".gokb,\n.gokwblock","#advertising",".pz_cont","#js-banner",".tx-admanager","#topCustomers",".js_bns",".et_pb_row_0_tb_header","#td_uid_9_6141b5fdcbe72,\n.td-header-header,\n.td_uid_89_6141b5fdd19ca_rand",".banner-holder",".kurator","#topBannerContainer,\n.tpa-row",".adition,\n.channel-sponsor","#nfad-inner",".desktop-wideboard-top,\n.wideboard-top,\nnau-external-content-lazy",".ad-container",".np8-type-advertorial,\n.view-partners","div[style=\"width:300px;padding:12px;float:left;\"],\ndiv[style^=\"width: 300px;\"]",".teaser--sponsored","#content-banner1,\n#content-banner3","#xxParentDivForWerbPostbit","#ContentFooterPartner",".qf-standard-banner-wrapp","#square","#footer","#banner-slider","div[id^=\"reise-\"]",".mobile-billboard-box",".rectangle","a[href^=\"https://www.frankly.ch/\"]",".tisement","#banner_leaderboard,\n#banner_vertical",".ministage-channel-sponsor-paragraph","a[rel=\"sponsored\"]",".elementor-element-31a7df7,\n.elementor-element-a2b2b40",".sl-banner","a[rel^=\"sponsored\"]",".lead-col,\na[href^=\"https://www.mydirtyhobby.de/\"][href*=\"?ats=\"]","#banner-top",".banner200,\n.banner350,\n.banner60","a[onclick^=\"__gaTracker('send', 'event', 'Ads'\"]",".PrintMotifRotator",".bannerspot",".banners",".slideshow",".block-np8-audienzz,\n.js-audienzz",".l-partnerSlideContainer","#banner-top-all-viewports",".djslider-in",".mui-style-17xiqz7,\n.mui-style-z954cu","#carouselInserate",".rotator",".teaser_type_paid_content,\n.watson-ad","#werbungTop,\n.werbungSmall,\n.werbungWide",".banner-full,\n.frontpage-card-banner",".ad-item,\n.mobile-list-ads,\n.side-ads",".banner-img-bottom",".bannerboxlinks-klein,\n.bannerboxrechts",".field--name-field-werbebild","div[class^=\"Advertisement_container\"]","#section-f09c501,\n.cm-popup-modal,\n.widget_banner",".td-a-rec",".inArticleA,\n.underContentA","#hat_message,\n.adv_block,\n.banner-wrapper,\n.promo__item","#brands","#sticky-aside-placeholder","#sticky-aside",".a-single",".banneruntermenu,\n.footerbanner,\n.videobanner",".spot",".spot_bottom","div[class^=\"bireklam\"]","a[href*=\"/linkout/\"]",".smsbox1,\n.smsbox2","#sidebar > li > .ffwidget_sidebar",".marcopolo,\n.widget--marktplatz","#text-59",".infoHeadWrap1,\n.is-fp-outer,\n.wp-element-button[href^=\"https://amzn.to/\"],\n[style*=\"background-color: #001d4a;\"],\na[href^=\"https://allround-pc.com/\"][href*=\"/?\"],\na[href^=\"https://bit.ly/\"],\na[rel=\"external noopener\"] > img[src^=\"/\"],\na[rel=\"noopener external\"] > img[src^=\"/\"]","a[rel*=\"sponsored\"]",".bxnxr_column,\n.bxv","div[style=\"width:310px; height: 510px;\"]","#wcontent,\ntable[width=\"300px\"][cellspacing=\"0\"][cellpadding=\"0\"][border=\"0\"]","div[style=\"width: 300px; height: 250px;\"],\ndiv[style=\"width: 336px; height: 280px;\"]","#mh_magazine_custom_posts-5",".advert_,\n.headeradvert_","#logo-right-widget","#chatins_frame","#tt_content,\n#wb_widget,\n#wc_widdget,\n.chn_center,\n.sicce-300x250,\n.size-300x250,\n.spz_height_60,\na[href^=\"https://tik-tok-dates.com/\"]","#tt_wrapper,\n.spz_height_80,\na[href=\"https://bit.ly/\"],\na[href^=\"https://www.visit-x.world/\"]","a[href^=\"https://www.erocom.tv/?utm_\"],\na[href^=\"https://www.erotik-von-nebenan.com/?utm_\"],\na[href^=\"https://www.handy-sextreff.info/?c=\"]","a[href^=\"https://www.julia-reaves.com/?bicc=\"]","a[href^=\"https://www.susi.live/FreeAccountLanding.aspx?\"]",".da_placeholder","div[class=\"app-banner\"]","a[href$=\"xref=nosim/wwwbildschirm-21\"]","a[href^=\"http://www.amazon.\"][href*=\"tag=\"]",".custom-bexad","div[style=\"height:80px;background-color:#fff\"]","div[style^=\"min-height: 330px;\"]",".add-inner,\n.header-top","iframe[src^=\"https://ssl.connextra.com\"]","div[class^=\"lp_track_\"]",".creatividad","#special_column,\n#wa_widget,\n.spc_height_80,\n.vjs-overlays",".banner_container",".banner_page_top,\n.sideboard_conatainer",".default__interest-block",".default__realtive-block,\n.video__sidebar-item",".samBannerUnit",".samCodeUnit","#video-right,\n.abcn-footer,\n.resumecard","#anzeige9",".partner-wrapper",".v-A_-commercial",".v-A_-topteaser__article:has(.v-A_-teaser__tag--ad)","a[href*=\"/go/\"],\na[href^=\"http://in.mydirtyhobby.com/track/\"],\ntable[align-center][cellpadding=\"13\"][border=\"0\"][bgcolor=\"lightgrey\"],\ntable[style=\"border: 1px solid black; padding: 5px 0px 5px 0px; background-color: lightgrey; text-align: center\"]","div[id^=\"eroti-\"]",".BannerContainer",".fcb-ad-banner-container,\n.footer-p4rtn3r-container,\n.footer-partner-container,\n.header-presented-by","#metaslider_widget-3,\nimg[title=\"Anzeige\"]",".ff-ba",".banner3box",".tf-ho,\n.tf-sp","#spz_42,\n.sz_300_250,\n.vjs-overlay","div[style=\"margin:10px 0 5px 0;min-height:250px;\"]",".gtag","#text-48",".article-latest.article-layout-0 > .row:has(.advertorial-icon)","a[href^=\"https://prf.hn/\"]",".aff-inhalt-geil-spalte,\n.zeigenfick","#iqd_mainAd","#text-html-widget-3","#tr-contentbottom,\nimg[width=\"140\"][height=\"68\"]",".big-sponsor-box,\n.small-sponsor-box",".partner-main-footer,\n.top-sponsor-nav",".logos-partner-holder,\n.sponsors-holder","#gamelead,\n.adtitle",".sponsorleft,\ndiv.post.hentry.ivycat-post:has(a[href^=\"https://amzn.to/\"]),\ndiv.post.hentry.ivycat-post:has(a[href^=\"https://www.amazon.de/\"])",".primary-footer",".tipps",".x-topbar",".addslot",".skybg,\ntable[style=\"margin-top:4px; margin-left:198px\"]",".home_rennab,\n.lead_rennab,\n.miragobox","#skyscraper-group,\n#skyscraper-group-left","#top-banner","div[id^=\"journ-\"]",".dkpw",".advertisments",".brave_popup","#tip_top","#custom_html-12","#custom_html-9",".img-banner",".nva-center","div[style^=\"height:300px;\"]","#tab-live-odds,\n.bettingStrip,\n.boxOverContent,\n.detailLeaderboard,\n.live-betting-strip,\n.odds,\n.prematchOddsBonus__bonus","#link_placeholder","#au,\n#nrad,\n#side-spot",".publicidad","#labelpub",".widget-3",".f1de-container,\ndiv[data-entrypoint=\"heycar-search-widget\"]",".stroer-ap,\n.stroer-ap_wrapper",".anzeige_teas_rect,\n.anzeige_teas_rect_ax,\n.b-top","a[href^=\"http://rover.ebay.com/\"]","a[href^=\"https://clkde.tradedoubler.com/\"]","a[href^=\"https://ebay.at/\"]",".elementor-element-0e1ce7d",".list-group","img[width=\"300\"][height=\"250\"]",".ai-track,\n.widget_aawp_widget_new_releases","a[href^=\"/red/red.php?\"],\ndiv[style=\"margin-top:-5px; margin-bottom:20px; width:100%; text-align:center; height:150px;\"]",".plistaList > .plista_widget_underArticle_item[data-type=\"pet\"]",".am_el",".amz","a[href^=\"https://amzn.to/\"]","a[href^=\"https://cutt.ly/\"]","#block-block-7","a[onmousedown^=\"this.href='https://paid.outbrain.com/network/redir?\"][target=\"_blank\"]",".v-A_-teaser__halfcol__listitem:has(.v-A_-teaser__tag--ad)",".v-A_-topteaser__rotationbox__item:has(.v-A_-teaser__tag--ad)",".v-A_-white__tile:has(.v-A_-teaser__tag--ad)",".adslot-fireplace,\ndiv[id^=\"ring-slot-\"]","div[style=\"height:90px\"]","#pf_incontent_2,\n.traffectiveBox",".topBanner","a[href*=\"//bit.ly/\"]",".plistaList > .plista_widget_belowArticle_item[data-type=\"pet\"],\na[href^=\"http://click.plista.com/pets\"]",".banner-top-section","#fx_imbanner","[href^=\"https://start.amateurcommunity.com/\"],\n[href^=\"https://susi.live/\"],\n[href^=\"https://www.zubivu.com/\"]","#ttt_wrapper,\n#wc_wdiget,\n.sice-300x250,\na[href^=\"https://www.tik-tok-dates.com/\"]",".tf-de","#tracking-url",".happy-inside-player","#bannerpos2",".gpt","#responsive_lightbox_image_widget-5,\n#responsive_lightbox_image_widget-6",".ai-placement","#custom_html-42","#custom_html-5","img[alt=\"Logo Partner\"]","#custom_html-17",".footer-partner",".ap",".sponsor-section","#fh-inside-bottom","#roboter-forum\\.com_mpu_bot,\n#roboter-forum\\.com_mpu_top",".TopBanner-root",".post-grid-item.grid-item:has(.ad-badge)","#banner-news,\n.banner-super-middle,\n.superbanner-top",".c-sponsors-list",".branding,\na[href^=\"https://pvn.mediamarkt.de/trck/eclick/\"] > img[src^=\"https://www.schnittberichte.com/resources/images/mediamarkt_\"],\na[href^=\"https://pvn.saturn.de/trck/eclick/\"] > img[src^=\"https://www.schnittberichte.com/resources/images/saturn_\"]","a[href^=\"https://amzn.to/\"] > img",".displaybanner-container",".da__placeholder,\n.sda",".kosmonaut_120x600,\n.kosmonaut_300x250",".o-ProductSliderItem[data-ssr-as*=\"\\\"clickUrl\\\":\\\"https://retail-api.sa-tech.de/api/\"],\n.o-SearchProductListItem[data-ssr-as*=\"\\\"clickUrl\\\":\\\"https://retail-api.sa-tech.de/api/\"],\narticle.o-CompactProductListItem:has(a[href^=\"https://retail-api.sa-tech.de/api/\"])",".stx","#leaderboard",".promotion-teaser-container",".prmtnContentMin,\n.prmtnKeepHeight,\n.toneFusePanel","a[href^=\"https://airbnb.com/rooms/\"]",".advheader","#acTop",".c-product-tile:has(div.c-product-tile__sponsored),\n.swiper-slide:has(div.c-product-tile__sponsored)",".adsurbg,\n.dazn,\n.spx-adsurbg-banner",".spons","#flattr > a,\n#flattr > p","#mcebox,\n#mcebox-sidebar","a[href=\"/www/888casino\"]",".b,\nins[data-meh-id]","div[id^=\"super-\"]",".Common-Kn-Rp-Inline,\n.Flights-Results-FlightRightRail",".swiper-slide:has(.entry-adv)",".pb-8.text-center.float-center",".wrap > footer[style=\"bottom: -260px;\"]:last-child > div:first-child",".adv-wrapper,\nimg[width=\"450\"][height=\"300\"],\nimg[width=\"450\"][height=\"700\"],\nimg[width=\"500\"],\nimg[width=\"800\"][height=\"230\"],\nimg[width=\"900\"][height=\"350\"]",".qm-head,\n.qm-side,\ndiv[style=\"min-height: 280px; margin-top: -20px;\"]","#tennisnetWidget","a[href^=\"https://www.krokodeal.net/\"]",".premium","#trade",".uhren-widget",".da-container,\n.da-container-sky","div[data-ads-provider=\"sdg\"]",".ai-viewport-1",".Anzeige","#adup1,\n#adup3,\n#adup5",".promobox","div:has(> img[referrerpolicy=\"unsafe-url\"]),\ndiv[style^=\"text-align:center;font-size:80%;\"]",".desk-pv.desk-pb\\+.portable-pv.lap-pr--.lap-ml.lap-pl-.bg--green-lightest.portable-ml0.border--top.border--bottom.palm-ph15,\n.jsDaa-D,\n.werbung:not(.toolbar-wrapper)","#urban-medrect1,\n#urban-medrect2","div[style=\"float:left;clear:left;height:620px;width:180px;padding-top:15px;\"]","#sp-sidebar1,\n.data-wb-main-adv-dir-right",".boxx",".footer-widget-zone,\na[href^=\"https://www.zononi.com/LA/LP/Finder?\"],\na[href^=\"https://www.zononi.com/VX/LP/Roulette?\"]","a[href^=\"https://www.wazazu.com/LA/Landingpage?\"]",".wps-player__happy-inside",".zenid-adlabel",".pornofilme_recht",".row.mt-0.mb-3.d-print-none:has(.fa-ad),\n.zgsky",".item-advert","#customWer",".kleinueber > .row + div > .topzubehoeranzeige-berichte","#angeboteStartseite2018",".ad_below-nav",".clearit_s","#Container > #head:first-child + #content + br + .spacer + center","#adc1,\n#adc2",".left-col__bottom",".fh-inside-post",".message--post:not([data-author])","div[align=\"center\"][width=\"468px\"] > table[height=\"60\"][cellspacing=\"0\"][cellpadding=\"0\"][border=\"0\"][align=\"center\"]",".zona_publi","#UNWB300100,\n#UNWB300200,\n#UNWB300300",".spalten_33_werbung,\ndiv[style=\"text-align: center; min-height: 110px;\"],\ndiv[style=\"text-align: center; min-height:260px;\"]",".lynxanzeige + .lynxcontainer","#tdi_39",".ads6p","div[class^=\"ad_\"]",".monkey-container",".slick--optionset--anzeigen-slider",".mj-pf-widget","article[class^=\"teaser nummer-\"]:has(span.specialfeature)",".add_top","#adunten + div[style=\"font-size:8pt; color:#999999; margin-left:39px; width: 728px;\"],\n#iphpbannerleft,\n#layerleft,\n#layerright,\n.rightbanner,\ncenter > table > tbody > tr > td[valign=\"bottom\"][align=\"center\"][style=\"width: 100%;\"]","#skyL_wrapper,\n#skyR_wrapper","a[href^=\"https://allvideoslots.com/\"],\na[href^=\"https://casino-bonus24.net/\"],\na[href^=\"https://casinoandy.com/\"],\na[href^=\"https://casinopilot24.com/\"]",".slide-box",".anzeigenbox,\ndiv[id^=\"Ads_BA_\"]","#masthead","#display-ga",".ad + #flashContent,\n.ad + .tdt,\n.ad + .uk-panel,\n.block-weather-link,\n.hd-banner,\na[target=\"_new\"][href^=\"inc/inc_link.php?id=\"]",".container-banner,\nimg[name=\"banner\"]",".ympb_target_banner","#skyScraper,\n#superBanner,\n.produkt_uebersicht > div > br.clear","#billboard-container,\n.ce_banneradbox",".ce_topicbox:has(.label-ad-highlight)","#banner6_container,\n#stroeer-container-pubperform",".category-werbung-kopfzeile,\ndiv[data-id=\"904ffeb\"]","#container_banner","#dm_conative_container_artikel,\n#stroeer-container-banner2",".ad-banner",".ad-banner-billboard","#ape_Detail_ad-endcap-1_Glance_placement,\n#heroQuickPromo_feature_div,\ndiv[data-ad-id],\ndiv[id^=\"sp_detail\"]",".fnetbr-pbb-container,\ndiv[class*=\"fnetbr\"]","#text-14","a[href*=\"/boardheaderads/\"]",".wanner,\n.wwd","#ah_bb_footer,\n.billboard-ad-footer,\n.billboard-ad-top,\n.content-ad-first,\ndiv[style$=\";min-height:250px;min-width:300px;\"],\ndiv[style$=\";min-height:250px;min-width:310px;\"],\ndiv[style=\"min-height:265px;\"]",".top-panel","#Fallback-Content",".rectX,\n.rect_sidebar",".amazon-link,\n.rmp-module__gam",".asa1_fbh,\n.rotslide-wrap","#text-65,\na[href=\"https://www.betrugstest.com/online-casino/apple-pay/\"],\na[href=\"https://www.easeus.de/datenrettung-software/mac-data-recovery-wizard-free.html\"],\ndiv[data-embed-provider=\"rcm-eu-amazon-adsystem-com\"]","a[href^=\"https://www.apfeltalk.de/magazin/affiliate/\"]",".banner_container__mobile_billboard","#banner",".arbei-widget,\ndiv[id^=\"arbei-\"]","#header-banner","img[width=\"160\"][height=\"600\"]","#sidebar-left #text-5,\n#wrapper > div[class] > img,\na[href=\"/panasonic_de\"],\na[href^=\"https://www.teufel.de/sales?partner_id=\"],\ndiv[id^=\"aread-\"],\nonehr","#aktieImFokus,\n#ariva\\.de_d_1x1_1,\n#ariva_de_d_300x250_2_filler,\n#dianomiiFrame,\n#siteTeaserBox,\n#woAktieiF,\n#wpAktieImFokus,\n.anzeigeText,\n.bannerleiste,\n.prodo-shadow,\n.teaserPicturedNews,\n.werbeplaetze_button,\n.woBannerHeader,\n.wo_news_top_banner,\na.background-red-bright:has(span.anzeige),\na[data-google_analytics_id^=\"wo\"],\ndiv[style=\"width:1000px; text-align:center; min-height:270px;\"],\nspan[onpointerdown^=\"countClickOnGAorEs(\"],\nspan[onpointerup*=\"prgAnalyticsEvent(\"]",".banner-slider",".sponsoren",".banner-leaderboard",".tx-sf-banners","td[width=\"100%\"][align=\"center\"] > hr[size=\"1\"][color=\"#8482A5\"] + table[cellspacing=\"0\"][cellpadding=\"10\"][border=\"0\"][bgcolor=\"#000040\"],\ntd[width=\"33%\"][valign=\"middle\"][align=\"center\"] > a[target=\"_blank\"][href^=\"/links/wechlink.asp?ID=\"] > img",".sponsor_col",".ADVBOX",".ad-list_small-native-container,\n.p-swatch_top-nice--blank.p-blocklink,\ndiv[data-slot-name=\"banner\"],\ndiv[data-slot-name=\"banner2\"]",".sdgSlotContainer","#billboard_btf_rlWr,\n#sky_btf_rlWr,\n#superbanner_rlWr,\na[onmousedown^=\"this.href='http://paid.outbrain.com/network/redir?\"][target=\"_blank\"]","#billboard_btf_2Wrapper,\n.superbannerBtfContainer","#billboard_rlWr,\n#sky_rlWr","a[data-nvp*=\"'trafficUrl':'https://paid.outbrain.com/network/redir?\"],\na[data-oburl^=\"https://paid.outbrain.com/network/redir?\"],\na[data-redirect^=\"https://paid.outbrain.com/network/redir?\"],\na[onmousedown^=\"this.href='https://paid.outbrain.com/network/redir?\"][target=\"_blank\"] + .ob_source","a[href^=\"https://paid.outbrain.com/network/redir?\"]","#oc24-div","#fh-outside-top",".fh-sidebar",".autog-widget",".widget_custom_html",".sideinfo","#left-banner-container,\n#right-banner-container,\ndiv[style=\"text-align: center; min-height: 180px;\"]","#footerpartners,\n.hmpartnersglobal","#StyleTM-TopBanner,\n.StyleTM-PartnerImages","#ston-footer-ad,\n.ston-ad,\n.ston-contentad,\ndiv[style^=\"min-height: 90px;\"]","#leaderboard-bg",".cadheight[style=\"min-height:600px;\"]","div[id^=\"basic-\"]","img[width=\"500\"][height=\"500\"],\nimg[width=\"600\"][height=\"500\"],\nimg[width=\"600\"][height=\"600\"]",".mod_banner","a[href^=\"banners.php?\"]","#MidRectangle","#leaderboardBelowNav",".MuiBox-root:has(a[href^=\"//b.fr3.eu.criteo.com/rm?\"]),\nli:has(a[href^=\"https://b.fr3.eu.criteo.com/rm?\"])","#sponsors,\n#web-trekk-pageupdate",".sponsors",".type-banner",".av-7mui-2434157fea122ac0fb770d6fe554162d,\ndiv[id^=\"bayre-\"]","#bannerLink","div[id^=\"traffective-ad-\"]",".vc_raw_html,\nimg[width=\"400\"]","a[href^=\"http://partners.webmasterplan.com/\"],\na[href^=\"https://neu.turbo-d.de/\"]","#WallpaperBanner",".dfpcontainer,\n.yieldlove","#checkdiv","#skyscraper","#billboard","div[id^=\"medium_rectangle\"]","div[class^=\"outbrain_\"],\ndiv[class^=\"showheroes_\"]","div[class^=\"traffective_\"]","div[data-testid=\"article-billboard-advertisement\"]","div[class^=\"article_billboard-\"],\ndiv[data-component-type=\"ad-slot\"]",".commercial-container,\n.commercial-rightwideskryper",".hm_widget_banner",".a.block04:has(a[href^=\"https://www.awin1.com/\"]),\n.wrap-col.box4:has(a[href^=\"https://www.awin1.com/\"])",".tdp",".partner-teaser","#tso-billboard-1,\n.tso-pub,\n.wb,\n.wb-wide",".banner-skyscraper",".lns-banners-zone","#smartclip-overlay",".wide-banner","#mrec",".stage-teaser__partner--advertorial,\n.tea-rectangle,\na[href*=\"/partner/\"]","div[data-tr-doc-type=\"dt=InlineAd|st=BTOAdTag\"]",".trc_related_container div[data-item-syndicated=\"true\"]",".bilde-widget","#content + #right",".asa2_fbva_wrapper,\ndiv[class$=\"-adlabel\"]","#topbanner",".stream-item","#BSB,\n.OAS_AD","div[class] > img[referrerpolicy=\"unsafe-url\"]",".header-banner",".adv_widget",".ai_widget,\n.azimg,\n.inserter-5,\n.inserter[data-ai],\ndiv[onclick^=\"ga('send', 'event', 'Ad',\"]","#webcontentstart,\n.sticky-wrapper","#text-18,\n.blogp-startseite,\n.blogp-werbung-oben-in-artikeln,\na[href^=\"https://all-inkl.com/?partner=\"]","#content_banner","#deals-aktionen-box,\n#pricechange-box,\n#top-angebote-box","#div-dfp-index1_300x250,\n#div-dfp-index2_300x250","#container_rectangle_1",".ce_rsce_bd_werbung",".hsbc_homepage_topflop,\n.topbanner,\n.wallpaper_top",".u-ad","#bnBanner,\n#bnTickerContainer:has(#bnTickerAdNotice),\n#sgFeedList,\n.bg-smartbroker-dark,\n.bg-smartbroker-light,\n.btn-smartbroker",".leaderboard",".bmg-ad",".bx-ada",".background",".btc-sponsored","#block-block-8,\n#topshadow",".code-block-2",".contentFrameEddie",".item + .at_sponsored > .itemHeadline",".shopLinkFrameWrapper",".topFrameEddie",".bfa-ad-slot,\n.fe-channel-item--promo",".trc-content-sponsored",".trc-content-sponsoredUB",".view--advertorial",".wv_story_el_insertedAd","#billboard_btf","#inpage,\n.bcode,\n.bcode-top-container",".w-mrec",".trc_related_container div[data-item-syndicated=\"true\"]:not(.inNetworkItem)","#WzTtDiV + table[width=\"100%\"][border=\"0\"],\nbody > table[width=\"100%\"][border=\"0\"]:first-child,\ntable[width=\"95%\"][cellspacing=\"1\"][border=\"0\"] > tbody > tr > td[valign=\"top\"]:first-child + td[style=\"vertical-align: top;\"]:last-child,\ntr:first-child:last-child > td[valign=\"top\"]:first-child + td[width=\"152\"][valign=\"top\"][align=\"center\"]:last-child",".promo-af-wrap","a[class^=\"herobanner-adv\"]",".sponsored--container",".va-adhint",".comp-ku8lxchu,\n.wixui-column-strip.wix-blog-hide-in-print",".block-15","img[width=\"728\"][height=\"90\"]",".idgWebcastsCarousel","#anzeige_mso_skyscraper,\n#anzeige_skyscraper_2","div[class*=\"adszone-\"]",".ads__initialized,\n.gujad-wrapper,\nconsent-for","#dlcharts-list + div:has(a[title*=\"Avast Free Antivirus\"]),\ndiv[data-vr-zone=\"hp-aquamarin-1\"]:has(img[src^=\"https://im.chip.de/\"]),\ndiv[data-vr-zone=\"hp-aquamarin-2\"]:has(img[src^=\"https://im.chip.de/\"]),\nsection[class=\"mt-sm fb-col-7 fb-col-sm-12 Listing\"] > div:has(a[title*=\"Avast Free Antivirus\"])","#partner-nav,\n.ads-alignment",".Article__Ad,\n.Article__Promo","#sky-tisoomi-wrapper,\n.mrec-news",".c-FloatingPrompt,\n.compar_tbl_body_plugin,\n.su-button,\ndiv[id^=\"coinc-\"]",".abo",".wv_story_el_billboard",".adbox-outstream,\n.article-view__rectangle,\n.blackfriday,\n.block1--banner,\n.block1--skyscraper,\n.skin-ad,\n.text-ad,\na[href^=\"https://www.computerbase.de/api/ad-click?\"],\na[rel*=\"sponsored\"] > img[alt=\"Anzeige\"]",".billboardBtfContainer,\n.jobbioTeaser,\n.superbannerContainer,\n.trc_related_container .syndicatedItem:not(.inNetworkItem)","#text-2",".idgLeaderBoard",".adcontainer",".teaser:has(.teaser__promolabel)",".wkTeaser:has(.promolabel)",".promContainer",".advert",".quiz-footer-wrapper","div[id^=\"avas-\"]",".banner-section",".review-recommendation-headline,\n.review-recommendation-headline + a","div[style*=\"width: 300px; height: 300px;\"]","#gpt_superbanner","a[href^=\"https://www.manitu.de/?partner=\"]","#automaten-richter,\nimg[width=\"120\"]",".raw-html-component",".previewtile.swiper-slide:has(a[href^=\"https://amzn.to/\"])","#banner-right,\n#content-billboard,\n#medium_rect","#dtm_multiboxcontainer,\n.banner_tl",".banner_top","img[height=\"300\"]","img[height=\"600\"]",".header-leaderboard,\n.header-leaderboard-container",".code-block-4",".wk",".ed-element",".custom-inhoadd",".anzeige-links,\n.billbo",".alice-adslot",".sad_banner,\n.sad_out-of-page,\n.sad_pubperform,\n.sad_rectangle,\n.sad_rectangle_2,\n.sad_sky,\n.sad_topmobile",".presse","#superBContainer",".container-banner-2,\n.partnerlogos",".rotation-partners","#rstpl-before-higher-position,\n.banneritem,\n.n2-ss-slider-3",".Rectangle",".widget_aawp_widget_box",".widget_commerce","#custom_html-8",".amazon-auto-links,\n.custom_html-7,\ndiv[id^=\"ax-\"],\ndiv[style=\"margin-bottom:10px\"]",".sdgAdServerAnchor","#sponsoren","#workshopWidget,\n.SkyscraperLeft,\n.SkyscraperRight,\n.landing-brands,\n.sponsortext,\n.widget-injection-point","#vlybyOneByOneWrapper",".billboardbanner",".code-block","a[href^=\"/adserver/goto/\"],\na[href^=\"https://servedby.flashtalking.com/\"]","#dogforum_footer,\n#dogforum_header,\ndiv[id^=\"dogforum_content_\"],\nli:has(.wbbXdLocationAfter1stPostAsPost),\nli:has(.wbbXdLocationPostList)",".werbemittel",".text-center.container.d-none.d-sm-block.margin-bottom-10.bb-fixheight","#dsBanner","#banner_right","#banner_top","#DCA_TOP","#DKGA_LEAD,\n#DKGA_SKY","td[width=\"120\"][valign=\"top\"][align=\"center\"]:last-child","#c3296,\n#c5812","#AD,\n.footer-sponsor-section",".ng-banner",".dbh-widget,\ndiv[id^=\"dbh-\"]","#block-dudende-d-970x250-1billboard,\n#block-leaderboard2ndslot,\n#block-lexemleaderboardunten,\n.tabloid__side-column-top,\n.tile__wrapper",".park-portal",".sponsor-list",".ce_plista","#EAT_D_Index_Top_Wrapper",".adsense",".srp-1p__banner,\n.vi-lb-placeholder",".ebn-billboard,\n.ebn-billboard-mobil,\n.ebn-incontent-1","#text-20","#marktplatz,\n.sbad",".g-adv-side,\n.g-adv-top > .inside",".n2-ss-slider-pipeline","#media_gallery-2","#rightcolumndiv",".affiliate-button",".ef-article-card--ad,\n.ef-footer__section,\n.ef-footer__section--logos,\n.ef-stadium-ad__banner",".sponsor_wrapper","#text-10,\ntr > th",".bannerContent","#oc24_container_top",".placeholdercontainer",".page__ad-element",".holder-box-5",".in-content",".mtbnewsAdBillboardContainer,\ndiv[class^=\"mtbnews-ad-container\"]",".p-header","a[href*=\"/redirect/\"]","a[href^=\"https://rover.ebay.com/\"]",".promo",".plainContentCollection",".group-externe-links",".chat,\n.ref-header-top-baner",".eral_wrapper","#stream-item-widget-2,\n#stream-item-widget-3",".ea-gat-slot-wrapper",".js-mock-banner",".js-stt-click > picture",".pub",".pub-content",".v-A_-sidecol__list__item:has(.v-A_-teaser__tag--ad)",".bwdfb-widget",".pm-items > [widget-child]:has([ping^=\"//b.nl3.eu.criteo.com/rm?\"]),\n[data-key-id]:has([src^=\"//b.nl3.eu.criteo.com/rm?\"])",".c-sidebar:has(> .widget-odd > div[class^=\"c-ad-exper-\"]),\ndiv[class^=\"c-ad-exper-\"]",".dm-slot",".premiumpartner,\n.topsponlink","#block-block-32,\n#block-block-35,\n#block-block-5","#sp-content-top",".borlabs-dealer,\n.borlabs_fairaudio_ads_widgetx,\n.candy-top",".cca","div[id^=\"npm_\"]","a[href^=\"https://www.awin1.com/awclick.php\"],\na[href^=\"https://www.booking.com/searchresults.html?aid=\"]",".teaserheld-header-wrapper","#incontent_1,\n#incontent_2","#qql","tr:first-child:last-child > td[align=\"left\"][width=\"150\"][valign=\"top\"]:first-child + td[align=\"center\"] + td[align=\"left\"][width=\"150\"][valign=\"top\"]:last-child",".mod-sponsor-icon",".hauptsponsoren",".module-footer-sponsors",".b-logo-listing,\n.sponser-lead-inner",".top-footer-inner",".sponsoren_wrapper",".fusion-builder-row-3,\nimg[width=\"280\"][height=\"160\"]",".elementor-element-f2d5c64",".owl-carousel.owl-loaded.owl-drag:has(.label-ad-highlight)",".excerpt-tile.cell.small-12.medium-6:has(.advertorials)",".card-streaming-btns",".main-banner","#m > div[style=\"left:16px;width:468px;overflow:hidden\"] + .p[style=\"left:4px;width:492px;height:262px\"]:last-child","#block-2,\n#block-7","#section-partner,\n.snippet--cta,\n.snippet-container","div[id^=\"banner_\"]","div[id^=\"finan-\"]","#dban1,\n#dban2,\n#dmr1,\n#dmr2","#fn-ankuendigung,\n#sideteaser,\n.Ad_FinativeHome,\n.Ad_ImageTeaser,\n.Ad_SmartAd,\n.c-sban1,\n.c-sban2,\n.nadT,\n.on-click--partner,\n.smartbroker--text,\n.smartbroker-logo,\n.smartbroker1,\ntr:has(span.sprite.h-w-c)",".ad02p,\n.paid-news-container,\n.videosponsor_hsbc",".affiliate-amex,\n.affiliate-mediamarkt,\n.affiliate-o2,\n.affiliate-saturn,\n.affiliate-tink","a[href^=\"https://www.communicationads.net/tc.php\"] > img","#sc-outstream-wrapper,\n.aside-rectangle",".adv",".head-top-bannerplace,\n.wrapper-banner",".pbph,\n.skyscrapper-left,\n.skyscrapper-right,\ndiv[id^=\"cncpt-dsk_\"]","[data-product-list-id]:has([data-badge-type=\"sponsored\"])",".boxOverContent__banner",".float-widget,\n.partners-title + .partners",".sidebar_partners",".user-flzads-pi1,\na[href^=\"/api/content/public/media/link?id=\"]","#CT_DESKTOP_NATIVE_HOR_ANY_hor2,\n#tfm_admanagerTeaser,\n#tfm_footer_yield,\n.Ad-Slot,\n.adsBlock,\n.cad,\n.cad_native,\n.cls_hor_prnt_am,\n.cls_slot_xxoutstreamxx,\n.cls_ver_prnt,\n.cls_ver_prnt_xs,\n.fol_mew-flying-carpet-wrapper,\n.ob-ad-carousel-layout,\n.ps-trackingposition_OrangerButton,\n.ps-trackingposition_PDFkasten,\n.shoppingcartctn,\na[href^=\"https://www.communicationads.net/tc.php\"],\na[href^=\"https://www.financeads.net/tc.php\"],\narticle[id^=\"teaser-\"][data-placement],\ndiv[id^=\"CT_SMARTPHONE_NATIVE_\"],\ndiv[id^=\"M_CONTENTAD\"],\ndiv[id^=\"M_TRSCT_hor\"]","a[href^=\"https://pvn.mediamarkt.de/\"]",".FC__Ad","div[id^=\"foodw-\"]","#bs-container,\ndiv[id^=\"outer_sas_\"]",".banner-row",".commercial-post-container,\n.pane-landing-advertorial","div[class^=\"werb-block-\"]","#gf-superbanner","#frnBanner,\n.frn_contAmazon,\ndiv[data-componentid^=\"ext-frn-adtag-\"],\ndiv[id^=\"ext-frn-adtag-\"]",".result-container > .container-right",".sponsors-wrapper",".widget_links","#ezisgib,\n#thgirrennab,\n.hinweisad",".bannertop,\n.ligaadd,\n.premiumPartner,\n.skyadd",".element_leaderboard,\n.element_squarebuttongroup,\n.news-item-wbg","img[width=\"140\"][height=\"140\"]",".fp-banner",".noContentBannerArea,\n.tandem_right,\n.tandem_top",".mediumrectangle",".superbanner","kas",".teaser__item:has(.teaser__adtype)","#partnerCentersLogoBar",".news-spiel-quoten","#SPMADS_fussballn_HOME_MEDREC_1",".contentAd--pos1","article[data-post-id]:has(.sponsor-byline)",".portal-top",".block-11,\n.block-12,\n.block-13","div[id^=\"viewHomeDesktop-outGrid-sponsored_products-\"],\ndiv[id^=\"viewSearchResultDesktop-inGrid-sponsored_products-\"]",".normal_text[width=\"100%\"][valign=\"top\"][height=\"100\"][align=\"left\"][border=\"0\"]",".jad-placeholder","img[width=\"300\"][height=\"246\"]","#mpu,\n#sky2_1,\ndiv[style=\"min-height: 600px; margin-bottom: 20px;\"]","#arb",".yftovjn,\n.yftovjn-container","#dfp-header,\n#dfp-header-container,\n#rectangle-container-desktop,\ndiv[id^=\"ad-div-\"]",".widget_aawp_widget_bestseller",".mobile-interscroller",".header-widget-area","a[data-track]",".widget_adtag_rectangle","#right-banners,\n.hitdb",".wp-block-group:has(.wp-block-button__link)","#banner_content","#buybox","#dtm_super,\n#rectangles,\n.gs-searchblock--adContainer,\n.mod-RechteWerbespalteStartseite",".shoepassion_content_banner,\n.shoepassion_sidebar_banner",".spice-box-container",".box--ad,\n.sky-left,\n.sky-right,\ndiv[id$=\"SparkWrapper\"]",".box.img_link:has(.advertorial_hint)","#teaserheld-header",".alice-adslot-label,\n.banner-homepage,\n.sidebar-btn-affiliate[rel=\"nofollow noopener sponsored\"],\ndiv[data-sdg-ad],\ndiv[data-trigger=\"sourcepoint-ad\"]",".atkp-bestseller-box",".verticalCarousel","div[style=\"border: 1px solid #000; padding: 5px; margin-bottom: 15px; background: url(https://www.go2android.de/wp-content/plugins/amazonsimpleadmin/img/amazon_DE_small.gif) right bottom no-repeat #ffffff;\"]","#coba_trading_investment_news,\n.v-is-sponsored-box","#ad_gsbuch","#iqadtile5,\n#pricehits,\n.g6 > .clearfix[style=\"margin: 20px 0; clear: both; min-height: 640px;\"],\n.gbox_affiliate,\n.sp-breakout-affy,\n.tags,\nli[data-article-id]:has(.icon-addy)","div[id^=\"csi_forum\"][style=\"min-height: 100px; padding: 0px; display: block;\"]",".ad_list",".premium_firm_list",".card-content > center:has(ins.adsbygoogle)",".mgawerbungbase",".container_skyscraper","#resultInfeed1,\n.adDetailRectangle,\n.bannerResult,\n.phoneblockAd",".quartermedia",".productCard:has(div.premiumProductCaption)",".noContentBannerWb",".footer","#rothaus-aktion",".adbanner,\n.footer__sponsors",".mh-widget.s5214-widget",".banner_image","#sponsors_slider,\n.home_sponsor_slider,\nimg[width=\"605\"][height=\"690\"]",".vc_carousel-inner","img[alt^=\"Werbung\"]",".ad-info,\na[data-adid]:not([data-adid=\"12937\"])",".ad__skyscraper--wrapper,\n.ad__superbanner--wrapper,\n.article__ad__wrapper,\narticle.card:has(.with-ad-marker)",".tx-imagecycle-pi1","img[width=\"600\"]","div[id^=\"promotionHeader\"]",".bannerbox",".su-button-wide[href^=\"http://amzn.to/\"]",".spu-box,\n.vc_custom_1666781149136","div[id^=\"hardw-\"]","div[id^=\"ad-\"]","div[style=\"float: right; clear: both; padding-left: 1rem; margin-top: -1rem; margin-right: -9rem; padding-bottom: 0.25rem;\"]",".ba-fullsize",".postanzeige","#Ads_Billboard_container",".css-1mdt86f,\ndiv[id^=\"adtech_\"]","#custom_html-6",".med4,\n.med5,\n.unserePartner","#block-network,\n.block-businessad","#anzeigendiv","#main-sponsor,\n.sponsoring-footer",".hauptsponsor,\n.sponsoren-right","#module-sponsors",".widget_media_image",".widget_text",".dfad,\n.widget_cfac","img[width=\"150\"][height=\"111\"]","#ad-landingpage-top,\n#bannerzone,\n.article-layout__header-wrbng,\n.img-ad,\n.incontent3-cls-reduc,\n.inread-cls-reduc,\n.middle-ad-container,\n.p-3.-mx-3.bg-gray-50:has(a[data-component=\"TeaserLinkContainer\"]:not(a[href^=\"https://www.heise.de/api/accountservice/subscribe/\"])),\n.perf-cls-reduc-leaderboard,\n.perf-cls-reduc-rectangle,\n.sponsored-placement,\nA-PATERNOSTER,\ndiv[style=\"min-height: 250px\"],\ndiv[style=\"min-height: 400px;\"]",".vidheight[style=\"min-height:450px;\"]",".topAdCol",".h5v-ad","a[href^=\"/de/hertha/sponsoren/exklusiv-partner/uebersicht/page/\"]",".bestlist-item__shop,\n.sky1-outer-container",".themenmonat","#anzeiged2",".asm_async_creative",".btn-danger,\na[href^=\"https://www.hockeyweb.de/?rex-api-call=pixel_forward&url=\"]","a[href^=\"https://clk.tradedoubler.com/\"]","#block-block-217,\n#block-block-218,\n#mrec-wrapper,\n#superbanner-wrapper,\n.content-amazon",".ksv-sponsoren-footer",".hs_anbieter_box_block","div[id^=\"block-views-advertising-\"]",".av-partner-fake-img,\n.avia-slideshow-1","#greyscale-2","#c5307,\n#sponsor-slider","tr > td[valign=\"top\"]:first-child + td[width=\"15\"] + td[width=\"186\"][valign=\"top\"]:last-child","div[id^=\"ibiza-\"]",".brick[data-b-title*=\"Traffective\"]","#verbraucherhinweis-300x600,\n#verbraucherhinweis-970,\n#verbraucherhinweis-970x250,\n#verbraucherhinweis-latest,\n#verbraucherhinweis-single-300x250","#halfpage-banner","#immowebAdCont",".banner-top-placeholder,\n.expose-ad-placeholder","article.type-post[data-post-id]:has(.sponsor-label)",".amalink","#adsight-slider,\n#r89-desktop-billboard-atf-0-wrapper,\n#r89-desktop-incontent-0-wrapper",".billboard-wrapper",".d-sm-block","div[data-ez-block-id=\"3324017\"]","#INS_D_ROS_Parallax,\n#parallax,\n.td_module_ih_current_news:has(.spo)","#bigsize",".ce_postlistbox:has(.label-ad-highlight)","#desktop-bottom-ad-wrapper,\n#desktop-left-ad,\n#desktop-left-bottom-ad,\n#desktop-top-ad,\n#recommendations,\na[href*=\"//www.amazon.\"][href*=\"tag=\"],\ndiv[style^=\"width: 728px;\"]",".product--box:has(.rm-sponso)","#custom_html-4",".post div[style=\"float:none;margin:0px 0 0px 0;text-align:center;\"],\ndiv[style=\"margin-bottom:.5em;padding-top:.5em;min-height: 270px;display: flex;justify-content: center;align-items: center\"]",".bigbanner,\n.skyscraper_left,\n.skyscraper_right","#text-64",".islam-widget",".pane-simpleads-ad-groups-9,\n.region-head-adbar-left","li:has([data-testid=\"advertisementSign-flag\"])",".plistaList > .itemLinkPET",".mpu",".magazinteaser","div[data-widget_type=\"shortcode.default\"]:has(.adsbygoogle),\ndiv[style=\"text-align: center;\"]:has(.adsbygoogle)","#jf-stroer-sky,\n#jf-stroer-superbanner","#banner_sidebar",".cad_box,\n.fusslogos","div[data-testid=\"display-ad\"]","#addemam-wrapper","#below-header","#globalAnnouncement",".footer-banner",".exp-vision__ext-wrapper--spad,\n.product--spa,\n.product--sponsored,\n.product:has(div.product__sponsored-ad-label),\n.rd-recommender__tile:has(div.rd-product-tile__badge--ad),\n.rd-recommender__tile:has(span.advertiser-info__button-icon),\n.spads-recommender,\n.sponsored-brand-products-container,\n.teaser-orchestration__wrapper--online",".kca-wrapper",".blc-left,\n.blc-right,\n.offline","a[style=\"position:relative; float:left; width:698px; height:63px; padding-left:28px; padding-right:0px; padding-top:14px; border:1pt solid #DADADC; background:#FFFFFF display:inline;\"]",".kick__ad-pos_wrapper",".kick__euro2020-brand-sponsor,\n.kick__modul--euro__sponsor","#kinder\\.de_sitebar_1,\n#kinder\\.de_sitebar_2","#MR,\ndiv[style*=\"height:250px\"]","#hockeystick,\n.performance-pub","#header_main,\n#klamm\\.de_forum_1,\n#klamm\\.de_forum_3,\n#klamm\\.de_incontent_1",".bannerprom,\n.opa",".klartads-widget",".banner-position","#brws_banner-supersize,\n#btf-billboard,\n#home-billboard,\n#liberty-home-above-header,\n#liberty-home-billboard,\n#liberty-vip-billboard,\n#liberty-vip-middle,\n#liberty-zsrp-bottom,\n#liberty-zsrp-top-banner,\n#vip-billboard,\n.j-liberty-wrapper,\ndiv[data-liberty-ad-loaded=\"true\"]",".admanager__ems__dmofooter-1,\n.admanager__ems__superbanner-1,\n.kb-home-medrec-halfpage,\n.ks-ad:not([data-adslot=\"karotte\"])","#mini-panel-rs_teaser_verpoorten,\n.contentRect,\na[href^=\"https://ed.koeln.de/ad/www/delivery/ck.php\"]","#leaderboard_nav,\n#wallpaper_left,\n#wallpaper_right","div[style=\"width:300px; height:250px;float:left; margin-right:15px; margin-bottom:15px; border:0; background-color:#c0c0c0; overflow:hidden;\"],\ndiv[style=\"width:728px; height: 90px; text-align: center; background-color:#c0c0c0;\"]",".RTaktAds,\n.advBoxSegment",".widget-1",".sidebar-right > #text-11,\n.sidebar-right > #text-6","#banner-wrapper-right-v3,\n#banner-wrapper-top-v1","#bdaia-widget-e3-10,\n#bdaia-widget-e3-11,\n#bdaia-widget-e3-12,\n#bdaia-widget-e3-14,\n#bdaia-widget-e3-9,\n#bdaia-widget-html-4,\n#bdaia-widget-html-7",".dm_ta300x300.sold_content","img[width=\"200\"][height=\"600\"]","#content-bottom-highlighted",".werbeplatzierung-container","#billboard_1_wrapper,\n#billboard_2_wrapper,\n#leaderboard_1,\n#mobilebanner_1,\n#rectangle_1,\n#rectangle_2,\n.article_nachDerWerbungWeiterlesen-desktop",".editorial-teaser","#kratzer,\n.bb_top,\n.ed_d","#content-solads,\n#home-teaser,\n#page-closing-sol,\n#page-top-sol,\n#zeiten,\n.additional-banner,\n.location-teaser,\n.section-banner,\n.sol-content,\na[href^=\"https://zwinkr.de/landing/\"]",".addtop","td[width=\"730\"] + td[align=\"center\"]",".banner_rechts,\ndiv[style*=\"width:300px;height:250px;\"]","img[width=\"468\"][height=\"60\"]",".adserver-container1",".zusatz_billboard",".feature.no_border.pull-left.mb-md,\n.feature_column.pull-left.new_add",".avad1_widget",".anzeige_content,\n.inline_wrapper",".metaslider","img[width=\"640\"][height=\"165\"]",".bannerslot-centered",".article-adbanner","#media_image-31,\n#media_image-33,\n#media_image-34,\n#media_image-39,\n#media_image-41,\n#media_image-42,\n#tdi_67,\n#text-60,\n.media_image-19,\n.media_image-22,\n.media_image-23,\n.media_image-24,\n.media_image-26,\n.media_image-28,\n.media_image-29,\n.media_image-30,\n.media_image-32,\nimg[height=\"250\"],\nimg[width=\"700\"],\nimg[width=\"770\"]","div[class^=\"MoliAd_\"]","#container-sidebar-banners",".adlabel","#banner-floater,\n#block-anzeige2,\n#block-macgadget-anzeigen-3,\n#block-macgadget-textwerbunglinks1,\n#block-macgadget-verlosung",".productbox",".Content_1-minheight,\n.Content_3-minheight,\ndiv[class^=\"Billboard-\"],\ndiv[class^=\"Billboard_\"],\ndiv[class^=\"Rectangle_\"]","#leadfullWrapper",".top-products,\na[href^=\"http://www.verleihshop.de/index.html?partner=\"]","#bigsize-top",".spielseite_anz_2,\n.spielseite_kopf",".logo-footer-module",".core-commercial,\n.trf-billboardcontainer","a[class*=\"sponsoredProductCard\"]","#content-banner",".clsy-adv-item,\n.clsy-c-advsection","#container_fs,\n#container_left,\n#container_right","[data-test=\"mms-search-showcase\"]",".section-banner-fullwidth","#myspacerinner,\n#myspacerright,\n#wobra-suche,\n.ads_mobile,\n.span > .white_bg[style=\"width: 100%; padding-right: 5px;\"],\n.span.white_bg[style=\"padding: 7px 2px; margin-left: 5px;\"],\n.span[style=\"width: 160px; margin-left: 5px;\"]","li.article:has([data-type=\"sponsored\"]),\nsection.post:has([data-type=\"sponsored\"])",".marketing-wrapper","#gen_inside_mobile_wrapper,\n#gen_inside_wrapper,\n#gen_top_wrapper,\n#msg_leaderboard_1_mobile_wrapper,\n#native_desktop_wrapper,\n#native_mobile_wrapper",".banner-inline",".-dfp,\n.ms-adPlace","#portfolio",".shipment,\n.shipmentPremium","img[width=\"250\"]",".result:has(a[href^=\"https://metager.de/partner/r?\"]),\n.result:has(a[href^=\"https://r.search.yahoo.com/\"]),\na[href^=\"https://metager.de/partner/r?\"],\na[href^=\"https://r.search.yahoo.com/\"]",".sb","div[class^=\"contentAdBox_\"],\ndiv[class^=\"placeholderAdBox_\"]","img[width=\"180\"][height=\"120\"],\nimg[width=\"300\"][height=\"150\"],\nimg[width=\"400\"][height=\"100\"]","div[id^=\"moads-\"]",".infinite-post:has(.adsbygoogle)",".dsp-placeholder,\n.mN_WC:has([data-testid=\"sponsored-badge\"]),\n.srp-placeholder,\n.topresult + .dealerAd,\n.vip-placeholder,\ndiv[style=\"min-height:250px\"]:has(#SRP_BILLBOARD_ADSENSE)","#m_vip_slot_2,\n#m_vip_top",".ViD7S,\ndiv[data-testid^=\"SRP_SBANNER_\"],\ndiv[data-testid^=\"SRP_TABLECELL_\"]","a[data-eventcategory=\"Kooperation\"]",".grey-banner,\n.grey-banner-bottom","#bigsize_inner",".Common-Kn-Display,\n.Common-Kn-Rp-FlightInline","#anzeige",".main-preview:has(.anzeige-label),\n.mopo-ads-editor,\n.slider-preview:has(.anzeige-label)",".mcad_wrapper,\n.mcadblock,\ndiv[class^=\"morec-\"]",".tef-widget__ad-slot","#text-16,\n#text-33,\n#text-39,\n#text-41,\n#text-42","#print_bannergroup","#plista,\n.bannerInfo","#parent-adbox-superbanner",".bannerwrapper",".boxjob",".container.margin-bottom-40.fullwidth-container-mobile.min-280,\n.min-280.mr,\n.superad","#MTB_M_ROS_Sticky,\n#header,\n#header-banner-mobile,\n.header__banner,\n.mtbn-fotos-incontent__container--mobile,\n.mtbnews-forum__in-thread,\n.mtbnews-forum__mobile-top,\n.mtbnews-mobile-sticky,\n.mtbnews-top",".incontent__container","#freikarten","#abAside,\n.anzC",".anz","a[href^=\"https://popup.taboola.com/\"],\niframe[src*=\"//fom.bildungscentrum.de/\"]","#spion_content_container","#belowCommentsFuseZonePortal,\n#belowDescriptionFuseZonePortal,\n#belowDetailsFuseZonePortal,\n#mrec1FuseZonePortal,\n#mrec2FuseZonePortal,\n#productIncontent1FuseZonePortal,\n#productIncontent2FuseZonePortal","#toplists","a[href^=\"https://www6.smartadserver.com/\"] > img","#outofpageWrapper,\n#sb1Wrapper",".ems-slot,\n.topbanner-mobile",".adcontent","div[id^=\"gpt-\"]",".n2-section-smartslider,\nimg[width=\"240\"]","#Ads","#R1C2,\n#R1C3",".r-d045u9.r-1udh08x.r-bnwqim.css-1dbjc4n",".as-frame-center","#logobanner",".tdi_88","#Werbung",".cardealers,\na[class=\"placement\"]","#news_content_1,\n#news_content_2,\n#news_content_3,\n#news_header,\n.extraContentContainer,\n.halfpage,\n.ialayerContainer",".shopWidget","#div-header,\n#div-sidebar_right_extra,\n#sky-left-container,\n.al-amazon,\n.deals-ticker,\n.gptSlot,\n.jobbioapp,\n.np-product-offers,\n.np-top-deals,\n.top-deals-swiper","#text-11,\n#text-13,\n#text-21,\n#text-26,\n#text-35,\n#text-54,\nimg[width=\"330\"][height=\"220\"],\nimg[width=\"533\"]","#homeDisplay,\n.widget_dkge_wrapper","div[style=\"min-height:290px\"]","#page_billboard","#nordkurier\\.de_bb_1,\n#nordkurier\\.de_bb_2,\n#nordkurier\\.de_lb_1,\n#nordkurier\\.de_mr_1,\n#nordkurier\\.de_mr_2",".fp-ad-placeholder",".av-carousel,\n.av-fade-carousel",".nozmhn_ad,\ndiv[id^=\"nozmhn_ad_\"]","#banner_container_rc,\n#banner_left_container_lc",".ax-medium-rectangle-n",".webcam-premium,\na[href^=\"https://www.visit-x.net/de/w/chathost/?w=\"]",".anzeige + .slider,\n.anzeige + p",".swiper-container",".jrCardBanner","#msn-ads-top",".adv-indicator,\n.bnrad,\n.right-leaderboard,\n.top-leaderboard","#slot-banner,\n#slot-rectangle,\n#slot-sky",".panel-display > .panel-col-side > #block-views-website-block-1",".adDecoration,\ndiv[style=\"clear: both; min-height: 300px;\"],\ndiv[style=\"clear: both; min-height: 640px;\"],\ndiv[style=\"clear:both; display:block; min-height: 300px;\"],\ndiv[style=\"clear:both; display:block; min-height: 640px;\"]",".main-club-partner",".boxesBottom,\n.boxgenericBox41",".preisboxinner","#hbpartner-logo-container,\n.article-rectangle,\ndiv[class*=\"adplacement_\"]",".widget-aal-unit-by-id","#on-footer-banner,\n#on-rectangle,\n#on-sky,\n.inlinemod-item:has(.on-ad),\n.on-ad,\n.on-top-banner-wrapper","#SMART_BILLBOARD,\n.ANZEIGE,\n.BILLBOARD,\n.SKYSCRAPER,\n.TEASERBOX.DEPOT_KONTO,\n.advertisedFund,\n.flex-layout:has(div[class^=\"ArticleTeaser_ov-article-teaser__onvistaCustomer_\"]),\n.isSponsored,\n.ov-article-teaser:has(.ov-article-teaser__onvistaCustomer),\n.ov-interaction,\n.ov-interaction-slot,\n.ov-table-sponsored-row,\na[class*=\"ArticleTeaserBox\"][href^=\"https://bnpp.lk/\"],\na[class*=\"ArticleTeaserBox_ovArticleTeaserBoxDefaultHeight_\"],\na[href*=\"&adname=\"],\ndiv[class*=\"InteractionTypeReference_ov-interaction-slot--fallback\"],\ndiv[class=\"col col--sm-4 col--md-3 col--lg-4 col--xl-4\"]","#jsn-pos-user-top","#bigklick,\na[href*=\"/goto.php?\"]",".pdp_reco-sponsored,\n.product.spa,\narticle[data-producttile-tracking*=\"wk.san_ProductType\\\":\\\"sponsored\\\"\"]",".header-widget-inner",".ox",".paradiso-hp-ads-horizontal",".sidebar_a",".anzeigen",".affiliateBelowArticle",".afBtn1,\n.afBtn2,\n.at_sponsored",".box[data-ga-event-label=\"Angebote für PC-WELT Leser\"],\n.box[data-ga-event-label=\"Für Sie empfohlen\"],\n.box[data-ga-event-label=\"PC-WELT Specials\"],\n.idgAmazonTextV2,\n.marketplace,\na[href^=\"http://www.pcwelt.de/pv/\"],\na[href^=\"http://www.verleihshop.de/pwindex.html?partner=\"],\na[href^=\"https://get.surfshark.net/aff_c?\"],\na[href^=\"https://ndirect.ppro.de/\"],\na[href^=\"https://pvn.saturn.de/\"],\na[href^=\"https://tracking.s24.com/\"],\na[href^=\"https://www.tkqlhce.com/click-\"]","a[href^=\"https://www.awin1.com/cread.php?\"]","#oc24-direkt,\n#pedelecforum\\.de_mpu_bot",".fh-sidebar-top","img[width=\"370\"]",".Laddbox,\n.Laddbox300",".normalSponsor,\n.presenting","#block-17",".superbanner-frame",".post.type-post.status-publish:has(.anzeige-box)","div[class^=\"pictu-\"]","#sidebar_right > #HTML7,\n#sidebar_right > #HTML9",".clipad,\ndiv[style=\"float:right; width: 300px; height: 250px\"]","#omsRectangleChannel",".amazon","div[id^=\"playf-\"]",".nav-anzeige,\n.sidebar > .imglinks",".ts-sptag",".section:has(.ad-container)","#ad1","#ad2,\n#ad3","#custom_html-21,\n.sc-button[href^=\"https://amzn.to/\"],\n.sc-button[href^=\"https://www.amazon.de/\"],\ndiv[style=\"min-height: 280px;\"]",".asa2_ajax_container,\n.first-list > li:has(a[href^=\"https://bit.ly/\"]),\n.first-list > li:has(a[href^=\"https://ipn.idealo.de/ts/\"]),\n.first-list > li:has(a[href^=\"https://tracking.s24.com/\"]),\n.pd-teaser:has(a[href^=\"https://bit.ly/\"]),\n.prad-td-header-sp-recs,\n.second-list > li:has(a[href^=\"https://amzn.to/\"]),\n.second-list > li:has(a[href^=\"https://ipn.idealo.de/ts/\"]),\n.second-list > li:has(a[href^=\"https://tracking.s24.com/\"])","#header-image-js",".box.box-style1:has(.notice),\n.cms-cl_tariff-row--ad",".AFS_ADD","img[width=\"160\"][height=\"92\"]",".td-header-container",".excerpt-tile.cell:has(.advertorials)",".prinz-info--lb","#rp_rpd_bb","#rel-article","div[id^=\"profe-\"]",".adColumnTop,\n.ob-p,\n.onlyDesktop:has(div.adContainer)","div[data-url-link^=\"https://track-adspree.com/\"]","div[style=\"width:160px;height:600px;\"]",".nfy-banner",".h5v","#banneroben,\n#bannerrechts,\n#startrechts,\n.leistenbanner,\n.listenbannerlinks,\n.toplinks",".anz-content,\n.anz-grey-content,\n.anz-grey-title,\ndiv[style=\"width: 100%; height: 250px; overflow: hidden; text-align: center; padding-top: 10px;\"],\ndiv[style=\"width: 100%; height: 250px; overflow: hidden; text-align: center;\"],\ndiv[style=\"width: 100%; height: 260px; overflow: hidden; text-align: center; padding-top: 10px;\"],\ndiv[style=\"width: 100%; height: 90px; overflow: hidden; text-align: center;\"]",".stickyBanner-wrapper",".btn2,\n.rectright",".elementor-element-f3e9036","div[id^=\"oms_gpt_\"]",".tdi_29","div[id^=\"radio-\"]",".branchenberichte",".trikots",".header-main",".ad-component,\n.ad-slot-container",".adcolor,\n.sidestickycon300x600,\na[onclick^=\"setAdClick\"],\ndiv[style=\"float: right; width: 300px; height: 250px; margin: 0 10px 80px 30px;\"],\ndiv[style=\"height: 90px; margin: 30px 0 20px 0; text-align: center; width: 100%;\"],\ndiv[style=\"height: 90px; margin: 30px 0 30px 0; text-align: center; width: 100%;\"],\ndiv[style=\"text-align:center; min-height: 260px; height: 260px; margin: 0 auto 0 auto;\"]",".boxschattenbutton,\n.boxschattenbuttonw","img[class=\"bnr\"]",".superbanner_wrapper","#block-3",".wk-slideshow",".lb","iframe[src=\"/more\"]",".port.hi",".Banner--isAd","div[style=\"height: 600px !important; max-width: 320px; margin: 15px auto;\"]","div[style=\"height: 250px\"]","img[height=\"200\"][width=\"240\"]","li[data-content-type=\"ad\"]",".rs-ad-tag,\n.rs-superbanner","#flagship_productlist,\n.flagship-container,\n.search-service-product:has(.sponsoredBadge)","div[class*=\"Product_productSpecialTile\"]","#mso-dplusc-banner_1,\n#mso-dplusc-banner_2,\n#mso-dplusc-banner_5",".sidebar-addbox,\n.topanzeigen-slider-wrapper",".footer__slider",".articlebody__rectangle,\n.page__billboard",".vc_custom_1629451242127","#text-27","div[class^=\"Adstyled_\"]","#rollertuningpage\\.de_lb_1,\n#rollertuningpage\\.de_sitebar_1,\n#rollertuningpage\\.de_sitebar_2",".ad-mrec","#main-banner","#ir_rpd_lb","div[style=\"margin:40px 0 0 0; text-align:center;\"],\ndiv[style=\"margin:60px 0 0 0; text-align:center;\"]","#billboard_1,\n.adwrapper--mobile","div[data-adformat=\"halfpage\"],\ndiv[data-adformat=\"rectangle\"]","div[id^=\"gptslot-\"],\ndiv[id^=\"id-beep-slot-\"]","#bigsizebanner,\n#contentbanner",".dm-slot__skyContainer",".portal-slot","#dfp-banner,\n.article-box:has(> .article-box__text > .article-box__info > span.article-badge--ad),\n.article-fill:has(.article-badge.article-badge--ad),\n.footer__partner,\n.iqadtile-wrapper",".action-item > * > .ad",".custom_googleanzeige",".footer_sponsor_row",".footer-sponsors,\n.module-advertising","a[href^=\"/ad/\"]",".box.w300.h250.mb40","a[data-name=\"topbanner\"],\ndiv[id^=\"schlager-ad-\"]","a[href^=\"https://www.lead-alliance.net/tc.php\"]","div[style=\"height: 166px\"]",".dp-sponsorenfooter",".bg,\n.welcome","div[id^=\"seenl-\"]","#topb,\n.selbs-blog-startseite-und-kategorien,\n.selbs-unter-artikeln,\n.tad1","#Mod373,\n#Mod416,\n.fnet-banner,\n.gruenebox2","#crazyclownhint","#divBG,\n#logoFalken,\n#promobalken",".bannerWrap,\n.sponsors-col","div[style=\"margin: 30px 0px 30px 0px;padding: 10px; border-width: 2px; border-style: dashed; background-color: #f6f5f2;\"]",".bannerBox","#ad","#Mid,\n#anchorBG",".banner-container","[id^=\"fh-afp_\"]",".sdc-site-au__leaderboard,\n.sdc-site-au__mpu-1","#MEDMRECHome,\n#MEDMRECHome2Lazy,\n#MEDMRECHome3Lazy","#outer_SR_banner_ganz_unten,\n#outer_SR_rechner_banner_unter_rechner,\n#outer_SR_rechner_display_unter_rechner",".adp1,\n.advorp1,\n.titelad,\na[rel=\" noreferrer noopener sponsored nofollow\"]","div[id^=\"smart-\"]",".td-banner-wrap-full","#smsboxIframe","#banner_oben","#text-53,\n#text-56,\n.infeedthingy",".tile99-wrapper",".skycraper","a[href^=\"https://wgaffiliate.com/?a=\"]","#wallpaper-link",".banner-btf-side-rectangle",".parallax_link,\n.strack_cli",".ad-mark","div[class^=\"ada-preservespace-\"]",".abox",".s1-ad,\ndiv[data-testid=\"better-collective\"]",".dcm-section-wrapper","img[width=\"768\"][height=\"768\"]",".elementor-element-127b96a","div[style=\"padding:5px 0 5px 0;\"][align=\"center\"]","#sponsorenleiste",".psw-container,\na[href^=\"https://www.communicationads.net/tc.php?\"],\nimg[data-image-title=\"amazonAktion\"]",".adserver,\nimg[width=\"728\"]",".smartmag-widget-codes",".ad-element","#colLeft > #info,\n#colRight > #search",".bb-wrap",".banner_bigsize_unten,\n.banner_content,\n.banner_sky","div[style=\"width: 468px;height: 60px;overflow: hidden;float: right\"]","#ston-billboard","div[data-adv-location]",".m-weekli","#slider,\n#taboola-mhsd,\n.mod-weekli",".iqad,\na[href^=\"https://cmk.sueddeutsche.de/cms/hub/\"][href*=\"/anzeige/\"]",".iqdcontainer",".angebot-der-woche-slider","#text-8",".tracking_trigger",".gpevxonqc",".swp-adbox,\n.u-adSlot:not(.u-adSlot--sky-left):not(.u-adSlot--sky-right)","#T-85628670,\n#T-86926496,\n#T-Shopping,\n#T-shoppingbox,\n#Tasfeed1,\n#Tasfeed3,\n#Tcontboxi + #Tgboxf,\n#Tlibelle,\n#ma_mrec,\n#vmsky,\n.Tadc,\n.Tgbox--anz,\n.Tgbox--blau,\n.Thh5Thide4PUR,\n.Thide4PUR,\n.Tprtnrmobilesib,\n.Tshlogobox,\n.Tsshopst2 + .Tmm,\n.med_anz,\n.toi-sh-breaker,\na[data-url^=\"https://count.shopping.t-online.de/RE?ID=\"],\na[href=\"https://gebrauchtwagen-suche.t-online.de/marke-skoda/modell-superb\"],\na[href^=\"http://count.shopping.t-online.de/RE?ID=\"],\na[href^=\"https://count.shopping.t-online.de/RE?ID=\"],\ndiv[class^=\"Tsshopst\"],\ndiv[data-dy*=\"Partner:\"],\ndiv[id^=\"T-\"].Tmm.Tltb.Tts.Tmc1.Tww1.Thh3[onfocus^=\"A('zid=\"] > .Ttsc.Ttsv169,\ndiv[id^=\"T-\"][oncontextmenu=\"return false\"],\ndiv[id^=\"ma_ar\"],\ndiv[id^=\"mrec\"],\nimg[alt^=\"Modetrends\"],\nimg[width=\"920\"][usemap^=\"#immap\"]","#advertMarkerHorizontalContainer,\n.css-1gm9xpz,\n.css-1lb3bt5,\n.css-2k2lok,\n.py-16.bg-alpine.border-b.border-solid.border-whitelilac.md\\:min-w-page,\n.py-16.md\\:py-24.border-solid.border-whitelilac.text-trout.leading-17.md\\:hidden,\n.tMRM_billiger,\n[data-commercial-format],\naside[data-testid=\"StageLayout.StreamItem\"],\ndiv[class^=\"adContainer\"],\ndiv[data-component=\"CommercialNativendo\"],\ndiv[data-external-sdi-mark=\"banner-placeholder\"],\ndiv[data-testid=\"Stage.Companion.Commercial\"],\ndiv[data-testid=\"TaboolaFeeds.Feed\"],\ndiv[data-testid^=\"Nativendo.ArticleFeed\"],\ndiv[id^=\"nativendo\"],\niframe[title=\"Top Partner\"] + span,\nsection[data-stage-layout^=\"custom_nativendo_\"]",".mailAdElem","#tMRM_amazon,\n#tMRM_billiger,\n#tpctop",".c-ad-container,\n.c-ad__container-p1,\n.tg-articletype-sponsored-deal.c-pin,\n.tg-articletype-sponsored-post,\n.tg-stage-sponsoredcontent",".hcf-news-aktuell",".jobunion-container",".pub-footer,\n.pub-single-side",".commercial",".ce_promotionbox",".heise-ad-element-wrapper","#enhancedtextwidget-11,\n#enhancedtextwidget-12,\n.td_11","#lb_header","#LxShop,\n#LxTN2ADV,\n#LxTNADV,\n#SpaceBefore,\n#SpaceRectangle,\n#SpaceTgtLink,\n#ttParallaxcontainer,\n#ttTarifTable,\ndiv[id^=\"LxIdealo\"],\ndiv[id^=\"ideaload\"],\ndiv[id^=\"tarifSlider\"]","#footer-partner,\n.header-logo-second-display","#after-header-banner","#banner-left-1,\n#banner-left-2,\n#banner-right-1,\n#banner-right-2",".logos","#amazon_300x90,\n#openx_LB,\n#petsexpert","div[id^=\"tipps-\"]",".hotelempfehlung",".bannergroupimgframe","#text-19","#advleft1,\n#advleft2,\n#advleft3,\n#advleft4,\n#advlrb1",".support-box","div[id^=\"netse-\"]",".page-sponsoring",".content-teaser-small,\n.contentRefsAside",".fh-sidebar.block > .block-container",".print\\:hidden.justify-center.items-center.mx-auto.min-h-\\[205px\\].max-\\[330px\\]\\:hidden.relative.min-\\[330px\\]\\:grid.min-\\[330px\\]\\:w-\\[300px\\].min-\\[366px\\]\\:min-h-\\[250px\\].min-\\[366px\\]\\:w-\\[336px\\].min-\\[780px\\]\\:min-h-\\[90px\\].min-\\[780px\\]\\:w-\\[720px\\].min-\\[1020px\\]\\:min-h-\\[250px\\].min-\\[1020px\\]\\:w-\\[960px\\].min-\\[1030px\\]\\:w-\\[970px\\].md\\:mb-10.col-span-full.max-md\\:order-3,\n.print\\:hidden.justify-center.items-center.mx-auto.min-h-\\[205px\\].max-\\[330px\\]\\:hidden.relative.min-\\[330px\\]\\:grid.min-\\[330px\\]\\:w-\\[300px\\].min-\\[366px\\]\\:min-h-\\[250px\\].min-\\[366px\\]\\:w-\\[336px\\].min-\\[780px\\]\\:min-h-\\[90px\\].min-\\[780px\\]\\:w-\\[720px\\].min-\\[1020px\\]\\:min-h-\\[250px\\].min-\\[1020px\\]\\:w-\\[960px\\].min-\\[1030px\\]\\:w-\\[970px\\].order-2.md\\:order-1.md\\:col-span-full",".OUTBRAIN .ob-p","div.has-mark[style=\"min-width: 300px; min-height: 250px;\"]","#bottom-blocks,\n.rectangle-right",".bscb-23811,\n.irypolkj,\n.zekfylmnsq",".tritime-ads-middle",".first_slot,\n.second_slot",".sponsors-slider",".sponsorftr","ins[style*=\"width: 300px; height: 250px;\"]",".stream-item-widget","#g-expanded,\n#g-header","#tvd-ad-top",".cont-60","#rightCont",".floatLeft[style=\"padding:10px;\"]",".button.affiliate,\n.promo-box,\n.promo-box-any-banner",".tfm-banner",".tvg-manager-box","a[href^=\"https://www.tweakpc.de/rev3/www/delivery/\"]",".chemical_sitelogo_r","table[style=\"background-color: none; border-top: 1px dashed; border-color: #a89058; border-left: 1px dashed; border-color: #a89058; border-right: 1px dashed; border-color: #a89058; border-bottom: 1px dashed; border-color: #a89058;\"]","#custom_html-107,\n#custom_html-110,\n#custom_html-77,\n#custom_html-88,\n#custom_html-95,\n#custom_html-97,\n.flexslider,\na[href^=\"https://www.amazon.\"][href*=\"tag=\"] > img","#fh-div,\n#shuffled-item,\n#shuffled-sponsored,\n#sidebar_container,\n#ufa-top",".ads-336,\n.b_top","#wrapper-banner-head",".mh-footer","#revista-de-viajes_contentAd_container,\n.uniq-ads","#native_ads2,\n.channel-logo-desc","#bjorn-text-20,\n#bjorn-text-22,\n#bjorn-text-24",".vm-banner",".header-right",".vc_custom_1544363997968,\nimg[width=\"110\"]","#sponsor-footer",".partners-footer","#text-9,\n.YouTubeDachstein,\n.YouTubeLEKI,\n.YouTubeoetz,\ndiv[class^=\"overlay-\"]","#skypos,\n.rcu,\n.rec",".vip-medium-rectangle,\n.vip-teaser","kas[type=\"placement\"]","a[href*=\"https://vflive.de/lotto24_desktop300x250-home\"] > .card-promo","#partnerLinks","div[id^=\"findexp-\"]","#bannerContainer,\n.sliderContainer","#dban3,\n#dcb1,\n#dcb2,\n#derivativecockpit,\n#dout1,\n#fullsizeBanner1,\n#kosocgen,\n#mooTicker,\n#mooTickerContainerMobile,\n#newsDesktopFlag,\n#siteteaser,\n.breakingNewsOfferteBox:has(span.offerteFlag),\n.lynxAds,\n.newsFlagSlider,\n.partnerNews > a[target=\"_blank\"],\n.sb_popularleverageproducts,\n.sb_quotebox,\n.sbteaser:has(span.generalAdTag),\n.shareInFocus,\n.shareTodayBox,\n.similarNews:has(span[title=\"Anzeige\"]),\n.teaser.objectfit:has(div.angebot),\n.teaser.objectfit:has(div.anzeige),\n.teaser:has(span.generalAdTag),\na[href^=\"https://smartbroker.de/\"][href*=\"/?utm_\"],\na[href^=\"https://smartbroker.de/?utm_source=\"],\na[href^=\"https://www.etracker.de/ccr?\"],\na[onclick*=\"'tableAd'\"],\na[onclick*=\"'tableAd'\"] + img,\na[onclick*=\"tableAd\"] + span,\ndiv[id^=\"nativendo-\"],\ntr:has(td > .float-end > span[title=\"Anzeige\"])",".lefthellwetter,\n.stimm-widget,\ndiv[id^=\"stimm-\"]",".teaserheld-wrapper","#ads","#service-middle,\n.iba-variant-test,\n.partner-links,\ndiv[data-adservice-slot],\ntr[data-component=\"MessageListAdRow\"]","#addmeright,\n#addmetop","#weekli-interstitial",".c-inline-teaser__body.c-inline-teaser__body--is-standalone:has(a[href^=\"https://www.financeads.net/tc.php?\"]),\ndiv[data-ad]","aside[id^=\"banner\"],\ndiv[style*=\"display: block ! important\"],\ndiv[style=\"position:absolute; top:5px; left:0px; text-align:center; width:100%; max-width:1000px; height:90px; overflow:hidden;\"]","div[x-data=\"modules.ad()\"],\ndiv[x-data=\"modules.ad()\"] + span,\ndiv[x-data^=\"modules.adMedia\"]",".guj-ad-slot","table[width=\"738\"][height=\"90\"]","#woFooterBillboard",".clicked_partner","#SP-commercials",".astra-advanced-hook-67722,\ndiv[id^=\"mixena-\"]","#text-html-widget-15","#block-views-sponsoredcontent-block,\n#block-views-sponsoredpromo-block,\n#p3wrapper,\n.content_before_3rd_para,\n.paid,\n.paidc,\n.spost,\n.sppost,\n.view-idcontent:has(a[href^=\"/sponsored/\"]),\narticle.node-teaser:not(.node-promoted),\ndiv[id^=\"gWrapper-\"],\ndiv[style]:has(a[onclick]),\niframe[style=\"height:250px;overflow: hidden;\"],\nsection#block-viewscontent-block","#g_content_recommendation,\n#homepage_rectangle,\n#wfv4_bb2_lazyload[style=\"min-height:250px\"],\n.amazon_widget_w660,\n.mb25[style=\"min-height:261px\"],\n.news330.floatL.mr10:has(.anzeige),\n.ob_what,\n.primis_widget,\n.rutschdiv,\na[href^=\"https://ndirect.ppro.de/click/\"],\na[href^=\"https://winfutu.re/trvisa\"],\ndiv[align=\"center\"][style=\"min-height: 320px;\"],\ndiv[class^=\"ws_contentAd\"],\ndiv[style=\"margin: 10px 0px; text-align: center; min-width: 300px; min-height: 250px;\"],\ndiv[style=\"margin: 3px 0px; text-align: center; min-width: 300px; min-height: 250px;\"],\ndiv[style=\"min-width: 300px; min-height: 250px;\"],\ndiv[style=\"width:670px;height:280px;\"]",".wf_gcsi","#topads","img[width=\"140\"][height=\"180\"]",".block-wissen-ads,\n.node-promoted","#naMediaAd_MR_WRAPPER",".mod-adslot",".code-block-13",".client_wrapper",".amazon-search",".widget__image--banner",".logo-slider","#outerBoxStart",".box_banner-container",".vc_custom_1623308998554",".sa2,\n.sa2_top",".spielen_kopf",".show-banner,\n.show-block","#offer","div[id^=\"aktue-\"]",".zett-teaser-trio:has(.zett-teaser-trio__kicker--ad-anzeige)","#slot__header,\n.products-inarticle-slider--parent",".logo_rechts_mitte",".witz > .bewertung + .detaillink + p:last-child,\n.witz > .bewertung + p:last-child","#block-block-14,\n#footer-banner-frame",".topRight300x250",".component-code-snippet","#custom_html-22","#_mo_cti,\n._mo_recs,\n.no-baldomero,\n.publi_cabecera_270,\n.publi_mega",".externalURL",".oc24-sidebar","#dish-top-desktop","#media_image-23",".support_banner_lead",".buy","#sidebar-sponsor,\n.widget-list-sponsors","#sponsors-tablet,\n.sponsors-desktop",".hirdetes","img[style=\"width:270px;height:80px;\"],\nimg[style=\"width:700px;height:90px;\"]","#nav_menu-2",".r","a[href^=\"https://media.campartner.com/\"],\na[href^=\"https://vxcsh.com/\"],\na[href^=\"https://www.big7.com/\"]",".sidebar","#spezial_column","#text-12","#BelowRectangle",".happy-player-beside","div[class^=\"runds-werbung-\"]",".owl-carousel","#custom_html-121,\n#custom_html-126,\n#custom_html-127,\n#custom_html-132,\n#custom_html-143,\n#custom_html-144,\n#custom_html-145,\n#desktop_understitial,\n#halfpage,\n#media_image-10,\n#rectangle,\n#top_0,\na[href*=\".rokkr.net/promo/\"],\na[href*=\"/hide.me/de/?friend=\"],\na[href*=\"/prf.hn/click/\"],\na[href*=\"?sca_ref=\"],\na[href^=\" https://www.bit.ly/\"],\na[href^=\"https://hide.me/de/promotion/\"],\ndiv[style=\"width:300px;height:250px\"]",".dfp-skyscraper",".dt",".supporter",".widget_random_banner_widget,\ndiv[id^=\"buong-\"]",".page-banner",".articles-pr-box,\n.bxslider,\n.partvert,\n.partvert-right","a[id=\"bottombanner\"]",".mainSponsor,\n.sportnews",".widget_sp_image",".werb",".sponsorslider",".qodef-e-logo > img[height=\"80\"]",".w-header,\ndiv[class^=\"AdSuperBanner_\"],\ndiv[class^=\"AdUnit_\"]",".add","a[href^=\"https://www.raiffeisen.it/\"]",".pr",".trauerhilfe_ads",".slideshowck",".divAdd_Banner",".custom-ban-wrap","#header-wrapper + div[class=\"row \"],\n.ad-listing,\narticle[id^=\"post-\"]:has(.sponsored-indicator)","[class*=\"use-theme-class_sponsored_\"],\ndiv[class^=\"ad-element_\"]",".az-adverts,\naside:has(img[src*=\"/adverts/\"])",".banPlace1,\n.banner_sidebar",".mdhRegister-btn","#head_banner,\n#pis_posts_in_sidebar-6,\n#widget_sp_image-14","#fcnbox,\n#nwmlay","#superreplacement","a[href^=\"https://www.banggood.com/marketing-\"]","#topBanner","#forumbanner","#dnvsuperbanner","#adunit",".commercialbar,\n.top_bannerbar",".elementor-element-1f0334b,\n.elementor-element-5edce23,\n.elementor-element-6c8f458,\n.elementor-element-8419f6d","#billboard_btf_2,\n#footer-ad,\n#ishares_etf_variation,\n#news-contentads,\n#sticky-superbanner,\n#ubs-banner-fallback,\n.adsbygoogle,\n.cpg_incontent1-container,\n.cpg_incontent2-container,\n.mleft-10 + .table-quotes,\n.mrec-height-prefix,\n.row.d-flex.align-items-center:has(a[href^=\"http://g.finanzen.net/allvest-fonds-home-intelligent-invest\"]),\n.snapshot__trading:has(.button-advertising-hint),\n.sticky__container--mrec,\na[href=\"#p500Werbehinweis\"],\na[href=\"http://g.finanzen.net/ubs-aktiendetail-hebel-fallback\"],\na[href^=\"http://g.finanzen.net/bs-anlegerclub\"],\na[href^=\"http://g.finanzen.net/hsbc-startseite-top-flop?id=\"],\na[href^=\"http://g.finanzen.net/premium-teaser-bnp\"],\na[href^=\"https://ad.doubleclick.net/\"],\narticle.page-content__item:has(img[alt=\"UBS\"]),\nimg[alt=\"Passende Produkte von Vontobel\"],\nimg[alt=\"Passende Produkte von der Société Générale\"],\nimg[alt=\"Vontobel Banner\"]","#nab_container","#ai_widget-5,\n#text-6","._bb_1,\n._gartenjournal_billboard,\n._gartenjournal_inarticle_2,\n._gartenjournal_leaderboard_oben,\n._gartenjournal_leaderboard_unten,\n.adinj",".atkp-container",".pane-dpipub-rossel-imu-middle-moblile,\n.pane-dpipub-rossel-native-top,\ndiv[class^=\"pane-dpipub-\"]",".AdSticky",".rectangles-row","#page-header + br + .forabg",".itd-ad-sidebar","div[style^=\"width:300px;height:250px;\"]",".content-main-box-300x250,\n.content-main-box-728x90,\n.content-right-box-300x250right","#ad_ic_1,\n#ad_ic_2",".netpoint",".noprint > div[style] + div[style] > script:first-child + div[style]:last-child",".gstsk,\n.gxt_banner,\n.gxt_feed","td:nth-of-type(3):not(:last-of-type) table[width^=\"3\"]","#as2931,\n.pi-banner,\na[href^=\"https://www.fincabayano.net/\"]","a[href^=\"//wixnm.com/\"]",".video-side-adds","#aside_left,\n#top_ga,\n#wraptt,\n.double-wrapper,\n.funbox",".code-block-1,\n.code-block-12,\n.code-block-14,\n.code-block-h-250px,\n.code-block-h-300px,\ndiv[style=\"height: 300px;\"]",".code-block-7","#catfad","#wa_join_btn,\na[href^=\"http://www.livestrip.com/FreeAccountLanding.aspx?\"]","#subheader","#Layer1,\n#Layer2",".header-promo","#banners,\ndiv[style=\"float:right; width: 110px; margin-left: 15px; margin-top: 12px; margin-bottom: 15px; padding: 2px 6px; text-align: center; border: 1px solid black; background:white; line-height: 2em; color: black;\"]",".widget_atkp_widget","img[height=\"90\"]","a[href^=\"http://camgirly.net\"]","#centcon-side-inner",".elementor-element-1266dd4,\n.elementor-element-41d9f5c,\n.elementor-element-4330702,\n.elementor-element-6b9ddea,\n.elementor-element-ef8547e,\na[href^=\"https://tentorium.tv/\"],\nimg[width=\"587\"][height=\"562\"],\nimg[width=\"600\"][height=\"550\"]","a[href*=\"/b1a8/\"]","#leaderwidget,\n.skycontent",".googlediv",".adb",".zitat > div[style=\"width:300px;\"]",".e_adv","div[id^=\"modifiedwerbung_\"]","div[style=\"height: 280px; margin: 5px 0 5px 0;\"]","#ny_banner,\n#nyba,\n#nybanner,\n#nydus_org_970x300_billboard_responsive,\n#right160x600,\n#stickyaside,\n.googl,\n.recommend,\n.right > .widgetbox2,\ndiv.ui-tabs:has(#nydus_org_300x600_desktop_1),\ndiv:has(> #nydus_org_970x300_billboard_responsive),\ndiv[id^=\"nydus_org_300x600_\"],\ndiv[style=\"height:90px;overflow:hidden;text-align:center;\"],\ndiv[style=\"overflow:hidden;border: 1px solid #ccc;background:#f7f7f7;border-radius:3px;\"]","a[href=\"http://topne.ws/onlineoutlet\"]","#parcello-mo","#wn-insurance-quote-editor","#gad-sky,\n#gads-leaderboard,\n.pane-aktuelle-top-links",".zenoLSInnerProductTableRightAmazon","#custom_post_widget-6","#premium-partners",".hallo-inhalt_2","div[id^=\"edit\"][style=\"padding:0px 0px 6px 0px\"] > table[id^=\"post\"][width=\"100%\"][cellspacing=\"0\"][cellpadding=\"6\"][border=\"0\"][align=\"center\"] + br + .tborder[width=\"100%\"][cellspacing=\"0\"][cellpadding=\"6\"][border=\"0\"][align=\"center\"]",".d_695692","a[href^=\"http://filestore.to/premium\"]",".Banner","#selfpromotionOverlay",".d_702192",".dl2019main,\n.top2019main","a[href*=\"/af.php\"]",".code-block-3[style],\n.code-block:has(i.fa-cloud-download-alt),\n.post_content .btn,\na[href^=\"https://ibooks.to/del\"],\na[href^=\"https://ibooks.to/smmland/\"],\nbutton[type=\"submit\"],\nform[method=\"get\"][action]:not([role=\"search\"]),\nimg[alt=\"Download kostenlos\"],\nimg[alt=\"Kostenlos Download\"],\nimg[title=\"Usenet\"]","a[href^=\"//fbmedia-ckl.com/\"]","#ni-overlay","a[href^=\"https://lp.mydirtyhobby.com/\"]",".d_702212",".top_news_adv",".fixed.bottom-0.pb-8",".falken-banner,\n.view-type-falken","#fullbanner2,\n.sdtv-gothaer,\napp-top-banner","a[href^=\"https://hoerbuch.us/dll/\"],\na[href^=\"https://linksnappy.com/?ref=\"],\na[href^=\"https://www.purevpn.com/?aff=\"],\na[href^=\"https://www.purevpn.com?aff=\"]","#block-anzeige,\n.region-topad","a[href^=\"//plx.hammerporno.xxx/pool_link/\"]","#unten_anzeigen"];

const hostnamesMap = new Map([["190.115.18.20",0],["aniworld.to",0],["s.to",0],["1000ps.at",[1,2,3,4]],["1000ps.ch",[1,4,108]],["1000ps.de",[1,3,4,434]],["bild.de",[1,556,557]],["bz-berlin.de",[1,540,556,559,592,596,597,598,599]],["ffn.de",1],["firmenwissen.de",[1,539]],["fussballdaten.de",[1,197,539,791]],["golem.de",[1,503,826]],["hcinnsbruck.at",4],["veu-feldkirch.at",4],["fc-suedtirol.com",[4,286]],["hcpustertal.com",4],["eulen-ludwigshafen.de",4],["fck.de",4],["hc-erlangen-ev.de",[4,865]],["hsc-bad-neustadt.de",4],["ibash.de",[4,889]],["plattentests.de",[4,1098]],["broncos.it",[4,1378]],["electrive.net",4],["99ers.at",5],["ahgz.at",6],["packaktuell.ch",6],["umweltwirtschaft.com",6],["abzonline.de",6],["agrarzeitung.de",6],["ahgz.de",6],["coating-converting.de",6],["fibers-in-process.de",6],["fleischwirtschaft.de",6],["praxistipps.focus.de",[6,614,769]],["food-service.de",6],["fvw.de",6],["ma-report.de",6],["packreport.de",6],["finanzfrage.net",6],["gutefrage.net",[6,1417]],["horizont.net",6],["textiletechnology.net",6],["altertuemliches.at",7],["arboe.at",8],["austriansoccerboard.at",9],["autoline24.at",10],["autoline24.ch",10],["autoline.de",10],["autorevue.at",11],["pocketpc.ch",[11,189]],["nachbelichtet.com",[11,340]],["4kfilme.de",[11,448]],["abenteuerfreundschaft.de",11],["appgefahren.de",11],["automatentest.de",[11,514]],["gameswirtschaft.de",[11,657,805]],["gebrauchtwagenberater.de",[11,811]],["googlewatchblog.de",[11,383,830]],["kabel-blog.de",11],["medienkuh.de",11],["nat-games.de",11],["stadt-bremerhaven.de",[11,339,1217]],["technikshavo.de",11],["justnetwork.eu",11],["gartenjournal.net",[11,1414]],["autoscout24.at",12],["autoscout24.de",12],["badenerzeitung.at",13],["bauernzeitung.at",[14,15]],["marktindex.ch",[14,177]],["krautundrueben.de",[14,623]],["lokalo.de",[14,867,970]],["boxverband.at",16],["buzzfeed.at",17],["costanachrichten.com",[17,270]],["24auto.de",17],["24books.de",17],["24garten.de",17],["24rhein.de",17],["24royal.de",17],["24vita.de",17],["az-online.de",17],["bgland24.de",17],["buzzfeed.de",[17,595]],["bw24.de",17],["chiemgau24.de",17],["come-on.de",[17,618]],["einfach-tasty.de",17],["fnp.de",[17,618]],["fr.de",[17,618]],["giessener-allgemeine.de",17],["giessener-anzeiger.de",17],["hallo-muenchen.de",17],["hna.de",17],["ingame.de",17],["innsalzach24.de",17],["kreis-anzeiger.de",17],["kreiszeitung.de",17],["landtiere.de",17],["lauterbacher-anzeiger.de",17],["mangfall24.de",17],["merkur.de",[17,618]],["rosenheim24.de",17],["sauerlandkurier.de",17],["schwaebische-post.de",17],["soester-anzeiger.de",[17,618]],["tz.de",[17,618]],["usinger-anzeiger.de",17],["wa.de",[17,618]],["wasserburg24.de",17],["wetterauer-zeitung.de",17],["bvz.at",18],["noen.at",18],["tellows.at",18],["icasa.ch",18],["nau.ch",[18,183]],["tachles.ch",18],["tellows.ch",18],["architektenwelt.com",18],["boote-exclusiv.com",18],["modell-fahrzeug.com",18],["online-webradio.com",[18,347]],["tennisnet.com",[18,409]],["vogue.com",18],["abendblatt.de",[18,142,453]],["ak-kurier.de",[18,463,464]],["azonline.de",18],["beruhmte-zitate.de",18],["bike-magazin.de",18],["bildderfrau.de",18],["chefkoch.de",[18,207,611]],["dastelefonbuch.de",[18,540,639,640]],["dwdl.de",18],["eatsmarter.de",[18,685,686]],["echo-online.de",18],["erf.de",[18,158]],["esslinger-zeitung.de",18],["eurosport.de",18],["futurezone.de",[18,793,794]],["gq-magazin.de",18],["hamburg.de",18],["idowa.de",[18,891]],["imtest.de",[18,793,896]],["ingenieur.de",18],["juedische-allgemeine.de",[18,916]],["klassikradio.de",[18,938]],["lahrer-zeitung.de",18],["macwelt.de",[18,977,978]],["modhoster.de",[18,29,197,903,1009]],["mybike-magazin.de",18],["netzwelt.de",18],["paradisi.de",18],["pcwelt.de",[18,91,335,348,768,977,1084,1085]],["pfaffenhofen-today.de",[18,29]],["primavera24.de",[18,370,1111]],["schwarzwaelder-bote.de",[18,533]],["selbermachen.de",18],["spektrum.de",[18,1202]],["stadtradio-goettingen.de",18],["stuttgarter-nachrichten.de",[18,533,1227]],["sueddeutsche.de",[18,184,559,592,593,1229,1230]],["sup-mag.de",18],["surf-magazin.de",18],["tellows.de",[18,1248]],["tour-magazin.de",[18,1262]],["vfb.de",[18,496]],["wallstreet-online.de",[18,753,1244,1308]],["web.de",[18,155,439,440,1311,1312]],["webwiki.de",[18,84,1313]],["wissen.de",[18,879,1330]],["wmn.de",18],["wn.de",[18,1244]],["yacht.de",18],["zeit.de",[18,58,184,1346]],["mallorcazeitung.es",[18,1354]],["bos-fahrzeuge.info",18],["leckerschmecker.me",[18,416,793]],["gmx.net",[18,155,439,440,1312]],["adz.ro",18],["mann.tv",18],["city23.at",19],["donnerwetter.at",[20,21]],["donnerwetter.ch",[20,21]],["all-in.de",[20,469]],["donnerwetter.de",[20,21]],["dvd-forum.at",22],["economyaustria.at",23],["ecvsv.at",24],["ehc-lustenau.at",25],["erotikforum.at",26],["falter.at",27],["fitundgesund.at",28],["ichkoche.at",[28,36]],["metal-hammer.de",[28,348,593,599]],["flugblattangebote.at",29],["regionews.at",29],["6navi.ch",[29,112]],["m.gota.ch",29],["jobagent.ch",29],["sexnews.ch",29],["3gewinntspiele.com",29],["akustik-gitarre.com",29],["bankkaufmann.com",[29,253]],["deavita.com",29],["knobelspiele.com",29],["melodieundrhythmus.com",[29,330]],["spieleklassiker.com",29],["1001spiele.de",29],["buchmarkt.de",29],["fruchtportal.de",[29,48,567,784]],["goldseiten.de",29],["juve.de",[29,919]],["kartenspielen.de",29],["komoedie-steinstrasse.de",29],["kradblatt.de",29],["laufen.de",29],["macerkopf.de",29],["mein-wahres-ich.de",[29,993]],["nordicsports.de",29],["pixelio.de",[29,1096]],["prospektangebote.de",29],["psi-magazin.de",29],["rockland.de",29],["salue.de",[29,1170]],["snanews.de",29],["suedtirol.de",[29,1231]],["svs1916.de",29],["urlaubsguru.de",[29,1292]],["wimmelbildspiele.de",29],["fussballgucken.info",29],["hcb.net",29],["anixehd.tv",29],["fotoobjektiv.at",30],["meinbezirk.at",[30,51]],["eishockey-online.com",30],["nacktefoto.com",[30,341]],["basicthinking.de",[30,95,522]],["buecher-magazin.de",[30,347,585]],["eishockey-magazin.de",[30,698]],["iplayapps.de",[30,142,909]],["radforum.de",[30,243]],["radio-oldtimer.de",30],["radioschwaben.de",[30,1128]],["silentworld.eu",[30,848]],["tarnkappe.info",[30,47,142,1375]],["radiotirol.it",30],["suedtirol1.it",30],["hockeyreport.net",30],["pi-news.net",[30,91,230,1428]],["furche.at",31],["futurezone.at",32],["journalonko.de",32],["kress.de",[32,787]],["promiflash.de",[32,1117]],["gruen-weiss.at",33],["gutekueche.at",34],["gutekueche.de",34],["heute.at",35],["kitzanzeiger.at",37],["kleinezeitung.at",38],["kochrezepte.at",39],["kremser-sc.at",[40,41,42,43]],["americaurlaub.de",[40,477]],["pressecop24.com",[41,367]],["africa-positive.de",[41,76,461]],["golfmagazin.de",[41,828]],["synmag.de",41],["sgleutershausen.de",43],["kt1.at",44],["laola1.at",45],["ligaportal.at",[46,47,48]],["baupool.com",47],["bundesliga.com",47],["motorsport-total.com",[47,333]],["fnweb.de",47],["formel1.de",[47,771]],["laborjournal.de",[47,955]],["linux-community.de",[47,580]],["linux-magazin.de",[47,580]],["mannheimer-morgen.de",[47,982]],["traktorpool.de",[47,1265]],["winfuture.de",[47,1326]],["rheintaler.ch",[48,197]],["11freunde.de",[48,436]],["amazona.de",[48,476]],["charivari.de",[48,609]],["dialo.de",48],["dynamo-dresden.de",[48,683]],["jetztspielen.de",[48,915]],["spielen.de",[48,580,751]],["maschinensucher.at",49],["maschinensucher.ch",49],["maschinensucher.de",49],["mediamarkt.at",50],["mediamarkt.de",[50,987]],["saturn.de",50],["nachrichten.at",52],["naturundtherapie.at",53],["osttirol-online.at",53],["kajak-magazin.com",53],["112-magazin.de",[53,153]],["highway-magazin.de",[53,157]],["kl-aktuell.de",53],["loz-news.de",53],["mef-line.de",53],["motorradundreisen.de",[53,1016]],["pc-experience.de",53],["radio-oberland.de",53],["sonic-seducer.de",[53,1200]],["speyer-report.de",53],["spielbox.de",53],["tvbb.de",53],["vorsprung-online.de",53],["bassprofessor.info",53],["hitradio.com.na",53],["griechenland.net",53],["hifistatement.net",[53,1418]],["teneriffa-heute.net",53],["tennistraveller.net",53],["wahrschauer.net",53],["notebookforum.at",[54,55]],["mercedes-forum.com",[54,55]],["vermieter-forum.com",[54,55,417]],["1erforum.de",[54,55]],["bauexpertenforum.de",[54,55,525,526]],["dasheimwerkerforum.de",[54,55]],["elektrikforen.de",[54,417,525,700]],["fitness-foren.de",[54,55]],["lpgforum.de",[54,55]],["megane-board.de",[54,55,525]],["pkw-forum.de",[54,55]],["skodacommunity.de",[54,55,376,441,510,511,1192]],["toyota-forum.de",[54,55,376,441,442,510,1087,1264]],["mazda-forum.info",[54,55,1371]],["windows-7-forum.net",[54,55,525]],["nunu.at",56],["oe24.at",57],["oefb.at",[58,59]],["polizei-nachrichten.at",60],["beautytipps.ch",60],["business24.ch",60],["denkmalpflege-schweiz.ch",[60,134]],["events24.ch",60],["gourmetnews.ch",60],["moebeltipps.ch",60],["motortipps.ch",60],["reiseziele.ch",[60,134,196]],["atv-quad-magazin.com",60],["it-production.com",[60,313,314]],["pool-magazin.com",60],["umzugstipps.com",60],["verkaufsoffener-sonntag.com",60],["celler-presse.de",[60,606]],["haie.de",[60,839]],["hansa-online.de",[60,230,852]],["hifi-today.de",60],["islamiq.de",60],["jungefreiheit.de",[60,917]],["lite-magazin.de",[60,966]],["oldenburger-onlinezeitung.de",60],["oscar-am-freitag.de",[60,230]],["radio-aktiv.de",[60,513]],["rechtsdepesche.de",[60,356]],["skipper-bootshandel.de",[60,1191]],["stadt-nachrichten.de",60],["unternehmermagazin.de",60],["via-ferrata.de",[60,122,339,356,1232,1300]],["werne-plus.de",60],["wir-leben-outdoor.de",60],["docma.info",60],["swz.it",[60,1391]],["betriebseinrichtung.net",60],["haushaltsapparate.net",60],["gailtal.news",60],["gitschtal.news",60],["greifenburg.news",60],["hermagor.news",60],["klagenfurt.news",60],["polizei.news",[60,196,356,1443]],["radenthein.news",60],["spittal.news",60],["steinfeld.news",60],["tierwelt.news",60],["troepolach.news",60],["villacher.news",60],["weissensee.news",60],["prost-magazin.at",61],["puls24.at",62],["radio.at",63],["radio.de",63],["rockantenne.at",[64,65]],["antenne.de",65],["rockantenne.de",[65,96]],["schwaebische.de",[65,1053]],["rockantenne.hamburg",[65,96]],["antenne.nrw",65],["rts-salzburg.at",66],["sempre-audio.at",[67,68]],["coincierge.de",[67,616]],["fazemag.de",67],["fuldainfo.de",67],["maniac.de",67],["oberberg-aktuell.de",[67,1063]],["pictures-magazin.de",[67,1094]],["smarthomes.de",[67,1197]],["soeren-hentzschel.at",69],["spielen-slots.at",70],["spielen-slots.com",70],["spielen-slots.de",70],["sportsbusiness.at",71],["tips.at",[72,73]],["ariva.de",[73,299,494]],["otto.de",[73,1076]],["toolbox.webediagaming.de",73],["zdnet.de",73],["u1-radio.at",74],["versicherungsjournal.at",75],["versicherungsjournal.de",75],["viamichelin.at",76],["wetter.at",[76,85]],["autoscout24.ch",76],["badi-info.ch",76],["viamichelin.ch",76],["erochatcommunity.com",76],["arbeitszeugnisgenerator.de",76],["fischkopf.de",76],["nachtkritik.de",[76,1034]],["eurotrainer.ndz.de",76],["regenbogen.de",76],["viamichelin.de",76],["xwords.de",76],["androidhow.eu",76],["stol.it",[76,1388]],["erochatcommunity.net",76],["raetselhilfe.net",76],["vienna.at",77],["vienna-capitals.at",78],["vol.at",79],["volksblatt.at",80],["vsport.at",81],["w24.at",82],["websingles.at",83],["weltfussball.at",84],["latina-press.com",84],["weltfussball.com",84],["deutsche-wirtschafts-nachrichten.de",84],["einrichtungsbeispiele.de",[84,694]],["gevestor.de",84],["weltfussball.de",84],["wetteralarm.at",86],["wetteronline.at",87],["wetteronline.de",[87,142,1320]],["wiener-online.at",[88,89]],["ipadblog.de",[88,907]],["nh24.de",[88,104,121,245,295,567,621,783,1048]],["einkochen.info",88],["wiiunews.at",[90,91]],["bildschirmarbeiter.com",[91,263,264]],["onepiece-tube.com",[91,344,345,346]],["bitreporter.de",[91,230,345,562]],["chip.de",[91,348,507,612]],["nickles.de",91],["pcgamesdatabase.de",91],["ruhrbarone.de",91],["schule-studium.de",[91,264]],["naruto-tube.org",[91,344,1448]],["emok.tv",91],["willhaben.at",92],["wochenblick.at",93],["yenivatan.at",94],["zurzeit.at",95],["9elf-magazin.de",95],["rockantenne.bayern",96],["ostbelgiendirekt.be",97],["kostenlose-sexvideos.biz",98],["sexkostenlos.biz",98],["deutschepornos.co",98],["erotik-sexvideos.com",98],["geilesexclips.com",98],["gratis-sex-videos.net",98],["gratisfickvideos.net",98],["sexfilmetube.net",98],["xhamsterdeutsch.xyz",98],["myboerse.bz",[99,100]],["thinkpad-forum.de",99],["salto.bz",101],["russland.capital",102],["russland.news",102],["ddl-warez.cc",[103,104,105]],["bitcoinnews.ch",[104,120,121,122,123,124]],["blog-der-republik.de",104],["computerschach.de",[104,621]],["nen-n.de",104],["radzeit.de",[104,1132]],["ostfussball.com",105],["ebook-land.cc",106],["wochenblatt.cc",107],["20min.ch",[109,110]],["lessentiel.lu",109],["3fach.ch",111],["aarauer-nachrichten.ch",113],["st-galler-nachrichten.ch",113],["wiler-nachrichten.ch",113],["winterthurer-zeitung.ch",113],["zugerwoche.ch",113],["anzeigervomrottal.ch",114],["argovia.ch",115],["esports.ch",[115,138,139]],["radio24.ch",115],["scfreiburg.com",[115,380,381]],["europages.de",115],["frischauf-gp.de",[115,781]],["hc-elbflorenz.de",115],["mainpost.de",115],["svww.de",115],["bolzano-bozen.it",[115,1377]],["argoviatoday.ch",116],["baerntoday.ch",116],["fm1today.ch",116],["nzz.ch",[116,187]],["pilatustoday.ch",116],["swissmom.ch",[116,184]],["zueritoday.ch",116],["avguide.ch",117],["bauernzeitung.ch",118],["biete6.ch",119],["rlc-gamer.de",[120,122,1156]],["ecommerce-vision.de",122],["laufzeit.de",122],["ligablatt.de",123],["blick.ch",125],["bluewin.ch",126],["bueroblog.ch",127],["computerfachmagazin.de",127],["office-roxx.de",127],["cash.ch",128],["cherry.ch",[129,130]],["lust24.ch",[129,174]],["comback.ch",[131,132]],["h-bw.de",[131,662,838]],["cvj.ch",133],["fahrzeuglackiererforum.de",133],["pornotim.com",[134,363,364]],["xhamsterde.com",[134,426,427]],["derbund.ch",135],["engadinerpost.ch",136],["erotikinserate.ch",137],["sihf.ch",139],["hannover96.de",139],["p-stadtkultur.de",139],["explora.ch",140],["fcz.ch",141],["finanzen.ch",[142,143,144]],["extremnews.com",142],["4investors.de",[142,447]],["apotheken-umschau.de",[142,489]],["dpd.de",142],["heise.de",[142,871]],["az.com.na",[142,355,1398]],["finanzen.net",[144,348,507,508,556,596,1411]],["freiburger-nachrichten.ch",145],["fussball.ch",146],["wetter.ch",146],["wirtschaft.ch",146],["gut-erklaert.de",[146,566,836]],["fuw.ch",147],["fvnws.ch",148],["gamemovieportal.ch",149],["games.ch",[150,151]],["chemnitzerfc.de",150],["deutsche-mittelstands-nachrichten.de",150],["gastrojournal.ch",[152,153]],["radsport-news.com",153],["drwindows.de",153],["filmpost.de",153],["gesetzlichekrankenkassen.de",153],["helles-koepfchen.de",[153,873]],["lehrerfreund.de",153],["medizin-netz.de",153],["ntg24.de",[153,1059]],["oekotest.de",[153,1066]],["oktoberfestportal.de",153],["pharmazeutische-zeitung.de",[153,1092]],["sportal.de",153],["stuttgarter-zeitung.de",[153,533,540,1228]],["touristik-aktuell.de",153],["tweakpc.de",[153,1284]],["vhs-ol.de",153],["glarus24.ch",154],["radiocentral.ch",154],["sunshine.ch",154],["gmx.ch",155],["gota6.ch",[156,157]],["sex-infos.ch",156],["greenbyte.ch",158],["rtl.de",[158,1163,1164]],["grower.ch",159],["healthhelp.ch",160],["perbene.ch",160],["daily-pia.de",[160,634]],["likehifi.de",[160,964]],["windowspower.de",[160,1324]],["help.ch",161],["homegate.ch",162],["hottime.ch",163],["immoscout24.ch",164],["itmagazine.ch",[165,166]],["gamereactor.de",[165,801]],["hardwareluxx.de",[165,389,442,855]],["mopo.de",[165,533,1012]],["jamesfm.ch",167],["jobscout24.ch",168],["jungfrauzeitung.ch",169],["kath.ch",170],["lifechannel.ch",171],["local.ch",172],["lolabrause.ch",173],["lustmap.ch",175],["marina.ch",176],["medienjobs.ch",178],["prewarcar.de",[178,1110]],["medienwoche.ch",179],["my-ladies.ch",180],["my105.ch",181],["namibia-forum.ch",182],["nebelspalter.ch",184],["tt.com",184],["gebraucht-kaufen.de",[184,810]],["mixed.de",[184,321]],["northdata.de",184],["raetsel-hilfe.de",184],["it-daily.net",[184,1420]],["watchtime.net",184],["netzwoche.ch",185],["news.ch",186],["themarket.ch",187],["wort.lu",[187,1397]],["onlinereports.ch",188],["privatmarkt.ch",190],["radiobeo.ch",191],["radiofr.ch",192],["rasa.ch",193],["redsite.ch",194],["reisetopia.ch",195],["reisetopia.de",195],["metal.de",[197,999]],["telepolis.de",197],["i-fidelity.net",[197,787]],["rockitradio.ch",198],["vintageradio.ch",198],["rro.ch",199],["saiten.ch",200],["schweizer-illustrierte.ch",[201,202]],["anisearch.de",[202,483]],["herz-fuer-tiere.de",202],["schweizerbauer.ch",203],["search.ch",204],["sex4u.ch",205],["andalusien-aktuell.es",[205,1353]],["sexabc.ch",206],["sexy-land.ch",[207,208]],["annos.de",207],["dasoertliche.de",[207,638]],["shaz.ch",209],["simmentalzeitung.ch",210],["sportal.ch",211],["strafbock.ch",212],["eurogirlsescort.de",[212,717]],["suche6.ch",213],["suedostschweiz.ch",214],["swissfunddata.ch",215],["testedich.ch",216],["testedich.de",216],["tieronline.ch",217],["tutti.ch",218],["urnerwochenblatt.ch",219],["vilan24.ch",220],["watson.ch",221],["weltwoche.ch",222],["woz.ch",223],["xdate.ch",224],["xerotik.ch",225],["xxxjob.ch",226],["zeitpunkt.ch",227],["zentralplus.ch",228],["zueri6.ch",229],["condor.cl",230],["literaturwelt.com",230],["anime2you.de",[230,482]],["cyclingmagazine.de",[230,513]],["heimatreport.de",[230,869]],["pfalz-echo.de",[230,843]],["prad.de",[230,1106]],["elliniki-gnomi.eu",230],["funcloud.club",231],["perfektdamen.co",232],["esport.cologne",233],["11880.com",234],["11889.com",235],["1200grad.com",[236,237]],["rotor-magazin.com",236],["1milf.com",[238,239]],["frauporn.com",[238,239]],["xfilmen.com",[238,239]],["wildesporno.xxx",[238,1482]],["2ix2.com",240],["3druck.com",241],["cannabis-special.com",241],["supertipp-online.de",[241,402]],["5-sms.com",242],["abnehmen.com",243],["aquariumforum.de",243],["auswandererforum.de",243],["pferd.de",243],["aerotelegraph.com",244],["algarve-entdecker.com",245],["allround-pc.com",[246,247]],["supermarktblog.com",[247,402]],["amerikawoche.com",248],["anal-pornos.com",249],["astronews.com",250],["astroportal.com",251],["av-views.com",252],["bbc-magazin.com",254],["beeg-pornos.com",[255,256,257,258,259,260]],["deinesexfilme.com",[255,256,257,258,259,260,272]],["einfachtitten.com",[255,256,257,258,259,260,272]],["gutesexfilme.com",[255,256,257,258,259,260,272]],["hd-sexfilme.com",[255,256,257,258,259,260,272]],["herzporno.com",[255,256,257,258,260,272]],["lesbenhd.com",[255,256,257,258,259,260]],["meinyouporn.com",[255,256,257,258,259,260]],["milffabrik.com",[255,256,257]],["nursexfilme.com",[255,256,257,260,272]],["pornodavid.com",[255,256,257]],["pornofelix.com",[255,256,257,260,272]],["pornofisch.com",[255,256,257,258,259,260,272]],["pornohammer.com",[255,256,257,258,259,260,272]],["pornohans.com",[255,256,257,258,259,260,272]],["pornohelm.com",[255,256,257]],["pornojenny.com",[255,256,257,258,259,260,272]],["pornoklinge.com",[255,256,257,258,259,260,272]],["pornoleon.com",[255,256,257]],["pornolisa.com",[255,256,257,361]],["pornoritze.com",[255,256,257]],["pornoschlange.com",[255,256,257,260,272]],["pornosusi.com",[255,256,257]],["pornotanja.com",[255,256,257,361]],["pornotom.com",[255,256,257,258,259,260,272]],["pornotommy.com",[255,256,257,258,259,260,272]],["pornovideos-hd.com",[255,256,257]],["pornozebra.com",[255,256,257,258,259,260,272]],["sexente.com",[255,256,257,258,259,260,272]],["sexfilme-gratis.com",[255,256,257]],["sexvideos-gratis.com",[255,256,257,260,272]],["sexvideos-hd.com",[255,256,257,258,259,260,272]],["tube8-pornos.com",[255,256,257,258,259,260,272]],["xhamster-sexfilme.com",[255,260,272]],["xnxx-porno.com",[255,256,257,258,259,260,272]],["xnxx-sexfilme.com",[255,256,257,260,272]],["hd-pornos.info",[255,256,1369]],["halloporno.net",[255,256,257,260,272]],["hdpornos.net",[255,256,257,258,259,260,272]],["pornhub-sexfilme.net",[255,256,257]],["pornoaffe.net",[255,256,257]],["pornohirsch.net",[255,256,257,258,259,260,272,361]],["pornoente.tv",[255,256,257,258,259,260,272,361,1369]],["xnxx-pornos.xxx",[255,256,257]],["pornoaffe.com",[258,259,260]],["xhamster-sexvideos.com",[258,259,260]],["bergwelten.com",261],["biancazapatka.com",262],["das-sternzeichen.de",264],["gamingmedia.de",264],["meintomtom.de",[264,881,995]],["metacrawler.de",[264,334]],["seaofsin.de",264],["seaofsin.info",264],["boerse-express.com",265],["boerse-social.com",266],["buchstaben.com",267],["computersm.com",268],["connextra.com",269],["daswetter.com",271],["der-farang.com",[273,274]],["bluray-disc.de",[273,573]],["deutschsex.com",[275,276]],["deutschsex.mobi",275],["digital-eliteboard.com",[277,278]],["musiker-board.de",[277,278,1025,1026]],["woodworker.de",277],["macuser.de",[278,442]],["vielfliegertreff.de",278],["drpornofilme.com",279],["eindeutscherporno.com",280],["eintracht.com",281],["elektrobike-online.com",[282,283]],["outdoor-magazin.com",[282,349,350,351]],["aerokurier.de",282],["auto-motor-und-sport.de",282],["caravaning.de",[282,349,603]],["cavallo.de",[282,604]],["flugrevue.de",282],["menshealth.de",[282,603]],["motorradonline.de",[282,349,350,603]],["mountainbike-magazin.de",[282,351]],["outdoorchannel.de",282],["promobil.de",[282,349]],["roadbike.de",[282,283,351]],["runnersworld.de",[282,603]],["womenshealth.de",282],["erogeschichten.com",284],["erotikseitentest.com",285],["fcbayern.com",287],["feinehilfen.com",288],["ff-bz.com",289],["fickverein.com",[290,291]],["analsexporno.net",[291,359,362]],["frauporno.com",292],["fussballeuropa.com",293],["fussballtransfers.com",294],["geocaching-magazin.com",295],["gewinn.com",296],["goal.com",297],["guteporno.com",298],["handelsblatt.com",299],["handy-auf-raten.com",300],["hc-neumarkt.com",301],["hcgherdeina.com",302],["herthabsc.com",303],["tv.herthabsc.com",304],["hierspielen.com",305],["hornoxe.com",306],["hsvhandball.com",307],["htfgames.com",308],["image-hifi.com",309],["utvmagazin.de",[309,950]],["inselradio.com",310],["internet-sms.com",311],["intimesrevier.com",312],["focus.de",[314,348,508,767,768]],["fool.de",314],["journalistenwatch.com",315],["kachelmannwetter.com",316],["kauf6.com",317],["koerperverletzung.com",318],["urheberrecht.de",[318,907]],["scheidung.org",318],["kopfhoerer.com",319],["kuehlschrank.com",319],["schlafsack.net",319],["staubsauger.net",319],["fernseher.org",319],["laufband.org",319],["kriegsberichterstattung.com",[320,321]],["eu-vertretung.de",[321,659,714]],["kronenachrichten.com",322],["lapippa.com",323],["livestreamde.com",324],["liveticker.com",325],["lmdfdg.com",326],["madchensex.com",327],["mallorcamagazin.com",328],["mein-wetter.com",329],["kostenloses-fernsehen.de",[330,945]],["de.motor1.com",[331,332]],["insideevs.de",332],["msn.com",[334,335,336]],["mundus-art.com",337],["mydict.com",338],["mydict.net",338],["mygermantimes.com",339],["arbeitsunrecht.de",339],["boxen.de",339],["fruchthandel.de",[339,607,782,783]],["wirsiegen.de",[339,1329]],["pornofilm.zone",339],["notebookchat.com",342],["prosieben.de",[342,914,921]],["tvspielfilm.de",[342,348,914,1281]],["notebookcheck.com",343],["fairytail-tube.org",[344,345,1448]],["picdumps.com",[345,356]],["anderes-wort.de",345],["widgets.outbrain.com",348],["autobild.de",[348,504,505,506,507,508]],["computerbild.de",[348,505,507,508,540,620]],["gamestar.de",[348,507,508,799,804]],["musikexpress.de",[348,599,1027]],["n-tv.de",[348,507,508,1033]],["ran.de",[348,507,508,921,1133]],["rollingstone.de",[348,506,599,1159]],["sport.de",[348,1209]],["persoenlich.com",352],["photaq.com",353],["photovoltaikforum.com",[354,355]],["spox.com",[356,396,397]],["dkamera.de",[356,667]],["donau3fm.de",356],["isaswomo.de",[356,910]],["ofdb.de",356],["plista.com",357],["pokerfirma.com",358],["pornhutdeutsch.com",[359,360]],["free-gay.org",[359,1430]],["pornomonster.com",362],["scharfe-pornos.com",362],["deutsche-sexfilme.net",362],["xhammer.net",364],["port01.com",365],["pr0gramm.com",366],["radiodeutsch.com",368],["radsportjournaltourman.com",[369,370]],["nachrichten.es",[370,621,860]],["rbleipzig.com",371],["rc-modellbau-blog.com",372],["ecrbs.redbulls.com",373],["fussball.de",373],["reiseblog7.com",374],["rittnerbuam.com",375],["roboter-forum.com",[376,377]],["autoextrem.de",[376,441,510,511]],["pedelecforum.de",[376,510,1086,1087]],["uhrforum.de",[376,509,1288]],["de.rt.com",378],["running-magazin.com",379],["sgf1903.de",381],["schnittberichte.com",382],["schrift-generator.com",383],["segeljournal.com",384],["servus.com",385],["terramatermagazin.com",385],["sexgeschichten.com",386],["shop-apotheke.com",387],["sinn-frei.com",388],["skiinfo.com",389],["bergsteiger.de",[389,540,541]],["skiinfo.de",[389,1190]],["videoaktiv.de",[389,1301]],["anrufer.info",[389,539]],["snowsociety.com",390],["songtexte.com",391],["spanienlive.com",392],["speedweek.com",393],["spielesite.com",394],["sportscheck.com",395],["german-porno-deutsch.info",[397,1368]],["spreeblick.com",398],["startxxl.com",399],["strippokerregeln.com",400],["sumikai.com",401],["swoodoo.com",403],["szene-hamburg.com",404],["tagesstimme.com",405],["technic3d.com",406],["teneriffa-aktuell.com",407],["teneriffa-news.com",408],["trendmutti.com",410],["tri2b.com",411],["kinofilme.ucoz.com",412],["uhrenratgeber.com",413],["unnuetzes.com",[414,415]],["unsere-helden.com",415],["veggieboom.com",416],["genialetricks.de",416],["jungewelt.de",417],["voucherwonderland.com",418],["wegwerfemailadresse.com",419],["weihnachts-filme.com",420],["froheweihnachten.info",420],["weihnachten.me",420],["weihnachts-bilder.org",420],["wetter.com",421],["wetter-deutschland.com",422],["wirtschaftslexikon24.com",423],["wochenblitz.com",424],["x-oo.com",425],["pornhubdeutsch.info",427],["xvideos-deutsch.com",428],["pornohut.info",[428,1372]],["youporndeutsch.info",428],["zenideen.com",429],["zuckerporno.com",430],["zwischengas.com",431],["pragerzeitung.cz",432],["89.0rtl.de",433],["100urlaubsziele.de",435],["14-tage-wettervorhersage.de",437],["1kh.de",438],["1und1.de",439],["home.1und1.de",440],["2ertalk.de",[441,442]],["usp-forum.de",[441,442,510]],["android-hilfe.de",[442,480]],["grillsportverein.de",442],["3dchip.de",443],["3drei3.de",444],["4crazy.de",445],["4fansites.de",446],["6profis.de",449],["90min.de",450],["99damage.de",451],["a3kultur.de",452],["abendzeitung-muenchen.de",454],["abg-net.de",455],["abload.de",456],["ad-hoc-news.de",457],["adventures-kompakt.de",458],["aedt.de",459],["aerzteblatt.de",460],["agriaffaires.de",462],["nr-kurier.de",464],["ww-kurier.de",464],["aktionspiele.de",465],["mahjongspielen.de",465],["zeitmanagementspiel.de",465],["aktionspreis.de",466],["all-electronics.de",[467,468]],["automobil-produktion.de",467],["chemietechnik.de",467],["fertigung.de",[467,744]],["fluid.de",467],["instandhaltung.de",[467,904]],["ke-next.de",467],["kgk-rubberpoint.de",467],["ki-portal.de",467],["neue-verpackung.de",467],["pharma-food.de",467],["plastverarbeiter.de",467],["produktion.de",[467,468,904]],["technik-einkauf.de",[467,904,1245]],["werkzeug-formenbau.de",467],["automotiveit.eu",[467,468,904]],["alles-mahlsdorf.de",470],["allgaeuer-zeitung.de",[471,472]],["brv-zeitung.de",471],["dtoday.de",471],["goslarsche.de",[471,832]],["pz-news.de",[471,1120]],["tageblatt.de",471],["teckbote.de",471],["weser-kurier.de",[471,627]],["alpin.de",[473,474]],["immobilienscout24.de",[473,895]],["amazon.de",475],["motormobiles.de",[477,1015]],["trinkwasserguru.de",477],["amigafuture.de",478],["analysedeutschland.de",479],["angelshow.de",481],["aol.de",484],["apfeleimer.de",485],["apfelpage.de",486],["apfeltalk.de",487],["apotheke-adhoc.de",488],["gamekeyfinder.de",489],["kultur-port.de",[489,844,950]],["ok-weinstrasse.de",489],["arbeits-abc.de",490],["archiexpo.de",491],["directindustry.de",491],["medicalexpo.de",491],["nauticexpo.de",491],["rotelaterne.de",[491,1160]],["architekt.de",492],["glamping.info",492],["areadvd.de",493],["arminia.de",[495,496]],["rot-weiss-erfurt.de",496],["seo-united.de",496],["budapester.hu",[496,1363]],["asialadies.de",497],["avladies.de",497],["badeladies.de",497],["behaarteladies.de",497],["bizarrladies.de",497],["busenladies.de",497],["deutscheladies.de",497],["devoteladies.de",497],["dominanteladies.de",497],["erfahreneladies.de",497],["escorts24.de",497],["exklusivladies.de",497],["grosseladies.de",497],["hobbyladies.de",497],["jungeladies.de",497],["kussladies.de",497],["latinaladies.de",497],["massierendeladies.de",497],["mollyladies.de",497],["nsladies.de",[497,1058]],["nymphomaneladies.de",497],["orientladies.de",497],["osteuropaladies.de",497],["piercingladies.de",497],["rasierteladies.de",497],["schokoladies.de",497],["spielkarussell.de",[497,1206]],["tattooladies.de",497],["tsladies.de",497],["zaertlicheladies.de",497],["zierlicheladies.de",497],["astronomie.de",498],["astrotreff.de",499],["asv-hamm-westfalen.de",500],["au-ja.de",501],["augsburger-allgemeine.de",[502,503]],["rheinische-anzeigenblaetter.de",503],["t-online.de",[503,559,566,592,593,1236,1237]],["watson.de",[503,819,1244,1310]],["autoexperience.de",509],["flugzeugforum.de",509],["xbox-passion.de",509],["gs-forum.eu",[509,1356]],["win-10-forum.de",510],["winboard.org",510],["autogazette.de",[512,513]],["schmunzelseite.de",513],["signal-online.de",513],["solaranlage-ratgeber.de",[513,872]],["xxx-amateur.eu",513],["unzensiert.ru",513],["autouncle.de",515],["b2run.de",516],["back-intern.de",517],["bafoeg-rechner.de",518],["studis-online.de",[518,1225]],["barrierefreie-immobilie.de",[519,520]],["heizsparer.de",[520,872]],["basic-tutorials.de",521],["basses-blatt.de",523],["beobachter-online.de",[523,539]],["einbecker-morgenpost.de",523],["gandersheimer-kreisblatt.de",523],["goldstar-tv.de",523],["romance-tv.de",523],["studio-magazin.de",523],["blaue-blume.tv",523],["bastel-elfe.de",524],["baur.de",527],["bayer04.de",[528,529]],["bvb.de",529],["dhb.de",529],["fc-union-berlin.de",[529,738]],["hallescherfc.de",[529,842,843]],["ofc.de",[529,1067]],["rundumkoeln.de",529],["uniliga.gg",[529,1362]],["bayernwelle.de",530],["bayreuther-tagblatt.de",531],["bbheute.de",[532,533]],["berliner-kurier.de",[533,542,543,544]],["berliner-zeitung.de",[533,542,543,545]],["bietigheimerzeitung.de",533],["blick.de",[533,565,566]],["donaukurier.de",[533,670]],["evangelische-zeitung.de",[533,543,544]],["frankenpost.de",533],["ingolstadt-today.de",[533,900,901]],["krzbb.de",533],["mittelbayerische.de",[533,900]],["np-coburg.de",533],["pnp.de",533],["bbqpit.de",534],["bbszene.de",535],["bbv-net.de",536],["stadtanzeiger-borken.de",536],["beat.de",537],["digitalphoto.de",[537,664]],["beliebtestewebseite.de",538],["drumsundpercussion.de",539],["eurogamer.de",[539,627]],["halle.de",539],["neuelandschaft.de",[539,1041]],["stereo.de",[539,1218]],["tourenfahrer.de",[539,879]],["berlinertageszeitung.de",546],["berlinmitkind.de",547],["berlinstadtservice.de",548],["bestattungen.de",549],["bhc06.de",550],["biallo.de",551],["bibliomed-pflege.de",[552,553]],["magistrix.de",[552,979]],["bigfm.de",554],["bikesport-emtb.de",555],["radfahren.de",555],["radsport-rennrad.de",555],["sportbild.bild.de",[558,559]],["businessinsider.de",[559,592,593]],["fitbook.de",[559,756,757]],["giga.de",[559,592,593,649,819,820]],["jetzt.de",[559,914]],["myhomebook.de",[559,592,593,756,1031]],["noizz.de",559],["sport1.de",[559,592,593,1211]],["techbook.de",[559,756]],["transfermarkt.de",[559,592,593,914,1266]],["travelbook.de",[559,756,757,1267]],["welt.de",[559,1315]],["bildercache.de",560],["biothemen.de",561],["bitsundso.de",563],["blaulichtreport-saarland.de",564],["tutonaut.de",[564,1275]],["hifi-forum.de",566],["kino.de",[566,649,819,934]],["meinestadt.de",[566,994]],["news.de",[566,881,1045]],["nordbayern.de",[566,1050,1051]],["teltarif.de",[566,1249]],["blickpunkt-brandenburg.de",567],["katzeausdemsack.de",[567,925]],["sunshine.it",[567,1390]],["blinker.de",568],["blitzrechner.de",569],["blog-it-solutions.de",570],["blogprojekt.de",571],["blogtotal.de",572],["bmw-syndikat.de",574],["boerse.de",575],["boerse-daily.de",576],["boerse-online.de",577],["boersen-zeitung.de",578],["boersennews.de",579],["boomerangtv.de",580],["infosat.de",580],["meteovista.de",580],["rhein-zeitung.de",[580,1154]],["borussia.de",581],["bravo.de",582],["cosmopolitan.de",582],["happinez.de",582],["lecker.de",582],["liebenswert-magazin.de",582],["maennersache.de",582],["praxisvita.de",582],["selbst.de",582],["wunderweib.de",582],["browsergames.de",583],["btc-echo.de",584],["buenasideas.de",586],["buffed.de",[587,588,589,590]],["gamezone.de",[587,589,590]],["pcgames.de",[587,588,589,590,1082]],["pcgameshardware.de",[587,590,1083]],["gamesaktuell.de",[589,590]],["videogameszone.de",590],["bunte.de",591],["busplaner.de",594],["fuldaerzeitung.de",595],["petbook.de",598],["stylebook.de",[599,756,757]],["ww3.cad.de",600],["campervans.de",601],["reisemobil-international.de",601],["camping.de",602],["celleheute.de",605],["galaxy-ingolstadt.de",[606,796]],["championstream.de",607],["online-gebuehrenrechner.de",607],["vfl.de",[607,1297]],["ibooks.to",[607,1433,1470]],["channelpartner.de",608],["chartsurfer.de",610],["efahrer.chip.de",613],["praxistipps.chip.de",614],["clever-tanken.de",615],["com-magazin.de",617],["computerbase.de",619],["randombrick.de",621],["tollabea.de",[621,1258]],["computerwoche.de",622],["tecchannel.de",622],["connect.de",[623,624,625]],["pc-magazin.de",[623,624]],["vaterland.li",623],["coolibri.de",626],["countrymusicnews.de",627],["ka-news.de",[627,787,920]],["morningstar.de",627],["suedkurier.de",627],["crossmagazin.de",628],["crucero-magazin.de",629],["curt.de",630],["curved.de",631],["custombike.de",632],["cz.de",633],["goettinger-tageblatt.de",633],["haz.de",633],["kn-online.de",633],["ln-online.de",633],["lvz.de",633],["maz-online.de",633],["neuepresse.de",633],["op-marburg.de",633],["ostsee-zeitung.de",633],["paz-online.de",633],["waz-online.de",633],["darts1.de",635],["dartsnews.de",636],["power-wrestling.de",636],["radsportaktuell.de",636],["tennisaktuell.de",636],["dashcamtest.de",637],["dnv-online.net",[640,1407]],["datenschutz-berater.de",[641,642]],["quadjournal.eu",642],["deine-tierwelt.de",643],["deinhandy.de",644],["delamar.de",645],["der-rissener.de",646],["derkleinegarten.de",647],["designtagebuch.de",648],["desired.de",[649,650]],["familie.de",[649,650,732]],["spielaffe.de",649],["deutsche-apotheker-zeitung.de",651],["deutsche-versicherungsboerse.de",652],["deutscherskiverband.de",653],["dfb.de",654],["diebildschirmzeitung.de",655],["dieharke.de",656],["diekuechebrennt.de",657],["diesachsen.de",658],["digitalfernsehen.de",[659,660]],["forum.digitalfernsehen.de",661],["digitalkamera.de",[662,663]],["djmag.de",665],["djz.de",666],["dogforum.de",668],["dolomiten.de",669],["fernsehserien.de",669],["drehscheibe-online.de",671],["dreingau-zeitung.de",[672,673]],["linguee.de",673],["druckerchannel.de",674],["druckkosten.de",675],["dslr-forum.de",676],["dsv.de",677],["dtb.de",678],["dtb-tennis.de",679],["dubisthalle.de",680],["duden.de",681],["duesseldorfer-anzeiger.de",682],["e-formel.de",684],["quoka.de",[686,1123]],["ebay.de",687],["ebike-news.de",688],["ebook-fieber.de",689],["ef-magazin.de",690],["ego4u.de",691],["ehv-aue.de",692],["eihi.de",693],["einsteiger-keyboard.de",695],["eintracht.de",696],["eisbaeren.de",697],["eishockeynews.de",699],["elle.de",701],["esquire.de",701],["freundin.de",701],["harpersbazaar.de",701],["instyle.de",701],["eltern.de",702],["emmikochteinfach.de",[703,704]],["karrierebibel.de",[704,923]],["emtb-news.de",[705,706,707]],["mtb-news.de",[705,707,1022]],["rennrad-news.de",705],["ladies.de",[707,956]],["emuenzen.de",708],["endstation-rechts.de",709],["englisch-lernen-online.de",710],["epd-film.de",711],["escortboard.de",712],["etcg.de",713],["euractiv.de",715],["eurocampings.de",716],["europa-landmaschinen.de",[718,719]],["suedtirolnews.it",718],["eurotransport.de",720],["eventelevator.de",721],["expert.de",722],["experten.de",723],["express.de",724],["ksta.de",[724,949]],["rundschau-online.de",[724,1167]],["f95.de",725],["fachzeitungen.de",726],["factsverlag.de",727],["fairaudio.de",728],["faktastisch.de",[729,730]],["frustfrei-lernen.de",[730,785]],["falk.de",731],["familienkost.de",733],["fanfiktion.de",734],["favicon-generator.de",735],["fc.de",736],["fc-hansa.de",737],["fcaugsburg.de",739],["fcbinside.de",740],["fcenergie.de",741],["fcschweinfurt1905.de",742],["femotion.de",743],["feuerwehrmagazin.de",745],["filmlaune.de",746],["filmstarts.de",747],["filmz.de",748],["finanzen-nerd.de",749],["finanzen100.de",[750,751]],["finanzmarktwelt.de",752],["finanznachrichten.de",[753,754]],["finanztreff.de",755],["fitforfun.de",[758,759]],["ibb-anzeiger.de",759],["suchen.mobile.de",[759,1006]],["suedtiroltv.it",[759,1389]],["fkk24.de",760],["fla.de",761],["flaconi.de",762],["flashscore.de",763],["floatmagazin.de",764],["flugmodell-magazin.de",765],["trucks-and-details.de",765],["flz.de",766],["netmoms.de",[769,1038]],["foodwissen.de",770],["fotohits.de",772],["fotomagazin.de",773],["fraenkischertag.de",774],["frag-mutti.de",775],["freenet.de",776],["suche.freenet.de",777],["freiburgesports.de",778],["freiluft-blog.de",779],["fremdwort.de",780],["fuersie.de",[786,787,788,789]],["grazia-magazin.de",[786,787,834]],["idee-fuer-mich.de",[786,787,788,834]],["jolie.de",[786,787,788]],["leben-und-erziehen.de",[786,787,788]],["maedchen.de",[786,787,788]],["ok-magazin.de",[786,787,788,834]],["petra.de",[786,787,788]],["vital.de",[786,788,834,1303]],["inside-digital.de",[787,902,903]],["jagderleben.de",787],["kochbar.de",[787,940]],["fundresearch.de",790],["fussballn.de",792],["ga.de",795],["galeria.de",797],["team.gamed.de",798],["gamepro.de",[799,800]],["gamersglobal.de",802],["games-mag.de",803],["haus-garten-magazin.de",[805,860]],["gartenflora.de",806],["gartenschlumpf.de",807],["gawina.de",808],["gearnews.de",809],["geemag.de",812],["gekonntgekocht.de",813],["gelbeseiten.de",814],["gentleman-blog.de",815],["gernekochen.de",816],["gesundheit.de",[817,818]],["onmeda.de",[817,1072]],["glycerinwissen.de",821],["gn-online.de",822],["go2android.de",823],["godmode-trader.de",824],["goldpreis.de",825],["forum.golem.de",827],["jaegermagazin.de",828],["st-georg.de",828],["tennismagazin.de",828],["golfv.de",829],["goolive.de",831],["goyellow.de",833],["guenstiger.de",835],["gwd-minden.de",837],["hallanzeiger.de",840],["hallelife.de",841],["hallespektrum.de",844],["hallo-minden.de",845],["hamburg-magazin.de",846],["kiel-magazin.de",846],["luebeck-magazin.de",846],["hamburg-pride.de",847],["hamburger-allgemeine.de",848],["handballecke.de",849],["handy-player.de",850],["handyraketen.de",851],["hardware-helden.de",853],["hardware-mag.de",854],["hardwareschotte.de",856],["hartware.de",857],["haufe.de",858],["haus.de",859],["hausgeraete-test.de",861],["heimwerker-test.de",861],["hifitest.de",[861,877]],["haustec.de",862],["haustechnikdialog.de",863],["hc-erlangen.de",864],["hceintracht-hildesheim.de",866],["hebelschein-spekulant.de",[867,868]],["werbestandard.de",867],["mdz-moskau.eu",[867,1358]],["heimspiel-online.de",870],["helpster.de",874],["herthabsc.de",875],["hifi.de",876],["hl-live.de",878],["hockeyweb.de",[879,880,881]],["scienceblogs.de",879],["unicum.de",[879,1290]],["wissenschaft.de",879],["hoerzu.de",882],["holstein-kiel.de",883],["homeandsmart.de",884],["hpd.de",885],["hsc2000.de",886],["hsg-pohlheim.de",887],["hsg-wetzlar.de",888],["ibiza-heute.de",890],["ifun.de",892],["iphone-ticker.de",892],["immo4trans.de",893],["immoauktionen.de",894],["indirekter-freistoss.de",897],["infoheute.de",898],["infranken.de",899],["tikonline.de",903],["integralrechner.de",905],["ableitungsrechner.net",905],["intersport.de",906],["presse-nachrichten.de",907],["iphone-tricks.de",908],["islamische-zeitung.de",911],["isnichwahr.de",912],["jameda.de",913],["juraforum.de",918],["kabeleins.de",921],["sat1.de",921],["sixx.de",921],["kalenderwoche.de",922],["kartfahrer-forum.de",924],["kaufland.de",926],["kauperts.de",927],["keyforsteam.de",928],["kfz-steuer.de",929],["kicker.de",930],["euro.kicker.de",931],["forum.kinder.de",932],["kinderspiele-welt.de",933],["klamm.de",935],["klappeauf.de",936],["klartext-ne.de",937],["kleinanzeigen.de",939],["koeln.de",941],["koelner.de",942],["korrekturen.de",943],["kostenlose-urteile.de",944],["kreativfieber.de",946],["kriminalpolizei.de",947],["kroatien-nachrichten.de",948],["kunst-zeiten.de",951],["kunststoffweb.de",952],["kurier.de",953],["l-mag.de",954],["laengengrad-breitengrad.de",957],["land-der-traeume.de",958],["lerntippsammlung.de",959],["lexolino.de",960],["libble.de",961],["lifeverde.de",962],["ligainsider.de",963],["lippe-news.de",965],["lokalezeitung.de",967],["lokalkompass.de",968],["lokalmatador.de",969],["lovelybooks.de",971],["lowbeats.de",972],["lust-auf-kroatien.de",973],["macgadget.de",974],["maclife.de",975],["mactechnews.de",976],["mahjongkostenlos.de",980],["mainz05.de",981],["manomano.de",983],["marketing-boerse.de",984],["markt.de",985],["mediabiz.de",986],["meedia.de",988],["meetingpoint-brandenburg.de",989],["mein-mmo.de",990],["mein-pferd.de",991],["mein-schoener-garten.de",992],["merkurist.de",996],["messweb.de",997],["metager.de",998],["mietminderungstabelle.de",1000],["mikanews.de",1001],["mo-web.de",1002],["mobiflip.de",1003],["mobile.de",1004],["m.mobile.de",1005],["mobilegeeks.de",1007],["modernhifi.de",1008],["momondo.de",1010],["moonsault.de",1011],["morecore.de",1013],["motor-talk.de",1014],["moviejones.de",1017],["moz.de",1018],["swp.de",[1018,1235]],["msh-online.de",1019],["nnz-online.de",1019],["msxfaq.de",1020],["mt.de",1021],["bikemarkt.mtb-news.de",1023],["mufa.de",1024],["recording.de",1026],["mv-spion.de",1028],["mydealz.de",1029],["myfont.de",1030],["myself.de",1032],["nationalgeographic.de",1035],["naturalhorse.de",1036],["nd-aktuell.de",1037],["netzkino.de",1039],["neue-braunschweiger.de",1040],["neumarkt-tv.de",1042],["neumarktaktuell.de",1043],["neuwagen.de",1044],["newzs.de",1046],["nextpit.de",1047],["nibelungen-kurier.de",1049],["nn.de",1050],["nordkurier.de",[1052,1053]],["notebookinfo.de",1054],["noz.de",1055],["nrhz.de",1056],["nrwhits.de",1057],["ntz.de",1060],["scdhfk-handball.de",[1060,1172]],["nur-positive-nachrichten.de",1061],["nwzonline.de",1062],["obermain.de",1064],["rhoenundsaalepost.de",1064],["oekoportal.de",1065],["offroadforen.de",1068],["oljo.de",1069],["onlinehaendler-news.de",1070],["onlineuebung.de",1071],["onvista.de",1073],["ostfriesischer-kurier.de",1074],["osthessen-news.de",1075],["oxmoxhh.de",1077],["oz-online.de",1078],["paradiso.de",1079],["parfumo.de",1080],["partyamt.de",1081],["radsport-seite.de",[1085,1131]],["aus-liebe.net",[1085,1400]],["persoblogger.de",1088],["perspektive-mittelstand.de",1089],["pferd-aktuell.de",1090],["pferdekult.de",1091],["photographie.de",1093],["pinksugar-kessy.de",1095],["planetradio.de",1097],["playfront.de",1099],["ploetzblog.de",1100],["pnn.de",1101],["tagesspiegel.de",[1101,1230,1241]],["podcast.de",1102],["pokewiki.de",[1103,1104]],["timeanddate.de",1103],["popkultur.de",1105],["preis.de",1107],["preis24.de",1108],["preissuchmaschine.de",1109],["print.de",1112],["prinz.de",1113],["prisma.de",1114],["produck.de",1115],["professional-audio.de",1116],["prosiebengames.de",1118],["psychic.de",1119],["rheinpfalz.de",1120],["zvw.de",1120],["qiez.de",1121],["queer.de",1122],["radiobob.de",1124],["radioguetersloh.de",1125],["radioholiday.de",1126],["radiosaw.de",1127],["radioszene.de",1129],["radmarkt.de",1130],["ratehase.de",1134],["rc-car-news.de",1135],["rc-car-rennsport.de",1135],["rc-news.de",1136],["readersdigest.de",1137],["realtotal.de",1138],["regensburg-digital.de",1139],["regioactive.de",1140],["reimmaschine.de",1141],["reise-preise.de",1142],["reisereporter.de",1143],["reiseuhu.de",1144],["news.reiseuhu.de",1145],["rendsburgerleben.de",1146],["restegourmet.de",1147],["reviersport.de",1148],["rewe.de",1149],["shop.rewe.de",1150],["rezeptwelt.de",1151],["rheiderland.de",1152],["rhein-neckar-loewen.de",1153],["ride-on-magazin.de",1155],["spielesnacks.de",[1156,1205]],["rnd.de",1157],["rollertuningpage.de",1158],["rp-online.de",1161],["rsa-radio.de",1162],["vox.de",1164],["ruhr24.de",1165],["rund-magazin.de",1166],["saarbruecker-zeitung.de",1168],["volksfreund.de",1168],["wz.de",1168],["saechsische.de",1169],["satvision.de",1171],["schalke04.de",1173],["schausteller.de",1174],["schiene.de",1175],["schlager.de",1176],["schwedenstube.de",1177],["scifiscene.de",1178],["scp07.de",1179],["seekxl.de",1180],["seenluft24.de",1181],["selbstaendig-im-netz.de",1182],["seo-suedwest.de",1183],["seorch.de",1184],["adspecials.sevenonemedia.de",1185],["sg-flensburg-handewitt.de",1186],["shopanbieter.de",1187],["sims4ever.de",1188],["sis-handball.de",1189],["tvtoday.de",1191],["sport.sky.de",1193],["slashcam.de",1194],["smart-rechner.de",1195],["smartdroid.de",1196],["smartphonemag.de",1198],["smsgott.de",1199],["sparneuwagen.de",1201],["spiele-kostenlos-online.de",1203],["spiele-umsonst.de",1204],["spielregeln.de",1207],["spiesser.de",1208],["sport-90.de",1210],["sportbuzzer.de",1212],["sportradio-deutschland.de",1213],["spot-on-news.de",1214],["sprachnudel.de",1215],["ssv-jahn.de",1216],["stereoguide.de",1219],["stern.de",1220],["steuerlinks.de",1221],["stimme.de",1222],["stock-world.de",1223],["strafbuch.de",1224],["studysmarter.de",1226],["faz.net",1230],["tirol.de",[1231,1256]],["supermarkt-inside.de",[1232,1233]],["swim.de",1234],["www-t--online-de.cdn.ampproject.org",1236],["email.t-online.de",1238],["suche.t-online.de",1239],["t3n.de",1240],["interaktiv.tagesspiegel.de",1242],["tchgdns.de",1243],["tech-review.de",1244],["techstage.de",1246],["teilzeithelden.de",1247],["tennis.de",1250],["teslamag.de",1251],["tff-forum.de",1252],["thsv-eisenach.de",1253],["tiervermittlung.de",1254],["tippscout.de",1255],["tobitech.de",1257],["tomsnetworking.de",1259],["tonight.de",1260],["tonspion.de",1261],["tourispo.de",1263],["trendyone.de",1268],["tri-mag.de",1269],["tritime-magazin.de",1270],["trvlcounter.de",1271],["tsg-hoffenheim.de",1272],["tsv1860.de",1273],["tuhlteim.de",1274],["tv-huettenberg.de",1276],["tvdigital.de",1277],["tvg-grosssachsen.de",1278],["tvhalle.de",1279],["tvinfo.de",1280],["m.tvspielfilm.de",1282],["tvsportguide.de",1283],["typo3blogger.de",1285],["ubuntu-forum.de",1286],["uepo.de",1287],["ukraine-nachrichten.de",1289],["unterwasserwelt.de",1291],["utopia.de",1293],["veggies.de",1294],["velomotion.de",1295],["verlagshaus-jaumann.de",1296],["vfl-gummersbach.de",1298],["vfl-wolfsburg.de",1299],["vip.de",1302],["live.vodafone.de",1304],["volleyball-bundesliga.de",1305],["vrnerds.de",1306],["tippspiel.wa.de",1307],["wasserburger-stimme.de",1309],["weekli.de",1314],["weristdeinfreund.de",1316],["werkenntdenbesten.de",1317],["wetter.de",1318],["wetterbote.de",1319],["wg-gesucht.de",1321],["wiesbaden.de",1322],["will-mixen.de",1323],["windowspro.de",1325],["winfuture-forum.de",1327],["wintotal.de",1328],["wissens-quiz.de",1331],["wohnglueck.de",1332],["wohnungswirtschaft-heute.de",1333],["fussballnationalmannschaft.net",[1333,1413]],["wolfsrevier.de",1334],["forum.worldofplayers.de",1335],["wp-koenigin.de",1336],["wohnidee.wunderweib.de",1337],["xgadget.de",1338],["xmedia-recode.de",1339],["xn--schne-aussicht-xpb.de",1340],["xn--solitr-fua.de",1341],["xn--spidersolitr-qcb.de",1342],["xnxx2.de",1343],["yasni.de",1344],["yoga-aktuell.de",1345],["zentrum-der-gesundheit.de",1347],["zfans.de",1348],["zitate-online.de",1349],["zum.de",1350],["zumfahren.de",1351],["nordschleswiger.dk",1352],["cannabis-medic.eu",1355],["kalender-365.eu",1357],["vanion.eu",1359],["lounge.fm",1360],["primeleague.gg",1361],["data-load.in",1364],["balaton-zeitung.info",1365],["codecheck.info",1366],["ero-world.info",1367],["hockey-news.info",1370],["rundschau.info",1373],["ssv-brixen.info",1374],["barfuss.it",1376],["buongiornosuedtirol.it",1379],["kultur.bz.it",1380],["dererker.it",1381],["dervinschger.it",1382],["hceppan.it",1383],["puschtra.it",1384],["sbb.it",1385],["nydus.org",[1385,1453]],["sportclub-meran.it",1386],["ssvbozenhandball.it",1387],["trauerhilfe.it",1392],["wallis24.it",1393],["volksblatt.li",1394],["filmstreaming-de.life",1395],["diegrenzgaenger.lu",1396],["archzine.net",1399],["belgieninfo.net",1401],["bundesliga-streams.net",1402],["chilloutzone.net",1403],["chinahandys.net",1404],["otr.datenkeller.net",1405],["dforum.net",1406],["g.doubleclick.net",1408],["edelsteine.net",1409],["sternzeichen.net",1409],["elektroauto-news.net",1410],["fupa.net",1412],["gartenratgeber.net",1415],["grenzecho.net",1416],["hstt.net",1419],["italienisch-lernen-online.net",1421],["kostenlosspielen.net",1422],["kreuzwort-raetsel.net",1423],["lavendel.net",1424],["mikrocontroller.net",1425],["my-homo.net",1426],["pesterlloyd.net",1427],["porno-himmel.net",1429],["pornohutdeutsch.net",1430],["sexfilme24.org",1430],["raidrush.net",1431],["raptastisch.net",[1432,1433]],["sexei.net",1434],["sexfilmegratis.net",1435],["sexvideoskostenlos.net",1435],["sims-3.net",1436],["staedte-info.net",1437],["taucher.net",1438],["breakpoint.untergrund.net",1439],["usa-info.net",1440],["warez-ddl.net",1441],["zensiert.net",1442],["report24.news",1444],["6chat.org",1445],["anime-loads.org",1446],["dejure.org",1447],["german-bash.org",1449],["metropolico.org",1450],["modified-shop.org",1451],["n-mag.org",1452],["outleter.org",1454],["parcello.org",1455],["travelguide-en.org",1456],["tschechien-online.org",1457],["zeno.org",1458],["wochenblatt.pl",1459],["wein.plus",1460],["hallobuer.ruhr",1461],["boerse.sx",1462],["goldesel.sx",[1463,1464]],["blockbuster.to",[1464,1467]],["saugen.to",[1464,1474]],["blackdevils.team",1465],["darkpantersclan.de.tl",1466],["gload.to",1468],["hd-source.to",1469],["kinoger.to",1471],["kinomax.to",1472],["pornkinox.to",1473],["xrel.to",1475],["fight24.tv",1476],["mywheels.tv",1477],["sportdeutschland.tv",1478],["hoerbuch.us",1479],["jungle.world",1480],["hammerporno.xxx",1481]]);

const entitiesMap = new Map(undefined);

const exceptionsMap = new Map(undefined);

self.specificImports = self.specificImports || [];
self.specificImports.push({ argsList, hostnamesMap, entitiesMap, exceptionsMap });

/******************************************************************************/

})();

/******************************************************************************/
