/*******************************************************************************

    uBlock Origin Lite - a comprehensive, MV3-compliant content blocker
    Copyright (C) 2019-present Raymond Hill

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see {http://www.gnu.org/licenses/}.

    Home: https://github.com/gorhill/uBlock
*/

/* jshint esversion:11 */

'use strict';

// ruleset: fin-0

/******************************************************************************/

// Important!
// Isolate from global scope
(function uBOL_cssSpecificImports() {

/******************************************************************************/

const argsList = ["div[id*=\"AdContainer\"]","#block-annonsblockx6,\n#block-bilwebbenmobileteaser,\n#block-googleaddesktopinsider,\n#block-marknadenmobileteaser,\n#block-stickyannons,\n#block-views-block-bilwebben-block-1,\n#block-views-block-company-ads-block-1,\n.editorial-ad,\n.views-element-container:has(a[href^=\"https://www.marknaden.ax/annons\"]),\ndiv[id|=\"block-googleadmaincontent\"]",".panorama",".mobileads,\n.videoad_container,\n.wpb_column.vc_column_container.td-pb-span8:has([src$=\"adsbygoogle.js\"]),\n.wpb_column.vc_column_container.td-pb-span8:has(a[onclick*=\"banner\"]),\n.wpb_content_element.wpb_text_column:has(div[class|=\"g g\"])",".ae-bg-gallery-type-default.elementor-section-height-default.elementor-section-boxed.elementor-hidden-phone.has_ae_slider:has([src=\"https://securepubads.g.doubleclick.net/tag/js/gpt.js\"]),\n.elementor-location-header .topp","#petition_page_top_ad","#div-ad-below-message,\n.pageWidth > div[style=\"min-height:90px;text-align:center;margin:auto;\"],\n.sidebar > div[style=\"min-height:250px;text-align:center;margin:auto;\"]","[href^=\"https://tc.tradetracker.net/\"],\ndiv.text-center.col-sm-6 > a[rel$=\"nofollow\"]","#block-local-offers-widget-front,\n.optionset-imported-ads,\n.revive-block,\n.view-imported-ad-ams",".ad.right-col-box,\n.banner-slot-box,\n.section-inner:has(> .banner-slot),\n.section-inner:has(> div[style] > .sanoma-ad-banner),\n[class^=\"banner-slot-preroll\"]",".text-link[href*=\"&utm_medium=banner&utm_campaign=\"],\n.text-link[href^=\"https://clk.tradedoubler.com/\"]",".ad-slot,\n.mobile-leaderboard-container,\n.resize-container","div[id^=\"dfp__\"]",".ad-container","a[href*=\"bannerTrack\"]","#outstream,\n.pnad-container",".td-post-content > .social-share ~ *,\nbody.post-template-default * .td-main-content-wrap:has(.tdt-ad-wrap)",".bc--grey-neutral-50,\n.card-article-ads","#topBanner","a[href*=\"tema.fi\"]",".affilistaukset,\n.leovegas,\n[class^=\"mstila\"],\na[href^=\"https://ads.expekt.se/\"],\na[href^=\"https://ads.mrgreen.com/\"],\na[href^=\"https://promo.leovegas.com/\"],\na[href^=\"https://stake.com/\"],\na[href^=\"https://www.expekt.com/\"],\na[href^=\"https://www.leovegas.com/\"],\ndiv[class=\"artikkeli_body\"] > p:first-of-type > a[href$=\".gif\"],\ndiv[class=\"artikkeli_body\"] a[href*=\"-Expekt-\"],\np img.alignnone[src$=\".png\"][alt=\"\"][width=\"2560\"][height^=\"20\"]","#spotlight-container-id","div[id|=\"almad\"]",".pb30:has(.adsbygoogle)","a[aria-label=\"Mainostaja\"],\na[aria-label=\"Mainostajan linkki\"],\ndiv[aria-label=\"Hakutulokset\"][role=\"main\"] [role=\"feed\"] [role=\"article\"]:has(a[aria-label=\"Sponsoroitu\"][href^=\"/ads/about/\"]),\ndiv[role=\"complementary\"] > div > div > div > div > div:not([class], [data-visualcompletion]) > span:has([aria-label=\"Mainostaja\"])","#billboard,\n#logopal,\n.flexibox,\n.shopster,\ndiv[class*=\"adbox\"],\ndiv[style=\"background: rgb(246, 66, 100) none repeat scroll 0% 0%; color: rgb(255, 255, 255); padding: 20px;\"]","#ipsLayout_mainArea > center,\n.ipsLayout_sidebarright,\n[data-nbenhadv]","#findance_desktop-top,\n#findance_mobile-top,\ndiv[id^=\"adslot_content\"],\ndiv[id^=\"adslot_sidebar\"]","#page-body > div[style=\"width:728px; margin:0 auto; padding:10px 0;\"]",".futis-sticky-footer[data-futis-trackbid]",".adv-link",".advr_box,\n.mvp-side-widget.widget_text,\n.pum-overlay,\n.wp_rss_retriever + div[style^=\"margin-top:\"],\n.wp_rss_retriever[style^=\"background:\"],\n[class^=\"top-banner-\"],\n[data-advadstrackid],\n[href=\"https://bonuspanda.com/fi/\"],\n[href=\"https://casinogorilla.com/fi/nettikasinot/\"],\n[href=\"https://pussit.com\"],\n[href=\"https://www.halvinlaina.fi\"],\n[href=\"https://yrityslaina.com\"]","#gp-natives,\n.ad-separatator,\n.carousel-cell--native,\n.content-continues-after-ad,\n.golfliitto-articles__commercial,\n.main-native,\n.native-carousel,\n.search-results > .section--ad__mob,\n.section--ad__panorama,\n.section--ad__rectangle,\n.section-native-list,\nbody.bbpress > .content-wrapper .section--ad,\ndiv:has(> #gp-native-1)",".td_block_template_1.td-a-rec-id-custom-spot.td-a-rec.td-block,\na[href$=\"koronaavastaan.fi/?ref=metrotuotanto\"]",".td-a-rec-id-sidebar","A[href=\"http://www.satshop.fi\"]",".boxi","div[class|=\"g g\"]","#cmorelink,\n.inline-txtad,\ndiv[class=\"block block-block\"]",".adv,\n.adv_content,\n.adv_side",".custom_banners_big_linkbefore-content,\n.custom_banners_big_linkwidget,\n[class^=\"custom_banners_big_linkcontent\"],\n[id^=\"_ning_zone_\"]","#mini-panel-autodoc_150x50,\n.gam-holder",".kiekk-footer-sticky[data-kiekk-trackbid]","[style^=\"text-align:center;margin-left:auto !important;margin-right:auto !important;height: 420px; margin-top:60px\"]",".oxy-modal-backdrop",".block-mainos","#secondary #block_widget-4,\n.bannerma",".code-block",".banners","a[href*=\"adsrv\"],\ndiv[class=\"main-bottom\"]",".addme","[href^=\"https://www.kasinokaverit.com/\"],\n[href^=\"https://www.lainaovi.fi/\"]",".lead-collector-cta",".strossle > div[class*=\"post-ad\"]",".md\\:bg-gray-200.md\\:max-w-full.md\\:px-4.md\\:py-4",".bg-white.mb-6:is(.p-3, .p-4):has([href*=\"/advertoriaali/\"])","#ad-300x150,\n#ad-300x300,\ndiv[class=\"ad230x90\"]",".ads",".pnadg-container","[href$=\"/pitkavetovihjeet/\"]",".mvp-post-ad-wrap","div[aria-label=\"Siirtymisruutu\"] ~ div[data-max-width=\"2400\"] + div[class]","#bottom-offer","#banneri_yla,\n.banner.content",".advert",".paid-content-wrapper",".widget_ads_carousel,\n.widget_adwidget,\n.widget_hintaopasbestprice,\nSECTION[id*=\"hintaopaspopular\"],\narticle.grid__item_1-2:has(> div.nativead)","[href=\"https://www.kasinokaverit.com/ilmaiskierroksia-nettikasinoilla/\"],\n[href=\"https://www.nainen.com/lainoja-kilpailuttamalla-saastat-aikaa-ja-rahaa/\"]","#art_right_banner:has(> [id|=\"almad\"]),\n.homepage-adspot","#article_sh li:has(.homepage-adspot-list)","#banner_area,\n.lazyLoadInhouseBanner,\n.topBannerMinHeight,\n[class*=\"pt\"][class*=\"pb\"][style*=\"border-top:1px solid #b3b3b3\"]","#article_box li:has([id|=\"almad-post-content\"])","#homeBottomBoxBanner,\n#homeTopBoxBanner,\n#huge_banner,\n#largeViewHouseBanner,\n.inh_banner_nl,\n.leftAdvDiv,\n.listing:not([data-id]):not(.tricky_link_listing)",".itemlist > li:not(.block_list_li)","div.nc_r_banner","#smallViewHouseBanner,\n.article-blocks__item:has(> [id|=\"almad-post-content\"]),\n.grid-x.cell:has(> [id|=\"almad-content\"])","body > .huge-banner",".article-blocks__item:has(> .block-row > [id|=\"almad-post-content\"]),\n.grid-x.cell:has(> #banner-container-HomePageBanner > [id|=\"almad-content\"])","#offer,\n#tulos-etu",".samBannerUnit,\n.samCodeUnit,\n.td-header-sp-recs",".js-notices.notices--block.notices,\n.samTextUnit","#nav + div[style=\"text-align:center;min-height:280px\"]","a[href^=\"https://pelaajat.com/out/\"] > img,\na[href^=\"https://www.freelaskutus.fi/\"],\ndiv[style=\"background:white;max-width:320px;padding:10px;margin-top:10px;\"]:has([id^=\"pelaajatcom-boksi\"])","#adiniframe_oikealaita_container,\n#bookingnostokuvasarjassa,\n#mainos .ilmoitus,\n#pm_mp_kotisivu,\n[id^=\"pm_mp_tekstissa\"]","br:has(+ br + ins[class=\"adsbygoogle\"]),\nbr:has(+ ins[class=\"adsbygoogle\"])",".adv_ads_ad_unit","center","a[href*=\"banner\"]",".banner-slot-preroll","[href^=\"http://ads.leovegas.com/\"],\n[href^=\"http://www.primeslots.com/\"],\ndiv#panorama_container,\ndiv[style=\"font-size:14px;line-height:21px;padding-top:6px;\"],\ndiv[style=\"padding-bottom:10px;border-bottom:1px solid gray;margin-bottom:6px;\"]:has(script[type=\"text/javascript\"]),\ndiv[style=\"padding-bottom:10px;margin-bottom:6px;border-top:1px solid gray;margin-top:6px;\"] + [type=\"text/javascript\"] + div,\ndiv[style=\"padding-bottom:10px;margin-bottom:6px;border-top:1px solid gray;margin-top:6px;\"] + table[width=\"468\"] + div,\nscript[src^=\"http://adserving.unibet.com/ad.aspx\"] + div[style=\"padding-bottom:10px;margin-bottom:6px;border-top:1px solid gray;margin-top:6px;\"],\ntable[width=\"468\"],\ntable[width]:has(script[class=\"teads\"]):not(:has(.category_story_unit))","[href$=\"/nettikasinot/\"],\n[href$=\"/nettikasinot/\"] + .dropdown-toggle","[data-bottom-floater]",".menu-item:has([href*=\"/veikkausvihjeet\"])",".menu-item:has([href$=\"/pitkavetovihjeet/\"])","a[href^=\"https://on.vallila.fi/\"],\np a[href^=\"https://related.iittala.com/\"],\np:has(strong):has(a[href=\"http://www.curaofsweden.com/fi\"])",".adf-placement-top",".annons",".panorama-wrapper",".advertisement","#mvp-leader-wrap,\n.clever-core-ads,\n.uutis-footer-sticky[data-uutis-trackbid]",".menu-item:has([href$=\"/vedonlyonti/\"])","#text-8,\n#text-9,\n.listing-item:has(> .item-inner > .native-title)","#secondary a[href^=\"https://diamondbeverages.fi/\"],\n#secondary a[href^=\"https://wihuri.metrotukku.fi/\"]",".advertising",".service-ad-panel","article[class]:has(> a[href^=\"https://tilaa.sanoma.fi/al-digi\"][href$=\"etusivu_flash\"])",".teaser-ad__background",".ticker--promo-10,\ndiv[class] > a[href^=\"https://tilaa.sanoma.fi/\"]","[data-info-container-text^=\"MAINOS\"]","div[class$=\"nativead\"]",".teivo-sidebar",".feedraviraportit:has(.mainosfeedravi)","[href=\"/tilaa-lehti\"]",".vaihtuvamainos,\ndiv[class=\"w-full md:w-2/5 pt-6 md:pt-0 pl-0 md:pl-8\"]",".ugaam-archive-ad-wrapper",".box--full.grid__container.clearfix,\n.magazineorderwidget__content,\n.sidebar-block:has(img.awpo-lazy)",".sidebar-block > a[href^=\"http://pubads.g.doubleclick.net/gampad/clk\"],\n[href*=\"paratiisi.fi\"]","#front_after_menu,\n.latest_sima,\n.soliloquy-link,\n.widget.sima",".px-4.py-2.bg-white.w-full:has(.poppartners)","#tilt-ad-top-stay-away",".px-4.py-2.bg-white.w-full:has([data-ad-unit-id])",".grid__item_1:has(> [id^=\"dfp__native-card\"]),\nli:has([id^=\"dfp__native-card\"])",".widget_nativearticles","#huomiotekstilinkki[href^=\"https://tilaus.\"]",".frontpage-banner,\n.native-comms","div[class*=\"PageBlock__ContentContainer\"]:has(div[class*=\"ContentSpotlightBlock__AdLabel\"])","[class*=\"ad__component\"],\n[class^=\"Ad__AdRoot\"]","ul[class*=\"relatedContent__list\"] > li:has([class*=\"ContentCard__AdLabel\"])",".ads-parade-wrapper,\na[href^=\"https://www.arvopaperi.fi/kumppanisisallot/\"][target=\"_self\"]:not(section > a),\ndiv#skyscraper-height-div > aside > div:has(a[href^=\"https://www.arvopaperi.fi/kumppanisisallot/\"])","[width]:has(.lazyload-wrapper):not(aside)","[class*=\"p2m385-\"]",".head.the-wrap,\n[id|=\"bunyad-widget-ads\"]",".pb[lazied],\n[id^=\"pb_cont\"].pb:has(> a[href^=\"/clk2?\"])","#pb_bottom,\n.box_dt,\n[href^=\"/clk\"]",".pb_t","div[class*=\"advertorial\"]",".teaser--ad",".front-page-ad-padding,\n.front-page-advertisement",".widget:has(.widget_advads_ad_widget)","#cm-banner",".sidebar-block:has([id^=\"adsivupalkki_\"])","#rt-sidebar-b",".advs,\n.moduletable:has(.advs)",".ad-wrapper,\n.widget_caravanlehti-ad,\nmain section.block-notices","[id^=\"afscontainer\"]","div[class=\"flex flex-wrap md:flex-nowrap lg:flex-nowrap gap-x-4\"][style=\"min-height:500px;\"]",".poppartners",".border-bottom.row:has(.poppartners),\ndiv[data-recommendation-type=\"ad\"]","div.min-h-\\[450px\\]",".px-4.py-2.border-b.border-gray-200.bg-white.w-full","div[style=\"min-height:450px;\"]","div[class=\"w-full bg-white border-gray-200 border-b py-2 px-4\"]:has([id*=\"_smart_boksi\"])","body:not(.post-type-archive-advertoriaali) .bg-white.p-3.mb-6:has(a[href*=\".fi/advertoriaali/\"])",".wrepper.mx-auto > .row[style=\"margin-bottom:20px\"]","div[class^=\"AdStyles__Wrapper\"],\ndiv[class^=\"OrderMagazinestyles__Container\"]","[data-banner-horseshoe]",".ni_holder",".js-fragment-web-lazy_carousel","._ning_outer","[id|=\"adni_widgets\"]",".compareGoogleCell",".swiper-slide:has(div[class*=\"ContentCard__AdLabel\"]),\ndiv[class^=\"EmbeddedArticle__Container\"]:has(div[class*=\"CommercialLabelContainer\"])","div[class^=\"ContentFlowBlock__CardContainer\"]:has(div[class*=\"ContentCard__AdLabel\"])","#div-leeadsFullpageAd,\n.article-ad-container,\n.commercial-row","div[style=\"min-height:300px;\"]",".widget_text:has([data-ad-unit-id]),\ndiv[id^=\"article-ad\"]",".dls-loaded","._3GUme._1hdYd:has(a[href^=\"https://pointti.fi\"])",".bg-elisa-dark,\n.bg-viaplay-dark-gray",".md\\:max-w-full.md\\:px-4.py-4:has([data-ad-unit-id])",".DfpAdSlot_dfp-ad-slot",".Index_native-ads",".Article_native-ads","div[class^=\"ad\"]",".page-notes > .note--highlight",".views-row:has(.is-commercial)","#annonsspalt,\n#leaderboard,\n.annonspekare",".sponsoredrow",".alp-advert",".thirstylinkimg","[href^=\"https://online.adservicemedia.dk/cgi-bin/click.pl\"]","#ad_global_below_navbar",".Advertisement__Box,\n.Advertisement__Box--with-padding,\n.Advertisement__Top,\n.FrontPageSpots__Ad",".banner-wrapper,\n.banner_middle",".content-article.h-container:has(#FKM-paraati),\n.in-list-ad-containers",".detailLeaderboard",".map-ad,\n[class*=\"adBox\"],\ndiv[class^=\"AdBlock_adContainer\"]",".widget_custom_html","div[id|=\"inline-banner-mobi\"]",".elementor-element-228d8bca,\n.elementor-element-24aa8e2,\n.elementor-element-9e2ec43,\n.elementor-widget-container > [href^=\"https://northernmarketing.fi/\"]",".gofollow",".elementor-widget:has(img[data-image-title^=\"MAINOS\"])","#adContainer,\n#ad_topScroller,\n#bigVideoAd_content,\n#eventad,\n#sky2_1,\n#sky2_2,\n#videoContainer:has(source[id|=\"videoad\"]),\n.ad_mobilebigwrap,\n.ad_video,\n.itsanad,\n.rwd.colthin > div,\n.sponsor,\n.videoAd,\ndiv[class^=\"ad_Bumper\"],\nsection.artistyle3.rightbox:nth-of-type(1)","li:has(.adsbygoogle),\nul.link:has(a[href^=\"http://clk.tradedoubler.com/\"])",".is-advertorial,\n.is-sidebar > .has-background:has(.is-advertorial),\n.is-sidebar > .has-background:has(a[href*=\"utm_medium=banner\"]),\n.js-tabpanel > ol > li:has(.is-advertorial),\ndiv[id|=\"div-gpt-ad\"]",".pad-small.col-md-4.col-sm-6.col-xs-12:has(.b2b-ad-list)",".adsbygoogle + script + br,\nbr:has(+ .adsbygoogle)",".content.single-banner,\n.top.panorama.banner,\n[class|=\"ml-adverts\"]:not(:has(a[href=\"https://reska.fi/lounasreska/\"])),\na[rel=\"lightbox[palvelut]\"]",".td-a-rec-id-content_inline,\n.ylapala",".bg-advertorial,\n.dre-item--feature-advertorial","#sp-alabanneri,\n.autoboksi.moduletable",".jattiboksi.moduletable",".banneritem,\n.module:has(.bannergroup)","[data-test-id=\"ad\"]","#banner-top,\n.feature:has([href$=\"/mainosyhteistyo/\"])",".any-commercial,\n.bottomlistarticle:has(.ag-promocolllabel),\n.col-section:has(.ag-promocolllabel)","#googlejs,\ndiv[class*=\"sub-container\"]","[id|=\"hv-wrapper-top\"],\na[href^=\"/ohjaus.php\"],\ndiv[class=\"hv-wrapper-left-item\"],\ndiv[class=\"hv-wrapper-right-item\"]",".outsider-ads,\n.pjra-relative.pjra-items-center:has(div[id^=\"fi-hintaopas-wde-section\"][id*=\"panorama\"]),\ndiv[class^=\"AdPlacement\"],\ndiv[class^=\"AdPlacement\"] + div[class|=\"EmptyCard\"],\ndiv[class|=\"StyledAdPlacementWrapper\"]",".header-container__ad-container,\n.page-index__adholder,\ntr.rahalaitos__desktop.rahalaitos",".default-banner-size",".ab-test-metered-softwall,\n.aldente-wrapper,\n.for-no-subscription.html-is-seuraa-myynti-bf.html-is-seuraa-myynti,\n.hs-advertorial,\n.hs-ticker-sales,\n.ticker--promo-20,\n[id^=\"aldente-mobi\"],\na.block[href*=\"/mainos\"],\narticle[class*=\"bg-native-ad\"],\ndiv[class*=\"-ad-block\"],\ndiv[class*=\"ad-container\"]",".grid--dfp-slots,\n.sidebar-block a[href^=\"https://seura.fi/mainos/\"],\n.sidebar-block a[href^=\"https://tekniikanmaailma.fi/mainoslehti/\"]",".pane-sbase-cts-native-native-front","#paraati-ad-grid,\n.-ad1.-ad.sidebar__column-item,\n.m-managedListing__column.-level-1:has(.-commercial),\n.right-now-widget__item--commercial","div[data-lazy-ad-unit-id]",".alennuskoodi-column-embed,\n.article-list a[href] > .article-sponsored,\n.card.eo-embed-container,\n.card:has(#il-rantapallo-right-column-box),\n.card:has(.alennuskoodi-column-embed),\n.card:has(.etua-widget-container),\n.card:has(.etuovi-react-embed),\n.center.category-list-embed,\n.commercial-list-item,\n.embed-placeholder:has(> div > .eo-embed-announcements-container.card),\n.etua-widget-container,\n.etuovi-react-embed,\n.front-sponsored-ad,\n.leiki-container-markkinapaikka2.leiki-container,\n.parade-ad-container,\n.recommendation-carousel-svod.recommendation-carousel,\n.side-column-content .card:has(.nettiauto-sponsored-content-text),\n.slider-content,\n.telkku-ads,\n[class|=\"almad-mobile-parade\"],\na.articles__list-item[href^=\"/telkku/\"]:has(p.articles__sponsored-banner),\ndiv.footer-wrapper__item.is-visible.LazyLoad,\ndiv.fp-container.card:has([href*=\"clark-taloutesi-tukena\"]),\ndiv.fp-container.card:has([src*=\"ilcdn.fi\"][src*=\"KAUPALLINEN\"][src*=\"YHTEISTY\"]),\ndiv.fp-container.card:has([src*=\"ilcdn.fi\"][src*=\"kaupallinenyht\" i]),\ndiv.fp-container.card:has([src*=\"ilcdn.fi\"][src*=\"kyi_\" i]),\ndiv.fp-container.card:has([src*=\"ilcdn.fi\"][src*=\"mainos\" i]),\ndiv.fp-container.card:has([src*=\"ilcdn.fi\"][src^=\"ky-\" i]),\ndiv.fp-container.card:has([src*=\"ilcdn.fi\"][src^=\"ky_\" i]),\ndiv.fp-container.card:has([src*=\"ilcdn.fi/Nauha_Rantapallo\"]),\ndiv.fp-container.card:has([src*=\"ilcdn.fi/asuminen_vattenfall_palkki\"]),\ndiv.fp-container.card:has([src*=\"ilcdn.fi/kuvat/nauhat/nauha_terveys_specsavers\"]),\ndiv[class=\"card \"]:has(.block > a[class=\"nakoislehti\"][href^=\"https://plus.iltalehti.fi/nakoislehti/\"]),\ndiv[class=\"iframe-container\"]",".newsbox:has(> [id^=\"div-gpt-ad\"]),\ndiv[class=\"footer-ylempi\"]","[class^=\"mainospaikka\"]","p:has([href^=\"https://track.adform.net/\"])",".button-mainos,\n.footer-1.footer.footer-widgets,\ndiv[class=\"row align-center\"]:has([class$=\"lazy-load-active\"])",".structItem--thread[data-author=\"Mainos\"]","[data-revive-zoneid]","#text-7,\n.artikkeli-slide:has(img[src*=\"-nostokuva\"]),\n.artikkeli-slide:has(img[src*=\"Ad-otsikko\"]),\n.artikkeli-slide:has(img[src*=\"mainos\"]),\n.artikkeli-slide:has(img[src*=\"natiivi-otsikko\"]),\n.view-full.uutinen:has(a[href=\"https://www.io-tech.fi/category/mainos/\"]),\n.widget.datatronic,\naside.jimmx","a.block[href^=\"https://www.admanager.fi/\"],\na[href^=\"https://www.is.fi/u/oma/tilaa/is-extra\"][href$=\"myyntitikkeri\"],\ndiv.sadblob-loading","section.sbs-articleitems[data-module_position_id=\"814\"]",".sbs-articleitems:has(.right-column-header + .articles-container .article-item:only-child .sponsored),\na.article-item:has(.sponsored),\ndiv.item:has(.sponsored)",".box--transparent:has(.advert)",".c-box-space:not(.c-box),\nli:has(div[id|=\"div-gpt-ad\"])",".latest-post-link:has(.mainos)","#ipsLayout_sidebar .ipsBox:not([data-blocktitle=\"Member Subscriptions\"]),\n.ipsSpacer_both,\n[data-role=\"sidebarAd\"] + br","[href=\"https://www.nettikasinovertailu.info/\"]",".collab,\n.collaboration,\n.content-section > .g:has([id^=\"gpt-desktop-inside-article\"]),\n.emp-ad,\n.right-inner-section:has(#gpt-desktop-side)",".widget-container:has([class^=\"ad_\"]),\n[src^=\"https://kaasujalka.fi/assets/banners\"]",".ad-mob_description,\n.frosmo_popup:has(.popup_advertiser),\n.is-background-gray-light-3:has([id^=\"dfp__\"]),\n.placeholder,\nli.grid__item:has([id^=\"dfp__native-card\"])",".wp-block-otavamedia-google-ad-slot","#native-list-wrapper,\n#native_text_wrapper,\n.native.feed_box_container","#puff-container,\n.m-contentListItemThumb:has(> div > div > div[class^=\"m-contentListItemThumb__advertisement\"]),\n.m-managedListing__column:has(> div > div > div > div[class^=\"m-contentListItem__advertisement\"]),\naside.sidebar__column-container:has(.-ad),\ndiv[class=\"lyta-lazy-load\"]","#outstream-container","#sidebar .simple-image > [href]:not([href^=\"https://kamera-lehti.fi\"]),\n#sidebar .widget[id|=\"custom_html\"],\n.etusivu-mainos:not(:has([href^=\"https://kamera-lehti.fi\"]))",".kaupallinen-general,\n.ksnote",".herald-module:has(.adsbygoogle),\n.herald-module:has([href^=\"https://revoltnoir.fi/\"]),\na[href=\"https://www.kielletytkirjat.com/\"],\na[href^=\"https://revoltnoir.com\"],\ndiv[id^=\"ads\"]",".elementor-element-2770b68,\n.elementor-element-3e26be8,\n.elementor-element-44ffbd5,\n.elementor-element-54b7f6f,\n.elementor-element-abfd7ba",".breaking-news-container,\na[href*=\"kiinnostuitko\"]:has([alt=\"banneri\"]),\na[href=\"https://punamustamedia.portal.worldoftulo.com/v2/shop/dtabkaiku\"]","#coral-talk + div[class]:has(a[href^=\"https://www.kauppalehti.fi/kumppanisisallot/\"]),\ndiv[class][width]:has(> .ad)","aside > div[class] > a[href*=\"/kumppanisisallot/\"]","div[class]:has(> .lazyload-wrapper > .etua-react-embed)",".blogi__nosto,\n.kl-sima--blocks > [href^=\"https://www.kauppalehti.fi/kumppanisisallot/\"]",".inner.sp-article,\n.list-article:has(.sp-tag),\n.sponsored-article.list-article","#search-top-wide-ad,\n#specific-bottom-rectangle-ad,\n#specific-bottom-wide-ad,\n#specific-openinghours-rectangle-ad,\n#specific-top-wide-ad","[class|=\"wp-block-ultimate-post-post-list\"]:has(.ultp-cat-mainos)",".kiint-adlabel,\n.kiint-widget",".bannerlink","app-ad",".banner","p:has([alt^=\"Mainos\"])","#traktorpool-ad",".promo",".article-continues,\n.card--is-sponsored,\n.wp-block-otavamedia-section-management li:has([id^=\"dfp__\"])","div[class=\" \"] > .rendered_board_widget:has(.kotimaa-adform-widget)","#nmbc,\n.artikkelim-jatkuu,\n.headerau,\n.ktbanner,\n.thirstylink","#kaikki-tarjoukset,\n.sbbyks",".campaign-teaser-show,\n.gtm-banner,\n.wg-banner","#middle,\ndiv[class*=\"banner\"]",".fusion-carousel",".g:has(.gofollow)",".g-1",".wpb_wrapper.wpb_text_column.td_block_wrap:has([auto-grid-data*=\"mainos\"])","#content1-container,\ndiv[class=\"m-contentListItemThumb -ctx-frontpage-now -level-1\"]:has(> div > div > [class^=\"m-contentListItemThumb__advertisement\"]),\ndiv[class=\"m-managedListing__column -ctx-index -level-1 -cols-2\"]:has(> div > div > div > div[class^=\"m-contentListItem__advertisement\"])",".tilaa-tasta,\n.ylabanner1",".box-banner a[href^=\"/redirect/\"],\n.fullwidth-banner:has(> a[href=\"https://www.lauttakyla.fi/tilaa/\"]),\n.fullwidth-imagebanner,\n.hasordercontent.orange-bg,\n.mainbanner",".adremark,\n.popup-overlay",".header-widget [href^=\"https://aslinkhub.com/\"]","[id|=\"etusivu-bottom-full\"]:has(.mainos)","div[class^=\"FeedList__AdWrapper-\"]",".middle-ad-container",".ennensisaltoa,\n.lmbanner",".type-banner",".article-block__list-article:has(a[href^=\"https://ls24.fi/kaupallinen-yhteistyo/\"]),\n.article-blocks-2022-divider:not(.article-block--2022 + .article-blocks-2022-divider),\n.asuntorauma-promo,\n.js-article-block:has(span[class$=\"commercial-label\"]),\n.js-article-block:has(span[class$=\"commercial-label\"]) + .article-blocks-2022-divider,\n.page-section--commercial,\n.palvelupankki-banner,\naside[class=\"sidebar\"] > [class^=\"advertisement ad advertisement\"] + [class^=\"advertisement ad advertisement\"] + section[class^=\"article-list\"]:last-of-type,\ndiv[class^=\"advertisement\"]","div.row:not(:has(article)):has([src=\"//s1.adform.net/banners/scripts/adx.js\"])","#kokosisaltoid","div#sponsor","div[class*=\"ArticleTeaserGroup_nativeAd\"],\ndiv[class^=\"MainLane_laneItem\"]:has(div[class^=\"ArticleBanner_advertorial\"])",".header_banner,\n.textwidget","div[class|=\"ad-section\"]",".widget_block:has(.matka-nostemedia-oikeapalsta)","div.structItem.is-prefix53",".wp-block-column:has(aside figure > a[href=\"https://www.hopealanka.fi\"]),\na[href=\"https://mailapro.fi/\"],\na[href=\"https://urheilutuet.fi/\"],\na[href=\"https://vesikourut.fi/\"],\namp-layout[amp-access^=\"popups.\"][role=\"button\"]","aside > div[class] > a[href=\"/kumppanisisaltoa\"],\ndiv[class]:has(> a[href=\"/kumppanisisaltoa\"]),\ndiv[width]:has([id|=\"almad\"]:not([id|=\"almad-mobileParade\"]))","div[class^=\"NativeAdSpotlight__Component\"],\ndiv[class^=\"pageFeed__topAdSlot\"],\ndiv[class^=\"transitionSlot__component\"]:has(div[class^=\"feedItem__commercial\"])","div[class*=\"feed__adSlot\"]",".aprofit,\n.section--native-left,\n.teaser--partner,\n.teaser-top-banner--partner,\n[data-set=\"main-ad\"]",".frontpage-ad-item:not(:has([href^=\"https://metsastajaliitto.fi/\"])),\n.view-id-jahtimedia_latest .list-item:has([href^=\"https://jahtimedia.fi/mainokset/\"])",".NoAdBlocker_main",".in-text-ad-slot-wrapper","a[data-ga-teaser-name=\"PartnerContentTeaser\"],\nbody:not(.is-style-kumppanisisallot) :is(aside, section) a[href^=\"https://www.mikrobitti.fi/kumppanisisallot/\"],\ndiv[class]:has(> [width] > [id|=\"almad\"]:not([id|=\"almad-mobileParade\"])),\ndiv[class][width]:has([id|=\"almad-mobileParade\"]),\ndiv[style=\"margin-bottom:0\"]:has(a[href^=\"https://www.mikrobitti.fi/kumppanisisallot/\"])",".elementor-widget-container > a[href^=\"https://sortter.fi/\"]","#header_ad33,\n#ostoHint,\n.banner-ad,\n.execphpwidget,\n.header_ad, important,\n.headermob_ad,\n.single-content-all > div[style^=\"float:left\"][style*=\"width:100%\"][style*=\"text-align:center\"][style*=\"margin-bottom:17px\"],\n.singlehinta.header_ad,\n.textwidget > div[style=\"width:300px; height:600px;\"],\n.tops-bar,\nbody.category > div .header_ad,\ndiv[class^=\"article_ad\"]",".block--monsterfi-ads,\n.epiq-landing-row--frontpage-leaderboard-ad","#tori.article-car-list,\n.category-kumppaniartikkeli.moottori_kumppani.smallfeature,\n.container.g-bg.ads.sidebar.item,\n.kumppaniartikkeli-sidebar.smallfeature,\n.narive-ad,\ndiv[class|=\"ad-rotation\"]",".ad-panorama,\na[href*=\"revads\"],\ndiv[class$=\"ad-giant\"]",".avod-web-player-pause,\n.visit-advertiser-link",".component-adincontent.component,\n.component-soniaincontent,\n.leaderboard,\n.sonia-container",".ppas,\ndiv[data-testid=\"endorsement\"],\nsection > ul > li > div:has(a[data-testid=\"ad-article-teaser-tag\"])",".add-banner",".promotional_banner_root","#banneriwrapper,\n.mobilead",".mob_panorama",".chakra-container + div[class]:has(> div[class] > [data-adfscript^=\"track.adform.net/\"])","div[style^=\"min-height:\"][style$=\";text-align:center\"]","div[style^=\"min-height:\"]",".node__content .block[class$=\"kampanja\"],\n.topbar,\ndiv[id^=\"block-credigo\"]",".building-campaign-element,\n[analytics-impression=\"insurance_link_impression\"],\n[analytics-impression=\"product_broadband_impression\"],\nenergy-promotion-building","[analytics-impression=\"energy-promotion_listing-page_impression\"]",".advertoriaalit,\n[aria-label*=\"mainos\"]",".mainos-top",".textwidget:has(.orimad-adlabel)","#sidebar [href=\"https://www.loytotex.fi/tarjoukset\"],\n.CMAC_AdChangerWidget.widget",".online-ad-container,\n.online-teaser--advertorial",".sp-module:has(.tassaWidget)",".ad-above","[aria-label=\"Linkki mainokseen\"]:not([href^=\"https://kauppa.palloliitto.fi/\"])","div[style=\"min-height:552px;\"]",".preroll-text,\n.text-ad-container",".ad","a[href=\"/category/mainos/\"],\nli[class=\"wa@s\"]:has([alt^=\"MAINOS:\"])",".omamainos-PIR,\n.ultp-block-wrapper:has(.ultp-cat-mainosartikkelit)",".ad-assigned.panoraamabanneri",".after-ad,\n.before-ad,\n.jattiboksi,\n.natiivimainos,\n.paraati",".widget_media_image > a[href=\"http://dimex.fi\"]",".proje-widget,\n.uusi-ylabanneri",".site-background-cta[data-action=\"campaignClick\"]","div[class=\"wpb_wrapper\"]","section.sbs-articleitems[data-module_position_id=\"640\"]",".block-radiovoima-advertisements",".FrontPage_native-ads","#dimScreenAll:has([data-category=\"DisplayAD\"]),\ndiv#kauppa_hot,\ndiv[id^=\"banner\"],\nimg#js_ad",".ad-info-bar,\n.front-page-box-ad,\n.lomakone-results-skyscrapers,\ndiv[id|=\"lomakone-resultads\"]","#adslot_bottom,\n#adslot_search,\n#topslot,\n.adslot_right,\n[href=\"https://www.suomi24.fi/lainaa/yhdista-lainat/\"]",".ad-container-wide",".r_ad_banner",".category-mainos,\ndiv[id|=\"retki\"][style]","body.home div[style^=\"margin-left: auto; margin-right: auto; text-align: center;\"] + .wp-block-separator,\ndiv[style^=\"margin-left: auto; margin-right: auto; text-align: center;\"] .is-external-link",".top-banner",".riist-content,\ndiv[id|=\"riist\"][style*=\"text-align: center\"]","a[href*=\"subaction=bannerredirect\"]:not(a[href*=\"-rv-tilaus\"])",".bg-white.w-full.py-2.px-4:has(.poppartners)",".widget_block:has(#nm-300x600-300x300)",".RuutuPlayer__Error-sc-1o2b3la-0",".panoraama_etus","#article-body .article div[class]:has(> .ad-container),\narticle[data-section=\"kaupallinen yhteistyö\"]",".grid__item_lg-1.grid__item_1:has(.dfp-advertisement),\n.wp-block-column:has(> [id|=\"dfp__native-card\"]),\nli:has(> [id|=\"dfp__native-card\"])",".article-item.column-mainospaikka",".section--full-size-ad-carousel",".g-single:has(.hs-cta-wrapper),\nbody.home .container > div[style=\"z-index:1800; margin-bottom:40px;\"]:has(.g-single > .hs-cta-wrapper),\nbody.page:not(.home) .g.g-3,\nbody.single-post .container[style]:has(.g-single > .hs-cta-wrapper)",".view-2019-ajankohtaiset-tarjoukset,\n.view-banneripaikka-etusivuoikea1","#auto-grid-container-5c470b0150cba",".td_block_wrap:has([href=\"https://www.sss.fi/category/mainos/\"])",".bg-box:has([id|=\"placement-ad-grid\"])",".has-ads,\n.no-print.justify-center.flex:has([data-ad-unit-id]),\na[href^=\"http://www.lainanvalittaja.fi/\"],\na[href^=\"https://autonvaraosat24.fi/\"],\na[href^=\"https://www.autodoc.fi/\"],\ndiv[id$=\"paraati\"],\ndiv[id|=\"banner\"]","#layout-banner-right",".banner_wide,\n.site-footer__banners",".ad_class,\n.om-adcoin-ad","div[class=\"site-header__top-container header-top-banner\"]",".ast,\n.editorial-slots,\ndiv[class*=\"Ad__AdWrapper\"],\ndiv[class^=\"HomePage__HeaderAd\"],\ndiv[class^=\"ThreadGridItemWrapper__CardCol\"]:has([class^=\"AdLivewrapped__AdWrapper\"]),\ndiv[id^=\"viihdes24_desktop-sidebar\"]",".bannerTop.S24_banner","div[class*=\"FooterAdWrapper\"],\ndiv[class*=\"HeaderAdWrapper\"],\ndiv[class*=\"__AdWrapper\"],\ndiv[class^=\"RightSidePanel__AdContainer\"]",".asp,\ndiv[class^=\"HomePage__RightColItem\"]:has(> div[class^=\"AdLivewrapped__AdWrapper\"]),\ndiv[class^=\"HomePage__RightColItem\"]:has(> div[class^=\"Lainavertailu__Container\"]),\ndiv[class^=\"Vaalikone__HeaderAdWrapper\"],\np:has(+ p + .asp)",".artikkelimainos,\n.headermainos,\n.natiivilinkit,\n.posts-list > .list-item:has([href=\"https://suomimobiili.fi/kategoria/sponsoroitu/\"])",".ad-banner-lift","[data-element-type=\"CardDefault\"] div[class^=\"CardBg\"]:has(> a[href^=\"https://kampanjat.mainos.sanoma.fi/\"])",".mainos_banner1,\n.widget > a[href^=\"https://www.nettikirjakauppa.com/\"]",".lazyload-wrapper:has([id|=\"almad\"]),\nbody:not(.is-style-kumppanisisallot) [class]:has(> a[href^=\"https://www.talouselama.fi/kumppanisisallot/\"]):not(section),\nbody:not(.is-style-kumppanisisallot) a[href^=\"https://www.talouselama.fi/kumppanisisallot/\"]:not(section > a),\ndiv.article-body > div:has(> div.LazyLoad.is-visible),\ndiv[width]:has(.lazyload-wrapper)",".bannerarea",".sidebar-banners","a[href=\"https://sinitaivas.com/kauppa/\"]",".siteHeader-widgetArea,\n.widget [href^=\"https://www.autodoc.fi/\"],\n.widget [href^=\"https://www.topautoosat.fi/\"]",".commercial-bottom.commercial,\n.commercial_wrapper,\n.node-promoted.node-teaser,\n.paragraph--type-ad","[class|=\"adform\"]",".CategoryPriceGuide_price-guide,\n.NativeAdHolder_native-ad-holder,\n.PriceGuide_price-guide,\ndiv.Article_nettix-embed-container","a[href^=\"/tyopaikat/kumppanisisalto-tyopaikat/\"],\naside > div[class] > a[href^=\"https://www.tekniikkatalous.fi/kumppanisisallot\"],\ndiv#skyscraper-height-div > div > aside > div > div > a[href^=\"https://studio.tekniikkatalous.fi/\"],\ndiv#skyscraper-height-div > div > section > div > a[href^=\"/kumppaniblogit/\"],\ndiv[class][width=\"980\"],\nsection > div > a[href^=\"https://www.tekniikkatalous.fi/kumppanisisallot/\"]","[width]:has(.lazyload-wrapper)",".ch:has(em > a)",".ad-blocks",".advertisement-banner-row,\n.article-container.shadow-sm.col:has(img[alt^=\"Oma tilausmainos\"])","div[class|=\"ProductRecommendationCarousel__CarouselContainer\"]",".bannerit-banneripalkki","div:has(> [id|=\"ad-slot\"]),\ndiv[id^=\"ad-slot-\"]","[class*=\"block-boxes-ad-300x250\"]","#header-standard-container,\n[data-testid^=\"div-gpt-ad-\"]","#front_big_event,\n#front_big_event > span,\n.itemwide:has([href=\"https://www.nextory.fi/partner-collaboration/tiketti/\"])","div[id^=\"Nostemedia_Desktop\"]","#cnt_lista tr:has(.mainosinline) + tr:has(> .divid),\n.contentti:has(> .mainos-mob:only-child),\n.contentti:has(> .mainos_yla:only-child),\n[class^=\"mainos\"]:not(:only-child)",".ctaad","[data-mobile-ad-unit-id],\ndiv[class=\"w-full bg-black border-gray-200 border-b\"]:has(a[href^=\"http://pubads.g.doubleclick.net/\"])","aside > div[class] > a[href^=\"https://www.tivi.fi/kumppanisisallot/\"],\nsection > .lazyload-wrapper + div[class]:has(> a[href^=\"https://tivi.fi/kumppanisisallot/\"]),\nsection > div[class] > a[href^=\"https://www.tivi.fi/kumppanisisallot/\"]","#banner_panorama_bottom,\n#footer_partner_links,\ndiv#banner_panorama_topmost,\ndiv#panorama_top,\ndiv#panorama_topmost","div[class*=\"adViewPage_maxWidthWrap\"]:not(div[class^=\"adViewPage_adWrap\"]),\ndiv[class=\"w-full py-2 px-2\"]:has(> div > div > div[id=\"banner_top\"][class^=\"bannerAd\"])",".appnexus-container",".billboard",".tsv3-c-common-forum-threadviewer__messages__item:has(.smartad),\n.tsv3-c-common-twocolumnslayout:has(div[class*=\"element--nativead\"]),\n.tsv3-c-common-twocolumnslayout__row__right:has(.noad-hideaction-self):not(:has(.tsv3-c-ts-newstip)):not(:has(.tsv3-c-common-forum-threadlist)),\n[class=\"tsv3-c-common-article__contentad notloaded\"],\n[data-readpeakurl^=\"https://app.readpeak.com/ads/\"],\ndiv[class*=\"tsv3-c-common-smart noad-hideaction\"]",".slideshow","#main > .ads","#right-sidebar,\n.adsanity-single,\n.top-bar",".cat-kaupallinen-yhteistyo,\n.urjal-widget.main:has(a[href=\"https://urjalansanomat.fi/verkkomainonta/\"]),\n.urjal-widget.main:has(a[href=\"https://ysiauto.fi/\"]),\n.widget:has(> a[href=\"/lounaat\"])","#auto-grid-container-5c40764673d19",".lazyload-wrapper:has(.eo-embed-announcements-container),\n[data-test=\"mainTeaserColumn\"][href^=\"https://www.uusisuomi.fi/kumppanisisallot/\"],\naside [data-test=\"tabs\"] [href^=\"https://www.uusisuomi.fi/kumppanisisallot\"],\naside [href^=\"https://track.adform.net/\"],\naside [href^=\"https://www.ilmarinen.fi/\"],\naside a[data-ga-teaser-name=\"PartnerContentTeaser\"]",".partner-blog-list,\n.side-list.commercial-blog-studio,\na[class*=\"commercial-blog-card\"]","div#etuoviVVAdPrototype",".lazyload-wrapper:has(.at-embed-container),\ndiv[width]:has(> [id|=\"almad-parade\"])",".widget_block","img[src^=\"https://ads.v2.fi/\"]:not([src$=\"discomainos.png\"], [src$=\"facebookmainos.jpg\"], [src$=\"instamainos.jpg\"], [src$=\"twittermainos.jpg\"], [src$=\"youtubemainos.jpg\"])","#bodyarea td[width=\"100%\"][valign=\"top\"] + td[valign=\"top\"]","div.display-ad",".online-promotion-bar",".AutomaticDfpWidget,\n.DfpWidget",".type-advertorial",".sdaelem.td-block-span12,\n.vausda","#block-isalennuskoodit,\n[href^=\"http://pelikone.fi/out/\"],\naside.sticky.bottom-0:has(> #block-isalennuskoodit:only-child)",".ads_carousel-2.widget",".elementor-motion-effects-parent:has(.strossle-sidebar),\n.elementor-widget-shortcode:has(#QADY),\n.elementor-widget-shortcode:has(.vu-adlabel),\n.elementor-widget-shortcode:has([data-ad-unit-id]),\n.page-ad__location,\n.vu-adlabel,\n.vu-content-injected-middle,\narticle.rp-lift.featured-post,\nsection[id^=\"front-page-parade\"],\nsection[id^=\"front_page_parade\"]","[id|=\"gpt-slot-billboard\"],\nli[class^=\"cg-\"][data-role=\"items-list-item\"]:has(> div > [id^=\"gpt-slot-results-\"][id*=\"rectangle\"])",".banner-mainos,\n.mobiiliylabanner,\ndiv[class*=\"artikkeliad\"],\ndiv[class*=\"artikkelimainos\"]",".d-md-block.d-lg-block.d-none,\n.kumppani-artikkelit,\ndiv[class*=\"native-article\"] > div[class=\"ezrichtext-field\"] > p > a[href^=\"https://danskebank.fi/\"],\ndiv[class^=\"banner\"] > a[href=\"https://www.viisasraha.fi/Taloushaltuun\"]",".code-block:has(ins[class=\"adsbygoogle\"])",".td-a-rec,\n.td-footer-wrap .td_block_title:has(+ .td-a-rec),\n.td-post-content .code-block,\n[href^=\"https://in.matsmart.fi/t/\"],\n[href^=\"https://track.adtraction.com/\"],\ndiv[id|=\"nm-300x300\"],\ndiv[id|=\"polii\"]:has([id|=\"nm-300x300\"] + br + br)",".article-sponsored,\na[class=\"article-item articlestream-item unloaded\"][data-sponsored=\"1\"],\nsection[class^=\"sbsads\"] + section[class^=\"sbs-articleitems full-size-list\"][data-module_position_id=\"612\"]",".voima-banneri-etusivulla,\ndiv[class|=\"voima-jutun-sisalla\"]:has(.voima-adlabel)",".wnd-free-stripe-link",".widget_media_image",".mobile-top-ad",".adBanner",".advertisement-slot,\n.commercial",".bfastmag-a-d-v,\n.widget:has([href^=\"http://pizza-online.fi/tt/\"]),\n.widget:has([href^=\"https://c.trackmytarget.com?\"]),\n.widget:has([href^=\"https://kauppa.latvala.com\"]),\n.widget:has([href^=\"https://med.etoro.com/\"]),\n.widget:has([href^=\"https://tc.tradetracker.net/\"]),\n.widget:has([href^=\"https://track.adtraction.com/\"]),\n.widget:has([href^=\"https://www.awin1.com/\"]),\n.widget:has([href^=\"https://www.kahvivertailu.fi\"]),\n.widget:has([rel=\"sponsored\"]),\n.widget:has([src^=\"https://track.adtraction.com/\"]),\n.widget:has(h2:only-child):has(+ .widget [href^=\"https://c.trackmytarget.com?\"]),\n.widget:has(h2:only-child):has(+ .widget [href^=\"https://www.awin1.com/\"]),\n.widget:has(h2:only-child):has(+ .widget [src^=\"https://track.adtraction.com/\"]),\n.wp-block-columns:has([href^=\"https://c.trackmytarget.com?\"]),\na[href=\"https://ostalohjalta.fi\"],\na[href=\"https://ostavihdista.fi\"]",".ad:not(:has(img[src*=\"doc_id=555723\"])):not(:has(img[src*=\"doc_id=553464\"])),\n.ad[class*=\"panorama\"],\n.ad[class*=\"paraati\"],\n.ad[class*=\"ylaboksi\"],\n.tarranurkka,\na[href^=\"/artikkeli-kaupallinen-\"]",".widget:has(.mainossidebar)",".b-area-ad-sidebar,\n.b-otavamedia-ads,\n.gb-otavamedia-ad,\n.s-area-ad-header,\n.wrap-top-ad,\ndiv[class$=\"kaupallinen-yhteistyo\"]","#fel-ad-banner","li:has([href^=\"https://track.adtraction.com/\"])","a[href=\"https://www.jurinet.fi\"]","[data-id=\"adsense\"]",".ad2",".jp_adsense_ad_container",".ad-article",".td_block_wrap.td-pb-border-top.td_flex_block:has(a[href=\"https://gekkonen.net/nettikasinot/\"]),\n.td_block_wrap.td_block_text_with_title:has(a[href^=\"https://affmore.com/\"]),\n.tdm-pricing-wrap,\n.tdm_block_pricing,\n.widget:has(.adsbygoogle),\n.widget:has([rel^=\"https://affmore.com/\"]),\n.wpforo-ad,\na[href^=\"https://affmore.com/\"],\na[href^=\"https://record.njordaffiliates.com/\"]","#hise-items-container,\n.grid-element-container:has(.hise-link[href^=\"https://\"])","div[id^=\"open_\"]",".hidden-print.panel-default.panel:has(kc-ad),\nkc-ad","#text-81,\n#text-82",".konsolifin-vaakamainos","#partners-container-big,\n.kotikokki_ensighten_ad","#ticker",".ads-desktop,\n.ads-mobile,\n.block-box.news-post:has(a[href^=\"https://www.metropoli.net/rahapelit/\"])","div.centered.motot-well-inverse.well[style^=\"padding-\"]","#ads-sidebar-top,\n#featured > figure[class] > a[href],\n#left-float > figure[class].wp-block-image > a[href][target][rel] > img[class][src],\n.ad.content-center,\n.content-center.header-nav-ad,\n.premium_container,\n.related-posts + figure[class].wp-block-image > a[href][target][rel] > img[class][src],\n.sidebar-element > .wp-block-image,\n.social-post + div + figure[class].wp-block-image > a[href][target][rel] > img[class][src],\n.wp-block-image > figure[class] > a[href],\n[aria-roledescription=\"Slideshow\"][aria-label~=\"Banner\"]:has(a[href][target=\"_blank\"]),\nfooter .quote:has(figure[class].wp-block-image > a[href]),\nli:has(a[href*=\"/202\"]):has(a[href*=\"nettikasino\"]),\nsection.post-single > figure[class].wp-block-image > a[href][target][rel] > img[class][src]",".tdc-element-style.td-pb-row.wpb_row.tdi_4.vc_row",".cb-banneri-uusi","[href=\"http://www.vertaa.fi/lentoliput/\"]",".all-adds","#PowerRectangle,\n#PowerSkyscraper,\n[href^=\"https://tc.tradetracker%2Enet/\"],\na[rel^=\"sponsored\"]","footer > .container.tdt-ad-wrap","#p0,\ndiv#main-content > div:first-of-type[style=\"overflow:visible\"],\nul#picture_legend + div[style=\"overflow:visible\"]","#fb-root + div > div[style=\"background-color: #fff; margin: 0 auto; padding: 20px; display: table; min-width: 300px; max-width: 100%; font-family: 'Open Sans', sans-serif; font-size: 14px;\"],\n.ad300x300","div[class] + div[class] ~ div[class]:has(> .lazyload-wrapper [data-adfscript])","#div-ff2-top,\n.windowbg3:has(#div-ff2-bottom)","a[href*=\"mst-yhtiot\"]","#custom_html-63,\n#text-32,\n[href=\"https://pt-media.org/pikakasinot/\"],\n[href^=\"https://kasinopartio.com/\"],\nsection:has(> a[href=\"https://nocompromiseclothing.com/\"])","#mw-data-after-content > div,\na#top ~ #siteNotice.mw-body-content"];

const hostnamesMap = new Map([["*",0],["alandstidningen.ax",1],["nyan.ax",[2,3]],["navigatormagazine.fi",[2,307]],["promaintlehti.fi",2],["sjofart.ax",4],["adressit.com",5],["keskustelu.afterdawn.com",6],["aijaa.com",7],["aland.com",8],["alypaa.com",[9,10]],["pelikone.fi",[10,323,324]],["ampparit.com",[11,12,13]],["golfpiste.com",[12,32]],["muropaketti.com",[12,66]],["nettiauto.com",[12,68,69]],["nettikaravaani.com",12],["nettikone.com",[12,69]],["nettimokki.com",12],["nettimoto.com",12],["nettivaraosa.com",12],["nettivene.com",12],["nettivuokraus.com",12],["alibi.fi",[12,115,116]],["anna.fi",[12,121,122,123]],["eralehti.fi",[12,170,171,172]],["hymy.fi",[12,116,212]],["kaksplus.fi",[12,98,122,234,235]],["kipparilehti.fi",12],["kotiliesi.fi",[12,123,235,258]],["koululainen.fi",12],["rakennusmaailma.fi",[12,172,294,335]],["seura.fi",[12,351]],["suomenkuvalehti.fi",[12,235,362]],["tekniikanmaailma.fi",[12,172,293,294,335,379]],["venelehti.fi",[12,419]],["luukku.com",[13,63]],["iijokiseutu.fi",[13,214]],["kaleva.fi",[13,214,237,238]],["kirkkojakaupunki.fi",13],["koillissanomat.fi",[13,214]],["kuntalehti.fi",[13,265]],["lapinkansa.fi",[13,214,238,268]],["mtvuutiset.fi",[13,301,302]],["pohjoisenpolut.fi",[13,214]],["pyhajokiseutu.fi",[13,214]],["raahenseutu.fi",[13,214]],["rantalakeus.fi",[13,214]],["seiska.fi",[13,350]],["siikajokilaakso.fi",[13,214]],["styleroom.fi",[13,358]],["keskustelu.suomi24.fi",[13,366]],["viinilehti.fi",13],["arcticinsider.com",14],["arvokisat.com",[15,16]],["herkkusuut.com",[15,16]],["huuhkajat.com",15],["laliiga.com",[15,16,52]],["leijonat.com",[15,16,52,58,59]],["nainen.com",[15,16,67]],["nhlsuomi.com",[15,16]],["suomif1.com",[15,16,52,90,91]],["suomifutis.com",[15,16,90,91,92]],["suomikiekko.com",[15,16,58,90,91,93]],["suomikoris.com",[15,16,90]],["suomiurheilu.com",[15,16,59,90]],["susijengi.com",[15,16]],["tinderinparhaat.com",[15,95]],["valioliiga.com",[15,16,91,100]],["viikonloppu.com",[15,16,51,101]],["metropoli.net",[15,452]],["sketsi.net",[15,16,460]],["eurheilu.org",[15,16]],["askelterveyteen.com",17],["myanimals.com",17],["aitiydenihme.fi",17],["mielenihmeet.fi",17],["autotalli.com",18],["brbikers.com",19],["elmotv.com",20],["etuovi.com",[21,22]],["mikrobitti.fi",[22,130,295]],["rantapallo.fi",[22,337]],["talouselama.fi",[22,130,246,372]],["etusuora.com",23],["facebook.com",24],["feissarimokat.com",25],["fillaritori.com",26],["findance.com",27],["foorumimme.com",28],["juttelu.com",28],["munfoorumi.com",28],["foorumi.eu",28],["keskustelu.info",28],["munpalsta.net",28],["futisfani.com",[29,30,31]],["kiekkofani.com",[30,31,42,43]],["penkkiurheilu.com",[30,31,43]],["uutisankka.com",[30,31,98,99]],["kiinteistoposti.fi",[30,251]],["projektiuutiset.fi",[30,330]],["halloota.com",33],["hardelli.com",34],["huoltovalikko.com",35],["ilmastointilaitteet.com",36],["jaakiekonmmkisat.com",37],["jalkapallonmmkisat.com",37],["ruuhkavuodet.fi",[37,347]],["jatkoaika.com",38],["kalamies.com",[39,40]],["edgeski.fi",[39,158,159]],["foregolf.fi",[39,159]],["rodeosnow.fi",[39,159]],["kalastus.com",41],["kodinkoneopas.com",44],["koeajolle.com",[45,46,47]],["inssinosingot.fi",[45,220]],["verkkouutiset.fi",[47,420]],["koneporssi.com",48],["konekuriiri.fi",48],["kukasoitti.com",49],["kuvaton.com",[50,51]],["kuvake.net",[50,451]],["leffatykki.com",[53,54,55,56,57]],["pelaajat.com",[53,82]],["animelehti.fi",[53,118,119,120]],["como.fi",[53,54,145,146,147,148,149,150,151,152]],["episodi.fi",[53,54,118,119,120,146,147,148,168,169]],["fum.fi",[53,103,146,147]],["inferno.fi",[53,54,55,118,119,120,146,147,169,219]],["pelaaja.fi",[53,54,55,146,148,149,169,322]],["rumba.fi",[53,54,119,120,146,147,148,150,152,346]],["soundi.fi",[53,119,146,147,148,150]],["tilt.fi",[53,54,103,119,120,147,148,150,151,152,394]],["lumipallo.fi",[57,279]],["listafriikki.com",60],["tanssiin.fi",[60,178,375]],["outlook.live.com",61],["lottoarvonta.com",62],["maastohiihto.com",[64,65]],["jaatama.fi",[64,227]],["retkilehti.fi",[64,341,342]],["riistalehti.fi",[64,342,344]],["m.nettiauto.com",70],["m.nettikaravaani.com",70],["m.nettikone.com",70],["m.nettimokki.com",[70,73]],["m.nettimoto.com",70],["m.nettivaraosa.com",70],["m.nettivene.com",70],["m.nettivuokraus.com",70],["www.nettiauto.com",[71,72]],["www.nettikaravaani.com",72],["www.nettikone.com",72],["www.nettimokki.com",[72,74]],["www.nettimoto.com",[72,75,76]],["www.nettivaraosa.com",72],["www.nettivene.com",[72,76,77]],["www.nettivuokraus.com",72],["nopeustesti.com",78],["pakkotoisto.com",79],["keskustelu.pakkotoisto.com",80],["palkkavertailu.com",81],["pienimatkaopas.com",83],["puhelinvertailu.com",84],["rahakirstu.com",85],["sammysatv.com",[86,87]],["karjalainen.fi",[86,243]],["ap-cdn.sanomagames.com",88],["sportti.com",89],["terveydenasialla.com",94],["tvmatsit.com",[96,97]],["ehandel.fi",[96,163]],["hardware.fi",[98,196]],["metsalehti.fi",[98,291]],["viisitahtea.com",102],["vuokraovi.com",[103,104]],["finnkino.fi",[103,184]],["aamulehti.fi",[105,106,107]],["hs.fi",[106,107,211]],["is.fi",[106,224]],["jamsanseutu.fi",[106,107]],["janakkalansanomat.fi",[106,107]],["kankaanpaanseutu.fi",[106,107]],["kmvlehti.fi",[106,107]],["merikarvialehti.fi",[106,107]],["nokianuutiset.fi",[106,107]],["rannikkoseutu.fi",[106,107]],["satakunnankansa.fi",[106,107]],["suurkeuruu.fi",[106,107]],["sydansatakunta.fi",[106,107]],["tyrvaansanomat.fi",[106,107]],["valkeakoskensanomat.fi",[106,107]],["aamuposti.fi",108],["esaimaa.fi",[108,173]],["ess.fi",[108,174]],["forssanlehti.fi",108],["hameensanomat.fi",108],["hankasalmensanomat.fi",108],["heinavedenlehti.fi",108],["helsinginuutiset.fi",108],["iisalmensanomat.fi",108],["ita-savo.fi",[108,173]],["itahame.fi",108],["joroistenlehti.fi",108],["joutsenolehti.fi",108],["juvanlehti.fi",108],["kaakonkulma.fi",108],["kangasniemenlehti.fi",108],["karkkilantienoo.fi",108],["keski-hame.fi",108],["keski-uusimaa.fi",108],["keskilaakso.fi",108],["koillis-savo.fi",108],["kouvolansanomat.fi",[108,173]],["ksml.fi",108],["kymensanomat.fi",[108,173,174]],["lansi-savo.fi",[108,173]],["lansi-uusimaa.fi",108],["lansisaimaa.fi",108],["lansivayla.fi",108],["lappeenrannanuutiset.fi",108],["laukaa-konnevesi.fi",108],["lopenlehti.fi",108],["loviisansanomat.fi",108],["luoteis-uusimaa.fi",108],["luumaenlehti.fi",108],["mantsalanuutiset.fi",108],["mattijaliisa.fi",108],["miilu.fi",108],["mikkelinkaupunkilehti.fi",108],["nurmijarvenuutiset.fi",108],["pieksamaenlehti.fi",108],["pielavesi-keitele.fi",108],["pitajalainen.fi",108],["pitajanuutiset.fi",108],["pyhtaanlehti.fi",108],["sampolehti.fi",108],["savonsanomat.fi",108],["seinajoensanomat.fi",108],["seutuneloset.fi",108],["sipoonsanomat.fi",108],["sisa-savolehti.fi",108],["sisasuomenlehti.fi",108],["sjl.fi",108],["soisalonseutu.fi",108],["tamperelainen.fi",108],["tollotin.fi",108],["turkulainen.fi",108],["uusilahti.fi",108],["uusimaa.fi",108],["uutis-jousi.fi",108],["uutisvuoksi.fi",[108,173]],["vantaansanomat.fi",[108,413]],["viikkosavo.fi",108],["viispiikkinen.fi",108],["viitasaarenseutu.fi",108],["warkaudenlehti.fi",108],["puruvesi.net",108],["aamuset.fi",109],["akaanseutu.fi",[110,111,112]],["lvs.fi",[110,111,112,280]],["orivedensanomat.fi",[110,111,280,317]],["pirkkalainen.fi",[110,111,280,326]],["shl.fi",[110,111,112,280]],["ylojarvenuutiset.fi",[111,112,280,435]],["aksa.fi",113],["alfatvuutiset.fi",114],["alueviesti.fi",117],["apteekkari.fi",124],["apu.fi",[125,126,127]],["eeva.fi",[126,161,162]],["lily.fi",[126,274]],["meillakotona.fi",[126,127,162,274,289,290]],["terve.fi",[126,274,290,385]],["arvopaperi.fi",[128,129,130]],["uusisuomi.fi",[129,130,406]],["kauppalehti.fi",[130,244,245,246]],["mediuutiset.fi",[130,245,288]],["tekniikkatalous.fi",[130,380,381]],["tivi.fi",[130,381,395]],["audiovideo.fi",131],["auto1.fi",[132,133,134]],["ilmainensanakirja.fi",[133,134]],["testeri.fi",[133,134]],["blogit.fi",134],["autobild.fi",135],["avainlehti.fi",136],["avecmedia.fi",137],["avplus.fi",138],["bittiraha.fi",139],["blogbook.fi",140],["bomber.fi",141],["boy.fi",142],["caravan-lehti.fi",143],["cdon.fi",144],["dailyfinland.fi",153],["demokraatti.fi",154],["digi-kuva.fi",155],["download.fi",156],["duunitori.fi",157],["edukas.fi",160],["ei-toimi.fi",164],["enontekionsanomat.fi",[165,166]],["haapavesi-lehti.fi",165],["inarilainen.fi",[165,166]],["kainuunsanomat.fi",[165,166]],["kalajokilaakso.fi",165],["kalajokiseutu.fi",165],["keskipohjanmaa.fi",165],["kittilalehti.fi",[165,166]],["kotikulmilta.fi",165],["kotilappi.fi",[165,166]],["kuhmolainen.fi",[165,166]],["kuusamonseutu.fi",165],["lestijoki.fi",165],["levinyt.fi",165],["luoteis-lappi.fi",[165,166]],["meantornionlaakso.fi",165],["nivala-lehti.fi",165],["perhonjokilaakso.fi",165],["pietarsaarensanomat.fi",165],["saariselansanomat.fi",[165,166]],["selanne-lehti.fi",165],["sompio.fi",[165,166]],["sotkamolehti.fi",[165,166]],["ylakainuu.fi",[165,166]],["epari.fi",167],["ilkkapohjalainen.fi",[167,215]],["jarviseutu-lehti.fi",167],["jurvansanomat.fi",167],["komiat.fi",167],["suupohjansanomat.fi",167],["viiskunta.fi",167],["metsastysjakalastus.fi",[171,172,293,294]],["etlehti.fi",175],["hyvaterveys.fi",[175,213]],["soppa365.fi",175],["etn.fi",176],["f1-forum.fi",177],["feedi.fi",178],["fiksukuluttaja.fi",[179,180]],["lehtikeidas.fi",[180,272]],["fillarifoorumi.fi",181],["finder.fi",182],["findit.fi",183],["flashscore.fi",185],["fonecta.fi",186],["fontanka.fi",187],["foreca.fi",188],["fuengirola.fi",[189,190]],["kaaoszine.fi",[190,232]],["paakallo.fi",[190,254,320]],["puheenaiheet.fi",[190,332]],["mesta.net",190],["futissuomi.fi",191],["gamereactor.fi",192],["glu.fi",193],["gogolf.fi",194],["haat.fi",195],["hattulaan.fi",197],["reska.fi",197],["hauskimmat.fi",198],["hbl.fi",199],["ostnyland.fi",199],["vastranyland.fi",[199,416]],["heili.fi",[200,201]],["outokummunseutu.fi",[201,319]],["pielisjokiseutu.fi",[201,319]],["pogostansanomat.fi",[201,319]],["prsanomat.fi",201],["ylakarjala.fi",[201,319]],["helsinkitimes.fi",202],["hevosurheilu.fi",203],["hidastaelamaa.fi",204],["hifimaailma.fi",205],["high.fi",206],["hinta.fi",207],["hintaopas.fi",208],["hintaseuranta.fi",209],["historianet.fi",210],["tieku.fi",210],["iltalehti.fi",216],["iltapulu.fi",217],["impe.fi",218],["bbs.io-tech.fi",[221,222]],["www.io-tech.fi",[222,223]],["iskelma.fi",[225,226]],["radionova.fi",[226,333]],["voice.fi",[226,426]],["m.jaatama.fi",228],["jahtimedia.fi",229],["juoksufoorumi.fi",230],["jvg.fi",231],["kaasujalka.fi",233],["keskustelu.kaksplus.fi",236],["kamera-lehti.fi",239],["kangasalansanomat.fi",240],["kansalainen.fi",241],["kansantahto.fi",242],["keskustelu.kauppalehti.fi",247],["toimitilat.kauppalehti.fi",248],["kauppojen-aukioloajat.fi",249],["kiakkoradio.fi",250],["kilipailut.fi",252],["kinuskikissa.fi",253],["klangi.fi",254],["suomenautolehti.fi",[254,361]],["kokemaenjokilaakso.fi",255],["koneviesti.fi",[256,257]],["maaseuduntulevaisuus.fi",[257,282]],["kotimaa.fi",259],["kotimaatutuksi.fi",[260,261]],["lomamatkalle.fi",[261,276]],["kotimikro.fi",262],["kuljetusnet.fi",263],["kulutusluottovertailu.fi",264],["kuntatekniikka.fi",266],["kuntsari.fi",267],["laitilansanomat.fi",267],["lapuansanomat.fi",269],["lauttakyla.fi",270],["lbaanijakuva.fi",271],["liberolehti.fi",273],["livetaajuus.fi",275],["lounaspori.fi",277],["ls24.fi",278],["maalampofoorumi.fi",281],["maaseutumedia.fi",283],["markkinointiuutiset.fi",284],["matkabongaukset.fi",285],["matkapuhelinfoorumi.fi",286],["mediaviikko.fi",287],["metsastajaliitto.fi",292],["misssuomi.fi",296],["mobiili.fi",297],["monster.fi",298],["moottori.fi",299],["motouutiset.fi",300],["mtv.fi",301],["app.mtvuutiset.fi",303],["mutsimedia.fi",304],["myheritage.fi",305],["napsu.fi",306],["nelonen.fi",308],["netti-tv.fi",[309,310]],["synonyymit.fi",310],["nettitrendi.fi",311],["asunnot.oikotie.fi",[312,313]],["toimitilat.oikotie.fi",313],["olutposti.fi",314],["omalahio.fi",315],["orimattilansanomat.fi",316],["osterbottenstidning.fi",318],["sydin.fi",318],["vasabladet.fi",[318,414]],["palloliitto.fi",321],["suomela.fi",[324,359]],["teknavi.fi",[324,378]],["pelit.fi",325],["pkank.fi",327],["pointti.fi",328],["pottupellossa.fi",329],["proshop.fi",331],["radiovoima.fi",334],["rakentaja.fi",336],["ratkojat.fi",338],["redfoxsanakirja.fi",339],["reservilainen.fi",340],["riimihaku.fi",343],["ristinvoitto.fi",345],["ruutu.fi",348],["satakunnanviikko.fi",349],["seurakuntalainen.fi",352],["seutumajakka.fi",353],["sijoittaja.fi",354],["sijoitustieto.fi",355],["somerolehti.fi",356],["sss.fi",357],["suomen118.fi",360],["suomenmaa.fi",363],["suomi24.fi",364],["chat.suomi24.fi",365],["www.suomi24.fi",367],["suomimobiili.fi",368],["superlehti.fi",369],["supla.fi",370],["svl.fi",371],["taloustaito.fi",373],["talviopas.fi",374],["turisti-info.fi",374],["teatteritanssi.fi",376],["tehylehti.fi",377],["telsu.fi",382],["tennis.fi",383],["tervareitti.fi",384],["terveyskauneus.fi",386],["ticketmaster.fi",387],["tiedonantaja.fi",388],["tiendeo.fi",389],["tiketti.fi",390],["tilannehuone.fi",[391,392]],["irc-galleria.net",[391,446]],["tilisanomat.fi",393],["tori.fi",396],["autot.tori.fi",397],["m.tori.fi",398],["traktorpool.fi",399],["ts.fi",400],["tulikulma.fi",401],["turuntienoo.fi",402],["ulvilanseutu.fi",403],["urjalansanomat.fi",404],["uudenkaupunginsanomat.fi",405],["puheenvuoro.uusisuomi.fi",407],["vapaavuoro.uusisuomi.fi",[407,408]],["www.uusisuomi.fi",409],["uusiteknologia.fi",410],["v2.fi",411],["vagarena.fi",412],["sevendays.vasabladet.fi",415],["vau.fi",417],["vauva.fi",418],["vertaa.fi",421],["viikkopk.fi",422],["viisasraha.fi",423],["viranomaisuutiset.fi",[424,425]],["gekkonen.net",[424,444]],["voima.fi",427],["webnode.fi",428],["wizhdsports.fi",429],["x2.fi",430],["xracing.fi",431],["yhteishyva.fi",432],["ykkoslohja.fi",433],["ylasatakunta.fi",434],["yrittajat.fi",436],["fel.gg",437],["lentopallo.info",438],["murtopallo.net",438],["murha.info",439],["piipaa.info",440],["2pos.life",441],["aasiakas.net",442],["deitti.net",443],["huuto.net",445],["kilokalori.net",447],["kokemakelainen.net",448],["konsolifin.net",449],["kotikokki.net",450],["motot.net",453],["mvlehti.net",454],["pallomeri.net",455],["esports.pallomeri.net",456],["polttoaine.net",457],["puskaradio.net",458],["riemurasia.net",459],["vapaasana.swedishforum.net",461],["vuodatus.net",462],["assembly.org",463],["futisforum2.org",464],["moottoripyora.org",465],["pt-media.org",466],["taisto.org",467]]);

const entitiesMap = new Map(undefined);

const exceptionsMap = new Map([["nettimokki.com",[0]]]);

self.specificImports = self.specificImports || [];
self.specificImports.push({ argsList, hostnamesMap, entitiesMap, exceptionsMap });

/******************************************************************************/

})();

/******************************************************************************/
