/*******************************************************************************

    uBlock Origin Lite - a comprehensive, MV3-compliant content blocker
    Copyright (C) 2019-present Raymond Hill

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see {http://www.gnu.org/licenses/}.

    Home: https://github.com/gorhill/uBlock
*/

/* jshint esversion:11 */

'use strict';

// ruleset: hun-0

/******************************************************************************/

// Important!
// Isolate from global scope
(function uBOL_cssSpecificImports() {

/******************************************************************************/

const argsList = ["div:has(> .ai-attributes + script + ins)","#article_end_popup,\n.banner.boxed","a[rel*=\"sponsored\"]","#a1,\n#a2","#onetrust-banner-sdk","#eu-cookie-law,\n#facebook-likebox-8,\n.wpcnt","[class*=\"advert\"]","#facebook-sharebar,\n#webaruhaz-ajanlo,\n.-contentTop,\n.a2blckLayer,\n.ctsGadx,\n.hashtags,\n.wrap,\nTD[id*=\"l_sponsor\"],\n[class*=\"adv_\"]","[class*=\"adtext\"]",".fb-exit-popup-container","#fanback,\n#permission-bar,\n.fu-container,\n.sample,\n[href*=\"hirdetes\"],\na[href*=\"adf.ly\"],\na[style=\"text-decoration:none;\"],\ntable[bgcolor=\"darkgray\"]",".content-list.content-body > .recommendation-holder,\n.content-text > .recommendation-holder,\n.left-column.col-md-8.col-sm-12 > .recommendation-holder,\n.right-column.text-center.hidden-sm.hidden-xs.col-md-4 > .recommendation-holder:nth-of-type(1),\n.right-column.text-center.hidden-sm.hidden-xs.col-md-4 > .recommendation-holder:nth-of-type(2),\n.top-column.col-xs-12 > .recommendation-holder,\ni > .recommendation-holder:nth-of-type(1),\ni > .recommendation-holder:nth-of-type(2)",".tqWLsnEEqeEw-bg,\n[style=\"z-index: 999999; background: rgba(0, 0, 0, 0.85098); display: block;\"]","[style=\"background: rgb(255, 255, 255); max-width: 720px; z-index: 9999999; opacity: 1; visibility: visible;\"]","[data-zadtype=\"billboard\"],\ndiv.mobileArticleAds,\ndiv.right-rail:has(div.ad-wrapper),\nfigure:has(a[href*=\"ignshop.hu\"])","div[id*=\"banner\"]","[class*=\"banner\"]","[app=\"tibrr-cookie-consent\"],\n[class^=\"k\"][class*=\"-container\"][class*=\"-2\"][class$=\"-hide\"]",".bpkad","A[href^=\"http://goo.gl\"]","[class*=\"reklam\"]","[id*=\"reklam\"]",".code-block:has(script + ins)","[class*=\"pea_cook\"]","[style=\"width:300px;height:250px;\"],\nscript[data-cfasync=\"false\"]","[class*=\"advertisement\"]","[class^=\"ad-\"]","#text-3","#kpopup","#sliding-popup","[id^=\"block-views-block-banners-\"]","[id*=\"banner\"]","[id*=\"etarget\"]","[class^=\"ads\"]","[id^=\"adchange\"]","#alsobox","#cookieinfo","div[id*=\"col_2\"]","[id*=\"advertisment\"]","#sutik",".bannergroup","#_iph_cp_popup,\n#cookie-bar,\n#cookie-notice,\n#cookie-window,\n#cookiebar,\n#hirdetes,\n#hirdetesek,\n.cc-banner,\n.cc-banner-wrapper,\n.cc-window,\n.cc_banner,\n.cc_banner-wrapper,\n.cc_window,\n.hird,\n.hirdetesek,\n.leet_product_banner_container,\n[class*=\"overlayBg\"],\nins[id^=\"aswift_\"]",".hirdetes","#cookie-law,\n.banner_middle",".ads_show_ad_title",".banner-wrapper",".banner-container","#overlay_readers_letter,\n#stickyHomePageRecommender,\n#webPushPopup,\n.a-hirstartRecommender,\n.m-donationBottomLine,\n.spklw-post-attr[data-type=\"ad\"],\n.widget-mini-article",".adaptiveAd[id^=\"444_cikk_mobil_\"],\n.adaptiveAd[id^=\"444_cikk_pc_\"],\n[id*=\"-banner-\"],\narticle:has(a[href*=\"hirdetes\"]),\ndiv.item:has(a[href*=\"hirdetes\"])","#text-5,\n#text-6","#galsoreklam,\n#oldalreklam,\n[href=\"https://777blog.hu/reklamblokkolo-kikapcsolasa/\"],\ndiv#rechtangle.widget:nth-of-type(5)","#cookieBox,\n#cookieBox_bg,\n.whiteBox:has(.goAdverticum)","#cookies-alert,\n[class^=\"zone_\"]","#g0,\n.az-layer,\n.big_badge,\n.floating-help-wrapper","[class*=\"ads\"]","#ajanlo","div#mymodal:has(#form-popup)",".flyout",".ez-egy-dc-doboz:has(> .double_click_doboz),\n[style^=\"min-height: 128px; background: url(\\\"https://static.agroinform.hu/static/site/img/hirdetes_up.png\\\") no-repeat center bottom -1px;\"]","#alapjarat_cikk_fekvo_1,\ndiv.header + .clearfix + .clearfix","#block-block-16,\n#block-block-22,\n#block-views-ajanlo-block,\n#sticky_footer",".mailingActionC",".ui-widget-overlay","[aria-describedby=\"cookies-dialog\"]","div.cikk_zona,\ndiv.rightside > iframe",".sidebar1 > div:first-child,\n[id^=\"hird_\"]",".mask,\n.showLink.reveal","[class*=\" adH\"]","#cookie-disclaimer,\n.brandbox",".tamogatoi,\n.wp-caption","#facebookPopUp,\n#facebookPopUpBackground,\n#szechenyi-container,\n.plus-wrapper","#_cikk_jobbhasab_2,\n#_cikk_jobbhasab_3,\n#_fooldali_header_alatti_banner,\n#_fooldali_header_banner,\n#_fooldali_jobbhasab_2,\n#_fooldali_jobbhasab_3,\n#custom_html-18,\n#custom_html-19,\n#custom_html-2,\n#custom_html-20,\n#custom_html-21,\n#custom_html-23,\n#custom_html-26,\n#custom_html-7,\n#custom_html-8","#custom_html-10","[class*=\"Advert\"]","[class*=\"etarget\"],\n[class*=\"szamlatabla\"]","[class*=\"hirdetes\"]","#CybotCookiebotDialog",".ads","#adds","p + center:has(iframe[data-src*=\"facebook\"]),\nscript + ins + h5",".cookie-notice-container","#article-2,\n#block-block-30,\n#block-block-60,\n.region-content-1-1 > div:last-child,\n.region-content-1-1 > div:nth-child(-1n+3),\n.region-content-1-3 > div:nth-child(-1n+2),\n.region-content-1-3 > div:nth-last-child(-1n+5),\n.view-banner-blokkok","#cookie","#popupajanlo","#total,\n.category-section.ad,\n.minisite","app-article-subscription-box,\napp-newsletter-modal","main + .ok-prerender","iframe[src=\"https://tunderszepek.baon.hu/tunderszepek-banner\"]",".widget_media_image",".pea_cook_wrapper","[class*=\"adcikk\"]",".hidden-xs:has(> .lablec_alatt),\n.hidden-xs:has(> .weboldal_felett),\n.tapeta.fixed,\n[data-ai],\nblockquote","[id*=\"sponsor\"]","#karrier,\n.modal,\n.modal-dialog",".modal-backdrop","#footerLogos,\n#pe_confirm,\n#underArticleAdvertisement,\n[id*=\"-ad-\"][data-x=\"1\"],\n[id^=\"div-gpt-ad-\"] + [class$=\"widget\"],\n[style=\"width:100%;text-align: center; margin-bottom:15px;\"],\na[href*=\"gemius\"],\nbody > .extraContentSection:nth-of-type(-1n+3)","#articleOfferFlag","#pe_confirm_optin_6","#ad-cikk1,\n#ad-cikk2,\n#ad-fekvo1,\n#ad-fekvo2,\n#ad-jobb1,\n#ad-jobb2,\ndiv:has(> div[id^=\"div-gpt-ad-\"])","#pe_confirm_optin_1","#taft,\n.living-earth,\n.meropixel-hide,\n.share,\n[class*=\"follow_promo_figure\"],\n[id*=\"cp_popup\"],\ndiv[class*=\"_ad\"],\ndiv[class*=\"adv\"],\ndiv[class*=\"blh-billboard-ad\"],\ndiv[id*=\"wAdBox\"]","[class*=\"adbox\"]","[id*=\"Banner\"]","div[class*=\"etarget\"]","#fbox-background","#lightview1,\n[class*=\"popupBanner\"]","#cookie_policy,\n#lw_bg1,\ndiv[style^=\"height:\"]","#newASZFLayer","#onetrust-consent-sdk,\n.o-banner--hirdetes",".real-estate-wrapper",".cookie__wrapper,\n.subscription-box,\nA[href=\"/jatek\"],\nA[href=\"/nyarimagazin\"],\n[class*=\"__ad\"],\n[class*=\"adContainer\"],\na[target=\"_blank\"][class=\"videa-wrapper\"],\niframe[src*=\"koponyeg.hu\"]",".newsletter-box","#wpgtr_stickyads_textcss_container,\n.extpp-container,\n.otw-sidebar:has(a[href=\"https://bpiautosok.hu/tamogatonk-a-te-ceged-jelenj-meg-nalunk-a-youtube-on-es-a-bpiautosok-hu-n/\"]),\n.widget.widget_text:has(.adsbygoogle),\nbody > br:first-child,\nbody > br:first-child + center,\nbody > br:first-child + center + br,\ncenter:has(> a[href=\"https://bpiautosok.hu/mediaajanlat\"]),\ncenter:has(> a[href=\"https://bpiautosok.hu/mediaajanlat\"]) + br,\ncenter:has(> font),\nfont + center,\nfooter + font, footer ~ br","#onesignal-bell-container,\n#onesignal-slidedown-container","#custom_html-11,\n#custom_html-6,\n#media_image-17,\ndiv[style=\"margin-top:20px;\"]","#upprev_box","div.bpkad","#full-desktop,\n#full-mobile,\nheader + div[style^=\"margin:\"]","#cooker_container,\n.banner_main_page_wrapper","#cadre_alert_cookies,\n#pa-push-notification-subscription,\n#sp-right > .sp-column > .sp-module.hidden-mobile,\n.banneritem","[class^=\"adsense\"]",".advert,\n.occsz-banner",".ads-container",".ads-left-container,\n.ads-name-title,\n.ads-right-container,\n.cookie-box-cnt,\n.infobar-cnt,\n.popup-ad,\napp-ads,\niframe[src^=\"https://cfusionsys.com\"]","#cookie-policy-content,\n.ad-article-comment,\n.ad-article-end,\n.ad-article-inside,\n.ad-article-inside-automatic,\n.ad-article-under-lead,\n.ad-content-top,\n.ad-header-after > *,\n.ad-header-after-article,\n.share-article","#web-push-popup","[class*=\"-adv\"]","#CookieAcceptLayer,\n#bdism1,\n#cikkajanlo,\n[class*=\"adv-\"]",".art-sidebar1,\n.art-sidebar2","#fadeandscale_background,\n#fadeandscale_wrapper",".enews-article-content .endless-shared-area",".sb-right > div:first-child","#cookie-law-info-bar","#banner_sav",".bannerContent","#headerBanner,\n#popupContentBanner-modal,\n.col-md-4.blog-sidebar:nth-child(even),\n.slidingBanner,\n.tablet-advert,\n.totop,\n.widgetDefault",".billboard","#billboard,\n[class*=\"prbox\"],\n[id^=\"linkbox_article\"]",".region-header.region",".jquery-modal.blocker.current",".cikk-halfpage.t-article-container_sidebar > div:first-child,\n.menu-sponsor_link,\n.rovat-halfpage.t-rovat-container_sidebar > div:first-child,\n.tctk,\n[id*=\"szponzoracio\"],\niframe",".cikk-vegi-ajanlo-reklamok","[id*=\"hirdetes\"]","#interstitial",".adbd-layer","body > section:not(.site-header):not(#toreskar):last-of-type","body > div[data-elementor-type=\"footer\"] ~ div[id][class*=\" \"]","[class=\"td-a-rec td-a-rec-id-content_top  tdi_62 td_block_template_1\"],\n[class=\"td-a-rec td-a-rec-id-header  tdi_53 td_block_template_1\"]","[id*=\"_ad\"]",".hirdetes-block","[class*=\"ad_\"]","[id*=\"ad_\"]",".detailRightAds,\n.min700height-desktop,\n.rltd_container [id^=\"rltd-ad-\"],\n.row:has(> #onet-ad-top),\n[class*=\"ad-\"],\n[class^=\"ads \"],\n[id^=\"ad-\"],\n[style=\"min-height: 300px;\"],\na[title=\"Hirdetés\"],\ndiv.wrapAds,\ndiv.wrapRectangle:has(#ad-cikk)",".ibb-banner-decor","[id^=\"ad_\"]","div[class*=\"contentBanner\"],\ndiv[style=\"text-align: center; margin-bottom:10px; position: relative;\"]",".sgpb-popup-dialog-main-div-wrapper",".penci-wrap-gprd-law,\n.sgpb-popup-overlay",".rckaexclude",".super","div.cookieLayer,\ndiv.supportModal","IFRAME","#article-recommend-popup,\n.adaptiveAd,\n.cookie-popup,\n.overlay-popup","[class*=\"_adv \"]",".popupunderlay,\n[class*=\"adPlace\"],\n[class^=\"goAdverticum\"]","[class*=\"adzone\"],\ndiv[id*=\"elementor-popup-modal-\"]","#catapult-cookie-bar","#darklayer,\n.views-field-nothing,\n[class*=\"_ad \"],\n[id*=\"_ad-\"]","#femina-shop-ajanlo-slider,\n.cikk-torzs [data-miniapp-id]:has(.femina-shop-ajanlo-slider-hirdetes),\n.cikk-torzs [data-miniapp-id]:has(.lapozgato-ajanlo),\n.doboz_harmados,\n.szelso-jobb > div:has(> a),\n[class*=\"kepeslinkes\"]","div[class*=\"reklam\"]",".partnership-ads",".crp_related,\ndiv[id^=\"forbesad\"],\np + [class*=\"-bekezdes-utan-\"]",".foot-logos.col-md,\n[href=\"https://www.barion.com/hu/vasarlok/arak-vasarloknak/\"],\na[href=\"http://consumer.huawei.com/hu/phones/mate10series/\"]","div:has(> [style*=\"calc\"])","#accept-container","[class*=\"banners\"],\n[href*=\"hirdetesek\"]",".etarget",".facebook-layer-box","#content-container > div > a:not([class*=\"MailListItem-\"]),\n[class*=\"magnum\"]","[class^=\"container-\"][class*=\"adZone\"]",".grey-popup-layer","#background_ad_top","#right > .xabrew300.box",".partners",".spleft,\n.spright","[class$=\"responsive-300px-600px\"],\na[onclick*=\"/muvelet/hozzaferes/kapcsolodas.php?id=\"],\nbody > style,\ndiv:has(> h4 + div[style*=\"calc\"])","#thanks > .hlist.nohead,\n.xabrecontainer,\na[onclick*=\"$.ajax\"],\ndiv#center:has(div > div > p > a[style=\"color: #b42223;\"]),\ndiv[class*=\"xabre-responsive\"]:not([class*=\"-980px-139px\"])",".roadblockcont",".act_hun,\n.adt_hun","#qc-cmp2-container,\n[id^=\"ibb-\"][class*=\"banner\"]",".leavingPopupLayer","#partnerek","[id^=\"zone\"]",".ad",".box-wrapper > .box-actual-magazine + .box-html","#adryf,\n.rltdwidget,\n[href^=\"https://www.webminute.hu\"],\n[id*=\"aswift\"],\ndiv.reklam_jobbra,\ndiv[style*=\"text-align\"]:has(> a > img),\ntd.txtcenter:has(> script + ins),\ntd[style=\"width: 10px;\"]:empty","#cookiekezeles","#banner,\ndiv[class*=\"Advert\"]","[class*=\"contentBanner\"]",".accept-cookies","div[id^=\"jqueryFloating\"]","#cookie_bar,\n#infobar","#banner2016kormanyhu,\n[id*=\"banner_1_29_\"]",".catch-click",".banner-widget-container",".mc-modal:has(iframe),\n[class^=\"moove-gdpr-\"],\n[id^=\"um-\"]:has(.fb-page.fb_iframe_widget)",".Ad,\n[id*=\"Ad_\"]",".Clear,\ndiv[id*=\"AdContainer\"]","#top > .p-0.container","#ajanlo_box_ah,\n#lightwindow_overlay","#player,\n#superbox",".szkozepkis","#kapubanner,\n[id*=\"_ads\"],\n[id^=\"cookieconsent\"]",".box_remote,\n.fbcont2,\n.fbfollow,\n.fbshare,\n.h-sideboard_2,\n.kalkulator","[id*=\"hirdet\"]","#cookiewarnbar","#nyeremenyModal,\n[class=\"modal-backdrop fade show\"],\n[id*=\"popup\"],\ndiv.row:has(> div.ads)","div[id*=\"Banner\"]",".hover_bkgr_fricc:has(.facebookPopupCloseButton),\ndiv[id*=\"zone-wallbanner-header\"]","#gyuri1,\n#gyuri2","[class*=\"billboard\"]","#cookieAlertBox,\n.banner_container,\n.banner_widget,\n.frame:has(> span[style^=\"font-size: 11px;\"]),\n.sy-box","[class*=\"-ad-container\"]","P[class*=\"banner\"]","[id^=\"advert\"]","div[class*=\"banner\"]","EMBED,\ndiv[class=\"module noheading\"]","#tetszett","[data-adblockonly]","#cucc,\n#layerbanner","#custom_html-3","#euro-event,\n#league-selector + .row + .row:has(.banner),\n#sponsors,\n.gdpr-cookie-notice","[class*=\"_ad\"]","#lebegodoboz,\n#szupertorony,\n[id*=\"-reklam\"],\n[id*=\"fancybox\"],\n[id^=\"hirdetes_jobb\"] + div,\n[id^=\"hirdetes_jobb_2\"] + div + div,\n[id^=\"szuperbanner_\"]","[id^=\"hirdetes\"]","#webpushSelctorFormId,\n.adcaption,\n.article-menu.panelgap,\n.article-otherelements-container content,\n.articlebox.clear.sidebar-ajanlat,\n.block-ms-box2,\n.cimlap-ajanlat.elem-1180.cimlap-grid-elem,\n.hosting,\n.hvg_push,\n.jobline-palyakezdo-feed,\n.selectWidget,\n.support-stripe,\n[class*=\"adtype-\"],\n[class=\"articleitem clear smallimage imgleft\"],\n[class=\"site-scarab-bottom open\"]","[class*=\"adsense\"]","[id*=\"-ad-\"]",".parallax_bottom,\n.parallax_top","div[class*=\"ad_\"]","#announcement,\n#cikktoolbaradomany,\n#cookiealert,\n#sidebar > table,\n.cikkszovegaction,\n.cikkszovegakcio,\n.kommentadomany,\nbody > div > a[target=\"_blank\"],\ndiv[id*=\"hirdetes\"]","[class*=\"hird-\"],\n[class*=\"hird_\"],\na[data-bs-content*=\"(hirdetés)\"]",".banner",".article-cards-inlist-ad,\n.article-text > p,\n.footer-banner-row,\n.iho-adzone,\n.social-icon","[class*=\" ad\"]",".topAdv",".shopline-box,\n.travelo-box",".cikk-vegi-ajanlo-reklamok-container","[class*=\"ad-container\"]","#ad_null_position,\n#also_bannerek,\n#index_shopline","#ot2015,\n#rightcoltd,\n#site_header","#main div[class*=\"banner\"],\n#sidebar > div[class*=\"banner\"],\ndiv.read div[class*=\"banner\"]","#_ao-cmp-ui,\n#sitemodal:has(.fb-button),\n.am_targetvideo_container,\ndiv[data-qa=\"oil-Layer\"]",".notification-popup","#bottompopup","#leftPoszter-section,\n#salePoszter,\n.home-section-banner,\n.u-hide\\@mobile.flag-wrapper--fill.flag-wrapper.grid-col-lg-1-4.grid-col-md-1-2.grid-col-1.article-list__item","div[class=\"tl-state-root tve-leads-ribbon tve-trigger-hide tve-tl-anim tve-leads-track-ribbon-1 tl-anim-slide_top tve-leads-triggered\"]","#cookie-law-info-again","#roadblock-adcum-zone,\n[style*=\"text-align: center;\"]:has(> .adverticum-label + a)","#joylike,\n[class*=\"Adverticum\"],\n[class^=\"adIn\"],\n[class^=\"adPlace\"]","#cookie_container","[data*=\"banner\"]","#header","#cookieSpan,\ndiv.bottom_sticky_banner","#check-also-box,\n#fejlec-hirdetes,\n[id^=\"cikken-beluli-hirdetes-\"]","#cookie-consent-dialog","#above_article_banner,\n#advertisements,\n#below_content_banner,\n#left_banners,\n#right_banners,\n#social,\n#wide_banners,\n.article_banner,\ndiv.subscribe_module,\ndiv[class=\"fb-like fb_iframe_widget\"]",".cookies-message-container","#cookieAcceptanceContainer","[id*=\"advert\"]","#nap_ajanlata,\n.tamogatott,\n.vippr,\n[class*=\"banner-\"],\n[class*=\"offer prbox\"],\n[class*=\"pr--\"],\n[class^=\"pr-\"],\n[class^=\"prbox\"],\ndiv.endless-shared-area,\ndiv[id*=\"billboard\"],\ndiv[id*=\"linkbox\"]",".qc-cmp2-container","#vshu-box,\n.integralt_felso_zona,\n.recommendationzone,\n[id*=\"adsense\"]","div:has(> a + h6)",".kapu,\n.mini_slider_div0","[class*=\"Banner\"]","div.accept-cookies","[name*=\"banner\"]",".adbg",".category > #prodstop1,\n.single-post > #prodstop1","#current_promotions_block,\n#skin-left,\n#skin-right,\n.box-general.clearfix,\n.discount.clearfix.nonLpk,\n.fullwidth.current_promotions_block","#beuszoAjanlo,\n#cikkalatti,\n#floating-recommendation,\n#mc-holder,\n#ovasar,\n#pr-box,\n#right-ecom,\n#top,\n.col-visible-xl.r-side.col-xl-4,\n.email-under-article,\n.frip-inline:has([data-module-name=\"inline-article\"]),\n.hird300,\n.kiskepes,\n.magnum,\n.panorama-wrapper,\n.pr-item,\n.spar,\n.szoveges,\n[data-module-name=\"hirlevel\"],\n[data-module-name=\"ingatlanbazar\"],\n[data-module-name=\"koponyeg\"],\n[data-module-name=\"videa\"],\n[id^=\"szponz-\"],\n[size=\"300x600\"],\ndiv[class$=\"widget\"]","#ac",".newsletter-layer,\ndiv.article-recommendation-zones","#accept-cookie","div.lol:has(> a[onclick=\"getValue()\"]),\ndiv.widget:has(> div.textwidget > p > script)",".cikkhirdetes,\n.sticky1hirdet","[class*=\"adserver\"]","[class*=\"-ad\"]","#navi_btm + div,\nimg[src^=\"https://logout.hu/muvelet/hozzaferes/kapcsolodas.php\"]",".nobanner,\n[class^=\"banner_\"],\n[id^=\"banner_\"]","#exposeMask","#page_PopupContainer",".goAds,\n.visible-lg.container,\ndiv[class=\"container-full\"][style=\"background:#fff\"]:has(.topadv)","#eucookielaw,\n.ad-magnum,\n.ad-verticalfull,\n[class*=\"simpleads\"]","#block-block-12,\n#block-block-19,\ndiv.gdprBoxContainer,\ndiv.promo-bar",".modal[role=\"dialog\"],\napp-calendar,\napp-facebook-popup,\napp-newsletter-popup","#cboxOverlay,\n#colorbox","#cookie-msg","#floatingBox,\n.ui-floating-message,\n.wsp-wrap,\n[class*=\"tBanner\"]",".banner_row,\n.proposer,\n.read_vs,\n.rightbanner",".cookie-bar,\n.mrc-bnr-plchldr,\n.popup-wrap,\n[class^=\"banner\"]",".sticky",".article-textlinkbox","#ad-image-big,\n#fadeandscale,\n#portfolioEzekIsErdekelhetnek,\n#recipeAndRelateds > h2.noprint,\n#sidebar_ads_box_2,\n.billboard-cikk,\n.hir-fekvo,\n[class*=\"ads_box\"],\ndiv[class=\"billboard fr\"],\ndiv[class=\"fej-elso-sor cf\"],\ndiv[id*=\"-ad-\"]",".allow-cookie-stripe","#app-advice,\n#app-commission,\n.x-marketing",".cim-reklam,\n.widget_text.widget.widget_custom_html",".om-holder","[class*=\"box ajanlo\"],\n[id*=\"ctnet\"]",".adbox","#sticky,\n.b336","[align=\"center\"] > a[href*=\"banner\"],\n[class^=\"ui-dialog\"]",".fb-page-cont,\n.topHorizontalBanner,\n[src^=\"/public/img/efi/\"]","#mobilinstruments,\n#stickyfooter,\n.cikkajanlo,\n.totalcar,\n[id*=\"billboard\"],\na[href^=\"https://bit.ly/\"]","#custom_html-4,\n#primary-sidebar,\n.right","#sidebar",".banner-bottom",".ckwrap,\n.list-item.has-banner",".code-block:has(> div + ins.adsbygoogle + script)","#didyou,\n#wallpaper_left,\n#wallpaper_right,\n.bet365_connect,\n[class*=\"_szponzor_\"]","[class^=\"ad_\"]","[class*=\"adlabel\"],\n[class*=\"leftlogo\"],\n[id*=\"adserver\"]","div#show_news_box,\ndiv.cookie-message","#tab-widget",".m-fbPopup",".m-breakingLayer:has(a[href*=\"nlc.hu/balkonfanatik\"]),\n.m-pcPromoArticlePointsLayer,\n.m-pcPromoFooterLayer,\n.rubAd,\ndiv.m-articleStickySocial,\ndiv.m-breakingLayer","[data-placeholder-caption=\"hirdetés\"]",".noprint,\ndiv[class*=\"ad-container\"]","#cookie-consent",".colorbox-cookiepolicy","#datasheetNavHelp","#slidebox,\n.highlighted-banner","#detect + .wrapper","[class*=\"ad-warning\"],\n[class=\"ad-blocked\"],\n[class=\"p-t-10 ad-blocked\"]",".col-xl-8 + aside.col-xl-4.col-visible-xl,\n.mw-allow-notification-dialog,\napp-article-page app-sidebar app-free-display-inventory,\napp-sport-article-page app-sidebar app-free-display-inventory,\nkesma-advertisement-adocean,\nsection.spar","div.facebook-layer-box","[class^=\"ad\"]","#zone-halfpage,\n#zone-roaddblock,\n.centercol.sponsor","#zone-titleheader",".slidein.popup.closeablenotification.scripted,\n.zone[data-zoneid]","#cookieconsentbar,\n#subscribepopuppanelalign",".banner-content,\na[href*=\"banner_click\"]","#kutu","#recommend,\n.frame-center,\n[class^=\"f10\"],\n[class^=\"grbox\"]","[class^=\"ads-\"]",".justClassBanner","#cikkertesito-reg-form,\n.banner.clearfix,\n.inner","#pushpushgo-container,\n.ad-container,\n.ph-flexi-box-wrap,\n.ui-dialog[aria-describedby=\"newsletter-modal\"],\n.ui-widget-overlay.ui-front,\n[aria-describedby=\"dialog-welcome\"],\n[class*=\"adbreak\"],\n[class*=\"c_banner\"],\n[class*=\"placeholder\"],\n[class=\"ph ph-responsive-wrap\"],\n[data-analytics-value]","#popup",".articleMetadata,\n.container.css-table > div:not(.container),\n.edgebox-widget.show,\n.introjs-helperLayer,\n.introjs-overlay,\n.introjs-tooltip,\n.port-adbd,\n[class*=\"_spon\"],\n[class=\"advert fix-advert\"]","#BlockCikkajanlo,\n#mymodal2,\n.footer--partners,\n[data-qa=\"oil-Layer\"],\n[data-qa=\"oil-full\"],\ndiv[id*=\"adocean\"]",".lead_alatti_txt,\n.mfor_cikk_beuszo,\n.news-page > div[style*=\"background: #FFF900;\"]:first-child,\n[src*=\"/banner/\"]","#newsletter_footer,\n#twister-banner,\n.cookie-layer","#fb_like_modal",".popup","#top > div:first-child",".banner__ad","[class*=\"banner \"],\n[id^=\"overlay\"]","[aria-describedby=\"newsletter-modal\"],\n[class*=\"adv--\"]","#wallpaper,\n.wallpaper-link","#psCookieNotification,\ndiv.ad-sm-text","#cookieconsent",".adblock-confirm,\n.newsletter-modal",".std0,\nIMG[src=\"images/hirdetes.gif\"]","#gdprCookieWrap,\n[class*=\"AdWrap\"],\n[id*=\"AdWrap\"]","#enableCookieDiv","[id*=\"ctnet_ad_\"],\ndiv[class*=\"ad \"]","#fhr-cookie-bar,\n#fragment,\n[class*=\"-ad-\"]","#text-9,\ndiv.sprtrvs-ad,\ndiv.tt-shortcode-1,\ndiv.tt-shortcode-2","#menusimple2 + div,\ndiv[style=\"width:100%;height:14px;text-align:left;font-size:9px;letter-spacing:3px;color:#5F5F5F;border-bottom:1px solid #CCC;margin: 10px 0 5px 0;\"],\nscript[async] + [data-widget-id]","#push-notification,\n.kezdo-kereso,\n[box-name=\"Hirdetés\"],\n[class*=\"Adv\"],\n[class*=\"peelgame\"],\n[class^=\"adact\"],\n[class^=\"adx_\"],\n[id*=\"Advert\"],\n[id*=\"peelgame\"],\ndiv.container.banner-container.left,\ndiv.container.banner-container.right,\ndiv.container.banner-container.wide > *","#google-display","[src*=\"hirdetes_\"]",".cikk-hir,\n[class*=\"googlebox\"],\ndiv[class*=\"adserver\"],\ndiv[id*=\"kirakat\"],\ndiv[id*=\"rightad\"]","[class=\"wp-container wp-top\"]","div.fb_shares",".modal_popup","[src^=\"/uploads/images/banners/\"]",".active.popup-screen,\n.popup-box,\n.stream-item,\n[id^=\"stream-item-\"],\n[id^=\"tie-block\"]:has(.stream-title)",".rightContent + [style]","#cookie-policy-bar,\n#hatterkep,\n#rovatpromo,\n.adslabel,\n[class^=\"ads_\"],\n[class^=\"ads_\"] + .clear,\niframe[class*=\"my-fbrecommend\"]","#ecom_pr,\n.ad-wrap-100,\n.jobb_300","#magnum","[class*=\"google-cikk\"]","[style=\"height: 250px\"]","#app-cookie-policy","#modal--umbrella,\n.recommendation.recommendation--out,\n.recommendation.recommendation--pr,\n.title-section__sponsored","div.banner",".kiemelttartalombox_feher",".border-top.p-4.bg-8.cookie-alert__inner",".spu-bg,\n.spu-box,\n[style=\"margin: 8px 0; clear: both;\"]","[id*=\"_bnr\"]",".sgpb-theme-3-overlay.sgpb-popup-overlay-1402.sgpb-popup-overlay,\nimg[class*=\"sgpb-\"]",".cross-site-programmatic-zones",".cikk-torzs-content-container > .kep_szeles.kep,\n.hasznaltautok-iframe-cikk-torzs,\n.header-tk-ajanlo,\n.joautok-iframe-cikk-torzs,\n.microsite,\n.szelso-jobb-lead_container,\n.totalkarWidget,\n[class*=\"adblokk\"]","#ads,\n[id*=\"adocean\"]",".ooono_promo","div.qc-cmp-ui-container",".adsense","#popunder_featured,\n.banner_box",".leftSide > .bnr,\n.rightSide > .bnr,\n.row:has(.mainTopBnr)","#blanket,\n#popUpDiv",".hird-cont",".banner-commercial,\n.reklamnagy",".page-rightside-advert,\ndiv[id*=\"advert-container\"]","[class*=\"szovegkozi\"],\n[id*=\"reklam_\"]",".adszoveg,\n[class*=\"ad_container\"],\n[class*=\"guestbox\"],\ndiv[class*=\"microsite\"],\ndiv[id*=\"microsite\"]","#backdrop,\n#best-cars-layer,\n#beta-message-invite,\n.centerHead,\n[class*=\"Etarget\"],\n[class*=\"Hirdetes\"],\n[class*=\"advert \"],\n[class*=\"szponzor\"]","[style^=\"bottom: 0px; left: 0px; position: fixed; width:\"],\ndiv[class*=\"-ad\"],\ndiv[class*=\"hird-\"],\ndiv[class*=\"hirdetes\"],\ndiv[class=\"fej_felett cf\"],\ndiv[id*=\"etarget\"]","#sitemessage",".top-video-container-banner","[class^=\"adv\"]","[style=\"z-index: 999999; background: rgba(0, 0, 0, 0.901961); display: block;\"]",".no_banner",".footprint_cookie","[id*=\"_ajanlatunk_\"],\ndiv.floating_share","[id*=\"AdFrame\"]","[class=\"wc_content wc_contentwide\"],\n[id*=\"AdZone\"]","div.penci-wrap-gprd-law,\ndiv.sgpb-popup-dialog-main-div-theme-wrapper-1,\ndiv.sgpb-popup-overlay-42657,\ndiv.sgpb-popup-overlay-42658","[id*=\"sense-\"]","#advert",".logopic2 + .fll,\n.overlay,\n.pupopadbox,\n[class=\"cikkbanner hirdbox mh40 listafriss\"],\n[style=\"margin-left:auto;margin-right:auto;width:980px;text-align:center\"]","#sidebad,\n#spu-main,\n#text-html-widget-6,\n[class*=\"PostAd\"],\n[class=\"e3lan e3lan-top\"],\n[id*=\"-bg\"]",".Cookie--bottom,\ndiv[id^=\"ga_g\"]","[href^=\"https://rosszlanyok.hu/\"],\n[style]:has(.adslot_1)","#adserving-tag-hb,\n#pa_sticky_ad_box_middle_left,\niframe[id^=\"postbid_if_\"]",".hover_bkgr_fricc","#RedUserNotification","#zadost,\n.cookies",".wrapper > .slider",".widget.widget_text",".back","#article > section > div:not(.article_content)","#st-2,\n.cookie-consent","#Promolecek,\n.header-1,\n[class*=\"Reklam\"],\ndiv[id*=\"Reklam\"],\ndiv[id*=\"anner\"]",".myftp-widget,\n[id^=\"fancybox-\"],\n[id^=\"myftp\"]"];

const hostnamesMap = new Map([["harmonikum.co",0],["carstyling.com",1],["cfusionsys.com",2],["dictzone.com",3],["eredmenyek.com",4],["gumiszoba.com",5],["hazipatika.com",[6,7,8,9]],["delmagyar.hu",[6,31,73,75,85,136,137]],["kisalfold.hu",[6,15,75,85,136,269,270]],["mindenkilapja.hu",6],["sg.hu",[6,364]],["mobilarena.hu",[8,173,174,183,185,186,310]],["24.hu",[9,46,47]],["hosszupuskasub.com",10],["humormagazin.com",11],["hungliaonline.com",[12,13]],["vilagunk.hu",[13,413]],["hu.ign.com",14],["ingatlan.com",15],["data.hu",[15,133]],["harmonet.hu",[15,75,209]],["klubradio.hu",15],["portfolio.hu",[15,253,351]],["szatmar.ro",[15,16,434]],["ingatlanmagazin.com",16],["revizoronline.com",[16,31]],["444.hu",[16,48]],["autopro.hu",[16,77,78]],["bitport.hu",[16,31,92]],["blogstar.hu",[16,105]],["dimo.hu",16],["donna.hu",[16,31]],["epresso.hu",16],["eropolis.hu",16],["es.hu",[16,31,161]],["est.hu",[16,163]],["femina.hu",[16,32,75,168]],["figyelo.hu",[16,101]],["galamus.hu",16],["gondola.hu",[16,31,191]],["gportal.hu",16],["gyoricegregiszter.hu",16],["gyorplusz.hu",[16,132]],["hir6.hu",16],["hirstart.hu",[16,75]],["hrportal.hu",[16,62,229]],["ingatlanok.hu",16],["intima.hu",16],["jogiforum.hu",16],["kalohirek.hu",[16,31,260]],["kamaszpanasz.hu",[16,261,262]],["kapos.hu",16],["kaposvarmost.hu",16],["komment.hu",[16,31,75]],["lovebox.hu",16],["magyarhirlap.hu",[16,31,183,294]],["mainap.hu",16],["mfor.hu",[16,303]],["mixonline.hu",16],["mmonline.hu",16],["mno.hu",[16,101,102,150,309]],["moly.hu",[16,311]],["napi.hu",[16,31,75,143,314]],["napiszar.hu",16],["nemzetisport.hu",[16,31,154,244,305,320,321]],["nice.hu",[16,323]],["noinetcafe.hu",16],["noplaza.hu",16],["novagyok.hu",[16,31]],["nyest.hu",[16,329]],["origo.hu",[16,31,73,283,335,336]],["partyponty.hu",[16,31]],["prim.hu",16],["retikul.hu",[16,361]],["ricsajok.hu",16],["sporthirado.hu",[16,31]],["szoftverbazis.hu",[16,282,382,383]],["tech.hu",[16,31]],["valasz.hu",16],["vidget.hu",16],["weborvos.hu",[16,232]],["wellnesscafe.hu",[16,102,418]],["kronika.ro",16],["sportoldal.ro",16],["deres.tv",16],["karpathir.com",17],["kekfeny.com",18],["ketkes.com",19],["magyarszo.com",[20,21]],["napinemszar.hu",[21,316]],["najlepsie-clanky.com",[22,23]],["5percblog.hu",[22,49]],["napiszar.com",24],["napiuzlet.com",25],["nemkutya.com",[26,27]],["joy.hu",[26,259]],["paleomedicina.com",28],["pannonrtv.com",[29,30]],["elemzeskozpont.hu",29],["femcafe.hu",[29,75,126,167]],["pdafanclub.com",31],["bacsmegye.hu",[31,84]],["betegvagyok.hu",31],["bien.hu",[31,44,75,91]],["divany.hu",[31,75,140,141,142,143,144,145]],["duen.hu",31],["egeszsegkalauz.hu",[31,96,99,152,153]],["eletmod.hu",[31,32,75,158,159]],["eron.hu",31],["geeks.hu",31],["hajdupress.hu",[31,75,203]],["hirposta.hu",31],["index.hu",[31,75,141,144,246,247,248,249]],["ipon.hu",[31,255]],["kezilabda.hu",31],["kiskegyed.hu",[31,54,96,153,190,271]],["kreativ.hu",[31,275,276]],["life.hu",[31,73,103,177,281,282,283,284]],["multiplay.hu",31],["pirulapatika.hu",31],["revizoronline.hu",31],["romnet.hu",[31,75,142]],["startlap.hu",[31,236,371]],["stylemagazin.hu",[31,375]],["trademagazin.hu",31],["velvet.hu",[31,75,143,144,246,248,396,407]],["kakukk.ro",31],["svedasztal.com",[32,33]],["autonavigator.hu",[32,73,74,75,76]],["szervuszausztria.hu",[32,33]],["ecoline.hu",[33,148]],["teltlanyok.com",34],["5mp.eu",35],["autobazar.eu",36],["eudomain.eu",37],["netbulvar.eu",38],["tarhely.eu",39],["utajovobe.eu",40],["hu",[41,42]],["liked.hu",[42,286]],["112press.hu",43],["168.hu",[44,45]],["player.hu",[44,122,348]],["twice.hu",44],["hiros.hu",[46,221]],["777blog.hu",50],["ado.hu",51],["adoforum.hu",52],["adozona.hu",[53,54]],["eduline.hu",[54,73,148,150,151]],["agrarszektor.hu",[55,56,57]],["hellovidek.hu",[55,213]],["infostart.hu",[55,57,252,253]],["penzcentrum.hu",[55,344]],["agroinform.hu",58],["alapjarat.hu",59],["alfahir.hu",60],["alza.hu",61],["americantourister.hu",[62,63]],["raketa.hu",[62,359]],["androgeek.hu",64],["angol-magyar-szotar.hu",65],["aranyoldalak.hu",[66,67]],["telefonkonyv.hu",67],["arukereso.hu",68],["atlatszo.hu",69],["atv.hu",70],["automotor.hu",[71,72]],["budapestkornyeke.hu",[72,114,115,116,117]],["blog.hu",[73,100,101,102,103]],["hasznaltauto.hu",[73,76,210]],["olcsobbat.hu",[73,142,331]],["cegbongeszo.hu",[75,102,120]],["hajokonyha.hu",75],["heol.hu",[75,85]],["hwsw.hu",[75,136,240]],["itmania.hu",[75,158]],["kitekinto.hu",[75,89,142]],["koponyeg.hu",[75,225,236,272]],["ma.hu",[75,158,159,277]],["motorrevu.hu",75],["noitema.hu",75],["onlinecegjegyzek.hu",75],["sonline.hu",[75,85,367]],["storyonline.hu",[75,374]],["szabadfold.hu",[75,376]],["szoljon.hu",[75,85,384]],["totalcar.hu",[75,144,145,246,247,394,395,396]],["travelo.hu",[75,336,398]],["vezess.hu",[75,102,325,408]],["offline.hu",[77,166]],["telekom.hu",[77,386]],["autosjog.hu",[79,80]],["helyitipp.hu",[80,214]],["napjainkportal.hu",[80,319]],["autoszektor.hu",81],["babanet.hu",[82,83]],["szepsegbroker.hu",[82,349,380]],["bama.hu",85],["baon.hu",[85,87]],["beol.hu",[85,90]],["boon.hu",85],["duol.hu",85],["feol.hu",85],["haon.hu",[85,102,206,207]],["kemma.hu",85],["nool.hu",85],["szon.hu",85],["teol.hu",85],["vaol.hu",85],["veol.hu",85],["zaol.hu",85],["bankmonitor.hu",86],["bebiztositva.hu",[88,89]],["bkv.hu",[93,94]],["mandiner.hu",[94,109,296]],["blikk.hu",[95,96,97]],["glamour.hu",[96,97,153,189,190]],["blikkruzs.blikk.hu",[98,99]],["freemail.hu",[101,176,177,178]],["mon.hu",[102,206]],["metazin.hu",103],["blogspot.hu",104],["tudtade.blogstar.hu",106],["bonuszbrigad.hu",107],["bookline.hu",108],["borsonline.hu",[109,110,111]],["iho.hu",[111,242,243]],["magyarnemzet.hu",[111,295]],["ripost.hu",[111,362]],["vg.hu",[111,409]],["bpiautosok.hu",[112,113]],["pestisracok.hu",[113,345]],["likenews.hu",[115,116]],["starity.hu",[115,370]],["kekvillogo.hu",[116,117]],["budapestpark.hu",118],["cartourmagazin.hu",119],["ceginformacio.hu",121],["civishir.hu",[122,123]],["computerworld.hu",[124,125]],["gamestar.hu",[124,125]],["pcworld.hu",[124,125]],["puliwood.hu",[124,125]],["gsplus.hu",[125,193,194]],["pcwplus.hu",[125,193,194]],["csaladinet.hu",[126,127]],["csongradihirek.hu",128],["csupasport.hu",[129,130]],["mindmegette.hu",[129,304,305]],["cyberpress.hu",[131,132]],["itthonrolhaza.hu",[132,257]],["dehir.hu",[134,135]],["magyarorszagom.hu",134],["demokrata.hu",138],["dijnet.hu",139],["linkcenter.hu",[142,287]],["transindex.ro",[142,244,275,435]],["totalbike.hu",[144,145,394]],["dizajnkonyha.hu",146],["e-cars.hu",147],["magyarnarancs.hu",148],["economx.hu",149],["sportorvos.hu",[150,369]],["egeszsegtukor.hu",154],["vehir.hu",[154,321,406]],["elelmiszer.hu",155],["elemi.hu",[156,157]],["topark.hu",[156,393]],["epiteszforum.hu",160],["gyakorikerdesek.hu",[161,195,196]],["esport1.hu",162],["evamagazin.hu",164],["f1vilag.hu",[165,166]],["forbes.hu",[166,171]],["filmoldal.hu",169],["foodora.hu",170],["fototrend.hu",[172,173,174]],["gamepod.hu",[173,174,182,183,184,185,186]],["hardverapro.hu",[173,174,184,185,208]],["itcafe.hu",[173,174,183,184,185,186]],["prohardver.hu",[173,174,183,184,185,186,356]],["logout.hu",[174,183,184,185,186,289]],["fovarosi-hirhatar.hu",175],["zene.hu",176],["accounts.freemail.hu",179],["fressnapf.hu",180],["gamekapocs.hu",181],["gentleman.hu",187],["gepigeny.hu",188],["gphirek.hu",192],["nepszava.hu",[193,225,322]],["hoxa.hu",[196,228]],["gyaloglo.hu",197],["gyartastrend.hu",[198,199,200]],["pharmaonline.hu",[198,346]],["medicalonline.hu",[199,299]],["gyorihir.hu",201],["gyulaihirlap.hu",202],["hang.hu",[204,205]],["magyarhang.org",205],["hatarido-szamitas.hu",211],["haziallat.hu",212],["hestore.hu",215],["hetek.hu",216],["hirado.hu",[217,218]],["videoklinika.hu",217],["hircsarda.hu",219],["hirextra.hu",220],["indavideo.hu",[220,245]],["hirtv.hu",222],["hoc.hu",223],["hogyankell.hu",224],["holtankoljak.hu",[225,226]],["kapcsolat.hu",225],["webbeteg.hu",[225,234,416]],["hotdog.hu",227],["huaweiblog.hu",230],["mlzphoto.hu",[230,307]],["napidroid.hu",[230,315]],["hunbasket.hu",231],["kosarsport.hu",231],["hunhir.hu",232],["hupont.hu",[233,234]],["hvg.hu",[235,236,237]],["vilagszam.hu",[237,412]],["m.hvg.hu",238],["hvo.hu",239],["idokep.hu",241],["ize.hu",242],["napiszex.hu",[242,317,318]],["promotions.hu",[242,357]],["sztarklikk.hu",242],["tvgo.hu",242],["ncore.pro",242],["ilovebalaton.hu",244],["forum.index.hu",250],["infoajka.hu",251],["infobekescsaba.hu",251],["infocegled.hu",251],["infocelldomolk.hu",251],["infodebrecen.hu",251],["infodombovar.hu",251],["infodunaujvaros.hu",251],["infoesztergom.hu",251],["infofehervar.hu",251],["infogyor.hu",251],["infohodmezovasarhely.hu",251],["infokarcag.hu",251],["infokeszthely.hu",251],["infokiskunfelegyhaza.hu",251],["infomiskolc.hu",251],["infomovar.hu",251],["infonograd.hu",251],["infopapa.hu",251],["inforabakoz.hu",251],["infosarvar.hu",251],["infosopron.hu",251],["infoszentendre.hu",251],["infoszigetkoz.hu",251],["infoszombathely.hu",251],["infotamasi.hu",251],["infotatabanya.hu",251],["infoveszprem.hu",251],["infozalaegerszeg.hu",251],["internet-marketing.hu",254],["ite.hu",256],["jofogas.hu",258],["mozinezo.hu",262],["muhelynet.hu",[262,291]],["kapu.hu",263],["kecskemet365.hu",264],["kektura.hu",265],["keol.hu",266],["kfc.hu",267],["kh.hu",268],["gloria.tv",269],["koroshircentrum.hu",273],["kossuth.hu",274],["marmalade.hu",275],["nol.hu",[275,328]],["turizmusonline.hu",275],["kulturpart.hu",277],["lakberendezes.hu",278],["leet.hu",279],["libri.hu",280],["ok.hu",284],["reblog.hu",284],["videa.hu",[284,410,411]],["lifestory.hu",285],["litera.hu",288],["superiorhirek.hu",288],["love.hu",290],["lumenet.hu",[291,292]],["mafab.hu",293],["mavcsoport.hu",297],["sorozataddict.hu",297],["mediacenter.hu",298],["menetrendek.hu",300],["merce.hu",301],["meska.hu",302],["mkbnetbankar.hu",306],["mme.hu",308],["mozishop.hu",308],["mult-kor.hu",312],["myonlineradio.hu",313],["telex.hu",[317,387]],["nkmenergia.hu",324],["nlc.hu",[325,326]],["noizz.hu",327],["webforditas.hu",[329,417]],["obi.hu",330],["onroad.hu",332],["onvideo.hu",333],["oprend.hu",334],["otvenentul.hu",337],["hir.ma",[337,423]],["pcforum.hu",[338,339,340,341]],["prog.hu",[338,339,341,355]],["pcguru.hu",342],["pecsma.hu",343],["piacesprofit.hu",347],["politaktika.hu",349],["hu.jooble.org",[349,432]],["port.hu",350],["privatbankar.hu",352],["profession.hu",353],["profitline.hu",354],["propeller.hu",[355,358]],["rendszerigeny.hu",360],["rtl.hu",363],["sielok.hu",365],["simple.hu",366],["sorozatwiki.hu",368],["kereso.startlap.hu",372],["stop.hu",373],["szamoldki.hu",377],["szeged.hu",378],["szeged365.hu",379],["szeretlekmagyarorszag.hu",381],["sztaki.hu",383],["telefonguru.hu",385],["terhesferfi.hu",388],["termalfurdo.hu",389],["thaimatrac.hu",390],["titkokszigete.hu",391],["tlap.hu",392],["traffihunter.hu",397],["turmixvilag.hu",399],["twn.hu",400],["ugytudjuk.hu",401],["usernet.hu",402],["valaszonline.hu",403],["vasarnap.hu",404],["vatera.hu",405],["videaloop.hu",411],["vilagszammagazin.hu",412],["vs.hu",414],["wasabi.hu",415],["widescreen.hu",419],["wikiszotar.hu",420],["feliratok.info",421],["kuruc.info",422],["szekelyfold.ma",424],["filmvilag.me",425],["mozinet.me",426],["online-filmek.me",427],["androbit.net",428],["calculat.org",429],["feliratok.org",430],["hogyan.org",431],["maszol.ro",433],["nepszava.us",436]]);

const entitiesMap = new Map(undefined);

const exceptionsMap = new Map(undefined);

self.specificImports = self.specificImports || [];
self.specificImports.push({ argsList, hostnamesMap, entitiesMap, exceptionsMap });

/******************************************************************************/

})();

/******************************************************************************/
