/*******************************************************************************

    uBlock Origin Lite - a comprehensive, MV3-compliant content blocker
    Copyright (C) 2019-present Raymond Hill

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see {http://www.gnu.org/licenses/}.

    Home: https://github.com/gorhill/uBlock
*/

/* jshint esversion:11 */

'use strict';

// ruleset: idn-0

/******************************************************************************/

// Important!
// Isolate from global scope
(function uBOL_cssSpecificImports() {

/******************************************************************************/

const argsList = [".popbox",".kln",".ays-pb-modals","#ad_bawah,\n#popup_bawah,\n#popup_box,\n[href=\"https://tinyurl.com/anoboyvip\"]","[href^=\"https://bit.ly/\"]","[href=\"https://klik.gg/anoboy\"],\n[href=\"https://klik.gg/anoboyvip\"]","#floating_banner_top1",".inner-floatbanner-bottom","#headads","#ptbanner","#top-banner",".loaded.ads-50","#ads",".ads","#le_header_ads","#ouibounce-modal","#sgpb-popup-dialog-main-div-wrapper",".sgpb-popup-overlay","#teaser3","#teaser4",".gulai_asam_manis","#playerOverplay,\n.anime-ner.mt-4 > .row,\n.content__tags,\n[href^=\"https://s.id/\"],\n[href^=\"https://shortku.in/\"],\ndiv.mt-4.p-1.breadcrumb-option:nth-of-type(3)",".floating__footer,\n[href^=\"https://tinyurl.com/\"]","#aiklanatas1,\n#aiklanatasd1,\n#aiklanheader1,\n#aiklanheader2,\n#aiklanheader3,\n#aiklanheader4,\n#aiklanheader5,\n#aiklanheader6,\n#aiklantengah1,\n#iklanatas1,\n#iklanatas2,\n#iklanatas3,\n#iklanatas4,\n#iklanbawah1,\n#iklanbawah2,\n#iklanbawah3,\n#iklanbawah4,\n#iklanfoatingbawah,\n#iklanside1,\n#iklanside2,\n#imgiklanatas1,\n#imgiklanatasd1,\n#imgiklanheader1,\n#imgiklanheader2,\n#imgiklantengah1,\n.iklantengah1,\n.pd-ads","#overplay",".box_item_berlangganan_popup","#fbanner,\n#fbbanner,\n#pbanner","#hbanner",".teaser3","[href^=\"https://yukclick.me/dunia21\"]","#teaser1","#teaser2",".ays-pb-modal",".ad","#floating_bot","#floatbannerkanan","#floatbannerkiri","#floating_banner_top",".elementor-popup-modal","#floatbottom,\n.adsrow","#floatcenter",".lepopup-popup-container,\n.lepopup-popup-overlay",".lepopup-popup-loader","img[alt=\"Advertisement\"]",".banner-float-bottom-2.banner-float-bottom","#repop","#floating_bot.btm_ban","a[href^=\"https://cek.to/\"]",".mfp-inline-holder.mfp-s-ready.mfp-container",".mfp-ready.mfp-with-zoom.mfp-no-margins.mfp-img-mobile.mfp-bg",".lazyloaded.loaded.ads-50",".sgpb-popup-dialog-main-div-wrapper","#floattop,\n#top6",".banner-img",".lazyloaded.ads-50","#btm_bannerMobile","a[href^=\"http://bit.ly/\"]","a[href^=\"https://goo.gl/\"]","#semprotpokemon_3,\n#semprotpokemon_4",".lazyloaded.ls-is-cached.bannerdua,\n.lazyloaded.ls-is-cached.bannersatu","#KD_adpB,\n.krucil_ads",".banner-float-bottom","#fixedban","#iklantengah1","#tutupen,\n[href=\"https://bit.ly/idx-xx\"]",".headbanner","#floatbanner-bottom",".ban_empat","div[id^=\"floating_banner_bottom\"]","#advertisement","#overlay",".sgpb-popup-overlay.sgpb-popup-overlay-19287.sgpb-theme-1-overlay",".underlay","#iklap,\n#iklhead,\n#jwp_gmn_adss","#promoContainer",".blocker.jquery-modal",".jwseed",".wp-image-80765.size-full.alignnone",".banner-left,\n.banner-right",".separator > a[imageanchor=\"1\"],\n[id^=\"ftads\"]","#kayan_reklam_sag,\n#kayan_reklam_sol",".contentlist","[href^=\"https://manjur.id/search.php\"]",".td-header-rec-wrap",".sg-popup-content","#middle-banner","div[class^=\"adsgen\"],\ndiv[class^=\"mobileads\"]",".lmd-iklan","#popup_content","#tengah > span",".imgbanner","#floating_banner_left,\n#floating_banner_right","#wrap > .headborder > .headcontent > .textwidget","#col,\n#tengah,\n#tengahaa,\ndiv.content-kuss",".klikdisini","#fadeinbox","#filmoncereklam","[id^=\"floating_banner\"]","a[href^=\"https://bit.ly/\"]","a[target=\"_blank\"][rel=\"nofollow\"] > img[src$=\".gif\"]","#banner-tengah","[href$=\"/sukamovieclub\"]","[href^=\"/GoUrl.php?ads=\"]",".pop-overlay","[href^=\"http://152.44.32.81\"]","#btm_banner",".iklansamping,\n.klnrec,\na[rel=\"nofollow\"] > img[src*=\"bp.blogspot.com\"],\na[rel=\"noopener\"] > img[src*=\"bp.blogspot.com\"]","#bioskop-kiri,\nbioskop-kanan",".mlb","#modal","#myModal","#playerOverlay","a[href^=\"https://shope.ee/\"]","iframe[style*=\"z-index: 2147483647\"]","a[href][target=\"_blank\"][rel=\"nofollow\"] > img[src$=\".gif\"]",".td-banner-wrap-full","#div-Inside-MediumRectangle",".ad-photo,\n.commSkin__fluid--left.commSkin__fluid,\n.commSkin__fluid--right.commSkin__fluid,\n.mb3.gpt-ad-head-wrapper.widget",".cls-outstream","#advertisement-2",".banner-fix-bottom,\n.banner320x480,\n.banner970x250,\n.bannerfull,\n.bannerhead,\n.closebanner1,\n.closebanner2,\n.head-banner,\n.parallax-box",".ayu-headads","#energysaving",".banner","img[width=\"720\"][height=\"90\"]","#floatads1",".middle-ad-cont",".anm__flying--ads-holder","#cont-megabillboard","a[href^=\"http://anizan.slask.pl/go.php\"]","#footer_sticky","#smartmag-block-codes-1 > .block,\na[href^=\"https://ads.id/\"]","#billboard",".d-flex.w-100:has([id^=\"div-gpt-ad\"])",".underlay-ad","#popupklan","#popupklanfooter,\n.pc-only.inline-banner","#billboard_banner","#floating_banner_bottoms","#floating_banner_tops","#wrap > center",".headborder:nth-of-type(5)",".billboardBig.billboard,\n.billboardBottom,\n.billboardFlying,\n.billboardFlyingBanner,\n.billboardFlyingFix,\n.billboardFlyingInner,\n.billboardLeaderboard.billboard,\n.billboardPushdown,\n.billboardRectangle.billboard,\n.billboardTop.billboard,\n.skyscrapper--left,\n.skyscrapper--right",".flying_carpet_show,\n.flying_carpet_show_inner",".product__card:has(.product__tag__ads)","#floating_banner_bottom2,\n#floating_banner_top img[width=\"728\"][height=\"90\"]","#headlineatas","#HTML2,\n.lalulintas",".ads-on,\n.ads__stick--left,\n.ads__stick--right,\n.ads_below_photo,\n.float-ads",".ads-partner-wrap",".ads__top-big,\n.cls-composite,\n.cls-geniee",".mgidclsbanner",".pushdown-banner",".bl-product-card-new:has(.bl-product-card-new__ads-badge)",".dp-card-container:has(.ico_promotion)",".code-block,\n.ct-section-inner-wrap > article + aside",".wpa","#adsic728,\n#adsic7282",".adsbawahjudul,\n.adsbawahposting","#hbanner:nth-of-type(1)",".adstops","#sgcboxOverlay",".megabillboard",".mr1:has([id^=\"div-gpt-ad\"]),\n.mr2:has([id^=\"div-gpt-ad\"])","#skinad,\n.detikads",".billboardmobile,\n.stickystatic,\ndiv.undefined,\ndiv[style$=\"height:600px;\"],\ndiv[style*=\"height:400px;\"],\ndiv[style^=\"width:970px;\"]",".footer_banner",".detail_ads,\n.mr3:has([id^=\"div-gpt-ad\"])",".ads-scrollpage-container,\n.ads-scrollpage-height,\n.parallaxindetail",".ads-slot",".paradetail",".Widget:nth-of-type(2),\n.Widget:nth-of-type(3)",".h-\\[250px\\].w-\\[300px\\],\n.h-\\[549px\\],\n[id^=\"rubiconTag\"]","#ads-728,\n#ads-960-mid,\n#ads-mid,\n#mid-banner,\n.ads2-home,\n.fixed-ads-atas,\n.mid-banner","#bottom_banner","#leaderboard:has([id^=\"div-gpt-ad\"]),\n#leaderboard[style*=\"width: 750px;height: 100px;\"],\n#megabillboard-desktop,\n#otp_banner,\n#sto_banner,\n#top_banner,\n.banner_inside_article,\n.bb_banner,\n.billboard-top,\n.mr1:has(#adv-caption-mr1),\n.normalbanner,\n.otp_banner_close,\n.parallax_abs,\n.skinad_1,\n.skinad_2,\n.skybanner,\n.staticdetail_ads,\n.staticdetail_container:has(.staticdetail_ads)","[href^=\"http://www.dukungbpjs.com/ref.php\"]","#ads-stack,\n#close-ads-stack,\n#itro_opaco,\n#itro_popup","#float-bottom-banner",".visible-lg",".ads_square_banner,\n.section_sticky_ads_bottom",".banner-common",".left.banner-vertical,\n.right.banner-vertical","#myPopup,\n[class^=\"ads-space-\"]","#peluang",".ktzsingle-bannerright",".ads-billboard",".btn_ads_close_top_frame",".pps-single-popup",".random","#footer_sticky_inside",".adsense-header-in-article",".box","#div-Inside-Medium-Rectangle,\n.ads-liftdown,\n.ads__stick,\n.ads__stick__fluid,\n.ads__stick__fluid--left,\n.ads__stick__fluid--right,\n.ads__stick__wrap,\n.ads__top-big250,\n.js-ads-stick,\n.read__left","#jxOutstreamContainer",".ads__boxr",".blocker-notice,\n.blocker-overlay","#balloonads,\n#megabillboard,\n#parallaxdetail,\n.ads_native_d,\n.billboard__banner,\n.m-r1:has([id^=\"div-gpt-ad\"]),\n.m-r2:has([id^=\"div-gpt-ad\"]),\n.parallax1","#ads-float,\n#solopos_float,\n.bottom-fix","#bannerkategoriheader,\n#mybannerpopup,\n#mybannerpopup2",".article-bottom-ad,\n.article-desktop-ad","#teaser7",".spb_middle.spb_banner","#text-28 > .textwidget,\na[href^=\"http://www.pembesar-vimax-herbal.com/\"]","[style=\"float:right; margin:7px 0 10px 10px;\"] > small","#IDN_Leaderboard,\n#IDN_PS_MegaBillboard,\n[id^=\"IDN_InArticle\"]",".parallax-ad",".sponsor_ads:nth-of-type(1),\n.sponsor_ads:nth-of-type(2),\n.sponsor_ads:nth-of-type(4)",".bottom-iklan,\n.bottom-iklan-detail","#floating_ads_bottom_textcss_wrap",".adBar-vertical.left,\n.adBar-vertical.right","#IklanIDGS,\n#bottombanner",".ktz-banneraftercontent","#headerbanner","#baca_juga,\n#more_stories,\n#title_kanal,\n#vertical_top_kanal",".aligncenter","#player-side-right","._ning_link.strack_cli","#anchormasklink",".bt-g1.b-g3.wb-300x100,\n.bt-g1.b-g3.wb-300x250","#bannerkiri",".d.wp-120x600,\n.wb-300x250","[style^=\"padding-top:16px;margin-bottom:24px;\"]","img[style=\"width: 125px; height: 125px;\"]","img:nth-of-type(2)","[class^=\"ad-\"][class*=\"-container\"]",".ads-jav","#in_image","[class$=\"__disclaimer\"]","#banner-popup,\n.gmr-banner-afterrelpost,\n.gmr-banner-logo,\n.gmr-footerbanner,\n.gmr-topbanner,\n.gmr-verytopbanner","#hello",".ans-300x250",".adv-space","#leaderboard",".bottom-frame-banner-close-btn,\n.bottom-leaderboard-cont,\n.skycapper","#dfp-bframe-cont","#v5-marcommpromotion.home-right-box,\n#v5-marcommpromotion2,\n#v5-showcase3,\n#v8-leaderboard,\n.banner-title,\n.box--banner,\n.crm-wrapper","#v5-showcase1,\n#v5-showcase2",".ad2",".ads__under__image",".textwidget img[width=\"300\"][height=\"250\"],\ncenter img[width=\"728\"][height=\"70\"]","#left-skyscraper,\n#right-skyscraper,\n.ad.b300x250","#floatbanner",".widget_text:has([href^=\"https://shope.ee/\"])","#box-zone_osm,\n#credential_picker_container,\n.ads-latest-wrap,\n.ads-on-body,\n.adsMR1Lipsus1,\n.bannerAdB,\n.bannerCenter,\n.bannerCenter1SubRubrik,\n.bannerCenter2SubRubrik,\n.bannerCenterRubrik,\n.bannerR,\n.bannerR2,\n.bannerR2A,\n.bannerR3,\n.bannerR3A,\n.bannerTopOut,\n.boxBanner1,\n.boxBanner3,\n.boxBannerR1akt,\n.boxSkinAd,\n.gramedia__gate,\n.hAds,\n.kcm-track,\n.kcm-track-sticky,\n.kcm__articleList,\n.kcm__big,\n.kcm__horizontal,\n.kcm__rectangle,\n.kcm__stick--left,\n.kcm__stick--right,\n.kcm__sticky,\n.kcm__superbig,\n.kcm__top,\n.kcm__tower,\n.kcm__track,\n.native-wrap,\n.ol_big_inner,\n.premium_div,\n.show.ol_promo,\n.video-box-wrap,\n[src^=\"https://adsimg.kompas.com\"],\ndiv:has(> #gpt-passback)","iframe[title=\"3rd party ad content\"]",".bannerTop1",".banner-center,\n.banner-mgid",".banner-top",".banner-dable.banner,\n.banner-gennie.banner,\n.banner-mgid-read.banner,\n.banner-right-big.banner,\n.banner-right.banner,\n.mb20.mt20.banner-dable-read.banner",".ad-plus,\n.text-ad","#bannertheme_left,\n#bannertheme_right",".adssingle,\na[href=\"http://kshowid.com/advertising/\"]","center",".banner_box",".banner_main,\n.leftcontent[style=\"padding:0px; margin:0px auto; height:250px; width:720px; border:0px; background:none; \"]",".img-banner","#idcomboard1.com-728x90,\n#idcomright1.com-300x250,\n#idcomright2.com-300x250,\n#idcomsensebox1.com-300x250,\n#idcomsky1.com-160x600,\n.ctnitem.ctncom","#lht2_lesson_after_vocab2_300x250_phone,\n#lht2_lesson_bottom_300x250_phone,\n#lht2_lesson_top_320x50_phone,\n#lht_base_bot_320x50_phone,\n#lht_lesson_right2_300x250_desktop,\n#lht_lesson_right_300x250_desktop",".box-ads-right","#float-banner","#rotating",".ad_990_80","p:has(> a[href=\"#downloadnow\"])",".hero_adslot","#footer_stickyexp,\n.room-list__card:has(.rc-photo__icon--promo),\n[class$=\"-item__room\"]:has(.rc-photo__icon--promo),\n[data-testid=\"miniKostRoomCard\"]:has(.rc-photo__icon--promo)",".manado-widget","#aa,\n#close,\n.mas_tamvan","#lbanner","img[width=\"240\"][height=\"240\"]",".-mx-\\[24px\\],\n.adsMarketeers,\n.h-\\[110px\\],\n.h-\\[260px\\],\n.modal-login-container,\n.w-\\[300px\\]",".masthead","#floating_ads_bottom_textcss_container",".bannercol,\n.bannerfloat,\n.bannerpos,\n.cell_banner_inside","#ad-genie-container,\n#div-paralax-container",".js-tower-sticky.clearfix.kcm__tower.kcm",".nkt__stick--left,\n.nkt__stick--right",".p-press__ad",".spnsr-top,\n.vip-info","a[href][target=\"_blank\"] > img",".in.modal-backdrop","#fab","[href^=\"//wizliebeg.com/\"]",".box_item_berlangganan",".sitemaji_banner","[style^=\"width: 300px;\"]","#nbpopx-wrapper,\n.jx-ads.nobar-ads","#left_ads_float_phonedevelop,\n#under-video-ads,\n.mask-ads","#wrap > table","#sidebar-right,\ncenter > table",".bannermovie,\n.banners",".content-kuss-ikln","#fatas","#previewBox2","#previewBox4","#floatbawah","#floating_banner_bot2",".ads-bottom-fixed,\n.ads-mega-box,\n.bannertopcenter,\n.box-ads-konten,\n.center-ban,\n.center-paralax,\n.detads,\n.flying_ads,\n.rc-ad-300x250,\n.skyscrapper,\n.sponsored-belt468x60",".banner-zone",".r-ads",".alignnone.size-large.wp-image-458","#prmn__megabillboard",".megabillboard-container",".czlll-rlselse",".float-ck",".gpt-ad-inner,\n.site-sticky-bottom",".ads-video-zone,\n.video-list-ads","#float-left,\n#float-right",".sg-popup-builder-content",".ads-50,\n.sgpb-popup-dialog-main-div-theme-wrapper-6","a.thirstylink",".semprotnenenmontok_2","#lepopup-popup-13,\n#lepopup-popup-13-overlay,\n[href=\"http://heylink.me/KAYA303\"]",".c-message > div:nth-of-type(1)","#me-div-gpt-ad-parallax,\n#me-div-gpt-ad-stickyad,\n.clear.size-wide-custom.dummy,\n.warp-ads-paralax","div[style=\"height:260px;\"]",".margin-right-40.left.pullquotes,\ndiv.ad-before","#forum_ads_8,\n#sodasusu_ads_side_left,\n#sodasusu_ads_side_right","#adds-top,\n#desktop-native-1,\n#desktop-native-2,\n#div-ad-dbt,\n#pariwara_dua,\n.adds-top.add,\n.bg-ads-sticky-side,\n.bg-ads-sticky-top,\n.parallax_swipe,\n.placeholder_belt,\n.placeholder_expose,\n.placeholder_leaderboard,\n.placeholder_medium,\n.placeholder_r1,\n.placeholder_r2,\n.placeholder_r3,\n.placeholder_read_body,\n.widget-ads-top,\n[id^=\"berita-terkait-\"],\ndiv.placeholder_pariwara","#anchorads",".\\33 .Premium.Sundul,\n.\\34 .Premium.Sundul","#right_ads_float_phonedevelop,\n.overlay","div[style=\"position:absolute; top:20px; left:45px; width:70px; background:#000; text-align:center;\"]","#fancybox-wrap","#fancybox_ajax,\n.advertisement_box1,\n.advertisement_box2","#banner-atas,\n#banner-bawah",".expandable-bottom-sticky,\n.tjp-placeholder-ads","a[data-testid=\"lnkProductContainer\"]:has(img[alt^=\"topads\"]),\ndiv[data-ssr=\"findProductSSR\"]:has(span[data-testid=\"lblTopads\"]),\ndiv[data-ssr=\"findProductSSR\"]:has(span[data-testid=\"linkProductTopads\"]),\ndiv[data-testid=\"CPMWrapper\"],\ndiv[data-testid=\"divProduct\"]:has(span[data-testid=\"icnHomeTopadsRecom\"]),\ndiv[data-testid=\"divProductWrapper\"]:has(span[data-testid=\"divSRPTopadsIcon\"]),\ndiv[data-testid=\"featuredShopCntr\"],\ndiv[data-testid=\"lazy-frame\"]:has(span[data-testid=\"lblProdTopads\"]),\ndiv[data-testid=\"master-product-card\"]:has(span[data-testid^=\"linkProductTopads\"]),\ndiv[data-testid=\"topadsCPMWrapper\"],\ndiv[data-testid^=\"divProductRecommendation\"]:has(span[data-testid=\"icnHomeTopadsRecom\"])","#idb3",".h-\\[90px\\]","#div-Right-MediumRectangle-1","#div-Top-Leaderboard","#bannerku,\n#bannerkubawah,\n#boxright [style=\"width:300px; height:250px;\"],\n#div-Center-FullBanner-1,\n#div-Center-FullBanner-2,\n#div-Tribunnews-Home-Center-2-FullBanner,\n#skinads,\n.belanja-picks,\n.content [style=\"width:160px; height:600px;\"],\n.ovh[style=\"width:468px;height:60px\"],\n.reserved_box_ads,\nimg[src*=\".pgi.tribunnews.com/\"]","#div-Right-MediumRectangle-3","#boxleft > .mb20","#an-Modal,\n.reveal-modal-bg","img[width=\"320\"][height=\"105\"]",".banneritem",".code-block-3.code-block","[class^=\"wisat-\"]","#Ad300B,\n#Ad728","#aside img[width=\"300\"][height=\"250\"],\n#lAds,\n#rAds,\n#simplemodal-container,\n#simplemodal-overlay","[href=\"https://cek.to/anc-dwc\"]","#teaser5","#previewBox3","#flobwh,\na[href^=\"https://rebrand.ly/\"]",".adshu",".show.popup","#floatbot,\n.appup",".mfp-ready.mfp-with-zoom.mfp-no-margins.mfp-img-mobile",".nyaa300,\n.nyaa728",".adsbygoogle",".box-ads--container",".bausastra-ads",".affcoups",".inf_infusionsoft_popup","div.ui_adblock","#TopBannerBg",".bnr",".banner-sc,\n.banner-sc2,\n.col-banner,\n.masonry-brick.drm-banner-x.drm-artikel:nth-of-type(3)",".header__kasad,\n.kasad-h",".flying_carpet_div,\n[style=\"height:0; min-height:180px;\"],\ndiv:has(> [id^=\"div-gpt-ad\"][class^=\"paralax\"])","#modalPopup","#adsoutsream,\n#div-Halfpage-,\n#fixslowshow,\n#halfpage-ads,\n.kiri-det-desk,\n.kus,\n.liftdownclass,\n.text-center.center.width-px-1100,\n[class*=\"heightads\"]","#Kolom-random-300,\n#iklan-dalam-postingan-300,\n#overlay[style=\"display: block;\"],\nimg[style=\"border:0;display:block;\"]","#top-banner-parallax,\n.banner-parallax,\n.footer_stickyexp",".adsense",".description-ads",".ads-120__left.ads,\n.ads-120__right.ads,\n.ads_160x600.ads",".ads-120__left,\n.ads-120__right,\n.ads-160,\n.ads-160-600,\n.ads-300-video,\n.ads_160x600,\n.ads_970x250,\n.set-ads-468,\na[style=\"width: 100%; height: 100%; display: block; position: fixed; z-index: 1\"]","#news_content > .font-weight-lighter,\na[href^=\"//ads-track.times.co.id\"]","#otp_ads,\n.giant-banner,\n.portlet.sideskycrapper,\n.slotiklan","#bottomframe-ad,\n#skinframe-ad-left",".ad-inventory-wrapper",".ads-article-inner,\n.ads-article-sidebar,\n.cover-ads-article,\n.news__detail-ads",".text-center:has(+ div[style^=\"background-image: url(\\\"/img/logo-ads\"]),\ndiv[style^=\"background-image: url(\\\"/img/logo-ads\"]","a[href^=\"http://www.apktiga.com/p/start-download-reayus.html\"]","#detailSkinAdLeft,\n#detailSkinAdRight",".ads-mr,\n.ads__skyscraper,\n.ads_imr2,\n.ads_sky,\n.ads_wrapper,\n.bottom_banner-wrapper.relative,\n.relative.below_photo,\n.relative.skycrapper,\n.relative.w-full,\n.skin_ads,\n.top_banner-wrapper",".mt20.top1,\ndiv.banner-r","#div-top-banner-transparent","#ads_megabillboard,\n#parallax-ad,\n.ads_sticky_footer,\n.rowx",".ads-sticky-left,\n.ads-sticky-right,\n.bg-grey.text-center.p-0.mb-3.mt-3,\n.mb-4.bg-grey.text-center",".ad-box-wrappr,\n.row > .show-desktop > div,\n.underlay-ad-text-box",".nkt__stick","#main-banner-middle,\n.legend_banner-container,\n.stickybanner",".gambar_pemanis",".ftadss",".parallax_ads,\n.widebanner.banner,\ndiv.showcase.banner,\ndiv.skycrapper.banner","[href^=\"https://scratchy-trick.com/\"]",".cls.code-block-center","#div-Inside-MediumRectangle2,\n.banner-skin--left,\n.banner-skin--right,\n.banner__giant,\n.banner__left,\n.banner__right,\n.banner__top,\n.read__skyscraper",".ads-popup__inner",".flying_carpet_show_fix",".ads.single_post_content,\n.animated.ads",".adbox","#bkgOverlay,\n#bn-premium,\n#delayedPopup,\n#premium,\n.article-sidebar,\n.d-sidebar,\n.skinner-left,\n.skinner-right,\n[id^=\"gpt-inline\"]",".box-ads-300x250,\n.box-ads-billboard,\n.box-ads-billboard-mobile,\n.section-ads-mid",".text-align-center.box-ads-content",".in_up_ad-area",".cads","#ilang2",".modal",".box-banner","#floating_ads_bottom_textcss2",".wait","[href=\"javascript:showHideGB()\"],\n[href^=\"http://dwatngkas.\"],\na[href^=\"http://cocobet.\"]","#ilang1",".adv",".bannersinglefot","#googlebox","#floatbtmleft,\na[href^=\"//angel4d.com/\"],\na[href^=\"//telolet4d.com/\"]",".iklanSUKI",".slot-iklan",".float_tengah,\n.separator",".lenyap",".ad-float-image",".rsABlock","a[href=\"https://klik.fun/Kp7S5\"]",".col-xs-12.col-md-6.col-lg-6",".bannerbawahheader,\n.inline-banner","#previewBox","#ftads,\n.berlangganan-500",".bot.ads","ins.adsbygoogle","#float-pop","#overlay-pop","#fancybox-overlay","[href=\"http://bit.ly/adsvbola\"],\n[id^=\"yui-gen\"].postcontainer",".bm.overlay","a.bnner","[href=\"https://klik.fun/ZyslX\"]","[id^=\"btop-\"]",".adbtm,\n.bh-ad,\n.block-bh-googledfp,\n.center-block.img-responsive",".stick-leaderboard-wrapper",".a_f,\n.a_mu",".cari-ads",".td-banner-bg.td-banner-wrap-full",".col-lg-3:has([id^=\"div-gpt-ad\"])","#Taboola_widget,\n#rec_ad4,\n.tonal__standfirst",".adplaceholder-mrec","[data-testid^=\"featured-ads\"]",".code-block-6,\ndiv[data-ub-carousel]","#sadl,\n#sadr",".ktz_banner","#sct_banner_top,\n#videoad1",".ads-header-5","#bmpop_adpB",".placeholder-container",".ads-container","img.aligncenter",".cfmonitor","#banner-popup-desktop",".idmupi-topbanner","#banner-right",".clearfix.act2-970x90:nth-of-type(1),\n.clearfix.act2-970x90:nth-of-type(3)","img[width=\"1020\"][height=\"350\"]","#semprot_ads_side_left,\n#semprot_ads_side_right","#jsemrp_372_719,\n#jsemrp_373_873,\n#jsemrp_374_469,\n#jsemrp_380_290",".semprotpokemon_1,\n.semprotpokemon_2",".coliklan",".cm-popup-modal",".banner3",".blox","#floatads2,\n#floatads3",".anuads","a[title^=\"manga4d\"]","#openpopunder","#adrandpop,\n#aplikasi",".mvic-btn",".floating-banner",".active.adde_modal-overlay,\n.adde_modal_detector-show.adde_modal_detector","a[href^=\"//bit.ly/\"]",".footer_sticky","#tutup,\n#tutup2","#float-atas",".header-banner","#lmd-iklan",".swal-overlay--show-modal.swal-overlay",".s-sponsor","#popuppress-9119,\n#top-banner-content","#main-popup",".banner-middle","[class*=\"banner\"]","a[target=\"_blank\"][rel^=\"noopener noreferrer\"] > img[src$=\".gif\"]",".kzl-header.kzl","[href=\"https://klik.gg/manhwadesu\"]",".iklan-tengah",".banner_player,\n[class^=\"adspost\"]","[href$=\"/referral/nontoncinema\"],\na[href^=\"http://referral.\"]",".box_banner","[href=\"//dumbpop.com/help.xml\"]","#iklan125x127,\n#iklan300x100,\n#iklan728x100","#largebanner","[class*=\"popmake\"]","table","#ffbp-bg,\n#ffbp-body,\n#ffbp-close",".btm_ban",".full-brkas-container",".setdah","a[rel^=\"nofollow noopener\"] > img[src$=\".gif\"]","#ffbp","#popup","#aboveDownloadBannerSection",".gmr-bannerpopup,\n[href^=\"//avgirls.asia/\"]",".add,\n.mobi.content-left,\n.mobi.content-right","#wpb_overlay,\n.wpb-image-popup.wpb-main-wrapper","#epmblock",".av-content-full",".adsincenter","#bannerhomefooter","#ftadsth",".fixed-lside,\n.fixed-rside",".davwheat-ad","#player-side-left","#home-bnner-content","#home-bnner2-content,\n.reklam-goster-sag,\n.reklam-goster-sol",".popup.show,\na[href^=\"https://jalur.win/\"]","#directorio > .random > center","#sidebar_right > .side:nth-of-type(5) > .textwidget,\n#sidebar_right > .side:nth-of-type(6) > .textwidget,\n#sidebar_right > .side:nth-of-type(7) > .textwidget,\n#sidebar_right > .side:nth-of-type(8) > .textwidget,\n#sidebar_right > .side:nth-of-type(9) > .textwidget",".bannerwrap","#previewBox1","#top-bnner-content","#_popIn_recommend_word,\n.alert,\n.container_skinad,\n[class^=\"ads-\"]",".fancybox-skin",".navbar-brand.bot,\ndiv[id^=\"previewBox\"]",".ads728-slot-panjang",".banner-premium","[class=\"sc__wrp\"]","[class^=\"xnxx5-\"]","[href^=\"https://klik4.me/dunia21\"]","#content > div:nth-of-type(1)"];

const hostnamesMap = new Map([["agenbokep.co",[0,103]],["agenbokep.guru",[0,103]],["agenbokep.pro",0],["45.12.2.2",[1,18,25,63]],["107.152.37.223",1],["185.217.95.43",1],["15.235.11.45",[1,18,24,30,51,71]],["185.217.95.48",1],["185.217.95.49",[1,15]],["157.245.12.72",1],["komik18.art",[1,18]],["kazefuri.asia",1],["manhwaindo.cfd",[1,18]],["onlyvid.cfd",[1,28]],["komikremaja.club",1],["cosmic345.co",[1,40,108]],["komikindo.co",[1,112]],["komikstation.co",[1,113]],["javsubid.com",[1,4,226]],["manhwalist.com",1],["mareceh.com",1],["nontondramaseri.com",1],["starjepang.com",1],["pascol.cyou",[1,28]],["oploverz.fan",[1,18,30,31]],["lendirpedia.fun",1],["indodb21.homes",[1,40]],["anikor.icu",1],["lendirpedia.icu",1],["onlyvid.icu",[1,28]],["sintube.icu",[1,28]],["anoboy.id",1],["heppinn.id",[1,18,40]],["kiryuu.id",[1,113]],["mangakita.id",[1,4,15,18]],["manhwaindo.id",1],["isekaisubs.web.id",[1,30,31,40]],["oploverz.co.in",1],["oploverz.info",[1,18,24,30,31]],["westmanga.info",[1,418]],["komikcast.io",1],["tv1.anikor.lol",1],["hencop.lol",[1,19]],["komikdewasa.me",[1,18]],["komikindo.me",1],["manhwaindo.me",[1,18]],["123.anikor.mom",1],["manhwaland.mom",1],["skandalpedia.mom",1],["kazefuri.net",[1,463]],["mangakita.net",[1,4,15,18,105,466]],["mangashiro.net",[1,30,98,467]],["mirrorkomik.net",[1,468]],["animasu.nl",[1,477]],["ikiru.one",1],["kiryuu.org",[1,18]],["mangakyo.org",[1,18]],["skandalpedia.rest",1],["melongmovie.site",[1,28]],["manhwaland.top",1],["oploverz.top",[1,17,18,24,30,31,84]],["oploverz.tv",[1,18,30,31]],["kazefuri.vip",1],["139.99.33.205",4],["139.99.120.222",[4,67]],["185.231.223.76",[4,73,74]],["gudangmovies21.cfd",4],["pecintabokep.club",[4,99]],["21filem.co",4],["bioskop45.co",4],["lk21go.fun",4],["manganime.in",[4,414]],["www.nontondramas.net",4],["kawanfilm21.online",[4,6]],["movieajip.online",4],["kawanfilm21.pro",[4,6]],["otakudesu.watch",4],["gm21.xyz",4],["anoboy.ink",5],["75.119.147.12",6],["194.163.158.12",6],["149.102.130.200",[6,15]],["45.67.231.215",6],["161.97.116.33",[6,15]],["89.117.61.35",6],["185.182.187.38",6],["173.212.245.75",[6,15]],["46.149.76.81",6],["154.12.229.9",[6,15]],["81.0.220.98",[6,15]],["cinema-indo.co",6],["northridgeautospa.com",[6,296]],["zonafilm.icu",6],["nontonlk21.live",[6,37]],["baladfilm.skin",6],["bioskopkeren.beauty",8],["bioskopkeren.bond",8],["bioskopkeren.sbs",8],["158.69.0.212",10],["terbit21.cafe",[10,85]],["movies21.co",[10,85]],["bioskopkerenin.com",10],["kebioskop21.com",10],["lk21tv.com",[10,85,178,260,261]],["dunia21.cx",[10,85]],["bioskopkeren.dev",10],["lk21.web.id",[10,56,260,407]],["sinemaindo.web.id",[10,56,260,401,411]],["terbit21.in",10],["kebioskop21.online",10],["ganool.watch",[10,85]],["ganool21.watch",10],["cctvbokep.bet",12],["inibokep.bet",12],["dutasex.bio",12],["perawabokep.cam",12],["perawanbokep.cam",12],["idxchannel.com",[12,208]],["cctvbokep.help",12],["budiarto.id",[12,353]],["cinemaindo.web.id",[12,27,401,402]],["malemjumat.ink",12],["malemjumat.lol",12],["malemjumat.mom",12],["dutasex.top",12],["filmapik.tv",12],["95.216.163.177",13],["192.99.70.18",13],["akurat.co",[13,104]],["22cinema.com",[13,121]],["ayobandung.com",[13,128]],["ayojakarta.com",[13,128]],["dapurpacu.com",[13,173]],["dewanontons.com",13],["download-lagu-mp3.com",13],["embed.dramanices.com",13],["duniafilm21.com",13],["gridoto.com",[13,118,148,149,152,193,194,195]],["harianjogja.com",[13,198]],["jawapos.com",[13,128,227,228]],["kompas.com",[13,149,152,244,245]],["koran-jakarta.com",13],["masagipedia.com",13],["pikiran-rakyat.com",[13,128,174,301]],["smallencode.com",13],["embed.dramacool.es",13],["republika.co.id",[13,369]],["hops.id",13],["komikindo.info",13],["dunia21.ltd",13],["k-vid.net",13],["otakuindo.net",13],["miyanime.site",[13,512]],["neumanga.tv",[13,30]],["5.182.209.205",14],["filmapik.international",14],["filmapik.kim",14],["filmapik.sbs",14],["filmapik21.space",14],["filmapik.support",14],["173.249.59.185",15],["194.163.145.21",15],["94.250.202.221",15],["185.217.95.30",15],["207.244.225.48",[15,72]],["drakorindo.best",15],["wibudesu.co",15],["giladrakor.com",15],["gudangmovies21.lol",15],["toriianime.net",15],["gatsunime.org",[15,484]],["indosemi45.org",15],["manhwaid.org",15],["layarkeren.site",15],["gudangmovies21.skin",15],["kazemanga.xyz",[16,308]],["65.108.132.145",[17,24,30,31,51]],["oploverz.bz",[17,24,84]],["sebokep.com",[17,54,308,309]],["komikdewasa.art",[18,77]],["bioskop201.biz",[18,31,80,81]],["animasu.cc",[18,87]],["bioskop21.co",18],["bioskopgalaxy21.com",[18,31,37,140]],["doujinlands.com",18],["downloadfilmbaru.com",[18,31,177]],["layarbiru21.com",18],["lmanime.com",18],["realmscans.com",[18,30,31]],["warungkomik.com",18],["22cinema.download",[18,31,343]],["nontonmovie.web.id",[18,31,159,409]],["luciferdonghua.co.in",18],["filmbaru.in",[18,31]],["luciferdonghua.in",[18,30,31]],["pemersatu.link",18],["komikcast.lol",18],["kuramanime.lol",[18,22]],["sektedoujin.lol",18],["komikmanhwa.me",[18,431]],["kumapoi.me",18],["mangaindo.me",18],["kikil.net",18],["komiku.net",[18,31,464]],["movie76.net",[18,31,37,138,140]],["ganool.nl",[18,31]],["ganool.ph",[18,31,419]],["cinemaindo.stream",[18,30,31,160]],["cinemaindo.tv",[18,30,31,519]],["animexin.xyz",[18,40]],["kanzenin.xyz",18],["sodasusu.com",[19,317]],["komikindo.tv",[20,386]],["oploverz.best",24],["oploverz.love",24],["animexin.top",24],["animekompi.vip",[24,40]],["194.163.183.129",[25,47]],["layarkaca21.com",27],["layarkaca21.web.id",27],["layarkaca21.net",27],["lk21.org",27],["lk21official.wiki",29],["film-ganool.co",[30,31]],["cinemaindo.com",[30,31,160]],["film-ganool.com",[30,31,189]],["filmroster.online",30],["bioskopmovie.tv",[31,518]],["clip.cewecewe.com",33],["ruangbokep.bond",34],["sibokep.bond",34],["ruangbokep.sbs",34],["streamingbokeponline.site",34],["ruangbokep.top",34],["streamingbokeponline.top",34],["kamarbokep.xyz",34],["kebokepanku.xyz",34],["bgibola.com",[35,36,37,40,135,136]],["bgibola.lat",[35,36,37,40,135,420]],["rumahperjaka.live",[35,37,38]],["rumahperjaka.site",[35,36,37,38]],["bioskopstar88.com",37],["cinemaqq.com",[37,161]],["juragantomatx.com",[37,140]],["bioskop55.me",[37,91]],["juraganmovie.net",[37,140]],["149.28.158.117",40],["212.32.226.234",40],["awsubs.co",[40,105,106]],["hencop.com",[40,201]],["indodb21.com",40],["anixlife.xyz",40],["shinigami05.com",[41,42]],["shinigamitoon.com",[41,43]],["shinigami06.com",[43,312]],["51.81.238.0",44],["193.178.172.113",45],["157.245.195.114",46],["37.49.229.132",[48,49]],["juraganfilm.icu",[48,349]],["216.155.135.144",50],["80.209.252.146",52],["164.68.127.15",53],["194.233.87.224",53],["154.26.132.73",53],["bokepmobile.fun",53],["194.233.73.15",54],["103.194.170.153",55],["xtubecinema.club",[55,102]],["xtubecinema.top",55],["46.166.167.16",[56,57,58]],["lk21.cam",56],["nekopoi.care",[56,86]],["nekopoi.cash",[56,86]],["gudangmovies21.cc",56],["indomovies.club",56],["indoxx1.club",[56,93]],["bioskop168.co",[56,107]],["filmbioskop21.co",56],["layarmovie21.co",56],["nontonsub.co",56],["01nonton.com",56],["123drakor.com",[56,57]],["bioskop45.com",[56,57]],["idbioskop.com",[56,57]],["nonton-streaming.com",56],["nonton789.com",56],["nontongratis88.com",56],["nontonmovie81.com",56],["nontonsub.com",[56,98]],["sashahillfilm.com",56],["semprot.com",[56,58,311]],["semprotku.com",[56,58]],["thirdstarfilm.com",56],["layarkacaxxi.id",56],["meownime.id",56],["zonabola.id",56],["nekopoi.lol",[56,86]],["animeboy.me",56],["nontonani.me",56],["nontondrama.me",56],["ns21.me",[56,57,67]],["sukamovie.mobi",[56,65]],["gandhool.net",56],["indomv.net",56],["nonton33.net",[56,57]],["satujiwa.net",56],["bioskop168.online",[56,107]],["layarxxi.online",[56,480]],["bioskop168.pro",[56,98,107]],["lk21.rip",56],["dewamovie.tv",56],["drakorindo.tv",[56,57]],["filmroster.tv",56],["ganoolmovie.video",56],["bioskopkeren.club",57],["bioskopxx1.com",57],["moviebaru21.com",[57,125]],["serunonton.com",57],["awsubs.id",57],["bioskopkeren.online",57],["indoxxi.top",[57,98,515,516]],["ns21.top",57],["bioskopkeren.xyz",57],["188.166.39.172",59],["173.199.167.192",60],["krucil.com",60],["krucil.net",60],["139.99.33.192",61],["164.68.105.199",62],["drakorindofilms.net",62],["video.pemersatu.org",[62,492]],["bokepid.wiki",[62,529]],["173.249.49.204",64],["139.99.33.210",65],["bokepfull.fun",65],["videocrot.org",[65,409]],["5.253.86.213",66],["layardrama21.icu",66],["nontonserial.com",[67,292,293,294]],["nonton21.tv",[67,293,294,344,421]],["139.99.61.225",68],["94.237.74.225",69],["streamingbokeps.co",[69,119]],["149.56.24.226",70],["kricom.id",70],["gomunime.biz",74],["68.65.123.84",75],["didrakorindo.com",75],["simontok.cx",75],["simontok.ink",75],["avtub.io",75],["sukanonton.online",75],["indoxxi.pictures",[75,496]],["indoxx1.pw",[75,501,502]],["avtub.sx",75],["indoxx1.art",76],["indoxxi.bz",76],["dewabioskop21.asia",78],["dewabioskop21.org",[78,481,482]],["mangaku.bio",79],["b201.info",[80,415]],["kabarviral.blog",82],["lewat.club",[82,94]],["mediapermata.com.bn",83],["terkini.id",[83,395]],["cafecinema.cc",88],["lk21.io",88],["dramamu.net",88],["lk21.cc",89],["dunia21.top",[89,98]],["dutafilm.cfd",90],["dutafilm.observer",[90,478]],["dutafilm.us",90],["bioskop007.club",91],["bioskop55.club",[91,92]],["bioskop1080.com",91],["bioskop90.com",[91,141]],["cinema007.com",91],["cinemastar21.com",[91,96]],["nontononline99.com",91],["bioskop90.me",91],["bioskop212.net",[91,96]],["apk.miuiku.com",94],["nf21.club",95],["semikeren.online",95],["dramaserial21.site",95],["nontonfilm21.club",96],["sinema21.id",96],["nontonfilmgratis.club",97],["ragihospitalkukatpally.com",97],["ns21.club",98],["animeindo.co",98],["idxxi.co",98],["lk21indo.co",98],["lk21xxi.co",98],["bioskopbos.com",98],["dramaind.com",98],["filmbioskop21.com",98],["lk21n.com",98],["nontondramas.com",98],["otakufile.com",98],["bioskopkeren.fun",98],["lk21c.fun",[98,345]],["subindo.id",98],["animebatch.web.id",98],["eka.web.id",[98,403]],["kazefuri.web.id",[98,406]],["mangaku.in",[98,408]],["lk-21.me",98],["neonime.net",98],["nontongratis88.net",98],["nontonbioskop21.org",98],["cinemaindo.pro",98],["layarindo21.pro",98],["animeku.tv",98],["sukamovie.club",[100,101]],["indoxx1.co",100],["idxxx1.com",[100,209]],["sidrama.com",100],["benfile.com",105],["blifnews.com",105],["kabar2.com",[105,233]],["mangacanblog.com",[105,267]],["semuaberita.com",105],["mangaku.web.id",[105,408]],["nusareborn.in",105],["film21terbaru.org",105],["cosmic1.co",108],["fastdrama.co",[109,110]],["hkfree.co",109],["iyottube.co",111],["iyottube.com",111],["komikcast.com",113],["bacamanga.id",113],["komikindo.id",[113,386]],["lk21official.co",114],["nontondramaonline.co",115],["nontondramaonline.net",115],["parapuan.co",116],["bolasport.com",[116,118,148,149,150,151,152]],["sonora.id",[116,149,152,275,391]],["www.parapuan.co",[117,118]],["motorplus-online.com",[118,149,195,274,275,276]],["tempo.co",120],["90animax.com",122],["animebatchs.com",[123,124]],["goblintvfree.com",123],["kapanlagi.com",[123,235,236,237]],["kompasiana.com",[123,149,152,218,247,248]],["merdeka.com",[123,271]],["nanime.in",123],["juragan-anime.net",[123,462]],["anixverse.com",125],["astroawani.com",126],["autonetmagz.com",127],["bagas31.com",129],["bareksa.com",130],["beritacyber.com",131],["beritasatu.com",[132,133,134]],["cnnindonesia.com",[132,163,166,167,168,169,170]],["detik.com",[132,162,163,164,166,168,169,174,175]],["jakartaglobe.id",134],["bioskop78.com",[137,138,139,140]],["cnbcindonesia.com",[137,162,163,164,165]],["nonton33.com",139],["bioskop99.me",[139,423]],["bioskop99.mobi",139],["nonton33.tv",139],["bisnis.com",[142,143]],["www.tek.id",[143,393]],["blibli.com",144],["blogspot.com",145],["destinasiwisatamu.blogspot.com",146],["starringheavenlyrics.blogspot.com",147],["kontan.co.id",[149,363]],["grid.id",[149,276,378]],["kompas.tv",[151,194,523]],["bukalapak.com",153],["m.bukalapak.com",154],["carisinyal.com",155],["cdramabase.com",156],["ceritasexindonesia.com",157],["chordtela.com",158],["cinema-indo.com",159],["nonton21.net",159],["haibunda.com",[162,168,170,174,197]],["mamikos.com",[162,227,265]],["insertlive.com",[166,170,222]],["teknoup.com",[166,323,324]],["beautynesia.id",[169,352]],["comotin.com",171],["cubmu.com",172],["dewantn.com",176],["dunia21tv.com",[178,179]],["cinema-indo.web.id",[178,179]],["layarcinema.tv",[178,179]],["duwitmu.com",180],["dwanonton.com",[181,182]],["dewanonton.vip",[181,527]],["emitennews.com",183],["eramuslim.com",184],["faktabali.com",185],["femaledaily.com",[186,187]],["alinea.id",186],["filem456.com",188],["gadgetren.com",190],["gamebrott.com",191],["gopego.com",192],["gudangpemain.com",196],["solopos.com",198],["hdtvku.com",199],["hellosehat.com",200],["hipwee.com",202],["hotabis.com",203],["iberita.com",204],["idntimes.com",[205,206]],["sindonews.com",[206,314]],["idpelago.com",207],["indobokepz.com",210],["indogamers.com",211],["indonesiamovies21.com",212],["indosiar.com",213],["indotelko.com",214],["indoxtream.com",215],["indoxx1.com",216],["idxx1.top",[216,430,514]],["indoxximovie.com",217],["inilah.com",[218,219]],["ekonomi.inilah.com",220],["teknologi.inilah.com",[220,221]],["isdaryanto.com",223],["jakbos.com",224],["jalantikus.com",225],["jendelakaba.com",229],["jenismac.com",230],["jpnn.com",231],["k-vid.com",232],["dramacool.io",232],["dramanice.io",232],["kabar24.com",234],["liputan6.com",[235,259]],["otosia.com",237],["m.kapanlagi.com",238],["klikanggaran.com",239],["www.hops.id",239],["klikseru.com",240],["komikbaru.com",241],["komikstation.com",242],["komiku.com",243],["tribunnews.com",[245,319,330,332]],["indonesiasatu.kompas.com",246],["modifikasi.com",[248,273]],["www.kompasiana.com",249],["kordindonesia.com",250],["kotakgame.com",251],["kshowid.com",252],["kuyhaa-me.com",253],["gigapurbalingga.net",253],["lapar.com",[254,255]],["loveindonesia.com",[254,262]],["ld2tv.com",256],["lensaindonesia.com",257],["www.lingohut.com",258],["lk21.pw",260],["cloud.majalahhewan.com",263],["info.mapsaddress.com",[263,269]],["info.vebma.com",[263,269,336]],["info.gambar.pro",[263,269,336]],["malaysiakini.com",264],["manadobaswara.com",266],["mangafap.com",268],["marketeers.com",270],["mgkomik.com",272],["my-best.com",277],["mydramalist.com",278],["mypt3.com",279],["doujindesu.tv",279],["nanimex1.com",280],["negumo.com",281],["nekonime.com",282],["neonime.com",283],["neonime.vip",283],["ninemanga.com",284],["njavtv.com",285],["nobartv.com",286],["nontonbokeps.com",287],["nontonfilm77.com",288],["nontonfilm88.com",289],["nontonme.com",290],["nontonplus.com",291],["fb21.tv",[293,294,344,521]],["dunia21s.fun",[294,344]],["lk21.li",[294,344,421]],["nontonsini.com",295],["okezone.com",297],["oktavita.com",298],["otomania.com",299],["palingseru.com",300],["popbela.com",302],["rbtv77.com",303],["readwebtoons.com",304],["realitakita.com",305],["realthaisluts.com",306],["remo-xp.com",307],["semarangkota.com",310],["siherp.com",313],["tetew.info",313],["greget.space",313],["situshp.com",315],["smartphoneku.com",316],["suara.com",[318,319]],["sundul.com",320],["susterbokep.com",321],["tabloidbintang.com",322],["idfl.me",[323,427,428]],["r-l.me",[323,427]],["tempointeraktif.com",325],["thejakartapost.com",326],["tokopedia.com",327],["topfilmz.com",328],["trenasia.com",329],["blog.tribunjualbeli.com",[330,331]],["makassar.tribunnews.com",333],["wartakota.tribunnews.com",334],["unixmen.com",335],["waralabakan.com",337],["windowsreport.com",338],["wisatalova.com",339],["wowkeren.com",340],["zonabola.com",341],["anichin.dev",342],["lkprd.fun",346],["nomat.fun",347],["lk21.host",348],["animeindo.id",350],["apkmod.id",351],["radarlombok.co.id",351],["novelgo.id",351],["paraedu.id",351],["hightech.web.id",[351,405]],["nama.web.id",351],["ceklist.id",354],["alona.co.id",355],["cerpen.co.id",356],["chip.co.id",357],["cosmogirl.co.id",358],["anime17.net",[358,444]],["dream.co.id",359],["kaskus.co.id",360],["katadata.co.id",361],["ketik.co.id",362],["lihat.co.id",364],["orami.co.id",365],["pontianakpost.co.id",366],["pricebook.co.id",367],["rejogja.co.id",368],["timesindonesia.co.id",370],["viva.co.id",371],["log.viva.co.id",372],["wartaekonomi.co.id",373],["dailysocial.id",374],["dataindonesia.id",375],["filmterbaru.id",376],["ggwp.id",377],["nextren.grid.id",379],["www.grid.id",380],["inews.id",381],["www.inibaru.id",382],["investor.id",383],["jurnalisindonesia.id",384],["kabargames.id",385],["komikcast.net",386],["komikindo.pro",[386,499]],["manganime.id",387],["medcom.id",388],["slurr.my.id",389],["onlinemetro.id",390],["tek.id",392],["terasjakarta.id",394],["tirto.id",396],["uzone.id",397],["internetpositif.uzone.id",398],["animeindo.web.id",399],["animeindo.video",399],["animekompi.web.id",400],["filmbagus21.info",402],["ganool.web.id",404],["mangaku.site",[408,511]],["resep.web.id",410],["suki48.web.id",412],["zigi.id",413],["senimovie.info",[416,417]],["senimovies.net",416],["ganool.is",419],["ganool.se",[419,507]],["ganool.st",419],["manganime.live",422],["doroni.me",424],["dunia21.me",[425,426]],["dunia21.net",426],["dunia21.org",426],["dunia21.wtf",426],["idtube.me",[429,430]],["lk21official.mom",432],["bharian.com.my",[433,434]],["hmetro.com.my",[434,438]],["cari.com.my",435],["mforum.cari.com.my",436],["hijabista.com.my",437],["majalahpama.my",437],["nona.my",437],["vanillakismis.my",437],["utusan.com.my",439],["mediahiburan.my",440],["mudah.my",441],["rasa.my",442],["youtube-mp3.my",443],["animeindo.net",445],["awnime.net",446],["bintangmawar.net",447],["brilio.net",448],["briliobeauty.net",[448,449]],["briliofood.net",448],["cinema-indo.net",450],["dramaqu.net",451],["duniaku.net",452],["filmace21.net",453],["filmbagus88.net",454],["filmku.net",455],["funtasticko.net",456],["gadismalam.net",457],["harakahdaily.net",458],["ibugil.net",459],["indoxxi.net",460],["inidramaku.net",461],["kurazone.net",465],["nobarfilm21.net",469],["pinayflex.net",470],["sangetods.net",471],["seri168.net",472],["suarasurabaya.net",473],["tvkabel.net",474],["unyil.net",475],["zonapanaz.net",476],["indobokep.pro",476],["bokepml.online",479],["dwa21.org",[481,483]],["kumpulmanga.org",485],["manhwadesu.org",486],["nanimex.org",487],["nontonanimeid.org",488],["nontoncinema.org",489],["otakuindo.org",490],["pakbos21.org",491],["pkspiyungan.org",493],["pojokmanga.org",494],["satujiwa.org",495],["bokepkita.pro",497],["indoporn.pro",498],["otakudesu.pro",500],["tv1.bokepindo21.vip",502],["kuramanime.red",503],["layardrama21.rest",504],["file.rocks",505],["lonteku.sbs",506],["cmovieshd.se",507],["myasiantv.se",508],["ganol.si",509],["komikcast.site",510],["komikcast.vip",510],["mangaku.vip",511],["4play.to",513],["indoxxi.tv",[515,522]],["nomat.top",517],["elde.tv",520],["xx1.tv",522],["layarkaca21.tv",524],["lk21.tv",524],["ns21.tv",525],["ns21.us",525],["drakorasia.us",526],["kurina.vip",528],["tv.lk21official.world",530],["indostreamings.xyz",531]]);

const entitiesMap = new Map([["agenbokep",0],["anichin",1],["animekompi",[1,2]],["komikcast",[1,18,19]],["komikdewasa",[1,18]],["komikremaja",[1,18]],["kuronime",[1,23,24,25]],["lendirpedia",[1,28]],["manhwaindo",[1,18]],["oploverz",[1,18,30,31]],["pascol",[1,2,28,32]],["samehadaku",[1,13,39,40]],["skandalpedia",1],["anoboy",[3,4,5]],["baladfilm",[4,6,7]],["kuramanime",[4,21,22]],["bioskopkeren",[8,9,10]],["layarkaca21",[9,26,27]],["drbokep",11],["dutasex",12],["perawanbokep",12],["filmapik",13],["komikindo",[13,20]],["filmapik21",14],["gudangmovies21",[15,16,17]],["nontondrama",29],["pemersatu",33],["ruangbokep",34],["streamingbokeponline",34],["rumahperjaka",[35,36,37,38]],["shinigami",[41,42,43]],["shinigamitoon",43]]);

const exceptionsMap = new Map(undefined);

self.specificImports = self.specificImports || [];
self.specificImports.push({ argsList, hostnamesMap, entitiesMap, exceptionsMap });

/******************************************************************************/

})();

/******************************************************************************/
