/*******************************************************************************

    uBlock Origin Lite - a comprehensive, MV3-compliant content blocker
    Copyright (C) 2019-present Raymond Hill

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see {http://www.gnu.org/licenses/}.

    Home: https://github.com/gorhill/uBlock
*/

/* jshint esversion:11 */

'use strict';

// ruleset: ind-0

/******************************************************************************/

// Important!
// Isolate from global scope
(function uBOL_cssSpecificImports() {

/******************************************************************************/

const argsList = [".header__banner",".penci-banner-box:not(#penci-banner_box--86294)",".theiaStickySidebar .widget_text",".wpb_content_element","#black-studio-tinymce-41,\n#black-studio-tinymce-67,\n#hotwp-header-banner,\n.hotwp-box.widget_black_studio_tinymce:has(> div > p > img:only-child),\n.hotwp-box.widget_black_studio_tinymce:has(> div > p > ins)","#front-widget .front-widget:nth-child(2),\n#sidebar .widget:nth-child(2)",".item_content,\n.vc_col-sm-4 .horizontal_carousel_container",".wpb_single_image","div[id^=\"nutdcr\"]",".header-promotion",".content-ad-block360,\ndiv[class*=\"ads__\"]",".td-a-rec","figure.wp-block-image",".canvas-slider,\n.wpb_single_image.vc_align_center a[target=\"_blank\"] img","#sidebar .widget_text",".e3lan",".my-3 img","div[style^=\"font-size:25px;\"] > table",".ad img",".home_popup","#tie-block_855",".stream-item-125-widget",".banner","#div_252,\n#wrapper_283,\n.aw320","div[data-ad-slot] ~ hr",".add img",".sidebar .widget_media_image:not(#media_image-5)","#Image1",".advt-col",".widget_media_image",".powrMarkContainer,\n.spad-section img,\na[onclick*=\"GPMonthlyPromo\"]","#descripton div[style*=\"url\"],\ndiv[pid^=\"10\"]",".advertise","#block-14",".td-a-rec .td-all-devices",".vc_widget_sidebar .td-a-rec",".vl-header-ads",".widget_media_gallery","#spcl_advertise_right,\n.DAdd .hidden-xs,\n.DAdd img,\n.topadv","#sv_gad_left",".ads",".fullwidth-add,\n.header-upper .pull-right,\n.sidebar-adds-widget",".add-inner",".td-header-sp-recs",".td-main-sidebar .widget_text,\n.wpb_raw_html:has(.adsbymahimeta),\ndiv[id^=\"garav-\"]",".paidPoster",".n2-section-smartslider",".sideadholder,\n.theadstop",".theiaStickySidebar .stream-item-widget",".img-ads > li > img","#text-2",".widget_custom_html",".main-content .stream-item",".stream-item-widget",".widget_media_image:not(#media_image-2)","#header-aside","aside.widget_media_image","div[class^=\"AdvtSample\"]",".mom-e3lanat",".mom_custom_text",".main-menu ~ .container div:has(> a > img[src*=\"/uploads/ads/\"])",".header-ads-wrapper","a[href*=\"kidoovacations.com\"]","[id*=\"_level_\"]:not([data-mixin]):not(#right_level_2_1)","div:has(> .text-left + [class*=\"728/90\"])","#text-52",".advertisement_above_footer","#Image10","#Image11","#Image3","#Image6","#jssor_1","#slider","#HTML31,\n#HTML32,\n.HTML:has(> div > ins.adsbygoogle)",".code-block",".gmx-image",".wp-block-jetpack-tiled-gallery",".widget_media_gallery:not(#media_gallery-3)","figure.wp-block-image.size-full",".banner-add",".cm-125x125-advertisement-widget",".comContent div[style*=\"min-height: 225px;\"]",".mom-e3lanat-wrap",".tr_e3lan-widget","#custom_html-4",".add-left",".add-sideber","#HTML2 .separator img",".sidebar .widget.Image",".widget_block",".banner-promotions-wrapper",".owl-carousel",".adsvnment",".post-image.entry-content",".bannerfooter","#sidebar .widget_black_studio_tinymce","#side-banner-ads",".iframe-ads-block",".bannar",".betterad-container",".m_none > a[target=\"_blank\"]",".custom-slider",".elementor-widget-shortcode img:not([src*=\"1f642.svg\"])",".pm_home_top_sidebar .widget_media_image",".videoaddwraper",".e-con-full.jedv-enabled--yes,\ndiv[class^=\"a2zsa-content\"]","#n2-ss-20,\n#n2-ss-6",".adv",".wpb_content_element img",".wpb_row.vc_inner",".elementor-widget-image .size-full",".banner-img","div[id^=\"aagol-\"]","div.colombiaonesuccess div:has(> div > div > a > div > p),\ndiv.colombiaonesuccess div:has(> div > div > a > h2 + h4)",".theiaStickySidebar .widget_media_image","figure.wp-block-gallery","div.col-lg-3:has(> ins.adsbygoogle),\ndiv[class*=\"ads_\"]",".bn-lg",".bn-lg-sidebar","#secondary .widget_media_image",".stream-item",".ws-block-body > a[href=\"\"]","#text-7",".elementor-widget-banner-box","#block-13",".elementor-col-33 .elementor-section","#media_image-4",".my-2",".bn-md","div[id^=\"itro_\"]",".adsImg_section",".advertismentRow",".colombiatracked",".imgOverlayAd,\ndiv[id^=\"AS_O_LHS\"] div:has(> div > span > a[rel*=\"sponsored\"])","#text-25","#text-54,\n#text-61",".tdb-block-inner > p img","div[id^=\"aapni-\"]",".aapno-widget","#roadBlock,\ndiv[class*=\"bigyap\"]",".ai-sticky-widget",".text-10,\n.text-4",".textwidget img",".long-ad,\n.single-content ~ p","div[class*=\"sgpb-\"]",".text-center:has(> a > img[src*=\"/ads/\"])",".sponsers",".elementor-widget-image",".elementor-widget-wp-widget-advads_ad_widget,\n.entry-content figure.is-resized,\ndiv[id^=\"abbih-\"]",".entry-content > figure.wp-block-image",".td-a-rec img","#text-3",".vc_col-sm-3 .bs-shortcode","#bigyaapan",".td_block_single_image","a[target=\"_blank\"] img","img[alt*=\"Sidebar AD –\"]","#main_content .d-sm-block",".myAdBox",".top_new_add","div img[src^=\"ad/\"]","#media_image-2",".a-ecom-wrap,\n.uk-text-meta",".ad-wrapper-leaderboard,\n.uk-sidebar._hsidebar","#HTML18","#HTML5",".ml-slider",".a-wrap","#sidebar1","#text-30","#text-48","#text-49,\ndiv[id^=\"achhi-\"]","#text-50","#text-18","#text-24","a[href*=\"newzoninfotech.com\"] img:only-child",".widget_media_video",".sidebar .kopa-carousel-widget",".elementor-widget-smartmag-codes",".footer_top_banner",".tab_265top_left",".bn-inner","a.external",".right_adbox iframe","#HTML1",".dt_navbar-banner-item",".small-banner-2,\na[href*=\"drneem.com\"]","a[href*=\"daraz.com.bd\"]",".adv-video","#ouibounce-modal",".ads-sec","div[id^=\"agnij-\"]","figure.wp-block-image.size-large","#main-body .custom,\n#sp-slider-wrapper,\n:not(#sp-component-area) > #sp--wrapper,\nsection:not(#sp-big-footer-wrapper) .article_anywhere,\nsection[id$=\"add-wrapper\"]",".widget_block:not(#block-2)",".stream-item-top-wrapper",".stream-item-widget:not(#stream-item-widget-3)",".ajabg-widget,\ndiv[class^=\"ajabg-\"]",".dn-container",".widget.Image","#text-4","div:has(> ins.adsbygoogle)","#bunyad_ads_widget-3","div[data-amads-id]",".header-baner",".Add",".add",".notice_single","#videoAdd",".Add figure",".col-md-12 .textwidget,\n.textwidget:only-child",".DHeaderBanner","img[alt=\"advertisement\"]","#content + .col-md-4 > div:nth-child(3)","a[href*=\"pathwaydrivingschool.com\"]",".advertise_to","img[alt=\"Jainta Barta Local Ad\"]",".ad-ajmernama",".block-custom-content",".widget_tibwky","div[data-adid]",".ad","#recent-boxes2,\n.blog-posts marquee ~ :not(div)","div[class*=\"pannel-banner\"],\ndiv[id^=\"ear-\"]","#text-html-widget-2","#block-17",".td-main-content-wrap .tdm_block img:not([src*=\"_n-1.gif\"])",".td-ss-main-sidebar .widget_media_image","#supermag_ad-12","#ai_widget-2",".text-html","#media_image-6 img","aside.widget_custom_html","#text-32",".add_banner",".sideAdd",".adv-topx","#header-right-section",".DAdd2",".carousel",".hdr_banner","a[href*=\"pustokbazar\"]","div[data-adid] img:not([alt*=\"e-Paper\"])",".adv_single,\n.banner-ad-01",".itpolly_widget img",".head_bottom_add",".uc-sky-ads","#text-20",".DAdd",".td-a-rec-id-sidebar","#popUp,\n.index_ads_one,\n.index_ads_three,\n.index_ads_two",".td-spot-id-header","._df_custom",".row + .single_side_bar",".mb-3 .w-100",".adss_banner,\n.cm-beside-slider-widget",".adv-slot",".ad-mb-app,\n.remove_ad_class",".elementor-widget-shortcode img",".sidebarVoteAd",".ne-banner-layout1",".ad-banner","main .htmlwidget,\nmain .imagewidget","#text-11","#text-14","#text-17","#text-29","#text-36","#text-37","#text-38","#text-57","#text-58",".adbox",".adouterbox,\n.marketingbnnerbox,\n.rightadbox","a[href*=\"jeevansathi.com\"]","#text-1",".header-banner",".customAds,\ndiv:has(> div[id*=\"-ad-\"])",".stickyAds",".ai_widget","#custom_html-3",".four-col > a[href=\"\"] img",".full_ad_section",".sidebar_top_Ad",".bigyapan",".modal__img",".tdm_block","#block-5",".stream-item:not(#tie-block_1354)","#custom_html-19","div[id^=\"SC_TBlock_\"]",".widget_text p",".colombiaadcode","div[id^=\"AS_O_LHS_\"] > div:nth-child(-1n+10)","div[id^=\"AS_O_LHS_\"] > div:nth-child(1n+20)","div[id^=\"showAS_\"]","#header-right-sidebar .widget_media_image:not(#media_image-7)","#headadd,\n.big-add,\n.reseller-add,\ndiv[class^=\"contentadd-\"]","#text-19","#text-21",".ad-pvt,\n.pvt-ads",".apand-before-content","#homeads",".advertisement","div[id^=\"goji_yo\"]",".portlet-journal-content","#text-11 iframe",".col-lg-2 > .white-bg,\n.order-3 .mt-4",".entry-content > p img","a[href*=\"alljobvacancies.com\"]",".container1","#FullWidthWidget-Top","#block-7",".html-div img",".jeg_content img.error,\n.jeg_header a[target=\"_blank\"] img,\nmarquee img",".flexslider","a[href*=\"traffictail.com\"] img",".advertisement-heading,\n.mb-4 .mt-3 img,\n.uk-container a[target=\"_blank\"] img[src*=\".gif\"]","section.widget",".news-desc figure img","div[class*=\"advertisement\"]",".custom-ad-link,\n.esn_twin_ad_widget","#sidebar",".adcontainer","main [data-adid]",".one-1",".primary-sidebar-widget:not(.h-c),\ndiv[data-adid] a:not([href*=\"arthosuchak.com\"]) img","#custom_html-11",".widget_origin_animated-image","div[id^=\"aryav-\"]",".affiliate-card.text-center",".adds_menu","body ~ iframe[style*=\"height: 100%\"]",".adsection:has(.ad-1),\n.desktop-ad-1,\n.revive-ads-top","#block-12",".tdm-popup-modal","#custom_html-5",".widget_custom_html.panel-first-child",".ad_sec","div:has(> div > p > .adsbygoogle)","div[id^=\"AS_O_LHS_1\"]","#HP_O_LHS_7 > div:nth-child(-1n+10),\ndiv[id^=\"AS_O_LHS\"] > div:has(a[href*=\"paid.outbrain.com\"])","div[id^=\"showAS_O_BEL\"]","#widget-sidebar-1","#widget-sidebar-3","#text-5",".wpb_single_image img:not([src*=\"krishi-\"]):not([src*=\"ban2-\"])","a[href*=\"prabhatnamkeen.com\"]","[data-adid]","div[class*=\"sgpb-popup-\"]",".elementor-section-items-middle ~ section:nth-child(4)",".widget_text",".td-spot-id-content_bottom",".td-spot-id-content_top","#custom_html-13,\n.header-widget-region",".widget_sp_image",".widget_gallery_img_widget","#content section.widget_media_image","#text-6",".addtoany_content_bottom ~ div img",".sidebar .widget_media_image",".td-main-content-wrap .td-a-rec",".slider-section",".header-top .align-items-end,\n.mt-1,\n.row > .mb-3",".barta-ad",".td-a-rec-id-header","#sidebar .widget_media_image",".master-slider-parent",".wpb_wrapper .wpb_single_image",".widget_smartslider3",".widget_metaslider_widget",".side-bar center > embed","#media_image-3",".master-slider",".vc_images_carousel",".header-right","div[class^=\"sgpb-\"]",".et_pb_ads_0,\n.widget_et_ads",".advertisement-cntnt,\ndiv[class^=\"adcntnr\"]",".mt-3",".addd",".bigyaapan-section",".full-bigyapan",".aloks","#HTML20",".separator a img,\nspan[style=\"font-size: 8pt; color: #bdbbbb;\"]","a[href*=\"amzn.to\"]",".ad-home",".AdSection",".AdvertClass",".prl-panel .widget_text","#mvp-leader-wrap","#custom_html-18","#HTML15","#HTML16","#HTML860",".code-widget","#bannerclassfd,\n#classlistmain,\n.addima,\n.almanacheader",".home-e3lan","#secondary .widget_text",".biggapon",".home_page_ad img","#top div:has(> .flex-c-c),\n.m-t-20:has(> div > div > .m-t-30),\nimg.max-w-full:not([src*=\"BLDA.jpg\"])",".banner-header","a[href*=\".ac.bd\"]",".theiaStickySidebar .wp-block-image,\n.width-ad-wrap",".elementor-widget-html iframe",".text-secondary.d-block",".sny-ads-panel","div[id^=\"bangl-\"]",".right-container .ads",".textwidget img:not([src*=\"banner-\"])",".Front-page-Right-Side-Ad,\n.Single-Post-Left-Side-Ad,\n.Single-Post-Right-Sidebar-Ad,\n.front-page-ad,\n.header_top_ad_area_2",".col-md-3 .widget_text.widget_area + .widget_area,\n.single_details .widget_area",".widget_area img","#HTML2",".banner2",".themesBazar_widget img","#block-25",".stream-item:not(#tie-block_309)","a[href*=\"itcornerbd\"] img",".widget_text .custom-html-widget","img[alt=\"Skin'O.-ad\"]",".aunqur img,\n.overayFeaturedImage,\n.topLeaderBoardAdHome,\ndiv[id*=\"BT_Inner_\"]",".header_ad_block",".topbanner","div[class*=\"code-block\"]",".printOff",".top_add",".codeneric_uam_link,\na[target=\"_blank\"] img:not([src*=\"icons\"])",".esn-ainfo-widget","#right_level_2",".inside-post-ad",".left_level_ad",".elementor-widget-jnews_element_ads_elementor",".elementor-shortcode .metaslider,\n.sidebar-inner",".widget_adsforwp_ads_widget","a[href^=\"/advertisements/advts/\"]","#id-widget-advertisements-4","#tie-slider-widget-2,\n#tie-slider-widget-9","#custom_html-6",".widget_area p > img","a[href*=\"enjoy.net.bd\"] img,\ndiv[data-href*=\"enjoynetwork.bd\"]","#custom_html-7",".home_page_ad",".widget_text img",".sidebar .widget_black_studio_tinymce","div[class^=\"barnalatoday\"]",".adalyticsblock img:not([src*=\"newbarnan_\"])",".bigyapaan__section",".bigyapan-banner",".a-widget,\na[href*=\"BandhoB\"]",".sidebar .widget_custom_html",".popup-wrpp,\n.widget_text img:not([src*=\"Captureeeebbbb.jpg\"])","a[href*=\"bdinfobiz.com/pos-software\"]","div[class*=\"adSlot\"]",".basta-first",".main-sidebar .widget_media_image","#HTML3","#Image2","a[href*=\"ad.battinews.com\"]","#HTML4","#SidebarWidgets-S1 .widget.Image","#block-6",".after-menu-ads",".bg-striped-diagonal,\na[title^=\"Advert\"]",".featad",".bot-ads","#cm-secondary .widget_block,\nfooter figure.wp-block-image","#wp-custom-header",".adv_image","#media_image-12",".cs-banner",".single-page2-topAdd","div[class^=\"add-section\"]","#block-4","#custom_html-2",".entry-ads-top",".h_ads,\n.sidebar-adv img",".wpb_wrapper .vc_raw_html","#text-13",".textwidget > p img,\n.textwidget:has(.adsbygoogle)",".advertise_space1",".header .pull-right","#BDIPO_ad_id,\n.advertisements","#media_image-6",".d-lg-block iframe",".add_img",".adflexbox","#bottom-header-banner",".DAdvertisement",".add_area",".add-section",".bdsom-content,\n.td_mod_wrap.td-fix-index > a img","div[style^=\"width:320px; height: 260px!important; float: right;\"]",".ad_text_box,\ndiv[class^=\"angwp_\"]","#text-html-widget-25,\n#text-html-widget-35,\n#text-html-widget-41","#secondary .side-widget:first-child,\n.coronaupperadd,\n.post-content .sidebar-content,\n.single-news-widget > img.size-full,\n[class^=\"add-\"]",".header-right-adv","div[id*=\"-ad-block-\"]",".vce-blank-module:not(#main-box-12)",".theiaStickySidebar .owl-carousel","img[alt*=\"AD \" i]",".wp-image-12972,\ndiv[id^=\"bebak-\"]",".entry-content .code-block",".sidebar .widget_text:not(#text-10)",".belag-content",".elementor-widget-image img:not([src*=\"bbtv-logo\"])","#rev_slider_1_1_wrapper",".gam-each-npad",".wplite-banner-ads",".FooterAdArea .wp-block-image","aside.widget_block",".td-ss-main-sidebar .td-a-rec",".vdo_ads","#primary img[alt=\"ads\"],\na[href*=\"mastercafebd\"],\naside:not(#text-33):not(#text-47) img[alt=\"ads\"]","#media_image-7",".swiper",".features-slide-widget,\n.image-post-slider",".code-block img",".jeg_ad",".addBox,\n.widget_categories:not(.postLatest-list)",".header-ainfo","#block-8",".common-widget .Image:not(#Image1):not(#Image3)",".sidebar .stream-item-widget:not(#stream-item-widget-18)",".stream-item-top","div:has(> div[id^=\"Ad--\"])",".mb_ads_title,\n[id*=\"_ad_\"]","#custom_html-15",".theiaStickySidebar .e3lan",".theiaStickySidebar .widget_custom_html",".metaslider",".vc_widget_sidebar,\n.wp-block-image img[src*=\"advt\" i],\n.wp-image-51060","#left_level_3","#level_1_after,\n.ad_level_1_before_heading",".content_top:first-child .latest_slider",".header_bottom_right",".banner-wrap img,\n.video-ad",".add .widget_area > img",".single-dtls a[href*=\"accbuysell.com\"]","div:has(> p > img.wp-image-23118)",".wpb_text_column.wpb_content_element",".default-advertise,\n.thedailytext-advertise","#HTML10","#HTML11","#home-ads","#div-ub-bhorerkagoj,\n#sidebar .textwidget",".np-header-ads-area",".bidro-content_4","section.widget_custom_html","#bk_sidebar_8,\n#text-69",".top-add",".bihar-widget","#wonderpluginslider-container-1",".elementor-widget-shortcode img[src*=\"WhatsApp\"],\nsection[data-id=\"e3b7c3d\"],\ntagdiv","aside.widget_media_gallery",".customad","a.post-middle-banner,\na.sidebar-banner",".elementor-image","#custom_html-1",".afw_ad",".wp-video",".asn-bk-txt","#media_image-10","#media_image-8","div[data-adid]:not([data-adid=\"5022\"]):not([data-adid=\"3716\"])",".bikan-before-content","div[class*=\"bikan\"]",".advertise img,\n.containerhome a[target=\"_blank\"] img:only-child,\n.desktop_main_news_banner",".container a[target=\"_blank\"] img","div[id^=\"sgpb-\"]",".divAdvertisement,\n.home-sidebar-banner,\n.topadmid",".full-with-add,\ndiv[class^=\"top-sidebar-adv\"]",".code-block-4",".home_widget",".navbar-top-banner,\n.newspaper-advertisement",".tdm-popup-modal-wrap",".td-post-content > p a:not([href*=\"biswabanglasangbad\"]),\n.td_block_single_image:not([data-td-block-uid=\"tdi_41\"])","img[alt=\"Gurukpo plus app\"]",".banner-bigyapan,\n.bigyapan-inside-content,\n.sidebar-advs","#skip-ads",".ad-banner-img",".adRightSideBar","#showAS_O_BEL_0",".sidebar_top_wrapper","#HTML8",".headerright","#Image119,\n#Image125,\n#Image25,\n#Image33,\n#Image85,\n#LinkList21","#Image16","#Image4","#main-top","#sidebar .widget.HTML:not(#HTML2)","#HTML9",".add-place",".header-add-place",".xembgt,\naside#sidebar-primary-sidebar","#text-9",".stream-item img",".topadlft","h5[style*=\"PEARL-ads.jpg\"]",".topad","div[data-zoneid]","div[style^=\"min-height:250px;\"]","#block-2",".td-ss-main-sidebar .widget_block",".wp-image-13566,\n.wp-image-352","#article-middle2,\n.max-h-full",".wpcnt",".pbwidget.slideshow",".footer_logo",".bornamelanews24adlabel","#header-right-sidebar","aside.widget_metaslider_widget",".body2_ad,\ndiv[class^=\"ad_mid\"]",".add_pad_bot_single,\n.add_pad_bottom",".sticky-sidebar .widget_media_image","#heatmapthemead-primary-sidebar,\n.amzn_wdgt",".bs-vc-block .wonderpluginslider-container",".header-inner #sidebar","#block-3","#block-9",".stream-item:not(.stream-item-top-wrapper)",".slider-pro",".Nws_banner_Hp,\n.ad-height-desktop,\n.div[id^=\"between_article_content\"],\n.hide-on-mobile,\n.podcastads",".ads_box_grid",".widget_text:not(#text-10)","#stream-item-widget-1","figure.wp-caption","img[alt=\"add buxar\"],\nimg[alt=\"ads buxar\"]",".add img:not(.wp-image-19734)","div[class^=\"ads_\"]",".blurb",".ds-ms-blurb",".theiaStickySidebar .wpb_single_image,\n.wpb_gallery_slides,\na[href*=\"amrutveni.com\"] img,\na[href*=\"chungathjewellery.com\"] img","#skipAdModal,\n.advertisement-fullwith,\n.bignews_slider,\nfooter ~ ul.images",".modal-backdrop",".insert-ad","#text-45,\n#text-47",".add > .widget_area img","div[data-adid][data-type=\"image\"]","#example,\n#logoright","#content img.jetpack-lazy-image[src*=\"-march.jpg\"]",".navbar-ad-section",".piki-ads",".epcl-banner",".bwg_container",".bwp_gallery_slideshow",".entry-content div[id^=\"cgmit-\"]",".header-before-ad",".main-sidebar .widget_block,\ndiv[id^=\"local-\"]",".add-top-margin,\n.ne-sidebar > div:not(.sidebar-box),\n.sidebar-box.bg-aqua","#media_video-2",".container-full .stream-item","#media_video-3",".chaip-after-content_4","#text-26","section.widget figure",".post-right-side-square-ads-big,\ndiv[class$=\"-ads\"]",".chama-before-content,\n.chama-widget","div[id^=\"champ-\"]",".code-block-center",".story-wrapper a.disabled","div[id^=\"AS_O_LHS\"] > div:nth-child(-1n+10)","#secondary section.widget_media_image","#sticky-wrapper .widget_media_image,\n.newscard-widget-ad","#main .code-block",".entry-content > p > img",".d-print-none","#text-67",".e3lan-top","#secondary section.widget_media_image:not(#media_image-23)",".widget_media_image:not(.media_image-50):not(.media_image-54)",".single-ditails + .add .widget_area",".add figure.size-full",".jeg_main .widget_media_image,\ndiv[id^=\"chann-\"] img:not([src*=\"Google-News-Icon-Channel-i-1.jpg\"])",".col-md-3 .master-slider,\n.elementor-widget-wp-widget-master-slider-main-widget,\n.entry-content figure img[width=\"600\"]",".content-box-ads,\n.news_content .code-block","#media_image-24","#HTML7",".td_block_text_with_title",".tdb_single_content img",".inner-ads",".spbs-width-ad",".mom_e3lan-empty",".home .elementor-widget-image","#header #sidebar","a[href*=\"ksrm.com.bd\"]","aside.widget_text",".widget_advertisement-bar",".evo-header-banner","section[id^=\"id\"]","a[href*=\"bharatgeneric.com\"]","#Image9",".cheta-before-content",".subhakamana-ad","#image_gallery_36934,\n#image_gallery_37522,\n#image_gallery_37524,\n#pg-22-3,\n#pg-22-5,\n.entry-the-content .code-block,\n.entry-the-content img.aligncenter.size-full,\n.entry-the-content img.alignnone.size-full,\n.topbar-inner .hgrid-span-12","#main .widget_media_image",".ad--space",".ad--widget-no,\n.carousel:not(#myCarousel2),\n.main--sidebar .widget:has(> div.ad--widget-no)","div[id^=\"chhat-\"]",".img-my-ad","#custom_html-21",".news_portal_ads_banner","aside.sidebar .widget_media_image","div[class*=\"stream-item\"]",".stickey-side .ad-title ~ a",".m-280,\ndiv[id^=\"v-chopaltv\"]","#carouselExampleControls",".height-100,\n.home-page-top-right-add",".home-lead-block,\n.square-space",".site-header-banner","[class*=\"googleAd\"]",".custom-html-widget","#block-15,\n.elementor-widget-he-advertisement-banner",".pum-content",".page.hentry","a[target=\"_blank\"]:not(a[href*=\"cinepati\"])",".code-block:not(.code-block-3)",".fw-bold.text-center",".td-main-content-wrap .td-a-rec-id-custom-spot","#newscard_horizontal_vertical_posts-3 .col-md-4:not(.first-col),\n#newscard_horizontal_vertical_posts-8",".advRow-fullW",".widget_block:not(#block-43)",".sticky-sidebar .widget_block","section.widget_media_image",".adwrp",".ad-div","#tdi_109,\n#tdi_113,\n#tdi_117,\n#tdi_126,\n.tdi_53_rand_style",".details-page-side-banner",".details-page-side-banner-2,\n.new-international-right",".-indx,\n.Video-indx",".jeg_midbar","#sidebar .widget.Image:not(#Image8)","#sidebar-primary-sidebar > .widget:not(#better-social-counter-2),\n#sidebar-secondary-sidebar > .widget","section.widget img","aside.text-center",".add figure",".map",".vc_raw_html img",".elementor-widget-wp-widget-news247_ads_banner_widget",".adalytics_ad",".bigyapan-gif-gallery",".features-spaces,\n.features-spaces-collages,\n.header-bigyapan",".para-3-ad",".momizat-ads",".sidebar .mom-e3lanat","#sidebar .widget.Image",".special_featur","#text-230",".middle-add","div[id^=\"AS_O_LHS_\"] > div:nth-child(-1n+8),\ndiv[id^=\"AS_O_LHS_\"] > div:nth-child(1n+16)",".ads-space",".widget_media_image:not(#media_image-40)",".sidebar-widget:has(> .widget-body > p:only-child),\n.widget-body > p img","#center-container .HTML","#tdi_57",".sidebar .widget_text",".sidebar > .widget_metaslider_widget",".topAdvertisementWrapper",".plyr",".wpb_raw_code","#wb_element_instance35,\n#wb_element_instance48",".ad-box",".ads728x90-thumb","#text-15",".widget_text.widget_area",".vc_raw_html a[target=\"_blank\"]","[data-adid] img",".right_sidebar_ads,\n.single_ads_top",".bsac",".single_details .code-block","#sitebox-ad125-3",".DADD","div[class*=\"DContentAdd\"]",".well","#sp-right .bannergroup",".hpRightAdvt,\n.navbar-static-top a[target=\"new\"]",".advertise a",".down_social_display_ad,\n.uc-sdr-ads,\n.vertical_add",".wp-image-6674,\n.wp-image-7688","#small-news","div[class^=\"ad_\"]","#bottomadothers",".textwidget:has(> p > ins.adsbygoogle),\nfigure.wp-block-image > img",".widget_area > img",".full_ad_widget",".td_block_image_box",".abv-container:not(.p-right-0)",".td-fix-index img",".smartmag-widget-codes",".add img:not([src*=\"Dainik-Dishari-\"]),\n.widget_area:not(.widget_text)",".digital-newspaper-advertisement-block",".widget_block img",".prl-grid .widget_black_studio_tinymce",".add-high",".single_page .add","a[href*=\"click.htm?\"][target=\"_blank\"]","#HTML12",".toped,\na[href*=\"chemmanurinternational.com\"]",".d-sm-block.my-3",".widget-header,\nfooter > center img",".adBgGray",".DetailsContent .textwidget",".ub-anchor-adcontainer,\ndiv[class^=\"DAdd3\"],\ndiv[id^=\"div-gpt-ad-\"]",".top_ads2","div[class^=\"add_\"]",".sidebar .s-widget img[src*=\"_n-\"]",".live .embed-responsive","#content-p > .row,\na[href*=\"karatoacourierservice.com\"]",".ad-container",".headerHt","#news_portal_ads_banner-3",".single_page_two_advertisement",".col-md-3.py-2 a img,\n.py-1 > a img","#myVideo,\n.col-md-4 .row.center-block,\n.col-md-4 .row.margin-bottom-30",".e-widget-swiper",".ads160_600-widget","[class*=\"ads300_\"]",".ads_click_counter",".wp-image-783",".ad_section,\n.mt-3 .wp-block-image","#metaslider_16689,\n#metaslider_21872","#backgroundad","#sidebaradvertise","#stickyadd",".wpb_wrapper > p:has(> ins.adsbygoogle),\nimg[class^=\"sb-ads\"]",".add img:not(.wp-image-1158)","img[alt=\"ad728\"]",".header-top-right",".add-longhead,\n.right-add-container",".add .widget_area ~ .widget_area",".penci-google-adsense-2","#secondary .widget_media_image:not(#media_image-17)",".td-main-content-wrap .tdm_block_inline_image",".middle-primary .news_portal_ads_banner","figure.vc_figure","img[alt=\"ads Image\"]","#media_image-5",".advertaisement,\n.head-banner",".Advt,\n.bottom_snackbar_common,\n.container-body > div:not(#topHead) .to-be-async-loaded-ad,\n.image-and-caption-wrapper,\n.popup-ad-content-wrap",".logo-banner,\ndiv[class*=\"advert\"]",".wpcp-carousel-wrapper",".add-img","div:has(> .w3-small)","section.widget_block","#custom_html-24",".widget_area > .textwidget",".widget.widget_block:not(#block-4):not(#block-95)","#media_image-23","#secondary .widget_block","div[id^=\"daini\"]",".gallery_section",".add:not(.wp-image-3687)",".wp-block-image","div[name=\"Articleshow-Organic-LHS-1\"]",".td-a-rec:not([class*=\"tdi_127_\"]),\n.td-ss-main-sidebar .widget_media_gallery","section img.attachment-full","#sidebar-primary-sidebar .widget_text","#block-10",".vc_raw_html",".td-a-rec:not(.tdi_274)",".ixnf","adnblock",".entry-content div[class*=\"daini-\"]",".widget_text:has(> div > div[id^=\"daini\"])",".widget_media_image:not(#media_image-5)",".penci-banner-box",".add-imgae",".siteber-add-section",".wpb_wrapper > .td-fix-index",".entry img.alignnone",".entry-content img",".advt_bx",".add:not(:has(> .widget_area > h3))",".d-lg-inline-flex","#metaslider_288,\n#metaslider_295,\n#metaslider_4598,\n.ad2","#adsense-468","#text-22",".popupad",".textwidget > p:has(ins.adsbygoogle)",".add-sec","#id",".adbnr","#leader-wrap",".cm-content .widget_media_image",".sidebar-widget .widget-body > p > img",".site-content .imagewidget","#tie-block_2253,\n.g-dyn",".list-advertisement",".elementor-widget-shortcode","div[id^=\"damru-\"]",".tr-ad","#cm-secondary .widget_custom_html",".flashwp-featured-posts-area,\n.flashwp-side-widget.widget_text",".widget-shortcode:not(#custom_html-12),\naside#sidebar-primary-sidebar > .widget_custom_html",".widget_area img:not(.wp-image-1166)",".gam-ad-position-wrap",".fullwidthbanner-container,\n.mujib_logo,\nimg[alt=\"Advertisement\"]",".ddnew-after-content","#divTopNewsHead + .row > .inner_news_head,\n#dvPopup",".elementor-image-carousel-wrapper",".elementor-shortcode img",".wonderpluginslider","#media_video-6,\ndiv[class*=\"colombia\"]:not(#LP_O_LHS_1)","#media_video-16,\n#media_video-17,\n#media_video-18,\n.widget_media_image:not(#media_image-3):not(#media_image-26)",".ad-03,\n.adone > div,\n.db-scnAd2","div[class*=\"-banner\"]",".tdi_79,\n.tdi_81,\ndiv[class^=\"desha-\"]",".wpb_video_widget","div[class*=\"m_ad-slot\"]","div[data-test-id=\"ad\"]","a[href*=\"daraz.com.bd/sepnil/\"]",".advertisement-section",".add-wrap",".code-block:not(.code-block-6),\n.tdi_348",".main-full .elementor-widget-image","#ads",".home-page-ads a:not([href*=\"deshprotikhon.com\"]),\n.main-content a[target=\"_blank\"] img,\n.main-header-ad",".header_top_ad_code,\n.jw_article_body div[style=\"text-align:center\"] div[style*=\"width:300px;\"]","img.alignnone.size-full",".horizontal_ad_wrap",".banner_section","figure img.tie-appear",".td-a-rec-id-content_inline",".popmake-content",".widget_black_studio_tinymce,\n.widget_wysiwyg_widgets_widget",".single-content p ~ figure.wp-block-image,\n.str3",".adspace img",".dhadi-content_2","#awaken_video_widget-4,\n.banner21",".ads-container",".container-section.py-3,\ndiv[class*=\"h-[250px]\"]","#media_image-9",".mid-add",".squareadd img,\na.hide-for-print","#left_level_2","#level_5_after_ad_space,\n.ad_before_level_3,\n.c-ad-container",".AD_NEWS_CONTENT_INNER_P1,\n.popover-ad",".e3lan300_250-widget",".td-g-rec",".logo__ads","#secondary .widget_text:not(#text-32)",".news_scrol-bean",".avenews-widget-image,\n.awac-wrapper,\n.masthead-middle-header .site-header-right","div[class*=\"-codes\"]",".td-is-sticky .tdm_block",".td-main-content-wrap .td_spot_img_all",".tdm_block_inline_image","#metaslider_widget-3","#metaslider_widget-5,\n#sidebar .widget_metaslider_widget,\n.slider_2,\n.slider_3",".add figure img","#main-ads-post","#newmodal .modal-dialog",".add-item",".header-promo",".advertise_part",".ad-part",".elementor-widget-wp-widget-custom_html",".MuiBox-root:has(> div > .adunitContainer)",".gal-img2,\n.topadtxt160","div[id^=\"adv\"]",".content-av,\n.widget-container-439 > div:not(#section_content_check_14080)","aside.ads-info-block","div[style^=\"height: 350px;\"]",".widget_area .attachment-full",".add-widget","#full_level_1_detail,\n#left_level_after_paragraph,\n.to-be-async-loaded-ad#after_related_post,\ndiv[class*=\"-ad-\"]",".advertisments",".widget_media_image:not(#media_image-38)",".adsbx728x90,\n.topnewsbx > div[style]",".page-content-single div[style*=\"clear:both;float:left;\"],\n.widget_media_image:not(#media_image-28):not(#media_image-49)",".widget_palika_advertisement","#content .widget_text","#text-8","#widget-sidebar-0 ~ div:not(#widget-sidebar-14)","#secondary-right,\ndiv[id^=\"doaba-\"]",".widget.Image:not(#Image1)",".sg-ad",".floating_ad_single",".addb",".skada,\n.skadd",".skads",".adv_box_3x25,\n.dool-ad,\n.dool_ad,\n.doolgad,\n.horiz_adv_area",".category_ad_space,\n.duble_advertisement,\niframe[src*=\"webdevelopmentjapan.com\"]",".td-banner-wrap-full",".dpAdSection",".drishti-grid-ads",".single3-page-add,\n.siteber-add2",".cmscontent-top",".advertise-area",".content-middle-ads",".entry-content a img,\nsection.widget_text",".td_block_video_embed",".DAdd3","#custom_html-10","#text-31",".widget_area",".widget-sidebar img,\nimg[alt=\"add image\"]","div[id^=\"eadar-\"]",".stream-item-mag",".long-ads","#sgpb-popup-dialog-main-div-wrapper",".ad1",".atf-wrapper","#addheaderbanner","a[href*=\"aruchuna.com\"],\na[href*=\"eelamhomeland.com\"],\na[href*=\"eelamview.com\"],\na[href*=\"eelamwallpapers.com\"],\na[href*=\"eelapparavaikal.com\"],\na[href*=\"eelavarkural.blogspot.com\"],\na[href*=\"eelaveechu.net\"],\na[href*=\"eelavenkai.blogspot.com\"],\na[href*=\"pulikalinkural.com\"],\na[href*=\"puliveeram.wordpress.com\"],\na[href*=\"tamileelamsongs.blogspot.com\"],\na[href*=\"thesakkatru.com\"],\na[href*=\"veeramaravarkal.com\"],\na[href*=\"veeravengaikal.com\"],\na[href*=\"verkal.com\"],\na[href*=\"yaalvaakai.com\"]","#AutoNumber1",".td-fix-index > h4,\n.td-ss-main-content .code-block",".td-main-sidebar .widget_custom_html",".td-post-content figure.wp-block-image",".elementor-widget-jet-listing-grid,\n.jet-popup",".ad-wrapper-250",".ad-wrapper-275,\n.ad-wrapper-photo,\n.align-home-ads,\n.amz-with-ads,\n.fbnad,\n.midArtContainer",".ad1_native",".adCANContainer,\n.wdt_amz",".hp-rhs-ads-container","div[class$=\"_ads\"]",".dgw","#welcome",".bn-content",".ad-img",".adalyticsblock",".banner-top,\n.wrapper-box","#roadblock-ad",".ads-rightside,\n[class*=\"center-ads\"]",".entry-content figure.wp-block-image",".banners-125","#block-21",".av_pop_modals_3","#text-12",".add-image",".bay-ad",".in-pan-ad,\n.mid-had,\n.side-bar-big-ads,\n.span-2 a:only-child,\n.top-bar-left-nav",".home_right_widget .textwidget > p",".banner-section",".details-big-banner,\n.top-header","#after-ad","#eloka-google",".gam-each-ad","#pravas-channel",".full-width-bigyapan-wrapper","#kode-iklan-bawah,\n.widget img[src^=\"data:\"]","#v-enavabharat-0",".ifrmbx","img[alt=\"Side banner\"]",".ad_squar,\n.extra_ad",".stream-item-below-post-content",".second_section_right,\n.third_section_ads",".logo-right-wrapper","#messagem",".widget_sow-image:not(#sow-image-27)","#st_hp_leaderboard_1","div[class*=\"customWidgetWrapper\"]:not(:has(> div > div > h2))",".ad-sec img,\n.daraz-ad",".w-60,\n.w-70","#custom_html-27",".single-entry > div[style^=\"float\"]","div[class^=\"topad\"]","#divSliderMain,\n.widget_media_image:not(#media_image-121):not(#media_image-113)",".bstyle-list ~ .post,\n.wpb_single_image figure","section.widget img:only-child","#HTML94","img[alt=\"ad image\"]",".main-ads-pikihome","#custom_html-8","#custom_html-9",".block-custom-content:not(#tie-block_1405)","#roadblockModal,\n.logo__right,\n.promo-detail,\n.promo__col,\n.promotional__col",".ws_gestures",".mainadvert,\n.mainadvert2,\n.mainadvert3,\n.mainadvert6,\n.mainadvert7,\n.mainadvert8","#text-16",".widget_custom_html:not(#custom_html-2)",".singlepage-section .col-md-8 .add img","img.img-fluid[src*=\"/backend/logo/\"]",".header_date_sidebar",".header_top_banner",".add_area > .textwidget","#top_level_full_1,\n.inside-post-ad-1",".kenm,\n.widget_kenm",".removeStyleAd,\ndiv[id^=\"taboola-\"]",".filmi-kan-ad,\n.filmi-kan-header-ad-wrapper,\n.filmi-kan-latest","div[class*=\"kan-ad\"]","#modalBody,\n.mb-hidden img.center","#itro_popup",".widget_fgwt",".jft_ads",".topheaderpic,\ndiv[style*=\"margin-top: 16px; height: 80px;\"],\ndiv[style*=\"margin-top: 6px; height: 145px; \"]","div[id^=\"BANNER\"]",".header-middle-area,\n.post-widget-carouselr,\n.theiaStickySidebar iframe,\naside.tb-posts-slide-widget",".buget-banner,\n.for-add",".masonry-slide-ad1",".InsidePost",".text-html ~ .stream-item-widget",".ad728_cont_mid",".post figure[id]",".ar_ads","#header .sidebar-col","#content .abv-container",".sidebar .stream-item-widget",".widget.text-html",".widget_right .textwidget","#text-10",".widget_media_video:not(#media_video-4)",".add_720_90_px,\n.story-detail-mid-add",".no-bg-box-model",".inside_ads",".adds_taja img,\n.ads aside:not(#custom_html-7)","div[class*=\"-shortcode-\"],\ndiv[id^=\"ganda-\"]",".header-widget",".wp-image-25993","#sp-ads,\n.sppb-addon-content .custom",".bdaia-box7",".site-adv1","#wonderpluginslider-container-3,\n.beforeheader_728",".myIFrame",".wp-image-27299","#media_image-21","#media_image-26","#media_image-27","#media_image-28",".mb-3:has(> div > ins.adsbygoogle)","#npkit-recent-posts-5,\n.entry-content .wp-block-image",".wp-block-group","#video-widget-2,\naside.sidebar-narrow",".single-post-content img.alignnone",".stream-item-above-post","#HTML24","#Image14","#content .widget_block","#content section.widget_text[id^=\"text-1\"]","a[href*=\"bit.ly\"]","aside.widget_media_image img:only-child",".innerAdColum","div[id^=\"ad_\"]","#content .stream-item","div[class*=\"_ads\"]","#khb-button-ades,\n#square-close .front,\n.uk-container section.widget",".khandakarit_widget:has(> div > p > ins.adsbygoogle)",".stream-item-above-header",".theiaStickySidebar .widget_text:not(#text-22)","#custom_html-14",".vl-site-content .widget_custom_html","div[class=\"country-add\"]",".countdown_wrapper","#widget-sidebar-0","#recent-post-slider-1","#media_image-51",".site-header-ads",".top-news-sidebar-ads",".adv-box-wrap,\n.box_wrap.p-2,\n.content-box-ad,\n.sm-main-adv-box",".below-samachar-add,\n.news-inline-add","#HTML6","#top1,\n.rimage,\ndiv.HTML:has(> div ins.adsbygoogle)",".add-slider,\n.adds-lg,\n.adds-sm",".side-indent .wgs-ads:first-child",".banner-right,\n.custom1,\n.ga-1,\n.videowrapper.mtop20,\nimg[alt=\"banner\"]",".logo_banner","div[class^=\"grami-\"]",".e3lan-bottom",".widget_media_image:not(#media_image-2):not(#media_image-4)",".dtl_section figure.image,\n.scrollable-slider,\n.sideAds_bg","#HTML29","#HTML30",".ads_css_title","#v-grehlakshmi-0","aside.widget_sp_image","#fsb_image,\n.add_block_hdefault,\n.custom-html-widget iframe,\n[id^=\"itro_\"]",".add-300x250,\n.rhsTopBannerParentAd",".a-single","#widget4",".do-space,\n.sep",".text-html-box.h250","#gulte-text-html-widget-2","[class$=\"_ads\"]",".thumbnail_container",".tdi_107.td_block_slide,\n.tdi_118","div[class*=\"iklan-\"],\ndiv[id^=\"center-ads\"]",".e3lan-below_header",".aalb-product-carousel-unit",".col-lg-3 .home__news_box,\n.footer__top__up__image,\n.web__banner",".haldw-widget,\ndiv[id^=\"haldw-\"]",".details-ad",".elementor-widget-image-carousel.e-widget-swiper",".wp-image-29079,\n.wp-image-29080",".to-be-async-loaded-ad",".td-post-content .td-a-rec","a[href*=\"/ads/\"]",".long__ads",".banner-click-action,\n.display,\n.top-income-source-wrapper",".min-global-adv","[class^=\"sgpb-\"]",".container-ad",".banner_wrapper",".in-news-advertisement",".hbm-320-50-ad",".featured-ad-bg",".cnt_cnt_ads,\n.neptop-ads-place,\n.nt_ads_space img","#secondary .widget_custom_html","a[rel*=\"sponsored\"]",".m-116,\n.m-200","#covernews_posts_carousel-7","#sidebar-primary-sidebar,\n#sidebar-secondary-sidebar,\n.single-post-content > p img:only-child","#ads300_600-widget-3,\n#eaa-12,\niframe[id^=\"ifr_\"]","#adAboveHeader","#widget-footer-1,\ndiv[id^=\"th-sb-ad-block-\"]:not(#th-sb-ad-block-1-2464)",".article_text-content figure","div[id^=\"hello-\"]",".article-desktop-ad-container","aside.widget_media_video","div[id^=\"AS_O_\"] > div:nth-child(-1n+10)",".list_ads",".article-container,\n[class*=\"boxzilla\"]",".rd-ads",".rd-between-ads,\n.rd-bottom-popup",".Ad",".content-banner,\n.feature-ad,\n.feature-bottom-ad","#myCarousel","#sppb-addon-1492748325089,\n.sppb-addon-container.main-content",".adsen,\n.c_ad","div[id^=\"himac-\"]",".wonderpluginslider-container","#tdi_156,\n.tdi_143",".et_pb_image,\n.otw-sidebar .widget_text,\n.post-wrap:has(> .otw-sidebar .widget_text),\n.widget_text a[target=\"_new\"] img,\ndiv[id^=\"himal-\"]","#widget_sp_image-12,\n.simple-image","#simple-image-popup","div[data-adid] img","#text-35,\n#text-39","#text-40",".bigyaapan-box",".bigyaapan-item",".elementor-widget-image:not(.elementor-element-79c39f1)","#primary .widget_media_image","#sidebar-primary-sidebar .widget_media_image","#custom_html-51",".lhk-ads-container","#content .widget_block:not(#block-62)",".post-text img","a[href*=\"astrosage.com\"],\na[href*=\"ojassoft\"]",".sticky-sidebar .widget_custom_html","#right-sidebar .widget_block",".obi_random_banners_posts",".penci-text-block",".theiaStickySidebar > .widget_text","a[href*=\"fkrt.it\"]","section[id^=\"ai_widget-\"]",".rd-widget-ads",".theiaStickySidebar .widget_block","#text-7 iframe","img[src*=\"c-force/booking/\"],\ntd[height=\"350\"]:has(> marquee)",".advInBtweenNewsCard,\n.advMasterSlot","#popup_box,\n#wowslider-container105,\n#wowslider-container113,\n.main_header .ws_images,\ndiv[class^=\"avtg\"]","#media_image-17",".logobanner","#wdslider-57",".ed-first,\n.right_level_2,\nsection[class*=\"-ad-\"],\nsection[class*=\"ad_after_\"]","div[id^=\"inside_post_content_ad_\"]","#block-23","#block-24","#stream-item-widget-5","a[target=\"_blank\"] img:not([src*=\"Screenshot_2022-11-22_at_10_43_32_PM.png\"])",".side_bar .py-1 img","p[class=\"fontBold\"]",".advertisement img",".et_pb_image:not(.et_pb_image_0_tb_header),\n.et_pb_post_content img,\n.et_pb_slider","div[id^=\"AS_P_\"]",".proad",".alignnone.size-medium","iframe[src*=\"igoogleportal.com\"]",".entry-content > div,\n.home .site-wrap > div:not(.elementor)","#content .master-slider-parent",".bg-color-gray-fot,\na[target=\"_new\"]",".newsbox_text,\n.page_left div > iframe",".ads-between-story,\n.bccl-ad-wrapper","#sidebar .widget:has(.banner)","a[href*=\"reecha.lk\"] img","#main-content .e3lan","a[target=\"_blank\"] img[alt=\"images\"]",".marquee-ads",".iftam-content",".widget_block:has(> p > ins.adsbygoogle)","header + div .elementor-shortcode img","#banner",".abv-container img",".td-a-rec-id-content_bottom","#HTML27",".bsac-container","#parentDiv0",".picgaladdcntr","#HTML14,\nimg[alt^=\"Menu\"]",".td-a-rec-img",".ads-div-style","#featured-multi-wrap",".sidebar .widget_block","#sticky-wrapper .widget_metaslider_widget","#media_image-14","#text-28",".widget_fcko:not(#fcko-25),\nfigure[id^=\"attachment\"]",".news-card:has(.ad1),\n[class*=\"taboola\"],\na[onclick*=\"eskcl/click.htm\"]:not([onclick*=\"&u=https%3A%2F%2Feisamay.indiatimes.com\"]),\ndiv:has(> [data-row-id=\"recommended-deals-widget\"])",".pwa-deals,\ndiv:has(> div[data-native-ad])","._taboola,\n.fakelisting",".wdt-taboola","#sidebar .widget:not(#widget-sidebar-7)","#custom_html-36",".ml-slider:not(#metaslider-id-53525)","#aniview",".adsBox",".ad_section_1",".advertSection,\n.rgtSideAdert_main",".innew-before-content,\n.innew-widget",".inner-news-ads",".widget_esn_ad",".td_block_video_playlist,\na.td_spot_img_all",".mag-adver-part","#text-577","#ads160_600-widget-2","#widget_626,\n#wrapper_526","section.widget img:not(.wp-image-85373)","div[id^=\"jagat-\"]",".widget_728x90_advertisement,\naside.widget_text:not(#text-25):not(#text-27)",".large_add_banner",".amws-custom-widget-show-ad",".ad-aria,\n.dt-highlighted-news-2 aside.widget_text","#fscorecard,\n.adv-img,\ndiv[style*=\"height:104px;\"]","#post-7708",".webAds",".AdCont,\n.BannerAds,\n.NativeAd",".Ads",".WhistleFeedAds,\n.slider img:not([src*=\"1595764637\"]),\nimg[alt*=\" Ad Image\"],\nimg[alt*=\"banner\"],\nimg[alt*=\"business ad\"]",".container-bn",".widget_supermag_ad","#custom_html-34",".futureads,\n.popup_img,\n.text-center.mt-3","#HTML101,\n#HTML123",".widget_custom_html:not(#custom_html-9)",".advertise_space2,\n.popbox,\n.top-bar",".photo-gellary iframe,\n.single_page .widget_area","#wr,\n.bigyapaan,\n.bigyapaan__section img:not([src*=\"election_result.jpg\"]),\n.inline__bigyapaan",".block-29",".advert_sec1_left,\n.advert_sec2",".elementor-shortcode",".advertisement_bar","#panel-31350-5-1-1",".CMAC_AdChangerWidget",".bigyaapan",".bigyapan-box",".mom_box_sc","#tie-block_1354",".td-main-content-wrap .td_block_single_image",".mukhya-samachar > .full-bigyapan",".adsimage img:not(.wp-image-63475)",".vmagazine_medium_ad",".sidebar-inside .widget_custom_html,\na[target=\"_blank\"]:not(.btn) > img",".e-con:has(> .e-con-inner > .elementor-widget-heading),\n.e-con:has(> .e-con-inner > .elementor-widget-html)",".header-nav-main.nav-right","div[id^=\"janga-\"]",".ws-block-body a img:not([src*=\"dj.JPG\"])",".inside-post-ad-before",".block-60,\n.block-74,\n.block-85","a[href*=\"click-add/\"]",".penci-content-main .wpb_content_element",".euro_add",".bg-gray:has(> .swiper),\n.h-full img,\ndiv[class*=\"f0f0f0\"]","#top_level_3,\ndiv:has(> ins)","#main .container",".desk-ad-bg-container,\n.ie-network-taboola","#media_gallery-3","#topads",".left_level_3","#metaslider_widget-2",".stream-item-below-post",".post-content .tr-caption-container","#tie-block_576,\n.wonderplugincarousel",".leaderboard-wrapper",".homeboxouter",".widget_text .td-all-devices",".jhark-content","[alt=\"joy e-bike latehar\"]",".rd-ads img:not(.wp-image-2735)",".code-block figure:has(> figcaption)","a[href*=\"affiliraiser.com\"]",".code-block-8","#secondary .widget_media_video",".inimistacad-home",".jogin-widget",".elementor-widget-html","div[id^=\"johar-\"]",".jonop-content",".ksrm_ads_bnr,\n.td-a-rec:not(.tdi_138)",".wp-image-1366",".adds-block","section[data-id=\"147a440\"]","#popAd,\na[href*=\"eximbankbd.com\"]:only-child,\na[href*=\"jamunagroup.com.bd\"]:only-child",".addtop_inner",".blurb img","#block-108",".kages-widget","#attachment_43256,\n#attachment_44092,\n.banner-ad-wrap",".code-block-3","hr:first-child ~ div","div[id^=\"slideshow\"]",".header .slide_img,\n.text_post_section + .row img","#author-bio-widget-1","div[id^=\"car-SL_\"]","#right-sidebar .widget_custom_html,\n#right-sidebar .widget_text img:not([src*=\"/Apps-\"]),\n.advertisement img:not([src*=\"Abu-Nasor-sir\"])",".advertisement-single-float",".desktopView:has(> [ad-position])",".widget_namo_advertisement",".wpb_content_element.vc_align_center",".aside-collection-ad-slot,\ndiv[class*=\"m__ad-\"]","a[href*=\"successacademy.org.in\"] img",".e3lan300_600-widget",".bannerListWidget",".custom-banners-cycle-slideshow",".wp-image-1118","#header-right",".tagdiv-type .td-fix-index img",".enhanced-text-widget",".HTML .widget-content img","div[class*=\"kanak-\"]",".masthead-header-banner",".kd_adv1",".td-ss-main-sidebar .td_block_image_box",".elementor-widget-spacer",".widget-container-188",".embed-responsive-4by3",".ktmjq","#text-2 p ~ p,\n#text-3 p ~ p",".uk-section-xsmall img",".single-sidebar iframe",".above-sidebar-wrapper","#ivrss_holder1","#panel-38-2-1-1,\n#pg-38-7",".vmagazine_lite_medium_ad",".addDivR1",".theiaStickySidebar .widget_custom_html:not(#custom_html-4)",".kd-ad-horizontal,\nsection.widget img:not(.wp-image-53237)",".theiaStickySidebar .text-html-box",".penci-html-ads",".ads-height-130,\nimg[title=\"wellfitindia\"]",".top-ad-d","[alt=\"add image\"]","div[id^=\"kastu-\"]","#myModal","div[class*=\"bigyaapan\"]","#wrapper a[target*=\"blank\"] img,\n.foot_ad",".sp-ad-row,\n.spnsrd-ad",".no-bod .ad-title + a img","#slideshow",".greytext","#stream-item-widget-2",".block-15",".theiaStickySidebar .widget_metaslider_widget",".inner-square",".brdbt.stock",".a-300-250,\n.cs-sec-feat-title",".st-banner","a.disabled",".bg-light.py-5",".stream-item img:not([src*=\"KARUKAPPILLIL-FOUNDATION_20240914_024439_0000.jpg\"])","#header-widgets,\n#secondary .widget_text img","#foot-ad-wrap","div[id^=\"AS_O_LHS_\"] > div:nth-child(1n+21)","a[href*=\"ksfe.com\"]","#widget_sp_image-14","#widget_sp_image-10,\n#widget_sp_image-11",".fb-dialog,\n.theiaStickySidebar .widget_media_image:not(#block-2):not(#media_image-17)",".single_sidebar:has(> ul > div)","div[class*=\"jeg_ad\"]","#block-127",".widget_block:has(> ins.adsbygoogle)",".widget_media_image:not(#block-245)",".sb-widget-ad",".sidebar-inner .widget_custom_html,\n.uris-slider-post-title",".ad-row-container,\n.detail-right-ad img:not([src*=\"unicode_converter.jpg\"])",".text-html-box figure","div[id^=\"khaba-\"] img:not([src*=\"Join-WhatsApp-Group\"])",".add:has(> div[id$=\"advertisement\"])",".hm-header-image,\n.widget_text:not(#text-15)","#widget-sidebar-2","#custom_html-28",".wonderplugincarousel-container","table[style^=\"width: 100%; background-color: rgb(255, 238, 0);\"]",".td-a-rec-id-content_top","#header .widget_block",".banner-widget,\n.khabarhub-inner-ads,\n.title-top section","#media_video-1",".single-728,\n.single-box",".img-ads,\n.site-footer__bottom,\n.view-ads",".td-spot-id-sidebar","#content .widget_media_image",".insd-advert","div[id^=\"khaba-\"]","div[class^=\"add-\"]","#block-16",".InArtilce-AdSlot01",".khaba-widget","#widget-sidebar-4","div[class*=\"vigyapan\"]",".addbelow",".widget_media_image:not(#media_image-8)","#media_gallery-2","#adgshp985719811,\nheader a[href*=\"/click-\"]",".vc_row:has(> .vc_column > .wpb_wrapper > .td-a-rec:only-child)",".tdi_62",".add_logo",".HTML:has(.slideshow-container),\n.HTML:has([alt=\"Image\"])",".n2-ss-slider",".colombiaonesuccess iframe,\ndiv[name=\"ArticleShow-Organic-LHS-1\"] div:has(> div > div > span + a),\nimg[alt=\"sonu\"]","#secondary .widget_custom_html:not(#custom_html-14):not(#custom_html-15),\n.elementor-spacer,\n.elementor-widget-heading","#sidebar-right .widget_custom_html","#sidebar-right .widget_media_image",".banner_add_class_main,\n.banner_add_class_right",".view-ads-view","div.mrgR5[style*=\"height:250px;\"]",".post-entry .code-block,\nsection .textwidget img:not(.wp-image-131626)","div[style^=\"height:100px\"]",".add-bg-02",".wpb_raw_code img",".box_outer.widget_text,\n.mom_ads300",".vide_area,\naside.right_content div.single_sidebar:has(> a[target=\"_blank\"])",".widget_section .add","#sidebar .ws-block-body > a img","div[style=\"overflow:hidden;min-height:250px\"]",".img-ad","a[href*=\"angelbroking.com\"]",".ad-after-breaking","div:has(> p > ins.adsbygoogle)",".textwidget p img",".widget_media_image:not(#media_image-2):not(#media_image-6)","img[alt=\"ad\"]","#block-27",".pixelMainDiv",".hr_ad_block","div[data-first-video=\"ul8Qyg4Ylko\"]",".topside-ad",".add .widget_area:has(> img)",".add p img,\n.singlepage-section .widget_area",".container-fluid.pt-3","[data-adid] > p",".koyil-widget,\ndiv[id^=\"koyil-\"]",".widget_block:not(#block-3)",".krant-after-content,\n.krant-below-title,\nsection.widget_custom_html:not(#custom_html-2)",".elementor-shortcode:has(> a, [id^=\"krant\"])",".add-top","#slider-pro-3-31077",".herald-da",".sidebar-widget .widget_media_image",".single-post aside.widget_media_image","#simpleimage-13,\n.sideadd",".topadd","#simpleimage-14,\n#simpleimage-26,\n#simpleimage-27,\n#simpleimage-29,\n#simpleimage-31,\n#simpleimage-5,\n.add1","#secondary .widget_media_image:not(#block-3),\n.entry-content p > a > img:not([src*=\"whatsapp-group.jpg\"])","#Image7","#belowflash,\n#belowmainnews,\n#pgc-7-1-1,\n.widget-header > img",".kushi-after-content",".above-banner",".amazingcarousel-list-container","a[href*=\"kasargodvartha.com\"],\na[href*=\"pace.edu.in\"]",".advbox,\n.sp_simple_youtube",".widget-banner",".wp-block-gallery",".bichar",".header_img","#block-11","div[id^=\"lalluram\"]","figure > iframe","img[src*=\"Modhomoti-\"]",".card.text-center,\n.fluid-news,\n.left .aside-wrapper","#main-content + aside > .widget_media_image",".lsb-blurb-sections",".code-block-6",".sticky > div:nth-child(2),\ndiv:not(.sticky) > div > .splide[aria-label=\"My Favorite Data\"]","#cookieModal,\n#header-banner .text-right","#sidebar .e3lan,\n.inner-wrapper .e3lan-below_header","#content > .widget_text",".banner-news-section",".lekali_online_adv",".widget_media_image img:not([src*=\"nocs.png\"])",".gsc-image",".add a[target=\"_blank\"],\n.ads_bottom_disp","#AD_FLOAT",".text-html-box","#logoBand-image,\n.StoryPage_tabooWrp__NKSGA,\n.ntwrk-wdgt,\n.prlads,\ndiv[class^=\"Ads_\"]",".taboola","#headermain .sp7","#news_portal_ads_banner-5",".cntarea img","#sidebar-right .widget_block figure",".author-widget",".e3lan-post",".center-aligned-ad,\n.paraAd img:not([src*=\"viber_image_\"])","div[id^=\"ai_widget\"]",".textwidget strong img","#sidebar .ws-block-body > a > img",".bottom_ad_slide,\n.slider_ad_top","#beforehead,\n#headerBanner,\n.inarticleAd",".homepage-taboola,\ndiv[id^=\"inlist\"],\ndiv[id^=\"photoInlist\"],\ndiv[id^=\"rhs-\"]",".ads_699",".td_block_empty_space","#herald-module-1-10,\n#herald-module-1-15,\n#herald-module-1-19,\n.herald-no-sid,\n.herald-txt-module img.size-full,\n.wp-image-225930,\n.wp-image-242302,\n.wp-image-246528,\n.wp-image-84961",".wpb_single_image img:not([src*=\"mukhaya-mantri-add.gif\"])",".entry-content > div[style^=\"float\"]","a[href*=\"deshihost.com\"]","div[class*=\"m__ad\"]",".bigyapan-section",".block-right-bottom-ads",".ads-style1","#block-59",".wow",".wp-image-27407","div[style*=\"height:260px\"]",".main-wrapper:not(.news-details-page) div:has(> div > [id^=\"div-gpt-ad-\"]),\n.outer-container .to-be-async-loaded-ad:not(#home_right_2)","div[id^=\"madat-\"]","#Image12,\n#Image18,\n#Image19","#Image13,\n#Image15,\n#Image17,\n#Image20","#Image21,\n#Image22","#Image23","#Image5","#media_image-50,\n#media_image-52,\n#media_image-53,\n#media_image-56,\n#media_image-60,\n#media_image-72,\n#media_image-82,\n#media_image-84,\n#media_video-5",".ads-iframe",".extra_bottom_sections,\n.hocal-ad-block,\n.story-ad1,\ndiv[class*=\"ad-box\"]",".left_level_2",".widget_media_image:not(#media_image-125)",".code-block:not(.code-block-4)",".stream-item-below-post-comments,\n.stream-item-in-post","aside.ai_widget",".sidebar-widget-wrapper > aside.widget_media_image",".Special-Embed-Code-2,\n.logo_image_container a[target=\"_blank\"]",".news-advertorial","#metaslider_widget-4",".widget_custom_html:not(#custom_html-4)","#adoverlay",".is-full-widescreen-ad",".section-ad-space",".single-post-content [data-adid],\ndiv[class*=\"makda-\"]","#ad",".inner-post-ads","div[id^=\"malab-\"] > img",".alertAdd,\n.malab-article-top-ads,\n.malab-home-page-sidebar-2",".entry-banner","iframe[src*=\"MalusKitchens\"]","#boxes",".container #sidebar img",".top-d","div[style*=\"height:1120px; \"]","entry-content a[href^=\"tel\"]",".code-block-2","#footer_section_1 img:not(#Image1_img)","#viral_advertisement-11,\n#viral_advertisement-7,\n#youtube_responsive-10",".post-entry div[style^=\"float\"]",".header-adds,\n.livedemo img",".sam-pro-ad",".wpb_content_element p[style*=\"SolaimanLipi\"]","#dfp_banner_header_panel + span,\n#recommendations,\n.siderbar-eds,\nspan[id] > iframe[id]:only-child",".advert",".inner-add,\n.post-inner-image",".comp-ad",".container .experiencefragment,\n.top-advt-block",".rhs-cont","#divFLRALeft,\n#divFLRARight",".td-main-content-wrap .td-a-rec:has(> div > div > h4.block-title)","div[id^=\"manva-\"]",".mh-header-widget-2",".theiaStickySidebar .elementor-inner-section",".advertise-border","#sidebar-right .widget_media_video","#vdo_ai_div-0",".widget_viy",".branding_logo,\ndiv[class^=\"banner_sliders\"],\ndiv[id^=\"ML_DT\"]","div.text-center:has(> h5 + img)","#main_ad1",".article-content .ml-slider",".header .mom-e3lanat",".post > a img",".sm-ads","div[class*=\"td-spot-id-content_\"]",".fullwidth-header-ads-wrapper","#left_level_after_image,\n.ad-gap-sm","footer .widget_media_image",".bigposter","#block-39",".tdb_single_content .wp-block-image",".tdm_block img","#right-sidebar-inner,\n.hustle-layout","div[class*=\" ad-slot-\"]",".latest_postnav","#mep_0",".ads .widget_media_image:not(#media_image-53)","img[alt=\"mAD\"]",".dpad_custom",".piki-ads-res",".wpwbs_banners",".mohag-widget",".DHeaderAdd,\n.ads img","div:has(> div > span[name=\"adchoicehtml\"])",".in__between_ads",".headRightAdv,\n.side_right li ~ li","#text-124",".td-post-content a > img",".add-section img","#metaslider_1316","#wds_container1_0",".ugaam-ad-wrapper","#widget-sidebar-2 ~ .widget:not(#widget-sidebar-14)","#text-html-widget-3","#data_id_1",".wpb_images_carousel",".wpb_single_image .attachment-full,\n.wpb_single_image .wpb_heading",".d-block",".home-small-ad,\n.top-links-form","#adsentop",".bd-sidebar .widget_text","center:has(> img.w-100)",".banner-half",".add-bottom-margin,\n.homead-fullwidth,\n.top-header .add-bottom-margin","#panel-134-5-1-0",".dfad,\n.wpb_wrapper .vc_raw_html img",".hb-img",".rt-top-ad",".article-tag-content:has(> .oiad)",".oiad",".os-ad,\n.os-ad-c",".footer-addds",".font_widget_two,\n.section_lead #myCarousel,\na[href*=\"/ad-2/\"]","#sidebar-primary-sidebar .widget_custom_html",".starofmysore",".d-sm-flex,\n.d-sm-none.d-block:not([class^=\"co\"]),\n.d-sm-none.d-flex,\n.mb-5.justify-content-center,\n.my-5.justify-content-center,\ndiv[style*=\"min-height\"],\nins[id^=\"infostation-\"]",".sidebars-area",".bdaia-header-e3-desktop,\n.bdaia-widget-e3","div[class*=\"ads_detail\"],\ndiv[id^=\"adverts\"]",".ads img:not([src*=\"nagarikpati-tv\"])",".ad300_1,\n.naiWeb,\ndiv[class^=\"Cube_\"]",".wp-block-image img,\ndiv[class*=\"naini-\"]",".advertisement-wrap,\n.logo-right-ad,\n.news-content-inner-ad","#bdaia-widget-html-4,\n#bdaia-widget-html-5","#stream-item-widget-4",".three_ads","div[id^=\"namma-\"]","div[id^=\"nande-\"]",".add-section-home.right",".no-vigyapan-section",".no-vigyapan-single","div[id^=\"narma-\"]",".stream-item-inline-post",".ad_responsive",".topadrt",".banner_ads,\n.long_ads1",".wp-image-12870,\n.wp-image-245,\n.wp-image-251,\n.wp-image-252","#header-banner","#media_image-42","#sidebar .widget_block",".header_biggapon","#block-50",".ads-bar,\n.details-sidebar > .row.justify-content-center","#stream-item-widget-12",".code-block:not(.code-block-10)",".bs-injection,\ndiv[id^=\"vuqly-\"]",".td-a-rec:not(.td-a-rec-id-content_top),\n.td_separator_solid",".tbarad-content-wrapper","div[id^=\"navin-\"]","div[class*=\"m__dfp\"]","#secondary .widget_media_image:not(#block-64)","#text-4 marquee",".penci-sidebar-right",".mid-ad-heading",".td-banner-bg",".wpb_raw_code + .td_block_text_with_title",".naya-bikalpa-advertisement",".detail-ad-holder,\n.image.attachment-full","#slotbanner",".image_head","div[class*=\"top_full_width_level_\"]:has(> [class^=\"ad\"])","a[href*=\"gurkhasfinance.com.np\"],\ndiv[id^=\"nayap-\"],\nsection.widget img:not(.wp-image-243554)","#flashnews",".post-body .tr-caption-container,\n.sidebar .HTML:not(#HTML15):not(#HTML8),\n.sidebar .Image:not(#Image6)",".wp-image-2104,\n.wp-image-2806","aside[id^=\"ai_widget-\"]",".pt_magazine_widget_social marquee","div[class^=\"bigyapan\"]",".header-top-details-right,\n.widget_black-studio-tinymce",".single-wrapper-details-sidebar-ads",".horizental-ad-image",".logo-ads,\n.logo-ads-header,\n.logo-ads-singlepage",".adsgo,\n.midads",".nepalijanta-ad","#content .news_portal_ads_banner","#sfSideadd .sfModulecontent > div:not(#divLatestNews),\n.modal-dialog","a[href*=\"callrakesh.com\"]",".fixedbar",".bannergroup",".nk-sidebar-ads,\n.paraAd",".advertiseImage,\n.siteContent > p a img",".modal-content",".single-post-advertisement",".ads img:not(.wp-image-72119)","#Image39","#Image8",".adsimage img:not(.wp-image-143293)",".full-ad-img,\n.inner-page-ful-ad-btm,\n.rojgar-img-blk",".don",".td_block_single_image:not(.tdi_27)",".add-sect",".no-bod > a,\n.skip-ads",".full-bigyaapan",".tc-side-ads",".ad-sec",".comon-ads","div a[target=\"_blank\"] img",".content-heading video,\n.gam-each-nvad",".fullwidth__add,\n.gam-each-caad:not(#gam-ad-13):not(#gam-ad-15)","div.ptop--30:has(> .ad--space)","#floating-sidebar .custom",".tigDiv,\n.vc_figure",".vc_slide","main .advertisement img","td:has(> script)","#main-head .right",".widget_mts_widget_adcode",".align_cent","#content center img",".news1-before-content_6,\n.news1-before-content_9",".ays-pb-modals","#right div:has(> div.nw18-dfp-ad),\n#vigyapan,\n.ad_cntainer,\n.add_secton,\n.ads-slider,\n.ftrad,\n.global-storylist li[style^=\"height\"],\n.listview-story li:has(div[data-implementation]),\n.listview-story li:has(div[id^=\"mobileAd\"]),\n.my-ad-rhs,\n.pwa_add,\n.sideMiddle,\n.sideTop,\n.site-ad-container,\n.taboola_setting,\ndiv:has(> .myad),\ndiv[class*=\"Header_inner_ad\"],\ndiv[class^=\"HomeMobile_mobile_add\"],\ndiv[style*=\"300px\"][style*=\"background\"]",".TABOOLA,\n.add_container,\n.newadd",".n18thder","div.newstrendvideo-box > ul > li:nth-child(7)",".entry-content iframe",".container .container #page-sidebar",".wp-image-643,\n.wp-image-8371","a[href*=\"narendramodi.in\"]","#widget-footer-0,\ndiv[id*=\"-ad-\"]",".custom-carousel,\n.custtwo_swiper-container,\n.slide-container",".home_last_ad",".single-block .col-sm-12 img",".topHeaderAd,\n.w-100","a[href*=\"/newspaper-ads/\"] img,\na[target=\"_blank\"] img[src*=\".gif\"],\na[target=\"_blank\"]:only-child img",".section-wrapper .stream-item",".add-banner,\n.aside-add",".adds_menu img",".code-block:not(.code-block-1)",".wpb_singleimage_heading",".img-advertise,\n.oit-ad-code",".neder_advertisement_content_banner","#below-header",".bc_random_banner",".wpb_gallery",".wpb-image-popup,\ndiv.g",".sidebar .widget_media_image:has(> :not(div))",".elementor-widget-image .size-large",".smart-head-mid .h-text",".right-banner",".Add-Master-Sside1,\n.Matter-Bottom-Add,\n.Matter-Top-Add",".td-main-content-wrap .widget_text",".elementor-widget-image img:not([src*=\"logo-en.png\"])",".block__2,\n.book_ads",".twp-ad",".side-widget.newsh-widget,\ndiv[id^=\"newsh-\"]","#Feed1",".entry-content p img",".newsk-content,\n.nktv_adv,\ndiv[class*=\"_adv_\"]",".sidea .wp-block-image,\n.wid-1",".ob-cards",".adfoxly-wrapper,\n.td-main-sidebar .widget_media_image,\n.ugaam-ad-wrapper-outer,\na[href*=\"href.li\"]","div[id^=\"newsl-\"]",".wpb_single_image figure img:not([src*=\"NM-01\"])",".advanced_text","#secondary .widget_block:not(#block-17)",".container-fluid a[target=\"_blank\"] img","#custom_html-23",".widget_media_image:not(#block-33)",".advertising,\n.advtertise","div[id^=\"AS_O_\"] > div:has(> div > div > span[name=\"adchoicehtml\"])",".section .adalyticsblock,\nsection.widget img:not(.wp-image-85386):not(.wp-image-87331)",".mySlides",".ads300x250",".header-second-adv,\n.row.mb-30,\n.sidebar-banner,\n.single-sidebar .post-carousel-1",".top-most-banner",".wp-image-10388,\n.wp-image-10536,\n.wp-image-11042,\n.wp-image-19215,\n.wp-image-2083,\n.wp-image-22995,\n.wp-image-3711,\n.wp-image-77",".axil-banner,\n.axile-ads-wrapper","a.disabled img,\ndiv[id^=\"AS_O_RHS\"] > div:has(> div > div > div > p)",".section_before_trneding","div[class^=\"newst-\"]","#main .widget_custom_html,\n.click-zoom,\n[id^=\"newsu-\"]",".td-g-rec-id-custom_ad_1","div[id^=\"newsw-\"]","#main .widget_sow-image",".widget_media_image:has(:is(ins, a[target=\"_blank\"]))",".p-3.text-center",".intes_fixed,\n.intes_fixed + div","div[id^=\"AS_O_LHS_1\"] > div:nth-child(2n+1)","div[id^=\"showAS_O_BEL_\"]",".td-footer-wrapper .widget_media_image,\n.top_index_block_adnow","#webbank-ad-section,\n.sidebar-right.card4",".foogallery_widget",".smashwords-widget","#sidebar2",".nnews-content",".advertise-ifrme,\n.top-hda","div[class^=\"nokha-\"]",".sidebar .mb-2",".codedokan_widget img",".latest_news_post_ad,\n.top_most_news_post_ad,\ndiv[class*=\"_bottom_ad\"],\ndiv[class*=\"_right_ad\"],\ndiv[class*=\"inner-main-ad\"]",".ai-attributes",".sidebar iframe",".addsn,\na[href*=\"countryoven.com\"]",".section-content .pt-20","#awt-left",".widget_media_image:not(#block-9)",".below-content.widget_text","div[style=\"font-size: 12px; color: #d0d0d0;\"]","#HTML19",".single-dtls img","div[id^=\"AS_O_LHS_\"] > div:nth-child(1),\ndiv[id^=\"AS_O_LHS_\"] > div:nth-child(1n+10)","#content section.widget_text",".td-ss-main-sidebar .widget_custom_html",".header-inner .sidebar-col,\n.main-section [data-adid]","#header .sidebar",".widget_widget_banner",".wp-image-133",".cmscontent-article1,\n.oi-adblock","div[style=\"min-height: 250px;\"]","._adr_abp_container,\n.paidPromo","div[class^=\"discounts-\"]","#text-55",".btmAdHldr",".advls","#ok18-roadblock-wrap,\n.add__fullwidth,\n.nh_widget_wrap,\n.ok-full-widht-adv,\n.okam-ad-position-wrap,\n.okam-each-ad,\n.tribox-add",".adds-sec",".sgpb-popup-overlay","img[alt=\"1205X128\"],\nimg[alt=\"Header Ad\"]","aside.widget_media_image img:not(.wp-image-64636)",".googleAdBlock",".onlyn-after-content",".BannerAdd2","a[href*=\"hons.com\"]","div.row:has(> .col-md12 > .margin-top > img.attachment-full),\nimg.attachment-full",".addcomponent","a[href*=\"rv-weddinghall\"],\na[href*=\"tel:\"]","#olh-rhs1,\n.ad_unit_728x90",".better-ads-listitemad",".widget_custom_html:not(#custom_html-14)",".ads_fix,\ndiv[class*=\"ad_\"]",".widget_custom_html:has(> div > ins.adsbygoogle)",".pahad-widget","div[id^=\"pahad-\"]",".biz-ad-block","div[class^=\"pakun-\"]","#media_image-11","div[data-structure=\"12\"]","#content .widget_sp_image",".carouselbanner",".site-wrap .elementor-widget-image",".block-widget",".header .col-lg-8","#webs-bin-5836d5a9170f38d57b00df0a,\n#webs-bin-5bd3752bd8b6aa0001ca1138,\n#webs-bin-5bd3762dd8b6aa0001ca1164,\na[href*=\"baluasiaadd\"],\na[href*=\"channel/UCrx9evkteoAOVMtnZIssVuA/\"],\na[href*=\"stsstudio.com\"]",".kopa-adv-widget","#primary .gam-ad-position-wrap,\n.roadblock__ad a img",".gallery-ads",".topRightAdSec","#media_video-9",".theiaStickySidebar .widget_media_video",".parva-widget,\ndiv[class^=\"parva-after-content\"]",".advertise-section",".col-md-4 .aligncenter.size-full","#text-23",".adds",".widget_media_image:not(#media_image-29)",".td-adspot-title + a","#Mod155,\n#Mod173,\n#Mod174","div[class^=\"aryav-\"],\ndiv[class^=\"newsf-\"],\ndiv[class^=\"patna-\"]","div[id^=\"gpt_ads_\"],\ndiv[style]:has(> div[id^=\"gpt_ads_\"])","#slide-holder,\n.oad",".vmag_pro_medium_ad",".featured-post-ads,\n.fullwidhtads,\n.indexadsone,\n.pragads,\n.title_below_ads","#block-142,\n#block-222","#FloatAdx-left,\n#FloatAdx-right",".elementor-size-small",".td_uid_23_5ee077adb2830_rand","img[alt*=\" Ad-\"]",".tdb_single_content figure .blocks-gallery-grid:only-child",".elementor-widget-image img:not([src*=\"About-pokhara\"])",".mid-header .navbar-nav img",".vc_figure .vc_box_border_blue",".main-bg .carousel",".tdc-row-content-vert-center",".widget_area .wp-block-image img:not(.wp-image-72)",".desktop-ad-nilsagor",".fn-header-banner",".long_adv,\n.side_adv_part",".stream-item-below-header",".kc_single_image",".td-a-rec:not(.tdi_72)","div[style=\"min-height:280px;\"]","div:has(> div[id^=\"div-gpt-ad-\"])",".td-post-content h3 img.size-medium,\n.td-post-content img.size-full",".adbar-area--,\n.navbar-area-2 ~ div[style],\n.ob-smartfeed-wrapper",".footer-widgets-wrap",".wp-block-image:has(> .wp-image-318),\n.wp-block-image:has(> .wp-image-417)",".stream-item img:not([src*=\"Imprint-Latest-\"])",".py-3 .w-100","#block-pj-advt1",".site-header .htmlwidget","#secondary .ai-sticky-widget",".last_ads",".wpb_wrapper.td_block_single_image","div:has(> [class^=\"advertisement-\"])",".modal,\ndiv[class^=\"advertisement-\"]",".tdi_76","[class^=\"ad-service\"]","#services1 li.last",".header .banner",".imgad1",".ad--widget,\n.counter--section",".ad-on-header",".ai_widget:not(#ai_widget-3)",".wpb_wrapper .td_single_image_bg",".sadv",".home_right_ads",".Hero-ads,\n.Hero-ads-banner,\n.sports_section .muktomot_section",".offer_grid",".single-add",".single-page-add2",".post-header .bg-e2e2e2,\ndiv[class*=\"adbox\"]","#addv,\n.for_add",".thads",".safe_life:has(> .textwidget)","#custom_html-17","#media_image-20","a[href*=\"getorgift\"]","div:has(> .dfp-ad-unit)",".ad img:not([src*=\"protichhobi-job.gif\"])",".d-flex > div[style*=\"height: 130px\"]",".slideshow-container",".slideshow-container ~ div .dot",".all_add_div",".ads-widget-sec","#media_image-15","#text-600060003,\n.bdaia-e3-container",".entry-content .stream-item",".jet-listing-grid",".sticky-sidebar section.widget_media_image",".AdvtRight",".ad-box-300",".mh-widget-col-1 .widget_media_image","#right-sidebar .elementor-widget-image,\n.metaslider:not(#metaslider-id-1999)","#supermag_ad-3",".ads-part727829,\n.top-adds",".Al_ads_area","#primary-sidebar",".single__bigyapaan",".col-md-4 .pbwidget,\n.site-content .pbwidget.imagewidget,\n.slideshow",".header-image-wrap,\n.purva-widget",".logo.float-right",".widget > .wp-block-image","div[class*=\"ad-slot-\"]","#head-imgput",".adver-half,\n.adver-mkks,\n.adver-rightmkks,\n.logo-adverimg",".widget_media_image:not(#media_image-53)",".footer-widgets-area section.widget_media_image","div[id^=\"AS_O_LHS_1\"] > div:nth-child(-1n+5)","#MenuAlertAD","div.td-a-rec",".qvzk",".wds_slider_cont",".widget_news_magazine_adsens,\n.widget_news_magazine_adv:not(#news_magazine_adv-6)",".wpb_raw_html",".secOne-add,\n.siteber-add",".category-covid19_corona .pf-content figure.wp-block-image:first-child,\n.pf-content div.wp-block-image:not(:first-child)","div[class^=\"display-area\"]",".popular-section.pt-50",".entry-content div[style*=\"float:left\"]",".small-adv","div[id^=\"rasht-\"]",".rg-advertisement-long-horizontal,\n.rg-side-adv",".full-ads-wrapper,\n.side-ads-wrapper",".td-modal-image img.size-full","#owl-demo1",".bigyapan-margin-btm",".adv-item,\n.content-banner--single",".sidea",".news247_ads_banner_widget",".tdb_single_content .tdb-block-inner > h4 + p ~ :not(div)",".main-sidebar > .widget_text:not(:last-child)",".small-arthik-widget","div[id$=\"-ad\"]",".wp-image-70951",".colombiaadcode img,\ndiv[id^=\"AS_O_LHS_1\"] > div:nth-child(-1n+6)","#left_level_1,\n.left_level_3_before",".add_content","div[style=\"min-height: 90px;\"]","#sidebar > .widget_media_image","#adHeaderBottom,\n.footer-adv",".top_dd","#custom_html-53,\n#custom_html-54",".header-centerbar-ad","#popup_indiv2",".adore-adver",".topaddno",".unite-gallery,\n.widget_awaken_medium_rectangle_ad",".dazar-ad","#widget_sp_image-2","#custom_html-26,\n#custom_html-29,\n#custom_html-30,\n#custom_html-39",".td-post-content .code-block",".td-ss-main-sidebar .widget_text","#kp-premodal-1--wrap","img[alt=\"advertise\"]","#block-20,\n.theiaStickySidebar .widget_media_image:not(#media_image-15),\ndiv[class*=\"stream-item-below-post\"]",".prachar",".e3lan img",".AdvtSample","div[class*=\"slide\"]:has(> div > .AdvtSample)",".wp-image-248125,\n.wp-image-248302","#herald_video_widget-2","div[id^=\"sachk-\"]",".view-ads-all-blocks",".full-banner,\n[class*=\"advertisement\"]","a[class^=\"myadsply\"]","div[id*=\"_O_\"] div:has(> div > div > a > p + h3)",".post-footer center","#block-31",".td-ss-main-sidebar aside,\na[href*=\"uihmt.com\"]","div[class^=\"sajag-\"]","div[id^=\"hwp-\"]",".text-center iframe",".primary-sidebar-widget",".adtext,\n.google_ads_wrap",".add-text,\n.add-text + a:last-child","#right_banner","div[class^=\"home-adright\"]","#quads-ad17070",".both_AD",".img-add,\n.top_advertize","div[id^=\"samac-\"]","div[class^=\"sgpb\"]",".add-sm",".cont_break_ads",".full-bann",".bsac img:not([src*=\"go-seva.jpeg\"])",".bannar-full-width",".slider2","#popUpModalAd,\n.app-news-section-div:has(> .adv),\n.bottomReadMoreCart div[style*=\"width: 300px !important;height: 250px\"],\n.bottomStickyDesktopDiv,\n.text-body-ad,\n.topStickyDesktopDiv,\ndiv[class^=\"textBodyAd\"]",".widget-container-130",".advertorialwrapper,\n.box-item","a[onclick*=\"tgsctp/click.htm?\"]:not([onclick*=\"https%3A%2F%2Ftelugu.samayam.com\"])",".advt_r","#HP_O_LHS_7 > div:nth-child(-1n+2),\ndiv:has(> a > div > .pd_title),\ndiv[id^=\"AS_O_LHS_\"] > div:nth-child(-1n+2)","#tie-slider-widget-5","table:has(> tbody > tr > td > a[href*=\"drkeshavjee.com\"])",".tdi_86",".widget_hootkit-slider-image","#sidebar-right-1 .widget.Image",".widget_block:not(#block-23):not(#block-22)","#sidebar-wrapper .widget.HTML:not(#HTML4)",".wiejqhgsp-container","#block-113,\n#block-114,\n#block-116,\n#block-117,\n#block-119,\n#block-120,\n#block-121,\n#block-122,\n#block-123,\n#block-124,\n#block-125,\n#block-126,\n#block-128,\n#block-129,\n#block-130,\n#block-131,\n#block-132,\n#block-134,\n#block-135,\n#block-136,\n#block-137,\n.footer-column-1 section:not(#block-95)",".sp-full-width-ads",".fw-bold.text-black","#block-22","#block-32","#media_gallery-10",".theiaStickySidebar > .widget_media_image",".item-size-right img,\n.mid-adv-sec-bottom,\n.top-head-hori-adv","#myCarouse2",".add-2","aside .widget_custom_html",".tophightlight_ad,\n.widget_text:not(#text-6)","div[data-widget_type*=\"_ads\"]",".mtphr-dnt-widget",".bg-white.text-center:has(img)",".sg-full-width-ads,\n.three-col-ads,\n.three-col-ads-block,\n.widget_sg_advertisement_1",".news_left_part_ad,\n.single_page_bottom_ad,\n.square_advertisement",".addBox2",".sangb-after-content",".advertisement_left_column,\n.advertisement_right_column",".advrts",".hm-sidebar > div[style],\n.top-banner",".pr-0","div[class^=\"sanje-\"]","#sanje-slider-30,\ndiv[id^=\"sanje-\"] img",".sidebar-right > .widget_text > h5","main section.sk_banner",".jeg-vc-wrapper iframe,\n.vc_row.vc_row-has-fill","#header-widget",".ws-block video",".allrounder-advertisement","figure.wp-block-table","a[href*=\"padmabankbd.com\"],\na[href*=\"premierbankltd.com\"]","div[class*=\"adver\"]:not(.logoadver)","div[id^=\"sarth-\"]","#content div[data-adid]","div[id^=\"inven-\"]","#media_image-31",".banner__ads",".posts__banner__ads,\n.stream-item img:not([src*=\"File.gif\"])",".widget_sisw_widget","div[id^=\"th-sb-ad-block-\"]",":has(> .metaslider)","#text-33,\n.quadss-location",".etad","div[id^=\"satym-\"]",".site-main .widget_media_image",".sidebar__ads","div[class^=\"jsx-\"]",".bdaia-widget:not(#bdaia-widget-e3-4),\ndiv:has(> .bdaia-e3-container)","#text-html-widget-7","#ads400px,\n.ads400pxinner,\n.briefNewsAd,\n.header_adbar,\n.toppageadsindexheader,\na[href*=\"splads\"]",".textwidget",".main-bigyaapan,\ndiv[class*=\"-bigyaapan-\"]",".hmxbiekzq",".leadnews .widget_area",".ws-block img:only-child","#media_gallery-26",".adsp","#custom_html-1291,\n#custom_html-1292,\n#custom_html-1293,\n#custom_html-1371,\n#text-882,\n.company-ads,\n.home-page-ads a:not([href*=\"sharebazarnews.com\"]),\n.lef-sidebar-ads,\n.main-header-ads,\na[href*=\"kidarkar.com\"]","[href*=\"whistleloop.com\"] img",".py-1 .w_lead,\nimg[alt=\"-Advertisement-\"]",".vc_raw_html:not(.tdi_87)",".custom img",".topAdv",".entry-content a[target=\"_blank\"] img,\n.iframely-embed","div[class^=\"sherp-\"],\ndiv[id^=\"sherp-\"]","#focus_slider",".sidebar-box a[target=\"_blank\"]",".headeradvt,\n.pageadvt,\n.post-item-description p a strong,\n.post-item-description p img",".theiaPostSlider_slides p > img",".elementor-widget-video,\nimg[src*=\"WhatsApp-Image-2021-08-16-at-3.07.30-PM\"],\nimg[src*=\"WhatsApp-Image-2021-08-19-at-2.46.04-PM\"]",".shobu-widget,\ndiv[id^=\"shobu-\"]",".featured-add,\n.sa-ad",".entry-content > img",".coupon_dealtop",".widget_media_image figure",".elementor-widget-sidebar .widget_custom_html,\ndiv[class^=\"shree-\"]","#ucier-4,\n#ucier-5,\n#ucier-6",".shrin-widget,\ndiv[id^=\"shrin-\"]","div[data-index]","section[class^=\"advertise\"]",".d-flex.justify-content-center,\n.home_page_part_one_right.second,\n.slider",".elementor-widget-image .size-full:not([src*=\"simanapari-1.png\"]),\n.elementor[data-elementor-type=\"wp-page\"] .elementor-widget-image","#brx-header .size-large",".hidedivcopy","#block-100",".widget_custom_html:not(#custom_html-11):not(#custom_html-2)",".hustle-popup","aside.widget_media_image > img",".widget_media_image:not(#block-6)",".add_after_scroller,\n.addtop_header,\n.addtop_inner img[data-filename],\n.single_after_ad,\n.single_before_ad",".theiaStickySidebar .elementor-widget-image,\n.theiaStickySidebar .elementor-widget-video",".advertise-widget-box",".widget_esn_ad:not(#esn_ad-3)","#news_portal_ads_banner-20,\n#news_portal_ads_banner-22","#sub-footer .widget_media_image",".themesBazar_widget > .textwidget",".single_page > .widget_area",".td-g-rec-id-sidebar",".post-inner .code-block img",".big-banner-left,\n.small-side-banner-wrapper",".bg-red-400","#wrapper-content .widget_text",".add img:not(.wp-image-18706):not(.wp-image-22177)",".jeg_main .elementor-widget-image",".twp-ad-image-section","#amazonautolinks_widgetbyid-2",".add:has(> div:only-child)","#tdi_191,\na[title=\"Sidebar ad-1\"]","#stream-item-widget-3",".FrameAdvt1","#sidebar .text-muted","a[href*=\"staraluminium\"]",".penci_single_ad_after_content",".widget_sow-slider",".ad-title ~ * > img:not([src*=\"BARON-\"])",".ds-scroll-ads",".main-headera .advertise","#colorcontentasash3,\n#featgal ~ div > #colorcontentblock",".suddi-after-content_13,\n.suddi-content_10,\n.whistleAds",".adredux","div[id^=\"suddi-\"]:not(.suddi-before-content_3)",".news-addheight","#sidebar-primary-sidebar .widget_text:not(#custom_html-4),\n[class*=\"pubadban\"]",".sidebar .no-bod",".block-inline-blockad-block,\n.field--name-field-ad-image",".container_fluid.bgColor2,\n.details-sidebar .mb-3,\n.py-3,\n.sidebar-news.justify-content-center","div[class^=\"ads\"]",".h_ads a:not([href*=\"sunbd24.com\"]),\n.header_area > .container,\n.share-ads,\n.sidebar-adv",".adv-load,\na .adv-vload,\ndiv[style^=\"padding: 25px 25px 90px 25px;\"]",".hero-section",".tdi_33 .td_block_single_image",".w-image.align_none .attachment-large",".col-sm-4 .hidden-xs","section.widget > figure",".nv-header-ads-area",".adMark","#sync3",".sponsored","#commentform img,\nspan[style^=\"color: red;\"]",".stoybday-ad",".advertise_image",".iframe-container",".live_title,\n.live_title + p","a > img.img-responsive",".widget_box img","#newsphere_posts_slider-7","#media_image-25",".add-area",".header__add,\nimg[alt=\"Page Add\"]",".jeg_midbar .jeg_nav_right","div[id^=\"itro_popup\"]",".advertisement-area","#itro_opaco",".home-section-ad","a[href*=\"cinefield.com\"],\na[href*=\"tamiltv.com\"]","#sidebar-schedule-slider",".tamil-widget",".cine_ad","#sidebar .text-html","#sidebar .widget_custom_html","a[href*=\"periyarkural.com\"],\na[href*=\"pna-aerial.fr\"]",".header-add",".sidebar > p",".adv_slider","a.in-cell-link",".home-mid-banner,\nsection.slider-sec","[alt=\"Short Term Rental - Toronto\"]",".sidebar-ad-banners","#block-19",".euvradxs,\n.spu-bg,\n.spu-box",".a-wrap:has(div[id^=\"div-gpt-ad\"])",".td-a-rec img:not([src*=\"join\"])",".after-menu-ad,\n.sidebar-add",".elementor-image img:not([src*=\"Tatviknews-white\"])","div[id^=\"tazak-\"]","#secondary aside.widget_custom_html,\na[href*=\"kitchenworldbd.com\"]","#sidebar-wrapper .widget.HTML:not(#HTML14):not(#HTML7)","#sp_widget_post_slider-2",".td-fix-index,\n.widget_custom_html img",".add-slot-3",".stay-connected-ads",".technology-section-ads",".tdb_single_content img.size-full,\n.tdb_single_content p img,\n.tdm-inline-image-wrap,\nh2 a[href*=\"one-medicine-\"]",".td-main-content-wrap .vc_raw_html",".fluid-width-video-wrapper,\niframe[name^=\"fitvid\"]","#sidebar-right > .widget_media_image","#right_level_0,\n.inside-post-ad-before-before",".headertoprightsideupdate",".data-area2 .heading,\n.single_leftbar.wow > h2",".custom-header","#djslider875,\n.content-holder-tvshowvaluevision,\n.content-holder-valueparma,\n.content-holder-valuevision,\n.wishesh-add",".td_spot_img_all","div[style=\"background-color: #fff; padding:0px; margin-right:10px;\"]","a.vc_single_image-wrapper:not([href*=\"thaiveedu.com\"])",".custom-html-widget > img","div[id^=\"thare-\"]","#HTML13","#carousel",".content-details .code-block",".add-sectionb,\n.add-sectionw,\n.lefr-box","a[href*=\"newtraffictail.com\"]","div[id*=\"ArticleShow_\"] > div:nth-child(-1n+10)",".elementor-widget-image .size-large:not(.wp-image-61263)","#header-section .my-1,\n.widget-wrapper.overflow-hidden",".admanager_home,\n.info_wrapper,\n.infostation","div:has(> .adsbygoogle)",".add_03",".elementor-widget-penci-featured-boxes",".code-block-1",".widget_text:not(#text-2)",".footer_top_add","#right_level_3","#top_full_width_level_15",".widget_text iframe[title],\ndiv[class^=\"thejo-\"]",".banner-adver","#taboola-ads,\n.py-2,\n.videoAdInArticle",".entry-content > div[class]:not(.addtoany_content)",".pos",".sidebar .widget.HTML",".single-image .carousel","#top-slider2",".entry-content p > img",".td-a-rec img:not([src*=\"perfect_kejriwal-\"])","figure .widget-image-caption","aside.widget_text:not(#text-49):not(#text-51)","#add-place,\n.idlc,\n.top-add-left4,\ndiv[id*=\"_300x250\"]",".farrr,\n[style*=\"height:80px;width:300px;\"]",".zox-post-ad-wrap",".category_page_right .single_page_bottom_ad","#media_video-4",".thest-widget,\n[id^=\"thest-\"]","#custom_html-12","#block-block-81",".freedomplayer,\ndiv[id^=\"third-\"]",".entry-content > :not(figure) img,\n.widget_youtube_responsive",".dmp","div:has(> .adv)",".elementor-widget-penci-custom-sliders",".single-wrapper-details-sidebar-ads img,\n.widget_black-studio-tinymce .aligncenter","#secondary .widget_block:not(#block-9)","a[href*=\"facebook.com/Future-Company-\"]","#app > section > div:first-child:not([class]),\n#mgIDReadMore div[style*=\"min-height\"]",".atfAdContainer,\n.bggrayAd","div[style*=\"min-height: 181px;\"]","div:has(> .ad-div)",".kopa-banner-300",".text-description ~ div[style*=\"height: 360px;\"]","#rev-slider-widget-2,\n.wpb_revslider_element",".rt-post-slider-style1",".hot_rwc_ads,\n.mid_rwc_ads",".addbx,\n.headnBx .text-right","a[href*=\"valokichu.com\"],\na[href*=\"webacademy-edu.com\"]","#text-27,\n.lefta,\n.righta",".wpb_text_column,\naside.widget_black_studio_tinymce",".td_mod_wrap",".mg-nav-widget-area .pull-right",".entry-content > div[style*=\"float\"]","#smart-head .h-text,\ndiv[id^=\"today-\"]",".sidebar-nav .mb-2 img","#unitDivWrapper-0[style^=\"height:\"]",".widget_block:not(#block-9)",".border-bottom.bg-white","div[id^=\"AS_O_LHS_1\"] > div:nth-child(1n+16)","#advertsub2","#custom_html-16","#text-42,\n.galboxcontainer,\n.widget_html_javascript_adder,\nimg[alt=\"SAT\"]",".elementor-widget-slides",".adimg:not([src*=\"_aalapp.jpg\"]):not([src*=\"_next tv.jpg\"]),\ndiv[id^=\"Truevisionnews_Banner_\"]",".af-middle-header .content_block",".piller_main","[class*=\"-banner\"]","aside .widget_media_image","div[id^=\"tvann-\"]",".section-content p img","#logo-right,\n.add-right",".ad-white-blk,\n.adliadworld,\n.ads-white-blk,\ndiv[class^=\"amp_Ad\"]",".wp-image-102704",".elementor-widget-image img:not([src*=\"new-logo.png\"]),\n.td_block_single_image.td-no-img-custom-url,\ndiv[id^=\"udupi-\"]",".post-middle-banner","#custom_html-20,\n.entry-content .code-block img","#media_image-32",".ad a:not([href*=\"ujyaalo\"])",".wp-block-image figure",".site-header ~ .bg",".div_ad_rgt","#block-43",".twp-ad-section,\n.twp-home-widget-section",".category_side","#mvp-site-wall","#main-content .widget_media_image,\n#text-43","div[class*=\" ads_\"]",".header_bottom_ad",".right_bottom_ad_section,\n.twp-adv-header","#sidebar-wrapper .widget.Image",".container > .features-today-box:only-child",".aft-sticky-sidebar,\n.header_ads_slide",".single_post_content a[href*=\"?tag=bitspi-21\"],\n.top_addarea",".column-inner,\n.fn-widget-image,\n.fn-widget_media_image","[class*=\"_ads_\"]",".fn-block .size-large:not(.wp-image-64792),\n.wp-image-35679,\n.wp-image-35692","div[id*=\"_O_\"] div:has(> div > div > a > div h3 + p)",".uttar-widget,\ndiv[id^=\"uttar-\"]","div[class*=\"uttar-\"]",".td-ss-main-sidebar .widget_media_video",".colombiaRequestSend,\ndiv[id*=\"_O_LHS_\"] > div:nth-child(-1n+10)",".widget_block:not(#block-26)","#home_page_ad","#mvp-ad-rel-wrap,\n#mvp-head-top,\n.theiaStickySidebar figure.wp-block-image,\nsection.widget_custom_html:not(#custom_html-7)",".each-side-ads > a,\n.full-ad-wrp,\n.tp-ad","div[id^=\"topmiddle\"]",".td-main-sidebar aside",".sidebar .widget_text:not(#custom_html-2)",".upper_links",".widget_media_image:not(#media_image-38):not(#media_image-39)","#vmadspace,\n.mh-header-2",".elementor-widget-vinazine-ads",".vatsa-middle","#tdi_2,\n.td-post-content > div[style^=\"clear\"]",".widget.Image:not(#Image150)","div[id^=\"image_\"]",".sppb-addon-clients","#sidebar-footer-4,\n#sidebar-primary-sidebar .widget:has(div[data-adid]:not([data-type=\"custom_code\"])),\ndiv[data-adid]:not([data-type=\"custom_code\"])",".sidebar.s2 .AdWidget_ImageWidget",".c-sections__container,\n.l-hp-top__off-off-lede",".velsm-content","img[alt=\"- ADVERTISEMENT -\"]",".mainEpaperR1R2 ~ div","#ads120_60-widget-2",".ad-top-bottom-space,\n.widget300xauto,\n.widget300xauto-targetted,\n[class*=\"-ad-\"],\n[class*=\"__ad\"],\ndiv:has(> .ad)","a[href*=\"goo.gl/18LXwT\"],\na[href*=\"puthinamnews.com\"],\na[href*=\"tubetamil.com\"],\na[href*=\"tubetamil.fm\"]","#adv",".add-box,\n.add-large-box","div[data-adid]:not([data-adid=\"99627\"])",".bdaia-post-content figure,\n.bdaia-post-content p img",".add-bar,\n.add_area img",".widget_digital_newspaper_banner_ads_widget","#first-advertisement","[class=\"hidden xmd:block\"],\ndiv:has(> div[id^=\"VTV_\"])",".td-no-img-custom-url,\n.td_block_single_image > span",".widget_nmrh,\ndiv[data-adid]:not(.nmrh-type-custom_code)","#block-28,\n#block-30",".advt_336,\n.full_ads_block",".entry > p:last-child > img",".a-15,\n.adv_side","a[href*=\"traffictail.com\"]","#right_siran",".footer-add",".bk-rect-fullWidth-desktop-vigyapan--1 img",".DContentAdd,\n.exclusiveSec + .row,\ndiv[style=\"height:400px\"]","#block-38,\n#block-52","#media_image-29","#media_gallery-28","#media_gallery-33,\n#media_gallery-41,\n#media_gallery-43",".widget.Image:not(#Image4)",".tac",".yashb-adlabel,\n.yashb-content","img[alt=\"header ads\"]",".quads-location","div[role*=\"CUSTOM\"]",".su-image-carousel,\n.tdi_26 .block-title,\n.tdi_27","#secondary .box-sec-bg,\n.adver-sec,\n.box-sec-bg .slider",".widget_media_image:not(#media_image-7):not(#media_image-8)","#ads_slider",".elementor-widget-html img,\ndiv:has(> pubguru),\ndiv[style^=\"float: none\"]:not([data-index=\"3\"])",".elementor-widget-image-carousel:only-child,\n.footer-widget .textwidget img",".post center > a[target=\"_blank\"]","div:has(> div > .dfp-ad-unit)","#unitDivWrapper-0,\n.image_Ad",".entry-content .banner_wrapper","#block-178,\n#h-ajfashion,\n.wp-block-embed-youtube","#LinkList2","#HTML33",".td-post-content .td-a-rec > figure img:not([src*=\"whatapp\"])",".adsense-inject,\n.sidebar-widget",".ad__full--length",".add-block,\nul.post h3.widget-title","#shoppingWidget,\n.add-center-div,\n.itgdAdsPlaceholder",".top-add-section",".container > .flex-c-c,\n.flex-c-s",".entry-content figure.wp-block-image ~ .wp-block-image",".stream-item-widget-content","#news_portal_ads_banner-2",".ader_ads","a[href*=\"biqdiq.com\"]",".ad-slide",".mvp-flex-ad","div[id^=\"amrit-\"]",".add-gap","#ad_container2,\n.right_box_golpo",".right_banner","figure.wp-block-embed","h2[id*=\"sponsor\"]",".stream-item:not(#tie-block_243)",".desktop-square-ad,\n.right-section-top-2",".ashmi-ad,\n.widget_block figure.size-large","div[class*=\"__adContainer__\"]",".addtoany_content + div:has(iframe)",".benga-raiganj-municipality",".ms-parent-id-1",".popup","a[target=\"_blank\"] img:only-child","#text-html-widget-14,\n.RightCont iframe",".elementor-widget-image figure","#secondary aside.widget_text",".widget-slider-inner","#attachment_28282","ins[data-ad-channel]","#cust_bann,\n#lcs_ad,\n#metaslider_7568,\n#metaslider_7646,\n#metaslider_7731,\n#rma_masala",".hustle-ui,\n.ml-slider img:not([src*=\"whatsapp-\"])",".b-ads",".td-a-rec img[alt=\"Google search engine\"]",".hm-header-sidebar,\n.quads-ad-label",".amazon-auto-links-widget",".code-block ~ img","div[id^=\"cguja-\"]",".pt-4:has(> .carousel)",".entry-content .g-single","#myCarouselv,\n.ad .carousel","#bk_sidebar_3,\n.hustle-content","section.widget_metaslider_widget",".main-box-inside:has(> p ins.adsbygoogle)",".head-main-ad","div.HTML:has(> .widget-content)",".theiaStickySidebar .widget.HTML:not(#HTML7)","#carouselExampleDark,\nmarquee","#addImage,\n.inner-add-banner","div[class^=\"max-h-[200px]\"]",".newshit-header-ads-wrapper","#dynamic_sidebar_before",".theiaStickySidebar .widget_smartslider3",".soliloquy-container,\n.widget_media_image:not(#media_image-4)",".main-footer .widget_text,\ndiv[class^=\"india-content_\"]",".widget_media_image:not(#media_image-16)","#wowslider-container1,\naside > .widget-title",".khaba-single-blog-manual","#right_level_1.mtop15",".right-inner .right-box,\ndiv[class^=\"google-\"]",".ads-slider-widget",".mahas-widget",".backg-g,\n.dsc-banners","#main aside.widget_media_image,\n.natur-content","#block-93","#leaderboard-content",".td-a-rec iframe",".entry-content img:only-child","section.widget_block:has(> p > ins)","#oppopo,\n.bs-listing-single-tab + .bs-listing-listing-grid-1","#SidebarWidgets-S1,\nimg[id^=\"Image\"]",".punja-widget,\ndiv[id^=\"punja-\"]",".sgpb-popup-dialog-main-div-wrapper",".widget_block:not(#block-22)",".google_ads_section","#media_gallery-4,\n#media_image-18,\n#media_image-19,\ndiv[id^=\"webre-\"]",".crime-before-content",".text-center.my-1","a[href*=\"gkprashnuttar.com\"],\na[href*=\"hindugodwallpaper.com\"]",".gb-container-553faf02","#main .entered:not([src*=\"WhatsApp-Join-Link.jpg\"])",".ad-close",".stream-item.half-box",".mzb-advertisement","#customImage,\n#customVideo,\n#header .right",".code-block:not(.code-block-2),\n.widget_media_image:not(#media_image-57):not(#media_image-47)","#rozu-2,\n.main-wrap div[class^=\"rozu\"]","div[id*=\"_webads\"]","div[id^=\"AS_O_RHS_\"] > div:nth-child(1n+4)",".td-a-rec video",".awac img.image,\n.np-home-bottom-section,\n.spcp-sidebar,\n.wp-image-82536","#block-37,\n#custom_html-169,\n#secondary aside.widget_media_image","div[id^=\"dolph-\"]",".unav_banner,\np:has(ins.adsbygoogle)","#sp-adsforbody,\n.sppb-column-addons > div:has(.carouselbanner)","#ccr-right-section #sidebar-video-post img",".add-row,\n.square_in img",".single_sidebar .spost_nav,\na.sideAdd",".side-bar > .widget:nth-child(2)","#advads_ad_widget-2,\ndiv[id^=\"glime-\"]","#headerTopAd","#headerBannerPromo,\n.gd-multi-news ul > div,\nli:has(> div[id^=\"taboola-mid\"])",".headinglist > div,\ndiv[style^=\"height:250px\"]","#block-26",".epcl-row,\n.grand-after-content_2",".the_content div[class^=\"gujar-content_\"]",".gujju-before-content_4,\n.the_content > div[class^=\"gujju-content\"]","a[href*=\"play.gamezop.com\"]",".entry-content-wrap div[id^=\"hello-\"]",".inside-right-sidebar > .gb-container:nth-child(2)",".cm-popup-modal",".stream-item-widget:not(#stream-item-widget-4)","#text-34,\n.wp-image-11223","#responsive_lightbox_image_widget-2,\n#secondary section.widget_text",".NewClass iframe",".Stickyads",".alt-balaji,\n.hr_banner",".vc_sidebar .widget_custom_html","#metaslider_10258","figure .vc_single_image-img","#india-slider-227",".widget_block:not(#block-30)",".ml-slider:not(#metaslider-id-1461)","#newsSection img,\n.video-container",".custom_sidebar_ads",".ct-header-text",".ad:has(> div:first-child)","div[id*=\"indon-\"]",".banner-slider-2","#sidebar .advertisement",".stream-item.content-only",".jaihi-before-content,\n.widget_text:not(#custom_html-7)","#secondary .widget_text:not(#text-17):not(#text-38)",".td-a-rec-id-content_bottom .ml-slider:nth-child(1n+6)",".mh-sidebar .widget_media_image",".rightbarhds,\n.toplogobannerRS1 .topcol1","#custom_html-43,\n.entry-content figure.wp-block-image:not(.size-large)","div[class*=\"kitsune-advert\"]",".newsever-widget .textwidget,\ndiv[id^=\"jhark-\"]",".stream-item-above-post-content","#text-html-widget-8,\nsection ~ .e3lan","#content .widget_text:not(#text-8),\n.av_slied,\n.avv_custom","iframe[src*=\"google.com/presentation/\"]",".ewic-slider","#content div[id^=\"khaba-\"]",".td-main-content-wrap .tdm_block_inline_text",".stream-item-widget:not(#stream-item-widget-6)",".custom-group-ads",".dce-dynamic-posts-collection,\n.elementor-element-3fb6b77","#secondary","div[class^=\"kokan-\"]","#postBody > div:nth-child(1n+3) .separator img",".elementor-widget-shortcode img[alt]",".eaa-ad,\n.tm-adv-header","#hadd,\ndiv[id^=\"lagat-\"]",".header--ad",".before-banner-ad,\n.top-left-add","div[class*=\"ads-height-\"]",".widget_carousel_slider","div[id^=\"livei-\"]",".blocks-gallery-item,\n.e3lan a img,\n.widget_custom_html:not(#custom_html-87)","div[id^=\"lokal-\"]",".theiaStickySidebar aside.widget_text","#photoInlist1,\n#photoInlist2,\n#rhs-middle,\n#rhs-top,\n.articlePage",".elementor-element-8c6f9c2,\n.elementor-element-f2e9897","#adrotate-wrapper",".code-block-5",".content-inner > p img",".td-a-rec:not([class*=\"tdi_345\"]),\ndiv[class*=\"tdi_140\"]","#ad_first_middle,\n#middle_level_1",".media-after-content",".container-bn:not(.mb-5),\n.two-ads",".Image.widget",".entry-content.single-post-content > img",".articleText > center > div","#text-9 iframe,\nsection.widget_media_image:not(#media_image-6)","div[id^=\"v-mumbaitak-in-\"]","#sidebar .widget.HTML,\n.separator > a img:not([height])",".post-text section","#block-views-block-detail-page-ads-block-2,\n.header-ad-section-desk,\n.nak-adv-cen:not(#block-views-block-global-news-home-page-block-3),\n.theiaStickySidebar .block-block-content,\ncenter[class*=\"addsCenter\"]",".wp-image-404",".TpGnAd_ad-cn,\n.ads-wrp",".widget.HTML:not(#HTML5),\ncenter > b + img",".bsac img:not([src*=\"1-1.jpg\"]),\n[data-adid]:has(> img)","#center-container [alt=\"Image\"],\n.PixyPaperad",".mobadv-4,\n.n13_adv,\n.n13_home_adv4,\n.n13_home_adv5",".td-fix-index img:only-child",".addver > ul:only-child,\n.ads-2018",".sppb-addon:has(.bannergroup),\ndiv:has(> div[class$=\"-content\"] > [class*=\"banner\"])",".wp-image-109634,\n.wp-image-15016",".wpb_wrapper.wpb_text_column",".avt_masterslider_el",".master-slider-main-widget",".widget_beside_slider",".widget_dtuy","#advertisement,\napp-squaread,\napp-squaread2,\napp-squaread4",".widget_300x250_advertisement",".tp[id^=\"Article\"]","#rishi_advertisement",".header-right-widgets,\nsection.widget_media_image:not(#media_image-13):not(#media_image-6)",".blockspare-blocks,\nimg[alt=\"Ad\"]",".container.frame",".td-a-rec-id-footer_top",".widget_block:not(#block-10)",".elementor-element .size-large,\ndiv[id^=\"nikha-\"]",".bookingaff",".bn-sidebar-content",".col-bn-ds","#Mod182,\n#Mod225,\n.main .bannergroup","div[class$=\"0-ad\"]","div[class$=\"-ad\"]",".header-advertise",".right-add",".widget_custom_html:not(#custom_html-10)","#national-news-section .promobox-wrapper,\n.news-text-content p img","#text-html-widget-4,\n.post-content ~ :not(div)",".td-a-rec img:not([src*=\"ad-ddepaper.jpg\"])",".td-a-rec-id-custom-spot",".widget_media_image:not(#media_image-13),\n.wp-custom-header","div[id^=\"advDiv\"]",".td-footer-wrapper",".td-is-sticky .td-a-rec","#sb-container","#vda-4",".code-block:not(.code-block-14)","#right-sidebar-inner .widget_media_image,\n.entry-content iframe[data-mce-fragment]",".onesignal-customlink-container ~ img","[class*=\"-add-\"],\ndiv:has(> [id^=\"div-ad-\"])",".vc_col-sm-8 .mom_custom_text","#cm-secondary .widget_custom_html img:not([src*=\"BKTC-New-Add.jpg\"])","#tdi_115","#tdi_101,\n#tdi_121",".wp-image-62537,\n.wp-image-62663,\n.wp-image-71118,\n.wp-image-71139,\n.wp-image-73550,\n.wp-image-73634,\n.wp-image-73651,\n.wp-image-73917,\n.wp-image-74768,\n.wp-image-74770,\n.wp-image-74771,\n.wp-image-74772,\n.wp-image-75230,\nimg[src*=\"gftr\"]",".adssection,\n.homemainads",".primary-sidebar-widget:has(div[data-adid])",".samay-widget,\ndiv[class^=\"samay-\"]",".widget_pkgrdlaobc","div[class^=\"add-right\"]","div[style*=\"margin-top:50px; margin-bottom:90px;\"]",".pum","#sticky-wrapper",".theiaStickySidebar > aside > .widget_media_image",".newsmatic-advertisement-block","div[id^=\"satya-\"]",".wp-image-38968,\n.wp-image-38972",".sidebar-right iframe",".jquery-modal",".mg-headwidget .code-block","#secondary .widget_media_image:not(#media_image-30)",".right-sidebar .widget_block","[class^=\"adsbox\"]","div[class*=\"sitamarhi-livecontent_\"],\ndiv[id^=\"sitam-\"]","#main-content .et_pb_gallery_image,\n#main-content .et_pb_image",".row-thirty.sidebar","#header_ad_mobile,\n#left_level_0_before_1,\n#level_6_before,\n.top_level_1","#disqus_recommendations","#right-sidebar-inner .widget_text",".imggoogel,\n.imgslider img:not([src*=\"pratibha.jpeg\"])","#level_bottom_full,\n.right_level_1",".col-lg-4 .gdgallery-gallery-container","#navbar .image",".contents > p img,\nsection.bg-light","#cactus-body-container .widget_custom_html,\ndiv[id^=\"thehd-\"]","div[id^=\"AS_O_LHS_\"] > div:has(> div > div > a > p + h3)",".sb-banner",".alp-advert,\ndiv[id^=\"thema-\"]","#block-73,\n#block-74","#block-35",".entry-content img[class=\" lazyloaded\"]","div:has(> .nbs-flexisel-container)","#splad,\n.thewall-ad-section,\nsmall[style*=\"font-size: 11px;color: #979797;display: block;text-align: center;\"]",".Home-seo-add-sidebar-bigborder,\n.section-ten-wrap,\n.tg-addbox","a[href*=\"surabooks.com\"]",".entry-content img.alignleft,\n.entry-content img.alignright","article div[class*=\"today-\"]",".elementor-video",".widget_dhnvx",".home_right_1_1,\n.home_right_3",".entry-content .bsac",".mob_ad_cntr iframe","#v-uptak-in-0","div:has(> .afw)",".right-adpanel-wrapper > div[style*=\"width:300px; height:250px;\"]",".adloc-is-banner",".mkd-sidebar .widget_text","#block-block-253--2,\n#block-block-263--2,\n#block-block-338,\na[href*=\"bitmangalore.edu.in\"],\na[href*=\"vishwasbawa.com\"]",".mega-wrap .main-ads-pikihome",".content-inner img",".rslides1,\n.rslides4",".headAdExBlock","div[id^=\"vknews\"]","#media_image-36,\n#media_image-38,\n#media_image-41","#v-weunetwork-in-0,\n.sale-ads,\n.top_ads_2,\n.utf_ad_content_area",".wpb_widgetised_column .wp-block-image","#secondaryright .widget_custom_html","#sidebar-section-top","html12,\nhtml2","#simpleimage-6,\na[href*=\"arabic.iirt.info\"]","#HP_O_LHS_7 > div:nth-child(-1n+5),\ndiv[id=\"showAS_O_BEL_0\"]",".wp-image-68028",".googlepublisherads,\n.post-header a[target=\"_blank\"] img",".herald-txt-module",".fix-img-fluid",".carousel.slide",".newsd-widget",".dns-caption-below",".td-all-devices",".sidebar-widget:has(> .widget-body > p > img:only-child)","#adsBanner","a[href*=\"utm_medium=banner\"]",".tds-button","#myModal1",".advert-single","img[alt=\"Arpico\"]","#desktopad",".penci_topblock",".theiaStickySidebar .elementor-widget-image img:not([src*=\"admit.jpg\"])","a[href*=\"CrystalSoapLK\"],\na[href*=\"kandos.lk\"]",".d-flex",".widget_custom_html:not(#custom_html-7)",".btm-sticky","#flexiselDemo1,\na[href*=\"advertising page\"] img",".elementor-widget-rt-image","a[href*=\"bit.ly/44036s6\"] img",".besides-slider-right","#ads_hide",".td-header-header-full",".fixed-banner,\n.main-ad-half","#headerright",".td-a-rec:not(.td-a-rec-id-sidebar)","div[data-type=\"_mgwidget\"]","#openModal1",".wpb_text_column.tagdiv-type","#block-views-ads-display-inner-block","#newads,\ndiv[id^=\"banner\"]","#openModal0,\n.ads-rig",".bg-grey-lighter.w-full,\na.group.w-full",".module-ct .custom",".d-lg-block",".youtube-responsive-container",".container-single-page .elementor-widget-image","#custom-ads-2,\n#main_middle_right_advert",".paid-banners",".wg-advert","img[target]","div[data-embed-button=\"embed_advertisement\"]","a[href*=\"adroll.com\"]",".a_d-banner",".add .widget_area img:not([src*=\"54342.jpg\"])",".block-block:not(#block-block-13)",".top-ads-block",".ad-sm,\n.ads-center-mt,\n.gallery,\n.header-ad-section","div[style=\"height:78px; width:100%\"]",".vc_raw_html .td-fix-index > div",".popupCloseButton,\n.rib__wrapper",".AdWidget_ImageWidget","#banner_header_728",".add-space",".content-inner h4",".widget_sp_image:not(#widget_sp_image-2)",".td-main-content-wrap .td-a-rec img",".addVertise,\ndiv[class*=\"sgpb-popup\"]",".fadInleft_ads",".Add img","#left-top-holder,\n.ad-left-holder","#right-holder","#body_ad,\n.ad728-top,\n.localads,\ndiv[class^=\"ad-block\"]",".add-336x280",".wpb_content_element > .wpb_wrapper",".dt-dynamic-banner-holder-others-dt","#media_image-1,\n.footer-right-widget",".elementor-widget-text-editor","img[alt=\"weblogs\"]:not([src*=\"coronavirus_up\"])",".lnw-ad","#text-51",".Ad-box-jana",".icici","#panel-38-0-1-1,\n.vmagazine-lite-medium-rectangle-ad",".mom_contet_e3lanat",".elementor-element-4f2ae98,\n.elementor-element-e9b9b10,\n.elementor-location-single .size-large",".Ad-Section,\n.google-ads-banner",".MR300250",".sub_new:not(.sss)",".elementor-popup-modal,\n.elementor-widget-sidebar",".lrads","a[href*=\"nilport.net\"] img",".av_block,\n.gofollow","#spc-ads,\n.ti-ads",".onads",".ad-spaces",".dk_only,\n.mob_only,\n.pj-ad-card","section.widget_media_image:not(#media_image-2)",".flexslider-eid",".post-wrap.post .sidebar .widget_text",".top_ads_home",".single_page_ad","#penci_custom_html-3",".logo-banner .pull-right","#content_add,\n.right_part div[style^=\"float:left;\"]","#HTML40,\n#HTML42,\na[href*=\"facebook.com\"] > img,\na[href*=\"goo.gl/\"] > img","a[href*=\"reviewmaster.info\"]",".td-footer-wrapper aside.widget_text img,\n.td-ss-main-sidebar > .widget_text",".hmBlock2ColRSec3","main .py-0 center img","[alt*=\" ad\"]",".Amain,\n.R300100","div[id^=\"vijay-\"]","#adOrGretings",".Image,\n.featuredposts,\ncenter > img[style=\"margin-top:20px;\"]",".sidebar > .widget_media_image",".ghont-ksrm-bottom",".ad3,\n.ad4,\n.spad","#bxnzmefcd-3",".wp-widget-group__inner-blocks",".d-ad,\ndiv[class*=\"banner\"]",".banner_right",".site-footer .widget_text",".advt-widget",".addSecound-sidebar","#layerslider_1,\n.content-inner img.size-full","div[class*=\"cs-banner\"]",".code-block-15 div:nth-child(3),\n.code-block:not(.code-block-15),\n.wp-image-31222,\n.wp-image-3732","#common_top_right_1,\n#mid_level_3_after,\n#news_ticker",".addCenter","div[id^=\"livet-\"]","div[id^=\"AS_O_LHS_\"] > div:nth-child(-1n+6)",".topaddsctn",".widget_media_image:not(#media_image-20)",".left_level_1",".adSlides,\na[href*=\"niet.uk\"] img",".prettyphoto","div[style*=\"float:left; width:100%; \"]",".custom-ads-row,\ndiv[style^=\"width: 728px; height: 90px;\"]",".content_section .to-be-async-loaded-ad","div[class*=\"width-ad\"]",".td-a-rec img:not([src*=\"Whatsapp-Strip-scaled-\"]),\na[aria-label=\"728×90\"],\ndiv[id^=\"vasun-\"]",".vv_advst","div[id^=\"vision-\"]","img[src*=\"ad_files\"],\ntable[height=\"100\"]:has(> tbody > tr[bgcolor]),\ntable[width=\"1000\"]:not([cellpadding])","[class*=\"  ad-\"]",".breaking-news-area.mt-15",".addc img",".banner-slider",".adda",".top-right-ads","section:has(> div > .advimg)","div[aria-label*=\"-Advt-\"],\ndiv[aria-label*=\".gif\"],\ndiv[aria-label=\"27.jpg\"],\ndiv[aria-label=\"30.jpg\"],\ndiv[aria-label=\"31.jpg\"],\ndiv[aria-label=\"Auction \"],\ndiv[aria-label=\"Banner-2.jpg\"],\ndiv[aria-label=\"Inder Lyn-19 June 2020-2.jpg\"],\ndiv[aria-label^=\"HSB-\"],\ndiv[aria-label^=\"Love-Punjab-\"],\ndiv[aria-label^=\"Mandy-Gur\"],\nnav + div",".slides",".blog-sidebar .widget_custom_html",".penci-infeed_ad",".elementor-widget-image-carousel,\nsection[data-id=\"9a0f91e\"]","#media_image-44",".entry-content > p img:only-child","body > .container > .row:first-child > div:last-child","#attachment_10957,\n#attachment_11499,\n#attachment_11653,\n#attachment_12010,\n#attachment_12428,\n#attachment_12691,\n#attachment_12880,\n#attachment_12945,\n#attachment_13381,\n#attachment_13529,\n#attachment_13539,\n#attachment_13549,\n#attachment_13929,\n#attachment_14460,\n#attachment_15074,\n#attachment_15085,\n#attachment_15191,\n#attachment_16388,\n#attachment_16691,\n#attachment_17141,\n#attachment_17329",".article-content h4 img","#right-sidebar .widget_sp_image",".mySlides2,\n.w3-section",".adver_banner,\n.theiaStickySidebar .ml-slider,\n.theiaStickySidebar .wpb_content_element",".lightwidget-widget",".single_featured_slide",".addd_banner","#HTML21","div[style=\"margin-top:-10px; text-align:center;\"] span",".bannertopimg,\n.bannertopimg2",".ty-trigger,\nbody ~ iframe",".vc_custom_1546328500609","div[data-adid]:not([data-adid=\"49911\"])",".chand-before-content_5,\n.chand-widget,\n.widget_viral_advertisement",".t-out-span",".single_dtails img","body > [class$=\"ads\"]","div[style=\"height: 250px;\"]","iframe[style*=\"height: 90px\"]","#widget_623,\n#widget_871","center > a[target=\"_blank\"]",".tdi_66","div[class*=\"bnner\"]","#content1-5 .lead > div:nth-child(1n+2) img",".ad-ticker-right,\n.entry-content [data-position]",".roadblockpopup,\n.seithigalad",".zja",".wpb_wrapper aside.widget_media_image",".no-vigyapan-sidebar-section",".code-block > img,\nfigure.wpb_wrapper","#bunyad_ads_widget-9 > .widget-title",".mySlideBox,\na[href*=\"?ref=\"]","a[target=\"_blank\"] > img",".jeg_main_content .wpb_widgetised_column,\n.widget_jnews_module_element_ads",".vc_raw_html:not(.tdi_128)",".header_adv",".widget_text:not(#text-24)","#widget_sp_image-3,\n#widget_sp_image-7,\n.bwp_gallery,\n.sidebar-right","#thumbs,\n.add_inner_news,\n.news-add",".logoright,\n.nhsgallery","#slideshow2,\n#slideshow3","#module_03_ads300x250"];

const hostnamesMap = new Map([["indootimes.com.au",[0,1,2,3]],["dailysobujbarta.com",[0,836]],["htvpunjabi.com",[0,7]],["lankasudar.com",[0,867,1571]],["nationissue.com",[0,29,867]],["tamilstar.com",[0,1242]],["ekkhabar.online",[0,761,2983]],["biratnews24live.com",[2,574]],["minnambalam.com",2],["opennewsx24.com",2],["samacharplusjhbr.com",2],["thejoharnews.com",[2,114,916,2370]],["tirthchetna.com",[2,29]],["jilanazar.in",[2,2673]],["anweshanam.com",3],["arthosuchak.com",[3,144,326]],["atharvnews.com",[3,84,345]],["budaunamarprabhat.com",[3,618,619]],["nayanepalnews.com",[3,11,37,571]],["sajagindia.com",[3,11,2121]],["shramjeevijournalist.com",3],["therisingcampus.com",3],["thesadaknama.com",[3,11]],["vidarbhaapla.com",[3,11]],["wayanadvision.in",3],["malayaleepathram.com.au",4],["rozanakhabarnama.com.au",5],["suprovatsydney.com.au",[6,7]],["adhorekhit.com",[7,179]],["bd24views.com",[7,475,476]],["bdsomoyernews.com",[7,29]],["bnanews24.com",[7,29,440,443]],["chattogramsangbad.com",7],["currentcrime.com",7],["dailygazipuronline.com",[7,56,795]],["dailysatkhira.com",[7,832]],["deshbartabd.com",[7,11,56,565,909]],["doinikbarta.com",[7,29]],["epatrakar.com",7],["farmsandfarmer24.com",[7,365]],["filmnews24x7.com",[7,1084,1085]],["gtamilnews.com",[7,29,1167]],["hind24news.com",[7,1233]],["jharkhandlatestnews.com",[7,1377]],["kalakkalcinema.com",[7,985]],["madhyapradeshdarshan.com",[7,1221]],["manchitra24.com",7],["munshiganjnews.com",[7,365]],["mysanchar.com",[7,376]],["nayapusta.com",[7,220,1774]],["newsbreathe.com",[7,1843]],["paathoknews.com",[7,1940]],["propunjabtv.com",7],["pujibazarexpress.com",7],["sabrangsamachar.com",7],["sajhaonlinekhabar.com",[7,2123]],["smsofup.com",7],["tamilscreen.com",[7,22,161]],["todaynp.com",7],["voiceofpanipat.com",[7,51]],["alamkikhabar.in",[7,909]],["krushival.in",7],["udaipurnews.in",[7,480,1136]],["bdnews.live",[7,56]],["newspost.live",[7,11,29]],["vidivelli.lk",7],["dainikazadi.net",[7,11,232,2893]],["abcb.news",7],["politalks.news",[7,11,29,51]],["1news.com.bd",8],["alochitokantho.com.bd",9],["jamalpurlive.net",[9,29]],["barendraexpress.com.bd",10],["binodonbichitra.com.bd",[11,12]],["protidinerkatha.com.bd",11],["techsangbad.com.bd",11],["gujaratnewsline.ca",11],["therepublicantimes.co",11],["touringtalkies.co",11],["247superfast.com",[11,78]],["aadarshhimachal.com",[11,29,108,109]],["aapkiummid.com",[11,136]],["abitfar.com",[11,154,155]],["actionpunjab.com",11],["aeznewschannel.com",11],["ajkerrajshahi.com",11],["allnewsgo.com",11],["alorkantho24.com",11],["aloron71.com",11],["amaderbharat.com",[11,56]],["amansavera.com",[11,251]],["amchimumbaionline.com",11],["angindianews.com",[11,280]],["azadexpress.com",11],["bdcurrentnews24.com",11],["bdsportsnews.com",11],["bdtimesnews.com",[11,495]],["beanibazarview24.com",11],["bengalreport.com",11],["bharatupdate.com",11],["bhilaitimes.com",[11,532,533]],["bhojpurilive.com",11],["bholanews.com",[11,108,541]],["bihardainik.com",[11,46]],["bilaspurlive.com",[11,571]],["boltauttarakhand.com",[11,605]],["brajeshkibaat.com",[11,227]],["breakingnewz24.com",11],["breakingtube.com",11],["britbangla24.com",11],["britishbanglanews.com",11],["buxarkhabar.com",[11,166,626]],["capitalmailnews.com",11],["chanakyanewz.com",[11,661]],["chandaulitimes.com",11],["charchitbihar.com",11],["chetaktimes.com",[11,69,459,693,694]],["chitralekha.com",11],["chothale.com",11],["cinevinodam.com",11],["citymailnews.com",[11,728]],["coastal-mirror.com",[11,739]],["corporatebarta.com",11],["corporatesangbad.com",11],["countrynewstoday.com",11],["crimecitynews.com",11],["crimecontrolnews.com",11],["crimeonusondhan.com",11],["ctgnews.com",[11,767]],["daily-khabar.com",11],["dailyamarsomoy.com",11],["dailynewsservices.com",11],["dailypurbomoy.com",11],["dailysharebazar.com",[11,834]],["dailysomoyersomikoron.com",[11,154,838]],["dailytimesbangladesh.com",11],["dainikup.com",11],["dakpeon24.com",11],["deshpratidin.com",11],["devbhoomisamvad.com",11],["digitalmalayali.com",[11,154,946]],["digitalmalayalionline.com",[11,154,947,948]],["dishabhoomi.com",11],["doinikbarta24.com",11],["bangla.earthtimes24.com",11],["echitwanpost.com",[11,1002]],["educationoverall.com",11],["ehapurnews.com",[11,74,1010]],["ejalakam.com",11],["ekattorbangla.com",11],["ekattorer-kotha.com",11],["ekushershokal.com",[11,280,476]],["emedialine.com",11],["emissionkhabar.com",11],["epradeshtoday.com",11],["epunemetro.com",[11,940]],["fatafatnews.com",[11,89,351]],["firstsuddi.com",11],["frontline24.com",[11,90,623]],["globalprabhat.com",11],["golmalnews.com",11],["goraynews24.com",11],["greenkeralanews.com",11],["guruvayooronline.com",[11,1176]],["gyandarpan.com",11],["haftavasool.com",11],["himachalbreaking.com",11],["himachalplus.com",[11,1220]],["hindnewsservice.com",11],["hindukhabar.com",[11,74]],["hindustanaaj.com",11],["hnewsraftaar.com",11],["hosadigantha.com",11],["inanewsagency.com",11],["inayam.com",[11,50]],["indiancinemagallery.com",11],["indianobservers.com",11],["indnewsdaily.com",11],["innuonline.com",11],["irinjalakuda.com",[11,985,1312]],["jaibharattv.com",11],["jangathatimes.com",[11,1355]],["jharkhandvarta.com",11],["kalamerajasthan.com",11],["kanlishnews.com",[11,940]],["kannadavahini.com",11],["karavaldaily.com",11],["karudannews.com",11],["khabardigital.com",11],["khabarexclusive24.com",11],["khabarliveindia.com",[11,1489]],["khaboronline.com",[11,1504]],["khabreapki.com",[11,1507]],["khabredinraat.com",11],["kharinews.com",[11,29]],["khaskhobor.com",11],["kheldhaba.com",[11,74,681,1516]],["khobor71.com",[11,1518]],["kholabarta24.com",11],["khulnatimes.com",[11,351]],["kirandoot.com",[11,1528]],["kochivattom.com",[11,1534]],["kohramlive.com",[11,56]],["kolkatatimes24.com",11],["krantimission.com",11],["kushinagarlive.com",[11,1555]],["lalitatimes.com",11],["lalsobujerkotha.com",11],["lawyerteluguweekly.com",11],["leaksin.com",11],["lightlinesnews.com",11],["localindore.com",[11,29]],["lokjantoday.com",11],["lokpaksh.com",[11,940,1599]],["lokshahilive.com",[11,74]],["madhyamat.com",11],["mahanaad.com",[11,993]],["maithilijindabaad.com",11],["malayalimanasu.com",[11,860]],["mangalorean.com",[11,1652]],["manobshongbad.com",11],["matopath.com",[11,29,1348]],["mayanewz.com",11],["media4support.com",11],["mera-uttarakhand.com",11],["metrofuturenews.com",11],["mihinews.com",11],["morekhabar.com",11],["moviemirchi24.com",11],["muhimmathonline.com",11],["muldharnews.com",11],["myagdikali.com",[11,948,1717]],["mynewswings.com",11],["nachiketalive.com",11],["nalanda-news.com",[11,29]],["narayanganjsangbad.com",11],["nayesubah.com",[11,1776]],["nepalpostdaily.com",[11,715,1801]],["nerkazhcha.com",11],["news15india.com",11],["newsatnet.com",11],["newsics.com",11],["newspitara.com",11],["newsstudio18.com",11],["nichod.com",11],["nirikhyaka.com",11],["nishanknews.com",11],["no2politics.com",11],["ntvtelugu.com",[11,1907]],["onakhabar.com",11],["onegujarat.com",11],["orbittimes.com",11],["ournews24.com",[11,154,860]],["pahadirajya.com",[11,29]],["pathanamthittamedia.com",[11,74]],["patuakhalipratidin.com",11],["pniindia.com",[11,1980]],["popular24news.com",11],["positivekhabar.com",[11,940]],["prabhattimes.com",[11,154,1995]],["pradeshsanchar.com",[11,154]],["prahaarkonkan.com",11],["prasthutha.com",[11,2008]],["pratidindaily.com",[11,43,154]],["pravakta.com",11],["pravasiexpress.com",11],["pravasishabdam.com",[11,2016]],["progoti24.com",11],["provatnews.com",11],["pudhuvaioli.com",11],["punjabmailusa.com",11],["purbobarta.com",11],["purwanchaldaily.com",11],["raigarhtopnews.com",[11,154,2058]],["rajasthanlive24x7.com",11],["ranbheri.com",11],["raozantimes24.com",11],["rashtriyapatrika.com",11],["rastriyakhabars.com",[11,2076]],["reporter24x7.com",11],["rightnewsindia.com",11],["roundupkerala.com",11],["rozanabhaskar.com",11],["samacharup.com",11],["samayviews.com",[11,2149]],["samriddhasamaj.com",[11,376]],["samvadjanhvi.com",11],["sandhesam.com",11],["saranshtimes.com",11],["sarhadkasakshi.com",[11,940,1066]],["saurashtrakranti.com",11],["shadhinalo.com",[11,56,1284,1915]],["sharpbharat.com",[11,74,2217]],["sheeshanews.com",11],["sherpurnews24.com",11],["shreesamachar.com",11],["sindhudurglive.com",11],["skynewspunjab.com",[11,154]],["smarthulchal.com",11],["srnewsgroup.com",11],["starlivenews.com",[11,51]],["subhartimedia.com",11],["suddinews.com",[11,74]],["swatvasamachar.com",11],["swaviman.com",[11,445]],["sylhet-tribune.com",11],["taazaanews.com",11],["tahalka24x7.com",[11,1118,2303]],["takshaktv.com",11],["tatkalsamachar.com",[11,860]],["telugumirchi.com",11],["telugupopular.com",11],["theappealnews.com",11],["thebandhu.com",11],["theexclusivestory.com",[11,154,1276,2365]],["thenewsmirchi.com",[11,859]],["theprobashi.com",11],["thepunchlineexpose.com",11],["thestellarnews.com",[11,2387]],["timeofrajasthan.com",11],["tmnewshub.com",11],["torrongonews.com",[11,154,605,860]],["tvindiaplus24.com",11],["uddoktabarta.com",11],["ujjwalduniya.com",11],["ujjwalhimachal.com",[11,940]],["ujyalokhabar.com",[11,2439]],["unitednews24.com",11],["usamibanglanews.com",11],["usmalayali.com",11],["uttarakhandnews24.com",[11,2460]],["uttarakhandreport.com",11],["uttaranchaltoday.com",[11,993]],["vaartavali.com",[11,479]],["vannibbc.com",11],["vartavani.com",[11,605]],["vavuniyanet.com",[11,2474]],["vidarbha24news.com",[11,2027]],["vijayasakshi.com",11],["vinnobarta.com",11],["vision2020news.com",[11,1009]],["voiceofjhabua.com",11],["voiceoflucknow.com",11],["vtvvitla.com",[11,56,192,2495]],["webkhabar.com",11],["youthindiatoday.com",11],["youthmukam.com",[11,2516]],["zillakhabar.com",11],["bdnews.global",11],["24indiatv.in",11],["agrabharat.in",11],["atulyabharat.in",[11,154]],["bdindianews.in",11],["breakingmalvani.in",11],["firsteyenews.co.in",[11,2585]],["muzaffarnagarbulletin.co.in",11],["newstrust.co.in",11],["salaamindia.co.in",11],["samaysakshya.co.in",[11,56]],["uknews.co.in",11],["crimestory.in",11],["dbnews24.in",11],["digitalbharatnews.in",[11,154]],["divyasandesh.in",11],["dotnews.in",11],["dtw24news.in",11],["entertainmenthub123.in",11],["goodmorningnews.in",11],["hind24tv.in",11],["hindimedia.in",[11,2644]],["i7news.in",11],["indiapublickhabar.in",11],["ivtv.in",11],["jharkhandnewsexpress.in",11],["justkannada.in",11],["khabarbhatapara.in",[11,1915,2676]],["khabor24.in",[11,2679]],["marudharbulletin.in",11],["mediawala.in",[11,56]],["newsfact.in",[11,74]],["newsncr.in",[11,2005]],["newstodayupdate.in",11],["odishanews24.in",[11,154]],["page3news.in",11],["prajapaksham.in",11],["prathidina.in",11],["pulse365.in",[11,29]],["punjabibulletin.in",11],["punjabisath.in",11],["raigarhnews24.in",[11,29]],["rajdhanisandesh.in",11],["rashtravadinews.in",11],["rastranews.in",11],["regnews.in",[11,2764]],["samacharseva.in",11],["samastipurtoday.in",11],["sangodnews.in",11],["tajavarthalu.in",11],["theangle.in",11],["thedeoriatimes.in",[11,860]],["therealtruth.in",11],["timeshindi.in",11],["trendingnewsindia.in",[11,1915]],["twnews.in",11],["vishalindia.in",11],["wishavwarta.in",[11,2827]],["newshunt.info",11],["samachar24.live",11],["the4thpillar.live",[11,29]],["trendingnewshindi.live",[11,2844]],["anidda.lk",11],["dailyceylon.lk",[11,860]],["divaina.lk",[11,2556,2851]],["mawbima.lk",[11,251,353]],["news7mannar.lk",[11,12]],["smartlady.lk",[11,2866]],["sportstoday.lk",11],["makkalosai.com.my",11],["avadhtimes.net",11],["chennaicitynews.net",[11,154,2889]],["cplusbd.net",[11,98]],["newsdarpan.in.net",11],["insaf24.net",11],["jagrukjanta.net",11],["kalaipoonga.net",[11,2889]],["lankanewsweb.net",[11,993,2907]],["news39.net",[11,50,56]],["newstelugu.net",11],["thamilkural.net",[11,29]],["24ghonta.news",[11,789,2944]],["aks.news",11],["blive.news",11],["hastakshep.news",11],["impactvoice.news",11],["up.news",11],["chitwanpost.com.np",11],["kuksamachar.co.nz",11],["news27.org",[11,605]],["rajputektamission.org",11],["cctvonline.tv",11],["jk24x7news.tv",[11,3010]],["mytvbd.tv",11],["news24nepal.tv",11],["tatwamayi.tv",11],["tsnews.tv",11],["thelondontimes.uk",[11,940]],["aksherpati.com",12],["apnashaharnews.com",[12,308]],["chandpurtelevision.com",12],["citypokhara.com",12],["damaulionline.com",[12,379,889]],["eveningkerala.com",[12,367,1059]],["hatmakhabar.com",12],["infokhabars.com",12],["janasongjog.com",12],["jonotaradalot.com",[12,416]],["jonotatv.com",12],["kalernatunsangbad.com",12],["madhyabindu.com",12],["mymensinghpratidin.com",[12,1724]],["newssarakhon.com",12],["newzzdeskkannada.com",[12,1561]],["prasashan.com",[12,735]],["ratnagirikhabardar.com",12],["sansanisurag.com",[12,1313]],["sehattimes.com",[12,15,29,2205]],["tirhutnow.com",12],["unveilnewser.com",[12,29]],["beforeprint.in",[12,74]],["darbhangacity.in",[12,29]],["namastepurvanchal.in",[12,1221,2714]],["omexpress.in",[12,51,1369]],["dainikkushtia.net",12],["update24.net",12],["newswings.online",[12,2986]],["canvasmagazine.com.bd",13],["cholomanjobab24.com.bd",[14,15]],["badaunexpress.com",[14,315]],["firstnewsbd.com",14],["bdjournal365.com",15],["bdlawnews24.com",[15,358]],["belagavisuddi.com",[15,506]],["chalonbeelbarta.com",15],["dainikaamsabha.com",[15,29]],["indoasiantimes.com",[15,29]],["jagatbhumi.com",[15,50,1318]],["jamunanewsbd.com",[15,98,206,1336]],["janjagranmediamanch.com",15],["jansaamna.com",[15,1247]],["kasaragod.com",[15,1437]],["nationalwartanews.com",[15,1751]],["news10india.com",[15,29,51]],["newsjungal.com",15],["parbatyachattagram.com",[15,516,564]],["pratidinertottho.com",15],["purvanchalnews.com",[15,29,1247]],["sarkarimanthan.com",[15,51,114]],["shabddoot.com",[15,838]],["shauryatimes.com",[15,29]],["sonalichandpurnews.com",15],["thecgnews.com",15],["thelastpagenews.com",15],["tosnews.com",[15,114]],["weeklyhajiganj.com",[15,2499]],["ghazipurkhabar.co.in",[15,200,2586]],["punjabnewslive.co.in",[15,366,2605]],["news85.in",[15,114,345]],["livesamachar.live",[15,51]],["ceylonradio.co.uk",[15,3025]],["corporatenews.com.bd",16],["currentnews.com.bd",17],["dailysunshine.com.bd",18],["arthasansar.com",[18,319,320]],["dainikbangla.com.bd",19],["newsbangla24.com",19],["edunews.com.bd",[20,21]],["mppost.com",21],["newslive24x7.com",[21,53,120,360]],["sarthakprayash.com",[21,120]],["glimeindianews.in",[21,53,120,2633]],["hajjnews.com.bd",22],["24hnbc.com",[22,79]],["alokitokhobor.com",22],["alokitoshitalakha.com",[22,244]],["asianmetronews.com",22],["bartakontho.com",[22,453]],["bn.bd24report.com",[22,473,474]],["chapainews.com",[22,40]],["comilla71tv.com",22],["coxsbazarpost.com",22],["crimeexpressbd.com",[22,400]],["dailyganomukti.com",22],["dakshinsunamganj24.com",22],["firlive.com",[22,1088]],["globalmalayalam.com",[22,1133,1134]],["kanchanjanghaonline.com",[22,1263]],["khobor24ghonta.com",[22,1517]],["malayaleevision.com",[22,1644]],["nabajug.com",[22,244]],["narsingdijournal.com",22],["postpati.com",[22,1989]],["puthithu.com",[22,2054]],["safalkhabar.com",[22,284,2116]],["sajhasabal.com",[22,2124]],["satkhiratoday.com",[22,206]],["seskhobor.com",22],["sylheterchakrirkhabar.com",[22,2298,2299]],["sylhetprothidin24.com",[22,2022,2300]],["odia-ray.in",[22,2742]],["tezsamachar.in",[22,2793]],["jonaki.tv",22],["ittefaq.com.bd",23],["manobkantha.com.bd",24],["meghnanews.com.bd",25],["bandarbanpratidin.com",[25,98]],["bijoykantho.com",[25,98]],["bonggonews.com",[25,606]],["channelcox.com",[25,673]],["chitrarpar.com",25],["crimebd.com",25],["dailyajkersurjodoy.com",[25,98]],["dailyapashinkantha.com",[25,98]],["dainikdeshbarta.com",25],["dainikdesherkotha.com",25],["dainiksomoyerbangladesh.com",[25,98]],["dakhinbongonews25.com",25],["deshprotidin.com",[25,98]],["doiniksabujbiplob.com",25],["faridpursamachar.com",25],["gabtalisangbad.com",[25,98]],["jagannathpur24.com",25],["jagratajanata24.com",[25,98]],["kansatnews24.com",[25,74,98]],["kholahawa24.com",25],["meherpurpress.com",25],["mvoice24.com",25],["newsbijoy.com",25],["newsvob.com",25],["nirjatitonewsbd.com",25],["onnodristy.com",25],["pabnamail24.com",25],["paharechok.com",25],["prbnews24.com",25],["protisomoy.com",25],["quicknewsbd.com",25],["satkhiratimes24.com",25],["sherpurtoday.com",25],["shubhoprotidin24.com",[25,155,2235]],["unlimitednews24.com",25],["updatebarta24.com",25],["vinnabarta.com",25],["haor24.net",25],["satkhiraprotidin.net",25],["bdgaibandha.news",25],["mna.com.bd",26],["nnb.com.bd",27],["evisionnews.co",[27,67,68,69,70]],["coverageindia.com",[27,747]],["digitalindia18.com",27],["gidhaur.com",[27,68,70,590,1127,1128]],["gzpnews.com",[27,459]],["liveaaryaavart.com",[27,459,545,798]],["madhepuratimes.com",[27,67,68,69,70,459,589,590,693,1128,1553,1614,1615,1616,1617,1618]],["malabarflash.com",[27,67,68,69,70,165,459,590,693,1553,1618,1636,1637]],["shaharaman.com",[27,586]],["siyanenews.com",[27,459]],["thattungal.com",[27,67,68,69,70,164,394,458,459,589,590,693,1128,1553,1614,1615,1618,1797,2353,2354]],["unmaikal.com",[27,184]],["vanniexpressnews.com",[27,590,693,1618]],["vijaytimes.com",[27,70]],["99samacharexpress.in",[27,165,461,545,2528]],["hamaramahanagar.in",[27,184,459,590,1553,1618]],["pinkcitynews.in",27],["thetodaytimes.in",27],["dth.news",27],["probashbd.news",[27,69]],["parthokko.com.bd",[28,29]],["news19tv.com",[28,161]],["sftv.com.bd",[29,36,37]],["janamitra.co",29],["18newsrajasthan.com",29],["24x7cg.com",[29,91]],["6pmnews.com",29],["aagaazfirstnews.com",[29,111]],["adeventmedia.com",29],["agraupdate.com",[29,192]],["ajkerbd24.com",[29,204]],["alertchhattisgarh.com",29],["alokitonewstv.com",29],["amarvaani.com",29],["amitrekha.com",29],["anewsoffice.com",[29,279]],["antarkatha.com",[29,74]],["apanderanews.com",[29,301]],["apkhabar.com",[29,302,303,304]],["apnapradesh24x7.com",[29,306]],["apnarajya.com",29],["arthakoartha.com",29],["arthanepal.com",[29,40]],["aslipunjabi.com",29],["attariyaonline.com",[29,348,349]],["azhimukham.com",[29,74,378,379]],["badauntoday.com",[29,51]],["balliakhabar.com",[29,391]],["balliakibat.com",[29,392]],["bangladaily24.com",29],["bantwalnews.com",[29,436]],["bhadas36.com",[29,120]],["bharatjan.com",[29,176,520]],["bharatsarathi.com",[29,89]],["bolozindagi.com",29],["breakingaajtaknews.com",29],["business24bd.com",29],["cgfrontline.com",[29,645]],["cgmetro.com",29],["cgnama.com",[29,51]],["cgwall.com",[29,51]],["chamolitimes.com",[29,176,523]],["chandrikadaily.com",29],["chauthiduniya.com",[29,690]],["chennairoyalcinema.com",29],["chirfar.com",29],["cibindianews.com",[29,51,166,710,711]],["comillarbarta.com",29],["communistonline.com",29],["countryinsidenews.com",[29,745,746]],["crichindinews.com",29],["crimenewstv24.com",[29,760,761]],["dailyalokitovor.com",[29,781,782]],["dailynagorik.com",29],["dailysatnadee.com",[29,51]],["dainikbhaskarup.com",[29,120,218,846]],["dainikjayantnews.com",[29,74,612]],["dainikkhabarlayehain.com",[29,51,176]],["dainikvatibangla.com",[29,206,882]],["dakhalchhattisgarh.com",[29,74,884]],["damaulinews.com",29],["daysbulletin24.com",[29,120]],["deshantor.com",29],["devbhoomiaajtak.com",29],["devbhoomidarshan17.com",29],["devbhoomimedia.com",[29,120]],["dhorpatannews.com",[29,51,331]],["digitalkhabar.com",[29,944]],["divyaindianews.com",[29,120]],["diyopost.com",[29,972]],["doiniksokalerbarta24.com",29],["envazhi.com",[29,1049]],["eratokhabar.com",[29,1051]],["expressherald.com",29],["fastsamachar.com",29],["fatehnagarnews.com",[29,50,266,996,1071]],["gadhsamvedna.com",[29,176,469,1065]],["galaxyinformer.com",[29,1103]],["galaxykhabar.com",29],["gandakichhadke.com",[29,303,1106]],["gayamahanagar.com",[29,51]],["grenonews.com",[29,688,1166]],["haikaravali.com",[29,850]],["haryanabhaskar.com",29],["hindustanabtak.com",29],["hindxpress.com",[29,53,120]],["historydekho.com",29],["ideatvnews.com",[29,1278]],["indianlooknews.com",29],["janatarsomoy24.com",29],["jansandesh.com",29],["jayakesarionline.com",29],["jharkhandupdates.com",29],["jivikatoday.com",29],["jjvnews.com",29],["jonopotro.com",[29,529]],["kageshworikhabar.com",[29,1396]],["kakakhabarilaal.com",[29,37,120,872]],["kalikadainik.com",[29,1407]],["kanakaikhabar.com",29],["kanakaionline.com",[29,74,167,1419]],["kanjirappallyreporters.com",[29,74,1420]],["kannadanewsnow.com",[29,74,147,167,790,1423]],["kanodnews.com",[29,1427]],["kantipath.com",[29,1428]],["keralanewz.com",29],["khabarok.com",[29,620,1494]],["khabarwithcover.com",[29,147]],["khulnanchal.com",[29,43]],["koshidarpan.com",[29,147]],["lambasafar.com",29],["livenarayanganj.com",29],["liveskgnews.com",[29,176]],["lokpukar.com",[29,1601]],["makkalmurasu.com",[29,1313]],["mangalamnewsonline.com",29],["manoranjansansar.com",29],["margarekha.com",[29,1665]],["mariahulive.com",[29,1666]],["meddlingmedia.com",29],["mediasaheb.com",[29,369,654]],["merabharatnews.com",29],["meruraibar.com",29],["moviewingz.com",[29,50,1084,1703]],["mussoorieaajtak.com",29],["nagarikbahas.com",[29,1148]],["nayabimarsha.com",29],["nepalface.com",[29,40]],["nepalmanch.com",[29,1795]],["nepalpostdainik.com",[29,1802]],["news129.com",[29,336,1820]],["news13tv.com",29],["news1hindustan.com",[29,61,620,1827]],["newscricket24.com",29],["newsfry.com",29],["newsglobalbd.com",[29,1856]],["newskadaba.com",[29,1859]],["newsplus21.com",29],["newsxindia.com",[29,1886]],["npbharat.com",29],["odisha24.com",29],["oktelugu.com",[29,476]],["onlinejalandhar.com",[29,812]],["otvnepal.com",29],["pahadsmachar.com",29],["parvasinewspaper.com",[29,50,1178]],["parvatanchal.com",[29,531,1960]],["paschimnepal.com",[29,1964]],["prabhatmantra.com",29],["pradeshmedia.com",29],["pradeshonlinekhabar.com",[29,51,170]],["pressbangla24.com",[29,37,990]],["primepunjab.com",[29,90]],["prothomshomoy.com",[29,55,445]],["pujibazarreport.com",[29,2035]],["punjabenews.com",29],["rajsattapost.com",[29,74,176]],["rashtrabodh.com",[29,46,2071]],["rashtratimes.com",[29,90]],["readertimes.com",29],["rghnews.com",[29,51]],["roytarsnews.com",29],["rubarunews.com",[29,66]],["sachkasafar.com",29],["sadaksanchar.com",29],["saiviswateja.com",29],["sajhabisaunee.com",29],["samachaarindia.com",[29,51]],["samacharhouse.com",[29,2130]],["samacharkyari.com",29],["samarsaleel.com",[29,1159]],["sancharbani.com",29],["sankhnaad.com",[29,176,2183]],["satkhiravision.com",29],["satyadeepsandesh.com",[29,1794]],["sb24live.com",[29,51]],["sbdnews24.com",[29,476]],["seemanchalnews.com",29],["setoghar.com",[29,40]],["sheershasangbad.com",[29,37,444]],["sikhvirsa.com",29],["sitakundabarta.com",[29,147,1282]],["sonipat24.com",29],["southasia24x7.com",[29,1248,1452]],["starvrutta.com",[29,375,2270]],["subanetha.com",29],["sunehradarpan.com",[29,51,176]],["sunokhabar.com",29],["sylhetnewstimes.com",[29,51]],["tamilankural.com",[29,2307,2308]],["tamilcinetalk.com",[29,129,829]],["tamilnews.com",[29,51,154]],["tatviknews.com",[29,111,2330]],["tejastoday.com",[29,2339]],["theamplenews.com",29],["thefourthmirror.com",[29,2366]],["theguptchar.com",[29,218,1736]],["theindiarise.com",29],["thelucknowtribune.com",[29,1198,2373]],["todaybhaskar.com",[29,2410]],["todaypati.com",[29,2413]],["tv36hindustan.com",[29,37,621]],["ujyaalonetwork.com",[29,303]],["ukpkg.com",[29,2442,2443]],["upantaodisha.com",[29,90]],["uttarakhand24news.com",29],["uttarakhandmedia.com",29],["vaanishreenews.com",29],["varthamanam.com",[29,2472]],["vedantbhoomi.com",[29,2476]],["vishwakarmakiran.com",[29,37,90]],["vision4news.com",[29,122,670]],["vivegamnews.com",29],["vvtuk.com",29],["aamaadmi.in",[29,89]],["balliakhabar.in",29],["bharatsamachartv.in",[29,120,2558]],["cgujala.in",[29,53,120,2571]],["chirantannews.in",[29,74]],["alivenews.co.in",[29,2158,2276,2578]],["andbiharnews.co.in",29],["expressindian.co.in",[29,2584]],["indianewsviral.co.in",[29,74,167,974,2588]],["newsdna.co.in",[29,176]],["rainbownews.co.in",[29,176]],["yashbharat.co.in",29],["currentnewz.in",[29,50]],["dharmyaatra.in",29],["dhunga.in",[29,2623]],["doonited.in",[29,2627]],["epaperindia.in",[29,854]],["gauravnews.in",[29,176]],["gionews.in",29],["hamariawaz.in",29],["hindmorcha.in",[29,120,2645]],["indiansamachar.in",29],["jagouttarakhand.in",[29,176]],["jaihindtimes.in",[29,276,2665]],["khabarbihar.in",[29,1492]],["lokalok.in",[29,90,2695]],["lokshakti.in",29],["nacnews.in",29],["nationupdate.in",[29,53,120]],["newshindustan.in",[29,2724]],["newsi.in",[29,237,2727]],["newsportals.in",[29,111,872]],["odiabarta.in",[29,469,1845]],["parmantimes.in",[29,2747]],["sabsach.in",[29,1028,1313]],["samachardoot.in",[29,890,2501]],["samaydarshan.in",[29,2769]],["shaheedokonaman.in",[29,51,176]],["tajakhabar.in",[29,176]],["tarunchhattisgarh.in",29],["thecritic.in",[29,2794]],["theruralpress.in",[29,2802]],["thetruths.in",[29,89]],["vijayapatha.in",[29,713,1472]],["zaptang.in",29],["ziotamil.in",[29,51,761]],["bhojpurimasala.live",29],["nkdigital.live",29],["newscut.lk",[29,2860]],["newsplus.lk",29],["puthusudar.lk",29],["dainikchattogram.net",[29,2894]],["panjabilok.net",29],["songbadsaradin.net",29],["voiceofuttarakhand.net",[29,176]],["abhitak.news",[29,120]],["asr24.news",29],["bangladeshmail.news",[29,860,2947]],["newindiatimes.news",[29,369]],["jugerbarta.online",[29,522,2388]],["eksandesh.org",29],["expressnewslive.tv",[29,176]],["news71bangla.tv",29],["pavilion.com.bd",30],["pundrokotha.com.bd",31],["redtimes.com.bd",32],["bihardailynews.com",[32,475]],["dailysylheterdinkal.com",32],["hipamat.com",[32,1253]],["sachetonbarta.com.bd",[33,34,35]],["asomkhobor.com",[33,334,335]],["ghaziabad365.com",[33,119,1122,1123]],["todayexpressnews.com",34],["apnepal.com",[36,309]],["dainikprime.com",36],["mirsarainews.com",36],["tamilcinemaz.com",[36,345,1084,2309]],["p2pnews.co",37],["bangla52news.com",[37,399]],["cgmitan.com",[37,122,445,597,648,649]],["citynewsindia.com",37],["e-barta247.com",37],["hindvatannews.com",[37,1252]],["jaljalakhabar.com",[37,40]],["jhunjhununewz.com",[37,1379]],["kundeshwartimes.com",[37,166]],["news4live.com",37],["newsnowbangla.com",[37,120,173]],["sabalpost.com",37],["samrudhaodisha.com",[37,1469,2155]],["shiftindia.com",37],["shreekanchanpath.com",[37,200,358,2232]],["vvnewsvaashvara.in",[37,1490]],["sylheterdak.com.bd",[38,39]],["dainiksylhet.com",[39,248,880]],["sylhetview24.net",[39,2932]],["unb.com.bd",[40,41]],["aayokhabar.com",[40,143,144]],["amaderorthoneeti.com",[40,246]],["anusandhan24.com",40],["arthadabali.com",[40,317]],["arthadaily.com",40],["ashakakiran.com",[40,331]],["baglungpost.com",40],["bd-pratidin.com",40],["biznessnews.com",[40,581]],["campuslive24.com",[40,631]],["chapaibarta24.com",[40,677]],["chhanbin.com",40],["dailymatobad.com",40],["dailynayadiganta.com",[40,815]],["dainikeenews.com",40],["dainiknewsnepal.com",40],["demokhabar.com",40],["desherkhabor24.com",40],["emalayalee.com",[40,1040]],["gandakilive.com",40],["globaltvbd.com",40],["gokarneshworonline.com",[40,331]],["gournadi24.com",[40,1155]],["heralokhabar.com",[40,1211]],["ichchhakamananews.com",[40,1277]],["indrenisamaj.com",40],["inextlive.com",[40,1305,1306]],["internetkhabar.com",40],["jagran.com",[40,1325]],["jhuthasach.com",40],["kalerkantho.com",[40,1406]],["kaligandakikhabar.com",40],["kamananews.com",[40,74]],["kantipurpati.com",40],["khabarcenter.com",40],["khabortv.com",[40,1505]],["kushtiatime24.com",40],["laligurash.com",40],["lekhajokhanews.com",[40,1578]],["livegandaki.com",40],["livehindustan.com",[40,1583,1584]],["mayurpati.com",40],["mediadabali.com",[40,380,1675]],["megakhabar.com",40],["motivatenews.com",[40,56]],["nagariknews.nagariknetwork.com",[40,1730]],["narayanganjprotidin.com",[40,98]],["nayasadak.com",40],["nepalesediaspora.com",[40,1784]],["nepalpana.com",40],["nepalraibar.com",40],["neptvnews.com",40],["newsbihani.com",40],["newsdeskkannada.com",[40,167,457,1849,1850]],["newsflash71.com",[40,1855]],["onlinedainik.com",40],["onlinepatrika.com",40],["palikanews.com",40],["paristamil.com",40],["pariwartankhabar.com",[40,318]],["punjabijagran.com",[40,1305]],["punjabstar.com",40],["reportersnepal.com",[40,192,735,2084]],["sajhapost.com",40],["samacharjagat.com",40],["samajikpatra.com",40],["sokalerkhobor24.com",[40,56]],["tamilan24.com",[40,1655]],["topnews24x7.com",40],["vichinthanamweekly.com",[40,79]],["webtvkhabar.com",40],["dainandini.in",40],["ibc24.in",[40,2650]],["peoplessamachar.in",40],["bdcnews.info",40],["jnewsbd.news",40],["womenscorner.com.bd",42],["colorsnewslive.com",42],["jogajog24.com",42],["khabar247.com",42],["newsbarisal.com",42],["rajbari.com",42],["sheershanews.com",42],["thepratyeknews.com",42],["lokwani.tv",42],["garavigujarat.biz",[43,44]],["insurancekhabar.com",[43,1310,1311]],["temalonline.com",43],["mediapunjab.biz",45],["mediapunjab.com",[45,1680]],["canadauthayan.ca",46],["24webnews.com",[46,89]],["angultv.com",[46,74,144]],["ausamachar.com",[46,354]],["mahadbd.com",[46,1627]],["smarthalchal.com",46],["rozanapost.in",[46,74,237]],["thehdnews.in",[46,2796]],["zamania.in",[46,2829]],["cknewsgroup.ca",47],["despunjab.ca",48],["bojrodhoni.com",[48,114]],["gandakivoice.com",[48,120]],["idp24news.com",[48,120]],["mahanagarkesari.com",48],["narailsangbad.com",[48,120,161]],["rudrakshnews.com",[48,114,195]],["shirshobindu.com",48],["urjanchaltiger.com",48],["neervely.ca",49],["ptcnetwork.ca",[50,51]],["abhibharat.com",[50,151,152]],["akkinikkunchu.com",50],["anaicoddai.com",[50,65,263,264,265,266,267,268,269,270,271]],["attachowk.com",[50,74,347]],["baghuabarta.com",50],["binodonnews24.com",50],["cinemasthi.com",[50,55]],["communitynews24.com",[50,345,670]],["currentkhabar.com",[50,151,772]],["dailymomenshahi.com",[50,151]],["gobikhobor.com",50],["hindi24news.com",[50,61,247]],["indokalingtimes.com",[50,84]],["jagprerna.com",[50,122,151,200,263,280,336,345,358,597,1030,1102,1324]],["joyparajoy.com",[50,974,1102]],["karmalamadhanews24.com",[50,84,372,519,667,1432,1433]],["komashisha.com",50],["maharashtradesha.com",50],["moviemandu.com",[50,151,200,1701,1702]],["pabilnews.com",[50,90,122]],["parichowk.com",[50,74]],["postpatrika.com",[50,1990]],["bangla.priyobandhu.com",50],["punjabbaani.com",[50,53,151,200,345,476,2037,2038,2039]],["punjabimaaboli.com",50],["republicbharatnews24.com",[50,623]],["samacharvaarta.com",[50,2134]],["vijaychowk.com",[50,74]],["yarlosai.com",[50,1178]],["bihar.express",50],["ccnnews24.in",[50,361]],["rninewsbihar.co.in",50],["jansamparklife.in",50],["udaipurnewschannel.in",50],["udayindiahindi.in",[50,480]],["cinesnacks.net",[50,2890]],["sidhakura.net",50],["1newsnation.com",51],["anokhateer.com",[51,287,288]],["apnaranglapunjab.com",51],["apnuuttarakhand.com",51],["awazrajasthanki.com",[51,370]],["bharatnewschannel.com",51],["cgtaik.com",51],["cgtop36.com",[51,114,195,653]],["ctn24.com",51],["dailysamvad.com",51],["dalhousiehulchul.com",[51,74]],["editorjee.com",[51,1005]],["goodnews-in.com",51],["gujjugully.com",51],["hadapsarexpress.com",[51,372,475,604]],["himalayandiary.com",51],["hinditechy.com",[51,53]],["indiavisionmedia.com",[51,686]],["joharlive.com",[51,178,1385,1386]],["journalistonlive.com",51],["kalkudahnation.com",[51,471,564]],["khabarbharat36.com",[51,74,147]],["khabarbhumi.com",51],["khabardarkhabar.com",51],["khabaristan.com",[51,1487]],["livereadernews.com",[51,53]],["lokbharat.com",[51,1592]],["magahinews.com",[51,564,1139,1370,1564,1624,1625]],["mbd24.com",[51,1671]],["mbmnewsnetwork.com",[51,167]],["missionsandesh.com",[51,1690]],["news127.com",[51,842]],["news24you.com",[51,120]],["newsbanglaa.com",[51,287]],["newsorbit.com",51],["pataka24.com",[51,120]],["purvanchalpost.com",[51,2052]],["quicklinenews.com",51],["ritambangla.com",[51,838]],["sangbadkonika.com",[51,53]],["swapnilbangladesh.com",51],["swarnimbharatnews.com",[51,2295,2296]],["tamilpadalvarigal.com",51],["tamilthisai.com",[51,2321]],["thehillsofmussoorie.com",[51,725]],["topchand.com",[51,2417]],["ujjawalprabhat.com",[51,120]],["vichareknayeesoch.com",[51,147]],["vishban.com",51],["voice4bihar.com",[51,2489]],["apnakhata.guide",51],["aavakaaya.in",[51,643]],["abtnews.in",[51,608]],["enews24x7.in",51],["headlineexpress.in",51],["khabriadda.in",[51,2680]],["livequicknews.in",[51,53,1000]],["manthannews.in",51],["news1today.in",[51,365,2720]],["newswayanad.in",[51,90,620,2734]],["nextkhabar.in",51],["palisirohionline.in",51],["polkhol.in",51],["priyanews.in",[51,287]],["todaysdigitalbreakingnews.in",[51,2808]],["satyamnews.net",51],["kannadavani.news",[51,2954]],["metroplus.online",51],["punjabiakhbaar.ca",[52,53,54]],["aaryaanews.com",[52,140]],["hkgnews247.com",[52,370]],["hindsat.in",[52,53]],["tararalo.net",52],["aapkimedia.com",53],["akjnews.com",[53,224]],["bangbandhupatrika.com",[53,120]],["banglarjanapad.com",[53,418,419]],["boguralive.com",[53,598]],["bombaysamachar.com",53],["bundelkhandsamachar.com",[53,312,620,621,622]],["chandinarsomoy.com",53],["charotarnoavaj.com",[53,120]],["cmgtimes.com",[53,120]],["cpnews24.com",[53,120]],["deshebideshe.com",53],["devbhoomilive.com",53],["ehapuruday.com",[53,115,120]],["globalecampus.com",53],["hamarahimachal.com",[53,114,120,287,1184]],["indiaedgenews.com",[53,370]],["internationalmalayaly.com",53],["janpadmirror.com",[53,120]],["jantaconnect.com",[53,1066]],["keralabhooshanam.com",53],["keralatimes.com",[53,1459]],["madawalaenews.com",53],["mbkhabar.com",[53,120,1000]],["metrojournalonline.com",53],["mpcgexpress.com",[53,120,1705]],["natunbarta.com",[53,195,1000]],["nayalook.com",[53,120]],["newssow.com",[53,120]],["newz24india.com",53],["northindiastatesman.com",[53,1000]],["panchagarhonline.com",53],["rewariupdate.com",53],["sabkasandesh.com",[53,1135,2107]],["saffronfactor.com",[53,120]],["shekhawatilive.com",[53,120]],["telegramnews24.com",[53,2341]],["thetadkanews.com",[53,120,195]],["thetimesofchhattisgarh.com",[53,1000]],["upcmnews.com",[53,1135]],["updatepunjab.com",[53,120]],["vinayavani.com",53],["wegwannews.com",[53,120]],["apnahimachalapnishaan.in",[53,84,787,1247,2549]],["bastarflame.in",53],["crimejasoos.in",53],["glibs.in",53],["indiaprimenews.in",[53,120,218]],["jabalpurdarpan.in",[53,2664]],["janmorcha.in",53],["justaction.in",53],["newsd5.in",[53,120]],["rajdhanitimescg.in",[53,114,1000,1126]],["rig24.in",53],["siddhamaruthuvam.in",[53,200]],["swatantraawam.in",53],["telegraphindia.in",53],["thehindkeshari.in",53],["sonprabhat.live",[53,120,2388]],["thepublicnews.live",[53,120]],["voiceofmedia.lk",[53,1047]],["allindianews.me",[53,120]],["asha.news",[53,120]],["pudhari.news",[53,120]],["massnews.online",[53,120,1402]],["prabudhajanata.online",[53,120]],["ravivardelhi.com",[54,120]],["punjabinational.ca",[55,56]],["solantoday.com",[55,2150,2251]],["64kalalu.com",56],["anshprabhat.com",56],["bharatnewsservice.com",[56,522]],["buxaruptodate.com",[56,476,627,628,629]],["canamnews.com",[56,365]],["champawatkhabar.com",[56,469,660]],["cinemapluz.com",[56,129]],["cumillarbarta.com",56],["dhunkhabar.com",[56,941]],["impact24news.com",[56,1284]],["kalakarmi.com",56],["kannadanet.com",[56,1422]],["khabarhp.com",56],["ktmkhabar.com",56],["kuberbhoomi.com",56],["mahavoicenews.com",56],["matraeducation.com",56],["mbdwebnews.com",[56,1672]],["mirmireonline.com",[56,1688]],["nepalawaj.com",[56,303,1106]],["poribortonersopoth.com",[56,249,365,761]],["prabartan.com",[56,1991]],["realviewnews.com",[56,2082]],["rj24news.com",56],["samarneetinews.com",56],["saurahaonline.com",56],["sutranews.com",[56,1327]],["tarangabarta.com",56],["theeditor24.com",[56,559,2364]],["thelifelinetoday.com",[56,1209]],["udaydinmaan.com",[56,176]],["updatesatkhira.com",[56,265,832]],["anwesantv.wordpress.com",[56,2506]],["yeskathmandu.com",56],["kokanmedia.in",[56,232,463,2684]],["bijoybangla.news",56],["udayakala.news",56],["punjabipost.ca",57],["aggarjanpatrika.com",57],["himalayanupdate.com",57],["hindiexpressnews.com",57],["tatkalnews.com",57],["uthayannews.ca",[58,59]],["pclive7.com",[58,872]],["everesttimes.net",[58,745,2902]],["tamilnews.cc",60],["malayalees.ch",[61,62]],["chhattisgarhvaibhav.com",[61,702]],["dainikpana.com",61],["indore-samachar.in",61],["makkalkural.net",[61,72]],["instanews.city",63],["99news.co",64],["bmdb.co",65],["oneindia24live.com",[65,1924]],["recentnepal.com",[65,172]],["chhattisgarh.co",66],["newsmalayalionline.com",[66,469]],["skyhawktimes.com",[66,445]],["nepalmother.com",[67,68,589,590,1614,1617,1796,1797]],["gyandatasamachar.blogspot.com",69],["ceylonmuslim.com",[69,184,644]],["dailyhealthletters.com",[69,393,459,545,586,798]],["inahardoi.com",[69,70]],["mithlahindinews.com",[69,952,1691]],["newsprahari.com",[69,590]],["rajsamachar.com",[69,184,459,586]],["sandwanews.com",[69,459]],["tapnewsindia.com",[69,165,184]],["vyganews.com",[69,679]],["tejasindia.in",69],["bestghazals.net",69],["fastnewsindia.co",[71,72]],["himachalmedia.co",73],["newsfront.co",74],["aafnokura.com",[74,110]],["aamsanchar.com",[74,127]],["abhayindia.com",[74,150]],["airanewsnetwork.com",[74,195,196]],["banglatelegraph.com",[74,422]],["biharivoice.com",[74,557]],["chatgaiyakhobor.com",[74,206]],["chhattisgarhprimetime.com",[74,700]],["cinemadaddy.com",[74,147,713]],["cinemapettai.com",74],["cityhalchal.com",[74,370,723]],["creativenewsexpress.com",74],["dailywhile.com",74],["dalitawaaz.com",74],["ghamasan.com",74],["gorakhpurhindinews.com",74],["govtofgaurang.com",74],["hindikhabar.com",[74,1236]],["hoophaap.com",74],["hosakannada.com",74],["idealindianews.com",[74,89]],["jkcnews.com",[74,1225]],["jogindernagar.com",[74,1383]],["khabarhikhabar.com",[74,218,1047,1066,1480,1481,1482]],["kingwaytamil.com",74],["knlslive.com",[74,1531,1532]],["kothamangalamnews.com",74],["lankamurasu.com",[74,184]],["loksaakshya.com",[74,1119,1120,1602]],["malwanews.com",[74,1649]],["muchata.com",[74,452]],["mulukhmaidan.com",[74,523]],["n7india.com",74],["navamalayali.com",[74,360]],["newscg11.com",[74,1844]],["newsthen.com",74],["officialkhabar.com",[74,1918]],["onlookersmedia.com",74],["patnanewslive.com",74],["priyochandpur.com",[74,473]],["priyoshomoy.com",74],["rkhabar.com",74],["roopcare.com",[74,134,299]],["rosemalayalam.com",[74,2098]],["samacharplusnews.com",[74,1666,1948]],["sangbadonline.com",74],["sangbadsafar.com",[74,120]],["satyakhabarindia.com",[74,151]],["shamolbangla24.com",[74,206,2213]],["shottoboyan.com",[74,604,2229]],["shottoboyan24.com",[74,604]],["socialsamvad.com",74],["starnews24bd.com",74],["sundarbontimes.com",[74,713]],["thecrimeonline.com",74],["thejharokha.com",[74,229]],["thinatamil.com",74],["tnpanchayat.com",74],["uttranews.com",[74,336]],["zoombangla.com",[74,147,2520]],["andolana.in",[74,1849]],["ebharatnews.in",[74,2423]],["globalindiannews.in",74],["gujaratexclusive.in",74],["media24news.in",[74,476]],["mediavisionnews.in",74],["newsuniversal.in",[74,2732]],["nikharanews.in",[74,2738]],["onlygujarat.in",74],["prajasatta.in",[74,2754]],["punjablivenews.in",[74,166,445,890,2759]],["rajasthanichirag.in",[74,2762]],["sachchadost.in",74],["starbangla.in",[74,2790]],["theindiandaily.in",74],["wcnews.in",74],["lekhaporabd.net",[74,2908]],["kelopravah.news",[74,91,850]],["satwadhara.news",74],["techzoom.tv",[74,3022]],["odishafast.co",75],["theinternalnews.co",76],["18indianews.com",77],["beforepublish.com",[78,504]],["jagocomilla.com",78],["smpnews24.com",78],["andhravilas.net",78],["namastenri.net",[78,2913]],["24jetnews.com",80],["24livenewspaper.com",81],["24newspress.com",[82,83]],["bn24live.in",[82,117]],["ibclive.in",[82,2651]],["mukhpatra.in",82],["48bangla.tv",82],["polikai.com",83],["swapnilsansar.org",83],["24timestoday.com",84],["amanyatralive.com",[84,120]],["hindirush.com",84],["indianletter.com",[84,1292]],["khabarwarrior.com",[84,369,616]],["thehimachal.com",[84,336]],["uttarakhandhindinews.com",84],["tnnews24.in",[84,336,623]],["24updatenews.com",[85,86]],["u71news.com",[85,2431]],["24upnews.com",[87,88]],["buxarpatrika.com",88],["36garhi.com",89],["a2znewsup.com",[89,104]],["avikaluttarakhand.com",[89,200,357,358,359]],["azchavattomonline.com",[89,377]],["banglanewsupdate24.com",89],["dainikchhattisgarhwatch.com",89],["dhakalive24.com",89],["keelainews.com",[89,1451]],["khabareducation.com",[89,1478]],["nammakudlanews.com",89],["odishatime.com",[89,276,838]],["rashtrasamvad.com",[89,276,2073]],["samastipurlive.com",89],["thekeralatimes.com",89],["udaydarpan.com",89],["upaajtak.com",89],["insightonlinenews.in",89],["24x7breakingpoint.com",90],["aanthaireporter.com",[90,129]],["ambikapurcity.com",90],["banglapostbd.com",[90,409]],["cobranews24.com",90],["filmaniaentertainment.com",[90,476,1066]],["globalhimachaltimes.com",90],["himalini.com",[90,169,233,996,1227,1228]],["jalandharbreeze.com",90],["janashaktinews.com",[90,1343]],["jogiexpress.com",[90,119,1382]],["kannurvarthakal.com",90],["khaskhabar24.com",[90,114]],["khulasamedia.com",90],["koyilandydiary.com",[90,1540,1541]],["livekhabar.com",90],["newspagebd.com",[90,1870]],["pularvu.com",90],["real4news.com",90],["saakshatv.com",[90,1480,2102]],["sachkidastak.com",[90,279]],["shaktialmora.com",[90,2212]],["smartindiadial.com",[90,1494,2245]],["sorejomin.com",90],["thepressnepal.com",[90,1065]],["timesofnellore.com",90],["todaynewshunt.com",90],["tv24live.com",[90,343,2428]],["boundaryline.in",90],["focusnews.co.in",90],["indonepalnews.in",[90,2661]],["liveindiakhabar.in",[90,312,2692]],["shreenews.in",[90,2782]],["thefactshala.in",90],["nawidunia.com",91],["timesandspace.com",91],["4malayalees.com",92],["4pmnewsonline.com",93],["4tamilmedia.com",94],["52banglatv.com",95],["balaganjprotidin.com",[95,390]],["5dariyanews.com",96],["60secondsnow.com",97],["71barta24.com",98],["71sangbad24.com",98],["71times.com",98],["ajkercrimenews.com",[98,205,206]],["ajkercrimetimes.com",[98,207]],["ajkertanore.com",[98,206]],["alochitosokal.com",98],["alokitodhaka.com",98],["alokitoteknaf.com",[98,206]],["aznewsbd24.com",[98,206,380]],["bangla71news.com",[98,206,400]],["banglanewstv.com",[98,413]],["banglarkonthosor.com",[98,173,358,420]],["banglarkonthosor24.com",98],["bholatimes24.com",98],["borendronews.com",[98,206,610]],["ccnews24.com",[98,639]],["coxsbazartimes.com",[98,206]],["crimeseen24.com",98],["dailyamaderbangladesh.com",98],["dailybahadur.com",[98,784,785]],["dailydishari.com",[98,791]],["dailyjugantorsangbad.com",[98,206,808]],["dailynotunsongbad.com",[98,785]],["dainikcampus.com",[98,847]],["dainikdishari.com",[98,853,854]],["dainikshikkhokderkotha.com",[98,206]],["daynikekusherbani.com",[98,896]],["deshersangbad24.com",98],["diptonews24.com",[98,868,965]],["durnityreport24.com",98],["ektibd.com",98],["fenitribune.com",[98,1077]],["fulbarianews24.com",98],["gtbnews24.com",[98,206,997]],["haimcharbarta.com",98],["haorbarta24.com",98],["indurkanibarta.com",[98,205]],["kopotakkhotimes.com",[98,1537]],["lalsobujerkontho.com",[98,206,1567]],["munshiganjvision.com",98],["narayanganjerkhobor24.com",98],["newsbna.com",98],["newspabna.com",98],["onushondhantv.com",98],["oporadhsangbad.com",98],["paribahanjagot.com",[98,206,1912]],["patiyapratidin.com",98],["pollysoktybarta.com",[98,1986]],["pracestanews24.com",98],["priyobanglanews24.com",98],["rbcnewsbd.com",[98,206]],["sarakkhonnews.com",[98,206]],["setvnews24.com",[98,2210]],["sharekhabar24.com",98],["sherpurgrambangla.com",98],["shikkhapotrika.com",[98,206]],["shiromoni.com",98],["shobshomoy.com",98],["somoyerdak24.com",98],["songbadsarakkhon.com",[98,2259]],["surjodoy.com",[98,206]],["sylhetmail24.com",98],["teknaf71.com",[98,868,869]],["thebarisal.com",[98,206]],["alokitonarayanganj24.net",[98,2882]],["banglarkagoj.net",[98,206]],["chatgarsangbad.net",[98,1561]],["eibela.net",[98,206]],["firstbdnews.net",98],["satkhiraprobaho.net",[98,206]],["banglalivenews24.tv",98],["71newstoday.com",99],["71sangbad.com",100],["7elevennews.com",[101,102]],["raajdhaninews.com",101],["a2znewslive.com",103],["a2zsamachar.com",105],["a4applenews.com",106],["aadarshasanchar.com",107],["hamrakura.com",107],["hindustanvision.com",[107,1251]],["maharashtratimes.com",[107,1003,1004,1014,1015,1016,1629]],["samakal.com",[107,2141]],["weeklynepal.com",[107,2500]],["cg24news.in",107],["andhrabhoomi.net",[107,2883]],["bdrtnn.net",107],["delhicrimepressnews.com",108],["parichaya.com",[108,144,220]],["humhindustaniusa.com",110],["thinakaran.lk",[110,2849]],["bholarbani.com",[111,543]],["janotarbani.com",111],["onstimes.com",[111,1936]],["pahareralo.com",[111,147]],["aagolavartha.com",112],["aajbikel.com",113],["aajexpress.com",[114,115]],["acpnews24.com",114],["aryasamay.com",114],["awazlive.com",[114,368]],["awaznews24x7.com",[114,176,369]],["bastabbadi.com",[114,120]],["kakkajee.com",[114,120,1402]],["meherpurnews.com",[114,832]],["mitanbhoomi.com",[114,120,176,358]],["nandighoshatv.com",[114,1740]],["news20live.com",[114,526]],["newsnasha.com",[114,176,195]],["newsroom9.com",114],["parvatjan.com",[114,1961]],["rajarhatbd.com",[114,476]],["sabkajammukashmir.com",[114,370,1135]],["sitakundtimes.com",114],["vismayamadyama.com",[114,522]],["vorerava24.com",[114,151,1856]],["inn24news.in",[114,120]],["jharkhandnews.live",114],["sunmision.tv",114],["bolanyathali.com",115],["ishwardinews24.net",[115,276]],["aajkaaldaily.com",116],["aajkadinnews.com",[117,118]],["aankhennews24.com",[117,118,128]],["bhadainimirror.com",[117,118]],["bhavtarini.com",[117,118]],["bundelkhandnews.com",[117,118]],["chennaipatrika.com",[117,118]],["dakshinapath.com",[117,886]],["darsilivetv.com",[117,118]],["hindikhabarwaala.com",[117,118,1237]],["indraprasthasamachar.com",[117,118]],["jagrantimesnews.com",[117,118]],["lokjannews.com",[117,118]],["sirajganjexpress.com",[117,118]],["threesocieties.com",[117,118]],["weeklybangalee.com",[117,118]],["aajbangla.in",[117,118,2530]],["bharatlive.co.in",117],["dankaram.in",[117,2618]],["fesn.in",[117,118]],["raebareliexpress.in",[117,118,2760]],["naradnews.live",[117,118]],["channelindia.news",117],["deshpatra.com",118],["firstrajasthan.com",118],["gexpressnews.com",118],["hindustankhabar.com",118],["hindustansamay.com",118],["hindustanvarta.com",118],["janajeevala.com",118],["livenewsxpress.com",118],["loudspeakeronline.com",118],["metrocitysamachar.com",118],["newsexpress24.com",118],["p24news.com",118],["polkholindia.com",118],["poorvanchalmedia.com",118],["purvikranti.com",118],["sansaninews.com",118],["starsamachar.com",[118,2267]],["vartanews.com",118],["bharatvarshnews24.in",118],["champarantoday.in",118],["firstbharat.in",118],["highwaychannel.in",118],["nbc24.in",118],["pickthekhoj.in",118],["rajasthanpost.in",118],["todaynewshindi.in",118],["nayabharat.live",[118,2683,2836]],["zndm.news",118],["aajkakanpur.com",119],["aapkanews.com",119],["aryavartposts.com",[119,329]],["demranews.com",119],["ekhabartoday.com",[119,1028,1029]],["emediatoday.com",119],["fourthpost.com",119],["gangalahar.com",[119,176,351,1109]],["ideaciti.com",[119,574]],["janpatranews.com",119],["network10tv.com",119],["newsbindass.com",[119,1840]],["pabnabarta24.com",[119,1118,1941]],["patnapost.com",[119,1970]],["polkholonline.com",[119,147,1856]],["pradeshnews24x7.com",[119,176,562]],["saunewsnetwork.com",[119,176,2201]],["thebiharnow.com",119],["thelokniti.com",119],["vishwanews24.com",119],["agnichakr.in",119],["mediapassion.co.in",119],["k24news.in",119],["ptbnews.in",[119,166,399]],["thekhabri.in",[119,949]],["vedantsamachar.in",[119,2822]],["banglasanglap.co.uk",119],["aajkalsamachar.com",120],["abpbharat.com",[120,161]],["akashgyanvatika.com",[120,173,218]],["azkersylhet.com",120],["bhorvaibhav.com",120],["bograsangbad.com",[120,531,597]],["cgnewstime.com",120],["cinenxt.com",120],["citysmartnews.com",120],["dainikrajeevtimes.com",120],["damaulikhabar.com",[120,161,888]],["divyadarpan.com",[120,969]],["f21news.com",[120,440,1065,1066,1067]],["himachalsamay.com",[120,1026]],["hindustanlivetoday.com",[120,173,298,480,974,1248]],["hnn24x7.com",[120,1257,1258,1259]],["indiasamachar24.com",[120,370]],["janexpresslive.com",[120,126]],["jharkhandnewsroom.com",120],["kaskikhabar.com",120],["khabardekho.com",[120,1475]],["khabarvani.com",[120,757]],["khabor24x7.com",120],["khaskhabarchhattisgarh.com",120],["lovedevbhoomi.com",120],["navakeralanews.com",[120,704,1755]],["nepaljapan.com",[120,1789]],["networktodaynews.com",120],["newj9.com",[120,126,218]],["newresultbd.com",120],["newsakhada.com",120],["newswing.com",[120,1885]],["newvavuniya.com",120],["pokharasports.com",[120,1099]],["qawmipost.com",120],["shrinaradmedia.com",[120,2234]],["surmanews.com",[120,2161]],["tehelkaindia.com",120],["tharsamwad.com",120],["theupkhabar.com",120],["uktez.com",120],["yugjagran.com",[120,2518]],["aajkaaditya.in",[120,166,452,1193]],["buxaruptodate.in",[120,2570]],["cglivenews.co.in",[120,280,376]],["delhibulletin.in",[120,2619]],["devbhumijknews.in",[120,336,2265]],["jugasankha.in",120],["khabarsar.in",120],["lokswar.in",[120,620]],["muvattupuzhanews.in",120],["nilkantho.in",120],["pnn24.in",[120,2749]],["purvanchaltimes.in",120],["shaktinews.in",[120,360]],["thesurgicalnews.in",[120,224,842,1450]],["youturn.in",120],["malayagam.lk",120],["vanakkammalaysia.com.my",120],["aapkiaawaz.net",120],["aajkasamay.com",121],["aajkiawaaz.com",[122,123]],["barisaltoday.com",[122,161,280,358,443]],["brajpatrika.com",[122,358,612,613]],["chakarianews.com",[122,656]],["ekhansangbad.com",[122,161,974,1030,1031]],["hastakshep.com",[122,280,476,1203]],["indianow24.com",[122,1295,1296]],["indiawarta.com",[122,597,974]],["kalmunainet.com",[122,247,358]],["lenseyenews.com",[122,358,725]],["manikganj24.com",[122,1653]],["nrsewa.com",[122,974]],["scnnewsindia.com",122],["whitemirchi.com",122],["youngorganiser.com",122],["mpbreaking.in",[122,2709]],["bdtodays.net",[122,298,358]],["aajkijandhara.com",[124,125]],["nwnews24.com",[124,1909]],["aakhriaankh.com",126],["bhawalbarta.com",126],["chandankesari.com",[126,345]],["dailykagojkolom.com",126],["dhinakkavalan.com",126],["kanjirappallynews.com",126],["laxminews24x7.com",[126,161,670,1159,1574]],["muldharpost.com",[126,485,838]],["pahaltoday.com",126],["sanjeevanisamachar.com",[126,2178]],["sasthabangla.com",[126,161,372,485,565]],["thebharatexpress.com",[126,372]],["thebiharnews.com",[126,161,1398,1571]],["updatenownews.com",[126,372]],["bharatnews18.in",[126,531]],["hindustanrepublic.in",[126,643,2647]],["janmatexpress.in",[126,166,370]],["news21live.in",[126,564]],["sajhamanch.com",[127,1494]],["newcinemaexpress.com",[129,1817]],["tamilveedhi.com",[129,526]],["vtv24x7.com",[129,664,2346,2493]],["aapkiaawaznews.com",130],["aapkikhabar.com",[131,132,133]],["anugrahavision.com",[131,292,293,294,295]],["bulandsoch.com",131],["cricketkhabara.com",[131,292,751]],["keralavoter.com",[131,293,584,1462]],["satyavoice.com",131],["upuklive.com",131],["uttarakhandpost.com",[131,2461]],["newstm.in",[131,132,2731]],["publicnewstv.in",[131,132]],["atalnews24.com",[132,340]],["dailyharyananews.com",[132,797]],["dainikhawk.com",[132,855]],["globalbharatnews.com",132],["haryanakranti.com",[132,292,1200]],["khabreelal.com",[132,292,1508]],["manoranjannama.com",[132,797,1659]],["newsremind.com",[132,340]],["newstodaynetwork.com",[132,292,1880]],["rochakkhabare.com",[132,292,2093]],["samacharnama.com",[132,797,2131]],["skynews100.com",132],["yuvaharyana.com",132],["zabardastharyana.com",132],["3pm.in",132],["samachartoday.co.in",[132,293]],["lifestylenama.in",132],["newsmoments.in",[132,797]],["kathir.news",[132,534,797,936,2362,2956]],["aapkisafalta.com",[134,135]],["achhisoch.com",[134,173,174,175]],["ekusheralo24.com",134],["aapnihathai.com",137],["aapnojodhpur.com",138],["aarthiknews.com",139],["news4csc.com",140],["aashanews.com",[141,142]],["khabarpatrikanp.com",142],["ejanakpurtoday.com",[144,1017]],["ekhonkhobor.com",[144,757]],["khabarbit.com",[144,151,1468]],["rastriyadaily.com",[144,2074]],["azadsipahi.in",[144,147]],["kodanki.in",[144,2683]],["smnewshimachal.in",[144,150]],["vatakaravarthakal.in",[144,520,2821]],["aayomail.com",145],["abasangthandp.com",146],["abbiharnews.com",[147,148,149]],["asianprimetime.com",147],["bisshobarta24.com",147],["citywatchnews.com",147],["filmistreet.com",[147,1083]],["globalpunjabtv.com",147],["hamdardtv.com",[147,604,760,1186]],["iftamil.com",[147,1279]],["indiatimesgroup.com",147],["jalauntimes.com",147],["knanayapathram.com",147],["livelokvani.com",147],["mahendranagarpost.com",[147,167]],["namasteandhra.com",[147,1737]],["newscrime24.com",[147,1845,1846]],["newsganga.com",[147,940]],["parbattaanchal24.com",147],["raibaaruttarakhand.com",[147,718]],["realtamilnews.com",[147,2081]],["tarunbharat.com",[147,901,2327]],["thurannakathu.com",[147,2394]],["timetvusa.com",[147,649,2405]],["todaypostlive.com",[147,1385,2414]],["topnewskerala.com",[147,548]],["ulipur.com",147],["voiceofmountains.com",147],["fastnewsnetwork.in",147],["news1india.in",147],["sidelook.in",147],["nationone.tv",147],["justmuz.com",149],["adhuniksamachar.com",150],["annapurnatimes.com",[150,286]],["berartimes.com",[150,508]],["jaagonews.com",150],["ktvprotidin.com",150],["thegramtodaydailynews.com",150],["ucchakontha.com",[150,985,1915]],["uttarakhandkhabar.in",150],["abhishektimes.in.net",150],["agranews.com",151],["aryandigitalseva.com",[151,200]],["cnewsbangla.com",[151,200]],["demokraticfront.com",151],["digitalhoga.com",151],["himwantpradeshnews.com",[151,838,849,872,1232]],["kyakhayal.com",151],["minoritiesnews.com",[151,476]],["newstodayjharkhand.com",[151,1647]],["odishanews365.com",[151,220]],["patnanow.com",151],["tnilive.com",[151,174,247,263,264,345,1241,1433,1965,2409]],["pnews.co.in",[151,627,1126,1369,2604]],["tennews.in",151],["theneeweb.net",151],["abhiyandaily.com",153],["himalayandiscover.com",[154,1222]],["khabargujarat.com",154],["techvision24.com",[154,2335]],["teknafnews.com",[154,2340]],["thekarmanews.com",154],["yespunjab.com",[154,860]],["postmanindia.in",[154,2750]],["tazakhabar.in",[154,993]],["unanews.in",154],["thebharatnews.net",[154,272,2935]],["bizmandu.com",[155,580]],["notunalo24.com",155],["weeklybangladeshusa.com",155],["ablivenews.com",156],["abnews24.com",[157,158,159]],["odhikar.news",[158,2963]],["alokitobangladesh.com",159],["abnews24bd.com",160],["amaderbikrampur.com",161],["balliatimes.com",161],["banglaralobd.com",161],["bareillytoday.com",[161,440]],["bdmetronews24.com",[161,485]],["bhaskarenews.com",[161,386,529]],["chanamurra.com",161],["dainikjanatarkotha.com",161],["dainiknayak.com",[161,871,872]],["darpansamachar.com",[161,372]],["dhenkanalupdate.com",[161,220,623]],["dokkinchattala.com",161],["himalayonlinemedia.com",[161,1224]],["hindlives.com",[161,386,867,1242,1243,1244]],["national18news.com",161],["nationaldunia.com",[161,372]],["newsbrahmanbaria.com",[161,913,990,1842]],["newschutney.com",[161,195,440,476]],["nikharanews.com",161],["odishanewsservice.com",161],["pathivaraonline.com",161],["punjablivekhabarnama.com",[161,1702]],["sajagpahad.com",[161,2122]],["sandhannews.com",[161,372,838,2168]],["sehorenewsdarpan.com",161],["theachievertimes.com",161],["ukhiyanews.com",[161,233,480,996,2440]],["gujaratinurasodu.in",[161,2639]],["karnatakatoday.in",161],["najarianews.in",[161,263,345]],["upnewz.in",161],["crimekhabar.live",[161,476,529,623]],["dainikkhojkhabar.live",[161,372,485,516,565,838,933,2833]],["sherpurnews24.net",161],["abplive.com",162],["marathi.abplive.com",163],["abtakapakesath.com",[164,165]],["rashtrasamarpan.com",[164,586,1152]],["battinews.com",[165,458,459,460]],["chapainawabganjnews.com",[165,679]],["eelanesan.com",165],["media24media.com",[165,461,544,1152,1674]],["nobojagorontv.com",165],["visarnews.com",[165,2486]],["36kaakda.in",[165,458,459,461,2527]],["topbharat.in",[165,184,644,1152]],["abtakkhabar.com",166],["bigtvnews.com",166],["giridihupdates.com",[166,1129,1130]],["hapurhulchul.com",[166,476,1193]],["hindsagarplk.com",[166,370]],["pinakatimes.com",166],["rsnewslive.com",[166,1166,2099]],["smacharaajtak.com",[166,2244]],["tharexpressnews.com",[166,2352]],["24expressnews.in",[166,2525]],["soochnanews.in",166],["abtakmedia.com",167],["currentnewsdainik.com",167],["himachalvarta.com",[167,1102]],["jhansidarshan.com",167],["livemagadh.com",167],["mujibsenanews.com",[167,178]],["satyaday.com",167],["thenetizennews.com",167],["theriyuma.com",[167,336,790]],["khabarbastar.in",[167,457]],["mpbreakingnews.in",167],["satv.tv",[167,3019]],["abtaknews.com",168],["digontonewsbd.com",168],["pradeepamonline.com",[168,725,1997]],["desikhabar.in",168],["achhikhabar.com",[169,170,171,172]],["live18h.com",169],["uniquesamay.com",[169,267,269,2446]],["amaderparis.com",[173,247]],["sambadsaradin.com",[173,264,298,504,597,765,974,1031]],["sachkahoon.com",[174,2112]],["actionindialive.com",176],["dunvalleymail.com",[176,993]],["shramikmantr.com",[176,1531,2231]],["thethinkmedia.com",[176,725]],["abhitaknewsuk.in",[176,1047,1369,1705,1990,2537]],["andhrapatrika.in",176],["pratidin24x7.in",176],["ts29.in",[176,2809]],["tv20news.in",[176,373,1226,2810]],["adbhutsamachar.com",177],["adbudhindia.com",178],["dailydhaka24.com",[178,790]],["citizenlive.news",178],["adhunikdaur.com",180],["adityabharat.com",181],["adiyakkamangalam.com",182],["adnlive24.com",183],["adrasaka.com",184],["balotranewstrack.com",[184,393,394,395]],["khantinews.blogspot.com",[184,545,586]],["kanaighatnews.com",[184,458,461]],["kathiravan.com",184],["marudharabharti.com",[184,415]],["newssapata.com",[184,586]],["sahibganjnews.com",[184,415,593,977]],["actionnews.in",184],["localmarathi.in",184],["aeiodisha.com",185],["agaminews.com",[186,187]],["ambalanews24.com",[187,259]],["agniban.com",188],["agnijwala.com",[189,190,191]],["crickethimalaya.com",189],["prameya.com",[190,2006]],["agrilife24.com",193],["agrtanews.com",194],["pahar24.com",[195,372,1047]],["tistanews24.com",195],["bengallive.in",[195,2554]],["ajabgjab.com",197],["ajakoartha.com",198],["ajeybharat.com",199],["biharkhabars.com",199],["emungaru.com",[199,1042]],["importmirror.com",[199,415,1285]],["india2daynews.com",[199,798,1289]],["khulikhabar.com",199],["maavarahinews.com",199],["satyawani.com",199],["azmlive.in",199],["newswitness.in",199],["sanskarnews.page",199],["ajithfans.com",200],["dailybhorerkolam.com",[200,788]],["dailypunjabtimes.com",[200,264,358,765]],["jagonatore24.com",[200,1322]],["kannadigaworld.com",200],["karaihinducanada.com",200],["prothomsurjadoy.com",200],["swadeshbani.com",[200,264,1071,2291]],["thakurprasad.com",200],["thepunjabi.com",200],["newswatch.co.in",[200,725,2601]],["devbhoomisamvad.in",200],["ekhabar.in",[200,604]],["indoremirror.in",200],["sabjanta.info",200],["ajkalerkhobor.com",201],["cinemainbox.com",201],["khabarwani.com",201],["marathiworld.com",201],["maxmaharashtra.com",[201,432]],["natunsylhet24.com",[201,1754]],["nayanjagriti.com",[201,432,1772]],["telugugateway.com",[201,432]],["teluguglobal.com",[201,2343]],["doonhorizon.in",[201,584]],["jeevanutsahnews.in",201],["maxwoman.in",[201,433,2703]],["employment-news.net",201],["ajkalerkontho.com",202],["ajkerbazzar.com",203],["ajkerdarpon.com",[206,208]],["ajkernarsingdi.com",206],["alokitobarisal.com",[206,240]],["alokitocoxsbazar.com",206],["alokitodigantonews24.com",206],["alorjatra.com",206],["amaderkuakata.com",206],["aponnewsbd.com",206],["banglarjamin24.com",[206,400]],["banglarsakal.com",206],["bdfinancialnews24.com",206],["bibartonbd.com",206],["bijoysamachar.com",206],["dailyajkershomoy.com",[206,779]],["dailynagorikdabi.com",206],["dailyshowadesherkhobor24.com",206],["dailysports24.com",[206,839]],["dainikeidin.com",206],["dainiknarsingdi.com",[206,868,869]],["dainikshokalerchattogram.com",206],["engrsvoice.com",206],["gorkhapatraonline.com",[206,1151]],["gsnnews24.com",206],["hamroeconomy.com",[206,735]],["haoranchalerkotha.com",206],["healthpati.com",206],["himalayannews.com",206],["jagodesh24.com",206],["kathmandupati.com",[206,636,1061,1443]],["khabarpunja.com",[206,1499]],["khoborpatrabd.com",206],["nagoriknewsbd.com",206],["narsingdipratidin.com",206],["natunbazar24.com",[206,380]],["natunshokal.com",[206,1753]],["news18.com",[206,810,1823,1824]],["news4nation.com",[206,1832]],["newsatfirst.com",[206,1838]],["newsdnntv.com",[206,1700,1851]],["nktelevision.com",206],["npkhabar24.com",206],["odekhabishwo.com",[206,1912]],["paharkantho.com",206],["paryatanbazar.com",[206,1963]],["pirojpursomoy.com",[206,380]],["pokharaexpress.com",[206,1982]],["pollysangbad.com",206],["rangpursangbad.com",206],["savarsangbad.com",[206,868,869]],["shahnamabd.com",[206,380]],["shilonbangla.com",206],["somoyerkantha.com",206],["somoyersangbad.com",[206,2253]],["sudinamonline.com",[206,2278]],["sunamganjersomoy.com",206],["tazakhobor24.com",206],["technologykhabar.com",206],["teknafnews24.com",206],["telegraphnews24.com",206],["uttorersomoy.com",[206,380]],["vachakam.com",[206,954,2466]],["voiceworld24.com",206],["inhnews.in",[206,2662]],["doctortv.net",206],["prabhatkiran.net",206],["sharebiz.net",[206,2927]],["janamsakshi.org",206],["ajkerdiganta.com",209],["ajkerjholok.com",210],["ajkermymensingh.com",211],["dainikthakurgaon.com",211],["kurigrambarta.com",211],["ajkerograbani.com",212],["dhakanewsexpress.com",212],["ajkerparibartan.com",213],["ajkerprosongo.com",214],["ajkerreport.com",215],["ajkersylhet.com",216],["ajmernama.com",217],["navabharat.news",[218,2961]],["akashjatra.com",[219,220]],["ananda-alo.com",220],["bdsangbad24.com",220],["biharnewslive.com",[220,560]],["cgtazanews.com",[220,652]],["chavakkadonline.com",220],["citypostlive.com",[220,734]],["cumillarpaper.com",220],["dainikjagrotochattogram.com",[220,858]],["dainikpotrika.com",220],["ganthan.com",220],["hamaratoday.com",220],["journalistcafe.com",220],["kilinochchinet.com",220],["konarklive.com",220],["paharbarta.com",220],["pbknews.com",220],["peoplespresstrust.com",220],["sabkuchgyan.com",220],["safalnews.com",220],["suddimane.com",220],["tandavnews.com",[220,2326]],["thesigmanews.com",220],["ahinsaexpress.in",220],["biharnation.in",[220,360,2562]],["crimecapital.in",[220,2610]],["dumanikhabar.in",220],["koshalnews.in",220],["malayalamdaily.in",[220,2699]],["morbinews.in",[220,2707]],["odishasambad.in",220],["onlinemalayali.in",220],["pehchanfaridabad.in",220],["samajalive.in",[220,2768]],["upnn.in",220],["nationexpress.live",220],["akhabarhub.com",221],["anmolkhabar.com",[221,281,282,283]],["bholabani.com",221],["dailysonargaon.com",221],["dainikalorprotidin.com",221],["ekagaj.com",[221,1021,1022,1023]],["hetaudanews.com",221],["hetaudatoday.com",[221,282,283,1215,1216]],["justnewsbd.com",[221,320]],["kolhabinews.com",[221,282,1535]],["lokaantar.com",[221,261,1591]],["mazzakoonline.com",221],["mediaoneonline.com",[221,1678]],["mymahanagar.com",221],["nawayug.com",[221,282,1765]],["newsclickbd.com",221],["onenewsbd.com",221],["sunamganjerkhobor.com",[221,2282]],["swalenewsbank.com",[221,2292]],["tukhabar.com",[221,1215]],["keralasabdam.in",221],["akhandbharatsamachar.com",222],["akilanews.com",223],["globalnews24x7.com",[224,370,1135]],["akkbd.com",[225,226,227]],["telugumalli.com",[225,1494]],["ojasvitimes.in",225],["dainikbharatbhaskar.com",227],["sylhetvoice.com",227],["ptcnews.tv",[227,3016]],["alaikal.com",228],["alakhharyana.com",229],["lokpatrika.in",229],["alertnews24.com",230],["aligarhmedia.com",[231,232]],["coxsbazarshomoy.com",232],["koshikiaas.com",232],["newsboardindia.com",[232,1841]],["samacharlahrein.com",232],["trendingtelugunews.com",232],["allaiyoor.com",233],["kalaroanews.com",[233,1296,1404,1405]],["allnewsbharat.com",[234,235]],["emstv.in",[234,2629]],["allsharebazarnews.com",236],["allwnews.com",237],["anondobarta.com",237],["heronewsonline.com",[237,1212]],["jannewslive.com",237],["paryavaranpost.com",[237,312,334,463]],["naturalnews.co.in",[237,2597]],["indiapolkhol.in",[237,2659]],["aloavanews24.com",[238,239]],["just36news.com",239],["malayalamtodayonline.com",[239,643,1642]],["prameyanews7.com",[239,2007]],["thefollowup.in",[239,2795]],["bd24time.com",240],["jamunaprotidin.com",240],["swadeshsangbad.com",240],["alokitobogura.com",241],["sangbaddinrat.com",241],["alokitoctg.com",242],["alokitomymensingh24.com",243],["alokitosonargaon.com",245],["amaderprotidin.com",248],["banglanews24ny.com",[248,411]],["channel786.com",248],["dailyjalalabad.com",[248,803]],["mohanagarnews.com",[248,1694]],["surmanews24.com",[248,2289]],["purbodeek.net",248],["sylhetexpress.net",248],["channel24bd.tv",[248,278,3006]],["weeklydesh.co.uk",[248,3028]],["amadersangbadbd.com",249],["chetona71bdnews.com",249],["ctvnews24.com",249],["dewanganjnews.com",[249,365,924]],["karnalbreakingnews.com",249],["malabarnews.com",[249,1639]],["networknewsgujarat.com",249],["onebanglanews.com",249],["aadyashanewsman.in",249],["duniahalchal.in",249],["headlinenews.lk",[249,365]],["amaderkhulna.net",[249,365,1814]],["timetv.news",249],["amadershomoy.com",250],["amarbanglabd.com",252],["amarbarishal24.com",253],["amarbarta24.com",254],["amarsandesh.com",255],["amarsangbad.com",256],["amarujala.com",257],["ambalacoverage.com",258],["banglasangbad24.com",258],["newsinbihar.com",[258,554]],["onlinebhaskar.com",258],["dainiksamvad.in",258],["indiadhuandhar.in",[258,2654]],["amraikhabor.com",260],["chouranews.com",[260,708]],["amritsandesh.com",261],["awamileaguetimes.com",261],["amritvichar.com",262],["arthparkash.com",263],["ctgcrimenews.com",[263,765]],["muslimkural.com",[263,597,974]],["onlinesaptari.com",263],["tamil.com",[263,480,1102]],["vyavasthadarpan.com",[263,264,480,974]],["newscup.in",[263,1102]],["himalayauk.org",[263,597]],["bdcrictime.com",[264,336,443,475,479]],["chandpurprobaha.com",[264,665]],["porospor.com",[264,597]],["livekhagaria.in",[264,2694]],["fenionline.net",[264,2903]],["e-jaffna.com",[265,996]],["manvadhikartimes.com",[265,516,838,1662]],["pehchanexpress.com",265],["theblastkhabar.com",[265,372,485,565,974,1102]],["gvtjob.com",[266,1178]],["satyamlive.com",[267,268,996,1227,2198]],["trttamilolli.com",[267,765,2422]],["janvadtimes.com",269],["himalayapost.com",[270,1223]],["anandabazar.com",[272,273]],["banglaxp.com",[272,426]],["beanibazarnews24.com",[272,497]],["bhartiyabasti.com",272],["lohagaranews24.com",[272,670,1590]],["pangighatidanikapatrika.in",272],["radiokanchan.com.np",[272,2978]],["anandalok.com",274],["anbnews24.com",[275,276]],["munshigonjerkagoj.com",[275,366]],["priyobandhu.com",275],["timesoneodia.com",275],["liveindia.live",275],["biharnews7.com",[276,558]],["chandpurreport.com",[276,666,667]],["deshrojana.com",276],["ekuruvi.com",[276,1033]],["ekusheysangbad.com",[276,729,1036]],["ghatail.com",[276,1121]],["jokhimnews.com",[276,360,745,757]],["khabardev.com",276],["mathuranews24.com",[276,1670]],["onlinespardha.com",276],["medianow.in",276],["71bdnews.net",276],["andhrajyothy.com",[277,278]],["bwoodtadka.com",279],["pleaseindia.com",279],["sagevaani.com",279],["tamilnigar.com",279],["newsnow.co.in",279],["webakhbar.in",[279,476]],["crimemukhbir.com",280],["firsttracknews.com",[280,443]],["khabarstate.com",280],["kushtiabd.com",[280,476]],["lotpot.com",[280,1609]],["manamnews.com",[280,1650]],["motivatedkannadiga.com",280],["outlinekhabar.com",280],["samastipurtown.com",[280,628]],["suddikanaja.com",[280,1490,2276]],["usanewsonline.com",[280,2454]],["janadeshnews.in",280],["khabarexpert.in",[280,336,476,2677]],["marginalised.in",280],["muznews.in",280],["newsharpal.in",280],["voiceoffreedom.in",280],["lalkhabar.com",[282,283,1562,1563]],["murchungatv.com",[282,1563]],["sajhakuranews.com",282],["annapurnapost.com",[284,285]],["canadanepal.com",284],["eadarsha.com",[284,999]],["everestawaj.com",284],["mardinews.com",284],["nepaldut.com",284],["safalawaj.com",284],["setoparewa.com",284],["indianvoice24.com",[287,838]],["newsnukkad.com",[287,620,1869]],["rcn24bd.com",287],["sikkimtoday.com",[287,475]],["antimvikalp.com",[289,290]],["ggsnews24.com",[289,1066,1117,1118,1119,1120]],["samachardarshan24.com",[289,1066]],["tejalgyannews.com",[289,529]],["ujiarpurnews.com",[289,1056,2388,2436]],["bharatnewslive24.in",[289,1066]],["anubhaviaankhennews.com",291],["chandaulisamachar.com",[292,584,662,663]],["chopaltv.com",[292,707]],["fashionnewsera.com",[292,584]],["heraldspot.com",[292,1210]],["keralaonlinenews.com",[292,293,294,722,1440,1457]],["newshaat.com",[292,293,584]],["thechopal.com",[292,2358]],["timeskerala.com",292],["woneminute.com",[293,342]],["aapninews.in",293],["devpath.in",[293,584,722,2622]],["anuragdarshan.com",296],["anytechtune.com",[297,298,299]],["biharhalchalnews.com",298],["rodoshee.com",298],["updatetimes.com",[298,643,765]],["fastlivenews.com",[299,996]],["ap7am.com",300],["khaptadmalikanews.com",[302,303,565]],["neelkanthafm.com",[302,303,1106]],["radiobihani.org",[302,2037]],["banglarkotha24.com",[303,421]],["bdlive24.com",303],["chandpur-kantho.com",303],["dailyinqilab.com",[303,800]],["dainikdeshseba.com",303],["ekushnews24.com",303],["globalnewsbd24.com",[303,1136]],["gorkhalikhabar.com",[303,1150]],["jagaranpost.com",303],["jaljalaonline.com",[303,1106]],["kalantor24.com",303],["kalerkotha.com",303],["lakshmipur24.com",[303,424]],["news71online.com",[303,575,1833,1834]],["newspolar.com",[303,1873]],["onlinemajdoor.com",[303,1002,1928,1929]],["samaynews24.com",[303,727,2148]],["shamolynews24.com",[303,575,1833]],["shikshapratidin.com",303],["subhayug.com",[303,2272]],["tharunaya.com",303],["thebdreport24.com",[303,2355]],["timesofmalwa.in",303],["bangladeshtoday.net",303],["onabil.net",303],["ournewsbd.net",[303,599,1405,1746,2922]],["banglapost.co.uk",[303,3024]],["apnamzn.com",305],["apnapunjabmedia.com",307],["emaatimes.com",308],["jeewanaadhar.com",308],["sabkikhabar.net",[308,2925]],["aponzonepatrika.com",310],["arerajdarshan.com",311],["areseenews.com",312],["kundapraa.com",[312,1552]],["odishamanthan.com",312],["samacharfirst.com",[312,2129]],["athirvu.in",312],["newsnagar.in",[312,463]],["satyagrahanews.in",[312,2776]],["arghakhanchi.com",313],["arlivenews.com",314],["arohitodaynews.com",[315,316]],["arthapath.com",318],["bikastimes.com",318],["bizkhabar.com",318],["dainikonline.com",318],["deshkonews.com",[318,914]],["drishtinews.com",[318,987]],["etajakhabar.com",318],["gaunbeshi.com",318],["ghatanarabichar.com",318],["harekpalnews.com",318],["ijalas.com",318],["imagekhabar.com",318],["khabarghar.com",318],["khabarhub.com",[318,1485]],["khabarkura.com",318],["lalitkhabar.com",318],["mntvonline.com",318],["momnepal.com",318],["narayanionline.com",[318,1741,1742]],["nepalpatra.com",[318,1800]],["onlinepana.com",318],["sabastaentertainment.com",[318,2106]],["sallerikhabar.com",318],["taksarnews.com",318],["thenepaltop.com",318],["janaboli.com",320],["pokharanews.com",320],["tulsipurkhabar.com",320],["arthasarokar.com",321],["arthikawaj.com",[322,323,324]],["kapilvastupost.com",322],["yazhnews.com",[322,2513]],["newsindialive.in",322],["pchelplinebd.com",323],["rajnitiprotidin.com",[323,2063]],["arthoneeti.com",325],["arya-tv.com",[327,328]],["bbttimes.com",[327,471]],["dvgsuddi.com",[327,336,440,995]],["satyagrahanews.com",327],["thepublicworld.com",[327,2381]],["thesunrisetoday.com",[327,654,995,2388]],["deshkiaawaz.in",327],["jharkhandsandesh.in",327],["aryavi.com",330],["eparinews.com",[331,1050]],["gandakitimes.com",[331,1107]],["pathivaradaily.com",[331,1966]],["sajhadabali.com",[331,843]],["swadeshnepal.com",331],["asianbanglanews.com",332],["asianetnews.com",333],["sathiyam.tv",[334,523]],["asrilanka.com",[336,337]],["digantabani.com",[336,942]],["khelarpata.com",[336,440,443,995]],["ktmdainik.com",[336,1548]],["newsganj.com",[336,475]],["newstodayinhindi.com",[336,443]],["techtamil.com",[336,2334]],["pradhanavartha.in",[336,1065]],["muznews.net",[336,2911]],["sanmarg.in",[337,765,2773]],["aswamedham.com",338],["atalhind.com",339],["atalsamachar.com",[341,342]],["atalstambh.com",[343,344]],["bharatvarshnews18.com",343],["goodmorningnation.com",[343,1145]],["hakikatnews.com",[343,344]],["khabarmantri.com",343],["mpkhabar.com",[343,344]],["news4indiatv.com",[343,1145,1479,1831]],["rajnewsupdate.com",[343,1145]],["mpcgtoday.com",345],["navpravah.com",345],["navsancharsamachar.com",[345,1763]],["satkhira24news.com",345],["shadhinkhobor.com",345],["shoutmehindi.com",[345,2230]],["biharpatrika.in",[345,1330,1369,2564]],["atozpatrika.com",346],["setohimalnews.com",348],["telugumuchatlu.com",348],["theutkal.in",348],["attingalvartha.com",350],["atulyaloktantranews.com",351],["awazeuttarpradesh.com",351],["deshrupantor.com",[351,424,919]],["navrashtramedia.com",351],["ottrancheithi.com",351],["shomoynews.com",351],["theevakam.com",[351,745]],["ainnews.tv",351],["aurbta.com",[352,353]],["ausnepalnews.com",355],["avadhkiaawaz.com",356],["dainikkirankamal.com",[357,703]],["hbharat.com",358],["janadhikarmedia.com",358],["jhanjhattimes.com",358],["medianp.com",[358,1102,1677]],["nnews24.com",[358,1897]],["siwanbazar.com",[358,604,974]],["clearnews.live",[358,867,2066]],["aviralsamachar.com",360],["suryarekha.com",360],["realtimes.in",360],["aviratvaatchal.com",361],["biswabanglanews.com",[361,577]],["mahaxpress.com",361],["watnopaarpunjabinews.com",361],["avnpost.com",362],["awaaz24x7.com",363],["awaazindiatv.com",364],["awajmedia.com",365],["barnalatoday.com",[365,447]],["bbc71.com",365],["dailybanglarrup.com",[365,479,787]],["dailyrajshahibarta.com",365],["dainikdehat.com",365],["deshbanglabd24.com",365],["independentkhabar.com",365],["islamtime24.com",365],["middleeastchandrika.com",[365,1687]],["politicsnews24.com",[365,860,1985]],["sanmarga.com",365],["suprovatuttarbango.com",365],["tajakhabaruttarakhand.com",365],["magadhnews.co.in",365],["bihari.news",365],["awajnews.com",[366,367]],["sahmatnews.com",[366,2120]],["srimanexpress.digital",[366,2521]],["dbnnews.in",366],["malayalamexpress.in",366],["veerdharanews.com",[367,2478]],["biharharpalnews.com",369],["sadeaalaradio.co.nz",[369,2981]],["bntlive.com",370],["ghumtidunia.com",370],["independentcitizennews.com",[370,372]],["livestorytime.com",[370,1586]],["news24x365.com",[370,765]],["rbnewsindiagroup.com",370],["thekhabrilal.com",370],["up18news.com",[370,1198]],["usmalayalees.com",370],["apradhprahari.in",370],["khabarwala.news",[370,866]],["aapabhitak.tv",[370,2537]],["ayodhyasamachar.com",371],["ayushindianews.com",[372,373,374]],["dharuvu.com",[372,939]],["fbdnews.com",[372,903,1072]],["fenirzamin.com",[372,485]],["globalsylhet.com",372],["himantar.com",[372,1231]],["hindiduniyaa.com",372],["jobareabd.com",372],["khabromehamarashahar.com",[372,1290]],["knewsgujarati.com",372],["mirsaraitimes.com",[372,838]],["muzaffarpurwow.com",[372,1716]],["pradeshdainik.com",[372,689,1190]],["sudarshankhabar.com",372],["amritvarshanews.in",[372,476,1102,2543]],["opensearch.co.in",372],["madhubaninews.in",372],["khabardinbhar.net",[372,643,933]],["nationalvision.news",372],["newshunter.online",[372,2985]],["azadsandesh.com",375],["bikashnews.com",[375,569,570]],["chattogramersomoy.com",[375,684]],["chitwanpress.com",[375,706]],["himnewspost.com",375],["nepalsandesh.com",[375,1806]],["newsviewspost.com",375],["reporterseye.com",[375,2083]],["peoplenews.lk",375],["nainitalsamachar.org",375],["azadsipahi.com",376],["entertainmentkhabar.com",376],["khabarpurwanchal.com",376],["state7online.com",[376,2271]],["surabhisaloni.co.in",376],["suryaa.co.in",376],["gnebangla.in",376],["pcbtoday.in",376],["dailyjuboraj.com",[380,807]],["tadantachitra.com",380],["deshergarjan.net",[380,2897]],["songkalpo.net",[380,2929]],["baahrakhari.com",[381,382]],["dekhapadhi.com",381],["capitalnepal.com",[382,637]],["khelpati.com",[382,1345]],["nepallive.com",382],["babuaa.com",383],["backtobollywood.com",[384,385,386]],["gossiplankanews.com",[384,1153]],["vasundhara.net",386],["bagmativoice.com",387],["bahumatrik.com",[388,389]],["bvnews24.com",389],["dailyjanakantha.com",[389,804]],["cinetimee.com",391],["lankac.news",391],["canarabuzz.com",392],["taazakhoj.com",[393,1152]],["tahkikatsamachar.in",393],["bangalianaa.com",396],["bangalorewaves.com",397],["bangla-news24.com",398],["livebavaal.com",399],["phaddalo.com",399],["seithisolai.com",399],["sirajganjnews24.com",[399,2240]],["aapkakhabri.co.in",399],["dastavej.in",[399,850,2413]],["vatankiawaz.in",[399,933]],["24city.news",399],["mkantho.com",400],["sobkhobar.com",400],["bangladesherkhela.com",401],["silkcitynews.com",[401,2237]],["bangladeshglobal.com",[402,403]],["enewsmp.com",403],["aapkaparyas.in",[403,2535]],["bangladeshonline24.com",404],["bangladeshsangbadpratidin.com",405],["bangladhara.com",406],["banglainsider.com",407],["banglalive.com",[408,409]],["banglarjanarob.com",409],["banglanews24.com",410],["banglanewsca.com",412],["banglaralonews.com",414],["banglarawaj.com",415],["chilahatiweb.com",[415,461]],["kushiyaranews.com",[415,458]],["samjhobharat.com",[415,2151]],["upayuktha.com",[415,1282,2450]],["banglarchithi.com",[416,417]],["bdsomachar24.com",[416,492]],["dristyprotidin.com",[416,492,988]],["moulvibazar24.com",[416,1700]],["somoyerkontha.com",[416,2252]],["hakkatha.com",417],["govindia.in",[418,1258,2637]],["banglatribune.com",[423,424]],["banglavashi.com",425],["dhangadhikhabar.com",[425,938]],["zeenews.india.com",[425,1288]],["bankbimaarthonity.com",[427,428]],["biniyogbarta.com",[428,572]],["doshdik.com",[428,984]],["janomot.com",[428,1361]],["bankingkhabar.com",429],["bankingsansar.com",430],["bankura24x7.com",[431,432,433]],["bhilwarahalchal.com",[432,534,535]],["dailythanthi.com",[432,840]],["dhanamonline.com",[432,534,936,937]],["janjwar.com",[432,1357]],["maalaimalar.com",[432,1612]],["madhyamam.com",[432,1621,1622]],["rewariyasat.com",[432,2088]],["npg.news",[432,2962]],["jantakiawaz.org",[432,1185,2368]],["hmtvlive.com",[433,1255,1256]],["thejasnews.com",[433,2368,2369]],["swadeshnews.in",[433,1134,2792]],["tv5news.in",[433,2811]],["bansalnews.com",434],["ctr24.com",434],["deshersangbad.com",434],["marathwadaneta.com",[434,1664]],["snpsports24.com",[434,732,2247]],["bansgaonsandesh.com",435],["bantwaltimes.com",437],["barciknews.com",438],["bareillylive.com",439],["bidhannagartimes.com",[440,548]],["cgctnews.com",440],["cityhotnews.com",[440,643,724,725]],["newsnetworks.co.in",[440,443]],["cricnewz.in",440],["maithilmanch.in",440],["sanskardarshan.in",[440,643,2774]],["barisalcrimetrace.com",441],["barisalpress.com",442],["desherpotrika.com",443],["onlinenepal.com",[443,1931]],["emediacreative.in",443],["lokvarta.net",443],["lokwarta.net",443],["barishalnews24.com",444],["bornamelanews24.com",[444,611]],["coxsbazaralo.com",444],["dainikkishoreganj.com",444],["durnitibarta.com",444],["gouripurnews.com",444],["itihas24.com",444],["saplatv.com",444],["chandpur24.net",444],["theeditors.net",444],["barishaltimes.com",445],["dharitri.com",445],["barlekhanews24.com",446],["barnanmedia.com",[448,449,450]],["merofilm.com",[449,450,741]],["mynewsnepal.com",450],["avenues.tv",450],["bartabangla.com",[451,452]],["mymarathi.net",[452,2912]],["bartamanbangladesh24.com",454],["tritiyamatra.com",454],["bartamanpatrika.com",455],["bastarkiaawaz.com",[456,457]],["colombotoday.com",457],["cnblive.com",[458,461,544]],["punalurnews.com",[458,2036]],["ukliveuttrakhand.com",458],["insightchhattisgarh.in",[458,2663]],["poonththalir.blogspot.com",[459,588,589,590]],["gandhawarta.com",459],["jalorenews.com",459],["jaunpurlive.com",[459,1371]],["shivpurisamachaar.com",459],["spyviewnews.in",[459,1911,2789]],["shortnews.lk",459],["battirepnews.com",[461,462]],["ekumaon.com",[461,544]],["eluvannews.com",461],["malwalive.com",[461,1648]],["nbcbangla.com",461],["kolhapurlive.in",[461,2685]],["tamilarul.net",[461,1911,2933]],["batukamma.com",[463,464]],["paridarshaka.com",[463,475,859,1564]],["rashtranayaknews.com",[463,565,2072,2073]],["vindhya24news.com",463],["viralfactsindia.com",463],["bayanno.com",465],["bbc24news.com",466],["chtmedia24.com",466],["bbcpunjab.com",467],["bbn24news.com",[468,469]],["dainikathah.com",469],["sbharatnews.com",[469,725]],["bbsrreporters.com",470],["samajeralo.com",[471,2139]],["dainikmaharajganj.in",[471,1117,2616]],["manzilnews.in",471],["capitalnews.lk",471],["bcsuddi.com",472],["muktirlorai.com",[473,492,713]],["notunerkotha.com",[473,1901]],["rajshahinews24.com",[474,2067]],["hdhrm.com",[475,476]],["pokharacity.com",[475,1981]],["sgstvtelugu.com",475],["thedastak24.com",[475,604]],["veekshanam.com",475],["janadeshexpress.in",[475,2666]],["bundelkhandvoice.com",[476,623]],["comillait.com",476],["gharkavaidya.com",476],["hindustan18.com",476],["jagrotobangali.com",476],["janamanas.com",476],["janawajnewslive.com",476],["januday.com",[476,949,1369]],["kishorgonj.com",476],["live7tv.com",[476,1105]],["livepress24.com",[476,1257]],["matribhumisamachar.com",476],["muthalvannews.com",[476,519]],["navyugsandesh.com",476],["ramprahar.com",476],["samacharmedia.com",476],["tamilvoicenews.com",476],["todayindia.com",[476,2412]],["vedsansar.com",476],["groundzeroenews.co.in",[476,1530,2587]],["crimeuttarakhand.in",476],["revoi.in",476],["saurashtratimes.in",476],["uttarakhandkesari.in",476],["satnanews.net",476],["bdbarrta24.com",[477,478]],["sunbd24.com",[477,2284]],["bn.bdcrictime.com",480],["janakhabar.com",[480,1339]],["padmatimes24.com",[480,781,1942]],["raftaarindianews.com",[480,1412]],["sankalpsavera.com",[480,2182]],["swisspungudutivu.com",480],["voiceofshatabdi.com",[480,974]],["bdcrime24.com",481],["bdcrimenews.com",[482,483]],["jamalpurlive.com",[482,1335]],["bdipo.com",484],["bijoynewsbd24.com",[485,516,564,565]],["haqeeqattoday.com",[485,526,838]],["odishalink.com",[485,933]],["scotnepal.com",485],["kannurvarthakal.in",[485,565,643]],["katghara.in",485],["prajawani.in",[485,516,565,643]],["trendnew.in",[485,703]],["starexpress.news",[485,516,564,565,933]],["bangla.bdnews24.com",486],["bdnews999.com",487],["bdnewsclub.com",488],["nitharsanam.net",488],["bdnewshour24.com",489],["bdprojonmo71.com",490],["bdsangbadpratidin.com",491],["dainikdeshersathe.com",[491,852]],["fenirkotha.com",[491,1075,1076]],["natuncumilla.com",[491,1075]],["europemalayali.co.uk",[491,3027]],["dinajpur24.com",[492,828,954,955]],["malisamajsocial.com",492],["probashbarta.com",[492,2021,2022]],["thebengalitimes.com",[492,881,2356]],["virakesari.lk",[492,2876]],["bdsomoy24.com",493],["bdtimes365.com",494],["bdtoday24.com",496],["beauronews.com",[498,499]],["headline24x7.com",[498,1204,1205]],["khabarduniya.com",498],["beautynewsnepal.com",500],["bebakmanch.com",501],["bebakshakti.com",502],["bebakuttarakhand.com",503],["bharatbarta.com",504],["healthbangla.com",504],["rcbrn.com",504],["deepamnews.lk",[504,867]],["bekhauphindia.com",505],["benkiyabale.com",507],["bethanchokkhabar.com",509],["nepalpress.com",[509,1634]],["betulsamachar.com",510],["dailynews24.in",[510,2613]],["nearnews.in",510],["paharipatrika.in",[510,2613]],["bhadas4media.com",[511,512]],["inkpoint.in",512],["bhaiyajinews.com",513],["bhaktibharat.com",514],["bhalukanews.com",515],["bhanjyangnews.com",516],["filmybahar.com",[516,933]],["gnews5.com",[516,1117]],["swatantradastak.com",516],["visfotnews.com",[516,565,933]],["odishakhabara.in",516],["bharatdarshannews.com",517],["janpadnewslive.com",[517,1362]],["bharathalchal.com",518],["bharathvaibhav.com",519],["kottayammedia.com",[519,884]],["orthosongbad.com",519],["prajasattaknews.com",[519,2003]],["keralaspeaks.news",519],["dharananews.com",520],["sanjaygram.com",520],["bharatkiawaj24.com",521],["dearfacts.com",522],["doabatimes.com",[522,976]],["loktantrakaagaz.com",522],["malayalamdailynews.com",522],["bengaluruvartha.in",[522,2555]],["gujaratmirror.in",[522,1330]],["sunlightnews.in",522],["bharatpostlive.com",523],["tamizhakam.com",523],["wayanadnewsdaily.com",[523,621,2496]],["naanmedia.in",[523,1472]],["bharatprawah.com",524],["bhartianews.com",[525,526]],["bhaskar.com",527],["divyamarathi.bhaskar.com",528],["bheldailynews.com",[530,531]],["navsatta.com",[531,1764]],["samaynewslive.com",[531,1372]],["sustothaki.com",531],["thehawabaaz.com",531],["vikalptimes.com",[531,2484]],["mithilacitynews.in",[531,1590]],["lalitpurfastnews.com",532],["filmchilive.com",[534,1078]],["bhilwarasamwad.com",[536,537]],["nagarprabha.org",[537,2994]],["bhnnews.com",538],["bholahatchitro.com",[539,540]],["sunbanglanews.com",539],["bholanews24.com",542],["bhopalsamachar.com",[544,545,546]],["ezhomelive.com",[544,1064]],["jaldhakanews.com",[544,586,593,1163,1333]],["sahityarachana.com",[544,2119]],["ekusheymedia.com",545],["gossip99.com",[545,1152]],["newscity.co.in",[545,2599]],["bhorerkagoj.com",547],["dailysharebazarprotidin.com",[548,835]],["currentpoltics.in",[548,703]],["dnewsnetwork.in",[548,703,2624]],["bidrohee.com",[549,550]],["drukpadam.com",[550,990]],["uttarkal.com",550],["bigkhabar.com",[551,552]],["cricket97.com",[552,750]],["dpcnews24.com",552],["biharaaptak.com",553],["bihardootnews.com",[554,555,556]],["news30express.com",554],["sansanikhejsamachar.in",554],["thenewsblast.com",556],["biharnewsindia.com",559],["himalipatrika.com.np",[559,838,2905]],["khagracharipratidin.com",[560,1385]],["biharnownews.com",[561,562]],["kalpa.news",[562,2953]],["bijoybanglabd.com",563],["dailynewshindi.com",[564,816]],["dhakardak-bd.com",[564,565,933]],["fairnepal.com",564],["lokatantraonline.com",[564,933]],["voiceofsatkhira.com",565],["ranchilive.in",565],["chandrikadaily.qa",[565,3002]],["bikalpadainik.com",566],["bikaner24x7news.com",567],["bikanerhulchul.com",568],["udupitimes.com",[570,2433]],["biratkhabar.com",573],["malnadtimes.com",[574,1647]],["thepoliticsagain.com",[574,2378]],["bishwabarta.com",575],["dailyoporad.com",[575,820]],["bishwanathbd24.com",576],["biswabanglasangbad.com",578],["biyanitimes.com",579],["prabhavnews.com",581],["bizshala.com",582],["blastkhabar.com",583],["blivenews.com",584],["newspoint24.com",[584,663,1872]],["odiagossip.com",[584,1913]],["toptamilnews.com",[584,1890,2419]],["himachalcrimenews.blogspot.com",585],["gramsamachar.com",[586,1162,1163]],["rknewsofindia.com",586],["nunworajasthan.co.in",[586,587]],["lakshynew.blogspot.com",587],["reporters7.com",587],["priyokulaura.com",[590,693,1553,1618]],["newmannar.lk",[590,1618]],["punalurnews.blogspot.com",591],["rujalanews.blogspot.com",592],["top99breakingnews.blogspot.com",593],["kalviseithi.net",593],["bnewskolhapur.com",[594,595]],["shikkhakantho.com",594],["bnnbharat.com",596],["himshimlalive.com",[597,974]],["techmahadev.com",597],["vaarte.com",[597,1351]],["voiceofnationnews.com",[597,1030]],["boishakhinews24.com",599],["brahmanbaria24.com",599],["boishakhionline.com",600],["bojrokontho.com",601],["gujarattimesusa.com",[601,1169]],["shabdonews24.com",601],["teesarakhamba.com",601],["vijaykarnatakaepaper.com",[601,2483]],["telugu.boldsky.com",[602,603]],["telugu.drivespark.com",602],["telugu.filmibeat.com",[602,1082]],["telugu.mykhel.com",[602,1722]],["telugu.goodreturns.in",[602,2636]],["bolpanipat.com",604],["khabriyanews.com",[604,1509]],["kulalworld.com",[604,1550,1551]],["hellomaharashtra.in",604],["uluberiasambad.in",604],["bonikbarta.com",607],["boolokam.com",608],["bordernewsmirror.com",609],["jamalpurbarta.com",612],["keralabreaking.com",612],["thebharatnama.com",612],["thepunjabwire.com",612],["cgimpact.org",[612,1119]],["britishpathram.com",614],["bslnews24.com",615],["bsnknews.com",616],["bspabla.com",617],["sunaminewstv.com",619],["checkpostnews.com",[620,643]],["mobilenews24.com",620],["sanatanjan.com",[620,1884]],["tamizhdb.com",[620,859,1028,1258,2325]],["pahadkasach.in",[620,1945,2745]],["samacharbharti.in",621],["gnewsindia.com",[623,1139,1140]],["khabarchalisa.com",[623,652,1472,1473]],["business-standard.com",624],["hindi.business-standard.com",625],["bwazarakatha.com",630],["canadamirror.com",[632,633]],["ibctamilnadu.com",632],["lankasri.com",[632,1570]],["manithan.com",[632,633,1654,1655]],["cineulagam.com",633],["ibctamil.com",[633,1275]],["jvpnews.com",[633,1394]],["news.lankasri.com",633],["tamilwin.com",633],["viduppu.com",633],["canchannels.com",634],["capitallivenews.com",[635,636]],["farwesttimesdaily.com",[636,1068]],["setokhari.com",637],["careerintelligencebd.com",638],["dailylalsabujer11nosectorofbd.com",639],["dailynotundiganto.com",639],["shamoybarta.com",639],["deshtimes24.news",639],["cdnews24.com",640],["cellitnews.com",641],["celluloidonline.com",[642,643]],["kilinochchinews.com",643],["kotajagran.com",643],["krantiodishanews.com",[643,1542]],["mediapoint24.com",[643,1679]],["punjabiakhbar.com",[643,2041]],["shabdshodh.com",[643,1366]],["24hrnews.in",[643,2526]],["chhattisgarhcrimes.in",[643,2573]],["dainiktimes.co.in",643],["overlook.co.in",[643,1129,2602]],["channeltoday.net",[643,1541]],["cgjanadesh.com",[646,647]],["kaimurlive.com",646],["cgnewsonline.com",650],["cgsandesh.com",651],["indianamo.com",652],["odiannews.com",[652,1914]],["newsway.in",[652,2733]],["chaalchalan.com",654],["digitaltrend-news.com",654],["garhwalkavikas.com",654],["thesingoritimes.com",[654,1132,2386]],["chaipanchayat.com",655],["chakrapath.com",657],["kendrabindu.com",[657,1453]],["onlinetvnepal.com",657],["abcnepal.tv",657],["chakrikhobor.com",658],["chamaktaaina.com",659],["chandpurnews.com",664],["mithapukur24news.com",664],["moonamvazhi.com",[667,1697]],["chandpursangbad.com",668],["chandpurtimes.com",[669,670]],["indiaupdate.co.in",670],["hindustanheadlines.in",[670,933,2646]],["chandreknews.com",671],["channel6bd.com",672],["channeldurjoy.com",674],["channelionline.com",675],["channelrb.com",676],["chapaidarpon.com",678],["voiceofbihar.in",[678,1118,1120,2825]],["livebihar24news.com",[679,1581]],["chatganrbani.com",[680,681]],["mirzapurnews.com",681],["chatonay71news.com",682],["chattogramerpatrika.com",683],["chattogramnews.com",685],["chattolarkhabor.com",[686,687]],["delhinews24.com",686],["indiareportertoday.com",[686,1297]],["kalingajyoti.com",[686,1408]],["nyayabatilive.com",686],["sakalakhabar.com",[686,1105,2125]],["thesakala.in",686],["chaukastoli.com",688],["newsvariant.com",[688,1884]],["rajsattanews.com",[688,2066]],["chautarikhabar.com",689],["hamromat.com",[689,1190,1191]],["chennaitodaynews.com",691],["chennaivision.com",692],["kalvinews.com",[693,1128]],["chhaharinetwork.com",695],["swornimkhabar.com",695],["chhapratoday.com",[696,697]],["songbadpratidin.com",697],["chhattisgarhaaj.com",[698,699]],["panpadu.com",698],["pratyeknewslive.com",[698,2013]],["legendnews.in",[698,2689]],["khabaraaptak.net",698],["chhattisgarhtimes.com",701],["satyaketansamachar.com",[702,1066]],["siwanonline.com",[702,924]],["chirirbandar.com",703],["mirrorlive24.com",703],["nayabihar.com",703],["atnbanglaonline.tv",703],["chitrodesh.com",[704,705]],["nzpunjabinews.com",[708,1910]],["chttoday.com",709],["sanjevani.com",[711,2180]],["cinejosh.com",712],["enavabharat.com",[713,1043]],["kositimes.com",[713,768,1539]],["seradesh.com",[713,2207]],["cinemapressclub.com",[714,715]],["cinemavalai.com",716],["cinepati.com",717],["cinereporters.com",718],["cinesamugam.com",719],["citinewslive.com",720],["citiupdate.com",721],["cityandolan.com",722],["ttncinema.com",722],["livebharatnews.in",[722,2691]],["janaagaj.in",724],["drishtinow.com",725],["janmantra.com",725],["jayhosh.com",[725,1373]],["kahalenews.com",[725,1397,1398]],["kubiyonews.com",725],["prajakiran.com",725],["sankalpakhabar.com",[725,2181]],["siyasatdarpan.com",[725,2243]],["speednewskannada.com",[725,2261]],["mootv.in",725],["britishkairali.co.uk",725],["citykhabre.com",726],["cityliveindia.com",727],["citynewsdhaka.com",[729,730]],["citynewsexpress.com",731],["citynewsgiridih.com",732],["citynewshindi.com",733],["clickmandu.com",735],["healthaawaj.com",735],["himalpost.com",735],["janatatimes.com",[735,1350,1351]],["khasokhas.com",[735,1515]],["livemandu.com",735],["nagarikkhabar.com",735],["newsofnepal.com",735],["postkhabar.com",735],["thecinematimes.com",735],["yohokhabar.com",735],["cnewsbharat.com",736],["cninews24.com",[737,738]],["newsallbangladesh.com",737],["computerbichitra.com",740],["corporatenepal.com",[741,742,743,744]],["thahakhabar.com",[742,2349]],["nepalbahas.com",[744,1779]],["purbelinews.com",[744,1022,2050]],["mybenipatti.in",[747,2711]],["coxbangla.com",748],["coxsbazarnews.com",749],["hindi.cricketnmore.com",752],["crimebarta.com",753],["crimediarybd.com",754],["crimejunction.com",755],["crimemukhabir.com",756],["crimenazarnews.com",[757,758]],["joddha.com",757],["nammudekodakara.com",757],["risalaonline.com",757],["sivantv.com",757],["crimenewsnepal.com",759],["ctgsangbad24.com",761],["nayabangla.com",[761,1766,1767]],["sangbaddiganta.com",761],["crimesuspence.com",762],["cs24bd.com",763],["primenewsbd.com",763],["ctgbarta24.com",764],["despardesweekly.co.uk",[765,1030,2101,3026]],["ctgdailynews24.com",766],["ctgpratidin.com",768],["ctgtimes.com",769],["ctnewsbd.com",770],["kollywoodvoice.com",[770,1084]],["prottashitoalo.com",770],["kdnewslive.in",770],["cumillasdnews24.com",771],["cvoice24.com",[773,774]],["eyenews.news",773],["dabangawaj.com",775],["fastindianews.com",[775,1069]],["shatabdinews.com",[775,2219]],["tahalaka.in",775],["dabangrajdhani.com",776],["daijiworld.com",777],["dailyajkerbarta.com",778],["dailyajkertalash.com",780],["sangbadpratidin.in",[782,2772]],["dailyamadercomilla.com",783],["dailybangladeshbani.com",786],["newspage13.com",787],["dailydeshkidharti.com",789],["jankipul.com",790],["inews.zoombangla.com",790],["abcnews.media",790],["dailyfaridgonj.com",792],["dailyfaridpurkantho.com",793],["dinakaran.com",[793,958]],["dailyfenchugonj.com",794],["dailyghagot.com",796],["mathagal.net",[798,2909]],["dailyindianherald.com",799],["dailyinshort.com",801],["dailyjagoran.com",802],["dailyjonomot.com",[805,806]],["theholytimes.com",[806,2367]],["dailykaratoa.com",[809,810]],["dainikshiksha.com",[810,879]],["saralpatrika.com",810],["ichowk.in",810],["dailykesari.com",811],["dailykhowai.com",812],["dailynabochatona.com",813],["dailynarayanganjerdak.com",[813,814]],["dailyolamakantho.com",[817,818]],["nationalpresstimes.com",817],["welcomeindianews.com",817],["tbcgzb.in",817],["dailyonusondhan.com",819],["passengervoice.net",819],["dailyprovatbela.com",821],["dailypunjabnews.com",822],["dailypunorutthan.com",[823,824,825]],["dhakanews24.com",[823,824]],["daynightnewsbd.com",824],["jagonarsingdi24.com",824],["newswin24.com",824],["dailypurbodesh.com",826],["dailyrajbarikantha.com",827],["dailyrangpur.com",828],["dailyreportbd.com",829],["dailysabuj.com",830],["dailysangbadprotidin.com",831],["globaltamilnews.net",832],["dailyshapoth.com",833],["dailysokalersomoy.com",837],["janshaktikranti.com",[838,1366]],["newzzar.com",838],["dailyuttorpurbo.com",841],["dainik4media.com",842],["dainikagnipath.com",843],["dainikamadershomoy.com",844],["dainikbharat24.com",845],["dainikcharghat.com",848],["dainikchintak.com",[849,850,851]],["cgnews24x7.wordpress.com",[849,2192,2303,2507]],["konnivartha.com",850],["thenewswave.com",850],["brightpost.in",[850,2568]],["janmat.co.in",850],["dthreeonline.com",[854,991]],["ekushejournal.com",[854,1034]],["lokhitexpress.com",[854,1593]],["ramailochha.com",854],["royalnews13.in",[854,1123]],["dainikhindmitra.com",856],["dainiki.com",857],["dainikjaltedeep.com",[859,860]],["londonbdnews24.com",[859,1606]],["manvadhikarabhivyakti.com",[860,1661]],["slogannews.com",860],["dainikjanwani.com",861],["dainikjharkhand.com",[862,863]],["jaunpur24.com",[863,995,1047,1126,1370]],["pressmirchi.com",863],["dainikkhabraan.com",864],["dainiklivenews24.com",865],["dainiklumbini.com",866],["dainikmas.com",867],["newsmalwa.com",867],["economicbd.com",868],["sharebarta.com",868],["sharesangbad.com",868],["sharebarta.net",868],["dainiknavraj.com",870],["odishamirror.com",[872,1917]],["dainiknepal.com",873],["samayapost.com",[873,2136,2145]],["dainiknepal.com.np",873],["dainikparibarton.com",874],["dainikpurvoday.com",875],["dainikroorkee.com",876],["dainiksandhyaprakash.com",877],["dainiksatkhira.com",878],["dainiktribuneonline.com",881],["netizennepal.com",881],["dainikvishwamitra.com",883],["dakhinanchal.com",885],["poojanews.com",885],["dakshinbharat.com",887],["purvanchalsandesh.com",887],["swatantrabharat.net",887],["damrua.com",[890,891]],["graminujala.com",[890,1159,1160]],["hamarahathras.com",[890,1183]],["manavadhikarsandesh.com",890],["kannada.newskarnataka.com",890],["nirbhiknazar.com",890],["rsnews24.com",890],["damstv.com",892],["dandikaanthi.com",893],["khabarindia24x7.com",893],["daniksamachar.com",894],["daunnenews.com",895],["dcnepal.com",897],["khullamanch.com",[897,1039,1526]],["makalukhabar.com",[897,1633,1634]],["dcnewsbd.com",898],["ddnews24x7.com",899],["deepika.com",900],["delhicrimepress.com",901],["ksdlivenews.com",[901,1547]],["delhiuptodate.com",[902,903]],["wayanadlivenews.com",902],["democratictvnews.com",904],["derbykhabar.com",905],["deshabhimani.com",[906,907]],["gonews24.com",[907,1143]],["deshajtimes.com",908],["deshdoot.com",[910,911]],["saamtv.esakal.com",[910,1052]],["sarkarnama.esakal.com",[910,1053]],["deshdorpon.com",912],["deshdorshon.com",913],["deshprahari.com",915],["deshpriyonews.com",916],["deshprotikhon.com",[917,918]],["udayavani.com",[917,2432]],["deshsanchar.com",920],["desimartini.com",921],["desimediapoint.com",922],["devinenewz.com",923],["newschai.com",923],["thebanglareport.com",923],["dhadingnews.com",[925,926]],["industryhit.com",925],["dinamina.lk",[925,2849,2850]],["dhadingpost.com",927],["dhadingupdate.com",[928,929]],["onlinetajakhabar.com",928],["dhaka18.com",930],["dhakapost.com",[931,932]],["thenepaltoday.com",931],["tamilnewsstar.com",[933,2315,2316]],["dhakareport24.com",934],["dhakatoday.com",935],["janprahar.com",[936,1185,1363]],["dheivegam.com",940],["enavamaratha.com",940],["navdeshtimes.com",[940,1758]],["news7express.com",940],["newsinside24.com",940],["bengalwatch.in",940],["telugudesk.net",940],["digiana.com",943],["digitalkhobor.com",945],["ratdinnews.net",948],["digitalnewslive.com",[949,950]],["mahekasansar.com",[949,1369,1630]],["digontonews.com",951],["dildarnagar.com",952],["dilersamachar.com",953],["techvoice24.com",955],["dinajpurnews24.com",956],["news71.tv",956],["dinajpurtv.com",957],["dinamalar.com",959],["cinema.dinamalar.com",960],["sports.dinamalar.com",961],["dinamani.com",962],["dineshkhabar.com",963],["dinvishesh.com",964],["dirt-sheet.com",966],["dishadaily.com",967],["divaina.com",968],["divyahimachal.com",970],["divyalive.com",971],["dmoitry.com",[973,974]],["gazarianews.com",974],["legalvoice24.com",[974,1575]],["harinayak.in",974],["samriddhinews.in",974],["westerntimesnews.in",[974,1679]],["dnnnews24x7.com",975],["dokadamganvkior.com",977],["dokhinercrime.com",978],["dholamaru.co.in",978],["donetbd.com",979],["donnews.com",[980,981,982]],["imandarmedia.com",[980,981]],["onlinedabali.com",[980,1926]],["ratopost.com",[980,2080]],["sancharkendra.com",[980,981,2080,2164]],["doolnews.com",983],["dotooknews.com",985],["bmnews24.net",[985,2887]],["drikpanchang.com",986],["drivespark.com",989],["tamil.oneindia.com",[989,1721,1922]],["googlepokhara.com",[991,1147,1148,1149]],["duniyasamachar.com",992],["durjoybangla.com",994],["e-kantho24.com",997],["e24bollywood.com",998],["eastcoastdaily.com",1000],["kelanchaltimes.com",[1000,1135,1452]],["manasvivani.com",1000],["nepaltvonline.com",[1000,1139]],["capitalvoice.in",1000],["tismedia.in",[1000,1755]],["ebrightnepal.com",1001],["sudurpatra.com",[1001,2280]],["vakeesam.com",[1002,1929,2468]],["gujarati.economictimes.com",[1003,1004]],["eisamay.com",[1003,1004,1012,1013,1014,1015,1016]],["enlightnews.com",[1003,1046]],["indiatimes.com",[1003,1016,1298,1299]],["bengali.timesxp.com",1003],["uttaranews24.com",1003],["saaravita.lk",[1003,2865]],["alorkantho24.news",[1003,2945]],["marathi.indiatimes.com",[1004,1300,1301]],["navbharattimes.indiatimes.com",1004],["samayam.com",[1004,1015,1301,2143]],["eelamalar.com",1006],["eelamtimes.com",1007],["egoomedia.com",[1008,1009]],["newsfastweb.com",1010],["eimuhurte.com",1011],["iamgujarat.com",[1012,1015,1273]],["vijaykarnataka.com",[1016,1299]],["ejanshakti.com",1018],["ejjdin.com",1019],["ekaainabharat.com",1020],["maloutlive.com",1020],["sangritimes.com",1020],["nepalmamila.com",[1021,1792,1793,1794]],["newsroomme.com",[1021,1874]],["farakdhar.com",1022],["ukeraa.com",1022],["ekantipur.com",1024],["ekattorbanglanews.com",[1025,1026]],["kannurnewsonline.com",[1026,1426]],["abnewslive.in",[1026,2538]],["ekattorlive.com",1027],["firstuttarpradesh.com",1030],["thenewhind.com",1030],["gnewsbd24.com",1031],["ekhon24.com",1032],["ekusheypatrika.com",1035],["elettilonline.com",1037],["elokasha.com",1038],["lokprashna.com",1038],["emailkhabar.com",1039],["nawalpurtimes.com",1039],["emountaintv.com",1041],["enepalese.com",1044],["enews71.com",1045],["entethiruvambady.com",1047],["newstruthlive.com",1047],["entevarthakal.com",1048],["esidhakura.com",1054],["etamilnews.com",1055],["ethiri.com",1056],["etvuttarakhand.com",1057],["eurobanglanews24.com",1058],["everestdainik.com",1060],["everesttimesnews.com",1061],["lokpath.com",1061],["exprestamil.com",1062],["eyenewsbd.com",1063],["mynews36.com",[1065,1725]],["futurekerala.in",1065],["aajtak24live.in",1066],["mrreporter.in",1066],["fastnewsbd.com",1070],["meherpurpratidin.com",1071],["udaipurkiran.in",1071],["fenchuganjnews.com",1073],["fenireport.com",1074],["filmcityworld.com",1079],["filmibeat.com",1080],["tamil.filmibeat.com",1081],["filmyfanda.com",1086],["filmykhabar.com",1087],["firstbihar.com",1089],["firstindianews.com",1090],["firstverdict.com",1091],["flowersoriginals.com",1092],["twentyfournews.com",1092],["maloutlive.flykingimmigration.com",1093],["fmhindi.com",1094],["fmnews24.com",1095],["fns24.com",1096],["focusbd24.com",1097],["focusmohona.com",1098],["fourteenkerala.com",[1099,1100]],["freelancerstory.com",1101],["gajabkhabre.com",1102],["janmanindia.com",[1102,1360]],["moonbreaking.com",1102],["gambhirmudda.com",1104],["ganaadhikar.com",1105],["jhabualive.com",1105],["minnal24.com",1105],["newstodaycg.com",1105],["sakshamuttarakhand.com",1105],["spreaditnews.com",1105],["sudurawaj.com",1105],["sudurpashimkhabar.com",1105],["tvannapurna.com",[1105,2429]],["newsnerve.in",1105],["upsamachar.org",1105],["hotpati.com",[1106,1263]],["gandaknews.com",1108],["gangnirchokh.com",1110],["garimatvnews.com",1111],["garjachhattisgarhnews.com",1112],["gaunsahar.com",1113],["gautamsandesh.com",1114],["gbnews24.com",1115],["geetanjalipost.com",1116],["madhyabhoomikeboal.com",[1119,1147,1619]],["dhamakachhattisi.in",1119],["ghaziabadparikrama.com",1124],["ghazipuraajkal.com",1125],["ghazipurtoday.com",1126],["gurugramnewsnetwork.com",1126],["gkprashnuttar.com",1131],["globalharyana.com",1132],["pkdnewschannelnoi.com",1135],["sarkariniyog.com",1136],["globenepal.com",1137],["gmnewsbd.com",1138],["goindianews.com",1141],["gondwanaexpress.com",1142],["gonokantho.com",1144],["khabarbhartiindia.com",1145],["medicallife.in",1145],["goodnewsbharat.com",1146],["janatakoaawaj.com",1148],["panchakoshitimes.com",[1148,1950]],["samabesionline.com",1148],["sangalokhabar.com",[1148,2170]],["gourbarta24.com",1154],["gramajyothi.com",1156],["gramerkagoj.com",1157],["gramintimes.com",1158],["ibn24x7news.com",[1159,1178,1276]],["patrikajagat.com",1159],["shriramjankitimes.com",1159],["gramnagarbarta.com",1161],["vbnews24.com",[1163,2475]],["telugu.greatandhra.com",1164],["grehlakshmi.com",1165],["gujaratimidday.com",1168],["khabribox.com",1169],["londonnepalnews.com",[1169,1607]],["gujaratvaibhav.com",1170],["gulfmalayaly.com",1171],["gulte.com",1172],["telugu.gulte.com",1173],["gunjankhabar.com",1174],["gurgaonmail.com",1175],["gvoice24.com",1177],["gyanipandit.com",1179],["hajurkokhabar.com",1180],["haldwanilive.com",1181],["halokhabar.com",1182],["hamdardmediagroup.com",1185],["prajapragathi.com",1186],["hamrobiratnagar.com",1187],["hamrokhabar.com",1188],["hamrokhelkud.com",1189],["hamrosandesh.com",1192],["dainikujagarkhabar.in",[1193,2617]],["harekpal.com",1194],["haribhoomi.com",1195],["harithakeralamnews.com",1196],["hariyalinepal.com",1197],["harmudda.com",1198],["janakeeyam.in",1198],["4pillar.news",1198],["haryanaekhabar.com",1199],["haryananewsexpress.com",1201],["haryananewsonline.com",1202],["rkexpose.com",[1204,2092]],["hellobanswara.com",1206],["hellobikaner.com",1207],["helloswasthya.com",1208],["hellouttarakhandnews.com",1209],["hetaudakhabar.com",[1213,1214]],["nepalipatra.com",1213],["sulsule.com",1213],["himachalabhiabhi.com",[1217,1218]],["ujyaaloonline.com",[1217,1530,2298,2438]],["upkikhabar.com",[1217,2453]],["himachalnownews.com",1219],["himachalreport.com",[1220,1221]],["ikvnews.com",[1221,1281]],["himaliawaj.com",[1225,1226]],["sahityapost.com",1226],["ontimenews.in",1226],["himalkhabar.com",[1229,1230]],["nayadainiki.com",1229],["kannadanews.today",1233],["hindi-news-today.com",1234],["hindifiber.com",1235],["sylhetprotidin24.net",[1237,2931]],["hindilok.com",1238],["hindinews24daily.com",1239],["hindisip.com",1240],["onelivenews.com",1240],["hinditips.com",1241],["elugutips.in",1241],["udaipurkiran.com",1243],["hindnama.com",1245],["hindusta24x7.com",1246],["hindustandailynews.com",1247],["jiwanjotsavera.com",1247],["hindustannewsexpress.com",1249],["marathi.hindustantimes.com",1250],["hknepal.com",1254],["specialcoveragenews.in",[1256,1357,2788]],["whatinindia.com",1258],["newslab24.in",[1258,2158]],["bestnow.in",1259],["hollywoodkhabar.com",1260],["hongkar.com",1261],["horizonhind.com",1262],["hpnewsatl.com",1264],["hrbreakingnews.com",1265],["hulakpatra.com",1266],["onlinenews7.com",1266],["hulchalnews24.com",1267],["hulchalpunjab.com",1268],["humarabikaner.com",1269],["humhindustanilive.com",1270],["humsamvet.com",1271],["i-news24.com",1272],["iautoindia.com",1274],["iimtnews.com",1280],["ilamai.com",1282],["hindinetnews.in",1282],["ilsheypar.com",1283],["inbnews24.com",1286],["india.com",1287],["tfipost.in",1287],["indianewsharyana.com",1290],["newsoneindia.com",1290],["thekanpur.com",1290],["haryana.indianews.in",1290],["bengali.indianexpress.com",1291],["newsnationtv.com",1291],["sathyamonline.com",[1291,2191]],["indiannewsroom.com",1293],["mbpratidin.com",[1293,1673]],["indianopinionnews.com",1294],["indiatv18.com",1302],["indiatv360.com",1303],["industrialpunch.com",1304],["prothomalo.com",[1306,2030]],["infoway24.com",1307],["inkhabar.com",1308],["innews16.com",1309],["upaharkhabar.com",1311],["irinjalakudalive.com",1313],["themenews24.com",1313],["irruppu.com",1314],["ishantimes.com",1315],["itvbd.com",1316],["jagarannews.com",1317],["jagatprahari.com",1319],["jagmarg.com",1320],["jagonarayanganj24.com",1321],["jagonews24.com",1323],["naidunia.com",[1325,1732]],["jagranjosh.com",[1326,1327]],["jagratilahar.com",1328],["jaianndata.com",1329],["kumudam.com",1329],["malayalamnewstimes.com",1329],["mycitydilse.com",1329],["pradeshajjtak.com",1329],["suragbureau.com",1329],["udaybulletin.com",1329],["youngvarta.com",1329],["aajtakmedia.net",1329],["rni.news",1329],["jaihindnewspaper.com",1330],["leading-news.com",1330],["jaihindustannews.com",1331],["jaijaidinbd.com",1332],["jaldimoney.com",1334],["janaaastha.com",1337],["janadhvani.com",1338],["janakikhabar.com",1340],["thenewskhazana.com",1340],["jananesan.com",1341],["janasanchar.com",1342],["janatapati.com",[1344,1345]],["janatasamachar.com",[1345,1349]],["janatarishtehaar.com",1346],["janatarnews24.com",1347],["janatarsylhet24.com",1348],["namasteholland.com",1351],["varthatrivandrum.com",1351],["janayugomonline.com",1352],["janbolnews.com",1353],["jandarshannews.com",1354],["janghatna.com",1356],["jankaritoday.com",1358],["janmadhyam.com",1359],["jansangathan.com",1364],["jansatta.com",1365],["jantabulletin.wordpress.com",[1366,1501]],["jantajanardan.com",1367],["jantaserishta.com",1368],["newstrack.com",[1368,1881]],["kadwaghut.com",[1370,1395]],["jaybharatnews.com",1372],["dailybihar.in",1372],["jeevalokam.com",1374],["jenerakhun.com",1375],["jharkhand-news.com",1376],["jhilko.com",1378],["jivanihindi.com",1380],["jjpnews.com",1381],["apnades.in",[1382,2547,2548]],["joginderposwal.com",1384],["kasaragodchannel.com",[1385,1438]],["motherlandpost.in",[1385,1438]],["jonopodsangbad.com",1387],["joynewsbd.com",1388],["jpworldnews.com",1389],["jubokantho.com",1390],["jubokantho24.com",1391],["jugantor.com",1392],["jugerkanthobd.com",1393],["kailarionline.com",1399],["kairalinewsonline.com",1400],["kairalynews.com",1401],["kalamlok.com",1403],["kalkionline.com",1409],["kalvikural.com",1410],["kalyankesari.com",1411],["kalyugkatehelka.com",[1412,1413,1414]],["roorkeehub.com",[1413,2097]],["kamanakhabar.com",1415],["kamdhenupost.com",1416],["kamuktastories.com",1417],["kanaighatbarta.com",1418],["kannadadunia.com",1421],["sabhavarthakal.com",1423],["kannadaprabha.com",1424],["kannurmetroonline.com",1425],["kanvkanv.com",1429],["kapotham.com",1430],["karainagar.com",1431],["karnatakamalla.com",1434],["karnatakavoice.com",1435],["karobardaily.com",1436],["kasargodvartha.com",[1439,1440]],["kashishnews.com",1441],["kasturinews.com",1442],["maagulf.com",[1443,1611]],["kathmandupress.com",1444],["kathmandutoday.com",1445],["kaumudiplus.com",1446],["kayakairan.com",1447],["kayalconnection.com",1448],["kayalpatnam.com",1449],["kbn10news.com",1450],["liveuttarakhand.com",1450],["sangbadcholoman.net",1450],["navshaktinews.com",1452],["keralafinance.com",1454],["keralakaumudi.com",1455],["keralanewshunt.com",1456],["keralaonlive.com",1458],["keralaviews.com",1460],["keralavisiontv.com",1461],["keraleeyammasika.com",1463],["kewalsach.com",1464],["kewalsachtimes.com",1465],["khabar36.com",1466],["khabar7clive.com",1467],["khabarcgnews.com",[1469,1470,1471]],["timesofswaraj.com",1470],["sinewstoday.com",1472],["khabardabali.com",1474],["khabardose.com",1476],["khabareast.com",1477],["khabarhekhabar.com",1479],["sameera.co.in",1479],["thenewswall.in",1481],["khabarhimachalse.com",1483],["thegandhigiri.com",1483],["khabarhouse.com",1484],["khabaribn7.com",1486],["smj24.com",1486],["khabarkunj.com",1488],["mediamalayalam.com",[1489,1676]],["khabarmala.com",1490],["nobokontho.com",1490],["khabarmukam.com",1491],["khabarmuluk.com",1492],["khabarpahad.com",[1492,1495,1496]],["khabarsameeksha.com",1492],["khabarodisha.com",1493],["mediyaan.com",1494],["satyamevtv.com",[1494,2197]],["khabarworld.com",1496],["khabarpradesh.com",1497],["khabarprawaha.com",1498],["sabaikosamachar.com",[1498,1561,2105]],["khabaruttarakhand.com",1500],["samacharagency.com",1500],["khabarvichar.com",1501],["satyasikha.com",1501],["khabor.com",1502],["khaboriya24.com",1503],["khabreaajtaklive.com",1506],["khamoshduniya.com",[1510,1511]],["shasansandesh.in",[1511,2781]],["khanjahanali24.com",1512],["khaptadonline.com",1513],["khaskhabar.com",1514],["khoborbari24.com",1519],["khoborersomoy.com",1520],["khosbasbarta.com",1521],["khulasa.com",1522],["khulasafirst.com",1523],["khulasaonline.com",[1524,1525]],["sridungargarhtimes.com",1524],["khulnagazette.com",1527],["spnewsbd.com",[1527,1988]],["kmassnews.com",1529],["knanayaworld.com",1530],["newsarchives24.com",1530],["newsdesk24.com",[1530,1848]],["samvaad365.com",[1531,2158,2159]],["knrchannel.com",1533],["kolomerbatra.com",1536],["koshionline.com",1538],["krantiprayas.com",1543],["krishibajar.com",1544],["krishnanews.com",1545],["krushinama.com",1546],["kulalaworld.com",[1549,1550]],["kurunews.com",1553],["adminmedia.in",1553],["singhamnewstv.in",1553],["kusenews.com",1554],["kushtianews24.com",1556],["kutchkhabar.com",1557],["kvartha.com",1558],["laatsaab.com",1559],["labanglatimes.com",1560],["lalitpurkhabar.com",1561],["lalluram.com",[1564,1565]],["lalmonibarta.com",1566],["lanka4.com",1568],["lankadawasa.com",1569],["bihartoday.net",1571],["lastnewsbd.com",1572],["latestlaws.com",1573],["lekaalionline.com",1576],["lekalionline.com",1577],["lifeglint.com",1579],["lightnewsbd.com",1580],["livehalchal.com",1582],["sandesh.com",1584],["livekeralanews.com",1585],["livetvkerala.com",1587],["localnewsodia.com",1588],["loginkerala.com",1589],["lokhitkipukar.com",1594],["lokjeewan.com",1595],["lokmat.com",[1596,1597]],["lokmatnews.in",[1596,2697]],["epaper.lokmat.com",1598],["lokpati.com",1600],["loksangbad.com",1603],["lokshahi.com",1604],["navjivanindia.com",[1604,1761]],["loktantrapost.com",1605],["lorai24.com",1608],["lumbinisanchar.com",1610],["madathakaja.com",1613],["madhyakesari.com",1620],["nativenews.in",1622],["madhyantar.com",1623],["mediamangalam.com",1624],["magnificentbihar.com",1626],["mahamtb.com",1628],["tarunchhattisgarhkor.comba",1630],["mahitivibhag.com",1631],["maihugodda.com",1632],["makdaiexpress24.com",1635],["mewartimes.com",[1636,1686]],["thereport24.com",[1636,2382]],["malabarinews.com",1638],["malayalamemagazine.com",1640],["malayalamonlinenews.com",1641],["malayalamuk.com",1643],["malayalivartha.com",1645],["malluchronicle.com",1646],["manasmediaonline.com",1651],["ada.lk",[1655,2845,2846]],["shyamalsylhet.net",[1655,1963]],["mannarkkadlive.com",1656],["manoramanews.com",1657],["manoramaonline.com",1658],["mantavyanews.com",1660],["marathisrushti.com",1663],["rojdin.in",1663],["marunadanmalayalee.com",1667],["mathabhanga.com",1668],["mathrubhumi.com",1669],["meerutdarpan.com",1681],["mekhadooth.com",[1682,1683]],["sindhudurgsamachar.in",1683],["mekhrajbairwa.com",1684],["metrovaartha.com",1685],["asomiyapratidin.in",[1685,2552]],["sathyadeepam.org",1685],["mirsaraikhobor.com",1689],["vasistatoday.in",[1691,2820]],["modernnewsindia.com",1692],["mohagani.com",1693],["momainews.com",1695],["moolbato.com",1696],["satkarpost.com",[1696,2192,2193,2194]],["sawalnepal.com",[1696,2193,2202]],["moonramkonam.com",1698],["morbiupdate.com",1699],["mp1news.com",1704],["mpenews.com",1706],["mpnewscast.com",[1707,1708]],["yesnewsmarathi.com",[1707,2514]],["cgbasket.in",1707],["msprotidin.com",1709],["muhurtham.com",1710],["mujibnagarkhabor.com",1711],["muktijoddharkantho.com",1712],["munaadi.com",1713],["musicjoymedia.com",1714],["musickhabar.com",1715],["myfirstshow.com",1718],["hindi.mykhel.com",1719],["tamil.mykhel.com",[1719,1720,1721]],["mymensinghnews.com",1723],["mysurumithra.com",1726],["mzamin.com",1727],["mznnews.com",1728],["nabaz-e-punjab.com",1729],["nalandalive.com",[1729,1735]],["nagarikpati.com",1731],["nainilive.com",1733],["najiknews.com",1734],["nalandareporter.com",1736],["nammabantwala.com",1738],["nandednewslive.com",1739],["sagarmatha.tv",[1741,3017]],["narmadanchal.com",1743],["narsingdirbani.com",1744],["bankalive.net",1744],["nation1voice.com",1745],["nationaldetectivenews.com",1746],["fonijkorea.net",1746],["nationalpowernews.com",1747],["nationalthoughts.com",1748],["nationaltodaylive.com",[1749,1750]],["peptechtime.com",[1750,1975]],["keepinspiringme.in",1751],["natunjug.com",1752],["navarashtra.com",1756],["navayuganews.com",1757],["navgujaratsamay.com",1759],["navinsamachar.com",1760],["navpradesh.com",1762],["southlive.in",1766],["nayabikalpa.com",1768],["nayabishwo.com",1769],["nayaharyana.com",1770],["nayaindia.com",1771],["nayapage.com",1773],["nayasabera.com",1775],["nbchindi.com",1777],["neemuchlive.com",1778],["nepalbritain.com",[1780,1781]],["rastriyakhabar.com",[1781,2075]],["nepalcanadanews.com",1782],["nepaldubai.com",1783],["nepalijanta.com",1785],["nepalimato.com",1786],["nepalipaisa.com",1787],["nepalipost.com",1788],["nepalkhabar.com",[1790,1791]],["srilankamirror.com",1790],["webcoachbd.com",1790],["tcvonline.co.in",1790],["editiontoday.in",[1790,1951,2628]],["am.lk",1790],["janchhaya.in",1793],["nepalpage.com",1798],["nepalpati.com",1799],["nepalraftar.com",1803],["nepalsamaya.com",[1804,1805]],["prabhabonline.com",1804],["nepalstatus.com",1807],["nepaltara.com",1808],["nepalviews.com",1809],["nepalwatch.com",1810],["neplays.com",1811],["nerpatham.com",1812],["netmalayalam.com",[1813,1814]],["netrokonajournal.com",1815],["nettamil.com",1816],["news-punjab.com",1818],["news11bharat.com",1819],["news13uttarakhand.com",1821],["news14india.com",1822],["news18marathi.com",1824],["hindi.news18.com",1825],["kannada.news18.com",1826],["news24delhi.com",1828],["news4himachal.com",1829],["news4himalayans.com",1830],["newsagencyindia.com",1835],["newsajako.com",1836],["newsaroma.com",1837],["newsbhandar.com",1839],["indiaaajkal.in",[1846,2653]],["newsdainik.com",1847],["samaylive.com",1851],["newsdustak.com",1852],["newsfireonline.com",1853],["newsflash24bd.com",1854],["newsheight.com",1857],["newshimachali.com",1858],["newskannada.com",1860],["newskoseli.com",1861],["newskranti.com",1862],["newslabz.com",1863],["newslinkers.com",1864],["newsmerchants.com",1865],["newsnazar.com",1866],["newsnetworkindia.com",1867],["newsnow24.com",1868],["newsplus24x7.com",1871],["hindi.newsroompost.com",1875],["newssanjal.com",1876],["newssewa.com",1877],["newssunamganj.com",1878],["newstaglive.com",1879],["newstrendindia.com",1882],["newsuperbharat.com",1883],["newszonebd.com",1887],["newuthayan.com",1888],["newzfast.com",[1889,1890,1891]],["samayduniya.com",[1891,2146]],["ni24news.com",1892],["nigranee.com",1893],["nijamtoday.com",1894],["nittaa.com",1895],["nknewsindia.com",1896],["nobat.com",1898],["nokhaexpress.com",1899],["notebazar.com",1900],["nrimalayalee.com",1902],["ntcnewsmedia.com",1903],["ntinews.com",1904],["ntnews.com",1905],["ntvbd.com",1906],["nuwakotexpress.com",1908],["obolokon24.com",1911],["odiapua.com",1915],["sarthaksamay.com",[1915,2189]],["hugujarati.in",1915],["newsofmithila.in",[1915,2730]],["odishabhaskar.com",1916],["onakanthirkantho.com",1919],["oneindia.com",1920],["kannada.oneindia.com",1921],["telugu.oneindia.com",1923],["onetamilnews.com",1925],["onlinekhabar.com",1927],["raigadtimes.co.in",[1929,2606]],["onlinemarg.com",1930],["onlinepatrakar.com",1932],["onlynews24.com",1933],["onp24.com",1934],["onsnews.com",1935],["osnepal.com",1937],["osvevo.com",1937],["ourmyliddy.com",1938],["outlookhindi.com",1939],["pagetamil.com",1943],["pahadprabhat.com",[1944,1945]],["pahilopost.com",1946],["pakundiapratidin.com",1947],["palampuronline.com",1948],["pallibatani.com",1949],["panchayattantra24.com",1951],["panchayattimes.com",1952],["panchkulasamachar.com",1953],["sportszone24.com",1953],["khabrainabhitak.org",[1953,2386,2992]],["pankourinews.com",1954],["pannagam.com",1955],["parchhayin.com",1956],["pardafas.com",1957],["pardaphash.com",1958],["hindi.pardaphash.com",1959],["rninews.co.in",1959],["parvatprerna.com",1962],["patheo24.com",1965],["protikhon.com",1966],["pathivaranews.com",1967],["pathramonline.com",1968],["loksansar.in",1968],["patnadaily.com",1969],["patrika.com",1971],["patrikai.com",1972],["payyanursouhrudavedi.com",1973],["pchelpcenterbd.com",1974],["perfecttamil.com",[1976,1977]],["jhabuanews.in",[1976,2671]],["pinkstea.com",1978],["pksnews24.com",1979],["policemukhbir.com",1983],["policevarthe.com",1984],["poriborton.com",1987],["positivebdnews24.com",1988],["uthayamnews.com",[1988,2456]],["prabhanews.com",1992],["prabhasakshi.com",1993],["prabhatkhabar.com",1994],["mumbaitak.in",[1994,2611,2710]],["prabhatvaibhav.com",1996],["pragatitimes.com",1998],["pragativahini.com",1999],["praharkhabar.com",2000],["prajajyothinews.com",2001],["prajamantalu.com",2002],["prakashkhabar.com",2004],["prakharpurvanchal.com",2005],["pratidhvani.com",2009],["pratidinakhbar.com",2010],["prativad.com",2011],["pratyeknews.com",2012],["pravasi.com",2014],["pravasidaily.com",2015],["prernanews.com",2017],["pressbarta.com",2018],["preyopathok.com",2019],["priyo.com",2020],["probashirdiganta.com",2023],["professorsbd.com",2024],["projonmonews24.com",2025],["promisenews24.com",2026],["prompttimes.com",[2027,2028]],["samvadnews.com",2027],["muznews.online",[2027,2984]],["prothom-elo.com",2029],["protichhobi.com",2031],["protidinerchitrobd.com",2032],["pslvtv.com",[2033,2034]],["popatlal.in",2033],["uttarbangergramunnayan.com",2039],["punjabguardian.com",2040],["punjabiinholland.com",2042],["sachikalam.com",[2042,2110,2111]],["punjabkesari.com",2043],["punjabtimesusa.com",2044],["punjabvarta.com",2045],["punnalaikkadduvan.com",2046],["purbakantho.com",2047],["purbanchal.com",2048],["purbashabd24.com",2049],["purvanchal24.com",2051],["purvanchalsurya.com",2053],["puthiyathalaimurai.com",2055],["kamadenu.hindutamil.in",[2055,2649]],["puttalamonline.com",2056],["radionrn.com",2057],["raisingvoice.com",2059],["rajasthankhabre.com",2060],["realitynews.in",2060],["rajbem.com",2061],["rajkajlive.com",2062],["rajpathmathura.com",2064],["thaiveedu.com",[2064,2350]],["rajsamandtimes.com",2065],["rajtantra.com",2068],["rajyasameeksha.com",2069],["ranchiexpress.com",2070],["ratantimes.com",2077],["ratokalam.com",2078],["ratopati.com",2079],["motivatenews.com.np",[2080,2164,2975]],["pokharapatra.com.np",[2080,2164,2977]],["bangla24x7.news",2081],["reportexclusive.com",2085],["republicadainik.com",2086],["rewanewsmedia.com",2087],["ridoyachandpur.com",2089],["risingbd.com",2090],["rjfnews.com",2091],["roddure.com",2094],["rojanapunjab.com",2095],["rojgarlive.com",2096],["rtvonline.com",2100],["ruhelkhandpost.com",2101],["saamana.com",[2103,2104]],["tamilyugam.in",2104],["spicenewsbd.com",2106],["sabkikhabar.com",2108],["samarthsahara.com",2108],["varchasvnews.com",2108],["viznews.in",2108],["sabkinajar.com",2109],["alayadivembuweb.lk",2109],["sehajtimes.com",2110],["sachkaujala.com",2113],["sachkitop.com",2114],["sadamoga.com",2115],["sagartvnews.com",2117],["saharasamachar.com",2118],["aisakya.in",[2120,2159]],["sakshi.com",2126],["samachar4media.com",2127],["samachardoot.com",2128],["samacharplus.com",2132],["samacharsach.com",2133],["samacharuk.com",2133],["samacharxpress.com",2135],["samadhannews.com",[2136,2137]],["samagrabharat.com",2138],["samajkihalchal.com",2140],["houseplan.lk",[2140,2855]],["samakalikamalayalam.com",2142],["telugu.samayam.com",2144],["samayindia24.com",2147],["sameerachannel.com",2150],["samnanews.com",2152],["sampattechno.com",2153],["samridhjharkhand.com",2154],["samudrapari.com",2156],["samugammedia.com",2157],["samvadexpress.com",[2160,2161]],["samvetshikhar.com",2162],["samwadbundelkhand.com",2163],["sanchorenews.com",2165],["sandeshnow.com",2166],["sandhan24.com",2167],["sandhyadesh.com",2169],["sangbad-gallery.com",2171],["sangbadajkal.com",2172],["sangbadchorcha.com",2173],["sangbadmail24.com",2174],["sangbadprotidin.com",[2175,2176]],["shomoynews.net",[2175,2928]],["sanghamam.com",2177],["sanjeevnitoday.com",2179],["sansanilive.com",2184],["sansarpost.com",2185],["sanvadnews.com",2186],["sarakhon.com",2187],["sarbochcha.com",2188],["sathiksamachar.com",2190],["ujjwalpradesh.com",[2192,2437]],["starbanglanews.net",[2192,2437]],["cg24x7.news",[2192,2303,2507]],["satlujbiastimes.com",2195],["satyaexpress.com",2196],["satyapathnews.com",2199],["satymevjayte.com",2200],["hindi.scoopwhoop.com",2203],["seemanchallive.com",2204],["seithy.com",2206],["setopati.com",2208],["setoshikhar.com",2209],["shabdsaransh.com",2211],["sharebazarnews.com",2214],["sharechat.com",2215],["shariatpurnews24.com",2216],["shasakprashasak.com",2218],["sheikhpuranews.com",2220],["sherpurtimes.com",2221],["shikkharalo24.com",2222],["shineupindia.com",2223],["shirurtaluka.com",2224],["shivamoggalive.com",2225],["shivshahilive.com",2226],["shobujbangladesh24.com",2227],["shomoynews24.com",2228],["shomoynews24.net",2228],["shreemanglamlive.com",2233],["uttrakhandtoday.com",[2235,2464]],["shyamalsylhet.com",2236],["simanapari.com",2238],["simpaninews.com",2239],["sirsonews24.com",2241],["siwanexpressonline.com",2242],["snn24.com",2246],["socialvikassamachar.com",2248],["sodhpatra.com",2249],["sokalerbangla.com",2250],["somoysongbad.com",2254],["sonalibanglanews.com",2255],["sonalinews.com",2256],["sonardesh24.com",2257],["sonatalasangbad.com",2258],["sorejominbarta.com",2260],["spnewsworld.com",2262],["sristybarta.com",2263],["srujananedu.com",2264],["ssnewsindia.com",2265],["abhitak.in",2265],["vvanews.in",2265],["starkhabre.com",2266],["starsangbad.com",2268],["startalkbd.com",2269],["subhechhanews.com",2273],["suddi9.com",2274],["suddidina.com",2275],["suddione.com",2277],["sudurkhabar.com",2279],["sudurpress.com",2281],["sunaulonepal.com",2283],["sunnews24x7.com",2285],["supportmeindia.com",2286],["suprobhat.com",2287],["surgujasamay.com",2288],["suryakhabar.com",2290],["swarajnewstoday.com",[2293,2294]],["shankhnaad.in",2294],["aajtak.in",[2296,2533,2534]],["sylhetbarta24.com",2297],["sylnewsbd.com",2301],["taftishofcrime.com",2302],["talashbangla.com",[2304,2305]],["thenewspost.in",2304],["tamil2daynews.com",[2306,2307]],["aanthaireporter.in",[2307,2308]],["tamilcnnlk.com",2310],["tamilcnn.lk",[2310,2868]],["tamildaily.com",2311],["tamillens.com",2312],["tamilmint.com",2313],["tamiltradepost.com",[2313,2322]],["tamilmithran.com",2314],["satyasamachar.in",2316],["tamilolli.com",2317],["tamilsaga.com",2318],["tamilspark.com",2319],["tamilthamarai.com",2320],["tamilvanakkam.com",2323],["tamilvisions.com",2324],["viewpointjharkhand.com",2325],["tarunchhattisgarhkorba.com",2328],["tatokhabar.com",2329],["tazakhabar36garh.com",2331],["techalonews.com",2332],["techshahin24.com",2333],["techworldbd.com",2336],["tedmnews.com",[2337,2338]],["headlinestripura.in",2338],["telugu99.com",2342],["teluguone.com",2344],["telugusmtv.com",2345],["teluguwirals.com",2346],["teluguwishesh.com",2347],["teznews.com",2348],["thakurgaon24newspaper.com",2351],["al-ihsan.net",[2354,2881]],["thebharatlive.com",2357],["thecolomboexpress.com",2359],["thedailybarta.com",2360],["thedailycampus.com",[2361,2362]],["thedhakacrimenews.com",2363],["thekeralapost.com",2371],["thelallantop.com",2372],["thenewsqube.com",2374],["thenewsrepair.com",2375],["thenewswords.com",2376],["thenrinews.com",2377],["muzaffarpurnow.in",2378],["theptvnews.com",2379],["thepublictoday.com",2380],["bangla.thereport24.com",2383],["thesabera.com",2384],["thesaturdaynews.com",2385],["uttarakhandraibar.com",2386],["thinaboomi.com",2389],["thirdeyenewslive.com",2390],["thirdeyetoday.com",2391],["thodkyaat.com",2392],["thuglak.com",2393],["tibrakhabar.com",2395],["tikheemirchi.com",2396],["times-bd24.com",2397],["timesnowhindi.com",[2398,2399]],["timesnowmarathi.com",[2399,2400]],["timesnowtamil.com",2401],["timesofadventure.com",2402],["timestamilnews.com",2403],["timestodays.com",2404],["tips4blog.com",2406],["tirangaacindianews.com",2407],["tnews247.com",2408],["todaybihar.com",2411],["kaptaan.co.in",2413],["todaysheoharnews.com",2415],["tolivelugu.com",2416],["topnepalnews.com",2418],["torontotamil.com",2420],["trendynewsnetwork.com",2421],["khabarfatafat.in",2421],["truelinenews.com",2423],["truevisionnews.com",2424],["trustnews24.com",2425],["tupaki.com",2426],["tv19online.com",2427],["twnewsbd.com",2430],["udupixpress.com",2434],["ujalahiteshiexpress.com",2435],["ukmalayalampathram.com",2441],["mukhyadhara.in",2443],["unfoldbangla.com",2444],["unikannada.com",2445],["unitednripost.com",2447],["univarta.com",2448],["unmadmagazine.com",2449],["upbhoktajanghosh.com",2451],["updatenews360.com",2452],["usharbani.com",2455],["utkalpratidin.com",2457],["uttarakhandcitynews.com",2458],["uttarakhandmorningpost.com",2459],["uttarakhandsamachar.com",2462],["uttareralo24.com",2463],["uukmanews.com",2465],["vadakaravoice.com",2467],["valaitamil.com",2469],["vanakkamlondon.com",2470],["kannada.vartamitra.com",2471],["vatsalyanews.com",2473],["veeravengaikal.com",2477],["velanai.com",2479],["vellinakshatram.com",2480],["velsmedia.com",2481],["vidhankesari.com",2482],["vikatan.com",2485],["vishvakannada.com",2487],["vishvasnews.com",2488],["voiceofdarbhanga.com",2490],["voiceofnewjersey.com",2491],["vskbihar.com",2492],["vtvgujarati.com",2494],["wealthfreedomideas.com",2497],["webdunia.com",2498],["wehindustan.com",2501],["lakshyatak.in",2501],["wenepali.com",2502],["wishmaya.com",2503],["firstlookbihar.in",[2503,2631]],["wnepal.com",2504],["womeneye24.com",2505],["jalauntimessite.wordpress.com",2508],["todaybiharnews1.wordpress.com",2509],["worsonlinenews.com",2510],["xxx-indian-porn.com",2511],["yashbharat.com",2512],["youth18.com",2515],["yugabdha.com",2517],["yuvnews.com",2519],["faridabadlatestnews",2522],["haal.fashion",2523],["10tv.in",2524],["yerahajawab.in",2528],["a2znews24.in",2529],["aajkaal.in",2531],["aajkasach.in",2532],["ashanews.in",2534],["abckhabar.in",2536],["agrinewsnetwork.in",2539],["ajhindidaily.in",2540],["dainikayodhyatimes.in",[2540,2615]],["alarmindia.in",2541],["amanpath.in",2542],["anandalok.in",2544],["anandamela.in",2545],["anmnews.in",2546],["ab71.tv",[2547,3004]],["argusnews.in",2550],["ashmitanews.in",2551],["ballialive.in",2553],["bharatiyadigitalnews.in",[2556,2557]],["bhartiyakhabar.in",2559],["bhartiyanews.in",2560],["bhilwarasamachar.in",2561],["biharnewstv.in",2563],["blackoutnews.in",2565],["bolbihar.in",2566],["boleindia.in",2567],["bucksvault.in",2569],["cgwebnews.in",2572],["cialive.in",2574],["citymirrors.in",2575],["cityonclick.in",2576],["aanmeegam.co.in",2577],["asalbaat.co.in",2579],["banglanewslive.co.in",2580],["cnin.co.in",2581],["deshbandhu.co.in",2582],["dgnews.co.in",2583],["isns.co.in",2589],["jinews.co.in",2590],["khabhar24live.co.in",2591],["khojinews.co.in",2592],["kungumam.co.in",2593],["loksattanews.co.in",2594],["mahasarkar.co.in",2595],["manabadi.co.in",2596],["neerfit.co.in",2598],["newstrendz.co.in",2600],["patnalive.co.in",2603],["sowork.co.in",2607],["timenews.co.in",2608],["webreporter.co.in",2609],["crimetak.in",2611],["uptak.in",[2611,2814]],["currentgk.in",2612],["dailynewsreport.in",2614],["deshdigital.in",2620],["deshvani.in",2621],["dnspnews.in",2625],["dolphintimes.in",2626],["evartha.in",2630],["gayanews.in",2632],["goodreturns.in",2634],["tamil.goodreturns.in",2635],["organizeindia.in",2637],["grandnews.in",2638],["gujjujankari.in",2640],["gujratkhabar.in",2641],["hellobikaner.in",2642],["hilllive.in",2643],["hindusthansamachar.in",2648],["idunammaooru.in",2652],["indiajaankari.in",2655],["indialivingnews.in",2656],["indianewscentre.in",2657],["indianspiritual.in",2658],["indiatv.in",2660],["janjankiawaaz.in",2667],["janjoshnews.in",2668],["janwani.in",2669],["jaunpurlivenews.in",2670],["jharkhandvani.in",2672],["jubileepost.in",2674],["kabirkiawaz.in",2675],["khabaruttarakhandlive.in",2678],["khonjkhobor.in",2681],["khulasanewslive.in",2682],["krantikarisanket.in",2686],["krishideepam.in",2687],["lagatar.in",2688],["lionexpress.in",2690],["liveindianews18.in",2693],["lokbharat.in",2696],["maithilbrahminmahasabha.in",2698],["mangalwedhatimes.in",[2700,2701]],["krishakjagat.org",2700],["manvadhikarabhivyakti.in",2702],["mediacover.in",2704],["mhone.in",2705],["mithimedia.in",2706],["moviemax.in",2708],["mysamachar.in",2712],["nakkheeran.in",2713],["ndtv.in",2715],["neemkathananews.in",2716],["positiveindia.net.in",2717],["newindia24.in",2718],["news13.in",2719],["newscircle.in",2721],["newscreation.in",2722],["newsgil.in",2723],["newshubinsight.in",[2725,2726]],["newsspecial.in",2726],["newslamp.in",2728],["newsnib.in",2729],["newsworldweb.in",2735],["newsxtra.in",2736],["newszon.in",2737],["nirpakhawaaz.in",2739],["timetovisit.in",2739],["nishpakshjanavlokan.in",[2740,2741]],["colombotamil.lk",2741],["odishareporter.in",2743],["otvkhabar.in",2744],["pakwangali.in",2746],["payyolionline.in",2748],["powertvnews.in",2751],["pplnews.in",2752],["prabhatparvnews.in",2753],["prathamnews.in",2755],["eelanadu.lk",2755],["pressnote.in",2756],["primestv.in",2757],["publictv.in",2758],["raftaar.in",2761],["rantraibaar.in",2763],["telugu.regnews.in",2765],["reportsindia.in",2766],["saharanpurweb.in",2767],["sambad.in",2770],["sananda.in",2771],["sarvodaytimes.in",2775],["satyagrahnews.in",2777],["satyasandhana.in",2778],["scgnews.in",2779],["seedhasawal.in",2780],["sindhuyouth.in",2783],["sirfsach.in",2784],["sitamarhilive.in",2785],["skknews.in",2786],["southwrap.in",2787],["sudarshannews.in",2791],["thehindutimes.in",2797],["theindianstate.in",2798],["themangaloremirror.in",2799],["thenationtimes.in",2800],["thenewssense.in",2801],["thevoices.in",2803],["thewall.in",2804],["thinkwithniche.in",2805],["tnstudy.in",2806],["today24.in",2807],["uksuddi.in",2812],["unishkuri.in",2813],["urjanchaltiger.in",2815],["uttarakhandtemples.in",2816],["uttaranchaldarpan.in",2817],["valanchery.in",2818],["varthabharati.in",2819],["vgnews.in",2823],["vknews.in",2824],["weunetwork.in",2826],["youthexpress.in",2828],["infosrilankanews.info",2830],["muslimmedia.info",2831],["odiascraps.info",2832],["faridabadnews.live",2834],["hindnews.live",2835],["news11.live",2837],["newsdiary.live",2838],["newspr.live",2839],["odisha.live",2840],["pardaphashnews.live",2841],["press4news.live",2842],["reporter.live",2843],["lankadeepa.lk",[2845,2857]],["aruna.lk",2847],["sinhala.asianmirror.lk",2848],["gagana.lk",2852],["dbcnews.tv",[2852,3007]],["giraya.lk",2853],["hirunews.lk",2854],["lakfmnews.lk",2856],["lknews.lk",2858],["nethgossip.lk",2859],["nethnews.lk",2859],["newsfirst.lk",2861],["newsview.lk",2862],["politics.lk",2863],["rivira.lk",2864],["subasetha.lk",2867],["tamilmirror.lk",2869],["thamilan.lk",2870],["theleader.lk",2871],["thinakkural.lk",2872],["truenews.lk",2873],["vaaramanjari.lk",2874],["valampurii.lk",2875],["webgossip.lk",2877],["wijeya.lk",2878],["truecopythink.media",2879],["24ghanta.net",2880],["aperata.net",2884],["bangladesherkhabor.net",2885],["bbarta24.net",2886],["bonikbarta.net",2888],["cnibd.net",2891],["crimenewsbd.net",2892],["dainikpurbokone.net",2895],["dakhal.net",2896],["kolarnews.net",2896],["edainikazadi.net",[2898,2899]],["edainikpurbokone.net",2898],["eenadu.net",2900],["pratibha.eenadu.net",2901],["goodmorningindia.net",[2904,2905]],["kuppilan.net",2906],["mediabharti.net",2910],["natunsomoy.net",2914],["nellaionline.net",[2915,2916]],["tutyonline.net",[2915,2939]],["news24bd.net",2917],["newsdoor.net",2918],["ngnews24.net",2919],["ourbiratnagar.net",2920],["ourislam24.net",2921],["patradoot.net",2923],["prajavani.net",2924],["sahilonline.net",2926],["soninews.net",2930],["tamilserialtoday-247.net",2934],["thevirallines.net",2936],["timenewsbd.net",2937],["tollywood.net",2938],["vijayavani.net",2940],["weeklysonarbangla.net",2941],["yarldevinews.net",2942],["yuvabrigade.net",2943],["amankishaan.news",2946],["banglamail.news",2948],["cniasia.news",2949],["indias.news",2950],["indiaspeaks.news",2951],["janata.news",2952],["kannadi.news",2955],["liveindia.news",2957],["livetrends.news",2958],["livevns.news",2959],["mediavision.news",2960],["paathok.news",2964],["sylhettoday24.news",2965],["sylhetview24.news",2966],["tcp24.news",2967],["usbangla24.news",2968],["vasundharadeep.news",2969],["vishwavani.news",2970],["visiontimes.news",2971],["voiceasian.news",2972],["yoyocial.news",2973],["yuvabharat.news",2974],["nepalipatro.com.np",2976],["rajbirajdainik.com.np",2979],["punjabiherald.co.nz",2980],["dailynewsj.online",2982],["steelcity.online",2987],["up80.online",2988],["viralsach.online",2989],["emulyankan.org",2990],["indiainside.org",2991],["maatram.org",2993],["nationalduniya.org",2995],["sebahotnews.org",2996],["telugucalendar.org",2997],["valvainews.org",2998],["manvimedia.page",2999],["changetv.press",3000],["ebangla.press",3001],["notebook.today",3003],["calcuttanews.tv",3005],["ekattor.tv",3008],["jamuna.tv",3009],["livetimes.tv",3011],["m7news.tv",3012],["news24bd.tv",3013],["ns7.tv",3014],["probashibangla.tv",3015],["samajbad.tv",3018],["somoynews.tv",3020],["sylheterjanapad.tv",3021],["worldpunjabi.tv",3023],["pravasi.us",3029],["tharunaya.us",3030]]);

const entitiesMap = new Map(undefined);

const exceptionsMap = new Map(undefined);

self.specificImports = self.specificImports || [];
self.specificImports.push({ argsList, hostnamesMap, entitiesMap, exceptionsMap });

/******************************************************************************/

})();

/******************************************************************************/
