/*******************************************************************************

    uBlock Origin Lite - a comprehensive, MV3-compliant content blocker
    Copyright (C) 2019-present Raymond Hill

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see {http://www.gnu.org/licenses/}.

    Home: https://github.com/gorhill/uBlock
*/

/* jshint esversion:11 */

'use strict';

// ruleset: jpn-1

/******************************************************************************/

// Important!
// Isolate from global scope
(function uBOL_cssSpecificImports() {

/******************************************************************************/

const argsList = ["#ad_inview_area,\n#gStickyAd,\n._popIn_recommend_article_ad,\n._popIn_recommend_article_ad_reserved,\n.ise-ad,\nbody .interstitial-ad,\ndiv[id^=\"JP_\"][style],\ndiv[id^=\"active_overlay\"]",".ads-above-single-player,\n.elementor-widget-container:has(> center:only-child > .for-floating),\n.elementor-widget-container:has(> center:only-child > div[id^=\"div-gpt-\"])","#custom_html-2","#custom_html-4","#custom_html-7",".ads-system,\n.cactus-sidebar-content > .widget_text:not(.style-5)",".AdContainer","#right-side > div.side-box > div.side-title:first-child,\n.open","div[style^=\"width: 300px; height: 250px\"]","#vi-smartbanner,\ndiv[style=\" height: 300px; overflow: hidden; max-width: 100%; \"],\ndiv[style^=\"max-width:700px\"]",".amazon-ranking-outer",".afi-block,\n.ht-banner","article > p > a[target=\"“_blank”\"] > img",".hello_from_adguard_japanese","#js-ur,\n.listPage__ad,\n.main__ad,\n.page__listPageAd",".slide_b",".pum-overlay","#text-3","#block-3","[id^=\"_ad_\"]","#header_banner",".ad_tab_wrap",".add","#text-2","body .code-block","#custom_html-71,\n.entry-content > div.widget_custom_html:has(div.google-ads)",".banner_rectangle,\n.main_contents > div.middle_section,\n.recruit_banner","a[href^=\"https://pakomanmama.com/\"] + br,\na[href^=\"https://pakomanmama.com/\"] + br + br,\na[href^=\"https://pakomanmama.com/\"] > font[color=\"red\"]",".entry-content > p > a[target=\"_blank\"]","#related-entries:first-of-type",".adsense",".res > a[href*=\"amazon.co.jp/\"][target=\"_blank\"]","#sidebar > aside#text-12:has(> .textwidget > p > a[target=\"_blank\"] > img[src*=\"bnr_\"]),\ndiv[class^=\"ad-box\"]","#text-16",".AMvertical",".ad1",".ad2",".ax-cp,\n[id^=\"gogo-ads-widgets\"],\n[id^=\"gogo-iad-widgets\"]",".kizi > div > p > a[href^=\"//www.amazon.co.jp/\"],\n.rakubtn,\n.yahoobtn","#st_custom_html_widget-14",".bnr","#recBanner,\n#topBnr",".blogroll_ads",".amazon",".ads","#left","#ad2 + h3,\n#articleBodyMore_bottom > div#monologue + br + ul,\n#bottom_tweet_rank + h3,\n#comment + h3,\n#m_ad4 + h4,\n.entry_ranking,\n.entry_ranking + h3,\na[id^=\"sitejack_\"],\ndiv[align=\"center\"] > a[href^=\"http://www.amazon.co.jp/exec/\"],\ndiv[align=\"center\"] > span[style=\"font-size: x-large; color: rgb(0, 0, 255);\"] > b","#more > div[align=\"center\"]:last-of-type > table,\n#scroll,\n.aaieba-e,\n.article-body-inner > div[align=\"center\"] > table,\n.left-column-inner > div.plugin-memo,\n.main-column-inner > div[style^=\"BORDER: #FCA6AA 1px solid; margin: 0px 0px 12px 0px\"]:first-child,\n.plugin-memo:has(> div.side > div > div[id^=\"mhub-\"])",".t_b[style^=\"font-size: medium; font-weight: 400; background-color:\"]","#sub","#leftbody > div.plugin-search_internal ~ div.plugin-memo,\niframe[src=\"http://bantyou.livedoor.biz/patrol.html\"],\ntable[bgcolor=\"#000000\"]",".plugin-memo:has(> div.side > a[href^=\"http://www.e-nls.com/\"])","li > a[href^=\"https://al.dmm.co.jp/\"]",".dmm","div[class^=\"google-user-ad\"]","#right_a:has(> div#rightbody > div#rakuafi),\n.AAA > a[href^=\"https://www.amazon.co.jp\"][target=\"_blank\"],\n.elsebody,\n.p_img,\n.r2 > a[href^=\"https://www.amazon.co.jp/\"],\n.yahoo-ad1b",".main > div > a[style][href*=\"amazon.co.jp/\"]","a[href^=\"http://www.amazon.co.jp/\"][target=\"_blank\"]",".plugin-memo:has(> div.side > a[href*=\"amazon.co.jp\"])",".kiziad,\na[href^=\"https://www.amazon.co.jp/gp/\"],\ndiv.plugin-memo:has(> div.side ins.adsbygoogle)","#leftbody,\n.PortalLinks > center,\n.mainmore > pre + table",".sideA,\n.sideB > p.side-title,\naside.section-box:has(> div.plugin-ad)","div[style=\"margin:10px 0;text-align:center;height:360px;\"]","div[style$=\"height:250px;\"]","div[style$=\"height:280px;\"]","div[style=\"width:300px;height:250px;\"]","#text-8","#text-11","#custom_html-37,\n#custom_html-39,\n.wp-block-group > .wp-block-group__inner-container:has(> .red_ a[href*=\"amzn.to\"])",".w-singleTop",".w-singleBottom","#custom_html-11","#custom_html-20","#custom_html-28","#custom_html-30","#custom_html-31","a[href=\"http://dir.spdoga1.net/e-top/deaivv.php\"]","#text-30",".widget-in-article",".article-body > center:has(> .adsbygoogle)",".single-pc-advertisement,\n.space-250,\n.space-60,\n.space-90,\ndiv[class$=\"-side-banner\"]",".header-main-banner",".sidebar hr,\na[href*=\"amazon.co.jp/\"][target=\"_blank\"],\ndiv[id^=\"ad-area\"]","a[href*=\"ck.jp.ap.valuecommerce.com/\"]","a[href^=\"https://amzn.to\"][target=\"_blank\"]",".ad2x",".adsence","#text-9","#text-10","#text-12","a[href=\"https://kabutoshimichi.com/\"]","a[href^=\"https://px.a8.net/svt/ejp\"]",".w-cta",".w-singleBottom > div.widget_text",".globalPage-ad","#st_custom_html_widget-8",".amagetti-tabs-container",".amagetti-tabContent",".yyi-rinker-contents","#content-sidebar > aside.widget_custom_html,\n#primary-sidebar > aside.widget_text:last-child,\n.entry-content > a[href^=\"https://www.amazon.co.jp/\"]",".plugin-memo:has(> div.side > div[style=\"margin:0;padding:5px;font-size:14px;word-break: break-all;\"] > a[href^=\"https://al.dmm.co\"][rel=\"nofollow\"] > img)",".plugin-memo:has(> div.side > a[href*=\"amazon.co.jp/\"][target=\"_blank\"] > img)",".pr","#simplicityclassictextwidget-29,\n#simplicityclassictextwidget-35,\n#simplicityclassictextwidget-36,\n#simplicityclassictextwidget-37,\n#simplicityclassictextwidget-38,\n#simplicityclassictextwidget-39,\n#simplicityclassictextwidget-40,\n#simplicityclassictextwidget-41,\na[href^=\"//ck.jp.ap.valuecommerce.com/servlet/referral\"],\ndiv[class$=\"addsspot_300_600_pc\"],\ndiv[style*=\"height:280px\"][style*=\"text-align:center\"],\ndiv[style^=\"width:300px;height:600px;\"],\ndiv[style^=\"width:680px;height:280px\"]","div[style*=\"width:336px;\"]",".ad",".sidebar__right a[target=\"_blank\"] > img","#bookid",".post > h2[data-amp-original-style=\"padding-left:3%;margin-top:2%;margin-bottom:5%\"]","span[style=\"font-size:60%;font:#333333\"]",".fixed,\n.fixed2",".p-cb__item--ad","#inplayer",".ads:not(.ads-row > .ads)","#sidebar > .contents,\n.contentsRight","#right_area",".sponser","iframe[src^=\"http://www.mmaaxx.com/\"]","#overlay_area","#barcenter",".blogbody > div.main:has(+ br + .posted > a.aposted[href=\"\"]),\n.blogbody > div.posted:has(> .aposted[href=\"\"]),\n.blogbody > h3.title:has(+ ifdatechanged + div.main + br + .posted > a.aposted[href=\"\"]),\nh2.date + div.blogbody:has(.aposted[href=\"\"]),\nh2.date:has(+ .blogbody .aposted[href=\"\"]),\nifdatechanged + div.blogbody:has(.aposted[href=\"\"])","div[class*=\"pmbanner\"]","#side > h3:last-of-type","div[class$=\"sticky-sidebar__widgets\"]",".dfad",".sponsored",".side--right > section.module--free:last-child",".ad-bottom-right,\n.admax-bottom > p[style],\n.side--right > .module--free:nth-child(-1n+4),\ndiv[class^=\"posi\"]",".card_pr","#pryc-wp-acctp-bottom",".bbsarea",".article > div.clear + div.clear + h3.frontTitle ~ article.excerpt_pick:has(~ div.clear + h3.frontTitle + article.excerpt_pick + div.clear)",".substitute-area-footer-on,\n.substitute-area-middle-on,\n.substitute-show-area-on","a[style*=\"width:728px; height:90px;\"]","a[style^=\"box-sizing:border-box;\"]",".ad-space-top-footer,\n.ad-space-top-header","div[style^=\"margin-top\"][style$=\"text-align:center;\"][style*=\"margin-bottom\"]",".substitute-display-area-on","div[style^=\"margin-top\"] div[style=\"font-size:0.8em;\"]","ins.adsbygoogle[data-ad-slot]",".banner-image","p[style=\"text-align: center;\"]",".widget-over-sns-buttons","#text-26",".xF6dY",".article__content > div > a[href^=\"https://jp.mercari.com/user/profile/\"] > img.pict",".advertisement-position",".adsbox,\n.adsboxtop,\n.sidebar > div.widget_text:has(> div.textwidget > a[target=\"_blank\"][href^=\"https://px.a8.net/\"]),\ndiv[style=\"text-align: center;\"] > a[href^=\"https://amzn.to/\"]","#text-49","a[href^=\"https://click.linksynergy.com/fs-bin/click\"] > img",".my-2:not(:has(> div.card))",".demo_url_replacer > div.widget_area,\n.pani-detail ~ div.detail-cont",".articleBody > div.media_frame:has(> a[data-category=\"affiliate\"][href^=\"https://www.amazon.co.jp/\"]),\n.original_middle_ad","[id^=\"ads\"]","#bottom,\n.l-extra + .breadcrumb ~ .l-wrapper .content > .gdc_row,\n.widgetSticky > aside.widget_text.widget-sticky","#text-27","#sidebox > h2:first-child,\ndiv[style^=\"margin:20px 0;padding:10px;background-color:#fea;background-image\"]",".first.fblock,\n.last.fblock","#text-7","#pc_text-19","#pc_text-21","div.page_side_bnr",".myad",".entry-content > div.add","#headline_around,\n#sidebar > table:first-child,\n.hover_img","div[class^=\"postUnderRssAd\"]",".box",".widget-above-single-sns-buttons",".dmm03,\n.dmm_top,\n.rankkingg,\n.side_ad_001","#sub > div.column-inner > div.column-inner-2 > div.plugin-memo:nth-of-type(1n+4),\n.entry_box3,\n.entry_box_left,\n.entry_box_right",".AmaQuick-box","#text-32","#text-33","#over-ad,\n.entry:has(> div.contents_body > div[style=\"text-align:center;margin-bottom:10px;\"] + div[style=\"font-size:8px;\"]),\na[href^=\"https://www.e-nls.com/access.php\"][target=\"_blank\"] > img[width=\"250px\"][height=\"250px\"],\ndiv.content:first-child:has(> div.entry_body > div[style=\"text-align:center;margin-bottom:10px;\"] + div[style=\"font-size:8px;\"])",".nls_product_set_wrap","#sideBar",".amazlet-box","#main-fit-wrapper > font[size=\"2\"],\na[href^=\"http://ad-seek.jp/\"]",".Adsense300","#header_billboard,\n.mns_bn[style$=\"height:250px\"],\n.mns_bn_text","#chatroom_ad_header","#chatroom_right","#free_space_post_list_bottom,\n#free_space_post_list_middle,\n#text-45","#text-31","#text-40","div[id^=\"gtm_\"]",".sponserdlink","div[class$=\"_adlabel\"]","#custom_html-3","#custom_html-13","#fix_sidebar",".sidebar_content > div.widget_custom_html",".widget_custom_html.single-top",".right-container > div.plugin-memo:first-child",".linkwithin_div + div.thanks,\ndiv[style=\"margin:-5px auto 5px auto; height:130px;\"]",".widget-above-single-content-title","#custom_html-10","#custom_html-19",".banner.blogcard",".adsensemore > div.center,\n.header-container > div.center","div[style^=\"width:300px;height:250px;\"]",".kaerebalink-box",".block-adsense-q-wrapper","#ac-main-content > .ac-d-lg-block,\n.ac-p-2.bg-e6e6e6.donation-box-right:has(> .ad-center),\n.ac-p-2.bg-light.ac-mb-2,\n.ad-fluid,\n.col-12.px-1,\n.container figure ~ div[class^=\"col-\"]:has(> .bg-light [id^=\"div-gpt-ad\"]),\n.flux-all-footer.ac-z-index-999.position-fixed.bg-light.w-100[style],\n.section-creator-ads,\n.theme-ads-box","div[style=\"min-height: 250px;\"]","#voting-taboola-wrapper,\n.ac-p-2.bg-light.ac-mt-3,\ndiv[id^=\"search-result-\"] div.bg-light.ac-p-2",".cont_campaign,\n.cont_end,\n.img_link","#banner",".ad01a,\n.menunaka > div[style^=\"font-size:10px;font-weight:normal;float:left;color:#996666;\"],\ndiv[style=\"border-top:1px solid #555;padding:20px 10px;\"],\ndiv[style=\"float:right;width:160px;\"],\ndiv[style=\"height:90px;\"],\ndiv[style=\"min-height:260px;\"],\ndiv[style=\"text-align:center;min-height:100px;margin-bottom:20px;padding 0 20px;\"],\ndiv[style^=\"width:600px;\"],\niframe[src^=\"//tool2.nan-net.com/bbs_side/ada_\"],\ntable[width=\"910\"]","div[style^=\"margin-top:50px;background-color:#FFF;padding:20px;\"]","div[style^=\"min-height:250px\"]","div[style$=\"min-height:250px;\"]","div[class^=\"koukoku\"]",".banner","#g_top",".winAD",".container_top_widget_content",".content_box:has(> ul.pr5),\n.entry_detail > a[onclick^=\"_gaq.push\"] > img,\n.entry_detail > p[style=\"margin: 40px 0 0px;\"]:has(+ a[onclick^=\"_gaq.push\"] > img)",".widget_custom_html",".col-lg-7 > table[width=\"100%\"]:has(a[href*=\"://click.dtiserv2.com\"]),\n.col-lg-7 > table[width=\"100%\"]:has(a[href*=\"://click.dtiserv2.com\"]) + img[alt=\"AngelPickUp\"],\n.d-lg-inline.col-lg-3 > iframe[src$=\"/new.php\"] ~ br,\n.d-lg-inline.col-lg-7 > table[width=\"100%\"][cellpadding=\"5\"] + br",".belowVideoBanner,\n.boxzilla-bottom-right-container",".adtext,\n.rank > li[id]",".ads-a","#top-banner-base",".ad_area__box,\n.contents_bottom_2-column_ad,\n.side div.prime,\ndiv[class^=\"rightSky0\"]","#text-4","#text-5",".menubox[style=\"text-align:center;padding:1em;\"],\n.myh-ads,\n.topinfeed","div[id^=\"_popIn_recommend\"]",".widget_custom_html > div.textwidget > a[href^=\"https://www.dlsite.com\"]",".module-typelist:has(> div.module-inner > div.module-content > ul > li > div > ins.adsbygoogle)",".cps-post-main > p:has(> ins.adsbygoogle)",".sponsor",".acr-popular,\n.plugin-memo:has(> div.side > div[class^=\"uz-\"]),\n.t_b > script + br,\n.t_b > span[style=\"font-size: 125%;\"]","#sub div.plugin-memo:first-child",".autopagerize_page_element > b,\nblockquote:has(> .amazon)",".left-container > div.plugin-memo:last-child","#Sticky-Left,\n.amazon_link_sidebar,\n.catch_amz,\n.clearfix.article_bodyfooter,\ndiv[style=\"text-align:center;margin-bottom:15px;height:250px;\"],\nimg[src^=\"https://ambassador-system.mercari.com\"]",".amazon_link",".right-column-inner > div.plugin-memo:first-child",".right-column-inner > div.plugin-memo:last-of-type",".titleunder.add","._popIn_infinite_page > li:has(> a[class*=\"_popIn_recommend_article_ad\"])","#widget-in-article,\n.af-box,\n.custom-box02","#insentence-adsense,\n.adsense-wrap,\n.hatena-module-html a[href^=\"https://h.accesstrade.net\"],\n.hatena-module-html a[href^=\"https://mogecheck.jp/purchase\"]","div[style*=\"width:320px;height:100px;\"],\ndiv[style=\"margin-left:50px;width:740px;height:100px;background-color:#000;\"]","#amazon","#abar,\n#abox,\n#gadgets,\n.pstft,\ndiv[style=\"margin:16px 0 0 -8px\"]","#surfing_adsense_widget-4",".archiveItem-infeed",".cstmreba",".widgetPost-bottom","#text-14","div[id^=\"anico-\"]:has(> ins)",".amazon-item-box","div[id^=\"bnc_ad\"]","#box2-inner > div.hatena-module-html:has(> div.hatena-module-body > div.AMvertical),\n.hatena-rakuten-detail","div[class^=\"article-body\"] > blockquote:has(> div[align=\"center\"] > a[href*=\"amazon.co.jp\"])","div[style=\"width: 780px; height: 485px;\"]",".abox",".c-banner-common,\n.c-banner-lg-site-jack","#sidebar > li:has(> div.block > div.blocksubhead > a#collapse_block_html_4)",".widget_block","#custom_html-43","#media_image-3","#media_image-2","a[href^=\"https://rpx.a8.net\"]","#pc_text-13",".hotentry","#widget-under-related-entries","#custom_html-5",".mt-3:has(> ins.adsbygoogle)",".widget-under-article",".l-mainContent__inner > div.post_content > center",".ad[style$=\"min-height:250px\"]",".ad.double,\n.ads300,\n.ads_bottom,\n.img_margin[style=\"min-height:265px\"]",".ad:first-child,\n.pc,\n.upperbox","#home-top-widget","#diver_widget_pcsp-55",".kk_gen_h,\n.kk_gen_top_h,\n.kk_ggl_h,\n.kk_rak_h_n,\n.kk_sdb_vertical,\n.kk_sidebar_items > div.item_box_sdb:has(> p.item_box-image > a[href^=\"https://www.amazon.co\"])",".PC_header_ad,\n.adh0",".ad-300-250,\n.ad-720-90","#BT_applejp_Inread,\n.after-header-widget-area",".widget_item_ranking",".entry-content > div[style=\"text-align:center;\"]",".loglyHead",".c-bnr,\n.c-bnrBox","#main-content > #content > .block.odd:has(aside[id^=\"div-gpt-ad\"]),\n.ad-appllio-Bottom,\n.ad-appllio-Title,\n.sidebar > .region-inner > .block.odd:has(div[id^=\"div-gpt-ad\"])",".adsense-responsive",".adcode-mix",".u-ta-center:not(.u-mt-10):not(#new_comment > .u-ta-center)",".ai_widget",".side-banner",".leader_ad_banner,\n.lowerad,\ndiv[style=\"margin:auto;width:100%;min-height:250px;\"]",".entry-content > div.widget_st_custom_html_widget","#mybox > div.widget_text",".ad-middle-wrap","#HometopAdOuter,\n#NativePr,\n#Outbrain_Osusume,\n#SubInner > div[class] > div.Pr,\n#SubInner > div[class]:has(> div.Ad),\n#SubInner > div[class]:has(> div.Pr),\n#ytplayer1-ad,\n.AdMod,\n.BannerBlock,\n.InReadCenter,\n.OutbrainAdMod,\n.OutbrainRecMod,\n.PrTextMod,\n.Section > .Pr,\n.ad-article-inner,\n.ad-pc-side-rect,\n.andNativead,\n.footer-ad-area,\n.l-aside > div[class] > div[class]:has(> div.Section > div.Pr),\n.module-ad-article,\n.module-ad-head,\n.module-content-footer__ad,\n.module-side-ad,\n.module-side-notice,\n.module-top-ad,\n.p-ad--topNews,\n.p-ad-area,\n.p-chumoku,\n.p-kurashi__list > div.p-kurashi__listItem:has(> div[id^=\"div-gpt-ad-\"]),\n.p-rectangleAd,\n.p_infeed_list_wrapper,\n.sidebar__banner,\n.vjs-modal-dialog.vjs-error-display,\ndiv[style=\"min-height: 270px;\"],\ndiv[x-component-name=\"AsahiDynamicInclude\"][x-component-data]",".Ad",".recommend-content,\n.sub-recommend,\ndiv[class*=\"ad-area\"]",".entry-links-group",".layout-content-col1--bg2,\n.module-editors-picks .module-list-articles > .module-list-articles__item:not([class*=\" \"])",".module-list-articles__item--ad",".Pr",".a-ad,\n.g-ad-side,\nul[class^=\"m-article-list\"][class$=\"readmore\"] > li.m-article-list__item:has(> div[id^=\"taboola-below-article-\"])",".--ad",".module-list-articles__item:has(> div[id^=\"div-gpt-\"])","div[class^=\"ad-\"][class$=\"-footer\"],\ndiv[class^=\"ad-\"][class*=\"-rect-\"]",".mod-media-add,\n.top-large-ad",".ad-pc-billboard","a[id^=\"article-ad-ad_\"]",".c-article-block:has(> div[id^=\"div-gpt-\"]),\n.c-promotion,\n.kiji_rect01",".banner-container","#bnr_underarticle,\n.detailMainBannerGA01,\n.mainBannerGA01,\n.mainBannerGA02,\n.mainBannerPR02,\n.sideBanner01,\n.sideBannerGA01,\n.sidePicup,\n.topMainBannerGA01","#subservicelogo_wrap","#contentWrap > div.not-athleterecipe",".widget-parts","#ad","#afad",".side-section[style],\ndiv[style=\"text-align: center;margin-bottom: 24px;\"]","div[class*=\"adBnrBox\"]","#btmInfoWrap,\n#itemsBelt1,\n.showcaseEmbedAdBoxWrap,\n.showcaseNativeAdHeightType01,\nsection[class^=\"showcaseNativeAdType\"]","#kanrenItems,\n.bnrWidthFull","#adOvl,\n#bread + div[style=\"width:100%; text-align: center; padding: 10px 0px;\"],\n#md_similar_box,\n.inst_overlap_cover","div[style*=\"min-height:250px;\"]","div[style*=\"min-height: 250px\"]","div[id][class^=\"popup\"][class$=\"wrap\"]",".td-a-rec,\n.td-ss-main-sidebar > .ai-viewport-1,\n.td-ss-main-sidebar > aside.widget:has(> div.block-title > span)","#masthead > div > a[href^=\"https://al.dmm.co.jp\"],\n#masthead > div > a[href^=\"https://pancolle-movie.jp/track.php\"],\n.content-top-in,\n.entry-content p[style=\"text-align: center;\"] a[target=\"_blank\"][rel*=\"noopener\"] > img[width]","#footer-widgets","#text-15","table[width=\"142\"]",".affiliate-api-widget","#head > table[width=\"100%\"] td[align=\"center\"]",".post-widgets-bottom",".post-widgets-top",".post > div.st-aside p[align=\"center\"]",".sidemovie,\n.sidemovietitle",".custom-html-widget a[href^=\"https://al.dmm.co.jp\"]",".custom-html-widget > p > strong",".custom-html-widget a[href^=\"https://www.e-nls.com/access.php\"]",".custom-html-widget > p > small","#banner_thr,\n#banner_thr + hr,\n#banner_top,\n.thrListTxtAd,\n.thrListTxtAd + hr,\n.thrWholeRight","#ad_navi,\n#gad_header,\n#gbnr_sidet,\ndiv[style^=\"width:100%; height:250px\"]",".entry > h2:has(> a[href=\"\"]) + .entry_date","body > div.container-fluid:has(> div.row > div.adsense-photoeditor-header-wrapper),\nmain > div.row:has(> div[id] > script[src^=\"//ads.themoneytizer.com/\"])","#diver_widget_pcsp-2","#custom_html-6","#custom_html-16",".setumeiside:nth-of-type(-1n+2)","#ad-main-upper",".add-wrap","body .addHead",".raku",".rectangle",".articleDetailAdd",".addSide",".banner_area_468,\n.js--ad--bottom,\n.ranking_banner,\n.sidemenu_banner,\n.sponsorsTextHeader","div[id^=\"hideme\"] div[id$=\"t\"]","#top_banner","div[style^=\"position: fixed;bottom: 0;left: 0;right: 0;margin: auto;height: 106px\"]","div[style^=\"height: 250px\"]","#instant_ad,\n#js-imageview-ad,\n.ad-native-comment,\n.res_ad,\n[class*=\"js-ads-content-top_\"],\ndiv[class^=\"sproutad_\"],\ndiv[id$=\"AdsMain\"]","#float-bnr","#floater_ads,\n#js-bottom-ad-300x250,\n.js-cardview_ad-320x50:not(:first-child)",".pc-only2-wrap",".p-article01-ad,\n.recommend-list,\n.uz-ny","div[id^=\"gooad\"]",".adSenseUnder",".p-headerBnr","#ad-header","#extra div.column-inner-2 > div.plugin-memo,\n#semiFixed > div.plugin-memo > div.sidetitlebody,\n.article-body-more > table[width=\"125\"]","#sidebar > aside:has(> div > a[href^=\"https://amzn.to/\"])",".dividerBottom > aside.widget-main.widget_custom_html,\n.widget-side.widget_custom_html","div[class^=\"p-dfp-banner-area\"],\nli.p-topics-list__item--ad-ranking",".custom-html-widget a[href^=\"https://www.sokmil.com\"]","#widget-tracking",".video-player","table > thead.pc_obj + tbody > tr:not([class])","#footer_cta",".adsense_center","#BottomAmazon,\n#TopAmazon,\n.main_center_body_text div[align=\"center\"]:has(> a[href^=\"https://ad.adpon-affi.net/ad/\"]),\na[href^=\"https://ad-nex.com/\"][target=\"_blank\"],\na[href^=\"https://ad.adpon-affi.net/ad/\"]","a[href^=\"https://ratel-ad.com\"]",".amachazl-box",".plugin-memo",".side-topad","#link,\n#new","#side-fixed","#col3",".hentry > p[style^=\"text-align\"]",".sideblock_banner",".side-widget-area > div[id^=\"text-\"],\ndiv[class^=\"g g-\"]","#no-ads-msg,\n.affiliate-card","#ArticleBlock > .entryMain:has(#ninja-blog-inactive) + #CommentBlock","#custom_html-55,\n#custom_html-63","div[style=\"float:none;margin:10px 0 10px 0;text-align:center;\"]","#text-13","div[class^=\"ad\"]",".ad-list",".subscription-flow","#HTML9","#HTML2",".bar-ads","#HTML6,\n.cls_PostBottomInArticleAdsence_divContents,\n.cls_PostFooterAdsence_divContents,\ndiv[style^=\"bottom: 0px; left: 0px; position: fixed;\"][style*=\"z-index\"][style*=\"background-color:\"]","iframe[src^=\"http://rcm-fe.amazon-adsystem.com\"]",".sponserd","#HTML7,\n#HTML8,\n#side-section > div.HTML:has(> div.widget-content > div.separator > a[href*=\"?utm_source\"]),\nspan[style=\"color:#666;margin-bottom:1px;\"]",".swell-block-capbox","#PR,\n.-pr,\n.sw-Ads","#sticky_sidebar_advertising-sticky-wrapper,\n.application__ads,\n.application__fixed-footer,\n.default__ads,\ndiv[style=\"width: 300px; height: 250px\"]","#adsub",".jack-wrap","#fixed_sidebar",".Side_adposition",".adsense-table","#columnLeft > div.sideBanner:last-child,\n#columnRight > div.sideBanner:first-child,\n.headBanner","table[style=\" border:1px solid #ccc; width:300px;\"]","#slide_wrap_pc,\naside.row > div.col[style=\"margin-top: 8px;\"]",".widgetSticky","#extra div.plugin-memo:nth-last-child(-1n+4),\n.paapi5-pa-product-container > div.paapi5-pa-product-details,\n.paapi5-pa-product-container > div.paapi5-pa-product-image,\n.plugin-memo:has(> div.side > script[type]),\n.pull-left.paapi5-pa-ad-unit:first-child",".amazon.Default","#extra div.plugin-memo:first-child",".aside_banner,\n.main_mokuji_ad_top,\n.newlistAdBox",".article_Banner_under,\n.side-menu-serviceLink",".dp-widget-header-title,\ndiv[id*=\"-\"][style=\"margin-left: auto; margin-right: auto; text-align: center; \"]","#mybox > .box:last-child,\n.ad-desktop-w","div[class^=\"ad-japan_adJapanLinks__\"],\nli[class^=\" \"]:has(> div.Ad)",".advertise",".advertise + hr","#text-6",".sidebar_content > div.widget_text",".widget_diver_widget_pcsp","#KkPcSideTu > nav + aside,\n#topKokuchi","#recommendedPost div.recommended:has(> div.related_content ins[data-ad-client])","#dlsite_native,\n#liver_native,\nli[id^=\"native_\"]",".adVortexFixedAd","#text-73",".kanren > dl:has(> dd > div.blog_info > p > i.fa-tags + a > font[color=\"red\"])","div[id^=\"ads-\"]",".float-right",".shared_content_container","a[href^=\"https://www.amazon.co.jp\"]",".panel-default > div.hidden-xs.row",".l_sidebar > h2:last-of-type,\n.side_box:last-child > h4","div[class^=\"sponsor\"]","a[rel=\"noopener sponsored\"]",".plugin-memo:has(> div.side > div > a[href*=\"://www.amazon.co.jp/\"][target=\"_blank\"] > img)","a[name=\"amazletlink\"]",".bottombanner,\n.resbanner,\n.sidebanner","#custom_html-9","#contents > p[style=\"text-align: center;\"]",".home-image-list-wrapper-with-advertisement__advertisement,\n.p-advertisement,\n.p-image-cards__item:has(> a.gtm-event-click),\n.p-sidebar__advertisement",".main-container-ads",".video-content-widget-area > div.custom-html-widget,\n.video-content-widget-area > h4:has(+ div.custom-html-widget)",".native-widget-area:first-child","div.side-widget-area:has(a[href^=\"https://www.e-nls.com/access.php\"])",".side-widget-area a[href^=\"https://al.dmm.co.jp\"]","#content > div[style=\"padding-top:20px; text-align:center;\"],\n.right_advs",".ad-border",".game_wrap_left > h2.game_tit,\n.pr_attention_right,\n.research_tit","#google_adsense + span.subcontit,\n.New_GoogleAD,\n.rectbanner,\n.sec_headline_promo,\n.superbanner",".pc-article-midle-ad-div,\n.post-top-ad-div,\n.right-ad-div","#movie-ad-box,\ndiv[class^=\"sidebar_ads_\"]","#custom_html-100",".ad-management",".normal,\n.txt-banner",".tweet_followme > div.hensyu_box,\n.tweet_followme > h3.komidasi_ao:first-child","#ad_rect ~ div.iframeWrapper,\n#ad_text,\n#ad_textbottom,\n#content-bottom-block,\n.content-article-pr",".banner_box,\napp-adsense-display-ads",".containertop-widget",".txtBox > p:has(> ins.adsbygoogle),\ndiv[class^=\"ad-JP_\"]","body > div.mx-10px > div.border-b:has(> div.flex > div[id^=\"div-gpt-ad\"]),\nbody > div.mx-10px.py-60px:has(> div.flex > div[id^=\"div-gpt-ad\"])","#recommend","#sponsors,\n#sponsorsTop,\n.txtBodyA1",".cc-infeed",".hatena-module-html:first-child","#fixedbanner,\n.entry-letterbody > blockquote.gazou:has(> p > a[rel=\"noopener noreferrer\"])",".link-page-full","div[class^=\"AdSection_\"]",".content > center",".p-post__adPostBlock","#subHeader_leaderboard","#floatingAd,\n.yahoo_jp_left_sidebar_ad","#main > .text_center:has(> .inline > div[id^=\"div-gpt-\"]),\n.side_ads_area",".added_app_box","#kakidashi-box-field,\n#under-toc-block-container","#post-bottom-widget","div[class^=\"ads-tag\"]",".ads_321,\n.pr_content",".md\\:max-w-672px > div.py-5:has(> div[id^=\"div-gpt-\"])","#_popIn_pc_side_rectangle_1,\n#content > ul.breadcrumb-in + div.center,\n.post-loop-wrap:has(> div[id^=\"div-gpt-\"])","#custom_html-21","div[class$=\"-ad\"]",".amazon-link","#_popIn_promotion",".ads_list","#keni_toc",".divAD_L",".plugin-memo:last-child",".plugin-memo:has(> div.side > div.AMvertical)","#scrollad","#_popIn_infeed_ranking,\n#cu_pc_article_inarticle,\ndiv[class^=\"cu_\"][class*=\"wrap\"][style*=\"height\"]",".right-container-ads + div.plugin-memo,\ndiv[style=\"margin-bottom:20px;\"]",".pab30","#content > div[class=\"ad\"] + div.section_common","#st_custom_html_widget-10",".ad_count,\n.rensai_widget","#contents > div[align=\"center\"]",".page-content > div[style^=\"margin-top:\"]:has(> div.a-single + br),\n.widget_questions_monthly_archive > div.widget_text",".advertising img",".a-single",".g-ad250","[class^=\"c-ad\"]","#entry > #entryStatus:has(> li > a[href=\"\"]) + #entryTime,\n#entry > #entryText:has(#ninja-blog-inactive) + .hr","div[class^=\"AdBanner_container__\"]",".linkul > li:has(> script[src^=\"https://pagead2.googlesyndication.com\"])","#serial-index > .box:has(> div[id^=\"div-gpt-\"]:only-child),\n.ad-top_twoside,\n.ad-twoside,\n.archives-list > ul > li.archives-list__item:has(> div[id^=\"div-gpt-ad\"]),\n.buttonlink2:has(> a[href^=\"https://amzn.to/\"]),\n.ranking-list > ul > li[class*=\"_\"]:has(> div[id^=\"div-gpt-ad\"]),\n.side-er,\ndiv[style^=\"font-family:Gill Sans;font-size:12px;line-height:12px;color:#CCC;text-align:center\"]","div[class^=\"side-ad\"]","#sidebar-scroll",".article__content > a[href^=\"https://www.amazon.co.jp\"][target=\"_blank\"],\n.article__content > a[href^=\"https://www.amazon.co.jp\"][target=\"_blank\"] + br,\n.side--right > section.module--free:nth-child(-1n+3)",".footerAD",".afbox","div[class^=\"MediaScrum\"],\ndiv[class^=\"RightColumn_rectangleBanner_\"],\ndiv[class^=\"SecondRectangle\"],\ndiv[id^=\"dol_all_\"]",".posts-list-under-widget","#custom_html-14","#custom_html-17","#custom_html-25","#custom_html-32",".ga-unit01",".widget-single-content-top",".sticky","#custom_html-24",".entry-content > p > span[style=\"font-size: 8pt;\"]","div[id^=\"mobile_ads\"]",".top-contents-ad-base","#cm_sidebar > div[style=\"margin:0px 0px 10px;\"]:has(> a[onclick][target=\"_blank\"]),\n.cm_ads,\n.main-topban","._ad,\n.vip-size-728x90,\ndiv[id^=\"optimize-sp-rect-\"]","#footer-ad-container",".ad-banner",".adnetwork-footer",".headline","#fix-space",".mainbox > .adbox + .widget_text",".sidebar > div.widget_text","#mobile_text-2,\n#mobile_text-4,\n.widget-below-toc",".widget-single-content-middle","#pcArticleAds",".small.text-center > div.row > div.text-center[style=\"margin-top:2px;color:#6c757d\"]",".AdsArea,\n.AdsArea + table + table",".right-column-inner > div.plugin-memo",".wrap > a.site-link-box",".article-body > div[align=\"center\"] > b > span[style=\"font-size: 125%;\"]","#gamefooter","div[class^=\"ad_\"]",".affiliate",".wrap-ad-common","#maingd,\n#topgd","#menu2Block > div.menuBlockBase:has(> div > div > div.plugin-freearea > ins.adsbygoogle)",".boxzilla-center-container,\n.boxzilla-overlay",".boxzilla-container",".post-widgets-middle",".adbox",".box-contentAd",".bn","#adsense-kijishita",".inner-contents a[href*=\"dmm.co.jp\"][target=\"_blank\"][rel$=\"nofollow\"] ~ a[href*=\"dmm.co.jp\"][target=\"_blank\"][rel$=\"nofollow\"],\n.inner-contents div[style=\"margin:0;padding:5px;font-size:14px;word-break: break-all;\"] ~ div[style=\"margin:0;padding:5px;font-size:14px;word-break: break-all;\"],\n.inner-contents hr,\n.side_menu:last-child","#custom_html-34,\n.post > div.widget_custom_html","#custom_html-33","#sidenavi > div#part_b,\n#sidenavi > h3.mid,\n.fr_mansion",".gadget_ad",".bfb_textTextBtn",".pochipp-box",".kijishita_ranking","#box2-inner > div.hatena-module-html:nth-last-child(-1n+2),\n#entry-footer-primary-modules,\n.customized-header,\n.entry-content > div:has(> a[rel=\"noopener sponsored\"])","p[style] > span[style=\"font-size: 80%;\"]",".g-ad","div[id][style=\"height: 300px;\"],\ndiv[id^=\"async-adsense\"][style^=\"min-height\"]","#m-osorezone,\n#subBtmBar-sticky-wrapper,\n.amazon-item,\n.aside-box > a[href^=\"https://screeningmaster.jp/\"]","div[style=\"width:728px; height:200px; margin:0 auto 20px;\"]","#bnrTwoColumnArea",".content-container > section > ol.row.ranking","#custom_html-61","#span-homes,\n.bnr-item,\n.ek-route-advertising-no-2,\n.ek-route-advertising-no-3,\n.na-bottom-wrap,\n.na-wrap,\n.sidebar-ad-item,\n.text-center[id^=\"div-transit_\"][id*=\"_access_result_\"][style^=\"margin: 8px auto\"]",".ad-bnr-w728,\n.post-header-bnr,\n.post-list-content--ad,\n.side-bnr,\n.side-infeed",".pc_banner,\n.simple-box3",".entry-content > h4:has(table a[href^=\"https://hb.afl.rakuten.co.jp/ichiba/\"]),\n.entry-content > p[style^=\"text-align:\"]",".Ad3Tile,\ndiv[style$=\"width: 336px; height: 280px;\"]","body > div[style]:has(> div.pcolle-parts),\nbody > div[style]:has(> script[src^=\"https://adm.shinobi.jp\"]),\ndiv[data-affiliateheight],\ndiv[style=\"width: 815px; height: 250px; margin: auto; text-align: center;\"]",".l-sidebar > aside.widget_custom_html:first-child","#text-672,\n.entry-content > p:last-of-type ~ table[border=\"0\"]","#ad_right-column01",".doublerec_css",".widget_amgatti_sk",".left_navi07_duga_movie",".section-swiper,\n.top-sponsored,\ndiv[class^=\"rectangle\"]","#side-fixed > div.widget_custom_html",".adbtntype,\n.adranking",".widget-banner",".pc-overlay","#main-fit-wrapper > div.pc-mieru","#BBBa,\n#BannerOne,\n#TopVrList",".ban","iframe[src^=\"https://ad-cheers.com/\"]","#extra div.plugin-memo:has(> div.side > div > div.sample_block > a[href^=\"https://adult.contents.fc2.com/aff.php\"])","table[summary=\"DMM\"]",".feed-ch,\n.feed-sp,\n.feed01","div[class^=\"ad-\"]",".post-inner > p > a[href^=\"https://al.dmm.co.jp\"]","#custom_html-15",".custom-box3,\n.eroga-widget","#article_box > a:not([href*=\"erogazo-\"]),\n#article_box > p:first-child,\n#text-42.right_sidebar,\n.post_content_btm_ad,\n.widget_text.right_sidebar:nth-last-child(-1n+2),\np > a[rel=\"nofollow\"]",".post_content_ad","#list > article.entry:first-of-type:not([id])",".entry-content > div[style=\"margin:0;padding:5px;font-size:14px;word-break: break-all;\"]","#text-106",".appc_text","#enhancedtextwidget-2","#main-top-widget,\n#text-61",".first-article > span[style=\"font-size: large;\"]","#text-22","#custom_html-27",".bann,\n.bann + ul.flex-container,\n.bann + ul.flex-container + div.button010,\n.entry-content > ul.flex-container,\n.pickupfn1",".entry-content > p > a[href^=\"https://al.dmm.co.jp/\"]","#enhancedtextwidget-27","a[href^=\"https://preaf.jp/pa.do\"]","div[class$=\"-mieru\"]",".max-w-\\[720px\\]","#enhancedtextwidget-5,\n#enhancedtextwidget-6","#enhancedtextwidget-4",".code-block[style=\"margin: 8px 0; clear: both;\"]","#container > table[width=\"960\"]",".c_c_b_w,\n.c_c_t_w,\nblockquote:has(> p > a[href^=\"https://nxcount.com\"])","#ets_contents_otona","figure > div[style^=\"display: block; position: absolute; top: 0px; left: 0px\"]",".osusumeDmm,\nh2[id*=\"random\"]","#list-wrap,\na[href*=\"/?AC=\"]",".plugin_ad_box,\ndiv[style=\"text-align: center;height: 90px; margin-bottom: 10px;\"]",".eyecatchbanner-outer",".overflow-hidden[style]","#more > center:last-of-type:has(> a[href$=\"300x250.php\"]),\n.ad-aside > a[target=\"_blank\"],\n.azrank_quote,\n.quote_area.article_detail_margin > table[cellpadding=\"5\"][style=\"border-collapse:separate;border-spacing:5px;border:none 0\"]:has(a[href*=\"amazon.co.jp\"][target=\"_blank\"] > img),\n.siteAside > div.ad-aside:nth-child(-1n+2)",".ad-siteRanking,\n.plugin-memo:has(> div.side > div#azrank-sidebar),\na.jackFix,\nblockquote:last-of-type:has(> div.amazlet-box)","#custom_html-18","#side-fixed > div.thk_ps_widget,\n#thk_ps_widget-26,\n#thk_ps_widget-71,\n#thk_ps_widget-75 > .ps-wrap,\n.bc,\n.container7,\n.ps-widget > div.top-ad:has(.img_container2)",".gb_ad_300_250,\n.gb_ad_footer,\n.gb_ad_lrec:first-child","#sideMenu > font[color=\"#666666\"],\n#sideMenu > img[width=\"180\"][height=\"16\"],\n#sideMenu > img[width=\"180\"][height=\"16\"] + br",".ad-box--app,\n.ad-box--ocam","#rmenu > div[style=\"display:block;\"] > div.p1_title,\n#rmenu > div[style=\"display:block;\"] > div.rmenubox,\n.floating-widget,\ndiv[style*=\"width:728;height:90px\"]",".bfb_textBtn,\n.bx-chat,\n.hoverner","#detail-right-bottom-ad,\n.article-ads__heading,\n.article-body__contents > a.btn-deep-orange[href*=\"?\"][target=\"_blank\"][rel=\"nofollow noopener\"]:has(~ div#art-toc),\n.article-body__contents-pr-primary,\n.banner-center,\n.banner-footer-rect-container,\n.banner-pc,\n.banner-super-jack,\n.banner-top-header,\n.l-contents-block--article-amazon,\n.search-box ~ div.l-contents-block:has(.card-game-sale-rank--amazon),\namp-iframe[width=\"382\"][height=\"700\"],\naside[class^=\"SponsorLink_sponsorLinkContainer_\"],\ndiv[class] > div.l-contents-block:has(> div.heading > a[href=\"/ranking/amazon/\"]),\ndiv[class^=\"ArticleDetailBanner_container_\"],\ndiv[class^=\"ArticleDetail_leftColumn\"] > section:has(> div > div.swiper div[class^=\"AmazonCard_card_\"]),\ndiv[class^=\"FooterRectangle_container_\"],\ndiv[class^=\"HalfPageBottomOrLargeRectangle_container_\"],\ndiv[class^=\"Header_superJack\"],\ndiv[class^=\"TopHeaderBanner_wrapper_\"],\nsection[class^=\"SecondRightColumn_\"] > ol[class^=\"AmazonRanking_list_\"]","#gam_pc_large_rectangle,\n#main-contents-side > div.textwidget:has(> section#top-game-tips > div.side-movie-pr),\n.amazon-rank,\n.jack_banner,\n.layout-ads-superbanner,\n.layout-rectangle,\ndiv[class^=\"ArticleDetail_column_\"]:has(> div > div > h2 > a[href^=\"/ranking/amazon/\"]),\ndiv[style=\"width: 1000px;height: 150px\"],\nsection[id^=\"CommonSideColumn_amazon-ranking_\"],\nsection[id^=\"CommonSideColumn_special-site_\"]:has(> div[class^=\"SpecialSite_container_\"] > div[class^=\"SpecialSite_siteImage_\"] > div[id$=\"_gam\"]:empty)","#mainArticleBottom_leftUnit,\n#mainArticleBottom_rightUnit,\n#mainArticleUnit,\n#mainFooterUnit,\n#mainTop_ATFUnit,\n#sideTop_ATFUnit",".a_fc1,\n.a_hey,\n.block:has(> .a_hey),\n.line-ad,\n.list_frame:has(> .list_main > .list_foot_field > a[href$=\"_rank\"]),\n.top-embed-ad,\n.top-live-ad","#fc2_text_ad,\niframe[src^=\"https://media5.fc2.com/\"]","#ad-footer","#ad-content","#ad_sidebody,\n.column-left_ad",".sidemenu_body:has(> dd.plg_body > div.plugin-freearea > div.dmmr18)",".mainEntryBody > center > a[href^=\"https://amzn.to\"][target=\"_blank\"],\n.mainEntryBody > center > strong:has(+ br + a[href^=\"https://amzn.to\"][target=\"_blank\"]),\n.menu1BlockBase:has(> div > div > div.plugin-freearea > a[href^=\"https://www.amazon.co.jp\"][target=\"_blank\"]),\n.menu1BlockBase:has(> div > div > div.plugin-freearea > div.AMvertical),\ncenter > a[href^=\"https://www.amazon.co.jp\"][target=\"_blank\"] > img",".rtbox_tri_rec,\n.topimg > .fc2aspace:empty,\n.wrecbox","#load:empty",".adsbygoogle","#adleft,\n#adright",".plugin1_outline:first-of-type,\n.plugin1_outline:nth-of-type(1n+3),\ndiv[align=\"left\"],\ndiv[align=\"left\"] + div[style]",".side-menu:last-child","div[class^=\"ad_entry_\"]","div[style^=\"width:728px;height:90px\"]","#sub-ad",".pompass","div[style*=\"width:300px; height:250px\"]","#menu2Block > div.menuBlockBase:has(> div.menuBlockBody a[href^=\"https://click.linksynergy.com/\"]),\n.mainEntryMore > a[href^=\"https://click.linksynergy.com/\"] ~ br,\n.mainEntryMore > a[href^=\"https://click.linksynergy.com/\"] ~ hr[size=\"1\"]","#left_column > div.menuBlock:first-child,\n.EntryMore > br + br + a ~ a[href*=\"amazon.co.jp/\"],\n.EntryMore > br + br + a ~ a[href^=\"https://affiliate.suruga-ya.jp\"],\n.EntryMore > br + br + a ~ a[href^=\"https://affiliate.suruga-ya.jp\"] ~ br:not(:last-of-type),\n.kanabell,\n.menuBlock:has(div.plugin-freearea > div[style^=\"overflow:hidden\"] > div.wboxlink)",".side_plugin:has(.adsbygoogle)",".more_ad","div[class$=\"_outline\"]:has(> div > div.plugin-freearea[style=\"text-align:left\"] > a[href^=\"https://al.dmm.com\"][target=\"_blank\"] > img)",".bnr-ad",".list_wrapper:has(> p[class=\"promotion_tag_spn\"])",".ads-container",".ad_panelAR,\n.main-body > div.content-wrap[aria-hidden][data-hidden-on-tab]","[class^=\"c-ad\"]:not(.c-ad-103)",".m-viewAd",".list-subCont > li[style$=\"height: 98px;\"],\n.pr-ads","body > table[width=\"150\"][border=\"0\"][cellspacing=\"0\"][cellpadding=\"3\"]:has(table[width=\"100%\"][border=\"1\"][cellpadding=\"5\"] a[href^=\"http://click.t2z.jp/zzz/\"][target=\"_blank\"])","#a8 > li:last-child,\n#ad728F,\n#admax-footer,\n#admax-menu,\n#dq4-related,\n#sponsored-link,\n.ad480,\ndiv[class^=\"A8-\"],\ndiv[class^=\"admax\"],\ndiv[id^=\"rakuten_\"]",".left_column","center > center > table[width=\"478\"][height=\"70\"]",".card[style=\"margin: 15px 0px\"],\n.col-xl-8 > div.row > div.col > div.card.d-lg-block",".Main__contentsParts > section.-freeArea,\n.ad-paddingbottom,\n[class^=\"Article\" i] > div[class^=\"Article\" i] > a[href^=\"https://www.amazon.co.jp/dp/\"][target=\"_blank\"]","div[class*=\"-ad-banner\"]","a[href^=\"https://www.amazon.co.jp/\"] > img","#text-42,\n.gallery","#text-47","#sticky-ads",".article > div:last-child:not([class]):has(> ins.adsbygoogle),\n.article > p:has(> ins.adsbygoogle)",".c-heading-2--with-icon-s:has(+ div#taboola-below-article-thumbnails),\ndiv[class$=\"dfp_ad\"]",".compact_coop,\n.main_body > div[style^=\"width: 100%\"][style$=\"text-align:center; margin-bottom: 10px\"],\na[href*=\"https://ads-field.com/ad/p/r?\"],\ndiv[style^=\"width: 100%; height: 280px\"]","div[style^=\"min-width: 300px; min-height: 250px\"]","div[style^=\"min-height: 250px;\"]",".ad-container","div[id^=\"logly-lift-\"]","#extra div.plugin-memo,\n#sub div.plugin-memo:nth-last-of-type(-1n+4),\n.article-body > span[style^=\"font-size:\"] + table:has(> tbody > tr > td > a[href^=\"https://www.amazon.co.jp/gp/product/\"]),\n.pager ~ center > table","aside > div[style]:has(> div.smanone > p > a[href^=\"https://www.dlsite.com/\"])","#block-9","#custom_html-8","#sub > div.plugin-memo:first-child","#pc_text-2",".ad-gate",".pop2,\ndiv[class^=\"sp_ad\"]","#boxRight > a[href^=\"https://www.amazon.co.jp/gp/\"],\ndiv[class*=\"ad-box\"]",".ad--inFeed,\n.ad--inFlex,\n.globalBody > .mdlRow.contentVisibility--auto:has(> .ad--recommend),\n.js--removeAdStyle,\n.mdlGrid__inner > article[class^=\"mdlGrid_\"][class*=\"mdlGrid__col4\"]:has(> a[href^=\"https://www.amazon.co.jp/\"]),\narticle[class^=\"mdlGrid_\"] > a[href^=\"https://www.amazon.co.jp/\"],\ndiv[class*=\"ad--rectangle--\"]",".CLS_reduced,\n.doublead,\ndiv[id*=\"_Infeed_TOP-\"],\nfooter > section:has(> div[id^=\"logly-\"]),\nfooter > section:has(> div[id^=\"logly-\"]) + hr.bold",".istock-random","#HTML12,\n#HTML15,\n#HTML26,\n#サイドバー > .HTML:not(:has(a[href^=\"https://out.freekontaktina.com\"])):not(:has(#twitter-widget-0))","#bglink,\n.banner-skyscraper,\n.related-article,\ndiv[style=\"font-size:15px;margin:30px 0 30px 18px\"]",".banners","#ad-ov1box,\n#adRakuten,\n#ad_box_double,\n.ad-selfbox,\n.amazon-book",".ad_box_double,\n.bk2.spsite,\n.listing-ad,\n.nw-ad","div[class^=\"ad-slot\"]","div[class^=\"ads_area\"]",".common__footer_main_ads,\n.common__footer_sns_ads",".main-frp-ads,\n.main-header-ads,\n.orp-player-rewarded","#rightad,\ndiv[style^=\"width:605px;height:250px\"],\ndiv[style^=\"width:728px;height:185px\"]",".tue2",".tue","#bottom-koukoku","#post-top-widget","#sidebar > div.widget_custom_html:has(center > a[rel^=\"nofollow\"] > img),\n.ad-single,\n.cta-content,\n.textwidget > center > a[target=\"_blank\"],\ncenter > a[rel=\"nofollow\"] > img,\ndiv[style*=\"text-align: center;\"] > p[style=\"text-align: center;\"] > strong,\niframe[src^=\"https://blog.fx-on.com/parts/ebooks_ranking_parts.php\"]","center > a[target=\"_blank\"] > img",".c-ad_bnr_super","#sidebar-scroll > aside#text-2",".notice_waku","#text-38",".entry-content > p > a[href^=\"https://hb.afl.rakuten.co.jp/hgc/\"],\n.entry-content > p > a[href^=\"https://www.amazon.co.jp/gp/search\"]",".wp-block-image > a[href^=\"https://www.ka-nabell.com/\"]",".cta",".header-info,\n.p-cv-btn-wrap","#sidebar-widget > div.pc_text:first-child","#ad-bottom-oya","div[id^=\"gakky-\"]","#block-4",".entry-content > a[href^=\"https://amzn.to/\"][target=\"_blank\"]",".MuiPaper-elevation.MuiPaper-rounded:has(> div[class^=\"css-\"] > div[id^=\"idhb-\"])",".amazon_box,\n.centerbox.homebox,\n.google-box2,\n.product_item_box_content",".right-container-ads > div.plugin-memo:last-of-type,\n.side_amazon,\ndiv[style=\"padding: 10px; margin-bottom: 10px; border: 1px dashed #cccccc;\"]","#ColumnAdv,\n#SquareBanner1,\n.GamePix-Games-Ads,\ndiv[class^=\"jsx-\"]",".thread__body > ul > li:not([class], [id]):has(> div[id]:empty:only-child),\n.thread__body > ul > li:not([class], [id]):has(> div[id^=\"div-gpt-\"]:only-child),\ndiv[style=\"display:inline-block;width:300px;height:250px;\"]",".pr-ranking","div[class^=\"jack\"]","#AdOverlayBanner","img[width=\"300\"][height=\"250\"]","#block-16","#block-13","#top-video-list-header-block",".top-banner","#block-5,\n.header-banner-desktop","#block-10","#block-2","#block-8","header#sqexHeader-black_rsp",".sppr",".content > h2#outline_1__2,\ntable[style=\"border-collapse: collapse; width: 100%;\"]",".l-sidebar > aside.widget_text","#custom_html-108,\n#diver_widget_pcsp-14,\n#diver_widget_pcsp-16,\n#diver_widget_pcsp-5,\n.single-related-area",".mt-12:has(> div.ads-double),\n.my-8:has(> div.ads-double),\n.white:has(+ .my-8 > div.ads-double) > hr:last-child","aside[id^=\"execphp-\"]","div[style^=\"margin: 0; padding: 5px;\"] > a[rel^=\"nofollow\"][href^=\"https://al.dmm.com/\"]","#sub div.plugin-memo:not(.plugin-link + div),\n.article-body-more > a[href^=\"https://al.dmm.co.jp/\"],\n.article-body-more > a[href^=\"https://gcolle.net\"],\n.article-body-more > a[href^=\"https://www.mgstage.com/product/\"],\n.article-body-more > hr + br + a[href^=\"https://al.dmm.co.jp\"] ~ br,\n.article-body-more > hr + br + a[href^=\"https://al.dmm.co.jp\"] ~ hr","#main_body > table > tbody > tr > td > center,\n.left_outline,\ndiv[id^=\"g_floating_area\"],\ndiv[style$=\"width: 625x;height:210px\"]",".rankbanner","div[id^=\"text-\"]:has(span[style=\"color: #ff0000;\"])",".kokowaku2",".entry-footer > div.widget_block","#custom_html-57","#ggo_250_wrapper,\n#headbar,\n#sgo_250_wrapper,\n.footer-banner > a:not([href^=\"https://gentosha-go.com\"]):not([href^=\"https://ggo-ad.com\"]),\n.side-banner > a:not([href^=\"https://gentosha-go.com\"]),\n.side-banner > a:not([href^=\"https://gentosha-go.com/\"]) > img",".bnr01",".ad_super","#banner_right","div[class*=\"-gtp-ad\"]","#banner_eye_catch",".amagetti-tabs-container + .container",".code-block > div.sponserdrink:has(+ .ninja-recommend-block)",".al-c",".right-container-ads > div.plugin-memo:first-child",".amaw_box,\n.box_drc",".entry-content > span[style=\"display: block;\"] > div[style=\"font-size:75%; color:#00BBDD;text-align: center;\"]","p[style^=\"text-align: center;\"]","#gn_sp-top_rectangle_middle,\n#gn_sp-top_rectangle_under,\n.gnz-top-banner,\n.md\\:h-\\[250px\\],\ndiv[id^=\"gn_pc-\"][style]","#article_head_v2,\n#article_top_v2",".plugin-memo:first-child",".minHeight250,\ndiv[class^=\"dfp_\"]","#related-box",".post-title-upper",".m_adbanner,\n.m_left_column_long_banner",".OUTBRAIN",".ad_phrase",".ad300_double",".post_content > div.p-blogParts > p.has-text-align-center.has-small-font-size",".video-detail__ads",".sideBanner2:first-child,\ndiv[style^=\"width: 100%; text-align: center\"][style$=\"height:250px;\"]",".adlode-cls,\n.footer_img_ssp_banner_under","#inner-footer .last .widget_custom_html",".bfb_imgBanner",".right-container > div.plugin-memo:nth-of-type(-1n+4)",".right-container > div.plugin-memo:last-of-type","#more > iframe[src^=\"https://richlink.blogsys.jp\"],\n.res_body:has(.amazon)",".plugin-memo:last-of-type",".plugin-memo:has(> div.side > div.ad-center)",".list-group > div[style*=\"max-height:125px\"],\n.list-group > div[style^=\"box-sizing:border-box;\"][style*=\"overflow:hidden;\"][style*=\"width:100%;\"],\ndiv[style=\"box-sizing:border-box; text-align:center; width:100%; height:100px; overflow:hidden; padding-bottom:10px; border-bottom:1px solid #ccc;\"],\ndiv[style=\"margin:10px 0;\"] > a[style],\ndiv[style=\"padding:0 0 30px 0; text-align:center; border-bottom:1px solid #ccc;\"]",".text > div[style=\"padding:30px\"]","#header-widgets,\n#onlineBanner,\n.entry-inner > table,\n.main-inner > center,\n.sidebar-content > div.widget_execphp",".footer-widget-1","a[href^=\"https://al.dmm.co\"]",".widget:has(> div.adsense),\n.widget:has(> ins.adsbygoogle),\n.widget:has(> ul > li > a[href^=\"https://www.amazon.co.jp\"])",".box.pr,\n.partner",".contents p.align-center","#sub div.plugin-recent_articles + div.plugin-memo,\n.topbox,\ndiv[class^=\"article-body\"] > a[href^=\"https://amzn.to/\"],\ndiv[class^=\"article-body\"] > span:has(> span > b > a[href^=\"https://amzn.to/\"]),\nspan[style=\"font-size: 125%;\"] > b > a[href^=\"https://amzn.to/\"]",".ad-relation",".side-adsense",".insentence-adsense2,\n.serviceTop-recommend-ad",".hatena-asin-detail","#top-editarea > p",".entry-footer-html > p",".entry-social-top-ad","div[id^=\"msmaflink-\"]","#top-editarea",".entry-content > .code ~ table[style*=\"width:300px\"]",".entry-footer-html",".freezed",".entry-content > p:has(> ins.adsbygoogle)","#box2-inner > div.hatena-module-html:last-child","#g-box",".banner-id,\n.box-article > .wrap,\n.col-md-2.sidebar-mobile,\n.flex-row.align-items-center.mt-2,\n.height-300,\n.height-350.px-1.col-md-4,\n.list-product,\n.mt-2.pb-1,\n.p-1.position-relative[style=\"width: 50%\"]","#JP_HBN_pc_all_billboard",".fmrect,\ndiv[class^=\"d_\"][style^=\"display: flex\"]",".arttop","#HTML54,\n#HTML61",".article-body-more a[href^=\"https://www.amazon.co.jp/\"],\n.article-body-more a[href^=\"https://www.amazon.co.jp/\"] + img + p",".mh-sidebar > .widget_custom_html,\n.sng-box.mbt2",".post-meta > div[style=\"margin-bottom:30px;\"] > div.button,\nheader > div.post-meta > div[style=\"padding:30px 0px 30px;\"]",".home-h:has(+ div[style^=\"max-width: 1\"][style*=\"height: 400px;\"][style$=\"background-color: #fff;\"]),\ndiv[style^=\"max-width: 1\"][style*=\"height: 400px;\"][style$=\"background-color: #fff;\"]",".list-main-article__header:has(+ div.OUTBRAIN),\n.post-content-ad",".a11 > div.a21",".cv_btn_02-box,\n.fixed-side-cv-btn,\n.js-fixed_side",".atop","div[id^=\"msmaflink-\"] + br + span[style=\"color: rgb(255, 0, 0);\"]","#footer > div:has(> iframe[style*=\"300px\"][style*=\"250px\"]),\n#sponsor1,\ndiv[id^=\"sponsor\"],\ndiv[id^=\"ssp\"]",".article-body > center:has(> a[href^=\"https://wu.\"] > img),\n.article-body-more > .akares,\n.himajin-headline,\n.netabare","#preview_dispAffi",".kizi-under-box","#text-18",".wrap-post-box > .post-box:not([role]):has(> .post-box-contents > .adsbygoogle)","iframe[width=\"320\"][height=\"100\"]","span.lastChild.small_letter[style^=\"position:absolute;right:10px;\"]",".colblockblank",".sec-ad",".article__content > br + div > a[href^=\"https://www.amazon.co\"],\n.module--free > center:has(> a[href] + br + iframe[src^=\"https://www.youtube.com\"]),\na[href^=\"https://www.amazon.co.jp/\"]",".prarea,\n.ut_ad_area",".tcd_ad_widget",".plugin-freearea td:has(ins.adsbygoogle)",".entry-content > center:has(> ins.adsbygoogle)",".ad_shop_footer","#ad_234x,\n.syosai","#sidemenu_right > div.plugin-freearea:has(> div.sidemenu_body > a[href^=\"https://al.dmm.co.jp\"]),\n.entry-bottom:has(+ .wakupr),\n.wakupr","#ranking-banners > table,\n.sidemenu:has(> div > div.plugin-freearea > a[href^=\"https://affiliate.suruga-ya.jp\"][rel=\"nofollow\"]),\n.sidemenu:has(> div > div.plugin-freearea > ins.widget-banner),\n.sidemenu:has(> div > div.plugin-freearea > script[src$=\"/rakuten_widget.js\"]),\na[href^=\"https://cnt.affiliate.fc2.com\"],\na[href^=\"https://cnt.affiliate.fc2.com\"] + br,\na[href^=\"https://cnt.affiliate.fc2.com\"] + br + br",".mainwidget:first-child","#custom_html-23",".widgetPost-top","#ad_fix,\n#ad_head3,\n#ad_index,\n#ad_index_fr,\n.job_ad_list_in,\n.menu_ad,\ndiv[style=\"position:relative;height:250px;\"]","#vip2_2",".uniquest-slot",".adblocks",".no-icon[href^=\"http://www.sfc.bz/\"] > img,\n.no-icon[href^=\"http://www.ultiga.jp/\"] > img,\n.no-icon[href^=\"https://www.194964.com/\"] > img",".responsibe-ad-wrap","#bnr-side-top > .list-wrap > li:has(> .adsbygoogle),\n.other-link:has(> .adsbygoogle),\n.other-link:has(> div[style] > .adsbygoogle)","#footerpr",".ad-lr,\n.huyos-widget",".entry-content > div.box26",".plugin2_outline > div.plugin2_body:last-child","#execphp-7","#block-7","div[id^=\"slide_wrap\"]","a[href^=\"http://www.cocre.co.jp/\"],\ndiv[style=\"padding-top:25px\"]","#text-28","#text-29","#custom_html-124,\n.widget:has(> .textwidget:empty)","#maincol > div.col-inner:first-child,\n#maincol > div.post:has(> div.post-title > h3 > a[href^=\"https://appollo.jp/api/lp/\"][target=\"_blank\"]),\n.rssbox02 ~ div.box,\nul > li:has(script[src*=\"//js.boost-next.co.jp/\"])",".mobileArticleAds",".articleList__ad",".custom-html-widget > a[href=\"https://haisha.linqar.com\"]","#side_top_ad",".the-content > table[border=\"0\"]",".sk-popup-window",".post > table[style]:has(> tbody > tr > td > .adsbygoogle),\naside > .author ~ a[href^=\"https://amzn.to/\"]",".adv",".check,\n.kkk","table[height=\"300\"],\ntable[height=\"878\"] > tbody > tr:has(> td[height=\"307\"][bgcolor=\"#f8fafc\"][align=\"center\"]),\ntd[width=\"948\"][height=\"167\"]","#media_image-9",".fixed-wrap",".footerBanner","[href^=\"https://www.roy-union.com/contents/ard.php\"],\ndiv[style$=\"background: rgba(0, 0, 0, 0.7);z-index:99999;text-align:center;\"]","div[id^=\"adx_\"],\ndiv[id^=\"im_wrap\"]","#header-ad-area,\n.bnr-pr,\n.formal-rectangle,\n.forum-article-bnr,\n.im_list,\n.list_school_banner_read,\n.res-banner-area",".first-article > br + b[style]",".AdsContainerDocumentTop","#custom_html-49,\n.elAds,\n.underHeaderAdPC",".splink","div[class^=\"entryadwrapper\"]","div[class^=\"gad\"]",".amaprop-side","div[id][style=\"height:285px;\"]",".ad01",".box02:has(> .ad01),\n.pcAd01",".deleteBox","p:has(> span > ins.adsbygoogle)","p:has(> ins.adsbygoogle)","#enhancedtextwidget-3","#poweredAdsBy",".plugin-monthly + div.plugin-memo","#sub div.plugin-memo:last-child",".ADW","div[class^=\"ads-cmn-\"]","#archive-ad","#related-entries > h2:has(+ div.ads),\na[href*=\".cardrush\"] > img",".ad_entry_toptext,\n.chumokujoho,\n.entry-header__ad-bottom,\n.entry_under_adunit,\n.recommend-ad,\n.under_featured_info_job_box",".adobject","#amazon-products","#text-19","div[class^=\"box_banner_\"]",".after_go_next,\n.area_a",".entry-content div[class^=\"p\"][class$=\"container\"]","#bigfooter,\n#custom_html-72","#custom_html-70",".ad-top-label",".custom:has(> div[class^=\"bg_g\"] > div[class^=\"clm\"] > a[target=\"_blank\"]),\n.slidebanner,\n.t3-banner-top,\n.t3-sidebar-right .bannergroup",".main > p[style=\"text-align:center;font-size: 80%;color: #a9a9a9;\"],\n.side_box:has(> div.font07 > div.g > div.g-col > a.gofollow)","#video_overlay_sample","#myad_alert_80,\ndiv[style=\"position: fixed; bottom: 5px; right: 5px; width: 300px; z-index: 9999;\"]",".all_banner_box_left_top_view_news",".container > div.row:has(> div.text-center > script[src^=\"https://poweredby.jads.co/\"]),\na[target=\"_blank\"] > img[src^=\"/ads/\"]","a[href^=\"https://www.extmatrix.com/?ref=\"]",".btn[href=\"/aff/chat\"],\n.teal",".adsvideo","#tracking-url,\n.widget > a[target=\"_blank\"] > img","div[class^=\"chatbanner\"]","div[style=\"margin-top: 100px\"] > div.justify-content-center","#c-modal",".td-post-content > table[class*=\"_none\"]",".banner_set:not(.pl_banner_top)","#article-ad-1","#sp-overlay:not(#style_important),\n.ArticleInnerAD,\n.Rectangle2:not(.PhotoPageScroll ~ .Rectangle2)","#other_news_website,\n#side_left,\n#side_right > .plugin-memo:first-child,\n#side_right > .plugin-memo:last-child,\n#side_rss a[href^=\"http://hb.afl.rakuten.co.jp/\"],\n#sponsered,\n.article_bodymore > table[style^=\"text-align:left;\"],\n.dix_ad_n,\n.jin-ads,\ndiv[style=\"width:728px; height:90px;\"]","table[style=\"text-align:left;margin-left:0;margin-right:0;\"]",".ad_entrymiddle_body1,\n.ad_entrymiddle_body2,\n.ad_header336_body,\n.plugin1_outline:has(> div > div > div.plugin-freearea > a[href^=\"https://www.amazon.co.jp\"]),\ndiv[class^=\"kiji_entry_ads\"]",".side_by_side",".ads_970x90","#the-content > div > div[style$=\"width: 100%; height: 312.5px;\"]",".web_adber-1","div[class$=\"_ad\"]",".plugin-memo:has(> div.side > a[href^=\"https://hb.afl.rakuten.co.jp/ichiba\"]),\n.side > a[href^=\"http://www.amazon.co.jp/gp/\"],\n.side > a[href^=\"http://www.neowing.co.jp/aff/\"],\n.side > a[href^=\"https://hb.afl.rakuten.co.jp/\"]",".side_pr","#st-header-under-widgets-box,\n#st_custom_html_widget-38,\n#st_custom_html_widget-55","p[style=\"color: #666; text-align: center;\"]",".YahooAds,\n.mainTopAd","section.block[style=\"overflow: hidden;\"]:has(> div.adsense_center),\nsection[class*=\"admid\"]","#sponsor-link,\n.frame-300-gray",".sidebar_list > li#widget_text:has(> div.textwidget > center > a[target=\"_blank\"] > img)",".entry-content > p.has-text-align-center",".column--r > center:first-child,\n.container-fluid > center,\n.container-fluid > div[style]:has(> ins.adsbygoogle),\n.container-fluid > div[style]:has(> ins.adsbygoogle) + hr,\n.container-fluid > h3.heading,\n.kattene,\n.thread-list > li[style$=\"overflow:hidden;\"],\ncenter > font[color=\"#4B0082\"] > b",".ad_tb",".plugin-amazon,\ndiv[style^=\"text-align: center; margin-top: 80px;\"],\np + table[cellpadding=\"5\"]",".pos-top.container-widget-area",".infeed.loop-article",".readmoreWrap > center",".af_bottom","#right > div.item + div:not([class]):has(> ins.adsbygoogle),\n#right > div[style=\"display:flex;\"] > div[style=\"flex-basis:280px;\"],\n#right > div[style^=\"display:flex;margin:20px 0;padding-top:5px;border-top:1px dotted\"] > div[style=\"flex-basis:336px;\"],\nbody > div > div[style=\"float:left;width:175px;\"] > div[style=\"margin-top:10px;text-align:center;\"]:last-of-type,\ndiv[style=\"display:inline-block;width:500px;text-align:center;margin-top:10px;\"] > div[style=\"display:inline-block;width:340px;text-align:center;\"],\ndiv[style=\"float:right;width:775px;\"] > div[style=\"margin-top:10px;text-align:center;\"] > div[style=\"display:inline-block;margin-right:20px;\"],\ndiv[style=\"float:right;width:775px;\"] > div[style^=\"width:730px;font-size:14px;margin-top:10px;padding:4px 0;border-top:2px dotted\"],\ndiv[style=\"width:780px;margin:0 auto;\"] > div[style=\"width:100%;margin:10px 0;\"],\ntd[width=\"340\"]","#ResSearchAdBottom,\n#ResSearchBato,\n#ads_home,\n.lasdiv,\n.s_resoncer","div[class^=\"Ad_\"]",".posts > div[id]:not([class])","#plugin_first > div.plugin_right:first-child","#text-20","#yAuctionBox,\n.bnArea,\n.bnSuper,\n.bnr-blk,\n.bnrAd,\n.c-ad_frameWrap,\n.c-box-adBox,\n.l-c_side_ad,\n.p-adBox_pc,\n.p-ad_rakuten,\n.p-cont_banner,\n.p-planBox_pr,\n.p-planbox_pr,\n.p-sideNav_bnr,\n.p-sidePr_wrap,\n.p-side_bnr_anker,\n.p-sponsorShop2,\n.pr-l-blk,\n.prTitle,\n.sponsorShop2,\n.sqTwo,\n.sqTwoWrapper,\ndiv[class$=\"-sideBnr\"],\ndiv[class$=\"-splitBox_cell-right\"]:has(> a > span > img[width=\"300\"][height=\"250\"])","#listingPr",".bodyBox > .bnr_support",".pr-bnr",".p-prArea",".side-pickup-wrap,\ndiv[class^=\"main-ad\"]",".post_datetime_tsuuhou2 > span",".cgrid-ga","div[class^=\"advertisement\"]",".ctr_ad","h2.left:has(+ #left_ads)","a[href=\"https://deaikeirank.net/\"],\na[href^=\"https://550909.com\"],\na[href^=\"https://mintj.com\"],\na[href^=\"https://pcmax.jp\"],\nbody > center > br:not(a[href^=\"https://kanajo.com\"] + br):not(img + br):not([id] + br),\nbody > font > center > br,\ncenter > div > font > center","a[href^=\"https://ac.cross-system.com\"]","#main-fit-wrapper > font[size=\"1\"],\n.main-body > div > div[align=\"left\"] > font[size=\"1\"],\n.main-body > div[align=\"left\"]:has(+ script[src^=\"https://pagead2.googlesyndication.com\"]),\na[href*=\"https://www.amazon.co.jp\"],\ndiv[style^=\"margin-bottom:5px;padding:2px;width:840px overflow:auto;height:362px\"],\ndiv[style^=\"margin-bottom:5px;width:832px overflow:auto;height:148px\"]",".krb-amzlt-box","#ads",".category-ue:first-child,\n.menu-ads",".ad_rectangle","#gb_pc_banner_contents,\n.c-ad-750-100,\n.c-ad-game-footer,\n.c-game-side-menu__ad-wrap",".adsbygoogle-noablate",".featured.section-inverse","#header-ad-o,\n#overlay,\n.article_mid_v2,\n.readmore-header:has(> div.ads-label),\ndiv[class^=\"ads-label\"],\ndiv[class^=\"ads-rect-\"],\ndiv[id^=\"karapaia_\"],\ndiv[style=\"padding-top: 10px; height: 600px\"]",".rectangle_bnr,\n.sideNav > div.execphpwidget,\ndiv[style=\"text-align:center;\"] > a[onclick^=\"ga('send', 'event', 'banner'\"]:not([href^=\"https://www.kashi-mo.com/\"])",".o--ads-area",".ad-pc",".ui-block-b:has(script:not([src]))","#my-footer",".ad-g,\n.news__detail__ad",".l-header__ad","#content > div.nosma","a[id^=\"tel\"]","div[id^=\"im_panel\"]","#ggl-wrapper,\n#ggl-wrapper + hr,\n.ggl03","#header_up,\n#sidebar > div > div > div.a-single,\n#sidebar > div > div > div.g",".articleSingle__ads,\n.twoAds",".adAdjust01",".entry-content :not([class]):has(> ins.adsbygoogle)",".entry-content > div.center:has(> p a[target=\"_blank\"][rel=\"nofollow noopener\"]),\n.responbox50",".side-menu__sponsord","div[id^=\"articleAd\"]",".plugin-memo:has(> div.side > div[id^=\"side-koukoku\"])","#sub div.plugin-memo:last-of-type",".article-body > span[style=\"font-size: small;\"],\n.ban_txt,\n.kijo_banner,\n.right-container > div > div.plugin-memo:last-child","div[class^=\"advads-\"]","#the-content > center","div[id^=\"kinto-\"]",".c-sponsor-bnr","div[style^=\"width:720px; height:90px\"]","div[style^=\"width:160px;height:600px;\"]","div[class^=\"rectangle-\"]",".prText",".respnsvad",".rss_c,\ndiv[style=\"min-height:80\"]",".ranking > li > a[href^=\"https://ac.congrab.com/\"]",".l-main__adlabel",".amzimg",".mostreadbox",".cps-post-main > a.blog-card + table",".adblock,\n.adblock + hr",".dmm-widget-placement,\n.plugin2_outline:has(> div > div.plugin-freearea > div[align=\"center\"] > a[href^=\"https://amzn.to\"][target=\"_blank\"]),\ntable[style=\"border-collapse: separate; border-spacing: 5px; \"]","div[class$=\"_outline\"]:has(.sample_block > a[href^=\"https://adult.contents.fc2.com/aff.php\"])",".Ads__heading,\n.Ads__under--permalinks,\n.article__content > center,\n.l-wrapper > section.module--free td:last-child,\n.side > section.module--free > center","#text-23",".adc,\ndiv[style=\"clear:both; width:300px; height:250px; margin:10px auto; text-align:center; line-height: 0px;\"]",".adv-page-title-bottom,\n.adv-sidecontent-bottom,\n.adv-sidecontent-top,\n.js-osusumetopicsarea",".l-sidebar > aside.widget_custom_html,\n.postCta,\ndiv[style*=\"min-height: 250px;\"]",".c-ad--sidebar-top,\n.c-sidebar > section.widget_text:last-child,\nsection[class^=\"c-ad\"]","#sadr","div[id^=\"ad\"]","#plugin2 > div.sub-container > div.plugin-freearea:has(> div > div > ins.adsbygoogle)",".l-mainContent__inner > center,\n.l-mainContent__inner > center ~ br:nth-of-type(-1n+3)",".entry-content > #my-footer",".ad_desc",".MdSB07Bnr,\ndiv[style*=\"width:640px;\"][style*=\"height:253px;\"]","#block-article-details-banner,\n#block-top-content-banner2,\n.y2024-content-wrap-01 > div.y2024-content:has(> div > div#block-sp-common-top-ad-banner),\ndiv[style=\"min-width: 728px; min-height: 90px;\"]","div[style$=\"min-height: 250px;\"]","div[class*=\"fourm\"]",".DlyFixedBanner,\n.EntertainmentArticleAds-root,\n.PcAside-ads,\ndiv[class*=\"adsWrapper\"],\ndiv[class^=\"article-items_ads_\"],\ndiv[class^=\"article-items_ads_\"] + div[aria-hidden=\"true\"]:empty,\ndiv[class^=\"page_sp_ad\"]","a[class^=\"side-banner_side_fixed_banner_\"]",".ad-b1","#top-banner",".widget_text:nth-last-child(-1n+2)","#commodity_ul","#ad1",".first-article > div[style=\"background:#E065A0; padding:5px; border:0px dotted #ff0000;\"],\ndiv[style^=\"width:778px;height:270px\"]","#page-banner","#newsNew > div[style=\"border-top: solid 2px #1b99c6;padding: 1em 0em;\"],\n#orverlay_kyotei,\n.center[style=\"margin:20px 0px;background:#f5f5f5;padding:3px 0px;\"],\ndiv[id^=\"banner_top_\"][class]",".widget_pc_ad","#fanza_native","#ArticleBottom > span[style=\"font-size:0.8em;color:#666;clear:both\"],\n#logoad,\n#rightbody > .plugin-memo > .side > div[style^=\"width: 100%; height: 250px;\"],\n#rightbody > .sideparts_200c + .plugin-memo > .sidetitlebody,\ndiv[class^=\"sideparts_\"]",".st-ad-on-title","div[class^=\"u-hasAd\"]",".cps-post-main center",".item_area,\ndiv[id^=\"bnc_ad_\"]","table[cellpadding=\"6\"] > tbody > tr > td[bgcolor=\"#FEE227\"][align=\"center\"]","body > center > font[size=\"4\"] > b > a[target=\"_blank\"][rel=\"noopener nofollow\"],\ncenter > font[size=\"2\"][color=\"#99801a\"] > b,\ntable[cellspacing=\"8\"] + br + table[width=\"98%\"][bgcolor=\"#cdcdcd\"]",".adnet-item",".plugin-memo:has(> div.side > ins.adsbygoogle)",".plugin-memo:has(> div.side > div.amazon)","#sidebar > aside#block-2:has(> iframe[data-src*=\"mmaaxx.com\"])",".adsW","#yadsOverlayUnit,\n.rakutenSec",".text-center[style=\"height: 280px; margin-bottom: 40px;\"],\n.w-100[style=\"height: 283px; margin-bottom: 40px;\"]","#custom_html-74","#content > center > a[href^=\"https://www.dlsite.com/maniax/dlaf/\"],\n#g_floating_area2","#taboola-thumbnails-mid2,\n.ad_square_sidebar",".matchedsidebarhome,\n.playblockaptp,\n.playblockbtmcon,\n.playblocktop,\ndiv[class^=\"responsive\"][class$=\"inc\"]","#main > center,\n#scrollbar-left,\n#scrollbar-right","a[href^=\"https://www.e-nls.com/access.php\"]",".type-page span.small",".plugin_first:has(> div > div.plugin-freearea[style=\"text-align:left\"])","#pr_bnr,\n.durasite,\n.siber-widget,\ndiv[class*=\"ad-h\"]",".relatedAdBox",".add.contentunder","#banner-footer > div.g,\n#banner-rectangle,\n#banner-spread,\na[href^=\"https://bit.ly\"],\nsection[id^=\"banner-infeed\"]","div[id^=\"div_fam8_\"]","#sub div.plugin-memo:has(> div.side > script[language=\"JavaScript\"]),\n.comment_rank_widget_root + div.main,\n.headline_outline",".center > p.nospace,\n.small.center",".sidebar-right","#browsi-wrec1ad",".list_series > li.product:not([id]),\n.sticky_banners","div[id^=\"manga-\"]",".home_widget",".manga-widget",".ad_01",".ad_affiliate,\n.ad_affiliate_common_footer,\n.nbrArea",".entry_text:nth-child(2):has(> #ninja-blog-inactive) + .entry_footer",".contents-bottom-ads,\n.description-bottom-ads","#scroll-adv,\n.amazonLinkMod",".ad-page","#side-right > div.side-widget-area:has(a[href^=\"https://rcv.ixd.dmm.com/api/surl\"]),\n.ently_thumbnail + div.video,\n.post > a[href^=\"https://rcv.ixd.dmm.com/api/surl\"] + div.video-bottom-widget-area","#sidebar > div.widget_text","div[style].plugin-memo.sidewrapper","#st_custom_html_widget-53",".recommend","body > div.container > div.my-4.text-center:has(> div[id^=\"div-gpt-\"]),\nbody > main + div.d-flex:has(> div.my-4 > div[id^=\"div-gpt-\"]),\ndiv[style=\"min-height: 280px\"],\nmain > div.flex:has(> div.flex > div.text-center > div[id] > iframe[id^=\"google_ads_\"]),\nmain.mt-3 > div[class=\"d-flex\"]",".l-banner01Ad,\ndiv[class^=\"l-adBanner\"]","#more > .t_b ~ p:has(> a[href^=\"https://www.amazon.co.jp\"])","#custom_html-1","#sidebar-2 > div.sticky,\ndiv[id^=\"ad-sidebar\"]","div[style] > div[class^=\"css-\"]:has(> div[id^=\"gpt_\"])","#media_image-10",".amazonwrapper",".list-group > .list-group-item:has(a[href*=\"&utm_medium=affiliate&utm_campaign=affiliate\"])",".ently_text > table[style],\n.menuLineDouble:first-child,\n.menuTabLight ~ p.pickup-2,\n.plugin3_outline:last-child","#classictextwidget-7",".plugin-memo:has(> div.side > div > a[href^=\"https://amzn.to\"][target=\"_blank\"])","#articlemainmore > div[style=\"margin:40px 0px 0px 30px;\"],\n#blogbody_id > div[style^=\"text-align:left; font-size:18px; margin:60px \"],\n#leftbody > div.plugin-memo:first-child,\n#leftbody > div.plugin-memo:last-of-type,\n#rightbody > div.plugin-memo > div.sidetitlebody:first-child,\n.related-articles","p[style=\"color:#666;margin-bottom:5px;\"]",".cta-wrap",".mdbnAdBlock__970x90,\n.mdbnViewerLast__adBannerBox,\ndiv[class^=\"adBlock__\"],\ndiv[style^=\"width: 970px;height: 90px;margin: 10px auto -10px\"]",".toTheEdge[style=\"text-align:center;font-size:24px;padding:10px;\"],\n.toTheEdge[style=\"text-align:center;font-size:24px;padding:10px;\"] + div.line,\ntr > td[colspan=\"4\"][align=\"center\"]:has(> script[src^=\"https://xml.affiliate.rakuten.co.jp\"])",".new.list > ul > li.item:has(> div[class^=\"iads\"])",".sp[style^=\"width:336px; height:280px\"]",".widget_pc_text",".furima-assist-ad-wrapper","div[style^=\"padding-top\"] > div[class^=\"_container_\"]:has(> div[class^=\"_wrapped-about-ads-link\"])","#text-23 > div.textwidget > div.wd_title_rss + p",".r-scroll,\n.side--right > section.module--free:first-child","div[id$=\"_ArticleBottom\"],\ndiv[id^=\"MM_PC_rectangle_\"]",".ad-in-article",".widget-below-single-content-title",".widget-below-sns-buttons",".entry-content > center",".entry-content > p[style=\"text-align: center;\"]",".adaida",".article__content > div[align=\"center\"]:not([class]),\n.module--free:has(> div.module__body > ins.adsbygoogle)","#fanza-slider,\n.i2i-header-text,\n.item-list > li.item:has(> div[class^=\"iads_\"]),\n.movie > ul > li.item:has(> div[class^=\"iads_\"])","#side_advertisement","aside[class^=\"happy\"]",".hallkouryakuline,\n.widget_sidebar_ad",".ninki","#desmiss,\n#post-0,\n.entry-content > .external,\n.entry-content > video ~ p.bd[style^=\"padding-bottom:\"],\n.menu-item > .external,\n.post p.bd[style^=\"padding-bottom: 50px\"]:has(> a[href^=\"https://al.dmm.co.jp/\"]),\n.topframe,\na[href^=\"http://www.amazon.co.jp\"][target=\"_blank\"][rel=\"noopener\"] > img.pict",".addown,\n.adup","iframe[src^=\"/top_center_bn/\"]","#js-slick,\n.bn250,\n.main-column > div.slider",".os-ads",".right-1st,\ndiv[id^=\"main\"] > aside > table:only-child","#sub > div.category > a[border=\"0\"][target=\"_blank\"][rel=\"nofollow\"] > img[width=\"300\"][height=\"250\"]",".tcdw_ad_widget",".entry-content > p > a[href^=\"https://amzn.to\"],\n.widget-footer-center",".widget-content-top",".movie__main > .movie__tag + div[style*=\"display: block; position: absolute; top:\"]",".free-area__ad",".header_banner","#left > div.side_box:has(> center > div > a[href^=\"https://al.dmm.co.jp/\"]),\n#right > div.side_box:has(> center > ins.dmm-widget-placement),\n.pc-top-banner","#top2_left,\n.entry-body > center > table[width=\"430\"]:not([cellspacing]),\n.font_pr4,\n.solinkimag,\n.widget-content-top table.has-fixed-layout td:has(> div > div.topprimg)",".widget-index-top",".widget-single-content-bottom","div[style=\"min-height: 280px;height: auto\"]",".mg-ads-inarticle,\n.mg-ads-placement","#myplace-100,\na[href^=\"https://www.madamlive.tv/LiveChat/acs.php\"],\ndiv[class$=\"-header\"],\ndiv[class$=\"-home\"] > div[style$=\"margin: auto;\"][style*=\"width:\"],\ndiv[class$=\"-single\"]","#main > div[style^=\"max-width:\"][style$=\"background-color: #fff;\"]",".tablink","#pc_text-6","#sub div.plugin-memo","#im_panel",".kaisetsu-box2","#ad-content-bottom,\n.mp-fixed-ads-screen",".mp-recommends-text,\ndiv[class^=\"mp-fixed-ads\"],\ndiv[data-ads]","#main div.column-inner-2 div[style=\"text-align:center;\"],\n#sub div.plugin-memo:nth-child(-1n+2)",".mediascreen","div[style=\"width:800px;\"]",".main-kizi-box:has(> .adsbygoogle)",".category_tab div[id^=\"text-8\"] > div.textwidget,\n.h_ttl.related-h > span.gf,\n.no-icon[href^=\"https://www.amazon.co.jp/\"]",".top_upper",".AMhorizontal + hr,\n.first-article > img.pict[width=\"24\"],\n.first-article > img.pict[width=\"24\"] + b,\n.plugin-memo:has(> div.side > script[src^=\"https://pagead2.googlesyndication.com\"])","#ad960x540,\n#dti_movie,\n.adbd[style^=\"background-color: rgb(255, 0, 96); color: white; text-align: center\"],\n.dti3free,\ndiv[style=\"height: 300px;\"],\ndiv[style=\"height: 840px; padding: 6px; margin: 0px 0px 16px;\"],\ndiv[style=\"width: 1020px; height: 380px; background-color: white; padding: 4px;\"]","#dtiovervideo,\n#left_ad_body,\n#thread_index_adb > div[style]:not(.btn),\n#thread_index_adt > div[style]:not(.btn),\n#trend_pain,\n.hey_douga,\n.hey_video,\n.trend_body > div:first-child,\n.trend_body div[style^=\"background-color: black; overflow: hidden; color: white\"],\nbody > div[style^=\"z-index: 105; position: fixed\"],\ndiv[style=\"margin-left: -1px; font-size: 0px; overflow: hidden; width: 200px; border: 1px solid gray; height: 64px;\"],\ndiv[style=\"width: 400px; height: 720px; margin-top: 30px;\"]",".txtad","#main > div[data-section-id=\"stripe.special\"]",".side-topad > .ad:first-child",".page_double_rectangle_wrapper","#float-bnr2",".koukoku-top,\n.side-body:nth-last-child(2)","#mybox > .ad,\n.theContentWrap-ccc > .head-cons2-pc","aside[class^=\"ads-\"]",".ad-video,\ndiv[class^=\"adarea\"]",".entry-footer > a[href^=\"https://hb.afl.rakuten.co.jp\"]",".amazon-auto-links-widget",".css-92i9wm,\ndiv[data-testid^=\"advertisement-\"]","#pc_big_ads_before_subfooter,\n#pc_sidebar_ads_a,\n.ads_contents_footer,\n.ads_contents_header","div[class^=\"c-ad\"]","#main-content > nav#breadcrumbFt + aside:not([class]),\n#navi-r > p.semihide[style=\"margin-left:15px;text-align:left;\"],\n.ads-page",".admsg","#ads-page-top,\n#main-content > p.semihide",".entry center",".infeed",".matome_caution,\n.sale_caution","#pc_text-3",".customized-header > .entry-header-html,\n.entry-footer-html > font[size=\"1\"]","#custom_html-22",".sidebar-box3","#original_ad1,\n.ad-posi1,\n.ad-posi2","#b_frame > #bottom_neta_list + a > div[style],\n#fixed_ad,\n#middleadv-nex,\n#vipad,\n.bottom_aff,\n.ngo1t2_simple,\n.thread_body > div[style=\"background-color:#FFF;padding:20px;-webkit-border-radius: 4px;-moz-border-radius: 4px;border-radius: 4px;border:1px dashed #ff00ae;\"],\n.thread_body > div[style^=\"margin-top:50px;background-color:#FFF;\"],\na[href*=\"//advcnt.nan.co.jp/r_out.cgi?\"],\na[href^=\"http://meeba.jp/campaign/\"],\na[href^=\"https://nosports-nofoul.tokyo/\"],\ndiv[style=\"border-bottom:1px solid #555;padding:20px 20px;\"],\ndiv[style=\"height:250px;width:610px;background-color:#000;\"],\ndiv[style=\"margin-botom:0px;min-height:100px;margin:0 20px;\"],\ndiv[style=\"margin:-5px 15px 10px 25px;height:70px;\"],\ndiv[style^=\"margin-top:\"]:has(> div > iframe[src*=\"/bbs/inc/hedadv\"]),\niframe[id^=\"bottomad\"],\niframe[src*=\"/bbs/inc/\"],\niframe[src=\"/show/bbs/s/inc/footadv_s_in/\"]",".side-ninki,\n.top-siko","#sidebar > div.widget_custom_html",".article-body-inner > p[style=\"”font-size:5pt;\"] + center",".hoverner-link",".xo-slider",".my-4.flex.justify-center,\naside.px-4.md\\:mt-6.md\\:px-0 > div.mb-8:first-child,\ndiv[style=\"height:250px;width:300px\"]","#ai_widget-9","#ai_widget-3,\n#ai_widget-5,\n#ai_widget-6,\n#ai_widget-8,\n.posts-list-middle-widget",".entry-under > div[style=\"margin: 0px 0px 20px 0px;\"]","div[style=\"text-align:center;margin-bottom:50px;color:#999;\"]","p[align=\"center\"] > a[target=\"_blank\"] > img",".ml-auto > .insurance-container > .text-center","td[height=\"280\"]",".hentry > div[style=\"text-align:center;\"],\n.pcUser","#main > div.column-inner > div.column-inner-2 > a[href^=\"https://e-gaming.g2afse.com/click\"],\n#rss-box,\n.article-outer-3 > a[href^=\"https://e-gaming.g2afse.com/click\"],\ndiv[style=\"position:fixed;bottom:0;right:0;z-index:9999;\"]",".al-c[style=\"text-align: left;\"]","#bottom_block.td","#HTML10,\n.botmads,\n.centa2,\n.postman22-nw2,\n.postman22-nw255","#pc_nk_top_main0,\n.Ad-main_footer,\n.SideJackBnr,\ndiv[class^=\"nk_AdvBox\"]",".nar_top_message_box,\ndiv[id$=\"_banner\"][style] > .modal_open","#side > div.inner > div.side_plugin,\n.side_plugin:has(> div > div > div.plugin-freearea > a[href^=\"https://amzn.to\"]),\n.side_plugin:has(> div > div > div.plugin-freearea > div > a[href^=\"https://al.dmm.co.jp/\"])","#bannerB2,\n.amazon-sidelist,\n.top-column-sidelist2",".FixedWidget__fixed_widget","#list2,\n.kensakubu + div:has(> a[href^=\"https://amzn.to\"]),\n.kouwaku1,\n.topkou,\n.uresuji-waku-all",".kokowaku3,\n.kouko3,\n.sideh2:has(+ .kouko3),\n.topmain + div > div:has(a[href*=\"amazon.co.jp\"]),\n.waku-zentai:has(a[href*=\"amzn.to\"])",".ad4-5,\n.adSec02,\n.su-modal,\ndiv[style=\"min-height: 395px; margin-bottom:10px;\"],\ndiv[style^=\"position: fixed; display: block; height: auto; bottom: 0px; width: 100%; z-index: 100\"]",".rSectionInner > div.side:first-child",".ad-list2,\n.article-body > aside.mb12:has(> div + script[src]),\n.article-body-after > aside.mb20:has(> div + script[src]),\n.s-side[style^=\"position: fixed\"]",".ad_response",".mb0.s-side[style],\n[class^=\"l-\"] > [class^=\"s-\"]:has(> [class^=\"ad-list\"])",".post div[align=\"center\"],\n.post div[align=\"center\"] + br,\n.post div[align=\"center\"] + br + hr","td[style=\"border-style: solid; border-color: #1a1919; text-align: center; height: 70px;\"]",".pcbl.bannerlist,\naside > .banner","#main div.column-inner-2 > center,\n.plugin-blog_members + div.plugin-memo","#custom_html-12","#side-fixed a[href^=\"https://www.amazon.co.jp/\"],\ndiv[id^=\"ad-slot\"]",".detailBottomAdWrap","#subBnr,\ndiv[class^=\"Container_btmBnr\"]",".is-ad","#footerRect","#_popIn_infeed1,\n#sidebar_head_banner,\n.widget > div.widget_row,\n.widget_min,\na[id*=\"_banner\"][target=\"_blank\"]",".campaign-list,\n.campaign-ttl",".product-item-box",".entry-content > center > a[href^=\"https://al.dmm.co.jp\"][rel=\"noopener\"]",".osu2,\n.sidelink,\n.topdmm,\ndiv[style=\"width: 300px;height: 250px;\"]","div[class^=\"article-body\"] > div[style=\"margin:0;padding:5px;font-size:14px;word-break: break-all;\"]",".sine5",".amazon_block,\n.dmm-box,\n.headline_entry_middle1,\n.plugin3_body,\ndiv[id$=\"test\"]",".adv-area",".books-single",".ad_bunner","#menuBlock-l,\n#menuBlock-r > div.menuBlockBody:has(> .menuText2 > div[align=\"center\"] > div.pr_banner),\n.menuBlockBase:has(+ div.menuBlockBody > .menuText2 > div[align=\"center\"] > div.pr_banner)","#adUnit32,\n#headerAdBnr2022,\ndiv[id^=\"adUnit\"]","#headerAdBnr",".wr",".cmn-sub_banner,\n.k-ad__text,\n.k-hub-layout__column-infeed-pr,\n.l-main_primary > .l-section:has(> .-textAd),\n.nui-ad,\n.search__promo,\n[class*=\"adForLarge_\"]:not([class^=\"anchor_\"]),\ndiv[class^=\"bottomContainer_\"] > div[class^=\"container_\"]:has(> h2 + ul[class*=\"adForLarge_\"]),\ndiv[class^=\"default_\"]:has(> div > div[class^=\"ad\"])",".js-stickySidebar,\n.js-stickySidebar_area,\n.p-card_list > li:has(> div[id^=\"div-gpt-ad-\"])",".p-contents__pr",".dag_banner",".l-section > ul.p-articleList > li:has(> div[id^=\"div-gpt-ad\"]),\n.p-articleAdList,\n.ranking + div.dag_banner + section.l-asideSection","#sticky1 > section.l-asideSection:has(div[id^=\"div-gpt-\"]),\n.-adtag,\n.l-main_primary > section[class=\"l-section\"]:has(> div.c-iconAd),\n.l-section[data-personalize-ad],\n.p-articleList > li.p-articleList_item:has(> div[id^=\"div-gpt-ad\"]),\n.p-articlePanel_item:has(> div[id^=\"div-gpt-ad-\"]),\n.p-article_ad,\n.p-article_banner,\n.p-article_recommend:has(> .p-article_recommend_heading > .p-article_recommend_image > a[href*=\"campaign\"])",".ad-text-box,\n.articles-list-item:has(> div[id^=\"div-gpt-\"]),\n.side-sticky-box[style=\"height: 2000px;\"]",".notice-area-link[href^=\"https://x.com/nintendoevery/status/1789294462038122577\"]",".kwaku1",".post-content ~ div.row:has(> div[class^=\"col-xs\"] > div.post-banner)","header.pc",".fr-adpon",".entry-footer-ad",".p-adBox",".left-column-inner > div.plugin-memo:first-child",".inyou,\n.inyou + p:has(> a[href^=\"https://www.amazon.co.jp/\"]),\n.left-column-inner > div.plugin-memo:last-of-type,\n.right-column-inner > div.plugin-memo:last-child","#leftbar > a[href^=\"https://al.dmm.co.jp/\"],\n#more > a[href^=\"https://al.dmm.co.jp/\"] > img",".scroll","main .widget_text.sidein","iframe[width=\"300\"][height=\"250\"]",".list > li:has(> script[src^=\"https://img.ad-nex.com/\"]),\n.list > li:has(> span.text > a[title^=\"(PR)\"])","div[class^=\"CardItem__adContainer\"],\ndiv[class^=\"DFPAdSlotListBottomFrame_\"]","#pc_tag_banner_area_1,\n.AdSlot_rectangleBox__20CXH,\n.c-side-block--banner,\n[class^=\"AdSlot_\"],\ndiv[class^=\"pc_adBox_\"]",".sec-recommend","#ads_w","#js-advertisingHeader",".banner-prbox,\n.mbb-left",".ly_main_inner[style^=\"margin-top: 50px; \"],\ndiv[style=\"width: 728px; height: 90px;\"],\ndiv[style^=\"display: inline-block; min-width: 300px; min-height: 250px\"]",".left-container > .left-column-inner","#contentleft > section > div.con:first-child,\n#r_sidebar > div.left_sogo","div[id^=\"veot_contents\"]",".brain_banner",".affiliate_tags","#sakusaku_admid,\n.card_ad,\n.wrapper_right_ad",".plugin-memo:has(> div.side > div[class^=\"google-user-ad\"])","#links > div.side:last-child",".l-ad-first,\n.p-ad-wrap02","#sok_side","#main > div[style^=\"margin: 0 auto 60px auto;\"]","#e,\n#e + div.entry_body,\n#more > a[href*=\"dmm.co\"],\n#sidemenu2 > dl.sidemenu_body:first-child,\n#sidemenu2 > dl.sidemenu_body:has(a[href^=\"http://www.e-nls.com\"]),\n.entry_body_banner,\n.entry_body_rss,\n.sidemenu_body:last-child",".cat_entry[style=\"height: 540px;\"]","#bnrarea",".adBox_inNews","#full-size-ol","#text-58,\n#text-59,\n#text-60,\n#text-74,\n#text-76,\n#text-77,\n#text-83,\n#text-86,\n.entry-content > div.wp-block-image:has(> figure > a.no-icon),\nimg[width=\"728\"][height=\"410\"],\nimg[width=\"728\"][height=\"410\"] + noscript + figcaption","#text-50","#text-78","#text-81","#text-122,\n#text-71","#my-footer > p[style]",".board_dmm,\n.fc2AD-title,\n.fc2AD-wrap",".content > div[style=\"margin:0;padding:5px;font-size:14px;word-break: break-all;\"] > a[href^=\"https://al.dmm.co.jp/\"]","#text-25","div[class^=\"yoneads\"]",".ad_minh_sp",".container > div[style]:has(> div.adv-bb),\n.logly-block,\ndiv[class^=\"adv-\"]","div[id^=\"boxad\"]",".footer-google-ads,\n.google-ads-item","#container > center,\n#container > hr,\n.main-container center,\n.main-container hr",".plugin-memo:has(> div.side > div[align=\"center\"] > a[href^=\"https://hb.afl.rakuten.co.jp\"][target=\"_blank\"])","#block-284,\n.eroterest_partsv2","#scrollfix > div.widget_custom_html,\n.hentry > div.widget_custom_html",".is-12 > div.block__content:has(> div ins.adsbygoogle)","#slide_wrap",".entry_adv",".external",".entry-content > p > a[href^=\"https://www.amazon.co.jp/dp/\"]","a[href^=\"//af.moshimo.com\"]","#ad-area",".side-topad > div.widget_st_custom_html_ad_widget",".home-post",".st-eyecatch",".widget_text",".responsibe-adsense-wrap","td > font[size=\"2\"] > span[style=\"font-family:HGP創英角ﾎﾟｯﾌﾟ体; font-size:2em; color:darkgreen;\"] ~ a,\ntd[valign=\"top\"][width=\"400\"][align=\"left\"]","header ~ div[class^=\"sc-\"]:not([id]) > div[class^=\"sc-\"]:not([id]) > div[class^=\"sc-\"]:not([id]) > div[class^=\"sc-\"]:not([id]):has(> div[style=\"min-height:250px\"])","div[style=\"min-height:250px\"]",".ad-box-02","div[style^=\"height:250px\"]",".widget:has(> a[href^=\"https://subyshare.com/affiliate/\"])","#cgrig_commid,\n#cgrig_comtop,\n#comright,\n#content > div.centcom,\n#incomtop,\n#midcom_outer","div > table[width][cellpadding=\"0\"] td[colspan=\"5\"],\ntable[width=\"728\"][height=\"90\"],\ntable[width=\"728\"][height=\"90\"] + hr","#rightBanner_1","#topBanner",".b--header","#ac-main-content > div.ac-p-2.bg-light.ac-mb-4.ac-d-lg-block,\n.ac-p-2.bg-light.ac-mb-3.ac-d-lg-block,\n.bg-light.ac-p-2.overflow-hidden[style=\"min-height: 120px;\"],\n.theme-ads-box-no-border,\n.w-100.my-3.bg-light[style=\"min-height: 306px;\"]","div[style=\"min-height: 90px;\"]","#r-fix,\n.ad-footer-related,\n.googleAdPost,\n.googleAdSide",".ap-block-ar,\n.hdg-c,\n.ik-32",".d-md-block > h3.forum-information:has(> i),\n.dmm-widget-wrapper,\n.forum-information > a[href^=\"https://summary.fc2.com/a/summary.php\"],\n.forum-information > table[border=\"0\"]",".col-md-8.order-md-0 > div.content > div.border-bottom.pb-3.d-md-block:has(a[href^=\"https://al.dmm.co.jp\"]),\n.forum-information > a[target^=\"_blank\"],\n.forum-information > a[target^=\"_blank\"] ~ br,\n.forum-information > span[style^=\"FONT-SIZE:\"]","body[bgcolor] > hr + br + div > ul","#execphp-8","#sortb > tbody > tr:not([class])",".post_content > div[class^=\"piyon-\"][style]","#text-46","#text-48",".theiaStickySidebar > .widget_text",".posts-list-upper-widget","#apptemppk2",".c-footer-ad,\n.c-side-rectangle-ad",".SideBarMid","div[id^=\"content_block_\"][class^=\"wiki-section-body-\"] table[id^=\"content_block_\"]:has(a.outlink[href*=\".amazon.co\"][target=\"_blank\"] img[style*=\"max-width:\"])",".ads_oya,\ndiv[style=\"height:100px\"]",".entry-content > p + div[style=\"border-style: solid ; border-width: 2px; border-color: #CCCCCC;\"]","#notfix > div.widget_custom_html",".home_bottom","#pc_text-74",".add_main,\n.add_post_sidebar","#right > .rank_table,\n.addl,\n.box_title_pr,\n.dvd_ad_right,\n.fanzabook,\n.mid_ad",".k_footer-body > div.k_row:has(> div > div[style^=\"width:300px\"])","#side > aside.widget,\ndiv[class^=\"iads_\"]",".gn_inline_exp","#main-content > div[align=\"center\"] > table td[width=\"340\"],\n#main-content > div[align=\"left\"] > p.semihide,\n#navi-r > div[style=\"margin-left:15px;\"]:not([class]),\n#relatedItem,\n.TRelatedItem",".line.mg_t20.mg_b13:has(+ script[src*=\"/amazon.js\"])","body > div[id][style*=\"9999\"][style*=\"fixed\"],\ndiv[id^=\"nitro\"]","a[href^=\"http://srv2.e-nls.com/\"],\na[href^=\"http://track.cross-system.com/click.php\"]",".css-pvblll,\n.p-items_main > div > div[class]:has(> div > div[class] > div[class] > div[class^=\"ad-\"][class$=\"0\"]),\n.p-items_main > div:not([class], [id]) > aside[class^=\"style-\"]:has(> div:only-child:not([class], [id]) > div[class^=\"style-\"]:only-child > div[class^=\"style-\"] > div[data-testid=\"ArticleAdsAfterBody_AdUnit\"]),\n.p-items_main > div[class^=\"css-\"]:has(div[id^=\"dfp-slot-\"]),\n.style-1gtaew4[data-testid^=\"popup-\"][data-testid$=\"-signup\"],\n.style-uaiz0z,\n.style-xgff9b,\narticle ~ div > section[class^=\"style-\"]:has(div[id^=\"logly-lift-\"]),\ndiv[id^=\"New2HomeTrendPage-\"] > div[class] > div[class] > div[class]:has(> div#trend-side-ad:only-child),\ndiv[id^=\"PersonalArticlePage-react-component-\"] > div[data-testid^=\"popup-\"][data-testid$=\"-signup\"]",".ad-300x250",".menu > div[style=\"text-align:center;\"],\n.menu > div[style=\"text-align:center;margin:0px;padding:0px;height:190px;width:160px;\"]",".k1y-inline-ad",".plugin_right:has(> div > div.plugin-freearea > div > a[href*=\"al.dmm.co\"])","#a-banner,\n#side-banner","div[id^=\"raifu-\"]",".contents_m div[style^=\"padding-top: 15px; padding-bottom: 5px\"][style$=\"background: whitesmoke;\"]","#video_on_ads","#outline > table[border],\n#scroll.plugin2_outline:last-child,\n.ently_text > div[style^=\"border:1px\"],\ndiv[class^=\"header-ad-outer\"],\ndiv[class^=\"header-ad-outer\"] + br,\ndiv[class^=\"kijinaka-outer\"]",".main-amazon-ranking",".gigaindex .detail .arti-body.af","iframe[style=\"width:120px;height:240px;\"]",".aside-box-ad",".af_box",".random-banner","#st_custom_html_widget-7","#mainWrap > center:has(div[id^=\"div_fam8\"]),\n#mainWrap > center:has(div[id^=\"div_fam8\"]) + br,\n#side2,\n.sideWrapFrame > ul > br,\n.sideWrapFrame > ul > br + hr,\n.sideWrapFrame > ul > center a[href^=\"https://www.amazon.co.jp/\"],\n.sideWrapFrame > ul > li ~ center > a[href^=\"http://smalog.jp/\"],\n.sideWrapFrame > ul > li ~ center:has(> a[href^=\"http://smalog.jp/\"]),\n.topWrap1Frame:first-child",".kiji-ad1,\n.sidebody-r,\ndiv[style=\"height:445px;\"]",".adsense-card",".my_ads",".ad-aside-big,\n.ad-aside-small,\n.ad-contents",".c_linkto:has(> .adsbygoogle)",".sidebar-box3:first-child",".content > div[align=\"center\"],\n.l-sidebar > aside.widget_search + aside.widget_text,\n.l-sidebar > aside.widget_text:last-child",".article__body > div[id^=\"text-\"]","div[class^=\"article-body\"] > div[style=\"border-style: solid; border-width: 1px; padding: 10px 5px 10px 20px;border-color: #ffffcc; background-color: #ffffcc\"]","iframe[src^=\"//rcm-fe.amazon-adsystem.com/\"]","#aw0[on=\"tap:exit-api.exit(target='landingPage',_googClickLocation='2')\"],\n#aw0[onclick=\"ha('aw0')\"],\n#custom_html-2 div.ad300x250,\n#div-gpt-ad-entrybottom,\n#related-posts:has(> ul > amp-list),\n.ads-relatedbottom:not(.ad300x250),\n.misc > #div-gpt-ad-header,\n.widget_custom_html:not(#custom_html-2),\namp-ad,\namp-ad-exit + div[class*=\"-banner\"],\ndiv[style*=\"animation-name: sco-ads-fade-in;\"]",".blog_parts_fix_pc,\n.l-mainContent__inner > div.p-blogParts,\n.l-mainContent__inner > div[style=\"padding-bottom: 5%;\"],\n.p-blogParts.post_content > div.is-style-bg_main_thin,\n.p-blogParts.post_content > p[style=\"text-align: center;\"]:has(+ div.is-style-bg_main_thin)",".sidebar > aside.widget_custom_html",".pickup-wrap,\ndiv[class*=\"-adarea-\"]","div[class^=\"ads-\"]","#embed-bottom-iframe,\n#primary > div[style^=\"width:700px;\"],\n#recommend-bottom + div.bubble:has(> div > div.article-footer-amazon),\n.ads-336-280,\n.article-footer-amazon",".ad-wrap1",".home_top","span[style=\"font-size:10px; color:#c0c0c0\"]",".comment_ad_block","#content div[align=\"center\"]:has(> ins.adsbygoogle)",".entry-content > center > span[style=\"font-size: xx-small;\"],\n.entry-header > center > font[size=\"1\"]","#custom_html-29",".main-items > div[id*=\"static-div-gpt-ad-\"] + div[id^=\"fusion-static-enter\"] + .custom-html-feature > hr,\n.row:has(div[id^=\"div-gpt-ad-\"])",".gptAd",".article__inline-gptAd",".bigsquareadposcen,\n.c336x280adsCenter","div[class*=\"ads\"],\ndiv[style=\"text-align:center; font-size:11px;\"] > span","div[style=\"width:100%;height:90px;padding:2px 0;\"]","#custom_html-2:last-child,\n.ct,\n.infeedads","div[id^=\"satos-\"]",".set_wrapper",".set_wrapper_absolute_right","#tertiary > section.side-menu:has(> div.side-menu-title > a[href^=\"https://www.amazon.co.jp/\"]),\n#tertiary > section.side-menu:has(> div.side-menu-title > div.plugin-freearea),\n#tertiary > section.side-menu:has(> div.side-menu-title > ins.adsbygoogle)","#pc-side-nav.module--free,\ndiv[id^=\"ads_\"]",".plugin1_outline:has(> div > div.plugin-freearea > div > a[href^=\"https://www.amazon.co.jp\"])","#main > aside:has(> div.ads-flexbox)","article > div[id^=\"custom_html\"]:has(> div.textwidget > a[href^=\"https://affiliate.suruga-ya.jp/\"])",".h_section2,\n.sbboxad,\n.sbboxadmini,\n.sbboxadsp",".c-sponsorbanner","div[data-type=\"embed_code\"]:not([data-uid=\"DUtZ1VZE\"]),\nmain > article + div > div.frame,\nmain > article > div:has(> div.frame.sd.appear)","#neko_ad",".sekai-adlabel","#outline > div > a[href^=\"https://click.\"] ~ br,\n#outline > div > div.ninja-recommend-block + br + div[align=\"center\"],\n.plugin2_outline:first-child,\n.plugin2_outline:nth-child(1n+5),\ndiv[style^=\"width:1000px; height:250px\"]","#fc2contents_entry,\n#fc2live_bunner,\n.category2:last-child",".underad",".adh::before","#sidebar > aside.widget_text","#advertisement","#gads","#ad_common20 + hr,\n.ads_rect",".fc2cm-td,\n.pcolle-parts,\ndiv[id^=\"myplace-\"]","#side_right",".banner-728_90",".abemaBtn,\n.ad_double,\n.h260,\n.h_280,\n.height280,\n.w_300","#middle_adv",".media-header-banner,\n.media-middle-banner",".mmcorner",".pr-box",".ac-mt-3.bg-light","div[class^=\"insentence-adsense-\"]",".articleBottomBanner,\ndiv[data-newsy-ad-name],\np > a[href^=\"https://amzn.to\"]","#rectangle",".entryBottomBanner",".side_banner",".related",".ad3",".ad-halfwrap",".h-16.md\\:h-24.p-1,\n.h-24.md\\:h-48.p-1,\n.horizontal-list-fanza,\n.max-w-2xl.sm\\:py-12.sm\\:px-6.lg\\:max-w-7xl,\n.mt-2 > div.items-center:has(> ul.horizontal-list-tweet-detail > li > div > a[rel=\"noopener sponsored\"]),\n.mt-2 > div.max-w-2xl.sm\\:py-12.sm\\:px-6,\n.mt-2 > div.mb-3.md\\:h-24.h-16,\na[href^=\"https://al.dmm.co.jp/\"][target=\"_blank\"]",".Rectangle01",".sideBnr","#custom_html-95,\n.post_content > .has-border:has(> .adsbygoogle)",".md_singleBanner,\n.md_tripleBanner,\n.prBanner",".content-head-forms-news","#pc_all_right_1st,\n.right_ad_c,\n.towcolumnBan_area",".ad_02",".wl-ad-container","div[class^=\"ad_footer\"],\ndiv[style^=\"font-size:85%;\"]",".ad_block1000",".baseSection > aside.widget_text","#cta_box-2","#ai_widget-2","#fix,\n.side-section:first-child","div[class*=\"ads-container\"]","#ads-iframe-fixed",".header-advertising,\nstrong > [href^=\"https://bit.ly\"]",".ad_space_article","#ad-ydn","#text-53,\ndiv[id^=\"starw-\"]","#text-34","#text-35",".kiji_adsense","#text-112",".netspeedRightAd,\n.netspeedRightAd + hr,\ntd > div[style*=\"10px auto 50px;\"][style*=\"8px 10px 6px;\"]","#cm1,\n#cm2,\n#cm3,\n#sub1,\ndiv[class^=\"cm\"][class$=\"name\"]",".widget","#ad-pc-consultation,\n.main-contents + .side-bar",".comment-container + hr:has(+ script + ins.adsbygoogle),\n.sk-container > div#ngwordModal + div.text-xs-center,\n.text-xs-center[style=\"min-height: 90px;width:100%;\"]","div[class^=\"adsense-\"]",".pc-kizi-top-box","#adds",".e-wiki_middle_responsive_kk_conf","#side > div > .widget-wrap > .textwidget > .al-c > a[target=\"_blank\"] > img",".l-main > div.dividerBottom > div.dividerBottom:has(> aside.widget > div.adWidget)","div[style=\"text-align:center;height:100px;margin:10px 0\"]","div[style^=\"height: 250px; width: 100%\"]","#accordion > div.smpnovel_list:has(> div.c-ad)",".entry-content > p.h4modoki,\n.widget_st_custom_html_ad_widget",".yyi-rinker-contents + p:not([id], [class], [style]),\n.yyi-rinker-contents + p:not([id], [class], [style]) + p:not([id], [class], [style])",".rstdtl-cmad,\n.side-adbanner-wrap,\n[class^=\"ad-min-size\"]",".ad_list_bottom_large,\n.rsttop-ad",".dfp-article","#Advertisement,\ndiv[class^=\"adarea_\"]",".main > .newTemp > p:last-child:has(> .adsbygoogle)","#body + #post,\n.ads_main_btm,\n.ads_nav_top","#custom_html-52,\n.sng-box",".module--rss_affiliate",".module--category-recent-entry","div[style=\"overflow:auto;height:550px;\"]","#execphp-3",".sp_sponsor,\n.sponsor_ext","#top-editarea center a[href*=\"utm_\"] > img,\n#top-editarea center a[target=\"_blank\"],\n#under-pager-edit-area,\n.hatena-module-html > div > a[href^=\"https://affiliate.suruga-ya.jp\"][rel=\"nofollow\"]",".entry-content > div.widget_custom_html",".ad-left,\n.gm-ad__side-300",".maintop-widget","img[width=\"10\"][height=\"90\"]",".back-b,\n.box-ad-i",".home_block > div.pc.clearfix","div[class*=\"_questionBottomAdArea_\"],\ndiv[class^=\"googlePublisherTags_ads\"]","div[class^=\"ads-super-banner-\"]",".ad-dummy,\n.fixed-ad","#block-15",".ads_fix_height_pc,\n.ads_fix_height_sp",".c-ad-banner--col2,\n.c-ad-banner:not(.-continual)","#custom_html-45","div[class^=\"googlead-\"],\np[class^=\"sponsored-\"]",".footer-margin,\n.fp-player > div[style*=\"z-index:\"],\n.table","div[id^=\"ad-tool\"]",".relative.w-full > span.absolute.inset-0.bg-textGray-900,\n.tablet\\:w-\\[728px\\].tablet\\:h-\\[90px\\]",".ad_custom,\n.ad_glia,\n.ad_list_top,\n.ad_topics_custom,\n.ad_video_box,\n.promotion","#ad-overlay-box,\n#ad-right-bottom",".row_f > div[style=\"text-align:center;\"]","#meerkat-wrap",".advertisement_area","#homebnrs,\n.yadsBanner",".rigth_banner_table_ad_noline","section > div[align=\"center\"] > font[size=\"-1\"][color=\"#404040\"]","#aside","div[class*=\"style_ad_\"]",".post-list-card > div[class=\"post-list cf\"]:has(> ins.adsbygoogle)",".bnr_block",".header_message","#ar_w300px > div.mb14px","#ar_w655px",".box2:has(> p > a[href^=\"https://hb.afl.rakuten.co.jp/\"])",".footer ~ div.main a[href^=\"https://\"]:not([href*=\"twitter.com/\"]),\n.main > div[style^=\"margin:0;padding:5px;\"],\niframe[src^=\"https://image.getchu.com/api/item_af.phtml/\"]","#custom_html-38",".article div.entry-content:has(div.wc-shortcodes-row > div.wc-shortcodes-column a[href^=\"//www.pcolle.com/product/detail/\"]),\n.elogch_blogparts_iframe,\n.entry-title ~ div:has(> a[href^=\"https://wlink.golden-gateway.com\"]),\n.entry-title ~ div:has(> a[href^=\"https://www.pcolle.com/product/detail/\"]),\n.nozokix_blogparts_iframe,\nfooter div[id^=\"text-\"]:has(> .textwidget > p > a[href^=\"https://wlink.golden-gateway.com\"])",".pc-ad-wide,\n.sp-header-ad","div[data-widget_type^=\"jnews_element_ads\"]",".g-single","div[style=\"min-height: 120px; padding-top: 10px\"]",".ad-h-resp,\n.post_ads_box","img[src^=\"https://livedoor.blogimg.jp/ld_manga/imgs/\"]","a[href^=\"https://hb.afl.rakuten.co.jp/\"]",".l-main .textwidget > a[href^=\"https://slim-base.com/\"] > img,\n.l-main .textwidget > a[href^=\"https://slim-base.com/\"] ~ br",".sidebar_content > div[id^=\"custom_html-\"]",".pickup-header,\na[href^=\"https://mauvecyan.com\"]","#custom_html-60","#left_fix_out #left_box3,\n#right_2nd > .right_box2","#main > div[class*=\"_div_center_w\"]","div[style=\"height:250px; width:300px;\"]",".ads-reserve-area,\n.interrupt:has(> .free-space)",".__isboostSideSlideShow,\niframe[id^=\"adpost_\"]",".aicp","#RECT,\n.p-top__ad,\n.p-under__kv",".entry-content > div:not([class]) + div:not([class]):has(div > a[href^=\"https://t.afi-b.com\"])","body > br + a","div[id^=\"common_ad\"]","#st_custom_html_widget-2",".bl_adunit,\n.pg_section_ads_double",".gallery__interstitial,\ndiv[class=\"koukoku overlay\"],\ndiv[class^=\"back-ad_\"]","div[class^=\"overlay-ad_\"]","#main-block > .grid > div[class^=\"grid-cell\"]:has(iframe[src*=\"/ad-d/\"]),\n#pickup-block > .grid:has(iframe[src*=\"/ad-d/\"])","#left-box > br,\n.entry-body > div[style=\"margin:0;padding:5px;font-size:12px;word-break: break-all;\"],\n.relate_dl ~ h3.midashi,\n.side-body:has(> div.plugin-freearea > div[id^=\"im-\"]),\n.side-title:has(+ .side-body > div.plugin-freearea > div[id^=\"im-\"])",".h2_bnr,\nsection[id^=\"xeory_banner_manager-\"]",".entry-content > div[align=\"center\"]",".double-rect-ads-group",".ad-area-a,\n.ad-area-b:has(> div.text-center > div[id^=\"div-gpt-\"]),\n.ad-area-c,\n.ad-area-popin,\n.main > .row.d-none[style^=\"min-height:\"],\nbody .ad-billboard,\nbody div#pc-gpt-overlay-wrap,\ndiv[class^=\"col-\"] > div#videoContent:has(> div#playerFrame > div#adContainer)","#footer_banner","#kashi_adunit_above,\n.kashi_banner2","body > div[style^=\"width:300px\"] > div[style=\"margin:15px auto 0 auto; font-size:11px;line-height:1.5;text-align:left;\"],\nbody > div[style^=\"width:300px\"] > table[style^=\"margin:0;\"]","#sidebar_follow_ad_area,\n.MediumRectangleBanner,\n.billboardBanner,\n.list__item[style=\"min-height: 120px\"],\n.lowerContents > div[style=\"text-align: center; height: 50px;\"],\n.recommendAdTag,\n.tonefuse_music_ad_area,\ndiv[style=\"text-align: center; min-height: 100px; margin-top: 15px\"],\ntbody > tr:has(> td > aside.sideBySideBanner)",".topBanner","a[href^=\"https://www.cuddle-jp.com/\"][target=\"_blank\"],\ndiv[class^=\"article-body\"] > div > b > span[style=\"color: rgb(255, 0, 0);\"],\ndiv[class^=\"article-body\"] > div > p[style=\"text-align: center;\"]","#HTML4,\n#after-ad,\n#sidebar > .widget#HTML3",".ad_pc",".bd_bd > div[style*=\"clear:both;border-top: 1px solid #999999\"],\ndiv[id^=\"banner-text-\"],\ndiv[style$=\"padding-top:10px;margin-top:10px;clear:both;border-top: 1px solid #999999\"],\ndiv[style=\"width:590px;height:90px;margin-left:7px\"]","#right2","a[href*=\"https://al.dmm.co\"],\na[href*=\"https://www.bybit.com/jpwelcome/\"]",".ad300row",".adsw","#single_banner_area,\nli[class=\"type1\"],\nli[class=\"type2 border_radius\"]","#top-container-widget,\n.single_ads",".blank_box",".elementor-widget-flat-posts + section.elementor-section.itigyotext","#diver_widget_pcsp-13",".ad-bottom-main,\ndiv[id^=\"single_banner\"] + div[align=\"center\"]",".layout_right > .entry_text:has(#ninja-blog-inactive) + .entry_footer",".m-prbnr,\n.m-prlist,\n.p-heading__ttl--pr,\ndiv[id$=\"_gam\"]",".side__ads",".article-outer .article-outer-3 > div[align=\"LEFT\"]","#sidemenu_widget-2 ~ .widget_st_custom_html_widget.ad","#diver_widget_pcsp-43,\n#diver_widget_pcsp-44","#execphp-15",".bodyFootBanner,\n.fullBanner",".gmoam_outer_wrapper",".adnet",".l-mainContent__inner > div.post_content > div.swell-block-capbox.is-style-shadow[data-colset],\n.l-mainContent__inner > div.post_content > div.swell-block-capbox.is-style-shadow[data-colset] + div.swell-block-capbox[data-colset],\n.w-fixSide","#set_banner_side_left,\n#set_banner_side_right,\ndiv[class=\"\"][style^=\"display:block; color:; background-color:\"]","div[class^=\"post-ad\"]",".podcast + aside,\na[href^=\"/ads/\"]","[class^=\"ad-\"]","#headlinkad,\n.sponsored_link",".ads_bygoogle",".common-footer-content > div.inner-content",".advertisement","div[id^=\"adblank\"]","#banner_t",".rightcolumn > tbody > tr[style^=\"width:\"]:not([class]):has(> td[style^=\"height:260px\"])",".amatable_wrap,\n.boxright,\n.logbox td > div:first-child,\n.menu1BlockBase:first-child,\n.more_ads,\ntr[align=\"left\"] > td[style^=\"font-size: 12px\"][align=\"left\"]",".banner_premwindow,\n.banner_superprem,\n.column_pin.mobile_width100 > div > a:not([href^=\"https://world-tt.com\"])","div[class^=\"afad_\"]","div[style=\"height: 700px;\"]",".sp-infeed-ad,\n.wwd-ad-manager-widget-feature-feed,\n.wwdj-ad",".adsense-placeholder","div[id^=\"space\"]",".infeed-ads","#custom_html-4 p + .soft-info-title","#appeal","#text-39","#text-79","#text-91","#custom_post_widget-11",".l-sidebar > aside[class=\"widget\"]:has(> div.execphpwidget a[href^=\"https://www.sokmil.com/\"][href*=\"affi=\"])",".post_content > div > div.is-style-border_sm:has(> div.is-style-dent_box > p > a[href^=\"https://network.mobile.rakuten.co.jp/campaign/\"]),\n.post_content > div.is-style-bg_stripe:has(> center > p > a[href*=\"valuecommerce.com\"]),\ndiv[style=\"width:100%;margin:0 auto;\"]","#container > div.widget-container.top,\n#widget-container-bottom","#twibox > ul > li:has(> div.textwidget script),\n.kizi > p:last-of-type:has(> a[href][target=\"_blank\"] > img.timtam)",".posts-under-1",".gs_ad","#excitebnr,\n#st_custom_html_widget-4,\n#st_custom_html_widget-5,\n.entry-content > p[style^=\"font-size\"][style$=\"center;\"]","#index_banner_top,\n#side_top_banner",".p-dmmad",".header_link[href^=\"https://go.bbrdbr.com\"]",".side_top_ad","#contents-colum-resp-ad,\n.box-pr,\n.box-pr + h2,\n.box-pr + h2 + h4,\n.box-pr + h2 + h4 + .table-item,\n.box-pr + h2 + h4 + .table-item + p,\n.box-pr + h2 + h4 + .table-item + p + p,\n.box-pr + h4,\n.box-pr + h4 + .table-item,\n.box-pr + h4 + .table-item + p,\n.box-pr + h4 + .table-item + p + p","#movie_ad","#ad01,\n#extarea,\n#record_detail > div.block[style=\"padding:15px 0;\"],\n#sidebar_right > div.mb20.pb20.pt20[style=\"clear:both;\"],\n.ad_area,\n.all > div.innner > div.block:last-child:has(> div#extarea),\n.modal-backdrop","#mytextwidget-33,\n#mytextwidget-36,\n#mytextwidget-37,\n#single_content_sidebar,\n.my_widget_text:first-child,\n.my_widget_text:last-child,\ndl[id^=\"mytextwidget-\"].corner:has(a[href^=\"https://rcv.ixd.dmm.com/api/surl\"])",".article > div[style=\"margin:0;padding:5px;font-size:12px;word-break: break-all;\"]:has(> a[href^=\"https://al.dmm.co.jp\"])",".under-entry-content > div.widget_custom_html.widget_text,\n.widget:has(> div.textwidget > table > tbody > tr > td > script[src^=\"https://effulgent-stroopwafel-efb9ce.netlify.app/\"]),\ndiv[style=\"margin:0;padding:5px;font-size:12px;word-break: break-all;\"]","#text-54",".hentry > div.center","div[style] > a[target=\"_break\"] > img",".wp-block-cocoon-blocks-blank-box-1.has-light-blue-border-color:has(> div > div.amazon-item-box)",".yosem-adlabel","#custom_html-26","#ai_widget-38,\n#ai_widget-43",".widget_text:first-child","#header-main > div.ad",".blog-sidebar:nth-child(2),\n.blog-sidebar:nth-child(4) > div.card:not(.sticky),\n.dmm_api_ad_2,\n.pagenav + div.row,\n.sticky > span:not([class]),\n.t_b > div > a[href^=\"https://al.dmm.co.jp\"],\n.x-scroll-wrap:has(> div.videoa)","#extra > div.column-inner > div.column-inner-2 > table[style$=\"width:170px;\"],\n#sub table[style=\" border:1px solid #ccc; width:170px;\"],\n.plugin-memo:has(> div.side > a[href^=\"https://www.ka-nabell.com\"]),\n.plugin-memo:has(> div.side > div#ad-fixed),\n.plugin-memo:has(> div.side > table a[href^=\"https://px.a8.net\"]),\na[href^=\"https://www.ka-nabell.com/\"]","#extra div.plugin-memo:last-of-type","#custom_html-36","#reblock_widget-4,\n.ct-code-block > a[rel$=\"sponsored\"]","#block-101,\n#block-106 ~ div.widget_block.fix_sidebar:has(> center > a),\n#block-93,\n.diver_widget_adarea","#float_left,\n.article-bottom",".amazon-table,\n.sidetop_ad","#info5 + div#info9,\n#info9:first-child,\nbody > hr[size=\"1\"] + center:has(> a[href^=\"https://ac.cross-system.com\"] + br + br + table[width=\"95%\"][cellpadding=\"0\"][bgcolor=\"purple\"]),\npr,\ntable[cellpadding=\"6\"] > tbody > tr > td[bgcolor=\"#000000\"][align=\"center\"],\ntd > font[size=\"4\"] + div#info9","#st_custom_html_widget-36","span[style=\"font-size:11px;\"]","#article_bottom_ad,\n#article_center_ad,\n.article-body-inner dl > dd > a[href^=\"https://al.dmm.co.jp\"][rel=\"nofollow\"][target=\"_blank\"],\n.article-body-inner dl > dd > b[style=\"color: rgb(255, 0, 0);\"],\n.article-body-inner dl > dd > span[style$=\"color: rgb(255, 0, 0);\"]",".ad-bnr-rect",".adContainer--double","div[class^=\"last_page_adsense\"]","#right","#goomid,\n#shop td,\n.tuhantitle","div[class^=\"style-module--ads--\"]",".body-content > div[style=\"margin: 0 0 15px 0; padding: 5px; font-size: 12px; word-break: break-all;\"] ~ p:has(> a.btn-user-submit[target=\"_blank\"]),\n.content-bottom-sidebar-wrap,\n.content-top-sidebar-wrap,\n.zozov-dmm1","#footer_sponsored,\n.internal_sponsored,\n.sidebar_sponsored","#js-overlay","#meows > p[style=\"text-align: center;\"]","#koteiwaku","td[style=\"width:310px;vertical-align:top;\"]",".ad__dbl-rectangle--box,\n.largeskyscraperBnrBox",".widget-below-comment-form:not(.widget_new_entries)",".pc_ad",".c-modal-light-score__ad-frame",".entry-adsense","#cls-improvement,\n.post > div[class^=\"ast-post\"] > header.entry-header > div[style=\"text-align: center;\"]",".ad4",".movie-Ad_01",".mb20[style=\"color:#999999; text-align:right;\"],\ndiv[style=\"margin-top:15px; padding:5px 0px; text-align:center; font-size:10px; border-top: 1px dashed gray;\"]","div[class*=\"-ads-\"]",".BottomFixedBannerContainer","div[class^=\"fluct-unit\"]",".manual_ads,\n.widget_custom_html.widget-main","#popup",".header.clearfix",".plugin-memo:has(> div.side > center > a[href^=\"https://www.amazon.co.jp\"])","#lcBox > div#centerBox > center:last-child,\n.pcbanner,\n.textbanner","#lcBox > div#centerBox > div.contentfree:has(> div.siteshokai),\n#lcBox > div#centerBox > h2:has(+ div.contentfree > div.siteshokai)","#lcBox > div#centerBox > h2:has(+ div.wf)","#lcBox > div#centerBox > div.contentfree2,\n#lcBox > div#centerBox > h2:has(+ div.contentfree2)","#execphp-39,\n#execphp-40",".amra","#widget-under-article","#leftbar-inner > a[href=\"http://www.eorzean.info/archives/3415373.html\"] + br + div ~ div,\n#leftbar-inner > a[href=\"http://www.eorzean.info/archives/3415373.html\"] ~ a,\n#leftbar-inner > a[href=\"http://www.eorzean.info/archives/3415373.html\"] ~ img,\n#sidebar-inner > div > a[href^=\"http://amazon.co.jp\"]",".add-control","#relatedAd","#main > div[style^=\"margin:\"][style*=\"20px\"]:has(> ins.adsbygoogle),\n.res,\nmain > div[style=\"margin:15px 5px;\"]:has(> ins.adsbygoogle)",".toshoadv","#widgets-wrap-sidebar > section.widget_text","#sidebar-widget > .widget_pc_text:first-child,\n.sousyoku","#sidetop_ad_pc,\n.Infeed,\n.ad_m,\ndiv[id^=\"hamac-\"]",".ads_header_under,\ndiv.aside_box[style=\"height: 600px;\"]",".job_ads","#\\30 0,\n#more > p:has(> span[style=\"font-size:150%;\"]),\n.amazon_item",".right-container > div.plugin-memo:last-child",".ad_data,\ncenter[style=\"min-height:60px;\"]","#carousel-banner,\n.main-box > div[align=\"center\"] > a[target=\"_blank\"] > img,\na[href=\"http://adulttoys.jp/info/\"][target=\"_blank\"]",".sidespesce > div > div[style^=\"margin:15px auto; width:300px; background-color:\"]","#headrank2:first-child,\nifarticlebodymore > div[align=\"center\"] > table",".menubox:first-child",".adad2",".ads_relation_title,\n.content_bottom_ads,\n.top_bottom_ads_relation_title,\n.top_bottom_contents_box_3","div[class^=\"ad_responsive_\"]","div[id^=\"sp_cont_\"]","#content > a[href^=\"https://amzn.to\"],\n#content > a[href^=\"https://www.amazon.co.jp\"]",".entry_footer_ads,\n.mybox-right-narrow,\ndiv[style=\"min-height: 325px;\"]","div[class^=\"ad-box-\"] > center",".card02,\n.no-icon[rel=\"nofollow\"]","#center_column > .left_column:has(> div.tieup_rand_block),\n#tieup_rand,\n#view_center_ad,\na[ad_id]","#footer-banner","#header_banner_wrapper,\n#side_right_banner,\n#tieup_banner,\n.view_top_banner","div[style^=\"width:680px;\"]",".ads-fluid",".delete-msg,\n.fanza-actress,\n.pickup-box1",".dfad:has(> ins.adsbygoogle)",".osusume-info,\n.osusume-info-header","div[id^=\"adArea\"]","[style=\"position:fixed;width:100%;top:0;z-index:-999;text-align:center;\"] ~ [style] > table > tbody > tr > td > a[href^=\"https://amzn.to\"]",".pull-right.pr",".box_s,\n.boxp,\ntable[width=\"180\"]:nth-last-of-type(-1n+2)",".adsbygoogle[data-ad-client],\n.ichioshi_no","#content > .entry_under_ads,\n#content > .entry_under_fb,\n#primary > div.half:has(> .ads),\n.widget_execphp:has(> div > ins.adsbygoogle),\naside:has(> ins.adsbygoogle)","#custom_html-110,\n.code-block-3 font[size=\"-1\"],\n.code-block:not(.code-block-3)","div[id^=\"ad-\"]","#main > div.freespace","#Left_AD,\n[class^=\"AD_\"]","#text-56,\n#text-63,\n#text-64,\n#text-65",".ads-related",".gadlink",".p-adsense-anchor",".mainbox > p[style=\"margin-bottom:0px;font-weight:bold;\"],\n.toprespon,\n.topsad",".cm-banner",".adnex",".ga","div[align=\"right\"] > a[href^=\"http://hb.afl.rakuten.co.jp/hsc/\"]","div[class][style*=\" \"] div[class]:not([style]) ~ div[class] a[href^=\"https://go.misskey.io/\"] > img[class]:not([src]) ~ button",".article-outer-3 > div[style^=\"clear:both;margin-top:0px;\"]","div[style^=\"width:610px; height:260px\"]","span[style=\"font-size:10px;color:#aaa;display:block;text-align:right;padding-right:5%;\"]","#sidebar-right > p.amazon,\ndiv[align=\"center\"] > center > table[border=\"1\"]:has(> tbody > tr > td > p > iframe[src^=\"http://rcm-jp.amazon.co.jp\"])",".aaso","main > section > div:has(> div.ad-container)",".single-bottom-ad","div[class^=\"sideads\"]","div[class^=\"yms-2ad-\"]",".plugin-l-t,\n.right-container > div.plugin-rss","font[color=\"#777\"] > font[size=\"1\"]","#sub > div.column-inner > div.column-inner-2 > div.plugin-memo:last-of-type,\n#sub > div.column-inner > div.column-inner-2 > div.plugin-memo:nth-child(-1n+2),\n.article-body-inner > table[width=\"750\"][height=\"320\"],\n.kjs,\n.pr-4,\ntable[height=\"300\"][width=\"750\"]","#oryourisokuho > div[align=\"center\"],\n#oryourisokuho > div[align=\"center\"] + hr","#topads,\n#topmadoka","#gn_overlay_wrapper",".left-container > div.plugin-memo:last-of-type","#bottom_banner_wrap",".pr_area",".billbord-js,\ndiv[id^=\"left_ad_\"],\ndiv[id^=\"right_ad_\"]",".u_adBox,\n.u_adFloatingBox",".matomelabel,\n.socialandbanner,\n.threadadvpc,\ndiv[class^=\"advertise_\"]",".entry-content > center > b,\n.entry-content > center > strong,\n.is-style-yellow_box:has(> div.cboxcomment > center > a[rel=\"nofollow\"])","#page_bottom_fixed","#container > div#footer:has(> div > ins.adsbygoogle),\n#main > div.frame:has(> script[src^=\"//go.trvdp.com/\"]),\n#main > div.frame:last-child:has(> #ad_area)",".overlay-item,\n.overlay-mask,\n.regular-banner,\n.ui-main-body > div.large-banner","#adbottom_box,\n.relatedarea,\n.relatedlabel","#adcenter_box,\n#adtoplabel",".bfb_textBtnTextBtn","#aeriaGamesCenterAd,\n#zumba-ad","iframe[style=\"width:300px;height:250px;border:none;vertical-align:bottom;\"]","#floating-banner","#sadfloat","#tmp_publicity","#sadbg","#sad",".bana",".top_kokoku_wp","a[class^=\"ad_\"],\nimg[alt^=\"(広告)\"]","#kokoku-area",".top_kokoku_box","#\\30 2.exclude-h2-cnt,\n#adpcheader,\n.PRrank-icon2,\n.ad_random_tag,\n.adsInterstitial-modal,\n.ads_position_left_kouryaku_under,\n.all-center:has(> tbody > tr > td > a[href^=\"https://t.quoriza.net\"] > img),\n.article > h2:has(+ p > a[href*=\"/?code=\"] > img),\n.article > p:has(> a[href*=\"/?code=\"] > img),\n.article > p:has(> a[href*=\"/?code=\"] > img) + p,\n.article > table.tableLine:has(> tbody > tr > td > a[href*=\"/?code=\"] > img),\n.cta-link-box02,\n.cta-link-box02 + h3,\n.cta-link-box02 + h3 + table.tableLine,\n.joubu-rank02,\n.overlay_wrapper,\n.overrayBox_01",".new_koukokuwaku_wrapper",".big-footer-topics__google-ad,\ndiv[class^=\"MainAdModule\"]",".ad-btf",".block-asp",".p-article__item--ad","div[class^=\"AdGoogle_\"],\ndiv[class^=\"SpAd\"]",".panel-pr-block-side","#app > div[class^=\"_\"] > div[class^=\"_\"] > div[class^=\"_\"] > div[class^=\"_\"] > div[class^=\"_\"]:has(+ div[id^=\"div-gpt-\"]:empty),\n#entryBody > div.pickCreative_root,\n#entryBody > div.pickCreative_root + p,\n#entryBody > div:last-of-type > p:empty + div.pickCreative_root[style=\"font-size:0\"],\n#entryBody > div:not([class]):empty ~ div:not([class]) > .pickCreative_root,\n#entryBody > div:not([class]):last-child > div.pickCreative_root,\n#entryBody > div:not([class]):last-child > div:not([class]):last-child > div.pickCreative_root,\n#entryBody > div:not([class]):last-child > div:not([class]):last-child > table[border=\"0\"] div.pickCreative_root,\n#entryBody > div[contenteditable=\"false\"] > table[style][width=\"100%\"] a[alt0=\"BlogAffiliate\"],\n#entryBody > div[style^=\"margin:10px 5px;padding:15px;word-break:break-all;color:#333;box-shadow:1px 1px 2px rgba(0,0,100,0.3);background:url\"]:last-child:has(> div[style=\"background:rgba(255,255,255,0.85);padding:5px;border-radius:1px;\"] > div[style=\"border:4px double #cbb994;border-radius:1px;padding:10px\"] > div.pickCreative_root),\n#entryBody > p > a.pickLayout6[data-img-url^=\"https://img.mobadme.jp\"],\n#entryBody [style=\"text-align: center;\"] > a.pickLayout6 > img.pickLayout6_img,\n#entryLi > li[class^=\"_\"]:has(> div.skinBorderBottomColor > div),\n#freespace a[href^=\"https://www.amazon.co.\"][rel=\"nofollow\"],\n#subAInner > div#freespace a.pickLayout6 > img.pickLayout6_img,\n.freespaceArea:has(> a[href^=\"//ck.jp\"][rel=\"nofollow\"]),\n.myPick_block,\n.natural08_block,\n.pickTag,\n.skin-entryAd,\naside[data-amb-auto-ad-style],\ndiv[class^=\"_\"][style=\"min-width: 300px; min-height: 250px;\"],\ndiv[class^=\"in-article-injected-ad-\"],\ndiv[data-slot=\"injected\"][style^=\"min-height: 2\"],\ndiv[style^=\"max-height: 250px\"][style*=\"justify-content: center;\"],\nfooter + div[class^=\"_\"][aria-hidden]",".ad-banner:not([data-name=\"single-2-soken\"])",".l-animeDetailSbMovieBanner","#ad_block_center,\n.side_ad__inner",".cynergi-widget","#pb_hidden","div[style*=\"min-height:280px\"]",".tgad",".adsp","#gowp-native",".gg-bottom",".ad-bnr-words",".adsbygoogle_area,\n.jack-content,\n.special_newarticle_list > li:has(> div.adsbygoogle_area)",".bnr-inarticle,\n.bnr-related,\n.brn-small,\n.gtm-pickup_amazon,\n.topics-ad-area",".ad-u","a[href^=\"http://www.amazon.\"][href*=\"/obidos/ASIN/\"],\na[href^=\"https://www.amazon.co.jp/exec/obidos/\"][target=\"_blank\"],\ndiv[style=\"max-height:250px;margin-bottom:10px;\"]","#ad_left_box,\n.ad_pop_new,\n.inste_popup,\n.sp_ad_next_menu,\ndiv[id^=\"ad_jack\"]",".p-ads-top-rec1,\n.sidebar-ad01,\n.sidebar-ad02","#ad_footer_space,\n.ad_header_frame","#imgUpperRectangle,\n#topbillboard,\n.contentWrapper aside.banner",".asajo-choice-area,\n.post > div[style=\"margin-bottom:20px; padding: 10px 0; border-top: 1px dashed #ccc; border-bottom: 1px dashed #ccc;\"]","#artAds,\n#sideR > .ban,\n#sitejack,\n.banR:first-of-type,\n.pickwrap,\nsection[class^=\"posts--\"] > .posts__row:has(script[src^=\"//i.socdm.com\"])","aside[id^=\"ad_\"]","div[class^=\"sw-AdNetWork\"]",".ad336_280","#google_relate_ads,\n.atwiki-ads-margin","#body_footer:has(> a[href^=\"https://www.amazon.co.jp/\"] > img),\n#imobile_adspotdiv2,\n#menubar > a[href^=\"https://amzn.to\"][rel=\"nofollow\"],\n#menubar > a[href^=\"https://px.a8.net/svt/ejp\"][rel=\"nofollow\"],\n#menubar > div:not([class]) > a[href^=\"https://amzn.to\"] > picture,\n#menubar > div:not([class]) > a[href^=\"https://hb.afl.rakuten.co.jp/hsc/\"] > img.atwiki_plugin_image,\n#menubar > div:not([class]) > a[href^=\"https://www.amazon.co.jp/dp/\"][rel=\"nofollow sponsored\"],\n#menubar > span[style=\"font-weight: bold;\"] > a[href^=\"https://amzn.to\"][rel=\"nofollow\"],\n#wikibody > h3[id^=\"id_\"] + br + hr,\n#wikibody > table.atwiki_plugin_region ~ div:not([class]) > a[href^=\"https://www.amazon.co.jp/dp/\"][rel=\"nofollow sponsored\"],\n.amaquick-box,\n.atwiki-ads,\n.menu[id^=\"menubar\"] > div.center_plugin > div > a[href=\"https://amzn.to/3SdGVLR\"][target=\"_blank\"],\n.menu[id^=\"menubar\"] > div.center_plugin > div > a[href^=\"http://www.amazon.co.jp/exec/\"][target=\"_blank\"],\n.menu[id^=\"menubar\"] > div.center_plugin > div > a[href^=\"https://hb.afl.rakuten.co.jp/hsc/\"][target=\"_blank\"],\n.menu[id^=\"menubar\"] > div[style=\"text-align: center;\"] > a[href^=\"http://www.amazon.co.jp/exec/\"][target=\"_blank\"],\n.plugin_include > div > span[style=\"font-weight: bold;\"] ~ a[href^=\"http://www.amazon.co.jp/exec/\"][target=\"_blank\"],\n.plugin_include > div > span[style=\"font-weight: bold;\"] ~ a[href^=\"http://www.amazon.co.jp/exec/\"][target=\"_blank\"] + br,\n.plugin_include > div > span[style=\"font-weight: bold;\"] ~ div > a[href^=\"http://www.amazon.co.jp/exec/\"][target=\"_blank\"],\n.plugin_include > div > span[style=\"font-weight: bold;\"]:has(+ br + div > a[href^=\"http://www.amazon.co.jp/exec/\"][target=\"_blank\"]),\niframe[width=\"728px\"][height=\"90px\"]","#asideBnr01,\n.min-h-01","div[class*=\"_ad_\"]",".pure-ad-banner,\n.side-col:first-child:has(> div.dfp-wrapper)",".side__ad-box","li[class*=\"--ad\"]",".js-legacy-infeed",".carousel-banner-top,\n.news__item--ad",".sidemenu__ad,\n.sidemenu__rect-ad",".fourm_video","#jp_mota_pc_all_right_1st,\n#jp_mota_pc_catalog_right_1st,\n#pc_autocone_glonavi[style=\"min-height: 250px;\"],\n.ad-rectangle__row,\n.ad_bigbanner","#text-44,\n.wp-block-column","#text-41","#text-43","#ads-pc-top-super,\n.related-list > .sp-show","div[class^=\"autom-\"]",".pr_posts","#sp,\n.center-xs:has(> div[id^=\"JP_BABY_resp\"]),\n.gutter-around.center-xs:has(div[id^=\"JP_\"])","#entryPrBox,\n#tertiary > aside.widget_text:has(> div > a[target=\"_blank\"]),\n.entry-content > table[width=\"100%\"]","#prBox","#sidebar-inner > a[href*=\"http://www.agoda.com\"],\n#sidebar-inner > a[href^=\"https://amzn.to\"],\n#sidebar-inner > table,\n.article-body-inner > a[href^=\"https://al.dmm.co.jp\"],\n.article-body-inner > div[style=\"margin:0;padding:5px;font-size:14px;word-break: break-all;\"]","div[id^=\"cf_async_\"]","#omc-full-article > div[style^=\"padding: 10px;\"][style*=\"border: 5px double #333333;\"],\n.pc_adv,\n.post-adv-text",".bnr-box,\n.kakomi",".ad-middle,\n.free-html,\ndiv[style=\"text-align: center; margin:30px 0 30px 0;\"]","div[style=\"min-height:280px;height: auto\"]","div[id^=\"top-adspace\"]",".pattern-box",".inc-ad-info",".KJS_KIJISHITA_PC_WRAP",".article__bnr,\n.pc_CLS_90,\ndiv[class*=\"CLS_250\"]","div[style^=\"width: 624px; margin-bottom: 20px; height: 270px;\"]",".ad-large-big",".left.box300","#detail > section.article-middle:has(> .box-wrap > .box-left > div[id^=\"div-gpt-\"])","#eyeCatch,\n.prTxt","#relationEntry > div[style=\"min-height: 100px;\"],\n.entryBody > div[style$=\"min-height:280px;\"],\n.module[style=\"min-height: 600px;\"]","#adEntryMainBottom","#ad2","#bizSPA_PC_all_header,\n#innerAdsense,\n.page-ad-wrap","#sub > div.column-inner > div.column-inner-2 > center > div[style=\"margin:0;padding:5px;font-size:12px;word-break: break-all;\"] > a[href^=\"http://www.dmm.co\"][style=\"display:block;text-align:center;\"],\n.advArea,\n.plugin-memo:has(> div.side > script[src^=\"https://js.ad-optima.com\"]),\niframe[style^=\"width: 300px; height: 250px;\"]",".plugin-memo:has(> div.side > a[href^=\"https://hb.afl.rakuten.co.jp\"][target=\"_blank\"])",".has-text-align-center.u-mb-ctrl > span.u-fz-s","a[href^=\"https://damaya.shop/products/\"],\na[href^=\"https://hoshimichishop.com/\"],\na[href^=\"https://j.vape.blue/a.cgi\"],\na[href^=\"https://xn--tckxa5c423yemxd.shop\"]",".article-body-inner div[style=\"margin:0;padding:5px;font-size:12px;word-break: break-all;\"]",".relate_banner","div[style^=\"top:0px;position:fixed;z-index:0;left:50%;\"]","#more > div[align=\"center\"] > a[href*=\"px.a8.net/svt/ejp?\"],\n#more > div[align=\"center\"] > span[style=\"font-size: 81.25%;\"],\n#more > div[style=\"font-size: 150%;\"] > b",".ad_topress","a[href^=\"https://www.amazon.co.jp/gp/product/\"]",".left-column-inner > div.plugin-popular_articles_with_image + div.plugin-memo:last-child,\n.right-column-inner > div.plugin-categorize + div.plugin-memo:last-child",".amazon ~ br[style=\"clear:left\"]",".main-column-inner > div[style*=\"height:400px\"]",".l-sidebar-b > div.plugin-memo:last-of-type,\n.latest-banner",".plugin-memo:has(> div.side > script[src^=\"https://js.ad-optima.com/\"])",".article-body-inner > div:last-child > div:has(> a[href^=\"https://ck.jp.ap.valuecommerce.com/\"]),\n.userDefTextLink[href^=\"https://ck.jp.ap.valuecommerce.com/servlet/referral\"][rel=\"nofollow\"]","#more > b:has(> a[href^=\"https://www.amazon.co.jp/\"]),\n#more > div.t_b:has(> div.ninja-recommend-block)",".main-column-inner > br","img[src^=\"https://www19.a8.net/\"]","#Amazon_rdm","#lite_link","#article-1003","a[title*=\"_300x250_\"]","#container > table,\n.article-body-more > a[href*=\"dmm.co.jp/\"],\n.article-body-more > a[href*=\"dmm.co.jp/\"] + br,\n.article-body-more > a[href*=\"dmm.co.jp/\"] + br + br","iframe[src=\"http://hanshintigers1.blog.jp/rss.html\"]","#more > span[style=\"color: rgb(255, 0, 0);\"],\n#more > span[style=\"color: rgb(255, 0, 0);\"]:last-of-type ~ br,\n.article-body ~ hr[style$=\"width: 100%;\"],\n.article-body-inner > a[href^=\"https://www.amazon.co.jp/gp/\"]",".article-body-inner > script[src^=\"//img-c.net\"] + div,\n.article-body-inner > table[cellspacing=\"15\"] + table:last-of-type,\n.main-container > table + br,\n.main-container > table + br + br,\n.right-container-ads","a[href^=\"https://amzn.to\"]",".Default.amazon",".plugin-memo:has(> div.side > center > a[href*=\"://amzn.to\"])",".google-user-ad-over + div[style^=\"width:\"]",".left-container-ads,\n.left-container-ads + table[width=\"300\"],\n.main-container table[style=\"border-style: none;\"]","#more > div[align=\"center\"]:has(> table table a[rel*=\"sponsored\"]),\n.page-article-side > div.plugin-memo:first-child,\n.page-article-side > div.plugin-popular_articles_with_image + div.plugin-memo",".adnw-2ad","#category-icons","div[class^=\"article-body\"] > div > div[style^=\"display: flex; flex-direction: column; align-items: center\"]:has(> a[href^=\"https://www.amazon.co.jp\"])","#extra div.plugin-memo:last-child",".article-body-inner > table[height=\"250\"]","#more > table[border=\"0\"] + br,\n.article-body-more > table:has(> tbody > tr > td > div[style] > a[href^=\"https://hb.afl.rakuten.co.jp/\"]),\n.plugin-memo:has(> div.side > table a[href^=\"https://hb.afl.rakuten.co.jp\"])","#more > div.t_b ~ a[target=\"_blank\"],\n.article-body > div[style=\"margin-bottom: 10px\"][align=\"center\"]",".plugin-memo:has(> .side > .dmm_ranking)","div[class^=\"article-body\"] > div[align=\"center\"] > table[border=\"0\"]",".article-body-inner > center,\n.blog_ad2,\n.left-column-inner > div.plugin-categorize + div.plugin-memo,\ndiv[align=\"center\"] > span[style=\"color: #FF0000;\"]",".left-column-inner > div.plugin-memo:last-child",".article-body-more > a[target][href*=\"amazon.co.jp\"],\n.article-body-more div:has(> a[target=\"_blank\"][href^=\"https://www.amazon.co.jp/dp/\"])",".left-column-inner > div.plugin-rakuten + div.plugin-memo,\n.right-column-inner > .plugin-recent_comments + div.plugin-memo",".article-body-inner div[style=\"margin-bottom:5px; margin-left:115px\"],\n.article-body-inner div[style=\"text-align: center; padding-top:0px\"],\ndiv[style^=\"text-align: center; margin-bottom\"],\ndiv[style^=\"text-align: center; margin-bottom\"] + center",".first-article > table,\ntable[summary=\"DLsite\"]","a[href^=\"https://www.dlsite.com/\"]",".article-body-inner > div[style=\"text-align: center;\"] ~ center,\n.article-option > section#comments + div[style=\"text-align:center;\"]","#extra div.plugin-memo:not(.plugin-memo:last-of-type),\n#sub div.plugin-memo:not(.plugin-memo:nth-child(2)),\n.article-body-more > div.amazon > div.pictBox",".plugin-memo:has(> div.side > a[href*=\"www.dlsite\"])",".plugin-memo:has(> div.side > a[href*=\"dmm.co\"]:not([href*=\"/mono/dvd/\"]))",".main-column-inner > a[href^=\"https://www.dlsite\"],\n.main-column-inner > div[style] > div[align=\"center\"] > a[target=\"_blank\"]",".sidebar_top_pr","#footer_ban","div[class*=\"-adsense\"]","div[id^=\"jp_ir_\"][style]","#secondary > aside.widget_text:not(#twitterLine),\n.amLink,\n.prePaidBanner,\n.rkLink,\n.widget_sell_entry:has(> div.showCF > div#showRank)",".c-widget-adbanner-frame",".story_box:first-child:has(> tbody > tr > td[valign=\"middle\"])",".banner-pc_right_1st,\n.banner-pc_right_2nd,\n.wrapper > div.full-width.banner-box",".module-recommend,\ndiv[style=\"margin-bottom:20px; width:728px;\"]","div[style^=\"width:728px; min-height:90px;\"]",".ad_billboard_inner,\n.side_ad_add,\narticle > div:not([class]):has(> p[align=\"center\"] > ins.adsbygoogle)","#bi-recommendedBottom-cxense,\n.f-content-secondary > div[style^=\"margin-top:1em\"],\n.f-content-secondary > style + div",".c-infoBar,\ndiv[id^=\"fourm_video_\"]","#thirdary > div.widget-block:has(> div[id^=\"div-gpt-ad\"]),\n.grid-crectangle","#extra div.plugin-memo > div.plugin-memo","div[id^=\"dfp-\"]",".p-entry__body > table[style=\"border:none;\"],\n.pc-overlay-ad","div[id^=\"div-gpt-ad-\"]",".p-mh250,\n.s-footer_fixed_cta,\n.s-main_article > div.u-mb_l:has(> a[target=\"_blank\"] > img),\n.s-outside_banner,\n.u-center.u-mt_l.u-mb_l,\nbody > div[style^=\"position:fixed;bottom:\"]",".rwdArticleInnerAdBlock,\n.rwdArticleOuterAdBlock","div[style=\"min-height: 280px; height: auto;\"]",".ccn-article-attention",".base-inner-slim[style^=\"min-height\"]",".adbnrs,\n.bnr350,\n.bnrBottom,\n.bnrBottomTop,\n.bnrBox468,\n.campad",".skyscraper","#adv_bottom,\na[id^=\"honkaku\"]","#main_column_inner > div[style^=\"width:320px;height:\"]",".sidebar_content > .widget_custom_html",".banner_small,\n.wrapper_side > aside.banner,\n.wrapper_side > div.banner_special_content:first-of-type","#body > .plainBox:has(.adv)","#modal-overlay","#welcome-modal-content",".t_koukoku","#tmp_wrap_publicity",".class_area7 ~ .class_area18",".kokoku",".zone04",".footerAdvert",".pc-only > div.aside_area:first-child,\n.sec-goods",".p-articleAd--rec--2col,\ndiv[style=\"min-height: 280px!important;min-width: 500px;\"]","#banner_area > h3,\n.banner_a",".article-body > div.ArticleComponentButton[id],\n.article-body > div.ArticleComponentHtml > div.ach-btn-balloon",".add-box","#ct-ad-streaming,\n#ct-ad-super-banner,\n#ct-ad-ydn-overlay,\n#ct-affiliate-box,\n#movie-ranking > li[style=\"margin: 16px 0; background:#fff;\"],\n.col-right300 > div.module:last-child,\n.ct-ad,\n.ct-ad-prime-display",".m-banner","#adBannerLower","#headAD,\n#rightContentsInnerBox > article.articleBox > div.articleSubBox:has(> .listItemGoodsSingleLarge),\n.listItemGoodsAd,\n.listItemGoodsAdContentsBottomBox,\ndiv[class^=\"google_adsense\"],\ndiv[style^=\"width:960px;height:320px\"]","div[style=\"border:1px solid black;padding:2px;\"]",".ad_cls,\n.reccomendArc","#tmBottomAd,\n#tmContHeadAd1,\n#tmHeadAd,\n#tmSideAd,\n.tmAdGaid,\ndiv[style=\"margin: 5px auto;max-width:650px;\"] > table.tmTable[style=\"width:100%;margin: 0;\"] > tbody > tr + tr:has(a[target=\"_blank\"])","#tmContHeadAd","#adtag-rectangle,\n.add_2,\n.prtxt","iframe[class^=\"i_f\"]",".newadarea,\n.uk-width-large-12",".newscontent > div[align=\"center\"]","#header_lower,\n.ad-lb,\n.left-column > div[style=\"width:200px; height:259px;\"],\ndiv[id^=\"ad_rectangle\"],\nh2.css-1jeee1j[data-view-mobile=\"false\"]","#related_site:last-child,\n#tournamentBnrArea,\n.lbadArea","#container > div[style^=\"width:1100px; \"],\n#news > ul","div[class*=\"-only\"][class$=\"-overlay\"]","#eijiro_pc_top_01,\n.rectangle_right","#fourm_video,\n#sys-article-upper-afc,\n#sys-pc-inArticleREC,\n#sys-upper-rec,\n.aa_ad-home-thumb-small,\n.aa_area-content-top,\n.aa_content-side > div[data-tracking-zone] > div.obtain-height,\n.aa_rec-box,\n.aa_swipe-content > div.aa_box-center:has(> div.ad-bnr),\n.docomo_custom_alliance,\n.ec-site-box.sys-ga-event-affiliate,\n.fixed_bottom_aa_ad,\n.shuffle-list-item,\n.sys-aa_placement,\ndiv[data-tracking-zone=\"modules-content-affiliateButtons\"],\ndiv[data-tracking-zone^=\"parts-common-adFirst\"],\ndiv[id^=\"sys_aa_pc_placement\"],\nsection[data-tracking-zone=\"modules-content-docomoCustomAlliance\"]",".layout_sidebar > div.obtain-height,\n.logly-ranking-wrapper,\ndiv[class^=\"ad-banner__\"]",".ad-long","a[href^=\"https://www.townu.jp/\"]",".ad_top300",".insert-ad,\n.insert-ad-area","#RcolRectangle","#BelowArtLink,\n#SuperBanner",".ad-_badge",".cap,\n.contents_banner_area,\n.h_cap,\n.top_banner_area",".leaderboard-container,\n.leaderboard-wrapper",".l-wrapper > div.l-sidebar:has(> aside > ins.adsbygoogle)",".entry-content > div[style=\"margin-left: auto; margin-right: auto; text-align: center; \"],\n.sidebar > aside.briar-widget",".footer-rec-add,\n.srb-text",".tbcms_ad-block,\naside[class^=\"tbcms_banner\"]","#AdPrimeDisplay,\n#\\33 00X250_R01,\n#sub > .negativemargin10top:first-child,\n.admovie,\n.pr-textlink__link,\n.yahooaffiliate-vertical,\ndiv[class^=\"bnr\"]",".show-ads,\n[id$=\"rec_bnr_header\"]",".advertisement2[style=\"clear: both;\"]:has(+ div.block-block)",".preloader",".pc300","div[class^=\"m-ad\"]",".header > div.cmp-bnr001,\n.l-container-narrow,\n.pt-40.ta-c.cscmp-lst002,\n.sub-container-wrp > div.cmp-lst001 > div.l-artlst001 > ul.list > li.item[style^=\"min-height:9\"]:has(> div[id^=\"div-gpt-\"])",".cmp-misc010",".super-banner",".cap_box_content:has(.swell-block-button__link[href^=\"https://h.accesstrade.net\"])","#_popIn_recommend,\n.pg-container-side div.cb-l1-m2:has(div.bnr-rect)","#dspc-relation_img,\n#joboxAd,\n#nativeRecommend,\n#rec1-umaya,\n.pageAd,\n.pnl-aside,\naside.add,\naside[class^=\"aside-\"][class*=\"-ad\"]",".ht5_adSense",".area-ad","#bottom_bottom_ad,\n#part_footer,\n.main_present_thread > div.padding > div.right.column",".side-topad > div.widget_st_custom_html_widget:has(> div > p > a[href^=\"//ck.jp.ap.valuecommerce.com/servlet/referral\"])",".hustle-popup","#ehime_pc_top_1st_rectangle,\n#home_minibnr,\n#prLink,\n.aside_box div[class^=\"mini_\"],\n.ehime_pc_all_header_wrap,\n.pr_sq_box,\n.superbnr_box",".dfp",".wrap-advert","#ad300x250,\n#timesale,\n.ec-ranking,\n.ec-ranking-article,\n.mainSide > div.topics,\n.media-shopping,\ndiv[class^=\"ad-aside\"],\ndiv[class^=\"ex-ad-rectangle\"],\ndiv[id^=\"exad\"],\ndiv[id^=\"gpt_\"]",".ad-header-banner","#header_bnr,\n.Lymain div[style$=\"width:610px;\"]",".Bnr","#cxra-rectangle,\n#fp-bhp-rectangle,\n#fp-rdef-rectangle,\n#fp-rectangleArea,\ndiv[id^=\"cx-ad-\"]","#video_container > div[style*=\"position: absolute; overflow: hidden;\"]:has(> img[src=\"/plus7/web/imgs/animation_spinner.gif\"])",".advertCont",".admeasure + hr,\n.admeasure:not(.textlink-ad),\n.article-body > .inread:has(> div[id^=\"div-gpt-\"]),\n.headline > li:has(> div[id^=\"div-gpt-ad-\"]),\nli.pr",".text-ad",".article-dfp","#adsYahoo,\n.allyanceAd","#before-container",".prContent,\nli[style=\"height:250px\"]","div[class^=\"ad_banner\"]","#footerbnr,\n.sspPR,\n.sspbox","div[style=\"width: 100%; height: 90px; clear: both;\"],\ndiv[style^=\"width: 160px; height: 600px\"],\ndiv[style^=\"width: 250px; height: 250px\"],\ndiv[style^=\"width: 728px;\"]",".box-header-banner,\n.sec-pr,\n.sec-side-banner","div[style=\"width: 700px; margin: 30px auto 0 auto; height: 250px;\"]",".ad.w-rec[style=\"text-align:center;margin:45px auto 40px;width:720px;\"],\n.ad:not(.w-rec)",".PrPr,\n.bd_beige_top3:has(div[id^=\"div-gpt-\"]),\n.detailAdsense,\n.main_1col:has(> div > div[id^=\"taboola-below-article-thumbnails-\"])",".adPremium","div[id^=\"contents-advertising\"]","#topix > .context:has(> #ad_centents_center),\ndiv[id^=\"ad_centents\"]","div[style=\"width:300px; height:250px;\"]",".ad-pr-text",".ad-wrapper-in-content",".node-body-content > div[style=\"background-color:#FFFBD6; margin:3em 2em; padding:10px 5px\"]","#gpt-div-ipc-wf-pc-u-kiji001,\n#watch-static-pc-c,\n.ad.billboard,\n.ad.item,\naside[id$=\"-amazon-ranking\"],\naside[id$=\"-rakuten-ranking\"],\ndiv[class^=\"affiliate_tag_\"]",".amazon-ranking",".ad_download",".amazon-aff","#amazon-ranking-widget,\n#webtan_adsense_nodefooter,\n.block-block-ad,\n.pane-bancho-common,\ndiv[style=\"background-color:#FFFBD6; margin:3em 2em; padding:10px 5px\"]",".firstview_custom,\n.singletop-widget","#bannerblock","#mkdiv_header_pitari",".entry-content > div.sng-box:has(a[href^=\"//ck.jp.ap.valuecommerce.com/\"])","#ATF,\n#AmazonRankingParts,\n#GeneralAD,\n#ISALR,\n#ISTCPB,\n#ITN,\n#ITR + div#colBoxRcBanner,\n#ITT,\n#OwnedAd,\n#RcolBanner,\n#SideLink,\n#SpvLink,\n#TextAd,\n#TopBox,\n#TopLink,\n#cmsBody > div.inner > h2.format--crosshead ~ div.cmsBodyBox:has(> div > center > strong > span > a[target=\"_blank\"][rel=\"noopener\"]),\n#cmsBodyMain > div:not([class]) > div[style=\"text-align:center;margin-bottom:20px;\"]:only-child,\n#cmsSubPR,\ndiv[id$=\"BrandText\"],\ndiv[id$=\"InFeedNative\"],\ndiv[id*=\"Rectangle\"],\ndiv[id^=\"ITR\"],\ndiv[style=\"min-width:600px;min-height:32px;\"],\ndiv[style^=\"font-family:Gill Sans;\"][style*=\"font-size:12px;\"][style*=\"line-height:12px;\"],\niframe[id^=\"cxWidget_\"],\nins[id^=\"yoneads\"]",".gad","#globalHeaderMiddle",".bannar,\n.contents_bannar,\n.headerbannar,\n.main-pr-single-top",".ad_itextad2_wrap,\n.ad_mcol_gad,\n.ad_mcol_gad2",".ad-lmc,\n.ad:not(.wrap > .ad),\n.article-list > li:has(> div[id^=\"yads_\"]),\n.high-CMSbox","ad_bnr","#relatedArea,\n#sideWrap > section#adbannerArea,\n.adSet",".duilian",".m-ad-double",".ad_full,\n.article-inner > .article-box._center._inner_break_horiz-sp,\n.panel_kv > li[style=\"display:flex; justify-content: center; flex-wrap: wrap;\"]:not([class])",".amazon_associate_banner,\n.com_pr_rmads_right,\ndiv[id^=\"Ads_google_\"],\ndiv[style^=\"width:500px;min-height:280px\"]","#site-contents > aside.cf > p.aright.message,\n.HEADER_PARTS,\n.area4 > div[style*=\"height:\"]","#site-contents > p.message.aright",".ad_common_4_300x250,\ndiv[class*=\"ad_index\"]","ul[class^=\"list\"][class$=\"__list\"] > li:has(> div[id^=\"div-gpt-\"])",".banner:has(> #knpc-rec1),\n.bottomPrArea,\n.isInfeedLoad,\n.prNews,\ndiv[id^=\"knpc-\"],\nli.active.native",".banner-area","body div.fc-ab-root:not(#style_important),\ndiv[class^=\"detail_adArea\"],\ndiv[class^=\"styles_ad\"],\nsection[class^=\"detail_recommended_\"]",".l_floatingbanner",".prArea",".amazon__category-af",".large-ad-area",".ad-container2,\n.kyobu-widget,\n.td-a-rec-id-custom_ad_2,\ndiv[class*=\"yad-\"]","a[href^=\"http://www.kyoeikasai.co.jp/\"]",".banner-area-entry",".textwidget > div.box > a[target=\"_blank\"][rel=\"noopener\"] > img[width=\"300\"]",".gunosy-ads-spot,\na[href^=\"https://suumo.jp/tokushu/pre/mansion/kanto/\"]",".m-articles > article.m-articles-item:has(> div[id^=\"div-gpt-ad\"])",".l-content-sub div.info","#map_yads,\n.ad-overture,\n.article div.clearfix[style^=\"margin\"],\n.side-news-ad","div[style^=\"width:728px;height:90px;\"]","div[class$=\"adarea\"]",".modAdBanner-3","#columnnews-container + div:not([class]) > a[style=\"font-size:65%;text-decoration: none;padding-left:10px;\"][onclick^=\"gtag(\"],\n.PRBOX,\n.texad,\n.texmongon","#sp-column-detail-bottom-banner","#header_top_banner,\n.bannerBox","#content div.main > aside.sub_aside:has(> .OUTBRAIN),\n.side_rectangle",".banner2","#around-article-area,\n#main-page-frame > div[style=\"display:flex;justify-content:center;align-items:center;height:120px;width:100%;\"],\n#naviad-area,\n#page_footer_adunit,\n#right-upper-banner-frame,\n#st-around-realestate-area,\n#st-bizreach-job-list,\n#under-advertisement,\n.ad-frame,\n.adv__section-ad-4,\n.advertising-link,\n.cmp_frame,\n.footInfeedArea,\n.footer-rect-ad-frame,\n.naviadContainer,\n.section-ad-1,\n.section-ad-3,\n.section-ad-4,\n.top-ad-frame,\ndiv[style$=\"margin: 30px 0; height: 250px;\"],\ndiv[style$=\"margin:30px 0;height:280px;\"]",".wp-block-st-blocks-my-box[style^=\"background-color:#fff\"]",".box_300,\n.out_pr,\n.pr-txt,\n.pr300","#main > div.mab10.tac[style=\"padding-bottom:3px;\"],\n#main > div.slider",".pr_txt",".newpickup_premium > li.widget_text a[href=\"https://estate.nikkan.co.jp/notice\"],\n.top_recommend","#headerbanner",".l-asideSection_featured",".p-articleTextad",".-info:has(> li > div[id^=\"div-gpt-\"]),\n.l-asideSection:has(> .dag_aside_pickup)",".prBox","#jobOffer,\n.c-ad-side",".btobArea",".txt_pr,\ndiv[class^=\"ad-nnn\"]",".sec-crpTop-stop","#ntv_setAD_PC_300_250,\n#ntv_setAD_PC_728_90,\n.genre-ad,\n.ntv-box-adBanner",".hulu-link",".overlay-publicity,\n.publicity-contents",".common-adbox:not(#ad04)",".ad-bottom-banner,\n.u-flex--center,\narticle > div[style=\"margin:0px 0;text-align:center;\"],\narticle > div[style=\"margin:25px 0;text-align:center;\"],\ndiv[style*=\"width:300px;height:250px\"]","#content-main div.block-link-list-b > article:has(> a > div.pr),\n.ad-tver,\n.affiliateLinks,\n.block-header-banner-wrapper,\n.block-sub > div.border-box > table > tbody:has(> tr > td > div[data-uz-url]),\n.block-sub-latest:has(> .lnk_kjbox),\n.block-sub-news tbody:has(> tr > td > div[class^=\"gmossp_\"]),\n.block-sub-recommend li > a[href^=\"https://www.oricon.co.jp/pj/\"],\n.block-sub-recommend li:has(> a > div.pr),\n.break-ad-box,\n.overlay-ad-area,\n.relatedLinksPhoto > div[style^=\"width:\"][style$=\"float: left;\"],\n.stickyfill tr:has(> td > div[class^=\"gmossp_\"]),\naside.block-header-banner,\naside.top-inline-banner","div[style=\"min-height:250px;\"]","#gpt-cojp_rec-footer,\n#gpt-cojp_rec-header",".ph",".list_ad,\n.o_aside__pure__ad",".yadsOverlay","#sc_pc_article_billboard,\n.ad-pr,\n.bnr_wrap,\ndiv[style=\"height: 250px\"],\ndiv[style=\"height:250px;\"]","#beta_ads01,\n.sp_none[style=\"height: 600px;\"],\ndiv[style*=\"250px\"]","#wrapper #button_id,\n.anchor","iframe[src^=\"https://popteen.co.jp/media/wp-content/themes/magazine_theme/ad_logly/\"]",".rc-cpn",".list-banner-01",".SideColumn__ad",".flexContents__box--adBox1",".portal-info-swiper","#pitari_area","#commonAdsParts,\n#content-sticky > table:has(div.rcardImg),\n#content-sticky > table:has(td[style=\"padding-right: 16px;\"] > div.side_lo > div#RGPT_Rak_Blog_User_SideBanner),\n#content-sticky > table[width=\"330px\"]:has(> tbody > tr > td > div.side_lo > div.sidefree > table div[style*=\"width: 280px;\"] a[href^=\"https://hb.afl.rakuten.co.jp/\"][target=\"_blank\"][rel*=\"sponsored\"]),\n.headerAdC,\ndiv[id^=\"div-plaza-point-ad-\"]",".rad-table-existItemDisplay",".gamelist-ads,\n.mypage-ads,\n.side-ad,\n.side-mypage-ad-wrap,\ndiv[style=\"width:728px;height:90px;\"],\nstyle + div.side-box:has(> ul > li > a[href^=\"https://ac.ebis.ne.jp/tr_set.php\"][target=\"_blank\"][rel=\"noopener noreferrer\"])","#footerOverlayContents,\n#recommendOfficialRecipe,\n.ad-table-label,\n.box_banner--top,\n.bt_app-ad_area,\n.ranking_recommend_recipe,\n.section_common_banner,\ndiv[id^=\"rdn-adspot\"]",".ad__pr","#bnr-area,\ndiv[class^=\"rt-wide-banner-\"]","#ads-billboard","#ad-ichiba,\n#teamsite-mid-pickup,\n.section-title1[style=\"margin-bottom: 10px;\"]",".ad-outer,\n.right-people[style^=\"min-width: 300px; min-height: 250px\"],\n.right-ranking",".code-block:not(.code-block-14),\n.code-block[style$=\"text-align: center; display: block; clear: both;\"]",".pc-top-ad-text","table[style=\"border:none;text-align:center;\"][width=\"660\"]",".pr-list",".m-ad-text","div[id^=\"my_banner-\"]",".sb-box-sub-07.fund-pr,\nh2.fund-pr",".l-sidebar > aside.widget_text:last-of-type",".sidebar > .text-xs-center:first-child,\n.text-md-right + .m-y-2.row","#attentionArea,\n.side-contentsAD","div[id^=\"jp_soon_\"][style]",".h-\\[250px\\].w-\\[300px\\],\n.items-center > .flex-col.pb-8:has(> h3 + .min-h-\\[250px\\] > div:only-child > div[id^=\"logly-lift-\"]),\n.max-w-\\[1100px\\] > div.pt-6.pb-8.border-app-text,\n.max-w-container > div.border-app-text:has(> div.min-h-\\[250px\\]),\n.text-app-text > div.h-\\[266px\\].bg-app-bg",".c-bnr > img.lozad,\n.leaf-page__bottom-ad,\n.leaf-page__top-ad",".textwidget:has(> div[id^=\"div-gpt-ad\"])",".list-basic-a:has(> li > div.c-ad)","#Sportiva_pc_article_UnderTitle",".block-widget-a-c__container:has(> div.mod-box > div.mod-box__container > div.js-ad-wpb_pc_house),\n.helper--min-height-225:has(> .OUTBRAIN),\nul.mod-grid2 > li.block-list-a-a__list__item:has(> div.block-banner-b-a),\nul.mod-grid2 > li.block-list-a-a__list__item:has(> div[class$=\"_InRecommend\"])","main > section.section:has(> div.section-container > div.OUTBRAIN)","div[class^=\"Fluct_shadow\"]",".adxTagArea","#text-24","#iframeHeader",".article_list > li:has(> div > div[id^=\"div-gpt-ad-\"]),\n.contents-pr,\n.mb30:has(> div > script[src*=\"rakuten\"]),\n.mb40:has(> div[id^=\"div-gpt-ad\"]),\n[class^=\"banner\"],\na[href^=\"https://park.sjnk.co.jp/campaign/ad_\"] > img,\ndiv[data-component=\"ad-basic\"],\nul[data-component=\"article-links\"]",".bbear-ad",".is-nativead-pagingad","#hdBnr,\n#rnvBnr",".ads_btm,\n.ads_icon",".bnr__section:has(script[src^=\"https://js.ad-stir.com\"])","#r-googleads",".ad_pc_article_undertitle",".ad_article_gallery_wrap",".om-ad",".ad_world > div,\n.sidebox > ul > div[style=\"display:block;margin-top:1em;\"],\ndiv[class$=\"_billboard\"],\ndiv[id] > div > div[style^=\"display:block;margin\"]:has(> p[style=\"margin-bottom:.5em;border:none;font-size:.9em;\"] > a[target=\"_blank\"] > span[style$=\"text-align:center;\"])",".dfp_tag",".cmp-misc014,\n.header > .cmp-bnr001",".head-bnr-area,\n.l-side-block--banner:has(> div.ad)",".ad-billbaord,\n.alliance_PR,\n.right-section > div.tckr",".ad-msq--sticky,\n.billboard_wrap,\n.pickup_item--PR,\n.power_item--PR",".p-news_snsarea","#rectangle-desktop,\n#superbanner-desktop,\n.analytics_pr_rect,\n.common-box-ad-rectangle,\n.newHeaderBanner,\n.rectangle-desktop",".common-box-ad,\n.common-box-ad-landscape",".pc-ad1,\n.pc-ad23","#footerPcBanner,\n#txcms_cms_sideBanner_1,\n#txcms_cms_sideBanner_2,\n.entry_detail_ad2,\n.tbcms_ad-block-overlay","#adArea",".MuiGrid-container[class*=\"jss\"]:has(> div.MuiGrid-item[style=\"margin:0 auto\"] > div#ad1)","#glr_popup",".bottom_prarea","#dcms_layoutPageBlock > section[class^=\"dlb_box\"]","#ad-lrec,\n#ad-new-ysp,\n#lrec,\n#pos-sqb,\n.yads-overlay,\ndiv[class*=\"Yda_\"],\ndiv[class^=\"Lrec_\"],\ndiv[class^=\"SearchResults_searchResults__contents__main__\"] > div.SSContainer,\ndiv[class^=\"Sports_StreamSports\"] > aside[class^=\"ArticleBox_ArticleBox\"]:has(> a[href^=\"https://app.adjust.com/\"]),\niframe[id$=\"_ad_frame\"],\nimg[src^=\"https://s.yimg.jp/bdv/yahoo/\"]","#adTopLREC,\n.bannerFrame,\n.ss,\ndiv[class^=\"LayoutMain-sc\"] > aside[class^=\"Component-sc\"]:has(> div[id^=\"adS\"]),\ndiv[class^=\"LayoutMain-sc\"] > section[class^=\"Component-sc\"]:last-of-type:has(> div[id^=\"adS\"])",".sn-banner > a[href*=\"adj.st/open/\"],\na[href^=\"https://pacificleague.com/setup/plan\"] > img",".Banner","#ydn-bot,\n#ydn-contents-top-text","#lrecArea,\ndiv[class*=\"SearchResults_searchResults__\"][data-device=\"smartphone\"] > section[class*=\"SSContainer_SSContainer__\"][role=\"complementary\"] > ul[class^=\"SSContainer_SSContainer__list__\"],\ndiv[class^=\"ErrorTypes_errorTypes__searchZeroHits__\"] > div.SSContainer,\ndiv[class^=\"Top_chie-Pages__ColumnItem--Sub\"] > div[class^=\"Top_chie-Pages__SubColumnSection--Box\"]:has(> #ad_lrec:only-child)","[id*=\"-ad-parent-\"]","#contents > div[class^=\"_\"] > div[class^=\"_1\"] > div[class^=\"_2\"] > div[class*=\" _\"]:has(> #subAdTop),\n#contents ~ div[class] > div[class^=\"wP-\"] > div[class]:first-child:has(> div[id^=\"ad_\"][class]),\n#newslist > div[class^=\"_\"] > div[class^=\"_\"] > ul[class^=\"_\"] > li[class^=\"_\"],\n#pr_main1 + div[class],\n.NRqdNbNt,\n.XuqDlHPN > div.pebAehAj._1IdtoV3i:last-child:has(> div[class^=\"_\"] > div[class^=\"_\"] > div[class^=\"_\"] > div[id^=\"ad_\"]),\n.ydn,\ndiv[class*=\"LREC_\"],\ndiv[class*=\"YDN_\"],\ndiv[class*=\"subAd\"],\ndiv[id^=\"cat_\"] > ul[class^=\"_\"] > li[class^=\"_\"]:last-child,\nmain > div[class^=\"_\"] > div[class] > div[class^=\"wP-\"] > div[class]:has(> div[id^=\"ad_\"][class]),\nsection[id][class^=\"_\"] > div._22wPPO7Q","div[id^=\"ad_\"]","#floating_banner,\n#jack","#qa-mr-ad1",".App__contentsAd,\n.SS__list:has(span.Badge--ad)","#contentsWrap > div.YOUcY + div.cyaYcX:has(> div.jOKwHf:only-child > div[id^=\"yads_\"]),\n#contentsWrap > div.fqtWpW:has(> div.jOKwHf > div[id^=\"yads_\"]),\n#yjnFixableArea > div > div.jOKwHf,\n.adWrap,\n.newsFeed_list > li > div[id^=\"ad\"],\n.nhSpBox3,\nli > a[class^=\"sc-\"][href^=\"https://rd.listing.\"]",".YCA","#contentsInner div[class^=\"SS_SS__\"],\n.AdBannerCarousel,\n.main > div[class^=\"SS_SS__\"]:first-child","#makerAd,\n.mdNorthBuyee,\ndiv[class^=\"style_Ad\"]:empty",".mdYCA",".sc-lrec","#cp_bnr,\n.cm-videoEmbedSub__banner,\n.hr-lrec,\ndiv.cm-modCommon02:has(> div[style=\"min-width: 300px; min-height: 250px\"])",".cmpList__adBlock",".pos-infeed",".adNm",".promoBanner","#bnr2,\n#ydn-top,\n#ysp,\n.ad-frame-fix,\n.heatstrokePromo,\n.rainRadarAd",".ad-text01,\n.pd,\n.rb","#latest_list > .p-ad-list-item + li.p-list-item,\n.dazn_banner,\n.news-top-latest__ad,\n.p-ad-dfp-rec1,\n.p-ad-feature-pr,\n.p-ad-list-item,\n.p-ad-news-txt,\n.p-ad-txt-nowrap,\n.p-ad-txt-wrap,\n[id^=\"ad_dfp\"],\ndiv[class$=\"__ads\"],\ndiv[class^=\"home-ad-\"],\ndiv[class^=\"p-ad-dfp\"],\ndiv[id^=\"dfp_\"]","._popIn_recommend_ad_section_articles,\n.p-topiList__item.py-1,\n.sidebar-ad-rakuten,\ndiv[class^=\"p-ad\"]",".thumbnail-ad","#bnr-block,\n.area-top-banner,\n.gDef-bottom-banner,\n.gDef-side-banner,\n.gDef-top-banner,\n.pr-bannerRect-block,\n.pr-has-two-columns",".sponsor_link",".special.pr","#list > .posts-list-upper-widget,\n#side-fixed > #custom_html-23,\n#side-fixed a[href^=\"//af.moshimo.com/af/c/click?\"],\n#sidebar-2 aside > div.widget_custom_html","td[width=\"840\"][bgcolor=\"#ffffff\"] > span.black_mui12180","#related_area_cce_logly,\n.pre_banner_area,\n.sponser_drink_area","#AdSpecialContents","#area-ad1,\n#snav03 > div[align=\"center\"],\n.mt-3 > div[align=\"center\"],\n.wrapper > div.container > div[align=\"center\"]:not([class]):not([id])",".single-infeed,\ndiv[id^=\"cr_\"]",".adBanner,\n.banner01,\n.feature,\n.newsWrap > .banner,\n.sideBanner",".field-amazon-product1,\ndiv[id^=\"block-banner\"]","#contents > div[style^=\"text-align\"][style$=\"center;\"],\n.adsSpRect,\n.head-pickup,\n.youtube,\np > a[href^=\"https://coconala.com/services/\"][rel=\"nofollow\"]","#top_fixed,\ndiv[id^=\"dugaflvplayer\"],\ndiv[id^=\"goods\"],\ntd.none[colspan=\"2\"][valign=\"top\"][align=\"center\"]:only-child","#AttentionArticle","#_popIn_infeed,\n.ad2column,\n.ad2column ~ table[width=\"700\"][cellpadding=\"0\"],\n.page_ad_slot",".c-box-ad-movie--space,\n.c-box-ad:not(:has(a[href$=\"/recruit1/\"]))","div[class^=\"ad_div\"]","#navi,\ndiv[class^=\"AD\"]","#modal_mti,\n.img_banner,\n.sc_banner",".pt-2.col-12[style=\"height: 105px;\"]",".mainSlideAll",".bnr-img[data-original=\"https://deli-fuzoku.jp/assets/img/user/pc/index/bnr_ec.png\"],\n.mod-bnrWrap:last-child","#eqlast,\n#shadowv,\n.ently_text > center > a,\n.page_navi > center > a:not([href^=\"https://deneblog.jp\"]):not([href^=\"/blog-entry-\"]):not([href*=\"fc2.com\"]) > img",".inner-widget,\n.rectangle-bn,\n[id^=\"dfng\"][id*=\"jack\"]","#pc_article_billboard,\na[id^=\"dfng_center_banner\"]:not([href^=\"https://news.denfaminicogamer.jp\"])","#dol17_article_recm_pc,\n#gpt-dol-infeed-ranking-text,\n#recommend-you,\n.ad-bannar-floating,\n.article-list > div > article:has(> div.ad-related),\n.banner-sp,\n.kabunushiyutai-ir,\n.pr-icon,\n.pr-icon + .top-article,\n.sub-trend-watch",".pickup",".prcolumn-h,\n.rectangle_ad_recommend_box",".section[style$=\"width:300px;height:600px;\"]",".single_banner",".ad_height",".add_area-center,\n.add_frame",".interstitial_ad","#yahooad_sp","#ad-wall-first-view,\n.col-xs-12.margin-bottom-lg > a[href^=\"https://search.rakuten.co.jp/search/mall/\"][rel=\"nofollow\"],\n.margin-bottom-md > a[target=\"_blank\"][href^=\"https://search.rakuten.co.jp\"]","#sp-link,\n.box-center",".l-sidebar > .widget:has(> .textwidget > p > .adsbygoogle)","#head_box,\n.amazonbox,\n.at_adwbox",".koukoku_middle,\n.osusume_msk_div4,\n.widget-area > div[align=\"center\"]:has(td > a[href^=\"http://www.d-064.com\"])",".autopagerize_page_element > .latest-banner,\n.l-sidebar-b > div.plugin-memo","div[id^=\"imobile_ad_\"]","#sub div.amzimg ~ a[href^=\"http://www.amazon.co.jp\"]","blockquote:has(a[href^=\"https://www.amazon.co.\"])","#sidebar-inner > div:has(> div.right-container-ads),\n.kotei",".footerBnr",".headerBnr","div[id^=\"divSP\"],\nspan[style=\"font-size: x-small;\"],\nspan[style=\"font-size: x-small;\"] ~ hr[size=\"1\"][color]",".plugin-recent_articles_image + div.plugin-memo,\n.plugin-rss:last-child","#more > a[href^=\"https://www.amazon.co.jp/\"]","#extra > div.column-inner > div.column-inner-2 > div.plugin-memo:first-child","#extra > div.column-inner > div.column-inner-2 > div.plugin-memo:last-of-type","#contents_item_base > div[style=\"margin-bottom:10px;\"] > div[align=\"center\"],\n#contents_item_base > table.onlyPCblock + div[style=\"margin-bottom:10px;\"],\n.ad_index_main_base,\n.ad_item_head,\n.contents_right_item > div.onlyPCblock[style=\"margin-bottom:10px;\"],\n.news_ad",".adAreaDownload,\n.adAreaHead",".adbox_top3","#adsense",".article-body + div[style=\"margin: 20px 0;\"]","#main-inner > p,\n.first-article > p","#menu_banner",".bottom-rectangle,\n.ssp_330_fixed,\n.ssp_728_01",".ssp_300_01",".ssp_300_02",".panel-default:last-child",".header-area-bn",".site_bottom_banner","#Related_Books,\n#relbooks,\n.rel-box[style=\"margin-bottom:0;height:100px\"]:first-child",".c_adnw,\n.ecnavi-games-ad",".billboard",".no-app.l-page__banner,\ndiv[style=\"width:49%;text-align:center;display:inline-block;\"]","#top_koukoku_container","#lokokoku","#press_area","#banner_footer1",".top_banner_7","#top_banner_kokoku_wrap","#video_wrap",".mp-Article_Ad",".ll-m-addContainer","section[data-vars-block-curation] > div[class*=\" \"]:has(> .ad-container)",".e__float_try","#sidebar1 > div.widget_text:has(> div > div.center > a[target=\"_blank\"]),\n.su_row","div[class^=\"p-advertisement\"]",".single_right_banner,\n[class*=\"margin-Ad\"]:not(.margin-Ad-B20)","#pc_article_right_1",".sidebar:has(> div > div.plugin-freearea > a[href*=\"e-nls.com/access.php\"])",".temu","div[class^=\"article-footer\"][class$=\"-affi\"]","div[style$=\"min-width: 250px; min-height: 300px;\"],\niframe[title=\"Advertisement\"]",".generalListAd","[class*=\"list\" i] > .ss","#agoda,\n#agoda_ads > div[id^=\"adgshp\"],\n#sideBoxRight table[cellpadding=\"0\"][cellspacing=\"0\"][border=\"0\"][style=\" border:1px solid #ccc; width:300px;\"]:not([class]),\n#sideBoxRight table[style*=\"border\"][style*=\" width:\"] a[href*=\"://rpx.a8.net/svt/ejp\"],\n.sidetitle:has(+ .side > div[style] > ins.adsbygoogle),\n.sidetitle:has(+ .side > ins.adsbygoogle),\ndiv[class$=\"ody\"] > div.text table[cellpadding=\"0\"][cellspacing=\"0\"][border=\"0\"][style=\" border:1px solid #ccc; width:300px;\"]:not([class])","div[class*=\"advertisement_sidebar_\"]","div[style^=\"width: 100%; min-height:90px;\"]",".m-articles__side-articles-ranking-list-item[style=\"display: block;\"],\n.p-wide.m-latest-list-item:has(> div[style=\"width: 100%; min-height:152px; margin: 0 auto;\"]),\ndiv[style=\"width: 100%; min-height:100px; margin: 0 auto;\"],\ndiv[style=\"width: 100%; min-height:250px; margin: 0 auto;\"]","#reader_ad_overlay","#dlUnder,\n#mains > .minispace2,\n.pl-lg-3.col-12 > div.custom",".common__adv_overlay","#content a > img[height=\"250\"],\n#content a > img[height=\"300\"],\n#sidebar > div.widget_custom_html:has(+ div#fix_sidebar),\n#sidebar > div.widget_custom_html:has(> div.textwidget > div.p-blogParts > div.ek-linked-block),\n.container > div.swiper-container:has(> div.swiper-wrapper > div.swiper-slide > a[href^=\"https://click.duga.jp/\"] > img),\ndiv[class=\"wp-block-column ek-linked-block\"]:has(> a.editorskit-block-link[href^=\"https://al.dmm.co.jp/?lurl\"])",".entry > div[style=\"padding: 10px; margin-bottom: 10px; border: 5px double #333333; border-radius: 10px;\"],\n.magazine_latest","#sideNavi div.banner:has(> a[href^=\"https://h.accesstrade.net/sp/cc?\"]),\n.adsenceArea",".side-menu:has(a[href^=\"https://adult.contents.fc2.com\"]),\n.side-menu:has(a[href^=\"https://al.dmm.co.jp/\"]),\n.side-menu:has(a[href^=\"https://click.dtiserv2.com\"]),\n.side-menu:has(iframe[src^=\"https://www.mmaaxx.com\"])","#sidebar > .widget:has(> p > .adsbygoogle),\n.entry-wrap--ads",".w-AdSense[style^=\"max-width: 860px;\"],\ndiv[class^=\"col-\"][style^=\"margin-bottom:60px;\"]","#relatedContent,\ndiv[class^=\"adArticle\"]",".my-1",".footerAdOuter,\n.googleAdsense-box,\n.googleAdsense-head-pc",".after-btn-fb-nice-ad-pc",".billboard-ad-slot",".bn_gpt_box",".css-9wmwr1,\nsection > div[class^=\" css\"]:has(> .ad-disclaimer:first-child + .ad-container:last-child)",".ad-article-rect,\n.articles-v-item:has(> div[id^=\"div-gpt-\"])","#footer-overlay-ad,\n.c-adgrid",".carousel_ad",".story__header-adbox","#top-big-ad,\n.kanren-unit,\n.link-unit-adjust,\n.side-top-ad,\ndiv[class^=\"freebox \"][style^=\"background:#f0ffff;\"],\ndiv[style=\"height:300px;margin-bottom:20px;\"]","#top_banner_left",".advertising-list",".ad-banner-font,\n.ad-small-font","#footerAdBanner",".l-sidebar-ads > li:not(:has(> a[href^=\"https://full-count.jp\"])),\n.l-sidebar-ads-top,\n.s-entry-ads,\na[href^=\"https://tp-bb.jp/\"],\na[id^=\"c2_click\"][id*=\"did_article\"]",".ad-rectangle-right,\n.m-ad-rectangle,\n.r-ad-rectangle","._popIn_recommend_header","div[style*=\"min-height:280px;\"],\ndiv[style=\"min-height: 100px;\"]","#ad3","#top > div[style=\"padding:25px 10px;\"],\n.box_top:has(> div.box_btm > .bukken-list),\n.box_top:has(> div.box_btm > .realestate-list),\n.box_top:has(> div.box_btm > .recipe-side-img-area),\n.contentTitle.ui-bar-gray:has(+ .table-b > .rank[class*=\"-list\"]),\n.contentTitle.ui-bar-gray:has(+ .table-b > .recipe-side-img-area),\n.full.main > div[style=\"text-align:center;\"],\n.google-ad-area,\n.listAds,\n.realestate-memory-box,\n.sub-row div.box:has(> div.content > div.juku-widget-item),\n.sub-row div.box:has(> div.content > div.widget-item p.price),\n.table-b:has(> .rank[class*=\"-list\"]),\n.table-b:has(> .recipe-side-img-area),\ndiv[style=\"margin-top:10px; margin-bottom:30px;text-align:center;display:inline-block;\"],\ndiv[style=\"padding:25px 10px;display:inline-block;\"]","#g8-ad-placement-pc_side_head,\n.l-billboard_container,\n.l-jack__top_container,\n.track_mario,\na[data-track-nier-keyword=\"pc_stores_banner\"],\ndiv[id^=\"g8-ad-placement\"],\ndiv[style=\"margin: 30px 10px 10px\"] > h2.a-header--2:has(+ div[id^=\"g8-ad-placement\"]),\nheader ~ .c-richlp__wrapper",".footer__banners,\n.sidebar__section--ads,\n.takeover","#contents-main > section > div[style=\"text-align:center;\"] > div[style=\"text-align:center;\"]","#sidebar-right","div[style=\"width:400px; height:290px; background-color:#fff;\"]",".banner_area_300,\n.banner_area_728","a[id$=\"-banner\"]",".trvdp-box",".ad_toppage_top","iframe[id^=\"IFTG\"]",".ad-article-middle,\n.ad-toc-bottom,\n.moko-ad",".side_recomend_trac,\n.taboola-recommend-span",".itx-widget","#ad_above_comment_html","#ad-jack,\n.ad-pc-footer,\n.bbs-ad-content,\n.c-rectangle-ad-wrap,\n.review_amazon_ranking_box,\n.review_amazon_ranking_container,\n.review_amazon_ranking_title,\n.walkthrough-ad-ranking-game,\n.walkthrough-hikari > div._area > a:not([href*=\"gamewith.co.jp/\"]),\ndiv[class$=\"adWrapper\"]",".superBnrBox",".p-banner-wrap","#HTML16,\n#home-ad-top1,\n.adiframe-wrapper-post-bottom,\n.adimage-wrapper-sidebar",".home_secondry_feature_bnr_ul > li.large",".w-afterRelated",".side-widget-area","#PC_SP_NEWS_D_GROUP,\n.PC_NEWS_D_PC_ONLY","div > div > p[style=\"margin:0; text-align:center;\"],\ndiv[style$=\"0; float:left;\"] > p[style=\"margin: auto; text-align:center;\"]","#ccw_sp_article_header_wrapper","#jp_gn_resp_article_inarticle_fundo,\n#pc_all_left_1st,\n.bal_insert_ad,\n.custom-html-widget > center > a[target=\"_blank\"] > img,\ndiv[id^=\"resp_\"],\ndiv[style=\"min-height:215px;margin:20px;\"]",".ad-pc-top,\ndiv[id^=\"jp_cgn_\"]",".m-listitem--ad",".game_info:has(> .game_amazon),\n.gc_ad","#gz-recommendedBottom-outerAd,\n#sideCxItem_bottomRanking,\n.bnL,\n.gz-entryDetail-footerItem,\n.s-body-ad,\n.s-body-ad-wrapper,\ndiv[id^=\"article-inner-cxad-\"]",".araklet",".inner-buy-box","#other,\n.a-img_add_header",".one_banner",".adClear",".ad_comment,\n.similar_ad",".advert","#async-ad_line3,\n.adlinefoot,\n.bnrBox01,\n.jboxbottom",".newentry_in > li.cf:not(:has(> a))","iframe[src^=\"https://proto2ad.durasite.net/\"]","section[class^=\"LinkBannerWrapper\"]",".prt-ad-banner","div[class^=\"_taxel_ad_article\"]",".tp-backdrop,\n.tp-modal","#advertising",".kokoku-area",".bl_main__add",".footbnr",".content5:has(#top_banner_7_list)",".sec_12:has(> div.wrap > div.kk_banner)","#gt_sp_all_footer,\n#gt_sp_all_header",".mainbody-ad-top,\ntable[width=\"750\"][height^=\"3\"]",".hk-pc-column-margin > section:has(.hk-ad-wrap)","#ads336,\n#adsense-content-unit,\n#h-superbanner,\n#main-contents > article.post-box.dnm,\n.parallel,\n.widget-right.widget_sp_image:not(#widget_sp_image-60),\n.widget-right.widget_text:has(a[href^=\"https://www.amazon.co.jp\"])",".wp-block-stk-plugin-cbox-notitle","a[target=\"_blank\"][rel^=\"nofollow\"][href*=\"ad\"]",".oAdBannerWithText,\n.oGoogleAdSpQuestions300x250",".entry-content > div[align=\"center\"] > p:has(> script[src^=\"//xml.affiliate.rakuten.co.jp/\"]),\n.entry-content > div[align=\"center\"] > p:has(> script[src^=\"//xml.affiliate.rakuten.co.jp/\"]) ~ p,\n.entry-content > p:has(> a[href^=\"http://x4.namidaame.com/\"])",".ad-in-entry-block","#bottom-editarea","#my-footer > div[style=\"text-align:center\"]",".size_b12","#adFooter,\n#entryBottomAd",".p-article__adTop",".adsense-middle",".stickyFooter",".box-header",".box-top","#secondary > .widget_sp_image","#bottom_bnr,\ntd[width=\"787\"]",".alignce > p",".adPCDoubleWrap,\ndiv[class^=\"ad\"][class*=\"Rectangle\"]",".sideAD",".p-topAd","#top_kokoku","#sidebar2 a[href^=\"/adv/ba.php\"]",".fixed-ad-wrap","#koukoku",".top-footer-banner",".kokokuMod",".content6_wrap",".article__contents > p:last-child:has(> .adsbygoogle),\n.sideCustomBlock__inr > .sideChoiceBlock:has(> .sideChoiceBlock__inr > .sideChoiceBlock__list > a.banner__link)","#st_custom_html_widget-149",".ad-sub","#side > div.sidewrapper[style^=\"width: 218px; margin-bottom: 0px; position:\"] a[target=\"_blank\"] > img,\n.abanner,\n.entrybody > blockquote:has(> .amazon),\nbody .abox","div.bg-white.text-center",".shitennoji-banner-js,\n.shitennoji-big-banner,\n.top_recent_article[style=\"display:block;\"],\ndiv[class*=\"adsense\"]","#main > aside.aside-content:has(> section.ad-section)","#admokuji",".media-ad",".c-article-ad","div[id$=\"_DFP\"]",".inread-banner",".amz-outline,\n.koruri.brown-link,\n.widget_fleximag_responsive_image_ad,\nins.adsbygoogle",".ad-right-rail-native-ad,\n.entry__right-rail-width-placeholder,\n.leaderboard-flex-placeholder,\n.right-rail-sticky__native-ad-container",".VcAdvertisement,\n.wp-block-ve-advertising",".tag_300,\n.tag_468,\n.tag_728,\n.tag_dummy","#topsadbg","#top_koukoku_banner","#adBanner","#banner-area",".banner-wp","#_popIn_recommend_top_1 + br + .bnrs.w340,\n.l-ad3,\n.post-body > div[style=\"border:solid\"],\n.textad_box,\ndiv[id^=\"ibaraki_pc_article_underarticle_\"]",".adsence_sp",".post-box-ad",".c-ads-box","[class*=\"-chumoku\"]",".entrybody > div[style=\"min-height: 170px;\"]",".floating-banner",".brick-ads,\n.brick:last-child:has(> div.items-scrolling > ul.items-goods > li > p > a.ga-buy)",".add01","div[style=\"margin-top:7px; height: 260px;\"]","#banner_pr,\n#custom_html-44,\n#jack_wrapper > div[id^=\"jack\"],\n.app_banner > a:not([href^=\"https://iphone-mania.jp/\"]),\n.fluxoverlay__wrapper,\n.pr_single_txt,\n.search + div#sidebar_right_menu,\n.single_pr_ad_all",".spmode[style$=\"width:620px;\"]","div[id][style=\"height:250px; width:300px;\"]","body .ad-block",".--wid.m-article-3colm:last-child:has(> div.m-article-3colm-list > div.ad-block),\n.ad-article-bottom-rectangle,\n.ad-fullscreen-wp,\ndiv[style=\"min-height:150px;\"]",".billbord,\n.web-advertising",".aBnr","#top_koukoku_wrap","#randomad",".bnrContent","a[id^=\"ad_\"][id$=\"03\"]",".ab-ad-area",".article-body-more > br ~ div[style]:has(> div > a[href^=\"https://amzn.to/\"])",".post-group > div.flex-row-center:has(+ div[data-gmoad]),\ndiv[style^=\"margin: 0px; padding: 0px; border: 0px; z-index: 999; position: fixed;\"]",".ads_wraptop2",".adsmain,\np[class^=\"adsn\"]",".p-adsense-in-list,\n.p-adsense-list-right-column-high-block,\n.p-custom-search-ad,\n.u-margin-xl-t > .u-margin-m-b[style^=\"height: 300px;\"]",".archive__item,\n.articleList__item:has(> div[id^=\"_popIn_infeed\"]),\n.article__ads","#st-header-cardlink-wrapper",".csw-content-box:has(> div.csw-content-footer > span.csw-ad-icon)",".mainColumnBannerArea","td[align=\"center\"][height=\"250\"]",".--pr,\ndiv[class^=\"dfp-\"]",".ad-col2","div[style=\"min-height:280px;margin-bottom:25px;\"]","#side > div.sideContents > div.amzimg,\n.entry:has(#gInactiveAdContainer),\n.top-ad__wrapper--center","#block-17,\n#media_image-8,\n.sideCustomBanner",".cmn-summary-1:has(> div[id^=\"div-gpt-\"])",".bg-ash-200[style=\"height: 94px;\"],\ndiv[style=\"clear:both;height:90px;\"],\ndiv[style=\"clear:both;overflow:hidden;max-height:90px;min-height:90px;\"]",".justify-center.pt-6.pb-22:has(> div[id^=\"div-gpt-ad-\"])",".bgkokoku","#content > div[style=\"margin:0px auto 4em auto;width:100%;height:auto;\"],\n.w-beforeRelated","#header1 > div[style=\"float:right;font-size:14px;line-height:16px;margin-right:10px;\"],\n#kakijun_books,\n.gadcenter","div[class^=\" Gap_size\"] > div[class^=\"Layout_\"]:has(> div[class^=\"Ad_ad_\"]),\ndiv[class^=\"widget-ad-\"],\ndiv[id^=\"work-ad-\"]","#ad_right_bar_top,\n#pc-overlay-base,\ndiv[id^=\"overlay_ad_\"]",".right-col > .side-multiline-html-area:has(img[src*=\"/banner_\"])","#main.contents div[class^=\"section_\"]:has(img[src^=\"/www/banner/images\"][src$=\".gif\"])",".m-bnr-inner","div[id^=\"bnAdvertisement\"]","#unit-159518","#block-top-billboard-1st,\n.blk-bnr02,\n.list-ranking01-bottom,\n.top-head-bnr",".entry-footer-html > div.entry-footer-html",".borderTop.pr.list_carousel",".ct-ad-wrap","#article-list > li:has(> div > iframe[width=\"300px\"][height=\"250px\"]),\n.list-group-item:has(> .pr),\n[class*=\"-ads\"],\ndiv[style=\"min-height: 256px;\"]","div[style=\"min-height: 280px;\"]",".book-tiles","#footer_adbanner,\n.adLandscape,\n.adResponsiveDisplay","#top_banner_koukoku",".sdr-banner","article[data-clarity-region=\"article\"] > center","#myPaymentModal,\ndiv[class$=\"iframe-ad\"],\ndiv[class$=\"word-ad\"],\nheader > div[id^=\"payment\"]",".adbox_pc",".l-main > div#category_list + section.l-section",".ban.r_menu","#adinfo","#side-kp-bnr-area1","#postAds_Wrap","#page_article_area > ul > li:has(> div[id^=\"div-gpt-\"])","div[class^=\"ad_area\"]","#geniee_overlay,\n.p-article-container__main > div[style=\"display: flex; justify-content: center;\"] > a[style=\"width: 100%;\"],\n.u-bg-dgray.c-section",".single_bnr_wrap",".rectangle_wrap",".meta_candy_description p[style=\"text-align: center;\"] > strong",".add-container,\n.box:first-child","a[onclick^=\"ga(\"][onclick*=\"banner\"]","#top_banner_kokoku",".recipe--detail-bannerarea,\n.side--banner-app,\n.side--logly","table[style=\"border:1px solid gray;\"][width=\"320\"][height=\"562\"],\ntable[style=\"border:1px solid gray;\"][width=\"610\"][height=\"450\"]","#ttop_prZ,\ntable[style=\"border:1px solid gray;\"][width=\"610\"][height=\"440\"],\ntd[colspan=\"3\"][valign=\"top\"] > table[style=\"width:950; height:270; border:1px solid gray;\"]",".page-body-side > div.ad-unit:first-child,\ndiv[style^=\"position:fixed;bottom:0;left:0;right:0;width:100%;background:\"]","#main_head_ad,\n.plugin-memo > div.side > div.amzimg,\n.plugin-memo:has(> div.side > a[name=\"amazletlink\"]),\n.plugin-memo:has(> div.side > center > a[name=\"amazletlink\"]),\n.plugin-memo:has(> div.side > div.amazlet-box)",".amazon01 + div[style=\"border:1px solid #1c7db3;margin:50px 0 10px;\"],\n.article_inline_ad_more,\n.top-article-ad","#side_l > aside > div.sidetitlebody:first-child,\n.popup_wrap",".article-body > div.rec-title,\n.article-body > div:not([class]) > a[href^=\"https://amzn.to\"][target=\"_blank\"],\n.salebox,\ndiv[style=\"border: 5px solid #008b8b;  box-shadow:0px 0px 5px; border-radius:8px; margin:5px 7px 15px 7px;\"],\ndiv[style=\"text-align:center; font-size:12px;\"]",".article-body-inner > table:has(> tbody div[class^=\"google-user-ad-\"])",".age,\n.kanren > dl.clearfix:has(a[href^=\"https://leaked.jp/1\"]),\n.kanren > dl.clearfix:has(a[href^=\"https://leaked.jp/d\"]),\n.kanren > dl.clearfix:has(a[href^=\"https://leaked.jp/f\"]),\n.kanren > dl.clearfix:has(a[href^=\"https://leaked.jp/k\"]),\n.kanren > dl.clearfix:has(a[href^=\"https://leaked.jp/smuc\"]),\n.st-labelbox,\n.st-mcbtn-box",".st-BottomBanner-top",".home-p-ads",".pr_banner",".bun-bannerpublicityBox2","#tmp_banner","#tmp_idx_publicity",".ItemList_Banner","#fixedAdv,\n.banner-sec",".rs_skip","#banner-advertisement","#link_box",".boxSideBnrArea","#top_kokoku_bg",".advertising-area",".top_banner8,\n.top_banner9",".footer_banner",".adv-area-wrapper",".koukoku-area","#tmp_rnavi_bnr,\n.sec_related",".banner_area","div.slide_link + div.wrap > div.aside",".banner2Mod > #randomBanner,\n.banner2Mod > #randomBanner + .list,\n.banner2Mod > #randomBanner + .list + .link","#tmp_advert_items,\n#tmp_banner_ads","#top_banner_7",".k-koukoku","#sadwrap",".kokoku_wp","#float_banner",".under-banner","#bnr_content","#BannerArea",".sadbg","#banner-pr",".top_sec03_r_box:has(> div > script[src=\"/js/banner.js\"])","#banners","#frame-banner-advertisement","#tmp_advertisement","#banner_frame","#adbanner","#fBanArea",".kokoku_n_wp",".kokoku-sec","#tmp_advert",".section-advertise","#aside_banner","#top_koukoku",".bnr_area",".container06_wp,\n.kokokubg","#top_banner_footer",".Item_List_adspace","#FooterPane > div.ItemList_Standard","#FooterPane > div.Item_normal",".tkokoku","#sponsor_banner","#adBannerArea",".block-banner","#top_banner_wrap","#police_banner_kokoku_list_wrap,\n.footer_banner_box",".kokoku-wp",".Item_tf_koukoku","li[id^=\"native-\"]",".bfapickup","#js-gtmAmazonSale,\n[class][data-ranking=\"amazon\"],\na[class^=\"articles_pArticles_HeroLink\"]:not([href]),\ndiv[class*=\"bodyAd_BillboardAd\"],\ndiv[class^=\"articles_pArticles_List_\"] > a:not([href]),\ndiv[class^=\"bodyAd_\"],\ndiv[class^=\"cxenseAd_\"],\ndiv[class^=\"ownedMediaAd\"],\ndiv[class^=\"styles_pBanner_\"],\ndiv[class^=\"styles_sBanner__\"]","#js-Columns-col-inner > div[style=\"min-height: 160px;\"],\n.Columns-col--size300 > div[m-section=\"top:large\"]:has(> script),\nli[id^=\"js-rankingIdeasAds\"]",".google-user-ad","#YDNA,\n#YDNB,\n#ad_tsuibi_1,\n#ad_tsuibi_2,\n#article-options > div.inline-block_2,\n#container > center > table > tbody > tr > td > a[href*=\"dmm.co.jp/\"],\n#content-inner2 > a[href^=\"https://affiliate.suruga-ya.jp\"],\n#fixR,\n#links_left div.plugin-memo:has(> div.side > table a[href^=\"https://al.dmm.co.jp\"]),\n#linksbody > div.plugin-memo:has(> div.side > div > small > a[href^=\"https://www.amazon.co.jp/dp/\"][target=\"_blank\"]),\n#linksbody > div[align=\"left\"]:has(> a[href^=\"https://www.amazon.co.jp\"][target=\"_blank\"]),\n#main > div.column-inner > div.column-inner-2 > a[href^=\"http://www.dlsite.com/maniax/dlaf/\"],\n#more > a[href^=\"https://www.amazon.co.jp\"][target=\"_blank\"],\n#pickrightcon > .right-container-ads,\n#random-product-container,\n#sidecolumnbody > a[href^=\"https://hb.afl.rakuten.co.jp/ichiba/\"],\n#sub > div.column-inner > div.column-inner-2 > a[href^=\"http://www.amazon.co.jp/\"],\n#sub > div.column-inner > div.column-inner-2 > a[href^=\"https://amzn.to\"],\n#third > a[href*=\"dlsite.com/maniax/dlaf/\"],\n.LargeImage.amazon,\n.MediumImage.amazon,\n.adArea2,\n.adArea3,\n.admore,\n.adplace,\n.ads_more ~ .article-main2 > div[style*=\"margin:\"][style*=\"#\"]:has(img[src*=\"amazon.\"]),\n.adsencewaku,\n.adsencewaku2,\n.afi-style1,\n.article ~ a[href^=\"http://www.amazon.co.jp/exec/obidos\"],\n.article-body > div.inline-block_3,\n.article-body-inner > a[href^=\"https://affiliate.suruga-ya.jp\"][rel=\"nofollow\"] > img,\n.article-body-inner > a[href^=\"https://px.a8.net/svt/ejp\"],\n.article-body-inner > a[href^=\"https://px.a8.net/svt/ejp\"] ~ img[src^=\"https://images-na.ssl-images-amazon.com/images/I/\"],\n.article-body-inner > br + a[href^=\"https://www.amazon.co.jp/\"][target=\"_blank\"],\n.article-body-inner > div > table[style=\" border:1px solid #ccc; width:150px;\"],\n.article-body-inner > div#more > a[rel=\"noopener sponsored\"][href^=\"https://www.dlsite.com/maniax/dlaf/\"],\n.article-body-inner > div.article-body-more + p[style=\"”font-size:5pt;\"] + center,\n.article-body-inner > table[cellpadding=\"0\"] > tbody > tr > td > div[style=\"border:1px solid #000000;background-color:#FFFFFF;margin:0px;padding-top:6px;text-align:center;overflow:auto;\"],\n.article-body-inner > table[height=\"250\"][width=\"700\"],\n.article-body-inner > table[style=\"color:darkblue; background-color: #FFFFFF\"][width$=\"570\"][border=\"1\"],\n.article-body-more > a[href^=\"https://al.dmm.co.jp\"][target=\"_blank\"],\n.article-body-more > b > strong > a[href^=\"https://al.dmm.co.jp\"],\n.article-body-more > div > a[href^=\"https://al.dmm.co.jp\"][target=\"_blank\"],\n.article-body-more table:has(> tbody > tr > td > link[href^=\"https://pdn.adingo.jp/\"]),\n.article-footer + div[style=\"font-size:16px;font-weight: bold;margin:10px 0 10px 0;\"],\n.article-outer-3 > div.article-body > a[href^=\"//ck.jp.ap.valuecommerce.com/servlet/referral\"][target=\"_blank\"],\n.article-outer-3 > div.inline-block_1,\n.article-outer-3 a[href^=\"https://www.amazon.co.\"][target=\"_blank\"][rel=\"nofollow\"],\n.article-outer-3 div.article-body-more [style] a[href^=\"https://www.dlsite.com/\"][rel$=\"sponsored\"],\n.article-outer-3 div.article-body-more a[href^=\"https://affiliate.suruga-ya.jp/modules/af/af_jump.php\"][rel=\"nofollow\"],\n.article-outer-3 div.article-body-more a[href^=\"https://al.dmm.co.jp/\"] > img.pict,\n.azlink-box,\n.blogbody > div.main > table[width=\"500\"]:not([height]) a[href^=\"https://www.dmm.co.jp\"],\n.column-inner-2 > a[href^=\"https://www.amazon.co.jp/\"][target=\"_blank\"] > img[src^=\"//ws-fe.amazon-adsystem.com\"],\n.column-inner-2 > div[style=\"margin:0;padding:5px;font-size:12px;word-break: break-all;\"] > a[href^=\"http://www.dmm.co.jp\"],\n.column-inner-2 > div[style=\"margin:0;padding:5px;font-size:12px;word-break: break-all;\"] > a[href^=\"http://www.dmm.co.jp\"] + p[style=\"margin:5px 0 0 0;padding:0;color:#8c8c8c;font-size:10px;\"],\n.fluct-2ad,\n.google-user-ad-bottom,\n.kiji .menu_cont3[style=\"text-align:center\"] > table[width=\"100%\"][border=\"\"],\n.kiji .menu_title3:has(+ .menu_cont3[style=\"text-align:center\"] > table[width=\"100%\"][border=\"\"]),\n.kiji > .article_main > div.krb-amzlt-box,\n.kijiadleft2,\n.kijinakakoukoku,\n.kiziue > #product-container,\n.left-container > .left-column-inner > center,\n.left-container > div.plugin-memo:has(> div.side > div.amakuri-undertext),\n.plugin-memo > div.side > a[href=\"http://game-news.biz/pc/sumato/god_game/\"],\n.plugin-memo > div.side > a[href^=\"http://v-fox.net\"],\n.plugin-memo > div.side > div.g-rank,\n.plugin-memo > div.side > div[align=\"center\"] > small > a[href^=\"https://www.amazon.co.jp/dp/\"],\n.plugin-memo > div.side > table[border=\"0\"] > tbody > tr > td > div[style$=\"width:280px;margin:0px;padding:5px;text-align:center;overflow:hidden;\"],\n.plugin-memo:has(> div.side > a[href^=\"//ck.jp.ap.valuecommerce.com\"]),\n.plugin-memo:has(> div.side > a[href^=\"http://hb.afl.rakuten.co.jp/hgc/\"][target=\"_blank\"]),\n.plugin-memo:has(> div.side > a[href^=\"http://www.e-nls.com/access.php\"][target=\"_blank\"] > img),\n.plugin-memo:has(> div.side > p > a[href^=\"http://www.amazon.co.jp/exec/\"][target=\"_blank\"][rel=\"nofollow\"] > img),\n.popularArticleWithImage > div > a[href^=\"https://www.mgstage.com/product/\"],\n.right-column-inner > a[href^=\"http://www.dmm.co.jp/netgame_\"][target=\"_blank\"],\n.right-container > table[style=\"color:darkblue; background-color: #FFFFFF\"][width$=\"305\"][border=\"1\"],\n.right-container-ads > a[target=\"_blank\"],\n.sponsor_side_body,\n.t_b > div > a[href^=\"https://al.dmm.co\"],\n.t_b > div[style=\"margin:0;padding:5px;font-size:12px;word-break: break-all;\"] > p[style=\"margin:5px 0 0 0;padding:0;color:#c00;font-weight:bold;\"],\n.t_b ~ a[href^=\"https://www.amazon.co.jp\"],\n.t_b ~ div > a[href^=\"https://al.dmm.co\"],\n.t_b ~ div > a[href^=\"https://www.amazon.co.jp\"],\n.t_b ~ div[style=\"margin:0;padding:5px;font-size:12px;word-break: break-all;\"] > p[style=\"margin:5px 0 0 0;padding:0;color:#c00;font-weight:bold;\"],\n.yms-user-ad,\na[href*=\"ad-feed.com/link/click\"],\na[href*=\"ad-nex.com/link.php?\"],\na[href*=\"https://makoto-store.com/adwords/\"],\na[href=\"https://xn--nckya3f3d.com/htaikenn\"],\na[href^=\"http://sma-p.com/link.php\"],\na[href^=\"http://sp.pun-c.jp/\"],\na[href^=\"http://www.corelive-s.com/\"],\ncenter > table[width=\"600\"][height=\"300\"][bgcolor=\"#778899\"],\ndiv[class*=\"-outer\"] div[class^=\"article-body\"] > a[style^=\"word-break: break-all;\"][href^=\"https://affiliate.suruga-ya.jp/modules/af/af_jump.php\"][rel=\"nofollow\"],\ndiv[class*=\"-outer\"] div[class^=\"article-body\"] > a[style^=\"word-break: break-all;\"][href^=\"https://al.dmm.co.jp/?\"][title],\ndiv[class*=\"-outer\"] div[class^=\"article-body\"] > a[style^=\"word-break: break-all;\"][href^=\"https://www.dlsite.com/maniax/dlaf/\"][rel=\"noopener sponsored\"],\ndiv[class*=\"-outer\"] div[class^=\"article-body\"] span[style=\"font-family: \\\"MS PGothic\\\";\"] > a[href^=\"https://al.dmm.co.jp/?\"],\ndiv[class*=\"-outer\"] div[class^=\"article-body\"] span[style=\"font-family: \\\"MS PGothic\\\";\"] > a[href^=\"https://www.dlsite.com/maniax/dlaf/\"][rel=\"noopener sponsored\"],\ndiv[class^=\"article-body\"] > div > span[style=\"font-family: \\\"MS PGothic\\\";\"] ~ div:not([class]) a[rel=\"noopener sponsored\"][href^=\"https://www.dlsite.com/maniax/dlaf/\"],\ndiv[class^=\"article-body\"] > div:not([class]):not([id]) > a[style=\"font-family: \\\"MS PGothic\\\";\"][target=\"_blank\"][rel=\"noopener sponsored\"],\ndiv[class^=\"article-body\"] > div[style=\"border-top:1px dashed #c0c0c0; margin-top:30px; padding:10px;\"] ~ a[href^=\"http://www.amazon.co.jp/exec/\"][target=\"_blank\"][rel=\"nofollow\"],\ndiv[class^=\"article-body\"] > div[style=\"font-family: \\\"MS PGothic\\\";\"] > a[href^=\"https://al.dmm.co.jp\"],\ndiv[class^=\"article-body\"] > dt.net[id] > span[style=\"background-color: rgb(255, 255, 255); font-size: 68.75%;\"] > div[style$=\"word-break: break-all;\"],\ndiv[id^=\"im-\"] + br + div.main-container-ads,\nth > a[href^=\"https://www.dlsite.com/maniax/dlaf/\"] > img.pict,\ntr > th > a[href^=\"https://al.dmm.co.jp\"][target=\"_blank\"]","#headlineBanner,\n.bannerRectangle","div[style$=\"height:90px; text-align:center\"]","#billboard,\n#bottom-banner,\n#post_content_banner","#header-banner","#top-footer-banner",".fbnr-area,\n.pr-txt-area,\n.top-fbnr-area","body .contents_ad",".bnrArea,\n.connection-post-ad,\n.new-post-advertisement","section[class*=\"posts-ad\"]",".ranking-item[data-rank=\"PR\"]",".AdsWidth","#bodyFrame > span[style=\"font-size:small;color:#939393;\"]","#undrep_category_block",".articleShow__nativeAd",".p-rotation-banner,\n.p-sub-banners",".freebox,\n.side-topad > .widget_text",".modfortuneSign","aside > div[style^=\"min-height\"]",".jobs-section,\n.layout-main > div.module-ad,\n.module-ad:has(> div.module-ad__item > div[id^=\"mn\"]),\n.module-ad__item,\ndiv[id^=\"mn\"]",".module-ad-header,\n.module-list-articles__ad",".kanren-under-ad-title,\n.more-ad-title",".ads_336,\n.ads_336x280","#index-remarkable,\n.ad-bnr-w300h250,\n.container + div.container.column-2.print-nodisp,\n.container-ad,\n.title-ad-sp,\naside[class^=\"ad-\"],\ndiv[id^=\"ad-pc-channel-infeed_\"]",".ad-infeed",".ad-super-banner-bottom","#bottomBanner",".p-article-middle-ad,\n.subarea-ad",".adarea01",".recommend_list > ul > li.cf:has(i.pr)","div[class^=\"Article_ad__\"]",".ad-fb,\n.ad-microad,\n.ad-rec,\n.ad_label_text,\n.article__inner > .ad_text + aside[style^=\"width:\"],\ndiv[style=\"width:300px;height:600px;\"]","div[class^=\"article\"] > div.mgnT60.mgnB60",".l-superbanner","aside[id^=\"mc_widget_\"]","#col_content > div.footer_content:has(> div.ads)","#footeradv,\n.pc_header_bottom_adv",".adv_bottom","#wide_scraper",".c-adBanner,\n.c-adBottomOverlay,\n.c-adDisplay,\n.p-topArticleList__item--ad",".ad-trend-topic-more-photo",".vc_widget_sidebar","form[action=\"https://www.google.co.jp/search\"] + div.row",".ext_text","#gads_p_bottom,\n#gads_p_top",".logly-lift-ad:last-child",".inarticle-ad,\n.post-foot-ad",".box[style=\"min-height:900px\"]","[id^=\"gtm-\"]","#sidebar,\n.post_content > div.swell-block-button + h4.wp-block-heading + p,\n.swell-block-button:has(> a[href^=\"https://live.fc2.com/adult/?afid\"]),\n.w-frontBottom,\n.wp-block-latest-posts + div.wp-block-image.u-mb-ctrl,\n.wp-block-latest-posts + div.wp-block-image.u-mb-ctrl + p.has-text-align-center,\nh4.wp-block-heading:has(+ div.pcolle-parts),\nh4.wp-block-heading:has(+ p + center)",".p-toppage__koukoku",".AdBnrList",".u",".orange",".articleRankingBlock__link[href^=\"https://k.zucks.net/\"]",".adsense-related-box,\n.txt_ad","#ad1201_wrapper,\n#stock_header_contents > div[class=\"min-h-[120px]\"],\n.h120p,\n.min-h-\\[316px\\].max-w-\\[300px\\],\ndiv[data-controller=\"footer-overlay\"],\ndiv[id^=\"v-ad-hide\"]",".l-side_section:first-child","div[class^=\"ad_hide\"]",".admodal",".comarea",".ad_hide,\n.pageCon_ad","div[data-controller=\"advertisement\"]","#layout > div#layout + div > div.relative,\n.max-w-xs.my-2\\.5.min-h-\\[146px\\]",".mod-adsenseSearch,\n.mod-listRanking-list__ad,\n.mod-section > .tx-ac > a[target=\"_blank\"],\n.mod-section > h2.mod-title1:has(+ .tx-ac > a[target=\"_blank\"]),\ndiv[class^=\"mod-jyukuSearchAd\"]",".ads300\\*250,\n.ads730,\n.thumbnail-list > li:is(:has(> div[id^=\"div-gpt-ad-\"]), :has(> .ads))","#_popIn_recommend + #related2,\n#_popIn_recommend2,\n.my_adslot_top2_div",".footer > div[style=\"\"]","#footer-widget-left",".COMMUNITY_bodyArea__subArea > .adBanner:first-child + .COMMUNITY_rightAreaBox",".NEWS_recentTopicsList__itemAd",".side-add",".footer_banner_wrap",".advertise_inner",".ft-bnr","#top_photo_banner",".bnrWOut","p[style=\"”font-size:5pt;\"] + center","#article-follow-sidebar > aside.uqmobile-recommend_box,\n.ad_bk-news_rakuten-mobile_recommend,\n.head_unique_btn,\n.header-follow-linecv","#advarea",".css-6a6dbz","table[style$=\"width: 300px;\"]","div[id^=\"ad_pos\"]",".newItemList > li:has(> ins.adsbygoogle),\n.newItemList > li[style=\"flex-basis: 100%; background-color: white;\"]","li.mb10:has(script.optanon-category-ad)",".st-Block > div[style^=\"min-height:\"]","#overlay-box-all,\n.banner-pr",".pickupBlock,\n.specialBlock",".a-external-banner--rectangle,\ndiv[class^=\"m-external-banner\"]",".pcbill,\n.widget-sidebar-standard:has(> div > div.squareb)","#adarea_banner,\n#newrelease_adBox,\n.jack,\n.page_adArea,\n.rect_box,\n.topRank_adBox_resp,\n.top_ad,\n.top_adBox,\ndiv[class^=\"special_adBox\"]","#sidemenu > dl.sidemenu_body:first-child,\n.entry_body > p.ichiran,\n.fc2_footer2 + script + div[id],\na:not([href]):not([class=\"lb-cancel\"]:empty):not([class=\"lb-close\"]:empty),\na[href*=\"://www.dlsite.com\"],\na[rel*=\"sponsored\"]",".ad-management:not([data-key=\"default__single__main_after\"])",".box-advertise,\n.box-detail__ads,\n.box-reviewerad,\n.innerAD",".bl_adSPWrap,\ndiv[style^=\"margin: 20px 0;\"],\ndiv[style^=\"padding-top:10px;  padding-bottom: 10px\"][style*=\"min-height\"],\ndiv[style^=\"padding-top:10px; padding-bottom: 10px; text-align: center; min-height: 270px\"]","#ads-w,\ndiv[style=\"width:100%;text-align:right;margin-top:20px;margin-bottom:4px;\"]",".bnr li:has([alt*=\"[PR]\"])",".dti_ad",".dsp-in-block,\n.p-recommendedArticle",".entry-content-wrapper > div.avia-builder-widget-area",".ad-bg-1,\n.categories-advertisements,\n.news-articles-show-footer > div.-h3:has(+ div[id^=\"logly-\"]),\ndiv[style=\"min-height: 100px; margin: 20px auto; text-align: center;\"]","#ad300250","#inc_rakuten_shopping,\n#inc_yahoo_shopping",".rect",".articleBnr_ydn,\n.articleList-along,\n.articleList-attention,\n.articleSns ~ .articleBnr_list,\n.box-warp > a[href^=\"//ck.jp.ap.valuecommerce.com/servlet/referral\"],\n.c-sideBanner,\n.c-sideBanner_articleBottom,\n.c-sidePickup,\n.follow_cv_eye-catcher,\n.headerBillboard","#osn_pc_article_underlist,\n.OSN_container,\n.content_widget",".is-banner:not(#shindan_top_sns_area),\n.is-recommended,\n.is-recommended + section.p-aside-section,\n.is-side-sponsored,\n.is-sponsored,\n.l-main > .p-aside-section:has(> div > div > div > div[id^=\"div-gpt-\"])","#submenubar,\n.google3","div[class^=\"top_kokoku_\"]","#c_bnr","#ad-side_top,\n.lo-main > aside:last-child","#adblock_guide_mask,\n.adblock_guide_box","#ad_clickcount_pitcure,\ndiv[style=\"margin:10px 0\"] > a[href*=\"utm_medium=text\"]",".ItemList_Advertising","ad[content-type=\"adsbygoogle\"],\ndiv[style=\"clear:both;padding-top:1em;text-align:center;\"]","div[class^=\"napbiz_ad\"]",".big_banner,\n.kyosan_content","[id^=\"div-M_MD_inf_fluid_\"],\nsection > div.bannar_area:only-child","[id^=\"div-M_MD_gtx_fluid_\"],\ndiv[style=\"min-height:300px;\"]",".ppg-panel__item:has(> div.ppg-panel-figure > div.ppg-panel-figure__inner > div.ppg-panel-figure__image--ad),\n.text_c[style=\"height: 50px;\"],\ndiv[style=\"min-height: 600px;\"]","div[style=\"min-height: 300px;\"]","#spNonDispSuperBannerArea","div[id^=\"div-M_MD_kiji_fluid_\"]","#h_bar,\n#join-bnr,\n#pr-link,\n.bl-top-square","#s_salon > div[style^=\"width:calc(\"]",".indexContents > div.indexContentsright:has(> div#googleadd)","#mobile_top_bnr,\n.biglobeBanner,\n.post-top-banner","#SPbanner,\n#gadsOverlayUnit,\n.inarticle-recommend,\n.news-cpl",".popin,\n.recommend-posts,\n.sidebar-ad + .sidebar-hr","#googleTop",".lottery-result-ad",".site-promo > div.site-promo",".ad_rectangle_article,\n.ad_rectangle_article_outer,\n.recommended_top",".sp-above-article-title","#ad-container","div[id*=\"Advertisement\"],\ndiv[id^=\"companies-detail-banner-ad-\"]","#smt_rec_dcmatch_1,\n.dgame",".ad200x200,\ndiv[class^=\"adbox_\"]","body > div[align=\"center\"] > table[border=\"0\"][cellpadding=\"1\"][cellspacing=\"0\"][width=\"700\"]",".list_row3_ad_2column",".ad-horizontal-wrapper,\n.game-ad,\n.game-ad-bottom,\n.game-list-ad","div[class^=\"adInfeed\"],\ndiv[class^=\"adMiddleRectangle\"],\ndiv[class^=\"adRecommend_\"]",".NR-ad,\n.NR-pr",".ads_h250,\n.ads_h253","#mod-freearea-main:has([id^=\"gooad-\"]),\n.article__banner,\n.mod-entry-set-goo-ad,\nbody > div[style^=\"height: 70px; position: fixed; z-index:\"]",".gn-partition.sp-padding15,\ndiv[class^=\"gooad_\"]","#gheader,\n.sponcer,\ndiv[style^=\"margin:20px\"][class=\"clearfix\"]",".addArea","#sticky_adsense,\n.main-ranking > dd > ul > li:has(> div.NR-ad),\ndd > ul > li:has(> div.NR-ad-ranking)",".l-browsi","#sj_side-banner,\ndiv.clearfix[style^=\"margin-top:20px;min-height:2\"],\ndiv[style=\"margin-top:20px;min-height:250px;\"],\ndiv[style=\"margin: 1em 0 0; min-height: 90px; display: flex; justify-content: center; align-items: center;\"]","div[class^=\"entry-ad-\"]","#entry-comment-footer-ad,\n#entrylist-ad-right-top,\n.centerarticle-aside-ad,\n.comment-header-ad,\n[class^=\"entrylist-ad-\"],\nsection[id^=\"btop-curation\"]",".ad-edit-done-wrapper","#touch-footer-ad-placeholder,\n.sidebar-banner,\ndiv[id^=\"google_afc_\"],\ndiv[id^=\"touch-\"][id$=\"rectangle\"]","td[height=\"112\"][align=\"center\"],\ntd[height=\"126\"][align=\"center\"],\ntd[height=\"400\"][align=\"center\"],\ntd[height=\"640\"][align=\"center\"],\ntd[width=\"735\"],\ntd[width=\"75\"][height=\"35\"][align=\"right\"]","body > center > table[cellspacing=\"3\"] > tbody > tr:last-child,\ntable[width=\"145\"][border=\"1\"]",".c-box.ad",".s-banner-top,\n.s-flux-bottom","td[width=\"790\"][valign=\"top\"] > font[size=\"1\"]","#pr","#ffb_content",".contents_left,\n.contents_right","#mainLeft[style^=\"overflow: hidden; height\"],\n.t_sidebar_amazon","ul[class^=\"cmn-bnr-ad-list\"]","p > table[width=\"10%\"][cellspacing=\"10\"] > tbody > tr > td[valign=\"top\"] > div[align=\"center\"] > font[size=\"-1\"],\ntable[cellspacing=\"5\"][bgcolor=\"#FFFFFF\"] th[valign=\"top\"] > h3:has(> a[href$=\"ref=nosim/\"]),\ntd[width=\"100%\"][valign=\"top\"][nowrap][bgcolor=\"#B0BCFF\"] > div[align=\"left\"] > div[align=\"center\"],\ntd[width=\"100%\"][valign=\"top\"][nowrap][bgcolor=\"#B0BCFF\"] > div[align=\"left\"] > p[align=\"center\"]","table[class^=\"advertising_area\"]",".detail_footer_ad,\n.detail_header_ad","#text-17",".battleResultAD,\n.resultADFrame","div[class^=\"adContainer\"]",".ev-related-url",".banner-header",".kkkarea",".wprt-container > center,\ndiv[style=\"height: 250px;\"]","#bnrHead,\n#nw-associate,\n#sideAdPanel,\n#taboola-below-article-thumbnails-desktop-1,\n.ad-teads-nw-box","#left-contents > div.side-hc > dl + dl:nth-child(-1n+7),\n#right-contents > div.side-hc > dl:nth-child(-1n+4)","span[class^=\"subject\"]","div.widget:has(> div.dp_text_widget > p > ins.adsbygoogle)","#web_pc_prime,\n.Ads,\n.Ads728x90WebPcFooter,\n.PreVideoStartPremiumLinkContainer,\n.ads.leadBanner,\n.sub.column > div.ads,\n[aria-label=\"video - currentTime\"] + div[style^=\"left\"]",".ads_nicovideo","#right-column > div[style*=\"height:250px; width:300px;\"],\n.ad-bannar-maincolumn-top,\n.adsense-728,\n.article > div[style=\"margin-left: -4px;\"] + ul[style=\"margin-left: -4px;\"],\ndiv[id^=\"dic_sp_300x250_\"]","#side-banner-north,\n#side-banner-south,\n[class^=\"___billboard-ad\"],\na[href=\"https://www.eldoahfree.com/\"][target=\"_blank\"] > img,\naside[class^=\"___ad-banner\"],\naside[class^=\"___banner-ad\"],\naside[class^=\"___program-information-ad-area_\"],\ndiv[class^=\"___player-ad-panel\"]","#ads_pc_seiga_footer","#float-bnr-container","#billboard_container,\ndiv[style=\"width:auto;height:90px;margin:0 0 15px 0\"]","#ads_pc_seiga_illust_watch_east,\n#top_ads_box_middle,\n.level_ad",".siteWide-BannerAd","#web_pc_top",".koukokuWrap",".koukoku-box",".tag-box > div.series-img","div[id^=\"ad-gpt-\"]",".nishi-target:not(#block-3 > .nishi-target)","#im_panel_pcov",".partner_button",".bnr_wide,\n.new_ad_area","#side > div.inline-block",".article_sp_bottom_ad_container",".ad_list,\n.aside_banner_ad,\n.float_banner_container,\ndiv[class^=\"banner_box\"]",".readmore_area",".koukoku","#main .content_area:has(.banner_list a[href^=\"/adv/\"])","#top_sidebar1_banner,\ndiv[id$=\"_kokoku_wrap\"]",".wb-contents > .topaside:has(> tbody > tr > td > table.bnrtitle)",".branch_wrap",".ad_over_header,\n.ad_right_top,\n.ad_under_answer,\n.ad_under_question,\n.adfunnel_header_block,\n.adfunnel_list_under,\n.adfunnel_main_special_box,\n.adfunnel_right_inhouse,\n.adfunnel_special_box_pc,\n.adfunnel_special_box_pc_bottom,\n.adfunnel_special_large_under,\n.inhouse_banner,\ndiv[class^=\"sponser_ad\"]",".c-ad-box","div[class$=\"-down-ad\"]",".jackad-header",".gameRankingPr","div[class^=\"banner\"] > a:not([href*=\"://www.ja\"])","#mainContentInner > .prBannerArea",".sidebar-container > div.row.mb-6:has(> div.position-relative > p > a[href=\"/about/ad.html\"]),\n.top-pr",".l-bottomBanner,\np > iframe[width=\"336\"][height=\"280\"]",".box-pr-image-01","main > div.top_sec10:has(> div.top_sec10_container > ul.top_kokoku_wp)","#eiyoshikai_ad",".ggadsbordertxt","img[width=\"468\"][height=\"60\"]",".ninja_onebutton + hr + a[href^=\"http://www.amazon.co.jp/gp/aw/rd.html\"]","div[class^=\"column\"] > div.inner:has(> div[id^=\"div-gpt-ad-\"])","#_popIn_recommend_text",".l-pr",".l--spBanner,\ndiv[id^=\"taboola\"]","#banner_ad",".st-ad",".header-fixed-ad","#div-gpt-osdn_mag_rec-article-middle,\n#head-ad-text",".rightbar:last-child","iframe[src^=\"https://rcm-jp.amazon.co.jp/e/cm?\"]",".ad-aside,\nblockquote > a[href^=\"https://www.amazon.co.jp/\"],\nblockquote:last-of-type:has(> div.AmaQuick-box),\nblockquote:last-of-type:has(a[href^=\"https://www.amazon.co.\"]),\ndiv[class^=\"article-body\"] > center:has(> a[target=\"_blank\"] > img)","div[class^=\"gad-\"]",".header-box,\ndiv[style=\"min-height: 833px;\"]",".side-box",".col-xs-12 > p[style=\"margin-bottom:0px;\"]",".sidebar__yahoo",".categoryGamesPC > div[class^=\"css-\"] > div[class^=\"css-\"] > div[class^=\"css-\"]:has(div[id^=\"JP_PTG_\"]),\n.categoryGamesPC > div[class^=\"css-\"] > div[class^=\"css-\"] > div[class^=\"css-\"]:has(div[id^=\"JP_PTG_\"]) + p.chakra-text.css-0,\n.css-3wtq36,\n.gameDetail section[class^=\"css-\"]:has(> ins.adsbygoogle),\n.gameDetailSideBar > div > p.chakra-text.css-0,\n.home_carousel > div[class^=\"css-\"] > div[class^=\"css-\"]:has(div[id^=\"JP_PTG_\"]),\na[href=\"https://myhome-cloud.net/\"] > img",".big_image",".content_right > div > span[style^=\"display: block; font-size: 30px\"]:has(+ div#taboola-below-article-thumbnails),\n.content_right > div > span[style^=\"display: block; font-size: 30px\"]:has(+ div#taboola-below-article-thumbnails-1),\n.specialBanners-cover","#PC_side_chase01,\n.header_ads_wrap",".col-xs-3[class$=\"tColumn\"] > ul > li > div.panel-default:has(> div.panel-body > center > a[href^=\"https://digirevo.liberty-net.jp/\"][target=\"_blank\"] > img[src^=\"https://digirevo.liberty-net.jp/bana/\"]),\n.col-xs-3[class$=\"tColumn\"] > ul > li > div.panel-default:has(> div.panel-body a[href^=\"//www.pcolle.com/product/detail/?\"][href*=\"&af_id\"][target=\"_blank\"] > img[width^=\"2\"]),\n.col-xs-3[class$=\"tColumn\"] > ul > li > div.panel-default:has(> div.panel-body a[href^=\"https://gcolle.net/product_info.\"][href*=\"/affiliate_banner_id\"][target=\"_blank\"] > img[width^=\"2\"]),\n.col-xs-3[class$=\"tColumn\"] > ul > li > div.panel-default:has(> div.panel-body a[href^=\"https://pancolle-movie.jp/track?aid\"] > img[width^=\"2\"]),\n.col-xs-3[class$=\"tColumn\"] > ul > li:has(> div.panel-default > div > center > table td > a[href^=\"http://www.dmm.co.jp/\"] > img)",".adsFooterTopWrap",".advert__wrapper","div[style^=\"width:300px; height:250px;\"]","div[style^=\"width:728px; height:90px\"]","#Ad300x250,\n.AdX300x250",".rightSSP,\ndiv[class^=\"ssp\"]","#foot > ul[style=\"width:620px;margin:0 auto 20px;\"],\n.ad_730_90,\n.pr_300_250",".kakomi-maru","div[style=\"height:90px;width:728px;margin:auto\"]","#gn_interstitial_area,\n.footer__ad,\n.side-ad-wrapper,\napp-remote-ad-frame","#recommend-column > div.thum_list_small > div.column:has(> div[id^=\"logly-\"]),\n#related_article-column",".area-billboard",".affi_items,\n.affi_title,\n.bottom-container",".ad_detail_box,\n.l-aside_ad-has-fixed,\n.l-aside_box > div.l-aside_ad,\nli.detail_box[style$=\"display: flex; align-items: center; justify-content: center;\"]",".side_topics",".banner-middle,\ndiv[style=\"height:90px; width:728px;\"]",".c-box:has(> div.uz-radichubu_pc),\n.c-topics__card__item--half:has(> div.ad_pr)","#js-ad_news_relational_post_top,\n.AdSide,\n.adSide__top","#pl_sponsorBannerArea",".p-ads",".l-bottom-fixed,\n.l-fixed-ad,\n.sale-wrapper",".related_post","#bnrLp,\n#footerBnr,\n.hint01_ad","#adEntry2rec,\n#ad_entryBottom,\n#appleBnr,\n.entryBottomAd","#rightColumn > .menuBanner:first-child,\n.ad-area-pc,\ndiv[id^=\"reb_\"][style],\ndiv[style=\"margin:0 auto; clear: both; padding:25px 0; text-align: center;\"]",".ranking-tower-records-music-bnr,\n.top-campaign-bnr,\na[class=\"sub-nav__item-link\"][target=\"_blank\"]","div[id^=\"rflxAdBaner\"],\ndiv[id^=\"rflxAdBaner\"] ~ hr",".amazon_wrap","#menu-sticky_ad",".execphpwidget","#ads-rect",".sidebox[style*=\"1000px; margin-top\"]",".pr_message_area,\ndiv[class*=\"pr_banner_images\"]","#ad10,\n#pickup-list-itxs-1,\n.item--linkbox,\n.thm-aside > div[style*=\"900px; margin-top:\"]","#footer_banner .ftr1,\n#footer_banner .ftr3","a[href^=\"http://adclick.cross-system.com\"]",".home_bnr_box","div[id$=\"_billboard\"]",".c-sidebar-ad,\n.p-article-slider > ul.p-article-group__list","#dmm-bottomad-column,\n#pickup-ninja-recommend,\n#primary-column > div.section:first-child,\n.istripper-corner,\n.pcgame-corner,\n.recommended-giko",".homepage > div.wp-block-group[style=\"border-style:none;border-width:0px;padding-top:0px;padding-right:10px;padding-bottom:10px;padding-left:10px\"],\n.ryukyushimpo-fourteen-container,\narticle ~ .flex-col:has(div[id^=\"gpt-\"][style^=\"min-width:\"]),\ndiv[id^=\"gpt-\"][style^=\"min-width:\"],\nmain > sidebar + div.flex:has(> ul > div.widget div[id=\"gpt-mobile-sp-all-middle-1st\"])","#extra div.plugin-memo + div.ad",".l-sidebar > aside.widget_media_image","#footer_bannerlist",".container_09",".bannerRMod",".top_content6:has(> ul#top_banner_5_list)",".advertising_area,\n.lokokoku",".l-content__header-bnr,\n.l-front__banner,\n.p-articles__list > .p-articles__item:has(> div[id^=\"sakigake_\"]),\ndiv[class*=\"__bnr-header\"]",".adsence2clm",".l-block > div:has(> div[class^=\"rectangle\"]),\n.l-secondary > div.l-widget:has(> div[class^=\"rectangle\"]),\n.rectangle300,\ndiv[style=\"font-size: 0.4em;background: repeating-linear-gradient(57deg, #fff, #fff 4px, #f5f5f5 5px, #f5f5f5 8px);color: #666666\"]",".co-relational-article",".contents_side > div.pc:has(> ul.m-bannerList),\n.m-adArea",".banner-footer",".ad-boomapp",".user-area > table#content_block_1:has(a[href^=\"http://ck.jp.ap.valuecommerce.com/\"])","#ad-two-center,\n.koukoku1,\n.koukoku2,\n.ranking_prbox",".advertising > div,\n.articleAdd,\n.rightAdd","aside.ad","#seotools > div[style^=\"text-align:center; margin-\"],\n.bx-window[style$=\"width:300px;\"],\ndiv[style^=\"height: 250px;\"]",".post_content--ad_area","td[width=\"200\"]","div[class^=\"banner0\"]",".section-supporter-link",".NinjaEntryCommercial,\narticle.EntryTextBox:has(#ninja-blog-inactive),\ndiv.EntryBlock:has(#ninja-blog-inactive),\ndiv.EntryInner:has(#ninja-blog-inactive)",".p-article__label--nextMark,\n.u-ta-center",".banner250,\n.sub_box > table:has(> tbody li > a[href^=\"https://www.rocket-wristband.com/\"]),\n.sub_box:has(> p.clerfix[style=\"line-height:150%;\"] > span[style=\"color:#AAA;\"] + a[target=\"_Blank\"]),\ndiv[style=\"width:565px;height:60px;\"],\ndiv[style^=\"width:468px;height:60px;\"]","#containerBottom",".ad-sec","#random-banner,\n#sponsor-banner","aside[id^=\"sad\"]",".custom-html-widget > div.p-archive-header.mt-5:has(+ div[id^=\"logly-\"])",".main_advertising",".adBlock2",".recommend-pr,\n.recruit",".articles-detail-page > table[width=\"680\"]","#gad-relatedentry,\n.gad-articletop,\n.gad-sidetop",".ad-archive",".postAds,\ndiv.h250,\nh3.headline5.mb10","#r1_advertisement,\n.ad_double_300_300,\n.ad_navigation_300_250","#g-ad",".free-block",".sam-slot",".contentBannerBox","#srdk-index-native-pc,\n.hatena-module-html:has(> div.hatena-module-body > div.srdk-rectangle-ad)","main[role=\"main\"] > p:has(> ins.adsbygoogle)",".sec-bannerArea",".bnr-area",".banner-rectangl",".ad_box_sp,\ndiv[class$=\"_article_ad\"],\ndiv[style$=\"min-height: 280px\"],\ndiv[style$=\"min-height:250px\"],\ndiv[style=\"margin: 10px 0px 10px 0px; min-height:200px\"],\ndiv[style=\"margin:auto;text-align:center; min-height:300px\"],\ndiv[style=\"min-height: 850px\"],\np[style=\"display: block; text-align: center; color: rgb(214, 214, 214); font-size: 12px; line-height: 10px; margin-bottom: 4px; padding-top: 2px;\"]","#ads-index-text,\n#gpt-sd_index_rec,\n#gpt-sd_other_rec,\n.ads-leaderbord,\n.srad-contentad-banner","#top-hat",".articles-body > span[style=\"font-size:small;\"] > span[style=\"color:#666666;\"]",".adlb","#amzout,\n.content > .obj_centering:has(ins.adsbygoogle)",".banner_middle",".Ads > div[id^=\"div-gpt-\"] + br,\niframe[src*=\"stv.jp/nnn/assets/\"]",".article__recommend","#adv_wrap,\n#r_navi > .banner",".use--ad","#contents > center:has(> div[id^=\"div-gpt-\"]),\n#foot-bnr,\n#webmag > .nodisplay",".adv2:has(div[id^=\"div-gpt-\"]),\n.post > div.adv2",".AfiBigText,\ndiv[class^=\"c-ads-tag\"]","#contents-basic div[style=\"margin:10px 0;height:100px;\"],\n.div-responsive-horizontal","div[class^=\"adsbox\"]",".bnrwrap,\ndiv[class*=\"tilebnr\"],\ndiv[id^=\"kpftw\"]","#ads_menubar,\n#ads_menubar_bottom,\n.rklink,\n.rkmark","div[id$=\"_parent\"]",".catchup,\ndiv.bnr","div[style=\"margin-bottom:10px;text-align:left;width:95%;overflow:hidden;\"] + h2",".list-recommend > ul:has(> li > a[href^=\"http://socialife.sony.net\"] > img)","#sidebar > section:nth-of-type(2),\n.overlay,\n.topic-container > .text-center + .section","div[class^=\"ad-box-\"],\ndiv[id^=\"relatedsearches\"]",".overture-side",".articles-single__article__ad__underarticle,\n.articles-single__aside__ad,\n.articles-single__aside__ad__border,\n.index-ad-manager__list,\n.single-program__ad-manager-list",".te-article__body__inner > div.te-article__section:has(> div.uz-ny)",".rectangle-images,\n.rectangle-images-main",".ad-premium-jack,\n.register:has(> div#adPCLarge)",".google_adsense_placeholder",".bkon","#pr-tokubetsu-banner,\na[href=\"https://retty.me/\"],\ndiv[class^=\"tenki-ad-\"]","#iasContainer > div.iasItem ~ div.iasItem > div[class*=\"ad-\"],\n.addHead.ad-pc,\ndiv[class*=\"ad-\"] > div[id^=\"dipalyId-\"]",".gb-grid-column > .gb-container > .gb-container > .gb-container:has(> .adsbygoogle),\n.inside-article > .gb-container:has(> .adsbygoogle),\n.inside-right-sidebar > .sticky-parent-container > .gb-container:has(> .adsbygoogle)","[class^=\"style_adS\"],\nsection[class^=\"style_advertisement\"]",".content-box-2col,\n.recommend-header-container,\n.right-banner > a:not([href*=\"the-ans.jp\"])",".related-posts","#rewardModal,\n.newsArticle_product,\n.sidebarcontents:has(> ul.affiliatelist)","[class^=\"css-\"] > div[class^=\"css-\"]:has(> amp-ad)",".inner-contents > #postscript > a[href^=\"https://al.dmm.co.jp/\"],\n.inner-contents > #postscript > a[href^=\"https://www.dmm.co.jp/\"][target=\"_blank\"][rel=\"noopener\"]","div[class^=\"_footer_ad\"],\ndiv[class^=\"_inlineAdWrapper_\"],\ndiv[id^=\"ad-promo-\"],\ndiv[id^=\"ad-side-\"]",".widget-media-ad:not(#widget-media-ad-72)","#adEntryTitleBottom,\n#bnr_goSrid,\n#hashiraR","div[class*=\"tkn-ad--top-billboard\"]",".c-adContainer:not(.ad_sideFixTop)",".super-banner-field","#zone04_bg",".sec_banner","#footerMdl,\n.bncenter","#main-right > #side_press_section,\n.btm_press_section","#DynamicAd",".banner-box",".footer-rbox-b,\n.side-topad > .side-widgets.widget_text",".tora-ads-default","div[style^=\"marign:8px\"]",".article-single > .sec-ad-article",".pr_bnr_contents_block",".affiliate_link,\n.article-meta-box,\n.box-ad-left,\n.original-pc-ad,\n.pc-side-ad-mrg,\n.side-column-float",".adsense_02,\n.left_box","div[id^=\"trend-\"]",".main-bottom__container,\n.personalityQuiz-GAM,\n.sideBar-AffiliateBanner,\n.sideBar-GAM,\n.sideBar-GAM_Middle",".same_theme,\ndiv[style=\"border:1px solid #aaa; border-radius:10px; padding:0px 15px; margin:0px auto 10px; width:90%; max-width:700px;\"],\ndiv[style=\"width:970px; height:90px; margin:20px auto 30px;\"]",".overlay__bg","#cont01 > div.heightLine-5:has(> div#pc-tmall-gamelist-gamelist),\n.pc.game_bnr,\n.primary-content > div[class] > div#aqua + p[align=\"center\"],\n.sp.game_bnr",".w-sidewall","div[style^=\"text-align:center; background-color:#fff;\"]",".wrapper > div.shadow-box:has(> div.ad_sfr)","img[width=\"728\"]","a[href^=\"https://click.duga.jp\"]","a[href^=\"https://mttag.com\"]","center > center > table[width=\"807\"]:has([href^=\"https://mttag.com\"][rel]),\ntable[width=\"780\"][cellpadding=\"5\"] tr:last-child,\ntable[width=\"780\"][cellpadding=\"5\"] tr:nth-child(2)","#index_banner_space_01 > div.text-center:has(> #random_image_2),\n.footer-links ~ .index_banner_space_07","center > center > table[width=\"807\"]:has(td[bgcolor=\"#ffffff\"] > [href^=\"https://pcmax.jp/lp/\"])","table[width=\"807\"]:has(td[bgcolor=\"#ffffff\"] > a[href^=\"https://www.e-nls.com\"])","table[width=\"446\"] > tbody > tr:has(td > a[href^=\"https://mttag.com\"]),\ntable[width=\"446\"] > tbody > tr:has(td > a[href^=\"https://www.e-nls.com\"])",".index_banner_space > div[class^=\"ad-\"],\n.mt-4 + .index_banner_space_03","a[href^=\"https://happymail.co.jp\"]","iframe[src^=\"https://tead.tver.jp/web/TEAD_banner\"]",".billboardBannerBox,\n.contBannerList","#tvl_pc_article_footer[style=\"width: 728px; height: 90px;\"],\n.ad > ul[style=\"list-style:none;font-size:12px\"],\n.for-pc[style=\"text-align: center;margin: 10px auto 20px;\"],\ndiv[id^=\"tvl_pc_all_\"]",".ads-banner-box",".j-htmlCode,\n.j-htmlCode + div.j-hr","#showAdPosition,\n.list-group-flush > a.list-group-item-action[href^=\"https://shop.sococo.jp\"],\ndiv[data-as-slot-id],\ndiv[style=\"text-align: center;margin:20px auto 400px auto;width :685px;\"]",".stripe-free,\ndiv[style*=\"height:280px;\"]",".Ad_728x90,\n.sideAd_300x250,\n.sideAd_300xfree",".addSpace336,\n.widget-sidebar:first-child > div.custom-html-widget:first-child",".sidebar > div.rankcontainer[id^=\"hot_\"]",".R_Adv,\n.ad280,\n.reladsgoogle,\n.topBoxAdsRight,\n.tracking,\n.underBoxAds",".su-animate",".al.f3.fg0,\na[rel=\"nofollow\"] > img[style=\"width:100%\"]","#amgatti_sk-2,\n#amgatti_sk-5,\n.header-cls,\n.wp-block-columns","#adArticleFooter,\n#fixed-affiliate,\n#relevantPost,\na[href^=\"https://track.affiliate-b.com\"]",".mh-posts-1",".entry-content > div[align=\"center\"] > a[href^=\"//ck.jp.ap.valuecommerce.com\"][target=\"_blank\"],\n.side-topad > div.widget_st_custom_html_widget","#plugin-a > div.plugin-memo,\n.ad-tp",".detail_footer__ad,\n.detail_header__ad,\n.top_side_first","div[class^=\"ad-\"][class*=\"_Square-\"]","#gbl_ad,\ndiv:not([class]) [class*=\"bg-gray-\"][class$=\"xl:hidden\"]:has(> .ad-container)","#right-vertical-ad-cal,\n#under-horizontal-ad","#main > .block:has(> div[style*=\"width:\"]:first-child > div[id^=\"div-gpt-\"]),\n#sticky_pc,\n#sub > section.dmenu-non:has(> div[style=\"width: 100%; margin: 0px auto 10px; text-align: center;\"] > div[id^=\"div-gpt-\"]),\n#sub > section[class*=\"block\"]:has(> div[style^=\"width:100%; margin:0 auto\"] > div[id^=\"div-gpt-\"]),\n.pc[style=\"text-align: center; min-height: 100px;\"],\narticle > section.block:has(> div[style] > div[id^=\"div-gpt-ad\"])",".bnr-sakuhin-info","#category-tms2019-ad-hide,\n#jp_wct_pc_article_undernextpage,\n#under-title-ads,\n#widget_code_php_in_widget-23 > h3.widget-title,\n.billboard-ads-wrapper,\n.execphpwidget > div.video-wrapper,\n.wct-recommend-posts li:has(div[data-uz-url])",".matome-pickup","#adPcBnrWrp,\n#adPcFootBnrWrp,\n#rightMiddleBnrId,\n.ad-blank,\n.adBannerHd,\n.adBannerHdWrp,\n.adBkOverlayClr,\n.adSmpBnrFtBtSp,\n.ads-loader,\n.firstDictBnr,\n.flex-rectangle-ads-frame,\n.rectangle-ads-frame-www","#secondary > a[href^=\"https://go.ad-link.net/\"]","#ejjeBottomRightFixedAds > div.sideBlock:has(> div[id^=\"div-gpt-\"][style^=\"height:80px; width:320px;\"]),\n#ejjeBottomRightFixedAds > div.sideBlock[style^=\"text-align:\"] + div.sideBlock,\n#ejjeRightTopAdId,\n#footFixAdBar,\n#learning-level-table-wrap > #leadBtnWrp,\n.hideAdBtn,\n.indexSideAdTop,\n.mainBlock:has(> .flex-rectangle-ads-frame),\n.mainBlock:has(> div[id$=\"RecommendAdId\"]),\n.premium-service-button,\n.sideBlock:has(> div[style=\"min-width: 300px; min-height: 100px;\"]),\n.sideBlock:has([id$=\"AdId\"]),\n.sideblock:has(> .ads-loader),\n.sideblock:has(> div[id^=\"div-gpt-\"]),\n.sideblock:not(:has(> *)),\n.slfAdsBox,\ndiv[class=\"sideBlock\"]:has(+ .slfAdsBox)","#translateAfterSpellCheckAdId,\n#translateFooterOverlayAdId,\na[onclick*=\"lead_to_premium\"]","#side","#wrapper > img[src$=\"/footer_ad.gif\"] ~ br,\ndiv[class^=\"ads0\"]",".widget_bbearad,\n.widget_bbearad-recommend,\n.widget_bbearad-single-bottom","div[id^=\"facemask_\"]","#wiki_menu > div.uk-sticky-placeholder",".al_method","#inbound-ad-container,\n#pc-bottom-parent-ad-container,\n#pc-caption-ad-container,\n.admenu-sticky,\n.fluct-overlay-container",".post_content > table[border=\"0\"]",".ad-stickyhero,\ndiv[class*=\"ContentFooterWrapper-\"]:has(> div > div.wide-adrail)","#pickupNewsModal_gallary","#WO_PC_InArticle-1,\n#ranking-part > ul.tab_content > li[class]:has(> a[data-google-interstitial]),\n.banner-area-margin-bottom,\n.section-recommend,\ndiv[id^=\"TW_\"],\ndiv[style=\"max-width:970px;min-height:90px;text-align:center;margin:0 auto;\"],\ndiv[style=\"width:670px ; height:300px;\"]",".jack-top,\n.jack-wrapper","table[style=\"margin-top:20px;\"][width=\"1110\"] > tbody > tr > td[align=\"left\"]:last-child,\ntable[width=\"300\"][height=\"250\"]","a[href^=\"https://3rdspring.jp/\"],\ntable[cellpadding=\"2\"][bgcolor=\"#CCCCCC\"]","table[height=\"260\"]","div[id$=\"-fixed-menu\"],\ndiv[id$=\"_bnr\"]","#ranking_ul > li.cardList__list_item:has(> div.grandRankingAd),\n.card--recommend6__list:not([show-index]),\n.swiper-wrapper > div.swiper-slide:has(> div.ad_swiper_card)","[class^=\"ads_\"]",".fixed_sidebar-wrapper","#text2 > p:first-child",".section-in > a[href=\"https://www.pasifea.com/\"][target=\"_blank\"]","#main > div[style=\"margin-bottom:15px;\"]","div[id*=\"_banner\"]","div[id^=\"tt521-\"]","#main > .column-inner > .column-inner-2 > a[href^=\"https://erokolky.com/\"][target=\"_blank\"],\n#main > .column-inner > .column-inner-2 > a[href^=\"https://movie.eroterest.net/site/s/\"][target=\"_blank\"]",".advertising","#ad_unit300,\n.ad_pc_rectangle,\n.ad_sp_rectangle,\ndiv[class^=\"ad_superbanner_\"],\ndiv[id$=\"_kj_movie\"]","#bnrLink",".top-kokoku","#tmp_wrap_pr",".template-top__aside__ad","#adBnrArea","div.sd_bnr01:has(> a:not([href*=\"//\"]))","#headpromotion-service",".admarking_label",".content > .list-tile:has(> li > div[id*=\"_dfp\"])","div[id^=\"yzpc\"]",".cta_merci,\n.cta_min",".w-full.h-\\[50px\\]",".p-rectangle_banner_box",".panel-banner",".bannerbox,\n.sidebarr","div[style$=\"min-height:90px;\"],\ndiv[style=\"height:100px;max-height:100px;overflow:hidden;\"]",".head-pick",".memomaru_ads",".ads-banner-fixed",".content-right > div[style=\"display:flex;justify-content:center;align-items:center;text-align:center;margin-bottom:12px\"],\ndiv[style=\"text-align:center;margin-bottom:16px;min-height:250px;width:auto\"],\ndiv[style^=\"display:flex;\"][style*=\"align-items:center;\"][style*=\"min-height:100px;\"],\ndiv[style^=\"display:flex;\"][style*=\"align-items:center;\"][style*=\"min-height:280px;\"]","#chaDivADS",".__ad-pc,\n.__sideBar > div.__ad:first-child,\ndiv[class^=\"__super-banner-\"]",".special_banner,\n.sub > div.banner:has(div.value_commerce)","#main center > a[href^=\"https://www.amazon.co.jp/dp/\"],\n.ad_geniee,\n.amazonmusic",".ad-below-single-header,\n.ad_AfterMore,\n.post-list-item-ad,\n.sidebar-single-ad",".main-contents > div.sp-only:has(> script[src^=\"//j.microad.net\"])","body > center > table[width=\"807\"]:has(a[href^=\"https://mttag.com\"][rel]),\ncenter > table[width=\"807\"]:has(td:not([class]) > a[href^=\"https://pcmax.jp/lp/\"])","center > table[width=\"807\"]:has(td[colspan] a[href^=\"http://click.duga.jp\"]),\ntable[width=\"451\"] > tbody > tr > td[height^=\"6\"]:has(td > a[target=\"_blank\"]:is([href=\"happy/happy.html\"], [href*=\"e-nls.com\"], [href^=\"https://mttag.com\"])),\ntable[width=\"451\"] > tbody > tr:has(+ tr > td[height^=\"6\"] td > a[target=\"_blank\"]:is([href=\"happy/happy.html\"], [href*=\"e-nls.com\"], [href^=\"https://mttag.com\"])),\ntd[width=\"250\"]:has(a[href^=\"https://happymail.co.jp\"]),\ntd[width=\"250\"]:has(a[href^=\"https://pcmax.jp\"])",".mt30[style=\"display:flex;justify-content:space-between;\"],\ndiv[class*=\"_AdWrapper\"],\ndiv[class^=\"Layout\"] > div[class^=\"articleId\"]:has(> div[class^=\"PopIn_\"]),\ndiv[class^=\"Layout\"] > div[class^=\"articleId\"]:has(> div[class^=\"PopIn_\"]) + hr,\ndiv[style$=\"display: inline-block; height: 280px;\"],\ndiv[style$=\"width:300px;\"]",".ad__search-lower-banner","#outline > div[align=\"center\"]",".amazon-ads,\n.block > div.container > div.row > article:has(> div > div > ins.adsbygoogle)",".mediaBottomAd,\n.mediaTopAd",".lyBannerDiv",".content > div[style=\"text-align:center;height:100px;overflow:hidden;margin-bottom:10px;\"]",".interstitial,\n.lastInterstitial","#imadv,\n.article-body:has(a[href$=\"://blog.mmm.me/goods/\"]),\n.article-title-outer:has(a[href$=\"://blog.mmm.me/goods/\"]),\n.article1:has(a[href$=\"://blog.mmm.me/goods/\"]),\n.kijilist-body1:has(a[href$=\"://blog.mmm.me/goods/\"]),\n.pankuzu:has(a[href$=\"://blog.mmm.me/goods/\"])",".content:has(a[href$=\"://blog.mmm.me/goods/\"])","#left > div.body:has(a[href$=\"://blog.mmm.me/goods/\"]),\n.article:has(a[href$=\"://blog.mmm.me/goods/\"])",".c_ad_wrapper,\n.c_related_section:first-of-type,\n.imagemaker_ad_wrapper,\n.play-Imagemaker_Footer,\n.search-Sidebar",".h-32,\ndiv[class^=\"m\"][style^=\"min-height\"]",".dfp-banners,\n.middle-ad-section,\n.small-ad-content,\ndiv[style^=\"margin: 30px auto 0;\"]","div.text-center.pa-0.my-2[style^=\"height: 1\"][style*=\"overflow: hidden;\"],\ndiv[style=\"height: 310px; overflow: hidden;\"]","#FR_PC_inArticle,\n#GB_pc_inArticle,\n#GB_pc_inread_mov,\n#GB_pc_inread_mov + div[style=\"min-height: 250px; overflow: hidden;\"],\n#MG_pc_2nd_Rectangle + div[style=\"width:300px; margin-top:15px;\"],\n#MG_pc_inArticle,\n.ad-slider,\n.articleBottomAd,\n.dontprint[style=\"min-height:90px;margin-bottom:45px;\"],\n.dontprint[style^=\"min-height: 250px;\"],\n.reduce-CLS,\n[class^=\"sponsored_\"],\ndiv.articleBottomSns + div[style=\"min-height: 250px; overflow: hidden;\"],\ndiv[style$=\"height: 250px;\"] + div.elementSectionHeadingsWithSuffix:has(+ .OUTBRAIN),\nmain > aside.blockContainer_block:has(> div > div.ad-container)",".pr-ad",".m-recommend,\ndiv[class^=\"affi-\"]",".c-ad2,\ndiv[style=\"margin: 20px auto 20px; text-align: center; min-height: 250px; overflow: hidden;\"]","#more > [href^=\"//clap.fc2.com\"] ~ div[style=\"text-align: center;\"],\n#more > div[style^=\"background-color: rgb(88, 140, 115)\"]:has(+ p + br + div > span[style=\"font-size: medium;\"] > strong),\n.plg3_body > div[align=\"left\"] > .plugin-freearea:has(> a[href^=\"https://al.dmm.co\"]),\n.side_left > div.plg_body:nth-child(-1n+6),\n.side_left > div.title_wrapper:nth-child(-1n+5),\n.side_right",".NA_ad","#side > div.td2:has(+ div > a[href^=\"https://click.duga.jp\"]),\n#side > div[style^=\"width:\"]:has(> a[href^=\"https://click.duga.jp\"]),\n.table_line:has(a[href^=\"http://www2.jp.jskypro.com/affiliate\"]),\n.table_line:has(iframe[src])",".ad-banner-m",".inven_spot",".nend_text_ad,\ndiv[style^=\"width:760px;height:250px;\"]","#rightadc,\ndiv[style=\"height:68px;\"],\ndiv[style=\"width:610px;margin: 0 auto;\"]",".rakuten_group_item","#more > a[href^=\"https://hb.afl.rakuten.co.jp\"],\ndiv[class^=\"kaerebalink-\"]","#more > table[border=\"0\"]","#BANNER-4gamer-Contents_Center_AD_Bottom_01,\n.GAME_AFFILIATE,\n.banner_left_4g,\n.custom_title_list_2,\n.g123_ranking_ad,\n.hot_game_now,\n.large_banner,\n.satellite_banner,\n.search_adcontainer,\n.season_special,\n.sidetop,\n.slidead_smartphone_top,\n.top_article > h2.V2_finding:has(+ .slidead_smartphone_top),\n.wide_banner,\ndiv[data-banner-framename$=\"AD_01\"]",".as-center-468px","#adoverlay,\n#js--banners--thread,\n.ADVERTISE_AREA,\n.ADVERTISE_AREA + div[style=\"margin-top:10px;margin-bottom:10px;width:100%;text-align:center;\"],\n.adbanners,\n.sticky_side_point > div.my-4:has(div.ads-item),\nbody > div > div[style=\"text-align:center; margin: 0 auto;width:100%;\"],\ndiv[style*=\"width: 728px;\"]",".supporter","#ad_network,\n#js-adstir-320x50,\n#js-bottom-ad-320x250,\n#js-cardview_ad,\n#js-subback_top_320x50,\n#js-thread-subback-top-ad,\n#subback > li[id][class*=\"_\"],\n.ad_320x50,\n.ad_5th_300x250,\n.ad_nth,\n.ad_nth_li,\n.js-cardview_ad-320x180 > div,\n.js-cardview_ad-320x180 > iframe,\n.js-cardview_ad-320x50,\n.js-overlay_ad,\n.ranking > div#js-topics-top.flex_center[style^=\"height: calc\"],\n.ranking > div[style^=\"height: 320px;\"],\ndiv[id$=\"-300x250\"],\ndiv[id^=\"topAdheader-\"]","#content-widget,\na[href*=\"myshopify.com\"]","div[style=\"padding:20px 0;text-align:center;font-size:20px;background-color:#FFF;max-width:1202px;line-height:180%;\"]",".sidein2","div[class^=\"ad-list\"]","#d-box > div:first-child > font[size=\"2\"],\ntable[summary=\"スポンサーリンク\"],\ntable[summary=\"関連コンテンツ\"],\ntable[summary] > tbody > tr[align=\"left\"][bgcolor]:has(> td > .adsbygoogle)","#area-site-footer-ad,\n#area-site-header-ad","#execphp-71,\n#mainEntity > div.clearfix > div.txt,\n#resid,\n#side-fixed > div.widget_execphp,\n.idname2,\n.post-h2-title,\n.posts-under-1 > div.execphpwidget > div.txt,\n.random,\n.random3,\n.txt > p > a[target=\"_blank\"][rel^=\"noopener\"]","#side-scroll",".permalink + div.module--category-recent-entry",".afc_popup","#avRanking,\n#doujinRankingFull,\n#gameRanking,\ndiv[id^=\"animeRanking\"],\ndiv[id^=\"comicRanking\"]",".adcontrol-wrapper","body > div[style$=\"height:100px;width:320px;\"]",".adsensewrapper",".haj",".appbank-tags > a.RWh2:first-child,\n.body-ad,\n.entry-list-item-native-ad,\naside > div.img-row:has(> div.one-half > h5 > a[href^=\"https://www.amazon.co.jp\"]),\np > a.feed-link","article[id^=\"post-\"] > div.box_single_content:has(> div.ad_300x250)",".plugin-memo:has(> div.side table a[style=\"word-wrap:break-word;\"][rel*=\"sponsored\"]),\ndiv[class^=\"article\"] dd:has(> b > table a[style=\"word-wrap:break-word;\"][rel*=\"sponsored\"])","div[id][class^=\"popup\"][class$=\"wrap\"][style^=\"opacity\"]","#text-134",".entry_pickup_fam,\n.right_bar > div.bar_title:first-child","#pc_text-4","div[style=\"width:692px;height:280px;margin:-8px auto 0 auto;\"]",".ad-fc2","div[id^=\"beaut-\"]",".modWysiwyg > div[style=\"min-height: 270px;\"]","#pc_text-10,\n.toppage_av",".ad_rakutenlinkshare",".ad001,\n.mkjAd",".blockAreaMainFooter > div.blockWrapper:has(> div.blockBody > div.eroterest_mgs_rec_parts),\n.blockAreaMainUpper > div.blockWrapper > div.blockBody > center > a[href^=\"https://al.dmm.co.jp/\"] > img,\n.blockSide > div.blockWrapper > div.blockBody > center > a[href^=\"https://al.dmm.co.jp/\"] > img,\n.blockSide > div.blockWrapper:has(> div.blockBody > div#eroterest_mgs_rec_parts),\na[href^=\"https://adult-sale.com/lp/\"],\na[href^=\"https://the-horse-racing.com/?ad=\"]",".blockAreaMainFooter > div.blockWrapper:has(> div.blockBody > iframe),\n.entryDetail div[style^=\"width: 100%; height: 395px; overflow-y: hidden;\"]",".blockAreaHeader","#center-left > .plugin3_outline,\n#center-left > .plugin3box,\n#right > .plugin2_outline:last-child",".ad__middle-banner__item--search,\n.sys_search_ad_text,\ndiv[class*=\"-on\"][class$=\"y-ad\"],\ndiv[class^=\"bustrip\"][class*=\"banner\"]","div[style=\"position: relative; z-index:255;\"]","#links > div[style=\"width:160px;height:600px;margin:0 auto 10px;\"],\n.gglad_728_90","div.clearfix[style=\"margin:200px 0 0 0;\"]","#ad-more,\n.metaslider,\n.pc_above_main,\n.pc_above_nextpage,\n.side-widget-area > div.widget_custom_html",".center-ads,\naside > div[id^=\"custom_html-\"]:has(> .textwidget > div:is(.ads-flexbox, #preafBanner_wrapper, .ninja-recommend-block))",".c-banner_w728_pc,\n.c-latest_main:has(> div.img > div[data-ad_space_id])",".adBoxWrap",".PrTextMypage,\n.ofnd,\n.pickup.link_list,\n.wrap-adm[style=\"width:170px; height:200px;\"],\ndiv[class^=\"logojack_button\"],\ndiv[id^=\"ad-display-\"]","div[id^=\"ad_game\"],\ndiv[style=\"width: 760px; min-height: 500px;\"]",".insentence-adsense3",".atcosme-HeaderAdContent,\n.bnr_sec","aside[class^=\"top_pc\"]",".entry-content > div[id^=\"custom_html-\"]","#bannerin,\n.ad-area-list,\n.ad-area_pr:has(> figure.ad > p[style^=\"display: inline-block\"]),\n.ad-area_trend_small,\n.ad-list-m,\n.ad_CIT_top,\n.foot-banner,\n.head-banner",".sponsorship",".textwidget > p:has(> a[href^=\"https://amzn.to/\"])",".noIE6","#right_box_inner > div[align=\"left\"]",".img-spc-box,\n.sph250","#link-overlay,\n.bookview-wrap a[class*=\"id\"][target=\"_blank\"],\n.bookview-wrap div.video-scroll,\n.out-scroll-img > ul.out-scroll-img__list:has(> li > a[target=\"_blank\"][href^=\"https://\"]),\n.pop-separate[href^=\"https://go.\"],\n.video-list,\niframe[src*=\"/www/delivery/\"],\niframe[src^=\"https://creative.rmhfrtnd.com/\"],\niframe[src^=\"https://go.mnaspm.com/\"],\nimg[src*=\"//cdn.ddd-smart.net/ad/\"]",".article-header-ad-space,\n.module-article-list-ad,\ndiv[class$=\"-ads\"]",".rblock:has(> div.rad),\n.ta_center.rblock",".adBnrList,\n.addBadge,\n.digimart_PC_resp01",".footer_dlsite",".v-row:has(> div.v-col > div > a[href=\"https://favry.app\"])","#body > div[style=\"margin-top:.35em\"],\n#menubar > div[style=\"margin:.5em 0 0 1em\"]","#im_panel_pc","#freebox_02","div[class^=\"unBox\"][class*=\"ad\"]",".banner_ws1,\n.floatbox1,\n.floatbox2,\n.plugin2_outline,\n.plugin3_outline","#block-111,\n#block-91,\n.wrap-grid-post-box > article:not([role=\"article\"])",".newgame_box td:not([style]):has(> a[href*=\"/promotion/\"][target=\"_blank\"]),\na[href*=\"/promotion/\"][target=\"_blank\"]",".itemTitle,\n.plugin-memo > div.side > div.plugin-memo:has(> div.side > div[id^=\"bnc_ad_\"]),\n.side > b > span[style=\"color: rgb(255, 0, 0);\"],\na[target=\"_blank\"]:not([href*=\"ebitsu.net\"]):not([href*=\"amaebi.co\"]):not([href^=\"https://www.youtube.com\"]) > img.pict",".hd2",".excite_sp_footer_area,\niframe[src*=\"/iframe/ad/\"]","#text1 p[style=\"text-align:center;\"],\n#tuibi,\n.text_inner div[style]",".pr_table,\n.random_ad_sidebar,\n.yubi,\ndiv[class^=\"rapper\"]","#sub_navi > h4",".base__advert-container",".entry-content > div[style=\"margin-bottom:10px\"] > a[href^=\"https://al.dmm.co.jp\"],\n.entry-content > h2:has(+ p + div[style=\"margin-bottom:10px\"])","#t_area > ul > li:has(> a[title^=\"[PR]\"]),\n#top_pr,\n.pcad,\na[href^=\"https://al.dmm.co.jp\"][target=\"_blank\"]","div[style*=\"height:260px;\"]","div[class^=\"__isboostLowerRight\"]","a[href^=\"https://a-affiliate.net/login/link.php\"],\na[href^=\"https://www.sokmil.com/\"],\naside > div.swiper,\nmain > .container:has(> .row > aside > .text-center > a[href^=\"https://www.ppc-direct.com/\"]),\nsection > aside > div.movie","#custom_html-102,\n#custom_html-135,\n#custom_html-78,\ntbody > tr:has(> td[class$=\"-ad\"])",".adAreaNative,\n.adMgs,\niframe[src^=\"//okbp.xyz/\"]",".edgBanner","#banner1,\n.dmm-ranking","#media_image-7,\na[href*=\"esports.net/go/\"]",".l-parts-a > div.side","#newfiles > ul.list > li[style*=\"height: 120px;\"],\n#preview_images > div[style^=\"max-width: 560px; position: relative; height: \"] > div.h_items[style=\"margin-bottom: 10px;\"],\n#preview_images > span[class^=\"tracking_\"] > div[style=\"position: fixed;\"] > div[data-pr],\n#wrapper > div[data-style][style*=\"fixed\"],\n.tag + div[class],\na[link*=\"al.dmm.co.jp\"],\narticle > div[style*=\"305px\"][style*=\"align-items:\"],\narticle > div[style=\"display: flex;align-items: center;margin-bottom: 5px;\"] > div[data-pr=\"1\"][style^=\"min-height: 20px;\"],\nbody ul.list > li[style=\"clear: left;width: calc(100% + 3px) !important;margin-right: -1px;height: 120px;margin-left: -2px;float: none;display: block !important;\"]","form > div[style=\"text-align:center\"],\ntable[width=\"176\"]:nth-of-type(2)",".ad_waku,\n.section_ad:not(.kiji + .section_ad),\n.section_adbox",".entry-content > div[style^=\"height: 44px;\"][style$=\"no-repeat;\"],\na[href^=\"https://ac.glowthcv.com/cl/\"]",".advertisement_media,\n.pc_only_ad","#right > div.plugin-memo:first-child,\n#touter + table,\n.sponsoredsink",".checker-related-wrap,\n.soku_wrap,\n.sum,\n.tokka,\na[href*=\"px.a8.net/svt/ejp\"],\ndiv[class^=\"spadd\"]","#leftAffi,\n.pr_aria,\n.side_box > h3:last-of-type,\nimg[src*=\"/bnr_ad_\"]",".articleDeleteButtonWrap",".home-recommend__item[class$=\"hidden\"]","a[id*=\"side_banner_abema_\"]","#custom_html-54,\n#widget-container-footer,\n#widget-post-footer,\ndiv[id^=\"widget-content-top\"]","#custom_html-62","#adsenes","#mvbx,\n.c11-2,\n.c11-3","#side_col > div.widget_custom_html:first-child,\n.banner_set,\nspan[style^=\"text-align: -webkit-center; font-size: medium; color: rgb(102, 102, 102)\"]",".bottomad4,\n.topad2",".container_top_widget_content:has(> div.custom-classic-textwidget > div > .adwidget),\n.sidebar_content > div.custom-classic-textwidget:has(> div > .adwidget),\n.sidebar_content > div.widget_execphp:has(> div > .adarea)",".g-txt","#mainEntity > div.clearfix > div.wp-block-group-is-layout-constrained:has(> .wp-block-group__inner-container > h2.wp-block-heading + div.yyi-rinker-contents),\n#mainEntity > div.clearfix > div.wp-block-image,\n#mainEntity > div.clearfix > div.wp-block-image + div.yyi-rinker-contents","#footer_ov_ad,\ndiv.hidden-xs[style=\"text-align: center;\"]",".sidebar > aside[id^=\"custom_html-\"],\n.sidebar > aside[id^=\"pc_text-\"]","a[href=\"https://liberty-net.jp/toukou/\"],\na[target=\"_blank\"][rel=\"nofollow\"] > img,\ndiv[align=\"center\"] > a[target=\"_blank\"] > img",".above-caption,\n.article_bottom,\n.bottombox > .bottombox,\n.bottomsection,\n.detail > .related:has(> .adsbygoogle),\n.infeed2,\n.interlude,\n.related-cate:has(> ins.adsbygoogle),\n.spll,\n.splnk,\n.splr,\n.topunit","#EndFooter,\n#Google_Index_Middle,\n#Google_TC,\n#LT,\n#entry-form,\n#latest > div.e_ad,\n.e_frame.e_ad",".google-3ad,\n.left-container > div.plugin-memo:first-child,\n.right-container > div.plugin-tag_cloud + div.plugin-memo",".adD,\n.adM","#ad_four_sequence",".sidebar_ad_pc",".side_box_ad","div[style=\"width: 100%; height: 100%; background: #ead5ff; border: #ff0000 solid 1px;\"]",".sidemenu_content:has(> div.plg_body > div.plugin-freearea > a[href=\"https://superfreesex.blog.2nt.com/\"])",".article-body > .mb12:has(> .uz-2-haryu-korea_pc:only-child),\n.article-body-after > div[style=\"padding-top: 10px; padding-bottom: 10px; margin-bottom: 30px; margin-top: 30px;background: whitesmoke;\"]",".first-article div[style=\"”text-align:center;”\"]","#images > div[style=\"text-align:center;margin-bottom:50px;\"],\ndiv[style$=\"overflow:hidden;\"] > table[width=\"1050\"][bgcolor=\"#000000\"]",".erKokMidashi,\n.horizontal-list","#right-content > nav:not([class]) + div.roundhead,\n#right-content > p.amatime,\n#right-content > ul#amarnk,\n#right-content2,\n.border_ad1",".mobhalf,\ndiv[class^=\"ga\"]",".blog_text a[target=\"_blank\"][rel=\"noopener\"],\n.blog_text a[target=\"_blank\"][rel=\"noopener\"] + br,\nscript + p + hr[size=\"1\"]",".c-ad--h250,\n.c-ad--tieup,\n.c-ad--w468,\n.c-ad-information,\n.c-ad_container",".l-header__ad_text,\n.p-shared-tieup__list","#my-footer > div[style=\"text-align:center;\"]","#btm_banner,\n#pomparadeArea,\n.mod-inn,\n.mod-recommend,\n.sidebar__liercoArea",".banner-a","a[title=\"Banner\"],\nimg[title=\"aaaaa\"]",".section > div.clear:has(> a[href^=\"https://amazon.co.jp/\"])","#side_slider2","#ad884-div-id,\n#links > div.sidetitle:last-of-type","#global-wrapper > div[style=\"text-align:center;\"] > div[style=\"display:inline-block;\"],\ndiv[style=\"text-align:center;margin-bottom:30px;\"]","#content1 div[style=\"text-align:center;\"],\n#wrapper > div#content1 + div.sidetitle,\n.postmain > table[border=\"0\"]",".entry-content > p:last-child > a[href^=\"https://www.amazon.co.jp/gp/search?\"][rel=\"noopener\"]","#wrapper > div[style^=\"margin:0 auto;width: auto; min-height\"][style$=\"text-align: center;\"],\n.article-body > div[style^=\"margin:0 auto;width: auto; min-height:\"],\n.cha_sp_all_header,\ndiv[class^=\"geniee_\"],\ndiv[style$=\"width: 970px; height: 250px\"]",".widget_custom_html.ad:has(> .textwidget > center > .adsbygoogle),\ndiv[id^=\"jpncu-\"]",".sub > div[style=\"width:200px; margin: 20px auto 20px;\"]",".custom-html-widget > a[href^=\"https://www.sokmil.com\"]",".l-pc_top_itiran_1st,\n.pc-all-right-3rd,\n.pc-keyphrase-sidecolumn-1st,\ndiv[class*=\"-ad\"],\ndiv[id^=\"ad_area\"]",".amazon-gift,\n.popular-book","#headline_banner",".header_add",".adsbygoogle ~ table[width=\"100%\"]","#custom_html-12.head-under,\n#custom_html-58,\n.fanzakiji,\n.fanzakiji2,\ndiv[align=\"center\"] > hr[style=\"border-style:solid 1px; border-color:#1a1a1a; width;100%; margin-bottom:50px;\"],\ndiv[style=\" width:65%;\"][align=\"center\"],\nheader + div.head-under","#content-top","#footer > div.footer-inner.shad,\n.adsensearea",".topentry_text",".entry-content > div[style^=\"text-align:\"],\n.padd,\n.padd + div[style=\"text-align: center;\"],\n.padd + div[style=\"text-align: center;\"] + p",".dadd",".ta-c > hr[width=\"760\"] ~ br:not(hr + br):not(font + br):not(font + br + br),\ncenter > table[width=\"807\"]:has(td[height=\"58\"] > font[size=\"+2\"] > a[href=\"happy/happy.html\"][target=\"_blank\"])","#blist > nav.panel > div[style^=\"border-bottom:1px solid\"][style*=\"text-align:\"]","#nwBanner,\n.ad:not(.col-312 > .ad:first-child),\n.book-pickup,\n.col-312 > section.small:last-child,\n.tomonokai + section:has(> div > div > a[href^=\"http://www.amazon.co.jp\"])",".prm","#rsspickup + div.box,\na[href^=\"https://a.r10.to\"][rel=\"nofollow\"],\na[href^=\"https://a.r10.to\"][rel=\"nofollow\"] + br,\na[href^=\"https://amzn.to\"][rel=\"nofollow\"],\na[href^=\"https://amzn.to\"][rel=\"nofollow\"] + br","table[border=\"0\"]:has(> tbody > tr > td[width=\"50%\"] > a[href^=\"https://al.dmm.co.jp/\"]),\ntd[width=\"100%\"]:has(> table[border=\"0\"] > tbody > tr > td[width=\"100%\"] > table[border=\"0\"] > tbody > tr > td > a[href^=\"https://al.dmm.co.jp/\"])","#vv_vv,\n.nin-pr,\n.sear_bb_w,\ndiv[class^=\"im-pr\"]","aside.box","#lcn-s_list_infeed1_gam,\n.l-contents--narrow,\n.p-adlcn,\n.p-information__section > div.e-book + p[style=\"text-align: center\"],\n.p-information__section > p:has(> iframe[src^=\"https://rcm-fe.amazon-adsystem.com/\"]),\n.r-items",".post_content > .p-blogParts:has(.pochipp-box a[href*=\"amazon.co.jp/dp/\"])",".bannerMain,\n.singlePostMv > .sidebar-title","#unblk",".adpc",".lol-r-affiliate,\n.widget-below-related-entries","#chatters + div[style=\"text-align:right;\"],\n.chatroom_ad_header,\n.layout_cont > div[align=\"center\"]:has(> a[href^=\"//\"][target=\"_blank\"]),\n.layout_cont > div[align=\"center\"]:has(> a[href^=\"//\"][target=\"_blank\"]) + hr","#広告-ad,\n.amazon-ko-ko-ku,\n.ko-ko-ku-area,\ndiv[id^=\"ad-blocker-\"]",".hide,\n[id^=\"ad_side_center\"],\ndiv[id^=\"ad_top\"]","#mhn_all_bb_gam,\n.ad-block + div.ranking-block,\n.wrap-PageInnerAD,\ndiv[class^=\"wrap-recommend\"]",".ablock,\n.amazon2",".aaprad_con,\n.side_pc_con > div[style=\"text-align:center; margin-bottom:30px; padding:10px; overflow:hidden\"]",".main_area div.m-b-20.pc_show,\ndiv[style=\"display: inline-block!important; margin-left: 5px; margin-right: 5px;\"],\nheader + div.pc_show","#content > center:has(> script[src=\"http://pagead2.googlesyndication.com/pagead/show_ads.js\"])",".toc",".adsense_p_2","div[class^=\"adSection_\"]",".mj-loop-article:has(> .loop-post-thumb > a[id^=\"Type\"]),\nhtml > body a[id^=\"Type\"]:not(#style_important)","#side_slider",".bam-card",".d-md-block.col[style^=\"flex:\"]","#sub > br","#main-2 > .post:has(> .pc_ad:only-child),\n#sp_list_recommend_frame + div.pc_only > div.pc_only.post:first-child,\n.news,\n.widget-area > div.widget-container:has(> div.pr_box)","a[href^=\"http://www.dmm.com\"] + br + hr,\ntable[cellpadding=\"10\"][width=\"870\"] + hr,\ntd[valign=\"top\"][width=\"635\"] > table > tbody > tr:first-child","#news_widget-2","#adview","[style^=\"font-size:90%;color:#999;\"],\ndiv[style$=\"background-color:#fafafa;padding: 5px;\"],\nform > div[style=\"margin: 1em 0;padding:0.1rem;background-color:#efefef;font-size:0.95rem;\"]",".contents_ad_wrap_center","#single_banner2,\n.side_col > div.widget_text:first-child,\n.side_col > div.widget_text:last-child",".sub_adv","#text-21","body > div[align=\"right\"]:last-of-type",".side_squer","#main_slider,\n#main_slider2,\n.sidebar_left_banner,\n.spSideNone:has(> li > div.app_icon)","div[style=\"width:100%;height:90px;\"],\ndiv[style=\"width:336px;height:280px;\"]",".Side > section.-category:first-child",".ad_article_center","#ads_2,\n.ad728-wrap,\n.ad__after > div.popular_article_pick_up,\n.wipe-ad-div-class","#ichiba",".article-middle-ad","#side_r > div[class^=\"plugin\"]:has(a[name=\"amazletlink\"])","#js-popup","#oCntrAd,\n#spgLoadAd,\n.apiRsltAd,\n.apiRsltFigAd",".ado-area,\n.adowidgets,\n.product-detail-purchase--floating",".onk16-widget,\ndiv[id^=\"onk16\"][style=\"width: 300px; \"]","#maintext > blockquote:has(> div.AmaQuick-box),\n.aban,\nblockquote:has(> div.amazon)",".custom-html-widget:has(> a[href^=\"https://www.amazon.co.jp/dp/\"]),\ndiv[style$=\"min-height:175px;\"]","#nuevoa","[id^=\"dmm_\"]",".goods","#banner-article,\ndiv[class*=\"ad_side_widget\"],\ndiv[class^=\"ad_side_widget\"]",".textwidget > center","#wrapper > div[style=\"text-align:center;padding-bottom:15px;\"]",".entry-content div[id^=\"oumi-\"]:has(> .oumi-adlabel),\n.oumi-widget",".kijinai_ad",".link_asp","div[id^=\"ad-in\"]",".sub-content > div[style=\"width:200px; height:200px;\"]","td[width=\"131\"]","#d_toparticle_flux_ad,\n.actions + section[style^=\"text-align: center; background: #FFF\"],\n.d_header",".adFooterBase,\n.adGamepageHeaderBase,\n.adMiddleRect2Css",".pr_box","#commentbody > div[style^=\"margin:5px 0px\"],\n.basehtml_side,\n.blogparts_freeArea:has(a[href^=\"https://www.amazon.co.jp/exec/\"]),\n.blogparts_freeArea:last-child,\n.inner_footer,\n.kiji_chuubu,\ndiv.mainmore > .inner","#links-left > section.-freeArea:last-child,\n.Article__content > div[align=\"center\"] > br",".sponsor-responsive,\ndiv[id$=\"-rectangle\"]","#right > div.hidden-sm > p,\n#right div[align=\"center\"] > table[border=\"0\"],\na[href=\"/adcookie.php\"],\np.“hidden-print”",".related-under","p[style^=\"min-height: 320px;\"]",".module:has(> script[src^=\"https://js.ad-spire.net/\"]),\ndiv[class^=\"article__title--ad\"]",".billboard__pr","#bannerdiv",".content_banner,\n.side_top_banner","div[style*=\"height:250px;\"]",".ad__bit,\n.article__billboard__video__container,\ndiv[class*=\"ad__container\"]",".thumb:has(> a[target=\"_blank\"]:only-child)","#maintitle_ad",".item[style],\ndiv[style^=\"width:1290px; height:280px\"]","#entry-list > div.entry-block:first-child,\n.side-02 > div.widget > div.textwidget > div.widget","td[rowspan=\"4\"][valign=\"top\"][nowrap=\"\"][align=\"left\"]",".text-center[style^=\" height: 300px; overflow: hidden; max-width:\"]:empty",".ads_sd,\n.ads_sd + br,\n.entry-content > ins.adsbygoogle + br,\ndiv[class^=\"gads-space\"]",".news-list-ad","#sidebarbody_r > div[align=\"center\"] > table[width=\"250\"]:has(a[href^=\"http://www.d-064.com\"])",".side--right","#links > div[align=\"center\"]:has(> table[style])",".plugin-message,\n.t_b[style^=\"font-weight:bold;font-size:16px;line-height:24px;background-color:#f5f5f5\"]",".-freeArea:has(> div > center > a[href^=\"https://click.linksynergy.com\"]),\n.-freeArea:has(> div > center > a[href^=\"https://www.amazon.co.jp\"])","#links",".text > a[href^=\"https://amzn.\"],\nimg[src*=\"amazon-adsystem\"] + br + a","#links-left > span[style=\"font-size:x-small;\"],\n.blogbody > div.text > a[href^=\"https://amzn.to\"][target=\"_blank\"],\n.blogbody > div.text > a[href^=\"https://www.amazon.co.jp\"][target=\"_blank\"]",".adreader,\n.adwidereader,\n.rakuten",".sekkaku-bbs-ad-point","div[align=\"center\"][style=\"font-size:12px;\"] > a[target=\"_blank\"],\ndiv[align=\"center\"][style=\"margin-top:60px; font-size:10px;\"] > br","div[align=\"center\"][style=\"margin-top:8px;\"]",".convert-ads","#st-header","div[align=\"center\"]:has(> ins.adsbygoogle)",".side-menu:has(> div > div.plugin-freearea > center > ins.widget-banner)","#ads_fieldOuter,\n#g_floating_tag_zone,\n#recommend_ad,\n.seesaa_channel,\nbody > div[style]:has(> table[border] > tbody > tr > td[height] > div[id^=\"criteo_slot_\"]),\nbody table[width=\"640\"] > tbody:has(> tr > td > a[href^=\"http://www.amazon.\"]),\ndd + table[cellspacing=\"0\"][cellpadding=\"0\"][border=\"0\"],\ndiv[style^=\"width:300px; height:250px\"],\ntd > div[align=\"left\"]:has(> a[href^=\"http://www.amazon.\"])","#item_ranking-2",".custom-html-widget > a:not([href^=\"https://shokuhin\"]),\na[id$=\"api-click\"]","#bnr1,\n#bnrSuperbannerBottom,\n#pc-campaign-appeal-01,\n#premiumPanel","#headerad_banner","center > b > a[href^=\"http://track.bannerbridge.net/click.php\"][target=\"_blank\"],\ncenter > strong > table[border=\"5\"][frame=\"void\"],\ncenter > table[cellpadding=\"5\"][bgcolor=\"#d3d3d3\"],\ncenter > table[width=\"935\"][height=\"100\"][cellpadding=\"10\"][bgcolor=\"peru\"],\nfont[color=\"#FF0033\"] > center > div[align=\"center\"],\nspan[style=\"display:block;margin:5px 0 0 0;padding:0;text-align:center;\"],\ntd > div[style^=\"padding: 5px; margin-bottom: 5px; border: 1px solid #cccccc; border-radius: 6px; text-align:\"][style$=\"background-color: #ffffff;\"]","table[style=\" FONT-SIZE: 18px\"][bgcolor=\"#ffffff\"][width=\"800\"][height=\"400\"],\ntable[style=\"FONT-SIZE: 12px\"][bordercolor=\"#ffccff\"][width=\"800\"][height=\"220\"],\ntd[valign=\"middle\"][width=\"800\"] > strong:first-child > font[color=\"#ff0000\"]:only-child","div[style^=\"min-height:180px;\"],\ndiv[style^=\"min-height:280px;\"]",".ds.first","#sub div.column-inner-2 > br,\n#sub div.column-inner-2 > table[border=\"0\"],\n.adbox2,\n.plugin-memo:has(> div.side > div.cstmreba),\ndiv[class^=\"article-body-\"] > div[class^=\"article-body\"] > div:not([class]):has(> div[align=\"center\"] > ins.widget-banner)",".layout_cont > div.small[align=\"center\"][style=\"margin-bottom:4px;\"],\n.layout_cont > div[align=\"center\"]:not(.prblock) + hr,\n.right_cont,\ndiv[align=\"center\"][style=\"margin:12px 0 24px 0;\"] + div.small[align=\"center\"],\ndiv[align=\"center\"][style=\"margin:12px 0 24px 0;\"] + div.small[align=\"center\"] + hr","#sidebar-scroll > aside.widget_custom_html,\n.entry-content > div.block-box:has(> div.wp-block-columns > div.wp-block-column div.wp-block-button > a[href^=\"https://amzn.to/\"])",".plugin-memo:has(> div.side > div > ins.adsbygoogle)","body > div.rwd:has(> ul.Article_box > li > p > a[href^=\"http://fam-ad.com/\"])",".wp-block-wp-quads-adds,\namp-iframe","#right_folder > div.textwidget > a[rel^=\"nofollow\"] > img,\n#right_folder > div.textwidget:has(> a[rel^=\"nofollow\"] > img),\n#right_folder > div.textwidget:has(ins.adsbygoogle)","div[id^=\"soman-\"]","#text-67,\n.stickyunit","#main_left,\n#main_right","#popup_area,\n.p-side-banner-lists","#amgatti_sk-3,\n#pc_text-80,\n#pc_text-94",".widget_text.ad","#down-articles > div.textwidget,\n#mybox > div.textwidget:first-child",".ml_ad_widget","p[style*=\"color:#333; text-align:center;\"]","br + center:last-child","font > b > a[target=\"_blank\"]",".ad-headerBottom","#pc_all_footer,\ndiv[style^=\"width:350px;height:290px;\"]","#cntAreaR > div[style*=\"padding:\"]:has(div[id^=\"div-gpt-\"]),\n#cntAreaR > div[style=\"border:1px solid #ccc;margin-bottom:10px;\"],\n#pc_all_inarticle,\n#pc_right_1st,\n#pc_right_2nd,\n.header-bn",".ads-statement,\n.sticky-container","#custom_html-65","a[data-atag-id]",".junk-ad-body,\n.nva-center,\nli.hidden-sm > a[href^=\"https:\"][target=\"_blank\"]","#pc_text-23,\niframe.lazyloaded[width=\"728\"][height=\"90\"]",".posts-under-1.widget_custom_html:has(> div.textwidget > iframe[src^=\"https://ad.duga.jp\"])","#side-fix",".article-header > center,\n.tmp-yarpp","#adexchange,\n#main-column > #trend-library:has(> .title-parts > span.ad),\n#sub-column > #information:has(> .title-parts > span.ad),\n.ad-bnr,\n.g-a-text,\n.special-articles > div.special-articles__item:has(> div[id^=\"div-gpt-ad-pc-\"]),\n.subsection:has(> .title-parts > span.ad),\n.tktopics:has(> h2 > span.ad),\ndiv[class^=\"g-a-bnr\"],\nul > li.block-pr",".rivals__graph-wrapper__ad,\n.shimen_finances__ad","a[href^=\"https://click.linksynergy.com/fs-bin/click\"],\na[href^=\"https://contents.fc2.com/aff.php\"]",".thre > object[data=\"/imobile.php\"]","div[id^=\"watch-\"]","div[class^=\"bg_ad_\"]",".c-max-width-height-350,\n.c-min-height-300x100-banner,\n.c-min-height-300x100-banner + div.c-min-height,\n.py-4","div[style=\"margin:auto;max-width:1400px;\"]","#is_w_area,\n.__isboostReturnAd,\na[id^=\"randomImageLink\"]",".ad-javascript","#content > div.widget_text:has(a[href=\"https://neetrio.jp/umalogdb/\"][target=\"_blank\"])","#block-11","div[class^=\"ad-inner\"]",".plugin-memo.sidewrapper:has(> div.side ins.adsbygoogle)","#header-r,\n#st-headerbox","#widget-under-sns-buttons","#sgpb-popup-dialog-main-div-wrapper",".sgpb-popup-overlay","#link_ad",".all-page > div[style=\"min-height: 270px; margin: 1em\"],\n.dmm-games,\ndiv[style=\"width: 90%;height:120px\"]","#my-footer > center","#execphp-38,\n.classic-textwidget:has(a[href^=\"//ck.jp.ap.valuecommerce.com\"]),\n.extendedwopts-show,\ndiv[style^=\"width:336px;height:280px\"]",".ad-banner-link,\n.carinsurance-link,\n.single-gallery-ad-hol-block,\n.type-1 > li:has(> div[id^=\"div-gpt-\"]),\n.webcg-1030,\n.webcg-ad1,\ndiv[id^=\"sub-top_2nd\"]",".j_pv_20:has(a[href^=\"https://www.amazon.co.jp\"][target=\"_blank\"]),\n[data-fee-style],\n[data-is^=\"riot-fee\"]:not(:has(.re_ph_2 > a[href^=\"https://donation.yahoo.co.jp/search/?\"])),\ndiv[data-style-lg=\"width: 728px;height: 90px;\"]",".sidebar_content > div.widget_custom_html:has(> div.textwidget > div.ad_block),\n.sidebar_content > div.widget_diver_widget_pcsp,\n.widget-shortcode:has(> div.execphpwidget > div[id^=\"div-gpt-\"])","#slide,\niframe[src*=\"wife-board.net/pr/banner\"],\niframe[src^=\"http://www.wife-room.net/pickup/\"],\ntable[border=\"0\"][width=\"100%\"] td[height=\"220\"][bgcolor=\"#F0F0F0\"],\ntbody > tr:has(> td > iframe[src$=\"/pr/bannercx81.php\"])",".entry-content > table[style=\"border-style: none;\"][border=\"1\"]","a[href^=\"https://www.banggood.com/\"],\ndiv[style=\"padding:20px 0px;\"] > center","body > .text-center[style*=\"height:\"][style*=\"280px\"]:has(+ nav > ul:empty)",".ads-native",".contentes_banner_2,\n.contents_ads_relation,\n.top_bottom_banner_box",".monthly_popular_wrap,\n.top_rss_side_ad","#third > div.plugin-memo:first-child,\n.adad",".aflImage,\n.aflLinkFlex,\n.extendedwopts-md-center.wtmne-widget",".hentry > .kizi-under-box:first-child",".l-main > aside.widget-page,\n.l-sidebar > aside.widget:first-child,\n.widgetPost","#pc_text-8",".topAdsenseArea",".banner-yoko,\ndiv[id^=\"im-\"]","#navi_recommend,\ndiv[id$=\"_ads\"]","#body > table:last-child","#secondary > div.widget_execphp,\n.article_wrap > p > span.red.b,\n.article_wrap > p:has(> span[style=\"color: #ff0000;\"]),\n.article_wrap > ul:has(> li > a[href^=\"https://amzn.to\"]),\n.free-area_after-cont > div.widget_custom_html,\n.free-area_before-title > div.widget_execphp,\ndiv[id^=\"JP_ZKN_\"]","#LeftAdBox > div.MenuBox:last-child,\n#ListPartner,\n#NaviTab_Ad,\n.MenuBox:has(> ins.adsbygoogle),\n.MenuBox[style=\"padding: 5px; min-height: 280px;\"],\n.PaddingTop10Bottom10[style=\"margin-bottom:5px; display: flex;\"],\ndiv[id^=\"ad_\"][id$=\"_top\"],\ndiv[style^=\"height: 250px; margin:\"]:has(> iframe[id^=\"ad_\"])",".MarginTop10Bottom10[style=\"height: 90px;\"]",".atid__wrapper",".ad[style^=\"min-width: 300px\"],\n.ad[style^=\"width:300px; height:250px\"],\n.ad[style^=\"width:310px; height:250px\"],\ndiv[id][style=\"width:300px;height:600px;\"],\ndiv[style^=\"min-width: 640px\"],\ndiv[style^=\"width:600px; height:200px\"]","#footer-container:has(> div.kahoku_pc_top_footeroverlay),\n.conteiner__main > div[style=\"line-height:1; border-bottom:1px solid #ccc; padding:8px;\"],\n.conteiner__main > div[style=\"min-width:686px;min-height:557px;\"],\n.page_hedding,\n.vr2_articleslist > .vr2_articleslist__item:has(> div[id^=\"div-gpt-\"]),\n.vr2_aside__area > div[style^=\"width:300px;min-height:\"],\n.vr2_bnrlist,\n.vr2_page_hedding,\n.vr2_pickuplist__item,\n.vr2_pr-main,\n.vr2_prlist,\ndiv[style^=\"display:flex; overflow-y:visible; position:fixed\"],\ndiv[style^=\"min-width:300px;\"],\ndiv[style^=\"min-width:728px; min-height:90px\"],\ndiv[style^=\"width:100%;min-height:250px;text-align:center;\"],\np.vr2_cate-title:has(+ .vr2_prlist)","#secondary > div.embed-responsive,\n#secondary > div.small,\n#secondary > video.w-100","#bigup2,\n#fuji-fns,\n#wrap_banner_billboard,\n.gf-slot-728,\n.image-area:has(> ins.adsbygoogle),\n.pr_contents,\n[class*=\"banner_type_\"],\ndiv[style^=\"border:1px solid #CCC;width:300px;margin:\"]",".wrap_pr_300_sky",".fixed-bottom,\ndiv[class^=\"my-ad\"]","#mw-content-text > div.ad.top[style*=\"min-height:\"],\n#mw-content-text > div.im[style^=\"min-height:\"],\n#mw-content-text > div[style*=\"min-height:\"]:has(> a[rel*=\"sponsored\"][target=\"_blank\"] > img),\n#mw-content-text > div[style*=\"min-height:\"]:has(> div.im > div[id^=\"im-\"] > script),\n#mw-content-text > div[style*=\"min-height:\"]:has(> div[id^=\"im-\"] > script),\n#mw-content-text > div[style*=\"min-height:\"]:has(> div[style] > div[id^=\"im-\"] > script),\n#mw-content-text > div[style=\"display: flex; flex-wrap: wrap; min-height: 250px; justify-content: center;\"],\niframe[src*=\"?affid=\"]","#footer > .pr,\n.sideColumnContainer > .content-block > .pr-block:not(:has(a[href=\"/reserve/omiyakenpo\"]))",".w-full > .text-center:has(> ins.adsbygoogle),\nmain > div.container > div.w-full:has(> ins.adsbygoogle)",".widget > a[href][target=\"_blank\"] > img",".g-a-banner,\n.g-a-rectangle,\n.g-a-rectangle-wrap",".widget-below-comment-form,\ndiv[id^=\"woman-\"],\nh3:has(+ div[id^=\"woman-\"])","div[style=\"float:left;width:600px;\\9 margin-top: 0px;margin-bottom:10px;\"]",".gad_pc,\n.sb-pc",".sidebar > section[id^=\"custom_html-\"],\nbody .my_adslotd",".article > div.no_print.mt10,\n.side_adarea1,\ndiv[class*=\"mb\"] > div.ml5[align=\"left\"]","#ad-double-rectangle","footer > div.container > div.row:not(:has(.text-muted))","#ad_rudel_1,\n#ad_rudel_2,\n#adv_dmm_main,\n#toContents + div[style=\"margin-bottom: 20px;\"]","#ad-box3","#pc_text-43","#advert_area_0",".b-r--before-site-content",".author + div.archive,\n.single > p[style=\"margin-bottom:10px;\"]","div[style=\"text-align:center;background-color:#000000;color:#FFFFFF\"],\ndiv[style=\"width:160px;margin-right:-175px;float:left;\"] > div[style=\"margin-top:10px;text-align:center;\"]:last-of-type,\ndiv[style=\"width:466px;background:#000000;color:#FFFFFF;text-align:center\"]","#p-SponsoredLink,\ndiv[style=\"font-size: 11px;\"]","#movie-last-movie > li:has(> center > ins[id])",".bottompr,\n.bottompr + a[href^=\"http://click.dtiserv2.com\"],\n.toppr,\n.videobottompr320x100","body > div[style=\"text-align: center;\"]",".adspc,\n[class^=\"sponsor\"]",".menubar > div[align=\"center\"] > a[target=\"_blank\"] > img,\ntd[width=\"95%\"][align=\"left\"][valign=\"baseline\"] > div[align=\"center\"][style=\"display:flex; flex-wrap:wrap; justify-content:center;\"]",".nearby > li:last-child:not([class])",".ads_pc_rectangle,\n.flux_ad_overlay,\n.list-group > tr:has(> td[style=\"text-align:center\"] > div[style^=\"padding-top:30px;\"])",".sidebar1-inner > aside.widget_text",".article__content > h3.module__heading,\n.side--right > section.module--free,\n[class*=\"spad_\"]","div[data-cptid][style],\ndiv[style$=\"height:90px; width:728px;\"],\ndiv[style^=\"margin:0 auto;height:\"][style$=\"px;\"]",".dfad:not(:has(> a[href^=\"https://www.todaishimbun.org\"])):not(:has(> a[href^=\"https://forms.gle\"]))","a[href=\"https://tomari.org/uri/amazon.html\"]","#mainBox > div.mainBack > div.bbsBox.smpt:has(> p > a[href*=\"/go.php\"]),\n#mainBox > h2:has(+ div.mainBack > div.bbsBox.smpt > p > a[href*=\"/go.php\"]),\n.sp-topad",".board_image","#right_wrap > div.right_plugin_wrap:has(> div.right_plugin_body > div[style] > ins.adsbygoogle),\ndiv[class^=\"adsense_article_\"]","#execphp-16",".entry-inner > table[width=\"600\"][height=\"250\"]",".side_category + aside",".left_main > a,\n.sample_block","div[id^=\"omc_ad_widget\"]",".script_box,\n.side-box-float-wrap,\na[id*=\"click\"][id*=\"banner_\"]","div[style=\"text-align:center\"]","#main-left > .center2,\n.tieup_rand_block","#player-wraper",".l-sidebar > aside.widget_block","span#ad",".normal-sidebar a[href^=\"https://www.amazon.co.jp/gp/\"]",".adsenseArea",".posts-under-2",".foogallery","#headerafficode",".post_content > table[style=\"border-collapse: collapse; width: 100%;\"]","p > a[target=\"_blank\"] > img","#videoDiv:has(> #addiv)","p > span.jump",".ads_za",".header-add.add-container,\n.side-column > .add-container",".aasc.center > iframe[class*=\"lazyload\"],\n.col-sm-4 > [id]:first-child:has(> ins.adsbygoogle),\n.col-sm-4 > [style=\"text-align:center;height:282px;overflow:visible!important;\"],\n.post_list[style=\"min-height:572px;max-width:1200px!important\"],\n.sidebar > div[style=\"height:2px;overflow:hidden;\"] + [class]:has(> ins.adsbygoogle),\ndiv[style*=\"min-height\"]:not([class])","#container > div[style=\"margin:0 auto;margin-top:2px;min-height:95px;text-align:center;\"],\n#sub > div.column-inner > div.column-inner-2 > div[style=\"text-align:center;\"],\n#sub a[href^=\"https://www.amazon.co.jp/gp/\"],\n.article-outer-3 > #article-options,\ndiv[style=\"width:100%;height:300px;\"]","#block-6",".article-body-inner > center > table","div[class^=\"article-body\"] > ul[id]",".SponsoredLink","#prs","iframe.lazyloaded",".p-table__contents--full.u-pt30vw-down-md",".u-dib",".adArticleSideTop300x250,\n.adHomeSideTop300x250","#bottomNbox,\n.wide_adbox",".entry-content > div.widget_text,\n.main-inner > .widget_text:has(> div > center > div.ml-slider),\n.post > center > a[href^=\"https://t.afi-b.com/visit.php\"]",".ad-banner:not([data-name=\"single-related-posts\"])",".post > .section-in > div[align=\"center\"],\n.post > .section-in > table",".sw-Ad,\n.sw-Ad-Banner,\n.sw-Amazon,\n.sw-Pcjack","div[class] > aside:has(> div[id^=\"gpt-ad-\"]),\ndiv[id^=\"gpt-ad\"]",".pr_link",".fresnel-greaterThanOrEqual-maxContent,\ndiv[class^=\"amazonHomeAd_\"]","div[style=\"width: 970px; margin: 0 auto 30px;\"]",".entry-content > div[style=\"text-align: center;padding: 15px 0;width: 339px;height: 286px;width: 100%;\"],\n.theiaStickySidebar > .ai-sticky-widget",".ad-common_pc-ranking",".blog-wrapper > center:has(> div#div-desktop > div[id^=\"div-gpt-ad-\"])",".article-tvbtn-under-ad,\n.c-ranking--type-b,\n.l-main > div.l-main-row:has(> .main-adarea),\n.u-lg-overflow-hidden[style=\"height: 200px;\"],\niframe.yahoo",".my-adspace,\ndiv[style=\"margin-top:10px; margin-bottom:10px; text-align:center;\"]",".ad > center > div[id^=\"div_fam_async\"]",".col-lg-4 > div[style=\"text-align:center;margin-bottom:15px;\"] div.panel-default:has(a[href^=\"https://prf.hn\"]),\n.row > div[class^=\"col-md-\"] > div[style^=\"text-align:center;margin-bottom:\"] > table[border=\"0\"]","iframe[height=\"250\"]","div[class^=\"gptad\"]",".footer-ads-recipe","#txtPr > span",".adcopy2 > a","div[style$=\"background: repeating-linear-gradient(45deg, #fff 0, #fff 10px, #eee 10px, #eee 20px); border: 1px solid #eee;\"],\ndiv[style^=\"width: 728px; height: 90px\"]",".lala-common-ad","#top-ad1-wrapper,\ndiv[id^=\"broadcast-content-ad\"],\nsection[id^=\"common-content-top-ad\"],\nsection[id^=\"top-sidebar-ad\"]","#uzou-chat-ad + div[class^=\"sc-\"]","center > center > table[width=\"807\"]:has(td[align=\"center\"] > a[href^=\"https://pcmax.jp/lp/\"]),\ntable[border=\"0\"][width=\"759\"] > tbody > tr > td[align=\"center\"]:has(a[target=\"_blank\"]:is([href^=\"https://pcmax.jp\"], [href^=\"https://happymail.co.jp\"])),\ntable[width=\"807\"]:has(td[colspan=\"5\"] a[href^=\"https://www.e-nls.com\"])","table[width=\"217\"]:has(a[href^=\"http://traffic-exchange.tv/bannerShare\"])",".adframe-container",".super_bnr_ufo",".video-plugin-skip-button",".pr_ad_text",".brand_panel","#ad9","#pr_ad","#interstitial,\n.container > div.sub-content > div[align=\"center\"][style=\"margin: 20px 0px;\"],\ndiv[id][style=\"min-width: 250px; min-height: 250px;\"],\ndiv[id][style=\"min-width: 320px; min-height: 50px;\"],\ndiv[style=\"min-width: 468px; min-height: 60px;\"],\nsection > div[align=\"center\"]:not([class]):not([style]):has(> img[src$=\"/pr_text.png\"])","div[align=\"center\"] > table[bordercolor=\"#FFFFFF\"]","div[style^=\"text-align:center;width:336px\"]","td[height=\"260\"][width=\"310\"],\ntd[height=\"290\"][width=\"320\"]",".parts-ad,\n.parts-ad-block,\nimg[src=\"images/parts/pr_text.png\"]",".swell-block-tab:has(.p-adBox),\n.wp-block-columns:has(a[href$=\"-today/\"])","#ad4","#product","a[href=\"https://chatreze.net/article/mamisc/\"]","#l-sidecontents > aside.plugin_first:first-child",".ggle-ad",".textwidget > p:has(> ins.adsbygoogle)",".contents-width > span > a[href^=\"https://www.sokmil.com/av/\"][target=\"_blank\"][rel]",".ads-area",".header_message_wrap",".ad > div.textwidget:has(> center > a[href^=\"http://pcmax.jp\"])","#sidebar > p.mg_b_5[style],\ndiv[style=\"width: 300px !important; height: 250px !important;margin-bottom:20px;\"],\np[style=\"margin-top: 80px;\"]",".article-body > p[style=\"text-align: center;\"],\n.toppagead",".tes_wrap",".widget_execphp",".c307ad",".article-body > center",".entry-content > p > a[href^=\"https://happymail.co.jp\"],\n.entry-content > p > a[href^=\"https://wlink.golden-gateway.com\"]",".admess,\n.sideBlock:first-child","#text-html-widget-2,\n.dspace-block,\n.wpap-tpl,\ndiv[style*=\"min-height\"][style*=\"height: auto\"]"];

const hostnamesMap = new Map([["*",0],["chiepedia.club",[2,129]],["adultgazobbs.com",2],["chem-station.com",[2,3,188,347,449,450]],["dietmiler.com",[2,22,189,532]],["electron-comic.com",2],["erokiwami.com",[2,171,619]],["erokune.com",[2,4,270,620]],["fx-koryaku.com",[2,232,724,725,726]],["gabarincho.com",2],["happymackeyblog.com",[2,24]],["hentai-share.com",[2,188]],["hyugarin.com",2],["ichimanabiblog.com",[2,449,878]],["idiom-encyclopedia.com",[2,66,77,188,881,882]],["innovationutah.com",[2,270,896]],["j-oosk.com",[2,780,925]],["kisslog2.com",[2,188,608,1026]],["koregasiritai.com",2],["m4ex.com",[2,429,1086,1087]],["ma-jann.com",[2,188,1088]],["marushin-magazine.com",[2,348,608,1117]],["monayoblog.com",[2,1176]],["moro-ai.com",[2,1180]],["nomadoma-daisen.com",[2,3,347,702]],["oreteki-design.com",[2,241,252,848,1317]],["p3fan.com",[2,23]],["saitoshika-west.com",[2,71,412,1375,1421]],["sanabo.com",[2,74,189,197,270,524,531,702,864,1248,1425,1426]],["sirabetter.com",[2,1470]],["tabanavi.com",[2,98,188,1511,1512]],["takahirosuzuki.com",[2,22]],["tech-biz-eng.com",[2,189,270,347,524,525,531]],["tispycat.com",[2,188]],["tsubuyaki0424.com",2],["videogakuen.com",[2,33,71,196,330,347,396,1248]],["xn--edksn8fbb6je1299kerqa.com",[2,262]],["yokohama-sports.com",[2,19,71]],["oppai-doga.info",[2,1751]],["aikatu.jp",2],["best-vape.jp",2],["carrozzeria-cdl.jp",[2,3,188,270,347]],["yama.minato-yamaguchi.co.jp",[2,2107]],["megabrasil.jp",[2,188]],["vr18.jp",[2,226,809]],["shinsengumi.link",[2,23]],["2week.net",[2,500]],["do-you-imi.net",2],["englishlands.net",2],["eroigame.net",2],["hagane-ya.net",2],["blog.katsubemakito.net",[2,3,270,347]],["lv73.net",[2,3,3302]],["maranic.net",2],["mohmongar.net",[2,3,188]],["mote-deai-xxx.net",2],["trade-environment.net",2],["sharevideos.org",[2,17,3509]],["dacelo.space",[2,30]],["anote.work",2],["disney-fun.xyz",2],["mangakansou.xyz",[2,3601]],["akiba3d.com",[3,66,226]],["appli-s.com",3],["ero-mangacafe.com",3],["mauyas.com",[3,270,347]],["ohoribella.com",3],["oshiireblog.com",[3,188]],["pcefan.com",[3,67]],["starwars-fan.com",[3,347]],["taku-blog.com",3],["silyugoi.cfbx.jp",[3,188,1969]],["briarpatch.co.jp",[3,2014]],["cazual.shufu.co.jp",[3,2176]],["k-knuckles.jp",[3,878,2494]],["modern-guitar-dive.jp",[3,188]],["chat-station.net",[3,3175]],["game16.net",[3,155,396,881,2177,3239]],["myjpop.jspinyin.net",3],["otonary.net",[3,188]],["blog.shimabox.net",3],["studiosero.net",[3,4,98,188,270]],["lagcapa.org",[3,188]],["ero-info-antena.site",[3,449,702,1523,3282]],["4thsight.xyz",[3,189,270,348,525,526,608,1166,3594]],["nuki-dokoro.com",[4,24,216,608,702]],["otonarisoku.com",[4,376,702,1325]],["romptn.com",[4,270,545,1416]],["rond8.com",4],["sekamaji-blog.com",[4,270,347,702]],["3040english.info",[4,347]],["bowz.info",4],["pocketwifi-hikaku.info",[4,270,702,1248]],["complesso.jp",4],["gamers1.jp",[4,347]],["tokyolucci.jp",[4,263,702]],["fpsjp.net",[4,69,571,702,3232,3233]],["genshin-matomech.umadacchi.net",[4,754,3442]],["bakotv.com",5],["video.fc2.com",[8,213,676,677,678,680]],["momon-ga.com",[8,1171,1172]],["shikotch.in",[8,1707]],["happycampus.co.jp",[8,2052]],["h1g.jp",[8,2407]],["hamic.ai",11],["ledge.ai",12],["adguard.app",13],["adguard.com",13],["adguard.info",13],["nordot.app",14],["majinai.art",15],["2ch-c.net",[15,810,1568,1936,3127]],["pictab.art",16],["ero-gazou.jp",[16,33,1133,1722]],["naitter.hippy.jp",[16,2424]],["leaked.jp",[16,810,2544]],["my-nikki.net",16],["azpek.asia",17],["tentacles.biz",[17,23,66,87,88,89]],["affi-convert.com",[17,225,226]],["akandama.com",17],["bsj-k.com",[17,414]],["cfnmroshutsucmnf.com",[17,225]],["chikiyasuibuki1104.com",[17,226]],["ero-doujin-blog.com",[17,67,89,226]],["eroero29.com",17],["freelance-jak.com",[17,225]],["hentai4610.com",17],["hhmanga.com",[17,23,225,429,837,838]],["javprice.com",17],["kaiten-heiten-24.com",[17,225]],["katsudonrecords.com",[17,23]],["kazenonaosikata.com",17],["kyomohot.com",17],["programming-se.com",17],["xn--u9jxj9b3c781sw80b0xxaz5s182b.com",17],["ysk-consulting.com",[17,88]],["mens-vio.info",[17,429]],["trendview.info",17],["bridgebook.jp",[17,335]],["blog.cgfm.jp",17],["dearfukui.jp",[17,218]],["g-times.jp",[17,87,225,226]],["ogurigo.jp",[17,376]],["rensai.jp",[17,2879]],["56s.thick.jp",[17,225]],["buhidoh.net",[17,3169]],["furugi1717.net",[17,827]],["gosanke.net",[17,225]],["hs-math.komaro.net",[17,23]],["movient.net",[17,3323]],["androplus.org",[17,98,3490]],["kimagurekizokunoadriatic.site",17],["l-media.tokyo",[17,23,66,158,225,226,429,3553]],["anotherlife.xyz",17],["newsclip.be",[18,19,20]],["sp.uta-net.com",[20,1593,1594]],["reserva.be",21],["bunkai.biz",[22,23]],["chimolog.co",[22,147,148,149]],["amehappi.com",22],["boosting-site.com",22],["higeojisan-lab.com",22],["kensho-zukan.com",22],["manga-comic-netabare.com",[22,1100,1101]],["manga-netabare-kanso.com",[22,881,1102]],["mangagift.com",[22,33,66]],["mazisuka.com",22],["mikobito.com",[22,1142,1143]],["moto-neta.com",[22,1183]],["multilingualtraveler.com",[22,270,429]],["nijiero-ch.com",[22,525]],["oyakudachi2525.com",22],["pokeca-new-card.com",22],["scawaiiweb.com",[22,352,356,1047]],["shiba-teire.com",22],["tomoyuki65.com",[22,827,1553]],["uruoistyle.com",22],["useful-notes.com",[22,188,543,1590]],["vtub0.com",[22,978,1101]],["ykigchi.com",22],["yukiq.com",22],["yuraika.com",22],["bge.jp",22],["bonsai.shikoku-np.co.jp",22],["dohack.jp",22],["gameo.jp",[22,1101,1644,2366]],["mangafull.jp",22],["point-game.jp",[22,102,2857]],["spread-sports.jp",[22,24,188,696,2941]],["tsuhon.jp",22],["pear-farmers.life",22],["crazy-irrumatio.net",22],["mupon.net",[22,201]],["topitane.net",[22,158]],["otakukosodate.work",22],["niko25niko.xyz",22],["lifematome.blog",[23,96,97,98]],["appl-y.com",[23,125]],["fromcocoro.com",23],["ikikatadatabase.com",[23,163,330,619]],["k-daidokoro.com",[23,88,972]],["mihomiho0109.com",[23,730,1140,1141]],["nana-trading.com",23],["oni-on-design.com",23],["gadget.phileweb.com",[23,1353]],["rawdd.com",23],["rittsun.com",[23,429]],["thedebu.com",23],["umaroidblog.com",[23,98,188]],["virtualgorillaplus.com",[23,225,226,429,1210,1606]],["xn--r8jwklh769h2mc880dk1o431a.com",[23,1651]],["yakyufan-asobiba.com",23],["boukenki.info",23],["m-raft.info",23],["popnews.info",23],["asianews2ch.jp",[23,376]],["bibilab.jp",23],["bonjour-anne.jp",[23,225]],["campify.jp",[23,158,225,1958]],["comicin.jp",23],["ibiza-games.jp",23],["kcsf-eco-ap.jp",23],["naruto-mon.jp",23],["shootingbar-ea.jp",23],["kanonway.link",[23,225]],["bkrb.net",23],["followcheck.itby.net",23],["wp-etc.navich.net",[23,158,429]],["urapo.net",23],["vapejp.net",[23,155,335,429,1665,3445]],["lovinyou.site",23],["culture-school.top",23],["senmonsyoku.top",23],["shinise.tv",23],["driverwork.xyz",[23,158,225]],["fruit01.xyz",23],["vegetables01.xyz",[23,3605]],["xn--btr874bhs1ao5h.xyz",[23,3605]],["crossbike.biz",24],["news.ajackiefeast.com",24],["anitubu.com",[24,269,270]],["apexlegends-leaksnews.com",[24,277]],["genshinnews.apexlegends-leaksnews.com",[24,190]],["apple-geeks.com",[24,281]],["automaton-media.com",[24,291,327]],["news.autonewscenter.com",24],["bazurecipe.com",[24,354]],["comicspoil007.com",[24,479]],["news.congdongytb.com",24],["news.containervanphong12h.com",24],["diendantruyen.com",24],["news.dogforms.com",24],["news.duanlibera.com",24],["eromanga-sora.com",[24,627,628]],["hoingaydi.com",24],["iqossan.com",[24,903]],["kojintekibikematomeblog.com",[24,385]],["mainoriti.com",24],["mizugigurabia.com",[24,1159,1160]],["naporitansushi.com",[24,347,523,1220,1221]],["nhasachmienphi.com",24],["oreno-erohon.com",24],["story.peeraw.com",24],["poire122.com",24],["pontako.com",[24,822]],["news.shouldibuythattoy.com",24],["spirituabreath.com",[24,1485]],["news.tiengnhatmoingay.com",24],["news.vietdiscovery365.com",24],["news.vnmaths.com",24],["xn--gmq92kd2rm1kx34a.com",[24,1647]],["news.xomsach.com",24],["yunikons.com",24],["zundad.com",24],["eizone.info",24],["okayadokari.info",24],["news.xepp.info",24],["news.codetheworld.io",24],["frozen.analyst.jp",[24,190]],["dxr.jp",24],["echigo-inakataiken.jp",24],["gameisbest.jp",24],["cocoseka.gamewiki.jp",24],["rere.jp",[24,2881]],["travel.spot-app.jp",[24,2940]],["volx.jp",[24,124,608,1583,3034]],["bl-archive.net",[24,252,1861]],["news.sonmy.net",24],["spoilerplus.net",24],["yoso-walk.net",24],["news.nenbiet.org",24],["daebak.tokyo",24],["pinksnailspa.us",24],["news.baovephapluat.vn",24],["news.thich.com.vn",24],["times.kinhteluatvcu.edu.vn",24],["news.fandom.vn",24],["news.nguoimua.vn",24],["news.animalworlds.xyz",24],["eizone.xyz",24],["gadgets.evolves.biz",25],["gamesindustry.biz",26],["gokkun.biz",[27,28,29]],["otokonoko.biz",[27,28,29]],["petanko.biz",[27,28,29]],["anarumama.com",[27,28,29]],["aokanmama.com",[27,28,29]],["ashikosu.com",[27,28,29]],["bata-wagina.com",[27,28,29]],["carsexspot.com",[27,437]],["chikubi-mu.com",[27,28,29]],["girikoki.com",[27,28,29]],["mazomenzu.com",[27,28,29]],["miwakunotango.com",[27,28,29]],["nanpamama.com",[27,28,29]],["ninshinmama.com",[27,28,29]],["nosemania.com",[27,28,29]],["pakomanmama.com",[27,28,29]],["panchirarizumu.com",[27,28,29]],["passion-passion.com",[27,437]],["peepspider.com",[27,28,29]],["pisuton.com",[27,28,29]],["sadomazomama.com",[27,28,29]],["sukatoromama.com",[27,28,29]],["taitsukingu.com",[27,28,29]],["tsubahaki.com",[27,28,29]],["worldporuno.com",[27,28,29]],["blackgal.net",[27,28,29]],["boindoru.net",[27,28,29]],["dadamore.net",[27,28,29]],["erocampus.net",[27,28,29]],["gerorian.net",[27,28,29]],["hamemama.net",[27,28,437,3251]],["hipup.net",[27,28,29]],["kochokocho.net",[27,28,29]],["muchimuchimama.net",[27,28,29]],["meisaku.org",[27,28,29]],["gurum.biz",[30,31]],["haijin-boys.com",[30,43,811]],["motivation-up.com",30],["natsukimemo.com",[30,1223]],["office-hack.com",[30,105,377]],["shin-shouhin.com",30],["anke.jp",30],["travelbook.co.jp",30],["cobwebs.jp",30],["news.biglobe.ne.jp",[30,2737]],["otonasalone.jp",[30,2845]],["starblog.jp",[30,2945]],["uma-x.jp",30],["4ka.net",[30,3133]],["cat.sc",30],["jumpmatome2ch.biz",[32,33,34,35,36]],["imashun-navi.com",[33,36,889]],["newageinglog.com",33],["umaumanews.com",[33,1583]],["news.sod.co.jp",[33,2177]],["animanch.com",[34,98,176,258,259]],["hostlove.com",[35,866]],["minpachi.com",[35,36]],["nan-net.com",[35,207,212,1213]],["enno.jp",[35,36,1062,1470]],["lab.syncer.jp",35],["j-lyric.net",35],["ap-siken.com",[36,274,275]],["db-siken.com",[36,275]],["erosexmanga.com",[36,637]],["fe-siken.com",[36,275]],["itpassportsiken.com",[36,274,275]],["nw-siken.com",[36,275]],["pm-siken.com",[36,275]],["sc-siken.com",[36,274,275]],["sg-siken.com",[36,275]],["gogo.gs",[36,105,1470,1704]],["games.wkb.jp",[36,105,3059]],["doucolle.net",[36,1087,3198]],["k05.biz",37],["z0i.net",37],["kagua.biz",38],["kaimyou.biz",39],["bamka.info",39],["keizai.biz",[40,41]],["afpbb.com",[40,228]],["hamakei.com",[40,41,812]],["shibukei.com",[40,41]],["baby-calendar.jp",[40,1865]],["e-mansion.co.jp",[40,105,2031]],["npn.co.jp",[40,105]],["minkei.net",[40,41]],["livedoor.biz",42],["livedoor.blog",[42,100,101]],["2chblog.jp",42],["blog.jp",[42,101,1303,1888,1889]],["bloggeek.jp",42],["blogism.jp",42],["blogo.jp",[42,1939,1940]],["blogstation.jp",42],["blogto.jp",42],["cafeblog.jp",[42,1940]],["corpblog.jp",42],["doorblog.jp",[42,101,447,564,1303,1889,2271]],["dreamlog.jp",42],["gger.jp",42],["golog.jp",42],["ldblog.jp",[42,51,1939,1940,2539]],["liblo.jp",42],["blog.livedoor.jp",[42,101,170,176,447,548,952,1034,1062,1303,1889,1916,1917,1940,2610]],["myjournal.jp",42],["mynikki.jp",42],["officeblog.jp",42],["officialblog.jp",42],["publog.jp",42],["storeblog.jp",42],["teamblog.jp",42],["techblog.jp",42],["xxxblog.jp",42],["youblog.jp",[42,1889,1940]],["diary.to",42],["weblog.to",42],["0taku.livedoor.biz",[43,44,45,46]],["birthofblues.livedoor.biz",43],["honwaka2ch.livedoor.biz",[43,54]],["newser.cc",[43,105,122]],["bipblog.com",[43,381,382,383,384]],["copysoku.com",43],["grasoku.com",[43,786,801,802]],["gundamlog.com",[43,787,803,804,805]],["hamusoku.com",[43,787,814]],["i2chmeijin.com",[43,876]],["ikarishintou.com",43],["itainews.com",[43,805,915,916]],["jumpsokuhou.com",[43,91,967,968]],["karukantimes.com",43],["kitizawa.com",[43,1019,1027]],["lovelivematocha.com",43],["moeplus.com",43],["nandemo-uketori.com",[43,1216]],["onecall2ch.com",43],["onihimechan.com",[43,1303]],["syurabahazard.com",[43,1303]],["tarosoku.com",[43,385,1523]],["usi32.com",[43,1591]],["news.2chblog.jp",[43,786,1785]],["oryouri.2chblog.jp",[43,1786]],["arrowknee-livedoor.blog.jp",43],["chomagireko.blog.jp",[43,1898]],["dark-soku.blog.jp",[43,354,1899]],["geinoutopics-plus.blog.jp",[43,1906]],["gensin.blog.jp",[43,239,1077,1908]],["kinsoku.blog.jp",[43,1915]],["pokebrary.blog.jp",43],["vtuber-matomeruyon.blog.jp",43],["ysokuhou.blog.jp",43],["carrot.dreamlog.jp",[43,2288]],["getnews.jp",[43,204,2133,2381]],["hosyusokuhou.jp",[43,2440]],["ascii2d.net",[43,213]],["ebitsu.net",[43,805,1931,3203]],["adultblogranking.com",[44,221,222]],["adultgle.com",44],["color-sample.com",44],["cour89.com",44],["diskgarage.com",[44,535]],["pokemon-gsc.g-takumi.com",[44,105]],["hayamimi-gunpla.com",[44,829]],["huyosoku.com",[44,874]],["karapaia.com",[44,1000]],["keyakizaka46matomerabo.com",[44,1013]],["manabi365.com",44],["moraerumall.com",44],["no-genkin.com",44],["on-ze.com",44],["puzzcore.com",[44,363,1204,1382]],["ryusoku.com",[44,1347,1419]],["tagindex.com",[44,1518]],["tanu-soku.com",[44,1522]],["troutangler-s.com",44],["smhn.info",[44,188,619,1759]],["tools4music.info",[44,1765]],["2nn.jp",44],["8mato.jp",[44,1796]],["ginnga.blog.jp",[44,1909]],["chixi.jp",44],["alphapolis.co.jp",[44,2004]],["chugoku-np.co.jp",[44,2022]],["nijimen.kusuguru.co.jp",[44,2095]],["sub.worldtimes.co.jp",44],["efight.jp",[44,2299]],["exile-fam.jp",[44,1796]],["febri.jp",[44,2323]],["flyteam.jp",44],["gaccom.jp",[44,2356]],["gamebiz.jp",[44,2358]],["gamepedia.jp",[44,2367]],["city.furano.hokkaido.jp",44],["iromame-beans.jp",[44,1796]],["jocee.jp",[44,1796]],["ladytopi.jp",[44,1796]],["city.chitose.lg.jp",44],["city.kushiro.lg.jp",44],["matomame.jp",[44,1796,2645]],["psychologicaltest.jp",44],["s8a.jp",44],["calorie.slism.jp",44],["charat.me",[44,3095]],["gori.me",[44,383,3099]],["blog2.mmm.me",[44,3112,3113]],["owata.chann.net",44],["ecodb.net",[44,3204]],["pctrouble.net",[44,105]],["blog.wanichan.net",44],["blog.with2.net",[44,222]],["postmap.org",[44,3507]],["nyahentai.red",44],["bishatti.com",[45,386]],["dateplus.red",[45,3523]],["aaieba.livedoor.biz",47],["akb48taimuzu.livedoor.biz",[48,49]],["nanjgod.blog.jp",[49,1924]],["bantyou.livedoor.biz",[50,51]],["eroduma.com",[51,603]],["moetataiken.com",51],["doucolle-kako.livedoor.biz",[52,53]],["chikakb.ldblog.jp",[53,2541]],["matometanews.com",[54,57,1126]],["lifehack2ch.livedoor.biz",55],["michaelsan.livedoor.biz",[56,57,58]],["akb48mt.com",[58,234]],["kimsoku.com",58],["pachinkopachisro.com",[58,234,1020,1328]],["baseballstats2011.jp",58],["hima-soku.doorblog.jp",[58,917,1034,2274]],["toushichannel.net",[58,64,3429]],["news4vip.livedoor.biz",59],["otanews.livedoor.biz",60],["seiyufan.livedoor.biz",61],["namaeuranai.biz",[62,63,64,65]],["alfalfalfa.com",[63,237,238]],["ironodata.info",[63,1735]],["kakijun.jp",[63,2500]],["gendai.media",[63,1139,3118]],["note.affi-sapo-sv.com",[64,227]],["carp-matome.blog.jp",65],["mapion.co.jp",[65,2103,2104]],["pointmall.rakuten.co.jp",[65,2150]],["wowkorea.jp",[65,3061]],["netgeek.biz",[66,67]],["azur256.com",66],["bright-b.com",[66,412]],["cent-hk.com",66],["coco2i.com",[66,87,88,225,469]],["doujin-voice.com",[66,158,429]],["hentai4daily.com",[66,87,226]],["javcc.com",[66,938]],["jp-idol.com",66],["jp-jav.com",66],["katfile-download.com",66],["keiba-atetai.com",66],["matsukishi.com",66],["nakiny.com",[66,704,1207,1208]],["sethplan.com",[66,158]],["soratoburin.com",66],["xn--glay-yn4c8b9a8lo661apz3h.com",[66,77,172,183,184,226,429,436,1316,1644,1645,1646]],["xn--mck5e585m.com",66],["yosshie.com",66],["erogazou.gallery",[66,1700]],["karatedo.co.jp",[66,98,524,1208]],["lomo-otoku.ssl-lolipop.jp",66],["a-zmanga.net",66],["gamejikkyou.com",67],["jpzipblog.com",[67,964]],["orenoraresne.com",[67,87,143,848,1313,1314,1315,1316]],["news.railway-pressnet.com",[67,619]],["yosemi-7.com",[67,1669]],["shikakuhiroba.net",[67,188,1236]],["anianierosuki.work",[67,87,387,388]],["news2019.biz",[68,69,70,71,72,73,74,75]],["kagoshima-gourmet.jp",[69,273,2499]],["aiolin.com",70],["douzin-q.com",70],["koikatsu-portal.com",[70,190,864]],["player440.com",70],["koe-voice.jp",[70,2518]],["taishon.nagoya",70],["shiroutowiki.work",[70,1282,3589]],["mettyaeeyan.com",71],["pinapopo.com",[71,87]],["yamiisoku.com",71],["spulse.info",71],["mobile.inest-inc.co.jp",[71,379,1555,2069]],["larksan.wp.xdomain.jp",[71,188,347,449]],["growrichslowly.net",[71,226]],["sukesuke-mile-kojiki.net",[71,73,270,620]],["ichimame.com",[72,197,218,491,524,641,864,877]],["taisy0.com",[72,125,827,1408,1519]],["daeudaeu.com",[73,162]],["holosoku.com",[73,167,620,864]],["vtuberseason.com",[73,74,526]],["bodymate.jp",73],["dennosokuho.com",[74,75,523,524,525,526,527]],["designoma.com",[74,531]],["sasebo2.com",75],["suresuta.jp",[75,2956]],["olch.biz",76],["deaisns1.com",76],["omezame.biz",[77,78]],["higashinada-journal.com",[77,155]],["u15-specialty.com",[77,184,558]],["retro-gamer.jp",[77,1493,1494]],["panchirasan.site",[77,347,882,1321,1367]],["anonelife.com",[78,272]],["dassen-azara4.com",[78,334]],["mtg60.com",[78,847,1190]],["tabi-rin.com",78],["plant-world.biz",79],["ryutsuu.biz",[80,81]],["lnews.jp",[81,2618]],["fgamers.saikyou.biz",[82,83,84]],["jnews1.com",[83,957,958]],["ameblo.jp",[83,242,1822]],["shanbara.jp",[83,2913]],["fashion-news.net",[83,84,449,3224]],["teach-me.biz",[85,86]],["appget.com",[86,280]],["av-baron.com",[87,328,329,330]],["minaminumaebi.blogmimi.com",[87,396]],["techtechnolog.com",[87,1528]],["xn--gutnkx91i.com",[87,225,429]],["kk1up.jp",[87,158]],["senzuri.net",87],["boin.pink",[87,3518]],["apprisejp.xyz",[87,225]],["alpaca76.com",[88,226,241]],["asiamediablog.com",88],["bluesea0925.com",[88,226,241]],["nihonjinnanmin.com",[88,429]],["vipcle2.com",[88,429,1041]],["j-air.jp",[88,225]],["nozokizennkaimax.xyz",[88,225,226]],["lionmaru.blog",[89,99]],["4610.adultav55.com",[89,220]],["erogazoufactory.com",[89,616,617]],["reiwa-kawaraban.com",89],["kankorekore.2-d.jp",[89,1173,1778]],["sozaino.site",89],["syukan.chinsiko.xyz",[89,143]],["xn--eckl0bk7f7cc4od8az005k0ssb.xyz",[89,500,2778]],["betweenjpandkr.blog",[90,91]],["abc-by.com",[91,201]],["burusoku-vip.com",[91,419,420,421]],["eddiarchive.com",91],["ganohr.net",91],["travel-nippon.net",[91,3433]],["vip-jikkyo.net",[91,188,3446]],["evolvinglife.blog",92],["digimamalife.com",92],["fayevery.blog",93],["mahjongsoul.info",93],["hatena.blog",94],["hatenablog.com",[94,817]],["blog.hatena.ne.jp",[94,2763]],["have-fun.blog",95],["re-doing.com",[95,1402]],["gfoodd.com",[96,778,779]],["nintendoevery.com",[96,778,1276]],["agemasen.com",[98,229]],["akirarok.com",98],["color-variations.com",98],["cyapu.com",98],["entameclip.com",[98,254,589]],["gadget-log.com",98],["gekibuzz.com",[98,768]],["jbjbgame.com",98],["kowakunotsubo.com",[98,412]],["murasan-net.com",98],["nonde-tabete.com",[98,158,225]],["salary-saver.com",98],["smartasw.com",[98,1475]],["switchsoku.com",[98,418,1507]],["tikitengo.com",[98,346,800]],["trovivo.com",[98,347]],["umamusumelabo.com",[98,354]],["xn--eckybzahmsm43ab5g5336c9iug.com",[98,201,449,702,1642]],["naga-ken.info",[98,531,773,1745]],["2chmeshi.net",98],["akkinews.net",98],["uzurea.net",98],["dq10.news",[98,1512]],["wpteq.org",98],["ske48matome.net",[101,234,561,1020,3402]],["newsoku.blog",[102,103,104]],["adult-machiko.com",[102,217]],["atodeyo.com",102],["minyu-net.com",[102,1156]],["nikkan-gendai.com",[102,1264]],["5chan.jp",[102,1794]],["ceron.jp",[102,200,1968]],["chunichi.co.jp",[102,2023,2024]],["kids.gakken.co.jp",102],["tokyo-np.co.jp",[102,2024,2191]],["townnews.co.jp",[102,1474]],["creatorzine.jp",[102,2239]],["cyclesports.jp",[102,2242]],["minpo.jp",[102,2675]],["db.msin.jp",[102,2705]],["pointi.jp",[102,2858]],["precious.jp",[102,2862]],["twpf.jp",102],["azby.fmworld.net",[102,3228]],["toyokeizai.net",[102,713,1469,3431]],["dq.h1g.jp",[104,449]],["peacedoorball.blog",[105,106]],["100n100r.com",105],["2chmm.com",105],["55sedori.com",105],["anime-hiroba.com",105],["new.atarasii.com",105],["athleterecipe.com",[105,315]],["baseball-data.com",105],["itest.bbspink.com",[105,361,362,363,364]],["blogmura.com",[105,397,398]],["candyrock25.com",105],["cyzowoman.com",[105,504]],["epub-tw.com",105],["ff10-hd.com",105],["figureskatejapan.com",[105,692]],["financial-field.com",[105,694,695,696,697,698]],["forbesjapan.com",[105,705,706]],["freesoft-concierge.com",[105,713]],["funabashi-tsushin.com",105],["hitoriblog.com",105],["karakoto.com",105],["kashiwa-tsushin.com",105],["katsushika-tsushin.com",105],["kaubel.com",105],["loo-ool.com",105],["manga-5.com",[105,1099]],["marshmallow-qa.com",[105,1114]],["maspiai.com",[105,1118]],["matsudo-tsushin.com",105],["min-repo.com",[105,1149]],["mindhack2ch.com",[105,1150]],["misato-gurashi.com",[105,1157]],["mono-money.com",105],["nachukichi.com",[105,1206]],["newsmatomedia.com",[105,1243]],["nicovideo-r18.com",105],["nikaidou.com",[105,1262,1263]],["onayamifree.com",[105,1300,1301,1302]],["jinja.otera-iine.com",105],["otokomaeken.com",[105,1322]],["otona-life.com",[105,1323]],["phileweb.com",[105,1351,1352]],["sci-pursuit.com",105],["sedoru.com",105],["sheepplus.com",[105,1450]],["sitebk.com",[105,377]],["4k.smartstartechnology.com",105],["smt-cinema.com",[105,1476]],["soccerdigestweb.com",[105,1478]],["sugoren.com",[105,1499]],["sukusuku.com",105],["tenbaiquest.com",105],["tetsudo-ch.com",[105,1534]],["tuber-ch.com",105],["twi55.com",[105,354]],["winningpost8.com",[105,1631]],["xn--n9jvd7d3d0ad5cwnpcu694dohxad89g.com",105],["yakkun.com",[105,1658]],["zukai-kikenbutu.com",105],["gundam-futab.info",[105,272,1727]],["rakuten-seo.info",105],["repeat-drama.info",105],["algorhythnn.jp",105],["ameba.jp",[105,1816]],["anmanko.jp",105],["ascii.jp",[105,1843]],["aviationwire.jp",105],["asianoneta.blog.jp",[105,787,1896]],["pazdra2ch.blog.jp",105],["bikebros.co.jp",[105,1605,2010]],["joqr.co.jp",[105,2083]],["jorudan.co.jp",[105,2084]],["nikkan.co.jp",[105,2116]],["family.php.co.jp",105],["ure.pia.co.jp",[105,2140]],["vogue.co.jp",105],["yomiuri.co.jp",[105,2230]],["coco-tte.jp",105],["cyzowoman.jp",105],["dogatch.jp",105],["dokuha.jp",[105,2267]],["newpuru.doorblog.jp",[105,667]],["e-words.jp",[105,654,2297]],["entamerush.jp",105],["erozine.jp",[105,2317]],["fujinkoron.jp",[105,1113,2299,2342]],["g-tips.jp",[105,377]],["gamewiki.jp",105],["getnavi.jp",[105,242]],["gingerweb.jp",105],["goetheweb.jp",105],["guitarmagazine.jp",[105,2399]],["hpplus.jp",[105,2445]],["idol-culture.jp",[105,2463]],["kamigame.jp",[105,2502]],["kanaloco.jp",[105,242,2508]],["town.niseko.lg.jp",105],["mainichi.jp",[105,398,1761,2633,2634]],["mikle.jp",[105,1302]],["mwed.jp",[105,210,696,2710]],["women.benesse.ne.jp",105],["ent.smt.docomo.ne.jp",[105,2742]],["e-typing.ne.jp",[105,553,2747]],["netatopi.jp",105],["newsphere.jp",[105,204,2784]],["mag.osdn.jp",[105,2838]],["otakomu.jp",[105,640,2281,2841]],["lp.p.pia.jp",[105,2853]],["qoly.jp",[105,213,2867]],["sai-zen-sen.jp",105],["smartlog.jp",105],["spaia.jp",105],["thetv.jp",[105,2978]],["ticketfes.jp",[105,2979]],["city.chofu.tokyo.jp",105],["tripnote.jp",[105,213,3002]],["vippers.jp",[105,3032]],["weblio.jp",[105,676,3044]],["gakufu.gakki.me",[105,3098]],["hinata.me",[105,242,3103]],["comicdb.lmn.me",105],["mangalove.me",[105,3110]],["hominis.media",[105,3119]],["itest.5ch.net",[105,362,363,994,3136]],["blog.ayurina.net",105],["bioweather.net",105],["buzip.net",105],["cinemacafe.net",[105,242,1400]],["ff8clear.net",[105,1631]],["gourmetpress.net",105],["h-taikendan.net",[105,3250]],["haryu-korea.net",[105,3253]],["kokopyon.net",[105,3284]],["myoji-kamon.net",105],["myoji-yurai.net",[105,3328]],["photoshopvip.net",105],["chat.shalove.net",[105,3388]],["sidelife.net",105],["vegelifemiki.net",105],["webcg.net",[105,2035,3453]],["webgaku.net",105],["ysklog.net",105],["yutura.net",105],["atopyandsobo.org",105],["johndoeblog.org",[105,3499]],["cytuschallenge.neocities.org",105],["jpon.xyz",[105,1704]],["haku.blue",107],["jetstream.bz",108],["reader.bz",109],["kanji.reader.bz",110],["cantera.camp",111],["video.520cc.cc",112],["520call.me",112],["chobit.cc",113],["final-fantasy.cc",[114,115,116]],["dragon-quest.jp",[114,115,116,2286]],["kingdom-hearts.net",114],["toragame.com",[115,116]],["blog.earthyworld.com",116],["minna.cc",117],["search.minna.cc",118],["hozonv.com",[118,871]],["po-kaki-to.com",[118,1368]],["twihub.net",[118,3437]],["okazuch.site",[118,431]],["miyachan.cc",[119,120]],["namjai.cc",120],["ffsagami.com",120],["junglekouen.com",120],["da-te.jp",120],["kyo2.jp",120],["naturum.ne.jp",120],["niiblo.jp",120],["sagafan.jp",120],["tamaliver.jp",[120,2961]],["osakazine.net",120],["hamazo.tv",[120,3569]],["blog.miyachan.cc",121],["seleck.cc",123],["happyrose.city",124],["2d-erocafe.com",124],["akashi-journal.com",124],["angry-mhm.com",124],["biru-mall.com",124],["camp-house.com",[124,225]],["eromoecom.com",124],["go-naminori.com",124],["ironotabi.com",124],["matsuiakinori.com",124],["optronics-media.com",[124,1310]],["ovninavi.com",124],["slender-model.com",124],["acueducto.jp",124],["kabutie.co.jp",124],["libertaction.co.jp",124],["we-love.shizuoka.jp",124],["news.sukupara.jp",[124,892,2953]],["toyo-2.jp",124],["analsexgay.net",124],["ani-chat.net",[124,790,1367,3143,3144]],["dspt.net",124],["iine-kunitachi.net",124],["ladybaba.net",124],["nerima-kosodate.net",[124,158]],["tipstour.net",[124,526,3424]],["bugbug.news",124],["yume100ntbr.org",124],["11874.click",125],["apexheadline.com",125],["collieme.com",125],["dq10beginner-media.com",125],["ebisu-fridaynight.com",125],["eternalcollegest.com",[125,641]],["matome.eternalcollegest.com",[125,412,608]],["gaddet.com",[125,733]],["kitaharima-hi.com",125],["kitaro38.com",125],["mitsuch.com",125],["otaku-sheepwolf.com",[125,412]],["pcfreebook.com",125],["sikopedia.com",[125,412]],["trendydenden.com",125],["yukawanet.com",[125,242,1677]],["9-bit.jp",125],["autoc-one.jp",[125,1857,1858]],["gardenstory.jp",[125,405,2375]],["yuu01.jp",[125,158]],["gamers-info.net",125],["netbusinessbox.net",125],["nilcollection.net",[125,827]],["pc-bto.net",[125,347,3350]],["ushigyu.net",[125,606,3197]],["webantena.net",125],["geek.sc",[125,347,3528]],["sekisei.click",[126,127]],["mukakin-blog.com",126],["okutta.net",126],["report.clinic",128],["ero-shame.club",130],["eroangle.club",[130,131]],["erogazoo555.com",[130,612,613]],["erogazoo.net",[130,3211]],["j-baseball.club",[132,133,134,135,136,137,138]],["j-basketball.club",[132,133,134,136,137,138,139]],["h178.com",[132,137,806]],["jukenbbs.com",[132,966]],["best-hit.tv",[132,134,3009,3563]],["bm.best-hit.tv",[136,137,138]],["pokemonsleep.club",140],["stelladia.club",141],["eigahitottobi.com",141],["wata-ridley.com",141],["takamaru1219.net",[141,3415]],["waral.club",[142,143]],["tamezatu.com",[142,272]],["eigo.plus",[143,270,347,882,2177,3521]],["zadankai.club",144],["misskey.io",[144,1773]],["warpday.net",144],["sushi.ski",144],["trpger.us",144],["mk.yopo.work",144],["amaebi.co",[145,146]],["netamesi.com",146],["takenokosokuhou.com",[146,1520,1521]],["bnewg.sokuho.org",[146,1521,3510]],["pizapoteto.com",[148,690,789,1314,1364,1365]],["freesoft-100.com",[149,553,712]],["mangaraw.co",150],["pan-pan.co",151],["sakidori.co",152],["005net.com",153],["addchannel.net",153],["0115765.com",154],["1000giribest.com",155],["kome3blog.com",[155,1041]],["yamakamu.net",[155,167,195,396,3467]],["dosukebe.site",[155,2177]],["100nuki.com",156],["1048s.com",157],["1173go.com",158],["check-pc.com",158],["kiragamiteru.com",158],["todoetan.com",158],["urutike.com",[158,1589]],["gayroom.jp",[158,226]],["99hs.org",158],["benefitdmv.site",158],["life-hack.xyz",158],["1201914.com",[159,160]],["totoneko.net",[159,3427]],["1242.com",161],["1616bbs.com",162],["189-0000.com",163],["tanu-blog.com",163],["20kaido.com",164],["2ch-matomenews.com",165],["2ch-mma.com",166],["afo-news.com",166],["antennabank.com",166],["newsnow-2ch.com",166],["besttrendnews.net",166],["konowaro.net",166],["matometatta-news.net",166],["news-choice.net",166],["news-three-stars.net",166],["2ch-uwaki.com",167],["hyougaki.xyz",167],["2chav.com",168],["2chcopipe.com",[169,170]],["cherio199.blog.fc2.com",[170,657]],["jisaka.com",170],["ponpokonwes.com",170],["suzusoku.blog.jp",170],["math-fun.net",[170,3309]],["openworldnews.net",[170,3340]],["2m3g1.com",[171,172]],["3dnchu.com",[171,182,183,184]],["cmjapan.com",[171,172,183,466]],["watch2chan.com",[172,1618]],["vitup.jp",[172,3033]],["blog.2nt.com",[173,174]],["youskbe.com",[174,1674]],["bottisoku.blog.2nt.com",175],["matomate.blog.2nt.com",176],["dxbeppin.com",176],["blog.esuteru.com",[176,639,640]],["supersolenoid.blog.fc2.com",[176,670]],["hattatu-matome.ldblog.jp",[176,2542]],["supersolenoid.jp",[176,670]],["moeeroheaven.blog.2nt.com",177],["352-mag.com",178],["hawaii-word.com",178],["soushiki-mag.com",178],["surfersite.com",178],["untenmenkyo-center.com",178],["373news.com",179],["3751chat.com",[180,181]],["chat.luvul.net",[181,3301]],["ashradar.com",183],["eromanga-daisuki.com",183],["kikublog.com",183],["rx7038.com",183],["hedge.guide",[183,690]],["bakufu.jp",[183,881,1866,1867]],["4meee.com",185],["4yuuu.com",[185,187]],["4ndan.com",186],["55kengo.com",188],["animemanga33.com",[188,267]],["asuneta.com",188],["canada-school.com",188],["doujin-game.com",188],["e-countries.com",[188,526,566,567]],["grisblog.com",188],["kaigaie.com",188],["kakeri-s.com",188],["masaralog.com",[188,196,524]],["motofan-r.com",188],["music-thcreate.com",188],["nonmama-blog.com",188],["setusoku.com",188],["softantenna.com",188],["sossy-blog.com",[188,330,396]],["vanilla-rock.com",188],["xn--eckveb0l002pve5b.com",188],["xn--sm-3g4aya4ck0dva9kwjzc.com",188],["xn--v8j5erc7ircta0r2694ac85c.com",[188,1143]],["tgiw.info",188],["feynman.co.jp",188],["gadgetrip.jp",[188,429,704,1173]],["marycore.jp",[188,2644]],["theyellowmonkey-movie.jp",[188,226]],["minatoku.net",188],["sbapp.net",[188,1314,3375]],["sim-jozu.net",[188,3400]],["uma-log.net",[188,189,347,567,3441]],["univnews.net",188],["blog.maripo.org",188],["minto.tech",[188,201]],["bloggingfrom.tv",188],["55paradise.com",189],["blogging-life.com",[189,348,394]],["mhw-blog.com",189],["cardfreaks.jp",[189,1962]],["financial-c.net",189],["talking-english.net",[189,270,348,449,3416]],["5app-ch.com",[190,191,192]],["adtechmanagement.com",[190,216]],["game-oruhachiv.com",190],["gamestlike.com",190],["shellbys.com",190],["yosk8.com",190],["sorae.info",[190,291,1760]],["fob.jp",[190,1282,2329]],["gazlog.jp",[190,2376]],["game-chan.net",[190,3238]],["cidresweet.com",191],["7-24blog.com",193],["2monkeys.jp",[193,1789]],["hobbylog.jp",[193,2425]],["724685.com",194],["728info.com",195],["erodou.tousatu.fun",[195,1167,1699]],["h-sextaiken.org",[195,1451]],["a-da-co-da.com",[196,197]],["fgsk8.com",[196,270]],["gazlog.com",[196,291]],["idle-girl.com",[196,883]],["kbn48.com",196],["macha795.com",[196,449]],["nufufu.com",[196,429]],["namatamago.net",[196,449,525,702]],["a-kimama.com",198],["a-to-monhan.com",199],["aba-net.com",200],["nicovideo.jp",[200,653,2789]],["shuminoengei.jp",[200,2925]],["2chan.net",[200,721,722,1749,2104,3128]],["bridalgown.work",[200,1062,1886,2355,3583]],["liquidfoundation.work",[200,1062,1886,2355,3582,3583,3587]],["tapestry.work",[200,3583]],["teaceremony.work",[200,1886,2355,3583]],["weddinghall.work",[200,1062,1886,2355,3583]],["kusoneko.blogspot.com",201],["nmbschedule.blog.fc2.com",201],["aoyagi-coffee.hatenablog.com",201],["ogeji.hatenablog.com",[201,824]],["tcg-bloglife.com",[201,1525]],["dn-voice.info",201],["46room.blog.jp",201],["moognyk.jp",[201,818]],["p2y.jp",201],["46matome.net",[201,384,1889,2281,3130,3131]],["keyakizaka46matomemory.net",[201,916,1303,3130,3280]],["abroadch.com",202],["ac-illust.com",[203,204,205]],["entamega.com",[204,590]],["photo-ac.com",[204,205,1354,1355]],["mitok.info",[204,1743]],["watch.impress.co.jp",[204,2064,2065]],["webcartop.jp",[204,1355,3042]],["odaibako.net",[204,1345]],["activitv.com",206],["adacomi.com",[207,208,209,210,211,212]],["bbspink.com",[207,357,358,359,360]],["illust-ai.com",[207,317]],["iyasiya.com",207],["radiolife.com",[207,1391]],["city.hirosaki.aomori.jp",207],["pref.osaka.lg.jp",[207,2581,2582]],["pref.shimane.lg.jp",207],["nanbbs.jp",207],["keimei.ne.jp",207],["5ch.net",[207,358,360,3134]],["crank-in.net",[207,3184]],["eroita.net",[207,209,3212]],["e-nenpi.com",[210,569,570]],["egolf.jp",[210,2300]],["number.bunshun.jp",[211,698,1951]],["news.denfaminicogamer.jp",[211,493,2065,2256,2257]],["numan.tokyo",[211,2256,3554]],["syosetu.com",212],["adaman-ero.com",213],["terakoya.asahi.com",213],["climbing-net.com",[213,354,465]],["demonition.com",213],["vip-front.video.g.fc2.com",[213,676,677,678]],["news.fresheye.com",[213,715]],["gaydebulog.com",213],["getchu.com",[213,775]],["hayamimi-hobby.com",[213,830]],["hoikuen-ranking.com",213],["pakutaso.com",[213,1331]],["allreviews.jp",[213,713]],["asajikan.jp",213],["classmethod.jp",213],["fantage.co.jp",[213,545,2040]],["kabuyoho.jp",213],["city.muroran.lg.jp",213],["pref.shiga.lg.jp",213],["city.yokkaichi.lg.jp",213],["money.smt.docomo.ne.jp",[213,2745]],["newswitch.jp",213],["russianbeauties.jp",[213,2891]],["wiki.seesaa.jp",[213,2906]],["city.unnan.shimane.jp",213],["smart-flash.jp",[213,2930]],["storie.jp",[213,2947]],["supari.jp",[213,218,487,2954]],["tanoshiiosake.jp",[213,2962]],["library.mitaka.tokyo.jp",213],["ichi-up.net",213],["kitimama-matome.net",[213,786,1676]],["nanpre.adg5.com",214],["adr-stock.com",215],["nikkei225jp.com",215],["adult3110.com",218],["kidanlog.com",[218,1015]],["xn--ecklz8ppb5cc7e3858d8zc.com",218],["nakoruru.jp",218],["pressroom.jp",218],["rpg-fan.jp",218],["abten.net",218],["cjcla.org",218],["phuot.site",[218,726,3534]],["open-code.tech",218],["adultangel.com",219],["advertimes.com",223],["aeoncinema.com",224],["bonblo.com",225],["entame-lab.com",225],["blog.imazeki-ryoga.com",225],["kokodora.com",[225,1036]],["minnano-casino.com",225],["carmania.info",225],["xox-tokyo.jp",225],["smartio.life",225],["oranne.net",[225,226]],["papamode.net",225],["vivahentai4u.net",225],["delmot-tea.org",[225,226]],["english-can.com",226],["gifubo-shine.com",[226,509]],["ichitaso.com",226],["keisan-mondai.com",[226,1008]],["doujin.koe-koe.com",[226,1032]],["amapc.p2pzen.com",226],["tsugumi-life.com",226],["wadaiwosaguru.com",226],["xn--h1sr7x3bs18i9rae26d.com",[226,429]],["gudeful.jp",226],["kawaii-girl.jp",226],["mathwords.net",[226,3310]],["sound-tv.net",226],["air-nifty.com",230],["cocolog-nifty.com",230],["hypplcs.com",230],["moe-nifty.com",230],["tea-nifty.com",230],["txt-nifty.com",230],["way-nifty.com",230],["akabane-shinbun.com",[231,232]],["bigyond2.com",[232,376]],["tsusshinofudeblog.com",232],["4gamer.net",[232,3132]],["akb48matomemory.com",233],["chaos2ch.com",[234,445,446,447]],["digital-thread.com",[234,498,534]],["fiveslot777.com",[234,699]],["kijyomatome.com",[234,1020]],["momoclonews.com",[234,1020]],["news109.com",[234,1020,1240]],["ske48matoeme.com",234],["chakuero-jyo-ho-koukanjyo.cafeblog.jp",[234,1956]],["akb48rompen.com",[235,236]],["sutekinakijo.com",[236,499,805]],["s2-log.com",[238,498,1420]],["all-nationz.com",[239,240]],["hiraganakeyaki.blog.jp",[239,240]],["kyarabetsunijiero.net",[239,1931]],["animesoku.com",240],["hero-news.com",[240,835]],["kijyokatu.com",240],["how-to-sexfriends.com",[241,870]],["manpiix.com",[241,389]],["nyuugyou.com",[241,389]],["oyabunx.com",[241,389]],["samuraixx.com",[241,389]],["yossense.com",241],["mamana.jp",241],["xn--hckl3e1e8a8ajin0czf.net",[241,389]],["am-our.com",242],["asahi.com",[242,297,298]],["basketball-zine.com",[242,351,352]],["curazy.com",[242,501]],["intojapanwaraku.com",242],["books.j-cast.com",[242,923]],["japanese.joins.com",[242,961]],["moneyforward.com",[242,370,1177]],["news.nifty.com",[242,354,553,698,1254]],["otonano-shumatsu.com",[242,1324]],["uta-net.com",[242,1592]],["yamahack.com",[242,794]],["animageplus.jp",[242,352,355,356]],["animeanime.jp",[242,1400,1826,1827]],["autocar.jp",242],["careerconnection.jp",242],["oricon.co.jp",[242,1206,1242,2132]],["otv.co.jp",[242,2136]],["saitama-np.co.jp",[242,1242,2160]],["tss-tv.co.jp",242],["news.tv-asahi.co.jp",242],["dailyportalz.jp",[242,2247]],["dime.jp",[242,2264]],["fishingjapan.jp",[242,2328]],["fujitv-view.jp",[242,2343]],["gamespark.jp",[242,1400,2369,2370]],["hira2.jp",242],["inside-games.jp",[242,1400]],["jocr.jp",[242,2485]],["mbs.jp",[242,606]],["mensnonno.jp",[242,2656]],["mynavi.jp",[242,792]],["smt.docomo.ne.jp",[242,367]],["knb.ne.jp",[242,2768]],["nishi2.jp",[242,2803]],["numero.jp",[242,2730,2806]],["projectdesign.jp",242],["qjweb.jp",[242,2865]],["matome.response.jp",242],["ryukyushimpo.jp",[242,2892]],["sitakke.jp",[242,2927]],["taishu.jp",242],["uhb.jp",242],["zigsow.jp",[242,3088]],["bepal.net",[242,3162]],["cafend.net",242],["encount.press",[242,3522]],["amatou-papa.com",243],["americakabu.com",244],["nanj.an-matome.com",245],["android-smart.com",[246,247]],["game-log.com",246],["tsumanne.net",[246,3434]],["androidjiten.com",248],["anichoice.com",[249,250,251,252]],["toychan.blog.jp",[250,1286]],["yosakoimatsuri.com",251],["ebetsunopporo.com",252],["sgamesreview.com",252],["shico.xyz",[252,3602]],["anicomigamania.com",253],["anige-labo.com",254],["keibadrive.com",254],["ohkashi.com",254],["psneolog.com",[254,1376]],["yomogame252.com",[254,1316,1645,1668]],["netouyonews.net",254],["haikara.news",254],["anige-sokuhouvip.com",255],["anigenavi.com",256],["anihatsu.com",257],["kuraberu.com",259],["moeasia.net",[259,3314]],["animatetimes.com",260],["anime-sharing.com",261],["anime-torrent.com",[262,263,264,265]],["automation-news.jp",[262,1859,1860,1861]],["warotanien.net",[262,3452]],["gamenv.net",[264,1578,3240]],["ichinuke.com",[265,879]],["jyosotalk.com",265],["hamlife.jp",[265,881,2409]],["animecomic-pass.com",266],["tvbok.com",[266,1573]],["aniplexplus.com",268],["cosmetics-trial.com",270],["erogamemod.com",[270,524,608,609]],["hotword-coolword.com",[270,868]],["blog.ko31.com",270],["pcmanabu.com",270],["saorerin.com",270],["tohaz.com",270],["coffee-station.fun",270],["zokeisha.co.jp",270],["blog.hisway306.jp",270],["kimootoko.net",[270,1367,3233,3281]],["annict.com",271],["5039.jp",272],["anytime-report.com",273],["douga.2shotdial.apcgi.com",276],["joshidaisei.axesslove.com",[276,336]],["axessmrs.com",[276,336,337,338,339]],["backsi.com",[276,337,338,340,341]],["berotuber.com",[276,336,337,341,375]],["lefty322.com",[277,330,978,1071]],["apexlegends-news.com",278],["apollomaniacs.com",279],["applealmondjp.com",282],["appli-huguai-matome.com",[283,284]],["omatome-info.com",284],["applikoryaku.com",285],["applinote.com",286],["appllio.com",287],["twidropper.appspot.com",288],["anzn.net",[288,3149]],["print-kids.net",[288,1761,3359]],["apptopic.com",289],["aprico-media.com",290],["osaka.arashitv.com",291],["arban-mag.com",292],["medibang.com",[292,665,1129]],["sirabee.com",[292,1465,1466,1467,1468,1469]],["arealme.com",293],["arkenji.com",[294,295]],["wakibungu.com",295],["sundaygamer.net",[295,330,561,3414]],["asagei.com",296],["asajo.jp",[296,1842]],["l-tike.com",298],["appli-maker.jp",298],["yahoo.co.jp",[298,1134,2205]],["maho.jp",298],["4years.asahi.com",299],["asm.asahi.com",300],["book.asahi.com",[301,302]],["maidonanews.jp",[302,1242,2629,2630]],["yorozoonews.jp",[302,2630,3084]],["digital.asahi.com",303],["dot.asahi.com",[304,305]],["360life.shinyusha.co.jp",[305,538,2169]],["globe.asahi.com",306],["mirror.asahi.com",307],["smbiz.asahi.com",307],["souzoku.asahi.com",[307,310]],["nakamaaru.asahi.com",308],["sippo.asahi.com",309],["telling.asahi.com",311],["asmr-labo.com",312],["at-s.com",313],["atelier-handmade.com",314],["atmos-tokyo.com",316],["atrain3d.com",[317,318]],["booksprivilege.com",[317,410]],["dq5clear.com",[317,318,552]],["h2ch.com",[317,807]],["html-css-javascript.com",317],["my-terrace.com",[317,1200]],["okinawaokuyami.com",[317,1295]],["virgintriumph.com",[317,1605]],["wpclear.com",[317,318,1636]],["ntv.co.jp",[317,2127]],["travel.rakuten.co.jp",[317,2153]],["conciergedesk.jp",317],["city.mikasa.hokkaido.jp",317],["pref.hokkaido.lg.jp",317],["pref.nagasaki.jp",317],["city.shinagawa.tokyo.jp",317],["anal-love.net",317],["repsoku.net",[317,3369]],["atsumori-tanukichi.com",319],["aucfan.com",[320,321,322]],["aucview.com",[320,322]],["detailtext-aucfan.com",320],["aucfree.com",[323,324,325]],["gekisaka.jp",324],["news-postseven.com",[325,1239]],["audio-sound-premium.com",326],["tojav.net",326],["spiced-media.com",329],["mhmatome.com",[330,790,1136]],["yasasiikurasi.com",[330,1365,1665]],["av-danyu.com",331],["av-sharing.com",332],["okazurand.net",[332,3338]],["avfuuzoku.com",333],["avtokutei.com",[334,335]],["papasu1102.com",[334,1335,1336]],["warorince.com",[334,1616]],["fitnesslove.net",334],["murakichi.net",[334,335,3325]],["gambatimes.com",335],["studentwalker.com",[335,748,1496]],["teyvatsokuho.com",[335,1339,1535]],["neo-blood.co.jp",[335,619,1644,2113]],["macsoft.jp",[335,1339,2626]],["nijisenmon.work",[335,500]],["bakusai.com",342],["balinavi.com",343],["bangkoknavi.com",343],["hawaiinavi.com",343],["hongkongnavi.com",343],["londonnavi.com",343],["macaonavi.com",343],["newyorknavi.com",343],["parisnavi.com",343],["pusannavi.com",343],["seoulnavi.com",343],["shanghainavi.com",343],["singaporenavi.com",343],["sydneynavi.com",343],["taipeinavi.com",343],["vietnamnavi.com",343],["bangofan.com",344],["dankanoko.com",344],["mamagoto.com",344],["blog.shinobi.jp",[344,2916]],["atgj.net",[344,513]],["edoblog.net",344],["kai-seki.net",344],["kuizu.net",344],["visualshoxx.net",344],["bannerkoubou.com",345],["baraero.com",[346,347,348]],["vtubersokuhou.com",[346,1610]],["dramanavi.net",[346,3201]],["debbysokuhou.com",347],["detail-infomation.com",[347,449]],["love-is-blue.com",347],["lowch.com",347],["dev.macha795.com",347],["teachios.com",[347,1526]],["yuki-portal.com",[347,1678]],["kindou.info",[347,1738]],["osusumecomic.net",347],["puchiho.net",[347,3144,3361]],["gigast.gigafile.nu",347],["tamashii-yusaburuyo.work",347],["base-y.com",349],["baseball-freak.com",350],["bbm-japan.com",[352,355,356]],["netkeizai.com",[352,355,356]],["nichinichi-magazine.com",[352,356,1250]],["rollingstonejapan.com",[352,355,356]],["driver-web.jp",[352,355,356]],["engineweb.jp",[352,355,356]],["nosweb.jp",[352,355,356,2213]],["oceans.tokyo.jp",[352,355,356]],["zaikai.jp",[352,355,356,1250]],["battlecats-db.com",353],["beasoku.com",354],["caramel-sp.com",[354,434]],["cyzo.com",[354,503]],["erodouga-s.com",[354,598]],["eromovie-s.com",354],["melty-novel.com",[354,1131,1132]],["milk-key.com",[354,598,1113,1146]],["mimitub.com",[354,1148]],["misty-novel.com",354],["purple-novel.com",[354,1131,1380]],["ramenhuhu.com",354],["report-newage.com",[354,1410]],["wazap.com",[354,745,1619]],["gourmet.aumo.jp",354],["travel.aumo.jp",354],["shimotsuke.co.jp",[354,752,2167]],["tv-tokyo.co.jp",[354,2016,2199,2200]],["japandesign.ne.jp",[354,2767]],["topics.or.jp",[354,2832]],["relazo.net",[354,3367]],["cinema.ne.jp",[355,1003]],["tennisclassic.jp",[355,2973]],["orangepage.net",356],["city.otaru.lg.jp",359],["city.kishiwada.osaka.jp",359],["benesse.ne.jp",[361,2727]],["bbspirits.com",365],["bcnretail.com",[366,367]],["hitosara.com",[367,859]],["goo.ne.jp",[367,2752]],["ocn.ne.jp",[367,2770]],["beadored.com",368],["beauty-navi.com",369],["becoolusers.com",370],["beelzeboulxxx.com",371],["beerbrick.com",372],["beikokukabu-etf-matome.com",373],["bengo4.com",374],["haru-journal.com",376],["life-alright.com",376],["nkskad.com",[376,724]],["gri.jp",376],["bijutune-expo.com",377],["billboard-japan.com",378],["billboard-rock.com",379],["digital-wallet.jp",379],["sotokabe.net",379],["billionwallet.com",380],["jp-weathernews.com",[380,962]],["keimusho.net",380],["gameludens.com",382],["mudasure.com",[383,1193]],["blog.game084.com",384],["kijoden.com",384],["negisoku.com",[384,1228]],["watarukiti.com",384],["genshin.blog.jp",[384,452,1907]],["nanjde.blog.jp",[384,1922]],["kimamamatome.doorblog.jp",[384,2276]],["2chmatome.net",384],["birori-blog.com",385],["hobby-museum.com",385],["blog.kaerucloud.com",[385,500]],["hamachan.info",[385,1728]],["danchitsuma.bishojo-oppai.com",[387,388]],["erodouga-onaking.com",[387,388]],["etude000.com",[388,642]],["bisyoujyox.com",389],["biteki.com",390],["bizushiki.com",391],["blog-and-destroy.com",392],["blog-sim.com",393],["blogmimi.com",395],["legend-anime.com",395],["livemimi.com",395],["meidomimi.com",395],["newtongym8.com",[395,1245]],["mimiblo.com",396],["baseballchannel.jp",[396,1870]],["business-mail.jp",[397,1952]],["n-seikei.jp",[397,2717]],["comic-pureri.jp",398],["gameranbu.jp",[398,2368]],["manga-comisol.jp",398],["baby.blogmura.com",399],["bozumemo.blogspot.com",400],["irasuton.com",400],["eikaiwamastery.blogspot.com",401],["kaikore.blogspot.com",402],["kledgeb.blogspot.com",403],["sandalaudio.blogspot.com",404],["ssbsblg.blogspot.com",405],["yuchrszk.blogspot.com",406],["blueskyzz.com",407],["umasiru.com",407],["bob-an.com",408],["bookmeter.com",409],["game.boom-app.com",411],["kisetsumimiyori.com",[412,784]],["reliphone.jp",412],["uptodate.tokyo",412],["brow2ing.com",413],["bucchinews.com",[415,416]],["kankeinai.blog.jp",416],["buhitter.com",417],["bukidobi.com",418],["korewaeroi.com",[418,1044]],["sagi-site.com",418],["xn--icktho51ho02a0dc.com",[418,865,1648]],["sabatech.jp",[418,1398,2894]],["heartlife-matome.com",[420,833]],["netakomori.blog.jp",420],["matome-tarou.ldblog.jp",[420,2543]],["valorantchannel.net",[420,3444]],["kijyomatome-ch.com",421],["majikichi.com",[421,1094,1095]],["konoyubitomare.jp",[421,1676,1916]],["business-textbooks.com",422],["businesschatmaster.com",423],["butsuyoku-gadget.com",424],["buzz-plus.com",425],["buzzfeed.com",426],["buzzyvox.com",[427,428]],["nna.jp",427],["c-camera.com",429],["chiebiyori.com",429],["coolbee1.com",429],["happy-news-style.com",429],["jsan-invest.com",429],["kikiki-fps.com",429],["shakinghip.com",[429,1449]],["animalbattles.wealthyblogs.com",429],["avianmedicine.jp",429],["mondra.jp",429],["noinfo-nolife.jp",429],["kokoro-racing.net",429],["spi.komaro.net",[429,3286]],["takapon.net",429],["c-dle.com",[430,431]],["more-gamer.com",431],["cad-data.com",432],["magazine.cainz.com",433],["carro-groce.com",[435,436]],["casabrutus.com",438],["cavolump.com",439],["cg-hentai.com",440],["cg-method.com",441],["xn--w8jtkjf8c570x.com",[441,1655]],["chaberi.com",442],["amachamusic.chagasi.com",[443,444]],["himanatokiniyaruo.com",[444,844]],["nikke-jp-news.com",[445,1268]],["blog19.fc2.com",447],["chekibbs.com",448],["cinema-sketch.com",449],["kana-mari-shokudo.com",449],["otakaranet.com",[449,1143,1315,1321]],["throwsmallstone.com",449],["wholenotism.com",449],["daij1n.info",449],["ssaits.jp",449],["bestrank.tv",[449,3566]],["chichi-pui.com",451],["chihosoku.com",452],["dondonwork.com",452],["ikuji-news.com",452],["kijobibouroku.com",452],["kimagure-kijyo.com",452],["kusainews.com",452],["maromeru.com",452],["momoclomatomex.com",452],["nandemomatomedan.com",452],["nijimoemoe.com",[452,1259,1260]],["pachinkolist.com",[452,1327]],["rare-channel.com",452],["ringofred53.com",452],["shurabanote.com",452],["wiiups.com",452],["yappaero.com",452],["toralucky.fun",452],["zootennis.fun",452],["akege.blog.jp",452],["j02r.blog.jp",452],["moemoeanime.blog.jp",452],["mon-st.blog.jp",452],["badminton.doorblog.jp",452],["buybuykorea.doorblog.jp",452],["egm.doorblog.jp",452],["idolgekijyo.doorblog.jp",452],["mankai-zakura.doorblog.jp",452],["mashlife.doorblog.jp",452],["shingekikyojin.doorblog.jp",452],["takegon.jp",452],["kagekidan.net",452],["shuraba.net",452],["uwasakijo.net",452],["taorun.xyz",452],["chijofile.com",[453,454,455]],["chijolog.com",[453,456]],["tekokeyland.com",[453,456]],["maniacture.com",[454,1109]],["chikuwachan.com",457],["chizaizukan.com",458],["chobirich.com",459],["chosunonline.com",460],["chouseisan.com",461],["cinemag-eiga.com",462],["clicccar.com",[463,464]],["moez-m.com",[463,518,1140,1165,1166,1167]],["erostopics.net",[463,3215]],["japan.cnet.com",467],["cocktaillog.com",468],["daeki-mania.com",469],["cocokara-next.com",470],["coindeskjapan.com",471],["coliss.com",[472,473]],["glam.jp",[472,2388]],["collabo-cafe.com",474],["color-hiyoko.com",475],["paiza.hatenablog.com",475],["namakeru.com",[475,1209]],["nekopictures.net",[475,1318]],["wackwack.net",475],["wanabe.net",[475,3451]],["psych0h3ad.tech",475],["comedydouga.com",476],["comic-days.com",477],["comic-walker.com",478],["koku-byakunews.com",479],["comione.com",480],["portal.connectedgamestore.com",481],["yahoo-jp.portal.connectedgamestore.com",482],["connpass.com",483],["conveni-now.com",[484,485,486,487]],["discka.com",[485,486,487]],["shisha-press.com",[485,486,487]],["smopia.com",[485,486,487]],["exogear.jp",486],["iqos-laboratory.com",487],["cookien.com",488],["news.cookpad.com",489],["coordisnap.com",490],["corocoro-tabi.com",491],["tvanimemuryoudouga.com",[491,525,531,864,1572]],["moqlog.jp",[491,524,545,1160,1591,2699]],["hmd.site",[491,3447]],["coromoo.com",[492,493]],["cosmopolitan.com",494],["elle.com",494],["esquire.com",494],["harpersbazaar.com",494],["womenshealthmag.com",494],["25ans.jp",[494,1779]],["ellegirl.jp",[494,2310]],["fujingaho.jp",[494,2341]],["costcotuu.com",495],["crankyseven-k.com",496],["crossbike-navi.com",497],["crx7601.com",[498,499]],["blue-archive.doorblog.jp",498],["csharpprogram.com",500],["mayukitchen.com",[500,1127]],["nullnote.com",500],["parlourfullslotl.com",[500,1338]],["paso-kake.com",[500,1339,1340,1341]],["solodc2017.com",[500,1341]],["economical.co.jp",[500,2032]],["hoshujapan.jp",[500,2438]],["tokyoupdate.jp",[500,2993]],["cysoku.com",502],["daifuku-diary.com",505],["dailynkjp.com",506],["dailynk.jp",506],["drama.damebito.com",507],["kansou.me",[507,3105]],["danna-shine.com",[508,509,510]],["dokuoya-shine.com",[509,543]],["traveltoku.com",[510,1564]],["danseisama.com",511],["jyoseisama.com",511],["vtubernews.jp",[511,3035]],["danshihack.com",512],["darumasangakoronda.com",513],["manga-cosplay.com",513],["dazn.com",514],["dddfont.com",515],["frames-design.com",515],["fukidesign.com",515],["kage-design.com",515],["calligra.design",515],["ddnavi.com",[516,517]],["kakakumag.com",[517,984]],["deai-help.com",518],["gadget2ch.com",[518,735]],["geinomatome.com",518],["mhwsmatome.com",518],["otonano.info",518],["blog.syumikatu.info",518],["toolmania.info",[518,1665,1764]],["curo.jp",518],["kinggonzalez.net",[518,3282]],["gameleaks.org",[518,3496]],["dechisoku.com",519],["dee-okinawa.com",520],["hobby.dengeki.com",521],["dengekionline.com",522],["tousatu-club.com",[523,608,1210,1367,1560]],["column.ifis.co.jp",[524,2058]],["kids-zoo.com",[525,1016]],["kurashinofusen.com",525],["asobou.co.jp",525],["nknews.jp",[525,789,2804]],["nkreport.jp",525],["i-think-it.net",525],["ff14.playguide2.net",527],["denwam.com",528],["dere-ken.com",529],["incident-wo.com",529],["sironet.work",529],["design-remarks.com",530],["iscle.com",[530,908]],["digihows.com",533],["dl-x.com",536],["dmm.com",537],["dmm.co.jp",537],["eikaiwa.dmm.com",538],["jetstar.com",538],["might-co.com",538],["bunshun.jp",[538,1949]],["wealthadvisor.co.jp",[538,2203]],["gizmodo.jp",[538,2385,2386,2387]],["hanakomama.jp",538],["retty.me",[538,3116]],["109cinemas.net",[538,3125]],["techno-edge.net",[538,1396,1400,3419]],["hentai-covers.site",538],["4545.to",538],["p-town.dmm.com",539],["dng65.com",540],["min.dododori.com",541],["doktornakanoblog.com",542],["dorama9.com",[544,545]],["english-speaking.jp",545],["womanlife.online",[545,1167,3146,3487]],["dorosoku.com",546],["douga-getter.com",547],["doujin-rpgfan.com",[548,549]],["doujinnomori.com",550],["doujinsokuhou45.com",551],["dq8clear.com",553],["game-gundam.com",553],["khclear.com",553],["moeyo.com",[553,1163,1164]],["himado.in",[553,1705]],["bi-girl.net",[553,3163]],["dqclear.com",554],["dqw-game.com",555],["dqwiki.com",556],["dragonquest11.com",556],["dragonquest9.com",556],["gustwiki.com",556],["laytonwiki.com",556],["mariokartwiki.com",556],["pokemon-wiki.com",556],["zapanet.info",[556,1771]],["draft-repo.com",557],["dragonball-neta.com",[558,559]],["xn--8uqt3cty5bwwbwwh.xyz",[558,622,3606]],["dragoooon.com",[560,561]],["corriente.top",[561,3558]],["driveplaza.com",562],["dtmstation.com",563],["dupcar-event.com",564],["dvdrev.com",565],["momojirinouen.com",567],["e-kodate.com",568],["hinakira.com",570],["rubiconbrewing.com",570],["voiceplus-php.jp",570],["e-penguiner.com",571],["fran-shushoku.com",571],["hegtel.com",571],["spla3sokuhou.games",[571,822]],["napgames.jp",571],["cybersocean.net",[571,3186]],["e-venz.com",572],["ear-phone-review.com",573],["eatout-hack.com",574],["ecnomikata.com",575],["egotter.com",576],["eiga.com",577],["eiga-watch.com",578],["anime.eiga.com",579],["tv.eiga.com",580],["eigajoho.com",581],["ekitan.com",582],["electrictoolboy.com",583],["elog-ch.com",584],["emonzyaku.com",585],["galleria.emotionflow.com",586],["emuokunmaster.com",587],["enrichoneslife.com",588],["reyuu-japan.com",588],["bitwave.showcase-tv.com",[588,1461,1462]],["entnavi.com",[591,592]],["inkyagamer.com",[592,895]],["ero-an.com",593],["eroanime-movie.com",594],["eroanimejk.com",595],["glamoroustube.com",[595,789,790]],["erobanach.com",596],["erodaizensyu.com",597],["erodougameijin.com",599],["erodougazo.com",[600,601]],["city.yatsushiro.lg.jp",[601,2523]],["erodoujinjohoukan.com",602],["eroelog.com",[604,605,606]],["tyoieronews.blog.jp",[604,1935,1936]],["gamer.ne.jp",[606,2634,2751]],["onlinegamer.jp",[606,2820]],["entax.news",606],["pinkch.eroelog.com",607],["smartparty.jp",608],["erogazo-ngo.com",[610,611]],["erogazopple.com",[611,614]],["roshutu-shuuti.net",613],["erogazou-pinkline.com",615],["itaeromanga.com",[616,628,914]],["erogematome.com",618],["japan-hentai.com",619],["xn--o9j0bk1914a8b2b.com",[619,1041]],["erologz.com",[621,622]],["eromanga-jkschool.com",623],["tokueromanga.com",623],["eromanga-school.com",[624,625]],["livechat-ero.net",[624,3297]],["eromanga-show.com",626],["hentai-one.com",626],["eromanga-time.com",629],["eromangajukujo.com",630],["eromazofu.com",631],["eromenskan.com",632],["erommdtube.com",633],["oreno3d.com",[633,1312]],["eronomoto.com",634],["eropasture.com",635],["eropuru.com",636],["erota2.com",638],["sumahodata.com",[641,1426,1502]],["eventernote.com",643],["english.evidus.com",644],["passnavi.evidus.com",645],["f1jouhou2.com",646],["fami-geki.com",647],["famitsu.com",648],["app.famitsu.com",649],["fashionsnap.com",650],["fc1adult.com",651],["fc2.com",[652,653,654]],["admin.blog.fc2.com",655],["beastmodeblock.blog.fc2.com",656],["gadgetdamage.blog.fc2.com",658],["gamemod.blog.fc2.com",659],["helpsupport.blog.fc2.com",659],["gtoys.blog.fc2.com",[660,661]],["wakudan.seesaa.net",660],["yoshidakenkou.net",660],["h723.blog.fc2.com",662],["infoany.blog.fc2.com",663],["joker004.blog.fc2.com",[664,665]],["newero1.blog.fc2.com",[666,667]],["newota.blog.fc2.com",[666,667]],["newresu1.blog.fc2.com",[666,667]],["newyaku.blog.fc2.com",[666,667]],["newmofu.doorblog.jp",667],["newssokuhou666.blog.fc2.com",668],["dokuo666.blog98.fc2.com",668],["northwood.blog.fc2.com",669],["uwagakisimasuka.blog.fc2.com",671],["katuru2ch.blog12.fc2.com",672],["blog47.fc2.com",673],["contents.fc2.com",674],["japan-baseball.jp",674],["adult.contents.fc2.com",675],["chara.ge",[676,1703]],["video.laxd.com",[678,1070]],["live.fc2.com",679],["web.fc2.com",681],["123hrs.web.fc2.com",682],["denkinyumon.web.fc2.com",683],["x.fc2.com",684],["fc2hub.com",685],["femimatsu.com",686],["ferret-plus.com",687],["ff14hikasensokuhou.com",688],["iyaaaao.doorblog.jp",688],["fig-memo.com",[689,690]],["figure-times.com",691],["kamikouryaku.com",[691,989]],["kamikouryaku.net",691],["filmarks.com",693],["kahoku.news",[695,3477]],["mi-mollet.com",[696,1138,1139]],["lovelive-ss.com",697],["thenewslens.com",697],["news.infoseek.co.jp",[697,2071]],["kyobun.co.jp",[697,2096]],["gqjapan.jp",[697,2396]],["huffingtonpost.jp",[697,2450]],["news.nicovideo.jp",[697,2795]],["peing.net",[697,3351]],["umamusume.net",[697,3443]],["qiita.com",[698,1386,1387]],["automesseweb.jp",[698,1862]],["nlab.itmedia.co.jp",[698,1203,2074,2076]],["sponichi.co.jp",[698,2179]],["flashff-blog.com",700],["fnjpnews.com",[701,702]],["happy-to-know.com",702],["towatowa.net",[702,1101,3430]],["waction.org",702],["anabundantlife.site",702],["48idol.tv",[702,3561]],["football-2ch.com",703],["footcalcio.com",704],["gosunkugi.com",704],["pinkpanfan.com",[704,1208]],["yoshitechblog.com",704],["avitter.net",[704,3158]],["vrc.wiki",704],["jbpress.ismedia.jp",[705,2472]],["forestofbreast.com",707],["formula1-data.com",708],["forzastyle.com",709],["freeimages.com",710],["freekontaktina.com",711],["city.kitami.lg.jp",713],["fresheye.com",714],["friends-esl.com",716],["sql55.com",716],["fruitfulenglish.com",717],["funemaga.com",718],["chowari.jp",718],["funny-ai.com",719],["futakuro.com",[720,721,722]],["may.nijiura-doll.info",[722,1749]],["fx-hakase.com",723],["adult-vr072.net",724],["jpmediadl.com",726],["nme-jp.com",[726,1278]],["fx-rashinban.com",727],["luchs.fxproject-blog.com",728],["fxshihyo.com",729],["ga-m.com",[730,731]],["gachi-matome.com",732],["natuyuki.com",733],["gadgerba.com",734],["gagetmatome.com",736],["tabkul.com",736],["gakkykun-game.com",737],["game-pc-bu.com",738],["i486.mods.jp",[738,2691]],["gameboku.com",739],["yjgames.gamedistribution.com",740],["gamefavo.com",741],["gamejksokuhou.com",742],["gamepix.com",743],["gamerch.com",[744,745,746]],["altema.jp",[746,1288,1814,1815]],["gamers-labo.com",[747,748]],["nurumayu.net",[748,3336]],["zzz.gamers-luck.com",[749,750]],["gameden.jp",[749,1535,2360]],["gaming-city.com",[751,752]],["kk-bestsellers.com",[752,1028]],["diamond.jp",[752,2258,2259]],["gamingdeputy.com",[753,754,755,756]],["hampee.com",755],["dietpartner.jp",[755,2262]],["javfree.me",756],["ganganonline.com",757],["gazounabi.com",758],["gazyekichi96.com",[759,760]],["josona.com",760],["speed.gigafile.nu",760],["ge-soku.com",761],["geartics.com",762],["geinou-nude.com",763],["geinou-sexy.com",764],["geinoujam.com",765],["geinoukame.com",766],["geitopi.com",767],["gekimatosoku.com",769],["gemelog.com",770],["gennji.com",771],["gentosha-go.com",772],["genxy-net.com",773],["gesoten.com",774],["kantangame.com",[774,996,997]],["kantan.game",[774,1701]],["yomipo.yomiuri.co.jp",774],["game.hiroba.dpoint.docomo.ne.jp",[774,997]],["getsuvolley.com",776],["getuploader.com",777],["ghibli-tosidensetu.com",780],["giants-news.com",781],["gigaho.com",[782,783]],["logworker.net",[782,3298]],["gintachan.com",784],["blog.thetheorier.com",[784,1318]],["rapidtables.org",784],["ginzamag.com",785],["girlsvip-matome.com",[786,787]],["jiji-kue.com",787],["kichimamasenki.com",787],["en.user-info.net",787],["girlswalker.com",788],["2ji.pink",[790,1618,3144,3517]],["go2senkyo.com",791],["goal.com",792],["impress.co.jp",792],["gogakuru.com",793],["gogo-miyagi.com",794],["camphack.nap-camp.com",[794,1219]],["izuhack.akao-hotel.co.jp",794],["goldage26000.com",795],["jpprepper.com",[795,965]],["golfnettv.com",796],["golfsapuri.com",797],["goo-net.com",798],["good-summary.com",799],["grasma.com",800],["pr-park.com",[800,1374,1375]],["saikyo-jump.com",802],["matomeblade.com",804],["ge-sewa-news.blog.jp",[804,1905]],["sunri2525.blog.jp",[804,1933]],["aqua2ch.net",[805,3154]],["hadakanonude.com",[808,809,810]],["idkeijiban.com",810],["kakaoid.com",810],["exploader.net",[810,3221]],["the-3rd.net",810],["deai.twitterid.net",810],["ukemi-no-kiwami.work",[810,1141,3592]],["hamapita.com",813],["hashirou.com",[815,816]],["seesaawiki.jp",[816,2907]],["anou4649.hatenablog.com",818],["noaboutsnote.hatenablog.com",818],["nomolk.hatenablog.com",818],["blog.munieru.jp",818],["b-taro.hatenablog.com",[819,820]],["yoima2.hatenablog.com",819],["kimpalife.com",819],["kobonemi.com",819],["kakkoii-kosodate.info",819],["blog.mshimfujin.net",819],["yume-ututu.hatenablog.com",820],["blog.treedown.net",820],["blog.hatenablog.com",821],["kuku81kuku81.hatenablog.com",822],["hikasango.com",[822,843]],["ryonkoroblog.com",822],["cutepink.work",[822,1318]],["nagano07.hatenablog.com",823],["omoshiro-hasshin.hatenablog.com",[823,825]],["valuable.hatenablog.com",823],["hotentry.hatenablog.jp",[823,825,2415]],["kansou-blog.jp",[823,2509]],["kalmia-works.net",823],["tamakino.hatenablog.com",826],["yagan.hatenablog.com",827],["kdrm4.com",827],["mtgoversears.com",827],["rojiuragame.com",827],["souda-kansai.com",827],["gigafile.ltd",827],["yoima.hatenadiary.com",828],["tadahome.info",828],["blog.amedama.jp",828],["hb-nippon.com",831],["hdouga.com",832],["heavy-peat.com",834],["hessionchiro.com",836],["openloadpro.com",[838,1307]],["spankbang-dl.com",838],["xvideos-dl.com",[838,1657]],["jav.direct",838],["asmr18.fans",838],["book18.fans",838],["popjav.in",838],["javprime.net",838],["twivideo.net",[838,3439]],["javfan.one",838],["nyahentai.re",[838,1171,1172]],["pingporn.ru",[838,3525]],["doujinantena.top",[838,1172]],["javmix.tv",[838,3571]],["hicbc.com",839],["hikak.com",840],["shindans.com",840],["doga.hikakujoho.com",841],["hikaritube.com",842],["nukistream.com",[842,1288]],["poyopara.com",842],["sugirl.info",842],["iqoo.me",842],["erry.one",842],["himasoku.com",845],["himatubushitrend.com",846],["bokumato.site",846],["himeb.com",847],["opantsu.fun",847],["win10labo.info",[847,1768]],["himmel-ellipse.com",[848,849]],["inshokuten.com",848],["kaiten-heiten.com",[848,978]],["xn--zckm5bnq2mpa6a1fz490bkx4ayzmvi9g.com",848],["hinapishi.com",850],["biz.hino-tama.com",851],["hinokoto.com",852],["hiragana46matome.com",853],["toriizaka46.jp",[853,2996]],["hiroburo.com",854],["his-vacation.com",855],["hisshobon.com",856],["ictmakes.com",856],["gogen-yurai.jp",856],["hitoikigame.com",857],["hitorinokurasi.com",858],["uwema-blog.com",858],["hkokuhaku.com",860],["hnalady.com",861],["hobbylabon.com",862],["hobonichielog.com",863],["holovtubermatome.com",865],["moti-soku.com",865],["kanto.hostlove.com",867],["how-to-inc.com",869],["hre-net.com",872],["htmq.com",873],["i-like-seen.com",875],["utagejima.jp",[878,3029]],["icon-surfer.com",880],["me-her.com",[881,1128]],["jn1et.com",882],["boshisoukan.net",882],["idol-blog.com",884],["ign.com",885],["ikebukuro-times.com",886],["ikikuru.com",887],["ikioi-ranking.com",888],["live-ranking.com",888],["peritter.com",888],["soraweb.net",888],["in-jpn.com",890],["inakadaisuki.com",891],["inazumanews2.com",[892,893]],["vw.mangaz.com",[892,1108]],["androck.jp",892],["infraexpert.com",894],["instagrammernews.com",[897,898]],["utaten.com",[897,1596,1597]],["rakuten-sec.co.jp",[897,2143]],["intensive911.com",899],["inter-edu.com",900],["inutomo11.com",901],["ipentec.com",902],["irasutoya.com",[904,905]],["nengaya.net",905],["irodorich.com",[906,907]],["kemochan.com",906],["ita-do.com",[909,910,911]],["tekoki-fuzoku-joho.com",[909,1530]],["kichikuou.com",[911,1014]],["ore-nijigazo.com",[911,1311]],["doujinhibiki.net",[911,3199]],["itachirin.com",[912,913]],["xn--pckyeuc8a9327cbqo.com",[913,1650]],["itaishinja.com",[917,918]],["monhan-mhw.com",[917,1179]],["jisakuhibi.jp",[917,2480]],["manga.itsys-tech.com",919],["iyuto.com",920],["izzetmtgnews.com",921],["j-cast.com",922],["j-cia.com",924],["jan39.com",926],["mag.japaaan.com",927],["japacrunch.com",928],["japan-railway.com",[929,930]],["newbalance-days.com",[930,1236]],["japan-secure.com",931],["japanjournals.com",932],["japanmetal.com",933],["jav321.com",934],["jav380.com",935],["javarchive.com",936],["javbus.com",937],["javcup.com",939],["javkun.com",940],["javple.com",941],["javtheater.com",942],["javtiful.com",943],["javtwi.com",944],["jidounten-lab.com",945],["jidoushatounan.com",946],["jiei.com",947],["jiji.com",948],["jin115.com",[949,950]],["yurukuyaru.com",[950,1680]],["jishin-yogen.com",[951,952,953]],["uwakich.com",[952,1598]],["hrs-game.main.jp",[953,2632]],["main-hrs-game.ssl-lolipop.jp",[953,2632]],["jiwasoku.com",954],["jm1xtk.com",[955,956]],["allabout.co.jp",[956,2002]],["city.soka.saitama.jp",956],["cmnw.jp",[958,1993]],["johojima.com",959],["johotaxi.com",960],["mcsg.co.jp",[960,2105]],["jpnumber.com",963],["jpopblog.com",964],["blog.janjan.net",965],["zch-vip.com",[967,1685]],["juniorsoccer-news.com",[969,970]],["rezv.net",970],["jyoshianaguguru.com",971],["kabegamikan.com",973],["kabu-sokuhou.com",974],["my.kabumap.com",975],["kaigai-antenna.com",976],["kaigainoomaera.com",977],["kakaku.com",979],["bbs.kakaku.com",980],["hoken.kakaku.com",981],["news.kakaku.com",982],["netmile.co.jp",[982,2114]],["waterserver.kakaku.com",983],["kakao-bbs.com",985],["line-bbs.manzoku100.com",985],["kakijun.com",986],["kakomonn.com",[987,988]],["dclog.jp",987],["inacity.jp",987],["kanajo.com",[990,991]],["blogterest.net",[991,3166]],["kandatasokuho.com",[992,993]],["yaruobook.com",[993,1664]],["buzzap.jp",[993,1955]],["c-ute.doorblog.jp",993],["cupmen.org",993],["kanjitisiki.com",[994,995]],["yuuu-nii.com",994],["atwiki.jp",[994,1847]],["kachimai.jp",994],["research-er.jp",[994,2882]],["city.kakegawa.shizuoka.jp",994],["city.imizu.toyama.jp",994],["t-mall.kantangame.com",998],["kantsuri.com",999],["kashi-mo.com",1001],["kasioda.com",1002],["kateigaho.com",1003],["jma.go.jp",[1003,2390]],["jma-net.go.jp",[1003,2390]],["novelup.plus",1003],["katuru.com",1004],["kazu-log.com",1005],["colombiacolom.net",[1005,3180]],["keibana.com",[1006,1007]],["iko-yo.net",[1007,3260]],["keitaijoho.com",[1009,1010]],["somanystars.net",[1010,3409]],["ken-g.com",1011],["kensetsunews.com",1012],["kidsna.com",1017],["kijonotakuhaibin.com",[1018,1019]],["kijyomita.com",[1018,1021]],["kazokuchannel.doorblog.jp",1018],["mojomojo-licarca.com",1019],["baiku-sokuho.info",[1020,1713]],["kingsmor.com",1022],["ygkb.jp",1022],["kinimininaru.com",1023],["kaigainohannou.info",1023],["kintore-style.com",1024],["kissfx.com",1025],["knshow.com",1029],["kodate-ru.com",1030],["sumu-lab.com",1030],["sumu-log.com",1030],["koe-koe.com",1031],["koimemo.com",1033],["kojimajan.com",1034],["kokodane.com",1035],["kokuchpro.com",1037],["kokuhakutaiken.com",[1038,1039]],["netoraretaiken.com",1039],["kokunanmonomousu.com",1040],["konest.com",1042],["konootokonoko.com",1043],["oppaimall.com",1043],["imagis.jp",1043],["costype.net",1043],["koreyome.com",1045],["koro-pokemon.com",[1046,1047]],["biz-journal.jp",[1047,1884,1885,1886]],["umk.co.jp",1047],["kosoch.com",1048],["koufuku-eki.com",1049],["koutchan.com",1050],["sai-kurashi.com",1050],["unjyou.com",1050],["umihiro.hateblo.jp",1050],["financepensionrealestate.work",1050],["kryk55.com",1051],["kyokugen.info",1051],["xn--10-yg4a1a3kyh.jp",1051],["news.kstyle.com",1052],["kumanichi.com",[1053,1054]],["er-animal.jp",[1054,2315]],["rkb.jp",[1054,2886]],["kumiko-jp.com",1055],["kurashiru.com",1056],["hikaku.kurashiru.com",1057],["pixiv.kurocore.com",[1058,1059]],["wws-channel.com",1059],["craftbeer-tokyo.info",[1059,1718]],["kurokawa707.com",1060],["kuroyonhon.com",[1061,1062]],["g-journal.jp",[1062,1885,1886,2354,2355]],["japan-indepth.jp",[1062,2479]],["beautifullywhitening.work",[1062,3581,3582]],["contents-group.work",[1062,1886,2355,3581,3582,3583,3584,3585]],["mineralfoundation.work",[1062,3581,3582,3585]],["nailcolor.work",[1062,1886,2355,3582,3583]],["nailenamel.work",[1062,3581,3582]],["kurusoku.com",1063],["kusurinomadoguchi.com",1064],["kyoteibiyori.com",1065],["kyukyoku-matome.com",1066],["musenboya.com",[1066,1197]],["kyunto.com",1067],["labaq.com",1068],["laboradian.com",1069],["les-koko.com",1072],["life-gogo.com",[1073,1074]],["zatsubitown.com",[1074,1682]],["lifeantenna.com",1075],["2ch-2.net",1075],["2ch-n.net",1075],["lions-matome.com",[1076,1077]],["meigen-chingen.com",1076],["yugioh-starlight.com",[1076,1675,1676]],["mhw.2chblog.jp",1077],["livechatdogaj.com",1078],["news.livedoor.com",[1079,1080]],["toyamadays.com",1079],["gata21.jp",1079],["loosedrawing.com",1081],["lovelive-petitsoku.com",1082],["lucky318b.com",1083],["lurenewsr.com",1084],["lyrical-nonsense.com",1085],["tuma.jp",[1087,3007,3008,3009,3010,3011,3012,3013,3014,3015]],["tumadouga.jp",[1087,3010,3012,3016,3017]],["hime.me",[1087,3008,3009,3010,3014,3101,3102]],["konyoku.net",[1087,3008,3009,3010,3011,3013,3014,3017,3102,3287]],["i-bbs.sijex.net",[1087,3398]],["toukou.tv",[1087,3008,3009,3010,3011,3015,3575]],["mabui-onna.com",1089],["mag2.com",[1090,1091]],["tripeditor.com",[1091,1566]],["maiuma.com",1092],["majandofu.com",1093],["ronsoku.com",1094],["makuring.com",1096],["manbooo.com",1097],["manetatsu.com",1098],["omansoku.com",1101],["sakasa-panty.com",1101],["shibukoi.com",1101],["mangahack.com",[1103,1104]],["soco-st.com",[1103,1479]],["mangalog.com",1105],["mangapedia.com",1106],["mangaz.com",1107],["manimax.com",1110],["marandr.com",1111],["mari-soku.com",1112],["marieclairejapon.com",1113],["daily.co.jp",[1113,2028]],["estate.nikkan.co.jp",[1113,2117]],["post.tv-asahi.co.jp",[1113,2198]],["39mag.benesse.ne.jp",[1113,2728]],["tosonline.jp",1113],["mart-magazine.com",1115],["maruhorror.com",1116],["match.com",1119],["math-travel.com",1120],["win-tab.net",[1120,3458]],["matome-plus.com",1121],["matome-plus.net",1121],["matomeantena.com",1122],["matomecup.com",1123],["news.matomegamer.com",1124],["matomelotte.com",1125],["multirecommend.com",1127],["yugioh-resaler.com",1127],["zatsugaku-company.com",[1127,1683]],["juantonto.official.jp",1127],["meiwasuisan.com",1130],["memopanda.com",1133],["eroiro.info",[1133,1722]],["bluelady.jp",[1133,1942]],["mercari.com",[1134,1135]],["fril.jp",[1134,2071,2337]],["mhw-matome.com",1137],["sumahoinfo.net",[1140,1141,1166,3413]],["starworldtrend.com",[1142,1492,1493,1494]],["milcow.com",1144],["mildch.com",1145],["milkberry.com",1147],["minkch.com",1151],["minna-antenna.com",1152],["minnano-anime.com",1153],["minnano-av.com",[1153,1154]],["minsalo.com",1155],["misuzu-message.com",1158],["eatmania.jp",1158],["kirei-lab.jp",1158],["hugnet.life",1158],["myphotostyle.org",1158],["mmd-list.com",1161],["moe-vip.com",1162],["rankingoo.net",[1163,1469,3366]],["nihongoka.com",[1167,1256]],["saitamarket.com",1167],["shicony.com",[1167,1451]],["xn--f6q12aj29i.com",[1167,1643]],["mogeringo.com",1168],["moguravr.com",1169],["momoiroadult.com",1170],["momoniji.com",1173],["mona-news.com",1174],["monamona2525.com",1175],["uragi.com",1175],["media.moneyforward.com",1178],["mosaic-jack.com",1181],["moshi-nara.com",1182],["movie-rush.com",1184],["moyugenn.com",1185],["mozakin.com",1186],["bbs4.mozakin.com",[1187,1188]],["nagasaki-np.co.jp",[1188,2110]],["msn.com",1189],["mudainodocument.com",[1191,1192]],["nieru.net",1192],["mukulog.com",1194],["munesada.com",1195],["muragon.com",1196],["mutyun.com",1198],["my-best.com",1199],["mymo-ibank.com",1201],["mysterynavi.com",[1202,1203,1204]],["n-styles.com",1205],["campus-hub.jp",1206],["fukuishimbun.co.jp",[1206,2025,2044,2045]],["gigafree.net",[1206,1966,3244]],["japohan.net",1208],["namba-osaka.com",1210],["naming-dic.com",[1211,1212]],["hatsuon.info",1211],["comic.nan-net.com",1214],["nanasepn.com",1215],["nanohanana.com",1217],["naoblogpcgame.com",1218],["be-my-slave.info",1220],["narutonti.com",1222],["natuero-dougakan.com",1224],["navinavi-hoken.com",1225],["nazolog.com",1226],["nazoq.com",1227],["nekotto-life.com",1229],["play.neos-easygames.com",1230],["ycp.synk-casualgames.com",1230],["net-frx.com",1231],["netkeiba.com",1232],["nar.netkeiba.com",1233],["netorarezukiview.com",1234],["new-akiba.com",1235],["supportcenternavi.com",1236],["you1news.com",[1236,1670]],["newmatoan.com",1237],["newmatosoku.com",1238],["newsee-media.com",[1241,1242]],["htb.co.jp",1242],["news.tv-aichi.co.jp",1242],["reader.futabanet.jp",[1242,2353]],["lisani.jp",1242],["yomuno.jp",[1242,2808]],["newsmomonga.com",1244],["nfljapan.com",1246],["nicheee.com",1247],["nichepcgamer.com",[1248,1249]],["nifty.com",1251],["game.nifty.com",1252],["repiiii.goo.ne.jp",1252],["myhome.nifty.com",1253],["nihon-eiga.com",1255],["nijiero-view.com",1257],["nijifeti.com",1258],["javdougaero.xxxblog.jp",[1259,3072]],["nijitoraware.com",1261],["app-liv.jp",[1262,1833]],["nikkanerog.com",1265],["nikkansports.com",1266],["p.nikkansports.com",1267],["nikkei.com",1269],["business.nikkei.com",1270],["magazine.nikkei.com",1271],["woman.nikkei.com",[1272,1273]],["active.nikkeibp.co.jp",[1272,2119]],["bio.nikkeibp.co.jp",[1272,2120]],["nfm.nikkeibp.co.jp",[1272,2121]],["xtech.nikkei.com",1274],["xtrend.nikkei.com",1275],["nitiweb.com",1277],["games.nme-jp.com",1279],["nocturne-tokyo.com",1280],["nomad-saving.com",1281],["nonbirikimama.com",1282],["norisoku.com",[1283,1284]],["densetsunokijo.net",1283],["celery.diary.to",[1283,3542]],["ntrblog.com",1285],["nukemanga.com",1286],["nuki-dou.com",1287],["twi-dl.net",1288],["twi-videos.net",1288],["nullpoantenna.com",1289],["o-uccino.com",1290],["oceans-nadia.com",1291],["ohtabooks.com",1292],["oisiso.com",1293],["okashimart.com",1294],["olive-hitomawashi.com",1296],["omosoku-r.com",1297],["onani-daisuki.com",1298],["iphone.onani-daisuki.com",1299],["wara2ch.com",[1299,1615]],["workch.jp",[1301,1302]],["yagov30.com",1303],["oniyomediary.com",1304],["ontomo-mag.com",1305],["ooiotakara.com",1306],["oppainorakuen.com",1308],["oppaisan.com",1309],["oshinpoke.com",1318],["under-taker.com",1318],["oshioki24.com",1319],["osiri-suki-club.com",1320],["oyako-kufu.com",1326],["paipan-holic.com",1329],["pakosen.com",1330],["panchiragazo.com",1332],["monolog.r-n-i.jp",1332],["btnmaker.me",[1332,3093]],["fig-memo-r18.site",[1332,3531,3533]],["pandachirari.com",1333],["panty-kiwami.com",1334],["plus1world.com",[1334,1367]],["xn--u9j3iub5080abs7bxbc.com",[1334,1652]],["utakata.work",1335],["parashuto.com",1337],["xn--cbkxbyfwj.net",[1339,3465]],["automove.jp",[1341,1863]],["run-way.jp",1341],["passlotime.com",1342],["pazusoku.com",[1342,1346]],["patanouchi.com",1343],["pathee.com",[1344,1345]],["pcrecommend.com",1347],["peepxx.com",1348],["peko-step.com",1349],["petyado.com",1350],["city.yachiyo.chiba.jp",1352],["photo-tea.com",1356],["photosku.com",1357],["picb2.com",1358],["a.picb2.com",1359],["pinktower.com",1360],["pisuke-code.com",1361],["pixiin.com",1362],["piyonote.com",1363],["playlearnlife.com",1366],["pointtown.com",1369],["poipiku.com",1370],["pokemasujikaku.com",1371],["pokemonbbs.com",1372],["pokemongo-get.com",1373],["xn--zcka7aza6gyb9jd.net",1374],["pulpxstyle.com",1377],["punyu.com",1378],["purelovers.com",1379],["puu-antenna.com",1381],["puzzle-ch.com",1383],["pvpoke-re.com",1384],["pwrtube.com",1385],["travel.mdpr.jp",[1387,2650]],["syougi.qinoa.com",1388],["quick-timez.com",1389],["r18blog.com",1390],["raifuappu.com",1392],["rank1-media.com",1393],["rapidshare-com-files.com",1394],["rastaneko-blog.com",1395],["rbbtoday.com",[1396,1397,1398,1399,1400]],["s.cinemacafe.net",1399],["gamebusiness.jp",1400],["response.jp",[1400,1827,2133,2369,2885]],["roundup-gamers.jp",1400],["speed.rbbtoday.com",1401],["jpnculture.net",[1402,1583,3273]],["re-file.com",1403],["rebosoku.com",1404],["recipekensaku.com",1405],["record-now.com",1406],["recotripp.com",1407],["reikawatanabe.com",1408],["renso-ruigo.com",1409],["next.rikunabi.com",1411],["roboanime.com",1412],["robokumac.com",1413],["rocketnews24.com",1414],["youpouch.com",[1414,1672,1673]],["rokemoba.com",1415],["rugby-rp.com",1417],["ryoko-club.com",1418],["did2memo.net",1418],["sakidori-ch.com",1422],["sakuradot.com",1423],["gametohkenranbu.sakuraweb.com",1424],["sankei.com",[1427,1428]],["sanspo.com",[1428,1429]],["zakzak.co.jp",[1428,2235]],["iza.ne.jp",1428],["saokouryaku.com",1430],["hf.saokouryaku.com",1431],["sarah30.com",1432],["saruwakakun.com",1433],["satoshisss.com",1434],["web.save-editor.com",[1435,1436]],["emu.web-g-p.com",[1435,1623]],["schizophonic9-2.com",1437],["scienceplus2ch.com",1438],["scoopersokuhou.com",1439],["screen-multimedia.com",1440],["second-storage.com",1441],["security-next.com",1442],["seikyouiku-illust.com",1443],["sekai-hub.com",1444],["sekai-kabuka.com",1445],["realtime-chart.info",[1445,1755]],["sekainorekisi.com",1446],["sexynude007.com",1447],["sexytvcap.com",1448],["shikakude.com",[1452,1453]],["pref.kochi.lg.jp",1452],["city.urasoe.lg.jp",1452],["dabun.net",1452],["shindanmaker.com",1454],["shirotomaster.com",1455],["shiroutosan.com",1456],["shitaraba.com",1457],["shogi-sanpo.com",1458],["shogis.com",1459],["headline.mtfj.net",[1459,3324]],["rookie.shonenjump.com",1460],["rdlp.jp",[1462,2874]],["silhouette-ac.com",1463],["sin-space.com",1464],["fumumu.net",[1466,1467]],["idou.me",[1468,3104]],["sirogohan.com",1471],["skebetter.com",1472],["skincare-univ.com",[1473,1474]],["soap-bbs.com",1477],["play.softgames.com",1480],["sophia-it.com",1481],["sozai-good.com",1482],["sp-mobile-blog.com",1483],["sp7pc.com",1484],["splatoon-torikara.com",1486],["spocale.com",1487],["spoilerplus.com",1488],["sportingnews.com",1489],["squallchannel.com",1490],["stanby.com",1491],["zekamashi.net",[1493,3472]],["stats-japan.com",1495],["1000mg.jp",[1496,1774]],["studio-radish.com",1497],["studio-webli.com",1498],["suke10.com",1500],["suki-kira.com",1501],["cojicaji.jp",1502],["sumaoji.com",1503],["supercweather.com",1504],["sutekicookan.com",1505],["suzukikenichi.com",1506],["syakouba.com",1508],["syokuraku-web.com",1509],["yomou.syosetu.com",1510],["tabelog.com",1513],["s.tabelog.com",1514],["tabi-labo.com",1515],["tabicoffret.com",1516],["tabikobo.com",1517],["taxisite.com",1524],["techeyesonline.com",1527],["teitengame.com",1529],["tenmusume.com",1531],["teratail.com",1532],["tetsudo.com",1533],["thebest-1.com",1536],["thedigestweb.com",1537],["tiebukurojinsei.com",1538],["valorantnews.jp",[1538,1560,3031]],["tipsfound.com",1539],["tktube.com",1540],["tm-webtools.com",1541],["to-corona-ex.com",1542],["togetter.com",1543],["twilog.togetter.com",1544],["tohyotalk.com",1545],["tok2.com",1546],["tokai-tv.com",1547],["tokyoartbeat.com",1548],["tokyoipo.com",1549],["tokyoloader.com",1550],["tomodachinpo.com",1551],["meitou.info",[1551,1742]],["tomonite.com",1552],["tool-taro.com",1554],["toramemoblog.com",1555],["toremaga.com",1556],["member.toremaga.com",1557],["toririnon.com",1558],["touhouyaruosure.com",1559],["tousatusin.com",1561],["traicy.com",1562],["trance-cell.com",1563],["trend-at-tv.com",1565],["tsuisoku.com",1567],["tsurimatome.com",1568],["keyboard-dojo.net",1568],["number-place-puzzle.net",1568],["tunamod.com",1569],["tutitatu.com",1570],["tv-happening.com",1571],["freesoft.tvbok.com",[1574,1575]],["goguynet.jp",[1575,2393]],["twicomi.com",1576],["twiigle.com",1577],["twimaru.com",1578],["yakusokunosora.com",1578],["mioyamazaki.jp",1578],["webcommu.net",1578],["uchubiz.com",1579],["uelog.com",1580],["ugtop.com",1581],["umamusume-umapyoi.com",1582],["unityroom.com",1584],["uraaka.com",[1585,1586]],["movies.yahoo.co.jp",1586],["uraaka-joshi.com",1587],["urapic.com",1588],["city.kitahiroshima.hokkaido.jp",1593],["town.yoichi.hokkaido.jp",1593],["city.hiroshima.lg.jp",1593],["utamap.com",1595],["fineboys-online.jp",1597],["movie.eroterest.net",[1597,3217]],["valorant4jp.com",1599],["valorantns.com",1600],["twittrend.jp",1600],["viet-jo.com",1601],["life.viet-jo.com",1602],["vipsister23.com",1603],["virginbmw.com",[1604,1605]],["virginducati.com",1605],["voltechno.com",1607],["volumy.com",1608],["voyeurgeek.com",1609],["w-higa.com",1611],["wa-syo-ku.com",1612],["walkerplus.com",1613],["ramen.walkerplus.com",1614],["warotanikki.com",1617],["sp.jp.wazap.com",1620],["web-dev-qa-db-ja.com",1621],["web-engineer-wiki.com",1622],["web-kanji.com",1624],["webcreatorbox.com",[1625,1626]],["macaro-ni.jp",[1626,2137,2624]],["mainichikirei.jp",[1626,2635]],["webllica.com",1627],["weeklyandmonthly.com",1628],["weeklybcn.com",1629],["whatext.com",1630],["10mtv.jp",[1630,1775]],["kodansha.co.jp",1630],["digiday.jp",[1630,2263]],["city.akabira.hokkaido.jp",1630],["police.pref.akita.lg.jp",1630],["city.shinjuku.lg.jp",1630],["teniteo.jp",1630],["psmk2.net",1630],["winxdvd.com",1632],["wordreference.com",1633],["workingnews117.com",1634],["world-tt.com",1635],["jp.wsj.com",1637],["wwdjapan.com",1638],["www-creators.com",1639],["xn--1-td6bm19b.com",1640],["xn--eckvas1f0ewfnc.com",1641],["xn--ipv6-yn4cxgwe959zqrkp58g.com",1649],["tousatu.xyz",1652],["xn--ecktc2ee4ct2a0f.xn--vcki1fxh883oon2c.com",1653],["xn--vekw70ybyi.com",1654],["xvideo-jp.com",1656],["yakuyoke-yakubarai-jinja.com",1659],["yamakei-online.com",1660],["yamareco.com",1661],["yaraon-blog.com",1662],["yaruo18book.com",1663],["yawarakai.com",1666],["ygokamo.com",1667],["young-machine.com",1671],["4k8ktv.jp",1672],["koisoku.ldblog.jp",1676],["yuki0918kw.com",1679],["zakuzaku911.com",1681],["zatugaku-gimonn.com",1684],["japan.zdnet.com",1686],["zeiri4.com",1687],["zerosumonline.com",1688],["zettai-ero.com",1689],["zokugo-dict.com",1690],["fashiontechnews.zozo.com",1691],["zozovideo.com",1692],["zukan.com",1693],["zuuonline.com",1694],["fuelle.jp",[1694,2339,2340]],["meow.fan",1695],["101010.fun",1696],["eegg.fun",1697],["eegg.dip.jp",1697],["gp-warau.fun",1698],["gampa.jp",[1698,2372]],["moeimg.net",[1700,3317]],["girlsnews.tv",1700],["funglr.games",1702],["kokuban.in",1706],["tech-camp.in",1708],["2game.info",1709],["urbanlife.tokyo",[1709,1881]],["9ketsuki.info",1710],["hentai.9ketsuki.info",1711],["overseas.antenam.info",1712],["kasegeru.blog.jp",[1713,1913]],["imas-cg.net",1713],["anal.bbsnet.info",[1714,1715]],["ms.bbsnet.info",[1715,1716]],["sm.bbsnet.info",1717],["dqmj.info",1719],["ekilog.info",1720],["eorzean.info",1721],["frc-watashi.info",1723],["game-kouryaku.info",1724],["gaten.info",1725],["gogen-ejd.info",1726],["hangul-note.info",1729],["hello-work.info",1730],["hoge5ch.info",[1731,1732]],["meshinews.blog.jp",1732],["ibbs.info",1733],["b.ibbs.info",1734],["kanasoku.info",1736],["kekkonkatsu.info",1737],["kyouryu.info",1739],["lolwiki-note.info",1740],["masutabe.info",1741],["mybouzu.info",1744],["nijie.info",[1746,1747,1748]],["city.living.jp",[1747,2615]],["horne.red",[1747,1748,3524]],["nldot.info",1750],["overjoyed.info",1752],["pcinformation.info",1753],["porn78.info",1754],["search2ch.info",1756],["server-navi.info",1757],["server-setting.info",1758],["soundeffect-lab.info",1761],["taiyoukou-navi.info",1762],["tochidai.info",1763],["weather-gpv.info",1766],["webliker.info",1767],["wtpage.info",1769],["yaruo.info",1770],["2ch.io",1772],["1geki.jp",1776],["2-d.jp",1777],["25jigen.jp",1780],["akasatananj.2chblog.jp",1781],["aikodemoneyfactory.dreamlog.jp",1781],["elephant.2chblog.jp",1782],["footballnet.2chblog.jp",1783],["gahalog.2chblog.jp",1784],["rabitsokuhou.2chblog.jp",1787],["2chmatome2.jp",1788],["36kr.jp",1790],["47news.jp",[1791,1792]],["kabutan.jp",[1791,2496]],["gakumado.mynavi.jp",[1791,2713]],["4travel.jp",1793],["5urprise.jp",1795],["9db.jp",1797],["ad-contents.jp",1798],["adminweb.jp",[1799,1800]],["howtonote.jp",[1799,1800,2444]],["javadrive.jp",[1799,1800,2444]],["webword.jp",1800],["adultexpo.jp",1801],["minigame.aeriagames.jp",1802],["agora-web.jp",1803],["aiacademy.jp",1804],["front-row.jp",[1804,2338]],["aichi.jp",1805],["hyogo.jp",1805],["city.anjo.aichi.jp",1806],["city.aomori.aomori.jp",1806],["hellonavi.jp",1806],["pref.ibaraki.jp",1806],["city.toride.ibaraki.jp",1806],["pref.kagoshima.jp",1806],["city.fujisawa.kanagawa.jp",1806],["city.yokosuka.kanagawa.jp",1806],["pref.kyoto.jp",1806],["lg.jp",[1806,1807,1975,2516]],["city.omura.nagasaki.jp",1806],["city.oita.oita.jp",1806],["city.sendai.jp",1806],["city.izunokuni.shizuoka.jp",1806],["city.arakawa.tokyo.jp",1806],["city.kita.tokyo.jp",1806],["pref.yamagata.jp",1806],["city.fuefuki.yamanashi.jp",1806],["pref.yamanashi.jp",1806],["tokunoshima-town.org",1806],["city.ichinomiya.aichi.jp",1807],["city.nagareyama.chiba.jp",1807],["city.noda.chiba.jp",[1807,1808]],["city.obihiro.hokkaido.jp",1807],["city.kawanishi.hyogo.jp",1807],["city.takarazuka.hyogo.jp",1807],["city.sagamihara.kanagawa.jp",1807],["city.zama.kanagawa.jp",1807],["city.suita.osaka.jp",[1807,2836]],["city.utsunomiya.tochigi.jp",[1807,2476]],["city.kokubunji.tokyo.jp",1807],["city.inazawa.aichi.jp",[1808,1809]],["city.nishio.aichi.jp",1808],["city.obu.aichi.jp",1808],["city.tokai.aichi.jp",1808],["city.toyota.aichi.jp",1808],["city.amagasaki.hyogo.jp",1808],["city.morioka.iwate.jp",1808],["pref.iwate.jp",[1808,2476]],["city.chigasaki.kanagawa.jp",1808],["city.ebina.kanagawa.jp",1808],["city.akita.lg.jp",1808],["city.gifu.lg.jp",1808],["city.higashikurume.lg.jp",1808],["city.kariya.lg.jp",1808],["city.kasugai.lg.jp",[1808,2476]],["city.toyooka.lg.jp",1808],["city.tsukuba.lg.jp",1808],["city.urayasu.lg.jp",1808],["city.ise.mie.jp",1808],["city.iruma.saitama.jp",1808],["city.fussa.tokyo.jp",1808],["city.itabashi.tokyo.jp",1808],["city.suginami.tokyo.jp",1808],["city.wakayama.wakayama.jp",[1808,2476]],["city.kawasaki.jp",1809],["city.maizuru.kyoto.jp",1809],["city.higashiosaka.lg.jp",1809],["city.himeji.lg.jp",1809],["city.iga.lg.jp",1809],["city.ikoma.lg.jp",1809],["city.inzai.lg.jp",1809],["city.kyotanabe.lg.jp",1809],["city.kyoto.lg.jp",1809],["city.ogaki.lg.jp",1809],["city.osaka.lg.jp",1809],["city.tama.lg.jp",1809],["city.nagoya.jp",1809],["city.hirakata.osaka.jp",1809],["city.yao.osaka.jp",1809],["city.higashiomi.shiga.jp",1809],["city.kiyosu.aichi.jp",1810],["city.komaki.aichi.jp",[1811,1812]],["city.fujieda.shizuoka.jp",1812],["pref.aichi.jp",1813],["gorillawiki.jp",1815],["blogger.ameba.jp",1817],["manekai.ameba.jp",1818],["monoreco.ameba.jp",1819],["news.ameba.jp",1820],["official.ameba.jp",1821],["ananweb.jp",1823],["anikore.jp",1824],["anime-japan.jp",1825],["s.animeanime.jp",1828],["anna-media.jp",1829],["anniversarys-mag.jp",[1830,1831]],["navi.lol-gg.net",[1830,3299]],["apowersoft.jp",1832],["games.app-liv.jp",1834],["mag.app-liv.jp",1835],["appbu.jp",1836],["applion.jp",1837],["appmedia.jp",1838],["artexhibition.jp",1839],["arukumachikyoto.jp",1840],["as-web.jp",1841],["asken.jp",1844],["asobeans.jp",[1845,1846]],["warau.jp",[1845,3037]],["w.atwiki.jp",1848],["news.audee.jp",1849],["audio-heritage.jp",1850],["city.iwaki.lg.jp",[1850,2565]],["aumo.jp",1851],["auone.jp",1852],["article.auone.jp",1853],["game.habits.auone.jp",1854],["portal.auone.jp",1855],["tenki.auone.jp",1856],["travel.co.jp",[1857,2194]],["sqool.net",[1860,3410]],["axismag.jp",1864],["kobe-np.co.jp",[1867,2089]],["bangkok.jp",1868],["barks.jp",1869],["baseballking.jp",1871],["basketballking.jp",1872],["baskmedia.jp",1873],["beiz.jp",1874],["bellcurve.jp",1875],["bellemaison.jp",1876],["benesse.jp",1877],["bestcarweb.jp",1878],["bg-mania.jp",1879],["bike-news.jp",[1880,1881,1882]],["trafficnews.jp",[1880,2998]],["kuruma-news.jp",[1881,2532]],["biyou-seikei.jp",1883],["heisei-housewarming.work",[1886,2355,3583]],["studioglass.work",[1886,2355,3583,3590]],["bizspa.jp",1887],["blog-bootcamp.jp",1890],["2chnewsblog.blog.jp",1891],["2chopmt.blog.jp",1892],["3-559.blog.jp",1893],["akibablog.blog.jp",1894],["animecomic-pass.blog.jp",1895],["azurlanesokuhou.blog.jp",1897],["doujinerosenka.blog.jp",1900],["dragonquestwalk.blog.jp",1901],["fighters-kingdom.blog.jp",1902],["fireflyframer.blog.jp",1903],["g-soku.blog.jp",1904],["gunji.blog.jp",1910],["hadasirori.blog.jp",1911],["hanshintigers1.blog.jp",1912],["kininaru-geinou-m.blog.jp",1914],["kyu3.blog.jp",1916],["anicobin.ldblog.jp",[1916,2540]],["world-fusigi.net",[1916,3462]],["livejupiter2.blog.jp",1917],["mamekichimameko.blog.jp",1918],["manpukunews.blog.jp",1919],["mfujin.blog.jp",1920],["nanj-world.blog.jp",1921],["nanjdesuno.blog.jp",1923],["nanjpride.blog.jp",1925],["nogizaka-46bunno1.blog.jp",1926],["nogizaka46matomenoma.blog.jp",1927],["oppao.blog.jp",1928],["sakamichijyoho46.blog.jp",1929],["seikeidouga.blog.jp",[1930,1931]],["gamedaradara.doorblog.jp",1931],["sow.blog.jp",1932],["tozanchannel.blog.jp",1934],["umamusume-pakamusu.blog.jp",1937],["yu-gi5000guard.blog.jp",1938],["punisoku.blogo.jp",1941],["bookbang.jp",1943],["boxil.jp",1944],["bridge-salon.jp",1945],["brightdays.jp",1946],["brutus.jp",1947],["btblog.jp",1948],["adultlog.net",1948],["crea.bunshun.jp",1950],["businessinsider.jp",1953],["buywrite.jp",1954],["caloo.jp",1957],["cancam.jp",1959],["car-me.jp",1960],["car-moby.jp",1961],["news.careerconnection.jp",1963],["careergarden.jp",1964],["cartoonnetwork.jp",[1965,1966]],["keisan.casio.jp",1967],["cgworld.jp",1970],["chatpad.jp",1971],["english.cheerup.jp",[1972,1973]],["malanka.tech",1972],["city.abiko.chiba.jp",1974],["city.chiba.jp",1975],["city-kirishima.jp",1975],["pref.ehime.jp",[1975,2305]],["city.fukushima.fukushima.jp",1975],["city.kamakura.kanagawa.jp",1975],["city.tome.miyagi.jp",1975],["city.sapporo.jp",1975],["city.hamamatsu.shizuoka.jp",1975],["pref.shizuoka.jp",[1975,2922]],["city.edogawa.tokyo.jp",[1975,2988]],["city.kofu.yamanashi.jp",[1975,3077]],["city.ichihara.chiba.jp",1976],["city.kamagaya.chiba.jp",1977],["city.matsudo.chiba.jp",1977],["city.moriya.ibaraki.jp",1977],["city.chuo.lg.jp",1977],["city.koganei.lg.jp",1977],["city.kuki.lg.jp",1977],["live.nicovideo.jp",[1977,2792]],["nishi.or.jp",[1977,2826]],["city.kawagoe.saitama.jp",1977],["city.tokushima.tokushima.jp",1977],["city.fuchu.tokyo.jp",[1977,2457]],["city.inagi.tokyo.jp",1977],["city.nerima.tokyo.jp",1977],["city.mobara.chiba.jp",1978],["city.tomisato.lg.jp",1978],["city.akiruno.tokyo.jp",[1978,2987]],["city.narita.chiba.jp",1979],["chikubi.jp",1980],["chisou-media.jp",1981],["chocotabi-saitama.jp",1982],["ciatr.jp",[1983,1984]],["ima.goo.ne.jp",1984],["cinematoday.jp",1985],["cinemore.jp",1986],["city-nakatsu.jp",1987],["city.naruto.tokushima.jp",1987],["ckworks.jp",1988],["cloudwoods.jp",1989],["clutch-s.jp",1990],["cman.jp",1991],["note.cman.jp",1992],["moving.a-tm.co.jp",1994],["agrinews.co.jp",1995],["akt.co.jp",1996],["alba.co.jp",1997],["sokuho.alba.co.jp",1998],["alc.co.jp",1999],["ej.alc.co.jp",2000],["eow.alc.co.jp",2001],["news.allabout.co.jp",2003],["magazine.aruhi-corp.co.jp",2005],["arukikata.co.jp",2006],["onnela.asahi.co.jp",2007],["atmarkit.co.jp",[2008,2009]],["itmedia.co.jp",[2009,2073,2074]],["okurin.bitpark.co.jp",2011],["bloomberg.co.jp",2012],["bocek.co.jp",2013],["bs-asahi.co.jp",2015],["bs-tvtokyo.co.jp",2016],["minkara.carview.co.jp",2017],["cecile.co.jp",2018],["chibanippo.co.jp",2019],["china-news.co.jp",2020],["chugainippoh.co.jp",2021],["niigata-nippo.co.jp",2022],["tabi.chunichi.co.jp",2025],["cmsite.co.jp",2026],["cnn.co.jp",2027],["dinos.co.jp",2029],["news.dmm.co.jp",2030],["eguchi-hd.co.jp",2033],["ehime-np.co.jp",[2034,2035]],["ecclab.empowershop.co.jp",2036],["excite.co.jp",2037],["laurier.excite.co.jp",2038],["woman.excite.co.jp",2039],["mixhost.jp",[2040,2678]],["fujitv.co.jp",2041],["fod.fujitv.co.jp",2042],["fukui-tv.co.jp",2043],["capa.getnavi.jp",[2045,2380]],["mecicolle.gnavi.co.jp",2046],["golfdigest.co.jp",2047],["news.golfdigest.co.jp",2048],["score.golfdigest.co.jp",2049],["golfnetwork.co.jp",2050],["gpoint.co.jp",2051],["higashiaichi.co.jp",2053],["hmv.co.jp",2054],["umatoku.hochi.co.jp",2055],["hokkaido-np.co.jp",2056],["homes.co.jp",2057],["kabuyoho.ifis.co.jp",[2059,2060]],["wowgame.jp",[2060,3060]],["it.impress.co.jp",2061],["netshop.impress.co.jp",[2062,2063]],["webtan.impress.co.jp",[2062,2068]],["forest.watch.impress.co.jp",2066],["video.watch.impress.co.jp",2067],["infoseek.co.jp",2070],["rakuten.co.jp",2071],["iot-consulting.co.jp",2072],["pasoble.jp",2074],["blog.skeg.jp",[2074,2928]],["figsoku.net",[2074,3227]],["mysqlweb.net",2074],["plus-a.net",2074],["securl.nu",2074],["atmarkit.itmedia.co.jp",2075],["iwanichi.co.jp",2077],["iwate-np.co.jp",2078],["j-wave.co.jp",2079],["news.j-wave.co.jp",2080],["jnocnews.co.jp",2081],["jomo-news.co.jp",2082],["mb.jorudan.co.jp",2085],["movie.jorudan.co.jp",2086],["news.jorudan.co.jp",2087],["khb-tv.co.jp",2088],["cocreco.kodansha.co.jp",2090],["city.kusatsu.shiga.jp",2090],["friday.kodansha.co.jp",2091],["zaitaku100.kokuyo.co.jp",2092],["ktn.co.jp",2093],["nazology.kusuguru.co.jp",2094],["kyodo.co.jp",2097],["b.kyodo.co.jp",2098],["ovo.kyodo.co.jp",[2099,2100]],["tvfan.kyodo.co.jp",2099],["kyoto-np.co.jp",2101],["liginc.co.jp",2102],["mantan-web.jp",[2104,2137,2641]],["mdn.co.jp",2106],["morinaga.co.jp",2108],["musicman.co.jp",2109],["navi.narakotsu.co.jp",2111],["city.nagano.nagano.jp",[2111,2549]],["navitime.co.jp",2112],["netoff.co.jp",2115],["nikkei-cnbc.co.jp",2118],["project.nikkeibp.co.jp",2122],["nishinippon.co.jp",2123],["nissen.co.jp",2124],["nnn.co.jp",2125],["nttdocomo.co.jp",2126],["cu.ntv.co.jp",2128],["news.ntv.co.jp",2129],["ohk.co.jp",2130],["okinawatimes.co.jp",2131],["juken.oricon.co.jp",2133],["jprime.jp",[2133,2490,2491]],["withonline.jp",[2133,3058]],["osdn.co.jp",2134],["oshimaland.co.jp",2135],["ox-tv.co.jp",2137],["php.co.jp",2138],["shuchi.php.co.jp",2139],["popteen.co.jp",2141],["rakuten-card.co.jp",2142],["beauty.rakuten.co.jp",2144],["books.rakuten.co.jp",2145],["car.rakuten.co.jp",2146],["corp.rakuten.co.jp",2147],["plaza.rakuten.co.jp",2148],["point-g.rakuten.co.jp",2149],["recipe.rakuten.co.jp",2151],["books.step.rakuten.co.jp",2152],["websearch.rakuten.co.jp",[2154,2155]],["grapee.jp",[2154,2398]],["recordchina.co.jp",2156],["rikujyokyogi.co.jp",2157],["saga-s.co.jp",2158],["sagatv.co.jp",2159],["sanin-chuo.co.jp",2161],["saru.co.jp",2162],["sbisec.co.jp",2163],["seibikai.co.jp",2164],["senken.co.jp",2165],["shikoku-np.co.jp",2166],["shinmai.co.jp",2168],["domani.shogakukan.co.jp",2170],["shueisha.co.jp",2171],["sportiva.shueisha.co.jp",2172],["wpb.shueisha.co.jp",2173],["yoi.shueisha.co.jp",2174],["zebrack-comic.shueisha.co.jp",2175],["cs.sonylife.co.jp",2178],["ssnp.co.jp",2180],["weekly-jitsuwa.jp",[2180,3050]],["stereosound.co.jp",2181],["stockweather.co.jp",2182],["sun-tv.co.jp",2183],["gammaplus.takeshobo.co.jp",2184],["storia.takeshobo.co.jp",2185],["tbs.co.jp",2186],["newsdig.tbs.co.jp",2187],["topics.tbs.co.jp",2188],["the-miyanichi.co.jp",2189],["tokubai.co.jp",2190],["tokyo-sports.co.jp",2192],["toonippo.co.jp",2193],["tv-aichi.co.jp",2195],["tv-asahi.co.jp",2196],["douga.tv-asahi.co.jp",2197],["city.kitakyushu.lg.jp",2200],["txbiz.tv-tokyo.co.jp",2201],["store.united-arrows.co.jp",2202],["wjsm.co.jp",2204],["auctions.yahoo.co.jp",2206],["baseball.yahoo.co.jp",2207],["beauty.yahoo.co.jp",2208],["carview.yahoo.co.jp",2209],["chiebukuro.yahoo.co.jp",2210],["detail.chiebukuro.yahoo.co.jp",2211],["finance.yahoo.co.jp",[2212,2213]],["freefielder.jp",2213],["mycaddie.jp",[2213,2712]],["games.yahoo.co.jp",2214],["jobcatalog.yahoo.co.jp",2215],["map.yahoo.co.jp",2216],["news.yahoo.co.jp",2217],["paypaymall.yahoo.co.jp",2218],["search.yahoo.co.jp",2219],["shopping.yahoo.co.jp",2220],["store.shopping.yahoo.co.jp",2221],["soccer.yahoo.co.jp",2222],["sports.yahoo.co.jp",2223],["toku.yahoo.co.jp",2224],["transit.yahoo.co.jp",2225],["tv.yahoo.co.jp",2226],["typhoon.yahoo.co.jp",2227],["weather.yahoo.co.jp",2228],["yakuji.co.jp",2229],["komachi.yomiuri.co.jp",2231],["yomidr.yomiuri.co.jp",2232],["ytv.co.jp",2233],["zaikei.co.jp",2234],["as-selection.net",2234],["audioreview.m1001.coreserver.jp",2236],["cosp.jp",2237],["courrier.jp",2238],["edtechzine.jp",2239],["crefan.jp",2240],["croissant-online.jp",2241],["cyclowired.jp",2243],["game-i.daa.jp",2244],["daibouken.jp",2245],["dailynewsonline.jp",2246],["dailyshincho.jp",2248],["dan-ball.jp",2249],["datazoo.jp",2250],["dcnenkin.jp",2251],["poginfo.ddo.jp",2252],["deagostini.jp",2253],["deli-fuzoku.jp",2254],["deneblog.jp",2255],["nikkan-spa.jp",[2259,2488,2801]],["zai.diamond.jp",2260],["dietclub.jp",2261],["discoveryjapan.jp",2265],["shopping-3ple.dmkt-sp.jp",2266],["blog.domesoccer.jp",2268],["live.doneru.jp",2269],["doope.jp",2270],["duellinks.doorblog.jp",2272],["h-pon.doorblog.jp",2273],["kabumatome.doorblog.jp",2275],["news-channel.doorblog.jp",[2277,2278]],["world-best-news.doorblog.jp",[2277,2278]],["sakukankou.jp",2277],["samuraigoal.doorblog.jp",2279],["samuraisoccer.doorblog.jp",[2280,2281]],["shikaku2ch.doorblog.jp",[2282,2283]],["otanew.jp",2283],["douga100ka.jp",2284],["dova-s.jp",2285],["dream.jp",2287],["anmin-kaimin.net",[2287,2770]],["linux.ikoinoba.net",2287],["nuinui358.dreamlog.jp",2289],["drivetraffic.jp",2290],["dropgame.jp",[2291,2292,2293]],["wamgame.jp",[2291,2293]],["imgbbs.dtn.jp",2294],["e-earphone.jp",2295],["e-rumoi.jp",2296],["ecnavi.jp",2298],["smcb.jp",2299],["city.imabari.ehime.jp",2301],["city.matsuyama.ehime.jp",[2302,2303]],["city.nishitokyo.lg.jp",[2303,2578]],["city.machida.tokyo.jp",2303],["city.ozu.ehime.jp",2304],["city.fukuyama.hiroshima.jp",2304],["city.hatsukaichi.hiroshima.jp",2304],["city.ebetsu.hokkaido.jp",[2304,2431]],["city.ishikari.hokkaido.jp",2304],["city.minamiawaji.hyogo.jp",2304],["city.ageo.lg.jp",2304],["pref.fukushima.lg.jp",[2304,2555]],["pref.hiroshima.lg.jp",2304],["city.kimitsu.lg.jp",[2304,2568]],["city.kure.lg.jp",[2304,2572]],["city.miki.lg.jp",2304],["city.niiza.lg.jp",2304],["city.sanyo-onoda.lg.jp",2304],["city.shunan.lg.jp",2304],["city.tondabayashi.lg.jp",2304],["city.yamaguchi.lg.jp",[2304,2601]],["pref.okayama.jp",[2304,2813]],["city.toda.saitama.jp",2304],["city.oyama.tochigi.jp",2304],["city.saijo.ehime.jp",2306],["city.kameoka.kyoto.jp",2306],["city.shimonoseki.lg.jp",2306],["city.takatsuki.osaka.jp",2306],["eigachannel.jp",2307],["eigobu.jp",2308],["ekiten.jp",2309],["enechange.jp",2311],["englishhub.jp",2312],["epark.jp",2313],["epochtimes.jp",2314],["erocommu.jp",2316],["esse-online.jp",2318],["estar.jp",2319],["exblog.jp",2320],["www.exblog.jp",2321],["fanblogs.jp",2322],["finasee.jp",2324],["media.finasee.jp",2325],["firecross.jp",2326],["firestorage.jp",2327],["footballchannel.jp",2330],["fpcafe.jp",2331],["free-avx.jp",2332],["free-fonts.jp",2333],["freebie-ac.jp",2334],["freegame-mugen.jp",2335],["frequ.jp",2336],["moneytimes.jp",[2339,2696]],["fujoho.jp",2344],["fujossy.jp",2345],["fukafuka295.jp",2346],["city.chikushino.fukuoka.jp",2347],["pref.fukuoka.lg.jp",2347],["city.nara.lg.jp",2347],["city.kurume.fukuoka.jp",2348],["city.fukuoka.lg.jp",2348],["police.pref.fukuoka.jp",2349],["city.aizuwakamatsu.fukushima.jp",2350],["city.takasaki.gunma.jp",[2350,2404]],["town.hokkaido-mori.lg.jp",2350],["city.ohtawara.tochigi.jp",[2350,2455]],["full-count.jp",2351],["futabanet.jp",2352],["game8.jp",2357],["gamedbs.jp",2359],["gamedesign.jp",2361],["gamefactory.jp",2362],["gameinn.jp",2363],["gameline.jp",2364],["gamelove.jp",2365],["googirl.jp",[2366,2394]],["gamewith.jp",2371],["ganref.jp",2373],["gapsis.jp",2374],["geinou-news.jp",2377],["web.gekisaka.jp",2378],["gendama.jp",2379],["conveni.getnews.jp",2382],["gihyo.jp",2383],["giocox.jp",2384],["lifehacker.jp",[2386,2387,2606,2607]],["roomie.jp",[2386,2606]],["globaledu.jp",2389],["jglobal.jst.go.jp",[2391,2392]],["kyoko-np.net",[2392,3289]],["gooworld.jp",2395],["game.granbluefantasy.jp",2397],["snrec.jp",2399],["gunma-kouiki.jp",2400],["city.maebashi.gunma.jp",2401],["city.hekinan.lg.jp",2401],["city.hidaka.lg.jp",2401],["city.ota.gunma.jp",2402],["pref.gunma.jp",[2402,2403]],["city.tatebayashi.gunma.jp",2405],["gyutte.jp",2406],["digital.hakoshin.jp",2408],["hana-ato.jp",2410],["happy-travel.jp",2411],["hasunoha.jp",2412],["ekme-pk2.hateblo.jp",2413],["anond.hatelabo.jp",2414],["neet3.hatenablog.jp",2416],["taxtax.hatenablog.jp",2417],["healthpress.jp",2418],["heim.jp",2419],["hibiki-radio.jp",2420],["hikkoshizamurai.jp",2421],["hint-pot.jp",[2422,2423]],["football-zone.net",[2423,3231]],["hobbytimes.jp",2426],["hoiclue.jp",2427],["news.hoken-mammoth.jp",2428],["city.asahikawa.hokkaido.jp",2429],["city.funabashi.lg.jp",[2429,2556]],["city.saitama.lg.jp",2429],["pref.wakayama.lg.jp",[2429,2600]],["city.bibai.hokkaido.jp",2430],["pref.kumamoto.jp",2430],["city.daito.lg.jp",2430],["city.gamagori.lg.jp",2430],["city.azumino.nagano.jp",2430],["city.sado.niigata.jp",2430],["city.eniwa.hokkaido.jp",2432],["town.fukushima.hokkaido.jp",2433],["city.goshogawara.lg.jp",2433],["city.mutsu.lg.jp",2433],["city.koshigaya.saitama.jp",2433],["city.hakodate.hokkaido.jp",2434],["city.nemuro.hokkaido.jp",2435],["city.moriguchi.osaka.jp",2435],["city.fukaya.saitama.jp",[2435,2897]],["city.kunitachi.tokyo.jp",2435],["town.tobetsu.hokkaido.jp",2436],["hon-hikidashi.jp",2437],["host2.jp",2439],["hotfrog.jp",2441],["hotokami.jp",2442],["houyhnhnm.jp",2443],["baila.hpplus.jp",2446],["more.hpplus.jp",2447],["spur.hpplus.jp",2448],["hs-exp.jp",2449],["i-voce.jp",2451],["ib-game.jp",2452],["city.kamisu.ibaraki.jp",2453],["city.kashima.ibaraki.jp",2454],["city.namegata.ibaraki.jp",2455],["city.tsuchiura.lg.jp",2455],["city.tsukubamirai.lg.jp",2455],["kyoiku.pref.ibaraki.jp",2456],["city.ryugasaki.ibaraki.jp",2457],["city.niigata.lg.jp",2457],["ibarakinews.jp",2458],["ichi-oshi.jp",2459],["icon.jp",2460],["icotto.jp",2461],["ideco-guide.jp",2462],["ieagent.jp",2464],["ikaclo.jp",2465],["imaonline.jp",2466],["ime2.jp",2467],["kbbs.jp",2467],["iphone-mania.jp",2468],["iphoroid.jp",[2469,2470]],["kirari-media.net",2470],["ismedia.jp",2471],["wedge.ismedia.jp",2473],["city.ichinoseki.iwate.jp",2474],["city.oshu.iwate.jp",2475],["city.asaka.lg.jp",2475],["city.hino.lg.jp",2476],["city.takayama.lg.jp",2476],["iyokannet.jp",2477],["jafmate.jp",2478],["jisin.jp",2481],["jitenon.jp",2482],["kanken.jitenon.jp",2483],["jmty.jp",2484],["johojima.jp",2486],["joshi-spa.jp",[2487,2488]],["joshinweb.jp",2489],["koukouseishinbun.jp",2491],["jqos.jp",2492],["jugem.jp",2493],["kabushiki.jp",2495],["s.kabutan.jp",2497],["city.takamatsu.kagawa.jp",2498],["kakuyomu.jp",2501],["city.atsugi.kanagawa.jp",2503],["city.hadano.kanagawa.jp",2504],["city.hiratsuka.kanagawa.jp",2505],["city.isehara.kanagawa.jp",2506],["city.odawara.kanagawa.jp",2507],["kashiwa-taikyo.jp",2510],["kawa-colle.jp",2511],["home.kingsoft.jp",[2512,2513]],["ieeebd.org",[2513,3498]],["kinmaweb.jp",2514],["kisspress.jp",2515],["city.kochi.kochi.jp",2516],["city.ueda.nagano.jp",2516],["city.ome.tokyo.jp",2516],["kochike.jp",2517],["kotobank.jp",2519],["kotoricafe.jp",2520],["kufura.jp",2521],["city.kumamoto.jp",[2522,2523]],["kumapon.jp",2524],["kunimachi.jp",2525],["kura-vie.jp",[2526,2527]],["life-n.jp",[2527,2605]],["kurashi-no.jp",2528],["kurashi-to-oshare.jp",[2529,2530]],["pashplus.jp",[2529,2849]],["kurashinista.jp",2531],["kushironews.jp",2533],["city.uji.kyoto.jp",2534],["city.mito.lg.jp",2534],["pref.yamaguchi.lg.jp",[2534,2602]],["city.matsumoto.nagano.jp",2534],["kyounoryouri.jp",2535],["image-eyes1.a.la9.jp",2536],["imgs.a.la9.jp",2537],["lamire.jp",2538],["leon.jp",2545],["pref.akita.lg.jp",2546],["pref.aomori.lg.jp",2547],["traderswebfx.jp",2547],["city.bunkyo.lg.jp",[2548,2549]],["city.kuwana.lg.jp",2549],["pref.toyama.jp",2549],["pref.chiba.lg.jp",2550],["city.chichibu.lg.jp",2551],["city.koka.lg.jp",2551],["city.kurashiki.okayama.jp",2551],["city.chita.lg.jp",2552],["city.fujinomiya.lg.jp",2553],["city.fukui.lg.jp",2554],["city.tokyo-nakano.lg.jp",[2554,2571]],["pref.gifu.lg.jp",2557],["city.habikino.lg.jp",2558],["city.higashimatsuyama.lg.jp",2559],["web.pref.hyogo.lg.jp",2560],["city.koriyama.lg.jp",2560],["city.ibaraki-koga.lg.jp",2561],["city.isesaki.lg.jp",2562],["city.settsu.osaka.jp",2562],["pref.ishikawa.lg.jp",2563],["city.ishinomaki.lg.jp",2564],["roote.ekispert.net",[2564,3205]],["city.izumisano.lg.jp",2566],["city.kashiwa.lg.jp",2567],["city.komatsu.lg.jp",2569],["city.konan.lg.jp",2570],["city.kumagaya.lg.jp",2571],["city.marugame.lg.jp",2573],["pref.mie.lg.jp",2574],["city.mitaka.lg.jp",2575],["city.musashino.lg.jp",2576],["city.nagasaki.lg.jp",2577],["city.noshiro.lg.jp",2579],["city.okazaki.lg.jp",2580],["city.adachi.tokyo.jp",2581],["city.saga.lg.jp",2583],["pref.saga.lg.jp",2584],["city.sakai.lg.jp",2585],["city.sano.lg.jp",2586],["city.setagaya.lg.jp",2587],["city.shibukawa.lg.jp",2588],["city.tochigi-sakura.lg.jp",2588],["city.ashikaga.tochigi.jp",2588],["city.kanuma.tochigi.jp",2588],["city.shizuoka.lg.jp",2589],["city.sodegaura.lg.jp",2590],["city.sumida.lg.jp",2591],["city.higashimurayama.tokyo.jp",[2591,2990]],["city.taito.lg.jp",2592],["city.tochigi.lg.jp",2593],["pref.tottori.lg.jp",2594],["city.toyohashi.lg.jp",[2594,2596]],["city.toyoake.lg.jp",2595],["city.toyokawa.lg.jp",2597],["city.tsuyama.lg.jp",2598],["city.ushiku.lg.jp",2599],["city.yokohama.lg.jp",2603],["city.yubari.lg.jp",2603],["city.naha.okinawa.jp",2603],["city.sayama.saitama.jp",2603],["city.yonago.lg.jp",2604],["limia.jp",2608],["livedoor.jp",2609],["livefans.jp",2611],["t.livepocket.jp",2612],["living.jp",[2613,2614]],["mondotv.jp",[2614,2694]],["mrs.living.jp",2616],["lmaga.jp",2617],["locari.jp",2619],["logmi.jp",2620],["2ch.logpo.jp",2621],["loljp-wiki.jp",2622],["love-jav.jp",2623],["macotakara.jp",2625],["madamefigaro.jp",2627],["magmix.jp",2628],["maikuranikki.jp",2631],["saku-city.mamafre.jp",2636],["mamari.jp",2637],["mamastar.jp",2638],["manababy.jp",2639],["manabitimes.jp",2640],["maonline.jp",2642],["markezine.jp",2643],["matomedane.jp",2646],["matomehub.jp",2647],["mayonez.jp",2648],["mdpr.jp",2649],["media-innovation.jp",2651],["megalodon.jp",2652],["gyo.tc",2652],["meigara.jp",2653],["memorva.jp",2654],["mens-ex.jp",2655],["merkmal-biz.jp",2657],["mery.jp",2658],["fc2ppv.mhx.jp",2659],["city.matsusaka.mie.jp",2660],["info.city.tsu.mie.jp",2661],["miima.jp",2662],["milfreaks.militaryblog.jp",2663],["mindhack-media.jp",2664],["minhyo.jp",2665],["minkabu.jp",2666],["cc.minkabu.jp",2667],["fu.minkabu.jp",2668],["fx.minkabu.jp",2669],["ysyoken.hikaku.minkabu.jp",2670],["itf.minkabu.jp",2671],["re.minkabu.jp",2672],["s.minkabu.jp",2673],["minkou.jp",2674],["mirrorz.jp",2676],["mistory.jp",2677],["mixi.jp",2679],["news.mixi.jp",2680],["mixonline.jp",2681],["city.natori.miyagi.jp",2682],["pref.miyagi.jp",2683],["police.pref.miyagi.jp",2684],["city.miyakonojo.miyazaki.jp",2685],["city.miyazaki.miyazaki.jp",2686],["mizu-trouble.jp",2687],["mobareco.jp",2688],["modalina.jp",2689],["modernliving.jp",2690],["richessemag.jp",2690],["mofmo.jp",2692],["s.mognavi.jp",2693],["moneypost.jp",2695],["moneyzine.jp",2697],["moppy.jp",2698],["mora.jp",2700],["motimoti3d.jp",2701],["motor-fan.jp",2702],["moviecollection.jp",2703],["moviewalker.jp",2704],["muromin.jp",2706],["muryou-keiba-ai.jp",2707],["music-book.jp",2708],["muuu.jp",2709],["mxtv.jp",2711],["news.mynavi.jp",2714],["osusume.mynavi.jp",2715],["woman.mynavi.jp",2716],["city.saku.nagano.jp",2718],["nakashibetsu.jp",2719],["namedic.jp",2720],["mx2b.nan-net.jp",2721],["nanos.jp",2722],["pref.nara.jp",2723],["navicon.jp",2724],["nbblog.jp",2725],["babycome.ne.jp",2726],["cat.benesse.ne.jp",[2729,2730]],["dog.benesse.ne.jp",[2729,2730]],["manabi.benesse.ne.jp",2731],["st.benesse.ne.jp",2732],["biglobe.ne.jp",2733],["beauty.biglobe.ne.jp",2734],["game.biglobe.ne.jp",2735],["join.biglobe.ne.jp",2736],["enjoy.sso.biglobe.ne.jp",2738],["weather.biglobe.ne.jp",2739],["hiroba.dpoint.docomo.ne.jp",2740],["apprev.smt.docomo.ne.jp",2741],["ichioshi.smt.docomo.ne.jp",2743],["mama.smt.docomo.ne.jp",2744],["sports.smt.docomo.ne.jp",2746],["easter.ne.jp",2748],["free.foto.ne.jp",2749],["freem.ne.jp",2750],["autos.goo.ne.jp",2753],["blog.goo.ne.jp",2754],["news.goo.ne.jp",2755],["oshiete.goo.ne.jp",[2756,2757]],["city.joetsu.niigata.jp",2757],["shogi.or.jp",[2757,2831]],["ranking.goo.ne.jp",[2758,2759]],["rank-king.jp",[2759,2871,2872]],["sports.goo.ne.jp",2760],["hatena.ne.jp",2761],["b.hatena.ne.jp",2762],["q.hatena.ne.jp",2764],["tim.hi-ho.ne.jp",2765],["jah.ne.jp",2766],["kotoba.ne.jp",2769],["bossgoo.sakura.ne.jp",2771],["yugioh-antenna.sakura.ne.jp",2772],["yukkuri-futaba.sakura.ne.jp",2773],["tour.ne.jp",2774],["www.ne.jp",2775],["nec-lavie.jp",2776],["nekochan.jp",2777],["nemotohiroyuki.jp",2778],["sexyvoice.org",2778],["sugoroku.nerliasaga.jp",[2779,2780]],["xn--gck1f423k.xn--1bvt37a.tools",[2780,3557]],["news-vision.jp",2781],["newsdigest.jp",2782],["newskingdom.jp",2783],["newsweekjapan.jp",2785],["newtoku.jp",2786],["neyagawa-np.jp",2787],["ngauge.jp",2788],["ch.nicovideo.jp",2790],["dic.nicovideo.jp",2791],["manga.nicovideo.jp",[2793,2794]],["seiga.nicovideo.jp",[2794,2796]],["sp.nicovideo.jp",2797],["www.nicovideo.jp",2798],["city.nagaoka.niigata.jp",2799],["city.sanjo.niigata.jp",2800],["propertylistings.nikkei.jp",2802],["numa2.jp",2805],["nurse-senka.jp",2807],["o-uccino.jp",[2808,2809]],["oggi.jp",2810],["city.beppu.oita.jp",2811],["pref.oita.jp",2812],["city.soja.okayama.jp",2814],["city.okinawa.okinawa.jp",2815],["okwave.jp",2816],["okbizcs.okwave.jp",2817],["omocoro.jp",2818],["onecareer.jp",2819],["jacom.or.jp",2821],["jartic.or.jp",2822],["kankomie.or.jp",2823],["museum.or.jp",2824],["nc-net.or.jp",2825],["okinawa-eiyo.or.jp",2827],["piano.or.jp",2828],["plala.or.jp",2829],["www6.plala.or.jp",2830],["tsukiji.or.jp",2833],["tvguide.or.jp",2834],["library.pref.osaka.jp",2835],["jpki.osdn.jp",2837],["ota-suke.jp",2839],["otajo.jp",2840],["otologic.jp",2842],["otonanswer.jp",[2843,2844]],["the-ans.jp",[2844,2976]],["ourage.jp",2846],["p-game.jp",2847],["sp.pachinkoslot.jp",2848],["pet-home.jp",2850],["peta2.jp",2851],["petwell.jp",2852],["piapro.jp",[2854,2855]],["office54.net",2854],["sanyonews.jp",2855],["tegaki.pipa.jp",2856],["popmaster.jp",2859],["pouchs.jp",2860],["novel.prcm.jp",2861],["president.jp",2863],["python.jp",2864],["qlife.jp",2866],["radichubu.jp",2868],["rakumachi.jp",2869],["rakuteneagles.jp",2870],["finders.me",[2871,3096]],["ray-web.jp",2873],["realsound.jp",2875],["recipe-blog.jp",2876],["recochoku.jp",2877],["reflexions.jp",2878],["rentry.jp",2880],["resemom.jp",2883],["reservestock.jp",2884],["rknt.jp",2887],["rokkasho.jp",2888],["roomclip.jp",2889],["rurubu.jp",2890],["s-max.jp",2893],["city.saitama.jp",2895],["city.fujimi.saitama.jp",2896],["city.kounosu.saitama.jp",2898],["city.tokorozawa.saitama.jp",2899],["sakigake.jp",2900],["san-tatsu.jp",2901],["sasatto.jp",2902],["sbbit.jp",2903],["searchkoreanews.jp",2904],["seesaa.jp",2905],["seijiyama.jp",2908],["seikeidenron.jp",2909],["seniorguide.jp",2910],["seotools.jp",2911],["serai.jp",2912],["shikiho.jp",2914],["city.izumo.shimane.jp",2915],["shiori-tabi.jp",2917],["shipping.jp",2918],["city.fuji.shizuoka.jp",2919],["city.fukuroi.shizuoka.jp",2920],["city.mishima.shizuoka.jp",2921],["hugkum.sho.jp",2923],["shoespost.jp",2924],["simchange.jp",2926],["skyticket.jp",2929],["smashop.jp",2931],["so-zou.jp",2932],["soccer-king.jp",2933],["softonic.jp",2934],["somu-lier.jp",2935],["soredoko.jp",2936],["spoiler.jp",2937],["vk.sportsbull.jp",[2938,2939]],["shufoo.net",[2939,3396]],["srad.jp",2942],["tenshoku.srad.jp",2943],["blog.ss-blog.jp",2944],["stds.jp",2946],["stv.jp",2948],["stylehaus.jp",2949],["suisan.jp",2950],["suits-woman.jp",2951],["sukupara.jp",2952],["supleks.jp",2955],["surfsnow.jp",2957],["swiki.jp",2958],["tabizine.jp",2959],["taishurx.jp",2960],["tap-biz.jp",2963],["sugutoku.tasdesign.jp",2964],["tbp.jp",2965],["tbsradio.jp",2966],["techable.jp",2967],["techinsight.jp",2968],["technologyreview.jp",2969],["telnavi.jp",2970],["temaeitamae.jp",2971],["tenki.jp",2972],["texal.jp",2974],["tg-uchi.jp",2975],["theriver.jp",2977],["tifer2.jp",2980],["timeout.jp",2981],["fashionbox.tkj.jp",2982],["tocana.jp",2983],["tokion.jp",2984],["tokk-hankyu.jp",2985],["tokyo-calendar.jp",2986],["city.hachioji.tokyo.jp",2989],["city.komae.tokyo.jp",2991],["city.meguro.tokyo.jp",2992],["toranoana.jp",2994],["ec.toranoana.jp",2995],["touken-world.jp",2997],["trailrunner.jp",2999],["trendka.jp",3000],["trilltrill.jp",3001],["try-it.jp",3003],["t-mall.tsite.jp",3004],["tsugimanga.jp",3005],["tsuritenki.jp",3006],["kyosui.net",[3009,3290]],["tver.jp",3018],["tvkingdom.jp",3019],["tvlife.jp",3020],["twpro.jp",3021],["uekipedia.jp",3022],["ufret.jp",3023],["web.ultra-soccer.jp",3024],["unitedcinemas.jp",3025],["univ-journal.jp",3026],["ura-akiba.jp",3027],["usedoor.jp",3028],["uub.jp",3030],["wanchan.jp",3036],["wear.jp",3038],["kishojin.weathermap.jp",3039],["weathernews.jp",3040],["web-ace.jp",3041],["webcomics.jp",3043],["eikaiwa.weblio.jp",3045],["ejje.weblio.jp",3046],["translate.weblio.jp",3047],["uwl.weblio.jp",3048],["l-o-l.net",[3048,3293]],["weddingcard.jp",3049],["wellmethod.jp",3051],["wiki3.jp",3052],["wikihow.jp",3053],["wikiwiki.jp",3054],["winchesterhouse.jp",3055],["wired.jp",3056],["withnews.jp",3057],["wowseoul.jp",3062],["wowsokb.jp",3062],["simtransfer.wpx.jp",3063],["xfolio.jp",3064],["wiper.xii.jp",3065],["xn--4gr16r4zc9g.jp",3066],["xn--68jza6c6j4c9e9094b.jp",3067],["xn--m9jq94aa0541c35dspl8l8d.jp",3068],["xn--o9ja9dn55ayerin411bcd3afbgz3gd4y.jp",3068],["xn--y8j8gq48f5heu33c.jp",3069],["xneo.jp",3070],["tt5218.xsrv.jp",3071],["dosports.yahoo-net.jp",3073],["yamagata-np.jp",3074],["city.hokuto.yamanashi.jp",3075],["city.kai.yamanashi.jp",3076],["city.koshu.yamanashi.jp",3078],["city.minami-alps.yamanashi.jp",3079],["yamatogokoro.jp",3080],["ymobile.jp",3081],["yogajournal.jp",3082],["yomitai.jp",3083],["yourbengo.jp",3085],["yourmystar.jp",3086],["yoyaku-top10.jp",3087],["invitation4you.link",3089],["m.kuku.lu",3090],["adult-gazou.me",3091],["memo.appri.me",3092],["cartune.me",3094],["fineplay.me",3097],["w.grapps.me",3100],["keisanki.me",3106],["buy.line.me",3107],["mobile.line.me",3108],["lineblog.me",3109],["blog18.mmm.me",[3111,3112]],["picrew.me",3114],["querie.me",3115],["sukima.me",3117],["limo.media",3120],["melos.media",3121],["aya0205.smart-douga.mobi",3122],["natalie.mu",3123],["marumie.name",3124],["2-carat.net",3126],["blog.40ch.net",3129],["find.5ch.net",3135],["jump.5ch.net",3137],["adultgeek.net",3138],["ai-matome.net",3139],["aidoly.net",3140],["all-freesoft.net",3141],["allcinema.net",3142],["animalch.net",3145],["anime-news.net",3146],["anime365.net",3147],["animephilia.net",3148],["ao-system.net",3150],["app-ranking.net",3151],["appbank.net",3152],["appmarketinglabo.net",3153],["asobicreate.net",3155],["at-a-gallop.net",3156],["avdouga.net",3157],["baseball-mag.net",3159],["bbspic-newer.net",3160],["beautelink.net",3161],["birdfan.net",3164],["blkt.net",3165],["ettina.blogterest.net",3167],["sukebelog.blogterest.net",3167],["sweetchocolate.blogterest.net",3168],["bushikaku.net",3170],["buttobi.net",3171],["calciomatome.net",3172],["catchapp.net",3173],["celery-marine.net",3174],["chil-chil.net",3176],["cinemarche.net",3177],["cityheaven.net",3178],["collepic.net",3179],["cosme.net",3181],["cosppi.net",3182],["couple-game.net",3183],["crepu.net",3185],["cybersyndrome.net",3187],["datadeliver.net",3188],["adultcomic.dbsearch.net",3189],["ddd-smart.net",3190],["dekiru.net",3191],["diamond-rm.net",3192],["digimart.net",3193],["digital-soccer.net",3194],["dissoku.net",3195],["dm-wiki.net",3196],["dobon.net",3197],["dousyoko.net",3200],["ero.e7c.net",3202],["eleking.net",3206],["elog-ch.net",3207],["energydrinkmania.net",3208],["ero-video.net",3209],["erodoganomori.net",3210],["erokan.net",3213],["eromon.net",3214],["eroterest.net",3216],["ertk.net",3218],["esports.net",3219],["exawarosu.net",3220],["ezbbs.net",3222],["matome.f-book.net",3223],["fashion-press.net",3225],["fesoku.net",3226],["community2.fmworld.net",3229],["fmv-mypage.fmworld.net",3230],["fujitv-flower.net",3234],["futabaforest.net",3235],["fx2ch.net",3236],["gahag.net",3237],["gamesink.net",3241],["gamestalk.net",3242],["garanger.net",3243],["gigazine.net",3245],["girlsreport.net",3246],["goisu.net",3247],["news.gree.net",3248],["plus.news.gree.net",3249],["hametaro.net",3252],["helohelion.net",3254],["okinny.heypo.net",3255],["hiwaijosi.net",3256],["hyperts.net",3257],["i-njoy.net",3258],["idokaba.net",3259],["report.iko-yo.net",3261],["ituki-yu2.net",3262],["jalan.net",3263],["japanhub.net",3264],["thatav.net",3264],["javstore.net",3265],["jigen.net",3266],["jinja-bukkaku.net",3267],["jiwachan.net",3268],["jj-jj.net",3269],["johnnys-watcher.net",3270],["joytokey.net",3271],["chanto.jp.net",3272],["jwing.net",3274],["jyukusiri.net",3275],["kai-you.net",3276],["karzusp.net",3277],["kateich.net",3278],["keokeoblog.net",3279],["kiwi-english.net",3283],["jhs-math.komaro.net",3285],["kyodemo.net",3288],["kyousoku.net",3291],["kyuusai2nd.net",3292],["lasisa.net",3294],["lettuceclub.net",3295],["limee.net",3296],["lolninja.net",3300],["ma-bank.net",3303],["mainichigahakken.net",3304],["makitani.net",3305],["mammemo.net",3306],["mapple.net",3307],["masterwiki.net",3308],["milkcafe.net",3311],["mj-news.net",3312],["mnk-news.net",3313],["moedb.net",3315],["moeeki.net",3316],["momi3.net",3318],["money-cashing.net",3319],["monokakitools.net",3320],["sscard.monokakitools.net",3321],["morekorea.net",3322],["muvc.net",3326],["mylifenews.net",3327],["nanigoto.net",3329],["nanjchallenge.net",3330],["nazo2.net",3331],["news4wide.net",3332],["nicozon.net",3333],["no-one-no.net",3334],["nofootynolife.net",3335],["o-dan.net",3337],["blog.onk164.net",3339],["orefolder.net",3341],["osakamotion.net",3342],["sp.oshaburi.net",3343],["oshiete-kun.net",3344],["otakuma.net",3345],["otayoripost.net",3346],["otoriyose.net",3347],["ouminews.net",3348],["oursounds.net",3349],["pictbland.net",3352],["pig109.net",3353],["dic.pixiv.net",3354],["plicy.net",3355],["pokema.net",3356],["pokemon-matome.net",3357],["pokemongo-kouryakumatome.net",3358],["privatter.net",3360],["ruigo.quus.net",3362],["rakukan.net",3363],["rakuten-sec.net",3364],["ichiba.faq.rakuten.net",3365],["renote.net",3368],["rocomotion.net",3370],["rubese.net",3371],["sabuibo.net",3372],["sagaoz.net",3373],["saikomangaraw.net",3374],["news.searchina.net",3376],["seesaa.net",3377],["5656-onepiece.seesaa.net",3378],["hdata.seesaa.net",3379],["helloprojects.seesaa.net",3380],["kirinstation.seesaa.net",3381],["my0nio.seesaa.net",[3382,3383]],["oto-suu.seesaa.net",3382],["sadironman.seesaa.net",3384],["seimei-handan.net",3385],["sekkaku.net",3386],["fm.sekkaku.net",3387],["receive.shamimomo.net",3389],["shigedosicks.net",3390],["shikaku-fan.net",3391],["shiroutoav.net",3392],["jbbs.shitaraba.net",3393],["shittokuadult.net",3394],["shokuhin.net",3395],["s.shufoo.net",3397],["silky-love.net",3399],["sk2ch.net",3401],["skypemeet.net",3403],["skypenguin.net",3404],["slotlog.net",3405],["smanavi.net",3406],["smatu.net",3407],["solomon-review.net",3408],["studiok-i.net",3411],["studyhacker.net",3412],["talknews.net",3417],["taruo.net",3418],["tennis365.net",3420],["amigo.tennis365.net",3421],["news.tennis365.net",3422],["teradas.net",3423],["toaru-web.net",3425],["tokyomotion.net",3426],["tousatu-ch.net",3428],["shikiho.toyokeizai.net",3432],["tv-watch.net",3435],["tvjapan.net",3436],["twiman.net",3438],["uhyohyo.net",3440],["voyeur-movie.net",[3447,3448]],["vsnp.net",3449],["waifu2x.net",3450],["service.webgoto.net",3454],["news.webike.net",3455],["wife-board.net",3456],["wikinis.net",3457],["windowsfaq.net",3459],["with2.net",3460],["wood-museum.net",3461],["worldfn.net",3463],["wtmnews.net",3464],["xn--cck0eqb0ebb.net",3466],["yoheim.net",3468],["youravhost.net",3469],["yugalab.net",3470],["yugioh-wiki.net",3471],["zyuken.net",3473],["chu.zyuken.net",3474],["daily-tohoku.news",3475],["hochi.news",3476],["kumin.news",3478],["gigafile.nu",3479],["choosar.gigafile.nu",3480],["shortener.gigafile.nu",3481],["wiki.yjsnpi.nu",3482],["teams.one",3483],["mangarawjp.onl",3484],["rallys.online",3485],["shueisha.online",3486],["2shot.org",3488],["live-events.a-jp.org",3489],["benricho.org",3491],["chomanga.org",3492],["colordic.org",3493],["erogamescape.dyndns.org",3494],["erogamescape.org",3494],["favolog.org",3495],["gotokyo.org",3497],["kabegami.jpn.org",3500],["kaworu.jpn.org",3501],["klmanga.org",3502],["loveh.org",3503],["nekonikoban.org",3504],["news-us.org",3505],["hoi4data.paradoxwiki.org",3506],["refind2ch.org",3508],["gift-for-loved-one.tokyo",[3509,3551]],["syosetu.org",3511],["todaishimbun.org",3512],["tomari.org",3513],["smpt.webrental.org",3514],["majeur.zawarudo.org",3515],["hinode.pics",3516],["bokunokanojo.pink",3519],["sexywars.pink",3520],["hedgehog.ryukyu",3526],["maguro.2ch.sc",3527],["cocoromembers.jp.sharp",3529],["adseek.site",[3530,3531]],["animemaruwakari.site",3532],["pixnest.pipio.site",3535],["s-restaurant24h.site",3536],["zabuu.site",3537],["vague.style",3538],["coron.tech",3539],["connect.coron.tech",3540],["gameguide.tech",3541],["dinvia.diary.to",3543],["global.sp.land.to",3544],["jump.x0.to",3545],["sukkiri.today",3546],["mag.digle.tokyo",3547],["movie.digle.tokyo",3548],["elog.tokyo",3549],["game-news.tokyo",3550],["hanako.tokyo",3552],["web.playerapp.tokyo",3555],["rakko.tools",3556],["mangakl.top",3559],["reminder.top",3560],["times.abema.tv",3562],["b.best-hit.tv",3564],["i.best-hit.tv",3565],["cchan.tv",3567],["delishkitchen.tv",3568],["ikora.tv",3570],["lala.tv",3572],["ohen.tv",3573],["popnroll.tv",3574],["traffic-exchange.tv",3576],["wav.tv",3577],["chobirich.us",3578],["jpshowbiz.us",3579],["abstractpainting.work",[3580,3581]],["lithograph.work",3581],["oilpainting.work",[3585,3588]],["efootball.work",3586],["tkgstrator.work",3591],["doujin-master.fc2.xxx",3593],["goodend.xyz",3595],["h-douga.xyz",3596],["itojisan.xyz",3597],["jinsei-kyukeityu.xyz",3598],["jukujo-neet.xyz",3599],["k3su.xyz",3600],["sugi69693.xyz",3603],["theav.xyz",3604],["hamakore.yokohama",3607],["socom.yokohama",3608]]);

const entitiesMap = new Map([["48idol",[1,2,3,4]],["9tsu",5],["fc2",6],["free-erobooks",7],["javmix",8],["jmanga",9],["manga.okiba",10]]);

const exceptionsMap = new Map(undefined);

self.specificImports = self.specificImports || [];
self.specificImports.push({ argsList, hostnamesMap, entitiesMap, exceptionsMap });

/******************************************************************************/

})();

/******************************************************************************/
