/*******************************************************************************

    uBlock Origin Lite - a comprehensive, MV3-compliant content blocker
    Copyright (C) 2019-present Raymond Hill

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see {http://www.gnu.org/licenses/}.

    Home: https://github.com/gorhill/uBlock
*/

/* jshint esversion:11 */

'use strict';

// ruleset: kor-1

/******************************************************************************/

// Important!
// Isolate from global scope
(function uBOL_cssSpecificImports() {

/******************************************************************************/

const argsList = [".banner",".advx",".MainBnnWrap,\ndiv[data-page] > div[class]:has(a[target=\"_blank\"])",".widget-side-box > .main-box:has(img[src^=\"/imgs/\"])","img[src^=\"/img/\"][src*=\".gif\"]",".custom_banner_item",".custom_banner_wrap","div[id^=\"tdn_\"][style*=\"height:\"]",".ba_test,\n.banner2",".popup_warp,\na[href][target=\"_blank\"] > img[src^=\"/images/banner/\"]:not([src^=\"/images/banner/webtoon_\"])","div[id*=\"-banner-\"]","#body_wrap > div[class][style^=\"margin:\"]",".main_banner",".mwcphideBtn",".product-banner,\ndiv[class^=\"mobile-m ad720_\"]","div[class^=\"DanjiInfomation__\"] > div[class^=\"Divider__SD_Layout-\"] + div[class^=\"Divider__SD_Layout-\"]","#banner",".flex > a[href][target=\"_blank\"]","div[id^=\"toptr-\"]",".col-md-3.at-col.at-side > .row.fix-gutters-5,\nimg[src^=\"/mainhover/\"]",".basic-banner.row.row-10","div[data-controller=\"font\"] > .hidden,\ndiv[data-fonts-target=\"fontsContainer\"] > div.group.min-h-auto:not(.duration-300):not(.justify-between)",".code-block","div[class$=\"-ad\"]","#main > div[class*=\"-ad-\"]","body .view_sp_banner .swipe-slide:has(img[src^=\"https://recipe1.ezmember.co.kr/cache/shop/\"]),\ndiv[id^=\"divEzad\"]",".container > div[style]:not([class]),\n.recipe_list > div[style*=\"height:\"],\n.sp_pdt_wrap,\n.view3_box > .sp_pdt_wrap:has(div[data-url*=\"//link.coupang.com/\"].coupang_layer),\ndiv[id^=\"obx_foodname_goods\"]",".page-content > .row.no-gap.no-space > .col-33","div[class^=\"banner_\"]","#articleBody > div[style*=\"height:\"],\n#articleBody ~ div[class$=\"_banner\"],\ndiv[class^=\"asd_\"]","div[class*=\"_ad_\"]","div[class^=\"ad-\"]","ul.post-list > li[class^=\"post-\"]:not([id]):not([data-post-id])","div[id^=\"mobonDivBanner_\"]",".copas_btn","#popup-root,\narticle > div[class^=\"sc-\"] > aside[class*=\" \"],\nfigure[id^=\"image-\"]:has(> img[src^=\"/files/media/\"])","#home-sidebar > a[target=\"_blank\"],\n.advertisement_area div[class^=\"ad\"],\ndiv:is([aria-label=\"Primary Sidebar\"], #home-sidebar) > aside:has(img.image),\nmain[role=\"main\"] header ~ .code-block",".tagdiv-type .best_news_wrap_mo,\ndiv[class^=\"floating_ad_\"]",".td-pb-span4.td-main-sidebar,\ndiv[class^=\"adsense_\"]","#__next > div:not([class]):not([id]) > div[style^=\"position:\"]","div[id$=\"_bn\"]","#hd_pop","div[id^=\"imgDiv\"]","#foogallery_widget-12,\n#foogallery_widget-13,\n#foogallery_widget-3","div[class^=\"ad\"]","div[class^=\"ad_\"]","div[class*=\"_banner_\"]",".topbanner","a[href^=\"/b/c/NPM\"],\nfooter ~ div[style^=\"position:\"]",".banner.container > .row > .col-6",".adsense-alt","a[href*=\"//link.coupang.com/\"][type]","article[class$=\"_banner\"],\ndiv[id$=\"_bn_area\"],\ndiv[id^=\"powerbiz\"],\ndiv[id^=\"scroll_banner\"],\ndiv[style~=\"#D5D5D5;\"][style~=\"border-bottom:1px\"],\niframe[src^=\"/main_contents/main_banner_\"],\niframe[src^=\"/media/include/media_view_banner.asp\"]","div[id$=\"_ad\"]","section[class^=\"banner-\"]","div[class$=\"_ban\"]","div[class^=\"popup_\"]","div[id*=\"-banner-\"] > div[class*=\" \"] > div[class*=\" \"][style*=\" \"],\nimg[src^=\"/tokinbtoki/\"],\nul[class] > li:has(> a[href*=\"tokkiweb.com\"])","div[class*=\"_ad\"]",".inner > div[class*=\" full\"] ~ div[class^=\"arl_\"],\n.left_area > a[href^=\"https://smartstore.naver.com/\"] + .h20,\n.left_area > a[href^=\"https://smartstore.naver.com/\"] + .h20 + .line,\n.wcms_side div[style^=\"padding-top:\"].aside div[class$=\"_ad\"] + .h20 + .line,\n.wcms_side div[style^=\"padding-top:\"].aside div[class^=\"banner_\"] + .h20 + .line","div[class^=\"article-adCover-div-\"]","#adNotice","div[id^=\"brave_popup_\"],\ndiv[style*=\" \"]#showtoday","#CmAdContent > table[style]","#container > div[style=\"margin-top:10px\"],\n.main_bnr",".wcms_bestnews ~ div[class]:has(~ div[class] ~ .side_major_company)","[id][class] > div[style].panel-default",".partners-wrap #partners","div[class$=\"Ad\"]","div[class^=\"layout__article-header\"] > div[class^=\"flex-chain-wrapper\"],\ndiv[class~=\"arcad-wrapper\"]","div[class$=\"_ad\"]","div[class^=\"AD\"]","div[class$=\"AD\"]","#fusion-app footer,\ndiv[class*=\"-pad-top-\"][class*=\"-margin-\"][class*=\"-bg-grey-\"]","div[id*=\"_ad_\"]","div[class$=\"_banner\"]",".aside_doctor .tour_box","[class*=\"_ad_\"]","#content ~ .edit_bottom li:has(.li_ad),\n.sub_article > div[style]","#_popIn_recommend","a[class*=\"_ad\"]","iframe[src=\"/common/inc/main_right_banner.asp\"],\nimg[src^=\"/images/banner/\"]",".bnr_area a[target]:not([href*=\"//realty.chosun.com/\"]),\niframe[src*=\"//realty.chosun.com/RealtyCommon/Promotion\"][src$=\".html\"]","div[class$=\"banner\"]","div[style].row.no-gutters > .col-3:not([style])","div[id*=\"Ad\"]","#footer_container,\n#wrap > div[style*=\"height:\"][style^=\"position:\"],\naticle div[style]:not([id]):not([class]):not([itemprop]),\nbody > div[style^=\"height:\"][style*=\"width:\"],\ndiv[id$=\"ad\"][class^=\"ad\"]","iframe[src^=\"/ad/\"]","article.layout__article-main > .box--pad-bottom-lg,\narticle.layout__article-main > .box--pad-top-md,\narticle.layout__article-main > .box--pad-top-xl.box--hidden-sm:has(> .box--border-xs),\nsection[itemprop=\"articleBody\"] > .arcad","div[class*=\"-banner\"]","a[target=\"_blank\"][href][onclick][class*=\"Banner\"]",".section_h3 > div:has(~ .m01_arl46)","div[class^=\"css-\"]:has(> ins.adsbygoogle)","img[class^=\"banner_\"]",".td_sub_read_contents div[style*=\"width:\"]","div[class$=\"_bn\"]","#cpb-popup-banners,\n#custom_banner_wrap","table[style]:not([style=\" \"]) a[href][target=\"_blank\"]",".MuiGrid-item button[style^=\"background-color:\"].MuiButtonBase-root",".con_primary hr.skin_margin,\ndiv[style] > div[class^=\"arl_\"] ~ hr.skin_margin,\ndiv[style] > div[class^=\"ban_\"],\ndiv[style] > hr.spc","#sdp-bottom-banner,\n#sdp-mid-banner-btf,\n#sdpAdsBottom,\n#sdpBottomAds,\n.ads-impression,\n.srp-top-banner-container,\ndiv[data-use-adzerk][id$=\"-banner\"],\nli.search-product__ad-badge",".plp-default__item.search-product__cmg-badge,\ndiv[data-page-type=\"brandSDP\"][id$=\"carousel-products\"],\ndiv[id^=\"sdp-\"][id$=\"-banner\"]","div[id$=\"_banner\"]","#srp-bottom-carousel-dco-contaner","div[style^=\"max-width:\"].bx-wrapper > div[aria-live=\"polite\"][style].bx-viewport,\ndiv[style~=\"background-image:\"][style*=\".cuonet.com/data/apms/background/\"].item","div[class*=\"Ad\"]","#danawa_main_container > .main-top > .main-top__center > .main-middlebnr,\n#danawa_wrap > .ttop_banner,\n.main__grid.main__grid--line .main__grid__right","#danawa-gnb-banner,\n.sponsor_pick,\ndiv[id*=\"-ad\"],\ndiv[id*=\"-ad-\"],\ndiv[id^=\"danawa-dpg-\"][id*=\"-dable\"]",".goods-list__ad","#ebayPowerClickBottomArea,\n#naverPowerShoppingArea,\n#powerClickProductListArea,\n#powerShoppingContent,\ndiv[class$=\"_ad_prodlist\"]","#powerClickListArea,\n.powershopping,\nli[style][id^=\"ad\"]",".trend-rank,\ndiv.dctrend_ranking,\ndiv.key_trendbox,\ndiv[class^=\"rightbanner\"],\nul.cmt_list > li[id^=\"comment_li_\"].ub-content.dory","div[id^=\"ad\"]","*[class^=\"adv-group\"],\n.brick-wid > .grid:has(> *[id*=\"_title\"] ~ *[style] .power-tittxt),\n.detail-top-lst li:has(a[href*=\"//addc.dcinside.com/\"]),\n.power-tit","#user_data_lyr .bg_grey:has(a[href*=\"//addc.dcinside.com/\"]),\n.gall_list .ub-content:not(.us-post):has(a[href*=\"//addc.dcinside.com/\"]),\narticle#write_wrap > #write > div[style]:has(ins.kakao_ad_area),\ntr.list_trend",".con_banner",".side .login-box ~ .img-wrap","div.key-trendbox,\nul.detail-top-lst.trend",".ban_box",".add_display",".ad","#content > .article > div[class][style],\nol.bd_lst li[class]:has(span[class^=\"ad_\"]),\ntable.bd_lst tr.notice:has(span.ad),\ntable.bd_lst tr[data-document-srl]:has(.ad_gray)","div[id^=\"ad-\"]",".MapMain > #map ~ div[class]:not([id]):not([style])","div[class$=\"-ad\"] ~ .section.naver","div[class*=\"Banner\"]","div[class*=\"banner\"]","div[id^=\"ad_\"]","#above_cmcl_box,\n#dongawrap > #view + div[class*=\"ad_\"],\ndiv[id^=\"adbox_\"]","#div_laypopup,\n#overlay",".at_content > div[style],\ndiv[id*=\"_cpc_\"],\niframe[id$=\"_ad\"]",".left_cont > div[style^=\"width:\"],\ndiv[class*=\"naver_power\"]",".today_sportnews,\ndiv[id*=\"_AD\"]",".hideBtn","div[style~=\"height:\"][style~=\"border-top:\"].relative","#body_wrap > #body_main > div[style]:nth-child(2)","section[id*=\"_ads_\"],\nsection[id^=\"block-\"].widget_block",".SubInforDiv_article table ~ div[style^=\"padding:\"][align=\"center\"]","body > div[style]:not([class])",".m-row > div[class^=\"col col-\"]:not(:has(> .col__inner a:not([href*=\"ad-api.enuri.info\"]))):has(.bnrbox ul[id][class^=\"bnr__\"]),\n.right--inner > div[class^=\"bnr_\"],\ndiv[id$=\"_banner\"][class^=\"banner_\"],\nli[class^=\"ad-\"]","div[class*=\"_bnr\"]","div[class*=\"-ad-\"]",".m_main_top_banner,\ndiv[style*=\" \"]#mainLayer",".adadwrap",".erd-ads-area","div[class$=\"_ad_wrap\"],\niframe[src*=\"//www.etnews.com/tools/refresh_script.html?\"]","div[style].xe-widget-wrapper:has(a[href^=\"/sisaing\"])","iframe[src=\"https://filetender.com/mobon.html\"]","#sidebar div[style^=\"height:\"]:not(.li),\n.adpost,\ndiv[class$=\"top_hotdeal\"],\niframe[src^=\"https://loader.fmkorea.com/_loader/loader.php\"]",".fm_vote ~ div[style*=\"max-width:\"],\n.rd_ft > div[style^=\"margin:\"][style*=\"max-width:\"],\ndiv[id^=\"fmad_\"] + div[style^=\"height:\"][class]",".col-300 > div[style^=\"height:\"],\ndiv[id^=\"add_view_\"][style]",".con_rt > div[class^=\"lcrt\"] ~ div[class^=\"mcrt\"]:has(img[src*=\"/common/ad_\"].ad)",".ad-form > .row > div[class^=\"col-md-\"]","aside[id^=\"ai_widget-\"]","#right-sidebar","div[class$=\"ad\"][style]","a[href^=\"/extcont/adclick.php\"]",".mwrap > div[style]:not([class])","div[class*=\"AD\"]",".game_wrap ~ div[style*=\" \"],\ndiv[id^=\"ads_\"]","div[id$=\"AD\"]","iframe[src^=\"https://ads.gamemeca.com/\"]",".gb-container > .container-widget:has(ins.adsbygoogle)","div[class^=\"ai-viewport-\"]","#body_read > div[style^=\"margin:\"] > div[class=\"\"][style*=\"width:\"]","iframe[id^=\"happy_banner_scroll_\"]","#gap > div[style*=\": \"].xe-widget-wrapper:has(.widget_banner_skin > .banner_list),\n.widget_banner_skin > ul.banner_list,\ndiv[style~=\"!important;\"] > .nw_box > div:not(class):not(id) > table[cellspacing=\"0\"][class]:not(:has(a[href*=\"//gigglehd.com/gg/\"]))","#wingBanner","body > #bottom-sticky",".td-ss-main-sidebar > .td-a-rec","div[itemprop=\"mainContentOfPage\"].theme-content + aside","aside .box-margins:has(~ .box-skin.point-title)",".side-ad-box,\ndiv[class*=\"-ad-\"]:not(data-el)","div[class^=\"banner-\"]","div[class*=\"-ad\"]:not(.container):not([style])","div[id^=\"banner\"]","div[id^=\"power_link_\"]",".article_area > .article_right","#articleText > section[style*=\"height:\"]","a[class^=\"ad_\"]",".wrap > div[id^=\"AD_MOBILE_VIEW\"] ~ div[style^=\"width:\"]",".article_area .list_r,\n.article_wrap div[class^=\"ad\"],\ndiv[id*=\"_ad\"]","div[class^=\"ad\"] ~ .ranking,\ndiv[style^=\"margin-top:\"].survey",".item-list > .on:has(.ad-wrap-text),\n.list-body > .list-item-ad,\n.view-mobile div[class*=\"margin-\"]:has(#main_bn)","#wrap_cnts > div[style^=\"margin:\"],\n#wrap_mdd ~ div[style*=\"height:\"]",".comment_best_wrap ~ div[id][style^=\"min-height:\"],\n[id^=\"li\"] > [id]:has(span ~ div img[src$=\"_ad.gif\"]),\nbody > .adsbygoogle,\ndiv[id$=\"_boom_boom_wrap\"][class*=\" \"],\ndiv[id*=\"_\"] div[class][style*=\"min-height:\"],\ndiv[id*=\"_\"][style*=\" \"] ~ div[id][class]:not([id*=\"_\"]),\nform[id][name] ~ div[id][style^=\"min-height:\"],\nstyle + a[href*=\"//\"][target=\"_blank\"],\ntable[class^=\"ad_\"]",".adsbygoogle","#wrap_cnts > div[style*=\"margin:\"][style^=\"width:\"].box,\n#wrap_cnts > div[style*=\"min-height:\"],\n#wrap_cnts td[align=\"center\"]:has(img[src$=\"_ad.gif\"]),\n.noti_div ~ div[style*=\" \"] > div[style*=\"overflow:\"][class],\ndiv[id*=\"_right_list_\"] ~ div[style],\ndiv[id^=\"list_right_\"] iframe[src*=\"/board/humor/list_right.html\"] ~ div","#aside > #partner,\ndiv[id$=\"_sponser\"],\ndiv[id^=\"Aside\"][id$=\"Event\"],\ndiv[id^=\"Partner\"],\ntr:has(> td[colspan][rowspan] > a[href*=\"//prod.danawa.com/\"] > img[src^=\"./partner/\"])","a[href^=\"/ad_link.php?\"]","#article-view-content-div div[class$=\"-banner\"]","#wrap_index ~ div[style]","div[class$=\"-banner\"]","#sky-banner-wrap,\nimg[src^=\"https://acache.ilbe.com/\"],\nul.board-body > li[id^=\"sponser_ad_\"]","article.cutin-banner,\narticle[id$=\"_banner\"]",".banner-wrap","#layer-popups",".wcms_banner",".article_view > .p_space + div + .h20,\ndiv[class$=\"_ad\"][style] + .h20","div[class^=\"banner\"]",".cPrdlists_wrap > .cPrdlists_rows:has(script[src*=\"//nvapi.feeldmc.com/\"])","ad,\naside > hr[class],\nheader ~ container[class*=\"-\"]","article > div[style]:not([class])","center > div[style] ~ center ~ div[style^=\"margin-top:\"],\ntable[id][width] tr[bgcolor] ~ tr:not([bgcolor]):has(td > ins.adsbygoogle)",".productListWrapper > .choiceWrap,\n.productListWrapper > .loadWrap","#btnlist > #listChoiceScope,\n.AdvertisingList,\n.productListWrap > #idRecommendWrap,\n.productListWrap > #serviceKeywordId,\n.productSortingList > .choice,\n.productSortingList > .listTitle:has(a[aria-describedby^=\"adLayerChoice\"])",".rightEnd > .section_inner > div[style]","div[id$=\"Ad\"]",".popup","ul.masonry-2-col > li[class] ~ li:not([class])","article[class*=\"-banner\"]","div[class^=\"ab_ad\"]","a[rel*=\"sponsored\"],\ndiv[type=\"DETAIL\"] section[aria-label=\"새 상품은 어떠세요?\"]","#ai_widget-2","div[class*=\"_bn_\"]","hr[style].blank","ul[id=\"info.search.place.list\"] > li.AdItem","#contEtc > #nativeAdWrap,\n#contEtc > #rightContentbox:has(#SearchRightAdWrap),\ndiv[data-gg=\"{s1:shopping}\"] h2 + div[class^=\"#banner\"]","div > a[href^=\"/event?event_id=\"][style],\ndiv[class^=\"left\"] ~ div[class]:not([style]):has(ins.kakao_ad_area),\ndiv[id^=\"kakao_ad_\"]",".ad-slot-vertical,\ndiv.max-w-screen-lg > .relative > div > div[class=\"\"]:nth-child(1)","section[class^=\"ad\"]","body > div[align] > div[align] > div[style] > div[style][align=\"center\"] > table[style*=\"margin-top:5px;\"],\nbody > div[align] > div[style*=\"overflow:hidden;\"][align] > div > div[class] > a[href],\nimg[src*=\"koreapas.com/bbs/data/\"],\nimg[src^=\"athe/\"]","div[class^=\"bn_\"]:not([class*=\" \"])",".articleTxtAD,\ndiv[id^=\"better-ads-\"],\niframe[src*=\"/wp-content/uploads/ads/\"]","div[itemprop=\"articleBody\"] ~ div[style]","body > article#content > article.block:has(ul#life_slider)","img[src*=\".imgbox.com/\"]","aside[class^=\"banner_\"]","div[style].text-center","div[class*=\"banner-\"]",".is-hover a[href^=\"http\"][target=\"_blank\"],\ndiv[id][class*=\" \"][data-interval] div[style*=\"/data/apms/background\"]","a[target=\"_blank\"][data-href][data-banner-statics]",".productDetailInfo ~ div[style*=\" \"].emptyComponent,\n.rankListType > li[class][data-object*=\"&ad=\"]:not([data-object*=\"&ad=n&\"])",".content_body > div[class$=\"_coupang_wrap\"],\n.content_more_div > .cmd_block_layer",".comic_bot_bnr,\n.payment_fullbnr","div[id^=\"ad\"][class^=\"ad\"][style]","aside > article ~ div[style*=\"height:\"]","iframe[src^=\"/banners/load/\"],\nimg[src*=\"//img.mediapen.com/banners/\"]","div[data-ad][class][style]","tbody td > div[id^=\"MAX_\"]:has(#gpt-passback)",".div_banner","div[class*=\"adsense-\"]","a[id^=\"ad-\"],\ndiv:not([class$=\"-mobile\"]) > div[class]:has(> [class*=\"_ad_\"]):not([data-review-count]),\ndiv[class~=\"hospital-images-box\"] ~ .row > .col-4","div[class^=\"Banner\"]",".footer_promotion,\nimg[src*=\"//image.munhwa.com/www/banner/\"]","section[class*=\"_ad\"]","div.ad","section[class$=\"_ad\"]","#welcome-ad,\n.content-preview",".widget-side > .widget-box > div[style]","#mainContainer #content .ct2 > section ~ *,\n.issueBn","#newsSidebar > div[class$=\"AD\"],\n#newsSidebar > div[class*=\"ad\"],\n#newsSidebar > div[id$=\"Banner\"],\n.thisTimeNews > div[class^=\"bn\"],\niframe[id^=\"ad\"]","div[class*=\"_banner\"]",".adtive",".divAdv,\niframe[title*=\"광고\"]",".sidearea.talktalk > .sideiframe","iframe[src^=\"/da/\"]","#breakingNews.overlay_break,\n#news_area ~ div[class*=\"_shopping\"]","a[href^=\"https://siape.veta.naver.com/\"]","#ssp-adpost","a[class*=\"banner_link_\"][target=\"_blank\"] > img[class*=\"banner_image_\"][src*=\"/Banner_\"],\ndiv[class^=\"popup_cheat_key_container__\"]",".wt_viewer .preview_store:not(:has(> img[src*=\"image-comic.pstatic.net/webtoon/event/contentsBanner/\"])),\n[id^=\"flex_ad_\"]","#ct div[class^=\"ly_\"],\n.band_banner","div[class*=\"_contentBody\"] main > .undefined:has(> div[class*=\"_Banner_\"]),\ndiv[class^=\"styles_Banner\"],\nimg[src^=\"https://nng-phinf.pstatic.net/\"][src*=\"_naverads.\"]","div[id*=\"Banner\"]","#MM_aside_smartad_container,\n.ISSUE-BANNER-AD,\ndiv.brick-vowel > div[data-block-code=\"AD-SMART-CHANNEL\"].MM_DA_SMARTCHANNEL,\ndiv[data-panel-code=\"SHOP_VOGUE\"] ._MM_TREND_PICK","div[id$=\"_AD\"]",".mail_toolbar ~ .smart_channel","#root > div[class*=\"PaymentLayout_article_\"] div[class*=\"AdBanner_article_\"],\ndiv[class*=\"Ads_article_\"] > div[class^=\"BottomAds_area-panel_\"]:has(> div[class*=\"Banner_article_\"]),\ndiv[class^=\"AdReward_list_\"] > div[class^=\"ADRewardGladBanner_article_\"],\ndiv[class^=\"SmartChannel_article__\"]:has(> div[class*=\"SmartChannel_\"])","#_pcmap_list_scroll_container > ul > li[data-laim-exp-id=\"undefined*e\"],\ndiv[data-nclicks-area-code] > div[class=\"place_section\"]:not([data-nclicks-area-code]):has(div[id*=\"_ad_\"])",".brand_search,\ndiv:is(._pl_section, ._bz_section).ad_section,\ndiv[class*=\"_fashion\"].more_prod,\ndiv[id^=\"power_link_together_\"],\nli[data-nvmid]._ad","._shopAdRoot,\n.sc._pwl_video_container,\nsection[class*=\"ad_\"]","div[class^=\"shoppingHomeResponsive_inner\"] div[class^=\"shoppingHomeResponsive_module__\"]:has(> .trend_pick)","div[class^=\"products_search_list\"] div[class^=\"adProduct_\"][id*=\"lst_\"]","#section_recommend div[class^=\"productList_list_area_\"] li[class^=\"productList_item_\"]:has(a[href*=\"//adcr.naver.com/\"]),\ndiv[class^=\"style_section_row_\"] > div[class*=\" asideItem_active_\"]:has(a[class^=\"adRecommend_\"]),\ndiv[class^=\"style_section_row_\"] ul[class*=\"asideBrand_brand_\"] > li:has(a[href*=\"//adcr.naver.com/adcr\"])",".main_grid_item > div[class*=\"_promotion__\"]","#newsstand ~ #feed.id_cargame .feed_box:has(span[class^=\"HighlightedColumnView-module__tag_ad_\"]),\n#root div[class^=\"Layout-module__content_\"]:has(iframe[src^=\"https://shopsquare.naver.com/\"]),\n#shortcutArea .shortcut_item:has(> a[href*=\"veta.naver.com\"] > i.ico_ad),\na[class*=\"_banner_\"],\ndiv[class^=\"Layout-module__content_area_\"]:has(> div[class*=\"_banner_\"]),\ndiv[id^=\"veta_\"]","#navyismMainContainer > div[style] + div:not([style*=\" \"]):not([id])j,\n#navyismMainContainer > div[style^=\"width:\"]",".app-layout-content > #app-board > .app-board-section > .app-board-container > div[style]:not([class]),\nmain.app-main > .app-layout-container > .app-layout-content > #app-board > div > div[style]:not([class])","table table > tbody table[width][cellspacing][cellpadding].black > tbody td[height=\"90\"]",".googlead",".articleView + .aside .smallbox:has(iframe[src^=\"/view/ad/\"]),\n.articleView div[class^=\"botBox\"]:not(.twinBox),\ndiv[class^=\"w_header_\"]:nth-child(1),\ndiv[id][style~=\"height:100px;\"],\niframe[src^=\"/view/ad/\"],\ntable[class*=\"Ad\"]",".article > div[style][class],\narticle > .article > div[class][style~=\"100%;\"][style~=\"250px;\"][style~=\"padding:\"],\ndiv[class$=\"adPos\"][class^=\"listStyle\"][style],\ndiv[style~=\"padding:10px\"][style~=\"10px;\"] > div[style^=\"height:\"],\niframe[src^=\"/ad_list/\"],\nsection > div[class^=\"listStyle\"] > ul[class^=\"listStyle\"] > li.first","#news-contents div[style*=\"margin:\"],\n.inwrap .right > div:not([class])","div[id^=\"popup_\"]","ul[class] > li:has(> a[href^=\"/guarantee.php\"])",".basic-banner,\ndiv.col-15.col-md-9",".board-tail-banner","div[id^=\"agnb-\"][class^=\"agnb-\"][style],\ndiv[id^=\"article\"].miso-post-gallery,\nli[class$=\"-ad\"]","[id$=\"Banner\"]",".inside-right-sidebar > aside[id^=\"custom_html-\"]","#div10Sticky,\n.content > ul.ad_area,\ndiv[class^=\"AD-\"],\ndiv[class^=\"m_ad\"],\ndiv[class^=\"new_ad\"]","iframe[src^=\"https://ojsfile.ohmynews.com/AD_FILE/\"],\nmain#article > .arc_list","table[bgcolor][cellspacing] td[bgcolor] table[width][cellspacing]:not([bgcolor]):has(tr marquee#innovationGA)",".basic-banner-gallery",".row > .col-sm-12:has(a[href^=\"/bbs/board.php?bo_table=primium\"])",".revenue_unit_wrap",".taboola","div[id^=\"lftwing\"]","#bottom_sit_handmade","tbody > tr[bgcolor] ~ tr:has(ins.adsbygoogle)","div[class*=\"ad_\"]",".content .left-wing > div","#primary-content > .magic-item-w","a[href*=\"../api/redirectAd.php?\"]","article > .inner ~ b","body > #academyMainModal:has(a[href^=\"https://academy.prompie.com/banners/\"]),\nbody > #academyMainModal:has(a[href^=\"https://academy.prompie.com/banners/\"]) ~ .modal-backdrop","div[id*=\"_banner_\"]","#fullscreen-overlay","[class^=\"img_wrapper\"],\ndiv[class^=\"panel_img_bottom_\"][style]","*:not(footer) > div[class^=\"main-\"][class$=\"-banner\"],\n.bot-content-area .mid-util-wrap .right-util-area,\n.custom-cont-page.custom-cont-page-head,\n.mid-content-area .left-util-wrap .bot-util-area,\n.price-compare-srch,\n.sponsor-logo-wrap,\ndiv[id*=\"_\"][class*=\"-\"][class^=\"bidrich-\"],\ndiv[id^=\"bidrich-\"],\ndiv[id^=\"bidrich_\"][style*=\" \"],\ndiv[role=\"main\"] > .logo-area","div[class*=\"-banner-\"]","[class^=\"banner-\"]","#divMemulRight > div:not([id]):not([class])",".google_bn",".entry-content > div[style*=\"height:\"]",".adrr,\ndiv.board_main > table > tbody tr.table_body.list_inner,\ndiv[class^=\"nbp_container\"]","#board_top .best_list ~ .border_box,\n.row.relative .main_aside:has(div.aside_background + div[id^=\"ad_main\"]),\ndiv[class*=\"ad_\"][style],\ndiv[class^=\"adrr_\"],\ndiv[id$=\"_best\"] ul[class*=\"best_list\"] li:has(a[href][target=\"_blank\"]),\ndiv[style*=\" \"] > div[id][style].relative,\ndiv[style].ti_wrapper",".aaddr_m_reward,\n.board_main .user_view_target ~ .row:not(:has(.source_url)),\n.main_center .line_deco_bottom:has(div[class^=\"ad_\"]),\ndiv[class^=\"ad_\"][class*=\" \"],\ndiv[id^=\"list_read_\"] ul[class*=\"_list\"] > li:has(a[href][target=\"_blank\"]),\ndiv[id^=\"mo_ad_\"],\ndiv[id^=\"nbp_container\"]","div[id^=\"dablewidget_\"]","#contentArea > div[style^=\"width:\"][id],\ndiv[class^=\"mythiell-mid-container\"]","div[id^=\"wps_layout\"][data-desc*=\"광고\"][data-box-file*=\"/box/\"]","article > div[id^=\"wps_layout\"] > div[style*=\"height:\"]","div[id^=\"carousel_\"].carousel.carousel-fade","#index > div[class^=\"box_shadow_\"][style]",".quiz_list:not([style]) ~ .result_wrap .restart,\n.waiting_coupang_wrap","#slrcf > .cl_spc,\ndiv[style^=\"height\"]#slrclub",".comment_inbox ul > li[style^=\"padding:\"]","div[id$=\"ad\"][style]","div[id$=\"-ad\"]",".list-webzine .list-item,\ntable .basic-info-alert:has(a[href=\"/marble/\"])","#Contents > #sideBox > div[style],\ndiv[id^=\"topAd\"],\np[class^=\"ad_\"]","div[class][data-ad][style]","div[id][style] > div[style*=\"margin-top:\"]","#aside > div[style^=\"width:\"]","div[id$=\"-banner\"]",".modal_contents",".visible-ad,\ndiv[class^=\"col-lg-offset-\"] > div[class^=\"col-lg-\"][style]:has(a[onclick*=\"link(\"]),\ndiv[class^=\"col-lg-offset-\"] > div[style*=\"height:\"].hidden-xs",".td_sub_read_contents > div[style]","#wrap > div[style^=\"overflow:\"][style$=\"background:#ddd;\"],\ndiv[itemprop=\"articleBody\"] > div[style^=\"float:\"]","#content > div[style^=\"background:\"][class]","#content > div[style^=\"padding:\"].module_box","#wrap > div[style*=\"height:\"]","section.content .thumbnail-area","div[style] > a[href][target=\"_blank\"]","div[style] > .td_block_wrap:has(a[target=\"blank\"])","#xt_sticker_wrap,\n.app-board-section tr:has(ins.adsbygoogle)","body > div[class][style*=\"box-shadow:\"]",".basic-body-main > .margin-bottom-5:has(a[target=\"_blank\"][tabindex])",".side-event-img","#bbs > table[style^=\"color:#\"] ~ div[style*=\"padding:\"][style*=\"border-left\"],\n#content > div[style*=\"width:\"],\n#contentmemo ~ .adsbygoogle > div[style^=\"background-color:\"],\n#honey > table[style*=\"border-left:\"][width],\n.content > .nextbr ~ div[style^=\"min-height:\"],\n.touch_none ~ div[style^=\"min-height:\"].bd_back,\ndiv[id^=\"dont\"][style],\ndiv[id^=\"dont\"][style] ~ table[style^=\"width\"],\ndiv[style^=\"margin-top:\"]#menu_right,\ndiv[style^=\"width:\"][class=\"adsbygoogle\"],\ntable.adsbygoogle ~ table[style^=\"min-height:\"]","div[class*=\"-adsense-\"]","div[class]:has(> a[aria-label=\"side-ads\"])",".et_bloom_popup","#divMsnAD,\niframe[src^=\"//ad\"][src*=\".thisisgame.com/ad\"]",".thecontent > .in-article-container,\naside#sidebar > div[id^=\"text-\"]",".adsense",".StoryBanner,\niframe[id^=\"aswift_\"]",".bloom-popup,\n.swim-side .module_plugin:has(a[target=\"_blank\"]),\nbody > div[style]#modal",".floatdiv",".poketory_sidebar > b","a[href^=\"https://www.panel.co.kr/user/join/etcpath/\"]",".adblock-on",".contents_style > blockquote:has(img[src*=\"coupangcdn.com/image/affiliate/banner/\"]),\n.contents_style > blockquote:has(img[src*=\"coupangcdn.com/image/affiliate/banner/\"]) ~ p:has(~ blockquote)",".module.module_plugin a[href*=\"//coinone.co.kr/user/signup?ref=\"],\n.module.module_plugin a[href*=\"//link.coupang.com/\"]","body.home #contents > .floating,\nimg[src*=\"://thumb.toomics.com/upload/banner/\"]:not([src*=\"/main/\"]):not([src*=\"/cut/\"])","main > section[style]:not([class])","a[href*=\"/ad/\"][target=\"_blank\"]","a[href^=\"/go/\"][target=\"_blank\"]","div[class*=\"at-\"] > .widget-box","#body_text > .at-main.at-col[style],\n.npia-board-gallery,\n.panel-default ~ .row > .col-sm-6","a[href^=\"https://torrentmode.com/bbs/bannerhit.php\"]","a[href*=\"/bbs/link.php\"]","style ~ .basic-post-gallery",".at-banner,\n.row-banner","a[href*=\"/ad/\"]","a[href^=\"/adver-\"]",".banner-box,\ndiv[style].border-shadow","#banner_header,\niframe[src*=\"//img.tvchosun.com/upload_img/\"][src*=\"/ad/\"],\nspan[class$=\"_banner\"],\nul[class^=\"banner_\"]","ul[class^=\"banner\"]",".wid","table[width][cellspacing] td[valign=\"top\"] table[width][border=\"0\"] td[height=\"100\"],\ntd[valign=\"top\"] ~ td[width][valign][bgcolor][align] table[width][height][border][cellpadding]","#contentsBox #mainCon #top_area,\n#frameBox,\n#login_box ~ #rightBox,\n#login_box ~ .roll,\n.primiumList,\nul[class$=\"_banner\"]","div[id$=\"Banner\"]","#header ~ div[class^=\"content_st_\"]:has(iframe[src$=\"_big_banner.php\"]),\n#sub_content table[style$=\"%; \"] td[valign]:not([style*=\" \"]) ~ td[style*=\" \"]","div[class*=\"-ContentSections\"] div[class^=\"css-\"] section:has(section[class*=\"-ContentSection\"] div[class*=\"-AdContainer\"])","#_contents div[data-container=\"bigBanner\"],\n#_rollingBanner,\n#_topBannerContainer","div[data-bottom-banner],\ndiv[data-list-wrapper=\"ad\"]",".search_box_listdeal > .aiplus","#aside div[class^=\"scroll-in\"] .bn:has(a[href^=\"/ad_link.php?\"])","div[id^=\"wjdqh\"]","[class^=\"ad\"]","#xcontent-goodsite,\n.mp4-banner-view",".thumb-ad","#popups","div[class*=\"border\"]:has(> a[href][target*=\"_blank\"]),\ndiv[x-data=\"popups()\"]","a[style*=\"background-image\"][style*=\"/data/banner/\"]",".news_view_con ~ div[style]","div[class*=\"-banner\"] div[class*=\" \"][style=\" \"]","table[class^=\"ad-\"]","img[id^=\"ad_\"]","#bnPartnerWing,\n#goodsDetailSponLnkArea,\n#mbnRoll_001 > .mbnRollUnit > .pagen_5,\n#mbnRoll_001 > .mbnRollUnit > .pagen_6,\n#mbnRoll_001 > .mbnRollUnit > .pagen_7,\n#yWelMid .yWelPubBook,\n#yWelTopMid > .wConLT,\n.mContRT .mbnRT,\ndiv[class*=\"_adArea\"],\ndiv[id$=\"_Ad\"],\ndiv[style^=\"margin-left:\"].yPartnerPop,\nspan[class$=\"Ad\"]","#welcomeTodayPop > section[id^=\"section\"][id$=\"Pop\"][style^=\"display:\"]","#contain > div[style*=\"margin-bottom:\"],\n#contain > div[style^=\"height:\"],\n#rich-media-placement ~ div[style*=\"height:\"][style*=\"padding-top:\"][style*=\"padding-bottom:\"],\ndiv:is(#board_search_result, .search_result) a[target=\"_blank\"][href^=\"/board/ad/\"],\ndiv[id^=\"clickmon_\"],\ntable.bd_list tr:has(a[href^=\"/board/ad/\"])","#article_list > li:not([class]),\n#levbar_info ~ .container ~ div[style^=\"height:\"],\n.container > div[style*=\"height:\"]",".rangking_wrap,\n.recommended_wrap",".popup_wrap","#sidebar-wrapper div[id^=\"HTML\"]:has(ins.adsbygoogle)","#pp_bd *:is(.ppatc_header, .bd_header) ~ div[class^=\"cd_\"]:has(div[style=\"\"].xe-widget-wrapper > div[style*=\" \"])","#shoppingMenu,\n.mounted .cont_wrap .right_area > div:not([class]),\n.shoplink_wrap,\ndiv[class$=\"-banners\"]",".area_real_news article.gdn,\ndiv[class^=\"gdn_\"]","div[class^=\"deepdive_widget_\"]",".naver_power_shopping,\n[class*=\"sponsor\"],\ndiv[class^=\"powercont_\"]","section[sc^=\"power\"]","section[data-product=\"shoppingBox\"]",".container div[style^=\"height:\"].mx-auto","#page ~ div[style^=\"min-height:\"]#content.row",".container-content div[class*=\" \"]:has(> div[id^=\"div-gpt-ad-\"]):not(:has(*[class]:not([id])))","div[class^=\"ads_\"]","#__layout > div:not([class]) > [class]:not(footer) > div[class]:not([sm]):not(.page-container),\ndiv[class^=\"flex\"][class$=\"h-[250px]\"]","#content-container > div[class*=\" \"]:has(> .vm-placement),\n#summoner-history-header ~ div[class*=\" \"][class^=\"sc-\"]:not([id]):not([style]),\n#top-area + div[class*=\" \"] > div[class*=\" \"]:not([id]):has(> .vm-placement),\n#top-area div[class*=\" \"]:has(> .vm-placement)","div[style^=\"min-height:\"][class^=\"bg-hasha-\"] > div[style] + .max-w-full","div[data-mesh-id=\"comp-lbw06ze4inlineContent-gridContainer\"] div[class*=\"wixui-\"]","div[class*=\" \"]:has(> .gliaplayer-container),\ndiv[class^=\"teads-\"],\nmain div[class*=\" \"]:has(> div[id^=\"div-gpt-\"] + div[height])","div[id*=\"amazon_shopping\"]",".promotion","section[id$=\"_banner\"]",".bottomPop","div:has(> a > img[alt=\"post-custom-banner\"]),\ndiv[class]:has(> ins.adsbygoogle)","#secondary > aside#search-4 ~ aside","#cards > div[class*=\"_\"]:not([id]).card,\ndiv[id^=\"ads\"][style]","div[class$=\"ad\"][id$=\"ad\"]",".modal > #pop_modal",".wrap_body .clearBoth ~ div[class^=\"margin_bottom\"]:not(:has(+ *)),\ndiv[class*=\"_AD\"]",".review_list_element > .c_review_recommend,\n[data-log-actionid-area*=\"plus\"],\n[data-log-actionid-area^=\"focus\"]","#plusPrdArea,\n#powerPrdSection","#cts .l-grid--nobg:has(button[data-log-actionid-area=\"power\"]),\n#section_plusPrd,\n._searchHotProduct,\n.search_content > section[data-log-actionid-area=\"power\"],\n.search_content > section[data-log-actionid-area=\"recommend\"],\nsection[class*=\"-ad-\"]","#rcmdPrd.rcmd_prd","a[href*=\"./bbs/banner_link.php?\"]",".leftad2","#welcom_wrap .new_toprolling_bn,\n#welcom_wrap > .font_remote,\n#welcomeMainBanner_welcome_tab li[id]:has(img[src*=\"/img/banner/flash/welcome/nav/\"]:not([src*=\"/nav/181010_\"])),\n#welcomeMainBanner_welcome_tab li[id]:has(img[src*=\"/img/banner/flash/welcome/nav/\"]:not([src*=\"/nav/181010_\"])) + li[style],\n#welcome_Right > .evntall,\n#welcome_center > div:not([class]):not([style]):not([id]),\n.banner_wrap .swiper-wrapper,\nbody > div[id][class][onclick*=\"Layer\"]","#main_visual","#shopping_wrap,\n.header_banner,\na[class^=\"banner_\"],\na[href*=\"//wrd.appstory.co.kr/rd.flad?\"]","#txt_area.article > .art_btm,\n.article_view > .fl_fr","div[class^=\"fortune_module\"]",".modrow-top > div[class$=\"_banner\"][id$=\"Banner\"],\n.today-smart-shopping","#region--content_floating ~ #region--content_body div[module-design-id]:has(.button--power_click),\n.component--chance_shopping,\ndiv[module-design-id] ~ div > .type--smiledelivery:has(+ .type--general .section--advertisement) ~ .component.type--general:not(:has(~ .type--general .text--smiledelivery_slogan)),\ndiv[module-design-id] ~ div[module-design-id]:has(> .component--sponsor_link .link--ask_sponsor)","#content > div[class^=\"ad_\"] *","div[class^=\"box__layer-\"][style]","div[class*=\"_banner--ad-\"]","div[class$=\"-togetheritems\"]","div[class*=\"slider-banner-\"],\ntable[width=\"1200\"]:has(> tbody > tr > td > div[class*=\"slider-banner-\"])",".wr2_lt > div[class^=\"pcbview\"][style*=\"margin-bottom:\"]",".wrap * + div[style*=\";margin\"]","[class*=\"ad_bizwatch_\"]","div[id^=\"block-\"][class^=\"block-content-\"][style],\ndiv[id^=\"shortcodes-ultimate-\"]:has(div[id^=\"block-\"][class^=\"block-content-\"][style])",".promote-box",".left_con_last,\nbody.body-community div[class*=\"Car\"]",".wrap > div[style$=\"height:100px;\"]:not([class])","iframe[src^=\"/advert/advert.php\"]",".bFloatingBanner","section[class$=\"_banner\"]","header > div[style].wrap","#article-view > .gray-bg","article table[align] td[height]","div[id$=\"_PlaceHolderContent_divMovieSelection_wrap\"][class]",".videoAdWrap",".venatus-container,\ndiv[ad-size]",".container > div[style][id],\n.widget-main-box ~ .widget-main-box:has(script[src*=\"//static.criteo.net/\"])","#container #content > .cpz_inner[style],\n#container #content > .gradation_area,\n#container #main_five_fixbnr ul.five_fixbnr_list,\n#container > div[class][style*=\"/GNBBottomLineBanner_\"][style^=\"background-image:url(\"],\n#content > #start_mainslide.cpz_mainslide,\n#contents #recomN.recomend_main,\n#contents > #EP_Rbnr, #contents > #EP_linebnr,\n#contents > div[id^=\"bnrLink\"].ma_visual_area.bnrContents ~ div:not(.smthp_infom):not(#productSrchListArea),\n#eventzone_img_wrap #con_area > input[type=\"hidden\"] + #con,\n#gamezone .bnrList_area > ul.rollbnr_list,\n#rightwing_section .rightwing_boxNew > .rightwing_bnr,\n#searchArea #side_ad,\n.contentsWrap > .topBanner_area,\n.cpz_inner .category_set_area div[class^=\"second_cate_area\"] div[class^=\"catebnr_area\"],\n.cpz_inner .recommend_wrap > .recommend_list,\n.cpz_inner .sta_rolling_banner,\n.pdtl_cm_detail .md_software,\nbody > #container > .cpz_inner,\nform > div[id$=\"wing_section\"][class*=\"wing_section\"],\nul[id*=\"_ad_\"]",".right_btn,\ndiv[class*=\"_main_ban\"],\ndiv[class^=\"contents\"] > div[class^=\"main_area\"]:has(a[href*=\"ADRollingBanner\"])",".group-deal .list > .group-power-link",".container > section#id_section_deal_list ~ section[id][class]",".main-evn > .main-visual,\n.slider > div[id$=\"_popup\"]",".reserEvent","div[class$=\"Banner\"]",".da_login-phone",".main6.bottomto50","a[href][target=\"_blank\"] > img[src^=\"/data/banner/\"]",".space_layout ~ div[class^=\"section_\"] > div:not([style*=\"solid\"]) + div[style]:not([class])","#aside #ol_before ~ div[style]:not(:has(.tbl_head_lt)),\n#aside .noticea,\n#bo_list + div[style*=\"height:\"],\n#container > div[style*=\"margin-bottom:\"]:has(img[src*=\"/data/file/ad\"]),\n#hd_qnb","#lv-container ~ .clearfix","#dpArticleBlocksWrapper,\ndiv[id^=\"ADOP_\"][style]","iframe[src^=\"/banner/\"]",".grand_banner,\n.grand_banner + .sectionc,\n.main_pay + .sectionc:has(a[href^=\"/business/recruit_write.php\"]),\n.main_pay ~ .sectionc > .nurse_banner ~ *:is(.sectionc, .hire-list),\n.nurse_banner:has(a[href^=\"/business/recruit_write.php\"])",".btop,\n.fvr,\n.mdt1,\na[href^=\"/ws/include/banner_link.asp?\"][target=\"_blank\"]","center + .bk20,\niframe[src*=\"//adreal.dt.co.kr/\"],\niframe[src*=\"dt.co.kr/ad.html\"]","div[data-slot^=\"adforus_\"]",".article_view > div[style$=\"overflow:hidden\"].img_center,\n.main_wrap > center > div[style*=\" height:\"],\ncenter + .bk40,\niframe[src*=\"//io1.innorame.com/\"] + .bk40,\nins[data-aiinad-inv] + .bk40","body > div[style*=\"position: fixed;\"][style*=\"z-index:99999\"][style*=\"bottom:\"]","div[id*=\"Banner\"]:not(:is(#mainNewBanner, .hm-main__slide-new)),\ninput ~ .searchRolling","div[itemprop=\"articleBody\"] > div[class][style]",".evt_area,\ndiv[class$=\"_popup\"],\ndiv[class^=\"codad_ban\"]","[class$=\"_dable\"][id^=\"boxshow_\"],\ndiv[class^=\"gg_\"], div[class$=\"_gg\"],\nsection[id^=\"aside_\"] > div[id$=\"-sticky-wrap\"] > div[id$=\"-sticky\"] > div[id^=\"w_read_\"][class^=\"boxshow_\"]",".article_body > div[class],\ndiv[class$=\"_banners\"]","#edailywrap > #headers ~ div[style*=\"height: \"],\n#right-sticky > .specialRightArea ~ div[class][style*=\"height:\"]:is(:has(> div[id^=\"dablewidget_\"]), :not(:has(> *)), :has(> iframe[allow-popups][title][sandbox]))",".main > .main_visual,\n.main > .main_visual + .section_1,\ndiv[id$=\"-banner\"][style]",".article_wrap .bottom_articles",".widget-box > div[style*=\"min-height:\"]",".eq.section div[class^=\"col-md-\"] > center,\ncenter > div[style*=\"background-color:\"],\nmain#main .eq.section > div[class$=\" \"][style^=\"background-position\"] ~ div[style^=\"float: \"]","ins.dcmads","div[id^=\"floating_banner_\"],\ndiv[onmousedown*=\"'event_label': 'AD'\"]",".sticky-content-spacer_sub > div[style*=\"width:\"],\nul[class^=\"bn_\"]",".ContentsWrap section[style*=\"height:\"],\n.containerWrap > .boxContWrap ~ section > div[style*=\"margin:\"][style*=\"text-align:\"],\n.containerWrap > section[style^=\"padding\"]:not([class]),\n.contents_body > div[style],\n.maj_list_wrap > .majnews_list:has(iframe[src*=\"//ads.mncmedia.co.kr/\"])","body > div[style]:not([class]):not([id])","#coupang_cover_box,\n#m_main_attendance_wrap ~ a[href^=\"../../plugin/mobile/board.php?bo_table=market_\"],\n#mw_mobile > div[style^=\"margin-bottom:\"],\n#mw_mobile > section[style]:has(> #coupang_cover_box > #coupang_ad_box),\n.main_right > .eto-games,\n.main_right > .reward_v2,\n.main_right > .youtube-container,\narticle[class$=\"-banner\"],\narticle[class^=\"etoad-\"],\narticle[id$=\"-banner\"],\nbody[marginheight] #coupang_cover_box ~ section[style^=\"margin-top:\"].box,\ndiv#super_store_skin_v1,\ndiv.my_880_100_wrap,\ndiv[class^=\"power_link\"],\ndiv[style*=\"margin-top:\"] > a[href*=\"?bo_table=store&wr_id=\"],\nsection.main_left > div[style*=\"width:\"][style*=\"text-align:\"] ~ div[style^=\"margin-bottom:\"],\ntbody > tr:has(> td > img[src*=\"/img/adland01.gif\"]),\nul.board_list > li.subject.ad_subject",".head_bar2 > div[class]:not([id]),\nform#head_search > li[style][class]",".contents .table_cls > li","aside.user-aside > article.box-skin + .box-margins:not(.box-solid-x) ~ div[class]:has(~ article),\naside.user-aside div[data-direction]#side-scroll-in > .float-center,\ndiv[style]#side-scroll-in article + .box-margins ~ div[class]:has(~ article.box-skin ~ article ~ article)","#r_aside > center > .bn","#top_src > div[style],\ndiv[id^=\"mobitree\"]","#custom_html-8","div[id*=\"_banner\"]","#container_c .tbl tr td[style*=\"solid\"] div[style^=\"height\"],\ndiv[style=\"\"] ~ div:not([style]):not([class]) table[width][style],\niframe[src^=\"bncode2/banner_\"]","center > .bn","#login-banner-box",".box__component-sponsor-link",".cate-search-result > #plusItem,\n.cate-search-result > #powerPlus,\n.cate-search-result > .title:has(+ #plusItem),\n.cate-search-result > .title:has(+ #powerPlus)",".ReactVirtualized__Grid__innerScrollContainer .box__banner-wrap > .box__banner--today,\n.box__banner-single > .box__inner,\n.js-impressionable",".section__main-inner > .box__promotion .box__item > *,\n.section__main-power","table[width][border] td:not([width]):has(div[align=\"CENTER\"] > .adsbygoogle, td[bgcolor] a[href*=\"//link.coupang.com/\"] > img)","#content div[class^=\"ArticleDetail_section_\"] > div[class^=\"MainNativeLab_wrap\"]","#content > .mainBanner,\n#topBnrWrap",".topBannerUse","[class][itemtype*=\"//schema.org/\"] > .right",".doc03_wrap > .doc03","#partnership,\n.tbl_wrap .bo_notice:has(span[class^=\"spon_b_icon\"]),\ndiv[class^=\"sponsor\"],\ndiv[id^=\"container_\"] .slide_box","#cont_warp table[style],\ndiv[style] > a[onclick*=\"_banner(\"],\niframe[src^=\"/banner/banner_\"]","#popUP_ZONE,\na[href^=\"javascript:\"][onclick^=\"banner_open(\"]","#Suggestion .newServices,\n#ly_subb,\n#related-writer-info .in-writer-info,\n.ly_subb,\n.outer-container table[width=\"100%\"] tr:has(td a[data-bd].banner),\na[class*=\"_banner\"]","#viewConts div[style][id^=\"articleBody\"]","#viewConts div[style][id^=\"articleBody\"] + p ~ center","div.aside-popular > ul.aside-popular-wrap > li > div[style~=\"300px;height:\"][style~=\"block;width:\"]","#inven_reservation_box,\n.commu-content div[style].sh-wrap,\n.invenbanner,\n.section_market_line,\narticle > div[style].banner,\naside div[style]:not([class])","#boardPart > div[style]:not([class]),\n.swiper-slide-active .part-visible-normal:has(img[src*=\"//static.marketinven.com/data/brand/\"]),\ndiv[class^=\"mobileDaNs\"],\ndiv[id^=\"mobileTailAd\"],\nsection.mo-top-nav ~ div[style]:not([id]),\nsection[class*=\"-ad\"]","#commonpart_invenpc","table.table-stripped tr:is(:has(.ad), :has(.adsbygoogle))",".top-owl.owl-carousel","#footer-wrapper div[id^=\"footer\"].footer:has(img[src*=\"=s\"]),\n#sidebar > div[data-version=\"2\"]#Image5",".bg-gray-5 > .list-group-flush",".byWd div[id^=\"bl_\"],\n.grand_banner_wrap li.item_adagency,\ndiv[id^=\"Banner\"]",".news > div[class$=\"_ad\"][style],\n.shopping_wrap div[class$=\"_ad\"]","#articlebody > div[style]:not([itemprop=\"articleBody\"]).article_content,\n#ednp_wrap,\n.MuiBox-root > .MuiBox-root > .swiper-initialized.swiper-backface-hidden:has([target=\"_blank\"]),\naside div[class*=\"my-\"].e1ecreks0.MuiBox-root:has(> .MuiBox-root > div[id$=\"_AD\"]),\ndiv[id^=\"right_banner\"]","img[src^=\"/data/__banner/\"],\nimg[src^=\"/image/banner/\"]",".Ui-Hotels-Results-List-Components-RheaLiteWrapper-container div:not([class]):has(div[class$=\"-sponsored\"]),\n.keel-grid .col-list-body .resultsList div:not([class]):not([id]):has(div[class*=\"-promo-\"] span[class$=\"-sponsored-text\"])","iframe[src*=\"//adv.khan.co.kr/\"]","div[data-sticky].sticky > .side-panel",".act-banner-box-wrapper",".mn_ad",".article_wrap ~ div[class^=\"nwbx\"]","div[id^=\"pop-layer-\"],\nheader ~ #_hidden_layer_",".box_skitter,\ndiv[class^=\"news_\"] > div[style*=\"height:\"]","body > div[class*=\"_banner_\"],\ndiv[class^=\"search_banner_\"],\ndiv[id^=\"bodyDialog\"]:not([style*=\"top: \"]).open:has(img[src*=\"kyobobook.co.kr/newimages/adcenter\"]),\ndiv[name=\"popAdv\"],\nmain div[id*=\"_banner\"][id^=\"welcome_\"][class$=\"_area\"]","[ng-if^=\"premiumLawyers\"],\ndiv[class^=\"premium-lawyer\"]",".tdn-inventory","a[href^=\"/Tracks/Banner-Log/\"]",".coupang-box",".bxslider",".container > div[style][id^=\"slider\"]","#news_main_all_wrp .today_issue ~ section[class=\"today_issue\"],\ndiv[itemprop=\"articleBody\"].article_info > div[id^=\"slot\"][style^=\"text-align:\"]","#article > div[id^=\"slot\"] table[style^=\"margin-bottom:\"],\n#newsViewArea div[style^=\"width:\"]:not([originw])","div[id^=\"AD\"]","div[id^=\"layerPopup_\"]","#MiMintBottomViewLayer","rs-fullwidth-wrap[style^=\"margin-top:\"],\nrs-module-wrap[id^=\"rev_slider_\"]","div[class^=\"bn_sec\"]","#container_right > div[id^=\"slot\"],\n.read_txt > div[id^=\"slot\"]","#main_premium_spon_block,\n#scm_premium_spon_block,\ndiv[id^=\"scm_ban\"][style*=\"url(/media/banner/\"]",".one_line_article > ul.list > li.item:not(:has(a[href^=\"/article.html?no=\"]))","div[class^=\"notice\"] .notice td[bgcolor=\"white\"]:has(ins.adsbygoogle)","#container.atcpage div[style]:not([class]):not([id])","section.textList > article.row:has(> ul.aritcle-info > li.title > a[href*=\"//adv.imadrep.co.kr/\"])",".aside_bundle > div[style*=\"height:\"]","div#close_mask","aside > div[class]:has(> .adsbyadop),\naside > div[class]:has(> .swiper),\naside > div[class]:has(> div:not([class]) > div[id^=\"taboola-\"]),\naside > div[class]:has(> div[id^=\"moneys_p_rs_\"]),\ndiv:not([class]) > a[href][target]","#section-main.cf > div[class^=\"section-\"] > div[class^=\"section-\"] > div:has(> a[href][alt][target=\"_blank\"] > img[alt][src]),\n.header-center.cf > .header-center-imgbox > a > img[src*=\"//cdn.mule.co.kr/data/original/\"],\n.modal-login-wrapper .right-box,\ndiv.section-leftmiddle-bottommiddle.cf,\ndiv[class^=\"section-\"][class$=\"-ad\"],\ndiv[class^=\"section-\"][class$=\"-bigad\"],\ndiv[class^=\"section-\"][class$=\"-smallad\"],\ndiv[class^=\"section-\"][class$=\"-topad\"],\ndiv[class^=\"section-\"][class$=\"ad-pc\"]",".article_view ~ div[style^=\"text-align:\"].clean_banner + .h50,\n.article_view ~ div[style^=\"text-align:\"].clean_banner ~ .wcms_banner + .h45,\n.article_view ~ div[style^=\"width:\"].clean_banner ~ .wcms_banner ~ .h50","#coupang-ad-wrapper","#article_conent > div[style].clearfix,\n[class^=\"ad-\"],\ndiv[style*=\";height:\"][data-ad],\niframe[src*=\"//nad.newdaily.co.kr/\"]","div[itemprop=\"articleBody\"] > div[style^=\"margin:\"].clearfix","div[data-layout-area*=\"_AD\"]",".user-content > .user-aside","div[data-id*=\"-ad-\"]","#pnlContainer .con_b > .ct_box:not([style]),\n#pnlContainer > div[class^=\"ct\"] > .con_b > div[style],\n#pnlContainer > div[class^=\"ct\"] > .section > .ct_box > div[style~=\"text-align:\"][style~=\"center;\"][style~=\"padding:\"][style~=\"10px\"],\n#pnlContainer > div[class^=\"ct\"] > .section > div[style]:not(class),\n.section div[class$=\"con_b\"][style],\ndiv[class^=\"ct\"] > .section > .view_box > #divViewBox > .viewbox > div[style]","table[style][width][cellspacing][cellpadding] tr[valign] > td[style]:has(img[src^=\"/file/_banner/\"]),\ntable[width][cellspacing][cellpadding][border] tr:not([height]) > td[width]:not([id]) ~ td[id]","div[id^=\"wingBanner-\"]",".txt table#bodyMainImg tr:has(> td[style^=\"margin:\"][style*=\";padding:\"] > table)","html[class*=\"pc-size\"] .av-area-fot",".top-navigation .wrapper > .row.equal > div[class=\"col-xs-12 col-sm-6 col-lg-4\"][style^=\"padding:\"]","#article-view div[style].float-center .clearfix > center[style],\n#article-view div[style].float-center .clearfix > div[class^=\"box-margin\"],\n#article-view div[style].float-center div[class^=\"m-view-\"]:not(:has(> article))","table td[valign][width] table > tbody > tr:not([bgcolor]) > td[height]:has(a[target=\"_blank\"])",".addot-wrapper,\n.news_con > div[align]:has(> a[href*=\"//coupa.ng/\"] > img[src*=\"//img.knowledgepower.co.kr/uploads/cpcbanner/\"]),\nbody > div[class^=\"brand-\"],\nbody > div[style^=\"position:fixed;\"][style*=\"z-index:9999\"][style*=\"width:\"],\ndiv.warp > a[href*=\"//someblossom.co.kr/product/detail.html?\"],\ndiv[id][class][style]:has(> .impactify-player-container),\ndiv[id^=\"adMall_popup_\"],\ndiv[id^=\"foin_\"],\npre > div[id]:has(> div[align] > a > img[src*=\"//img.postshare.co.kr/images/banner/\"]),\npre > div[style]:has(> iframe[src*=\".ad4989.co.kr/\"])",".left > .shopping-preview,\n.right > .board-preview.board-ppomppu,\n.together_goods,\nbody .contents .container .topSub-nav,\ndiv[id^=\"div_new_power_link_\"],\ndiv[id^=\"pp_ban_\"],\ntable .list-notice-alarm-sponsor-tr,\ntable#revolution_main_table tr[class^=\"common-list\"]:has(table a[href*=\"?id=pmarket&\"]),\ntbody > tr[id^=\"page_show_ad_\"],\ntr > td div.bridge","#bbs_inform li[class^=\"bbs_ad\"],\n.ct .bbs.ppomppu ul[class^=\"bbsList_\"]:has(.new_sk > a[href*=\"?id=pmarket&\"]),\n.ct > .bbs > #bbs_inform li:has(span ~ a[onclick^=\"informAdClick\"]),\n.google-ad,\n.main-menu-group ~ .ct #board-cate ul[style] li[onclick*=\"/new/hotdeal\"] ~ li[onclick^=\"location.href=\"][onclick*=\"market\"],\n.main-menu-group ~ .ct #board-cate ul[style] li[onclick^=\"location.href=\"][onclick*=\"/bbs_list.php?id=ppomppu2\"],\n.main-menu-group ~ .ct #board-cate ul[style] li[onclick^=\"location.href=\"][onclick*=\"/bbs_list.php?id=ppomppu7\"],\niframe[src*=\"/banner/google_ad.html\"],\nsection.shopping-board","#wrapper div[class$=\"contents_box\"]:has(ins.adsbygoogle)","div[class*=\" \"]:has(> a[class*=\" \"][href][target=\"_blank\"] img[src*=\"/_next/image?url=\"][src*=\"%2Fuploads%2Fbanner%2F\"])",".now_content_ads__wrapper","sbs-player-ad-wrapper","#sn_banner_side_top","#floating_bottom,\ntable[valign=\"top\"] div[id^=\"left_body\"] > table td[align=\"center\"] > div[style*=\" \"]","table[id*=\"Ad\"]","[style]#withpang_p","#Article > .Line_gray ~ div[style]:not([class]):not([id])","#contentsBodyDiv > table[width]",".W_wrap > div[style*=\"height:\"]","#Article > div[style]:not([class])","#viewWrapDiv > div[style*=\" \"]:not([class]):not([id])",".mt30 .con_rt > style + div[style]:not([class])","div[class*=\"-grey-\"][style]","div[class*=\"-ads\"]","div[id*=\"_adsense_\"]","iframe[src*=\"//nad.tf.co.kr/\"],\niframe[src*=\"tf.co.kr/public/layout/\"][src*=\"/top_menu_bar_\"][src*=\".php\"]","#artContent > div[style]:not([class]),\ndiv[class^=\"AD_\"],\ndiv[class^=\"swiper-topbanner\"],\nul[class$=\"Ad\"]","#posLeft > div[style~=\"width100%;font-size:\"][style~=\"#ececec;margin-bottom:\"],\n#tfHeader > div[style]:not([class]),\niframe[src^=\"/public/ad/\"]","a[onclick^=\"goAD\"][onclick$=\"()\"]",".fdimmed ~ div[style^=\"max-width:\"]","[class^=\"adsense\"]","div[itemprop=\"articleBody\"] > div[style*=\"margin-\"]:not([class])",".ezmob-footer,\n.ezoic-ad","div[class*=\"Advertisement_\"]","[class$=\"-advert\"],\nsection[class*=\" \"]#header-standard-container",".bn",".coupangPosition","ul#_dealListContainer.list > li.item.type_admon[data-maincategoryno]","#navigation-cnt > div[class][style]:has(~ div[style*=\"margin-bottom:\"]),\n#navigation-cnt > div[style*=\" \"]:not([style*=\"margin-bottom:\"]),\n#viewConts > div[id^=\"articleBody\"]",".T4Tutorials","#no_pages.bg_w","div[class^=\"adv-\"]","[class^=\"aside-bnr\"],\naside[class*=\"-ad-\"]","#container > div[class^=\"content\"] > section[id^=\"detailHotnews\"] ~ aside[class^=\"aside-box\"][class$=\"bg11\"],\n#container aside[class^=\"aside-\"]:has(ul[id^=\"ad\"]),\n.article > aside[data-position],\n.hidden-obj ~ aside[class^=\"aside-box\"].bg11,\nsection[class^=\"box-type\"].bg11 ul[class^=\"list\"] > li[class^=\"aside-box\"]",".cont-row > div[class^=\"cont-item\"] > .detail-rel","main > div[style*=\" \"].section","div[style]#cenArea > .today,\ntd[id^=\"divBn_\"]","iframe[src^=\"/inc_banner/\"],\nspan > #hns_mask","div[class^=\"newsview_ad_\"],\ndiv[class^=\"text_ad_\"],\nul > li[class^=\"ad_\"][id^=\"snsAd_area\"]",".power_box div[class^=\"asset\"]:has(iframe[src*=\"//adv.zdnet.co.kr/\"]),\ndiv[class*=\"_bn_\"][style],\ndiv[id$=\"AdCon\"][style],\ndiv[id^=\"A1_\"][style*=\"height:\"],\niframe[src^=\"/template_ad/?aid=\"],\niframe[src^=\"https://adv.zdnet.co.kr/\"]",".mdsns_reply > div[style^=\"margin-bottom:\"]","table[id^=\"index_\"] tr:has(ins.adsbygoogle)","#list_aside div[id^=\"list_row_\"].list_table_row_notice:has(a[href$=\"?bo_table=notice&sca=%EC%8A%A4%ED%8F%B0%EC%84%9C\"]),\n#sidebar_container .relative:has([class*=\"_ad_\"]) ~ div[class^=\"spacer\"],\n#view_warning .relative:has(ins.adsbygoogle):not([class*=\"_content\"])",".card:has(> .banner > a[href*=\"//ad.everytime.kr/\"]),\ndiv.banners:has(> a[href*=\"//ad.everytime.kr/\"])","#container > div#rightContents > div[style*=\"height:\"]",".board_view .related_content > ul > a","#aside > div[style^=\"background-color:\"]",".neo_top_center,\ndiv[style^=\"display:\"] > .fvideo:has(> .vm-placement)",".blockUI.blockMsg.blockPage,\n.blockUI.blockOverlay","[class*=\"_banner\"]","div[class^=\"bann_\"],\ndiv[class^=\"bnn_\"],\ntable[border=\"0\"] > tbody > tr > td:not(td > div:not(div.noresize) + b > a:not([target=\"_blank\"]))",".wkbn_bk.tp","div[id^=\"banner_\"] > a[target=\"_blank\"]",".widget-side-box > div[class^=\"main-box main-\"]",".side_floating","div[class*=\"inner\"].column > div:has(a[href*=\"/banner_click.php\"])","#user-wrap.mobile ~ div[style^=\"height:\"]","center a[href*=\"//mbong.kr/banner\"],\ndiv[role=\"main\"]#content div[data-pswp-uid].rhymix_content:not([class^=\"document_\"]):not([class^=\"comment_\"])","#cCon + aside.sidebar2,\n.list_d.ldd > ul > li:has(script[src*=\"//pagead2.googlesyndication.com/\"]),\nhtml[class*=\"mobile\"] .list_document li:not([class])","[data-postid].ultp-shortcode",".content.ad",".xe-widget-wrapper > div[style]:has(a[href^=\"/ad\"])","#article_body_content > .link_news > ul > div[class] > div[style],\n.top_area > .wrap_sl_item > .slick-slider,\ndiv[data-acidx][data-kind].sideBlock","div[class^=\"das_article\"][class$=\"_wrap\"],\niframe[src^=\"/template/ads/\"]","div[data-widget=\"recommend\"].box","#app > aside[style*=\"margin-top:\"].v-navigation-drawer--right","main div[class*=\"space-\"].hidden.flex-none",".news-cont ~ .news-special","#article-view.mobile .wrapper > .clearfix,\n#leftFloat","a[href^=\"https://link.coupang.com/\"]",".oxad,\na[href^=\"https://ads.orbi.kr/\"],\ndiv.panel.class-event-wrap",".hide_on_app_ios",".HAdLine,\n.main_contents > div[class^=\"sc-\"]:has(img[src*=\"//cdnimg.happyshopping.kr/img_ad/\"]),\niframe[src*=\"//ad.pping.kr/\"]","#genesis-sidebar-primary,\nad-shield-ads","#content > .sub_content > .board_view > div[align=\"center\"]:not([class]):not([id]):not([style])","a[onclick^=\"go_banner\"]","#bo_ad,\n#bo_v_top ~ section[style*=\"height:\"]",".ad-template","#container ~ div[style^=\"width:\"][style*=\"height:\"].mobile,\ndiv[class$=\"Bann\"],\ndiv[data-ads-url],\nsection[class$=\"-ads\"]",".media_s_right > div[style^=\"height:\"].clear","div[id^=\"banner\"][class=\"\"][style*=\"height:\"],\ndiv[style] > ul[class^=\"AD\"]","div[onclick^=\"wcs.event(\"]",".cmsBanner",".inner-body.hided .inside-content-background-gradient,\n.inner-body.hided .partners-inside","form[method=\"post\"] > #maskLayer","iframe[data-ezsrc*=\"//coupa.ng/\"]","div[class^=\"KeyVisualBanner_container_\"],\ndiv[class^=\"Main_container_\"] div:is([class^=\"PreorderMainCard_root_\"], [class^=\"Main_cardWrap_\"]):has(a[data-promo-name]),\ndiv[class^=\"RecommendationMobile_cardWrapper_\"] > a[class^=\"MainBannerV2_container_\"][data-promo-name]","a[href^=\"https://www.dothome.co.kr/ad/\"][target=\"new\"]",".inside-content-background-gradient,\n.partners-inside",".app-aside-content a[href^=\"https://link.coupang.com\"],\n.app-main-banner,\na[class*=\"zod-banner\"]",".custom_code.board_top,\ndiv[style].fancybox-type-inline","div#newsRank",".ent_wrapper.slide-vertical-effect .ent_navigation,\n.widget-side .widget-title:has(+ div a[href^=\"/bbs/link.php?bo_table=\"][target=\"_blank\"]),\na[href*=\"/bbs/link.php?bo_table=partner&\"],\na[href*=\"?bo_table=partner\"]","#sidebar > .module:has(> div[id^=\"ad\"])","div[id*=\"ads\"]","#googleTop",".text-center > a[onclick^=\"App.trackOutboundLink\"]:has(> img[class^=\"visible-\"][class$=\"-block\"])","a[href][target=\"_blank\"][referrerpolicy=\"unsafe-url\"],\nsection > div[class*=\" \"]:has(a[href][target=\"_blank\"][referrerpolicy=\"unsafe-url\"]),\nsection > div[class*=\" \"]:has(ins.adsbygoogle),\nul > a[href*=\"/0ad\"].visittag","iframe[src*=\"/banner.html\"]","center > div[style*=\"margin:\"]","div[class^=\"style__GoogleAdSenseContainer-\"]",".respons-edit > div[style^=\"width:\"].float-right",".widget-side div[style*=\" \"]","#adsense","div[style] table[width] td[width]:has(> ins.adsbygoogle)","#coupangAd,\n#hongboInfoList,\n.aside > div[class^=\"side_\"]:not([class*=\"account\"]),\n.nav_container > div[id$=\"_content\"][class^=\"content_\"] .contents_main > div[class^=\"main_center_\"],\n.nav_container > div[id$=\"_content\"][class^=\"content_\"] .section_list.notice > div[class^=\"main_top_\"],\n.nav_content > div[id$=\"_content\"][class^=\"content_\"] div[class^=\"post_\"] > div[class^=\"view_center_\"],\ndiv.main_center_widjrhfirj,\ndiv.main_top_cmdlfkgirjd,\ndiv:has(> div[class=\"ad_banner\"]),\ndiv[class*=\"_outline\"],\ndiv[id$=\"_content\"][class^=\"content_\"] > div[class^=\"list_top_\"]:not([class*=\" \"])",".board_recommended > a.list_item ~ div[class*=\" \"],\n.content_list.search > div[class^=\"list_center_\"],\n.nav_container .post_view > div[class^=\"view_top_\"],\n.nav_container > .content_main > div[class^=\"main_center_\"],\n.nav_container > .content_main > div[class^=\"main_top_\"],\n.nav_container > .content_view_list > div[class^=\"list_bottom_\"],\n.nav_container > div[class^=\"content_\"][class$=\"_list\"] a[href^=\"/service/board\"] ~ div[class^=\"list_center_\"],\n.nav_container > div[class^=\"list_bottom_\"],\n.shop_naver,\ndiv[id^=\"naverAd\"]",".section_list.hongbo","div[id^=\"carousel_\"] a[target=\"_blank\"]","a[data-dd-action-name*=\"Ads\"],\nimg[src*=\"/data/file/main/\"]","iframe[src^=\"//shop-redapi.daum.net/red-apigate/daumtop/\"]",".aside_g.aside_ad,\n.aside_g.aside_shopping","div[data-tiara-layer=\"ad\"]",".ggb-bnr",".mtop_adfit,\ndiv[class][data-ad-media][data-ad-pubuser][data-ad-type][data-ad-width][data-ad-height],\ndiv[data-slot-type=\"IMAGE_BIG_BANNER\"].box_bnr","#splinkColl,\n.adLinkColl,\n.content_sponsor,\n.screen_out ~ div[disp-attr]:has(> div:is(#splinkColl, .adLinkColl)),\n.screen_out ~ div[disp-attr]:has(c-list-ad),\nbody.nate .screen_out ~ div[disp-attr]:has(> #bizDirtColl),\nbody.nate .screen_out ~ div[disp-attr]:has(> div[style*=\"height:\"]),\nbody.nate aside#mAside > div[disp-attr]:has(> .wing_nate),\ndiv[class] > div[disp-attr] ~ div[disp-attr]:has(a[href*=\"//brandsearch.ad.daum.net/\"][onclick^=\"smartLog\"]),\niframe[src*=\"//ad.search.nate.com/\"]",".section_cont div[disp-attr]:has(.adLinkColl),\nbody.nate .section_cont [disp-attr] > #specialMColl,\nbody.nate .section_cont [disp-attr] > div[style*=\"height:\"]","ul.list_column > li.item_ad",".inner_main > div[data-tiara-layer=\"shopping\"],\n.inner_side > .box_g:has(> #shoppingTitle),\n.inner_side > div[style^=\"min-width:\"]",".ddnad","#r_aside center > div[class=\"bn\"]",".post_content > div[data-dest=\"placeholder\"][style^=\"min-height:\"]","#content > div.bd > div.bd_lst_wrp > center,\n.content > div.bd > div.clear > div > center,\n.side > .widget_div > .content > center,\ndiv[data-docsrl] ~ div[style^=\"height:\"][style*=\"text-align:\"]",".wrapper > div[style*=\" \"]#container > div:not([class])","a[href^=\"http\"][target=\"_blank\"].thumbnail","#menufoot > .hot_under,\ndiv[class^=\"powerlink_\"],\ndiv[id^=\"sidead\"]","body > div[style^=\"min-height:\"]:not([class]):not([id])","#mboard tr:has(> td:not([class]) div[style^=\"margin:\"][id^=\"d\"]),\nbody > .foot:has(> div[style*=\"margin:\"][id^=\"d\"]),\nbody > div[style]:has(> div[class^=\"powerlink_\"]),\ndiv[class$=\"ad_area\"]",".hd_pops","#serContents div[align=\"left\"],\ndiv[class$=\"_adban\"],\ndiv[class*=\" \"] > div[class*=\" \"][class*=\"_\"] ~ div[class$=\"fright\"],\ndiv[class*=\"mall_\"][style*=\" \"][class*=\"_slider_\"],\ntd[width]:not([valign]) ~ td[align=\"left\"] ul.banner","#coupangModal,\n.modal-backdrop","div[id^=\"detect\"]",".fancybox-wrap:has(> .fancybox-skin > div > div > #dialoga.wst_ad_badge)","*:has(> a[target=\"_blank\"] img[src^=\"/images/KTImage/\"]),\n.ads + div:not([class]),\n.obituaries-wrapper:has(img[src^=\"/images/AdImage/\"]),\n.pop-layer,\ndiv[class] > div[class^=\"post-style\"] ~ .rn_block,\ndiv[class] > div[class^=\"post-style\"] ~ .rn_block + hr","aside > .obituaries-wrapper.recent_news_inner",".xe_content span ~ div[style]","[style=\"margin-bottom: 20px;\"].row.row-15",".sidebar_book",".feed-list-wrap .feed-item-wrap-SPONSORED",".gdl-left-sidebar","img[src^=\"/img/sp/\"]","#sidebartop,\n.entry-content > div[id^=\"top\"]",".sidebar[style] > aside[id^=\"text-\"][class] ~ aside[id^=\"text-\"][class]",".pop-area.--dim.--active","div[class*=\"_ban_\"]","*[class*=\"-coupas-\"],\ndiv[class^=\"Post_continue_coupang__\"],\ndiv[class^=\"Post_post__\"] > .text-center:has(ins.adsbygoogle)",".at-main > .widget-box,\n.w-banner,\ndiv[class^=\"header-banner-\"],\ndiv[id^=\"float\"]","#wrap_right > #right","tr.notice:not([data-document_srl])","div[class^=\"Ad\"],\nheader .dis-table > div[style^=\"padding-top:\"].dis-table-cell","#sticky_variable_area,\nheader > .header-space","[id*=\"Ad\"],\ntable[align] table[align] td[valign] table[cellspacing] tr > td[colspan][height][bgcolor],\ntable[align] table[border] table[align]:has(td[align] img[alt=\"검색광고\"]),\ntable[bgcolor][align] table[cellspacing][align] tr:has(table table strong > a[href*=\"?Board=enterprise\"]),\ntable[width] table[width] td[width][height]:has(a[target=\"_blank\"] img[alt=\"배너광고안내\"]),\ntable[width] table[width] tr:has(> td[colspan] td[width][height] > img[alt=\"스폰서광고\"])","#TopAddFrame,\n.row > div[class][id=\"\"] ~ #Contents ~ a[href*=\"?Board=enterprise\"],\n.row > div[class][id=\"\"] ~ #Contents ~ a[href*=\"Board=enterprise\"] + div[class],\n.row > div[class][id=\"\"] ~ #Contents ~ div[style],\n.row > div[style=\"\"].col-xs-12 ~ div[id] + div[style]","div.banner_l,\ndiv.banners_area,\nul.menu:has(> li > a[class^=\"banner_\"])","div[class*=\"ad-\"],\ndiv[class~=\"before:bg-psgr-disabled\"],\ndiv[data-ad]",".at-container .at-col div[style^=\"height:\"]:not([class]),\ndiv[class^=\"col-md-\"] div:is([style^=\"width:\"], [style^=\"min-width:\"])","*[class]:not([class*=\" \"]) > div[class]:not([class*=\" \"]) ~ *:not([class]) > *[class]:has(iframe[id^=\"google_ads_iframe_\"]),\n*[class]:not([class*=\" \"]) > div[class]:not([class*=\" \"]) ~ *:not([class]) > *[class]:has(iframe[src*=\"arca.live/external/callad\"]),\ndiv:not([class*=\" \"]) ~ div div + div[class]:has(> div[id][class]):not(:has(div[class*=\" \"] > span)),\ndiv[class] ~ div div + *[class]:not([class*=\" \"]) *[class*=\" \"] div[class]:has(> iframe[id^=\"google_ads_\"]),\ndiv[class] ~ div div + *[class]:not([class*=\" \"]) *[class*=\" \"] div[class]:has(iframe[src*=\"arca.live/external/callad\"]),\ndiv[class]:not([class*=\" \"]) ~ div[class*=\" \"] > *[class*=\" \"] > *:has(iframe[id^=\"google_ads_iframe_\"]),\ndiv[class]:not([class*=\" \"]) ~ div[class*=\" \"] > *[class*=\" \"] > *:has(iframe[src*=\"arca.live/external/callad\"])","article h1 ~ div[class] > div[id]:has(> iframe[id^=\"google_ads_iframe_\"])","#mnetplus-modal-root","a[href^=\"/ad-\"]"];

const hostnamesMap = new Map([["kr.bb-tv.co",0],["agit359.com",0],["agit360.com",0],["agit361.com",0],["agit362.com",0],["agit363.com",0],["agit364.com",0],["agit365.com",0],["agit367.com",0],["agit368.com",0],["agit369.com",0],["agit370.com",0],["agit371.com",0],["agit372.com",0],["agit373.com",0],["agit374.com",0],["agit375.com",0],["kukinews.com",[0,45]],["m.comic.naver.com",[0,262]],["sports.news.naver.com",0],["pressian.com",0],["m.sedaily.com",[0,127,320]],["yhinews.com",0],["lolchess.gg",[0,173]],["ajl.co.kr",0],["ebn.co.kr",0],["economist.co.kr",[0,192,475]],["funshop.co.kr",0],["healtho.co.kr",[0,525]],["hinfomax.co.kr",0],["mosen.mt.co.kr",[0,127,571]],["paxnet.co.kr",[0,68,301,587]],["hinfomax.kr",0],["bloter.net",[0,31,697]],["miraetv.net",[10,735]],["3.37.104.109",13],["103.204.13.68",14],["m.richgo.ai",15],["linkkf.app",16],["filetender.com",[16,147]],["bonik.me",[16,689]],["yadongtube.net",16],["yatv.net",16],["yadongwang.org",16],["yadongkorea.red",16],["yako.red",16],["moneypin.biz",17],["toptrend.blog",18],["mangacat.cc",[19,20]],["manatoki464.net",[20,41,285,287,732]],["manatoki465.net",[20,41,285,287,732]],["manatoki466.net",[20,41,285,287,732]],["manatoki467.net",[20,41,285,287,732]],["manatoki468.net",[20,41,285,287,732]],["manatoki489.net",[20,285,287,732]],["manatoki490.net",[20,285,287,732]],["manatoki491.net",[20,285,287,732]],["manatoki492.net",[20,285,287,732]],["manatoki493.net",[20,285,287,732]],["manatoki494.net",[20,285,287,732]],["manatoki495.net",[20,285,287,732]],["manatoki496.net",[20,285,287,732]],["noonnu.cc",21],["tv25.co",22],["youtu.co",[23,24]],["m.diningcode.com",[23,124]],["gamemeca.com",[23,112,160,161]],["kpenews.com",23],["kyeongin.com",[23,45,58,102]],["m.tenbizt.com",[23,120]],["tipsandtrickskorea.com",[23,355]],["todaysppc.com",23],["yeongnam.com",[23,399,400]],["m.11st.co.kr",[23,435]],["www.auction.co.kr",23],["cgv.co.kr",[23,53,58,155,465]],["gmarket.co.kr",[23,515]],["insight.co.kr",[23,532]],["m.inven.co.kr",[23,68,312,534]],["mememedia.co.kr",[23,24]],["tvreport.co.kr",[23,120]],["dfast.kr",[23,24]],["acmicpc.net",[23,692]],["enterdiary.com",24],["maxmovieen.com",24],["mystylezip.com",24],["tenbizt.com",[24,351]],["capress.kr",24],["carandmore.co.kr",24],["hotplacehunter.co.kr",24],["mobilitytv.co.kr",24],["newautopost.co.kr",[24,246,577]],["tminews.co.kr",24],["thehousemagazine.kr",24],["10000recipe.com",25],["m.10000recipe.com",26],["1004girl.com",27],["ajunews.com",[28,29,30]],["dajunbi.com",28],["auth.danawa.com",28],["prod.danawa.com",[28,45,109]],["m.kin.naver.com",28],["m.sports.naver.com",[28,275]],["m.hub.zum.com",28],["qooqootv.fun",28],["beyondpost.co.kr",28],["www.ebs.co.kr",[28,44,252,492]],["gqkorea.co.kr",28],["news.jtbc.co.kr",[28,45,542]],["metroseoul.co.kr",[28,562]],["mk.co.kr",[28,45,565]],["m.fomos.kr",28],["jjan.kr",[28,46,70,75,650]],["newspic.kr",28],["socialvalue.kr",[28,44,175]],["it.chosun.com",[30,44]],["realty.chosun.com",[30,44,82]],["drapt.com",30],["modoodoc.com",[30,242]],["pann.nate.com",[30,127,255]],["msearch.shopping.naver.com",[30,273]],["osmanias.com",[30,45,297]],["salgoonews.com",30],["xportsnews.com",[30,120]],["cm.asiae.co.kr",[30,444]],["asiatoday.co.kr",30],["khan.co.kr",[30,45,545]],["newstong.co.kr",30],["zdnet.co.kr",[30,45,70,127,635]],["theqoo.net",[30,70,744]],["algumon.com",[31,32]],["besteleven.com",[31,47]],["ccdailynews.com",31],["weekly.chosun.com",31],["daejonilbo.com",31],["dailysecu.com",31],["dpg.danawa.com",[31,46,107]],["m.danawa.com",[31,45,108]],["m.etnews.com",31],["ggilbo.com",31],["hankooki.com",31],["daily.hankooki.com",[31,167]],["hankookilbo.com",[31,172,173]],["hankyung.com",[31,45,174]],["hogangnono.com",31],["incheonilbo.com",31],["kimpga.com",[31,219]],["newspim.com",[31,47,283]],["nzkoreapost.com",[31,112,141,288]],["spochoo.com",31],["sportsseoul.com",[31,127,141]],["ziksir.com",31],["chungnamilbo.co.kr",31],["cnet.co.kr",31],["dealsite.co.kr",31],["digitaltoday.co.kr",[31,168,196,481]],["enetnews.co.kr",31],["foodnews.co.kr",31],["getnews.co.kr",31],["interfootball.co.kr",31],["lifedesk.co.kr",[31,556,557]],["mediaus.co.kr",31],["nbnbiz.co.kr",31],["newdailyhealth.co.kr",31],["pinpointnews.co.kr",[31,589]],["pointe.co.kr",31],["police112.co.kr",31],["ppomppu.co.kr",[31,70,246,592]],["shinailbo.co.kr",31],["spotvnews.co.kr",31],["tgdaily.co.kr",31],["eanews.kr",[31,192,556]],["huffingtonpost.kr",31],["newsnjoy.or.kr",[31,664]],["orbi.kr",[31,311,666]],["youthassembly.kr",[31,311]],["eroun.net",[31,196,504]],["topstarnews.net",[31,745]],["anewsa.com",33],["sports.chosun.com",[33,83,84]],["apycsports.com",34],["atlantachosun.com",35],["atlantak.com",36],["autopostkorea.com",[37,38]],["ygosunews.com",[38,405]],["quiz.avatye.com",39],["avguri10.com",[40,41]],["avguri11.com",[40,41]],["avguri12.com",[40,41]],["avguri13.com",[40,41]],["avguri14.com",[40,41]],["avguri15.com",[40,41]],["avguri4.com",[40,41]],["avguri5.com",[40,41]],["avguri6.com",[40,41]],["avguri7.com",[40,41]],["avguri8.com",[40,41]],["avguri9.com",[40,41]],["uwayapply.com",[40,382,383]],["booktoki461.com",[41,57]],["booktoki462.com",[41,57]],["booktoki463.com",[41,57]],["booktoki464.com",[41,57]],["booktoki465.com",[41,57]],["booktoki466.com",[41,57]],["booktoki467.com",[41,57]],["booktoki468.com",[41,57]],["booktoki469.com",[41,57]],["booktoki470.com",[41,57]],["booktoki471.com",[41,57]],["booktoki472.com",[41,57]],["booktoki473.com",[41,57]],["booktoki474.com",[41,57]],["booktoki475.com",[41,57]],["booktoki476.com",[41,57]],["newtoki464.com",[41,285,286,287]],["newtoki465.com",[41,286,287]],["newtoki466.com",[41,286,287]],["newtoki467.com",[41,285,286,287]],["newtoki468.com",[41,285,286,287]],["newtoki469.com",[41,286,287]],["newtoki470.com",[41,286,287]],["newtoki471.com",[41,286,287]],["newtoki472.com",[41,286,287]],["newtoki473.com",[41,286,287]],["newtoki474.com",[41,286,287]],["newtoki475.com",[41,286,287]],["newtoki476.com",[41,286,287]],["newtoki477.com",[41,286,287]],["newtoki478.com",[41,286,287]],["newtoki479.com",[41,286,287]],["newtoki480.com",[41,286,287]],["newtoki481.com",[41,286,287]],["nolgoga25.com",41],["nolgoga26.com",41],["nolgoga27.com",41],["nolgoga28.com",41],["nolgoga29.com",41],["nolgoga30.com",41],["nolgoga31.com",41],["nolgoga32.com",41],["nolgoga33.com",41],["nolgoga34.com",41],["nolgoga35.com",41],["torrentdin10.com",[41,369]],["torrentdin11.com",[41,369]],["torrentdin12.com",[41,369]],["torrentdin13.com",[41,369]],["torrentdin14.com",[41,369]],["torrentdin15.com",[41,369]],["torrentdin4.com",[41,369]],["torrentdin5.com",[41,369]],["torrentdin6.com",[41,369]],["torrentdin7.com",[41,369]],["torrentdin8.com",[41,369]],["torrentdin9.com",[41,369]],["postshare.co.kr",[41,591]],["principlesofknowledge.kr",[41,670]],["zzzz.lol",[41,688]],["manatoki469.net",41],["manatoki470.net",41],["manatoki471.net",41],["manatoki472.net",41],["manatoki473.net",41],["avjoa59.com",42],["avjoa60.com",42],["avjoa61.com",42],["avjoa62.com",42],["avjoa63.com",42],["avjoa64.com",42],["avjoa65.com",42],["avjoa66.com",42],["avjoa67.com",42],["avjoa68.com",42],["avjoa69.com",42],["avjoa70.com",42],["avjoa71.com",42],["avjoa72.com",42],["avjoa73.com",42],["avjoa74.com",42],["avjoa75.com",42],["avjoa76.com",42],["avjoa77.com",42],["avpink365.com",43],["avpink366.com",43],["avpink367.com",43],["avpink368.com",43],["avpink369.com",43],["avpink370.com",43],["avpink371.com",43],["avpink372.com",43],["avpink373.com",43],["badayak.com",44],["basketkorea.com",44],["entertainpost.com",[44,138]],["m.fmkorea.com",[44,149]],["heraldcorp.com",[44,177]],["news.heraldcorp.com",[44,74,79,177]],["koreadaily.com",[44,220]],["lalawin.com",44],["m.newsen.com",[44,280]],["newsis.com",[44,281]],["m.ohmynews.com",[44,292]],["slrclub.com",[44,326]],["jwmx.tistory.com",44],["hub.zum.com",44],["m.gamechosun.co.kr",[44,512]],["hobbyen.co.kr",44],["m.moneys.co.kr",[44,568]],["thespike.co.kr",44],["ujnews.co.kr",[44,624]],["ytn.co.kr",[44,633]],["beautynury.com",[45,46]],["bemil.chosun.com",[45,70,71,72]],["health.chosun.com",[45,75,76,77]],["donga.com",[45,58,127,128]],["encar.com",[45,70]],["etnews.com",[45,145]],["mbiz.heraldcorp.com",[45,178,179]],["m.heraldpop.com",[45,179]],["humoruniv.com",[45,184]],["imnews.imbc.com",45],["investchosun.com",45],["m.jjang0u.com",45],["kjwwang.com",45],["m.cafe.naver.com",45],["search.naver.com",[45,270]],["nesin.com",[45,70]],["ohmynews.com",[45,70,291]],["sedaily.com",[45,252,319]],["sportalkorea.com",[45,70,331,332]],["m.starnewskorea.com",[45,328,340]],["stoo.com",[45,341]],["teamblind.com",45],["news.zum.com",[45,319,411]],["dak.gg",45],["asiae.co.kr",[45,70,443]],["compuzone.co.kr",[45,469]],["edaily.co.kr",[45,238,493]],["etoday.co.kr",[45,502]],["joongang.co.kr",45],["kmib.co.kr",[45,548]],["m.mk.co.kr",45],["nocutnews.co.kr",[45,319,582]],["news.sbs.co.kr",[45,319,598]],["m.todayhumor.co.kr",45],["unsin.co.kr",45],["dprime.kr",[45,77,102,127,638]],["news1.kr",[45,658]],["m.search.daum.net",[45,712]],["v.daum.net",[45,53,70]],["news.v.daum.net",[45,713]],["ggoorr.net",[45,718]],["kyeonggi.com",[46,58]],["game.naver.com",[46,263]],["www.naver.com",[46,276]],["r114.com",[46,127,313]],["kwnews.co.kr",[46,70,75]],["koreatimes.net",[46,141,173,329,729]],["bizhankook.com",48],["blacktoon302.com",49],["blacktoon303.com",49],["blacktoon304.com",49],["blacktoon305.com",49],["blacktoon306.com",49],["blacktoon307.com",49],["blacktoon308.com",49],["blacktoon309.com",49],["blacktoon310.com",49],["blacktoon311.com",49],["blacktoon312.com",49],["blacktoon313.com",49],["singingdalong.blogspot.com",50],["sajuplus.net",50],["ydailynewsis.blogspot.com",51],["boannews.com",[52,53]],["edu.donga.com",53],["m.etoday.co.kr",[53,503,504]],["mbn.co.kr",[53,70,102]],["mmzone.co.kr",[53,567]],["mnews.sbs.co.kr",53],["m.boannews.com",54],["bontv59.com",[55,56]],["bontv60.com",[55,56]],["bontv61.com",[55,56]],["bontv62.com",[55,56]],["bontv63.com",[55,56]],["bontv64.com",[55,56]],["bontv65.com",[55,56]],["bontv66.com",[55,56]],["bontv67.com",[55,56]],["bontv68.com",[55,56]],["bontv69.com",[55,56]],["tvzota106.com",[55,56,380]],["tvzota107.com",[55,56,380]],["tvzota108.com",[55,56,380]],["tvzota109.com",[55,56,380]],["tvzota110.com",[55,56,380]],["tvzota111.com",[55,56,380]],["tvzota112.com",[55,56,380]],["tvzota113.com",[55,56,380]],["tvzota114.com",[55,56,380]],["tvzota115.com",[55,56,380]],["tvzota116.com",[55,56,380]],["popco.net",[55,740]],["busan.com",[58,59]],["m.health.chosun.com",[58,78,79,80]],["fnnews.com",[58,127,150]],["kizmom.hankyung.com",58],["medicaltimes.com",[58,72,160]],["m.munhwa.com",[58,247]],["zum.com",[58,75,409]],["asiatime.co.kr",[58,158,252]],["hani.co.kr",[58,521]],["m.kmib.co.kr",[58,549]],["kpanews.co.kr",[58,245]],["www.daum.net",[58,75,714]],["dodot.cafe24.com",[60,61]],["loapost.cafe24.com",[60,61]],["ohohz.cafe24.com",[60,61]],["ktestone.com",60],["jiavr.xyz",[60,61]],["windnews.cafe24.com",62],["celuvmedia.com",63],["m.celuvmedia.com",64],["ceoscoredaily.com",65],["chaegeon.com",66],["chchclub.com",67],["chosun.com",[68,69]],["ksg.co.kr",68],["nownews.seoul.co.kr",68],["m-i.kr",[68,652]],["goodgag.net",[68,70]],["ddengle.com",[70,120,121,122]],["dmitory.com",70],["fntimes.com",[70,151]],["m.gamemeca.com",70],["happycampus.com",[70,175,176]],["ichannela.com",[70,75]],["imaeil.com",[70,197]],["isplus.com",[70,206,207]],["munhwa.com",[70,244,245,246]],["news.naver.com",[70,74]],["yes24.com",[70,401]],["aladin.co.kr",[70,440]],["auction.co.kr",[70,445]],["dnews.co.kr",70],["etoland.co.kr",[70,75,505]],["itcm.co.kr",[70,537]],["kick-off.co.kr",70],["m.nocutnews.co.kr",[70,583]],["ent.sbs.co.kr",70],["seoul.co.kr",[70,87,600]],["clien.net",[70,701]],["news.daum.net",70],["wowtv.co.kr",[71,74,311,627]],["biz.chosun.com",[73,74]],["www.chosun.com",[73,88]],["styleup.gameangel.com",[74,75,159]],["dcnewsj.joins.com",[74,75,211]],["maxmovie.com",[74,87,235]],["place.naver.com",74],["mlbpark.donga.com",[75,131]],["joseilbo.com",[75,214]],["section.cafe.naver.com",75],["newsen.com",[75,279]],["toomics.com",[75,192,365]],["yakup.com",[75,396]],["mitem.auction.co.kr",[75,449,450]],["berryjam.co.kr",[75,451]],["djtimes.co.kr",[75,483]],["knnews.co.kr",75],["order.kyobobook.co.kr",75],["m.mt.co.kr",[75,391,570]],["mydaily.co.kr",75],["thebell.co.kr",[75,614]],["m.ytn.co.kr",[75,634]],["fomos.kr",[75,641]],["forwarder.kr",[75,642]],["mdjournal.kr",75],["tokenpost.kr",[75,678]],["windowsforum.kr",[75,683]],["m.mail.daum.net",75],["comic.naver.com",[77,261]],["m.ppomppu.co.kr",[77,593]],["m.cgv.co.kr",[80,125,466]],["monthly.chosun.com",81],["dcinside.com",[83,111]],["m.sports.chosun.com",[85,86,87]],["auto.danawa.com",85],["news.nate.com",[85,127,251,252]],["m.sportschosun.com",[85,86,87,328]],["m.eye.seoul.co.kr",[85,602,603]],["m.seoul.co.kr",[85,602,603,604]],["m.wowtv.co.kr",85],["ciokorea.com",89],["itworld.co.kr",[89,539]],["coolenjoy.net",[89,704]],["genshin.gamedot.org",89],["cjlogistics.com",90],["cnbnews.com",91],["cocstorage.com",92],["coinpan.com",93],["coinreaders.com",[94,95]],["newstomato.com",[95,112]],["m.weekly.khan.co.kr",95],["shinmoongo.net",95],["cokcoktv10.com",96],["cokcoktv11.com",96],["cokcoktv12.com",96],["cokcoktv13.com",96],["cokcoktv14.com",96],["cokcoktv15.com",96],["cokcoktv16.com",96],["cokcoktv17.com",96],["cokcoktv18.com",96],["cokcoktv4.com",96],["cokcoktv5.com",96],["cokcoktv6.com",96],["cokcoktv7.com",96],["cokcoktv8.com",96],["cokcoktv9.com",96],["corearoadbike.com",97],["coronaita.com",98],["cosinkorea.com",99],["coupang.com",100],["m.coupang.com",[101,102]],["hwbattle.com",[102,188]],["pushoong.com",[102,307,308]],["all-mice.co.kr",[102,441]],["elle.co.kr",[102,497]],["epnc.co.kr",[102,500,501]],["sir.kr",[102,609]],["catnews.net",102],["kidkids.net",[102,725]],["www.coupang.com",103],["cuonet.com",104],["dailypharm.com",105],["cmobile.g-enews.com",[105,156,157,158]],["m.g-enews.com",[105,156,157,158]],["smartfn.co.kr",[105,607]],["danawa.com",106],["search.danawa.com",110],["app.dcinside.com",[112,113]],["m.dcinside.com",[112,113,117]],["fmkorea.com",[112,148]],["search.zum.com",[112,301,412]],["m.khan.co.kr",112],["moneys.co.kr",112],["newdaily.co.kr",[112,141,578]],["m.tf.co.kr",[112,612]],["search.daum.net",[112,711]],["gall.dcinside.com",[114,115]],["game.dcinside.com",115],["h5.dcinside.com",116],["sign.dcinside.com",118],["ddanzi.com",119],["woman.donga.com",120],["ruliweb.com",[120,127,316]],["thisisgame.com",[120,122,354]],["dundam.xyz",122],["diningcode.com",123],["digitalchosun.dizzo.com",[125,126]],["edit.incruit.com",[125,199]],["m.dailian.co.kr",[125,383]],["hojunara.com",[126,182]],["manamoa100.com",126],["manamoa101.com",126],["manamoa102.com",126],["manamoa103.com",126],["manamoa104.com",126],["manamoa105.com",126],["manamoa106.com",126],["manamoa107.com",126],["manamoa108.com",126],["manamoa109.com",126],["manamoa110.com",126],["manamoa111.com",126],["manamoa112.com",126],["manamoa113.com",126],["manamoa114.com",126],["manamoa115.com",126],["manamoa116.com",126],["manamoa117.com",126],["manamoa118.com",126],["manamoa119.com",126],["manamoa99.com",126],["ildaro.com",127],["m.nate.com",[127,250]],["www.nate.com",[127,257]],["m.stock.naver.com",127],["mobile.newsis.com",[127,282]],["planet-times.com",127],["seoulwire.com",127],["serieamania.com",[127,324]],["m.thisisgame.com",127],["torrentbot161.com",[127,368]],["torrentbot162.com",[127,368]],["torrentbot163.com",[127,368]],["torrentbot164.com",[127,368]],["torrentbot165.com",[127,368]],["torrentbot166.com",[127,368]],["torrentbot167.com",[127,368]],["torrentbot169.com",[127,368]],["torrentbot170.com",[127,368]],["torrentbot171.com",[127,368]],["torrentbot172.com",[127,368]],["torrentbot173.com",[127,368]],["torrentbot174.com",[127,368]],["torrentbot175.com",[127,368]],["m.edaily.co.kr",[127,199,319,494]],["fpn119.co.kr",[127,509]],["mania.kr",127],["dbr.donga.com",129],["kids.donga.com",130],["sports.donga.com",132],["donthellgo.com",133],["instructivehumility.com",133],["news.oasisfeed.com",[133,289]],["curiosityblog.co.kr",133],["issueclick.kr",133],["dprime.kr.dvdprime.com",134],["edufindkorea.com",135],["eegosa.com",136],["emmaru.com",137],["enuri.com",[139,140,141]],["nongmin.com",[140,173]],["kr-weathernews.com",[141,225]],["view.nate.com",141],["m.enuri.com",142],["eoreuni.com",143],["avada.tistory.com",[143,358]],["www.erdcloud.com",144],["extmovie.com",146],["frtoon220.com",152],["frtoon221.com",152],["frtoon222.com",152],["frtoon223.com",152],["frtoon224.com",152],["frtoon225.com",152],["frtoon226.com",152],["frtoon227.com",152],["frtoon228.com",152],["frtoon229.com",152],["frtoon230.com",152],["frtoon231.com",152],["frtoon232.com",152],["frtoon233.com",152],["newtoon224.com",152],["newtoon225.com",152],["newtoon226.com",152],["newtoon227.com",152],["newtoon228.com",152],["newtoon229.com",152],["newtoon230.com",152],["newtoon231.com",152],["newtoon232.com",152],["newtoon233.com",152],["newtoon234.com",152],["funissu.com",153],["jootc.com",[153,213]],["funnyissue.com",154],["googlewph.com",154],["gyeomipang.co.kr",154],["g-enews.com",155],["hotword.site",[155,751]],["news.g-enews.com",156],["m.inews24.com",160],["m.joynews24.com",[160,202,215]],["m.yonhapnewstv.co.kr",[160,631]],["geekorea.com",162],["gentlysallim.com",163],["vietnamguide.co.kr",[163,625]],["ggeal.com",164],["ggjil.com",165],["gigglehd.com",166],["goodmorningcc.com",167],["sports-g.com",167],["slist.kr",[167,673]],["gukjenews.com",168],["mnews.imaeil.com",[168,198]],["haninpost.com",169],["haninvegas.com",170],["sports.hankooki.com",171],["phdkim.net",[173,311,739]],["memberssl.auction.co.kr",174],["megabox.co.kr",174],["minimap.net",[174,734]],["ombudsmannews.com",175],["hungryapp.co.kr",[175,475,527]],["kpja.kr",175],["usjournal.kr",175],["chimhaha.net",[175,699]],["etorrentro.net",175],["mrealfoods.heraldcorp.com",180],["heraldpop.com",181],["humorpick.com",183],["m.humoruniv.com",[185,186]],["meeco.kr",[186,347,654]],["web.humoruniv.com",187],["hyundaenews.com",189],["ibabynews.com",190],["idaegu.com",191],["ilbe.com",[192,193]],["img.imimggggg87878.com",192],["philgo.com",[192,301,302]],["blockchainhub.kr",[192,311]],["cineaste.co.kr",[192,468]],["signin.gmarket.co.kr",192],["jpaxnet.co.kr",192],["ondisk.co.kr",[192,585]],["bigkinds.or.kr",[192,475,663]],["m.ilbe.com",[194,195]],["kinolights.com",195],["ilemonde.com",196],["mjmedi.com",196],["khgames.co.kr",[196,546]],["digitalasset.works",196],["bgchang.co.kr",199],["m.hungryapp.co.kr",[199,528]],["m.news1.kr",[199,418,659]],["www.incruit.com",200],["inews24.com",[201,202]],["joynews24.com",201],["infosori.com",203],["m.shop.interpark.com",204],["shopping.interpark.com",205],["shopping.naver.com",[207,272]],["star.ohmynews.com",207],["m.cafe.daum.net",207],["jellinggame.com",208],["jgmoa57.com",208],["jgmoa58.com",208],["jgmoa59.com",208],["jgmoa60.com",208],["jgmoa61.com",208],["jgmoa62.com",208],["jgmoa63.com",208],["jgmoa64.com",208],["jgmoa65.com",208],["jgmoa66.com",208],["jgmoa67.com",208],["jgmoa68.com",208],["jgmoa69.com",208],["jgmoa70.com",208],["jgmoa71.com",208],["jjalbot.com",209],["jjang0u.com",210],["joongna.com",212],["map.kakao.com",216],["shoppinghow.kakao.com",217],["webtoon.kakao.com",218],["m.bobaedream.co.kr",[220,458]],["koreapas.com",221],["koreatimes.com",222],["kormedi.com",223],["koya-culture.com",224],["ktxtorrent121.com",226],["ktxtorrent122.com",226],["ktxtorrent123.com",226],["ktxtorrent124.com",226],["ktxtorrent125.com",226],["ktxtorrent126.com",226],["ktxtorrent127.com",226],["ktxtorrent128.com",226],["ktxtorrent129.com",226],["ktxtorrent130.com",226],["ktxtorrent131.com",226],["ktxtorrent132.com",226],["ktxtorrent133.com",226],["ktxtorrent134.com",226],["ktxtorrent135.com",226],["lawnb.com",227],["lecturernews.com",228],["linkeye10.com",229],["linkeye11.com",229],["linkeye12.com",229],["linkeye13.com",229],["linkeye14.com",229],["linkeye15.com",229],["linkeye16.com",229],["linkeye17.com",229],["linkeye18.com",229],["linkeye19.com",229],["linkeye20.com",229],["linkeye21.com",229],["linkeye7.com",229],["linkeye8.com",229],["linkeye9.com",229],["linkrand10.com",230],["linkrand11.com",230],["linkrand12.com",230],["linkrand13.com",230],["linkrand14.com",230],["linkrand15.com",230],["linkrand16.com",230],["linkrand17.com",230],["linkrand18.com",230],["linkrand19.com",230],["linkrand5.com",230],["linkrand6.com",230],["linkrand7.com",230],["linkrand8.com",230],["linkrand9.com",230],["loawa.com",231],["lotteon.com",232],["lottoen.com",233],["manaboza62.com",234],["manaboza63.com",234],["manaboza64.com",234],["manaboza65.com",234],["manaboza66.com",234],["manaboza67.com",234],["manaboza68.com",234],["manaboza69.com",234],["manaboza70.com",234],["manaboza71.com",234],["manaboza72.com",234],["manaboza73.com",234],["mediajeju.com",236],["mediapen.com",[237,238]],["missyusa.com",239],["mobile.missyusa.com",240],["modoocode.com",241],["moyoplan.com",243],["starnewskorea.com",[246,339]],["bada.io",[246,424]],["mimint.co.kr",[246,475,563]],["arca.live",[246,687]],["search.11st.co.kr",[247,436]],["marupost.mycafe24.com",248],["narutong.com",249],["m.yakup.com",[252,397]],["boribori.co.kr",[252,460]],["news2day.co.kr",[252,580]],["ypbooks.co.kr",[252,284,383,632]],["m.comm.news.nate.com",253],["m.news.nate.com",254],["m.pann.nate.com",256],["naver.com",258],["blog.naver.com",259],["chzzk.naver.com",260],["kin.naver.com",264],["evape.kr",264],["m.naver.com",[265,266]],["tf.co.kr",[266,611]],["mail.naver.com",267],["new-m.pay.naver.com",268],["pcmap.place.naver.com",269],["m.search.naver.com",271],["search.shopping.naver.com",274],["time.navyism.com",277],["newreop.com",278],["newstof.com",284],["newtoki461.com",285],["newtoki462.com",285],["newtoki463.com",285],["newtoki489.com",285],["newtoki490.com",285],["newtoki491.com",285],["newtoki492.com",285],["newtoki493.com",285],["newtoki494.com",285],["oceansabyss.com",290],["ohmytaxinews.com",293],["opworlds18.com",[294,295]],["opworlds19.com",[294,295]],["opworlds20.com",[294,295]],["opworlds21.com",[294,295]],["opworlds22.com",[294,295]],["opworlds23.com",[294,295]],["opworlds24.com",[294,295]],["opworlds25.com",[294,295]],["opworlds26.com",[294,295]],["jusoyo12.net",[294,724]],["jusoyo13.net",[294,724]],["jusoyo14.net",[294,724]],["jusoyo15.net",[294,724]],["jusoyo16.net",[294,724]],["jusoyo17.net",[294,724]],["jusoyo18.net",[294,724]],["jusoyo19.net",[294,724]],["jusoyo20.net",[294,724]],["jusoyo21.net",[294,724]],["jusoyo22.net",[294,724]],["oracionspace.com",296],["poketory.com",[296,305]],["tistory.com",[296,356,357]],["club.pdpop.com",298],["pervsi.com",[299,300]],["sori114.com",299],["vop.co.kr",301],["plankim.com",303],["playwares.com",304],["academy.prompie.com",306],["m-sooriya.tistory.com",307],["ygosu.com",[307,403]],["quasarplay.com",309],["quasarzone.com",[310,311,312]],["mobiinside.co.kr",311],["m.r114.com",314],["rdsong.com",315],["bbs.ruliweb.com",317],["m.ruliweb.com",318],["segye.com",321],["segyebiz.com",[321,322]],["sejonghub.com",323],["simcong.com",325],["m.slrclub.com",[327,328]],["soxak.com",329],["newsfeed.dispatch.co.kr",329],["itwind.co.kr",[329,538]],["spochak.com",330],["soccerline.kr",[332,674]],["comic.sportsseoul.com",[333,334]],["vod.sportsseoul.com",333],["spotv120.com",335],["spotv121.com",335],["spotv122.com",335],["spotv123.com",335],["spotv124.com",335],["spotv125.com",335],["spotv126.com",335],["spotv127.com",335],["spotv128.com",335],["spotv129.com",335],["spotv130.com",335],["spotv131.com",335],["spotv132.com",335],["spotv133.com",335],["spotv134.com",335],["spotv135.com",335],["spotv136.com",335],["spotv137.com",335],["spotv138.com",335],["sptv24.com",336],["sptv25.com",336],["sptv26.com",336],["sptv27.com",336],["sptv28.com",336],["sptv29.com",336],["sptv30.com",336],["sptv31.com",336],["sptv32.com",336],["sptv33.com",336],["sptv34.com",336],["sptv35.com",336],["sptv36.com",336],["sptv37.com",336],["ssodam.com",337],["starjn.com",338],["m.stoo.com",342],["sumpic.com",343],["sundayjournalusa.com",344],["sundaynewsusa.com",345],["svrforum.com",[346,347]],["talk-cargo.com",348],["tcafe2a.com",349],["te31.com",350],["theddari.com",352],["thewordcracker.com",353],["kilho.net",[356,726]],["chmodi.tistory.com",359],["gugomah.tistory.com",360],["hunnek.tistory.com",361],["ilsangt.tistory.com",362],["lee-master.tistory.com",363],["playcraft.tistory.com",364],["toon123.com",366],["torrentbam129.com",367],["torrentbam130.com",367],["torrentbam131.com",367],["torrentbam132.com",367],["torrentbam133.com",367],["torrentbam134.com",367],["torrentbam135.com",367],["torrentbam136.com",367],["torrentbam137.com",367],["torrentbam138.com",367],["torrentbam139.com",367],["torrentbam140.com",367],["torrentbam141.com",367],["torrentbam142.com",367],["torrentbam143.com",367],["torrentbam144.com",367],["torrenttt130.com",367],["torrenttt131.com",367],["torrenttt132.com",367],["torrenttt133.com",367],["torrenttt134.com",367],["torrenttt135.com",367],["torrenttt136.com",367],["torrenttt137.com",367],["torrenttt138.com",367],["torrenttt139.com",367],["torrenttt140.com",367],["torrenttt141.com",367],["torrenttt142.com",367],["torrenttt143.com",367],["torrentrj166.com",368],["torrentrj167.com",368],["torrentrj168.com",368],["torrentrj169.com",368],["torrentrj170.com",368],["torrentrj171.com",368],["torrentrj172.com",368],["torrentrj173.com",368],["torrentrj175.com",368],["torrentrj176.com",368],["torrentrj177.com",368],["torrentrj178.com",368],["torrentrj179.com",368],["torrentrj180.com",368],["torrentrj181.com",368],["torrentsome144.com",368],["torrentsome145.com",368],["torrentsome146.com",368],["torrentsome147.com",368],["torrentsome148.com",368],["torrentsome149.com",368],["torrentsome150.com",368],["torrentsome151.com",368],["torrentsome152.com",368],["torrentsome153.com",368],["torrentsome154.com",368],["torrentsome155.com",368],["torrentsome156.com",368],["torrentrj174com",368],["torrentgram65.com",370],["torrentgram66.com",370],["torrentgram67.com",370],["torrentgram68.com",370],["torrentgram69.com",370],["torrentgram70.com",370],["torrentgram71.com",370],["torrentgram72.com",370],["torrentgram73.com",370],["torrentgram74.com",370],["torrentgram75.com",370],["torrentgram76.com",370],["torrentgram77.com",370],["torrentgram78.com",370],["torrentgram79.com",370],["torrentgram80.com",370],["torrentmode.com",371],["torrentnx17.com",372],["torrentnx18.com",372],["torrentnx19.com",372],["torrentnx20.com",372],["torrentnx21.com",372],["torrentnx22.com",372],["torrentnx23.com",372],["torrentnx24.com",372],["torrentnx25.com",372],["torrentnx26.com",372],["torrentnx27.com",372],["torrentpi144.com",373],["torrentpi145.com",373],["torrentpi146.com",373],["torrentpi147.com",373],["torrentpi148.com",373],["torrentpi149.com",373],["torrentpi150.com",373],["torrentpi151.com",373],["torrentpi152.com",373],["torrentpi153.com",373],["torrentpi154.com",373],["torrentpi155.com",373],["torrentpi156.com",373],["torrentqq332.com",374],["torrentqq333.com",374],["torrentqq334.com",374],["torrentqq335.com",374],["torrentqq336.com",374],["torrentqq337.com",374],["torrentqq338.com",374],["torrentqq339.com",374],["torrentqq340.com",374],["torrentqq341.com",374],["torrentqq342.com",374],["torrentqq343.com",374],["torrentqq344.com",374],["torrentqq345.com",374],["torrentqq346.com",374],["torrenttip125.com",375],["torrenttip126.com",375],["torrenttip127.com",375],["torrenttip128.com",375],["torrenttip129.com",375],["torrenttip130.com",375],["torrenttip131.com",375],["torrenttip132.com",375],["torrenttip133.com",375],["torrenttip134.com",375],["torrenttip135.com",375],["torrenttip136.com",375],["torrenttip137.com",375],["torrenttip138.com",375],["torrenttop103.com",376],["torrenttop104.com",376],["torrenttop105.com",376],["torrenttop106.com",376],["torrenttop107.com",376],["torrenttop108.com",376],["torrenttop109.com",376],["torrenttop110.com",376],["torrenttop111.com",376],["torrenttop112.com",376],["torrenttop113.com",376],["torrenttop114.com",376],["torrenttop115.com",376],["torrenttop116.com",376],["tvchak77.com",377],["tvchak78.com",377],["tvchak79.com",377],["tvchak80.com",377],["tvchak81.com",377],["tvchak82.com",377],["tvchak83.com",377],["tvchak84.com",377],["tvchak85.com",377],["tvchak86.com",377],["tvchak87.com",377],["tvchak88.com",377],["tvchak89.com",377],["tvchak90.com",377],["tvchak91.com",377],["tvchak92.com",377],["tvchak93.com",377],["tvchak94.com",377],["tvchak95.com",377],["tvchak96.com",377],["tvchak97.com",377],["tvchak98.com",377],["news.tvchosun.com",378],["tvwiki10.com",379],["tvwiki11.com",379],["tvwiki12.com",379],["tvwiki13.com",379],["tvwiki14.com",379],["tvwiki15.com",379],["tvwiki16.com",379],["tvwiki17.com",379],["tvwiki4.com",379],["tvwiki5.com",379],["tvwiki6.com",379],["tvwiki7.com",379],["tvwiki8.com",379],["tvwiki9.com",379],["uuoobe.com",381],["m.mimint.co.kr",383],["wassada.com",384],["pedia.watcha.com",385],["front.wemakeprice.com",386],["mw.wemakeprice.com",387],["search.wemakeprice.com",388],["whosaeng.com",389],["wjdqhzld.com",390],["xetown.com",391],["xn--vv4b11c.com",392],["xvideos-kr.com",393],["yaburi52.com",394],["yaburi53.com",394],["yaburi54.com",394],["yaburi55.com",394],["yaburi56.com",394],["yaburi57.com",394],["yaburi58.com",394],["yaburi59.com",394],["yaburi60.com",394],["yaburi61.com",394],["yaburi62.com",394],["yaburi63.com",394],["yaburi64.com",394],["yaburi65.com",394],["yaburi66.com",394],["yaburi67.com",394],["yaburi68.com",394],["yaburi69.com",394],["yaburi70.com",394],["yaburi71.com",394],["yaburi72.com",394],["yagong76.com",395],["yagong77.com",395],["yagong78.com",395],["yagong79.com",395],["yagong80.com",395],["yagong81.com",395],["yagong82.com",395],["yagong83.com",395],["yagong84.com",395],["yagong85.com",395],["yagong86.com",395],["yagong87.com",395],["yagong88.com",395],["yagong89.com",395],["yagong90.com",395],["yagong91.com",395],["yagong92.com",395],["yagong93.com",395],["yagong94.com",395],["yagong95.com",395],["yagong96.com",395],["yagong97.com",395],["yagong98.com",395],["ydbox30.com",398],["ydbox31.com",398],["ydbox32.com",398],["ydbox33.com",398],["ydbox34.com",398],["ydbox35.com",398],["ydbox36.com",398],["ydbox37.com",398],["ydbox38.com",398],["ydbox39.com",398],["ydbox40.com",398],["ydbox41.com",398],["ydbox42.com",398],["ydbox43.com",398],["ydbox44.com",398],["ydbox45.com",398],["ydbox46.com",398],["tvbox68.xyz",398],["tvbox69.xyz",398],["tvbox70.xyz",398],["tvbox71.xyz",398],["tvbox72.xyz",398],["tvbox73.xyz",398],["tvbox74.xyz",398],["tvbox75.xyz",398],["tvbox76.xyz",398],["tvbox77.xyz",398],["tvbox78.xyz",398],["tvbox79.xyz",398],["tvbox80.xyz",398],["tvbox81.xyz",398],["tvbox82.xyz",398],["tvbox83.xyz",398],["tvbox84.xyz",398],["ekn.kr",400],["m.yes24.com",402],["m.ygosu.com",404],["ygy48.com",406],["ygy49.com",406],["ygy50.com",406],["ygy51.com",406],["ygy52.com",406],["ygy53.com",406],["ygy54.com",406],["ygy55.com",406],["ygy56.com",406],["ygy57.com",406],["ygy58.com",406],["ygy59.com",406],["ygy60.com",406],["ygy61.com",406],["yongtj.com",407],["yul-do.com",408],["invest.zum.com",410],["m.search.zum.com",413],["shopping.zum.com",414],["koreanbots.dev",415],["av19.gg",416],["maple.gg",417],["talk.op.gg",418],["poro.gg",419],["tftps.gg",420],["hasha.in",421],["ponh.info",422],["a-ha.io",423],["bloomingbit.io",425],["thebook.io",426],["thepumpkin.io",427],["velog.io",428],["allaboutshaving.kr",429],["asked.kr",[430,431]],["www.instiz.net",[431,723]],["buly.kr",432],["0db.co.kr",433],["11st.co.kr",434],["www.11st.co.kr",437],["2cpu.co.kr",438],["5donews.co.kr",439],["news.appstory.co.kr",442],["browse.auction.co.kr",446],["itempage3.auction.co.kr",447],["m.auction.co.kr",448],["item.gmarket.co.kr",450],["cnews.beyondpost.co.kr",452],["m.beyondpost.co.kr",453],["bizwatch.co.kr",454],["blockmedia.co.kr",455],["boardlife.co.kr",456],["bobaedream.co.kr",457],["bodnara.co.kr",459],["brainbox.co.kr",461],["cadgraphics.co.kr",462],["casenews.co.kr",463],["cbinews.co.kr",464],["chaoscube.co.kr",467],["m.compuzone.co.kr",470],["coocha.co.kr",471],["m.coocha.co.kr",472],["cultureland.co.kr",473],["cvsnet.co.kr",474],["dailian.co.kr",475],["rhythmer.net",475],["daisomall.co.kr",476],["darakwon.co.kr",477],["datanews.co.kr",478],["ddaily.co.kr",479],["deliverypoint.co.kr",480],["semoi.kr",[480,672]],["dispatch.co.kr",482],["doctorjob.co.kr",484],["dschool.co.kr",485],["dt.co.kr",486],["m.dt.co.kr",487],["www.dt.co.kr",488],["dtoday.co.kr",489],["e-himart.co.kr",490],["earlyadopter.co.kr",491],["www.edaily.co.kr",495],["eleparts.co.kr",496],["enjoytaiwan.co.kr",498],["eomisae.co.kr",499],["hellot.net",[500,719]],["filecity.co.kr",506],["m.fishingseasons.co.kr",507],["fntoday.co.kr",508],["m.fpn119.co.kr",510],["fun-iyagi.co.kr",511],["timecoffee.co.kr",511],["gamefocus.co.kr",513],["gginews.co.kr",514],["browse.gmarket.co.kr",516],["category.gmarket.co.kr",517],["m.gmarket.co.kr",518],["www.gmarket.co.kr",519],["gobest.co.kr",520],["happymoney.co.kr",522],["m.happymoney.co.kr",523],["hashcode.co.kr",524],["hogaeng.co.kr",526],["i-boss.co.kr",529],["idsn.co.kr",530],["m.idsn.co.kr",531],["inven.co.kr",533],["www.inven.co.kr",535],["issuelink.co.kr",536],["jobkorea.co.kr",540],["mnews.jtbc.co.kr",541],["junggi.co.kr",543],["kayak.co.kr",544],["kidd.co.kr",547],["kmug.co.kr",550],["kookje.co.kr",551],["kyobobook.co.kr",552],["lawtalk.co.kr",553],["lawtalknews.co.kr",554],["lawtimes.co.kr",555],["manhwa.co.kr",558],["m.mbn.co.kr",559],["star.mbn.co.kr",560],["mediatoday.co.kr",561],["newsworker.co.kr",[561,581]],["mininote.co.kr",564],["mksports.co.kr",566],["monitor.co.kr",569],["news.mt.co.kr",572],["osen.mt.co.kr",573],["news.mtn.co.kr",574],["mule.co.kr",575],["m.mydaily.co.kr",576],["biz.newdaily.co.kr",579],["noteforum.co.kr",584],["m.osen.co.kr",586],["piku.co.kr",588],["pohangnews.co.kr",590],["redflame.co.kr",594],["community.rememberapp.co.kr",595],["now.rememberapp.co.kr",596],["sbs.co.kr",597],["sellclub.co.kr",599],["en.seoul.co.kr",601],["m.nownews.seoul.co.kr",[603,605]],["www.seoul.co.kr",606],["steptohealth.co.kr",[608,609]],["techrecipe.co.kr",610],["news.tf.co.kr",613],["m.thebigdata.co.kr",615],["thecall.co.kr",616],["theguru.co.kr",617],["themomstory.co.kr",618],["m.thesingle.co.kr",619],["tiendeo.co.kr",620],["m.tinnews.co.kr",621],["sta.tion.co.kr",622],["www.tmon.co.kr",623],["withcast.co.kr",626],["yna.co.kr",628],["m.yna.co.kr",629],["yonhapnewstv.co.kr",630],["commutil.kr",636],["defensetimes.kr",637],["everytime.kr",639],["fafan.kr",640],["fow.kr",643],["nts.go.kr",644],["gorani.kr",645],["hash.kr",646],["wiki.hash.kr",647],["heye.kr",648],["japanout.kr",649],["kharn.kr",651],["mbong.kr",653],["mground.kr",655],["minelist.kr",656],["muko.kr",657],["m.newspic.kr",660],["nunting.kr",661],["okky.kr",662],["op.skill.or.kr",665],["outstanding.kr",667],["pping.kr",668],["ppss.kr",669],["reurl.kr",671],["m.socialvalue.kr",675],["sportsw.kr",676],["thelec.kr",677],["jovelys.ulog.kr",679],["coolfun.zal.kr",679],["url.kr",680],["vitaminhealth.kr",681],["wadiz.kr",682],["ggulzam.zal.kr",684],["zod.kr",685],["1412.live",686],["bera.world",686],["redsun50.me",690],["redsun51.me",690],["redsun52.me",690],["redsun53.me",690],["redsun54.me",690],["redsun55.me",690],["redsun56.me",690],["redsun57.me",690],["redsun58.me",690],["redsun59.me",690],["redsun60.me",690],["redsun61.me",690],["redsun62.me",690],["redsun63.me",690],["redsun64.me",690],["redsun65.me",690],["redsun66.me",690],["redsun67.me",690],["redsun68.me",690],["redsun69.me",690],["redsun70.me",690],["redsun71.me",690],["redsun72.me",690],["redsun73.me",690],["redsun74.me",690],["22st.net",691],["alltimelegend.net",693],["betanews.net",694],["m.betanews.net",695],["blackkiwi.net",696],["bozayo.net",698],["chuing.net",700],["m.clien.net",702],["www.clien.net",703],["damoang.net",705],["daum.net",706],["entertain.daum.net",707],["focus.daum.net",708],["pubg.game.daum.net",709],["m.daum.net",710],["dogdrip.net",715],["esuwon.net",716],["extrememanual.net",717],["hellven.net",720],["instiz.net",721],["m.instiz.net",722],["gnu.kilho.net",727],["koreaminecraft.net",728],["www.koreatimes.net",730],["lover932.net",731],["lover933.net",731],["lover934.net",731],["lover935.net",731],["lover936.net",731],["lover937.net",731],["lover938.net",731],["lover939.net",731],["lover940.net",731],["lover941.net",731],["mathbang.net",733],["moeni.net",736],["mongri.net",737],["moviepang.net",738],["3277532532.reviewtoday.net",741],["save-1.net",742],["tailstar.net",743],["news.unn.net",746],["ibric.org",747],["m.ibric.org",748],["tvroom5.org",749],["lol.ps",750],["namu.wiki",752],["en.namu.wiki",753],["mnetplus.world",754],["bobaelink65.xyz",755],["bobaelink66.xyz",755],["bobaelink67.xyz",755],["bobaelink68.xyz",755],["bobaelink69.xyz",755],["bobaelink70.xyz",755],["bobaelink71.xyz",755],["bobaelink72.xyz",755],["bobaelink73.xyz",755],["bobaelink74.xyz",755],["bobaelink75.xyz",755],["bobaelink76.xyz",755]]);

const entitiesMap = new Map([["agitnovel",0],["agitwebtoon",1],["anilife",2],["avsee",3],["bbongtv",4],["cokcok",5],["coktv",6],["g-enews",7],["newtoki",8],["sonagitv",9],["tvhot",[10,11]],["tvzone",12]]);

const exceptionsMap = new Map([["board.namu.wiki",[752]]]);

self.specificImports = self.specificImports || [];
self.specificImports.push({ argsList, hostnamesMap, entitiesMap, exceptionsMap });

/******************************************************************************/

})();

/******************************************************************************/
