/*******************************************************************************

    uBlock Origin Lite - a comprehensive, MV3-compliant content blocker
    Copyright (C) 2019-present Raymond Hill

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see {http://www.gnu.org/licenses/}.

    Home: https://github.com/gorhill/uBlock
*/

/* jshint esversion:11 */

'use strict';

// ruleset: rus-0

/******************************************************************************/

// Important!
// Isolate from global scope
(function uBOL_cssSpecificImports() {

/******************************************************************************/

const argsList = ["#vkMsg,\ndiv[class*=\"notifier_baloon_\"],\ndiv[id$=\"notifiers_wrap\"],\ndiv[id^=\"vk_ads_\"]","[href*=\"://redir.wargaming.net/\"]","[href*=\"media.hubfiles.gdn\"]","a[href*=\"&utm_medium=cpa\"][target=\"_blank\"]","a[href*=\".converteam.online\"]","a[href*=\".refocus.ru\"][target=\"_blank\"]","a[href*=\".yvok.ru\"]","a[href*=\"//admag.pro/\"]","a[href*=\"//mobiads.ru/\"]","a[href*=\"//ukrmedia.center/\"]","a[href*=\"/advtise.net\"]","a[href*=\"/bodyclick.net\"]","a[href*=\"/luckproducti.ru\"]","a[href*=\"/maniya.info\"]","a[href*=\"/relap.io/adv/\"]","a[href*=\"/rikkobr.com\"]","a[href*=\"/skiles.link\"]","a[href*=\"/starinform.ru\"]","a[href*=\"/traforet.com\"]","a[href*=\"101xp.com/?utm_source=ad\"]","a[href*=\"1xwgn.xyz\"]","a[href*=\"2di.site\"]","a[href*=\"://clickio.com/\"]","a[href*=\"://gdz-ru.work/\"]","a[href*=\"://mediasyndicate.ru\"][href*=\"banner\"]","a[href*=\"://mt-pbs.te.ua\"][target=\"_blank\"] > img","a[href*=\"://rotagmbetdog.xyz/\"]","a[href*=\"://smi.expert/\"]","a[href*=\"://smi.today/\"]","a[href*=\"://vsesdal.com/promo/\"]","a[href*=\"://winline.ru\"]","a[href*=\"abs-cdn.org\"]","a[href*=\"actionteaser.ru\"]","a[href*=\"adbid.biz\"]","a[href*=\"adsmedia-provider.com\"]","a[href*=\"advclicks.net\"]","a[href*=\"advert-content.com\"]","a[href*=\"aff-ads.com\"]","a[href*=\"autochetki.ru\"] img","a[href*=\"bigleads.ru\"]","a[href*=\"binomo.com/promo\"] > img","a[href*=\"catcut.net\"]","a[href*=\"cpagette.com\"]","a[href*=\"cpagetti.com\"]","a[href*=\"cpagettio.com\"]","a[href*=\"cpaggetti.com\"]","a[href*=\"cpaggetti.ru\"]","a[href*=\"cpamatica.com\"]","a[href*=\"direct\"][href*=\"advert.ru\"],\niframe[src*=\"directadvert\"]","a[href*=\"download-center.club\"]","a[href*=\"globalteaser.ru\"]","a[href*=\"incrypted.net\"][href*=\"banner\"][target=\"_blank\"]","a[href*=\"installoffer.net\"]","a[href*=\"leadadvert.ru\"]","a[href*=\"lenkmio.com\"][target=\"_blank\"]","a[href*=\"marathonmirrorbet.com\"]","a[href*=\"medicinetizer.ru\"]","a[href*=\"news-network.ru\"][target=\"_blank\"]","a[href*=\"newsnetwork.ru\"][target=\"_blank\"]","a[href*=\"novostimira.biz\"]","a[href*=\"omnicpa.ru\"]","a[href*=\"onetwoaffiliates.com\"]","a[href*=\"people-group.su\"]","a[href*=\"promoheads.com\"]","a[href*=\"reals-gooods.ru\"]","a[href*=\"recreativ.ru\"]","a[href*=\"redtram.com\"]","a[href*=\"rootmedia.cc\"]","a[href*=\"runetki.com\"]","a[href*=\"teasermoney.com\"]","a[href*=\"tizerclick.com\"]","a[href*=\"tovar.helloprice.ru/click/\"]","a[href*=\"trafmag.com\"]","a[href*=\"true-gooods.ru\"]","a[href*=\"universallnk.com\"]","a[href*=\"www.nnn.ru\"]","a[href*=\"wwwapteka.info\"]","a[href*=\"zen.yandex.\"] > img:not([src*=\"gstatic.com\"]):not([onload*=\"google\"]):not([jsaction])","a[href^=\"http://amigo-source.website/\"]","a[href^=\"http://amigoman.pw/\"]","a[href^=\"http://amigone.pw/\"]","a[href^=\"https://20idei.ru\"] > *","a[href^=\"https://bither.one/\"]","a[href^=\"https://click.track-lesta.ru/\"]","a[onclick*=\"media-rotate.com\"]","a[onclick*=\"reklamka.ru.net\"]","form[action^=\"//12go.asia/\"][target=\"_blank\"] > .powered","iframe[src*=\"//kwork.ru/api/widget/\"]","iframe[src*=\"//sass.com.ua/\"]","iframe[src*=\"/adnetpartner.com\"]","iframe[src*=\"/uniontraff.com\"]","iframe[src*=\"://match-center.playmaker24.ru/\"]","iframe[src*=\"bongacams.com\"]","iframe[src*=\"giraff.io/\"]","iframe[src*=\"steambets.net/\"]","iframe[width=\"240\"][height=\"400\"]","img[width=\"468\"][height=\"60\"]","noindex a[href^=\"http://www.westmister.eu/collection/\"], noindex a[href^=\"http://www.westmister.eu/collection/\"] ~ *","a[href*=\"://smi2.ru/newdata/news?ad=\"]","a[href*=\"://smi2.ru/newdata/news?ad=\"] *",":not(obhod-adblocka)","#adbtm","#ads",".banner","#banner",".loading",".flb,\n.plb",".footer-lb,\n.player-lb","#sidebar > .banners-list > :not([id^=\"email-\"])",".brand-top",".main-banner-wrapper","body > a[href][target=\"_blank\"]",".awd-hidden-phone",".card-placeholder,\napp-block-widget-banner",".bung-container","#FheaderContent > #archiveString ~ div[id]:not([class]):not([id=\"forecastShort\"]),\n#content-wrapper > #content ~ div[id]:not([id=\"mapa\"])","div:has(> ins)",".adbn2-wrap2",".fbOverlay","div[align=\"center\"] > a[href] > img[src*=\".gif\"]","[src*=\"/public/banner/\"]","#topbanners_bg","div[id*=\"banner\"]",".ads",".banner-wrapper","#ipsLayout_mainArea > center[style],\n#rightBanners,\n.okus_top","#videorekframe",".facebook-bg, .facebook-window","div[class*=\"banner\"]","[class^=\"brand\"],\n[id^=\"bg_banner_link\"],\na[href^=\"/banner.php\"],\nobject[data*=\"banner\"]",".right-bnr",".sidebar-top a[href*=\"/advertise\"]",".blockreklam","#js-dialog-social-overlay","#leftcolon,\n#rightcolon",".adv","*",".rightbar__reklama",".tiled_cap,\ndiv[id][class][style=\"min-height:150px\"]","div[class]:has(> a[title] ~ a[title] > div[class])","body > div[id^=\"brands\"]",".bs-vc-sidebar-column > div > div:has([id^=\"yandex_rtb\"]),\n:not(.sidebar) > .widget_text",".sidebar > .widget_text ~ .widget_text",".ban1",".ban2",".top-banner","[id^=\"unit_\"]",".ab-fade,\n.widebanner","div[id^=\"promo_banner\"]","[id*=\"Banner\"]",".bounceIn.hola.attention",".art_dzen,\ndiv[class^=\"bnmd_\"],\ndiv[id^=\"dm_bnr\"]","noindex","body > [onclick]",".banner_top","div[id^=\"slot-\"]",".movie-full > noindex","div[class*=\"tizer\"]","a[href*=\"goo.gl\"]",".full-news td[bgcolor]",".right-col > .right-block-title,\ncenter > .right-block-title","body > [id][style^=\"z-index\"]","#dle-content > a[href] > img","div[class^=\"right\"] .ramka1:has(noindex)",".rek",".adv-player",".good-target","div[style] > a[href]:not([href^=\"/\"]):not([href^=\"https://mozaika.biz/\"]) > img,\ndiv[style]:has(> a[href]:not([href^=\"/\"]):not([href^=\"https://mozaika.biz/\"]) > img)",".onesongblock-download",".onesongblock-rbt",".playlist-ad",".forumlink","#parent-erocritic","#sidebar > .widget:has([href*=\"//pwnd.cx\"]),\n#sidebar > .widget:has([href*=\"utm_\"][target=\"_blank\"]),\n.add-link,\n.block_left,\n.block_right,\n.section_spoiler,\nbody > div[class^=\"spu-\"]",".crymoreb","a[href*=\"banner\"][target=\"_blank\"]",".pw-rkl-section,\n.side-rkl-section","iframe[src*=\"banner\"]","#latest_news > div,\n#main_content_wrap > #latest_news > table[width=\"100%\"] > tbody > tr > td[width=\"100%\"] ~ *,\n#main_content_wrap > #latest_news > table[width=\"100%\"] > tbody > tr ~ *,\n#main_content_wrap > table[width=\"100%\"] > tbody > tr > td[width=\"100%\"] ~ td,\n#page_footer .vBottom[style],\n#page_header > div[style^=\"position:\"] > a[href][target=\"_blank\"],\n#pl-speedbar,\n#tor-fl-bgn,\n.forums tr[id^=\"f-\"]:has(.topic_icon[src$=\"/folder_lock.gif\"]),\n.med.bordered.attach > tbody > .tCenter ~ .tCenter + tr,\n.med.bordered.attach > tbody > tr.row1 ~ .row3,\n.med.bordered.attach > tbody > tr.row1 ~ .row3 ~ *,\n.rk,\n.tCenter.nowrap.mrg_12,\n.tCenter.nowrap.mrg_12 + div[style],\n[id*=\"adriver\"],\na[href*=\"toy69.ru\"],\na[href*=\"vsexshop.ru\"],\ndiv[id^=\"bn-\"]",".forabg div[class][style*=\"cursor\"]","#rekl-center",".r21,\na[href*=\"bear\"],\ndiv[class^=\"r\"][style*=\"height:\"],\ndiv[class^=\"r711\"],\ndiv[style^=\"background-color: rgb(204, 0, 0)\"]",".br",".shoppy_offers",".ipsA1d","body > .js-div:empty","[id^=\"oframe\"] > pjsdiv:has(> pjsdiv > img[src$=\"/adblock.png\"])",".download_inner,\n.reset > li > a[target=\"_blank\"]",".Advertising","a[href=\"http://vsofte.biz/rel.html\"]",".block-body > .mr_first_post,\n.f_op,\n.p-body-inner > .notices,\n.sotka,\n.sponsor-banners",".PanelScroller,\n.funbox",".samBannerUnit",".samCodeUnit",".topb",".ipsAd123,\n.ipsAd123 + div[align=\"center\"],\n[id^=\"numlink\"],\na[href*=\"promotion&section=adclick\"],\nbody > div[class^=\"simplemodal\"]",".ad","a[target=\"_blank\"] > img[src*=\"/outbyte/\"]",".js--direct-ad-host,\n[data-banner-place-id],\ndiv[id^=\"yandex_direct_\"],\nhtml.html-mobile div[class$=\"__inner--custom-width\"],\nhtml.html-mobile div[class*=\" false\"],\nhtml.html-mobile div[class*=\"--hideable\"],\nhtml.html-mobile div[data-banner-place-id]",".big-ad-animation-box",".small-white-block",".banner_box","div[id^=\"banner-slider-\"]",".code-block",".header__banner","a[href*=\"//zen.yandex.ru/\"]",".adFoxBanner","._1xza2sg,\na[href*=\"://redirect.2gis.com/adv/\"]",".stream-item",".widget_text",".article-content + .card-wrapper,\n.aside-promo,\n.r-header-wrapper,\ndiv[class^=\"r-block\"]",".branding","a[href*=\"utm_campai\"]",".av-branding-bottom,\n.av-branding-top,\n.break,\n.show-on-desktop",".--advert",".right_banner",".top_banner",".redTram,\n.region-sidebar-second-inner > .block ~ .block .rtecenter","a[href*=\"//dzen.ru/\"]",".news-detail > .animate.content ~ div[id]",".front-widgets,\n.sidebar-content a[href][target=\"_blank\"] > img",".market-link",".bans","a[href*=\"zen.yandex.ru\"]","#page::after","a[href*=\"banner\"]","[data-banner-id]",".adv_test",".adb","iframe[src*=\"/delivery/afr.\"]",".brandLink,\n.brandingBottom,\n.brandingTop","div[class^=\"banner\"]","body.blocked > #modalCookies,\nbody.blocked > div[class*=\"modal-overlay\"]",".advertisements,\n.custom-html-widget > a[target=\"_blanck\"]",".infTable.goods-list","#cookiesAgreementNotice","#full-top-layout,\n#top-layout,\n.template:has(> .template-content > .template-block > div > script),\ndiv[data-class-name=\"ads_engine\"]",".bookgDiv,\na[href*=\"://betonmobile.by\"]","a[href*=\"/bookmaker\"]",".placeholder",".column2 > .section-rss",".extender,\n.sticky > .section,\n.top-media-extender",".section-media","div[class^=\"stopblock\"]","#atvcap,\n#rhs_block .xpdopen div[data-ved] > .mod:not([data-attrid]),\n.VkpGBb:has(.gghBu),\n.cu-container > div[class*=\"commercial-unit\"],\n.rlfl__tls > div[jstcache]:has(.gghBu)","div[class*=\"baner\"]","#banner_top",".partners",".side-banner",".b-card__sale,\n.b-catalog-table__sale","#main-sidebar > .widget_custom_html:last-child","a[href*=\"infobank.by/modules/astat/click.aspx\"][target=\"_blank\"],\ndiv[id*=\"swiffycontainer\"]",".wrBanerPlace noindex","div[class^=\"banner_\"]","div[data-banner-class]",".banner-header","div[class^=\"banner\"][class$=\"rightSide\"] > .banner:nth-of-type(1)",".col-partner-offers","#right-banner-container,\ndiv[id^=\"surveys\"]","body[class*=\"modal-\"] > [class^=\"modal\"]","div[class*=\" styles_empty_collapse\"],\ndiv[data-container-id]","#content div[class]:not([id]):has(> [id^=\"adfox_\"]:first-child)","[data-name=\"ad_in_listing\"] > article:has(> div > [id^=\"adfox_\"])","#node-banners,\n#page > .region-secondary-content,\n.region-top-banner","#dbtn2","aside[id^=\"banner-\"]","#bodysubcont > div[style^=\"padding\"]:not([id]):not([class]),\n.bdiv","#slider_content,\na[rel=\"nofollow\"][target=\"_new\"][href^=\"/ref&url=\"]",".teasers",".bottom-bnr,\n.brn-container,\n.zen-subscribe-container",":not(.blinks) > .ad",".custom-html-widget > a[href][target=\"_blank\"][rel=\"noopener noreferrer\"],\n.mn-a-rec,\n.zen-block-wrapper",".advertising-widget",".center-special,\n.video_advert_block,\na[href^=\"/redirect.php?bid=\"],\ndiv[class^=\"super_context\"]","div[class*=\"banners\"]",".alfa-promo-btn,\n.bg-light-blue,\n.r-sidebar > .own-placement,\n.showcase-aside.hidden-xs",".article__banner",".main_logo_carusel","a[href^=\"https://www.alibi.by\"]","a[href][target=\"_blank\"] > img[src^=\"/img/ban\"],\na[href][target=\"_blank\"]:not([href^=\"/\"]):not([href^=\"https://nb.by/\"]) > img[width=\"100%\"],\nbody > .container > div[style=\"background-color:#dfe0e1\"]","[class^=\"side-banner\"]",".main-branding-bg-link,\n.nn-banner",".bnr-top-wide,\n.news-incut_position_right,\n.news-media__preview > a:not([href*=\"onliner.by/\"]) > img,\n.news-promo:has(> .news-promo__details),\n.news-promo[style^=\"background-color:\"]:has([href*=\"banner\"]),\n.news-promo[style^=\"background-color:\"]:has([href]:not([href*=\".onliner.by/\"])),\n.news-promo[style^=\"background-color:\"]:has([href^=\"https://catalog.onliner.by/\"]),\n.news-text > * > a[href^=\"https://catalog.onliner.by/\"][href*=\"utm_\"],\n.news-text > .news-media a[href^=\"https://catalog.onliner.by/\"],\n.news-tidings__item.js-closable,\n.news-widget,\na[href*=\".betera.by\"],\na[href*=\".pm.by\"],\na[href*=\"voka\"][href*=\"utm_\"],\nimg[src=\"https://content.onliner.by/news/1100x5616/eb7d2f564b229c0da9f39ec11eb7d529.png\"]",".news-banner","a[href*=\"bit.ly\"]",".important.b-fleamarket__right-block","div[id*=\"yandex_ad\"]",".b-offers-promo","#parimatch-widget .b-main-page-result__list,\n.adfox-banner-background,\n.b-tiles-banner,\n.b-tiles-outer_special,\n[class*=\"megabanner\"],\nheader > a[href*=\"utm_\"]",".b-renommee__wrap","#top-banner-block,\n.banner-cube","#animation_container","#left > .HR[align=\"right\"] ~ *,\ndiv[style*=\"width:240px; height:400px;\"]","a[href^=\" https://vk.com/look_up_potolki\"],\naside#sidebar > a[href],\nbody > #container > div[style]",".top_brand","div[id^=\"banObject\"]","div[class^=\"adsensepost\"]",".hbaner,\ndiv[class^=\"sidebar-\"] > div[id^=\"media_image-\"]",".csc-textpic:has(> .csc-textpic-imagewrap > a > img[src*=\"realt.by/uploads/pics/bsb-bank_mechty_\"])",".S617e090e7e,\ndiv[class$=\"-BlockDetect\"],\nmain > div:first-child:empty + div:not([class]) > div > div","body > div:not([id]):not([class])[style^=\"position\"][style*=\"background\"][style*=\"z-index\"]",".left_col",".r_col > center,\n.r_col > div[style]","a[href*=\"://reklama.tut.by/\"]",".min-height-200px","#TopBox,\n.side_banners",".widget_media_image","#content > .block:has(a[href][target=\"_blank\"] > img),\n.block:has(.adsbygoogle),\n.block:has([id^=\"yandex_rtb\"]),\n.sidebar > .block:has(a[href][target=\"_blank\"] > img),\na[class^=\"adv-\"][class$=\"-link\"]",".banners",".header-reclame,\n.rekblockr","#banner_750,\n.themaBannerPlace","#topbn,\n.column_banner-wrap","#marketWidget,\n#rightLinksBlock,\n.b-aditem,\n.b-hota,\n.b-mainbanner,\n.b-prmplace,\n.branding > a,\n.branding_bottom_links,\n.branding_top_links,\n.impl-vscroll-container[style=\"max-height: 1200px;\"],\n.m-topic-tam, .m-topic-tam ~ div,\n.prom-l,\n.prom-r,\n.reklama_links,\n.rubric-brand,\n.top-offer,\n.top_brand_links,\na[href*=\"://preved.tut.by/?clickid=\"],\nbody > div[style*=\"position: fixed;\"][style*=\"right: 0;\"],\ndiv[data-atom-marker=\"kupi_block\"],\ndiv[data-io-title=\"Новости компаний\"]",".banner-place",".mm-main",".b-alpari,\n.tbl-lite > tbody > tr.clickable ~ tr:not(.clickable),\n.tbl-lite > tbody > tr[onclick] ~ tr:not([onclick])",".branding-top",".b-widget",".m-market,\n.search-i > .b-results-list:first-child:not([start])","#article_body > .TitledImage,\na[href*=\".pm.by/\"],\na[href*=\"://pm.by/\"]",".b-top + #resource_block,\n.l-main > .b-top + .b-top",".block-velcompany",".dmi-header-ads,\ndiv[class*=\"ads-placement\"]",".zen-sector","#sidebar-first object",".bonus-btn,\n.header__bonus,\ndiv[id^=\"bookmaker_\"]","a[href*=\"//ads.adfox.ru/\"]","#banner.b-banner__content,\n.Ad > .Ad-Container ~ .Ad-Spinner,\n.AdvRsya-Slot,\n.Root > .ECommerceCarousel,\n.VideoViewer .Viewer-ScrollContainer > div[class]:first-child > div[id][class]:first-child:empty + div,\n.adv_pos_compare-bottom,\n.adv_pos_compare-side,\n.adv_pos_popup,\n.b-direct,\n.b-spec-adv,\n.b-yabrowser-promo,\n.blocks-grid__item_static > .direct_type_stripe,\n.container__banner,\n.content.i-bem > .body__topblocks,\n.content__right > .z-market_right_yes,\n.direct-view,\n.dist-overlay__popup,\n.forecast-details > .card:has(> [class*=\"adv\"]),\n.i-bem.adsrv,\n.i-bem.b-timetable__row[onclick*=\"awaps\"],\n.i-bem.stripe_type_promo,\n.i-bem.tv-grid__item-adv,\n.i-bem.tv-sortable-item.tv-sortable-item_sortable_no,\n.masonry .incut_banner,\n.scroller__wrap > .showcase__item:has(.product-card__direct),\n.search-advert-badge__advert,\n.search-list-view__advert-offer-banner,\n.search-results__guadeloupe,\n.serp-adv__add,\n.serp-adv__all,\n.serp.main__carousel .Label_theme_direct,\n.sidebar-container ._id_branding_tele2,\n.sidebar-container .card-providers-view__item._big,\n.sidebar-container .search-advert-badge,\n.sidebar-container a[class*=\"_id_campaign_\"],\n.sidebar-container div[class^=\"banner-placeholder\"],\n.sidebar-view .business-advert-view,\n.sidebar-view div[style*=\"!important\"]:not([style*=\"font-size\"]),\n.spec-adv,\n.stack [class*=\"sticky\"][class*=\"banner\"],\n.stack [id*=\"sticky\"][id*=\"banner\"],\n.stack div[class*=\"modal\"][class*=\"-R-A\"],\n.stat_pixel_yes[onclick][class*=\"_layout_\"][class*=\"_format_\"],\n.turbo-advert__loader,\n.weather-maps__ad,\na[href^=\"/maps/\"][href*=\"/tinkoff_has_offer\"],\nbody > .popup[data-bem*=\"https://yabs.yandex.ru/count/\"],\nbody > .route-tip-view,\nbody[class*=\"b-page_alt-widgets_yes\"] .feed ._need-stub,\ndiv[aria-label=\"Реклама\"],\ndiv[class*=\" news-\"][class$=\"_mode_daas\"],\ndiv[class*=\"VideoViewer-Block\"] > .VideoPlayerMetaInfo ~ div:has(> div[id]:empty),\ndiv[class*=\"cl-teaser cl-teaser_card cl-teaser_fixed\"] ~ div[class=\"cl-teaser cl-teaser_card cl-teaser_fixed\"],\ndiv[class*=\"sidebar\"] > .direct-snippet,\ndiv[class^=\"b-spec-adv\"],\ndiv[data-block=\"banner-view\"],\nhtml[class*=\" Theme_color_news-\"] div[class*=\"_type_native\"] [class*=\"_type_card\"]:has(> div > div:empty),\nimg[src*=\"yandex.net/get-direct\"]","#rsya-guarantee,\n.DirectInline,\n.DirectSnippet,\n.Organic_withPromoOffer,\n.SearchPageGrid-Item_direct,\n.content__left > #search-result > li:has(> .Organic_withPromoOffer),\n.content__right div[class]:has(> div > script),\n.content__right div[class][data-log-node]:has(.DirectInlineContainer),\n.layout__banner,\n.main__distr-popup,\n.serp.main__carousel:not([data-bem*=\"collectionId\"]),\n[data-vnl*=\"rsya_guarantee\"],\ndiv[class*=\"Images\"] .SimpleSkeleton,\ndiv[class*=\"Images\"] div[class*=\"-Card_bottomAdv\"],\ndiv[class*=\"Images\"] div[class*=\"_filled\"][style^=\"max-width:\"],\ndiv[class=\"serp-item RsyaGuarantee\"],\ndiv[id*=\"Images\"] .SimpleSkeleton,\ndiv[id*=\"Images\"] div[class*=\"_filled\"][style^=\"max-width:\"]",".link-bro","[class*=\"mini-suggest__item\"] > a[href*=\"://yabs.yandex.\"][href*=\"/count/\"],\n[class*=\"mini-suggest__item\"] > a[href*=\"://yandex.\"][href*=\"/clck/\"],\n[class*=\"mini-suggest__item\"] > a[href][target=\"_blank\"],\n[id^=\"suggest-item-\"] > a[href*=\"://yabs.yandex.\"][href*=\"/count/\"]",".afisha-profit-banner,\ndiv[class$=\"-banner\"],\ndiv[data-bem*=\"height\"][data-bem*=\"R-A-\"],\ndiv[id][style=\"display: block; position: static; opacity: 1;\"],\ndiv[style^=\"width:100%;height:2\"][style$=\"px;display:block\"]",".awaps__banner,\n.software-header-promo,\na[href][style*=\"storage.mds.yandex.net/get-bstor/\"],\ndiv[class^=\"direct\"]:not([class^=\"directory-content\"])","[target][class*=\"fullscreen-banner\"],\ndiv[class^=\"direct-public\"]",".js-doc-html > div[class^=\"pages_\"] > div[class]:empty,\n.with-bottom-direct > div[class] > div[class]:empty",".js-scroller-right:has(> div:only-child),\n[data-key=\"box=left-box\"]:has(> [data-key=\"view=react-left-column\"] + div:empty) a[href*=\"/premium-\"],\ndiv[class*=\"DirectLine\"]",".layout_type_search.headline__footer,\ndiv[data-zone-name=\"direct-ads-gallery\"]",".bar__driver-container,\n.page-root > .d-overhead,\n[class^=\"audio-advert\"],\nbody > div[style^=\"min-height\"] > .notify,\nbody > div[style^=\"min-height\"] > .notify *,\ndiv[class*=\"sidebar\"] .no-ads",".slider > .slider__item_advert",".notify",".Direct,\n.SearchSegments__row:has([class*=\"banner\"]),\n.SearchSegments__row:has([id*=\"banner\"]),\n.ThreadLayout__topDirect",".sidebar-direct",".zen","#mount main > div[class^=\"content__\"] > .content__main ~ div[class*=\"content__\"] > *,\n#mount main > div[class^=\"content__\"] ~ div:not([class^=\"content__\"]):not(.zen):not(.bread-crumbs) > *,\n.main-controller__grid-wrapper > [class*=\"grid_period_\"] ~ * > *,\n.page_controller_channel main.content > div[class]:first-child > div:first-child[style*=\"background-image\"],\n[class*=\"grid_period_\"] > div[class] > div[class^=\"grid__\"] ~ div:not([class^=\"grid__\"]),\nbody > #mount > div[class] > :not(header):not(main):not(footer):not(.metrika-loader),\ndiv[class*=\"adv-manager\"],\nscript[nonce] + script[nonce] + div[class]","#dle-content > .news:has(> .news_text :not(.text_spoiler) > a:not([href^=\"/\"]):not([href*=\"anistar.org/\"]):not([href*=\"astar.bz/\"]):not([href*=\"online-star.org/\"]):not([href*=\"online-stars.org/\"])),\n#dle-content > .news:has(> .news_text object),\n.content-pravo > .news-list ~ div[class^=\"center\"],\n.right-panel-bottom > .favorites ~ span,\n[href*=\"://r.advg.agency/\"],\na[href*=\"://litmarket.ru/\"],\na[onclick^=\"if(typeof yaCounter\"],\niframe[src*=\"banner\"]:not([src^=\"https://vk.com/widget_comments.php\"])",".context-ad",".ad_sponsor_newbanner_forum,\ndiv[style] > center","#right > div[style*=\"height:\"][style*=\"255px\"]",".adv-hidden-xs",".panel-primary","#rkl-left",".homeBanner,\n.postBanner",".DmWidget","#prgm-block,\n.video-container > a[href][target=\"_blank\"]",".main-full > noindex",".content-card ~ :not(.content-card) > a[href][target=\"_blank\"]","a[href*=\"/fonzo.ru/adv/\"]","div[id^=\"qwetaper\"]","#custom_brand,\n.odds_section","#advmusic_banner","#posts > center","a[href*=\"://nowa.cc/page.php?p=rek\"] img",".EstBS-bnContent,\n.theshit_top_block",".banner-top","#container > :not(#page) a[target^=\"_\"],\n.sidebar_block > h2[style=\"margin-top: 10px\"],\n.sidebar_block > h2[style=\"margin-top: 10px\"] + div",".rbt_web","#player > div[style*=\"pointer;\"]","#window-body > #formula ~ p,\n#window-body > :not(p),\n#window-body > a + p,\n#window-frame > #window-title,\ncenter > a > img","#right > .colorstrip,\n#torrents ~ div[align=\"center\"]","#closed-vid,\n.telegram__wraper","#amgf,\na[href*=\"/1w.tf\"]","a[href*=\"/1b.yt\"]","a[href*=\"/is.gd/\"]","#rectangle-wrapper","span[id][style] > div[id]:first-child:last-child",".clickads,\ndiv[class^=\"unique-\"]","div[class^=\"mc-banner\"]","div[class*=\"bunner\"]","div[id^=\"bnr-\"]","#scroll_banner_container,\ndiv[style=\"min-height: 90px\"]","a[href*=\"/ad.admitad.com/\"]",".index-top-banner","img[alt^=\"Баннер\"]",".video-spot",".content-box div[style^=\"margin-bottom: 20px;\"]",".load_banner",".has-top-liner .layout > div > .cc",".widget_custom_html",".sam3Bannner2Uni",".adblck",".gnezdo","body > noindex","#before_film_torrents,\n#container > center:nth-child(-1n+3),\n#leftmenu .no-mobile a[href][target=\"_blank\"],\n.film_page > div:not([id]):not([class]) > center,\n.video-inner-top",".ads-popup,\ndiv[class*=\"desktop_direct\"]",".advertising",".media","div:has(> [src=\"/secret.png\"])","a[style*=\"color:\"] > span","a[href][target=\"_blank\"] > img[width][height]",".roll_autoplay_ads",".wrapper-main > .clearfix","#new-ad-part",".badge-primary,\n.left-sidebar > a[href][target=\"_blank\"] > img",".banner_holder","#TVZavr","div[class^=\"dolmraz\"]","#right_case > .module:has(script)",".bgAdd","body > div[id][style^=\"height\"]:not(#id),\ndiv[id*=\"-sidebar\"]","#darkenwrapper,\n.rules[style^=\"display:\"][style*=\"position:\"][style*=\"z-index:\"]",".work","#pwindow,\n#pwrap","a[href*=\"clck.ru\"]","#osiad",".posts__adv","#video_bootom",".bad","#popular","body > .brand","body > div[class^=\"remodal\"]",".co_ba","div[class*=\"-brnd\"]","pp",".advertising-heading",".comments-wrapper,\ndiv[class*=\"ads-fixed\"]",".sp_darkvids",".main > div[style]","header noindex","figure[id^=\"attachment\"]","div[style=\"display: block;\"]",".rakana","#unique-because-id",".rightpanel","xp-banner-sidebar","#ads-speedtest-view-container","#uvpromo",".backstretch","div[id^=\"advert\"]","a[href*=\"picjoke.net\"]","#wpstb-block","#detected,\n.partner-ads","#exposeMask,\n.xenOverlay","#adsh","#bnnr","a[href*=\"rbs_banner\"]","body > noindex > center","#sidebar-fixed > div[class*=\"group\"] > noindex,\n.footerLegal,\na[href^=\"http://www.steroydsrus.net/\"],\ndiv[class^=\"strus\"]","div[class^=\"charlotte-\"]","#topgame","#header","div[class*=\"teaser\"]","a[href*=\"ororo.tv\"]","div[style*=\"background-color\"][style*=\"position\"][style*=\"z-index\"],\ntd[width=\"29%\"]","object, embed","div[id^=\"banner\"]","div[id^=\"b_n_r_\"]",".yandex-absolute","#article_banner","[id*=\"redtram\"]","a[data-bid]",".header-banner",".left-banner",".right-banner","a[href^=\"/bitrix/rk.php\"]",".vex","div[id^=\"slidebox\"]","div[id^=\"tgroup_\"]","div[id^=\"yazd_\"]",".col_l_b","div[class^=\"advtss\"]",".game-drv,\n[class*=\"tizer\"],\na[href*=\"/landing\"],\na[href*=\"adblock\"]",".banner_main,\n.left_banner > a[target=\"_blank\"],\n.middle_banner",".promo","tr > td > #myElement","div[class^=\"adver_\"]","a[href*=\"/ad.adriver.\"]","a[target=\"_blank\"] > img[width=\"1200\"]","a[href^=\"https://play.google.com/store/apps/details?id=\"]",".banner-link","div[class^=\"adsbanner\"]",".b-side-block:not(.b-side-block-slider)",".av-block,\n.widget:has(> div > .av-block)",".td-for-blocks > .left-block[style]","#content::after,\n#content::before,\n#header_b,\nheader::after",".bannertopclass,\ndiv[style*=\"width: 240px;\"][style*=\"height: 400px;\"]","body.playerCode > div[style^=\"position: absolute;\"][onclick]","#topright","#mdl_adb","td[style*=\"theme_orig\"] > table",".bnrcontainer",".img-banner-responsive",".tg-button","div[id^=\"clear_\"]",".widget-sidebar:has(> div .adsbygoogle),\n.widget-sidebar:has(> div > [id^=\"adfox_\"]),\np[style=\"border:3px solid #C1FF0A;background-color:#d5d5d1;padding:10px;\"]",".rightside > .block:has(> .dcont > div > ins)",".widget_text:has([id^=\"yandex_rtb\"])",".link_textblock > div[style=\"height:250px\"]",".commercial-branding article > div:only-child > div:first-child + div + div:last-child,\naside:has(> div > [class^=\"banner--native-partner_widget\"]),\ndiv[class*=\"banner-\"],\ndiv[id^=\"rcmw-container-\"][id*=\"-horizontal-\"],\ndiv[style=\"min-height: 600px;\"] ~ div,\ndiv[style=\"min-height:600px\"] ~ div,\ndiv[style^=\"height: 290px\"][style*=\"overflow: hidden\"],\ndiv[style^=\"min-height: 240px\"],\ndiv[style^=\"min-height: 250px\"],\ndiv[style^=\"min-height: 290px\"],\ndiv[style^=\"min-height: 300px\"],\ndiv[style^=\"min-height: 400px\"],\ndiv[style^=\"min-height: 600px\"],\ndiv[style^=\"min-height:240px\"],\ndiv[style^=\"min-height:250px\"],\ndiv[style^=\"min-height:290px\"],\ndiv[style^=\"min-height:300px\"],\ndiv[style^=\"min-height:400px\"],\ndiv[style^=\"min-height:600px\"],\ndiv[style^=\"order:\"][style*=\"-1\"]","[data-auto_media-desktop*=\"rnet_widget\"]","#mainFloatDesctop,\ndiv[id][style=\"height:150px;\"],\ndiv[id][style=\"height:350px;\"]",".adbn-wrap,\ndiv[id^=\"laoad_Adb\"]",".advertisingheader,\na[href*=\"loshadka-kachalka.ru\"]",".ipsSpacer_both:empty","#ad","#imRunetkiPop,\n#l0ZKuGa775","#dle-content > span > noindex","div[style^=\"background:#444;\"]","a[href^=\"/go.php\"]",".branding-container","#secondary > .widget_text","#sponsors","a[href*=\"utm_\"]","aside div[class^=\"a-single\"]",".hottopicadvertbox","mark > strong",".staticFragment","#reachMedia,\n#shadowMedia","#adpartner_branding > center","#da-slider","#navbar-container > div[style^=\"height\"],\na[href*=\"bitmakler.com/go.php\"],\nimg[onclick*=\"bitmakler.com/go.php\"]","div[style] > div[class*=\"Overlay\"][id*=\"Overlay\"]","#overlay",".post-body > div[dir] > div[dir] > h1#result","#sidebar-wrapper",".foot > .widget.HTML","#parent_popup","a[target=\"_blank\"][href*=\"besthosting.ua/\"]","body > div:not([id]):not([class])[style*=\"z-index\"]",".fly_player","#desktop_sticky_ad_container,\n.midAdvert","div[class^=\"advert\"]","#morev","#brand","#right_col > .banner,\n#slider,\n.megatop","#content-padding > #content ~ hr ~ *,\n#page > a[href] > img,\n.entry > p > a[href][rel=\"nofollow\"],\n[class^=\"BlockR\"],\na[href^=\"https://tutvisa.by/\"]",".adsbygoogle","a > img[style*=\"height:100px;\"]",".b-reclame","[data-ad]","body.access div[id^=\"access-au\"]","aside > #vedomosti_block:nth-child(-1n+9)",".offblo",".recommended",".rtiz","tbody > tr > td[style=\"vertical-align:top\"]",".information-container","a[href*=\"offer_id=\"]",".banner-announce,\n.banner-parallax,\n.header-bottom__adv,\n.infographic-countdown,\n.infographic-duel,\n.recommender-block ~ .banner + div:not([class*=\"comments\"]),\n[data-href*=\"okko.sport\"],\na[href*=\"okko.sport\"]","#body > #top .textwidget,\n#fon","a[rel=\"nofollow\"] > img[src^=\"/\"]","#sidebar-first-screen-0,\n#sidebar-stream-0,\na[href*=\"/stat/click-\"][target=\"_blank\"]","div:has(> .adsbygoogle)","div[style=\"height:auto;min-height:300px;\"]","div[class^=\"partners\"]","#tvukrnet","div[id^=\"reklama\"]","#partbn","a[href][target=\"_new\"]:not([href*=\"clusterdelta.com\"]),\niframe[src=\"/portal/stf.html\"]",".full-text > div[align=\"center\"] ~ div[align=\"center\"],\nimg[src*=\"/600_200\"]",".promo-background,\ndiv[class^=\"viewer\"][class*=\"banner\"]","#adblocker",".banner_rekl","body > a[href]","td[width=\"300\"] + td[valign=\"top\"] > .textc:has(a[href^=\"goto.php\"]),\ntd[width=\"300\"] + td[valign=\"top\"] > div[class^=\"c\"],\ntd[width=\"300\"] + td[valign=\"top\"] > noindex ~ noindex,\ntd[width=\"300\"] > div[class^=\"c\"],\ntd[width=\"300\"] > noindex",".b-main_body-i > noindex,\n.l-navigation-i > noindex","a[href^=\"/engine/dude/index/leech_out.php\"]",".rightBanner,\ndiv[id^=\"google_banner\"]",".recl_vert","[id^=\"ads_zone\"]","#content > noindex","div[class*=\"boxzilla\"]",".promo_sidebar,\n[class*=\"bg_banner\"]","#gads","body > div[id^=\"popup-\"]",".adv-heading,\n.rel_block","div[id*=\"TizerGroup\"]","div[id^=\"block-advertblock\"]","[data-type=\"elo-placement\"]",".c-block:has(> .c-dv-sns),\n.c-block:has(> [id^=\"adfox_\"]),\na[href*=\"://yabs.yandex.ru/count/\"],\ndiv[class$=\"content\"] ~ div + div[class*=\" \"][class$=\"--mh\"],\ndiv[class*=\"--content article \"] + div,\ndiv[class*=\"--content article \"] + div + div:not(:last-child),\ndiv[class*=\"--content article \"] + div ~ div:last-child > div:first-child + div[class]",".c-dv-sns",".bannerWrap",".banner-box,\n.top-banners-area",".messageB",".bn_news_incut,\na[href*=\"#after_incut\"]","#please_share","#topbun,\n.wdpu-container,\n.wpmui-overlay,\na[class=\"gofollow\"] > img","div[style=\"position: fixed; top: 0px; left: 0px; background-color: rgba(0, 0, 0, 0.8); width: 100vw; height: 100vh; z-index: 9999999;\"]","#sidebarBanner,\n.bookmaker_panel > .entry > .thumb,\n.ga_data,\n.right_column > .bets + .side_bookmakers,\n.side_bookmakers:has(> .bookmakers_list),\n[name=\"odds\"]",".bets",".widget_wrap",".bn","#redtram_news,\n.wiget.ukr_links,\n[onclick^=\"trackOutboundLink\"],\na[href*=\"bybit.com/\"] > img",".asp-widget-ads","a[href*=\"//besplatka.ua\"]","ins",".spot",".sidebar1","noindex > a[rel=\"nofollow\"][target=\"_blank\"]",".er-banner","body.cl-noscroll > .cl-dialog[style*=\"position: fixed\"]","center:has(> .adsbygoogle)",".abtop","[class][style*=\"important\"] * *","[data-container=\"outer\"]",".wp_baraban_like",".BoxVideo.clear ~ .BoxVideo.clear",".td-menu-background,\ndiv[id^=\"divFLRA\"]",".fc-ab-root","body > div[id][class]","#topline",".noindex-block","div[id][class^=\"popup\"][class$=\"wrap\"]",".mw-adblock",".sliding-block","a[href*=\"privatefx.com\"]",".skip-advert,\nbody > div[id][style*=\"z-index\"]","body > #banner","a[href*=\"728x90\"]",".rklma",".block-video > .table",".sponsor","div[id^=\"__vliadb\"]",".top-admitadv",".fuck-adblock","#welcomepopup_overlay,\n#welcomepopup_window",".banx-top,\n.container__bannerZone,\n.crttextpad,\n.detailLeaderboard,\n.otPlaceholder,\ndiv[id^=\"box-over-content\"],\nsport[name=\"soccer\"]","#bottomRightPanel,\n#responsiveBottomPanel",".fh5---banner---container","[id^=\"my1kil_\"]","#fancybox-overlay,\n.fancybox-wrap",".popularList > center",".ads-insert,\n.bet-informer__widget,\n.bk-notification ~ .nav__top,\n.bonus-bk,\n.footer-info__links-column._pwa-disable,\n.head-menu__bonus,\n.match-action,\n.special-projects,\n.without-content,\n[class^=\"bookie-\"],\n[data-popper-placement],\na[href=\"/betting/bonus\"],\na[href=\"/betting/bookmakers\"],\na[href=\"https://www.footboom1.com/betting\"],\na[href=\"https://www.footboom1.com/betting/bookmakers\"],\na[href=\"https://www.footboom1.com/casino/review?burgermenucasino\"],\na[href^=\"/betting/\"][target=\"_blank\"],\ndiv[class*=\"_bookie\"]","div[style=\"width:540px;height:90px;overflow:hidden;display:block;margin-top:10px\"]",".left_ff a[href*=\"/fortrader.org/\"],\n[id^=\"collapseobj_forumbit\"] .alt1Active > div[style=\"float:right\"]",".single_brba","#fb-popup","div[class^=\"traffic-video\"],\ndiv[id^=\"custom_fan_gate_overlay\"]","body .breadcrumb + center > [color=\"red\"] > b","#breadcrumb ~ div[style^=\"padding:\"],\n.nobord","#posts > .postcontainer[id^=\"yui-gen\"]","[class*=\"modal\"]","#wrapper > .l-container_wide[style*=\"min-height:\"],\n.friends-holder,\n.js-r-menu-item_friends,\n.offers-index,\n.text-center:has(> [style=\"min-height: 249px;\"]),\ndiv[style=\"min-height: 249px;\"],\ndiv[style=\"min-height: 89px;\"]",".fader-social",".game-preview-wrap > :not([class=\"game-preview\"])",".adsense",".dynban,\n.livebet,\n.pull-right > noindex,\n.yaadstracker","a[href^=\"/go\"]",".brand-block,\nsection[id^=\"tm-top-\"]","a[href=\"/go/vshapke.html\"]","#gp-pro-upsell",".mn-news-lst-ad-bl > div,\n[data-gmimplid],\na[href*=\"=http\"]:not([target]),\ndiv[style=\"overflow:hidden;\"]","#headb,\n.advb","#turn_advert.adblock","#facebook-modal","body.modal-open > .modal-backdrop","a[href][title*=\"банер\"],\nimg[class^=\"rec\"]","div[class*=\"block-articles-\"][class*=\"-native\"]",".widget_ad_unit,\ndiv[style=\"margin-top:5px;height:90px;\"]","body > div[g-popup-type=\"popup_ad\"]",".a-insertion,\n.b-insertion,\n[data-gcat=\"ads\"]",".bg-link","#pol,\n.shadow",".text-center:has(script),\n[data-controller=\"SearchInputController\"] ~ .well-container",".breadcrumbs ~ [value*=\"://gdz-ru.work/\"] ~ #exercises","div:has(> [href*=\"://gdz-ru.work/\"])","div:has(> img[src*=\"ops.\"])","[src*=\"/inc/getBanIf.\"]",".br-body,\n.br-col","#rekl",".gallery-center-ad-block,\n.news-block-magick,\n.sidebar-banner-block,\narticle div[style*=\"#EFEFEF\"]","div[class^=\"teaser\"]","#col-right > br","[id^=\"aswift_\"]",".post-top-meta[style*=\"fixed;\"],\np[style=\"padding-left: 20px;\"][align=\"center\"],\np[style=\"text-align:left;margin-left:10px;\"]",".Bu.y3,\ndiv.ae5","a[href^=\"http://landing.meendo.com/\"]","body > table[style=\"border: 1px solid #369\"]",".similar",".azk-banner",".ad-above-mod-dl-btn","img[src*=\"/upload/rk/\"]","object[width=\"200\"][height=\"100\"]",".dfp-slot__placeholder-text a,\n.pack-sponsor,\n.promo-block_courses,\n.sidebar-small-banner,\n.tm-company-card__branding",".dfp_label",".popmake-overlay",".stream-item-widget","div[class^=\"block-ad-\"]","div[class$=\"col\"] > .side ~ .side + .sidebtm ~ *",".fixedBg",".block-bg",".sidebar-bg","div[data-api=\"/API/banners\"]","a[href*=\"/go.php\"][target=\"_blank\"]","div[id^=\"news-id-\"] > div[align=\"center\"] > a[href*=\"aHR0c\"],\ntd[valign=\"top\"] > table:has(a[href*=\"/go.php\"][target=\"_blank\"])","#purchase_pref",".soc-auth-btns","#header + div[style*=\"960px\"],\n#partner,\n#partner-aside",".ai_widget",".mbywx,\n.widget_mbywx",".widget_block",".proakk","body > #video ~ [class][style*=\"pointer\"][style*=\"z-index\"]","#mainnews,\na[href*=\"helpix.ru\"]","body > div[id^=\"ab\"],\nbody > div[id^=\"ab\"] + div[style*=\"cursor\"]","#main > #top","[alt=\"Ads\"],\n[src*=\"/images/banner/\"]","a[href*=\"fas.st/\"]","#block-informer-news-page","#hideifpossible.box_wait",".bd-callout-danger,\n.bd-callout-warning","div[class^=\"adblock-warning\"]",".mv-content",".adsContainer",".home-new-column-bunner > [class] ~ [class*=\"home-new-bunner\"],\n.incrypted-top-banner",".article-single .bg-light,\n.main-page .card-body > a[target=\"_blank\"],\n.main-page > .container > .row > div + div ~ div,\n.main-page > .container > div[class^=\"text-black\"]",".banner-holder > .box","a[href^=\"http://trumangifts.com/\"]","body > div[style*=\"z-index\"][style*=\"9999\"]",".ads_body_page,\ndiv[class^=\"sticky-block\"]","#news-partner",".hbanner",".full-right-video1[style=\"text-align: center;\"],\ndiv[style=\"margin: 10px; text-align: center;\"]","#hit_pr,\n.partner_news","#PromoteSignUpPopUp,\n#__next > .fixed,\n#__next > style + div[class]:not([id]),\n#abPopup,\n.ad-blocker-popup,\n.js-general-overlay,\ndiv[class^=\"desktop\"] > .hidden,\ndiv[class^=\"outbrain_outbrain-wrapper_\"]","center a > img","#text-9,\ncenter > pre,\ndiv[class^=\"itech-\"][id^=\"itech-\"],\nspan.td_btn[style=\"color: #ffffff;\"]",".a-single",".info","img[src*=\"/images/commertials/\"]","#yandex_recommend,\n.Blocksmaster,\n.b-block__parterslist,\n.bcontainer,\n.hcont,\n.honor-mobile-menu-logo,\n.horb,\n.logohonor,\n.mobadv,\n.mobb,\n.vcont,\n.vertb,\n[src*=\"rose.ixbt.com/banner/\"],\na[data-menuitem=\"honor\"],\na[href*=\"ixbt.com/cgi-bin/click\"],\na[title=\"Яндекс Зен\"],\ndiv[class^=\"clickable_zone\"],\niframe[src*=\"ixbt.com/cgi-bin/banqs.cgi\"]",".b-adfox",".deskadv","div[id^=\"marketWidget\"]","#uLogin,\n.b_footer,\n.folders:has(> .title > [href=\"/?id=favorites\"]) ~ .forumpage_table div[style^=\"background: #aea; color:#020;\"],\n.head_ulogin",".ym-gbox-right > div[style=\"margin:0; padding:0\"][align=\"center\"],\nheader > div[style^=\"background\"]",".smbad","a[href*=\"/click/branding/\"]","#ixbt-video-news-block:empty","[title*=\"быстрый браузер!\"] > img",".bannergroup","#antiBlock","div[data-container=\"sidebar\"] div[class*=\"j-imageSubtitle\"],\ndiv[data-container=\"sidebar\"] div[class*=\"j-text\"]",".banner__content","a[href^=\"http://photo.stylus.com.ua/\"]",".rec,\n.tban-content","#sidebar .widget_text","iframe[src*=\"/images/banners/\"]","#header > center > div[style]","#secondary > .sidebar-widget:has([id^=\"yandex_rtb\"]),\n#secondary > .widget_recent_entries ~ .sidebar-widget","body > table > tbody > tr > td[align=\"center\"]",".top--banner",".left + .right","a[href*=\"mail.ru/r\"]","#content14",".b-background__link",".side > .random-link ~ *",".imgonline ~ *","a[href^=\"http://kinorubik.com/module.php\"]",".singlebox > .blockquote",".sidebar-nadpis,\ndiv[class^=\"sidebar-\"] > div[type=\"text/css\"][rel=\"nofollow\"]","#madBlockModal, .modal-backdrop","#kl-ad-top","#kl-o-gallery-ad,\n.kl-ad-item,\na[href^=\"/ad-redirect.php\"]","#branding","#right_banner","a[id^=\"linkFon\"],\ndiv[class=\"franke-sidebar\"]:not([style])","#shops-wrap,\n.ads-separator,\n.text-center > div[style=\"height: 250px;\"],\n.top-m-used-block,\n[class^=\"gekon\"]","#apext",".overlay_wrap",".pg-title--ymla,\n.region > .most-popular ~ .media-block-wrap",".kino-text > div[style^=\"clear:both;\"]",".widget_image-vertical","#banners-partners-blocks",".sidebanner-wrapper","#warn",".sa_widget","div[class^=\"chp_ads_block_modal\"]","div[class^=\"top_baner\"]",".content > .card ~ div:has(> center > [id^=\"adfox_\"]),\n.menu > .sticky",".cookies-w",".branding_top","div[id^=\"adsline\"]","#owaadbar,\n.N3k7EN5vRGTrONWBPg250,\ndiv[tabindex][role=\"region\"][aria-label] ~ div[data-max-width][class] + div[class^=\"_3_\"]",".banner_container",".brand",".cat-widget__adv-container,\n.cat-widget__card-wrap--adv,\n.entry-wrap-promo,\n.j-w-adv,\n.j-w-adv-content,\n.lj-recommended,\n[lj0sale0autoplay0dockable0video0mount],\na[href^=\"http://gpsavto.com.ua/\"][target=\"_self\"],\na[href^=\"http://kiwieducation.ru/\"],\ndiv[class][style^=\"height:\"][style*=\"background-color: black; position: relative;\"]:has([src*=\"docking\"][src*=\"eaglecdn\"])",".eplayer-time-to-ad","[id*=\"_R-A-\"]",".sidebar-custom",".customtext-widget",".content-inner > .entry-wrap > .disabledcomments,\n.sidebar-custom > dd > a[href] > [title],\n.sidebar-custom > dd > br",".j-w-customtext","[class*=\"kupibilet\"],\na[href*=\"offer\"][target=\"_blank\"]",".edwrap",".j-e-afterpost-randomsocial,\n.j-mainbanner",".mainpage__wrap-content div[class*=\"card\"]:has(> div > div[class*=\"empty\"] [id*=\"directive.id\"])",".j-promo-widget","a[class^=\"banne\"][href][target=\"_blank\"]","#ad_blocker_found",".textwidget > a[target=\"_blank\"] > img[src*=\"/wp-content/uploads/\"]","div[style^=\"promo\"]",".infotext,\n.view > div[align=\"center\"] > a,\nnav ~ a > img[align=\"right\"]","#ipbwrapper > table + #userlinks,\na[href=\"https://adblockplus.org/ru/faq_basics#disable\"]","iframe[src*=\"ad.adriver.ru\"]","#leoDiv",".article_end_banner,\n.content_top_banner,\n.widget-offers,\ncenter > a[href*=\"goo.gl\"] > img,\ndiv[id*=\"-gpt-\"]","#promo-app-ap,\n#subscribePopup,\n#top-candy,\n.ya-candy",".top_baner",".topad",".Here","#html-header > #obj",".adblock",".section-body > [itemprop=\"comment\"] ~ div[style=\"margin-bottom: 15px;\"],\na[href*=\"www/delivery/ck.php?\"],\ndiv[class*=\"revive\"],\ndiv[onclick*=\"Кликнул по рекламе\"]",".widget.indexcontent[style*=\"fixed\"],\ndiv[id^=\"sape_links\"]","#abnotify",".rew-block","div[id^=\"MeendoBrand\"]","a[href*=\"twnt.ru\"]","center > a[href][target=\"_blank\"] > img","div[id^=\"news_melodramo_ru\"]","div[class^=\"article-mvideo\"] > div[style^=\"background:\"]","a[href*=\"vsemayki.ru\"]","#jma",".adsDesktop","div[style=\"min-height: 300px;\"]",".commercical_wrap",".zen-popup-component","#promo",".bannerhead,\n.seoquake-nofollow","#smart_banner,\n.custom-height-250","#right_informer,\n.fb-window-wrap,\na[href^=\"https://iqoption.com/promo/\"]",".rekblok","#bb",".td-ss-main-sidebar","div[class^=\"frik\"]","#ad_global_below_navbar",".integration--advert,\n.main-feed > [class*=\"-block\"]:has(> div .integration),\n.navmenu__advert,\ndiv[class*=\"banner-wrapper\"]",".all_bet_block",".one-news__content-banner,\n.shares-wrap > .container > .swiper-pagination,\n.swiper-wrapper > a:not([href*=\"moniheal.com/\"]),\na:not([href*=\"moniheal.com/\"]) > img[src*=\"/m-public/\"]",".bottom_banner",".ms-article-content > div[style^=\"overflow: hidden; padding-top:\"],\n.ms-side-items--with-banner","[id^=\"slider\"][id*=\"ontent\"] span.right","#fly_mozg","#lay.lay","iframe[src^=\"https://www.mp4upload.com/\"][src$=\".html\"]",".p-md.text-center.ibox-content:nth-of-type(2)",".pic","a[href*=\"aHR0c\"]","div[class*=\"simplemodal\"]",".mainb > .main_block:has(> #slides > #reklama)","body > .overlay[style=\"display: block;\"]",".g-single","[src*=\"//rutube.ru/play/embed/\"],\ndiv[style=\"position:relative; width:600px; height:350px\"]",".pos-market","#top_banner",".ban-popup,\n.ban-right,\nimg[src^=\"/ban/\"]","div[id^=\"rek\"][style]","a[href^=\"https://nashvancouver.com/linkout/\"] > img[alt=\"tree\"]","#cmsg","div[class^=\"rblok\"]",".subscribe","a[href^=\"//?type=\"],\na[href^=\"/a_\"]",".head-block","#channelsFeed > [data-block-type=\"channel-card\"] ~ :not([data-block-type=\"channel-card\"]),\n[data-block-type=\"ads\"]",".td_only_right td[height=\"300\"]",".body-page-right-column > div[align=\"center\"],\ndiv[class*=\"prm\"]",".areplacer,\ndiv[style=\"float: left; width: 728px; height: 90px; background: #313131;\"]","div[style*=\"920px;\"][style*=\"250px;\"]",".RhooBg,\n.modalRhoo","#header-wrapper noindex > a[href][target=\"_blank\"],\n.important-news-block ul > li > noindex",".ad_728_90_page","#bottom_banner",".alert",".clauses_block_rel .panel:has([href*=\"dex.browser\"]),\n.slides,\na[href][rel=\"noopener noreferrer\"][title=\"Скачать\"],\ndiv:has(> div > [href*=\"dex.browser\"])","div[class$=\" \"][style=\"display: inherit ;\"]","div[class^=\"reklama\"]","div[style=\"float: none; margin:0px;\"]","div[id^=\"nazar\"]",".widget_text:has(> .textwidget > #mt_promo_wghot)","#toplink > h3[style=\"color: red\"]","td[width=\"2\"] + .slink[align=\"center\"] > :not(#dle-content)","a[href^=\"http://mnogoskidok.kiev.ua/\"]","div[id^=\"bablo_\"]",".googleBanner,\n.headerBiding,\n.newsFull_textEmptyBlock",".videoOfDay","[class*=\"banner\"]",".splide__list > .splide__slide:has(> article > .banner)",".yad","img[src=\"/download.png\"]","[href*=\"=ogemorroe.com\"],\ndiv[id^=\"webapteka_\"]",".b-mask",".rek_ban a[href]:not([href^=\"https://okaygorod.com/\"])","#oms_center_block div[id][style*=\"text-align:\"] > a,\n[onclick^=\"oms_zz_\"],\nimg[style^=\"display:block\"][style*=\"width:100%\"]",".adleft","#pegination ~ a,\n.pegination ~ a",".gallery-full > p,\nbody [class^=\"mdp-deblocker-\"],\ndiv[style^=\"min-height:\"][style$=\"px;\"]",".post-single-content div[style^=\"padding:\"][style*=\"40px\"],\n.single_post > div[style^=\"height:\"][style*=\"weight:\"]","#advLeftZone","div[id^=\"lbx_\"]",".review-body > div,\na[href*=\"/buy/\"][rel=\"nofollow\"],\ntr:has(> td > noindex > div > [href*=\"://yabs.yandex.ru/\"])","div[class^=\"goog\"]",".overheader","a[href^=\"http://go-anonym.ru\"]",".blok1,\n.content .custom-block",".header td[align=\"right\"] > a,\ndiv > .mainmenu:has(> a[href*=\"pornolavka.pw\"])","#sdv_branding,\n.articles_list_inner > div:has(> .sdv-box),\n.bar_bnr_wrap,\n.sdv-box,\n.sdv_article_sidebar_inner,\n.sdv_item,\n.sdv_promo_article,\n.sdv_sitebar_wrap,\n.top_banner_box,\n.ulogin_auth,\nbody > .article_item_container","body > div[id]:not([class])[style=\"display: block;\"]","div > [src] + [id] + [class][style^=\"display: block;\"]",".b-stella","#content > div[id^=\"mx\"],\n#left_block > div:not([id]):not([class])","div[style=\"position:absolute;width:100%;text-align:center;height:90px;top:10px;left:0\"]",".adBlocked","div:has(> [src*=\"pagead2.\"]),\ndiv[id^=\"sidebar\"] div[id^=\"sidebar\"]:has(div > [src*=\"pagead2.\"])",".app > div ~ div > a[target=\"_blank\"] > img","[gnezdo_container_id]","#alert-wrap",".sidebox:has(> div[id^=\"bn_\"])","div[id^=\"bn_\"]","div[class*=\"ScreenBanner\"]","iframe[src=\"/site/in\"]","a[href=\"http://net-well.ru/\"]","body > div[style*=\"z-index\"][style*=\"background\"]","[onclick*=\"cashalot.su\"]","a[href^=\"http://cashalot.su\"]",".right-side > .sticky","body > div[style^=\"width: 100%; height: auto; position: absolute; z-index: 100000; top: 0px; bottom: 0px; cursor: pointer; background: url\"]","#download,\n#download + div[style*=\"text\"]","img[src*=\"/img/wizard.\"]","div[style=\"text-align:center;  border-radius:7px; width:160px;  border:1px solid #666666;  margin-left:5px;padding-right:5px;color:#FFF;  background-color:#666;font-family:Maven Pro,century gothic, arial, helvetica, sans serif;padding-top:94px;  height:600px;  padding-left:5px; font-size:18px; \"]","#bannerHolder",".mv-advert-position__pause",".content-reclame,\n.sidebar-reclame,\n.similar-news",".social-button--yandexzen","a[href*=\"/dzen/\"]",".creatividad",".animate > .day-expectations","a[href*=\"got.by\"]","#commercial_ad_showthread_firstpost,\n.banners_navbar_below","a[href^=\"http://lentainform.com/\"]",".mainContent > #Notices","img[src*=\"img/adw/\"]",".blocksubhead.righttb + a[style^=\"z-index:1000;\"]","#ad-medrec__first,\n#pons-ad-leaderboard","noindex > a[target=\"_blank\"] > img","#abAlert,\n#headerUpgradePremiumBtn,\ndiv[id^=\"age\"][id*=\"erification\"]",".spots-wrap,\n.video-spots-col",".avr-wrapper","a[href][target=\"_blank\"]","#c7b82880e,\n#cab741974,\na[target=\"_blank\"] + br, a[target=\"_blank\"] + hr,\nimg[width=\"250\"][height=\"250\"]",".entry-content > .textwidget","img[width=\"728px\"][height=\"90px\"]","#po-vips",".avyes,\n.mixma","#kt_player > a[target]","body > .wrap",".entry-content > table[border]",".blockSns",".sidebar-widgets-1 > div[id^=\"codewidget-\"] ~ .widget_text:not(:last-child),\nfigure.wp-block-image","#atlas_240x400,\n#branding_click,\n#overlaybranding,\n.adv_advmusic,\n.js-core_branding,\n.magig_conteiner,\n.yandexmusic","div[id*=\"bunner\"]",".fasc-button,\na[href^=\"http://jmp1.ru/\"],\ndiv[id^=\"pg-aa-ad\"]",".widget.widget_text",".block_links","a[href*=\"://s.zbanx.com/r/\"]",".sidebar-a330-content",".h_right_center > noindex > a[href]","#psm-messenger-subscribe-popup,\n.dynbaner","#posts > .postbitim[style^=\"height\"]","#mytest,\n.recomendation-feed-bottom,\ndiv[class^=\"td-\"][class*=\"-rec \"]","div[class^=\"radio_ads_\"]",".goo_gle","div[class^=\"reclama_\"]",".notifyjs-corner",".ytp-ad-progress-list,\ndiv[id^=\"MarketGid\"]",".right_column > noindex","body > div[style*=\"2000\"]","tr[onclick*=\"blablacar\"]",".HTML:has(> .widget-content > .adsbygoogle)","#norris-detector,\n.game-description-text a[class][href][target=\"_blank\"]:not([href^=\"/\"]):not([href^=\"https://rbkgames.com/\"]),\n.poster-grid-item > a[target=\"_blank\"]:first-child ~ a[target=\"_blank\"]",".sm-widget",".stickblock",".b-informers","#as_131,\n#slidePanelContainerAB,\n.qb",".banner-holder",".nerban",".hvosting,\nimg[src=\"/img/locked.png\"]","#screen_block","a[target=\"_blank\"] > img[src^=\"/\"]",".js-newAutoSearchItemInformer",".bout-bets","#pologo-article,\n.br-new,\nbody > [class^=\"side-url-\"],\ndiv[id^=\"citybattleslide\"]","#id-custom_banner,\n#login-form + .tdc-zone > .tdc_zone > div[class^=\"tdi_\"][class*=\"_rand_style\"] + .tdc-row > .tdc-row-content-vert-center,\n.rn-widget,\n.td-a-ad,\n.td-a-rec,\n.td-is-sticky > .wpb_wrapper > div:has(.td-a-rec),\n.td-is-sticky > .wpb_wrapper > div:has(.wpb_wrapper:empty),\n[swg-standard-button=\"contribution\"],\nbody > div[style^=\"position: fixed; display: flow-root; z-index:\"],\ncenter > a[href][target=\"_blank\"] img,\ndiv[class^=\"td-header\"] .td-stretch-content","a[href*=\"aff_c?offer_id\"]",".rad",".content > div[style=\"width:100%; text-align: center;\"],\n.content table[height=\"250\"]","#offers,\n#today-media-article,\n.Mirtesen-root,\n.column__row_article-page_right:empty,\n.external-widget,\n.follows-channel_djen,\n.hide--partner--block,\n.listing_partners-news,\n.right-column > .aside-block:has(script),\nbody > div[class^=\"Popup-\"]",".topbanner","[href^=\"postings.cgi?action=edit&forum=5&topic=51141\"]:not([href$=\"postno=1\"]) ~ .post img:not([src*=\"://forum.ru-board.com/board/\"]),\ntd:not([class=\"lgf\"]) > table[width][cellpadding][bordercolor=\"#EEEEEE\"][border=\"1\"][bgcolor=\"#FFFFFF\"]:not([width$=\"%\"])",".g","a[href*=\"/reklama/\"]","*:has(> a[href*=\"prostitutkixxx\"])","span[onclick]:not([onclick*=\"ruinformer\"]) > img[src*=\"banner\"]",".rkl","#logo > noindex,\n.sb > a > img[src^=\"http://rupier.com/forum/\"]","#footer_wrap,\n#sideRight > .box ~ div","body > form > a[target=\"_blank\"],\nbody > span > form > a[target=\"_blank\"]",".classblsi.addshr",".bann",".nobr,\na[href][target=\"_blank\"] > img[src*=\"/-=Banners=-/\"]",".L,\n.R",".post_body center > a[target=\"_blank\"],\ndiv[id^=\"jetta\"]",".forum_buttons","#topbanner",".bp",".html5-bp",".sakhui-b","a[target=\"_blank\"] > img[width=\"240\"]",".main-col > .mom_box_sc,\n.main-sidebar > .mom_custom_text ~ .mom_custom_text,\n.secondary-sidebar > .mom_custom_text,\ndiv:has(> .mom-ads-wrap),\nimg[src*=\"/SAV_banners/\"]","a[href^=\"goto.php\"] > img[src^=\"bae/\"],\ndiv[id*=\"nu_ban\"]",".slider-wrapper","body > div[style*=\"2147483647\"]","a[href$=\".php\"]",".zen_box",".baners",".items-list > noindex",".top_a","img[alt=\"adblock\"]","body > div[class]:not([id])[style^=\"background-color\"][style*=\"z-index:\"]",".col-main > h2[style=\"margin-top: 30px;\"]",".theiaStickySidebar","#ll_slot_3 + * + div[style*=\"160px;\"],\n.gray > center > div[style*=\"125px;\"],\ncenter > div[style*=\"200px;\"],\ndiv[style=\"width:100%;text-align:center;\"] > center",".b-adv-micro,\n.b-bks,\n.b-instaforex,\n.b-top-adv,\na[class*=\"b-menu__li__a-\"]","[onclick*=\"btsearch.me\"]","[onclick*=\"goo.gl\"]",".edina > a[href=\"http://monstro-beats.com/\"]",".sprite-14 + * > hr + table[align=\"center\"]","div[class^=\"adverser\"]",".ban__wrapper,\n.single__right > .right__title",".banner_wrp","#yandexBanner",".block-relap,\n.block-superwidget,\ndiv[id^=\"blockad\"]","div[id^=\"yandex_direct\"]","a[href^=\"/bitrix/rk.php\"][href*=\"banner\"]",".navbar > br,\n.navbar > center",".gc-question-ads-2,\n.rkl-horizontal,\ndiv[style=\"width:336px; height:280px;\"]",".content-block > div[style^=\"background\"],\n.main-center-block > div[style^=\"background\"],\na[href*=\"azbukasofta.xyz\"]","#divAffLink,\n#smart-aff-link-table,\n.TblOBan,\n.btn-download > .submit-spinner,\n.cardPageDescMain > div[id][style],\n.contentWrap > .st-browser__page ~ div[id][style],\n.st-browser__timer,\n.yablock,\na[href*=\"driverpack-solution\"],\na[href^=\"prog\"][target=\"_blank\"],\na[href^=\"prog\"][target=\"_blank\"] ~ *","a[class*=\"-banner-\"]",".display_natural",".helkamaAnimeGoogle,\n.vjs-overlay-background,\n[class^=\"sbrand--\"]",".whitelist","#bannersPlayer",".toppad","#sidebar > .block-title,\n#sidebar > .textwidget,\n#sidebar > .widget_text,\n.advertisment-events,\n.bookrating,\na[href=\"https://sportarena.com/betting/\"],\na[href=\"https://sportarena.com/bookmakers/\"],\na[href=\"https://sportarena.com/uk/rejting-bukmekeriv/\"],\nbody > #fb-root,\nbody > .nomobile","div[id^=\"branding\"]","a[href*=\".ashx?\"]","a[href*=\"/1xstavka\"]","a[href*=\"/c.php?\"],\na[href*=\"://sportliga.com/bookmakers/\"] ~ a,\ndiv[class^=\"bulletin\"]","#embed .MuiButton-containedPrimary,\n#player .MuiButton-containedPrimary","#slot_central,\nnav > .items > a[href]:not([href^=\"/\"]):not([href^=\"https://sprashivalka.com/\"])","div[id*=\"_R-\"]",".tp-overlay",".ououou",".topic-actions + .clear + .post.bg2 + .divider + .post.bg3","table:first-child + .tablebg + .tablebg + .tablebg,\ntable:first-child + .tablebg + .tablebg + br + .tablebg","#bonga-bottom-banner,\n#tablespons","#fixblock","a[href]:not([href^=\"http://taobao-forum.com/\"]) > img[src^=\"/banner/\"]","#banners",".ads-horiz,\n.disable-adblock",".add",".main-container-wrap > div[class$=\"-bg\"],\n.main-container-wrap > div[id][class][style*=\"opacity\"]","#sabl",".jeg_deals",".tdsAd",".xoxo.blogroll","div[class^=\"remodal\"]","a[href^=\"https://www.facebook.com/republicplatte/\"]","body > div[style*=\"background-color:\"][style*=\"z-index:\"]",".right.col > div[style^=\"min-height\"],\n.right.col > div[style^=\"width:300px;\"]","[data-slick*=\"autoplay\"]",".alignnone[width=\"300\"][height=\"300\"]",".posts-sidebar,\n.pseudosidebar,\n.row-banner-top","#header-right-section",".RightColumn .Content > a",".stamp_main ~ .item","#guseff_top,\n#ipsLayout_contentWrapper > div[style*=\"min-height:\"],\n#ipsLayout_sidebar .ipsBox:has(> .adsbygoogle),\n#ipsLayout_sidebar .ipsBox:has(> [id^=\"yandex_rtb\"]),\n#ipsLayout_sidebar .ipsBox:has([href][target^=\"_blan\"] > img[src*=\"/gra/\"]),\n.cPost + script + center,\n.gusev,\ndiv:not([id]):not([class])[style^=\"min-height:\"]",".full_pict1 > center,\nbig,\ndiv[style=\"width:100%; height:275px; display:block\"],\ndiv[style=\"width:100%; height:310px; display:block\"],\ndiv[style=\"width:336px; height:280px; display:block\"]",".sticky-block",".dfp-slot",":not(this-site-promotes-malware)",".header-partnership,\ntor-banner-ads,\ntor-banner-block",".logo + div","a[href^=\"/\"][href*=\".php\"][target]","a[href*=\"vk.cc\"]","center > b:nth-of-type(3),\ncenter > table[bgcolor=\"CC0099\"],\ntd[valign=\"top\"] > noindex",".banners_img","a[href*=\"/bet/\"],\na[href*=\"/betting/\"],\ndiv[class*=\"rb-widget\"],\ndiv[class^=\"BookmakerGift_bookmaker-gift_\"],\ndiv[class^=\"Main_main-layout__empty-block\"]","#branding-head-link,\n#reklama_banner,\n.overvideo",".banner-systems-container",".content_player > noindex > noindex","header > nav ~ div,\niframe[src^=\"/\"][style*=\"overflow:\"],\nul[class*=\"file-download\"] + div[class*=\" \"]","body > .mask","#sideRight > div[align=\"center\"] > a[href]","#content .metaslider,\ndiv[id^=\"banadd\"]",".asside:has(> .topBook),\n.bonuses,\n.buk-table,\n.header-bonus,\n.topBook","a[href*=\"/betting\"]",".textwidget","[data-element_type=\"widget\"] a[rel=\"nofollow\"]","a[href*=\"li.ru/go?\"]","body > center:first-of-type",".information__image,\n.js-sidebar > .pst-block > .textwidget:first-of-type,\n.js-sidebar > .pst-block > a[target=\"_blank\"],\n.main-content > div[class*=\" vc_row-fluid vc_custom_\"]:nth-child(-1n+2),\n.sbr-slider > .pst-block > .pst-block-head","a[href^=\"http://babnik.com/\"],\na[href^=\"http://bongacash.com/\"],\na[href^=\"http://cashtube.ru/\"],\na[href^=\"http://costaction.com/\"],\na[href^=\"http://df.halileo.com/\"],\nstrong > span[style=\"color:red\"]","a[href^=\"http://bongacams.com/\"]","#di356 > div[style^=\"text-align: center\"],\na[href^=\"http://sexkompas.xyz/\"],\nnoindex > a > img","a[target=\"_blank\"][href=\"http://www.mshop.in.ua/\"]",".article > noindex","div[class^=\"ad-\"]",".sidebar > .widget:nth-child(-1n+4) > .widget-content div[style=\"text-align: center;\"] > a[href]","td[width=\"33%\"]","#topnews",".banner-unit",".news_view > a[href][rel=\"nofollow\"][target=\"_blank\"] > img,\n.search_bar ~ .padd","#sidebar > div[class]:last-child,\n.tiles_wrapper > .js-file_item ~ div:not([class*=\"tiled\"])","#siteContent > div:not([id]):not([class]) ~ div[class]",".banners-list__items,\n.single-sidebar__banners",".distr-vidget-block",".sidebar > .widget_text",".main_content > noindex,\n.peretyajka",".viboom-overroll","td > .bc[align=\"center\"]",".ad ~ noindex","#adblockpopup","aside > a[href][target=\"_blank\"]","#brand-adv-left,\n#brand-adv-right,\n.banners-right",".randid","[style^=\"position: absolute; width: 100%;\"]",".link_image,\n.link_img,\ndiv[id^=\"block-views-advert_\"]",".custom-block","#popup_block","#ads_left,\n#feed_rows > div[class^=\"feed_row\"]:has(> .page_block .adaptive_ad),\n#feed_rows > div[class^=\"feed_row\"]:has(> .page_block [class*=\"_noClick\"]),\n#feed_rows > div[class^=\"feed_row\"]:has(> .page_block [data-role=\"adChoicesMenu\"]),\n#feed_rows > div[class^=\"feed_row\"]:has(> .page_block div[data-role=\"advertisinglabel\"]),\n#feed_rows > div[class^=\"feed_row\"]:has(> [id^=\"post-\"] > ._post_content .PostHeader > .PostHeaderInfo > [class^=\"PostHeaderSubtitle\"] > span [class] ~ [class] ~ [class] ~ [class] ~ [class] ~ [class] ~ [class] ~ [class] ~ [class] ~ [class] ~ [class] ~ [class] ~ [class]),\n#feed_rows > div[class^=\"feed_row\"]:has(> [id^=\"post-\"] > ._post_content .PostHeader > .PostHeaderInfo [onclick*=\"ads_params:\"]),\n#feed_rows > div[class^=\"feed_row\"]:has(> [id^=\"post-\"] > ._post_content .PostHeader > .PostHeaderInfo [onmouseover*=\"AdsLight\"]),\n#feed_rows > div[class^=\"feed_row\"]:has(> [id^=\"post-\"] > ._post_content .PostHeader > .PostHeaderInfo span.PostHeaderSubtitle__item [class] [class] [class]),\n#feed_rows > div[class^=\"feed_row\"]:has(> [id^=\"post-\"] > ._post_content .post_header_info [onmouseover*=\"AdsLight\"]),\n#page_wall_posts > div[id^=\"post-\"]:has(.wall_marked_as_ads),\n#wk_content > #wl_post > div:has(.wall_marked_as_ads),\n._ads_block_data_w,\n.post_marked_as_ads,\n.wall_wrap div[id^=\"post-\"]:has(.post_content > .post_info > .wall_text > .wall_post_cont > .wall_marked_as_ads),\n[data-ad-block-uid],\ndiv[adchoiceview],\ndiv[class^=\"feed_row \"] > div[id^=\"feed_repost-\"]:has(.wall_marked_as_ads),\ndiv[class^=\"feed_row \"] > div[id^=\"post-\"]:has(.wall_marked_as_ads),\ndiv[data-ad-view],\ndiv[data-ad],\ndiv[id^=\"post-\"][onmousedown^=\"wall.postClickStat(event)\"],\ndiv[id^=\"spostadsite_\"]","#chrome_bar_content,\n.EcommFeedItemsBlock,\n._ads_promoted_post_data_w,\n.ads_ads_box,\n.ads_ads_news_wrap,\naside[aria-label=\"Актуальные новости\"]","div[data-ads]",".wi_head[href*=\"/away.php?to=\"],\n.wi_head[href*=\"/away.php?to=\"] + .wi_body","#js-slider-1,\n.jsx",".direct",".soa",".colLeft","#shapka-blk,\n.blogbody:has([href*=\"utm_\"]),\n.comments-head,\n.neteye-posts,\na[href*=\"feipiter.\"]",".wsite-image-border-thin > a[target=\"_blank\"]","#adriver_ClickArea,\n.home_Advert","#head-content,\n.widget_calendar ~ .widget_text ~ .widget_text","[class^=\"view_back\"]","#layout-center > a[target]",".items:has(> .item-card [src*=\"/images/pek.png\"]),\n.items:has(> .item-card script)",".zzz",".all_news_partners,\n.everlast,\n.nmGoods","a[href*=\"favbet\"][target=\"_blank\"]",".ABD_display_wrapper,\n.a111,\n[align=\"center\"] > a[href][target=\"_blank\"]","#adv_top2","div[id^=\"main_banner\"]",".ban200,\n.topban",".item-content:has(> .title > a[href*=\"//zen.yandex.ru/\"]),\n.rca-block","a[href*=\"myprintbar.ru\"]",".block-bets,\n.top-menu-fonbet,\na[href*=\"olimp.bet\"]:not([href*=\"logo_footer\"]),\nbody.home > [class*=\"modal\"]","#adsWall-0,\n#adsWall-1","#hidemead",".abs_row","#hbanner,\n.adsb,\n.sidebar > .dcont","#topbar","#contribute_footer,\ndiv[class^=\"wh_ad_\"]",".sidebar > .flying","#leftmenu > noindex",".ds-down,\n.yaoffer","#custom_html-6","#brend","#header-wrapper","[class^=\"adv_first\"]","div[class*=\"advert\"]","#ads_warning",".block-bgimg,\n.header-nav-wowhead-premium,\n.is-atf.horizontal-bg,\n.is-atf.vertical-bg,\n.is-btf.horizontal-bg,\n.premium-promo-row,\n.type-coupon-codes,\ndiv[id^=\"announcement\"]",".marketWidgetWrapper,\n.stick-promo--container","div[style*=\"710px;\"][style*=\"70px;\"]","#sideLeft > .left ~ *","#video-right,\n.thumb-ad,\ndiv[id^=\"ad-footer\"]",".header2 > .header","div[style*=\"-ad-bg-\"]","table > tbody > tr","#header-flash,\n#main-menu > a[href*=\"://yoy.so\"],\n#top-line > div > a[href][onclick*=\"open_popup\"],\n.__axcode__,\n.lenta > tbody > tr:has(> .newshead > div > .mainpage > a[href*=\"utm_campai\"]),\n.lenta > tbody > tr:has(> .newshead > div > .mainpage > a[href*=\"utm_campai\"]) + tr,\n.lenta > tbody > tr:has(> .newshead > div > .mainpage > a[href*=\"utm_campai\"]) + tr + tr,\n.lenta > tbody > tr:has(> .newshead > div > .mainpage:first-child),\n.lenta > tbody > tr:has(> .newshead > div > .mainpage:first-child) + tr,\n.lenta > tbody > tr:has(> .newshead > div > .mainpage:first-child) + tr + tr,\n.no-compress > a[href*=\"yaplakal.com/go/\"],\na[href^=\"http://www.yaplakal.com/adv/\"],\na[href^=\"http://www.yaplakal.com/go/\"],\na[target=\"_blank\"][href*=\"/click/?http\"],\nbody > a[id^=\"clk-\"],\ntr > td[align=\"center\"][id^=\"in-feed\"][style*=\"important\"]","#top-line > .pop-up",".noadb","div[class^=\"_5\"]","[itemtype=\"https://schema.org/WPAdBlock\"]","#contents > ytd-rich-item-renderer:has(> #content > ytd-display-ad-renderer),\n#movie_player > .ytp-cards-teaser,\n#offer-module,\n#savefrom__yt_btn a.sf-menu-item[href=\"#\"],\n.annotation.iv-promo,\n.video-annotations .annotation-type-text","aside > a > img","body > div[align=\"center\"]",".best_game_sec",".eldala_widget,\n.rcl-label",".branding_place",".adsense_anchor_ads","#test,\n#warning,\n.baseer > .heading,\n.block.elite,\n.title_spoiler",".pub-box,\ndiv[class$=\"-ads\"],\nfigure",".brn-ads-box,\n.brn-blocker-box","#wrap > .navbar,\n[title=\"Yandex Direct\"]",".inner__ads","#sp-right > .sp-inner > .module:has([id*=\"ScriptRoot\"]),\n#sp-right > .sp-inner > .module:has([onerror])",".bannergroupr-nostyle,\n.sweet-alert, .sweet-overlay",".container:has(> .remove-sda-wrap),\n.page-wrapper .last-news ~ .container > .information,\n.remove-sda-wrap","a[href^=\"http://antenna-su.ru/\"],\na[href^=\"http://quad.ru/\"],\na[href^=\"http://radial.ru/\"]",".sidebar","[style*=\"cursor: no-drop;\"]",".yapr","#testVideo,\n.oi_papa_oi,\na[href*=\"&brid=\"],\nbody > * > div[style^=\"padding-top\"],\nbody > a[onclick],\nbody > div:not([id]):not([class]):not([style]),\nbody > span:nth-child(-1n+6)","body > a",".ads-inner-top",".bannerblock","#sidebar-right img,\n.slide_anons,\na[target=\"_blank\"] > img[src^=\"http://lib.rus.ec/sites/default/files/\"]","#ab--notification-ribbon,\n#delfiTopBar,\n.C-ad-block-layer,\n.C-banner,\n.ad-container,\na[href^=\"http://ap.delfi.ee/b?\"]","a[class^=\"alex_bnr_\"]",".cookie-paywall-visible .cookie-paywall",".tp_rightblock_noframe [width=\"336\"][height=\"240\"]",".block-outer a[href][rel=\"nofollow\"]","#text-7.widget","div[data-uk-slideshow]","#agbordid,\n.agbordfull",".div-download-h,\n.div-download-v",".home .td-pb-row:has(> .wpb_column:only-child .wpb_wrapper > .td-a-rec),\n.home .vc_row > .vc_column:has(> .wpb_wrapper > .td-a-rec)",".zbin","img.pleer",".contribute-modal","#main_right_col > .section:not(.section_blogs),\n.top-promo","#ruslife-banner,\n.mod_bannerslider,\n.module-banner",".b-r",".desktop-context > div[class*=\"_cover_\"],\ndiv[class^=\"stories_container\"] > div[class^=\"stories_story\"]:has(> [class^=\"stories_story_banner\"])","div[class^=\"advertisement\"]","#header > .container > div[style=\"padding-top:20px;\"]","#container + center,\na[href] > img[src*=\"/images/et\"]","div[id^=\"centered\"]","div[class$=\"_ushki\"],\niframe[src*=\"banners.php\"],\ntd[style=\"width:180px; padding-left: 15px;\"] > table:last-child","div:has(> a[href]:not([href^=\"/films/\"]):not([href^=\"/serials/\"]) > div)",".fw.topbanner,\n.rightbanner_in","#dle-content > .well,\n.row .panel-danger",".gazprom-top,\ndiv[class^=\"banner\"]:not(#vk_groups)","#bannerborder","#fb-popup-bg,\n.hfm-right-content > .hfm-block[style]","#center-left > aside > section,\n#center_left > .informer,\n#toolsbar,\n.branners,\n.norkos,\n.trongds,\n:not(#dle-content) > .shortstory:has(> a > div > .advs-label),\ndiv[class^=\"bp_\"][class*=\"-block\"]","#partner-block","app-adv-placeholder,\napp-adv-video-placeholder",".partner-recomendation",".b-ad-space__placeholder,\n.b-pb-frontpage__240x400-banner,\n.i-layout__branding-link,\n.i-layout__top-leaderboard-banner,\n.smi2-news-container",".ad-branding-block,\ndiv[class*=\"-branding-\"] > a[target=\"_blank\"]","#sveta__muzika-banner,\n.playOther,\na[href*=\"/zvuk_transfer?\"]",".r2016,\ndiv[data-element-id]",".col_1 > .block2","div[id^=\"DIV_DA\"]","#sidebar > a[href][target=\"_blank\"],\n.sponsor a[href][target=\"_blank\"]","div[class^=\"block-banner-\"]","#article_feeds .title-comments,\n#article_feeds > .row:has(> div > a[href*=\"yandex.\"][href*=\"news\"][href*=\"favid\"]),\n.block-sticky > div[style^=\"min-height:\"],\nbody > .container > div[style^=\"min-height:\"]","#min-banners-block,\na#bg",".sidebar-banner","#adv-list-top",".ad-banner","#top_error_notify,\n.bannersIframe",".adv_big","div[id^=\"detection-block\"]",".no_block","#msgUser","[id^=\"padb_widget_\"]","#adb-pop",".alert-dashed",".article-aside-promo a[href][target=\"_blank\"],\n.flex-promo-series > .left-col > :not(#players):not(.serial-series-info),\n.flex-promo-series > .right-col a[href][target=\"_blank\"]","#TopAdMb,\ndiv[class^=\"topAd\"]",".page-subscribe",".vk_show,\ndiv[id*=\"-error-page\"] + div,\ndiv[id*=\"-error-page\"] > *","#myShowBlock1,\n#s-side,\n.tiznews",".full-page > noindex",".hdsd",".menu > li.top_menu ~ li:not(.top_menu),\n.war_item:has(> .war_img > a[href*=\"exaccess\"]),\na[href*=\"exaccess\"],\ndiv[style=\"background: #a94442;padding: 5px;font-size: 16px;\"]","noindex [style^=\"display\"][style*=\"block\"]",".footer-first-widgets-section,\n.footer-second-widgets-section > section > .widget_text,\n.widget_text:has(#kwork-widget)","a[href*=\"/yand.\"],\na[href*=\"sub/\"] img","center > a[href][rel=\"nofollow\"] > img","#alert > #overlay,\n.baz,\n.infopanel_left,\ndiv[class^=\"banaces\"]","table[id^=\"ad-\"]","a[href^=\"http://thisclick.\"]",".side_block > .side_header:empty,\na[href*=\"zenyandexru\"]",".exitblock",".rb_new","div[class]:has(> div[id][align=\"center\"])","#zhiviprosto",".mmm,\ndiv[class*=\"plashque\"],\nmain > .main__block:has(> [src*=\"https://rutube.ru/\"])","[class*=\"rekl\"]",".strip_only_desk,\ndiv[class=\"content_group i_frame\"]","#cmp-iframe,\ndiv[data-dest=\"placeholder\"]",".elementor-column-gap-extended > .elementor-row > .elementor-hidden-phone","div[id^=\"ban\"]","div[class^=\"HP_\"],\ndiv[id^=\"section_\"]","#menubar > div[style^=\"float:\"],\n.quote > .text:first-child,\n.quote > div[style]",".carcar",".sponsor-thread",".adsplaser_pro_abtest",".friend_links",".content-images,\n.image-side,\nimg[src^=\"data:image\"]","body > :not([id]):not([class]):not(script)",".p-body-pageContent center > [href^=\"https://t.me/\"] > img","div[align=\"center\"] > a[href][target=\"_blank\"]","td > .postbody ~ div[style=\"margin:10px 40px;\"]","iframe[src*=\"/assets/rkl/\"]","article > a[href][target=\"_blank\"]","#footer > .row-fluid > div[style=\"padding-top: 10px; float:left;\"]",".bbody > noindex",".articleContent > p:has(> span + strong[style]),\n.articleContent > p[style=\"display: block!important; text-align: center;\"],\n.buy-game","#adslinks,\ndiv[class^=\"bannerzone\"]","a[href][target=\"_blank\"][rel*=\"noopener\"] > img",".banner-block",".banner-item","[class*=\"blog-holder\"] > noindex","[src*=\"banners/\"]","#topbanners",".adredirector",".newsbox-outer-banner","#dclaim,\n.dialog-fog","#upg-banner","a[href*=\"mnogoskidok.kiev.ua\"]",".adsbyskyline",".widget_mpslwidget",".g1-injected-unit",".bci-ad ~ p","div[id^=\"mdl_ctnr_\"]","#informer","tr[height=\"250px\"]","img[src*=\"chexov.info/images/banners/\"]",".top_links","img[src*=\"://cxid.info/bcx/\"]","#openModal","div[id$=\"_ad\"]",".blue-bann,\n.slideshowbg",".cont > noindex,\n.leftcol > noindex,\na[href*=\"/search?\"][href*=\"pid=\"]","div[style*=\"339px;\"]",".main_ad728x90,\n.sid_ad300x250 > a[href][target=\"_blank\"]","#top-random-banner,\nfigure > div > img[src*=\"/var-min.jpg\"]",".partner-news","#outer > #third","table > tbody > tr > td[valign=\"top\"][align=\"left\"][width=\"200\"]",".remove_in_mobile,\ndiv.dating",".pg_content_nav > a[href][target=\"_blank\"]",".partner",".ads-overlay,\n.bet,\nbody > blockquote",".advertisement","#adb-aft-art,\n.native-ads,\n.rmgm","[onclick*=\"//zen.yandex.ru/\"]","#wrapcentre > div[align=\"center\"],\na[href*=\"tinyurl.com\"],\ndiv[id^=\"adsfoot\"],\ndiv[id^=\"res\"],\ntbody > tr > td[style*=\"vertical-align: top\"],\ntd > .tablebg[style^=\"background-color:\"]","a[href*=\"/ali.pub/\"]",".mob-banner",".preloadText","td.back td[style=\"height:215px\"]",".bnr-block,\n.loader:empty,\n.main-partners,\ndiv[class^=\"r\"][style^=\"height\"][style*=\"margin:\"],\ndiv[style=\"height: 400px\"]",".my-3","div[style*=\"height\"][style*=\"250px\"],\ndiv[style*=\"height\"][style*=\"260px\"]","div[style*=\"height\"][style*=\"270px\"],\ndiv[style*=\"height\"][style*=\"470px\"]",".client,\na[href*=\"/Na-pravah-reklamy/\"],\na[href^=\"/cms/admin/banner.php\"]",".adv_header",".block-block",".bgroup","#rightcolumn[valign=\"top\"] > div",".author-widget,\n.read-also__title,\n.sidebar > :not(.widget)","#podnovka ~ div[style],\n.sigo","#msg_pop",".content_rb",".widget_execphp","#AutoNumber1","a[target][href*=\"/go.php?url=\"] > img[src^=\"/\"]","div[id^=\"block-views-banner\"],\ndiv[id^=\"block-views-paid_place_slider-block\"]",".article_contentroll,\n.aside_item,\n.companyButton,\n.footer_apps,\n.gamma-zen,\n.onlineBlock,\na[href*=\"okko.\"],\ndiv[class*=\"-fix \"][class$=\"as-desktop\"],\ndiv[data-modules=\"banner\"]","a[href*=\"//wink.\"]","advertronic-slot",".side-box:has(> [id=\"div-gpt-ad-sidebar\"])",".second-message","body > [style^=\"z-index: 1000000; \"]","#related-posts-after .mag-box-title",".left-col.hidden-phone",".jptop","#neheraplper_9000 > a[href] > span,\na[title=\"LostFilm.INFO\"] > div[style*=\"height\"],\ndiv[id^=\"heraplper\"] > a[href]",".main-right > div:not([class])[style^=\"margin-bottom:20px\"]","#s\\(1\\),\n.owl-carousel,\naside img[src^=\"http://magtimes.info/wp-content/uploads/\"]",".b1",".td-g-rec","article[id^=\"post-\"] > .entry-meta + div[style^=\"padding-bottom:\"]",".source-link","div[id]:has(> wix-iframe),\nwix-iframe",".home-right-rk,\n.npt","#content > center","[class*=\"yandexzen\"]",".lt_bl,\n.megasale,\n.yamin,\n.yelobv4","a[href*=\"vott.ru\"]",".BigBlock",".tm-content ~ .tm-main-bottom .widget_custom_html:not([style]),\na[class^=\"branding-\"],\nimg[src*=\"/_img/ban/\"]","#content > .lenta",".sidebar > noindex",".tiserpc,\na[href*=\"/goto/\"][target]",".ad_260_px",".d-none:has(> .adsbygoogle),\n.page_content > .article_content ~ div[style^=\"width:\"],\n.sidebar > div[style^=\"width:\"],\ndiv[id^=\"tvfooter\"],\ndiv[style=\"display:none\"]","div[class*=\" min-h-\"]",".rotator","a > img[width=\"240\"][height=\"400\"]","div[id^=\"hitsadv\"]","div[style=\"text-align: center; margin: -18px 0 25px; \"]",".focus-ad,\n.mob","#modal.modal-bg","[src*=\"/storage/banner_upload/\"]","body > #page ~ *",".widget_hugeit_slider_widget",".vjs-inplayer-container","body > div[id][style=\"display: block;\"]",".wf_ads","[style*=\"line-height:1;\"][style$=\"font-size:8px;\"],\n[style*=\"line-height:1;\"][style$=\"font-size:8px;\"] ~ a[href][target=\"_blank\"]",".bnr-top,\na[href^=\"http://domzaton.ru/\"],\na[href^=\"http://www.alekseevskiy.astf.ru/\"],\na[href^=\"http://www.tigerltd.ru/\"]","a[href*=\"fastrader.ru\"]",".head_bann",".bg_header_right > .soft",".block-dark:has(script)",".col-right tbody > tr:has(.adsbygoogle),\n.col-right tbody > tr:has([id*=\"banner\"]),\n.col-right tbody > tr:has([id^=\"SRTB_\"]),\n.col-right tbody > tr:has([id^=\"yandex_rtb_\"]),\n.col-right tbody > tr:has([src*=\"/ads/\"]),\ndiv[id^=\"hme_ad_news\"]","noindex > table[width=\"200\"]",".js-site-top__banner","body > #promo-popup","div[style^=\"display:inline-block\"][style$=\"margin:0px 0px 12px 0px;\"],\niframe[data-src*=\"/reklama.\"]","#header > div[style^=\"text-align: center;\"]","[data-phpbb-ads-id]",".banner-topflash,\n.fr-banners-main,\n.st-allbanners,\na[target=\"_blank\"] > img[alt]","#news_bannerPlace,\n.banners_tmpl3",".media:not([style=\"padding:0;\"])","#mvp-leader-wrap,\ndiv[class^=\"angwp_\"]","#partners,\n#topBaner,\nobject[width=\"150\"][height=\"100\"]",".bodyline > div[style*=\"height:90px\"],\na[href*=\"/cl.php?b\"],\ndiv[class^=\"bnrb\"]","div[style]:has(> p > [href=\"#hideRekCaption\"])",".bg-logo-ads",".container > a[href*=\"utm_campai\"] ~ a[href][target=\"_blank\"]","a[href^=\"/go\"][href*=\".php\"][target=\"_blank\"],\ndiv[class*=\"transformer-form\"]","#rightcol > .module-outer1,\n#rightcol > .module-outertoppanel,\n#top45,\n#top6out,\ntable[style=\"height: 20px; width: 100%;\"]","#header_banner,\ndiv[class^=\"erid\"]",".gmp_widget",".readthis",".banner-container","section.countdown",".okadv__block,\n.okadvertisement",".top_banners","a[href^=\"//twogarin.info/goto/\"] > img[src*=\"/wp-content/\"]","a video",".sidebar-inner > .widget ~ .widget_text,\n.widget_super_rss_reader","#footer","a[href*=\"://www.wem.ua\"]",".module-social .module-social.hidden-xs,\n.module-top > .module-inner ~ *",".bnr-block__bnr,\n.newsfeed__banner,\ndiv[style=\"height:260px;clear:both;\"],\ndiv[style=\"height:600px\"]",".main_frame > div[style=\"float:left; width:245px; height:130px;\"]","#snsocial_modal_jic",".advertising-card","#vi_ad,\n#vi_adlink,\nbody > div[id^=\"headbr\"]","#content h3[style] > span[style^=\"color\"],\na[href*=\"grovieavtomati.vip\"]",".content-banner",".textwidget > noindex","#cboxOverlay","#colorbox",".modal-block-hide-twitch","a[href^=\"/bitrix/rk.php\"][target=\"_blank\"]",".right > .mblock > div","div[class^=\"vds-\"][class*=\"cloud\"]",".mm_widget,\n.popular","#unified-slider",".news > noindex","#advBox,\n.left-column center:has(> .adsbygoogle)",".cookies","img[src*=\"/banners/\"]",".ad-test-vpn,\n.consent__notice,\n.consent__notice ~ .body-blackout,\n.content-article p:has(> .adsbygoogle),\n.narrow-column > style ~ div > div:has(a[style^=\"color:\"]),\na[href*=\"://fineproxy.org\"],\na[href*=\"://finevpn.org\"],\na[href*=\"://hdmnm\"],\na[href*=\"://hidem\"],\na[href*=\"://proxyelite.info\"]","span > a[href][target=\"_blank\"][rel=\"nofollow\"]",".island:has(> .adsbygoogle),\n.island[style^=\"padding: 2rem 0;\"]","#ad_ctd,\n#cts_test,\nmain > ._bg-red",".App-bannerBottom,\n.App-bannerTop,\n.DFPBanner-root,\n.Layout-bannerTop",".cookie-dialog,\n.fm-dialog-overlay",".mfp-bg, .mfp-wrap","#trevda",".post_content.newsletter ~ .post_subscribe","div[class^=\"cookies-modal\"]",".top-xata > .content_wrapper",".placeholder-branding,\n.top-after-banner,\ndiv[class*=\"right-side-banner-\"]",".belta-informer,\ndiv[class*=\"top-banner\"] a[href][target=\"_blank\"]","div[class^=\"Banner\"]",".page-header__promo-btn[href*=\"/reklama/\"],\n[data-subscribe-zen],\n[data-without-height],\na[href^=\"https://advert.kp.ru\"],\nbody > #app [data-gtm-el=\"content-body\"] ~ div > div:has(> [data-subscribe-zen]),\nbody > #app div:has(> div:first-child + div > div:first-child > div:first-child + section > div > div > script[data-key]),\nbody > #app div:last-child:has(> div > div > div ~ section > div > [id^=\"unit_\"]),\nbody > #app div[class]:has(> a[draggable=\"false\"][href^=\"https://zen.yandex.ru/\"]),\ndiv[data-name]:not(.buttonContainer)","a[href^=\"https://zen.yandex.ru/\"]",".yandex-ad-container","#ads-full-screen,\n.nambafood,\n.xbet","#adhider,\n.recommended-wrap",".footer-add > a,\n.rek-widgets,\n.toprek,\n.yelrec","#player-blocker,\ndiv[class*=\"oops-\"]","#fb_bottom_like",".branding-link",".tradingview-widget-container","body > .preloader,\nbody > [id][class*=\" \"]:not([style])","#left-sidebar > .sidebar-chunk.mid:not(.strong),\n.article > .onadlable,\n.dc_promo,\n.vivo-wide,\na[title^=\"3DNews\"][title*=\"Дзен\"]",".ymarket-affiliate-widget",".fade[class*=\"modal\"]",".indent,\n.sbanner","[class*=\"widget_sp_image\"]",".block[id*=\"-banners-\"]",".elementor-image > a[href]:not([href^=\"/\"]):not([href^=\"https://alau.kz/\"])[target=\"_blank\"],\nimg[src*=\"/banner\"][src*=\".gif\"]",".columnBanner",".tradingview-widget-container__logo","a[href*=\"://1xbet.\"]","#mc_baner","#moneyblock,\n.brand_a,\n.no_news,\ndiv[class^=\"aks-\"]",".freedom__banner,\nimg[src*=\"/images/sponsors/\"]",".content-column ~ .content-column > .section-rss",".fonbet-banner",".branding-space,\na[href*=\"branding\"]",".uk-container > .uk-grid:has(> div > strong ~ div > script[src*=\"idealmedia\"]),\n[src*=\"/embed/SportsBetting\"],\nimg[src*=\"1xbet\"]","#bannerlayer",".kivvi_social","#banner1000_250,\n#banner300_250,\n#zharnama300_250,\n#zharnama300_400",".b-container",".a6",".ban-head,\n.bn-slider",".swal2-container","#advertising",".menu + .block > div > a > img[src^=\"images/\"]",".navbar-fixed-bottom","#header-top-space,\n.main-links > [style*=\"background\"]",".bnr-tall","#js-widget-pm,\n.block-branded-icon,\n.block-main-info__sponsor-image,\n.js-branding-top,\n.js-commercial-menu,\n.nearest-matches,\n.page__top,\n.widget-1xbet,\n.widget-parimatch-wrapper,\n[class*=\"ad-slot-module\"],\n[class*=\"adv\"][class*=\"laceholder\"],\ndiv[class*=\"sponsorship\"]",".advert","#div-gpt-listing-full-screen-container,\ndiv[data-testid=\"qa-advert-slot\"]",".ad2","body > div.layer0",".top-promo-view",".logo + #ja-search","#popup_prod","a[href][style*=\"display: block\"] > img","#fonbet_oversize_container,\n.footer-top__partners > .footer-block-wide:only-child,\n.game-info__bottom",".banner-bg","div[class^=\"ads\"]","[class^=\"sponsor_\"],\n[class^=\"xbet\"],\ndiv[class^=\"brndng\"]","a[href*=\"paripartners\"]",".header_adv","section:has(> .ya-news)",".header_sub_links","#text-3",".rennab",".banner_mix_left,\n.banner_right",".advertising-blank",".betconest,\n[class*=\"-top-btn\"],\n[class*=\"xbet\"],\na[href=\"/bookmaker/\"],\ndiv[class^=\"vesti-banner\"]","#brand_logo,\na[onclick*=\"Branding\"][style]","div[class*=\"banner_\"]","#branding_link",".module:has(> div > iframe[src*=\"://yk.kz/\"][src$=\"/\"]),\n.top-line,\n.top-line button,\niframe[src*=\"://yk.kz/\"][src$=\"/\"]",".adBanner",".dzen","[class^=\"ads_\"]","#allowNotificationsPopup,\n.adblock_alert,\nimg[alt=\"Parimatch logo\"]","div[id^=\"adv_\"]",".advertising-action-timer,\n.buy-sidebar",".index-page-widget-pravo-google-banner-right,\n.index-page-widget-pravo-pravmedia",".mob_hide[style*=\"min-height:\"],\n.spec-list","div[class^=\"ad_\"]",".static-banner","#redirect-button > #timer",".logo-container > div[class=\"widget-header\"],\na[href^=\"http://248.dp.ua\"],\na[href^=\"http://happydiets.net\"],\na[href^=\"http://kiddo.ua\"]","#top","#idx-sidebar2 > div:not([id]):not([class]),\n#logo-td + .w100.tCenter,\n#main-nav > .ext-links,\n#page_footer > div[style^=\"padding\"],\n#topic_main > [id^=\"post_\"] ~ .hide-for-print,\n#topic_main > [id^=\"post_\"] ~ tbody:not([id^=\"post_\"]) > [class],\n.bn-topic,\n.postLink[href*=\"://sbermegamarket.ru/\"],\n.postLink[href*=\"citilink.ru/\"],\n.t-body-txt-ad,\n[class=\"attach bordered med\"] > tbody > .row3 ~ .row3 > td > :not([class^=\"internal-promo-\"]),\n[class^=\"bn-\"],\n[class^=\"internal-promo-\"],\n[id^=\"bn-\"],\na[class^=\"ref-\"][target=\"_blank\"],\na[href*=\".vkplay.ru\"],\na[href^=\"go.php?id=\"],\niframe[src*=\"/rutrk.org/iframe/\"],\ntr.row3 > td > ul > li:has(> a[href*=\"offer_id=\"])",".prf-box[style=\"padding:30px\"]","#info > div[id^=\"mp_wid_\"] ~ .textos,\n.content > #info:nth-of-type(1):has(> .textos)",".onp-sl-overlap-box",".article_ads_section,\n.small_ads_cell",".grid-r",".md\\:u-block,\n.overflow-hidden.c-card,\n[class^=\"c-banner\"],\n[data-product],\na[href*=\"/purchase\"][target=\"_blank\"],\nimg[height][src^=\"https://shuba.life/static/banners/placeholders/\"],\nsection.c-post__full > [style=\"overflow: hidden;\"]",".entry-content > h3,\n[href*=\"mclk.ru\"]","body > .wrap-overlay",".rtbCont","#top_reklama","#secondary > .widget_custom_html",".serials > .serial:has(> .serial-btn > .row > div > img[src^=\"/assets/smotret_anime-\"])",".sidebar-widget:has(> .bra__col)",".wrapper-partner-rb,\ndiv[class^=\"partner-\"]","div:has(> noindex > script)","div[class^=\"vjs-promo\"]",".content > .text-block.form-wrap","[data-testid=\"ExpressCouponBookmakers\"],\na[href*=\"/sportbooks\"],\na[href*=\"/tsr/\"]","a[href*=\"bookmaker\"]","#float-bottom-content-closer","#carouselPrintstok,\n.parent,\na[href^=\"/fon\"]",".branding-fk",".d-none:empty,\n.fn-more-info,\n.fn-sources","#film > #content > span[style=\"color:#ff6a00;\"]",".inline-desk",".notification-widget","#pointer-informer-container,\n#simpalsid-news,\n.header_numbersTop,\n.numbers-placeholder","body > div[class*=\"branding\"]","#article > .right-block,\ndiv[class*=\"bannerplace\"]","[id*=\"_wideBann\"]","div[class*=\"block-mplus\"]",".video-ad-container",".news-feed-item[style=\"height: 400px\"],\n.ushi,\na[href=\"//moldovenii.md\"],\ndiv[class*=\"-bnr\"]","#business-sidebar,\n.point-ads,\n[style^=\"position:\"] div[class]:has(.point-ads),\n[style^=\"position:\"] div[class]:has(> a[href*=\"utm_campai\"]),\na[href*=\"://sales.simpals.com/\"][href*=\"banner\"],\narticle:has(> div[id^=\"article-\"] > .business),\naside > div:has(> a[href*=\"utm_campai\"]),\naside > div[class]:has(> div > [id*=\"adsense\"]),\ndiv:has(> article > div > a[href*=\"/business/\"]),\ndiv[class]:has(> a[href*=\"://sales.simpals.com/\"][href*=\"banner\"]),\nspan > a[href*=\"/novosti/business/\"]","div[style^=\"min-height:\"][style*=\"250px\"]",".company_related-banner,\n.h_banner-container","body[onfocus*=\"reloadliveblock\"] > #bugoverlay ~ table table[bgcolor=\"#dbdbdb\"] td[bgcolor=\"#fafafa\"],\nbody[onfocus*=\"reloadliveblock\"] > #bugoverlay ~ table tr > td[height^=\"9\"][bgcolor],\ntd[background^=\"//cdn.livetv\"] tr > td[valign=\"top\"] + td[align=\"right\"]","body > #localpp[onclick*=\"window.open\"],\nbody[bgcolor] > #adbtm,\nbody[bgcolor] > div[id=\"ads\"][style^=\"position: absolute;\"],\nbody[bgcolor] > div[id^=\"iframe-container\"]",".alert-mess > .row","#galepro-core-adb-enabled","#sidebar1-wrap > center > a[href][target=\"_blank\"],\ndiv[style=\"position:absolute; top:65px; left:520px;\"]","body > div[style^=\"pointer-events: none;\"][style*=\"visible;\"]","#jadb",".v_adv",".adblock + *,\n.masr,\n.soret","[class^=\"menu\"][class*=\"special\"]","a[href*=\"porter.vip\"]",".textwidget > a[href]",".block:has(> .content > [data-la-block])","#rightsidebar,\n.like_hide,\ndiv[id$=\"sidebar\"] > .rounded:has(> .roundct > noindex)","#add2_div",".skin-block",".red.nodata,\ndiv[id^=\"inform_top_\"]",".polna-rkl > a",".desctop,\nembed",".node-promoted",".left-wrap > .left-block-bg","a[href=\"/help\"],\na[oncontextmenu=\"return false;\"]",".rightBlock:has(> .shopOffers)","#litres_btn","div[style=\"font-size:11px; margin: 0 2px 0 2px;\"]",".AppPromo,\n.CheatModal__modal,\n.CommentBanner,\n.Grid-in .GridItem:has(> div [class*=\"advertiser\"]),\n.Home-section:has(> div .title [class*=\"romo\"]),\n.kinopoisk,\n.okko,\n[onclick*=\":hd.kinopoisk.ru\"],\na[href*=\"hd.kinopoisk.ru\"]",".kinopoiskBanner,\nmain > .contAlt","#wrapperBillboardScroll","[class^=\"st-br\"] > *,\nheader.st-flex,\nheader.st-flex ~ *",".no-adb",".content > .errors,\n.sidebar > div:has(> #twitch-embed)","a[href*=\"/banners\"],\nbody > noindex ~ br,\ndiv[style^=\"background-color: #E9EAD6; width:100%; height:\"]","div[id^=\"adv\"]","td[valign=\"top\"][align=\"right\"] a[href][target=\"_blank\"] > font[color=\"red\"],\ntd[valign=\"top\"][align=\"right\"] a[href][target=\"_blank\"] > font[color=\"red\"] ~ img",".col-md-4 > .mynavblock ~ div","div[class][style=\"margin-top: 20px; margin-bottom: 20px;\"]",".shadow.sidebar,\ndiv[class^=\"trsm\"]","#bnr,\n#header a[target=\"_blank\"],\n#space,\n#space + a[target=\"_blank\"],\na[target=\"blank\"] > img",".panel-primary:has(> .panel-body[style=\"padding: 20px;\"] a[href*=\"aeza.\"]),\na[href*=\"aeza.\"],\na[href=\"/download\"]",".footer__btn-link",".header-img,\n.right__images","td > div[align=\"center\"][style=\"height:300px\"]","div[id^=\"ads_notice_\"],\ntd > div[class]:not([id])[style*=\"important\"]","div[class^=\"spns\"]",".code11,\n.firstPostRandomCode_wrapper",".contleft-nomenu,\n.leftside > noindex,\n.rightslide","div[class]:has(> a[title] > div[class])",".footer-container #blink7","div[id^=\"M\"][id*=\"Preload\"]",".ads_R","a[href*=\"://torrentinka.me/gom\"]",".side-content-adblock","td:first-child + td[valign=\"middle\"][align=\"center\"]","#flowplayer > div[class][style]:first-child",".b-right","div[class^=\"cpa\"]","div[class*=\"adfinity_block\"]","#root > div > div:not([id]):not([class]):not([style]),\n[data-test-id$=\"-recommended\"] > div > div > div:nth-child(-1n+3):has(> div > div > div:empty),\nbody.ReactModal__Body--open > div[style^=\"z-index: 999; position: absolute;\"],\nmain > div[data-sharing-target] ~ div:nth-child(-1n+9):not([data-sharing-target])","the-card:has(> thetruestory-widget-top)","a[href^=\"/bitrix/bitrix.php\"]",".parthners",".sidebar-banner-wrap,\n[class^=\"HomePage_aBanner\"]",".top-line-bn,\niframe[src*=\"kluch.media/banners/\"]",".widget-banner",".menu-promo","#br_hg_all,\n.advertise-section,\n.hg-adv-item,\n.widget_leftadvbanner",".aside-links,\n.nadavi-widget,\n.text-with-bg,\na[href*=\"://telemart.ua/\"]","a[href*=\"matchit.me/\"]",".banner-section",".betera-widget,\n.popular-section,\n.side-section__banner-wrap","img[alt=\"ad\"]","header > a:not([href^=\"/\"]):not([href*=\"://orenburg.media/\"])","[data-remodal-id]",".block-wrap-da",".a_d_v",".ult-banner-block,\n[data-vc-parallax]","img[src*=\"/images/banner\"]","#ticketsbox",".channel-centre > .bottom-links ~ .d-md-block",".banner-img","[class^=\"mz-advert-\"]","#ad-recipe-bottom,\n#main-aside > .ib,\n.ads_enabled,\n.as-ad-step,\n.noprint > div[style*=\"height:300px;\"]",".timecss,\n.timecssip,\na[onclick=\"openAuc();\"][title=\"Free money easy\"],\na[title=\"For video ad companies\"]","[href^=\"https://t.me/\"]","[id^=\"n-rek-\"]",".ban240",".head + .main,\ndiv[style*=\"/reklama.gif\"]",".rekl",".advert-header,\n.new-header,\nbody > div[class]:not([id]):nth-child(-1n+5) > a[href]","img[alt^=\"Hilton\"]","#gxFooterBanner,\n.pageContent > div[style^=\"outline\"] > a[href]:not([href^=\"../threads/\"])","#secondary > .widget_custom_html ~ .widget_custom_html","a[href^=\"http://hpc.name/redirector_ads\"]","#inoe-banner,\nnoindex > div[id^=\"block\"]","#notices",".Banner",".draggable_oio","#left > .bl0 ~ .bl0:not(:nth-last-child(2)),\n#right > .bl0 ~ .bl0:not(:nth-last-child(-1n+2))",".execphpwidget > div[id]:not([class]):not([style])",".esc_adv_inside_container","#bt-stop-ra,\n#side > div[style*=\"300px\"][style*=\"600px\"]",".block-inner > noindex","#prerollad",".leep_promo_link,\n.page > div > center > noindex","html > body ~ div","td[align=\"center\"] > a[href][target=\"_blank\"]",".uk-width-8-10 > div[align][style*=\"width:\"][style*=\"height:\"]",".b-rightBanner","div[style=\"text-align: center;\"] > a[href][target=\"_blank\"] > img","#anews_bigtizer","a[href*=\"/addownload.html\"]","a[href*=\"/surl.li/\"]","a[href*=\"fon.bet/\"]","#no_mobile > a[href][target=\"_blank\"]","div[id][style=\"min-height:250px\"]","#js-preload-banner","#infobox_right","div[id^=\"teaser\"]",".alert-danger","a[href*=\"babyitalia.ru\"]","#dle-content div[align=\"center\"]:not([class])",".b-banner-container",".b-banner_sm",".b-header-banner,\n.b-net-preview,\n.mtbottom_priceua",".b-advertise",".b-puzzle-banner","a[href*=\"aHR0c\"] > img","noindex a[href][target=\"_blank\"]","body > #cboxOverlay, body > #colorbox",".right-sidebar div[style^=\"width: 300px; height: \"],\n.right-sidebar__title_without_border:has(> div[style^=\"width: 300px; height: \"]),\n.widget_header aside,\naside[id][style^=\"height:\"],\ndiv[id$=\"_megadiv\"]",".row-banner","div[id^=\"chadddos-guard\"]",".logo-w + a[target=\"blank_\"]",".px-nav-dropdown-menu > .px-nav-item:has(> a > #uLogin),\nli[id^=\"slide\"]","td[bgcolor] > table[bgcolor=\"#EAEBEE\"],\ntd[bgcolor] > table[bgcolor=\"#EAEBEE\"] + table","#antiAdBlock,\n.rek_plashka,\n[id^=\"_myproduct\"]","form > article[id^=\"elComment_\"]:has(strong > a[href$=\"-Adver/\"])",".pls_rmv","div[onclick^=\"onclickRight\"]","a[href^=\"https://www.reg.ru/\"]","#dle-content > table td > a[target=\"_blank\"] > img,\n.stic","#popup_bg",".container > .sidebar,\ndiv[class^=\"news-block\"]","#nav_news > table[class],\n#nav_right,\n#pbie_25,\n#ptext_15,\n.left_banners",".g-ads","#content123",".dlogo td[align=\"center\"],\n.mmenu a[href^=\"http\"]:not([href^=\"http://dream\"]),\na[href^=\"http://tapker.com/app/\"]",".banner-categories,\n.main > div:first-child[style*=\"99%;\"],\n.main > table[height=\"128\"]","body > #right","#vista_toolbara > table:nth-of-type(2),\na[href*=\"in.htm?\"],\na[href][target=\"_blank\"][tooltip]",".intro","#ed-shortbar","div[style*=\"display:inline-bl1ock\"]","#sideLeft > .baza",".mreklama","a[href*=\"freebitco.in\"]","p[style=\"text-align: center\"] > a[href] > img","a.film-online[target=\"_blank\"]",".right_colum > section:first-child",".infTable",".mtsnb,\n.wrapper-outer > .background-cover",".modal_type_video-ads,\ndiv[class*=\"__ads-\"]",".fb-ads-block,\n[data-ab-test-id],\ndiv[class^=\"rkl-\"],\nya-recommendation-widget","#main_content + td[width=\"240px\"]","#teaser-cc-cell",".da-section","#chrome_popup,\n#fishki-prompt-widget,\n.brand-ear,\n.cycle-carousel-wrap > [style*=\"z-index: 100;\"],\n.drag_element:has([href*=\"poleznaja-reklama.html\"]),\n.header-nav__link[href=\"/games/\"],\n.is_adv_post,\n.like_wall.is_visible,\n.sidebar__block_trend ~ .sidebar__block_trend,\n[class^=\"partner-post\"],\n[class^=\"side\"][class*=\"right\"] div[class*=\"promo\"],\n[href=\"https://servers.ru\"],\na[href*=\"poleznaja-reklama.html\"],\ndiv[id^=\"b-close\"],\niframe[src*=\"ondu.ru/\"]","a[href*=\"shop.vmayke.org\"]",".yandex_ads","div[class^=\"popup\"]","#popupwindow","#sidebar > div[style]:not(#rightmenu)","#info-main-block,\na[href*=\"csgo.life\"]",".branding-spacer,\n.head-margin > .nomargin.block",".PostContent > noindex > center,\n.cleared","#relategames > noindex,\n.swfgame_banners",".adv_algn","#afoot,\n#hfsn","#header-banner","#banner-top",".banan_block",".widget_widget_catchbox_adwidget","a[rel=\"nofollow\"] > div[align=\"center\"] > img",".floating,\nimg[width=\"140\"][height=\"30\"]",".dns_banner,\na[\\;] > img,\na[href^=\"http://cifra-zone.ru\"]","center > noindex > a[target=\"_blank\"]",".inRek","aside > .widget_search + .widget_text","[src*=\"_partners/\"],\ntable > tbody > tr > td[width=\"210\"][valign=\"top\"]",".a-video-block","noindex > a[href*=\"/go.php\"] > img:not([src=\"/uploads/vk.png\"])",".stockgame","a[href=\"http://hdserial.com\"]",".container > div[id^=\"adblock-\"] ~ .row,\ndiv[id^=\"adblock-\"]",".top-b.row",".nevidimka,\nbody > div > .menu,\ndiv[style=\"background: #ffffff; box-shadow: 0 0 0 1px #457a9d, 0 0 5px #333; padding: 10px 3px 3px 3px;\"]","a[href*=\"/banners/go_to/\"]",".mcompl","#content > .container","#left_menu_no_adv ~ *,\n#right_menu div[id][class][style^=\"display\"] *,\niframe[src*=\"/advert.\"]",".right-col","#dle-content div[style*=\"440\"]",".buyframe,\n.main-bg a[target=\"_blank\"] > img","a.red,\na[href=\"/out.php\"]","div[id$=\"odalWin\"]",".banerp","img[src^=\"/templates/onlinegid/images/panel\"]","a[href*=\"chromepro.ru\"]",".warning-adblock",".sidebarsB > .sidebar1","#swf","[class$=\"ad_title\"]",".padding > table[width=\"180\"]:nth-of-type(4),\na[href*=\"epidems.net\"]",".panel-body noindex",".article:has(> .article__title > a > .advertising),\n.col__sidebar > .unit-side-informer,\n.unit-inner-banner,\n.unit-side-banner,\n.unit-top-banner,\n.unit-top-dark-banner","div[id^=\"holder_\"]",".text > div[style^=\"min-height:\"]",".bunner_container","[href*=\"/pari\"],\ndiv:has(> table > tbody a[href*=\"kulichki.com/advert\"]),\niframe[src*=\"/leon/\"]","a[href*=\"adv&\"][href*=\"click&id\"]","div[class^=\"but-150\"],\ntd[width=\"150\"][align=\"right\"][valign=\"top\"]",".sape[style=\"width:500px;\"],\n.td_poisk[style*=\"background:#f5f0e8;\"]",".sidebar > .widget_list_mag_wp_300px:first-child,\n.sidebar > .widget_list_mag_wp_300px:has(> .img-300 > a[href][target=\"_blank\"]),\n.sidebar > .widget_list_mag_wp_300px:has(> .img-300 > div[id])",".banad,\n.down_link > .wl:not([style]),\n.file_download > div[style*=\"height:\"],\n.file_info_ad",".article-header__video-banner,\n.b-blocks,\n.banner-area,\n.swal2-backdrop-show,\n.top-bnr,\na[href*=\"/adfree\"]","a[href*=\"thehost.ua\"] > img",".book_ltrs,\n.box_title_on_pages:first-child[style=\"width:100%;\"],\n.pay,\na[href*=\"/feisovet/\"]","body > div[style^=\"position: fixed\"]","#image_after_image-viewer,\n#image_image-viewer_top",".dle_b_yandex",".header-top",".partner-block","#top-band-2","#mod_fav","a[href^=\"http://scorch5.com/\"]",".blocker-notice, .blocker-overlay","#mb_top_space,\ndiv[style$=\"#CCCCCC;\"]",".apygame","center > a[target=\"_blank\"]","[data-widget*=\"adblockOverlayEnabled\"] .notifications","div[id$=\"-menu\"] [class*=\"module-body\"]:has(> script[src]:not([src*=\"vk.com\"]))",".row.row-flash.roll",".re-block","#text-html-widget-4","a[href^=\"http://digit.com.ua/\"]","center > table > tbody > tr[valign=\"middle\"]:first-child + tr:last-child",".adv_video,\n.verx_r",".visible-lg .widget_text","a[href*=\"steam-account.\"]",".rightColomn > aside:has(> .textwidget)",".softobase-client-promo",".adsh_ads4",".advf-top",".topbnr,\n.vk-music-link,\n.vk-player-promo",".card-panel:has(> center > .ds)","div[style*=\".am15.\"]","#teasers-sidebar,\n#teasers-top,\n.more-teaser","#rtm-top","a[href*=\"redikg.ga\"]","._unit","[id*=\"teaser\"]",".inban,\n.page-banner__wrapper,\ndiv[class*=\"__bot-ad\"],\ndiv[class*=\"__top-ad\"],\ndiv[onclick*=\"partner\"]",".app-page__left > .app-page__menu ~ div[style*=\"height:\"]","#dle-content > .short-post > .category,\n.topnews noindex","#vk_up_table,\nbody > div[style*=\"cursor: pointer;\"]","div[id^=\"mawid\"]",".block-header[style=\"margin-bottom: 15px;\"]",".news > div[onmouseout][onmouseover][style],\ncenter > a[target=\"_blank\"][rel=\"nofollow\"]",".badv,\ndiv.hide.margin32 > .ttle,\ndiv.hide.margin32 > .ttle ~ *",".post_liked","div[class^=\"rek\"]","div[class^=\"ban\"],\ndiv[class^=\"videoban\"]","#content > .unspecific.message,\n#some_ad_block_key_popup,\n.modal","#button-contact-vr,\n.oblivki,\n.top-reklama",".down",".player22","[src$=\"/social.gif\"]",".sub-text",".simple-banner,\nbody > .brend","a[href^=\"http://club-vulkano.com/\"]","a[href^=\"http:\"]:not([href*=\"ochevidec.net\"]):not([href*=\"livejournal\"]):not([href*=\"icq\"])",".inner_box3","#rightcol-c > div > noindex","noindex > table.alt1","#leftcol-c > br + div[style],\n.info_one,\na[href^=\"http://verismediya.ru\"]","#container > div.otzyv_box_float[id^=\"review_\"] ~ .otzyv_box_float:not([id^=\"review_\"]),\n#google_recommended,\n.right_column_one > div[class^=\"mainblock h\"]",".dds,\na[rel=\"nofollow,noindex\"]","ins[style^=\"display:inline\"]","[href^=\"go.php?to=\"]","div[id^=\"pcash-block\"]","#daos,\n.entry > div[style^=\"float:\"]","a[href*=\".sim-networks.com/index.php?pid=\"]",".adv-wrapper",".article-comments > .row > div[class] + div[class],\n.h-advert,\n.head-ad_vert,\n.right-a_dvert,\na[href*=\"https://patreon.com/\"]",".gdeslon-widget","#bla,\n.left_side,\n[id^=\"blabla_tr\"]","#pddk221",".dzenSlider",".b-sidebar-right,\ndiv.hide_mobile[style]","#dle-content > div[id^=\"id-\"]","#sidebar","div[class*=\"ya\"][class*=\"dzen\"],\ndiv[class*=\"ya\"][class*=\"news\"]",".bnr_300_600","#ss-menu > ul > li[style],\n.ss-overflow-hidden,\nli[class^=\"ss-li-\"]","#tesaerleft",".xpwt_video-spots-col","a[href^=\"/url?go=\"]",".package-timeline__item--adv",".col-cont div[align=\"center\"]:not([class])",".reclama_v",".col-lg-3,\n.prognoz_block,\n.reklama_img_ssilka,\n.top-menu > .top-menu-item ~ .top-menu-item ~ .top-menu-item > :not([href])","a[href^=\"http://bestspb.ru\"],\na[href^=\"http://www.risecargo.ru\"]","[alt*=\"Amigo\"]","#left-bot","#installApp",".yandex-link",".download_file:has(> a[href*=\"/sb/clk/\"])","div[id*=\"rca\"]",".popup[id*=\"-results-banner\"]","#page_header > center,\n#page_header > hr,\n#sidebar1-wrap > hr,\n#sidebar1-wrap > noindex ~ table,\n#sidebar2-wrap > hr","#sverhuAd",".download_blue_yellow",".container_gads","#page > #overlay","img[src^=\"https://rsload.net/images\"][src*=\"2890374\"]","img[src*=\"banner\"]",".menu_block.navi > a:not([href^=\"/\"]):not([href^=\"http://ru-admin.net\"])","div[style*=\"fyi5fimf.\"]","#left_col .center > noindex ~ *","#page-body > noindex > .bg3,\na[href^=\"http://www.seopowersuite.ru/\"]",".item-full > .list-items ~ .subcol","#bottomBlockAdfox,\ndiv[class^=\"ggmodale\"]",".full_story + center,\n.topbannerbg",".lb-sideleft",".adbon",".smotrite",".contextlink","#blokya",".bns-bl,\n.player-bn",".a_top",".adv-sale","a[href^=\"http://naoblake.com/\"]",".sect-recl","#fo_cblock2 > .row2 > table ~ div[align=\"center\"],\n#fo_cblock3","div[id^=\"carousel_pos\"]",".mask,\n.modal-baner,\nobject[data*=\"/images/zen/\"]",".scrolled-adv","[data-banner]","a[target=\"_blank\"][href*=\"olimp\"]","#left_slide > #conteiner, #left_slide > noindex","#fixcyber,\n.article__content > table[width=\"336\"]","#opaco, #popup","div[id^=\"rek\"]","td[width=\"120\"][valign=\"top\"] a[href][target=\"_blank\"]","[href=\"http://surgeryzone.net/knigi-po-medicine\"]","#aposnow,\n#page_header td[width=\"230\"] + td,\n.attach > tbody > tr:not([class]) > td[width=\"100%\"][class=\"attachheader\"][align=\"center\"]","[id^=\"nadavi\"]",".widget_partn","div[id^=\"news-id-\"] > .quote > div,\ndiv[id^=\"news-id-\"] > .quote:has(> div)",".b_articles__banner,\n.partner-news:not(.b_crosswidget)",".newsText > p:has(> ins)",".row > .col-md-7 > .panel-default","div[class^=\"download-rek\"]","a[href*=\"browser.\"]",".maincont > div:nth-last-of-type(2) > a > img",".side-widget > a[href][target=\"_blank\"] > img:not([alt*=\"elegra\"])","#theBanner,\n.tBoxAdv",".content > noindex > :not([href*=\"tyurem.net\"])","#bottom-notice","a[href*=\"://money-birds.\"],\na[href*=\"://payad.me/\"],\na[href*=\"://surfearner.me/\"],\na[href*=\"://teaser.bz/\"],\na[href*=\"bolshoyvopros.ru/\"]",".adv-news,\n.lazy-load-banner,\nbody > .yellow-die","#left_banner,\ndiv[class]:not([id]):first-child:only-child > div[class]:not([id]):first-child:only-child > div[class]:not([id]):first-child:only-child > div[class]:not([id]):first-child:not(:only-child),\ndiv[class]:not([id]):first-child:only-child > div[class]:not([id]):first-child:only-child > div[class]:not([id]):first-child:only-child > div[class]:not([id]):first-child:not(:only-child) ~ div[class]:not([id])","#top-banner",".fixed-block > div[class] ~ div,\narticle > section:has(> div > div > a[href*=\"/ad.adriver.\"]),\ndiv[class*=\" \"]:first-child + div[class*=\" \"]:last-child > div[class*=\" \"] > div[class*=\" \"]:first-child:empty ~ div[class*=\" \"],\ndiv[class^=\"fuel-\"][class$=\"-banner\"],\ndiv[id^=\"ecbr-\"],\niframe[src*=\"safemore.ukr.net/\"]",".custom-html-widget > a[href] > img",".outer > br,\n.outer noindex > center > a[href][target=\"_blank\"]","a[href*=\"utorrentgames.net/module.php\"]","#dle-speedbar > .hblock:has(> .adsbygoogle),\n.full-story > .mblock:has(> noindex),\n.mblock > noindex,\n.right .mblock:has(> a[href][target=\"_blank\"] > img)","div[style^=\"position: absolute; width: 300px;\"]",".mv-advert-position",".tizer",".prevent-first-click","div[class^=\"adrotate\"]",".sidebarBlock:first-child","div[class^=\"sectionrol\"]",".code-block:has(> .content_rb)",".c-center > .cols ~ *,\n.c-left > .block ~ *","div[style^=\"text-align:center;line-height:0;display:block;height:\"]",".after_image_promo,\n.walls_data > .item:has(> .thumbnail script)",".ads-long-block","a[href=\"#\"][onclick*=\"_blank\"]",".downloadPageBox > div[id]:has(> img + style),\n.dpbTimeOut,\n.isadNotif,\n.wzADS,\narticle > div[id]:has(> img ~ style)",".fullstory ~ noindex .pleer",".right-full > noindex","#top_ajax_ad","#popup.modal-box","#content > .info-box,\n.blog-cat > .box[style^=\"height:\"]",".adblocker-notification,\n.slideshow__link,\na[href=\"http://greedydwarf.ru\"],\nbody > div[style*=\"z-index: 10000\"]","#dle-content > .search","#ipd-msg-wrapper + br + center,\na[href^=\"https://author24.ru/\"],\nimg[alt=\"author24.ru\"]","div[class^=\"rec-\"]",".we-are-featured","a[href][rel=\"noindex\"]","td[align=\"center\"][style=\"width:220px;\"] + td[valign=\"top\"] > :not(#dle-content)",".gooo",".for-article > .js-switch-blocks-center > .news-feed-wrapper:has(> .news-feed > .for-banner),\n.for-banner,\n.page-new > .left,\na[href^=\"/banner/click/\"]","#wp-custom-header > .header-image-wrap > img,\na[href][rel=\"nofollow noopener\"] > img","#header_advt-wrapper,\n#slotPromoinformer300x250,\n.content-roll,\n.mobile-branding-wrapper,\n.news-list-col > .news-list,\n.partner-wrap-block,\ndiv[id^=\"slot300x\"]","[class*=\"adv-\"][class*=\"new\"]","[id^=\"mobileBrandingPlace\"]","div[id^=\"videoAdvWrapper\"]","div[class*=\" ZNT_\"]","a[href*=\"insorg.org\"]","#block-zwzd-partners",".mediametrics","div[id^=\"Zz\"]","img[src=\"/img/ad-1.png\"]",".banner-sidebar",".recomended,\ndiv[class^=\"djslider\"]","#partner-widget-mediametrics,\n.capybara-mini[style^=\"width:300px;min-height:300px;\"]",".bn-content",".sect-repeat-ban",".td-post-content > p:has(> i > [onclick^=\"yaCounter\"])",".block-content > .ageLimit","[class^=\"banner\"]",".content > .comment-block[style^=\"margin\"]",".reklbanner","div[class*=\"remodal\"]",".fotorama__stage:has(> div img[src*=\"/i/a/\"]),\na[onclick*=\"ad_click_\"]",".my-4",".temporary_banner",".block-mediametrics",".adv-container-wrapper,\n.partners-container,\n.promo-card-small,\ndiv[class$=\" feed-item\"]","#installer,\n#loaded,\n.ads-ob,\n.aside > [id][class],\n.aside div[id][class]:empty,\n.grid > div[class^=\"it_\"]:has(a[href][target=\"_blank\"]),\n.header #person:empty,\n.theiaStickySidebar > [id][class],\n[itemprop=\"articleBody\"] > [id][class]:empty,\ndiv[class^=\"it_\"]:has(> div[class^=\"banner\"]),\ndiv[id^=\"prog_adv_\"]","[class^=\"partner\"]","div[id^=\"adriver_banner\"]",".bPosition_c2,\n.is_momenty,\n.item-text > div:has(> div > .inpage_block-adv),\n.no-print[style*=\"height\"],\n.publication-c4,\na[href=\"/advert\"],\ndiv[class^=\"inpage_block-adv-\"],\ndiv[class^=\"right-banner\"],\ndiv[id^=\"top_banner\"],\ndiv[id^=\"widget-container_news\"],\ndiv[style*=\"height\"][style*=\"110px\"],\ndiv[style*=\"height:\"][style*=\"width:\"][style*=\"overflow:\"]",".bbh,\n.bbn",".g-banner","#pn_gsc_pblocks,\naside.tm-sidebar-a [class*=\"block\"]",".adblocker",".container-fluid > div[class=\"container uphead\"],\n.dlblock:has([href*=\".drp.su/\"]),\n.horizontal > .rbox:has(> div a[href*=\"page.php?id=3023\"]),\n[href=\"download/page.php?id=5511\"],\na[href*=\"page.php?id=3023\"],\nbody > .dlblock ~ .container > div[style=\"margin-top:25px;margin-bottom:25px;\"],\nbody > .dlblock ~ .container[style=\"padding-top:12px;\"],\nhtml:not([style]) > body getsitecontrol-widget:not(#getsitecontrol-7665)",".uix_ad_banners,\ndiv[style=\"height:5px;\"]",".header-link",".related_news:has(script)","div[style^=\"margin: 20px 0;min-height:\"]","a[href*=\"://fineproxy.org/\"]",".afterpost-teaser-x,\n.sidebar-block:has(> .sticky .comm-blog),\ndiv[id^=\"slider-middle\"]",".two-big-block",".glsdklj","#adFoot",".canshow,\n.main-banners,\niframe[src*=\"/bredir/\"]",".main-b",".comments ~ noindex","div[class^=\"homeBannersAds\"]",".msg-AdBlock",".follow_button",".my-5","[data-type=\"anti-abp\"]",".spots-side","[data-action=\"banners\"]",".card__description__adv,\n.details__bg",".overflow-hidden.border[class*=\"border-brand-base\"],\n.to-brand-danger,\n[data-test=\"channel-name-link\"] ~ div:has(> div > div[id^=\"yandex_rtb\"])","#messageblock1",".eduChat,\n.well-google,\n[action*=\"homework.ru\"],\n[action*=\"vse-sdal.com\"],\na[href^=\"https://zakaz.semestr.ru/\"],\narticle div:has(> [action*=\"homework.ru\"]),\narticle div:has(> [action*=\"vse-sdal.com\"]),\ndiv[id^=\"Math\"][id$=\"Block\"] > div:has(a[href]:not([href^=\"/\"]):not([href*=\".semestr.\"])),\ndiv[id^=\"Math\"][id$=\"Block\"] > div:has(a[href^=\"https://zakaz.semestr.ru/\"])","[id*=\"banner\"]",".background-banner","pjsdiv[style^=\"position: absolute; left: 0px; top: 0px; width: 100%; height: 100%; pointer-events: none; z-index: 10000; display: block; background:\"][style*=\"/player/loader.png\"]",".leftside.lcolomn > .block:nth-of-type(1),\n.maincont > center",".rightrekl",".book-box:has(> [class*=\"banner\"])",".logo_ad_wrap",".cookie-modal,\n.dzen-logo,\n.sidebar a[href][target=\"_blank\"] > img,\n.sidebar__wrap > :not(.sidebar__info),\n.yet:has(div[id]:empty)","a[href*=\"erotel.org\"]",".ttte","a[href*=\"/?from=portal&place=ver-slider\"],\ndiv[class^=\"inform_doska\"],\ndiv[id*=\"company\"],\ndiv[id^=\"who_portal\"]",".ad1,\n.ad3",".phpbb-ads-center","#phpbb-ads-ab","#branding-ads",".overhang","img[width=\"727\"][height=\"89\"]",".sidebar-widget:has(> [data-la-block])",".posts-container > .card:has(> div > [id^=\"yandex_rtb_\"]),\n.posts-container > .card:has(> iframe[src*=\"/banners/\"])",".sidebar > .side-box > center ~ *","a[href*=\"://animedub.ru/\"]",".sub-info a[href][target=\"_blank\"] > img",".content div[style^=\"min-height:\"]","#moduleLeft[style=\"border:0;\"],\n#wrap > div[class^=\"headbg\"] > a[href][target=\"_blank\"],\n.batre,\n.shortstoryContent > center[style],\ndiv[class^=\"interDub-\"],\ndiv[id^=\"moduleLeft\"]:has(iframe)","[style=\"background:#2f2d38; margin:10px;\"]",".topside::after,\n.topside::before",".item:has(> script),\n.item:has([src*=\"/images/pek.png\"])",".nobo + .box-categories,\ndiv[style^=\"width:100%; height:90px;\"]",".main > noindex",".rek1","div[id^=\"admitad\"]","#page-body > .bg2.post:not([id])","#top-banner-box","a[target=\"_blank\"][href^=\"http\"] > img","a[href^=\"/trh\"],\ntd[align=\"left\"]:has(> div[id^=\"bb\"] > [id*=\"ScriptRoot\"]),\ntd[valign=\"top\"][width=\"155\"] > table:has(div[id*=\"Composite\"]),\ntd[valign=\"top\"][width=\"155\"] > table:has(div[id^=\"bn_\"])","div[style*=\"width: 240px; height: 600px\"]",".message-container,\n.rightbar > div[style^=\"width\"],\na[href^=\"https://daftsex.github.io/\"],\nbody > div[style*=\"position\"][style*=\"background\"]","a[href^=\"https://theporndude.com/\"]",".vce-related-box:has(> .main-box-inside script)","a[href^=\"http://sportfarma.com\"]",".fp-player a[href^=\"https://bogvideo.com/partneram/\"]",".adva2,\n.dl_link ~ [class]:not(div),\n.dl_link ~ div[align=\"center\"]","a[href^=\"http://agatauto.kia.ru/\"],\na[href^=\"http://sberbank.ru/ru/person/promo/\"]","body > center:last-child,\nbody > table[width=\"99%\"] + p[align=\"center\"]",".Yreklama,\ndiv[class^=\"adaptivgoogle\"]",".short_ban","#smo_modal,\n.wrapper-sponsors",".news-content-wrapper,\n.side-content-wrapper,\n.top-content-wrapper",".nav > .menu-part",".page__main a[href][target=\"_blank\"] > img",".custom",".tt-panel > .note","#installpack-table > .buttons-wrapper > p,\n#installpack-table > .center-wrapper,\n.btn-installpack",".jqmOverlay,\n.jqmWindow",".block_r",".desktop_banners,\ndiv[class^=\"mob_banner\"]","[class$=\"bbody\"],\ncenter + noindex","#bleft,\n#bright,\n#mainContainer > div:not([id]),\n.col-auto[style^=\"height:\"],\n[class^=\"embed-responsive\"],\nbody > .position-fixed,\ndiv[class*=\"vright\"],\ndiv[class^=\"spinner\"] ~ .d-flex","div[style=\"width: 100%; height: 250px;\"]","td[align=\"center\"] > .leftmenu-text","#ads-sidebar-block","div[class^=\"blockdiv\"],\ndiv[class^=\"ftprefix\"]",".custom-html-widget",".aslot,\nsection > .col-full + script + center[class]",".box-Customs2,\n.box-Customs3",".bottom-bar,\na[href*=\"nacked_tits_bot\"],\nimg[src*=\"/download-yb.\"],\nnoindex > .boxlinks","#rightside > .right-block:nth-of-type(2)",".down-mg","body > div[id^=\"ban\"][style],\ndiv[class^=\"gov\"]",".block_d,\n.sidebar > .vk:not(:last-of-type),\ndiv[align=\"center\"] > .vk","table[height=\"90\"],\ntbody > tr > td[width=\"100%\"][valign=\"top\"] + td","#install-area > .post-install,\n.carbon-ad","center > div > noindex",".promo-bl,\n.video_rekl",".baner",".homes",".line > a[href][target=\"_blank\"] > *",".attachment a[href*=\"aHR0c\"][target=\"_blank\"]","[data-ofga-link]","#sideAdv",".dw_focus_widget_news_ticker,\ndiv[class^=\"adslot\"]","#myCarousel,\n.fade[class^=\"modal\"],\n.row-fluid.center > h3,\n.row-fluid.center > h4","aside > section[class^=\"ad\"]","#main > #logo + [class*=\" \"],\nbody > :not(div):not([id]):not([class]):not([style]):not(script)","a[href*=\"://clcr.me/\"]",".homeads,\n.pmedia_240",".-adfb",".page-note","#player > .absolute","a[href*=\"epngo.bz\"]","body > div[class^=\"revelation\"]",".viewinfo ~ center > .link1,\n.viewinfo ~ center > .link2","#rightside > div > noindex,\n#rightside > div[style^=\"background:\"]","#showcase","#rec","#rec_bg,\n.bloc0",".form-wrapper.cf",".sidebarleft > aside","td:first-child + td[width=\"250\"]","#mv,\n.am","a[target=\"_blank\"][rel=\"nofollow\"][href^=\"/engine/download?\"]","#link_brand","#modex",".footer > span > div[style=\"text-align: left;\"] > div[style=\"text-align: right;\"]",".brend",".row > .hidden-sm.hidden-xs > :not([class])",".b-popup","div[style*=\"hot-game.info\"],\nimg[alt=\"Hot-Game\"]","#all > #popup,\n#all > div[style=\"padding:1px;width:100%\"]",".articl_center > noindex","#youcontrol","noindex > .banner",".place_bottom,\nimg[onclick^=\"countAdClick\"]","#wrapcentre td[colspan=\"3\"] > table:nth-child(4),\n[href^=\"http://numbuster.com\"],\n[href^=\"http://www.cenam.net\"],\na[href^=\"http://happycomp-nn.ru\"],\na[href^=\"http://ostrie.ru\"],\ndiv[class=\"postbody\"][id^=\"post\"] ~ center,\ntd[style*=\"url(/images/\"]",".article__dzen","._sm24",".item:has(> div > [src*=\"pek.png\"]),\n.meti",".main > .new_header_90.boxNoPadding3:first-child,\nimg[width=\"240\"][height=\"25\"]",".custom > div[style*=\"display\"],\n.custom > noindex,\na[href*=\"://look-sport.net/\"]","#right-image",".come_d,\n.footer #banner ~ td","#modal-adbmon-div","div:has(> div > [href*=\"bit.ly\"])","div[class^=\"bodyclick\"]","body > div[data-mg-c]","div[id^=\"ab_\"]","center > #vis","div[onclick*=\"SkipR\"]",".bar_bannerz,\n.probirka-popup-container","div[id^=\"AdFox_banner\"]",".banner-left",".banner-right",".ref_link,\ndiv[style=\"color:red;font-size:25px;\"], .adblock_loock",".newsbody > noindex","#advert","#latest_news td[width=\"85%\"] > table > tbody > tr:nth-child(-1n+2)",".banner240","td > table.topic ~ .delemiter:not(:empty)","td[valign=\"top\"] > .forabg:has(> div > div > .inner > .postbody > .content > script[src*=\"oldxit.ru\"])",".promo-banner",".rechka","#teas",".rubadv-post,\n.rubadv-top-in,\na[href^=\"http://minecraftrating.ru/\"]","a[href=\"/donate.php\"] + a[target=\"_blank\"]","a[target=\"_blank\"][href*=\"/webiz/\"],\nimg[width=\"829\"][height=\"90\"]","[class*=\"ad-block\"]",".promo-yandex",".contentBox > noindex",".booster,\n.top_bg > a","#aside > div[style^=\"border:\"],\n.youtube","#pageBody > div[style^=\"text-align: center;\"],\n.partnersList,\n.rightSide > .social_groups ~ div,\n.rightSide > a,\n.sideBlock:has(> .adsbygoogle),\n.sideBlock:has(> [id^=\"CNM\"]),\nnoindex > [class$=\"-block\"]","a[href^=\"/red\"]","a[href][target=\"_blank\"][style*=\"smapps.org/lead/banner/\"]",".card-yandex,\n.inside-smi",".block12 > a[target=\"_blank\"]","#menuLeft","a[href^=\"http://studlancer.net\"]","tr > td[width=\"250 px\"][valign=\"top\"]","div[id^=\"post-\"] > div[class=\"a-divide-entry\"]","#new-adver-promo,\n#new-header > #leftQuote,\n#new-header > #rightQuote",".block_down:has(> .itemdown_nottorent_sub)","center > p > a[target=\"_blank\"]",".dosugban,\n.someban","a[href^=\"http://www.traht.org/module.php\"]",".header > .red,\na[href*=\"://pronpic.org/\"]",".sidebar > .widget-wrap ~ .widget-wrap > .widget_text,\ndiv[style=\"min-height:120px;\"]",".ovdiv","div[style=\"position: relative;display: block;width: 100%;height: 90px;margin-top: 10px;\"]",".custom > div[style^=\"padding:\"]","iframe[src^=\"http://kinohouse.ucoz.ru\"]",".oldest_neews > table > tbody > tr > td:not(:last-child),\n.post_body > div[style=\"color:red;font-size:25px;\"],\na[href*=\"rutor.\"]:not([href*=\".rutor.org\"])","#dle-content > div[style^=\"float: right;\"]",".a-top,\n.partner_","#yandexbot_post","body > #document_modal.modal, #some_ad_block_key_popup,\ndiv[id^=\"adspace\"]","noindex div[align=\"center\"] > a > img",".conrek",".catalog > .shorty:has(> .block),\narticle > div:not([class])","a[href^=\"/index.php?banner-system-redirect/\"]",".modalFacebook",".asn,\n.blockmainkv","table[background=\"themes/xbox/images/hhead.jpg\"]","#center2 > .block",".textwidget a[href][target=\"_blank\"]:not([href*=\"xxx-game.org\"])","a[href^=\"http://i100.ru\"]","#main_banner",".aside > div ~ div",".banners-top",".snap-block > .ad + div,\ndiv[class][style^=\"width:\"][style$=\"300px;\"],\ndiv[class^=\"za-columns-\"]",".fad,\n.pad",".no24_teaser","#page-body > div[class=\"panel\"]","div[class^=\"promo\"][class*=\"wrapper\"]","#bdp_ad_container,\n#bdp_shadow","#content-container > div[style^=\"display: block;\"],\n#content-container > div[style^=\"position: fixed;\"]",".widget_text > .widget-top",".video-sqrs-bl",".banner_widget","img[src*=\"jobvacancy.pro/img/commin/\"]","div[class*=\"plav_\"]","aside > .widget_block",".googlesingledown,\n.row > div:has(> .card-blog script),\n.singlepartners,\np:has(> .adsbygoogle)",".remt,\n.topadmobile,\ndiv[class^=\"remon-after-\"]",".tnx-block,\naside a[onclick^=\"yaCounter\"]","#somewin","a[href*=\"vk.com/away.php\"]","aside .HTML > .widget-content > a > img","adsense",".dna-adfox-block",".dna-vue-player,\n.header-top-banners","[class^=\"cs-banner\"],\na[href][target=\"_blank\"] > img[src*=\"banner\"]",".BodyNewsStyle:has(> div > [id^=\"yandex_rtb\"]),\ndiv[style=\"height:20px;\"]:empty","[id^=\"banner\"]","#holdon",".desktop-banner,\naside[class^=\"main_container Banner\"]",".eriuue-content,\n[class^=\"bablo\"],\n[class^=\"quads-\"]",".btTbl > tbody > .row1 > .genmed[align=\"center\"] noindex,\n.copyright tbody > tr > :not(.copyright),\n.header .row2 tr:not(:last-child),\nbody > .ui-corner-all,\niframe[src*=\"/forum/ads/\"]",".partners_rows,\n.sidebar.column > div:empty,\n.sidebar.column > h5","#ads-top.ads,\n#jtn-common-adv-label > path,\n#ui-common-adv-label > path,\n[data-ns-portal] [data-adv-mark],\n[data-ns-portal] div[class^=\"topicsList\"] a[href*=\"erid=\"],\n[data-test=\"text-list-with-dropdown\"] a[href*=\"erid=\"],\n[data-test=\"text-list-with-dropdown\"] a[href*=\"erid=\"] ~ div,\n[data-test=\"themes-line\"] a[href*=\"erid=\"],\n[data-test=\"themes-line\"] a[href*=\"erid=\"] ~ div","#hoverprompt",".ctaRightWidget",".sidebar-news,\n.uracy,\n.wrapper-branding,\n[class^=\"bnr-\"],\na[href=\"/menu-subscription\"]","iframe[src*=\"/smi\"]",".showMessageAdBlock","#sidebar > .custom-html-widget ~ .custom-html-widget,\n.main > div > a[href][target=\"_blank\"],\ndiv[align=\"center\"][class$=\"only\"]",".b_top,\n.post-banner-bottom",".pop-block","[data-creative]","#div-hb-top-forum,\n.PReP\\+,\n.gridContainer > div[class*=\" grid\"]:has(> [data-creative]),\ndiv[class^=\"newsFeedBlock_\"] > div[class^=\"news_\"] > a[href*=\"?erid=\"],\ndiv[class^=\"newsFeedBlock_\"] > div[class^=\"news_\"]:has(> a[href*=\"?erid=\"])",".forum-right-column,\n.forum-top-banner,\n.global-wrapper > noindex li::after,\na[href*=\"://auto.ru\"][href*=\"utm_\"]","[data-placement]","[data-status]","[data-test=\"sticky-header\"] > div > div > div > div:first-child:not([data-test])","div[class^=\"articleBlockFullscreenGallery_\"] > div[class^=\"wrapper_\"] > div[class^=\"slider_\"] ~ div","noindex ul > li > [data-click-area]","[data-ref=\"sticky-header-wrap\"] > [data-test=\"sticky-header\"] ~ div",".widget_custom_html:has(> .textwidget > #MediaMetricsInject)",".promotion","#header-inner > font > a[href][target=\"_blank\"]",".banner-in-frame",".banner-bottom,\ndiv[bs_id]",".f80,\n.pages_sf_right_block > table[style*=\"min-height:\"],\n.yanews__block",".recl","div[class^=\"vex\"],\ndiv[id][block][style]",".partners-list",".full-story__banner",".article__aaa,\n.article__dzen-share,\n.bnbox,\na[href*=\"://rostoknadache.ru\"] > img","#vertbar_table,\ndiv[class*=\"popup\"]",".long-banner,\na[href^=\"/admin/banner/system/click/\"],\ndiv[style^=\"position: relative; width: 230px; height: 400px\"],\nimg[src*=\"баннеры\"]",".reklama_sidebar_ads",".offer","#widgets .custom-html-widget","a[href*=\"smarty.sale\"],\ndiv[class*=\"smartys\"]",".card.promo,\n.header__advertising-block,\n.side-promo-place-right","#ipbwrapper > div[align=\"center\"],\n.borderwrap > [id^=\"p_row_\"] ~ table[width=\"100%\"]:not([id^=\"p_row_\"]),\ndiv[style=\"width:900px; margin: 5px auto 5px auto\"]","#b-bottom,\n#b-top","div[class^=\"brrr_\"]","body > div[id][class]:has(> div[id][class] [class^=\"adblock\"])",".megaShadow,\n.paywall-activated,\n.topAdvertize","div[class^=\"GbShadow\"]","div[class=\"post bg1\"]",".no_ampr","div[id^=\"b_script\"]","#pun-announcement,\n.tclcon > noindex,\n.tclcon > table[height=\"31\"]","._im72e8,\n._y2b48h","#dle-content > table:first-child center,\n.menu > a:not([href^=\"/\"]),\nnoindex a[target=\"_blank\"]",".greyblock,\n.rightblock > .shadowp","center > object > a[target=\"_blank\"]","div[id^=\"t_Banner\"]",".wrapper > div[style^=\"overflow:hidden\"]","blockquote",".owl-wrapper-outer .slideAlt,\nbody > .gifimg","#head_banner","#special-link,\n#title-partner-news,\n.smi24_tisers,\na[href*=\"makfa.ru/\"]",".top-banner__container","div[style$=\"250px;\"]","[class^=\"LinkZen\"],\ndiv[class^=\"Banners_skeleton_\"]","#top-pannel,\n.top-header-wrapper",".lad","img[src*=\"/images/undefined/\"]","a[href=\"https://vk.com/sochirealtys\"]","#column_center > [class^=\"modern_block\"]","a[target=\"_blank\"] > img","body > #page ~ div[id][class]",".branding-banner,\ndiv[class^=\"block_1\"]",".bldownload > b,\n.bldownload-reklama,\n.reklamafull","#trance","#closing,\n.agregator_R,\n.fs_bottom > noindex,\n.logo,\na[href^=\"http://psychosearch.ru/\"]","a[href*=\"a24help.ru\"]","a[href][style^=\"display:block\"] > img,\nbody > div:not([id]):not([class])[style^=\"position: relative;z-index:\"]",".grayb",".cFadeDark,\n.flatBottom,\n.flatTop,\n.partners-blocks-wrap,\n.row > .col3.positionRelative","ul > li > a[href*=\"erid=\"],\nul > li > a[href*=\"erid=\"] ~ div","#side_left > .bnav ~ *,\n#side_right > .side_right_bl ~ *",".rhead","#runBanner,\n.col > .news-grid:has([class*=\"adv-\"]),\n.l-branding-top,\n.underNewsAdb,\ndiv[id*=\"Adb\"]","[data-test=\"header-adv-logo\"]","div[data-test=\"header-sticky\"] > div > section ~ div","#read-mediam,\n.head-b,\n.right-b,\n[src*=\"://73online.ru/advert/\"]",".bk-widget,\na[href^=\"/bookmakers\"]","div[class^=\"article-partners\"],\ndiv[class^=\"smi24_informer\"]",".topic_shop_offers,\n[data-campaign-code][data-url*=\"http\"]","#GPM_7days_D_Top,\n#RutubePlayerNews,\n#comment_banner,\n#news-widget,\n#page_content > div > div:not([id]):not([clas])[style*=\"padding:\"],\n.b-hz2_type_section,\n.b-section_content_partners-news,\n.header-7days__branding,\n.header-7days__recommendation_advertising,\n.material-7days__paragraf-info:has(> #RutubePlayerNews),\n.mtop,\ndiv[class*=\"js-banner_ad_\"],\ndiv[id][style=\"width: 970px; height: 250px;\"]","#smth,\n#ya-bottom",".padding.right > .block",".vp-content-l-r > div > *",".advzone,\n[id^=\"site-welcome\"]","marquee[scrollamount]",".bsac",".ranbne.clearfix","#center_b,\n#up_b,\na[href^=\"http://boostor.ru\"],\na[href^=\"http://goto.astdn.ru/\"]","a[href*=\"funpay.ru\"]",".ignore-select","[src*=\"/images/banners/\"]","#games",".advs","td[valign=\"top\"] > table[height=\"180px\"]","div[style*=\"/design/common/pic/please\"]","#top_promo,\nimg[src^=\"/uploads/promo/\"]","a[onclick][href*=\"adhands.ru\"]","a[href*=\"//parnuxi.biz\"]","div[align=\"center\"] > table[width=\"160\"],\ndiv[align=\"center\"] > table[width=\"962\"]","td.t_bg > center:has(> a[href][target=\"_blank\"] > img)","img[width=\"170\"][height=\"340\"][border=\"0\"],\nimg[width=\"570\"][height=\"80\"][border=\"0\"]","#popup3,\n.fancybox-overlay",".widget_custom_html.FixedWidget__fixed_widget","a[href*=\"://dzen.ru/\"]","#partners-news-container","#yandex-zen,\n[aria-label=\"Реклама\"],\n[data-test=\"SECTION\"] > [data-test=\"SECTION-CONTENT\"]:has(> div > [href^=\"/out/?url=\"]),\na[href^=\"/out/?url=\"],\ndiv[class^=\"Advert\"]","noindex > a[target=\"_blank\"][rel=\"nofollow\"]","#nadoelo,\n.content:has(> div > #nadoelo)","#header-links,\na[href^=\"http://www.ag.ru/go/outer\"]","#container > style + ul[class]",".cpatop,\n.offersblock,\n.vnimanie",".side-cpa",".widget_zen_widget",".adchoice,\na[href^=\"/gobanner\"],\ndiv[class*=\"adagro\"],\ndiv[class^=\"brending\"],\nsection[class^=\"my-\"]",".adv_content","img[id^=\"cradv_\"]",".bnrs","#popup-bottom","#rightside .main-content:has(> span script)",".b_read_online:has(> .litres_fragment_body),\n.best_sellers,\n.list_other_sites,\n.list_other_tab,\n.wrapper_ban",".container:has(> div[align=\"center\"] > video > [src*=\"://dental-paint.ru/\"])","#leftcol > *,\n#rightcol > *","#advise",".header-decor.index","div[class^=\"two-column-page-sidebar-slided-boners\"]",".tz-widget.container",".badven,\n.bpartn,\n.centersideinn > .cblock","#sidebar-floating","#alia_modal,\n#vita_modal",".baner_top,\n.block_saitbar > .ul_partner ~ .link_all,\n.ul_partner,\n[href=\"union/advert.htm\"],\na[href*=\"multiwork.online/\"],\ndiv[style=\"width: 600px; height: 90px; margin-left: auto; margin-right: auto;\"],\niframe[src*=\"multiwork.org\"]",".banner.black,\n.banner.red,\n.coefficients,\n.field-item > p:has(noindex [href*=\"adfox.ru\"]),\n.field-item > p:has(noindex [href*=\"pari.ru\"]),\n.field-item > p:has(noindex [href*=\"utm_campaign\"]),\n.last-news:has(> .block_title ~ [id^=\"unit_\"]),\n[onmouseenter=\"onClickPbButton()\"],\na[href*=\"://aff1xstavka.com/\"],\niframe[src*=\"ad.allboxing.ru\"]","a[href^=\"https://relap.io/\"][data-ad-link]",".article__aggr",".widget-bnnr,\nmain > .container > .site-content:has(> .content-banner)","div[id^=\"promo_\"]",".header__main-banner,\n.header__top-banner","#content_r_box,\ndiv[id^=\"blockbann\"]","a[href*=\"-pokupka-zhilya-\"],\ndiv[id^=\"bx_\"]","[id*=\"baner\"],\nimg[src*=\"/theme/img/hmwk/\"]",".bet-wrap,\n.pasta-wrap,\na[href*=\"fonbet.ru\"]","a[href*=\"mediaget.com\"]",".fancybox-container",".td-bnr-wrap-full,\nbody > div[style=\"display: inline-block\"],\ncenter > div > a[rel*=\"nofollow\"][target=\"_blank\"]","[src*=\"/imgr/\"]","a[href] > img[style*=\"display:\"]","big > a","#page > center","#action",".personal > .overlay,\n.popup.subscribe_panel",".a,\n.a_top_place,\n.b-nav li > a:not([href^=\"/\"]):not([href*=\"altapress\"]),\n.b-sidebar-right > div[style*=\"height: 300px;\"]","div[class*=\"partners\"]",".bgbanner",".active_bet,\n.book_banner,\n.fix_block,\n.forecast-ad-line,\na[href=\"/category/theory/\"]",".bookmakers","div[id^=\"amic_banner_\"]","#top_section #smflogo,\na[href*=\"amit.ru/service-center\"],\na[href*=\"evroremont.amit.ru\"]","div[style=\"width:300px;height:200px\"]","a[class*=\"rekl\"][target=\"_blank\"]:not([href^=\"http://amurpress.ru/\"])","table[align=\"center\"][width=\"90%\"] > tbody > tr > td[align=\"left\"] + td[width=\"234\"],\ntbody > tr > td[width=\"50%\"][valign=\"top\"] + td[width=\"120\"][valign=\"top\"],\ntbody > tr:has(> td[valign=\"top\"][width=\"130\"] > font > [href=\"/advertising/\"]),\ntbody > tr:has(> td[valign=\"top\"][width=\"130\"] > font > [href=\"/approach/\"]),\ntd[width=\"100%\"][align=\"center\"] > a[href] > img,\ntd[width=\"600\"] + td[width=\"250\"] > center > a[href] > img","div[id^=\"ad_header\"]",".adb-def",".you_a",".brand-link","[class*=\"af_advert_\"]","a[href^=\"https://alitems.com/\"]",".a_mh250,\n.bottombanner,\n.col-right > .block,\n.promo_head,\n.promo_middle,\n[onclick*=\"brand\"],\ndiv[id^=\"krt-\"]","#slides_top",".widget_html_javascript_adder",".layer_box > #header,\ndiv[class=\"layer_box flex\"] > a[href][target=\"_blank\"]",".esg-bleach",".first-popup,\n.videoroll-banner,\n.vsemayki-banner",".poverh,\n.sidebar div:has([data-relap-id]),\na[href=\"https://animedub.ru/adblock.html\"],\ndiv[class^=\"rolic\"]","#offreklama","noindex > a[style][target=\"_blank\"]",".badversting,\n.ban_center_screenlist,\n.basecont,\n.randomnews > .videorek","#drakensang","#snow","div[id^=\"news_anisim_info_\"]",".container-fluid > .row:nth-of-type(2),\na[href*=\"/teasers/\"]","a[href^=\"http://bonus123.com/\"]","#block-block-1,\n#block-block-21,\n#block-block-31,\n#block-block-77,\n.top-text-block",".featured","blockquote:not([style=\"border:2px #000000 dashed; padding: 18px; margin:0px 0px 0px 0px;\"])","center > a[href]:not([href=\"//www.liveinternet.ru/click\"]) > img[src]",".rightColumn a[href][target] > .Recbanner","div[class*=\"sredstvo_container_group\"]","a[href^=\"/ads.php?\"]","a[href*=\"://timeweb.com/\"]","#sponser_vidjet","#flip_container",".sidebar-item.banner","div[id^=\"advBox\"]",".native-brand > div",".backgroundmain,\n.tingle-popup,\n[data-information]",".banner-zone,\n.menu-item > a[href*=\"utm_campaig\"],\n[class*=\"home-credit\"]",".dle_b_ad_block",".theiaStickySidebar > .widget_custom_html","div[class^=\"Eshop\"]","#data-column-center-adv,\n#post-data-adv,\n#right-data-container [bannerid],\n.orgs-adv-c",".baner-wrap-inside,\n.kp-top-banner","#doscroll_prompt,\n#invite_bottom-news,\n#main_adv,\n#sticky_top-adv,\n.col:has(> [id^=\"yandex_rtb_\"]),\n.col_adv,\n.tabloid,\n[class*=\"adv_\"],\n[class*=\"cc_adv\"],\n[class]:has(> a[href] [class*=\"partner\"]),\na[href*=\"://argumenti.ru/ad_informer/click/\"],\ndiv[id^=\"rtb_\"],\ndiv[style*=\"height: 264px;\"],\nheader > div[style^=\"background:\"]","#botr,\n#rzdl,\n#topr,\n#yar","a > img[width=\"160\"][height=\"120\"]",".sp-column > .sp-module:has([id*=\"ScriptRoot\"])","a[onclick^=\"setClickBanner\"]",".randomizer,\n.tiz_intext",".rela_page,\na[href=\"span class=\"]",".advertisingColumn",".b240,\n.midtizer,\ncenter > noindex > div[style*=\"height:\"]","div[style=\"border: 1px solid black\"]","a[href*=\"internet-gazeta-world.ru/\"]","#tooplate_wrapper > center > table[style*=\"background\"],\n#tooplate_wrapper br","div[class^=\"direkt-\"]",".tablebg:has(> tbody > tr > td > .nalivaj)","[class^=\"vigvam\"],\ndiv[class^=\"snow\"]","a[href*=\"://beta.mediafort.ru/textclick.php?id=\"],\na[href][style*=\"display: block\"]","div[id^=\"ut-1\"]","#alfa-dart",".b-adverts","[id^=\"agat_plus_banner\"]","#teleastro","div[style=\"height: 120px;\"]","#right-column > noindex","#fullscreenmf",".nopad",".au-candy,\n.au-prime-page-desktop-banner,\n.au-right-banner,\n.main__appendix",".blok_new > div[style]",".opadv",".VertisAds,\n[style^=\"height:\"][style*=\"250px\"]:empty,\ndiv[class^=\"AdWithFixedHeight\"]",".textwidget > div > a > img",".sitebar",".aside-block:has(> .media_aside_our-partners),\n.media_aside_our-partners",".kaka_zone","#myID",".top_banner_hidder,\n[class^=\"block_tgb\"],\na[href=\"javascript:;\"][class=\"vetrine\"]",".banner_div",".no_gav","div[id^=\"adv-block\"]",".sticky","#poppup-ads-banner,\ndiv[style=\"height:250px\"]",".g-banner__columns",".topline__branding__wrapper",".topline__disable-adv__button,\n.topline__item__image-block,\nbody div .banner__container,\nbody div .banner__filmstrip","div[class^=\"fox-tail\"]",".banner_content,\n.mainBannerBlockCenter","#shop","div[class^=\"stuleblok\"]",".ad_yad","#topBanner","a[href^=\"http://www.hamqsl.com/\"]","div[class^=\"advert-\"],\ndiv[class^=\"items-ads-\"],\ndiv[class^=\"style-ads\"],\ndiv[class^=\"styles-item-\"]:has(> [data-marker=\"bx-recommendations-block-item\"] > div[class^=\"body-actions-\"]:empty),\ndiv[class^=\"styles-item-\"]:has(> div[class^=\"advert-mimicry-\"])",".tizers",".in",".on",".outreach","body > .info-block,\niframe[src*=\"smi2\"]",".wrap > noindex","[class*=\"banner-border\"]",".bla-bla-car","#ya_feed_cont",".banner__top","img[src*=\"awd.is/banner/\"]","a[href*=\"stulspb.ru\"],\na[href*=\"zasvetom.ru\"],\ndiv[id^=\"boom_bar\"]",".banner_bot,\n.header_top,\n.teaser_links","div[class^=\"rkl\"]",".info-wrapper",".adfox-video-desk,\n.format_video_comment,\n.grid > div[style^=\"height: 250px;\"],\n.viqeo-embed,\ndiv[class*=\"rennab-\"]",".brand-list,\n.clearfix.blog-incut-uad,\n.header-links,\n.mb7.clearfix,\n.nivea-pr-block","a[target=\"_blank\"] > img[width=\"210\"][height=\"115\"]","td[width][background^=\"pic/fill\"]",".branding-bg,\n.gpb-currency-banner,\n[data-adfox-container],\n[data-dfp-container],\n[data-gtm-view*=\"view_calc_widget_content\"],\ndiv[data-name=\"custom:advertising.block\"]","#product-best,\n.g_ban_bot,\n[data-offer],\narticle > aside:has(> [data-offer])","a[href^=\"https://barneos22.ru/go/\"]","a[href^=\"/rk.php\"],\ndiv[id^=\"fixed_bottom\"]",".ea-col,\n.rblock,\ndiv[id^=\"eadvt_wrapper\"]","body > .subscribe-popup","p[style=\"border: 3px solid #000000; background-color: #FFFF80; padding: 10px;\"]",".maincontentcell td[valign=\"top\"]",".container > .wrapper > .row > .grid_4,\n[src*=\"/global/banner/\"]","a[href^=\"https://vk.com/extrasense_russia\"]","[data-blockid^=\"app_cms_Blocks\"]","html > .q1","a[href*=\"//go.acstat.com/\"]","div[class^=\"myblockbottom\"]","#root","a[href=\"http://rur.beeline.ru\"]","a[href^=\"http://belive.ru/ordering_form/\"]",".danabol",".right > :not([style=\"padding-bottom: 25px;\"]),\na[href*=\"r.php?r=\"]",".adbg",".fixed_link--telegram-group",".install-pack-info,\n.ip-motto,\n.ip-motto + table > tbody > tr:last-child > td:not(:last-child),\n.ip-motto + table > tbody > tr:not(:last-child),\n.ip-motto + table > thead,\nmain > article.post:has(> header > .mainpage_title > [title^=\"InstallPack\"])",".rightbann","#mine","td[align=\"left\"][valign=\"top\"][class^=\"t\"]",".ya-partner_ads-up > *",".form-group:has(> .ulogin_block)",".topicbanner_box",".block_smi",".widget-direct,\n.widget-pomogi",".cover-msg,\n.pg-section:has(> .abox-layout),\n.section-marked,\n.sticky-promo-wrapper,\n[src*=\"/uploads/commerce/\"]",".reclame",".fark",".plashka","td[valign=\"top\"][width=\"200px\"][height=\"600\"] > div[style],\ntd[valign=\"top\"][width=\"240px\"][height=\"600\"]","#sidebar > div[style*=\"visibility: visible !important\"],\ndiv[style*=\"block\"][style*=\"center\"][style*=\"width:\"][style*=\"height:\"]",".lending_adv_top",".bnr-top_holder",".sidebar__content-wrp:has(.sidebar__image > a[href^=\"http://gamazavr.ru/\"]),\na[href^=\"http://gamazavr.ru/\"] > img",".entry-content > div[style]","#faq-index,\n.box:has(> noindex),\naside > div:has(script),\naside > noindex",".bnr","div[class]:has(> [id^=\"yandex_rtb_\"])",".b-promo-slider",".banner-default","a[href*=\"/goto.php?file=\"]","div[class][style*=\"z-index\"][style*=\"999999;\"][style*=\"background\"][style*=\"rgb\"]","[id^=\"ai_widget\"],\ndiv[class^=\"blackwot-\"][style]","div:has(> [id^=\"yandex_rtb\"])",".widget_custom_html:last-child",".js-barmen-loaded:not([data-barmen=\"Showcase\"])",".sidebar > div[class^=\"block\"]",".widget-content > #overlay,\na[href*=\"bolotov.com.ua\"]",".adsbygoogle > *","div[class^=\"bc-advertising\"]",".XenAdvShop,\n.message[data-author=\"KADR\"] > .primaryContent .signature",".banner-img:not([href^=\"http://bnkirov.ru/\"]):not([href*=\"rodnaya-vyatka.ru\"]):not([href*=\"che-online.com\"]),\n.brand-bg,\n.plate-panel",".gift-banner,\na[href][class^=\"ls_\"]",".hungry",".seedbnrs",".bookmaker-container,\na[data-href*=\"://bmbrdr.ru/\"],\na[href*=\"://bmbrdr.ru/\"],\ndiv[class*=\"banner-placeholder\"],\ndiv[data-banner-place_id]",".partners-widget","a[href*=\"bookmakers\"]","a[href*=\"clickfrm.com\"]",".maincont > div[class=\"clr\"],\n.mdl,\n.rightcol,\ndiv[id^=\"BlockId\"],\nimg[src^=\"/promo/\"]",".warning",".litres_widget_body,\ndiv[style^=\"width:240px;height:400px\"]",".widget_text:has(.medicinetizer)","#sidebar > .block:has(> .blockcontent > noindex > [id^=\"kdm-bloc-\"])","#zfix",".cookielaw-modal-layer",".td-all-devices",".td-banner-wrap-full","#dle-content a[href*=\"aHR0c\"]",".theiaStickySidebar > [class^=\"post-\"] ~ .clear20",".my-sheet-Adv,\n.preloadBannerSizer",".ebooks-widget,\n.honey,\n.shelf:has(> .adaptive-banner),\n.shelf:has(> .ebooks-widget),\n.shelf:has(> [data-disclaimer*=\"Реклама\"]),\n.shelf_type_recommendations,\n[data-disclaimer*=\"Реклама\"]","#wb_Image1044,\n[onclick^=\"window.\"][onclick*=\"://\"],\na > img[alt*=\"Яндекс\"],\nbody > #container > div[id^=\"SlideShow\"] + div,\nbody > [id$=\"_master_footer\"] ~ [id$=\"_master_footer\"] > div[id$=\"_master_footer_Container\"] > div[id^=\"Layer\"],\ndiv[id^=\"SlideShow\"],\nimg[src*=\"/images/Banner_\"]",".add_zen",".in.fade.modal","[data-alias=\"Copyright\"] .widget-area > .widget_text:not(:last-child):has(script),\naside[data-alias=\"Заголовок\"] .widget-area > .widget_text,\naside[data-alias=\"Над новостями\"],\naside[data-alias=\"Под меню\"],\naside[data-alias=\"Слева\"] .widget-area > .widget_text ~ .widget_text,\naside[data-alias=\"Справа\"] .widget-area > .widget_text ~ .widget_text",".a-d-v,\ndiv[class*=\"advbig\"]","body > .ui-widget.ui-dialog",".banner-top-wrap,\n[class^=\"sideBanner\"],\nhtml[style*=\"overflow:\"] > body > div:not([id]):not([class]):not([data-stories-widget-settings])",".entry-content > div[style^=\"float\"]","div[id^=\"tab_scroll_blok\"],\ndiv[id^=\"tab_scroll_blok\"] ~ table,\ntable[align=\"center\"][height=\"360\"],\ntd[align=\"center\"][style*=\"height:\"][style*=\"360px\"]",".aff-offers,\n.sidebar_top > .mobile-hide",".currency__logo,\n.interests-box,\n[class*=\"__advertising-\"],\na[href*=\"erid=\"]",".intext-block",".page__section:has(> .partner)","div[id^=\"bnr_\"]",".ad_header_inner",".pad > .readd,\n.rek, .rek ~ .ramka,\ndiv[class^=\"ban_\"],\ndiv[class^=\"bsys_\"]","[class^=\"baner\"]","#sbox-overlay,\n#sbox-window,\n.art-Header,\n.art-sidebar1 input[src^=\"/images/banners/\"],\n.banneritem,\n.vtem_bannergroup,\na[target=\"_blank\"] > input[type=\"image\"][style]","a[href*=\"://goo-gl.su/\"]","#byw_top_banner",".arenda,\n.fon-reiting,\n.kaz,\n[class^=\"rekl\"]",".no_amp","div[style^=\"min-height: 250px;\"][style*=\"background:\"]","body > div[style*=\"width\"][style*=\"z-index\"][style*=\"position\"]",".static_re,\ntd[align=\"center\"][valign=\"top\"][width=\"48%\"]",".post-content > p[style*=\"line-height: 230%\"]","#a_sidebar_container,\n#under-calc-ad-placeholder",".bottomFixedBlock","div[class^=\"page-block-ad\"]",".commercial","section > .container-fluid > div[style^=\"width:\"][style$=\"%\"]",".brand-overlay,\n.item-adv","div[class*=\"HHC-Banner-\"]","div[class*=\"wrapper-banner\"]",".recomend-section:has(> .flex > :not([data-href^=\"http://carrotblog.ru/\"]))","a[href*=\"/adclick.php?bannerid=\"]","#page > :empty,\n.bx-composite-btn,\n.extra,\n.main > :empty","a[href^=\"http://catchenglish.ru/includes/redirect\"]","a[href^=\"http://ad.cbonds.info/\"]","a[href*=\"advertisement\"]",".bookingaff","a[href=\"//cdnvideo.ru/?from=playercdn.cdnvideo.ru\"]","div[id^=\"ttiz_\"]","#banner_right_place,\nmarquee","#adver_block_left,\n#adver_block_right","a[href*=\"chatovod.ru/cli\"],\na[href*=\"chatovod.ru/cli\"] *","a[href*=\"catcut.net\"] *","div[class^=\"offer-\"]",".ru200200",".ru360120",".ru560130",".ru56080",".min-h-90,\n[data-provider=\"yandex\"],\n[jello-component=\"yamarket\"]",".header__block > .header__block-title,\n.panel-group > .panel_primary:has(> .panel__body > #MediaMetricsInject),\n.widget-any-content","#bl_top_reklama,\nbody > div[style*=\"width: 990px\"],\ndiv[style^=\"clear: both\"] a[href]:not([href*=\"chelnyclub.ru\"])","img[src*=\"/img/banners/\"]",".asideContainer > aside[class=\"asideBox \"]:first-child","body > div[class*=\"ui-widget\"]","#glory","#headlineAdv,\n#topAdsBlock","table[style=\"width: 100%; height: 90; margin-bottom: 5px\"]",".logo.right","#datebar,\n#wrapheader > div[align=\"center\"]:first-child,\ndiv[style=\"float:right; margin-right: 5px;\"],\nimg[width=\"120\"][height=\"40\"],\nimg[width=\"224\"][height=\"60\"]","a[href^=\"http://chinaprices.ru/go.php\"][target=\"_blank\"],\na[href^=\"http://www.gearbest.com/m-promo\"]","#mouselayer,\n#top-lighthouse,\nbody > center > a[href=\"/aliexpress.php\"]","body > table[height=\"80\"]","#ipsLayout_sidebar .ipsWidget:has([alt=\"advertisement_alt\"]),\ndiv[style*=\"min-height:100px;\"]","[alt=\"advertisement_alt\"]","a[href^=\"http://pakhomov-school.ru/partners/chiptuner\"] > img","div[class^=\"chitaru__wonder\"],\ndiv[id^=\"bnr\"]","div[id^=\"news_chto_\"]","#blackfire","#adfox-stretch-banner,\n#special-promo-link-container",".banner_wrap.MAIN_RIGHT,\n.banner_wrap.MAIN_TOP,\na[href*=\"/adv\"],\ndiv[class^=\"banner\"][class*=\"LENTA\"]",".header__adv",".link_test",".popupBlock","a[href^=\"http://author24.ru/unreg-order/\"]","[data-cfpa],\ndiv[class^=\"click-content\"]",".container-banners",".banner_tgb","[src=\"//an.yandex.ru/system/context.js\"] ~ iframe","#kplus-popup-banner",".an-pic-top-box,\n.cross-ans-box","#zilfond,\n.ads-soloway",".adriver","body > div[class][style*=\"background\"][style*=\"display: block\"]",".objects_row > .cnb-zone > a:not([href*=\"cnews.ru\"]),\n.section_mainnews > .container:has(> .line_pattern > a[href^=\"https://market.cnews.ru/\"]),\n.tizer_block",".header-brand-logo",".section_widget_market",".bottom-banner",".post > .entry-tags + .row,\n.post > .entry-tags ~ div[style*=\"clear\"],\n.site-header__banner",".admitad-checker-popup,\n.custom-reklama","#down_ads","#mbanners",".partner-content,\n.top-sidebar-banner",".kursInformer #head-content,\n.kursInformer #ref",".ad_nameplate","body > div[id^=\"pw\"]",".free-period-banner",".D_Top,\ndiv[class^=\"D_\"][class*=\"x\"]","table[align][frame=\"rhs\"][style]",".bannercount","#kph0",".banner__sidebar",".top_tizer_cell,\nnoindex > .normal_tahoma","td[width=\"556\"] > :not(#dle-content)","body > div:not([id]):not([class]):empty","#calcs1",".b-top-banner__content,\n.background-figure,\n.imgCorp,\n.noteFrame,\n.top-menu-banner","#teaser_table","#pr_top,\n.brendingBg,\n.promo_block","div[id^=\"facebook_win\"]",".--ligastavok,\n.p__header > .p__header-image ~ div::before,\n.post-content > div:not([class]):not([id]) > div[class]::before,\n.wtb,\n[class*=\"-odd\"],\n[class*=\"_book\"],\n[class*=\"_odd\"],\n[data-odds-series],\na[href*=\"/cq67er/\"],\na[href=\"https://cq.ru/bookmakers\"]","#after_first_post_yadirect,\ndiv[style] > noindex a > img,\nimg[src*=\"cqham.ru/forum/ad/\"],\nimg[src^=\"ad/\"],\nimg[width=\"380\"][height=\"60\"],\ntable[width=\"937\"][height=\"60\"]","div[style^=\"width:\"][style*=\"100%;\"][style*=\"display:\"][style*=\"block\"]","#sidebar > #fixed,\n#sidebar > .block-social:nth-of-type(2),\n.anime > script + div[id],\na[href*=\".creativportal.ru\"]","a[href*=\"www.sko.ru/\"][target=\"_blank\"]",".bannercenter",".widget > a[href][target=\"_blank\"]",".banka",".main_block > center > .slider,\n.mainb > .main_block:has(> center > .slider)",".smile","a[href=\"https://www.sogaz.ru/sport\"]","#wrapfooter,\nA[onclick^=\"countAdClick\"]","a[href=\"http://autosteamgifts.ru/\"]",".topBanner","a[href*=\".space\"]","#btn_wrapper,\ndiv[class^=\"index-module__notice-\"]",".goto_news__block,\n.js_out-block ~ .modal-backdrop, .js_out-block","div[class*=\"bnrs-block\"]","#__next > div > main + div + div,\n#page-error-modal",".aside > .widget > [class*=\" \"]","#yatopbanner,\n[style^=\"margin: 3px 0px\"]:has(script),\ntable[id^=\"post\"] ~ div[style^=\"margin: 3px 0px\"][style*=\"display\"]","#bl_05",".infoblock > .full:has(> div[style*=\"height:\"] > div > div[id^=\"adfox_\"]),\ndiv[class^=\"relap-\"]",".kaspersky-chat,\n[class*=\"bookmaker\"]:not(.root),\na[class^=\"vkPlay\"],\na[href*=\"erid:\"][target=\"_blank\"],\ndiv[class^=\"asideWidgets_\"] > .rounded-block:has(> [href*=\"bookmakers\"]),\ndiv[class^=\"sponsor\"]","a[href*=\"betboom.bet\"]",".b-banner_600x90",".vc_column_inner > .vc_column-inner:has(.g-single > [id^=\"yandex_rtb_\"])",".b-promo__placeholder,\n.b-sidebar-ad,\nsection[data-uid=\"ad\"],\nsection[data-uid=\"extraAd\"]","div[id^=\"branded_img\"]","#widgetized-area","#mvp-post-bot-wrap,\n.left_sidebar","div[class^=\"whatever\"]","body > table","body > span[id^=\"s\"][style]","#mdl_ctnr","#external_iframe,\n.article_block:has(> [id^=\"unit_\"])","#r,\n.bottom_bun,\n.bun,\n.top_bun","#preveav,\n#promo-fix,\n#uzhanina","[id^=\"smartrotator_ad\"]","#allEntries ~ a[href]","img[width=\"900\"][height=\"100\"]",".subscribe-modal,\na[href][target=\"_blank\"][rel=\"noopener noreferrer\"]",".ddd,\n.offer-ac,\n.post__entry > div[style^=\"background\"],\n.vtizer","a[target=\"_blank\"] > img[width=\"180\"]",".top_baners > a[href][target=\"_blank\"]:not([href^=\"/deti/index.php\"]),\ntbody > tr > td[valign=\"top\"][align=\"left\"]","a[href^=\"http://lnd.m-mba.ru/\"]","div[id^=\"SRTB_\"]","div[class^=\"mypopup\"]",".ad-blocked-message,\ndiv[class^=\"advertising-\"][class*=\"-popup-overlay\"]","div[class^=\"yandex-video\"]",".menu_block,\n.side_banners_box","td[valign=\"top\"][style^=\"background\"] tr[height]","a[href*=\"iherb.com\"]","#delta_18,\n#fly-container,\n.footer-other-interesting",".acid","a[href^=\"http://\"]:not([href^=\"http://www.youtube.com/\"]) > #banner_l","#primary > article:has(> .panel > .panel-heading > [href=\"/reklama.php\"]),\n#secondary > aside:has(> .widget-title > [href=\"/reklama.php\"])","#dirlotbah,\na[href][onclick*=\"Banners\"]","#topbanner-wrapper0","#navlist a[href][target=\"_blank\"],\ntd[align=\"right\"] a[href][target=\"_blank\"]","#divHeader",".goods ~ h3, .goods ~ h4,\n.page_index.content > p a[href][target=\"_blank\"] > img",".cont_in_c > .item","div[align=\"center\"] a[target=\"_blank\"] > img,\ndiv[class^=\"tm-article-banner\"]","#grid-loop > .post:has(> a[href*=\"://urldirect.ru/\"]),\n#top-bar,\na[href*=\"://urldirect.ru/\"]",".adaurum,\n.main_wrapper > div[class=\"column column_left\"],\n.right.article-reklame > * > :not(.block_all_day) > *,\n[class*=\"container\"][class*=\"partner\"]",".MyOpacity1","img[src*=\"/partner-banner/\"]","div[class^=\"creative-placeholder\"]","#myModal,\n.jgcabd-container","#vid_vpaut_div",".hban","#rbc",".center_tizer,\na[href*=\"kakprosto.ru\"]","[data-test=\"custom-wrapper\"]:has(> div > [href*=\"movix.ru/\"])","#slide-close,\n#sliding-bar",".duck-line","div[class^=\"a7-btns\"]","body > #pop-up-window","#adv-sidebar,\n.over-rsi,\ndiv[style^=\"display: flex; align-items: center; justify-content: center; background-color: #ECF3F7; margin-bottom: 5px;border-radius: 7px; padding: 5px;position: relative;z-index: 0; min-height:\"]","#sidebar > [style=\"width:420px; margin-top:15px;\"] > div ~ div","[class*=\"yandex-news-promo\"]","tr[style*=\"important\"]","a[href][title=\"http://rek-chek.ru/\"]","#mgid,\n#novoteka,\n#sidebar > .mb10,\n.tobbanner","td.windowbg3",".sticky-holder > .block-title.yellow","div[class][data-element*=\"BANNER\"],\ndiv[id^=\"AdwolfBanner240x400_\"]","#kalambur,\n.bn-btm,\n.p-sidebar > style + [class],\n.subline ~ :not([id=\"navigation\"]):not([class=\"page-width\"]),\na[href*=\"/gobet/\"],\na[href^=\"/plain/\"],\nspan[id^=\"zone\"]",".penci-sidebar-left,\n.pered-kontentom,\n[href*=\"://dotaguide.ru/go/\"]","body > .wid-fb","#sp-component .custom","#timer_1","div[class*=\"banner\"]:not(.banner-vk)","#adblock_popup","#banner240x400,\n#dv-top,\n#side-dv,\n.aio_banner,\n.js-adv-widget,\n.mywidget-item[class*=\"teaser\"],\n.nav-menu > li > a[href][target=\"_blank\"],\n.side-link,\n[class*=\"autoRu\"],\n[class*=\"autoRu\"] + .hr,\ndiv[class^=\"osago-\"]",".c-darkening-hover-container ~ :not(.c-darkening-hover-container) > div[id],\n.c-dv-p,\n[data-target]:has(> div > h3 ~ [href*=\".drom.ru/\"]),\n[data-target^=\"drom_\"],\n[data-track]:has(> div[id]:empty + script),\na[href=\"/_api/drom/navigate\"],\na[href] > div > div > div > div,\na[href][target=\"_blank\"] > img[src][style^=\"width: 100%; height: auto;\"][style*=\"vertical-align: middle; max-width: 240px;\"],\ndiv:has(> a[href] > div > div > div > div),\ndiv[class]:has(> div > .drom-logo),\ndiv[class]:has(> div[id][class] > a[href] > img[src^=\"https://avatars.mds.yandex.net/get-adfox-content/\"]),\nimg[src^=\"https://avatars.mds.yandex.net/get-adfox-content/\"]","div[class] > a[href][target=\"_blank\"] > img","#dle-content > #overlay","#rest_vl_block,\n.b-media-cont_theme_adverts,\niframe[src*=\"yummy.drom.ru\"]","div[class*=\"candy\"],\ndiv[id*=\"candy\"]","#dromRightCol,\n#drom_catalog_block,\n.b-banner-group",".view-advertisement-blocks",".ALMGcspq,\n.distribution,\n.layout__right-column > div[class*=\" \"][style] > div[class*=\" \"] > div:only-child,\n.propaganda,\n.supbar--top,\ndiv[style*=\"banner-height\"]","#center-block > noindex,\na[href^=\"//talk.\"][target=\"_blank\"]","#footer noindex,\n.mainbanner","#r-colonka > .f-block ~ .f-block ~ .f-block,\n#r-colonka > a[target=\"_blank\"],\n#r-colonka > center,\n[align=\"CENTER\"] > a[href][target=\"_blank\"] > img,\ndiv[id^=\"edit\"] > div[style=\"padding: 6px 0px 0px 0px\"]","img[src*=\"/imgnew/\"],\nimg[src*=\"/imnew/\"]",".zenad-card-rtb","#teaser,\n#ya-dist,\n._is-floor-with-ds-cards,\n._is-for-article-floor,\n._is-for-video-floor,\n.adv-ecom,\n.adv-skeleton___main,\n.article-page-layout > main > div > div[id],\n.article-render-mobile__embed_embed-type_yandex-direct,\n.article-right-ad-block,\n.article__bottom-embed-wrapper > .ad-split-embed + div,\n.viewer-layout__content div[class*=\"-player \"][aria-label] ~ div:not([class]),\n.zen-ui-viewport-expansion__container:empty,\n[aria-label=\"Карточка этажа\"] > div[class]:not([class*=\"rapper\"]),\n[aria-label=\"Таб категорий\"][href^=\"/floors-promo/\"],\n[aria-label^=\"Peкл\"],\n[aria-label^=\"Карточк\"][aria-label*=\" p\"][aria-label*=\"кл\"],\n[aria-label^=\"Карточк\"][aria-label*=\" рекл\"],\n[aria-label^=\"Карточк\"][aria-label*=\"мы\"],\n[aria-label^=\"Рeкл\"],\n[aria-label^=\"Рекл\"],\n[class*=\"desktop\"] ~ [id*=\"teaser\"],\n[class^=\"card-part-wrapper\"] ~ div[class=\"\"],\n[class^=\"dzen-desktop\"] ~ div[id$=\"-popup\"],\n[class^=\"dzen-desktop--top-micro-app__\"] [class^=\"dzen-desktop--top-micro-app\"][class*=\" \"],\n[data-name=\"video-in-combo-zen-container\"],\n[data-ssr],\n[data-testid=\"recommend-auth-popup\"],\n[id*=\"-teaser\"] > div[id],\n[id*=\"_floor_\"] article[class]:not(._is-desktop) ~ article._is-desktop,\n[id*=\"_tsar\"],\na[href*=\"://t.mail.ru/redir/\"],\na[href*=\"://yandex.ru/an/count/\"],\na[href*=\"://yandex.ru/an/count/\"] ~ a[href*=\"://yandex.ru/an/count/\"] ~ div,\narticle > section:first-child + div:not(:last-child),\narticle > section:first-child + div:not(:last-child) + div:last-child,\narticle[class*=\"-promo\"],\naside[id^=\"article_\"][class*=\"rihggt\"] > div[class],\ndiv:has(> .adv-skeleton___main),\ndiv[aria-label=\"Карточка рекомендованного видео\"] ~ [aria-label]:not([aria-label=\"Карточка рекомендованного видео\"]),\ndiv[class*=\" news-site--\"][class*=\"__desktop\"],\ndiv[class*=\"-top-ad-\"],\ndiv[class*=\"Container\"] > div[style=\"opacity: 1;\"] > div[class*=\"articleRight\"][style^=\"max-height:\"],\ndiv[class*=\"DirectAdvert\"],\ndiv[class*=\"PunchCardsOnVideoShowcase\"] div[aria-label=\"Реклaмный блок\"],\ndiv[class*=\"PunchCardsOnVideoShowcase\"] div[class^=\"grid__row\"] > div[class*=\"heme\"],\ndiv[class*=\"__loaded-\"],\ndiv[class*=\"_position_articleBottom\"],\ndiv[class*=\"_position_feedSingleCard\"],\ndiv[class*=\"_rightAdWrapper\"],\ndiv[class*=\"_topBannerContainer\"],\ndiv[class*=\"article__\"] > .undefined ~ div[class*=\"millde\"] > div[id][class],\ndiv[class*=\"bannerMain\"],\ndiv[class*=\"card-video-promo__root\"],\ndiv[class*=\"card-widh-ad_\"],\ndiv[class*=\"card-with-ad__\"],\ndiv[class*=\"news-advert\"],\ndiv[class*=\"news_branding\"],\ndiv[class*=\"placehoder\"]:empty,\ndiv[class*=\"tsar__container\"],\ndiv[class*=\"video\"] [aria-label=\"Табы рекомендаций\"] ~ [aria-label*=\"карта\"],\ndiv[class*=\"video-viewer-sidebar__ad\"],\ndiv[class*=\"videoCardAd\"],\ndiv[class*=\"widget\"] > div[class*=\"container\"] > div ~ div,\ndiv[class^=\"ad-link\"],\ndiv[class^=\"advert-panel\"],\ndiv[class^=\"article-item__articleItem-\"] > div[class*=\"subscribeBanner\"] + div:not([class]),\ndiv[class^=\"article__article-\"] > div[class^=\"article-item\"] > div[id],\ndiv[class^=\"auto-slide-ad__container\"],\ndiv[class^=\"content--news-tsar\"],\ndiv[class^=\"dzen-desktop__link_bro-\"],\ndiv[class^=\"dzen-desktop__teaser-\"],\ndiv[class^=\"dzen-mobile__\"] > div[id$=\"-fullscreen\"],\ndiv[class^=\"dzen-mobile__topContentBackgroundBottom\"],\ndiv[class^=\"floor-card-rtb_\"],\ndiv[class^=\"floor-skeleton-card__skeletonCardWrapper\"],\ndiv[class^=\"grid__row-\"]:has(> div[class^=\"video-card-ad\"]),\ndiv[class^=\"news-\"][class*=\"_banner\"],\ndiv[class^=\"news-\"][class*=\"banger\"],\ndiv[class^=\"news-\"][class*=\"tsar\"],\ndiv[class^=\"short-video-sidebar-placeholder\"]:empty,\ndiv[data-name^=\"zen2\"],\ndiv[data-testid=\"article-showcase-card\"]:has(> [data-testid=\"card-rtb\"]),\ndiv[id*=\"splashscreen\"],\ndiv[id][class$=\"__ad\"],\ndiv[style*=\" !important; \"][style$=\" !important;\"],\niframe[style=\"display: block; border-width: 0px;\"]:not([id])","div[class^=\"news-\"][class*=\"Branding\"],\ndiv[class^=\"news-mt-advert\"]","div[class^=\"adb\"]",".banner-topline",".fixday",".e1-top-panel__link[title=\"Авто\"],\n.js-sticky-rotation-banners,\n[class*=\" undefi\"],\nli[class=\"e1-nav__item _auto\"]","[data-vr-contentbox=\"Новость в левой колонке\"]:has(> div ~ div ~ div),\n[itemprop] > div:has(> div > [id*=\"ad\"]),\n[itemprop] > div:has(> div > [id*=\"inline\"]),\nsection:has(> div[class]:empty + div[class]:empty + div[class]:empty + div[class]:empty)","[class^=\"styled__AdvLink-sc-\"],\ndiv[class^=\"post-\"] > section[class^=\"styled__Wrapper-sc-\"],\ndiv[class^=\"styled__ProgrammaticWrapper-sc-\"],\nsection > section:has(> [class^=\"styled__AdvLink-sc-\"])",".banners-puzzle,\n.neon-skeleton,\n[data-neon-skeleton-removable]","a[href^=\"http://youcanhappy.ru/\"]","a[href^=\"https://www.shipito.com/\"]",".cartoon","#ad_global_below_navbar > div[align] + div[style],\na[href][target=\"_blank\"] > img[alt=\"папироска.рф\"],\na[href^=\"http://smokekitchen.ru/\"]",".blurb","a[href^=\"http://nvek.com.ua/\"]","#billboard,\n.ad_branding_footer div[class^=\"emotion\"]:has(> [title=\"yandexzen\"]),\n.ad_branding_header > section,\n[title=\"yandexzen\"]","#slidebotbox",".b-dsk-hero-ads-banner",".card_commercial","div[id^=\"float-sidebar\"]",".sidebar > a[href][target=\"_blank\"]",".row[style=\"margin-top: 30px;\"],\ndiv[class*=\"_promocodes \"]","div[class*=\"znamya\"]",".e-zen-block",".right_col > div[style^=\"margin-top\"]",".alert_warn,\n.blok_forum > div[style],\n.out_new,\n.rules:has(> p > [src=\"/img/no_ad.png\"]),\ndiv[class=\"forumbg_star\"],\ntable[class^=\"header\"] > tbody > tr > td ~ [class]",".bybit","#b-info-wrapper,\n.extra-banner","a[href*=\"pokupka-radiolom.ru\"]","body > div[onclick^=\"window.open\"]",".black-footer",".adsense_blok","a[href*=\"puzzle-movies.com\"]","#rcl","a[target=\"_blank\"] > img[src^=\"http://www.erudition.ru/images/\"]","#wrap > div[style]:not([id]):not([class]),\na[href*=\"://marchelas.tilda.ws\"]",".b-fade,\n.b-mdl","div[id^=\"getContent_esoreiter\"]",".notice[data-notice-id=\"1\"],\n.p-header-content > .p-header-logo ~ div","[class*=\"landing\"],\n[class*=\"templatespromo_\"]","#full_det > div[style]:not([id]):not([class]),\n.book_bl > div[style]:not([id]):not([class]),\n.interestingly","td[valign=\"top\"][width=\"176\"][align=\"center\"]",".article-item > .article__footer ~ :not(.article__footer):not(.comments-container),\n.block:has(> .block__body script),\n.block:has(> div > [class*=\"bookmaker\"]),\n.top-rates,\n.wrapper > div[style*=\"height:\"]",".gift-block","[class*=\"bookmaker\"]","div[style*=\"height:400px;\"],\ndiv[style*=\"min-height:\"][style*=\"00px\"]","#AdwolfVerticalBanner,\n.infox",".related-content-story--sponsored",".place-content-center,\n.scroll-smooth,\ndiv[class^=\"fixed bottom\"]",".panneliker a[href][target=\"_blank\"]","img[src*=\"/img/ab/\"]",".adblock-pls,\ndiv[id^=\"Banner\"]",".col-right hr,\n.right-box-banner,\n.soc-line ~ hr,\n.two-col ~ hr,\n[class*=\"box-partners\"]",".direct-ad,\n.yandex-market-widget",".promo-block",".interesting-news",".banner_slider","#ulogin,\ndiv[id*=\"result\"]","#b2-container,\n.b-other-news,\n.banner_sidebar,\n.banner_topline",".adcredit,\n.b-horizontal,\n.boff,\n.floating.b-sidebar,\n.head-horizontal,\n.sidebar-rtb,\n.smi2,\n.widget-area div[class*=\"-banner\"],\na[href*=\"advertising\"],\nbody > div[class^=\"facebook-\"]","aside > .row > .text-center","a[href^=\"/redirect/\"][target=\"_blank\"] > img[alt][title],\niframe[src*=\"/upload/fapl_\"]","div[class*=\"advban\"]","div[id*=\"reklblok\"]",".entry-content > div[style^=\"min-width:300px\"]",".widget.HTML",".article__annex","#search_panel > .panel-body ~ div,\n.container > .row > .text-center",".ddb-adv,\n.footer-partners__block,\n.gazprom-logo,\n.header-sponsors,\n.parnters-foot,\n.partners-logo,\n.sl-foot,\ndiv[class^=\"adv-\"]:has(> div[id^=\"adfox_\"])",".top-site-an","a[href=\"http://trudvsem.ru/\"],\na[href=\"http://www.novomotors.com/\"],\na[href=\"http://www.polyplast-un.ru/\"],\na[href=\"http://www.pravo.gov.ru/\"],\na[href=\"http://www.procterandgamble.ru/\"]","#bcat,\n.coeffs","a + br,\na + br + br","[itemtype*=\"://schema.org/NewsArticle\"] .article-box + div[style=\"padding: 10px\"],\ndiv[class*=\"follows-channel_yandex\"]",".widget_custom_html > .partners__heading ~ .custom-html-widget",".lb-ad-visible","a[href^=\"http://trening-maximum.ru\"]",".a-block",".top-bookmakers-widget,\ndiv[class^=\"bet-widget-\"]","noindex > table[style]",".hochuvkino,\n.hvk,\n[title=\"Яндекс Дзен\"],\na[href=\"#\"],\na[href]:not([href=\"#\"])[onclick],\na[href^=\"https://hochuvkino.ru\"],\ndiv[id^=\"bseller_\"]","#dle-content noindex a[href][target=\"_blank\"]",".footer-banner-block,\n.profile-text-banner,\nbody > div[class^=\"hidden-\"],\ndiv[id^=\"cntnt_block_\"],\ndiv[id^=\"finamBanner_\"]","#brokerintegration,\n.highlightbox.content_box","header > .container-fluid",".first_block > .right_block,\ndiv[class^=\"swal2\"]","#chart_a,\n#news_a,\n[class$=\"_top_a\"]",".topline","div[id*=\"_ban\"]","div:has(> .banner-bdm),\ndiv[class^=\"bnr-\"]",".stb-container","#stb-overlay,\ndiv[class^=\"dgd_\"]",".right-column .bx-wrapper,\n.right-column .select-content[style=\"margin:9px auto;\"]","a[href*=\".fhserv.ru\"]:not([href^=\"https://image.fhserv.ru\"])","#promo > div > div,\n.bannermod,\na[href^=\"https://animal-farma.top\"]",".rads,\ndiv[class*=\"relap-\"]","a[href=\"http://vitomaxx.ru/\"] > img","#header > .widget_text","cat-banner",".banners-topic",".gametiles > div[id][style]","[id*=\"adsPlace\"]",".head-banner","div[id*=\"tizer\"]","#phpbb_announcement,\nbody.section-index .sidebar","[align=\"CENTER\"] > a[href][target=\"_blank\"],\ntd.alt1Active > div > div[style=\"float:right\"]","td[width=\"738\"] noindex","#content > div[style*=\"fixed\"]","img[src=\"/images/banners/virtoo.jpg\"],\nimg[src^=\"/images/banners/goporez\"]",".footer_banners,\n.navbar_banners",".gridContainer > [class*=\"grid\"]:has(> [class] > [href=\"/format/fproject/\"]),\n.gridContainer > [class*=\"grid\"]:has(> [class] > [href^=\"/pressrelease\"]),\n.gridContainer > [class*=\"grid\"]:has(> [data-creative]),\n.gridOneThirdLaptop > [class^=\"sliderWrap_\"],\n.record > div[class]:has(> div > [href=\"/pressrelease/\"]),\n[class*=\"pictureDayBlock_\"] li > a[href*=\"/?erid=\"],\n[class*=\"pictureDayBlock_\"] li:has(> a[href*=\"/?erid=\"]),\n[class^=\"articleBlockVideo_\"] video ~ button,\n[data-io-article-url] > [itemprop=\"articleBody\"] ~ p[class],\na[href=\"/__business_news\"],\narticle.NVaun > [class] ~ [class],\naside > div[class]:has([class*=\"flickity\"]),\naside ~ aside > div:first-child,\naside ~ div aside > div[class]:first-child,\naside:empty,\ndiv[class]:has(> div > button + [href=\"/pressrelease/\"]),\ndiv[class^=\"newsFeedBlock_\"] > div[class^=\"news_\"] > a[href^=\"https://doctorpiter.ru/\"],\ndiv[class^=\"newsFeedBlock_\"] > div[class^=\"news_\"]:has(> a[href^=\"https://doctorpiter.ru/\"]),\ndiv[style*=\"--creative-height:\"],\ndiv[style^=\"order:\"] > a[href*=\"/?erid=\"],\ndiv[style^=\"order:\"] > a[href*=\"/?erid=\"] ~ div,\nsection[class^=\"sliderWrap_\"]:has(> div > [href=\"/pressrelease/\"]),\nul > li:has(> div > div > a[href*=\"/?erid=\"])","#onesignal-promt-target > div:first-child,\nheader > div[class^=\"funding_\"]","div[class*=\"Banner\"]","div[class^=\"cookieNotice\"]",".rttr_bnr",".bot_banner,\n.dzenreg,\ndiv[class^=\"leon\"],\ndiv[class^=\"middle_banner\"]",".bloc1:has(div[id^=\"bn_\"]),\n.bloc_right > .bloc0,\n.bloc_right > div:has(> .nopromo_view),\n.lastnewscat:has(> [id*=\"ScriptRoot\"]),\n.nopromo_view,\na[href=\"/bookmakersrating/\"]",".center-adv,\n.left-adv",".IQXal,\n[data-interval] > li div[style=\"min-height: 64px;\"],\n[data-io-article-url] > footer > div[class]:has(> .undefined),\ndiv[data-title=\"Реклама на Forbes\"]","body > div > a[target=\"_blank\"] > img",".newss2 a[target=\"_blank\"]","#html-footer,\n#html-header,\n.html-box",".samListItem","div[id^=\"fa_ticker\"]",".contbaner,\ntd[valign=\"top\"][width=\"100%\"] > div[id][style^=\"clear\"],\ntd[valign=\"top\"][width=\"100%\"] > table[class^=\"forumline \"]:nth-child(1)",".module > .box-content[style] > div[class]","#messageList > [id^=\"post-\"] ~ .message:not([id^=\"post-\"]),\ndiv:has(> [class$=\"relap-block\"]),\nnoindex > [style*=\"display: block;\"]","#column-left noindex > .module-content,\n#root-wrapper > .top-module-container",".fRight > .rightBox,\n.m2","#footer-ads-banner-cont,\n#middle-ads-banner,\n#top-ads-banner-wrap,\ndiv[id*=\"reklama\"],\ndiv[id^=\"king-rightplace\"]",".adOnPostBtwImg",".ftips-branding-ad","a[href^=\"/goto.php\"],\ndiv:has(> a[href^=\"/goto.php\"]),\ndiv:has(> sup)","#menuforum,\n.headreklama,\n.menublock:last-child",".menu__item.special",":not(#container-top) > blockquote","#content_r,\n#footer_left,\n#pai_thumbz_hider","div[style^=\"margin-left:\"] > a[href=\"#\"],\nform#redirect ~ div .row > div > .content_rb ~ div",".t_bg > center,\ntd[width=\"210\"][align=\"left\"]","p[align=\"center\"] > a[href] > img","#fbpopup",".b-mts-logo,\n.rc2:has(div:first-child > #rc-bn),\n.rc2:has(div[id^=\"adfox_\"])",".center_b",".tingle-modal",".sidebar > .block-content:has(> noindex > script)","#left > div:not(#ms),\n#main + #right","#rfunlog","[id^=\"icqwin_\"]",".header","a[href^=\"http://fvhm.ru/adv/\"],\na[href^=\"http://slivz.com/\"]",".bgad",".bgad + div[style*=\"height:\"],\n.col-md-4.text-center","a[href^=\"/s\"][target=\"_blank\"],\nimg[src=\"/img/separator.gif\"]","#vp_main_520,\n.lr_block > iframe","a[href^=\"http://game-10.ru/i.php?url=http://www.adcash.com/\"]","#secondary > .widget-wrap:has(> .widget_execphp)",".rightBanner > h4","[href^=\"https://p2d.ru/\"],\ndiv[class^=\"adblock_\"]","a[id^=\"mainbackgr\"],\na[onmouseup*=\"_trackEvent\"],\ndiv[style=\"margin: 10px auto; width: 970px; height: 250px\"]",".advertising_review,\n.logo-df,\n.logo-zen-feed,\n.top-branding,\n.top-img-wrap",".alarmalarm-backtop,\n.under-back,\ndiv[class^=\"alarmalarm-banner\"]",".adaptiv,\n.xopo-player-container","#global_back_link","#html-footer > .container > :not(center)",".brandingh,\n.brndblock,\n.brndlnk","body > div[align=\"left\"][style^=\"position: fixed;\"]",".__b-popup1__,\n.advback,\n.full_screen,\nimg[height=\"310\"]","a[href*=\"/go/\"]","#banner-slider",".show-block",".adfox-banner,\n.js_aside_sp","body > #bodypopup","a > img[src^=\"http://gaynsk.ru/img/\"],\ntd[bgcolor=\"#dedede\"]","div[class*=\"billboard\"]","#_id_flowup,\n.b_nav > a[target=\"_blank\"],\n.b_telegram,\n.m_zen,\n.rcmw-container,\nbody > div[style^=\"height:\"][style*=\"vh\"]:empty,\ndiv:has(> .b_telegram),\ndiv[id^=\"_g_exchange_\"]",".header-widget,\na[href^=\"http://www.soglasie.ru/\"]",".banners_bottom","div[class*=\"AdBox\"]",".bracing-banner",".b-imp-notice,\nbody > div[class^=\"stop-block\"],\ndiv[class^=\"b-app-promoter\"]","a[href*=\"letyshops\"]",".pull-right > [class] ~ [class]",".store-hosting,\ndiv[id^=\"media\"]","div[class^=\"wiad\"]",".main-footer-btn,\n.wpb_text_column",".banner-bottom-wrapper","[class^=\"mgedwn\"],\na[href*=\"/gobtn.php\"]",".widget_pfj",".cities-popular:has(> .list:empty),\n.content-column > .section-media,\n.widget-container,\ndiv[class*=\"feed-partner\"],\nsection > .feed-bg","#guitarist","#dropin",".sidebar__banner","center > noindex,\ndiv[style=\"float:left;width:344px;height:295px;\"],\nindex > .entry,\nnoindex > .entry","ng-banner","ng-teasers",".rb","#rek_bg","a[href*=\"branding\"][target=\"_blank\"]","div:not([id]):not([class]):has(> div + div + section + section) > div:first-child + div > div:only-child > div:first-child + div:last-child",".GbShadow","#topbox-container,\n.wide-banner,\na[href^=\"http://www.glavmore.ru/linker.php\"]","#sidebar > center","div[class^=\"baner\"]",".seo-info",".video_code:empty",".news-grid > .news-grid__col:has([id^=\"banner\"]),\niframe[src*=\"/upload/adv_banner/\"]","a[href*=\"firmpage.ru\"]",".rstbox",".asus_prm","div[class^=\"widget-twitch\"] > .data","#fon-adv","[data-role=\"primaryNavBar\"] a[href^=\"http://csserv.ru/\"],\n[data-role=\"primaryNavBar\"] a[href^=\"https://gamecms.ru/\"]","#html5player > div[style*=\"absolute\"],\na[href^=\"http://premium.goodgame.ru/ra/www/\"]","#topmod","[href*=\"/link?to=\"]",".side_block",".block > a > img[width]",".right-side > .reading:has(> div > #MediaMetricsInject)","#at-cv-lightbox,\n.sidebar-right > div[class*=\"banner\"]","div[id^=\"lngtblck_\"]",".article_footerText,\n.horizontal-banner","a.additional-earnings-banner-snippet:not([href*=\"gorodrabot.ru/\"]),\ndiv[id]:not([class]):not([style])[aria-hidden=\"true\"]",".alert-warning,\n.section-r-top,\n[src*=\"/files/rk/\"]",".blnk,\n.section-feed-sm > div:has(> .blnk)","a[href*=\"smi2.net/\"]","body > div[class$=\"-subscr\"]",".articles-special,\n.banner-simple,\n.posts-relative",".col-md-4 noindex",".box-shadow:has(> [id^=\"adfox_\"])","body > a[target=\"_blank\"]","div[style=\"width: 970px; height: 90px;\"]",".darkPart > .connection ~ a[href][target=\"_blank\"] > img,\n.newContent > .all > :not(.button),\n.otherNews > .newsList ~ div","#main-sec > .block-side ~ .block-side",".textwidget a[href][target=\"_blank\"]","div[id^=\"rare_\"]",".dopoln",".new-block",".first-b,\n.news_t_left[style^=\"background:#ff0000;\"],\n.v-recom",".article-ads,\n.news-ads,\n.stop-waiting","a[href*=\"goaway.php\"]","#gts-carousel","#sidebar-wrap .widget_custom_html,\n.mediametrix",".box-warning","[class^=\"windowbg\"] > noindex,\n[id^=\"ya_direct_\"],\nnoindex > a[href*=\"svetomuz.ru\"]","[class*=\"hide\"][class$=\"ban\"],\ndiv[id^=\"gbr_\"],\ndiv[style=\"clear:both;height:200px;\"]","a[href^=\"/sp.php?id=\"]",".adv_collumn > h3,\n.adv_collumn > p:not([style]),\na[href*=\"ecvator.\"]","#headerq,\n.b-fad,\n[alt^=\"Реклама\"]","aside .widget_custom_html",".likewall","#right-sidebar > aside:has(.adsbygoogle),\n#right-sidebar > aside:has([id^=\"yandex_rtb\"]),\n#right-sidebar > aside:has(div[name]),\ndiv[name]","a[href*=\"nanokleber-original.com\"]","[src*=\"://pagead2.googlesyndication.com/\"]",".teaser","aside[id^=\"rec\"]",".bannermain",".hd_head","#bnr_1",".sidebar .widget_text","#fixed1,\n.veramoy,\na[href*=\"://reduction.helpsetup.ru/\"],\nh5#center",".block > noindex,\na[href^=\"http://www.hen-tai.ru/engine/go.php\"]","#vgtrk_bottom","#onload_popup,\n.b-modal","div[class^=\"banner-place\"]","div[data-rb-slot]",".article__content__zen,\n.feature__ad-block,\nbody[data-pageid] #ipsLayout_sidebar",".banners-center,\n.small-text:has(> a[href^=\"https://dzen.ru/\"])",".up-pek-top,\naside > a[href=\"/pek/\"],\naside > div[class^=\"margintop\"],\ndiv[id^=\"BAHEP\"]","[id*=\"hidemead\"]","[data-uk-grid-match*=\"target\"],\nbody > #wrap-popup-box",".an-sidebar1",".footer-one.fbox","div[class^=\"chp_ads_block\"]","#orphus",".right-block.rek","#top_ban,\nbody > center > .px_blue_fon","div[style=\"max-height:250px\"]","a[href^=\"http://adslead.ru\"]","[id^=\"brand-\"]",".text_block_widget_video",".download_method > .method_box ~ *","[class$=\"_banner\"]","tr > td[width=\"170px;\"] ~ td[width=\"170px;\"] > div[style^=\"padding: 0; margin: 0;\"]",".modal.in.modal-vc","div[class^=\"vitrina\"]",".burger_b","div[style^=\"margin-left:\"][style*=\"margin-bottom:\"][style*=\"position:\"][style*=\"orange\"][style*=\"z-index:\"]","#block-sape","a[href*=\"regru.net\"] > img","body > div[id] > [onclick],\nbody > div[id] > [onclick] ~ *,\nbody > div[id]:empty,\nbody > div[id]:has(> [onclick])","#wrapheader > table[width=\"100%\"]",".l-article-wrapper > center > a[target=\"_blank\"] > img[border=\"0\"],\n[class*=\"tbann\"],\n[class^=\"promo\"]",".content__col-left","a[style*=\"/banner.\"]","body > [class^=\"adbd-\"]","#substrate",".admania_adblock_detector",".modal-open div[class^=\"modal\"]","#jv-banner,\n.jvmod-pad.png > a[target=\"_blank\"] > img","div[class^=\"ab-\"][class$=\"-text\"]","nofollow > noindex > p","div[class^=\"content__banner\"]",".block_top",".ad-brending,\n.informer-container,\n.knb-grid-layout > .no-radius,\n.knb-informer,\n.knb-sidebar_top,\n[class*=\"HeadingPage_most_discussed\"],\n[class^=\"AdFoxBanner\"],\n[class^=\"LentaAdFox_\"],\ndiv[class^=\"MaterialSubscription_root_\"],\ndiv[class^=\"TopPageBanner_wrap_\"]","a[class^=\"MaterialCpa_\"],\ndiv[class^=\"KeysForGamers_button\"]",".block-full-width,\n.bq-menu ~ div:not([class=\"top-side side1\"]):not([class=\"top-side side2\"]),\n.top-adapt",".promo-top",".fly-button,\n.i-box-ads,\n.nav-link_huawei,\na[href=\"/advertising/\"]","a[href*=\"pr.ikovrov.ru/www/\"],\niframe[src*=\"pr.ikovrov.ru/www/\"]",".info > .t_tips2","fieldset[style^=\"display: inline; width: 45%;\"]","iframe[src*=\"://vamproducts.ru/\"]","tr > .leftcat > *","td[align][valign=\"top\"] > div[align=\"center\"] > table","[id^=\"bn\"] > *","a[href^=\"https://www.youtube.com/\"] img",".m-advertising,\n.m-videoplayer-advert",".post_pole_post","div[id^=\"ad_id\"]","#execphp-3",".my-block[style=\"height:730px;\"],\n.wiged.widget_text",".ad_customs",".obl",".rightbar > div[align=\"center\"][style]","#helpme[style=\"display: block;\"],\na[href*=\"goobmizd.ashx\"]","a[href^=\"/netcat/modules/banner/\"][target=\"_blank\"]","#like_box,\n.yandex-widget","a[onclick*=\"Баннеры\"]","#ot-right > div[id^=\"mod\"]:has(.bannergroup),\ndiv[class^=\"fonrec\"]",".ppoibrorzf","#dmLarge,\n.idv3-advert2,\n.idv3-popup-frame,\n.ya-invite-block","div[style=\"width: 200px;height: 300px;position: relative;\"],\ndiv[style^=\"width:199px;height:299px;\"]",".b-Article_main-banner,\n.b-BannerPlace,\n.b-PopupBanner",".alignright div[style^=\"height\"],\ntd[style] > div[style=\"height: 120px\"]",".adv_code_wrapper","div[id^=\"TM_\"]","#ezobann","img[alt=\"Скачать\"]",".gnice","#adsClose","#footer > #wide_links","div[style^=\"width: 728px; margin:\"]",".toplogo__advertisement-wrap","div[id^=\"pl\"][id*=\"_ban\"]",".general_block > a[href][target=\"_blank\"]","#fab-enabled","div[class^=\"shortcode-\"] > [data-href],\ndiv[class^=\"shortcode-\"] > a[href*=\"/go/\"],\ndiv[data-region][data-pending=\"true\"],\nsection[class*=\"related\"]","td[valign=\"top\"] > .block-user ~ *",".globalmesswarnwrap,\n.row2 > span[style^=\"float:\"],\nimg[width=\"460\"][height=\"60\"]","#popwindow",".postitem__dpd_block,\n[data-slug=\"damprodam\"],\na[href*=\"tinkoff.ru\"][href*=\"utm_campaign\"]",".faq > ul > li + div",".content > div[align=\"right\"][style^=\"float:\"],\n.tr-banner",".brocock,\ndiv[id^=\"ymarket-mobtop\"]","#rotateAdvert,\n.b-adblock-message,\n.b-adwords-news-read-banner,\ndiv[class^=\"b-branding\"]","a[href*=\"akva-motors.ru\"]","aside .widget:has(> .widget-container [class^=\"nadavi\"]),\naside .widget:has(> .widget-container [id^=\"ya_\"])","#sb-calc-wrapper,\n.b-specOffers","a[href^=\"http://kinezio.center/\"]","#slider_01","a[href*=\"halaleda.me\"],\na[href*=\"mavlid.ru\"]",".sidebar-content > .widget_custom_html ~ *","#content > .nav-single:has(> ins),\n#main > :not(#primary):not(#leftbar):not(#seecondary),\n#menu-block > :not([class=\"widget widget_search\"]):not([class=\"widget_ widget_menu\"]):not([class=\"widget_pl popular-posts\"]):not([class=\"widget widget_comments\"]):not([class=\"widget widget_taag_cloud\"]):not([class=\"widget_f widget__scr_lp\"]):not([class=\"sbar\"]),\n#page > :not(#masthead):not(#main):not(footer),\n#primary > :not(#content),\n#seecondary > :not([id=\"menu-block\"]),\n.entry-content > [class*=\" \"][style=\"text-align: center;\"],\nbody > :not(#page)","body > #modal[style*=\"blur\"]",".ad-bottom-dc","a[href^=\"https://kwork.ru\"]","#fguru,\n#sping",".b240.rc4,\n.colr > h4",".itzin-podcast-promo,\n.site-header__img",".modal__sidebar,\n.news-detail__panel > .news-detail__panel-col:first-child > div,\n.section-marketing-block","div[id^=\"ADS_\"]","#video-flack,\n.ivi-footer ~ div[class] > style + div[class],\n[data-test=\"watch_with_adv\"] > .nbl-button__primaryText",".rollPlus,\na.teaserImage[target=\"_blank\"],\nbody.watch > div[class]:not([id]):not([style]):nth-child(-1n+2) > style + .content",".aside-advertising,\n.block-container-margins [style^=\"height:\"][style*=\"250px;\"],\n.get_news_link__bottom__item:has(> a[href*=\"yandex.\"]),\n.get_yandex_subscription_links,\n.partner_before_head,\n.top-advertising,\n.two-col-with-advertise2__right,\n.two-col-with-partner__inside__right,\n[data-partners-block-id]","#footer > .block ~ .block","a[href^=\"?uups\"],\ntr > td > div[style^=\"border\"][style*=\"padding\"][align=\"center\"],\ntr[height=\"90px\"]","a[href*=\"mark.ru/\"][target] img","noindex table[width=\"100%\"]",".adblock-service",".mod_ext_dropdown_box_module_position","#colwrap > .module-notitle",".sidebarinner",".header_banner",".showcase_search","a[href^=\"http://creativepromo.ru/\"],\niframe[src^=\"http://creatagen.ru/\"]",".sidebar-rk","aside > .profile-inner + a[href][target=\"_blank\"] > img",".demo","body > div[class*=\"-container\"][class*=\"-hide\"]",".is_visible.like_wall","a[href*=\"football-shopping.ru\"]","#middletbl_r_in > a[href=\"http://www.sushivenik.ru\"]","#rigthBlokBaners","a[href^=\"http://get-wn.net/\"]","#top-line-container",".gads","#top-advertisment",".leftb",".c-moneyPlace_empty,\n[class^=\"IgromaniaChannel_mania\"],\nsection[class^=\"MaterialsManufacturerPage_infiniteWrap\"] > div[class^=\"InfiniteScrollWrap_content\"] > [class^=\"MaterialItemPage_materialSection\"]:has(> .knb-grid-container > [data-io-article-url] a[href=\"/tags/partnyorskij-material/\"])",".sam-container a[href]:not([href*=\"rk.karelia.ru\"])",".caroufredsel_wrapper",".newsItem > .otherBlock:has(> .textContainer > noindex),\n.newsItem:has(> div > small),\ndiv[class^=\"advCell\"]","div[id*=\"actionteaser\"]",".banner-wrap",".banner:not(.topcontent_banner)",".l-mainAdArea","#text-popup-load-window","table > tbody > tr > td[width=\"728\"]",".header_site,\n.show[class^=\"fix_post\"]","#blink,\n#top-b,\n.itemFullText > center + div[style*=\"center\"],\ntable[style^=\"width: 776px; height: 214px\"]",".top-block","#interesting_articles",".adex,\n.content_wrap > div[class^=\"content_\"] > div > a[href^=\"/go.php?id=\"],\n.cough_block,\n.kg_promo,\n.paracontainer img,\n.paralink,\n.social_login > .ulogin ~ .caution,\n.ten_banner_center,\n.ten_footer_wrap,\n.ten_topbar + div:not(.ten_ears_wrap),\n.ten_topbar ~ div[class]:not([id]):nth-child(-1n+10):not(.ten_ears_wrap):not(.content_wrap):not(.footer_wrap),\n[class^=\"ten_frontrow\"],\na[href^=\"/go.php\"][target=\"_blank\"]","#fullscreenBanner,\n.fonbet,\n.fonbet-logo,\n.m-bnr.b-float_panel_item,\na[href][class*=\"_fonbet\"]",".vjs-link_view-yandex-plus",".footer_sponsors","a[href*=\"parimatch.ru/\"]",".e-bnr",".bottom-partners","div[id][block-id]",".showcase,\na[href^=\"http://kineshemec.ru/bn/click/\"]",".banners-box","#cntr > .l-outer ~ style + table ~ table,\n.bottom-banner-ks,\n.topbar__link > .red,\ndiv[class*=\"ks-banner-news\"],\ndiv[class^=\"boxFormWrapper\"]:has(> div[class^=\"link\"] a[href*=\"/images/reklama/\"]),\ndiv[id^=\"top-master\"]",".footer-banner",".rightcol > div:has(a[href][target=\"_blank\"])","#special_block,\n#top_line,\n#top_space,\n.button_online_block,\n.button_online_info,\n.content_block > .page_content_block:has(> div[style] [id*=\"_dobro\"]),\n.content_block > div[class*=\"_text_white\"],\n.horisontal_delim,\n.view_online_block,\n[class*=\"_dobro\"],\n[id*=\"_dobro\"],\na[onclick*=\"_counter\"][target=\"_blank\"],\ndiv[style^=\"width:100\"][align=\"center\"]",".market","div[align=\"center\"] > noindex",".w-banner","a[href=\"http://bike-centre.ru/\"]",".in-list-banner-env","#rightcolumn > .blockdiv[style^=\"height\"],\n#rightcolumn > .blockdiv[style^=\"text-align:\"],\n.div1000,\n.div_dzen,\n.rightzagolup,\ndiv[class^=\"under_shapka\"] > *,\ndiv[style^=\"text-align:\"][style*=\"center;\"][style*=\"height:\"]",".tabs",".bn-top10,\n.top-banners",".brand-click,\n.brand-click-inner,\n.brand-container",".top-banner-container","#top > div[id][style^=\"height: 210px\"],\n.app__page > div[class*=\"-container_\"]:not([class*=\"media\"]):not([class*=\"content\"]):first-child,\n.desktop-layout-with-sidebar__middle > .desktop-layout-with-sidebar__wrapper > div[class*=\"-container_\"]:not([class*=\"kinopoisk\"]):first-child,\n.media-post-page > div[class*=\"-container_\"]:not([class*=\"media\"]):first-child,\n.page-content > div[id]:not(#header-info-bg):empty,\na[href^=\"https://kinopoisk.ru/special/\"][href*=\"utm_campaign=\"],\naside.dialog,\ndiv[class$=\"__adfox\"],\ndiv[class$=\"g-kinopoisk-media\"],\ndiv[class]:first-child > div[class*=\" \"] > div:first-child + :not(div) + div[class*=\" \"]:last-child,\ndiv[class^=\"styles_adBlockWarningRoot\"],\ndiv[class^=\"styles_themeTopBanner\"],\ndiv[class^=\"toaster-container\"],\ndiv[data-type=\"teaserspec\"],\ndiv[id$=\"_super_banner\"],\ndiv[id$=\"_top_banner\"],\ndiv[id$=\"banner_300_600\"],\ndiv[id*=\"_superbanner_\"],\nimg[class^=\"styles_copyrightImg_\"]",".branding-wrapper",".side-block > .boxTable ~ .boxTable",".fullstory a[href*=\"aHR0c\"]","#inner > div[style=\"margin-bottom: 24px;\"],\n.newsBanner,\ndiv[style=\"height: 90px; font-size: 1px; line-height: 1px;\"],\ndiv[style]:has(> [id^=\"adfox_\"]),\ndiv[style]:has(> [id^=\"unit_\"]),\ndiv[style]:has(> ntvk)","#container > #top,\n.ad-forum-block,\n.data-place,\n.r_links,\n[id^=\"bg_link_\"],\ndiv[class^=\"rsya_block\"]","a[href*=\"omniwins.ru\"]",".browse,\n.scrollable","#block1,\n#block3",".col-2 > div[id^=\"right_block\"]:has(.content_rb)","#promoVip",".supercover-banner-header",".pane-advertisment",".panel-col-top .pane-content > :empty",".bgcolortr > td[style*=\"padding-right\"] *,\na[href][target=\"_blank\"][onclick]","a[href^=\"http://golosplus.ru/index.php\"]",".button[href^=\"/download.php?q=\"]",".region > #block-biblioteka-zanr-menu ~ div",".banner + hr,\n.related-posts","a[href^=\"/goto/?idbanner=\"]",".b-header",".adv-hint",".adv_nest,\n.network_share > .network_share__item:has(> .network_share__name > [data-href^=\"https://dzen.ru/\"]),\n.rocket_man,\na[href*=\"//rusfond.ru\"],\ndiv[class^=\"adv_\"],\nheader a[href*=\"&erid=\"][target=\"_blank\"]",".lban",".hidden-print","div[class=\"r\"]",".block-test:has(#marketAttractive),\n.block-test:has(#vid_vpaut_div),\n.block-test:has(> [id^=\"yandex_rtb\"])","div[id][style=\"background: transparent;\"]",".rideo,\na[href*=\"b17.ru/\"]",".branding-click,\n.u-sidebar [style=\"min-height: 400px;\"],\na[href][rel=\"sponsored\"],\ndiv:has(> header ~ a[href][rel=\"sponsored\"])",".direct_elm_footer,\n.ext_link_img,\n[id^=\"ocean2011\"],\na[href*=\"/banners/\"],\ndiv[id^=\"BANNER\"],\ndiv[id^=\"kodirect_\"],\ndiv[id^=\"newsid_\"] > .row0[style=\"margin-bottom:8px;\"] ~ .row0[style=\"margin-bottom:8px;\"],\ndiv[id^=\"ydirect_\"]","#content > .b-under-menu,\n#sidebar > .block-empty,\ndiv[id^=\"psn_\"]",".post-block > div[id],\n.post-block ~ .post-block ~ div[id],\n.recomend-section",".is-style-warning","#HTML1.image_header,\n#allrecords > div[id^=\"rec\"]:has([href*=\"/ad.admitad.com/\"]),\n#allrecords > div[id^=\"rec\"]:has([id^=\"marketWidget\"]),\n#saContent .boxFrame,\n#saContent .kprCont,\n#se-sidebar,\n#sidebar-block-top,\n.afisha-r__block,\n.cmn_r,\n.inner-layout > div[style*=\"250px\"],\n.kion__wrapper,\n.kpad,\n.kplContTxt > img[src*=\"//qpicture.ru/\"],\n.kupi-reklamu-btn,\n.page-header_tell[href*=\"/reklama/\"],\n.rcard_link,\n.serial-content_container:empty,\n.tgb_block,\n.ya-market,\ndiv.ad-slot,\ndiv[class^=\"ad-slot\"],\ndiv[id^=\"rec\"] > div div[style=\"align-items:center;\"],\ndiv[style*=\"height:\"][style*=\"250px\"][style*=\"important\"],\ndiv[style=\"width: 100%; margin: 30px 0; height: 250px;\"]","#popup-id,\n.partners-news-block,\n.ul-button,\np:has(> .ul-button)","[id^=\"adv_\"],\na[href^=\"http://lamma.24ex.net/\"]","div[id^=\"fialet_\"],\ndiv[id^=\"nenadod_\"]",".sidebox:has(.adsbygoogle)",".lwsoc",".ag-adv-container,\n.instagram-block-wrap","img[src*=\"/advert/\"]","div[id^=\"comp_\"]",".adbs","a[href*=\"/banner/\"]",".bordered:has(> center > .adsbygoogle),\n.bordered:has(> center > [id^=\"yandex_rtb\"]),\n.relap-novate_ru__widetitles-wrapper",".banners-group,\n.material-bottom-banner,\n.section-banner","#offers-right","#bannerContent > div[id^=\"banner\"] a:not([href*=\"kupikolesa\"])",".banersline,\n.reld-1,\n.tax,\n.wrap-inf4x4",".smi24",".today_cbr","#botbanner,\ndiv[id^=\"banplace\"]",".left_bl > .floating",".block_sponsor","#content > .ipsAd > script + div:not([id]):not([class]),\n.ipsLayout_right > a[href]",".vipblock.container,\na[href=\"buy-ads.html\"]",".vda","a[onclick*=\"atob\"]","#general > a[href][target=\"_blank\"]",".news_list1","#left_menu > div[style] > noindex,\nbody > div[style] > noindex","#pricerbig",".gen-banner",".rek-but,\n.rek-top","._longgrid:has(> [class*=\"info\"] > [class*=\"_ad-title\"]),\n.banner + div[class][id],\n.custom-banner,\n.scroll-to-site,\n.topic-page__info ~ div,\n.yandex-games,\ndiv[class*=\"goodnews\"][class*=\" \"]",".entry-content > div:not([id]):not([class]):not([style])[align=\"center\"]",".wp-block-spacer","div[id^=\"news-id-\"] ~ *",".block_sidebar.banner-video ~ .block,\n.sidebar .start_block a[href^=\"http\"]:not([href*=\"://lfl.ru\"]),\n.sidebar .start_block table[style=\"width: 263px;\"]","a[href^=\"http://center-fp.ru/\"]","table[style=\"width: 100%; height: 23px;\"]","#main-citat,\n.right-ban,\n.wide-ban","[class*=\"_a24\"]",".player_advert","#fixlife","a[href^=\"http://www.zaochnik.com/\"]",".ban-r,\n.ban-r + .prodlist-links","#popup",".footer-widgets__container,\n.partner-strip,\ndiv[class*=\"footer-widgets__container\"] > [data-key^=\"custom_html-\"]",".theme-wrapper > .container > div > *",".page-wrapper > .analyzer-page > .subscriber","div[class=\"main-widgets-item main-widgets-banner flex\"]",".left-bnr,\n.left-col > .left-bnr ~ .left-block","#bordTop",".rkb","#top_rtb","#secondary > .widget_custom_html:not(:last-child),\n.banner_dc",".clinic-image","#biblio_book__read > h2,\n.listen_online > h2","div[id^=\"inpage_\"]",".main__rightside--rbt","iframe[src*=\"/bitpapa/\"]","#header > :not(#logo):not(.block):not(:last-child),\n#samtop,\n[id*=\"abovecontent\"],\na[href^=\"http://liveangarsk.ru/out\"]",".col-z-right > #livecars_ru ~ *,\n.wow_box,\n.z_wow_aftertxt",".wall",".news > center > a[target=\"_blank\"] > img,\ntd[width=\"367\"] > noindex + table[width=\"367\"]","#liveinternet_600x250,\n#liveinternet_billboard,\n.allpageinner td[height=\"100\"],\n.gifts,\n.header > .headerlinks,\n[style=\"margin-top:-24px;\"] ~ .leftcolumn > div ~ div,\n[style=\"margin-top:-24px;\"] ~ br + div,\na[href*=\"/fastvk.com/\"],\na[href^=\"https://an.yandex.ru/count/\"],\ndiv[style^=\"width:970px; height:280px;\"],\nscript + div[id] > div[style^=\"width:\"],\ntd[align=\"left\"][valign=\"top\"][width=\"150\"] > iframe[height=\"840\"],\ntd[width=\"240\"][valign=\"top\"] > p ~ *",".btn-buy-holder,\n.prm-block,\n.prm-header,\na[href=\"/advertising\"], a[href=\"/advertising\"] ~ div *,\ndiv[class*=\"context-ads-\"]","div[style^=\"min-height: 700px;\"]",".block:has(> .relap-runtime-iframe),\n.header-top-bar a[id],\n.widget:has(> [class*=\"bookmaker\"]),\n.widget:has(a[href*=\"bookmaker\"]),\n.widget:has(a[href*=\"utm_campai\"]),\na[href*=\"odds\"],\na[href*=\"partner\"],\na[href*=\"tips/go\"],\ndiv:has(> [data-has-bookmaker-odds]),\ndiv:has(> div[style=\"color:#D42A28\"]),\ndiv[style=\"color:#D42A28\"],\ndiv[style=\"color:#d42a28\"],\ndiv[style=\"height:90px;\"],\nnoindex > div[style*=\"height:\"]",".rec_book,\n[class*=\"wow\"]",".z_picard_card_d,\n[id*=\"wow\"],\na[href*=\"://www.livesport.ru/away\"]","#ne_nazhimat",".banner-border-wrap,\n.with-ad",".pediatr-banner-container","[width=\"630\"][height=\"90\"]","#bottom_media",".mod-custom3[style]",".google_container, .google_container + div[style],\n.interactive__vk,\n.vbanners",".block-reklamo_rotator,\n.toneBlock","div[style^=\"height:120px;display:block\"]","center > div[style=\"font-size:14px;background:#FFFACD;\"]",".artbannersplus","noindex > .linkPar","div[style=\"border-right: 1px solid rgba(0, 0, 0, 0.125);\"]",".pagination-item > [id^=\"bx_\"] ~ :not([id^=\"bx_\"]),\n.sidebar-module:has(> div[id^=\"adfox_\"])",".b-header-adv-stripe,\ndiv[style^=\"width:300px;height:600px\"]","#registr",".morefoot_back,\nnoindex > a > [width=\"250\"][height=\"250\"]",".b",".article__item_conversionlink,\n.article__item_slot,\n.daynews > table tr > td ~ td ~ td:last-child,\n.mailru-visibility-check,\n.viewbox__holder .viewbox__side,\n.viewbox__holder .viewbox__side-loader ~ *,\n[data-rb-slot],\n[data-view^=\"Slot\"][data-adq-id],\na[class^=\"rb-\"][href^=\"https://r.mail.ru/\"][target=\"_blank\"],\naside div[style^=\"min-height:\"][data-hideorder]:first-child:not(:only-child),\ndiv[class*=\"rb-slot_plug\"],\ntbody:has(> tr > td > [class*=\"daynews__item\"]) > tr > td ~ td ~ td:last-child,\ntr > .daynews__spring","#bubble-home,\n#grid .asteroid-widgets,\n#grid .widget__container .promo-with-text,\n#grid .widget__container > .calendar-container,\n#grid .widget__container > .event-list-widget,\n#grid .widget__container > .games-widget,\n#grid .widget__container > .progress-bar-widget,\n#grid div[class^=\"feed__\"],\n#user-settings-modal > .user-settings-container > .user-settings-types > .user-settings-types__item:first-child,\n#user-settings-modal > .user-settings-container > .user-settings-types > .user-settings-types__item:last-child,\n.balloon-anchor > .balloon,\n.mailbox__add-btn-logo,\n.ph-ext,\n.ph-project-promo-container,\n.resplash-btn.noadsButton,\n.weather_right-column .weather__description::after,\n[data-testid=\"news-tabs\"] ~ div > div ~ div > div[style],\nbody > .grid > div[class^=\"grid\"][class*=\"__header\"] > .toolbar,\nbody > .zeropixel ~ * .balloon,\nbody > .zeropixel ~ * .stripe-wrapper,\nbody > .zeropixel ~ * div[class][style^=\"color:\"][style$=\"background-size:auto 40px\"],\nbody:not(.js-module) .searchContainer ~ div > a.dmb,\ndiv[slot=\"main-column\"] > .header,\ndiv[slot=\"main-column\"] > .header ~ .swiper,\nmain#grid .promo-news,\nmain#grid > .grid-middle ~ div:not([class]):not([id])","[data-logger-parent=\"sidebarDoubleRight\"]","div[data-closewrap-container]","table > tbody > tr > td:first-child + td + td:last-child",".stripe-wrapper,\n.tgb-wrapper,\n.tgbv-wrapper","a[id^=\"tb-\"][class^=\"tb-\"][target=\"_blank\"],\ndiv[data-mp*=\"LazyPulse\"]",".grid > .grid__row_table > [name] ~ div:not([name]),\n.spring_adb,\n.wrapper > .cols > .cols__wrapper > :not([class*=\"cols\"])","div[class*=\"advHeaderStatic\"],\ndiv[class^=\"Datalistinfo__root\"],\ndiv[class^=\"Folder__worm\"],\ndiv[class^=\"Public-desktop__rightCol-\"],\ndiv[class^=\"ReactViewer__attachesSidebar\"],\ndiv[class^=\"ReactViewer__attachesinfo-\"],\ndiv[class^=\"ReactViewer__bottominfoWrapper-\"],\niframe[src^=\"https://o2.mail.ru/\"] ~ div div[class^=\"ViewerHeader__closeIcon--\"],\nsection > div[class^=\"Rightinfo__header\"]","div[class^=\"Worm__root-\"]",".cols__wrapper > aside,\n.deti-slot_exchange,\n.js-smoky-end","div[class^=\"Sidebarinfo__root\"]","[data-qa=\"ArticlesList\"] > [data-logger=\"ListItem\"] ~ div:last-child:not([data-logger=\"ListItem\"])","#app-canvas .layout__overflow-container > .advert-column,\n#app-canvas .layout__overflow-container > .slot,\n#app-canvas .promo-block-letter + div[class]:not([class*=\"list-\"]):not(a),\n#message-sent__rb-center-container,\n#popup-placeholder,\n.layer-sent-page__banner,\n.layout__content div[data-test-id=\"promt-tooltip\"],\n.letter-list-item-adv",".m-fixed-panel","[data-logger-parent=\"sidebarRight\"]","[data-qa=\"Grid\"] > div > div:has(> [data-rb-slot]),\n[data-qa=\"Grid\"] > div:has(> div > [data-rb-slot]),\n[data-qa=\"Grid\"] div:has(> .marker-adv-holder span[data-qa=\"Text\"]),\ndiv[data-qa=\"Box\"]",".js-scroll-to-site__hidden",".adv-marker_hover,\n.align_left > a[aria-label=\"Смотреть онлайн\"],\n.block_ad-text,\n.p-commercial,\n.p-movie-intro__commercial,\n.p-movie-intro__content-inner .adv-marker_hover ~ .text,\n.p-tv-major__spring,\n.sticky-springs div[style*=\"position:\"],\na.button_color_project[name],\ndiv[class*=\" rb_\"],\ndiv[data-required]","div[class*=\"sticky-springs__item\"]",".direct_septima",".TopBannerSlot,\n.adv-contacts,\n.banner_left,\n.link-ad","#like-buttons,\n.left-advert-block","[href^=\"https://minigames.imgsmail.ru/static/css/social-likes.\"] ~ div[class]:has([href*=\"/info/adblock\"])","#history_container > div[class][style*=\"display: block!important\"],\n.app-event-bubbles,\n.b-column-right__block-news-cloud,\n.b-fourth-pseudo-column,\n.b-history-event:empty,\n.b-history__adv-post-carousel,\n.b-music__main__banner,\n.b-video__native-rb-banner,\n.b-video__top-rb-banner,\n.l-app__left,\n.l-app__right,\n.l-common__container > div > div[style^=\"display:\"],\n.sp-video__billboard,\n.ui-simple-block[class*=\"promo\"],\n:not(.l-common__container) > div[style*=\"position\"][style*=\"display\"][style*=\"visible\"][style*=\"opacity\"][style*=\"background-color\"],\n:not(.l-common__container) > div[style^=\"position:\"][style*=\";display:\"][style*=\";opacity:1;visibility:visible;height:\"],\ndiv[class^=\"app-adv-\"],\ndiv[class^=\"l-music__banner\"],\ndiv[style^=\"position:\"][style*=\";display:\"][style*=\";opacity:1;visibility:visible;height:\"] > div[style^=\"display:\"],\nhtml.window-loaded .b-video-backscreen",".r-source,\n.reference-page__card ~ span:last-child",".layout_footer > .block","div[data-module=\"LazyLoad.PromoPopup\"] .js-module.block","#ok-wrapper.container div[class][style=\"width: 100%;\"],\n#ok-wrapper.container span.js-href","a[href^=\"https://t.mail.ru/redir/\"],\nbody div div[class*=\"adv-slot-\"],\ndiv[data-pos],\ndiv[style^=\"top: \"]:has(> div > div[class=\"\"]:empty),\ndiv[style^=\"top:\"] ~ div[style^=\"top:\"] > div > div[class=\"\"] + div:last-child",".adv-marker-box,\n.pm-toolbar__group ~ .pm-toolbar__group .pm-toolbar__banner ~ .js-button [class],\n.pypo-slot,\n.pypo-springs-sticky,\n.top-ad-wrap,\n[data-qa=\"ArticlesList\"] > div:has(> .pypo-slot),\ndiv[class^=\"Gallery__slideSide_\"]",".cols__column__inner_border,\n.forecast-branding-link,\n.js-springs__group__top,\n.unprinted",".page__content__slide > .messagelist > div:not([cid]):not([style]):not([id]):not([class])",".cols__column_sidebar > span,\n.counters ~ div[id][class*=\" \"],\n.counters ~ span div[id][class*=\" \"],\n.js-no-smoky ~ div[class^=\" \"],\n.js-no-smoky ~ span > div[class^=\" \"],\n.sticky-springs,\n.viewbox__slide_side_show,\n.viewbox__slide_side_show ~ span,\n.wrapper > .cols [id][class*=\" \"],\n[data-content=\"Смотреть онлайн в любое время\"],\nbutton[data-player*=\"eid\"][name],\ndiv[class*=\"js-popup\"] div[id][class*=\" \"]","a[href^=\"http://mainspy.ru/banner/\"]","[data-role=\"sidebarAd\"] > center,\ntr > td[align=\"center\"] > script + center > a[href] > img","span[id^=\"banner\"]","#photo_viewer[style],\n#top_banner_ad_fox,\n[data-name=\"search-banner\"],\ndiv[id][style=\"width: 320px; height: 100px;\"]",".img_ban","div[class^=\"m1\"]","a[href*=\"kredit100.ru\"]","a[href*=\"swaqua.ru\"]","#positioner > div[style=\"height:30px;\"],\nimg[src*=\"/images/pari/\"]",".fullwidthbanner-container",".sovet",".cards__col:has(> .card_cb)",".content_banner",".md-block-native_ad",".js-info-block-fixed","#player_ima-ad-container,\n.rexona_player_play","a.vjs-link_view-mpartner[href=\"https://matchtv.ru/subscriptions\"]","#nagadai,\n.leftAdClass",".abs,\n.page_Banner,\n.rotac_reklama,\n.spanlink[onclick*=\"biorepet-ufa.ru\"],\n.spanlink[onclick*=\"e-autopay.com\"],\n.spanlink[onclick*=\"foxford\"],\n.spanlink[onclick*=\"ohnet.ru\"],\n.spanlink[onclick*=\"uchmet.ru\"]",".sape",".d290 > .adv_small","a[href^=\"http://printbook.ru/\"]","#advTopLine,\n#requestShutOfBlocker,\ndiv[id*=\"Tutor\"]","a[href*=\"?partner\"],\niframe[src*=\"mauforum.ru/\"][src$=\"/\"]","center > strong","a[href^=\"/ent.php\"]","#rightRnd,\n#yandex_sim,\ndiv[id^=\"mega_rt_\"]",".creative-container._vb-2",".ds-block-product",".module__block_rectangle","div[class*=\"adfox\"]","#pagecontent > div[style*=\"background-color\"]",".podpiska",".branding_adv",".ipsPad_bottom",".rek-bar,\n.theiaStickySidebar > ul > .widget_text",".sidebarAds",".structure-index > div:not([id]):not([class])[style^=\"width\"],\n.structure-index > div:not([id]):not([class])[style^=\"width\"] + div[align=\"center\"],\ndiv[style=\"overflow:hidden\"] > div[align=\"center\"][style^=\"height:\"],\ntd[align=\"right\"] > .structure-right:not([id])",".ad_money,\ntd[width=\"240\"] a[href^=\"go.php3?id=\"]","#billboard-atf,\n.ads-run-blocks","#reportsInfoBase","#cnt_top_top,\nmain > .hide-on-mobiles > div[class=\"sideblock\"]:first-child",".eump-com-linktxt","div[style=\"background: #fff;padding: 10px; margin-bottom: 20px;\"]",".r_banner","a[href^=\"/index.php/poster_redir\"]",".google_adv",".rusfond-block,\n.side-banner-yandex","div[id^=\"youtube_ad_\"]",".platform-content:has(> .moduletable a[rel=\"sponsored\"])","img[width=\"200\"][height=\"400\"]","form[name=\"show_image\"] > center,\nscript[src^=\"http://am10.ru/\"] + center","#header_bottom,\n.js-banner","div[style=\"width: 80%; align-items: center;\"] > center","body > center > a[href][target=\"_blank\"]:first-child",".caution-message,\n.caution-message ~ *,\n.preloading,\n.vopros-block",".footer-promo-block","#content > div[style^=\"max-width:\"]","#sidebar_right","#right_col2 > .module","div[id^=\"add_rek\"]",".snp-root",".app-popups",".preview-section .vertical-video__loader","#bonuses-modal,\n.catfish,\n.comm,\n.fb-comm,\n.header-bk,\n.users-preferences,\n[data-type*=\"banner\"],\na[class*=\"Header_headerPromo\"],\na[href^=\"/promo\"],\ndiv[class^=\"BookmakersRating\"],\ndiv[class^=\"Catfish_catfish\"],\ndiv[class^=\"DefaultType_banner\"],\ndiv[class^=\"ExternalWidget_\"],\ndiv[class^=\"HomeBranding_mainBackground\"],\ndiv[class^=\"StickyPanel_\"]","#ban_500,\n.block_top:has(> div:empty),\n.block_top:has(> div:empty) + div,\n.block_top:has(> div:empty) + div + .block_bottom,\n.main_container[style*=\"90px\"]","#sm_content,\n#sm_olay,\n#wrapper > .fma-bg","#wrap-popup-box,\n.clearfix.content > div > .col-sm-12",".banner_margin,\ndiv[class^=\"metro_banner_\"]","a[href^=\"http://lite.baza-winner.ru/\"]","noindex > div[align=\"center\"]",".custom-html-widget > noindex,\ndiv[class^=\"papex\"]",".rotator-wrap",".sidebar_rek","a[href*=\"nfemo.com/click\"],\ndiv[style=\"text-align:center;clear:both;\"]","a[href*=\"http://new-igry.ru/games/\"] > img[src^=\"/uploads/posts/\"],\na[href^=\"/lp2/go.php\"]","#abDetected","body > [class*=\"-blackout active\"],\nbody > [class*=\"-blackout active\"] + div[class$=\"-wrapper\"]",".advt-mf",".b-map-tgb-container,\n.m-mimikria","aside > .block:has([id^=\"ambn\"]),\nnoindex > center > a","[id^=\"trumedia_holder_\"],\n[id^=\"trurlmedia_holder\"]","#very-right-column,\n.aggregator__header,\n.partner-block-wrapper,\n.post-data > div[id^=\"pad_b\"],\n.top-block__ad,\n.topic-block:has(> .partner-block-wrapper),\n.topic-block:has(> [id^=\"adfox_\"])","a[href*=\"banners.php?click=\"],\na[href*=\"banners.php?click=\"] + a",".slidebox_social",".yandex",".article-grid__good-top,\ndiv[class^=\"good-place\"]","div[class][style*=\"important\"]",".panel-danger,\na[href*=\"zjbi.ru\"] > img",".post-right-ads",".tidymag-sidebar-content",".fotwdgt_bt_adw,\n.prom,\n.tg-fon-gif",".recomend,\ndiv[class*=\"300x600\"],\ndiv[class^=\"bnr-background\"],\ndiv[id^=\"bnr-background\"],\ndiv[id^=\"container\"]","[data-ad-slot]",".shapka > a[target=\"_blank\"]","#floating",".zen_subscribe",".bg-general,\n.container-links,\n.fon-ref,\n.link-1,\n.page-header > .bg-one-server,\n.page-header > .left,\n.page-header > .right","div[class^=\"banner_right\"]","span[style*=\"background: #ffe348\"]","#sb-site > div[class][style*=\"z-index\"][style*=\"999999\"]",".widget-sidebar:has([src*=\"/wp-content/uploads/\"][src*=\"/ban\"][src*=\"er\"]),\n.widget-sidebar:has(p > script),\nimg[src*=\"/wp-content/uploads/\"][src*=\"/ban\"][src*=\"er\"]","meta + center > table[cellspacing=\"0\"][cellpadding=\"0\"][border=\"0\"],\ntd[width=\"190\"] > .table[width=\"190\"]","div[class^=\"RELINK\"],\ndiv[class^=\"relink\"]","div[style$=\"468px;\"]",".bg_banner,\n.mbanner_in_post,\n.tbanner,\nbody > div[id^=\"float_head\"] > div[id^=\"bg-\"],\ndiv[class^=\"rbanner\"],\ndiv[id^=\"lbanners\"]","[href=\"http://www.ivlim.ru/\"],\ndiv[style=\"padding-top:5px;height:107px;\"]",".side .in[style]","#wrap > .forabg:has(> div > div > .adbp > table)",".single-teasers","div[style^=\"border: 1px solid #b56e13; padding: 5px; border-radius: 6px; font-size:\"]","body > [id]:not([class]):not([iframe]):not(#main-bg)",".sidebox:has(> .inner > .adsbygoogle)","#header_baner",".pro-adv,\n.pro-block:has(> .pro-block-adv),\n.sitebar_reklama_wr","#adapt-wrapper > noindex,\n.headBn,\n.headZyx,\n.pinBnFs",".banner-place::before,\n.sidebar-border,\n.sticky-wrap > div[id^=\"id-\"]",".post-tags__yn,\n.post-tags__yz,\n.sidebar-ya-wrap,\n.yanews-button,\n.yn,\n.yz","center > a[rel=\"nofollow\"][target=\"_blank\"] > img",".main-header","#tad-box","body > #colorbox *","div[id^=\"yaad\"]","div[style=\"min-height: 50px;\"]:has(> img[src*=\"/file/id_content:\"])","#left_banners > a[href=\"http://sod.mos.ru\"]",".sideColumn > div[class] > div[style^=\"margin-bottom:\"] + div","aside > .block .banner","#logodesc td[width][align],\n.copyright > a[href]","[data-motor-desktop*=\"exchange_block\"]",".b_block,\n.pban,\nbody.noscroll::before","#wrapper > #header","a[href^=\"http://www.mountain.ru/banner\"]",".search-item_tgb,\n.specs-column,\n.specs-near,\ndiv[class=\"row specs\"],\ndiv[class^=\"rnb-\"]","#kt_player > iframe[src]",".nofs_container",".footr,\n.igrof","div[id^=\"PM_rotator\"]","body > div[class^=\"tccSm\"]","[class^=\"tizdiv\"]","[id^=\"teaser_\"]",".btop",".video-box table[style^=\"background-color: #000000;\"]","a[href][target=\"_blank\"] img",".zen-widget","#stickymsg","#right_column",".banner_header","#page-sidebar > div > h3,\n#page-sidebar > div > h3 ~ ul,\n#vue-bubble,\n.additional-info > nofollow > [align=\"center\"] > a[target=\"_blank\"] > img,\n.courses,\n.promo-popup,\n.r-courses__lists,\n.wrapper > div[style^=\"background:\"][style*=\"videouroki.net\"]","div[class^=\"advertising-content-\"]",".topiclist + div[style^=\"padding\"]","#popupBanner,\n.SEO","#popup_overlay,\n#social_popup_window,\n.ovl_pf","a[href*=\"barbarisnews.ru\"]","#cont-i > span[style*=\"color:red\"]","div[class^=\"commercials\"]","a[href^=\"http://tasselmagic.ru\"]",".section > #tn1",".elle-special-projects","#popap_top","div[id^=\"pad_bnr_\"]","div[id^=\"beta_place_\"]","#reclbarfix","td[bgcolor=\"#FDFDFD\"][align=\"left\"] > noindex,\ntd[bgcolor=\"#FDFDFD\"][align=\"left\"] > noindex ~ br,\ntd[width=\"240\"] ~ td[width=\"100%\"] > table[width=\"100%\"][align=\"center\"]","#featured-wants,\n#letystd-block,\na[href^=\"/r.php\"]",".gamepage_download_left,\n.gamepage_download_right",".items > .p-item ~ div[class][style],\n.view-related-item[style^=\"height:\"]","a[href=\"javascript:\"]","#download_form > .modal-body,\n#download_form > .uk-margin-top[style],\nbody > div[id][style*=\"position: absolute\"],\ndiv[id][class][style*=\"width\"][style*=\"height\"]",".vbmenu_popup + div[align=\"center\"]:not([id]):not([class])",".media-ads-block","body > #layout > .fixed","#right_banner_wrapper",".sidebarzap .widget_custom_html ~ .widget_custom_html.FixedWidget__fixed_widget","._banner","div[class^=\"page-header__top-banner\"]","#right > .nofloat,\n.tb-container",".ru320140",".ru56070","body > * > div[id][style*=\"height:\"],\nbody > div > table[width=\"92%\"]:not([class=\"top-region\"])","._block-banner,\n.rightCol > div:has(> a > img[src*=\"/images/banners/\"]),\n.seo_green",".ads_single,\n.naked-banner,\n.shesht-ad-side-banner","[class*=\"teaser\"]","#gifts",".noun","a[href*=\"sun-leads.com\"]","[style^=\"background:url(/img\"][style*=\"padding\"],\na[href*=\"/test/\"][target=\"_blank\"]",".art-postcontent div[style] > a[href][target=\"_blank\"] > img,\ndiv[id*=\"script\"],\ndiv[style*=\"margin-top: 9.5px;\"]","#daos_outer",".art-sidebar2 > .widget_text",".container > table[align]","p:has(> a[href*=\"yandex.\"][href*=\"news\"][href*=\"favid\"])",".saitbar_bock:has(.mpwidget)","body > div[style*=\"background-color:#ff0000;color:#ffffff;\"]",".column a[href][target=\"_blank\"]","#bkbanner,\na[href^=\"https://kontur.ru/\"]",".pad > noindex,\ndiv[id^=\"sbs\"]",".buttons","[id^=\"cmdgebh\"]","[class=\"0\"] > .firstnews","a[href^=\"/bn/bn.php?partner=\"]",".iseeyou","[data-dlebclicks]","noindex > table[width=\"100%\"]",".adgoogle","#r_detail_bottom",".su-note",".adblock-notify,\n.exchange-block,\n.partners-header,\n.partners-right,\n.sidebar-widget,\ndiv[class*=\"single-rtb-\"],\niframe[src^=\"/exchange/\"]",".header-rek-block,\n.social-container","p:has(> strong > a[href*=\"//dzen.ru/\"])",".bue-align-c",".ftbn-b-yan,\n.ftbn-b-zen,\n.mbl-adv,\n.mod-floatbann",".discount-side-240,\n.navbar-nav > .important,\n.pr-side-240,\nbody > .soclinks + script + div[class]:not([id])","body > .sticky","#masonry-container > .corner-stamp,\n.aside-col > .moduletable:has(> .inner > .box-ct > .adsbygoogle)","#slyWindow,\n.blockOverlay.blockUI,\na[href=\"/reklama/\"]","a[href^=\"/redirect\"]",".banner-middle",".right_banners",".ad-before","#xtest-videoad",".banner-left-detail-new,\n.news-banners-source","#_prizmaNE,\n.special_banner_in,\n.standart_banner > [src*=\"/advertising/flash\"] + *,\na[href^=\"http://newsroom24.ru/ankvarzpr/\"]",".post-content + div[style^=\"border:\"]:has(> div > [href*=\"yandex\"])",".lipuchka,\n.rsya","div[id][style=\"height: 120px;\"],\ndiv[id][style=\"height: 80px;\"]",".stream-item-above-post,\n.theiaStickySidebar > .widget_text:first-child",".sideitem","[data-ads]",".adf-ins",".lv-right-banner,\n.lv-right__text-advert",".sp-toppromo",".articles,\n.place","div[class*=\"iw-modal\"]","div[id*=\"_ban_\"],\ndiv[id^=\"tab_scroll_\"]",".firefox,\n.trueoffice","#az1,\n#az2,\ndiv[id^=\"az\"]","a[href^=\"/banclick.php\"]",".au-top-ads-container,\n.bottom-auto-ads,\n.rn-global-sidebar,\n.rn-top-banner,\n.starnews-block",".m_lbanner,\np > a[href][target=\"_blank\"]:not([href*=\"nnov.ru\"]) > img[src*=\"/bannery/\"]",".bottom-rkl",".remodal-is-opened",".content_cactus,\n.right_col_bamboo",".clearfix > .media,\n.mg-posts-sec:has(> script)","div[style=\"clear: left\"]","#rek_desktop_fixed",".floating_bnr","img[alt=\"Нацпроекты\"],\nimg[alt=\"Тульские СМИ\"]","div > #yaMarket ~ table[width=\"100%\"]","._1ysoK,\n.comments_block div > article + div[style^=\"margin\"],\ndiv[class]:has(> div[style^=\"display\"] ~ div > div[id*=\"adfox_\"])",".root > .bigb,\na[href^=\"http://r.novgorod.ru\"]",".ad-block",".contdi,\n.contdiv,\nnoindex > .co",".grid-news-none,\n[id^=\"rtb_\"]","[onclick*=\"Click_slider_ad\"]","#advert_result",".mesre.amessage,\n.ntgb_,\n.rightbar,\na[href*=\"adrai.novostroykin.ru/wow/go/\"],\niframe[src*=\"adrai.novostroykin.ru/wow/go/\"]","#bannerholder,\n#lightbox,\n#lightboxOverlay,\n.b-header__banner,\n.promo_link","app-advertising-card a[href*=\"utm_campaign\"][target=\"_blank\"],\napp-article-banner,\napp-topline-advertising","div[class^=\"header-top\"] ~ *",".ban",".big_banner",".bannertop","#newszen,\ndiv[id^=\"flamur\"]","a[href*=\"://o-keys.ru/ya_browser\"]","div[style=\"width:970px;height:250px;margin:12px auto 12px auto;display:block\"]","#headBaner,\n.miko-baner-center,\n.vr_mobile_right_block","noindex > center > table",".js_load",".l2",".mainrams > div[class^=\"cd\"]",".jPanelModule",".ads_banner_right",".bottom_abs_info,\n.data-banner > #brunch,\n.data-banner > #zarniza","div[id*=\"baner\"]",".h2o,\niframe[src*=\"zzap.ru\"]",".main-branding,\n[data-popup=\"bonus\"]","#content > div[style=\"margin-left: 15px; margin-top: 10px;\"] > a > img,\n#sidebar > #boxes,\n#text-33,\n#text-34","div[class^=\"toneBlock\"]",".card-container","aside .widget_text",".jquery-modal.blocker",".adblock_popup_warning,\n.grf_wrapper","img[src*=\"ad.admitad.com\"]",".content-footer__subscription,\n.good,\n.good__header_top","#fthColWrp *,\n#hook_Block_AsideColumn img:first-child ~ div:not(#hook_Block_CompactFooter),\n#hook_Block_AvatarPromoMenu,\n#hook_Block_FixedPromoBanner,\n#hook_Block_ForthColumnTopBanner,\n#hook_Block_FourthCol div:has([class] ~ [class] ~ [class] ~ [class] ~ [class] ~ [class]),\n#hook_Block_LeftColumnAdCustom,\n#hook_Block_TargetBanner,\n#hook_Block_TopContent,\n#rightColumn[data-mouse-wheel],\n.dialogWrapperBanner,\n.exit-popup,\n.feed-list > .feed-w:has(> [class^=\"feed\"] > .feed-header [class] ~ [class] ~ [class] ~ [class] ~ [class] ~ [class]),\n.feed-list > .feed-w:has(button[class*=\"advert-badge\"]),\n.forthTopAdv,\n.html5-vpl_oklive-banner,\n.update-browser_container,\n[data-module*=\"banner\"],\ndiv:has(> #hook_Block_CompactFooter) > div:not(#hook_Block_CompactFooter),\ndiv[class*=\"__banner-feed\"],\ndiv[class*=\"__banner-feed-\"],\ndiv[data-place*=\"BANNER\"],\niframe[src^=\"//oktools.ru/page/static/\"]",".adstitles",".message[data-author=\"Ads Master\"],\nimg[src*=\"/img/rkl/\"]","#screenGlideAdb,\n#topAdb,\n.news-grid > div[id^=\"first\"],\n.news-grid > div[id^=\"rastyagka\"],\n[data-io-article-url] .content-block,\nbody div[class*=\"-branding\"],\ndiv[id^=\"newsUnderNewsFullwidth\"][class=\"grid\"]",".bb-a_b,\n.blopr,\n.rcblo",".left_col_top,\n.left_col_top ~ *,\na[href*=\"omskinform.ru/go/\"][target=\"_blank\"] > img","a > img[height=\"100\"]","img[width=\"468\"]",".mts__block","a[href^=\"http://adv.omskzdes.ru/\"],\nobject[id^=\"banner\"]",".sticky.first","#banner_big","p > table[cellspacing=\"5\"][cellpadding=\"0\"][width=\"100%\"] > tbody > tr > td[width=\"50%\"][style=\"border: 1px solid #000;\"]",".table-scroll",".no-pop",".V3-wrap-big",".video-box ~ .ageBlock","#sub-songs","[href=\"/reyting-bukmekerov/\"],\ndiv[class^=\"dle_b_\"]","#socAds,\n[id^=\"ad\"][class*=\"ads\"],\ndiv[class^=\"wraprer\"]",".bnr__mark",".forum-section .main > div[align=\"center\"],\n.widget:has(> .text-center > script),\ndiv:not(.adv-wrapper):has(> ins)","noindex > iframe","#basic-modal-content","body > font > font > div[style*=\"width:\"]","#container > div[style],\n#left a[href*=\"://opershop.ru\"],\n#left li:has(a[href*=\"//wink.\"]),\n#left li:has(a[href*=\"://opershop.ru\"]),\n#middle > .thumbnails:has(> ins a[href*=\"//wink.\"]),\n#middle > dd:has(> .body > a[href*=\"//wink.\"]),\n#wrapper > #bglink,\n.follows-channel_zen,\n.recommend,\na[href=\"https://oper.ru/follow/wi\"],\ndd > .body > center ~ *,\ndd > .body font > a[target=\"_blank\"]","td[width=\"90\"]",".dcont .b_center,\na[href^=\"http://self-test.org/\"]",".top-news","#downbanners",".td-ad-background-link,\na[href^=\"https://orenburg.metro-cc.ru/\"]",".forumrules > a[href]:not([href*=\"airgun.org.ru\"])","[src^=\"/adv/\"],\naside > .boxlet[align=\"center\"],\ndiv[id*=\"interpag\"]",".yt-header-bg","[src=\"/download32.png\"]",".bnz_horizontal","td[width=\"10\"] + td[width=\"260\"]:last-child","a[href^=\"/redir.php\"][target=\"_blank\"] > img[src*=\"banner\"]","#logo-area","#rightside noindex","#primary .textwidget noindex,\na[href*=\"cookery-on-every-day.ru\"],\na[href*=\"moudom.ho.ua\"],\na[href*=\"privatbank.ua\"],\na[href*=\"swigroup.org\"],\na[href^=\"http://www.ozon.ru/context/\"]",".modulebody > table[style=\"width:200px\"],\nimg[style=\"height:90px; width:728px\"]",".bottom-money,\n.others","#custom_html-14,\na[href*=\"://genshindrop.com/ref/\"],\ndiv[class^=\"code-block\"][style*=\"text-align: center;\"]",".sideblock > .sidecap, .sideblock > .sidecap + .sideinner","a[href=\"http://evpatoriya-leto.crimea.ua\"]","body > .page-wrapper-common ~ div[id][class=\"\"]",".article_openx,\n.uk-article-header-content:nth-child(2),\n.uk-panel-box.linker,\n.uk-panel-box.widget_text,\na[href^=\"http://otvetkak.ru/go.php\"]",".content table[height=\"90\"]",".an-line-between,\n.container-block:has(> [class]:not(.container-block) > ins),\n.container-block:has(> ins:first-child),\n.hostkey,\n.main-wrap > .grid.ui > div[style=\"display: block;\"],\n.mainlist-inline-an > :not(.tag-trend),\n.mainlist-inline-an[class*=\"main-articles\"],\n.material-content > .column > p > ins ~ br,\n.material-inline-an,\n.material-other-feed,\n.right-content-wrap.sticky-container,\n.right-sticky-content:has(> ins),\n.spoiler-block:has(> .spoiler-body > [id^=\"yandex_rtb_\"]),\n.top-menu ~ .main-wrap.container > .grid.ui > .row.container-block,\n[id^=\"pipMtbRoot\"],\nbody > div[class][style*=\"margin-\"],\ndiv:has(> #fixScrollPip),\ndiv[class*=\"__lxG__\"],\ndiv[class*=\"pip-\"],\ndiv[class]:has(> [id^=\"pipMtbRoot\"]),\ndiv[itemprop=\"articleBody\"] > div[id^=\"yandex_rtb\"] ~ br,\nh4.left.aligned.divider.header,\nh4.left.aligned.divider.header ~ .divider,\nimg[src^=\"https://overclockers.ru/st/images/partners/\"]",".needblock,\ndiv[style=\"border: 1px solid #ccc; margin: 5px 0; text-align:center; background-color: #d9e5f1; font-size:20px; font-weight:bold;padding:10px\"]","[src*=\"/banner\"]",".layout-page > div:has(> div > p > a[href*=\"://docs.ozon.ru/common/pravila\"]),\n[data-lcp-name*=\"anner-\"],\n[data-replace-layout-path] > div[style=\"height:300px;\"],\n[data-replace-layout-path]:only-child > div[style^=\"min-width:\"][style*=\"height:\"],\n[data-widget=\"advBanner\"],\n[data-widget=\"advVideoBanner\"],\n[data-widget=\"freshIsland\"]:has(> div > [data-widget=\"objectBannerList\"]),\n[title=\"Реклама\"],\ndiv[data-widget=\"banner\"],\ndiv[data-widget=\"videoProductBlock\"],\nheader + [data-replace-layout-path] > div[class]:not([data-widget]):first-child","body > div[id][style^=\"display: block\"][style*=\"background: red\"]","body > #overlay",".topLink a[href*=\"ruscale.ru\"]",".poster > .poster-content + p",".tgb__heading","#filter-form a[href^=\"/redirect/\"][target=\"_blank\"]",".tg-promo","#google-block","#top > .sepA,\n#top > div[style*=\"height: 200px\"],\n.placeR > .link",".floatcontainer.formcontrols.blockbody > a[href][target=\"_blank\"]","body > div[style*=\"fixed\"]:not([id]):not([class])","#surfbe,\n.rbrocks,\nbody div .banner,\nform > div[style^=\"width: 300px;\"]",".sidebar > #HTML2","div[align=\"center\"][style=\"display: block;\"],\ndiv[style=\"text-align: center; margin: auto;\"] > a[target=\"_blank\"]",".horizontalBanner,\n[class*=\"winner\"]",".zenlink",".article-banner","#divMain > .clear,\n#divMain > div[id][style=\"margin: 0px 10px; height: 60px;\"],\n#ulNewsList > li.b,\n.newsList > li.b,\n[pnz-ads]:not(eto-dlya-mob-ver),\n[style*=\"height: 43px\"][style*=\"max-height: 43px\"] ~ div[class^=\"space_\"],\n[style^=\"width: 140px; height: 280px;\"],\na[href*=\"://b.penzainform.ru/go/\"],\ndiv[id][style*=\"width:\"][style*=\"height: 43px\"],\nli[style^=\"width: 140px; height:\"][style*=\"max-height\"]","#index-right > .col-border.col-1,\n.b-content,\n.b-main__important,\n.b-top-wrapper,\n.mainmenu-ads,\n.news-content__b,\n.sidebar.col-1","#contentBox > #right > #rightContent,\n.altAdA",".inner__share-ya-zen",".alert-blue","#amigo_btn","#header_right_cell",".fix",".a__link,\n.h-menu__item--external,\nnoindex > noindex","[class$=\"banns\"]","div[class^=\"social-list-subscribe\"] > a[href*=\"yandex.\"]","[data-id-promo]","div[style^=\"width: 728px; height: 90px;\"],\ntable[width][height=\"90\"][style]","div[id^=\"mindmachine\"]","a[href^=\"http://supertest.ga/\"]",".b_verh_st,\na[href^=\"/go?https://w.cscore.ru/mira/\"],\ndiv[id^=\"av\"],\ntable[width=\"100%\"][align=\"center\"] > tbody > tr > td.column[valign=\"top\"]","#rightpan > .block:has(> div > a[href*=\"banner\"][target=\"_blank\"])","body > #bb","#home-wide-block","#content div[id^=\"slider_\"],\n.post_wrap:has(> #post_body_b)","#menu-subs > [href]::after,\n.ads-placeholder,\n.comments__adv,\n.header-right-menu > a[href][target=\"_blank\"],\n.player__adfox,\n.sidebar-block_half,\n.sidebar-block_placeholder,\n.stories-feed__container > .story:has(> .story__main > [id]),\n.stories-feed__container > .story:has(> .story__placeholder),\n.stories-feed__container > .story:has([class*=\"sponsor\"]),\n.stories-feed__container > .story[data-author-name] ~ .story:not([data-author-name]),\n.stories-feed__container > .story[data-author-name] ~ .story[data-context-actions*=\",profile_hide,\"],\n.stories-feed__related-stories-adv,\n[data-role=\"adb-warning\"],\n[href*=\"/acceptable-ads\"],\naside > .sidebar-block:empty","#footer-widgets .group.pad",".match-info ~ h3,\n.odds,\nimg[src*=\"/img/mars_\"],\nimg[src*=\"/img/melbet\"]","div[class^=\"hairw-\"]","div[id^=\"banner-right-inside\"]","body > table > tbody > tr > td[valign][width]",".bn-wrapperWrithwhasd","#sidright > .srm,\n#yandex_save,\n.custom_:has(> div[id*=\"ScriptRoot\"]),\n.custom_:has(> div[id^=\"infox_\"]),\n.custom_:has(> div[id^=\"unit_\"]),\n.slideshowck",".dfp-container,\n.mezzanine > .mezzanine-center > div:not([class])",".subscrite-widget:first-child",".match-bet,\n.match-coef",".side_left > center,\n.side_right > center",".gray_border.pie","a[href*=\"://go.pleogame.site/r/\"]","#check_ad_block,\n.partner_news__container,\ndiv[class^=\"pr__news\"][style=\"padding-right: 0 !important;\"]","#light_comment,\n.fpa-block",".banner-advertise-img",".infoblock > div[style=\"height: 900px;\"]","#headban_right,\n#main-ban,\n#sidebar-right noindex","#banners > noindex > a[href]:not([href*=\"pobedish.ru\"])","[href*=\"ohnet.ru\"]",".advertising > span.title,\n.box-side > .box-content > noindex,\n.two-banners,\na[href][onclick*=\"banner_click\"],\na[href^=\"http://opx.podolsk.ru/www/delivery/ck.php\"]",".b-r > b","a[href^=\"https://lucky-boys.ru/\"]","a[href*=\"ove\"][href*=\"ou.ru/\"],\ntable + table[align=\"center\"][summary] > tbody > tr:first-child + tr:last-child > td[align=\"center\"][valign=\"top\"][width=\"333px\"],\ntable + table[align=\"center\"][summary] > tbody > tr:first-child > th:first-child + th + th:last-child,\ntd:has(> a[href*=\"iloveyou.ru/\"])",".PageCap > table .nodivs > a",".rekla_down_block",".shoppy","#news_tomsk > div:empty,\n.adsbox,\n.bannerbox,\n.blockm:has(> #sela),\n.footer > .center","div[id^=\"bannerplace\"]","#fixydiv,\na[href^=\"/go\"][href*=\".php\"]","#BlueA,\n#page-footer > noindex,\n.forumbg.forumbg-table[style*=\"background-color:#00A857\"],\n.table1 > tbody > tr[style^=\"background-color:\"],\na[href^=\"./go.php\"],\ntd[align=\"left\"][valign=\"top\"] > noindex","a.external[rel=\"nofollow\"][href*=\"/go/?site=\"] > img[src$=\".gif\"]",".main_width > div[align=\"center\"]",".ib-col div[style=\"width:600px;\"]","#hide-adblock","[id^=\"illumination\"]","#facebook_videoboom,\n.r_block > div[style=\"height: 600px; overflow: hidden\"]","a[href^=\"http://www.mirorgazma.ru/?partner=\"]","#head-links","a[href*=\"intim-shop.ru\"]","#aside > center ~ *","body > .slide.carousel",".ad_block_widget","#content > div[style^=\"padding\"]",".aimage,\n.bimage,\na[href^=\"http://chinaprices.ru\"],\ncenter[style*=\"margin-top\"],\nimg[width^=\"8\"][height^=\"3\"][src$=\".gif\"]","#ads_dummy,\n#ads_wide,\n#gAds,\n#top__mpic,\n.masonry-brick.ads","#sidebarinner > fieldset","a[href*=\"/offer/\"]","table[width=\"1000\"][height=\"95px\"],\ntd[onclick*=\"cntr.php?ban_id=\"]",".banner_before_mainmenu,\n.vk.soc-banner","#delta_14,\n.bl:empty,\n.sp-header-block,\n.video-bl,\n.video-bl ~ .specproject-widgets,\nbody > div[class]:empty[style=\"height: 100%;\"],\nbody > div[class]:empty[style=\"height: 100%;\"] + div a,\ndiv[class*=\"content-md\"] > div[class$=\"-m\"],\ndiv[class*=\"content-md\"] > div[class*=\"menu\"]","#right","body > [id]:not([class])[style^=\"z-index\"]","body > div[class^=\"mfp-\"]",".a-absolut-div-b","#pptcloud-mail","a[href*=\"/a/click/\"],\ndiv[id^=\"aabb\"]","a[href$=\".php\"][target=\"_blank\"]","#scrolling-news-list > div[style^=\"min-height:3\"],\n.page > .header,\n.special.block,\ndiv[class=\"section\"]:has(> .staticFragment)","[id^=\"warta_ads-\"]",".feed-bnnrs--right,\n.prvd-af-primary-rnnb",".entry-content > div:not([id]):not([class])[style^=\"height\"],\ndiv[class^=\"distr\"]","#back_brd,\n#footer + div[align],\n#m1-link[href],\na[onclick][target=\"_blank\"]",".vk-group","#kontainer-top","div[class^=\"sidebar-advert-block\"]",".ti-block",".bober,\n.news-container > hr ~ hr ~ hr",".b-adv-marker,\n.b-partners-news","#slide-sidebar[role=\"complementary\"]","#sidebar > .block,\n.banners-topic-banner","a[class*=\"http\"] > img[width=\"240\"]",".col-md-3 > center > img[style]","div[class^=\"news-card_newsPreviewRight\"]:empty","body > #TB_overlay, body > #TB_window",".pr-banner-wrap","div[class^=\"b-banner\"]","#content > div[style=\"margin:30px auto;\"],\n#submain > div[class^=\"a\"][style]",".adfox-hidden",".special",".charts-ad,\ndiv[style=\"width:300px\"]","body > div[class*=\"modal\"],\ndiv[id][block-id][style]","a[href^=\"https://cryptocandle.ru\"]","[data-href*=\"adbl\"],\ndiv[id^=\"bottom_block\"]","div[class*=\"vex-modal-block\"]","[class*=\"container-ad\"],\ndiv[class*=\"flex-grow\"]:has(> .sticky > .adv)","#pagenav_menu ~ div[style*=\"height:\"],\n.tborder[width=\"165\"]",".adp-block",".cpablcok,\n.strochka","div[id^=\"partners-content-\"]",".card-special-gallery--topic,\n.relative-products,\n.top-banner-slider","a[href^=\"http://bestgamblingsolutions.com/\"]",".b-custom-banner,\n.branding:not(body),\n.branding__footer","div[id^=\"gruptiz_\"]","table.weather + noindex",".wrap_flat_ads_block","a[href][target=\"_blank\"][title*=\"potter.timepad.ru\"],\na[href][target=\"_blank\"][title=\"trudobr.ru\"],\na[href][title*=\"/1clickgain/\"]",".egg-list",".main-post-content > p[style] > strong,\niframe[src*=\"ADVERT\"]",".smi","#secondary.widget-area",".flexbannergroup > div:not(.gsInformer)","#header > .container > a[href=\"/menu\"] ~ h2","div[class^=\"stream-item\"]",".bantop,\n.lcol.mainside > center","div[style=\"padding-top: 0px; padding-right: 0px; padding-bottom: 0px; padding-left: 0px; \"][align=\"left\"]",".psyTopBanner",".articles-page__banners_wrapper",".hb-placeholder",".sidebar-rek",".textwidget > a[href][target=\"_blank\"]",".b-advertising,\n.barmen-item,\n.chameleon,\n.right-banners",".topbannans-wrapper","a[href=\"http://bookfestival.mibf.info/\"],\na[href=\"http://ridero.ru\"]","div[class][style^=\"height:\"][id]:empty","div[style^=\"position:fixed; top:0px; left:0px; opacity: 0.9;\"]",".pythonworld-contributor","#rightPanelBanner,\n.advertTop,\n.q_banner,\n.q_teaser,\narticle[data-type=\"advert\"]",".items_block > article.item[style*=\"important\"],\n.items_block.news > .low_new:not(.aside_left),\n.primary > .low_new.item:nth-of-type(2)",".icoStr",".header_top > .left,\n.partners_box > *,\ndiv[class]:has(> .inner > a[href=\"/help/adblock/\"]),\niframe[src*=\"//ads.qrz.ru/\"]",".small-fancy-sheet:has(> .adv_banner),\n.small-fancy-sheet:has(> script),\n.yandex_ad_floating","a[href*=\"bannersdisable_button\"],\na[href=\"https://quote.ru/?utm_source=topline\"] img",".default_menu > div:first-child,\ntable + table tr:last-child > td:last-child > .border",".autor-bl","div[class^=\"News__adv\"]",".topright,\na[href*=\"/affiliate/\"],\na[href*=\"rich-birds.org\"]","div[id^=\"banner-place-\"]",".list-banner",".tiser_sape","#header_partenaire,\n[id^=\"zone_pub\"],\na[href*=\"report.capinfopro.ru/\"][target=\"_blank\"]","[summary=\"content_table\"] > tbody > tr > td[height=\"90\"],\ntable[style=\"margin-top:5px\"] a[href^=\"/adclick/\"],\ntd[width=\"240\"][valign=\"top\"] > div[style=\"height: 250px;\"]","#sidebar > a[href=\"#\"][onclick]","#banner_code,\n[src*=\"//radiokot.ru/adv/\"]",".dummy-yandex-zen-channel-block,\n.lentainform-block",".ad5en5eCheck",".grafity",".news__item_promotion,\nbody > a[href][target]","td.td-2 > a[href] > img",".forums ~ table[cellpadding][cellspacing]",".main > .container > .row .placeholder,\n.sidebar-island.box-shadow",".mblok","[data-news_media-desktop*=\"rnet_widget\"],\narticle div:has(> div > [id^=\"rcmw-container\"]:empty),\ndiv[id^=\"rnet_\"],\ndiv[style^=\"min-height: 140px\"],\ndiv[style^=\"min-height:140px\"]","[data-doctor_media-desktop*=\"rnet_widget\"]",".finance__partners,\n[data-finance_media-desktop*=\"rnet_widget\"],\nbody[data-finance_media-desktop=\"main\"] .commercial-branding > nav ~ div > div > script ~ div > div:last-child",".fzwuC,\ndiv:has(> [id^=\"rcmw-container-\"]),\ndiv[class][style=\"\"]",".notification-warning,\n[class*=\"MaillistItemAdvertPlace\"],\ndiv[class*=\"Ad-direct\"],\ndiv[class*=\"Ad-root\"],\ndiv[class*=\"AddBillboard\"],\ndiv[class*=\"AppContainer-adWrapper\"],\ndiv[class*=\"SentLetter-context\"],\ndiv[class*=\"WithRightBarWrapper\"] > div[class*=\"AutoAppContainer\"] ~ *","div[class^=\"DirectMKB\"],\ndiv[class^=\"LayoutSearch\"] section > article[class*=\" Serp__item\"]:not([class^=\" Serp__item\"])","[data-sport_media-desktop*=\"rnet_widget\"]",".rui-Snackbar-snackbar","[data-travel_media-desktop*=\"rnet_widget\"]",".eagleplayer-advertisement-remain-time","[data-weekend_media-desktop*=\"rnet_widget\"]","[data-woman_media-desktop*=\"rnet_widget\"]","#app > .ad,\n#app > script + div",".b-banners__bottom,\n.main-banner","#wrapper > noindex","body > div[id] > [align=\"center\"] > a[target=\"_blank\"],\ndiv[style^=\"height:100px;\"]",".erm-sidebar-part.hs-shadow[id] > .textwidget,\n.textwidget > a[href^=\"http://www.masmotors.ru\"],\ndiv[class^=\"best-prices\"]",".countdown,\n.deposit-block,\n.fox-fallback,\n.header__project__info,\n.item-in-article:has([href*=\"erid=\"]),\n.js-index-central-column .js-index-doscroll:has([data-pixels-on-show*=\"adfox\"]),\n.js-index-central-column .js-index-doscroll:has([href*=\"erid=\"]),\n.js-video-player-ad-skip,\n.l-col-100h:has(> div [href*=\"banner\"]),\n.l-sticky-right-parent,\n.mts-promo,\n.popup_push,\n.right-promo-block,\n.shopping-card-button,\n.showcase-collection__logo, .showcase-collection__subtitle,\n.simple-promo-card,\n.video-player__controls__ad-countdown,\n[data-vr-zone=\"Топ новости\"] a[href*=\"utm_campaign\"]:not([href^=\"https://pro.rbc.ru/\"]),\n[data-vr-zone=\"Топ новости\"] div:has(> a[href*=\"utm_campaign\"]:not([href^=\"https://pro.rbc.ru/\"])),\n[data-yandex-name^=\"selfpromo_\"],\n[data-yandex-show=\"cards_marketplace_show\"],\n[data-yandex-show^=\"commercial_cards_\"],\na.video-player__details[target=\"_blank\"],\nbody > [data-yandex-name=\"blockad_click\"],\ndiv[class^=\"item-slider__partner\"]",".g-banner__news-footer > div[class=\"js-rbcslider-multi-news\"],\n.news-feed a[href*=\"utm_campaign\"]",".rbc-header-hide-banners,\n.rbc-header-project-image,\n.swiper-wrapper > .swiper-slide a[href*=\"utm_campaign\"]",".js-one-office.premium",".header__partner",".block-banner",".slider-main > .single-item > a[href]:not([href*=\"yanzori\"])","#lh_bar-product",".side_rek,\n.top_header a[href][target=\"_blank\"]",".block-community-yanews","#masthead","#wrap-smi2,\n.yandex-dzen,\nbody > div:not([id]):not([class])[style^=\"width: 350px;\"]",".widget_custom_html:has([id^=\"yandex_rtb\"])","#main2 > table,\n#sidebar > .scroll,\na[href^=\"http://referatwork.ru/refwork_agency/\"] > img,\ndiv[align=\"justify\"] > center,\ndiv[style=\"rftk\"]",".banner__image,\nimg[src*=\"Baner\"]",".yandexAd",".right_banner_container,\n.top_container","#linkPlace,\nimg[alt=\"Читать онлайн\"]",".footer__promotion_container,\ndiv[id^=\"GPM_Relax_fm_\"]","#sidebar .yashare-auto-init ~ :not(em)",".b-main__split.hidden-print","aside > a[href][onclick=\"return !window.open(this.href)\"]","[onclick^=\"update_banner\"]","div[style*=\"height:325px;\"]","a[href*=\"/ffg.su\"] > img",".center_banner,\niframe[src*=\"gruntovik.ru\"]","#pagenav_menu + center ~ center,\n#posts > br","a[title=\"Дзен\"],\ndiv[aria-label=\"Дзен\"],\ndiv[class*=\"Adfox\"],\ndiv[class*=\"PageArticle\"][class*=\"_partner_\"],\ndiv[class*=\"YandexAD\"],\ndiv[class*=\"adBox\"],\ndiv[class*=\"adFox\"],\ndiv[class^=\"EditorialPageArticleAside_item\"][style^=\"height:\"],\ndiv[class^=\"Page_asideItem\"][style^=\"height:\"],\ndiv[id][class*=\"media\"]:empty,\ndiv[id][class*=\"tgb\"]:empty",".antiblock,\n.m-blur ~ #modalLayer,\n.m-ya,\n.the-in-carousel__item:has(> [data-has-banner])","a.gofollow[data-track]",".cookie-agreement-wrapper",".article--external,\ndiv[style=\"width:300px;height:500px\"]",".stat-zen",".view_banner",".m-padding","a > img[width=\"120\"][height$=\"0\"][src^=\"/images/\"]",".barInPost,\n.leftBar,\n.topBar","div[style^=\"background: url\"]","#button-container > .overlay,\n.message.ab,\n.right_panel,\nbody > marquee[style*=\"red\"]","#right_banners img[width=\"230\"]",".IsAdBlock","div[class][style=\"background-color:#fcfcee;padding:10px\"],\ntd[width=\"240\"] > table[class=\"tab-right\"]","#top_content + div[style=\"padding: 0px 3px 0px 10px; margin: 0;\"],\nbody > .noprint[style^=\"height\"]",".entry-con > noindex","#recl","a[href*=\"://robloro.ru/reklama\"]","[data-msetup]",".banner-970x90,\n.factus-promoted","a[href*=\"rosrabota.ru/delivery/\"] > img",".pblock",".plusonet-sl,\na[href^=\"http://rp-mechanics.ru/engine/go.php\"]","#adv240x400",".n-banner",".alibut,\nimg[alt*=\"реклам\"]",".subscribe-wrap",".main-news2 > div[style^=\"position: fixed;\"][style*=\"left:\"],\n.sidebar > a[href][target=\"_blank\"][rel=\"nofollow\"] > img,\ndiv[align=\"center\"] > div[style^=\"background-color:\"][style*=\"height:300px;\"],\ndiv[align=\"center\"][style=\" background-color: #ececec;\"] > div[style*=\"font-size:\"]",".elementor-popup-modal",".teasers_list","p[align=\"center\"] > noindex > a[href][target=\"_blank\"] > img,\ntd[background*=\"banner\"],\ntd[width=\"150\"][height=\"210\"],\ntd[width=\"231\"][height=\"100\"]",".b-content > .right,\n.left_information_block > aside",".customnopadding",".cpa_top",".tizz","div[class*=\"widget_custom_text\"]",".col-left > .pope ~ .pope","noindex > nofallow,\ntd[height=\"90\"][bgcolor]","body > div[id^=\"money\"]","#block-block-22","#detectAdblock,\n.searchField_y",".b-partners-integration,\n.partner-news-wrapper","div:has(> div > [id^=\"adfox_\"])","#subscription_banner_root,\ndiv:has(> div > [id^=\"yandex_rtb\"])","a[href^=\"/target/\"]","#sidebar > :not([class=\"banner240box\"]:first-child),\n.bannerBox",".ban_rek_a","div[class^=\"yved\"]","#service_column > a[target=\"_blank\"]:not([href*=\"почтоваякарта.рф\"])","#block-2",".market-div",".widget_categories:has(> div[align=\"center\"] > img[src*=\"/aliban\"])","#sidebar1-wrap > div[align=\"center\"]","a[href*=\"://ali.ski/\"]","div[class^=\"notification-\"][class*=\"module__\"],\ndiv[class^=\"rai_raichu-wrapper__advertWrapper\"],\nspan[class^=\"rai_raichu-advert-timers\"]","a[href^=\"https://1ra.ru\"],\ndiv[data-type=\"anti-abp\"]","iframe[src*=\"://s-platoon.ru/forfon/\"]",".b100Px60,\n.b240x400,\n.b468x120,\n.b880x90,\n.brb,\niframe[data-src*=\"/icontent/\"]","nobr > div > table","#common_div > .top_bb + .bb_table_bg,\n.common_left > [id^=\"rep_\"] > .bl_main,\n.common_right_banners","#offfy-agent-bottom,\nbody > center > h3 + nobr + table[width=\"100%\"],\nbody > center:nth-of-type(1) > table[bgcolor]:not([width]),\nbody > center:nth-of-type(1) > table[width=\"100%\"],\ntable[border][style^=\"border: solid #8e5373\"][style$=\"margin-bottom: 3px;\"]","#LeftBox","center > a[style][href][target=\"_blank\"]","#docAd",".side > #menu ~ .box",".notices_img_ad","#adblock","#lolotop,\n.lolcount","#content > div > div[class^=\"zone_\"],\n.blabel,\n.clearfix.ipsSideBlock > div[class^=\"zone_\"]:not(:last-child)","#nws > .banner,\n.banner > noindex,\n.container > div > object","img[src=\"/images/pek.png\"]","div[class=\"item\"][id^=\"_\"]","body > #feed",":not([class]):has(> div[class] > iframe[src^=\"/\"][src$=\".html\"]),\niframe[src^=\"/\"][src$=\".html\"]","a[href*=\"www.warnax.ru\"]","#activee,\ndiv[id$=\"-ad\"]",".banner-glav-240x400","a[href^=\"http://scask.ru/forex4you.php\"]","div[class^=\"sreda\"]","a[href^=\"http://yashcher.ru\"] > img","div[class^=\"featured\"]","#bigBanner,\n#old_school > .App > br,\n#old_school > .App > div > [color=\"red\"],\n.con_warper > div[class$=\"_block\"],\n.con_wraper ~ div[class] > div:not([class=\"content\"]),\n[role=\"main\"] div[style^=\"position: absolute; top: 0px; \"][style*=\"cursor: pointer\"],\na[href^=\"/o\"][target=\"_blank\"],\ndiv[style] > a[target=\"_blank\"] > img[src^=\"data:\"],\ndiv[style^=\"text-align:center; color:red;\"][style*=\"font-size:16px\"],\nmain > div[class*=\" \"]:nth-child(-1n+2) > div ~ div","div[id^=\"turp_\"]","#wbounce-modal,\n.widget_cb_widget",".banner-post,\n.yandex-zen","a[href^=\"http://vk.cc/\"][target=\"_blank\"]","[class^=\"bnnr_bx_\"]",".lside-player,\n.pgs-player > div[align=\"center\"],\ndiv[class=\"sidebar lside\"] > :not(div)","a[href^=\"http://16r.su/\"]","body > #subscribe-popup","#bannerTop,\n.topFaceGuest",".top_lnk_img",".gensmall > .block_links","#semestr-news","#alert_top_site,\n.panel.text-center,\n.panel[style^=\"height:\"]","div[id][style*=\"width:\"][style*=\"height:\"][style*=\"margin:\"]","#leftbn",".b-adds","a[href*=\"receive-money.biz\"]",".rtp-wrapper,\n.vids",".adv_holder","#dd-flash-area,\n.sp-container","#google_box","#main-content > :not(.content):not(#sidebar),\n.mot,\n.theiaStickySidebar > :not(#text-html-widget-13):not(#text-html-widget-18):not(#text-html-widget-25):not(.posts-list):not(.login-widget):not([class*=\"widget_wpforo_widget_recent_\"]),\ndiv[class^=\"elan\"]","div[class*=\"-banner\"]","#adv_banner,\n#sidebar .toggled:has(> .mob_quad_banner),\n.mob_quad_banner","a[target=\"_blank\"][rel=\"nofollow\"]:not([href*=\"severpost.ru\"]) > img",".rkl3,\n.rkl4,\n.rkl_united","script[src*=\"iwantyourpromo.com\"] ~ div[align=\"center\"]",".header_right","a[href^=\"http://skb-uran.ru\"]",".js-layout__block--banner",".adsdesctop",".aside > .grid > div > img[alt=\"Shazoo @ Yandex.Zen\"],\n.aside > .grid > div > img[alt=\"Shazoo @ Yandex.Zen\"] ~ div,\na[href^=\"https://shazoo.ru/click/\"],\naside > div:has(> iframe[src*=\"://goodgame.ru/html/embed-player/dist/index.html?partner=\"]),\naside > iframe[src] + p[style],\nbody > style + div[class]:not([id]),\ndiv[class^=\"sm\"]:has(> .vk-privacy-mode-banner),\ndiv[class^=\"sm\"]:has(> div > [id^=\"yandex_rtb_\"])",".bgt_top,\n[id^=\"beget\"]",".t3-sidebar > div[class=\"t3-module module  \"]",".b-baner-sho-me-link","#twocol center:has(> div[style] [src=\"//an.yandex.ru/system/context.js\"]),\n.pc-banner,\n.top-yoox,\ntd[id][valign=\"top\"][width=\"300\"] > table.tborder[width=\"100%\"]","#adsenseNiz","#right-rand-1,\n[id*=\"banana\"],\na[href*=\"/?section=519\"]",".b-block--banner",".dzen_widjet,\n[src*=\"sibnet.ru/iframe-wink\"],\nbody > div[id][class*=\"push\"],\ndiv[class*=\"2023\"][class*=\"root\"],\ndiv[id^=\"right_\"][id*=\"_place_wrapper\"],\ndiv[id^=\"sibAd_\"]","#stakanDomostroy,\n.article__banner-link,\n.branding-wrapper > a,\n.content-right-branding,\n.main-header-center > div,\n.main-header-middle > div,\n.stakan-border:not([style]),\n[class*=\"banner__brand\"]","#ya-block,\n.leftcolumns-programm_of_the_week,\n.recommended_soft_alltab_content > #tabWindows > :nth-child(1),\n.softmain_content__newprogram_tabs + .softmain_content__newprogram_content > .softmain_content__newprogram_content_item:first-child,\ndiv[class^=\"programm_block-ad\"]","#vjs-overlayclip-container-box,\n.video__topline","#head-links > a[href*=\"://rt.sibnet.ru\"],\n.header__topline,\n[class^=\"WinkPromo_\"],\ndiv[class^=\"Info_sidebar_\"] a[class^=\"Informer_root_\"],\ndiv[class^=\"Realty_root\"]",".TeraPromo,\n.block-body.block-row:has(.TeraPromo),\n.block-body.block-row:has(.resourseReklverx),\n.notice--primary","div:has(> div[id^=\"M\"][id*=\"Composite\"])",".fixed-block,\n.ozon_link","div[id^=\"game_banner\"]","a[href*=\"myrusakov.ru\"],\ndiv[id^=\"content_text\"] > center:has(a[href*=\"myrusakov.ru\"])","#header_center","a[href^=\"https://citycard.ru/lucky\"]","a[href*=\"/adhunt\"]","p > script[src*=\"wmrfast.com\"] ~ *","a[href^=\"http://vk.com/club61342137\"]","a[href^=\"http://hb-shop.ru\"]","#banners-after-search-form,\n.search-result__list-item[data-offerid],\ndiv[class*=\"uis-popup\"][class*=\"banner\"]",".svg-adblock",".bottom-adv-color,\n.download-box > div:not([class=\"download\"])",".grid-advert-wrap","td[align=\"center\"] > p[align=\"center\"][valign=\"bottom\"] ~ p[align=\"center\"][valign=\"bottom\"]",".bbr__big,\ndiv[style^=\"min-height: 250px;\"][style*=\"font-size: 0;\"]","#alioffer,\n#servisybuttons,\nimg[alt=\"Али распродажа\"]","div[class*=\"region-amm\"]","[data-id^=\"exAd_\"],\ndiv[class]:has(> div > [data-id^=\"adfox-\"]),\ndiv[class]:has(> div > [data-id^=\"exAd_\"])","#pop-up-window","a[href^=\"http://toyota-dynamica.ru/\"]","#fo_Объявления,\n#fo_Партнеры,\n#fo_Пресса","div[class^=\"parthner\"]",".brand-banner",".videoconteiner ~ h4",".dialog-wrapper,\n.header__wrapper--inner a[href^=\"/tariffs?redirect=\"]","iframe[src*=\"adUrl\"]",".inner > .widget_media_image",".aside-p-c-a,\n.p-c-a,\ndiv[class*=\"popup-eventSubscribe\"],\ndiv[class*=\"promotion-click-area\"]",".panel-reklama","span[style=\"cursor: pointer;\"][onclick]:not([onclick*=\"snow-motion.ru\"])","a[href^=\"/component/banners/click/\"]",".b-body-brand-banner,\n.b-body-sidebar__banners,\n.b-head-banner__link,\n.b-post-view__tgb,\narticle > .b-post-view__section:has(> .b-post-view__projects > div > [id^=\"adv220_\"])",".b-links > a[href^=\"/bookmakers/\"] ~ a,\n.block-centering[style*=\"min-width\"][style*=\"min-height\"],\n.match-menu > .ul-wrapp > .main > .noajax,\n.match-tab-content > #match-header + .block,\na[href*=\"/redirect.php?destination\"],\na[href^=\"http\"][href*=\"utm_campai\"],\ndiv[class*=\"block-new-desine-\"][class*=\"-bookmakers\"]","#odds,\n#widget_bk,\n.footer > :not(.footer_bottom),\n.header_top > :not(.header_top_logo),\ndiv[class^=\"page_\"][class$=\"_right\"] div:has(> div[id]:empty ~ script),\ndiv[style^=\"position:\"][style*=\"height:\"][style*=\"90px\"]",".right-sidebar > .block",".banner_block",".top-b-place > .container > .b-place","#promo_bottom","td > noindex",".header-html-1","a[href=\"/golink/https://soft-file.ru/yandeks-brauzer/\"]","#pxsnazzy,\nimg[width=\"180\"][height=\"400\"]",".advertise","center > table[style=\"width:150px;\"]",".clearfix > center:first-child",".title-inst",".grid-ad-box","#addbar + table > tbody > tr > td[style],\n#menu p[align=\"center\"] > b,\na[href^=\"https://inspin.me\"],\na[href^=\"https://rosecatalog.ru\"]",".free-games,\n.sam-slot,\n[data-href*=\"offer_id=\"]",".left_block_bg_container + td td[width=\"340\"]:first-child,\n[class$=\"_block_bg_container\"] td[align=\"center\"] > p > a[target=\"_blank\"]",".special-block-yabrowser","a[href^=\"http://cmd-online.ru/\"],\na[href^=\"http://ido.mgsu.ru/\"],\na[href^=\"http://www.ars-plus.ru/\"],\na[href^=\"http://www.prestij-stroy.ru/\"],\na[href^=\"http://www.promplast.net/\"],\na[href^=\"http://www.smclinic.ru/\"]","#widget_ads,\n.sidebar_list > .widget_text:not(#text-4):not(#text-89),\n.sidebar_list > [id*=\"custom_html\"]",".postbitlegacy[id^=\"yui-gen\"]","body > #top","#rek_blocker",".right_zone > #banner",".yjround_in > br,\n[data-original^=\"http://news.soundex.ru/images/banners/\"],\n[src^=\"http://news.soundex.ru/images/banners/\"]","div:has(> #kb)","a[href^=\"http://kmabiz.org/\"]","#facebook_popup","a[href^=\"http://advert.mirtesen.ru/\"]",".cardForecast_card_container__b_Ukm > div[class^=\"cardForecast_btn\"],\na[href*=\"/bonuses\"],\ndiv[class^=\"button_advertisement\"],\ndiv[class^=\"card-carousel_winline\"],\ndiv[class^=\"main-menu_affiliateItem\"] *,\ndiv[class^=\"main-menu_bonusLogo\"],\ndiv[class^=\"main-menu_other\"],\nimg[alt=\"bookmaker\"]","noindex > a:not([href*=\"spartak.ru/\"])[target=\"_blank\"][rel=\"nofollow\"]",".huge_banner","#headerBanners,\n.index-banner,\n.ipsList_reset > .ipsWidget:has(> div > [id^=\"yandex_rtb\"]),\n.ipsList_reset > .ipsWidget:has(> div > p > a > img[src*=\"/banners/\"]),\n.ipsWidget > div > p > a > img[src*=\"/banners/\"],\n.message-view-ads",".content-teasers,\n.mediacartel",".wrapper > aside","#banners-klik",".a990_90,\n.bnrobject",".adds,\n.live--article","#banners > a,\n#top4banners","div[id][block]","#side_ads_content,\n.placeholder_billboard,\n.vms_article_parent a[href*=\"utm_\"],\n.z-adblock-message,\ndiv[id*=\"_ad_marker_\"],\ndiv[id^=\"desktop_content_side_banner\"],\ndiv[id^=\"desktop_in_\"]",".adv_240x400,\n.bnr-2horizontal,\n.gallery-gusar,\n.top2-banners","#_ad_container_,\n#betPreviewContainerDesc,\n#show-popup,\n#socgroup,\n.ls-social-block__dzen,\n.se-banner,\n.se-bets,\n.se-bn-notice,\n.se-material-page__blog-buttons,\n.se-material-page__footer-aggregator,\n.se-partner-stuffing-info,\n.se-translation-scoreboard-event-bets,\n.se-translation-scoreboard-extra__bookie,\n.specButtons,\n.wichtig[class*=\"hidden\"],\n[class^=\"se-bookie\"],\ndiv[class*=\"right_col_banner\"],\ndiv[class=\"clearfix mb_10\"],\ndiv[data-portal-id=\"brandedButton\"],\ndiv[data-portal-id^=\"banner\"]","a[href*=\"erid=\"][target=\"_blank\"]",".sport__champcom",".article-bottom-block > .hdr2,\n.column-right > div[style=\"margin-top:20px;\"],\n.column-right > h5.hdr2,\n.no-print ~ * hr","a[href*=\"://go.sport24.ru\"],\ndiv.right-scroll-bar-position,\ndiv[aria-expanded=\"false\"]",".spb_cmp_top_banner","div[class^=\"adriver_\"]","a[href=\"/advertising\"]",".sidebar_video:empty,\na[href=\"/bookmakers/\"],\ndiv[data-logger=\"partnerNews\"]",".post-conversion-block",".good__top","a[href^=\"http://activizm.ru/\"],\na[href^=\"http://www.drafty.ru/\"]",".bet-block,\n.js-header-slider-container,\n.statistics__footer","#top-ad,\n#top-banner-place,\n#ya-antiadblock-notification-container,\n.columns__alt-column .frame,\n.comment-ads,\n.comments-list__ad-item,\n.document-recommendations,\n.fonbet-teaser,\n.high-adload-container,\n.in-read-placement,\n.in-read-wrapper,\n.in-read-yadv,\n.js-ad-label,\n.layout__branding,\n.middle-banner-place,\n.nav-list__widget-wrapper .promo-block,\n.navigation-right-column-banner,\n.navigation-top__specials + div:empty, .navigation-top__specials,\n.news-item__content > p > strong > a[rel=\"nofollow\"],\n.one-card[data-img_desktop^=\"https://dumpster.cdn.sports.ru/\"],\n.place-for-ad,\n.poll-variant__coeff,\n.poll__ad-label,\n.poll__bookmaker-link,\n.poll__bookmaker-logo,\n.promo-link,\n.recommendations__list > .recommendations__item:has([href*=\"promo\"]),\n.record-widget__bookmaker,\n.right-first-banner-place + div,\n.rightPart > .mB20,\n.short-news > [data-content-name],\n.short-news > br,\n.short-news > p:has(> .advert_material),\n.social-links__zn,\n.teaser-before-links__adv-label,\n.x5-popup-overlay,\n[class*=\"_label \"],\n[class*=\"parimatch\"],\n[class]:has(> .aside-news-list__advert ~ a[href^=\"https://sprts.cc/\"]),\n[data-content-name=\"banner-dfp\"],\n[data-content-piece=\"adfox\"],\n[data-control*=\"Videonow\"],\n[data-control*=\"adblock\"],\n[data-control=\"Stat.KinopoiskButton\"],\n[data-control=\"Stat.OkkoButton\"],\n[data-control^=\"Aliens.\"],\n[data-control^=\"Banners.\"],\n[data-init2-by-float],\n[data-is-ad-poll] .bookmaker-info,\n[data-refresh],\n[data-refresh] + div,\n[data-type=\"reklama\"],\n[id*=\"ScriptRoot\"],\n[id^=\"dfp-fullscreen-\"],\na#sitewrapper[href][target=\"_blank\"][style*=\"cursor\"],\na[href*=\"click\"][target=\"_blank\"][style^=\"display\"],\na[href=\"https://trbna.co/2u3V2dO\"],\na[href^=\"https://sprts.cc/\"],\nbody > div[class^=\"br-lt\"] > :not(.page-layout):not(.pageLayout),\ndiv[class*=\"SALES\"] > .accordion__handle,\ndiv[class*=\"material-list--additional-block\"] > .material-list__item:has(a[href^=\"https://sprts.cc/\"]),\ndiv[data-control-noinit=\"Common.BetsTabs\"],\ndiv[data-control=\"Common.AutoInit\"],\ndiv[data-control^=\"Common.Bets\"],\nimg[src*=\"s5o.ru/source/_desktop/aliens/\"],\np > a[rel=\"nofollow\"] > img[height][width],\nstyle:first-child ~ [class^=\"gift__\"]",".match-teaser__betting-bar,\n.polling,\n.teaser-bookmaker,\n[class*=\"okko\"]",".poll__footer > .poll-share ~ div,\n[data-noinit]","#KefTable,\n.heading > .heading__logo,\n.schedule__bet-block,\n[class^=\"timetable__bet\"],\na.match-mini__heading-link > .match-mini__logo,\nnoindex > .news__description","div[class*=\"bookmakerOdds\"]","div[id*=\"AdContainer\"]","#container > div[style] > script + style ~ ul",".sponsorslist,\n[class^=\"advt\"]",".adfox_placeholder,\n.calculator-branded-button,\n.subscription-popup,\ndiv[class^=\"article_spec-wrapper_\"],\ndiv[class^=\"special-offers-\"]",".navbar_notice a[href][target=\"_blank\"]",".boardlistInner[style=\"background-image: url(/logo/Standart/TemaLine2.png); background-repeat: repeat-y\"]","#win > .podps","#innertop,\n.britem",".video_adsense,\n.video_adsense:has(#vid_over_float)","aside a[id][href][target=\"_blank\"]",".main_background",".creative",".tgb",".SG-fixed-block",".popup-army","body > div[id^=\"ips_\"]","a[href^=\"http://steelsports.ru/bannerbro\"]","#sideRight > noindex,\n.tad","a[href^=\"http://stock-list.ru/free-forts\"]","#cont_right_240","#vst_mvideo","#preroll_mediaplayer,\n.corner_banner,\na[href*=\"clc.to\"],\ndiv[class^=\"_content\"] > div[class^=\"_video-wrapper\"] ~ [class] [class^=\"_list_\"]:has([href^=\"/to?http\"][href*=\"%2Fgo\"]),\ndiv[id*=\"fakeContentShifter\"],\nli:has(> [href=\"https://zen.yandex.ru/stopgame\"]),\nsection > div[class^=\"_content-wrapper_\"]:has(> div > a[href^=\"/watch\"]) ~ div[class^=\"_content\"] a[href^=\"/to?http\"]","#aside.punktir,\n#top > .top_action,\n.special > a[href][target=\"_blank\"]","#last-ad-link-block,\n.n-main-center-rounded-block[style=\"padding:20px 0\"],\n.n-main-center-rounded-block[style=\"padding:20px 0\"] ~ .n-main-center-rounded-block,\n.n-main-left-banner-delta",".b2bCnt,\n.banerCnt,\na[href^=\"/banclick\"]","#content-sub,\n#content-top,\n#elid_out_one,\n#elid_out_two,\n#footer[class],\n[id][class] > [src*=\"ads.adfox.ru\"] + style + div[id],\n[id][class] > style:first-child + div[id],\na[href*=\"_click?id=\"],\ndiv[class*=\"info\"] > div[class$=\"_title\"],\ndiv[class*=\"info\"] > div[class$=\"_title\"] ~ div[class$=\"_outer\"],\npsplus-footer",".header-banners","noindex > div[class^=\"ad_\"]",".article-description > noindex","[data-partner]",".advert-banner-wrap,\n.preview-item:has(> [id^=\"yandex_rtb\"]),\n.sidebar.blue",".alm-btn-wrap",".mediawayss_adv,\n.sendsay_adv","#notifications_menu + .t1border","#right > .sideblock > :not(#vk_groups):not(.fb-page)",".top_right_side",".blockBottom,\n.blockLeft,\n.blockRight","div[class^=\"styles_inread_\"]",".f-test-search-result-item:has(> div > div .f-test-link-Podrobnee),\n.f-test-search-result-item:has(> div li div:empty:first-child + div:empty),\ndiv:has(> div > div > [class*=\"f-test-vacancy-ad-context-\"]),\ndiv[class*=\"f-test-vacancy-ad-context-\"]",".box:has(> div[data-dlebclicks]),\n.page-content > .row",".marketgid","body > div[id^=\"jBox\"]",".modal-baner + .mask, .modal-baner","div[class*=\"sgpb-popup-\"]",".b-blockquote-partner,\n.b-content__section_partners,\n.b-content__section_teasers,\n.b-content__title[href^=\"http://mediametrics.ru\"],\n.b-content__title_ads:not([href*=\"partners.svpressa.ru\"]),\n.b-top-header__partner,\n[id^=\"adfox_\"],\ndiv[class*=\"adfox_banner\"]","body > .special-message-wrapper",".flatBlock,\niframe[src*=\"videonow.html\"]","td > div[style*=\"#FFAAAA;\"],\ntd[align=\"center\"][valign=\"top\"] > form ~ p > font > a[href]",".ahuelguardd","#header2",".forumline > tbody > tr > td[valign=\"middle\"] > a[href] > img,\ntable[align=\"right\"][valign=\"middle\"] > tbody > tr > td[align=\"left\"] ~ td,\ntable[width=\"95%\"][align=\"center\"] > tbody > tr[align=\"right\"] a[href]:not([href*=\"/sysadmins.ru\"])[target=\"_blank\"] > img","#add_header,\na[href^=\"https://adamantfinance.com/\"]",".bancode,\n.open-table > .pr > .dcb,\na[href*=\"//pulse.mail.ru/\"],\na[href^=\"/index.php?go=Banners\"] > img:not([src=\"/images/info/shema.gif\"]),\ndiv[class^=\"partnews\"]",".taba_rss_wr.rel.fl","#mask",".sbs_p","div[class^=\"b-sponsor-logo\"],\ndiv[class^=\"b-sponsor-logo\"] ~ center","#pagenav_menu ~ center",".col_c_stats > a[href^=\"http://talkwebber.ru/go/?\"],\n.post_block ~ table",".bodyline ~ td[style=\"width: 240px;vertical-align: top;\"],\nbody > div[style=\"width: 960px; margin: 0 auto; height: 300px; position: relative;\"]",".advert-tizer","a[href^=\"http://shop.megafon.ru/\"]","#top_page_box,\ndiv[class*=\"InlineAd\"],\ndiv[class^=\"PartnerMaterial\"],\ndiv[class^=\"ReadTass_wrapper\"]",".adblock_notif",".dog",".gray_block:has(> .block_links)","[alt=\"LoveProd\"]",".megabitus","#text-6","#edd_cart_widget-2 + .widget_text > .widget-title,\n.widget_sslwidget",".article-banner-side,\n.billboard-banner",".myWinGrid,\ndiv[id^=\"_uwndTop\"]",".Agreement",".bottom_rekl,\n.nadav-market",".leftBanner","[data-advadstrackid]",".wrapper-sticky .wpb_content_element","a[rel=\"nofollow\"][href=\"http://obob.tv/\"]",".views-row-banner","div[id^=\"block-banner\"]",".adbPopup,\nimg[src*=\"/images/ads/\"]",".content.main ~ .text-center",".bs-topbanner","#top > .header-top",".sidebar__rek,\na[href*=\"teplocom-m.ru\"]","#modal_form_vk,\n#overlay_vk","a[href*=\".php?ad=\"]","div[id^=\"ad_\"]","#column-left .banner","header ~ section:last-child","div[class^=\"recpost\"]","a[class^=\"base-BuyAdvLink-\"],\ndiv[class*=\"-BannerPlaceholder-\"]",".content > .homepage_widget:has(.adsbygoogle),\n.content ~ #sidebar > .widget:last-child,\n.spacer_400,\ndiv[class]:has(> .js-relap-anchor)",".wogame55,\na[href=\"https://thelastgame.ru/how-to-load/\"],\nimg[alt=\"как качнуть\"]","#bodypopup",".container-rekl-top","#answers div[style*=\"overflow:hidden\"],\n.theq-header__beta__nav__promo,\na[href*=\"t.mail.ru/redir/\"],\ndiv[class*=\"annonser\"]","#mess_box",".leftblinks","#sitilink","[id^=\"bn_\"]","div[class$=\"_branding\"]","img[src^=\"/partners/\"]",".banner__title,\n.header__banner__cont","#bg_popup","#execphp","div[id^=\"kazandrey\"]",".channel-feed > .channel-feed__brick:has(> .cfeed-card > .cfeed-card-contents--banner)","[style*=\"tltgorod.ru/Pics/ban/\"]","a[href=\"http://casinobonus2.co\"],\na[href=\"http://www.ks-p.ru/\"],\nnoindex > marquee","#footer > div > noindex",".adwidget,\n.reviewwidget:has(.adwidget),\n.tmbwrekbelow","#tegA3,\n.reklama_top",".mbottom_wrapper",".block-block [class^=\"cp\"],\n.block-block [id^=\"cp\"]",".b-partners",".right_cell > center","#top-adv-container,\n.topBan.w33.white",".middle-block","#top_b,\n.right > br,\nimg[tooltip=\"РЕКЛАМА\"],\nimg[width=\"300\"][src^=\"/uploads/\"]","#b1_place,\ntd[valign=\"bottom\"][height=\"220px\"][align=\"center\"],\ntd[valign] > a > img[vspace=\"10\"]","#block-block-39,\n.klinks","#kompstar_block",".banner.nocp","#wikihead,\n.NoCurTips,\n.airelle,\n.hotel-form__header,\n.left-menu-pcodes,\n.magnifique-header__partners,\n.proxima,\n.sys-sky,\n.tt-tim,\n.youtube-lm-trailer,\ndiv[class^=\"partner-link\"],\ndiv[data-antares=\"true\"]","body > div[id^=\"fancybox\"]","#content_l_box > .column_wrap > div[style*=\"min-height:\"]","div[id^=\"google_full_story\"]",".ad-info,\n.zverinco,\ndiv[class*=\"zebra\"]","[action^=\"/bclick/\"]",".item.promo","#footer-banner-widget,\n[data-bh]",".flash,\n.imgblock > a[style]",".main__left > .block","noindex > nofollow","a[href*=\"amigo.mail.ru\"]","a[href][target=\"_blank\"] > img","[href=\"/kak-skachat.html\"]",".mg","img.Text[src^=\"/images/\"]","#page_flip,\n.inner-wrap > #header,\n.spec_img[src]",".popularMaterialList > div[id^=\"readmore_\"] ~ [class]:not([id^=\"readmore_\"]),\nbody > #black,\ndiv[class^=\"trstr_adv_\"]",".js_banner,\n.modal-open .adv_modal,\n.modal-open > .modal-backdrop",".tp-layout-default__aside-right-content > div:empty,\narticle.type-post:has([href=\"/adblock\"]),\ndiv[class^=\"tp-\"][class$=\"-top-container\"]",".col-md-2 > .thumbnail",".listform[style^=\"margin-left\"]","#main_content_section > table > tbody > tr > td:nth-of-type(2)","a[href*=\"utm_source=partner\"][target=\"_blank\"] > img","#bttBanner,\n#rightAdvBlock,\n.mddlAdvBlock",".tPechenkiInfoblock",".trash_special,\na[href*=\"://trashbox.ru/r.php?\"],\ndiv[class^=\"div_branding_\"]",".wpInsert",".column-sidebar__ads,\n.gallery-sidead__ad","#block-rsamain,\ndiv[id^=\"block-rtb\"]","#sp-left",".mirtesen-feed","#top-line","a[href*=\"abc-home.ru\"],\na[href^=\"http://vneftegaze.ru/\"]","a[href^=\"https://triskirun.ru/golink/\"]","#grid-top","a[href*=\"://mediametrics.ru/\"],\ndiv[class^=\"post-banner\"]","#dle-content > #aceplayer ~ [class*=\" \"],\n.adb_m",".widget_rss",".ad200x150,\n.ad200x300,\n.ad240x400","img.aligncenter[src*=\"kadastr\"]",".header-adv_space,\n.news_alert-text,\n.part_block,\n[data-href*=\"://zen.yandex.ru/\"],\n[data-href*=\"yandex.\"][data-href*=\"news\"][data-href*=\"favid\"],\na[data-href*=\"//dzen.ru/\"]","#wlyeyyz",".adversing_block","#bottomdies,\n.jq_turoperator_adv_items,\n.turoperator_adv_title","#flash_layer,\n.invideo",".intereso","div[id^=\"vid_over_float\"]","#DBdesktopBillboard",".panel:has(> .panel-body > #marketWidget),\n.panel:has(> .panel-body > [id^=\"yandex_rtb_\"]),\n[id^=\"adv_orders_\"]",".side-block:has(> .side-header + .side-article > .side-article-title > [href=\"\"])",".b-adv-block,\n.b-adv__header,\n.b-overlay-soc,\n.b-overlay__video > .b-overlay__aside,\n:not(.yandex_zen_link) + .yandex_zen_link",".cat,\n.recipe-adv_bottom,\n.sidebar-useful-block,\n.yandex-adv_list",".foot_2,\n.otstup,\n.right_con > :not(.city_paper)","#content > table[cellspacing=\"1\"][cellpadding=\"1\"],\ntable[width=\"280\"][height=\"258\"]",".footer_contact > div > .row > .hidden-xs:nth-child(3),\na[href^=\"https://news.yandex.ru/smi/\"]",".azsbx",".xasdfx",".zen-block,\naside .custom-html-widget > a[rel=\"noopener\"] > img",".kc6a,\n.y_dzen",".new-bgs-o",".banner-center",".header__dzen-link,\n.main > .container:has(> div:empty ~ script),\na[href*=\"cli.co\"]","#sidebars > .widget_search + .widget_text,\n#sidebars > .widget_search + .widget_text + .widget_text ~ .widget_text",".textwidget a[href]:not([href^=\"http://tvoyazhizn50.ru/\"])","#content-wraper > p,\n#sidebar > .left_ad_block","#news_lenta > .hidden-xs:not(.news_item),\n#right_column_banner,\n[data-comment*=\"reklama\"],\na[href^=\"https://kdservis.ru/\"]","pjsdiv[id^=\"oframe\"] > pjsdiv[style*=\"opacity: 0.1;\"]:empty,\npjsdiv[id^=\"oframe\"] [style=\"animation-play-state: running;\"]",".ad_block_inner,\n.read-next","#snippetprice,\nbody > table > tbody > tr:first-child > td:first-child + td[valign=\"top\"][align=\"left\"],\nnoindex > center[style]",".ya-news","a[href^=\"http://macnews.in.ua\"]",".advert-uz-block","a[href*=\"amigo.mail\"][target=\"_blank\"],\na[href*=\"ukit-freelance.com\"][target=\"_blank\"] > img","#wmciframe,\na[href^=\"http://www.anketka.ru\"],\nform[action*=\"wmcasher.ru\"]","a[href^=\"http://evsembu.com/in.htm?wm=\"]","#crazy-content > div:not([id]):not([class])[style^=\"background-color:\"],\n.links,\n.loginza","div[class^=\"mfp-\"]",".bannerline",".category2 > .fa-exchange,\n.category2 > .fa-exchange ~ span,\n.content > span > b,\n.right > .rates,\n.right > div[class=\"block\"]",".top-kitten-container","#topBnr_container","a[href=\"http://www.ddmlab.ru\"][rel=\"nofollow\"][target=\"_blank\"],\nimg[src*=\"/banners_for_umpro/\"]","nav","#aspnetForm > center,\na[href^=\"/redirect.asp\"]","#sidebar > div > a[href][target=\"_blank\"]",".main_news_right_block_advert,\n.wikimart,\ndiv[class^=\"beono-banner\"]","#sidebar-left .all_news ~ *",".padspo",".wrapper-sticky","noindex > div > a[href][target=\"_blank\"]","#Stage,\n.toolbarContent > .toolbarLink","#rt-maintop,\ndiv[id^=\"rt-sidebar-\"] > .rt-block ~ .rt-block",".post > .title,\n.post > noindex",".main-content-padding > div[class]:not([itemprop])","body > .popup-overlay",".news-group__content > .news-group__item:has(> .banner),\ndiv[class^=\"partners-block\"]","#sidebar > .main_shadow:empty,\n.direct_stat,\n.news_yandex_background,\n.promo_feed_side,\n.zen_background,\naside[class*=\"cls_placeholder\"],\ndiv[class*=\"cls_placeholder_ad\"],\ndiv[class^=\"cls_placeholder_\"]","#edge_top",".sidebanner",".entry-content > .twp-article-wrapper ~ a[href][target=\"_blank\"]","a[href*=\"hacknet-service.com\"]","#adv-tizer,\n#bns-c > .photos,\n.bn-w100,\n.promo-left,\na[href^=\"http://reklama.v102.ru/\"]",".sidebar > div[style],\na[href][onclick]",".right > .v_left > .moduletable ~ .moduletable","#out_banner",".col-light-grey:has(> .bottom-banner),\n.main-page-banner-container",".c-popup,\n.job42","img[src*=\"/system/banners/\"]",".promo-trust,\n.tgb-content",".custom_subsite_html,\n.sidebar-tree-list-item--custom-html,\n[class^=\"post-branding-\"],\n[data-analytics*=\"native\"],\n[data-gtm*=\"ponsor\"],\na[class^=\"sber-\"],\nvue[name=\"booster\"]",".banner_home,\na[href=\"http://www.vdclab.ru/\"]",".article-recommendation,\n.article__metrics,\n.article__sticky > div[class^=\"adfox\"]:has(.teaser-commerce),\n.card-banner-priorityclub,\n.card-banner-tgb,\n.the-header__top a[href*=\"?erid=\"],\n.the-loader,\n[class*=\"banner\"]:has(.teaser-commerce)",".widget_multiplead",".widget:has(> .pm-ads-banner)","div[id^=\"reclamads\"],\ndiv[style=\"display: inline-block;\"] a[href]","#dynamic-to-top,\n#element_to_pop_up,\nbody > .b-modal","div[class$=\"_ads\"]",".racy_sidebar","#fixed-adv-block,\n#sportbox_migration_adv_click_link,\n.adv-list > *,\n.vgtrk-a1:has([id^=\"MediaMetricsInject\"]),\n.vgtrk-a1:has([id^=\"adfox_\"]),\n:not(.vgtrk-a1-list_inner) > .vgtrk-a1,\ndiv[id^=\"DIV_SMI_\"]",".newsPartners",".b-anons--banner,\ndiv[class^=\"g-banner\"]",".sb-banner",".inedx-right-banner","img[src*=\"/b-files/\"]",".adv__horizontal","img[alt=\"Ping-Admin.Ru\"]",".box-primary:has(> .box-body[style^=\"min-height:\"]),\ndiv[style=\"height:348px;\"],\ndiv[style=\"margin-bottom:15px;\"],\ndiv[style=\"margin:10px -10px;\"],\ndiv[style=\"width:100%; margin:0 auto;\"]",".two-ad,\n.w_back_shapes,\n[data-click]",".adfshift,\n.dragon_lord,\n.fatad,\n.forge_empires,\n.thisad,\n.vgt_fullscreen,\na[href^=\"https://vgtim.es/\"]",".widget.d-xs-none",".onp-sl-overlap-background,\n.onp-sl-overlap-locker-box","#VegasHeadAds,\n#sidebar div[id*=\"rotator_\"]","body > #usac",".fbln","#kupitraff","div[class^=\"down-page\"]:has(> .file-active) > .timer,\ndiv[class^=\"down-page\"][style=\"display: block; width: 100%; height: auto; text-align: center;\"]","#logoslide,\n[id$=\"-banner\"]","body > div[id][class] > .header > div > div:not([class^=\"header\"]) > *,\nbody > div[id][class] > .header ~ div[class] > ul > li[class]:not(.ttyyuu)",".vHeight300","#main-top,\na[href=\"http://ros-yarn.ru/\"],\na[href^=\"http://silkindian.ru/\"]",".p-news",".bannerbg","div[class^=\"AdBlockAlert_root\"]",".static-banners","div[class^=\"banners\"]","article > div[style^=\"min-height:\"],\naside > .text-center","[data-newsb]","#onair > img[data-src=\"/img/player_cover.svg\"],\n.onair_wrapper > [name=\"btn_air_close\"],\na[href^=\"https://news.yandex.ru/index.html?from=rubric\"]","td[width=\"26%\"] td#articles_w",".adaptive_banners,\n.background_url,\n.readall > p:first-child,\n.readyandex,\n.special_branding",".yan-zen","div[id^=\"ruk_\"]","div[id^=\"svecha_\"]",".sideboxrek","#ads-full,\n#rdp-we-adswiki","a[target=\"_blank\"][href^=\"http://li.ru/go?\"],\ndiv[id^=\"rekl\"],\nimg.b",".isShow.popup",".content-box-r > div[style^=\"width:240px\"],\n.content-box-r > table[width=\"240\"],\n.header-vt-bn","body > div[class]:last-of-type",".vp-bonus,\n[src*=\"/banners/\"]","#sadetsbouter",".adb-block","div[style$=\"width:240px; height:400px\"],\ndiv[style^=\"width:100%; height:280px; padding:\"]",".loader,\n.wrap-adplace-frame,\n[data-adplace-inited]","div[data-qa=\"PromoSlider\"]","#aside > noindex","a[href^=\"http://\"]:not(.postlink) > img",".centercol > center",".widget_custom_html ~ .widget_text","div[class*=\"venus\"]","#fullscreen,\n.ads_list",".a-overlay",".ab,\n.bunners-wrapper-line,\n.target-top,\n.tb,\n.top-line-bun",".company-materials","a[href^=\"https://vuzopedia.ru/adv/\"]","[class*=\"ad_banner\"],\na[href*=\"/games/\"]",".partner-in-sidebar,\ntable[width=\"672\"][height=\"300\"]",".fly","body > div > div[style*=\"overflow\"],\niframe[src*=\"clientscript/a_\"],\niframe[style=\"width: 100%; height: 60px;\"],\niframe[style=\"width:100%; height:110px;\"]",".article__block_productSet,\n.bnrBlock,\n.hbTop__wrapper,\ndiv:has(> [data-block-after=\"productSet\"])",".unicorn","a[href^=\"http://nibis.ru/\"]",".sidebar-blocks-block[style=\"height: 1700px;\"]","body > div[class] > p","#scrollable,\ndiv[id^=\"diana_\"]",".bannerheader_header,\n.nav_we > a:not([href^=\"http://webmasters.ru/\"]):not([href^=\"/\"]):not([href^=\".\"]),\na[href^=\"vB.Sponsors/link.php?f=\"]",".reklandvipinfo","#wrap > #page-header ~ div[class=\"forabg\"]:nth-child(-1n+5)",".grey","a[href^=\"http://flagman.kiev.ua/\"]",".yand","#adfoxPromoBanner","#movie-right noindex > center",".novelty-aside__i_ad","#win","#p-sidebar-extlinks",".footer__banner","#shadow_vk,\n#vk_wiget_popup","div[id^=\"newsteaser_\"]",".box:has(> div > .adsbygoogle)","a[href=\"/shorturl\"]","#banner_registrator,\n.targetHolder,\naside > .block-search + .block-search + .block-search","#amgo,\n.bloc_native_games",".full-news-head > .full-news-top ~ *,\n.full-news-stb-content a[href]:not([href^=\"https://wintorrents.ru/engine/download.php?\"]),\na[href*=\".wintorrents.ru\"]","#script_block",".side-bar > div[style=\"margin-bottom: 10px;\"]","a[href^=\"index.php?cf=html-tbanner&bid=\"]","#outside-col,\n[data-name*=\"Banner\"]","#googlerekl,\n.js-relap__item-inner > a[href*=\"https://relap.io/r?\"] ~ *,\nbody > #dark_popup,\nbody > #dialog-fb","table[style*=\"2px dashed;\"]",".sidebar > :not(.card),\n.yasubscribe","a[href*=\"/ad/www/delivery/ck.php\"]","#content > div[style*=\"min-height:\"]","#site5top2,\n#site5top3","a[href^=\"http://www.world-art.ru/ad_\"],\ncenter > table[width=\"1000\"][height=\"250\"]",".left noindex","div[class^=\"ww-cont-\"][class$=\"ban\"]","tr > td[width=\"728\"]","a[href][target=\"_blank\"] > img[alt*=\"тариф\"]","a[href^=\"/play-\"] > img","#popup-1","a[href=\"http://nsb-money.ru\"]","#topbox","div[class=\"side-blok\"]",".ins_art_native,\ndiv[style*=\"min-height: 200px;\"]","div[id^=\"arevicofancy-\"]","#post_ads","a[href*=\"/go.php?id=\"]","a[href^=\"http://x-kuzov.ru/\"][target=\"_blank\"]","body > iframe",".xakep-ads",".mylink","a[href=\"//xbts.ru/\"] + a[target=\"_blank\"]",".mdwr","a[href*=\"megaindex.com\"][target=\"_blank\"]","body > center > a[href] > img[alt]","#full-smile,\n.content5 > .rad5,\n.right-block,\n.speedbar ~ .rad5",".topsbox","p > .ContentTitle[style=\"height: 20px;\"],\np > .ContentTitle[style=\"height: 20px;\"] + .ContentText,\np:has(> .ContentTitle[style=\"height: 20px;\"])",".DirectStripe,\n.i-mini-bem[class*=\"banner\"],\n.i-mini-bem[style],\n.market-feed,\n[id*=\"feed\"][id*=\"_\"]",".FSGalleryLayout > .GalleryGuadeloupe,\n.OffersSearchPage__adCut,\ndiv[class$=\"__ads\"],\ndiv[class*=\"AdContainer\"],\ndiv[class*=\"__bottom-ad\"],\ndiv[class^=\"OfferCard__stickyAd\"],\nli[class*=\"__list-item_type_ad\"],\nli[class*=\"__list-item_type_promo\"]","#topBan,\n.banBox,\n.home-list","#newsflash","div[id^=\"plusplus_mw\"]",".content_right_avvd",".goods-blockh,\n.rekwrap",".rca_des","div:has(> [id^=\"adfox_\"])","aside[class^=\"articlePartnerNews_\"]",".catalogElAd",".content_f > div > center",".layout__left_sticky > div[class$=\"-wrapper\"]:has(> .related-root.typo:empty),\n.related-root.typo:empty",".advert-sticks,\n.custom-block > .ext-embed,\n.org.i-bem.org_js_inited > div[style^=\"border-bottom\"],\n.org__sidebar > .org__links + div[style^=\"margin-top\"],\n.pharmacy-page-view__top-banner,\n.stack > .aab-adv,\n.stack > .promo,\n.turbo-advert,\ndiv[class$=\"ear_js_inited\"] > a[href^=\"//awaps.yandex.ru\"],\ndiv[id][data-log-node] > div:empty ~ i > [class] > .loader__dots,\ndiv[id][data-log-node] > div:empty ~ i > [class] > .loader__text,\ndiv[id^=\"R-I-\"],\nymaps > div[class^=\"search-placemark-layout-connect_advert\"],\nymaps > div[class^=\"search-placemark-layout-connect_special\"]","div.root[id]:empty",".WebBanner",".no-compress > a[href*=\"yap.ru/go/\"]","[class*=\"revenue-block\"]","#table1,\n[href*=\"/goto.php?id=\"][target=\"_blank\"] > img[src^=\"http://yarportal.ru/\"],\ntd.desc","[style$=\"height: 60px;\"]","div[id^=\"bbq_widget_\"]","span[style=\"font-size:14px;\"],\nspan[style=\"font-size:14px;\"] + *","#td-outer-wrap > div[style^=\"display:block;height:\"]",".d-advs,\n.d-banners,\n.n-ad-silver,\n.n-banner--adblocked,\n.n-most-banner-wrapper,\n.static-adv,\nbody > div[style*=\"height:\"][style*=\"180px\"],\ndiv[class^=\"y-ad\"]","#dle-content > div[style=\"margin-top:7px;\"]:has(.newstitle > a[href*=\"/reklama.\"]),\n#jok-banner-affix","#s-diamond-most,\n.s-slider","[onclick]:not([onclick^=\"window.open('https://youhack.ru/posts/\"])","div[data-test-component=\"ProductOrAdCard\"] > span[data-debug-info]","center > font > div[style*=\"#FFCC66;\"]","#yp-fullscreen[data-statclick-action*=\"banner\"],\n.sticky-banner,\n.text-banner,\ndiv[class^=\"yp-tgb-\"]","a[href^=\"http://1000-k.ru/\"]",".g-dyn","div[class][data-aid]",".sticky > .aside__reload","div[class^=\"yarpp\"]","div[class^=\"dle_b_app\"]",".stl_d3 [class^=\"stl_\"], .stl_d3 [class^=\"stl_\"] + br",".zab-news > article.zab-news__item ~ div:not(.zab-news__item)",".partner-iframe,\ndiv[id^=\"taboola\"]","a[href=\"/ali.php\"]",".blogtbg",".randomtable","td[class^=\"alt\"][align=\"left\"] [style=\"float:right\"]","#custom_html-2,\n#text-12,\nli[id^=\"menu-item-\"] > a[href^=\"http\"]:not([href*=\"kali.org.ru/\"]):not([href*=\"zalinux.ru/\"])","#text-10",".moduletabletimer-buf,\n.rstboxes",".partners-block > a[href][target=\"_blank\"]","#ecl-notice,\n#text-21","#gkBanner1","#head-banner,\ndiv[id^=\"reklama-box\"]",".contextblock","div[style=\"background: darkorange; padding: 10px;\"]","noindex > table[width=\"100%\"][cellpadding=\"1\"],\nnoindex td[width=\"40%\"] > noindex,\ntd[width=\"99%\"] + td:last-child","#online-bookmakers","div[class*=\"Banners\"]","body > div:not([id]):not([class])","div[id^=\"smartrotator_ad\"]",".health_wrapper > .links,\na[href^=\"http://mo-zdorovie.tomsk.ru\"]",".blockLinks",".footbox > .rcol > noindex","table[style=\"table-layout:fixed; border-collapse:collapse\"]","a[href^=\"http://mine-minerals.com/\"]","#download ~ table[width=\"100%\"][align=\"center\"],\n#mainbg,\n.ushki2,\n[data-role=\"sidebarAd\"],\ndiv[id$=\"_AD2\"],\ndiv[id*=\"ADNEWS\"],\ndiv[id*=\"_adforum\"],\ndiv[id^=\"advb-\"],\ntd.transparent > table > tbody > tr[align=\"left\"]","a.branding",".ipsResponsive_block[style=\"background-color: #ffffff;height:94px;\"],\n[src*=\"trk.mail.ru/\"],\np:has(> [src*=\"trk.mail.ru/\"]) + p[style]",".randshop > a:not([href^=\"https://forum.zoneofgames.ru/\"]),\n.stickBanner,\n.videoBanner,\ndiv[class*=\"dver\"]","#clone[style*=\"250px\"]",".box-banner,\n.contents > .box-padding","td[width=\"250\"] > a[href][target=\"_blank\"] > img[src*=\"gif\"]","body > .jumbotron",".yjsquare.zpravda,\ndiv[class^=\"flexbannergroup\"]","[data-slot-name],\ndiv[class^=\"styled__GalleryBannerRight\"],\ndiv[class^=\"styled__Suspendable\"]:has([data-relap-id])",".in_othersmi,\n.outer-banner","#sidebar > li:first-child,\n.posts > [id^=\"post_\"]:has(> .postdetails > .userinfo > [title*=\"Advertiser\"]),\n.yui-sidebar > [id^=\"widgetlist_column\"] > li:nth-child(-1n+2),\ndiv[style=\"background-color: yellow; border-width: 2px; border-style: dashed; border-color: red;\"]","#ctl00_TopPanel_LangPanel > .top","div[class*=\"grundik\"]","#sidebar1-wrap > .tCenter ~ .sb_back ~ .sb_back + .sb_bottom ~ *,\n[id^=\"noty_bottom\"][id$=\"layout_container\"]","a[style*=\"/imgs/a/\"]",".mfp-hide",".col-right > .side-box > a[href^=\"http:\"][target=\"_blank\"]","#torrents ~ center","center > table","a[href*=\"//goo.su/\"]",".similar.a[style]",".widget:not([class$=\"hidden-xs\"])","a[href] > img[src*=\"img/yandex\"]","#banner_left_arsenal","a[href^=\"http://kredit.social/\"]",".pmovie__player-controls > .tabs-block__select > a[target=\"_blank\"]",".sidebar-wrapper div[style=\"text-align:center;\"] > a[target=\"_blank\"]","div[id^=\"slice-\"]",".bg-websdr:has(> .card-body > div > [id] > div[id^=\"yandex_rtb\"]),\n.row[style=\"display: block;\"]:has(iframe)",".hidden-xs.alert-warning","#share-popup,\n.top_row",".modal-backdrop","iframe[src*=\"/upload/banner\"]","[src*=\"promo_res\"]","#subscribe_book_happy","#after_ask_helpful,\n.ads_desktop","[poster^=\"http://static.apteki.su/img/banners/\"]","div[class^=\"large-mk\"]","div[class*=\"grid-user-data\"]:has(> [class*=\"user-data-grid\"] > :empty)","#ad_global_above_footer,\n#adsense_firstpost,\ntd[align=\"center\"] > div[style^=\"position: absolute;\"][style*=\"width:200%;\"]","div[id][align=\"center\"]",".ad_sponsor_banner,\n.ad_sponsor_banner_forum,\ndiv[class$=\"-bannerContent\"],\ndiv[class=\"\"][style=\"\"] > noindex","div[class^=\"banner_header\"]",".module-full #banner,\n.module-full:has(#banner)","a[href^=\"http://epnclick.ru/\"]","#wpfront-notification-bar-spacer","body > div[id][class][style*=\"background\"][style*=\"visible\"]",".ckf-box","div:has(> div[id^=\"js-hb-\"]),\ndiv[id^=\"js-hb-\"]","table[width=\"100%\"][style=\"z-index:5;\"]","[cellspacing=\"2\"] > tbody > tr > td[bgcolor=\"#ffffff\"][align=\"center\"],\na[href=\"http://presentazii.ru/\"]","a[href][target=\"_blank\"] > img[alt^=\"Видеоблог\"]","body > span","#open_new_site,\na[href*=\"perfectslotspro.com\"]",".promo-wrapper","#dle-content > a[href],\na[href^=\"//qps.ru/\"]",".ads_mark,\n.leftSideAdLink,\n.up_b","[class*=\"commerc_panel\"]",".container-bbbs",".rekl_ad",".article-free,\n.brand-shifter,\n.popular-block,\n.post-list__card:has(> .popular-block),\n[href*=\"apygame.com/click\"]","tbody > tr[style=\"background-color: black\"]",".ad4",".newton-ad","aside[data-alias^=\"Слева \"]","#block-warning",".column.last.mini > p",".right_side","div[class*=\"teasers\"]",".ut-contentroll,\nbody > #a",".rtecenter > a[href][target=\"_blank\"]","#dom_adblock",".bannersList,\na[href=\"/advertisement\"]","[class*=\"sam\"][class*=\"pro\"]",".queen_link",".luckTitle",".insta_rek","div[class^=\"market\"]","td[valign=\"top\"] > center > .link1","#bg_img","img[src*=\"/banner/\"]","a[href*=\"/betinfo/\"],\niframe[src*=\"livetvcdn.net/html/\"],\ntd[height^=\"9\"][bgcolor]","#a_center,\n#modal-overlay,\n#modal-window","a[href^=\"/engine/\"],\ndiv[id^=\"formula\"],\ndiv[id^=\"parimatch\"],\ndiv[id^=\"somon\"]","#banners-top","#branding-html",".comment-area .newsbox-outer-banner,\n.topbanners,\n[class$=\"bsnack\"]","#sliderbar,\n.knopka","#dfp_fullscreen_block,\n.related-video-holde-right > .table,\n.spot1",".widget-content > a > img[width=\"200\"]","#unblocker","article ~ article:has(> [class] > div:only-child > img:first-child),\nbody > #ipbwrapper > script + div > table > tbody > tr > td[width] + td,\nbody > div[id^=\"r\"] > div[id^=\"r\"][href],\nbody[itemscope] [id]:first-child > style ~ a[href][target=\"_blank\"],\nhtml[style] > body[style=\";background-color:#E6E7E9!important\"] .advanced-area .post[itemid] ~ .post:not([itemid]):nth-child(-1n+3),\nhtml[style] > body[style=\";background-color:#E6E7E9!important\"] .article > div[style^=\"background-color:\"]:has(> span + a[id][href][target=\"_blank\"]),\nhtml[style] > body[style=\";background-color:#E6E7E9!important\"] [id][class] > .slider-list:nth-child(-1n+5) + div[class],\nhtml[style] > body[style=\";background-color:#E6E7E9!important\"] [id][class] > .slider-list[style] ~ div[class]:not([id]):has(> :only-child:not(div):not([id]):not([class])),\nhtml[style] > body[style=\";background-color:#E6E7E9!important\"] [id][class] > div:has(> h2 ~ script),\nhtml[style] > body[style=\";background-color:#E6E7E9!important\"] [id][class] > div[id^=\"devdbc_all_\"] ~ div[class]:has(> :only-child:not(div):not([id]):not([class])),\nhtml[style] > body[style=\";background-color:#E6E7E9!important\"] [id][class][style^=\"overflow: hidden; height:\"] > div[class]:first-child,\nhtml[style] > body[style=\";background-color:#E6E7E9!important\"] [id][class][style^=\"overflow: hidden; height:\"] > div[style*=\"display: block;\"],\nhtml[style] > body[style=\";background-color:#E6E7E9!important\"] [itemprop=\"articleBody\"] > div[style^=\"background-color:\"]:has(> span + a[id][href][target=\"_blank\"]),\nhtml[style] > body[style=\";background-color:#E6E7E9!important\"] article ~ article:nth-child(3),\nhtml[style] > body[style=\";background-color:#E6E7E9!important\"] article:not([id]):not([itemid]):first-child + article,\nhtml[style] > body[style=\"background-color: rgb(230, 231, 233) !important;\"] .advanced-area .post[itemid] ~ .post:not([itemid]):nth-child(-1n+3),\nhtml[style] > body[style=\"background-color: rgb(230, 231, 233) !important;\"] [id][class] > .slider-list:nth-child(-1n+5) + div[class],\nhtml[style] > body[style=\"background-color: rgb(230, 231, 233) !important;\"] [id][class] > .slider-list[style] ~ div[class]:not([id]):has(> :only-child:not(div):not([id]):not([class])),\nhtml[style] > body[style=\"background-color: rgb(230, 231, 233) !important;\"] [id][class] > div:has(> h2 ~ script),\nhtml[style] > body[style=\"background-color: rgb(230, 231, 233) !important;\"] [id][class] > div[id^=\"devdbc_all_\"] ~ div[class]:has(> :only-child:not(div):not([id]):not([class])),\nhtml[style] > body[style=\"background-color: rgb(230, 231, 233) !important;\"] [id][class][style^=\"overflow: hidden; height:\"] > div[class]:first-child,\nhtml[style] > body[style=\"background-color: rgb(230, 231, 233) !important;\"] [id][class][style^=\"overflow: hidden; height:\"] > div[style*=\"display: block;\"],\nhtml[style] > body[style=\"background-color: rgb(230, 231, 233) !important;\"] article ~ article:nth-child(3),\nhtml[style] > body[style=\"background-color: rgb(230, 231, 233) !important;\"] article:not([id]):not([itemid]):first-child + article,\niframe[src*=\"utm_campaign\"],\ntbody > tr[valign=\"top\"] > td[width*=\"%\"] + td > a[href][target=\"_blank\"] > img","#playerBg","div[id][style*=\"position: fixed;\"][style*=\"z-index\"]",".widget_exchange_rates_widget",".popup_module_container","div[class*=\"course-widget\"]","div[class^=\"max-\"]","div[class^=\"mix-news\"]","a[href*=\".li\"],\np:has(> strong a[href*=\".li\"])",".t-aside-banners,\n.t-banner","#news_partner > .relap-default__block-title,\n.admix,\n.left_mob > .title",".bg-gray","div[id^=\"widget_wrapper_\"]:has(#vid_vpaut_div),\ndiv[id^=\"widget_wrapper_\"]:has(.widget_video_ads)",".lista > center a[rel=\"nofollow\"][href][target=\"_blank\"],\nbody > div[style^=\"width:\"][style*=\"1265px\"]",".tm-top","#sidebar > :not(.sb-watched)","a[href*=\"su0.ru\"]",".banners-ads,\n.sidebar--right > .block_full:has(.banners-ads)",".banner-inner","[id*=\"wmg-\"]","#radiorek",".menu > li > a[href^=\"https://vk.com/\"],\n.pageBranding,\ndiv[class^=\"rklmd_\"]",".content-middle > .leading-publishers:first-child,\ndiv[class]:has(> .content-b noindex)","#header[style] #header:not([style])",".baner noindex,\n.reclam",".topserial > a[href],\ndiv[style=\"padding-bottom:15px;margin-bottom:15px;border-bottom:1px solid #dfdfdf;\"]",".h-top-pad","object",".social-annoyer",".video_right_block","#rrrFooter,\n#rrrHeader,\n#rrrToper",".ad_subcontent",".articleContent > .recomendation_list + h2.block-title,\n[id*=\"ScriptRoot\"]:not(.news-block-magick)",".b_reklama","div[id^=\"meta_news_block\"]","a[href*=\"://fast-torrent.tv/gomed.php\"]","#rek-right-column","#partner_title","div[class^=\"banner_sape\"]","img[width=\"484\"][height=\"62\"]",".adversting-block-1 > .col-no-padding,\n.document-advertising",".header-bottom-second","div[class^=\"hind\"]","div[class*=\"sidebar\"]","#this-pays-for-bandwidth-container-hor,\n.BetterJsPopOverlay","body > .playerlive",".article__footer_adv,\n.article_idealmedia","blink",".aside-block:has(div[class^=\"adfinity_block_\"]),\ntable[height=\"300\"]:has(div[class^=\"adfinity_block_\"])",".tn-player-tsr",".banner_long,\n.banner_small","[src*=\"/uploads/banners/\"]",".w-full > a[href^=\"/channel/\"] ~ div:has(> div > [id^=\"yandex_rtb\"])","div[class^=\"alarm\"]",".rk1, .rk2, .rk3, .rk4, .rk5","a[href^=\"http://shop.ast.ru\"]",".framework__subscription",".index-module__wrapper--XM_aB",".left_panel_shop","#rightbar > .block:first-child + .block,\nbody > [class]:empty,\nbody > [target=\"_blank\"],\nbody > p",".post_wrap > span[id] > a[href]:not([href*=\"imdb\"]):not([href*=\"tv.com\"])[class=\"postLink\"][target=\"_blank\"]:last-of-type,\na[href*=\"://cutter.li\"],\na[href^=\"http://ru.avxcore.com\"],\na[href^=\"http://seedbox.org.ua/\"],\nbody > #wrap > div[style]:not([id]):not([class])",".foot-partners",".wrapper > #header > a[href][target=\"_blank\"] > img","div[class^=\"l-banners\"]","body > div[style^=\"padding:\"] > a[href]",".jconfirm","#player-mobile-select > .buttons-container","#prompt-form-container-phone,\n.moanerwrap","div[style*=\"/partner-news\"]","a[href^=\"/go.php?id=\"]",".span4:has(.thumbnail > a[href*=\"/asd/\"]),\na[href*=\"/asd/\"]",".center_col > .layout","main > .hidden",".adfox-wrapper,\n.d-flex [class^=\"partners\"],\n.d-flex:has(> div > [class^=\"partners\"]),\n.promo-slider__wrapper,\na[class*=\" ya_\"],\ndiv[class*=\"InformationBlock_\"],\ndiv[class*=\"dzenFoxButtonsContainer\"] > div[class^=\"root\"]","#rek,\nobject[name=\"videoblock\"]",".main-body > .box-admin ~ .box-admin",".container > .info","#rec_vert_right","a[href*=\"/promo/out/banner/\"]","body[onclick^=\"closeMyAd\"] > div[id][style*=\"position\"][style*=\"background-color\"]",".player > .reklama_b,\n.right_bar > .reklama_b",".maintable td#right",".block_rekno + iframe",".advrigth,\naside > .banner + .title","#bannerXbet,\n.dont-add-our-site-pls","#rk-content,\n.fmessage,\na[href*=\"softboxmarket.com\"]","body > div[style*=\"1240px\"]",".rs-promo",".article__dpen,\n.aside__fly,\n.back-fixed,\n.header__btn-small,\n.js-clickcount,\n.sticky-bottom,\n[onclick*=\"dzen.ru\"]",".ukrnetlinks,\ndiv[id^=\"bannplace\"]",".ubo-overlay > .player-ad-notice",".rkl-box",".hokblokrights,\nbody > .head",".border-top:has(> [id*=\"ScriptRoot\"]),\n.pip-video-wrapper","div[id^=\"div-gpt-ad-\"]","a[href*=\"/advert/\"]",".hide_640,\n.sidebar > :not([class]),\n.video-block-styled,\na[href*=\"kion.\"],\na[onclick*=\"//ads.adfox.ru/\"],\ndiv > center:has(> [href^=\"https://zen.yandex.ru/\"]),\ndiv[class^=\"block-\"][class*=\"0\"]","#jwplayer-container > #container-player[style*=\"width:100%\"][style*=\"cursor:pointer\"]","wasd-banner,\nwasd-player-overlay-banner","#center > div[style^=\"height: 250px\"]",".elementor-widget-video","#catalog > a[href^=\"/anime/promo\"],\n#sidebar .section[style^=\"padding-top:\"],\nnoindex > .section",".fp-brand,\n.primary > noindex","#ra9e",".b-obozrevatel-top",".right-inner > .right-social ~ .right-social,\n[class^=\"spec-block-\"]",".aside__banner-container,\n.news-partners-add,\n.playlist__banner-wrapper",".news-item:has(.ads)",".jcarousel-wrapper:not([id]),\n.last_articles","#branding_wrap,\n#promoArticle,\n.inner-wrap > .nav-additional,\n.reklama-block,\n.video-dv-wrapper,\napp-adv-skeleton,\napp-desktop-top-banner,\napp-main-page-adv-block,\napp-video-adv-block,\ndiv[style^=\"min-height: 250px;\"][style*=\" 50px\"]",".article-text > .insert:has(a[rel*=\"sponsored\"])",".ipblockmap > div > .ip ~ .ip + div,\n.menu_banner,\n.module_adsense,\na[href*=\"hidemy.name\"]",".article-partners-news",".sb-block:has([id*=\"ScriptRoot\"])",".fixedBanner,\n.fixedBlock,\na[href^=\"/\"][target=\"_blank\"]",".poster-modal","#prjctrHightlights,\n.tag-brand-link",".advertinline","a[href=\"http://www.akvariumi.com.ua/\"]",".topBorder > noindex a[href^=\"http\"]:not([href*=\"otipb.at.ua\"]) > img","body > p + p > a[href] > img",".content-rules > p:has([href^=\"https://autoshini.com/shop/\"]),\n.sidebar_upper",".da-iframe",".fixedBrand",".main__row > .tns-outer,\n.main__row > .tns-outer + .controls",".article_sidebar > div[class=\"textwidget\"],\nspan[onclick^=\"window.open\"][style*=\"cursor:\"]",".sb-partners",".sidebar > a",".adBl,\n.prmtn,\n[class*=\"promotion\"]","div[style^=\"width:\"][style*=\"240px;\"][style*=\"height:\"]",".franshiz",".main_header > .full_width a[target=\"_blank\"] > img,\n.sidebar_list_item a[href][target=\"_blank\"] > img",".islands--recommended,\n.parner--news,\n.parner--side-news","a[href$=\".htm\"]",".hamburger__overlay.no-close",".wp_image_wrap",".img-responsive[src$=\".gif\"],\na[href] > .img-responsive,\nimg[src*=\"/img/andora\"]",".news > li > noindex,\n[src*=\"gorod.cn.ua/image/upload/\"],\ndiv[class$=\"_pos\"],\ndiv[class^=\"branding_\"],\ndiv[class^=\"pos\"][class*=\"_\"]",".sModuleContent,\n.topAdv","[data-widget_type=\"image.default\"]",".friks-row,\nimg[src*=\"/image/banners/\"]",".theiaStickySidebar > .text-html:has(> div > iframe[src=\"about:blank\"])",".under-menu-area",".dle_b_big_header,\ndiv[class^=\"dle_b_righttop_\"] > div[align=\"center\"]",".adsence-wrapper,\ndiv[id^=\"user-to-register\"]",".adcontainer","#sp-right .custom > p > a > img,\nsection[id^=\"sp-subcribe-footer\"]:not(#sp-subcribe-footer)",".live__wallper",".fullwidthabanner",".mod_ijoomlazone,\na[href*=\"srsltid\"] > img,\nheader .size-75",".banner-promotions-wrapper","img[src*=\"/assets/img/ads/\"]",".post__bottom-banner,\n.post__partners-news,\n.reveal-overlay",".newscomp",".news-section_items > li.link > a[target=\"_blank\"] > img",".adace-slideup-slot-wrap",".banner-block > :not(noindex)","#modal-cpa",".eb-inst,\n.mod-custom","body > div[style^=\"position:fixed;\"][style*=\"z-index\"][style*=\"background\"],\nbody > style + div,\ndiv[class] > a[href][rel=\"nofollow\"] > p",".bloc__r","#kinotvukrnet",".sidebar-container > a[rel=\"nofollow\"] > img",".details > a[href=\"http://gamelion.net/\"]","#IUAfinanceBlock",".right-col > .mob1","#internetuacom",".post .g-single,\n.postmeta-primary ~ .hr1[style=\"border-bottom-color:#eee\"]",".area-after-nav,\n.single-widgets > p[style=\"font-size:1.25rem\"]",".widget-type-banners",".header > .sticky-top,\ndiv[id^=\"block-reklama\"]",".socials-popup",".nts-ad",".rpad script[src*=\"orbit.lun.ua\"] + span",".tfblock","a[href^=\"http://ua.hit.gemius.pl/hitredir/id=\"]","div[class^=\"advtext_\"]",".news_divide-banner,\n.right_column_content > [href][target=\"_blank\"],\n.unit_header-banner","img[src=\"/filmi.jpg\"]","aside > div[style] > a[href^=\"http\"]:not([href*=\"finbalance.com.ua\"])",".coolbanner,\n.sales-box",".content-inner > noindex","div[id^=\"afc_\"]","#fader,\n#likesplash,\n.mcontent.read > span[class]",".video-row,\na[href*=\"monobank.ua/\"]",".r_sell",".clr[style],\n.infolinks,\ntable[width=\"580\"][height=\"90\"]",".widget_custom_html:has([data-wpel-link=\"external\"]),\n.widget_custom_html:has(a[href*=\"utm_campai\"]),\na[data-wpel-link=\"external\"][target][rel*=\"nofollow\"] > img","#header-rek,\nbody > div[id][style*=\"background\"][style*=\"visible\"]",".leftbar a[href][target=\"_blank\"] > img[src*=\"/image/banner/\"]",".adv_block_txt,\n.brand_left,\n.brand_right",".ads-place",".hygge-layout-sidebar","#left a[rel=\"dofollow\"],\n#stretch > video,\n.ban_h","#reply-title","#right > div[style^=\"height:\"],\nbody > table > tbody > tr > td[style^=\"height:112px;\"],\ntd.left[width=\"200\"][valign=\"top\"][style=\"height: 320px;\"] > br",".banner_modal",".newcatside-left","iframe[src*=\"joblog.com.ua/xmg.\"]","#leftban,\n.absk,\na[href^=\"/informer/main.html#reklama\"]",".branding-bg-link",".banner-target",".content > p[style^=\"font-size: 1.3em\"] > strong > a[href],\n.layout_right_column > p,\ntd.left-column,\ntd.right-column",".question:has(> .adsbygoogle),\n.sidebar > .widget:has(> .adsbygoogle)","#catfishWrap,\n#kurs_pixel,\n.currencycom,\n[aria-live] > tr:has(> .currencycom),\naside .advertising",".post-block","div[class*=\"section-smartslider\"]",".copyright",".side_block:has(> .adsbygoogle)",".entry-aside a[target=\"_blank\"] > img,\ntable[id^=\"post-\"] + div[style]","[href*=\"local.com.ua/banner\"]","#sidebar-right > .widget_custom_html:nth-child(-1n+2),\n#sidebar-right > .widget_custom_html:nth-child(-1n+3) ~ .widget_custom_html","#related","img[src*=\"/static/banners/\"]",".section-rss","#aside-teaser,\n#container-deposit,\n#sticky-wrapper > .js-ad-aside,\n.advertising-caption,\n.all-news > .items > .item:has(> div > [data-bn-slot]),\n.aside-wrap > .js-ad-aside.mfm-aside-block,\n.bannerbar,\n.mfm-aside-block[style],\n[class*=\"mfz-banner\"],\n[class*=\"mfz-teaser\"],\n[data-bn-slot],\ndiv[id^=\"premium-\"]",".baright,\ndiv[style^=\"display: table; width: 650px; height: 90px;\"]","a[href*=\"invest-expert.com.ua\"]","[data-link*=\"goo.gl\"]","#right-sidebar > .widget_text:not(:first-child),\n#site-container > #container > center",".ra-top-banner","#header-text-nav-wrap,\n.top-bar-ads",".single-bottom-advertising-block","img[src*=\"/banner\"]","#GoodVane",".banner_article,\ndiv[class^=\"open4-sidebar\"]",".ainfo-block[class*=\"b-\"]",".banner--tall",".wp-block-image > figure img[height=\"107\"],\n.wp-block-image > figure img[height=\"160\"],\na[href*=\"://fav.bet/\"]","#banner-top-stretching","wo-ad","div[class*=\"_place__\"]",".td-main-sidebar .widget_text",".site-header__ads,\n.top-ads-links",".ym-video--wrapper",".alko,\n.koz-box,\n.kr-loo-box,\n.video-box","#jm-right .bannergroup","a[href*=\"://prichernomorie.com.ua/i/clka.php?bid=\"]",".ban_subhead,\n.bg-banner,\nheader > a",".cars2",".e3lan-top,\ndiv[style=\"clear:both;float:left;width:100%;margin:0 0 20px 0;\"]","#content > .container > #page-header,\n.background-link,\n.horizontal_baner,\n.journal_top_baner,\n.pane-node-field-right-long-banner,\niframe[src*=\"rz.com.ua/sites/default/files/baneri-\"]","#mainContent > noindex,\n#mainNav > .titleBlue ~ .titleBlue,\n#mainNav > div[style=\"margin-bottom:20px;\"],\n#secondaryContent > .titleBlue,\n#secondaryContent > .titleBlue ~ br,\n#secondaryContent > div[style=\"margin-top:20px;\"] > noindex > :not([title=\"Горячая линия\"]),\n#secondaryContent > div[style=\"margin-top:20px;\"] ~ div[style=\"margin-top:20px;\"],\n[src*=\"images/banners\"]:not([src=\"images/banners/lin.gif\"])","#ads_header_right,\n.widget-group-no-name .sidebarAdvertising,\n.widget-group-no-name:has(.sidebarAdvertising)","body > div[align=\"right\"] > span",".smart-widget,\ndiv[class^=\"smart-\"]","a[href*=\"://flavovir.ua\"] > img",".banner_side","aside > .custom-html-widget","#sidebar-forum,\n.sponsors,\n.sponsors_big",".sp_block script[src*=\"pagead2.\"] ~ a",".c-post__content > div:has(> [id^=\"_vidverto-\"]),\n.tgr-ads,\n[data-text^=\"Новини партнер\"]",".infoA",".hedban",".custom-html-widget > a,\n.custom-html-widget > div","td[style=\"width:170px;vertical-align:top;\"]","a[href^=\"/redirects/banner.php\"]:not([title=\"Телеграм Канал Трибун 2023\"])",".sidebar-special,\n.sidebar-wrap > div:has(> [id*=\"ScriptRoot\"]),\na[href*=\"/cgi-bin/click\"]","#content > .readalser,\n.social-box-item",".theiaStickySidebar .widget_text",".b-page-border > ul[style*=\"width: 600px\"]",".b-top-banner","#rightcolumn",".aliexpress,\n.answear.sale",".virus-widget,\ndiv[class^=\"virus-\"],\nfooter > .footer-main,\nfooter > h4",".block-type-advertising,\n.paragraph--type--banner","#text-57,\n#text-59,\n.widget-area:has(> .widget_text > .textwidget > [id^=\"CNM\"]),\n.widget-area:has(> .widget_text > .textwidget > [id^=\"MarketGid\"]),\n.widget_text:has(> .textwidget > script),\n.widget_text:has(> .textwidget img[src*=\"/banners/\"]),\na[href*=\"://turagent.od.ua\"]",".gpt-main",".main-box:has(> .main-box-inside > div[id^=\"MIXADV_\"])",".td-fix-index > a[href][target=\"_blank\"]","#ban > #lin,\n#ban noindex,\na[href*=\"ukrskidka.com.ua\"],\nnoindex #ban",".td-post-content > p:has(> ins)","#block-reklamappidzagolovokdnya","#atlanta,\n.cont_station > .tags ~ .K_t_a ~ .K_t_a,\n.footer_link_bottom_main,\n.inner_right > div[style*=\"display:\"]",".awac-wrapper",".base-post-divider ~ a[href][target=\"_blank\"] > img,\n.our-news ~ a[href][target=\"_blank\"] > img,\n.our-news ~ img[src],\n[src*=\"/frontend/assets/advert/\"]","[src*=\"/uploads/banner\"]","#bg-brander-promo,\na[onclick*=\"Branding\"]","#sp-top-banners,\n.sp-module-content > div[class=\"\"][style=\"\"],\na[href^=\"/component/flexbanners/\"],\ndiv[id^=\"sp-\"] > .sp-column > .sp-module.hiden-xs","#popup-manager.popup-show",".bannerAffix,\n.bannerHeader,\n.blockProjects_stocksInNews,\n.pad_banner,\ndiv[class^=\"link_brand\"]",".blockProjects_post,\ndiv[class*=\"blockTAdvert\"]",".custom > p > a,\n.custom > p > img","#max-header-adv-id","iframe[src*=\"holder.com.ua\"]",".sidebar > .nm-banner-widget","a[href^=\"http://bark.in.ua\"]",".booking,\n.secondary-slider",".c-feed__list-item:has(> .c-feed__item > .c-r)",".c-r",".advOnTop,\n.inl-blk",".bot-brand","iframe[name*=\"banner\"]","#swiffycontainer",".bnblock,\n.verytopbanner",".b-access__auth,\n.b-access__overlay,\n.b-place-art__mark","#adb-info,\n[data-place-block]","#rt_obmen,\n.FKY_VIDEO,\n.gis_logo,\n.tit_line","#sticky-wrapper,\ndiv[id^=\"banner-zone\"]","div[class*=\"banner-zone\"]","div[class^=\"Advertising\"]","#sidebar > div > a > img,\n.other-news","span[onclick*=\"banner\"]",".o-adds,\n.u-m-h-250",".banner ~ .separator,\n.header-nav .isport-link,\n.main-right > div[style^=\"width: 300px;\"]","#content-roll-tracker,\n#newsRightColumn .right-column-divider,\n#newsRightColumn div[style*=\"min-height:\"],\n#partners-propositions,\n.news-text > .insert:has(> a[target=\"_blank\"]),\n[id*=\"VideoAdvWrapper\"],\ndiv[class*=\"BrandingPlace\"]",".adver_top","#branding-bg-pickit,\n.hdr_banner,\ndiv[class=\"side-banner\"]","a.banner","#ad-730,\n.informer.double",".banner_news,\ndiv[id^=\"corebanner\"]",".fixed_left_ads,\n.fixed_right_ads",".right_content noindex",".page-single > .col-right",".welcome2",".banner_top_right,\ndiv > .comments ~ .blok_header_title,\ndiv[class^=\"lentainform\"]",".top_blogger_banner","div[class$=\"-prm\"]",".abox",".i-topbanner",".sam-pro-container,\n.single-post:has(.sam-pro-container),\ndiv[class^=\"single-video-reklama-\"]",".catalog-three-products","#header .textwidget,\n#secondary > #text-2",".TopBanner730,\n.Wrap > .anons,\n.clear.logo_container,\n.news_premium_item,\n.partner_links,\n.widget_adv",".widget-news_premium","#Premium,\n.content > .news > div > #news_cont ~ [class]",".swiper-slide:has(> a[href*=\"utm_campai\"])","noindex:has(> div ins)","#fb-modal,\n.baner-widget","#left-sidebar > .widget_text,\nmain > div[style=\"display: inline\"]",".simple-top-block","div[id^=\"candyplace_\"]",".tds-button > a[href=\"https://pravda.if.ua/zamovyty-reklamu/\"],\n.wpb_wrapper > .td_block_single_image,\n.wpb_wrapper > .tdm_block_inline_image,\na[href*=\"oxford-med.com.ua\"]",".sidebar .g-single a[href][target=\"_blank\"],\n.widget-a-wrap",".fb-s-blog-two-top a[href]:not([href^=\"/\"]):not([href^=\"https://versii.if.ua\"]),\na[href]:not([href^=\"/\"]):not([href^=\"https://versii.if.ua\"]) > img,\naside > a[href]:not([href^=\"/\"]):not([href^=\"https://versii.if.ua\"]),\naside > div[class=\"brxe-block\"],\nheader > [id] > div > div ~ a[href]:not([href^=\"/\"]):not([href^=\"https://versii.if.ua\"])",".banner-fullborder,\n.entry-banner",".filter-container,\n.lenta > .clear_block,\n.lenta > .clear_block + hr,\n.lentanewspost > .clear_block + hr,\n.reklam_in_text,\ndiv[class^=\"content-text\"] > .content-text ~ hr,\ndiv[class^=\"content-text\"] > .opinion,\ndiv[class^=\"content-text\"] > div[style=\"min-height: 405px;\"]","a[href^=\"http://poisk450.blogspot.com/\"]",".custom-modal",".module-content > noindex","#block-5,\n#block-6","body > div[style^=\"background:\"][style*=\"display: block\"]","a[href^=\"http://8ua.org/\"]","div[class=\"widget widget_text\"]",".slider-main,\nbody.lock #subscribes","#branding_top,\n.air-top,\n.col3,\n.col5,\n.redtram_news,\na[href][rel*=\"sponsored\"]","a[href^=\"/\"][target=\"_blank\"][rel=\"nofollow\"]","img[src*=\"/uploads/blocks/\"]",".copyright-inner > p ~ p","#brandlink,\n#cols2premium,\n.euroban","a[href^=\"https://inf.im/pinup_bonus\"],\ndiv[id][style=\"min-height:400px\"]",".b-block > table[class]",".block_top_banner,\n.football-link[target=\"_blank\"],\n.premium-desk",".entry-content > p:has(> strong > a[href*=\"utm_campai\"]),\n.post-txt > p:has(.highlight > a[href*=\"utm_\"]),\n.product-info,\n[data-course],\na[href*=\"/?ulp\"],\na[href*=\"://telemart.ua/\"]:has(> span > strong),\na[href*=\"utm_campai\"] > img","div[class*=\"content_ads\"]",".banner_style,\n[class*=\"region-banner\"],\n[class*=\"region-news\"] > .block > * > .img-responsive,\n[class*=\"region-news\"] > .block a[href][target=\"_blank\"]","#block-15,\n#block-16,\nimg[data-lazy-src^=\"https://www.newsroom.kh.ua/wp-content/uploads/tiny_\"]","a[href^=\"//www.slk.kh.ua/banners/\"]","#central > table > tbody > tr > .noprint,\n#left-banners,\n[id^=\"banner_\"],\na[href^=\"/click.html\"]","a[href*=\"://1001gagarin-stat2.com/\"]",".ad-modal,\n.bets-block","a[href*=\"cargo120.com\"]","body > #myModal",".js-relap__item:has([data-ad-link]),\n.torba-lightbox-side-wrap",".ft-bnnr-block",".lazy-load-box[style^=\"font-size: 0.75em;\"]","body > noindex > noindex","#flydiv","td[valign=\"top\"] > noindex > center","#ourBranding,\n.imaband",".main_top_line,\n.promobar,\n.promobrand,\n.turn-off-add-block-text",".tuborg,\nbody > #background",".popularBanner",".elementor-widget-container > a[href][target=\"_blank\"] > img","img[src*=\"/uploads/rain.\"]",".node-article > .row ~ .row.only-desktop,\n.sidebar-box:has(> .row > .block-block),\n.sidebar-box:has(> [class^=\"ne-banner-\"]),\ndiv[class^=\"ne-banner-\"]",".theiaStickySidebar > .widget_block",".promo-inner > .container > a[href=\"https://vechirniy.kyiv.ua/reklama/\"],\n.promo-inner > .container:has(> .media:only-child),\n.promo-inner > .container:has(> a[href*=\"://bit.ly/\"]),\n.promo-inner > .container:has(> a[href*=\"utm_campaign\"]),\n.promo-inner > .container:has(> a[href^=\"https://vechirniy.kyiv.ua/reklama/\"]),\n.ukrnet",".head_img_parent,\n.isfixed,\n.sidebar_kdbn","div[class^=\"adv-banner\"]",".realty-short-preview,\n.search-results-section:has(.new-building-offer-list),\na[href*=\"/redirect-andromeda/\"],\nmain ~ div[class]:has(> div > div > a[href*=\"/redirect-andromeda/\"] ~ a[href*=\"/redirect-andromeda/\"])",".banner-block.banner-label",".wonderpluginslider-container",".toplineban","div[id^=\"admixer_\"] ~ .line",".face-right > .direct-link,\ndiv[class^=\"brand_\"],\nnoindex > script[src^=\"/adv.php?\"] ~ div","#aukro_s,\n#b_meta_popup,\n#meta_market_bottom,\n#rbn,\n#slando_s,\n.ads_240,\n.context,\n.mbnr,\n.riaBanner,\ndiv[id^=\"anabelarto\"],\ndiv[id^=\"meta_banner_\"]","div[class^=\"bookmaker\"]",".main__banner-bottom,\n.sidebar__ads,\ndiv[class^=\"city__banner\"]",".pRight","#flash_market_468","div[class^=\"banner-\"]",".informer[id^=\"mp_banner_\"],\n.reclama","#bx-composite-banner","div[id][style=\"padding-bottom: 35px;\"]","a[href*=\"://sgo.one/\"]",".td-for-blocks div[style=\"margin-bottom: 5px;\"] > noindex,\n.td-for-other > div:first-child[style] ~ .s-block:not([style]):not(:last-child),\n[style^=\"height: 200px; left\"][style*=\"position: absolute\"],\ndiv[id^=\"mbrightbanner\"],\ntd[height=\"180\"] ~ td[height=\"180\"]","div.b-widgets",".mt_adv_block","[data-top-iid]","a[href=\"/adv.php\"]","#kinoafishaslider","#toplayer-bg,\n.nopad > center > a[href][target=\"_blank\"],\na[href][target=\"_blank\"] > div,\ndiv[id$=\"toplayer\"]","#widget_wrapper_46,\n#widget_wrapper_48,\n.append_html","#citata,\na[href*=\"billing.hostpro.ua\"]",".aside__advertising,\n.main > section:not([class]) ~ br,\n.main__business:has(> script),\naside > .dialog > a[href]:not([href^=\"/\"]):not([href^=\"https://pik.net.ua/\"])","body.modal-open #ft_custom_modal",".code-block-34","img[src*=\"banner_\"]","#right.widget-area","center > ins ~ *","#A12,\n#A2,\n#B2,\n#B3,\n#B4",".main__slider,\n.popup-banner",".article__content__footer > div[class^=\"r\"],\n.background-branding,\n[data-vr-zone=\"Баннер\"],\ndiv[id^=\"async_\"][id*=\"_spec\"],\nimg[src=\"/images/dis_blocker_big.jpg\"]",".btn-product-embed","[class*=\"Banner\"]",".global_overheader",".ab-block",".b-layout__right::before",".sidebar-content > .widget_custom_html,\na[rel=\"noopener nofollow sponsored\"]",".img-responsive,\ndiv[class*=\"ai-viewport-\"],\ndiv[class^=\"code-block\"][style^=\"margin: 8px auto; text-align: center; display: block;\"]","#half_right","#banners-header-bottom,\nimg[src*=\"/images/bnr/\"],\nnoindex > .block-banners","#first-top-banner,\n#head-top > div > a[target=\"_blank\"],\naside > .widget_media_image",".square-banner-wrapper",".read__right,\ndiv:has(> div[id][data-url]),\ndiv[id][data-url]","div[class^=\"dle_b_bet\"]","div[style][onclick*=\"/rizni/\"]",".gd,\n.inad",".td-ss-main-content > div[style=\"margin-top: 40px;\"] ~ *","a[href^=\"http://creditka.kiev.ua\"]","img[alt=\"Hosting Ukraine\"]","[data-src*=\"bashmac\"]",".divider,\n.sidebar-right","#ad_pu_modal,\n#telegram_modal,\n:not(html) > iframe[style*=\"important\"]:not([src^=\"https://disqus.com/embed/comments/\"]),\ndiv[id^=\"ads\"]","#rightCommercial",".adsgoogle","a[href*=\"://opillia.com/\"]","img[src*=\"/partner/images/\"]",".penci-sidebar-widgets.widget-area-2,\ndiv[class^=\"c40-reveal-modal\"]",".artbanner,\n.kom,\n.wrapbanner","[class^=\"ad_slot\"]",".divBanners",".slider_big",".header_rec","#top-categories-autoscroll > #main-autoscroll","a[href*=\"/php/rotator/goto.php?id=\"]","[class^=\"headerBanner\"] > .top","div[id^=\"baner\"]","div[class^=\"advertising\"]",".vidverto-wrapper",".adw-link","article > .box[style=\"width:fit-content\"]",".aside-column > a > img[src*=\"/home/banners/\"]","[id^=\"rst-page-banner-300x250\"]",".sidebar-widgets > .widget_text,\n.spu-bg,\n.spu-box","a[title=\"Реклама\"]","a.info[href][target=\"_blank\"]","#page-header > .panel,\n.headerbar > .inner > div[style=\"float:right\"]","[class*=\"billboard\"]","#head--area,\n.ablock,\ndiv[class^=\"sed\"] > .half.left > .sdbrick:nth-child(-1n+9),\ndiv[class^=\"sed\"] > .half.right > .sdbrick,\ndiv[class^=\"sed\"] > a[rel=\"nofollow\"]",".mfp-bg,\n.subscribe-popup","#adsLeftZone,\n#rightCol,\n.informerTop,\n.rightAdvBox,\ndiv[style^=\"margin\"][style$=\"width: 300px;\"]","[class^=\"branding-link-\"]","#videos-ads,\ndiv[id^=\"premium-banner\"],\ndiv[id^=\"topbanner\"]","#b_sport_240,\n#bann-240,\n#news_text > div[class]:has(table[cellpadding] a[target=\"_blank\"]),\n#news_text > p:has(> a[href*=\"://analyticsq1.com/\"]),\n.coefficient,\n.news-event__text > div[class]:has(table[cellpadding] a[target=\"_blank\"]),\n.right-top__banner,\n.sportua-bet-block,\na[href*=\"clickstats.fun\"],\ndiv[id^=\"b_sport_\"],\ndiv[id^=\"zone_\"],\nimg[src=\"https://pic.sport.ua/images/media/orig/f2/16364.gif\"]",".partners-block",".sadse,\n.widgetBestBookmakers,\n[class^=\"best_game\"],\n[src*=\"/img/sadse/\"]","div[class^=\"adv-wrapper\"]",".video-banner",".bottom > .bnr",".bnr-wrapper","aside > .w-nt.primary-sidebar-widget","#advertisement",".Notices.PanelScroller",".category-card__card-row > .col:has(> div > .tabletki-adunit),\n.com__panel-header",".csa-head","#popup-root","#Flash","#header > .rounded",".partners-news",".banner-wide","a[href*=\"brendi\"][target=\"_blank\"],\na[href][target=\"_blank\"][style*=\"/media/uploads/\"]",".c-aside__port,\n.c-section > .l-row > .l-col:has(> [data-ad-container]),\niframe[src*=\"/partner-news?\"],\nmain > aside.u-divider--t:has(> iframe[src*=\"/partner-news?\"])",".partners-block-wrapper",".article__adml,\n.aside-gab,\n.gab-ins,\ndiv[class^=\"ab_premium_\"]",".colum_widget_block_pp,\na[href=\"https://ukrfootball.ua/bookmaker/\"],\na[href=\"https://ukrfootball.ua/casino/\"],\na[href^=\"https://ukrfootball.ua/go/\"],\naside > section:has(> .colum_widget_block_pp)",".socialBlockSlide","#ads-sidebar",".vbet-mid,\nimg[src*=\"/images/puma_\"],\nimg[src*=\"/images/vbet_\"]",".fancybox-lock .fancybox-overlay",".val-external__top-banner,\n.val-sidebar",".banners_home","#right_part > .new_section:empty,\n#right_part > noindex",".right_banner_hold","section[id^=\"ctup_ads-\"]",".article-partners",".holiday-banner-bl,\n.trn-info-block",".col__big .unit-rubric__head[style^=\"margin-top:\"],\n.footer-partners,\n.partner-news-content,\n.sponsors-holder","#modal_window,\n#overlay_fb_modal","#above-header,\n.ai-placement,\n.block-custom-banners,\n.new-banners,\n.znaj-banners_ajax,\na[href^=\"http://prive.kiev.ua\"],\ndiv[class*=\"advertising\"]",".sidebar > .widget_rvuoi:nth-child(-1n+4)",".posts-list-banner",".min a[target=\"_blank\"][rel=\"nofollow\"] > img","#relationfield > div:has([href*=\"://aliclick.shop/\"]),\n.panel-default:has(> .widget_rekl),\n.widget_rekl","a[href^=\"http://robotsforex.ru/sale/\"],\na[href^=\"https://my.alfa-forex.ru/ru/registration/\"]",".bVerticalRectangle,\n.middleboard,\n.rightContainer > .floating_banner,\niframe[src*=\"/www/delivery/\"]","[class^=\"reklama-ads-\"]","#oframeplayer > [class][style^=\"display: block\"],\n.block-info-vertical","div[class*=\"adv-\"]","#offerPopup",".post__banner,\nvideo[src*=\"/storage/uploads/\"][src$=\".mp4\"]",".header-reklama",".LeaderBoard,\n.contentBoxR.floating_banner","#middle_section > div[style^=\"float:\"],\n#right_section > div[style^=\"height: 400px\"],\n#top_two_article",".sidebar > .adv ~ *","[onclick*=\"ClickOnAd\"],\n[onclick*=\"ClickOnBanner\"]","#ovva-player .o-pp,\ndiv[class^=\"playlist-player-branding-\"]",".under-player","#sidebar > li:has([id^=\"yandex_rtb_\"]),\n[vid_vpaut_pl]",":not(my-obnaruzhili-blokirovshchik)","#bnadplayer,\n.fullpanefn","body > div > .a-overlay",".body-sub-form",".detected-block-modal,\n.js-detected-block","a[href$=\".php\"] > img,\na[href*=\".htm\"] > img,\nbody > div[style*=\"right\"] > a[target=\"_blank\"],\ndiv[class^=\"ant\"][class*=\"block\"],\ntable[style*=\"width: 468px;\"][style*=\"border-collapse: collapse;\"][style*=\"height: 60px;\"]","#top-page-ads,\n.ablock_side,\n.header2,\n.main_top_ads",".darkrek","a[href][target=\"_blank\"][style^=\"display:\"],\ntd[width=\"200\"][valign=\"top\"] > a[href]","body > div > .container > a[href][target=\"_blank\"]","#register_popup",".makeBet,\n.zoneBanner","body > div:not([id]):not([class]) + div:not([id]):not([class]) + div:not([id]):not([class]) + div:not([id]):not([class]) ~ div[id]:not([class])","a[rel=\"nofollow\"][target=\"_blank\"][href^=\"http://lu4ok.ws/go/?\"]",".plaintext > noindex,\nnoindex > .lastnews","iframe[src*=\"gnezdo.ru\"]","#page > noindex a[href][target=\"_blank\"]:not([href^=\"http://praetorians.ws/forum/\"])","#rek-top,\n.soft-day:not(:first-child) > .box,\ncenter > .box-shadow + table:last-child",".topad_banner","#dle-content > table[width=\"100%\"][height],\n#torrent_77_info,\n.separator,\ntd.topBorder > table[width=\"100%\"][height]","td[style^=\"text-align:center;width:50%\"]","#localNotice #aside_buttons,\n#localNotice .infobox,\n#n-Группа-в-Дискор��е,\n#n-Канал-в-Телеграме,\n.sitenotice > .floatleft + p + p","div[style^=\"background:\"][style*=\"/ple.jpg)\"]","div[style^=\"max-width:\"][style*=\"200deg\"]","a[href^=\"http://iq-option.org/\"]","iframe[src*=\"/banner/\"]","div[id^=\"post\"] > .tech-info + :empty","img[src][width=\"241\"][height=\"383\"],\nimg[src][width=\"300\"][height=\"216\"]",".b-flex,\n.l-a-fly",".adv-links","div[class^=\"adace\"]",".adt",".main > a[href*=\"bit.ly\"] > img,\np.main:has([href*=\"bit.ly\"])","#gkadblock",".banner__holder"];

const hostnamesMap = new Map([["*",[0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63,64,65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,80,81,82,83,84,85,86,87,88,89,90,91,92,93,94,95,96,97,98,99]],["37.1.217.105",100],["37.1.216.106",100],["37.1.217.113",100],["37.1.206.118",100],["5.45.66.118",100],["37.1.216.119",100],["37.1.206.121",100],["37.1.207.130",100],["37.1.202.140",100],["5.45.65.153",100],["37.1.203.156",100],["37.1.205.159",100],["5.45.70.162",100],["37.1.204.182",100],["37.1.206.231",100],["37.1.201.32",100],["5.45.86.39",100],["37.1.205.47",100],["37.1.207.65",100],["37.1.204.76",100],["5.45.87.85",100],["37.1.206.95",100],["rutor-search.info",100],["hawk.live",100],["extrutor.org",100],["herutor.org",100],["listrutor.org",100],["new-rutor.org",100],["pipitor.org",100],["pronpic.org",[100,2199]],["xrutor.org",100],["123torrent.ru",100],["r-tor.ru",100],["sssrtor.ru",100],["berutor.site",100],["blackrutor.site",100],["extrutor.site",100],["fastrutor.site",100],["prutor.site",100],["rutor1.site",100],["rutor-live.tk",100],["tracker-rutor.tk",100],["78.142.19.8",[101,102,103]],["aliez.me",[101,102]],["context.reverso.net",[102,1920]],["smartphone.ua",[102,5215]],["city01.am",[103,113,114]],["danilin.biz",[103,150]],["015.by",[103,113,114,202]],["belretail.by",[103,221]],["go212.by",[103,113,114]],["go216.by",[103,113,114]],["interfax.by",103],["intex-press.by",103],["sport-tv.by",[103,212,307,308]],["tele.click",103],["tr.anidub.com",[103,483]],["championat.com",[103,546,547]],["comores24.com",[103,113,114]],["defence-ua.com",103],["egamersworld.com",[103,211,587,588]],["fraza.com",[103,594]],["gordonua.com",103],["hen-tay.com",[103,692,693]],["hostingkartinok.com",[103,696]],["iasakh.com",103],["info-ua.com",[103,715]],["lentasporta.com",103],["livejournal.com",[103,198,326,783,784,785,786,787]],["mipped.com",[103,831]],["moldfootball.com",[103,111,837]],["playboyrussia.com",[103,223,924]],["ringside24.com",[103,989]],["rybalka.com",[103,247,1011]],["sakh.com",[103,1012,1013,1014,1015,1016]],["uaportal.com",[103,884]],["usionline.com",[103,1125]],["avoka.do",103],["baltnews.ee",[103,146]],["belsat.eu",[103,684]],["hightech.fm",103],["sib.fm",[103,1257]],["vesty.co.il",103],["yourlink.in",103],["godublin.info",[103,113,114]],["golondon.info",[103,113,114]],["goriga.info",[103,113,114]],["gre4ka.info",[103,225,1363]],["officepackage.info",[103,1403]],["rzn.info",[103,1423]],["sakhalin.info",[103,363,1424]],["skypefree.info",103],["ukrreal.info",103],["vilniuje.info",[103,113,114]],["1plus1.international",[103,1470]],["namba.kg",[103,158,1054,1489]],["zanoza.kg",[103,1494]],["7232.kz",[103,113,114]],["go11.kz",[103,113,114]],["goshymkent.kz",[103,113,114]],["inaktau.kz",[103,113,114]],["inalmaty.kz",[103,113,114]],["inastana.kz",[103,113,114]],["inatyrau.kz",[103,113,114]],["kolesa.kz",[103,149,1517]],["ligasy.kz",103],["namba.kz",[103,1054,1524]],["vlast.kz",103],["yk.kz",[103,1551]],["anapa.life",[103,113,114]],["ecology.md",[103,1594]],["65.media",[103,113,114]],["kursiv.media",[103,1666]],["igry-man.net",[103,1793]],["kulichki.net",[103,672,1539,1819]],["mods-fs.net",[103,551,1107,1851]],["moviestape.net",103],["odpublic.net",103],["online-mult.net",103],["peugeot-citroen.net",[103,380]],["politobzor.net",[103,1094,1901,1902,1903]],["reverso.net",[103,1919]],["tochka.net",[103,284,1961]],["vsluh.net",[103,1902]],["karelia.news",[103,113]],["bzserial.online",103],["anadyr.org",[103,2085]],["chistosex.org",[103,2115]],["gooool365.org",[103,2136]],["sopsport.org",[103,111]],["stopcor.org",[103,884]],["news.pn",[103,196,2255]],["168.ru",[103,460,2306]],["1prime.ru",103],["1rnd.ru",[103,113,114]],["1sn.ru",103],["2mm.ru",[103,2196,2333]],["2pricolisty.ru",[103,2335]],["3652.ru",[103,113,114]],["3654.ru",[103,113,114]],["8422city.ru",[103,113,114]],["allcio.ru",[103,463,2425]],["altgazeta.ru",[103,2441]],["angarsk38.ru",[103,113,114]],["apihost.ru",[103,2477]],["baikal-daily.ru",103],["bazhopol.ru",[103,113,114]],["be-in.ru",103],["bgoperator.ru",103],["blizko.ru",[103,2610]],["carsweek.ru",[103,205,2673]],["chehov-vid.ru",[103,146,454,1346]],["chipfind.ru",[103,2702]],["cinetv.ru",103],["city41.ru",[103,113,114]],["cnews.ru",[103,205,2724]],["copyright.ru",103],["dailycomm.ru",103],["delovoibiysk.ru",103],["dentalmagazine.ru",[103,308,2791]],["domashniy.ru",103],["echo-oren.ru",103],["examen.ru",103],["exler.ru",[103,2910]],["f1cd.ru",[103,308]],["f1news.ru",[103,326,2196,2917]],["factroom.ru",[103,2918]],["fantv.ru",103],["fc-zenit.ru",[103,247,2927]],["fedpress.ru",[103,2932]],["finobzor.ru",[103,1901,1902,1903]],["fn-volga.ru",[103,1314]],["fnvolga.ru",103],["foodinnovation.ru",103],["gamestar.ru",[103,3025]],["gazeta.ru",[103,3032,3033]],["go01.ru",[103,113,114]],["go26.ru",[103,113,114]],["go31.ru",[103,113,114]],["go32.ru",[103,3063]],["go61.ru",[103,113,114]],["go7812.ru",[103,113,114]],["gorod3466.ru",[103,113,114]],["gorod55.ru",[103,158,3077]],["gorodarmavir.ru",[103,113,114]],["goroddomodedovo.ru",[103,113,114]],["hen-tai.ru",[103,3119]],["i2hard.ru",[103,3151]],["iguides.ru",[103,3166]],["inc-news.ru",103],["infolyubertsy.ru",[103,113,114]],["inform69.ru",[103,113,114]],["inosmi.ru",103],["interior.ru",103],["intermedia.ru",[103,205,3203]],["it-weekly.ru",[103,463,2425]],["it-world.ru",[103,463,2425]],["www.ivi.ru",[103,3231]],["joxi.ru",103],["kinoplex.ru",[103,3292]],["klassnye-chasy.ru",[103,3303]],["kod.ru",[103,3313]],["korabel.ru",[103,2971,3325]],["kurgan.ru",[103,2016,3345]],["lenta.ru",[103,2913,3360]],["live4fun.ru",[103,3387]],["lookatme.ru",[103,1732,3399]],["loveradio.ru",[103,204,3404]],["marker.ru",103],["maximum.ru",[103,2798]],["mos-holidays.ru",[103,3571]],["mosfilmgold.ru",103],["news.nashbryansk.ru",103],["newslab.ru",103],["oneprog.ru",[103,3744]],["ontvtime.ru",[103,1078]],["oper.ru",[103,218,1374,3759]],["penzadoctor.ru",[103,3803]],["post-tracker.ru",[103,111,225,996,3869]],["pravo.ru",103],["prm.ru",[103,145,3896]],["render911.ru",103],["ria.ru",[103,2422,4012]],["roem.ru",[103,3296,4031]],["rusroman.ru",103],["russia.ru",[103,145]],["samara24.ru",[103,145,4071]],["sarnovosti.ru",103],["savepic.ru",[103,4084]],["seodiz.ru",103],["slon.ru",[103,4152]],["softkey.ru",103],["sonikelf.ru",[103,4193]],["echomsk.spb.ru",[103,4204]],["spbdnevnik.ru",[103,4210]],["stereo.ru",103],["stranaru.ru",[103,4257]],["superomsk.ru",103],["supersadovnik.ru",[103,4273]],["tass.ru",[103,4295]],["text.ru",103],["theblueprint.ru",103],["forum.tiguans.ru",103],["topwar.ru",[103,146,1901,1903,2421,2528,4360]],["tulapressa.ru",[103,218,4398]],["tumix.ru",103],["turizm.ru",[103,2601,4400]],["tvernews.ru",[103,146,4416]],["ukraina.ru",[103,205]],["utro.ru",[103,146,4453]],["vce-besplatno.ru",103],["vm.ru",[103,205,4505]],["vomske.ru",103],["vprognoze.ru",[103,4517]],["warfiles.ru",[103,1901,1902,1903]],["weacom.ru",[103,4538]],["wildo.ru",[103,145,4555]],["ya62.ru",[103,4599]],["yocity12.ru",[103,113,114]],["yuginform.ru",[103,4257]],["yugopolis.ru",[103,1442,1443]],["yznal.ru",103],["zvezdi.ru",103],["teleg.run",103],["namba.tj",[103,1054,4744,4745]],["bestrussia.tv",103],["gooool.tv",[103,2136]],["poltavske.tv",103],["rudetective.tv",103],["showgid.tv",[103,4834]],["strashnoe.tv",103],["tet.tv",[103,1442,1443]],["tvrain.tv",103],["ukrlife.tv",103],["unian.tv",103],["weukraine.tv",[103,4851]],["0312.ua",[103,113,114]],["032.ua",[103,113,114]],["0332.ua",[103,113,114]],["0342.ua",[103,113,114]],["0352.ua",[103,113,114]],["0362.ua",[103,113,114]],["0372.ua",[103,113,114]],["0382.ua",[103,113,114]],["0412.ua",[103,113,114]],["0432.ua",[103,113,114]],["0462.ua",[103,113,114]],["0472.ua",[103,113,114]],["048.ua",[103,113,114]],["0522.ua",[103,113,114]],["0532.ua",[103,113,114]],["0542.ua",[103,113,114]],["0552.ua",[103,113,114]],["056.ua",[103,113,114]],["0564.ua",[103,113,114]],["057.ua",[103,113,114]],["061.ua",[103,113,114]],["06242.ua",[103,113,114]],["0642.ua",[103,113,114]],["0652.ua",[103,113,114]],["0692.ua",[103,113,114]],["1plus1.ua",[103,4857,4858]],["2plus2.ua",103],["44.ua",[103,113,114]],["62.ua",[103,113,114]],["04141.com.ua",[103,113,114]],["04563.com.ua",[103,113,114]],["04596.com.ua",[103,113,114]],["04597.com.ua",[103,113,114]],["04598.com.ua",[103,113,114]],["04868.com.ua",[103,113,114]],["0512.com.ua",[103,113,114]],["05136.com.ua",[103,113,114]],["05161.com.ua",[103,113,114]],["05366.com.ua",[103,113,114]],["05447.com.ua",[103,113,114]],["0566.com.ua",[103,113,114]],["0569.com.ua",[103,113,114]],["06153.com.ua",[103,113,114]],["0619.com.ua",[103,113,114]],["0623.com.ua",[103,113,114]],["06236.com.ua",[103,113,114]],["06237.com.ua",[103,113,114]],["06239.com.ua",[103,113,114]],["06252.com.ua",[103,113,114]],["06267.com.ua",[103,113,114]],["06272.com.ua",[103,113,114]],["06274.com.ua",[103,113,114]],["06277.com.ua",[103,113,114]],["0629.com.ua",[103,113,114]],["06452.com.ua",[103,113,114]],["3849.com.ua",[103,113,114]],["4594.com.ua",[103,113,114]],["5692.com.ua",[103,113,114]],["6262.com.ua",[103,113,114]],["6264.com.ua",[103,113,114]],["agrobusiness.com.ua",103],["champion.com.ua",[103,128]],["dnl.com.ua",[103,680]],["dostyp.com.ua",103],["kurs.com.ua",[103,259,1078,4955]],["nnews.com.ua",[103,203,4972]],["ogosex.com.ua",103],["pn.com.ua",[103,4980]],["dengi.ua",[103,145,246,1723,1724]],["dialog.ua",103],["dnl.dn.ua",[103,680]],["football.ua",[103,145,212,5055]],["glavcom.ua",[103,5061]],["ukurier.gov.ua",103],["blitz.if.ua",103],["kinoafisha.ua",[103,562,5121]],["konkurent.ua",[103,145,5123]],["ugorod.kr.ua",103],["minus.lviv.ua",103],["portal.lviv.ua",[103,4912,5133]],["kherson.net.ua",[103,1461]],["mv.org.ua",[103,5184]],["osvita.ua",[103,1314,5191]],["reporter.ua",[103,5204]],["trademaster.ua",[103,158]],["val.ua",[103,212,5242]],["repost.uz",[103,391,4418,5262]],["sports.uz",[103,5263]],["ppc.world",[103,5275]],["link.ac",[104,105]],["infobank.by",[104,231,251]],["fergananews.com",[104,614]],["lm-games.com",104],["readbookz.com",104],["voxpopuli.kz",[104,1548,1549]],["live-gol.net",[104,1829]],["qupier.org",104],["liveangarsk.ru",[104,3388]],["ping-admin.ru",104],["premiership.ru",104],["urod.ru",[104,4448]],["cripo.com.ua",[104,697,4917]],["xtreme.ws",[104,5290]],["lenkino.adult",[106,107]],["ebalovo.porn",[107,2256]],["ebalovo.pro",107],["hrk.aero",108],["forum.rarib.ag",109],["1in.am",[110,111]],["lovesun.by",[111,265]],["mybrazz.club",[111,403]],["dead-serial.com",[111,175]],["ggscore.com",[111,667]],["itechua.com",[111,725,726]],["izbezhat-nakazania.com",111],["kosti-tv.com",[111,175]],["prosportua.com",[111,284]],["spletnica-tv.com",111],["sportarena.com",[111,1053,1054]],["strela-online.com",111],["teenwolf-tv.com",111],["theflash-tv.com",111],["udargol.com",111],["vskazke-tv.com",[111,175]],["c-inform.info",111],["kinoafisha.info",[111,123,326,1373,1374,1375]],["prosports.kg",[111,212,1490]],["alau.kz",[111,209,231,436,1503]],["prosports.kz",[111,212,1490]],["shuba.life",[111,1571]],["fishki.net",[111,175,205,212,1768]],["igry-online.net",[111,231]],["mac-torrent-download.net",111],["playua.net",[111,1895]],["freeopenvpn.org",[111,672]],["grimm-online.org",111],["igrovaya.org",[111,1728,2144,2145]],["pesikot.org",111],["vsetors.org",[111,2145]],["tg.telepult.pro",111],["101.ru",[111,146,231,2288,2289,2290]],["101kofemashina.ru",[111,2291]],["bugaga.ru",111],["csgamer.ru",[111,1232]],["ctv7.ru",[111,2767]],["e-libra.ru",[111,391]],["fashiony.ru",111],["fclmnews.ru",[111,2930]],["game2day.ru",[111,3016]],["horrorzone.ru",[111,212,3138]],["in-dmitrov.ru",[111,231]],["in-domodedovo.ru",[111,231]],["in-istra.ru",[111,231]],["in-kolomna.ru",[111,231]],["in-korolev.ru",[111,231]],["in-narofominsk.ru",[111,231]],["in-reutov.ru",[111,231]],["in-schelkovo.ru",[111,231]],["in-vidnoe.ru",[111,231]],["in-voskresensk.ru",[111,231]],["inbalashikha.ru",[111,231]],["inchehov.ru",[111,231]],["inchernogolovka.ru",[111,231]],["indolgoprud.ru",[111,231]],["indubnacity.ru",[111,231]],["inegorievsk.ru",[111,231]],["inelgorsk.ru",[111,231]],["inelstal.ru",[111,231]],["infryazino.ru",[111,231]],["inhimkicity.ru",[111,231]],["inivanteevka.ru",[111,231]],["inkashira.ru",[111,231]],["inklincity.ru",[111,231]],["inkotelniki.ru",[111,231]],["inkrasnoarmeisk.ru",[111,231]],["inkrasnogorsk.ru",[111,231]],["inkrasnoznamensk.ru",[111,231]],["inlobnya.ru",[111,231]],["inlosinopetrovsk.ru",[111,231]],["inlotoshino.ru",[111,231]],["inlubertsy.ru",[111,231]],["inluhovitsy.ru",[111,231]],["inlytkarino.ru",[111,231]],["inmozhaisk.ru",[111,231]],["inmytishchi.ru",[111,231]],["innoginsk.ru",[111,231]],["inodintsovo.ru",[111,231]],["inorehovo.ru",[111,231]],["inozery.ru",[111,231]],["inpavposad.ru",[111,231]],["inpodolsk.ru",[111,231]],["inprotvino.ru",[111,231]],["inpushchino.ru",[111,231]],["inpushkino.ru",[111,231]],["inramenskoe.ru",[111,231]],["inroshal.ru",[111,231]],["inruza.ru",[111,231]],["insergposad.ru",[111,231]],["inserprud.ru",[111,231]],["inserpuhov.ru",[111,231]],["inshahovskoe.ru",[111,231]],["inshatura.ru",[111,231]],["insolnechnogorsk.ru",[111,231]],["instupino.ru",[111,231]],["intaldom.ru",[111,231]],["involokolamsk.ru",[111,231]],["inzaraisk.ru",[111,231]],["inzheldor.ru",[111,231]],["inzhukovskiy.ru",[111,231]],["inzvenigorod.ru",[111,231]],["kushvsporte.ru",111],["likeni.ru",[111,463,3377]],["madjong-besplatno.ru",111],["mirf.ru",[111,3528]],["ne-kurim.ru",[111,3645]],["pimpletv.ru",[111,607,3826]],["povarenok.ru",[111,128,158,205,1033,2504,2505,3875]],["prodota.ru",[111,212,2774]],["relook.ru",[111,2505]],["saratovnews.ru",[111,4081]],["zab.ru",[111,4634]],["zorgee.ru",[111,4666]],["jut.su",[111,128,4712]],["topfile.tj",[111,225,3651,4747]],["alexua.tv",[111,620]],["animejapan.tv",111],["bit.ua",111],["gta.com.ua",[111,4939]],["kievvlast.com.ua",[111,4952]],["ko.com.ua",[111,4312,4953]],["comments.ua",[111,128,4881,5024]],["cvnews.cv.ua",[111,5026]],["gorod.dp.ua",[111,231,5035]],["gameinside.ua",[111,284,5059]],["jetsetter.ua",111],["forpost.lviv.ua",[111,739]],["nashkiev.ua",111],["ifnews.org.ua",[111,1076,5026,5182]],["lvnews.org.ua",[111,1076,5026]],["tenews.org.ua",[111,593,1076,1447,4902,5026,5188]],["uanews.org.ua",[111,5026]],["rvnews.rv.ua",[111,1076,5026]],["traktorist.ua",[111,175,511,5233]],["upl.ua",[111,5240]],["bestinfo.am",112],["rp5.am",[115,116]],["rp5.by",[115,116,300]],["rp5.kz",[115,116,300]],["rp5.md",[115,116]],["rp5.co.nz",[115,116]],["rp5.ru",[115,116,300]],["rp5.co.uk",[115,116]],["computer76.ru",[116,594]],["videoredaktor.ru",[116,594,672]],["freestore.app",117],["championat.asia",118],["darkmoney.at",119],["arenda.az",120],["big.az",121],["bina.az",122],["tap.az",122],["turbo.az",122],["enovosty.com",[122,212,591,592,593,594]],["ogorodnik.com",122],["propozitsiya.com",[122,959]],["chem21.info",[122,1330]],["bitpump.ru",[122,225]],["snow-motion.ru",[122,4169]],["uralpress.ru",[122,146,4444]],["stadion.uz",[122,5265]],["day.az",[123,124]],["024.by",[123,203,204,205]],["gs.by",123],["takprosto.cc",123],["gagadget.com",[123,641,642]],["gsconto.com",[123,678]],["klubok.com",[123,158,766]],["scooter-remont.com",[123,144]],["seasonvar24.com",123],["tvsezon.com",[123,1100]],["orl.ec",[123,1214,1215]],["gameme.eu",[123,1226]],["allnews.kz",123],["sports.kz",[123,454,1538,1539]],["mangalib.me",123],["savevideo.me",[123,1644]],["yaoilib.me",123],["chatadelic.net",[123,962]],["hotzoom.net",123],["ura.news",[123,218,231,1346,1358,2038]],["like-film.online",123],["jooble.org",[123,2149]],["sexytales.org",[123,2214]],["bigpicture.ru",[123,146,286,2593]],["coderoad.ru",123],["football-fun.ru",123],["fotokto.ru",[123,2987]],["icons8.ru",123],["infoniac.ru",[123,680]],["malenkiy.ru",[123,3451]],["my-calend.ru",123],["novostiplanety.ru",123],["soccer.ru",[123,475,3061,4172]],["timeout.ru",[123,308]],["world-knigi.ru",[123,4573]],["euromd.com.ua",123],["gotoshop.ua",[123,5065]],["jooble.ua",123],["1927.kiev.ua",[123,5111]],["meta.ua",[123,670,2264,2443,5050,5137,5138]],["podrobnosti.ua",[123,885]],["1plus1.video",[123,212,4858,5268]],["lux.fm",[124,1246,1247]],["disput.az",125],["enter.az",126],["great.az",127],["haqqin.az",128],["gorodvitebsk.by",[128,245]],["gp.by",[128,246]],["sport5.by",128],["primemusic.cc",128],["agroreview.com",[128,458,459]],["bezformata.com",[128,513]],["cryptonewsua.com",[128,306]],["fatalgame.com",[128,609,610]],["gecid.com",[128,666]],["industry-hunter.com",[128,714]],["prostatitanet.com",[128,466,960,961]],["roscontrol.com",128],["vringe.com",[128,1156,1157]],["vshkole.com",128],["wonderzine.com",128],["skachat-kino.fun",128],["9tv.co.il",[128,1292]],["19rus.info",[128,146]],["menportal.info",[128,711]],["nmedic.info",[128,711]],["nv-online.info",128],["valverus.info",128],["vinnitsa.info",[128,1455]],["365info.kz",128],["kt.kz",128],["tengriauto.kz",[128,1540]],["tengrinews.kz",[128,1540,1541]],["tengrisport.kz",[128,1540,1542]],["tengritravel.kz",[128,1543]],["locals.md",128],["zaryad.me",128],["agrotimes.net",[128,1709]],["neboleem.net",[128,1872]],["polochka.net",[128,1905]],["wowjp.net",[128,1999]],["vklasse.online",[128,2072]],["1777.ru",[128,205,2308]],["19rusinfo.ru",[128,223]],["1ul.ru",128],["2goroda.ru",128],["3ys.ru",[128,2355]],["73online.ru",[128,2054,2365]],["advis.ru",[128,2391]],["autodmir.ru",[128,2524]],["avtodispetcher.ru",128],["bakemono.ru",[128,380]],["bel.ru",[128,205]],["bloknot.ru",[128,205]],["bloknot-astrakhan.ru",[128,205]],["bloknot-gelendzhik.ru",[128,205]],["bloknot-kamyshin.ru",[128,205]],["bloknot-krasnodar.ru",[128,205]],["bloknot-krymska.ru",[128,205]],["bloknot-moldova.ru",[128,205]],["bloknot-morozovsk.ru",[128,205]],["bloknot-novorossiysk.ru",[128,205]],["bloknot-rossosh.ru",[128,205]],["bloknot-rostov.ru",[128,205]],["bloknot-samara.ru",[128,205]],["bloknot-shakhty.ru",[128,205]],["bloknot-stavropol.ru",[128,205]],["bloknot-taganrog.ru",[128,205]],["bloknot-volgodonsk.ru",[128,205]],["bloknot-volgograd.ru",[128,205]],["bloknot-volzhsky.ru",[128,205]],["bloknot-voronezh.ru",[128,205]],["bloknotanapa.ru",[128,205]],["bloknotlipetsk.ru",[128,205]],["bloknotsaratov.ru",[128,205]],["bloknotsochi.ru",[128,205]],["bloknottambov.ru",[128,205]],["car.ru",[128,1350,2666]],["cbonds.ru",[128,2675]],["codernet.ru",128],["con-med.ru",128],["cybersport.ru",[128,1560,2622,2773,2774]],["echosevera.ru",[128,2870]],["filmz.ru",128],["fishingsib.ru",[128,2952]],["flamp.ru",[128,2957]],["food.ru",[128,205,2971,2972]],["forum-profit.ru",[128,175]],["gameguru.ru",[128,454]],["goodfon.ru",[128,228]],["hunting.ru",[128,2952]],["infpol.ru",128],["investfunds.ru",128],["ircity.ru",[128,2294,2295,2296,2297,2300]],["islam-today.ru",[128,2141,3218]],["iz.ru",[128,146,205,3232]],["joborgame.ru",128],["k1news.ru",[128,149,3251]],["klavogonki.ru",128],["knijky.ru",[128,3312]],["kursktv.ru",[128,245,854]],["laradiofm.ru",128],["medialeaks.ru",[128,3489]],["megatyumen.ru",[128,3506]],["myslo.ru",[128,3619]],["penza-press.ru",[128,245,660]],["ppt4web.ru",[128,3879]],["pravoved.ru",[128,3885]],["profibeer.ru",128],["redfm.ru",128],["relax-fm.ru",[128,2737,4002]],["rg.ru",[128,3480,4011]],["smolensk-i.ru",[128,205,4161]],["sovsport.ru",[128,218,4202]],["spanishrestaurant.ru",128],["zagorod.spb.ru",[128,4209]],["start33.ru",128],["syzran-small.ru",[128,218,4285]],["tele.ru",[128,4309]],["the-flow.ru",128],["thequestion.ru",[128,4329]],["thg.ru",[128,212,4332]],["tveda.ru",[128,660]],["twentysix.ru",128],["ufanotes.ru",[128,4436]],["vashurok.ru",[128,212,4465]],["veterinargid.ru",128],["woman.ru",[128,223,2818,4244,4565]],["zaim-profi.ru",128],["zebra-tv.ru",[128,246]],["zoohoz.ru",128],["zorbasmedia.ru",128],["vovka.su",128],["footballua.tv",[128,917,4788]],["20minut.ua",128],["agronews.ua",[128,212,284,459,1984,3061]],["besplatka.ua",[128,4879]],["bhub.com.ua",[128,3265]],["budport.com.ua",[128,1213,4910]],["epravda.com.ua",[128,594,4923,4924,4925,4926,4927]],["pravda.com.ua",[128,607,4923,4925,4927,4985]],["growhow.in.ua",[128,684,5091]],["sportguide.kiev.ua",128],["obyava.ua",[128,5168]],["okna.ua",[128,5176]],["vikka.ua",[128,5246]],["xsport.ua",[128,247,463,5138]],["livesport.ws",[128,854,5283]],["navigator.az",129],["geonavigator.ge",129],["oxu.az",[130,131]],["liking-soft.ru",[130,3378]],["unvan.az",132],["video.az",133],["navkolonas.com",133],["gazeta-severny.ru",[133,3034]],["morediva.ru",133],["vseprynosti.ru",133],["anekdot.bar",134],["kinosimka.be",135],["btrans.by",[135,227]],["qna.center",135],["reviewscompanies.club",135],["crimea-news.com",135],["dv-gazeta.info",[135,1107,1339]],["androidkino.net",135],["reestr.rublacklist.net",135],["wotsite.net",[135,1998]],["progroshi.news",[135,154,2032]],["proukraine.news",135],["ru",[135,201,2285]],["dugtor.ru",[135,2854]],["internet-technologies.ru",[135,3205]],["resheba.top",135],["xcadr.tv",[135,953,4853]],["ua",[135,201,917]],["vesti.uz",[135,146,5266]],["ads.bid",136],["directx.biz",136],["getdstudio.cab",136],["bestsoft.club",136],["browser-extensions.club",136],["rutorrent.co",136],["toprated-film.co",136],["appt12mn.com",136],["dnevni4ok.com",136],["downloadamigo.com",136],["elementsbrowser.com",136],["everinform.com",136],["getdstudio.com",136],["install-now.com",136],["medicin-novosti-24.com",136],["news-decent.com",136],["news-sphere.com",136],["novostly.com",136],["banner.mob.ru.com",136],["t1mcapp.com",136],["tlmnt.com",136],["tordrom.com",136],["wogoods.com",136],["rutracker.eu",136],["top-rutor.eu",136],["ex.24smi.info",136],["top.24smi.info",136],["zodiac-game.info",136],["driverpack.io",136],["getdstud.io",136],["idealmedia.io",136],["upro.me",136],["rutor.ml",136],["cs-serva.net",136],["installpack.net",136],["saymigren.net",136],["sysenvfiles.net",136],["etarg.network",136],["topnews.smi.one",136],["dw1-msetup.org",136],["medicineteaser.org",136],["rutorgame.org",136],["rutraker.org",136],["starblog.org",136],["olx.ua.partners",136],["msetup.pro",136],["offergate.pro",136],["ubar.pro",136],["ufiler.pro",136],["dugtor-deer.pw",136],["activation-keys.ru",136],["adregain.ru",136],["apicloud.ru",136],["cheatget.ru",136],["click2soft.ru",136],["clickbytes.ru",136],["content.directadvert.ru",136],["downloadbrowser.ru",136],["driverpaksolution.ru",136],["exonews.ru",136],["fast2click.ru",136],["filetaker.ru",136],["fin-vector.ru",136],["flebolab.ru",136],["getappwiz.ru",136],["getfiletds.ru",136],["getyoursoft.ru",136],["globalstylis.ru",136],["hdvideoboxs.ru",136],["health-official.ru",136],["kinowinx.ru",136],["linksoftbox.ru",136],["litebrowser.ru",136],["losnews.ru",136],["mainews.ru",136],["manysoftlink.ru",136],["marketgid.ru",136],["medicineteaser.ru",136],["mysoftbox.ru",136],["nalivali.ru",136],["newsma.ru",136],["ognyvo.ru",136],["orgsales.ru",136],["picpick.ru",136],["pochistit.ru",136],["popcornhd.ru",136],["prime-oblako.ru",136],["programma-ochistki.ru",136],["readvesti.ru",136],["rotateme.ru",136],["rsboot.ru",136],["rustoria-topnews.ru",136],["sb-on-line.ru",136],["search-cdn.ru",136],["searchcdn.ru",136],["smiru.ru",136],["softboxtds.ru",136],["t-lafa-site.ru",136],["tdsclicks2.ru",136],["tdsrotations.ru",136],["tft-test.ru",136],["torrentum.ru",136],["ubar-pro.ru",136],["ubar-pro2.ru",136],["ubar-pro3.ru",136],["ubar-pro4.ru",136],["ufiler-download.ru",136],["ufiler-pro.ru",136],["ufiler-pro2.ru",136],["viniki.ru",136],["vserpg.ru",136],["womens-journal.ru",136],["worldinform.ru",136],["xbox-torrent.ru",136],["ya-browser.ru",136],["ya-cdn.ru",136],["ya-distrib.ru",136],["yadistr.ru",136],["yasearch-cdn.ru",136],["yasearchcdn.ru",136],["ynsearch.ru",136],["zpppstop.ru",136],["zqwjpxow7boc.ru",136],["ex.infox.sg",136],["ex.24smi.site",136],["download.studio",136],["drp.su",136],["yabrowser.su",136],["rutors.tk",136],["spishi.vip",136],["new-rutor.website",136],["rutracker.work",136],["1xikk.world",136],["1xool.world",136],["mytrk.xyz",136],["spcs.bio",[137,138,139]],["gdespaces.com",[137,138,139]],["spac1.com",[137,138,139]],["spaces-blogs.com",[137,138,139]],["usersporn.com",[137,138,1123,1124]],["spcs.global",[137,138,139]],["spaces.im",[137,138,139]],["strip2.in",[137,138,1123,1124]],["spac1.info",[137,138,139]],["spcs.life",[137,138,139]],["spac.me",[137,138,139]],["spac1.me",[137,138,139]],["spcs.me",[137,138,139]],["gdespaces.net",[137,138,139]],["spac1.net",[137,138,139]],["spcs.network",[137,138,139]],["spcs.news",[137,138,139]],["spac1.org",[137,138,139]],["spcs.pro",[137,138,139]],["spcs.pub",[137,138,139]],["spcs.reviews",[137,138,139]],["spac1.ru",[137,138,139]],["spac.run",[137,138,139]],["spcs.social",[137,138,139]],["spac.wtf",[137,138,139]],["strip2.xxx",[137,138,1123,1124]],["spcs-files.xyz",[137,138,139]],["spcs.mobi",[138,139]],["google-cloud.services",[138,1124]],["ukr.bio",140],["365news.biz",[141,142]],["newgoal.ru",142],["afanasy.biz",[143,144,145,146]],["ura-inform.com",[145,1122]],["fullsite.org",[145,2133]],["novosti-n.org",[145,2182]],["1fnl.ru",[145,475,2311]],["1tulatv.ru",[145,475,511]],["78.ru",[145,2367]],["bragazeta.ru",[145,454,2634]],["job.ru",[145,277,1442,1443,3241,3242]],["km.ru",[145,3307]],["livejournal.ru",145],["riamo.ru",[145,205,1527,2831,4015]],["rusnext.ru",[145,218,4051,4052]],["smilekaluga.ru",145],["study.ru",[145,205,1259,4263]],["ucheba.ru",[145,4429]],["rusvesna.su",[145,146,205,212,4051,4730]],["dnepr24.com.ua",[145,1461]],["kr24.com.ua",[145,1461]],["nikolaev24.com.ua",[145,1461]],["v-variant.com.ua",145],["odessa.net.ua",[145,1461]],["gazeta.zp.ua",[145,1461]],["dnpmag.com",[146,573]],["do-slez.com",[146,574]],["eadaily.com",[146,583]],["melodrama1.com",146],["newinform.com",[146,860,861]],["russian.rt.com",[146,205,218,308,995]],["news-front.info",[146,1397,1398]],["polit.info",[146,861]],["mgorod.kz",[146,231,247,1519]],["ratel.kz",[146,1534]],["zakon.kz",[146,212,1555,1556]],["steaklovers.menu",146],["politexpert.net",[146,861,1899]],["sm.news",[146,205,218,2026,2035,2036]],["usa.one",[146,2050,2051]],["hightech.plus",146],["5-tv.ru",[146,2358]],["56orb.ru",[146,826]],["62info.ru",[146,463,2361]],["7info.ru",146],["allboxing.ru",[146,205,1341,2420,2421]],["anekdot.ru",[146,225,2455]],["argumenti.ru",[146,205,284,2490]],["autonews.ru",[146,2530,2531,2532,2533]],["belive.ru",[146,2576]],["bombardir.ru",[146,511,2620,2621,2622]],["daily-inform.ru",[146,2780]],["dni.ru",[146,223,2815]],["eg.ru",[146,223]],["expert.ru",[146,2911]],["ferra.ru",[146,2934]],["gazeta-tula.ru",[146,3035]],["glavnoe24.ru",146],["gorobzor.ru",[146,3073]],["gorvesti.ru",[146,3081,3082,3083]],["govoritmoskva.ru",[146,2763,3090]],["gubdaily.ru",[146,203,3100]],["iarex.ru",[146,458]],["inforeactor.ru",[146,212,861,3185]],["kirov-portal.ru",[146,3299]],["letidor.ru",[146,2934,3032]],["livelib.ru",[146,3393]],["m24.ru",[146,3412]],["mirtesen.ru",[146,3532]],["mk.ru",[146,205,218,2549,3536,3537]],["moslenta.ru",[146,2934,3032,3575]],["myhistori.ru",[146,3609]],["nashgorod.ru",[146,826]],["nation-news.ru",[146,861]],["nevnov.ru",[146,861,3657]],["news.ru",[146,204,218,223]],["nn.ru",[146,231,2294,2295,2296,2297,2300,3687]],["ntv.ru",[146,1553,3712]],["osnmedia.ru",[146,205]],["passion.ru",[146,2934,3032]],["penzainform.ru",[146,218,3804]],["penzavzglyad.ru",[146,475,3805]],["pikinform.ru",146],["pnp.ru",[146,3841]],["politonline.ru",[146,2060]],["pora.ru",146],["pravda.ru",[146,515,3083,3883]],["quto.ru",[146,2934,3032]],["radidomapro.ru",[146,3955]],["radioromantika.ru",[146,2289,2290,2737,3962]],["rbc.ru",[146,2297,2531,2532,2533,3984,3985,3986]],["ria56.ru",[146,4013]],["riafan.ru",[146,212,861,4014]],["rueconomics.ru",[146,861]],["rusplt.ru",[146,380,511,1833,4053]],["sevkavportal.ru",[146,231]],["sharknews.ru",[146,387,4124]],["sminews.ru",146],["sobesednik.ru",[146,223,2196]],["sport-express.ru",[146,212,218,3853,4215,4216]],["sportrbc.ru",[146,2532,2533,3985,4216,4227]],["sports.ru",[146,196,212,226,1487,4228]],["sun-news.ru",[146,4267]],["trendymen.ru",[146,573,4388]],["tsn24.ru",[146,4393]],["tvc.ru",[146,2196,4408]],["vedomosti.ru",[146,4469]],["versia.ru",146],["veseloeradio.ru",[146,2737,4475]],["vesti.ru",[146,4476]],["vesti-yamal.ru",[146,4477]],["vestivrn.ru",[146,4482]],["vokrugsveta.ru",[146,223,2818,3477]],["zr.ru",[146,218,4668]],["agitpro.su",146],["ua.today",[146,4761]],["mir24.tv",[146,4806]],["ren.tv",[146,4824]],["tsargrad.tv",[146,205,218,276,2181,4839]],["vokrug.tv",[146,1553,4847]],["2000.ua",[146,4859]],["kriminal.net.ua",[146,3589,5030,5154]],["rbc.ua",[146,4333,5201]],["xn--b1ats.xn--80asehdb",[146,3081]],["all.biz",147],["berdyansk.biz",148],["cools.biz",149],["mp3cc.biz",[149,168,169,170]],["get-tune.cc",[149,168,169,170]],["mp3iq.com",[149,168,170]],["cools.dj",149],["ipleer.fm",[149,170]],["iplayer.info",[149,170]],["vmuzice.me",[149,1656]],["intermusic.name",149],["market4game.ru",[149,2971]],["yellowpages.uz",[149,5267]],["delovoymir.biz",[151,152]],["sexytal.com",[152,391,1025]],["skolkovarim.com",[152,1036]],["voffka.com",[152,462,1148]],["mgnovenie.net",152],["vlasti.net",[152,854,1984]],["limon-tv.org",152],["porno4you.org",152],["adiabet.ru",152],["astrosfera.ru",152],["modewomen.ru",152],["moviki.ru",[152,3583]],["primenimudrost.ru",152],["relasko.ru",[152,4001]],["sexytales.ru",[152,1025]],["sportobzor.ru",[152,4226]],["superhumor.ru",[152,462,1148]],["edufuture.biz",153],["xvatit.com",[153,653,1185]],["trupornolabs.org",[153,284,562,1094,2231]],["xxxadulttorrent.org",[153,562]],["popgun.ru",153],["naruto-base.tv",[153,4810]],["fileclub.biz",154],["nemezisworld.com",154],["sharij.net",[154,1941]],["odessa.online",154],["ferrum-body.ru",154],["ridus.ru",[154,4017]],["fsell.biz",155],["hd-720.biz",[156,157]],["bigpovar.com",157],["menquestions.ru",[157,231,3510]],["promtu.ru",[157,872,1459,3913]],["hdkino.biz",[158,159]],["vsofte.biz",[158,189]],["nowa.cc",[158,360,361]],["zserials.cc",[158,284,370,371,372]],["androidsmartfony.com",158],["spam-club.blogspot.com",[158,523]],["disgustingmen.com",[158,475,571]],["ilenta.com",[158,284,607,705,706]],["javadevblog.com",158],["pesni-tut.com",[158,284,909]],["raskraska.com",[158,974]],["relizua.com",158],["softikbox.com",158],["torrent-igri.com",158],["udaff.com",[158,562,1114]],["aces.gg",[158,1282]],["7days2die.info",[158,739,1311]],["for-ua.info",[158,284,936,1351,1352]],["skachat-igri-besplatno.info",[158,284]],["ebanoe.it",[158,387,1482]],["4k-kino.net",158],["7torrents.net",[158,1094]],["audioskazki.net",158],["ex-fs.net",[158,1759]],["igri-torrent.net",158],["newrutor.net",158],["serialpro.net",158],["sewin.net",[158,1939]],["torrent-besplatno.net",158],["torrent-club.net",158],["torrents-game.net",158],["3torrent.org",158],["kinoplace.org",158],["mixsoft.org",[158,372]],["studopedia.org",[158,1437,1953]],["geekteam.pro",[158,1459]],["4allwomen.ru",[158,569]],["a-age.ru",158],["aacalc.ru",[158,284,2377,2378]],["app2top.ru",[158,212,284,2483]],["arsenaltula.ru",[158,212]],["spam-club.blogspot.ru",[158,523]],["cheb.ru",[158,475,2396,2685,2686,2687,2688]],["chepetsk.ru",[158,2695]],["f-igri.ru",[158,380,2916]],["farap.ru",158],["game-pool.ru",158],["games--torrent.ru",158],["gtp-tabs.ru",[158,3098]],["igryday.ru",[158,1965]],["kinonews.ru",[158,326,1375,3290]],["kinotorka.ru",158],["kontrolnaya-rabota.ru",[158,284]],["microstock.ru",158],["mobiltelefon.ru",[158,475,3555]],["noob-club.ru",[158,205,1094,2378,3691]],["office-guru.ru",[158,3729]],["onlinemultfilmy.ru",[158,3750]],["osobye.ru",[158,3775]],["prosadiogorod.ru",[158,466,3920]],["ra1ohx.ru",158],["radiopotok.ru",[158,3960]],["rusbitor.ru",158],["sbornik-music.ru",[158,4086]],["softbaze.ru",158],["superg.ru",158],["torrentrepack.ru",158],["tuchkatv.ru",[158,4394]],["vashipitomcy.ru",158],["winxland.ru",[158,4562]],["yaminecraft.ru",[158,4608]],["youhack.ru",[158,4623]],["zoneofgames.ru",[158,284,4659,4660]],["kritka.su",[158,284,371,1094,4715]],["tankist.su",158],["avtovod.com.ua",[158,4907]],["filmasik.com.ua",[158,4929]],["kino-teatr.ua",[158,5120]],["cheboksary.ws",[158,475,2685,2686]],["lostfilm.hdkino.biz",160],["in-trend.biz",161],["kichkas.biz",162],["kino-live8.biz",163],["kino-live2.org",163],["kinogo.biz",164],["oka.fm",[164,1252]],["sms24.info",[164,300]],["sms24.me",[164,300]],["fonzo.ru",[164,356]],["hemingway-lib.ru",164],["sex-empire.tv",[164,4832]],["ternopoliany.te.ua",[164,1678]],["kodik.biz",165],["kodik.cc",165],["aniqit.com",165],["kodikdb.com",165],["kodik.info",[165,1377]],["manga-online.biz",166],["mozaika.biz",167],["mp3iq.comz",169],["mp3sort.biz",171],["best-soft.npps.biz",172],["openssource.biz",[173,174,175]],["openssource.info",[174,1407]],["hosting.cafe",[175,348]],["buhgalter911.com",[175,537,538,539]],["domohozayki.com",175],["elementarno-tv.com",175],["electricalschool.info",[175,1342]],["uvelir.info",[175,1453]],["alltor.me",[175,1606]],["backup.menu",[175,348]],["dedicated.menu",[175,348]],["https.menu",[175,348]],["license.menu",[175,348]],["shared.menu",[175,348]],["vds.menu",[175,348]],["beremennost.net",[175,711,1721]],["uvelir.net",175],["vorozheya.org",175],["kopilkaurokov.ru",175],["multiurok.ru",[175,3597]],["ogribax.ru",[175,209,3732]],["palantinbest.ru",[175,3788]],["www.pesticidy.ru",[175,326,3811]],["php.ru",[175,3820]],["parnuxi.biz",176],["pornolab.biz",[177,178]],["pornolab.cc",[177,178]],["pornolab.lib",[177,178]],["pornolab.net",[177,178]],["tamboff.ru",[177,4292]],["livetv.sx",[177,4741]],["pornorip.biz",179],["psihologia.biz",[180,181]],["sci-lib.biz",181],["economuch.com",181],["uchebnikfree.com",181],["xn--80aaivjfyj3e.com",181],["sci.house",181],["medinfo.live",181],["all-sci.net",181],["finbook.news",181],["lawbooks.news",181],["provse.news",181],["lawbook.online",181],["scicenter.online",181],["myzooplanet.ru",[181,1575]],["lib.sale",181],["bib.social",181],["economics.studio",181],["pravo.studio",181],["textbooks.studio",181],["ruporus.biz",182],["ruporus.cc",182],["ruporus.com",182],["ruporus.net",182],["porus.ru",182],["ruporus.top",182],["ruporus.tv",182],["ruporus.xyz",182],["sakhalin.biz",183],["slivup.biz",184],["sport7.biz",[185,186]],["sportbar.biz",[185,186]],["barsportbar.com",185],["s7yours.com",185],["sbautumn.com",185],["sportabar01.com",[185,491]],["sportbarchik88.com",[185,186]],["sporting77.com",[185,186]],["sportsite777.com",[185,491]],["channels247.net",[185,186]],["spotless365.net",185],["goool7.ws",[185,186]],["terabit.biz",187],["ua-ix.biz",188],["yougame.biz",190],["zerocoolpro.biz",[191,192,193,194]],["beliyspisok.ru",[192,2577]],["clubvolvo.ru",[192,231]],["forum-volgograd.ru",[192,2981]],["rusfishing.ru",192],["termoportal.ru",[192,193]],["ifud.ws",192],["cnc3018.ru",[193,2723]],["krisha.kz",194],["zismo.biz",195],["clickthis.blog",[196,197]],["tut.by",[196,295,303,312,313]],["agravery.com",196],["filehippo.com",196],["obsuzhday.com",[196,887]],["prostopleer.com",[196,964]],["sprashivalka.com",[196,1059]],["ukranews.com",[196,394,607,1116,1117]],["inform-ua.info",[196,380]],["kinda.media",[196,487]],["dumskaya.net",[196,1754]],["liga.net",[196,363,1826]],["babla.ru",[196,2555]],["geekmir.ru",[196,380]],["ifun.ru",196],["klops.ru",[196,231,3306]],["mmovote.ru",196],["myshared.ru",[196,3617]],["primpogoda.ru",[196,906,3892]],["regmarkets.ru",[196,1060,3999]],["riavrn.ru",196],["vogue.ru",196],["vz.ru",[196,218,4533]],["zaks.ru",[196,218]],["lookmeet.tv",196],["pik.net.ua",[196,5156]],["vgolos.ua",196],["cont.ws",[196,259,5277]],["levik.blog",198],["lena-miro.ru",198],["olegmakarenko.ru",198],["shakko.ru",198],["shiro-kino.ru",198],["vadimrazumov.ru",198],["periskop.su",198],["ain.business",[199,200]],["ain.ua",[200,284,4867]],["by",201],["ampercar.com",[203,284]],["kakbog.com",[203,745]],["o-polze.com",[203,882]],["hersonweek.net",[203,1789]],["bolshoyulov.ru",[203,465,2618]],["femmie.ru",[203,2933]],["fuzzmusic.ru",203],["gadgets-help.ru",203],["kovi.ru",[203,3328]],["pcminipro.ru",[203,1352]],["poravkrym.ru",[203,2747]],["villaved.ru",[203,465,4491]],["autogeek.com.ua",[203,284,306,1326,4906]],["itbusiness.com.ua",[203,4652]],["itsider.com.ua",[203,1192]],["vsviti.com.ua",[203,5020]],["mmr.net.ua",[203,1192]],["agropolit.com",[204,211,457]],["kp.ua",204],["av.by",[205,213]],["belkagomel.by",[205,220]],["realt.by",[205,298]],["politrussia.com",[205,938]],["vsezdorovo.com",[205,1162]],["mel.fm",[205,1249]],["nsn.fm",[205,218]],["atas.info",205],["nakhodka.media",[205,1442,1443]],["stavropol.media",[205,1442,1443]],["kaifolog.net",205],["politnavigator.net",[205,1900]],["sovets.net",[205,231,454,1145,1947,1948,1949]],["zaycev.net",[205,218,2013]],["readovka.news",[205,2033]],["actualnews.org",[205,2076]],["1istochnik.ru",[205,2313]],["7days.ru",[205,2369]],["amurmedia.ru",[205,1442,1443]],["auto.ru",[205,2518]],["autosaratov.ru",205],["baby.ru",[205,2037,2556]],["bidbaits.ru",[205,2590]],["chukotkamedia.ru",[205,1442,1443]],["autosport.com.ru",[205,2732]],["cq.ru",[205,2750]],["ctc.ru",[205,2196,2763]],["deita.ru",[205,2785]],["domclick.ru",205],["eaomedia.ru",[205,1442,1443]],["eva.ru",[205,2907]],["finam.ru",[205,2941]],["fontanka.ru",[205,218,1556,2297,2298,2300,2969]],["friday.ru",[205,3000]],["interface31.ru",205],["irkutskmedia.ru",[205,1442,1443]],["izhlife.ru",[205,2936]],["kamchatkamedia.ru",[205,1442,1443]],["www.kolesa.ru",205],["krasnoyarskmedia.ru",[205,1442,1443]],["lipetskmedia.ru",[205,231,680]],["magadanmedia.ru",[205,1442,1443]],["nashe.ru",[205,3640]],["new-magazine.ru",[205,218,3658]],["om1.ru",[205,3737]],["priamurmedia.ru",[205,1442,1443]],["primamedia.ru",[205,1442,1443]],["prufy.ru",205],["radiojazzfm.ru",[205,3640,3957]],["radioultra.ru",[205,3640]],["rockfm.ru",[205,3640]],["sakhalinmedia.ru",[205,1442,1443]],["sevastopolmedia.ru",[205,1442,1443]],["smotrim.ru",[205,4164]],["sovets24.ru",[205,231,1145,1947]],["sravni.ru",[205,4236]],["starhit.ru",[205,2294,2818,3933,4244,4245]],["svpressa.ru",[205,4277]],["takiedela.ru",205],["teleport2001.ru",[205,1357,4311,4312]],["topnews.ru",205],["tverigrad.ru",[205,4412]],["ulanmedia.ru",[205,1442,1443]],["ussurmedia.ru",[205,1442,1443]],["womanhit.ru",[205,231,4568]],["yakutiamedia.ru",[205,1442,1443]],["ytronews.ru",[205,218]],["chitamedia.su",[205,1442,1443]],["krasnodarmedia.su",[205,1442,1443]],["neva.today",[205,2648,4758]],["tv2.today",[205,4760]],["103.by",206],["2gis.by",207],["2gis.kz",207],["2gis.ru",[207,2331]],["4esnok.by",[208,209]],["korabelov.info",[208,1379]],["agrimpasa.com",209],["erokomiksi.com",209],["golbis.com",[209,673]],["golovnie-boli.com",209],["hyperione.com",[209,697,698,699]],["inforpost.com",[209,717]],["kopomko.com",209],["kulemet.com",[209,306]],["macosinfo.com",209],["nagadala.com",[209,851]],["snelwilcox.com",209],["chirik.info",209],["hronika.info",209],["miformat.info",[209,1388]],["ruslo.info",209],["mezha.media",[209,212,284,306,478,1369,1668,1669]],["alkogolu.net",[209,465,543]],["meganovosti.net",209],["ru-mir.net",209],["udobreniya.net",209],["calend.online",209],["bizua.org",[209,684,2105]],["1000iodinsovet.ru",209],["2info2.ru",209],["atlasprirodirossii.ru",[209,699]],["belattra.ru",209],["boxvideotv.ru",209],["brunet-ka.ru",[209,2638]],["cherepah.ru",209],["clubwindows.ru",209],["domashnie-zagotovki.ru",[209,2827]],["domashniecvety.ru",209],["excelprost.ru",209],["giantessa.ru",[209,3043]],["hitagro.ru",[209,3129]],["htmlhook.ru",[209,3147]],["koroleffsov.ru",209],["krashevseh.ru",[209,1369]],["legkopolezno.ru",[209,225,3358]],["makeupkey.ru",[209,1232]],["nash-sekret.ru",209],["newsrank.ru",209],["northern-newspaper.ru",[209,3692]],["ofigeno.ru",209],["ovetryanke.ru",209],["paratechnik.ru",209],["podruzke.ru",[209,2105]],["portable-rus.ru",209],["portalvirtualreality.ru",[209,3867]],["prostolinux.ru",[209,3922]],["putin-today.ru",209],["pzik.ru",209],["rainbowsky.ru",[209,3966]],["sci-fi-news.ru",[209,4090]],["srnsk.ru",209],["strana-it.ru",209],["svoitabachok.ru",209],["trmzk.ru",209],["ustanovkaos.ru",[209,380,4450]],["ventilationpro.ru",209],["walaw.ru",209],["yconsult.ru",[209,4617]],["chudesniesovetiki.site",209],["lightstories.site",209],["free-news.su",209],["geomedia.top",209],["mamabook.com.ua",[209,4963]],["newssky.com.ua",209],["zdorovia.com.ua",209],["poleznaya.dp.ua",209],["roza2012.net.ua",209],["galas.te.ua",[209,593]],["sich.zp.ua",209],["podarok.video",209],["abw.by",[210,211,212]],["tv.yandex.by",[211,342,343]],["elevatorist.com",[211,589]],["filmozavr.com",[211,619,620]],["latifundist.com",[211,775]],["psm7.com",[211,231,284,966]],["superagronom.com",211],["zemliak.com",[211,1197]],["tv.yandex.kz",[211,342,343]],["myshows.me",[211,326,811,1627]],["old.myshows.me",[211,1628]],["filmozavr.net",[211,619,620]],["lada-granta.net",[211,1822]],["gotennis.ru",[211,3085]],["inoprosport.ru",[211,3193]],["kinopati.ru",[211,3291]],["lkforum.ru",[211,1822]],["osp.ru",[211,475]],["podfm.ru",211],["popcornnews.ru",[211,3860]],["tv.yandex.ru",[211,342,343]],["overclockers.ua",[211,5192]],["tv.yandex.uz",[211,342,343]],["smartpress.by",[212,305]],["vandrouki.by",212],["vgr.by",[212,322]],["astar.bz",[212,344]],["cy-pr.com",[212,564]],["nachasi.com",212],["sovetromantica.com",[212,1049]],["tribuna.com",[212,284,1097]],["tt-cup.com",212],["yaplakal.com",[212,1188]],["solncevo.info",[212,363,1436]],["tayga.info",[212,454,1442,1443]],["proglib.io",212],["point.md",[212,551,1599,1600]],["spafilms.me",[212,1648]],["shkole.net",212],["allbasketball.org",[212,607,2081]],["animaunt.org",[212,2088]],["anistar.org",[212,344]],["online-star.org",[212,344]],["online-stars.org",[212,344]],["junona.pro",212],["1snau.ru",[212,717,2318]],["7dach.ru",[212,854,2368]],["aqua-therm.ru",[212,2489]],["autoreview.ru",212],["bez-smenki.ru",[212,2586]],["darkermagazine.ru",212],["euro-football.ru",[212,454,1584,2901,2902,2903,2904]],["festima.ru",[212,551]],["www.film.ru",[212,390,2939]],["gdz.ru",[212,395,3041]],["glavagronom.ru",[212,225,3056,3057]],["glavpahar.ru",212],["www.khl.ru",212],["lgoty-vsem.ru",[212,3366]],["liveresult.ru",[212,1584,2904,3395]],["med2.ru",[212,3486]],["meteo-tv.ru",[212,216]],["nim.ru",212],["orelgrad.ru",212],["playground.ru",[212,3832]],["playmaker24.ru",[212,3833]],["pr-cy.ru",[212,3881]],["russorosso.ru",212],["silver.ru",[212,3282,4139]],["news.sportbox.ru",[212,215,1726,4221]],["sportsdaily.ru",[212,218,1485,4231]],["stratege.ru",[212,4258]],["tvmag.ru",[212,4418,4419]],["vc.ru",[212,284,412,1403,2853,4467]],["vjazhi.ru",[212,1889,3072,4497]],["vmgu.ru",[212,4506]],["forum.watch.ru",[212,4536]],["yap.ru",[212,1188,4613]],["www.zoneofgames.ru",[212,1094,1697,4662]],["topvideo.tj",[212,231,284,562,4748]],["4pda.to",[212,286,4751]],["animedia.tv",[212,821]],["1news.com.ua",[212,685,4892]],["gnatkovsky.com.ua",[212,4936]],["grippua.com.ua",[212,4938]],["gsminfo.com.ua",212],["uoor.com.ua",212],["volnorez.com.ua",[212,5017]],["informator.ua",[212,5101]],["landlord.ua",[212,5129]],["sostav.ua",212],["gazeta.uz",[212,5257]],["www.aviasales.by",214],["www.aviasales.kg",214],["www.aviasales.kz",214],["www.aviasales.md",214],["www.aviasales.ru",214],["www.aviasales.ua",214],["www.aviasales.uz",214],["banana.by",[215,216]],["football24.ru",[215,216,847,2974]],["bigmir.net",[216,246,1723,1724,1725]],["inedelya.ru",216],["maulnet.ru",[216,3474]],["tourdom.ru",[216,2171]],["cntime.cn.ua",216],["vse-sto.com.ua",216],["bdg.by",217],["belarus-news.by",218],["fonmod.com",218],["ixbt.com",[218,607,729,730,731,732]],["utyug.info",218],["ladys.media",218],["regnum.news",[218,2034]],["teleprogramma.pro",[218,2275,2276]],["360tv.ru",[218,2343]],["avtonovostidnya.ru",[218,2542,2543]],["avtovzglyad.ru",[218,620,2549,2550]],["bst.bratsk.ru",[218,2635]],["coop-land.ru",[218,2744]],["energyfm.ru",[218,286,2544,2889]],["finuslugi.ru",218],["gdeichto.ru",[218,2542]],["kommersant.ru",[218,3317]],["life.ru",[218,811]],["metronews.ru",[218,3518]],["moe-belgorod.ru",[218,3563,3564]],["moe-kursk.ru",[218,3563,3564]],["moe-lipetsk.ru",[218,3563,3564]],["moe-online.ru",[218,3563,3564]],["moe-tambov.ru",[218,3563,3564]],["mydecor.ru",[218,2818,3607]],["mywebpc.ru",[218,412,3622]],["naked-science.ru",[218,3630]],["ohotniki.ru",[218,3733]],["overclockers.ru",[218,3783]],["peterburg2.ru",[218,391,3812]],["pnz.ru",[218,932]],["regnum.ru",[218,2034]],["rifey.ru",[218,4018]],["rutube.ru",[218,4066]],["super.ru",[218,4270]],["thegirl.ru",[218,2818]],["tvzvezda.ru",[218,231,4424]],["u-f.ru",[218,4427]],["xn----7sbabwosghnf8al4lkj7b.xn--p1ai",[218,4285]],["belaruspartisan.by",219],["belta.by",[222,223]],["dailystorm.ru",223],["doctorpiter.ru",[223,2818]],["kakprosto.ru",223],["marieclaire.ru",[223,2818]],["maximonline.ru",[223,475,2818,3477,3478]],["newxboxone.ru",[223,535,3675]],["parents.ru",[223,2818,3477,3791]],["psychologies.ru",[223,2818,3932,3933]],["tvtver.ru",[223,1949,4414,4423]],["wday.ru",[223,2818,3477,3791,4537]],["blisch.by",[224,225]],["gomel-sat.bz",225],["alcogolizm.com",[225,464,465,466,467]],["zhacker.net",[225,2014]],["maw.ru",[225,3475]],["ozersk74.ru",[225,3785]],["threatpost.ru",225],["2ip.ua",[225,1604,4862]],["agro-business.com.ua",[225,4897,4898]],["agronomy.com.ua",[225,4898,4900]],["uamotors.com.ua",[225,726]],["yaizakon.com.ua",[225,5022]],["bobr.by",226],["buhonline.ru",[226,2643]],["zakon.ru",[226,4637]],["bycard.by",[228,229]],["satsis.info",[228,1428]],["allinfo.kz",228],["kimo.ma",228],["swordmaster.org",[228,917]],["leroymerlin-jeb.ru",228],["old-games.ru",[228,3736]],["citydog.by",[230,231]],["chytomo.com",[231,553]],["crazymailing.com",231],["internetua.com",231],["kamchatinfo.com",[231,746]],["kerchinfo.com",231],["kino-kingdom.com",[231,752]],["kyiv-independent.com",231],["mobile-review.com",[231,803,836]],["onlineradiobox.com",231],["the-village-kz.com",[231,1082]],["turkmenportal.com",231],["yarik-sat.com",[231,1190]],["zerno-ua.com",[231,1198]],["dnepr.info",[231,1336]],["ponedelnik.info",231],["zhitomir.info",[231,478]],["999.md",[231,1592,1593]],["the-village.me",[231,1082]],["kluch.media",[231,463,590,1664]],["khersonline.net",231],["postovoy.net",231],["studfile.net",231],["studfiles.net",231],["yarnews.net",[231,2007]],["botinok.porn",231],["46tv.ru",231],["aldebaran.ru",[231,2409]],["asiarussia.ru",231],["bezparazita.ru",[231,466]],["bountymax.ru",231],["buzulukday.ru",[231,2652,2653]],["calend.ru",[231,2664]],["dom2stars.ru",231],["dota2.ru",[231,2838]],["gmod-fan.ru",[231,3062]],["gorod48.ru",[231,1042,3076]],["gtavicecity.ru",[231,308,3097]],["kvnews.ru",[231,3349]],["manga24.ru",231],["mashintop.ru",231],["mediaryazan.ru",[231,1042,3491]],["modernrock.ru",231],["moya-semya.ru",231],["musicforums.ru",231],["nlo-mir.ru",231],["novostroev.ru",[231,3703]],["nsday.ru",[231,2652,2653]],["ntr-24.ru",[231,3709,3710]],["nversia.ru",231],["orenday.ru",[231,2652,2653]],["perevolockday.ru",[231,2652,2653]],["pln-pskov.ru",[231,3838]],["ppt.ru",[231,3878]],["rtraveler.ru",[231,4038]],["saltday.ru",[231,2652,2653]],["sorochinskday.ru",[231,2652,2653]],["spark.ru",231],["subscribe.ru",[231,4265]],["the-village.ru",[231,1082,4324]],["tltonline.ru",[231,4343]],["trisosny.ru",[231,4392]],["trymobile.ru",231],["ukrinform.ru",231],["vdvsn.ru",231],["vorle.ru",[231,391]],["wincore.ru",[231,4557]],["worldofmods.ru",231],["zoon.ru",[231,4664]],["vse.sale",231],["vklybe.tv",231],["village.com.ua",[231,1082]],["hochu.ua",231],["telegraf.in.ua",[231,391,1550,5096]],["torrents.in.ua",[231,5097]],["nv.ua",[231,4923,5164]],["zn.ua",[231,2062,5200,5250]],["xn----7sbabrtfclecozdeg8b6a.xn--p1ai",231],["domovita.by",232],["dzr.by",233],["egida.by",234],["eplus.by",235],["ex-press.by",236],["football.by",[237,238]],["fanday.net",[238,1760]],["gismeteo.by",[239,240,241,242,243]],["galnet.fm",239],["gismeteo.kz",[239,241,242,1510]],["meteofor.md",239],["www.ukr.net",[239,1974,1975]],["gismeteo.ru",[239,241,243,342,475,1510,3047]],["spletnik.ru",[239,326,4213]],["meteofor.com.ua",[242,4965]],["google.by",244],["google.com",244],["google.kz",244],["google.ru",244],["google.com.ua",244],["open.ua",245],["bmwclub.ru",[246,2615]],["chemezova.ru",[246,380]],["vd-tv.ru",[246,4468]],["rada.com.ua",246],["mport.ua",[246,1724,1727,5148]],["grodnonews.by",[247,248]],["twogarin.info",[247,1445,1446]],["censor.net",[247,1730,1731,1732]],["mos.news",[247,1042,2027]],["siteua.org",[247,2217]],["nsnet.ru",247],["vesti42.ru",[247,4481]],["highload.today",[247,1752,2380,4756]],["mc.today",[247,1678,4756,4757]],["itc.ua",[247,1678,1752,4756,4757,5104]],["hata.by",249],["hdd.by",250],["irr.by",[252,253,254]],["irr.ru",[252,2196,3216]],["securitylab.ru",[253,1042,1259]],["kaktutzhit.by",[255,256]],["nashvancouver.com",[255,857]],["koko.by",257],["komplat.by",258],["kraj.by",259],["allapteki.ru",[259,2418]],["profile.ru",[259,3903,3904]],["kufar.by",260],["auto.kufar.by",261],["re.kufar.by",262],["kv.by",263],["last.by",264],["ma.by",266],["mebelminsk.by",[267,268]],["nashbryansk.ru",268],["mediabrest.by",269],["nyagan.life",269],["vuralsk.life",269],["cher-poisk.ru",269],["govoritsatka.ru",269],["govorituzhnik.ru",269],["kaluga-poisk.ru",269],["koryazhma-poisk.ru",269],["nur24.ru",269],["vologda-poisk.ru",269],["yasniy-city.ru",269],["yola-poisk.ru",269],["meteo.by",270],["minsknews.by",271],["mlyn.by",272],["moyareklama.by",273],["moyareklama.ru",273],["mycity.by",274],["apteka.ru",[274,2487]],["forum.krasmama.ru",[274,3331]],["myfin.by",[275,276]],["myjob.by",277],["n1.by",278],["nb.by",279],["neg.by",280],["nn.by",281],["onliner.by",[282,283,284]],["auto.onliner.by",283],["fisher.spb.ru",[283,4205]],["bib.bz",284],["img2txt.com",[284,709]],["kurkul.com",[284,771]],["modsfire.com",284],["onlinevideoconverter.com",284],["zbirna.com",[284,1196]],["liveball7.gq",284],["arminfo.info",[284,291,1317]],["soft-windows.info",284],["windows-soft.info",284],["goal24.live",[284,1581]],["liveball8.ml",284],["real-game.net",284],["torrent-shyter.net",284],["ua.news",[284,1678]],["photoshop-besplatno.org",[284,2189]],["rutracker-2017.org",284],["z-music.org",[284,2251]],["korsars.pro",[284,412]],["blizzardheroes.ru",[284,2611]],["csgo-guides.ru",284],["games-vam.ru",284],["stopgame.ru",[284,4254]],["vgtimes.ru",[284,4486]],["daxshat.site",[284,4676]],["newstudio.tv",[284,4811]],["varta1.com.ua",[284,593]],["xn--80ac9aeh6f.xn--p1ai",284],["baraholka.onliner.by",[285,286]],["1tv.ru",[286,326,2196,2320]],["artem-kashkanov.ru",286],["astrakhan-24.ru",[286,2508]],["galya.ru",[286,3012]],["gotovim-doma.ru",[286,2141,3087]],["qip.ru",[286,3942]],["vputilkovo.ru",[286,4518]],["catalog.onliner.by",287],["www.onliner.by",288],["ont.by",289],["para.by",290],["pogoda.by",[291,292]],["poligon.by",293],["pressball.by",294],["probusiness.by",295],["pronetblog.by",296],["rcity.by",297],["reshu.by",299],["sdamgia.ru",[299,4093]],["finget.ru",[300,594,2945]],["katalog-aktsii.ru",300],["vikings-warofclans.ru",300],["samsebeyurist.by",301],["second.by",[302,303]],["select.by",304],["sn.by",306],["hronikers.com",306],["politarena.online",306],["pclegko.ru",306],["expert.com.ua",306],["volyninfa.com.ua",[306,5019]],["gk-press.if.ua",[306,5080]],["svoboda.te.ua",[306,1693]],["inform.zp.ua",[306,5253]],["forexsystemsru.com",[308,620,633]],["24dom.info",[308,1309]],["omskregion.info",[308,1404,1405,1406]],["softbesplatno.net",[308,847,1944]],["profi-forex.org",[308,2197,2198]],["32cars.ru",308],["marpravda.ru",[308,3462]],["planetaseminarov.ru",308],["smoldaily.ru",308],["vl.ru",[308,2198,2850,2961,4501]],["wordpressinside.ru",[308,4571]],["znamyuzl.ru",[308,2156,4656]],["tods-blog.com.ua",[308,5004]],["tabletka.by",309],["talks.by",310],["transinfo.by",311],["nevasport.ru",[313,1593,3567,3656]],["gx.net.ua",313],["afisha.tut.by",314],["finance.tut.by",315],["pogoda.tut.by",316],["search.tut.by",[317,318]],["rep.ru",[317,4004]],["sport.tut.by",319],["www.tut.by",320],["velvet.by",321],["volkovysk.by",323],["businessman.ru",[323,2648,2649]],["syl.ru",[323,2648,4279]],["vrgames.by",324],["vseprosport.by",325],["vseprosport.kz",325],["vseprosport.ru",325],["vse-pro-sport.com.ua",325],["yandex.by",[326,327,328,329,330]],["kinorium.com",326],["yandex.kz",[326,327,328,329,330]],["drive.ru",[326,2845]],["film.ru",326],["gamemag.ru",[326,3018]],["onlinestreams.ru",[326,3752]],["pikabu.ru",[326,3824]],["pluggedin.ru",[326,380,3840]],["trinixy.ru",[326,4389]],["yandex.ru",[326,327,328,330,4609,4610]],["yandex.uz",[326,327,328,329,330]],["ya.ru",[328,329,330,4597]],["dzen.ru",[330,787,1974,2858,2859,2860]],["afisha.yandex.by",331],["afisha.yandex.kz",331],["afisha.yandex.ru",331],["afisha.yandex.uz",331],["disk.yandex.by",[332,333]],["disk.yandex.kz",[332,333]],["disk.yandex.ru",[332,333]],["disk.yandex.uz",[332,333]],["disk.yandex.com",333],["docviewer.yandex.by",334],["docviewer.yandex.kz",334],["docviewer.yandex.ru",334],["docviewer.yandex.uz",334],["mail.yandex.by",335],["mail.yandex.com",335],["mail.yandex.kz",335],["mail.yandex.ru",335],["mail.yandex.uz",335],["market.yandex.by",336],["market.yandex.kz",336],["market.yandex.ru",336],["music.yandex.by",337],["music.yandex.kz",337],["music.yandex.ru",337],["music.yandex.uz",337],["radio.yandex.by",[338,339]],["radio.yandex.kz",[338,339]],["radio.yandex.ru",[338,339]],["radio.yandex.uz",338],["rasp.yandex.by",340],["rasp.yandex.kz",340],["rasp.yandex.ru",340],["rasp.yandex.uz",340],["translate.yandex.by",341],["translate.yandex.kz",341],["translate.yandex.ru",341],["translate.yandex.uz",341],["wtftime.ru",[342,4582]],["aviso.bz",345],["center.bz",346],["kinokong.bz",347],["alexfilm.cc",349],["animeonline.cc",350],["apparat.cc",351],["euro2016.cc",352],["freehat.cc",353],["hdkinomir.cc",354],["joyreactor.cc",355],["kape.cc",356],["kinogoo.cc",357],["liveball.cc",358],["liveball.uno",358],["muzmo.cc",359],["rf-cheats.ru",[360,4010]],["nulled.cc",362],["pornolenta.cc",363],["1743.ru",[363,2307]],["k-ur.ru",363],["ntsk.ru",[363,2307,3711]],["orki.ru",[363,2307,3769]],["orsk.ru",[363,2307]],["bashinform.rugameportalrf.ru",363],["smotra.ru",363],["gts.tv",[363,2307]],["online.ua",363],["kinoprofi.vip",[363,2019,5269]],["pornreactor.cc",364],["fapreactor.com",364],["sefon.cc",365],["toples.cc",366],["turbobits.cc",367],["tourbobit.com",367],["turbobif.com",367],["turboobit.com",367],["tourbobit.net",367],["turbobeet.net",367],["turbobit.net",367],["turbobita.net",367],["turbobits.net",367],["turbobi.pw",367],["utorr.cc",368],["filmitorrent.net",368],["gg.xooxo.cc",369],["sportlive365.net",372],["zfilm-hd.org",372],["zfilme-hd1.site",372],["soccer24.top",372],["usgang.ch",373],["vipleague.ch",374],["strikeout.co",[374,429]],["vipleague.co",[374,429]],["vipleague.is",[374,429]],["vipleague.me",374],["homerun.re",374],["vipbox.sx",[374,429]],["zamunda.ch",375],["zamunda.net",375],["baltanews.city",376],["barnews.city",376],["bilopillia.city",376],["bilyayivka.city",376],["chernihiv.city",376],["chortkiv.city",376],["dobronews.city",376],["drohobych.city",376],["energodar.city",376],["fastivnews.city",376],["gylyajpole.city",376],["hadiach.city",376],["haisyn.city",376],["horodok.city",376],["kagarlyk.city",376],["kalushnews.city",376],["kalynivka.city",376],["kavun.city",376],["kitsman.city",376],["konotop.city",376],["kremenets.city",376],["kuma.city",376],["lozova.city",376],["mltpl.city",376],["netishyn.city",376],["nikopol.city",376],["nizhyn.city",376],["novakahovka.city",376],["novograd.city",376],["nsirogozy.city",376],["oretsk.city",376],["pereiaslav.city",376],["petropavlivka.city",376],["popasnaya.city",376],["primorka.city",376],["rakhiv.city",376],["sarnynews.city",376],["shostkanews.city",376],["skadovsk.city",376],["slavuta.city",376],["starkon.city",376],["susidy.city",376],["svatove.city",376],["thegard.city",376],["tira.city",376],["toretsk.city",376],["troyitske.city",376],["volnovakha.city",376],["volodymyrets.city",[376,381]],["yuzhkanews.city",376],["zhmerynka.city",376],["zoloto.city",376],["izmacity.com",[376,739]],["priluki.city",377],["prk.city",378],["technical.city",[379,380]],["tivix.co",[380,430]],["5terka.com",[380,448]],["alive-ua.com",[380,468]],["gazetaby.com",[380,656]],["newsgsm.com",[380,847,862]],["repack-fitgirl.com",380],["rpgdon.com",380],["shkolniku.com",380],["tuttop.com",380],["uaspectr.com",[380,1111]],["gazetaby.info",[380,656]],["kp.kg",[380,1486,1487]],["kp.kz",[380,1486,1487]],["kp.md",[380,1486,1487]],["parazit24.me",380],["gazetaby.media",[380,656]],["igui.mobi",[380,1687]],["outsidethebox.ms",380],["uanic.name",380],["etotop.net",[380,1758]],["jut-su.net",[380,1799]],["ladylib.net",[380,1823]],["yamdex.net",380],["volga.news",[380,2040]],["multfilms.online",380],["anirem.org",[380,2091]],["ok-tv.org",[380,2185]],["only-tv.org",380],["simhost.org",[380,2215]],["tv-only.org",380],["vsetop.org",[380,2242]],["torrent-games.rip",380],["2x2forum.ru",380],["animemobi.ru",[380,2464]],["ap22.ru",[380,2474]],["app-time.ru",[380,2482]],["appsgames.ru",380],["atlantisfood.ru",380],["big-anime.ru",[380,2591]],["bik-info.ru",380],["cheatground.ru",[380,2684]],["chelnyagro.ru",380],["cknow.ru",380],["click-or-die.ru",[380,2715]],["ecofoodferma.ru",380],["elektrosat.ru",380],["etika-education.ru",380],["gamelendi.ru",380],["gameout.ru",[380,697]],["igra-wow.ru",[380,3159]],["instrument16.ru",380],["klub-masterov.ru",380],["kp.ru",[380,1486,1487,3329]],["kritika24.ru",[380,3332]],["libking.ru",380],["mixbits.ru",380],["moy-instrument.ru",[380,1352]],["mrtranslate.ru",380],["ognennoetv.ru",380],["osortah.ru",380],["presentation-creation.ru",380],["privatbankrf.ru",380],["ravis-avto.ru",380],["remont-avtovaz.ru",380],["revelationonlinedb.ru",[380,4008]],["rutracker.ru",[380,4064,4065]],["samelectric.ru",[380,465,2402]],["selomoe.ru",380],["seloved.ru",380],["siddgames.ru",[380,4138]],["steampass.ru",[380,4248]],["stiralkainfo.ru",380],["tmbw.ru",[380,4344]],["topmmo-games.ru",[380,2097]],["torrent-games-2016.ru",380],["totori.ru",[380,4373]],["trackitonline.ru",[380,4378]],["tvoilokony.ru",380],["vizazh-2.ru",380],["zhaparova.ru",380],["algagroup.su",380],["mmorpg.su",[380,475,4720]],["smotret-fizruk-online.su",380],["vsetut.su",380],["gitjournal.tech",[380,906]],["hype.tech",[380,732]],["sonix.tk",380],["aniplay.tv",380],["hdclub.ua",[380,5068]],["pornoakt.click",382],["pornobomba.click",383],["p0sembed.com",383],["pornoklad.live",383],["pbembed.me",[383,1259]],["porn0sex.online",[383,2061]],["zrelki.click",384],["ebaland.net",384],["oxy.cloud",385],["timeweb.cloud",386],["100pdf.club",387],["avtotachki.com",[387,499]],["cryptodzen.com",387],["root-nation.com",[387,436,535,562,991,992]],["ternopillive.com",[387,726,1076,1077,1078]],["volyninfo.com",[387,594,1151]],["dacha.help",[387,1138]],["glavradio.info",387],["lhealth.info",387],["mi100.info",[387,1387]],["ua-report.info",[387,1448]],["analitikaua.net",[387,1448]],["aspekty.net",[387,1448]],["kazakh-zerno.net",[387,391,1232]],["netsofta.net",387],["simptomy-lechenie.net",387],["vgolove.net",387],["erokomiksi.org",387],["alladvices.ru",387],["amorefilms.ru",387],["borodina-protiv-buzovoj.ru",387],["cheb-live.ru",387],["dietdo.ru",[387,2450,2802]],["electric-220.ru",[387,465]],["flytothesky.ru",387],["gametrick.ru",387],["happymodern.ru",[387,3111]],["koskomp.ru",387],["m-zh.ru",387],["muwhi.ru",387],["psiholog4you.ru",387],["rubrowsers.ru",387],["sdelalremont.ru",[387,4095]],["tipsboard.ru",[387,4338]],["vizitnlo.ru",387],["vseiski.ru",387],["withcars.ru",387],["zelenj.ru",387],["pravda.cn.ua",[387,4890]],["4studio.com.ua",387],["auto-portal.com.ua",387],["gizchina.com.ua",387],["kyivvlada.com.ua",[387,4956,4957]],["new-s.com.ua",387],["smartmama.com.ua",[387,1213,4996,4997]],["wona.com.ua",387],["chas.cv.ua",[387,5025]],["ua-news.in.ua",[387,5099]],["golos.te.ua",[387,5188]],["1.zt.ua",[387,4957]],["forum.antichat.club",388],["brazzers-hdx.club",389],["doramy.club",390],["elek.club",391],["rogoff.club",[391,408]],["demotivation.me",[391,1616]],["apachan.net",391],["gameru.net",[391,1775]],["igrigo.net",[391,1792]],["repackov.net",[391,1918]],["rutab.net",[391,1933]],["amdm.ru",391],["amuzic.ru",391],["astromeridian.ru",[391,2512]],["centr-molodosti.ru",391],["documentalnye.ru",[391,2822]],["gossebanmen.ru",391],["hi-fi.ru",[391,463,885,1117,3124]],["miytvideo.ru",391],["nowfilms.ru",391],["oterraria.ru",[391,3777]],["story-house.ru",[391,3935]],["tourister.ru",[391,4374]],["hi-tech.ua",[391,5071]],["womo.ua",391],["filebase.ws",[391,4367,5279]],["fast-torrent.club",392],["nebeda.net",392],["fast-fiml.ru",392],["fast-torrent.ru",392],["filmpotok.ru",392],["kinomuch.ru",392],["pickfilm.ru",392],["veleto.ru",392],["vixim.ru",392],["fast-torrent.su",392],["fireman.club",[393,394]],["diary.ru",[394,764,854,2800]],["ku66.ru",[394,3337]],["prostoprosport.ru",394],["qrz.ru",[394,3945]],["track24.ru",394],["ufanet.ru",394],["pershij.com.ua",394],["gdzotputina.club",[395,396]],["gdzguru.com",[395,664,665]],["megaresheba.com",395],["reshebnik.com",[395,396,664,985]],["sumypost.com",395],["gdz.fm",395],["gdz-putina.fun",[395,1273]],["spishi.fun",[395,396]],["resheba.me",[395,1641]],["gdzputina.net",[395,396]],["zoobrilka.net",[395,396]],["gdz.ninja",[395,396]],["megaresheba.ru",[395,3505]],["stavcur.ru",[395,4247]],["xn--c1acj.xn--p1acf",395],["xn--c1acj.xn--p1ai",[395,5300]],["gtorrent.club",397],["gtorrent.ru",397],["happycoin.club",398],["in-english.club",399],["jutsu.club",400],["kinored.club",401],["musify.club",402],["myzuka.club",404],["onfillm.club",405],["onlinemix.club",406],["reallanguage.club",407],["satdx.club",409],["showfilm.club",410],["slitherio.club",411],["soft-portal.club",412],["flapler.com",412],["mods-game.net",412],["rufonts.ru",[412,4040]],["sverhestestvennoe.club",413],["svoimirykami.club",414],["videonews.club",415],["videozal.club",416],["xexe.club",417],["idwl.cn",418],["bomba.co",419],["grouple.co",[420,421]],["readmanga.io",[420,421]],["koro.life",420],["doramatv.live",[420,421,1580]],["selfmanga.live",[420,421]],["librebook.me",[420,421,1624]],["selflib.me",[420,421]],["doramatv.one",[420,421,1580]],["mintmanga.one",[420,421]],["usagi.one",[420,421]],["allhen.online",[420,421]],["findanime.ru",[420,421]],["mose.su",[420,421]],["ibb.co",422],["brclip.com",[422,531]],["frvid.com",[422,531]],["kzclip.com",[422,531]],["ru-clip.com",[422,531]],["ruclip.com",[422,531]],["thclips.com",[422,531]],["trvid.com",422],["uaclips.com",[422,531]],["kzblow.info",422],["ruburn.info",422],["trshow.info",422],["clip-share.net",[422,531]],["flash-player.net",[422,531]],["jpvid.net",422],["ru-clip.net",[422,531]],["vnclip.net",[422,531]],["infotime.co",[423,424]],["glavnoe.net",424],["kinofilm.co",425],["mp3co.co",426],["mp3no.com",426],["ofxme.co",427],["povar.co",428],["0tvet.com",431],["1001-dollar.com",432],["101xp.com",433],["10fastfingers.com",434],["1bigboss.com",435],["bigboss.video",435],["1informer.com",436],["fainaidea.com",[436,606]],["mediasat.info",[436,1386]],["itech.co.ua",436],["220vk.com",437],["alfa-form.ru",[437,2411]],["24kadra.com",438],["2proraba.com",439],["paperdoc.ru",439],["3dtuning.com",440],["4algeria.com",441],["forum.bestflowers.ru",441],["4creates.com",442],["4itaem.com",443],["4pna.com",[444,445]],["vbsupport.org",[444,2240]],["out-club.ru",444],["forum.print-forum.ru",444],["prioz.ru",444],["4rama.com",446],["5sfer.com",447],["6barrel.com",449],["samru.ru",[449,692]],["6sotok-dom.com",450],["subsidii.net",[450,773]],["ant-top.ru",[450,2468]],["abc-english-grammar.com",451],["abc-people.com",452],["adblock-tester.com",453],["checkadblock.ru",[453,2625]],["advizzer.com",454],["pogoda.com",[454,934]],["conversion.im",[454,1298]],["kramatorsk.info",[454,1380]],["uaprom.info",[454,1449,1450]],["ekaraganda.kz",[454,1508]],["lada.kz",454],["coollib.net",454],["musicmp3spb.org",454],["tparser.org",[454,1175]],["cataclysmdda.ru",454],["ereport.ru",454],["floraprice.ru",[454,2961]],["go64.ru",[454,680,3064]],["igrixl.ru",454],["kp40.ru",[454,3330]],["mirnov.ru",454],["musicwars.ru",454],["news29.ru",[454,3664,3665]],["ptzgovorit.ru",[454,3934]],["servers-samp.ru",454],["grinkod.spb.ru",[454,4207]],["vidal.ru",454],["mix.tj",[454,4743]],["sport.ua",[454,1157,5216,5217]],["agro-ukraine.com",455],["agronomu.com",456],["p-p.com.ua",[458,4977]],["agrostory.com",[460,461,462,463]],["perepostil.ru",460],["rabochy-put.ru",[460,1042]],["afisha.s13.ru",460],["sportmaps.ru",[460,562,4224]],["depo.ua",460],["drinks.ua",[460,5038]],["vikna.if.ua",[460,2547,5086]],["zi.ua",[460,463,680,5249]],["l2oops.com",[461,462]],["club.foto.ru",[461,462]],["wm-school.ru",[461,4563]],["acc.cv.ua",[461,462]],["l2anons.ws",[461,462]],["3vozrast.ru",462],["kanalukraina.tv",[462,4797]],["gubkinskiy.com",[463,680]],["mgazeta.com",[463,825,826]],["nmosktoday.com",[463,871]],["rugrad.eu",[463,1230]],["bits.media",[463,1661]],["officelife.media",[463,1670,1671]],["37.ru",[463,2344]],["compulenta.ru",[463,475,2740]],["infostart.ru",463],["mnmag.ru",[463,3548]],["yantann.rbsmi.ru",[463,825,3989]],["yanzori.rbsmi.ru",[463,825,3989,3990]],["seonews.ru",[463,4107]],["vladtv.ru",463],["vn.ru",[463,4508]],["vt-inform.ru",463],["jlady.ru",[464,3240]],["parazitovnetu.ru",[464,2788]],["spinazdorov.ru",[464,1719,4212]],["cardiologiya.com",[465,466,541,542,543]],["floradoma.com",[465,628]],["medotvet.com",[465,466]],["mpsdoc.com",465],["sustav.info",[465,543,1440,1441]],["diabethelp.org",[465,1440,2117]],["1parazit.ru",[465,2314]],["24stoma.ru",465],["alkotraz.ru",465],["big-stirka.ru",465],["f4iwiki.ru",465],["fastcarp.ru",[465,2618]],["firstfisher.ru",465],["kakbik.ru",465],["literaguru.ru",[465,3383]],["luckyfamilyman.ru",465],["medicina-kirov.ru",465],["mixednews.ru",[465,3534]],["moikolodets.ru",[465,466]],["moyapechen.ru",[465,466]],["mr-build.ru",465],["nosnebolit.ru",465],["oprostatit.ru",465],["selok.ru",[465,3112]],["silaman.ru",[465,466]],["udermis.ru",[465,466,1138,1441,2747]],["vesdoloi.ru",[465,4474]],["vitaminius.ru",465],["wheeclamp.ru",465],["youpk.ru",465],["healthy2life.com",466],["kogda-budet.com",466],["papillomy.com",[466,903]],["plateginfo.com",[466,922,923]],["prorecepty.com",466],["vash-ortoped.com",[466,644]],["kpacotka.info",466],["goodread.name",466],["gipergidroz.net",466],["sad-doma.net",466],["womanlady.net",466],["2mb.ru",466],["anginamed.ru",466],["askort-studio.ru",466],["avtoelektrik-info.ru",[466,2541]],["calculat.ru",[466,2662]],["dermatitanet.ru",[466,2792]],["domovityi.ru",466],["etochay.ru",466],["every-holiday.ru",466],["fightnews.ru",466],["fishedem.ru",466],["gameorakul.ru",466],["gboteh.ru",466],["godsvadba.ru",466],["herbaldoc.ru",466],["hozobzor.ru",466],["hudelkin.ru",466],["infekc.ru",[466,3181]],["lookmedbook.ru",[466,3400]],["luxvaz.ru",[466,3409]],["m-e-f.ru",466],["megatechnostroy.ru",466],["mensgen.ru",[466,3511]],["moyaspina.ru",466],["moypodval.ru",[466,3587]],["moyskelet.ru",[466,3588,3589]],["music-education.ru",466],["mykozha.ru",[466,3611]],["namenu.ru",466],["narmed24.ru",466],["narodnaiamedicina.ru",466],["nashirybki.ru",466],["obrazovaka.ru",[466,3588,3721]],["omaske.ru",[466,3112]],["otravlen.ru",466],["podvaldoma.ru",466],["poluchi-teplo.ru",466],["potolokspec.ru",[466,3112]],["progrib.ru",[466,2495,3908]],["prohodimets.ru",466],["promoipochki.ru",466],["salat-legko.ru",466],["samogoniche.ru",466],["sdelala-sama.ru",[466,3631,4094]],["stomachum.ru",466],["telecomspec.ru",466],["timelady.ru",466],["uroki-pitaniya.ru",[466,1138]],["vdv-kavkaz.ru",[466,2141]],["vmirevolos.ru",466],["webdiana.ru",[466,2328,4094,4542]],["zavisimost03.ru",[466,4199,4647]],["zdoroveenet.ru",466],["zhenskij-sajt-katerina.ru",[466,1872]],["elektrik-a.su",[466,4705]],["all-episodesfun.com",469],["all-for-woman.com",470],["back-in-ussr.com",470],["domosedy.com",[470,575]],["edalnya.com",470],["kaksekonomit.com",470],["klikabol.com",470],["myprikol.com",470],["pisez.com",470],["pitomzy.com",470],["rulenta.com",470],["sci-hit.com",470],["slovobozhie.com",470],["tursputnik.com",470],["ya-superpuper.com",470],["zakon-i-poryadok.com",470],["videohit.info",470],["budtezdorovy.net",470],["malyutka.net",470],["showbizzz.net",470],["klubnichka.xyz",470],["mistika.xyz",470],["allmoldova.com",[471,472]],["pavon.kz",[472,1531]],["pavlodar.news",[472,1531]],["gdeposylka.ru",[472,3039]],["infomir59.ru",[472,3184]],["rentv-smolensk.ru",472],["telesputnik.ru",[472,3623,4313]],["ubuntovod.ru",472],["webmasters.ru",[472,4543]],["allnetcorp.com",473],["allsportlinks.com",474],["alogvinov.com",[475,476]],["gamer-info.com",[475,650]],["kudago.com",475],["aif.ru",[475,2404]],["computerra.ru",[475,2550,2741]],["gamebomb.ru",[475,3017]],["forums.goha.ru",475],["gotps3.ru",[475,3088]],["kugesi.ru",[475,2686]],["move.ru",[475,3582]],["na-svyazi.ru",[475,2685,2687,3626,3627]],["omskpress.ru",[475,3742]],["ps3hits.ru",475],["radiorecord.ru",475],["shazoo.ru",[475,4125]],["sobaka.ru",[475,4171]],["sportbox.ru",[475,2196,4220]],["altai4u.com",477],["amoledo.com",[478,479]],["anatomia-strasti.com",480],["andro-news.com",481],["ani-mania.com",482],["anidubonline.com",484],["anidub.vip",484],["anifap.com",485],["anitokyo.org",[485,2092]],["anitokyo.tv",[485,2092]],["animenfo.com",486],["aratta-ukraine.com",487],["drawnstories.ru",487],["tvvse.my1.ru",[487,3603]],["webos-forums.ru",[487,4545]],["gisclub.tv",487],["teremok.org.ua",[487,5189]],["armadaboard.com",488],["armfootball.com",489],["asiapoisk.com",490],["assiatv.com",491],["tv-assia.org",[491,2233]],["astrolibra.com",492],["medickon.com",492],["multrecept.com",492],["tvoipitomec.com",492],["tvoipitomec.info",492],["au-ok.com",493],["autosoftos.com",494],["averina.com",495],["just-for-fun.ru",[495,3247]],["avtomaniya.com",496],["avtorambler.com",[497,498]],["rambler.ru",[497,3032,3967]],["auto.rambler.ru",498],["azrotv.com",500],["baby-mult.com",501],["baku365.com",502],["balticlivecam.com",503],["speedtest.org.ua",503],["batpic.com",504],["batzbatz.com",505],["bd-sanctuary.com",506],["cine-sanctuary.com",506],["comics-sanctuary.com",506],["manga-sanctuary.com",506],["bdsmplaneta.com",507],["belarushockey.com",508],["belprauda.com",[509,510]],["desktophut.ru",509],["bessarabiainform.com",[511,512]],["ebooktime.net",[511,1755]],["fex.net",[511,1763]],["animevost.org",[511,1094,2090]],["vost.pw",[511,1094,2090]],["dwg.ru",[511,2857]],["pc-consultant.ru",511],["programmersforum.ru",511],["sport24.ru",[511,1106,4219]],["animevost.top",[511,1094,2090]],["bezzamorochek.com",514],["bigcaucasus.com",515],["bilshe.com",[516,517]],["businessua.com",[516,540]],["multikino.com",516],["binary-forum.com",518],["bitmakler.com",519],["bless-news.com",520],["blogspot.com",521],["newnavitel.blogspot.com",522],["uaexpert.blogspot.com",524],["zvamynews.blogspot.com",525],["sportnet.live",[525,1586]],["joomlatown.net",525],["flb.ru",525],["ipadus.ru",525],["kaifzona.ru",525],["klanwin.ru",[525,3302]],["ruspicbox.ru",525],["sovsekretno.ru",[525,3083,4201]],["znaj.ua",[525,5251]],["booksgid.com",526],["boom365hd.com",527],["sport365hd.com",527],["sport365hd.net",527],["whd365.pro",527],["bountyporn.com",528],["pornoneverdie.com",528],["boxrec.com",[529,530]],["iphones.ru",[530,3209]],["lovitut.ru",[530,3405]],["pc.ru",530],["brd24.com",[532,533]],["onyxgame.com",[532,894]],["minizal.net",532],["anti-malware.ru",[532,2470]],["brestcity.com",534],["browserleaks.com",535],["nookea.com",535],["otzovik.com",[535,899]],["studizba.com",535],["todotech20.com",535],["forum.vorota.de",[535,1209]],["anivisual.net",535],["ficbook.net",[535,1764]],["apptractor.ru",535],["kg-portal.ru",[535,3271]],["kulturologia.ru",[535,3340]],["forums.overclockers.ru",[535,3784]],["stalker-mods.clan.su",[535,2842,4703]],["stalker-mods.su",[535,2842,4703]],["btcsec.com",536],["unian.info",[538,1341,1358,1359,1442,1443,1452]],["unian.net",[538,1341,1358,1359,1442,1443,1452]],["buhgalter.com.ua",[538,539,4389,4911]],["factor.ua",[538,5046]],["tsn.ua",[538,5234]],["unian.ua",[538,1341,1358,1359,1442,1443,1452]],["omastopatii.ru",[541,3738]],["prizvanie.su",[543,4728]],["casino-mining.com",544],["ceesty.com",545],["clkmein.com",545],["cllkme.com",545],["corneey.com",545],["destyy.com",545],["festyy.com",[545,615]],["gestyy.com",545],["newsfortrump.ga",545],["skipp.io",545],["clkme.me",545],["skiip.me",545],["viid.me",545],["wiid.me",545],["sh.st",545],["shorte.st",545],["jigbig.tk",545],["rutracker.lib",[546,706,1565]],["rutr.life",[546,706,1565]],["rutracker.net",[546,706,1565]],["rutracker.nl",[546,706,1565]],["rutracker.org",[546,706,1565]],["cherkassy-sport.com",548],["chesalka.com",549],["chezasite.com",550],["chudo-povar.com",[551,552]],["help-wifi.com",551],["pixwords-help.info",551],["mydiv.net",[551,1863]],["nikolaev-city.net",551],["readweb.org",551],["wotspeak.org",[551,2247]],["pingvin.pro",[551,2268]],["draug.ru",[551,2608,2842]],["modsforwot.ru",[551,2608,2842]],["sega-play.ru",551],["slo.ru",[551,4151]],["vplate.ru",551],["7themes.su",[551,4605,4693]],["cyberpedia.su",[551,1437]],["banker.ua",[551,4876]],["padaread.com",553],["devby.io",[553,1138,1474]],["moika78.ru",[553,3566,3567]],["dev.ua",[553,1138,1474]],["cikavosti.com",554],["city4me.com",555],["clip2net.com",556],["clusterdelta.com",557],["consol-games.com",558],["consol-games.net",558],["coub.com",559],["cowcotland.com",560],["wamiz.com",560],["cpasee.com",561],["crazyatomicgames.com",[562,563]],["xxx-igra.com",[562,563]],["yaldagames.com",[562,563]],["torrentinka.me",[562,1652]],["cyclone-soft.com",565],["hide-info.pro",565],["gameshake.ru",565],["dailylviv.com",566],["depfile.com",567],["depositfiles.com",568],["diabet-med.com",[569,570]],["on-movie.net",569],["forum.masterforex-v.org",569],["dk003.com",572],["donpress.com",576],["dotabuff.com",577],["drive2.com",[578,579]],["drive2.ru",[578,2846]],["drugasmuga.com",580],["dynamomania.com",581],["dzfoot.com",582],["easypronunciation.com",584],["economistua.com",585],["efootballdb.com",586],["myfootball.top",[588,4768]],["emotionalrating.com",590],["777score.ru",[590,847,2366]],["ok-magazine.ru",590],["poltava.to",590],["expert.in.ua",[592,593]],["ukrnews24.net",[593,1976]],["dks.com.ua",593],["galinfo.com.ua",[593,4934]],["nbnews.com.ua",593],["plitkar.com.ua",593],["rivnepost.rv.ua",[593,5208]],["real-vin.com",[594,979]],["audiotag.info",[594,1321]],["stravy.net",594],["inforesist.org",[594,1527,2147]],["ostro.org",594],["erocadr.com",595],["erotix-tv.com",596],["kinorai.org",596],["escorenews.com",597],["bestgardener.ru",[597,2584]],["compress.ru",[597,2739]],["espanarusa.com",598],["esputnik.com",599],["eucargologistic.com",600],["customgames.ru",600],["eurabota.com",601],["examenpdd.com",[602,603]],["liveinternet.ru",[603,787,1348,2573,3392]],["experttur.com",604],["f1analytic.com",605],["f1ua.org.ua",605],["fashion2news.com",[607,608]],["in-poland.com",[607,712]],["wormax.io",607],["moyens.net",607],["newspad.ru",[607,608]],["zazloo.ru",[607,699,4648]],["hotallnews.today",[607,608]],["portaltele.com.ua",[607,699,4984]],["kreschatic.kiev.ua",607],["tales.org.ua",607],["dailymail.co.uk",607],["itop-gear.ru",[609,3225]],["fcportables.com",611],["afrowesh.org",611],["fctvhd.com",612],["felomena.com",613],["fgh-game.com",616],["filmisub.com",617],["filmovmir.com",618],["bogmedia.org",[619,2107]],["anilib.moe",[620,1690]],["anilib.one",[620,1690]],["anilibria.iss.one",[620,1690]],["medkrug.ru",[620,3496]],["anilib.top",[620,1690]],["must-see.top",620],["anilibria.tv",[620,1690]],["financerites.com",621],["finatica.com",622],["findretros.com",623],["fit4brain.com",624],["flashscorekz.com",625],["flashscore.ru.com",625],["soccerstand.com",625],["livescore.in",625],["flashscore.com.ua",625],["flashscore.ua",625],["flightradar24.com",626],["online.fliphtml5.com",627],["fon-ki.com",629],["megomult.ru",[629,2763]],["footballgazeta.com",630],["footboom1.com",631],["for-ua.com",632],["forklog.com",634],["formulalubvi.com",[635,636]],["humor.fm",[635,1244]],["econet.ru",[635,2873]],["forumdz.com",637],["forumodua.com",[638,639]],["virusinfo.info",[639,1456]],["forum.developing.ru",[639,2796]],["ruboard.website",[639,5270]],["virusbase.ru.free-anti-spy.com",640],["autoua.net",[642,1717]],["www.okino.ua",642],["gamasexual.com",643],["gamasexual.ru",643],["game-mcpe.com",644],["reshator.com",[644,984]],["polismed.ru",644],["taurion.ru",[644,4298]],["videoculinary.ru",[644,4487]],["game-tournaments.com",[645,646]],["gdetoedet.ru",[646,3040]],["uzum.tv",[646,4843]],["gamegpu.com",647],["gameinonline.com",648],["gamepedia.com",649],["gamesubject.com",651],["ganoderma-mushrooms.com",652],["korrektor.name",652],["varicream.org",652],["gasolina-online.com",[653,654]],["galka.if.ua",[654,5079]],["proxima.net.ua",[654,5157]],["gazeta1.com",655],["gazetavv.com",657],["gazgolder.com",658],["gdetraffic.com",[659,660]],["eurolab.ua",[660,5044]],["novaposhta.ua",660],["gdz-free.com",661],["gdz4you.com",662],["gdzbot.com",663],["gigantporno.com",668],["htmlweb.ru",[668,672,3148]],["glavpost.com",[669,670]],["prohondroz.ru",[670,1719,3278,3909]],["ittour.com.ua",[670,2722,4947]],["glianec.com",671],["elsyst.gnomio.com",672],["pvpru.com",[672,967]],["bestradio.fm",[672,1241]],["forum.niiot.net",[672,1874]],["ghame.ru",672],["ph4.ru",[672,3816]],["mail.google.com",674],["sites.google.com",675],["amaterka.ru",675],["blogspot.ru",[675,2612]],["www.google.com",676],["www.google.ru",676],["grodno24.com",677],["gta5-mods.com",679],["paparazzi.ru",[680,1527,3790]],["guzei.com",681],["habr.com",682],["qna.habr.com",683],["hariola.com",[684,685,686]],["ukrhealth.net",684],["hdkinoteatr.com",[687,688]],["hdkinoteatr3.net",[687,1788]],["hearthhead.com",[689,690]],["wowhead.com",[689,690,1180]],["thottbot.com",690],["hellomagazine.com",691],["mp3davalka.com",692],["mymedicalportal.net",[692,1865]],["work.ua",[692,5248]],["forums.heroesofnewerth.com",694],["hitmotop.com",695],["mod-land.ru",697],["sho.org.ua",[699,5187]],["iccup.com",700],["id-storage.com",701],["ignio.com",702],["igorchernomoretz.com",703],["igropoisk.com",704],["lelang.su",[706,4716]],["shopping.nv.ua",[706,5165]],["ilikenews.com",707],["imagebam.com",708],["imgrutor.com",710],["imolodost.com",711],["opitanii.net",711],["incrypted.com",713],["infokava.com",716],["obozrevatel.com",[717,883,884,885]],["pogodnik.com",[717,935,936]],["bychico.net",717],["ecosounds.net",717],["musecube.org",717],["dyrik.ru",717],["in-drive.ru",717],["oknotivi.ru",717],["sandero.ru",[717,4077]],["turbominer.ru",717],["infoyarsk.com",718],["interesniy.com",[719,720]],["bookskeeper.ru",[720,2624,2625]],["intv.com",721],["intvua.com",722],["investing.com",723],["iobit.com",724],["ripik.net",724],["megatrest.ru",724],["sofirus.ru",[724,4177]],["softa-mnogo.ru",[724,4183]],["xakeroker.ws",724],["autocentre.ua",[726,1322,4872]],["cheline.com.ua",[726,4915]],["te.ua",[726,1076,2486,5227]],["itvmg.com",727],["iviche.com",728],["ixbt.games",[730,736]],["ixbt.market",[730,731]],["ixbt.pro",730],["rbkgames.com",[732,978]],["vyborok.com",732],["forum.ixbt.com",733],["prosound.ixbt.com",734],["smb.ixbt.com",[735,736]],["www.ixbt.com",737],["izcity.com",738],["cdmail.ru",738],["ualinux.com",739],["ndn.info",[739,1395]],["radnuk.info",[739,1418]],["zvid.org",739],["chronicles.pro",739],["arz-biz.ru",[739,2502]],["dtpptz.ru",739],["fermagid.ru",739],["hv-info.ru",[739,3149]],["infoselection.ru",[739,3187]],["ko44.ru",739],["mamadysh-rt.ru",739],["medicalj.ru",739],["muzcentrum.ru",739],["newgubakha.ru",739],["ok-inform.ru",739],["planetaskazok.ru",739],["shansonline.ru",739],["tv29.ru",739],["kaskad.tv",739],["obs.in.ua",739],["jaitoutcompris.com",740],["gitarist05.jimdo.com",741],["journaldugeek.com",742],["kaddr.com",743],["kafanews.com",744],["kulinarnayamozaika.ru",745],["z-city.com.ua",745],["kanoner.com",747],["karpovka.net",747],["keysportal.com",748],["kharkovforum.com",749],["khersondaily.com",750],["kiev2000.com",751],["kinogorod.com",753],["kinokladovka.com",754],["kinopoiskhd.com",755],["kinopult.com",756],["kinorubik.com",757],["kinospy.com",758],["kinovidos.com",759],["kissvk.com",760],["kloomba.com",[761,762]],["klumba.com",761],["klopotenko.com",[763,764,765]],["altapress.ru",[763,2439,2440]],["komedra.com",767],["krastown.com",768],["krymr.com",769],["kubik-v-kube.com",770],["kursk.com",772],["kykarek.com",773],["vjazanie.info",773],["sobakada.ru",773],["lagrosseradio.com",774],["leechyscripts.com",776],["life-reactor.com",777],["list-org.com",778],["litnet.com",779],["littleone.com",780],["litvek.com",781],["outlook.live.com",782],["novyny.pro",783],["flicksbar.fun",[784,1271]],["flicksbar.info",[784,1271]],["agroinfo.kz",[784,1500,1501]],["flicksbar.mom",[784,1271]],["vp.rambler.ru",[786,3976]],["colonelcassad.livejournal.com",788],["dubikvit.livejournal.com",789],["masterok.livejournal.com",790],["odin-moy-den.livejournal.com",791],["sergeydolya.livejournal.com",[791,793]],["yurasumy.livejournal.com",[791,796]],["puerrtto.livejournal.com",792],["varlamovru.livejournal.com",794],["www.livejournal.com",795],["zloy-odessit.livejournal.com",797],["llifle.com",798],["lospopadosos.com",799],["radojuva.com.ua",799],["lostfilmstv.com",800],["lostpix.com",801],["lr-club.com",[802,803]],["finversia.ru",[803,2948]],["pogoda.ru",[803,3848]],["severinform.ru",803],["lyrsense.com",804],["vashuchebnik.com",804],["en365.ru",804],["maanimo.com",805],["macilove.com",806],["magical-skin.com",807],["malekal.com",[808,809]],["dalaaadno.ru",808],["dokfilm.maminforum.com",810],["mastergrad.com",[811,812]],["govp.info",[811,1361,1362]],["allforpeople.net",811],["rtlxl.nl",811],["433175.ru",811],["naurfo.ru",[811,3643]],["forum.qrz.ru",811],["wallpapershome.ru",811],["matiz-club.com",813],["mediafire.com",814],["medvesti.com",815],["meendoru.com",816],["megosales.com",[817,818]],["otcrytki.com",817],["gidonline.fun",[818,1274]],["gig-games.net",818],["torrents-soft.net",[818,1966]],["yaebus.net",818],["aggromusic.ru",818],["fullpcgame.ru",818],["torrent-song.ru",818],["melodramo.com",819],["mesjachnye.com",820],["metal-tracker.com",821],["fontov.net",821],["metanit.com",822],["meteobar.com",823],["meteopost.com",824],["micro-win.com",[827,828]],["headsoft.kz",827],["rl-team.net",[827,1923]],["bookarchive.ru",827],["vsetyt.us",827],["mignews.com",829],["milliarderr.com",830],["mirfactov.com",832],["mister-blister.com",833],["mistosumy.com",834],["mynizhyn.com",[834,850]],["pechera.info",[834,850,1409]],["mobile-files.com",835],["solnechnogorsk.net",835],["cqham.ru",[835,2751]],["nexia-club.ru",835],["zx-pk.ru",[835,3594,4670]],["foto.ua",[835,3294,5058]],["moniheal.com",838],["moscow-post.com",839],["forum.finance.ua",839],["ru.motorsport.com",840],["motovolg.com",841],["mozgotvet.com",842],["mp4upload.com",843],["www.mp4upload.com",844],["mreadz.com",845],["multitran.com",846],["music-torrent.com",847],["kino4k.in",847],["games.portal.md",847],["online-fix.me",[847,1632]],["kinofanonline.net",847],["texdizain.net",[847,1960]],["animesure.org",847],["musictor.org",847],["windowspro.ru",847],["rg-mechanics.site",847],["muzofon.com",848],["myfreeproject.com",849],["nashamama.com",852],["nashaniva.com",853],["nashmontreal.com",[854,855]],["mail.ukr.net",[854,1973]],["consultant.ru",854],["cossa.ru",[854,2746]],["mgnews.ru",[854,3520]],["kriminal.tv",[854,917,3462,4801]],["studclub.poltava.ua",854],["nashol.com",856],["nautiljon.com",858],["newgdz.com",859],["politros.com",861],["slovodel.com",[861,1037]],["softpir.com",[862,1045]],["wkino4.net",[862,1995]],["newsland.com",863],["newsmsk.com",864],["newsru.com",865],["nexusmods.com",866],["forums.ngemu.com",867],["nicematin.com",868],["varmatin.com",868],["monacomatin.mc",868],["nikvesti.com",869],["ninemanga.com",870],["nonameno.com",[872,873]],["rusrek.com",872],["x-raydoctor.ru",[872,4587]],["notebookcheck-ru.com",874],["noteru.com",875],["uzl71.ru",875],["novostivmire.com",876],["novyjgod.com",877],["novynarnia.com",878],["numberempire.com",879],["nwcod.com",880],["o-doroge.com",881],["oboz.ua",[884,5166]],["ua-independent.com",885],["vbryanske.com",[885,1128]],["opticlub.org",885],["amic.ru",[885,2444]],["anime-bit.ru",[885,2026,2458]],["inflora.ru",[885,3182]],["lifenews.ru",[885,2067,2421]],["lifenews78.ru",[885,2067]],["players.com.ua",[885,4979]],["www.obozrevatel.com",886],["officebesplatno.com",888],["ogemorroe.com",889],["ogorodniki.com",890],["pdalife.ru",[890,2173,3801]],["okaygorod.com",891],["onlinemschool.com",892],["onlinetestpad.com",893],["open3dmodel.com",895],["opisanie-kartin.com",896],["orakul.com",897],["orybe.com",898],["otzywy.com",900],["ozlib.com",901],["studref.com",901],["vuzlit.com",901],["bstudy.net",901],["studbooks.net",[901,1951]],["studwood.net",901],["studme.org",[901,1951,2223]],["xstud.org",901],["pamm-fxprofit.com",902],["parnuxi.com",904],["partnerkin.com",905],["pastebin.com",906],["anime-free.ru",906],["meteoservice.ru",906],["pawno-info.ru",[906,3796]],["admin.rainbow-online.ru",906],["logist.uxxo.ru",906],["forum.pcastuces.com",907],["pddua.com",908],["pdd.ua",908],["photofacefun.com",910],["photofilters.com",911],["photofuneditor.com",912],["photopea.com",913],["photos-models.com",914],["pic-chik.com",915],["pidru4nik.com",[916,917]],["forpost.media",917],["dochronika.ru",917],["www.semestr.ru",[917,4105]],["bigkyiv.com.ua",917],["uti-puti.com.ua",[917,5013]],["today.ua",917],["pinterest.com",918],["pise4ka.com",919],["pk-help.com",920],["pkmods.com",921],["qiwiq.ru",923],["player-cdn.com",925],["playmarket-for-pc.com",[926,927]],["playmarket-pc.com",927],["roblox-pc.com",927],["playonlinux.com",928],["playvega.com",929],["playvideolink.com",930],["moevideo.net",930],["videochart.net",[930,1054,1981]],["thesame.tv",[930,4838]],["podillyanews.com",931],["podolyaka.com",[932,933]],["pay-day.ru",[932,3797]],["podolyaka.ru",[932,933,3846]],["tvcenter.ru",932],["warhead.su",932],["police-russia.com",937],["polosedan-club.com",939],["poltava365.com",940],["poltavaforum.com",941],["pons.com",942],["poragovorit.com",943],["encyclopaedia-russia.ru",943],["pornhub.com",944],["pornopodborka.com",945],["pornovkisku.com",946],["pindosoff.net",946],["teplomontag.net",946],["potokcdn.com",947],["prankota.com",[948,949,950]],["ua-novosti.info",[949,1108,1447]],["ua-novosti.online",949],["glamour.kyiv.ua",[949,1108]],["spyware-ru.com",950],["pressa-online.com",951],["primanki.com",952],["private-records.com",953],["privatfinance.com",954],["proglazki.com",955],["programma-peredach.com",956],["proidei.com",957],["promodj.com",958],["hitsovet.ru",[961,3130,3131]],["prostomac.com",962],["db.chgk.info",962],["dsvload.net",[962,1753]],["gubkabob.net",962],["forzajuve.ru",[962,1404,2986]],["imageban.ru",962],["kak-spasti-mir.ru",962],["moi-detsad.ru",962],["rap-text.ru",962],["recensent.ru",962],["seriatv.ru",[962,4114]],["volomy.ru",962],["podrobno.uz",[962,1042,2684,5261]],["prostomob.com",963],["pslan.com",965],["pythonru.com",968],["radiobells.com",969],["radiogrom.com",970],["radioprofusion.com",971],["radiox.com",972],["rafkino.com",973],["forum.raskraska.com",975],["raspisanie24.com",976],["razvitierebenka.com",977],["receptisalatov.com",980],["redtram.com",981],["redtube.com",982],["reklama-crimea.com",983],["podolsk.ru",[983,3845]],["gdzplus.me",984],["retinaboys.com",986],["rewalls.com",987],["auto.ria.com",988],["riotpixels.com",990],["vpnmag.ru",992],["rosphoto.com",993],["royallib.com",994],["rtkorr.com",996],["automobili.ru",[996,1042]],["forum.ru-board.com",997],["rubryka.com",[998,999]],["theuk.one",[998,2049,2050]],["test-nmo.ru",998],["ruero.com",1000],["ruinformer.com",1001],["runyweb.com",1002],["rupier.com",1003],["ruseller.com",1004],["forums.rusmedserv.com",1005],["rusopen.com",1006],["russian-bazaar.com",[1007,1008]],["nr2.ru",1007],["russiandc.com",1009],["rustorka.com",1010],["rustorkacom.lib",1010],["rustorka.net",1010],["game4you.top",1010],["games-pc.top",1010],["innal.top",[1010,4764]],["naylo.top",1010],["rustorka.top",1010],["pogodasakhcom.ru",[1012,3851]],["rusprofile.ru",[1012,4054,4055]],["ykt.ru",[1012,4036,4620]],["sakhalin.tv",1012],["marketsakhcom.ru",[1013,3461]],["travelsakhcom.ru",1014],["sakh.name",1015],["autosakhcom.ru",1015],["f-1.ru",1016],["salonav.com",1017],["sat-digest.com",1018],["sat-expert.com",1019],["gorodvkusa.ru",1019],["sbfull.com",1020],["raes.tech",1020],["wigistream.to",1020],["serialy-2021.com",1021],["serialy-tor.com",1021],["setafi.com",1022],["reedr.ru",[1022,3996]],["sexgamesbox.com",1023],["sexsmotri.com",1024],["shadbase.com",1026],["sherdog.com",1027],["shraibikus.com",[1028,1029]],["topdaynews.ru",1029],["sibmail.com",1030],["siliconrus.com",1031],["sims-game.com",[1032,1033]],["sivator.com",1034],["skatay.com",1035],["smotri.com",1038],["snatchnews.com",1039],["sntch.com",1040],["soccer0100.com",1041],["spectehinfo.ru",1041],["trudbox.com.ua",1041],["sochi.com",1042],["2x2tv.ru",[1042,2338]],["actualcomment.ru",1042],["asn24.ru",1042],["kubnews.ru",[1042,1527,1561]],["lgz.ru",[1042,3367]],["newsroom24.ru",[1042,3671]],["ohranatruda.ru",[1042,1314]],["onlinetambov.ru",[1042,3753]],["mk.tula.ru",[1042,4396]],["vegetarian.ru",[1042,4470]],["velikiynovgorod.ru",1042],["forum.soft4dle.com",1043],["softobase.com",1044],["softportal.com",1046],["solverbook.com",1047],["soonnight.com",1048],["spanishdict.com",1050],["spartak.com",1051],["sportanalytic.com",1052],["sportliga.com",[1055,1056,1057]],["manutd.ru",[1055,3458]],["c-sgo.ru",[1056,2657]],["sportrecs.com",1058],["spravkus.com",1060],["profinance.ru",[1060,3905]],["sputnikipogrom.com",1061],["stroy-telo.com",1062],["superkot.com",1063],["forum.superkot.com",1064],["sxnarod.com",1065],["sxn.today",1065],["tagaev.com",1066],["site-do.ru",[1066,4142]],["footballtransfer.com.ua",[1066,4932]],["taobao-forum.com",1067],["tapclap.com",1068],["rgfootball.net",[1068,1921]],["ascnb1.ru",[1068,2503]],["matematikalegko.ru",[1068,3468]],["orangeapps.ru",[1068,3763]],["shadowlands.ru",1068],["tarkov-market.com",1069],["tatfish.com",1070],["technologypep.com",1071],["techonthenet.com",1072],["tehnot.com",1073],["tehnoyug.com",1074],["telestrekoza.com",1075],["pb-news.info",1076],["pasy.media",[1076,1674]],["agroter.com.ua",[1076,4901,4902]],["oblast-te.com.ua",[1076,4974]],["skidkaonline.ru",1078],["terrikon.com",1079],["tgstat.com",1080],["tgstat.ru",1080],["the-clu.com",1081],["theageoffootball.com",1083],["therussianamerica.com",1084],["tod-news.com",1085],["tomat-pomidor.com",1086],["topasnew24.com",[1087,1088]],["payeer-gift.ru",[1088,3798]],["upl.uz",1088],["topsante.com",1089],["closermag.fr",[1089,1264]],["grazia.fr",1089],["torent-igruha.com",1090],["inferno.games",1090],["rutor-gamer.info",1090],["torrentigo.net",1090],["only-soft.org",1090],["torrentigruha.org",1090],["torrent-soft.pro",1090],["besplatnyeprogrammy.ru",[1090,2581]],["mediagetguru.ru",1090],["rutor-game.ru",1090],["torrent-music.ru",1090],["where-game.ru",1090],["apad2.top",1090],["monna2.top",1090],["torontovka.com",1091],["torrent-pirat.com",1092],["torrenther.com",1093],["smotret-multfilmi.net",1093],["torrentmir.com",1094],["5torrent.net",1094],["8torrent.net",1094],["bootos.net",1094],["vse-serii.net",1094],["knigomania.org",1094],["dosgames.ru",1094],["minecraft-files.ru",[1094,3523]],["newpcgame.ru",1094],["torrent-bro.ru",1094],["torrent-cash.ru",[1094,4368]],["torrent-post.ru",1094],["torrgames.ru",1094],["xn----7sbcqvkpkdtgif1a4h.xn--p1ai",1094],["dating.trans-admirer.com",1095],["trassae95.com",1096],["truba.com",1098],["trud.com",1099],["twirpx.com",1101],["twirpx.org",1101],["ua-cinema.com",1102],["ua-ekonomist.com",1103],["ua-electro.com",1104],["ua-football.com",[1105,1106]],["scores24.live",[1106,1583,1584]],["livesport.ru",[1106,3390,3396,3397]],["livecup.run",[1106,3396]],["ua-vestnik.com",[1107,1108]],["edu-lib.net",1107],["az-priroda.ru",1107],["bisnesideya.ru",[1107,2599]],["doctorrouter.ru",[1107,1303,2819,2820]],["farmamir.ru",[1107,2922]],["halyavapliz.ru",1107],["kopilohka.ru",1107],["ruskweb.ru",1107],["samogonpil.ru",1107],["x-kuzov.ru",[1107,1537,4586]],["yroki-kompa.ru",[1107,4627]],["medicalanswers.site",1107],["lifeinvest.com.ua",1107],["medfactor.com.ua",1107],["medicalanswers.com.ua",[1107,1108]],["uapress.kyiv.ua",[1107,1447]],["woman24.kyiv.ua",1107],["zhenskiy.kyiv.ua",[1107,1108]],["marketer.ua",1107],["dialogs.org.ua",[1107,5180]],["news24.in.ua",[1108,1447]],["arguments.kyiv.ua",1108],["dailynews.kyiv.ua",1108],["elegantwoman.kyiv.ua",[1108,5127]],["lady.kyiv.ua",1108],["womanlife.kyiv.ua",1108],["useti.org.ua",1108],["uaplay.com",1109],["gameshare.com.ua",1109],["drevo.uaportal.com",1110],["nuriknur.ucoz.com",[1112,1113]],["drochunov.net",[1113,1751]],["ukrainianiphone.com",1115],["ukrmilitary.com",1118],["unibytes.com",1119],["unit-car.com",1120],["ur8lv.com",1121],["v-androide.com",1126],["vazremont.com",1127],["book-briefly.ru",[1127,2623]],["velikolepnyivek.com",[1129,1130]],["kino-history.net",1129],["versii.com",1131],["vesti-ukr.com",1132],["via-midgard.com",1133],["1hd1080.info",[1133,1308]],["1hd1080tv.info",[1133,1308]],["2hd1080.info",[1133,1308]],["newsbalt.ru",[1133,3667]],["videoprobki.com",1134],["vidzur.com",[1135,1136]],["videofun.me",[1135,1136,1655]],["videobug.net",[1135,1136,1980]],["play44.net",1136],["yucache.net",1136],["vinbazar.com",1137],["vipidei.com",1138],["orchardo.ru",1138],["vizyt.com",1139],["vk.com",[1140,1141,1142]],["vk.ru",1140],["m.vk.com",1143],["vkfaces.com",1144],["vkurske.com",[1145,1146]],["vo-production.com",1147],["volnafm.com",1149],["volnorez.com",1150],["volynnews.com",1152],["volynpost.com",1153],["vpopke.com",1154],["bookmo.org",1154],["eromo.org",1154],["vidmo.org",1154],["vrhell.com",1155],["vsaduidoma.com",1158],["vseazs.com",1159],["vserialy.com",1160],["vserialy.fun",1160],["great-tv.ru",1160],["vsetv.com",1161],["vskazketv.com",1163],["new-team.org",1163],["bigbangtv.ru",1163],["onlysimpsons.ru",[1163,3756]],["swip.su",1163],["vtb-league.com",1164],["want2vote.com",1165],["wbprx.com",1166],["we-reads.com",1167],["webtun.com",1168],["wiaderko.com",1169],["wikihow.com",1170],["wikiwolrd.com",1171],["windows-disk.com",1172],["windows-driver.com",1173],["windows-program.com",1173],["softomania.net",1173],["warezok.net",1173],["windows-driver.net",1173],["winreviewer.com",1174],["world-mmo.com",[1175,1176]],["wot-news.com",[1177,1178]],["eda.ru",[1178,2874]],["sevastopol.su",[1178,4732]],["firtka.if.ua",1178],["wotactions.com",1179],["wylsa.com",1181],["x-console.com",1182],["xreferat.com",1183],["xv-ru.com",1184],["yablyk.com",1186],["yakpravylno.com",1187],["yap.ru.yaplakal.com",1189],["yarnovosti.com",1191],["youtebem.com",1192],["rusfootball.info",1192],["obozvrn.ru",1192],["agri-gator.com.ua",[1192,4896]],["rama.com.ua",1192],["subbota.ua",[1192,5223]],["youtube.com",1193],["zarlit.com",[1194,1195]],["remake.net.ru",1195],["zestradar.com",1199],["zh24.com",1200],["znak.com",1201],["znanija.com",1202],["zx-pk.com",1203],["gidonline.cx",1204],["igra-prestoloff.cx",1205],["objavlenija.respublika.cz",1206],["filmix.date",1207],["filmix.fm",1207],["filmix.life",1207],["filmix.pub",1207],["filmix.tech",1207],["filmix.zone",1207],["dl2kq.de",1208],["dic.academic.ru",1209],["f1comp.ru",1209],["ftuapps.dev",1210],["ideaprog.download",1211],["lostfilm.download",[1212,1213]],["lostfilm.life",[1212,1213]],["lostfilm.one",[1212,1213]],["lostfilm.pro",[1212,1213]],["lostfilmtv.site",[1212,1213]],["lostfilmtv2.site",[1212,1213]],["lostfilmtv3.site",[1212,1213]],["lostfilmtv5.site",[1212,1213]],["lostfilm.space",[1212,1213]],["lostfilm.today",[1212,1213]],["lostfilm.tv",[1212,1213,4804]],["lostfilm.tw",[1212,1213]],["lostfilm.uno",[1212,1213]],["lostfilmtv.uno",[1212,1213]],["lostfilm.win",[1212,1213]],["mylenium.ru",1213],["100filmov.net",[1215,1703]],["keys-kas.ru",1215],["posters.ec",1216],["lib.rus.ec",1216],["delfi.ee",1217],["lol24.ee",1218],["postimees.ee",1219],["rybolov.ee",1220],["stena.ee",1221],["money.energy",1222],["malagarusa.es",1223],["muzland.es",1224],["muzland.info",1224],["muzland.ru",1224],["euroiphone.eu",1225],["gidonline.eu",1227],["kinogo.eu",1228],["moscowtimes.eu",1229],["moscowtimes.ru",1229],["ruslife.eu",1231],["autotuning.expert",1232],["egdz.net",1232],["7zip-download.ru",1232],["fbm.ru",1232],["soft-click.ru",[1232,4179]],["direct.farm",[1233,1234]],["myplaycity.ru",[1234,3614]],["afisha.fi",1235],["doska.fi",[1236,1237]],["russian.fi",[1237,1238]],["anwap.film",1239],["anison.fm",1240],["deti.fm",1242],["grind.fm",1243],["kerch.fm",1245],["24tv.ua",[1247,1634,1894,2010,2011,4784,4860]],["maximum.fm",1248],["moskva.fm",1250],["piter.fm",1250],["muzofond.fm",1251],["ololo.fm",[1253,1254]],["kontur-map.ru",[1254,3322]],["radioshanson.fm",1255],["sfera.fm",1256],["tort.fm",1258],["vostok.fm",1259],["101poisk.ru",[1259,2292]],["pornobomba.vip",1259],["z200.fm",1260],["zk.fm",[1260,1262]],["zvukoff.ru",1260],["zaycev.fm",1261],["online.zakon.kz",[1261,1557]],["me.fo",1263],["etr.fr",1265],["iphonesoft.fr",1266],["iphonetweak.fr",1266],["papergeek.fr",1267],["pausecafein.fr",1268],["trackr.fr",1269],["fanserial.fun",1270],["fanserialstv.net",1270],["gdz.fun",1272],["gdz-ru.work",[1272,5274]],["kino2018.fun",1275],["onporn.fun",1276],["piratbit.fun",1277],["piratbit.org",1277],["piratbit.top",1277],["pb.wtf",1277],["utorrentfilmi.fun",1278],["utorrentfilmi.ru",1278],["utorrentmusic.ru",1278],["zaruba.fun",1279],["trackeroc.ga",1280],["trackeroc.info",1280],["trackeroc.ml",1280],["trackeroc.org",1280],["ttrackeroc.ru",1280],["trackeroc.tk",1280],["mehanik.games",1281],["tes-game.ru",1281],["ru.gg",1283],["sexxx.gg",1284],["compromat.group",1285],["diets.guru",1286],["newsyou.info",[1286,1399]],["pohudet.org",[1286,2190]],["kinozal.guru",1287],["kinozaltv.life",1287],["kinozal.me",1287],["kinozal.tv",1287],["searchengines.guru",1288],["zhkt.guru",1289],["2ch.hk",[1290,1291]],["2ch.life",[1290,1291]],["pshack.net",1291],["mypresentation.ru",[1291,3615]],["tonna-games.ru",1291],["cursorinfo.co.il",1293],["detaly.co.il",1294],["israelinfo.co.il",1295],["newsru.co.il",1296],["bash.im",1297],["taker.im",1299],["vise.im",1300],["bestweapon.in",1301],["fairtop.in",1302],["gamingsym.in",1303],["ranobe-novels.ru",1303],["transformator220.ru",1303],["wuxiaworld.ru",[1303,4065]],["probiv.in",[1304,1305]],["probiv.one",[1304,1305]],["igru-xbox.net",1305],["rutor.in",1306],["x-minus.in",1307],["4doma.info",1310],["academ.info",1312],["agroone.info",1313],["amur.info",[1314,1315]],["newsmaker.md",[1314,1597]],["diletant.media",[1314,1663]],["24sk.ru",1314],["ast-news.ru",1314],["privatka.ua",1314],["gts39.ru",[1315,3099]],["anna-news.info",1316],["asiaplustj.info",[1318,1319,1320]],["v-info.ru",[1318,4456]],["news.tj",[1319,4746]],["autotheme.info",[1322,1323]],["azpolitika.info",1324],["bazarmedia.info",1325],["bitfin.info",1326],["blockchain.info",1327],["chaynikam.info",1328],["checkfootball.info",1329],["chexov.info",1331],["coronavirus-monitor.info",1332],["cxid.info",1333],["dentaltechnic.info",1334],["itcrumbs.ru",[1334,3224]],["life.ck.ua",1334],["devid.info",1335],["docfilms.info",1337],["doefiratv.info",1338],["dyvys.info",[1340,1341]],["glavred.info",[1341,1356,1357,1358,1359]],["glavred.net",[1341,1356,1357,1358,1359]],["ictv.ua",[1341,4845,5077]],["electrik.info",1343],["ero-top.info",1344],["fansector.info",1345],["fbr.info",1346],["fightnews.info",[1347,1348]],["expres.online",1348],["almodi.org",1348],["kun.uz",1348],["floristics.info",[1349,1350]],["e-ink-reader.ru",[1352,2861]],["ruspdd.ru",1352],["youblogs.ru",[1352,1689]],["gdzputina.info",1353],["gencit.info",1354],["girlstop.info",1355],["glazey.info",1360],["evening-kazan.ru",1362],["gumer.info",1364],["happy-biock.info",1365],["happy-block.info",1365],["howto-news.info",1365],["healthystyle.info",1366],["inforuss.info",[1367,1368,1369]],["lentaruss.ru",[1367,1368,1369]],["smiruss.ru",[1367,1368,1369]],["gotovchik.ru",1368],["kleo.ru",[1368,3304]],["aplik.ru",1369],["discover24.ru",1369],["edurusnews.ru",1369],["mobnovelty.ru",1369],["soderzhanki2.ru",1369],["trud-ost.ru",1369],["holostyak.site",1369],["ivanovy.info",1370],["grand2.ru",1370],["kapriz.info",1371],["kharkov.info",1372],["knigomir.info",1376],["koolhydraatarmerecepten.info",1378],["lektsia.info",1381],["dokumentalkino.net",1381],["lostfilm.info",1382],["loveread.info",1383],["magtimes.info",[1384,1385]],["yakutsk.ru",[1385,1569,4604,4605]],["mivmeste.info",1389],["mmatoday.info",1390],["mobbit.info",1391],["moreprodukt.info",1392],["mytor.info",1393],["nasha-strana.info",1394],["newformat.info",1396],["animang.one",1398],["zdravotvet.ru",1398],["ngp-ua.info",1400],["nnovosti.info",1401],["obukhiv.info",1402],["dtf.ru",[1403,2853]],["newsomsk.ru",[1405,3670]],["ostroh.info",1408],["pensioneram.info",1410],["podskazki.info",1411],["pornbase.info",1412],["portfel.info",1413],["daz3d.ru",[1413,2783]],["portsoft.info",1414],["procherk.info",1415],["punkt-a.info",1416],["pwcats.info",1417],["etextlib.ru",[1418,2440,2899]],["redirekt.info",1419],["rgmechanics.info",1420],["ru-an.info",1421],["rulez-t.info",1422],["sarov.info",1425],["sat-ukraine.info",1426],["satellitetvforum.info",1427],["sevnews.info",1429],["shostka.info",1430],["shotam.info",1431],["sibmama.info",1432],["sibmama.ru",1432],["forum.sibmama.info",1433],["forum.sibmama.ru",1433],["small-games.info",1434],["socportal.info",1435],["studopedia.info",1437],["studopedia.net",[1437,1952,1953]],["lektsii.org",[1437,1953,2158]],["megaobuchalka.ru",[1437,1953,3503]],["studopedia.ru",[1437,1953,4261,4262]],["infopedia.su",1437],["studopedia.su",[1437,1953,2355,4262,4738]],["sudakonline.info",1438],["sudostroenie.info",1439],["vctr.media",[1442,1443]],["wallnews.org",1442],["newsvl.ru",[1442,1443,2850,3674]],["trueua.info",1444],["artofcare.ru",1445],["forum.fonarevka.ru",[1445,2968]],["novosti24.kyiv.ua",1447],["cwer.me",[1449,1615]],["cwer.ru",[1449,1615]],["cwer.su",[1449,1615]],["cwer.ws",[1449,1615]],["ukrmir.info",1451],["via-midgard.info",1454],["vsezdes.info",[1457,1458,1459]],["primemusic.ru",1458],["kaminyn.ru",1459],["val-woman.ru",1459],["zarabotoki.ru",1459],["westnews.info",[1460,1461]],["samsebevoin.ru",[1460,1461]],["wotexpress.info",1462],["x-race.info",1463],["x-true.info",1464],["xenforo.info",1465],["yakutia.info",1466],["yeisk.info",1467],["zhmak.info",1468],["zhzh.info",1469],["zhzh.com.ua",1469],["2ip.io",[1471,1472]],["radioradar.net",1471],["2ip.ru",[1471,1472]],["severpost.ru",[1471,4118]],["bhf.io",1473],["d3ward.github.io",1475],["meduza.io",1476],["mega.io",1477],["mega.nz",1477],["multiup.io",1478],["starve.io",1479],["thebell.io",1480],["vtimes.io",1481],["house.kg",1483],["mashina.kg",[1483,1488]],["kabar.kg",1484],["kaktus.kg",1485],["kaktus.media",1485],["radiokp.ru",[1487,2275,3959]],["sport.kg",1491],["ts.kg",1492],["turmush.kg",1493],["megalyrics.ru",[1494,3502]],["newkaliningrad.ru",[1494,3661]],["24.kz",1495],["fanforum.ru",1495],["24pdd.kz",1496],["3dnews.kz",[1497,1498]],["3dnews.ru",[1497,1498]],["irecommend.ru",[1498,3212]],["activ.kz",1499],["novadoba.com.ua",[1501,4973]],["aktobeinfo.kz",1502],["alser.kz",1504],["bizmedia.kz",[1505,1506]],["nur.kz",[1506,1526,1527]],["coap.kz",1507],["forbes.kz",1509],["hcbarys.kz",1511],["ifin.kz",1512],["informburo.kz",1513],["kinomania.kz",1514],["kinoprosmotr.site",1514],["casstudio.tv",[1514,4777]],["kivvi.kz",1515],["kiwi.kz",1516],["mail.kz",1518],["mhelp.kz",1520],["l-a-w.ru",1520],["motorshop.kz",[1521,1522]],["book-online.com.ua",1521],["nalogikz.kz",1523],["newauto.kz",1525],["turbopages.org",1527],["1obl.ru",1527],["biofile.ru",1527],["domodedovoriamo.ru",[1527,2831]],["flashgames.ru",1527],["footballreview.ru",[1527,2976]],["girlsgogames.ru",1527],["klinriamo.ru",[1527,2831]],["kolomnariamo.ru",[1527,2831]],["korolevriamo.ru",[1527,2831]],["krasnogorskriamo.ru",[1527,2831]],["lubertsyriamo.ru",[1527,2831]],["forum.mista.ru",[1527,2279,3533]],["mytischiriamo.ru",[1527,2831]],["nightwarez.ru",1527],["podolskriamo.ru",[1527,2831]],["reutovriamo.ru",[1527,2831]],["riamobalashiha.ru",[1527,2831]],["schelkovoriamo.ru",[1527,2831]],["sergposadriamo.ru",[1527,2831]],["serpuhovriamo.ru",[1527,2831]],["solnechnogorskriamo.ru",[1527,2831]],["zhukovskiyriamo.ru",[1527,2831]],["serialu.tv",1527],["olx.kz",1528],["olx.ua",1528],["olx.uz",1528],["orda.kz",[1529,1530]],["akniga.org",[1529,2078]],["newsvideo.su",[1529,2078,4722]],["platon.kz",1532],["prodengi.kz",1533],["shaiba.kz",[1535,1536,1537]],["siropik.ru",1536],["moei.ru",1537],["chernomorets.odessa.ua",1537],["i.ua",[1540,2141,5074]],["time.kz",1544],["business-class.su",1544],["mix.tn.kz",1545],["turanpress.kz",1546],["vesti.kz",1547],["sia.ru",[1549,4131]],["vse.kz",1550],["kolyan.net",1550],["traffilm.net",1550],["yk-news.kz",[1552,1553]],["2x2.su",[1553,4692]],["yvision.kz",1554],["bug.org.ua",1554],["muzika.ru",1556],["pravo.zakon.kz",1558],["www.zakon.kz",[1559,1560]],["kolombo-online.ru",1560],["tripoli.land",1561],["surl.li",1562],["zabeba.li",1563],["zadolba.li",1564],["imgbum.ru",[1564,2387,2389,3172]],["xpicture.ru",[1564,2387,2389,3172]],["epizod.life",1566],["igra.life",1567],["mirkrasoty.life",1568],["arduino-project.net",1568],["ryazan.life",[1569,1570]],["krym.news",1569],["novostivl.ru",[1569,3702]],["v-tatarstane.ru",[1569,4457]],["tnt-premier.life",1572],["varplatform.life",1573],["bitshare.link",1574],["knigi.link",1575],["sysadmin.link",1576],["24.animez.live",1577],["cherkasy.live",1578],["cyberscore.live",1579],["poimel.live",1582],["sport247.live",1585],["zombie-film.live",1587],["banki.loans",1588],["frkp.lol",1589],["bb.lv",1590],["delfi.lv",1591],["delo.ua",[1593,3709,5028]],["makler.md",1595],["mamaplus.md",1596],["noi.md",1598],["gafki.ru",[1600,2317]],["rabota.md",1601],["me",[1602,1603]],["livetvstream.pro",1603],["2ip.me",1604],["abc-fonts.me",1605],["anime-chan.me",1607],["artfile.me",1608],["batsa.me",1609],["express-novosti.ru",[1609,2914]],["biggestplayer.me",1610],["brainstorage.me",1611],["freelansim.ru",[1611,2993]],["moikrug.ru",1611],["tmfeed.ru",1611],["center4.me",1612],["news.center4.me",1613],["clib.me",1614],["emusic.me",1617],["fanfics.me",1618],["filmhd1080.me",1619],["gdzputina.me",1620],["botanam.net",1620],["hideip.me",1621],["kinofrukt.me",1622],["kinotorrs.me",1623],["litmir.me",1625],["lleo.me",1626],["myzcloud.me",[1629,1630]],["sims3pack.ru",[1630,4140]],["nekto.me",1631],["itcats.ru",1631],["w10.jeanzzz.ru",[1631,3238]],["noadsradio.ru",1631],["sharkgame.ru",1631],["animeland.su",1631],["studies.in.ua",1631],["opennet.me",[1633,1634]],["opennet.ru",[1633,1634,3758]],["pejnya.me",1635],["pejnya.net",1635],["poiskm.me",1636],["ranobelib.me",1637],["rbook.me",1638],["rebill.me",1639],["repack.me",1640],["rozetked.me",1642],["rulit.me",1643],["shikimori.me",1645],["shikimori.one",1645],["shikimori.org",1645],["slivup.me",1646],["smotriserial.me",1647],["tasix.me",[1649,1650]],["kino.video",1649],["topradio.me",1651],["uakino.me",1653],["unsorted.me",1654],["walking-dead.me",1657],["yummyani.me",1658],["yummy-anime.ru",1658],["adme.media",1659],["agents.media",1660],["detector.media",1662],["knife.media",1665],["lemonade.style",1665],["kyiv.media",1667],["speka.media",[1669,1678]],["dfm.ru",[1670,2798,2799]],["ivona.ua",[1670,3952]],["opentv.media",1672],["orenburg.media",1673],["processer.media",1675],["rivne.media",1676],["slukh.media",1677],["3ddd.ru",[1678,2346]],["newsua.ru",[1678,2016,3673]],["smolnarod.ru",1678],["tv-gubernia.ru",[1678,4407]],["voip.ru",1678],["yablor.ru",1678],["vmeste.tv",[1678,4846]],["profidom.com.ua",1678],["thepage.ua",1678],["tavr.media",1679],["hitfm.ua",1679],["kissfm.ua",[1679,5122]],["melodiafm.ua",1679],["radiorelax.ua",1679],["radioroks.ua",[1679,5199]],["rusradio.ua",1679],["tavrmedia.ua",1679],["play.tavr.media",1680],["usm.media",1681],["news.meta.ua",1681],["zona.media",1682],["1000.menu",1683],["divxplayer.ml",[1684,1685]],["hcdn.online",[1684,1685]],["player.cvary.org",[1684,1685]],["haes.tech",[1684,1685]],["metaverseid.tk",[1684,1685]],["hqq.tv",[1685,4795]],["hitvk.mobi",1686],["rugame.mobi",1688],["sex-comics.mobi",1689],["russian7.ru",[1689,4057]],["lenfilm.tv",1689],["cha.moscow",1691],["bdf.ms",1692],["donbass.name",1693],["hpc.name",1694],["inoe.name",1695],["forum.inoe.name",1696],["obninsk.name",1697],["wi-fi.ru",[1697,4551]],["gennadij.pavlenko.name",1698],["sergeistrelec.name",1699],["shanson.name",1700],["mp3.uzhgorod.name",1701],["vpk.name",1702],["1ttv.net",1704],["3ppc.net",1705],["7sim.net",1706],["adultboard.net",1707],["aflenses.net",1708],["alexlarin.net",1710],["allcrimea.net",1711],["alldz.net",1712],["allsport-news.net",[1713,1714]],["allsport-live.ru",1713],["anekdotov.net",1715],["askentire.net",1716],["avan-ti.net",[1718,1719]],["serialrussian.ru",[1719,4113]],["porevo.site",1719],["vk.barkov.net",1720],["osnova.news",[1720,2030]],["best-soft.net",1722],["afisha.bigmir.net",1726],["techno.bigmir.net",1727],["brotorrent.net",1728],["torrent-mass.ru",1728],["windows10activation.ru",1728],["cat-a-cat.net",1729],["o-filme.ru",1729],["hi-tech-pro.ru",1730],["check-host.net",1733],["clubfile.net",1734],["crackstatus.net",1735],["crimea-board.net",1736],["cxem.net",1737],["forum.cxem.net",1738],["darkteam.net",1739],["delphimaster.net",1740],["design-for.net",1741],["diakov.net",1742],["dictat.net",[1743,1744]],["megatest.online",[1743,2057]],["fithacker.ru",1743],["storyfox.ru",1743],["cluber.com.ua",1743],["dofiga.net",1745],["dok-film.net",1746],["howdyho.net",1746],["howdyho.pro",1746],["doranime.net",1747],["nnm-club.pw",1747],["dreamprogs.net",1748],["driveroff.net",[1749,1750]],["samlab.ws",[1749,5288]],["dropmefiles.net",1752],["dropmefiles.com.ua",1752],["emu-land.net",1756],["erichware.net",1757],["frenglish.ru",[1758,2998]],["fantasiya.net",1761],["feofan.net",1762],["file-tracker.net",1765],["filmodrom.net",1766],["filmstvclub.net",1767],["fotoinform.net",1769],["freeexe.net",1770],["freelogovectors.net",1771],["simplewine.ru",1771],["funnymir.net",1772],["hereinteresting.ru",1772],["intersnoznat.ru",1772],["futbik.net",1773],["gamedayz.net",1774],["games-archive.net",1776],["games-porno.net",1777],["games-reviews.net",1778],["zagonkop.gb.net",1779],["zagonkov.gb.net",1779],["zagonka.net",1779],["zagonko.org",1779],["zogonka.org",1779],["zagonka.tv",1779],["gearshout.net",1780],["bouweenpc.nl",1780],["bagnet.org",[1780,2099]],["get-tune.net",[1781,1782]],["mirmmo.ru",[1781,3531]],["oneprogs.ru",[1781,3745]],["gitarshkola.net",1783],["gmt-max.net",1784],["goldroyal.net",1785],["good73.net",1786],["haleava.net",1787],["fullgames.ru",[1787,3004]],["hi-fi-forum.net",1790],["hitfile.net",1791],["ikinokz.net",1794],["imagenizr.net",1795],["india-tv.net",1796],["ingrus.net",1797],["internetno.net",1798],["kak-prosto.net",1800],["katushka.net",1801],["kino-portal.net",1802],["kinoakter.net",1803],["kinobanda.net",1804],["kinobaza.net",1805],["kinobb.net",1806],["kinodroid.net",1807],["kinogid-online.net",1808],["kinopictures.net",1809],["kinoprofi.net",1810],["kinorai.net",1811],["kinoshek.net",1812],["klivent.net",1813],["komapz.net",1814],["komarovskiy.net",1815],["korrespondent.net",[1816,1817]],["isport.ua",[1817,5103]],["korzik.net",1818],["football.kulichki.net",1820],["l2on.net",1821],["lavnik.net",1824],["libertycity.net",1825],["libertycity.ru",1825],["linuxthebest.net",1827],["litlib.net",1828],["lostpic.net",1830],["lrepacks.net",[1831,1832,1833]],["radarmedia.net",[1832,1916,1917]],["macovod.net",1834],["magicfilm.net",1835],["funtik.tv",1835],["mapakids.net",1836],["medical-club.net",1837],["mega-tracker.net",1838],["megamult.net",1839],["megaonlines.net",1840],["inmoment.ru",[1840,3190]],["megogo.net",1841],["memesmix.net",1842],["metrogame.net",1843],["midasbox.net",1844],["mir-snov.net",1845],["4fun.mksat.net",1846],["mmaps.net",1847],["mobportal.net",1848],["modernfirearms.net",1849],["modgames.net",1850],["moiprogrammy.net",1852],["mp3lemon.net",1853],["mp3party.net",1854],["mp3poisk.net",1855],["mskins.net",1856],["multik-online.net",1857],["multiki-online.net",1858],["musinfo.net",1859],["my-ref.net",1860],["myanimelist.net",1861],["mychords.net",1862],["polaremont.ru",1862],["stokvod.ru",1862],["soft.mydiv.net",1864],["nagon.net",1866],["nanoreview.net",1867],["naogorode.net",1868],["narodclub.net",1869],["nashaplaneta.net",1870],["nastroy.net",1871],["brovary.net.ua",1872],["newbum.net",1873],["nikopolnews.net",1875],["notorgames.net",1876],["1progs.ru",[1876,2317]],["novinki-kino.net",1877],["smotra.net",1877],["novoruskino.net",[1878,1879]],["ruskinonovoe.net",1879],["novostiua.net",1880],["nowgamer.net",1881],["ochevidec.net",1882],["onfilmz.net",1883],["oszone.net",1884],["forum.oszone.net",1885],["soft.oszone.net",1886],["otzyvua.net",1887],["pcprogs.net",1888],["peugeot-club.net",1889],["phpbbguru.net",1890],["piccash.net",1891],["pingvinoff.net",1892],["piratemedia.net",1893],["pirate-party.ru",1893],["pise4ka.net",1894],["plohihmacov.net",1896],["poezdato.net",1897],["poizdato.net",1897],["poleno.net",1898],["topcor.ru",[1903,4360]],["politolog.net",1904],["porjati.net",1906],["pornoham.net",1907],["pornomage.net",1908],["posylka.net",1909],["prog-top.net",1910],["programki.net",1911],["prsport.net",1912],["puchkov.net",1913],["putingamer.net",1914],["questtime.net",1915],["prozoro.net.ua",[1916,5158]],["rifme.net",1922],["rosserial.net",1924],["rserials.net",1925],["rsload.net",1926],["forum.rsload.net",1927],["offisny.ru",1927],["ru-admin.net",1928],["kinogo.ru.net",1929],["rus-linux.net",1930],["ruseo.net",1931],["russkoekino.net",1932],["santikov.net",1934],["savepic.net",1935],["scantrad.net",1936],["season-var.net",1937],["seosprint.net",1938],["vip-prom.net",1938],["seo-master.org",1938],["sexvideobaza.net",1940],["sintetiki.net",1942],["smotritv.net",1943],["softoroom.net",1945],["softoroom.org",1945],["sonnik-online.net",1946],["focus.ua",[1949,4660,5040,5054]],["sportgoal.net",1950],["studopedia.com.ua",1953],["stulchik.net",[1954,1955]],["kabachok.online",1954],["surgeryzone.net",1956],["tapochek.net",1957],["tech-choice.net",1958],["testsoch.net",1959],["toneto.net",1962],["toolslib.net",1963],["torrent-xatab.net",1964],["torrento.net",1965],["newserials.tv",1965],["transkarpatia.net",1967],["translit.net",1968],["tyurem.net",1969],["ucoin.net",1970],["595.ucoz.net",1971],["ukr.net",1972],["absite.ru",1974],["kinopod.ru",[1974,3293]],["valetudo.ru",[1974,4461]],["uniongang.net",1977],["uniongang.org",1977],["utorrentgames.net",1978],["vesti-ua.net",1979],["byzoo.org",1980],["videoshara.net",1982],["notefood.ru",[1982,3694]],["vidoza.net",1983],["winnote.ru",1984],["vremenno.net",1985],["vsedoramy.net",1986],["vsekamni.net",1987],["vsplanet.net",1988],["wallegend.net",1989],["wallscloud.net",1990],["wav-library.net",1991],["windows64.net",1992],["winzoro.net",1993],["wkino2.net",1994],["wm-help.net",1996],["womansay.net",1997],["x-uboino.net",2000],["xboxland.net",2001],["xittv.net",2002],["newsler.ru",2002],["xmages.net",2003],["xn--m1ah5a.net",2004],["xyya.net",2005],["yakutsk-news.net",2006],["zakarpatpost.net",2008],["zaxid.net",[2009,2010,2011,2012]],["football24.ua",[2010,2012,5056]],["zwezda.net",[2015,2016,2017]],["primgazeta.ru",2017],["360tv.news",2018],["aum.news",[2019,2020]],["bash.news",2021],["brokker.news",2022],["ctrana.news",2023],["strana.news",2023],["ctrana.one",2023],["strana.one",2023],["strana.today",2023],["dontimes.news",2024],["doramalive.news",2025],["kolo.news",2026],["goodgame.ru",[2026,3071]],["pg11.ru",[2026,3814]],["pg12.ru",[2026,3814,3815]],["pg13.ru",[2026,3814,3815]],["pg21.ru",[2026,3814,3815]],["prochepetsk.ru",[2026,3814]],["prodzer.ru",[2026,3814,3898]],["progorod33.ru",[2026,3814]],["progorod43.ru",[2026,3814,3815]],["progorod58.ru",[2026,3814]],["progorod62.ru",[2026,3815]],["progorod76.ru",[2026,3814]],["progorodnn.ru",[2026,3814]],["progoroduhta.ru",[2026,3814]],["nabat.news",2028],["noworries.news",2029],["ip.osnova.news",2031],["readovka67.ru",[2033,3993]],["abnews.ru",[2036,2380]],["susanin.news",2037],["rb.ru",2037],["uzreport.news",2039],["postal.ninja",2041],["spele.nl",2042],["comss.one",2043],["comss.ru",2043],["dublikat.one",2044],["mmo.one",2045],["newsua.one",2046],["onlinetv.one",2047],["spys.one",2048],["glaz-ok.online",2052],["gorod24.online",[2053,2054]],["kirov.online",2055],["lolzteam.online",2056],["mogilev.online",2058],["mymsk.online",2059],["piggy-bank.online",2060],["auto62rus.ru",2060],["eset-key.ru",2060],["mycrib.ru",2060],["showmehow.ru",2060],["realist.online",2062],["rudub.online",2063],["russia-tv.online",2064],["semestr.online",[2065,2066,2067]],["semestr.ru",[2065,2066,2067]],["skam.online",2068],["stormo.online",2069],["stormo.tv",2069],["the-cinema.online",2070],["tv-interny.online",2071],["21region.org",2073],["24smi.org",2074],["7ba.org",2075],["7ba.ru",2075],["akipress.org",2077],["alensat.org",[2079,2080]],["forummikrotik.ru",2080],["allbookerka.org",2082],["alleng.org",2083],["libren.org",2083],["allkey.org",2084],["anigang.org",[2086,2087]],["anifors.ru",2087],["animecos.ru",2087],["animesos.ru",2087],["shinigami.tv",2087],["animego.org",2089],["appmo.org",2093],["appstudio.org",2094],["armtv.org",2095],["gorod.cn.ua",[2095,4888]],["baginya.org",[2096,2097]],["forum.baginya.org",2098],["bape3.org",2100],["bigfangroup.org",2101],["freebfg.org",2101],["binmovie.org",2102],["biqle.org",[2103,2104]],["biqle.ru",2103],["body-builder.org",2106],["bookre.org",2108],["bratsk.org",2109],["christianka.bratstvo.org",2110],["cameralabs.org",2111],["catorrent.org",2112],["charter97.org",2113],["chasdiy.org",2114],["darktorrent.org",2116],["8vp.ru",[2117,2372]],["doramax.org",2118],["download-windows.org",2119],["softhome.ru",2119],["mo4movin.dyndns.org",2120],["wildberries.ru",[2120,4554]],["electrik.org",2121],["euroki.org",2122],["exnews.org",2123],["fastpic.org",[2124,2125]],["www.kinopoisk.ru",[2125,3294,3295]],["fenzin.org",2126],["findhow.org",2127],["fortrader.org",2128],["forumua.org",2129],["dovidka.biz.ua",2129],["xn---2--mddxunv8a2esa.xn--p1ai",[2129,5297]],["fotoshop-online.org",2130],["freeisland.org",2131],["freetp.org",2132],["freetp.ru",2132],["gamestracker.org",2134],["gisher.org",2135],["goroskop.org",2137],["greasyfork.org",2138],["hack-tool.org",2139],["hdstudio.org",2140],["helpiks.org",[2141,2142]],["ru-minecraft.org",2141],["footballfacts.ru",2141],["mota.ru",2141],["ojin.tv",2141],["fbc.biz.ua",[2141,4881,4882]],["homeporno.org",2143],["igrozor.org",2146],["internetsms.org",2148],["kaztorka.org",2150],["kinobase.org",2151],["kinovit.org",2152],["knigavuhe.org",2153],["knizhnik.org",2154],["konohatv.org",2155],["kubyshka.org",2156],["riperam.org",[2156,2205]],["radiochief.ru",2156],["ladyclub.org",2157],["lion-tv.org",2159],["literator.org",2160],["live-sports101.org",[2161,2162]],["uchim.org",2161],["pastila-club.ru",2161],["loginz.org",2163],["lubbook.org",2164],["masteroff.org",2165],["mediapapa.org",2166],["mir-games.org",2167],["mixupload.org",2168],["mozilla-russia.org",2169],["mozutil.mozilla-russia.org",2170],["multmer.org",2171],["my-hit.org",2172],["nemo-crack.org",[2173,2174]],["imgal.ru",[2173,3171]],["newrezume.org",2175],["newsoboz.org",2176],["nikcenter.org",2177],["nnov.org",2178],["nnportal.org",2179],["nntt.org",2180],["novorosinform.org",2181],["obmenvsem.org",2183],["odnako.org",2184],["opensharing.org",2186],["freepiks.ru",[2186,2994]],["pcportal.org",2187],["photolessons.org",2188],["pollee.org",2191],["ppt-online.org",2192],["prigotovit.org",[2193,2194]],["piling.re",[2193,2194]],["avtonavideo.ru",[2193,2194]],["chinimavto.ru",[2193,2194]],["minecraftnavideo.ru",[2193,2194]],["multivarki-redmond.ru",[2193,2194]],["odezhda2.ru",[2193,2194]],["pol-video.ru",[2193,2194]],["prohozhuigru.ru",[2193,2194]],["remontnavideo.ru",[2193,2194]],["televizor2.ru",[2193,2194]],["shiny2.ru",2194],["probirka.org",[2195,2196]],["auto.vesti.ru",[2196,4478]],["gameportalrf.ru",2197],["proporno.org",2200],["pxtracker.org",[2201,2202]],["vtracker.org",[2201,2202]],["vk.xakep.org",2201],["gamedev.ru",2201],["prowebber.ru",[2201,3929]],["rfpl.org",2203],["forum.rhbz.org",2204],["roskomsvoboda.org",2206],["ru-m.org",2207],["rubook.org",2208],["rubukkit.org",2209],["rutracker21.org",2210],["sarafannoeradio.org",2211],["scarabey.org",2212],["sea-man.org",2213],["sinonim.org",2216],["sixinch.org",2218],["smapps.org",2219],["solidarnost.org",2220],["sotniktv.org",2221],["streamzone.org",2222],["leksika.com.ua",2223],["forum.tambovnet.org",2224],["tavrijci.org",2225],["the-ebook.org",2226],["thelastupd.org",2227],["torrent-stop.org",2228],["torrpeda.org",2229],["traht.org",2230],["turkcinema.org",2232],["tv-fresh.org",2234],["tvizor.org",2235],["smotretonline.ucoz.org",2236],["uniondht.org",2237],["univertv.org",2238],["usemind.org",2239],["forum.vip-cxema.org",2241],["vsitv.org",2243],["vsthemes.org",2244],["wmasteru.org",2245],["womenzone.org",2246],["x360-club.org",2248],["xxx-base.org",2249],["xxx-game.org",2250],["zadonbass.org",2252],["forum.hdtv.ru",2252],["efir.plus",2253],["kratko.plus",2254],["glagol.press",2257],["all-best.pro",2258],["animedia.pro",2259],["tt.animedia.tv",2259],["bankdirect.pro",2260],["chipinfo.pro",2261],["expert-dacha.pro",2262],["gayzona.pro",2263],["infotechnic.pro",2264],["jobvacancy.pro",2265],["kino-mania.pro",2266],["losst.pro",2267],["remontka.pro",2269],["riwkus.pro",2270],["audiobook.rmail.pro",2271],["rutor-group.pro",2272],["sport-tv.pro",2273],["survarium.pro",2274],["sportkp.ru",[2275,4222]],["ukrsport.pro",2277],["unews.pro",[2278,2279]],["vecdn.pw",2280],["hromadske.radio",2281],["cpa.rip",2282],["nnmclub.ro",2283],["nnmclub.to",2283],["mayday.rocks",2284],["turkca.0pk.ru",2286],["1000sovetov.ru",2287],["10i5.ru",2293],["116.ru",[2294,2295,2296,2297,2298,2299,2300,2301,2302]],["14.ru",[2294,2295,2296,2297,2300]],["161.ru",[2294,2295,2296,2297,2300,2301]],["164.ru",[2294,2295,2296,2297,2300,2301]],["173.ru",[2294,2295,2297,2300,2301]],["178.ru",[2294,2295,2296,2297,2300]],["26.ru",[2294,2295,2296,2297,2300,2301]],["29.ru",[2294,2295,2296,2297,2300]],["35.ru",[2294,2295,2296,2297,2300]],["43.ru",[2294,2295,2296,2297,2300]],["45.ru",[2294,2295,2296,2297,2298,2300]],["48.ru",[2294,2295,2296,2297,2300]],["51.ru",[2294,2295,2296,2297,2300]],["53.ru",[2294,2295,2296,2297,2300]],["56.ru",[2294,2295,2296,2297,2300]],["59.ru",[2294,2295,2296,2297,2298,2300,2301,2359]],["60.ru",[2294,2295,2296,2297,2300]],["62.ru",[2294,2295,2296,2297,2300]],["63.ru",[2294,2295,2296,2297,2300,2301]],["68.ru",[2294,2295,2296,2297,2300]],["71.ru",[2294,2295,2296,2297,2300]],["72.ru",[2294,2295,2296,2297,2299,2300,2301,2302,2363,2364]],["74.ru",[2294,2295,2296,2297,2299,2300,2301,2363,2364]],["76.ru",[2294,2295,2296,2297,2300,2301]],["86.ru",[2294,2295,2296,2297,2300]],["89.ru",[2294,2295,2296,2297,2300]],["93.ru",[2294,2295,2296,2297,2298,2300,2301]],["chita.ru",[2294,2295,2296,2297,2299,2300,2363,2364,2706]],["e1.ru",[2294,2295,2296,2297,2299,2300,2301,2302,2363,2864]],["izh1.ru",[2294,2295,2296,2297,2300]],["mgorsk.ru",[2294,2295,2296,2297,2300]],["msk1.ru",[2294,2295,2296,2297,2300]],["ngs.ru",[2294,2295,2296,2297,2299,2300,2301,2359,2363,2364]],["ngs22.ru",[2294,2295,2296,2297,2300]],["ngs24.ru",[2294,2295,2296,2297,2300,2301]],["ngs42.ru",[2294,2295,2296,2297,2298,2300]],["ngs55.ru",[2294,2295,2296,2297,2298,2299,2300,2301,2302]],["ngs70.ru",[2294,2295,2296,2297,2300]],["sochi1.ru",[2294,2295,2296,2297,2300,2301]],["sterlitamak1.ru",[2294,2295,2296,2297,2300]],["tolyatty.ru",[2294,2295,2296,2297,2300,2301]],["ufa1.ru",[2294,2295,2296,2297,2300,2301,2363,2364]],["v1.ru",[2294,2295,2296,2297,2298,2300,2301]],["vladivostok1.ru",[2294,2295,2297,2300,2301]],["voronezh1.ru",[2294,2295,2296,2297,2300,2301]],["www.nn.ru",2301],["125region.ru",2303],["156.ru",2304],["16-bits.ru",2305],["19216811.ru",2309],["1fenshui.ru",2310],["1gai.ru",2312],["1pnz.ru",2315],["1pokirpichy.ru",2316],["1track.ru",2319],["21forum.ru",2321],["forum.na-svyazi.ru",2321],["forum.zarulem.ws",2321],["23met.ru",2322],["24auto.ru",2323],["24pdd.ru",2324],["26-2.ru",[2325,2326]],["arbitr-praktika.ru",[2325,2326]],["budgetnik.ru",[2325,2326]],["buhsoft.ru",2325],["business.ru",[2325,2326]],["cxychet.ru",[2325,2326]],["dirsalona.ru",[2325,2326]],["fd.ru",[2325,2326]],["gazeta-unp.ru",[2325,2326]],["gd.ru",[2325,2326]],["gkh.ru",[2325,2326]],["glavbukh.ru",[2325,2326,3058]],["hr-director.ru",[2325,2326]],["kdelo.ru",[2325,2326]],["kom-dir.ru",[2325,2326]],["law.ru",[2325,2326]],["lawyercom.ru",[2325,2326]],["menobr.ru",[2325,2326]],["nalogplan.ru",[2325,2326]],["pro-goszakaz.ru",[2325,2326]],["pro-personal.ru",[2325,2326]],["resobr.ru",[2325,2326]],["rnk.ru",[2325,2326]],["sekretariat.ru",[2325,2326]],["stroychet.ru",[2325,2326]],["trudohrana.ru",[2325,2326]],["ugpr.ru",[2325,2326]],["zarplata-online.ru",[2325,2326]],["zdrav.ru",[2325,2326]],["budgetnyk.com.ua",[2325,2326]],["dzakupivli.com.ua",[2325,2326]],["kadrovik01.com.ua",[2325,2326]],["medsprava.com.ua",[2325,2326]],["sop.com.ua",[2325,2326]],["golovbukh.ua",[2325,2326]],["buhsoft.ru26-2.ru",2326],["27r.ru",2327],["27sysday.ru",2328],["ojimail.ru",2328],["donetskfishing.2bb.ru",2329],["parfumclub.9bb.ru",2329],["colorforum.ru",[2329,2731]],["alpclubmei.mybb.ru",2329],["fkme.nc-21.ru",2329],["webtalk.ru",[2329,4547]],["wmforum.2bb.ru",2330],["2krota.ru",2332],["2olega.ru",2334],["7lostworlds.ru",2335],["2whois.ru",2336],["2womans.ru",2337],["psysovet24.ru",2337],["31tv.ru",[2339,2340]],["novostiliteratury.ru",2339],["kazan.32top.ru",2341],["360.ru",2342],["38mama.ru",2345],["3dn.ru",2347],["megasoft.3dn.ru",[2348,2349]],["athlete.ru",2349],["kotomatrix.ru",2349],["probiysk.ru",[2349,3897]],["3drubik.ru",2350],["3dtoday.ru",2351],["3mod.ru",2352],["3mp3.ru",2353],["3mv.ru",2354],["libsib.ru",[2355,3368]],["mydocx.ru",2355],["4725.ru",2356],["47news.ru",2357],["5litra.ru",2360],["66.ru",2362],["www.e1.ru",[2364,2865]],["80-e.ru",2370],["8lap.ru",2371],["9111.ru",2373],["9sx.ru",2374],["a-russia.ru",2375],["seeds.org.ua",2375],["a42.ru",2376],["abkhasiya.ru",2379],["rp-mechanics.ru",[2379,4034]],["fakty.ua",[2380,5048]],["academic.ru",2381],["acer-a500.ru",2382],["rabota-kovrov.ru",2382],["sosnovskij.ru",[2382,4194]],["ackordofmine.ru",2383],["acomics.ru",2384],["actualtraffic.ru",2385],["adhands.ru",2386],["adult-images.ru",[2387,2388,2389]],["screenpost.ru",[2387,2472,4092]],["advesti.ru",2390],["aeslib.ru",2392],["afisha.ru",2393],["daily.afisha.ru",2394],["www.afisha.ru",2395],["afisha21.ru",2396],["pogoda21.ru",[2396,3849]],["afportal.ru",2397],["ag.ru",2398],["agilerussia.ru",2399],["agro-biz.ru",[2400,2401]],["ecology-of.ru",2400],["agrognom.ru",2402],["apral.ru",[2402,2486]],["kvmarvel.ru",2402],["agroxxi.ru",2403],["akademekb.ru",2405],["akak.ru",2406],["akakpravilno.ru",2407],["alcodistillers.ru",2408],["alexbruni.ru",2410],["click.alfabank.ru",2412],["aliexpressblog.ru",2413],["alimero.ru",2414],["all-biography.ru",2415],["all-for-kompa.ru",2416],["all-gigiena.ru",2417],["allbest.ru",2419],["allcarz.ru",[2422,2423]],["allcc.ru",2424],["alldonors.ru",2426],["allfight.ru",2427],["allgosts.ru",2428],["allhockey.ru",2429],["allking.ru",2430],["pornoshara.tv",[2430,4822]],["alllyr.ru",2431],["allmmorpg.ru",2432],["allrefrs.ru",2433],["allrepack.ru",2434],["allsport-tv.ru",2435],["allunix.ru",2436],["alphapedia.ru",2437],["alpindustria.ru",2438],["alvin-almazov.ru",[2442,2443]],["forum.amit.ru",2445],["amsterdamtravel.ru",2446],["amurpress.ru",2447],["anchem.ru",2448],["andevice.ru",[2449,2450]],["androeed.ru",2451],["androidinsider.ru",[2452,2453]],["myvi.ru",[2452,3621]],["appleinsider.ru",[2453,2484]],["hi-news.ru",[2453,3125]],["androproblem.ru",2454],["angvremya.ru",2456],["animalbox.ru",2457],["anime100500.ru",2459],["anime777.ru",2460],["animedub.ru",2461],["animejoy.ru",2462],["animemaga.ru",2463],["animemovie.ru",2465],["animestars.ru",2466],["anisima.ru",2467],["anti-free.ru",2469],["anypictures.ru",[2471,2472,2473]],["pixcloud.ru",[2472,2473]],["apest.ru",2475],["apidog.ru",2476],["apihot.ru",2478],["games.apitech.ru",2479],["www.aport.ru",2480],["app-s.ru",2481],["appstorrent.ru",2485],["kino-russfilm.ru",2486],["topgir.com.ua",[2486,5005]],["aptekamos.ru",2488],["arhangel.ru",2491],["ariom.ru",2492],["armflot.ru",2493],["armtorg.ru",2494],["aromatmasla.ru",[2495,2496]],["artemsannikov.ru",2497],["artfile.ru",2498],["artinvestment.ru",2499],["artlifebazar.ru",2500],["artsgtu.ru",2501],["asienda.ru",[2504,2505]],["diets.ru",[2504,2505,2803]],["mycharm.ru",[2504,2505]],["myjane.ru",[2504,2505,3610]],["stranamam.ru",[2504,2505,3610,4256]],["asna.ru",2506],["assessor.ru",2507],["forum.astrakhan.ru",2509],["astralomir.ru",2510],["astrohelper.ru",2511],["astv.ru",2513],["forum.athlete.ru",2514],["au.ru",2515],["audio-hi-fi.ru",2516],["electro-sila.ru",2516],["audit-it.ru",2517],["auto-dvrs.ru",2519],["auto-kmu.ru",2520],["auto43.ru",[2521,2522]],["dom43.ru",2522],["gorodkirov.ru",2522],["job43.ru",2522],["autocad-master.ru",2523],["autodoc.ru",2525],["spbit.ru",[2525,4211]],["autogener.ru",2526],["autolada.ru",2527],["autolikes.ru",2528],["autonevod.ru",2529],["rbclife.ru",[2533,3986]],["autostat.ru",2534],["autotom.ru",2535],["x-soft.tomsk.ru",[2535,4355]],["autotopik.ru",2536],["autotraveler.ru",2537],["avatan.ru",2538],["riatomsk.ru",[2538,4016]],["aviaham.ru",2539],["www.avito.ru",2540],["jekstrasens.ru",2541],["avtoradio.ru",[2544,2545]],["avtosreda.ru",[2546,2547]],["avtovokzaly.ru",2548],["infoindustria.com.ua",2550],["horo.meta.ua",2550],["forum.awd.ru",2551],["azbooki.ru",2552],["engisys.ru",2552],["zip1000.ru",2552],["azovnews.ru",2553],["b17.ru",2554],["klex.ru",2554],["koob.ru",[2554,3323]],["babyblog.ru",2557],["babysaratov.ru",2558],["balakhna.ru",2559],["banki.ru",2560],["bankiros.ru",2561],["barneos22.ru",2562],["bashinform.ru",2563],["bashskazki.ru",2564],["batenka.ru",2565],["baza-nomerov.ru",2566],["bazatabletok.ru",2567],["bazr.ru",2568],["bbcont.ru",2569],["bbs-sk.ru",2570],["bdmbase.ru",2571],["beatmake.ru",2572],["beautiflash.ru",2573],["popcake.tv",2573],["blackhole.beeline.ru",2574],["homenet.beeline.ru",2575],["benzin-price.ru",2578],["beon.ru",2579],["berkem.ru",2580],["best-antidepressanty.ru",2582],["bestfree.ru",2583],["bestpersons.ru",2585],["bezformata.ru",2587],["bfm.ru",2588],["bibliofond.ru",2589],["bigness.ru",2592],["bigpuzzle.ru",2594],["bikepost.ru",2595],["biletyplus.ru",2596],["biomolecula.ru",2597],["bioware.ru",2598],["bitcryptonews.ru",[2600,2601,2602]],["apostrophe.ua",[2601,4868]],["ogolosha.ua",[2601,5175]],["forum.materinstvo.ru",[2602,3471]],["vse-shutochki.ru",[2602,4520]],["biwork.ru",2603],["biysk-ok.ru",2604],["black-warez.ru",2605],["blackdesert-info.ru",2606],["blackwot.ru",[2607,2608]],["emdigital.ru",2608],["pogodavtomske.ru",[2608,3852,3853]],["blagden.ru",2609],["sitecoder.blogspot.ru",2613],["bloomchain.ru",2614],["bnkirov.ru",2616],["bobsoccer.ru",2617],["bolshoyvopros.ru",2619],["gol.ru",2621],["e-xecutive.ru",2625],["gibdd-gai.ru",2625],["bookz.ru",2626],["bookzvuk.ru",2627],["boomtv.ru",2628],["borda.ru",2629],["forum24.ru",2629],["myqip.ru",2629],["unoforum.ru",2629],["bosch-home.ru",2630],["botanichka.ru",[2631,2632]],["hs-manacost.ru",2632],["oren.ru",[2632,3764]],["boxkino.ru",2633],["briefly.ru",2636],["browserss.ru",2637],["poleznii-site.ru",2638],["brutaljack.ru",2639],["bryansknovosti.ru",2640],["novozybkov.su",[2640,4724]],["bryansktoday.ru",2641],["bs-life.ru",2642],["bukety-iz-konfet.ru",2644],["bunin-lit.ru",2645],["chehov-lit.ru",2645],["cult-lib.ru",2645],["cult-news.ru",2645],["dostoevskiy-lit.ru",2645],["esenin-lit.ru",2645],["gogol-lit.ru",2645],["kuprin-lit.ru",2645],["lermontov-lit.ru",2645],["lit-info.ru",2645],["nabokov-lit.ru",2645],["nekrasov-lit.ru",2645],["niv.ru",[2645,3683]],["paustovskiy-lit.ru",2645],["pushkin-lit.ru",2645],["referat-lib.ru",2645],["svr-lit.ru",2645],["tolstoy-lit.ru",2645],["turgenev-lit.ru",2645],["vysotskiy-lit.ru",2645],["burdastyle.ru",2646],["business-gazeta.ru",2647],["businessmens.ru",2650],["buyerinfo.ru",2651],["agronom.com.ua",2653],["bvedomosti.ru",2654],["bwtorrents.ru",2655],["forum.byw.ru",2656],["cadelta.ru",[2658,2659]],["modfarm.ru",2659],["cakevita.ru",2660],["darevamed.ru",2660],["calc.ru",2661],["calcus.ru",2663],["shkolazhizni.ru",2664],["caniplay.ru",2665],["car72.ru",2667],["carambatv.ru",2668],["career.ru",2669],["carobka.ru",2670],["carrotblog.ru",2671],["cars.ru",2672],["catchenglish.ru",2674],["cccp3d.ru",2676],["ccoins.ru",2677],["playercdn.cdnvideo.ru",2678],["changeworks.ru",2679],["charming-face.ru",2680],["chastnik-m.ru",2681],["chatovod.ru",2682],["mobile-4at-obshenie.chatovod.ru",2683],["cheb.ws",[2686,2687,2688]],["zarulem.ws",[2687,3627,5291]],["cheezu.ru",2689],["chelny-izvest.ru",2690],["chelnyclub.ru",2691],["chelseablues.ru",2692],["chelseanews.ru",2693],["chemrise.ru",2694],["chess-samara.ru",2696],["chesspro.ru",2697],["chevy-niva.ru",2698],["forum.china-iphone.ru",2699],["chinaprices.ru",2700],["chinaspb350.ru",2701],["chipmaker.ru",[2703,2704]],["goldsrc.ru",[2704,3070]],["forum.chiptuner.ru",2705],["chto-proishodit.ru",2707],["chuvyr.ru",2708],["cian.ru",2709],["cisoclub.ru",2710],["city-n.ru",2711],["online-films.ckoro.ru",2712],["clan-soprano.ru",2713],["izmailov.tv",2713],["cleverstudents.ru",2714],["club.ru",2716],["club-lexus.ru",2717],["clubsandero.ru",2718],["clubtk.ru",2719],["cmlt.ru",2720],["cn.ru",[2721,2722]],["factorio.su",[2723,4706]],["anticollector.biz.ua",2723],["safe.cnews.ru",2725],["www.cnews.ru",2726],["docs.cntd.ru",2727],["m.ua",[2727,5043,5134]],["cod31.ru",2728],["cofp.ru",2729],["coil32.ru",2730],["old.kurs.com.ru",2733],["marvel.com.ru",2734],["pornolomka.com.ru",2735],["comboplayer.ru",2736],["comedy-radio.ru",2737],["comfysoft.ru",2738],["consmed.ru",2742],["cool-archive.ru",2743],["copypast.ru",2745],["cowcash.ru",2747],["cpainform.ru",2748],["cpykami.ru",2749],["crazygames.ru",2752],["creativportal.ru",2753],["crimea.ru",2754],["crmonline.ru",2755],["crypto-coins.ru",2756],["cs-amba.ru",2757],["csgolife.ru",2758],["csharpprogramming.ru",2759],["cska-hockey.ru",2760],["hctorpedo.ru",[2760,3114]],["csmania.ru",2761],["forum.csmania.ru",2762],["karaoke.ru",2763],["ctc-rnd.ru",2764],["odysseus.ctc.ru",2765],["ctnews.ru",2766],["culture.ru",2768],["cwetochki.ru",2769],["cyberforum.ru",2770],["cyberinfo.ru",2771],["cyberleninka.ru",2772],["cyberstyle.ru",2775],["d-russia.ru",2776],["d3.ru",2777],["daboom.ru",2778],["dachnye-sovety.ru",2779],["dailyhoro.ru",2781],["dari-radost13.ru",2782],["beadeath.dclans.ru",2784],["asn.in.ua",[2784,5087]],["delovoigorod.ru",2786],["delovoy-kirov.ru",2787],["delpc.ru",2788],["delpos.ru",2789],["demiart.ru",2790],["design-warez.ru",2793],["deti-obninsk.ru",2794],["detstrana.ru",2795],["dezbox.ru",2797],["hitfm.ru",2798],["montecarlo.ru",2798],["rusradio.ru",[2798,4056]],["dietaonline.ru",2801],["digger.ru",2804],["digibi.ru",2805],["dimonvideo.ru",2806],["directlot.ru",2807],["disney.ru",2808],["divx-kino.ru",2809],["dj.ru",2810],["djekxa.ru",2811],["djrogoff.ru",2812],["dlltop.ru",2813],["dnevnienovosti.ru",2814],["do.ru",2816],["doc-tv.ru",2817],["moya-planeta.ru",[2817,3584]],["naukatv.ru",2817],["ferr-um.ucoz.ru",2820],["doctube.ru",2821],["narodna-osvita.com.ua",2821],["dokak.ru",2823],["dom.ru",2824],["dom-sonnik.ru",2825],["gadania-na-lubov.ru",2825],["dom72.ru",2826],["domfailov.ru",2828],["domkad.ru",2829],["domodedovod.ru",2830],["domsnov.ru",2832],["domsovetof.ru",2833],["donday.ru",2834],["donday-aksay.ru",2834],["donday-novocherkassk.ru",2834],["donday-shakhty.ru",2834],["donday-taganrog.ru",2834],["volga-day.ru",2834],["forum.donfisher.ru",2835],["dorognoe.ru",[2836,2837]],["europaplus.ru",[2837,2905]],["radio7.ru",2837],["retrofm.ru",2837],["dotaguide.ru",2839],["dowlatow.ru",2840],["download-software.ru",2841],["stalkerportaal.ru",[2842,4241]],["top-mods.ru",[2842,4359]],["dressupmix.ru",[2843,2844]],["teensgames.ru",2844],["driver.ru",2847],["droidmod.ru",2848],["drom.ru",[2849,2850]],["forums.drom.ru",2851],["drupal.ru",2852],["dungeonmaster.ru",2855],["duster-clubs.ru",2856],["mail.ru",[2858,3416,3417,3418,3419,3420,3421,3422]],["sportsdzen.ru",[2860,4232]],["e-katalog.ru",2862],["ek.ua",[2862,5042,5043]],["e-sant.ru",2863],["eanews.ru",2866],["eapteka.ru",2867],["earth-chronicles.ru",2868],["ebay-russia.ru",2869],["ecigtalk.ru",2871],["ecm-journal.ru",2872],["edablog.ru",2875],["edadeal.ru",2876],["edimdoma.ru",2877],["edunews.ru",2878],["eftwiki.ru",2879],["www.eg.ru",[2880,2881]],["gorodche.ru",2881],["ekabu.ru",2882],["elbruso.ru",2883],["electric-house.ru",2884],["electroandi.ru",2885],["elhow.ru",2886],["elwo.ru",2887],["emuzic.ru",2888],["englishsub.ru",[2890,2891]],["lenglish.ru",2890],["ereko.ru",2892],["erudition.ru",2893],["eschemo.ru",2894],["esetnod32.ru",2895],["esoreiter.ru",2896],["esp8266.ru",2897],["espritgames.ru",2898],["etomesto.ru",2900],["fight.ru",[2902,2936,2937]],["football.konkurent.ua",2903],["eurosport.ru",2906],["evlas.ru",2908],["exdex.ru",2909],["expertcen.ru",[2912,2913]],["express-prigorod.ru",2915],["fanat1k.ru",2919],["fapl.ru",2920],["faqusha.ru",2921],["faston24.ru",2923],["fatcatslim.ru",2924],["fb.ru",2925],["fbsearch.ru",2926],["fcenter.ru",2928],["fchimik.ru",2929],["fcpug.ru",2931],["motor.ru",[2934,3578]],["secretmag.ru",[2934,4101]],["wmj.ru",2934],["ffoodd.ru",2935],["www.sport.ru",[2936,4218]],["file-online.ru",2938],["films-torrent.ru",2940],["finanz.ru",2942],["finecooking.ru",2943],["finfront.ru",2944],["finiz.ru",2946],["finmarket.ru",2947],["finzz.ru",[2949,2950]],["lolzona.ru",2949],["fion.ru",2951],["fit4power.ru",2953],["fiteria.ru",2954],["fitfan.ru",2955],["fitseven.ru",2956],["flashboot.ru",2958],["flashplayer.ru",2959],["floomby.ru",2960],["www.ogorod.ru",2961],["chis-chernomorsk.com.ua",[2961,4916]],["flowtation.ru",2962],["forum.flprog.ru",2963],["fluence-club.ru",2964],["flylady.ru",2965],["fm-app.ru",2966],["yootv.ru",2966],["tvapp.su",2966],["folkdoctor.ru",2967],["www.fontanka.ru",2970],["foodretail.ru",2973],["footballhd.ru",2975],["forbes.ru",2977],["forchecking.ru",2978],["forseven.ru",2979],["lifehaker.forum-top.ru",2980],["next-energy.forum2x2.ru",2982],["yakusubstudio.forum2x2.ru",2983],["znaemtolk.forum2x2.ru",2984],["forumhouse.ru",2985],["fotostrana.ru",2988],["fototelegraf.ru",2989],["fototips.ru",2990],["fragrantica.ru",2991],["freakenergy.ru",2992],["freescreens.ru",2995],["imgbase.ru",2995],["imgcach.ru",2995],["imgclick.ru",2995],["payforpic.ru",2995],["picclick.ru",2995],["picclock.ru",2995],["picforall.ru",2995],["freesoft.ru",2996],["freezpic.ru",2997],["fresher.ru",2999],["friends10.ru",3001],["fssprus.ru",3002],["fukushima-news.ru",3003],["funlog.ru",3005],["funmult.ru",3006],["fvhm.ru",[3007,3008]],["game-bomb.ucoz.ru",3007],["g-list.ru",[3009,3010]],["ongab.ru",3009],["gageno.ru",3011],["pikapo.ru",3011],["game-10.ru",3013],["game-roblox.ru",3014],["game01.ru",3015],["gamer.ru",3019],["gamer-mods.ru",3020],["gameround.ru",3021],["games-on-pc.ru",3022],["games-tv.ru",3023],["gamesisart.ru",3024],["gametimer.ru",3026],["gamexp.ru",3027],["gamingservers.ru",3028],["gastronom.ru",3029],["gavag.ru",3030],["gaynsk.ru",3031],["mentoday.ru",[3032,3512,3513]],["novochag.ru",[3032,3512,3700]],["pravilamag.ru",[3032,3512]],["techinsider.ru",[3032,3512,3513]],["thesymbol.ru",[3032,3512]],["thevoicemag.ru",[3032,3512,3513]],["gazetametro.ru",3036],["gdeetotdom.ru",3037],["gdekluet.ru",3038],["moyaposylka.ru",3039],["ragingbiker.ru",3039],["genshin-info.ru",3042],["gid-minecraft.ru",3044],["gig-torrent.ru",3045],["giport.ru",3046],["gitaristu.ru",3048],["gitarkin.ru",3049],["mosuch.ru",3049],["pc-user.ru",3049],["photoshop-master.ru",3049],["gitflic.ru",3050],["gizmod.ru",3051],["glamour.ru",[3052,3053]],["gq.ru",3052],["glas.ru",3054],["health.mail.ru",[3054,3430,3431]],["glasscannon.ru",3055],["kgd.ru",3056],["glavmore.ru",3059],["glavufa.ru",3060],["globalmsk.ru",3061],["nta.ua",3061],["godendo.ru",3065],["gofrag.ru",3066],["imenie-home.ru",[3066,3170]],["news-tape.ru",[3066,3170,3663]],["vamrecipes.ru",[3066,3170]],["specials.goha.ru",3067],["www.goha.ru",3068],["goldenlib.ru",3069],["goporez.ru",3072],["gorockop.ru",3074],["gorod47.ru",3075],["goroday.ru",3078],["gorodovoy.ru",3079],["gorodrabot.ru",3080],["gosvopros.ru",3084],["gotoroad.ru",3086],["forum.gov-zakupki.ru",3089],["gramota.ru",3091],["grand-lion.ru",3092],["graycell.ru",3093],["griffiny.ru",3094],["grimuar.ru",3095],["gta-gaming.ru",3096],["guidesgame.ru",3101],["guitarplayer.ru",3102],["forum.guns.ru",3103],["gunsbroker.ru",3104],["gurutestov.ru",3105],["gzt-sv.ru",[3106,3107]],["muz-teoretik.ru",3107],["telik.top",3107],["iptv.org.ua",3107],["tva.org.ua",3107],["haba.ru",3108],["hackware.ru",3109],["kali.tools",3109],["halyavin.ru",3110],["internethalyava.ru",[3110,3206]],["hardstones.ru",3112],["hardwareluxx.ru",3113],["hdtrailer.ru",3115],["hdtv.ru",3116],["headphone-review.ru",3117],["helpsetup.ru",3118],["heregirl.ru",3120],["ledilana.ru",3120],["hetaqrqire.ru",3121],["hh.ru",3122],["hi-chef.ru",3123],["hibiny.ru",3126],["hideme.ru",3127],["historyrusedu.ru",3128],["mod-wot.ru",3131],["hl-inside.ru",[3132,3133]],["np.pl.ua",[3132,4182]],["hmn.ru",3134],["holm.ru",3135],["homearchive.ru",3136],["horadric.ru",3137],["hostmp3.ru",3139],["hotcharts.ru",3140],["hotlog.ru",3141],["houzz.ru",3142],["hqroom.ru",3143],["hr-portal.ru",3144],["htmlacademy.ru",3145],["htmlbook.ru",3146],["hwp.ru",3150],["i2r.ru",3152],["iblitzmods.ru",3153],["ibusiness.ru",3154],["ideya-biznesa.ru",3155],["ifias.ru",3156],["ifreeapps.ru",3157],["igdz.ru",3158],["igraemsa.ru",3160],["igrhost.ru",3161],["igromania.ru",[3162,3163]],["kanobu.ru",[3162,3257]],["igroutka.ru",3164],["igry-bitva-zamkov.ru",3165],["ikovrov.ru",3167],["image2you.ru",3168],["imageup.ru",3169],["imgfiles.ru",3173],["imgmoney.ru",3174],["imhonet.ru",3175],["imtw.ru",3176],["indigomath.ru",3177],["indivip.ru",3178],["inetsovety.ru",3179],["infectus.ru",3180],["info-mage.ru",3183],["milknews.ru",3184],["informpskov.ru",3186],["infotechnica.ru",3188],["infox.ru",3189],["inmyroom.ru",3191],["inopressa.ru",3192],["inpearls.ru",3194],["inpot.ru",3195],["insanegames.ru",3196],["instagrabber.ru",3197],["instagram-foto.ru",3198],["instantcms.ru",3199],["integral-calculator.ru",3200],["interfax.ru",[3201,3202]],["sport-interfax.ru",[3202,4217]],["internet-law.ru",3204],["investoday.ru",3207],["invisiblebra.ru",3208],["iv-modelist.ru",3208],["nakrutiperiscope.ru",[3208,3631]],["nrbiz.ru",3208],["pervoevtoroe.ru",3208],["starlinemedia.ru",3208],["tv-mari.ru",3208],["ipicture.ru",3210],["irad.ru",3211],["irk.ru",3213],["vesti.irk.ru",3214],["ironfriends.ru",3215],["iskra-sev.ru",3217],["islamnews.ru",3219],["istorikonline.ru",3220],["it-actual.ru",3221],["it-enginer.ru",3222],["it-here.ru",3223],["itvcom.ru",3226],["itzine.ru",3227],["ivanovonews.ru",3228],["ivbb.ru",3229],["ivi.ru",3230],["izbavsa.ru",3233],["izgr.ru",3234],["izhevsk.ru",3235],["izone.ru",3236],["jaomix.ru",3237],["jeder.ru",3239],["greenpost.ua",[3241,5067]],["jofo.ru",3243],["jsprav.ru",3244],["jstack.ru",3245],["jurnalu.ru",3246],["justcoolidea.ru",3248],["juventus.ru",3249],["k-agent.ru",3250],["kachni-ka.ru",3252],["kaermorhen.ru",3253],["kaifolog.ru",3254],["kaluga.ru",3255],["kalugacity.ru",3256],["rk.karelia.ru",3258],["kasparov.ru",[3259,3260]],["ria-m.tv",[3259,4825]],["kavkazova.ru",3261],["kavtoday.ru",3262],["sletat.ru",[3262,4149]],["kazanfirst.ru",3263],["kazanutlary.ru",3264],["kazus.ru",[3265,3266]],["kelmochka.ru",3267],["ketchuptv.ru",3268],["key-test.ru",3269],["kurs.if.ua",[3269,5081,5082]],["keypro2.ru",3270],["khl.ru",3272],["api-video.khl.ru",3273],["mhl.khl.ru",[3274,3275]],["vhlru.ru",3275],["video.khl.ru",3276],["whl.khl.ru",3277],["kidpuz.ru",3278],["kineshemec.ru",3279],["kingisepp.ru",3280],["kingisepp-today.ru",3281],["xn----etbbecbrbp5ahkja1ae7v.xn--p1ai",[3281,5296]],["kino-archive.ru",[3282,3283]],["kino-teatr.ru",3284],["kinofann.ru",3285],["kinofrog.ru",3286],["kinomania.ru",3287],["kinomonitor.ru",3288],["kinonavigator.ru",3289],["kinoteatr.ru",3296],["kinotv1.ru",3297],["kinow.ru",3298],["kirovnet.ru",3300],["kkal.ru",3301],["pi-c.ru",3302],["klerk.ru",3305],["www.km.ru",3308],["kmory.ru",3309],["kniga-diva.ru",3310],["knigi-chitaty.ru",3311],["komcity.ru",3314],["komiinform.ru",3315],["komionline.ru",3316],["kompas74.ru",3318],["konkurent.ru",3319],["konorama.ru",3320],["konstruktortestov.ru",3321],["koolinar.ru",3324],["kosmetista.ru",3326],["kot-i-koshka.ru",3327],["krolmen.ru",3333],["krugo.ru",3334],["ktonanovenkogo.ru",3335],["ktv-ray.ru",3336],["kubik3.ru",3338],["kudainvestiruem.ru",3339],["kulturomania.ru",3341],["kupidonia.ru",3342],["kupikolesa.ru",3343],["kurer-sreda.ru",3344],["kursk-izvestia.ru",3346],["kurskcity.ru",3347],["kurufin.ru",3348],["kyron-clan.ru",3350],["l2argument.ru",3351],["l2db.ru",3352],["l2top.ru",3353],["la2nika.ru",3354],["ladyspecial.ru",3355],["laststicker.ru",3356],["legends.ru",3357],["lenov.ru",3359],["lessonsflash.ru",3361],["levashove.ru",3362],["lewi.ru",3363],["lfl.ru",3364],["lgoty-expert.ru",3365],["lideo.ru",3369],["life-prog.ru",3370],["life-students.ru",3371],["life170.ru",3372],["fototeens.lifeforums.ru",3373],["propohoroni.ru",3373],["lifehacker.ru",3374],["lifetambov.ru",3375],["likemetr.ru",3376],["lineageternal.ru",[3379,3380]],["tera-lib.ru",3380],["lineykasm.ru",3381],["listaj.ru",3382],["litportal.ru",3384],["forum.littleone.ru",3385],["live24.ru",3386],["livecars.ru",[3389,3390]],["liveday.ru",3391],["liveposts.ru",3394],["liwihelp.ru",3398],["lost-abc.ru",3401],["lostfilm2.ru",3402],["love-sims.ru",3403],["lumpics.ru",3406],["lunno.ru",3407],["motolife24.ru",3407],["luxurynet.ru",3408],["lyricshub.ru",3410],["m-strana.ru",3411],["maam.ru",3413],["macosworld.ru",3414],["magcity74.ru",3415],["sportmail.ru",[3416,3419,3420,3422,3442,3443,4223]],["kino.mail.ru",[3418,3434]],["tv.mail.ru",[3418,3449]],["auto.mail.ru",[3419,3423]],["cloud.mail.ru",[3424,3425]],["doc.mail.ru",[3425,3427]],["deti.mail.ru",3426],["dom.mail.ru",3428],["e.mail.ru",3429],["octavius.mail.ru",3429],["news.mail.ru",[3430,3441,3442,3443]],["pogoda.mail.ru",[3430,3431,3442,3447]],["vfokuse.mail.ru",3430],["horo.mail.ru",[3431,3433]],["hi-tech.mail.ru",3432],["lady.mail.ru",3435],["light.mail.ru",3436],["love.mail.ru",3437],["minigames.mail.ru",[3438,3439]],["okminigames.mail.ru",[3439,3444]],["my.mail.ru",3440],["otvet.mail.ru",3445],["pets.mail.ru",3446],["touch.mail.ru",3448],["mainspy.ru",3450],["sp.mamask.ru",3452],["mamba.ru",3453],["mamcompany.ru",3454],["manikyres.ru",3455],["manjaro.ru",3456],["mannaya-kasha.ru",3457],["marathonec.ru",3459],["market-pages.ru",3460],["martrending.ru",3463],["masterstl.ru",3464],["matchtv.ru",3465],["video.matchtv.ru",3466],["matematika-club.ru",3467],["materialscience.ru",3469],["materinstvo.ru",3470],["math-prosto.ru",3472],["mauforum.ru",3473],["maxikarta.ru",3476],["mayaksbor.ru",[3479,3480]],["md4u.ru",3481],["mdex-nn.ru",3482],["videout.ru",3482],["meat-expert.ru",[3483,3484]],["china-review.com.ua",3483],["med-heal.ru",3485],["meddaily.ru",3487],["media-online.ru",3488],["mediametrics.ru",3490],["mediavitrina.ru",3492],["mediazavod.ru",3493],["medikforum.ru",3494],["medinfo-yar.ru",3495],["medside.ru",3497],["mega-stars.ru",3498],["megacritic.ru",3499],["moscowsg.megafon.ru",3500],["megaimg.ru",3501],["megapeer.ru",3504],["megapeer.vip",3504],["melodiimp3.ru",[3507,3508]],["sitepartners.ru",[3508,4143]],["memstatus.ru",3509],["metaratings.ru",3514],["meteonova.ru",3515],["metodsilva.ru",3516],["metrologe.ru",3517],["metrprice.ru",3519],["miasskiy.ru",3521],["milknet.ru",3522],["minecraft-inside.ru",3524],["minecraft-mods.ru",3525],["minimultik.ru",3526],["mirdiets.ru",3527],["top10books.ru",3527],["mirkvartir.ru",3529],["mirlib.ru",3530],["mixmuz.ru",3535],["prnt.sc",[3537,4672]],["mkap.ru",3538],["mks-onlain.ru",3539],["mmamama.ru",3540],["mmgp.ru",3541],["mmo13.ru",[3542,3543]],["ps4.in.ua",3543],["mmogamez.ru",3544],["mmoglobus.ru",3545],["mmohelper.ru",3546],["mmotop.ru",3547],["mnogo-krolikov.ru",3549],["mnogoto4ka.ru",3550],["mnogovoprosov.ru",3551],["mob39.ru",3552],["mobiguru.ru",3553],["mobiledevice.ru",3554],["mobiset.ru",3556],["mobtop.ru",3557],["forum.mobzon.ru",3558],["mockva.ru",3559],["modfix.ru",3560],["mods-club.ru",3561],["modsgaming.ru",3562],["prokuzbass.ru",[3563,3910]],["moeobrazovanie.ru",3565],["molchun.ru",3568],["monstrbit.ru",3569],["monteon.ru",3570],["mosday.ru",3572],["my.mosenergosbyt.ru",3573],["mosgorzdrav.ru",3574],["motogon.ru",3576],["motoliga-nn.ru",3577],["motorpage.ru",3579],["motorpuls.ru",3580],["mountain.ru",3581],["moybrauzer.ru",3585],["moydrygpk.ru",3586],["myhairsalon.ru",3589],["progipertoniyu.ru",[3589,3906]],["znachenieimenipro.ru",[3589,4653]],["mozhaysksg.ru",3590],["mp3films.ru",3591],["mschistota.ru",3592],["mskgazeta.ru",3593],["mul-tor.ru",3594],["mult-film-pro.ru",3595],["camelot.multilocal.ru",3596],["camelot.userlan.ru",3596],["multoigri.ru",3598],["murman-fishing.ru",3599],["muz.ru",3600],["muz-tv.ru",3601],["minecraft15.my1.ru",3602],["myanimecorner.ru",3604],["otvaga2004.mybb.ru",3605],["utkonos.mybb.ru",3606],["myfelt.ru",3608],["mymirknig.ru",3612],["mirknig.su",3612],["myparcels.ru",3613],["olivkafrekenbok.myqip.ru",3616],["myshave.ru",3618],["myusli.ru",3620],["n1.ru",[3623,3624]],["n71.ru",3625],["nadavi.ru",3628],["nadavi.com.ua",3628],["nakanune.ru",3629],["narkoseti.ru",3632],["audiopoisk.narod.ru",3633],["doc-suvorov.narod.ru",3634],["naruto-brand.ru",3635],["narutoplanet.ru",3636],["bbs.nashalife.ru",3637],["nashashcola.ru",3638],["nashdisk.ru",3639],["nastroyvse.ru",3641],["natural-cosmetology.ru",3642],["ndscalc.ru",3644],["needtext.ru",3646],["nefrolab.ru",3647],["neosmi.ru",3648],["nesekretno.ru",3649],["story.neskromnie.ru",3650],["basaru.net.ru",3651],["superkarate.ru",[3651,4272]],["weblance.com.ua",3651],["lexxs.us",3651],["hotsoft.net.ru",3652],["wintech.net.ru",3653],["netall.ru",3654],["netschool-edu22-info.ru",3655],["newauthor.ru",3659],["newdaynews.ru",3660],["newradioshop.ru",3662],["mypornoonlain.tv",3665],["newsazerbaijan.ru",3666],["newsinfo.ru",3668],["newsko.ru",3669],["newstula.ru",3672],["ng.ru",3676],["ngnovoros.ru",[3677,3678]],["ngzt.ru",[3677,3678]],["progorod59.ru",[3677,3678]],["progorodchelny.ru",[3677,3678]],["progorodnsk.ru",[3677,3678]],["progorodsamara.ru",[3677,3678]],["prokazan.ru",[3677,3678]],["18000.com.ua",3677],["love.ngs.ru",3679],["sp.ngs.ru",3680],["nick-name.ru",3681],["niscu.ru",3682],["nixp.ru",3684],["nm71.ru",3685],["nmosktoday.ru",3686],["ppl.nnov.ru",3688],["noddb.ru",[3689,3690]],["android-club.ws",3689],["zenit-fk.ru",[3690,4650]],["forum.northnet.ru",3693],["vkusneedoma.ru",3694],["notik.ru",3695],["nov-pravda.ru",3696],["nova-wings.ru",3697],["novayagazeta.ru",3698],["novgorod.ru",3699],["novostioede.ru",3701],["novostroy-m.ru",3704],["novostroykin.ru",3705],["now.ru",3706],["nsp.ru",3707],["nsportal.ru",3708],["sibinfo.su",3709],["irtafax.com.ua",[3709,4944]],["servers-rust.ru",[3710,4117]],["gfxstuff.ws",3711],["o-keys.ru",3713],["obfog.ru",3714],["oblgazeta.ru",3715],["obnimau.ru",3716],["obogrevguru.ru",[3717,3718]],["stroitel-list.ru",3717],["termogurus.ru",[3717,3718]],["oboznik.ru",3719],["obrazbase.ru",3720],["obrkarta.ru",3722],["ochevidets.ru",3723],["octavia-a5.ru",3724],["odds.ru",3725],["oddstyle.ru",3726],["odeve.ru",3727],["odinelectric.ru",3728],["ognov.ru",3730],["porjati.ru",[3730,3861]],["sovkusom.ru",[3730,4200]],["ogorod.ru",3731],["ok.ru",3734],["ok-pressa.ru",3735],["omskinform.ru",3739],["omskmama.ru",[3740,3741]],["prologic.su",3741],["omskzdes.ru",3743],["onfoto.ru",3746],["online-buhuchet.ru",3747],["online-south-park.ru",3748],["onlineguru.ru",3749],["onlinepetition.ru",3751],["onlinetrade.ru",3754],["only-paper.ru",3755],["onxa.ru",3757],["oplati.ru",3760],["optimistt.ru",3761],["orakul.ru",3762],["airgun.org.ru",3765],["linux.org.ru",3766],["mob.org.ru",3767],["rutor.org.ru",3768],["oru.ru",3770],["oryol.ru",3771],["osadovod.ru",3772],["oskazkax.ru",3773],["osnovu-ved.ru",3774],["bloknot-khersona.ks.ua",3774],["osocionike.ru",3776],["othereal.ru",3778],["otherforum.ru",3779],["e.otruda.ru",3780],["otvetkak.ru",3781],["otzyv.ru",3782],["ozon.ru",3786],["painart.ru",3787],["pojrem.ru",3788],["panzer35.ru",3789],["partarium.ru",3792],["pasmi.ru",3793],["pastenow.ru",3794],["patee.ru",3795],["pc-aio.ru",3799],["pcnews.ru",3800],["pechiexpert.ru",3802],["people-ask.ru",3806],["peopletalk.ru",3807],["pes-files.ru",3808],["pesenok.ru",3809],["songpros.ru",3809],["songspro.ru",3809],["pesiq.ru",3810],["petromap.ru",3813],["phantastike.ru",3817],["photo-boutique.ru",3818],["photoshablon.ru",3819],["pic4you.ru",3821],["pic5you.ru",3821],["pickupclub.ru",3822],["pickupforum.ru",3823],["piki-trip.ru",3825],["pipdecor.ru",3827],["pitbit.ru",3828],["pixs.ru",3829],["pkrc.ru",3830],["planet-today.ru",3831],["match-center.playmaker24.ru",3834],["playunturned.ru",3835],["pleer.ru",3836],["pleogame.ru",3837],["plodovie.ru",3839],["pnzstroi.ru",3842],["pobedish.ru",3843],["podelki-doma.ru",3844],["poebuilds.ru",3847],["pogoda7.ru",3850],["poisk-ru.ru",3854],["poiskvps.ru",3855],["poker-wiki.ru",3856],["pokupki21.ru",3857],["polit.ru",3858],["poncy.ru",3859],["porno-monster.ru",3862],["pornotales.ru",3863],["pornotext.ru",3864],["portal-kultura.ru",3865],["portalgkh.ru",3866],["portamur.ru",3868],["postila.ru",3870],["postmoda.ru",3871],["posudaa.ru",3872],["poufe.ru",3873],["povar.ru",3874],["pozdrav.ru",3876],["viknaodessa.od.ua",[3876,5172]],["poznamka.ru",3877],["buh24.com.ua",3878],["pptcloud.ru",3880],["pr-people.ru",3882],["pravda-tv.ru",3884],["prazdnovik.ru",3886],["prestige-gaming.ru",3887],["prgazeta.ru",3888],["price.ru",3889],["prikol.ru",3890],["primorye.ru",3891],["primpress.ru",3893],["printerprofi.ru",3894],["privetsochi.ru",3895],["profbuh8.ru",3899],["professionali.ru",[3900,3901]],["ntn.ua",3901],["professorweb.ru",3902],["trashbox.ru",[3904,4383]],["program-pro.ru",3907],["promebelclub.ru",3911],["xn----btbdkbsogebtjq6bm4g5b.xn--p1ai",3911],["promigren.ru",3912],["pronedra.ru",3914],["pronovostroy.ru",3915],["prooflink.ru",3916],["prophotos.ru",3917],["propochemu.ru",3918],["propogodu.ru",3919],["proshkolu.ru",3921],["protdt.ru",3923],["proufu.ru",3924],["provapes.ru",3925],["province.ru",3926],["provinceinfo.ru",3927],["provladimir.ru",3928],["psxplanet.ru",3930],["psy-music.ru",3931],["publy.ru",3935],["pulscen.ru",3936],["pushkin.ru",3937],["pushkinprize.ru",3938],["puzzleheap.ru",3939],["pvcalc.ru",3940],["pythonworld.ru",3941],["news.qip.ru",3943],["qrcoder.ru",3944],["queen-time.ru",3946],["quote.ru",3947],["qwe.ru",3948],["r-kopilka.ru",3949],["r0.ru",3950],["rabota24online.ru",3951],["rabota66.ru",3952],["rabotasakhcom.ru",3953],["raceportal.ru",3954],["radiodacha.ru",3956],["radiokot.ru",3958],["radioradio.ru",3961],["radioscanner.ru",3963],["www.radioscanner.ru",3964],["raenza.ru",3965],["doctor.rambler.ru",3968],["finance.rambler.ru",3969],["horoscopes.rambler.ru",3970],["mail.rambler.ru",3971],["nova.rambler.ru",3972],["sport.rambler.ru",3973],["top100.rambler.ru",3974],["travel.rambler.ru",3975],["weekend.rambler.ru",3977],["woman.rambler.ru",3978],["www.rambler.ru",3979],["rapsinews.ru",3980],["rasfokus.ru",[3981,3982]],["waralbum.ru",3981],["rating-avto.ru",3983],["cash.rbc.ru",3987],["pro.rbc.ru",3988],["forum.rcdesign.ru",3991],["rcmm.ru",3992],["readytospeak.ru",3994],["realnoevremya.ru",3995],["referatwork.ru",3997],["region15.ru",3998],["rekportal.ru",4000],["remontcompa.ru",4003],["repetit-center.ru",4005],["reporter64.ru",4006],["reshak.ru",4007],["reviewdetector.ru",4009],["rin.ru",4019],["risk.ru",4020],["risovach.ru",4021],["ritsatv.ru",4022],["rk1.ru",4023],["rknweb.ru",4024],["rlocman.ru",4025],["rlsnet.ru",4026],["rmnt-aqua.ru",4027],["roadvictory.ru",4028],["robloro.ru",4029],["rocketdockfree.ru",4030],["rosrabota.ru",4032],["roypchel.ru",4033],["rpod.ru",4035],["lk.rt.ru",4036],["rt02.ru",4037],["ru-minecraft.ru",4039],["rufox.ru",4041],["www.ruhim.ru",4042],["runews24.ru",4043],["rupor73.ru",4044],["rus-urologiya.ru",4045],["rusdemotivator.ru",4046],["rusdozor.ru",4047],["rusdtp.ru",4048],["ruskino.ru",4049],["ruskline.ru",4050],["tvin.su",4054],["russiancfg.ru",4058],["russianporno911.ru",4059],["russianpost.ru",4060],["russkiiyazyk.ru",4061],["russkiypro.ru",4062],["rustaste.ru",4063],["rutvet.ru",4067],["s-platoon.ru",4068],["s13.ru",4069],["salex.ru",4070],["samlib.ru",4072],["samods.ru",4073],["samopoznanie.ru",4074],["samoychiteli.ru",4075],["sampik.ru",4076],["sanstv.ru",4078],["sapr.ru",4079],["forum.saransk.ru",4080],["sasisa.ru",4082],["wap.sasisa.ru",4083],["sberometer.ru",4085],["sbp-program.ru",4087],["scandar.ru",4088],["scask.ru",4089],["scooter777.ru",4091],["sdelanounas.ru",4096],["sdelaycomp.ru",4097],["season.ru",4098],["seasonvar.ru",4099],["secondstreet.ru",4100],["1901.selcdn.ru",4102],["self-edu.ru",4103],["semerkainfo.ru",4104],["seolik.ru",4106],["seopult.ru",4108],["serfery.ru",4109],["serg-casper.ru",4110],["seriallife.ru",4111],["serialochka.ru",4112],["serveradmin.ru",4115],["servernews.ru",4116],["severstalclub.ru",4119],["sftv.ru",4120],["sgad.ru",4121],["shahty.ru",4122],["shakai.ru",4123],["sheensay.ru",4126],["sheru.ru",4127],["sho-me.ru",4128],["shophelp.ru",4129],["shpargalkablog.ru",4130],["sibdepo.ru",4132],["sibnet.ru",4133],["info.sibnet.ru",4134],["soft.sibnet.ru",4135],["video.sibnet.ru",4136],["www.sibnet.ru",4137],["simulyator-myshi.ru",4141],["sitepokupok.ru",4144],["skachaj24.ru",4145],["skmash.ru",4146],["skyback.ru",4147],["slbook.ru",4148],["slivap.ru",4150],["slovarozhegova.ru",4153],["smart-lab.ru",4154],["smartbobr.ru",4155],["smexigrex.ru",4156],["smi2.ru",4157],["smile-vkontakte.ru",4158],["smolbattle.ru",4159],["smolensk-auto.ru",4160],["smolensk2.ru",4162],["smotrikinohit.ru",4163],["snitsya-son.ru",4165],["snn-mn.ru",4166],["snob.ru",4167],["snovidenija.ru",4168],["snowrock.ru",4170],["soccer365.ru",4173],["soccer365.com.ua",4173],["sochinyashka.ru",4174],["socproxy.ru",4175],["domik.ua",[4175,5031]],["soel.ru",4176],["soft-arena.ru",4178],["soft-file.ru",4180],["soft-i-kino.ru",[4181,4182]],["softboard.ru",4184],["softby.ru",4185],["softking.ru",4186],["softodrom.ru",4187],["softonic.ru",4188],["softru.ru",4189],["softsalad.ru",4190],["sol-online.ru",4191],["solncewonews.ru",4192],["sostav.ru",4195],["sotovik.ru",4196],["news.soundex.ru",4197],["soundtimes.ru",4198],["sovetyporemontu.ru",4199],["spartak.ru",4203],["gazeta.spb.ru",4206],["marketing.spb.ru",4208],["splkirov.ru",4214],["sportmk.ru",4225],["cyber.sports.ru",4229],["www.sports.ru",4230],["spravportal.ru",4233],["sql-tutorial.ru",4234],["sr-week.ru",4235],["srtclub.ru",4237],["staforceteam.ru",4238],["stalker-gsc.ru",4239],["stalkermod.ru",4240],["stankiexpert.ru",4242],["star-wars-film.ru",4243],["uralweb.ru",[4245,4445]],["startgamer.ru",4246],["steelsports.ru",4249],["sterlegrad.ru",4250],["stock-list.ru",4251],["stocktime.ru",4252],["stolica.ru",4253],["stopress.ru",4255],["strikes.ru",4259],["stud-time.ru",4260],["stylenews.ru",4264],["sudga.ru",4266],["sunhome.ru",4268],["sunsurv.ru",4269],["superjob.ru",4271],["supertabak.ru",4274],["svadbavo.ru",4275],["svetlica-mama-blogger.ru",4276],["swaego.ru",4278],["synonymizer.ru",4280],["synthira.ru",4281],["sysadminblog.ru",4282],["sysadmins.ru",4283],["system-fx.ru",4284],["taba.ru",4286],["tackler.ru",4287],["tagilcity.ru",4288],["tagline.ru",4289],["talkers.ru",4290],["talkwebber.ru",4291],["doska.tamboff.ru",4293],["taminfo.ru",4294],["tassbiz.ru",4296],["tatler.ru",4297],["taxifm.ru",4299],["tdaily.ru",4300],["te4h.ru",4301],["tea-online.ru",4302],["techdigest.ru",4303],["techmusic.ru",4304],["technoavia.ru",4305],["tehno-rating.ru",4306],["tehnobeton.ru",4307],["teknoblog.ru",4308],["tele-satinfo.ru",4310],["temp-mail.ru",4314],["templateinstant.ru",4315],["tenstars.ru",4316],["teploguru.ru",4317],["tests-exam.ru",4318],["texnic.ru",4319],["textarchive.ru",4320],["tg-a.ru",4321],["tglink.ru",4322],["the-geek.ru",4323],["theins.ru",4325],["thelastgame.ru",4326],["theonion.ru",4327],["theplace.ru",4328],["thevidosss.ru",4330],["thevista.ru",4331],["thisisus.ru",4333],["thr.ru",4334],["tihvesti.ru",4335],["time-to-read.ru",4336],["timeallnews.ru",4337],["tkaninfo.ru",4339],["tlgrm.ru",4340],["tltgorod.ru",4341],["tltnews.ru",4342],["tnt-online.ru",4345],["togliatti24.ru",4346],["tokzamer.ru",4347],["tolknews.ru",4348],["desk.tomsk.ru",4349],["gorod.tomsk.ru",4350],["mama.tomsk.ru",4351],["novo.tomsk.ru",4352],["sadiki.tomsk.ru",4353],["tv2.tomsk.ru",4354],["forum.tomsknet.ru",4356],["tonkosti.ru",4357],["tonnews.ru",4358],["topcraft.ru",[4361,4362]],["mctop.su",[4362,4718]],["topgearrussia.ru",4363],["tophotels.ru",4364],["toptracker.ru",4365],["torrent-bort.ru",[4366,4367]],["torrent-ideal.ru",4369],["torrent-igruha.ru",4370],["torrent10.ru",4371],["torrent3.ru",4371],["torrent50.ru",4371],["torrnado.ru",4372],["tourpom.ru",4375],["tproger.ru",4376],["tracker.ru",4377],["forum.tradelikeapro.ru",4379],["tradoman.ru",4380],["translate.ru",4381],["translit.ru",4382],["travel3.ru",4384],["travelask.ru",4385],["traveller-eu.ru",4386],["trend-city.ru",4387],["trishurupa.ru",4390],["triskirun.ru",4391],["tula-football.ru",4395],["tulactive.ru",4397],["tuningkod.ru",4399],["news.turizm.ru",4401],["api.turk-sinema.ru",4402],["api.ekranka.tv",4402],["api.yadoma.tv",4402],["turkish-tv-series.ru",4403],["turkishtvsoapopera.ru",4404],["tutu.ru",4405],["tuzlist.ru",4406],["tvcook.ru",4409],["karavan.tver.ru",4410],["forum.tvercity.ru",4411],["tverisport.ru",[4413,4414]],["tverlife.ru",4415],["tvigle.ru",4417],["tvoj-onlajn.ru",4420],["tvoyazhizn50.ru",4421],["tvsok.ru",4422],["twizz.ru",4425],["tyndex.ru",4426],["uamovies.ru",4428],["ucoz.ru",4430],["leonkrevs.ucoz.ru",4431],["samodelkyn.ucoz.ru",4432],["ucrazy.ru",4433],["ufacitynews.ru",4434],["ufamama.ru",4435],["ug.ru",4437],["ugo.ru",4438],["umpro.ru",4439],["uploads.ru",4440],["upn.ru",4441],["uptracker.ru",4442],["ural56.ru",4443],["urank.ru",4446],["urbc.ru",4447],["useron.ru",4449],["space.utema.ru",4451],["utmagazine.ru",4452],["uznayvse.ru",4454],["v-dacha.ru",4455],["v-zlom.ru",4458],["v102.ru",4459],["vakhta-job.ru",4460],["vashdom.ru",4462],["vashdosug.ru",4463],["vashgorod.ru",4464],["vbr.ru",4466],["vekx.ru",4471],["vellisa.ru",4472],["velosipedinfo.ru",4473],["med.vesti.ru",4479],["realty.vesti.ru",4480],["vfl.ru",4483],["vgae.ru",4484],["vgorodekirove.ru",4485],["videokaif.ru",4488],["videovegas.ru",4489],["vika-plus.ru",4490],["forum.vingrad.ru",4492],["vip-mods.ru",4493],["virpl.ru",4494],["virtualbrest.ru",4495],["vitaportal.ru",4496],["vk-smi.ru",4498],["vkdiz.ru",4499],["live.vkvideo.ru",4500],["kino.vl.ru",4502],["vladday.ru",4503],["vladnews.ru",4504],["vmo24.ru",4507],["vnitkah.ru",4509],["vodotopim.ru",4510],["voenhronika.ru",4511],["vologdahistory.ru",4512],["volzsky.ru",4513],["voprosov-net.ru",4514],["votpusk.ru",4515],["votrube.ru",4516],["vsadu.ru",4519],["vse42.ru",4521],["vseapteki.ru",4522],["vsebasni.ru",4523],["vsehvosty.ru",4524],["vseosi.ru",4525],["vsepredohraniteli.ru",4526],["vseprorebenka.ru",4527],["vsluh.ru",4528],["vsthouse.ru",4529],["vtomske.ru",4530],["news.vtomske.ru",4531],["vuzopedia.ru",4532],["w7phone.ru",4534],["waitpost.ru",4535],["weather7.ru",4539],["web-shpargalka.ru",4540],["webdesign-master.ru",4541],["webofcomics.ru",4544],["webpark.ru",4546],["webtous.ru",4548],["wefilms.ru",4549],["westernfilm.ru",4550],["news14.wifiram.ru",4552],["wikireality.ru",4553],["win7ka.ru",4556],["windata.ru",4558],["winitpro.ru",4559],["winstation.ru",4560],["wintorrents.ru",4561],["wmmail.ru",4564],["womanadvice.ru",4566],["womanbusiness.ru",4567],["forum.woodtools.ru",4569],["wooordhunt.ru",4570],["world-art.ru",4572],["world-weather.ru",4574],["worldcrisis.ru",4575],["forum.worldoftanks.ru",4576],["worldoftanksgame.ru",4577],["wotspeak.ru",4578],["wowgaid.ru",4579],["wowlol.ru",4580],["wowskill.ru",4581],["wuzzup.ru",4583],["wysiwygwebbuilder.ru",4584],["x-16.ru",4585],["xakep.ru",4588],["xboxrussia.ru",4589],["xbts.ru",4590],["ximepa.ru",4591],["xtool.ru",4592],["xxuy.ru",4593],["xxx-russian.ru",4594],["cinephile-online-hd.xyzy.ru",4595],["y-games.ru",4596],["realty.ya.ru",4598],["yachaynik.ru",4600],["yagd-torr.ru",4601],["yagramotniy.ru",4602],["yakako.ru",4603],["yamal-media.ru",4606],["yamart.ru",4607],["travel.yandex.ru",4611],["uslugi.yandex.ru",4612],["yapx.ru",4614],["yarportal.ru",[4615,4616]],["xn--80awhdeco3h.xn--p1ai",4615],["yepman.ru",4618],["yesasia.ru",4619],["joker.ykt.ru",4621],["stroy.ykt.ru",4622],["youla.ru",4624],["youtext.ru",4625],["yp.ru",4626],["ysia.ru",4628],["ytvideo.ru",4629],["yuga.ru",4630],["yur-zakon.ru",4631],["z-torrents.ru",4632],["za4eti.ru",4633],["zab.tv",4634],["zahav.ru",4635],["zakazgid.ru",4636],["zakonia.ru",4638],["forum.zakonia.ru",4639],["zalinux.ru",[4640,4641]],["medved.us",[4641,5256]],["zamena-podshipnikov.ru",4642],["zanmsk.ru",4643],["zaporpobedim.ru",4644],["zaqw.ru",4645],["zastroyschiki39.ru",4646],["zelenograd.ru",4649],["zhukvesti.ru",4651],["zmoe.ru",4652],["znaigorod.ru",4654],["znaikak.ru",4655],["zol.ru",4657],["zombi-family.ru",4658],["forum.zoneofgames.ru",4661],["zoodrug.ru",4663],["zoospravka.ru",4665],["zpravda.ru",4667],["zvezdaweekly.ru",4669],["zzap.ru",4671],["underver.se",4673],["underverse.su",4673],["nya.sh",4674],["amedia.site",4675],["filmitorrent.site",4677],["fonland.site",4678],["porno-island.site",4679],["qaru.site",4680],["storinka.site",4681],["storinka.com.ua",4681],["ebooks.skin",4682],["sfw.so",4683],["economic.social",4684],["animego.space",4685],["onlineclass.space",4686],["realstream.space",4687],["websdr.space",4688],["rgho.st",4689],["top.thepo.st",[4690,4691]],["kadik.com.ua",4691],["ander.su",4694],["androidphone.su",4695],["apteki.su",4696],["ati.su",4697],["tm.ati.su",4698],["trucks.ati.su",4698],["audioportal.su",4699],["bestgamer.su",4700],["allgames.zone",4700],["bhf.su",4701],["caravan.su",4702],["cryptoworld.su",4704],["games-two.su",4707],["glav.su",4708],["infokam.su",4709],["insite.su",4710],["kievforum.ipb.su",4711],["kino-line.su",4713],["blog.korabli.su",4714],["mcrate.su",4717],["minecraft-mod.su",4719],["omnibus.moy.su",4721],["novostroy.su",4723],["piratia.su",4725],["porngames.su",4726],["prisnilos.su",4727],["rockstargame.su",4729],["sd-company.su",4731],["sexoporno.su",4733],["shopping-spb.su",4734],["southpark.su",4735],["lyucifer.tv",4735],["m-z.tv",4735],["izmailovtv.xyz",4735],["stih.su",4736],["stolica-s.su",4737],["topgame.su",4739],["vlab.su",4740],["w98008mo.beget.tech",4742],["ogo.ua",[4744,5173]],["5peciali5t.tk",4749],["chahid4u.tk",4750],["protonvideo.to",4752],["wstream.to",4753],["actual.today",4754],["equity.today",4755],["rudub.today",4759],["agronom.top",4762],["indi1.top",4763],["zannn.top",4764],["itcrowd.top",4765],["kinolook.top",4766],["megatrack.top",4767],["shrlink.top",4769],["telek.top",4770],["volna.top",4771],["1yar.tv",4772],["animespirit.tv",4773],["arigato.tv",4774],["arigus.tv",4775],["baibako.tv",4776],["dndz.tv",4778],["domkino.tv",4779],["ebongo.tv",4780],["ekranka.tv",4781],["eneyida.tv",4782],["espreso.tv",[4783,4784,4785]],["tv.meta.ua",[4785,5140]],["fast-torrent.tv",4786],["football-russia.tv",4787],["fox-online.tv",4789],["giclub.tv",4790],["gtk.tv",4791],["guberniya.tv",4792],["hindcine.tv",4793],["hochu.tv",4794],["kanaldim.tv",4796],["uatv.ua",4796],["kino-zal.tv",4798],["kinoblog.tv",4799],["kinovdom.tv",4800],["kuban24.tv",4802],["limehd.tv",4803],["m-live.tv",4805],["more.tv",4807],["odysseus.more.tv",4808],["mult-fan.tv",4809],["novafilm.tv",4812],["novy.tv",4813],["objectiv.tv",4814],["obob.tv",4815],["okanime.tv",4816],["ovva.tv",4817],["peers.tv",4818],["piter.tv",4819],["pornoboss.tv",4820],["pornogam.tv",4821],["protanki.tv",4823],["rideo.tv",4826],["rivne1.tv",4827],["rus24.tv",4828],["sakh.tv",4829],["sawlive.tv",4830],["seetv.tv",4831],["show-online.tv",4833],["smotrisport.tv",4835],["softbox.tv",4836],["thailandproperty.tv",4837],["tvoemisto.tv",4840],["player.twitch.tv",4841],["uafilm.tv",4842],["vikna.tv",[4844,4845]],["wakanim.tv",4848],["wasd.tv",4849],["webcam-erotic.tv",4850],["wikianime.tv",4852],["yocast.tv",4854],["104.ua",4855],["1kr.ua",4856],["games.24tv.ua",4861],["4mama.ua",4863],["tvoymalysh.com.ua",[4863,5008]],["5.ua",4864],["agroportal.ua",4865],["agrotimes.ua",4866],["aquaforum.ua",4869],["otipb.at.ua",4870],["ut3mk.at.ua",4871],["automoto.ua",4873],["avtoblog.ua",4874],["avtoradio.ua",4875],["beauty.ua",[4877,4878]],["viva.ua",[4877,5247]],["bin.ua",4880],["business.ua",4883],["menu.cc.ua",4884],["mycooking.pp.ua",4884],["cf.ua",4885],["provce.ck.ua",4886],["zmi.ck.ua",4887],["map.cn.ua",4889],["slavutich.cn.ua",4891],["49000.com.ua",4893],["a7d.com.ua",4894],["agrarii-razom.com.ua",4895],["news.agro-center.com.ua",4899],["apnews.com.ua",4903],["apostrophe.com.ua",4904],["armyinform.com.ua",4905],["bankchart.com.ua",4908],["bankua.com.ua",4909],["buknews.com.ua",[4912,4913]],["camtasia.com.ua",4914],["denzadnem.com.ua",4918],["dnpr.com.ua",[4919,4920]],["gorsovet.com.ua",4920],["dpchas.com.ua",4921],["edenland.com.ua",4922],["eurointegration.com.ua",[4924,4925,4928]],["finbalance.com.ua",4930],["fitomarket.com.ua",4931],["gadgetstyle.com.ua",4933],["geomap.com.ua",4935],["gorodkiev.com.ua",4937],["guland.com.ua",4940],["harpersbazaar.com.ua",4941],["hsl.com.ua",4942],["inspired.com.ua",4943],["itnet.com.ua",4945],["itnews.com.ua",4946],["jewishnews.com.ua",4948],["joblog.com.ua",4949],["kidstaff.com.ua",4950],["sovet.kidstaff.com.ua",4951],["ktozvonit.com.ua",4954],["libelle.com.ua",4958],["lifedon.com.ua",4959],["lifter.com.ua",4960],["local.com.ua",4961],["lypa.com.ua",4962],["me3.com.ua",4964],["minfin.com.ua",4966],["moto.com.ua",4967],["msd.com.ua",4968],["myukraina.com.ua",4969],["nezhatin.com.ua",4970],["ngsrabota.com.ua",4971],["onlinemusic.com.ua",4975],["open4business.com.ua",4976],["paramountcomedy.com.ua",4978],["pogodairadar.com.ua",4981],["poltavawave.com.ua",4982],["poradumo.com.ua",4983],["tabloid.pravda.com.ua",4986],["pravo-porada.com.ua",4987],["prichernomorie.com.ua",4988],["proagro.com.ua",4989],["programy.com.ua",4990],["rivnenews.com.ua",4991],["rz.com.ua",4992],["shans.com.ua",4993],["shopinfo.com.ua",4994],["siver.com.ua",4995],["virus-stop.com.ua",[4997,5015]],["sobitie.com.ua",4998],["sportnews.com.ua",4999],["stroimdom.com.ua",5000],["forum.taxiservice.com.ua",5001],["telegraf.com.ua",5002],["the-village.com.ua",5003],["travelgps.com.ua",5006],["tribun.com.ua",5007],["ukrlib.com.ua",5009],["ukrs.com.ua",5010],["unn.com.ua",[5011,5012]],["inter.ua",[5012,5102]],["vidstezhyty.com.ua",5014],["vitatv.com.ua",5016],["volyn.com.ua",5018],["westudents.com.ua",5021],["zaholovok.com.ua",5023],["promin.cv.ua",5027],["hi.dn.ua",5029],["slavinfo.dn.ua",5029],["news.dn.ua",5030],["forum.domik.ua",5032],["vp.donetsk.ua",5033],["dou.ua",5034],["nashemisto.dp.ua",5036],["uoor.dp.ua",5037],["dsnews.ua",[5039,5040]],["education.ua",5041],["facenews.ua",5045],["i.factor.ua",5047],["finance.ua",[5049,5050]],["news.finance.ua",5051],["fixygen.ua",5052],["flagma.ua",5053],["buhoblik.org.ua",[5053,5178]],["forbes.ua",5057],["gazeta.ua",5060],["glavnoe.ua",5062],["glavpost.ua",5063],["golos.ua",5064],["grad.ua",5066],["healthinfo.ua",5069],["hh.ua",5070],["hotline.ua",5072],["hubs.ua",5073],["tv.i.ua",5075],["www.i.ua",5076],["board.if.ua",5078],["radiotrek.rv.ua",[5082,5207]],["pravda.if.ua",5083],["report.if.ua",5084],["versii.if.ua",5085],["city450.in.ua",5088],["crimezone.in.ua",5089],["e-book.in.ua",5090],["gsm.in.ua",5092],["medbib.in.ua",5093],["pro-kyiv.in.ua",5094],["rayon.in.ua",5095],["tyachivnews.in.ua",5098],["infocar.ua",5100],["joinfo.ua",5105],["kg.ua",5106],["newsroom.kh.ua",5107],["slk.kh.ua",5108],["rabota.kharkov.ua",5109],["0day.kiev.ua",5110],["biznet.kiev.ua",5112],["dominus.kiev.ua",5113],["dynamo.kiev.ua",5114],["funtime.kiev.ua",5115],["izvestia.kiev.ua",5116],["moto.kiev.ua",5117],["shram.kiev.ua",5118],["smartsoft.kiev.ua",5119],["format.kr.ua",5124],["ksza.ks.ua",5125],["t.ks.ua",5126],["vechirniy.kyiv.ua",5128],["lb.ua",5130],["flatfy.lun.ua",5131],["visnyk.lutsk.ua",5132],["marieclaire.ua",5135],["medicina.ua",5136],["pogoda.meta.ua",5139],["metamarket.ua",5141],["meteo.ua",5142],["meteoprog.ua",5143],["militarist.ua",5144],["mind.ua",5145],["moirebenok.ua",5146],["molbuk.ua",5147],["multitest.ua",5149],["my.ua",5150],["azart.net.ua",5151],["broadcast.net.ua",5152],["c-s.net.ua",5153],["okrain.net.ua",5155],["regionnews.net.ua",5159],["smska.net.ua",5160],["trserial.net.ua",5161],["zakarpattya.net.ua",5162],["nrj.ua",5163],["video.oboz.ua",5167],["1tv.od.ua",5169],["culturemeter.od.ua",5170],["odessa-life.od.ua",5171],["city.ogo.ua",5174],["btu.org.ua",5177],["cfts.org.ua",5179],["e-bookua.org.ua",5181],["mac.org.ua",5183],["patrioty.org.ua",5185],["risu.org.ua",5186],["umu.org.ua",5190],["petcare.ua",5193],["ng.pl.ua",5194],["pogliad.ua",5195],["price.ua",5196],["profootball.ua",5197],["protocol.ua",5198],["rau.ua",5200],["recept.ua",5202],["reono.ua",5203],["rst.ua",5205],["my.rv.ua",5206],["torg.rv.ua",5209],["vse.rv.ua",5210],["sd.ua",5211],["senior.ua",5212],["sinoptik.ua",5213],["slovoidilo.ua",5214],["sportonline.ua",5217],["sport-express.ua",5218],["sport24.ua",5219],["dobre.stb.ua",5220],["strahnadzor.ua",5221],["stroyobzor.ua",5222],["debaty.sumy.ua",5224],["forums.sumy.ua",5225],["tabletki.ua",5226],["doba.te.ua",5228],["nday.te.ua",5229],["poglyad.te.ua",5230],["telekritika.ua",5231],["teleportal.ua",5232],["tyzhden.ua",5235],["u24.ua",5236],["ukrfootball.ua",5237],["ukrinform.ua",5238],["unn.ua",5239],["uteka.ua",5241],["shop.vashsad.ua",5243],["www.vashsad.ua",5244],["vgorode.ua",5245],["golos.zp.ua",5252],["medinfo.zp.ua",5254],["portall.zp.ua",5255],["kinohit.uz",5258],["mover.uz",5259],["nuz.uz",5260],["spot.uz",5264],["soyztreid.website",5271],["serial.wiki",5272],["torrnado.win",5273],["2baksa.ws",5276],["darkwebs.ws",5278],["igraprestolov.ws",5280],["kote.ws",5281],["lfootball.ws",5282],["lu4ok.ws",5284],["oane.ws",5285],["onlyf.ws",5286],["praetorians.ws",5287],["forum.smolensk.ws",5289],["lurkmore.wtf",5292],["xn--c1ajfnfb.xn--p1acf",5293],["xn----7sbb0bildcbgm8a.xn--p1ai",5294],["xn----dtbfdbwspgnceulm.xn--p1ai",5295],["xn--24-7lcajlu.xn--p1ai",5298],["xn--80ady2a0c.xn--p1ai",5299],["xn--k1afadd0cwc.xn--p1ai",5301],["24video.xxx",5302],["cameleo.xyz",5303],["gk-stalker.xyz",5304],["xporno.xyz",5305]]);

const entitiesMap = new Map(undefined);

const exceptionsMap = new Map([["vk.com",[0,77]],["vk.ru",[0]],["caliber.ru",[1]],["worldoftanks.com",[1]],["worldoftanks.ru",[1]],["worldofwarplanes.ru",[1]],["worldofwarships.ru",[1]],["wotblitz.com",[1]],["wowsblitz.com",[1]],["wowslegends.com",[1]],["media.hubfiles.gdn",[2]],["b-kontur.ru",[3]],["online.sberbank.ru",[3]],["pokupay.ru",[3]],["sunsim.ru",[3]],["converteam.online",[4]],["refocus.ru",[5]],["yvok.ru",[6]],["admag.pro",[7]],["mobiads.ru",[8]],["ukrmedia.center",[9]],["advtise.net",[10]],["bodyclick.net",[11]],["luckproducti.ru",[12]],["maniya.info",[13]],["relap.io",[14]],["rikkobr.com",[15]],["skiles.link",[16]],["starinform.ru",[17]],["traforet.com",[18]],["101xp.com",[19]],["1xwgn.xyz",[20]],["2di.site",[21]],["clickio.com",[22]],["gdz-ru.work",[23]],["mediasyndicate.ru",[24]],["mt-pbs.te.ua",[25]],["rotagmbetdog.xyz",[26]],["smi.expert",[27]],["smi.today",[28]],["vsesdal.com",[29]],["sports.ru",[30,31]],["tribuna.com",[30,31]],["winline.ru",[30]],["abs-cdn.org",[31]],["actionteaser.ru",[32]],["adbid.biz",[33]],["adsmedia-provider.com",[34]],["advclicks.net",[35]],["advert-content.com",[36]],["aff-ads.com",[37]],["autochetki.ru",[38]],["bigleads.ru",[39]],["binomo.com",[40]],["catcut.net",[41]],["forum.zaycev.net",[41]],["mobile-4at-obshenie.chatovod.ru",[41]],["oknotivi.ru",[41]],["opa-kino.ru",[41]],["cpagette.com",[42]],["cpagetti.com",[43]],["cpagettio.com",[44]],["cpaggetti.com",[45]],["cpaggetti.ru",[46]],["cpamatica.com",[47]],["directadvert.ru",[48]],["download-center.club",[49]],["globalteaser.ru",[50]],["incrypted.net",[51]],["installoffer.net",[52]],["leadadvert.ru",[53]],["cashbackmenu.ru",[54]],["marathonmirrorbet.com",[55]],["medicinetizer.ru",[56]],["news-network.ru",[57]],["newsnetwork.ru",[58]],["novostimira.biz",[59]],["omnicpa.ru",[60]],["onetwoaffiliates.com",[61]],["people-group.su",[62]],["promoheads.com",[63]],["reals-gooods.ru",[64]],["recreativ.ru",[65]],["redtram.com",[66]],["rootmedia.cc",[67]],["runetki.com",[68]],["runetki.tv",[68]],["teasermoney.com",[69]],["tizerclick.com",[70]],["helloprice.ru",[71]],["trafmag.com",[72]],["true-gooods.ru",[73]],["universallnk.com",[74]],["nnn.ru",[75]],["wwwapteka.info",[76]],["claims.ru",[77]],["livejournal.com",[77]],["amigo-source.website",[78]],["amigoman.pw",[79]],["amigone.pw",[80]],["20idei.ru",[81]],["bither.one",[82]],["lesta.ru",[83]],["media-rotate.com",[84]],["reklamka.ru.net",[85]],["12go.asia",[86]],["kwork.ru",[87]],["sass.com.ua",[88]],["adnetpartner.com",[89]],["uniontraff.com",[90]],["playmaker24.ru",[91]],["bongacams.com",[92]],["giraff.io",[93]],["steambets.net",[94]],["mc-terra.ru",[95]],["rusdtp.ru",[95]],["primegrid.com",[96]],["westmister.eu",[97]],["mirtesen.ru",[98]],["smi2.ru",[98,99]],["mail.ru",[135,201]],["m.vk.com",[1142]],["e.mail.ru",[2858,3416,3418,3419,3420,3421]],["octavius.mail.ru",[2858,3421]],["dobro.mail.ru",[3420]],["fishki.net",[4609]]]);

self.specificImports = self.specificImports || [];
self.specificImports.push({ argsList, hostnamesMap, entitiesMap, exceptionsMap });

/******************************************************************************/

})();

/******************************************************************************/
