/*******************************************************************************

    uBlock Origin Lite - a comprehensive, MV3-compliant content blocker
    Copyright (C) 2019-present Raymond Hill

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see {http://www.gnu.org/licenses/}.

    Home: https://github.com/gorhill/uBlock
*/

/* jshint esversion:11 */

'use strict';

// ruleset: spa-0

/******************************************************************************/

// Important!
// Isolate from global scope
(function uBOL_cssSpecificImports() {

/******************************************************************************/

const argsList = [".ui-search-layout__item:has(.poly-component__ads-promotions)",".banner-desktop-300",".banner-libre",".banner",".pub_begum,\n.publicidad_cont",".publicidad","#text-3","#footer-widgets,\n.banner-promotions-wrapper,\n.fp-slider,\n.metaslider,\nimg[class^=\"slider\"]",".widget_metaslider_widget",".ad-wrapper",".ad","#cacho-overlay,\n#cacho-popup,\n.lazypubli,\n.slickWindow","#div-abc_1024x100_arriba_logo,\n.banner-lateral",".banner-box","#bannerPopup,\n.banner-simple,\n.bannerLoaded,\n.linkBannerHeader","#bannerZocalo",".contenedor_banner_popup,\n.contenedor_principal_banner_lateral",".zona_banners","p[style=\"margin:2px auto 2px auto;padding:2px 2px 2px 2px;border:0px solid #999999; background-color:#f0f0f0; overflow:hidden;\"]",".custom-html-widget",".g",".wp-block-image","div[align=\"center\"] > a","[id^=\"media_image-\"]","div[style=\"width: 90%; height: 90px; background: #fff; text-align: center; display: inline-block; color: #bbb; font-family: 'Open Sans', sans-serif; font-weight: 700; font-size: 1.2rem; white-space: nowrap; padding: 0px 5% 0; overflow: hidden;\"]",".stream-item-mag",".widget-ad-image",".widget_block",".banner-wrapper",".bottom-sticky-banner-box,\n.css-svo7lo,\n.fixed-banner,\n.pre-home-banner-box",".tdi_36","#lik",".banner-lanusse,\ndiv[class*=\"dfp-async\"]",".bnr",".modal-backdrop",".td-a-rec-id-custom-spot",".st-banner",".visable","#OBJETO861 > .ad-obj",".tronco--init","div[id^=\"dsr-\"]","#text-7","#text-5,\n#text-6","#carruselMarcasBlaisten",".ppp","div[style=\"margin-top:10px;float: left;\"]",".bannerpopup",".bnc",".bannernota,\n.bannernota2,\n.bannernota3",".sponsor",".banner-box-container,\ndiv[class*=\"_site-banner-top_\"]",".publicidad_nota",".adv",".banner-home",".n2-section-smartslider",".widget_media_image",".ads",".banner-swap","a[href^=\"https://www.starplus.com\"][href*=\"?cid=\"]","#bloqueBannersHorizontal1,\n.banner_inner",".banners","#banner",".p336-c,\n.p336_2,\n.pie,\n.publicidad-728-top","#custom_html-4","#generico,\n.bannerSide,\n.bannnerTop",".ml-slider,\n.slider-34391",".widget_custom_html","img[width=\"300\"]","#text-4","p[style=\"margin:2px 2px 2px 2px;padding:2px 2px 2px 2px;border:0px dashed #999999; overflow:hidden;\"]",".ap",".apb",".container-spot","#id_popup_MM_cliqueado,\n.cookie_lasa_popup,\n.popup_MM__cliqueado,\n.td-a-rec-id-sidebar,\ndiv[style=\"box-shadow: rgba(0, 0, 0, 0.4) 0px 0px 20px; background: rgb(255, 255, 255); animation-duration: 0.4s; animation-delay: 0.2s; border-radius: 4px; width: 900px; height: 500px; margin: auto; padding: 30px;\"]",".banner-nativo",".add",".--ads,\n.auspicia > a[href^=\"https://betsson.bet.ar/\"],\n.ln-aside,\n.ln-banner-container,\n.logos-wrap,\n.mod-banner,\n.sidebar__aside,\n.sponsor-container",".sponsors",".lanus-widget","#custom_html-3","img[height=\"300\"]","img[height=\"728\"]","img[height=\"304\"],\nimg[height=\"705\"]",".clublavoz,\n.imgSponsor,\n.producto-tienda",".fondo_column_publi2",".header_publicity,\n.link-ads-content,\n.publicity",".sponsored",".container-advertising,\n.ui-recommendations-carousel-wrapper-ref:has(a[rel=\"nofollow, sponsored\"]),\n.ui-recommendations-list__container--pads,\n.ui-search-bottom-ads__container,\n.ui-search-sidebar-advertising__display,\n.ui-search-sidebar-placements,\nli.ui-search-layout__item:has(div.ui-search-item__pub-container)",".creatividad",".megabanner",".pum-content,\nimg[width=\"400\"][height=\"100\"]","#swiffycontainer",".banner-center",".banner-border,\n.bannerTopHeader",".sc-905ccbfc-0,\n.sc-905ccbfc-1,\n.sc-905ccbfc-5,\n.sc-905ccbfc-7,\na[href=\"https://www.facebook.com/SchneiderARG/\"],\na[href=\"https://www.youtube.com/watch?v=IZPtel51MlA\"]",".partnerships-view","#sticky-banner-article",".m-pod-promo-image",".ofertas2","#key2sticky,\n.widget-content:has(a[target=\"_blank\"])","img[height=\"735\"]","img[height=\"200\"]","img[height=\"250\"]","img[width=\"336\"]",".article-banner,\n.banners-rotate,\n.bloque-secondary,\n.featured-banner","#pub728,\na[href^=\"publicidad.php?\"]",".banner-flex",".banner-bloque,\n.box-banners-dest,\n.box-bloque-banners,\n.columna-tercera","#imagensidebar,\n.Estilo1,\n[href^=\"https://www.bancodecorrientes.com.ar\"]","ads-component",".quadro-ads-widget-1col",".banners_flash","#publiRightContainer",".banner-side","#bloque-11",".banner-billboard-wrapper","img[alt=\"Buenbit\"],\nimg[alt=\"vitawallet.io\"],\nimg[alt=\"wallbit\"]","#text-1000,\n#text-1001,\n#text-25,\n#text-999","iframe[style*=\"z-index: 2147483647\"]",".horizontal-area,\n.square-area","a[href*=\".php\"],\na[href^=\"https://bstk.me/\"]",".a-single",".ed-ads,\n.leftSidebar,\n.rightSidebar",".container_publi",".adcontainer-portlet","[action^=\"https://significadoconcepto.com/\"]",".M-publicitat",".amp_columnapubli",".nou-publi-cap-home",".publi-inter-portada",".publi_interpagina",".advertising",".commercial-up-full,\n.sk--offered-by",".no-baldomero",".roba","ra[type=\"intext\"]",".c-banner",".container-ad",".patrocini",".publicitat","a[href*=\"://bit.ly/\"]","[href^=\"https://www.tgtravel.net/\"]","#divTopBanner,\n.row-publi-portada,\n.spotPortada",".banerpromocio","#publicos,\n#publientrenotis,\n.zona-ajbcn,\n.zona-lacaixa","[href^=\"https://www.caixabank.cat\"]",".caixa-publicitat",".publi-horizontal,\n.publicitat-banner",".bannerfix",".bannerContainer",".container-banner-header",".drts",".ads13",".mx-auto.aspect-box.bg-secondary.bg-opacity-10",".mh266-100",".the-banner",".banner-ancho,\n.banner-ancho-movil","#media_image-17,\n#media_image-30,\n.home-featured-widgets",".header-promotion",".OtherPages_othersection__Ad_Ae,\na[class^=\"Banner_\"],\ndiv[class^=\"Autofact_\"],\ndiv[class^=\"InterestingSection_\"]",".aawp","div[id^=\"beerg-\"]",".widget_text",".advertisement",".widget_aawp_widget_box","div[id^=\"canna-\"]",".banner-capital","#page-header,\n.peace-of-mind",".banner_full",".cnvs-block-section:has(#contenido-patrocinado)",".banner-cms",".banner-top",".ad-container",".boxbanner_container",".odds-slider-widget","div[id^=\"debos-\"]",".each-container.grid.grid-cols-1.items-center.default-gap.items-end.mx-auto.container.default-padding",".openx",".td-a-rec",".pub-escritorio","div[style=\"width:100%;margin: 30px auto; text-align:center;clear:both;padding:20px 0;\"]","#bannerGCP,\n#pub,\n.RP,\n.cajabanners",".bloque-dfp","a[href^=\"https://www.vgs.cl/\"]",".widget_owjnimg",".wpwbs_banners",".mx-auto.aspect-box.bg-primary.bg-opacity-10.overflow-hidden.my-1",".ai-viewport-1",".img-banner","#slot_box01,\n#slot_top",".agrupadorPatrocinados,\n.section-dfp",".wpb_single_image","a[href^=\"http://www.futboldeculto.com\"]",".arcad-feature",".banner-fixed-container,\n.home-banner,\n.slide__banner",".d_banner_t13,\n.home-slider__header__sponsor,\n.t_banner_t13,\n[class^=\"home-category-grid\"],\n[class^=\"home-slider__ads\"],\ndiv[class^=\"home-category-grilla__pub-\"],\ndiv[class^=\"live-page__ads-\"]","#web-tc-horizontal-1-d,\n#web-tc-horizontal-2-d,\n.contenedor-auspicio",".banner-full","div[style=\"width: 970px; height: 250px;\"]","[href^=\"https://jeronimosoymuyfeliz.org/\"],\n[href^=\"https://www.dsa.com.co/\"]","[href^=\"http://www.cedimed.com/\"],\n[href^=\"http://www.incodol.com/\"],\n[href^=\"https://kstore.com.co/\"],\n[href^=\"https://www.aress.com.co/\"],\n[href^=\"https://www.usana.com/\"]","[id^=\"metaslider\"]","[href^=\"https://colombia.argos.co/\"]","#BannerFlotanteDp,\n#Banner_Flotante_Dp,\n#Robapagina_1,\n#Robapagina_mb_1,\n#SuperBanner1,\n#SuperBanner2,\n#Superbanner_1","[href^=\"https://www.rimax.com.co/\"]","[id^=\"block-views-block-pauta-lateral-\"]","[href*=\"extra.com.co\"]",".publicidadtop",".bannergroup","#Barra_1_D,\n#Boton_1_D",".banner_header",".vc_single_image-img,\ndiv[itemtype^=\"https://schema.org/WPAdBlock\"]",".publicy-banner",".Ads_megaBannerTopContainer","[href^=\"https://co.findasense.com/\"]","#media_gallery-7",".advertising-news,\n.imperdibles__position","[href^=\"https://coronaviruscolombia.gov.co/\"]",".pauta","#ads-mascotas","[class^=\"banner\"]","#text-15",".homepage-widget > #text-16","#box-over-content-a,\n#box-over-content-detail,\n.liveActiveBet-ico",".bettingStrip,\n.detailLeaderboard,\n.liveBetWrapper,\n.oddsWrapper","#pinno-post-bot-ad,\n.pinno-flex-ad,\n.pinno-widget-ad",".attachment-full",".attachment-large",".jawban",".td_spot_img_all","a[href^=\"https://startgaming.net/\"]",".cyclone-slider-widget-8",".ads_url_insert,\ntr[data-lang=\"Publicidad\"]",".gpt-slot-barra-flotante-inferior,\n.gpt-slot-satelite-container",".pauta__billboard",".anpub",".cssanimations","#block-wplay,\n.goles_acero_banner","div[style=\"padding: Publicidad\"]",".banner-header",".adx","#dst_pub_728,\ndiv[style=\"height:334px\"]","[class*=\"pelag-\"]","a[href^=\"https://geriasa.es/\"],\na[href^=\"https://karting-rivas.com/\"]",".actua-widget,\ndiv[id^=\"actua-\"]",".esdfp","#avisosDerechaContainer",".vc_custom_1650472176304,\n.vc_custom_1650479017608,\n.vc_custom_1676190182392","#banner_footer,\ndiv[style=\"width: 300px; height: 600px;\"],\ndiv[style=\"width: 640px; height: 480px;\"],\ndiv[style=\"width: 728px; height: 90px;\"]","div[id^=\"Bannerprincipal\"]",".td-header-sp-recs","#binanceAd","#bannerStickyHeader,\n.banner-3-col",".banner-container","div[class^=\"banner-\"]","#disp-cta",".w-full.min-h-\\[100px\\].pt-\\[48px\\]",".pbl",".commercial-banner,\n.commercial-banner-top","div[data-mod=\"ads\"]",".attachment-medium_large",".g-eplanning","img[width=\"468\"]","#anuncio-dark,\n.ad-leaderboard-row",".banner-bilboard,\ndiv[style=\"float:left;width:970px;height:90px;background: #eee; margin-right:10px\"]",".topleader",".qtcd_pt,\n.qtcd_wt",".ads-notificator,\n.publi1","td[width=\"728\"][height=\"90\"]",".jlm-ad-videoo","#publicidadhub,\n#srcpublicidadhub",".bannerfijodcha,\n.bannerfijoizda2,\n.bannerskinhome,\n.bannersuperiorhomebajomenu","#ue_popups",".m-desvio-ecommerce",".code-block",".placeholder",".center,\n.sticky-container[style=\"height:600px;\"]",".banner_superior",".banner_bienes_rosario_contenido,\n.banner_dinamic,\n.banner_inferior",".banner_sop",".banner--full","a[href^=\"https://www.bikezona.com/util/redirect.asp?idbanner=\"]","[href^=\"https://www.continental-neumaticos.es/\"]","#multiplier_banner_container",".Scl-r","[href^=\"http://www.mcsinformatics.net/\"]","a[href^=\"https://innyweakela.co/redirect?\"]","iframe[style^=\"width: 100% !important; height: 95px !important; opacity: 1 !important; max-width: 420px\"]",".sidebar > .widget.Image,\ndiv[class^=\"fixed-\"][class$=\"Sd\"]",".widget.Image","div[style*=\"background-image: url\"]","[href^=\"https://www.binance.com/\"],\n[href^=\"https://www.bitcoinshoy.com/\"]","div[style=\"font-family:Arial, Helvetica, sans-serif;font-size:9px;color:#666666\"],\niframe[src*=\"://supercore.adm-vids.com/video_offer?\"]",".home-poll-block__ad","#espacio-teads,\n[class*=\"div-gpt-ad-\"]","[href^=\"http://www.intellywp.com/\"]",".TableWidget","#widget_sp_image-2","#mundo-descuento,\n.baner300x250,\n.baner630x250,\n.baner960x50,\n.baners-medio-nota-ampliada",".c-p-ia,\n.c-s > div","div[style^=\"width: 728px;\"]",".wpb_images_carousel",".ib-ad-text",".publ11s-b0ttom,\n.r11ght-pl4yer-169","#rp1-compuesto",".pauta-barra-media",".banner--",".banner--megabanner",".advBottomPagin,\na[href^=\"https://www.pornogratis.online/\"]","#barraAvisoAds",".pasli",".layout-rev","#top",".oletf-img",".raw-html-component",".cienradios-ads","#containerAdSpaceTop,\n.floatingBottomAd,\n.pub","a > img[alt^=\"Ganar\"]",".banner-right,\n.box-adv,\n.column > div[class] > div[class^=\"sc-\"]:has(div[class^=\"sc-\"] > div[id^=\"div-gpt-ad\"]),\ndiv[class^=\"sc-\"]:has(> div[id^=\"div-gpt-ad\"])",".adsense",".StickyCorner,\n.TopLeaderboard","a[href*=\"/comicxporntrafee.html\"]","a[href^=\"https://paysuites.me/\"]",".espacio-publi,\n.espacio-publi-google","div[class*=\"containerAdSlot\"],\ndiv[class^=\"ad-catfish_\"]","div[class^=\"ad-slot_\"]",".arcad-container,\n[id^=\"arcad-feature\"]",".link_cams",".rteright",".game-promo,\n.games-horizontal-promo,\n.sidebar-game",".samCodeUnit","[class*=\"td-a-rec-id-\"]",".cript-adlabel,\n[class*=\"cript-advanced-ads\"],\n[class*=\"cript-homepage-\"]",".banner-revista,\n.blocksponsor,\n.content-banner,\n.entry-box-banner,\n.piecesponsor,\n.piecesponsor2","[href^=\"https://cryptopotato.com/ad/lumenswap\"]","#anuncio","#megaSuperior_multisite,\ndiv[class^=\"adsGroupTop\"],\ndiv[class^=\"ads__ad_\"],\ndiv[class^=\"cards__card_ad-\"]",".sidebar > #text-html-widget-11","img[src=\"http://logos.cdn.cxpublic.com/PAN_logo_38px.png\"]",".itau-banner,\n[href^=\"https://camaraarmenia.org.co\"]",".container-publicidad",".separator__sponsored","div[class^=\"content_gpt_\"]",".customAdvertise_Campaign","a[rel*=\"sponsored\"]","[id^=\"diari-\"]",".clickout-banner-regular_native_box",".e3lan",".text-html-box",".caja_bannersV","div[style^=\"width: 300px; height: 250px;\"],\ndiv[style^=\"width: 300px; height: 600px;\"]","div[id^=\"diari-\"]",".Banner",".bnn","#dl_970x250_1,\n#dl_970x250_2,\n#dl_970x250_3,\n#stickyunit,\n.top-banner",".anuncio",".banneritem","#bannerDiv,\n#gkRightBottom,\n#gkRightTop,\n.vc_align_left,\n.wpb_raw_html",".m-branded,\n.section-native-container",".related-native-item","#lngtd_ad_video",".cont_publi_desktop",".samBannerUnit","#banner_publicitario","div[id^=\"donos-\"]","div[id^=\"duros-\"]","#contiene_orejeras",".g-single",".econo-code-block","[href^=\"https://bit.ly/\"],\n[href^=\"https://velotax.com.co/\"]","#topbar,\n.fondo_publicidad",".anuncioAlt,\nimg[alt=\"ADR Formación\"]","#radlinks,\n.gpt_300,\n.leaderboard-wrap",".featured_specials",".textwidget","#z_pub_inf_new,\n#z_pub_sup_new,\n.ads-superior,\n.pub_lat1_father,\n.pub_lat2_father,\n.pub_lat3_father",".__lxG__multi,\ndiv[class^=\"ads_single_\"]",".widget.HTML","#apsa-pop-hidden-img,\n#wrapper-header-full,\n.apsa-embed-cont,\n.widget_apsa_campaign","#tiquetesMasBaratos,\n.Widgetsliderintelecto,\n.contentBannerIntelecto,\n.intelectoslidercabecera",".ned-ad-dynamic",".adcrt300x600,\n.articleAside__module.articleAside__module--isSticky,\n.revUnit--placeholder","#custom_html-53,\n#custom_html-54,\n#publitopfondo,\n.fullwidthabanner,\n.fullwidthbanner-container",".content-add,\n.module-free-html-ads",".publicidad_marca,\ndiv[id^=\"banner_\"]",".contenedor__publicidad","#sticky_container,\n.adv_inline,\n.article-adv,\n.comments-adv,\n.heading__sponsor,\n.publi_intext2",".pubbox",".widget_simpleimage",".Ads,\n.external-logos",".ele-banner",".coverless",".___-N",".banner_box,\n.banner_box_p","#tdi_16",".sub_header","img[alt^=\"banner-vert-\"],\nimg[width=\"450\"],\nimg[width=\"980\"]","img[width=\"500\"]",".con_publi","#en_nd_home_flat_2,\n#en_nd_home_flat_3",".note-home-container--1-space",".banner-img",".elementor-element-a51cde3,\n.elementor-element-d45ce2c,\n.elementor-element-d782763",".zone",".publi-top",".banner-a",".banner-b,\n.banner-c,\n.banner-d,\n.banner-e,\n.banner-f,\n.banner-g",".banner-h",".b-bra-bbva,\n.c-bra,\n.c-brr,\n.c.c-pfb.c--m",".site-header__publicidad",".ad02-obj","div[class^=\"adcont_\"]",".branded",".branded-content",".banner_lat",".row-sky-banners","[href^=\"https://www.yara.com.ec/\"]","#block-2,\n#block-3,\n.code-block-1,\n.code-block-18,\n.code-block-4,\n.tag-enlace-de-afiliados,\na[href*=\"https://urbanous.com/tienda/tazas/eo-eeeeooo/\"]",".code-block-6,\n.code-block-9",".separator",".publi-lateral",".top-bar",".tdi_132",".board-tu-negocio,\n.c-add--no-text,\n.main-article-container-patr:has(.contenido-comercial),\n.patrocinador-contenedor",".c-add","#custom_html-21","p[style=\"color: rgb(144, 144, 144); background-color: rgb(235, 235, 235);font-size: 12px;padding-left:5px;\"]",".border-grey-100",".bt_publicar_ecn","#home_top,\n.uber","#bannerHorizontal,\ndiv[style=\"background-color:#FFFFFF;border-top:2px solid red; margin-bottom: 16px;\"],\ndiv[style=\"background-color:#ffffff;border-top:2px solid red; margin-bottom: 16px;\"],\ndiv[style=\"clear:both;width:100%;background-color: #EFEFEF;height:90px\"],\ndiv[style=\"clear:both;width:100%;background-color: #EFEFEF;height:90px;\"]",".stream-item-widget,\n.widget_wp_views",".media-ajust-tablet-publi-top,\n.pub-2,\n.publi-foot",".bloque_anun",".perfbtn","#motor-home","[data-type=\"ads\"]",".patrocinio,\n.ue-c-cover-content--is-branded",".bankimia,\n.retargetting,\n.ue-l-article__secondary-column-item.ue-l-article--grow:has(.ue-c-ad),\nimg[class=\"ue-c-widget__sponsor\"]","#block-29,\n.amazon-auto-links",".grid-pod:has(.patrocinado-title)","[id^=\"arcad-\"]","#main_video_fluid_html_on_pause",".gtag","a[target=\"_blank\"][href^=\"https://accounts.binance.info/register?ref=\"],\na[target=\"_blank\"][href^=\"https://ripio.go.link/\"]","td[style=\"font-family:Arial, Helvetica, sans-serif;font-size:9px;color:#efefef\"]",".pub-btf,\n.pub-mid,\n.pub-text,\n.pub-top,\ndiv[class^=\"pub-\"]",".adshare_belownav,\n.adshare_firstpost,\n.adshare_lastpost","#AutoNumber30,\n#div-300x250,\n#div-336x280_foro_footer,\n#div-336x280_respuesta_medio,\n#div-970x90,\n#div-970x90_respuesta,\n#div-970x90_respuesta_final,\n#notices,\n#sidebar > div > section:has(.fixed_adslot),\na[href=\"http://goo.gl/NDrfcW\"],\nsection[style=\"min-width: 300px; height: 640px\"]","#custom_html-17",".addoor-pubtag","#ad_global_below_navbar,\ndiv[style=\"width:120px; height:600px;\"],\ndiv[style=\"width:970px; height:90px;\"]","[href^=\"https://roobet.com/\"]","a[href^=\"http://bit.ly/\"]","#espacio-multi","#headeradd,\ndiv[style*=\"z-index: 9999\"]",".btn_betplay,\n.contenedor-logo-patrocinador,\n.pauta-bk",".timer",".myButton",".banner-bajo-header,\n.bannerclick,\n.macrobannerblock,\n.patrocinado-new","div[id^=\"gener-\"]","[class^=\"angwp_\"]","[href^=\"https://tungurahuaturismo.com\"]","#id-bannerUnderHeader,\n.advertising--desktop,\n.advertising--mobile",".Banner300x100","[href^=\"https://refpa.top/\"],\n[href^=\"https://www.jackpotcitycasino.com/\"],\n[href^=\"https://www.spincasino.com/\"],\n[href^=\"https://www.topwager365.com/\"]",".gtmclickpromo","#advertising","#custom_html-12,\n.textwidget.custom-html-widget","#banner_float,\n#new_ads","#onhsl","img[width=\"300\"][height=\"600\"]",".M50B--md,\n.banner--evento,\n.wrapperBanner",".td-visible-desktop","[class^=\"product-card\"],\ndiv[class^=\"embed-card_card_\"]:has(a[href^=\"http://disneyplus.bn5x.net/\"])","div[id^=\"horaj-\"]","img[width=\"250\"]","img[width=\"728\"]","[class^=\"bp\"]",".et_pb_row_4","img[width=\"720\"]",".revcontent,\n.trb_taboola","#block-block-42,\n#block-infoblocks-infoblocks-fixedsize-17,\n#block-infoblocks-infoblocks-fixedsize-18,\n#block-infoblocks-infoblocks-fixedsize-5,\n#block-infoblocks-infoblocks-fixedsize-6,\n#block-infoblocks-infoblocks-fixedsize-7,\n.node-advertisement",".afterlogo,\n[href^=\"https://navegantes.aimc.es\"],\na[href*=\"_banner.php?id=\"]","#adblockadvice,\n[id^=\"detection\"]",".widget_idealista,\nA[href=\"http://www.idealista.com/news/vacacional/mercado-vacacional/2015/08/12/738750-competencia-arremete-contra-la-ley-que-limita-los-pisos-turisticos-en-el?xts=352991&xtor=AD-186-[node/738750]-[]-[57601_1]-[lavanguardia.es__lavanguardia.es]-[]-[titulo_1_1]&source=314\"],\n[href=\"http://www.idealista.com?xts=352991&xtor=AD-186-[idealista]-[]-[57601_1]-[lavanguardia.es__lavanguardia.es]-[]-[home_1_1]&source=314\"]","[href^=\"http://s1.igg-games.com/index.php?\"]","#publi2One","#top-banner-wrapper","#ifr_widget_sal",".pb-f-utilities-ad",".adsense-columna",".marco-publicidad","#block-views-diosuniversal-block-1,\n#zone-user-wrapper,\n.block-100,\n.block-101,\n.block-106,\n.block-111,\n.block-112,\n.block-87,\n.block-95","div[style=\" border:1px solid; background-color:#FFF; width:1220px; margin-left:auto; margin-right:auto; padding-bottom:10px\"]",".content-pub-top,\na[href*=\"/ads.php?id=\"]",".banner-2,\n.banner300x,\n.bannerpremiumnh",".banner-horizontal",".bannerwide","#mvp-head-top,\n[href^=\"https://elfotoys.com/\"]",".advert,\n.game-page-sidebar,\na[href*=\"smarturl.it/\"]",".Banners-lateral",".ai-dynamic","#sc-brandday",".spu-bg,\n.spu-box,\ndiv[class*=\"banner-\"]","div[class^=\"pubcaja\"]","#teaser3",".genosha_ads_fixed_bottom,\ndiv[style=\"position:absolute; top:12px; width:970px; height:90px; background:#FFF; z-index:100; padding:0px; margin:0px\"]","#rotator2,\n.piki-ads,\nimg[data-original-height^=\"300\"]","#anpr,\n.sponsor_stats",".axds",".axds-lane",".widget_custom_html > .block-title,\n.wpipa-container",".bannerheader",".main-banner-ad,\n.pinno-ad-container","img[width=\"600\"]",".adyb",".section-banner","img[width=\"800\"]",".dialog-message,\nimg[width=\"385\"]",".elementor-element-15f1544d",".banner2",".tads-header-mobile","._ning_inner",".section-aside-roba,\naside[class^=\"mod-ad-\"]",".orbit-container",".brand-claro,\n.branded-sponsor,\n.spm","#ventana-flotante",".widget_sp_image",".article-module-sponsored,\n.box900,\n.div-patrocinado5,\n.lv-publi-box","img[alt^=\"publicidad\"]","img[width=\"900\"]",".elementor-element-32d83d8",".publi_robapaginas",".bam-topbar",".add990x90","iframe[style*=\"width: 100% !important; height: 170px !important; opacity: 1 !important;\"]","[class^=\"teaser\"]",".voc-home-branded-naked","#block-banneranimado,\n#block-views-block-banner-block-1,\n.mibanner",".dfp","#mega-atf,\n.partners","div[class^=\"lider-\"]","div[class^=\"r89-\"]",".td-ss-main-sidebar",".llano-antes-del-contenido,\n.llano-contenido",".c-pub","#takeover-desktop,\n#takeover-desktop-counter,\n#takeover-movil-counter",".gad,\n.grow.flex.justify-center.h-\\[300px\\],\n.w-full.h-\\[600px\\].my-5","#banners_footer",".BANNER-IMAGES,\ndiv[id^=\"detection\"]",".td_block_template_1.widget.widget_text",".trevda","#banners_cabecera,\nhr[style=\"width:5px; color:#CC6600; background-color:#CC6600; margin-top:3px; margin-bottom: 3px;\"]","#fixedban,\n#fixedban2,\n.anunciofooter","#Patrocinio,\n.ad-item-bt-cont,\n.codere,\n.flex-b-promociones",".textwidget a[href^=\"https://ar.puma.com/\"],\nimg[width=\"750\"]",".ib-ad-img",".owl-example",".brave_popup,\ndiv[id^=\"wmd-anuncio-\"]","a[href^=\"https://alertlogsemployer.com\"]","._p-ft,\n._p-tp",".sign,\na[href^=\"http://online.caliente.mx/promoRedirect?\"],\nimg[alt^=\"caliente.mx\"]","[href^=\"https://online.caliente.mx\"]","#enla","div[data-id^=\"013f85c\"]","#by_hawkers","a[href^=\"https://www.univistainsurance.com/\"]",".pb-tag",".height-bantop-fijo",".has-advertisement,\n.ma-ContentListing-advertising-native","div[style^=\"height: 300px;\"],\ndiv[style^=\"height: 553px;\"]",".banner_detail_files,\n.banner_detail_top","#moreg",".banner-listado-simple","[class^=\"pub-banner\"]","#wrapper-20,\n#wrapper-65,\n#wrapper-7,\n.banner-ad-not-1,\n.banner-ad-not-top",".e-post-banner",".tlf-ad",".promo","div[style=\"background-color:#FFF;margin-bottom:10px;height:250px;\"]",".bc_random_banner",".ad-banner","img[width=\"330\"]","#widget-mdcribeo-loultimo,\n.bolarosa,\n.publi-box","a[href^=\"https://get.surfshark.net/\"]",".tdi_307","a[href^=\"https://www.platanomelon.com/?rfsn=\"]",".a-ty,\n.i_sba,\na[href^=\"https://landings.videochatprovider.com/\"],\na[href^=\"https://www.fuegocams.com/\"]",".brandvoiceFooter,\n.brandvoiceHeader,\n.dfp-container,\n.small-promo","[id^=\"metaslider_widget-\"]","#ad_wrapper_head",".widescreen","a[href^=\"https://www.eneba.com/\"][href*=\"?af_id=\"]","#Mod375,\n#Mod427,\n#Mod450,\n#Mod452","#ads","a[href=\"http://iglesiasegura.com/\"]",".box_a","#skin",".cc3,\n.publii",".pinno-ad-label",".prefix-adlabel,\na[href^=\"https://noticiasparamunicipios.com/linkout/\"]","#ads-inread,\n.barra-compuesta","#banners",".bannerspace","#notas_arriba","#text-8","div[style=\"background-color: #E6E6E6; padding: 2px; text-align: center\"]",".ad-block,\n.envoltorio-intext1,\n.mega,\n.outofpageHome,\na[href*=\"legalitas.com/\"]","[href^=\"https://seranking.com/\"]","#billboard-wrapper","[href^=\"https://www.electrohuila.com.co/\"],\niframe[src^=\"https://www.youtube.com/embed/CiedpC-wP7E?\"]",".pestana_footer","div[aria-label=\"QODE\"]","#camsFooter,\n.banner-bg,\n.camsHome,\na[href^=\"https://www.amateur.tv/\"]",".hidden-under-920,\n.resumecard",".space",".caja-banner-990",".btnads,\n.pfake","a[target=\"_blank\"][href^=\"https://startgaming.net\"]",".ad-300x250,\ndiv[style*=\"min-height: 250px;\"],\ndiv[style^=\"width: 300px;\"]","div[style*=\"min-height: 600px;\"]",".hustle-popup",".hpe-i-ad",".epl-space","#publi1,\n#publia,\n.abotonsponsor,\n.botonsponsor",".bwe_ext_partners","a[href*=\"wg-aff.com/click?\"]","[href^=\"https://record.secure.acraffiliates.com/\"]",".adv-square",".bnfo,\na[href^=\"https://www.webcampornoxxx.net/\"]","div[class*=\"banner-set\"]",".Txt_PROMOCIONES,\n.Txt_Promociones,\n.Txt_promoclaro,\n.Txt_promomovistar,\n.Txt_promotigo",".countdown-container,\n.logo_group_mar,\n.productos,\n.sliderPrensa,\n.sticky-box[style=\"height: 800px;\"],\n.sticky-box[style=\"height: 950px;\"],\n.tagPublicidad,\n.titulares-iframe","div[id^=\"r89-\"]",".stream-item","#headerFuseZonePortal,\n#mrec1FuseZonePortal,\n#productIncontent1FuseZonePortal,\n#productIncontent2FuseZonePortal",".py-4.text-center,\n.relative.flex.h-full.flex-col","[onclick*=\"'page' : '/virtual/Ad/\"]","#affiliate-livecam-widget-435","[class*=\"code-block-\"]","a[href^=\"https://www.gymglish.com/partner/\"]",".masthead-banner","#wallpaper,\n.head-wrap-out","[id^=\"frame-div-gpt-ad-\"]",".elementor-element-4034d76","#zonaavisos,\n.container_publicidad",".comprabilletes",".loading-add",".barra-megabanner-tp,\n.widget-sdb-publi,\n.widget-widget_this_theme_publi_text","div[style=\"height:200px;max-width: 840px;width: 840px;\"]",".concintillo",".banner_bienes_rosario,\n.banner_centro_inf",".rumbo-widget,\n.widget_media_gallery","td[style=\"color:#666666; font-size:11px; padding:2px;\"]",".sdp-ad",".publish-box",".main-banner","#antiBannersGigantes",".a728",".abbcn-footer",".ntv-disclaimer",".code-block[style^=\"margin: 20px auto;\"]","[href^=\"/clickb.php\"]","div[id^=\"article_ads\"],\ndiv[id^=\"list_ads\"]","#text-52,\n.ad3,\n.ad4,\n.ad5,\n.ad6",".ad2",".oxy-modal-backdrop",".accession",".it-ad,\n.it-ad-wrapper","[href*=\"quest.com/\"],\n[href^=\"https://www.apexsql.com/\"]","#pub_sup","a[href^=\"https://es.johnnybet.com/\"]","div[style=\"width:300px; height:250px; margin:0px auto;\"]","#publicidad-slider","a[href*=\"://clk.tradedoubler.com/click?\"],\na[href^=\"//clk.tradedoubler.com/click?\"]","#author-banner,\n#blog-banner,\n#header-banner,\n#highlights-banner,\n#text-69,\n#text-86,\n#text-87",".ad_space_large,\n.rapid_banner_home,\n.rapid_banner_sidebar",".prime-banner","#custom_html-19",".tno-banner,\n.tno-blocks-banner-horizontal","#slimbanner,\ndiv[style*=\"width: 300px; height: 250px;\"],\ndiv[style^=\"overflow: hidden\"]","a[href*=\"://psicotecnicos2x.es/\"],\na[href=\"http://www.sespol.es\"]",".fan,\n.intensive-add","#bannerbajo","#interstitial_container",".td-all-devices","div[data-testid=\"test-ads\"]",".widget[data-widget-type=\"ListWidget\"]","div[data-widget-type=\"Advertisement\"]",".bderecho,\n.bizquierdo","#g",".banner-bottom",".uvs-ad-full-width,\n[data-widget-type^=\"Outbrain\"]",".banner-970,\n.side-banner",".pauta-cuad","div[style=\"font-size: 0.8em; text-align: left; color: rgb(136, 136, 136);\"],\ndiv[style=\"margin-top:15px;float:left;width:100%;\"]",".fake_player,\ndiv[class^=\"ano_\"]","a[href^=\"https://www.primevideo.com/\"][href*=\"tag=\"]",".afs-block",".elementor-element-4485d264",".adv-link",".attachment-medium,\n.widget_media_video","#banner-mega",".pba,\n.pbb,\n.pbc,\n.pbd,\n.pbf,\n.pbi,\n.pbj",".client-logo-slider",".block-crvt-adbtgmedia","div[class^=\"pauta_\"]",".banner_widget","#bio_ep,\n#sidebar-best-vpns,\n#sidebar-top-vendors","#bt_aws_ad_slot_1",".sidebar1.sidebar-separators",".happy-inside-player",".overlay_popup","#banner_top_container,\n.slidebanner,\na[href^=\"https://beone.es/\"]",".popvidcnt",".a-wrap","#sidebar > .et_pb_widget,\n.code-block-3,\n.code-block-5",".advertising-last",".mmc_ads_solo_escritorio","[href^=\"https://jumbo.com.do/\"]","#modalanucio","div[id^=\"publicidad-\"]","#advertisement","#fancybox-overlay,\n#fancybox-wrap,\ndiv[id^=\"elmer-\"]",".sgpb-popup-dialog-main-div-wrapper,\n.sgpb-popup-overlay,\nrs-slides",".widget.widget_text","a[href=\"http://www.herbalife.com.ec/\"]",".region-pv1-superior-amplia",".elementor-element-811f5f8,\n.elementor-element-cfab89b,\n.elementor-element-fb5d061,\n.jet-popup","[id^=\"slider_\"]","img[alt=\"Promos\"]","img[style*=\"max-width: 970px;\"]","#cajasbuscadoras,\n.module-coupons,\na[href=\"http://boticariagarcia.com/\"],\na[href=\"http://lofficiel.es/\"],\na[href=\"http://www.esquire.es\"],\niframe[src^=\"https://www.20minutos.es/cajasbuscadoras/\"],\nimg[src=\"http://mmedia.20m.es/modulos/pastillas/nuevas/pastillas/Bankia.png\"]",".mega-superior","#block-block-17,\n#block-block-39,\n#block-block-43,\n#block-block-50",".BANNER,\n.BNR-DER","#wrap-pantallazo,\n.banner-cabecero",".td-banner-wrap-full",".appSlider","#bottombox,\n#topA_iframe,\na[href^=\"https://www.amazon.\"][href*=\"tag=\"]",".bannerhome,\n.destacados",".containerBanner,\n.transfer-container",".cl-billboad-wrapper,\n.osa-as24-placeholder",".rm-product.rm-format,\n[aria-label=\"advertisement\"],\n[id*=\"-sponsored_products-\"]",".popup-promo",".pubframe,\n.rbbox-odds","#advertising-right,\n#advertising-top","div[style=\"margin:5px auto 5px;text-align:center;\"]",".block-anuncios",".b-2","div[style=\"text-align:center; margin-bottom: 15px; background-color:#F4F4F4;width: 302px;\"],\ndiv[style=\"text-align:center; margin-bottom: 15px; background-color:#F4F4F4;width: 728px;\"]","td[class*=\"id_publi_\"]:has(img[alt=\"publicidad\"])","a[onclick^=\"return ad_redirect\"]","#bhorizontal,\n#columnapublicidad,\n#mediacolumna,\n.advertising-corte-interstitial",".BANNER_COLUMN",".grp--branded-style",".henneoHB",".fusion-header-banner",".ePubli1,\nimg[src=\"http://media.grupojoly.com//0001985000/0001985392.gif\"],\nimg[src=\"http://media.grupojoly.com//0002002500/0002002922.gif\"]","#leftbanner,\n#mvp-leader-wrap,\n#rightbanner",".minibanner_content",".baterybanner",".g-dyn",".publi",".beta-placement","#pmMarketing_1","[href^=\"https://www.morerayvallejo.es\"]",".sk--sponsored-by",".news-sponsored-content","#banners-superiores,\n#progressBar,\n.AD_Content,\n.adsLinicom,\n.bankia-cuerda,\n.bannerInferior,\n.bannerIntermedio,\n.banners-superiores2,\n.caja-publi-port,\n.railContainer1,\n.railContainer3,\ndiv[id^=\"300x\"],\ndiv[id^=\"728x\"]",".mauto.textcenter.mb20.mt20","#modulo_buscador_sv,\n.flex__publi,\n.other-services","#ads_position_2,\n.cls-publi-height,\n.m_gollum,\n.mods-box-body,\n.v-banner,\ndiv[style=\"min-height:250px;\"],\ndiv[style=\"min-height:290px;\"]","div[style=\"width: 336px; height: 565px; float: right; margin-top: 30px;\"],\ndiv[style=\"width:300px; height:600px; float:right; margin-left:3px;\"],\ndiv[style=\"width:300px;height:600px;float:right\"],\ndiv[style=\"width:728px; height:90px; margin: 0 auto; margin-top: 5px; margin-bottom: 5px;\"],\ndiv[style=\"width:728px;height:90px;margin: 0 auto; margin-bottom:5px; margin-top:5px\"],\ndiv[style=\"width:970px;height:90px;margin:0 auto;margin-bottom:5px;\"]","#cx_widget,\ndiv[style=\"min-height: 700px\"]","#top_image_div",".ea-gat-slot-wrapper",".js-stt-click > picture",".banniere,\n.native","#colLateral[style=\"height: 1200px;\"]","[href^=\"https://lustlia.co/?ref=\"],\na[href^=\"https://es.amateur.tv/\"],\ndiv[align^=\"center\"]",".testimonials-partners",".boxOverContent__banner",".col-sm-2","a[href*=\"/publicidad.php?id=\"],\niframe[src*=\"://www.netpol.es/\"]",".re-AdvertisingDominanceNative",".banner-placeholder","#adobe-pagination-mkt-copy,\n#layer_coupon,\n.adobe-coupon-container,\n.adobe-grid-design,\n.banner-adobe","#ai_widget-2",".node-anuncio-megabanner","#sky2_1,\ndiv[style^=\"min-height: 600px;\"]","[href=\"http://espanol.istockphoto.com/?esource=gi_es_home_3pack_istock_3\"] > .promo-hover","#sidebarADefault",".addg,\n.titulo-publicidad","._modulo-amazon,\n.c-sidebar-branded,\n.entry__right-rail-width-placeholder,\n.leaderboard-flex-placeholder,\ndiv[data-adtype]","[href^=\"https://www.colex.es\"],\n[href^=\"https://www.nuevamutuasanitaria.es\"]",".sk--project-with-logo","img[alt=\"http://interbenavente.es/pag/serviciosweb\"],\nimg[alt=\"http://www.ford.es/serviciopostventa/PromocionesPostventa2013\"],\nimg[alt=\"http://www.serviciosfunerarioszamoranos.com/\"],\nimg[alt=\"https://www.facebook.com/pages/Caprichos-Benavente/1151234814894029?fref=ts\"],\nimg[alt=\"https://www.facebook.com/zarabanda.regalos?fref=ts\"]","#text-72,\na[href*=\"caixabank.es/\"],\na[href*=\"comprometidoscon.org/\"]",".car-insurance,\n.finance","a[href*=\"/linkout/\"]",".textoPatrocinio,\n.vinculoPatrocinio",".u_1843050363",".ad_fixed_h,\n.adpos,\n.mujerhoy","#aside,\n#sidebar,\n[id^=\"djslider\"]","img[alt*=\"Banner\"]",".l-resultsList__item:has(.kl-blade--sponsored)","#text-7 > .textwidget","a[class*=\"sponsoredProductCard\"]",".js-ads-not-visible,\n.megaBanner","[data-test=\"mms-product-card\"]:has([data-test=\"mms-plp-presented\"]),\n[data-test=\"pdp-bundles-content\"]","td[class*=\"id_publi_\"]:has(a[href^=\"https://www.amazon.es/\"])","div[class^=\"coreCarousel__advertisementBox-\"]",".jobbioapp,\n.np-product-offers","#slider-wrapper,\n.lateral",".addContainer",".publi-sidebar-listado","a[href^=\"http://www.fuegodevida.com/\"]","#banner_superior,\n#banners_laterales",".akcelo-wrapper","article[id^=\"divAdserver\"]","a[href^=\"https://www.awin1.com/cread.php\"]","#decine21_widget_estrenos,\n.megabanner-container,\n.pb-ads,\nimg[src=\"http://ficheros.publico.es/resources/cintillos/iberia-express.jpg\"]","#opciones > #patrocinio","#horizotal-banners,\n#right-banners,\n#widget_banners","a[href=\"http://www.cyclosaltamirano.es/\"],\na[href=\"http://www.morellasingletracks.com/\"],\na[href=\"http://www.mybikenet.com/development/\"],\na[href=\"https://www.facebook.com/pages/BENIBIKES-Benidorm/177123992350243?fref=ts\"]",".promo262x90","img[height=\"90\"]",".sevil-widget","._mo_recs_tpi","#kbg",".grid_24","a[href=\"http://turismourense.com/index\"]","div[style=\"height:270px; padding: 10px 0;\"]","#home-rectangle-spotlight,\n.werbung",".turium-advertising",".ads-titleposttl",".bg-banner","#spBx,\n.adMbBlTp",".got-dvr",".banner--article,\n.w-openx-banners","a[class^=\"fasc\"]",".serie-optimanetwork,\n.ver-ahora",".tpd",".herald-da,\n.posttakeoverlink,\n.takeoverlink","#taboola_nota,\n.multimedia_taboola","#wfg_ad-LDB1,\n#wfg_ad-LDB2,\n#wfg_ad-MPU1,\n#wfg_ad-MPU2",".add-inner,\n.col-sm-9",".sk--branded-content","#p15_box_1,\n.col-banner_c2,\n.p15_banners_box1_234","[src=\"http://va6.thand.info/0hsfy957uswi2cgypg23\"],\na[href*=\"http://www.physoi.eu/script/redirect.php?url=*\"]","#advertDialog1",".wago-ad-container",".section-cpa","div[class^=\"tumas-\"]","#stationary-ad","div[id^=\"cedvtoj-\"]","#newlayercontent","div[class^=\"div-dfp-\"]","[class*=\"sgpb-popup\"]",".box-banner","a[href=\"http://www.ayojon.mx/\"]",".coupons__container,\ndiv[class^=\"itemgpt_\"]",".dfp-tag-wrapper-container","#leaderboard0",".MitadLogoCaliente","#block-block-15,\n.boxbanner","div[style^=\"position: fixed!important;text-align: center;bottom: 0!important;left: 0;\"]","#region-preface-second,\n.publicidadBoxBanner300x75",".publi-4,\n.publi-5,\n.publi-6",".g1-delta,\nh2[style=\"color: #000000;text-align: left\"],\nh2[style=\"text-align: center;\"]","#centro_pub,\n#main__dehit,\n.portada_1LB,\n.portada_1MT,\n.pub__portada,\n.publicidad_basica,\ndiv[style=\"width:970px; height:90px; display:block !important; margin:0 auto; overflow:hidden; margin-bottom: 10px;\"]",".sl_caliente",".todopuebla,\n.tp-centro","#tdi_42",".rayabtn",".break_patrocinadores",".leaderboard",".publimg","div[id^=\"almom-\"]","#publicidad-nas","div[style=\"width:300px; height:250px\"]","iframe[width=\"300\"][height=\"250\"][border=\"0\"][frameborder=\"0\"][scrolling=\"no\"],\niframe[width=\"500\"][height=\"400\"][border=\"0\"][frameborder=\"0\"][scrolling=\"no\"][maxwidth=\"500\"][maxheight=\"400\"][type=\"responsive\"]",".widget_aawp_widget_bestseller","[href^=\"https://www.instant-gaming.com/\"]",".publicidad-l","iframe[src*=\"ads.ad4game.com/\"]",".full_add","#floatLayer2",".mt-AdvertisingRoadblock-top,\n.mt-Display--top","#bannercabeceravideo,\n.bannerColumnas,\n.lateralderecho,\n.lateralizquierdo,\nimg[alt^=\"Banner\"]","div[style=\"margin: 0 -10px 20px -10px\"]","#fancesaPubli,\n.visible-md.visible-lg.img-responsive.center-block",".h-block.h-block-250.bg-dark.mb-1",".lecourse,\n.slotbanner-top,\ndiv[style=\"margin:0px 20px 20px 30px;font-size:16px;border:1px solid #d5e1e5\"]",".jk-300","#text-12","#sp_block_15,\n#sp_block_22","#ban160,\n#ban300,\n#ban728,\n#banTxt,\n#t_diag","#dl-banner-300-250","#dialogintrusivo,\n.divpublicidades,\n.margenpublicidad","#text-14,\n#text-16,\n#text-19,\n#text-20,\n#text-21,\n#text-22","#text-17",".td-anuncio-contenido,\n.td-anuncio-superior","a[href^=\"https://datingnow.life/\"]",".adcams,\n.home-native-patrocinado",".cnt-down",".section-center > .BoxContent:nth-of-type(2),\n.section-right > .BoxContent:nth-of-type(2)",".img-ad-default,\na[href^=\"https://amzn.eu/\"]","div[id^=\"fab-on\"]",".tdi_22",".widget_aawp_widget_new_releases,\ndiv[id^=\"weedm-\"]",".content_store","[href^=\"https://www.montrebar.com/\"]",".mod.relatednews",".td-a-rec-id-header","#anuncioca","#publiperro",".topads-wrap","[class^=\"adTag\"]",".adunit-01-max","#ccr-sidebar-add-place,\na[href^=\"https://promomark.es/\"]","a[href=\"http://castillafloristeria.com/\"],\na[href=\"http://electrosanzhermanos.com/\"]","div[id^=\"enter-\"]","[alt^=\"Tienda\"],\nimg[src=\"http://static.tumblr.com/omgciym/0iNnhnzq2/neopeseta.png\"],\nimg[src=\"http://static.tumblr.com/omgciym/0tvmih3p3/memetienda.jpg\"],\nimg[src=\"http://static.tumblr.com/omgciym/2bBmgb175/juegacos.jpg\"],\nimg[src=\"http://static.tumblr.com/omgciym/Pnenkw34v/edrfwregwrgwtrgwr.jpg\"],\nimg[src=\"http://static.tumblr.com/omgciym/SXxm66n6y/lol-logo.png\"]","a[href=\"http://ganadineroconencuestas.com/dinero_flow/?webform=*&c=&s2s=*&pubid=*&subid=&medio=*&vendor=*&context=\"]","#block-especialclarodesktop","[href^=\"https://clasificados.clasiguia.com.pa\"]","[onclick*=\"/publicidad\"]","div[class^=\"AdsSlot_\"]",".sidebar-zonahogar",".ec-club",".module_mm,\n.statics_module","#bannercentral,\n#bannercentral2,\n#bannertop",".atm-banner-middle,\n.atm-banner-strip,\n.atm-banner-top",".hiraoka",".logo-min,\n.mdl-sponsors,\n.module__sponsor","#total,\n#total2,\n#total3","#article-banner-comentarios,\n#breaking-news-banner1,\n#fullwidth-banner,\n#top-banners,\n.banner-full-60,\n.col-banner,\n.col-banner-45",".grid.desk-8.alpha > p","#car_top","a[href^=\"https://hacktorrent.net/\"]","a[href^=\"https://bisecthosting.com/\"]","#after-ad,\n[id^=\"Image\"]",".owl-carousel",".supsystic-slider-wrapper",".adblockweb","[id^=\"gift-\"]","span[style=\"font-weight:bold; cursor:pointer; text-decoration:underline\"]","a[href*=\"leadzupc.com/\"]",".branding-wrapper",".widget_ti_image_banner","a[href*=\"clicktag_promo\"]",".grid_12 > .grid_4","#promo,\n#promoSept19A,\n#promoSept19B,\n.promoTop","a[href^=\"https://bit.ly/\"],\na[href^=\"https://vario.tv\"]",".banners-side-container,\na[href=\"http://www.180.com.uy/banner?ID=857&CODE=portal.index\"]",".auspicios,\n.modulo_publi",".List-sponsor,\n.Page-above.loaded:has(div[class^=\"GoogleDfpAd\"]),\n.PromoBasic:has(.Promo-sponsor),\n.PromoFeat",".zone-adsense","#conectab","#bannerEspeciales,\n#clima-banner",".banner_elementos","img[width=\"970\"][height=\"120\"]","#ad-area,\n#ad-area-top","#img_pub,\n#publicidad-2",".bsac",".bfbc",".bnpub,\n.join",".vjs-producer",".footer_partner_container_wrapper","[href^=\"https://qp.erotilink.es\"]",".lst_ft_bn","[onclick^=\"AbrirEnlaceStar('\"]"];

const hostnamesMap = new Map([["mercadolibre.com.ar",[0,87]],["mercadolibre.com.bo",[0,87]],["mercadolibre.cl",[0,87]],["mercadolibre.com.co",[0,87]],["mercadolibre.co.cr",[0,87]],["mercadolibre.com.do",[0,87]],["mercadolibre.com.ec",[0,87]],["mercadolibre.com.gt",[0,87]],["mercadolibre.com.hn",[0,87]],["mercadolibre.com.mx",[0,87]],["mercadolibre.com.ni",[0,87]],["mercadolibre.com.pa",[0,87]],["mercadolibre.com.pe",[0,87]],["mercadolibre.com.py",[0,87]],["mercadolibre.com.sv",[0,87]],["mercadolibre.com.uy",[0,87]],["mercadolibre.com.ve",[0,87]],["750.am",1],["lared.am",2],["diariouno.com.ar",2],["puntal.com.ar",[2,3,106]],["a24.com",2],["0221.com.ar",[3,4,5]],["canal-ar.com.ar",3],["diariodecuyo.com.ar",[3,32,33]],["diariopopular.com.ar",[3,38]],["econojournal.com.ar",3],["elancasti.com.ar",3],["eldiarionuevodia.com.ar",[3,46]],["impulsobaires.com.ar",3],["lacapital.com.ar",[3,13,74]],["lanacion.com.ar",[3,76,77]],["lavoz.com.ar",[3,83]],["letrap.com.ar",3],["losandes.com.ar",[3,77]],["puntobiz.com.ar",[3,107]],["realpolitik.com.ar",3],["tntsports.com.ar",3],["unoentrerios.com.ar",[3,74]],["unosantafe.com.ar",[3,74,113]],["viapais.com.ar",3],["voydeviaje.com.ar",[3,115]],["t13.cl",[3,152,195]],["tntsports.cl",3],["motor.com.co",3],["24con.com",3],["agenciafe.com",3],["agritotal.com",3],["ambito.com",[3,252,253]],["azarplus.com",[3,60,271]],["bienbonita.com",3],["bigbangnews.com",[3,280]],["c5n.com",3],["castellonplaza.com",[3,306,307]],["cronista.com",[3,49,333]],["diariolaprovinciasj.com",[3,353]],["diariolasamericas.com",3],["diariolibre.com",[3,354]],["donbalon.com",[3,355]],["elgrafico.com",3],["elimparcial.com",[3,391,392,393]],["elnacional.com",[3,399]],["elonce.com",[3,404,405,406,407]],["elpatagonico.com",[3,410]],["elplural.com",[3,415]],["garticphone.com",3],["guarda14.com",3],["infocanuelas.com",3],["lacuarta.com",3],["lapoliticaonline.com",[3,517]],["laprensagrafica.com",[3,521]],["laverdadnoticias.com",3],["masgamers.com",3],["mdzol.com",3],["mibrujula.com",3],["minutouno.com",[3,253,574]],["pajilleros.com",[3,614]],["paraveronline.com",3],["primiciasya.com",[3,74]],["rosario3.com",3],["sanjuan8.com",3],["srpacks.com",3],["tutecnomundo.com",3],["tvynovelas.com",3],["tycsports.com",[3,171,692]],["valenciaplaza.com",[3,306]],["visortmo.com",[3,521,704]],["observador.cr",3],["alicanteplaza.es",[3,306]],["planetadeagostini.es",[3,821]],["welife.es",3],["sputniknews.lat",3],["debate.com.mx",[3,391,861]],["eleconomista.com.mx",[3,424]],["meristation.com.mx",[3,267]],["elinformador.mx",[3,873]],["informador.mx",[3,873]],["diariohoy.net",3],["eleconomista.net",3],["ellas.pa",3],["rpp.pe",[3,49,56,937]],["ella.sv",3],["laiguana.tv",3],["busqueda.com.uy",3],["meteored.com.ar",[5,88,89]],["carasycaretas.org.ar",5],["meteored.cl",[5,88,89]],["eldeportivo.com.co",[5,207]],["elpais.com.co",[5,209]],["animekb.com",5],["dinero.com",5],["estadiodeportivo.com",5],["expansion.com",[5,437,438]],["gonzoo.com",[5,134]],["highxtar.com",[5,471]],["iahorro.com",5],["laizquierdadiario.com",5],["latercera.com",[5,526]],["lavozdealmeria.com",5],["neomotor.com",5],["okdiario.com",[5,608]],["pulzo.com",[5,621]],["supercines.com",5],["tiempo.com",[5,88,89]],["cronicabalear.es",5],["iberempleos.es",5],["publico.es",[5,49,56,134,823]],["areajugones.sport.es",5],["eltribuno.info",5],["generacionuniversitaria.com.mx",[5,527]],["mundoejecutivo.com.mx",[5,867]],["diario.mx",[5,872]],["meteored.mx",[5,88,89]],["meteored.com.py",5],["16valvulas.com.ar",6],["infoagro.com.ar",[6,68]],["elsigloweb.com",[6,42]],["todopolicia.com",[6,606,682]],["25digital.com.ar",[7,8]],["horadeopinion.com.ar",[8,65,66,67]],["elespia.co",8],["envilladevoto.com",[8,25,431]],["3dgames.com.ar",9],["abchoy.com.ar",[10,11]],["elsol.com.ar",[10,52,53]],["diaridegirona.cat",[10,132,133]],["regio7.cat",[10,132,133]],["fmdos.cl",10],["applesfera.com",10],["bebesymas.com",[10,273]],["bolavip.com",[10,172,173,174,293]],["compradiccion.com",10],["diariocordoba.com",[10,132,133]],["diariodelviajero.com",[10,273]],["directoalpaladar.com",[10,358,359]],["elblogsalmon.com",[10,273]],["elconfidencial.com",[10,381]],["eldiario.com",10],["elpais.com",[10,408]],["elperiodicodearagon.com",[10,132,133]],["elperiodicoextremadura.com",[10,132,133]],["elperiodicomediterraneo.com",[10,132,133]],["espinof.com",10],["genbeta.com",10],["genbetadev.com",10],["laverdad.com",10],["levante-emv.com",[10,132,133]],["mediotiempo.com",[10,562,563]],["motorpasion.com",[10,359]],["motorpasionmoto.com",[10,273]],["noticiasdenavarra.com",[10,133]],["noticiasrcn.com",[10,304,602]],["ntn24.com",10],["pymesyautonomos.com",[10,273]],["revistafama.com",10],["salvajes.com",10],["todo-mail.com",10],["trendencias.com",10],["trendenciashombre.com",[10,358,359]],["vidaextra.com",[10,358,359]],["vitonica.com",10],["es.wallapop.com",10],["xataka.com",[10,358,359]],["xatakaciencia.com",10],["xatakafoto.com",10],["xatakahome.com",10],["xatakamovil.com",10],["xatakandroid.com",10],["xatakawindows.com",10],["diariocorreo.com.ec",[10,723]],["diariodeibiza.es",[10,132,133]],["diariodemallorca.es",[10,132,133,756]],["economiadigital.es",10],["elcorreogallego.es",[10,132,133,766]],["eldia.es",[10,132,133,768]],["eurosport.es",10],["farodevigo.es",[10,132,133]],["informacion.es",[10,132,133,797]],["laopinioncoruna.es",[10,132,133]],["laopiniondemalaga.es",[10,132,133]],["laopiniondezamora.es",[10,132,133]],["laprovincia.es",[10,132,133]],["larazon.es",[10,131,757,802]],["lne.es",[10,132,133]],["meteoconsult.es",10],["superdeporte.es",[10,132,133]],["telecinco.es",[10,336,833]],["deia.eus",[10,133]],["noticiasdealava.eus",[10,133]],["noticiasdegipuzkoa.eus",[10,133]],["emporda.info",[10,132,133,849]],["jornada.com.mx",10],["aica.org",10],["abcsaladillo.com.ar",12],["agroclave.com.ar",13],["cronica.com.ar",[13,29]],["anbariloche.com.ar",[14,15,16,17]],["anroca.com.ar",[14,15,16,17]],["elcordillerano.com.ar",[14,15]],["elterritorio.com.ar",[14,15]],["noticiasnet.com.ar",[14,15]],["diarioeldia.cl",[15,176]],["nuevodiarioweb.com.ar",17],["apfdigital.com.ar",18],["infoban.com.ar",[18,69]],["arquimaster.com.ar",[19,20,21,22]],["ellatinodehoy.com",19],["ahoraeg.com",[20,121,247]],["analitica.com",[20,121]],["donostitik.com",[20,364]],["elperiodicodelaenergia.com",[20,121]],["eltelegrafo.com",20],["isanidad.com",20],["periodicolaperla.com",20],["jotdown.es",20],["valencianews.es",20],["lapagina.com.sv",20],["moracontenidos.com",[21,55,581]],["cultoro.es",21],["enteratelatino.org",[21,924]],["arribalanus.com.ar",23],["diarioconurbano.com.ar",[23,30]],["el1digital.com.ar",23],["impactonews.co",[23,226,227]],["incp.org.co",[23,231]],["berjadigital.es",23],["armasymuniciones.net",[23,55,191]],["biodiesel.com.ar",24],["cadenaoh.com.ar",[25,26]],["profesionalreview.com",[26,635]],["cafexmedio.com.ar",27],["invertirenbolsa.mx",27],["ciudad.com.ar",28],["elcomercio.com",[28,380]],["hazteveg.com",[28,467]],["lmcipolletti.com",28],["lmneuquen.com",28],["diariocronica.com.ar",31],["henaojara.com",[33,468]],["diarioelinformante.com.ar",34],["laopinionsannicolas.com.ar",[34,79]],["elnacional.com.do",[34,721,722]],["hoy.com.do",[34,721]],["diarioelnorte.com.ar",35],["elproductor.com",[35,416]],["confirmado.net",35],["diariolarepublica.com.ar",36],["diarionoticias.com.ar",37],["diarioresumen.com.ar",39],["diariosanrafael.com.ar",40],["diariovictoria.com.ar",[41,42]],["planbnoticias.com.ar",[41,68,80,101,102,103]],["elexpediente.co",[41,217]],["nuestroclima.com",[41,606]],["easy.com.ar",43],["elchubut.com.ar",44],["infoplatense.com.ar",44],["eldia.com",44],["elcomercial.com.ar",45],["eleconomista.com.ar",47],["elliberal.com.ar",[48,49]],["elobservador.com.uy",[49,77,958]],["elnueve.com.ar",50],["elretratodehoy.com.ar",51],["lanoticiadequilmes.com.ar",52],["20minutos.com",[52,239,240]],["clarin.com",[52,93,171,318]],["elespanol.com",[52,86,386]],["elindependiente.com",[52,395]],["juegosarea.com",52],["20minutos.es",[52,239,240,510,733]],["20minutos.com.mx",[52,239,240]],["destinonegocio.com",53],["elsolnoticias.com.ar",[54,55]],["hortanoticias.com",[54,67,476,477]],["noticiasformosa.com.ar",[55,90]],["bcnoticias.com.co",[55,201]],["claridadpuertorico.com",55],["cronicasnews.com",55],["diariotextual.com",[55,67,357]],["elnuevogeorgia.com",[55,401,402]],["gacetinmadrid.com",55],["laprensadecolorado.com",[55,67,518]],["noticiasenlineacr.com",55],["realidadsm.com",[55,121,367]],["somosjuarez.com",55],["viajareslapera.com",55],["webelpuente.com",55],["cronica.com.ec",55],["lanacion.com.ec",[55,726]],["radiosucre.com.ec",55],["larepublica.ec",55],["crearmiempresa.es",[55,68]],["barrigaverde.net",55],["diarioeltiempo.com.ve",55],["elperiodicodemonagas.com.ve",[55,965]],["elsiglo.com.ve",[55,121,178]],["eltrecetv.com.ar",[56,57]],["laprensaaustral.cl",56],["lared.cl",56],["dimayor.com.co",56],["benditofutbol.com",56],["cronicadelquindio.com",56],["lostiempos.com",[56,547]],["perfil.com",[56,620,621]],["peru.com",[56,342,624]],["studio92.com",56],["cdn.com.do",[56,719]],["eslang.es",56],["uypress.net",56],["atv.pe",[56,311]],["corazon.pe",56],["gnula.se",[56,118]],["espn.com.ar",58],["espn.cl",58],["espn.com.co",58],["espn.co.cr",58],["espn.com.do",58],["espn.com.ec",58],["espn.com.gt",58],["espn.com.mx",58],["espn.com.pa",58],["espn.com.pe",58],["espn.com.uy",58],["espn.com.ve",58],["fenix951.com.ar",59],["fm899.com.ar",60],["eurogirlsescort.es",[60,778]],["telesurtv.net",60],["fmvida.com.ar",61],["lapoliticaonline.com.mx",61],["fulltv.com.ar",62],["futbolhoy.com.ar",63],["gente.com.ar",64],["grupormultimedio.com",66],["lahora.com.ec",66],["equipar.es",66],["nicaraguahoy.info",66],["atacamaenlinea.cl",[67,157,158]],["beergeeks.cl",[67,160,161]],["apuestasfree.com",[67,262]],["cinemascomics.com",67],["conbasesllenas.com",67],["informe21.com",[67,493]],["lacapitalmdp.com",[67,509]],["lapanteradc.com",[67,515]],["mundo724.com",[67,480,583]],["socialetic.com",67],["thebeertimes.com",[67,160,164]],["pcpro.es",[67,178]],["beermagazine.net",[67,164,884]],["videospornogratisx.net",[67,477]],["insideevs.com.ar",[70,71]],["iproup.com",[70,498]],["laarena.com.ar",[72,73]],["dolarhoy.com",[72,361]],["lagaceta.com.ar",75],["lagacetasalta.com.ar",75],["elperiodico.cat",[75,137]],["elperiodico.com",[75,137,412,413]],["sumedico.com",75],["cope.es",[75,424]],["epe.es",[75,137,412,413]],["sport.es",[75,830]],["laconversacion.net",75],["ruedasgordas.es",[77,826]],["lanusnoticias.com.ar",78],["lapampadiaxdia.com.ar",[80,81]],["laredpampeana.com.ar",[80,82]],["loteriasmundiales.com.ar",84],["loventine.com.ar",85],["loventine.es",85],["maximaonline.com.ar",86],["hispanidad.com",86],["lleida.com",89],["modaes.com",89],["noticiaslasflores.com.ar",91],["noticiasurbanas.com.ar",92],["ole.com.ar",[93,94]],["olx.com.ar",95],["pagina12.com.ar",96],["paginasblancas.com.ar",97],["blancas.cl",97],["paginasblancas.com.pe",97],["pdindustriales.com.ar",98],["periodismokosher.com.ar",99],["pescare.com.ar",100],["ipsnoticias.net",102],["transponder1200.com",[103,477]],["planetabocajuniors.com.ar",104],["promiedos.com.ar",105],["radioexito.com.ar",108],["rionegro.com.ar",109],["salpimenta.com.ar",110],["tiemposur.com.ar",111],["tiendeo.com.ar",112],["ushuaia24.com.ar",114],["dolarito.ar",116],["comodorodeportes.gov.ar",117],["flvto.biz",[118,119]],["gnula.cc",[118,151]],["mp3juices.cc",118],["2conv.com",118],["doramasflixs.com",118],["doramasvip.com",118],["telenovelas-turcas.com.es",118],["jkanime.net",118],["serieskao.net",118],["vidoza.net",118],["lectortmo.org",118],["serieskao.tv",118],["cuevana3.video",118],["pelisplus.video",118],["pivigames.blog",120],["atb.com.bo",121],["elmetro.com.co",121],["aviacionline.com",121],["elambito.com",121],["gasteizhoy.com",[121,367,459]],["latinopinionbaltimore.com",[121,528]],["radiomunera.com",121],["sticknoticias.com",121],["teleamazonas.com",121],["aurora-israel.co.il",121],["siempre.mx",121],["eldeber.com.bo",122],["reduno.com.bo",123],["paginasiete.bo",124],["pelisplus.cam",125],["3cat.cat",126],["aguaita.cat",[127,128,129,130]],["pallarsdigital.cat",[127,128,129,130]],["rubitv.cat",[127,128,129,130]],["tarragonadigital.com",[127,128,129,130]],["naciodigital.cat",[128,129,144]],["pensem.cat",[128,130]],["ara.cat",131],["ejeprime.com",[131,373]],["papajuegos.com",131],["periodistadigital.com",131],["plantadoce.com",[131,626]],["realovirtual.com",131],["relevo.com",131],["tribunaavila.com",[131,685]],["tribunaburgos.com",[131,685]],["tribunaleon.com",[131,685]],["tribunapalencia.com",[131,685]],["tribunasalamanca.com",[131,685]],["tribunasegovia.com",[131,685]],["tribunasoria.com",[131,685]],["tribunavalladolid.com",[131,685]],["tribunazamora.com",[131,685]],["elcorreoweb.es",[132,767]],["laopiniondemurcia.es",[132,133]],["e-noticies.cat",[134,135]],["diariovasco.com",134],["elcorreo.com",134],["larioja.com",134],["leonoticias.com",[134,538]],["diariodenavarra.es",[134,757]],["diariosur.es",134],["digitalcamera.es",134],["elcomercio.es",134],["eldiariomontanes.es",134],["elnortedecastilla.es",134],["hoy.es",134],["ideal.es",[134,538]],["lasprovincias.es",134],["primeralinea.es",134],["elnacional.cat",136],["cocheglobal.com",136],["cronicavasca.com",136],["culemania.com",136],["diario16plus.com",136],["cronicaglobal.elespanol.com",136],["huleymantel.com",136],["planetarealmadrid.com",136],["elpuntavui.cat",[138,139]],["leconomic.cat",[138,139]],["lesportiudecatalunya.cat",[139,143]],["isabadell.cat",140],["autoextragti.com",140],["madridnorte24horas.com",140],["washingtonhispanic.com",[140,274]],["soloqchallenge.gg",140],["pelisplus.lat",140],["mexicodesconocido.com.mx",140],["labustia.cat",141],["laveu.cat",142],["noticiestgn.cat",145],["racocatala.cat",146],["tot-hospitalet.cat",147],["totsantcugat.cat",148],["tottarragona.cat",149],["vilaweb.cat",150],["uqload.com",151],["13.cl",152],["deportes13.cl",152],["800.cl",153],["adnradio.cl",[154,155,156]],["caracol.com.co",154],["wradio.com.co",154],["wradio.com.mx",154],["cnnchile.com",155],["futuro360.com",155],["redmipaisnorte.cl",158],["autosusados.cl",159],["cannabis420.cl",[160,164,165]],["comidasespanolas.com",[160,164]],["recetasdepan.net",[160,164,884]],["weedmagazine.net",[160,164,912]],["reparaciondecomputadoras.online",160],["cafevirtual.cl",162],["pamplonaactual.com",162],["trincheraonline.com",162],["cambio21.cl",163],["nicaraguainvestiga.com",163],["jerezcofrade.tv",[163,903,952]],["debosaber.cl",[164,175]],["comidaschilenas.com",[164,322]],["capital.cl",166],["chileautos.cl",167],["chilevision.cl",168],["chocale.cl",169],["concierto.cl",170],["cooperativa.cl",171],["dalealbo.cl",[172,173,174]],["redgol.cl",[172,173,174]],["eltiempo.com",[172,233,423,424]],["futbolcentroamerica.com",[172,173,174]],["hobbyconsolas.com",[172,325,474]],["juanbeisbol.com",[172,173,174]],["juanfutbol.com",[172,173,174]],["lapaginamillonaria.com",[172,173,174]],["somosfanaticos.fans",[172,173,174]],["buenazo.pe",172],["elpopular.pe",172],["larepublica.pe",[172,935]],["libero.pe",172],["wapa.pe",172],["diarioestrategia.cl",177],["infodefensa.com",177],["diariolaprensa.cl",178],["bavaronews.com",178],["chacodiapordia.com",178],["eladelantado.com",178],["elmundotoday.com",178],["elperiodicousa.com",178],["guineainfomarket.com",178],["horajaen.com",[178,475]],["lagdeguinea.com",178],["noticialdia.com",[178,597]],["noticiasuno.com",178],["periodismo.com",178],["soynuevaprensadigital.com",178],["tumbaabierta.com",178],["ultimahoraec.com",178],["elmercurio.com.ec",[178,724]],["diariolatino.net",178],["eldiario.net",178],["udlaspalmas.net",[178,911]],["contrapunto.com.sv",[178,945]],["mundoplus.tv",[178,543,953]],["elaragueno.com.ve",178],["lacalle.com.ve",178],["avn.info.ve",178],["elamaule.cl",179],["elboyaldia.cl",179],["elconcecuente.cl",179],["elmagallanews.cl",179],["elmartutino.cl",179],["elmorrocotudo.cl",179],["elnaveghable.cl",179],["elnortero.cl",179],["elobservatodo.cl",179],["elquehaydecierto.cl",179],["elrancahuaso.cl",179],["elrepuertero.cl",179],["elvacanudo.cl",179],["laopinon.cl",179],["elciudadano.cl",180],["eldefinido.cl",181],["eldinamo.cl",182],["theclinic.cl",[182,196]],["ellibero.cl",183],["elperiodista.cl",184],["expresodelacosta.cl",185],["guiahoreca.cl",186],["ilustrado.cl",187],["lanacion.cl",188],["latribuna.cl",189],["meganoticias.cl",190],["miradiols.cl",191],["mariosegura.com",[191,558]],["prensafutbol.cl",192],["publimetro.cl",193],["metroecuador.com.ec",193],["soychile.cl",194],["tvn.cl",197],["yapo.cl",198],["accounter.co",199],["atlnacional.com.co",200],["boyaca7dias.com.co",202],["canal1.com.co",203],["diariodelcauca.com.co",[204,205]],["diariodelsur.com.co",[205,206]],["elinformador.com.co",208],["ecijaweb.com",208],["lancelotdigital.com",[208,513]],["lavozdemoron.es",208],["elwebdelmirall.net",208],["extra.com.co",210],["hoydiariodelmagdalena.com.co",211],["redmas.com.co",212],["revistacromos.com.co",213],["elespectador.com",[213,389]],["revistapym.com.co",214],["tiempodenoticias.com.co",215],["diarioadn.co",216],["elheraldo.co",[218,219]],["valoraanalitik.com",[218,274,695]],["elmeridiano.co",220],["emprendices.co",[221,222]],["misionesonline.net",[221,902,903]],["flashscore.co",[223,224]],["flashscore.es",[224,783]],["flashscore.pe",224],["forbes.co",225],["recursosculturales.com",226],["villavonoticias.com",[226,374,702]],["jawcloud.co",228],["momento24.co",229],["moviesdvdr.co",230],["cinecalidad.gg",230],["pelisplay.co",232],["portafolio.co",[233,234]],["seguimiento.co",235],["slimdownload.co",236],["winsports.co",237],["19640noticias.com",238],["ushuaianoticias.com",[239,694]],["primicia.com.ve",239],["3djuegos.com",241],["4pelagatos.com",242],["actualarganda.com",243],["actualidadradio.com",244],["adiariocr.com",245],["agencianova.com",246],["novachaco.com",246],["novalaplata.com",[246,605]],["ahorradororata.com",248],["alcalorpolitico.com",249],["aldeaviral.com",250],["periodicoeldiario.com",[250,622]],["eldiariodeguayana.com.ve",250],["allinonedownloader.com",251],["apertura.com",253],["elnueve.com",[253,400]],["elpuntodeequilibrio.com",253],["infotechnology.com",253],["revistacar.es",253],["americateve.com",254],["andro4all.com",255],["animalpolitico.com",256],["anitoc.com",257],["lectormanga.com",257],["otakuteca.com",257],["panicmanga.com",257],["planetaneperian.com",257],["recetasmaria.com",257],["sombracycling.com",257],["tannyfashion.com",257],["todomecanica.com",257],["vgrecipes.com",257],["worldmangas.com",257],["ansalatina.com",258],["antena3.com",259],["atresmedia.com",259],["lasexta.com",[259,524]],["melodia-fm.com",259],["appsparavertv.com",260],["aptitus.com",261],["arbolabc.com",263],["argentinavende.com",264],["cordobavende.com",264],["aristeguinoticias.com",265],["as.com",266],["meristation.as.com",267],["astrologiaenlinea.com",268],["aulafacil.com",269],["avisosdeocasion.com",270],["baratos.com",272],["bembibredigital.com",274],["comedera.com",274],["periodismodelmotor.com",274],["radiocre.com",274],["stonkstutors.com",274],["tresubresdobles.com",[274,684]],["finofilipino.org",[274,925]],["intercambiosvirtualeshd.org",274],["mejoresmodsminecraft.site",[274,943]],["bernabeudigital.com",[275,276]],["eltiempo.es",[275,773]],["bienesrosario.com",[277,278,279]],["rosariogarage.com",[277,279,652]],["wiselwisel.com",[277,708]],["bikezona.com",281],["bimotos.com",282],["binary.com",283],["bingoporno.com",284],["blanesaldia.com",285],["blog-peliculas.com",286],["misseriesinolvidables.blogspot.com",287],["novelasromanticash.blogspot.com",288],["reconquistanoticias.blogspot.com",[289,290]],["ladefensadigital.com",289],["xanateach.blogspot.com",291],["boardzona.com",292],["bolivia.com",294],["colombia.com",294],["buenaventuraenlinea.com",295],["buscamultas.com",296],["businesscol.com",297],["cadena3.com",298],["cadenaser.com",299],["calculadora-de-derivadas.com",300],["calculadora-de-integrales.com",300],["canal-i.com",301],["canal21ebre.com",302],["marfanta.com",[302,557]],["canalporno.com",303],["canalrcn.com",[304,305]],["cerdas.com",308],["cerebriti.com",309],["chacohoy.com",310],["corrienteshoy.com",310],["chapintv.com",311],["repretel.com",311],["rts.com.ec",311],["sonora.com.gt",311],["c9n.com.py",311],["snt.com.py",311],["canal12.com.sv",311],["chathispano.com",312],["cheemsporn.com",313],["ciclismoatual.com",314],["tenisaldia.es",314],["cienradios.com",315],["cifraclub.com",316],["cinelibreonline.com",317],["cocina-chilena.com",319],["coin360.com",320],["comicxporn.com",321],["compraensanjuan.com",323],["computerhoy.com",[324,325]],["autobild.es",325],["businessinsider.es",325],["topgear.es",325],["comutricolor.com",326],["conejox.com",327],["contextoganadero.com",328],["cooljuegos.com",329],["cotilleando.com",330],["burbuja.info",[330,847]],["criptoinforme.com",331],["criptonoticias.com",332],["cryptopotato.com",334],["cualesmiip.com",335],["cuatro.com",336],["factoriadeficcion.com",336],["bemad.es",336],["divinity.es",336],["energytv.es",336],["mtmad.es",336],["niusdiario.es",336],["uppers.es",336],["yasss.es",336],["cuyonoticias.com",337],["cdn.cxpublic.com",338],["dataifx.com",339],["depor.com",[340,341,342]],["elcomercio.pe",[340,342,932]],["diariocorreo.pe",[342,931]],["gestion.pe",342],["derechouned.com",343],["desarrollowp.com",344],["microsiervos.com",[344,453,568]],["supercpps.com",344],["diaridesabadell.com",345],["diarideterrassa.com",345],["diariobitcoin.com",346],["diariocolatino.com",[347,348]],["teknofilo.com",[347,675]],["diariocostadelsol.com",349],["diariocritico.com",350],["diarioelsalvador.com",351],["diariolagrada.com",352],["marketingregistrado.com",352],["prensa.com",[352,569,633]],["elesquiu.com",353],["gastrolabweb.com",353],["infofueguina.com",353],["pilaradiario.com",353],["poresto.net",353],["diarioresponsable.com",[355,356]],["elsaltodiario.com",[355,420]],["esmtb.com",[355,433]],["motorpasion.com.mx",359],["discogs.com",360],["doncolombia.com",362],["esaschicas.com",362],["donlgbt.com",363],["durosa4pesetas.com",365],["economia3.com",[366,367]],["desdesoria.es",[367,754]],["economipedia.com",368],["ecosdelcombeima.com",369],["ecuavisa.com",370],["educaplay.com",371],["ehowenespanol.com",372],["elbierzodigital.com",374],["futbolretro.es",[374,789]],["elblog.com",375],["elchapuzasinformatico.com",376],["elchavodel8tv.com",377],["ppelverdadero.com.ec",377],["elciudadanoweb.com",378],["elcolombiano.com",379],["elcucodigital.com",382],["eldebate.com",383],["eldesmarque.com",384],["eldestapeweb.com",385],["diariodeavisos.elespanol.com",387],["elespecial.com",388],["elestimulo.com",390],["frontera.info",[393,405,850]],["elimpulso.com",394],["elmercurioweb.com",[396,397]],["mododeporte.com",397],["elmundofinanciero.com",398],["noticierodelllano.com",401],["elnuevoherald.com",403],["esdiario.com",[404,432]],["rewisor.com",407],["motor.elpais.com",409],["elperiodic.com",411],["eldiario.es",[413,769]],["elperiodicodeaqui.com",414],["elrellano.com",[417,418]],["180grados.digital",[418,717]],["elrincondelvinotinto.com",419],["elsalvador.com",421],["elsolnews.com",422],["segre.com",424],["miarevista.es",424],["serpadres.es",424],["eltorotv.com",425],["eluniversal.com",426],["eluniverso.com",427],["emol.com",428],["encuentra24.com",429],["entornointeligente.com",430],["espaebook2.com",434],["estrenarvivienda.com",435],["europafm.com",436],["ondacero.es",[436,816]],["elmundo.es",[437,772]],["blog.facialix.com",439],["falabella.com",440],["fayerwayer.com",441],["felizporno.com",442],["fichajes.com",443],["finanzasargy.com",444],["fitnesszona.com",445],["formulatv.com",446],["forobeta.com",447],["forocoches.com",448],["forococheselectricos.com",449],["foromtb.com",450],["foroparalelo.com",451],["freeethereum.com",452],["freetether.com",452],["coinfaucet.io",452],["freebitcoin.io",452],["fucklouder.com",[453,454]],["futbolme.com",455],["futbolred.com",456],["gameflare.com",457],["gamezfull.com",458],["generacionxbox.com",460],["gerente.com",461],["goraymi.com",462],["granadahoy.com",463],["diariodealmeria.es",463],["diariodecadiz.es",463],["diariodejerez.es",463],["diariodesevilla.es",[463,759]],["eldiadecordoba.es",463],["europasur.es",463],["huelvainformacion.es",463],["malagahoy.es",463],["guadairainformacion.com",464],["guiascasinos.com",465],["habitaclia.com",466],["hentaienesp.com",469],["hentaila.com",470],["hipertextual.com",472],["hispanicpost.com",473],["libroscristianosgratis.net",476],["laprensademn.com",[477,519,520]],["vidaysabor.com",[477,519,700]],["hosteltur.com",478],["hoyenbogota.com",[479,480]],["hoylosangeles.com",481],["hsbnoticias.com",482],["htcmania.com",483],["huelva24.com",484],["st1.idealista.com",485],["igg-games.com",486],["imperiodefamosas.com",487],["independentespanol.com",488],["indicepr.com",489],["infobae.com",490],["infojardin.com",491],["infopico.com",492],["inkagames.com",494],["inmodiario.com",495],["iprofesional.com",[496,497]],["todacolombia.com",497],["juanbustos.com",499],["juegos.com",500],["juegosjuegos.com",501],["jugarbet.com",502],["noticias.juridicas.com",503],["kairosweb.com",504],["kiwilimon.com",505],["knightnoscanlation.com",506],["yugenmangas.com",506],["la-razon.com",507],["laboyanos.com",508],["lainformacion.com",[510,511]],["lajornadanet.com",512],["laoctava.com",514],["lapatilla.com",516],["periodicoelsolpr.com",518],["laprensani.com",522],["las4esquinas.com",523],["lasubasta.com",525],["latino-webtv.com",527],["xnalgas.com",[527,713]],["ver-television.online",527],["lavanguardia.com",529],["laventanabolivia.com",530],["laverdaddemonagas.com",531],["lavozhispanact.com",532],["lawebdelprogramador.com",533],["lectuepubgratis.com",534],["lecturas.com",535],["nationalgeographic.com.es",535],["leercapitulo.com",536],["legionasia.com",537],["laverdad.es",538],["lexlatin.com",539],["libertaddigital.com",[540,541]],["libremercado.com",540],["liderendeportes.com",[542,543]],["lifeder.com",544],["llanosietedias.com",545],["los40.com",546],["macrojuegos.com",548],["madlifes.com",549],["pepeporn.com",549],["madridpress.com",550],["sahagundigital.com",550],["magazinelatino.com",551],["magisnet.com",552],["manerasdevivir.com",553],["mangacrab.com",554],["marca.com",555],["marcadegol.com",556],["mariskalrock.com",559],["mastercoria.com",560],["mediavida.com",561],["record.com.mx",[563,869]],["mega1080.com",564],["merca20.com",565],["rinconforero.mforos.com",566],["miamidiario.com",567],["midiario.com",569],["milanuncios.com",570],["milenio.com",571],["miltorrents.com",572],["minijuegos.com",573],["mioriente.com",575],["misionescuatro.com",576],["noticias.mitelefe.com",[577,578]],["telefe.com",578],["mms-mexico.com",579],["monografias.com",580],["mundo.com",582],["mundodeportivo.com",584],["mundommorpg.com",585],["corepunk.online",585],["mundour.com",586],["muycerditas.com",587],["muyzorras.com",588],["nacion.com",589],["lateja.cr",589],["nacionpaisa.com",590],["es.nametests.com",591],["neoauto.com",592],["nintenderos.com",593],["norteenlinea.com",594],["notariosyregistradores.com",595],["noticiacristiana.com",596],["noticias3d.com",598],["noticiasdel6.com",599],["noticiasenlamira.com",600],["noticiasparamunicipios.com",601],["noticiasyprotagonistas.com",603],["estadio.ec",603],["noticierodigital.com",604],["nuevamujer.com",607],["omarhvelasquezm.com",609],["ondavasca.com",610],["opanoticias.com",611],["otakustv.com",612],["oversos.com",613],["pampaporno.com",615],["parentesis.com",616],["parlamentario.com",617],["peliculasaudiolatino.com",618],["pelispanda.com",619],["divxtotal.li",619],["divxtotal.nl",619],["divxtotal.pm",619],["cuevana.se",619],["dontorrent.ws",619],["periodicoellaurelpr.com",623],["petardashd.com",625],["playpaste.com",627],["pokertube.com",628],["porneados.com",629],["pornogratisdiario.com",630],["portalfruticola.com",631],["practisistemas.com",632],["prensalibre.com",634],["promodescuentos.com",636],["psicologiaymente.com",637],["pt-mexico.com",638],["pulpo69.com",639],["puupnewsapp.com",640],["quepasamedia.com",641],["quesonlosvaloreseticos.com",642],["signodeinterrogacion.com",642],["ramenparados.com",643],["rateyourmusic.com",644],["recursos-biblicos.com",645],["reforma.com",646],["renfe.com",647],["reporteindigo.com",648],["republica.com",649],["resultados-futbol.com",650],["retinatendencias.com",651],["rumbonews.com",653],["sailingzona.com",654],["sdpnoticias.com",655],["semana.com",656],["sensacine.com",657],["sensacine.com.mx",657],["separarensilabas.com",658],["seriesgrey.com",659],["serviporno.com",[660,661]],["muchoporno.xxx",661],["skdesu.com",662],["skylinewebcams.com",663],["slidesgo.com",664],["smnoticias.com",[665,666]],["smnoticias.info",[665,666]],["costacadizcomunicacion.es",[666,750]],["softoniclabs.com",667],["somosohlala.com",668],["somosxbox.com",669],["sqlshack.com",670],["supercontable.com",671],["superluchas.com",672],["tabascohoy.com",673],["talcualdigital.com",674],["telesemana.com",676],["televisa.com",677],["deportes.televisa.com",678],["thaderclub.com",679],["theobjective.com",680],["todoblaugrana.com",681],["tokyvideo.com",683],["tribunamaresme.com",686],["periodicoelnazareno.es",686],["tudiscovery.com",687],["tudn.com",[688,689]],["univision.com",[689,693]],["tumomo.com",690],["tvenganchado.com",691],["vanguardia.com",696],["verepeliculas.com",697],["vergnula.com",698],["vibbo.com",699],["villavicenciodiaadia.com",701],["viralizalo.com",703],["vivanolamag.com",705],["vix.com",706],["volkgames.com",707],["wizcase.com",709],["wordmagicsoft.com",710],["wowtechlife.com",711],["xn--xvideos-espaol-1nb.com",712],["veoporno.gratis",712],["zigzagdigital.com",714],["zonavideosx.com",715],["laregion.cr",716],["tutorialesenlinea.es",[716,837]],["confidencial.digital",718],["colorvision.com.do",720],["lagaceta.com.ec",725],["ldu.com.ec",727],["planv.com.ec",728],["radiocentro.com.ec",729],["dialoguemos.ec",730],["eldiario.ec",731],["expreso.ec",732],["abc.es",734],["ancient-origins.es",735],["andaluciainformacion.es",[736,737]],["informacionalcalalareal.es",736],["informacionpuentegenil.es",736],["informacionsanfernando.es",736],["sanlucarinformacion.es",736],["vivaalmeria.es",736],["vivaalmunecar.es",736],["vivaantequera.es",736],["vivaarcos.es",736],["vivabarbate.es",736],["vivabenalmadena.es",736],["vivacadiz.es",736],["vivacampodegibraltar.es",736],["vivachiclana.es",736],["vivaconil.es",736],["vivacordoba.es",736],["vivaelpuerto.es",736],["vivaestepona.es",736],["vivagranada.es",736],["vivahuelva.es",736],["vivajaen.es",736],["vivajerez.es",736],["vivamarbella.es",736],["vivapunta.es",736],["vivarota.es",736],["vivasevilla.es",736],["vivatorremolinos.es",736],["vivavejer.es",736],["vivavelezmalaga.es",736],["vivamalaga.net",736],["vivavalencia.net",736],["vivagalicia.tv",736],["viruji.andaluciainformacion.es",738],["androidpit.es",739],["anisearch.es",740],["areasac.es",741],["autopista.es",742],["autoscout24.es",743],["carrefour.es",744],["casinonewsdaily.es",745],["ceroacero.es",746],["comunio.es",747],["concuchilloytenedor.es",748],["cosasdecome.es",749],["cuartopoder.es",751],["cuencanews.es",752],["darkstone.es",753],["diariodelalinea.es",755],["marie-claire.es",[757,810]],["muyhistoria.es",[757,810]],["muyinteresante.es",[757,810]],["muynegociosyeconomia.es",[757,810]],["diariodepasion.es",758],["diariodeteruel.es",760],["diariodevalderrueda.es",761],["diariolalupa.es",762],["diarioronda.es",[763,764]],["desdelinux.net",764],["ebay.es",765],["infolibre.es",769],["eleconomista.es",770],["empresite.eleconomista.es",771],["epasatiempos.es",774],["neomotor.epe.es",775],["escort46.es",776],["euractiv.es",777],["europa-agricola.es",779],["via-mobilis.es",779],["europapress.es",780],["famosateca.es",781],["ffcv.es",782],["force-download.es",784],["foropolicia.es",785],["fotocasa.es",786],["freeones.es",787],["freepik.es",788],["gaceta.es",[789,790]],["gamereactor.es",791],["gettyimages.es",792],["heraldo.es",793],["hoyaragon.es",794],["huffingtonpost.es",795],["iberley.es",796],["interbenavente.es",798],["irispress.es",799],["estadiodeportivo.whitelabel.kelisto.es",800],["kissfm.es",801],["latinpress.es",803],["lavozdegalicia.es",804],["lebrijadigital.es",805],["leganews.es",806],["leroymerlin.es",807],["livenumetal.es",808],["manomano.es",809],["mediamarkt.es",811],["mil21.es",812],["mitele.es",813],["nextpit.es",814],["noticiasmallorca.es",815],["paginasamarillas.es",817],["pajarracos.es",818],["paxinasgalegas.es",819],["petitchef.es",820],["portalbici.es",822],["dle.rae.es",824],["realbetisbalompie.es",825],["rumbo.es",827],["segoviaudaz.es",828],["sevillainfo.es",829],["supremacy1914.es",831],["tallasgrandes.es",832],["todomercadoweb.es",834],["transfermarkt.es",835],["turium.es",836],["zooplus.es",838],["bandaancha.eu",839],["cuevana3.eu",840],["naiz.eus",841],["pelis24.gratis",842],["seriesturcas.gratis",843],["verpeliculasporno.gratis",844],["publinews.gt",845],["elheraldo.hn",846],["ciudadccs.info",848],["va6.thand.info",851],["agma.io",852],["wago.io",853],["pelispedia.la",854],["cuevana.pro",854],["purochocolate.life",855],["tumascota.life",855],["abs0rb.me",856],["chatytvgratishd.me",857],["megaserie.me",858],["avisooportuno.mx",859],["bcsnoticias.mx",860],["elsiglodetorreon.com.mx",862],["eluniversal.com.mx",[863,864]],["viveusa.mx",864],["excelsior.com.mx",865],["foxsports.com.mx",866],["razon.com.mx",868],["tiempo.com.mx",870],["yucatan.com.mx",871],["elpopular.mx",874],["mixfm.mx",875],["nupcias.mx",876],["terremoto.mx",877],["adslzone.net",878],["alfabeta.net",879],["almomento.net",880],["animebum.net",881],["animeflv.net",882],["apurogol.net",883],["blizzboygames.net",885],["brujuladigital.net",886],["buenaisla.net",887],["buentv.net",888],["capodeportes.net",889],["coches.net",890],["diariodelaribera.net",891],["elotrolado.net",892],["elpotosi.net",893],["esporno.net",894],["eshentai.tv",894],["infojobs.net",895],["jkhentai.net",896],["kiosco.net",897],["labsk.net",898],["lacuerda.net",899],["mangatigre.net",900],["maracodigital.net",901],["noticiasdelavilla.net",904],["pelispunto.net",905],["poringa.net",906],["pornocolombiano.net",907],["seriesanimadas.net",908],["sunoticiero.net",909],["tutiempo.net",910],["zona-leros.net",913],["la.network",914],["show.news",915],["tubarco.news",916],["cuevana3.nu",917],["pelisplushd.nz",918],["nickelodeonplus.online",919],["albumoftheyear.org",920],["aporrea.org",921],["artesacro.org",922],["diariodelaribera.org",923],["noticiasdelmundo.org",926],["diaadia.com.pa",927],["panamaamerica.com.pa",928],["andina.pe",929],["americatv.com.pe",930],["exitosanoticias.pe",933],["laindustria.pe",934],["peru21.pe",936],["dinostream.pw",938],["abc.com.py",939],["cuevana3.rip",940],["hackstore.rs",941],["nocensor.sbs",942],["noticiasdehoy.site",944],["elpais.com.sv",946],["vidasana.sv",947],["moviesjoy.to",948],["seriesdanko.to",949],["animeid.tv",950],["eldoce.tv",951],["ondaluz.tv",954],["qmusica.tv",955],["playdede.us",956],["180.com.uy",957],["elpais.com.uy",959],["lr21.com.uy",960],["montevideo.com.uy",961],["pantallazo.com.uy",962],["radiomontecarlo.com.uy",963],["radiocarve.uy",964],["fronteradigital.com.ve",966],["versionfinal.com.ve",967],["juegosjuegos.ws",968],["maduras.xxx",969],["videos.mrvideospornogratis.xxx",970],["pornes.xxx",971],["qporno.xxx",972],["tupornogratis.xxx",973],["grantorrent.zip",974]]);

const entitiesMap = new Map([["mercadolibre",0]]);

const exceptionsMap = new Map(undefined);

self.specificImports = self.specificImports || [];
self.specificImports.push({ argsList, hostnamesMap, entitiesMap, exceptionsMap });

/******************************************************************************/

})();

/******************************************************************************/
