/*******************************************************************************

    uBlock Origin Lite - a comprehensive, MV3-compliant content blocker
    Copyright (C) 2019-present Raymond Hill

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see {http://www.gnu.org/licenses/}.

    Home: https://github.com/gorhill/uBlock
*/

/* jshint esversion:11 */

'use strict';

// ruleset: swe-1

/******************************************************************************/

// Important!
// Isolate from global scope
(function uBOL_cssSpecificImports() {

/******************************************************************************/

const argsList = ["#sliding-popup",".revive-wrapper, div[id^=\"block-views-block-editorial-ads\"], div[id^=\"block-blockbanner\"]",".front #secondary-content-wrapper, .banner-wrapper, .content-prefix-banner-wrapper","#topadmob",".banner-block",".panorama",".gdpr,\na[onclick*=\"banner\"], .ad-follower",".g","a[href*=\"svenskaspel.se\"][target]","[class*=\"teaser-native\"], lcl-ad, .ad-welcome, .affiliate-links__container, .x-bonnier-news-links__container",".top-banner","div[id^=\"azrhymes_com_between_content\"]",".widget_sp_image, a[title^=\"ANNONS\"], .inner_sidebar .widget_text, .entry-content a[href*=\"utm_campaign\"],\narticle:has(a[href*=\"/annons-\"])",".sponsored-articles-container, .nav-sep-blink, .annons-label, .index-side-banner-wrapper, .index-top-banners-wrapper, .fullwidthbanner-container, .banner-wrapper,\narticle:has(.border-sponsored)",".listpage-banner, .available-services,\n.newcars-widget:has(a[href*=\"bit.ly\"], a[href*=\"content-ad\"])",".grid-add-container",".frontPageBox--links",".textwidget a[target=\"_blank\"]","#cmplz-cookiebanner-container",".js-banner-wrapper,\n.js-cookie-disclaimer","#g-header, #g-aside, #g-sidebar, div[data-role=\"sidebarAd\"]","#ipsLayout_mainArea > iframe","td > a[target=\"_blank\"] img","a[href*=\"bannerid\"]",".box-of-announcement, a[href*=\"campaign\"][target=\"_blank\"], div[class*=\"rotating-\"], #bottombanner, #promoPopup, .modal-backdrop, .newsletterPopUp","a[target$=\"blank\"] img:not([class^=\"tweet\"])","div[id^=\"everysport_sky\"], img[alt=\"X3000\"], img[alt=\"Casinofeber\"],\nfooter > div:has(a[href*=\"casino\"])",".header-static-lg, .fp-partner, .xs-ad, .bo-wrapper, #betsid, .news-banner-mini, .xs-cblock, .cookie_consent_bar, #odds, a.bellows-target[href*=\"/svenskaspel\"], a.bellows-target[href*=\"/betting\"], a[href*=\"/go/\"][onclick], #lg-box-scyscraper,\n:is(div.text-center, div.d-none):has(a[href*=\"/go/\"][onclick], .fotboll_content_wrapper[data-id])",".smartbanner","#cookie-notice","a.gofollow[data-track]",".border-b:has(#vi-ad, div[data-adk-container], div[id^=\"fotbolltransfers_mpu\"]),\ndiv[class^=\"ad\"], a[href^=\"https://ads.\"], .header_sponsored, .fresnel-greaterThanOrEqual-panorama, .fresnel-lessThan-panorama, a[rel*=\"sponsored\"],\ndiv[style^=\"min-height\"]:has(div[id^=\"fotbolltransfers_mpu\"], div[id^=\"fotbolltransfers_mobil\"])",".advertising, .sidebar .widget_text, .sidebar .widget_media_image, .has-post-thumbnail.category-okategoriserade",".cookie-popup, .overlay","div[id^=\"hallb-\"]",".headerannons, .sidebarannonsseg, .footerannons",".wt-cli-cookie-bar-container","gdpr-alert",".sponsored",".elementor-popup-modal","#kadDiv, div[style=\"margin:25px 0;max-width:255px!important;\"], #scrollAdj ~ *","td[width=\"305\"], br + a[href*=\"/casino\"]",".sidebar .widget_custom_html","a[target=\"_blank\"] img[alt]","main > div:first-child:has(.banniere)","article.grid:has(a[href=\"/creative-studio\"]),\narticle[data-type=\"native\"], .ag-product-wrapper, .product-carousel__container, .shop_carousel, .editorsPick, div[class^=\"strossle-widget-\"], .ad-min-height, a.cts-impression-item[data-cts-label*=\"banner\"], section[data-cts-label=\"affiliate-carousel\"], .ad-row-column","div[style=\"height: 120px;\"]:not([id]):not([class])",".insider-ads, [id^=\"mainadvertorial\"], [id^=\"dfptag\"], .block-advertorial, .block-views-blockconventus-info-articles-info-article-block, #dfp-tag-before_artikel, #dfp-tag-mobile_before_artikel, #block-views-block-leader-article",".ad",".et_bloom .et_bloom_flyin_center, a[href*=\"/?utm_medium=affiliate\"], a.bigblue[target]",".inline-share-buttons","#wsfb-container, .share-buttons, .ad-space, div[id^=\"ad-\"],\n.ssp_divider:has(.sponsored-bar)",".washer",".stream-item","#top-wrapper",".leaderboard",".sidead_border",".cookieScript","[class^=\"ad-\"]",".partners-box, .cube-bonus-list, .section-featured-links-column, .section-bonus-list, a[href=\"https://sportbloggare.com/casino-bonus\"], a[href=\"https://sportbloggare.com/bettingsidor\"], a[href=\"https://sportbloggare.com/betting-bonus\"],\n.section-body-plus .body-block:has(a[href*=\"betting\"])",".pubhead, #bannermobile",".h-36:has(iframe[srcdoc*=\"ad_div\"]),\n.puff__ad-heading, ad-skyscraper__wrapper, iframe[title*=\"Bet 365\"], iframe[srcdoc*=\"ad_div\"],\n:is(.min-h-80, .w-64.absolute):has(div[id^=\"svenskafans_\"]),\n:is(.min-h-\\[400px\\], .min-h-96, .hidden.min-h-60):has(.ad-slot)","#prisjakt-popular, .ad:not(.adPanorama), .adForumSticker, .dark-mode__sponsor",".ads",".article.related > a[href*=\"&utm\"][target=\"_blank\"],\n.popup-overlay",".right","#cookieNotification, .gad, div[style^=\"font-size:11px; margin-left\"], div[style^=\"font-size:11px; margin-left\"] + div[style]",".stopjump","#load",".annons-block,\n.g1-mosaic-item:has(.category-annonssamarbete)",".cookie-consent",".takeover-link","#cookies-eu-banner","div[style^=\"min-height\"]:has(.adsbygoogle)",".online-teaser--advertorial, .online-ad-container",".cookie",".square-item:has(.qz-quiz-sponsored)",".bannergroupno-padding","#tm-top-a",".bannergroup","a[href*=\"rocketpot.io\"], a[href*=\"casino\"], a[href*=\"betting\"], .a-wrap",".banner","[data-widget_type*=\"bnnrwidgets\"], a[href*=\"/annons/\"], div[data-widget_type=\"image.default\"] a[target=\"_blank\"], div[data-pid^=\"ad\"], .essb-mobile-sharebottom","article[data-section=\"allmänt\"], .flow_article[href*=\"/samarbete/\"]","#sticky_ad, div[style*=\"ad_hor.gif\"], a[href*=\"casino\"], a[href*=\"kasyno\"], a[href*=\"betting\"], a[href*=\"spelsajter.eu\"], a[href*=\"spelsidor.org\"], a[href*=\"oddsgurun.com\"], a[href*=\"betsidor\"], a[href*=\"välkomstbonusar\"]","[class*=\"feed-ad\"]",".annons","a[href*=\"/atl-tv-annons/\"], [class^=\"Ad_\"], div[class^=\"WidgetCTASticky\"], a[class^=\"CTA_ctaWrapperCampaignBase\"]","#didomi-host","[class^=\"newsletter-subscribe\"], div[class^=\"cookie-message\"], div[role=\"presentation\"]",".panoramaAnnons, .JobAdDiv, .annonsKolumn, .insideAd, .ingressAd, .familyAds, .annonsWrapper, #indexLinks","div[id^=\"dagensnamn_\"], .dagensnamn_nu_billboard_middle, a[href*=\"kohantering\"]","#rightbanners",".spons",".vkmui-Text--grey, [class^=\"adContainer\"], div[class^=\"bordersAndShadows\"] > div[style^=\"min-height\"]:only-child, div[data-track-id=\"family.Familjeannonser\"], div[class*=\"adElement\"], div[id*=\"_panorama\"], div[data-track-id*=\"panoramaAd\"], div[data-track-id$=\".native\"], div[data-track-id$=\".blockAd\"],\narticle div[style^=\"padding-bottom\"]:not([class]):has(div[data-tagid*=\"_panorama\"])","div[aria-label=\"Annonser\"]","[class*=\"annonser\"], #cboxOverlay, #cboxWrapper, a[href*=\"=banner\"][target]",".elementor-widget-text-editor:has(a[href*=\"casino\"])","#site-preloader",".rstbox",".advert",".isax, #cookiebar","a[href*=\"/track.adtraction.\"]",".td_mod_wrap a img[data-permalink], a[data-wpel-link=\"external\"][onclick], a.td-lazy-img[target], a[href*=\"casino\"]","#cookie-law-info-bar",".ui-widget-overlay, .ui-dialog",".panorama-sticky, .sticky-area, #ad-outofpage_dynamic, .desktop-only","#rb-cookie","ad-iris-sunt-ad-wrapper, ad-block, .native, ad-full-page-block, a[href^=\"/native\"], widget-family, widget-memorial, widget-marknadsguiden, widget-jobb-plus, a.puff-primary-link[href*=\"/erbjudande/\"], .ad-hidden, iris-puff-native, iris-subscribe-footer",".revive-box",".preloader",".outsider, .panel--naringsliv",".elementor-popup-modal:has(a[href=\"/integritetspolicy\"]),\nsection.dce-visibility-event:has(a[href*=\"casino\"])","[href*=\"casino\"][target]",".overlay-loader,\n:is(.et_pb_fullwidth_image, .et_pb_image) a:not([href^=\"/\"]):not([href*=\"pilsner.nu\"]), .mctb-position-bottom",".sponsor-list, .cookie-law-wrapper, .big-ad-placeholder, .affiliate-wrapper",".pjra-relative, .outsider-ads, div[class^=\"AdPlacementWrapper\"]",".cookie-info","#takeover","#adsblock, #adsblockfoot, .fpright, div[onclick*=\"window.open\"]",".cookie-box,\ntd[valign=\"middle\"] > a[target=\"_blank\"]",".u-bottomFixer",".samnytt-card:has(a[href*=\"jackpot\"], a[href*=\"casino\"][href*=\"bonus\"]),\n.sticky > div.fixed[class*=\"bg-opacity\"],\n.sticky > div:has(img[src^=\"/butik\"]),\na[href*=\"casino\"], a[target=\"_blank\"] img:not([class^=\"tweet-\"]), a img[src^=\"/butik\"], main > section + div + div img, div[class^=\"samnytt-widget\"] + .sticky img",".cookiePush, .stickyFollow, .sponsorGroup__item",".cookieAlert","#more-banners",".ad-container","a[onclick*=\"bannerClick\"], #linkus, .details-bet-banner",".et_pb_code_inner:has(.svm-target)","a[href*=\"casino\"]","#modal div[itemtype][itemscope] > div[class]:has(a[href*=\"doubleclick\"]),\na[href*=\"adform.net\"], .ad-fullscreenWallpaper__container",".bet365, .panorama-wrapper, .tvg-manager-box, .tv102945, .tv102987, #event_banner, .go-to-partner, .odds, #text-13","div[class*=\"odds_container\"], .sidebar a[target]",".image-post-link[target]",".skyad-wrapper",".popup-large, .popup-bottom, .square-banner-wrapper","div[id^=\"ads\"]","#top-banner-container, #top-banner-wrapper",".gorg-content-side .mt-3:has(a[href*=\"casino\"]),\n.gorgad","a[href*=\"&do=advertisement&ad=1\"]","#opab-modal, .opab-footer-offer","div[id^=\"sverigesNaturPopup\"]",".content-news:has(span[id*=\"Sponsored\"]),\n.page-panorama","[class*=\"top-ad-\"]","#bannerbox",".code-block:has(.shop-page-wp-grid),\n.featured-area, .awac-wrapper,\n.penci-single-block[data-current-url*=\"cbd\"]:has(a[href*=\"?ref=\"]),\n.standard-article:has(a[href*=\"/adtr.co\"], .post-entry > div[style^=\"background-color: #f5f5f5; font-size: 12px; padding: 10px;\"])",".field--name-field-ad-banner-image","#cookie-banner",".cookies","#onetrust-consent-sdk",".cookieconsent-optin-marketing","a[href^=\"/nyheter/native-artiklar/\"]","section.elementor-section:has(a[href=\"https://stodlinjen.se/\"][target=\"_blank\"]),\nsection.elementor-section:has(a[href=\"https://stodlinjen.se/\"][target=\"_blank\"]) + section.elementor-section",".cookies-wrap, .Modal, .article-list-item--native, .advert-notice-box, .native-popup, .takeover-wrap, .native-notice-box, .darwin--content,\narticle.article-list-item:has(a[href*=\"/native/\"])","#superright-side, a[href*=\"/casinoguide\"], [id^=\"adPlacement\"], a[href^=\"https://kampanj.\"], a[href*=\"/rabattkod\"][data-test-tag=\"internal-link\"], a[href^=\"/sportbladet/speltips/\"], a[href*=\"aftonbladet.se/kampanj/\"], #takeover-container, div[class^=\"stickylogin\"],\n:is(main > section > div[class^=\"hyperion\"], #main > section > div[class^=\"hyperion\"]):has(a[href*=\"/brandstudio\"], a[href*=\"/brand-studio\"], a[href*=\"/rabattkod/\"], a[href*=\"/casinoguide/\"], iframe[src*=\"compricer\"]),\narticle[class^=\"article-wrapper\"] ~ div[class^=\"hyperion\"]:has(a[href*=\"/t?a=\"], a[href*=\"/click\"], a[href^=\"http\"][nofollow], a[href^=\"http\"][rel*=\"nofollow\"]),\naside > div[class^=\"hyperion\"]:has(a[href*=\"/rabattkod\"], a[href*=\"/kampanj\"], a[href*=\"/brandstudio\"], a[href*=\"/brand-studio\"]),\nsection[class*=\"layout-main\"] > div[class^=\"hyperion-css\"]:has(a[href*=\"/produkt/\"]:not(a[href^=\"/\"]), a[href*=\"/varumarken/\"]:not(a[href^=\"/\"]), a[href*=\"/prisjakt.nu\"])","[data-test-tag=\"prisjakt-carousel\"], a[href*=\"/brandstudio\"], a[href*=\"/brand-studio\"], div[class^=\"advertory-\"]:not(.advertory-header-anchor),\ndiv[style*=\"min-height:240px\"]:has(iframe[src*=\"/widgets/ads/\"])",".dp--mb",".banners",".partnerCard, .partnerContent, .entry-content figure.wp-block-image, .category-partner, .ams-playad-injected",".article-list-item--native, a.article-topic__list-item[href^=\"/annons\"]",".native","a[href^=\"/annons/\"], a[href^=\"/native/\"], .slot-module, .slot-articlemodule, #__next > div > div > div > div:empty, section > div:empty, article > div > div > div:empty",".front-slider-reklamsamarbete, .category-gastkronika-reklamsamarbete, .front-top-reklamsamarbete",".td-a-rec","div[id^=\"aleku-\"], #carouselVideoAd, #carouselVideoAdMobile, .native-bg, .casino",".collapse.row.jobb.annonslista, #sponsored, #banners-right, .mittenbanner, #banners-top, #banners-bottom","#af-preloader",".c-ad__panorama, .c-ad__insider, #outsiderTop, div[data-k5a-pos^=\"panorama\"]",".mat-card:has(.ad-word),\napp-ads","div[id^=\"ad-\"]",".topbanner-wrapper,\ndiv[style^=\"text-align:center;min-height\"]:has(div[id^=\"adwrapper\"])",".gt-loader",".gda, .cookie-notification, .iy.first","a[href*=\"track.adform\"]","#partnerMenuContainer, #partnerMenuContainerFiller,\n.spons-artc, a[href^=\"/native/\"]",".bg-native,\nmain > div:not([id]):not([class]):has(a[href$=\"nyhetsbrevet\"])",".newscolumn:has(a[href$=\"/sponsrat/\"])","#zox-lead-top-wrap,\n:is(.p-list, div[class*=\"post-\"]):has(a[href*=\"/annons\"])",".sek-module-inner a[target=\"_blank\"],\n:is(article.category-gastinlagg, .widget_recent_entries li):has(a[href*=\"spelbolag\"], a[href*=\"casino\"], a[href*=\"-betta\"], a[href*=\"betting\"])","#banner-holder","#cc--main, div[class*=\"dfp-ads-container\"]",".allto-widget, .allto-before-content, .allto-after-content, article[class*=\"sponsrad\"]",".bannersRight","#toast-container","a[href^=\"/sponsrade\"]","#cookiebanner","article:has(a[href*=\"/sponsrad\"])",".Container:not(.ContentItem-content):has([data-controller=\"ad\"]),\n.Teaser--native, .o-native, [data-controller=\"ad\"], div[id^=\"consent-\"]",".nl_popup",".metaslider",".ContentItemList-item:has(.Teaser--nativeAd),\ndiv[data-native-ad-position]:has(.Ad),\ndiv[id^=\"consent-\"]",".Ad","[class*=\"panorama\"],\narticle:has(.Entry-sponsored)","[data-testid=\"ad-area\"], footer + div.shadow-lg.fixed","#annons",".top-add",".a-wrap","#main > .col-links,\n.sidebar_content:has(a[href*=\"casino\"])",".card:has(.adsbygoogle)",".newsletter-popup",".elementor-widget[data-settings*=\"sticky_\"], div[id^=\"babyhjalp_panorama\"], div[id^=\"babyhjalp_mobil\"], div[id^=\"stagi\"]","[id^=\"google_ad\"]","#cookiescript_injected_wrapper",".featured-teaser:has(a[onclick*=\"adClick\"]),\n.newsletter, a[onclick*=\"adClick\"], .gpt-slot",".cookie-notice",".puffLine, .d-flex > div[style*=\"min-height\"], div[style=\"overflow-x: hidden;background-color:rgb(250,250,250);width:320px;min-height:200px;\"], div[style=\"overflow-x: hidden;background-color:rgb(250,250,250);width:320px;min-height:320px;\"]",".elementor-element[data-widget_type=\"image.default\"], .aeywhae-single,\narticle.elementor-post:has(a[href*=\"casino\"], a[href*=\"bonus\"], a[href*=\"betting\"], a[href*=\"/noje/\"])","#top-banner-mobile, .apd-text, .apds_main, .entry-priomaker, [class^=\"dls-\"], .csmi","#top-banner",".pum-overlay",".cookie-consent-wrapper, #takeover-outer",".ann-puff, .headerLinks, .cookiesInfo","a[href*=\"sponsrat-innehall\"], div[class$=\"-promotion\"]","aside.section-sm",".bettips-am","#cookie-bar",".post-block-style:has(a[href*=\"/annons\"])",".annonser","#header-image, #block-2",".includingFeaturedSliderArticle:has(.native-mark),\nfl-gdpr, fl-panorama-top, fl-newsletter-popup, fl-ad, div[id^=\"takeover\"]",".d-print-none > div:has(a[target=\"_blank\"])","#cookieinfo,\n.flowad, .nativepuff",".datax",".carouselbanner-wrp",".placement_panorama, .blocket-placement, div[style=\"height: 240px;\"], [class*=\"offering-info-box\"], [data-id=\"placement_panorama\"], div[class*=\"BannerLink\"]",".ReactModalPortal:has(a[href=\"/articles/cookies\"]),\na:not([href*=\"bokadirekt.se\"]):not([href^=\"/\"]) img",".cookie-law",".elementor-section:has(.sponsor, .elementor-post.category-sponsrat),\n[id^=\"boktu-\"]",".article-top-advt","#outer",".meta-info-container:has(a[title*=\"Sponsrad artikel\"])",".main > div[class^=\"jsx-\"]:last-of-type:has(img[src*=\"borskollen_appen\"]),\n.outer:has(img[src$=\"ad_label.png\"]),\n.wrapper > div[class^=\"jsx-\"] > .outer:has(a[href*=\"casino\"]),\n[id^=\"borskollen_small\"], [id^=\"borskollen_large\"], .featured-link, .app-store-box, #borskollen_desktop-side, #borskollen_desktop-panorama, div[id^=\"borskollen_mobile-detaljsida\"]","div[data-widget_type=\"image.default\"] a:not([href^=\"/\"], [href*=\"bostadsrattsnytt.se\"]) img",".banner-image, .bvads-container, .a-full-width, .ads-container,\n.blog-article-card:has(.sponsor-mark)","#header-banner, #cboxOverlay, #colorbox, .adv-inner, #sidebar-banner,\n.rlt-top-pro:has(a[href*=\"casino\"])",".popup-signup, .takeover","div[id^=\"brans-\"], .widget-sponsored-post",".container:has(a[href*=\"casino\"]),\n[class*=\"sponsored\"], #watcherPop, .modal-backdrop","[class*=\"sponsored\"], [class*=\"Sponsored\"], [class*=\"LivepodPuff\"], .videoAd, .js-video-ad, [class*=\"AdkContainer\"], div[class^=\"LivewrappedContainer_root\"],\nsection[class*=\"Article_layout\"]:has(section[class*=\"Sponsored\"])",".bt-article:has(a[href*=\"/annons/\"])","#page > div:not(.left):not(.right),\n#titlebanner","a[target=\"_blank\"]:not([href^=\"/\"], [href*=\"butiksnytt.se\"]), #tdi_57","a[target=\"_blank\"] picture, div[data-settings*=\"sticky\"], div[id^=\"butik-\"]",".block-ad, a[href^=\"/partner/\"], .threadMatchedContent, #svartalistan-login-required-overlay",".pop_box",".code-block:has(.adsbygoogle),\n.protect_contents-overlay, .ai_widget","[class^=\"siteAds\"], .siteAlerts, #gan-popup","#text-2.widget_text, .header-widget-area",".post:has(a[href*=\"/annons/\"]),\na[href*=\"/annons/\"], .newsletter-popup-content-overlay, .ai-viewports","#newsletterPopup,\narticle:has(a[href*=\"/partner/\"])",".ads-above-header, .ads-teaser, .paragraph--type--ad-script, div[about*=\"/annons/\"], a[href*=\"/sv/annons\"]",".banner_window, .banner_label, .card_veckans_pryl, .bg_camping_se",".highlighted:has(.advertisement)",".advertisement",".header-ads-wrapper, .ai-adb-hide, .ai-sticky-widget, .hampaonline","div[id^=\"canna-\"]","div[id^=\"carup-\"]",".cookie-banner, .desktopbanner,\n.recent-post-item:has(a[href=\"#\"]:not(.w-condition-invisible))",".Cookie-notice, .Product-modal, .Offer-popup, .Toaster",".Blurb--native","[id^=\"block-views-ad\"], .modal-container","#text-6, .theiaStickySidebar .category-uncategorized,\n.ajax_loader",".adsense-main","div[adunit]",".latest-content__card-secondary:has(.nativo),\n.nativo","#loftloader-wrapper",".sticky-sidebar, #gdpr-container, .slick-carousel",":is(article.tg-item, .lcp_catlist li):has(a[href*=\"/annons\"])",".featured-post--sponsored, .grid-item--sponsored, #advert-once-banner-fullskarm",".Advert",".video-annons, .native-box, .arcad-block-container",".item:has(.prebid, div[data-ad-unit-id], a[href*=\"casino\"])",".popup","#moove_gdpr_cookie_info_bar",".outher-sidebar, a[href*=\"/annons/\"], .dj-inline-ad, .sticky","div.g",".container:has(.dagensps_ad)",".infinite-scroll-component > .container:has(a[href*=\"/ut.dagensps.se/\"], .grid:empty),\n.postbox:has(.sponsored_post),\n.text-sm:has(a[href*=\"casino\"]),\na[href*=\"-partner/\"], .ad-links-module, .dagensps_ad, a[href*=\"ut.dagensps.se\"][target], .bottom_banner, .leftsidebanner, .c-external-notice,\ndiv.justify-center:has(div[id*=\"_pano\"], div[id*=\"_tws\"], div[id*=\"_mobil\"]),\ndiv[class^=\"bg-\"]:has(a[href=\"/ps-partner\"])",".banner-desk, .banner-mob,\n:is(.sticky.-top-4, .container > div[class=\"\"]):has(a[href*=\".se/ads/\"])",".banner-area","#dr-preloader,\n.header-top__wrapp, .article-item__banner,\n:is(.slick-slide, .article-item__line-bottom):has(.sponsored-badge)",".cookies-popup",".ai-rotate, .two-ads-wide-container",".rightcol",".topdiv",".cc-cookies",".sv-marketplace-sitevision-cookie-consent, .sv-cookie-consent-modal, .env-modal-dialog__backdrop, .env-modal-dialog__backdrop--in","#ads","a[href*=\"?aktion=bannerclick\"]",".td-big-grid-post:has(a[href*=\"/samarbete/\"]),\n.td_module_wrap:has(a[href*=\"/annons/\"]),\ndiv[id^=\"dator-\"]",".cky-consent-container","[id^=\"ads300\"], [id^=\"linkcat-\"]","#fancybox-wrap, div[id^=\"densi-\"],\nfooter .x-bar:has(div[id^=\"densi-\"])",".fp_banners, .cypress-popup_newsletter,\n.post-box:has(.sponsored)",".banner-hidden, .z-newsletter-modal, .z-newsletter-popup","div[class^=\"ad_\"], a[href*=\"annons\"], a[href*=\"spel\"], a[href*=\"casino\"], a[href*=\"kasino\"], a[href*=\"extrapengar\"], a[href*=\"investera\"], a[href*=\"boka\"], a[href*=\"strategier\"], a[href*=\"buda-\"]","div[style*=\"height: 244px;\"]",".di_panorama-wrapper, .site-header__panorama, .di_panorama__isAdLabel, .discount-box, .campaign-ad-box, .di_start__teaser-placeholder, .di_teaser-flak-planbokskoll, .di_teaser-flak-container--native, .native-box, .bandit-box__teaser--native, a[href*=\"/brandstudio\"], .service-box, .brand-studio-box, .native-article, .listing-box-native,\n.market-start-top + div:not(.market-container__wrapper)",".teaser-native",".bn_advertisement__panorama, .bn_advertisement__container",".scroll-message, .gallery-banner, .horseshoe, [data-ad-type], .bcm-banner, .default-banner-size,\n.standard.mobile-rows:has(a[data-ad-domain]),\n.teaser:has(.teaser__cat--sponsorlabel)",".top-header:has(.adsbygoogle)","article.category-leverantorer, div[style^=\"[banner-style]\"],\np[style=\"text-align: center;\"]:has(a[target] > img)",".contain:has(a[target=\"_blank\"])","#sponsored-posts, #right-banners, .banner-wrapper, .top-banner-label, .banner-label,\n.post:has(.label-sponsored)",".ai-track",".article--native, .teaser-card--native, .ds-teaser--native, #dnse-popup,\n.campaign-holder",".doon-promotion, a.link[target=\"_blank\"]",".sponsored_content",".target-banner, div[data-type=\"BANNER\"]","#g-preloader",".commercial-row, .aside-image-with-link, .post-container-sponsored, aside a[href*=\"/branschnyheter/\"], .e-loop-nothing-found-message",":is(li, article):has([href*=\"/sponsradeartiklar/\"])",".textwidget a[target*=\"blank\"] img","#lblock-ads,\n.td-fix-index:has(a[href*=\"casino\"])",".container:has(.ad)",".content aside.column-narrow:last-of-type","#cookie_wrapper, a[href*=\"medlem\"] > div, .ryk-top,\n:is(div.Block, div[style^=\"display: table\"], h1[itemprop=\"name\"] ~ div:not([style=\"display:none;\"]):not([class^=\"content\"][class$=\"content\"])):has(a[href*=\"medlem\"], [onclick*=\"medlem\"], .adsbygoogle)",".iframe-section-container:has(iframe[src*=\"bannerflow\"]),\n.linked-image-section:has(a[target=\"_blank\"]),\n.rmss_ap-top-ad + .rmss_t-ap-grid-stripe:has(a[href*=\"svenskaspel\"]),\n.rmss_module-sponsors, .rmss_ap-top-ad, .rmss_ad-panorama, .rmss_t-momenu__sponsors-area, a[target][href*=\"svenskaspel\"], .sponsor-img",".cc_banner-wrapper",".bg-sponsor","#main > #home_start_div ~ .m_t.box:nth-last-child(-1n+2),\n#sticky-panorama-container, #mob-wrap",".advertisement--item",":is(.grid.place-items-center, div[style^=\"height\"].items-center):has(div[id*=\"LeaderBoard\"], div[id*=\"Leaderboard\"]),\narticle:has(#marketing),\ndiv.rounded-4xl:has(a[href$=\"/firma#marketing\"])",".e-banner",".wpb_wrapper > .vc_row_inner:has(script[data-bid])","#ew-cookiebar-full, #ew-cookiebar-manage",".fixed.bottom-0, a[target=\"_blank\"][href*=\"utm_campaign\"]","a[href*=\"utm_campaign\"]","#text-2","#preloader",".penci-block-vc:has([href*=\"casino\"]),\ndiv[id^=\"espre-\"], .category-native",".penci-wrap-gprd-law","[data-controller=\"ad-container\"], .bg-gradient-white",".mvp-side-widget a[_blank\\\"]",".banneritem",".textwidget:has(a[target=\"_blank\"])",".view-multiply-top, .frontpage-multiply-main, .right-column-multiply-container","#secondary > .widget:nth-child(2)",".partnerartikel, #sidebar-ads-right, #nyhetsbrev-pp-wrapper__container,\n.post-teaser:has(a[href$=\"/annons/\"])","#panorama",".cc-window",".cc-container, [data-gabnr], #carpet",".bnr","section[data-ha-element-link*=\"kampanj\"], .elementor-element-686a3aa6, .elementor-popup-modal",".link:has(a[href*=\"bannerid=\"]),\n.wm-nopop, #main > p[style^=\"color\"], #slidebox",".ad-image, .bottom-popup, .conversion",".campaign,\n.html-widget > div[style^=\"text-align: center; font-size: 10px;\"],\n.html-widget[data-vendor]:has(script[data-vendor]),\n.teaser:has(a[href*=\"/annons\"], a[href*=\"/brandstudio\"], a[href*=\"/brand-studio\"], a[href*=\"/kampanj.\"], a[href*=\"/lanapengar.\"], a[href*=\"/rabattkoder.\"], a[href*=\"/spel.expressen.se\"], .vignette--svg + a[href*=\"teknikensvarld.\"], .teaser__bottom--ad-marker),\na[href*=\"/spel.exp\"], a[href*=\"/lanapengar.exp\"], a[href*=\"/rabattkoder.exp\"], a[href*=\"/annons\"], .match-betting, .discount-ad, .b-ad__caption, .pressrelease-teaser, .widget-ad-marker, .widget-ad-marker + a, .promotion-banner, .widget--collaboration, .rotator--external, a[data-click-track*=\"prisjakt\"], .linked-image-widget a[href*=\"/kampanj/\"], .linked-image-widget a[href*=\"lifestyle.expressen.se\"], #premiumAdWrapper, .tapet-popup-overlay, .outsider-ads, .teaser > a[href*=\"/kampanj.\"], .teaser > a[href*=\"/brandstudio\"], .teaser > a[href*=\"/brand-studio\"], figure[data-article-data*=\"/sponsrat\"], figure[data-article-data*=\"/annons\"], figure[data-article-data*=\"/brand-studio\"], .teaser--native, .native-article, .branded-content","[class^=\"BauProvider\"]",".sm-text:has(.adsbygoogle)","#cookieNotice","a[href*=\"/kampanj/\"], .flm-kampanj",".cookies-wrapper",".featured-article:has(.badge-partner-text),\na[href*=\"/banner/out/\"], .bnr_box, div[class^=\"panel\"][style*=\"lightgoldenrodyellow\"]",".adspace, a[class*=\"annons\"]",".burt-unit, .art_ad, adline, f-panorama, f-deals, #rpPopular, #maxetiseFull, #outsider, [data-ad=\"true\"], f-internallink[adid],\nf-internallink:has(a[href=\"#\"])",".node-news:has(a[href*=\"casino\"]),\na[title*=\"Casino\"], #top-content","a[href*=\"/sponsra\"], #partners,\narticle:has(a[href*=\"betting\"], a[href*=\"casino\"], a[href*=\"kasino\"], a[href*=\"/gastskribent/\"])",".jnews-cookie-law-policy, a[href*=\"casino\"], .custom-html-widget a[target=\"_blank\"]",".widget_text:has(a[href*=\"casino\"])","#topslider-wrapper + .container > .sidebar, .sidebar a[target=\"_blank\"], .sidebar a[href*=\"casino\"], .sidebar a[href*=\"betting\"], .sidebar a[href*=\"automater\"],\n.news:has(a[href*=\"casino\"], a[href*=\"free-spins\"]),\n.row.news > div[style^=\"border\"]:last-of-type",".cooperation-banner__container, .takeover-desktop, .takeover-mobile, #discover-banner",".banner-wrapper, .col-banner","#leader-wrap, #rpwe_widget-2, .side-widget .textwidget","#cookie-consent-banner,\n#penthouse-ads","#page-section-2, #page-section-24, .add-special-banner, .g-single","#spopup,\n.thumbnail:has([data-revive-zoneid])","#scrollup",".boxOverContent--a, .otPlaceholder, .seoAdWrapper, .adsbackground-wrapper, .prematchOddsBonus__bonus, .prematchLink[target], .detailLeaderboardSkeleton","#PreHeader","#cookie",".fodertipset-org-banner","#CybotCookiebotDialog, #CybotCookiebotDialogBodyUnderlay","div[class^=\"MuiDialog-root\"]","#myModal, .adImage","#topBanner","article:has(.sponsored-text),\ndiv.article:has(a[href$=\"artiklar-i-samarbete\"]),\ndiv[id*=\"panorama\"], .panorama-pos","div[data-widget_type=\"image.default\"] a:not([href*=\"forexgruppen.se\"], [href^=\"/\"]), .widget_media_image a:not([href*=\"forexgruppen.se\"], [href^=\"/\"])",".env-modal-dialog--show, .env-modal-dialog__backdrop",".c-announcement:has(.c-label--sponsored),\n.site-partnevisment, .h-background--sponsored-light, .row .text-center img, a[href^=\"https://hubs.la\"], .c-partners, iframe[srcdoc*=\"_ad_div\"], .annons-text",".article-row:has(.h-background--sponsored),\n.c-featured-article:has(a[href*=\"/sponsrat\"])",".recent-articles:has(.collaboration-brand)",".cli-modal",".tingle-modal--visible",".ff_sponsored_articles, .widget_sow-image a[target=\"_blank\"], .ff_banners_widget_widget",".SMBoxContentBanner, a[data-gaevent*=\"action=bookmaker_odds\"], #ouibounce-modal, .SMGameAtomSingleGameOddsComponent",".brand, .desktop-ad-web, a[href*=\"telia.se/privat/tv/sport\"] img, .mobile-ad-web, .ad-banner,\n.notice:has(span[class$=\"sponsored\"])",".visit-advertiser-link",".fotbollsthlm-image-container:has(.fotbollsthlm-ad-link)",".footer-links, .fotbo-target",".subArticlesponsored, div[style=\"width:300px;float:right;\"], div[style=\"float:right;width:300px;\"], #partner-box, .adbox-label, .banner-panorama-wmn",".tn, .zooKeeper, #scraper, .subHeadSponsors","#siteflash, #customer-link-container",".takeover-container",".sidebar-front .widget_text.dark ~ p,\n.visible-xs:has(a[href*=\"casino\"]),\nimg[src*=\"/sponsor/\"] + br + .boxlogo, .sidebar-front .boxen",".sponsor",".anm1-container, [class^=\"anp\"], [class^=\"ans\"], .box.evergreen, #a-midscroll",".CookieBar",".elementor-location-header section.elementor-element:first-child","[id^=\"ad-\"]",".topp-banner, .annons-mark",".slot-container",".alert-success","div.modal-cacsp-backdrop, div.modal-cacsp-position","aside.widget:has(a[href*=\"casino\"])",".article-facebook,\n.card:has(.article-sponsored, a[href*=\"/sponsrat\"])",".article-overview__col:has(.gpt--loaded),\n.link-list:has(a[href*=\"casino\"]),\na[href*=\"/annonser/\"], a[href*=\"/sponsrat-\"], div[id^=\"cncpt-\"]",".cookie--wrapper","#cookielawwarning, #eventad, [id^=\"sky\"], [id^=\"ad_lead\"], a[rel=\"sponsored\"], .external_div_bigVideoAd, #mpu, #leftToLogo, .itsanad, div[class^=\"ad_Bumper\"], div[style=\"min-height: 600px; margin-bottom: 20px;\"], div[id^=\"ad_\"], div[class^=\"preAd_\"], div[class^=\"ad_smartphbig\"], .adMobileBig, div[class^=\"preMobileBig\"], .external_div_videoAd, .ad_mobilebigwrap,\n.rightbox:has(#grtvbelt_Sponsored)",".footer-widgets .widget_block li",".banner-component, .partners, .cookie-meddelande","[class^=\"adverts-\"]",".widget_media_image a:not(a[href*=\"globalbar.se\"], a[href^=\"/\"]) img","aside .textwidget a img",".godare-ad-element, a[href*=\"/brand-studio\"], a[href*=\"/brandstudio\"], .recipe-ad, a[href*=\"utm_campaign\"][data-test-tag=\"external-link\"]",".partner-area","#citadela-infobar",".c-partners__item","a[href*=\"/annonssamarbete/\"], .deals_block_wrapper, .ai-close-fit",".category-partners",".sgpb-popup-overlay, #sgpb-popup-dialog-main-div-wrapper, .et_pb_gallery","aside#secondary:has(.adsbygoogle)",".post:has(a[href*=\"casino\"], a[href*=\"kasino\"], a[href*=\"betting\"]),\na[href*=\"/click.\"], #block-2, #block-4","div.grid_container[style*=\"height:240px;\"]",".stream-item:has(.adsbygoogle)",".loader","section[aria-label=\"Kakinformation\"]","#seasonalTakeover, div[class*=\"sponsorBarContainer\"], div[class*=\"footerSponsors\"], .slick-slide a[target=\"_blank\"]",".hb-adlabel, [id^=\"hb-\"], .ad-placement-side, p > a[target=\"_blank\"]","div.text-center:has(div[ad-placement])","#__next > div > div.bar:first-child",".col-sm-4 > div[class]:has(a[href*=\"casino\"], a[target=\"_blank\"])",".add-wrap, .listings-search-ads, .right_panel, #pmg-widget-root,\ndiv[style*=\"--mobile-height\"]:has(div[id^=\"div-gpt\"])",".elementor-widget-container > a > img","[class*=\"partnerinfostyle\"], div[id^=\"hejao-\"], .kb-advanced-image-link[target], .category-partnerinformation, .kt-modal-linkalign-center, .hejao-target","#custom_html-15, .code-block img, .banner-promotions-wrapper,\n.latest-posts-grid:has(a[href*=\"/annons/\"])","[id*=\"banner\"], a[href^=\"https://ad.\"], a[href^=\"https://ad2.\"]","a[data-test-id^=\"top-banner-ad\"], div[data-test-id=\"exit-intent-banner\"], div[data-test-id=\"urgency-banner-modal\"]",".pageCookies, #ad-insider1, #ad-insider2, #ad-mobil-1, #ad-mobil-2, #ad-mobil-3, #ad, #ad1, #ad2, #adform-outstream, .ad__text, .entry__ad, .entry__related__sponsored, .module__sponsored",".post-item:has(.sponsor-summary)","#sa_slider_shortcode,\n.annonsnotis + span + span + div.td-pb-row:has(a[href*=\"adtr.co\"])","#ad_unit_placeholder, div[class^=\"Panorama_panoramaAd\"], .listing__panorama-banner, .broker-banner, div[class^=\"BrokerBanner\"], div[class^=\"PanoramaMobile\"],\n:is(article, li):has([class*=\"SponsoredLabel\"], .article-card__sponsored-text),\n:is(div[class^=\"Carousel\"], #top_listing):has(div[class^=\"PaidPlacementLabel\"]),\ndiv[data-testid=\"living-cost-logos-section\"]:has(span[aria-label=\"annons\"])",".article:has(.annons),\ndiv[id^=\"hj-\"], div[id^=\"ik-\"]",".billboard-style, .between-posts,\n.row[style*=\"height\"]:has(.adsbygoogle)","[class^=\"styleManual_mainContentBox\"] > div[style^=\"min-height\"]:first-of-type,\na[data-trackimp][target], .hitta-map .integration-txt, .section-details--alb, [class*=\"dummyAd\"], [class*=\"StyledAdSlot\"], [data-bind*=\"Ad\"], div[class^=\"GraphicAd_\"], [class*=\"adContainer\"], [id*=\"_panorama\"], [id*=\"_skyscraper\"], div[style=\"min-height: 250px;\"], div[data-track=\"displayplacering-customer\"], a[data-test=\"boostAdLink\"], div[class^=\"style_bannerContainer\"], [data-track=\"click-promotion-banner\"], div[class*=\"adWrapper\"]",".club-ad-item, .banner-row",".fixed.z-50:has(a[href=\"/plus\"]),\n.h-\\[152px\\]:has(iframe),\n.items-center:has(a[target=\"_blank\"]),\n:is(.sticky, .hidden.lg\\:block):has([id^=\"hockeynews_\"])",".Odds_Widget_Ad, div[class*=\"_panorama\"], .category-sponsrade, div[class*=\"_in_article\"], div[class*=\"desktop_sidebar\"], div[class*=\"mobile_square\"]",".custom-html-widget a[href]:not([href^=\"/\"]):not([href*=\"horisontmagasin.se\"]) img",".cookie_popup_box","#bannnerContainer, #pop_overlay, .banner-s, div.featured",".banner-box,\narticle:has(.sponsored-article)",".ui-top-adversite, #optin-cover, #optin",".article-native","div[id^=\"husbi-\"]","div[id^=\"husvagnochcamping-\"], .ast-below-header-bar",".col-md-4 .widget:has(a[href*=\"spelbonus\"]),\n:is(.article-list li, .post):has(a[href*=\"betting\"], a[href*=\"casino\"])","div[ng-controller=\"CookieConsentCtrl\"],\ndiv[ng-show*=\"isUiDisabled\"]",".banner-center, .banner-center ~ br, div[class^=\"ad-container\"],\n.flow_teaser:has(a[href*=\"casino\"], a[href*=\"poker\"], a[href*=\"cbd-olja\"])","div[class^=\"ads\"]","#pnlCookie, .campaign-top, .campaigns-right",".advert-take-over","div[id^=\"inkop-\"]","[class*=\"banner-container\"], .sponsorsswipeblock","[itemtype=\"https://schema.org/WPAdBlock\"]",".overlay","#newsletter-sliding",".tag-sponsrad","a[onclick^=\"gtag\"], .header-banner, .penci-featured-cat-custom-ads","#astroid-preloader,\n#redim-cookiehint-modal",".activate-notifications-container.shown, .newsletter-popup-content-overlay, [class*=\"ai-viewport\"],\n.post:has(.post__category--sponsored)","div.cookie-warning-container, .mb-adarea",".jaktplay-ad",".jet-popup",".o-blockCarousel--placementAd, .o-blockArea__item--block-ad, .m-blockAd",".day-nav ~ a:not([href*=\"kalender.se\"]), a:not([href*=\"kalender.se\"]) img, div[style^=\"height:340px\"], div[style^=\"height:110px\"]",".markupbox:has(a[href*=\"casino\"]),\na[href*=\"/partner\"],\narticle:has(a[href*=\"/partner\"])","#custom_html-2","a[target][onclick], #cliSettingsPopup",".forumlist-main-inner > div[style]","a[href*=\"casino\"], a[href*=\"kasino\"]",".post:not([data-elementor-type=\"single-post\"]):has(div[class$=\"annonser\"]),\na[href*=\"unibet.com\"], a[href*=\"/kampanjer.\"], a[href*=\"utm_campaign\"], div[class^=\"yw-\"], a[data-wpel-link=\"external\"][target=\"_blank\"]",".card-partner, .partner","div#video-overlay, div.sidebar_frame, #affiliates, #affiliates + .text, #popup-interstitial-overlay, .cu_banner, #interstitial-overlay, .kingsize-native","#header-top, div[data-hook=\"consent-banner-root\"]","#overlay, a[rel*=\"sponsored\"], .-panorama-ad-wrapper,\ndiv[id^=\"sp_message_container\"]","div[class^=\"ad-\"]",".tm-cookie-banner","#cookie-popup","#footer #block-7,\n.post:has(a[href*=\"casino\"])",".CookieConsent",".ads-wrapper-main, .InterstitialModal","[class*=\"list_item_sponsored\"], [class*=\"promotion_bottom_holder_wrapper\"], [class*=\"beverage-recommendation_wrapper\"], [class*=\"list_item_wide_sponsored\"], [class^=\"ad_position\"],\ndiv[class*=\"mosaic_item_wrapper\"]:has(div[class*=\"sponsorLabel\"])",".block--gamw",".site-loader",".gdpr-wide",".pricerunner","div[id^=\"adv\"], #site-right-col-wrapper a[target] img","div.recad, div.adhor, div.stickyad","a[href*=\"/annonsering\"]",".CookiePopup",".pc-das, [data-ad-type],\n.post-card:has(a[href*=\"ad=native\"])","#subscribe_splash, [class*=\"nativeadwidget\"], .partnermedia, .annonswidget",".email-popup-wrapper,\n.square-format:has(.kv-ad-label)","#panoramaTop, .facebook",".screen-sm, .screen-md",".inpostbanner, .banner-leaderboard",".single-entry__ads","#startpage-top-right, .ads_text + a, div[class*=\"square_rotate\"], a[target=\"_blank\"][rel=\"nofollow\"], #ouibounce-modal, iframe[src*=\"iframebanner\"], .widget_maskinstationer_widget,\narticle:has(.ads_text),\naside.enhanced-text-widget:has(div[class^=\"square_rotate\"]),\naside.side-box:has(.adsbygoogle)","img[alt=\"Annons\"] + .img-flipper","[class^=\"CookiesModal\"]",".modal-wrapper, div#beskrivning[style=\"font-size: 10px; text-align: center; color: #8E8C8C; max-width: 700px;\"]","#partners_inside, #partners_right, #partners_top",".footer-newsletter",".e-loop-item:has(div[data-eael-wrapper-link*=\"annonssamarbete\"]),\n.elementor-image > a:not([href*=\"https://lesscarbs.se\"]), a[href*=\"/affiliates/\"], div[id^=\"1\"][style*=\"250px\"],\narticle:has(a[href*=\"/annonssamarbete/\"])","#bookingcom-resor-wrapper, #aktuellaerbjudanden, #sky-left-wide, .topNavItem[href*=\"casino\"], .topNavItem[href*=\"betting\"], #bottom-splinks, #momondoBoxRightCol","div[class^=\"CookieBar\"]",".moban","a[href*=\"/bit.ly/\"]","div[class*=\"ad_container\"], div[class*=\"_ads_\"]","#cookies-accept",".ct-link[target=\"_blank\"], a[href*=\"casino\"], a[href*=\"spellicens\"]","#ss-floating-bar, .top-ads-widget, .header-inner center, #sidebar-right .widget_custom_html,\narticle:has(a[href*=\"/annons/\"])","#pageContainer > div:first-child:not([id]), #topContainer a:not([href=\"/\"], a[href=\"/sitesearch\"])","#text-3",".penci-rlt-popup","#CookieConsent","a[href*=\"campaign\"][data-test-tag=\"external-link\"], div[data-ad-subtype],\narticle + div[class^=\"hyperion\"]:has(iframe[src*=\"tize.no\"]),\narticle:has(.ad)","#MoreLink_fade-out-div,\n.adremark, .coofad, .popup-overlay, .hidead, .phoneads, .pricecomp, .offerz, .type-articleadvertorial, .adblock, .lbplussinfo, .popup-overlayx, a[href*=\"/advertorial\"], a[href*=\"/advertorial\"] + .textbox, .prisjakt, #stickleft, #stickright, .adbox, .mainbanner,\ndiv[class^=\"col-md\"][style*=\"border-radius\"]:has(a[href*=\"/advertorial\"])","section.widget_media_image, a[target=\"_blank\"]:not([href*=\"ljungbysporten.se\"])",".applicant-match-container, .banner-item",".banner-container",".panoramaImageBox","div.has-post-thumbnail.category-extramaterial:has(a[href*=\"laneformed\"], a[href*=\"casino\"])",".entry__teaser--promotion, .wpcnt, .sunt-widget, .lifeofsvea-widget",".elementor-image a[href]:not([href*=\"lovelylife.se\"]) img","#bdCheckAlso.bdCheckAlsoShow, .topBanner, #sidebar .widget_media_image","#annonsPelareMobil","#archiveAdContainer, .casino-wrapper","#large_banner",".cWidgetContainer > ul > li:first-child, div[style*=\"border: 1px solid\"] a[target=\"_blank\"], div[data-role=\"sidebarAd\"], a[href*=\"&ad=\"]",".hustle-popup, div[class$=\"-sponsrat\"],\n.td_module_wrap:has(div[class$=\"-sponsrat\"]),\narticle:has(.sponsored-inlist),\ndiv[data-td-block-uid]:has(a[href*=\"/kategori/sponsra\"])",".mh-sidebar, .mh-header-columns",".banner_hoger, .google_ads_mg_frontpage, .footerComercialDiv","div[id^=\"marke-\"]",".td-cpt-post:has(a[href*=\"/annons/\"])",".elementor-column:has(.ekit-sticky),\nsection.elementor-inner-section:has(.adsbygoogle)","[id^=\"matin-\"]","#sidebar .widget_text","div[id^=\"matma-\"]","#kd-preloader","div[style=\"z-index: 2000;\"], div[style=\"z-index: 2000;\"] + div",".annonsmellandiv, .annonssidadiv","[data-article-sponsored=\"true\"], .content-main-adwrapper, .campaign-sidebar","#page_preloader","article[data-customer]",".advInsideSticky,\nul.wp-block-post-template:has(a[href*=\"/kategori/partner/\"])",".b-topshop,\n:is(.b-card, .b-related__item):has(.advert)",".bg-grey-light:has(a[target=\"_new\"])",".elementor-image a[target=\"_blank\"], .oc_cb_wrapper, .elementor-widget-image a[target=\"_blank\"]","[id^=\"Annons\"]",".comment:has(.nosnaj),\n.nosnaj",".profile-native",".desktop-homepage-ad, .desktop-main-ad, .latest-betting-campaigns, .best-casino-section, .top-casino",".front-banner, .front-banner-cover, #text-2, [class*=\"sponsrat-inlagg\"], a[href*=\"://kampanjer.\"], .ohmbet_link, a[href*=\"adsrv.eacdn.com\"], .jeg_postblock + .wpb_content_element, .spelbolag-text, .adbox, .fight-odds-aggressive,\n.img-featured-posts-image:has(a[href$=\"/annons/\"]),\n.tablepress:has(a[href*=\"expekt\"])",".modal-wrap, .slide-in-box",".true_native_block",".card:has(.sponsored),\n.sponsored-item, [class*=\"banner\"], .outsider",":is(article, li):has(a[href*=\"casino\"], a[href*=\"kasino\"])","#home_ans, [name=\"article-advertisment\"]","a[href^=\"/redirect-ad\"]","div[style^=\"max-width\"]:has(div[id^=\"ad-\"])","div[onimpression]",".Advertisement",".article-list__item:has(.bam-ad-slot, .article-list__item__box--sponsored),\n.article-list__item__link--sponsored, .ispanorama, #Popup, .ElementAdvertisement","div.lboard, div.instream-dynamic, #top-area-promo, div.sidebar div.sticky, .promo, .lboard-desktop, .lboard-mobile, #bottom-sticky-promo","div.container:has(a[href=\"/author/news55-partner/\"])",".sponsrad, .sponsradcol1, .newsv-widget",".list-item:has(.news-spot-medium__ad-title)",".secondary-sidebar > .panel-pane:last-child,\n.view-partner-articles, [class*=\"sponsored-article\"], .tertiary-bottom, div[class*=\"nojesguidenads\"]",":is(td[rowspan=\"2\"][align=\"left\"], table[width=\"640\"][cellpadding=\"7\"]):has(a[href*=\"casino\"])","#campaign_area",".pspy_info, [class^=\"prisjakt-\"],\n:is(.td-big-grid-post, .td_block_inner):has(a[href*=\"/sponsrat/\"])","#cookieWindow",".templateHelannonsBOX",".bannercontent",".third-col, article[class*=\"sponsrad\"], div[id^=\"nyd-\"], .below_header_front_page, div[data-aeon-news-trackbid=\"1\"], .aeon-news-widget, div[id^=\"aeon-news\"]",".breadtext_content.paywall_breadtext p:first-child::before,\n.lazyload_bar.show, .lazyload_outer.show, .sponsrat, .is_native, .sticky-scroll, .flow_ad",".article-list li:has(a[href*=\"kasino\"], a[href*=\"casino\"], a[href*=\"-slot-\"]),\n.teaser:has(a[href*=\"casino\"]),\n.widget.facebook, .content > div:not([class]) img, a[href*=\"www.casino\"], a[href=\"/karnkraft.php\"]",".site-branding a ~ p, .wp-block-jetpack-slideshow","div[style=\"display: flex; justify-content: center; flex-direction: column; align-items: center;\"]","div[class^=\"TopPanoramaAd\"], div[class^=\"StickySideAd\"], div[class*=\"_native\"], div[class^=\"Ad_placement\"], div[class*=\"PanoramaAd_\"]",".mailpoet_form, #secondary",".oc_cb_wrapper, .simple-image a:not([href^=\"/\"]):not([href*=\"ordfrontmagasin.se\"])",".visible-lg, .hidden-lg",".modal-cookieform","article.category-shoppingguide",".text-center:has(div[id^=\"padeldirekt\"])",".pfm-partners, .pff-partners, .c-widget-ad, .c-teaser--native, #toBanner","div[id*=\"ad_banner\"]","#nyhetsbrev-pp-wrapper__container, .partnerartikel, #secondary .textwidget a:not([href*=\"passioneffect.se\"]) img","#panoramaholder, #parallax, .cc-floating, a[href*=\"utm_medium=banner\"],\n:is(.intro, #hero, #featholder):has(.spons)","aside#below-header, aside.sidebar-right img, aside.sidebar-left img, aside#above-main, aside#after-first-post, h1 + .wp-block-video, h2 + .wp-block-image img[src$=\".gif\"]",".noMarginAd",".sidealtcol",".txs-a","aside a[href*=\"utm_campaign\"]","[class^=\"Banner\"]","div.adfit, .cookie_notice, div[style^=\"width:100%;max-width: 728px;\"] > div[align=\"center\"], div[style^=\"width:100%;max-width: 728px;\"] > br","a.gofollow[data-track]:not([href*=\"www.popularastronomi.se\"])",".site-background-banner","#omtag p[style^=\"margin-top\"]:not([class]):has(a[target=\"_blank\"]),\n.textmenyspalt:has(img[src^=\"bilder/annons\"])",".g1-popup-newsletter, .g1-slideup-wrap",".qxa-container",".landing-ad,\narticle + div.bg-white:has(.ad-inner)","#always-visible-banner-desktop-banner,\n:is(.md\\:min-h-\\[90px\\], .lg\\:min-h-\\[250px\\], .h-\\[250px\\], .justify-between.md\\:mx-10):has(div[id^=\"RAD_D\"], div[id^=\"RAD_M\"])","#original_taboola",".mobileHide, .mobile-show",".promo","#header > div > div.last, #block-4, #mvp-leader-wrap","div[class*=\"ad-wrapper\"], button#cookiePreferences, .c-modal-backdrop--active",".res-display",".adsbox-wrapper, .banner-xxl_panorama-container, .banner-top-container","#media_image-6, #block-81, #media_image-7",".banner-col, .alt-banner-col",".svrf__sticky-ad, .svrf-block__banner, .sv-cookie-consent-banner, .sp-banner-block, .sp-double-ad-block, .sp-head-sponsor-container, .sp-regular-sponsor-container, .sp-ad",".post-card-sponsored, .modal-plus, .modal-backdrop",".cookie-disclaimer-wrap, .type-promo, .sector-annons, .sticky-footer",".td-cpt-post:has(a[href*=\"/sponsra\"]),\n.tdm-popup-modal-wrap",".widget_cooperations, .dfrcs,\naside.widget_text_widget_startpage_only:has(a[href*=\"casino\"], a[href*=\"kasino\"], a[href*=\"betting\"])",".sv-cookie-consent-banner, .hiq-partners-banner",".schac-widget",".so-cookie__area",".fo-banner, .fp-banner",".rmss_module-block-linked_image, a[href*=\"svenskaspel.se\"]","a[href*=\"casino\"], a[href*=\"spelsajt\"], a[href*=\"betting\"]",".info_cookies","#main-sidebar .widget_media_image, #post-sidebar .widget_media_image, #content > .code-block","div[class^=\"baner\"], a[target=\"_blank\"] img","#cookie-manager","article:has(a[href^=\"/annons\"]),\np > a:not([href*=\"siljannews.se\"]):not([href^=\"/\"]) img","#app > div[data-reactroot] > div:first-child:has(a[target])","#text-41, #leader-wrapper, a[href^=\"/till/\"][target=\"_blank\"],\n:is(.sidebar-widget, .archive-list li):has(a[href*=\".se/odds/\"], a[href*=\"/betting/\"], a[href*=\"kasino\"], a[href*=\"/promomen/\"])","[id$=\"-ad\"]","#annonser","#newsletter-overlay, #newsletter-modal",".td-category-pos-:has(a[href*=\"casino\"]),\na.td_single_image_bg, span.td_single_image_bg[data-img-url*=\"Annons\"]","div[style=\"padding-top:0px;padding-right:0px;padding-bottom:0px;padding-left:0px;flex-basis:50%\"]:has(a:not([href*=\"skaneplus.se\"]):not([href^=\"/\"]) > img)",".sp-banner-block","#black-studio-tinymce-3, .menu-item a[target=\"_blank\"], .footer-widgets","#topbanner, #mittbanner, #topbannerm, #mittbannerm,\n.textwidget:has(.adtext),\narticle:has([title^=\"Annons\"], a[href*=\"/annons\"])","#tdi_51, .td-content-more-articles-box","#videoad","a[href*=\"/sponsra\"]","#cookie-button-banner, .campaigns, [id*=\"GlobalCampaigns\"]",".jobslider.up",".masthead, .col-right, a[href^=\"https://goo.gl/\"], a[href*=\"//bit.ly/\"], a[target=\"_blank\"][onclick], #ap1, .modal, .modal-backdrop",".article-short:has(a[href*=\"/sponsrat-innehall\"])",".region-sidebar-second",".sidebar","#modal-container, div[data-testid=\"advert-card-gam\"]",".ss-modal, .modal-mobile-app","div[itemtype=\"https://schema.org/WPAdBlock\"], .bs-wrap-gdpr-law",".article-list:has(.sponsrad-over),\n.block-rr,\n.link-list-item:has(img[src*=\"sponsrad\"])","a[target=\"_blank\"][onclick]",".secondaryContent:has(a:not([href^=\"/\"], [href*=\"spanienforum.se\"])),\na:not([href^=\"/\"], [href*=\"spanienforum.se\"]) img[src*=\"/media/\"]",".sidebar-right, .ad_header + p","#slideout",".mh-sidebar .textwidget,\ndiv.widget_text:has(a[href*=\"casino\"], a[href*=\"casivo\"])",".cookie-div, a[href$=\"/banner/\"]","#text-4",".header_top, #media_image-2, #text-6, article[class*=\"veckans-produkt\"]","div[style*=\"min-height\"]:has(div[id^=\"sportlovin_\"])",".textwidget:has(a[href*=\"casino\"])","#secondary:has(a[href*=\"casino\"])",".pnlAdTop",".banner-right, .banner-left, .wpb_single_image a[target=\"_blank\"], .tdm-popup-modal-wrap,\n:is(.latest-post, .td-cpt-post):has(a[href*=\"/sponsrat\"])","[class*=\"jsx-\"][style*=\"position: sticky\"], .bc--grey-neutral-50[style^=\"min-height\"], .ads-column",".premium-page-ad, .footer-banner-wrapper, div[id^=\"stopp-\"]","div[class^=\"Navigation__Overlay\"]",".premium-carousel-wrapper","div[class*=\"-promo\"], div[class*=\"prisjakt-\"]","#loader-wrapper","li.embedded, footer li.long","#mega-ad-wrapper, #svd-top-ad, div[class*=\"advertory\"], div[data-custom-ad-handled=\"true\"], span[data-id=\"bottom-sticker-offer\"], div[data-context-pageview*=\"native-svd\"],\narticle:has(div[class^=\"NativeBarWrapper\"])","#eprivacyModal, .modal-backdrop",".cookie-overlay, .cookie-box","#ajax-loading-screen",".widget_block:has(a[href*=\"/t/t?\"])",".image-block:has(a[class*=\"sponsor\"]),\ncustom-ad, sponsors",".Dialog[data-dialog-skip-auto-open-for-utm-source-value=\"Newsletter\"]",".news-multi-link--sponsor",".highlight:has(.partnerLabel)",".widget_et_ads, .module-etads, #text-13, #block-4, a[target=\"_blank\"][rel=\"noopener noreferrer\"], a > img[width=\"300\"][height=\"250\"], a > img[width=\"800\"][height=\"175\"], a[href*=\"casino\"], a[href*=\"poker\"], a[href*=\"kasino\"], a img[width=\"1000\"][height=\"300\"]","#survey-dialog","[data-ad-id], .darkenwrapper","#bannercolumn, img[title^=\"Annons\"]","app-exposure-small,\nsvv-short-news-widget:has(.native-news-link),\nsvv-wide-news-widget:has(.annons)",".article-item:has(.article-label--sponsored, .article-item--sponsored)",".cd-desktop-banner, .cd-mobile-banner, .cd-header-banner-wrapper",".wp-block-image a[target]",".puff:has(script[src*=\"lwadm.com\"], .pjSidebar),\ndiv[id$=\"_ad\"], div[id$=\"_ad_mobile\"], .externalTopMobile, #externalTopMobile, a[href*=\"prisjakt.nu/produkt\"], #nativendo-mainfeed + aside > .article, .article-footer > h3, .article-footer > .aeChart, #newExternal","[class*=\"-reklam\"], .sif-sponsorer, .teaserblock, .commonblock a:not([href^=\"/\"], [href*=\"/swehockey.se\"])",".thb-cookie-bar",".toppbanner-outer, .reklamplats_hspalt, .egenbanner","amp-user-notification.cookie",".create-account-banner, .buy-premium-banner, div[class*=\"pb-\"] > div.text-center","p[align=\"center\"]:has(.adsbygoogle),\nsection[id^=\"Panorama\"]","[class^=\"ad-container\"], [class^=\"adbox-single\"], div[id^=\"takeover-\"], .top-bar-container",".fancybox-container, #newsletterSubLink",".post:has(.sponsor)",":is(.vce-sticky, .vce-content-bottom):has(a[target])",":is(.article_widget_preview, .article_widget_listing):has(a[href*=\"casino\"], a[href*=\"kasino\"]),\n:is(.top-news, .big_article):has(img[src*=\"casino\"], img[src*=\"surfeo\"])",".elementor-widget-container:has(a[href*=\"casino\"])",".no-ad",".page-gutter.left, .page-gutter.right, [id^=\"bbPrisjakt\"]",".item:has(img[src*=\".se-www\"])",".md\\:mt-\\[100px\\]:has(script[data-adfscript])",".ez-sidebar-wall, a[href*=\"/partykungen\"]",".row-uppdragstest",".ad-container-section, .article-sponsored, div[data-hasbanner=\"yes\"], .thelocal-here-be-magic, #articleBody > .ml-manual-widget-container:empty",":is(.widget_media_image, .wp-block-image) a:not([href*=\"thepattayanews.se\"]),\na.td_single_image_bg:not([href*=\"thepattayanews.se\"]), #tnp-modal, .desktop-contents",".sidebar .widget_widget_code, .casino","div[style*=\"z-index: 999; background-color: rgba(0, 0, 0, 0.5)\"], .bg-grey.hideOnPrint, .bg-adYellow",".sv-marketplace-sitevision-cookie-consent, .sv-vr-popup, .env-modal-dialog, .env-modal-dialog__backdrop",".cookie-bar",".subscribe_now_popup, .type-native, #captive, .hldr_takeover_nl.show, .hldr_takeover",".cli-modal-backdrop","section.widget_text:has(div[id^=\"ad-\"])","div[id^=\"ad-block\"]","div.tot-content-preview-container-small[style*=\"border-top:4px solid #ffb200;\"], .content-overlay--black, a[href*=\"casino\"], a[href*=\"/sponsrat/\"], a[href*=\"/sponsrat/\"] + p.tot-content-preview--meta, .newaddiv, .tot-sidebar",".c-block-manager > .container:first-child:has(.gpt-ad-slot),\nfooter + div.fixed",".w-dyn-item:has(.sponsrad-artikel-wrapper:not(.w-condition-invisible)),\na[class*=\"annons\"], .annonser-sektion","[id^=\"bunyad\"]",".bottom-bar--animate-in, #job_ads_scroller, .header_banner",":is(.hidden, div[class=\"lg:hidden\"]):has(div[id^=\"travnet_\"])","a[href*=\"/sponsrat/\"]","div[class^=\"CookieDisclaimer\"]",".featured-post:has(a[href*=\"/category/reklam\"], a[href*=\"/category/annons\"]),\n.post_feed_post:has(.sponsor-info)","[class$=\"banner_ad\"]",".site-wrap > .row > .col-sm-3","#col_right","li[id^=\"infeed\"], div.presented-by",".maxetise",".frontpage_article:has(a[href*=\"casino\"], a[href*=\"kasino\"], a[href*=\"betting\"], img[data-cfsrc*=\"Sponsra\"])",".adbar",".middle-banner",".post-item:has(a[href*=\"casino\"], a[href*=\"-lan-\"], a[href*=\"kasino\"], a[href*=\"kredit\"])","div[id^=\"ungdo-\"]","div[id^=\"unive-\"]",".type-partnerartikel",".buy-items, div[style*=\"min-height\"]:has(#topbanner, script[data-pbid], [id^=\"nativendo\"], div[id^=\"upplysning_outstream\"])","#banner-top-block",".results li[style^=\"margin\"]:not(.result), .spahotels",".clamzone, .component-adzone","div[class^=\"ad-300x250\"], div[class^=\"ad_300x250\"]",".intro-popup",".latest-article-native",".carousel-slide:has(.sponsored-label),\napp-native-puff, .header-top-banners","div[style*=\"rgba(0, 0, 0, 0.5)\"]:has(div[onclick])","#nyhetsbrev","[id*=\"annons\"], #getFixed","div[class^=\"Popup\"], div[class^=\"CookieBanner\"]",".wpb_single_image a[target=\"_blank\"], .gp-footer-2",".row:has(a[href*=\"casino.se\"]),\narticle.column:has(a[data-k5a-url=\"/a/null\"]),\narticle[data-section=\"nativeannons\"]",".banner-spacer,\n.nyhet-ad, .vm-ad-wrap, .adtop__mobile","#westander-cookie-dialog, .Cookie-consent__backdrop","a[href^=\"/partnermaterial/\"]","br ~ a[target=\"_blank\"]","#rich-media-wrapper,\n.teaser:has(.teaser__native-marker),\ngen-article-wrapper:has(.article__header-native-banner)",".Internal-ad",".mtsnb, .villalivet-target, a[href*=\"/sponsrat-innehall/\"], div[data-td-block-uid=\"tdi_85\"], a[href*=\"utm_campaign\"][target=\"_blank\"], div[data-td-block-uid=\"tdi_87\"]",".wppsac-post-carousel:has(a[href*=\"/spons\"])",".annonsinlagg, .annonsen",".push-to-newsletter, .fancybox-overlay,\n.top-add, .sidebar-adds, .spons-content",".product_banner_wrapper",".popup_missa-inget",".topheaderinfo","a[href*=\"/go/\"][target], .category-kampanjer","div[class^=\"articles_articleBrief\"]:has(div[class*=\"articles_campaign\"])",".column:has(.adsbygoogle),\n.hero-body > .container > div[style^=\"min-height: 300px\"], .column:empty","#cookiescript_injected",".LFRBox","div[class^=\"overlay-color-cohort\"]:has(a[aria-label=\"Download the Yelp app\"])",".yweb-news-paper-banner",".featured","div[style^=\"position: fixed; left: 0px; top: 0px; width: 100%; height: 100%; z-index: 999;\"]","a[target=\"_blank\"]:not([href^=\"/\"]):not([href*=\"/macken.xyz\"])"];

const hostnamesMap = new Map([["alandsradio.ax",0],["riksettan.net",[0,81]],["klassiker.nu",[0,81]],["automobil.se",[0,81]],["caroftheyear.se",[0,81]],["endurobloggen.se",[0,81]],["mopedgaraget.se",[0,81]],["plastikoperationsforum.se",0],["so-rummet.se",[0,663]],["svjt.se",0],["vibilagare.se",[0,81,767]],["alandstidningen.ax",1],["bilwebben.ax",2],["handel.ax",3],["naringsliv.ax",4],["nyan.ax",[5,6,7]],["bytbil.com",[5,14]],["sverigesnatur.org",[5,141]],["alltforforaldrar.se",[5,174]],["di.se",[5,48,88,297,298]],["passioneffect.se",[5,600]],["tv24.se",[5,742]],["upphandling24.se",[5,750]],["golfguidenonline.se",[7,416]],["nyhetsbyranjarva.se",[7,30,590]],["rockbladet.se",7],["tv-kanal.se",7],["almtuna.com",8],["bjorkloven.com",8],["frolundahockey.com",8],["kalmarhockey.com",8],["malmoredhawks.com",8],["nybrovikings.com",8],["ostersundik.com",8],["lhc.eu",8],["taif.nu",8],["aikhockey.se",8],["bikkarlskoga.se",8],["brynas.se",8],["difhockey.se",8],["farjestadbk.se",8],["fbclerum.se",8],["hockeyallsvenskan.se",8],["hv71.se",8],["ikoskarshamn.se",8],["leksandsif.se",8],["luleahockey.se",8],["modohockey.se",8],["moraik.se",8],["orebrohockey.se",8],["roglebk.se",8],["shl.se",8],["skellefteaaik.se",8],["sodertaljesk.se",8],["timraik.se",8],["vaxjolakers.se",8],["vik.se",8],["avestatidning.com",9],["salaallehanda.com",9],["bbl.fi",9],["hbl.fi",9],["vastranyland.fi",9],["klt.nu",9],["st.nu",9],["allehanda.se",9],["arbetarbladet.se",9],["bandypuls.se",9],["barometern.se",9],["bblat.se",9],["blt.se",9],["borlangetidning.se",9],["bt.se",9],["dalademokraten.se",9],["fagersta-posten.se",9],["falkopingstidning.se",9],["falukuriren.se",9],["folkracepuls.se",9],["gd.se",9],["hd.se",9],["ht.se",9],["jp.se",9],["kristianstadsbladet.se",9],["ljusdalsposten.se",9],["ljusnan.se",9],["lt.se",9],["ltz.se",9],["moratidning.se",9],["na.se",9],["norrteljetidning.se",9],["nsk.se",9],["nuiosteraker.se",9],["nvp.se",9],["nyaludvikatidning.se",9],["nynashamnsposten.se",9],["olandsbladet.se",9],["op.se",9],["skaraborgslanstidning.se",9],["skd.se",9],["skovdenyheter.se",9],["smalandsdagblad.se",9],["smalanningen.se",9],["smp.se",9],["smt.se",9],["soderhamnskuriren.se",9],["sodran.se",9],["sydostran.se",9],["sydsvenskan.se",9],["tidningenangermanland.se",9],["tidningenharjedalen.se",9],["tranastidning.se",9],["trelleborgsallehanda.se",9],["ut.se",9],["vastgotabladet.se",9],["vaxjobladet.se",9],["vetlandaposten.se",9],["vlt.se",9],["vn.se",9],["ystadsallehanda.se",9],["se.azrhymes.com",[10,11]],["bettips.se",[10,81,214]],["borskollen.se",[10,48,231]],["bostadsrattsnytt.se",[10,232]],["dagenslogistik.se",[10,209,275]],["bandyfeber.com",12],["borsvarlden.com",13],["dagenstv.com",15],["kolla.tv",[15,786]],["dayviews.com",16],["dialasen.com",[17,18]],["backpacking.se",17],["bussmagasinet.se",[17,30,240]],["byggteknikforlaget.se",[17,247]],["etunanytt.se",[17,104,336]],["fiskemagasinet.se",17],["kanadaresa.se",17],["livetsgoda.se",[17,25,525]],["nyadagbladet.se",[17,39,586]],["opulens.se",[17,592]],["radiotreby.se",[17,617]],["ravarumarknaden.se",[17,619]],["sporthalsa.se",[17,30,499,671]],["torbjornstips.se",17],["usa.se",17],["extrakt.se",18],["gamingtips.se",18],["lakartidningen.se",[18,253,505]],["ordmedzcxy.se",18],["macken.xyz",[18,787]],["doktorn.com",19],["edgeflyfishing.com",[20,21]],["jaktsidan.se",[21,43]],["elektronikforumet.com",[22,23]],["existenz.se",[23,345]],["funfunfun.se",23],["entreprenad.com",24],["cleannet.se",24],["dagenshandel.se",24],["food-supply.se",24],["foodnet.se",24],["framtidensbygg.se",24],["fri-kopenskap.se",24],["habit.se",24],["lifesciencesweden.se",24],["medtechmagazine.se",24],["metal-supply.se",24],["motormagasinet.se",24],["packnet.se",24],["plastnet.se",24],["processnet.se",24],["recyclingnet.se",24],["rt-forum.se",24],["transportnet.se",24],["uochd.se",24],["verkstaderna.se",24],["woodnet.se",24],["eqotime.com",25],["battregolf.se",[25,30,206]],["betongforeningen.se",25],["bjjtv.se",25],["espressomedia.se",[25,331,332]],["europaportalen.se",[25,337]],["forsvarssektorn.se",25],["magasinethockey.se",25],["motorsportbladet.se",[25,568]],["newsvoice.se",[25,404,577]],["nitroz.se",25],["ordfrontmagasin.se",[25,593]],["thepattayanews.se",[25,721]],["tranakampsport.se",[25,732]],["twostrokerider.se",25],["everysport.com",26],["fotboll.com",[27,28]],["allsvenskan.se",[28,63,173]],["hastnet.se",[28,432]],["superettan.se",28],["swebbtv.se",28],["fotbollsresultat.com",[29,30]],["aip.nu",[29,85]],["dalabygden.se",29],["funktionshinderpolitik.se",[29,400]],["lansposten.se",29],["sjostadsbladet.se",[29,104,163,646]],["skaneplus.se",[29,209,647]],["sormlandsbygden.se",29],["automation.se",[30,196]],["batliv.se",30],["borattforum.se",[30,163,230]],["brollopsmagasinet.se",30],["elinor.se",30],["em-fotboll.se",30],["fisheco.se",[30,365]],["globalpolitics.se",[30,413]],["husbyggaren.se",30],["it-finans.se",[30,332,468]],["it-hallbarhet.se",[30,332,468]],["it-halsa.se",[30,332,468]],["it-kanalen.se",[30,332,468]],["it-pedagogen.se",[30,332,468]],["it-retail.se",[30,332,468]],["nyhetersto.se",[30,589]],["revisionsvarlden.se",[30,38]],["vildmarken.se",30],["vm-fotboll.se",[30,778]],["fotbolltransfers.com",31],["gentlemannaguiden.com",32],["goteborg.com",33],["hallbartbyggande.com",34],["handelsnytt.com",35],["hejauppsala.com",36],["biostock.se",[36,209]],["bredband.se",36],["svenskfilmdatabas.se",[36,104]],["hockeymagasinet.com",[37,38]],["mittforetag.com",[38,48]],["driva-eget.se",[38,48,308]],["foretagande.se",[38,376]],["runnersworld.se",[38,513,626]],["travelnews.se",[38,199,734]],["utsidan.se",[38,754]],["inpress.com",39],["rocknytt.net",[39,82]],["butikstrender.se",[39,104,242]],["evergreengarden.se",39],["ff.se",39],["magasink.se",39],["mykitchenstories.se",39],["transportnytt.se",[39,196]],["kamrat.com",40],["kolozzeum.com",41],["kulturbloggen.com",42],["schack.se",[42,631]],["lindenytt.com",43],["varmepumpsforum.com",[43,67]],["arjeplognytt.se",[43,189]],["autopower.se",[43,198]],["poolforum.se",[43,608]],["luleahockeyforum.com",44],["mabra.com",45],["allas.se",45],["elle.se",45],["femina.se",45],["hant.se",[45,429]],["motherhood.se",45],["residencemagazine.se",45],["svenskdam.se",[45,429]],["minhembio.com",46],["miningmetalnews.com",47],["byggnyheter.se",47],["dagensfastigheter.se",47],["dagensnaringsliv.se",47],["energinyheter.se",47],["industrinyheter.se",47],["infrastrukturnyheter.se",47],["inredningsnyheter.se",47],["jarnvagsnyheter.se",47],["metallerochgruvor.se",47],["papperochmassa.se",47],["solenerginyheter.se",47],["sportochfritidsnyheter.se",47],["stockholmsbyggnyheter.se",47],["transportochlogistik.se",47],["vindkraftsnyheter.se",47],["sv.picmix.com",[48,55]],["sportbloggare.com",[48,59]],["skillingaryd.nu",[48,125]],["xn--vrnamo-bua.nu",[48,125]],["aktiespararna.se",[48,160]],["bettingstugan.se",48],["bovision.se",[48,233]],["brollopstorget.se",[48,239]],["dagensopinion.se",[48,86]],["dn.se",[48,88,298,306]],["expressen.se",[48,88,126,347]],["familjeliv.se",[48,296,351]],["fastighetsvarlden.se",48],["golflivet.se",[48,418]],["ifokus.se",48],["ifragasatt.se",48],["kamerabild.se",[48,476]],["lajvo.se",[48,504]],["receptfavoriter.se",48],["swedroid.se",[48,701]],["teknikveckan.se",[48,714]],["tidningenridsport.se",[48,104,726,727]],["tripadvisor.se",[48,739]],["tyda.se",[48,744]],["vardfokus.se",[48,104,727,759]],["vemringde.se",48],["morotsliv.com",49],["newsner.com",[50,51]],["djurbibeln.se",[50,51]],["ettgottskratt.se",[50,51]],["humorbibeln.se",[50,51]],["sportbibeln.se",[50,51]],["nouw.com",52],["omnihalsa.com",53],["skanesport.se",[53,649]],["sportpanelen.se",[53,673]],["orebronyheter.com",54],["autonytt.se",[55,102,113,197]],["tekniknytt.se",[55,712]],["rakapuckar.com",56],["skrattsajten.com",57],["norpan.se",[57,63]],["sonicmagazine.com",58],["ratsit.se",[58,618]],["svenskadating.com",60],["svenskafans.com",61],["sweclockers.com",62],["tasteline.com",[63,64]],["akademikern.se",63],["byggvarlden.se",[63,199,248]],["chefstidningen.se",[63,260]],["culturezone.se",63],["fotosidan.se",[63,390]],["jaktjournalen.se",[63,199,470]],["jaktojagare.se",[63,471]],["merinfo.se",[63,555]],["moviezine.se",[63,569]],["socionomen.se",63],["omtanke.today",[63,199,248,785]],["trafikradion.com",65],["undertian.com",66],["veckansmiddag.com",68],["veckorevyn.com",69],["webhallen.com",[70,71]],["tillnyktrad.se",70],["snapsvisor.eu",[72,73]],["minip.nu",[72,73]],["dinstartsida.se",72],["raggningsboken.se",[72,73]],["osterbottenstidning.fi",74],["sydin.fi",74],["vasabladet.fi",74],["webbjobb.io",75],["kwiss.me",76],["metalcentral.net",[77,78,79]],["egoinas.se",78],["rotter.se",[79,335]],["mobilanyheter.net",80],["alekuriren.se",[81,160,164]],["campingsverige.se",[81,251]],["dalarnasaffarer.se",[81,279,280,281]],["dh.se",81],["djungeltrumman.se",[81,304]],["eniro.se",[81,323]],["entreprenadaktuellt.se",81],["frillesasbandy.se",81],["hallandsnaringsliv.se",[81,279,280,281]],["husbilhusvagn.se",[81,453]],["ja.se",81],["jamtlandsaffarer.se",[81,279,280,281]],["ljuskultur.se",[81,148]],["maskinbladet.se",81],["naringslivetvgl.se",[81,279,280,281]],["nyheteridag.se",[81,588]],["omni.se",[81,591]],["omniekonomi.se",[81,591]],["onkologiisverige.se",[81,281]],["restaurangvarlden.se",[81,624]],["sjuharadsnaringsliv.se",[81,279,280,281]],["skik.se",81],["skogsaktuellt.se",81],["spelo.se",[81,531]],["stockholmsaffarer.se",[81,279,280,281]],["svenskalag.se",[81,686]],["sverigesindustri.se",[81,281,698]],["rodeo.net",83],["vovve.net",84],["alba.nu",86],["fiskejournalen.se",86],["formeldirekt.se",[86,379,380]],["fotbolldirekt.se",[86,379]],["golfing.se",[86,417]],["hockeysverige.se",[86,447]],["innebandymagazinet.se",[86,379]],["motivation.se",[86,567]],["padeldirekt.se",[86,379,380,597]],["atl.nu",[87,88]],["land.se",[87,88]],["landlantbruk.se",[87,88]],["bulletin.nu",89],["dagenskalmar.nu",90],["dagenshultsfred.se",90],["dagensvastervik.se",90],["dagensvimmerby.se",90],["dagensnamn.nu",91],["dykarna.nu",92],["flm.nu",93],["folkbladet.nu",94],["lokaltidningen.nu",94],["mellanbygden.nu",94],["nordsverige.se",94],["vasterbottningen.se",94],["vk.se",94],["fraser.nu",95],["fria.nu",96],["stockholmsfria.se",96],["fuska.nu",97],["gmfk.nu",98],["grillbloggen.nu",99],["hembostad.nu",[100,101]],["nojesmagasinet.nu",[100,101]],["aftonbladet.se",[100,102,154,155]],["arbetaren.se",100],["cfanytt.se",[100,101]],["computersweden.se",[100,264]],["foretagsbladet.se",[100,101]],["gestrikemagasinet.se",[100,101]],["halsasverige.se",[100,101]],["langd.se",[100,507]],["lasarnas.se",[100,101]],["mandarinmedia.se",[100,101]],["pressbladet.se",[100,101]],["sjofartstidningen.se",[100,645]],["sportidrott.se",[100,101]],["stoppapressarna.se",[100,678]],["svenskpress.se",[100,101]],["thatsup.se",100],["hockeybladet.nu",[102,103,104]],["ekonominyheter.se",[102,314]],["lesscarbs.se",[102,514]],["matinspo.se",[102,547]],["undervarttak.se",[102,746]],["alltomhusbilen.se",104],["battrestadsdel.se",[104,207,208,209]],["cookaholic.se",[104,265]],["forskning.se",[104,382]],["frihetsnytt.se",104],["karriarlakare.se",[104,478]],["livinguppsala.se",104],["raa.se",104],["smaspararguiden.se",104],["varvat.se",[104,763]],["vinliv.se",[104,775]],["hungrig.nu",105],["jennysmatblogg.nu",106],["filippoon.se",106],["lindasbakskola.se",[106,518]],["niiinis.se",106],["zeinaskitchen.se",106],["kalmar.nu",107],["kuriren.nu",108],["corren.se",108],["ekuriren.se",108],["eposten.se",108],["folkbladet.se",108],["helagotland.se",108],["kkuriren.se",108],["mvt.se",108],["norran.se",108],["nsd.se",108],["nt.se",108],["pt.se",108],["sn.se",108],["strengnastidning.se",108],["unt.se",108],["vimmerbytidning.se",108],["vt.se",108],["landetsfria.nu",109],["fempers.se",109],["tidningenglobal.se",109],["tidningensyre.se",109],["lyckasmedbakning.nu",110],["brl.se",110],["naturnaraskogsbruk.se",110],["pinkprogramming.se",110],["tonyhatefnejad.se",110],["marsta.nu",111],["nyatider.nu",[112,113]],["pilsner.nu",114],["podcasts.nu",115],["prisjakt.nu",116],["quizza.nu",[117,118]],["lifeofsvea.se",117],["elbilen.se",118],["rejsa.nu",119],["forum.robsoft.nu",120],["rollspel.nu",121],["friaordet.org",121],["bukefalos.se",121],["husbilsklubben.se",121],["ihusbil.se",121],["thaisnack.se",121],["xn--lnforum-exa.se",[121,782]],["samnytt.nu",122],["samnytt.se",122],["skiljebosk.nu",[123,124]],["hallbyhandboll.se",[123,124]],["lundgiants.se",[124,537]],["spokbloggen.nu",126],["affarerinorr.se",[126,151]],["affarsvarlden.se",[126,153]],["bolagsfakta.se",126],["byggahus.se",[126,243]],["destination.se",126],["filmtopp.se",[126,361]],["folkhalsasverige.se",126],["foretagsverige.se",126],["forskningsverige.se",126],["grillbibeln.se",126],["hallbarhetsverige.se",126],["kampenmotcancer.se",126],["motorbibeln.se",126],["tillvaxtsverige.se",126],["viivilla.se",[126,518,769]],["sporttv.nu",127],["svenskamagasinet.nu",128],["sverige.nu",129],["obsid.se",[129,404]],["sportsnews.se",[129,166,674]],["teknologiexperten.se",[129,716]],["xn--sporthnt-5za.se",[129,166,674]],["tv.nu",130],["tvmatchen.nu",131],["tvsporten.nu",132],["usabil.nu",133],["webbkryss.nu",134],["yogafordig.nu",135],["zeromagazine.nu",136],["flashback.org",137],["garaget.org",138],["forum.mustangclubsweden.org",139],["offside.org",140],["voodoofilm.org",142],["180.se",143],["2000tv.se",144],["56kilo.se",145],["7an.se",146],["8sidor.se",147],["aapl.se",148],["hrnytt.se",[148,451]],["inblick.se",[148,459]],["inredningsarkitektur.se",148],["matklubben.se",148],["adecco.se",149],["apotekhjartat.se",149],["ica.se",[149,279]],["tele2.se",149],["advokaten.se",150],["affarsstaden.se",152],["godare.se",[155,414]],["livsstil.se",[155,527]],["agriaffaires.se",156],["machineryzone.se",156],["truckscorner.se",156],["aikfotboll.se",157],["tidningen.djurskyddet.se",[157,305]],["vaken.se",157],["akaskidor.se",158],["husohem.se",158],["praktisktbatagande.se",158],["sportfack.se",158],["svenskgolf.se",[158,692]],["tidningenhalsa.se",158],["utemagasinet.se",158],["vagabond.se",[158,757]],["akaviaaspekt.se",159],["kurera.se",[160,199,501]],["tidningen.se",[160,287,722]],["vinbanken.se",[160,774]],["aktuellhallbarhet.se",161],["byggindustrin.se",161],["dagensmedia.se",161],["dagensmedicin.se",161],["dagenssamhalle.se",161],["dagligvarunytt.se",161],["fastighetsnytt.se",161],["market.se",161],["privataaffarer.se",161],["resume.se",161],["aktuellsakerhet.se",[162,163]],["aletorget.se",165],["alingsastorget.se",165],["almhulttorget.se",165],["alvestatorget.se",165],["amaltorget.se",165],["angelholmtorget.se",165],["arbogatorget.se",165],["arvikatorget.se",165],["askersundtorget.se",165],["avestatorget.se",165],["bastadtorget.se",165],["bengtsforstorget.se",165],["bjuvtorget.se",165],["bodentorget.se",165],["bollebygdtorget.se",165],["bollnastorget.se",165],["borastorget.se",165],["borlangetorget.se",165],["botkyrkatorget.se",165],["bromollatorget.se",165],["eksjotorget.se",165],["enkopingtorget.se",165],["eskilstunatorget.se",165],["eslovtorget.se",165],["fagerstatorget.se",165],["falkenbergtorget.se",165],["falkopingtorget.se",165],["faluntorget.se",165],["filipstadtorget.se",165],["flentorget.se",165],["forshagatorget.se",165],["gallivaretorget.se",165],["gavletorget.se",165],["gislavedstorget.se",165],["goteborgtorget.se",165],["gotenetorget.se",165],["gotlandtorget.se",165],["hagforstorget.se",165],["hallsbergtorget.se",165],["hallstahammartorget.se",165],["halmstadtorget.se",165],["haningetorget.se",165],["harnosandtorget.se",165],["harrydatorget.se",165],["hassleholmtorget.se",165],["hebytorget.se",165],["hedemoratorget.se",165],["helsingborgtorget.se",165],["herrljungatorget.se",165],["hoforstorget.se",165],["hoganastorget.se",165],["hoortorget.se",165],["horbytorget.se",165],["huddingetorget.se",165],["hudiksvalltorget.se",165],["hultsfredtorget.se",165],["hyltetorget.se",165],["jonkopingtorget.se",165],["kalixtorget.se",165],["kalmartorget.se",165],["karlshamntorget.se",165],["karlskogatorget.se",165],["karlskronatorget.se",165],["karlstadtorget.se",165],["katrineholmtorget.se",165],["kavlingetorget.se",165],["kiltorget.se",165],["kirunatorget.se",165],["klippantorget.se",165],["kopingtorget.se",165],["kramforstorget.se",165],["kristianstadtorget.se",165],["kristinehamntorget.se",165],["krokomtorget.se",165],["kumlatorget.se",165],["kungalvtorget.se",165],["kungsbackatorget.se",165],["laholmtorget.se",165],["landskronatorget.se",165],["leksandtorget.se",165],["lidkopingtorget.se",165],["ljungbytorget.se",165],["ljusdaltorget.se",165],["ludvikatorget.se",165],["luleatorget.se",165],["lundtorget.se",165],["lyckseletorget.se",165],["lysekiltorget.se",165],["malmotorget.se",165],["mariestadstorget.se",165],["markarydtorget.se",165],["marktorget.se",165],["moratorget.se",165],["nackatorget.se",165],["nassjotorget.se",165],["norrtaljetorget.se",165],["nybrotorget.se",165],["nykopingtorget.se",165],["nynashamntorget.se",165],["olandtorget.se",165],["olofstromtorget.se",165],["orebrotorget.se",165],["ornskoldsvikstorget.se",165],["orusttorget.se",165],["osbytorget.se",165],["oskarshamntorget.se",165],["ostersundtorget.se",165],["osthammartorget.se",165],["partilletorget.se",165],["piteatorget.se",165],["ronnebytorget.se",165],["saffletorget.se",165],["salatorget.se",165],["sandvikentorget.se",165],["sigtunatorget.se",165],["simrishamntorget.se",165],["sjobotorget.se",165],["skaratorget.se",165],["skellefteatorget.se",165],["skovdetorget.se",165],["skuruptorget.se",165],["soderhamntorget.se",165],["sodertaljetorget.se",165],["sollefteatorget.se",165],["sollentunatorget.se",165],["solnatorget.se",165],["solvesborgtorget.se",165],["staffanstorptorget.se",165],["stenungsundtorget.se",165],["stockholmtorget.se",165],["strangnastorget.se",165],["stromstadtorget.se",165],["sundsvalltorget.se",165],["sunnetorget.se",165],["svenljungatorget.se",165],["tabytorget.se",165],["tanumtorget.se",165],["tidaholmtorget.se",165],["tierptorget.se",165],["timratorget.se",165],["tingsrydtorget.se",165],["tjorntorget.se",165],["tomelillatorget.se",165],["torsbytorget.se",165],["tranastorget.se",165],["tranemotorget.se",165],["trelleborgtorget.se",165],["trollhattantorget.se",165],["trosatorget.se",165],["uddevallatorget.se",165],["ulricehamntorget.se",165],["umeatorget.se",165],["uppsalatorget.se",165],["vallentunatorget.se",165],["vanersborgtorget.se",165],["varatorget.se",165],["varbergtorget.se",165],["varnamotorget.se",165],["vasterastorget.se",165],["vasterviktorget.se",165],["vaxjotorget.se",165],["vellingetorget.se",165],["vetlandatorget.se",165],["vimmerbytorget.se",165],["ystadtorget.se",165],["alexandrabylund.se",166],["helahisingen.se",[166,435]],["stockholmblaljus.se",166],["alingsastidning.se",167],["bohuslaningen.se",167],["gp.se",167],["hallandsposten.se",167],["harrydaposten.se",167],["hn.se",167],["kungalvsposten.se",167],["kungsbackaposten.se",167],["markposten.se",167],["mellerudsnyheter.se",167],["molndalsposten.se",167],["partilletidning.se",167],["stromstadstidning.se",167],["sttidningen.se",167],["ttela.se",167],["alkompis.se",168],["allaaktier.se",169],["allabolag.se",170],["allamassor.se",171],["allatvkanaler.se",172],["alltomarbetsmiljo.se",175],["alltomburgare.se",176],["alltomelbil.se",177],["alltomhif.se",178],["alltomkungligt.se",179],["alltommc.se",180],["alltomnorrtalje.se",181],["alltomsallskapsspel.se",182],["alpresor.se",183],["altinget.se",184],["antagning.se",185],["universityadmissions.se",185],["arbetarskydd.se",186],["lag-avtal.se",186],["nyteknik.se",186],["arbetet.se",187],["fastighetsfolket.se",187],["handelsnytt.se",187],["ka.se",187],["sekotidningen.se",187],["tidningenelektrikern.se",187],["arbetsvarlden.se",188],["arkitekten.se",[190,191]],["chef.se",[191,258,259]],["da.se",[191,269]],["elinstallatoren.se",191],["frisor.se",191],["natursidan.se",191],["svd.se",[191,684]],["svenskfarmaci.se",[191,690]],["vvsforum.se",191],["arkitektur.se",192],["arvikanyheter.se",193],["dalslanningen.se",193],["filipstadstidning.se",193],["fryksdalsbygden.se",193],["hjotidning.se",193],["kt.se",193],["kt-kuriren.se",193],["mariestadstidningen.se",193],["nkp.se",193],["nlt.se",193],["nwt.se",193],["provinstidningen.se",193],["saffletidningen.se",193],["skaraborgsbygden.se",193],["sla.se",193],["vf.se",193],["assistanskoll.se",194],["aurumforum.se",195],["datormagazin.se",[196,289,290]],["verkstadstidningen.se",196],["aventyrsresor.se",199],["babyhjalp.se",200],["badkartan.se",201],["cafekartan.se",201],["campingkartan.se",201],["hotellkartan.se",201],["kyrkokartan.se",201],["pizzakartan.se",201],["restaurangkartan.se",201],["slottskartan.se",201],["sushikartan.se",201],["vandrarhemskartan.se",201],["vintagekartan.se",201],["wifikartan.se",201],["bakasockerfritt.se",202],["barnistan.se",[203,204]],["welma.se",[203,204]],["ingenjorsjobb.se",[204,461]],["barnsemester.se",205],["flashback.se",208],["leta.se",[208,515]],["cannabis.se",[209,254]],["magasinetkonkret.se",209],["snowmobile.se",[209,662]],["tobaksfakta.se",209],["beernews.se",210],["bergsmannen.se",211],["taxiidag.se",[211,709]],["tidningenbyggmaterial.se",211],["tidningendacksnack.se",211],["besoksliv.se",212],["bestchampagne.se",213],["biblioteksforeningen.se",215],["psykologiguiden.se",215],["rabattsok.se",215],["bike.se",216],["bildobubbla.se",217],["bilresaieuropa.se",218],["bilsport.se",219],["bio-link.se",220],["web-tools.se",220],["bioenergitidningen.se",221],["birthday.se",222],["bjuvsweek.se",223],["blocket.se",224],["bokadirekt.se",225],["bokmassan.se",226],["svenskamassan.se",226],["boktugg.se",227],["boneo.se",228],["booli.se",229],["brafiler.se",234],["branschaktuellt.se",235],["branschkoll.se",236],["branschstegen.se",237],["breakit.se",238],["butiksnytt.se",241],["byggfaktadocu.se",244],["byggipedia.se",245],["byggnadsarbetaren.se",246],["cafe.se",249],["camping.se",250],["canariajournalen.se",[252,253]],["cannabisifokus.se",255],["carup.se",256],["cfosvepet.se",257],["hrsvepet.se",257],["fokus.se",259],["cineasten.se",261],["citattorget.se",262],["citiboard.se",263],["cyclingplus.se",266],["cykelframjandet.se",267],["cykla.se",268],["dagen.se",270],["dagens.se",271],["dagensarena.se",272],["dagensinnovation.se",273],["modernalivet.se",[273,565]],["nyheter.swebbtv.se",[273,700]],["dagensjuridik.se",274],["dagensps.se",[276,277]],["news55.se",[277,576]],["realtid.se",277],["dagenstech.se",278],["dansbandsnytt.se",282],["danskaspraket.se",[283,284,285]],["digitalavykort.se",[284,285]],["vmj.se",[284,285]],["viseniorer.se",[285,777]],["dansportalen.se",286],["hh.se",286],["kb.se",286],["danstidningen.se",287],["lira.se",[287,520]],["slangopedia.se",287],["darkside.se",288],["forexgruppen.se",[290,377]],["kvalitetsmagasinet.se",[290,502]],["miljo-utveckling.se",[290,502]],["skogen.se",[290,655]],["studeravidare.se",[290,680]],["telekomidag.se",[290,502]],["vdtidningen.se",[290,502]],["deliquate.se",291],["densistavilan.se",292],["dental24.se",293],["designbase.se",294],["devote.se",[295,296]],["borssnack.di.se",299],["digitalfotoforalla.se",300],["iform.se",300],["pctidningen.se",300],["varldenshistoria.se",300],["dinamediciner.se",301],["dinbyggare.se",302],["dinvinguide.se",303],["doon.se",307],["dust2.se",309],["edukatus.se",310],["ehandel.se",311],["ehandelstips.se",312],["ekonomifokus.se",313],["horisontmagasin.se",[313,448]],["shoegazing.se",[313,637]],["spanaren.se",313],["eksjoco.se",315],["electronic.se",316],["elevspel.se",317],["elitettan.se",[318,319]],["obosdamallsvenskan.se",[318,319]],["ifiske.se",319],["sdhl.se",[319,634]],["ssl.se",[319,634]],["storvretaibk.se",[319,634]],["elprisetjustnu.se",320],["emocore.se",321],["energi.se",322],["kartor.eniro.se",324],["enkelteknik.se",325],["enterprisemagazine.se",326],["epochtimes.se",327],["esportare.se",328],["esportnytt.se",329],["esportsacademy.se",330],["etc.se",333],["etfmarknaden.se",334],["etn.se",335],["uppsalanyheter.se",[335,752]],["eventeffect.se",[338,339,340,341]],["executiveeffect.se",[339,340,341]],["saleseffect.se",[339,340,341]],["svartgul.se",[340,683]],["kemisamfundet.se",341],["knep.se",341],["tidningenskriva.se",[341,728]],["vackertvader.se",[341,755]],["veckansnyheter.se",341],["evertiq.se",[342,343]],["fz.se",[343,405]],["exakt24.se",344],["expo.se",346],["livesport.expressen.se",348],["extraextra.se",349],["familjehemmet.se",350],["familjesidan.se",352],["fastighetssverige.se",353],["fastighetstidningen.se",354],["feber.se",355],["tjock.se",355],["festivalinfo.se",356],["fightermag.se",357],["filmparadiset.se",[358,359]],["svenskhistoria.se",[359,693]],["filmtipset.se",360],["findit.se",362],["firstclassmagazine.se",363],["firstfoto.se",364],["fl-net.se",366],["flamman.se",367],["flashscore.se",368],["flygtorget.se",369],["fn.se",370],["fodertipset.se",371],["fof.se",372],["folkofolk.se",373],["foodfolder.se",374],["foreca.se",375],["recepten.se",375],["formas.se",378],["rf.se",378],["skogssallskapet.se",378],["forni.se",381],["forstasidorna.se",383],["forvaltarforum.se",384],["fotboll-tv.se",385],["fotbollskanalen.se",[386,387]],["koket.se",[387,492]],["tv4.se",[387,743]],["tv4play.se",387],["fotbollsthlm.se",[388,389]],["gasetten.se",[389,409]],["fragbite.se",391],["framtid.se",392],["freedomtravel.se",393],["freeride.se",[394,395,396]],["gamereactor.se",[395,408]],["happyride.se",[395,396,431]],["hockeyettan.se",[395,445]],["frihet.se",397],["frilagt.se",398],["friluftsframjandet.se",399],["funnygames.se",401],["nyckelspel.se",401],["fuska.se",402],["futsalmagasinet.se",[403,404]],["gaffa.se",406],["gais.se",407],["gavletravet.se",410],["travsport.se",410],["glassakademin.se",411],["globalbar.se",412],["golf.se",415],["goteborgextra.se",419],["huddingeextra.se",419],["lundextra.se",419],["sollentunaextra.se",419],["sundsvallextra.se",419],["goteborgsgolfaren.se",420],["grandtech.se",421],["grillbaronen.se",422],["guldkanalen.se",423],["haaf.se",424],["haften.se",425],["hallakonsument.se",426],["hammarbyfotboll.se",427],["handbollskanalen.se",428],["happypancake.se",430],["hbwebben.se",433],["hejaolika.se",434],["helgon.se",436],["hellofresh.se",437],["hemhyra.se",438],["hemmafixbloggen.se",439],["hemmanytt.se",440],["hemnet.se",441],["hemtrevligt.se",442],["hifitorget.se",443],["hitta.se",444],["hockeynews.se",446],["hotellorestaurang.se",[449,450]],["byggfakta.today",[449,450]],["citymark.today",[449,450]],["husbil.se",452],["husvagn.se",452],["husbilsplats.se",454],["husvagnochcamping.se",455],["ibnytt.se",456],["icagruppen.se",457],["improveme.se",458],["industritorget.se",460],["inkopsradet.se",462],["innebandy.se",463],["internetmedicin.se",464],["internetodontologi.se",465],["internetstiftelsen.se",466],["svenskarnaochinternet.se",466],["ipo.se",467],["itseniorerna.se",469],["jaktplay.se",472],["javligtgott.se",473],["journalisten.se",474],["kalender.se",475],["mobil.se",476],["kardemummagumman.se",477],["riktighockey.se",477],["kiacarclub.se",479],["killsteal.se",480],["kimura.se",481],["kingmagazine.se",482],["kingsizemag.se",483],["kittad.se",484],["klart.se",485],["klendr.se",486],["klimatnytt.se",487],["knulla.se",488],["kobe.se",489],["kodboken.se",490],["kokaihop.se",491],["kollega.se",493],["kompanjoner.se",494],["komponentkoll.se",495],["konsumentmagasinet.se",496],["kristendate.se",497],["kritiker.se",498],["kultmagasin.se",499],["kulturama.se",500],["kvartal.se",503],["landleyskok.se",506],["lantbruksnytt.se",508],["laromedia.se",509],["lawline.se",510],["lchfarkivet.se",511],["lektionsbanken.se",[512,513]],["levandehistoria.se",516],["lidingonyheter.se",517],["skk.se",[518,654]],["ungdomsfotboll.se",[518,748]],["linguee.se",519],["listaroo.se",521],["listor.se",522],["litteraturmagazinet.se",523],["livetochdiabetes.se",524],["livsmedelsverket.se",526],["ljudochbild.se",528],["ljungbysporten.se",529],["lokalguiden.se",[530,531]],["svenskverkstad.se",[531,697]],["lokalnytt.se",532],["lokalti.se",533],["loppi.se",534],["lovelylife.se",535],["lundagard.se",536],["lysekilsposten.se",538],["magasinetparagraf.se",539],["maipenrai.se",540],["maklarvarlden.se",541],["maltermagasin.se",542],["maringuiden.se",543],["marketmate.se",544],["marketplace.se",545],["marknadschefer.se",546],["matkanalen.se",548],["matmalin.se",549],["matpriskollen.se",550],["matspar.se",551],["medibok.se",552],["megafonen.se",553],["meningokockfonden.se",554],["mestmotor.se",556],["metromode.se",557],["mhis.se",558],["milansverige.se",559],["miljomat.se",560],["missatsamtal.se",561],["mitti.se",562],["mmabetz.se",563],["mmanytt.se",564],["modette.se",566],["musikermagasinet.se",570],["mytaste.se",571],["narkive.se",572],["naturvetarna.se",573],["netdoktor.se",574],["netdoktorpro.se",574],["netflixguiden.se",575],["nextconomy.se",578],["ng.se",579],["nogg.se",580],["nordfront.se",581],["nordichardware.se",582],["nordiskradio.se",583],["nordiskskog.se",584],["norrahalland.se",585],["nyheter24.se",587],["ordguru.se",594],["oru.se",595],["oskarshamns-nytt.se",596],["padelfeber.se",598],["pakryss.se",599],["piraja.se",601],["pirkt.se",602],["placera.se",603],["playradio.se",604],["poddtoppen.se",605],["podtail.se",606],["pomu.se",607],["popularastronomi.se",609],["proshop.se",610],["psykoterapicentrum.se",611],["pussad.se",612],["qx.se",613],["racemagazine.se",614],["radio.se",615],["radio-sveriges.se",616],["recept.se",620],["res.se",621],["reseguiden.se",622],["resesidan.se",623],["ridsport.se",625],["sakochliv.se",627],["samfalligheterna.se",628],["sanghafte.se",629],["sbf.se",630],["skaneridsport.se",[630,648]],["schoolido.se",632],["screen-marknaden.se",633],["senses.se",635],["sexpacket.se",636],["shortcut.se",638],["si.se",639],["sweden.se",639],["siljannews.se",640],["siljanskok.se",641],["sillyseason.se",642],["siriusbandy.se",643],["vetlandabk.se",643],["sistersinlaw.se",644],["skargarden.se",650],["skellefteamedia.se",651],["skidspar.se",652],["skippo.se",653],["skogsforum.se",656],["skolporten.se",657],["skrattnet.se",658],["skyltat.se",659],["skyscanner.se",660],["smartsenior.se",661],["sokbat.se",664],["spanienforum.se",665],["spelagratis.se",666],["spelhubben.se",667],["spelochfilm.se",668],["sportal.se",669],["sportbilen.se",670],["sportlovin.se",672],["stallet.se",675],["startaochdriva.se",676],["stegforhalsa.se",677],["storyhouseegmont.se",679],["surfa.se",[681,682]],["teknikfreak.se",682],["svenskahousegruppen.se",685],["svenskanomader.se",687],["svenskbyggmarknad.se",688],["svenskelitfotboll.se",689],["svenskfotboll.se",691],["svenskjakt.se",694],["svensktgolfforum.se",695],["svensktidskrift.se",696],["sverigespringer.se",699],["swehockey.se",702],["sydasien.se",703],["sydnarkenytt.se",704],["synonyma.se",705],["synonymer.se",706],["tabyallehanda.se",707],["tandlakartidningen.se",708],["teknifik.se",710],["teknikguiden.se",711],["tekniksmart.se",713],["99.teknikveckan.se",715],["temaarkiv.se",717],["temadagar.se",718],["testfakta.se",719],["thelocal.se",720],["tidningenbalans.se",723],["tidningencurie.se",724],["tidningennara.se",725],["tlnt.se",729],["totallyorebro.se",730],["totallystockholm.se",730],["tradevenue.se",731],["traning40plus.se",733],["travnet.se",735],["travronden.se",736],["sportapp.travsport.se",737],["trendenser.se",738],["turismnytt.se",740],["turistmal.se",741],["typkanske.se",745],["ungdomar.se",747],["universitetslararen.se",749],["upplysning.se",751],["uppsatser.se",753],["vadvivet.se",756],["varden.se",758],["vardpraktikan.se",760],["varldenshaftigaste.se",761],["vartgoteborg.se",762],["vasterastidning.se",764],["veterinarmagazinet.se",765],["vi.se",766],["vietnamportalen.se",768],["vilaser.se",770],["villalivet.se",771],["villatidningen.se",772],["vimedbarn.se",773],["vinochmatguiden.se",776],["voister.se",779],["vokabel.se",780],["webbkameror.se",781],["m.yelp.se",783],["ysektionen.se",784]]);

const entitiesMap = new Map(undefined);

const exceptionsMap = new Map(undefined);

self.specificImports = self.specificImports || [];
self.specificImports.push({ argsList, hostnamesMap, entitiesMap, exceptionsMap });

/******************************************************************************/

})();

/******************************************************************************/
