/*******************************************************************************

    uBlock Origin Lite - a comprehensive, MV3-compliant content blocker
    Copyright (C) 2019-present Raymond Hill

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see {http://www.gnu.org/licenses/}.

    Home: https://github.com/gorhill/uBlock
*/

/* jshint esversion:11 */

'use strict';

// ruleset: vie-1

/******************************************************************************/

// Important!
// Isolate from global scope
(function uBOL_cssSpecificImports() {

/******************************************************************************/

const argsList = ["[id^=\"adm-slot\"]",".qc",".banner-bottom","#video_player ~ div[id]","div[style^=\"position:fixed;inset:0px;z-index:100000;\"]",".mp-adz","#catfish","#overlay","#banner",".ads-gg-top,\n.container + .col-xs-12.content_wrap,\n.content > .content > .content,\n.wrap-single > .pagination.text-center",".w1e48c4420b7073bc11916c6c1de226bb","#f186fb23a33995d91ce3c2212189178c8","#qc_clgt",".advertisement","#popup-giua-man-hinh",".ad-container","#quangcaopc","#wap_bottombanner",".c-ad,\n.container.mt-1.d-none.d-lg-block,\n.menu-item-object-custom",".align-items-center.justify-content-between.d-flex.col-12 > .d-lg-none.d-block",".sub-menu.d-none.d-lg-flex",".marquee-container",".company","div[id^=\"dnn_\"]",".code-block-1.code-block,\n.navbar-container + .container",".container > .row > center","[id^=\"Balloon_\"]","a[rel=\"nofollow\"]","#match-child-1,\n.banner-link,\n.block-catfish.text-center.d-lg-none.d-block,\n.container > ul,\n.container.mt-1,\n.logo-cnt > .d-lg-none.d-block,\n.menu-cuoc-one88,\n.mt-5.d-lg-none.d-block.pb-2.text-center,\n.offer,\n.pl-lg-0.col-xl-4,\n.row.d-none,\n.widget-offers__list,\ndiv.d-lg-none.d-block:nth-of-type(3)",".match-detail__offer",".sk_balloon",".offer__btn",".menu-top-nha-cai",".menu-cuoc-8xbet",".catfish-top",".catfish-bottom",".xx-ads",".toogle-ads","#floating_ads_bottom_textcss_container,\n.module_home_ads",".classvi,\n.elementor-section-height-default.elementor-section-boxed.elementor-element-e601265.elementor-element.elementor-top-section.elementor-section",".adsMobile,\n.col-chat,\n.offer-rating.widget-offers__list",".dcmm-button-player.row",".adLogoPlayer",".sda-catfish",".sda-preload-popup,\n.sda-preload-popup-overlay",".banner-top","#bottomFixedDiv,\n#js_pup_navigation,\n#wAdList,\ntr[id^=\"word_\"]",".no-auto-popup","#player + div[id],\n.playover",".jw-logo","#fbox-background",".gnarty-offads","#sn-AnchorAd,\n.pAd,\n.relatedPostsAd,\ndiv.pAdin",".adNative",".ads","a[href^=\"/cgi-bin/to.cgi\"]",".block:has([data-adaptive])",".monkey-content-duoicanbiet,\n.monkey-section-tinnoibat,\ndiv.monkey-qc",".list-dat-cuoc",".widget.widget_text","div[id^=\"float\"],\ndiv[id^=\"hide_float\"]",".bannerBox,\n.footerBanner,\ncenter > [href*=\"tlink.vn\"]",".float-ck-center-lt",".mb-4 > [style=\"min-height: 350px;\"]",".fixed","a[rel=\"noopener noreferrer\"]",".widget-wrap.widget_text",".div_box_adv",".alldiv ~ div[class]",".chapter-content .min-h-\\[275px\\]","[id$=\"bnr\"]",".top-right",".line-ads",".popup",".banner-ads","div#recent-content:nth-of-type(1)",".adsbygoogle","#bannerContainer1,\n#bannerContainer2,\n#sp-wrapper-hovering-format,\n.wam-banner,\ncenter:has(.adsbygoogle)","div.ad",".ad-manager-forum-list-bottom,\n.ad-manager-forum-list-top,\n.ad-manager-header,\n.ad-manager-thread-view-bottom,\n.ad-manager-thread-view-top,\na[rel=\"noopener noreferrer nofollow\"],\ndiv[style=\"margin:6px 0px 6px 0px\"]","#antiblocker,\n#antiblocker_underplayer","#topbanner",".btn_small_fix_container",".ads-home-feed",".advertTop,\n.hsdn > li:has(.adsbygoogle),\n.module_plugins",".banner-bot-mobile,\n.banner-top-mobile,\n.preload","[href^=\"https://shope.ee\"]","#latest-censored-videos > .row > div.pb-3.col:nth-of-type(1),\n.v3sb-box",".cat-fish.a-play,\n.overlay",".ezo_ad",".ezoic-ad",".advbox","div[style=\"padding: 0px; margin: 10px 0 0 0 ; width: 100%;text-align: center;min-height: 280px;\"],\ndiv[style=\"width: 100%; min-height: 240px; text-align: center;\"],\ndiv[style=\"width: 100%; min-height: 90px; text-align: center;\"],\ndiv[style=\"width: 100%;text-align: center;min-height: 280px;\"]",".info-footer:nth-child(4)","#countdown,\n.section-gqc1,\ndiv[style=\"margin: 10px 0 5px 0; min-height: 250px;\"]","[href$=\"/goout/lazada\"],\nsection.nh-section:nth-of-type(5)","div[class*=\"ads\"]",".ads-embed","#mp-adx-b32","[class^=\"box_adv_ele\"]","#_pop-nettruyenww-15,\n#catfish-content,\n#pop_nettruyenww",".banner","#_pop-nettruyenx-13","#banner-qc_outstream,\n.adv_home_300_250,\n.nqc-zone",".in.fade.modal-backdrop",".quang-cao","#pc-preload-modal","#itro_opaco",".BanerTop100",".banner-container",".adv-300-right","#mobile_content_top","a#banner","#container-ads","#p-GMH","#fakeDown","#anchor-ad",".aSlP,\n.bef,\n.hmvD",".shadow-card + .mt-2","#adsposttop","#adrighttop",".adbox","#scriptDiv",".stream-item","#footer-widget-area",".google-auto-placed",".box,\n.pum","div#adsChapterTop","#ad_info_top,\n#catfishAd,\n#floating-banner-left,\n#floating-banner-right,\n#popup-truyenqq,\n#popup-truyenqq-home,\n.ads-banner,\ndiv#ad_info",".sticky-footer",".footer-info",".ai-viewport-1","#ads_preload1,\n#ads_preload2,\n#catfish-adv,\n.widget_text.text-center + .text-center","[class*=\"_banner\"]",".item-qc",".Header_topBanner__1xD-2,\n.styles_bannerInArticleWrapper__rPPJH,\n.styles_topBanner__NL_gW","#BigBanner,\n.ads_position",".ads_txt,\n[href=\"https://tailieugiaovien.com.vn/\"]","#download_appnew,\n.box-most-viewed.box-course.box-slide,\ndiv.ads_ads,\nh3.sub-title,\nul.list:nth-of-type(2)","div[class^=\"adbox\"]","a.news__item--action:nth-of-type(2)","#article > .pt-3.text-centers,\n.text-muted","#balloon,\n.affiliate,\n.player-midpoint-progress",".banner-masthead","#link-view > center:nth-of-type(1)",".button-action-float-banner",".wtt-ads","#ouibounce-modal",".pum-overlay","#adstop2,\n.ads-item,\n.col-lg-4.hidden-xs.d-flex.flex-column.address-wrap",".float-right",".adv-side-bar,\n.banner-adv-wrapper,\n.banner-adv-wrapper2,\n.item-qc1",".g-imgbot,\n.g-imgtop,\n.link2.group-link,\n.top-main > div:nth-child(1) > div:nth-child(1) > div:nth-child(2)",".btn-bet",".active.bg-overlay",".td-container > div.td-pb-row > .td-pb-span12,\n.td-container-wrap.td-logo-wrap-full.td-banner-wrap-full,\n.td-crumb-container,\n.td_block_template_1.tdi_11.td-g-rec-id-sidebar,\n.td_block_template_1.tdi_28.td-g-rec-id-custom_ad_1.td-g-rec,\n.td_block_template_1.tdi_30.td-g-rec-id-sidebar.td-g-rec,\n.td_block_template_1.tdi_4.td-g-rec-id-custom_ad_1.td-g-rec,\n.td_block_template_1.tdi_6.td-g-rec-id-sidebar.td-g-rec,\n.td_block_template_1.tdi_9.td-g-rec-id-custom_ad_1.td-g-rec",".Float_ads,\n[id^=\"zone-ads\"]",".code-block-8.code-block,\n.ez-video-wrap","#invideo_wrapper,\n.Ads,\n.mobile-catfixx",".pc-catfixx",".bbMediaWrapper-inner > .samCodeUnit,\n.js-replyNewMessageContainer.block-body > div.samCodeUnit > .samItem,\n.p-footer,\n.samVideoOverlay",".footer-fixed-br-container",".code-block","#ads-1xbet-catfish,\n#popup-1720497466,\n.banner728,\n.container > div[style^=\"height: 228px\"]",".a-header,\n.apu,\n.header","#mp-preload-popup-overlay",".banner-play","#myModal,\ndiv[id^=\"adsphim-\"]",".v4j-watch-1.v4j-content,\nbody > div[class]",".ff-banner",".cash-fish,\n.cash-fish-pc,\n.preload-pc,\n.top-mobile-banner,\n.under-player-pc-banner","#menubentrai,\n.gnartyx-offads","div.py-2.md\\:py-6.mx-auto.w-full.max-w-screen-3xl > div.relative","#backgroundPopupp,\n#popupContact","#ds_top,\n.hidden-md.right.col-3,\nbody > .container > div","div[class*=\"size-\"]","#m-bet",".fade.show,\n.ibs-bet",".btn-betnow",".box-host,\n.btn-bet-top,\n.item-betnow",".topbanner","[onclick^=\"__a.hide\"],\ndiv:has([class$=\"-modal\"])","#popup_banner_beta",".hd-tube-desktop,\n.hd-tube-mobile","#footer_fixed_ads",".popUpBannerBox",".bnqcclm",".adsphim-mobile-popup","._9xtpcl.c4je67d.c1qs0lzc.c1hrlkpu.cc2icwl.c1i0iccj.cfd18df,\n._9xtpcl.e1e6v8dt,\n.blbew80,\n.llnefd1,\n.lpp0nsn,\n.luq51lg.a13wihj,\n.pointer-events-auto.block,\n.zbgpvb19.zbgpvb16.zbgpvbj.zbgpvbh.zbgpvbg.zbgpvbf.zbgpvbe.zbgpvb1",".ad-pin-right-bottom",".adv",".no-ads,\n.parent.special,\n.partner-me",".ad-floater,\n.popunder-link,\n.promotion-popup,\n.video-ad-layer","[href*=\"hnmac.vn\"],\n[href*=\"laptopvang.com\"],\n[href*=\"macbookgiasi.vn\"],\n[href*=\"macone.vn\"],\n[href*=\"minhtuanmobile.com\"],\n[href*=\"vender.vn\"],\ndiv.\\35 fb1ed6025b0b.widget:nth-of-type(3)",".header-fix-ads,\n.lepopup-popup-container,\n.lepopup-popup-overlay","#header-ads-full,\n#shoppe_ads_fly,\n.ads-responsive,\n[id^=\"ads-\"]","a[rel=\"nofollow sponsored\"]",".-translate-x-1\\/2.transform.left-1\\/2.bottom-0.fixed",".underplayer_btn","#top_addd",".btn-fanpage.btn-default.btn-block.btn","#xs-addd0",".module_single_ads",".btn-betting,\n.datCuocBTN,\n.modelAds,\n.nhacaiuytin,\n.text-running",".footer-banner",".sticky",".container-banner,\n.modal-ads,\ndiv[class^=\"slide-bar\"]","#menu-main-menu > .menu-nha-cai-uy-tin.menu-item.nav-item.style-2 > .nav-link,\n.bookmaker-selector-container,\n.c-int.d-lg-none.d-block,\n.container > .row > .col-12,\n.d-lg-none.d-block.p-1.text-center,\n.gmd-match-footer__odds,\n.justify-content-center.d-flex > .btn-primary.btn,\n.mt-1.d-lg-flex.d-none.sub-menu,\n.nav-wrap > a[rel=\"nofollow\"],\na.d-lg-none.d-block:nth-of-type(2)",".cashfish",".btn-bottom-right-append-player,\n.images-bnr-bellow-append-custom,\n.images-top-pl",".btn-odds",".btn-od",".d-lg-flex.d-none.p-0.company.flex-1.table",".ads-menu-item,\n.dcmm-button-player-item,\n.divdatcuoc",".show-ads-banner,\n.widget",".btn-action,\n.btno-group.d-none.d-lg-flex,\n.container > .mt-1,\n.container > .mt-3,\n.d-lg-block,\n.justify-content-between.d-lg-none.d-flex.btno-group,\n.menu-item:has(a[rel=\"nofollow\"]),\n.topButton,\n.widget_offer,\nheader > .container",".grid-match__footer,\n.odds-comp,\n.w-100.justify-content-center.align-items-center.d-flex,\na.d-lg-none.d-block:nth-of-type(1)",".black-layout > div:nth-child(2),\n.popup_u,\ndiv[style^=\"position: absolute;top: 0;\"]","div#bnads","#iklan-atas-wrapper","#top-banner-pc","#sponsor-balloon",".banner_list,\n.item-more,\n.nc_sidebar_home,\n.widget-sidebar-block",".body_wrapper1","#ads_location,\n.block.ad",".truct-catfish,\n.truct-widget",".chat-header,\n[href=\"https://8xbe52.com\"]",".adspopupgiua,\n.adspopupleft,\n.adspopupright,\n.float-ckgiua",".btm_bar","#preload","#haun-player > div[style],\n#primary-nav > div[style],\n.separator","[href*=\"cellphones.com.vn\"]",".textwidget","#right_float,\n[id$=\"float_banner\"]",".link-gold,\n[id^=\"banner\"]","iframe[src*=\"ads\"]",".banner-shopee,\na[href^=\"https://shope.ee\"]",".MuiDialog-container,\n.MuiDialog-root,\n.MuiModal-backdrop,\n.css-ylxsn9.MuiStack-root,\n.vjs-banner-btn,\ndiv.css-m49bkq.MuiStack-root > a","#ad_global_below_navbar",".b-player",".baloon,\n.col-sm-10.kqcenter,\n.kqbackground.vien ~ a[target=\"_blank\"]","#qc-kpgame","#left_ads_float,\n#right_ads_float",".banner_top",".catfix","#IMAGE635 > .ladi-transition.ladi-image,\n#IMAGE639 > .ladi-transition.ladi-image,\n#POPUP648,\n.backdrop-popup","#pc-catfix,\n.lightbox-player-pc,\n.mobile-catfix,\n.pc-catfix,\ndiv[id^=\"preload-\"],\nmobile-catfix",".banner-preload","#pm_quangcao","#catfish-banner,\n#dl-banner-728x90,\n.center-screen.backdrop,\n.topless",".ads-pc,\n.ads-sp",".boxzilla-bottom-right-container,\n[href^=\"https://gotrackecom.info\"]",".top-float-ck","#popup","#wap_bottombannerr,\n.grid-match[style]",".ads-floatingads,\n.banner-item,\n.top-nha-cai","#ad_balloon",".adpia_banner",".modal",".grid-match__footer > a.btn:nth-child(3),\n.mct_-bet-bot,\n.mmo-inner,\n.show.fade,\na[href^=\"/go\"]",".mmo",".btnz",".modal-backdrop.show",".fixed-bottom,\n.popup-banners",".sbAdv","#adsTopInPageBanner,\n.adsContainer,\n.header__auth > .details__devices-list",".elementor-widget-image",".box-rating",".catfish-ck",".adx1","#ab_ctl,\n.bannerads",".banner_site,\n.notify_auto,\n.sidebar_box_gray","#ads_large_detail,\n#banner_top,\n#box_qua_tang_vne,\n#raovat,\n#rich-media-banner-ads,\n#sis_popup,\n#supper_masthead,\n.article_ads,\n.article_ads_300x250,\n.banner_mobile_300x250,\n.section_ads_300x250",".Notices.PanelScroller","div[class*=\"qca\"]",".content_middle_rightbar","#pc-top-banner,\n#quang-cao","winbox-1",".banners","#top_oddd",".popup-overlay","#popup_fi","a[target=\"_blank\"][rel=\"nofollow noopener\"]","#idAdLink","#closeAds",".qc-inner,\ndiv[id^=\"qc_M_\"]",".sticky_bottom,\n.t_logo","p[style=\"color: rgb(174, 174, 174); margin-top: 10px; margin-bottom: 20px;\"]",".adv_phim,\n.fixed_bottom",".js-editors-choice-slider.editors-choice-slider > .adsbygoogle","#hide_float_right","[src^=\"https://ads.starzd.com/\"]",".block.translate-x-\\[-50\\%\\].left-2\\/4.z-\\[1\\].bottom-\\[-6px\\].fixed.mx-auto.md\\:container.md\\:px-0.px-4.w-screen",".ft-box,\n.vb-button > .mct_-bet,\ndiv.vebo-sp.container:nth-of-type(7)","#mp-preload-pp-overlay,\n.adpl",".expand-static-banner,\n.preload-banner,\n.static-banner",".bet-btn-8423,\n.btn_betnow_632132,\n.highlight,\n.images-bnr,\n.images_fixed,\na.btn_fb:nth-of-type(2)","#hots-btn,\n.bn-popup-bottom-sdwdwxw,\n[href=\"/top-nha-cai.html\"],\ndiv.row-nhacai,\nli.for-desktop-2 > [href^=\"https://debet.moi/\"],\nli.for-desktop-2 > [href^=\"https://net88.gg/\"]",".show.modal","#adspm4u",".v4j-header > a[target=\"_blank\"]",".quangcaomobile","#tut4ktream_idAdLink",".banner-catfish-bottom","#divExoLayerWrapper","#header-ads,\n#header-ads + center","#catfish-ads",".v4j-header > center","#custom_html-42",".ads-wrapper",".v4j-header.v4j-content","body > [style*=\"position: fixed;\"]","#AgeModal","#adx,\ndiv.banner-catfish-bottom",".sdzhead","#horizontal-ad",".ads-container",".ads_below_player",".qx_135","div[data-value=\"1\"]","#ads-popup",".footer-button-sign-in.hide-desk,\n.hide-desk.wrap-content > .wrap-btn-action,\n.menu-right-slide",".navbar-ex8-collapse","#bnc1","#bnc0","#sticky",".banner-ads-cs",".box-ads,\n.linkBanner","#sticky_ad,\ndiv.text-center:nth-of-type(2)","#adsbottom,\n.happy-under-player,\n.vailo-sticky,\n.vailo-under-navbar,\n.vailo-under-navbar-mobile",".text-center.rounded.p-3.border.mb-lg-4.mb-3","#position_full_top_banner_pc",".gc-header__wrapper + div[style]",".button-dangkyngay",".afw-topbanner",".adsitem","#banner3double","div[id^=\"adsWeb\"]","#pos-25,\n#pos-26","div[style=\"text-align:center;margin-top:0px;margin-bottom:0px;\"]","[class^=\"sticky-top\"],\n[href*=\"vietcombank.com.vn\"]",".bgadmtoptotal","#wrapper > [id^=\"adm-slot\"],\n[class^=\"ads_\"]",".bannertop",".my_responsive_add,\n.titleBar + *,\n[class1=\"my_responsive_add\"]","#background_bg_link,\n#subRightAboveHome,\n.adv-24h-mid,\n.col:has(a[rel=\"nofollow\"]),\n.col:has(a[rel=\"sponsored\"]),\n.fixad300x600,\n.module3,\n[id^=\"ADS_\"]",".admicro",".top-header","#subiz_wrapper,\n.ad-embed",".features-r","#bannerMasthead,\n#desktop-home-top-page,\n#mobile-home-middle-1,\n#mobile-home-middle-2,\n#mobile-home-top-page,\n.ads-masthead",".sys-ads","#topbn","#Adsv,\n.right-banner > a[title]",".__ads_click","#neo-right-ads","#BannerAdv","#gallery-2,\n.hd-cate-wrap,\n.home-qc-wrap,\n.home-sec-right .widget_media_image,\n.noname-left",".Advs_adv-components__1nBNS.Advs_adv-300x250__2eyhC.Advs_no-content__RWwW2,\n.HotTagGlobal_fixed-height__1f50i",".exp_qc_share",".c-banner",".bg-gray,\n.sidebar > div[style]","div[id^=\"adsbg\"]",".banrpstn","#myElementz,\n.bannerinfooter,\n.quang-cao-ben-phai","#vi-smartbanner,\n.LRBanner,\n.running.adsbyvli",".bg_allpopupss,\n.bgal_popndungalal,\n.bn1,\n.bn2,\n.box_quangcao_mobile_320x50,\n.box_text_qc,\ndiv.news-left-related:nth-of-type(2)","#tubia","[id^=\"admzone\"]",".khw-ads-wrapper.clearfix",".banner-bottom-menu,\n.popup-bg,\n.showpop,\n[href*=\"bit.ly\"]","#adrightsecondx,\n#adrightspecial,\n#adrightspeciallinks,\n#adsuggestion",".ads-sponsor,\n.khw-adk14-wrapper",".top-banner-mobile","[id^=\"adv\"]",".quang_cao_pc_right_hoc_tap",".ads-tags,\n.img_side_bar,\n.poka-image",".ads_shortcode",".admicro_top","#adop_bfd,\nins[class*=\"adsby\"]",".sponsor-zone","div[id^=\"ads_\"]","#top-adv",".box-banner","div[class^=\"adv-\"]",".ads-970x280","#pc-bill",".align-items-center.justify-content-between.d-flex.text-center.bg-grey-6.w-100,\n.d-flex.justify-content-between > div > div.d-flex.justify-content-around.mt-4,\n.pc-top,\n.top-ads-16x9","#myCarousel,\n.banner-boder-zoom",".block:has(.block-container > .block-body > a[href]),\n.block:has(.block-container > .block-body > ins)",".asd-headt,\n.detail__foru,\n.mb-40.section__qadd,\n.super-masthead,\n.top-banner,\n[class*=\"box-home\"],\n[data-marked-zoneid=\"tn_detail_danhchoban\"],\n[data-marked-zoneid=\"tn_detail_quantam\"],\n[id^=\"dablewidget_\"],\nzone","div[class$=\"_ads\"]",".zone-top,\n[id^=\"pos-\"]",".c-banner-item","div[id^=\"adsMobile\"]",".fyi",".ads-common-box",".p-body-pageContent > table[style=\"width:100%;display:inline-block;background: #fff;\"]",".jsx-3569995709,\n.micro,\n.middle-comment-promotion,\n.pro-container,\ndiv[style=\"width:300px;height:250px\"],\ndiv[style=\"width:300px;height:600px\"],\ndiv[style=\"width:320px;height:100px\"]","#main-videoplayer,\n#pc-top,\n.ads-position",".container .desktopjszone,\n.mobilejszone","#LeaderBoardTop,\n#admbackground,\n#adsMainFooter,\n.Mobile_Masthead_TTO_Wrapper,\n.adm-bot,\n.box-qad,\n.content-amuasam,\n.detail__qc,\n.section__r-vietlot,\n.wrapper-ads-mb",".clearfix.adregion,\n.visible-md.header-banners",".Flagrow-Ads-under-header",".vfs_banner","#vmcad_sponsor_middle_content,\n.box-adv,\n.mb-20.col-right-ads,\n.vmcadszone","section.mar20:nth-of-type(2),\nsection.mar20:nth-of-type(4)","#banner-dai-bottom,\n#banner-dai-top",".adsbypubpower,\n.p-body-sidebar > .block > .block-container:has(.adsbypubpower),\n.p-body-sidebar > .block > .block-container:has([data-widget_id]),\n.v-element > .v-responsive,\ndiv.message--post,\ndiv[style]:has(.adsbypubpower)",".adContainer",".bf-3-primary-column-size.bs-vc-sidebar-column.vc_col-sm-3.vc_column_container.bs-vc-column.wpb_column > .wpb_wrapper.bs-vc-wrapper",".wrapper-adv","#banner1ab",".ad_by_yellowpages,\n.banner_add","#Zingnews_SiteHeader,\n.znews-banner","#bar_float_r,\n.quangcaomb",".group-link:has(a[href*=\"&utm_\"]),\n.topnhacai",".jw-button-image",".odds-button,\n.odds-button2",".banner-bottom-append-custom,\n.button-in-player-box,\n.logo-top-right-append-custom","#banner_preload,\n.doc-truyen-ads-d1,\n.doc-truyen-ads-d2",".v4j-watch-1.v4j-content > center","li.special.parent"];

const hostnamesMap = new Map([["*",[0,1,2]],["sextop.asia",[3,4]],["vectorx.top",3],["hls.playerfb.xyz",3],["motchilltvzz.biz",[5,6]],["motphimtvv.com",5],["www.mp.com",[5,98]],["movies.vkoolz.com",[5,14]],["subnhanh1.org",[5,50,286]],["hhtrungquoc6.com",[6,81]],["hhvsub.com",6],["wibu47.com",6],["motphim.cv",6],["hhhay.ink",[6,186]],["hhtqvietsub.me",[6,220,221]],["hhtq3d.net",[6,81]],["hoathinh4k3.net",6],["motchillie.net",6],["hhchina.shop",[6,221,305]],["hoathinh3dtq.site",6],["hoathinhtq.site",6],["dragonphim.tv",6],["hhh3d.tv",6],["hhninja13.tv",6],["hhtutien.tv",6],["phimdacap.tv",[6,320]],["yanhh3d.tv",[6,14,306,326]],["animeweb.vip",[6,81]],["hhtq5.vip",6],["hhtq8.vip",[6,81]],["phimhoathinh3d.vip",6],["hh3d1.xyz",6],["xemphimchill.xyz",[6,14,15,185]],["phimbet.biz",[7,8]],["tructiepdabong5.co",[7,31,40,41,42]],["dongphim.la",[7,184,196]],["hhpanda.li",[7,184,198,199,200]],["subnhanhvl.li",[7,184,198,199,201]],["motchill.love",[7,201]],["hhanime3d.net",[7,184,199]],["phim.vkool8.net",[7,267,268]],["biphim.now",[7,27,198,279]],["dongchill.pro",[7,184]],["subnhanh.sh",[7,198,201]],["protruyen4.xyz",[7,182]],["tamlinh247.biz",9],["khosex.blog",[10,11]],["sexheovl.com",[10,11]],["trangsexdam.net",[10,11,183]],["quat69.pro",[10,11]],["sexsoc.info",[11,183]],["phimsexvl69.net",11],["vlxxai.net",[11,183]],["javhd.social",[11,183]],["javhd.tech",[11,312]],["anime47.cam",[12,13]],["doctruyen3qk.pro",13],["www.toptruyento.pro",13],["247phim.cc",[14,15]],["hayhaytv.cc",[14,15]],["boctem.com",14],["tvhay26.com",14],["vuaphimmoi1.com",14],["bimmup.tv",[14,317]],["www.ssphim.us",[14,15]],["vungtv.us",[14,113]],["www.phimmoichilla.xyz",[14,15]],["ephoto360.com",[15,72]],["thiepmung.com",15],["phiimoi.net",15],["cakhiai.cc",[16,17,18,19,20,21,22,23]],["xoilacxj.cc",[16,17,20,21,22,23,27,28,29,30,31,32,33]],["90phutz46.live",[16,17,21,22,29,33,207]],["veboz54.live",[16,17,19,21,22,23,204,210,215]],["avvietsub.info",[17,173,174]],["rakhoiz38.live",[17,30,204,210]],["xoilaczz63.live",[17,29,32,33,210,212,216]],["phym18.lol",[17,173,217]],["nhentaivn.online",[17,173,281]],["xemtivi.tvhayhd.tv",[17,322]],["phimsexsub.xyz",17],["mitomz27.live",[23,204,210,211,212]],["hayphim.cc",24],["keonhacai55.cc",[25,26]],["xemtivingon.org",26],["abtruyenmoi.com",[27,47]],["doctruyenln.com",[27,69]],["xemtivi4k.com",[27,149,150]],["damconuong.fun",[27,159]],["xem.tructiepnba.me",[27,225]],["ketqua04.net",[27,240]],["live2.thapcam120.net",[27,154,258]],["live3.thapcam27.net",[27,154,258]],["live3.thapcam29.net",[27,154,176,258,261]],["live4.thapcam29.net",[27,154,176,258]],["vidian.online",[27,284]],["bongdainfox.tv",27],["nghean24h.vn",27],["live4.thapcamm.xyz",[27,154,176,258,260,261]],["sexhihiz.ch",[34,35,36]],["nungmup.net",[34,36,244]],["phimlongtieng.net",[34,108,109,110,111,114,247]],["vlxx.tech",[34,35,54,169,247,313]],["ohaysex3x.net",35],["tvhayw.org",[35,291]],["vlxyz.tube",36],["heovktgame.club",37],["phimmoi.club",38],["tvphim.li",[38,74,202]],["motphimww.net",[38,202]],["sexhd88.club",39],["xoivo2.online",[41,42,214]],["tvzinghd.co",[43,44]],["phimmoinay.info",[43,182]],["phimmoissz.pro",[43,299]],["123nhadatviet.com",45],["123nhadatviet.net",45],["nld.com.vn",45],["tuoitre.vn",[45,401]],["tuoitrenews.vn",45],["live.7mvn4.com",46],["abysscdn.com",[48,49]],["freeplayervideo.com",[48,49]],["player-cdn.com",[48,49]],["geoip.redirect-ads.com",[48,49]],["animet3.info",[49,50,171]],["phimss.net",[49,250]],["xemphim18.net",[49,62,184,276]],["live4.xoilac34.org",[49,175,176,177,178,179,293]],["fdcdn.xyz",[49,417]],["watch.rkplayer.xyz",[49,419]],["animetvn4.com",[50,51]],["apkmoddone.com",[52,53]],["apkmoddone.phongroblox.com",[53,116,117]],["appvn.com",54],["javtopxx.com",[54,88]],["mod.lnpchannel.com",54],["vivuphim.info",[54,184,185]],["phimmoi.ing",54],["ghienphim.io",[54,101,191,192]],["soikeo365.net",[54,255]],["cungthi.online",[54,76]],["antt.vn",54],["bongda24h.vn",54],["kienthuc.net.vn",[54,380]],["nghenhinvietnam.vn",54],["saostar.vn",[54,386]],["v.xemphimviet.xyz",[54,101,192,422]],["asianbookie.com",55],["baomoi.com",56],["baonga.com",57],["bongda12h365.com",58],["canhrau.com",59],["topthuthuat.com",59],["chotlo3s.com",60],["www.clbgamesvn.com",61],["cliphotvn69.com",62],["xem15.com",[62,147]],["hh3dhay.life",62],["tram3d.me",62],["phevkl.my",[62,165,229,230]],["www.gvnvh.net",62],["viet69.now",[62,165,229,230,280]],["mobiblog123.one",62],["sayhentai.one",62],["phimvuihd.org",62],["cliphot69.skin",[62,308]],["vutruphim.tv",[62,325]],["topviet69.video",62],["congthucvatly.com",[63,64]],["phuongtrinhhoahoc.com",[64,118]],["contuhoc.com",65],["www5.cbox.ws",65],["cryptoviet.com",66],["diadiem.com",67],["mobi.ditnhauvietnam.com",68],["dualeotruyenomega.com",70],["ebookbkmt.com",71],["fullcliphot.com",[73,74,75]],["fulllivehot.live",[73,208]],["home1.mannhan11.pro",[73,205,296]],["gamehayvl.com",76],["giavang.net",76],["romgoc.net",76],["gocmod.com",77],["file.gocmod.com",78],["forum.gocmod.com",79],["hayghechill.com",80],["truyensieuhay.com",[81,130]],["hoahoc247.com",82],["hoidap247.com",83],["hsctvn.com",84],["huphimtv.com",85],["www.iosviet.com",86],["javtiful.com",87],["laptrinhcanban.com",[89,90]],["yhocdata.com",[90,157]],["lichngaytot.com",91],["lichvannien365.com",92],["linkneverdie2.com",93],["linkneverdie.net",93],["linkneverdie.top",93],["loigiaihay.com",94],["metruyencv.com",95],["metruyencv.info",95],["metruyencv.net",95],["mmo4me.com",96],["baodauthau.vn",[96,337]],["motchilltvf.com",97],["muabanraovat.com",99],["nettruyenww.com",[100,101]],["truyengihotnay.com",[101,127]],["truyengihotnha.com",[101,127]],["truyengihotqua.com",[101,127]],["tenmientruyengi.net",[101,127]],["thichxemphim1.net",[101,263]],["truyengihotdo.net",[101,127]],["truyengihotnha.net",[101,127]],["truyengihotqua.net",[101,127]],["truyengihotzay.net",[101,127]],["baoxaydung.com.vn",101],["taichinhdoanhnghiep.net.vn",[101,190]],["tienphong.vn",[101,337,394,395]],["toquoc.vn",101],["nettruyenx.com",102],["nhaccuatui.com",103],["pheclipsex.com",[104,105,106]],["sexchichnhau.net",[104,105,106,252,253]],["phim18vip.vip",[104,105,106,253]],["sieudam.vin",[105,106,253]],["phim202.com",107],["phimdinhcao.com",[108,109]],["www.phimdinhcaoz.com",[108,110,111]],["phimlongtieng.com",[108,110,111,114]],["phimdinhcao.net",[108,110]],["phimhdctv.com",[112,113]],["phongroblox.com",115],["www.vip1s.top",[116,315]],["quantrimang.com",[119,120,121]],["hoatieu.vn",[119,139,205,371]],["vndoc.com",[121,139]],["khoahoc.tv",121],["download.com.vn",121],["download.vn",[121,147,362]],["gamevui.vn",121],["sieutamphim.com",122],["thuthuatjb.com",123],["thuthuattienich.com",124],["www.tiengnhatdongian.com",125],["ycongnghe.com",[125,155]],["toithuthuat.com",126],["truyenqqto.com",128],["truyensextv.com",129],["lxmanga.store",[129,309]],["tvhaiss.com",131],["tvhayd.com",132],["tvso1.com",133],["bongdaso66.net",[133,233]],["blog.abit.vn",[133,333]],["vesotantai.com",134],["vietcetera.com",135],["vietgiaitri.com",136],["vietjack.com",137],["www.vietjack.com",138],["vsc60.com",140],["vtruyen.com",141],["vuighe4.com",[142,143]],["xem1080.com",143],["web1s.com",144],["webhoctienganh.com",145],["webtretho.com",146],["xemphimjav.com",148],["bieudogiavang.vn",150],["xosodaiphat.com",151],["xxoilac.com",[152,153,154]],["goal.90phut24.xyz",[153,154,416]],["live3.thapcam26.net",[154,175,176,210,258,259,260,261,262]],["yeah1.com",156],["animevietsub.cx",[158,159]],["rphang.day",160],["viet69.ec",161],["finacor.fr",162],["bluphim.fun",163],["truyen18.fun",164],["viet69.gold",[165,166]],["cdnwp.icu",167],["mephim.ink",[167,187]],["jav.sexsub.icu",168],["phim1080.in",169],["phim18hd.in",170],["animew.info",172],["socolivebongda.net",[173,254]],["xem.banhkhuc120.info",[175,176,177,178,179]],["xem.vebo31.net",[175,176,177,179]],["vebo4.net",[175,176,177,179]],["doctruyenchu.info",180],["xem.javkche.info",181],["phimtho.net",182],["soikeoz.vip",[182,278]],["javhd.shop",183],["bichill.video",184],["www.buomtv.io",188],["dubaotiente.io",[189,190]],["giadinhonline.vn",[190,359]],["vietnamnet.vn",[190,405]],["maclife.io",193],["tapchibitcoin.io",194],["truyenfull.io",195],["motchilltv.la",197],["tructiep.caheo7.link",[203,204,205,206]],["bongda.rakhooi.tv",[203,204,205,321]],["phimmoichillz.my",[204,229]],["mn.mediastation.live",209],["vaoroi7.live",[213,214]],["vn.phym18.lol",218],["www.gaingon18.me",219],["keoso.me",222],["ngaytho.me",223],["phimno1.me",224],["chat.vebotv.me",226],["sieukhung.meme",227],["play.anh.moe",228],["bantincongnghe.net",231],["blogkiienthuc.net",232],["chodansinh.net",234],["domdomtruyen.net",235],["fastscans4.net",236],["xem19.gavang1.net",237],["xem20.gavang1.net",237],["gockhuat.net",238],["vn.javbabe.net",239],["khiphach.net",241],["mythethao.net",[242,243]],["vnesports.net",[243,271]],["jav.vc",244],["www.o-study.net",245],["phimgichill.net",246],["phimmoichilltv.net",248],["phimnhua.net",249],["sachmoi.net",251],["tenovi.net",[256,257]],["truyentuan.xyz",[257,420]],["noitu.pro",[262,298]],["tracnghiem.net",264],["phimmoi.tuphim.net",265],["vietmoz.net",266],["vphims.net",268],["www.vlxxhot.net",[269,270]],["vailonxx.vip",[270,329]],["vnexpress.net",272],["vozer.net",273],["vtipster.net",274],["vuonhoalan.net",275],["zcine.net",277],["bongda365.news",278],["phimhaymoi.online",282],["tut4ktream.online",283],["blogtruyenvn.org",285],["hayhaytv.org",286],["lmssplus.org",287],["mphim14.org",288],["truyenaudiocv.org",289],["tuoinungvn.org",290],["www.vipfilm.org",292],["cliphot69.pics",294],["chillphimmoi.pro",295],["home2.mannhan9.pro",297],["phimsexhay669.pro",300],["sexgaidep69.pro",301],["xemphimsexhayhd.pro",301],["sexvn2024.pro",302],["phim.sexxsub.pro",[303,304]],["vl.phe.to",[304,314]],["hhtm.site",306],["hd.javhay.site",307],["sex.tuoi69.store",310],["filemoon.sx",311],["the.tube",316],["hentaihvn.tv",318],["phim88.tv",319],["vieclam.tv",[323,324]],["xskt.com.vn",324],["ketqua247vn.vip",327],["tram3d.vip",328],["10gb.vn",330],["2banh.vn",331],["2game.vn",332],["afamily.vn",334],["sport5.vn",334],["www.anninhthudo.vn",335],["autodaily.vn",336],["xehay.vn",[336,412]],["www.baogiaothong.vn",338],["phapluatplus.baophapluat.vn",339],["videophapluat.baophapluat.vn",340],["cafebiz.vn",341],["cafef.vn",[342,343]],["ttvn.toquoc.vn",343],["chap.vn",344],["24h.com.vn",345],["autopro.com.vn",346],["baohaugiang.com.vn",347],["congan.com.vn",348],["daklak24h.com.vn",349],["dantri.com.vn",350],["doisongphapluat.com.vn",351],["vtcnews.vn",351],["tapchikientruc.com.vn",352],["thanhtra.com.vn",353],["thoidai.com.vn",354],["petrotimes.vn",354],["www.thuocbietduoc.com.vn",355],["thuongtruong.com.vn",356],["thuysanvietnam.com.vn",357],["voh.com.vn",358],["congluan.vn",359],["congly.vn",360],["thitruongtaichinhtiente.vn",[360,393]],["danviet.vn",361],["eva.vn",363],["fshare.vn",364],["game24h.vn",365],["game8.vn",366],["gameio.vn",367],["gamek.vn",368],["soha.vn",368],["genk.vn",369],["vnews.gov.vn",370],["kenh14.vn",372],["kinhtedothi.vn",[373,374]],["minhngoc.net.vn",374],["vn-z.vn",374],["lazi.vn",375],["luatduonggia.vn",376],["lucloi.vn",377],["muare.vn",378],["myeva.vn",379],["phunumoi.net.vn",381],["nhipcaudautu.vn",381],["nhacdj.vn",382],["qdnd.vn",383],["reatimes.vn",384],["rung.vn",385],["www.saostar.vn",387],["sharecode.vn",388],["techrum.vn",389],["thanhnien.vn",390],["thethao247.vn",391],["thethaovanhoa.vn",392],["tinnhanhchungkhoan.vn",395],["tiin.vn",396],["timdaily.vn",397],["tinhte.vn",398],["tinmoi.vn",399],["tintucvietnam.vn",400],["tuyengiao.vn",402],["v4u.vn",403],["vietfones.vn",404],["vietq.vn",406],["viettelstore.vn",407],["voz.vn",408],["vtvgo.vn",409],["vungoctuan.vn",410],["webthethao.vn",411],["yellowpages.vn",413],["znews.vn",414],["tuoi69.vote",415],["plcdn.xyz",418],["vietxxx.xyz",421]]);

const entitiesMap = new Map(undefined);

const exceptionsMap = new Map([["cafef.vn",[0]],["livescore.com",[1]],["msn.com",[1]],["dm.de",[1]],["medium.com",[1]],["vnexpress.net",[2]]]);

self.specificImports = self.specificImports || [];
self.specificImports.push({ argsList, hostnamesMap, entitiesMap, exceptionsMap });

/******************************************************************************/

})();

/******************************************************************************/
